#   PyIdGen - User Profile Generation Library for Quality Assurance and Information Security Testing
#   Copyright (C) 2013 Paul Greenberg <paul@greenberg.pro>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.

import random;

class PostalAddress:
    'Represents a US Address'
    
    def __init__(self, zip=None, city=None, county=None, state=None, unit=None):
        '''Initialize US Address based on a provided criteria.'''
        self.address1();
        self.address2(unit);
        self.address3(zip, city, county, state);
        
    def address2(self, flag):
        unit   = ['Apartment','Office','Room','Suite','Unit', 'Floor'];
        number = [' ',' #'];
        if (random.randint(1, 5) == 1) or flag:
            self.Address2 = random.choice(unit) + random.choice(number) + str(random.randint(1, 3000));
        else:
            self.Address2 = '';
        return;

    def address1(self):
        streets = ["10 Mile Rd","10 W 37 Rd","10 W 38 Rd","10 W 43 Tr","10 W 54 Rd","1000 St W","100th Ave","100th St SE",
            "101st Ave","101st Street","102nd Ave","1035 Rd","1040 Rd","1049 Rd","104rd Ave","104th Ave W",
            "104th St","1050 Rd","1055 Rd","105th Pl","105th St","106th St","107th Ave","109th Ave","10th Aly",
            "10th Ave","10th Ave N","10th Ave S","10th Ave SW","10th Avenue","10th Hole Dr","10th Line",
            "10th Ln NW","10th Sideroad","10th St","10th St SW","11 1/2 St","11 Highway","11 Line N","11 Mile Rd",
            "11 N 45","11 Road","1100 St W","110th St","111th Ave","112th Ave","112th St","113th St E","115 Dr",
            "115th Street","116th Ave","117th St","118th St","119/14","119th St","11th Aly","11th Ave","11th Ave S",
            "11th Ave SE","11th Ave SW","11th Avenue","11th Ct","11th Ct S","11th Ln","11th Pl","11th Road East",
            "11th St","11th St NW","11th Street","12 Foot Falls Rd","12 Line N","12 Road","120th Ave","120th St",
            "121st St","12227","123rd St","125th Ave","125th St","126th Ave W","126th St SW","126th St W","128th Ave",
            "129th St","12N10","12th","12th Ave","12th Ave SE","12th Ave SW","12th Avenue","12th Ct","12th Line",
            "12th Line E","12th Pl","12th Plaza Cir","12th St","12th St N","12th St NE","12th St NW","12th St S",
            "12th St SW","12th Street","12th Ter","13 1/2 Mile Rd","13 Line N","1300 West","1302 Pr Dr",
            "130th Ave","131st St","132nd Ave","132nd St W","133rd St","135th St W","137th Pl","13N27 Fwr Rte",
            "13N45","13N46","13th Ave","13th Ave SW","13th Ave W","13th Ct","13th Hole Dr","13th Line","13th St",
            "13th St E","13th St NE","13th St SE","14 Bia","14 Line N","14 N 01 Rd","14.5 Rd","14.5 St","140th St SW",
            "140th St W","142nd St","1430","144th Ave","145th Ave","145th St","145th Street Bridge","148th Pl",
            "14N 39","14N32","14N46","14th Aly","14th Ave","14th Ave E","14th Avenue","14th Ct","14th Line","14th Ln",
            "14th Pl","14th St","14th St E","15 Mile Rd","15 N 04 Rd","15 N 06 A Rd","15 Sideroad","15.5 Ln",
            "150 Ave","150th Ave","150th Dr","150th St","1517","157th Ave SE","15B","15N02","15th Aly N","15th Ave",
            "15th Ave NE","15th Ct NW","15th Pl E","15th St","15th St 16th St Aly","15th St SE","15th St W",
            "15th Street","15th Street Rd","16 1/2 Mile Rd","16 Bia","16 Mile Rd","16 N 06 Rd","16 N 19 Rd",
            "16 N 23 Rd","16 N 29 A Rd","16 N 35 Rd","16 N 58 Rd","16 N 62 Rd","16 Sideroad","161st St E",
            "162nd St E","164th St E","169th St","16th Ave","16th Ave N","16th Avenue","16th Ct NW","16th Pl SW",
            "16th Rd","16th St","16th St E","16th St NE","16th St SW","16th Street","17 3/4 St","17 Mile Rd",
            "17 N 31 Rd","17 N 75 Rd","17 N 85 A Rd","17 Sideroad","170th Ave","171st St E","172 Rd","1725 E St",
            "172nd St E","173rd Ave","173rd Ave SE","1753 Dr","1754 Dr","175th Ave","175th St","176th St","1775 St",
            "177th St","1786 Dr","178th St","179th St","17N41","17W26A","17a Sideroad","17th Ave","17th Ave NW",
            "17th Ave S","17th Avenue","17th Ct NW","17th East St","17th Pl","17th Pl NE","17th Pl SW","17th St",
            "17th St E","17th St NW","18","18 Mile Rd","18 N 05 D Rd","18 N 25 F Rd","18 N 26 Rd","18 N 33",
            "18 N 33 Rd","18 N 34 Rd","18 N 36 A Rd","18 N 36 Rd","18 N 53 Rd","18 Rd","18 Sideroad","180th St W",
            "181st St","182nd St","184th Pl","184th St","184th White Cutoff","185 North St","185th St","185th St N",
            "186th St W","187B","188","18N12","18N22","18N24","18N33","18N62","18th Aly","18th Ave","18th Ave E","18th Ave NE",
            "18th Ave NW","18th Avenue","18th Ct S","18th Rd","18th St","18th St NW","18th St S","18th St SE",
            "19 1/2 Ave","19 N 11 Rd","19 N 12 A Rd","19 N 23 Rd","19 N 25 Rd","19 N 30 Rd","19 N 34 Rd",
            "19 N 79 Rd","19 Sideroad","190th St","190th St W","192nd Ave","199th North St","19N31 Rd","19th Ave",
            "19th Avenue","19th Pl NE","19th St","19th Ter NE","1A","1C","1N12","1er Callejon Coahuila","1st",
            "1st Aly N","1st Aly S","1st Ave","1st Ave E","1st Ave N","1st Ave NW","1st Ave S","1st Ave SW",
            "1st Avenue","1st Court","1st Ct Rd","1st East","1st Ln","1st North","1st North St","1st Pl","1st Point",
            "1st Rd","1st St","1st St N","1st St NE","1st St S","1st St SE","1st Street","1st Way","2","2 Mile Rd",
            "2-50 Deer View","20 1/2 Ave","20 Mile Rd","20 N 09 Rd","20 N 10 Rd","20 N 29 Rd","20 N 30 Rd",
            "20 N 59","20 Sideroad","200 North St","20000","200th St E","202A","202nd St","203C","203rd Ave Byp",
            "203rd St E","204th Ave NW","20883","20Bb","20N02","20N28","20th Aly","20th Aly S","20th Ave","20th Ave S",
            "20th Ave SE","20th Ave SW","20th Pl","20th St","20th St E","20th St F","20th St N","20th St NE",
            "20th St SW","21 1/2 Mile Rd","21 Bia","21 Spur","210th Ct NW","210th St","211th St","214th St",
            "215 Beltway","215th St","217th St","218th St E","21st Aly N","21st Ave","21st Ave N","21st Ave NE",
            "21st Ave SE","21st Ave SW","21st Ct NW","21st Pl","21st Rd","21st St","21st St N","21st St NE",
            "21st St NW","21st St SE","21st St SW","2200 E","2200 East","220th St","221 Rd","2218 Rd","223rd St",
            "22451","226th St","22B","22nd Ave","22nd Ave E","22nd Ave S","22nd Ave W","22nd Dr","22nd St","22nd St N",
            "22nd St NW","22nd St SW","22nd St W","22nd Street","23 Rd St NE","23000","23000 Rd","230th Ave",
            "230th Pl","230th St","23N19","23rd Ave","23rd Ave NW","23rd Avenue","23rd Avenue SE","23rd Court",
            "23rd Ln","23rd Rd","23rd St","23rd St N","23rd St NW","23rd St W","23rd Street","2400 East","240th St",
            "24140 Rd","24250","24360","246th St W","24N89X","24th Ave","24th Rd","24th St","24th St Frontage Rd",
            "24th St SE","24th St W","25","25 1/2 Ln","25 Sideroad","25.21 Rd","250th St","252nd St W","254A",
            "254B","254th St","257th St W","25N03","25N34","25th Ave","25th Ave W","25th Helena Dr","25th Loop SE",
            "25th Pl","25th St","25th St N","25th St NW","25th St SW","25th St W","25th Street","26 1/4 Ave",
            "26 Sideroad","262","263","263rd St E","265th St W","26th Aly N","26th Ave","26th Ave N","26th Rd",
            "26th St","26th St N","26th St NE","26th St NW","26th St SW","26th Way","270 St","2705","270th St",
            "273","277","2772","279A","27th Ave","27th Ave N","27th Court Cir NW","27th Ct S","27th St","27th St NW",
            "27th Street","27th Ter S","280th Ave","281","2832 Rd","2841A","284th St","28th Aly N","28th Ave",
            "28th St","28th St E","28th St SW","28th Street","28th Trl","29 Fundy Bay Boulevard","293rd Ave",
            "298A","29N22","29N38","29th Aly","29th Aly N","29th Ave","29th Pl","29th St","29th St NW","29th Street",
            "2N71","2S10","2nd","2nd Aly","2nd Aly N","2nd Ave","2nd Ave N","2nd Ave NE","2nd Ave NW","2nd Ave SE",
            "2nd Ave SW","2nd Ave W","2nd Avenue","2nd Dr","2nd Dr NE","2nd Line","2nd Line E","2nd Ln","2nd New Hampshire Tpke S",
            "2nd Pl","2nd Rd","2nd St","2nd St E","2nd St N","2nd St NE","2nd St NW","2nd St S","2nd St SE","2nd St offramp",
            "2nd Street","2nd Ter","3 B","3 B A","3 B C","3 Pines Canyon","3 Ponds Ln","3 Road","3 Tank Rd","300th Ave",
            "300th St","300th St NW","303rd St","305","305th St","30th Dr","30th Pl","30th St","30th St E","30th St SW",
            "31 Mile Rd","3100 Kingston Road","310th St","319 Ave","31A","31st Ave","31st Ave E","31st Ave NW",
            "31st Dr","31st Pl","31st St","31st St E","31st St NE","32 1/2 St","32700 Rd","32N13 (Big Pines) Rd",
            "32nd Ave","32nd Ave NW","32nd St","32nd St W","33 Rd","33 Weeks Dr","335","337","33N84A","33rd Ct E",
            "33rd Rd","33rd St","33rd St E","33rd St SW","33rd Street","34 1/2 Rd","34 St 35 St Aly","340th Ave",
            "349th St","34th Ave","34th Ave N","34th Rd","34th St","34th St S","34th St SE","34th Street","35 Highway",
            "350 Rd","3510 Quetico Court","356","35th Ave","35th Ave N","35th Pl","35th St","35th St N","35th St SW",
            "368th Ave","369","36th Ave","36th Ave E","36th Cir SE","36th Ct NE","36th St","36th St SW","36th Street",
            "37 Highway","37356","374","37N26 Rd","37th Ave","37th Ave W","37th Ct NE","37th St","37th St NE",
            "37th St W","37th Street","380th St","387th Ave","38th Ave","38th Ave E","38th St","38th St E",
            "38th St NE","38th St NW","38th Street","39 National Forest","39-4-22","39th Aly NW","39th Ave",
            "39th St","39th St NW","39th St SW","3D Rd","3N01","3N16","3S89 Rd","3rd","3rd S","3rd Aly N","3rd Ave",
            "3rd Ave N","3rd Ave NE","3rd Concession","3rd Ct","3rd Line","3rd Pl","3rd Pl E","3rd Range","3rd St",
            "3rd St E","3rd St NW","3rd St No 1","3rd St SE","3rd St SW","3rd St W","3rd Street","3rd Way Ln",
            "4 A C","4 C G","4 Cl","4 Ea","4 H A","40 1/2 Rd","40 C","401 Toronto and 410 Brampton via 403",
            "404 / DVP / 401","405 Rd","4065","40th Aly","40th Aly N","40th Ave","40th Ave E","40th Rd","40th St",
            "40th St S","41","4101 Westminster Place","412 Rd","4135 Shipp Drive","41N54 Rd","41st Ave",
            "41st Ct NW","41st Pl","41st Pl N","41st St","41st St NW","41st St SW","41st Street","425","42N21 Rd",
            "42nd Ave","42nd Ave E","42nd Ave NE","42nd Ct","42nd St","42nd Street","43 1/2 St","435 Markham Road",
            "43N35 Rd","43rd Aly","43rd Aly N","43rd Ave","43rd Dr","43rd Ln","43rd St","43rd St NW","43rd St SW",
            "44 1/2 St","44 Ave","441","442 Cnty Rd","448","449","44N02 Rd","44N05 Rd","44N55rd","44th Aly","44th St",
            "44th St NW","44th St SW","45 Highway","450th St","453","455 Apache Court","457th Ave","45N50",
            "45N58X","45th Ave","45th Ave SW","45th Pl N","45th St","45th St SW","45th St W","46N05 Rd","46N07 Rd",
            "46N12 Rd","46N19 Rd","46N44 Rd","46N53","46th Ave","46th Ave NW","46th Pl","46th St","46th St S",
            "46th St SW","46th Street","47N25Y Rd","47th Ave","47th Ave E","47th Avenue","47th St","47th St N",
            "47th St SW","47th St W","48","48 Highway","48-Spur","485 Meadows Boulevard","48N20 Rd","48th Ave",
            "48th Pl E","48th St","48th St NE","48th St NW","48th St SW","48th St W","49 State Road","495",
            "49Er Cir","49th Ave","49th St","49th St NE","4A","4A-518","4WD Rd","4th","4th Aly","4th Aly W","4th Ave",
            "4th Ave Marshall Way Aly","4th Ave N","4th Ave NW","4th Ave S","4th Ave SE","4th Ave SW",
            "4th Lake Rd","4th Line","4th Line E","4th Line Road","4th Ln","4th Pl NE","4th Plz","4th Rd","4th St",
            "4th St E","4th St N","4th St NE","4th St S","4th St SE","4th St SW","4th St W","4th Street","5","5 Line N",
            "5 Mile Point Rd","5 Th St SW","50","50 1/2 St","505th Ave","506 Highway","509 Highway","50th Ave",
            "50th St","50th St NE","50th Street","513","515","518th St","51st Ave","51st Ave N","51st St","51st St 52nd St Aly",
            "51st St E","51st St NW","51st St SW","52","520th St","525","52nd Ave E","52nd Ct NW","52nd St","52nd St SW",
            "52nd Street","530","532 Highway","534","53rd Ave","53rd Dr","53rd St","53rd St E","53rd St NW","53rd Street",
            "543 Rd","547th Ave","54th Ave","54th St","54th Street","556 Highway","55th Ave","55th Rd","55th St",
            "55th St NW","55th St W","562","56th Ave","56th Rd","56th St","57th Ave","57th St","57th St NW","57th Street",
            "58","581","58A Highway","58th Ave","58th St","58th Street","59th Dr","59th Pl","59th Pl S","59th St",
            "59th St NW","5N30","5S10","5S15","5th","5th W","5th Ave","5th Ave N","5th Ave NW","5th Ave SE","5th Ave SW",
            "5th Avenue","5th Bayway","5th Ct NW","5th Line","5th Pl","5th Pl E","5th Pl S","5th Pl W","5th Rd",
            "5th St","5th St E","5th St NW","5th St SE","5th St W","5th Street","5th Ter N","6 A Rd","6 Line N",
            "6 Mile Hwy","6 Road","60 Rd","60th Ave","60th Pl","60th Pl S","60th St","60th St E","60th St W","61st Aly N",
            "61st St","61st St NW","61st Street","62 Byp","620 Highway","620th Ave","62nd St","637","637E","638 Highway",
            "63rd St NW","63rd Street","64","642-T Pvt","64th Ave","64th St","64th St NW","64th Street","65th St",
            "65th Street Transverse","66th St","670 Highway","67th St","67th St N","67th St W","67th Street",
            "68th St","68th St S","690th Ave","69th Pl N","69th St","6A","6S88","6th","6th Aly","6th Aly N","6th Ave",
            "6th Ave N","6th Ave S","6th Ave W","6th Avenue","6th Concession","6th Ct","6th Line","6th Ln",
            "6th Pl","6th Rd","6th St","6th St NE","6th St NW","6th St S","6th St SW","6th St W","6th Street Thomas",
            "6th Way NW","7","7 Line N","7 Mile Rd","7 Mile Rd NE","7 Mile Service Dr","7 Pines Rd","7 Road",
            "7 Th St","7 by 9 Rd","7.25 Ln","70 Sthy","70th St","70th St NE","70th Street","71st St","72nd St",
            "73rd St NE","740th St","74th Ct","74th St","74th Street","75th Ave","75th St","76th St","77 Nf","771 Rd",
            "77th St","77th Street","78th St","78th Street","79th Aly S","79th St Transverse Rd","7th","7th Aly",
            "7th Aly N","7th Ave","7th Ave 8th Ave Aly","7th Ave E","7th Ave N","7th Ave NW","7th Ave S",
            "7th Avenue","7th Bayway","7th Court","7th Ct N","7th Line","7th Line E","7th Line Road","7th Pl",
            "7th St","7th St N","7th St NE","7th St NW","7th St SE","7th St SW","7th St W","7th Street","8 1/2 Mile Rd",
            "8 3/4 Ave","8 W 14 Rd","8 W 17 Rd","8 W 18 Rd","8 W 18 Tr","8009 Co R N","8050 Trail","80th St",
            "80th St NW","8106 County Road","812 St","81st Aly","81st St","82nd Ave","82nd St","82nd St S",
            "82nd Street","8364","83rd Ave","83rd St","84th St","84th St S","85th St","85th St NW","85th St W",
            "86th Pl S","86th Street","87th St","87th Street West","88","88th St","88th St E","88th Street",
            "89th St","8B","8N26","8th Aly","8th Ave","8th Ave E","8th Ave N","8th Ave NW","8th Ave S","8th Avenue",
            "8th Ct","8th Ct S","8th Line","8th Line W","8th Ln","8th Pl","8th St","8th St E","8th St NE","8th St NW",
            "8th St SE","8th St SW","8th St W","8th Ter","8th Ter W","9 1/8 Ave","9 Line N","9 W 25 Rd","9 W 40 Rd",
            "900 St E","90th St","91st Aly N","91st St","92nd St","92nd St N","92nd St W","939","93rd St","93rd St N",
            "94th St","94th St NW","95th St","95th Street","96 Rd","96th St","97th Pl N","97th St","97th Street Transverse",
            "98th Aly N","98th St","99 Frontage Rd","99th St W","99th Street","9N45","9Road 400","9e Rang",
            "9th Aly","9th Aly S","9th Ave","9th Ave E","9th Ave NE","9th Avenue","9th Helena Dr","9th Line",
            "9th Line W","9th Ln","9th Pl NW","9th Pl W","9th St","9th St E","9th St NW","9th St S","9th St SE",
            "9th St W","A 001 County Road","A 007 County Road","A Ave","A B Cotton Dr","A Dr","A Dr NE",
            "A Leonard Way","A N B Ln","A Rd","A Royal Ln","A St","A Street","A T T Ln","A-089","A-29","A086","A4892",
            "AT&T ROW","AZ 143","Aaron Ave","Aaron Dr","Aaron Rd","Aarondale Rd","Aarons Dr","Aarons Rd","Aarons Way",
            "Abajo Dr","Abalone Ave","Abalone Dr","Abalone Way","Abandoned Boston & Maine RR","Abandoned County Road",
            "Abandoned Hotel St","Abandoned Railroad","Abandoned Rd","Abanico Pl","Abb Rd","Abbe Road",
            "Abbet St","Abbeville Road","Abbeville St","Abbey Ct","Abbey Ct SE","Abbey Ln","Abbey Rd","Abbey Road",
            "Abbeywood Crescent","Abbeywood Ct","Abbie Ln SW","Abbington Ln","Abbot Ct","Abbot Hill Rd",
            "Abbot Park","Abbot Street","Abbot View","Abbotsfield Gate","Abbotsford Ave","Abbotsford Ln",
            "Abbotsford Road","Abbott Avenue","Abbott Brook Rd","Abbott Circle","Abbott Dr","Abbott Mtn Rd",
            "Abbott Place","Abbott Rd","Abbott St","Abbotts Rd","Abbs Street","Abby Ln","Abby Rd","Abby St",
            "Abby Way","Abdou Pl","Abe Rd","Abeche Dr","Abel Ln","Abel Rd","Abel Street","Abell Street","Abella St",
            "Abellville Dr","Abenaki Ln","Abenari Way","Aberdeen Ave","Aberdeen Avenue","Aberdeen Ct",
            "Aberdeen Dr","Aberdeen Dr SE","Aberdeen Ln","Aberdeen St","Aberdeen Street","Abeto Ct","Abeto Rd",
            "Abeyta Rd SW","Abiento Pl","Abigail Ct","Abigail Way","Abilene Drive","Abilene St","Abilene Way; E Radcliffe Dr",
            "Abingdon Road","Abington Ave","Abington Ave E","Abique Dr","Abis Pl","Able Dr","Able Ln","Able Noble Dr",
            "Ables Dr","Abner Ln","Aborn Ave","Abouaf Ct","Abraham Ave","Abraham Way","Abrahamson Rd","Abrams Ave",
            "Abrams Cir","Abrams Ridge Rd","Abrazo Dr","Abronia Ave","Absecon Blvd","Absecon Blvd Brg",
            "Absecon Rd","Acabedo Ln","Acacia Ave","Acacia Ct","Acacia Dr","Acacia Rd","Acacia St","Acacia Trl",
            "Acacia Way","Academic Dr","Academic Way","Academy","Academy Ave","Academy Blvd","Academy Ct",
            "Academy Dr","Academy Dr NW","Academy Lane","Academy Ln","Academy Park Place","Academy Parkway E NE",
            "Academy Pl","Academy Rd","Academy Road","Academy St","Academy Street","Acadia Ct SE","Acadia Dr",
            "Acadia Drive","Acadia Ln","Acala St","Acama Ave","Acampo Dr","Acanthus Ct","Acapulco Dr","Acapulco Pl",
            "Acaso Dr","Accent Ct","Access Rd","Access Rd B SE","Access Road","Ace Dr","Ace Ln","Ace Rd","Acebo Ct",
            "Acequia Ln","Aces Pl","Acheson Boulevard","Achilles Avenue","Achilles Dr","Achorn Hill Rd",
            "Acker Rd","Ackerman Ave","Ackerman Pl","Ackerman Road","Ackerman St","Ackermanville Rd",
            "Ackers Terrace","Ackerson Lane","Ackerson St","Ackertown Rd","Ackley Ter","Acklins Ave",
            "Acoaxet Road","Acocks Dr","Acoma St","Acomb Rd","Aconley Court","Acorn Ave","Acorn Cir","Acorn Circle",
            "Acorn Ct","Acorn Dr","Acorn Drive","Acorn Hill","Acorn Lane","Acorn Ln","Acorn Pl","Acorn St",
            "Acorn Street","Acorn Way","Acre Dr","Acre Road","Acre St","Acres Rd","Action Ave","Action Fab Rd",
            "Action Ln","Acton Road","Acton Street","Acushnet Avenue","Acushnet St","Acwron Dr","Ad's Ln",
            "Ada Crescent","Ada Ct","Ada Mary Pl","Ada Pl","Ada Place Dr SE","Ada St","Ada Street","Adah St",
            "Adair Dr","Adair St","Adalina Ct","Adaline St","Adaline Way","Adalisa Ave","Adam Pl","Adam Rd",
            "Adam St","Adam-Cumm Road","Adamello Way","Adames Shore Rd","Adamic Hill Rd","Adams Aly",
            "Adams Ave","Adams Avenue","Adams Blvd","Adams Court","Adams Ct","Adams Dr","Adams Drive","Adams Green",
            "Adams Hill Rd","Adams Leidenfrost Rd","Adams Ln","Adams Pl","Adams Rd","Adams Resort Dr",
            "Adams Road","Adams Shore Dr","Adams St","Adams St NE","Adams St SE","Adams Street","Adams Trl",
            "Adams Way","Adamson Rd","Adamsville Road","Adamucci Ln","Adanac Ct","Adanac Drive","Adare Way",
            "Adda Dr","Addely Dr","Addie Lane","Addingham Ave","Addington Avenue","Addington Court","Addington Ln",
            "Addison Ave","Addison Avenue","Addison Ct","Addison Dr","Addison Rd","Addison St","Addison Street",
            "Addor","Adelaida Rd","Adelaide Avenue","Adelaide Road","Adelaide Street S","Adele Ct","Adele St",
            "Adelford Ave","Adelheid Way","Adelia Ct","Adelina Ct","Adeline Ave","Adeline Pl","Adella Dr",
            "Adelman Road","Adelphi Ct","Adelphi Dr","Adelphi St","Adelphia Ave","Aden Rd","Adencliff Road",
            "Aderholt Rd","Aderholt St","Aderno Court","Adina Lane NW","Adirondack Northway","Adirondack Park",
            "Adirondack Park Preserve","Adirondack Pl","Adit 4 Rd","Adkins Rd","Adlena Pl","Adlepha Ave",
            "Adler St","Administration Road","Administration Way","Admiral Circle","Admiral Dr","Admiral Drive",
            "Admiral Nimitz Ave NE","Admiral Rd","Admiralty Way","Adobe","Adobe Creek","Adobe Creek Ct",
            "Adobe Dr","Adobe Pl","Adobe Rd","Adobe Springs Ct","Adobe St","Adolfus St","Adolphs Dr","Adolphus St",
            "Adot Way","Adra Villaway","Adrian Ave","Adrian Ct","Adrian Hill Way","Adrian Lake Rd","Adrian Way",
            "Adriana St","Adrianno Crescent","Adrians Way","Adriel Dr","Adriene Way","Adullam Avenue",
            "Adult Dr","Advantage Pointe Ct","Adventist Blvd NW","Adventist Church Rd","Aegean Dr",
            "Aegean St","Aero Rd","Aerojet Ave","Aesculapius Rd","Aetna Pl","Aetna St","Affirmed Ln","Afton Ave",
            "Afton Avenue","Afton Chapel Rd","Afton Dr","Afton Ln","Afton Rd","Afton Ter","Afton Way","Ag Pl SE",
            "Ag School","Agape Ln","Agar Road","Agatam Ave","Agate","Agate Ct","Agate Dr","Agate St","Agate Ter",
            "Agate Way","Agave Ave","Agave Cir","Agave Rd","Agawam Ave","Agawam Road","Agawam Street","Agena Ln",
            "Ager Beswick Rd","Ager Rd","Agnes Ave","Agnes Dr","Agnes Jones Rd","Agnes Pl","Agnes St","Agnew Road",
            "Agnew Street","Agora Road","Agostina Crescent","Agostina Dr","Agricola Rd","Agua Caliente Rd",
            "Agua Fria Ct NW","Agua Tibia Pl","Agua Vista","Aguacate Ln","Aguereberry Point","Aguila Rd",
            "Aguirre Rd","Aguirre Springs Rd","Agulawok Dr","Ahearn Ave","Ahern Dr","Ahlers Rd","Aho Road",
            "Ahola Ave","Ahrens Ln","Ahrens Pl","Aichebaun","Aida Way","Aiken Ave","Aiken Mine Rd","Aikenhead Avenue",
            "Aikens Road","Ailanthus Ln","Aileron Ave","Ailsa Ave","Aim Ave","Aimee Way","Ainsdale Wy","Ainswick Dr",
            "Air Park Dr","Air Strip","Aircraft Ave","Airdrie Ct","Aires Dr","Airforce Rd","Airline Hwy",
            "Airmont Avenue","Airpark Dr","Airport Blvd","Airport Connector","Airport Ct","Airport Dr",
            "Airport Park Blvd","Airport Parkway","Airport Rd","Airport Rd SW","Airport Return","Airport Road",
            "Airport Service Road","Airport Way","Airport Zero Level","Airsdale Ave","Airstrip Rd",
            "Airview Ct","Airview Dr","Airview Rd","Airview Road","Airway Blvd","Airway Dr","Airway Rd SW",
            "Airway St NE","Airy Hill St","Aitken Circle","Aitkin Rd","Ajanta Ave","Ajax Ave","Ajay Dr",
            "Ajo Rd","Akard St","Ake Ave","Akela Rd","Akeley","Akerly Dr","Akers St","Akins Ct","Akron Boat Club Rd",
            "Akron Canfield Rd","Akron Ct","Akron Expressway","Akron Pl","Akron Rd","Akwo Cir","Al Carrison St",
            "Al Khayam Ct","Al Parker Ln","Alabama Ave","Alabama Ave SW","Alabama Path","Alabama St",
            "Alabanza Rd","Alabaster","Alachua Ct","Alam Rd","Alamar Ave","Alamatos Dr","Alambique Trail",
            "Alambre","Alameda Ave","Alameda Circle","Alameda Ct","Alameda Rd","Alameda St","Alamitos Way",
            "Alamo Ave","Alamo Ave SE","Alamo Creek Rd","Alamo Ct","Alamo Dr","Alamo Hueco Pl","Alamo Rd",
            "Alamo Spring Trail","Alamo St","Alamo Way","Alamosa Drive","Alamosa Way","Alan","Alan B Shepard Highway",
            "Alan B Shepard Jr Highway","Alan B Shepard Jr Hwy","Alan Ln","Alan Pl","Alan St","Alan Ter",
            "Alana Dr","Alana St","Alandale Avenue","Alanview Dr","Alaska","Alaska Ave","Alaska Jade St",
            "Alaskan Blvd","Alava","Alba Avenue","Alba Ct","Alba Place NW","Albacon Rd","Alban St","Albana Dr",
            "Albany Ave","Albany Avenue","Albany Blvd","Albany Ct","Albany Ct NW","Albany Post Road",
            "Albany Rd","Albany St","Albany Street","Albany Tpke","Albatross Ave","Albatross Dr","Albatross St",
            "Albee Ln","Albee Rd","Albee St","Albemarle Ave","Albemarle St","Albermarle Ave","Albermarle Avenue",
            "Albernathy St","Albert Ave","Albert Ct","Albert Cucci Dr","Albert Davis Rd","Albert Dr",
            "Albert Ln","Albert Pl","Albert Rd","Albert Road","Albert St","Albert Street","Albert Street N",
            "Alberta Ave","Alberta Avenue","Alberta Ct","Alberta Dr","Alberta Drive","Alberta St","Alberta Ter",
            "Alberto Ave NE","Alberto Cataudella Memorial Trail","Albertson Fire Road","Albertson St",
            "Albin Ave","Albin Rd","Albina Avenue","Albion Ave","Albion Cross Rd","Albion Rd","Albion Ridge H Rd",
            "Albion Ridge Rd","Albion Road","Albion St","Albion-Little River Rd","Albiso Dr","Albrecht Ave",
            "Albrecht Rd SW","Albright Ave","Albright Avenue","Albright Ln","Albright Rd","Albro Street",
            "Alburtis Ave","Alcalde Rd SW","Alcamo Ave","Alcan Avenue","Alcaranci Dr","Alcarin Rd NW",
            "Alcina Avenue","Alcona Rd","Alconbury Way","Alcosta Blvd","Alcott Ave","Alcott Ave NE","Alcott Cir",
            "Alcott Ct","Alcott Dr","Alcott Road","Alcyon Ct","Aldan Ave","Aldbury Ct","Aldcroft Crescent",
            "Aldebaran Ave","Aldeburgh Ave","Alden Ave","Alden Avenue","Alden Cir","Alden Ct","Alden Dr",
            "Alden Drive","Alden Ln","Alden Pl","Alden Road","Alden St","Alden Street","Alden Ter","Alden Walk",
            "Alder","Alder Ave","Alder Bottom Rd","Alder Creek Dr","Alder Creek Dr S","Alder Crescent",
            "Alder Ct","Alder Ln","Alder Pl","Alder Rd","Alder Springs Rd","Alder St","Alder Street E","Alder Street W",
            "Alder Ter","Alderberry Ln","Alderbrook","Alderbrook Lane","Alderbrook Rd","Aldercrest Court",
            "Aldergrove Drive","Alderman Rd","Aldersgate Ct","Aldershot Crescent","Alderslea Avenue",
            "Alderson Avenue","Alderwood Ct","Aldin Rd","Aldine St","Aldo Ct","Aldom Cir","Aldon Dr","Aldon Ln",
            "Aldorisio St","Aldred Drive","Aldrice Burk Dr","Aldrich Ave","Aldrich Dr","Aldrich Ln","Aldrich Rd",
            "Aldrich St","Aldrich Street","Aldrin Ln","Aldwin Road","Aldworth Street","Aldwyn Ln","Aleatha Cv",
            "Alecia Dr","Aleda Drive","Alegre Dr","Alegre Dr NE","Alegre Rd","Alegre St","Aleli Rd","Aleman Dr",
            "Alemar Way","Alene Ave","Aleppo St","Alessandro Rd","Alex Cir","Alex Circle","Alex Ct","Alex Dr",
            "Alex Jefferies Rd","Alex Pl","Alexa Breanne Ct","Alexa Ct","Alexa Rd","Alexander","Alexander Ave",
            "Alexander Boulevard","Alexander Ct","Alexander Dr","Alexander Hill Road","Alexander Ln",
            "Alexander Muir Road","Alexander Pky","Alexander Rd","Alexander Road","Alexander St","Alexander Street",
            "Alexander Valley Ln","Alexanderia Ave","Alexandra Avenue","Alexandra Boulevard","Alexandra Cir",
            "Alexandra Street","Alexandra Way","Alexandria Bay and Hammond Trolley","Alexandria Court",
            "Alexandria Pkwy","Alexandria Rd","Alexandrite Rd","Alexis Ave","Alexito St","Alexmuir Boulevard",
            "Alexnoel Ct","Alfa Ter","Alferd Ave","Alfieri Ct","Alford Dr","Alford Ln","Alford St","Alfred Harrell Hwy",
            "Alfred Paterson Drive","Alfred Rd","Alfred Road","Alfred St","Alfred Street","Alfred Way",
            "Alga Rd","Alganet Rd","Algard St","Algarrobo","Algebe Way","Algeciras Dr","Alger Ave","Alger Rd",
            "Alger St","Alger Street","Algerine Rd","Algin Dr","Algodon Rd","Algodones Ct NE","Algomah St",
            "Algonquin","Algonquin Avenue","Algonquin Ct","Algonquin Dr","Algonquin Ln","Algonquin Path",
            "Algonquin Point Rd","Algonquin Road","Algonquin Trl","Algonquin Way","Alha Ave","Alhambra Avenue",
            "Alhambra Circle North","Alhambra Ct","Alhart Drive","Alia Ct","Alicante Ave","Alicante Dr",
            "Alicante Way","Alice Aly","Alice Ave","Alice Ave NE","Alice Avenue","Alice Court","Alice Dr",
            "Alice Grant Ln","Alice Lake Dr","Alice Ln","Alice Moody Rd","Alice St","Alice Street","Alicewood Court",
            "Alicia","Alicia Ave","Alicia Ave NW","Alicia Ct","Alicia St","Alico Rd","Alida Ct","Alida Dr",
            "Alimony Rd","Alington Bridge St","Alinn Pass Rd","Alisa Ln","Aliso Ct","Aliso Dr NE","Aliso Dr SE",
            "Aliso Pl","Alison","Alison Drive","Alisos Rd","Alissa Dr","Alissa Ln","Alitak Rd","Alitos Dr",
            "Alkali Dr","Alken Rd","All Pro Dr","All Trades Rd","Allamuchy Rd","Allan Avenue","Allan Dr",
            "Allan Drive","Allan Place","Allan St","Allan Street","Allan's Mill Road","Allanbrooke Drive",
            "Allanburg Road","Allandale Road","Allanford Road","Allanhurst Drive","Allaquest Ct","Allard Avenue",
            "Allard Cir","Allard Dr","Allard St","Allayden Drive","Allegan Cir","Allegany St","Allegany State Park",
            "Allege Ct","Alleghany Ave","Allegheny Ave","Allegheny Rd","Allegheny Springs Rd","Allegheny St",
            "Allegheny Way","Allegra Dr","Allegre Rd","Allen Ave","Allen Avenue","Allen Blvd","Allen Cemetery Rd",
            "Allen Court","Allen Ct","Allen Ct Rd","Allen Dr","Allen Hill Rd","Allen Lake Rd","Allen Ln",
            "Allen Padgham Rd","Allen Park Pl","Allen Pl","Allen Place","Allen Rd","Allen Road","Allen St",
            "Allen Street","Allen's Way","Allenbury Gardens","Allenby Rd","Allendale Dr","Allendale Rd",
            "Allende Ln","Allende Rd","Allenford Dr SE","Allengate Avenue","Allenhurst Ave","Allenton Pl",
            "Allenvale Avenue","Allenwood Ave","Allenwood Dr","Allenwood Rd","Allerman Ln","Alley","Alley 1",
            "Alley 3","Alley 51","Alley 8","Alley 9","Alley Dr","Alley No 4","Alley Rd","Alley S","Alley St","Alley Way",
            "Alleyhoot Rd","Alleyne Ave","Alleyway","Allgeyer Ave","Allgood Street","Alliance Ave","Alliance Avenue",
            "Alliance Rd","Alliance St","Allie Canyon Trl","Allie St","Allied Way","Allin St","Allingham Gardens",
            "Allison","Allison Ave","Allison Cir","Allison Ct","Allison Dr","Allison Park Rd","Allison Rd",
            "Allison Sq","Allison St","Allison Street","Allison Way","Allister Avenue","Allore Road",
            "Alloway Aldine Rd","Alloway-Woodstown Rd","Allred Rd","Allspice Ln","Allston Rd","Allston Street",
            "Allthorn Ave","Allwood Ter","Allyn Rd","Allyson St","Alm Rd","Alma Ave","Alma Cole Rd","Alma Ct",
            "Alma Dr","Alma Mesa Rd","Alma Pl","Alma Rd","Alma Rd SE","Alma Street","Almac Drive","Almaden Rd",
            "Almaden Way","Almanor Dr","Almar Rd","Almar St","Almeda Ct","Almeda Street","Almejo Avenue",
            "Almelo Rd","Almira Avenue","Almithni Ave","Almond Ave","Almond Blossom Ct","Almond Court",
            "Almond Ct","Almond Dr","Almond Grove Mhp","Almond Pl","Almond Rd","Almond St","Almond Valley Dr",
            "Almont Ave","Almont St","Alnette Road","Alnoor Dr","Alnwick Lane","Aloe Dr","Aloe Drive","Aloma Dr",
            "Alonzo Ct","Alosio Dr","Alpen Way","Alpena St Rd","Alper St","Alpha Ave","Alpha Avenue","Alpha Crucis St",
            "Alpha Ct","Alpha Ln","Alpha Loop Rd","Alpha Rd","Alpha St","Alpha Street","Alphano Rd","Alpheus St",
            "Alpine Ave","Alpine Cir","Alpine Ct","Alpine Cv","Alpine Dr","Alpine Ln","Alpine Meadows","Alpine Pl",
            "Alpine Pointe Ln","Alpine Rd","Alpine Ridge","Alpine Ridge Way","Alpine Road","Alpine Spring Rd",
            "Alpine St","Alpine Street","Alpine Ter","Alpine Trl","Alpine Way","Alps Ct","Alps Dr","Alps Rd",
            "Alps St","Alscot Ave","Alsop Avenue","Alsop Ct","Alsopp Park Rd","Alston Ave","Alsun Dr","Alt Dr",
            "Alta","Alta Acres Dr","Alta Ave","Alta Dr","Alta Ln","Alta Mesa","Alta Mesa East Rd","Alta Mesa Way",
            "Alta Monte Ave NE","Alta Oaks Rd","Alta Peak Ct","Alta Pl SE","Alta Sierra Dr","Alta St",
            "Alta Ter","Alta Trail","Alta Trl","Alta Vista","Alta Vista Ct","Alta Vista Dr","Alta Vista St",
            "Alta Way","Altacrest Dr","Altadena Court","Altadena St","Altair Cir","Altair Ct","Altair Rd",
            "Altamont Ave","Altamont Dr","Altamont Rd","Altamont Way S","Altaview Ct","Altavista Ct",
            "Alter Court","Alter St","Altern St","Althea Ct NE","Althea Dr","Althea Path","Althea St","Altito St",
            "Altmark Ave","Alto Ave","Alto Dr","Alto Pines Rd","Alto Rd","Alton Avenue","Alton Ct","Alton Pl",
            "Alton Pl NE","Alton Place","Alton Road","Alton St","Alton Towers Circle","Altona Road","Altoona St",
            "Altura Dr","Altura St","Alturas Dr","Alturas Rd","Altus Ave","Altus Park Drive","Alum Ave",
            "Alum Hill Road","Alum Rock Ave","Alumni St","Alva Ct","Alva Lake Rd","Alva St","Alvarado St",
            "Alvarez Dr","Alvern Ave","Alvey Ln","Alvillar Rd","Alvin","Alvin Ave","Alvin Ct","Alvin James Dr",
            "Alvin St","Alvin Street","Alvin Way","Alvina Dr","Alviso Dr","Alvord Dr","Alwood Ln","Alysheba Ave",
            "Alysia Ct","Alyson Rd","Alyssa Ave","Alyssa Ln","Alyssum Ct","Alyssum Ln","Amada Romero Rd",
            "Amadeo Pl","Amadita Ln","Amado","Amador Ln","Amador Plaza Rd","Amagosa Rd","Amalfi Dr","Amalfy Ave",
            "Aman Dr","Amanda Cir","Amanda Ct","Amanda Dr","Amanda Ln","Amanda St","Amanda Way","Amanita Ave",
            "Amann Dr","Amansa Landing","Amapola Ct","Amapola Dr","Amaranth Ln","Amarillo Dr","Amarillo Rd",
            "Amarillo St","Amarillo del Sol","Amario Rd","Amarone Avenue","Amasa Road","Amason St","Amateur Ln",
            "Amatista Ln","Amatol Rd","Amazing Valley Ln","Amazon River Cir","Ambassador Street","Amber Ave",
            "Amber Cir","Amber Ct","Amber Dr","Amber Hill Dr","Amber Isle","Amber Lantern Cir","Amber Ln",
            "Amber St","Amber Vista","Amber Way","Amberglen Court","Amberglen Dr","Amberjack Bay E",
            "Amberlea Ln","Amberlea Road","Amberly Ct","Amberly Dr W","Amberwick Trl","Amberwinds Ct",
            "Amberwood Lane","Amberwood Pl","Amberwood Rd","Ambler Ct","Ambler Way","Amboy Court","Amboy Pl",
            "Amboy Rd","Amboy St","Ambrose Alday Loop SE","Ambrose Ct","Ambrose Dr","Ambrose Ln","Ambrose St",
            "Ambrosia Way","Ambs Rd","Amco Rd","Ameer Avenue","Amelia Ct","Amelia Dr","Amelia Ln","Amelia St",
            "Amelia Street","Amend St","Ameretta Avenue","America Ave","America Avenue","America Mine Rd",
            "America Street","American Canyon","American Canyon Rd","American Dr","American Legion Circle",
            "American Legion Dr","American Rd NW","American River Bike Trl","American River Dr",
            "American River Rd","American River Way","Americare Ct NW","Americas Pky","Amerine St",
            "Amersfort Place","Amerson Rd","Ames 1st Ln","Ames 2nd Ln","Ames Ave","Ames Circle","Ames Court",
            "Ames Cres","Ames Ct","Ames Hill Rd","Amesbury Aly","Amesbury Avenue","Amesbury Drive","Amesbury Pl",
            "Amesbury Rd","Amesbury Street","Amesdale Dr","Amethyst Ave","Amethyst Circle","Amethyst Dr NE",
            "Amethyst Way","Amey St","Amgen Ct","Amherst Ave","Amherst Avenue","Amherst Cir","Amherst Ct",
            "Amherst Dr","Amherst Park","Amherst Pl","Amherst Rd","Amherst Road","Amherst St","Amherst Street",
            "Amherst Way","Amhurst Dr","Amico Avenue","Amidon Pl","Amiens Ct","Amiens Road","Amigo","Amigo Dr",
            "Amigo Drive","Amigo Ln","Amik-Onse Ct","Amis Ave","Amistad Dr","Amistad Ln","Amistad St E",
            "Amito Avenue","Amity Pl","Amity Road","Amity St","Amity St SE","Ammo Rte","Ammon Dr","Ammon Rd",
            "Ammon St","Ammrus Way","Amor Dr","Amorak Rd","Amorose St","Amory Ave","Amory Ct","Amos Ave","Amos Crescent",
            "Amos Douglas Rd","Amos Mc Keen Rd","Amos Pl","Amos St","Amos Street","Amparo Drive","Ampere Ave",
            "Ampezzo Avenue","Amsbry St","Amsden Ave","Amspoker Rd","Amsterdam Ave","Amsterdam Avenue",
            "Amsterdam Cir","Amsterdam Dr","Amsterdam Rd","Amtrack Road","Amulet Crescent","Amundsen Avenue",
            "Amundsen Ln","Amvet Dr","Amvets Memorial Highway","Amy Cir NW","Amy Ct","Amy Dr","Amy Lane",
            "Amy Ln","Amy Rd","Amy St","Amy-Jenn Dr","Amys Way","Anacapa Ave","Anacapa Bay Ln","Anacapa Cir",
            "Anacapa St","Anacapa Trl","Anaconda Avenue","Anaheim Avenue NE","Anahoe Cir","Anahuac Ave",
            "Anamonte","Anan Wade Rd","Anaparno Ct","Anastasia Ct","Anastazi Dr","Anawan Avenue","Anawood Way",
            "Anaya Ln","Anaya Rd","Anazasi Rd","Anazazi Rd","Anchor Ave","Anchor Ct","Anchor Dr","Anchor Drive",
            "Anchor St","Anchorage Ave","Anchorage Cir","Anchorage St","Ancient Dr SW","Ancient Stone Avenue",
            "Ancona Road","Ancona St","Andalucia Ct","Andana Cir","Andaravida Rd","Anden Pl","Anderman St",
            "Andermatt Dr","Andersen Drive","Anderson","Anderson Ave","Anderson Ave NE","Anderson Ave SE",
            "Anderson Avenue","Anderson Blvd","Anderson Boulevard","Anderson Dr","Anderson Drive",
            "Anderson Ford Rd","Anderson Grade Rd","Anderson Hill Rd","Anderson Line","Anderson Ln",
            "Anderson Pl","Anderson Pl SW","Anderson Rd","Anderson Road","Anderson St","Anderson Street",
            "Anderson Valley Way","Anderson Way","Andes Pl","Andes Rd","Andes Road","Andes-Delancey Rd",
            "Andes-Delancey Road","Andissa","Andorra Ct","Andover Ct","Andover Dr","Andover Drive","Andover Mohawk Rd",
            "Andover Pl","Andover Point","Andover Rd","Andover Road","Andover Street","Andover Way","Andrade Rd",
            "Andre Ave","Andre Ct","Andre Ln","Andrea Ave","Andrea Dr","Andrea Ln","Andrea Pl","Andrea St",
            "Andreasen Dr","Andree Rd","Andree Way","Andres Ct","Andres St","Andrew Ave","Andrew Ct","Andrew Dr",
            "Andrew Hardings Lane","Andrew Park","Andrew Pl","Andrew St","Andrew Street","Andrew Victor Way",
            "Andrews Ave S","Andrews Avenue","Andrews Ct","Andrews Memorial Drive","Andrews Pl","Andrews Rd",
            "Andrews Road","Andrews St","Andrews Street","Andrews Way","Andria Ave","Andria Rd","Andrien Ln",
            "Andromeda Ln","Andros Ave","Andrus Ave","Andry Rd","Andy Dr","Andy Ln","Andy's Court","Anea Trl",
            "Anegam Rd","Aneta Circle","Angel Court","Angel Crest Cir","Angel Ct","Angel Dr","Angel Hill Rd",
            "Angel Lake Rd","Angel Mountain Rd","Angel Pass Drive","Angel Pond Rd","Angel Ranch Rd",
            "Angel St","Angel Abrego","Angela Ave","Angela Crescent","Angela Ct","Angela Dr","Angela Pl",
            "Angela Robin St","Angela St","Angelberry St","Angeles Crest Hwy","Angeles Rd","Angelina Avenue",
            "Angeline Ave","Angeline Street N","Angelita Ave","Angell Ln","Angell Rd","Angell St","Angelo Cir",
            "Angelow Rd","Angelus Ave","Angelus Ct","Anger Rd","Angie Ct","Angie Dr","Angie Place","Angle Dr",
            "Angle St","Angle Street","Anglers Rest Cv","Anglia St","Anglican Church Road","Angola Cv",
            "Angora Lake Rd","Angora Street","Angostura Camp Rd","Angus Avenue","Angus Glen Boulevard",
            "Angus Ln","Angus Rd","Angus Way","Anillo Way","Animas Ct NE","Anita Ave","Anita Ct","Anita Drive",
            "Anita Ln NE","Anita Ter","Anjou Ct","Ankara Dr NE","Ann Arbor Ln","Ann Arbor Rd","Ann Ave",
            "Ann Boleyn Ln","Ann Cir SE","Ann Ct","Ann Dr","Ann Hannagan Ln","Ann Lee Dr","Ann Marie Dr",
            "Ann Mitchell Rd","Ann St","Ann Street","Ann Street N","Ann Ter","Ann's Fire Road","Anna Ave",
            "Anna Ct","Anna Dr","Anna Drive","Anna Lee Dr","Anna Ln","Anna Marie Ct","Anna Road","Anna St",
            "Anna Sue Cir","Annabelle Drive","Annadale","Annadale Ter","Annan Cir","Annan Drive","Annan Ln",
            "Annan Woods Drive","Annandale Dr","Annapolis Avenue","Annapolis Dr","Annapolis Rd","Annapolis Road",
            "Annapolis St","Annavoy Street","Anndale Drive","Anne Dr","Anne Ln","Anne St","Anne Street",
            "Annedale","Annett Ave","Annette Ave","Annette Avenue","Annette Ct","Annette Rd","Annette Street",
            "Annex Rd","Annie Ave","Annie Dr","Annie Ln","Annie St N","Annie's Hill","Annin St","Annina Avenue",
            "Annina Crescent","Annis Court","Annis Rd","Annis Street","Annisquam Rd","Annrae St","Anpy Rd",
            "Anrrom St","Ansel Ct","Ansel Dr","Ansley Grove Road","Ansley Street","Anson Avenue","Anson Dr",
            "Anson Rd","Ansonia Street","Ansonia-Derby Expy","Anstruther Lake Road","Antares Ave",
            "Antares Dr","Antell Cir","Antelope Blvd","Antelope Ct","Antelope Dr","Antelope Hills Dr",
            "Antelope Ln","Antelope Ovi","Antelope Rd","Antelope Spring","Antelope Springs Rd","Antelope St",
            "Antelope Trl","Antelope Valley Freeway","Antelope Valley Fwy","Antelope Way","Anthia Drive",
            "Anthon Rd","Anthony Ave","Anthony Cir","Anthony Drive","Anthony Pl","Anthony Rd","Anthony Road",
            "Anthony St","Anthony Street","Anthony Way","Antiach Church Rd","Antietam Dr","Antigua Ct",
            "Antigua Pl","Antigua Rd","Antioch Ave","Antioch Community Rd","Antioch Drive","Antioch Rd",
            "Antiqua Ln","Antique Drive","Antique Ln SE","Antium Rd","Antler Court","Antler Hollow Pl",
            "Antler Ridge Way","Antler Street","Antler Way","Antoinette Dr","Antola Rd","Anton Pl","Anton Square",
            "Anton St","Antone","Antonio Ct","Antonio Dr","Antonito Rd","Antrim Street","Anvil Ct","Anvil Rd",
            "Anworld Place","Anya Ct","Anza Pl","Anzac Cir","Apache Ave","Apache Dr","Apache Gold","Apache Ln",
            "Apache Pl","Apache Rd","Apache Road","Apache Road S E","Apache Rose Ct","Apache St","Apache Tr",
            "Apache Trail","Apache Trce","Apache Trl","Apartments","Apawana Ln","Apgar Ct","Aphrodite Dr",
            "Apis Ct","Aplenhof Dr","Apley Dr","Apodaca Rd","Apollo Ave","Apollo Court","Apollo Dr","Apollo Ln",
            "Apollo Way","Appalachi St","Appalachian Dr","Appalachian Trail","Appaloosa Ct","Appaloosa Ln",
            "Appaloosa Rd","Appaloosa Way","Appeling Dr","Apperson Cir","Appian Dr","Appian Way","Apple Blossom Blvd",
            "Apple Blossom Boulevard","Apple Blossom Dr","Apple Blossom Drive","Apple Blossom Ln",
            "Apple Bluff Dr","Apple Creek Boulevard","Apple Creek Ct","Apple Creek Dr","Apple Creek Rd",
            "Apple Dr","Apple Grove Court","Apple Grove Rd","Apple Hill Ct","Apple Hill Dr","Apple Hill Rd",
            "Apple Jack Ln","Apple Ln","Apple Orchard Path","Apple Pl","Apple Ridge Rd","Apple St","Apple Tree Ct",
            "Apple Tree Row","Apple Valley Ct","Apple Valley Rd","Apple Valley Road","Apple Way","Applebey St",
            "Appleblossom Cir","Appleblossom Dr","Applebrook Dr","Appleby Ave","Applecross Ln","Applecross Pl",
            "Appledale Ln","Appledale Road","Appledore Ave","Applegate Ave","Applegate Court","Applegate Ct",
            "Applegate Lane","Applegate Ln","Applegate Ter","Applegate Way","Applegrove Ct","Applejack Ln",
            "Applemill Road","Appleton","Appleton Ave","Appleton Avenue","Appleton Place","Appleton Rd",
            "Appleton St","Appleton Street","Appletree Ct","Appletree Dr","Appletree Ln","Appletree Rd",
            "Appletree St","Applewood Avenue","Applewood Dr","Applewood Drive","Applewood Ln","Applewood Rd",
            "Applewood Trail","Applino St","Appomattox Ct","Appomattox Dr","Appomattox Pl NE","Appy Acres",
            "Apremont Highway","Apricot Dr","Apricot Ln","Apricot St","Apricot Street","April Cir","April Ct",
            "April Cv","April Ln","April Rd NE","Apsley Road","Apthrop Ave","Aptos Ave","Apulia Rd","Aqua Caliente Rd",
            "Aqua Ct","Aqua Ln","Aqua St","Aqua Ter","Aqua Vista Ct","Aqua Way","Aquadale Drive","Aquarium Dr",
            "Aquarius Dr","Aquarius St","Aqueduct Rd","Aqueduct Street","Aquila Ln","Aquilla Rd","Aquino Cir",
            "Ar 16 Hwy W","Ar 65 Hwy N","Ar 65 Hwy S","Ar 8 Hwy N","Ar 9 Hwy E","Ar 92 Hwy E","Ar 95 Hwy",
            "Arabella Rd","Arabian Ln","Arabian Rd","Arabian Trl","Arabian Way","Arabis Dr","Araby Rd","Aragon Avenue",
            "Aragon Dr","Aragon Rd SW","Aram Ct","Arapaho Court","Arapaho Ct","Arastradero Rd","Arate Ln",
            "Arawak Ct","Arb St","Arbaugh St","Arbawr Ct","Arbogast Rd","Arbol Grande","Arbolada Dr","Arboles Dr",
            "Arbolito Ct","Arbor Crest Dr","Arbor Ct","Arbor Ct E","Arbor Ct W","Arbor Dr","Arbor Ln","Arbor Pl",
            "Arbor Rd","Arbor St","Arbor Street","Arbor Way","Arbordale Pl","Arborhurst Cir","Arborhurst Ln",
            "Arborry Hill Dr","Arborway","Arborwood","Arbour Crescent","Arbour Ct","Arbroath Ln","Arbuckle Ct",
            "Arbuckle Rd","Arbuckle Tribble Rd","Arburn Ave","Arbutus Ave","Arbutus Dr","Arbutus Ln",
            "Arbutus St","Arbutus Way","Arca Dr","Arcada Dr","Arcade 1","Arcade Avenue","Arcade Blvd","Arcadia Ave",
            "Arcadia Ct","Arcadia Dr","Arcadia Palms Dr","Arcadia Park Rd","Arcadia Pl","Arcadia Plz",
            "Arcadia Rd","Arcadia St","Arcadia Street","Arcadian Shores Rd","Arcadian Trl NW","Arcaro Rd",
            "Arcata Pl","Arcata Rd","Arcata Trl","Arch Bay Ln","Arch Rd","Arch St","Arch Street","Archdale St",
            "Archer Ct","Archer Dr","Archer Lane","Archer Rd","Archer St","Archer Street","Archer View Dr",
            "Archer's Aly","Archers Ridge Rd","Archery Ridge Rd","Arches Ave","Archibald Ave","Archibald Road",
            "Archie Valley Ct","Archuleta Dr NE","Archwood Manor Dr","Archwood St","Arciero Ct","Arco Ct NW",
            "Arco Iris St","Arcola","Arcola Ave","Arcola Trail Lake Rd","Arcos Dr","Arctic Ave","Arctic Spring Way",
            "Arcus Rd","Ardagh Road","Ardath Ave","Ardath Dr","Ardelean Dr","Arden Court","Arden Ct","Arden Dr",
            "Arden Dr W","Arden Pl","Arden Road","Arden Valley Road","Arden Valley Street","Arden Way",
            "Ardennes Ct","Ardenwood Cir","Ardesch Ct","Ardgrove Ln","Ardill Crescent","Ardilla Rd","Ardis St",
            "Ardisia Ct","Ardleigh Ct","Ardley Ct","Ardmaer Dr","Ardmore Ct","Ardmore Ln","Ardmore Pl","Ardmore Rd",
            "Ardmore Ridge Rd","Ardmore St","Ardoch Dump Road","Ardon Ct","Ardoyle Ave","Ardsleigh Dr",
            "Ardsley Ct","Ardsley Dr","Ardsley Road","Ardsley Sq","Ardwold Gate","Area B","Arellano Rd",
            "Arena Dr","Arena Street","Arenac St","Arenas Valley Rd","Argail Way","Argee Dr","Argentite St",
            "Arginis St","Argo Dr","Argonaut Way","Argonne Ave","Argonne Farm Dr","Arguello Creek","Arguello Dr",
            "Arguello Rd","Argus Ave","Argus Crescent","Argyle Ave","Argyle Ct","Argyle Dr","Argyle Pl",
            "Argyle Rd","Argyle Road","Argyle St","Argyle Street","Argyle Ter","Arial Court","Ariana Way",
            "Arianza Ct","Ariba","Ariel Circle","Arielle Lane","Aries Cir","Aries Crescent","Aries Rd","Arigot Ct",
            "Arion Place","Arion Rd","Aris Ave","Arista Dr","Arista St","Aristotle","Aristotle Dr","Aristotle Drive",
            "Aristotle Ln","Arivaca Rd","Arizo Ct","Arizona Ave","Arizona Blvd","Arizona Ln","Arizona Pl NE",
            "Arizona St","Arizona State Hwy 260","Arjang Ct","Arjay Crescent","Arkabutla Cv","Arkabutla Dam Rd",
            "Arkabutla Lake Dam","Arkabutla Rd","Arkadelphia Rd","Arkansas Ave","Arkansas Ct","Arkansas Dr",
            "Arkansas St","Arkell Ct","Arlana Way","Arlee Ave","Arlena Ct","Arlena Terrace","Arlene Ct",
            "Arlene Dr","Arlene Pl","Arlene Ter","Arlene Way","Arleta Avenue","Arlie Dr","Arlin Rd","Arline Dr",
            "Arlington Ave","Arlington Avenue","Arlington Cir","Arlington Court","Arlington Ct","Arlington Dr",
            "Arlington Drive","Arlington Pl","Arlington Point","Arlington Rd","Arlington Road","Arlington Sq",
            "Arlington St","Arlington Street","Arlington Terrace","Arlo Rd","Arly Ct","Armada Dr","Armand Ave",
            "Armand Dr","Armand Rd","Armand St","Armando Ave","Armenta","Armentrout Path","Arminta St","Armistice Blvd",
            "Armitage Crescent","Armitage Dr","Armitage Ln","Armitage St","Armito Dr","Armonica Rd","Armory",
            "Armory Pl","Armory Rd","Armory St","Armour Ave","Armour Rd","Armour Road","Armour Street","Arms Ave",
            "Armstrong Ave","Armstrong Avenue","Armstrong Blvd","Armstrong Cemetery Rd","Armstrong Ct",
            "Armstrong Dr","Armstrong Ln","Armstrong Pass Trail","Armstrong Pl","Armstrong Rd","Army Rd",
            "Arna Ln","Arndt Ave","Arnell Ln","Arneson Ln","Arnett Blvd","Arnett Cir","Arnette Dr","Arnie's C",
            "Arno Rd","Arno St NE","Arnold Ave","Arnold Avenue","Arnold Blvd","Arnold Cir","Arnold Crescent",
            "Arnold Ct","Arnold Dr","Arnold Ln","Arnold Rd","Arnold Road","Arnold St","Arnold Street","Arnold Ter",
            "Arnold Terrace","Arnot Pl","Arnprior Road","Arona Ct","Arosa Hill","Arrants St","Arrigoni Brg",
            "Arrison Ct","Arrow Creek Pky","Arrow Ct","Arrow Dr","Arrow Head","Arrow Park Rd","Arrow Road",
            "Arrow St","Arrow Street","Arrowbear Dr","Arrowhead","Arrowhead Dr","Arrowhead Ln","Arrowhead Park Dr",
            "Arrowhead Point Rd","Arrowhead Rd","Arrowhead Ridge Dr SE","Arrowhead Road","Arrowhead Trl",
            "Arrowhead Way N","Arrowood Ct","Arrowood Pl","Arrowood St","Arrowridge Cir","Arrowsmith Dr",
            "Arrowwood Ave","Arrowwood Ct","Arrowwood Ln","Arrowwood Rd","Arroyo","Arroyo Ave","Arroyo Ct",
            "Arroyo Drive","Arroyo Grande Rd","Arroyo Ln","Arroyo Pl","Arroyo Seco","Arroyo Seco Dr",
            "Arroyo Seco Way","Arroyo St","Arroyo Vista Dr","Arroyo Vista Ln","Arroyo del Mar","Arsdale Pl",
            "Arsenal Street","Art St","Art and Mary Thomas Ln","Artcraft Rd","Artemecia Ln","Artemis",
            "Artesia Blvd","Artesia Dr","Artesian Ave","Arthur Ave","Arthur Ave S","Arthur Avenue","Arthur Cir",
            "Arthur Ct","Arthur Dr","Arthur Ln","Arthur Pl","Arthur Rd","Arthur Road","Arthur St","Arthur Street",
            "Arthurs Ct","Arthurs Rd","Arthurs Round Table","Articwood Ct","Artie's Ln","Artillery Ln",
            "Artisan Ln","Artist Rd","Artist View","Artista Dr","Artists Dr","Artola St","Artwin Rd","Aruba Court",
            "Aruba Crescent","Aruba Ct","Aruda Rd","Arundel Avenue","Arundel Rd","Arundell Ave","Arvidson Rd",
            "Arvin Ave","Arvon Rd","Arvona Place","Arya Ct","Aryana Dr","Arzon Pl","Asarco St","Asberry Ln",
            "Asbury Ave","Asbury Ct","Asbury Dr","Asbury Ln","Asbury Rd SE","Asbury-Anderson Rd","Asbury-West Portal Rd",
            "Ascalon Ave","Ascension","Ascolda Boulevard","Ascot Avenue","Ascot Cir","Ascot Ct","Ascot Dr",
            "Ascot Ln","Ascot Park","Ascot Pl","Ascot Place","Asgard","Asgard Rd","Ash","Ash Ave","Ash Avenue",
            "Ash Creek Rd","Ash Ct","Ash Dr","Ash Drive","Ash Loop","Ash Meadows Rd","Ash Pan Flat Rd","Ash Pky",
            "Ash Pl","Ash Rd","Ash St","Ash Street","Ash Valley Rd","Ashanti Dr","Ashberry Ct SE","Ashbourne Ct",
            "Ashbourne Dr","Ashbrook Ln","Ashbrook Pl","Ashburn Crescent","Ashburn Pl","Ashburnham Drive",
            "Ashburnham Road","Ashbury Boulevard","Ashby Cir","Ashby Ct","Ashby Dr","Ashby Drive","Ashby Hills Ct",
            "Ashby Place","Ashby Rd","Ashcraft Rd","Ashcroft Ct","Ashdale Pl","Ashdale Road","Ashdown Dr",
            "Ashe Ct","Ashely Pl","Asher Ln","Asher Rd","Asher Street","Ashery Ln","Ashfield Ct","Ashfield Drive",
            "Ashfield Ln","Ashford Cir","Ashford Cir NE","Ashford Dr","Ashford Drive","Ashford Rd","Ashford Street",
            "Ashgrove Road","Ashington Club Rd","Ashlan Way","Ashland Ave","Ashland Ave E","Ashland Avenue",
            "Ashland Ct","Ashland Dr","Ashland Place","Ashland Rd","Ashland St","Ashland Street","Ashlar Dr",
            "Ashlawn Ave","Ashlee Blvd","Ashley 17","Ashley Ave","Ashley Avenue","Ashley Circle","Ashley Court",
            "Ashley Ct","Ashley Cv","Ashley Dr","Ashley Ln","Ashley Nicole Ln","Ashley Oaks","Ashley Pl",
            "Ashley Rd","Ashley Ridge Rd","Ashley Road","Ashley St","Ashley Way","Ashlyn Ct","Ashman Rd",
            "Ashmeade Ct","Ashmont Park","Ashmont Street","Ashmun St","Ashridge Place","Ashton Ave","Ashton Ct",
            "Ashton Drive","Ashton St","Ashuelot Dr","Ashurst Ave","Ashurst Rd","Ashville St","Ashwd Dr",
            "Ashwood Ave","Ashwood Avenue","Ashwood Ct","Ashwood Dr","Ashwood Lane","Ashwood Ln NE","Ashwood Pl",
            "Ashwood Rd","Ashworth Avenue","Ashworth Cir","Ashworth Pl","Ashworth Rd","Ashworth Road",
            "Ashylon Ave","Asip Rd","Asistencia Dr","Askea Grove Ln","Askoran Trl","Asp Ln","Asp Rte 2",
            "Aspara Dr","Aspen Aly","Aspen Ave","Aspen Ave NE","Aspen Ave NW","Aspen Cir","Aspen Circle",
            "Aspen Compound","Aspen Ct","Aspen Dr","Aspen Grove Cir","Aspen Knoll Dr","Aspen Knolls Way",
            "Aspen Ln","Aspen Loop","Aspen Pl","Aspen Place","Aspen Rd","Aspen Rd SW","Aspen Ridge","Aspen Ridge Ct",
            "Aspen Road","Aspen Springs Ave","Aspen St","Aspen Ter","Aspen Trail Rd","Aspen Village Way",
            "Aspen Way","Aspen Wood Ave","Aspendale Drive","Aspengrae","Aspenview Drive","Aspenwood Cmn",
            "Aspenwood Ct","Aspenwood Dr","Aspenwood Drive","Aspenwood Ln","Asphalt Rock Rd","Asphodel 3rd Line",
            "Asphodel 7th Line","Aspinwall St","Aspiration Ct","Asprey Court","Assabet Road","Asser Levy Place",
            "Assiniboine Road","Asta Drive","Aster","Aster Ave","Aster Ct","Aster Dr","Aster Ln","Aster Rd",
            "Aster St","Asterfield Drive","Asteroid","Asteroid Dr","Asti St","Aston Ct","Aston St","Aston Ter",
            "Astor Dr","Astor Pl","Astor Place","Astor Rd","Astor St","Astor Way","Astoria Ave","Astoria Blvd",
            "Astoria Ct","Astoria Dr","Astoria Park S","Astoria Way","AstraZeneca Road","Astrotec Dr",
            "At & N St","Atascadero Ave","Atchison Rd","Atchison St","Atco Ave","Atha's Way","Athena Ct",
            "Athena Ln","Athenia Court","Athens Ct","Athens Dr NE","Athens St","Atherton Ave","Atherton Avenue",
            "Atherton Ct","Atherton Hill Rd","Atherton Island Pl","Atherton Street","Atherton Way",
            "Athey Rd","Athletic Field Rd","Athlone Avenue","Athlone Road","Athoe Street","Athol Avenue",
            "Athol Richmond Road","Athol Street","Atigun Dr","Atilano Rd","Atkins Ave","Atkins Ln","Atkins Ranch Rd",
            "Atkins Rd","Atkins St","Atkinson Ave","Atkinson Ct","Atkinson Rd","Atkinson Ridge Rd","Atkinson St",
            "Atkison Rd","Atlanta Ave","Atlanta Rd","Atlantic Ave","Atlantic Avenue","Atlantic Blvd",
            "Atlantic Blvd NE","Atlantic City Blvd","Atlantic City Ct","Atlantic City Expy","Atlantic County Bikeway",
            "Atlantic Ct","Atlantic Dr","Atlantic St","Atlas Ave","Atlas Peak Rd","Atlee Dr","Atoka St",
            "Atoll Dr","Atonement Ave","Atrayente Way","Atrium Lane","Atsina Rd","Atsion Batsto Rd","Attaquin Street",
            "Attawanot St","Atteberry Dr","Attebery St","Atterbury Blvd","Atterbury Ln","Atterdag Rd",
            "Attersley Drive","Attila Rd","Attillia St","Attitude Ct","Attleboro Cir","Attorney St","Attridge Rd",
            "Attucks Ter","Atwater Ave","Atwater Court","Atwater Rd","Atwater Road","Atwells Avenue",
            "Atwood","Atwood Ave","Atwood Avenue","Atwood Ct","Atwood Pl","Atwood Rd","Atwood Way","Au Bord du Lac Rd",
            "Au Large Boulevard","Au St 1","Auberry Rd","Aubill Dr","Aubrey Carr Scenic Dr","Aubrey Long Rd",
            "Aubry Ct","Auburn Ave","Auburn Avenue","Auburn Ct","Auburn Dr","Auburn Hill","Auburn Lane",
            "Auburn Pl NW","Auburn Rd","Auburn St","Auburn Street","Auburn Trl","Aucas Dr","Auden Cir","Audia Court",
            "Audiffred Ln","Auditorium Dr","Audley End","Audobon Trl","Audra Ct","Audrelane Court","Audrey Ave",
            "Audrey Ct","Audrey Pl","Audrie St","Audubon Ave","Audubon Cir","Audubon Ct","Audubon Rd","Audubon Street",
            "Audubon Way","Aufra Pl","August Ave","August Dr","August Lane","August Ln","Augusta Cir","Augusta Ct",
            "Augusta Dr","Augusta Dr SE","Augusta Dr SW","Augusta Drive","Augusta Solsville Rd","Augusta St",
            "Augusta Way","Augustine Rd","Auk Kwaan Way","Aukland Lane","Aukland Road","Auldearn Cir",
            "Auldfarm Rd","Aunt Janes Road","Aura Ct","Aureen Dr","Aurelia St","Aurene Ln E","Aureo Way",
            "Auricchio Ave","Auriga Ct","Aurilla Street","Aurora Cir","Aurora Dr","Aurora Heights","Aurora Industrial Pky",
            "Aurora Rd","Aurora Road","Aurora St","Aurora St NW","Aurora Way","Austen Ct","Austen Lane",
            "Austin","Austin Ave","Austin Cir","Austin Ct","Austin Dr","Austin Ln","Austin Park Driveway",
            "Austin Pl","Austin Rd","Austin Rd NW","Austin St","Austin St.","Austin Street","Austin Way",
            "Austinburg Rd","Austinville Rd","Austis Rd","Austria Avenue","Autauga County 103","Autauga County 104",
            "Autauga County 16","Autauga County 19","Autauga County 20","Autauga County 21","Autauga County 57",
            "Autauga County 66","Autauga County 69","Autauga County 92","Authority Dr","Autillo Way",
            "Auto Rd","Autram Ave","Autrey Ave","Autrey Dr","Autumleaf Dr","Autumn Ave","Autumn Avenue",
            "Autumn Breeze Drive N","Autumn Brook Trl","Autumn Circle","Autumn Creek Ln","Autumn Crescent",
            "Autumn Ct","Autumn Dr","Autumn Drive","Autumn Haze Ct","Autumn Hill Cir","Autumn Hill Dr",
            "Autumn Hill Rd","Autumn Hill St","Autumn Hills Boulevard","Autumn Ln","Autumn Ln SW",
            "Autumn Oak Ct","Autumn Oaks Ln","Autumn Ridge Apartment","Autumn Ridge Ct","Autumn Ridge Rd",
            "Autumn Road","Autumn Rust Dr","Autumn St","Autumn Street","Autumn Ter","Autumn Walk Ct",
            "Auvergne Oval","Auxiliary Drain Ditch","Av Styles Rd","Ava Ct","Ava Road","Ava St","Avalanche Ct",
            "Avaleen Pl","Avalon Ave","Avalon Avenue","Avalon Boulevard","Avalon Ct","Avalon Dr","Avalon Ln",
            "Avalon Pl","Avalon Rd","Avalon Road","Avalon Street","Avalon Trl","Avalon Woods Ct","Avant Rd",
            "Avanti Dr","Ave 43","Ave L-6","Ave N-8","Ave W-10","Ave W-12","Ave W-6","Ave X-2","Avedon Rd","Aveline Crescent",
            "Avellano Ln","Avenal Cutoff Rd","Avenal St","Avenida Abeja","Avenida Alteras","Avenida Barona",
            "Avenida Blanco","Avenida Campana","Avenida Casatino","Avenida Club la Quinta","Avenida Colonia",
            "Avenida Cortez","Avenida Cuesta Los Osos","Avenida Decas Naciones","Avenida Diego Rivera",
            "Avenida Encanto","Avenida Encento","Avenida Gaviota","Avenida Imperial","Avenida Jalisco",
            "Avenida Jinete","Avenida Majorca","Avenida Mendez","Avenida Michelle","Avenida Miguel Anzurez",
            "Avenida Navarro","Avenida Nazas","Avenida Ocotillo","Avenida Palmera","Avenida Rubio",
            "Avenida Sevilla","Avenida Trebolo","Avenida Velasco","Avenida Ventura","Avenida Vista Hermosa",
            "Avenida Zacatecas","Avenida de Adelina","Avenida de Las Flores","Avenida de Los Reyes",
            "Avenida de Margarita","Avenida de Plata","Avenida de la Madre","Avenida del Poniente",
            "Avenida del Sol","Avenida la Candela","Avenida la Costa","Avening Drive","Avenue 102",
            "Avenue 104","Avenue 11","Avenue 11 1/2","Avenue 12","Avenue 124","Avenue 132","Avenue 14 1/2",
            "Avenue 16","Avenue 17","Avenue 17 3/4","Avenue 170","Avenue 176","Avenue 184","Avenue 188",
            "Avenue 19 1/2","Avenue 194","Avenue 2","Avenue 20","Avenue 20 1/2","Avenue 20 1/4","Avenue 208",
            "Avenue 216","Avenue 22 3/4","Avenue 222","Avenue 23","Avenue 236","Avenue 244","Avenue 26",
            "Avenue 272","Avenue 280","Avenue 28E","Avenue 295C","Avenue 295D","Avenue 296","Avenue 3 NW",
            "Avenue 3 SE","Avenue 306","Avenue 310","Avenue 324","Avenue 326","Avenue 328","Avenue 334",
            "Avenue 346","Avenue 360","Avenue 378","Avenue 388","Avenue 392","Avenue 40","Avenue 404","Avenue 406",
            "Avenue 415","Avenue 416","Avenue 420","Avenue 424","Avenue 44","Avenue 452","Avenue 48","Avenue 52",
            "Avenue 55","Avenue 56","Avenue 61 1/2 E","Avenue 64","Avenue 7","Avenue 76E","Avenue 78","Avenue 8",
            "Avenue 84","Avenue 9","Avenue 9 1/2","Avenue 96","Avenue 98","Avenue A","Avenue B","Avenue B 1/2 E",
            "Avenue B Aly","Avenue Batoche Avenue","Avenue C","Avenue D","Avenue D12","Avenue Dieppe Avenue",
            "Avenue E","Avenue E E","Avenue E Aly","Avenue F","Avenue G","Avenue G Aly","Avenue G-12","Avenue H",
            "Avenue I","Avenue J","Avenue K","Avenue L","Avenue L-8","Avenue M","Avenue M-6","Avenue N","Avenue O",
            "Avenue P","Avenue P-12","Avenue Princess Mary Avenue","Avenue Q6","Avenue R","Avenue Road",
            "Avenue S Aly","Avenue T","Avenue U","Avenue X","Avenue at Port Imperial","Avenue of Flags",
            "Avenue of Memories","Avenue of Oaks","Avenue of Two Rivers","Avenue of the Americas",
            "Avenue of the Giants","Avenue of the Oaks","Avenue of the Stars","Avenue of the States",
            "Averett Ln","Averic Road","Averill Avenue","Averill Rd","Avery Ave","Avery Avenue","Avery Hotel Rd",
            "Avery Lake Rd","Avery Lane","Avery Ln","Avery Rd","Avery Road","Avery Sheep Ranch Rd","Avery St",
            "Avi Court","Aviador Avenue","Avian Dr","Aviary Dr","Aviation Dr","Aviation Way","Aviator Ln",
            "Avila Ct","Avila Ln","Avila St","Avila Way","Avilla Heights Dr","Avis Ct","Avisford Park Ln",
            "Avoca Drive","Avocado Crst","Avocado Dr","Avocet Ct","Avon","Avon Ave","Avon Avenue","Avon Court",
            "Avon Dr","Avon Lane","Avon Ln","Avon Pl","Avon Place","Avon Rd","Avon St","Avon Street","Avondale Ave",
            "Avondale Drive","Avondale Rd","Avonell Dr SW","Avonhurst Road","Avonlea Cir","Avonlea Dr",
            "Avonridge Rd","Avonwick Gate","Awatobi Ovi","Awenita Ct","Awtrey Ln","Axbridge Ct","Axel Ave",
            "Axelson Rd","Axen Rd","Axford St","Axtell Ave","Aye Ct","Ayer Rd","Ayers Ave","Ayers Pond Rd",
            "Ayers Rd","Ayers Rock Rd","Aylesbury Ave","Aylesbury Road","Aylesford Drive","Ayleshire Dr",
            "Aylesworth Avenue","Aylesworth Cir NW","Ayliffe Ave","Aylmer Street N","Aylward Ave",
            "Ayora Ln","Ayr Court","Ayrault Dr","Ayres Ct","Ayres Loop","Ayres Rd","Azalea","Azalea Ave","Azalea Cir",
            "Azalea Ct","Azalea Dr","Azalea Dr.","Azalea Drive","Azalea Gateway","Azalea Hills Dr","Azalea Ln",
            "Azalea Rd","Azalea St","Azalea Street","Azalea Trce N","Azalea Way","Azalia Ln","Azee Dr","Azevedo Rd",
            "Aztec","Aztec Cir","Aztec Ct","Aztec Ln","Aztec Rd","Aztec Rd NW","Aztec Road","Aztec St","Aztec Wash",
            "Azucena Ct","Azucena Ln","Azul Dr","Azul Rd","Azul Rd SE","Azure Bay St","Azure Rd","Azurite",
            "Azurite Rd","Azusa Ln","B","B 048","B 060","B 18","B 22","B 39","B Ave","B Camp","B Ct","B Ct S","B Dunn Rd",
            "B I A Hwy 11","B Ln","B Rd","B Rd Ln","B Road","B Roadway","B St","B St SE","B Street","B-028","B-058",
            "B-060","B-18 R-38","B-32","B-36 Rd","B-38","B-Line Dr","B11A Road","BIA Road 174","BIA Road 196",
            "BIA Road 45","BIA Road 5038","BIA Road 51","BIA Road 52","BIA Route 145","BIA Route 2080",
            "BIA Route 8084","BLM 1103","Babak Boulevard","Babb Ave","Babbit Dr","Babbling Brook Rd",
            "Babbs Ct","Babcock Ct","Babcock Hill Rd","Babcock Ln","Babcock St","Babcock Tavern Road",
            "Babes Dr","Babette Ave","Babocomari Ln","Baby Blue","Babylon Ave","Baca Ave","Baca Cir","Baca St",
            "Baccarat Ln","Baccus Way","Bache St","Bachelor Rd","Bachelor Valley Rd","Bacher St","Bachly Crescent",
            "Bachman Dr","Bachman Drive","Back A Ways Ln","Back Acres Ln","Back Basin Rd","Back Bay Dr",
            "Back Bone Rd","Back Chester Rd","Back Crosby Rd","Back Gate Rd","Back Mesa Rd","Back Rd",
            "Back Road To Mount Hermon","Back West Creek Rd","Backacre Ln","Backbone Rd","Backbone Trail",
            "Backs Launching","Backus Rd","Bacon Ridge Rd","Bacon St","Bacon Street","Bacontree Pl","Badelona Ct",
            "Baden Pl","Badenough Canyon Rd","Badger Ave","Badger Circle Dr","Badger Ln","Badger Rd",
            "Badger St","Badlands Ln","Baffin Ct","Bagdad Hwy","Bagdad Rd","Bagdad Road","Bagdad Way","Baggett Dr",
            "Baggett Rd","Baggs Bay","Bagley Ave","Bagley Rd","Bagot Street","Bagpipe Ct","Baguley Road",
            "Bahia Ct NE","Bahia Ln","Bail Weather Cir SE","Bailee Ln","Bailes St NW","Bailey Ave","Bailey Cir",
            "Bailey Corners Rd","Bailey Cove Cir SE","Bailey Creek Rd","Bailey Ct","Bailey Cutoff Rd",
            "Bailey Dr","Bailey Gibson Cir","Bailey Hill Rd","Bailey Lane","Bailey Ln","Bailey Rd","Bailey Ridge Rd",
            "Bailey Springs Rd","Bailey St","Baily Bend Rd","Bain Avenue","Bainbridge Avenue","Bainbridge St",
            "Bainbridge Street","Baine Ct","Bair","Bair Rd","Baird Ave","Baird Blvd","Baird Ln","Baird Rd",
            "Baird St","Bairdmore Ave","Bairdsley Pl","Baisa Rd","Baisley Cir","Baja Ct","Baja Ct NE","Baja Dr",
            "Baja Grande Ave","Baja Way","Bajac","Baker Ave","Baker Avenue","Baker Blvd","Baker Brook Rd",
            "Baker Court","Baker Dr","Baker Drive","Baker Hill Rd","Baker Hollow Rd","Baker Hollow Road",
            "Baker Ln","Baker Place","Baker Pond Road","Baker Rd","Baker Road N","Baker St","Baker Street",
            "Baker Trl","Baker Way","Baker's Pl","Bakerdale Rd","Bakers Creek Rd","Bakers Creek Road",
            "Bakers Dr","Bakersfield Ave","Bakersfield-Glennville Rd","Bakersfield-Tehachapi Hwy",
            "Bakerton Drive","Bakertown Rd","Bakervill Lane","Bakerville Street","Bakos Pl","Bakoua Ct",
            "Bal Harbour Drive","Bala Drive","Balanchine Ct","Balancing Rock Dr","Balantrae Drive",
            "Balaton Avenue","Balatta Canyon Ct","Balboa Ct","Balboa Dr","Balboa Rd SW","Balboa Way",
            "Balch Hill Rd","Balch Park Rd","Balcom Rd","Balcones Ct","Bald Eagle Ave","Bald Eagle Avenue",
            "Bald Hill Rd","Bald Hills Rd","Bald Mountain Rd","Balding Boulevard","Balding Court",
            "Baldpate Ln","Baldpate Road","Baldwin Acres","Baldwin Ave","Baldwin Blvd","Baldwin Ct","Baldwin Dr",
            "Baldwin Hills Ct","Baldwin Ln","Baldwin Pl","Baldwin Rd","Baldwin Rd N","Baldwin Rd S","Baldwin Run Rd",
            "Baldwin St","Baldwin Street","Baldwinsville Road","Baldwinville Road","Bale Rd","Baler Blvd",
            "Baler St","Bales Avenue","Balfour Ave","Balfour Cir","Balfour Dr","Balfour Ln","Balfour Street",
            "Balfrey Dr","Bali Hai Ln","Balian","Balignac Ave","Balin Ct","Balisle St","Balkensar Ln","Ball Ave",
            "Ball Avenue E","Ball Dr","Ball Park","Ball Park Dr","Ball Park Rd","Ball Park St","Ball Pl",
            "Ball Road","Ball St","Ball Street","Ballad Drive","Ballantra Common","Ballantrae Drive",
            "Ballantyne Drive","Ballarat Dr","Ballard Ave","Ballard Crescent","Ballard Dr","Ballard Ln",
            "Ballard Rd","Ballard St","Ballast Ave","Ballenger Rd","Ballentine Dr","Baller Mtwy","Ballinger St",
            "Balliol Street","Balloon Fiesta Pky","Ballou Street","Ballpark Way","Balls Bluff Road",
            "Ballville Road","Bally Bunion Dr","Ballygar Way","Ballyronan Road","Ballyview St","Balmoral Ave",
            "Balmoral Avenue","Balmoral Ct","Balmoral Dr","Balmoral Mills Ct","Balmoral Way","Balmuir",
            "Balmy St","Baloras St","Balsa Ave","Balsam Ave","Balsam Ave SW","Balsam Avenue","Balsam Cres",
            "Balsam Crescent","Balsam Ct","Balsam Dr","Balsam Ln","Balsam Pa Road","Balsam Rd","Balsam Road",
            "Balsam St","Balsdon Crescent","Balsh Dr","Balsm Rd","Baltibroo Road","Baltic Ave","Baltic Cir",
            "Baltic Rd","Baltic St","Baltimore Ave","Baltimore Grove Rd","Baltimore Pike","Baltimore Street",
            "Baltusral Dr","Baltusrol Ct","Baltusrol Dr","Baltusrol Way","Bama Rd","Bambeck Rd","Bamberry Rd",
            "Bambi Ln","Bamboo Dr","Bamboo Tr","Bamburgh Circle","Bamburgh Ct","Bamfield Dr","Bamford Ave",
            "Bami's Aly","Bampton Pl","Ban Ln","Banana Tree Ln","Banas Ln","Banbury Ct","Banbury Dr","Banbury Rd",
            "Bancroft Ct","Bancroft Dr","Bancroft Mill Rd","Bancroft Park","Bancroft Pl","Bancroft Road",
            "Bancroft St","Banda Ct","Bandera St","Banderilla Dr","Bandini Pl","Bandit Dr","Bandit Way",
            "Bandon Dr","Bandorr Rd","Bandy Ct","Bandy Rd","Baneberry Dr","Baneberry Ln","Banegas Rd","Banff Ct",
            "Banff Drive","Banfield Drive","Banfield Ln","Banfield Rd","Banger Rd","Bangor Mountain Road",
            "Bangor St","Bangs Ave","Bank","Bank Ave","Bank Avenue","Bank St","Bank Street","Banker Ln","Bankfield Drive",
            "Bankfoot Ct","Bankhead Hwy","Bankhead Pky NE","Bankhead Rd","Banks Ave","Banks Creek Rd",
            "Banks Rd","Banks St","Banks Street","Bankside Dr","Banmoor Boulevard","Bannan Ln","Bannard Ave",
            "Bannavitch St","Banneker Pl","Banner Dr","Banner Lane","Banner Quaker Hill Rd","Banner Rd",
            "Banning Way","Bannister St","Bannock Cir","Bannock Ct","Bannockburn St","Banor Dr","Banstock Drive",
            "Banta Pl","Banta St","Bantam Ave","Bantham Street","Banting Crescent","Bantry","Bantry Avenue",
            "Bantry Cir NW","Bantry Ln","Bantry Ter","Banwell Rd","Banyan Ct","Banyan Rd","Banyan St","Banyon St",
            "Baptist Church Road","Baptist Common Road","Baptist Corner Road","Bapton Rd","Bar 6 Dr",
            "Bar Crest Dr","Bar Ela Ranch Rd","Bar Harbor Cv","Bar Harbor Dr","Bar Harbour","Bar M Ln",
            "Bar Nothing Trl","Bara St","Baraga St","Baranca Dr NE","Baranda Ct","Barat Rd NW","Barb Row",
            "Barbados Ct","Barbados Dr N","Barbados Ln","Barbados St","Barbara Ann Pl","Barbara Ann St",
            "Barbara Ave","Barbara Ct","Barbara Dr","Barbara Lane","Barbara Lee Dr","Barbara Ln","Barbara Pl",
            "Barbara Rd","Barbara St","Barbara Street","Barbara Ter","Barbara Way","Barbary Rd","Barbay Rd",
            "Barbee Ct","Barber Ave","Barber Ct","Barber Hill Rd","Barber Hollow Rd","Barber Loop","Barber Rd",
            "Barber Ridge Rd","Barber St","Barberry Ave","Barberry Lane","Barberry Ln","Barberry Road",
            "Barbers","Barbican Drive","Barbican Trail","Barbie Cir","Barbie Lane","Barbie Ln","Barbieri Road",
            "Barboa Rd","Barbour St","Barbuda St","Barcella Crescent","Barcelona Ct","Barcelona Dr","Barcelona St",
            "Barchetta Ct","Barchstead Place","Barcladen Rd","Barclay Court","Barclay Ct","Barclay Dr",
            "Barclay Ln","Barclay Rd","Barclay St","Barclay Street","Barcroft Cir SW","Barczewski St",
            "Bard St","Barden Pl","Barderry Ln","Bardonia Rd","Bards Beach Road","Bardsea Court","Bardwells Ferry Road",
            "Bardy Dr","Bardy Tract","Bare Cove Lane","Bare Hill Rd","Bare Hill Road","Bareback Ct","Barefoot Cir",
            "Barela Way","Barfield Ln","Barganier Rd","Bargary Way","Bargos Pl","Barham Avenue","Barham Dr",
            "Barham Loop","Barham St","Baring Cross St","Barite Rd","Barjode Rd","Bark Ln","Bark Pl","Bark Shanty Rd",
            "Barkalow Rd","Barkalow St","Barkeath Dr","Barker Ave","Barker Avenue","Barker Court","Barker Ct",
            "Barker Ln","Barker Rd","Barker St","Barker Street","Barker Way","Barkers Mill Rd","Barkley Ave",
            "Barkley Dr","Barkley St SW","Barksdale Avenue","Barkstone Ave","Barkway Ln","Barkway Road",
            "Barkwood Dr","Barlake Avenue","Barlesan Road","Barley Drive","Barley Mill Rd","Barley Neck Road",
            "Barley Point Rd","Barley Ridge Dog Leg","Barley Sheaf Rd","Barlin Ave","Barling St","Barlow Ave",
            "Barlow Avenue","Barlow Bend Rd","Barlow Dr","Barlow Farm Rd","Barlow Lake Rd","Barlow Ridge Rd",
            "Barlow St","Barmac Drive","Barn Hollow Ct","Barn Owl Dr","Barn Owl Way","Barnaby Place",
            "Barnadyn Ln","Barnard Pl","Barnard St","Barnardo Avenue","Barnaval Draw Rd","Barnegat Ave",
            "Barnegat Bay Dr","Barnegat Beach Dr","Barnegat Blvd","Barnegat Rd","Barnert Pl","Barnes Ave",
            "Barnes Avenue","Barnes Bay Rd","Barnes Dr","Barnes Pl","Barnes Rd","Barnes Road","Barnes St",
            "Barneston Ln","Barnet Segal Ln","Barnett Ave","Barnett Dr","Barnett Pl","Barnett St","Barnette Rd",
            "Barney Degnan Hill Rd","Barney Hale Road","Barney Hollow Rd","Barney Ln","Barney St",
            "Barnfield Drive","Barnhart St NE","Barnhouse Rd","Barnie Rd","Barnosky Ct","Barnsbury Dr",
            "Barnsdale Ave","Barnsdale Rd","Barnsdale Way","Barnsider Ln","Barnsley Crescent","Barnstaple Ct",
            "Barnstead Dr","Barnt-Deklyn Rd","Barnum Ct","Barnum Rd","Barnwood Ct","Baron Ave","Baron Ct",
            "Baron St","Baron's Way","Baronian Ct","Baronnel Ln","Barooshian Ct","Barque Circle","Barr Dr",
            "Barr Pl","Barr Rd","Barr Road","Barracks Rd","Barranca Ln","Barre Ave","Barre Drive","Barrel Way",
            "Barren Rd","Barret Street","Barrett","Barrett Ave","Barrett Avenue","Barrett Bend","Barrett Dr",
            "Barrett Hill Rd","Barrett Lake Rd","Barrett Lane","Barrett Ln","Barrett Rd","Barrett St",
            "Barrett Stoddard Truck Trail","Barrett Way","Barretts Hill Rd","Barretts Run Rd","Barrhaven",
            "Barrhill Road","Barrick Ln","Barrick Road","Barrie Dr","Barrie Rd","Barrie View Drive",
            "Barrington Ave","Barrington Avenue","Barrington Bridge Ln","Barrington Dr","Barrington East",
            "Barrington Ln","Barrington Rd","Barrington Woods Ct E","Barrister Pl","Barron Ave","Barron Road",
            "Barrons Bridge Rd","Barrow Ln","Barrows Point","Barrows Road","Barry Ave","Barry Ct","Barry Hollow Rd",
            "Barry Ln","Barry Rd","Barry Road","Barry Street","Barry Way","Barrymore Dr","Barrymore Rd",
            "Barrymore St","Barse Street","Barstow Ave","Barstow St NE","Barsuda Drive","Bart Cir","Bart Pl",
            "Bartal Ct","Bartel Pritchard Square","Bartel Road","Bartell Rd","Bartell Road","Barter Pl",
            "Barth Rd","Barthold St","Bartholf Lane","Bartholomew Ct","Bartine St","Bartles Rd","Bartlett Avenue",
            "Bartlett Ct","Bartlett Dr","Bartlett Farm Rd","Bartlett Pl","Bartlett Place","Bartlett Rd",
            "Bartlett Road","Bartlett St","Bartlett Street","Bartlett Way","Bartlett Woods","Bartley Bull Parkway",
            "Bartley Ln","Bartolo Ave","Barton Ave","Barton Avenue Extension","Barton Bird Rd","Barton Creek Rd",
            "Barton Ct","Barton Dr","Barton Hill Rd","Barton Lane","Barton Ln","Barton Rd","Barton Run",
            "Barton St","Bartonville Avenue W","Bartoo Ct","Bartosz Lane Number 52","Bartram Ave",
            "Bartram Rd","Bartsch Ln","Bartz Rd","Basalt Dr","Basalt Rd","Basch Circle","Basch Rd","Bascomb Dr",
            "Bascomb Pl","Base Line Rd","Base Line Road","Base Line offramp","Base Ln","Base Meadows Dr",
            "Base Rd","Base St","Basehart SE","Basel St SW","Baseline Rd","Baseline Road","Basesball Line Rd",
            "Bashi Rd","Bashkir St","Basic Ave","Basil Dr","Basil Leaf Ave","Basil Ln","Basile Rd","Basile Rowe",
            "Basille Ave","Basilone Pl","Basilone Road","Basin Creek Trl NW","Basin Gulch Rd","Basin St",
            "Baskerville Dr","Baskerville Run","Basket Switch Rd","Basler Rd","Basley Rd","Basra Ln",
            "Bass Ave NE","Bass Cove Trail","Bass Ct","Bass Cv","Bass Dr","Bass Lake Rd","Bass Lake Road",
            "Bass Lake View Ct NE","Bass Lake Woods Ln","Bass Pro Mills Drive","Bass Rd","Bass St",
            "Bassett Ave","Bassett Lane","Bassett Ln","Bassett St","Basswood Blvd","Basswood Cir","Basswood Circle",
            "Basswood Ct","Basswood Dr","Basswood Rd","Basswood Road","Basswood Street","Bassy Ln","Bataan Ave",
            "Bataan Cir","Bataan Loop","Batavia Ave","Batchelder Hill Rd","Batchelder Rd","Batchelder Street",
            "Batchelor Rd","Bateman Rd","Bates Ave","Bates Court","Bates Lane","Bates Ln","Bates Rd","Bates Rd SE",
            "Bates St","Bates Street","Bates Way","Bath Cameron Rd","Bath Rd","Bath Road","Bath St","Bath Street",
            "Bathgate Dr","Bathgate Pl","Bathurst Ave","Bathurst Ct","Bathurst Road","Bathurst St","Bathurst Street",
            "Batona Trl","Batory Avenue","Batson Drive","Batson St","Batsto Rd","Batt Dr SW","Battell Rd",
            "Battell St","Batten Lane","Batten Ln","Battersea Road","Batterson Ct","Batterswood Drive",
            "Battery Avenue","Battery Ct","Battery Place","Battery Rd","Battery St","Battery Ter","Battista Ln",
            "Battle Creek Linear Path","Battle Ct","Battle Dr","Battle Hill Rd","Battle Mountain Airport",
            "Battlefield Rd","Battleford Road","Battles Cv","Battles Street","Battlewood Way","Batty Doe Lake Rd",
            "Baucher Ct","Bauer Ave","Bauer Dr","Bauer Ln","Bauer Rd","Bauerlane","Baughman Rd","Baum Rd","Baumbach Ln",
            "Baumgartner Ct","Baumhart Rd","Baur Ave","Bautista Ct","Bautista Dr","Bauxite Ave","Bavaria Dr E",
            "Bavier St","Bavuso Ln","Baw Beese Trl","Baxman Rd","Baxter","Baxter Ave","Baxter Dr","Baxter Farm Rd",
            "Baxter Grade Rd","Baxter Lane","Baxter Rd","Baxter St","Baxter Street","Bay","Bay 11th Street",
            "Bay 25th Street","Bay 29th Street","Bay 37 St","Bay 48th Street","Bay 49th Street","Bay 50th St",
            "Bay 8th St","Bay Ave","Bay Avenue","Bay Beach Way","Bay Blvd","Bay Breeze Ln","Bay Bridge (upper deck)",
            "Bay Bridge Cutoff Rd","Bay Cir","Bay Club Dr","Bay Court","Bay Ct","Bay Dr","Bay Drive","Bay East Teamway",
            "Bay Farm Pl","Bay Harbor Blvd","Bay Haven Partnership","Bay Hill Cir","Bay Hill Rd","Bay Hill Way",
            "Bay Hollow Dr","Bay Knoll Rd","Bay Laurel Dr","Bay Laurel St","Bay Lea Park","Bay Leaf Ln",
            "Bay Ln","Bay Meadows Dr","Bay Parkway","Bay Point Harbour","Bay Rd","Bay Ridge Dr","Bay Ridge Rd",
            "Bay Road","Bay Shore Dr","Bay St","Bay State Place","Bay State Road","Bay Street","Bay Street Ramp",
            "Bay Ter","Bay Terrace","Bay View Avenue","Bay View Dr","Bay View Rd","Bay Vista Ct","Bay Way",
            "Bay West Blvd","Bay Willow Way","Bayberry Ct","Bayberry Ct W","Bayberry Dr","Bayberry Lane",
            "Bayberry Ln","Bayberry Rd","Bayberry Road","Baybreeze","Baycrest Avenue","Bayer Ave","Bayfield Ct",
            "Bayfield Street","Bayfront","Bayfront Expy","Bayfront Place","Bayhampton Drive","Bayhill Cir",
            "Bayhills Dr","Baylawn Drive","Bayleaf Ct","Bayles Dr","Bayless Ct","Bayless Dr","Baylies Street",
            "Baylis Ln","Baylis Rd","Baylis St","Baylor Cir","Baylor Ct","Baylor Dr","Baylor Lake Rd","Baylor Pl",
            "Bayly Street","Bayly Street W","Baymouth St","Baynard Ct","Baynes Rd","Bayonne Ave","Bayonne Dr",
            "Bayonne Street","Bayou Dr NE","Bayou Point Rd","Bayou Rd","Bayou Road","Bayou la Batre-Irvington Hwy",
            "Baypoint Dr","Bayridge Cove","Bayridge Drive","Bayshore Ave","Bayshore Dr","Bayshore Drive",
            "Bayshore Freeway","Bayshore Highway","Bayshore Rd","Bayshore Road","Bayside Ave","Bayside Avenue",
            "Bayside Ct","Bayside Dr","Bayside Drive","Bayside Gate","Bayside Lane","Bayside Ln","Bayside Rd",
            "Bayside Ter","Baysmill Ct","Bayswater","Bayswater Avenue","Baytree Cir","Baytree Crescent",
            "Baytree Ct","Baytree Rd","Bayview","Bayview Ave","Bayview Avenue","Bayview Dr","Bayview Drive",
            "Bayview Fairways Drive","Bayview Ln","Bayview Parkway","Bayview Road","Bayview St","Bayview Street",
            "Bayview Ter","Bayview Walk","Bayview Wood","Bayway Circle","Baywood Ct","Baywood Drive",
            "Baywood Oaks Way","Baywood Road","Baywood Way","Baywyn Dr","Bazan Rd NW","Bazeley","Bea Haven Ln",
            "Bea Ln","Bea Luck Road","Beach 213th St","Beach 21st St","Beach 40th Street","Beach Access",
            "Beach Ave","Beach Avenue","Beach Blvd","Beach Cliff Ave","Beach Court","Beach Ct","Beach Dr",
            "Beach Front","Beach Haven West Blvd","Beach Hollow Rd","Beach Lake Hwy","Beach Lane",
            "Beach Ln","Beach Pl","Beach Plum Dr","Beach Plum Lane","Beach Port Dr","Beach Rd","Beach Road",
            "Beach St","Beach Street","Beach Ter","Beachcliff Dr","Beachcomer Ln","Beachdale Avenue",
            "Beachgrass Court","Beachmont Road","Beachview Dr","Beachview Drive","Beachview Street",
            "Beachwood Ave","Beachwood Blvd","Beacom Ln","Beacon Ave","Beacon Avenue","Beacon Ct","Beacon Dr",
            "Beacon Hall Drive","Beacon Heights Lane","Beacon Hill Dr","Beacon Industrial Park Rd",
            "Beacon Lane","Beacon Light Rd","Beacon Ln","Beacon Park Dr","Beacon Pl","Beacon Rd","Beacon St",
            "Beacon Street","Beacon Way","Beaconhill Road","Beaconsfield Avenue","Beaconsfield Rd",
            "Beacroft Road","Beagle Dr","Beagle Run","Beak Street","Beakrush Ln","Beal Ave","Beal Ln","Beal Rd",
            "Beal St","Beal Street","Beale Ave","Beale St","Beales Mills Road","Beals Dr","Beals Rd","Beals St.",
            "Beam Ave","Beam St","Beaman Br","Beaman Rd","Beaman Road","Beamer Road","Beamer Street","Beamish Drive",
            "Bean Aly","Bean Ave","Bean Brook Rd","Bean Clipper Rd","Bean Creek Rd","Bean Hill Rd","Bean Rd",
            "Beane Rd","Beanfield Pl","Beantown Rd","Beantree Ct","Beany Bird Ln","Bear Ave","Bear Basin Rd",
            "Bear Brook Ln","Bear Brook Rd","Bear Butte Rd","Bear Canyon Rd","Bear Canyon Trl","Bear Cave Rd",
            "Bear Creek Cemetery Rd","Bear Creek Ct","Bear Creek Dr","Bear Creek Rd","Bear Ct","Bear Dr",
            "Bear Fork","Bear Head Rd","Bear Hill Rd","Bear Hill Road","Bear Hollow","Bear Hollow Dr",
            "Bear Hollow Rd","Bear House Rd","Bear Lake Rd","Bear Lane","Bear Ln","Bear Mountain Rd",
            "Bear Mountain State Parkway","Bear Mtn Rd","Bear Pen Rd","Bear Pl","Bear Poin Place",
            "Bear Rd","Bear Ridge Rd","Bear River Ct","Bear River Rd","Bear River Ridge Rd","Bear Run Rd",
            "Bear Springs Rd","Bear St","Bear Street","Bear Swamp Rd","Bear Valley","Bear Walk Cir","Bear Xing",
            "Bear's Den Cottages","Bearberry Ave","Bearbury Drive","Bearcat Blvd","Bearclaw Ave","Bearclaw Rd",
            "Beard Ave","Beard Rd","Beard St NW","Beard Street","Beardall Pl","Beards Landing Rd","Beardsley Rd",
            "Beardsley St","Bearhollow Dr","Bearse Road","Bearses Way","Bearskin Cir","Beartown Mountain Road",
            "Bearwallow Rd","Beason St","Beasore Rd","Beat Creek Dr","Beat Line Rd","Beaton Dr","Beaton Rd",
            "Beatrice Ct","Beatrice Dr","Beatrice St","Beatrice Way","Beatrix Road","Beattie Ave","Beattie Pond Rd",
            "Beattie Rd","Beatty Ct","Beatty Dr","Beatty Pl","Beatty Rd","Beatty Ridge Rd","Beatty St","Beatty View Rd",
            "Beatty Wash","Beaty Avenue","Beaty Ct","Beaty Rd","Beauford Pl","Beaufort Ave","Beaufort Ct",
            "Beaufort Terrace","Beaulieu Ln","Beaumaris Crescent","Beaumaris Drive","Beaumere Way",
            "Beaumonde Heights Drive","Beaumont Ave","Beaumont Avenue","Beaumont Place","Beaumont Rd",
            "Beaumont Trl","Beaumont Way","Beauregard Ave","Beausite Dr","Beauttelo Rd","Beauty Hill Rd",
            "Beaver Aly","Beaver Ave","Beaver Bar Ct","Beaver Bay Ct","Beaver Brook Dr","Beaver Brook Ln",
            "Beaver Brook Rd","Beaver Brook Road","Beaver Cir","Beaver Creek","Beaver Creek Ct","Beaver Creek Rd",
            "Beaver Creek Road","Beaver Crest Ct","Beaver Crest Ter","Beaver Ct","Beaver Cut Rd","Beaver Dam Dr",
            "Beaver Dam Rd","Beaver Dam Trl","Beaver Dr","Beaver Hollow Lane","Beaver Lake Estates",
            "Beaver Ln","Beaver Meadow Rd","Beaver Meadow St","Beaver Meadow St S","Beaver Pl","Beaver Pond Rd",
            "Beaver Rd","Beaver Ridge Dr","Beaver Ridge Rd","Beaver Run Dr","Beaver Run Rd","Beaver St",
            "Beaver Street","Beaver Swamp Dr","Beaver Valley Rd","Beaverdam Trail","Beaverson Blvd",
            "Beaverton Rd","Bechel Pl NW","Bechnell Trl","Beck Ave","Beck Ave NE","Beck Dr","Beck Ln","Beck Rd",
            "Beck St","Becka Dr","Beckenham Court","Beckenwood Dr","Becker Ave","Becker Ln","Becker Pl",
            "Becker Rd","Beckett Avenue","Beckett Crescent","Beckett Lane","Beckett St","Beckett Street",
            "Beckford Street","Beckland Dr","Beckler Avenue","Beckley Cir","Beckman Ave","Beckside Rd",
            "Beckwith Pl","Beckwith Rd","Becky Ave","Becky Rd","Becky St","Bed Bug Hollow Rd","Bedford Ave",
            "Bedford Avenue","Bedford Chagrin Pky","Bedford Cir","Bedford Ct","Bedford Dr","Bedford Lane",
            "Bedford Ln","Bedford Park","Bedford Park Avenue","Bedford Pl","Bedford Pl N","Bedford Rd",
            "Bedford Road","Bedford St","Bedford Street","Bedient Rd","Bedilion St","Bedminster Rd","Bednar Ln",
            "Bedrock Court NW","Bedrock Dr","Bee Barn Rd","Bee Canyon Rd","Bee Drive","Bee Gee Ct","Bee Rock Rd",
            "Bee St","Beebe Ave","Beebe Ln","Beebe Ranch Rd","Beebe Rd","Beebout Ln","Beech","Beech Ave","Beech Ct",
            "Beech Dr","Beech Glen Street","Beech Grove Rd","Beech Hill Rd","Beech Knoll Rd","Beech Knolls Trl",
            "Beech Ln","Beech Park","Beech Park Rd","Beech Rd","Beech Road","Beech St","Beech Stone","Beech Street",
            "Beech Ter","Beech Tree Ln","Beechcrest Dr","Beecher Ave","Beecher Rd","Beecher St","Beecher Street",
            "Beechers Brook Rd","Beechknoll Rd","Beechland Ct","Beechmont St","Beechnut Ct","Beechnut Dr",
            "Beechnut Hill Dr","Beechnut St","Beechtree Cir NW","Beechtree Rd","Beechvale Dr","Beechwood Ave",
            "Beechwood Avenue","Beechwood Cir","Beechwood Ct","Beechwood Dr","Beechwood Ln","Beechwood Park Rd",
            "Beechwood Pl","Beechwood Rd","Beechwood Road","Beechwood St","Beechwoods Road 5","Beede Cir",
            "Beegum Rd","Beekman Ave","Beekman Pl","Beekman Place","Beekman St","Beeler Rd","Beemer Church Rd",
            "Beers St","Beeson Rd","Beet Wagon Rd","Beetle St","Beginners Lane","Begonia Ct","Begonia Pl",
            "Behberg Rd","Behmer Rd","Behnke Rd","Bei Rd","Beiter Walk","Bel Air Avenue","Bel Air Dr","Bel Air Pl",
            "Bel Air St","Bel Air Way","Bel Aire Ave","Bel Aire Ln","Bel Aire Plz","Bel-Air Ct","Belair Ct",
            "Belair Dr","Belair Drive","Belaire Ln","Belanger Crescent","Belanger Dr","Belcastro St",
            "Belcastro Street","Belcher Rd","Belcolla Ln","Belcourt Avenue","Belcourt Rd","Belcrest Ave",
            "Belden Mine Rd","Belden Pl","Belden Rd","Belden St","Belding Ct","Beldingville Road","Belec St",
            "Belfast Rd","Belfast Road N","Belfast St","Belfield Road","Belfield St SW","Belford Crescent",
            "Belford Dr","Belgrade Ter","Belgrave Ave","Belgrave Ct","Belgrave Square","Belgrove Drive",
            "Belgrove Way","Belhaven St","Belhsada Rd","Belicose Ct","Belile Road","Belinda Ann Ln","Belize Ct",
            "Belkin Ct","Belknap Ln","Belknap Rd","Belknap Road","Belknap St","Bell Ave","Bell Ave SW","Bell Bluff Truck Trail",
            "Bell Bottom Rd","Bell Canyon Fire Road","Bell Court","Bell Ct","Bell Drive","Bell Green Ct",
            "Bell Harbour Drive","Bell Hill Rd","Bell Laboratories Rd","Bell Lane","Bell Line Road",
            "Bell Ln","Bell Pky","Bell Pl","Bell Rd","Bell Ridge Rd","Bell Road","Bell Royal Court","Bell Springs Rd",
            "Bell St","Bell Street","Bell-Irving Drive","Bella Ct","Bella Rd","Bella St","Bella Vista Avenue",
            "Bella Vista Cir","Bella Vista Court","Bella Vista Dr","Bella Vista Rd","Bella Vista Way",
            "Belladonna Cir","Bellagio Dr","Bellair Rd","Bellaire Hills Dr","Bellaire Manor","Bellamy Road North",
            "Bellamy Road South","Bellanca Ave","Bellant","Bellarosa Lane","Belle Aire Beach Road",
            "Belle Ave","Belle Avenue","Belle Ayre Boulevard","Belle Bluff Ct","Belle Butte Dr; Black Boot Dr",
            "Belle Creek Dr","Belle Crest Ct","Belle Dr","Belle Essence Ave","Belle Falor Ct","Belle Fern Pl",
            "Belle Fountain Ave","Belle Meade Pl","Belle Orchard St","Belle Rd","Belle River Rd","Belle Spring Ranch Rd",
            "Belle St","Belle Street","Belle View Ave","Belle la Blanc Ave","Belleau Wood Ln","Belleflower Rd",
            "Bellehaven Ave NE","Bellehaven St","Bellemeade Ave","Bellerose St","Belles Hollow Dr",
            "Belleview Ave","Belleview Ct","Belleview Dr","Belleview Rd","Belleville St","Belleville Street",
            "Bellevue Ave","Bellevue Avenue","Bellevue Dr","Bellevue Pky","Bellevue Pl","Bellevue Plz",
            "Bellevue St","Bellevue Street","Bellevue Ter","Bellewood Cir","Bellewood Ct","Belleza Pl",
            "Bellfield Ave","Bellflower Ct","Bellflower Rd","Bellflower St","Bellgrove Drive","Bellinger Dr",
            "Bellinger St","Bellis Dr","Bellkay Dr","Bellmore Ave","Bellmore St","Bello Pl","Bellows Ln",
            "Bellport Cir","Bellrock Road","Bellrose Ave NE","Bells Ct","Bells Ln","Bells Mills Rd","Bellshire Ct",
            "Bellshire Ln","Belltower Lane","Bellvare Crescent","Bellview Pl","Bellview Rd","Bellvista Road",
            "Bellwood Ct","Bellwood Dr","Belmar Ave","Belmar Blvd","Belmar Cir","Belmar Ct","Belmar Pl",
            "Belmarsh Ave","Belmont Ave","Belmont Avenue","Belmont Court","Belmont Dr","Belmont Park",
            "Belmont Park Dr","Belmont Pl","Belmont Rd","Belmont Stakes Ln","Belmont Street","Belmont Ter",
            "Belmont Township 3rd Line","Belmont Way","Belmore Ct Rd","Belmore Dr","Beloedere Ct",
            "Belrock St","Belrose Ct","Belser Ct","Belshaw Ave","Belshaw Place","Belsize Drive","Belt Line Ave",
            "Belt Ln","Belt Parkway","Beltline Rd SW","Belton St","Belva Ln","Belva Way","Belvan Ave","Belvedere Ave",
            "Belvedere Pl","Belvedere Rd","Belvedere Road","Belvidere Ave","Belvidere Rd","Belvidere Road",
            "Belview Avenue","Belvoir Cir","Belwood Ln","Bement Ct","Bement Pl","Bemersyde Drive","Bemis Road",
            "Bemus-Ellery Rd","Ben Doran Boulevard","Ben Hur Rd","Ben Johnson Ct","Ben Meeker Rd",
            "Ben Moses Ln","Ben St","Benafield Dr","Benavon Road","Benbow Pl","Bence Rd","Bench Dr","Bench Rd",
            "Bend Ct","Bend Ferry Rd","Bend Rd","Bend Way","Bender Ave","Bender Ln","Bender Pl","Bender Road",
            "Bendleton Dr","Benedet Drive","Benedict Ave","Benedict Dr","Benedict Ln","Benedict Pond Road",
            "Benedict Rd","Benedict Street","Benet Ct","Benevolent St","Bengston Ave","Benham Place Road",
            "Benham St","Benham Street","Benicia Rd","Benito Dr","Benja Ln","Benjamin Boulevard","Benjamin Ct",
            "Benjamin Drive","Benjamin Nicholas Pl","Benjamin St","Benjamin Street","Benleigh Drive",
            "Benlock Road","Benmor Dr","Benmore Ter","Bennet Dr","Bennet Drive","Bennet Pl","Bennett Ave",
            "Bennett Circle","Bennett Dr","Bennett Lake Road","Bennett Ln","Bennett Lot Rd","Bennett Pl",
            "Bennett Rd","Bennett St","Bennett Street","Bennett Way","Bennie Ln","Bennington Connector",
            "Bennington Ct","Bennington Dr","Bennington Dr NE","Bennington Hills Ct","Bennington Rd",
            "Bennington St","Bennitt St","Benny Ln","Benny Way","Benoit Lane","Benoit St","Benoit Street",
            "Benoni Ln","Benrus St","Bens Ct","Bens Way","Benscotor Rd","Bensel Aly","Bensley Rd","Benson Ave",
            "Benson Avenue","Benson Dr","Benson Lake Rd","Benson Ln","Benson Park Road","Benson Rd","Benson Road",
            "Benson St","Benson Street","Benson Swamps Rd","Bent Branch Ln","Bent Creek","Bent Creek Dr",
            "Bent Dr","Bent Oak Rd","Bent Oak Trl","Bent Rail St","Bent Rd","Bent Road","Bent St","Bent Tree Ct",
            "Bent Tree Dr","Bent Tree Pl","Bentley Ave","Bentley Crescent","Bentley Ct","Bentley Ct NW",
            "Bentley Ln","Bentley Rd","Bentley Road","Bentley Street","Benton Aly","Benton Ave","Benton Crossing Rd",
            "Benton Crossing Road","Benton Dr","Benton Hill Road","Benton Loop","Benton Place South",
            "Benton Rd","Benton St","Benton Street","Benton Way","Bentongrove Dr","Bentwick Crescent",
            "Bentwood Crescent","Bentwood Ln","Bentz Rd","Benway Hill Rd","Benway Road","Benwell Ave",
            "Benwiley Ave","Beranek Rd","Berbay Circle","Berclay St","Berczy Street","Berdais Ct","Berdeno Ave",
            "Berea Industrial Pky","Berenda Rd","Berendo Ave","Berendos Ave","Beresford Ct","Beresford Dr",
            "Beresford St","Beretta Ct","Berfoyl Ln","Berg Brook Rd","Berg Dr","Berg Fenceline Rd","Berg Rd",
            "Berg St","Bergamen Dr","Bergamot Crescent","Bergamot Ct","Bergdoll Ave","Bergen Ave","Bergen Beach Place",
            "Bergen Blvd","Bergen Ct","Bergen Pl","Bergen St","Bergen Street","Bergen Tpke","Bergen Trl",
            "Bergenline Ave","Berger St","Bergerac Ln","Bergeron St","Bergin Pl","Bergman Dr","Bergman Ln",
            "Bergman St E","Bergweg Rd","Bering Avenue","Bering Way","Beringer Ave NE","Beringer Way",
            "Berkdale Dr","Berkeland Ct","Berkeley Ave","Berkeley Cir","Berkeley Ct","Berkeley Dr","Berkeley Ln",
            "Berkeley Rd","Berkeley St","Berkeley Street","Berkery Pl","Berkham Road","Berkindale Drive",
            "Berkley Ave","Berkley Ct","Berkley Dr","Berkley Ln","Berkley Pl","Berkley St","Berkley Street",
            "Berkshire Avenue","Berkshire Court","Berkshire Ct","Berkshire Dr","Berkshire Ln","Berkshire Pl",
            "Berkshire Place","Berkshire Rd","Berkshire St","Berkshire Way","Berl Avenue","Berlant Ave",
            "Berldale Ave","Berlin Canyon Rd","Berlin Ln","Berlin Rd","Berlin Road","Berlin Street","Berm Ln",
            "Bermond Ave","Bermond Ct","Bermondsey Road","Bermuda Cir","Bermuda Dr","Bermuda Pl","Bermuda Road",
            "Bermuda St","Bermudez St","Bern Pl","Bernabe Cir","Bernadette","Bernadette Court","Bernadette Ct",
            "Bernadette Rd","Bernadette St","Bernadine Ave","Bernal Ave","Bernal Rd","Bernal St","Bernalillo Ct",
            "Bernan Cir","Bernard Ave","Bernard Ct","Bernard Rd","Bernard St","Bernardo Ave","Bernardo Ln",
            "Berne Ave","Berner St","Berner Trail","Berney Crescent","Berneys Station Rd","Bernhard Avenue",
            "Bernice Ave","Bernice Avenue","Bernice Cir","Bernice Dr","Bernice Rogers Way","Bernice Street",
            "Bernick Crescent","Bernie Ln","Bernita Dr","Bernita Pl","Bernstein Ln","Bernwood Ct","Berrel Ct",
            "Berrenda Mesa Canal","Berrimore Ln","Berrington Ct","Berry Ave","Berry Brook Rd","Berry Ct",
            "Berry Dr","Berry Hill Rd","Berry Ln","Berry Patch Ln","Berry Patch Rd","Berry Pond Circuit Road",
            "Berry Rd","Berry Road","Berry St","Berrywood Rd","Berstein Road","Bert Budd Avenue","Bert Little Rd",
            "Berta Rd","Bertch Rd","Berth Ave","Bertha Ct","Bertha Ln","Bertha Rd SE","Bertha Street","Berthal St",
            "Berthiaume Dr","Berthold Ave","Bertis Adams Way","Bertolani Cir","Berton Pl","Bertram Pl",
            "Bertram Street","Bertrand Ave","Bertrand Avenue","Bertrand Blvd","Bertrand Dr","Berts Xing",
            "Bertussi Rd","Berwick Avenue","Berwick Crescent","Berwick Ct","Berwick Lane","Berwick Ln",
            "Berwick Pl","Berwick Rd","Berwick Rd S","Berwick Street","Berwick Way","Berwin Dr","Berwin Ln",
            "Berwin St","Berwood Ave","Berwyck Ct","Beryl Dr","Berylwood Rd","Besaw Rd","Besen Pky","Bess-Ryan Rd",
            "Bessborough Drive","Bessemer Mine Rd","Bessey Road","Bessie Pl","Bessie St","Bessom Street",
            "Best Line Rd","Best Ranch Rd","Best Road","Best Station Rd","Best View Trl","Best's Road",
            "Bestor Ln","Bestview Drive","Beswick Drive","Beth Ave","Beth Dr","Beth Ln","Beth Pl","Bethany Ave",
            "Bethany Cir","Bethany Ct","Bethany H Road","Bethany Hills Dr","Bethany Home","Bethany Leigh Drive",
            "Bethany Pike","Bethany Street","Bethel Ave","Bethel Avenue","Bethel Church Rd","Bethel Dr",
            "Bethel Ln","Bethel Pl","Bethel Rd","Bethel Road","Bethel St","Bethel Street","Bethell","Bethesda Road",
            "Bethleham Rd","Bethlehem Ln","Bethune Drive","Bethune Way","Betsie Dr","Betsy Ct","Betsy Ln",
            "Betsy Ross Brg","Betsy Ross Cir","Betsy Ross Ct","Bette Dr","Betters Rd","Bettina Ave","Bettino Dr",
            "Bettinson Court","Bettis Hill Rd","Bettis Pl","Bettis St","Bettles Rd","Betty Ave","Betty Brook Rd",
            "Betty Dr","Betty Lee Ter","Betty Ln","Betty Rd","Betty St","Betty St NE","Betty Sutherland Trail",
            "Bettyjean Ave","Betula Dr","Between the Pigeons Trl","Beu Lah St","Beucler Pl","Beulah Ave",
            "Beulah Bay Ln","Beulah Church Rd","Beurling Avenue","Bev Ave","Bevada Ln","Bevans Rd","Beveric Lane",
            "Beveridge Locks Road","Beveridge Road","Beverlee Dr","Beverley Crescent","Beverley Street",
            "Beverly Ann","Beverly Arbor Ave","Beverly Ave","Beverly Blvd","Beverly Court","Beverly Ct",
            "Beverly Dr","Beverly Glen Boulevard","Beverly Hills Ave NE","Beverly Hills Rd","Beverly Park Drive Way",
            "Beverly Pl","Beverly Rd","Beverly Road","Beverly St","Beverly Street","Beverly Terrace Dr",
            "Beverly Trl","Beverly Way","Beverly-Rancocas Rd","Bevin Ave","Bevin Brook Dr","Bevis Ct",
            "Bevshire Circle","Bewick St","Bewley Ct","Bewley Pky","Bexley Court","Bexley Rd","Bexley Way",
            "Bexley-La Road","Bexman Grn","Bey Lea Rd","Beyea Rd","Beyer Ln","Beyer Rd","Beylund","Bezanson Rd",
            "Bi State Plz","Bia 241","Bia 70","Bialystoker Place","Biamonte Parkway","Bianca Ave","Bianchi Dr",
            "Bibb County 12","Bibb County 26","Bibb County 9","Bibb County Line Rd","Bibury Gate",
            "Bice Dr","Bice Rd","Bicentennial Court","Bicentennial Way","Bickett Ave","Bicknell Ave",
            "Bicknell Avenue","Biddle Brook Ln","Biddle St","Biddles Ln","Bidewell Avenue","Bidwell Ave",
            "Bidwell Common","Bidwell Rd","Bidwell Ter","Bieben Trl Ct","Biehs Court","Bielers Ln","Bienestar Ln",
            "Bieslada Ct","Big Apple Drive","Big Barn Rd","Big Bass Cv","Big Bay P Road","Big Bay Point Road",
            "Big Bay Point Road","Big Bear Dr","Big Bear Rd","Big Ben Rd","Big Ben Trail","Big Bend Ct",
            "Big Bend Dr","Big Bend Rd","Big Boulder Dr","Big Bridge Rd","Big Canyon Rd","Big Cedar Road",
            "Big Chief","Big Chief Road","Big Creek Church Rd","Big Creek Rd","Big Creek Road","Big Delta Ct",
            "Big Dipper Dr","Big Foot Rd","Big Hill Church Rd","Big Hill Rd","Big Hill Road","Big Hollow Rd",
            "Big Horn Ln","Big Horn Mobile Home Park","Big Hurricane Spur Rd","Big Joe's Rd","Big Lake Rd",
            "Big Lakes Rd","Big Nose Dr","Big Oak Dr","Big Oak Flat Rd","Big Oak Flat Rd N","Big Oak Ln (Pvt)",
            "Big Owl Rise","Big Pine Canal","Big Pine Rd","Big Pines Rd","Big Rideau Lake Road","Big Rideau North Shore Road",
            "Big Ridge Rd","Big River Rd","Big Rock Rd","Big Run Rd","Big School Lot Lake Rd","Big Sky Ct",
            "Big Sky Dr","Big Sky Ranch Rd","Big Sky Way","Big Springs Ct","Big Springs Ln","Big Springs Rd",
            "Big Springs Wash","Big Stone Lake Rd","Big Stump Rd","Big Sycamore Canyon Rd","Big Sycamore Creek Rd",
            "Big Trail Cir","Big Tree Close","Big Tree Ln","Big Tree Rd","Big Trestle Trl","Big Wash Rd",
            "Big Waters Lane","Bigelow Court","Bigelow Crescent","Bigelow Dr","Bigelow Ln","Bigelow Pl",
            "Bigelow Rd","Bigelow Street","Bigford Road","Bigger St","Biggers Pass Rd","Bigham Court",
            "Bigham Trl","Bighorn Dr","Bighorn Island Ave","Bighorn Rd NE","Bijou Avenur","Bike Path",
            "Bilbermar Crescent","Bilberry Rd","Bilco Rd","Bill Clinton Dr","Bill Davis Ln","Bill Jones Rd",
            "Bill Kostic Rd","Bill Lunceford Rd","Bill Marne Rd","Bill Riley Trail","Bill Sansing Dr",
            "Bill Stahl Rd","Bill Yance Rd","Bill's Way","Billco Rd","Billie Dr","Billings Place","Billings St",
            "Billings Street","Billingsgate Dr","Billington Crescent","Billington Rd","Billman Ave",
            "Billow Avenue","Bills Place","Billson Ave","Billy Ln","Billy Marks Rd","Billy McKee Rd",
            "Billy Schwerd Rd","Billy Tanner Rd","Billy Wright Rd","Biloxi Ct","Bilston Ave","Biltmore Ct",
            "Biltmore Park","Bimbrok Road","Bimini Crescent","Bimini Way","Bin-Scarth Road","Bindel St",
            "Bindertwine Boulevard","Binefar Ln","Binford Street","Bing Pl","Bingham","Bingham Ave","Bingham Ct",
            "Bingham Hill Cir","Bingham Hill Ln","Bingham Mountain Rd","Binney Hill Rd","Binsse St",
            "Biola Ave","Biology","Bion Dr","Birch","Birch Ave","Birch Avenue","Birch Bay Rd","Birch Cir","Birch Court",
            "Birch Creek","Birch Crescent","Birch Crescent Dr","Birch Ct","Birch Dr","Birch Glen Ct",
            "Birch Grove Ct","Birch Grove Rd","Birch Hill Ct","Birch Hill Rd","Birch Hill Road","Birch Hills Dr",
            "Birch Isl Road","Birch Lake Rd","Birch Lane","Birch Ln","Birch Meadow Road","Birch Park Dr",
            "Birch Pl","Birch Place","Birch Poi Road","Birch Rd","Birch Ridge Rd","Birch Road","Birch Run",
            "Birch Run Rd","Birch St","Birch Still Rd","Birch Street","Birch Street Hyannisport","Birch Street Passway",
            "Birch Ter","Birchbank Lane","Birchbark Dr","Birchbrook Ct","Birchcrest Dr","Birchcrest St",
            "Birchdale Ct","Birchdale Rd","Birchdale Way","Birchfield Drive","Birchim Ln","Birchland Court",
            "Birchland Park","Birchlane","Birchmount Road","Birchpark Drive","Birchtree Dr","Birchtree Ln",
            "Birchtree Rd","Birchview Crescent","Birchwood Acres","Birchwood Acres Ln","Birchwood Ave",
            "Birchwood Ct","Birchwood Dr","Birchwood Drive","Birchwood Lane","Birchwood Ln","Birchwood Rd",
            "Birchwood Ter","Birchwood Terrace","Bircke Strasse","Bird Ave","Bird Hill Rd","Bird Hill Road",
            "Bird Jackson Rd","Bird Lane","Bird Mountain Rd","Bird Ranch Rd","Bird Spring Canyon Rd",
            "Bird St","Bird of Paradise Rd","Birdcage Center Ln","Birdsall Line","Birdsall Rd","Birdsong Ln",
            "Birdsong Pky","Birdsong Way","Birdsview Ter","Birdwood Ave","Birkdale Road","Birkeland Ln",
            "Birkenfeld Ave","Birkett St","Birkhall Place","Birkner Dr","Birkshire Rd","Birmingham Dr",
            "Birmingham Rd","Birmingport Rd","Birnam Road","Birney Plz","Birney Street","Birr St","Birstler Rd",
            "Biscayne Blvd","Biscayne Boulevard","Biscayne Cir","Biscayne Ct","Biscayne Dr","Biscayne Rd",
            "Bischoff Ave","Biscotti Pl","Biscuit Hill Rd","Bishop Ave","Bishop Avenue","Bishop Ct","Bishop Path",
            "Bishop Rd","Bishop Ridge","Bishop St","Bishop Street","Bishop Trl","Bishop Way","Bishops Gate",
            "Bishops Way","Bishopsbridge Crescent","Bishopville Rd","Bisland Road","Bismarck Dr","Bismark Dr",
            "Bismark Rd","Bismark Way","Bison","Bison Ln","Bison Pky","Bison Trl NW","Bissell Ave","Bissell Avenue",
            "Bisset Dr","Bissett Way","Bisson Ave","Bisson Street","Bissonette Rd","Bitlers Rd","Bitter Fern Ln",
            "Bittern Road","Bitterroot Pl","Bittersweet Ct","Bittersweet Dr","Bittersweet Drive","Bittersweet Ln",
            "Bittersweet Ridge","Bitterwater Cyn Rd","Bittle Ct","Bixby Court","Bixler Ave","Bixler Dr",
            "Bizzibe St","Bj Pl","Blabon St","Blace Hat Rd","Blachley Cir","Black","Black Ance Point","Black Ave",
            "Black Bass Cv","Black Bear Aly","Black Bear Hwy","Black Bear Ln","Black Bear Rd","Black Bear Trail",
            "Black Bear Trl","Black Bird Pl","Black Blvd","Black Brook Dr","Black Brook Rd","Black Brook Road",
            "Black Brothers","Black Bull Rd","Black Butte Rd","Black Canyon Pl","Black Canyon Rd",
            "Black Creek Boulevard","Black Creek Drive","Black Creek Hollow","Black Creek Rd","Black Dr",
            "Black Duck Circle","Black Eagle Ave","Black Forest Dr","Black Forest Rd","Black Fox Lookout Rd",
            "Black Friars Yard","Black Gulch Rd","Black Hawk","Black Hawk Cir","Black Hawk Dr","Black Hawk Rd",
            "Black Hawk St","Black Hill Ridge","Black Hills Rd","Black Horse Ct","Black Horse Pike",
            "Black Horse Rd","Black Hut Rd","Black Jack Ln","Black Jack Rd","Black Kite Dr","Black Lake 11 Route",
            "Black Lake North Shore Road","Black Lake Pl","Black Lake Rd","Black Log Rd","Black Mountain Ct",
            "Black Mountain Rd","Black Mountain Trail","Black Mountain Truck Trail","Black Mtn Rd",
            "Black Oak Ct","Black Oak Dr","Black Oak Ln","Black Oak Park","Black Pine Ln","Black Plain Rd",
            "Black Point Horseshoe St","Black Point Rd","Black Ranch Rd","Black Rd","Black Ridge Ln",
            "Black Riv Road","Black River Ln","Black River Rd","Black Rock Mine Rd","Black Rock Rd",
            "Black Rock Wash","Black Saddle Dr","Black Slate St","Black Walnut Cir","Black Walnut Ln",
            "Black Walnut Rd","Black Walnut St","Black Walnut Trail","Black Willow Court","Blackberry Ave NW",
            "Blackberry Bay Dr","Blackberry Cir","Blackberry Ct","Blackberry Lane","Blackberry Ln",
            "Blackberry Ln NE","Blackberry Rd","Blackberry Ridge","Blackberry St","Blackbird Ave",
            "Blackbird Ct","Blackbird Dr","Blackbrook Way","Blackburn Ave","Blackburn Boulevard","Blackburn Crescent",
            "Blackburn Ct","Blackburn Dr","Blackburn Rd","Blackburn Street","Blackbush Drive","Blackett's Ridge Trail",
            "Blackey Rd","Blackfield Dr","Blackfoot Ave","Blackfoot Dr","Blackfoot Ln","Blackfoot Rd",
            "Blackfoot Trl","Blackford Dr","Blackford St","Blackforest Drive","Blackhawk Rd","Blackhawk St",
            "Blackheath Dr","Blackhills Pl","Blackhurst Dr","Blackinton Road","Blackiston Cv","Blackjack Bay",
            "Blackjack Mountain Rd","Blackmoor Ct","Blackmore Pond Road","Blackoak Mews","Blackoak Rd",
            "Blackoak Ridge","Blackpine Ct","Blackpool Way","Blackrock Rd","Blacks Canyon Rd","Blacksmith",
            "Blacksmith Dr","Blacksmith Ln","Blacksmith Road","Blackstock Rd","Blackstone Ct","Blackstone Dr",
            "Blackstone Road","Blackstone St","Blackthorn Avenue","Blackthorn Dr","Blackthorn Drive",
            "Blackthorn Rd","Blackwater Alcove","Blackwell Ave","Blackwell Avenue","Blackwell Court",
            "Blackwell Ct","Blackwell Dr","Blackwell Place","Blackwell St","Blackwell Way","Blackwell's Landing",
            "Blackwood Avenue","Blackwood Barnsboro Rd","Blackwood Clementon Rd","Blackwood Ct",
            "Blackwood Dr","Blackwood Rd","Blade Ave","Bladen Rd","Blaikley Dr","Blaine Ave","Blaine Dr",
            "Blaine Ln","Blaine Rd","Blaine St","Blair Ave","Blair Cir","Blair Circle","Blair Ct","Blair Dr",
            "Blair Ln","Blair Pl","Blair Road","Blair St","Blairmore Ave","Blairton Road","Blaisdell Ave",
            "Blake Ave","Blake Avenue","Blake Ct","Blake Dr","Blake Hill Rd","Blake Mountian Trl","Blake Rd",
            "Blake Road","Blake St","Blake St NW","Blake Street","Blake's Ln","Blakeley Avenue","Blakeley Rd",
            "Blakely Road","Blakemore Court","Blakeney Pl","Blakeslee St","Blakewood Dr","Blakley Cir",
            "Blakley River Rd","Blanch Ave","Blanchard Dr","Blanchard Hill Road","Blanchard Ln E",
            "Blanchard Ln W","Blanchard Road","Blanchard St","Blanchards Flat Rd","Blanche Ct","Blanche Dr",
            "Blanche St","Blanche Street","Blanco Kendelia Rd","Blanco Rd","Bland Line","Bland Pl","Blandford Rd",
            "Blandin St","Blandina St","Blanding Ave","Blanding Ct","Blanding Rd","Blandon Rd","Blane Aly",
            "Blaney Avenue","Blaney Lane","Blanik Ave","Blankenship Ave","Blankenship Ln","Blanton Blvd",
            "Blantyre Avenue","Blanvon Road","Blashack St","Blass Rd","Blatherwick Dr","Blauvelt Dr",
            "Blauvelt Rd","Blauvelt St","Blauvet Hollow Rd","Blavis St","Blaylock Rd","Blazing Star Ct",
            "Blazing Tr Dr","Bleeker St","Blevins Place","Blezard Line","Blind Crossing Rd","Blind Pond Rd",
            "Blinkoff Ct","Blinn Rd","Bliss Ct","Bliss Ln","Bliss Rd","Bliss River Ct","Bliss Road","Bliss St",
            "Bliss Street","Blissful Lane","Blitzkrieg Trl","Blizzard Ridge Rd SE","Blk Water Rd",
            "Blm Rd","Block Church Rd","Blocker Ct","Blockhouse Rd","Blodgett Mills Rd","Blogett Dr",
            "Blokland Drive","Blood Rd","Blood Road","Bloody Basin Rd","Bloody Camp Rd","Bloody Pond Rd",
            "Bloom Street","Bloomburg Drive","Bloomfield Ave","Bloomfield Club Ct","Bloomfield St",
            "Bloomgate Cr","Blooming Hills Dr","Bloomingdale Dr","Bloomington Ave","Bloomington Road",
            "Bloomsbury Avenue","Bloomsbury St","Bloor Street","Bloor Street East","Bloor Street West",
            "Bloor-Bayview Ramp","Bloss Ct","Blossom Ave","Blossom Cir W","Blossom Ct","Blossom Dr","Blossom Hill Rd",
            "Blossom Ln","Blossom Rd","Blossom Road","Blossom Spring Rd","Blossom Springs Rd","Blossom St",
            "Blossom Street","Blossomfield Road","Blossomwood Ave","Blount St","Blowing Cave Rd","Blue",
            "Blue Arroyo Dr","Blue Balaton Ln","Blue Bell Dr","Blue Bell Rd","Blue Bend Rd","Blue Berry Hill Rd",
            "Blue Bird Canyon Dr","Blue Bird Dr","Blue Bird Hill Dr","Blue Bird Ln","Blue Bonnet Court",
            "Blue Cain Rd","Blue Camas Rd","Blue Cane Rd","Blue Canyon Rd","Blue Chip Ln E","Blue Claw Rd",
            "Blue Creek Mountain Trl","Blue Creek Mtn Trl","Blue Cypress Avenue NE","Blue Dodge Trl",
            "Blue Dun Ct","Blue Falls Pl","Blue Fin Cir","Blue Flag Ct","Blue Forest Drive","Blue Granite Ln",
            "Blue Grass Boulevard","Blue Grass Rd","Blue Grove Ln","Blue Gum Dr","Blue Haven Dr NE",
            "Blue Heron Cir","Blue Heron Ct","Blue Heron Dr","Blue Heron Dr S","Blue Heron Ln","Blue Heron Rd",
            "Blue Heron Ridge","Blue Herron Ln","Blue Hill Ave","Blue Hill River Road","Blue Hills Dr",
            "Blue Hills Parkway","Blue Hills View","Blue Hole Rd","Blue Ice Ct","Blue Jay Ave","Blue Jay Dr",
            "Blue Jay Ln","Blue Jay Rd","Blue Jay Trl","Blue Jays Way","Blue Lagoon Court","Blue Lagoon Dr",
            "Blue Lake Cove Ln","Blue Lake Rd","Blue Lakes Ct","Blue Light Ln","Blue Mesa Way","Blue Moon Lane NE",
            "Blue Moun Drive","Blue Mountain Dr","Blue Mountain Lake","Blue Mountain Road","Blue Mouse Rd",
            "Blue Mtn Dr","Blue Oak Avenue","Blue Oak Way","Blue Palm Dr","Blue Pine Ave NW","Blue Rd",
            "Blue Ridg Trail","Blue Ridge Cir","Blue Ridge Ct","Blue Ridge Dr","Blue Ridge Rd","Blue Ridge Trail",
            "Blue Ridge Truck Trail","Blue River Dr","Blue Rock Ranch Rd","Blue Rock Rd","Blue Sage Lane",
            "Blue Skies Ct","Blue Skies Dr","Blue Sky Dr","Blue Sky Rd","Blue Slide Creek Rd","Blue Slide Rd",
            "Blue Spruce Ct","Blue Spruce Dr","Blue Spruce Ln","Blue Star Hwy","Blue Star Turnpike",
            "Blue Teal Place","Blue Teal Way","Blue Topaz Ave","Blue Trail;Forge Road Trail","Blue Trail;White Trail",
            "Blue Water Dr","Blue Water Ln","Blue Water Place","Blue Water Rd","Blue Water Trl","Blue Willow Drive",
            "Blue Wing Cir E","Blue Wing Dr","Blue Winged Dr","Bluebank Rd","Bluebeard Dr","Bluebell Cv",
            "Bluebell St","Bluebell Way","Blueberry Ave NW","Blueberry Circle","Blueberry Ct","Blueberry Drive",
            "Blueberry Hill","Blueberry Hill Dr","Blueberry Hill Park","Blueberry Hill Rd","Blueberry Lane",
            "Blueberry Ln","Blueberry Pl","Blueberry Rd","Blueberry Ridge Rd","Bluebird Ct","Bluebird Dr",
            "Bluebird Ln","Bluebird St","Bluecreek Dr","Bluefield Dr","Bluefield Terrace","Bluefin Dr",
            "Bluegrass Dr","Bluegrass Ln","Bluehurst Ave","Bluejay Dr","Bluejay Ln","Bluejay Rd","Bluejay Way",
            "Blueking Crescent","Bluemist Rd","Blueridge Dr","Bluesage Ct","Bluestone Ave","Bluestone Ct",
            "Bluestone Dr","Bluestream Drive","Bluett Tanner Rd","Bluewater Ct","Bluewater Ln","Bluewater Pl",
            "Bluewater Way","Bluff Rd","Bluff Reach","Bluff Springs Rd","Bluffport Rd","Bluffs Ct","Bluffs Road",
            "Bluffside Dr","Bluffview Ct","Bluffview Dr","Bluffview Rd","Blum St","Blume St NE","Blundell Road",
            "Blvd. Lázaro Cárdenas","Bly Hill Rd","Bly Hollow Rd","Blyler Pl","Blyler Rd","Blythe Ogilby Rd",
            "Blythe Pl","Blythe Rd","Blythe Shore Road","Blythe St","Blythe Way","Blyton Ln","Bmw Plz",
            "Bo Ln","Boag Road","Boake Trail","Boanza Dr","Board Hill Rd","Board Rd","Boardley Road","Boardman Riv Rd SW",
            "Boardman Street","Boardman's Road","Boards Crossing Rd","Boardwalk","Boardwalk Ct","Boardwalk Pl",
            "Boardwalk Street","Boardwalk To Homes","Boars Nest Rd","Boat Basin Rd","Boat House Road",
            "Boat Landing 13 Rd","Boat Landing Access","Boat Launch Ln","Boat Pl","Boat Stall Rd",
            "Boatbill Cir","Boathouse Rd","Boating Pl","Boatman Ave","Boaz St","Bob Ave","Bob Cat Trl","Bob Ct",
            "Bob Fredrick Rd","Bob Gilder Pl","Bob Holbrook Rd","Bob Hope Dr","Bob Kaufman Aly","Bob S Creek Truck Trail",
            "Bob Street","Bob Taylor Dr","Bob White Dr","Bob's Rd","Bob-O-Link Manor","Bob-O-Link Road",
            "Bobarn Dr","Bobbie Ln","Bobbinshop Rd","Bobby Dr","Bobby Ln","Bobby Taylor St","Bobbye Ave",
            "Bobbys Run Rd","Bobcat Ave","Bobcat Cir","Bobcat Ct","Bobcat Dr","Bobcat Hollow Rd","Bobcat Ln",
            "Bobcat Way","Bobcaygeo Road","Bober Ln","Bobiak Road","Boblyn Way","Bobo Ct","Bobo Ln","Bobo Loop",
            "Bobo Rd","Bobolink Ln","Bobs Lake Road","Bobs Road","Bobwhite Ln","Bobwhite St","Bobwith Ln",
            "Boca Ct","Boche Ln","Bock Ct","Bock Dr","Bockes Rd","Bockington Crescent","Boclair Dr","Bodega Pl",
            "Bodenhammer Ave","Bodfish St","Bodie Ave","Bodie Rd","Bodie St","Bodily Pl","Bodine Ave","Bodine Dr",
            "Bodmin Road","Bodnar Dr NE","Bodnar St","Bodrington Court","Bodwell Ct","Boeing Dr","Boeing St",
            "Boem Avenue","Boes Road","Boettcher Ct","Bog Hill Road","Bogan Dr","Bogardus Ln","Bogart Pl",
            "Bogart Street","Bogert Avenue","Bogert Dr","Bogert Pl","Bogert Rd","Bogert St","Bogerts Mill Rd",
            "Bogey Cir","Bogey Pl","Boggan Ln","Boggess Run Rd","Boggiano Dr","Boggs St","Boggy Creek","Bogie Ln",
            "Bogie Way","Bogle Rd","Bogle Street","Bogota Gdns","Bogota St","Bohanon Bridge Rd","Bohemian Rd SE",
            "Bohemio Ct SW","Bohl Dr","Boies St","Boiling Springs Ave","Boiling Springs Rd","Boisdale Avenue",
            "Boise Ave","Boise Ave SW","Boise Cir","Boise Ct","Boise Street","Bokee Court","Bolam Airport",
            "Bolam Logging Road","Boland Rd","Bolander Dr","Bolanos Ave","Bold Ct","Bold Springs Rd",
            "Bolen Ct","Boles Motor Way","Boles Road","Boles St","Bolie Stafford Rd","Boligee St","Bolin Rd",
            "Bolingbroke Ct","Bolitho Dr","Bolivar Dr","Bolivar Ln","Boliver Rd","Bollinger Canyon Rd",
            "Bolo Rd","Bolt Ct","Boltin St","Bolton Ave","Bolton Avenue","Bolton Cir","Bolton Farms Rd",
            "Bolton Rd","Bolton Road","Bolton St","Bolton Street","Boman Rd","Bomar Dr","Bombardier Ave",
            "Bombay Ct","Bombay Plz N","Bombay Rd","Bombay St","Bon Veu Cir","Bona Ln","Bonaffon St","Bonaguidi Rd SW",
            "Bonair Road","Bonanza Ct","Bonanza Dr","Bonanza King Rd","Bonanza Rd","Bonanza Way","Bonapard Pt Rd",
            "Bonaparte Ct","Bonar Street","Bonavem Drive","Bonavista Ln","Bond Avenue","Bond Dr","Bond Pl",
            "Bond Road","Bond St","Bond Street","Bondeno St","Bondhead Street","Bondi Avenue","Bone Rd",
            "Bone Run Rd","Bonelli Trl","Boner Dr","Boneset","Boneta Corals","Boneyard Rd","Bonfield Avenue",
            "Bonfield Dr","Bongards Crossroads","Bonham Ave","Bonhomme St","Boni Ln","Boni Rd","Bonie Ct",
            "Bonin Drive","Bonis Lane","Bonisteel Road","Bonita Ave","Bonita Avenue","Bonita Crescent",
            "Bonita Dr","Bonita Ln","Bonita Loop","Bonita Pl","Bonita Rd","Bonita Ter","Bonito Street","Bonitz St",
            "Bonn Ln","Bonna Ave","Bonnell Ave","Bonner Ct","Bonner Rd","Bonner Road","Bonnerdale Rd","Bonnertown Rd",
            "Bonneta Court","Bonnett Dr","Bonneville Ave","Bonneville Avenue","Bonney Rd","Bonnie Brae",
            "Bonnie Brae Ave SE","Bonnie Brae Rd","Bonnie Brook Rd","Bonnie Cir","Bonnie Claire Dr",
            "Bonnie Dr","Bonnie Glen Ct","Bonnie Hill Dr","Bonnie Hollow Ln","Bonnie Lk Dr","Bonnie Ln",
            "Bonnie Meadow Ln","Bonnie Rd","Bonnie Springs Rd","Bonnies Way","Bonnot Pl NE","Bonny Ln",
            "Bonnymede Ct","Bonnymede Ln","Bonnyvale Rd","Bonsall Ave","Bonsecour Crescent","Bonsor Road",
            "Bonter's Lane","Bonwit Pl","Boody Ct","Booger Hollow Rd","Book Ct","Booker Ave","Booker St",
            "Boole Rd","Boomerang Ln","Boon Avenue","Boon St","Boone Cir","Boone Rd","Boone Valley Rd","Boone-Canyon",
            "Boonville Rd","Booraem Ave;New York Ave","Boot Creek Rd","Booth Ave","Booth Ln","Booth Rd",
            "Booth St","Booth Walker","Boothby Ct","Boothby Dr","Boothby Ln","Boothill","Boothill Rd SE",
            "Boothroyd Avenue","Boots Rd","Bootzins Rd","Boox St","Boratko St","Borax","Borbel Rd","Borchart St",
            "Borchers Dr","Borda St","Bordeaux Valley Dr","Bordelais St","Borden Ave","Borden Avenue",
            "Borden Brook Road","Borden Brook Road Branch","Borden Hill Court","Borden Street",
            "Bordentown Chesterfield Rd","Bordentown Rd","Border Ave","Border Hwy","Border Road","Border St",
            "Borderland Rd","Borders St","Boreal Pl","Borealis Avenue","Borel St","Boreland Cir","Boreland Pl",
            "Boren Dr","Boresma Loop","Borg Rd","Borger Pl","Borica Ct","Borinquen Place","Borland Ln","Borland Street E",
            "Borman Dr","Borman Way","Bornt Rd","Boro Commons","Boroline Road","Boron Ave","Boronda Rd",
            "Boronda St","Borough Approach East","Borough Drive","Borough Pl","Borough St","Borrego Dr",
            "Borrego Palm Canyon Rd","Borrego Way","Borrow Pit Rd","Bors Ct SW","Borson St","Borthwick Way",
            "Borton Mill Ct","Bortons Mill Ct","Borzotta Blvd","Bosler Way","Bosley Hill Rd","Bosque Dr",
            "Bosque Loop","Bosque St NW","Bosque del Sol Ln NW","Boss Ave","Bossy Lane","Bost Dr","Bostock Crescent",
            "Boston Ave","Boston Avenue","Boston Blvd","Boston Commons Pl","Boston Ct","Boston Hill Rd",
            "Boston Ln","Boston Pl","Boston Post Rd","Boston Road","Boston St","Boston Street","Boston Tpke",
            "Boston Wharf Road","Bosun Ave","Boswell Ave","Boswell Ct","Boswell St","Bosworth Avenue",
            "Bosworth Dr","Bosworth Street","Botanical","Botany Hi Crescent","Botany Pl","Botany St",
            "Botany Tr","Botcher Rd","Bothwell Avenue","Bothwick Rd","Botley Road","Botsford Pl","Bottle Brush Way",
            "Bottlebrush Dr","Bottlebrush Ln","Bottoms Dr","Bouchier Street","Boudinot St","Boudousquie St",
            "Bougainvilla Ct","Bougainvillea Dr","Bough Ct","Boughton Rd","Boulder Ave","Boulder Bluff Ave",
            "Boulder Bluff Ln","Boulder Cir","Boulder Creek Dr","Boulder Creek Ln","Boulder Creek Pl",
            "Boulder Creek Rd","Boulder Creek St","Boulder Ct","Boulder Dr","Boulder Field Way","Boulder Hwy",
            "Boulder Ln","Boulder Pl","Boulder Rd","Boulder Ridge Cir","Boulder Ridge Xing","Boulder Street",
            "Boulder Way","Boulder Wood","Bouldon Ditch Road","Boulevard","Boulevard Court","Boulevard Craftsman Boulevard",
            "Boulevard E","Boulevard Martinique","Boulevard Pky","Boulevard Rd","Boulevard de Jardin",
            "Boullion Road","Boultbee Avenue","Boulton Street","Boultons Beach Rd","Bound Brook Ave",
            "Bound Tree Rd","Boundary Ave","Boundary Cir","Boundary Ln","Boundary Oak Dr","Boundary Oak Ln",
            "Boundary Rd","Boundary Road","Boundary St","Bounds Trl","Bountiful Way","Bounty Ct","Bounty Rd",
            "Bounty Way","Bourang Way","Bourassa Dr","Bourbon Ct","Bourbon Ln","Bourbon St","Bourdon Avenue",
            "Bourne Bridge Road","Bourne Dr","Bourne Rd","Bourne St","Bournemouth Road","Bournville Drive",
            "Bouse Rd","Boush St","Boutwell Hill Road","Boutwell Rd","Bovee Rd","Bovina Rd","Bow 'n' Arrow Dr",
            "Bow Bridge Rd","Bow Dr","Bow Ln","Bow Pointe Dr","Bow River Crescent","Bow St","Bow Street",
            "Bow Valley Drive","Bowan Court","Bowan Ct","Bowater Drive","Bowcroft St","Bowden Aly","Bowden Rd",
            "Bowden St","Bowditch Drive","Bowdoin Road","Bowdoin St; Stanford St","Bowdoin Street",
            "Bowdoin Trl","Bowen Ave","Bowen Dr","Bowen Dr E","Bowen Hill Rd","Bowen Rd","Bowen Road","Bowen St",
            "Bowen Street","Bowen Trail","Bowen-Piney Rd","Bowenhill Rd","Bowens Ln","Bower Ln","Bower St",
            "Bowerbank Drive","Bowers Ave","Bowers Dr","Bowers Ln","Bowers Rd","Bowers Road","Bowes Ave",
            "Bowes Avenue","Bowhill Drive","Bowie Rd","Bowie Way","Bowles Avenue","Bowles Fountain Road",
            "Bowles Rd","Bowles Street","Bowles Terrace","Bowley Dr","Bowley Way","Bowman Avenue","Bowman Ct",
            "Bowman Dr","Bowman Ln","Bowman Rd","Bowman St","Bowman Street","Bowmen Ln","Bowne Rd","Bowne Station Rd",
            "Bowne Street","Bowood Dr","Bowring Walk","Bowser Rd","Bowslaugh Road","Bowsprit Close","Bowsprit Point",
            "Bowyer Ave","Box Canyon Dr","Box Canyon Rd","Box Office Dr","Box Turtle Lane","Boxberry Avenue",
            "Boxberry Way","Boxer Blvd","Boxley Pl","Boxtown Rd","Boxwood Ave","Boxwood Crescent","Boxwood Ct",
            "Boxwood Dr","Boxwood Ln","Boxwood Pl","Boxwood Rd","Boxwood St SE","Boxwood Ter","Boxwood Way",
            "Boy Scout Camp Rd","Boy Scout Lake Rd","Boyard Ct","Boyce Ave","Boyce Pl","Boychyn Drive",
            "Boyd Cir E","Boyd Ct","Boyd Dr","Boyd Ln","Boyd Rd","Boyd Springs Rd","Boyd St","Boyd Street",
            "Boydell Place","Boyden Street","Boyden Street Extension","Boyds Mill Rd","Boyer Dr","Boyer Ln",
            "Boykin St","Boyle Road","Boylston Lane","Boylston Place","Boylston Street","Boylston Ter",
            "Boynton","Boynton Ave","Boynton Dr","Boynton Lane","Boynton Place","Boynton Prairie Rd",
            "Boynton Rd","Boynton St","Boynton Street","Boys Club Street","Boys Street S","Boysen Rd",
            "Boysenberry Ln","Boyton Hill Rd","Boyton St","Bozak Rd","Braastads Rd","Brabant St","Brabham St",
            "Bracard Ct","Brace Rd","Braceo St","Braceville Robinson Rd SW","Bracken Ave","Bracken Street",
            "Bracken Woods Dr","Brad St","Bradburn Road","Bradbury Crescent","Braddock Ave","Braddock Bay State Pky",
            "Braddock Ln","Braddock Rd","Braddock St","Braddon Way","Braden Ct","Braden Pl NE","Braden Rd",
            "Bradford","Bradford Ct","Bradford Dr","Bradford Heights Rd","Bradford Hill Rd","Bradford Ln",
            "Bradford Pl","Bradford Rd","Bradford St","Bradford St NE","Bradford Street","Bradford Terrace",
            "Bradgate Drive","Bradish Dr","Bradl Ln","Bradley 141 Rd","Bradley 17 Rd","Bradley 184 Rd",
            "Bradley 191 Rd","Bradley 25 Rd N","Bradley 25 Rd S","Bradley 27 Rd S","Bradley 273 Rd",
            "Bradley 3 Rd","Bradley 339 Rd","Bradley 34 Rd","Bradley 460 Rd","Bradley 471 Rd","Bradley 49 Rd",
            "Bradley 53 Rd","Bradley 57 Rd","Bradley 62 Rd","Bradley 8 Rd N","Bradley 94 Rd","Bradley Ave",
            "Bradley Avenue","Bradley Ct","Bradley Dr","Bradley International Airport Connector",
            "Bradley Rd","Bradley Road","Bradley Road 16","Bradley Sq","Bradley St","Bradley St SW","Bradley Ter",
            "Bradley-Henley Rd","Bradmar Cir","Bradmore Avenue","Bradner Ave","Bradshaw Rd","Bradshaw Street",
            "Bradsher St","Bradstock Road","Bradura Ct","Bradwick Way","Brady Beach Rd","Brady Ct","Brady Drive",
            "Brady Mountain Overlook","Brady Rd","Brady St","Brady Street","Brady Trl","Brae Ridge","Braeburn",
            "Braeburn Boulevard","Braeburn Court","Braeburn Dr","Braeburn Drive","Braeburn Ln","Braeburn Rd",
            "Braehead Drive","Braehurst Ln","Braemar Ct","Braemore Road","Braeside Ave","Braeside Square",
            "Braeton Way","Braewood Rd","Brafman Dr","Braga Ln","Bragaglia Dr","Bragg","Bragg Road","Bragg St",
            "Bragg Street","Bragg Ter","Brahman Rd","Brahms Dr","Braile St","Brain Ridge Rd","Brainard Ave",
            "Brainard Rd","Brainard St","Brainard Street","Brainerd Blvd","Braithwaite Road","Braley Hill Road",
            "Braley Pond Rd","Braley Rd","Braman Ct","Bramble Court","Bramble Ct","Bramble Ln","Bramblewood Ln",
            "Bramblewood Way","Bramell St","Bramhall Ave","Bramhall Rd","Brammar Street","Brammer Rd",
            "Bramsey Drive","Bramshott Avenue","Bramwell Drive","Branca Rd","Branch","Branch Ave","Branch Avenue",
            "Branch Creek Rd","Branch Ct","Branch Dr","Branch Flat Rd","Branch Ln","Branch Mountain Rd",
            "Branch No 3 Canal","Branch Rd","Branch St","Branch Street","Branchville Rd","Branchwood Dr",
            "Branchwood Ln","Branchwood Park","Branchwood Pl","Branchwood Ter","Branco Rd","Brand Ave",
            "Brand Rd","Brand St","Branden Dr","Brandenburg Ln","Brandes Rd","Brandi Dr","Brandies Rd","Branding Iron Rd",
            "Brandon Ave","Brandon Ct","Brandon Dr","Brandon Gate Drive","Brandon Ln","Brandon Thomas Way",
            "Brandonkane Ln","Brandt Rd","Brandy Apple Rd","Brandy Court","Brandy Ct","Brandy Hill Rd",
            "Brandy Ln","Brandy Way","Brandywine Boulevard","Brandywine Cir","Brandywine Common","Brandywine Ct",
            "Brandywine Dr","Brandywine Ln","Brandywine Pl","Brandywine Rd","Brandywine St","Brandywine Way",
            "Brandywyne","Brandywyne E","Brandywyne Court","Branford Dr","Branford Pl","Brangus Dr",
            "Branigan Way","Brannan Island Mhp","Brannon Harris Way","Brannon Rd","Brannough Rd","Brannum St",
            "Branscum","Branscum Dr","Branson Ave","Brant Rd","Brant St","Brant Ward Rd","Brantingham Rd",
            "Brantwood Court","Brantwood Dr","Brantwood Road","Brantwood Ter","Brasch Blvd","Brasfield Rd",
            "Brass Castle Rd","Brass Ring","Brassie Ct","Brasswood Road","Brasted District Rd","Brattle Street",
            "Braun Ct","Braun St","Braunsdorf Rd","Bravada Ct","Brave Trl","Braverwood Dr","Bravo Ct","Bravo St",
            "Brawn Road","Braxton Pl","Braxton Rd","Brayan Dr","Braymore Boulevard","Brays Hill Rd","Brazil St; 4th St E",
            "Brazilnut Ct","Brazos Ct NE","Brazos Ct SE","Brazos Ct SW","Brea Canyon Rd","Breakenridge Ter",
            "Breakers Ln","Breakers Reach","Breakfast Hill Rd","Breakneck Rd","Breakneck Road","Bream Bluff",
            "Breamhaven Cv","Brearly Cres","Brearly Loop","Brechin Ln","Brechtel Rd","Breck Ave","Breck Ct",
            "Breck Hill Rd","Breck St","Breck Street","Breckenridge","Breckenridge Boulevard","Breckenridge Ct",
            "Breckenridge Dr","Breckenridge Pl","Breckenridge Rd","Breckenridge St","Breckenwood Pl",
            "Breckinridge Ave","Breckswood Oval","Breech Ct","Breed Street","Breeders Ct","Breeds Hill Ct",
            "Breem St","Breen Lane","Breen Place","Breeze Hill Dr","Breeze Pl","Breeze St","Breezeway Crescent",
            "Breezeway Dr","Breezewood Ave","Breezewood Dr","Breezie St","Breezy Ct","Breezy Drive","Breezy Hill Rd",
            "Breezy Knoll","Breezy Knoll Dr","Breezy Meadows","Breezy Ocean Ln","Breezy Orchard St",
            "Breezy Point Rd","Breezy Willow Ln","Brehler Ave","Breitbeck Ln","Bremen Ave","Bremer St",
            "Brenda Cir","Brenda Pl","Brendan Ln","Brendan Rd","Brendan Way","Brenden Ln","Brendwin Road",
            "Brenna Pl","Brennan Beach Rd","Brennan Concourse","Brennan Ct","Brennan Rd","Brennan Road",
            "Brennan St","Brennans Point Ln","Brennen Ct","Brenner Pass","Brenner Pl","Brent Cir","Brent Dr",
            "Brent Ln","Brent Rd","Brent Thurman Way","Brent Wood St","Brentcliffe Road","Brentford St",
            "Brentford Way","Brenthaven St","Brentina Ave","Brenton Ct","Brenton Road","Brenton Street",
            "Brentwood","Brentwood Ave","Brentwood Ct","Brentwood Cv","Brentwood Dr","Brentwood Drive",
            "Brentwood Rd","Brentwood Road North","Brentwood Road South","Brentwood St","Brentworth Way",
            "Brenyon Way","Bresciani Ln","Bresset Rd","Bressler St","Bret Ct","Bret Dr","Bret Harte Rd",
            "Breton Ave","Breton Avenue","Breton Dr","Breton Road","Bretonian Dr","Bretonian Dr E","Bretonian Dr W",
            "Brett Ct","Brett Pl","Brett Road","Brett St","Bretton Road","Breuer Rd","Brevard Blvd","Brevity Ln",
            "Brevoort Place","Brewer Ave","Brewer Loop","Brewer Rd","Brewer St","Brewer Street","Brewer's Mills Road",
            "Brewers Mill Rd","Brewerton Boulevard","Brewery Rd","Brewhause Ln","Brewsland Crescent",
            "Brewster Ave","Brewster Ct","Brewster Dr SE","Brewster Heights","Brewster Rd","Brewster St",
            "Brewster Street","Brewton Ave","Brezius Ln","Brian Ave","Brian Avenue","Brian Cir","Brian Ct",
            "Brian Lane","Brian St","Brian Way","Brians Way","Briar Crest","Briar Ct","Briar Cv","Briar Hill Avenue",
            "Briar Hill Lane","Briar Knoll Dr","Briar Knolls","Briar Ln","Briar Manor Apartment","Briar Patch Rd",
            "Briar Path","Briar Path Lane","Briar Rd","Briar Ridge Rd","Briar Road","Briar Way","Briarberry Ln",
            "Briarcliff NE","Briarcliff Ave","Briarcliff Ct","Briarcliff Dr","Briarcliff Lane","Briarcliff Ln",
            "Briarcliff Rd","Briarfield Dr","Briarfield Drive","Briarfield St","Briargate Ln","Briarhill Dr",
            "Briarhill Rd","Briarly Drive","Briarscross Boulevard","Briarsdale Crescent","Briarsdale Drive",
            "Briarstone Ln","Briarstone Rd","Briarwood","Briarwood Ave","Briarwood Avenue","Briarwood Cir",
            "Briarwood Ct","Briarwood Cv","Briarwood Dr","Briarwood Drive","Briarwood Ln","Briarwood Place",
            "Briarwood Rd","Briarwood Road","Briarwood St","Briarwood Ter","Briarwood Trl","Brice Hollow Rd SE",
            "Briceland Thorn Rd","Brick Alley","Brick Church Rd","Brick House Rd","Brick Kiln Rd",
            "Brick Kiln Road","Brick Rd","Brick Row Aly","Brick St","Brick Way","Brickell Place","Bricker St",
            "Brickscape Dr","Brickway Blvd","Bricky Rd S","Brickyard Rd","Bridal Ln","Brideshill Rd",
            "Bridge Arbor Rd","Bridge Ave","Bridge Bay Dr","Bridge Creek Dr","Bridge House St","Bridge Ln",
            "Bridge Plz","Bridge Rd","Bridge Road","Bridge Road Extension","Bridge St","Bridge Street",
            "Bridge Street W","Bridge Two Ln","Bridge View Dr","Bridge Way","Bridge Wells","Bridgeboro St",
            "Bridgeman Ct","Bridgeman Rd","Bridgemont Ave NW","Bridgepointe Dr","Bridgeport Ave","Bridgeport Ct",
            "Bridgeport Cv","Bridgeport Dr","Bridgeport Street","Bridger St","Bridges Court","Bridgestone Dr",
            "Bridget Ct","Bridget St SE","Bridget Walk","Bridgeton Ave","Bridgeton Ct","Bridgetown Pike",
            "Bridgeview","Bridgeview Ave","Bridgeview Dr","Bridgewater Avenue","Bridgewater Ct","Bridgewater Dr",
            "Bridgewater Pl","Bridgewater Pl NW","Bridgewater Rd","Bridgewaters Dr","Bridgewood Ln",
            "Bridie Ave","Bridle Ct","Bridle Glen St","Bridle Ln","Bridle Path","Bridle Path Circle",
            "Bridle Path Lane","Bridleford Court","Bridleholme Crescent","Bridlewood Boulevard",
            "Bridlewood Dr","Bridlewood Ln","Brieann Dr","Brielle Ave","Brien Avenue","Brienz Way","Brier Dr",
            "Briercliff Dr","Briere Patch Ln","Briere Rd","Brierwood Avenue","Brierwood Dr","Brierwood Road",
            "Brierwood St","Briffjr","Brigadoon Cir","Brigadoon Ct","Brigatine Rd","Briggs Avenue","Briggs Ct",
            "Briggs Dr","Briggs Rd","Briggs St","Briggs Street","Brigham Cir","Brigham Court","Brigham Hill Rd N",
            "Brigham Road","Brigham St","Brigham Street","Bright Oaks Cir","Bright Sky","Bright Slope Way",
            "Bright St","Bright Star Dr","Bright Star Rd","Bright Street","Bright View Rd","Brightly Drive",
            "Brightman Street","Brighton 10th Lane","Brighton 10th Terrace","Brighton 11th Street",
            "Brighton 14th Street","Brighton 1st Path","Brighton 1st Street","Brighton 2nd Place",
            "Brighton 4th Court","Brighton 4th Lane","Brighton 4th Place","Brighton 4th Road","Brighton 4th Street",
            "Brighton 5th Court","Brighton 5th Place","Brighton 5th Street","Brighton 6th Court",
            "Brighton 6th Street","Brighton Ave","Brighton Avenue","Brighton Ct","Brighton Dr","Brighton Ln",
            "Brighton Pl","Brighton Rd","Brighton Ridge Ct","Brighton Way","Brights Point Rd","Brightstar Rd N",
            "Brightwood Avenue","Brightwood Dr","Brightwood Street","Brigid Ct","Brigton Drive","Brill Rd",
            "Brill St","Brillo Dr","Brillo St","Brimfield Ave","Brimfield Rd","Brimfield Road","Brimforest Gate",
            "Brimley Road","Brimmer Farm Rd","Brimmer Junction Rd","Brimmer Rd","Brimorton Drive",
            "Brimstone Dr","Brimstone Rd","Brimwood Boulevard","Brinckerhoff Ct","Brinda Ln","Bringhurst Ave",
            "Bringle Loop","Bringold Ave","Brink Ave","Brink Rd","Brinker Hoff Ave","Brinkerhoff Ave",
            "Brinkerhoff St","Brinkerhoff Ter","Brinkley Ln","Brinkley St","Brinkman Rd","Brinley Ln",
            "Brinley St","Brinsmade Rd","Brinston Road","Brinwood Gate","Briny Cir","Brion Rd","Brisas Drive",
            "Brisbane Ct","Brisbane Glen","Brisbane Ln","Brisco Bridge","Brisk Ln","Bristlecone Way",
            "Bristol Avenue","Bristol Cir","Bristol Crescent","Bristol Ct","Bristol Curve","Bristol Dr",
            "Bristol Ln","Bristol Pike","Bristol Rd","Bristol Road West","Bristol Square St","Bristol St",
            "Bristol Street","Bristol Ter","Bristol Valley Rd","Bristol Valley Road","Bristolwood Rd",
            "Britannic Ave","Brite St","Briton Cir NW","Briton-Houghton Bay Road","Britt Rd","Britt Street",
            "Brittain Ln","Brittan Avenue","Brittany Ct","Brittany Dr","Brittany Ln","Brittany Road",
            "Brittany St","Brittany Way","Brittany Woods","Brittingham St","Britton Ave","Britton Ln",
            "Britton Rd","Britton Run Rd","Britton Street","Britz Cir","Brixey Dr","Brixham Dr","Brixton Lane",
            "Brizee St","Bro Pl","Broad","Broad Ave","Broad Rd","Broad Reach","Broad St","Broad Street","Broad Ter",
            "Broadacre Pl","Broadacres Dr","Broadcast Ave","Broadchannel Rd","Broadebeck Dr","Broadfield Drive",
            "Broadgreen Street","Broadhead Ct","Broadlands Boulevard","Broadlawn Dr","Broadleaf","Broadleaf Cir",
            "Broadleaf Dr","Broadleaf Road","Broadleaf Street","Broadmead Avenue","Broadmere St","Broadmoor 60th Turnaround Turn",
            "Broadmoor Cir NW","Broadmoor Dr","Broadmoor Pl","Broadmoor St","Broadmore St","Broadoak Crescent",
            "Broadoaks Drive","Broadriver Dr","Broadstone Trail","Broadview Ave","Broadview Avenue",
            "Broadview Dr","Broadview Pl","Broadview Rd","Broadview Ter","Broadwater Ln NE","Broadway",
            "Broadway Ave","Broadway Avenue","Broadway Blvd","Broadway Rd","Broadway Redfern","Broadway St",
            "Broadway Street","Broadway Terrace","Broadway Way","Broadwell","Broatch Road","Brocado Ln",
            "Brock Cir","Brock Con Road","Brock Concession 7 Road","Brock Dr","Brock Hill Rd","Brock Ln",
            "Brock Mountain Ln","Brock Rd","Brock Road","Brock St","Brock Street","Brock Street E","Brock Street S",
            "Brock Street West","Brock-Scugog Townline Road","Brockton Avenue","Brockton Ct","Brockton Dr",
            "Brockton Rd","Brockton Sq","Brockview Crescent","Brockville Street","Brockway Ave","Brockway Hotel Dr",
            "Brockway Mills Rd","Brockway Rd","Brockways Mill Rd","Broderick Rd","Broderick St","Brodie Cir NW",
            "Brodie Dr","Brodie Mountain Road","Brodie Rd SW","Brodie West Ct","Brodil Ct","Brodrick Ave",
            "Broeas Dr NW","Brohm Pl","Brokaw Blvd","Brokaw Ct","Brokaw Rd","Broken Arm Rd","Broken Arrow",
            "Broken Arrow Dr","Broken Arrow Drive","Broken Arrow Rd","Broken Bow","Broken Bow Ct",
            "Broken Bow Rd","Broken Branch Trl","Broken Ct","Broken Down Dam Rd","Broken Hickory Cv",
            "Broken Hickory Dr","Brokeoff Tr Ln","Bromfield Street","Bromhowser St","Bromilow St",
            "Bromley Ave","Bromley Ct","Bromley Ln","Bromley Rd","Brompton Ct","Brompton Ln","Bromsgrove Road",
            "Bromwich Way","Bronc Rd","Bronco Ln","Bronco Way","Bronson","Bronson Ct","Bronson Rd","Bronson St",
            "Bronson Way","Bronx River Parkway","Bronze Cir","Bronze Dr","Brook Ave","Brook Crescent",
            "Brook Ct","Brook Dr","Brook Dr N","Brook Drive","Brook Farm Rd","Brook Haven Lane","Brook Hill Pl",
            "Brook Hill Rd","Brook Hollow Dr","Brook Hollow Rd","Brook Lane","Brook Leaf Ct","Brook Ln",
            "Brook Pl","Brook Rd","Brook Ridge Ct","Brook Road","Brook Run Ave NE","Brook Song Way","Brook St",
            "Brook Street","Brook Ter","Brook Tr","Brook Valley Rd","Brook Valley Ter","Brook View Dr",
            "Brook Way","Brook Xing","Brookbanks Drive","Brookberry Ln","Brookbridge Road","Brookdale Ave",
            "Brookdale Avenue","Brookdale Ct","Brookdale Dr","Brookdale Pl","Brookdale Rd","Brookdale St",
            "Brooke Avenue","Brooke Dr","Brooke Moore Ct","Brooke Street","Brooker Rd","Brooker Ridge",
            "Brookeview Drive","Brookfield Ave","Brookfield Cove Ave","Brookfield Crescent","Brookfield Ct",
            "Brookfield Dr","Brookfield Pl","Brookfield Rd","Brookfield Road","Brookfield St","Brookhaven Dr",
            "Brookhaven Dr SE","Brookhaven Pl NW","Brookhaven Ter","Brookhaven Way","Brookhill Ave",
            "Brookhill Ln","Brookhill Rd","Brookhollow Dr","Brookhouse Drive","Brookhouse Ln","Brookhurst Rd",
            "Brookhurst Road","Brookide Road","Brookins Green Dr","Brooklake Rd","Brookland Avenue",
            "Brooklands Ave","Brooklawn Ave","Brooklawn Cir","Brooklawn Dr","Brooklawn Pky","Brooklea Dr",
            "Brooklet Court","Brookline Road","Brookline Street","Brookline Way","Brooklyn Avenue",
            "Brooklyn Bridge","Brooklyn Bridge Promenade","Brooklyn Ct","Brooklyn Hwy","Brooklyn Queens Expy; I-278",
            "Brooklyn Rd","Brooklyn-Battery Tunnel","Brooklyn-Queens Expressway","Brookmeadow Cir",
            "Brookmere Dr","Brookmill Rd","Brookpark Rd","Brookridge Dr","Brookridge Drive","Brooks Ave",
            "Brooks Avenue","Brooks Bend Dr","Brooks Ct","Brooks Dr","Brooks Edge Dr","Brooks Lane","Brooks Ln",
            "Brooks Pl","Brooks Pond Road","Brooks Rd","Brooks St","Brookshire Rd","Brookside Ave","Brookside Avenue",
            "Brookside Cir","Brookside Ct","Brookside Dr","Brookside Drive","Brookside Farm Rd","Brookside Ln",
            "Brookside Pky","Brookside Pl","Brookside Ranch Rd","Brookside Rd","Brookside Ter","Brookside Way",
            "Brookstone Cir","Brookstone Ct","Brooktree Ln","Brookvale Way","Brookvalley Avenue","Brookview Blvd",
            "Brookview Cir","Brookview Ct","Brookview Drive","Brookview Ln","Brookview Manor Dr","Brookview Rd",
            "Brookview Ter","Brookway St","Brookwillow Ave","Brookwood Boulevard","Brookwood Cir",
            "Brookwood Ct","Brookwood Dr","Brookwood Dr SE","Brookwood Pky","Brookwood Rd","Broom Rd",
            "Broome Blvd","Broome St","Broome Street","Broomfield Ct","Broomfield Rd","Broomstick Way",
            "Brophy Ave","Brophy Rd","Brothers Lane","Brotherton Ave","Broughton Dr","Broughton St","Brouillard Avenue",
            "Browb Dr","Brower Avenue","Brower Ct","Brower Ln","Browing Farm Rd","Browley Rd","Brown Ave",
            "Brown Bear Rd","Brown Church Rd","Brown Cir","Brown Court","Brown Ct","Brown Dr","Brown Hill Rd",
            "Brown Homes","Brown Island Street","Brown Line","Brown Ln","Brown Mtn Road","Brown Pl","Brown Rd",
            "Brown Rd Rd","Brown Road","Brown Springs Loop","Brown Square","Brown St","Brown Street",
            "Brown Subdivision Rd","Brown Tract Rd","Brown's Ln","Browndale Crescent","Browne Ct",
            "Brownell Dr","Brownell Rd","Brownell St SE","Brownes Meadow Road (Forest Route 3N92)",
            "Brownfield Rd","Browning Ave","Browning Ave N","Browning Ave NW","Browning Avenue","Browning Court",
            "Browning Ln","Browning Rd","Browning Rd 1","Browning Trail","Browning Way","Brownlee Rd",
            "Brownleigh Avenue","Brownridge Crescent","Brownrigg Rd","Browns Aly","Browns Corner Rd",
            "Browns Creek Rd","Browns Ferry Rd","Browns Gap Rd","Browns Line","Browns Ln","Browns Rocky Rd",
            "Browns Valley Rd","Brownsell Dr","Brownson St","Brownstone","Brownstone Ave","Brownstone Crescent",
            "Brownstone Ct","Brownstone Dr","Brownstone Lane","Brownwood Rd","Browside Avenue","Broxton Ln",
            "Brozville Rd","Bruce Ave","Bruce Avenue","Bruce Cir","Bruce Creek Drive","Bruce Ct","Bruce Dr",
            "Bruce Freeman","Bruce Ln","Bruce Rd","Bruce St","Bruce Street","Bruce Woodbury Beltway",
            "Brucedale Avenue","Brucedale Dr","Bruceville Rd","Bruck Ct","Bruckner Blvd","Bruckner Expressway",
            "Brugge Dr","Bruin Lake Shore Rd","Brule Ave","Brule Crescent","Brule Gardens","Brule Landing Rd",
            "Brule Rd","Brum St","Brumby Way","Brumm's Farm Rd","Brummell Road","Brumwell Street","Brunck Rd",
            "Brundidge St","Bruner Hill Rd","Bruner Ln","Brunetta Way","Brunetto Grv","Bruning Ave","Brunner Rd",
            "Bruno Ave","Bruno St","Bruns St","Brunson Rd","Brunswick Ave","Brunswick Avenue","Brunswick Dr",
            "Brunswick Pike","Brunswick Rd","Brunswick St","Brunswick Street","Bruntsfield Street",
            "Brury Ln","Brush Canyon Rd","Brush Creek Ct","Brush Creek Dr","Brush Creek Ln","Brush Hill Circle",
            "Brush Oak Ct","Brush Rd","Brush St","Brushville Rd","Brushwood Ave","Brushwood Rd","Brushy Camp Ridge Rd",
            "Brushy Creek Dr","Brushy Creek Ln","Brushy Creek Road","Brushy Creek Trl","Brushy Creek Way",
            "Brushy Mountain Rd","Brussel Rd","Bruster Dr","Brutus Ct","Brutus Mentz Townline Rd",
            "Bryan Ave","Bryan Avenue","Bryan Creek Rd","Bryan Ct","Bryan Dr","Bryan Rd","Bryan St","Bryan's Rd",
            "Bryann St","Bryant Ave","Bryant Avenue","Bryant Ct","Bryant Dr","Bryant Hill Rd","Bryant Lane",
            "Bryant Ln","Bryant Pl","Bryant Rd","Bryant Road","Bryant St","Bryant Street","Bryce Ave","Bryce Ct",
            "Bryce Rd","Brydon Lake Rd","Bryn Mawr Ave","Bryn Mawr Dr","Bryn Mawr Rd","Bryner Rd","Brynhurst Way",
            "Bryon Cir","Bryon Rd","Bryson","Bryson Ln","Bryson Road","Bryson's Cove Dr","Bryte Bend Rd",
            "Bubbling Springs Dr","Bubbling Wells Ln","Bubbling Wells Rd","Bubier Street","Buccaneer Blvd",
            "Buccaneer Dr","Buccaneer Way","Buccaneers Way","Buchan Ridge Rd","Buchanan Ave","Buchanan Ct",
            "Buchanan Dr","Buchanan Draw Rd","Buchanan Drive","Buchanan Pl","Buchanan Rd","Buchanan St",
            "Buchanan Street","Buchanon Ct","Buchanon Pennisula Rd","Buchner Ln","Buck","Buck Brook Rd",
            "Buck Brush Ln","Buck Canyon Rd","Buck Creek Rd","Buck Dr","Buck Hill Rd","Buck Island Dr",
            "Buck Ln","Buck Meadows Rd","Buck Mtn Rd","Buck Owens Blvd","Buck Pl","Buck Point Rd","Buck Pond Rd",
            "Buck Ranch","Buck Rd","Buck Run Rd","Buck St","Buck Street","Buck Trl","Buckalew Dr","Buckboard Ct",
            "Buckboard Dr","Buckboard Ln","Buckboard Trl","Buckboard Way","Buckeye Creek Rd","Buckeye Ct",
            "Buckeye Dr","Buckeye Park","Buckeye Rd","Buckeye Springs St","Buckeye Trail","Buckford Rd",
            "Buckhaven","Buckhead Dr","Buckhill Road","Buckhorn Ct","Buckhorn Dr","Buckhorn Ln","Buckhorn Rd",
            "Buckingham Cir","Buckingham Ct","Buckingham Dr","Buckingham Dr N","Buckingham Gardens Pky",
            "Buckingham Ln","Buckingham Pl","Buckingham Road","Buckingham Way","Buckius St","Buckle Ave",
            "Buckley Ln","Buckley Rd","Bucklin Rd","Bucklin Street","Buckman Springs Rd","Bucknell Ave",
            "Bucknell Ct","Bucknell Rd","Bucknell Trl","Buckner Dr","Buckridge Dr","Buckridge Rd","Bucks Green Road",
            "Bucks Hill Rd","Bucks Ln","Bucks Only Dr","Bucksaw Ridge Dr","Buckshutem Rd","Buckskin Ave",
            "Buckskin Dr","Buckskin Glen","Buckskin Ln","Buckskin Loop","Buckskin Ranch Dr","Buckskin Rd",
            "Buckskin Way","Buckthorn Rd","Buckthorne Canyon Rd","Bucktown Rd","Buckwash Rd","Buckwheat Ln",
            "Bucyrus Erie","Bud Ave","Bud Ct","Bud Lane","Bud Odom Rd","Bud Way","Budd Lake Rd","Budd St","Budding Ln",
            "Budding Ridge Rd","Buddy Dr","Buddy Rd","Buddy St","Budea Crescent","Budgell Terrace","Budlong Ave",
            "Budlong St","Budreau Avenue","Buelah","Buena Pl","Buena Point Ct","Buena Tierra Way","Buena Ventura Ct",
            "Buena Vista Ave","Buena Vista Ct","Buena Vista Dr","Buena Vista Dr SE","Buena Vista Pl",
            "Buena Vista Rd","Buenaventura Academy Rd","Buenos Dias","Buerkle Pl","Buerman Ave","Buff Rd",
            "Buffalo Ave","Buffalo Avenue","Buffalo Bill Ave","Buffalo Creek Dr","Buffalo Ct","Buffalo Dr",
            "Buffalo Grass Rd","Buffalo Mtn Rd","Buffalo Range Rd","Buffalo Rd","Buffalo River Cv",
            "Buffalo Road","Buffalo Skyway","Buffalo St","Buffalo Trl","Buffaloberry Ln","Buffet Ter",
            "Buffett Ter","Bufford Street","Bug Scuffle Rd","Buggy Whip Ln","Bugle Bluff Dr","Bugle Ct",
            "Bugle Ln","Bugle Trl","Bugtown Rd","Buhne Dr","Buida Ct","Buie Ct","Buirch Ln","Buist Ave","Buker St",
            "Bulfinch Drive","Bull Bridge Rd","Bull Creek Rd","Bull Creek Way","Bull Elk Ridge","Bull Gap Rd",
            "Bull Hill Rd","Bull Hill Road","Bull Mill Rd","Bull Mountain Rd","Bull Pine Dr","Bull Rd",
            "Bull Road","Bull Run","Bullard Ave","Bullard Dr","Bullard Rd","Bullat St","Bulldog Way","Bullens Lane",
            "Bullens Ln","Bullet Ln","Bullion Pl","Bullion Rd","Bullis Canyon Rd","Bullis Rd","Bullock County 130",
            "Bullock County 23","Bullock Dr","Bullock Drive","Bullring Ln","Bullskin Ridge Rd","Bullwhip Ct",
            "Bullwhip Rd","Bullwinkle Dr","Bully Choop Rd","Bulrush Rd","Buman Court","Bumble Bee Rd",
            "Bumblebee Cir","Bump Rd","Bumpus Rd","Bumpy Ln","Bumpy Rd","Bumstead Road","Bunarch Rd","Bunch St",
            "Bunchgrass Trail","Bundette St","Bundy Ave","Bundy Ln","Bundysburg Rd","Bunert Rd","Bungalow Ct",
            "Bungalow Dr","Bungalow Pl","Bungee Hill Connector","Bungy Rd","Bunker Ave","Bunker Hill Ave",
            "Bunker Hill Dr","Bunker Hill Rd","Bunker Hill Road","Bunker Hill Run","Bunker Lane","Bunker Place",
            "Bunker St","Bunkhouse Ct","Bunn Hill Rd","Bunnell Ct","Bunnell St","Bunnvale Rd","Bunting Bridge Rd",
            "Bunting Dr","Bunting Drive","Bunting Ln","Buoy St","Bur Clover Way","Bur Oak Avenue","Burbank Ave",
            "Burbank Dr","Burbank Ln","Burbank Rd","Burbank St","Burbka Lane Dr","Burch Blvd","Burch Rd",
            "Burch St","Burchard Ave","Burchell","Burchell Ct","Burcher Road","Burchfield Ave","Burchfield Spur",
            "Burd Ln","Burd St","Burda Ln","Burdak Rd","Burdeck Dr","Burden Ave","Burden Ln","Burdett Pl","Burdette Ct",
            "Burdick Rd","Burdock Ct","Bureau Rd","Bureau of Land Mgmt Rd 1037","Bureau of Land Mgmt Rd 1526",
            "Burgan Ave","Burgandy St","Burgar Street","Burgard Pl","Burgess Ct","Burgess Dr","Burgess Drive",
            "Burgess Pl","Burgess Rd","Burgess Road","Burgess St","Burghardt Street","Burgoon Rd","Burgoyne Street",
            "Burgundy S","Burgundy Ct","Burgundy Dr","Burgundy Ln","Burgundy Way","Burhamthorpe Road West",
            "Burhans Ave","Burke Dr","Burke Ln","Burke Pky","Burke Pl","Burke Rd","Burke St","Burkehaven Ter",
            "Burkett Ave","Burkhardt Ln","Burkle St","Burkston Place","Burl Ave","Burlando Dr","Burleigh Rd",
            "Burlew Pl","Burlew Rd","Burliegh Farm Rd","Burlingame Ave","Burlingame Rd","Burlington Ave",
            "Burlington Bristol Bridge","Burlington Ct","Burlington Jacksonville Rd","Burlington Northern Santa Fe R",
            "Burlington Pike","Burlington Ridge Rd","Burlington Road","Burlington St","Burlington Street",
            "Burlison Ln","Burlwood Court","Burlwood Ct","Burmese Ln W","Burnam Wood","Burnap Road Extension",
            "Burncoat Street","Burndean Court","Burnell Ave","Burner","Burner St","Burnet Ave","Burnet St",
            "Burnett Ave","Burnett Avenue","Burnett Brook Dr","Burnett Cir","Burnett Dr","Burnett Rd",
            "Burnett St","Burnett Street","Burnett Ter","Burnette Ct","Burney Pass Dr","Burnham Ave",
            "Burnham Ln","Burnham Parkway","Burnham Rd","Burnham Rd E","Burnham Road","Burnham Street",
            "Burnham Street N","Burnhamthorpe Crescent","Burnhamthorpe Road","Burnhamthorpe Road East",
            "Burnhamthorpe Road West","Burnhamthorpe Trail","Burning Tree Ct","Burning Tree Ln",
            "Burning Tree Rd","Burns Ave","Burns Boulevard","Burns Cir","Burns Hill Rd","Burns Lane N",
            "Burns Pl","Burns Point","Burns Rd","Burns Street","Burnside Ave","Burnside Avenue","Burnside Bend",
            "Burnside Dr","Burnside Line","Burnside Road","Burnt Bridge Ave","Burnt Hill Rd","Burnt Leaf Ln",
            "Burnt Log Crescent","Burnt Meadow Road","Burnt Oak Dr","Burnt Rail Rd","Burnt Ranch Dump Rd",
            "Burnt Sienna St","Burnt Tavern Rd","Burntwood Trl","Burnwell Street","Burpee St","Burr Ave",
            "Burr Avenue","Burr Oak Drive","Burr Pl","Burr Rd","Burr Road","Burr St","Burr Valley Rd","Burrage Ct",
            "Burres Ct","Burridge Cir","Burridoe Road","Burrill St","Burrington Hill Rd","Burrington Rd",
            "Burrito Creek Rd","Burro Canyon Range","Burro Cr Rd","Burro Ln","Burroughs Ave","Burroughs Pl",
            "Burroughs Place","Burroughs Point","Burroughs St","Burrow Trl","Burrows Hall Boulevard",
            "Burrows Rd","Burrstone Rd","Burrwood Dr","Bursera St","Burson St","Burst Ct","Bursthall Street",
            "Bursum Rd","Burt Ct","Burt Dr","Burt Hill Rd","Burt Lane","Burt Rd","Burt Springs Trailer Ct",
            "Burt St","Burten St","Burton Ave","Burton Ave SE","Burton Avenue","Burton Dr","Burton Heights Blvd",
            "Burton Hill Rd","Burton Pines Dr SE","Burton Rd","Burton St","Burton Street","Burtons Ct",
            "Burtwood Acres Rd","Burwash Road","Burwell Aly","Burwell Rd","Burwick Ln","Burwood Ave",
            "Burwood Ln","Bury Dr","Bus Rd","Busby Ave","Busby Grove Rd","Busby Ln","Busby Rd E","Busch Ln",
            "Busch St","Bush Dr","Bush Hill Rd","Bush Kill","Bush Lane","Bush Park","Bush Rd","Bush Road","Bush St",
            "Bush Street","Bushard Dr","Bushbury Drive","Bushcroft Grove","Bushkill Drive","Bushkill Ln",
            "Bushland Rd","Bushnell Ave","Bushy Hill Ln","Bushy Trl","Busiel St","Business Ave","Business Center Dr",
            "Business Park Dr","Business Rd","Busse St","Bussey Ln","Busti Ave","Busti-Sugar Grove Rd",
            "Bustos Dr","Bustos Way","Butano Cut Off","Butano State Park Rd","Butcher Ln","Butchers Ln",
            "Butchie Aly","Butchs Pl","Butler Ave","Butler Ave SE","Butler Avenue","Butler Branch Rd",
            "Butler Creek Rd","Butler Ct","Butler Dr","Butler Ln","Butler National Rd","Butler Place",
            "Butler Rd","Butler Rd SW","Butler Road","Butler St","Butler Street","Butler Ter","Butler Valley Ranch",
            "Butler Valley Rd","Butlers Walk","Butman Road","Buttahatchee Dr","Butte Ave","Butte Creek Rd",
            "Butte Oaks Rd","Butte St","Butte Valley Rd","Butte View Ct","Buttel Dr","Buttell Ave","Butter Cup Ln",
            "Butter Hill Rd","Butter Rd","Buttercreek Rd","Buttercup Ln","Buttercup Rd","Butterfield Cir",
            "Butterfield Estates","Butterfield Lake Rd","Butterfield Ln","Butterfield Rd","Butterfly",
            "Butterfly Ln","Buttermere Ln","Buttermilk Falls Rd","Buttermilk Rd","Butternut","Butternut Ave",
            "Butternut Boulevard","Butternut Creek Road","Butternut Creek St","Butternut Ct","Butternut Dr",
            "Butternut Ln","Butternut Rd","Butternut St","Butternut Ter","Butters Landing","Butterworth Avenue",
            "Butterworth Ct","Butterworths Bogs Rd","Butteview Pl","Buttles Rd","Button Ln","Button Rd",
            "Button Valley Rd","Buttonfield Road","Buttonshell Ln","Buttonwillow Dr","Buttonwood Ave",
            "Buttonwood Campground","Buttonwood Ct","Buttonwood Dr","Buttonwood Lane","Buttonwood Ln",
            "Buttonwood Pl","Buttonwood Rd","Buttonwood St","Buttonwood Ter","Buttonwood Turn","Buttonwood Xing",
            "Butts Ave","Butts Ln","Butts Pl","Butts Rd","Butts Rock Rd","Buttston Rd","Buttzville Rd","Buxton Ave",
            "Buxton Lane","Buxton Rd","Buzwell Corner Rd","Buzzards Glory Rd","Buzzell Gap","Buzzy Blvd",
            "Buzzy Ln","Byars Rd","Bybrook Drive","Byers Dr","Byers St","Bygone Dr","Byington Rd","Byland Abbey Ln",
            "Byland Road","Byler Dr","Byler Rd","Bylot Way","Byng Avenue","Byngmount Avenue","Bynner Dr",
            "Bypass Rd","Byram - Kingwood Rd","Byram Rd","Byrd Dr","Byrd Pl","Byrd St","Byrdee Way","Byrne Ln",
            "Byrnell Ln","Byrnes Ave","Byron Ave","Byron Avenue","Byron Blvd","Byron Dr","Byron St","Byron Street S",
            "Bystander Rd","Bywood Dr","Bywood Rd","C","C 41","C Ave","C Ave N","C Bar K Rd","C Dr NE","C J Rd","C K Clarke St",
            "C Morris Cain Pl","C R 126","C R 148","C R 15","C R 236","C R 302","C R 305","C R 32","C R 510","C R 514",
            "C R 515","C R 521","C R 522","C R 530","C R 534","C R 536","C R 54","C R 540","C R 541","C R 552","C R 555",
            "C R 569","C R 574","C R 586","C R 618","C R 624","C R 625","C R 633","C R 637","C R 657","C R 658","C R 659",
            "C R 701","C R 746","C R 83","C Rd","C S Ranch Rd","C St","C St Elvas Ave Aly","C Street","C T Access Rd",
            "C W Post Dr","C Wheaton Rd","C&C Dr","C-483 Rt Rd","C-50-F Camino de Gutierrez","C-56-A Corazon",
            "C-Drive N","C. Fred Johnson Memorial Highway","C0 Hwy 155","C1-033","C1-037","C1-058","C1-186",
            "C1-190","C1-192","C106","C119A","C2","C2-032","C3-011","C3-054","C3-066","C3-076","C3-077","C3-099","C3-100",
            "C3-111","C3-113","C3-115","C3-134","C3-152","C3-165","C3-169","C3-267","C4-018","C4-024","C4-025","C4-050",
            "C4-056","C406","C41","C42","C96","CA 14","CA 2 south","CA 204","CA 41","CA 47","CA 58","CA 60","CA 91","CA 99","CA-210 West onramp",
            "CA-57 North onramp","CA-60 West onramp","CALLE MARGARITA","CC Rd C002","CCC Rd","CHP Ofcr. John Bailey Mem. Fwy",
            "Caambridge Dr","Caballo de Fuerza Rd SE","Cabana Ct","Cabana Dr","Cabaret Dr","Cabazon St",
            "Cabello Dr","Caberfae Hwy","Cabernet Circle","Cabernet Ct","Cabernet Cv","Cabernet Dr","Cabernet Way",
            "Cabeza de Vaca Rd","Cabeza de Vasques Trl","Cabin","Cabin Ln","Cabin Rd","Cabin-Spur","Cabinda Dr",
            "Cabinhill Cir","Cable Ave","Cable Hill Rd","Cable Rd","Cable St","Cabot Blvd E","Cabot Rd",
            "Cabot Station Road","Cabot Street","Caboto Trail","Cabri Ln","Cabrillo Ave","Cabrillo Avenue",
            "Cabrillo Ct","Cabrillo Highway","Cabrillo Hwy","Cabrillo Ln","Cabrillo Plz","Cabrolet Dr",
            "Cachat Dr","Cache Peak","Cachet Ct","Cacilley Rd","Cactus Bloom Dr","Cactus Ct","Cactus Dr",
            "Cactus Flats Rd","Cactus Holly Ln","Cactus Ln","Cactus Point Ct","Cactus Ridge Ave","Cactus St",
            "Cactus Trl","Cactus Valley Rd","Cactus Wren Cir","Cactus Wren Ct","Cactusview Dr","Cadagan Ct",
            "Cadbury Ave NW","Cadbury Dr","Caddo Gap Rd","Caddo Pond","Caddo Rd","Caddo St","Caddy Dr","Caddy Rock Rd",
            "Caddy Row","Cadet Pl","Cadillac Avenue","Cadillac Blvd","Cadillac Cv","Cadillac Dr","Cadillac Pl",
            "Cadillac St","Cadiz Rd","Cadiz-Jewett Rd","Cadjaw Pond Rd","Cadle Ave","Cadogan Way","Cadorna Avenue",
            "Cadosia-Apex Rd","Cady Court","Cady Ln","Cady St","Caesar Ave","Caesar Avenue","Caesar Ct",
            "Caesar Pl","Cafferty Rd","Caffin Ct","Cagle Rd","Cagney","Cagua Dr SE","Cahaba Ave","Cahaba Dr SW",
            "Cahant Ave","Cahill Aly","Cahto Dr","Caila Dr","Cailey Anna Ln","Cain Ave","Cain Ln","Cain Rd",
            "Cains Rd","Cairn Blvd","Cairn Ct","Cairn Hill Rd","Cairngorm Rd","Cairns Drive","Cairo St",
            "Caistor Gainsboro Townline Road","Caistorville Road","Caitlin Ct","Caitlin Ln","Caitlin Park",
            "Cajon Ave","Cajon Ln","Cal Ln","Calabacillas Ct","Calabazas Boulevard","Calabria Dr","Calabrisi Rd",
            "Calaguiro Drive","Calais Court","Calais Street","Calais Way","Calamigos Rd","Calamine Rd",
            "Calamity Ln","Calanda Ave","Calanda St","Calariva Dr","Calas Ct","Calavera Pl","Calaveras Ave",
            "Calaveras Dr","Calaveras Rd","Calaveras River Bike Ph","Calcita Dr","Calcott Court","Caldari Road",
            "Caldbeck Avenue","Caldecott Lane","Caldeno Ave","Calder Place","Calder St","Calderon Rd",
            "Calderstone Crescent","Calderwood Ave","Calderwood Avenue","Caldwell Ave","Caldwell Dr",
            "Caldwell Road","Caldwell St","Caldwell Ter","Caleandra St","Caleb Ct","Caleb Ln","Caleb Street",
            "Caledonia Park Road","Caledonia Road","Caledonia Street","Calef Hwy","Calenda Dr","Calesa Ct",
            "Caleta Ct","Calf Canyon Rd","Calfas Rd","Calgary Ave","Calgary Cir","Calgary Ct","Calgary Dr",
            "Calhoun Ave","Calhoun Rd","Calhoun St","Calhoun Street","Cali Ave","Calias Dr","Calico","Calico Crescent",
            "Calico Ct","Calico Dr","Calico Place","Calico Rd","Calico Rock Ct","Caliente Ave","Caliente Bodfish Rd",
            "Caliente Creek Rd","Caliente Ct","Caliente Rd","Califa St","California Aly","California Ave",
            "California Blvd","California Dr","California Holly St","California Oak St","California Pines Blvd",
            "California Pl","California Rd","California St","California State Route 237 (West)",
            "California State Route 85 (South)","Calistoga Road","Calistoga St","Calkins Dr","Call Rd",
            "Call Way","Calla Ave","Calla Lily Ct","Calla Terrace","Callaghan Rapids Road","Callaghan Road",
            "Callaghan St","Callahan Ct","Callan Ln","Callan St","Callander Cir","Callayomi St","Calle 2",
            "Calle 7a","Calle Acueducto","Calle Adamo","Calle Al Rumbo","Calle Alamo","Calle Alcazar",
            "Calle Alegre NW","Calle Alta","Calle Amistad Ln","Calle Avila","Calle Azul","Calle Barcelona",
            "Calle Bello","Calle Cabito","Calle Caborca","Calle Callado","Calle Canon","Calle Cantando",
            "Calle Carla","Calle Carranza","Calle Cascada","Calle Cataldo","Calle Chanate","Calle Chinquito Rd",
            "Calle Chiquta","Calle Colima","Calle Converse","Calle Corral de Piedra","Calle Corte",
            "Calle Creosota","Calle Cuarta","Calle Cuervo","Calle Don Rodrigo","Calle Empalme","Calle Entrada",
            "Calle Entradero","Calle Escuela Vieja","Calle Espejo","Calle Espirito","Calle Feliz",
            "Calle Francesca","Calle Fuego","Calle Galvez","Calle Garcia","Calle Gomez","Calle Hernandez Rd",
            "Calle Jardin","Calle Juanito","Calle Junio","Calle Ladera","Calle Las Brisas","Calle Lechuga",
            "Calle Limon","Calle Linda","Calle Liseta","Calle Los Bosque","Calle Luna","Calle Maclovio Herrera",
            "Calle Marina","Calle Mazatan","Calle Mecedora","Calle Merona","Calle Montalvo Cir","Calle Musica",
            "Calle Naranjo","Calle Neil","Calle Nevada","Calle Noria","Calle Ocana","Calle Pagosa","Calle Paloma",
            "Calle Parral","Calle Patron","Calle Paul","Calle Pequeno","Calle Pino","Calle Ponca","Calle Riscoso",
            "Calle Ritari","Calle Rivera","Calle Roble","Calle Rosa","Calle Sagrada","Calle Sahuaro",
            "Calle San Luis Potosi","Calle San Miguel","Calle Santa Cesilia","Calle Serena","Calle Sndr",
            "Calle Taraddei","Calle Tepic","Calle Toledo","Calle Tolosa","Calle Trucksess","Calle Unida",
            "Calle Vado","Calle Varada","Calle Verano","Calle Vibora","Calle Vista Way","Calle de Cambio Rd",
            "Calle de Campo","Calle de Las Corazones","Calle de Las Familias Ct","Calle de Los Desca",
            "Calle de Los Helechos","Calle de Los Suei","Calle de Ora","Calle de Ricardo","Calle de San Albino",
            "Calle de Sonora","Calle de Talar","Calle de Vecinos","Calle de Vega","Calle de Zamora",
            "Calle de el Cortez","Calle de la Burrita","Calle de la Entrada","Calle del Cielo",
            "Calle del Gecko","Calle del Grajo","Calle del Norte","Calle del Oro","Calle del Pajarito",
            "Calle del Rio Norte","Calle del Rito","Calle del Sol","Calle del Sol St","Calle del Sueno",
            "Calle del Sur","Calle el Fuente","Calle la Mesa","Callecita Membreno","Calli St","Calliandra Rd",
            "Callisto Ln","Callisto Rd NW","Callowhill St","Calls Hollow Rd","Calm Court","Calm Lake Cir",
            "Calma Rd","Calmhill Dr","Calmoor Way","Calneva Ln","Calnino Tres Ave","Calobar Ln","Calomel",
            "Calora Court","Calpine Co Road","Calsilco Ave","Calsite Ct","Calstock Drive","Calston Ave",
            "Calumet Loop","Calumet St","Calumet Street","Calusa Trl","Calvary Ave","Calverley Trail",
            "Calvert Rd","Calvert St","Calvery Ct","Calvin","Calvin Ave","Calvin Ave SE","Calvin Cir S",
            "Calvin Ct","Calvin Rd","Calvin Rogers Ln","Calvin St","Calvin Street","Calvington Drive",
            "Calypso","Calyx Ln","Calz. Rodolfo Sánchez Taboada","Calzada Ave","Calzada Ct","Calzona Blvd",
            "Cam-Hay Dr","Camaho Pl","Camarco Cir","Camarco Road","Camardo Driveway","Camarilla Ave",
            "Camarillo Ave","Camarillo Dr","Camballeria Dr","Cambay St","Cambell Ave","Camberley Court",
            "Camberra Dr","Cambray Road","Cambria Dr","Cambria Drive","Cambria Rd","Cambridge Ave","Cambridge Avenue",
            "Cambridge Cir","Cambridge Commons","Cambridge Crescent","Cambridge Ct","Cambridge Ct S",
            "Cambridge Dr","Cambridge Drive","Cambridge East","Cambridge Heights Way","Cambridge Ln",
            "Cambridge Place","Cambridge Rd","Cambridge St NE","Cambridge Street","Cambridge Street N",
            "Cambridge Street S","Cambridge Way","Cambridgepark Drive","Cambridgeport Rd","Cambrook Ln",
            "Camby Chase Rd","Camden Ave","Camden Byp","Camden Ct","Camden Drive","Camden Oak Ct","Camden Pl",
            "Camden Rose Ct","Camden St","Camden Street","Camden Way","Camel Point Dr","Camel St","Camel Tr Rd",
            "Camel Trl Rd","Camelback Rd","Camelia Cir","Camelia Ct","Camelia Dr","Camelia River Way",
            "Camelia Trl","Camellia Ave","Camellia Ct","Camellia Dr","Camellia Ln","Camellia St","Camelot Court",
            "Camelot Ct","Camelot Dr","Camelot Pl","Camelot Rd","Camelot Way","Cameo Cir","Cameo Crst","Cameo Ct",
            "Cameo Ln","Cameo St","Camera Way","Camero Dr","Cameron Ave","Cameron Avenue","Cameron Ct","Cameron Dr",
            "Cameron Glen Boulevard","Cameron Hills Ct","Cameron Rd","Cameron Road","Cameron St","Cameron Street",
            "Camfield Ct","Camile Ct","Camilia St","Camilla Crescent","Camilla Rd","Camille Dr","Camille Ln",
            "Camillo Dr","Camillo Way","Caminito Badalona","Caminito Clavo","Caminito Cuarzo","Caminito Davila",
            "Caminito Flecha","Caminito Ladera","Caminito Luisito","Caminito Madrigal","Caminito Pintoresco",
            "Caminito Prado","Caminito Propico","Caminito Salado","Caminito Secoya","Caminito Tamborrel",
            "Caminito Tierra","Caminito Tulipan","Caminito Volar","Camino Aguila","Camino Alameda",
            "Camino Alameda SW","Camino Algarve","Camino Andalusian","Camino Arroyo","Camino Caluroso",
            "Camino Casa Verde","Camino Castillo","Camino Colorado","Camino Conejo","Camino Contigo",
            "Camino Ct","Camino Cumbre","Camino Derecho","Camino Drive","Camino Eldorado","Camino Encinas",
            "Camino Hierro","Camino Lacouague","Camino Largo","Camino Las Colinas Verde","Camino Loma Alta",
            "Camino Loma Verde Ave","Camino Merano","Camino Monte Vista","Camino Morro","Camino Nuevo Mejico",
            "Camino Oro","Camino Pepita","Camino Pescadero","Camino Plz","Camino Real","Camino Ruiz",
            "Camino San Ignacio Rd","Camino San Miguel","Camino Santa Fe","Camino Santiago","Camino Sin Buelta",
            "Camino Sobrante","Camino Uno SW","Camino Vista Hermosa","Camino Vista Linda","Camino Yrisarri",
            "Camino de Abajo","Camino de Buena Vida","Camino de Constancia","Camino de Delores",
            "Camino de Herrera","Camino de Lago","Camino de Las Brisas","Camino de Pavos","Camino de Valle",
            "Camino de Vida","Camino de Viento Rd","Camino de Vivir","Camino de la Finca","Camino de la Vista Dr",
            "Camino del Canon","Camino del Charro","Camino del Corazon","Camino del Coronado","Camino del Feliz",
            "Camino del Gallo","Camino del Lago Dr","Camino del Molin","Camino del Norte","Camino del Pajaro",
            "Camino del Pilar","Camino del Pueblo","Camino del Rincon Colorado","Camino del Rosario",
            "Camino del Santo Pky","Camino del Sol","Camino del Sol Dr","Camino del Torreon","Camino la Llorona",
            "Camino la Paz","Camman Dr","Cammati-Shandon Rd","Cammel St","Camnel Pl","Camnod Way","Camp",
            "Camp 23 Rd","Camp 9 Rd","Camp Allamuchy Rd","Camp Ave","Camp Bal Pl","Camp Dr","Camp Eagle Rd",
            "Camp Edge Rd","Camp Farnsworth Rd","Camp Ground Rd","Camp Hiawatha Rd","Camp Hill Rd",
            "Camp Joseph Robinson","Camp Karefree Rd","Camp Lane","Camp Ln","Camp Lou Henry Hover Rd",
            "Camp Madron Rd","Camp Nine Rd","Camp Pharsalia Corr Facility","Camp Pl","Camp Poyntelle",
            "Camp Rd","Camp Rd 4","Camp Rice Point Rd","Camp Road","Camp Road 3","Camp Rock Rd","Camp Run",
            "Camp Six Rd","Camp Smith","Camp St","Camp Street","Camp Talool Rd","Camp Ten Rd","Camp Three Rd",
            "Camp Two Ten Mile Rd","Camp Washington Rd","Camp Winaki Rd","Campana Rd","Campbell Ave",
            "Campbell Avenue","Campbell Blvd","Campbell Ct","Campbell Flats Rd","Campbell Hill Rd",
            "Campbell Ln","Campbell Pl","Campbell Rd","Campbell Ridge Rd","Campbell St","Campcarr Rd",
            "Campeche St","Campell Ave","Camper Dr","Camperdown Ave","Campers Ln","Campground Rd","Campground Road",
            "Camphor Way","Campillos","Campingtons Ridge Rd","Campion Rd","Campo Nuevo Dr","Campo Rd",
            "Campos Rd","Camptonville Rd","Camptown Rd","Campus Dr","Campus Dr W","Campus Hill","Campus Ln",
            "Campus Loop Rd","Campus Pky","Campus View St","Campus Way","Campwood Ct","Camroden Rd","Camron Ave",
            "Camrose Drive","Can Bon Rd","Cana Ct","Cana Rd","Canaan Ct","Canaan Rd","Canaan Southfield Road",
            "Canada Goose Dr","Canada Hill Rd","Canada Lane","Canada Rd","Canada Road","Canada Run Rd",
            "Canada St","Canada Street","Canada de Los Alamos Rd SE","Canada's Wonderland Drive",
            "Canadian Road","Canadian Side","Canadice Hill Rd","Canal Access Rd","Canal Bank Road",
            "Canal Bank Street","Canal Cir","Canal Dr","Canal Ln","Canal Rd","Canal Road","Canal St","Canal St W",
            "Canal Street","Canal Street E","Canal View Rd","Canal Woods","Canal de la Mancha","Canandaigua St",
            "Canard Ave","Canarios Ct","Canary Ct","Canary Cv E","Canary Cv W","Canary Ln","Canboro Road",
            "Canborough Road","Canby Ave","Canby Rd","Cancelar Dr","Cancun Rd","Cancun St","Candaleria St",
            "Candelaria Dr","Candelaria Rd","Candelaria St","Candeleras St","Candia Rd","Candia Rd Rd",
            "Candia Road","Candia St","Candice Ave","Candida Rd","Candleberry Lane","Candlebrook Crescent",
            "Candlelight Ct","Candlelight Drive","Candlelight Ln","Candlestick Ave NE","Candlestick Cir",
            "Candleway Ct","Candlewick Ct","Candlewick Ln","Candlewood Ct","Candlewood Ct NE","Candlewood Dr",
            "Candlewood Gardens","Candlewood Ln","Candlewood Park","Candlewood Rd","Candlewood Ter",
            "Candlewyck Dr","Candy Apple Ln","Candy Ct NW","Candy Ct SW","Candy Ln","Cane Creek Rd","Cane Hill St",
            "Cane Peak Ct","Cane Rd","Cane Spring Rd","Canet Rd","Caney Creek Rd","Caney Creek Wildlife Managemen",
            "Caney Ln","Canfield","Canfield Ct","Canfield Dr","Canfield Lane","Canfield Ln","Canfield Rd",
            "Canfield St","Canham Crescent","Canice Street","Canidae Ct","Caniles Ln","Canisteo River Rd",
            "Canisteo St","Canku Rd","Canlish Road","Cannery Hill Rd","Cannes St","Cannet Ln","Canney Rd",
            "Canning Avenue","Canning Factory Rd","Canning Road","Cannock Dr","Cannock St","Cannon Beach St",
            "Cannon Blvd","Cannon Cir","Cannon Hill Road Extension","Cannon Rd","Cannon Road","Cannon St",
            "Cannon View Rd","Cannons Campground Rd","Canoas Garden Ave","Canoe Ave","Canoe Lake Road",
            "Canoe Run Rd","Canole Stick","Canon Rd","Canoncito Ave","Canoncito Pl NE","Canones Pl","Canongate Trail",
            "Canonicus Street","Canopy Ct","Cantante","Cantar Ct","Cantara St","Cantebury Ct","Cantebury Dr",
            "Cantel Ct","Cantel Way","Cantelope Ct","Cantera Run","Cantera St","Canterberry Shore Dr",
            "Canterbury","Canterbury Cir","Canterbury Circle","Canterbury Ct","Canterbury Dr","Canterbury Drive",
            "Canterbury Forest Rd","Canterbury Ln","Canterbury Rd","Canterbury St","Canterbury Wood Rd",
            "Cantertrot Court","Cantlay St","Canto Ct","Canton Court","Canton Ct","Canton Rd","Canton Rest Area",
            "Canton St","Canton Street Road","Cantor Ave","Cantrece Ln","Cantrell Rd","Cantwell Ave SW",
            "Cantwell Ranch Rd","Canuck Trail","Canvas Back Dr","Canvas Ct","Canvasback Dr","Canvasback Lane",
            "Canyon","Canyon Bluff","Canyon Creek Rd","Canyon Crest Dr","Canyon Ct","Canyon Dr","Canyon Hill Way",
            "Canyon Ln","Canyon Oak Dr","Canyon Oaks Ct","Canyon Oaks Dr","Canyon Point Ln","Canyon Rd",
            "Canyon Rim Pl","Canyon Road","Canyon Six Rd","Canyon Terrace Dr","Canyon Trail Way","Canyon Trl",
            "Canyon View Cir","Canyon View Dr","Canyon View Forest Rd","Canyon View Rd","Canyon View Way",
            "Canyon Vista","Canyonback Rd","Canyonwood Ln","Caoba Ct","Capania Ct","Capdello St","Cape Circle",
            "Cape Cod Ave","Cape Cod Rail Trail","Cape Ct","Cape Dr","Cape Hope Way","Cape Horn Rd","Cape Horn Rd E",
            "Cape Island Ct","Cape May Ave","Cape May Dr","Cape May St","Cape Sand Dr","Cape Spencer St",
            "Cape Street","Capece Rd","Capella Way","Capellan St","Capera Drive","Capeview Street","Capewell Drive",
            "Capewood Ct","Capistrano Ave","Capistrano Ct","Capistrano Dr","Capital","Capital Dr","Capital Ln",
            "Capitan Cir","Capitan Dr NE","Capitol","Capitol Ave","Capitol Blvd","Capitol City Fwy","Capitol Ct",
            "Capitol Dr","Capitol Hill Ave","Capitol Hills Pky","Capitol St","Capitola Ave","Capitola Dr",
            "Capitola Rd","Capner Court","Capps Crossing Rd","Capps Dr","Capps Rd","Capra Ct NE","Capral Ln",
            "Capri Cir","Capri Dr","Capri Street","Capri Ter","Capri Way","Caprice Ave NW","Capricorn Dr",
            "Capron Rd","Capshire Dr","Capstan Cir","Capt Shankey Dr","Captain Bailey Road","Captain Cook Cir",
            "Captain Dr","Captain Lewis Dr","Captain Linnell Road","Captain Neville Dr","Captains Corridor",
            "Captains Cove Lane","Captains Lane","Captains Walk","Captains Way","Captivation Ct","Capulin Rd NE",
            "Car Barn Ct","Car St","Car-Ley Ct","Cara Ct","Cara Dr","Cara Ln","Cara Mia Way","Cara Way","Caracas Ct",
            "Caradonna Crescent","Caramel Dr","Caranel Cir","Carasaljo Dr","Carat Ave","Caravan St","Caravan Village Mhp",
            "Caravelle Dr","Caraway Ct","Caraway Dr","Caraway Drive","Carbajal Rd","Carbary Dr","Carberry Dr",
            "Carberry Ln","Carbon Hill Buchtel Rd","Carbon St","Carbow St","Card Ln","Card Rd","Card St",
            "Cardell Avenue","Carden Dr","Cardene Ct","Cardif Rd","Cardiff","Cardiff Court","Cardiff Ct",
            "Cardiff Ln Extended SE","Cardiff St","Cardigan Ct","Cardigan Dr","Cardigan Rd","Cardin Cir",
            "Cardinal Ave","Cardinal Ave NW","Cardinal Cir","Cardinal Circle","Cardinal Corner","Cardinal Ct",
            "Cardinal Dr","Cardinal Flower Dr","Cardinal Ln","Cardinal Rd","Cardinal St","Cardinal Street",
            "Cardinal Ter","Cardinal View Ave","Cardinal Way","Carding Mill Ct","Cardnal Rd","Cardon",
            "Cardon St","Cardona St","Cardy Place","Carefree Dr","Carefree Hwy","Careful Ave","Carey Ave",
            "Carey Avenue","Carey Ct","Carey Dr","Carey Hill","Carey Ln","Carey Rd","Carey St","Carey Street",
            "Carhart St","Caribbean Ct","Caribou Rd","Cariglia Trail","Carillon Dr","Carini Villa St",
            "Carino Cir","Cario Pl","Carisbrooke Court","Carl Dr","Carl Jones Rd","Carl Landi Circle",
            "Carl Laux Rd","Carl Ln","Carl Moren Rd","Carl St","Carla Ave","Carla Blvd","Carla Ln","Carla St",
            "Carland Rd","Carlann Ln","Carlaw Avenue","Carlen Ct","Carleton Acres S","Carleton Aly",
            "Carleton Court","Carleton Island Rd 2","Carleton Lake Dr","Carleton Pl","Carleton Rd",
            "Carleton Street N","Carleton Terrace","Carleton West Rd","Carley Crescent","Carley Rd",
            "Carlie St","Carlin Ct","Carlingford Ln","Carlisa Ave","Carlisie Aly","Carlisle Ave","Carlisle Ave SE",
            "Carlisle Blvd","Carlisle Blvd NE","Carlisle Ct","Carlisle Ln","Carlisle Rd","Carlisle Road",
            "Carlisle St","Carlisle Way","Carlita Dr","Carlos Ave","Carlos Rd SW","Carlotta Way","Carlow Dr",
            "Carls Ave","Carls Lane","Carlsbad Blvd","Carlsbad Dr","Carlsberg Place","Carlsbrook Ln",
            "Carlsen Dr","Carlson Camp Rd","Carlson Court","Carlson Ct","Carlson Dr","Carlson Drive",
            "Carlson Ln","Carlson Rd","Carlson St","Carlton Ave","Carlton Avenue","Carlton Ct","Carlton Dr",
            "Carlton Pl","Carlton Rd","Carlton Road","Carlton St","Carlton Ter","Carlton Way","Carly Dr",
            "Carlyle Ct","Carlyle Street","Carlyon Line","Carlysle St","Carmacks Way","Carman St","Carmel Ave",
            "Carmel Ct","Carmel Dr","Carmel Ln","Carmel Rancho Blvd","Carmel St","Carmel Way","Carmelina Dr",
            "Carmelita Dr","Carmella Dr","Carmen Ave","Carmen Avenue","Carmen Dr","Carmen Pl","Carmen St",
            "Carmichael Ave","Carmichael Crescent","Carmichael Dr","Carmill Dr","Carmine Street","Carmino Rd",
            "Carmona Ave","Carna Road","Carnaby Cir","Carnagie Bay Rd","Carnation Cir","Carnation Ct",
            "Carnation Dr","Carnation Ter S","Carncross Rd","Carneer Ave","Carnegie Ave","Carnegie Beach Road",
            "Carnegie Center Blvd","Carnegie Ct","Carnegie Ridge","Carnegie Road","Carnelian Rd","Carnelian St",
            "Carnelian St NE","Carnell St","Carner","Carnes Cir","Carney Dr","Carney Ln","Carnforth Dr",
            "Carnforth Drive","Carnitas St","Carnival","Carnival Dr","Carnley St","Carnwath Ct","Carnwith Drive W",
            "Carob Dr","Carob Ln","Carob St","Carob Way","Carol","Carol Ann Ct","Carol Ann Way","Carol Ave",
            "Carol Avenue","Carol Blvd","Carol Ct","Carol Dr","Carol Ln","Carol Ln SE","Carol Pl","Carol Rd",
            "Carol Road","Carol Run N","Carol St","Carol St NE","Carole Dr","Carole Ln","Carolier Ln","Carolina Ave",
            "Carolina Ct","Carolina Dr","Carolina Nooseneck Rd","Carolina Rd","Carolina St","Carolina Trail",
            "Caroline Ave","Caroline Avenue","Caroline Cir","Caroline Ct","Caroline Dr","Caroline Foster Ct",
            "Caroline St","Caroline Street","Carolyn Ave","Carolyn Ct","Carolyn Dr","Carolyn Pl","Carolyn Rd",
            "Carolyn St","Carolyn Street","Carolyn Way","Carousel Pl","Carp Elgin Rd","Carpenter Ave",
            "Carpenter Avenue","Carpenter Dr","Carpenter Ln","Carpenter Pl","Carpenter Rd","Carpenter Ridge",
            "Carpenter St","Carpenteria Rd","Carpenters Circle","Carquinez Avenue","Carr Bailey Rd",
            "Carr Corners Rd","Carr Ct W","Carr Dr","Carr Ln","Carr Pl","Carr Rd","Carr Road","Carr St","Carr Street",
            "Carraige Drive","Carranza Rd","Carrar Dr","Carrasco Rd","Carraway Crescent - Morrisburg",
            "Carre Dr E","Carrell Loop","Carrera Boulevard","Carrera del Darro","Carriage Cir","Carriage Court",
            "Carriage Ct","Carriage Dr","Carriage Drive","Carriage Hill Dr","Carriage Hill Road","Carriage House Rd",
            "Carriage Lamp Way","Carriage Lane","Carriage Ln","Carriage Oaks Way","Carriage Park Dr",
            "Carriage Pky","Carriage Road","Carriage Shop Road","Carrick Avenue","Carrick Cir","Carrick Dr",
            "Carrick Ln","Carrie Hills Ave","Carrie Lees Way","Carrie Pl SE","Carrie Rd","Carrier Aly",
            "Carrier Cir","Carrier Drive","Carrier Rd","Carrigan Cmn","Carrillo Street","Carrington Drive",
            "Carrington Lane","Carrol Ct","Carrol Rd","Carrol St","Carroll Ave","Carroll Avenue","Carroll Canal Ct",
            "Carroll Creek Rd","Carroll Ct","Carroll Cv W","Carroll Ln","Carroll Park E","Carroll Pl",
            "Carroll St","Carroll Street","Carrollwood Dr","Carron Avenue","Carruthers Lane","Carse Dr",
            "Carsean Ct","Carson Ave","Carson Ct","Carson Cv","Carson Dr","Carson Rd","Carson Road","Carson St",
            "Carson Street","Carson Way","Carsons Cv","Carsonville Rd","Carsphairn Ln","Carstairs Cir",
            "Carswell Ave","Carswell Avenue","Carta Luna St","Cartan Ln","Cartegena Rd NE","Carter Ave",
            "Carter Cir","Carter Ct","Carter Dr","Carter Ln","Carter Notch Rd","Carter Rd","Carter Road",
            "Carter Scott Pl","Carter St","Carteret Rd","Carters Cutoff","Carters Gin Rd","Carters Grove",
            "Carthage Rd","Carthage St","Carthay Cir","Cartier Court","Cartier St","Cartlidge Ave","Cartmel Drive",
            "Carton St","Cartpata Ct","Cartpath Pl","Cartwright Avenue","Cartwright East Quarter Line Road",
            "Cartwright Rd","Cartwright Road","Cartwright Way","Caruso Ave","Caruso Ct","Caruthers St",
            "Carved Canyon Ln","Carvel Ave","Carver Ave","Carver Circle","Carver Lane","Carver Pl","Carver Rd",
            "Carver Road","Carver Street","Carveth Crescent","Carvin Ave","Carwin Crescent","Cary Ave",
            "Cary Court","Cary Ln","Carza St","Casa Alegre","Casa Bonita","Casa Bonita Ct","Casa Cross",
            "Casa Ct","Casa Diablo Mine Cutoff Rd","Casa Dr","Casa Grande Ave","Casa Grande Dr","Casa Grande Ln",
            "Casa Hermosa Dr NE","Casa Loma Rd","Casa Montana Ct","Casa Nova Drive","Casa Rd","Casa Real Ct",
            "Casa Redonda Dr","Casa St","Casa Vegas St","Casa Villa","Casa Vista Dr","Casa del Oro Way",
            "Casa del Oso NE","Casa del Rey Ct","Casa del Sol","Casaba Ave","Casablanca Ln","Casale Ct NW",
            "Casale Rd","Casarow Dr","Casas Belles","Casavan Avenue","Casazza Dr","Casazza Pl","Casazza Ranch Ln",
            "Cascadas Cir","Cascade","Cascade Ave","Cascade Canyon Dr","Cascade Ct","Cascade Dr","Cascade Falls Ave",
            "Cascade Hills-Ridge SE","Cascade Ln","Cascade Rd","Cascade St","Cascade Way","Cascades Ave",
            "Cascades Ter","Cascadita Ter","Casci Ridge Rd","Casco Rd","Case Ave","Case Rd","Case Street",
            "Case Ter","Casentini Dr","Casentini St","Casern Ave NW","Caseville Ct","Casey Ct","Casey Cv",
            "Casey Dr","Casey Rd","Casey St","Casey Street","Cash Ave","Cash Cir","Cash St","Cashel Ct","Cashmere Ln",
            "Casimir St","Casimiro Rd","Casino Way","Casitas del Este Ln","Casmere Rd","Cason Dr","Caspar Orchard Rd",
            "Caspar Point Rd","Casper Rd","Caspian Ave","Caspian Dr","Caspio Ct","Cass Avenue","Cass Cove Rd",
            "Cass Mill Rd","Cass Park Access Rd","Cass St","Cassady Ln","Cassandra Boulevard","Cassandra Dr",
            "Cassandra Drive","Cassandra Ln","Cassanna Way","Cassel Fall River Rd","Cassella Rd","Cassellville Lane",
            "Casserly Rd","Cassia Ct","Cassidy Dr","Cassidy Pl","Cassidy Rd","Cassie Dr","Cassin Pl N","Cassin Pl S",
            "Cassio Rd","Casslebury Ln","Casswell Cir NW","Castalia St","Castan Avenue","Castanada St SW",
            "Castano Way","Castelin Ave","Castello Dr","Castello Way","Casterton Avenue","Castex St",
            "Castile Ave","Castile St NW","Castillo","Castillo Dr","Castings","Castle Bay Dr","Castle Canyon Ave",
            "Castle Creek Rd","Castle Crest Ct","Castle Crest Dr","Castle Ct","Castle Dr","Castle Gardens Rd",
            "Castle Gate Way","Castle Heights Ave","Castle Hill Crescent","Castle Hill Drive","Castle Park Ct",
            "Castle Peak Rd","Castle Pines Dr","Castle Pl","Castle Point Ter","Castle Rd","Castle Rd NW",
            "Castle Ridge Dr","Castle Road","Castle Rock Ct","Castle Rock Ln","Castle Rock Rd","Castle St",
            "Castle Street","Castle View Avenue","Castle View Way","Castle Way","Castlebay Ln","Castleberry Rd",
            "Castleberry Rd W","Castlebuono Ave","Castlefinn Ln","Castlehill Road","Castleknock Road",
            "Castleman Ln","Castlemore Avenue","Castleridge Drive","Castlerock Ln","Castlerock Rd",
            "Castleton Ct","Castleton Dr","Castleton Ln","Castleton Rd","Castleton St","Castleview Drive",
            "Castlewall Ave","Castlewood Dr","Casto Blvd","Caston Rd","Castor Crescent","Castor Rd","Castpa Pl",
            "Castro St","Castro Valley Fwy","Castulo Ln","Casual Dr","Casual Way","Casuga Ct","Caswell Ct",
            "Caswell Ln","Caswell Rd","Caswell St","Caswell Street","Cat Claw Rd","Cat Deakle Rd","Cat Holler Rd",
            "Cat Hollow Rd","Catalda Court","Catalina Ave","Catalina Crescent","Catalina Ct","Catalina Dr",
            "Catalina Harbor St","Catalina Way","Cataline Ave","Catalonia Ave; Paseo Miramar; Resolano Dr",
            "Catalpa Ave","Catalpa Dr","Catalpa Lane","Catalpa Ln","Catalpa Pl","Catalpa Rd","Catalpa St",
            "Catalpa Way","Catamaran Dr","Catamount St","Cataract Street","Cataraqui Woods Drive",
            "Catavee Campground Rd","Catawba Ave","Catawba Ct","Catawba Dr","Catchacoma Court","Cater Street",
            "Catering Road","Catfish Rd","Catharine Street","Cathcart Crescent","Cathedral Bluffs Drive",
            "Cathedral Dr","Cathedral Place","Cathedral Ridge St","Cathedral Road","Cathedral Stairs Ct",
            "Cathedral Vista Ln","Catherine Ave","Catherine Cir","Catherine Ct","Catherine Pl","Catherine St",
            "Catherine Street","Catherine Street W","Cathmich Ct","Cathy Ave","Cathy Cir","Cathy Crescent",
            "Cathy Ct","Cathy Dr","Cathy Ln","Catkin Cir","Catlin Ave","Catlin Dr","Catlin Estate Rd","Catlin Rd",
            "Cato Ct","Catoe Rd","Caton Center Cross Rd","Catron Co Rd A009","Catron Co Rd A016","Cats Eye Dr",
            "Catskill Scenic Trail","Catt Co Rd 6","Cattail Court","Cattail Ct","Cattail Loop","Cattaragus Dr",
            "Cattaraugus Ave","Cattier Rd","Catting Dr","Cattle Branch Ct","Cattle Dr","Cattle Rd","Cattlemans Cv",
            "Cattlemen Rd","Caufield Ave","Caughlin Rd","Caulfield Ct","Causeway Rd","Causeway Road",
            "Causeway Road N","Cavalcade Ct","Cavalier Country Rd","Cavalier Ct","Cavalier Dr","Cavalier Ln",
            "Cavallo Dr","Cavalry Dr E","Cavan Street","Cavanaugh St","Cavataio Rd","Cavco Ln","Cave City Rd",
            "Cave Rd","Cave Valley Rd","Cavedale Rd","Cavell Avenue","Caverly Court","Caverns Rd","Caves Road",
            "Cavett Dr NW","Cawelo Extended","Cawthra Rd","Cawthra Road","Caxton Ln","Cayenne Creek Ct",
            "Cayetano Ct","Caylan Cv","Caylor St","Cayman Way","Cayton Rd","Cayuga Ave","Cayuga Blvd","Cayuga Lake State Park",
            "Cayuga Ln","Cayuga Rd","Cayuga St","Cayuga Street W","Cayuga Trl","Cayuga Way","Cayuse St",
            "Cayuta St","Cazares Cir","Cazdena Ln","Cazorla Ave","Cbtsp Fire Road","Cea Dag Cir","Ceanothus",
            "Cebola Rd","Cebu Ct","Cecelia Ave","Cecelia Ct","Cecil Ave","Cecil Brunner Dr","Cecil Keane Ln",
            "Cecil Rd","Cecil Smith Rd","Cecil St","Cecil Williamson Rd","Cecile","Cecilia Cir","Cecilia Ct",
            "Cecilia St","Cecilville Rd","Cecina Ave","Cecylia Court","Cedar","Cedar Aly","Cedar Ave","Cedar Avenue",
            "Cedar Bend Dr","Cedar Branch Ct","Cedar Breaks Ln","Cedar Bridge Rd","Cedar Bridge Road",
            "Cedar Brook Ave","Cedar Camp Rd","Cedar Cir","Cedar Cliff Rd","Cedar Court","Cedar Cove Road",
            "Cedar Creek Dr","Cedar Creek Drive","Cedar Creek Ln","Cedar Creek Rd","Cedar Crest","Cedar Crest Ct",
            "Cedar Crest Dr","Cedar Crest Road","Cedar Ct","Cedar Ct NE","Cedar Dell Ave","Cedar Dr",
            "Cedar Ed Rd","Cedar Flats Rd","Cedar Gle Road","Cedar Glen Dr","Cedar Grove Drive","Cedar Grove Dr",
            "Cedar Grove Rd","Cedar Grove Road","Cedar Heights","Cedar Heights Rd","Cedar Hill Ave",
            "Cedar Hill Dr","Cedar Hill Rd","Cedar Hill Ter","Cedar Hollow","Cedar Hollow Dr","Cedar Isl Road",
            "Cedar Island Ct","Cedar Island Dr","Cedar Knolls Rd","Cedar Lake Dr N","Cedar Lake Dr S",
            "Cedar Lake Ln","Cedar Lake Rd","Cedar Ln","Cedar Log Ct","Cedar Medow Lane","Cedar Mill Ln",
            "Cedar Mountain Rd","Cedar No 40 Rd","Cedar Noll Dr","Cedar Park Road","Cedar Pl","Cedar Plains Rd",
            "Cedar Poi Lane","Cedar Point Ln","Cedar Pointe","Cedar Pt Shores","Cedar Rd","Cedar Ridge Condominium",
            "Cedar Ridge Ct","Cedar Ridge Pl","Cedar Ridge Rd N","Cedar Ridges Road","Cedar River Ct",
            "Cedar River Dr","Cedar Run","Cedar Springs Rd","Cedar St","Cedar Stream Rd","Cedar Street",
            "Cedar Swamp Rd","Cedar Swamp Road","Cedar Ter","Cedar Town Dr","Cedar Tree Ln","Cedar Valley Road",
            "Cedar Valley Way","Cedar Walk","Cedar Water Rd","Cedar Well","Cedarbend Dr","Cedarbrook Ave",
            "Cedarbrook Ct","Cedarbrook Lane","Cedarbrook Rd","Cedarcraft Ln","Cedarcrest Cir","Cedarcrest Crescent",
            "Cedarcrest Lane","Cedarcrest Rd","Cedarcroft Ave","Cedarcroft Rd","Cedardale Avenue",
            "Cedardale Rd","Cedardale Road","Cedarfield Commons","Cedarglen Gate","Cedargrove Cir",
            "Cedarhaven Dr","Cedarhill Ave","Cedarholm Avenue","Cedarhurst Dr","Cedarhurst Rd","Cedarshores Drive",
            "Cedarspring Dr","Cedarstone Road","Cedartree Ln","Cedartree Rd","Cedarvale Avenue","Cedarvale Boulevard",
            "Cedarvale Drive","Cedarview Ave","Cedarview Village","Cedarville Rd","Cedarwood Ave",
            "Cedarwood Ct","Cedarwood Dr","Cedarwood Drive","Cedarwood Ln","Cedarwood Rd","Cedarwood Road",
            "Cedarwood Ter","Ceder Ct","Cederstone Ledge","Cediton Parkway","Cedro St","Cedros Ave","Cedrus Dr",
            "Ceed Ln","Celata Ln","Celaya St","Celebration Ln","Celebrity Cir","Celery Farm Ln","Celese Cir",
            "Celeste","Celeste Drive","Celeste Rd","Celestial Pl","Celestial St","Celestial Way","Celia Ct",
            "Celia Dr","Celia St","Celina St","Celina Street","Celona Dr","Celotex Rd","Celso Ct","Celtic Cir",
            "Celtic Ln","Celtic St","Cementerio","Cemetary Rd","Cemetary Road","Cemetery Ave","Cemetery Hill Rd",
            "Cemetery Ln","Cemetery Rd","Cemetery Road","Cemetery St","Cemetery Street","Cemetry Rd",
            "Cenajo","Cenco Blvd","Cenerville Ave","Cenrose Cir","Cenrose Pl","Centaur St","Centenary Dr",
            "Centennia Drive","Centennial","Centennial Ave","Centennial Ct","Centennial Dr","Centennial Drive",
            "Centennial Lane","Centennial Park Road","Centennial Park Boulevard","Centennial Plz",
            "Centennial St","Center","Center Ave","Center Ave NW","Center Cir","Center Ct N","Center Dr",
            "Center Drive","Center Green Ct","Center Grove Rd","Center Hill Hwy","Center Hill Rd",
            "Center Line Rd","Center Ln","Center Loop","Center North Rd","Center Pky","Center Pl S","Center Point Pky",
            "Center Point School Rd","Center Rd","Center Road South","Center St","Center Street","Center U Dr",
            "Center Valley Rd","Center Way S","Center Way SW","Centerama Cir","Centerlawn St","Centerport Road",
            "Centerview Cir","Centerville Avenue","Centerville Rd","Centerville Way","Centerway Dr",
            "Centime Way","Centinela Ave","Centner North Dr","Central Ave","Central Avenue","Central Blvd",
            "Central Cemetary Rd","Central Ct","Central Dr","Central Drive","Central Hill Rd","Central Hwy",
            "Central Lake Ave","Central Miles Rd","Central Park Boulevard N","Central Park Boulevard S",
            "Central Park Dr","Central Park Drive","Central Park Driveway","Central Park Great Hill",
            "Central Park West","Central Parkway East","Central Parkway West","Central Pike","Central Pl",
            "Central Place","Central Rd","Central School St","Central Sq","Central St","Central Station Rd",
            "Central Street","Central Street Extension","Central Tree Road","Central Valley Hwy",
            "Central Way","Centralia River Rd","Centre Dr","Centre Lane","Centre Line Road","Centre Road",
            "Centre School Way","Centre St","Centre Street","Centre Street North","Centre Street S",
            "Centre Street South","Centre Trl","Centre View Drive","Centreview Street","Centura Ave",
            "Centurian Dr","Centurian Drive","Centurion Dr","Centurion Sq","Century Blvd","Century Cir",
            "Century Ln","Century Oaks Ln","Century Plant Rd","Century Rd","Ceramic Dr","Cerca Dr","Cercado Ct",
            "Cerchio Basso","Cerel Circle","Ceremonial Drive","Ceres Pl","Cereza Pl","Cerini Rd","Cerise Rose Ave",
            "Cerrano Dr","Cerrito Ave","Cerrito Way","Cerritos Ave","Cerritos Dr","Cerro Gordo Rd","Cerro Loop",
            "Cerro Noroeste Rd","Cerro Vista Dr","Cerro de la Paz","Cerswell Drive","Cerulean Ave",
            "Cervantes Cir","Cerveza Cir","Cessna Ave","Cessna Bay","Cessna Dr","Cessna Rd","Cetona Avenue",
            "Cezanne Ct","Cezanne Ln","Chableau Ct SW","Chablis N","Chablis S","Chablis Cir","Chablis Ct",
            "Chablis Way","Chabolla Ave","Chabot Dr","Chaboya Rd","Chaco Ct","Chaco Rd","Chacon Rd NW","Chad Aldrich Rd",
            "Chad Ct","Chadbourn Ct","Chadburn Ct","Chadburn Street","Chadds Cv","Chadds Ford Ct","Chadsey Dr",
            "Chadsford Ct","Chadwick Ave","Chadwick Avenue","Chadwick Cir","Chadwick Dr","Chadwick Hill Rd",
            "Chadwick Pl","Chadwick Rd","Chadwick St","Chadwick Street","Chadwyn Dr","Chaffee Cir","Chaffin Ln",
            "Chagall Dr","Chagar Ct","Chagnon St","Chagrin Ave SW","Chain of Lakes Drive","Chain of Lakes Drive W",
            "Chalcom Circle","Chalet Dr","Chalet Ln","Chalet Pl","Chalet Ridge Dr","Chalfant Road","Chalfont Pl",
            "Chalk Mine Rd","Chalkstone Course","Chalkstone St NW","Challen Cir S","Challenge Pass Rd",
            "Challenger Ave","Challenger Cir","Challenger Ln","Challenger Rd","Challenger Way","Challister Court",
            "Chalmers Ave","Chalmers Ct","Chalons Pl","Chamber Lain","Chamber's Road","Chamberlain Ave",
            "Chamberlain Avenue","Chamberlain Ct","Chamberlain Lane","Chamberlain Rd S","Chamberlain St",
            "Chamberlain Trl","Chamberlin Hill Rd","Chamberlin Tr","Chambers Avenue","Chambers County 008",
            "Chambers County 011","Chambers County 023","Chambers County 101","Chambers County 114",
            "Chambers County 162","Chambers County 166","Chambers County 224","Chambers County 267",
            "Chambers County 276","Chambers County 474","Chambers County 535","Chambers County 83",
            "Chambers Ln","Chambers St","Chambers Street","Chambers Wells Cutoff","Chamblee Ct NE",
            "Chambley Dr","Chambord Dr","Chamboro Court","Chambray Dr","Chambry Ct","Chameleon Rd","Chamisal Ln",
            "Chamizal","Chamlee Pl","Champ Rd","Champagne S","Champagne W","Champagne Court","Champagnolle Rd",
            "Champion Ct","Champion Mobile Home Park","Champion Rd","Champions Cir","Champions Dr",
            "Championship Dr","Champlain Avenue","Champlain Dr","Champlin St","Champs Flat Rd","Chanaral Ave",
            "Chance Dr","Chancellor Drive","Chancellor Ln","Chancellor St","Chancery Ave","Chancy St",
            "Chandlee Dr","Chandler Ave","Chandler Ave SW","Chandler Brook Rd","Chandler Dr","Chandler Dr W",
            "Chandler Drive","Chandler Mountain Rd","Chandler Pl","Chandler Place","Chandler Rd","Chandler St",
            "Chandler Street","Chandler Ter","Chandler Terrace","Chandler's Vly Trl Ct","Chandlers Ave",
            "Chandlers Mill Rd","Chandlers Mills Rd","Chandlersville Rd","Chandoga Dr","Chandos Avenue",
            "Chandra Ct","Chaney Dr","Chaney Hill Rd","Chaney Lake Rd","Chang St","Changebridge Rd","Channel Ave",
            "Channel Avenue","Channel Ln","Channel Nine Court","Channel Rd","Channel St","Channel Way",
            "Channing Court","Channing Ln","Channing Road","Chantal Street","Chantay Ln","Chanticleer Ave",
            "Chanticleer Ct","Chantilly Ave","Chantilly Pl","Chantler Road","Chantler Street","Chanute St",
            "Chaos","Chapais Crescent","Chaparal Ln","Chaparral Ct","Chaparral Dr","Chaparral Dr W","Chaparral Pl",
            "Chaparral Rd","Chaparral Slope Rd","Chaparrel Ave","Chaparrita Ct","Chaparro Way","Chapedel Pl",
            "Chapel Ave","Chapel Ave E","Chapel Cir","Chapel Ct","Chapel Dr","Chapel Hill Cir","Chapel Hill Dr",
            "Chapel Hill Rd","Chapel Ln","Chapel Park","Chapel Park Avenue","Chapel Place","Chapel Rd",
            "Chapel Road","Chapel St","Chapel Street","Chapel Street N","Chapelcrest Ln","Chapin Aly",
            "Chapin Beach Road","Chapin Court","Chaplain Magsig Ave","Chapleau Ave","Chapleau Place",
            "Chaplin Crescent","Chaplin Ct","Chaplin St NW","Chaplow Ln","Chapman Ave","Chapman Ct","Chapman Dam Rd",
            "Chapman Dr","Chapman Ln","Chapman Pl","Chapman Point","Chapman Pt Dr","Chapman Ranch Dr",
            "Chapman Rd","Chapman Road","Chapman St","Chapman Street","Chapman Ter","Chappaquiddick Road",
            "Chapparal Ave","Chappell Pl","Chappell St","Chappie Street","Chaps Rd SE","Chardon Rd","Chardonnay Dr",
            "Chardonnay Place","Chardonnay Rd","Charge Pond Road Connector","Chari Ln","Charing Cross Rd",
            "Charisma Ct","Charity Ln","Charlemont Dr","Charles","Charles Ave","Charles Bancroft Hwy",
            "Charles Carroll Building","Charles Ct","Charles Dr","Charles E Young Dr S","Charles M. Christiansen Trail 100",
            "Charles Pl","Charles Place","Charles Rd","Charles St","Charles Street","Charles Street East",
            "Charles Street North","Charles Ter","Charles Tupper Drive","Charlesgate East","Charlesgate West",
            "Charleson Rd","Charleston Ave","Charleston Blvd","Charleston Grn","Charleston Lake Rd",
            "Charleston Lake Road","Charleston Rd","Charleston Road","Charleston St","Charleston Ter",
            "Charlesworth Rd","Charlevoix Ave","Charleys Creek Rd","Charlie Brown Dr","Charlie Dawson Rd",
            "Charlie Green Road","Charlieville Road","Charlnor Pl","Charloma Dr","Charlotte Ave","Charlotte Ave NW",
            "Charlotte Ct","Charlotte Dr","Charlotte Drive","Charlotte Lane","Charlotte Ln","Charlotte Pl",
            "Charlotte Rd","Charlotte St","Charlotte Street","Charlotte Way","Charlton Pl","Charm Ct",
            "Charmain Ct","Charman Ave","Charmes Ct","Charmont Ave","Charms Ravine Dr","Charnal Cir",
            "Charnwood Crescent","Charnwood Ct","Charnwood Dr","Charolais Boulevard","Charose Ln",
            "Charrington Avenue","Charro Ct","Charter Oak Ave","Charter Oak Dr","Chartin Rd","Chartland Boulevard S",
            "Chartway Boulevard","Chartwell Carriage Way N","Chartwell Ct","Chartwell Rd","Chartwell Road",
            "Charwalt Pl","Charwood Dr","Chase","Chase Ct","Chase Dr","Chase Farm Rd","Chase Mills-Louisville Rd",
            "Chase Pky","Chase Place Ln","Chase Rd","Chase Ridge","Chase Road","Chase Run","Chase St","Chase Street",
            "Chase Terrace","Chase Valley Dr","Chase Way","Chasehurst Drive","Chasewood Cir","Chasse Drive",
            "Chassell St SW","Chastang Rd","Chastang St","Chastellux Ln","Chastity Ln","Chat Ct","Chatam St",
            "Chatanika River Recreational Rd","Chateau Court","Chateau Ct","Chateau Drive","Chateau Grove Ln",
            "Chateau Pl","Chateau Rive","Chateau Thierry","Chateau Way","Chater Lane","Chatfield Drive",
            "Chatfield Pl E","Chatham Avenue","Chatham Ct","Chatham Dr","Chatham Hill Rd","Chatham Pl",
            "Chatham Point Dr","Chatham Rd","Chatham Road","Chatham Sq","Chatham St","Chatham St SE",
            "Chatham Street Extension","Chatham Walk","Chatham Way","Chathamwoods Dr","Chatillion Dr",
            "Chatlin Dr","Chatsford Rd","Chatsford St","Chatsworth Ave","Chatsworth Dr","Chatsworth Rd",
            "Chatsworth Village","Chatwood Rd","Chatworth Ct","Chatwyck Ln","Chaucer Ct","Chaucer Cv",
            "Chaucer Pl","Chaucer Rd","Chaucer St","Chaudet Ln","Chaumont Dr","Chauncey Avenue","Chauncey Street",
            "Chauncy St","Chaunin Rd","Chautauqua Ave","Chautauqua Nancy B. Diggs Trail","Chautauqua Rd",
            "Chaves Rd","Chavez Rd","Chayne Cir","Chaytor St","Cheaha Rd","Cheatam Rd","Checkmate","Cheerful Pl",
            "Cheeric House Rd","Cheerio Ln","Cheese Factory Rd","Cheese Factory St","Cheeseboro Rd",
            "Cheetah Path","Cheever Pl","Cheever Place","Cheever Street","Cheevers Avenue","Chehalis Cir",
            "Chelcie St","Chelmsford Ln","Chelsea Ave","Chelsea Court","Chelsea Ct","Chelsea Dr","Chelsea Lane",
            "Chelsea Ln","Chelsea Meadows Dr","Chelsea Pl","Chelsea Rd","Chelsea St","Chelsea Ter","Chelsea Tr Ct",
            "Cheltenha Road","Cheltenham Ct","Chelton Ave","Chelton Dr","Chelwynde Ave","Chemical Way",
            "Chemin Oswego Way","Chemin de Coaticook","Chemise Mountain Rd","Chemung Pl","Chemung Street",
            "Chena Dr","Chenal Pky","Chenango Rd","Chenault St","Chenell Dr","Chenette St","Cheney Creek Rd",
            "Cheney Dr","Cheney Ln","Cheney Pky","Cheney Rd","Cheney Road","Chennault Ave","Cher Ln","Cheraz St NE",
            "Cheremoya Ave","Cherhill Drive","Cherie","Cherie Ln","Cherimoya Ave","Cherish Ave","Cherokee",
            "Cherokee Ave SW","Cherokee Beach Rd","Cherokee Boulevard","Cherokee Cir","Cherokee County 22",
            "Cherokee County 29","Cherokee County 41","Cherokee County 455","Cherokee County 48",
            "Cherokee County 60","Cherokee County 62","Cherokee County 671","Cherokee County 758",
            "Cherokee County 77","Cherokee County 790","Cherokee County 82","Cherokee County 89",
            "Cherokee County 903","Cherokee County 94","Cherokee Ct","Cherokee Dr","Cherokee Hills Rd",
            "Cherokee Ln","Cherokee Path","Cherokee Pl","Cherokee Pony Trl","Cherokee Rd","Cherokee Rd SW",
            "Cherokee St","Cherokee Trl","Cherokee West","Cherrier Ct","Cherry Aly","Cherry Ave","Cherry Ave offramp",
            "Cherry Avenue","Cherry Avenue N","Cherry Blossom Dr","Cherry Blossom Ln","Cherry Brook Dr",
            "Cherry Canyon Dr","Cherry Cir","Cherry Creek Cv","Cherry Creek Dr","Cherry Ct","Cherry Dr",
            "Cherry Gate Ln","Cherry Hill","Cherry Hill Ct","Cherry Hill Dr","Cherry Hill Ln","Cherry Hill Rd",
            "Cherry Hills Dr","Cherry Hills Ln","Cherry Lane","Cherry Ln","Cherry Mountain Pl","Cherry Orchard Rd",
            "Cherry Orchard St","Cherry Parke","Cherry Pl","Cherry Plum Ct","Cherry Point Ln","Cherry Point Rd",
            "Cherry Point Rd SW","Cherry Post Crescent","Cherry Rd","Cherry Ridge Rd","Cherry Springs Rd",
            "Cherry St","Cherry St NE","Cherry St SE","Cherry Street","Cherry Tree Ct","Cherry Tree Ln",
            "Cherry Tree Rd","Cherry Valley Cir","Cherry Valley Dr","Cherry Valley Rd","Cherry Way",
            "Cherry Wood Ln","Cherrydale Ct NW","Cherrydale Pl","Cherryhill Road","Cherryhills Ct",
            "Cherrylawn Dr","Cherrystone Drive","Cherrywoo Lane","Cherrywood","Cherrywood Cir","Cherrywood Forest Ln",
            "Cherrywood Ln","Cherrywood St","Chertsey Ln","Cherum","Cherwell Ct","Chery Street","Cheryl Ann Dr",
            "Cheryl Clay Way","Cheryl Ct","Cheryl Dr","Cheryl Ln","Cheryl St","Cheryle Way","Cheryll Ln",
            "Ches Mae Ln","Chesapeake Ct","Chesapeake Dr","Chesapeake Rd","Chesapeake Ter","Cheseboro Rd",
            "Chesham Rd","Cheshire Ave","Cheshire Ct","Cheshire Dr","Cheshire Ln","Cheshire Pl","Cheshire Road",
            "Cheshire St","Cheshire Way","Chesley Hill Rd","Chesley Rd","Chesne Rd","Chesney Ave","Chesnut Street",
            "Chess Road","Chesser Rd","Chester Ave","Chester Avenue","Chester Bowles Hwy","Chester Cir",
            "Chester Court","Chester Dr","Chester Hill Road","Chester Lane","Chester Pike","Chester Pl",
            "Chester Place","Chester Rd","Chester Road","Chester St","Chester Street","Chester Tpke",
            "Chester W Nimitz St","Chesterfield Ct","Chesterfield Dr","Chesterfield Drive","Chesterfield Rd",
            "Chesterfield Road","Chesterfield St","Chesterfield Way","Chesterton Pl","Chesterton St",
            "Chesterton Way","Chestnut","Chestnut Aly","Chestnut Ave","Chestnut Avenue","Chestnut Cir",
            "Chestnut Court","Chestnut Ct","Chestnut Dr","Chestnut Extended","Chestnut Flat Rd","Chestnut Hill",
            "Chestnut Hill Avenue","Chestnut Hill Cemetery Rd","Chestnut Hill Ct","Chestnut Hill Dr",
            "Chestnut Hill Driveway","Chestnut Hill Ln","Chestnut Hill Rd","Chestnut Hill Road",
            "Chestnut Hill Ter","Chestnut Ln","Chestnut Oval","Chestnut Rd","Chestnut Rd NW","Chestnut Ridge Rd",
            "Chestnut Road","Chestnut St","Chestnut St Extension","Chestnut St SE","Chestnut Street",
            "Chestnut Street W","Chestnut Ter","Chestnut Terrace","Chestnut Trl","Chesuncook Ln","Cheswell Way",
            "Cheswick Pl","Chet Way","Chetopa Dr","Chetwynd Dr","Chevalier Ave","Chevalier Rd","Chevchenko Ave",
            "Chevel Ave","Cheviot Ct","Chevrolet Dr","Chewalla Blvd","Chews Landing Rd","Cheyenne Ave",
            "Cheyenne Blvd","Cheyenne Cir","Cheyenne Ct","Cheyenne Dr","Cheyenne Drive","Cheyenne Way",
            "Chi Mar Dr","Chi Psi","Chianti Crescent","Chicago Ave","Chicago Blvd","Chicago Rd","Chicago St",
            "Chiciahua Rd","Chick A Dee Ct","Chickadee Dr","Chickadee Lane","Chickadee Ln","Chickadee Rd",
            "Chickadee Road","Chickamanga Park Dr","Chickamauga Ave","Chickasaw Cir","Chickasaw Ct",
            "Chickasaw Dr","Chickasaw Ridge","Chickasaw Way","Chicken Springs Rd","Chickenboro Rd",
            "Chickering Lane","Chicksaw Ave","Chico Ave","Chico Ct","Chico Ln","Chico St","Chicopee St",
            "Chicory Court","Chicory Dr","Chicot Rd","Chief","Chief Canyon","Chief Cir","Chief Joseph Snake Road",
            "Chief Ladiga Walking Trl","Chief Rd","Chiefswood Square","Chieftain Crescent","Chiffchaff Ct",
            "Chiften Hills","Chihuahua Ave","Chihuahua Rd NE","Chilatchee Park Rd","Chilcoot Ave",
            "Chilcotin Rd","Child's Loop","Child's Rd","Child's Way","Childers Rd","Childers St","Childrens Way",
            "Childs Ave","Childs Blvd","Childs St","Childs-Hill","Chilhowie Dr","Chili Rd","Chilkoot Trl",
            "Chillery Avenue","Chillicothe Rd","Chillon Ln","Chilmark St NW","Chiloco Trce","Chilson Rd",
            "Chiltern Hill","Chilton Hall","Chilton Park","Chilton St","Chilverton St","Chimaja Rd","Chimes Rd",
            "Chimineas Ranch Rd","Chimney Creek Rd","Chimney Peak Ave","Chimney Pot Ln","Chimney Rock",
            "Chimney Rock Rd","Chin Creek Rd","China Creek Rd","China Creek Way","China Grade Rd",
            "China Hollow Rd","China Lake Blvd","China Mine Road","China Ranch Rd","China Sea Ave",
            "China Spring Loop Rd","China St","Chinaberry Ln","Chinchilla Ave","Chinchilla St","Chinese Cherry Ct",
            "Ching Lynch Rd","Chingarora St","Chinkapin Ave","Chinle Ave","Chino Avenue","Chino Blvd",
            "Chino Rd","Chino Valley Fwy","Chinook Candy Ct","Chinook Ln","Chinook Trl","Chinquapin Ln",
            "Chinquapin Loop","Chintewink Aly","Chip N Dale Dr","Chipmunk Cir","Chipmunk Crescent",
            "Chipmunk Dr","Chipmunk Hill","Chipmunk Lane","Chipmunk Xing","Chippanee Dr","Chippawa Court",
            "Chippawa Road","Chippenben Dr","Chippenham Ct","Chippenham Drive","Chippewa Ct","Chippewa Dr",
            "Chippewa Ln","Chippewa Rd","Chippewa Road","Chippewa St","Chippewa Street","Chippewa Tr",
            "Chippewa Trl","Chipping Park Boulevard","Chippunben Dr","Chipshot Ct","Chipwood St","Chiquita Ln",
            "Chiquita Rd","Chiricahua St","Chirlin Dr","Chisholm Avenue","Chisholm Ct","Chisholm Dr",
            "Chisholm Trl","Chism St","Chismahoo Rd","Chisolm Trl NE","Chisum Place","Chiswick Cir","Chiswick Street",
            "Chitlin Switch Rd","Chittenden Avenue","Chittenden Dr","Chittenden St","Chives Rd","Chiz Rd",
            "Chloe Dr","Chmura Road","Choate Hill Rd","Chocker Way","Chocolog Road","Chocorua Ln","Choctaw Ave",
            "Choctaw Ave E","Choctaw Dr","Choctaw Ridge Rd","Choctaw Ridge Street","Choctaw St","Choctaw Trl",
            "Choctaw Way","Choktah Trl","Cholame Rd","Cholla","Cholla Dr","Cholla Pl","Cholla Rd","Cholla St",
            "Cholla Way","Chollita Rd","Chorister Pl","Chow Chew","Chow Chow Ln","Chrestensen Rd","Chris Ct",
            "Chris Haven Trl","Chris Heer Trl","Chris Ln","Chris Rd","Chris Ter","Christal Springs Rd",
            "Christensen Rd","Christian Circle","Christian College Rd","Christian Flury Rd","Christian Hill Rd",
            "Christian Hill Ter","Christian Ln","Christian Reesor Park Avenue","Christian St","Christiana Ave",
            "Christiani Road","Christiansen Way","Christianson Hill Rd","Christidi Drive","Christie Ave",
            "Christie Avenue","Christie Ct","Christie Dr","Christie Lake 51 Lane","Christie Ln","Christie Rd",
            "Christie St","Christie Street","Christina Ct","Christina Dr","Christina St","Christine Ave",
            "Christine Cir","Christine Ct","Christine Cts","Christine Dr","Christine Ln","Christine Pine Ct",
            "Christine Pl","Christine St","Christle Ct","Christman Avenue","Christman Rd","Christmas Hill Road",
            "Christmas Tree Hill Rd","Christmas Tree Lane","Christmas Tree Lane - 262","Christmas Tree Ln",
            "Christmas Tree Pl","Christnovich Rd","Christopher Ave","Christopher Cir","Christopher Columbus Dr",
            "Christopher Crescent","Christopher Ct","Christopher Dr","Christopher Harding Lane",
            "Christopher Lee Cir","Christopher Ln","Christopher Rd","Christopher Ridge Ter.","Christopher St",
            "Christwood Ct","Christy Court","Christy Hill Rd","Christy Ln","Christy Plz","Christy Rd",
            "Christy St","Christy Ter","Christy Way","Christyway Ct","Chrisval Avenue","Chrome Ridge Rd",
            "Chromite St","Chrysler Ln","Chrysler Rd","Chrystal Bay Ct","Chrystal View Ln","Chuar Dr",
            "Chubby Ln","Chucalissa Pky","Chuck Drive","Chuck St N","Chucker Ct","Chuckhole Ln","Chuckwagon Rd",
            "Chudleigh Avenue","Chughole Rd","Chukkar Ln","Chula","Chula Vista Ave","Chula Vista Dr",
            "Chulio Rd SE","Chulitna Trl","Chung St","Church","Church Ave","Church Avenue","Church Ct","Church Dr",
            "Church Drive","Church Hill","Church Hill Downs Ct","Church Hill Dr","Church Hill Rd",
            "Church Hollow Rd","Church House Rd","Church Hwy","Church Lane","Church Ln","Church Loop",
            "Church Pl","Church Rd","Church Road","Church St","Church St E","Church St N","Church St S",
            "Church St W","Church St.","Church Street","Church Street E","Church Street N","Church Street Rd",
            "Church Street S","Church Street West","Church Way","Church of God Loop","Churcher Drive",
            "Churchfield Ave NW","Churchfield Cir","Churchill Avenue","Churchill Downs Ave","Churchill Downs Ct",
            "Churchill Dr","Churchill Drive","Churchill Drive E","Churchill Lane","Churchill Ln","Churchill Rd",
            "Churchill Road","Churchill St","Churchill Street","Cibola Rd","Cicada Ct","Cicero Stage",
            "Cicerone Rd","Cider Brook Dr","Cider Ct","Cider Mill Ct","Cider Mill Rd","Cider Street",
            "Ciele Cir","Cielia St","Cielito Dr","Cielito Trl","Cielo Azul","Cielo Grande","Cielo Lindo",
            "Cielo del Este","Cienega Dr","Ciervo Trail Way","Cigas Road","Cijos St","Cimahosky Rd","Cimarron Ct",
            "Cimarron Dr","Cimarron Rd","Cimarron River Ct","Cimarron Road","Cimarron Trails Dr","Cimarron Trl",
            "Cimerron","Cimmaron Cv","Cimmaron Dr","Cinchona St","Cincinnati","Cincinnati Creek Rd","Cinco de Mayo",
            "Cinder Haul Rd","Cinder Rd","Cinderella Dr","Cinderella Ln","Cinderwood Ct","Cindy Ave",
            "Cindy Dr","Cindy Ln","Cindy St","Cindy St NW","Cindy Ter","Cindywood Cir","Cinecue Way","Cinnabar Rd",
            "Cinnamon Ct","Cinnamon Ln","Cinrickbar Drive","Cinroc Circle","Cintas Ave","Cintra Ln E",
            "Cipriano Rd","Cirby Oaks Way","Circle Ave","Circle Blvd","Circle Ct","Circle Ct E","Circle Dr",
            "Circle Dr E","Circle Dr N","Circle Dr SE","Circle Dr W","Circle Drive Compound","Circle Drive West",
            "Circle Heights Aly","Circle L Ranch Rd","Circle Lazy J Rd","Circle Ln","Circle Mountain Rd",
            "Circle R Oaks Ln","Circle R Way","Circle Rd","Circle St","Circle Way","Circuit Drive","Circuit Road West",
            "Circulo de Casitas","Circulo del Monte NE","Circumferential Hwy","Cirelly Rd","Cirencester St",
            "Cirre Way","Cirvela Pl","Cisco Ln","Cisco Rd","Cissell Ln","Citadel Drive","Citadell Rock Rd",
            "Citation","Citation Crescent","Citation Ct","Citation Ct W","Citizens Pky","Citron Ave",
            "Citron Ct","Citronia St","Citrus Ave South offramp","Citrus Ct","Citrus Fair Dr","Citrus Ln",
            "Citrus Rd","Citrus St","City Ave","City Blvd W","City Brook Rd","City Centre Drive","City Crossroads Dr",
            "City Dump Rd","City Hall Square","City Lake Rd","City Lights","City Line Ave","City Park Dr SW",
            "City Pl","City Road","City Shop Rd","Cityview Boulevard","Cityview Ter","Civic Center Blvd",
            "Civic Center Dr","Civic Center Drive","Civic Center Plz","Civic Sq W","Civita Lane","Civitan Rd",
            "Clabuesch St","Claflin Terrace","Claiborne Ct","Claim St","Clair Fire Ln","Clair St","Claire Ave",
            "Claire Ct","Claire Lake Ave","Claire Ln","Claire St","Clairemont Mesa Blvd","Clairet Dr",
            "Clairmont Ave","Clairmont Ct","Clairmont Dr","Clairmont Rd","Clairmont St","Clairview Ave",
            "Claitor Way","Clamshell Dr","Clancy Rd","Clancy Road","Clancy St","Clanfield Court","Clapp Rd",
            "Clapp Road","Clappison Boulevard","Clapson St","Clara Ct","Clara Dr","Clara Ln","Clara Louise Drive",
            "Clara Rd","Clara St","Clara Street","Claradon Ln","Clare Ave","Clare Avenue","Clare Road","Claredon Dr",
            "Claredon Ter","Claremont Ave","Claremont Ave NE","Claremont Avenue","Claremont Blvd",
            "Claremont Ct","Claremont Dr","Claremont Lane","Claremont Rd","Claremont St","Claremont Way",
            "Claremont-wescott Connector","Claremore Avenue","Clarenan Drive","Clarence Ave","Clarence Biesenthal Drive",
            "Clarence Dr","Clarence Dr SE","Clarence E Chestnut Jr Byp","Clarence Irby Rd","Clarence Park",
            "Clarendon Avenue","Clarendon Ct","Clarendon Dr","Clarendon Drive","Clarendon Road","Clarendon St",
            "Clarendon Street","Claretta","Clarges Ln","Clarice Ave","Claridge Pl","Claridge St","Clarie Dr",
            "Clarington Road","Clarington-Manvers Boundary Road","Clarion Ct","Clarion Dr","Clarion Road",
            "Clarissa Ave","Clarissa Drive","Clarissa Joseph Road","Clarissa Ln","Clark Ave","Clark Avenue",
            "Clark Avenue West","Clark Boulevard","Clark Carr Rd SE","Clark Cir","Clark Ct","Clark Dr",
            "Clark Hill Rd","Clark Ln","Clark Mills Rd","Clark Pl","Clark Rd","Clark Road","Clark Road Extension",
            "Clark St","Clark Street","Clark Walk","Clarke Ave","Clarke Plz","Clarke St","Clarkes Ln","Clarks Cross Rd",
            "Clarkson Ave","Clarkson Ct","Clarkson Road","Clarkson St","Claro Ave","Claroskee Rd","Classen St",
            "Classic Avenue","Classon Ave","Claudius Gate","Claursen Dr","Claus Road","Clausell Rd","Clausen Ln",
            "Clausland Mountain Rd","Claveau Landing","Clavelita Pl","Claver Avenue","Claverack Rd",
            "Clavey Ct","Clay Ave","Clay County 18","Clay County 225","Clay County 30","Clay County 7",
            "Clay County Road 479","Clay Ct","Clay Cv","Clay Hill Rd","Clay Hwy","Clay Hwy Strt 16","Clay Pl",
            "Clay Rd","Clay St","Clay Street","Claybank Road","Clayboard St","Clayborne Ct","Claybrooke Street",
            "Clayburn Ct","Clayhill Rd","Claymeadow Avenue","Claymore Ct E","Claymore Drive","Claypine Rise",
            "Claypool","Clayton Ave","Clayton Center Rd","Clayton Crescent","Clayton Ct","Clayton Driftway",
            "Clayton Drive","Clayton Mill River Road","Clayton Rd","Clayton Road","Clayton St","Cleadon Road",
            "Clear Acre Ln","Clear Creek","Clear Creek Ct","Clear Creek Dr NE","Clear Creek Ln","Clear Creek Rd",
            "Clear Lake Rd","Clear Lake Reservoir Rd","Clear Lake Road","Clear Rapid Ct","Clear Spring Rd",
            "Clear Vie Drive","Clear View Dr","Clear View Dr SW","Clearfield Ave","Clearfield Pl",
            "Clearfield Rd","Clearfield St","Clearglen Dr","Cleargrove Ct","Clearlake Avenue","Clearman Pl",
            "Clearmeadow Boulevard","Clearside Place","Clearview Ave","Clearview Cir","Clearview Cv",
            "Clearview Dr","Clearview Drive","Clearview Heights","Clearview Ln","Clearview Rd","Clearview St",
            "Clearview St NW","Clearwater Cir","Clearwater Dr","Clearwater Drive","Clearwater Falls Ct",
            "Clearwater Ln","Clearwater Pl","Clearwater Rd","Clearwater Ter","Clearwood Ave","Cleaver St",
            "Cleavland St","Cleburne Cir","Clegg St","Cleghorn Ct NW","Cleland Pl","Clematis Ct","Clematis Pl",
            "Clematis Road","Clematis St","Clemence Ave","Clemens Crescent","Clemens Sq","Clement Ave",
            "Clement Place","Clement Rd","Clement St","Clement Street","Clementi Street","Clementia Cir",
            "Clementina St","Clementine Square","Clementine St","Clementon Rd","Clements","Clements Bridge Rd",
            "Clements Dr","Clements Rd","Clements Road","Clements Road E","Clements Road W","Clemmer",
            "Clemsford Sq","Clemson Crescent","Clemson Ct","Clemson Rd","Clendening Rd","Cleo Amelia Ln",
            "Cleo Ave","Clergy Street East","Clerk Ave","Clermont Pl","Clermont Ter","Clescent Dr","Cleveland",
            "Cleveland Ave","Cleveland Avenue","Cleveland Blvd","Cleveland Ct","Cleveland Metro Park Dr",
            "Cleveland Metro Pky","Cleveland Pl","Cleveland Rd","Cleveland St","Cleveland Street",
            "Cleveland Way","Clevenger Dr","Cleverdon Boulevard","Clewell Dr","Cliff Ave","Cliff Branch Dr",
            "Cliff Dr","Cliff Hill Pl","Cliff Rd","Cliff Ridge Rd","Cliff Road","Cliff Road North","Cliff Sieler Way",
            "Cliff St","Cliff Street","Cliffe Avenue","Cliffedge Way","Cliffhouse Ln","Clifford Dr","Clifford Place",
            "Clifford St","Clifford Street","Cliffrose Ct","Cliffrose Dr","Cliffrose Ln","Cliffside Ave",
            "Cliffside Ct","Cliffside Dr","Cliffside Park","Cliffside Trl","Cliffview Cir","Cliffview Ct",
            "Cliffwood Ave","Cliffwood Dr","Cliffwood Ter","Cliffwood Way","Cliftmont Ave NE","Clifton Ave",
            "Clifton Blvd","Clifton Boulevard","Clifton Court","Clifton Dr","Clifton Heights Dr","Clifton Pl",
            "Clifton Rd","Clifton Road","Clifton St","Clifton Street","Clifton Way","Climax Dr","Cline Cabin Rd",
            "Cline Mountain Road","Cline Shore","Clinger Ln","Clingerman Rd","Clingman Dr","Clinker Rd",
            "Clint-Eldredge Rd","Clinton","Clinton Ave","Clinton Ave N","Clinton Avenue","Clinton Ct",
            "Clinton Hill Dr","Clinton Ln","Clinton Pl","Clinton Rd","Clinton River Shore Rd","Clinton River Trail",
            "Clinton Road","Clinton St","Clinton Street","Clinton Ter","Clinton Way","Clintonview Rd",
            "Clio St","Clipper Road","Clipper Way","Clive Cir","Clive Pl","Cliveden Pl","Cloie Cir","Cloister Ct",
            "Clonmore Drive","Clonsilla Avenue","Cloride Cliff Rd","Close Ave","Closser Ave","Closson Court",
            "Closter Dock Rd","Clothespin Aly","Clothier Way","Cloudcroft Dr","Cloudland Rd","Cloudsdale Cir",
            "Cloudslee Road","Cloudswood","Cloudview Rd","Clough","Clough Canyon","Clough Ln","Cloughley Drive",
            "Cloutier Rd","Clove Ave","Clove Brook Road","Clove Lakes Exwy S Svc Rd","Clove Road",
            "Clove Way","Clovelly Cove","Clovelly Drive","Clover Ave","Clover Avenue","Clover Canyon Rd",
            "Clover Ct","Clover Dr","Clover Hill Ln","Clover Hill Rd","Clover Lane","Clover Leaf Street",
            "Clover Ln","Clover Meadow Ct","Clover Mill Rd No 2","Clover Park Dr","Clover Rd","Clover Ridge Dr",
            "Clover Ridge Drive E","Clover Ridge Drive W","Clover Ridge Rd","Clover St","Clover Street",
            "Clover Valley Rd","Clover Way","Cloverbrae Crescent","Cloverbrook St","Clovercrest Dr",
            "Cloverdale","Cloverdale Rd","Cloverdale St","Cloverfield Dr","Cloverhill Road","Cloverland Dr",
            "Cloverleaf Trl","Cloverleaf Way","Clovermeadow Dr","Cloverville Rd","Clovis Rd","Clower St",
            "Club Acre Ln","Club Ct","Club Dr","Club Estates","Club House Dr","Club House Ln","Club Ln",
            "Club Moss Ln","Club Premier Dr","Club Rd","Club Rd S","Club Rd SE","Club Ter","Club View Dr",
            "Club Way","Clubhouse","Clubhouse Cir","Clubhouse Dr","Clubhouse Plz","Clubhouse Rd","Clubine Rd",
            "Clubview Ct","Clune Park Rd","Cluney Lane","Cluny Drive","Cluster C","Cluster Oak Place",
            "Clyde Ave","Clyde Ct SW","Clyde Rd","Clyde Road","Clyde St","Clyde Way","Clydebank Place","Clydes Rd",
            "Clydesdale Cir","Clydesdale Dr","Clydesdale Lane","Clydesdale Way","Clymer Cir","Clymer St",
            "Clymer Walk","Clymer-Sherman Rd","Clytie Way","Co 15 1/2 St S","Co 18th","Co Park Rd","Co Rd 440 Rd",
            "Co Rd Lighthouse","Co Rd Ma Rd","Co Rd Net Ln","Co Rd283","Co Road 0087","Co Road 162","Co Road 167",
            "Co Road 338","Co Road 363","Co Road 407","Co Road 446","Co Road 501","Co Road 521","Co Road 529",
            "Co Road 79","Co Road 9","Co Touring Rte 46","Co-Op Dr","Co24","Coach Ave","Coach Ct","Coach Rd",
            "Coachford Way","Coachlight Sq","Coachlight Way","Coachman Ct","Coachwood Ct","Coady Ct",
            "Coal","Coal Ave","Coal Ave SW","Coal Crk Rd","Coal Ct","Coal Rd","Coal St","Coal Valley Rd","Coalburg",
            "Coales Branch Cir","Coales Branch Ln","Coalinga-Mendota Rd","Coalport Drive","Coalport St",
            "Coalter Ave","Coan Pond Dr","Coast Ave","Coast Blvd S","Coast Dr","Coast Glen Spur Nort",
            "Coast Guard Sta S Rd","Coast Oak Ct","Coast Trail","Coastal Woods Ct","Coaster Lane",
            "Coates Ave","Coates Road West","Coates St","Coats Rd","Coats St","Coatsworth Aly","Cobalt St",
            "Cobane Ter","Cobb Aly","Cobb Ave","Cobb Ct","Cobb Ln","Cobb Place","Cobb Rd","Cobb St","Cobble Creek Dr",
            "Cobble Heights Rd","Cobble Hill Ln","Cobble Hill Rd","Cobble Ln","Cobble Way","Cobblebrook E",
            "Cobblefield Ln","Cobblefield Rd","Cobblers Ct","Cobbles E","Cobblesdale Ave NW","Cobblestone Chase",
            "Cobblestone Ct","Cobblestone Dr","Cobblestone Ln","Cobblestone Rd","Cobblestone Way",
            "Cobbs St","Cobden St","Coberly Rd","Cobham Park Rd","Coblestone Ct","Cobra Ln","Coburg St",
            "Coburn Court","Coburn Rd","Coburn Woods","Cobus Oaks Dr","Coca","Cocanut Grove Ct","Cochecton Tpk",
            "Cochecton and Great Bend Tpke","Cochise Ave","Cochise Cir","Cochise Ct","Cochiti Rd",
            "Cochran Dr","Cochran Lake Rd","Cochran St","Cochrane Drive","Cochrane Street","Cockayne Ave",
            "Cockburn Dr","Cockburn Street","Cockle Cove Ridge","Cockspur Ct","Coco Ct","Coco Dr","Coconino Ln",
            "Cocula Ave","Cod Dr","Cod Ranch Rd","Coddington Rd","Coddington Street","Code Drive","Codfish Hill Rd",
            "Codlin Street","Codringto Street","Cody Ave","Cody Lane","Cody Pass","Cody Pl","Cody Rd","Cody Rd NE",
            "Cody St","Coe Ave","Coe Drive","Coe Hill Rd","Coe Way","Cofey Road","Coffey Rd","Coffey Street",
            "Coffman Dr","Coffman and Pico Rd","Cofield Cir","Cofrin St","Cogbill St NE","Coggins Ln",
            "Cogswell Court","Cohail Ln","Cohannet Street","Cohansey Ter","Cohen Ave","Cohen and Cohen Rd",
            "Coho Rd","Cohocton Loon Lake Rd","Cohocton Pl","Cohocton Rd","Cohocton Street","Coil Pl",
            "Coin Street","Coit Way","Cojo Rd","Coke Dr","Cokeley Ct","Coker Ave","Coker St","Cokesbury Califon Rd",
            "Cokesbury Rd","Colanthe Ave","Colbath Ave","Colbert St","Colborne Street","Colborne Street E",
            "Colborne Street East","Colborne Street W","Colborne Street West","Colburn Avenue",
            "Colburn St","Colby Ave","Colby Cir","Colby Court","Colby Ct","Colby Dr","Colby Ln","Colby Pl",
            "Colby Rd","Colby Road","Colby St","Colby Terrace","Colby Way","Colbys Lane","Colchester Drive",
            "Colchester Rd","Colcord Pond Rd","Colcord Rd","Cold Brook Rd","Cold Brook Street","Cold Creek",
            "Cold Creek Dr","Cold Deck","Cold Harbor Dr","Cold Hill Rd","Cold Spring","Cold Spring Dr",
            "Cold Spring Rd","Cold Spring Road","Cold Springs Rd","Cold Stream Ct","Cold Water Ct",
            "Cold Water River Levee","Coldbrook Dr","Coldbrook Road","Coldbrook St NE","Colden St",
            "Coldspring Ct","Coldspring Dr","Coldspring Rd","Coldstream Avenue","Coldstream Ct","Coldstream Dr",
            "Coldstream Lane","Coldwater Ct","Coldwater Mews","Coldwater Road","Coldwater Trl","Cole Ave",
            "Cole Avenue","Cole Crescent","Cole Dr","Cole Farm Boulevard","Cole Haven Ter","Cole Hill Rd",
            "Cole Ln","Cole Plain","Cole Rd","Cole Rd Spur","Cole Road","Cole Springs Rd","Cole St","Colebrook Road",
            "Coleco Ln","Coledale Road","Coleen Way","Coleman Ave","Coleman Cir","Coleman Court","Coleman Crescent",
            "Coleman Cv","Coleman Dr","Coleman Lane","Coleman Ln","Coleman Rd","Coleman St","Coleman Street",
            "Colene St","Coleraine Dr","Coleraine Drive","Coleridge Street","Coles Avenue","Coles Clove Rd",
            "Coles Creek State Park Trl","Coles Hill Rd","Coles Point Ct","Coles Pond Rd","Coles Rock Rd",
            "Coles St","Coles Street","Colfax Ave","Colfax Dr","Colfax Hwy","Colfax Street","Colgate Ave",
            "Colgate Avenue","Colgate Ct","Colgate Rd","Colgate University","Colibri Ct","Colima","Colima Rd",
            "Colin Kelly Ct","Colina Alta Dr","Colina Ln","Colinas Avenue NE","Collaberg Rd","Collamer Cir",
            "Collamore Cir","Collar Ave","Colleen","Colleen Court","Colleen Ct","Colleen St","College Ave",
            "College Avenue","College City Rd","College Ct","College Cv","College Dr","College Heights Dr",
            "College Highway","College Hill Rd","College Manor Drive","College Park St","College Parkway",
            "College Pky","College Pl","College Place","College Rd","College St","College St N","College Street",
            "College Street E","College Street W","College View Court","Collegeview Dr","Colleran Pl",
            "Collett Ave","Colley St","Collier Ave","Collier Ct","Collier Dr","Collier Rd","Collier Run Rd",
            "Collier Springs Rd","Collier Street","Collignon Way","Colline Dr","Collingdale Road",
            "Collings Rd","Collingswood Ave","Collingswood Pl","Collingswood Rd","Collingwood Ave",
            "Collingwood Cir","Collingwood Dr","Collingwood Road","Collins","Collins Ave","Collins Avenue",
            "Collins Center Zoar Road","Collins Corner Road","Collins Ct","Collins Dr","Collins Drive",
            "Collins Ln","Collins Pky","Collins Rd","Collins St","Collins Street","Collinsville Rd","Collinswood",
            "Collinswood Ln","Collis Dr","Collura Ln","Collver Rd","Collyer Ave","Colmar St","Colmart Way",
            "Cologne Ave","Coloma Ct","Coloma Heights Rd","Coloma Rd","Colonel Conklin Dr","Colonel Danforth Trail",
            "Colonel Dr","Colonel S Crescent","Colonia Blvd","Colonia Rd","Colonial Ave","Colonial Cir",
            "Colonial Cir NE","Colonial Crescent","Colonial Crossing","Colonial Ct","Colonial Dr",
            "Colonial Drive","Colonial Manor Dr","Colonial Pky","Colonial Plz","Colonial Rd","Colonial Road",
            "Colonial Ter","Colonial Village Dr","Colonial Way","Colonial Way SE","Colonization Road",
            "Colonna Drive","Colonnade Road","Colony Court","Colony Ct","Colony Drive","Colony Ln","Colony Rd",
            "Colony Rd NE","Colony Road","Colony View Cir","Colony Way","Colorado Ct","Colorado Ct SW",
            "Colorado Mountain Rd NE","Colorado Rd","Colorado River Dr","Colorado St","Colorado Vista",
            "Colrain Road","Colson Ct","Colt Ct","Colt Dr","Colt Rd","Colton Ave","Colton Ct","Colton Dr","Colton St",
            "Colton-Pierrepont Rd","Coltrane Drive","Colts Ln","Colts Neck Rd","Colts Run Rd","Colucci Drive",
            "Coluco Pl","Columbet Ave","Columbia Ave","Columbia Avenue","Columbia Blvd","Columbia Cir",
            "Columbia Ct","Columbia Dr","Columbia Dr E","Columbia Dr N","Columbia Dr S","Columbia Mt St",
            "Columbia Pl","Columbia Place","Columbia Rd","Columbia Rd 160","Columbia Rd 206 W","Columbia Rd 279",
            "Columbia Rd 492","Columbia Rd 67","Columbia Rd 85","Columbia St","Columbia Street","Columbia Ter",
            "Columbia Terrace","Columbia Terrace Turn lane","Columbia Village Dr","Columbia Way",
            "Columbian Ave","Columbian Street","Columbine Ave","Columbine Blvd","Columbine Cir","Columbine Dr",
            "Columbine Pl","Columbine Rd","Columbus Ave","Columbus Avenue","Columbus Blvd","Columbus Cir NW",
            "Columbus City Rd","Columbus Dr","Columbus Jobstown Rd","Columbus Jordan Rd","Columbus Pky",
            "Columbus Pky W","Columbus Pl","Columbus Rd","Columbus Road","Columbus Road E","Columbus St",
            "Columbus St W","Columbus Way","Colusa Hwy","Colusa St","Coluter Pine Ave","Colvard St","Colvin Blvd",
            "Colvin Ct","Colvin Ln","Colvin Street","Colwell St","Colwood Dr","Comal Ct","Comanche Ave",
            "Comanche Ct","Comanche Dr","Comanche Pl","Comanche Rd NE","Comanche Trl","Comb St W","Comberland Dr SE",
            "Combermere Drive","Combine Dr","Combs Ave","Combs Plz","Comegys Rd","Comer Ave","Comet Ct",
            "Comet Ln","Comet Road","Cometa Pl NE","Comey Avenue","Comfort Ave","Comfort Road","Comiche Ct",
            "Coming Thu the Rye Rd SW","Comiskey Rd","Comissioners Rd","Comley Ave","Comly St","Commander Rd",
            "Commerce Aly N","Commerce Ave","Commerce Blvd","Commerce Court","Commerce Ct","Commerce Ct W",
            "Commerce Dr","Commerce Ln","Commerce Pl","Commerce Rd","Commerce St","Commerce St E","Commerce Street",
            "Commerce Valley Drive East","Commerce Valley Drive West","Commerce Way","Commercial Aly",
            "Commercial Ave","Commercial Dr","Commercial Dr S","Commercial Drive","Commercial Rd",
            "Commercial St","Commercial Street","Commercial Ter","Commodore Ave","Commodore Cove Dr",
            "Commodore Dr","Common Avenue","Common Dr","Common Street","Commonmwealth Dr","Commons Dr",
            "Commons Drive","Commonwealth Ave","Commonwealth Avenue","Commonwealth Ct","Commonwealth Dr",
            "Commonwealth Drive","Communica Road","Communipaw Ave","Community Ave","Community Centre Road",
            "Community Dr","Community House","Community House Rd","Community Pl","Community Rd","Community Road",
            "Community St","Community Street","Commuter Way","Comnanti Shannon Rd","Como St","Compadre Ln NE",
            "Company St","Compass Ave","Compass Court","Compound Dr","Comprehensive School Drive",
            "Comptche Ukiah Rd","Compton","Compton Ave","Compton Cres","Compton Crescent","Compton Ct",
            "Compton Ln","Compton Pl","Compton Rd","Comstock Bridge Rd","Comstock Cir W","Comstock Dr",
            "Comstock Pl","Comstock Rd","Comstock Rd NE","Comstock Road","Comstock St","Con Carne Ct",
            "Conant Avenue","Conant Ct","Conant Rd","Conard Ave","Conarroe St","Conaskonk Dr","Concannon Ct",
            "Concepcion St","Concept Mountain Ct","Concessio Road","Concessio Street","Concession 1 Road",
            "Concession 1 Road","Concession 1 Seneca Road","Concession 10 Road","Concession 12 Road",
            "Concession 13 Road","Concession 18 Road","Concession 2","Concession 2 Road","Concession 2 Road",
            "Concession 2 Road W","Concession 2a Road","Concession 3 Road","Concession 4 Road",
            "Concession 4 Road","Concession 4a Road","Concession 5 Road","Concession 5b Road","Concession 6 Road",
            "Concession 6 Road","Concession 7 Road","Concession 7 Road","Concession 8 Road","Concession 8 Road",
            "Concession 8a Road","Concession 9 Road","Concession 9 Road","Concession 9a Road",
            "Concession 9b Road","Concession Road","Concession Road 10","Concession Road E","Concession Street",
            "Conch Cir","Conch Shell Ct","Conchas Pl","Conchas Rd","Conchas St NE","Conchester Hwy","Concho Cir",
            "Concho Rd","Concord Ave","Concord Avenue","Concord Court","Concord Ct","Concord Downs Ave",
            "Concord Dr","Concord Highway","Concord Ln","Concord Pike","Concord Pl","Concord Place","Concord Rd",
            "Concord Road","Concord Square","Concord St","Concord Street","Concord Turnpike","Concord Way",
            "Concord Xing","Concorde Place","Concordia College","Concordia Court","Concordia Pl SW",
            "Concourse Village W","Concow Rd","Concrite Rd","Condalia Ave","Condensery Rd","Condict St",
            "Condin Rd","Condit Ct","Condor Avenue","Condor Cir","Condor Ct","Condor Peak Trail","Condor Pl",
            "Condor St","Condotti Drive","Conduit Street","Cone Dr","Cone Grove Rd","Cone Ln","Cone Road",
            "Conecuh County 13","Conecuh County 45","Conecuh County 47","Conecuh County 5","Conejo Canyon Ct",
            "Conejo Ln","Conejos Valley Rd","Conestoga Cir","Conestoga Court","Conestoga Ct","Conestoga Dr",
            "Conestoga Pky","Conestoga Rd","Conestoga Road","Conewango St","Coney Dr","Coney Island Avenue",
            "Coney Road","Confederate Ridge Dr","Confederation Drive","Confederation Drive","Confederation Parkway",
            "Conforti Ave","Congdon Rd","Conger Ave","Conger Ave S","Conger Ct SW","Conger St","Congers Lake Rd E",
            "Congers Rd","Congo Rd","Congress Alley","Congress Ave","Congress Avenue","Congress Court",
            "Congress Dr","Congress Hall Ln","Congress Pl","Congress Rd","Congress Springs Rd; Big Basin Way",
            "Congress St","Congress St W","Congress Street","Congressman George E. Brown, Jr. Mem. Hwy",
            "Conifer","Conifer Ct","Conifer Dr","Conifer Ln","Coniston Road","Conklin Ave","Conklin Ln",
            "Conley Dr","Conley Rd","Conlins Road","Conmack Ln","Conn Drive","Conn Rail Rd","Connally Ln",
            "Connaught Avenue","Connaught Circle","Connecticut Ave","Connecticut Ct","Connecticut Dr",
            "Connecticut Dr Rhode Island Aly","Connecticut St","Connecticut St NE","Connecting",
            "Connecting Rd","Connector Rd","Connector Road","Connector To Eliot Bridge","Connemara Ave",
            "Conner Dr","Conner Ln","Conner Rd","Conner St","Connerton St","Connery Avenue","Connett Rd",
            "Connettuct","Connie Ave","Connie Ln","Connie Pl","Connie Pl SW","Connifer Rd","Connolly Crescent",
            "Connolly Street","Connor Ave","Connor Ln","Connors St","Conover Ct","Conover Ln","Conover Pl",
            "Conover Rd","Conover St","Conquest Road","Conquista Ave","Conrad Ave","Conrad Cem Rd","Conrad Ln",
            "Conrad Nathan Pl","Conrad St","Conrad Strasse","Conrads Dr","Conrail Railroad","Consecon Main Street",
            "Conser","Conservation Path","Conservation Rd","Constable Bridge Rd","Constable Ln","Constable Pl",
            "Constable Rd","Constable Road","Constable St","Constance Dr","Constantine St","Constantine Way",
            "Constellation Ave","Constellation Crescent","Constellation Dr","Constellation Ln",
            "Constellation Place","Constitution Ave","Constitution Boulevard","Constitution Cir",
            "Constitution Ct","Constitution Dr","Constitution Drive","Constitution Rd","Constitution Road",
            "Constitution St","Constitution Way","Construction Rd","Construction Way","Consuelo Ave",
            "Consul Way","Consumers Road","Conswell Rd","Container Dr","Contau Lake Road","Contempra Cir",
            "Contigani Dr","Continental Ave","Continental Blvd","Continental Ct","Continental Dr",
            "Continental Dr N","Contini Mine Rd","Contintal Dr","Contoocook Ave","Contour Drive","Contra Costa Canal Trail",
            "Contra Costa Place","Contra Way","Contract Rd","Contractors Rd","Convair","Convair Rd","Convent Ave",
            "Convent Rd","Converse St","Converse Street","Conway Ct","Conway Drive","Conway St","Conway Ter",
            "Conwel Rd","Conwell St","Cook Ave","Cook Cir","Cook Circle","Cook Drive","Cook Hill Rd","Cook Ln",
            "Cook Path","Cook Pl","Cook Rd","Cook St","Cook Street","Cook's Ba Drive","Cook's Lake Rd","Cooke Pl",
            "Cookeville Rd","Cookman Ave","Cooks Hill Rd SE","Cooks Rd","Cool Creek Ave","Cool Rd SE",
            "Cool Ridge Ave","Cool Valley Ln","Cool Water Ct","Cool Water Dr","Coolbrook Ct","Cooledge Rd",
            "Cooley Blvd","Cooley Dr","Cooley Rd","Cooleylake Rd","Cooleyville Road","Coolidge Ave","Coolidge Avenue",
            "Coolidge Circle","Coolidge Dr","Coolidge Pl","Coolidge Place","Coolidge St","Coolidge Street",
            "Coolidge Trl","Coombs Ct","Coombs St","Coon Creek Rd","Coon Den Rd","Coon Hill Rd","Coon Point Rd",
            "Coon Rd","Coon Run Rd","Coon Trail Rd","Coon's Road","Cooney Place","Coonhound Ln","Coons Dr",
            "Coontown Rd","Cooper Aly","Cooper Ave","Cooper Canyon Rd","Cooper Cir","Cooper Court","Cooper Creek",
            "Cooper Cv","Cooper Dr","Cooper Hawk Ln","Cooper Landing Rd","Cooper Lane Road","Cooper Ln",
            "Cooper Ranch Ct","Cooper Rd","Cooper Road","Cooper Sand Rd","Cooper Square","Cooper St",
            "Cooper Terrace","Cooper Tomlinson Rd","Cooperage Crescent","Cooperage Ln","Cooperage Road",
            "Cooperative Way","Coopergrove Ave","Coopergrove Dr","Coopers Creek Rd","Coopers F Road",
            "Coopers Falls Road","Coopers Grove Rd","Coopers Kill Rd","Coopertown Apts Rd","Coors Boulevard",
            "Coors Boulevard NW","Coors Pl SW","Coosa St","Cooter Ter","Copa Cabana Ct","Copco Rd","Copeland Avenue",
            "Copeland Cem Rd","Copeland Dr","Copeland Rd","Copeland Road","Copeland Woods Rd","Copeley Rd",
            "Copernicus Drive","Copes Ln","Copicut Road","Copland Ct","Copley Ct","Copley Pl","Copley Rd",
            "Copley St","Copley Street","Copous Rd","Coppard Avenue","Copper Aly","Copper Ave","Copper Beech Ln",
            "Copper Canyon Dr","Copper Canyon Way","Copper Cove Dr","Copper Creek Rd","Copper Crest Dr",
            "Copper Ct","Copper Dr","Copper Lake Ct","Copper Lane","Copper Ln","Copper Meadows Dr","Copper Mine Rd",
            "Copper Moon Ct","Copper Moon Ln","Copper Ridge Dr","Copper Sage St","Copper Springs Dr",
            "Copper Springs Rd","Copper Sun Dr","Copper Trl","Copper Valley Tr","Coppercreek Dr","Coppercrest Dr",
            "Copperfield Ct","Copperfield Ln","Coprice Ct","Copthorne Avenue","Cora Ave","Cora Pl","Cora Rose Ln",
            "Coral Ave","Coral Beach St","Coral Bell Hollow","Coral Ct","Coral Desert Dr","Coral Dr",
            "Coral Harbor Dr","Coral Isle Dr","Coral Ln","Coral Pl","Coral Rd","Coral Rd NW","Coral Ridge SW",
            "Coral Road","Coral Rock Dr","Coral Sea Rd","Coral Shine Ct","Coral St","Coral Street","Coral Tree Dr",
            "Coral Vine Arbor Ave","Coral Way","Coralberry Ct","Coralwood Ct","Coram Rd","Corbett Crescent",
            "Corbett Drive","Corbett Rd","Corbin Aly","Corbin Ave","Corbin Ct","Corbin Hill Rd","Corbin Ln",
            "Corbin Rd","Corby Road","Corcoran Dr","Corcoran Rd","Cord RMRd","Cord Rd","Cord Way","Corda Ln",
            "Cordage Terrace","Cordary Ave","Cordell Ct","Cordero Ct","Cordero Mine Rd","Cordery Ave",
            "Cordes Ct","Cordial Ct","Cordial Road","Cordilleras Trail Connector","Cordon Pl","Cordon Rd",
            "Cordoniz St NW","Cordova","Cordova Brg","Cordova Cir","Cordova Dr","Cordova Port of Entry Brg",
            "Cordova Rd","Cordova Road","Cordova St","Cordova Vista Ct","Cords Ln","Corduroy Rd","Cordwell St",
            "Corella Ct","Coretta Dr","Corey Ct","Corey Cv","Corey Dr","Corey Hill Rd","Corey Ln","Corey Rd",
            "Corey Street","Coreydale Court","Coreys Sawmill Ln","Corfu Pl","Coria Trce","Corina Cir",
            "Corinna Ct","Corinne Crescent","Corinth Gardens","Corinth Rd","Corinthian Dr","Corinthian Rd",
            "Cork Harbor Court","Cork Hill Ct","Cork Hill Rd","Cork Ln","Cork Oak","Corkory Way","Corkstone Glade",
            "Corkum Rd","Corless Ln","Corley Avenue","Corley Rd","Corliss Dr","Corliss St","Corman's Lane",
            "Cormorant Cir","Cormorant Way","Corn Creek Field Station","Corn Crib Ln","Corn Flower Ln",
            "Corn Hollow Rd","Corn Ln","Cornelia Ave","Cornelia St","Cornelia Street","Cornelius Ave",
            "Cornell","Cornell Ave","Cornell Avenue","Cornell Blvd","Cornell Circle","Cornell Court",
            "Cornell Crescent","Cornell Dr","Cornell Meadows Avenue","Cornell Pl","Cornell Rd","Cornell Rouge Boulevard",
            "Cornell St","Cornell Street","Cornell Way","Cornellius St","Corner Br Trail","Corners Ranch Cv",
            "Cornerstone Cir","Cornfield Lane","Cornflower Ln","Cornhusk Rd","Corning Blvd","Cornish Dr",
            "Cornish Drive","Cornish Rd","Cornish St","Cornstill Rd SE","Cornus Ln","Cornus Plz","Cornwall Ave",
            "Cornwall Dr","Cornwall Ln","Cornwall Road","Cornwall Sq","Cornwall Street","Cornwallis Dr",
            "Cornwallis Drive","Coro Cv","Coro Rd","Coromar Drive","Corona","Corona Ave","Corona Ave NE",
            "Corona Ct","Corona Dr","Corona Rd","Corona Redonda","Corona St","Coronado Ave","Coronado Ave NE",
            "Coronado Blvd","Coronado Dr","Coronado Freeway","Coronado Fwy","Coronado Loop","Coronado Mal",
            "Coronado St","Coronado State Monument","Coronado Trl","Coronatio Drive","Coronation Boulevard",
            "Coronation Road","Coronet Dr","Coronet Ln","Coronet Rd","Corono","Corporal Church","Corporate Center Dr",
            "Corporate Ct","Corporate Dr","Corporate Dr W","Corporate Pl","Corporate Pl S","Corps Pl",
            "Corps Rd","Corral Canyon Rd","Corral Cir","Corral Creek Rd","Corral Dr","Corral Hollow Rd",
            "Corral Pl","Corral Rd","Corral de Quati","Corralitos Rd","Corralitos View Rd","Corralones Rd",
            "Corriander Ct","Corrib Ct","Corridor D","Corrigan Ave","Corrigan Close","Corrigan Dr","Corrine St",
            "Corrine Street","Corrington Rd","Corrinne Ct","Corry Ln","Corsair Ln","Corsalo Rd","Corsay Rd",
            "Corsbie Cir SW","Corsica Ln","Corsica Rd","Corsica Way","Corson Ln","Corsons Tavern Rd",
            "Cort 11/8","Cort 30","Cort Cir","Corta Bella Way","Corta Madre Way","Corte Almonte","Corte Bernardo",
            "Corte Breve","Corte Briones","Corte Calandria","Corte Cindarella","Corte Descanso","Corte Dorada NW",
            "Corte Enano","Corte Escobar","Corte Floradora","Corte Lucinda","Corte Luna","Corte Madeira",
            "Corte Madera Ave","Corte Madera Ln","Corte Mar de Brisa","Corte Pastoral","Corte Pico Verde",
            "Corte Playa Jacinto","Corte Rosaire","Corte San Fernando","Corte Sobrado","Corte Torero",
            "Corte Vera Cruz","Corte Viernes N","Corte Vista","Corte de Colores","Corte de Encanto",
            "Corte de Flores","Corte de Rosa","Corte de la Reina","Corte del Pozo","Cortes Ct","Cortez Ave",
            "Cortez Avenue","Cortez Ct","Cortez Dr","Cortez Ln","Cortez Pl","Cortez Place","Cortez Rd","Cortez Way",
            "Cortland Avenue","Cortland Dr","Cortland Ln","Cortland Pl","Cortland Rd","Cortland St","Cortland Street",
            "Cortland Way","Cortlandt Pl","Cortlandt St","Corto Dr","Corto St","Cortona Dr","Cortright Rd",
            "Corttis Rd","Corunna Ln","Corvado Dr","Corvair","Corvair Ct","Corvair Dr","Corvallis Ct","Corvato Ct",
            "Corvette Avenue","Corvette Dr","Corvette Rd","Corwin Ave","Corwin Ct","Corwin Dr","Corwin Rd",
            "Corwin Street","Corwine Ln","Cory Allen","Cory Canyon Rd","Cory Dr","Cory Ln","Cory Rd","Cory St",
            "Coryell Street","Coryland Rd","Corylus Plz","Cosburn Avenue","Cosburn Road","Cosby Rd","Cosby Road",
            "Cosca Dr","Cosentino Gardens","Cosett Rd","Cosgrove Creek Rd","Cosklo Rd","Cosmic Ln SW",
            "Costa Ave","Costa Azul","Costa Road","Costelow Ct","Coston Ave","Costonia Mt Tabor Rd","Costonia Rd",
            "Cosumnes Mine Rd","Cosumnes View Trl","Cosygrove Cir","Cote Ln","Cote Rd","Cotillion Ct",
            "Cotluss Rd","Cotorro Ct","Cotswold Cir","Cotswold Ct","Cotswold Ln","Cotswold Pl","Cotta St",
            "Cottage Ave","Cottage Avenue","Cottage Circle","Cottage Ct","Cottage Dr W","Cottage Green",
            "Cottage Grove Dr","Cottage Lane","Cottage Ln","Cottage Park","Cottage Pl","Cottage Place",
            "Cottage Rd","Cottage Road","Cottage Row","Cottage St","Cottage Street","Cottage Way","Cottageville-Cedar Run Rd",
            "Cottaquilla Rd","Cottesmore Avenue","Cotteswood Place","Cottingha Crescent","Cottingha Road",
            "Cottingham Street","Cotton","Cotton Court","Cotton Ct","Cotton Drive","Cotton Gin Rd","Cotton Ln",
            "Cotton Pl","Cotton Rd","Cotton St","Cotton Weed Cove Rd","Cotton Wood","Cottongrass Lane",
            "Cottonridge Cir","Cottontail Ct","Cottontail Dr","Cottontail Ln","Cottontail Rd","Cottontop Rd",
            "Cottonwood","Cottonwood Ave","Cottonwood Cir","Cottonwood Creek","Cottonwood Ct","Cottonwood Ct SE",
            "Cottonwood Dr","Cottonwood Drive","Cottonwood Grove","Cottonwood Grove Trl","Cottonwood Hill Ave",
            "Cottonwood Ln","Cottonwood Ranch Rd","Cottonwood Rd","Cottonwood Road","Cottonwood St",
            "Cottonwood Trl","Cottrell Rd","Cottrelle Boulevard","Cotty Dr","Cotus Rd","Couch Crescent",
            "Coudersport-Jersey Shore Hwy","Cougar","Cougar Ave","Cougar Canyon Way","Cougar Ct","Cougar Dr",
            "Cougar Falls Ct","Cougar Ln","Cougar Pass Rd","Cougar Ridge Rd","Cougar Rock Rd","Cougar St",
            "Cougar Walk","Coughlin Dr","Coules Court","Coulson Dr NE","Coulter Avenue","Coulter Ct",
            "Coulter Drive","Coulter Rd","Coulters Rd","Coulterville Rd","Coultrap Rd","Council Dr","Council Ring Road",
            "Council Rock Ave","Council St","Counsello Terrace","Count Fleet St","Countess Ave","Countess Ct",
            "Country Air Ln","Country Club","Country Club Blvd","Country Club Cir","Country Club Cir NW",
            "Country Club Ct","Country Club Dr","Country Club Ln","Country Club Ln E","Country Club Pl",
            "Country Club Place","Country Club Rd","Country Club Rd W","Country Club Road 1","Country Club Shores W",
            "Country Creek Dr","Country Dr","Country Estates Drive","Country Farm Way","Country Flats Ln",
            "Country Forge Ln","Country Gables Dr","Country Glen","Country Glen Ct","Country Glen Dr",
            "Country Glen Road","Country Hill Ln","Country Hills Rd","Country Juniper Ln","Country Lake Dr",
            "Country Lane","Country Ln","Country Meadow Ct","Country Mill Dr","Country Oaks Dr","Country Rd",
            "Country Rd 14","Country Ridge Ct","Country Squire Way","Country Trl","Country View Dr",
            "Country View Ln","Country View Way","Country Village Ln","Country Village Rd","Country Villas Twhm",
            "Country Vista Ln","Country Way","Country Wood Ln","Country Woods Ln","Countrybrook Ln",
            "Countryridge Ln","Countryside Cir","Countryside Crescent","Countryside Dr","Countryside Ln",
            "Countryside St NE","Countrywood Ct","Counts Rd","County 1 Road","County 1 Road E","County 10 Road",
            "County 12 Road","County 16 Road","County 17 Road","County 18 Road","County 2 Road","County 20 Road",
            "County 20918 Rd","County 21 Road","County 22 Road","County 23 Road","County 24 Road",
            "County 25 Road","County 27 Road","County 29 Road","County 3 Road","County 36 Road","County 4 Road W",
            "County 40 Road","County 41 Road","County 42 Road","County 46 Road","County 47 Road","County 48 Road",
            "County 5 NW","County 5 Blvd","County 5 Road","County 50 Road","County 504 Road","County 51 Road",
            "County 57 Road","County 6 Road","County 6 Road S","County 64 Road","County 67","County 7 Road",
            "County 70","County 8 Road","County 9 Road","County Center 3 Ct","County Club Rd","County Farm Rd",
            "County Highway 1","County Highway 129","County Highway 13","County Highway 19","County Highway 202",
            "County Highway 204","County Highway 236","County Highway 239","County Highway 30",
            "County Highway 36","County Highway 3A","County Highway 4","County Highway 45","County Highway 456",
            "County Highway 457","County Highway 46","County Highway 49","County Highway 5","County Highway 524",
            "County Highway 58","County Highway 60","County Highway 61","County Highway 614","County Highway 627",
            "County Highway 628","County Highway 72","County Highway 739","County Highway B","County Highway D",
            "County Highway G","County Highway H","County Highway H-44","County Highway I","County Highway J",
            "County Highway J41","County Highway K","County Highway K60","County Highway LLI","County Highway N",
            "County Highway Q","County Highway T","County Home Rd","County House Rd","County Hwy C",
            "County Institutional Road","County Line Road","County Line Church Rd","County Line Creek Rd",
            "County Line Rd","County Line Road","County Line Road (Ave 0)","County Nine Rd","County Park Rd",
            "County Quarry Rd","County Rd","County Road","County Road 0-8","County Road 0006","County Road 002",
            "County Road 0078","County Road 010","County Road 1","County Road 1-53","County Road 1-69",
            "County Road 1-71","County Road 1/Carman Road","County Road 10","County Road 1005",
            "County Road 100A","County Road 101","County Road 102","County Road 103","County Road 104",
            "County Road 1043","County Road 104A","County Road 105","County Road 106","County Road 107",
            "County Road 1078","County Road 1081","County Road 1087","County Road 109","County Road 11",
            "County Road 110","County Road 1100","County Road 1104","County Road 111","County Road 1110",
            "County Road 1116","County Road 1119","County Road 112","County Road 1120","County Road 113",
            "County Road 1132-A","County Road 114","County Road 1140","County Road 115","County Road 116",
            "County Road 1160","County Road 117","County Road 119","County Road 1192","County Road 11A",
            "County Road 12","County Road 120","County Road 1202","County Road 121","County Road 1212",
            "County Road 122","County Road 1225","County Road 1228","County Road 123","County Road 124",
            "County Road 1240","County Road 1242","County Road 1246","County Road 125","County Road 1253",
            "County Road 125B","County Road 126","County Road 1269","County Road 127","County Road 128",
            "County Road 12A","County Road 13","County Road 130","County Road 131","County Road 133",
            "County Road 134","County Road 1366","County Road 137","County Road 138","County Road 1387",
            "County Road 14","County Road 140","County Road 141","County Road 142","County Road 1420",
            "County Road 1426","County Road 143","County Road 1435","County Road 144","County Road 1442",
            "County Road 145","County Road 146","County Road 149","County Road 1492","County Road 15",
            "County Road 15 S","County Road 150","County Road 1504","County Road 151","County Road 1533",
            "County Road 1536","County Road 154","County Road 155","County Road 156","County Road 157",
            "County Road 1575","County Road 158","County Road 1589","County Road 159","County Road 159 (Springhill)",
            "County Road 16","County Road 160","County Road 160 (Browning Rd","County Road 161",
            "County Road 162","County Road 163","County Road 1631","County Road 164","County Road 165",
            "County Road 166","County Road 1674","County Road 168","County Road 169","County Road 17",
            "County Road 170","County Road 171","County Road 172","County Road 1728","County Road 175",
            "County Road 176","County Road 179","County Road 18","County Road 180","County Road 181",
            "County Road 182","County Road 183","County Road 1831","County Road 184","County Road 185",
            "County Road 188","County Road 189","County Road 18A","County Road 18C","County Road 19",
            "County Road 190","County Road 190A","County Road 191","County Road 194","County Road 195",
            "County Road 196","County Road 197","County Road 199","County Road 1B","County Road 2",
            "County Road 2 N","County Road 2 SE","County Road 2 C F","County Road 2 F A","County Road 2 G A",
            "County Road 2 P A","County Road 2-12","County Road 2-2","County Road 2-48","County Road 2-49",
            "County Road 2-55","County Road 20","County Road 2000","County Road 200A","County Road 201",
            "County Road 202","County Road 203","County Road 204","County Road 205","County Road 206",
            "County Road 2071","County Road 2073","County Road 209","County Road 21","County Road 2103",
            "County Road 2103 E","County Road 2103 C","County Road 2103 D","County Road 2103 F",
            "County Road 211","County Road 2114","County Road 211B","County Road 212","County Road 2120B",
            "County Road 2124","County Road 213","County Road 214","County Road 217","County Road 2170",
            "County Road 218","County Road 219","County Road 21B","County Road 22","County Road 221",
            "County Road 222","County Road 2229","County Road 223","County Road 2232","County Road 2235",
            "County Road 224","County Road 225","County Road 225 A","County Road 226","County Road 228",
            "County Road 229","County Road 23","County Road 232","County Road 233","County Road 2333",
            "County Road 234","County Road 235","County Road 2357","County Road 2358","County Road 236",
            "County Road 238","County Road 2380","County Road 23A","County Road 24","County Road 240",
            "County Road 2404","County Road 242","County Road 245","County Road 246","County Road 247",
            "County Road 249","County Road 25","County Road 25/19","County Road 251","County Road 252",
            "County Road 253","County Road 2530","County Road 254","County Road 257","County Road 25A",
            "County Road 26","County Road 260","County Road 261","County Road 262","County Road 263",
            "County Road 264","County Road 265","County Road 266","County Road 267","County Road 27",
            "County Road 270","County Road 274","County Road 276","County Road 2786","County Road 27A",
            "County Road 28","County Road 280","County Road 2812","County Road 282","County Road 283",
            "County Road 284","County Road 285","County Road 29","County Road 290","County Road 2900",
            "County Road 293","County Road 295","County Road 297","County Road 298","County Road 299",
            "County Road 3","County Road 3 E","County Road 3 D A Lizard","County Road 3-23","County Road 30",
            "County Road 3008","County Road 301","County Road 3014","County Road 302","County Road 3020",
            "County Road 3021","County Road 3027","County Road 303","County Road 3032","County Road 3035",
            "County Road 305","County Road 306","County Road 3062","County Road 3066","County Road 307",
            "County Road 3074","County Road 308","County Road 309","County Road 3097","County Road 30A",
            "County Road 31","County Road 3103","County Road 311","County Road 3123","County Road 313",
            "County Road 314","County Road 3149","County Road 315","County Road 316","County Road 3167",
            "County Road 317","County Road 3173","County Road 318","County Road 3182","County Road 31A",
            "County Road 32","County Road 3217","County Road 322","County Road 324","County Road 325",
            "County Road 326","County Road 327","County Road 3273","County Road 328","County Road 329",
            "County Road 33","County Road 330","County Road 331","County Road 332","County Road 3325",
            "County Road 3327","County Road 333","County Road 336","County Road 3381","County Road 3389",
            "County Road 339","County Road 34","County Road 342","County Road 343","County Road 344",
            "County Road 3443","County Road 345","County Road 346","County Road 349","County Road 35",
            "County Road 350","County Road 351","County Road 3518","County Road 352","County Road 3551",
            "County Road 3553","County Road 357","County Road 358","County Road 3590","County Road 35A",
            "County Road 36","County Road 3616","County Road 362","County Road 363","County Road 37",
            "County Road 3709","County Road 371","County Road 375","County Road 376","County Road 377",
            "County Road 38","County Road 382","County Road 383","County Road 386","County Road 38A",
            "County Road 38F","County Road 39","County Road 395","County Road 3951","County Road 396",
            "County Road 3CA","County Road 3KA","County Road 4","County Road 4 FA","County Road 4 H D",
            "County Road 4 H F","County Road 4 KG","County Road 40","County Road 400","County Road 4003",
            "County Road 4006","County Road 4009","County Road 401","County Road 4010","County Road 402",
            "County Road 4026","County Road 403","County Road 4036","County Road 404","County Road 405",
            "County Road 407","County Road 408","County Road 41","County Road 410","County Road 4120",
            "County Road 414","County Road 4141","County Road 415","County Road 416","County Road 418",
            "County Road 418A","County Road 419","County Road 42","County Road 42 E","County Road 4202",
            "County Road 421","County Road 422","County Road 424","County Road 427","County Road 428",
            "County Road 429","County Road 43","County Road 430","County Road 431","County Road 433",
            "County Road 436","County Road 438","County Road 44","County Road 442","County Road 444",
            "County Road 447","County Road 448","County Road 449","County Road 45","County Road 451",
            "County Road 452","County Road 453","County Road 4531","County Road 456","County Road 458",
            "County Road 459","County Road 46","County Road 460","County Road 4608","County Road 461",
            "County Road 462","County Road 465","County Road 469","County Road 47","County Road 472",
            "County Road 474","County Road 48","County Road 480","County Road 4840","County Road 485",
            "County Road 487","County Road 488","County Road 49","County Road 491","County Road 492",
            "County Road 494","County Road 495","County Road 5","County Road 50","County Road 50/16",
            "County Road 500","County Road 5020","County Road 503","County Road 504","County Road 505",
            "County Road 506","County Road 507","County Road 509","County Road 51","County Road 510",
            "County Road 511A","County Road 512","County Road 513","County Road 514","County Road 517",
            "County Road 518","County Road 519","County Road 5190C","County Road 52","County Road 520",
            "County Road 5200","County Road 521","County Road 522","County Road 524","County Road 526",
            "County Road 527(Alt)","County Road 528","County Road 5281","County Road 53","County Road 530",
            "County Road 530 A","County Road 532","County Road 533","County Road 535","County Road 536",
            "County Road 537","County Road 539","County Road 54","County Road 540","County Road 541",
            "County Road 542","County Road 543","County Road 544","County Road 545","County Road 5461",
            "County Road 547","County Road 548","County Road 549","County Road 549A","County Road 55",
            "County Road 550","County Road 5500","County Road 551","County Road 5512","County Road 553",
            "County Road 554","County Road 555","County Road 556","County Road 559","County Road 560",
            "County Road 5601","County Road 561","County Road 565","County Road 566","County Road 5671",
            "County Road 5680","County Road 569","County Road 57","County Road 570","County Road 572",
            "County Road 575","County Road 577","County Road 58 C","County Road 580","County Road 581 East",
            "County Road 583","County Road 5861","County Road 589","County Road 59","County Road 6",
            "County Road 60","County Road 600","County Road 6000-1","County Road 601","County Road 604",
            "County Road 605","County Road 606","County Road 6070","County Road 6074","County Road 61",
            "County Road 610","County Road 613","County Road 614","County Road 615","County Road 62",
            "County Road 621","County Road 622","County Road 6220","County Road 625","County Road 627",
            "County Road 628","County Road 629","County Road 63","County Road 6300","County Road 632",
            "County Road 633","County Road 635","County Road 637","County Road 639","County Road 639;Newark Ave",
            "County Road 63B","County Road 64","County Road 64/18","County Road 644","County Road 646",
            "County Road 648","County Road 649","County Road 65","County Road 650","County Road 651",
            "County Road 652","County Road 653","County Road 654","County Road 655","County Road 657",
            "County Road 658","County Road 659","County Road 66","County Road 661","County Road 665",
            "County Road 67","County Road 671","County Road 672","County Road 6720","County Road 677",
            "County Road 68","County Road 686","County Road 69","County Road 699","County Road 6A",
            "County Road 7","County Road 70","County Road 7001","County Road 7030","County Road 7032",
            "County Road 7033","County Road 7041","County Road 71","County Road 710","County Road 711",
            "County Road 7167","County Road 717","County Road 72","County Road 722","County Road 7250",
            "County Road 7252","County Road 726","County Road 727","County Road 728","County Road 73",
            "County Road 730","County Road 732","County Road 733","County Road 734","County Road 737",
            "County Road 74","County Road 742","County Road 743","County Road 745","County Road 746",
            "County Road 749","County Road 75","County Road 7520","County Road 7575","County Road 75A",
            "County Road 7615","County Road 767","County Road 7675","County Road 77","County Road 770",
            "County Road 771","County Road 78","County Road 780","County Road 781","County Road 783",
            "County Road 79","County Road 798","County Road 8","County Road 80","County Road 801",
            "County Road 803","County Road 804","County Road 8041","County Road 8059","County Road 8060",
            "County Road 81","County Road 813","County Road 814","County Road 819","County Road 820",
            "County Road 822","County Road 8227","County Road 823","County Road 826","County Road 83",
            "County Road 84","County Road 846","County Road 847","County Road 85","County Road 852",
            "County Road 8532","County Road 857","County Road 859","County Road 86","County Road 862",
            "County Road 865","County Road 868","County Road 87","County Road 874","County Road 876",
            "County Road 88","County Road 881","County Road 888","County Road 89","County Road 89 N",
            "County Road 9","County Road 90","County Road 903","County Road 905","County Road 9085",
            "County Road 909","County Road 91","County Road 92","County Road 9212","County Road 927",
            "County Road 93","County Road 938","County Road 94","County Road 940","County Road 946",
            "County Road 948","County Road 949","County Road 953","County Road 955","County Road 958",
            "County Road 96","County Road 97","County Road 98","County Road 980","County Road 985",
            "County Road 988","County Road 99","County Road 993","County Road 995","County Road 996",
            "County Road 9A","County Road A","County Road A-13","County Road A-15","County Road A-21",
            "County Road A-25","County Road A-33","County Road A-40","County Road A-49","County Road A001",
            "County Road A005","County Road A007","County Road A009","County Road A010","County Road A012",
            "County Road A016","County Road A017","County Road A022","County Road A023","County Road A035",
            "County Road A038","County Road A039","County Road A045","County Road A051","County Road A066",
            "County Road A078","County Road A083","County Road A1","County Road A12","County Road A120",
            "County Road A128","County Road A142","County Road A154","County Road A176","County Road A18A",
            "County Road A19A","County Road A3","County Road A74","County Road B-063","County Road B-52",
            "County Road B005","County Road B006","County Road B017","County Road B018","County Road B023",
            "County Road B024","County Road B026","County Road B030","County Road B039","County Road B040",
            "County Road B044","County Road B046","County Road B050","County Road B089","County Road B108",
            "County Road B26","County Road B30A","County Road C","County Road C-1","County Road C-30",
            "County Road C-32","County Road C-39","County Road C-429","County Road C-46","County Road C-48-A",
            "County Road C-50-E","County Road C-54","County Road C-57-A","County Road C-58","County Road C-58-C",
            "County Road C-61","County Road C001","County Road C002","County Road C003","County Road C004",
            "County Road C006","County Road C015","County Road C022","County Road C025","County Road C031",
            "County Road C035","County Road C036","County Road C040","County Road C041","County Road C045",
            "County Road C047","County Road C049","County Road C074","County Road C087","County Road C124",
            "County Road C58A Conejo","County Road C6","County Road CO12","County Road CO19","County Road CO20",
            "County Road CO31","County Road Cl","County Road Cn","County Road Coo","County Road Ct",
            "County Road D","County Road D006","County Road D036","County Road DD","County Road DO87",
            "County Road Dl","County Road E 026","County Road E 33","County Road E002","County Road E007",
            "County Road E013","County Road E020","County Road E023","County Road E035","County Road E069",
            "County Road E1405","County Road E1446","County Road EE-2","County Road Ee 5","County Road F035",
            "County Road F051","County Road Faf","County Road Ffi","County Road Ffn","County Road G",
            "County Road G002","County Road G004","County Road G012","County Road G013","County Road G015",
            "County Road H H","County Road H-10","County Road I","County Road I A","County Road I C",
            "County Road II","County Road J","County Road J-1","County Road JJ","County Road Ks","County Road L",
            "County Road Lb","County Road Lf","County Road Lga","County Road Lia","County Road M",
            "County Road N-3-N","County Road N291","County Road N4783","County Road N4792","County Road N8G01",
            "County Road Np","County Road O","County Road P-1","County Road PP","County Road Pc","County Road Pee",
            "County Road Ppe","County Road Pra","County Road Q","County Road R","County Road R110",
            "County Road RD64","County Road Rl","County Road S","County Road Seee53","County Road T",
            "County Road TT","County Road V","County Road W 38","County Road W-2","County Road W102",
            "County Road W154","County Road W38","County Road WW","County Road Wood 330","County Road Wood 338",
            "County Road Wood 364","County Road X","County Road Y","County Road Z-2","County Road at",
            "County Route 1","County Route 1/22","County Route 1/6","County Route 1/7","County Route 1/8",
            "County Route 10","County Route 10/6","County Route 11/7","County Route 119/12","County Route 119/13",
            "County Route 119/2","County Route 119/32","County Route 12/5","County Route 13","County Route 13/6",
            "County Route 13/9","County Route 15","County Route 15/2","County Route 152A","County Route 16/1",
            "County Route 16/2","County Route 16/4","County Route 16/6","County Route 17/2","County Route 17/4",
            "County Route 18","County Route 18/15","County Route 18/2","County Route 18/3","County Route 19",
            "County Route 19/1","County Route 19/24","County Route 2","County Route 2/1","County Route 2/2",
            "County Route 20","County Route 20/4","County Route 20/6","County Route 21","County Route 21/2",
            "County Route 21/3","County Route 22","County Route 220/7","County Route 23/2","County Route 23/4",
            "County Route 24","County Route 25/14","County Route 25/5","County Route 26","County Route 26/4",
            "County Route 28","County Route 28/1","County Route 29","County Route 29/3","County Route 3",
            "County Route 3/11","County Route 3/12","County Route 3/2","County Route 3/4","County Route 3/6",
            "County Route 3/7","County Route 3/9","County Route 30","County Route 30/3","County Route 31/2",
            "County Route 31/8","County Route 315","County Route 32","County Route 32/1","County Route 34",
            "County Route 35/24","County Route 35/6","County Route 36","County Route 38","County Route 38/5",
            "County Route 4","County Route 4/5","County Route 4/7","County Route 40","County Route 40/2",
            "County Route 40/3","County Route 40/5","County Route 41A","County Route 42/6","County Route 4230",
            "County Route 43/1","County Route 44/6","County Route 451","County Route 46","County Route 46/8",
            "County Route 48","County Route 5","County Route 5 Jersey Mtn Rd","County Route 5/10",
            "County Route 5/5","County Route 50/18","County Route 50/2","County Route 50/26","County Route 50/28",
            "County Route 50/31","County Route 50/39","County Route 52","County Route 54","County Route 56",
            "County Route 58","County Route 58/1","County Route 58A","County Route 6/3","County Route 60/12",
            "County Route 62/18","County Route 621","County Route 626","County Route 64","County Route 7",
            "County Route 7/1","County Route 7/2","County Route 7/3","County Route 8","County Route 8/2",
            "County Route 8/9","County Route 87/3","County Route 9","County Route 9/3","County Route 9/6",
            "County Route 92","County Route J40","County Rt 3/10 Rd","County Rt 36","County Rt 74",
            "County Way","Countyr Club Rd","Coupland Rd","Cour Royale","Courchesne Rd","Courelette Road",
            "Cours de Clemenceau","Cours de Martinique","Cours de Pasteur","Coursen Pl","Coursen St",
            "Coursen Way","Coursey Ln","Courson Dr","Court 22","Court 3","Court 30","Court Access Rd","Court Ave",
            "Court Cowan","Court Dr","Court F","Court House Sq","Court I","Court Ln","Court Pl","Court San Bernardo",
            "Court Sq","Court St","Court Street","Court Ter","Court U","Courtenay Cir","Courter Ln","Courtesy Ave",
            "Courtesy Blvd","Courtfield Cir","Courthouse Sq","Courtice Road","Courtland Ave","Courtland Rd",
            "Courtland St","Courtland Street","Courtly Manor Dr","Courtney Crescent","Courtney Dr",
            "Courtney Ln","Courtney Pl","Courtney St","Courtneypark Drive E","Courtneypark Drive East",
            "Courtois Ln","Courtright Ln","Courtside Cir","Courtview Dr","Courtview Dr SW","Courtwright Road",
            "Coushatta Ln","Cousins Trailer Ct","Cousintown Rd","Coutolenc Rd","Couture Gardens","Covati Ct",
            "Cove Acess Rd","Cove Ave","Cove Avenue","Cove Cir","Cove Creek Rd","Cove Crescent","Cove Cross Rd SE",
            "Cove Ct","Cove Dr","Cove Pl","Cove Point Dr","Cove Rd","Cove Road","Cove St","Cove Street","Cove Way",
            "Covel Street","Covelo Rd","Covelo St","Covenant Ln","Covenant Way","Coventry Cir","Coventry Circle",
            "Coventry Close St","Coventry Court","Coventry Ct","Coventry Dr","Coventry Dr NW","Coventry Ln",
            "Coventry Pl","Coventry Rd","Coventry Road","Coventry Street","Coventry Ter","Coventry Way",
            "Cover St","Coverdale Drive","Covered Brg","Covered Bridge Rd","Covered Wagon Rd","Covert Ct",
            "Coves End Road","Covey Ct","Covey Ln","Covey Quail Ln","Covey Rd","Covington Ave","Covington County 67",
            "Covington Dr","Covington Rd","Covington Ter","Cow Camp Rd","Cow Head Saddle Trail","Cow Path",
            "Cow Path Dr","Cow Path Rd","Cowan Ave","Cowan Avenue","Cowan Cir","Cowan Circle","Cowan Dr",
            "Cowan Ln","Cowan Street","Cowboy Ln","Cowboy Way","Cowden Ave","Cowee Ave","Cowell St","Cowgirl Ct",
            "Cowie Court","Cowing St","Cowles Ave","Cowles Lane","Cowley Ln","Cowley Rd","Cowpath Ct","Cowpen Creek Rd",
            "Cowper Ave","Cox Ave","Cox Blvd","Cox Boulevard","Cox Creek Pky S","Cox Dr","Cox Farm Rd","Cox Hollow",
            "Cox Mill Road","Cox Rd","Cox St","Cox Street","Coxfarm Road","Coxs Crossing Rd","Coxs Dr","Coxworth Avenue",
            "Coy Smith Hwy","Coyan Way","Coyle Creek Cir","Coyle Ct","Coyote Bluff","Coyote Bush Rd",
            "Coyote Canyon Rd","Coyote Cir","Coyote Creek Trail","Coyote Crescent","Coyote Dr","Coyote Gap Rd",
            "Coyote Loop","Coyote Pass","Coyote Point","Coyote Rd","Coyote Ridge Ct","Coyote Ridge Rd",
            "Coyote Run Rd","Coyote St","Coyote Trl","Coyote Valley Way","Coyote Vista Rd","Coyote Way",
            "Coyt Rd","Cozy Ave","Cozy Ln","Cozy Ojai Rd","Cozy Street","Cozyloft Dr","Cp Dr","Cr","Cr-5","Crab Apple Dr",
            "Crab Apple Ln","Crabapple Ct","Crabapple Dr","Crabapple Ln","Crabtree Ct","Crabtree Ln",
            "Crabtree Rd","Crabtree Road","Crabtree Trl","Cracker Asphalt Rd","Cracker Ln","Craddock Dr",
            "Craddock St","Craft Ln","Craft Rd","Crafton Cir","Craftons Park Ln","Cragg Rd","Cragin Dr",
            "Cragmont Dr","Craig Ave","Craig Cave Rd","Craig Crecent","Craig Ct","Craig Dr","Craig Hill Ln",
            "Craig Ln","Craig Mitchell Ln","Craig Rd","Craig Road","Craig St","Craig Street","Craig-tide Way",
            "Craighead 361 Rd","Craighead 373 Rd","Craighead 386 Rd","Craighead 463 Rd","Craighead 467 Rd",
            "Craighead 528 Rd","Craighead 636 Rd","Craighead 715 Rd","Craighead 733 Rd","Craighead 912 Rd",
            "Craighead 916 Rd","Craigheadova Cv","Craiglee Drive","Craigmont Ave","Craik Road","Crain Ln",
            "Crain Rd","Craine Rd","Cram Pl","Cramblett Rd","Cramer Ave","Cramers Corners Rd","Crammer Ave",
            "Crammer Ln","Crampton Ave","Cranberry Aly","Cranberry Ave","Cranberry Bog","Cranberry Bog Access Rd",
            "Cranberry Bog Rd","Cranberry Bogs Access Rd","Cranberry Court","Cranberry Dr","Cranberry Lake Road",
            "Cranberry Lane","Cranberry Lane Hyannis","Cranberry Ln","Cranberry Meadow Road","Cranberry Pl",
            "Cranberry Pond Path","Cranberry Rd","Cranberry Run Dr","Cranberry Shores Ln","Cranbrook Ct",
            "Cranbrook Ln","Cranbrook St NE","Cranbrook Way","Cranbrooke Avenue","Crandall Drive",
            "Crandall Pl","Crandall Rd","Crandall St","Crandell Dr","Crane","Crane Ave","Crane Avenue","Crane Creek Rd",
            "Crane Ct","Crane Dr SW","Crane Hill Rd","Crane Ln","Crane Rd","Crane Rd SW","Crane St","Crane Street",
            "Crane Valley Rd","Crane Way","Cranebrook Dr","Cranebrook Drive","Cranford Hall","Cranford Rd",
            "Cranford St","Crang Avenue","Cranleigh St","Cranmore Cir","Cranmore Rd","Cranston Park Avenue",
            "Cranston Street","Cranwood Dr","Cranwood Dr SW","Crary Rd","Crater Pl","Crater View Dr",
            "Cratin Pl","Craven Rd","Craven Road","Craven St","Craven Ter","Cravens Rd","Crawford","Crawford Ave",
            "Crawford Avenue","Crawford Ct","Crawford Drive","Crawford Hill","Crawford Ln","Crawford Park Rd",
            "Crawford Rd","Crawford Rose Drive","Crawford St","Crawford Street","Crawford Way","Crawforth Street",
            "Crawmer Rd SE","Crayford Drive","Crayton Ct","Crazy Horse Trl","Crazy Rabbit Rd","Crazyhorse St",
            "Cread Ct","Creag Ave","Creal Rd","Cream Street","Creameary Rd","Creamery Ct","Creamery Ln",
            "Creamery Rd","Creamery Road","Creamy Rd","Creanona Boulevard","Crease Rd","Crease St","Credit Woodlands Court",
            "Creditstone Road","Creditview Road","Cree Trl","Creek 113","Creek 13","Creek 1A","Creek 37",
            "Creek Ave","Creek B-5","Creek C-58-D","Creek Ct","Creek Dr","Creek Dr SE","Creek Hill Ln","Creek Hollow Rd",
            "Creek P","Creek Rd","Creek Ridge Rd","Creek Road","Creek Street","Creek Trl","Creekbank Dr",
            "Creekbank Road","Creekdale Ln","Creekhaven Dr","Creekhollow Ln","Creekline Dr","Creekside Cir",
            "Creekside Ct","Creekside Dr","Creekside Ln","Creekside Rd","Creekside Way","Creekview Circle",
            "Creekview Ct","Creekview Dr","Creekview Ln","Creekview Path","Creekview Pl","Creekview Trce",
            "Creekwood Dr","Creekwood Ln","Creel Rd","Creemer Ave","Creeper Hill Road","Creery Avenue",
            "Creetown Cir","Creetown Ln","Crefeld Ct","Creighton Avenue","Creighton Rd","Creighton Street",
            "Cremeans Rd","Crenshaw Ave","Crenshaw Ct","Crenshaw Rd","Creola Cir","Crepe Myrtle Dr","Cres Vista Ave",
            "Cresane Street","Crescendo Avenue","Crescendo Dr","Crescendo St","Crescent Ave","Crescent Avenue",
            "Crescent Beach","Crescent Bend","Crescent Blvd","Crescent Court","Crescent Creek Ct",
            "Crescent Dr","Crescent Dr S","Crescent Drive","Crescent Hill Avenue","Crescent Meadow Rd",
            "Crescent Pl","Crescent Place","Crescent Rd","Crescent Road","Crescent St","Crescent Street",
            "Crescent Way","Crescenta Ct","Crescentwood Drive","Cresent Pl","Cresent St","Creservoir Rd",
            "Crespi Cir","Crespi Dr","Crespi Way","Cress St","Cressey Avenue","Cressey St","Cresskill Ave",
            "Cresswell Road","Cressy Dr","Cressy Lakeside Road","Crest Ave","Crest Ave SE","Crest Ct",
            "Crest Dr","Crest Dr N","Crest Heights","Crest Ln","Crest Pl","Crest Rd","Crest Rd SE","Crest St",
            "Crest Trail","Crest View Ave","Crest View Rd","Crest Way","Cresta Dr","Cresta Luna Ct NE",
            "Crestdale Rd","Crestdale Road","Cresthaven Dr","Cresthaven Rd","Cresthill Dr","Crestlake Cir",
            "Crestland Ave NW","Crestlane Ct","Crestline Dr","Crestline Rd","Crestmont Rd","Crestmore St",
            "Creston Ave","Creston Pl","Creston Rd","Creston Ridge Rd","Creston St","Creston-Eureka Rd",
            "Crestridge Ct","Crestridge Ln","Crestridge Rd","Crestview Ave","Crestview Avenue","Crestview Cir",
            "Crestview Ct","Crestview Dr","Crestview Dr SW","Crestview Ln","Crestview Pl","Crestview Rd",
            "Crestview St","Crestway Road","Crestwood Ave","Crestwood Cir","Crestwood Ct","Crestwood Dr",
            "Crestwood Drive","Crestwood Pl","Crestwood Rd","Crestwood Road","Crestwood Trl","Creswick Court",
            "Creswick Road","Creveling Rd","Crevi Rd","Crewe Avenue","Crewenen Road","Crews Rd","Crews St",
            "Crickard Dr","Cricket Cir","Cricket Ct","Cricket Drive","Cricket Hill Dr","Cricket Hill Rd",
            "Cricket Hill Road","Cricket Knoll","Cricket Lane","Cricket Ln","Cricket Park Ct","Crickett Ct",
            "Crickett Ln","Cricklewood Drive","Cricklewood St SW","Crider Rd","Crieff Avenue","Crile Rd",
            "Crill Rd","Crim Rd","Crimson","Crimson Court Mobile Park","Crimson Dr","Crimson Fire Ct",
            "Crimson Leaf Dr","Crimson Ln","Crimson Tide Ave","Crine Ln","Crinella Ct","Crinkleroot Clearing",
            "Crisafulli Trl","Criscione Drive","Criscoe Street","Crisfield Cir","Crisp Canyon Rd",
            "Crispin Rd","Criss St SE","Crisscross","Crissey Ln","Cristallina Way","Cristian Rd","Cristisle Dr",
            "Cristo Dr","Cristo Rey Ave","Cristobal Dr","Criswell Rd","Critchlow Rd","Crite St","Crivelli Aisle",
            "Crock St NE","Crockamhill Drive","Crocker Blvd","Crocker Circle","Crocker Lane","Crocker Mansion Drive",
            "Crocker St","Crockery Shore Ct","Crockett Rd","Crockett Yard Rd","Crocus Ct","Crocus Drive",
            "Crocus Ln","Croft Ln","Croft Street","Croft Way","Crofton Ct","Crofton Way","Crombie Street",
            "Cromer Rd","Cromer St","Cromo Dr","Cromwell Ave","Cromwell Ct","Cromwell Road","Cromwell St",
            "Cron Way","Cronig Avenue","Cronin Drive","Cronin Road","Cronin St","Crook Ave","Crook Rd","Crooked Brook Dr",
            "Crooked Creek Dr","Crooked Ledge Road","Crooked Run Rd","Crooked Tree Dr","Crooked Trl",
            "Croom Rd","Cropley Ave","Cropper St","Cropsey Ave","Cropsey Avenue","Cropwell Ct","Crosbie Rd",
            "Crosby Ave","Crosby Avenue","Crosby Cir","Crosby Ln","Crosby Pl","Crosby Road","Crosby St",
            "Crosby Street","Crosby Way","Crosland Drive","Crosley Street","Crosley Truck Trail","Cross",
            "Cross Acres","Cross Ave","Cross Bronx Expressway","Cross Brook Ct","Cross Canyon Trail",
            "Cross Court","Cross Cre Road","Cross Creek Ct","Cross Creek Dr","Cross Creek Ln","Cross Creek Oval",
            "Cross Cut Rd","Cross Dr","Cross Farm Rd","Cross Fox Ct","Cross Hill Cir","Cross Hill Road",
            "Cross Lake Rd","Cross Ln","Cross Marin","Cross Mountain Rd","Cross Park Blvd","Cross Ranch Rd",
            "Cross Rd","Cross Road","Cross Roads","Cross Slope Ct","Cross St","Cross Street","Cross Street Cotuit",
            "Cross Timbers Ct","Cross Way","Cross the Brook Ave","Crossan Ave","Crosscut Rd","Crossdale Ave",
            "Crossett Pl","Crossett Rd","Crossfoot Terrace Ct","Crosshaven Pl","Crosshill St","Crossing Boulevard",
            "Crossing Ct","Crossing Ln","Crossing Way","Crossland Rd","Crossley Pl","Crossley Rd","Crossley Way",
            "Crosslynne Ave","Crossman Rd","Crossovers Street","Crosspike Dr","Crossridge Dr","Crossroads",
            "Crossroads Drive","Crossroads Rd","Crosstown Fwy","Crossville Rd","Crosswick Ave","Crosswicks Ellisdale Rd",
            "Crosswicks St","Crosswind Rd","Crosswind Way","Crosswinds St","Croswell Rd","Croteau Dr",
            "Crothers Ct","Croton Rd","Crotty Rd","Crotty St","Crouch Ave","Crouthamel Rd","Crow Creek Ave",
            "Crow Hill Rd","Crow Lake Road","Crow Lane","Crow Ln","Crow Point Rd","Crow Rd","Crow St","Crow Trl",
            "Crowder Road","Crowe Rd","Crowell Ave","Crowell Road","Crowell St","Crowes Purchase Road",
            "Crowland Avenue","Crowland Road","Crowley - Shermin Road","Crowley Lake Drive","Crowley Ln",
            "Crowley St","Crowleys Ridge Rd","Crown Acres Court","Crown Crescent","Crown Ct","Crown Dr",
            "Crown Pl","Crown Point Rd","Crown Rd","Crown Road","Crown Street","Crown Valley Ln","Crown Valley Pky",
            "Crown's Lane","Crowne Point Pky","Crownshield Avenue","Crows Landing Road","Crows Mill Rd",
            "Crows Nest","Crowsnest Crescent","Croydon Ct","Croydon Rd","Croydon Tpke","Crozer St","Crozier Lane",
            "Crozier Road","Crugers Ave","Crugers Rd","Cruikshank Rd N","Cruise Rd","Cruiser Ct","Crumbling Ct",
            "Crumhorn Mt Rd","Crumpton Dr","Crumwald Ln","Crusader Ave","Cruse Ave","Cruvers Trl","Cruz Ct",
            "Cruz Rd","Cruz Tierra St","Crypess Corner Rd","Crystal Ave","Crystal Bay Dr","Crystal Beach Boulevard",
            "Crystal Cave Cir","Crystal Cavern Way","Crystal Commons Dr","Crystal Creek Rd","Crystal Ct",
            "Crystal Downs Ct","Crystal Dr","Crystal E Main","Crystal Falls Dr","Crystal Hill","Crystal Hwy",
            "Crystal L Road","Crystal Lake","Crystal Lake Road","Crystal Lake Ave","Crystal Lake Rd",
            "Crystal Lake Terrace","Crystal Ln","Crystal Mile Ct","Crystal Park Rd","Crystal Ridge Rd SW",
            "Crystal Ridge Way","Crystal Road","Crystal Rock Cir","Crystal S Drive","Crystal Spring Road",
            "Crystal Springs Rd","Crystal St","Crystal Valley Ct SE","Crystal Veiw Dr","Crystal Way",
            "Crystalwood Dr","Cth H","Cty Rd N 95","Cty Road 3320","Cty Rte 5/1Waites Run Rd","Cuatro Vistas Dr",
            "Cub Lake Rd","Cub Rd","Cub St","Cubberly Rd","Cubert Street","Cubist Ct","Cubs Pl","Cucamonga Ave",
            "Cuccolo Ln","Cuchilla de Lupe Rd","Cuchillo de Oro","Cucumber Hill Rd","Cuda Dr","Cuddy Valley Rd",
            "Cudneys Rd","Cudworth Place","Cue Ball Spur","Cuervo Dr","Cuervo Dr NE","Cuesta Brava Ln",
            "Cuesta Ct","Cuesta Dr","Cuff Rd","Cuffley Crescent N","Cuidado Ln","Cul de Sac 2","Culdorf St",
            "Culford Pl","Culford Road","Culham Trail","Cullen Ave","Cullen Ct","Cullen Dr","Cullipher Ln",
            "Cullman Mtwy","Culloden Ct","Culotta Ln","Culp Dr","Culpepper Ave","Culpepper Cir","Culture Dr NE",
            "Culver Blvd","Culver Ct","Culver Hill Rd","Culver Rd","Culver St","Culvert Dr","Culvert Street",
            "Culverwell St","Cumber Avenue","Cumberlan Road","Cumberland Ave","Cumberland Ct","Cumberland Dr",
            "Cumberland Outdoor Club Rd","Cumberland Pl","Cumberland Rd","Cumberland St","Cumbre Negra St",
            "Cumbre Rd","Cumiskey St","Cummer Avenue","Cumming Ave","Cummings","Cummings Ave","Cummings Hill Rd",
            "Cummings Rd","Cummings Street","Cummins Dr","Cumulus Dr","Cuna Ct","Cunard Ave","Cunard Pl",
            "Cuneo Rd","Cunha Dr","Cunha Road","Cunico Rd","Cunningham Dr","Cunningham Rd","Cunningham Way",
            "Cupid Dr","Cupids Dart St","Cupio St","Cupples Trl","Cupsaw Ct","Cupsaw Dr","Curacao","Curandero Pl",
            "Curbelo Way","Curdsen Way","Curfman","Curlew Ct","Curly Horse Rd","Curly Ln","Curran Ave","Curran Memorial Highway",
            "Currans Ln","Currant Aly","Curren Rd","Currey Ave","Currey Crescent","Curricabark Rd","Currie Ave",
            "Currie Rd","Currie Street","Currier Court","Currier Ln","Currier Pl","Currier St","Currier Street",
            "Currier Way","Currierville Rd","Curry","Curry Aly","Curry Ave","Curry Comb Rd","Curry Ln","Curry Rd",
            "Curry Rd 24","Curry Road 1","Curry Road 3","Curry Road 6","Curry Road 9","Curry Road Ab",
            "Curry Road Ae","Curry Road Ah","Curry Road Ai","Curry Road V","Curry Road Z","Curry St",
            "Curry Ter","Curt Byrum Pl","Curtain Dr","Curtis Ave","Curtis Crescent","Curtis Ct","Curtis Dr",
            "Curtis Ln","Curtis Pl","Curtis Point Dr","Curtis Pond Rd","Curtis Rd","Curtis Road","Curtis St",
            "Curtis Street","Curtis Way","Curtiss Rd","Curtiss Street","Curtner Ave","Curtola Pky","Curtwood Dr",
            "Curve Street","Curwen Cir","Curzon Avenue","Curzon Street","Cushendall Ct","Cushetunk Rd",
            "Cushing Ave","Cushing Ct","Cushing Road","Cushing Way","Cushman Rd","Cushman Street","Cushman Terrace",
            "Custer Ave","Custer Crescent","Custer St","Custer Valley Rd","Custom Ct","Custom Lumber Ln",
            "Customs Dr","Cut Across Rd","Cut Off Dr","Cut Off Rd","Cut Off Road","Cuthbert Blvd","Cuthbert Rd",
            "Cuthbert St","Cutlass Dr","Cutler Drive","Cutler Highway","Cutler Rd","Cutler Road","Cutler St",
            "Cutler St SW","Cutler Street","Cutover Rd SE","Cutter Ave","Cutter Ct","Cutter Ln","Cutter Pky SE",
            "Cutter Rd","Cutter Way","Cutterfield Road","Cutters Court","Cutthroat Cir","Cutthroat Ln",
            "Cuttin Lake Trl","Cutting Ave","Cutting Blvd","Cuttings Corner","Cuttler School Rd","Cutty Sark Ct",
            "Cutty Sark Dr","Cuyama Ave","Cuyler St","Cuzco Ct","Cyclone St","Cycod Pl","Cygnet Ct","Cygnet Rd",
            "Cymbidium Cir","Cynthia Avenue","Cynthia Cir","Cynthia Ct","Cynthia Dr","Cynthia St","Cynwood Dr",
            "Cynwyd Ave","Cynwyd Cir","Cynwyd Dr","Cyphers Rd","Cypress Ave","Cypress Avenue","Cypress Bay Ave",
            "Cypress Cir","Cypress Circle","Cypress Court","Cypress Creek Ave","Cypress Crest Ln",
            "Cypress Ct","Cypress Dr","Cypress Dr SW","Cypress Island Ct","Cypress Lake Ct","Cypress Ln",
            "Cypress Mountain Dr","Cypress Pky","Cypress Point Ct","Cypress Ranch Rd","Cypress Rd",
            "Cypress Road","Cypress St","Cypress Street","Cypress Way","Cypressvalle St","Cyprus Ln",
            "Cyr St","Cyress St","Cyril Martin Place","Cyrus Cir","D","D 75","D A R Dr","D Amico Ave","D Ave",
            "D Ave N","D Dr NE","D L Jones Rd","D O Mills Ct","D P Rd","D P W Dr","D Ranch Rd","D Rd","D St","D St N",
            "D Street","D W Field West Parkway","D'Allesio Dr","D'Arby Point Lane","D'Arcy Magee Crescent",
            "D'Artisan Road","D'ambrosio Way","D'arcy Street","D-Walker Rd","D-Way","D0556 Rd","D0893 Rd",
            "D0894 Rd","D1028 Rd","D4756 Rd","D4765","D4820","D91A","DNA Way","Dabneys Rd","Dack Boulevard","Dacoata Path",
            "Dacosta Dr","Dacosta St","Dacre Ave","Dacus Lake Rd","Dacus Rd","Dacy Ave","Dad's Lake Rd",
            "Dades Thwy","Dads Hill Rd","Daewoo Pl","Daffodil Cir","Daffodil Ct","Daffodil Dr","Daffodil Pl",
            "Dafni Cir","Dafoe Court","Dafoe Crescent","Daggett Way","Dahill Road","Dahl St","Dahlgreen Pl",
            "Dahlia Ave","Dahlia Court","Dahlia Ct","Dahlia Dr","Dahlia Pl","Dahlia St","Dahlia Ter","Daikers Cir",
            "Dailey Ave","Dailey Dr","Dain Avenue","Daina Ct","Daines Dr","Dairy Ave","Dairy Barn Dr","Dairy Farm Rd",
            "Dairy Rd","Daisey Dr","Daisey Rd","Daisy Aly","Daisy Avenue","Daisy Blvd","Daisy Ct","Daisy Ct NE",
            "Daisy Dr","Daisy Gold Ct","Daisy Hill Ln","Daisy Hill Rd","Daisy Ln","Daisy Mae Ln","Daisy Pl",
            "Daisy Rd","Daisy St","Daka Ct","Dakar St","Dakin Rd","Dakota Ave","Dakota Ct","Dakota Ln","Dakota Rd",
            "Dakota St","Dakota St NE","Dakota Station Ln","Dakota Street","Dakota Trl","Dal-mor Road",
            "Daldon Ln","Dale Ave","Dale Avenue","Dale Court","Dale Creek Rd","Dale Ct","Dale Douglas Rd",
            "Dale Dr","Dale Evans Pky","Dale Ll Ln","Dale Ln","Dale Pl","Dale Potter Rd","Dale Rd","Dale Road",
            "Dale St","Dale Street","Daleberry Place","Dalebrook Rd","Dalemere Rd","Dalemount Avenue",
            "Dalerose Ct","Daleview Ct","Daleville Rd","Dalewood Ct","Dalewood Dr","Daley Ave","Daley Dr",
            "Daley Rd","Daley St","Dalfield Dr","Dalgeish Avenue","Dalgreen Pl","Dalhousie Crescent",
            "Dalhousie Street","Daliba St","Dalies Ave","Dalington Rd","Dalis Dr","Dall Ln","Dallarda Dr",
            "Dallas","Dallas 101","Dallas 263","Dallas 319","Dallas 411","Dallas 429","Dallas Ave","Dallas County 101",
            "Dallas County 109","Dallas County 3","Dallas County 30","Dallas County 361","Dallas County 39",
            "Dallas County 403","Dallas County 404","Dallas County 414","Dallas County 519","Dallas County 560",
            "Dallas County 62","Dallas County 81","Dallas County 86","Dallas County 932","Dallas County 933",
            "Dallas County 952","Dallas County 960","Dallas Dr","Dallas Ln","Dallas Rd","Dallas Road",
            "Dallas St","Dallas St SE","Dallas Street","Dalley Dr","Dally Ct","Dalmas Road","Dalmatian Dr",
            "Dalmatian St","Dalmeny Road","Dalrymple Drive","Dalson Rd","Dalston Road","Dalton Court",
            "Dalton Ct","Dalton Dr","Dalton Hwy","Dalton Lane","Dalton Parkway","Dalton Rd","Dalton Road",
            "Dalton Street","Daly Dr","Daly Rd","Daly St","Dam","Dam Rd","Dam Site Loop","Damage Ditch","Damas Pl",
            "Damascus Dr","Damask Rose Ct","Damassa Rd","Dambacher Rd","Dambrasca Ct","Damgaard Rd","Damien Way",
            "Damin","Damon Dr","Damon Drive","Damon Lane Minot","Damon Ln","Damon St","Damons-point Road",
            "Damper Cir","Dampier Cir","Damron Rd","Damrose Rd","Damson St","Dan East Trl","Dan Fox Drive",
            "Dan Mitchell Rd","Dan St","Dan Wood Dr","Dana Ave","Dana Avenue","Dana Bluff East","Dana Ct",
            "Dana Dr","Dana Pl","Dana Point Harbor Dr","Dana Road","Dana St","Dana St NE","Dana Street",
            "Danabirch","Danar St","Danbi Dr","Danbrook Ct","Danbrook Dr","Danbury Ct","Danbury Dr","Danby Dr",
            "Danby Pl","Danby Rd","Danby Way","Dance Hal Lane","Dance Hall Dr","Dancer Dr","Dancie Dr","Dancing Vines Ave",
            "Dandelion Ct","Dandy Dude Dr","Dane Avenue","Dane Rd","Dane Street","Danebrock Dr","Danecroft Ave",
            "Daned Rd","Danemar Dr","Danese Ln SE","Daneswood Road","Danforth Avenue","Danforth Cir",
            "Danforth Road","Danforth Road E","Danforth Road W","Dani Ln","Daniel Ave","Daniel Branch Rd",
            "Daniel Cir NW","Daniel Creek Road","Daniel Ct","Daniel Dr","Daniel Finn Circle","Daniel Ln",
            "Daniel Low Ter","Daniel Rd","Daniel Shays Highway","Daniel St","Daniel Street","Daniel Way",
            "Daniel Webster Hwy","Daniell Ct","Daniell Dr","Danielle Dr","Danielle Drive","Danielle Ter",
            "Danielle Way","Daniels Ave","Daniels Chapel Rd","Daniels Dr","Daniels Island Road","Daniels Rd",
            "Daniels Ridge Rd","Daniels Road","Daniels St","Daniels Street","Danielson Ave","Danika Dr NW",
            "Danlyn Ct","Danlyn Dr","Dann Dr","Danna Ct","Dannack Hill Rd","Dannemiller Ave SW","Danner Cv",
            "Danny Cv","Danny Pl","Dannybrook Cir","Dano Blvd","Danridge","Dans Rd SE","Dante Ct","Dante St",
            "Dantes View Road","Dantin Ct","Dantz Run Rd","Danube Ave","Danver Ln","Danvers Way","Danville Amity Rd",
            "Danville Ct","Danville Mountain Rd","Danville Rd","Daos Ct","Daphna Rd","Daphne Ave","Daphne Cir NE",
            "Daphne Rd","Daponte Dr","Dapple Ct","Dapple Grey Trl","Dar Pl","Dar Valley Rd","Dara Ct","Dara Lane",
            "Darby Ave","Darby Dr","Darby Ln","Darby Paoli Rd","Darby Rd","Darcel Avenue","Darcie Dr","Darcie Ln",
            "Darcy Ave","Darcy Ln","Darcy St","Darcy Street","Dare Ave","Dare Ln","Dare St","Darek Dr","Daretown Rd",
            "Dari Ct","Daria Dr","Darien Ct","Darien Rd","Dark Hollow Rd","Dark Lane Rd","Dark Ln","Dark Peak Dr",
            "Dark Sky Dr","Dark Star Ave","Darla Dr","Darla St","Darla's Ln","Darlap Pl","Darlen Cir","Darlene Ave",
            "Darlene Cir","Darlene Dr","Darlene Ln","Darlene Ter","Darling Ave","Darling Cabin Ct","Darling Court",
            "Darling Dr","Darling Ln","Darling Rd","Darling Road","Darling Street","Darling Way","Darlington Ave",
            "Darlington Ct","Darlington Dr","Darlington Park Road","Darlington-Clarke Townline",
            "Darmody Ave","Darnay Rd","Darpinian Way","Darr Rd","Darrah Pl","Darrah Rd","Darran Dr","Darras Court",
            "Darrell Rd","Darrell St","Darren Ln","Darrens Way","Darrett Ct","Darrow Ct","Darryl Dr","Darst Rd",
            "Dart St","Dart Street","Dartanian Place","Darte Drive","Dartford Road","Dartmoor Ct","Dartmouth Ave",
            "Dartmouth College Highway (Rt","Dartmouth Ct","Dartmouth Dr","Dartmouth Dr SE","Dartmouth Ln",
            "Dartmouth Pl","Dartmouth Rd","Dartmouth Road","Dartmouth St","Dartmouth Street","Dartnell Avenue",
            "Darton St","Darts Mill Rd","Dartts Cross Rd","Darvel Ln","Darwin Dr","Darwin Pl","Darwin Road",
            "Darwin Way","Daryl Ave","Daryl Ln","Darymple St","Dascomb Road","Dash Place","Dash St","Dashner Rd",
            "Dassance Rd","Dassing Ave","Datchet Close","Datchet Road","Date Ave","Date Creek Ave","Date Farm Rd",
            "Date Grove Rd","Date Rd","Datyon Way","Dau Ct","Daugherty Rd","Daulton Dr","Daval Rd","Dave Cole Rd",
            "Dave Dr","Davean Drive","Davebrook Road","Davenport - 3rd St","Davenport - 4th St","Davenport Ave",
            "Davenport Rd","Davenport Road","Davenport St","Davenport Street","Daventry Ct","Davern Ave",
            "Davern Lane","Davey Ave","Davey Boulevard","Davey Pl","Davey-Mendenhall Rd","David Allen Way",
            "David Ave","David Ct","David Ct SW","David Dr","David Heard Rd","David Jones Spur","David Lewis Rd",
            "David Ln","David Pl","David Rd","David St","David Street","David Ter","David Way","Davidoff Street",
            "Davidson Ave","Davidson Blvd","Davidson Co Road","Davidson Dr","Davidson Ln","Davidson Rd",
            "Davidson Road","Davidson St","Davies Ave","Davies Crescent","Davies Ln","Davies St","Davin Park Dr",
            "Davina Dr","Davinci Ct","Davinwood Dr","Davis Aly","Davis Ave","Davis Cir","Davis Court","Davis Creek",
            "Davis Ct","Davis Ct SW","Davis Cup Dr","Davis Dr","Davis Drive","Davis Hill Rd","Davis Hwy",
            "Davis Ln","Davis Lock Road","Davis Pl","Davis Ranch Rd","Davis Rd","Davis Ridge Rd","Davis Road",
            "Davis St","Davis Station Rd","Davis Street","Davis Xing","Davison Ave; W Davison Ave",
            "Davison Ct","Davison Rd","Davoli Way","Davos Dr","Davy Dr","Dawes Ave","Dawes Dr","Dawes Ln N",
            "Dawley Rd","Dawlish Avenue","Dawn Ave","Dawn Blvd","Dawn Cir","Dawn Cir NW","Dawn Crossing Dr",
            "Dawn Ct","Dawn Ct NE","Dawn Cypress Ln","Dawn Dr","Dawn Drive","Dawn Garden Ave","Dawn Ln",
            "Dawn Pl","Dawn St","Dawnflower St","Dawnshire Dr","Dawson Ave","Dawson Avenue","Dawson Ct",
            "Dawson Dr","Dawson Easement","Dawson Pl","Dawson Rd","Dawson St","Dawson Street","Day Ave",
            "Day Ave SW","Day Avenue","Day Dr","Day Lilly Ct","Day Lily Ct","Day Pl","Day Pond Rd","Day Rd",
            "Day School Rd","Day St","Day Star Rd","Daya Way","Daybreak Ln","Dayer Cir","Daylight Ave","Daylon Ct",
            "Daymond St","Dayna Dr","Days Rd","Days Xing","Dayton Ave","Dayton Ct","Dayton Rd","Dayton St",
            "Dayton Street","Daytona Ave","Daytona St","Daytown Road","Daywell St","Dazzling Ter","De Adalena St",
            "De Angelis Dr","De Baker St","De Benedetti Ct","De Caro Rd Spur 1","De Chalie Road","De Courcy Court",
            "De Ferrari Ct","De Foe Ave","De Forest Cir","De Forest St","De Fouri St","De Garmo Dr","De Haven Crk Rd",
            "De Kalb Jct Rensselaer Falls Rd","De Korte Dr","De Laurenti Ct","De Leon Ave","De Leon Cir",
            "De Long Ave","De Long St","De Luz Rd","De Luz Truck Trail","De Marco Boulevard","De Mello Rd",
            "De Meo St","De Met Dr","De Nada","De Neve Ln","De Osma St","De Palma Ave","De Palma St","De Paul Cir",
            "De Pumpo Ln","De Remer Mountain Rd","De Ronde Pl","De Salvo Ct","De Solo Dr","De Spain Ln",
            "De Vaca Ct","De Vargas Rd","De Vere Gardens","De Vicenzo Ct","De Vinci Ct","De Vry Dr","De Witt St",
            "De Wolff Ave","De la Farge Dr","De la Luz Cir","De la Rosa Ln","De la Vina Pl","De la Vina St",
            "DeMeritt Circle","Dea's Field Rd","Deacon Dr","Deacon Lane","Deacon Lee Trl","Deacon Pl",
            "Deacon Rd","Deacon St","Deacon's Way","Dead End Rd","Dead Horse Canyon Rd","Dead Horse Trl",
            "Dead Lake Rd","Dead Stream","Deadlock Bay Road","Deadmans Creek Rd","Deakin St","Deal Esplanade",
            "Deal Rd","Dealy Ln","Dean","Dean Ave","Dean Avenue","Dean Ct","Dean Dr","Dean Edmond Rd","Dean Ln",
            "Dean Martin Blvd","Dean Martin Dr","Dean Martin Drive","Dean Park Road","Dean Place",
            "Dean Rd","Dean Road","Dean St","Dean Street","Dean Trl","Dean View Cir","Deanbank Drive","Deane Dr",
            "Deane Field Crescent","Deann Trl","Deanna Pl","Deanna Ter","Deans Branch Rd","Dearborn",
            "Dearborn Ave","Dearborn Avenue","Dearborn Cir","Dearborn Dr","Dearborn Lane","Dearborn Ln",
            "Dearborn Rd","Dearborn St","Dearborn Street","Dearborne Ave","Dearborne St","Dearham Wood",
            "Dearing St","Dearman Fork Rd","Deasy Lane","Death Valley National Park","Death Valley Rd",
            "Deatsville Hwy","Deauville Dr","Deb-Mar Woods Pl","Debacker Rd","Debaron Ln","Debbie Ct",
            "Debbie Dr","Debbie Lane","Debbie Ln","Debbie Rd","Debbie St","Debbie Way","Debby Ave","Debby Dr",
            "Debby Ln","Debby St","Debchar Ct","Debevoise Avenue","Debevoise Pl","Debevoise Street","Deblaquire Street N",
            "Deblaquire Street S","Deblon Ct","Deborah Ln NE","Deborah Rd","Deborah Ter","Debord Dr",
            "Debra Ann Lane","Debra Ave","Debra Avenue","Debra Dr","Debra Lee Ct","Debra Ln","Debra St",
            "Debron Ct","Dec Truck Trail","Decamp Dr","Decatur Ave","Decatur Dr","Decatur Rd","Decatur St",
            "Decatur St S","Dechard St","Decicco Pass","Decicco Rd","Decker","Decker Blvd","Decker Dr","Decker Hill Rd",
            "Decker Pky E","Decker Pl","Decker Rd","Decker School Ln","Decker St","Decker Ter","Deckers Park",
            "Deckertown Tpke","Decks Pl","Declair Road","Decosta Circle","Decotah Trl","Dederer St","Dee Dr",
            "Deed Ave","Deeks Road","Deele Road","Deep Bay Road","Deep Creek Dr","Deep Dale Dr E","Deep Dell Pl",
            "Deep Dene Drive","Deep Hill Rd","Deep Hollow Ln","Deep River Rd","Deep Rock Rd","Deep Run Cv",
            "Deep Run Rd","Deep Valley Trl","Deep Water Cir","Deep Waters Ct","Deep Wood Drive","Deep Woods Dr",
            "Deepdale Drive","Deepriver Dr","Deepwell Rd","Deepwood Ct","Deepwood Trl","Deer","Deer Acres Ln",
            "Deer Ave","Deer Bay Drive","Deer Canyon Dr","Deer Creek","Deer Creek Blvd","Deer Creek Circle",
            "Deer Creek Ct","Deer Creek Dr","Deer Creek Ln","Deer Creek Rd","Deer Creek St","Deer Creek Wildlife Mgt Area",
            "Deer Cross Dr","Deer Drive","Deer Field Cir","Deer Flat Rd","Deer Foot Trl","Deer Haven Dr",
            "Deer High Rd","Deer Hill Ln","Deer Hill Rd","Deer Hill Run South","Deer Hollow Ct","Deer Hollow Dr",
            "Deer Hollow Rd","Deer Horn Ave","Deer Horn Court","Deer Isle Dr","Deer Lake Rd","Deer Lake Rd E",
            "Deer Ln","Deer Meadow Dr","Deer Oaks Dr","Deer Park","Deer Park Ave","Deer Park Cemetery",
            "Deer Park Cir","Deer Park Dr","Deer Park Drive","Deer Park Rd","Deer Park Ridge Ave",
            "Deer Path","Deer Path Ct","Deer Path Ln","Deer Path Rd","Deer Path Way","Deer Pen Road",
            "Deer Point","Deer Pond Rd","Deer Ridge Rd","Deer Run","Deer Run Court","Deer Run Ct","Deer Run Dr",
            "Deer Run Ln","Deer Run Rd","Deer Run Road","Deer Run St","Deer Run Trl","Deer Spring Ct",
            "Deer Spring Rd","Deer Springs Ln","Deer Springs Way","Deer St","Deer Tr","Deer Track Ln",
            "Deer Track Run","Deer Trail","Deer Trail Ct","Deer Trail Cv","Deer Trail Ln","Deer Trl",
            "Deer Valley Ct","Deer Valley Dr","Deer Valley Ln","Deer Valley Rd","Deer Woods Ln","Deerbrook Drive",
            "Deerbrook Street","Deercreek Ct","Deere Ct","Deerfield","Deerfield Ave","Deerfield Avenue",
            "Deerfield Ct","Deerfield Dr","Deerfield Drive Sq","Deerfield Ln","Deerfield Parkway",
            "Deerfield Pl","Deerfield Rd","Deerfield Road","Deerfield St","Deerfield Turn","Deerfoot Ln",
            "Deerhaven Rd","Deerhorn Rd","Deerhurst","Deerhurst Avenue","Deerhurst Court","Deerhurst Dr",
            "Deerhurst Drive","Deering Avenue","Deering Cir","Deering Square","Deerlick Brook Rd",
            "Deermont Rd","Deerpath Rd","Deerskin Rd","Deerwood Ct","Deerwood Dr","Deerwood Rd","Deese Rd",
            "Defiance Ave","Defiance Rd","Deforest Ct","Degagne Ct","Degan Hill Rd","Degaris Avenue",
            "Degas Drive","Degelow Rd","Degen Ln","Degeorge Cir","Degovia Ave","Degraw Ave","Degraw Street",
            "Degroat Rd W","Degroff Pl","Dehaan Loop","Dehart Pl","Dehart St","Dehirsch Ave","Dehnz Ln",
            "Dehoff Canyon Rd","Dehon St","Deibler Dr","Deidre Dr","Deidrick Rd","Deirdra Ct","Deirdre Ct",
            "Deisius St","Deitrick Hill Rd","Dejordy Road","Dekalb St","Dekens Ct","Dekoven Court","Del Carbo Rd",
            "Del Cielo Ct","Del Dotto Ct","Del Este Dr","Del Francesco Way","Del Lago Dr","Del Luz Rd",
            "Del Mar Ave","Del Mar HOV ramp entrance","Del Mar Point","Del Mar Scenic Pky","Del Mira Dr",
            "Del Monte Blvd","Del Monte Ln","Del Monte St","Del Mundo","Del Norte","Del Norte Dr","Del Norte Ln",
            "Del Norte St","Del Obispo Trailer Park Rd","Del Ora Ave","Del Oro St","Del Paso Rd","Del Prado",
            "Del Ray Ct","Del Rey Ct","Del Rey Dr","Del Rey Rd","Del Rio Ave","Del Rio Cir","Del Rio Rd",
            "Del Rio Way","Del Rosa Dr","Del Sol Blvd","Del Sol Ct","Del Sol Dr","Del Sol Ln","Del Sol Pl",
            "Del Sol Rd SE","Del Sur Way","Del Valle Pl","Del Valle Rd","Del Venturi Rd","Del Vista Way",
            "Dela Vina Ave","Delabra Road","Delacorte Cir","Delacy Ave","Delafield Ave","Delafield Avenue",
            "Delafield Pl","Delaguera St","Delair Ave","Delamar Loop NW","Delamare Dr","Delamater Rd",
            "Delamo Woods Dr","Delancey","Delancey Pl","Delancey Rd","Delancey St","Delanco Rd","Deland A Park",
            "Delaney Dr","Delaney Drive","Delaney Hill Rd","Delaney Way","Delaney's Ln","Delano Ave",
            "Delano Ln","Delano Pl","Delano Place","Delano St","Delany Dr","Delany Hill Rd","Delaport Way",
            "Delauney Ave","Delavan Ave","Delavan Ave W","Delavan Pl","Delavan St","Delaverne Rd","Delaware",
            "Delaware & Raritan Canal Towpath","Delaware Ave","Delaware Avenue","Delaware Basin Rd",
            "Delaware Ct","Delaware Dr","Delaware Expressway","Delaware Pky","Delaware Pl","Delaware Rd",
            "Delaware Route 1","Delaware St","Delaware Trl","Delaware Water Gap Nra","Delaware Xing",
            "Delbarton Ct","Delbert Street","Delcliff Cir","Delco Ave","Deldise Dr","Delekas Ave","Delevan Dr",
            "Delevan Rd","Delf Dr","Delfern Rd","Delfire Street","Delford Ave","Delgado Pl","Delhaien Court",
            "Delhi St NE","Delhurst Dr","Delia Court","Delia Ct","Delia Dr","Delia Ln","Delicato Way","Delikat Ln",
            "Delilah Rd","Deline Rd","Delings Cove Rd","Delisle Gate","Dell Ave","Dell Avenue","Dell Dr",
            "Dell Park Avenue","Dell Road","Dell St","Dell Way","Dell Wood Rd","Della Camera Ave","Della Ct",
            "Della Dr","Della Rd","Della Robbia Ln","Della Run","Della Street","Dellano Street","Dellavalle Ave",
            "Dellbrook Crescent","Deller Rd","Delleview Aly","Dellinger Acres Rd","Dells Ln","Delltop Ln",
            "Dellview Ct","Dellwood Ave","Dellwood Cir","Dellwood Rd","Delma Rd","Delma Woods","Delmar Ave",
            "Delmar Dr","Delmar Rd","Delmar St","Delmont Ave","Delmont Avenue","Delmonte Road","Delnice Drive",
            "Delnore Place","Deloach Rd","Deloraine Avenue","Delores Ave","Deloro Road","Delovich Rd",
            "Delpenn Dr","Delphi Ct","Delphia St","Delpine Rd","Delran Pky","Delray Ave","Delsea Dr","Delsea Dr N",
            "Delsea Manor","Delsed Woods Dr","Delsie St","Delta Ave","Delta Bluffs Blvd","Delta Ct","Delta De Anza Regional Trail",
            "Delta Dr","Delta Lake Blvd","Delta Pl","Delta Ranch Dr","Delta Rd","Delta Road","Delta Road 104",
            "Delta Road 14","Delta Road 4","Delta St","Delta Street","Delta View Rd","Deltic Rd","Delton St",
            "Delvin Way","Delwit Ave","Delwood Drive","Demarest Ave","Demarest Ct","Demarest Mill Ct",
            "Demarest Mill Rd","Demarest Pl","Demarest St","Demarius St","Demeduk Court","Demeo St","Demeter Rd",
            "Demetrius Ave","Demi Rd","Deming Rd","Deming St","Deming Way","Democrat Rd","Demond Avenue",
            "Demond Rd","Demorest Ave","Demott Ave","Dempsey Ave","Dempsey Ave SW","Dempsey Dr","Dempsey Rd",
            "Dempsey St","Dempsytown-Gresham Rd","Demunn Rd","Den Oak Dr","Den Quarry Way","Dena Way",
            "Denada Rd","Denal Way","Denali Dr","Denali Rd NE","Denali Way","Denbigh Crescent","Denby Court",
            "Denby Ct","Denby Road","Denby St","Denege Cir","Denfield Pl","Dengler St","Denham Rd","Denholm Dr",
            "Denis Dr","Denise","Denise Ave","Denise Ct","Denise Dr","Denise Dr SW","Denise St","Denison Ave",
            "Denison Pky E","Denison Pky W","Denison Street","Denman Ave","Denman Rd","Denmark St","Denn Rd",
            "Denne Boulevard","Dennett Drive","Dennis Ave","Dennis Avenue","Dennis Creek Dr","Dennis Ct",
            "Dennis Dr","Dennis Drive","Dennis Ln","Dennis Martin Rd","Dennis McHugh Ct","Dennis Rd",
            "Dennis St","Dennison Ave","Dennison Avenue","Dennison Drive","Dennison Lane","Dennison Rd",
            "Denniston Ave","Denniston Street","Denny Dr","Denny Rd","Denny Road","Deno Ct","Denoya Dr",
            "Denrael Drive","Denslow Ave","Dent Dr","Dent Pl SW","Denton Ave","Denton Avenue","Denton Creek Rd",
            "Denton Dr","Denton Rd","Denton St","Denure Drive","Denver Ave","Denver Court","Denver Dr","Denver Rd",
            "Denver St","Deodar Ave","Deodar St","Deodara St","Depaoli St","Depew St","Dephomas Ln","Depot",
            "Depot Ave","Depot Pl","Depot Pl Appr","Depot Rd","Depot Road","Depot Sq","Depot St","Depot Street",
            "Deppa Rd","Deppoliti Ave","Dept of Defense","Deputy Way","Dequeen City Shop","Dequindre St",
            "Derby Ct","Derby Ct SW","Derby Dr","Derby Field Rd","Derby Lane","Derby Ln","Derby Pl","Derby Rd",
            "Derby St","Derby Street","Derbyshire Rd","Dercole Dr","Derek Alan Dr","Derek Pl","Dermody St",
            "Derner Line","Deroche Road","Derose Ct","Deroshia Ln","Derosia Rd","Derrald Drive","Derrick Rd",
            "Derringer Dr","Derry Crescent","Derry Dr","Derry Road","Derry Road East","Derry Road West",
            "Derrydown Road","Derrydown Way","Dersan Street","Dersch Rd","Derwent Ave","Derwent Avenue",
            "Derwin Street","Derwyn Road","Des Arc Dr","Des Chênes Drive","Des Lauriers Rd","Desbrosses Street",
            "Desbrough Dr","Descanso Ln","Descanso St","Descending Creek St","Deschel Dr","Deschutes Rd",
            "Deseret Dr","Deseronto Road","Desert Ave","Desert Blossom Rd","Desert Blvd N","Desert Clover Ct",
            "Desert Creek Ave","Desert Ct","Desert Dove","Desert Dr","Desert Eagle Rd","Desert Flower Dr",
            "Desert Forest NE","Desert Glen Dr","Desert Hawk Dr","Desert Heights Dr","Desert Jade Cir",
            "Desert Jewel Cir","Desert Lily Pl","Desert Ln","Desert Palm Drive","Desert Plains Ave",
            "Desert Plum Rd","Desert Queen Rd","Desert Rd","Desert Ridge Ave","Desert Rose Ct","Desert Rose Dr",
            "Desert Rose Pl","Desert Shadow Rd","Desert Solitude St","Desert Sprinqs Ct","Desert Trail Dr",
            "Desert Trl","Desert View Dr","Desert View Ln","Desert View Rd","Desert View St","Desert Village Ave",
            "Desert Willow Lane","Desertas Ct","Desertrose Way","Deshon Drive","Desierto Luna St",
            "Desierto Verde","Design Centre","Deslauriers Street","Desmaris Ave","Desmond Court","Desmond Ct",
            "Desmond Dr","Desmond Terrace","Desota Dr","Desoto Ct","Desoto Levee Dr","Desoto Rd","Despirito Ln",
            "Dessie Dr","Destefano Road","Destiny Ct","Destiny Dr","Destiny Way","Detoro Way","Detour St",
            "Detrich Aly","Detrick Rd","Detroit Ave","Detroit Dr","Detroit Street","Deutz Ave","Development Rd",
            "Devenish Ln","Devenoge Dr","Devereaux Dr","Devereaux St","Devereaux Way","Devereux Ave",
            "Devericks Rd","Devika Dr","Devil Diver Ct","Devil S Dive Rd","Devil's Slide Bridge","Devil's Stair Hill",
            "Devil's Valley Road","Deviller St","Devils Cyn Trail","Devils Den Trl","Devils Hole Rd",
            "Devils Lake Hwy","Devils Lake Rd","Devine Ave","Devine Drive","Devine St","Devlin Ave","Devolder Road",
            "Devols Dam Rd","Devon Ave","Devon Avenue","Devon Blvd","Devon Ct","Devon Dr","Devon Ln","Devon Pl",
            "Devon Rd","Devon Road","Devon St","Devon Street","Devon Terrace","Devon Way","Devondale Street",
            "Devonshire Dr","Devonshire Drive","Devonshire Rd","Devonshire Road","Devonshire St","Devore Dr",
            "Devoted Way","Devowe St","Devries Ln","Devriese Ct","Devron Ct","Dew Ave","Dew Drop Byp","Dew Drop Ln",
            "Dew Point Ave","Dewberry Crescent","Dewberry Dr","Dewberry Ln","Dewberry St","Dewbourne Avenue",
            "Dewey Ave","Dewey Cv","Dewey Dr","Dewey Dr NE","Dewey Gibson St","Dewey Manor Dr","Dewey Pl",
            "Dewey Rd","Dewey Road","Dewey Smith Dr","Dewey St","Dewey St SW","Dewey Street","Dewindt Rd",
            "Dewitt St","Dewitt Street","Dewolf St","Dewsbury Way","Dexter","Dexter Avenue","Dexter Boulevard",
            "Dexter Ct","Dexter Dr","Dexter Dr S","Dexter Hollow Rd","Dexter Pl","Dexter St","Dexter Street",
            "Dexter Ter","Dexterdale Rd","Dey St","Deyell Line","Deyos Road","Di Carlo Ct","Diablo","Diablo Ct",
            "Diablo Ranch Dr","Diablo Rd","Diabold Dr","Diagonal 122","Diagonal Rd","Dial Ave","Dial Cir",
            "Dial St","Dial Way Ct","Diamante N","Diamante Cir","Diament St","Diamler Parkway","Diamond",
            "Diamond A Dr","Diamond Ave","Diamond Bar Rd","Diamond Ct","Diamond Dr","Diamond Drive","Diamond Ln",
            "Diamond Match Road","Diamond Mine","Diamond Mtn Rd","Diamond Peak Dr NE","Diamond Pl",
            "Diamond Rd","Diamond Road","Diamond Springs Rd","Diamond St","Diamond Street","Diamond Ter",
            "Diamondback Dr","Diamondhead Dr","Dian's Hill","Diana Ave","Diana Ct","Diana Dr","Diana Drive",
            "Diana Ln","Diana Pl","Diana Ter","Diana Way","Dianawood Ridge","Diane Ave","Diane Ct","Diane Dr",
            "Diane Pl","Diane St","Diane Way","Diangelo Dr","Dianne Ct","Dias Dr","Dias Ln","Diaz Ct","Diaz Dr",
            "Diaz Pl","Dibble Rd","Dibgate Boulevard","Dice Rd","Dices Spring Rd","Dick Barbsley Ranch Rd",
            "Dick Brown Pond Rd","Dick Dennis Rd","Dick St","Dick's Ghost Dr","Dickens Ave","Dickens Drive",
            "Dickens Ln","Dickens St","Dickerman Hill Rd","Dickerson Rd","Dickerson St","Dickerson Way",
            "Dickey St","Dickie Road","Dickinson Ct","Dickinson St","Dickman Dr","Dickman Rd","Dicks Ave",
            "Dickson Park Crescent","Dickson Rd","Dickson Road","Dickson St","Dickson Street","Dickvandail Rd",
            "Dictum Court","Didier Rd","Dido Ave","Diedrick Pl","Diego Ct","Diego Rivera Dr","Diener Rd",
            "Dierauf St","Dierks St","Diet Rd","Dieter Ave","Dietz Cir","Dietz Ct","Dietz Farm Cir NW","Difalco Ave",
            "Digby Ave","Digby Dr","Digby Ln","Digby Street","Digger Pine Ridge Rd","Dignity Cir","Dijon Place",
            "Dike Ln","Dike Road","Diletta Court","Dilingham Street","Dilks Ln","Dill Ave","Dillard Rd NW",
            "Diller Dr","Diller Way","Dillingham Pl","Dillingham Rd","Dillion Ln","Dillon Ave","Dillon Avenue",
            "Dillon Dr","Dillon Rd","Dillon Way","Dilly Cir","Dilts Rd","Diltz Ln","Diltz Road","Dilworth Ct",
            "Dilworthtown Rd","Dimatteo Ct","Dime Rd","Dimensions St","Dimmick Rd","Dimmock Ave","Dimond Hook Dr",
            "Dinan Street","Dinard Ct","Dineh Trl","Dingle Daisy Rd","Dingle Ln","Dingledine St","Dingler Rd",
            "Dingley Court","Dingman","Dingman Campground Rd","Dinkey Creek Rd","Dinky Joe Rd","Dino St",
            "Dinsdale Drive","Dinsdale St","Dinuba Ave","Dionne Dr","Dionne Way","Dipping Vat Rd","Dipsea Trail",
            "Dirleton Ln","Dirt Rd","Disa Ln","Disabled Hunters Rd","Disbrow Hill Rd","Disco Road","Discovery Ct",
            "Discovery Drive","Discovery Trail","Discovery Village Ln","Discus Ct","Disher Street W",
            "Dishion Pl","Disk Dr","Disney Court","Disposal Ln","Disposal Plant Road","Disraeli Street",
            "Dissette Street","Distribution Ave","Distribution St","Distributor Rd","District 34 Road",
            "District Center Dr","District Ct","District Road","Ditch","Ditch Creek Rd","Ditch House Ln",
            "Ditmar Cir","Ditmars Ln","Ditmars Rd","Diven St","Dividing Dr","Divina St","Divine Drive","Division Ave",
            "Division Avenue","Division Creek Rd","Division Dr","Division Lane West","Division Ln",
            "Division Road","Division Road E","Division Road W","Division St","Division Street","Divison St",
            "Divito Trl","Divot Pl","Dix St","Dixey Ct","Dixiana Ct","Dixie Ave","Dixie Ln","Dixie Rd","Dixie Road",
            "Dixie Valley Rd","Dixiecrat Rd","Dixon 4431","Dixon Ave","Dixon Avenue","Dixon Crescent",
            "Dixon Ct","Dixon Drive","Dixon Hilltop Pl SE","Dixon Ln","Dixon Rd","Dixon Road","Dixon St",
            "Dixon Street","Dixon Town","Dixson St","Dixwood Ct","Dizzy Dean Rd","Doan Ave N","Doan Rd",
            "Doan St","Doane Ave","Doane Avenue","Doane Rd","Doane Road","Doane Street","Doanes Aly","Doanoke Ave",
            "Dobbie Road","Dobbins Drive","Dobbins Rd","Dobla Rd NW","Doble Drive","Dobleski Rd","Dobush Ave",
            "Doc Bar Ct","Doc Hall Rd","Doc Morrison Rd","Dochery Pl","Dock Hill Rd","Dock Road","Dock St",
            "Dock Way","Docker Hill Rd","Dockery Ave","Docksey","Dockside Ln","Doctor Davies Rd","Doctor Ln",
            "Doctor Mary Moore Beatty Circle","Doctor Nott Rd","Doctors Lane","Doctors Park","Dod Pl",
            "Dodd Rd","Dodd St","Doddington Drive","Dodds St","Dodge Ave","Dodge Blvd","Dodge Cross Rd",
            "Dodge Ct","Dodge Dr","Dodge Drive","Dodge Ln","Dodge Rd","Dodge Ridge Rd","Dodge Street","Dodson Road",
            "Dodwells Hill Road","Doe Ave","Doe Ct","Doe Dr","Doe Hollow","Doe Lake Rd","Doe Mill Rd","Doe Pl",
            "Doe Run","Doe Run Cir","Doe Run Dr","Doe Trail Ln","Doe Trl","Doe Way","Doescher Ave","Dog Strasse",
            "Dog Town Road","Dog Valley Rd","Dogbane Ave","Doggett Ln","Dogleg Dr","Dogtown Rd","Dogwood",
            "Dogwood Ave","Dogwood Cir","Dogwood Ct","Dogwood Dr","Dogwood Hill","Dogwood Hollow Rd",
            "Dogwood Ln","Dogwood Loop","Dogwood Pl","Dogwood Rd","Dogwood St","Dogwood Ter","Dogwood Tr",
            "Dogwood Trail","Dogwood Trl","Dogwood Way","Doheney Dr","Doheny Ln","Doheny Park Plaza",
            "Doherty Circle","Dohner Dr","Dolack Rd","Dolan Ave","Dolan Rd","Dolan St","Dolbeer St","Dolby Ln",
            "Dolce Dr","Dolen Ct","Dolerita Ct","Dolge Ave","Dolington Rd","Dollar Ct","Dollar Lake Rd",
            "Dollar Rd","Dollhouse Dr","Dolliver Ln","Dolly Ct","Dolly Ln","Dolly Varden Ave","Dolly Varden Boulevard",
            "Dolly Varden Drive","Dollywood Rd","Dolores Creek","Dolores Dr","Dolores Plz","Dolores Rd",
            "Dolores St","Dolorosa St","Dolph Cutoff","Dolphin Ave","Dolphin Avenue","Dolphin Dr","Dolphin Drive",
            "Dolphin Ln","Dolphin Point Rd","Dolphin Rd","Dolson Court","Dolton Rd","Dolton St","Domain St",
            "Domar Pl","Dome Rd","Domenic Crescent","Dominc Bruno Boulevard","Domingo Rd NE","Dominguez Dr",
            "Dominica Ave","Dominick Street","Dominion Street","Dominy Drive","Domnus Ln","Don Andres Ct SW",
            "Don Ave","Don Bonito St","Don Bosco Ln","Don Budge Ln","Don Edmondo Ct","Don Enrico Ct",
            "Don Fernando Rd","Don Jay Pl","Don Juan Ct","Don Juan Ct NW","Don Luis Rd","Don McAllister Rd",
            "Don Miguel Dr","Don Mills Bus Terminal","Don Mills Road","Don Minaker Drive","Don Mor Drive",
            "Don Ricardo Pl","Don St","Don Tomas Ct","Don Valley Parkway","Don Valley Parkway Northbound",
            "Don Valley Parkway Southbound","Don Vincente Dr","Don Way","Don West Rd","Don's Ct","Don's Rd",
            "Dona Ana Dr","Dona Ana Rd","Donahoo Ct NE","Donahue St","Donahue Street","Donahugh Drive",
            "Donald Aly W","Donald Ave","Donald Avenue","Donald Dr","Donald Nelson","Donald Nelson Ave",
            "Donald Pl","Donald Road","Donald St","Donald Way","Donalda Crescent","Donaldson Ave","Donaldson Ln",
            "Donaldson Rd","Donaldson St","Doncaster Boulevard","Doncaster Rd","Doncaster Street",
            "Doncrest Drive","Doncrest Road","Donegal Dr E","Donell Court","Doner Rd","Donerail Ct","Donette Ct NE",
            "Dongan Place","Doniphan Dr","Doniphan Park Cir","Doniphan Rd","Donland Avenue","Donlands Avenue",
            "Donley Ave","Donlon Dr","Donlon Hall Loop","Donmac Drive","Donna Ave","Donna Ct","Donna Dee Ct",
            "Donna Dr","Donna Lee Trail","Donna Rd","Donna Way","Donnalisa Dr","Donnas Ln","Donnellon Square",
            "Donnelly Cross Road","Donnelly Dr","Donnelly Rd","Donner Ave","Donner Cir","Donner Ct","Donner Rd",
            "Donnie Cv","Donnie Dr","Donnington Rd","Donnybrook Ln","Donop St","Donora Drive","Donovan Dr",
            "Donovan Rd","Donovan St","Donray Dr","Donridge Drive","Donwoods Court","Donze Ct","Doodle Hollow Rd",
            "Dool Trail","Dooley Drive","Dooley Rd","Dooley St","Dooling Rd","Doolittle","Doolittle Ave",
            "Doolittle Avenue","Doon Cir","Doon Road","Doonaree Drive","Dootyville Rd","Dora Ave","Dora Dr",
            "Dora St","Dora Street","Dorada Way","Dorado Beach NE","Dorado Court","Dorado Ct","Dorado Dr SE",
            "Dorado Rd","Dorado Ter","Dorado Way","Doral Blvd","Doral Ct","Doral Pl","Doran Ln","Doran Pl",
            "Doran St","Dorbeth Rd","Dorcas Street","Dorchester Ave","Dorchester Cv","Dorchester Dr",
            "Dorchester Drive","Dorchester Rd","Dorchester St","Dorcot Avenue","Dore Ct","Doree Rd","Doreen Dr",
            "Doreen Drive","Doreen Ln","Doreen Way","Dorel","Dorel St","Doremus Dr","Doremus Pl","Dorenne St",
            "Doria Ave","Dorian Way","Dorinda Dr","Doris Ave","Doris Avenue","Doris Ct","Doris Pky","Doris Pl",
            "Doris St","Doris St NE","Doris Way","Dorman Street","Dormas Rd","Dormer Road","Dormidera Avenue",
            "Dormilon Rd","Dormont Ave","Dorn Ct","Dornur Dr","Doroski Rd","Dorothea Ave","Dorothea Dr",
            "Dorothea Ter","Dorothy Dr","Dorothy Ln","Dorothy Rd","Dorothy St","Dorothy Way","Dorotockeys Ln",
            "Dorr Dr","Dorr Rd","Dorr Run Rd","Dorr St","Dorrance Rd","Dorrance St","Dorrett St","Dorris Ave",
            "Dorris Dr","Dorrough Rd","Dorset Ave","Dorset Park","Dorset Pl","Dorset Rd","Dorset Road","Dorset Way",
            "Dorsett Dr","Dorsey Dr","Dorsey Drive","Dorsey Lee Rd","Dorson Ln","Dorst Dr","Dorthel St",
            "Dorva Ave","Dorval Ct","Dory Ct","Dory Ln","Dos Amigas","Dos Equis Ct","Dos Reis Rd","Dos Rios Rd",
            "Dos Robles Ct","Doscher Street","Doskow Rd","Doss St","Doster","Doten Ln","Dottielyn Ave","Dottino Ln",
            "Dotty St","Doty Ave","Doty Dickens Dr","Doty Ln","Dotyville Rd","Double Cross Dr","Double D Dr",
            "Double Diamond Pky","Double Dr S","Double Eagle","Double Eagle Way","Double Gate Estates",
            "Double K Rd","Double Mountain","Double Notch Ln","Double R Blvd","Double S Mtn Rd","Double S Rd",
            "Double St; Gramercy Ave","Double Tree Cv","Double Tree Dr","Double Tree Rd","Double Woods Rd",
            "Doubletree St","Doud Rd","Dougall Dell Lane","Dougherty Rd","Doughty Cir","Doughtys Pl",
            "Douglas Ave","Douglas Avenue","Douglas Blvd","Douglas Boulevard","Douglas Crescent","Douglas Ct",
            "Douglas Dr","Douglas Drive","Douglas Ln","Douglas Ranger Sta Rd","Douglas Rd","Douglas Road",
            "Douglas Spring Trail","Douglas St","Douglas Street","Douglas Ter","Douglas Way","Douglas-Hyatt Rd",
            "Douglass St","Douglass Street","Doulton Drive","Douro Fifth Line","Douro Fou Line","Douro Second Line",
            "Douro Seventh Line","Douville Court","Dove Cir","Dove Creek Dr","Dove Ct","Dove Draw Ln",
            "Dove Island Rd","Dove Ln","Dove Pl SE","Dove Rd","Dove Spring Canyon Rd","Dove St","Dove Street",
            "Dove Tail Ter","Dove Ter","Dove Wing Dr","Dovehaven Court","Dovehouse Avenue","Dover Ave",
            "Dover Canyon Rd","Dover Chester Rd","Dover Cir","Dover Crescent","Dover Ct","Dover Dr","Dover Hill S",
            "Dover Ln","Dover Pl","Dover Ridge Rd","Dover Road","Dover St","Dover Street","Dover-Eliot Rd",
            "Dovercourt Road","Doverwood Court","Doverwood Ct","Dovetail St","Dovewood Drive","Dovewood Ln",
            "Dow Ave","Dow Avenue","Dow Dr","Dow Hwy","Dow Jones Ave","Dow Pl","Dow Place","Dow Rd","Dow Street",
            "Dowagiac Ave","Dowaliby Ct","Dowd Rd","Dowd St","Dowell Ln","Dowie Pl","Dowling Pky","Dowling St",
            "Dowman St","Dowmer Pl","Down Home Ct","Down St","Downard Ln","Downe Ave","Downer Hill Rd","Downes Rd E",
            "Downey","Downey Cir","Downey Circle","Downey Road","Downeys Hill Dr NE","Downing Boulevard",
            "Downing Cir","Downing Crescent","Downing Cv","Downing Dr","Downing Ln","Downing Pl","Downing Rd",
            "Downing St","Downing Street","Downing Way","Downs Dr","Downs Rd","Downsview Avenue","Downsview Bus Terminal",
            "Downsview Station Kiss & Ride","Dows Rd","Doxmere Dr","Doxsee Avenue S","Doyle Ave","Doyle Cove Road",
            "Doyle Ct","Doyle Ln","Doyle Rd","Doyle Road","Doyle St","Doyle Street","Dozer Line","Dozier Ct",
            "Dr 1727 A","Dr Childs Rd","Dr Marquise Dr","Dr Martin Luther King Dr","Dr Martin Luther King Jr Blvd",
            "Dr Nott Rd","Dr Shaneyfelt Ln","Dr. Paul Dudley White Path","Dracaea Ave","Dracka Rd",
            "Draft Ct","Dragon Creek Rd","Dragon Crest Dr","Dragon Fly St","Dragonfly Dr","Drain Dr",
            "Drake Cir","Drake Ct","Drake Dr","Drake Knoll Rd","Drake Ln","Drake Pl","Drake Place","Drake Rd",
            "Drake St","Drake Way","Drakestown Rd","Drambuie Ct","Draper Cir","Draper Drive","Draper Road",
            "Draper S Cir","Drapkin Ave","Drasco Truck Trail","Drawbridge Ct","Dray Ct","Drayton Dr",
            "Drayton Ln","Drayton Pl","Dreahook Rd","Dream Crest Road","Dream Lake Dr","Dream Spirit",
            "Dream Way","Dreamwalker Way","Dreamwood Rd","Drenkelly Court","Dresden Ave","Dresden Street",
            "Drew Cir","Drew Court","Drew Ct","Drew Kelly Way","Drew Merigold Rd","Drew Pl","Drew Rd","Drew St",
            "Drew Street","Drew Ter","Drew Way","Drewbrook Court","Drewry Ln","Drewry Rd","Drews Ln","Drexel",
            "Drexel Ave","Drexel Ct","Drexel Dr","Drexel Gate Dr","Drexel Pl","Drey Rd","Dreyer Drive","Drift Rd",
            "Drift Road","Drift Way","Drifter Ln","Drifter Peak St","Driftway","Driftwood","Driftwood Avenue",
            "Driftwood Cove Rd","Driftwood Ct","Driftwood Dr","Driftwood Island Ct","Driftwood Ln",
            "Driftwood Pl NW","Driftwood Road","Driftwood St","Driftwood Terrace","Driggs Lake Truck Trail",
            "Driggs River Rd","Driggs St","Drinda Way","Drinkard Rd","Drinkwate Drive","Dripping Springs Ave",
            "Dripping Springs Rd","Driscoll Ln","Driscoll Rd","Driscoll Road","Driskoll Ln","Drive 152",
            "Drive 18","Drive 2","Drive 88","Drive Through Tree Rd","Drive Way","Drive-in Exit","Driver Ave",
            "Driver Rd","Driver Road","Driver St","Driveway","Driveway To Fiske School","Driving Park Rd",
            "Drown St","Droxford St","Droyers Pointe Blvd","Druid Hill Park","Druid Hills Rd","Drumlin Dr",
            "Drummer Ln","Drummers Ct","Drummond Dr","Drummond Line","Drummond Rd","Drummond Road","Drummond Street",
            "Drummond Ter","Drummore Ln","Drury Ave","Drury Ct","Drury Lane","Drury Ln","Drury St","Drusilla Way",
            "Dry Bridge Rd","Dry Canyon Rd","Dry Corral Ln","Dry Creek Cutoff","Dry Creek Rd","Dry Falls St",
            "Dry Ford Rd","Dry Fork Rd","Dry Hill Loop","Dry Hill Rd","Dry Hill Road","Dry Lake Rd","Dry Rd",
            "Dry Stone Cir SE","Dry Valley Rd","Dry Valley St","Drybread Rd","Dryden Ave","Dryden Ave SW",
            "Dryden Blvd","Dryden Ct","Dryden Rd","Dryden Ter","Drydock Avenue","Dryer Ave","Drysdale Drive",
            "Drytown Rd","Du Bois Ct","Du Bois Dr","Du Pont Pl","Duane Dr NE","Duane St","Duane Street",
            "Duart Pl","Duarte St","Dub's Way St","Dubbs Rd","Dublin Ct","Dublin Hill Rd","Dublin Ln","Dublin Rd",
            "Dublin Road","Dublin Street","Dublin Ter S","Dubloon Ct","Dubois Ave","Dubois St","Dubonnet Ave",
            "Dubonnet Ln","Dubuque St","Duches Drive","Duchess Ct","Duchess Dr","Duchess Rd","Duchess Street",
            "Duchniks","Duck","Duck Blind Aly","Duck Call Ct","Duck Creek Ct","Duck Creek Rd","Duck Ct",
            "Duck Hallow","Duck Haven","Duck Hawk Ct","Duck Lake Rd S","Duck Lane","Duck Ln","Duck Nest Mtwy",
            "Duck Pond Rd","Duck Rd","Duckford Cir","Duckhole Trl","Duckhorn Ct","Duckworth Street","Dudley Ave",
            "Dudley Ave NE","Dudley Avenue","Dudley Cir","Dudley Drive","Dudley Place","Dudley Rd","Dudley Road",
            "Dudley St","Dudley Street","Duece St","Dueitt Rd","Duenas","Duer Ct","Duer Ln","Duer St","Duerksen Rd NW",
            "Duffel St","Dufferin Avenue","Dufferin Hill","Dufferin Street","Duffield St","Duffwood Ln",
            "Duffy Dr","Duffy Rd","Dufoe Pl","Dufour's Drive","Dufree St","Dufton Hollow Rd","Dug Rd","Dugan Aly",
            "Dugan Ave","Dugan Dr","Dugan Ln","Dugan Rd","Dugan Road","Dugar Rd","Duggan Avenue","Duggan Drive",
            "Duggan Rd","Dugout Dr","Dujauncy St","Duke Ave","Duke Ct","Duke Ln","Duke Rd","Duke Street","Duke of York Boulevard",
            "Dukes Ct","Dukes St","Dukinfield Crescent","Dukoff Dr","Dulancey Ct","Dulaney Rd","Dulany Ave",
            "Dulce Dr","Dulle Dr","Dulles Dr","Dulloff Dam Rd","Dulmage State Road","Duluth Street","Dumas Ave",
            "Dumas Court","Dumas Dr","Dumas Rd","Dumble Avenue","Dumfries Cir","Dummy Line Rd","Dumont Ave",
            "Dumont Dr","Dumont Lake Dr","Dumont Park Rd","Dump Rd","Dun Cir","Dun Glen-Unionville Rd",
            "Dunanderry Way","Dunavant St","Dunbar Dr","Dunbar Rd","Dunbar Road","Dunbar St","Dunbar Street",
            "Dunbarton Center Rd","Dunbarton Dr","Dunbarton Rd","Dunbarton Road","Dunbridge Hts","Dunc's Point",
            "Duncamp Pl","Duncan Ave","Duncan Bull Drive","Duncan Creek Rd","Duncan Ct","Duncan Dr","Duncan Hwy",
            "Duncan Mill Road","Duncan Rd","Duncan Road","Duncan St","Duncan Street","Dundalk Drive",
            "Dundas Square","Dundas Street","Dundas Street East","Dundas Street W","Dundas Street West",
            "Dundee Ave","Dundee Avenue","Dundee Cir","Dundee Ct","Dundee Dr","Dundee Drive","Dundee Ln",
            "Dundee Rd","Dundee St","Dunderberg Meadow","Dundonald Street","Dune Ave","Dune Grassway",
            "Dune Hollow Ave","Dune Ln","Dune St","Dune Ter","Dunelm Drive","Dunera Avenue","Dunes Ct","Dunes Dr",
            "Dunes Rd","Duneville St","Dunfield Rd","Dunford Rd","Dunford St","Dunforest Avenue","Dungan Ave",
            "Dunham Ave","Dunham Lake Rd","Dunham Ln","Dunham Rd","Dunham St","Dunhill Dr","Dunington Drive",
            "Dunka Lk Rd","Dunkeld Avenue","Dunkerhook Rd","Dunkirk Avenue","Dunkirk Cir","Dunkirk Dr",
            "Dunkirk Road","Dunkirk St","Dunklee Hill Rd","Dunlap Ave","Dunlap Dr","Dunlap Rd","Dunlap Street",
            "Dunloe Road","Dunlop Dr","Dunlop Street","Dunlop Street E","Dunmanus Drive","Dunmore Avenue",
            "Dunmow Cres","Dunn","Dunn Ave","Dunn Avenue","Dunn Hill Rd","Dunn Lane","Dunn Ln","Dunn Rd","Dunn St",
            "Dunne Place","Dunnett Boulevard","Dunnicliffe Ct","Dunns Cove Rd","Dunns Hill Road","Dunns Line",
            "Dunrobin Ave","Dunrobin Court","Dunroven Dr","Dunrovin Ct","Dunsen Ave","Dunsinane Drive",
            "Dunsmore St","Dunstan Dr NW","Duntley Ln","Dunton Dr","Duntz Ln","Dunvegan Road","Dunwich Ave",
            "Duplex Avenue","Duplex Crescent","Dupont Parkway","Dupont St","Dupont Street","Dupree Rd",
            "Duquesa Ct","Duran Dr","Durand Pl","Durand Rd","Durango Cv","Durango Drive","Durango Ln","Durango St",
            "Durango Way","Durant Ave","Durant Avenue","Durant Cir","Durant Dr","Durazno Rd","Durban Ct",
            "Durfor St","Durham Ave","Durham Boat Dr","Durham Cir","Durham College","Durham Court","Durham Ct",
            "Durham Dr","Durham Highway 47","Durham Nockamixon Rd","Durham Point Rd","Durham Rd","Durham Road",
            "Durham St","Durham Street","Durham Street E","Durham Street S","Durham Ter","Durham Way E",
            "Durham-Pentz Rd","Durie Ave","Durie Street","During Rd","Durkee Dr","Durkee Rd","Durland Pl",
            "Durmont Ct","Durnford Road","Duro Ct NE","Durwood Pl","Dusa Dr","Dusing Ln","Duso Rd","Dusseldorf Way",
            "Dustan Street","Dusterberry Way","Dustin Dr","Dustin Street","Dustin Way","Dustine Dr W",
            "Dustman Ln","Duston Rd S","Duston Ridge Rd","Dusty Ave","Dusty Gold Ln","Dusty Lane","Dusty Ln",
            "Dusty Miller Dr","Dusty Rd","Dusty Star Road","Dusty Trail Dr","Dutch Ct","Dutch Farm Rd",
            "Dutch Flat Trail","Dutch Hill Rd","Dutch Hollow Country Club","Dutch Myrtleway","Dutch Rd",
            "Dutch Ridge Rd","Dutch Valley Ln","Dutch Valley Rd","Dutcher Rd","Dutchess Ave","Dutchess Dr",
            "Dutchman Dr","Dutchmans Point Rd","Dutil St","Dutra Ct","Dutton Ave","Dutton Hill","Dutton Ln",
            "Dutton Rd","Dutton St","Duttonwood Ln","Dutyville Rd","Duval Ln","Duval Street","Duvol Road",
            "Duxbury Cir","Duxbury Lane","Duxbury Ln","Dwars Kill Ln","Dwight Ave","Dwight Court","Dwight Little Rd",
            "Dwight Pl","Dwight St","Dwight Street","Dwight Street Extension","Dwight Way","Dwinell Rd",
            "Dwinnell Way","Dwyer Dr","Dwyer Street","Dyckman St","Dyckman Street","Dye Rd","Dyer Ave","Dyer Avenue",
            "Dyer Rd","Dyer St","Dyer Way","Dyers Ct","Dyerville Loop Rd","Dyess Rd","Dyesville Rd","Dyke Rd",
            "Dyker Place","Dykstras Way West","Dylan Rd","Dynsham Ln","Dyotte Street","Dyson Lane","Dyson Road",
            "E","E 10 Mile Rd","E 10 Rd","E 104th Pl","E 104th St","E 109th St","E 10th Ave","E 10th St","E 115th St",
            "E 116th St","E 119th St","E 11th St","E 121st St","E 122nd St","E 123rd St","E 127th St","E 12th Pl",
            "E 12th St","E 130th St","E 132nd St","E 134th St","E 135th St","E 136th St","E 13th Ave","E 13th St",
            "E 140th St","E 142nd St","E 143rd St","E 145th St","E 146th St","E 148th St","E 149th St","E 14th Ave",
            "E 14th St","E 150th St","E 151st St","E 156th St","E 158th St","E 159th St","E 15th Ave","E 15th St",
            "E 162nd St","E 166th St","E 168th St","E 16th Ave","E 16th St","E 171st St","E 174th St","E 17th Ave",
            "E 17th St","E 180th St","E 181st St","E 185th St","E 18th Ave","E 18th St","E 19th St","E 1st Ave",
            "E 1st St","E 1st St N","E 2 Nd St","E 20th Ave","E 20th St","E 216th St","E 218th St","E 21st St",
            "E 221st St","E 224th St","E 225th St","E 228th St","E 229th Pl","E 232nd St","E 238th St","E 23rd St",
            "E 24th Ave","E 24th Pl","E 24th St","E 25 Mile Rd","E 250th St","E 25th St","E 26th Ave","E 26th St",
            "E 27th St","E 28 Rd","E 28th St","E 29th St","E 2nd St","E 309th St","E 30th St","E 31st St","E 329th St",
            "E 32nd Pl","E 32nd St","E 33rd St","E 34th Pl","E 34th St","E 355th St","E 35th St","E 36th St",
            "E 37th St","E 37th Way","E 38th St","E 3rd Ave","E 3rd St","E 40th St","E 41st St","E 42nd St",
            "E 43rd St","E 44th St","E 44th Way","E 45th St","E 46th Pl","E 46th St","E 47th Ln","E 48th St",
            "E 49th St","E 4th","E 4th Ave","E 4th Pl","E 4th St","E 5 Mile Rd","E 50th St","E 51st St","E 51st Street Pedestrian Xing",
            "E 52nd St","E 53rd St","E 55th St","E 57th Pl","E 58th St","E 5th Ave","E 5th St","E 60th St",
            "E 61st St","E 63rd St","E 65th St","E 66th","E 66th St","E 69th St","E 6th Ave","E 6th St","E 71st Pl",
            "E 73rd St","E 74th St","E 77 Dr","E 77th Pl","E 77th St","E 79th St","E 7th Ave","E 7th St","E 80th St",
            "E 81st St","E 82nd Pl","E 84th St","E 85th St","E 86th St","E 8th St","E 900 N","E 91st St","E 96th St",
            "E 98th St","E 99th St","E 9th St","E Abbottson St","E Aberdeen St","E Abila St","E Academy Ave",
            "E Accurate Cir","E Achi St","E Adams Ave","E Adams Pl","E Addington St","E Adell St","E Agape Dr",
            "E Agnes St","E Ahwahnee Ave","E Alabama St","E Albacore Way","E Albuquerque Rd","E Alderman Ave",
            "E Alexander Rd","E Alexander Way","E Alhambra Ave","E Allegheny Ave","E Allen St","E Almendra Dr",
            "E Almeria Rd","E Almond Rd","E Alpine Lake Dr","E Alpine Rd","E Alta Ave","E Alta Vista Rd",
            "E Altadena Ave","E Altarinda Dr","E Amber Ln","E Amberwood Dr","E Andrews Ave","E Ann St",
            "E Annette Dr","E Annsbury St","E Anthony Way","E Apache St","E Apollo Rd","E Appleby Rd",
            "E Applegate Way","E Apricot Ave","E Apricot Dr SW","E Aravaipa Rd","E Arbor Ave","E Arcade Rd",
            "E Aris Dr","E Arnold Rd","E Arrow Hwy","E Arrowhead Dr","E Art Ave","E Arts Ln","E Asbury Anderson Rd",
            "E Ash Ave","E Ash Rd","E Ashcroft Ave","E Ashfield Ct","E Aspen Ave","E Aspen Dr","E Atkins Ave",
            "E Atlantic Ave","E Auburn St","E Aurora Dr","E Aurora Ln","E Austin Way","E Auto Center Dr",
            "E Avalon Dr","E Ave","E Avenida Los Vallecitos","E Avenida Palmar","E Avenue 124","E Avenue 39",
            "E Avenue E-6","E Avenue F","E Avenue F 14","E Avenue J 10","E Avenue J 12","E Avenue J 14",
            "E Avenue J 2","E Avenue J 3","E Avenue J 8","E Avenue O-8","E Avenue Q","E Avenue Q 3","E Avenue Q-1",
            "E Avenue Q-14","E Avenue R-11","E Avenue R-13","E Avenue R-2","E Avenue R-5","E Avenue R10",
            "E Avenue T-10","E Avenue V","E Avenue X","E Aztec","E Aztec Cir","E B St","E Babcock St","E Bailey St",
            "E Bajada Dr","E Balance Ln","E Balch Ave","E Balcom St","E Ballard Ave","E Balsam Ave","E Baltic St",
            "E Baltimore Pike; Baltimore Pike","E Banister Dr","E Bank St","E Banyan Ct","E Bardsley Avenue",
            "E Basic Rd","E Bath Rd","E Battles Rd","E Bay Mud Rd","E Bayview Ave","E Bayview Dr","E Beach",
            "E Beach Ave","E Beach Way","E Beachton Rd","E Beard Ave","E Beatryce St","E Beech St NE",
            "E Belgravia Ave","E Bell Ln","E Bell Rd","E Bellbrook St","E Belleview Ave","E Bellevue Rd",
            "E Bennett Heights","E Bennett St","E Bentbrook Dr","E Berkeley Ct","E Berks St","E Berneil Dr",
            "E Berry Ave","E Beryl Ln","E Beverly St","E Bigelow St","E Birch Ave","E Birch Dr","E Birch St",
            "E Bisbee Ave","E Bisnaga Dr","E Blackjack Rd","E Blair Town Hall Rd","E Blake St","E Blithedale Ave",
            "E Bloomfield Rd","E Bloss St","E Blue Heron Ln","E Bluff Rd","E Blvd","E Bobolink Ln","E Bolinger Way",
            "E Bonanza","E Boonville New Harmony Rd","E Bos St","E Boston","E Boulevard St","E Boundary St",
            "E Bowman Pl","E Bradley St","E Branch Pl","E Brandywine Ln","E Brazaro Ave","E Bridge St",
            "E Brinkerhoff Ave","E Bristol St","E Broad St","E Broad Street","E Broadway","E Broadway Ave",
            "E Broken Arrow Trl","E Brookdale Ave","E Brookdale Pl","E Brookfield Dr","E Brookwood Cir",
            "E Brookwood Dr","E Brown Ave","E Brown St","E Buchtel Ave","E Buck St","E Buena Vista Ave",
            "E Buena Vista Dr","E Buffalo St","E Bull Elk Trl","E Bullard Ave","E Burgess Ln","E Burk Ave",
            "E Burlington Ave","E Burnell Rd","E Burns Ave","E Burt Rd","E Busby Dr","E Byrd Ave","E C Ave",
            "E C D Ave","E C R 5740","E C St","E Cabot St","E Cactus Ln N","E California Ave","E Calle Adobe Lane",
            "E Calle Alta Vista","E Calle Aurora","E Calle Bolivar","E Calle Encanto","E Calle Luna",
            "E Calle Osito","E Calle Redonda","E Calle Ventura","E Calypso Ave","E Cambria St","E Cambridge Ave",
            "E Camden St","E Camino Principal","E Camino Real St","E Camino Villas","E Camino Vista",
            "E Campbell Ave","E Campus Dr","E Canal St","E Candlelight Dr","E Canyon Creek Ct","E Capitol Expy",
            "E Cardinal Way","E Carey Ave","E Carlisle Rd","E Carmel Ave","E Carmel Valley Rd","E Carmen Ave",
            "E Carol Ave","E Carpenter St","E Caruthers Ave","E Casablanca Ave","E Cassell Ave","E Cathedral Rock Dr",
            "E Cattle Dr","E Cavalier Dr","E Cayuga St","E Cazier","E Cedar Ave","E Cedar St","E Cedarwood Ln",
            "E Center Ave","E Center Dr NE","E Center Rd","E Center St","E Central Ave","E Centre St",
            "E Cesar Chavez Memorial Hwy","E Chadakoin Pky","E Chamberlain Rd","E Champlain Dr",
            "E Channel Rd","E Charleston Road","E Chelsea Dr","E Cheltenham Ave","E Cherbourg Dr",
            "E Cherry St","E Chestnut Pl","E Chestnut St","E Chicago Blvd","E Chicago St","E Choctaw Ct",
            "E Cholla St","E Chuckwalla Rd","E Church St","E Chuska St","E Cicero St","E City Ave","E Clark Ave",
            "E Clark Rd","E Clarkson Ave","E Clary St","E Clayton Ave","E Clementine St","E Clements Bridge Rd",
            "E Clermont Ave","E Cleveland Ave","E Clifton Ave","E Cline Ave","E Clinton Ave","E Clinton St",
            "E Cloverdale Dr","E Co 13 1/2 E","E Co 9th St","E Coach Ln","E Cochise Rd","E Cody St",
            "E Coelho Ave","E Cole Ave","E Colebrook Rd","E Coleman Ave","E Coles Ave","E Colfax Ave",
            "E College Ave","E College St","E Colorado Ave","E Columbine Cir","E Columbine Rd","E Columbus Ave",
            "E Colvin St","E Comet Rd","E Comly St","E Commerce Ave","E Commercial St","E Commissioner St",
            "E Compress St","E Comsoft Pl","E Comstock St","E Conejo Ave","E Congress St","E Conn","E Connecticut Ave",
            "E Constitution Dr","E Coogan Dr","E Cook St","E Copeland Rd","E Cornell Ave","E Cornell St",
            "E Corning Ave","E Cornwall St","E Cortez Dr","E Cortner St","E Corunna Rd","E Cottonwood Ln",
            "E Cougar Ave","E Country Club Ln","E Countryside Dr","E County Line Rd","E County Road 132",
            "E County Road 194","E County Road 474","E County Road 602","E County Road 924","E Court Ave",
            "E Court St","E Courtney St","E Cove Ct","E Covina St","E Coyote Rd","E Coyote Run Trl","E Cramer St",
            "E Crawford Ave","E Crescent Pky","E Crestview Ave","E Crestview Cir","E Crisman Rd","E Crooks",
            "E Cross Ave","E Ct","E Cullum Ln","E Curtis Ave","E Curtis St","E Cuthbert Blvd","E Cutler Rd",
            "E Cypress St","E Dakota Rd","E Dale","E Darrah Ln","E Dartmouth Dr","E Dateland Rd","E Davenport Dr",
            "E Davis Rd","E Davis St","E Day Rd","E Dayton Ave","E Decatur Ave","E Deerfield Rd","E Deerskin St",
            "E Defiance St","E Delaware Ave","E Delcoa Ave","E Delilah Rd","E Denni St","E Deodara St",
            "E Derringer Way","E Desert Inn Rd","E Desert Ln","E Desmond Ln","E Devonshire Ave","E Dewey Ave",
            "E Diamond Ave","E Diamond Cir","E Dickerson St","E Dickinson Ave","E Dinner Lake Rd",
            "E Division St","E Dominick Street","E Donner Ave","E Doris Ave","E Dorman Rd","E Dr","E Dr NE",
            "E Drake Dr","E Drive Ave S","E Duck Lake","E Duke Dr","E Dunbarton Rd","E Dunnam St","E Dunstable Rd",
            "E Durango St","E Durango Way","E Dusty Ln","E Dutch Ave","E Dutchtown Harlingen Rd","E E Field",
            "E E St","E E Street","E Eagle Ln","E Eaglenest Trl","E Earlene","E Earlham St","E Eberhardt St",
            "E Echo Dr","E Eckerson Rd","E Eckles St","E Edgar Ave","E Edgecomb St","E Edgemont St","E Edgewood Ave",
            "E Edgewood Cir","E Edgewood Estate","E Edsall","E Edsall Blvd","E El Morado Ct","E Elaine Ave",
            "E Elderberry St","E Eleanor St","E Elizabeth St","E Elk Ave","E Elkhart St","E Ellington St",
            "E Elm Ave","E Elm St","E Emery Rd","E Encore Dr","E End Rd","E Enfield Rd","E Englewood Ave",
            "E Enid Ave","E Enrose St","E Entrada Once","E Erdman Rd","E Erie St","E Escondido Ave","E Essex Ave",
            "E Essex Dr","E Estrellita Ct","E Eugenia Ave","E Evans Ave","E Evans St","E Evening Glow Ave",
            "E Evergreen Ave","E Evergreen Rd","E Evergreen St","E Eyre St","E F St","E F St; E F Street",
            "E Fairmont Ave","E Fairmount Ave","E Fairview Rd","E Fairview St","E Falcon St","E Far Vista Ave",
            "E Farm Rd","E Fayette St","E Fedora Ave","E Felton St","E Fern Drive South","E Fernwood Ave",
            "E Ferry St","E Finch Ave","E Finch Ln","E Fir Ave","E Fisher Creek Rd","E Flag St","E Floradora Ave",
            "E Florence Ave","E Florian Ave","E Foppiano Ln","E Forest Ave","E Forest Oaks Dr","E Fork Hall Canyon Rd",
            "E Fortlee Rd","E Fortuna Palms Loop","E Foster","E Foxtail Dr","E Frances Willard Ave",
            "E Frank Ln","E Franklin","E Franklin St","E Frazier St","E Freedom Ln","E Fresno St","E Frias Ave",
            "E Front St","E Frye Rd","E Fulton St","E G St","E Gail Dr","E Galileo Dr","E Galyn St","E Garden Ave",
            "E Garden St","E Garfield Ave","E Garfield St","E Garland Ave","E Garnet Cir","E Garrett Ave",
            "E Gary Ave","E Gary Cir","E Gate","E Genesee Street","E George Ave","E George St","E Gettysburg Ave",
            "E Gibbon Mountain Pl","E Gila Dr","E Girl Scout Ln","E Glauchester Rd","E Glen Ave","E Glen Cir",
            "E Glen Ln","E Glencove Ave","E Glencove St","E Glendale Ave","E Gleneagle Dr","E Glenn Ave",
            "E Grago Blvd","E Graham Ave","E Gramercy Pl","E Granada Ave","E Grand Ave","E Grand Lake Rd",
            "E Grandview Rd","E Grandview St","E Grant Ave","E Grant St","E Granvia Valmonte","E Grayson Rd",
            "E Green Rd","E Greenlawn Ave","E Greenlee St","E Greenshire Ct","E Greenway Cir","E Greg St",
            "E Grevillea St","E Griffith","E Grove Ave","E Grove Cir","E Grove St","E Grovecenter St",
            "E Grovers Ave","E Guadalupe Rd","E Guiberson Rd","E Gutierrez St","E H Pl","E H St","E Hacienda Reposo",
            "E Haes Ave","E Halifax St","E Hall Rd","E Hamilton Ave","E Hamm Ave","E Hammer Ln","E Hammond Ave",
            "E Hammond Ct","E Hammond St","E Hampton Dr","E Hampton Ln","E Hampton Way","E Hanford Armona Rd",
            "E Harbor Dr","E Hardaway St","E Hardy Ave","E Harford","E Harmon Ave","E Harmony Ave","E Harmony Cir",
            "E Harold St","E Harper Rd","E Harrison Ct","E Harrison St","E Hartley Ave","E Harvard St",
            "E Harvest Ave","E Harvey Ave","E Hatfield St","E Haven Rd","E Hawknest Rd","E Hayland St",
            "E Haystack Dr","E Hazzard St","E Heatherbrae Dr","E Hedges Ave","E Helen St","E Hemlock St",
            "E Henrietta Road","E Henry St","E Herbert Ave","E Hermosa Vista Cir","E Herndon Ave",
            "E Hervey St","E Hester Rd","E Hewitt Ave","E Hewson St","E Hickory Ave","E Hidalgo Ave",
            "E High Ave","E High St","E Highland Ave","E Highland Rd","E Highlands Cir","E Highway 412",
            "E Highway 70","E Hildreth Ave","E Hill Ct","E Hill Rd","E Hill St","E Hillsdale Blvd","E Hillview St",
            "E Hillview Trl","E Hilton St","E Hinckley Ave","E Ho Rd","E Holderness Rd","E Holland Ave",
            "E Hollygreen Dr","E Hollyvale St","E Holmes Ave","E Honeybear Pl","E Hooker St","E Hope Dr",
            "E Hopi Ave","E Hopkins Ave","E Horizons Ct","E Horseshoe Canyon Rd","E Horseshoe Rd",
            "E Hosking Ave","E Houser St","E Houston Ave","E Houston St","E Howard Ct","E Howard Pl",
            "E Howell St","E Hubbell Hill Rd","E Hubbell St","E Hubert Rd","E Hudson Ave","E Hunter Ct",
            "E Hunter St","E Huntington Ave","E Huntington Blvd","E Hurley Pond Rd","E Huron Ave",
            "E Hurst St","E Hylda St","E I St","E Idaho Ave","E Iler Ct","E Illinois Ave","E Illinois St",
            "E Imperial Ct","E Indian Ave","E Indian Bend Rd","E Indigo Brush Rd","E Indio Pl","E Ingham Ave",
            "E Inyo Ave","E Inyo St","E Iowa St","E Irene St","E Irwin Ave","E Isaiah Ave","E Isham Ave",
            "E Island Circle Dr","E Island View","E Ithaca Recreation Way","E Ivanhoe Pl","E Ivy Ave",
            "E Ivy St","E J St","E Jacinto Dr","E Jack Ct","E Jackson St","E James St","E Jasmine St","E Jasper St",
            "E Javelina Ave","E Jefferson Ave","E Joffre St","E Johnson Rd","E Johnston St","E Jones",
            "E Jones Beach Dr","E Jones St","E Juana Ave","E Juaneno Ave","E Juanita Ave","E Juarez St",
            "E Julia St","E Jura Cir","E Kamm St","E Kanai Ave","E Kaviland Ave","E Kearsley St","E Keim Dr",
            "E Kell Ln","E Kelton Ln","E Kenbridge Dr","E Kennedy","E Kennedy Ave","E Kennedy St","E Kenoak Dr",
            "E Kenosha Ave","E Kensington Dr","E Kent Rd","E Kentucky Ave","E Kentucky St","E Kenyon Rd",
            "E Kerckhoff Ave","E Kimberly Ave","E Kings Bay Rd","E Kings Hwy","E Kings Way","E Kingswood St",
            "E Kinney Pl","E Kirby Ave","E Kittle Pl","E Knight Ave","E Knowlton St","E Kraft Ave","E L St",
            "E Lafayette St","E Lake Ave","E Lake Ct","E Lake Dr","E Lake Rd","E Lake Road","E Lake St",
            "E Lakeshore Dr","E Lakeview Dr","E Lamona Ave","E Landmark Way","E Lane Ave","E Lane St",
            "E Lansing Way","E Larch St","E Lark Dr","E Larkstone Dr","E Larson Rd","E Las Rocas Dr",
            "E Laskey Rd","E Latham Ave","E Latonia St","E Laughead Ave","E Laura Ave","E Laurel Cir",
            "E Laurel Loop","E Laurel St","E Lawn Ct","E Lawn Dr","E Lawrence Rd","E Le Baron Ave","E Lee Blvd",
            "E Lee Cir","E Lee Pl","E Lee St","E Leisure Ave","E Lenox Rd","E Lester St","E Letson Ave",
            "E Lewelling Blvd","E Lexington Ave","E Lexington Ct","E Lexington St","E Liberty Ave",
            "E Liberty St","E Lime St","E Lincoln Ave","E Lincoln Hwy","E Lincoln St","E Lincoln Way",
            "E Linda Vista Dr","E Linden Ave","E Linden St","E Lindner Ave","E Lindsley Rd","E Line St",
            "E Lippincott St","E Litchfield Rd","E Littler Ct","E Lizbeth Ave","E Lobo Ave","E Lockeford St",
            "E Lockesburg Ave","E Lockhart St","E Lockwood St","E Locust Ave","E Lola Dr","E Loner Ave",
            "E Loon Lake Ln","E Loop Rd","E Lords Court","E Lorena Ave","E Los Altos Ave","E Los Flores St",
            "E Lost Trails St","E Louise Ave","E Louisville Ave","E Lovett St","E Lupine Ave","E Luray St",
            "E Lycoming St","E Lyle Ln","E M 134","E M Barnett Rd","E M St","E Madison Ave","E Madison Dr NE",
            "E Madison St","E Magill Ave","E Magnasite Rd","E Magnetic St","E Magnolia Dr","E Magnolia St",
            "E Mahoney Ave","E Main Rd","E Main St","E Main St SE","E Main Street","E Maki Rd","E Mal","E Malaga Rd",
            "E Mallory St","E Manitou Road","E Manning Ave","E Manoa Rd","E Manrun Rd","E Manse Rd","E Mantua Ave",
            "E Maple Ave","E Maple Ct","E Maple St","E Marcellus Ave","E Marcy Ave","E Margaret Ct","E Marina Rd",
            "E Mariposa Ave","E Mariposa Grande Dr","E Mariposa Road","E Market St","E Marthart Ave",
            "E Maryland Ave","E Mathews Rd","E Matthews St","E Mauerhan Pl","E Mc Crea Dr","E Mc Donald Ave",
            "E Mc Lean Way","E Mc Williams Ave","E McAllen Rd","E McAuley Dr","E McCabe Rd","E McGuire Dr",
            "E McKenzie Ave","E McKinley Ave","E McMurray Pl","E McNeal St","E Meadow Ln","E Meadowbrook Dr",
            "E Meander Dr","E Mechanic St","E Mel Ave","E Melinda Ave","E Melody Ave","E Melrose St",
            "E Mena Ave","E Mendocino Ave","E Merced St","E Merrill Ln","E Merrill St","E Mesquite Ridge Cir",
            "E Michigan Ave","E Midland Blvd","E Mill St","E Mill Stream Cir","E Miller Ave","E Millwood Dr",
            "E Milton Ave","E Mission Ln","E Mission Rd","E Mission St","E Mississippi Ave","E Missouri Ave",
            "E Missouri St","E Ml Ave","E Moana Ln","E Moberly Ave","E Mockingbird Ln","E Moline St",
            "E Mombasha Rd","E Mono Ave","E Mono St","E Monroe Ave","E Monroe St","E Montara Blvd","E Monte Vista Ave",
            "E Montecito Ave","E Monterey Rd","E Montwood Ave","E Moore St","E Moorman St","E Moreland St",
            "E Morley Ave","E Morris Ave","E Morris St","E Morrow Dr","E Morten Ave","E Morton Ave","E Mosher St",
            "E Motts Creek Rd","E Mount Ave","E Mount Garfield Rd","E Mount Vernon Ave","E Mount Whitney Ave",
            "E Mountain Ave","E Mountain Rd","E Mouse Trl","E Mueller St","E Muir Field Dr","E Muirwood Ct",
            "E Mulberry Aly","E Muncie Ave","E Muriel Dr","E Muscat Ave","E Musser St","E Myrtle St",
            "E N St","E Nance Cir","E Nancy Ln","E Naranja Ave","E Narberth Ter","E Nash Ave","E Nauraushaun Ave",
            "E Nebraska Ave","E Nees Ave","E Nell Ave","E Nesquehoning St","E New St","E New York Ave",
            "E Newton Dr","E Nicholson Rd","E Nido Ave","E Niles Ave","E Noble Ave","E Nogales","E Nogales Rd",
            "E Norma Ln","E Normal Ave","E Norman Pl","E Norris St","E North Ave","E North H","E North St",
            "E Northview Ln","E Northwood Dr","E Norwich Ave","E Nugget Dr","E Nyon Ave","E O St","E Oak Ave",
            "E Oak Haven Dr","E Oak Rd","E Oak St","E Oak St NE","E Oakdale St","E Oakhurst Way","E Oakland Pl",
            "E Oakwood Blvd","E Ocean Ave","E Octagon Rd","E Ogle Ave","E Ohio St","E Oil Well Rd","E Old Hickory Rd",
            "E Old Mountain Rd","E Old Stone Cir S","E Old Vail Rd","E Olive Ann Ln","E Olive Ave",
            "E Omaha Ave","E Orange Rd","E Orangewood Ave","E Orchard Pwky","E Orchard St","E Orchid Dr",
            "E Organ Ave","E Oro Ave","E Oshkosh Cir","E Ottawa Rd","E Otto Rd","E Owens Ave","E Pace Ct",
            "E Pacific St","E Padua Way","E Paisano Dr","E Paisano Dr; United States Highway 62",
            "E Palm Dr","E Palm Ln","E Palm Rd","E Palm St","E Palmer St","E Palmyra Dr","E Palo Alto Ave",
            "E Palo Verde Dr","E Palo Verde St","E Palomar Dr","E Palomino Rd","E Pama Ln","E Pamela Rd",
            "E Paradise Ave","E Paris Ave SE","E Park Ave","E Park Dr","E Park Drive","E Park Pl","E Park St",
            "E Park Way","E Parkdale Dr","E Parkington Ln","E Partridge Path","E Paseo Laredo","E Passaic Ave",
            "E Passaic St","E Passyunk Ave","E Patterson Ave","E Paul Ave","E Pavilion St","E Payne St",
            "E Peach Aly","E Pearl St","E Pecan Ln","E Penguin Way","E Penn Sq","E Peralta Way","E Pere Marquette St",
            "E Perimeter Rd","E Perkins","E Perliter Ave","E Perrin Rd","E Perry St","E Pershing Ave",
            "E Pershing St","E Phelps Rd","E Philo Ave","E Pico Ave","E Pierce St","E Pinchot Ave","E Pine Ave",
            "E Pine Creek Rd","E Pine St","E Pine Tree Ln","E Pinecrest Cir","E Pinecrest Ln","E Pinto Dr",
            "E Pioneer Rd","E Pitman St","E Placita Arroyo Seco","E Placita Doblada","E Placita Metate",
            "E Placita Tres Vidas","E Plata Ave","E Platt Ave","E Platt St","E Plaza Ave","E Pleasant Ave",
            "E Plymouth Ave","E Poco Calle","E Poinsettia St","E Polk Ave","E Polk St","E Pontiac Way",
            "E Poplar Ave","E Poplar St","E Port Dr","E Portals Ave","E Porter St","E Portland Ave","E Post Rd",
            "E Pottor Dr","E Powell Way","E Preston Ave","E Price Rd","E Primm Blvd","E Prince Rd","E Princess Dr",
            "E Proctor St","E Prospect St","E Prospect Vista Way","E Prosperity Ave","E Pterodactyl Ln",
            "E Pulteney Street","E Pyle Ave","E Quackenbush Ave","E Quail Ave","E Quail St","E Quartz Ave",
            "E Quinnell Dr","E Raco Ave","E Radburn St","E Railroad Ave","E Railroad St","E Railway Ave",
            "E Rainbow Dr","E Rairdan Ln","E Rambler Rd","E Ramblewood Dr","E Ramona Ave","E Ranchero Rd",
            "E Rancho Caliente Dr","E Rancho Dr","E Randall St","E Randall Wobbe Ln","E Raymond St",
            "E Red Oak Dr","E Red Range Way","E Redfield Rd","E Regal Way","E Remington Dr","E Renee Dr",
            "E Reno Ave","E Rhea Rd","E Rialto Ave","E Rice Dr","E Richardson Ave","E Richert Ave","E Richmond Ave",
            "E Ricker Rd","E Riddle Ave","E Ridge Cir","E Ridgecrest Blvd","E Rincon Ave","E Rising Sun Pl",
            "E Rita Rd","E River Ave","E River Rd","E River St","E River Xing","E Riverside Dr","E Rives St",
            "E Robert St","E Roberts Ln","E Robin Rd","E Robinson Ave","E Rochester Ave","E Rock Ridge Rd",
            "E Rocking W Ranch Rd","E Rockland St","E Rocky Trl","E Rodgers St","E Rose Ave","E Rose Dr",
            "E Rose St","E Rose Tree Rd","E Rose Valley Rd","E Ross Ave","E Ross St","E Rossi St","E Rosted Rd",
            "E Roush Rd","E Roxanne Way","E Ruby Ave","E Rude St","E Rue Le Charlene","E Rundell St",
            "E Ruscomb St","E Russell Dr","E Russell Rd","E Russell St","E Ruth Ave","E Ryan Ln","E Ryer Rd",
            "E Sabino Sunrise Cir","E Saddle St","E Saddleback Ln","E Sage Dr","E Sagewood Ln","E Saginaw Ave",
            "E Saginaw Way","E Saguaro Vista Ct","E Saint Andrews Dr","E Saint Louis Ave","E Sample Ave",
            "E San Bernardino Ave","E San Bruno Ave","E San Gabriel Ave","E San Joaquin Rvr Levee Rd",
            "E San Juan Ave","E San Julien Rd","E San Marcos Dr","E Sanilac Rd","E Santa Clara St",
            "E Santa Fe Ave","E Sarah Ln","E Savannah Rd","E Saxon Ave","E Scepter Ln","E Scharbauer St",
            "E Schiller St","E School Ave","E Schumacher St","E Scott Ave","E Seabright Rd","E Seamans Dr",
            "E Sean Ave","E Sedgley Ave","E Seldon Ln","E Seltzer St","E Seneca St","E Sentiero Ave",
            "E Serafina Ave","E Service Road","E Seville St","E Seymour St","E Shangri la Rd","E Shay St",
            "E Shea Dr","E Sheffield Ct","E Shepherd Ave","E Shepherd St","E Sherman Blvd","E Sherwood Ave",
            "E Shields Ave","E Shore Dr","E Shore Path","E Shore Rd","E Shore Way","E Shorecrest Dr",
            "E Shoreview Dr","E Short 10th St","E Side Hill Rd","E Siebert Rd","E Sierra Ave","E Sierra Madre Ave",
            "E Sierra Madre Blvd","E Sierra St","E Sierra View Dr","E Sierra Way","E Siesta Dr","E Silver St",
            "E Skyline Dr","E Skyline Rd","E Smoke Tree Rd","E Snowdon Cir","E Solar Ave","E Solar Dr",
            "E Soledad Ln","E Sonora Ave","E Sonora Rd","E South Ave","E South St","E Sparta Ave SE",
            "E Spawn Lane","E Spray Way","E Spring St","E Springwood","E Spruce Ave","E Spur Dr","E St",
            "E St John St","E St Joseph St","E Stadium Dr","E Star Peak Rd","E State Highway 96","E State Road",
            "E State Route 246","E State St","E Stella Ln","E Stella St","E Stemmer Ln","E Stenzil St",
            "E Sterner St","E Stevens Rd","E Stewart Ave","E Stirrup Dr","E Strayhand St","E Street",
            "E Street Rd","E Stroud","E Stutts Truck Trail","E Sumac Dr","E Summerdale Ct","E Summerfield Ct",
            "E Summerset Ln","E Sun Cloud Pl","E Suncrest Rd","E Sunnyside Ave","E Sunnyside Dr","E Sunrise Ridge Pl",
            "E Surf St","E Susana St","E Sutton Ave","E Swamp Rd","E Swart Rd","E Switch Ave","E Sycamore Ave",
            "E T Ave","E T U Ave","E Tabor Rd","E Taft Ave","E Talcott St","E Talor Dr","E Tanbark Ln","E Tango Cir",
            "E Teague Ave","E Tefft St","E Telegraph Rd","E Telegraph St","E Tenaya Way","E Terminal Produce Dr",
            "E Terra Vista Ln","E Terrace Ave","E Territorial Rd","E Thayer St","E Thelma St","E Thetford Rd",
            "E Thiesen Rd","E Thigpen Dr","E Thomas Ave","E Thomas St","E Thornton Rd","E Thunderbolt Dr",
            "E Thurman Ave","E Timberlane Rd","E Tioga Ave","E Topa Topa St","E Topeka Dr","E Torino Ave",
            "E Tower Ave","E Townline Rd","E Trailridge Cir","E Troy Ave","E Truitt Ave","E Truxtun Ave",
            "E Truxtun Frontage Ave","E Tucumcari Blvd","E Tulare Ave","E Tulip Ln","E Tulipwood St",
            "E Tulsa St","E Tupper Street","E Turnbull St","E Tusculum St","E U St","E Uncle Jack Pl",
            "E Union Ave","E University Ave","E Utica St","E Valencia Rd","E Vallejo Ct","E Valley Rd",
            "E Valley View Ct","E Vartikian Ave","E Vasques","E Vassar Ave","E Ventura St","E Verde Ln",
            "E Vermillion St","E Vermont Ave","E Via Mercado","E Via Montana","E Via Soledad","E Via de Olivos",
            "E Via de Palmas","E Via de Ventura","E View Dr","E Viking Rd","E Villa Theresa Dr","E Village Ct",
            "E Vinewood St","E Vinson Cir","E Virginia Ave","E Vulcanite Ave","E W Ave","E Wade Ave",
            "E Wales Green Ln","E Walkerton St","E Walnut Ave","E Walnut Dr","E Walnut St","E Waltann Ln",
            "E Walter Ave","E Wardlow Rd","E Warner Ave","E Warren St","E Washington","E Washington Ave",
            "E Washington St","E Water St","E Water Street","E Watson Dr","E Waveland Ave","E Webb Ln",
            "E Webster Ave","E Weldon Ave","E Westcott Ave","E Western Sky Ln","E Westmoreland St",
            "E Westward Ave","E Westward Way","E Wheat Rd","E Whispering Wind Dr","E White Ave","E White Pine Ln",
            "E Whitehill Rd","E Whitesboro St","E Whittemore Ave","E Wilbur Rd","E Wild Cherry Ct",
            "E Wildhorse Dr","E Willard St","E Willetta St","E Williams Ave","E Willow Ave","E Willow Point Rd",
            "E Willow St","E Willowick Cir","E Wilson Ave","E Windfall Rd","E Windstone Trl","E Wingshadow Dr",
            "E Winona Ave","E Winslow Williamstown Rd","E Wisconsin St","E Wishart St","E Wister St",
            "E Wood Dr","E Woodbound Dr","E Woodburn Ave","E Woodcock Pl","E Woodhaven Ln","E Woodland Dr",
            "E Woodland Rd","E Woodsdale Ave","E Worley Pl","E Wrenwood Ave","E Wright St","E Wutchumna Ave",
            "E Wyoming Ave","E X Ave","E Yarina Ln","E Yates St","E Yorkshire Dr","E Yucca St","E Zane Ave",
            "E and B St","E and W Section Line","E de Ave","E del Camino","E del Rio Dr","E el Alameda",
            "E el Caminito Dr","E el Carmen St","E el Esteban Way","E el Paseo Ct","E la Cienega St",
            "E la Cresta Ave","E la Paloma Ct","E la Sierra Dr","E0009 Rd","E0015 Rd","E0036 Rd","E0075 Rd",
            "E0085 Rd","E0095 Rd","E0100 Rd","E0120 Rd","E0140 Rd","E0150 Rd","E0190 Rd","E0200 Rd","E0215 Rd",
            "E0220 Rd","E0230 Rd","E0240 Rd","E0247 Rd","E0250 Rd","E0280 Rd","E0303 Rd","E0340 Rd","E0980 Rd",
            "E2140","Eadall Ave","Eadenhurst Ave","Eady Rd","Eagan Ln","Eagen Ct","Eager Ave","Eagle","Eagle 15 Bayview Dr",
            "Eagle Ave","Eagle Bend Ln","Eagle Brook Ct","Eagle Canyon Creek","Eagle Canyon Rd","Eagle Crest Apts Private Rd",
            "Eagle Crest Ct","Eagle Ct","Eagle Dancer Ln","Eagle Dr","Eagle Green Ct","Eagle Harbor Rd",
            "Eagle Hill Rd","Eagle Lake Ln","Eagle Lake Rd","Eagle Ln","Eagle Peak Dr","Eagle Peak Rd",
            "Eagle Point Road","Eagle Pointe Rd","Eagle Rd","Eagle Ridge Dr NE","Eagle Ridge Ln","Eagle Ridge Rd",
            "Eagle Ridge Way","Eagle River Rd","Eagle Rock Ave","Eagle Rock Ct","Eagle Rock Dr","Eagle Rock Rd",
            "Eagle Row","Eagle St","Eagle Sticks Dr","Eagle Street","Eagle Terrace","Eagle Truck Trail",
            "Eagle Valley Rd","Eagle View Dr","Eagle Wash","Eaglecloud Dr","Eaglehelm Ct","Eaglehelm Pl",
            "Eaglemont Dr","Eagles Landing Road","Eagles Nest Ln","Eagles Nest Rd","Eagles Way","Eagleson Road",
            "Eagleston Lane","Eaglestone Road","Eaglet Way","Eagleview Crescent","Eagleview Pl","Eagleview Way",
            "Eaglewood Ave","Eaglewood Boulevard","Eagon Ave","Eakens Court","Eakes Rd","Eakin St","Eames Corners Rd",
            "Eames Street","Eardley Ave","Eardley Ct","Earhart Ct","Earhart Way","Earl Chadick Rd","Earl Ct",
            "Earl Haig Avenue","Earl Rd","Earl Seaton Rd","Earl St","Earl Street","Earl Stringer Rd",
            "Earle Ln","Earley St","Earlham Dr","Earlin Ave","Earls Ct","Earlthorpe Crescent","Earlytown Rd",
            "Earnest Chapel Rd","Earnest St","Earnhart Dr","Earnscliffe Road","Earp St","East Street",
            "East - West Rd","East 101st Street","East 102nd Street","East 107th Street","East 10th Street",
            "East 110th Street","East 114th Street","East 116th Street","East 117th Street","East 120th Street",
            "East 124th Street","East 127th Street","East 12th Street","East 135th Street","East 16th Street",
            "East 17th Street","East 21st Street","East 23rd Street","East 24th Street","East 25th Street",
            "East 26th Street","East 27th Street","East 28th Street","East 2nd Street","East 31st Street",
            "East 34th Street","East 35th Street","East 36th Street","East 37th Street","East 38th Street",
            "East 3rd Street","East 40th Street","East 41st Street","East 42nd Street","East 43rd Street",
            "East 45th Street","East 49th Street","East 50th Street","East 51st Street","East 55th Street",
            "East 56th Street","East 57th Street","East 58th Street","East 5th Street","East 60th Street",
            "East 62nd Street","East 65th Street","East 66th Street","East 68th Street","East 79th Street",
            "East 7th Street","East 81st Street","East 83rd Street","East 86th Street","East 8th Street",
            "East 91st Street","East 92nd Street","East 93rd Street","East 97th Street","East 98th Street",
            "East 99th Street","East Alford Road","East Ave","East Avenue","East Barnard Rd","East Battery Street",
            "East Beach Dr","East Beaver Creek Road","East Berkeley Street","East Blvd Service Road",
            "East Broadway","East Burnside Avenue","East Cat Canyon","East Chaparral","East Charlton Road",
            "East Chestnut Hill Road","East Circle Drive","East Colrain Road","East Communication Road",
            "East Concord Dr","East County Road","East Crawford Ranch Rd","East Crescent Avenue",
            "East Ct","East Don Parkland","East Don Roadway","East Dr","East El Camino Real","East Elm Street",
            "East End Ave","East End Rd","East Fairway Ln","East Fifth St","East Fork","East Fork Rd",
            "East Fourth Ave","East Gate","East Gate Rd","East Grant St","East Green Mountain Rd",
            "East Greenwood Street","East Grippen Lane","East Haskell Avenue","East Haven Drive",
            "East Haverhill Street","East Hill Rd","East Hills Dr","East Hoosick Road","East Houndpack Way",
            "East Houston Street","East James Ct","East Kingston Street","East Laguna Ct","East Lake Dr",
            "East Lake Drive","East Lake Laura Rd","East Lake Rd","East Lake Stable Rd","East Lakeside Dr",
            "East Lane Dr","East Line Road","East Ln","East Main St","East Main Street","East Market St",
            "East Maxwell Dr","East Meadowlark Ln","East Merrimack Street","East Midland Avenue",
            "East Mountain Rd","East New Mexico 44","East New York Avenue","East Oak Street","East Ocean Ave",
            "East Ox Bow Road","East Page Rd","East Park","East Parkway Dr","East Path","East Pearce Street",
            "East Pendleton St","East Pky","East Platt Street","East Railroad Springs Rd","East Rd",
            "East Richardson Road","East Richardson Street","East Ridge Rd","East Rive Road","East River Rd",
            "East River Road","East Road","East Roseville Parkway","East Saddle River Road","East Sheffield Road",
            "East Shor Road","East Shore","East Shore Blvd","East Shore Cv","East Shore Dr","East Shore Ln",
            "East Shore Rd","East Shore Road","East Side Calpella Road","East Spur","East St","East State Street",
            "East Street","East Tally Ho Turn","East Temple Street","East Third Ave","East Tomstead Road",
            "East Trl","East Van Duzen Rd","East Van Vliet Rd","East Washington Street","East Weaver Rd",
            "East Wind Ln","East Windsor Rd","East Windsor Road","East-West Base Line Rd","East-West Park Rd; E River Rd",
            "Eastanollee Rd","Eastbluff Village","Eastbound Service Station","Eastbourne Ave","Eastbourne Dr",
            "Eastbourne Drive","Eastbourne Ter","Eastbrook Ave","Eastbrook Cir","Eastbrook Dr","Eastbrook Ln",
            "Eastbrook Rd","Eastbrooke Ln","Eastburn Ave","Eastcrest Ct","Eastdale Cir Access","Eastdale Court",
            "Eastdale Crescent","Eastdale Ln","Easter St","Easterly Ave","Easterly Dr","Easterly Ter",
            "Eastern 36th Cutoff","Eastern Ave","Eastern Ave SE","Eastern Avenue","Eastern Blvd","Eastern Pky",
            "Eastern St","Eastfield Dr","Eastfork Ln","Eastgate","Eastgate Dr","Eastgate Lane","Eastgate Parkway",
            "Eastham Street","Eastlake Pky","Eastland Ave NE","Eastland Drive","Eastland Pky","Eastland Rd",
            "Eastman Ave","Eastman Rd","Eastman St","Eastman Trl","Eastmere Ln","Eastmoreland Dr","Easton Ave",
            "Easton Dr","Easton Hill Rd","Easton Rd","Easton St","Easton Tpke","Eastonbrook Terrace",
            "Eastpark Ct","Eastport Ct","Eastport Rd","Eastridge Cir","Eastridge Dr","Eastridge Loop",
            "Eastridge Manor Apartment","Eastshore Freeway","Eastside Ave","Eastside Rd","Eastside Sq",
            "Eastside St","Eastvale Drive","Eastview Ave","Eastview Boulevard","Eastview Crescent",
            "Eastview Ct","Eastview Drive","Eastview Ter","Eastville Avenue","Eastward Rd","Eastway",
            "Eastwick Ct","Eastwind Cir","Eastwind Dr","Eastwood Ave","Eastwood Avenue","Eastwood Blvd",
            "Eastwood Court","Eastwood Cv","Eastwood Dr","Eastwood Ln","Eastwood Place","Eastwood Rd",
            "Eastwoods Rd","Easy Ave","Easy Ct","Easy St","Eaton Ave","Eaton Court","Eaton Ct","Eaton Dr","Eaton Gate Rd",
            "Eaton Hwy","Eaton Pl","Eaton Rd","Eaton St","Eaton Street","Eatongate Dr","Eau Clair St","Eau Claire Ave",
            "Eayrestown Rd","Ebb Tide Cir","Ebberts Ranch Rd","Ebbetts Ct","Ebenezer Road","Eberle Rd",
            "Eberlin Dr","Eberly Dr","Ebersole Rd","Ebert Ln","Ebony Court","Ebony Ln","Ebony Rd","Ebonywood Gate",
            "Ebright Ave","Ebury Ct","Eccles St","Eccles Street N","Echo Canyon Cir","Echo Ct","Echo Dr",
            "Echo Glen","Echo Harbor","Echo Lake South Ln","Echo Ln","Echo Point","Echo Point Ln 4","Echo Rd",
            "Echo Ridge Dr","Echo Ridge Road","Echo St","Echo Way","Echovalley St NW","Eckel Rd","Ecker Drive",
            "Eckerson Ave","Eckerson Rd","Eckerson Rd W","Eckert Farm Rd","Eckford Road","Eckles Rd",
            "Eclat Ct","Eclipse Ave","Eco Ridge Rd","Eco Road 746","Econome Ct","Ecopark Gate","Ed Christine Dr",
            "Ed Everett Way","Ed Jones Rd","Ed Quigg Way","Ed Stevens Rd","Edan Canyon Rd","Eddie Ct",
            "Eddie Dr","Eddins Ln","Eddins Rd","Eddy Ave","Eddy Gulch Rd","Eddy Ln","Eddy Loop","Eddy Rd","Eddy Scant City Rd",
            "Eddy Street","Eddystone Cir","Ede St","Edel Ave","Edelheim Road","Edell Pl","Edell Rd","Eden Ave",
            "Eden Cir","Eden Ct","Eden Ct NW","Eden Dr","Eden Prairie Ave","Eden Rd","Eden Road","Eden Roc Cir",
            "Eden St","Eden Street","Eden Valley Drive","Edenborough Drive","Edenbridge Drive","Edenbrook Hill",
            "Edenvale Blvd","Edenville Walk","Edenwood Dr","Eder Ave","Edgar Ave","Edgar Pl","Edgar Rd",
            "Edgar Road","Edgar St","Edgartown West Tisbury Road","Edge Creek Trl","Edge Lane","Edge Water Dr",
            "Edgebrook Ct","Edgebrook Dr","Edgebrook Way","Edgecliff Ave","Edgecliff Ln","Edgecombe Avenue",
            "Edgecroft Road","Edgefield Ct","Edgefield Drive","Edgefield Ln","Edgeford Pl","Edgehill Court",
            "Edgehill Ct","Edgehill Dr","Edgehill Drive","Edgehill Ln","Edgehill Rd","Edgehill Road",
            "Edgehill Way","Edgeley Boulevard","Edgell Rd","Edgell Road","Edgely Ave","Edgely Dr","Edgely Rd",
            "Edgemar Ct","Edgemere Ave","Edgemere Bl","Edgemere Blvd","Edgemere Dr","Edgemere Rd","Edgemont Ave",
            "Edgemont Dr","Edgemont St","Edgemont Ter","Edgemoor Ave","Edgemore Drive","Edgevalley Drive",
            "Edgeview Ave","Edgeview Dr","Edgeview Ln","Edgeware Dr","Edgeware Rd","Edgewater Ave W",
            "Edgewater Ct","Edgewater Dr","Edgewater Drive","Edgewater Ln","Edgewater Pl","Edgewater Rd",
            "Edgewater St","Edgewater Ter","Edgewood","Edgewood NW","Edgewood Ave","Edgewood Avenue",
            "Edgewood Blvd","Edgewood Circle","Edgewood Crescent","Edgewood Ct","Edgewood Ct N","Edgewood Dr",
            "Edgewood Drive","Edgewood Gardens","Edgewood Ln","Edgewood Park Dr","Edgewood Pl","Edgewood Rd",
            "Edgewood Road","Edgewood St","Edgewood Ter","Edgewood Way","Edgley Dr","Edgley St","Edick Rd",
            "Edie Ct","Edie Ln","Edie Rd","Edina Ct","Edinboro Ave","Edinborough Ct","Edinborough St","Edinburg Ct",
            "Edinburgh","Edinburgh Ave","Edinburgh Ct","Edinburgh Dr","Edinburgh Ln","Edinburgh Street",
            "Edington Dr SE","Edison Ave","Edison Green","Edison Park","Edison Pl","Edison Rd","Edison St",
            "Edison Street","Edison Teson Mountain Rd","Edistel Crescent","Edith Ave","Edith Blvd NE",
            "Edith Ct","Edith Dr","Edith Rd","Edith St","Edith Street","Edleen Pl","Edminster Dr","Edmond Ct",
            "Edmond Ln","Edmond Street","Edmonds Pl","Edmonds Rd","Edmondson St","Edmons Street","Edmonston St",
            "Edmonton Dr","Edmonton Rd","Edmonton Road","Edmonton St","Edmonton Street","Edmund Cir",
            "Edmund Dr","Edmund Rd","Edmund St","Edmund Street","Edmund Ter","Edna Circle","Edna Ct","Edna Pl",
            "Edna Purviance Way","Edna Ranch Cir","Edna Rd","Edna St","Edsall Ter","Edsam Ave","Edsam Rd",
            "Edson Street","Edward Ave","Edward Cody Lane","Edward Ct","Edward F Smith Blvd","Edward Hopper Way",
            "Edward Jeffreys Avenue","Edward Pl","Edward St","Edward Street","Edward T Arcy Sr Blvd",
            "Edwards Ave","Edwards Canyon Rd","Edwards Ct","Edwards Deming Dr","Edwards Dr","Edwards Ln",
            "Edwards Point Rd","Edwards Rd","Edwards Road","Edwards St","Edwards Street","Edwin Ave",
            "Edwin Dr NW","Edwin St","Edwin Street","Edwina Ct","Edwins Rd","Edythe's Rd","Eel Dr","Eel River Road",
            "Eel Weir Rd","Eels Lake Road","Effinger Pl SE","Effinger Rd","Effingham Rd","Effingham Trl",
            "Effley Falls Rd","Egan Ct","Egan Cyn Rd","Egan Ln","Egan Pl","Egerter Road","Eggert Rd","Eggleston Pl",
            "Eggleston Rd","Eggo Way","Eginton Ave","Eglin Street","Eglington Street","Eglinton Avenue",
            "Eglinton Avenue East","Eglinton Avenue West","Egremont Plain Road","Ehlers Dr","Ehlers Ln",
            "Ehrenberg Rd","Ehrlich Ct","Eibert Rd","Eichenwald St","Eickhoff Rd","Eickleberry Rd","Eiden Rd",
            "Eider Cir","Eider Dr","Eidner Way","Eifall","Eiffel Boulevard","Eiffel Cir","Eighmy Rd","Eight Mile Ranch Rd",
            "Eighteen Mile Creek Rd","Eighteent Line","Eighth Line","Eighth Louth Avenue","Eighth Street",
            "Eighth Street M","Eileen Avenue","Eileen Dr","Eileen Drive","Eileen St","Eino Dr","Einstein Dr",
            "Eisele Ave","Eisenhower Ave","Eisenhower Avenue","Eisenhower Ct","Eisenhower Dr","Eisenhower Drive",
            "Eisenhower Rd","Eisenhower St","Eiserle Ln","Eiss Pl","Eissler Ct","Eissler School","Eklutna Lake Rd",
            "Ekroos Rd","Ekstrand Road","Ekstrom St","El Acebo","El Aire Pl","El Arco Iris Dr","El Basset Ct",
            "El Bolero Dr","El Cajon Blvd","El Cajon Way","El Callejon","El Caminito St","El Camino",
            "El Camino Ave","El Camino Avenue","El Camino Dr","El Camino Real","El Camino Real Overlook",
            "El Campo Rd","El Cap Ct","El Capitan Dr","El Capitan Ln","El Cazador Way","El Cedro Cir",
            "El Centro Ave","El Centro Dr","El Centro Rd","El Centro St","El Cerrito Ct","El Cerrito Dr",
            "El Charro Ln","El Cielito Rd","El Cimino Dr","El Conquista Rd","El Corto Dr","El Creston Cir",
            "El Dolora Way","El Dorado","El Dorado Ave","El Dorado Dr","El Dorado Freeway","El Dorado Rd",
            "El Dorado St","El Dorado Street","El Encanto Dr","El Ensueno Cir NE","El Ensueno Rd SE",
            "El Este Ave","El Greco St","El Higo Ct SE","El Hogar Ct","El Jardin Ave","El Johnson Rd",
            "El Llano Ln NW","El Mango Way","El Mar Ave","El Medio Pl","El Mercado Pky","El Monte Rd",
            "El Monte Way","El Morado St","El Morro Ave","El Nido Dr","El Nido Ln","El Oso Way","El Paseo Dr",
            "El Paseo Rd","El Paso Pl","El Paso Rd","El Pass","El Patio Drive","El Pharo Dr","El Pinon Rd SW",
            "El Portal Ct","El Portal Dr","El Portal School Rd","El Prado","El Prado Dr","El Prado Rd",
            "El Prado Rd NW","El Pueblo Drive","El Rancho Ave","El Rancho Ct","El Rancho Dr","El Rancho Ln",
            "El Rancho Rd","El Rancho Way","El Redondo","El Rey","El Rey Vista St","El Rio Rd","El Serano Ave",
            "El Sereno Rd","El Solindo Rd","El Sueno Rd","El Teda Ln","El Tejon Ave","El Tejon Avenue",
            "El Terraza Dr","El Tesorito St","El Torero Dr SE","El Toro Ct","El Toro Dr","El Torreon Loop Rd",
            "El Vado","El Vallencito Dr","Elaina Cir","Elaine Ct","Elaine Dr","Elaine Drive","Elaine Rd",
            "Elaine St","Elaine Trail","Elam Cir","Elam Rd","Elan Ln","Elayne St","Elba Aly","Elba Hwy","Elba Rd",
            "Elbe Ave","Elberne Ave","Elberon Ave","Elbert Rd","Elbert Street","Elberta St","Elbethel Rd",
            "Elbon St","Elbow Poi Road","Elbow Point Road","Elbridge St","Elcho Road","Elcho St","Elcona Dr",
            "Eldan Pl","Elden Lookout Rd","Elder Ave","Elder Avenue","Elder Ct","Elder Ln","Elder Pl","Elder Rd",
            "Elder St","Elderberr Lane","Elderberry Ct","Elderberry Ct NE","Elderberry Ln","Elderberry Rd",
            "Elderberry St","Elderbrook Crescent","Elderkin St","Elderly Housing Road","Elderwood Cir",
            "Eldomar Avenue","Eldon Ct","Eldon Road","Eldonia Road","Eldora Pl","Eldorado Canyon Rd",
            "Eldorado Canyon St","Eldorado Dr","Eldorado Lane","Eldorado Pl","Eldorado St","Eldred Circle",
            "Eldred Rd","Eldredge Ave","Eldredge Rd","Eldridge Ave","Eldridge Avenue","Eldridge Cir",
            "Eldridge Ct","Eldridge Dr","Eldridge Lane","Eldridge Rd","Eldrow Rd","Eleanor Ave","Eleanor Cir",
            "Eleanor Court","Eleanor Ln","Eleanor Road","Eleanor St","Eleanor Street","Eleanor Ter","Eleanor Way",
            "Eleanore Ln","Elect Right of Way","Election Ln","Electric Ave","Electric Ave SE","Electric Avenue",
            "Electric Railway","Elementary School","Elen Ct","Elena Ave","Elena Cir SW","Elena Ct","Elena Dr",
            "Elenia St","Elevation St","Elfindale Crescent","Elford Drive","Elgar Court","Elgers St",
            "Elgin Ave","Elgin Court","Elgin Rd","Elgin St","Elgin Street","Elgin Street E","Elgin Street W",
            "Elgin Street West","Eli Cir","Eli Ct","Eli St","Elia Drive","Elias Rd","Eliese Dr","Elijah Street",
            "Elijah Way","Elinor Avenue","Elinor Dr","Elinore Pl","Eliot Place","Eliot Street","Elired St",
            "Elisa Ct","Elisa Lynn Way","Elisabeth Taylor","Elite Road","Elite St","Eliz St","Elizabeth Ave",
            "Elizabeth Ave SE","Elizabeth Avenue","Elizabeth Cornish Lndg","Elizabeth Crescent N",
            "Elizabeth Ct","Elizabeth Dr","Elizabeth Drive","Elizabeth Grove","Elizabeth Ln","Elizabeth Peak Rd",
            "Elizabeth Pky","Elizabeth Pl","Elizabeth Rd","Elizabeth St","Elizabeth Street","Elizabeth Street SE",
            "Elizabeth Ter","Elizabethtown Ct","Elizia Drive","Elk Ave","Elk Creek Rd","Elk Crescent",
            "Elk Ct","Elk Dr","Elk Grove Florin Rd","Elk Horn","Elk Horn Ln","Elk Rd","Elk Ridge Ln","Elk Ridge Run",
            "Elk River Ct","Elk River Mills Rd","Elk River Rd","Elk River Rd N","Elk Run","Elk Run Pl",
            "Elk St","Elk View Tr","Elkhart St","Elkhorn Ct","Elkhorn Getz Rd","Elkhorn Rd","Elkhorn Trl",
            "Elkhurst Dr","Elkins Way","Elko Drive","Elkview Dr","Elkwood Ave","Elkwood Drive","Ella Ave",
            "Ella Ct","Ella Dr","Ella Green Rd","Ella Mae","Ella Rd","Ella St","Ellen Ave","Ellen Court","Ellen Ct",
            "Ellen Dr","Ellen Drive","Ellen Lane","Ellen Ln","Ellen Mine Rd","Ellen Rose Ct","Ellen Springs Ct",
            "Ellen St","Ellen Street","Ellen's Way","Ellendale Drive","Ellendale Rd","Ellenview Ave",
            "Ellenwood Ave","Eller Dr","Ellerbeck Street","Ellerslie Road","Ellerthorpe Ave","Ellery Ave",
            "Ellery Ct","Ellery Street","Ellery Walk","Ellesmeer Avenue","Ellesmere Avenue","Ellesmere Road",
            "Ellicot Dr","Ellicott Pl","Ellicott Trl","Ellie Dr","Ellin Ct","Ellington Dr","Ellington Drive",
            "Ellington Road","Ellington St","Ellingwood Court","Ellinwood Way","Elliot","Elliot Ave S",
            "Elliot Avenue","Elliot Ct","Elliot Drive","Elliot Lane","Elliot Rd","Elliot St","Elliot Street",
            "Elliot Way","Elliotsville Ln","Elliott Lake Ln","Elliott St","Elliott Street","Elliott Ter",
            "Elliott Way","Ellis Aly","Ellis Ave","Ellis Avenue","Ellis Cir","Ellis Ct","Ellis Dr","Ellis Drive",
            "Ellis Pl","Ellis Rd","Ellis Ridge Rd","Ellis Road","Ellis St","Ellis Street","Ellisdale Rd",
            "Ellisen Rd","Ellish Pky","Ellison Bluff Rd","Ellison Drive","Ellison Park","Ellison Pl",
            "Ellison Street","Ellisville Road","Ells Rd","Ellstree Dr","Ellsworth Ave","Ellsworth Dr",
            "Ellsworth Lake Rd","Ellsworth Ln","Ellsworth Rd","Ellsworth Road","Ellsworth St","Ellsworth Street",
            "Ellwood Ave","Ellwood Ct NW","Ellwood Drive","Ellwood Drive W","Ellwood Rd","Elm","Elm Ave",
            "Elm Avenue","Elm Cir","Elm Court","Elm Creek Bvld","Elm Creek Dr","Elm Ct","Elm Ct SE","Elm Dr",
            "Elm Grove Avenue","Elm Grove Dr","Elm Grove Ln","Elm Lawn","Elm Ln","Elm Pl","Elm Place","Elm Rd",
            "Elm Ridge Drive","Elm Road","Elm St","Elm St E","Elm St W","Elm Street","Elm Street Branch",
            "Elm Street South","Elm Tree Road","Elm Tree Road E","Elm Trl","Elm View Rd","Elm Way","Elma Ave",
            "Elmbank Road","Elmbrook Dr","Elmcrest Ave","Elmdale Pl","Elmdon Court","Elmeere Ave","Elmer Ave",
            "Elmer Road","Elmer St","Elmer Wohlfeil Trl","Elmgrove Road","Elmhurst Ave","Elmhurst Avenue",
            "Elmhurst Dr","Elmhurst Drive","Elmhurst Ln","Elmhurst Park","Elmhurst Pl","Elmhurst Rd",
            "Elmhurst Road","Elmira Ave","Elmira Road","Elmira St","Elmira Street","Elmlea Road","Elmo Ave",
            "Elmo St","Elmora Ave","Elmore Rd","Elmore Street","Elmrill Road","Elmrock Ave","Elmsdale Road",
            "Elmsford Ct","Elmsford Dr","Elmwood Ave","Elmwood Avenue","Elmwood Cir","Elmwood Ct","Elmwood Dr",
            "Elmwood Drive","Elmwood Ln","Elmwood Park S","Elmwood Park W","Elmwood Pl","Elmwood Rd",
            "Elmwood St","Elmwood Street","Elmwood Terrace","Elmwood Trl","Elmwood Way","Elnora Rd","Elowin Ct",
            "Eloy Rd","Elphick Lane","Elphick Rd","Elrod Rd","Elrose Road","Elsa Way","Elsbeth Road","Elsiah St",
            "Elsinore Dr","Elsinore St","Elson St SE","Eltapome Hts","Elton Ln","Elton Rd","Elton St","Elva Avenue",
            "Elvanfoot Ln","Elvin Ave","Elvira","Elvira Ct","Elvis Presley Blvd","Elvyn Crescent","Elwood Ave",
            "Elwood Boulevard","Elwood Ct","Elwood Dr","Elwood Pl","Elwood Rd","Elwood St","Elwyn Ct","Ely Dr",
            "Ely Rd","Ely St","Elyse Pl SE","Elysium Dr","Elysium Street","Emanuel Pl","Emanuel St","Embarcadero Ave",
            "Embassy Avenue","Embassy Drive","Emberwood Way","Embla Street","Embro Dr SE","Embry Ave",
            "Emcarr Drive","Emden St","Emelia Ln","Emerald","Emerald Ave","Emerald Canyon Dr","Emerald City Ln",
            "Emerald Court","Emerald Ct","Emerald Dr","Emerald Eagle St","Emerald Gardens Cir","Emerald Gate",
            "Emerald Hgts St","Emerald Isle Dr","Emerald Lane","Emerald Ln","Emerald Mountain Dr",
            "Emerald Oak Dr","Emerald Park Ct","Emerald Rd SW","Emerald River Dr","Emerald St","Emerald Way",
            "Emergency Access","Emeric Ct","Emerson Ave","Emerson Court","Emerson Ct","Emerson Dr","Emerson Hill",
            "Emerson Ln","Emerson Pl NE","Emerson Place","Emerson Rd","Emerson Road","Emerson St","Emerson Way",
            "Emery Hill Boulevard","Emery Ln","Emery Park Rd","Emery Road","Emery St","Emery Way","Emerys Bridge Rd",
            "Emig Ct","Emigrant Pass Rd","Emil Ln","Emilia Pl","Emils Ave","Emily Ave","Emily Ct","Emily Dr",
            "Emily Ln","Emily Pl","Emily Rd","Emily St","Emily Street","Emily's Pass SW","Emily's Place",
            "Eminence Ct","Eminence Road","Emma Ave","Emma Ct","Emma Lee Ln","Emma Road","Emma St","Emma Street",
            "Emmadale St","Emmason Dr SW","Emmet Ave","Emmet St","Emmett Ave","Emmett Avenue","Emmett Ct",
            "Emmett Ln","Emmett Pl","Emmett St","Emmitt Rd","Emmons Avenue","Emmons Cir","Emmons Dr","Emmons Farm Rd",
            "Emmons St","Emmons Street","Emory Ave","Emory Pl","Emperor Ct","Emperor Lane","Empire Ave",
            "Empire Avenue","Empire Drive","Empire Ln","Empire Star Mine Rd","Empress Avenue","Empress Dr",
            "Empress Ln","Empress Street","Empringham Drive","Empty Saddle Ln","Emwood Ave","Emwood Dr",
            "Ena Gunn Rd","Encanto Rd","Encelia Ave","Enchanted Ct","Enchanted Hills Rd","Enchanted Valley Cir NW",
            "Enchantment Cir","Encina Ave","Encina Rd","Encinal St","Encinatas St","Encinitas Ave","Encino Ave",
            "Encino Dr","Encino Ln","Encino Rd","Encino St","Enclave Ct","End Run Ln","Endean Avenue","Enderby Crescent",
            "Enderling Dr","Endicott Ave","Endicott Place","Endicott St","Endicott Street","Endicott Ter",
            "Endmoor Ct","Endres St","Endurance Tr","Endwell St","Endwood Road","Energy Way","Enez Dr","Enfield Ave",
            "Enfield Cir","Enfield Falls Rd","Enfield St","Engard Ave","Engel Ave","Engelwood Nursing Home",
            "England Rd","Engle Rd","Engle St","Engleberg Ter","Englehardt Ave","Englert Ln","Englewood Ave",
            "Englewood Ct","Englewood Drive","Englewood Ln","English Ave","English Creek Rd","English Ct",
            "English Lakes Blvd","English Ln","English Oak Drive","English Oaks Dr","English Range Rd",
            "English Rose Dr","English Settlement Rd","Engman Lake Rd","Engman Rd","Enid St","Eniwetok Dr",
            "Enmount Drive","Ennerdale Street","Ennis Road","Enos Ave","Enos Cir","Enos Gate","Enos Ln",
            "Enos Way","Enramada Dr","Enright Road","Enrique Sanchez Rd","Enrique St","Ensenada","Ensenore Rd",
            "Ensign Dr","Ensign St","Ensley Dr","Ensworth St","Entereza Ln","Enterprise Aly","Enterprise Ave",
            "Enterprise Ave N","Enterprise Ct","Enterprise Dr","Enterprise Drive","Enterprise Lake Rd",
            "Enterprise Rd","Enterprise Road","Enterprise St","Enterprise Way","Entrada Ln","Entrada Pl",
            "Entrada Place NW","Entrada Ridge Ave","Entrada West","Entrados Dr","Entrance Ramp","Entrance Rd",
            "Entranosa Loop","Entranosa Rd","Enviromental Dr","Enzor Rd","Eoline Pass","Eoline Rd","Eos Ln",
            "Ephesus Rd","Epidote Ct","Epidote Rd","Epperson Dr","Epping Court","Eppinger St","Epsom Avenue",
            "Epsom Downs Drive","Equator Crescent","Equestrian Crescent","Equestrian Rd","Equestrian Trl",
            "Equine Incline Loop Trail","Equinox Ave","Equinunk Creek Rd","Equity Ct","Era Heliport",
            "Erasmus Street","Erath St","Erbbe St NE","Erbes Rd","Erbs Way","Erdmann Ln","Erdrick St","Erenst Dr",
            "Erhardt St","Erial Rd","Eric Ct","Eric Dr","Eric John Ct","Eric Ln","Erica Circle Extension",
            "Erica Ct","Erica Drive","Erica Ln","Erickson Rd","Erickson Street","Ericson Road","Ericsson Pl",
            "Erie Ave","Erie Blvd E","Erie Ct","Erie Heights Line","Erie Ln","Erie Pl","Erie Rd","Erie St",
            "Erie St NW","Erika Plz","Erin Centre Drive","Erin Crescent","Erin Ct","Erin Gate Boulevard",
            "Erin Ln","Erin Mills Parkway","Erin Oaks Ct","Erin Trail","Erindale Avenue","Eringate Road",
            "Erledon Rd","Erlesmere Avenue","Erlin Avenue","Erma Ct","Ermine Rd NW","Ernest Dr","Ernest Drive",
            "Ernest Lane","Ernest Parr Gate","Ernest Rd","Ernest St","Ernest Way","Ernie Evans Rd","Ernie Young Rd",
            "Ernst Ave","Eroh Rd","Erreca Rd","Errickson Ave","Errol Flynn","Erskine Creek Rd","Ertman Dr",
            "Ervin Ave","Ervin Ln","Erwin Ave","Erwin Ct","Erwin Hollow Rd","Erwin Ln","Erwin Park","Erwin Pl",
            "Erwin St","Escalante Dr","Escalante Way","Escallonia Ct","Escallonia Dr","Escalon Ct","Escambia Ct",
            "Escanaba Road","Escarpment Dr","Escher Dr","Escher St","Escobar Ct","Escobar St","Escoll Dr",
            "Escondido Ave","Escondido Rd","Escondito Cir","Escott-Rockport Road","Escue Dr","Esker Rd",
            "Esmeralda Ave","Esmeralda Ct","Esmond Avenue","Esmond Pl","Esmond St","Esoteric Way","Espalda Ct",
            "Esparta Ave","Espectro Way","Espee St","Espejo Ave","Espejo Ct SW","Espejo Pl","Espejo St NE",
            "Esperanza","Esperanza Ave","Esperanza Ln","Esperaza Cir","Esperero Trail","Esplanade Ave",
            "Esplanade Ln","Esquire Cir","Esquire Rd","Esrey St","Essa Road","Esse Blvd","Essence Ave","Essendon Ct",
            "Essex Ave","Essex Avenue","Essex Center Drive","Essex County 601","Essex County 619",
            "Essex County 630","Essex County 637","Essex County 662","Essex County 669","Essex Ct",
            "Essex Dr","Essex Drive","Essex Green Ct","Essex Junction Ct","Essex Lane","Essex Ln","Essex Pl",
            "Essex Place","Essex Rd","Essex Road","Essex St","Essex Street","Essex Terrace","Essex Way",
            "Essington Ave","Essla Dr","Estabrook Dr","Estabrook Ln","Estabrook Road","Estado Rd","Estallens",
            "Estancia Ct","Estate Ct","Estate Road","Estates Dr","Este Es Rd","Este Pl","Esteem Dr","Estel Waller Ln",
            "Estell Way","Ester Ave","Ester Rd","Ester St","Esterly St","Estero","Estes Cv","Estes Dr","Estes Ln",
            "Estes Rd W","Esther Ave","Esther Depew St","Esther Dr","Esther Drive","Esther Ln","Esther Shiner Boulevard",
            "Esther St","Estill St","Estlle Ave","Esto Rd","Eston Ln","Eston Pl","Estrada Ave","Estrelita Dr",
            "Estrella Dr","Estrellita Way","Estribo Ln","Estuary Way","Esty Cv","Esty Road","Etchart Ln",
            "Ethan Drive","Ethan Ln","Ethan Way","Ethel Ave","Ethel Ct","Ethel Rd","Ethel St","Etheridge Pl",
            "Etiwanda Ave","Etobicoke Creek Trail","Eton Ct","Eton Dr","Eton Ln","Eton Manor Dr","Eton Pl",
            "Eton Rd","Eton Way","Etra Perrineville Rd","Etriscan Ln W","Etta Ct","Ettrick Cir","Ettrick Ln",
            "Etude Drive","Etz Meloy Mtwy","Eubank Blvd NE","Eubank Blvd SE","Eubank Pl","Eubank Rd",
            "Eubanks St","Eucalyptus Aly","Eucalyptus Ave","Eucalyptus Dr","Eucalyptus Ln","Euclid Ave",
            "Euclid Ave SE","Euclid Avenue","Euclid St","Eudora St","Eufaula Aly","Eugena Ave","Eugene Ave",
            "Eugene St","Eugene Way","Eugenia Rd NW","Eugley Park West","Eula Dr","Eunice St","Eureka Ave",
            "Eureka Ct","Eureka Dr","Eureka Pl","Eureka Rd","Eureka Road","Eureka St","Eureka Valley Rd",
            "Eusden Dr","Eustis Ave","Euston Avenue","Euston Rd","Euston St","Eva Court","Eva Ln","Eva Pl",
            "Eva St","Evan","Evan St","Evangeline Court","Evangeline Road","Evans Avenue","Evans Cir","Evans Court",
            "Evans Ct","Evans Dr","Evans Knoll","Evans Ln","Evans Passway","Evans Pl","Evans Rd","Evans Ridge Rd",
            "Evans Road","Evans St","Evans Street","Evans Ter","Evans Way","Evanston Ct","Evanston Drive",
            "Evanston Pl","Evanstown Rd","Evansville Cv","Evanton Dr","Evart St","Evarts Hill","Evco Ct",
            "Evelun Ave","Evelyn Ave","Evelyn Avenue","Evelyn Ct","Evelyn Ct NE","Evelyn Dr","Evelyn Pl",
            "Evelyn St","Evelyn Street","Evelyndale Dr","Evelyne Rd","Evening Dew Dr","Evening Primrose Ave",
            "Evening Shade Dr","Evening Shade Ln","Evening Song Ln","Evening Star Cir","Evening Star Ct",
            "Evening Star Dr","Ever Ct NW","Ever Ridge Ct","Everbreeze Dr","Everden Road","Everest Dr",
            "Everest Dr N","Everest Dr S","Everett Ave","Everett Avenue","Everett Cir","Everett Ct","Everett Pl",
            "Everett Rd","Everett Road","Everett St","Everett Street","Everett Ter","Everett Way","Everglade Rd",
            "Evergreen","Evergreen Ave","Evergreen Avenue","Evergreen Bay Dr","Evergreen Blvd","Evergreen Cir",
            "Evergreen Circle","Evergreen Ct","Evergreen Dr","Evergreen Dr SW","Evergreen Gardens",
            "Evergreen Hill","Evergreen Lane","Evergreen Ln","Evergreen Meadows Rd","Evergreen Pk",
            "Evergreen Pky","Evergreen Pl","Evergreen Rd","Evergreen Road","Evergreen St","Evergreen Street",
            "Evergreen Ter","Evergreen Way","Evergreens Drive","Everhart Dr","Everingham Court","Everit Circle",
            "Everitt Rd","Everland Dr","Everman Rd","Eversole Dr","Everson Pl","Evert Rd","Everton Court",
            "Everton Drive","Everton St","Evesham Crescent","Evolution","Evolution Rd","Evona Ave","Evreux St",
            "Ewald Dr","Ewald Pl","Ewart Rd","Ewart Street","Ewell Rd","Ewen Avenue","Ewen Drive","Ewing St",
            "Ewins Ln","Exbury Road","Excaliber Lane","Excalibur Ct","Excalibur Dr","Excalibur Rd","Excelsior Mine Rd",
            "Excelsior St","Exchange Boulevard","Exchange Pl","Exchange Rd","Exchange St","Exchange Street",
            "Executive Center Blvd","Executive Cir","Executive Dr","Executive Drive","Executive Park Drive",
            "Executive Park Plaza Rd","Executive Way","Exer Ave","Exeter Dr","Exeter Highland Dr",
            "Exeter Ln","Exeter Rd","Exeter St","Exeter Street","Exeter Ter","Exford Drive","Exit","Exit 116",
            "Exit 278","Exit 303","Exit 311","Exit 362","Exit 375 Highway 404 / Don Valley Parkway",
            "Exit 402B","Exit 441A","Exit 522","Exit Ramp","Exley Ave","Exline Rd","Exmoor Cir","Exmoor Pl",
            "Exmoor Road","Expedition Dr","Experimental Farm Road","Experimental Forest Rd","Exploits Arm",
            "Explorer Ct","Explorer Cv","Express St","Ext","Exterior Street","Exton St","Eyer Drive","Eyers Rd",
            "Eyland Ave","Ez Dr","Ezekiel Porter Road","Ezell St","Ezra Boice Rd","Ezra Pl","F & N Ln","F 41",
            "F A A Rd","F E Jackson Rd","F L 14","F R 1910","F R 439","F R 441","F R 478","F R 76","F R 8100",
            "F R 89","F Rd 62","F S 256","F S 416 Rd","F S 54 Rd","F S 609 Rd","F S 970","F S Rd 81A","F S Rd 95",
            "F S Road 380","F S Road 67","F S Road 731","F S Road 995","F St","F Walk","F-042","F-054","F-064",
            "F-Drive N","FDR Drive","FIXME","FR 445","Faber Cir","Fable Ave","Fabry Dr","Factory Dr","Factory Rd",
            "Factory Site Rd","Factory St","Factory Street","Faculty Cir","Faculty Rd","Faddis Aly","Faggs Manor Ln",
            "Fagundus Rd","Fahy Ave","Faial Ct","Fail St","Failing Ave","Fair Ave","Fair Lawn Ave","Fair Ln",
            "Fair Meadow Ln","Fair Oaks Avenue","Fair Oaks Blvd","Fair Oaks Ct","Fair Oaks Dr","Fair Oaks Lane",
            "Fair Oaks Pl","Fair Ridge Ct","Fair Ridge Dr","Fair St","Fair Street","Fair View Dr","Fair Way",
            "Fair Weather Dr","Fairall Street","Fairbairn Court","Fairbairn Street","Fairbank Ave",
            "Fairbanks Ave","Fairbanks Pl","Fairbanks St","Fairbanks Street","Fairbanks Turn","Fairbrook Dr",
            "Fairbrook Ln","Fairchild Ave","Fairchild Dr","Fairchild St","Faircliff Rd","Faircrest Ave NW",
            "Fairdale Drive","Fairdale Pl","Fairfax Ave","Fairfax Crescent","Fairfax Dr","Fairfax Ln",
            "Fairfax Pl","Fairfax Rd","Fairfax Rd SW","Fairfax St","Fairfax Street","Fairfield Ave","Fairfield Avenue",
            "Fairfield Boulevard","Fairfield Cir","Fairfield Ct","Fairfield Dr","Fairfield Drive",
            "Fairfield Pl","Fairfield Place","Fairfield Rd","Fairfield St Cantalier St Aly","Fairfield Street",
            "Fairfield Ter","Fairfield Way","Fairglen Avenue","Fairglen Crescent","Fairgroun Road",
            "Fairground Ave","Fairground Lane","Fairground Rd","Fairground St","Fairgrounds","Fairgrounds Dr",
            "Fairgrounds Rd","Fairgrove Avenue","Fairhaven Ct","Fairhaven Dr","Fairhaven Drive","Fairhaven Pl",
            "Fairhaven Road","Fairhill Dr","Fairhill Ln.","Fairholme Drive","Fairington Crescent",
            "Fairland Pl","Fairland Road","Fairlane Dr","Fairlawn Ave","Fairlawn Dr","Fairlawn Street",
            "Fairlea Avenue","Fairlea Dr","Fairlee Rd","Fairlock Ave","Fairmead Blvd","Fairmeadow Avenue",
            "Fairmeadow Place","Fairmont Ave","Fairmont Cir","Fairmont Dr","Fairmont Way","Fairmount Ave",
            "Fairmount Boulevard","Fairmount Ct","Fairmount Dr","Fairmount Park Ave NE","Fairmount Rd",
            "Fairmount Ter","Fairoaks Ct","Fairoaks St","Fairplain Dr","Fairplay Rd","Fairpoint Maynard Rd",
            "Fairpoint New Athens Rd","Fairport Rd","Fairty Drive","Fairvalle Road","Fairview","Fairview Ave",
            "Fairview Ave N","Fairview Avenue","Fairview Avenue E","Fairview Cir","Fairview Ct","Fairview Dr",
            "Fairview Dr S","Fairview Drive","Fairview Drive South","Fairview Fire Road","Fairview Lane",
            "Fairview Ln","Fairview Mall Drive","Fairview Pl","Fairview Place","Fairview Rd","Fairview Road",
            "Fairview St","Fairview Ter","Fairview Way","Fairwaters Ln","Fairway","Fairway Ave","Fairway Ct",
            "Fairway Ct N","Fairway Dr","Fairway Dr E","Fairway Drive","Fairway Gardens","Fairway Ln",
            "Fairway Pines","Fairway Rd","Fairway Road","Fairway St","Fairway Trails Dr","Fairway View Dr",
            "Fairways Dr","Fairweather Rd","Fairweather Xing","Fairwinds Pl","Fairwood Crescent","Fairwood Dr",
            "Fairwynde Cir NW","Fairy Ring Ln","Faith","Faith Dr","Faith Home Rd","Faith Ln","Falbourne Street",
            "Falcon Bluff Ct","Falcon Court","Falcon Crest Dr","Falcon Crest Ln","Falcon Ct","Falcon Dr",
            "Falcon Ln","Falcon Rd","Falcon Ridge Parkway","Falcon St","Falcon Street","Falcon Ter","Falcon Way",
            "Falconcrest Drive","Falconwood Sq","Falconwood Way","Falk Pl","Falkinburg Dr","Falkirk",
            "Falkirk Street","Falkirk Terrace","Falkland Way","Fall Ave","Fall Brook Rd","Fall Creek Rd",
            "Fall Creek Ridge Rd","Fall Creek St","Fall Dr","Fall Mountain Rd","Fall River Avenue",
            "Fall Street","Fall Trail Rd","Fall View Dr","Fall Wy","Fallaw Rd","Fallbrook Ave","Fallbrook Rd",
            "Fallbrook Road","Fallbrook St","Fallbury Ct","Fallen Leaf Ave","Fallen Leaf Ct","Fallen Leaf Lake Rd",
            "Fallen Leaf Lane","Fallen Leaf Ter","Fallen Oak Rd","Fallen Oak Street","Fallen Oaks Ln",
            "Fallen Tree Ct","Falling Leaf","Falling Leaf Ct","Falling Leaf Trl","Falling Springs Ave",
            "Falling Springs Rd","Falling Star Dr","Falling Tree Ave","Falling Water Ct","Falling Water Trail",
            "Falling Waters Trail","Fallingbrook Crescent","Falls Brg","Falls Creek Rd","Falls Grove Ln",
            "Falls Road","Falls Spring Rd NW","Falls View Ln","Fallsdale Rd","Fallview Dr","Fallview Rd",
            "Falmouth Ave","Falmouth Ct","Falmouth Rd","Falmouth Road","Falmouth St","False Point Ct",
            "False Ravine Trail","Falstaff Avenue","Falstaff Rd","Falstrom Ct","Falveys Way","Falvo Street",
            "Fama Rd","Fambrough Dr","Family Ct","Fancher Ave","Fancher Rd","Fandango Pl","Fandon Ave","Fannie Jackson Rd",
            "Fanoni Ln","Fanshawe Drive","Fanslow","Fansonia Plantation Rd","Fantasy Ln","Far Niente Dr",
            "Faraday Rd","Farago Ave","Farah Dr","Farber Ln","Farbridge St","Farewell St","Fargo Avenue",
            "Fargo Pl","Fargo Road","Fargo St","Farham Ct","Farhill Rd","Faria Ave","Faring Ford Rd","Faris Avenue",
            "Farlaine Drive","Farley Aly","Farley Dr","Farley Place","Farley Road","Farley St","Farley's Point Rd",
            "Farlin St","Farm Hill Road","Farm House Rd","Farm Lane","Farm Ln","Farm Rd","Farm Ridge Rd",
            "Farm Road 100","Farm Road 2149 East","Farm Service Road","Farm St","Farm View Dr","Farm-to-Market Road 1169",
            "Farm-to-Market Road 125","Farm-to-Market Road 1294","Farm-to-Market Road 1399",
            "Farm-to-Market Road 1437","Farm-to-Market Road 145","Farm-to-Market Road 1527",
            "Farm-to-Market Road 1573","Farm-to-Market Road 2130","Farm-to-Market Road 2298",
            "Farm-to-Market Road 2357","Farm-to-Market Road 281","Farm-to-Market Road 298","Farm-to-Market Road 3458",
            "Farm-to-Market Road 769","Farm-to-Market Road 788","Farm-to-Market Road Rd 2295",
            "Farman Rd","Farmbrook Road","Farmcote Drive","Farmcote Road","Farmer Ave","Farmer Court",
            "Farmer Ct","Farmer Dr","Farmer Ln","Farmer Ranch Rd","Farmer St","Farmers Ln","Farmersville Road",
            "Farmfield Street","Farmhouse Ln","Farmingdale Ave","Farmingdale Dr","Farmingdale Pky",
            "Farmington Ave","Farmington Drive","Farmington Ln","Farmington Rd","Farmington River Tpke",
            "Farmington Valley Greenway","Farmington Woods Ct","Farmland Ave","Farmstead Court",
            "Farmstead Ln","Farmstead Road","Farmstead Way","Farmview Ct","Farmview Road","Farmville Rd",
            "Farner Ave","Farnes Ave","Farney Pit Rd","Farnham Ave","Farnham Ct","Farnham Sq","Farnham Street",
            "Farningham Crescent","Farnsworth Ave","Farnsworth Ln","Farnum Ave","Farnum Ct","Farnum Rd",
            "Farnum St","Farnum Street","Farnworth Close","Farquhar Rd","Farr Avenue","Farr Ln","Farr Rd",
            "Farr's Ln","Farragut Ave","Farragut Ct","Farragut Dr","Farragut Ln","Farragut Pl","Farragut Place",
            "Farragut Rd","Farragut Street","Farrah Ln","Farran Drive","Farrar Ln","Farrell Cir","Farrell Corners",
            "Farrell Court","Farrell Rd NW","Farrelly Ave","Farrelo Rd","Farridge Ct","Farringdon Ave",
            "Farrington Ave","Farrington Ct","Farrington Rd","Farrington St","Farris Dr NW","Farris Ln",
            "Farroll Ave","Farrows St","Farside St","Farthing Way","Farview Ct","Farview Dr","Farview Hill Rd",
            "Farview Ln","Farwell Ave","Farwell Dr","Farwell Rd","Farwell St","Farwil Dr","Fascination St",
            "Fashion Island Blvd","Fashion Plz","Fast Ct","Fast Lane Loop","Fast Ln","Father Devalle Boulevard",
            "Father John Sarantos Way","Father Mcgivney Way","Father Tobin Road","Fathom Ave","Fats Hollow",
            "Faulkenburgh Ave","Faulkland Road","Faulkner Avenue","Faulkner Ct","Faulkner Lake Rd",
            "Faulkner Rd","Faulkner Street","Fauna Ave","Fauquier Avenue","Faust Ave","Fava Dr","Faverino",
            "Favor Street","Fawcett Trail","Fawn Brook Ct","Fawn Cir","Fawn Court","Fawn Creek Ct","Fawn Ct",
            "Fawn Dr","Fawn Drive","Fawn Fescue Ct","Fawn Hill Dr","Fawn Hill Pl","Fawn Hill Rd","Fawn Lake Rd",
            "Fawn Ln","Fawn Rd","Fawn Ridge Ct","Fawn Ridge Dr","Fawn Run","Fawn St","Fawn Trl","Fawn Valley Pl",
            "Fawn Way","Fawncrest Blvd","Fawndale Road","Fawnridge Dr","Fawson Cove Way","Faxon Ave",
            "Faxon Road","Fay Court","Fay Pl SW","Fayann Ln","Faye Harris Rd","Faye St","Fayette Rd","Fayette St",
            "Fayette Way","Fayle St","Fays Ln","Faysmith Ave","Fdr Veterans Hospital Rd","Feagin Ave",
            "Feak Hollow Rd","Feakin Ave SW","Fearing Street","Feather Canyon Rd","Feather Cir","Feather Dr",
            "Feather Farms Rd","Feather Ln","Feather River Dr","Featherbed Ln","Featherstar Ave","Featherston Drive",
            "Featherstone Avenue","Featherstone Canyon Rd","Featherstone Rd","Feathertop Lane",
            "Featherwood Ave","Feature Dr","Febo Ct","Febrianti Way","Federal Ave","Federal Blvd","Federal Circle",
            "Federal Court","Federal Ct","Federal Farm Dr","Federal Forest 2284 Rd","Federal Forest 3630 Rd",
            "Federal Forest Road 4500","Federal Forest Road 461","Federal Furnace Road","Federal Lane",
            "Federal Ovp St","Federal Pond Road","Federal Rd","Federal Road","Federal St","Federal Street",
            "Federman Dr","Fedirko Ct","Fee Place","Feeder Canal Road","Feeder Road S","Feeder Run Cir NW",
            "Feedlot Ln","Feek Rd","Feely Ln","Fehler Lane","Feiger Ln","Fein Ln","Feister St","Fela Dr","Felan Crescent",
            "Felas Ct","Felbrigg Avenue","Felch Rd","Feldbaum Pl","Felder Dr","Feldman Ter","Feldspar Ct",
            "Felicidad Ct","Felicity Lane","Felisa Ct","Felix Ave","Felix Canyon Rd","Felix Pl","Feliz Creek Dr",
            "Fell Line","Fell St","Fell Street","Fellows Farm Rd","Fellows Ln","Fellows Rd","Fellowship Ct",
            "Fellowship Way","Fells Lane","Fellscrest Rd","Fellsway","Fellswood Dr","Fellswood Way","Felspar Ave",
            "Felstead Avenue","Felt Rd","Felta Rd","Felter Rd","Felter St","Felterwood Ln","Felton Place",
            "Felton Pond Road","Felton Rd","Felton St","Felton Street","Feltus St N","Femia Road","Fenced Land Grant Boundary",
            "Fencourt Avenue","Fenders Ferry Rd","Fenders Rd","Fenderson Rd","Fendt Farm Rd","Fenhold St",
            "Fenimore St","Fenland Dr","Fenmar Drive","Fenmore Ave","Fenn Avenue","Fennell Street","Fenner Dr",
            "Fenner St","Fennimore Ter","Fenning Drive","Fenside Drive","Fenton Ave","Fenton Dr","Fenton Ln",
            "Fenton Rd","Fenton St","Fenton Street","Fenway Ave","Fenway Ct","Fenwick Avenue","Fenwick Pl",
            "Fenwick Way","Fenwood Crescent","Ferdon St","Fergalea Avenue","Fergerson Ave","Fergushil Road",
            "Ferguson","Ferguson Ave","Ferguson Avenue","Ferguson Cir","Ferguson Corners Rd","Ferguson Drive",
            "Ferguson Rd","Ferguson St","Ferin Rd","Ferina St","Fermery Dr","Fermin Ln","Fermoy Ln","Fern Ave",
            "Fern Avenue","Fern Ct","Fern Dr","Fern Glenn Way","Fern Hollow Rd","Fern Ln","Fern Rd","Fern Rock Rd",
            "Fern St","Fern Street","Fern Trail","Fern Trl","Fernald Ln","Fernandez Ln","Fernbrook Cir",
            "Fernbrook Ct","Fernbrook Dr","Ferncliff Cir","Ferncliff Court","Ferncliff Ct","Ferncliff Rd",
            "Ferncroft Rd","Ferncroft Way","Ferncuko St","Ferndale Ave","Ferndale Avenue","Ferndale Cir",
            "Ferndale Ct","Ferndale Dr","Ferndale Rd","Ferndale St","Ferndell Circle","Ferndell Dr","Ferne Blvd",
            "Ferne-Rachel Road","Fernhill Boulevard","Fernhill Ct","Fernhill Dr","Fernley Ct","Fernley Out of Town Park",
            "Fernmoor Drive","Fernon St","Fernrae Dr","Fernridge","Fernridge Ct","Fernridge Dr","Fernside Court",
            "Fernside St","Fernview Dr","Fernway Cir","Fernwood Ave","Fernwood Avenue","Fernwood Ct",
            "Fernwood Dr","Fernwood Gardens","Fernwood Ln","Fernwood Park","Fernwood Pl","Fernwood Place",
            "Fernwood Rd","Fernwood St","Fernwood Ter","Ferrati Rd","Ferreira Ranch Dr","Ferrell","Ferrell Ave",
            "Ferrell Hill Rd","Ferrells Ln","Ferrier Avenue","Ferrier St","Ferrin Ct","Ferris Ave","Ferris Avenue",
            "Ferris Ct","Ferris Lane","Ferris Ln","Ferris Rd","Ferris St","Ferron Rd","Ferry Bridge Rd",
            "Ferry Camp Rd","Ferry Crossing Hill Rd","Ferry Lane","Ferry Ln","Ferry Pl","Ferry Rd","Ferry Road",
            "Ferry Road Extension","Ferry St","Ferry Street","Ferry Street Branch","Fersgh Ln","Fertig St",
            "Fertiledale Drive","Fessenden Pl","Fesserton Road","Fesserton Sideroad","Festivity Cir",
            "Fetty Rd","Fetyko Ave","Feutz","Ff 2292A","Ff Rd 2234F","Ff Rd 2871","Ff3660","Fiber Rd","Fiddle Creek Rd",
            "Fiddle Hill Rd","Fiddlehead Ct","Fiddler Hill Rd","Fiddlers Elbow Rd","Fiddlers Green Rd",
            "Fidlar Glen Road","Fidler Ave","Field Ave","Field Avenue","Field Court","Field Ct","Field Ln",
            "Field Rd","Field Sparroway","Field St","Field Stone Road","Field Street","Fieldbrook Rd",
            "Fieldcrest Dr","Fieldcrest Lane","Fieldcrest Ln","Fieldcroft Court","Fielden Avenue",
            "Fielden Ln","Fielder Ct","Fieldgate Dr","Fieldgate Drive","Fieldhedge Dr","Fielding Drive",
            "Fieldlark Dr","Fieldlight Boulevard","Fields Ave","Fields Avenue","Fields Rd","Fields St",
            "Fieldspring Dr","Fieldston Road","Fieldstone Ct","Fieldstone Dr","Fieldstone Drive","Fieldstone Ln",
            "Fieldstone Rd","Fieldstone Ter","Fieldstone Way","Fieldview Crescent","Fieldview Dr",
            "Fieldway Road","Fien St","Fiero Dr","Fiero Rd","Fierro Ct","Fierro Rd","Fiesta Blvd","Fiesta Way",
            "Fietta Ln","Fietta Rd","Fietz Ln","Fife Ave","Fife Court","Fife Ln","Fife St","Fife Street","Fife-Coal Rd",
            "Fifield Ln","Fifield Rd","Fifteen Road","Fifteenth Avenue","Fifteenth Line","Fifteenth Street",
            "Fifth Avenue","Fifth Line W","Fifth Louth Street","Fifth St","Fifth Street","Fifty Eight Street",
            "Fifty Road","Fig Ave","Fig Ct","Fig Leaf Cir","Fig Leaf Cv","Fig St","Figg Rd","Figgie Dr","Figmond Ave",
            "Figueroa Mountain Rd","Figueroa St","Figueroa St Mormon St Aly","Filbert Ave","Filbert Ct",
            "Filbert Dr","Filbert Rd","Filbert St","Filbert Way","Filer Rd","Filer St","Filkins Ln","Fillingham",
            "Fillmore Ave","Fillmore Dr","Fillmore Pl","Fillmore Rd NE","Fillmore St","Fillmore Street",
            "Fillup Dr SE","Filly Way","Filmic Lane","Filmore Ave","Filmore St","Filter Plant Rd","Fin del Sender",
            "Finca","Finch","Finch Avenue","Finch Avenue East","Finch Avenue W","Finch Avenue West","Finch Bus Terminal",
            "Finch Ct","Finch Dr","Finch Ln","Finch Rd","Finch St","Finch Street","Finderne Rd","Findhorn Ln",
            "Findlay Way","Findley Ave","Findley Dr","Findley's St","Fine Blvd","Fingal St","Fingerboard Rd",
            "Fingerling Ln","Fingers Dr NE","Fini Dr","Fink Rd","Finkbohner Rd","Finke Rd","Finkle Hill Rd",
            "Finlandia Blvd","Finlaw Rd","Finley Ave","Finley Avenue","Finn Cove Ct","Finney Bridge Rd",
            "Finney Rd","Finney Street","Finngal Pl","Finnigan Rd","Finnon Reservoir Rd","Finns Dr","Fintray Pl",
            "Fiorentin St","Fir Ave","Fir Court","Fir Creek Trl","Fir Ct","Fir Dr","Fir Ln","Fir Loop Ct","Fir Rd",
            "Fir St","Fir Trl","Fire Academy Dr","Fire Agate Dr","Fire Break Rd","Fire Cove Rd","Fire Crown Cir",
            "Fire Dance Ct","Fire Dept Rd","Fire House Hill","Fire House Ln","Fire House Road","Fire Lane 10A",
            "Fire Lane 11","Fire Lane 16","Fire Lane 22","Fire Lane 31","Fire Lane 33","Fire Lane 34",
            "Fire Lane 344","Fire Lane 361","Fire Lane 4","Fire Lane 41","Fire Lane 49","Fire Lane 5",
            "Fire Lane 9","Fire Ln","Fire Ln 178","Fire Ln 30","Fire Ln 4","Fire Loop Trail","Fire Rd","Fire Rd 142",
            "Fire Rd 26","Fire Rd 32","Fire Rd 4880 W","Fire Rd 4906 W","Fire Rd 4964 W","Fire Rd 58",
            "Fire Road 18","Fire Road 38","Fire Road 52","Fire Road 83","Fire Rout","Fire Route","Fire Route 122",
            "Fire Route 13","Fire Route 18","Fire Route 202","Fire Route 207","Fire Route 223","Fire Route 23",
            "Fire Route 253","Fire Route 26A","Fire Route 26C","Fire Route 32","Fire Route 33A","Fire Route 354",
            "Fire Route 367","Fire Route 48C","Fire Route 5","Fire Route 52B","Fire Route 54","Fire Route 55",
            "Fire Route 58F","Fire Route 61A","Fire Route 82D","Fire Route 85F","Fire Station Rd",
            "Fire Tower Rd","Fire Trl","Firebird Ct","Firebird Ln","Firebreak","Firecreek Rd","Firecrest Ave",
            "Firefighter Cook","Firefly Cv","Firefly Ln","Fireglow Ln","Firehouse Ln","Firelane 200",
            "Firelane 33","Firelane 71","Fireman Dr","Fireman St","Firenze St","Fireside Ct","Fireside Way",
            "Firestation St","Firestone Blvd","Firestone Dr","Firestone Way","Firethorn Dr","Firethorn Way",
            "Firetower Dr","Firetower Rd","Fireweed Dr","Firewheel Rd NW","Firewood Dr","Firmament Ave",
            "First Avenue","First Breath Dr","First Creek Hiking Trl","First Lift Canal","First Montgomery Dr",
            "First Parish Road","First Road","First ST","First St","First Street","Firth Ln","Firwood Crescent",
            "Firwood Ct","Firwood Ln","Fischer Ave","Fischer Blvd","Fischer Rd","Fish Canyon Rd","Fish Creek",
            "Fish Creek Rd","Fish Creek Wash","Fish Eddy-Sullivan County Line Rd","Fish Hatchery Rd",
            "Fish Hawk Road","Fish Hill Ln","Fish Hill Rd","Fish Hill Road","Fish Hook Ln","Fish Rd",
            "Fish Rock Rd","Fish and Game Club Road","Fish and Game Rd","Fisher Ave","Fisher Avenue",
            "Fisher Cir","Fisher Ct","Fisher Dr","Fisher Drive","Fisher Estates Ln","Fisher Farm Rd",
            "Fisher Lake Rd","Fisher Pl","Fisher Rd","Fisher Ridge","Fisher Road","Fisher St","Fisherdick Road",
            "Fishermans Dr","Fishers Ln","Fisherville Road","Fishing Creek Rd","Fishing Lake Road",
            "Fishing Ln","Fishing Village Rd","Fishlock Street","Fishtrap Rd","Fisk Avenue","Fisk Road",
            "Fiske Mill Road","Fiskin Avenue","Fitch Ln","Fitch St","Fitch Street","Fitchburg Cemetery",
            "Fitchburg Road","Fitchs Bridge Road","Fittons Road E","Fittons Road W","Fitzgerald Dr",
            "Fitzgerald Way","Fitzgibbon Avenue","Fitzpatrick Dr","Fitzpatrick Way","Fitzrandolph Ave",
            "Fitzrandolph Rd","Fitzroy Terrace","Fitzsimmans Lake Ave","Five Cent Gulch St","Five Hills Pl",
            "Five Kezar Ponds Rd","Five Mile Line Road","Five Mile Rd","Five Oaks Way","Five Pennies Ln",
            "Five Points Dr","Five Points Fredonia Rd","Five Points Rd","Five Points St","Fivemile Rd",
            "Fizz Ln","Fl 271","Fl1107","Flaca Ln","Flafair St","Flagg Ave","Flagg Dr","Flagg Road","Flagg St",
            "Flagg West Rd","Flagpoint Ave","Flagstaff Ct","Flagstaff St","Flagstone Ct","Flagstone Dr",
            "Flagstone Drive","Flaherty Ln","Flambeau St","Flame Vine Ct","Flaming Oak Dr","Flaming Thorn Dr",
            "Flamingo Cir","Flamingo Cv","Flamingo Ln","Flamingo Pl","Flamingo Rd","Flamingo Terrace Dr",
            "Flamingo Way","Flaminia Court","Flamm Brook Rd","Flanagan Hollow","Flanagan Rd","Flanders Ave",
            "Flanders Ln","Flanders Rd","Flanders St","Flannigan Rd","Flansburg Rd","Flat River Rd","Flat Rock Rd",
            "Flat Rock Road","Flat St","Flat Wood Rd","Flatbush Ave","Flatbush Avenue","Flathead River Ct",
            "Flatiron Rd","Flatwoods Drive","Flauhaus Rd","Flavell Road","Flavian Ave","Flax Ct","Flax Garden Way",
            "Flax Island Rd","Flazington Court","Flecha Doble","Fleck Rd","Fleck Rd NE","Fleet Ct","Fleet Street",
            "Fleet Walk","Fleetwell Ave","Fleetwood Dr","Fleetwood Rd","Fleetwood Road","Fleming Dr",
            "Fleming Ln","Fleming Rd","Fleming Road","Fleming St","Flemington Court","Flemington Road",
            "Flemington Whitehouse Rd","Fletcher Ave SW","Fletcher Blvd","Fletcher Dr","Fletcher Drive",
            "Fletcher Lake Ave","Fletcher Place","Fletcher Rd","Fletcher St","Fletcher Street","Fletcher Wright Dr",
            "Fleur de Lis Rd","Fleur-de-Lis Court","Flickner Rd","Flint","Flint & Smith Rd","Flint Ave",
            "Flint Bock Trl","Flint Corn Rd","Flint Fork Cir","Flint Ln","Flint Lock Dr","Flint Memorial Park",
            "Flint Place","Flint Pond Road","Flint Rd","Flint Ridge Dr","Flint St","Flint Street","Flint Town Road",
            "Flint Way","Flinthill Pl","Flintlock Ct","Flintlock Rd","Flintlock Road","Flintlock St",
            "Flintlock Way","Flintock Trl","Flintoft Ct","Flitsch Dr","Flittertown Rd","Float Rd","Flood Control Rd",
            "Flood Rd","Floodwall St","Floodway Rd","Flor Amarilla","Flor Blanca","Flor Marsha","Flor de Sol",
            "Flor del Rio","Flor del Sol","Flora Ave","Flora Azalea Ct","Flora Bay","Flora Camellia Ct",
            "Flora Cir","Flora Ct","Flora Drive","Flora Ln","Flora St","Flora Vista Dr","Floradale St","Floral Ave",
            "Floral Ave S","Floral Ct","Floral Dr","Floral Ln","Floral Parkway","Floral Street","Floral Ter",
            "Floralia St","Floralita Ave","Florallan Ct","Floralview Dr S","Florek Road","Florelle Drive",
            "Florence Ave","Florence Ave NE","Florence Avenue","Florence Blvd","Florence Court","Florence Ct",
            "Florence Dr","Florence Drive","Florence Ln","Florence Pl","Florence Rd","Florence Road",
            "Florence St","Florence Street","Florence Twn Rd F","Florentine Dr","Florentine Gardens",
            "Florentine St","Flores Ave","Flores Dr","Florida","Florida Ave","Florida Ave SW","Florida Court",
            "Florida Ct","Florida Keys Dr","Florida Ln","Florida Rd","Florida Rd NW","Florida Road","Florida St",
            "Floridora","Florie Farm Rd","Florine Ave","Flory Ave","Flossmore Road","Flournoy St","Flow Rd",
            "Flower Br","Flower Ln","Flower Street","Flower Valley Cir","Flowerday Dr","Flowering Cactus Pl",
            "Flowering Tree Dr","Flowing Wells Ln","Floyd Avenue","Floyd Ct","Floyd Dr","Floyd Ln","Floyd St",
            "Floyd Ter","Floyd Walk","Fluellen Drive","Fluker Rd","Flume Creek Rd","Flume Ct","Flume Rd",
            "Flume St","Fluorite Dr","Fluorite Rd","Fly Jib Court","Flyatt Rd","Flycatcher Avenue","Flyer Rd",
            "Flying B Dr","Flying Eagle Ln","Flying K Ranch Ln","Flying K Ranch Rd","Flynn Creek Rd",
            "Flynn Ct","Flynn Dr","Flynn Mountain Rd","Flynn Rd","Flynn St","Flynn's Road","Fmc-Paradise Pk Rd",
            "Fnick","Foam Avenue","Foamore Ln","Fobes Island","Fobes Rd","Foch","Foch St","Fodderstack Mnt Rd",
            "Foden Rd","Fofo Loop","Fogg Rd S","Fogleman Rd","Fohl Rd","Foley Beach Expy","Foley Dr","Foley Ln",
            "Foley Rd","Foley Road","Folger St","Folks Rd NE","Folkstone Crescent","Folkway Drive","Follansbee Rd",
            "Follett Rd","Follett St","Follett Street","Follette Street","Follins Bay Road","Follis Avenue",
            "Folly Mill Ter","Folmac Cir","Folsom Boulevard","Folsom Dr","Folsom Oaks Ct","Folsom Parkway Rail Trail",
            "Folsom Rd NW","Folsom St","Fomer Road","Fonda Ave","Fonda St","Fondiller St","Fontain St","Fontaine Ave",
            "Fontaine Bleau Dr","Fontaine Drive","Fontana Ave","Fontana Ct","Fontana St","Fontanelle Dr",
            "Fontenelle Dr","Fontenelle St SE","Fonthill Ave","Foolish Pleasure Rd","Fools Acre Rd",
            "Foot Path","Foot Trl","Footbridge Road","Foote Crossing Rd","Foote Pl","Footehill Rd","Foothill Blvd",
            "Foothill Border Rd","Foothill Dr","Foothill Dr SE","Foothill Expressway","Foothill Freeway",
            "Foothill Ln","Foothill Oaks Dr","Foothill Rd","Foothill Road","Foothill Vista Dr","Foots Corners Rd",
            "Foraker Ln","Forbes Ave","Forbes Avenue","Forbes Dr","Forbes Field Ct","Forbes Street","Forbestown Reservoir Rd",
            "Forbidden Dr","Forbus Rd","Forbush Rd","Forbush St","Force Dr","Forces Hill Rd","Ford Ave",
            "Ford Ct","Ford Dr","Ford Drive","Ford Hill Road","Ford Ln","Ford Products Rd","Ford Rd","Ford Road",
            "Ford St","Ford Street","Ford Valley Rd","Ford Wilson Boulevard","Fordham","Fordham Ave",
            "Fordham Cir","Fordham Ct","Fordham Dr","Fordham Place","Fordham Rd","Fordham Way","Fordhouse Boulevard",
            "Fordi Ct","Fordover Drive","Fordway Rd","Fore Way","Forecastle Road","Forecastle Way","Foreman Ave",
            "Foreman Ln","Foreman Park","Foremast Ct","Forepeak Dr","Forest","Forest 11 Trl","Forest 263 Rd",
            "Forest 2676","Forest 3N10","Forest 458 Rd","Forest 467 Rd","Forest 493 Rd","Forest 83 Rd",
            "Forest Access Rd","Forest Ave","Forest Ave; Franklin St","Forest Avenue","Forest Avenue S",
            "Forest Bay Dr","Forest Blvd","Forest Brook St","Forest Cir","Forest Creek Ct","Forest Ct",
            "Forest Dr","Forest Drive","Forest Edge Ct","Forest Edge Dr","Forest Fire","Forest Glade Boulevard",
            "Forest Glen Cir","Forest Glen Crescent","Forest Glen Ct","Forest Glen Dr","Forest Glen Drive",
            "Forest Glenn Blvd","Forest Grove Ln","Forest Heights Boulevard","Forest Heights Street",
            "Forest Hill","Forest Hill Ave","Forest Hill Dr","Forest Hill Drive","Forest Hill Pky",
            "Forest Hill Rd","Forest Hill Road","Forest Hill Street","Forest Hills Com","Forest Hills Dr",
            "Forest Hills Park Rd","Forest Hills Rd","Forest Hills Road","Forest Hills Way","Forest Home Rd",
            "Forest Hwy 209","Forest Knoll Drive","Forest Knoll St","Forest Lake Dr N","Forest Lane",
            "Forest Lawn Ave","Forest Ln","Forest Lodge Lake Rd","Forest Manor Gate","Forest Manor Road",
            "Forest Meadow Pl","Forest Mountain Dr","Forest Oaks Ln","Forest Park Ct","Forest Park Dr",
            "Forest Park Loop","Forest Park Rd","Forest Path Court","Forest Pky","Forest Pl","Forest Rd",
            "Forest Rd 119","Forest Rd 133","Forest Rd 20","Forest Rd 2141","Forest Rd 2410","Forest Rd 45",
            "Forest Rd 490","Forest Rd 494","Forest Rd 50","Forest Rd 55","Forest Rd 82","Forest Rd 87",
            "Forest Rd 94","Forest Ridge Ct","Forest Ridge Dr","Forest Ridge Ln","Forest Ridge Road",
            "Forest Rim Ln","Forest Road","Forest Road 106","Forest Road 1123","Forest Road 12","Forest Road 139",
            "Forest Road 1633","Forest Road 202","Forest Road 2142","Forest Road 2263","Forest Road 2357",
            "Forest Road 253","Forest Road 262","Forest Road 279","Forest Road 2809","Forest Road 316A",
            "Forest Road 39 N","Forest Road 3910","Forest Road 507","Forest Road 530","Forest Road 557",
            "Forest Road 6","Forest Road 63","Forest Road NW","Forest Route 09","Forest Route 10",
            "Forest Route 12N13","Forest Route 12N52","Forest Route 13N12","Forest Route 13N13",
            "Forest Route 13N26","Forest Route 13N34","Forest Route 13N42","Forest Route 13N44",
            "Forest Route 13S05","Forest Route 13S45","Forest Route 14S21","Forest Route 15N17",
            "Forest Route 15N36","Forest Route 16N01","Forest Route 16N02","Forest Route 16N20",
            "Forest Route 16N28","Forest Route 16N35","Forest Route 16N39","Forest Route 16N48",
            "Forest Route 17N04","Forest Route 17N07","Forest Route 17N08","Forest Route 17N10",
            "Forest Route 17N16","Forest Route 17N23","Forest Route 17N39","Forest Route 17N49",
            "Forest Route 18N07","Forest Route 18N17","Forest Route 18N30","Forest Route 19N13",
            "Forest Route 19N29","Forest Route 19N51","Forest Route 1N02","Forest Route 1N04","Forest Route 1N04Y",
            "Forest Route 1N08","Forest Route 1N14","Forest Route 1N35Y","Forest Route 1N84","Forest Route 1N97",
            "Forest Route 1S07","Forest Route 1S26","Forest Route 20N01","Forest Route 20N16","Forest Route 20N33",
            "Forest Route 21N32","Forest Route 21No8","Forest Route 21S06","Forest Route 21S50",
            "Forest Route 21S70","Forest Route 21S75","Forest Route 22N15","Forest Route 22S72A",
            "Forest Route 24N01","Forest Route 24N02","Forest Route 24N16","Forest Route 24N19",
            "Forest Route 24N20","Forest Route 24N32","Forest Route 24N41E","Forest Route 24N55",
            "Forest Route 24N62","Forest Route 25N01","Forest Route 25N23","Forest Route 25N36",
            "Forest Route 25S02","Forest Route 25S04","Forest Route 25S15","Forest Route 26","Forest Route 26N01",
            "Forest Route 27S11","Forest Route 28S07","Forest Route 28S27A","Forest Route 28S27B",
            "Forest Route 28S40","Forest Route 29N10","Forest Route 29S02","Forest Route 29S04",
            "Forest Route 2N02","Forest Route 2N05","Forest Route 2N06","Forest Route 2N11","Forest Route 2S09",
            "Forest Route 2S17","Forest Route 2S25","Forest Route 2S37","Forest Route 2S62","Forest Route 2S64",
            "Forest Route 2S91","Forest Route 30","Forest Route 30N24","Forest Route 31N02","Forest Route 32N08",
            "Forest Route 32N14","Forest Route 33N12","Forest Route 33N19","Forest Route 37N02",
            "Forest Route 38N01","Forest Route 38N10","Forest Route 38N27","Forest Route 39N14",
            "Forest Route 39N28","Forest Route 3N03","Forest Route 3N13","Forest Route 3N18","Forest Route 3N21",
            "Forest Route 3N24Y","Forest Route 3N26","Forest Route 3N31","Forest Route 3N39","Forest Route 40N51",
            "Forest Route 40N57","Forest Route 40N61","Forest Route 41","Forest Route 41N86","Forest Route 42N17",
            "Forest Route 43N23","Forest Route 44N04","Forest Route 44N96","Forest Route 45N49",
            "Forest Route 46N10","Forest Route 46N60","Forest Route 46N64","Forest Route 47N03",
            "Forest Route 47N09","Forest Route 47N63","Forest Route 4N01","Forest Route 4N02","Forest Route 4N08",
            "Forest Route 4N09","Forest Route 4N10","Forest Route 4N11","Forest Route 4N33","Forest Route 4N51",
            "Forest Route 4N63","Forest Route 4S01","Forest Route 5N05","Forest Route 5N09","Forest Route 5N12",
            "Forest Route 5N21","Forest Route 5N22","Forest Route 5N25","Forest Route 5N28","Forest Route 5N31",
            "Forest Route 5N31C","Forest Route 5N38","Forest Route 5N41","Forest Route 5N52","Forest Route 5N65",
            "Forest Route 5N95","Forest Route 5S01","Forest Route 6N03","Forest Route 6N08","Forest Route 6N09",
            "Forest Route 6N12B","Forest Route 6N17","Forest Route 6N25","Forest Route 6N26","Forest Route 6N45",
            "Forest Route 6N65","Forest Route 6N70","Forest Route 6N80","Forest Route 7N02","Forest Route 7N05",
            "Forest Route 7N07","Forest Route 7N08","Forest Route 7N14","Forest Route 7N23","Forest Route 7N53",
            "Forest Route 7N664","Forest Route 8N24","Forest Route 93","Forest Route 9N01","Forest Route 9N11",
            "Forest Route M2","Forest Route M3","Forest Route M4","Forest Rt 14N42","Forest Rt 2N17",
            "Forest Rt 3N14","Forest Rt 3N44Y","Forest Rt 3N92","Forest Rt Gn25","Forest Rte 22S04",
            "Forest Rte 22S05","Forest Rte 23S15","Forest Run Rd","Forest Serv Rd 310","Forest Service",
            "Forest Service 253 Rd","Forest Service 6 Rd","Forest Service 705 Rd","Forest Service 927Ok Rd",
            "Forest Service Rd 25","Forest Service Rd 360","Forest Service Rd 6323","Forest Service Rd 8N11",
            "Forest Service Road","Forest Service Road 114","Forest Service Road 1426","Forest Service Road 2",
            "Forest Service Road 31","Forest Service Road 317 H","Forest Service Road 917","Forest Service Trail 72",
            "Forest Servide Road 93712 A","Forest Springs Dr","Forest St","Forest Street","Forest Svc 187A Rd",
            "Forest Svc 4408","Forest Svc 544 Rd","Forest Svc Rd 194","Forest Trail Place","Forest Trl",
            "Forest View Ave","Forest View Dr","Forest View Ln","Forest Way Dr SE","Foresta Rd","Forestal Dr",
            "Forestbrook Ct","Forestbrook Drive","Forestdale Ave","Forestdale Rd","Forestdale Road",
            "Forester Ave","Forester Crescent","Forester Cv","Forester' Road","Foresthill Ave","Foresthill Bridge",
            "Foresthill Rd","Forestry Drive","Forestry Rd","Forestry Rd 220","Forestry Rd 646A","Forestry Rd 901A",
            "Forestry Rd 94","Forestry Rd 9953","Forestry Road 9004","Forestry Road 9403","Forestry Road 9510",
            "Forestry Road 9959","Forestry Road 9968","Forestview Dr","Forestview Drive","Forestville Rd",
            "Forestwood Dr","Forestwood Drive","Forestwood Street","Forfar Cir","Forfar Ln","Forge Ct",
            "Forge Pl","Forgotton Pl NW","Fork Indian Creek Rd","Fork Rd","Forkey Avenue","Forks Rd",
            "Forks Road","Forman Ave","Forman Ct","Forman Rd","Fornelius Ave","Forney Dr","Forni Ct","Forni Dr",
            "Forres Ln","Forrest Ave","Forrest Avenue","Forrest Cir","Forrest Ct","Forrest Dr","Forrest Hill Dr",
            "Forrest Hill St","Forrest Ln","Forrest Road","Forrest Service Road 94378A","Forrest St",
            "Forrest Street","Forrestal Dr","Forrester Rd","Forrester St SE","Forrester Street","Forrett Dr",
            "Forsgate Dr","Forster Avenue","Forster St","Forsyth Rd N","Forsyth Road","Forsyth Street",
            "Forsythe St","Forsythia Ave NW","Forsythia Drive","Forsythia Ln","Fort","Fort Avenue","Fort Avenue Terrace",
            "Fort Bragg-Sherwood Rd","Fort Bragg-Willits Rd","Fort Davis St","Fort Dearborn Drive",
            "Fort Dix Rd","Fort Drum","Fort Duquesne Dr","Fort Getty Rd","Fort Griswold Ln","Fort Hamilton Parkway",
            "Fort Hamilton Pky","Fort Hill Park","Fort Kente Road","Fort Lake Rd","Fort Lee Rd","Fort Loop Rd",
            "Fort Meyers Ct","Fort Mifflin Rd","Fort Plains Rd","Fort Point Rd","Fort Ross Way","Fort St",
            "Fort Street","Fort Toulouse Rd","Fort Tryon Place","Fort Worth Pl","Fort York Boulevard",
            "Fortecon Drive","Fortescue Rd","Forth St","Forthbridge Crescent","Fortin Avenue","Fortine Rd",
            "Fortney","Fortney Dr","Fortrose Crescent","Forts Lake Rd E","Fortuna","Fortuna Ave","Fortuna St",
            "Fortune Ave","Fortune Blvd","Fortune Gate","Fortune Lane","Fortune St","Forty First Street",
            "Forty Third Street","Fortyfifth Infantry Division Dr","Forum Dr","Forward Dr","Forward Pass Ct",
            "Forward Rd","Fosdick Street","Foshee Rd","Foss Ave","Fossa Tpke","Fossil Bed Rd","Fossil Creek Ct",
            "Fossil Creek Rd","Fossil Hill Road","Foster Ave","Foster Avenue","Foster Bay Lane","Foster Drive",
            "Foster Hill Rd","Foster Hill Road","Foster Ln","Foster Park","Foster Rd","Foster Road","Foster Sideroad",
            "Foster St","Foster Street","Foster Wheeler","Fosters Loop Rd","Fostertown Ln","Fostoria Ct",
            "Fostoria Rd NE","Fottler Road","Foul Rift Rd","Foulk Road","Foulks Ave","Foulkstone Rd",
            "Foundation Ct","Founders Bl","Founders Bridge","Founders Hill Rd","Founders Road","Founders Walk",
            "Foundry Ave","Foundry Avenue","Foundry Ln","Foundry Pl","Foundry St","Fountain Ave","Fountain Dr",
            "Fountain Green Dr","Fountain Park Avenue","Fountain Park Ln","Fountain Rd","Fountain St",
            "Fountain Street","Fountain Way E","Fountainhead Dr","Fountainview Way","Fountayne Ct",
            "Four Bridges Road","Four Corners Dr","Four Corners Rd","Four Hills Ct SE","Four Mile Run",
            "Four Oaks Gate","Four Oaks Rd","Four Seasons Ln","Four Seasons Trl","Four Springs Trl",
            "Four Wheel Drive Rd","Four Winds Way","Fouracre Way","Fouratt Ave","Fourseasons Drive",
            "Fourteent Line","Fourth Avenue","Fourth Li Road N","Fourth Line E","Fourth Street","Fourthgreen Place",
            "Foust St","Fouts Spring Rd","Fowler Ave","Fowler Court","Fowler Lane","Fowler Ln","Fowler River Rd",
            "Fowler St","Fowler Street","Fowler Way","Fowlers Lane","Fownes Ct","Fox","Fox Ave","Fox Bluff Dr",
            "Fox Blvd","Fox Briar Cv","Fox Chase Ct","Fox Chase Dr","Fox Cir","Fox Creek N","Fox Creek Road",
            "Fox Crescent","Fox Croft Dr","Fox Ct","Fox Ct E","Fox Den Rd","Fox Dr","Fox Fire Cv","Fox Glenn Lair",
            "Fox Glove Cir","Fox Glove Ct","Fox Hill Dr","Fox Hill Lane","Fox Hill Ln","Fox Hill Rd",
            "Fox Hollow","Fox Hollow Dr","Fox Hollow Ln","Fox Hollow Rd","Fox Hollow Springs Cir",
            "Fox Hollow Way","Fox Hound Chase E","Fox Hunt Lane","Fox Ln","Fox Meadow Cv","Fox Meadow Rd",
            "Fox Mountain Rd","Fox Pl","Fox Rd","Fox Ridge Cir","Fox Ridge Ct SW","Fox Ridge Ln","Fox Ridge Rd",
            "Fox River Ave","Fox River Crossing","Fox River Way","Fox Road","Fox Run","Fox Run Ct","Fox Run Cv",
            "Fox Run Dr","Fox Run Lane","Fox Run Ln","Fox Run Rd","Fox Spring Dr","Fox St","Fox Tail Ct",
            "Fox Tail Trl","Fox Trce","Fox's Bottom Rd","Fox's Mill Rd","Foxberry Dr","Foxboro Road",
            "Foxborough Ct","Foxbury Dr SW","Foxchase Ln","Foxcroft Boulevard","Foxcroft Ct","Foxcroft Dr",
            "Foxcroft Rd","Foxe Harrow Dr","Foxen Canyon Rd","Foxfire Ln","Foxglove Ln","Foxglove View",
            "Foxglove Way","Foxgrove Dr","Foxgrove Pl","Foxhill Dr NW","Foxhurst Way","Foxmead Road",
            "Foxmeadow Lane","Foxmoor Cir","Foxridge","Foxridge Ct","Foxridge Drive","Foxrun Ln","Foxshire Ln",
            "Foxtail Dr","Foxtail Ln","Foxton Ct","Foxtrotter Ln","Foxvale Ave","Foxvale St NE","Foxwood Dr",
            "Foxwood Grove","Foxwood Ln","Foxwood Pl","Foxwood Sq S","Foxwood Trail","Foye Ave","Foyer St",
            "Fr 1230","Fr 183","Fr 2","Fr 2300","Fr 320","Fr 321","Fr 331","Fr 419 A","Fr 68","Fr 87","Fr 91A","Fr Ln 28",
            "Fr Ln 287","Fr324","Fr92","Frachiseur Rd","Fragrant Spruce Ave","Fraley St","Frame Rd","Framingham Road",
            "Fran Morgan Dr","Franca Crescent","France Ave","France Street","Franceen Ln","Frances","Frances Ave",
            "Frances Dr","Frances Ln","Frances St","Frances Street","Frances Street N","Frances Street S",
            "Francesca Ln","Franceschi Rd","Francestown Rd","Francine Court","Francine Ct","Francis Ave",
            "Francis Ct","Francis Dr","Francis Dr E","Francis Lee Building","Francis Ln","Francis Rd",
            "Francis Scott Way","Francis Springs Rd","Francis St","Francis Street","Francis Ter","Francis Way",
            "Franciscan St NE","Franciscan Way","Francisco Ave","Francisco Ct","Francisco Dr","Francisco Ln",
            "Francisco Pl","Francisquito Ave","Franco Western Rd","Franconia","Franconia Ridge Trail",
            "Francoso","Frandosa Ln","Frank Ave","Frank Clark Rd","Frank Ct","Frank Dr","Frank Foy Rd","Frank Hil Road",
            "Frank Kenison Rd","Frank Maes Ave","Frank McCue Ln","Frank Schnopps Road","Frank Scott Ln",
            "Frank Sinatra Dr","Frank St","Frank Street","Frank Williams Rd","Frank Williams Road",
            "Frank's Xing","Franka Pl","Frankdale Avenue","Frankford Ave","Frankford Road","Frankfort Ave",
            "Frankfort Ct","Frankfurt","Frankie Ln","Frankiln Street","Frankish Avenue","Frankland Road",
            "Franklin Ave","Franklin Ave S","Franklin Avenue","Franklin Blvd","Franklin Canyon Rd",
            "Franklin Ct","Franklin Desert","Franklin Dr","Franklin Drive","Franklin Farm Rd","Franklin Ferry Rd",
            "Franklin Hill Rd","Franklin Hill Road","Franklin Mt Cr Rd","Franklin Pky","Franklin Pl",
            "Franklin Place","Franklin Rd","Franklin Road","Franklin School Rd","Franklin Square Apartments Rd",
            "Franklin St","Franklin Street","Franklin Ter","Franklin Way","Franklyn Pl","Franks Ave",
            "Franks Cir","Franks Rd","Frankton Road","Franmor Drive","Franrivers Ave","Franskevicz Rd",
            "Franti Rd","Franz Lane","Franzen Hills Ct NE","Franzen Rd SW","Frary Rd","Frasco Ave","Fraser Court",
            "Fraser Ct","Fraser Drive","Fraser Rd","Fraser Road","Fraser St","Frayne Ln","Frazee Ave","Frazee Ridge Rd",
            "Frazer Pl","Frazer Street","Frazier St","Frear Rd","Freckles Ct","Fred Eller Dr","Fred Hessinger Rd",
            "Fred Macmurray Ln","Fred Meijer Heartland Trail","Fred Nichols Rd","Fred Pl","Fred St",
            "Fred Street","Fred Varley Drive","Freda Ave","Freda Ln","Fredela Ln","Frederick Avenue",
            "Frederick Ct","Frederick Dr","Frederick E Everett Tpke","Frederick Pl NW","Frederick Rd",
            "Frederick St","Frederick Street","Frederick Ter","Fredericka St","Fredericks Ranch Rd",
            "Fredericks Rd","Fredericksburg Way","Fredericton Road","Fredonia Central Schools Rd",
            "Fredonia Ct","Fredonia Milltown Rd","Fredric Ferry Rd","Fredrick Dr","Fredrick Pl","Fredricksburg Pl",
            "Fredricksburg Rd","Fredrico Dr","Free Ave","Free Rd","Free Union Rd","Freeborn St","Freed Rd",
            "Freedly St","Freedom Ct","Freedom Dr","Freedom Fields","Freedom Ln","Freedom Rd","Freedom Way",
            "Freeferry Cir","Freehold Rd","Freehold St","Freehold-Englishtown Rd","Freel-Peak Ave",
            "Freeland Ave","Freeland Avenue","Freeland Dr","Freeland Road","Freeman Ave","Freeman Ct",
            "Freeman Hollow Rd","Freeman Pl","Freeman Place","Freeman Road","Freeman St","Freeman Street",
            "Freemantle St","Freemont Ave","Freemont Ct","Freemont St","Freemount Fuel Break","Freeport Ln",
            "Freeport Rd","Freesia Ct","Freesia Dr","Freestone Rd","Freethy Blvd; Elmar Ct","Freeway Dr",
            "Freeway Ln","Freeway Rd","Freewill Dr","Freeze Mountain Dr","Frei Ranch Rd","Freiday Ln",
            "Freight Building Rd","Freiot Ave","Frejon Ln","Frelimo Ct","Frelinghuysen Ave","Frelinghuysen Rd",
            "Fremont Ave","Fremont Avenue","Fremont Ct","Fremont Dr","Fremont Rd","Fremont Road","Fremont St",
            "Fremont St Offramp","Fremont Street","Fremont Way","French Ave","French Avenue","French Creek Dr",
            "French Creek Mina Rd","French Hill Rd","French Ln","French Rd","French St","French Street",
            "Frenchs Park Rd","Freneau Rd","Fresca Ln","Fresco Ct","Fresh Ponds Rd","Freshspring Drive",
            "Freshwater Ct","Freshwater Drive","Freshway Drive","Fresno Cir","Fresno Coalinga Road",
            "Fresno Ct","Fresno Rd","Fresno St","Friar Ave","Friar Brook Dr","Friar Ln","Friarsheel Ln",
            "Friartuck Cir","Frias Court","Frichot Avenue","Fricot City Rd","Fried St","Friedens Church Rd",
            "Friederich Park","Friedham Rd","Friedman St","Friedrich Rd","Friedrichsen Ln","Friend St",
            "Friendly Dr","Friendly Ln","Friends St","Friendship Ct","Friendship Dr","Friendship Ln",
            "Friendship Rd","Friendsville Rd","Frienza Ave","Frier Ln","Fries Mill Rd","Fries Rd","Friesen Boulevard",
            "Friesen Place","Friis Camp Rd","Fringetree Ct","Frisbee Hill Rd","Frisbie Ln","Frisbie Rd",
            "Frisbie St","Frisby Court","Frisby Rd","Frith Rd","Frith Road","Fritsch Ave","Fritz Aly","Fritz Ln",
            "Fritz Pl","Fritz St","Frobish Rd","Frobisher Street","Frog Aly","Frog Hollow Rd","Frog Pond Rd",
            "Frolick Crescent","Froma St","Fronsee Rd","Front Ave","Front Ct","Front Drive","Front Road",
            "Front St","Front St SW","Front Street","Front Street East","Front Street S","Front Street W",
            "Front Street West","Frontage Rd","Frontage Rd SE","Frontage Road","Frontenac Avenue",
            "Frontenac Blvd","Fronterra Way","Frontier Ave","Frontier Avenue","Frontier Cir","Frontier Ct",
            "Frontier Dr","Frontier Lane","Frontier Rd","Frontier St","Frontier Trl","Frontier Way","Frook Ct",
            "Frosh Dr","Frost Ave","Frost Circle","Frost Court","Frost Dr","Frost Drive","Frost Hill Pl",
            "Frost Hill Rd","Frost Lane","Frost Ln","Frost Pl","Frost Pocket Trl","Frost Pond Rd","Frost Rd",
            "Frost St","Frost Street","Frost Trail","Frost Way","Frosty Way","Frudden Rd","Fruit Place",
            "Fruit St","Fruit Street","Fruita Ln","Fruitland Road","Fruitvale Ave","Fry Pond Rd","Fryc Street",
            "Frye Rd","Frymire Rd","Frys Valley Rd","Fs 1005 Rd","Fs 1424 Rd","Fs 1471 Rd","Fs 1525 Rd",
            "Fs 1525A Rd","Fs 3138","Fs 42 Rd","Fs 5142 Rd","Fs 6969","Fs 6986","Fs 81","Fs 9128W","Fs 92730A Rd",
            "Fs 94355A Rd","Fs 976E","Fs Rd","Fs Road 69","Fs496","Ft McRae Rd","Fuchlow Dr","Fuchsia Ct","Fuego Ct",
            "Fuel Break Rd","Fuente","Fuentes Rd","Fugere St","Fuji St","Fulford St","Fulham Ct","Fulham Drive",
            "Fulkerson Rd","Fulkerth Rd","Fuller","Fuller Ave","Fuller Avenue","Fuller Crescent","Fuller Ct",
            "Fuller Hill Rd","Fuller Ln","Fuller Pl","Fuller Place","Fuller Rd","Fuller Road","Fuller St",
            "Fuller Way","Fullerbrook Road","Fulmer Ave","Fulmer Lane Dr","Fulmer Rd","Fulmer St","Fulop St",
            "Fulper Rd","Fulstone Pl","Fulstow Ct","Fulton","Fulton Ave","Fulton Avenue","Fulton Creek",
            "Fulton Ct","Fulton House Way Spur","Fulton Mall","Fulton Pl","Fulton Rd","Fulton St","Fulton Street",
            "Fumadera Ln","Fund Raising","Funderburg St","Fundy Bay Boulevard","Fundy Ct","Funk Hollow Rd",
            "Funston St","Fuqua Ave","Fuqua Rd","Fur Farms Rd","Furber St","Furey Rd","Furlong Ave","Furlong Dr",
            "Furman Ave","Furman Dr","Furman Pl","Furman St","Furnace Creek Ave","Furnace Creek Dr","Furnace Creek Wash Rd",
            "Furnace Dock Rd","Furnace Pond Way","Furnace Rd","Furnace St","Furnace Street","Furness Pky",
            "Furniss Crescent","Furnival Road","Futura Dr","Futura Way","Future Karl Dr","Futures Way",
            "Futurity Pl","Fycke Ln","Fyke Road","Fyler Rd","Fyler Road","G","G 08 Rd","G Aly","G E Weldon Rd",
            "G H Dr","G P Rd","G Rd","G Road","G St","G St S","G Street","G Walk","G-003","G-007","G-029","G-032","G-4","G-O Rd",
            "G3 Rd","G4 Rd","G5 Rd","GSP Express Lane","Gabby Ln","Gabe Rd","Gaber Dr","Gable Blvd","Gable Dr",
            "Gable Rd","Gable's Way","Gablewing Cir","Gabriel","Gabriel Creek Rd","Gabriel Dr","Gabriel Way",
            "Gabriele Ct","Gabrieleno NRT 11W14; GabrilienoTrail","Gabrielino NRT","Gabriella Ave",
            "Gaddis Cir","Gaddis Pit Rd","Gadek Pl","Gadianton Ave","Gadsby Avenue","Gadsen Pl","Gadsen St",
            "Gadwall Way","Gae St","Gaewood Ct","Gage","Gage Ct","Gage Dr","Gage Rd","Gage St","Gage Street","Gageview Court",
            "Gaggos St","Gagnier Camp Trl","Gagnon Rd","Gail Ave","Gail Ct","Gail Dr","Gail Pl","Gail Rd","Gail Street",
            "Gail Way","Gailes Ct","Gailwood Court","Gain Court","Gainer Rd","Gainer Road","Gaines Aly",
            "Gaines Ave","Gaines Rd","Gaines St","Gaines Way","Gainesborough Ct","Gainesborough Ter",
            "Gainsboro Rd","Gainsborough Avenue","Gairloch Cir","Gaiser Ct","Gaisler Rd","Gala Avenue",
            "Gala Ln","Galahad Ave","Galahad Way","Galassi Ct","Galatea St","Galatina St","Galaxy Court",
            "Galaxy Ct","Galaxy Dr","Galbraith Court","Galbraith Drive","Galbraith Rd","Gale","Gale Ave",
            "Gale Crescent","Gale Meadow Way","Gale Rd","Gale Road","Gale Street","Gale Way","Galen Dr",
            "Galena Crescent","Galena Ct","Galena St","Gales Court","Galewood Ct","Galey St","Gallagher Ave",
            "Gallant Avenue","Gallant Dr","Gallant Drive","Gallatin Pl","Gallatin Rd","Gallegos Park",
            "Gallegos Rd","Gallery Hill","Galley Ave NW","Galley Avenue","Gallina Rd","Gallipoli Pl",
            "Gallito St","Gallo Dr","Gallo Rd","Galloping Hill Rd","Galloway Drive","Galloway Rd","Galloway Road",
            "Galloway Trl","Gallup Pl SW","Gallview Lane","Galva Ave","Galvin Ave","Galway Cir NW","Galway Court",
            "Galway Crescent","Galway Pl","Galway Rd NE","Galway St NW","Gamache Ln","Gambassi Ct","Gambels Way",
            "Gambichler Rd","Gambin Hill","Gamble Ave","Gamble Avenue","Gamble Street","Gamboa Ln","Gamboge St",
            "Gambrel Dr","Game Club Rd","Game Dept Rd","Gamebird Rd","Gammage Rd","Gammon Rd","Gammons Road",
            "Gamsby Rd","Ganado Way","Ganaraska Road","Gandy Ln","Gandy Loop","Gandy Rd","Ganesha St","Ganges Ln",
            "Gann Rd","Gannet Dr","Gannet Pl","Gannet Road","Gannet Way","Gannett Pasture Lane","Gannett Rd",
            "Gannett Street","Gannon Rd","Gano Rd","Gansberg Ct","Gansvoort St","Gantley Road","Ganttown Rd",
            "Gaona St","Gap Mountain Rd","Gap View Dr","Gapview Ave","Gapview Ln","Garabaldi Pl","Garabedian Drive",
            "Garage Road","Garamound Ave","Garamound Court","Garbage Pit Rd","Garber Ave","Garber Dr",
            "Garber Hill Rd","Garber Sq","Garcia Aly","Garcia Ave","Garcia Ct","Garcia Dr","Garcia Ln","Garcia Rd",
            "Garcia St","Garcia St NE","Gard Ave","Gardapee Rd","Garden Aly","Garden Ave","Garden Avenue",
            "Garden Cir","Garden City Dr","Garden City Ln","Garden City Skyway","Garden Ct","Garden Ct S",
            "Garden Dr","Garden Drive","Garden Gate Pl","Garden Gate Terrace","Garden Gateway Way",
            "Garden Grove Ave","Garden Grove Freeway","Garden Gulch Cir","Garden Hill Dr","Garden Home Dr",
            "Garden Lane","Garden Ln","Garden Oval","Garden Party Ln","Garden Pl","Garden Rd","Garden Road",
            "Garden St","Garden State Parkway","Garden State Pkwy","Garden State Pky","Garden Street",
            "Garden Ter","Garden Way","Garden of Eden Road","Gardena Rd","Gardenbrook Dr","Gardendale Ln",
            "Gardenia Ave","Gardenia Blossom St","Gardenia Cir","Gardenia Ct","Gardenia Dr","Gardenia Ln",
            "Gardenia Pvt Dr","Gardenia St","Gardenia Way","Gardens Ave","Gardenside Ln","Gardenvale Road",
            "Gardenville Rd","Gardenwall Dr","Gardenwood Ln","Gardiner Drive","Gardiner Expressway",
            "Gardiner Expressway - Toronto","Gardiner Expressway East","Gardiner Expressway West",
            "Gardiner Park","Gardiner Pl","Gardiner Street","Gardiner Trl","Gardiners Road","Gardner Ave",
            "Gardner Avenue","Gardner Barclay Rd","Gardner Ct","Gardner Drive","Gardner Lake Hts",
            "Gardner Ln","Gardner Road","Gardner St","Gardner St NW","Gardon St","Garduno Dr NW","Gareau Avenue",
            "Garfella Drive","Garfield","Garfield Ave","Garfield Ave NW","Garfield Ave SW","Garfield Avee White Fir Way Aly",
            "Garfield Avenue","Garfield Canal","Garfield Close","Garfield Ct","Garfield Ct NW","Garfield Dr",
            "Garfield Flat Rd","Garfield Ln","Garfield Pl","Garfield Rd","Garfield St","Garfield Street",
            "Garfield Ter","Gargoyle Rd","Garibadi Pl","Garibaldi St","Garin Pky","Garin Rd","Garland Ave",
            "Garland Ct","Garland Dr","Garland St","Garland Ter S","Garland Way","Garlet Ct","Garmisch Pl",
            "Garner Ave","Garner Bradford Ln","Garner Rd","Garnerville Ter","Garnet Ave","Garnet Creek Ln",
            "Garnet Ct","Garnet Dr","Garnet Ln","Garnet Mine Trl","Garnet Pl","Garnet Rd","Garnet Street",
            "Garnet Valley Entrance Dr","Garnet Way","Garnett Drive","Garnock","Garnock Avenue","Garrard Road",
            "Garreton Road","Garretson Ave","Garrett Ave","Garrett Ct","Garrett Dr","Garrett Drive","Garrett Ln",
            "Garrett Street","Garrety Ln","Garrick St","Garringer Road","Garrison","Garrison Avenue",
            "Garrison Dr","Garrison Pl","Garrison St","Garrison Ter","Garrod Rd","Garry Rd","Garryana Dr",
            "Garryann Ter","Garrybrook Drive","Garside Ct","Garth","Garth Ave","Garth Rd","Garth St","Garthwood Road",
            "Gartner Rd","Garvey Ave","Garwood Ct","Garwood Dr","Garwood Ln","Garwood Pl","Gary","Gary Ave",
            "Gary Ave NE","Gary Ct","Gary Dr","Gary Ln","Gary Pl","Gary Rd","Gary Road","Gary St","Gary Way","Gas Lamp Lane",
            "Gas Pipeline Rd","Gas Point Rd","Gas Rd","Gas Well Rd","Gascanade Dr NE","Gaskell Hill Rd",
            "Gaskell Rd","Gaskill Ave","Gaskill Circle","Gaskin Ln","Gaslight Cir","Gaslight Dr","Gaslight Ln",
            "Gastineau Country Ln","Gaston Ln","Gatchell Ave","Gate 8 Rd","Gate Four","Gate House Ln",
            "Gate Moss Oval","Gate Nine Co","Gate Post Ln","Gate Way","Gately Drive","Gatenby Gate","Gates Ave",
            "Gates Ct","Gates Ln","Gates Mills Estates Dr","Gates Rd","Gates St","Gatesborough Ct","Gateshead Dr",
            "Gateway","Gateway Ave","Gateway Blvd","Gateway Blvd E","Gateway Blvd S","Gateway Blvd W",
            "Gateway Cir","Gateway Ct","Gateway Dr","Gateway Ln","Gateway Natl Rec Area","Gateway Rd",
            "Gateway Rd E","Gatewood Crescent","Gatewood Dr","Gatewood Ln","Gatfield Avenue","Gath Ter",
            "Gatzmer Ave","Gaucho Ct","Gaucks Ln","Gaudaur Court","Gaudenzio St","Gauguin Avenue","Gaul St",
            "Gault St","Gaumer Ave","Gauntlett Rd","Gauss Rd","Gauthier Road","Gaventa St","Gavilan Ct",
            "Gavin Court","Gavin Lake Rd NE","Gavin Stone Ave","Gaviota Ave","Gawaine Ln","Gawthorne Ave",
            "Gay Ave","Gay Boy Ct","Gay Ln","Gay Rd","Gay St","Gay Street","Gayboy Ct","Gayhart Rd","Gaylan Dr",
            "Gayle Cir","Gayle Court","Gayle Dr","Gayle Pl SW","Gayle St","Gaylord Avenue","Gaylord Dr",
            "Gaylord Drive","Gaylord Ln","Gaylord St","Gaylord Street","Gaylord Ter","Gaynier Ct","Gaynor Rd",
            "Gaywood Dr","Gaza Way","Gaze","Gazebo Ct","Gazelle Callahan Rd","Gazelle Dr","Gazos Creek Rd",
            "Gazza Rd","Geary Cir","Geary Rd","Gebhart Pl","Geddes Rd","Gedney Court","Gedney St","Gedney Way",
            "Geeck Rd","Geer Rd","Geeslin Dr","Geeson Rd","Gehrig Ave","Gehring Rd","Geigel Hill Rd","Geil St",
            "Geise Ct","Geise Rd","Geisendorfer Rd","Geisser Ln","Gel Ct","Gelder Dr","Gelding Ln","Geldner Ave",
            "Gelert Road","Gelly Dr","Gem Ave","Gem Cir","Gem Place","Gemini Crescent","Gemini Ct","Gemini Dr",
            "Gemstone Ct","Gen Franz Sigel Dr","Gen Hope Rd","Gena Maria Ct","Genard Ct","Gendreau Street",
            "Gendron St","Gene Ln","Geneil Ct","General Bradley St NE","General Edwards Highway","General Hitchcock Hwy",
            "General Lafayette Rd","General Motors Dr","General Patch St NE","General Petroleum Rd",
            "General Plz","General Stark Rd","General Vandenburg St","Generals Way","Generation Boulevard",
            "Genesee Ave","Genesee Rd","Genesee St","Genesee Street","Genesee Valley Greenway","Genesee Valley Park",
            "Genesee Valley Regional Market","Genesis Way","Geneso St","Genet St","Geneva Ave","Geneva Avenue",
            "Geneva Ct","Geneva Heights","Geneva Hwy","Geneva Rd","Geneva St","Geneva Street","Geneve St",
            "Genevieve Ave","Genevieve Ln","Genial Ct","Genie","Genista Ave","Gennaro Pl","Gennela Square",
            "Genni Pl","Genno Drive","Genoa Ave","Genoa Dr","Genoa Dr NE","Genoa Rd","Genoa Road","Genoa St",
            "Genoa Way","Genovese Ln","Gensen Dr SW","Gentile Ct","Gentle Ben Rd","Gentle Sky Ct","Gentry",
            "Gentry Ave","Gentry Dr","Gentry Rd","Gentry St","Gentry Way","Gents Road","Gentwood Dr","George Archer Dr",
            "George Ave","George Crumb Rd","George Ct","George Dieter Dr","George Dr","George Dunfee Rd",
            "George F Highway","George Hannum Street","George Holdridge Ln","George Jackson Dr",
            "George K Dr","George McKenzie Court","George Newell Rd","George Parks Hwy","George R. Visconti Road",
            "George Rd","George St","George Street","George Street S","George Washington Bridge (lower level)",
            "George Way","George Yeager Rd","George's Landing","Georgeanna Dr","Georgeanna St","Georgellen Ave",
            "Georgene Dr NE","Georges Rd","Georgetown Ave","Georgetown Condos","Georgetown Ct","Georgetown Dr",
            "Georgetown Franklin Tpke","Georgetown Loop","Georgetown Rd","Georgetown Road","Georgetown St",
            "Georgetown St NE","Georgetowne Dr","Georgewell","Georgi Cir","Georgia Aly NW","Georgia Ave",
            "Georgia Ct","Georgia Ln","Georgia Okeefe Way","Georgia Rd","Georgia Slide Rd","Georgia St",
            "Georgia St NW","Georgia Street","Georgian Ct","Georgian Rd","Georgian Ter","Georgiana Street",
            "Georgina Ave","Georgina Gate","Georgina Street","Georjean Dr","Geppetto Ln","Geraghty Terrace",
            "Gerald","Gerald Ave","Gerald Court","Gerald Ct","Gerald Pl","Gerald R Ford Fwy","Gerald R Ford Fwy SW",
            "Gerald Road","Gerald St","Geraldine Rd","Geraldine St","Geranium Court","Geranium Ct","Geranium Ln",
            "Geranium St NE","Gerard Ave","Gerard Ct","Gerard Dr","Gerard Street","Geraud Ave","Geren St",
            "Gerlich St","Germain Avenue","Germain Rd","Germaine Dr","German Mills Park","German Mills Road",
            "German Rd","German St","Germania Ct","Germanna Court","Germantown Ave","Germantown Rd","Germany Rd",
            "Germonds Village","Germone Rd","Geronimo Ct","Geronimo Trl","Gerrard Street East","Gerrish Ct",
            "Gerritsen Avenue","Gerry Fitzgerald Drive","Gerry Street","Gershwin Street","Gershwin Way",
            "Gersoni Road","Gertrude Dr","Gertrude Place","Gertz Ave","Gervic St","Gesner Ave","Gessner Dr",
            "Gessner Rd","Gessner Ter","Gettysburg Ave","Gettysburg Rd","Gettysburg St","Getz Ave","Geyser Ct",
            "Ghent Street","Ghirlanda Ct","Ghost Pony Rd","Giant Rock Rd","Giaramita St","Gibb St","Gibbon Dr",
            "Gibbon Drive","Gibbons Rd","Gibbs Ave","Gibbs Ave NE","Gibbs Dr","Gibbs Rd","Gibbs Road Spur",
            "Gibbs St","Gibney Crescent","Gibraltar Rd","Gibson Blvd","Gibson Ln","Gibson Pl","Gibson Place",
            "Gibson Rd","Gibson St","Gibson Street","Gibson Swamp Rd","Gibson Way","Giddings Street",
            "Giegerich Ave","Gielow Ln","Giem Rd","Gifford Ave","Gifford Ave We","Gifford Ct","Gifford Dr",
            "Gifford Drive","Gifford Hill Rd","Gifford Rd","Gifford Street","Giffords Glen","Giga Ct",
            "Gigante Ter","Gigi Ct","Giguere Road","Gihon Spring Drive","Gil Peterson Dr","Gila","Gila Mesa Rd",
            "Gila Valley Rd","Gilbert Ct NW","Gilbert Dr","Gilbert Ln","Gilbert Pl","Gilbert Road","Gilbert St",
            "Gilbert St N","Gilbert St S","Gilbert Street","Gilbreath Dr","Gilchrest Rd","Gilchrist Street",
            "Gilcreast Rd","Gildas Rd","Gilday Ave","Gilday Dr","Gilded Sun Dr","Gile Street","Gilead Place",
            "Giles Ave","Giles St","Giles Way","Gilespie Street","Gilford Ave","Gilford Road","Gilgen Ave NE",
            "Gilgorm Road","Gilham St","Gill Avenue","Gill Dr","Gill Hill Rd","Gill Ln","Gill Rd","Gill St",
            "Gill Street","Gillam Spring Trl","Gillespie Rd","Gillete Rd","Gillette Rd","Gillette Road",
            "Gillette St","Gilley Mill Rd","Gillian Drive","Gillies St","Gillingham Dr","Gillingham St",
            "Gillis Ave","Gillis Ln","Gillis Street","Gillman Creek Dr","Gilman Rd; Fenders Ferry Rd",
            "Gilmore Ave","Gilmore Beach Rd","Gilmore Dr","Gilmore Ln","Gilmore Rd","Gilmore Road","Gilmore St",
            "Gilmore Street","Gilmour Ct","Gilmour Street","Gilpin Avenue","Gilrix Ct","Gilrix St","Gilsizer Slough",
            "Gilson Ct","Gilson Ln","Gilson Rd","Gilson St","Gilstrap Ln","Gilsum Rd","Giltspur Drive","Gilwee Road",
            "Gimbert Ln","Gimelli Ct","Gin Rd","Gina Ct","Ginder Pl","Ginger Ct","Ginger Downs","Ginger Drive",
            "Ginger Hill Ct","Ginger Ln","Gingerbread Castle Rd","Gingerwood Ln","Gingham St","Gingko Ln",
            "Ginny Ave","Ginny Ln","Ginstar Ct","Ginther Dr","Ginwood Cv","Gionti Pl","Giorgano Ave","Giorno Ave",
            "Giotto Crescent","Giovanna Dr","Gipson Rd","Gipson St","Girard Ave","Girard Ave N","Girard Rd N",
            "Girard Ridge Rd","Girard Street","Girard Tower Dr","Girl Scout Dr","Girl Scout Ln","Giroux St",
            "Girth Way","Girtys Point","Girvan Ln","Gita Ct","Giusti Ct","Given Road","Givenchy Street",
            "Givernaud Ter","Glabe Ln","Glacier Cv","Glacier Dr","Glacier Grove Dr","Glacier Gulch Rd",
            "Glacier Hwy","Glacier Lodge Rd","Glacier Meadow Dr","Glacier Peak Ln","Glacier Rd","Glacier View Ave",
            "Glad Dr","Glad Park Avenue","Gladbrook Ct","Glade Ave","Glade Camp","Glade Ct","Gladean Ct",
            "Glades Rd","Gladiola Cir","Gladiola Ct","Gladney Ave","Gladsmore Crescent","Gladstone Avenue",
            "Gladstone Dr","Gladstone Forest Tr","Gladwin Ave","Gladwyne Ct","Gladwynne Ct","Gladys Burnham Ln",
            "Gladys Ct","Gladys Lane","Gladys St","Glamis Cir","Glamis Ln","Glamis Rd","Glamorgan Road",
            "Glann Rd W","Glardon Cir","Glascow Rd","Glaser Ln","Glasgow Dr","Glasgow Loop","Glasgow Rd",
            "Glasgow Rd NW","Glasgow Road","Glass Avenue","Glass Canyon Rd","Glass Drive","Glass Lantern Dr",
            "Glass Mountain Crossroad","Glass Rd","Glass St","Glass Ter","Glassboro Ave","Glassford Ct",
            "Glasson Way","Glasstown Rd","Glassy Pond Ave","Glastonbury Cir","Glastonbury Road","Glastonbury Thorn St",
            "Glavera Ave NE","Glazener","Glazer Rd NW","Gleason Avenue","Gleason Circle","Gleason Dr",
            "Gleason St","Glee Ln","Gleeton Rd","Glen","Glen Allen Road","Glen Arbor Rd","Glen Artney Rd",
            "Glen Ave","Glen Avenue","Glen Avenue West","Glen Brook Dr","Glen Burnie Rd","Glen Cameron Road",
            "Glen Camp Loop","Glen Cannon Trl","Glen Canyon Ct","Glen Canyon Rd","Glen Castle Drive",
            "Glen Castle Street","Glen Circle Dr","Glen Cove Rd","Glen Crescent","Glen Ct","Glen Cv",
            "Glen Dell","Glen Dhu Drive","Glen Dr","Glen Dr NE","Glen Drive","Glen Eagles Rd","Glen Edyth Drive",
            "Glen Elgin Drive","Glen Elle Drive","Glen Elm Avenue","Glen Forest Dr","Glen Gave Road",
            "Glen Haven Ct","Glen Hill Drive","Glen Hollow Dr","Glen Holly St","Glen Landing Ave",
            "Glen Ln","Glen Lomond Ln","Glen Long Avenue","Glen Martin Dr","Glen Miller Dr","Glen Miller Road",
            "Glen Morris Drive","Glen Nor Ave","Glen Oaks Ln","Glen Park Avenue","Glen Park Court",
            "Glen Park Ct","Glen Park Road","Glen Pl","Glen Rd","Glen Ridge Ct","Glen Ridge Dr","Glen Road",
            "Glen Ross Road","Glen Scarlett Road","Glen Smail Road","Glen St","Glen Stewart Avenue",
            "Glen Street","Glen Struan Dr","Glen Tay Road","Glen Ter","Glen Valley Road","Glen View Dr",
            "Glen View Rd","Glen Way","Glena St NE","Glenabbey Drive","Glenallan Street","Glenanna Road",
            "Glenarm Road","Glenavy Avenue","Glenayr Place","Glenayr Road","Glenbourne Ct","Glenbourne Park Drive",
            "Glenbrea Ct","Glenbrook Ave","Glenbrook Ct","Glenbrook Dr","Glenbrook Drive","Glenbrook Ln",
            "Glenbrook Pky","Glenbrook Rd","Glenbrook St","Glenburnie Ln","Glencairn Avenue","Glencairn Street",
            "Glencedar Crescent","Glencedar Road","Glencoe Ave","Glencoe Dr","Glencoe Heights Dr",
            "Glencreek Way","Glencrest Dr","Glencrest Ter","Glencroft Cir","Glendale Ave","Glendale Avenue",
            "Glendale Blvd","Glendale Cir","Glendale Dr","Glendale Freeway","Glendale Pl NE","Glendale Rd",
            "Glendale Road","Glendale St","Glendale Street","Glendarling Road","Glendell Terrace",
            "Glendennan Avenue","Glendhu Pl","Glendon Ct","Glendonwynne Road","Glendora Mountain Rd",
            "Glendora Pl","Glendower Circuit","Gleneagle Ct","Glenfield Crescent","Glenford Ave","Glengall Lane",
            "Glengate Road","Glengrove Avenue","Glengrove Avenue West","Glengrove Road","Glenham Street",
            "Glenhaven Cir","Glenholme Avenue","Glenifer St","Glenlake Avenue","Glenlea Dr","Glenloch Ave",
            "Glenmanor Pl","Glenmar Cir","Glenmar Rd","Glenmark Rd","Glenmere Ct","Glenmont Dr","Glenmoor Ct",
            "Glenmore Ave","Glenmore Crescent","Glenmore Drive","Glenmore St","Glenmore Terrace","Glenmount Avenue",
            "Glenn Ave","Glenn Avenue","Glenn Blvd","Glenn Cir","Glenn Ct","Glenn Dr","Glenn Dr NE","Glenn Oaks Ct",
            "Glenn Rd","Glenn St","Glennelm Road","Glenns Aly","Glennside Ave","Glenoak Ct","Glenoak Pl",
            "Glenora Drive","Glenorchy Road","Glenridge Rd","Glenridge Road","Glenrio St","Glenrose Avenue",
            "Glenshire Dr","Glenside Ave","Glenside Cir","Glenside Dr","Glenside Ln","Glenside Pl","Glenside Rd",
            "Glenside Trl","Glentana St","Glenthorne Drive","Glenthorpe Dr","Glenvale Boulevard","Glenview Ave",
            "Glenview Avenue","Glenview Cir","Glenview Ct","Glenview Dr","Glenview Drive","Glenview Ln",
            "Glenview Rd","Glenview Road","Glenview Street","Glenview Ter","Glenview Terrace","Glenway Avenue",
            "Glenwick Cir","Glenwood Ave","Glenwood Ave.","Glenwood Avenue","Glenwood Circle","Glenwood Crescent",
            "Glenwood Ct","Glenwood Dr","Glenwood Dr N","Glenwood Dr S","Glenwood Glade","Glenwood Pl",
            "Glenwood R 55/100 Rd","Glenwood Rd","Glenwood Road","Glenwood St","Glenwood Street","Glenwoods Avenue",
            "Glf Rd","Glide Path Rd","Glider St","Glider View Way","Gliding Hawk St","Glimmer Ln","Glisson Rd",
            "Glistening Rush St","Global Ct","Global Rd","Globe Mills Rd","Globe St","Gloria Avenue",
            "Gloria Ct","Gloria St","Gloria Street","Glorieta St","Glorney St","Glory Hole Ct","Glory Ln",
            "Glory Rd","Gloryland Ln","Glos Road","Gloucester Avenue","Gloucester Rd","Gloucester Road",
            "Gloucester St","Glover Ave","Glover Daniels Rd","Glover Dr","Glover Dr SW","Glover Ln","Glover Rd",
            "Glover St","Glover Street","Glovers Bend Rd","Glovers Ferry Rd","Glovers Rd","Glow Dr","Gloxinia Pl",
            "Gluckman Ave","Glyndon Ct","Glynis Falls Ct","Gniech Rd","Goa Way","Goad Rd","Goast Hill","Goat Hill Rd",
            "Goat Moth Hill","Goat Ranch Ctf","Goat Ropers Rd","Goat Trl","Goats Hill Rd","Gobbell Rd",
            "Gobbler Rd","Gobbler's Knob Rd","Gobblers Knob Rd","Gobi Ave","Gobi Ct","Gobin Way","Goble St",
            "Gochine Dr","Godboldt Ave","Goddard Avenue","Goddard Craft Ln","Goddard Ct","Goddard Dr",
            "Goddard Ln","Goddard Nisbet Rd","Goddard St SE","Goddard Street","Godfrey Dr","Godfrey Lane",
            "Godfrey Ranch Rd","Godfrey Rd","Godfroy Rd","Godinho Ave","Godley Ln","Godolphin Road","Godson Road",
            "Godstone Road","Godwin Ave","Godwin Terrace","Goebel St","Goemble Ave","Goerke St","Goethals Bridge",
            "Goethe Park Rd","Goethe Rd","Goettel Ct","Goetz Street","Goff Ave","Goff Rd","Goff St","Goffe Dr",
            "Goforth Dr","Gohman St","Golby Rd","Golconda","Gold Arrow Dr","Gold Ave","Gold Bar Rd","Gold Canyon Dr",
            "Gold Canyon Rd","Gold Canyon Trail","Gold Creek Rd","Gold Crest Ln","Gold Crown Rd","Gold Ct",
            "Gold Dr","Gold Dust Cir","Gold Dust Dr","Gold Dust St NE","Gold Fields Dr","Gold Finch Court",
            "Gold Gulch Rd","Gold Hill Ct","Gold Hill Rd","Gold Hill Way","Gold Lake Hwy","Gold Leaf Ln",
            "Gold Mine Rd","Gold Mountain Dr","Gold Mountain Rd","Gold Nugget Way","Gold Pan Ln","Gold Rd",
            "Gold Ridge Ln","Gold River Ct","Gold Rock Ct","Gold Run Rd","Gold Springs St","Gold St",
            "Gold Street","Gold Valley Rd","Goldbeaten Aly","Goldbrush St","Goldcrest St","Golden Ave",
            "Golden Avenue","Golden Bear","Golden Birch Pl","Golden Blvd","Golden Center Fwy","Golden Chestnut Pl",
            "Golden Crest Dr","Golden Ct","Golden Cypress Ave","Golden Dawn Ct","Golden Eagle Ct",
            "Golden Eagle Ter","Golden Gate Ave","Golden Gate Circle","Golden Gate Ct","Golden Gate Ln",
            "Golden Gate Rd","Golden Gate Trail","Golden Hoof Ln","Golden Ln","Golden Meadow Dr","Golden Meadow Rd",
            "Golden Moss Rd","Golden Oak Ct","Golden Oak Ln","Golden Pheasant Pky","Golden Pond Ave",
            "Golden Rain St","Golden Rd","Golden Reed Dr","Golden Ro Lane","Golden Rock Cir","Golden Run Road",
            "Golden Saddle St","Golden Sands Dr","Golden Shadow Ct","Golden Shore Dr","Golden Slipper Rd",
            "Golden Slopes Ct","Golden Springs Ave","Golden St","Golden Stair Way","Golden State Acc Rd",
            "Golden State Ave","Golden State Blvd","Golden State Front Rd","Golden Sunset Ct","Golden Treasure Trl",
            "Golden View","Golden Way","Golden Willows Ave","Golden Woods Ct","Golden-Hills","Goldenfield",
            "Goldenmil Road","Goldenridge Ct","Goldenridge Road","Goldenrod Ct","Goldenrod Dr","Goldenrod Ln",
            "Goldenrod Way","Goldenview Court","Goldeye Drive","Goldfield Dr","Goldfield St","Goldfinch Ct",
            "Goldfinch Rd","Goldhawk Trail","Goldhill Road","Goldhill Way","Goldie Drive","Goldie Road",
            "Golding Ln","Golding Rd","Goldman St","Goldmine Woods Ln","Goldpine Avenue","Goldridge Ave",
            "Goldrush Ct","Goldrush Dr","Goldsboro Ct","Goldsboro Dr","Goldseive Dr","Goldsmith Ave",
            "Goldsmith St","Goldsmith Street","Goldstein Road","Goldstone Cir","Goldstone Rd","Goldthorne Avenue",
            "Goldville Cut Off Rd","Goldville Rd","Goldweber Ave","Goldy Rd","Golf Cart Dr","Golf Cart Rd",
            "Golf Center Pky","Golf Club Ave","Golf Club Dr","Golf Club Rd","Golf Club Road","Golf Club Trl",
            "Golf Course Dr","Golf Course Rd","Golf Course Road","Golf Ct","Golf Dr","Golf Links Circle",
            "Golf Links Dr","Golf Ln","Golf Player Ave","Golf Rd","Golf St","Golf View Dr","Golf View Rd",
            "Golf Way","Golfdale Road","Golfhaven Drive","Golfview Cir","Golfview Ct","Golfview Dr","Golfview Dr NE",
            "Golfview Rd","Goliad Ct NW","Goliath Dr","Goll Ave","Goller Pl","Golondrina NW","Golondrina Ln",
            "Golson Rd","Gomer Hill Rd","Gonder Rd","Gondola Cir","Gondola Ln","Gonzales Court","Gonzales Ct",
            "Gonzales Dr","Gonzales Rd","Gonzalez Rd","Gonzalez Way","Gooch Rd","Good Hope Road","Good Intent Rd",
            "Good Luck Turn Pike","Good News Ln","Good News Way","Good Road","Goodbee St","Goode Street",
            "Gooderham Estate Boulevard","Goodfello Avenue","Goodfellow Road","Goodford Rd","Goodhart Ave",
            "Goodhart Crescent","Goodhue Street","Gooding Drive","Goodison Avenue","Goodlands St",
            "Goodleberg Rd","Goodman Ave","Goodman Ln","Goodman Ranch Rd","Goodman Rd","Goodman Rd W",
            "Goodman St","Goodman St S","Goodman Wash","Goodmote Dr NW","Goodnight Trl","Goodnow Rd",
            "Goodrich Ave","Goodrich Ave NE","Goodrich Hollow Road","Goodrich St","Goodrich Street",
            "Goodridge Street","Goods Road","Goodsell Ave","Goodson Rd","Goodwater Hwy","Goodway Dr",
            "Goodwill Rd","Goodwin Ct","Goodwin Pky","Goodwin Place","Goodwin Rd","Goodwin Rd No 1","Goodwin Road",
            "Goodwin Street","Goodwood Park Court","Goody Rd","Goodyear Crescent","Goodyear Rd","Goose Haven Rd",
            "Goose Lake Rd","Goose Lane","Goose Point Rd","Goose Pond Rd","Goose Pond Road","Goose Run",
            "Goose St","Goosebay Lane","Gooseberry Aly","Gooseberry Ln","Gooseneck Rd","Goosepond Rd",
            "Gopher Ct","Gorden Ln","Gorden Rd","Gordon","Gordon Ave","Gordon Avenue","Gordon Cir","Gordon Ct",
            "Gordon Dr","Gordon Drive","Gordon Ln","Gordon Pl","Gordon Rd","Gordon Road","Gordon Snidow Ct NE",
            "Gordon St","Gordon Street","Gordon Valley Rd","Gordonhurst Ave","Gordonia Dr","Gordons Aly",
            "Gore Rd","Gore Road","Gore Street","Gore Street West","Gore Valley Trail","Goredon Dr","Goreway Drive",
            "Gorgas Rd","Gorge Rd","Gorginio Dr","Gorham Pl","Gorham St","Gorham Street","Goritz Rd","Gorkie Rd",
            "Gorley Ln","Gorman Ave","Gorman Rd","Gorman Ter","Gormley Court","Gorton Lake Rd","Gorum Bridge Rd",
            "Gosey Rd","Goshen Creek Rd","Goshen Rd","Goshen Run Rd","Goshen Swainton Rd","Gosiere Rd",
            "Goslin Rd","Gosling Ln","Gosnell St","Gosnold Street","Gospodnevich Rd","Gosport Ave","Goss Dr",
            "Goss Ln","Gossamer Avenue","Gossett Pl","Goswell Road","Gotha Street","Gotham St","Gothard St",
            "Gottier Dr","Goudy Rd","Gough Avenue","Gough St","Goulart Rd","Gould Ave","Gould Dr NE","Gould Pl",
            "Gould Place","Gould Pond Rd","Gould Rd","Gould St","Gould Street","Goulet Ave","Goulet Ct",
            "Goulet St","Gouveia Way","Gouverneur St","Gov Wentworth Grant Rd","Gov. Harold G. Hoff Plaza",
            "Govenors Rd","Governmen Road","Government Blvd","Government Rd","Government Road","Governor Avenue",
            "Governor Bradford Lane","Governor Crescent","Governor Drive","Governor John Wentworth Hwy",
            "Governor Printz Boulevard","Governor St","Governor Wentworth Rd","Governor Winthrop Lane",
            "Governors Ave","Governors Drive","Gowland Road","Goya Dr","Goyo Gate","Grace Ave","Grace Blvd",
            "Grace Cir","Grace Court","Grace Crescent","Grace Ct","Grace Dr","Grace Lake Rd","Grace Pl",
            "Grace Rd","Grace St","Grace Street","Grace Valley Rd","Graceful Ln","Gracehill Court","Graceland Dr",
            "Gracey Ln","Gracie Square","Graciella Dr","Graciosa Ct","Graciosa Dr","Grade Rd","Grade School Rd",
            "Grade or Lane A","Grado el Tupelo","Grady Ave NW","Grady Dr","Grady Forrester Rd","Grady Rd",
            "Grady St","Graeagle Way","Graef Rd","Graff Ln","Graff Rd","Grafton Ave","Grafton Avenue","Grafton Sq",
            "Grafton St","Grafton Street","Graham","Graham Ave","Graham Court","Graham Dr","Graham Lake Road",
            "Graham Lake Ter","Graham Pl","Graham Rd","Graham Road","Graham St","Graham Ter","Grahm Rd",
            "Grain Mill Rd","Grainflat Rd","Gram Street","Gramarcy Ave","Grambo Dr","Gramercy Ct","Gramercy Dr",
            "Gramercy Park North","Gramercy Pl","Grammercy Pl","Granada Ave","Granada Cir","Granada Ct",
            "Granada Dr","Granada Dr NW","Granada Rd","Granada Way","Granard Boulevard","Granby Ave S",
            "Granby Court NW","Granby Ln","Granby Street","Grand Army Hwy","Grand Army of the Republic Hwy",
            "Grand Ave","Grand Ave NE","Grand Avenue","Grand Beach Rd","Grand Blvd","Grand Both","Grand Boulevard",
            "Grand Canal","Grand Cir","Grand Cove Way","Grand Ct NE","Grand Dr","Grand For Trail","Grand Forest Trail",
            "Grand Forks Road","Grand Key Dr","Grand Mediterra Blvd","Grand Oak Dr","Grand Oak Drive",
            "Grand Oak Way","Grand Oaks Dr","Grand Pointe Way","Grand Ridge Avenue","Grand River Ave",
            "Grand River Dr","Grand Rock Dr","Grand Rock Rd","Grand St","Grand St SW","Grand Street",
            "Grand Summit Ave","Grand Tam Crescent","Grand Ter","Grand Teton Dr","Grand Trunk Western Railroad",
            "Grand Valley Boulevard","Grand Valley Road","Grand View Ave","Grand View Cir","Grand View Dr",
            "Grand Vin Ave","Grandad Rd","Grandaddy Rd","Grande Blvd SE","Grande Sombrero Way","Grande View Tr",
            "Grande Vista","Grande Vista Ct NW","Grande Way","Grandeur Dr","Grandhill Rd","Grandma Ln",
            "Grandmont Ave","Grandravine Drive","Grandview","Grandview Ave","Grandview Avenue","Grandview Blvd",
            "Grandview Cir","Grandview Cv","Grandview Dr","Grandview Drive","Grandview Estates","Grandview Lakes Cv",
            "Grandview Lakes Dr","Grandview Ln","Grandview Pl","Grandview Rd","Grandview Rv Park",
            "Grandview St","Grandview Street","Grandview Street N","Grandview Street North","Grandview Ter",
            "Grandville Ave","Grandville Ave SW","Grange","Grange Ave","Grange Avenue","Grange Hall Rd",
            "Grange Hall Road","Grange Park","Grange Place","Grange Rd","Grange Street","Grange Walk",
            "Granger Cir","Granger Pl","Granger Place","Granger Street","Grangeville Blvd","Grangeway Court",
            "Granillo St","Granit Ct","Granite","Granite Ct","Granite Cyn Rd","Granite Ledge Ave","Granite Ln",
            "Granite Mountain Ct","Granite Pass Ave","Granite Pl","Granite Post Lane","Granite Post Rd",
            "Granite Rd","Granite Reef","Granite Road","Granite Springs Dr","Granite St","Granite Street",
            "Granite View Dr","Granite Way","Grant","Grant 133","Grant 167078","Grant 270017","Grant 48",
            "Grant 737","Grant Ave","Grant Ave S","Grant Avenue","Grant Blight Crescent","Grant Blvd",
            "Grant Cir","Grant Court","Grant Ct","Grant Dr","Grant Drive","Grant Ln","Grant Pl","Grant Place",
            "Grant Rd","Grant St","Grant Street","Grant Ter","Grant Way","Grant Wood Way","Grantbrook Court",
            "Grantete Blvd","Grantham Rd","Grantland Rd","Grantline","Grants Ave","Grants Mill Dr","Grants Pass Rd",
            "Grantwood Blvd","Grantwood Ct","Granville Ct","Granville St","Grape Ave","Grape St","Grape Street",
            "Grape Vine Arbor Ave","Grapefruit Cir","Grapefruit St","Grapevine Creek Rd","Grapevine Ln",
            "Grapevine Rd","Graphite Ct","Graphite Way","Grasmere Dr","Grasmere Road","Grass Ave","Grass Hopper",
            "Grass Lake Rd","Grass Valley Rd","Grass Valley St","Grassfire Crescent","Grasshopper Ln",
            "Grasslands","Grasslands Rd","Grassmere Ave","Grassotti Ct","Grassy Ln","Grassy Sound","Grater St",
            "Gratiot Ct","Gratiot Lake Rd","Gratiot St","Grattan Street","Gratton Avenue","Graustark Path",
            "Gravel Creek Rd","Gravel Hill Rd","Gravel Hill-Spotswood Rd","Gravel Pit Rd","Gravel Point Rd",
            "Gravel Road","Gravelly Ford Dr","Gravelly Point Rd","Gravelly Run Rd","Gravelly Valley Airport",
            "Gravenstein Dr","Gravert Pl","Graves","Graves Ave","Graves Cir","Graves Rd","Graves Reservoir",
            "Gravevine Cy Dr","Gravity Ave","Gravity Way","Gravlee Jct Rd","Gray Ave","Gray Avenue","Gray Court",
            "Gray Ct","Gray Fox Cir","Gray Fox Ct","Gray Fox Dr","Gray Fox Ln","Gray Fox Rd","Gray Fox St NW",
            "Gray Hill Rd","Gray Place","Gray Rd","Gray Road","Gray Road South","Gray Squirrel Ln","Gray St",
            "Gray Wolf Dr","Graybark Ln","Graybrook Ln","Graydon Hall Place","Graydon Pl","Graydon Ter",
            "Grayfield Drive","Graylag Ln","Graymoor Rd","Grayrock Rd","Grays Ct","Grays Ferry Ave","Grays Ferry Rd",
            "Grays Road","Grayson Crescent","Grayson Dr","Grayson Pl","Grayson Rd","Grayson St","Graysonia Dr",
            "Graystone Gardens","Graystone Ln","Grayton Rd","Grayville Dr","Grazia","Grazia Court","Greaswood Rd",
            "Great Abaco St","Great Arbor Way","Great Barrington Road","Great Basin Highway","Great Basin Pl",
            "Great Bass Lake Rd","Great Bear Way","Great Beds Way","Great Brook Ln","Great Elm Dr",
            "Great Gulf Trail","Great Hill Avenue","Great Hill Dr","Great Hills Dr","Great Jones Aly",
            "Great Meadow Rd","Great Meadow Road","Great Neck Drive","Great Oak Drive","Great Oak Ln",
            "Great Oak Rd","Great Oaks Ct","Great Road","Great Rock Rd","Great Salt Lake Dr","Great Western Street",
            "Greatfalls Ct","Greaves Ln","Greaves Pl","Grebe Rd","Grebing Ct","Greble St","Grechen Road",
            "Grecian Ave","Greco Ln","Greco Rd","Greeley Rd","Greeley St","Greely Fire Road","Greely St",
            "Greem Acres","Green","Green Acres","Green Acres Blvd","Green Acres Ln","Green Acres Rd",
            "Green Aly","Green Ash Ln","Green Ave","Green Ave NW","Green Avenue","Green Bay Ct","Green Bay Loop",
            "Green Bay Road","Green Briar Dr","Green Bridge Rd","Green Bush Rd","Green Canyon Ct",
            "Green Canyon Ln","Green Canyon Rd","Green Cir","Green Court","Green Cove Cir SE","Green Creek Ln",
            "Green Creek Rd","Green Ct","Green Ct S","Green Dr","Green Eden Rd","Green Farm Rd","Green Fir Cir",
            "Green Gables St","Green Glen Dr","Green Glen Way","Green Grove Dr","Green Hedges Ln",
            "Green Hill","Green Hill Rd","Green Hills Pl","Green Hills Rd","Green Hollow Dr","Green Island Rd",
            "Green King Loop","Green Knoll Rd","Green Lake Dr","Green Lakes Park Ter","Green Lane",
            "Green Lane Road","Green Lawn Pl","Green Leaf Ln","Green Lilac Cir","Green Line Rd","Green Ln",
            "Green Lodge Street","Green Meadow Ave","Green Meadow Dr","Green Meadows Circle","Green Meadows Dr",
            "Green Memorial Blvd","Green Mountain Ct","Green Mountain Rd","Green Mountain Road",
            "Green Mountain Road East","Green Oaks Ln","Green Orchard Place","Green Park Ln","Green Pine Dr",
            "Green Pointe","Green Pond Rd","Green Pond Road","Green Rd","Green Ridge Rd","Green Rine Ct",
            "Green River Road","Green Road","Green Sands Ave","Green Springs Ave","Green St","Green St Annex",
            "Green St S","Green Street","Green Teal Way","Green Tree Dr","Green Tree Lane","Green Valley Ct",
            "Green Valley Dr","Green Valley Rd","Green Verdugo Edison Rd","Green Vine St","Green Vista Ct",
            "Green Way","Green Willow St","Green Willows Dr","Greenache Way","Greenacre Dr","Greenacre Drive",
            "Greenacres Road No 2","Greenan Road","Greenbank Chatsworth","Greenbank Drive","Greenbench Rd",
            "Greenberg Gate","Greenberry Place","Greenboro Ct","Greenbough Drive","Greenbrair Rd",
            "Greenbriar Ave","Greenbriar Blvd","Greenbriar Cir","Greenbriar Court","Greenbriar Ct",
            "Greenbriar Dr","Greenbriar Lane","Greenbriar Ln","Greenbriar Rd","Greenbrier Ave","Greenbrier Ln",
            "Greenbrier Rd","Greenbrook Cir","Greenbush Ave","Greencastle Ct","Greendale Crescent",
            "Greendale Dr","Greendale Rd","Greendowns Drive","Greene Dr","Greene Rd 105","Greene Rd 233",
            "Greene Rd 314","Greene Rd 326","Greene Rd 345","Greene Rd 502","Greene Rd 561","Greene Rd 605",
            "Greene Rd 738","Greene Rd 747","Greene Rd 805","Greene Rd 820","Greene Rd 919","Greene Rd 972",
            "Greene Road","Greene St","Greene Street","Greenery Ct","Greenfiel Road","Greenfield","Greenfield Ave",
            "Greenfield Avenue","Greenfield Ct","Greenfield Dr","Greenfield Ln","Greenfield Park Dr",
            "Greenfield Rd","Greenfield Road","Greenhaven Ct","Greenhaven Dr","Greenhaven St SW","Greenheaven Dr",
            "Greenhedges Court","Greenhill Avenue","Greenhill Dr","Greenhill Ln","Greenhill Rd","Greenhouse Ln",
            "Greenhouse Rd","Greenhurst St","Greenhurst Village","Greenhurst Village Dr","Greening Ln",
            "Greenland Ct","Greenland Dr","Greenland Road","Greenlane Drive","Greenlaw Avenue","Greenlawn Ave",
            "Greenlawn Rd","Greenleaf Ct","Greenleaf Gate","Greenleaf Road","Greenleaf St","Greenleaf Street",
            "Greenlees Drive","Greenlefe Court","Greenly Ave NE","Greenly Ct","Greenman Ave","Greenmeadow Dr",
            "Greenmount Ave","Greenock Street","Greenoogh Pond Rd","Greenough Park","Greenpoint Avenue",
            "Greenridge Cir","Greenridge Ct","Greenridge Drive","Greenridge Way","Greens Aly","Greens Chapel Rd",
            "Greensbor Drive","Greensboro Ln","Greensboro Rd","Greensboro Road","Greenshire Street",
            "Greenspire Road","Greenstone Ct","Greensward Ln","Greensward Way","Greenswood Pl","Greenthumb Ln",
            "Greentree Dr","Greentree Dr SE","Greentree Ln","Greentree Rd","Greenvale Rd","Greenvall Circle",
            "Greenvalley Circle","Greenview Ave","Greenview Ct","Greenview Dr","Greenview Drive",
            "Greenview Gate","Greenview Way","Greenville Ln","Greenville Reservation Rd","Greenville Terrace",
            "Greenway","Greenway Ave","Greenway Avenue","Greenway Ct","Greenway Dr","Greenway Dr SE",
            "Greenway Rd","Greenway Ter","Greenway Walk","Greenwich Ave","Greenwich Ct","Greenwich Dr",
            "Greenwich House Drive","Greenwich Plains Road","Greenwich Road","Greenwich St","Greenwich Street",
            "Greenwich Village","Greenwood Ave","Greenwood Avenue","Greenwood Bus Loop","Greenwood Cemetery Rd",
            "Greenwood Ct","Greenwood Dr","Greenwood Lake Rd","Greenwood Lake Tpke","Greenwood Ln",
            "Greenwood Pl","Greenwood Rd","Greenwood Road","Greenwood St","Greenwood Street","Greenwoods Ave",
            "Greenwycke Ln","Greer Avenue","Greer Rd","Grefco","Greg Lawn Dr","Greg St","Gregg Dr","Gregg St",
            "Gregory Ave","Gregory Avenue","Gregory Cir","Gregory Ct","Gregory Dr","Gregory Farm Road",
            "Gregory Hill Dr","Gregory Ln","Gregory Pl","Gregory Rd","Gregory Road","Gregory St","Gregory Way",
            "Gregorys Way","Greig Ave","Greig Rd","Greig Street","Grell Rd","Grelle Dr","Gremel Rd","Gremlin Ct",
            "Grenada Ave","Grenada Cir","Grenadier Road","Grenadine Glen","Grenand Ct","Grenhart St",
            "Grennan Rd","Grenoble","Grenoble Ct","Grenoble Pl","Grenview Boulevard S","Grenville Road",
            "Grenville St","Gresham Dr","Gresham Rd","Gresham Road","Greta Ave","Greta Ln","Greta Street",
            "Gretchen St","Gretel Cir","Gretel Place","Gretman Crescent","Gretna Avenue","Gretna Green Ln",
            "Greve Dr","Greveatte St.","Grevillea Ave","Grew Boulevard","Grey Birch Dr","Grey Bull Way",
            "Grey Coach Road","Grey Fox Dr","Grey Fox Rd","Grey Fox Run","Grey Hawk Cir","Grey Lake Rd",
            "Grey Rd","Grey Squirrel Ln","Grey St","Grey Valley Rd","Grey Way","Greyback Rd","Greycedar Court",
            "Greycourt Ave","Greydale Ave","Greydale St","Greyhound St","Greyledge Pl","Greys Bay Road",
            "Greyson Rd","Greystone Acres St","Greystone Ln","Greystone Rd","Greystone Road","Greystone Way",
            "Greyton Crescent","Griak Dr","Grider Rd","Gridley Ave","Gridley Blvd SE","Gridley Plz","Griegos Rd NW",
            "Grier Dr","Grier St","Griers Ln","Grieves Pky","Griffen Ave","Griffen Lem Rd","Griffin Ct",
            "Griffin Hill Rd","Griffin Ln","Griffin Point","Griffin Pond Road","Griffin Rd","Griffin St",
            "Griffins Bay Rd","Griffins Rd","Griffith Ave","Griffith Pl","Griffith St","Griffith Street",
            "Grifton Ave","Griggs Dr","Griggs Rd","Griggs St SE","Griggs Street","Grimes Road","Grimes St",
            "Grimsby Court","Grimsby Rd","Grimsby Road","Grimwood Rd","Grindell Rd","Grinding Wheel Dr",
            "Grindstone Rd","Grinker Pl","Grinnel Ave","Grinnell Road","Grinnell Street","Griscom St",
            "Grissom Ave","Grissom Ct","Grissom Dr NE","Grissom Rd","Grissom St","Grist Mil Road","Grist Mill Circle",
            "Grist Mill Lane","Gristmill","Gristmill Lane","Griswald St","Griswold Rd","Griswold St",
            "Griswold Street","Gritman Ct","Gritte Lane","Grizzly Bear Way","Grizzly Bluff Rd","Grizzly Creek Dr",
            "Grizzly Flat Rd","Grizzly Hill Ct","Grizzly Way","Grm Dr","Grnlf Rnch","Grobelny Dr","Grochdwski St",
            "Groen Ct","Groff Rd","Grofsick Lane","Grogan's Rd","Groom Ave","Groom Lake Rd","Groover Rd",
            "Gros Rd","Gross Ave","Gross Ranch Rd","Gross Rd","Gross St","Gross Street","Grossbeak Drive",
            "Grosse Pointe North High Schoo Dr","Grosse Pointe Pl","Grossman Ave","Grossmont Ct",
            "Grosvenor Sq","Grosvenor St","Groton Dr","Groton Road","Groton Shirley Road","Grotzman Ln",
            "Ground Squirrel","Groundbrier Ln","Groundhog Rd","Grouse Crossing Way","Grouse Ct","Grouse Flats Dr",
            "Grouse Rd","Grouse Springs Rd","Grout Road","Grove Ave","Grove Ave Hawthorne St Aly",
            "Grove Avenue","Grove Cir","Grove Ct","Grove Dr","Grove Hill","Grove Hill Avenue","Grove Hill Trl",
            "Grove Ln","Grove Pl","Grove Poplar Grove","Grove Rd","Grove Rd NW","Grove Rd W","Grove St",
            "Grove St - Rt 16 Cd Road","Grove Street","Grove Street Cotuit","Grove Street E","Grove Ter",
            "Groveland Dr","Groveland St","Groveland Station Rd","Groveland Street","Groveleaf Road",
            "Grovepark Street","Grover Ct SW","Grover Dr","Grover Ln","Grover Pl","Grover Rd","Grover St",
            "Grover Street","Groverdale Road","Groves Farm Rd","Groves Lane","Grovewood","Grovner St",
            "Growers Ln","Grubb","Grubb Rd","Grubstake Trl","Grumpy Ln","Grundel Dr","Grunder Ct","Grunstra Pl",
            "Guadalupe Ave","Guadalupe Dr","Guadalupe Parkway","Gualala Ridge Rd","Guam Ct","Guam Ln",
            "Guard Street","Guardian Dr","Guardian Peak St","Guardians Trail","Guatay","Guatemala Ave",
            "Guava Ave","Guay St","Guaymas Bay Ct","Guaymas Way","Guenevere Way","Guenther Ave","Guenther Pl",
            "Guernsey Ct","Guerra Way","Guerrero Ln","Guerrero St","Guertin St","Guess Dr","Guest Road",
            "Guestville Avenue","Guffin Lane","Gugel Pl","Guide Pl","Guidepost Path","Guido Ave","Guidotti Rd",
            "Guild Road","Guildford Ct","Guildpark Pathway","Guildwood Parkway","Guildwood Way","Guilford Cir",
            "Guilford Ln","Guilford Pl","Guilford Rd","Guillermo Ln","Guilmartin Rd","Guiltner Rd","Guin Rd",
            "Guiness Avenue","Guinevere Ct","Guinness Ct","Guinns Cove Rd","Guittard Rd","Gulch Trl",
            "Gulf Ave","Gulf Rd","Gulf Road","Gulf Stream Way","Gulf Street","Gulfbrook Dr","Gulfcrest Rd",
            "Gulfstream St","Gull Landing","Gull Manor Dr","Gull Pointe Dr","Gull Rd","Gullfoot Circle",
            "Gullwing Lake Road","Gully Road","Gullybrook Ln","Gultch Rd","Gum","Gum Branch Rd","Gum Cir",
            "Gum Pond Mtwy","Gum St","Gumpas Pond Rd","Gumpoint Rd","Gumps Ln","Gun Club Rd","Gun House Hill Rd",
            "Gun Powder Blvd","Gun Smoke Cir","Gunderson","Gundry Ave","Gunn Road","Gunnebo Dr","Gunnison Ave",
            "Gunnison Court","Gunslinger St","Gunsmith Dr","Gunter Rd","Gunters Tn Rd","Gunther Cir",
            "Gunther St","Guntzer St","Gurley Pike","Gurley St","Gurnee Ct","Gurnee Dr","Gurnet Road","Gurnsey Ln",
            "Gurnsey Rd","Gurran Dr","Guru Ram Das Ct","Gus Grissom Dr NW","Gus Harris Trail","Gus Rallis Dr",
            "Gus Steele Rd","Gushue St","Gusmer Dr","Gust St","Gustafson Rd","Gustin Street","Gustine St",
            "Gusto Rd","Gutherie St","Guthrie Crescent","Guthrie Ln","Guthrie Rd","Gutierra","Guttenberg St",
            "Guy Ave","Guy Ct","Guy Ln","Guy Manners Road","Guy St","Guy Witts Rd","Guyan Ave","Guyan Cr Rd",
            "Guyan River Rd","Guyer Ave","Guymard Tpke","Guytoi Court","Gwendale Crescent","Gwendolyn Blvd",
            "Gwendolyn St","Gwendolyn Way","Gwinn St","Gwinnett Ct","Gwizdak Ct","Gyan Way","Gym Dr","Gypsy Bell Ave",
            "Gypsy Lane","Gypsy Ln","H","H Bridgman Rd","H Dr","H L Cir","H L Ct","H Rd","H St","H St S","H Street",
            "H Walk","HWY 400 Southbound Ramp","Haag Ave","Haas Rd","Haas Way","Haase Rd","Haataja","Habitat Ln",
            "Hachita Peak Rd","Hachita Rd","Hacienda Ave","Hacienda Dr","Hacienda Loop","Hacienda Pl",
            "Hacienda Rd","Hacienda Trail","Hacienda Way","Hack Rd","Hackamore Way","Hackberry","Hackberry Ct",
            "Hackberry Dr","Hackberry Gate","Hackberry Ln","Hackberry Rd","Hackensack Ave","Hacker Road",
            "Hackers Ln","Hackett Hill","Hackett Street","Hacketts Pond Drive","Hackfeld Road","Hadden St",
            "Haddington Dr","Haddo Road","Haddock Avenue","Haddon Ave","Haddon Ct","Haddon Rd","Haddon Street",
            "Haddon View E","Haddonfield Berlin Rd","Haddonfield Pl","Haddonfield Rd","Hader Park",
            "Hadfield St","Hadlar Dr","Hadley Aly","Hadley Ave","Hadley Court","Hadley Farm Rd","Hadley Ln",
            "Hadley Rd","Hadley Street - Iroquois","Hadley Way","Hadock St","Hadrian Dr","Hadrill Ct",
            "Hafey Street","Hagan Dr","Hagan Loop","Hagan Rd","Hagar Ct","Hagar Ped Access","Hagar Street",
            "Hagen Ct","Haggard Ln","Haggarts Sideroad","Haggerty Rd","Haggerty Road","Haggerty Road E",
            "Haggerty Way","Hagler Coaling Rd","Hagley Dr","Hagood Aly","Hague Ct","Hague Rd","Hague St",
            "Hagys Ford Rd","Hahn Ln","Hahn Rd","Hahn St","Haigh Rd","Haight Pl","Haights Gulf Rd","Hail Ln",
            "Hail St","Hail Storm Ct","Hailberd Ct","Hailesboro St","Haileybury Drive","Haimer Avenue",
            "Haines Ave","Haines Ave NE","Haines Cove Ct","Haines Hwy","Haines Neck Rd","Haines Place",
            "Haines Rd","Haines Road","Hainsworth Court","Haist Street","Haiwee Ct","Haiwee St","Hal's Rd",
            "Halbert Ave","Halbert St","Halcroft Pl","Halcyon Dr","Halcyon Way","Haldimand Trail","Haldon Avenue",
            "Hale Ave","Hale Ave N","Hale Creek Rd","Hale Ct","Hale Dr","Hale Ln","Hale Rd","Hale St","Hale Street",
            "Haleb Ct","Hales Landing","Halesia Drive","Haley Ct","Haley Ln","Haley Rd","Haley St","Haleys Way",
            "Half Moon Dr","Half Way","Halfmoon Dr","Halford Avenue","Halford St","Halfway Avenue","Halfway Dr",
            "Halfway House Rd","Halfway Hse Spur","Halfway Pond Road","Halfway Rd","Halfway St","Halgren Cres",
            "Haliburton Avenue","Halibut Ave","Halibut Way","Halifax Dr","Halifax Ln","Halifax Rd","Halifax Street",
            "Hall Ave","Hall Avenue","Hall Court","Hall Ct","Hall Dr","Hall Drive","Hall Ln","Hall Meadow Cir",
            "Hall Rd","Hall Road","Hall St","Hall St SW","Hall Street","Hall Street Branch","Hall Village Rd",
            "Hall Way","Halladay Ln","Halladay St","Hallam St","Hallcrest Avenue","Hallcroft Ct","Halleck Street",
            "Hallenbeck Rd","Haller Ave","Haller Avenue","Haller Cres","Hallett Ct","Hallett Rd","Halley Dr",
            "Halliard Ave","Halliday St","Hallman Rd","Hallman S Rd","Hallman St","Hallmark Court","Hallmark Ct",
            "Hallmark Pky","Hallock St","Hallockville Road","Halloran Springs Rd","Halloway Circle",
            "Halloway Road","Halls Mill Rd","Halls Pond Rd","Hallum Dr","Hallview Drive","Hallwood Dr",
            "Halmar Rd","Halmore Dr","Halo Ave","Halpin Ave","Halpin Rd","Halsey Ave","Halsey Dr","Halsey Lake Rd",
            "Halsey Ln","Halsey Pl","Halsey Rd","Halsey Reed Rd","Halsey St","Halso Mill Rd","Halstead Ave",
            "Halstead Drive","Halstead Pl","Halstead Rd","Halstead St","Halsted Ave","Halsted Dr","Halsted St",
            "Halter Ct","Halvern Ave","Halwyck Cir NW","Halyard Ct","Ham Ave","Ham Ln","Ham Rd","Hamate Way",
            "Hambaugh Morris","Hamblin Rd","Hamblins Hayway","Hambly Avenue","Hambly Court","Hambly Street",
            "Hambone Heights","Hambone Rd","Hambrick Dr","Hambright Rd","Hamburg Street","Hamburg Turnpike",
            "Hamby Rd","Hamden Ave","Hamden Ct","Hamel Ave","Hamel Dr","Hamer Dr","Hamilton","Hamilton Aly",
            "Hamilton Ave","Hamilton Avenue","Hamilton Ct","Hamilton Hill Rd","Hamilton Ln","Hamilton Pl",
            "Hamilton Point","Hamilton Rd","Hamilton Road","Hamilton St","Hamilton Stage Rd","Hamilton Street",
            "Hamilton Ter","Hamilton Tr","Hamilton Walk","Hamker Ct","Hamlen Ave","Hamlet Ave","Hamlet Ct",
            "Hamlet Dr","Hamlet Mill Rd","Hamlet St","Hamlet Trl","Hamlett Dr","Hamley Rd","Hamley Street",
            "Hamlin Beach State Park","Hamlin Lane","Hamlin St","Hamlin Street","Hamlin Trl","Hamline Rd",
            "Hammac Rd","Hammatt Ave","Hammco Cir","Hammer Loop Rd","Hammersly Boulevard","Hammersmith Drive",
            "Hammock Rd","Hammock Terrace","Hammon Rd","Hammond Hill Rd","Hammond Hill Road","Hammond Park Dr",
            "Hammond Pl E","Hammond Rd","Hammond Road","Hammond St","Hammond Trail","Hammondsport-Wayne Rd",
            "Hammonton Rd","Hamms Gulch Trail","Hamms Ln","Hamp Roberts Rd","Hampden Place","Hampden Road",
            "Hampden Street","Hampel Ave","Hampel St","Hampshire Ct","Hampshire Dr","Hampshire Line",
            "Hampshire Ln","Hampshire Place","Hampshire Rd","Hampshire Ridge","Hampshire St","Hampshire Street",
            "Hampstead Rd","Hampstead Street","Hampton Blvd","Hampton Cir","Hampton Ct","Hampton Dr",
            "Hampton Gardens","Hampton Hills Dr","Hampton Ln","Hampton Park Crescent","Hampton Park Dr",
            "Hampton Pl","Hampton Rd","Hampton Springs Drive","Hampton St","Hampton Street","Hampton Way",
            "Hamrick Dr","Hamsley Rd","Hamstead Avenue","Hamstead Dr","Hamton Pl","Hana Ln","Hana Rd","Hanan Dr",
            "Hance Ave","Hancock Ct","Hancock Dr","Hancock Hwy","Hancock Pl","Hancock Place","Hancock Rd",
            "Hancock St","Hancock Street","Hancock Ter","Hancorne Ranch Rd","Hand Ave","Handel St","Handel Way",
            "Handley Aly","Handley Dr","Handley Ln","Hands Road","Handsaw Rd","Haney Avenue","Haney Dr",
            "Hanford Ave","Hanford Pl","Hanford Rd","Hanford St","Hangar Rd","Hanger Rd","Hanging Rock Tr",
            "Hanging Wall Dr","Hangtree Rd","Hangtree Trl","Hank Pl","Hank Williams Rd","Hankins Rd",
            "Hanks Ave","Hanley Ct","Hanley St","Hanlon Ln","Hanmer Street W","Hann Pl","Hanna Ct","Hanna Drive",
            "Hanna Rd","Hanna St","Hannah Ave","Hannah Ct","Hannah Dr","Hannah Dustin Dr","Hannaland Dr",
            "Hannan Ave","Hannan Trace Rd","Hanne Ct","Hannett Ave","Hanni Cir","Hannibal Pl","Hannigan",
            "Hanning Court","Hannon Ave","Hannon Street","Hano Rd","Hanover","Hanover Ave","Hanover Court",
            "Hanover Ct","Hanover Dr","Hanover Drive","Hanover Lane","Hanover Ln","Hanover Pl","Hanover Rd",
            "Hanover Sq","Hanover St","Hanover Street","Hanrahan Rd","Hans Dr","Hanscom Drive","Hansel Hodges Rd",
            "Hansell Rd","Hansen Ave","Hansen Cir","Hansen Court Dr","Hansen Hill Rd","Hansen Ln","Hansen Rd",
            "Hansen St","Hansom Ave","Hansom Rd","Hansom St","Hanson Ave","Hanson Bar Trl","Hanson Bridge Rd",
            "Hanson Dr","Hanson Ln","Hanson Place","Hanson Road","Hanson St","Hanson Street","Hanson Way",
            "Hanthorn St","Hanton City Rd","Hapeburg Rd","Hapeman Rd","Hapgood Pl","Hapgood St","Hapgood Street",
            "Happeny Ct","Happy Acres","Happy Camp Rd","Happy Cir","Happy Dr NW","Happy Go Lucky Ct",
            "Happy Hill Rd","Happy Hollow","Happy Hollow Dr","Happy Hollow Dr NE","Happy Hollow Rd",
            "Happy Horse Way","Happy Hour Dr","Happy Isles Ct","Happy Jack","Happy Ln","Happy Trails Dr",
            "Happy Trl","Happy Valley Ave","Happy Valley Rd","Happy Valley Spur","Happy Valley Trl",
            "Hapsburg Ct","Hara St","Harantis Lake Rd","Harbison Ave","Harbison Rd","Harbor Ave","Harbor Beach Ct",
            "Harbor Cir","Harbor Club Cir W","Harbor Ct","Harbor Dr","Harbor Freeway","Harbor Heights Rd",
            "Harbor House Apts","Harbor Island Dr","Harbor Mist Dr","Harbor Pl","Harbor Point Dr",
            "Harbor Pt Ct","Harbor Rd","Harbor St","Harbor Street","Harbor View Avenue","Harbor View Ct",
            "Harbor View Dr","Harbor View Lane","Harbord Street","Harborn Road","Harbortowne Dr","Harborview Ct",
            "Harbour Ct","Harbour Road","Harbour Street","Harbour Way","Harbourd","Harbourtown Blvd",
            "Harbrite Drive","Harcourt Avenue","Harcourt Pl","Harcourt Road","Harcove Street","Harcroft Road",
            "Harcuvar Dr","Hard Times Ln","Hardcastle Ln","Hardee Hill","Hardell St","Harden Farm Rd NW",
            "Hardenburg Ln","Hardenburg Rd","Hardenburgh Ave","Hardesty Ln","Hardin Rd","Hardin Run Rd",
            "Harding","Harding Ave","Harding Avenue","Harding Blvd","Harding Ct","Harding Dr","Harding Hwy",
            "Harding Pl","Harding Rd","Harding Road","Harding St","Harding St NW","Harding Street","Harding Ter",
            "Hardisty Drive","Hardman St","Hardnett Ct","Hardpan Ln","Hardrock Rd","Hardrock St","Hardscrabble Ct",
            "Hardscrabble Road","Hardstone Dr","Hardt Ln","Hardt Rd","Hardwick Dr","Hardwick St","Hardwicke Dr",
            "Hardwood Ct","Hardwood Dr","Hardwood Hill","Hardwood Ridge","Hardwood St","Hardwood Street",
            "Hardwood Trl","Hardwoods Rd","Hardword Dr","Hardy Ave","Hardy Avenue","Hardy Ct","Hardy Dr",
            "Hardy Ln","Hardy Rd","Hardy Road","Hardy St","Hare Creek Ter","Hare Pl","Hare Rd","Hare St","Harebell Ct",
            "Harek Rd","Hares Tail Close","Harewood Avenue","Harewood Run","Harfield Dr","Harford Pl",
            "Hargis Ave","Hargold Ave","Hargrave Rd","Hargraves St","Hargreaves St","Hargrove Rd","Hargrove Rd E",
            "Haring Farm Ct","Haring Pl","Haring St","Haring Street","Harkers Hollow Ct","Harkney Hill Rd",
            "Harlan Dr","Harlan Ln","Harlan Mtwy","Harlan Rd","Harlan St","Harland Street","Harlandale Avenue",
            "Harlands Creek Rd","Harlem Rd","Harlem River Dr","Harlem River Drive","Harlem River Park Brg",
            "Harlen Ln","Harlequin Dr","Harlequin Rd NE","Harless Rd","Harley Ave","Harley Avenue","Harley Dr",
            "Harley St","Harlin Creek","Harling St","Harlow Crescent","Harlow Ct","Harlow Pl","Harlow Rd",
            "Harlow Street","Harma Pl","Harman Ct","Harman Way","Harmar St","Harmer Road","Harmersville Rd",
            "Harmon Ave","Harmon Dr NE","Harmon Pl","Harmon Rd","Harmon Ridge Rd","Harmon St","Harmony Avenue",
            "Harmony Cir","Harmony Circle","Harmony Ct","Harmony Farms Ln","Harmony Hill Ct","Harmony Ln",
            "Harmony Point Dr","Harmony Rd","Harmony Road","Harmony Road North","Harmony St","Harmony Station Rd",
            "Harmony Street","Harmony Way","Harms Ln","Harmyk Ct","Harness Ct","Harness Rd","Haro Ave","Harold Ave",
            "Harold Cir","Harold Dr","Harold Dr NW","Harold Ln","Harold Parker Road","Harold Pl NE","Harold Roberts Rd",
            "Harold St","Harold Street","Harold Way","Harolds Way","Harp Ct","Harp St","Harp Way","Harper Ave",
            "Harper Avenue","Harper Crescent","Harper Dr","Harper Fire Road","Harper Hill Road","Harper Ln",
            "Harper Rd","Harper Road","Harper St","Harpers Point Road","Harpoon St","Harpur Dr","Harpy Eagle Ave",
            "Harquahala Dr","Harraca Springs Rd","Harrell Ave","Harreton Rd","Harrier Ct","Harrier Way",
            "Harriet Ave NW","Harriet Avenue","Harriet Dr","Harriet Ln","Harriet Pl","Harriet St","Harriet Thayer Avenue",
            "Harriete Ct","Harriett Way","Harriette Road","Harriettsville Rd","Harrigan Rd","Harriman Cir",
            "Harriman State Park","Harrington Ave","Harrington Avenue","Harrington Cir","Harrington Dr",
            "Harrington Rd","Harrington Road","Harrington Ter","Harris Ave","Harris Avenue","Harris Dr",
            "Harris Grade Rd","Harris Ln","Harris Pl","Harris Pond Rd","Harris Rd","Harris St","Harris Street",
            "Harris Way","Harris Woods","Harrisburg Rd","Harrison Aly","Harrison Ave","Harrison Ave N",
            "Harrison Ave SW","Harrison Avenue","Harrison Ct","Harrison Dr","Harrison Hill Spur Rd",
            "Harrison Hwy","Harrison Ln","Harrison Ln SW","Harrison Pl","Harrison Place","Harrison Rd",
            "Harrison Rd E","Harrison Rd N","Harrison St","Harrison Street","Harrisonville Rd","Harrls Hill Dr",
            "Harrogate Ct","Harrogate Dr","Harrold St","Harrow Dr","Harrow Ln","Harrow Street","Harrowsmith Court",
            "Harry Cash Rd","Harry Homans Drive","Harry Kress Dr","Harry L Dr","Harry L Spur","Harry Pl",
            "Harry Rd","Harry St","Harry Truman Ovps","Harry Walker Parkway North","Harry Wright Park",
            "Harryman Dr","Harsh Ave SE","Harshaw Avenue","Hart Blvd","Hart Boulevard","Hart Cir","Hart Dr",
            "Hart House Circle","Hart Ln","Hart Oaks Dr","Hart Pl","Hart Rd","Hart Road","Hart St","Hart Street",
            "Hart Ter","Harte St","Hartel Ave","Harter Ct","Harter Road","Hartfield Boulevard","Hartfield Ln",
            "Hartfield Road","Hartford Ave","Hartford Avenue","Hartford Avenue East","Hartford Avenue West",
            "Hartford Court","Hartford Ct","Hartford Dr","Hartford Mansfield Rd","Hartford Rd","Hartford Street",
            "Hartford Way","Hartismere Court","Hartke Pl","Hartland Drive","Hartland Hill","Hartland St",
            "Hartley","Hartley Ave","Hartley Ct","Hartley Road","Hartley St","Hartlot Rd","Hartman Aly",
            "Hartman Ln","Hartman Rd","Hartman Road","Hartman St","Hartnell Pl","Harts Bridge Rd","Harts Gravel Road",
            "Hartshorn Ln","Hartshorn Road","Hartshorne Dr","Hartsook St","Hartung Street","Hartung Way",
            "Hartwell Road","Hartwell Way","Hartz Dr","Hartzell Ferry Rd","Harvard","Harvard Ave","Harvard Ave NW",
            "Harvard Camp Rd","Harvard Ct","Harvard Depot Road","Harvard Dr","Harvard Ln","Harvard Pl",
            "Harvard Rd","Harvard Road","Harvard Sq","Harvard St","Harvard Street","Harvard Ter","Harvard Way",
            "Harve St","Harvell St","Harvest Ave","Harvest Ct","Harvest Dr","Harvest Hill","Harvest Ln",
            "Harvest Mill","Harvest Moon Drive","Harvest Moon Ln","Harvest Rd","Harvest Street","Harvest Trl",
            "Harvest Way","Harvest Way E","Harvester Road","Harvestwood Lane","Harvey Ave","Harvey Ave NW",
            "Harvey Ct","Harvey Dr","Harvey Ln","Harvey Place","Harvey Rd","Harvey Road Two","Harvey St",
            "Harveys Lane","Harvie Avenue","Harvy Ave","Harwick Ct","Harwood Ave NE","Harwood Avenue N",
            "Harwood Avenue S","Harwood Ct","Harwood Drive","Harwood Rd","Harwood Road","Harwyn Dr","Hasbrouck Ave",
            "Haskell Ave","Haskell Flats Dr","Haskell Pky","Haskell Pl","Haskell Rd","Haskell St","Haskell Street",
            "Haskins Ave","Hasler Valley Rd","Hass Road","Hassart St","Hassel Ct","Hassig Rd","Hastain Rd",
            "Hasting Crossing Rd","Hasting Dr","Hastings Ave","Hastings Avenue","Hastings Blvd","Hastings Ct",
            "Hastings Dr","Hastings Heritage Trail","Hastings Ln","Hastings Loop","Hastings Rd","Hastings St",
            "Hasty Rd","Hat Creek Powerhouse No 2 Rd","Hatch Avenue","Hatch Rd","Hatch St","Hatcher Dr",
            "Hatcher Rd","Hatchers Circle","Hatchery Ln","Hatchet Ln","Hatchet Place","Hatchet Rd","Hatchett Rd W",
            "Hatchie Coon Rd","Hatcox Rd","Hately Ln","Hatfield Ln","Hatfield Pl","Hatfield Rd","Hatfield St",
            "Hatfield Street","Hathaway Ave","Hathaway Ct","Hathaway Drive","Hathaway Pond Road Spur",
            "Hathaway Rd","Hathaway Road","Hathaway Trl","Hathcoat Rd N","Hatherly Road","Hatherton Crescent",
            "Hatheway Dr","Hathorn Acres Rd","Hathorne Place","Hatt Hill Dr","Hatter Street","Hatters Ln",
            "Hattie St","Hatty Ln","Hatzinger Rd","Hauberk Ct","Hauck St","Hauge Dr","Haughwout Ave","Hauk Cir",
            "Haultain Road","Hauser Ln","Hauser St","Hausmann Ct","Hausna Rd","Haut St SW","Havasu Ct","Havasu Heights",
            "Havasu Lake Dr","Havelock Street","Havemeyer Street","Haven Ave","Haven Ct","Haven Dr","Haven Green Ct",
            "Haven Hill Way","Haven Ln","Haven Point","Haven Rd","Haven Ridge Ln","Haven Road","Haven St",
            "Haven Ter","Havenbrook Boulevard","Havendale Road","Havenhurst Ct","Havens Ave","Havens Mill Rd",
            "Havens Rd","Havenview Road","Havenway Gate","Havenwood Cir","Havenwood Drive","Havenwood Ln",
            "Havenwood Rd","Haverford Ave","Haverford Rd","Haverhill Circle","Haverhill Rd","Haverhill Street",
            "Haverling Ln","Havervale Ln","Havilah Street","Haviland Dr","Haviland Pl","Havland","Hawaii Ln",
            "Hawaii Rd","Hawarden Crescent","Hawes Rd","Hawes St","Hawk Aly","Hawk Ave","Hawk Ave SE","Hawk Avenue",
            "Hawk Canyon Rd","Hawk Ct","Hawk Haven St","Hawk Hill Road","Hawk Meadow Rd","Hawk Pine Rd",
            "Hawk Road","Hawk St","Hawk's Nest Dr","Hawkes Ln","Hawkes St","Hawkesbury Ct","Hawkeye Ave",
            "Hawkins","Hawkins Court","Hawkins Dr","Hawkins Rd","Hawkins Road","Hawkins St","Hawkridge Trail",
            "Hawks Peak Rd","Hawks Peak Way","Hawks Road","Hawks St","Hawksbridge Cir","Hawkshead Way",
            "Hawkweed Way","Hawley Road","Hawley St","Hawley Street","Hawman Avenue","Haworth Ave","Haworth Dr",
            "Haworth St","Hawranick Rd","Hawthorn Ct","Hawthorn Cv","Hawthorn Dr","Hawthorn Drive","Hawthorn Road",
            "Hawthorne","Hawthorne Ave","Hawthorne Avenue","Hawthorne Boulevard","Hawthorne Cir","Hawthorne Ct",
            "Hawthorne Dr","Hawthorne Dr N","Hawthorne Drive","Hawthorne Ln","Hawthorne Pky","Hawthorne Pl",
            "Hawthorne Rd","Hawthorne St","Hawthorne Street","Hawthorne Ter","Hawthorne Way","Hawver Rd",
            "Hay Hook Rd","Hay Point Landing Rd","Hay Press Rd","Hay St","Hay Valley Rd","Hayden Dr",
            "Hayden Hill Ctf","Hayden Lane","Hayden Ln","Hayden Rd","Hayden St","Haydock Ct","Hayes Ave",
            "Hayes Camp Rd","Hayes Cir","Hayes Ct","Hayes Hill And Branch Road","Hayes Line","Hayes Rd",
            "Hayes Rd E","Hayes Road","Hayes St","Hayes Street","Hayfield Cir","Hayfield Ln","Hayfield Rd",
            "Hayfork Pl","Haygood Way","Hayhoe River Trail","Haylage Cir","Hayles St","Haymar Dr","Haymarket Ln",
            "Haymarket St","Haymeadow Rd","Haymen Cir","Haymur Street","Hayneck Rd","Haynes Ave","Haynes Avenue",
            "Haynes Rd","Haynes Road","Haynes St","Haynes Street","Hayney Ave","Hayride Dr","Hays Cemetery Rd",
            "Hays Dr","Hays Ln","Hays Park Ave","Hays St","Haystack Dr","Haystack Rd","Hayts Corners East Rd",
            "Hayuco","Hayward Ave","Hayward Drive","Hayward Lane","Hayward St","Hayward Street","Haywood Dr S",
            "Haywood Rd","Hayworth Hills Dr NE","Hazard Ave","Hazard Pl","Hazard Rd","Hazard Street",
            "Hazel Ave","Hazel Ct","Hazel Dell Rd NE","Hazel Dr","Hazel Fischer School","Hazel Pl","Hazel Rd",
            "Hazel St","Hazel Street","Hazelbrook Dr","Hazelhurst Ave","Hazell Court","Hazelmere Drive",
            "Hazelnut Court","Hazelnut Ct","Hazelnut Dr","Hazelnut Rd","Hazelton Ave","Hazelton Avenue",
            "Hazelton Dr","Hazelton Road","Hazelton St","Hazelview Ave","Hazelwood Avenue","Hazelwood Ct",
            "Hazelwood Dr","Hazelwood Ln","Hazelwood Rd","Hazelwood St","Hazen Rd","Hazle St","Hazlehurst Ave",
            "Hazlitt Way","Hazzard St","Hcr 73","Head Of The Bay Road","Head Way","Headlands Close","Headlands Reach",
            "Headquarters Rd","Headquarters St","Headquarters Way","Headwater Crescent","Headwater Dr",
            "Headwater Road","Headwaters Rd","Headway Ln","Heald Rd","Heald St","Healing Springs Rd",
            "Health Avenue","Health Camp Rd","Health Clinic Rd","Healton Cir","Healy Hardwood Rd",
            "Healy Pasture Rd","Healy Trl","Healy Way","Heaney Ave","Heap Ave","Heard Ave","Hearn Ave","Hearn St",
            "Hearst Ave","Hearst Castle Rd","Hearst Circle","Hearst Dr","Hearst Willits","Hearst-Willits Rd",
            "Heart Lake Road","Heartbreak Ridge Trail","Hearth Ct","Hearth Rd","Hearth Way","Hearthside Avenue",
            "Hearthstone Ave","Hearthstone Crescent","Hearthstone Dr","Hearthstone Drive","Hearthstone Ln",
            "Hearthstone Rd","Hearthstone Ter","Hearthwood Ct","Heartland Trl NW","Heartrose Ct","Hearts Club Dr",
            "Hearts Content Rd","Heartstring Ct","Heartwood Cir","Heaslip Ln","Heaslip Road","Heaslip Terrace",
            "Heath Ave","Heath Ct","Heath Dr","Heath Lee Ct","Heath Ln","Heath Rd","Heath Road","Heath St",
            "Heath Street West","Heathbank Avenue","Heather","Heather Brook Ln","Heather Cir","Heather Ct",
            "Heather Dr","Heather Drive","Heather Glen Apartment","Heather Haven Dr","Heather Hill Dr",
            "Heather Hills Rd","Heather Lane","Heather Lily Ct","Heather Ln","Heather Rd","Heather Road",
            "Heather Street","Heather Way","Heatherbrae Ct","Heathercreek Way","Heathercrest Dr","Heatherhill Rd",
            "Heatheridge Dr","Heatherington Drive","Heatherington Way","Heatherland Road","Heatherleigh Avenue",
            "Heatherside Drive","Heatherstone St","Heatherwood Dr","Heathrow St","Heaton Ct","Heaton Ln",
            "Heaton St","Heatons Mill Cir","Heaven Ln","Heavenly Dr","Heavenly Hollow","Heavenly Ridge Rd",
            "Heavenly Valley Ct","Heavens Way","Hebard Ct","Hebard St","Hebe Ln","Heber Down Crescent",
            "Heberdeen Ct","Hebert Rd","Heberton Ave","Hebrides Cir","Hebron Ave","Hebron Rd","Hebron Street",
            "Hecate Ct","Heck Ave","Heckel St","Hecla St","Hecox Rd","Hedda St","Heddon Rd","Heddon St","Hedge Ct NE",
            "Hedge Road","Hedge Row","Hedge St","Hedge Way","Hedgegate Rd","Hedgehog Ln","Hedgeland Ct",
            "Hedgemoor Dr","Hedgerose Ln","Hedgerow Ct","Hedgerow Dr","Hedgerow Ln","Hedges Pond Road",
            "Hedgeway","Hedgewood Dr","Hedgewood Drive","Hedgewood Pl","Hedigham Blvd","Hedlund Ct","Hedstrom Dr",
            "Hedstrom Way","Hedy Gate","Heelpath Rd","Heenan Place","Heer Dr","Hefferan Rd","Heffner Hills Cir",
            "Hegadorn Street","Hegel Pl","Hegel Rd","Hegel Rd NW","Hegeman Avenue","Heger Way","Hegerman St",
            "Hegner Ct","Heidi Ct","Heidi Dr","Heidi Ln","Heier Dr","Height St","Heights Ct","Heights Ln","Heights Rd",
            "Heights Road","Heikes Rd","Heil Blvd","Heim Ave","Hein Ave","Heinlen St","Heinrich Rd","Heitman Mountain Trail",
            "Helecho Rd NW","Helen Ave","Helen Avenue","Helen Ct","Helen Dr","Helen Drive","Helen Marie Ct",
            "Helen Perry Rd","Helen Pl","Helen St","Helen Street","Helen Street - Iroquois","Helen Way",
            "Helen's Pl","Helena Ave","Helena Avenue","Helena Court","Helena Creek Ct","Helena Rd NW",
            "Helena St","Helena Street","Helenrich St","Helgren Rd","Helicon Rd","Heliotrope Ln W","Hell Hole Rd",
            "Hellems Avenue","Hellems Rd","Heller Dr","Heller Hill Rd","Heller Park Ln","Heller Pky",
            "Heller Pl","Heller Rd","Hellhole Canyon","Hells Half Acre Rd","Helluvahill Ln","Helmar Rd",
            "Helmer-Mosher Rd","Helmetta Jamesburg Rd","Helmhill Ave","Helms Ave","Helms Dr","Helmsdale Dr",
            "Helmsdale Rd","Helmsley Avenue","Helmsley Pl","Helmwood Ct","Helsel Ln","Helsinki Crescent",
            "Helston Place","Helter Skelter Rd","Helton Dr","Helton Rd","Helva Ln","Helweg Rd","Hematite St",
            "Hemenway Ave","Hemenway Cv","Hemenway Rd","Hemenway Street","Hemeon Road","Hemhock Ave",
            "Hemi Cir","Hemingway Ct","Hemlock","Hemlock Ave","Hemlock Blvd","Hemlock Cir","Hemlock Ct",
            "Hemlock Cv","Hemlock Dr","Hemlock Drive","Hemlock Hill Dr","Hemlock Hill Rd","Hemlock Hills Rd",
            "Hemlock Hollow Rd","Hemlock Ln","Hemlock Plz","Hemlock Rd","Hemlock Ridge Dr","Hemlock St",
            "Hemlock Street","Hemlock Ter N","Hemlock Ter S","Hemlock Valley Way","Hemlock-Hill","Hemmford Drive",
            "Hemphill Rd","Hempson Ave","Hempstead 1010 Rd","Hempstead 1012 Rd","Hempstead 180 Rd",
            "Hempstead 19 Rd","Hempstead 20 Rd","Hempstead 211 Rd","Hempstead 237 Rd","Hempstead 24 Rd",
            "Hempstead 307 Rd","Hempstead 379","Hempstead 80 Rd","Hempstead Ave","Hempstead Rd","Hemstreet Ave",
            "Hendee Rd","Hendershot Avenue","Henderson","Henderson Ave","Henderson Avenue","Henderson Ct",
            "Henderson Dr","Henderson Hill Rd","Henderson Hollow Rd","Henderson Hwy","Henderson Ln",
            "Henderson Pl","Henderson Place","Henderson Rd","Henderson St","Henderson Street","Henderson Way",
            "Hendom Meadow Drive","Hendrick Hill","Hendrick Rd","Hendricks Ave","Hendricks Cir","Hendricks Cswy",
            "Hendricks Ct","Hendricks Dr","Hendricks Lane","Hendrickson Ave","Hendrickson Rd","Hendrickson St",
            "Hendrix Ave","Hendrix Ave NE","Hendrix Rd","Hendrys Ct","Hendrysburg Freeport Rd","Henke Ct",
            "Henke Trlr Park Rd","Henkle Ave","Henley Ave","Henley St","Henmarken Dr","Henness Cir","Henness Pass Rd",
            "Hennessey Rd","Henning Dr","Henning St","Henri A Burque Hwy","Henri Matisse Ave","Henricks Road",
            "Henrietta Ave","Henrietta Street","Henriette St","Henrilee St","Henry Andry Rd","Henry Ave",
            "Henry C Luthin Pl","Henry Clay Blvd","Henry Co Land Field","Henry County 170","Henry County 2",
            "Henry County 204","Henry County 26","Henry County 29","Henry County 33","Henry County 46",
            "Henry County 65","Henry County 7","Henry County 73","Henry County 93","Henry County 97",
            "Henry Crescent","Henry Ct","Henry Dr","Henry Ford II Dr","Henry Harris Rd","Henry Hudson Bike Trail",
            "Henry Hudson Bridge","Henry Hudson Dr","Henry Hudson Parkway","Henry Knox Rd","Henry Ln",
            "Henry M Baldwin St","Henry Miller Ave","Henry Pl","Henry Rd","Henry Ridge Mtwy","Henry St",
            "Henry Street","Henry Vick Rd","Henrylaye Terrace","Henrys Dr","Henrys Way","Henshaw Cir",
            "Henshaw Rd","Henshaw Street","Henshaw Terrace","Hensley St","Henson Ln","Henson Rd","Henson St",
            "Henwood Rd","Hepatica Ct","Hepbourne Street","Hepburn Dr","Hepburn Rd","Hepler Rd","Hepplewhite Ct",
            "Hepworth Pl","Herado Ave","Herald St","Herb Ct","Herbcain Avenue","Herbert Ave","Herbert Calbert Drive",
            "Herbert Ct","Herbert J Ave","Herbert Pl","Herbert Pl NW","Herbert Rd","Herbert St","Herbert Street",
            "Herbert Ter","Herbert Way","Herbertsville Rd","Herby Way","Herchimer Avenue","Hercules Street",
            "Hereford Ave","Hereford Ln","Hereford Rd","Hereford St","Herflicker Blvd","Herford St","Hering Pl",
            "Heritage Ave","Heritage Blvd","Heritage Cir","Heritage Court","Heritage Ct","Heritage Dr",
            "Heritage Drive","Heritage Hill Road","Heritage Hills Boulevard","Heritage Hills Dr",
            "Heritage Hts","Heritage Ln","Heritage Manor Dr","Heritage Manor Pl","Heritage Meadow Pl",
            "Heritage Oak","Heritage Oak Glen Mhp","Heritage Pl","Heritage Pointe Blvd","Heritage Rd",
            "Heritage Road","Heritage Springs Dr","Heritage Way","Herkimer Dr","Herkimer Road","Herkimer St",
            "Herley Road","Herlong Airport Rd","Herman Ave","Herman Ln","Herman Rd","Herman St","Herman Thau Rd",
            "Hermanas Grd SW","Hermance Rd","Hermann St","Hermes Ct","Hermes Rd","Hermes St","Hermina St",
            "Hermit Court","Hermit Rd","Hermit St","Hermitage","Hermitage Dr","Hermitage Ln","Hermitage Rd",
            "Hermitage Road","Hermitage St","Hermon Avenue","Hermosa Ave","Hermosa Dr","Hermosa Ln","Hermosa Pl",
            "Hermosa St","Hermosillo Dr","Hermosita Dr","Hernandez St","Hernborg Rd","Herndon","Herndon Ln",
            "Hero Square","Heron","Heron Cove Rd","Heron Ct","Heron Dr","Heron Hollow","Heron Hollow Avenue",
            "Heron Lane","Heron Ln","Heron Road","Heron St","Heron Way","Herons Way","Herr Rd","Herr Road Spur",
            "Herr Trail Rd","Herr Way","Herrada Ct","Herrada Way","Herrell Avenue","Herren St","Herrick Dr",
            "Herrick's Cv","Herricksville Rd","Herridge Circle","Herring Ave","Herring Pond Road",
            "Herring Run Drive","Herring Way","Herschel Pl","Herschel Rd","Herschel St","Hersey Crescent",
            "Hersey Ln","Hersey St","Hersey Street","Herseyway Ln","Hershel St","Hershell Henry Rd","Hershey Ct",
            "Hershey Ln NW","Hersheys Dr","Herthum Rd","Hervey Ct","Herzberg Gardens","Herzog Pl","Hesby Way",
            "Hesperian Boulevard","Hess Ave","Hess Mill Rd NE","Hess Rd","Hess Way","Hessell Rd","Hessian Ave",
            "Hessian Dr","Hessian Hill Dr","Hessian Way","Hestand Ln","Hester Avenue","Hester St","Hester Way",
            "Hesters Store Rd","Heston Ave","Hetherington Crescent","Hethrow Ln","Hetzel Ave","Hetzel Ln",
            "Heverly","Heward Avenue","Hewes Circle","Hewins Street","Hewitt Ave","Hewitt Crescent","Hewitt Ct",
            "Hewitt Dr","Hewitt Pl","Hewitt St","Hewlett Rd","Hewlett St","Hewlitt and Sturtevan Rd",
            "Hey Hoe Woods Rd","Heyden Lake Road","Heydenreich St","Heyer","Heyer Ln","Heyer St","Heyer Way",
            "Heyneman Ln","Heynen Rd","Heyward Hills Dr","Heywood St","Heywood Street","Hi Ct","Hi Geer Dr",
            "Hi Ho Ridge Rd","Hi Mount Cir","Hi Mountain Lookout Rd","Hi Point Dr","Hi Valley Rd",
            "Hi View Dr","Hi View Rd","Hi-Lea Farn Rd","Hi-Low Rd","Hialeah Dr","Hialiah Ave","Hiawatha Ave",
            "Hiawatha Avenue","Hiawatha Cir","Hiawatha Dr","Hiawatha Line","Hiawatha Ln","Hiawatha Pl",
            "Hiawatha St","Hiawatha Trl","Hiawatha Way","Hibanks Rd","Hibbard Ave","Hibbard Road","Hibbard Road Extended N",
            "Hibbards Way","Hibben Pl","Hibiscus Avenue","Hibiscus Court","Hick's Bend","Hickery Rd",
            "Hickey Creek Truck Trail","Hickey St","Hickling Trail","Hickman Ave","Hickman Dr","Hickman Ln",
            "Hickman Rd","Hickock Ct","Hickory","Hickory Ave","Hickory Avenue","Hickory Brg","Hickory Cir",
            "Hickory Court","Hickory Creek Dr","Hickory Crest Dr","Hickory Crest Dr S","Hickory Ct",
            "Hickory Cut Dr","Hickory Dr","Hickory Drive","Hickory Estates Dr","Hickory Grove","Hickory Grove Cir",
            "Hickory Grove Rd","Hickory Grove Rd N","Hickory Head Rd","Hickory Hill Dr","Hickory Hill Ln",
            "Hickory Hill Mhp","Hickory Hill Rd","Hickory Lane","Hickory Ln","Hickory Ln E","Hickory Ln W",
            "Hickory Point Dr","Hickory Rd","Hickory Ridge","Hickory Road","Hickory Run Rd","Hickory Shade Cv",
            "Hickory St","Hickory Ter","Hickory Tree Ln","Hickory Trl","Hickory Way","Hickory Wood Ln",
            "Hickox Rd","Hicks","Hicks Ave","Hicks Cyn Rd","Hicks Dr","Hicks Ln","Hicks Pl NW","Hicks Rd","Hicks Ridge Rd",
            "Hicks St","Hicks Street","Hicky Cv","Hicky St","Hidalgo Dr","Hidalgo Ln","Hidalgo Rd NW","Hidden Acres Rd",
            "Hidden Ark Rd","Hidden Beaches Dr","Hidden Brook Dr","Hidden Brook Rd","Hidden Canyon Rd",
            "Hidden Cove Cir","Hidden Cove Court","Hidden Cove Ln","Hidden Creek Dr","Hidden Ct","Hidden Dr",
            "Hidden Falls Rd","Hidden Falls Way","Hidden Forest Ct","Hidden Glen","Hidden Glen Ct",
            "Hidden Hill Ln","Hidden Hill Rd","Hidden Hills Dr","Hidden Hills Ranch Rd","Hidden Hills Rd",
            "Hidden Hollow","Hidden Hollow Ct","Hidden Hollow Dr","Hidden Hollow Way","Hidden Hollows Rd",
            "Hidden Knoll Ct","Hidden Lake Cir","Hidden Lake Cv","Hidden Lake Trl","Hidden Lakes",
            "Hidden Ledge Rd","Hidden Lk Dr","Hidden Ln","Hidden Meadow","Hidden Meadow Dr","Hidden Meadows Dr",
            "Hidden Mesa Ct","Hidden Mountain Rd","Hidden Oaks Dr","Hidden Oasis Ct","Hidden Pond Ct",
            "Hidden Rd","Hidden Ridge","Hidden River Rd","Hidden Sands Ct","Hidden Springs Rd","Hidden Valley",
            "Hidden Valley Dr","Hidden Valley Ln","Hidden Valley Rd","Hidden Valley Trl","Hidden Valley to Minaret Connector",
            "Hidden View St NW","Hidden Walk Ln","Hidden Wood Dr","Hiddenvalley Rd","Hideaway Dr",
            "Hideaway Lakes","Hideaway Lane","Hideaway Ln","Hifi Ln","Higbee Ln","Higbee St","Higgins Ave",
            "Higgins Cemetery","Higgins Circle","Higgins Crowell Road","Higgins Dr","Higgins Rd","Higgins Street",
            "Higginsville Rd","High Breeze Ct","High Bridge Spur Rd","High Ct","High Desert Rd","High Feather",
            "High Glade Rd","High Grove Rd","High Lake Rd","High Land Rd","High Loop Dr","High Loop Rd",
            "High Manor Dr","High Meadow Ct","High Meadow Rd","High Meadow Way","High Mesa Rd","High Mountain Ln",
            "High Mountain Lookout Rd","High Mountain Road","High Noon Way","High Oaks Dr","High Path Road",
            "High Pine Dr","High Pine Way","High Plains Ln","High Point Cir","High Point Courts","High Point Cv",
            "High Point Dr","High Point Park","High Point Pl","High Point Rd","High Point Trl","High Pond Rd",
            "High Rd","High Ridge Dr","High Ridge Rd","High Rock Dr","High School Hill","High School Ln",
            "High School Rd","High School St","High School Trail","High St","High St E","High St NE",
            "High St SE","High St W","High Street","High Street - Morrisburg","High Street Place",
            "High Street W","High Tech Road","High Trees Dr","High Valley Rd","High View Ct","High View Rd",
            "High View St","Higham Ave","Highbank Road","Highboy Ct","Highbridge Rd","Highbridge Road",
            "Highbrush Ct","Highbury Road","Highcastl Avenue","Highcliff Ct","Highcliffe Drive","Highcrest Ct",
            "Highcrest Road","Highcroft Road","Highdale St","Highfield Avenue","Highfield Ct","Highfield Ln",
            "Highfield Rd","Highfield Road","Highgate Ln","Highgate Street","Highglen Avenue","Highgrade Rd",
            "Highgrove Rd","Highhill Drive","Highland Ave","Highland Ave SE","Highland Avenue","Highland Blvd",
            "Highland Circle","Highland Creek Overpass","Highland Cross","Highland Ct","Highland Ct SW",
            "Highland Dr","Highland Dr W","Highland Drive","Highland Farms Dr","Highland Forest Dr",
            "Highland Forrest Rd","Highland Heights Drive","Highland Hills Dr","Highland Hills Rd",
            "Highland Lakes Rd","Highland Line","Highland Ln","Highland Oaks","Highland Park Cir SE",
            "Highland Park Dr","Highland Park Drive","Highland Park Rd","Highland Pky S","Highland Pl",
            "Highland Place","Highland Rd","Highland Road","Highland St","Highland Street","Highland Ter",
            "Highland Trails Ave","Highland View Cir E","Highland View Glen","Highlander Ave SW",
            "Highlands Blvd","Highlands Cres","Highlands Park Dr","Highlands Ranch Pl","Highlands Rd",
            "Highlawn Ave","Highlawn Pl","Highline Ave","Highline Rd","Highmeadow Ct","Highmeadow Dr",
            "Highmount Rd","Highnoon St","Highpark Pl","Highpoint Turn","Highridge Court","Highridge Dr",
            "Highridge Road","Hight St","Hightstown Byp","Highvale Lane","Highview Ave","Highview Cir",
            "Highview Ct","Highview Dr","Highview Ln","Highview Pl","Highview Rd","Highview St","Highway 1",
            "Highway 11","Highway 11 North","Highway 11 South","Highway 11 north ramp","Highway 115",
            "Highway 12","Highway 12 (Trans-Canada)","Highway 140","Highway 15","Highway 16","Highway 161 N",
            "Highway 168","Highway 177 S","Highway 20","Highway 203","Highway 22","Highway 244 N","Highway 26 W",
            "Highway 263","Highway 27","Highway 28","Highway 289","Highway 2A","Highway 2A/Lawson Road/Kingston Road Access",
            "Highway 306","Highway 32 Central","Highway 322","Highway 35/115","Highway 36","Highway 37 W",
            "Highway 376 N","Highway 38","Highway 4","Highway 40 E; State Route 343","Highway 400",
            "Highway 400 (Trans-Canada)","Highway 400 South - Toronto","Highway 401","Highway 401 - Toronto (Airport)",
            "Highway 401 - through traffic only","Highway 401 Collector","Highway 401 East via 409",
            "Highway 401 Eastbound","Highway 401 Exit","Highway 401 Exit 613","Highway 401 Express",
            "Highway 401 Westbound","Highway 403","Highway 403 Collectors","Highway 403 Express",
            "Highway 403 West - Hamilton","Highway 404","Highway 404 / Newmarket","Highway 404 / Sheppard Avenue",
            "Highway 404 Collectors","Highway 404 Northbound","Highway 404 Southbound","Highway 406",
            "Highway 407","Highway 407 Westbound","Highway 409","Highway 409 (to 401 East)","Highway 409 (to 427, 401)",
            "Highway 41","Highway 410","Highway 410 / Highway 403","Highway 410 North","Highway 410 Northbound / Brampton",
            "Highway 410 South","Highway 420","Highway 427","Highway 427 (no access to QEW Hamilton)",
            "Highway 427 Collector","Highway 427 Express","Highway 427 North","Highway 427 North off ramp",
            "Highway 427 Northbound","Highway 440","Highway 478","Highway 48","Highway 485","Highway 567",
            "Highway 58","Highway 6 W","Highway 62","Highway 62 E","Highway 63 S","Highway 7","Highway 7/115 (Trans-Canada)",
            "Highway 7/115 southwest (Trans-Canada)","Highway 78","Highway 89 NW","Highway 9",
            "Highway Department","Highway Dept","Highway Dr W","Highway M35","Highway QEW","Highway Rd",
            "Highwood Ave","Highwood Ct","Highwood Dr","Highwood Rd","Highwood Ter","Highwood Way","Higley Rd",
            "Higman Ave","Higuera Ave","Hihn Rd","Hike-Bike Trail","Hiking Trl","Hil Ray Ave","Hilary Ave",
            "Hilary Ct","Hilbert Dr","Hilda Avenue","Hilda Benscoter Rd","Hilda Ln","Hilda St","Hilda Ter",
            "Hilda Way","Hildreth Ave","Hildreth St","Hildreth Street","Hile Rd","Hiley Ave","Hiley Avenue",
            "Hilfiker Ln","Hill","Hill Ave","Hill Avenue","Hill Bridge Dr","Hill Cir N","Hill Creek Road",
            "Hill Crescent","Hill Crest","Hill Crest Ln","Hill Dr","Hill Edge","Hill Hollow Road","Hill Ln",
            "Hill N Dale Dr","Hill Pl","Hill Pl N","Hill Place Dr","Hill Pond Ln","Hill Province Road",
            "Hill Ranch Rd","Hill Rd","Hill Road","Hill St","Hill Street","Hill Top Rd","Hill Top Trail",
            "Hill Valley Cemetery Rd","Hill Valley Rd","Hillaire Pl","Hillandale Ln","Hillando Drive",
            "Hillary Ct","Hillbilly Rd","Hillborn Ct","Hillbrook Ct","Hillburn Rd","Hillbury Drive","Hillcrest",
            "Hillcrest Ave","Hillcrest Avenue","Hillcrest Cir","Hillcrest Cmn","Hillcrest Ct","Hillcrest Dr",
            "Hillcrest Dr NE","Hillcrest Drive","Hillcrest Drive Number One","Hillcrest Estates Trl",
            "Hillcrest Lenape Ave","Hillcrest Ln","Hillcrest Manor Ct","Hillcrest Meadow","Hillcrest Rd",
            "Hillcrest Road","Hillcrest St","Hillcrest Street","Hillcrest Ter","Hillcrest Trl","Hillcroft Dr",
            "Hillcroft Drive","Hillcroft Street","Hillcroft Way","Hilldale Ct","Hilldale Rd","Hilldan St",
            "Hilldowntree Road","Hillel Ct","Hillel Place","Hiller Avenue","Hiller Rd","Hiller St","Hillery Ave",
            "Hillgrove Pl","Hillhaven Dr","Hillhaven Rd","Hillholm Boulevard","Hillhurst Ave","Hillhurst Drive",
            "Hilliard Ave","Hilliard Street","Hilliker Ln","Hillman Airport","Hillman Dr","Hillman Pl",
            "Hillman Street","Hillmont Ln","Hillmont Pl","Hillock Dr","Hillock Meadows Dr","Hillridge St",
            "Hillriegel Dr","Hills Ave","Hills Rd","Hillsaale St","Hillsboro Ave N","Hillsboro Ave SE",
            "Hillsboro Ct","Hillsboro Dr","Hillsborough","Hillsborough Rd No 1","Hillscrest Rd","Hillsdale Ave",
            "Hillsdale Avenue","Hillsdale Avenue East","Hillsdale Avenue West","Hillsdale Ct","Hillsdale Rd",
            "Hillsdale St","Hillsedge S","Hillsford Court","Hillside Ave","Hillside Ave S","Hillside Avenue",
            "Hillside Ct","Hillside Dr","Hillside Drive","Hillside Haven Rd","Hillside Homes","Hillside Ln",
            "Hillside Pathway","Hillside Pl","Hillside Pl SW","Hillside Rd","Hillside Road","Hillside St",
            "Hillside Street","Hillside Ter","Hillside Ter E","Hillside Trail Drive","Hillside Way",
            "Hillswick Cir","Hillswick Ln","Hillton Rd","Hilltop","Hilltop Ave","Hilltop Boulevard","Hilltop Climb Dr",
            "Hilltop Ct","Hilltop Dr","Hilltop Drive","Hilltop Ln","Hilltop Pl NE","Hilltop Rd","Hilltop Road",
            "Hilltop St","Hilltop St SW","Hilltop Street","Hilltop Ter","Hilltop Way","Hillvale Dr","Hillview Ave",
            "Hillview Cir","Hillview Dr","Hillview Dr NW","Hillview Drive","Hillview Lane","Hillview Pl",
            "Hillview Rd","Hillview Road","Hillview Ter","Hillview Way","Hillway Dr","Hillwood Street",
            "Hilly's Ln","Hillyer Dr","Hilo Ave","Hilo Cir","Hilt Rd","Hilt-Hungry Rd","Hilton Ave NW","Hilton Ct",
            "Hilton Dr","Hilton Head Ct","Hilton Heights Rd S","Hilton Pl","Hilton St","Hilton Street",
            "Hilton's Point Road W","Hiltonville Rd","Hinchinbrooke Road","Hinckley Ct","Hinckley Ln",
            "Hind Cir","Hinde Ave","Hinderer Ave SW","Hindhead Road","Hindman Rd","Hinds Ave","Hinds Rd",
            "Hindu Cir","Hine Rd","Hine St","Hines Rd","Hinesburg Rd","Hingham Avenue","Hingham Cv","Hingham Ln",
            "Hingham Street","Hinkle Ln","Hinkle St","Hinkley Ln","Hinman Rd","Hinman St","Hinmin Rd","Hinnen Ave",
            "Hinsdale Ave","Hinsdale Dr","Hinsdale Rd","Hinsdale Road","Hinsdale St","Hinsley St","Hinson Rd",
            "Hinson St","Hinton Ave","Hinton Hill Rd","Hinton St","Hiram Rd","Hiram Road","Hiram St","Hirams Ln",
            "Hircock Road","Hirliman Rd","Hiroshima St","Hirz Mtn Rd","Hiscock Boulevard","Hiscocks Road",
            "Historic Legacy Ct","Historic Rte 66","History Ln","Histric Dam Tr","Hitch Blvd","Hitchcock Dr",
            "Hitchcock Ln","Hitchcock Rd","Hitchcock St","Hitchen Post Dr","Hitching Post Bln","Hitching Post Dr",
            "Hitching Post Road","Hite Ct","Hite Ln","Hittle Creek Dr","Hitty Rd","Hivilies Dr","Hiwasse Rd",
            "Hiwassee Ter","Hix Ct","Hixon St","Hllswick Ln","Hoadley Ter","Hoag Rd","Hoagland Ct","Hoagland Rd",
            "Hoards Road","Hobart Ave","Hobart Ct","Hobart Pl","Hobart Rd","Hobart Road","Hobart St","Hobbes Ct",
            "Hobbit Ct","Hobble Bush Dr","Hobbs Ct","Hobbs Hwy S","Hobbs Rd","Hobbs Road","Hobby Horse Rd",
            "Hobdy St Ln","Hobe St","Hoben Rd","Hoblitt Ave","Hobnail Ct","Hobson Ave","Hobson Ct","Hobson St",
            "Hobson Street","Hoch Trl","Hockanum Dr","Hockanum Road","Hockeborne Ave","Hocker Rd","Hockney St",
            "Hoda Pl","Hode St","Hodecker Parkway","Hodencamp Rd","Hodge Creek Rd","Hodge Ct","Hodge Rd",
            "Hodges Hill Dr","Hodges Ln","Hodges St","Hoe Rd","Hoedown Rd","Hoehn Ln","Hoelscher Ln","Hoeltzer St",
            "Hoes Hill Rd","Hoey Ave","Hoff St","Hoffecker Hill Rd","Hoffman Ave","Hoffman Court","Hoffman Ct",
            "Hoffman Dr","Hoffman Ln","Hoffman Pl","Hoffman Rd","Hoffmeister Ln","Hofmann Avenue","Hog Mtn Fire Road",
            "Hog Tommy Rd","Hog Wallow Rd","Hogan Ct","Hogan Dr","Hogan Way","Hogan's Alley","Hogback Irrigation Canal B Lin",
            "Hogback Rd","Hogback Ridge Rd","Hogenmiller Cir","Hogfoot Rd","Hoggs Lane","Hogs Back Rd",
            "Hogsback Rd","Hogue Ave","Hogue Rd","Hohenthal St","Hohman Dr","Hoiland Rd","Hoiles Dr","Hoisington Rd",
            "Hoit Tower Dr","Holancin Road","Holborne Avenue","Holbourne Road","Holbrook Aly","Holbrook Dr",
            "Holbrook Rd","Holbrook Terrace","Holbrooke St","Holburn Ln","Holcher Ln","Holcomb Ave","Holcomb Dr",
            "Holcombs Rd","Holdcroft Ln","Holden Ave","Holden Cir","Holden Dr","Holden Ln","Holden Rd","Holden Road",
            "Holden St","Holden Street","Holder St","Holderness Rd","Holdridge St","Holdrum Ct","Holdsworth Ct",
            "Holdsworth Way","Hole in the Ground","Holgar Ln","Holgate Ave","Holgate Rd","Holiday Ave",
            "Holiday Bend St","Holiday Cir","Holiday Cir S","Holiday Ct","Holiday Ct NE","Holiday Dr",
            "Holiday Hill Rd","Holiday Ln","Holiday Pl","Holiday Plaza","Holiday Rd","Holiday Shore Dr",
            "Holiday Shores Rd","Holiday St","Holiday Way","Holita Road","Holla Bend River Rd","Holland Aly",
            "Holland Ave","Holland Ave NE","Holland Dr","Holland East Brimfield Road","Holland Glenwood Rd",
            "Holland Lake Rd","Holland Rd","Holland St","Holland Street","Hollenbeck Ave","Holley Avenue",
            "Holley Farm Rd","Holley Mill Rd","Holley Rd","Holley St","Holley Xing","Holli Loop","Holliday Drive",
            "Hollifield Ln","Holliman Lane","Hollingham Road","Hollings St","Hollingston Pl","Hollingswood Cir",
            "Hollington Crescent","Hollis Avenue","Hollis Johnson Tr","Hollis St","Hollis Street",
            "Hollison Dr","Hollister Ave","Hollister Ct","Hollister Rd","Hollister Road","Hollister St",
            "Holloman Ln","Hollow Brook Cir","Hollow Brook Dr","Hollow Brook Rd","Hollow Cres","Hollow Ct",
            "Hollow Dr","Hollow Haven Ln","Hollow Hill Ln","Hollow Horn Rd","Hollow Ln","Hollow Oak Dr",
            "Hollow Oak Ln","Hollow Rd","Hollow Road","Hollow Rock Ct","Hollow Springs Dr","Hollow Tree Dr",
            "Hollow Wharf Dr","Holloway Ave","Holloway Dr","Holloway Ln","Holloway Rd","Hollowcrest Rd",
            "Hollowell Way","Hollowview Road","Hollweg St","Holly","Holly Ave","Holly Cir","Holly Court",
            "Holly Creek Rd","Holly Ct","Holly Dell Ct","Holly Dr","Holly Drive","Holly Fernway","Holly Glen Rd",
            "Holly Glenn Way","Holly Grove Rd","Holly Grove-Meeks Rd","Holly Hill Ave","Holly Hill Ct",
            "Holly Hill Ln","Holly Hts","Holly Jill Ln","Holly Lane","Holly Ln","Holly Oak Dr","Holly Pl",
            "Holly Rd","Holly Rd SW","Holly St","Holly Tree Ln","Holly Vista Blvd","Holly Way","Holly Winn Ln",
            "Holly Woods Dr","Hollyberry Trail","Hollybrook Ave","Hollybrook Crescent","Hollybrook Dr",
            "Hollybrook Dr S","Hollyhock Dr","Hollyhock Ln","Hollyhock Street","Hollyoak St","Hollyridge Cir",
            "Hollyrood Avenue","Hollyview St NE","Hollywood Ave","Hollywood Avenue","Hollywood Blvd",
            "Hollywood Boulevard","Hollywood Dr","Hollywood Drive","Hollywood Freeway","Hollywood Ln",
            "Hollywood Rd","Hollywood St NE","Holm Crescent","Holman Ave","Holman City Rd","Holman Creek",
            "Holman Crescent","Holmcrest Rd","Holmdel Rd","Holmer Ln","Holmes Ave","Holmes Avenue","Holmes Brook Ave",
            "Holmes Cir","Holmes Ct","Holmes Dr NW","Holmes Hwy","Holmes Ln","Holmes Rd","Holmes Road","Holmes Sabatini Way",
            "Holmes St","Holmes Street","Holmes Ter","Holmesville Rd","Holmur Dr","Holsby Crescent","Holser Canyon Rd",
            "Holsome Rd","Holste Ave","Holstein Pl","Holsworthy Crescent","Holt Ave","Holt Ct","Holt Pl",
            "Holt Rd","Holt Road","Holt St","Holtby Street","Holten Ave","Holton Park","Holton St","Holtshire Road",
            "Holtz Hollow","Holven Ct","Holway St","Holy Cross Circle","Holy Oak St","Holyoake Crescent",
            "Holyoke Ave","Holyoke Ct","Holyoke Pl","Holyrood Dr","Homage Way","Homan Ct","Homberg Pl","Hombre Ln",
            "Home Acres Ave","Home Ave","Home Creek Ln","Home Gardens Dr","Home Meadows Lane","Home Pl",
            "Home Place Rd","Home St","Home Street","Homecrest Avenue","Homeplace Rd","Homer Ave","Homer Hansens Private Rd",
            "Homer Ln","Homer Rd","Homer St","Homer Street","Homestead","Homestead Ave","Homestead Ct","Homestead Dr",
            "Homestead Drive","Homestead Ln","Homestead Loop Rd","Homestead Park Dr","Homestead Pl",
            "Homestead Rd","Homestead Road","Homestead St","Hometeam St","Homeview Ct","Homewood Ave",
            "Homewood Avenue","Homewood Ct","Homewood Dr","Homeworth Dr","Hommann Ave","Homoa Ct","Hon Bottom Co",
            "Honan St","Honda Cyn Rd","Honda Way","Honduras Rd","Honeoye Creekside Mobile Home","Hones Hill",
            "Honey Bee Way","Honey Creek Rd","Honey Ct","Honey Girl Pl","Honey Harbour Road","Honey Hill",
            "Honey Hill Dr","Honey Jones Creek Rd","Honey Ln","Honey Locust Court","Honey Locust Ln SE",
            "Honey Road","Honey Run Rd","Honey Suckle","Honey Suckle Ln","Honey Tree Dr","Honeybee Ct",
            "Honeycomb Path","Honeylocust Ct","Honeysuckle Avenue","Honeysuckle Cir","Honeysuckle Ct",
            "Honeysuckle Dr","Honeysuckle Ln","Honeysuckle Rd","Honeysuckle Run","Honeysuckle Way",
            "Honeyville Rd","Honeywell Dr","Honeywell Drive","Honeywood Crescent","Hong Kong St","Honolulu Cv",
            "Honors Cir","Honsberger Avenue","Honson Dr","Hoo-Koo-E-Koo Trail","Hoochaneetsa Blvd",
            "Hoochaneetsa Plaza South","Hood Aly","Hood Ave","Hood Mesa Trl","Hood Rd","Hood St","Hoodgate Drive",
            "Hoods Point Way","Hook Ave","Hook Mt Ln","Hook Rd","Hook Street","Hooker Avenue","Hooker Creek Rd",
            "Hooker Dr","Hooker St","Hooks Ln","Hooks Rd","Hooksett Rd","Hoopa Cir","Hoopa Dr","Hooper Ave",
            "Hooper Ct","Hooper Farm Road","Hooper Hill Rd","Hooper Ln","Hooper Rd","Hooper St","Hooper Street",
            "Hoosac Road","Hoosac Street","Hoosier Valley Rd","Hoot Owl Ln","Hoot Owl Ter","Hootenanny Ln",
            "Hooton Drive","Hooven Rd","Hoover Ave","Hoover Avenue","Hoover Ct","Hoover Dr","Hoover Drive",
            "Hoover Park Drive","Hoover Pl","Hoover Rd","Hoover St","Hoover Way","Hooverton Pl","Hopal Ln",
            "Hopatcong Ave","Hopcroft Road","Hope Ave","Hope Ave W","Hope Avenue","Hope Chapel Rd","Hope Circle",
            "Hope Crossing Rd","Hope Farms Rd","Hope Hwy","Hope Ln","Hope Mtn Rd","Hope Rd","Hope Rd NW",
            "Hope Square Apartment","Hope St","Hope Street","Hope Street S","Hope View St","Hope-Johnsonburg Rd",
            "Hopedale Street","Hopeland Ave","Hopeman Ln","Hopestill Street","Hopewell Dr","Hopewell Rd",
            "Hopewell Road","Hopewell St","Hopewell Way","Hopi Cir","Hopi Dr","Hopi Rd","Hopi Rd NE","Hopi Trl",
            "Hopkins Avenue","Hopkins Dr","Hopkins Ln","Hopkins Pl","Hopkins Rd","Hopkins Road","Hopkins St",
            "Hopkins Street","Hopkinson Pl","Hopkinson St","Hopler Pl","Hopmeadow Rd","Hoppe Rd","Hopper Ave",
            "Hopper Rd","Hopper St","Hoppington Avenue","Hopsage Ct","Hopson Ln","Hopson Rd","Hoptree Dr",
            "Hopyard Rd","Horace Ct","Horace Harding Expressway","Horace Mann Ave","Horace Rd","Horacio Pl NE",
            "Horan Rd","Horan St","Horatio St","Horfield Avenue","Horizon Cir","Horizon Ct","Horizon Dr",
            "Horizon Rd","Horizon Ter","Horizon Vista Bld","Horley Ave","Horn Ctf","Horn Dr","Horn Rd","Horn St",
            "Horn Street","Hornada Trl","Hornak Drive","Hornbeam Way","Hornbeck Pl","Horne St","Horne Street",
            "Horne Trl","Horned Toad","Horner Ave","Horner Avenue","Horner Court","Horner Ln","Horner St",
            "Hornet Ave","Hornet Ln","Horniday Dr","Hornig Rd","Hornitos Rd","Hornsby Ave","Hornshill Drive",
            "Hornyak St","Horrigan Avenue","Horrigan Ln","Horrocks St","Horse","Horse Back Cir","Horse Canyon Rd",
            "Horse Creek","Horse Creek Ln","Horse Creek Rd","Horse Dr","Horse Linto Rd","Horse Mesa Rd",
            "Horse Mill Hill Rd","Horse Ranch Rd","Horse Run","Horse Shoe Dr","Horse Shoe Loop","Horse Shoe Pass",
            "Horse Show Way","Horse Springs Rd","Horse Thief Bay Road","Horse Trail Rd","Horse and Cattle Camp Loop Rd",
            "Horsechestnut Rd","Horsedreamer Lane","Horseley Hill Drive","Horseneck Road","Horseshoe Bay Road",
            "Horseshoe Bend Rd","Horseshoe Cir","Horseshoe Circle","Horseshoe Ct","Horseshoe Hill Rd",
            "Horseshoe Lake Rd","Horseshoe Ln","Horseshoe Ln S","Horseshoe Loop","Horseshoe Spring Rd",
            "Horseshoe Trl SE","Horseshoe Way","Horseshoebend Rd","Horsfall Rd","Horstman Ln","Horton Ave",
            "Horton Beach Rd","Horton Cir","Horton Farm Rd","Horton Ln NW","Horton Rd","Horton St","Horton St NE",
            "Horton Street","Hortop Street","Hory St","Hosier Rd","Hoskier Rd","Hosking Pl","Hoskins St",
            "Hoskyn Rd","Hosman Ln","Hosmer Circle","Hosper Rd","Hospital Dr","Hospital Drive","Hospital Loop",
            "Hospital Plz","Hospital Rd","Hospital St","Hospitality Center Way","Hospitality Cir",
            "Hossack Dr","Hostetter Rd","Hot Spring Road","Hot Springs Ct","Hot Springs Mountain Dr",
            "Hotaling Ct","Hotchkin Rd","Hotchkiss Avenue","Hotchkiss Dr","Hotchkiss Road","Hotel Ave NE",
            "Hotel Ln","Hotel Place","Hotel Rio Dr","Hotel Road","Hotel St","Houck Rd","Houdaille Rd","Hough Rd",
            "Hough Road","Houghton Hill Rd","Houghton Lane","Houghton Ln","Houghton Pl","Houghton Rd",
            "Houghton St","Houghton Street","Houle Dr","Houle St","Houlihan Ave","Houma St","Hounsfield St",
            "Hourigan Rd","House Drive","House Rd","House Road 550","House Wren Rd","Houseman Lake Dr",
            "Houses Corner Rd","Housing Authority Driveway","Houssell CT","Housten Ct","Houston","Houston Ave",
            "Houston Avenue","Houston County 75","Houston County 8","Houston Cts","Houston Dr","Houston Rd",
            "Houston Road","Houston St","Hout Cir","Houtz Ave SE","Hovey Ln","Hovey St","Hovey Way","Hovick Rd",
            "Hoviland Ln","Hovnania Blvd","Howard","Howard Ave","Howard Avenue","Howard Blvd","Howard Cir",
            "Howard Ct","Howard Hill Rd","Howard Jeffers Dr","Howard Ln","Howard Park Avenue","Howard Pl",
            "Howard Place","Howard Rd","Howard St","Howard Street","Howard Way","Howards Fork Dr","Howdee Rd",
            "Howe Avenue","Howe Brg","Howe Creek Rd","Howe Dr","Howe Lane","Howe Ln","Howe Rd","Howe St","Howell Ave",
            "Howell Cabin Dr","Howell Camp Rd","Howell Dr","Howell Rd","Howell St","Howes Road","Howland Ave",
            "Howland Avenue","Howland Pl","Howland Rd","Howland St","Howland Street","Howling Wolf Ln",
            "Howton Rd","Hoxie Ave","Hoxie Rd","Hoy Orchard Ct","Hoydale Row","Hoyle Drive","Hoyt Rd","Hoyt St",
            "Hozel St","Huachuco Pl","Hualapai Cir","Hualapai Dr","Hualapai Hilltop Hwy","Huasna Rd",
            "Huasna River Rd","Hub Cir","Hubbard Ct","Hubbard Hill Rd","Hubbard Pl","Hubbard Rd","Hubbard St",
            "Hubbard Way","Hubbardston Road","Hubbardton Rd","Hubbel Dr","Hubbell Rd","Hubbs Dr","Huber Ave",
            "Huber St","Hubert Ave","Hubert Dr","Hubert H Humphrey Dr","Huck Dr","Huckelberry Ln","Huckle Hill Road",
            "Huckleberry Ave","Huckleberry Cir","Huckleberry Ct","Huckleberry Ln","Huckleberry Rd",
            "Huckleberry Road West","Huckleberry Trl","Huckleberry Way","Huckols Rd","Huddersfield Drive",
            "Huddle Ave","Hudner Ln","Hudson Apartment","Hudson Ave","Hudson Avenue","Hudson Ct","Hudson Cv",
            "Hudson Dr","Hudson Drive","Hudson Heights","Hudson Manor Terrace","Hudson Pl","Hudson Rd",
            "Hudson River Waterfront Walkway","Hudson Road","Hudson St","Hudson Street","Hudson Ter",
            "Hudson View Rd","Hudson View Ter","Hudson Walk","Hudspeth St","Hueber Dr","Huested Ln","Huff Way",
            "Huffaker Rd","Huffman Ave","Huffman Ln","Huffman Rd","Huffs Island Road","Hufft St","Hugely Bridge Rd",
            "Hugh Ave","Hugh Cole Rd","Hugh J Posey Rd","Hugh St","Hugh Street","Hughes Ave","Hughes Crescent",
            "Hughes Dr","Hughes Park Drive","Hughes Pl","Hughes Rd","Hughes St","Hughes St NE","Hughes Street",
            "Hughey Creek","Hughey Meadows Cv","Hughey St","Hughs Way","Hugill Road","Hugo Ave","Hugo Lane",
            "Hugo Way","Huguley Rd","Hulaco Rd","Hulbert Road","Hulet St","Hulett Rd SW","Hulkonen Rd","Hull Ave",
            "Hull Ct","Hull Dr","Hull Mountain Rd","Hull Rd","Hull Street","Hullen Crescent","Hullmar Drive",
            "Hullsville Spur","Hulme St","Hulse Ave","Hulse Street","Hulseman St","Hulsey Branch Rd",
            "Hulsey Rd N","Hultberg Rd","Humaston St","Humber College Boulevard","Humber River Recreational Trail",
            "Humberhill Avenue","Humberline Drive","Humbert Ave","Humbert Ln","Humbert Rd","Humbert St",
            "Humbert Street","Humberto Way","Humble Wood","Humboldt St","Humboldt Street","Humboldt Way",
            "Humbolt Redwoods State Park","Humbolt Redwoods State Park Rd","Humbug Rd","Humbug Willow Creek Trail",
            "Humewood Drive","Humewood Gardens","Hummingbird Circle","Hummingbird Ct","Hummingbird Dr",
            "Hummingbird Lane","Hummingbird Ln","Hummingbird Mhp","Hummingbird Pl","Hummingbird Rd",
            "Hummingbird Trl","Hummingbird Way","Hummock Point Rd","Hummock Road","Humphrey Ave","Humphrey Ln",
            "Humphrey Rd","Humphrey St","Humphrey Street","Hun Rd","Hundred Oaks Dr","Hungary Valley Rd",
            "Hungerford Ave","Hungerford St","Hungerford Street","Hunnicut St","Hunsaker Dr","Hunsinger Rd",
            "Hunsley Lane","Hunt Ave","Hunt Avenue","Hunt Blvd","Hunt Cir","Hunt Club","Hunt Club Court",
            "Hunt Club Dr","Hunt Club Drive","Hunt Creek Rd","Hunt Ct","Hunt Dr","Hunt Ln","Hunt Pl","Hunt Rd",
            "Hunt Road","Hunt Shore S","Hunt Street","Hunt Valley Ln","Hunt Walk","Hunter","Hunter Ave",
            "Hunter Ave S","Hunter Avenue","Hunter Chaprl Rd","Hunter Ct","Hunter Ct SW","Hunter Dr",
            "Hunter Drive","Hunter Hill","Hunter Ln","Hunter Pl","Hunter Rd","Hunter Rd N","Hunter Road",
            "Hunter St","Hunter Street","Hunter Street W","Hunter Trl","Hunter's Hill Rd","Hunter's Way",
            "Hunterdon St","Hunterfly Pl","Hunters Creek Rd","Hunters Ct","Hunters Dr","Hunters Glen Dr",
            "Hunters Hill Trl","Hunters Inlet Rd","Hunters Ln","Hunters Mountain Pky","Hunters Path",
            "Hunters Point Avenue","Hunters Ridge","Hunters Run","Hunters Run South Rd","Hunters Run West",
            "Hunters Valley Way","Hunters Way","Hunting Club Rd","Hunting Hill Farm Dr","Hunting Hills Rd",
            "Hunting Street","Hunting Valley Rd","Huntingdale Boulevard","Huntingdon Ln","Huntington Ave",
            "Huntington Avenue","Huntington Ct","Huntington Dr","Huntington Hill","Huntington Hts",
            "Huntington Lake Rd","Huntington Lane","Huntington Ln","Huntington Park Drive","Huntington Pky",
            "Huntington Pl","Huntington Rd","Huntington Street","Huntington Ter","Huntington Tr","Huntington Village Ln",
            "Huntingwood Crescent","Huntingwood Drive","Huntleigh Rd","Huntley Dr","Huntley Ln","Huntley Rd",
            "Huntley St","Huntley Street","Huntress Avenue","Huntridge Ln","Hunts Pond Rd","Hunts Run Rd",
            "Huntsman Ave","Huntsmill Boulevard","Huntsmill Crescent","Huntsville Ave","Huntwood Ct",
            "Hupfield Trail","Hupp Rd","Huprick Rd","Hurd Ave","Hurd Rd","Hurd St","Hurdville Rd","Hurffville Rd",
            "Hurlburt St","Hurley Ave","Hurley Crescent","Hurley Ct","Hurley Street","Hurlock Ave","Hurlwood Lane",
            "Huron Ave","Huron Ct","Huron Ln","Huron Pl","Huron Rd","Huron River Dr","Huron River Shore Rd",
            "Huron St","Huron Street","Hurondale Dr","Huronia Road","Hurontario Street","Hurricane Cir",
            "Hurricane Creek Rd","Hurricane Rd","Hurricane Road","Hurricane Trl","Hurricane Valley Rd",
            "Hurrle Ave","Hurst Drive","Hurst Hammock Rd","Hurst Road","Hurst St","Hurstland Ave","Husbands Rd",
            "Huse Rd","Huskey Mountain Rd","Hussa Pl","Husted Landing Rd","Huston Rd","Huston St","Hutch Rd",
            "Hutchcroft Avenue","Hutchins Ave","Hutchins Dr","Hutchinson Ave","Hutchinson Dr","Hutchinson Road",
            "Hutchinson St","Hutchison Ln","Huth St","Hutson Dr","Hutton St","Hutton Street","Huttons Trl",
            "Huxley Drive","Huxley Rd","Huyck Ave","Huyler Rd","Hwy 395 - El Camino Sierra","Hwy 5 Byp",
            "Hyacinth Dr","Hyacinth Drive","Hyacinth Ln","Hyacinth Street","Hyacinthe Boulevard","Hyampom Rd",
            "Hyatt Ave","Hyatt Lane","Hyatt Ln","Hybrid Pl","Hyde Ave","Hyde Avenue","Hyde Park Avenue",
            "Hyde Park Cir","Hyde Park Dr","Hyde Park Drive","Hyde Pky","Hyde Place","Hyde Rd","Hyde St",
            "Hyde Street","Hyder St","Hydesville Rd","Hyers St","Hyknoll Rd","Hylan Blvd; W Fingerboard Rd; Hylan Blvd",
            "Hyland Court","Hyland Drive","Hyland Ln","Hyland Ridge Rd","Hyler Ct","Hyman Ave","Hymen Ct",
            "Hypine Road","Hyssop Path","Hystrix Plz","Hytech Dr","Hytrol St","I - 540","I 10","I 5","I 540","I 580",
            "I 605","I 680","I 710","I 780","I 80","I C","I D A Park North","I St","I St N","I Street","I Walk","I- 10 Service Road",
            "I- 17 Access Rd","I- 30 Service Road","I- 55 Access Rd","I-10","I-10 East / San Bernardino onramp",
            "I-10 El Monte Busway","I-10 HOV Ln","I-10 West onramp","I-15","I-15 S On-ramp","I-15 South / San Diego onramp",
            "I-17","I-19","I-19 (Bus)","I-195","I-20","I-205","I-215","I-215 Beltway","I-25","I-271","I-271 Express",
            "I-275","I-280","I-280 Eastbound","I-280 Westbound","I-287","I-287 Northbound","I-293","I-295",
            "I-295 link","I-30","I-359","I-380 East","I-384","I-390","I-393","I-40","I-40 and United States Highway 666",
            "I-475","I-495","I-5","I-5 (Scenic)","I-540","I-55","I-55; I-69","I-590","I-64","I-676","I-680","I-690","I-69; State Highway 304",
            "I-70","I-75","I-77","I-78","I-78 East","I-78 East Local Lanes","I-78 Eastbound","I-78 West","I-78 West Local Lanes",
            "I-78 Westbound","I-79","I-8","I-8 On-ramp","I-80","I-81","I-84","I-85","I-86","I-87","I-88","I-90","I-90 / NYS Thruway Eastbound",
            "I-90 / NYS Thruway Westbound","I-90 East","I-90 West","I-91","I-93","I-94","I.X.L. Road","Ian Avenue",
            "Ian MacDonald Boulevard","Ibapah Rd","Ibar Way","Ibbetson Crescent","Ibc","Iberville Road",
            "Ibex Ave","Ibey Court","Ibis Ct","Ibis Way","Ibm Pky E","Icarian Rd NE","Ice Box Canyon Ct",
            "Ice House Lane","Ice House Rd","Ice Pond Drive","Ice Road","Iceberg Canyon Dr","Icemeadow Ln",
            "Ichabod Dr","Ichabod Ln","Icicle Br","Ida Ave","Ida Beach Rd","Ida Dr","Ida Lindsey Dr","Ida Rd SW",
            "Ida Red Ln","Ida Russell Rd","Ida St","Ida State Line Rd","Ida Street","Ida Way","Idaho Ave",
            "Idaho Dr","Idaho Rd","Idaho Springs St","Idaho St","Idaho Way","Idalane St","Idalia Rd SW; Idalia Rd SE",
            "Ide Perrin Rd","Ideal Rd","Idle Lake Rd","Idle Ln","Idlebrook Ct","Idlehour Trail","Idleswift Drive",
            "Idlewild St","Idlewild Street","Idlewood Ave","Idlewood Blvd N","Idlewood Dr","Idlewood Rd",
            "Idus Dr","Idyllwild Cir","Idyllwood Crescent","Idylwild Rd","Idylwild St NE","Idylwood Court",
            "Ifield Road","Ignacio Ct","Igoe Road","Igoewood Dr","Iguana Cir","Ileen Dr","Ilene Ave","Ilex Cir NW",
            "Ilex Ln","Ilexberry Ln","Ilium Ct","Illiloutte Fall W","Illinois","Illinois Ave","Illinois Camp Rd",
            "Illinois St","Illinois St NW","Illinois Trl","Illman Dr","Imboden Rd","Imboden St","Imbrie Pl",
            "Imlay Pl","Immigrant Ravine","Imogene St","Impala Hills","Imperial Ave W","Imperial Dr",
            "Imperial Dr SW","Imperial Ln","Imperial St","Imperial Trl","Imperial Way","Imuris Ct","Imus Rd",
            "Imvite Rd","In06","In280","Ina Ct","Ina Road","Ina Street","Inamour Dr","Inaudi Ct","Inboard St",
            "Inca Pl","Inca Rd NE","Inca St NE","Inchcliffe Crescent","Incline Ct","Incline Village Ct",
            "Ind Rd 5035","Ind Sr 471","Ind Sr 9654","Ind St 482","Independence Ave","Independence Blvd",
            "Independence Ct","Independence Cv","Independence Dr","Independence Ln","Independence Rd",
            "Independence Sq","Independence Way","Index St","India Street","Indian","Indian Ar Road",
            "Indian Bend Ln","Indian Brook Dr","Indian Brook Road","Indian Cir","Indian Creek Dr",
            "Indian Creek Dr S","Indian Creek Rd","Indian Creek Trail","Indian Crest Cir","Indian Ct",
            "Indian Diggins Rd","Indian Dr","Indian Field Rd","Indian Grove","Indian Gulch","Indian Gulch Rd",
            "Indian Head Ranch Rd","Indian Head Rd","Indian Hill","Indian Hill Dr","Indian Hill Rd",
            "Indian Hills Ct","Indian Hills Dr","Indian Hollow Rd","Indian Joe Ln","Indian Knoll Rd",
            "Indian Lake Rd","Indian Lake Road","Indian Lookout Rd","Indian Mills Rd","Indian Oak Dr",
            "Indian Ocean Ave","Indian Pass Rd","Indian Path","Indian Peak Rd","Indian Pl NE","Indian Point",
            "Indian Ranch Road","Indian Road","Indian Rock Rd","Indian Route 102","Indian Route 118",
            "Indian Route 12","Indian Route 1230","Indian Route 181","Indian Route 2010","Indian Route 21",
            "Indian Route 213","Indian Route 215","Indian Route 30","Indian Route 333","Indian Route 34",
            "Indian Route 35","Indian Route 36","Indian Route 4","Indian Route 42","Indian Route 47",
            "Indian Route 5024","Indian Route 5035","Indian Route 5037","Indian Route 5040","Indian Route 5043",
            "Indian Route 5049","Indian Route 5060","Indian Route 582","Indian Route 59","Indian Route 6230",
            "Indian Route 6260","Indian Route 6321","Indian Route 6520","Indian Route 6620","Indian Route 6820",
            "Indian Route 6930","Indian Route 73","Indian Route 8066","Indian Route 8074","Indian Route 8076",
            "Indian Route 9001","Indian Route 9006","Indian Route 9051","Indian Route 9064","Indian Route 9073",
            "Indian Route 9201","Indian Route 9857","Indian Rte 17","Indian Rte 26","Indian Rte 5",
            "Indian Run","Indian Run Rd","Indian Scotty Campground Road","Indian Serv Rt 216","Indian Service Rd 38",
            "Indian Service Rd 7010","Indian Service Route 12","Indian Service Route 14","Indian Service Route 31",
            "Indian Service Route 36","Indian Service Route 5008","Indian Service Route 5013",
            "Indian Service Route 5020","Indian Service Route 7011","Indian Service Route 7049",
            "Indian Service Route 7053","Indian Service Route 7101","Indian Service Route 7140",
            "Indian Service Rt 130","Indian Service Rt 136","Indian Service Rt 14","Indian Service Rt 197",
            "Indian Service Rt 22","Indian Service Rt 26","Indian Service Rt 282","Indian Service Rt 291",
            "Indian Service Rt 31","Indian Service Rt 342","Indian Service Rt 35","Indian Service Rt 36",
            "Indian Service Rt 361","Indian Service Rt 45A","Indian Service Rt 47","Indian Service Rt 50",
            "Indian Service Rt 54","Indian Service Rt 541","Indian Service Rt 605","Indian Service Rt 625",
            "Indian Service Rt 7","Indian Service Rt 7000","Indian Service Rt 716","Indian Service Rt 74",
            "Indian Service Rt 76","Indian Service Rt 81","Indian Service Rt 852","Indian Service Rt 9",
            "Indian Service Rt 92","Indian Spring","Indian Spring Rd","Indian Spring St","Indian Springs Dr",
            "Indian Springs Ranch Rd","Indian Springs Rd","Indian Stream Rd","Indian Street","Indian Summer Dr",
            "Indian Trail","Indian Trail Rd","Indian Trl","Indian Valley Crescent","Indian Valley Rd",
            "Indian Village Dr","Indian Village Rd","Indian Way","Indian Wells Ave","Indian Wells Canyon Rd",
            "Indian Wells Ln","Indian Wells Rd","Indian Wells Trl","Indiana Ave","Indiana Ave NW",
            "Indiana Ct","Indiana East-West Toll Rd","Indiana Rd","Indiana St","Indiana Terrace","Indiana Way",
            "Indianola Way","Indians Rd","Indiantown Rd","Indigo Cmn","Indigo Dr NW","Indigo Hill Rd",
            "Indigo Hills Dr","Indigo Valley St","Indio Dr","Indio Way","Indore Ct NE","Indsr 471","Industrial W",
            "Industrial Blvd","Industrial Ct","Industrial Dr","Industrial Farm Rd","Industrial Hwy",
            "Industrial Park","Industrial Park Crescent","Industrial Park Dr","Industrial Park Rd",
            "Industrial Pk","Industrial Pky","Industrial Pky S","Industrial Pky SW","Industrial Rd",
            "Industrial St","Industrial Way","Industry Dr","Industry Street","Infantry Rd","Infield Avenue",
            "Infield Ln","Infrequently Maintained Trl","Inga Rd","Ingalls Rd","Ingalls St","Ingalls-Marsden Rd",
            "Ingate Pass","Ingate Rd","Ingell Street","Ingelside Drive","Ingenuity Ave","Ingersol Ave",
            "Ingersol Rd","Ingersoll Rd","Ingersoll St","Ingersoll Way","Ingerson Rd","Ingham Ave","Ingham Avenue",
            "Ingham Co Fairgrounds Srv Rd","Ingham Way","Ingle Rd","Ingle St","Inglehart Rd","Inglehart Road",
            "Ingleton Boulevard","Ingleton Dr","Inglewood Ave","Inglewood Blvd","Inglewood Dr","Inglewood Drive",
            "Inglewood Road","Inglewood Street","Inglis Court","Ingoldsby Road","Ingomar Dr","Ingomar St",
            "Ingraham Road","Ingraham St","Ingraham Ter","Ingram Ave","Ingram Dr","Ingram St","Ingulf St",
            "Inigo Way","Inkerman Street","Inkpen Lane","Inland Ct","Inland Dr","Inland Street","Inlet Bay Ave",
            "Inlet Cv","Inlet Ter","Inman Street","Inmon Rd","Inn Ln","Inn-D-Inn Ct","Inner Loop Expy","Innes Rd",
            "Inness Circle","Innis Ave","Innis Rd NW","Innisbrook Dr","Innisbrook Rd","Innisfil Beach Road",
            "Innisfil Beach Road","Innisfil Road","Innisfil Street","Innistree Place","Innkeeper Rd",
            "Innocent Way","Innsbruck Dr","Innsdale Ct","Insbrook Ct","Insbrook Dr","Inschno Rd","Inskeep Ct",
            "Inskip Rd","Inslee Pl","Inspiration Way","Insterstate 190 South","Institute St","Interlake Rd",
            "Interlaken Dr","Interlaken Road","Interlochen Pky","Intermediate Way W","International Dr",
            "International Pl","Interstate 15","Interstate 190","Interstate 190 North","Interstate 190 South",
            "Interstate 195","Interstate 215","Interstate 290","Interstate 290 Youngman Expressway",
            "Interstate 290; Youngman Expressway","Interstate 391","Interstate 395","Interstate 40",
            "Interstate 40; Historic Route 66","Interstate 495","Interstate 495 Sb Cd Road",
            "Interstate 515","Interstate 880 (North)","Interstate 91","Interstate 93","Interstate 93;New Hampshire Route 101",
            "Interstate 95 Connector","Interstate Dr","Interstate Highway 10","Interstate Highway 10; Papago Freeway",
            "Interstate Highway 10; United States Highway 180; United States Highway 85",
            "Interstate Highway 25","Interstate Highway 275","Interstate Highway 27; United States Highway 87",
            "Interstate Highway 29","Interstate Highway 30","Interstate Highway 390","Interstate Highway 390; Genesee Expy",
            "Interstate Highway 393 Westbound","Interstate Highway 40","Interstate Highway 430",
            "Interstate Highway 459","Interstate Highway 480","Interstate Highway 481","Interstate Highway 490",
            "Interstate Highway 5","Interstate Highway 530","Interstate Highway 565","Interstate Highway 59",
            "Interstate Highway 65","Interstate Highway 69","Interstate Highway 78 E","Interstate Highway 78 East",
            "Interstate Highway 78 West","Interstate Highway 81","Interstate Highway 84","Interstate Highway 86",
            "Interstate Highway 87","Interstate Highway 88","Interstate Highway 89","Interstate Highway 90",
            "Interstate Highway 90 / NYS Thruway","Interstate Highway 90; New York State Thruway",
            "Interstate Highway 91","Interstate Highway 990 Lockport Expressway","Interstate Highway I 290 Youngman Expressway",
            "Interurban Pathway","Intervale Pond Rd","Intervale Road","Intrepid Drive","Intruder Ave",
            "Inverary Drive","Inverdon Road","Invergarry","Inverhouse Drive","Inverness Close","Inverness Crescent",
            "Inverness Ct","Inverness Dr","Inverness Ln","Inverness Pky","Inverness Road","Inverrary Wy",
            "Inverray Pl","Investment St","Inwood Avenue","Inwood Ct","Inwood Dr","Inwood Ln","Inwood Pl",
            "Inwood Rd","Inyo Ct NE","Inyo Pl","Inyokern Rd","Ioka Dr NE","Iola Street","Iolanthus Ave",
            "Iona Ave","Iona Ct","Iona Dr","Iona Pl","Iona St","Ione St","Ionia Ave","Ionia St","Iota Pl","Iothian Dr",
            "Iowa","Iowa Ave","Iowa City Rd","Iowa St","Ipswitch Ct","Irbid Road NE","Irdell Ln","Irelan Ave",
            "Ireland St","Irena Road","Irene Ave","Irene Ave NE","Irene Avenue","Irene Blvd","Irene Cir",
            "Irene Ct","Irene Dr","Irene St","Irene Street","Irene T Jackson Rd","Ireson Street","Ireton Key",
            "Irick Rd","Iridescent Ave","Iriquois Way","Iris Ave","Iris Cir","Iris Ct","Iris Dr","Iris Lane",
            "Iris Ln","Iris Pl","Iris Rd","Iris Rd NW","Iris St","Iris Street","Irish Hill Rd","Irish Lake Ln",
            "Irish Line","Irish Ridge Rd","Irish Rose Drive","Irmac Court","Irman Woods Cir","Irmulco Rd",
            "Iron Bridge Rd","Iron Canyon Cv","Iron Cir","Iron Ct","Iron Dr","Iron Furnace Dr","Iron Gate Rd",
            "Iron Horse Avenue","Iron Horse Dr","Iron Horse Trail","Iron Mine Dr","Iron Mine Hill Rd",
            "Iron Mine Road","Iron Mountain Dr","Iron Mountain Rd","Iron Mtn Rd","Iron Oak Dr","Iron Pin Trl",
            "Iron Point Rd","Iron Springs Way","Iron Street","Iron Wolf Rd","Iron Wood Rd SE","Ironbridge Way",
            "Irondale Ave","Irondale Road","Irondequoit Blvd","Irone Pl","Ironia Rd","Irons St","Ironwood",
            "Ironwood Cir","Ironwood Ct","Ironwood Dr","Ironwood Ln","Ironwood Rd","Ironwood St","Ironwood Ter",
            "Ironwood Way","Iroquois","Iroquois Ave","Iroquois Avenue","Iroquois Cir","Iroquois Court",
            "Iroquois Creek","Iroquois Ct","Iroquois Dr","Iroquois Drive","Iroquois Pass","Iroquois Rd",
            "Iroquois Trl","Irven St","Irvin Ave","Irvin Rd","Irvin St","Irvine Mills Rd","Irvine Road",
            "Irvine Turner Blvd","Irving Ave","Irving Blvd","Irving Blvd NW","Irving Ct","Irving Dr",
            "Irving Drive","Irving Pl","Irving Road","Irving St","Irving St SE","Irving Street","Irvington Pl",
            "Irvon Trl","Irwin Avenue","Irwin Crescent","Irwin Ln","Irwin Pl NE","Irwin St","Irwin Street",
            "Irwin Way","Irwindale","Isaac Ct","Isaac Ln","Isaac Murray Avenue","Isabel Ave","Isabel Rd",
            "Isabel St","Isabella Ave","Isabella Avenue","Isabella Street","Isabelle Dr","Isabelle Street",
            "Isan Road 5","Isatis Ave","Isbell Rd","Isbell St","Isenhauer Rd","Isherwood Dr","Isherwood Way",
            "Ishi-Pishi Rd","Island","Island 37 Rd","Island 40 Rd","Island Ave","Island Branch Rd","Island Ct",
            "Island Dock Rd","Island Dr","Island Dreams Ave","Island Drive","Island Hill Rd","Island Park Drive - Iroquois",
            "Island Pl","Island Pond Rd","Island Pond Road","Island Rd","Island Road","Island Run","Island St",
            "Island View Dr","Island Way","Islandview Drive","Islandview Way","Isle Point Ct","Isle of Pnes",
            "Isleib Rd","Islesworth Ave","Isleta Boulevard SW","Islington Avenue","Islington St","Islington Street",
            "Ismay St","Isola","Issac Ct","Issac Ln","Issleib","Isthmus Rd","Iszard Rd","Italia Crescent","Italy St",
            "Italy Valley","Itasca Rd SE","Itasca St","Ithaca Ave","Ithaca Dr","Ithaca Rd","Ithaca St","Itham Ct",
            "Ithan Creek Rd","Ithan Woods Ln","Iva Fuller Rd","Iva Lake Road","Iva Street","Iva Way",
            "Ivadel Pl","Ivah Street","Ivan Ln","Ivan Pl","Ivan Road","Ivanhoe Dr","Ivanhoe Rd","Ivanhoe Road",
            "Ivanhoe Street","Ivanhoe Way","Ivanpah Cima Rd","Iverness St","Ivers Court","Iversen Rd",
            "Iverson Ct","Ives Ct","Ives Cv","Ives Dr","Ives Pl","Ives Rd","Ives St","Ivey Dr","Ivey Ln","Ivins Dr",
            "Ivins Ln","Ivins Rd","Ivjohaje Loop","Ivory Ave","Ivory Cir","Ivory Coast Dr","Ivory Pl","Ivory Tusk Court",
            "Ivsbridge Boulevard","Ivy","Ivy Arbor Ln","Ivy Ave","Ivy Avenue","Ivy Chase Cir","Ivy Cir",
            "Ivy Court","Ivy Ct","Ivy Dr","Ivy Ln","Ivy Ln E","Ivy Pl","Ivy Pl SW","Ivy Rd","Ivy Ridge Ct","Ivy St",
            "Ivy Stone Court","Ivy Trce","Ivy Trl","Ivy Way","Ivy Wood Dr","Ivygreen Road","Ivyhurst Cir",
            "Ivyhurst Rd","Izmir St","J","J 16","J 17","J 31","J Aday Rd","J B Williams Rd","J C Edmonston Cir",
            "J D Ranch - Mineral Spring","J D Ranch Mineral Spring Rd","J D Young Dr","J Dr","J F Blvd",
            "J F K Dr","J F Kennedy Blvd E","J Ln","J M Parker Ln","J O Torres Rd","J R Hollow Rd","J Rd",
            "J Roadway","J St","J T Polk Dr","J W P Ranch Rd","J W Williams Ln","J08","JACKRABBIT ST","JFK Expressway",
            "Jacaranda Drive","Jacaria Dr","Jacarilla Ln","Jacarillo Trl","Jacey Ct","Jach Ln","Jacinta Drive",
            "Jacintho Street","Jacinto Dr","Jack Creek Rd","Jack Ct","Jack Fleck Dr","Jack Lake Road",
            "Jack Ln","Jack London Ct","Jack Lunceford Dr","Jack O' Lantern Park","Jack Pine Ct","Jack Pine Dr",
            "Jack Pine Rd","Jack Rabbit Crescent","Jack Rabbit Run","Jack Shaw Rd","Jack Springs Rd",
            "Jack St","Jack Tar Ct","Jack Warner Pky","Jackal Trl","Jackalope Tr","Jackass Flats Rd",
            "Jackass Ridge Rd","Jackes Avenue","Jackhammer Dr","Jackie Avenue","Jackie Dr","Jackie Lane",
            "Jackies Rd","Jackman Ridge Rd","Jackman St","Jackpine Plains Rd","Jackrabbit Rd","Jacks Blvd",
            "Jacks Ln","Jacksboro Dr","Jackson","Jackson NW","Jackson 102","Jackson 19","Jackson 197","Jackson 2",
            "Jackson 306","Jackson 318","Jackson 330","Jackson 50","Jackson 58","Jackson 620","Jackson 66",
            "Jackson 919","Jackson Ave","Jackson Avenue","Jackson Cir","Jackson Co Rd 133","Jackson County 1155",
            "Jackson Creek Rd","Jackson Cty Rd 609","Jackson Dr","Jackson Heights","Jackson Hill Road",
            "Jackson Hole Rd","Jackson Ln","Jackson Meadows Rd","Jackson Pl","Jackson Point Rd","Jackson Rd",
            "Jackson Road","Jackson Road 1125","Jackson Road 1155","Jackson Run Rd","Jackson Schoolhouse Rd",
            "Jackson Sisters Rd","Jackson St","Jackson Street","Jackson Terrace","Jackson Valley Rd",
            "Jackson Wash","Jackson Way","Jacksonville Stage Road","Jacksonville-Cato Rd","Jacktown Rd",
            "Jacmacia St","Jacob Ave","Jacob Ct","Jacob Dekema Fwy","Jacob Dr","Jacob Fisher Avenue",
            "Jacob Harris Ln","Jacob Ladder Rd","Jacob Ln","Jacob Ln SE","Jacob Pl","Jacob Rd","Jacob St SW",
            "Jacobs Ave","Jacobs Ln","Jacobs Rd","Jacobs St","Jacobson Avenue","Jacobson Rd","Jacobstown Checterfield Rd",
            "Jacobus Dr","Jacobus Ln","Jacoby Blvd","Jacoby Cir","Jacoby Creek Rd","Jacquelin Ann Ct",
            "Jacqueline Ave","Jacqueline Cir","Jacqueline Ct","Jacqueline Rd","Jacqueline St","Jacques Lane",
            "Jacques St","Jacques Street","Jacquier Ct","Jacwin Drive","Jade Ave","Jade Cliffs Ln","Jade Ct",
            "Jade Ln","Jade St","Jadeite Ave","Jadestone Ave","Jadestone Dr","Jadida Ave","Jager Rd","Jagger Ave",
            "Jagoe St","Jaguar Rd","Jahan Dr","Jake Rd","Jake St","Jake Staggers Rd","Jake Tom Rd","Jakes Wash Rd",
            "Jal Rd","Jal el Paso Pipe Line Rd","Jalmia Pl","Jamaica Ct","Jamaica Ln","Jamaica Rd","Jamar Circle",
            "Jamboree Ct","Jamerson Dr","James","James A. Rhodes Appalachian Highway","James Ave",
            "James Ave SE","James Avenue","James Circle","James Creek Rd","James Curtin Dr","James Dean Ave",
            "James Dr","James Drew Ln","James E Jonas Rd","James Irvine Trail","James Kelley Dr","James L Gibbs Drive",
            "James L Gibbs Road","James Lane","James Lick Fwy","James Ln","James Moore Rd","James Pl",
            "James Potter Road","James Rd","James Road","James Rowe Drive","James Run","James St","James St Manor",
            "James Street","James Street - Iroquois","James Street E","James Street N","James Street W",
            "James Village Rd","James Walls Rd","James Way","James Williams Rd","Jameson","Jameson Beach Rd",
            "Jameson Crescent","Jameson Dr","Jameson Pl","Jameson Rd","Jamesport Dr","Jamestown Ct","Jamestown Rd",
            "Jamesville Grove Rd","Jamesville Rd","Jamie Ave","Jamie Ct","Jamie Dr","Jamie Ln","Jamie Rose St",
            "Jamie Way","Jamieson Crescent","Jamieson Dr","Jamieson Road","Jamieson Street E","Jamison Ct",
            "Jamison Rd","Jamison Run Rd","Jan Ave","Jan Ct","Jan Dr","Jan Rd","Jan Snyder Rd","Jan St","Jan Way",
            "Jance Pl","Janczuk Rd","Jane Ann Addition Rd","Jane Ave","Jane Bus Terminal","Jane Crescent",
            "Jane Ct","Jane Ct NE","Jane Dr","Jane Francis Way","Jane Lane","Jane Ln","Jane Pl","Jane Rd","Jane St",
            "Jane Street","Jane's Chapel Rd","Janelle Ave","Janelle Ct","Janes Ln","Janesville Road",
            "Janet Ave","Janet Ct","Janet Dr","Janet Ln","Janet Pl","Janet Rd","Janet Road","Janet Way","Janette St",
            "Janette Street","Janeway Ave","Janice Ave","Janice Pl","Janice St","Janie Ave","Janie Dr","Janie Ln",
            "Janie St","Janine Way","Janna Way","Janopaul Avenue","Janray Drive","Jans Boulevard","Jansen Ct",
            "Jansen St","Janset Way","Janus Park Dr","Japatul Valley Rd / State Hwy 79 Exit","Japonica Ave",
            "Japonica Dr","Jaqueline St","Jaques Ln","Jaquima Dr","Jaramillo Pl","Jarbidge-Charleston County Rd",
            "Jardin Ct","Jardine Ct","Jared Cir","Jarman Rd","Jarombek Ct","Jarrard St","Jarred Dr","Jarrett Dr",
            "Jarrett St","Jarvis Dr","Jarvis Lane","Jarvis Ln","Jarvis Pl","Jarvis Rd","Jarvis St","Jarvis Street",
            "Jasinski Rd","Jasmine Crescent","Jasmine Dr","Jasmine Ln","Jasmine Pl","Jasmine Rd","Jasmine St",
            "Jason Ave","Jason Ct","Jason Dr","Jason Ln","Jason Malone Rd","Jason St","Jasper Ave","Jasper Bend",
            "Jasper Johns Way","Jasper Ln","Jasper Rd","Jasper Road","Jasper St","Jasper Street","Jasper Way",
            "Jaudon Rd","Jaunt Ave","Java Street","Jaw Mill Rd","Jawbone Canyon Rd","Jay Ave","Jay Ct","Jay Ln",
            "Jay Pl","Jay Rd","Jay Shepherd Rd","Jay St","Jay Street","Jayann Way","Jaybell Grove","Jaybird Ln",
            "Jaycroft Ct","Jayhawk Dr","Jaymar Ln","Jaymar Rd","Jayne Pl","Jayne St","Jaywood Manor Dr",
            "Jc Mauldin Hwy","Je-NE-Be Dr NE","Jean Dr","Jean Kennedy Ln","Jean Ln","Jean Marie Ave",
            "Jean St","Jean Street","Jean Ter","Jean Way","Jeanette Dr","Jeanette Drive","Jeanette St","Jeanibo Rd",
            "Jeanne Ln","Jeannette St","Jeb Stuart Rd","Jedburgh Ln","Jedburgh Road","Jeep Place","Jeep Trl",
            "Jeff Court Cir","Jeff King St","Jeff St","Jeffcoat Drive","Jeffer Ct","Jeffer Ln","Jefferson",
            "Jefferson Ave","Jefferson Ave N","Jefferson Ave S","Jefferson Cir","Jefferson Ct","Jefferson Davis Hwy",
            "Jefferson Dr","Jefferson Drive","Jefferson Forest Drive","Jefferson Hwy","Jefferson Lane",
            "Jefferson Ln","Jefferson Rd","Jefferson Road","Jefferson Sideroad","Jefferson St","Jefferson St / Indio Blvd / Indio offramp;I-10 West onramp",
            "Jefferson St NE","Jefferson Street","Jefferson Ter","Jefferson Way","Jeffery Dr","Jeffery Pine Dr",
            "Jeffery Street","Jeffery Way","Jeffeson St","Jeffords St","Jeffrey Dr","Jeffrey Heights Rd",
            "Jeffrey Rd","Jeffrey St","Jeffrey Street","Jeffrey Way","Jeffreys Neck Road","Jeffrie Ave",
            "Jeffries St","Jeffries Street","Jeffry Ln","Jefreelind Dr","Jelecote Dr","Jelley Avenue",
            "Jellico St","Jellicoe Crescent","Jellys Ferry Rd","Jemez Pl","Jemima Mount Rd","Jemison Ave",
            "Jemison Rd","Jenell Dr","Jeni Ann Ct","Jenifer Ct","Jenkins Bridge Rd","Jenkins Ct","Jenkins Dr",
            "Jenkins Rd","Jenkinson Cir","Jenks St","Jenna Ct","Jenne Rd","Jenner Court","Jenner Ct","Jenness Pond Rd",
            "Jenney Street","Jennie Lee Rd","Jennie Ln","Jennie's Ln","Jennifer Agnes Ave","Jennifer Ave",
            "Jennifer Cir","Jennifer Court","Jennifer Ct","Jennifer Dr","Jennifer Ln","Jennifer Rd","Jennifer St",
            "Jennings Avenue","Jennings Cir","Jennings Creek Rd","Jennings Ranch","Jennings Rd","Jennings Road",
            "Jennings St","Jennings Vista Cir","Jennison Road","Jenny Cir","Jenny Ct SW","Jenny Dr","Jenny Jump Ave",
            "Jenny Lane","Jenny Lind Rd","Jenny Ln","Jenny Wrenway","Jenrich Road","Jensen","Jensen Dr",
            "Jensen Drive","Jensen Pl","Jensen Rd","Jenson Rd","Jenson St","Jenter Aly","Jeppson Ln","Jeraback Dr",
            "Jeraldo St","Jeralds Ave","Jeranna Court","Jeremy Ct","Jeremy Drive","Jerge Dr","Jericho Ln",
            "Jericho Rd","Jerlee St","Jermey Lane","Jernigans Rd","Jerod Ln","Jerome Ave","Jerome Avenue",
            "Jerome Pl","Jerome St","Jerome Street","Jerri Ct","Jerry Rd","Jerry Smith Cir","Jerry St","Jerry Tarkanian Way",
            "Jersey Ave","Jersey Avenue","Jersey Gardens Blvd","Jersey Hill Rd","Jersey Pl","Jersey Shore Medical Center",
            "Jersey St","Jersey Street","Jerseydale Rd","Jerusalem Chapel Rd","Jerusalem Hill Rd",
            "Jerusalem Rd","Jerusalem Road","Jesmond Dene Hts Pl","Jess Dr","Jess Valley Rd","Jesse Ct",
            "Jesse Green Rd","Jesse Rd","Jessica Ct","Jessica Drive","Jessica Pl","Jessica Way","Jessicas Way",
            "Jessie Burroughs Dr","Jessie Court","Jessie James Ln","Jessie Rd","Jessie St","Jessup Mill Rd",
            "Jessup Rd","Jessup Road","Jesuit Dr","Jet Center Pl","Jeter St","Jett Ln","Jett Mtn Rd","Jetton Rd",
            "Jetton St","Jetty St","Jewel Canyon Dr","Jewel Hou Lane","Jewel Ridge Ave","Jewel St","Jewel Street",
            "Jeweled Mesa","Jewell","Jewell Ln","Jewell North","Jewell Road","Jewell St","Jewell Street",
            "Jewell Weed Ct","Jewett Ave","Jewett Dr","Jewett Pl","Jewett Road","Jewett Scio Rd","Jewett Street",
            "Jewett's Court","Jewetts Court","Jez Rd","Jfk Blvd","Jib Ct","Jib St","Jibbom St","Jicarilla Blvd",
            "Jig Rd","Jigger Dr","Jill Ave","Jill Ct","Jill Jean Ave","Jill Ln","Jill Rd","Jillette Rd","Jillian Ct",
            "Jills Ct","Jim Bridger Rd","Jim Denning Way","Jim Gray Rd","Jim Hall Rd","Jim Raney Ln",
            "Jim St","Jim Young Fork Rd","Jim's Rd","Jimbo Ln","Jimilyn St","Jimmie Ln","Jimmy Nolan Road",
            "Jimmy Way","Jims Lane South","Jimston Drive","Jimtown Rd","Jk Lumsden Way","Jo Ann Dr","Jo Dan Lane",
            "Jo Dean Ct NE","Joan Ave","Joan Ct","Joan Dr","Joan Drive","Joan Pl","Joan Street","Joan Trl",
            "Joan Way","Joann Way","Joanna Drive","Joanna Pl","Joanne Court","Joanne Ct","Joanne Drive",
            "Joanne Ln","Joanne Way","Joaquim F Pina Avenue","Joaquin Murieta","Joaquin Rd","Joaquin Rocks Lookout Rd",
            "Joaquin St","Jobb Road","Jobella Ln","Jobson Way","Jobstown Juliustown Rd","Jobway Ave",
            "Jocada Road","Jocelyn Ln","Jochem Road","Jockey Ave","Jockey Hollow Rd","Jockey Ln","Jockeys Way",
            "Joda Dr","Jodi Lane","Jodi Lynn Ln","Jodie Court","Jody Court","Jody Lane","Joe Angel Rd","Joe Ave",
            "Joe Catlin Rd","Joe Dales Drive","Joe Dolan","Joe Edwards St","Joe Kennedy Way","Joe Killough Rd",
            "Joe Plise","Joe Pombo Pky","Joe Pye Ct","Joe Pye St","Joe Quick Rd","Joe Silver Blvd","Joe Springs Dr",
            "Joe Watson Ct","Joe Wheeler Hwy","Joe Whitacre Rd","Joe's Canyon Trail","Joel Dr","Joel Pl",
            "Joel R St","Joel Rd","Joel St","Joel Way","Joelle Ct","Joelle Rd NE","Joes Rd","Joey Ln","Joey Trl",
            "Joffre Ave","Joffre St","Johanna Ct","Johannesburg Ave","John Anderson Ct","John Ashley Rd",
            "John Ave","John Ave SE","John Avery Ln","John Bird","John Button Boulevard","John C Lodge Fwy",
            "John Calvin Dr","John Carroll Rd","John Counter Boulevard","John Crow Rd","John Ct","John Dare Rd",
            "John Davis Gate","John Deere Dr","John Deere Ln","John Deere Rd","John Deisman Boulevard",
            "John Dixon Rd","John Dow Ave","John Drive","John Drury Drive","John Emery Dr","John F Foran Fwy",
            "John F Kennedy Blvd","John F Kennedy Drive","John F. Kennedy Parkway","John Fitch Way",
            "John Ford Road","John Fox Rd","John Garland Boulevard","John Glenn Rd","John Graham Court",
            "John Grubb Court","John Hancock Way","John Hand Dr","John Harden Dr","John Henry Cir",
            "John Henry Dr","John Hill Ct","John Hyman Rd","John K Dr","John Lenhardt Rd","John Moon Road",
            "John Muir Trail","John Noland Rd","John P Sullivan Ct","John Peet Rd","John Pl","John R Bend",
            "John R Dr","John Roemmelt Dr","John Ryle Ave","John Shannon Rd","John Shine Ct","John St",
            "John Street","John Street S","John T Centrino Memorial Drive","John Tuttle Rd","John Tyler Ave",
            "John Velthoven Ter","John Walsh Blvd","John Watt Boulevard","John Wayne St","John Wesley Cir S",
            "John White Rd","John Wiedeckehr Ct","John's Ln","Johnathan Pl","Johned Rd","Johnies Way",
            "Johnny Bee Rd","Johnny Cake Hill","Johnny Cake Hill Ln","Johnny Cake Hollow Road",
            "Johnny Dr","Johnny Holiday St","Johnny Jack-Hi Rd","Johnny Ln","Johnny Pl","Johnny Shirley Rd",
            "Johnny Tuck Ct","Johnnys Lane Rd","Johns Ln","Johns Rd","Johnsarbor Dr W","Johnsdale Ter",
            "Johnson","Johnson Ave","Johnson Ave NE","Johnson Avenue","Johnson Court","Johnson Creek",
            "Johnson Ct","Johnson Dr","Johnson Dr N","Johnson Drive","Johnson Heights","Johnson Hill Rd",
            "Johnson Hill Tr","Johnson Island Rd","Johnson Lane","Johnson Ln","Johnson Loop","Johnson Park",
            "Johnson Pl","Johnson Rd","Johnson Rd W","Johnson Ridge Rd","Johnson Run Rd","Johnson St",
            "Johnson Street","Johnson Street Brg","Johnson Ter","Johnson Wash","Johnsonburg Bypass Rd",
            "Johnsons Ln","Johnsonville Road","Johnston Ave","Johnston Blvd","Johnston Drive","Johnston Ln",
            "Johnston Rd","Johnston Road","Johnston St","Johnston Street","Johnston Ter","Johnstone St",
            "Johnsville Mc Crea Rd","Joie Ct","Joie Pl","Joiners Ln","Joint Rd","Jojoba Hills Rd","Jola Cir",
            "Jolenes Cir","Joli Court NE","Jolie Ct","Joliet Ct","Joliet Ln","Joliet Pl","Joliet St","Jollett Rd",
            "Jolliffe Avenue","Jolly Cir","Jolly January Ave","Jolly Jeep Rd","Jolly Roger Dr","Jolly Tr",
            "Jollytown Rd","Jomar Ct","Jomax","Jon Lief Ct","Jon Street","Jonah Dr","Jonas Ave","Jonas Street",
            "Jonathan Cir","Jonathan Ct","Jonathan Ln","Jonathan St","Jonathan Street","Jonathan Ter",
            "Jonathan Way","Jonathon Cir","Jones Ave","Jones Avenue","Jones Bluff Rd","Jones Crossing Rd",
            "Jones Dr","Jones Ferry Road","Jones Fork Power House Rd","Jones Hunter Access Trl",
            "Jones Ln","Jones Pl","Jones Ranch Ct","Jones Rd","Jones Rd SW","Jones St","Jones Street","Jones Walk",
            "Jones Way","Jonestown Rd","Jonestown-Claremont Rd","Joni Lee Ln","Jonothan Way","Jonquil Crescent",
            "Jonquil Ln","Jonquil Ln N","Joplin Ct","Jopling Avenue North","Joppa Rd;North Village Rd",
            "Jordan Ave","Jordan Court","Jordan Lake Road S","Jordan Lane","Jordan Ln","Jordan Ln NW",
            "Jordan Ln West","Jordan Rd","Jordan Road","Jordan St","Jordan Street","Jordan Way","Jordanray Boulevard",
            "Jordon Ln","Jorene Drive","Jorge Dr","Jorgenson Road","Jorgito Ave","Jose Ave","Jose Lake Tr",
            "Jose's Way","Joseler Ct","Joseph Ave","Joseph B. Clarke Rail-Trail","Joseph Canyon Dr",
            "Joseph Ct","Joseph Dr","Joseph Drive","Joseph Ln","Joseph Road","Joseph St","Joseph Street",
            "Joseph Wilder Cir","Josephine Ave","Josephine Cir","Josephine Dr","Josephine St","Josham Ln",
            "Joshua Cir","Joshua Ct","Joshua Dr","Joshua Grove Ave","Joshua Huddy Dr","Joshua Ln","Joshua Ridge Dr",
            "Joshua St","Joshua Tree Cir","Joshua Tree Ln","Joshua's Creek Trail","Josiah Dr","Josie Dr",
            "Joslin Rd","Joslin Road","Joslin St","Joslyn Access","Joslyn Rd","Joston Dr","Jotham Rd","Jouberts Rd",
            "Joule St","Journey Ct","Journey Way","Jovan Ter","Joy Ct","Joy Dr","Joy Drive","Joy Farm Ln","Joy Farm Rd",
            "Joy Ln","Joy Place","Joy Rd","Joy Road","Joy St","Joy Tract Rd","Joyce Ave","Joyce Avenue","Joyce Cir",
            "Joyce Crescent","Joyce Ct","Joyce Dr","Joyce Ln","Joyce Parkway","Joyce Road","Joyce St","Joyceville Road",
            "Joycroft Rd","Joyes Ln","Joylin St","Joyner Rd","Juan Ave","Juan Bautista de Anza Trail",
            "Juan Carlos St","Juan Ct","Juan P Sanchez Rd","Juanita Ave","Juanita Ct","Juanita Dr","Juanita Ln",
            "Juarez Rd","Jub Rd","Jubilee Court","Jubilee Crescent","Jubilee Ct","Jubilee Pass","Jubilee Rd",
            "Judah Ave","Judd Ave","Judd Road Expressway","Judea Cemetery Rd","Judge Brown Rd","Judge Rd",
            "Judge Street","Judge Vernon Ct","Judge Ward Ct","Judi Pl","Judicial Dr","Judick Street",
            "Judith Ct","Judith Dr","Judith Road","Judith St","Judith Street","Judson Ave","Judson Pl SE",
            "Judson Street","Judson Street Rd","Judy Ave","Judy Ct","Judy Dr","Judy Ln","Judy St","Judys Ln",
            "Jug Run Rd","Juldan Place","Jules Avenue","Julia Cir","Julia Ct","Julia Dr","Julia Ln","Julia St",
            "Julia St N","Julia Ter","Julian Ave","Julian Dr","Julian Rd","Julian St","Juliana Ter","Julie Ann Ln",
            "Julie Ave","Julie Ct","Julie Dr","Julie Ln","Julie Rd","Julie St","Julie Way","Julieann Ln","Julien Ct",
            "Juliet Cres","Juliet Crescent","Juliet St","Juliet Way","Juline Dr","Julius Ln","Julius Street",
            "Juliustown Rd","Julliard Drive","Julliard St","July Jewel Ave","July Run Rd","Jumano Ct",
            "Jumbo Grd","Jump Up Ct","Jumping Frog Ct","Junco Ct","Junco Pl","Junction Pond Ln","Junction Rd",
            "Junction St","June Ave","June Avenue","June Bug Ln","June Ct","June St","June Street","June Way",
            "Juneberry Avenue","Juneberry Cir","Juneo Ct","Junetown Road","Junewood Crescent","Jungkind St",
            "Jungle Orchard St","Jungo Rd","Juni Ct","Juniata Ave","Junin Ln","Junior Dr","Junior St","Juniper",
            "Juniper Ave","Juniper Blvd","Juniper Circle","Juniper Court","Juniper Ct","Juniper Dr","Juniper Dr NW",
            "Juniper Hill","Juniper Hill Rd","Juniper Lake Rd","Juniper Lane","Juniper Ln","Juniper Mine Rd",
            "Juniper Park Rd","Juniper Pl","Juniper Place","Juniper Rd","Juniper Ridge Ave","Juniper Road",
            "Juniper Saddle Dr","Juniper St","Juniper Street","Juniper Terrace","Juniper Tr","Juniper Trl",
            "Juniper Valley Way","Juniper Way","Junipero Serra Fwy","Junipero St","Juniter Way","Junius Ponds Service Area",
            "Junkin Street","Junkins Ave","Jupiter","Jupiter Dr","Jupiter Lane","Jupiter Rd","Jupiter St",
            "Jupiter Way","Jurassic Dr","Jurewicz St","Justice Dr","Justice Hill Cutoff","Justin Circle",
            "Justin Ct","Justin Dr","Justin Ln","Justin St","Justine Ln","Justinpaul Ln","Jutland Dr","K 3 Ln",
            "K Ave","K Rd","K St","K St L St Aly","K Walk","K Way","K and K Rd","Ka'II","Ka-Ton-Ah Ter","Kabeyun Road",
            "Kabuki Ave","Kachina Cir","Kachina Dr","Kachina Loop","Kachina Rd","Kachina Tr","Kacy Ln","Kaderka Rd",
            "Kadet","Kadota Ave","Kafir Ct NE","Kaftan Way","Kahles Rd","Kaighns Ave","Kailash Cir","Kaiser Ct",
            "Kaiser Dr","Kaiser Loop Trl","Kaiser Rd","Kakiat Ct","Kalamazoo Ave","Kale Drive","Kaleb Ln",
            "Kalenda Cmn","Kalev Road","Kali Place","Kalifornsky Beach Rd","Kalil Dr","Kalin Dr","Kalioka Sv Rd",
            "Kalla Ln","Kalleston Dr","Kallibrooke Ln","Kalos St","Kaltag Dr","Kalvin Ter","Kalynn Dr","Kam Ave",
            "Kam Ct","Kamber Ct","Kamena St","Kamian Way","Kaminski Rd","Kamloops Dr","Kamm Ln","Kammerlin Ln",
            "Kammu Drive 6","Kamsky Rd","Kamuela Rd","Kanan Rd","Kanan Road","Kancamagus Hwy","Kandra Rd",
            "Kane Holly St","Kane Mtn Rd","Kane Road","Kane Springs Rd","Kane St","Kane-Wilcox Rd","Kaneohe Ave",
            "Kanepsky St","Kangaroo Creek Rd","Kanine Rd","Kanis Rd","Kankamagus Brook","Kanoeho Dr",
            "Kanora Dr","Kansas","Kansas Ave","Kansas City Rd","Kansas St","Kansas Way","Kant St","Kanteles Street",
            "Kanturk Gate","Kaolin Road","Kaplon Rd","Kappa Ave","Kappelle Avenue","Kara Ln","Kara Rd","Kara St",
            "Karcheck Ln","Karemark Dr","Karen","Karen Ave","Karen Ave NE","Karen Circle","Karen Ct","Karen Dr",
            "Karen Drive","Karen Pl","Karen Rd","Karen St","Karen Ter","Karens Ln","Karge St","Karina Court",
            "Karina Road","Karina Way","Kariya Drive","Karkin Pl","Karl Ave","Karl Fraser Road","Karl St",
            "Karla Ct","Karla Dr","Karlen Ave","Karlen Rd","Karm Way","Karma Ct","Karma Road","Karol St","Karotauish Ln",
            "Karow Rd","Karpa St","Karr Canyon Rd","Karrdale St","Karron Rd","Karskh","Karst Ave","Karst Rd NE",
            "Karsten Dr","Karta Court","Kasey Way","Kashmir Way","Kassner Ave","Kasson Center Rd","Kasson Rd",
            "Kast Ct","Katama Road","Katavols","Katchewanooka Court","Kate Avenue","Kate Dr","Kate St",
            "Katelyn Cir","Kater St","Katharyn Michael Road","Katherine Ct","Katherine Dr","Katherine Ln",
            "Katherine Rd","Katherine Street","Katherun St","Kathleen Circle","Kathleen Ct","Kathleen Drive",
            "Kathleen Pl","Kathleen Rd","Kathleen St","Kathryn Ave","Kathryn Crescent","Kathryn Ct","Kathryn Ln",
            "Kathryn Pl","Kathryn Road","Kathryn St","Kathryn Way","Kathy Ct","Kathy Jo Ln","Kathy Ln","Kathy Rae Dr",
            "Kathy Suzanne Way","Kathy Way","Katie Ct","Katie Dr","Katie Ln","Katie St NE","Katies Ln","Kato St",
            "Katrina Court","Katrina St","Kattak","Katy Ln","Katz Ave","Kauai Dr","Kauffman St","Kaufman Aly",
            "Kaufman Rd","Kaufmann Dr","Kaufmann Rd","Kavanagh Pl","Kavanaugh Ave","Kavanaugh Blvd","Kavanaugh St",
            "Kawartha Drive","Kay Avenue","Kay Cir","Kay Ct","Kay Dr","Kay Drive","Kay Ln","Kay St","Kay Street",
            "Kaya Ln","Kayla Dr","Kayleigh Dr","Kaylynn","Kays Ln","Kayser Cir","Kayuta Ter","Kaywill Drive",
            "Kaywood Cv","Kazar Ct","Keach Rd","Keach Street","Kean Ct","Kearley Lane","Kearney Ave","Kearney Dr",
            "Kearney St","Kearney Street","Kearns Dr","Kearns Pl","Kearns Rd","Kearny Ave","Kearny Mesa Rd",
            "Kearny Rd","Kearny St","Kearsarge Rd","Kearsarge St","Keasbey Rd","Keates Rd","Keathley Dr",
            "Keating Ave","Keating Lane","Keats Ave","Keats Rd","Keats Road","Keck St","Kee Mar Ct","Kee Rd",
            "Keebaugh-Follrod","Keech Hill Rd","Keefer Road","Keefere Hollow","Keegan Pl","Keegan Way",
            "Keel Ave","Keel Ct","Keel Rd","Keele Rd E","Keele Street","Keeler Boulevard","Keeler Dr","Keeler Rd",
            "Keeler St","Keeley Ln","Keeling Rd","Keeling St NW","Keen Ln","Keen St","Keen Street","Keenan Crescent",
            "Keenan Ct","Keenan Dr","Keenan Lake Rd","Keenan Pl","Keenan St","Keenan Way","Keene Ave","Keene Rd",
            "Keene Road","Keene Street","Keener Dr","Keeney Ave","Keeney Ct","Keep Dr","Keepsake Way","Keesler Corners Rd",
            "Keeton Ln","Keewatin Boulevard","Keewatin Street","Keewaydin State Park","Keffer Dr",
            "Keffer Ln","Kegler","Kehoe Court","Kehoe St","Keifer St","Keim Blvd","Keir Hill Rd","Keira Ct",
            "Keirns Rd","Keiser Ave","Keith Cv","Keith Dr","Keith Hill Road","Keith Rd","Keith St","Keith Street",
            "Keithtown Rd","Kelby St","Kelfield Street","Kelglen Ln","Kell","Kellam Ave","Kellar Ln","Keller Ave",
            "Keller Ct","Keller Ln","Keller Rd","Keller Ridge Dr","Kellers Crossroads","Kellett Rd","Kelley Brook Rd",
            "Kelley Ct","Kelley St","Kelley Way","Kellie St","Kellkari Rd","Kellog Hill Rd","Kellogg Arc",
            "Kellogg Rd","Kellogg Road","Kellogg St","Kells Lane No 22","Kelly","Kelly Ave","Kelly Ave SW",
            "Kelly Botton Rd","Kelly Boulevard","Kelly Canyon Rd","Kelly Cir","Kelly Creek Rd","Kelly Crossing Ln",
            "Kelly Crossing Rd","Kelly Ct","Kelly Dr","Kelly Hill Rd","Kelly Ln","Kelly Pky","Kelly Rd",
            "Kelly Road","Kelly St","Kelly St NW","Kelly Street","Kelly Way","Kelly's Road","Kellys Ln",
            "Kelpwood St","Kelsea Ave","Kelsey Ave","Kelsey Canyon Rd","Kelsey Crt","Kelsey Ct","Kelsey Dr",
            "Kelsey Ln","Kelsey Park","Kelsey Rd","Kelsey St","Kelsey Way","Kelso Creek","Kelso Crescent",
            "Kelso Ln","Kelso Way","Kelson Avenue N","Keltie Avenue","Kelton Rd","Kelton Road","Keltz Way",
            "Kelvedon Mews","Kelvin Ave","Kelvin Avenue","Kelvin Grove","Kelwood St","Kemah Pl","Kemah Road",
            "Kemano Road","Kemble Rd","Kemmer Ln","Kemp Ct","Kemp Dr","Kemp Ln","Kemp Rd","Kemp Road E","Kemp Square",
            "Kemper Ct","Kemper Lakes St","Kemper Rd","Kemper Street","Kempf St","Kemple Dr","Kempsell Crescent",
            "Kempsey Dr","Kempson Pl","Kempster St","Kempton Rd","Ken Dr","Ken J Dr","Ken Mar Ind Pky","Ken Scull Ave",
            "Ken's Lake Estates","Kenagy Ct NW","Kenbarb Road","Kenborough Court","Kencrest Cir","Kendal Avenue",
            "Kendale St","Kendall Blvd","Kendall Ct","Kendall Dr","Kendall Hill Road","Kendall Mountain Rd",
            "Kendall Pl","Kendall St","Kendaville Rd","Kendig St","Kendleton Drive","Kendra Ct","Kendra Way",
            "Kendrick Avenue","Kendrick Ct SE","Kendrick Ln","Kendrick St","Kenhill Beach Road","Kenilworth",
            "Kenilworth Ave","Kenilworth Ct","Kenilworth Dr","Kenilworth Ln","Kenilworth Rd","Kenilworth St",
            "Keniston Hill Rd","Kenmare Way","Kenmore Ave","Kenmore Avenue","Kenmore Ct","Kenmore Dr",
            "Kenmore Rd","Kenmore St","Kenmore Ter","Kenmuir Ave","Kenmuir Avenue","Kenna Court","Kennally Creek Pack Trl",
            "Kennard Avenue","Kennebank Ln","Kennebec Ct","Kennebec Street","Kennebunk Cir","Kennebunk Street",
            "Kennedy","Kennedy Blvd","Kennedy Blvd E","Kennedy Cir","Kennedy Ct","Kennedy Dr","Kennedy Drive",
            "Kennedy Flat Rd","Kennedy Lane","Kennedy Ln","Kennedy Meadow Rd","Kennedy Rd","Kennedy Road",
            "Kennedy Road Branch","Kennedy St","Kennedy Street","Kennedy Street East","Kennedy Street W",
            "Kennedy Ter","Kennedy Way","Kennel Ln","Kennelwood Dr","Kennelworth Ave","Kenneth Ave","Kenneth Ave N",
            "Kenneth Avenue","Kenneth Ct","Kenneth Dr","Kenneth Lane","Kenneth Rd","Kenneth St","Kenneth Street",
            "Kenneth Way","Kennett Drive","Kenney Shore Ln S","Kennington Court","Kennison Pky","Kenny Avenue",
            "Kenny Creek Rd","Kenny Ln","Kenny St","Kenny Way","Kennybeck Ct","Kenora Crescent","Kenova Rd",
            "Kenpark Ct","Kenrick Farm Rd","Kenro Way","Kenroy Ave","Kenruth Dr","Kensico St","Kensington Ave",
            "Kensington Cir","Kensington Ct","Kensington Dr","Kensington Expessway Westbound","Kensington Expressway Eastbound",
            "Kensington Ln","Kensington Rd","Kensington St","Kensington St NW","Kensington Way","Kensley Dr",
            "Kenston Lake Dr","Kent Ave","Kent Avenue","Kent Court","Kent Ct","Kent Dr","Kent Ln","Kent Pl",
            "Kent Rd","Kent Road","Kent St","Kent Street","Kent Street W","Kentfield Pl","Kentfield Rd",
            "Kentland Ave","Kentland Crescent","Kentmere Pl","Kentuck Lake Rd","Kentuck Rd","Kentuck Tower Rd",
            "Kentucky","Kentucky Ave","Kentucky Avenue","Kentucky Ct","Kentucky Ct S","Kentucky Flat Rd",
            "Kentucky Ln","Kentucky St","Kentwood Dr","Kenvale Court","Kenview Blvd","Kenwood Avenue",
            "Kenwood Dr","Kenwood Drive","Kenwood Park","Kenwood Rd","Kenwood St","Kenwood Street","Kenwood Ter",
            "Kenworthy Ct","Kenworthy Way","Kenwyck Ct","Kenyan Pl NW","Kenyon Ave","Kenyon Crescent",
            "Kenyon Ct","Kenyon Dr","Kenzie Blvd","Keokuk Ave","Kepler Ct","Kerbaugh St","Keremeos Crescent",
            "Kerford Road","Kermit Place","Kermit Rd","Kern Ave","Kern Ct","Kern Dr","Kern Ln","Kern Rd","Kern River Canyon Rd",
            "Kern St","Kernan St","Kerner Blvd","Kerney","Kernita Rd","Kernville Rd","Kernwood Dr","Kero Rd",
            "Kerr Ave","Kerr McGee Rd","Kerr Rd","Kerr Road","Kerr Street","Kerri Ct","Kerrigan Ave","Kerrs Corner Rd",
            "Kerry Court","Kerry Ct","Kerry Dr","Kerry Ln","Kerry Park","Kerry Point Road","Kerry St","Kerryman Cir",
            "Kerwin Gate","Kesavan Dr","Kesell Boulevard","Kesling Ct","Kessler Road","Kessler St","Kester Rd",
            "Kestler Ln","Kestrel Ave","Kestrel Ct","Keswick Cir","Ketch Ave","Ketch Ln","Ketch Pl","Ketch Rd",
            "Ketcham","Ketchum Ave","Ketchum Court","Ketola Rd","Kett Road","Kettering Cir","Kettle Court",
            "Kettle Dome St","Kettle Hole Road","Kettlebelly Rd","Ketzler Dr","Kevin B Ln","Kevin Ct",
            "Kevin Cv","Kevin Dr","Kevin Lee Ln","Kevin St","Kevin Way","Kew Gardens Rd","Kew Road","Kewanee Way",
            "Kewaskum Rd","Kewen Ave","Key Cir","Key Court","Key Dr","Key Vista Cir","Key West Ct","Keyes Rd",
            "Keyes Road","Keyes St","Keys Ct","Keyser Rd","Keyser St","Keyson","Keystone Dr","Keystone Private",
            "Keystone Rd","Keystone St","Keystone Trl","Keyvam St","Keyworth Trail","Kezar Drive","Kfc Dr",
            "Khedive Avenue","Khleem Rd","Khuram St","Kibbe Rd","Kibler Ln","Kiblin Shores Cir","Kickapoo Ct",
            "Kickapoo Trl","Kickerboc","Kickox Rd","Kid Pl","Kidd Loop","Kidd Road N","Kidder Ave","Kidder Ln",
            "Kidder Rd","Kidder St","Kidders Beach Rd","Kidney Rd","Kidwell Dr","Kidwell Ln","Kieber Way",
            "Kiefer Rd","Kiefer St","Kielgart Ave","Kiernan Rd","Kieser Rd","Kiger Mustang Cir","Kila Dr",
            "Kilamanjaro Ln","Kilarney Dr","Kilbannan Court","Kilbary Road","Kilbourne Ave","Kilbourne Dr",
            "Kilburn Ct","Kilburn Pl","Kilburn Rd","Kilburn Street","Kilby Field Rd","Kilby St","Kilby Street",
            "Kilcullen Castle Gate","Kilda Cir","Kildeer Ln","Kildonan Drive","Kileen St","Kiler Canyon Rd",
            "Kiley Dr","Kilfoil St","Kilgore Ridge Rd","Kilgore St","Kilgour Avenue","Kilkare Pky","Kilkormic St",
            "Killaby Drive","Killam Hill Road","Killamarsh Drive","Killane St","Killarney Bay Road",
            "Killarney Beach Road","Killarney Road","Killdeer Ct","Killian Ct","Killian Dr","Killian Pl SE",
            "Killian Rd","Killian Road","Killian St","Killingsworth Rd","Killins Street","Kilman Road",
            "Kilmarnoch Ln","Kilmarnock Avenue","Kilmarnock Road","Kilmary Ln","Kilmer Ct","Kilo Vista Rd",
            "Kilroe Rd","Kilroy Rd","Kilsby Cir","Kilsyth Terrace","Kilt Ave","Kilty Ave","Kilworthy Road",
            "Kim","Kim Ave","Kim Cir","Kim Ct","Kim Louise Dr","Kim St","Kimball Ave","Kimball Dr","Kimball Lake Shores Rd",
            "Kimball Rd","Kimball Road","Kimball St","Kimball Ter","Kimball Way","Kimbark Ave","Kimbark Boulevard",
            "Kimbell Ave","Kimber Ct","Kimber Rd","Kimbercroft Court","Kimberlee Ct","Kimberley Dr","Kimberly Cir",
            "Kimberly Ct","Kimberly Ct S","Kimberly Dr","Kimberly Ln","Kimberly Pl","Kimble Ct","Kimble Ln",
            "Kimbourne Avenue","Kimbrell Cutoff Rd","Kimbrough Rd","Kimbrough St","Kime Ave","Kimono Crescent",
            "Kin Way","Kincaid Rd","Kincora Dr","Kindle Ave","Kindle Station Cv","Kindness Rd","Kindred Ln",
            "Kiner Ave","Kinerson Ln","King Arthur Ct","King Arthurs Ct","King Ave","King Avenue","King Boulevard",
            "King Branch Rd","King Chcur Rd","King Cir","King Ct","King Dr","King Drive","King Edward Avenue",
            "King Edwards Ln","King Fisher Dr","King George Road","King George Rd","King George's Road",
            "King Georges Post Rd","King Henry Ave","King Hill Rd","King James Ln","King Ln","King Mill Rd",
            "King Mountain Loop Trail","King Oak Terrace","King Peterson Rd","King Philip Rd","King Phillip Street",
            "King Pl","King Place","King Pond Rd","King Rd","King Ridge Rd","King Road","King Silas Ct",
            "King St","King St S","King Street","King Street E","King Street East","King Street W","King Street West",
            "King Ter","King View Crescent","King William Ct","King's Court","King's Grant Court",
            "Kingbird Court","Kingdom Hall Ln","Kingdom Way","Kingfisher Court NW","Kingfisher Ct",
            "Kingfisher Way","Kinghurst Dr","Kinglet Ct","Kingman Avenue","Kingman Dr","Kingmount Crescent",
            "Kings Ave","Kings Canyon Ct","Kings Crescent","Kings Croft","Kings Crossing Rd","Kings Ct",
            "Kings Gate N","Kings Gate Ct","Kings Gate Pky","Kings Grant Dr","Kings Highway","Kings Hill Road",
            "Kings Hwy","Kings Hwy E","Kings Landing Way","Kings Ln","Kings Lynn Road","Kings Mountain Rd",
            "Kings Pl","Kings Point Drive","Kings Pointe Cv","Kings Rd","Kings Ridge Rd","Kings Road",
            "Kings Street","Kings Valley Rd","Kings Way","Kings Wharf Road","Kingsberry Dr","Kingsborough 4th Walk",
            "Kingsborough 5th Walk","Kingsborough Crescent","Kingsbridge Ct","Kingsbridge Dr","Kingsbridge Pl",
            "Kingsbury Rd","Kingscross Drive","Kingsdale Avenue","Kingsdale Drive","Kingsessing Ave",
            "Kingsfield Dr","Kingsgate Pky","Kingshill Road","Kingsland Avenue","Kingsland Crescent",
            "Kingsland Ct","Kingsland Ln","Kingsland Plz","Kingsland Rd","Kingsley Avenue","Kingsley Ln",
            "Kingsley Road","Kingsley St","Kingsmead Court","Kingsmere Avenue","Kingsmere Lane","Kingsmere Road",
            "Kingsmill Court","Kingsmoor Gate","Kingspoint Ln","Kingsridge Drive","Kingsridge St",
            "Kingston Ct","Kingston Farm Rd","Kingston Garden Rd","Kingston Ln","Kingston Rd","Kingston Road",
            "Kingston St","Kingston Way","Kingsview Boulevard","Kingsview Drive","Kingsway Boulevard",
            "Kingsway College Drive","Kingsway Crescent","Kingsway Rd","Kingswick Apts Rd","Kingswood Ct",
            "Kingswood Dr","Kingswood Rd","Kingswood Road","Kingswood Spur","Kingwood Dr","Kingwood Rd",
            "Kinkora Ct E","Kinley Ave","Kinley Pl NE","Kinlin Road","Kinlock Ct","Kinlock Rd","Kinmonth Road",
            "Kinmount Crescent","Kinne Street","Kinnett Ave","Kinney Ave","Kinney Cir","Kinney Farm Rd",
            "Kinney Road","Kino","Kinross Dr","Kinsey Valley Rd SW","Kinsigton Park Road","Kinsington Cir",
            "Kinsley Grove","Kinsman Ct","Kinsman Ln","Kinsman St","Kintner Aly","Kintner Estates","Kintners Rd",
            "Kintzing Dr","Kinuchee Brdg School Rd","Kinzel Ln","Kinzie St","Kinzley St","Kiowa Bay",
            "Kiowa Cir","Kiowa Ct","Kiowa Ct NE","Kiowa Cv","Kiowa Pl","Kiowa Rd","Kiowa St","Kipahulu Ln",
            "Kipford Way","Kipling Avenue","Kipling Cir","Kipling Dr","Kipling Rock Rd","Kipling Street",
            "Kipp Ave","Kipp Rd","Kipping Avenue","Kira Ln","Kirby Pl","Kirby Rd","Kirby Road","Kirk Ave","Kirk Cir",
            "Kirk Drive","Kirk Ford Way","Kirk Rd","Kirk St","Kirkbride Dr","Kirkbride St","Kirkbridge Rd",
            "Kirkcaldy St","Kirkcudbright Ln","Kirkendoll Rd","Kirkfield Road","Kirkham Street","Kirkland Dr S",
            "Kirkland Drive","Kirkland Rd","Kirklee Ln","Kirklees Rd","Kirklin Ave","Kirkman Ln","Kirkman Pl",
            "Kirkman Way","Kirkpatrick Rd","Kirkpatrick St","Kirksey Ave","Kirkseys Bend","Kirkstone Cir",
            "Kirkville Rd N","Kirkwall Crescent","Kirkwall St","Kirkwood Ave","Kirkwood Dr","Kirkwood Pl",
            "Kirkwood Village Rd","Kirschemann Rd","Kirsten Ct","Kirsten Dr","Kirsten St","Kirstie Court",
            "Kirwood St","Kiser Dr","Kish Ct","Kisha Ct","Kissam Rd","Kistler Ave","Kiswick Street","Kitchen Gulf Rd",
            "Kitchener Dr; Louise Dr","Kitchener Road","Kitchener Street","Kitchner Dr","Kite Hawk Ln",
            "Kite Hawkway","Kite Hill Ln","Kite St","Kitley South Elmsley Townline Road","Kitson Drive",
            "Kittannie Ave","Kittell Rd","Kittery Ave","Kittery Dr","Kittery Dr NW","Kittery St","Kittery Street",
            "Kitti-Wake Dr","Kittle Dr","Kittredge Ter","Kittridge Drive","Kitty Island Rd","Kitty Ln",
            "Kitty St","Kittyhawk Ave","Kiva Hill","Kiwanis Rd","Kiwanis St","Kiwanis Trl","Kiwi Ln","Kk Rd",
            "Klamath Beach Road","Klamath Ct","Klamath River Dr","Klamath Trl","Klatt Dr","Klauder Rd",
            "Klee Ct","Kleinshore Rd","Klem Road North Elemetary Sch","Klem Road South Elemetary Sch",
            "Klemens Dr","Klemer St","Klemm Ave","Klevins Ct","Klien Avenue","Klimek Boulevard","Kline Ave",
            "Kline Dr","Kline St","Klinger Ave","Klondike","Klondike Rd","Klondyke Rd","Klonowski Ave","Kloosvillie Dr",
            "Kloster Ct","Klug Cir","Knable Ln","Knapp Ave","Knapp Cir","Knapp Ln","Knapp Rd","Knapp Shore",
            "Knapp St","Knapp St NE","Knapp Way","Knapp's Knoll Rd","Knapton Avenue","Knauer Ln","Knauf Ave",
            "Knauf Rd","Kneass St","Kneeland Road","Kneeland St","Knepp Rd","Knight Ave","Knight Avenue",
            "Knight Ct","Knight Ln","Knight Loop","Knight Rd","Knight St","Knightbridge Road","Knightly Ln",
            "Knightly Road","Knighton Ln","Knighton Rd","Knights Avenue","Knights Ct","Knights Rd","Knightsboro Rd",
            "Knightsbridge Close","Knightsbridge Ct","Knightsbridge Rd","Knightwood Way","Knik Goose Bay Rd",
            "Knob Cone Trl","Knob Hill","Knob Hill Dr","Knob Hill Rd","Knob Peak Lookout Rd","Knobb Ave",
            "Knobby Kable Rd","Knobhill Dr","Knobhill Way","Knoble Pl","Knode Ave","Knole Haven Drive",
            "Knoll Cir","Knoll Dr","Knoll Ln","Knoll Pl","Knoll Rd","Knoll Road","Knoll St SE","Knoll View Dr",
            "Knollcrest Ct","Knollcrest Farm","Knollcroft Rd","Knolle Bros Rd","Knolls Crescent","Knollside Ct",
            "Knollview Ave","Knollwood Ave","Knollwood Ct","Knollwood Dr","Knollwood Drive","Knollwood Pl",
            "Knollwood Rd","Knollwood South","Knollwood Trl","Knolson St","Knott's Motel Rd","Knottingham St",
            "Knotty Pine Dr","Knotty Pine Grove","Knowles Ave","Knowles Dr","Knowles Road","Knowles St",
            "Knowlton Hill Rd","Knowlton Rd","Knox Cir","Knox Court","Knox Cove Ave","Knox Ct","Knox Dr",
            "Knox Ln","Knox Rd","Knox Road","Knox St","Knox Way","Knudsen Dr","Knudsen Ln","Knudsen St","Koabel Road S",
            "Kobala Ave","Kobe St","Koch Rd","Koch St","Koch Ter","Kodak 18 Rd","Kodak 20 Rd","Kodak 29 Rd",
            "Kodak 30 Rd","Kodak 31 Rd","Kodak Park","Kodak Water Pumping Station","Koelle Blvd","Koenig Cir",
            "Koenig Rd","Kohl Rd","Kohler Ave","Kohne Rd","Kohout Drive","Kohut St","Koisenko Trce","Koki Ln",
            "Koko Ln","Koko Reef Dr","Kokomo Ct","Kokomo Dr","Kokora Ave","Kolb Ave","Kolb Cir","Kollander Rd",
            "Kollenkark Dr","Kolliker Dr","Kolob Ct","Kolpwood Ave NW","Komura Road","Kona Dr","Kona St",
            "Konczal Ave","Konitzer Rd","Konshire","Konya Dr","Kooaukee Ct","Koons Ave","Kopernik St","Kopra St",
            "Korbel Dr","Korbel Pl","Korean Veterans Memorial Highway","Korneck Rd","Korpi St","Kory Ct",
            "Kosciusco Ave","Kosciusko St","Koshare Ct","Koshivas Drive","Kossuth Pl","Kossuth Place",
            "Kossuth St","Kotar Rd","Koteo Ln","Koths St","Kotter Ct","Kourtney Ln","Kouwenhoven Ln","Kovington Dr",
            "Kovr Dr","Kowaliga Cove Rd","Kowaliga Rd","Kozak Dr","Kozak Ln","Kozak St","Kozani St","Kozloski Rd",
            "Kozlov Street","Kozy Ct","Krafft Ct","Kraft Ct","Kram Ct","Kramer","Kramer Ave","Kramer Ct","Kramer Dr",
            "Kramer Ln","Kramer Rd","Kramer St","Krans Ln","Krause Ave","Krazy Acre Ln","Krazy Ln","Kreiger Rd",
            "Kreischer St","Kremper Ct","Kress Hill Dr","Kress St","Kress-Hansen Rd","Kressler Ave","Kresson Rd",
            "Kresswold Ln","Kreuger Ct","Krick Ct NE","Krick Road","Krider Dr","Krieger St","Krieghoff Avenue",
            "Kriger Rd","Kris Cir","Kris Dr","Kris Kringle St","Krisa Ln","Krisbury Avenue","Krista Court",
            "Krista Ct","Kristan Ln","Kristen Ct","Kristen Ln","Kristen Pl","Kristi Ln","Kristin Ct","Kristin Ct SE",
            "Kristina Crest","Kristine Dr","Kristine Ln","Kristy Ln","Krochmally Ave","Krodel Rd","Kromas Ave",
            "Krone Ln","Krosno Boulevard","Krotje Rd","Kroy Ct","Krueger Rd","Kruger Rd","Krumb St","Kruse Rd",
            "Krusen St","Kruser Rd","Krystallos Ln","Krystyna Rd","Kubin Ct","Kubinski Rd","Kubis","Kuchle St",
            "Kuck Rd","Kudder Hill Rd","Kuffel Rd","Kugler Ave","Kuhn Dr","Kuhn Rd","Kuhn St","Kuhne Rd","Kuhnley Farm Rd",
            "Kuiper Dr","Kukui Ct","Kullman Corporate Campus Dr","Kulpin Avenue","Kumeyaay Rd","Kumeyai Trl",
            "Kumpf Cir","Kuna Ave","Kunkle Rd","Kupaaq St","Kupeck Rd","Kupine Ridge","Kupo Ct","Kurenda Way",
            "Kurt & Hall Ln","Kurt Ave","Kurt Rd","Kurtis Drive","Kurtz Dr","Kurtz Rd","Kurtz St","Kusak Rd",
            "Kushla McLeod Rd","Kushnetki Rd","Kuttruff Rd","Kuykendall Pl","Kwaay Paay Mountain",
            "Kyburz Dr","Kydd Road","Kyes St","Kyle Canyon Rd","Kyle Cir","Kyle Ct","Kyle Dr","Kyle Wendelin Ln",
            "Kylemore Crescent","Kyler Ct","Kylie Lane","Kymer Rd","Kynoch Ave","Kyra Cir","Kyra Ln","Kyrsten Ter",
            "Kytan Rd","L A Aqueduct","L K Blvd","L P Haul Rd","L R 295","L St","L Street","L Walk","L and L Ct",
            "L and M Acres Dr","L'Ambiance Ct","L'Anguille Ave W","L'Anguille Rd","L.O.F. Road","LB9 Road",
            "La Altura Rd","La Baga Trl","La Bajada","La Ballena Cir","La Bamba","La Baya Dr","La Belle Dr",
            "La Belle Tr","La Belle-Bartramsville Rd","La Boheme Dr NW","La Bonita Ave","La Brea Ave",
            "La Brea Cir","La Brea Ln","La Brea St","La Brisa Rd","La Buena Tierra Ave","La Burnum Ln",
            "La Cadena Rd","La Calle Corte","La Camila Rd NE","La Canada Ct","La Canada Verdugo Rd",
            "La Casa Pl","La Casa Via","La Cascata","La Casita Ave","La Chance Cir","La Chapa Ave","La Charles Dr NE",
            "La Cienega St","La Cienega Way","La Cieniga Blvd","La Cima Ln","La Corona Trail","La Corrida Rd NE",
            "La Corte Ter","La Coruna Pl","La Costa Dr","La Costa Ln","La Crembre Rd","La Crescenta Ave",
            "La Cresenta Ave","La Cresta Ave","La Cresta Dr","La Cruz Ct","La Cuenta Ct","La Cuesta Ave",
            "La Cuesta Ct","La Cumbre Ct","La Dante St","La Dia Ct","La Due Way","La Entrada","La Entrada Ln",
            "La Entrada Rd","La Estrella St","La Fargeville Road","La Fayette Ave","La Fiesta Ave",
            "La Fleure Rd","La Fountain Road","La Fountaine Dr","La France Dr","La France Rd","La Gallina Ave",
            "La Garza","La Glenn Ln","La Gloria Rd","La Grande St","La Grange Ct","La Grange Rd","La Habra Ct",
            "La Harina Ct","La Jares","La Jolla Cir","La Jolla Ct","La Jolla Dr","La Jolla Hermosa Ave",
            "La Jolla Ln","La Jolla Village Dr","La Jolla Way","La Joya Ct","La Junta Rd","La Ladera Rd",
            "La Loma Rd","La Luna Pl","La Luz Canyon Rd","La Luz Dr","La Luz Pl","La Madera Rd","La Madre Way",
            "La Madrona Ct","La Mancha Cir","La Mancha Dr","La Mancha Pl","La Manga Trl","La Mesa Ct",
            "La Mesa Dr","La Mesa Ln","La Mesa Rd","La Mesa Way","La Mesita Dr","La Mirage Cir","La Montana Dr",
            "La Mothe Pl","La Noria","La Osa Dr","La Padera Rd","La Palma Dr","La Palma Rd","La Paloma Dr",
            "La Paz","La Paz Cir","La Paz Ct","La Piedra Beach Rd","La Pinta Street","La Plata Dr","La Plata Way",
            "La Playa St NE","La Poblana Rd NW","La Porte Rd","La Pradira Ave","La Praix St","La Puebla St",
            "La Puerta Dr","La Quebrada Pl","La Quinta Court","La Quinta Ct","La Quinta Ln","La Ramada Dr",
            "La Riviera Dr","La Robardiere Rd","La Rocca Avenue","La Roda Ct","La Roda Ln","La Roi Dr",
            "La Rosa Ct","La Rosa Dr","La Rose Avenue","La Rossa Cir","La Rue Ave","La Rue Mills Road",
            "La Sabre St","La Salina Pl","La Salle Ave","La Salle Cir","La Salle Ct","La Salle St","La Scala Lane",
            "La Secla Pl","La Selva Ave","La Sierra Ln","La Sierra St","La Sierrita Rd","La Solana Way",
            "La Sombra Ct","La Spezia Way","La Sundora Cir","La Susida Rd","La Tuna Correctional",
            "La Tuna Cyn Foot Trail","La Valley Lane","La Vante Ave","La Vereda Rd","La Verja Ct SE",
            "La Verne Ave","La Veta Ct NE","La Veta Dr","La Vida Ln","La Vida Nueva del Sur SW","La Villa Dr",
            "La Villa St","La Vina","La Vista","La Vista Dr","La Vonne Ave","La Vuelta","La Zenja Dr","Labarre Dr",
            "Labian Dr","Laborcita Canyon Rd","Labrador Crossroad","Labrador Dr","Labrador St","Labrea Ct",
            "Lac Labelle Rd","Lace Fernway","Lacefield Ln","Lacewood Drive","Lacey Ln","Lacey Station Rd",
            "Lacey Tree St","Lachenour Ave","Lackawanna Ave","Lackawanna Ln","Lackawanna Pl","Lackawanna Rd",
            "Lackawanna St","Lackawanna Valley Industrial Highway","Lackland Dr","Lackland St",
            "Lackland Ter","Lacky Dam Road","Laclair Ln","Laconia","Laconia Ave","Laconia-Gilford Byp",
            "Lacosta Ct","Lacosta Pl","Lacoste Boulevard","Lacour St","Lacroix Court Dr","Lacrosse St",
            "Lacy Ct","Lacy Ln","Lacy Pl","Lacy Rd","Ladd Avenue","Ladd Rd","Ladd Street","Ladder Ranch Rd",
            "Ladera Dr","Ladis Rd","Lado Rd","Lado del Rio Rd","Ladue Dr","Ladue St","Ladwood Dr","Lady Bug Ln",
            "Lady Churchill Court","Lady Dian Court","Lady Godiva Drive","Lady Godiva Way","Lady Slipper Lane",
            "Lady Slipper Ln","Ladybank Road","Ladybug Trail","Ladyface Ct","Ladyhawk Ct","Ladyslipper Lane",
            "Lael Ct","Lafayette","Lafayette Ave","Lafayette Ave SE","Lafayette Avenue","Lafayette Court",
            "Lafayette Ct","Lafayette Dr","Lafayette Dr NE","Lafayette Drive","Lafayette Ln","Lafayette Pl",
            "Lafayette Plaza","Lafayette Rd","Lafayette St","Lafayette Street","Lafayette Terrace",
            "Lafever Ct","Lafeyette Street","Lafferty Ln","Lafite Ct","Lafoe Ln","Lafrance Block","Lagana Rd",
            "Lagna Seca Way","Lago Rd","Lago de Palmas","Lagoon Cir","Lagoon Dr","Lagoon Ln","Lagos Ct",
            "Lagos Ln","Lagrande St SW","Lagremas St","Lagrima","Laguardia Pl","Laguna","Laguna Ave","Laguna Blvd NW",
            "Laguna Ct","Laguna Dam Rd","Laguna Grande Ct","Laguna Ln","Laguna Mirage Ln","Laguna Oaks Pl",
            "Laguna Parkway","Laguna Pl","Laguna Rd","Laguna Seca Ln NW","Laguna Serrano","Laguna St",
            "Laguna Street","Laguna Trail","Laguna Vista Dr","Lagunita Ct","Lagunitas Ave","Lahantan Dam Rd",
            "Lahinch Dr","Lahmon Ln","Lahontan Rd","Laidlaw Ave","Laidlaw Street N","Laidlaw Street S",
            "Laine Ct","Laine Rd","Laine Way","Laing Street","Laings Ave","Laingsburg","Lainie St","Lair Ct",
            "Laird Aly","Laird Ave","Laird Drive","Laird St","Lairs Run Rd","Lake Agape Dr","Lake Alice Dr",
            "Lake Angela Rd","Lake Ashmere Dr","Lake Ave","Lake Avenue","Lake Barnegat Dr N","Lake Bluff Dr",
            "Lake Bluff Road","Lake Blvd","Lake Boone Drive","Lake Bottom","Lake Bree Drive","Lake Breeze Rd",
            "Lake Brookwood Dr","Lake Candlewod","Lake Center Rd","Lake Centerton Dr","Lake Chabot Ln",
            "Lake Chabot Rd","Lake Cir","Lake Circle Dr","Lake Crescent","Lake Cross Rd","Lake Ct","Lake David",
            "Lake Dr","Lake Dr E","Lake Dr S","Lake Drive","Lake Drive N","Lake Drive North","Lake Driveway West",
            "Lake Eagle Nest Dr","Lake Earl Drive","Lake Forest Cir","Lake Forest Ct","Lake Forest Cv",
            "Lake Forest Dr","Lake Forest Dr E","Lake Forest Dr N","Lake Forest Dr W","Lake Forest Drive",
            "Lake Forest St","Lake Front Dr","Lake Front Ln","Lake Front Rd","Lake Geneva","Lake George Road",
            "Lake Grace Rd","Lake Grinnel Ln","Lake Head Road","Lake Herman Rd","Lake Hill","Lake Hill Dr",
            "Lake Hill Rd","Lake Hughes Rd","Lake Huron St","Lake Isabella Blvd","Lake Kathryn Rd W",
            "Lake Lila Dr","Lake Ln","Lake Manor Pl","Lake Manuka Rd","Lake Mary Rd","Lake Mary Road Bikepath",
            "Lake Mead Pkwy","Lake Medford Ln","Lake Michigan Dr","Lake Michigan St","Lake Miguel Rd",
            "Lake Mildred Rd","Lake Mist Dr","Lake Morey Rd","Lake Mountain Rd","Lake Oaks Dr","Lake Ontario Pl",
            "Lake Ontario State Parkway","Lake Ontario State Pky","Lake Oswego Rd","Lake Otis Pky",
            "Lake Otis Rd","Lake Pasture Rd","Lake Path","Lake Path 2 Rd","Lake Pl","Lake Point Ct","Lake Point Dr",
            "Lake Potanipo Rd","Lake Promenade","Lake Ranch","Lake Rd","Lake Ree Ave","Lake Ridg Road",
            "Lake Ridge Ct","Lake Ridge Dr","Lake Ridge Ln","Lake Ridge Pl","Lake Ridge Rd","Lake Ridge Road",
            "Lake Road","Lake Shastina Dr","Lake Sherwood Cir","Lake Sherwood Dr","Lake Shor Drive",
            "Lake Shore Boulevard Recreational Trail","Lake Shore Boulevard West","Lake Shore Cir",
            "Lake Shore Dr","Lake Shore Drive","Lake Shore Estates","Lake Shore Ln","Lake Shore Lodge Road",
            "Lake Shore Rd","Lake Shore Road","Lake Shore Way","Lake Shore Woods Rd","Lake Side Ln",
            "Lake Side Maner Dr","Lake Sites Dr","Lake Spier Dr","Lake St","Lake St N","Lake Station Rd",
            "Lake Stison Ct","Lake Street","Lake Street Extension","Lake Ter","Lake Valley Acres Rd",
            "Lake Valley Dr","Lake Valley Rd","Lake Van Geisen Rd","Lake Victoria Dr","Lake View Ave",
            "Lake View Ct","Lake View Dr","Lake View Dr W","Lake View Pl","Lake View Rd","Lake View St",
            "Lake View Ter","Lake Vista Dr","Lake Watch Ct","Lake Welch Pky","Lake West Point","Lake Wind",
            "Lake Woods Street","Lake of Meadows Rd","Lakecrest Ave","Lakedale St","Lakefield Road",
            "Lakehills Dr","Lakehurst","Lakehurst Circle Road","Lakehurst Drive","Lakehurst Naval Air Ctr",
            "Lakehurst Rd","Lakehurst Road","Lakehurst Street","Lakeknole Rd","Lakeland Avenue","Lakeland Cir",
            "Lakeland Crescent","Lakeland Dr","Lakeland Drive","Lakeland Freeway","Lakeland Fwy","Lakeland Ln",
            "Lakeland Rd","Lakelands Avenue","Lakemont Dr","Lakemont Pl","Lakeport Ave","Lakeport Blvd",
            "Lakeport Dr","Laker Ln","Lakeridge","Lakeridge Ct","Lakeridge Dr","Lakeridge Ln","Lakes Dr",
            "Lakes End Ln","Lakes Ln","Lakes Rd","Lakes Trail","Lakeshore","Lakeshore Boulevard","Lakeshore Boulevard East",
            "Lakeshore Boulevard Eastbound","Lakeshore Boulevard West","Lakeshore Ct","Lakeshore Dr",
            "Lakeshore Dr W","Lakeshore Drive","Lakeshore Road","Lakeshore Road E","Lakeshore Road East",
            "Lakeshore Road W","Lakeshore Road West","Lakeside Ave","Lakeside Ave E","Lakeside Avenue",
            "Lakeside Bloulevard","Lakeside Blvd","Lakeside Ct","Lakeside Cv","Lakeside Dr","Lakeside Dr N",
            "Lakeside Dr S","Lakeside Drive","Lakeside Dune","Lakeside Lane","Lakeside Mobile Ct",
            "Lakeside Rd","Lakeside Road","Lakeside St","Laketown Rd","Lakeview","Lakeview Ave","Lakeview Avenue",
            "Lakeview Boulevard","Lakeview Cir","Lakeview Crescent","Lakeview Ct","Lakeview Dr","Lakeview Drive",
            "Lakeview Heights","Lakeview Ln","Lakeview Pines Rd","Lakeview Rd","Lakeview Rd NE","Lakeview Road",
            "Lakeview St","Lakeview Street","Lakeview Ter","Lakeview Ter N","Lakeville St","Lakeway Blvd",
            "Lakeway Dr","Lakewood Ave","Lakewood Ct","Lakewood Dr","Lakewood Farmingdale Rd","Lakewood Pl",
            "Lakewood Rd","Lakewood St","Lakewood Way","Lakotah Ln","Lalemant Road","Lama Rd","Lamar St",
            "Lamb Ave","Lamb Extended","Lamb Rd","Lambda Dr","Lamberhurst Close","Lambert Ave","Lambert Hills Blvd",
            "Lambert Pky","Lambert Pl","Lambert Rd","Lambert Road","Lambert St","Lambert Street","Lambert Terrace",
            "Lambert Trail","Lamberton Rd","Lamberts Ln","Lambeth Road","Lamborn Ave","Lambreth Ln","Lambrook Drive",
            "Lambrusco Ln","Lambs Run","Lambson Ln","Lambuth Rd","Lamdry Ln","Lamington Pl","Lamokin St",
            "Lamont Avenue","Lamont St","Lamont Street","Lamp Rd","Lampbright Rd","Lampkin Dr","Lamplighter Ct",
            "Lamplighter Ln","Lamplighter Rd","Lampman Drive","Lamprey Cir","Lamprey Rd","Lampson St",
            "Lampton Crescent","Lamson Ln","Lamstone Street","Lana Dr","Lana Ln","Lana St","Lana Terrace",
            "Lanai Ct","Lanai Dr","Lanark St","Lanark-Gravel Ridge Rd","Lanatt St","Lanca Dr","Lancashire Blvd",
            "Lancashire Road","Lancashire St","Lancaster Ave","Lancaster Avenue","Lancaster Court",
            "Lancaster Ct","Lancaster Dr","Lancaster Ln","Lancaster Rd","Lancaster St","Lancaster Street",
            "Lance Ct","Lance Dr","Lancelot Ct","Lancelot Dr","Lancelot Lane","Lancer Drive","Lancer Ln",
            "Lancer St","Lancey Cir","Lancome St","Land Ave","Land Fill Rd","Landa St","Landau Lane","Landdin Rd",
            "Landen Court","Lander Ave","Lander Dr","Landers Lane","Landers Rd","Landers St","Landers Street",
            "Landfill Rd","Landgraph Ave","Landing","Landing Ln","Landing Rd","Landing Rd S","Landing St",
            "Landis Ave","Landis St","Landline Rd","Landlock Landing","Landmark Dr","Landmark Ln","Landmark Way",
            "Landon Dr","Landon Ln","Landon Ln SW","Landon Street","Landover Rd","Landry Ln","Landsborough Avenue",
            "Landsbridge Street","Landsdowne Rd","Landsford St","Landucci Rd","Landy St","Lane 101","Lane 109",
            "Lane 130A Lake George","Lane 140A Lake George","Lane 150 Long Lake","Lane 150C Jimmerson Lake",
            "Lane 240 Lake Gage","Lane 3","Lane 301B Lake George","Lane 385 Big Otter Lake","Lane 470 A Lake James",
            "Lane 490A Lake James","Lane 5","Lane 650Ab Snow Lake","Lane 650Ad Snow Lake","Lane 880 Snow Lake",
            "Lane Ave","Lane C","Lane Cir","Lane Dr","Lane E","Lane F","Lane G (West Side)","Lane Hill Rd",
            "Lane Marion Way","Lane Rd","Lane Road","Lane Scholl Yarnel Rd","Lane Way","Lanes End","Lanes Mill Rd",
            "Lanesboro Way","Lanesborough Road","Lanewood Dr","Lang Court","Lang Farm Rd","Lang Rd","Lang Road",
            "Lang Ter","Langan Ct","Langdale Rd","Langdon Ct","Langdon G Burwell Drive","Langdon Lane",
            "Langdon Rd","Langdon St","Lange Ave","Langemark Avenue","Langford Drive","Langham Street",
            "Langhart Ct","Langholm Ln","Langhorne Newtown Rd","Langley Pl","Langley Rd","Langley St",
            "Langmaid Road","Langman Drive","Langner Creek Rd","Langon Hollow Rd","Langstaff Road",
            "Langstaff Road East","Languid Ln","Lanhold Dr","Lanier St","Laning Dr","Laning St","Lankenau Ave",
            "Lankester Lane","Lankin Boulevard","Lannette","Lanning Ln","Lanning Ter","Lanora Ave","Lansdale Ave",
            "Lansdale Pl","Lansdale Rd","Lansdowne Ave","Lansdowne Avenue","Lansdowne Ct","Lansdowne Dr",
            "Lansdowne Street W","Lansford St","Lansing Ave","Lansing Ct","Lansing Rd","Lansing St","Lansinger Rd",
            "Lantados St","Lantana Ave","Lantana Dr","Lantana Way","Lantern Court","Lantern Ct","Lantern Lane",
            "Lantern Ln","Lantuck Rd","Lanvale Pl","Lanyard Ct E","Lanyard Road","Lanza Ave","Laomatong Rd",
            "Lapaz Rd","Lapeer Ct","Lapell's Road","Lapham Ln","Lapham Way","Lapierre Ave","Lapierre Avenue",
            "Lapine Ave","Lapis Cir","Laplante' Road","Lapointe Dr","Lapon Canyon","Lappe Avenue","Lappley Ave NE",
            "Lapsley St","Laqueda Dr","Lar Ct","Larabee Ranch Rd","Laracor Lane","Laramee St","Laramie Ave",
            "Laramie Cir","Laramie Lane","Laramie Rd","Laramie Way","Larboard St","Larch Ave","Larch Ct",
            "Larch Ln","Larch Row","Larch St","Larchen Ln","Larchmont Ave","Larchmont Blvd","Larchmont Circle",
            "Larchmont Pl","Larchmont Rd","Larchview Trail","Larchwood Ave","Larchwood Cir","Larchwood Dr",
            "Larchwood Rd","Larchwood Way","Larcridge Lane","Lard Pond Rd","Larder Way","Lardner Rd",
            "Largent Cir","Largo Ln","Largs Ln","Lariat Ct","Lariat Dr","Lariat Ln","Larissa Ct","Lark Ave",
            "Lark Ave SW","Lark Dr","Lark Ln","Lark Ln SE","Lark Pl","Lark St","Lark Street","Larkfield Dr",
            "Larkin Aly","Larkin Ct","Larkin Dr","Larkin Lane","Larkin Ln","Larkin Pl","Larkin Road","Larkin St",
            "Larkin Street","Larkmead Addition","Larkmead Crescent","Larks Meadow","Larkspur Ave",
            "Larkspur Close","Larkspur Ct","Larkspur Ln","Larkspur Rd","Larkstone Ln","Larkwood Ave",
            "Larkwood Dr","Larmer Line","Larnaca Road NE","Larne Pl","Larned St","Laronde Avenue","Larosa St",
            "Larose St","Larrea Ave","Larry Dr","Larry Ln","Larrylyn Dr","Larrys Camp Rd","Lars Ln","Larsen Ln",
            "Larsen St","Larson Ave","Larson Ln","Larson Rd","Larue Rd","Larue St","Larwood Boulevard","Larwood Dr",
            "Larzelere Ave","Las Alturas Rd","Las Brisas Dr","Las Colinas Dr","Las Cruces Rd","Las Flores Ln",
            "Las Flores Pl","Las Granjas Dr","Las Hadas","Las Hermanas St NW","Las Lilas Ct","Las Llajas",
            "Las Lomas Dr","Las Mananitas St","Las Moradas Cir","Las Palmas St","Las Plumas Ct","Las Posadas Entrance",
            "Las Posas St","Las Ramblas Dr","Las Road","Las Rosas Rd SW","Las Tigres Dr","Las Tunas Dr",
            "Las Varas Cyn Rd","Las Vegas Boulevard","Las Vigas Ln","Las Vista St","Las Vistillas Ln",
            "Lasa Dr","Lasa Ln","Lasaine Ave","Lasalle Ave","Lasalle Cir NE","Lasalle Dr","Lasalle St","Lasalle Street",
            "Laser St","Lash Pl","Lash Rd","Lash Street","Lashbrook Ave","Lasher Lane","Lasher Rd","Lashkoff Rd",
            "Lashley Dr","Lashley Hill Rd","Lasky St","Laspina St","Lassen","Lassen Ave","Lassen Ct","Lassen Dr",
            "Lassen Ln","Lassen Peak Parking","Lassen St","Lassen Trl","Lassen Way","Lasseter Dr","Lasso Trl",
            "Lassonde Street","Last Chance Ln","Last Chance Rd","Last Frontier Cir","Last Trampas Ridge Trail",
            "Latache Ct","Latana Ave","Latania Boulevard","Latches Ln","Lath Ln","Latham","Latham St","Latham Terrace",
            "Latham Trl","Lathers Avenue","Lathrop Rd","Lathrup Blvd","Latifee Ct","Latigo Cir","Latigo Dr",
            "Latigo Ln","Latigo Loop","Latigo St","Latigo Trl","Latimer Ave","Latimer St","Latimer Ter",
            "Latin Way","Latisha Ln","Latitude Lane","Latona Rd","Latona St","Latour Ct","Latourette St",
            "Latoya Rd","Latrobe Rd","Latrobe St","Latteri Ct","Lattimer Hill Rd","Lattin Rd","Latton Road",
            "Latvia Court","Lauckson Pl","Lauderdal Crescent","Lauderdale County 100","Lauderdale County 107",
            "Lauderdale County 261","Lauderdale County 299","Lauderdale County 33","Lauderdale County 34",
            "Lauderdale County 363","Lauderdale County 390","Lauderdale County 394","Lauderdale County 447",
            "Lauderdale County 462","Lauderdale County 501","Lauderdale County 55","Lauderdale County 551",
            "Lauderdale County 593","Lauderdale County 60","Lauderdale County 66","Lauderdale County 8",
            "Lauderdale County 83","Lauderdale County 89","Lauderdale County 92","Lauderdale County 94",
            "Lauderdale Dr","Laugher Avenue","Laughing Cow Rd","Laughing Horse Ln","Laughlin Dr NW",
            "Laughlin Ln","Laughlin Way","Laumaster St","Launch Gate","Launch Ln","Launch Ramp Rd","Launt Hollow Rd",
            "Lauppe Ln","Laura Ave","Laura Cir","Laura Ct","Laura Dr","Laura Herbert Dr","Laura Lane","Laura Lee Ave NE",
            "Laura Ln","Laura Ln SE","Laura Rd","Laura St","Laura Street","Laural Run","Laurel","Laurel Ave",
            "Laurel Ave SW","Laurel Avenue","Laurel Blvd","Laurel Canyon Blvd","Laurel Cherry Ct",
            "Laurel Cir","Laurel Creek Rd","Laurel Crest Dr","Laurel Ct","Laurel Dr","Laurel Drive","Laurel Glen Dr",
            "Laurel Hill Blvd","Laurel Hill Rd","Laurel Hill St","Laurel Hill Terrace","Laurel Lane",
            "Laurel Ln","Laurel Ln N","Laurel Mountain Rd","Laurel Mtn Rd","Laurel Park Dr","Laurel Path",
            "Laurel Pl","Laurel Place","Laurel Place Plz","Laurel Pond Trl","Laurel Rd","Laurel Ridge Ct",
            "Laurel St","Laurel Street","Laurel Trl","Laurel Way","Laurel Wood Ct","Laurelcrest Avenue",
            "Laurelhurst Dr","Laurellen Rd","Laurelton Dr","Laurelwood Cemetary","Laurelwood Dr","Laurelwood St",
            "Laurelwood Street","Lauren Ct","Lauren Ln","Lauren Pl","Laurence Ct","Laurenita Way","Laurentid Avenue",
            "Lauretti Ct","Lauriano Dr","Laurie Cir","Laurie Ct","Laurie Dr","Laurie Ln","Laurier Road",
            "Laurin Dr","Laurjoe St","Lauryn Ridge Ct","Lause Bay","Lava Cap Rd","Lava Loop Rd","Lava Pl",
            "Lava Ridge Ct","Lavake","Lavant Mill Road","Lavas Road","Lave Bed Rd","Lavela Rd","Lavelli Way",
            "Lavender Dr","Lavender Gate Dr","Lavender Ln","Lavender Star Dr","Lavene Ct","Lavenham Ct",
            "Laver Ct","Laverne Ave","Laverne Street","Laverock Drive","Laverton Way","Lavet Rd","Laveta Ln",
            "Lavina Ter","Lavinia Ave","Laviolette Street","Lavoie Ln","Lavon","Lavon Dr","Lavon New Ln",
            "Lavron Court","Lavuelta Rd","Lavy Ct","Law Dr","Law St","Lawler St","Lawles Tr","Lawley Ct","Lawley Rd",
            "Lawman Ln","Lawman Rd","Lawn Ave","Lawn Ridge Rd","Lawn St","Lawn Street","Lawnbank Road","Lawndale Ct",
            "Lawndale St","Lawndale Street","Lawnsbury Dr","Lawnsdale Rd","Lawnside Dr","Lawnside Drive",
            "Lawnview St","Lawnwood Ct","Lawrence Ave","Lawrence Avenue","Lawrence Avenue East","Lawrence Avenue West",
            "Lawrence Cir","Lawrence Ct","Lawrence Ct NE","Lawrence Dr","Lawrence Drive","Lawrence Hill Rd W",
            "Lawrence Landing Rd","Lawrence Ln","Lawrence Pl","Lawrence Rd","Lawrence Rd 554","Lawrence Road",
            "Lawrence Road 1170","Lawrence Road 137","Lawrence Road 214","Lawrence Road 607","Lawrence Road 631",
            "Lawrence St","Lawrence Way","Laws Ln","Laws Poleta Rd","Lawshe Dr","Lawson Ave","Lawson Court",
            "Lawson Dr","Lawson Oaks Dr","Lawson Rd","Lawson Street","Lawton","Lawton Ave","Lawton Dr","Lawton Hill Rd",
            "Lawton St","Lawton St SE","Laxton Ln","Lay Rd","Layer Rd","Layfayett St","Layfayette Ct","Layfield Dr",
            "Layfield St","Layman Rd","Layman St","Laynya Ln","Layton Ct NE","Layton Pl NE","Layton Springs Rd",
            "Layton St","Layton Street Rd","Lazarine Ct","Lazo Dr","Lazulite Ln","Lazy Bear","Lazy Buck Rd",
            "Lazy Cir","Lazy Joe Ave","Lazy L Ln","Lazy L Ranch Rd","Lazy M Loop","Lazy Meadow Ct","Lazy R Ln",
            "Lazy V Ln","Lazybrook Cir","Lazys Dr","Lazzari Ln","Le Blanc Rd","Le Bon Air Trl","Le Conte St",
            "Le Flore Pl","Le Grande Ave","Le Havre Ln","Le Jean Way","Le Parc","Le Point St","Le Ranch Rd",
            "Lea Crescent","Lea Ct","Lea Grove Crescent","Lea Ln","Lea St","Leach Canyon Rd","Leach Ln",
            "Leach St","Leachman Rd","Leacock Lane","Leacrest Cv","Lead Ave SW","Lead Hill Rd N","Lead Mountain Rd",
            "Lead St","Leader Lane","Leadership Ct","Leadivelle Ln","Leadley Lane","Leadmine Road","Leaf Ave",
            "Leaf Ct","Leaf Dr","Leaf Ln","Leaf St","Leafland St NW","Leafwood Cir","Leafwood Ct","Leafy Hill Ln",
            "Leagate Road","League St","Leah Ln","Leah St","Lealand Rd","Leameadow Way","Leaming Ave","Leamington Cir",
            "Leamington Pl","Leamy Ave","Leander Rd","Leander St","Leandra Way","Leandre St","Leaning Pine Way",
            "Leaning Rock Ct","Leann Blvd","Leanne Boulevard","Leanne Ter","Leanto Ln","Leap Ct","Leap Dr",
            "Learned Rd","Leary Ln","Leata Ter","Leather St","Leatherleaf Drive","Leavell Dr","Leavenworth Ave",
            "Leaverite Way","Leavitt","Leavitt Ln","Leavitt Street","Leavorite Dr","Leawood Ave","Leawood Drive",
            "Leawood Ln","Lebanon Hill Road","Lebanon St","Leblanc Ave","Leblanc Rd","Lecarre Dr","Lechler Mtwy",
            "Lechuga St","Leckron Rd","Leclair St","Lecta-Mercerville Rd","Ledbetter Ave","Ledbetter Cv",
            "Ledbetter St","Ledbury Street","Leddell Pond Rd","Ledge Dr","Ledge Ln","Ledge Rd","Ledge Rock Trl",
            "Ledge St","Ledgebrook Rd","Ledgecroft Pl","Ledgehill Rd","Ledgerock Cir","Ledgerock Ln",
            "Ledges","Ledges Rd","Ledgewater Dr","Ledgeway","Ledgewood Dr","Ledgewood Drive","Ledgewood Hills Dr",
            "Ledgewood Rd","Ledgewood Trl","Ledo Pl","Ledo Rd","Ledoux Rd","Ledru Ave","Leduc Rd","Lee","Lee Ann Ln",
            "Lee Ave","Lee Avenue","Lee Avenue W E","Lee Cir SE","Lee Circle","Lee Court","Lee Ct","Lee Ct NW",
            "Lee Dr","Lee High Cir","Lee Hope Rd","Lee Hwy","Lee Jackson Ct","Lee Lake Water District Rd",
            "Lee Ln","Lee Pl","Lee Ranch Commino Rd","Lee Rd","Lee Rd 351","Lee Road","Lee Road 144","Lee Road 155",
            "Lee Road 244","Lee Road 306","Lee Road 324","Lee Road 346","Lee Road 609","Lee Road 629",
            "Lee St","Lee Street","Lee Vining Ave","Lee Westfield Road","Leech Lake Rte 50","Leech Street",
            "Leed Ave","Leeds Ave","Leeds Ct","Leeds Lane","Leeds Rd","Leeds St","Leeds Street","Leedsville Rd",
            "Leek Ln","Leeli Road","Leeman Rd","Lees Creek Rd","Lees Mills Rd","Leesburg Ln","Leesburg Street",
            "Leeshore Road","Leeside Dr","Leesville Rd","Leetonia Rd","Leeward Dr","Leeward Dr N","Leeward Drive",
            "Leeward Spur","Leeward Way","Leewood Dr","Lefebvre Rd","Leff Ln","Lefferts Ave","Leffingwell Pl",
            "Leflrore County Green St","Left Fork Laurel Creek","Left Fork Sandy","Left Fork Union Ridge Rd",
            "Left turn lane","Leftwich Ln","Legacy Court","Legacy Ct","Legacy Pointe Pky","Legacy Way",
            "Legate Hill Road","Legato Court","Legends Way","Legero Ln","Legg Fork Rd","Legg Rd","Legge Hill Rd",
            "Leggs Ln","Legion Ave","Legion Avenue","Legion Dr","Legion Pl","Legion Place","Legion Rd","Legion Street",
            "Legion Way","Legislative Ave","Legris Ave","Lehigh Ave","Lehigh Blvd","Lehigh Ct","Lehigh Dr",
            "Lehigh Rd","Lehigh St","Lehigh Station Rd","Lehigh Valley Linear Trail","Lehigh Valley Thruway",
            "Lehigh Valley Trail","Lehigh Way","Lehman Ave","Lehman Ln","Lehman St","Lehs Lane","Leibeck Rd",
            "Leicester Ln","Leicester Street","Leidenfrost Rd","Leif Erickson Memorial Highway",
            "Leifer St","Leigh Ave","Leigh Cir","Leigh Rd","Leighton Ave","Leighton Ct","Leighton Ln","Leighton Place",
            "Leighton Ter","Leila St","Leinig Way","Leins Rd","Leiper St","Leis Pl","Leisure Ln","Leisure Park Cir",
            "Leisure Village Dr","Leisure World","Leitchcroft Crescent","Leith Court","Leith Hill Road",
            "Leith St","Lelah Ln","Leland Avenue","Leland Cir","Leland G Wright Ave","Leland Gulch Rd",
            "Leland Rd","Leland Road","Leland St","Lemarsh St","Lemay St","Lembeck Ave","Lembert Dome Ct",
            "Lembi Dr","Lembo Dr","Lemert St","Leming St","Lemoine Ave","Lemon Ave","Lemon Ct","Lemon Dr","Lemon Hill Dr",
            "Lemon St","Lemondrop Ct","Lemontree Ln","Lemonwood Dr","Lemonwood Ln.","Lemonwood St","Lemoore Naval Air Station",
            "Lemore Cir","Lemos Rd","Lemoyne St","Lemp Ave","Lemsford Drive","Lemur Dr","Len Cir","Lena Ave",
            "Lena Crescent","Lena Ct","Lena Dr","Lena Landegger Hwy","Lena Mac's Way","Lena Rd","Lenape Dr",
            "Lenape Ln","Lenape Rd","Lenape Trail (Yellow)","Lenape Trl","Lenape Way","Lenapi Dr","Lenard Cir",
            "Lenarthur Court","Lenawee Rd","Lender St","Lenevar Ave","Leng St","Lenni Ct","Lenni Lenape Ct",
            "Lennon Trail","Lennox Ave","Lennox Ln","Lennox Road","Lenny Ln","Leno Mills Avenue","Lenolt St",
            "Lenoras Way","Lenore","Lenore Ave","Lenore Avenue","Lenore Way","Lenox Ave","Lenox Avenue",
            "Lenox Ct","Lenox Pl","Lenox Rd","Lenox Road","Lenox St","Lenox Street","Lenox Ter","Lens Fork St",
            "Lensmith Drive","Lent Ave","Lenteja Ln","Lenters Dr","Lentz Rd","Lenzen Ct","Leo Bingo Ct",
            "Leo J Bidwell Ave","Leo Ln","Leo Pl","Leo St","Leola St","Leolang Ave","Leon Ave","Leon Cir","Leon St",
            "Leona Ave","Leona Ct","Leona Ln","Leona St","Leonard","Leonard Ave","Leonard Avenue","Leonard Circle",
            "Leonard Dr","Leonard Lake Rd","Leonard Pl","Leonard Rd","Leonard St","Leonard St SE","Leonard Street",
            "Leonard Way","Leonard Young St","Leone Dr","Leone St","Leonhardt St","Leoni Dr","Leonia Ave",
            "Leonor Drive","Leons Rd","Leopard Lilly Dr","Leopard Way","Leopold Ter","Leora Court","Leoson Pky",
            "Leota Ave","Leota Ln","Leparc Road","Lepine Drive","Leprechaun Ln","Lequita Pl","Leray St",
            "Leroy Ave","Leroy Avenue","Leroy Court","Leroy St","Leroy Street","Lesa Ln","Lesgay Crescent",
            "Lesher Aly","Lesko Ln","Lesley Avenue","Leslie Ave","Leslie Avenue","Leslie Foster Highway",
            "Leslie Greenbelt","Leslie Leas Dr","Leslie Ln","Leslie Pl","Leslie Rd","Leslie St","Leslie Street",
            "Lesmill Road","Lesmount Avenue","Lesperance Court","Lesser Pky","Lesser Way","Lester Dr",
            "Lester Lane","Lester Rd","Lester St","Lestina Beach Rd","Lesuer Rd","Letas Trl","Letcher Street",
            "Letchworth Crescent","Letendre Avenue","Letitia Ln","Letteau Ave","Letterman","Letts Ct",
            "Letts Landing Rd","Letts Valley Rd","Letz Ave","Leue Ave","Lev Ave","Leva Ln","Leval Road",
            "Levasseur Rd","Levee","Levee Rd","Levelland Pl","Leverett Street","Leverette Ln","Levering Way",
            "Leveroni Rd","Levert Rd","Levesque Dr","Levey Ditch Camp Rd","Levgar St","Levi Ct","Levi St",
            "Leviathan Mine Rd","Levick St","Levoy Ln","Lew Alice Dr","Lewallen Rd","Lewandoski Pl","Lewandowski St",
            "Lewellyn Dr","Lewes Crescent","Lewis Ave","Lewis Carroll Way","Lewis Creek Trail","Lewis Ct",
            "Lewis Dr","Lewis Flats Rd SE","Lewis Hill Rd","Lewis Ln","Lewis Mountain Cir","Lewis Mountain Rd N",
            "Lewis Park","Lewis Pl","Lewis Ranch Rd","Lewis Rd","Lewis Road","Lewis St","Lewis St NE","Lewis Street",
            "Lewis Street W","Lewis Way","Lewis and Clark Rd","Lewisburg Aly","Lewisburg Rd","Lewiston Rd",
            "Lewiston Road","Lewmay Dr","Lex Dr SW","Lexfield Avenue","Lexie Dr","Lexington Ave","Lexington Ave NW",
            "Lexington Avenue","Lexington Ct","Lexington Dr","Lexington Drive","Lexington Hills Rd",
            "Lexington Ln","Lexington Park Rd","Lexington Pl","Lexington Rd","Lexington St","Lexington Street",
            "Lexington Ter","Lexow Ave","Ley Pl","Leyendecker Rd NE","Leyland Avenue","Leyte Pl","Leyte St",
            "Liah Lane","Liana Street","Liar Rd","Libby Ct","Libby Dr","Libby Ln","Libcrest Dr","Liberal Ave",
            "Liberato Court","Liberator Cir","Liberta Pl","Liberty Aly","Liberty Ave","Liberty Bell",
            "Liberty Blvd","Liberty Church Rd","Liberty Cir N","Liberty Cir S","Liberty Corner Rd",
            "Liberty Ct","Liberty Dr","Liberty Estates Dr","Liberty Hill","Liberty Hills Ct","Liberty Island Rd",
            "Liberty Ln","Liberty Pl","Liberty Point Cv","Liberty Pointe Drive","Liberty Rd","Liberty Road",
            "Liberty School Rd","Liberty Springs Rd","Liberty St","Liberty Street","Liberty Village",
            "Liberty Way","Libra Cir","Libra Cir SW","Libra Ln","Libra Rd NE","Libra Road","Library Ct",
            "Library Dr","Library Lane","Library Ln","Library Rd","Library St","Library Street","Library Way",
            "Libre Glen","Libre Plz","Licciardello Dr","Lichen Court","Lida Ln","Liddington Hill Rd",
            "Lidell Rd","Lidia Pl","Lido Ave","Lido Dr","Lido Ln","Lido Way","Lieb Ln","Liehs","Liela Dr","Lierly St",
            "Liese Ave","Life Ave","Lifford Road","Lift Lock Road E","Liggett Rd","Liggett St","Light Ave",
            "Light Breeze Dr","Light Rd","Light Sky Ave","Light St","Lighterwoods Dr","Lightfoot Ln",
            "Lighthill Rd","Lighthouse Beach Rd","Lighthouse Ct","Lighthouse Dr","Lighthouse Ln","Lighthouse Point",
            "Lighthouse Rd","Lighthouse Way","Lightning Street","Lightsfoot Ln","Lightwood Ln","Likens St",
            "Lil Bit Way","Lila Rose Ct","Lila St","Lila Street","Lilac Ave","Lilac Court","Lilac Crest",
            "Lilac Ct","Lilac Lane","Lilac Ln","Lilac Rd","Lilac Springs Ct","Lilac St","Lilac Trl","Lilac Valley Road",
            "Lilac Way","Lile Ln","Lilian Drive","Lillebakke","Lillebakke Ct","Lillian Candie Rd","Lillian Court",
            "Lillian Ct","Lillian Pl","Lillian Rd","Lillian St","Lillian Street","Lillias Street","Lillibet Road",
            "Lilliput Ln","Lilliput Road","Lilly Dr","Lilly Pond Dr","Lilly Rd","Lily Ave","Lily Ct","Lily Dr",
            "Lily Gap Rd","Lily Lavelle Ln","Lily Ln","Lily Mar Ln","Lily McKeowan Crescent","Lily Pond Rd",
            "Lily Rd","Lilywood Road","Limcombe Drive","Lime Bank Rd","Lime Canyon","Lime Drive","Lime Kiln Ct",
            "Lime Kiln Rd","Lime Point St","Lime Ridge Trail","Lime St","Lime Stone Sink Ln","Lime Street",
            "Limehurst Trailer Park Dr","Limekiln Rd","Limekiln Trail","Limerick Acres","Limerick Ave",
            "Limerick Dr","Limerick Forest Road","Limerick Hts","Limerick Hts Dr","Limerick Ln","Limeridge Drive",
            "Limestone Ct","Limestone Dr","Limestone Rd","Limetree Ln","Limevale Crescent","Limley Dr",
            "Lin Aly","Lin Mar Ln","Lina Ln","Linaberry Rd","Linares Ave","Linch Canyon Dr","Lincklaen Center Rd",
            "Lincoln","Lincoln Aly","Lincoln Ave","Lincoln Ave N","Lincoln Avenue","Lincoln Blvd","Lincoln Cir",
            "Lincoln Circle","Lincoln Court","Lincoln Ct","Lincoln Ctr SW","Lincoln Dr","Lincoln Green Close",
            "Lincoln Green Dr","Lincoln Hwy","Lincoln Ln","Lincoln Oval","Lincoln Park","Lincoln Parkway",
            "Lincoln Pky","Lincoln Pl","Lincoln Place","Lincoln Rd","Lincoln Road","Lincoln Sq","Lincoln St",
            "Lincoln Street","Lincoln Street Connector","Lincoln Ter","Lincoln Terrace","Lincoln Tunnel Expressway",
            "Lincoln Woods Rd","Lincolnshire Dr","Lincolnway West","Lincolnwood Dr","Lincroft Dr",
            "Lind Ct","Lind Haven Dr","Lind Ln","Lind N Johnson Ln","Linda Ann Ct","Linda Anne Ct","Linda Ave",
            "Linda Cir","Linda Ct","Linda Dr","Linda Lee Ave","Linda Lee St","Linda Ln","Linda Ln W","Linda Pl",
            "Linda Rd","Linda Road","Linda Rosa Ave","Linda St","Linda Street","Linda Vista Ave","Linda Vista Dr",
            "Linda Vista St","Linda Vista Steps St","Linda Way","Lindaro Ct","Lindavista Dr","Lindberg Ave",
            "Lindberg Rd","Lindberg St","Lindbergh Ave","Lindbergh Blvd","Lindel Street","Lindemann Ave",
            "Linden Ave","Linden Ave SE","Linden Ave.","Linden Avenue","Linden Boulevard","Linden Court",
            "Linden Crescent","Linden Ct","Linden Dr","Linden Fields","Linden Grove Ln","Linden Lime Ct",
            "Linden Ln","Linden Pl","Linden Place","Linden Rd","Linden St","Linden Street","Linden Technical Park",
            "Linden Ter","Linden Tree Ln","Lindenshire Avenue","Lindenwood Rd","Linderman Rd","Lindero Ave",
            "Lindesta Rd","Lindley Street","Lindman Street","Lindner Ln","Lindo Ct","Lindo Park Dr","Lindo St",
            "Lindora St","Lindsay Ct","Lindsay Lane","Lindsay Ln","Lindsay Pl","Lindsay Rd","Lindsay St",
            "Lindsay Street","Lindsay Street N","Lindsey Ave","Lindsey Avenue","Lindsey Dr","Lindsey Farm Road",
            "Lindsey Hollow Rd","Lindsey Ln","Lindsey Rd","Lindsey St","Lindsley Rd","Lindy Ave","Lindy Ln NE",
            "Lindy Pl","Lindylou Road","Lindys Tr","Line 3 Road","Line 4 Road","Line 5 Road","Line 8","Line 8 Road",
            "Line Aly","Line Ave","Line Rd","Line St","Linebrook Road","Lineside Dr","Linfield Ave SE","Linford Ter",
            "Linger Ln","Linhart St","Linholm Rd","Link Ln","Link Pl","Link St","Link Street","Links Ave","Links Ct",
            "Links Road","Linkview Dr","Linlake Drive","Linlen Ave","Linlithgow Ln","Linmar Way","Linmore",
            "Linmore Ave","Linn Cox S Mills","Linn Street","Linne Rd","Linnea Ln","Linnell Way","Linnet St",
            "Linns Ct","Linnsmore Crescent","Linrose Avenue","Linsey Ln","Linsky Ln","Linsmore Crescent",
            "Linson Rd","Linstead Court","Linstedt Street","Linter Rd","Linton Ave","Linton Park Road",
            "Linton St","Linus Ct","Linville Dr","Linville St","Linwood Ave","Linwood Avenue","Linwood Dr",
            "Linwood Drive","Linwood Rd","Linwood St","Linwood Street","Linwood Terrace","Linwood Way",
            "Lio Avenue","Lion Dr","Lion Heart Ct","Lion Pl","Lionel Ave","Lionhead Trail","Lionheart Lane",
            "Lions Cir","Lions Mouth Road","Lions Road - Morrisburg","Lionstone Drive","Lipan St",
            "Lipari West Dr","Lipizzan Rd","Lipman Dr","Lipowitz Ave","Lippincott St","Lippitt Ave","Lippitt Development Rd",
            "Lipply Rd","Lippman Rd","Lipsett Ave","Liptak Ln","Lipton","Lipton Ave","Lipton Avenue","Liquidamber Ln",
            "Lirious Ave","Lisa Ann Dr","Lisa Court","Lisa Ct","Lisa Denise Ct","Lisa Dr","Lisa Drive","Lisa Lane",
            "Lisa Ln","Lisa Rd","Lisa Road","Lisa Vista","Lisamy Drive","Lisbon Canfield Rd","Lisbon Pl",
            "Lisbon Rd","Liscomb Street","Liscombe Road","Liscum St","Lisgar Street","Lisk Ave","Lismic Boulevard",
            "Lismore Green","Lissom Crescent","Lister Dr","Lister St","Liston Ave","Liston Ln","Listowel Line",
            "Liszt Gate","Lita Ln","Lita Pl","Litaker Ridge Rd","Litchfield Rd","Litchfield St","Litchfield Street",
            "Litchfield Tpke","Litchi Grove Ct","Litchi Way","Litt Dr","Littell Rd","Little","Little Alum Pond Road",
            "Little Aston Cir","Little Ave","Little Avenue","Little Beach Lake Rd","Little Bear No 3",
            "Little Bear Trl","Little Beaver Rd","Little Bone Run Rd","Little Boulevard","Little Boy Rd",
            "Little Boys Ct","Little Britain Road","Little Broadway St","Little Brook Ln","Little Brook Rd",
            "Little Brook Way","Little Bullskin Rd","Little Cacapon River Rd","Little Calf Pastures Hwy",
            "Little Chestang Rd","Little Clear Lake Rd","Little Cow Creek","Little Creek Cir","Little Creek Ln",
            "Little Creek Rd","Little Creek Road","Little Ct","Little Dann Creek Rd","Little Drive",
            "Little Dry Creek Rd","Little Fawn Ct","Little Field Pl","Little Forks Square","Little Gate",
            "Little Hannah Lane","Little Hedge Connect","Little Heron Ct SE","Little Herring Pond Road",
            "Little Hill Ln","Little Hill Rd","Little Hope Rd","Little Horsethief Canyon Rd","Little Hunter St",
            "Little Island Park","Little John","Little John Ct","Little John Dr","Little John Lane",
            "Little John Mgt Area Sthy","Little John Rd","Little Lake Rd","Little Ledge Rd","Little Ln",
            "Little Mill Rd","Little Moose Jaw Way","Little Mountain Rd","Little Neck Road","Little Oak Ln",
            "Little Ol Ct","Little Otter Dr","Little Paddy Rd W","Little Pigeon Bay Road","Little Pine Road",
            "Little Pine Way","Little Point Rd","Little Pond Rd","Little Rd","Little Rideau Lake Road",
            "Little River 14 N","Little River 212","Little River 284","Little River 72","Little River Rd",
            "Little River72","Little Road","Little Run Rd SW","Little Sandy Pond Road","Little Sandy Rd",
            "Little Shuteye Rd","Little Silver Pky","Little Spring Brook Road Spur","Little Springs Rd",
            "Little St","Little Tom Rd","Little Trappe Rd","Little Traverse Rd","Little Valley Rd",
            "Little Walker Rd","Little Weaver Ln","Little Weoka Creek Rd","Little West Street",
            "Little Wild Horse","Little York Mount Pleasant Rd","Little York Pattenburg Rd",
            "Little York Right of Way","Little's Ln","Littlecroft Rd","Littlefield Dr","Littleford Street",
            "Littlejohn Lane","Littleleaf Crescent","Littler Dr","Littler Ln","Littleton Rd","Littleton Road",
            "Littleton Sayre Rd","Littlewood Ct","Littlewood Drive","Litton Rd","Litwa Ln","Live Oak",
            "Live Oak Ave","Live Oak Ct","Live Oak Dr","Live Oak Knolls Dr","Live Oak Meadow Rd","Live Oak Rd",
            "Live Oak St","Live Oak Ter","Liverpool Ave","Liverpool Cir","Liverpool Ct","Liverpool Rd",
            "Liverpool Road","Liverpool Way","Livery Ct","Livery Way","Livesey Parkway","Living Waters Rd",
            "Livingston","Livingston Ave","Livingston Avenue","Livingston Cir","Livingston Ct","Livingston Dr",
            "Livingston Ln","Livingston Park","Livingston Pky","Livingston St","Livingston Street",
            "Livingstone Road","Livley Cir","Livolsi Dr","Livonia Ave","Livorna Heights Rd","Liz Cir",
            "Liza Robyn Cir","Lizard Ct","Lizzie Ave","Lk Macatawa Campground","Llama Ln","Llama Ranch Rd",
            "Llanberris Rd","Llanito Lindo","Llano Ct NW","Llano Delnorte","Llano Vista Rd","Llano del Norte",
            "Llavanna Dr","Llewellyn Pky","Lloyd Ave","Lloyd Avenue","Lloyd Ct","Lloyd Ln","Lloyd Manor Road",
            "Lloyd St","Lloyd Street","Lloyd Watson Rd","Lloydsville Bannock Rd","Lo Hi Way","Loafers Ln",
            "Loan Cove Rd","Loan Oak Dr","Loanda Ln","Loantaka Ln S","Lobelia Ct","Lobinger Ave","Lobo Dr",
            "Lobo Rd","Lobos St","Locey Rd","Loch Achray Cv","Loch Ln","Loch Lomand","Loch Lomond Way","Loch Lynn St",
            "Loch Ness Crescent","Lochdale St","Locheil Rd","Lochiel St","Lochland Dr","Lochlin Train",
            "Lochness","Lochness Crescent","Lock Rd","Lock St","Lock Street W","Lock Way","Lock's Rd","Lockdare Street",
            "Locke Cir","Locke Ln","Locke Rd","Locke Road","Locke Street","Locke View Dr","Locker Drive",
            "Lockerbie Dr","Lockerby Ln","Lockett Rd","Lockewood Ln","Lockhart","Lockhart Cir","Lockhart Dr",
            "Lockhart Drive","Lockhart Hill Rd","Lockhart Road","Lockhart St","Lockheed Martin Way",
            "Lockie Rd","Lockie Road","Lockley Ct","Lockness Dr","Locks Village Road","Locksley Road",
            "Lockwood Ave","Lockwood Circle","Lockwood Ct","Lockwood Dr","Lockwood Lane","Lockwood Pl",
            "Lockwood Road","Lockwood San Ardo Rd","Lockwood San Lucas Rd","Lockwood St","Loco Mountain Rd",
            "Loco Rd","Locomotive Ln","Locus Avenue","Locuson Ave","Locust Ave","Locust Avenue","Locust Blvd",
            "Locust Ct","Locust Dr","Locust Dr NE","Locust Grove","Locust Grove Ln","Locust Grove Rd",
            "Locust Hill Drive","Locust Lake Cir","Locust Ln","Locust Rd","Locust St","Locust St; State Highway 113",
            "Locust Street","Lode St","Lodestone Rd","Lodge Avenue","Lodge Ln","Lodge Rd","Lodge Road","Lodge St",
            "Lodge Way","Lodgepole","Lodgepole Dr","Lodges Corner Rd","Lodi Ct","Lodi Hill Rd","Lodi Ln SE",
            "Lodi St","Lodi Street","Lodosa Dr","Loescher Ln","Loetscher Pl","Loewner Ln","Lofgren Ave",
            "Loftus Ln","Lofty St","Log Cabin Ln","Log Cabin Point","Log Cabin Rd","Log Cabin Ter","Log Cabin Way",
            "Log City Rd","Log Ln","Log Rd","Log Spur Tr","Log Tavern Dr","Logan Airport Terminal B",
            "Logan Ave","Logan Avenue","Logan Cir","Logan Ct","Logan Dr","Logan Gap Rd","Logan Ln","Logan Pl",
            "Logan Rd","Logan Road","Logan St","Loganberry Court","Loganberry Crescent","Loganrun Ln",
            "Logger Brook Rd","Loggerhead Grove","Loggers Run","Loggers Trail","Logging Rd","Logging Road 45061",
            "Logston Ct","Logstone Crescent","Logwood Drive","Lohengrin Court","Lohman Dr","Lohmann Pl",
            "Lohr Ct","Lohrey Ln","Loire Ct","Loire St","Loire Valley Avenue","Lois Ave","Lois Ct","Lois Dr",
            "Lois Faye Court","Lois Ln","Lois St","Lola Dr NE","Lola St","Loland Ln","Lollard Ct","Loma Blvd",
            "Loma Bonita","Loma Canada Ct","Loma Casi Ln","Loma Cir","Loma Colorado Ct","Loma Colorado Dr NE",
            "Loma Ct","Loma Lada Dr","Loma Linda Ct","Loma Linda Ln","Loma Linda Pl SE","Loma Pedregosa NW",
            "Loma Pl","Loma Rica Dr","Loma Rica Rd","Loma St","Loma Verde Ct","Loma Verde Ln","Loma Verde Mountainway",
            "Loma Vista Dr","Loma Vista Rd","Loma de Cobre Dr","Loma del Oro","Loman Ln","Lomas Dr","Lomb Memorial Drive",
            "Lombard Aly","Lombard Ln","Lombard Road","Lombard St","Lombardi Ct","Lombardi Dr","Lombardi Ln",
            "Lombardi St","Lombardy Crescent","Lombardy Ct","Lombardy Dr","Lombardy Ln","Lombardy Rd",
            "Lombardy St","Lombardy Street","Lomg Grd","Lomila Dr","Lomita Dr","Lomita St","Lomita Way",
            "Lomond Avenue","Lomond Cir","London Ave","London Bridge Rd","London Ct","London Hill Rd",
            "London Park Ct","London Plane Ave","London Rd","London St","London Star Rd","London Ter",
            "Londonderry Ct","Londonderry Dr","Londonderry Turnpike","Londonderry Way","Londonnaire Dr",
            "Lone Cedar Dr","Lone Cedar Way","Lone Cliff Dr","Lone Dr","Lone Eagle Rd","Lone Mountain Ct",
            "Lone Oak","Lone Oak Ct","Lone Oak Dr","Lone Oak Rd","Lone Pine Dr","Lone Pine Ln","Lone Pine Road",
            "Lone Pine Trl","Lone Pine Way","Lone Ranch Rd","Lone Rd","Lone Star Ct","Lone Star Dr","Lone Star Pl",
            "Lone Star Rd","Lone Tree Rd","Loneja Rd","Lonepine Rd","Lonesome Dove Rd","Lonesome Rd",
            "Lonestar Trl","Lonewolf Ct","Loney's Lane","Long","Long Acres Ave","Long Avenue","Long Beach",
            "Long Beach Blvd","Long Beach Ln","Long Blvd","Long Bottom Rd","Long Branch Avenue","Long Branch Way",
            "Long Canyon Rd","Long Cir","Long Creek Rd","Long Creek Way","Long Ct","Long Dr","Long Draw Rd",
            "Long Drive","Long Driveway","Long Farm Rd","Long Gone Ave","Long Hay Flat Rd","Long Hill Drive",
            "Long Hill Rd","Long Hill Road","Long Hill Street","Long Hollow Ct N","Long Hollow Ct S",
            "Long Horn Ct","Long Island Expy","Long Lake Rd","Long Lake Road","Long Lane Rd","Long Leaf Cir",
            "Long Loop Rd","Long Path","Long Point Rd","Long Pond Brook Way","Long Pond Rd","Long Pond Road",
            "Long Rd","Long Ridge Rd","Long Ridge Trail","Long Road","Long Run Rd","Long St","Long Swamp Rd",
            "Long Ter","Long Town Road","Long Trail","Long Valley Rd","Long Valley Road","Long Valley Way",
            "Long View Rd","Long Wharf","Long Woods Road","Longacre Ave","Longacre Blvd","Longacre St",
            "Longboat Ave","Longboat Avenue","Longbourne Crescent","Longbow Ct","Longbow Mt Rd","Longbow Square",
            "Longbranch Cir","Longbridge Rd","Longbrook Rd","Longcrest Rd","Longevity Dr","Longeway Rd",
            "Longfellow Ave","Longfellow Avenue","Longfellow Ct","Longfellow Drive","Longfellow Pl",
            "Longfield Cir","Longfield Road","Longford Ave","Longford Rd","Longford St","Longhill Road",
            "Longhorn Dr","Longhorn Ln","Longhorn Trl","Longino St","Longley Dr","Longley Road","Longley Street",
            "Longmeadow Blvd S","Longmeadow Dr","Longmeadow Road","Longmeadow St","Longmont St","Longmont Way",
            "Longmoor Road","Longmore Street","Longridge Rd","Longridge Ter","Longridge Trl","Longs Ave",
            "Longs Church Rd","Longs Ln","Longs Point Ln","Longs Point Rd","Longs Rd","Longshore Rd",
            "Longshot Rd","Longspur Ct","Longspur Dr","Longstreet Ave","Longstreet Lane","Longtown Rd",
            "Longview Ave","Longview Ct","Longview Dr","Longview Drive","Longview Ln","Longview Pl","Longview Rd",
            "Longview Ter","Longview Way","Longwater Chase","Longwood Avenue","Longwood Court","Longwood Ct",
            "Longwood Dr","Longwood Drive","Longwood Rd","Longwood Road","Longworth Ave","Longworth Avenue",
            "Longworth St","Lonita Trl","Lonnie Ave","Lonny Court","Lonsdale Road","Looging Trl","Look Dr",
            "Look Out Tower Rd","Looking Glass Crescent","Looking Glass Ln","Lookout","Lookout Cir",
            "Lookout Court","Lookout Dr","Lookout Ln","Lookout Pl","Lookout Point Court","Lookout Rd",
            "Lookout Road","Lookout Street","Lookout Tower Rd","Lookout Trl","Loomis Bay Rd","Loomis Landing Rd",
            "Loomis Ranch Road","Loomis St","Loomis Valley Rd","Loon Avenue","Loon Cir","Loon Creek Cir",
            "Loon Echo Dr","Loon Ln","Loon Road","Loon Song Ln","Loon Street","Loon Way","Looney St","Loontail Street",
            "Loop 101","Loop Rd","Loop St","Loope Rd","Loose Horse Ln","Loper Valley Rd","Lopes St","Lopez Creek",
            "Lopez Ln","Lopez St","Lora Street","Lorae Pl","Lorain Ave","Lorain Ct","Lorain St","Loraine Dr",
            "Loraine Michele Way","Loramie Cir","Lorane Way","Loraview Lane","Lord Calvert Dr","Lord Dr",
            "Lord Rd","Lord St","Lord Sterling Dr","Lord's Hill Rd","Lorden Ln","Lordville Rd","Lore St",
            "Loreley Rd","Lorelie St","Loren Ct","Loren Way","Lorena Dr","Lorene Drive","Lorentz Rd","Lorenzo Ave",
            "Lorenzo Ln","Loreto Dr","Loreto Ln","Loreto St","Loretta Ave","Loretta Court","Loretta Ct",
            "Loretta Dr","Loretta Drive","Loretta Ln","Loretta Rd","Loretto","Loretto Ave","Lori Avenue",
            "Lori Ct","Lori Dr","Lori Lane","Lori Ln","Lori Ln N","Lori Marie Cir","Lori Rd","Lori St","Lorile Cir",
            "Lorillard St","Loring Ave","Loring Avenue","Loring Cir","Loring Run","Loring St NW","Loring Street",
            "Lorisa Ln","Lorna Cir","Lorna Dr","Lorna Rae Boulevard","Lorna St","Lorne Avenue","Lorne Park Road",
            "Lorne St","Lorne Street","Lorraine Ave","Lorraine Avenue","Lorraine Ct","Lorraine Dr","Lorraine Drive",
            "Lorraine Pl","Lorraine Rd","Lorraine Street","Lorraine Way","Lorraines Pl","Lorric Ln N",
            "Lorric Ln S","Los Alamitos Dr","Los Alamitos Way","Los Alamos Dr","Los Alamos Rd","Los Altos Ave",
            "Los Altos Rd","Los Amigos Cir","Los Angeles Aqueduct","Los Angeles St","Los Arboles Ave NE",
            "Los Arboles Ave NW","Los Arboles Ct","Los Arboles Dr","Los Arcos Cir","Los Bonitos Way",
            "Los Carneros Way","Los Cedros Cir","Los Cedros Dr","Los Cerros Ave","Los Chavez Rd","Los Encantos Cir",
            "Los Encantos Dr","Los Encinos Ct","Los Felinos Creek","Los Feliz St","Los Flores Rd",
            "Los Fuentes Dr","Los Griegos Rd","Los Hermanos St","Los Hermosos Way","Los Hijos Rd",
            "Los Jardines Creek","Los Leones St","Los Manzanis Rd NW","Los Olivos Ave","Los Padillas Rd",
            "Los Padillas Rd SW","Los Palmos St","Los Palos Dr","Los Palos St","Los Pinos Rd","Los Prados St",
            "Los Ranro Dr","Los Rios Dr","Los Serranos Dr","Los Siglos Dr","Los Trechos Ct","Los Verdes Ln",
            "Losee Dr","Losson Garden Dr","Lost Arrow Rd","Lost Ave","Lost Coast Trail","Lost Corner Rd",
            "Lost Creek Dr","Lost Creek Rd","Lost Dutchman Dr","Lost Horse Mine Trail","Lost Key Dr",
            "Lost Lake Dr","Lost Lake Rd","Lost Ln","Lost Man Trl","Lost Nation Rd","Lost Payment Rd",
            "Lost Pear Way","Lost River Rd","Lost Springs Ave","Lost Spur Rd E","Lost Trail","Lost Valley Dr",
            "Lost Valley Rd","Losty Rd","Lotas St","Lothian Avenue","Lothian Ln","Lott Ln","Lott Pl","Lott Rd",
            "Lott Street","Lottie Ln","Lottridge Rd","Lotus Ave","Lotus Ct","Lotus Ln","Lotus St","Lotz St",
            "Lou St","Louck St","Louden Ter","Loudville Road","Louella Ave","Louella Dr","Louette Ct","Loughlin Pl",
            "Loughry Woods Trail","Louis Ave","Louis Barnes Ln","Louis Ct","Louis Dr","Louis Drive","Louis Lane",
            "Louis Ln","Louis St","Louis Street","Louisa St","Louisa Street","Louisanna St","Louisberg Sq",
            "Louise Circle","Louise Dr","Louise Dr SW","Louise Ln","Louise Pl","Louise Rd","Louise St","Louise Street",
            "Louise Weltz Ln","Louisiana Ave","Louisiana Blvd SE","Louisiana St","Louisiana Trl","Louisville Ave",
            "Louisville Drive","Lounsberry Hollow Rd","Lounsberry Rd","Lounsbury Rd","Lourdes Rd",
            "Lous Ct","Louth Street","Louvain Avenue","Lovato Ln","Love Ave","Love Lane","Love St","Loveday",
            "Loveday St","Lovejoy Ln","Lovejoy Plantation Rd","Lovejoy Rd","Lovelace Rd SE","Lovelady Ln",
            "Lovelady Rd","Loveland Ct","Loveland Hill Rd","Loveland Rd","Loveland St","Loveland Way",
            "Lovelin Ct","Lovell Ave","Lovell Dr","Lovell Lake Rd","Lovell Summit Rd","Lovells Rd","Lovelock St",
            "Lovelock-Unionville Rd","Lovely St","Loveness Logging Road","Lovering Line","Lovering Street",
            "Lovers Lane","Lovers Ln","Lovett Pl","Lovett Rd","Lovewell Ct","Lovewell Pond Rd","Lovewell Street",
            "Lovgren Rd","Lovie Ln","Lovilla Boulevard","Lovington Rd","Lovotti Ct","Low Ct","Low Divide Rd",
            "Low Gap Rd","Low Ln","Low Meadow Ln S","Low Rd","Low St","Lowden Ln","Lowe Ave","Lowe Avenue",
            "Lowe Dr","Lowe Lake Rd","Lowell Ave","Lowell Avenue","Lowell Camp Rd","Lowell Court","Lowell Ct",
            "Lowell Hanks Rd","Lowell Ln","Lowell Pl","Lowell Road","Lowell St","Lowell Street","Lowens Strasse",
            "Lower Azusa Rd","Lower Barrack Rd","Lower Big Chute Road","Lower Briggs Hollow Rd",
            "Lower Bryants Landing Rd","Lower Buck Ridge Rd","Lower Bull Crk Flats Rd","Lower Bush Rd",
            "Lower Circle Dr","Lower Colfax Rd","Lower Cuchillo Creek Rd","Lower Doetown Rd","Lower Dolington Rd",
            "Lower Don Recreational Trail","Lower Embargo Rd","Lower Falls Rd","Lower Faraday Road",
            "Lower Ferry Rd","Lower Georges Creek Rd SW","Lower Glen Rd","Lower Gulf Rd","Lower Hack St",
            "Lower Hill Rd","Lower Honcut Rd","Lower Jarvis Street","Lower Jones Road","Lower Kaubashine Rd",
            "Lower Lake View Dr","Lower Las Colonias Rd","Lower Links Road","Lower Ln","Lower Log Rd",
            "Lower Loop Rd","Lower Lost Prairie Rd","Lower Main St","Lower Mountain Rd","Lower North Shore Rd",
            "Lower Oakwood Road","Lower Onondag Park Dr","Lower Park Rd","Lower Rd","Lower Ridge Rd",
            "Lower River Rd","Lower Rock Creek Road","Lower Round Lake Road","Lower School St",
            "Lower Shore Dr","Lower Simcoe Street","Lower South Main St","Lower South St","Lower Springs Rd",
            "Lower Spruce Ct","Lower Sunset Dr","Lower Swedes Bridge Rd","Lower Toddsville Rd",
            "Lower Town Creek Rd SE","Lower Trail","Lower Troy Rd","Lower Twining Rd","Lower Westfield Road",
            "Lower York Rd","Lowerre Pl","Lowery Dr","Lowery Point Ct","Lowes Canyon Rd","Lowes Creek Rd",
            "Lowes Rd","Lowes Street","Lowick Ln","Lowing Ave","Lowland Ave","Lowland Hill Rd","Lowland Place",
            "Lowry Ln","Lowry Ranch Rd","Lowther Avenue","Lowther Dr","Lowville Heights Rd","Loxie Ln",
            "Loxley Ct","Loxley St","Loy Ln","Loy Rd","Loy St","Loyalist Court","Loyalist Ct","Loyalist Drive",
            "Loyalist Parkway","Loyola Ave","Loyola Blvd","Loyola Dr","Loyola Rd","Loyola Way","Loysen Rd",
            "Lozano Way","Lozier Ave","Lozier St","Lr 106","Lr 108","Lr 119","Lr 132","Lr 153","Lr 165","Lr 338",
            "Lr 346","Lr 364","Lr 39","Lr 393","Lr 75","Lr 88","Lt Crawford Wheeler Ct","Lualan Lane","Luann Dr",
            "Luanna Point Dr","Luau Dr","Lubao Ave","Lubbers Ln","Lucas Bottoms Rd","Lucas Ct","Lucas Dr",
            "Lucas Ferry Crossing","Lucas Lane","Lucas Lash Rd","Lucas Ln","Lucas Rd","Luce","Luce Avenue",
            "Luce Meadow Rd","Lucena Dr","Lucerne Dr","Lucerne Way","Lucero Ave","Lucero Pl","Lucero Rd",
            "Luchese Ln","Lucia Ct","Lucia Ln","Lucia St","Lucie Ln","Lucille","Lucille Ave","Lucille Dr","Lucille Ln",
            "Lucille St","Lucinda Ave","Lucinda Ln","Luck Up","Luckman Way","Lucky Ln","Lucky Wash Rd","Lucky Way",
            "Lucy Ave","Lucy Ct","Lucy Ln","Lucy Rd","Lucy St","Lucy Street","Ludbrook Court","Ludeman Dr",
            "Ludgate Drive","Ludlam Ln","Ludlow Avenue","Ludlow Court","Ludlow Dr","Ludlow Ln","Ludlow St",
            "Ludstone Drive","Ludwick Rd","Ludwig Ave","Ludwig Ln","Ludwig St","Ludwin Dr","Luella Dr","Luella Ln",
            "Luenburgh Tpke","Luenburgh Tpke 2","Lufkin Way","Lugano Rd","Lugar de Padilla","Lugenia Dr",
            "Lugent Ln","Lugers Road","Lugo St","Luhrig Rd","Luhrs Ct","Luis Dr","Luiz F. Kahl Way","Lujan Dr",
            "Lujan Hill Rd","Luke Ave","Luke Ct","Luke Dr","Lukens Drive","Lukens Ln","Luker Ln","Lukow Terrace",
            "Lull St","Lullaby Ln","Lulu Ct","Lulu St","Lum Hill Rd","Lum Rd","Lumbard Rd","Lumber City Hwy",
            "Lumber Yard Rd","Lumberjack Close","Lumbermans Rd","Lumberton Rd","Lumbervale Avenue",
            "Lumina Dr","Lumpkin Rd","Lumsden Avenue","Lumsden Park Rd","Luna Canyon Rd","Luna Cir","Luna Court",
            "Luna Dr","Luna Rd","Luna Sereno Ct","Luna Vista Ln","Luna del Rey St","Lunar Cir","Lunar Rd NW",
            "Lund Avenue","Lundbar Pl","Lundberg Street","Lunde Ln","Lundy's Lane","Lundys Ln","Lunga Rd",
            "Luni Ln","Lunker Ct","Lunny Dr","Luoma Rd","Lupe St","Lupin Drive","Lupin St","Lupin Street Trail",
            "Lupine Cir","Lupine Ct","Lupine Dr","Lupine Ln","Lupine Pl","Lupine Rd","Lupine St","Lupine Way",
            "Luppatatong Ave","Lupus Ln","Luquer St","Luquer Street","Lura Street","Lurelane St","Lurleen Dr",
            "Lusandra Cir","Lusard Dr","Lusard St","Lusherm Ct","Lusk Farm Cir","Lusscroft Rd","Luster Ln",
            "Lustre Rd NE","Lutea Ter","Luther Ave","Luther Belk Rd","Luther Dr","Luther Road","Luther Waddles Wash",
            "Luton Gate","Luttgen Pl","Luttrell Ct","Lutts","Lutz Rd","Luverne Avenue","Luxemburg Ave","Luxor Ave",
            "Luznar Ln SW","Lyceum Ct","Lycia St","Lycoming Ave","Lyda Ln","Lydall Road","Lydgate Ave","Lydia Crescent",
            "Lydia Dr","Lydia Ln","Lydia St SW","Lydia Street","Lydon Street","Lye Rd","Lyell Rd","Lyellwood Pky",
            "Lyford Street","Lykes Dr NE","Lyle Farm Ln","Lyle Ln","Lyle Rd","Lyle St","Lyle Ter","Lylewood Dr",
            "Lyman Ave","Lyman Boulevard","Lyman Dr","Lyman Ln","Lyman Pl","Lyman Rd","Lyman St","Lyman Street",
            "Lyman Way","Lyman Wilson Ridge Trail","Lyme Rd","Lyme St","Lyn Road","Lynbrook Dr","Lynch Ave",
            "Lynch Brook Rd","Lynch Canyon Dr","Lynch Canyon Rd","Lynch Ct","Lynch Farm Rd","Lynch Rd",
            "Lynch Terrace","Lyncourt Dr","Lyncrest Dr","Lyncrest Rd","Lyncroft Drive","Lynd Avenue",
            "Lynd Ward Way","Lyndale Ave","Lyndale Street","Lyndals Ln","Lynde Lane","Lynde Rd","Lynden St",
            "Lyndhurst Avenue","Lyndhurst Drive","Lyndhurst Ln","Lyndhurst Rd","Lyndhurst Ter","Lyndon Ave",
            "Lyndon Pl","Lyndon Street W","Lyndway Dr","Lynette Dr","Lynhaven Road","Lynian Way","Lynmont Road",
            "Lynn","Lynn Ave","Lynn Bridges Rd","Lynn Cir NW","Lynn Ct","Lynn Dr","Lynn Heights Drive","Lynn Hill Rd",
            "Lynn Lane","Lynn Ln","Lynn Oak Dr","Lynn Rd","Lynn St","Lynn Street","Lynn Ter","Lynn Terrace",
            "Lynn Way","Lynne Ct","Lynne Ln","Lynnfield Dr","Lynnfield Ter","Lynngrove Avenue","Lynnhaven Dr",
            "Lynnrod Court","Lynnwood Ave","Lynnwood St","Lynvalley Crescent","Lynwood Crescent","Lynwood Dr",
            "Lynwood St","Lynx Cir","Lynx Pl","Lynx Rd","Lyon Blvd","Lyon Center Drive","Lyon Industrial Dr",
            "Lyon Pl","Lyon St","Lyon Street","Lyons Ave","Lyons Avenue","Lyons Ct","Lyons Dr","Lyons Drive",
            "Lyons Lane","Lyons St","Lyons Street","Lyonsville Road","Lypnik Way","Lyric Ave","Lyric Rd NW",
            "Lytle St","Lytton Boulevard","Lywood Street","M & M Dr","M & M Ln","M & S Ct","M 89","M Ave","M Cty",
            "M J Tapia Dr","M L Ln","M St","M St SE","M Street","M&M Dr","M-3 Rd","M-504","M-99","M-Drive N","M-Way",
            "M1 Rd","Ma-We-Mor View Ln","Maalot Ct","Mabaline Rd","Mabel's Road","Maberly Station Road",
            "Mabien Lake Rd","Mable Ave","Mabry Rd","Mabury Sq","Mac Arthur Blvd","Mac Arthur Way","Mac Ct",
            "Mac Donald Rd","Mac Dougal Street","Mac Dougall Rd","Mac Intosh Ln","Mac Ln","Mac Niel Rd",
            "Mac Rd","Mac St","Mac Tul Rd","MacComish Lane","MacDonald Avenue","MacDonald Drive","MacDonald Street",
            "MacDonald-Cartier Freeway","MacDonnell Street","MacEwen Drive","MacFarlan Avenue",
            "MacGregor Avenue","MacIntosh Street","MacIntyre Lane","MacKenzie Place","MacKenzie Road",
            "MacKenzie Street","MacLennan Avenue","Maca Pl","Macadamia Ln","Macademia Ln","Macal Drive",
            "Macamo Court","Macarthur Ave","Macarthur Blvd","Macarthur Circle","Macarthur Rd","Macattack Ln",
            "Macau St","Macbain Ave","Macbeth Dr","Maccan St","Macdermott Drive","Macdill Ct","Macdonald Rd",
            "Macdonald-Cartier Freeway","Macduff Ln","Macduff St","Mace Avenue","Mace Boulevard","Mace Pl",
            "Mace Way","Macedonia Rd","Macey Court","Macgregor Ct","Macguire Ln","Machado Ln","Machen Rd",
            "Machuca Dr","Macinaw Rd","Macintosh Dr","Maciver St","Mack Ave","Mack Avenue","Mack Dr","Mack Pl",
            "Mack St","Mackay Avenue","Mackay Rd","Mackenzie Ct","Mackenzie Rd","Mackey Ave","Mackey Drive",
            "Mackie Dr","Mackinaw St","Mackinaw Trail Rd","Mackinaw Trl","Macklin Rd","Macklin Road",
            "Macks Canyon Rd","Macks Gulch Rd","Mackville Rd","Maclarie Ln","Macleod Way","Maclovia St",
            "Macmillan Rd","Macmurray St","Macomber Ave","Macomber Ln","Macombs Dam Brg","Macombs Rd",
            "Macon Rd NE","Macoun Drive","Macs Island Dr","Macy Rd","Macy Street","Mad Brook Road","Mad River Rd",
            "Madaket Road","Madbury Rd","Maddalena Rd","Madden Hill Rd","Madden Ln","Madden Rd","Maddox Ln",
            "Maddox Rd","Maddox St","Maddux Dr","Madeira Avenue","Madeira Pl NE","Madelaine Crescent",
            "Madelaine Drive","Madeleine Ln","Madeline Road","Madeline Ter","Mader Ct NE","Madera Ave",
            "Madera Ct","Madera Dr","Madera St","Madera del Presidio Dr","Madison 1305","Madison 1470",
            "Madison 1539","Madison 1975","Madison 2000","Madison 2315","Madison 2355","Madison 2410",
            "Madison 3105","Madison 3120","Madison 3149","Madison 3160","Madison 3440","Madison 5035",
            "Madison 5230","Madison 5510","Madison 5520","Madison 5530","Madison 5570","Madison 6001",
            "Madison 6019","Madison 6021","Madison 6200","Madison 6225","Madison 6336","Madison 6423",
            "Madison 6578","Madison 7005","Madison 7015","Madison 7250","Madison 7580","Madison 8340",
            "Madison 8384","Madison Ave","Madison Ave SE","Madison Ave W","Madison Avenue","Madison Blvd",
            "Madison Ct","Madison Dr","Madison Heights Boulevard","Madison Ln","Madison Pl","Madison Rd",
            "Madison St","Madison Street","Madison Twp","Madison Village Dr","Madison Way","Madoc Street",
            "Madonna Ln","Mador Avenue","Madra Ave","Madras Pl","Madras Rd NE","Madre Ln","Madrid Cir","Madrigal Ct",
            "Madrona Ave","Madroncillo St","Madrone Ave","Madrone Ct","Madrone Ln","Madrone Manor","Madrone St",
            "Madrone Way","Madwind Rd","Mady Grice Rd","Mae Rd","Maegus Dr","Maelin Ct","Maenpah St","Maez Rd",
            "Maffey Crescent","Mafic Ct","Magais St","Magazine Road","Magdalena","Magee Dr","Magee Pt Rd",
            "Magee Rd","Magellan Ave","Magellan Drive","Magenta Ct","Magesta","Maggie Ave","Maggie Dr","Maggie Ln",
            "Maggie's Way","Maggior Ct","Maggiore Ln","Magic Forest Trl","Magic Ln","Magic Moment Ln",
            "Magill Ave","Magill Blvd","Magill Drive","Magill St","Magistrate Terrace","Magma Aly","Magma Rd",
            "Magnetic St","Magnolia","Magnolia Ave","Magnolia Avenue","Magnolia Cir","Magnolia Crescent",
            "Magnolia Ct","Magnolia Dr","Magnolia Ln","Magnolia Ln N","Magnolia Rd","Magnolia St","Magnolia Street",
            "Magnolia Terrace","Magnolia Way","Magnotta Road","Magowan Ave","Magpie Ct","Magruder St",
            "Maguire Court","Maguire Ct","Maha Dr","Mahan Dr","Mahar Ave","Maharg Rd","Maher Blvd","Mahina Street",
            "Mahinske Dr","Mahl Loop","Mahmood Crescent","Mahogany Cir","Mahogany Dr","Mahogany Drive",
            "Mahogany Rd","Mahogany Tr","Mahogany Way","Mahon Ave","Mahone Rd","Mahoney Ave","Mahoney Rd",
            "Mahoney Road","Mahoning St","Mahood's Road","Mahoosuc","Maida Ct","Maida Ter","Maiden Lake Rd",
            "Maiden Lane","Maiden Lane Road","Maiden Ln","Maiden St","Maidenhair Lane","Maidens Mill Road",
            "Maidensford","Maidstone Ct","Maidu Ave","Maidu Ln","Maidu Trl","Mail Road","Maillett Rd","Maimonides Court",
            "Main Aly","Main Aly S","Main Ave","Main Boulevard","Main Campus Rd","Main Circle","Main Dalton Road",
            "Main Dr","Main Drain Rd","Main Dunstable Rd","Main Entry Road","Main Rd","Main Road","Main Sail Dr",
            "Main St","Main St E","Main St N","Main St.","Main Street","Main Street Byp","Main Street E",
            "Main Street North","Main Street Osterville","Main Street South","Main Street W","Main Trail",
            "Main Trl","Maine Ave","Maine Dr","Maine Pl","Maine St","Maine Turnpike","Mainmast Pl","Mains Ave",
            "Mainsail Dr","Mainsail Ln","Maintenance Rd","Mainview Dr","Maishoss St","Maitland Ave","Maitland Drive",
            "Maitland Place","Maitland Street","Maize Corn Rd","Maize Way","Majela Ln","Majestic Crescent",
            "Majestic Hills Drive","Majestic Ln","Majestic Lodge Rd","Majestic Shadows Ave","Majestic Terrace Dr",
            "Majestic View Ct","Majestic Way","Majesty Way","Major Ave","Major Deegan Expressway",
            "Major Deegan Expy","Major Ln","Major Mackenzie Drive E","Major Mackenzie Drive East",
            "Major Mackenzie Drive West","Major Oaks Road","Major Street","Majora Ln","Majorca Cir",
            "Makepeace Dr","Maker Way","Makin Ave","Mako Tr","Malabar Place","Malabu Ave NW","Malaga Dr",
            "Malaga Gate","Malaga Ln","Malaga Pl","Malaga Rd","Malaga St","Malapardis Rd","Malati Cir","Malavenda Ln",
            "Malcolm Ave","Malcolm Avenue","Malcolm Ct","Malcolm Road","Malcolm X Blvd","Malcolm X Boulevard",
            "Malcom X Dr","Malden Lane","Malden Pl","Malden Road","Malden Street","Malden Street Park",
            "Malden Terrace","Maldiner Ave","Malecite Ln","Malen Ave","Mali Dr","Malibou Terrace","Malibu",
            "Malibu Canyon Rd","Malibu Ct","Malibu Lane","Malibu Rd","Malibu Way","Malio Dr","Mall Access Rd",
            "Mall Ct","Mall Street","Mallard","Mallard Ave","Mallard Ct","Mallard Cv","Mallard Dr","Mallard Dr N",
            "Mallard Lane","Mallard Ln","Mallard Pl","Mallard Point","Mallard Point Cv","Mallard Rd",
            "Mallard St","Mallard Trl","Mallard Way","Mallards Cove Lane","Mallards Landing Rd","Mallet Ln",
            "Malley St","Mallison Ave","Mallory Ave","Mallory Dr","Mallory Ln","Mallory Rd","Mallorytown Road",
            "Mallow Dr","Mallow Rd","Mallow Road","Malloy Tract","Mallview Ct","Malm Avenue","Malmaison Rd",
            "Malmo Court","Malmy Dr","Malone Ave","Malone Dr","Malone Drive","Maloney Ln","Maloney St","Malsbury Ln",
            "Malta Avenue","Malta Ln","Malta Way","Malthouse Rd","Malton Bus Terminal","Malumia Dr","Malus Ct",
            "Malvasia Ct","Malvern Ave","Malvern Ct","Malvern Dr","Malvern St","Malvern Street","Mamba Ct",
            "Mameluke Hill Rd","Mamie Dr","Mammoth Ave","Mammoth Creek Connector","Mammoth Dr","Mammoth Hall Trail",
            "Mammoth Pools Ct","Mammoth Rd","Mammoth Slopes Way","Mammoth Spring Mountain Rd","Manada Rd",
            "Manajo Way","Manalapan Rd","Manales Rd","Manana Dr","Manasquam Ln","Manassas Ave","Manassas Ct",
            "Manassas Junction","Manchaug Road","Manchester Ave","Manchester Blvd","Manchester Court",
            "Manchester Ct","Manchester Dr","Manchester Rd","Manchester St","Manchester Street","Manchester Terrace",
            "Manchuca","Mandan Rd","Mandarin Ave","Mandarin Court","Mandarin Ln","Mandel Dr","Manderley Drive",
            "Manderson Rd","Manderville St","Mandeville Ct","Mandeville Dr","Mandeville St","Mandiwood Farm",
            "Mandiwood Farm Rd","Mandolin Circle","Mandolin Court","Mandon Ct","Mandrake","Mandrake Street",
            "Mandrapa Rd","Mandy Ct","Mandy Way","Manet Avenue","Manet Circle","Manford Dr","Mangan Boulevard",
            "Mango Dr","Mango St","Mangos Dr","Mangus Creek Ln","Mangus Dome Trl","Manhart Way","Manhasset Ct",
            "Manhattan Ave","Manhattan Bridge","Manhattan Bridge lower level (reversible)","Manhattan Dr",
            "Manhattan Drive","Manhattan Ln","Manhattan St","Manhatten Ave","Maniece Avenue","Manila Avenue",
            "Manila Pl","Manila St","Manilow Street","Manion Road","Manis Ave","Manistee Ct","Manistee Street SE",
            "Manistique Township Road","Manito","Manitoba Ct","Manitoba St","Manitou Ct","Manitou Mountain",
            "Manke Rd","Mankill Brook Rd","Manko Dr","Manley Ct","Mann Ave","Mann Ct","Mann Dr","Mann Rd","Mann St",
            "Mann Street","Mannel Ave","Manners Court","Manning Ave","Manning Avenue","Manning Dr","Manning Lane",
            "Manning St","Manning Way","Mannington Ct","Mannington Dr","Mannington Rd","Mannix Rd","Manomet Avenue",
            "Manon Dr","Manon Way","Manor Ave","Manor Blvd.","Manor Court","Manor Cres","Manor Crescent",
            "Manor Ct","Manor Dr","Manor Haven Road","Manor House Ct","Manor House Rd","Manor Park","Manor Rd",
            "Manor Road","Manor Road East","Manor St","Manor Ter","Manor View Dr","Manor Way","Manordale Crescent",
            "Manorheights Street","Manors Rd","Manorwood St","Manse Ln","Manse Rd","Mansfield Avenue",
            "Mansfield Blvd N","Mansfield City Rd","Mansfield Crescent","Mansfield Dr","Mansfield Lane",
            "Mansfield Rd","Mansfield St","Mansion Pky","Mansion Pl","Mansion Rd","Mansiones Ln","Mansur Rd",
            "Manter Meadow Rd","Manthey Rd","Mantle Avenue","Manton Ave","Manton Ct","Manton Ponderosa Way",
            "Manton Rd","Manton St","Mantoni Drive","Mantua Ave","Mantua Blvd","Mantua Grove Rd","Mantua Pike",
            "Mantz St","Manu Trl","Manuel Ave","Manuel Canyon Rd","Manuel Cir","Manuel Ct","Manvers Drive",
            "Manvers-Scugog Townline","Manville Dr","Many Nations Rd","Manzana Ave","Manzana St",
            "Manzanal Rd","Manzanita","Manzanita Ave","Manzanita Ct","Manzanita Ct SE","Manzanita Dr",
            "Manzanita Ln","Manzanita Rd","Manzanita St","Manzanita Way","Manzano Expy","Manzano St NE",
            "Manzo Rd","Maolis Ave","Mapache Ct","Mapes Dr","Mapes Pl","Maple","Maple Ave","Maple Ave S","Maple Avenue",
            "Maple Beach Road","Maple Beach Rd","Maple Branch Rd","Maple Brook Dr","Maple Court",
            "Maple Creek Rd","Maple Crescent","Maple Crest Ln","Maple Ct","Maple Dr","Maple Drive","Maple Edge Lane",
            "Maple Falls Ct","Maple Falls Road","Maple Glen Dr","Maple Glen Ranch Rd","Maple Grove",
            "Maple Grove Road","Maple Grove Avenue","Maple Grove Blvd","Maple Grove Ln","Maple Grove Rd",
            "Maple Grove Road S","Maple Heights","Maple Hill Ln","Maple Hill Rd","Maple Island Rd",
            "Maple Knoll Dr","Maple Lake Rd","Maple Leaf Dr","Maple Leaf Drive","Maple Ln","Maple Manor Ct",
            "Maple Meadows Dr","Maple Park Drive","Maple Path","Maple Pl","Maple Point Rd","Maple Point St",
            "Maple Ridge","Maple Ridge Road","Maple Ridge Dr NE","Maple Ridge Rd","Maple Ridge Road",
            "Maple Road","Maple Springs St","Maple Springs Trl","Maple St","Maple St N","Maple St SE",
            "Maple Street","Maple Street N","Maple Street South","Maple Ter","Maple Terrace","Maple Tree Ln",
            "Maple Trl","Maple Village","Maple Way","Maplebrook Ct","Maplecrest Dr","Maplecrest St","Mapledale Ave",
            "Mapledale Rd","Maplegrove Road","Maplegrove St","Maplehurs Crescent","Maplehurst Ave SE",
            "Maplehurst Avenue","Maplehurst Rd","Maplehyrn Avenue","Maplelane Dr","Maples Ave","Maples Ln",
            "Mapleshade Dr","Mapleston St","Mapleton Cir","Mapletree Ct","Mapleview Ave","Mapleview Drive",
            "Mapleview Drive E","Mapleview Drive West","Mapleview St","Maplewood Ave","Maplewood Avenue",
            "Maplewood Court","Maplewood Dr","Maplewood Ln","Maplewood Pl","Maplewood Rd","Maplewood Road",
            "Mar Jo Ln","Mar Les Dr","Mar Vista Dr","Mara Circle","Mara Ct","Mara Ln","Mara Loma Cir","Mara Road",
            "Mara-Carden Boundary Road","Maracaibo St","Maramak Road","Maramesh Dr","Marana","Maranatha Way",
            "Marann Ter","Marantha Dr","Marascino Ct","Marauder Rd","Maravilla Dr","Marazan St","Marazion Hill Ct",
            "Marbil Ave","Marble Ave","Marble Ave NE","Marble Head Ct","Marble Hill Rd","Marble Place",
            "Marble Rd","Marble St","Marbled Rock Ave","Marblehead Road","Marblewood Drive","Marburger St",
            "Marc Ct","Marcela Ave","Marcelina Ln","Marcella Dr","Marcelline Crescent","Marcelyn Ave",
            "Marcero Dr","March Hill Pasture Rd","March Ln Bike Ph","March St","Marchar Street","Marchena St",
            "Marcheta St","Marchmont Road","Marchuck Rd","Marcia Ave","Marcia Avenue","Marcia Dr","Marcia Rd",
            "Marcia St","Marcial Dr","Marcie Dr","Marcin Ct","Marcinczyk Pl","Marco Rd","Marco St","Marcola Ct",
            "Marcone","Marconi Ave","Marconi Rd","Marcos Ln NE","Marcos Rd NW","Marcotte Street","Marcoux Rd",
            "Marcum St N","Marcus Ct","Marcus Dr","Marcus Garvey Avenue","Marcus Park","Marcy Ave","Marcy Ct",
            "Marcy Dr","Marcy Road","Marcy St","Mardan Dr","Mardel Ln","Marden Ave","Marden Avenue","Marden Lane",
            "Mardis Point Rd","Mardon Ct","Mardon Dr","Mare Ct","Mare Island Cswy","Mare Ln","Mare Meadow Ct",
            "Mare Rd","Marengo Ave","Marengo County 33","Marengo County 41","Marengo County 44","Marengo County 45",
            "Marengo County 5","Marengo County 53","Marengo County 57","Marengo County 6","Marengo County 63",
            "Marengo County 73","Maresfield","Marfil Ave","Margaret Ave","Margaret Avenue","Margaret Corbin Drive",
            "Margaret Court","Margaret Ct","Margaret Dr","Margaret Joseph Road","Margaret Ln","Margaret Pl",
            "Margaret Rd","Margaret St","Margaret St SW","Margaret Street","Margaret Way","Margarets Ln",
            "Margaretta Ave","Margarido Dr","Margarita Ave","Margarita Dr","Margarita Rd","Margarita St",
            "Margarita Ter","Margaritaville Way","Margate Ave","Margerie St","Margerum Rd","Marget Ann Ln",
            "Margie Ln","Margin Turn","Marginal St","Margo Ln","Margo Loop","Margolies Rd","Margot Street",
            "Margrath Place","Margueretta Street","Marguerita Ln","Marguerite Avenue","Marguerite St",
            "Marguy Road","Maria Court","Maria Ct","Maria Ct SE","Maria Dr","Maria Ln","Maria Manor S",
            "Maria St","Mariah Rd","Mariah St","Marian Ave","Marian Ct","Marian Dr","Marian Ln","Marian Rd",
            "Mariana Dr","Mariane Ct","Mariani Dr","Marianna Rd","Marianne Ln","Marianne St","Marianne Way",
            "Mariano Trusillo St","Maribeth","Maricela Dr","Marich Way","Maricio Dr","Marick Park Dr",
            "Maricopa Dr","Maricopa Hwy","Maricopa Pl","Maricopa Rd NE","Maricopa St","Maricora Rd","Marie Ave",
            "Marie Avenue","Marie Crest","Marie Ct","Marie Dr","Marie Ln","Marie Louise Ln","Marie Major Dr",
            "Marie Pl","Marie St","Marier Street","Marietta Blvd NW","Marietta Dr","Marietta Rd","Marigold Ave",
            "Marigold Ct","Marigold Ln","Marigold Pl","Marigold Rd","Marigold Road","Marigold St","Marilla St",
            "Marilyn Ave","Marilyn Dr","Marilyn Pl","Marilyn St","Marilyn Street","Marilyn Way","Marilyn's Ave",
            "Marin Ave","Marin Avenue","Marin St","Marina Bay Dr","Marina Bay Pky","Marina Dr","Marina Drive",
            "Marina View Dr","Marina Way","Marine Ave","Marine Avenue","Marine Corps League Highway",
            "Marine Drive","Marine Pl","Marine Plz","Marine Street","Marine Way","Mariner Bay St","Mariner Court",
            "Mariner Dr","Mariners Lane","Marinette Ave","Maring Rd","Marino Hills Dr","Marino Rd","Marino St",
            "Marino Way","Marinus St","Mario St","Marion Ave","Marion Ave NW","Marion Avenue","Marion Crescent",
            "Marion Ct","Marion Dr","Marion Johnson Rd","Marion Ln","Marion Pl","Marion Rd","Marion River Rd",
            "Marion Road","Marion St","Marion Street","Marion Walk","Mariposa Ave","Mariposa Ct","Mariposa Dr",
            "Mariposa Drive","Mariposa Grove Rd","Mariposa Springs Dr","Mariquita Rd","Marisa Crescent",
            "Marisa Ct","Marisol","Marisol Rd","Marissa Dr","Maritime Road","Marius Ct","Marius Ln","Marius St",
            "Marjay Ct","Marjorie Dr","Marjorie Drive","Marjorie Ln","Marjorie St","Marjorie Street",
            "Marjory Avenue","Mark Ave","Mark Ct","Mark Dr","Mark Elkins Rd","Mark Jewell Ln","Mark Leany Dr",
            "Mark Ln","Mark Rd","Mark St","Mark Street","Mark Twain","Mark Whitt Rd","Markam St","Markay Street",
            "Markell Road","Marker Ave","Marker Dr","Market Ave","Market Ave N","Market Center Ave","Market Hill Road",
            "Market Lane","Market Ln","Market Sq","Market Square Crescent","Market St","Market St E",
            "Market Street","Markey Ave","Markhall Avenue","Markham Cir","Markham Rd","Markham Road",
            "Markham St","Markham Street","Markhams Rd","Markland Rd","Markle St","Markley Rd","Marklyn Dr",
            "Marko Ln","Marks Ave","Marks Corners Rd","Marks Ct","Marks Dr","Marks Dr NW","Marks Ln","Marks Pl",
            "Marks Trailer Ct","Markson Dr","Markthaler Pl","Markus Dr","Markville Road","Marl Dr","Marl Rd",
            "Marlane Rd","Marlawr Gate","Marlbank Road","Marlboro Cir","Marlboro Ct","Marlboro Dr","Marlboro Drive",
            "Marlboro Rd","Marlboro Road","Marlborough Ave","Marlborough Avenue","Marlbridge Way",
            "Marle Dr","Marlena Drive","Marlene Ave","Marlene Blvd","Marlene Court","Marley Mill Rd",
            "Marlia Ct","Marlia St","Marlin","Marlin Court","Marlin Ct","Marlin Dr","Marlin Farm Rd","Marlock St",
            "Marlon Ave","Marlon Street","Marlott Road","Marlowe Ave","Marlowe Dr","Marlton Pike E","Marlwood Ct",
            "Marlyn Ln","Marlyn St","Marlyn Ter","Marlys Larson St","Marmac Drive","Marmac Rd","Marmaduke Street",
            "Marmay Pl","Marmill Way","Marmion Way","Marmol Ct","Marmon Place","Marmon Street","Marmora Aly",
            "Marmot Rd","Marmot Street","Marne","Marne Ave","Marne Park Rd","Marni Ct","Marni Way","Marnie Ln",
            "Marom Dr","Maroon Drive","Marple Rd","Marple St","Marques Ct","Marquette Ave NW","Marquette Avenue",
            "Marquette Blvd","Marquette Rd","Marquis Ave","Marquis Ct","Marr Ave","Marr Lane","Marrakech Rd NE",
            "Marrakesh Rd","Marrano Dr","Marre Dr","Marrett Road","Marrianna Pl","Marriet Ct","Marrion St",
            "Marrott Tr","Marrow Ln","Mars Ave","Mars Hill Cemetery Rd","Mars Lane","Marsala Ln","Marsalla Dr",
            "Marsalle Rd","Marsciano St","Marsdale Drive","Marsdale Rd","Marsden Court","Marseille","Marsen St",
            "Marsh Creek Road","Marsh Dr","Marsh Hill Road","Marsh Ln","Marsh Rd","Marsh St","Marsh Street",
            "Marsh Trail","Marsh Trail Rd","Marsha","Marsha Ct","Marsha Rd","Marshal Ave","Marshal St","Marshall Ave",
            "Marshall Avenue","Marshall Bch Rd","Marshall Ct","Marshall Dr","Marshall Dr E","Marshall Lane",
            "Marshall Rd","Marshall Road","Marshall St","Marshall Street","Marshall Trl","Marshalls Creek Rd",
            "Marshalltown Rd","Marsheann Hill Rd","Marshfield Court","Marshlynn Avenue","Marshsong Ave",
            "Marsi Road","Marsten Rd","Marston Ct","Marston Rd","Marston Street","Marstone Ln","Marta Ct",
            "Martel Ct","Martell Ave","Martell Ct","Martens Rd","Martense Court","Marter Ave","Martha Ct",
            "Martha Dr","Martha Ln","Martha Rd","Martha St","Martha Terrace","Marthas Lane","Marthas Vineyard",
            "Martin","Martin Ave","Martin Creek Rd","Martin Ct","Martin Dr","Martin Goodman Trail","Martin Grove Road",
            "Martin Ln","Martin Luther King Blvd","Martin Luther King Boulevard","Martin Luther King Jr Ave",
            "Martin Luther King Jr Blvd","Martin Luther King Jr Rd","Martin Luther King St",
            "Martin Pl","Martin Ranch Rd","Martin Rd","Martin Rd NW","Martin Rd SW","Martin Road","Martin St",
            "Martin St S","Martin Street","Martin Ter","Martin Wright Rd","Martin's Ferry Rd","Martineau St",
            "Martinez Dr","Martinez Ln","Martinez Pl NW","Martinez Ranch Road","Martinez Rd","Martinez St",
            "Martinez Trl","Martinique Dr","Martinique Pl","Martins Creek Belvidere Hwy","Martins Grove",
            "Martins Lane","Martins Ln","Martinsburg Rd NE","Martinsville Ave","Martinsville Rd","Martintown Rd",
            "Martinwood Ct","Martiri Ct","Martis Ct","Martis Place","Martling Pl","Martling Rd","Martville Road",
            "Marty Ln","Martz Rd","Maruche Canyon Rd","Marv St","Marvel Ave","Marvel Rd","Marvin Ave","Marvin Doster Rd",
            "Marvin Dr","Marvin Drive","Marvin Gardens St","Marvin Ranch Rd","Marvin Rd","Marvin Road",
            "Marvin St","Marwill Street","Marwin Dr","Mary Ann Cv","Mary Ann Dr","Mary Ann Furnace Rd",
            "Mary Ann Ln","Mary Anne Drive","Mary Augusta Street","Mary Austin Cartway","Mary Austin Rd",
            "Mary Ave","Mary Belle Dr","Mary Beth Dr","Mary Beth Lane","Mary Butler Ln","Mary Carl","Mary Crapo Way",
            "Mary Ct","Mary Dr","Mary Ella Cir NW","Mary Ellen Ave","Mary Ellen St NE","Mary Gapper Crescent",
            "Mary Jane Ct","Mary Jo Ct","Mary Joe Ln","Mary Lane Dr","Mary Len St","Mary Ln","Mary Lou St",
            "Mary Louise Ave","Mary Lynn Ln","Mary Manor Dr","Mary Moore Road","Mary Nich Road","Mary Perkins Rd",
            "Mary St","Mary St.","Mary Street","Mary Way","Mary White Rd","Mary's Rd","Maryann Ct","Maryann Lane",
            "Maryann Rd","Maryannis Dr","Marybay Crescent","Marybelle Rd","Marycrest Rd","Marycroft Avenue",
            "Marydale Avenue","Marydee Ct","Marye St","Maryhill Drive","Maryland Ave","Maryland Avenue",
            "Maryland Boulevard","Maryland Cir","Maryland Dr","Maryland Drive","Maryland Pky","Maryland Pl",
            "Maryland St","Marylestone Dr","Maryln","Marymount Dr","Marys Ln","Marys Pl","Marysville Blvd",
            "Marysville Pl","Marysville Road","Marywood Dr","Marzen Ln","Mascoma Avenue","Mascoma Street",
            "Masconemet Avenue","Masdaram Dr","Maserati Dr","Mashnee Road","Maskwonicut Street","Mason Ave",
            "Mason Canyon Rd","Mason Court","Mason Ct","Mason Dr","Mason Ferry Rd","Mason Heights","Mason Hill",
            "Mason Hill Rd","Mason Hospital Dr","Mason Ln","Mason Pl","Mason Rd","Mason St","Mason Street",
            "Mason Street W E","Mason Ter","Mason Way","Masonic Ave","Masonic Dr","Masonic Home","Masonic Ln",
            "Masonic Rd","Masonic Way","Masons Mobile City","Masonville Centerton Rd","Mass Ave N",
            "Mass Central/MCRT","Massa Ln","Massachusetts Ave","Massachusetts Avenue","Massachusetts Ln",
            "Massachusetts Turnpike","Massasoit Bridge Road","Massasoit Rd","Massell Rd","Massey Ct",
            "Massey Dr","Massey Rd","Massey Road","Massey St","Massey Street","Masseyfield Gate","Massimo Cir",
            "Mast Head","Mast Head Reach","Mast Ln","Mast Rd","Mast Road","Mast Road Extention","Masten Rd",
            "Master St","Mastercraft Ave","Masters Avenue","Masterson Drive","Masterson Ln","Masthope Ave",
            "Mastros Trailer Park Rd","Matamoroe Way","Matchedas Street N","Matchedas Street S",
            "Matchwood Ln","Mateo Ave","Mateo Prado Ct","Mater Mea Pl","Materos Rd","Mateuse St","Matey Ave",
            "Mathe Dr","Mathena Rd","Mather St","Mather Street","Matheson Boulevard East","Matheson St",
            "Mathew Circle","Mathew Ct","Mathew Ln","Mathew Rd","Mathew Street","Mathews Ave","Mathews Dr",
            "Mathews Gate","Mathews Rd","Mathews St","Mathewson Avenue","Mathewson Street","Mathieson Pl",
            "Mathilda Avenue","Mathilda Dr","Mathis Dr","Mathis Rd","Mathis St","Mathurin Road","Mathus Rd",
            "Matilda Ter","Matilija Canyon Rd","Matilla Rd","Matisse Rd","Matlack Ave","Matley Ln","Matley Rd",
            "Matmor Rd","Mato Ct","Matson Ct","Matt Rd","Mattaha Dr","Mattakeesett Street","Matteoni Dr",
            "Matter Horn Way","Matterhorn Ct","Matterhorn Pl","Mattes Rd","Matthew Ct","Matthew Dr","Matthew Ln",
            "Matthew St","Matthew Street","Matthews Dr","Matthews Rd","Matthews Run Rd","Matthewson Rd",
            "Mattice Road","Mattingly St","Mattis Rd","Mattison Ave","Mattison Rd","Mattison St","Mattix Run Rd",
            "Mattnick Dr","Mattole Rd","Mattox St","Matzek Rd","Maud Ave","Maud Rd","Maud Street","Maude Bevan Hill Rd",
            "Maude Tower Rd","Maughan Crescent","Maui Cir","Maui Ct NE","Maujer Street","Mauldin","Mauldin St",
            "Maulding Avenue","Maumee St","Maumelle Blvd","Maunaloa Dr","Maupin Ln","Maura Lane","Maura Road",
            "Maureen Ave W","Maureen Cir","Maureen Ct","Maureen Dr","Maureen Street","Maurer Ave","Maurice",
            "Maurice Court","Maurice Ln","Maurice Mitchell Rd","Maurice River Pky","Maurino Court",
            "Mauro Ct","Maury River Rd","Mauve","Maverick Cir","Maverick Ct","Maverick Dr","Maverick Rd",
            "Maverick St","Maverick Street","Maverick Way","Mavety Street","Mavis Road","Mavis St","Mawney Ave",
            "Mawr Ct","Max Ct","Max Ln","Max Roys Dr","Max Street","Max Tilley Rd","Maxall St","Maxey Dr","Maxey St",
            "Maxfield Boulevard","Maxham Meadow Way","Maxie Ln","Maxim Dr","Maxim St","Maxine Dr","Maxine St NE",
            "Maxlow Ave","Maxson Rd","Maxson St","Maxwell Ave","Maxwell Ct","Maxwell Dr","Maxwell Loop Rd",
            "Maxwell Rd","Maxwell Shores Dr","Maxwell St","Maxwood Dr","May Ave","May Avenue","May Camp Rd N E",
            "May Case Rd","May Ct","May Dr","May George","May Pl","May Rd","May St","May Street","Mayan Dr","Mayapple Ln",
            "Maybaum Avenue","Maybee Ln","Maybelle Ct","Maybelle St","Mayberry Ave","Mayberry Ln","Mayberry Rd",
            "Mayberry Road","Mayberry Way","Maybrook Ave","Maybrook Ct","Maybury Grand St","Maydolph Road",
            "Maydor Ln","Mayer Rd","Mayette Rd","Mayfair Ct","Mayfair Dr","Mayfair Drive","Mayfair Ln","Mayfair Pl",
            "Mayfair Rd","Mayfair Ter","Mayfield Ave","Mayfield Avenue","Mayfield Ct","Mayfield Dr","Mayfield Rd",
            "Mayfield Richards Rd","Mayfield St","Mayfield Terrace St","Mayfield Trl","Mayflower Avenue",
            "Mayflower Circle","Mayflower Ct","Mayflower Dr","Mayflower Drive","Mayflower Lane","Mayflower Ln",
            "Mayflower Rd","Mayflower Rd NE","Mayflower St","Mayflower Street","Mayhew","Mayhew Dr","Mayhew Lane",
            "Mayhew St","Mayita Way","Mayland Ave","Mayle Rd","Mayles Ln","Maymont Ln","Maynard Ave","Maynard Circle",
            "Maynard Ct","Maynard Rd","Maynard St","Mayo Drive","Mayo Rd","Mayo Road","Mayor Crescent","Maypink Ln",
            "Maypole Street","Mays Alley","Mays Landing","Mays Landing Rd","Mays Ln","Maysh","Maysville Rd NE",
            "Mayville Ave","Maywood Dr","Maywood Park Crescent","Mazatzal Dr","Maze Rd","Mazinaw Heights Road",
            "Mazza Ln","Mazzilli Drive","Mazzoni Pl","Mc 133","Mc 143","Mc 164","Mc 170","Mc 6019","Mc Abee Ln",
            "Mc Adoo Ridge Rd","Mc Afee Vernon Rd","Mc Afee-Glenwood Rd","Mc Affee Pl","Mc Alexander Rd",
            "Mc Allister Rd","Mc Almont Rd NE","Mc Art Rd","Mc Arthur Dr","Mc Arthur Hill Rd","Mc Beth Way",
            "Mc Bride Ave","Mc Bride St","Mc Bridge Rd","Mc Bryde St","Mc Caan Rd","Mc Cabe Park St",
            "Mc Cabe St","Mc Call Ave","Mc Call St","Mc Can Mill Rd","Mc Cann","Mc Cann Rd","Mc Cann St",
            "Mc Carthy Dr","Mc Carthy Hill Rd","Mc Cauley Rd","Mc Clain Ave","Mc Clain Rd","Mc Clenaghans Mill Rd",
            "Mc Cloud Ave","Mc Cluskey Rd","Mc Connaha Rd","Mc Connell Ave","Mc Cook Ave","Mc Cormack Pl",
            "Mc Cormick Pl","Mc Corty Rd","Mc Coy Rd","Mc Cray Ct","Mc Creary Dr","Mc Creery Ranch Rd",
            "Mc Cully Ave","Mc Curdy Ave","Mc Cutcheon Ln","Mc Daniel Avenue","Mc Divitt Ave","Mc Donald Dr",
            "Mc Donald St","Mc Donnell Ct","Mc Enroe Dr","Mc Entee Dr","Mc Farland St","Mc Gee Creek Rd",
            "Mc Gill Ln","Mc Gill St; United States Highway 93","Mc Ginnis","Mc Ginnis Rd","Mc Guckin St",
            "Mc Guire Cv","Mc Guire Pl","Mc Guire St","Mc Hale Rd","Mc Hann Rd","Mc Henry Valley Rd",
            "Mc Ilvin St","Mc Ilwraith St","Mc Intyre Rd","Mc Kay Ln","Mc Kee Rd","Mc Kelvey St","Mc Kenna St",
            "Mc Keown Ave","Mc Kevett Rd","Mc Kinley","Mc Kinley Ave","Mc Kinley Ave SW","Mc Kinley St",
            "Mc Kinney Ave","Mc Kinney St","Mc Koon Ave","Mc Koons Rd","Mc Lain Pl","Mc Lanahan St","Mc Laughlin Mill Rd",
            "Mc Lean Ave","Mc Leod Ave","Mc Leod St","Mc Ln","Mc Lure Rd","Mc Mahan Cove Rd","Mc Mahon Pl",
            "Mc Michael St","Mc Millan Ave","Mc Murray Meadows Rd","Mc Nabb Dr","Mc Nabb Rd","Mc Namara Rd",
            "Mc Neil St","Mc Neil Truck Trail","Mc Nerney Ave","Mc Phetres St","Mc Queen Blvd","Mc Questen St",
            "Mc Whorter St","McAdams Ranch Rd","McAdams Rd","McAdoo Ave","McAfee Rd","McAlpine Street",
            "McAnally Pl","McArthur St","McAtee Ln","McBain Avenue","McBeth Ct","McBrayer Ln","McBride Ave",
            "McBride Avenue","McBride Crescent","McBride Rd","McCabe Ave","McCabe St","McCabe Way","McCaddam Rd",
            "McCaffery Rd","McCaffery Trl","McCain Ln","McCain Street","McCainville Rd","McCall","McCall Ave",
            "McCall Cir","McCall Manor Apartment","McCall Pl","McCallum Crescent S","McCann Blvd",
            "McCann Ct","McCann Rd","McCann St","McCannan Avenue","McCarson Ln","McCarter Ave","McCarter Hwy",
            "McCarter Rd","McCarthy Blvd","McCarthy Boulevard","McCarthy Court sidewalk (south side)",
            "McCarthy Ct","McCarthy Ln","McCarthy Rd","McCarthy St","McCarty Cir","McCarty Dr","McCarty Hill Rd",
            "McCarty Ridge Rd","McCarty St","McCarver Rd","McCaskill Aly E","McCay Ave","McCay Dr","McCellen St",
            "McClain St","McClanathan Ave","McClee St","McClellan Ave","McClellan Blvd","McClellan St",
            "McClelland Ave","McClellen St","McCloud Rd","McClung Ave","McClure Court","McClure Drive",
            "McClure Ln","McCluskey Ct","McCluskey Dr","McCollough Rd","McColm Dr","McCombs St","McConnell Ave",
            "McConnell Drive","McConnell Rd","McCormack Street","McCormick Ave","McCormick Blvd","McCormick Ct",
            "McCormick Rd","McCorriston Sq","McCosh Cir","McCosh Mill Rd","McCourt Pl","McCowan Road",
            "McCoy Dr","McCoy Ln","McCoy Mtn Rd","McCoy Rd","McCoy St","McCracken","McCracken Dr","McCracken's Landing Road",
            "McCrackin Avenue","McCrae Loop","McCraney Street East","McCrary Cir","McCray Rd","McCrea Pl",
            "McCrede Road","McCree Ave","McCrimmon Crescent","McCrimon Rd","McCrump St","McCulloch Avenue",
            "McCullough Dr","McCullough Drive","McCumber Hill Rd","McCune Rd","McCurdy Dr","McCurdy Ln",
            "McCurdy Rd","McCurry Ln","McDairmid Road","McDaniel Ln","McDaniel St","McDaniels Dr","McDermott Pl",
            "McDevitt Dr","McDole Rd","McDonald","McDonald Ave","McDonald Blvd","McDonald Ln","McDonald Pl",
            "McDonald Rd","McDonald's drive-thru","McDonalds Mhp","McDougall Court","McDougall Drive",
            "McDowell Ct","McDowell Pl","McDowell St","McEarl Rd","McEathron Ln","McEnnery Canyon Rd",
            "McEwen Avenue","McEwen Rd","McFadden Road","McFarland Court","McFarland Rd","McFarland St",
            "McFarlane Ave","McFarlen Dr","McFarrens Lane","McGalliard Ave","McGee's Aly","McGehee Place Ct",
            "McGill Road","McGill St","McGill Street","McGinnis Avenue","McGlenn Ct","McGlowerd Rd","McGougin Rd",
            "McGovern Rd","McGowan Court","McGowen Rd","McGrath Ave","McGrath Ln","McGrath Pedestrian Bridge",
            "McGraw Ct","McGray Way","McGregor Ct","McGregor Dr","McGregor St","McGriff Court","McGuffie Dr",
            "McGuire Blvd","McGuire Mountain Rd","McGuire St","McHargue Ln","McHood Rd","McIntosh Cir",
            "McIntosh Drive","McIntosh Ln","McIntosh Rd","McIntosh St","McIntosh Street","McIntyre Ave",
            "McIntyre Ct","McIntyre Rd","McIntyre St","McIrvine Road","McIver Rd","McKale Ln","McKay Dr",
            "McKay Ln","McKay Rd","McKay St","McKeague Ave","McKean Ave","McKee Ave","McKee Avenue","McKee Hill Rd",
            "McKee Ln","McKee Pl","McKee Rd","McKeen Rd","McKell Ln","McKellar","McKeller Rd","McKelvy Ave",
            "McKendree Rd","McKendry Road","McKenna Dr","McKenney Ct","McKenney Dr","McKenny Ct","McKenzie Ave",
            "McKenzie Drive","McKenzie Ln","McKenzie St","McKenzie Street","McKenzie Trl","McKeown Ave",
            "McKeown Ln","McKesson St","McKinley Ave","McKinley Ave SW","McKinley Avenue","McKinley Ct",
            "McKinley Dr","McKinley Pl","McKinley Rd","McKinley St","McKinon","McKinstry St","McKishen Rd",
            "McKnight Ave","McKone Ln","McLain","McLain St","McLane Rd","McLaren Crescent","McLaren Street",
            "McLaughli Road","McLaughlin Ave","McLaughlin Ln","McLaughlin Road","McLean Dr","McLean Rd",
            "McLean Road","McLean Way","McLear Rd","McLelland Rd","McLemore Way","McLendon Rd","McLennan Dr",
            "McLeod Dr","McLeod Lake Game Tr","McLeod Street","McMahan Dr","McMahon Ave","McMahon Rd",
            "McMains St","McMaster Avenue","McMeeken Street","McMichael Pl","McMichael St","McMicking Street",
            "McMillan Avenue","McMillan Ct","McMillan Rd","McMillan Sideroad","McMillian Rd","McMorrough Rd",
            "McMullen Crescent","McMullen Dr","McMullen Rd","McMurrey Ln","McNab Avenue","McNab Boulevard",
            "McNabb St","McNair Ln","McNamee Manor","McNanna Ct","McNaughton Ave","McNaughton Road","McNeal Rd",
            "McNeeley Way","McNeely St","McNeil Davis Ln","McNeil Rd","McNeil St","McNeil Street","McNeil Whistler Way",
            "McNeilly Road","McNicoll Avenue","McNomee St","McNutt Street","McPherson Pl","McQuesten Cir",
            "McRae Dr","McRae Drive","McRae Ln","McRae Par Road","McRae Road","McRae Way","McReynolds Cemetery Rd",
            "McSwain Rd","McSweeny Crescent","McVey Ave","McVey Rd","McVickers Ln","McWhirter Rd","McWilliams Rd",
            "Mcalister Street","Mcbride's Court","Mccarthy Road","Mccaul Street","Mcculloch Street",
            "Mcdonald Road","Mcendy Street","Mcevoy Circle","Mcfarlin Road","Mcgilpin Road","Mcgregor Avenue",
            "Mckay Place","Mckenzie Drive","Mclevin Avenue","Mds Dr","Meachum Road","Mead Ave","Mead Blvd",
            "Mead Court","Mead Ct","Mead Dr","Mead Ln","Mead Pond Park","Mead Rd","Mead St","Mead Way","Meade Ct",
            "Meade Dr","Meade Rd","Meade St","Meade Street","Meader Ln","Meaders Lane","Meador Dr","Meadow Ave",
            "Meadow Avenue","Meadow Blvd","Meadow Br","Meadow Brook Dr","Meadow Brook Ln","Meadow Brook Rd",
            "Meadow Club Rd","Meadow Creek","Meadow Creek Ln","Meadow Creek Rd","Meadow Croft Cir",
            "Meadow Ct","Meadow Dr","Meadow Green Cir","Meadow Green Ct SE","Meadow Grove Ln","Meadow Hill Rd",
            "Meadow Lafe Dr","Meadow Lake Rd","Meadow Lakes Dr","Meadow Lane","Meadow Lane Ct","Meadow Lark",
            "Meadow Lark Ct","Meadow Lark Dr","Meadow Lark Ln","Meadow Lark Pvt Dr","Meadow Lawn",
            "Meadow Ln","Meadow Mist Ct","Meadow Muffin Ln","Meadow Oak Dr","Meadow Oaks Ct","Meadow Rd",
            "Meadow Ridge Ln","Meadow Ridge Rd","Meadow Road","Meadow Run Ct","Meadow Run Loop E",
            "Meadow St","Meadow Stream Dr","Meadow Street","Meadow Street Branch","Meadow Trail","Meadow Vale Dr",
            "Meadow View Dr","Meadow View Ln","Meadow View Rd","Meadow Vista Dr","Meadow Vista Ln",
            "Meadow Way","Meadowbrook","Meadowbrook Ave","Meadowbrook Ave NE","Meadowbrook Court",
            "Meadowbrook Crescent","Meadowbrook Ct","Meadowbrook Dr","Meadowbrook Farms","Meadowbrook Lane",
            "Meadowbrook Ln","Meadowbrook Pl","Meadowbrook Rd","Meadowbrook Ter","Meadowcliff Dr",
            "Meadowcliffe Avenue","Meadowcreek Dr","Meadowcrest Dr","Meadowcrest Road","Meadowcroft Ln",
            "Meadowcroft Rd","Meadowdale Dr","Meadoweigh Ln","Meadowgate Blvd","Meadowland Ct","Meadowland Drive",
            "Meadowlane Dr","Meadowlark Ct","Meadowlark Dr","Meadowlark Ln","Meadowlark Loop","Meadowlark Rd",
            "Meadowlark St","Meadowmere Ln","Meadowmont S C","Meadowood Apartment","Meadowood Ave",
            "Meadowood Dr","Meadowood Drive","Meadowood Ln SW","Meadowood Rd","Meadowood Road","Meadowridge Crescent",
            "Meadowridge Ct","Meadows Ave","Meadows Dr","Meadowside Dr","Meadowvale Drive","Meadowvale Place - Morrisburg",
            "Meadowvale Road","Meadowview Ave","Meadowview Cir","Meadowview Cir NW","Meadowview Ct",
            "Meadowview Dr","Meadowview Drive","Meadowview Ln","Meadowview Pl","Meadowview Rd","Meadowview St",
            "Meads Rd","Meadview Dr","Meagan Ct","Meagan Cv","Meagley Rd","Meaher St","Meander Court","Meander Dr",
            "Means Pl","Means Rd","Means Turner Ln","Meath Dr","Mebus St","Mecca Ave","Mechanic Ave","Mechanic St",
            "Mechanic Street","Mechanical Dr","Mechanics Alley","Mechanics Ave","Mechanics Court",
            "Mechanics St","Mechem St","Mecklenburg Rd","Meco Rd E","Meda By-Pass","Medallion Cir","Medford Ave",
            "Medford Lakes Countr","Medford Leas","Medford Pl","Medford Rd","Medford St","Medford Way",
            "Medhat Drive","Medhurst Road","Media By-Pass","Media Byp","Media Station Rd","Median Drive",
            "Medical Center Dr","Medical Ln","Medical Park Dr","Medical Park Pl","Medici Rd","Medicine Bow Cir",
            "Medicine Man Rd","Medicine Mountain Ct","Medina Court","Medina Dr","Medina Ln","Medina Place",
            "Medina Square","Medina St","Medio Luna Ave","Medio St","Mediterranean Pl","Medley Ave","Medley St",
            "Medline Ave","Medline Rd","Meece St","Meeham Way","Meeker Avenue","Meeker Rd","Meeker St","Meekings Drive",
            "Meeks Ave","Meeks Bay Ave","Meenhan Avenue","Meer's Pt Rd","Meeting House Ln","Meeting House Road",
            "Meeting Pl","Meeting Place Circle","Meeting Rock Dr","Meetinghouse Hill Rd","Meetinghouse Road",
            "Mefferd Ave","Meg Ct","Mega Ct NE","Megan Ann Ct","Megan Cir","Megan Court","Megan Ln","Meggs Rd",
            "Meghan Dr","Meghann Ln","Megill Dr","Mehearg Rd","Mehlenbacher Rd","Meigh Road","Meighen Ave",
            "Meisel Ave","Meisner Ct","Meiss Rd","Meisten St","Meister Ave","Mekler Ct","Melanie Lane","Melanie Ln",
            "Melanson Point","Melant Dr","Melarkey St","Melba Ave","Melba Dr","Melbourne Avenue","Melbourne Ct",
            "Melbourne Dr","Melbourne Road","Melfi Ct","Melgo Lane","Melia Drive","Melinda Crescent",
            "Melinda Ct","Melinda Ln","Melinda Way","Melisa Avenue","Melissa","Melissa Ct","Melissa Ln",
            "Melissa Rae Cir","Melita Ct","Mellak Rd","Mellanby Avenue","Mellen Ave","Melling Dr","Mellings Drive",
            "Mellisa Ct","Mellon Road","Mellor Ct","Mellor Rd","Mellow Ln","Mellowood Drive","Melodiewold",
            "Melody Cir","Melody Ct","Melody Lane","Melody Ln","Melody Lodge Road","Melon St","Melray St",
            "Melrose","Melrose Ave","Melrose Ave S","Melrose Avenue","Melrose Cir","Melrose Ct","Melrose Dr",
            "Melrose Extension","Melrose Ln","Melrose Pl","Melrose Road","Melrose St","Melrose Street",
            "Melrose Terrace","Melton Carter Dr","Melton Ct","Melton Pl","Melton Tr","Melucci Ct","Melva Street",
            "Melvern Ln","Melvern Road","Melville Ave","Melville Avenue","Melville Lane","Melville Pl",
            "Melville Road","Melville St","Melville Terrace","Melville Walk","Melvin Ave","Melvin Dr",
            "Melvin Pl","Melvin St","Melvina Pl","Membres Rd","Memerle Shores Ln","Memorial Ave","Memorial Avenue",
            "Memorial Blvd","Memorial Bridge","Memorial Cir","Memorial Dr","Memorial Dr W","Memorial Drive",
            "Memorial Drive Underpass","Memorial Heights Rd","Memorial Ln SW","Memorial Park Cir",
            "Memorial Park Dr","Memorial Park Rd","Memorial Pky","Memorial Rd","Memorial Square","Memorial St",
            "Memory","Memory Gardens Lane","Memory Lane","Memory Ln","Memory Rd","Memphis Ct","Memphis St",
            "Menaker Rd","Menalto Lane","Menaul Blvd NE","Mendelssohn Street","Mendo County Rd 442",
            "Mendocino Ct","Mendocino Dr","Mendoleine Rd","Mendon Dr","Mendon Street","Mendota Ave","Mendota Dr",
            "Mendota St","Mendum Ave","Menemsha Road","Menge Creek Rd","Menges St","Menke Cir","Menlo Ave",
            "Menlo Dr","Menno Street","Menoke Be Road","Menominee Rd","Menominee River Rd","Menta Corte",
            "Mentone Ave","Mepps Ct","Merced Ct","Merced Falls Rd","Merced National Wldlife Refuge",
            "Merced Rd","Merced St","Mercedes","Mercedes Bend","Mercedes Dr","Mercedes Ln","Mercedes Rd",
            "Mercer Crescent","Mercer Ct","Mercer Dr","Mercer Ln","Mercer Rd","Mercer St","Mercer Street",
            "Mercerville-Whitehorse Rd","Merchant Cir","Merchant Road","Merck Access Rd","Mercury Ave",
            "Mercury Blvd","Mercury Dr","Mercury Hwy","Mercury Ln","Mercury Plz","Mercury St","Mercury Way",
            "Mercus Hill Rd","Mercy Rd","Mercy St","Merden St","Meredith Ave","Meredith Avenue","Meredith Cir",
            "Meredith Ct","Meredith Dr","Meredith Ln","Meredith Pl","Meredith St","Merganser Ter N","Merganser Ter S",
            "Mergho Impasse","Merian Way","Merida Ct","Meridan Ave","Meriden St","Meridian Boulevard",
            "Meridian Ct","Meridian Dr","Meridian Line Rd","Meridian Ln","Meridian Pl","Meridian Rd",
            "Meridian Road","Meridian St","Meridian Way","Meridith Dr","Merigold Dr","Merion Ave","Merion Ln",
            "Merion Rd","Merissa Dr","Merit Court","Merito Ave","Merivale Ave","Merker Dr","Merkley Road",
            "Merle Ave","Merle Cir","Merlin Blvd","Merlin Ct","Merlin Dr","Merlin Ln","Merlin St","Merlo Ave",
            "Merlot Ct","Merlot Dr","Merlot Pl","Merlot Way","Mermaid Avenue","Mero Rd","Merrett Dr","Merrett Street",
            "Merriam Avenue","Merriam Rd","Merribrook Rd","Merric Ct","Merrick & Co","Merrick Blvd","Merrick Cir",
            "Merrick Ct","Merrick Rd","Merrick St","Merrick Street","Merrickville Road Spur","Merridy St",
            "Merrifield Dr","Merrill Ave","Merrill Avenue East","Merrill Cir","Merrill Mt Rd","Merrill Pit Rd",
            "Merrill Pl","Merrill Road","Merrill St","Merrill Street","Merrill Town Hall Rd","Merrill Woods Rd",
            "Merrills Way","Merrimac Avenue","Merrimac Ct","Merrimac Ct NE","Merrimac Drive","Merrimac Road",
            "Merrimac St","Merrimac Street","Merrimack Dr","Merrimack Street","Merriman Ln","Merriman Rd",
            "Merriman Truck Trail","Merrinack Way","Merrison St","Merritt Ave","Merritt Avenue","Merritt Blvd",
            "Merritt Ct","Merritt Dr","Merritt Road","Merritt Road N","Merritt St","Merritt Street","Merrivale Rd",
            "Merrow Rd","Merry Ln","Merry Road Spur","Merrybrook Dr","Merrydrew Court","Merrymount Ave N",
            "Merrymount Rd","Mersea 11 Road","Mersereau Pl","Merson St","Mertensia Ln","Mertle St","Merton Street",
            "Merts Landing","Mervel Ave","Mervin Ln","Mervyn Avenue","Merwin Lane","Merwina Ave","Merwyn Rd",
            "Merwyn Street","Meryal Ln","Merz Ave","Merze Ave","Mesa Ave","Mesa Ct","Mesa Ct SW","Mesa Dr",
            "Mesa Dr NW","Mesa Grande Rd","Mesa Linda Dr NE","Mesa Linda Rd","Mesa Linda St","Mesa Marin Dr",
            "Mesa Rd","Mesa Sea","Mesa St","Mesa St SE","Mesa Terrace Rd","Mesa Top Trl","Mesa Verde","Mesa Verde Ave",
            "Mesa Verde Ct","Mesa Verde Dr","Mesa View","Mesa Vista Ave","Mescal Ct","Mescal Pl","Mescal Way",
            "Mescalero Ct","Mescalero Rd NE","Mescalero Trl","Mescallero","Meserole Street","Meshoppen Creek Rd",
            "Mesilla St NE","Mesnard St","Mesquite","Mesquite Ave","Mesquite Canyon Rd","Mesquite Dr",
            "Mesquite Pl SW","Mesquite Rd","Mesquite Valley Rd","Messengers Bay Rd","Messer Dr","Messer Ln",
            "Messer Rd","Messiah Dr","Messina Dr","Messina St","Meston Ranch Rd","Meta Rd","Metacom Ave",
            "Metacomet Circle","Metacomet Street","Metacomett Road","Metcalf","Metcalf Circle","Metcalf Dr",
            "Metcalf Gap Rd","Metcalf Street","Metcalfe Drive","Metcalfe Street","Meteor Aly","Meteor Trl",
            "Meteor Way","Meter St","Methodist Church St","Methuen Avenue","Methuen St","Methuen Street",
            "Methuselah Trail","Metlars Ln","Metler Road","Metro","Metro Academy Way","Metro Dr","Metro Orange Line Bikeway",
            "Metro Road N","Metro Trl","Metropolitan Avenue","Meuse Argonne St","Meuter Pl","Mewata Gate",
            "Mewburn Avenue","Mex-2","Mexican Flat Trail","Mexican Lake Rd","Mexican Ridge Rd","Meyer Dr",
            "Meyer Hill Rd","Meyer Ln","Meyer Rd","Meyer St","Meyer Street","Meyer's Road N","Meyerhill Cir E",
            "Meyers Ave","Meyers Creek Road","Meyers Dr","Meyers Ln","Meyers Rd","Meyers Road","Meyers Way",
            "Mezcal St","Mgm Dr","Mi 2","Mi 7","Mi3","Miacomet Road","Miami Avenue","Miami Blvd","Miamis Rd","Mica Dr",
            "Mica Dr NE","Mica Way","Mich Court","Mich-Chi-Won","Michael","Michael Ann Ct","Michael Ave",
            "Michael Avenue","Michael Boulevard","Michael Cir","Michael Crest Dr","Michael Ct","Michael Dr",
            "Michael Ln","Michael Loop","Michael Rd","Michael Sears Road","Michael Smith Dr","Michael St",
            "Michael Ter","Michael Wendell Way","Michael's Cir","Michaels Mountain Rd","Michaels Path",
            "Michaels Way","Michalik Rd","Michaud Avenue","Michel Rd","Michela Way","Michele Ct","Michele Dr",
            "Michele Way","Michelina Terrace","Michell St","Michelle Ct","Michelle Dr","Michelle Drive",
            "Michelle Ln","Michelle Pl","Michelle Ridge","Michelle Ruelle","Michelle St","Michelle St SW",
            "Michelle Way","Michelson Road","Michener Court","Michibay Dr","Michigan Ave","Michigan Ave E",
            "Michigan Avenue","Michigan Blvd","Michigan Ct","Michigan Hollow Rd","Michigan Road","Michigan St",
            "Mickey Courts","Mickey Mantle Ave","Mickey St","Micki Dr","Mickle Blvd","Mickle Bridge Rd",
            "Mickle St","Mickley Rd","Micks Rd","Micro Rd","Mid Atlantic Pky","Mid Belmont Township 7th Line",
            "Mid Cape Highway","Mid County Expressway","Mid County Expy","Mid Mountain Rd","Mid Oaks Rd",
            "Mid Orange Correctional Facili","Mid Valley Rd","Midas Dr","Midas Loop","Midcrest Ct",
            "Midcrest Rd","Midcroft Drive","Middagh Street","Middie Ln","Middle Ave","Middle Branch Rd",
            "Middle Brook Rd","Middle Haven Dr","Middle Libby Rd","Middle Ln","Middle Point Dr","Middle Ponderosa Way",
            "Middle Pratt Pond Rd","Middle Ranch Rd","Middle Rd","Middle Ridge","Middle Ridge Dr",
            "Middle Ridge Rd","Middle Road","Middle Rose St","Middle Rowsburg Rd","Middle St","Middle Street",
            "Middle Trl","Middleboro Avenue","Middleboro Rd","Middleborough Rotary","Middlebourne Pl",
            "Middlebrook Dr","Middlebrook Hill Rd","Middlebrook Pl","Middlebrook Rd","Middlebrooks Dr",
            "Middlebrooks Ln","Middlebury Drive","Middlebury Ln","Middlebury Rd","Middlebury Store Rd",
            "Middlecott Lane","Middlefield Rd","Middlefield Road","Middlelake Rd","Middlesex Ave",
            "Middlesex Avenue","Middlesex Essex Tpke","Middlesex Rd","Middlesex Road","Middleton Ave",
            "Middleton St","Middleton Street","Middletown Ct","Middletown Rd","Midhurst Drive","Midiron Way",
            "Midland","Midland Ave","Midland Avenue","Midland Blvd","Midland Dr","Midland Road","Midland Street",
            "Midland Trail Rd","Midland Way","Midlantic Dr","Midnightsun Trail","Midori Ln","Midpark Dr",
            "Midpark Drive","Midsection St","Midstate Drive","Midvale Ave","Midvale Way","Midway Ave",
            "Midway Ct","Midway Dr","Midway Ln","Midway Rd","Midway St","Midway Street","Midwood Ave","Midwood Rd",
            "Midwood Road","Midwood Street","Midwood Trail","Mifflin St","Miguel Ln","Miguel St","Miguel Way",
            "Mihato Heights","Mikado Avenue","Mike Dr","Mike McLaughler","Mike O’Callaghan-Pat Tillman Memorial Bridge",
            "Mike Rd","Mike St","Mike Yorba Way","Mikell Ct NW","Mikell Ln","Mikes Crossway","Mikes Rd",
            "Mikinda Ave","Mikolla Court","Mikolla Road","Mila St","Milady Road","Milagra Dr","Milagro Estrella",
            "Milam Ln","Milam Rd","Milan Ave","Milan Rd","Milano Ct","Milano Dr","Milano St","Milarch Rd","Milard Ln",
            "Milbank Ave","Milbank Rd","Milbar Ct","Milbocker Rd","Milbrook Rd","Milburn Dr","Milburn Road",
            "Milburn St","Milcrip Rd","Mildenhall St","Mildred Ave","Mildred Avenue","Mildred Ct","Mildred Dr",
            "Mildred J Ct","Mildred Ln","Mildred St","Mildred Ter","Mile High Cir","Mile High Rd","Mile Point Dr",
            "Mile Road","Mile Square Rd","Mile Strip Expy","Milens Rd","Miles Ave","Miles Farm Road",
            "Miles Ln","Miles Rd","Miles Spring Rd","Miles St","Miles Way","Milestead Rd","Milestone Road",
            "Milestrip Rd","Milestrip Rd East","Milestrip Rd West","Milewood Rd","Miley Rd","Milford Ave",
            "Milford Beach Rd","Milford Ct","Milford Dr","Milford Glen Cir","Milford Grd","Milford Haven Drive",
            "Milford Landing Dr","Milford Ln","Milford Pl","Milford Pl NE","Milford Street","Milford Town Green Ln",
            "Milford Warren Glen Rd","Milford-Commons Rd","Milgray Ct","Military","Military Ave","Military Pass",
            "Military Rd","Military Reservation Boundary","Military St","Military Trail","Militia Trail",
            "Milk Avenue","Milk Run Road","Milk St","Milk Street","Milkey Rd","Milkweed Lane","Milkwood Avenue",
            "Milky Way","Milky Way Point","Mill Ave","Mill Avenue","Mill Brook Rd","Mill Canyon Rd","Mill Creek",
            "Mill Creek Ct","Mill Creek Dr","Mill Creek Ln","Mill Creek Loop","Mill Creek Rd","Mill Creek Trl",
            "Mill Creek Way","Mill Dr","Mill Glen Road","Mill Glen St","Mill Hill Road","Mill Ln","Mill Park Rd",
            "Mill Pl","Mill Pond Condos","Mill Pond Rd","Mill Pond Road","Mill Pond Way","Mill Port Cv S",
            "Mill Race Rd","Mill Race Road","Mill Rd","Mill Road","Mill Road Circle","Mill Run","Mill St",
            "Mill St NE","Mill St Rd","Mill Stream Cir","Mill Street","Mill Street E","Mill Street S",
            "Mill Street; Highway 43","Mill Trce","Mill Valley Cir S","Mill Valley Road","Mill Wheel Ct",
            "Millar Ct","Millar Dr","Millard Ave","Millard Avenue","Millard Cir","Millard Rd","Millard Street",
            "Millay Ct","Millbank Rd","Millbank St","Millbrook Gate","Millbrook Pl","Millbrook Rd","Millbrook Street",
            "Millbrook Way","Millbury Road","Millbury Street","Millcar Drive","Millcliff Circle","Millcreek Drive",
            "Millcreek Pl","Milldale Rd","Millen Road","Millennium Drive","Millennium Loop","Miller Ave",
            "Miller Basin Rd","Miller County 10","Miller Creek Cir","Miller Creek Rd","Miller Ct",
            "Miller Dr","Miller Heights Rd","Miller Hill Rd","Miller Ln","Miller Park Rd","Miller Pl",
            "Miller Place","Miller Ranch Rd","Miller Rd","Miller Road","Miller St","Miller Street","Miller Way",
            "Miller's Cutoff","Miller's Grove","Millers Grove Rd","Millers Ln","Millers Mills Rd",
            "Millers Run Rd","Millers Xing","Millersville Ln","Millet","Millett Dr","Milleville Ave",
            "Millford Xing","Millholland Tr","Millicent Rogers Rd","Milligan Dr","Milligan Ln","Milligan Place",
            "Milliken Ct","Millington Rd","Milliron Rd","Millpond Ct","Millpride Ln","Millrace Rd","Mills",
            "Mills Ave","Mills Avenue","Mills Extended","Mills Ln","Mills Pl","Mills Ranch Rd","Mills Rd",
            "Mills Road","Mills St","Millside Dr","Millstone Ct","Millstone Ln","Millstone Rd","Millstream Ct",
            "Milltown Rd","Millux Rd","Millview Ave NW","Millway Avenue","Millwood Court","Millwood Dr",
            "Millwood Parkway","Millwood Rd","Millwood Road","Millwood St NW","Millwright Avenue",
            "Milmont Ave","Milne Avenue","Milne Ct","Milne Lane","Milne Street","Milner Avenue","Milner Gate",
            "Milner Road","Milner St","Milnor St","Milo Ln","Milo St NW","Milrose Ln","Milroy Lane","Milsap Bar Rd",
            "Milton Ave","Milton Ave NE","Milton Avenue","Milton Ct","Milton Pl","Milton Place","Milton Rd",
            "Milton Road","Milton St","Milton Street","Milverton Boulevard","Milward Street - Mariatown",
            "Milwaukee Ct","Milwee St","Milwood Ave","Mimbres Dr","Mimi Ct","Mimi Ln","Mimi Pl","Mimico Avenue",
            "Mimosa","Mimosa Ave","Mimosa Cir","Mimosa Ct","Mimosa Dr","Mimosa Drive","Mimosa Ln","Mimosa Rd",
            "Mimosa St","Mimosa Trl","Mims Cir","Mims Rd","Mims St","Min Avenue","Mina Ave","Mina Rd","Mina St",
            "Minard Rd","Minaret Rd","Minaret to Tallus Connector","Minarets Ave","Mindanao Dr","Minden Ln",
            "Minden Way","Mindenville Dr","Minder St","Mindy Ln","Mine Ave","Mine Ct","Mine Hill Rd","Mine Rd",
            "Mine Road","Mine Spring Ln","Mine St","Mineola Pl","Mineola Road","Mineola Road West","Mineola St",
            "Miner Cir","Miner Lake Dr","Miner Rd","Mineral Ave","Mineral Radge Rd","Mineral Rd","Mineral Spring Way",
            "Mineral St","Minero Rd","Miners Bay Road","Miners Lane","Minerva Ave","Minerva St","Mines Rd",
            "Ming Tree Ln","Mingay Avenue","Mingo Ave","Mini Jacket St","Mini Ranch Rd","Mini St","Minifie Road",
            "Minisink Dr","Minisink Rd","Minisink Trl","Minister Rd","Mink Ct","Mink Dr","Mink Rd","Minkler Rd",
            "Minks Pond Rd","Minkville Rd","Minneapolis Park Dr","Minnehaha Path","Minnehaha St","Minneluta Trl",
            "Minnesota","Minnesota Ave","Minnesota Ct","Minnesota Dr","Minnesota St","Minnetonka Cir",
            "Minnewawa Road","Minnie Jones Ln","Minnie St","Minnietown Ln","Minnow Ln","Minns Ave","Minocqua St",
            "Minonee Ln","Minor Dr","Minor Hill Rd SW","Minor St","Minorca Ct","Minorca Place","Minortown Road Connector",
            "Minot Light Ct","Minot Ln","Minot St","Minott Road","Minquadale Boulevard","Minquadale Tr Pk",
            "Minquadle Tr Pk","Minsi Dr","Minsther Dr","Minstrel Drive","Mint Meadow Dr","Minter Ct",
            "Minto Road","Minton Place","Minturn Rd","Mintwood Ln","Minuet Ln","Minuet Pl","Minute Arms Rd",
            "Minute Man NHP/Battle Road Trail","Minuteman Road","Mipolomol Rd","Mira","Mira Ct","Mira Flores Ln",
            "Mira Ln","Mira Loma Dr","Mira Loma Rd","Mira Mesa Blvd","Mira Vista Place","Mira Way","Mirabella Ave",
            "Miracle Lane Rd","Miracosta St","Mirada Cir","Mirada Ln","Mirador Ct","Mirador Dr","Mirador St",
            "Miraflores Ave","Mirage Ct","Mirage Place","Mirage St","Miramar Ave","Miramar Cir","Miramar Ct",
            "Miramar Ln NW","Miramar Ter","Miramar Way","Miramontes St","Miranda Ct","Miranda Ln","Miranda Rd",
            "Miranda St","Mirasol Pl NW","Mirasol Way","Miraya Court","Miriam Ct","Miriam Rd","Miriam Road",
            "Mirick Ave","Mirick Road","Mirror Lake Rd","Mirrored Image Ct","Mirrow Court","Mirth Dr",
            "Mirth Rd NE","Misener Road","Misery Bay Rd","Mish Dr","Mishawum Road","Mishemokwa Trl","Miss Bev Rd",
            "Miss Elle Way","Misset St","Mission Bell Ave","Mission Carmel Cv","Mission Ct","Mission Drive",
            "Mission Hills Dr","Mission Oaks Blvd","Mission Rd","Mission Ridge Ct","Mission St","Mission-del-Rio",
            "Mississaga Street W","Mississau Street","Mississauga Road","Mississauga Transitway",
            "Mississauga Valley Boulevard","Mississippi Ave","Mississippi St","Mississippi Trl",
            "Missouri St","Missouri Street","Missy Rd","Mist Flower Ct","Mista Ct","Mista Dr","Mistletoe Ave",
            "Mistletoe Dr","Mistwell Crescent","Mistwood Dr","Mistwood Ln","Misty Cloud Pl","Misty Court",
            "Misty Cove Ct","Misty Ct","Misty Glen Dr","Misty Lake Glen Rd","Misty Lane","Misty Ln","Misty Marie Ln",
            "Misty Meadow Drive","Misty Meadow Ln","Misty Meadows Dr","Misty Moon Ave","Misty Pine Crescent",
            "Misty Rose Ave","Misty Sky Dr","Misty Valley Dr","Misty Woods","Mistywood Ln","Mitchel St",
            "Mitchell","Mitchell Ave","Mitchell Avenue","Mitchell Cir","Mitchell Creek Dr","Mitchell Ct",
            "Mitchell Dr","Mitchell Hill Road","Mitchell Lake Rd","Mitchell Lane","Mitchell Ln","Mitchell Mine Rd",
            "Mitchell Rd","Mitchell Rd SE","Mitchell Road","Mitchell St","Mitchell Street","Mitchell Ter",
            "Mitchells Way","Mitchelltown Rd","Mitra Ln","Mitrano Ln","Mitscher St","Mitten Ln","Mitzpah Rd",
            "Miwok Path","Mixer St","Mizoras Dr","Mizpah Rd","Mizpah St","Moab Ct","Moak Dr","Moana Pl","Moapa Road",
            "Moark Dr E","Moat Mountain Trail","Moberley Avenue","Moberly Avenue","Moberly Pl","Moberly Rd",
            "Mobil Home Park","Mobile Blvd","Mobile Dr","Mobile Home Dr","Mobile Home Park","Mobile Ln",
            "Mobile Rd","Mobile St","Mobley St","Mocal Rd","Mocasin Trl","Mocassin Trl","Moccasin Dr","Moccasin Path",
            "Moccasin Rd","Moccasin Switchback Rd","Moccasin Trail","Moch Rd","Mochen Ct","Mocine Elm Ct",
            "Mock Rd","Mockingbird","Mockingbird Dr","Mockingbird Hill Rd","Mockingbird Ln","Mockingbird Rd",
            "Mockingbird Trl","Model Ave","Modena Dr","Modena Ter","Modica St","Modies Ranch Rd","Modjeska Canyon Rd",
            "Modjoska","Modler Road","Modlin Road","Modoc Ave","Modoc Ct","Modoc Pl","Moekel Rd","Moeller Pl",
            "Moff Dr","Moffatt Avenue","Moffatt Street","Moffett Rd","Moffett Rd;United States Highway 98; State Route 42",
            "Mogollon","Mogollon Rim Rd","Mohamed Cir","Mohave Ln","Mohave Rd","Mohawk Ave","Mohawk Cir",
            "Mohawk Ct","Mohawk Dr","Mohawk Rd","Mohawk St","Mohawk Street","Mohawk Tr","Mohawk Trail","Mohawk Trl",
            "Mohegan Dr","Mohegan Ln","Mohegan St","Mohegan Street","Mohican","Mohican Dr","Mohican Rd",
            "Mohican Trl","Mohican Way","Moic Dr","Moira Avenue","Moira Road","Moira Street W","Moise Wood Rd",
            "Moison Rd N","Moits Pl","Mojave Ct","Mojave Dr","Mojave Freeway","Mojave Ln","Mojave Rd","Mojave Road",
            "Mojave St","Mojave Tr","Molen Dr","Molina Creek","Molina Hill Rd","Molino del Rey","Mollard Road",
            "Mollbore Ter","Mollendo Blvd","Moller St","Mollie Ln","Molly Avenue","Molly Dr","Molly Ln",
            "Molly Pitcher Dr","Molly Pitcher Way","Molnar Ct","Molokai Dr","Molsom Cir","Moluch Street",
            "Mommoth Slopes Way","Momosa Way","Mona Ave","Mona Lisa Ct","Monadnock St","Monaghan Road",
            "Monarch Cir","Monarch Dr","Monarch Drive","Monarch Ln","Monarch Park Avenue","Monarch Park Drive",
            "Monarch Pass Dr","Monarch Pl","Monastery Ave","Monastery Ln","Monck Street","Moncreif Line",
            "Moncrest Dr","Moncrieff Drive","Monday Rd","Mondo Ln","Monessen Ct","Monet Street","Monet Walk",
            "Monet Way","Money Rd","Money St","Moneymore Road","Monfort Street","Mongollon Ct","Monica Ct",
            "Monica Ln","Monico Dr","Monique Ave","Monique Court","Monique Ct","Monique Dr","Monique Dr NE",
            "Monique Street","Monita Cir","Monitor Ln","Monitor Mill Rd","Monitor Rd","Monitor St","Monitor Street",
            "Monitor Way","Monk Ct NW","Monk Street","Monkey Run Rd","Monklands Avenue","Monks Rd","Monkton Avenue",
            "Monmouth","Monmouth Ave","Monmouth Blvd","Monmouth Dr","Monmouth Rd","Monmouth St","Monmouth Street",
            "Monmouth Ter","Mono Ave","Mono Ct","Mono Dr","Mono Lake Ave","Mono St","Mono Street Trail",
            "Mono Way","Monolith St","Monomee Ln","Monomoit Lane","Monomonac Drive West","Monomonac Road East",
            "Monomoy Street","Monona Dr","Monoplane Pl","Monora Estates Ln","Monponsett Street","Monro",
            "Monroe Asher Field Rd","Monroe Ave","Monroe Ave W","Monroe Avenue","Monroe Blvd","Monroe Community College",
            "Monroe Ct","Monroe Dr","Monroe Drive","Monroe Orleans County Line Road","Monroe Pl","Monroe Rd",
            "Monroe St","Monroe Street","Monroe Trl","Monroe-Heights Rd","Monrovia Canyon Truck Trail",
            "Monsanto Court","Monsey Rd","Monsignor Casey Highway","Monsignor Obrien Highway","Monson Turnpike",
            "Mont Ave","Monta Vista Rd","Montague Loop","Montague Pl","Montague Rd","Montague Street",
            "Montaine Park","Montalvo Way","Montana Ave","Montana Ave; United States Highway 62; United States Highway 180",
            "Montana Avenue","Montana Blvd","Montana Ln","Montana Pl N","Montana Serena Ct","Montana St",
            "Montano Pointe Pl NW","Montauk Pl","Montauk Trl","Montaup Street","Montavenia Dr","Montazuma Cyn Rd",
            "Montcalm Boulevard","Montclair Ave","Montclair Ct","Montclair Dr","Montclair St","Monte Alegre Rd",
            "Monte Azul Ln","Monte Bello Road","Monte Carlo Drive","Monte Christo Rd","Monte Cristi Street",
            "Monte Grosso Ct","Monte Hermoso Dr","Monte Maria Ave","Monte Rd","Monte Road","Monte Verde Dr",
            "Monte Viso Dr","Monte Vista Ave","Monte Vista Cir","Monte Vista Ct","Monte Vista Dr",
            "Monte Vista Ln","Monte Vista Rd","Monte Vista Ridge Rd","Monte Vista St","Montebello Blvd",
            "Montebello Rd","Montecello","Montecito Ave","Montecito Court","Montecito Dr","Montee Rd",
            "Montefino Dr","Montego","Montego Ct","Montego Road","Monteira Ln","Montelena Ct","Montell St",
            "Montello Street","Montera Dr","Montera Ln","Monterey Ave","Monterey Blvd","Monterey Crest Dr",
            "Monterey Ct","Monterey Dr","Monterey Drive","Monterey Pines Pl","Monterey Rd","Monterey Salinas Hwy",
            "Monterey St","Monterey Sunrise","Montero Ct","Montero Rd NE","Monterrey Ave","Montessouri St",
            "Montevallo Rd","Montevideo Road","Montevina Rd","Montezuma","Montezuma Ave","Montezuma Pl",
            "Montezuma St","Montezuma Trail","Montezuma Trl","Montgomery Ave","Montgomery Avenue",
            "Montgomery Dr","Montgomery Hwy","Montgomery Ln","Montgomery Pkwy Loop NE","Montgomery Pl",
            "Montgomery Place","Montgomery Rd","Montgomery Rd NE","Montgomery Road","Montgomery St",
            "Montgomery Street","Monticello Ave","Monticello Ave NW","Monticello Ct","Monticello Pl",
            "Monticello Raceway","Monticello Rd","Montiel Truck Trail","Montlake Ter","Montour St",
            "Montoya Ave","Montoya Cir","Montoya Rd","Montoya St","Montoya St NW","Montre Way","Montreal Street",
            "Montreux Way","Montridge Way","Montrois Ln","Montroles Rd","Montrose Ave","Montrose Avenue",
            "Montrose Crescent","Montrose Ct","Montrose St","Montrose Station Road","Montura Dr","Montvale Pl",
            "Montview Ct","Montview Pl","Monty Circle","Monument Avenue","Monument Court","Monument Ct",
            "Monument Drive","Monument Hill Rd","Monument Katnich","Monument Rd","Monument St","Monument Valley Road",
            "Monument Walk","Monument Way","Moo Ct","Moody Bridge Road","Moody Ln","Moody Meadow","Moody Pky",
            "Moody Rd","Moody Springs Ct","Moody St","Moody Street","Moody Truck Rd","Mooers Lane","Moon",
            "Moon Aly","Moon Canyon","Moon Creek Way","Moon Dust Ln","Moon Hill Rd","Moon Lake Rd","Moon Pl NE",
            "Moon Rd","Moon Roses Ct","Moon Run Rd","Moon Shadow","Moon Shadow Ct","Moon Shadow Ranch Rd",
            "Moon St","Moonachie Ave","Moonbeam Cir","Moonbeam Grove","Moonbend Rd","Moonbranch Dr","Mooncrest Dr",
            "Mooney Ave","Moonglow Ct","Moonlight Drive","Moonlight Lane","Moonlight Mesa","Moonlight Park Ave",
            "Moonlight Rd","Moonlight Ter","Moonpenny Lane","Moonridge","Moonridge Rd","Moonrise Ct",
            "Moonriver Bay","Moonsail Ln","Moonshine Creek","Moonstar Ln","Moonstone Ave","Moonstone Dr",
            "Moonstone Road E","Moonstruck Point","Moonview Dr","Moonwind Ct","Moorcroft Ave","Moore Ave",
            "Moore Avenue","Moore Cir","Moore Ct","Moore Dr","Moore Drive","Moore Hill Road","Moore Orchard Road",
            "Moore Pilot Ridge Rd","Moore Pl","Moore Rd","Moore Road","Moore St","Moore Street","Moorea Dr",
            "Moorehead Dr","Mooreland Dr","Mooreland St","Moores Ln","Moores Pond Spur","Moores Terrace Rd",
            "Mooresboro Rd","Moorestown Mount Laurel Rd","Mooresville Rd","Mooreton Ave","Mooreville Ridge Rd",
            "Mooring Ave","Mooring McNeil Rd","Moorman Ave","Moorpark Fwy","Moorpark St","Moorpark Way",
            "Moose Ave","Moose Ct","Moose Dr","Moose Hill Rd","Moose Hill Road","Moose Ln","Moose Pond Dr",
            "Moose Rd","Moose Ridge Rd","Moose St","Moosilauke Rd","Moosup Valley Rd","Moot Ct","Moote Road",
            "Mootz Rd","Moqui Dr","Moqui St","Mora Ave","Mora Dr","Mora St","Morab Ct","Morada Pky","Moraes Ct",
            "Moraga Ct","Moraga St","Moraga Way","Morales Dr","Moran Ave","Moran Rd","Moran Road","Moran St",
            "Morango Dr","Moravetz Ln","Moravian Rd","Moravian St","Moray Avenue","Moray Ct","Morcom Ter",
            "Morden Road","More Park Rd","More Rd","Moreau Ct","Morehart Ave","Morehouse Flats Rd","Moreland Ave",
            "Moreley Ave","Morella Ave","Moreman Ln","Morenci Rd","Moreno Rd","Morey Dr","Morgan","Morgan Ave",
            "Morgan Avenue","Morgan Blvd","Morgan Carr Rd","Morgan Center Rd","Morgan Church Rd","Morgan Ct",
            "Morgan Dr","Morgan Estates Rd","Morgan Gulf Rd","Morgan Hill Rd","Morgan Ln","Morgan Park Rd",
            "Morgan Rd","Morgan Ridge","Morgan Road","Morgan St","Morgan Street","Morgan Valley Rd","Morgan's Street",
            "Morgandale Ct","Morgans Point Road","Morgans Road","Morgans Run","Morgans Way","Morisse Ave",
            "Morley Ave","Morley Dr","Mormon Emigrant Trl","Morning Dove Ave","Morning Dove Dr","Morning Dove Drive",
            "Morning Dove Ln","Morning Dr","Morning Glory Ct","Morning Glory Dr","Morning Glory Ln",
            "Morning Glory St","Morning Glory Way","Morning Mist Dr","Morning Oak Ln","Morning Side Dr",
            "Morning Star Dr","Morning Star Drive","Morning Star Mine Rd","Morning Star Rd","Morning Star Row",
            "Morning Sun Ct","Morning View","Morning View Ave NW","Morning View Dr","Morningdale Blvd",
            "Morninglory Dr","Morningside Ave","Morningside Avenue","Morningside Ct","Morningside Dr",
            "Morningside Drive","Morningside Ln","Morningside Rd","Morningstar Ct","Morningview Dr",
            "Morningview Trail","Moro Bay Dr","Moro Rock Tr","Morrell St","Morretti Canyon Rd","Morril Dr",
            "Morrill Ave","Morrill Street","Morrilton Cir NW","Morris Ave","Morris Avenue","Morris Blvd",
            "Morris Court","Morris Dr","Morris Ln","Morris Majestic Rd","Morris Mill Rd","Morris Pl",
            "Morris Rd","Morris Road","Morris St","Morris St NE","Morris Street","Morris Ter","Morris Town Beach",
            "Morris Tpke","Morris Way","Morrison Ave","Morrison Avenue","Morrison Crescent","Morrison Ln",
            "Morrison Rd","Morrison Road","Morrison St","Morristown Dr","Morristown Rd","Morro Creek St",
            "Morro Dr","Morro Hills Pl","Morro Rd","Morrow Aly","Morrow Avenue","Morrow Road","Morrow St",
            "Morse Ave","Morse Court","Morse Dr","Morse Ln","Morse Pl","Morse Rd","Morse St","Morse Street",
            "Morse Terrace","Morsetown Rd","Morsh Station Rd","Mort Ave","Mortensen Ct","Morter St","Mortimer Avenue",
            "Mortimer Court","Mortimer St","Mortimer Street","Morton Ave","Morton Avenue","Morton Dr",
            "Morton Ln","Morton Pl","Morton Rd","Morton St","Morton Street","Morven Pl","Mosco Street","Moselle St",
            "Mosely Ave","Moses Rd","Mosey Beach Rd","Mosher Dr","Mosher Rd","Mosher St","Mosher Street",
            "Moshier Rd","Mosholu Avenue","Mosley Rd","Mosquero Pl NW","Moss Canyon","Moss Cir","Moss Ct",
            "Moss Dr","Moss Lane","Moss Old Mill Rd","Moss Rd","Moss Ridge Ct","Moss Rock Dr","Moss Rock Rd NE",
            "Moss Run Rd","Moss View Ln","Mossbank Drive","Mosselle Pl","Mossford Court","Mossom Road",
            "Mosswood Cir","Mosswood Ct","Mosswood Dr","Mosswood Ter","Mossy Oak Ln","Mossy Oaks Ct",
            "Mossy Ridge Ln","Mossy River Rd","Mossy Rock Ct","Mostar Street","Mosure Ln","Mote Rd","Moten Cemetery Rd",
            "Mother Gaston Blvd","Mother of Pearl St","Mothers Park Road","Moton Ln","Motor Dr","Motor Way",
            "Mott Hill Rd","Mott Rd","Mott St","Motta Dr","Mottice Dr SE","Mouldy Rd","Moulson St","Moulton Avenue",
            "Moulton Cir","Moulton Rd","Moulton Street","Mounce Rd","Mound Ave","Mound City Rd","Mound Street",
            "Mounds Trl","Mount Acara Dr","Mount Ackerly Dr","Mount Airy Dr","Mount Alb Road","Mount Albert Road",
            "Mount Anthony Rd","Mount Ararat Dr","Mount Baldy Cir","Mount Baldy Ct","Mount Belvedere Blvd",
            "Mount Blackburn Ln","Mount Brodie Cir","Mount Brook Lane","Mount Burney Ct","Mount Carmel Avenue",
            "Mount Carmel Ln","Mount Carmel Rd","Mount Carmel St","Mount Cedar Ave","Mount Clement Ave",
            "Mount Crescent Trl","Mount Dashan Ln","Mount Doble Dr","Mount Dr","Mount Eaton Rd","Mount Ephraim Ave",
            "Mount Etna Dr","Mount Eve Rd","Mount Foraker Ct","Mount Foraker Dr","Mount Fuji Crescent",
            "Mount Glen Road","Mount Globe Street","Mount Grove Rd","Mount Hamilton Rd","Mount Hebron Rd",
            "Mount Hersey Rd","Mount Holly","Mount Holly Loop","Mount Hollywood Dr","Mount Hood Court",
            "Mount Hood Ct","Mount Hope Avenue","Mount Hope Rd","Mount Horeb Road","Mount Horeb Road",
            "Mount Jefferson Road","Mount Julian Viamede Road","Mount Kilimanjaro Ln","Mount Kisco Dr",
            "Mount Lassen Ln","Mount Lebanon Road","Mount Logan Ln","Mount McKinley Ct","Mount Misery Ln",
            "Mount Misery Rd","Mount Moriah Dr","Mount Morris Dam","Mount Nebo Rd","Mount Olive Dr",
            "Mount Olive Drive","Mount Olive Rd","Mount Overlook Ave","Mount Pinos Rd","Mount Pisgah Ave",
            "Mount Pisgah Rd","Mount Pl","Mount Pleasant Road","Mount Pleasant Ave","Mount Pleasant Dr",
            "Mount Pleasant Pike","Mount Pleasant Place","Mount Pleasant Rd","Mount Pleasant Road",
            "Mount Pleasant St","Mount Pleasant St NW","Mount Prospect Ave","Mount Prospect Rd",
            "Mount Provo Rd","Mount Rainier Dr","Mount Ranier Way","Mount Ranm Dr","Mount Rd118","Mount Road",
            "Mount Royal Avenue","Mount Rushmore Dr","Mount Salem Rd","Mount San Berdu Dr","Mount Scott Dr",
            "Mount Shannon Dr","Mount Sierra Pl","Mount Signal Ave","Mount St. Louis Road E","Mount Ste Road",
            "Mount Tobin Pl","Mount Tom Ski Road","Mount Umunhum Rd","Mount Union Ave","Mount Vernon Addition",
            "Mount Vernon Ave","Mount Vernon Avenue","Mount Vernon Ct","Mount Vernon Dr","Mount Vernon Rd",
            "Mount Vernon Sq","Mount Vernon St","Mount Vernon Street","Mount Victory Rd","Mount View Dr",
            "Mount View St","Mount Vista Blvd","Mount Way","Mount Wilcox Road","Mount Wilson Rd","Mount Woodson Rd",
            "Mount Zineche Rd","Mount Zion Rd","Mount Zion Way","Mountain","Mountain Ave","Mountain Avenue",
            "Mountain Bell Ct","Mountain Bell Rd","Mountain Blvd","Mountain Cir","Mountain Cir S",
            "Mountain Ct","Mountain Dew Dr","Mountain Dr","Mountain Farm Rd","Mountain Gap Rd","Mountain Hill Rd",
            "Mountain Hill Road","Mountain Home Ranch Rd","Mountain Home Rd","Mountain House Pky",
            "Mountain House Rd","Mountain Lake Rd","Mountain Lake Ter","Mountain Laurel Dr","Mountain Laurel Ln",
            "Mountain Laurels Dr","Mountain Lion Ln","Mountain Lion Rd","Mountain Ln","Mountain Meadow Way",
            "Mountain Meadows Cir","Mountain Misery Ln","Mountain Oak Way","Mountain Oaks Dr","Mountain Park Rd",
            "Mountain Point Ave","Mountain Quail Ct","Mountain Ranch Rd","Mountain Rd","Mountain Rd NE",
            "Mountain Ridge","Mountain Ridge Dr","Mountain Road","Mountain Spur","Mountain St","Mountain Street",
            "Mountain Top","Mountain Top Rd","Mountain Trl","Mountain Valley Trl","Mountain View",
            "Mountain View S","Mountain View W","Mountain View Ave","Mountain View Cir","Mountain View Ct",
            "Mountain View Cutoff","Mountain View Dr","Mountain View Dr NW","Mountain View Drive",
            "Mountain View No 2","Mountain View Pl","Mountain View Rd","Mountain View Road","Mountain View St",
            "Mountain View Trl","Mountain View Way","Mountain Vista Rd","Mountain Waters St","Mountain Way",
            "Mountainboro","Mountaindale Aly","Mountaindale Rd","Mountaineer Ct","Mountaingate Drive",
            "Mountainside Acc","Mountainside Ave","Mountainside Avenue","Mountainside Ct","Mountainview Ave",
            "Mountainview Dr","Mountainview Rd","Mountainview Road","Mountainview Street","Mountainwood Ct",
            "Mountainwood Ter","Mountaire Dr","Mountalan Avenue","Mountbatten Crescent","Mountfair Terrace",
            "Mountjoy Avenue","Mountland Drive","Mountview Place","Mourning Dove Cir","Mourning Dove Ln",
            "Mousam St","Moutain Cv","Movico Loop","Movico Loop Rd","Movico Loop Rd E","Mowat Avenue",
            "Mowhawk Ln","Mowry Ave","Mowry St","Moxter Court","Moyer Ave","Moyer Heights Dr","Moyer Ln",
            "Moyer Road","Mozart Avenue","Mozart Ln","Msg R Miller St","Mt Baldy Rd","Mt Bethel Rd","Mt Carmel Rd",
            "Mt Chocorua Dr","Mt Crescent Trl","Mt Gap Rd","Mt Hebron Rd","Mt Herman Rd","Mt Hope Rd",
            "Mt Ida Rd","Mt Joy Rd","Mt Miguel Rd","Mt Nebo Ave","Mt Nebo Rd","Mt Olive Church Rd","Mt Olivett NE Rd",
            "Mt Pleasant Dr","Mt Pleasant Lane","Mt Pleasant Rd","Mt Pleasant St","Mt Prospect Rd",
            "Mt Rainier Dr","Mt Read Blvd","Mt Side Rd","Mt Tabor Rd","Mt Vernon Cir","Mt Vernon Rd",
            "Mt Vernon St","Mt View Dr","Mt View Rd","Mt View Ter","Mt William Pond","Mt Zineche Rd",
            "Mt Zion Rd","Mt. Auburn Place","Mt. Umunhum Road","Mtn Laurel Cir","Mtn Swallow Ct","Muchivo Trl",
            "Muck Rd","Muckey Rd","Mud Creek Rd","Mud Ln","Mud Pond Ct","Mud Pond Rd","Mud Rd","Mud Run Rd",
            "Mudcat Road","Muddrd","Muddy Brook Road","Mudgett Dr","Mudie Ln","Mudjekeewis Trl","Mueller St",
            "Muerdale St","Muhenberg Ave","Muinos St","Muir Ave","Muir Canyon Rd","Muir Dr","Muir Drive",
            "Muir St","Muir Street","Muirbank Boulevard","Muirfield Ct","Muirfield Dr","Muirfield Ln",
            "Muirhead Road","Muirhead St","Muirkirk Ln","Muirlands Drive","Muirside Road","Mukai Ct",
            "Mulanax Dr","Mulberry Ave","Mulberry Cir","Mulberry Ct","Mulberry Dr","Mulberry Fork","Mulberry Lane",
            "Mulberry Ln","Mulberry St","Mulberry Street","Mulcahy Ct","Mulcahy Lane","Mulders Ln","Muldoon Ave",
            "Mule Bridge Rd","Mule Canyon","Mule Deer Dr","Mule Deer Ln","Mule Ears Dr","Mule Ln","Mule Skinner Rd",
            "Mulford Ave","Mulford Ct","Mulford Dr","Mulford Ln","Mulford Rd","Mulham Place","Mulheron St",
            "Mulholland Dr","Mulholland Hwy","Mulholland Way","Mullaney Ave NW","Mullein Ct","Mullen",
            "Mullen Drive","Mullen Rd","Mullen St","Muller Avenue","Muller Dr","Muller Rd","Mullet St","Mullett Dr",
            "Mullica Hill Road","Mulligan Dr","Mulliken Way","Mullins Dr","Mullins Rd","Mullins St","Mullray Ct",
            "Mullshire Ln","Mulock Drive","Mulroony Cir","Mulvaney Dr","Mulvey Street","Mulvoy Taylor Rd",
            "Muma Ln","Mumby Road","Mumford Dr","Mump Creek Rd","Mums Ct","Munce Ct","Munce Rd","Mund Rd","Mundo Rd NE",
            "Mundry Rd","Mundy Ln","Munger Avenue","Munger Cir","Munger Ct","Munger Rd","Munich St","Municipal Dr",
            "Municipal Ln","Municipal Plz","Municipal Rd","Munion Field Rd","Munn Cir","Munn St","Munro Dr",
            "Munro Pl","Munro Rd","Munro Street","Munroe Dr","Munroe St","Munroe Street","Munrow Row","Munson Crescent",
            "Munson Dr","Munson Rd","Munson St","Munson Street","Munsonhurst Rd","Munton Cir","Muntz","Muntz Ln",
            "Mural Rd","Murdoch Ave","Murdoch Road","Murdock Ave","Murdock Rd","Murdock Street","Murfee St",
            "Muriel Ave","Muriel Avenue","Muriel Bennett Way","Muriel Ln","Muriel Pl","Murietta Ave",
            "Murietta Ln","Murison Boulevard","Murl Dr","Muro Way","Muroc Lake Dr","Murphree Valley Rd",
            "Murphy Ave","Murphy Ct","Murphy Dr","Murphy Ln","Murphy Rd","Murphy Road","Murphy St","Murphy Street",
            "Murphys Lane","Murphys Rd","Murray Ave","Murray Ct","Murray Dr","Murray Drive","Murray Farm Lane",
            "Murray Glen Drive","Murray Hill Dr","Murray Hill Pky","Murray Hill Rd","Murray Ln","Murray Oaks Dr",
            "Murray Pl","Murray Pond Rd","Murray Rd","Murray Ridge Rd","Murray Road","Murray Ross Parkway",
            "Murray St","Murray Street","Murraydale Ln","Murrie Street","Murrieta Ave","Murry","Murry St",
            "Murta St","Murtha Dr","Muscari Way","Muscat Ave","Muscatel Rd","Muscatine St","Muscato Ct",
            "Muscoda Rd","Muscovitz Ave","Muscovy Ln","Museum Ave","Museum Drive","Museum Village Rd",
            "Mushatt Ln","Music Mountain Cir","Music Rd","Musick Honor Farm Rd","Muskegat Circle",
            "Muskegon Ave NW","Musket Ave","Musket Dr","Muskogean Trl","Muskoka B Road","Muskoka Street",
            "Muskrat Drive","Muskrat Rd","Muskrat Trail","Musky Point Rd","Mussari Court","Mussell St",
            "Musso Rd","Mustang Ct","Mustang Dr","Mustang Ln","Mustang Rd","Mustang Road","Mustang St","Mustard Street",
            "Muster Ave","Mustic Way","Mutau Flat Rd","Mutton Hill Rd","Mutton Lane","Muzzey Rd","Muzzy St",
            "Mwd Rd","My Way","Mychal Ln","Myer Ln","Myer Rd","Myer's Cave Road","Myers Ave","Myers Ln","Myers Pl",
            "Myers Rd","Myers Rd NE","Myers St","Myers St NW","Myers Street","Myers Way","Mygina Ave","Myles Standish Road",
            "Mylrea St","Mynatt Dr","Myopia Ln","Myra Dr","Myra Pl","Myra St","Myricks Street","Myrna Pl","Myrna Rd",
            "Myron Ave","Myron Ct","Myron St","Myrtle Aly","Myrtle Ave","Myrtle Avenue","Myrtle Court","Myrtle Ct",
            "Myrtle Dr","Myrtle Ln","Myrtle St","Myrtle Street","Myrtle Ter","Myrtlewood Ave","Mystery Point Rd",
            "Mystic Avenue","Mystic Canyon Ct","Mystic Cir","Mystic Dance St","Mystic Desert Ave",
            "Mystic Lake Rd","Mystic Ln","Mystic Ridge Ct","Mystic St","Mystic View Dr","Myvalli Dr",
            "N 1000 E","N 102nd Ln","N 102nd St","N 103rd Pl","N 104th Dr","N 106th Ave","N 1070 W","N 107th Way",
            "N 108th Pl","N 109th Ave","N 109th Way","N 10th Ave","N 10th St","N 110th Ave","N 111th Ave",
            "N 111th St","N 113th Ln","N 114th Way","N 117th St","N 117th Way","N 11th St","N 11th Way",
            "N 123rd Way","N 124th Dr","N 125th Dr","N 126th Ave","N 127 Ave","N 12th Ave","N 12th St","N 12th Way",
            "N 131st Pl","N 139th Ave","N 13th St","N 149th Ave","N 14th Ave","N 14th St","N 150th Ln","N 155th Ave",
            "N 155th Ln","N 15th St","N 161st Avenue","N 168th Ave","N 16th St","N 174th St","N 17th Pl",
            "N 17th St","N 180th Ln","N 183rd Ave","N 185th Ave","N 18th Pl","N 18th St","N 19th Dr","N 19th St",
            "N 1st St","N 1st St W","N 1st Street","N 200 E","N 200th Ave","N 20th St","N 21st St","N 22nd Ave",
            "N 22nd Pl","N 22nd St","N 23rd","N 23rd Cir","N 23rd St","N 245 W","N 24th Ln","N 24th St","N 253rd Ave",
            "N 25th Ave","N 25th Dr","N 25th St","N 26th Rd","N 26th St","N 27th Dr","N 27th St","N 28th Pl",
            "N 28th St","N 29th Dr","N 29th St","N 2nd Ave","N 2nd Avenue","N 2nd St","N 3003","N 30th Dr",
            "N 30th Pl","N 30th St","N 31st Dr","N 31st Pl","N 31st St","N 32nd Ave","N 32nd Dr","N 32nd St",
            "N 33rd Dr","N 33rd Pl","N 33rd St","N 34th Ave","N 34th Dr","N 34th Pl","N 34th St","N 350 W",
            "N 35th Dr","N 35th Pl","N 35th St","N 36","N 367","N 36th Ave","N 36th Dr","N 36th St","N 37th Dr",
            "N 37th Pl","N 37th St","N 382nd Ave","N 38th Ave","N 38th Dr","N 39 3/4 Rd","N 39th Pl","N 39th St",
            "N 3rd Ave","N 3rd St","N 3rd West","N 400th Ave","N 4050","N 4062","N 4063","N 4065","N 4087","N 40th Ave",
            "N 40th Ct","N 40th Ln","N 40th Pl","N 40th St","N 41st Ave","N 41st Dr","N 41st Pl","N 41st St",
            "N 423rd Ave","N 42nd Ave","N 42nd Dr","N 42nd St","N 43rd Dr","N 43rd Pl","N 43rd St","N 44th Dr",
            "N 44th St","N 45th Ave","N 45th Cir","N 45th Dr","N 45th Pl","N 45th St","N 46th Ave","N 46th Cir",
            "N 46th Dr","N 47th St","N 48th Dr","N 48th Ln","N 48th St","N 48th Way","N 49th Ave","N 49th Pl",
            "N 49th St","N 4th Ave","N 4th St","N 50th Cir","N 50th Ln","N 52nd Ave","N 52nd St","N 53rd St",
            "N 54th Ct","N 54th Ln","N 54th St","N 55th Dr","N 55th Pl","N 55th St","N 56th Ave","N 59th Dr",
            "N 59th Pl","N 59th St","N 59th Way","N 5th Ave","N 5th Pl","N 5th St","N 61st Ave","N 62nd E St",
            "N 62nd Way","N 63rd Dr","N 63rd St","N 64th Ave","N 650 W","N 65th Ave","N 66th Dr","N 66th St",
            "N 67th Dr","N 67th Pl","N 68th Ave","N 68th Dr","N 68th Pl","N 68th St","N 69th Ave","N 69th Dr",
            "N 69th Pl","N 6th Ave","N 6th St","N 7037","N 70th Ave","N 71st Ave","N 71st Dr","N 71st Pl","N 725 E",
            "N 73rd St","N 74th Ave","N 74th Way","N 75th Pl","N 75th St","N 76th St","N 77th Ave","N 77th Dr",
            "N 78th Ave","N 78th Pl","N 78th St","N 79th Ave","N 79th Dr","N 79th Pl","N 7th","N 7th Ave","N 7th St",
            "N 800 W","N 80th Pl","N 80th Way","N 81st Ave","N 81st Ln","N 81st St","N 82nd Ave","N 82nd St",
            "N 83rd Dr","N 83rd Ln","N 83rd Pl","N 83rd St","N 84th Ave","N 85th St","N 85th Way","N 86th Ave",
            "N 86th Pl","N 870 W","N 87th Ave","N 87th Dr","N 87th St","N 88th St","N 89th Pl","N 89th Way",
            "N 8th","N 8th Ave","N 8th St","N 92nd Dr","N 93rd St","N 94th Ave","N 94th Pl","N 94th St","N 95th Dr",
            "N 95th St","N 96th Pl","N 98th Ave","N 98th St","N 99th Avenue","N 99th Dr","N 9th Ave","N 9th St",
            "N A St","N Abby St","N Abernathy St","N Abington Rd","N Acacia Rd","N Acacia St","N Adams Ave",
            "N Adams St","N Addition Rd","N Adelade St","N Adler Ave","N Aero-Park Ct","N Ahwanee Ter",
            "N Airmont Road","N Alba","N Alden St","N Alder Dr","N Alder St","N Alice Ave","N Alice Ct",
            "N Alice St","N Allen Ave","N Alma Dr","N Almond Cir","N Alta Way","N American St","N Americas Ave",
            "N Anchor St","N Andrew Dr","N Angeline Cir","N Anna Strong Cir","N Annapolis Ave","N Annies Ln",
            "N Answick Cir NW","N Antioch Ave","N Arboleda Rd","N Archie Ave","N Arkansas Ave","N Arkansas St",
            "N Arkona Ave","N Arlington Ave","N Arlington Dr","N Armada Ave","N Arroya Cir","N Arroyo Ln",
            "N Arroyo Pl","N Arthur Ave","N Arundel Dr","N Ash St","N Ashby Ave","N Asher Rd","N Ashton Pl",
            "N Ashurst Ct","N Aspen Dr","N Athletic St","N Atlantic Ave","N Atlantic Blvd","N Atmore Ave",
            "N Atwood","N Augusta St","N Aurora St","N Ausable Tr","N Austin Ave","N Austin St","N Autumn St",
            "N Ave E","N Avenida Arbodela","N Avenida Calma","N Avenida Refugio","N Avenida of the Stars",
            "N Avenue C","N Avenue D","N Avery St","N Avon Ct","N Azalea Ave","N B St","N B Tinn St","N Bailey Dr",
            "N Bailey St","N Baker St","N Balch St","N Bald Mountain Rd","N Ballou St","N Bank Ln","N Bankle Ct",
            "N Banner Way","N Barker St","N Barkerville Rd","N Barkley St","N Barnard St","N Barnes St",
            "N Barton Ave","N Bass Lake Rd","N Basswood Cir","N Battlefield Ct","N Bay Ct","N Bayard St",
            "N Bayou Dr","N Bayou Rd","N Beach Dr","N Beck Rd","N Beechwood St","N Belardo Rd","N Bellevue Ave",
            "N Bellflower Blvd","N Belmont Dr","N Bend Dr","N Berendo St","N Bergen Mills Rd","N Bergin Ln",
            "N Berkeley Ave","N Berkshire Dr","N Bern St","N Bethel Ave","N Bina St","N Birch Dr","N Birchwood Ave",
            "N Black River Rd","N Blackhawk Ln","N Blackstone St","N Blagg Rd","N Blocker Ave","N Blosser Rd",
            "N Blue Ridge Dr","N Blue Sage Dr","N Bobcat Ln","N Bodine St","N Bolivar Ct","N Bollinger Rd",
            "N Bolton Rd","N Bond Rd","N Bonow Dr","N Bossett Rd","N Boston Ave","N Boston Pl","N Bothwell Ave",
            "N Boyd Ave","N Bracken Dr","N Bradbury","N Bradley Pl","N Brae Ct","N Branch Dr","N Branch Rd",
            "N Brazos Dr","N Brent St","N Brewery Hill Dr","N Brewster Rd","N Briarwood Dr","N Bridle Trl",
            "N Broad St","N Broadway","N Brook Ave","N Brook St","N Brooklyn St","N Brooks Ave","N Brookside Ct",
            "N Brophy Cir","N Brownstone Dr","N Brundidge St","N Brush St","N Bryant Ave","N Buffalo Run Dr",
            "N Bull Run St","N Bungalow Ln","N Buntin Ave","N Burbank Dr","N Burgher Ave","N Burk St",
            "N Burtis Ave","N Burton St","N Bush Ave","N Busti St","N C","N C R 1670","N C R 1740","N C R 3300",
            "N C St","N Cactus Way","N Cadwallader St","N Cairngorm Rd","N Calaveras St","N California Ave",
            "N California St","N Calle Marcus","N Calle Santiago","N Calle el Trigo","N Calvin St",
            "N Camellia Ave","N Cameo Dr","N Camino Cantil","N Camino Cordon","N Camino del Grillo",
            "N Campus Ave","N Canal Rd","N Canary Dr","N Capitol Ave","N Carland Rd","N Carlisle St",
            "N Carnation Ln","N Carpenter Rd","N Carriage Hills Dr","N Carrie St","N Carroll Dr","N Carroll St",
            "N Casa Blanca Dr","N Caswell Ave","N Cave Creek Rd","N Cayuga St","N Central","N Central Ave",
            "N Central St","N Centre City Pky","N Cesar E Chavez Dr","N Chadwick St","N Chance Ave",
            "N Channing Ave","N Chaphagen Dr","N Charles Ave","N Charlotte Ave","N Chelsea Cir","N Chemung St",
            "N Cherokee Ln","N Cherokee Tr","N Cherry Beach Ct","N Cherry Ln","N Chester","N Chester Ave",
            "N Chester Pky","N Chesterfield Dr","N Chestnut Ave","N Chestnut St","N Chicago Ave","N Chieftain St",
            "N Church Ln","N Church Pl","N Church St","N Cielo Dr","N Cinco Millas Rd","N Cindy Ave",
            "N Clancy","N Claremont Ave","N Clark Cir","N Clark St","N Clearview Ave","N Cleveland St",
            "N Cliffwood Ave","N Clifton St","N Clinton Ave","N Clinton St","N Cloud Dr","N Cloverdale Dr",
            "N Coast Hwy","N Cocopas Rd","N Coldwater Rd","N Colfax Ave","N Coliseum Dr","N College Ave",
            "N College Rd","N College St","N Collinson Ave","N Colonial Ave","N Colonial Dr","N Columbia Ave",
            "N Columbine Ln","N Commerce St","N Conchas Dr","N Concourse Dr","N Congress Ave","N Conifer Rd",
            "N Connecticut Ave","N Conner St","N Constance Dr","N Contessa Ave","N Conyer St","N Cook Ln",
            "N Cooks Bridge Rd","N Copia St","N Copperbelle Pl","N Corbin St","N Corley Rd","N Cornelia",
            "N Corona Ave","N Corte Canyon del Salto","N Cottonwood","N Country Club Dr","N Country Dr",
            "N Country Trl","N County Line Rd","N County Road 237","N County Road 265","N County Road 275",
            "N County Road 309","N County Road 335","N County Road 343","N County Road 359","N County Road 361",
            "N County Road 488","N County Road 503","N County Road 919","N Court St","N Covelo Ave",
            "N Coyote Ln","N Cracked Pot Rd","N Crawford St","N Creek Dr","N Crescent Dr","N Crescent St",
            "N Crest Dr","N Crest Pl","N Crestridge Rd","N Crestview Ave","N Crimea St","N Crimson Sunset Ln",
            "N Criss St","N Crockett Rd","N Crockett St","N Cromwell Pl","N Crown St","N Crystal Ln",
            "N Crystal St","N Ct","N Curry St","N Curtis Pl","N Custer Rd","N Cypress Ave","N Cypress St",
            "N Daisy Pl","N Daley St","N Dana Foothill Rd","N Dante Ave","N Darr Rd","N Dartmouth Ave",
            "N Datura Rd","N Davidson Rd","N Davis Ave","N Davis Dr","N Davis St","N Dawn Ridge Way",
            "N Dean St","N Dearing Ave","N Deer Run","N Delaware Ave","N Delbert Ave","N Delhi St","N Delsea Dr",
            "N Delwood Dr","N Demarest Ave","N Deming Rd","N Denair St","N Derby Rd","N Desert Blvd",
            "N Desert Sky Pl","N Desert View Dr","N Detroit Ave","N Dewberry","N Dewey Ave","N Diamond Ave",
            "N Diamond Hills Ln","N Diamond Pl","N Diamond Point Blvd","N Diamond Rd","N Diamondback Ct",
            "N Diana Ave","N Diana St","N Dickran Dr","N Dillon St","N Dittmar Dr","N Divernon Ave","N Dobbins Dr",
            "N Dogwood Dr","N Donna Dr","N Dorsey Ln","N Dos Cabezas Rd","N Double Diamond Pl","N Doughty Ave",
            "N Douglas Ave","N Douglas St","N Dove Rd","N Dover St","N Downing Pl","N Dragoon St","N Dresden Rd",
            "N Drexel Cir","N Dudleyville Rd","N Duke Ave","N Duncannon St","N Durant Ave","N Duskview Dr",
            "N E St","N Eagle Village Rd","N Eaglecrest Dr","N East Ave","N East Blvd","N East River Rd",
            "N East St","N Eastwood Cir","N Edgemere Dr","N Edison St","N Edison Way","N Edith Pl","N Effie St",
            "N Elgin Ave","N Ellis St","N Elly Mae Dr","N Elm St","N Elmwood Ave","N Elmwood Cir","N Emerson Ave",
            "N Emperor Dr","N Equestrian Dr","N Erie Ave","N Erten St","N Esperanza St","N Estrella Ln",
            "N Etting St","N Eucalyptus Ave","N Euclid Ave","N Everett Ave","N Evergreen Ave","N Everhard Ct",
            "N Express St","N Ezie Ave","N Ezra St","N Faded Love Ln","N Fair Ave","N Fairfield Dr","N Fairhill St",
            "N Fairview Ave","N Farm-to-Market Road Rd 1506A","N Farr St","N Farris Ave","N Farson St",
            "N Fashion Show","N Fasley Ave","N Federal St","N Ferger Ave","N Fermi Ave","N Fern Dr","N Ferris Rd",
            "N Fickett Ave","N Field Ct","N Fiesta Dr","N Filbert Ave","N Fine Ave","N Fir Ave","N Fir Fork",
            "N Firelane Rd","N Fisher Ave","N Fisher Pl","N Fitzgerald Ln","N Flora Ave","N Florida St",
            "N Flowers Mill Rd","N Floyd Dr","N Flyer Ave","N Forecastle Dr","N Forest Ave","N Forkner Ave",
            "N Forward Rd","N Fox Cub Hollow","N Fox Rd","N Frankford Ave","N Franklin St","N Franklin Tpke",
            "N Frankwood Ave","N Freeman Ave","N Fremming Ave","N French Dr","N Fresno St","N Front St",
            "N Fruitport Rd","N Fulgham Ct","N Fuller Ave","N Fulton St","N G St","N Gaff St","N Gaiche Rd",
            "N Galahad Pl","N Galaxy Rd","N Gale St","N Garden Ave","N Gateway Dr","N Gatewood Pl","N Gaviota Ave",
            "N Gem Trl","N Gemstone Rd","N Gila Ln","N Gilbert St","N Gladeview Dr","N Gladiola Rd","N Glaspie",
            "N Glen Rd","N Glenn Ave","N Glenwood Ave","N Godbold Trl","N Gold St","N Golden Ave","N Golden State Blvd",
            "N Goodhope Ave","N Gordon St","N Goshen Rd","N Governor Printz Blvd","N Grama St","N Granada Ave",
            "N Granada Rd","N Grand Ave","N Grandbrook Cir SE","N Grant Ave","N Grapevine Ln","N Gratz St",
            "N Gray St","N Green St","N Greenbush Rd","N Greenfield Dr","N Greenhouse Way","N Greenvalley Ave",
            "N Greenwich Ave","N Greenwood Ave","N Greenwood Dr","N Gregory Ave","N Greycloud Ln",
            "N Gross St","N Grove St","N Gutierrez St","N Gwen Dr","N H State Forest Rd","N Haddon Ave",
            "N Hale Ave","N Hall Ave","N Hamilton St","N Hampton Rd","N Hampton St","N Haney Ave","N Hanson Ave",
            "N Harbour Way","N Harrison St","N Harvard Ave","N Harvard St","N Haverford Ave","N Haviland Ave",
            "N Hayden St","N Haymond Ave","N Hayston Ave","N Helena St","N Hemberger St","N Hendricks St",
            "N Henrahan St","N Herbert Ave","N Hereford","N Hibbert","N Hickory St","N High Ave","N High Desert Cir",
            "N High St","N Highland Ave","N Highland Rd","N Highland St","N Highton Hills Dr","N Hill Rd",
            "N Hillbrook Dr","N Hillcrest Path","N Hillside Ave","N Hinman Ave","N Hobart Blvd","N Hobart St",
            "N Hollow Ave","N Holly Ave","N Holly Dr","N Holly St","N Hollywood St","N Holt Ave","N Home St",
            "N Homesite Ct","N Homestead Pl","N Honeysuckle Ln","N Hook Rd","N Hope Ave","N Hope St",
            "N Horseshoe Bend Rd","N Horton St","N Houston Ave","N Houston St","N Howard Ave","N Howard St",
            "N Howell St","N Hualapai Way","N Hughes Pl","N Hummingbird Ln","N Hurd St","N Hyer Rd","N I St",
            "N Ibis Pl","N Indiana Ave","N Ingram St","N Ironwood Dr","N Ironwood Ln","N Island Rd","N Ithaca Ave",
            "N Ivanhoe Ave","N J St","N J State Park Walking Trl","N Jackson Ave","N Jackson Hwy",
            "N Jackson St","N James St","N Jasmine Ave","N Jebb Rd","N Jefferson Ave","N Jefferson St",
            "N Jerry Ln","N Jesse St","N Jicarilla Rd","N Joaquin St","N John Richmond Rd","N Johns Ave",
            "N Johnson Blvd","N Johnson Rd","N Joplin Cir","N Joseph Ave","N Judson St","N Kachina","N Kachina Cir",
            "N Kalmia St","N Kathleen Ln","N Katy Ln","N Kavanagh Ave","N Kaweah Rd","N Kaweah River Dr",
            "N Keith St","N Kelly Dr","N Kelly Rd","N Kenneth Rd","N Kenter fire road","N Kessing Pl",
            "N Ketchumville Rd","N Keystone Ave","N Keystone Ct","N Keystone St","N Kimball Way","N Kimberlee Way",
            "N King St","N Kingsgate Dr","N Kingston St","N Kirby St","N Kirk Rd","N Kistler St","N Kitchen St",
            "N Kittyhawk Ave","N Kokopelli Trl","N Lac Jac Ave","N Lacey Lake Rd","N Lake Blvd","N Lake Knoll Dr",
            "N Lake Ln","N Lake Shore Dr","N Lake St","N Lake Trl","N Lakeshore Point","N Lakeview Ct",
            "N Lakeview Dr","N Lambert St","N Lambeth Ct","N Lancelot Ave","N Landen St","N Lane Ave",
            "N Lanier Ave","N Lapeer Rd","N Las Flores Dr","N Lassie","N Latrobe Pl","N Laurel Dr","N Lawrence Sq",
            "N Lawrence St","N Lea Ave","N Ledford St","N Lee Creek Rd","N Lee St","N Lee Trevino Dr",
            "N Leggett St","N Legion Dr","N Leithgow St","N Leland Cir","N Lenhome Dr","N Lennox Rd",
            "N Leonard Ave","N Leroy Rd","N Leslie","N Lester Dr","N Liberty Drive","N Lihu St","N Lime Ave",
            "N Lincoln Ave","N Lincoln Hill Dr","N Lincoln St","N Linda St","N Lindale St","N Lindenwood St",
            "N Lindley Dr","N Lindstrom Pl","N Line Dr","N Lisbon Ave","N Little Owl Ln","N Little Rock Ave",
            "N Locan Ave","N Locust Lake Rd","N Locust St","N Lodi Ave","N Logan St","N Long Beach Blvd",
            "N Longfellow Ave","N Longlook Rd","N Longpoint Ln","N Loop Rd","N Los Alamos Rd","N Los Carneros Rd",
            "N Los Coyotes Diagonal","N Lost Lake Ln","N Louis Ln","N Louise Ave","N Lovell Landing Rd",
            "N Lowell Rd","N Lowell St","N Lower Valley Rd","N Lynn Blvd","N Lynn St","N Lynn's Aly",
            "N M 37/10 Mile Turnaround","N Mackinac Ave","N Mackville Rd","N Macy St","N Madden St",
            "N Maddox Ave","N Madison Ave","N Madison St","N Magic Way","N Magrudder Rd","N Main St",
            "N Main Street","N Maine Ave","N Maine St","N Malachite Cir","N Manila Ave","N Manitou Trl",
            "N Manlius Rd","N Manning Blvd","N Mansfield Ave","N Maple Ave","N Maple St","N Mapleton Dr",
            "N Marginal Hwy","N Mariposa Ave","N Mariposa St","N Mark Dr","N Market St","N Mars Dr","N Martha Ave",
            "N Martin Luther King Dr; United States Highway 49","N Martin St","N Martinez Lake Rd",
            "N Martinez Ln","N Marty Ave","N Marvine St","N Maryland Pky","N Maryland St","N Massachusetts Ave",
            "N Matthew Ave","N Matu","N Matus Ave","N Maysville Ave","N McAleb Ave","N McCadden Pl","N McCall Ave",
            "N McKinley Ave","N McPherson St","N McVay Rd","N Meadow Dr","N Meadow Ln","N Meadow St",
            "N Meadow Street","N Meadowbrook Dr","N Meadowbrook Ln","N Meadowbrook Pky","N Meadowlark St",
            "N Megan St","N Meigs Creek Rd NE","N Melinda Dr","N Melody Ln","N Melody St","N Mercer St",
            "N Meridian Ave","N Mesa St","N Mesilla St","N Mesquite Oasis Rd","N Meyler St","N Miami Ave",
            "N Michael Rd","N Michael St","N Michelle Ave","N Michigan Ave","N Michigan Rd","N Midland St",
            "N Miles Rd","N Mill Ave","N Millbrook Ave","N Millwheel Pl","N Mindy Pl","N Minnisink Ave",
            "N Minot","N Mirage St","N Miranda St","N Mission Cove Ln","N Mississippi Ave","N Missouri Ave",
            "N Missouti Ave","N Mitchell Creek Dr","N Mitchell Ln","N Mogollon St","N Mohave St","N Mohawk St",
            "N Monroe Ave","N Montana Ave","N Monte Carlo Ct","N Monterey Cir","N Monterey St","N Montgomery Ave",
            "N Montgomery Ct","N Montgomery St","N Moorpark Rd","N Morningside Dr","N Morris St","N Mosley Rd",
            "N Moss Flat Rd","N Moss St","N Mount Airy Ave","N Mountain Shadow Dr","N Mountain View Dr",
            "N Mountainview Dr","N Mozart Ct","N Mt Zion Rd","N Mudd Rd","N Munn Ave","N Murphy Ave",
            "N Murray St","N Murry St","N Myrtle St","N Nagle St","N Nantucket Ave","N Napa St","N Nassau Dr",
            "N Natrona St","N Neeley Rd","N Neighbours Blvd","N Nevada Way","N New Haven Ave","N Newton Dr",
            "N Nickel Plate St","N Norfolk St","N Norman St","N North Aire Ave","N North Carolina Ave",
            "N Northampton St","N Norton Ave","N Norwood St","N O Keefe St","N O St","N Oak St","N Oakhill Cir",
            "N Ocean Ave","N Ocotilla Ln","N Odin Dr","N Ohio Blvd","N Ok St","N Old Coyote Rd","N Oleander Ct",
            "N Olen Ct","N Olive Ave","N Olive St","N Omaha Cir","N Omega Pl","N Onyx Dr","N Oracle Rd",
            "N Orange Ave","N Orange Blossom Ln","N Orange St","N Orangethorpe Park","N Oraton Pky",
            "N Orchard Pl","N Orchard St","N Ore St","N Oriole Pl","N Orleans St","N Osage St","N Osborn Ave",
            "N Osito St","N Otto Rd","N Ovid Rd","N Oxford Ct","N Oxford Oval","N Pacific Ave","N Palethorp St",
            "N Palm St","N Palmers Rd","N Palo Duro Rd","N Palo Verde Blvd","N Palomar Ave","N Pami Cir",
            "N Pamplico Drive","N Panorama Dr","N Paradise View Ln","N Paris Ave","N Park Ave","N Park Dr",
            "N Park Ln","N Park Pl","N Park St","N Parker Ave","N Parker Rd","N Parkridge","N Parkway Dr",
            "N Parrish Dr","N Partridge Dr","N Partridge Meadows Ct","N Pasadena Ave","N Pascack Rd",
            "N Paseo Acacia","N Paseo de Los Rancheros","N Patricia Dr","N Patrick Rd","N Patsy St",
            "N Patton Ave","N Paxon St","N Peach St","N Pecan Dr","N Pellegrino Dr","N Pemberton Rd",
            "N Pembroke Ln","N Peninsula Dr","N Pennock St","N Pennsylvania Rd","N Penrod Rd","N Peralta Ct",
            "N Percy St","N Perimeter Rd","N Perris St","N Perry St","N Perugia Way","N Pettis Way","N Phillip Ave",
            "N Phillips St","N Pier","N Pike Rd","N Pine","N Pine Canyon Dr","N Pine Island Dr","N Pine St",
            "N Pine Ter","N Pinon Dr","N Pinon Rd","N Pioneer","N Pioneer Rd","N Placita Agave","N Placita Esquina",
            "N Platina","N Plaza Dr","N Plaza de Lirios","N Pleasant Ave","N Plymouth Ct","N Pommel Dr",
            "N Pomona Ave","N Pond Dr","N Pond Rd","N Pontotac Rd","N Pope St","N Poplar Ave","N Poplar St",
            "N Portage St","N Possum Ridge Ln","N Post Rd","N Pownal Rd","N Prairie St","N Preakness Ct",
            "N Price Ave","N Price Rd NW","N Primrose Point","N Princeton Ave","N Princeton St","N Progressive Rd",
            "N Prospect St","N Pueblo Ave","N Quarry Boundary Rd","N Railroad Ave","N Railroad St",
            "N Railyard Ct","N Ramapo Ln","N Ranchito St","N Ranchview Dr","N Raven Ln","N Raymond Ave",
            "N Recreation Ave","N Rector Way","N Redfield St","N Reed Ave","N Reed Rd","N Reese Ave",
            "N Reese St","N Remington Ave","N Rena St","N Revere","N Rhea Pl","N Ricardo","N Ricardo Cir",
            "N Rice St","N Richards Rd","N Richmond Ave","N Ricke Ln","N Ridge Rd","N Ridgeview Ct","N Ridgeway Rd",
            "N Ridgewood Pl","N Ridley Creek Rd","N Riley St","N Ringo St","N Rio Mineral","N Rio Vista",
            "N Rio Vista Ave","N Rita Ct","N River St","N Rivers Edge Dr","N Riverside Ave","N Riverview Ave",
            "N Riverview Blvd","N Riviere du Chien Loop","N Road 161","N Robbins St","N Robert Daru Dr",
            "N Roberts Pl","N Robison Rd","N Roeben Dr","N Rogers St","N Rolling Acres Rd","N Rolling Stone Lake Rd",
            "N Romig Ln","N Roosevelt Blvd","N Rose Ave","N Rose Ln","N Rose Quartz Dr","N Rose St","N Rosecrest Cir",
            "N Rowell Ave","N Royal Ascot Dr","N Rudy Rd","N Run Rd","N Ruska St","N S St","N Saddleback Ave",
            "N Safflower Ln","N Safford Ave","N Saginaw Road","N Saginaw St","N Sagman St","N Saint Louis St",
            "N Saint Paul Ct","N Salisbury St","N Salt Creek Rd","N San Diego Ave","N San Jacinto St",
            "N San Joaquin Dr","N San Miguel Ave","N San Pedro Ave","N San Pedro River Rd","N San Rafael Ave",
            "N San Simon Dr","N San Souci Dr","N Sandal Cir","N Sanders Rd","N Sanderson Ave","N Santa Cruz St",
            "N Santa Fe Ave","N Santa Rosa Ave","N Saturmino Dr","N Saybrook Dr","N Schenley Ave",
            "N School","N School Dr","N School St","N Schutz Dr","N Scottsville Rd","N Sedro St","N Seminole St",
            "N Senate St","N Sequoia Dr","N Service Dr","N Seventh Heaven Ln","N Seville Dr","N Shadow Creek Wy",
            "N Shannon Rd","N Sharon Ave","N Shelly Ave","N Shepherd Ct","N Shepherd St","N Sherman Ave",
            "N Shiloh Dr","N Shirk Rd","N Shore Dr","N Shore Point","N Shore Rd","N Shore View Dr","N Sierra Ave",
            "N Sierra Vista Ave","N Sierra Vista Dr","N Sierra Vista St","N Signal Hill Rd","N Silver Fox Dr",
            "N Silver Sands Dr","N Simmons Ave","N Simmons Rd","N Sitgreaves St","N Six Lakes Rd",
            "N Skaneateles St","N Skyview Way","N Slauson Cir","N Sloan Ln","N Sloan St","N Smedley St",
            "N Smith St","N Smoke Tree Ave","N Snow Cap Way","N Sol Ct","N Solano","N Somerton Ave","N South Bend Blvd",
            "N South St","N Spalding Ave","N Spangler St","N Spencer","N Sperry Dr","N Spire Ct","N Spring",
            "N Spring St","N Spruce St","N St","N St O St Aly","N Stainglass Ln","N Stanford Ave","N Stanton Ave",
            "N Star Ave","N Star City Rd","N Star Dr","N Star Rd","N State Ave","N State Highway 41",
            "N State Highway 89","N State St","N Stevens St","N Stewart St","N Stocktons Aly","N Stonehill Rd",
            "N Stoneridge St","N Stoughton St","N Straight St","N Street","N Street North","N Street Road",
            "N Stumpy Rd","N Stuyvesant St","N Sullinger Ave","N Sullivan Rd","N Summer Night St",
            "N Summit Dr","N Summit Rd","N Sunnyside Ave","N Sunset Dr","N Suntuoso Ct","N Surfside Cir",
            "N Susie Ln","N Swarthmore Ave","N Sycamore Slough Rd","N Sydenham St","N Tabernacle Dr",
            "N Taffee Dr","N Tahquitz Ave","N Tamarind Ave","N Tanglewood Ct","N Tapo Rd","N Tarlton St",
            "N Tassajara Dr","N Taylor Ln","N Taylor St","N Teilman Ave","N Telegraph Canyon Rd","N Temperance Ave",
            "N Tennessee Ave","N Territorial Rd","N Territory Ave","N Tex Canyon Rd","N Texas Ave",
            "N Thendara Rd","N Thesta St","N Thomas Ct","N Thompson Ct","N Thor St","N Thornridge Ln",
            "N Three Buttes Pl","N Thunderbird Dr","N Thurlow Ave","N Timber Rd","N Tonto Cir","N Tonto Trl",
            "N Topanga Canyon Blvd","N Torino Ave","N Tortoise St","N Tortose Ln","N Township Road",
            "N Travis","N Trend Dr","N Trinity Ave","N Trovas Dr","N Tulane St","N Turner Rd","N Turner St",
            "N Turnerville Rd","N Turquoise Ave","N Tustin Ave","N Twain St","N Twin Lakes Dr","N Twin Pines Dr",
            "N U Ave","N Uber St","N Union St","N Unionville Rd","N Uruapan Way","N Utah St","N Vagedes Ave",
            "N Valadez St","N Valencia Pl","N Valente Rd","N Valentine Ave","N Valeria St","N Valley Dr",
            "N Valley Green Dr","N Valley Vista Dr","N Van Etten St","N Ventu Park Rd","N Veprek Ln",
            "N Veranda Pl","N Verano Ct","N Verdugo Dr","N Vermont Ave","N Via Dorado","N Via Las Palmas",
            "N Via Latigo","N Via de Cerro","N Via de la Sombre","N Via la Doncella","N Victor Rd",
            "N View Dr","N Villa Ct","N Village Dr","N Vine St","N Vinton Rd","N Virginia Rd","N Vista Ave",
            "N Vista Dr","N Vista Pl","N Vista St","N Vita Dr","N Vodges St","N Waccamaw St","N Wade Blvd",
            "N Walch St","N Wall Ave","N Wallace Dr","N Walnut Ave","N Walnut St","N Walnut Ter","N Wapoma Ave",
            "N Warner Ave","N Warren Ave","N Warwick Rd","N Washington","N Washington Ave","N Washington St",
            "N Water St","N Watts St","N Webb Ave","N Weber Ave","N Wedgewood Ct","N Weeks Way","N Weis Ct",
            "N Welch Ave","N Wellington St","N Wells Ave","N Werley Rd","N West Ave","N West Lawn Ave",
            "N West St","N Westhaven St","N Westside St","N Westview Dr","N Wetter St","N Whispering Pine Rd",
            "N Whispering Ridge Way","N White Horse Pike","N Wild Eagle Ave","N Wildwood Blvd",
            "N Wildwood Rd","N Wilkinson Way","N Willow Ave","N Willow St","N Willsie St","N Wilmot Rd",
            "N Wilson Ave","N Wimer Rd","N Wimpy Jones Rd","N Winans Rd","N Winchester Ave","N Winery Cir",
            "N Winfield Scott Plz","N Wingfield Pk","N Winners Cir","N Wiota St","N Wisconsin St",
            "N Wolfe Rd","N Wood Ave","N Woodland Rd","N Woodlawn Dr","N Woodrow Ave","N Woodrow St",
            "N Woods Rd","N Woodside Ct","N Woodson Ave","N Woodstock St","N Wright Ln","N Wrightwood Dr",
            "N Yamashita St","N Yarbrough Dr","N Yarmouth Ave","N Yo-He-Wah Dr","N Yoder St","N Yosemite Ave",
            "N Yucca Ct","N Zircon Ct","N Zircon Dr","N del Pino","N el Camino Dr","N el Capitan","N el Dorado Ct",
            "N el Granito St","N el Rio Dr","N for Rd","N la Cienega Dr","N la Patera Ln","N la Peer Dr",
            "N la Senda Dr","N-8031","N. Sandario Rd","N. Whisman Rd","N0100 Rd","N0252 Rd","N0258 Rd","N0293 Rd",
            "N0330 Rd","N0364 Rd","N0415 Rd","N0498 Rd","N0560 Rd","N0735 Rd","N0795 Rd","N0805 Rd","N0810 Rd",
            "N0845 Rd","N0855 Rd","N0865 Rd","N0885 Rd","N1029","N2520 Rd","N4420 Rd","N4750 Rd","N4770 Rd","N4800",
            "N4820","N5072","NE 101st St","NE 20th St","NE 23rd Ave","NE 2nd St","NE 3rd St","NE 6th St","NE Fasset St",
            "NE Jackson St","NE Oak St","NE Oak Street","NE Place 9th","NE Railroad Blvd","NFD 010 Trl",
            "NFD 024 Trl","NFD 058 Trl","NFD 200 Trl","NFD 394 Trl","NFD 402 Rd","NFD 41S15 Rd","NFD 425 Rd",
            "NFD 451 Rd","NFD 469 Rd","NFD 589 Rd","NFD 616 Rd","NJTP EZ-Pass Lane","NV 215","NW 10th Ave",
            "NW 10th St","NW 14th Ave","NW 2nd Ave","NW 5th St","NW 6th Ave","NW 6th St","NW 7th St","NW Avenida Esplendida",
            "NW Bonnie Ln","NY 49","Na Me Guss Ct","Naamans Dr","Naamans Rd","Naauma Lane","Naberal Ave",
            "Nabors Rd","Nachez St","Nacimiento Lake Dr","Naciniento Shores Dr","Naco Rd","Nada Ct","Nadeau Rd",
            "Nadeau St","Nadeau Street","Nadeau Trl","Nadel Dr","Nader Ct","Nadia Ln","Nadine Blvd","Nadine Crescent",
            "Nadine St","Nadowa St","Nagel St","Nagle Ave","Nagle Rd","Nagle Road","Nagle St","Nagog Park",
            "Nagy Ln","Nahma Trl","Nairn Avenue","Nairn Dr","Nairn Ln","Nairn Pl","Naked Creek Hallow Rd",
            "Namao Drive","Nambe W","Nambe Ct","Nambe Ct NE","Nambe Loop","Namonee Trl","Nampeyo St","Nana Trail",
            "Nanak Road","Nanaula Dr","Nance Rd","Nancia Dr","Nancy Ann Bend Rd","Nancy Ct","Nancy Dr","Nancy Drive",
            "Nancy Lane","Nancy Ln","Nancy Mae Ave","Nancy Pl","Nancy Rd","Nancy Road","Nancy St SE","Nancy's Way",
            "Nandor Dr","Nanette Ln","Nanez Rd","Nanna Ct","Nano Dr","Nansen Ct","Nantucket Blvd","Nantucket Cir",
            "Nantucket Colony Cir","Nantucket Ct","Nantucket Dr","Nantucket Drive","Nantucket Pl",
            "Nantucket Rd","Nantucket St","Nantyr Drive","Nanuuq Trl","Nanwood Dr","Nanwood Drive","Naomi Crescent",
            "Naomi Dr","Naomi Evans Rd","Naomi Rd","Naomi St","Naomi Street","Naomi Way","Napa Dr","Napa Rd",
            "Napa Ridge Dr","Napa Valley Rd NE","Napanee Road","Napier Street","Naples Cir.","Naples Ct",
            "Naples Hill Rd","Naples Pl","Napoli Dr","Nara Visa Ct","Naranja Way","Narbrook Park","Narcisco Way",
            "Narcissus Ave","Nardin Dr","Nardone Pl","Nares Ave","Narla Ln","Narlene Way","Narragannett Dr",
            "Narragansett Ave","Narragansett Park Dr","Narragansett Pl","Narrow Lane","Narrow Lane Ct",
            "Narrow Ln","Narrows Lock Road","Narrows Rd","Narumson St","Nash","Nash Ct","Nash Hill Road",
            "Nash Memorial Road","Nash Road","Nash St","Nasha Way Road","Nashua Cir","Nashua Dr","Nashua Rd",
            "Nashua Road","Nashua St","Nashua Street","Nashville Ct","Nashville St","Nasmith Avenue",
            "Nason Rd","Nason St","Nassau Ave","Nassau Ct","Nassau Park","Nassau Pl","Nassau Street","Nasto Ter",
            "Nat Key Rd","Nata","Natal Avenue","Natale Way","Natalia Ln","Natalicio Ln","Natalie Ave","Natalie Dr",
            "Natalie Rd","Natchaug St","Natchez Dr","Natchez Trace Pky","Natchiq Ave","Nathan Ct","Nathan Cutler Dr",
            "Nathan Ln","Nathan's Way","Nathaniel Cir","Nathaniel Pl","Nathaniel St","Nathaniel Street",
            "Nathaway Drive","Natick St","Nation Dr","National Ave","National Dr","National Forest 273",
            "National Forest Dev Rd","National Forest Rd 121","National Forest Rd 906","National Forest Rd 915",
            "National Forest Road 111","National Forest Road 2120","National New Lafferty Rd",
            "National Old Trails Rd","National Park Blvd","National Parks Service Road","National Rd",
            "National Trails Hwy","National Union Blvd","Native Dancer Way","Natl Forest Develop Road 001 Rd",
            "Natl Forest Develop Road 007 Rd","Natl Forest Develop Road 010 Rd","Natl Forest Develop Road 011 Rd",
            "Natl Forest Develop Road 015 Rd","Natl Forest Develop Road 017 Rd","Natl Forest Develop Road 017 Trl",
            "Natl Forest Develop Road 018 Rd","Natl Forest Develop Road 020 Rd","Natl Forest Develop Road 023 Rd",
            "Natl Forest Develop Road 023 Trl","Natl Forest Develop Road 037 Rd","Natl Forest Develop Road 049 Rd",
            "Natl Forest Develop Road 053 Trl","Natl Forest Develop Road 060 Rd","Natl Forest Develop Road 067 Rd",
            "Natl Forest Develop Road 067 Trl","Natl Forest Develop Road 069 Trl","Natl Forest Develop Road 088 Rd",
            "Natl Forest Develop Road 091 Rd","Natl Forest Develop Road 096 Rd","Natl Forest Develop Road 1007",
            "Natl Forest Develop Road 107 Trl","Natl Forest Develop Road 112","Natl Forest Develop Road 115 Rd",
            "Natl Forest Develop Road 116","Natl Forest Develop Road 117 Trl","Natl Forest Develop Road 119 Rd",
            "Natl Forest Develop Road 120 Trl","Natl Forest Develop Road 128 Trl","Natl Forest Develop Road 132 Rd",
            "Natl Forest Develop Road 140 Rd","Natl Forest Develop Road 1509","Natl Forest Develop Road 156 Rd",
            "Natl Forest Develop Road 171 Rd","Natl Forest Develop Road 177","Natl Forest Develop Road 178 Rd",
            "Natl Forest Develop Road 179 Rd","Natl Forest Develop Road 2015","Natl Forest Develop Road 214 Rd",
            "Natl Forest Develop Road 300 Trl","Natl Forest Develop Road 323","Natl Forest Develop Road 342 Rd",
            "Natl Forest Develop Road 343 Trl","Natl Forest Develop Road 354 Rd","Natl Forest Develop Road 366 Rd",
            "Natl Forest Develop Road 389 Rd","Natl Forest Develop Road 405 Rd","Natl Forest Develop Road 407 Rd",
            "Natl Forest Develop Road 410 Rd","Natl Forest Develop Road 4110 Rd","Natl Forest Develop Road 415 Rd",
            "Natl Forest Develop Road 416 Rd","Natl Forest Develop Road 418 Rd","Natl Forest Develop Road 419 Rd",
            "Natl Forest Develop Road 431 Rd","Natl Forest Develop Road 434 Rd","Natl Forest Develop Road 436 Rd",
            "Natl Forest Develop Road 4402","Natl Forest Develop Road 441 Rd","Natl Forest Develop Road 445 Rd",
            "Natl Forest Develop Road 447 Rd","Natl Forest Develop Road 449 Trl","Natl Forest Develop Road 450 Rd",
            "Natl Forest Develop Road 451 Rd","Natl Forest Develop Road 453 Rd","Natl Forest Develop Road 458 Rd",
            "Natl Forest Develop Road 460 Rd","Natl Forest Develop Road 472 Rd","Natl Forest Develop Road 491 Rd",
            "Natl Forest Develop Road 502 Rd","Natl Forest Develop Road 529 Rd","Natl Forest Develop Road 539 Rd",
            "Natl Forest Develop Road 5520","Natl Forest Develop Road 564 Rd","Natl Forest Develop Road 567 Rd",
            "Natl Forest Develop Road 568 Rd","Natl Forest Develop Road 610 Trl","Natl Forest Develop Road 617 Rd",
            "Natl Forest Develop Road 622 Rd","Natl Forest Develop Road 643 Rd","Natoli Ave",
            "Natrona Ave","Natulhi Trl","Nature Ln","Nature Tr Court","Nature View Blvd","Nature Wood Ct",
            "Natures Cove Ct","Natures Crossing","Natures Trl","Natures Way","Naturewood Dr","Naudain St",
            "Naugatuck Cir","Naugle Dr","Nauset Ln","Naushon North","Naushon Road","Nautical Dr","Nautical St",
            "Nautilus Ct","Nautilus Ln","Nautilus Rd","Nautilus Street","Nauvoo Rd","Navada","Navajo Ave",
            "Navajo Cir","Navajo Ct","Navajo Dr","Navajo Drive","Navajo Ln","Navajo Rd","Navajo Route 132",
            "Navajo Route 16","Navajo Route 193","Navajo Route 5000","Navajo Route 5007","Navajo Route 5012 (Sanostee Road)",
            "Navajo Route 5020","Navajo Route 60","Navajo Route 63","Navajo Route 6310","Navajo Route 6460",
            "Navajo Route 7044 (Cousins Road)","Navajo Route 7140 (Lupton Road)","Navajo Route 8",
            "Navajo Route 8031","Navajo Route 9065","Navajo Rte 41","Navajo Service Rt 7044","Navajo Service Rt 7047",
            "Navajo Tr","Navajo Way","Navarre Rd SW","Navarro Bluff Rd","Navarro Ct","Navarro Ln","Nave Ct",
            "Navegar Cir","Navesink Ave","Navesink Ct","Navia Dr","Navia Ln","Navigator Ct","Navigators Reach",
            "Navilla Pl","Navlet Ct","Navy Hall Circle","Navy Rd","Navy St","Navy Street","Navy Walk","Navy Way",
            "Navy Wharf Court","Naw St","Nawaka Blvd","Naylon Ave","Naylon Street","Naylor Ave","Naylor Rd",
            "Nazzaro Ct","Neal Avenue","Neal Ct","Neal Dr","Neal Mill Rd","Neal Pl","Neal Rd","Neal Street",
            "Neale Dr","Neale Rd","Neale St","Neals Ln","Nealy Blvd","Neary Ave","Neatherwood Ter","Nebel Way",
            "Nebo Hill Rd","Nebo St","Nebraska Ave","Nebraska Street","Necarsulmer Dr","Neck Farm Rd",
            "Nectarine St","Nector Ave","Ned Rd","Nedellec Dr","Nedra Dr","Need Street","Needham Dr","Needham Rd",
            "Needham St","Needham Way","Needhamdale Road","Needle Dr","Needle Point Road","Needlepine Ln",
            "Needles Eye Rd","Needles Hwy","Needmore Dr","Neepaulin Dr","Nees Ave","Neetsie Dr SW","Neff Rd",
            "Neff Road","Neff Street","Negro Ben Rd","Nehlsen","Neid Rd","Neidhardt Rd","Neighborhood Dr",
            "Neighbors","Neil Armstrong Elementary Sch","Neil Ct","Neil Ln","Neil St","Neil's Aly","Neill Ct",
            "Neilly Ct","Neilor Crescent S","Neilson Avenue","Neilson Rd","Neilson Road","Neipsic Rd",
            "Nelden Rd","Neleen Dr","Nelles Boulevard","Nelles Court","Nelles Road N","Nelles Road S",
            "Nellie Dent Dr","Nellie Ln","Nellie Ln 2","Nellie Springs Ct","Nellis Dr","Nello St","Nello Street",
            "Nellwood Cir","Nelmar Heights Rd","Nelson Ave","Nelson Avenue","Nelson Blvd","Nelson Circle",
            "Nelson Crescent","Nelson Ct","Nelson Dr","Nelson Hill","Nelson Hill Rd","Nelson Ln","Nelson Loop",
            "Nelson Pl","Nelson Ranch Rd","Nelson Rd","Nelson Road","Nelson St","Nelson Street","Nelson Way",
            "Nelson Williams Rd","Nemana Ln","Nematode Ln","Nemo Pl SW","Neponset Court","Neponset Place",
            "Neponset Street","Nepote Pl","Neptune Ave","Neptune Crescent","Neptune Ct","Neptune Dr",
            "Neptune Drive","Neptune Pl","Neptune Sq","Neptune St","Neptunes Ct","Nero Ln","Neros Run","Nesbit Ave",
            "Nesbit Rd","Nesbitt Rd","Nescochague Rd","Neskell Dr","Nesmith Pl","Nessus Street","Nester Cv",
            "Nestle Ave","Nesto Ter","Nestor Crescent","Nestora Ave","Nestorita Way","Netherby Road",
            "Netherford Road","Netherland Ave","Netherland Avenue","Netherwood Road","Netop Trl","Netta Road",
            "Nettie Norris Dr","Nettle Way","Nettles Rd","Nettlesboro Rd","Nettleton Hollow Rd","Neumann Rd",
            "Neumarkel Rd","Neumier Dr","Neuschwander Rd","Neva Ct","Nevada","Nevada 124 Rd","Nevada 129 Rd",
            "Nevada 179 Rd","Nevada 180 Rd","Nevada 281 Rd","Nevada 297 Rd","Nevada 34 Rd","Nevada 422 Rd",
            "Nevada 48 S","Nevada 48 W","Nevada 48 Rd N","Nevada 48 Rd S","Nevada 51","Nevada 60 Rd W",
            "Nevada Ave","Nevada Classic Cir","Nevada Dr","Nevada F204 Rd","Nevada F214 Rd","Nevada F42 Rd",
            "Nevada Pl","Nevada St","Nevette Ct","Neville Ct","Neville Dr","Neville Lane","Neville Park Boulevard",
            "Neville St","Nevins St","New Albany Rd","New Alexaandria Rd","New Bedford Ave","New Bedford Road",
            "New Beginings Ln","New Bethel Rd","New Bolton Road","New Bond St","New Boston Rd","New Boston Road",
            "New Boston Street","New Braintree Road","New Bridge Road","New Brunswick Ave","New Buffalo Rd",
            "New Castle Ave","New Castle Avenue","New Castle Rd","New Castle Street","New Cedar Ln",
            "New Cedarbrook Rd","New Centre Rd","New City Rd","New Clarkstown Rd","New County Road",
            "New Cumberland Rd NE","New Delhi St","New Dock Street","New Dorp Ln","New Dorp Plz","New Dublin Road",
            "New Duck Pond Rd","New Dunstable Rd","New Ebenezer Rd","New England Ct","New England Dr",
            "New Era Dr","New Farm Ct","New Front St","New Gold Butte Rd","New H U D Housing Rd","New Hampshire Ave",
            "New Hampshire Route 101","New Hanover Ave","New Hartford Shopping Center","New Haven St",
            "New Hill Rd","New Hillcrest Ave","New Holland Dr","New Holland Village","New Hope","New Hope W",
            "New Hope Ln","New Hope Rd","New Hope Way","New Housing Rd","New Jersey Ave","New Jersey Route 181",
            "New Jersey Route 183","New Jersey Route 42","New Jersey St","New Jersey Turnpike",
            "New Jersey Turnpike Newark Bay Extension","New Kent Dr","New King Street","New Kingston Mountain Rd",
            "New Lenox Road","New Liberty","New Liberty Rd","New Life Ln","New Market Ave","New Mashipcang Rd",
            "New Mexico Ave","New Mexico State Road 127","New Mexico State Road 50","New Milford Ave",
            "New Milford Rd","New Mill Street","New Minn Hts","New Mont Rd","New Moores Creek Rd",
            "New Oak Ct","New Oakstreet","New Park Rd","New Pass Mine Rd","New Prospect Rd","New Rd",
            "New Reed Street","New River Rd","New Road","New Rodgers Rd","New Rome Rd","New Salem Point",
            "New Schley St","New School Rd NW","New Seabury Drive","New Seward Hwy","New Sherborn Road",
            "New South Road","New St","New Stowell Rd","New Street","New Turnpike Rd","New Valley Rd",
            "New Village Rd","New Walnut St","New Water Street","New Watermelon Rd","New Westminster Drive",
            "New Whale Street","New Wine Pl","New Wood Rd","New Years Dr","New York Ave","New York Canyon",
            "New York Canyon Rd","New York Mountain Rd","New York Plaza","New York Rd","New York St",
            "New York State Route 440","New York State Thruway","New Yorker Dr","Newalls Beach Road",
            "Newark Ave","Newark St","Newark Tpke","Newark Turnpike","Newberg Rd","Newbern Avenue","Newbern Dr",
            "Newbern Street","Newberry Ave","Newberry Ct","Newbolds Ln","Newbound Court","Newbridge Rd",
            "Newbridge Way","Newburg Ln","Newburg Rd","Newburg St","Newburgh Tpke","Newbury Cir","Newbury St",
            "Newburyport Turnpike","Newby Avenue","Newby Ct","Newby Dr","Newcastle Ave","Newcastle Ct",
            "Newcastle Dr","Newcastle Street","Newcastle Way","Newcomb Ave","Newcomb Avenue","Newcomb Dr",
            "Newcomb Rd","Newcomb St","Newel Street","Newell Ave","Newell Dr","Newell Hill Rd","Newell Hill Road",
            "Newell Pl","Newell Pond Road","Newell Rd","Newell Road","Newell St","Newfield Avenue","Newfield Cir",
            "Newfield Road","Newfound Way","Newfoundland Road","Newgard Dr","Newgate Place","Newhall Ave",
            "Newhall Court","Newhall St","Newhall Street","Newhart St","Newholm Road","Newington Avenue",
            "Newington Rd","Newkirk Ave","Newkirk Dr","Newkirk Rd","Newkirk Road","Newland Dr NE","Newlanders Cove Dr",
            "Newman Ave","Newman Creek Rd","Newman Dr","Newman Drive","Newman Hill Rd","Newman Springs Rd",
            "Newman St","Newman Trl","Newmark Ave","Newport Cir","Newport Ct","Newport Dr","Newport Lane",
            "Newport Neck Rd","Newport Rd","Newport Rd NW","Newport Ridge Dr E","Newportville Rd",
            "Newsom St","Newspaper Road","Newton Ave","Newton Drive","Newton Ln","Newton Mtwy","Newton Park Dr",
            "Newton Rd","Newton St","Newton Street","Newton Swartswood Rd","Newton Town Road","Newton Way",
            "Newtonbrook Boulevard","Newtons Landing Blvd","Newtown Pike","Newtown Rd","Newtown Richboro Rd",
            "Newtown Road","Newtown Street Rd","Newville Ave","Newville Rd","Next St","Neyagawa Boulevard",
            "Nfw 106","Nfw 517","Nfw 99","Niagara Aly","Niagara Ave","Niagara Boulavard","Niagara Dr","Niagara Falls Blvd",
            "Niagara Rd","Niagara Shore Dr","Niagara St","Niagara Street","Niagra Ct","Niagra Ridge",
            "Niantic Pl","Nibert Dr","Niblick Rd","Nice Ct","Nice Pl","Nice-Lucerne Cutoff Rd","Nichol Ave",
            "Nichol St","Nicholas Ave","Nicholas Cir","Nicholas Ct","Nicholas Dr","Nicholas Ln","Nicholas Way",
            "Nicholette Rd","Nicholl Dr","Nichols Ave","Nichols Boulevard","Nichols Cem Rd","Nichols Cir",
            "Nichols Ct","Nichols Drive","Nichols Hunt Rd","Nichols Line","Nichols Ln","Nichols Mill Rd",
            "Nichols Rd","Nichols Road","Nichols Street","Nicholson Hill","Nicholson Road","Nick Smith Rd",
            "Nickel Ave","Nickel Dr","Nickel Rd","Nickel St","Nickelaus Ct","Nickerson Avenue","Nickerson Dr",
            "Nickerson Rd","Nickerson Valley Rd","Nickett Dr","Nickle Rd","Nickleby Ave","Nickletown Rd",
            "Nickolas St","Nicodemus Ln SW","Nicol Ter","Nicola Rd","Nicolan Road","Nicole Cir","Nicole Ct",
            "Nicole Dr","Nicole Loop","Nicole Marie Avenue","Nicolet St","Nicolette Ct","Nicoli St",
            "Nicolia Dr","Nicollet Ave","Nicosia Way","Niderer Rd","Nidever Rd","Niece Road","Nielsen Ct",
            "Nieman St","Niewview Dr","Night Hawk Dr","Night Hawk Ln","Night Hawk Rd","Night Heron Ln",
            "Night Swim","Nightengale St","Nightfall Ct","Nighthawk Way","Nightingale Path","Nightingale Place",
            "Nightingale St","Nightjar Ct","Nightshade Pl","Nightsky Rd","Nightwind Cir","Nihau Ave",
            "Nike Ave","Nike Ct","Nikhil Ct","Niki Ln","Niki Rd","Nile Street","Niles Ave","Niles Rd","Niles Way",
            "Nill Ave","Nilman Road","Nilo Dr","Nimble Hill Rd","Nimbus Place","Nimbus Rd","Nimitz Dr","Nimrod Crescent",
            "Nimrod Ct","Nims St","Nina Ct","Nina Drive","Nina St","Nine Foot Rd","Nine Mile Rd","Nineteenth Street",
            "Ninetieth Street","Ninety Nine Way","Ninive Dr","Ninth Line","Ninth Road","Ninth Street",
            "Nipa Ave","Nipigon Street","Nipper St","Nippising St","Nippon Ct","Nipton Rd","Nipview Cir",
            "Nirvana Ct","Nishga Court","Nishuane Rd","Nita Ct","Nita Ln","Nivens Ln","Nixburg Rd","Nixon Ave",
            "Nixon Lake Rd","Nixson St","Nizhoni Way","Nm 173","Nm 511","Nm 528 Blvd NW","Nnp","No 1","No 17 Rd",
            "No 6 Rd","No Co Rd 305","No Easy Rd","No Main St","No Name Blvd","No Name Ln","No Short St",
            "No Way","No-Name St","Noah Dr","Noah Ln","Noah Rd","Noahs Landing","Noakes St","Noam Drive","Nob Ave",
            "Nob Ct","Nob Hill Oval","Nob Shore Ave","Nobe Rd","Nobel Drive","Noble Ave","Noble Avenue",
            "Noble Creek","Noble Ct","Noble Ln","Noble Pl NE","Noble Rd","Noble Road","Noble Street","Nobleton Cir",
            "Nobleton Drive","Nobodys Road","Nocturn Way","Nocturne Dr","Nod Rd","Nodak Rd","Nodaway Ave",
            "Nodens Ct","Nodin Drive","Noe Avenue","Noel Court","Noel Ln","Noel Rd","Noel St","Noel Street",
            "Nogal Canyon Rd","Nogal Ct","Nogales Dr","Nogales Rd NE","Nogales St","Nogezzi Rd","Nogues Rd",
            "Noisy Creek Rd","Nojack Ct","Nojoqui Ln","Nokomis Dr","Nokomis Lake Dr","Nokomis Rd","Nolan Ave",
            "Nolan Cir","Nolan Dr","Nolan St","Noland St","Nolans Point Rd","Nolgs Cir","Noll Street","Nolls Farm Rd",
            "Nolon Park","Nolte Dr","Nomad Ave","Nomahegan Ct","Nomoe Rd","Nonquit Road","Nonquon Road",
            "Nooch Rd","Noojin Ct","Noon Rd","Noonan Dr","Noonday St","Noone Ave","Noony Hill Rd","Nooseneck Hill Rd",
            "Nora Ct","Nora Dr","Nora Lane","Nora Lynn Dr","Nora Rd","Noranda Drive","Norbert Ave","Norbrook Dr",
            "Norcross Circle","Norcross Drive","Norcross Rd","Norcross Street","Nordale Ave","Norden Crescent",
            "Nordhoff Pl","Nordhoff Ridge Rd","Nordia Ln","Nordic Ave NW","Nordic Dr","Nordic Woods Ln",
            "Noreen Ct NE","Noreen Ln","Noren St","Norene St","Norfal Pl","Norfield Ct","Norfleet Ave","Norfleet Dr",
            "Norfolk","Norfolk Ave","Norfolk Avenue","Norfolk Court","Norfolk Ct","Norfolk Dr","Norfolk Rd",
            "Norfolk Street","Norfolk Terrace","Norgrove Crescent","Noriega Rd","Noritake Ct","Norite Ave",
            "Norlen Ln","Norma Ave","Norma Ct","Norma Ln","Norma Rd","Norma St","Normal Blvd","Norman Ave",
            "Norman Avenue","Norman Bridge Rd","Norman Cir","Norman Dr","Norman Hill Ln","Norman Pl",
            "Norman Rd","Norman Road","Norman Rogers Drive","Norman St","Norman Way","Normandale Dr",
            "Normandie Ave","Normandie Ave North Access Rd","Normandy Ave","Normandy Avenue","Normandy Ct",
            "Normandy Dr","Normandy Ln","Normandy Pl","Normandy Rd","Normandy St","Normandy Street","Normandy Way",
            "Norms Rd","Norris Ave","Norris Court","Norris Dr","Norris Path","Norris Rd","Norris St","Norris Way",
            "Norrisgrove Ave","Norseman Dr","Norseman Street","Norsex Ave","Norte Pl","Norte Rd","Norte Vista Dr",
            "Norte del Sol Ln","North","North 10th Street","North 18th Street","North 1st Street",
            "North 21st Street","North 4th Street","North 5th Street","North 6th Street","North 9th Street",
            "North Aly","North Appaloop Pl","North Arlington Avenue","North Ashburnham Road","North Ave",
            "North Ave E","North Avenue","North Baker Hollow","North Bay Road","North Bend State Park",
            "North Bonnington Avenue","North Branch Parkway","North Branch Rd","North Brigham Hill Road",
            "North Camp Hill Rd","North Campus Drive","North Carolina Ave","North Charlame Court",
            "North Church Street","North Cir","North Circle Dr","North Commerce Square","North Court",
            "North Creek Cutoff","North Creek Rd","North Ct","North Dome Ct","North Dorset Place",
            "North Dr","North Drexel Dr","North Drive","North Edgely Avenue","North Edgewood Rd","North Elliott Place",
            "North End Rd","North End Road","North Fork","North Fork Mill Creek Road","North Fork Rd",
            "North Fork Trail","North Forty Rd","North Front Street","North Gate","North Gate Rd",
            "North Glenway Avenue","North Green Street","North Hamilton Pky","North Hartford Ave",
            "North Hastings Avenue","North Hill Road","North Hills Dr","North Hills Terrace","North Holden Road",
            "North Horse Mountain Rd","North Hwy","North Industrial Way","North Jackson Street",
            "North Jean Street","North King Street","North Lane","North Lane Number Two","North Leonard Ave",
            "North Line Rd","North Ln","North Locust St","North Loop","North Loop Dr","North Madison Street",
            "North Main Parkway","North Main St","North Main Street","North Market Street","North Mary Avenue",
            "North McKinley Ave","North Michigan St","North Oak Creek Rd","North Park Dr","North Park Road",
            "North Park Street","North Pastoria Avenue","North Peak St","North Pierce","North Pl",
            "North Point Cv","North Pond Ct","North Pond Rd","North Precinct Street","North Putnam Street",
            "North Quincy Street","North Range Rd","North Rd","North Rd SE","North Rd; Mont Sec Ave",
            "North Reading St","North Remington Rd","North Richwood Avenue","North Ridge","North Ridge Dr",
            "North Ridge Ln","North Ridge Pl","North Ridge Rd","North Ridge Trail","North Riva Ridge Loop",
            "North River Court","North River Farm Dr","North River Rd","North Road","North Road W",
            "North Sanford Road","North School Road","North Scugog Court","North Service Road",
            "North Sho Road","North Shore Dr","North Shore Dr East","North Shore Ln","North Shore Rd",
            "North Silver Lane","North South Fwy","North South Rd","North St","North St W","North Star Drive",
            "North Star Loop","North Star Rd","North State Line Rd","North Street","North Street E",
            "North Street W","North Sun Road","North Sunset Bay Road","North Talbot Rd.","North Ter",
            "North Trail","North Trl","North Turner Way","North Underwood Street","North Van Buren Street",
            "North Village Rd","North Washington Street","North Way","North West Street","North William Street",
            "North Windemere Avenue","North York Boulevard","North-South Arterial Highway","North-South Freeway",
            "Northam Dr","Northam Rd","Northampton Boulevard","Northampton Court","Northampton Ct",
            "Northampton Dr","Northampton Rd","Northampton Road","Northbank Ln","Northbrook Rd","Northcliffe Ct",
            "Northcoast St","Northcott Ln","Northcrest Drive","Northeast Ave","Northeast Boulevard",
            "Northeastern Avenue","Northeights Rd","Northend Ln","Northern Ave","Northern Avenue",
            "Northern Avenue E","Northern Blvd","Northern Cir","Northern Creek Rd","Northern Dancer Dr",
            "Northern Dr","Northern Lights Avenue","Northern Rail Trail","Northern Rd","Northey Drive",
            "Northfield Ave","Northfield Gate","Northfield Plz","Northfield Road","Northfork Pl","Northgate Crescent",
            "Northgate Ct","Northgate Dr","Northgate Drive","Northgate Ln","Northgate Manor","Northgate Pl S",
            "Northgate Plz","Northgate Road","Northglen Ln","Northhaven Ct","Northill Ct","Northill Dr",
            "Northington Ct","Northlake St","Northland Ave SW","Northland Dr","Northland Rd","Northland St",
            "Northlin Park Road","Northline Rd","Northline Road","Northlyn Ct","Northover Street",
            "Northport Lane","Northridge Dr","Northridge Drive","Northridge Ln","Northridge Pl","Northridge Road",
            "Northrop Ave","Northrop Rd","Northrup Ave NW","Northrup Court Apartment","Northshore Dr",
            "Northshore Rd","Northside Avenue","Northside Drive","Northspur Rd","Northstar","Northstar Drive",
            "Northtown Court","Northumberland Boulevard","Northumberland Rd","Northumberland Street",
            "Northumberland Way","Northup Rd","Northvale Ln","Northvale Road","Northview","Northview Ave NW",
            "Northview Dr","Northview Rd","Northway","Northway Dr","Northwest Cir NW","Northwest Hill Road",
            "Northwest Pass","Northwestern Ct","Northwestern Way","Northwich Ct","Northwind Dr","Northwind Rd",
            "Northwood Ave","Northwood Dr","Northwood Hollow Ct","Northwood St","Northwood Terrace",
            "Northwoods Rd","Norton","Norton Avenue","Norton Hills Rd","Norton Hollow Rd","Norton Lane",
            "Norton Ln","Norton Pl","Norton Rd","Norton St","Norton Village Ln","Nortree St","Norumbega Dr",
            "Norval Avenue","Norvel Dr N","Norwalk Rd","Norway Lake Rd","Norway Ln","Norway Maple St",
            "Norway Spruce","Norway Street","Norway Trl","Norwell Street","Norwich Ct","Norwich Ln","Norwich Pl",
            "Norwich Place","Norwich Way","Norwich Worcester Tpke","Norwill Crescent","Norwood Ave",
            "Norwood Ave S","Norwood Ct","Norwood Pl","Norwood Place","Norwood Rd","Norwood St","Norwood Street",
            "Norwood Ter","Norwood Terrace","Norwood View","Nosoni Ct","Nostrand Ave","Notch Pond Rd",
            "Notch Rd","Notch Road","Noth Service Road","Nothing Rd","Notre Dame Ave","Notre Dame St",
            "Nottawa Avenue","Nottawasa Street;Nottawasaga Street;Nottawasaga Street","Notting Hill Gate",
            "Nottingham","Nottingham Ct","Nottingham Dr","Nottingham Dr W","Nottingham Pl","Nottingham Pointe",
            "Nottingham Rd","Nottingham Sq","Nottingham Street","Nottingham Way","Nottinghill Road",
            "Notus Ave","Nouque Ranch Rd","Nourse Road","Nova Ct","Nova Scotia Avenue","Novack Dr","Novad Ct",
            "Novak St","Novara Way","Novato Blvd","Novato Ln","Novato Way","Novatoga Dr","Novel Aly","Novel Ct",
            "Novella Road","Novello Dr","November Sky St","Novi St","Novik Ln","Novina Pl","Nowak St","Nowlin Ct",
            "Noyes Lane","Noyes Ln","Noyes Rd","Noyes St","Noyestar Rd","Nr 41","Nrtherhart Road","Nsilver Lake Rd",
            "Ntu Rd","Nu Wav Kaiv Blvd.","Nubana Avenue","Nuckrolls Ct","Nudd Way","Nueva Ave","Nueva Mission Rd",
            "Nuevo Ave","Nuffers Ln","Nugent Ct","Nugent Rd","Nugett Pl","Nugget Dr","Nugget Sq","Nugget Way",
            "Nuha St","Nulls Rd","Numa St","Number 22 Rd","Number 23 Rd","Number 26 Rd","Number 40 Rd","Number 5 Ditch Rd",
            "Nummytown Rd","Nunda Ave","Nunda Blvd","Nunda-Dansville Rd","Nunes Ct","Nunes Rd","Nunn Ave",
            "Nunnemacher St","Nunzie Ct","Nurme Avenue","Nurmela","Nurse Avenue","Nursery Ln","Nursery Road",
            "Nursery Street","Nussbaum Rd","Nut Tree Ct","Nutcraker Rd","Nutgrass Rd","Nuthatch Ln","Nuthatch Road",
            "Nutleaf Ct","Nutley Ave","Nutmeg Ave","Nutmeg Dr","Nutmeg Lane","Nutmeg Ln","Nutmeg Rd","Nutmeg Rd NE",
            "Nutmeg St","Nutmeg Street","Nutmegg Ct","Nutria Rd","Nutt Rd","Nutting St","Nuttman Street",
            "Nutwood Cir","Nye Ave","Nye Ct","Nye Rd","Nye Road","Nykun Island Ln","Nyma Way","O Brien Ave",
            "O Brien Dr","O C Dobyne Rd","O Connor Rd","O Connors Ln","O Doul Ave","O Drive","O Hara Dr",
            "O Len Cir","O Neal Rd","O Neil Ave","O Neil Dr","O Neil Rd","O Neil St","O O McIntyre Park",
            "O Quinn St","O St","O' Neil Cir","O'Brian Rd","O'Brien Mtn Rd","O'Brien Rd","O'Brien Road",
            "O'Connor Drive","O'Connor Ln","O'Connor Rd","O'Hara Road","O'Hare Rd","O'Keefe Lane","O'Meal Rd",
            "O'Melveny Cir","O'Neil County Road","O'Neil Way","O'Neill Road","O'Neill Street","O'Shaughnessy Blvd",
            "O'Shea Crescent","O'Shea de Oaks Ln","O'connor Cresent","O-1 Rd","O-Drive N","O7A Road",
            "Oak","Oak Acorn Ct","Oak Apple Ave","Oak Ave","Oak Ave SW","Oak Avenue","Oak Brook Cir","Oak Brook Ct",
            "Oak Brook Pl","Oak Canyon Dr","Oak Chase Dr","Oak Cir","Oak Circle","Oak Court","Oak Creek Pl",
            "Oak Crest Avenue","Oak Ct","Oak Dr","Oak Dr W","Oak Flat Rd","Oak Ford Way","Oak Forest Dr",
            "Oak Forest Ln","Oak Glen Ave","Oak Glen Dr","Oak Glen Rd","Oak Grove","Oak Grove Ave","Oak Grove Cemetery",
            "Oak Grove Ct","Oak Grove Ln","Oak Grove Rd","Oak Grove Street","Oak Grove Trl","Oak Harvest Ln",
            "Oak Haven Farm Rd","Oak Hill NE","Oak Hill Ave","Oak Hill Cemetery Rd","Oak Hill Cir",
            "Oak Hill Dr","Oak Hill Dr Extended S","Oak Hill Lane","Oak Hill Pl","Oak Hill Rd","Oak Hill Rd offramp",
            "Oak Hill Road","Oak Hill St","Oak Hill Trl NE","Oak Hills Dr","Oak Hollow Cir","Oak Hollow Ln",
            "Oak Hollow Rd","Oak Island Dr","Oak Knoll Ave","Oak Knoll Blvd","Oak Knoll Ct","Oak Knoll Dr",
            "Oak Knoll Drive","Oak Knoll Rd","Oak Knoll Road","Oak Knoll Terrace","Oak Lake Dr","Oak Lake Road",
            "Oak Lane","Oak Lane Dr","Oak Leaf Cir","Oak Leaf Ct","Oak Leaf Ln","Oak Ledge Rd","Oak Ln",
            "Oak Manor Dr","Oak Manor Mhp","Oak Meadow Dr","Oak Meadow St","Oak Mesa Dr","Oak Mews Ct",
            "Oak Mountain Dr","Oak Orchard River Road","Oak Park Ave","Oak Park Avenue","Oak Park Blvd",
            "Oak Park Dr","Oak Park Ln","Oak Park Pl","Oak Pl","Oak Place","Oak Point Trl","Oak Post Rd",
            "Oak Ranch Dr","Oak Ranch Rd","Oak Rd","Oak Ridge Ave","Oak Ridge Avenue","Oak Ridge Circle South",
            "Oak Ridge Dr","Oak Ridge Ln","Oak Ridge Rd","Oak Rise Dr","Oak Road","Oak Rock Ln","Oak Shade Ln",
            "Oak Shadow Cir","Oak Shores Lane","Oak Side Ln","Oak Springs Dr","Oak Springs Rd","Oak Square",
            "Oak St","Oak Street","Oak Street Extension","Oak Street Terrace","Oak Summit Ct","Oak Ter",
            "Oak Terrace","Oak Terrace Ct","Oak Terrace Cv","Oak Terrace Dr","Oak Tree Apartment",
            "Oak Tree Estate Dr","Oak Tree Rd","Oak Tree Road","Oak Tree St","Oak Tree St NE","Oak Trl",
            "Oak Valley Dr","Oak View Avenue","Oak View Ct","Oak View Ln","Oak View Rd","Oak View St",
            "Oak Villa Cir","Oak Villa Dr","Oak Village","Oak Village Ct","Oak Walk","Oak Way","Oak Wells Rd",
            "Oak Wynne Dr","Oakbrook Ct","Oakbrook Dr","Oakbrook Ln","Oakbrook Rd","Oakbrooke Dr","Oakburn Place",
            "Oakchase Cv","Oakcrest Drive","Oakdale Ave","Oakdale Boulevard","Oakdale Dr","Oakdale Pl",
            "Oakdale Rd","Oakdale St","Oakdale Terrace","Oakdell Ln","Oakdene Ave","Oakdene Crescent",
            "Oakengates Dr","Oakes Dr","Oakes Group Office Park","Oakey Streak Rd","Oakfern Ln","Oakfield Ln",
            "Oakford Rd","Oakglade Crescent","Oakham Road","Oakham Street","Oakhill Ave","Oakhill Avenue",
            "Oakhill Ct","Oakhill Dr","Oakhurst Ave","Oakhurst Pky","Oakhurst Rd","Oakhurst Road","Oakknoll Dr",
            "Oakland Ave","Oakland Ave / Harrison St exit","Oakland Avenue","Oakland Camp Rd","Oakland Court",
            "Oakland Dr","Oakland Pl","Oakland Rd","Oakland St","Oakland Street","Oakland Ter","Oakland Way",
            "Oaklawn Ave","Oaklawn Ter","Oaklea Boulevard","Oakleaf Dr","Oakleaf Ln","Oakledge Rd","Oakleigh Dr",
            "Oakley Ave","Oakley Dr","Oakley Ln","Oakley St","Oakley Ter","Oakline Ct","Oakmeadow Boulevard",
            "Oakmont Aly E","Oakmont Ave","Oakmont Ct","Oakmont Dr","Oakmont Rd","Oakmont Ter (Egress)",
            "Oakmont Way","Oakmoor Ave","Oakmount Ave","Oakmount Blvd","Oaknoll Way","Oakridge Ave","Oakridge Boulevard",
            "Oakridge Crescent","Oakridge Ct","Oakridge Dr","Oakridge Drive","Oakridge Park Rd","Oakridge Pky",
            "Oakridge Rd","Oakridge Road","Oakridge St","Oakridge St SW","Oakridge Terrace","Oakridge Way",
            "Oaks Bluff Dr","Oaks Chapel Rd","Oaks Dr","Oaks Rancho Rd","Oakshire Ave","Oakshire Ct",
            "Oakshire Ln","Oakshire Pl","Oaktree Ave","Oaktree Ln","Oakview Ave","Oakview Cir","Oakview Ct",
            "Oakview Dr","Oakview Dr W","Oakway Dr","Oakway Ln","Oakwind Dr","Oakwood Ave","Oakwood Avenue",
            "Oakwood Cir","Oakwood Ct","Oakwood Dr","Oakwood Drive","Oakwood Estates","Oakwood Hollow Ln",
            "Oakwood Ln","Oakwood Pl","Oakwood Rd","Oakwood Rd E","Oakwood Ridge St","Oakwood St","Oakwood Ter",
            "Oakwood Way","Oakwynne Ter","Oasis Ave","Oasis Club Dr","Oasis Ct","Oasis Ln","Oasis Ranch Rd",
            "Oasis Spring Ranch Rd","Oates Lane","Oatman Rd","Oatman-Topock Hwy","Oats Rd","Oats St",
            "Obanion Rd","Obannon Rd","Obeline Dr","Oberhoffer Dr","Oberlin Ave","Oberlin Rd","Oberlin Road",
            "Oberlin St","Oberly Rd","Oberst St","Obert Ct","Oberwald Way","Obispo Dr","Obre Pl","Obregon Rd NE",
            "Obrien Rd","Observation Dr","Observatory Ln","Observatory Path","Observatory Pl","Observatory Road",
            "Observer Hwy","Obsidian Rd","Ocala Ln","Ocasa Ct","Ocatillo Ct","Occidental Ave","Occidental Cir",
            "Ocean Ave","Ocean Avenue","Ocean Beach Highway","Ocean Beach Rd","Ocean Blvd","Ocean Breeze Ave",
            "Ocean Ct","Ocean Dr","Ocean Dr S","Ocean Drive","Ocean Front Ln","Ocean Front St","Ocean Gate Ave",
            "Ocean Gate Dr","Ocean Lake Loop","Ocean Ln","Ocean Meadows Cir","Ocean Park East","Ocean Park Medical Condo Rd",
            "Ocean Parkway","Ocean Rd","Ocean Ridge Drive","Ocean Road","Ocean Side Ave","Ocean St","Ocean Street",
            "Ocean Street West Hyannisport","Ocean Ter","Ocean View Ave","Ocean View Dr","Ocean View Street",
            "Ocean View Way","Oceana Blvd","Oceana Drive West","Oceana Terrace","Oceania St","Oceanic Brg",
            "Oceanport Ave","Oceanport Dr","Oceanside Dr","Oceanside Walk","Oceanus Avenue","Oceanview Ave",
            "Oceanview Avenue","Oceanview Rd","Oceanview Ter","Ocelot Ct","Ocelot Rd NE","Oceola Ct",
            "Ochonski Road","Ocie Rhoden Dr","Ocio St","Oconee Cir","Oconnell Rd","Ocotillo Ct SW","Ocotillo Dr",
            "Ocotillo St","Octagon Rd","Octavia Street","Octavia Way","October Drive","October Trail",
            "Octubre Dr","Ode Way","Odell Rd","Odell Way","Oden Island Dr","Odena Rd N","Odena Rd S","Odesa Dr",
            "Odessa Ave","Odessa Avenue","Odessa Cir","Odessa St","Odom Dr","Odom Loop Rd","Odonnell Farm Rd",
            "Odus Murphee Dr","Odyssey Way","Oersted Rd NE","Office Pky","Offley Ave","Ogalalla Rd","Ogaz Loop",
            "Ogden Ave","Ogden Cir","Ogden Dr","Ogden Ln","Ogden St","Ogdenview Lane","Ogemah Road","Ogemaw Shores Dr",
            "Ogilby Dr","Ogimas St","Oglala Ct","Ohanneson Rd","Ohara Ave","Ohare Ave","Ohare Rd","Ohio","Ohio Ave",
            "Ohio Avenue","Ohio Cir","Ohio Ct","Ohio Dr","Ohio River Hwy","Ohio St","Ohio Trl","Ohio Turnpike",
            "Ohlone Trail","Oil Gas Co","Oil Mill Rd","Oil Rd","Oil Well Rd","Oilfield Rd","Oilfields Rd",
            "Oille Street","Oise Dr","Ojai Santa Paula Rd","Ojibwa Cir","Ojibwa Pl","Ojo de la Casa",
            "Ok Avenue","Ok St","Oka Road","Okanagan Drive","Oke Road","Okiola Ave","Oklahoma Ave","Oklahoma Drive",
            "Okrey Springs Rd","Okwarine","Okwaw Ave","Ola St","Olaf Ave","Olancha","Olancha Ln","Oland Drive",
            "Olander Ave","Olander Ln","Olcott Ave","Olcott Sq","Old 12 Cross Roads","Old 16th Avenue",
            "Old 231","Old 26 Rd","Old 44 Dr","Old 8A Rd","Old Abbott Pl","Old Abo Tr","Old Acton Rd","Old Adobe Rd",
            "Old Airport Rd","Old Alamo Rd","Old Albany Road","Old Albertson Rd","Old Altos Rd","Old Alturas Rd",
            "Old Amboy Rd","Old Ashby Rd","Old B Rd","Old Baptist Rd","Old Barney Avenue","Old Bartlett Rd",
            "Old Bay Rd","Old Bay Road","Old Bay St","Old Beahan Rd","Old Bean Rd","Old Bear Creek Rd",
            "Old Beaver Dam Rd","Old Bedford Road","Old Belmont Ave","Old Belvidere Rd","Old Bilby Rd",
            "Old Birch River Rd","Old Black Hill Rd","Old Black Horse Pike","Old Black Springs Rd",
            "Old Bloomfield Ave","Old Blue Lake Rd","Old Boorne Dr","Old Bowerstown Rd","Old Boyce Rd",
            "Old Bradberry Pl","Old Bradford Rd","Old Brainard Rd","Old Brewer Rd S","Old Briceland Rd",
            "Old Bridge Ct","Old Bridge Matawan Rd","Old Bridge Pl","Old Bridge Rd","Old Bridge Road",
            "Old Bridge St","Old Bridge St N","Old Broadway","Old Brook Rd","Old Brookline Rd","Old Brookville Rd",
            "Old Brundridge Rd","Old Camp Rd","Old Campbellton Rd","Old Cannon Rd","Old Cape Street",
            "Old Carriage Road","Old Carriage Trl","Old Castle Cir","Old Castlemore Road","Old Cat Rock Rd",
            "Old Cavern Hwy","Old Cemetery Rd","Old Cemetery Road","Old Centre Street","Old Cherry Ave",
            "Old Church Rd","Old City Falls Br","Old Claremont Rd","Old Clave Rd","Old Clinton Rd",
            "Old Clovis Hwy","Old Co 50/15","Old Coach Rd","Old Coal Mine Rd","Old Cobble Dr","Old Coffeetown Rd",
            "Old Cokesbury Rd","Old Colchester Rd","Old Colonial Rd","Old Colony Lane","Old Colony Ln",
            "Old Colony Rd","Old Colony Road","Old Columbiana Rd","Old Columbus Rd","Old Common Road",
            "Old Concord Road","Old Cooks Falls Rd","Old Corn Rd","Old Cottage Ln","Old Coulterville Rd",
            "Old Country Club Rd","Old Country Rd","Old Country Way","Old County Rd 26","Old County Rd 95",
            "Old County Road","Old Creamery Road","Old Creditview Road","Old Creek Cir","Old Croton Rd",
            "Old Crow Trial","Old Crown Rd","Old Dale Rd","Old Dallas Rd","Old Dam Road","Old Deferno Rd",
            "Old Derry Rd","Old Derry Road","Old Devore Ranch Canyon Rd","Old Dexter Hwy","Old Dixiana Rd",
            "Old Dock Road","Old Donner Trl","Old Dorchester Rd","Old Dove Ln","Old Dover Rd","Old Drakesville Rd",
            "Old Drovers Ln","Old Dubois Rd","Old Dunbarton Rd","Old Duncan Grade Rd","Old Durham Rd",
            "Old Dutch Mill Rd","Old Dutch Rd W","Old E Shore","Old E Shore Rd N","Old East Brookfield Road",
            "Old Easton Rd","Old Egg Harbor Rd","Old Elm Street","Old Emigrant Rd","Old Estates Ct",
            "Old Evans Rd","Old Fairy Rd","Old Farm Circle","Old Farm Ct","Old Farm Rd","Old Farm Road",
            "Old Farmers Ln","Old Ferry Rd","Old Ferry Road","Old Finch Avenue","Old Fitch Hill Rd",
            "Old Fitzwilliam Rd","Old Flomaton Rd","Old Fluvanna Ave","Old Forest Hill Road","Old Forest Rd",
            "Old Forest Street","Old Forge Drive","Old Francestown Rd","Old Friars Blvd","Old Frost Ln",
            "Old Ganey Rd","Old Gardner Road","Old Garland Rd","Old Garrison Road","Old Gate Hill Ln",
            "Old Georgia Rd","Old Ghost Rd","Old Gilbertville Road","Old Gladstone Rd","Old Glenn Hwy",
            "Old Gordon Rd","Old Goulais Bay Road","Old Government Rd","Old Green Bank Mill Washington Rd",
            "Old Greenfield Road","Old Gristmill Rd","Old Grove Rd","Old Guejito Rd","Old Ham Rd",
            "Old Hanson Road","Old Harding Hwy","Old Harrison Chapel Rd","Old Harrison Pass Rd",
            "Old Harvard Road","Old Hassler Creek Ln","Old Hayneville Rd","Old Hector St","Old Heritage Way",
            "Old Hickory Ln","Old Hicks Rd","Old High Rd","Old Highland Tpke","Old Highway 31 N",
            "Old Highway 70","Old Highway 87 Ln","Old Highway 93","Old Highway 95","Old Highway 99 S",
            "Old Hollow Tree Rd","Old Homestead Road","Old Homestead Road","Old Hook Rd","Old Hotel Rd",
            "Old Houston Dr","Old Hwy","Old Hwy 14","Old Hwy 20","Old Hwy 28","Old Hwy 299","Old Hwy 301",
            "Old Hwy 395","Old Hwy 5","Old Hwy 6","Old Hwy 61","Old Hwy 68","Old Hwy 7","Old Hwy 71","Old Hwy 8 Rd",
            "Old Hwy 84","Old Hwy 93","Old Hwy 93 (Alt)","Old Hwy 95","Old Hwy O","Old Hwy Rd","Old Hwy1",
            "Old Indian Springs Rd","Old Infirmary Rd","Old Iroquois Trl","Old Jacksonville Rd",
            "Old Jacobs Road","Old Jamestown Bridge","Old Jasper Hwy","Old Jasper Rd","Old Jonesboro Cash Rd",
            "Old Juniper Rd","Old Kennedy Road","Old Kiln Way","Old Kingman Hwy","Old Kingston Road",
            "Old Lagoon Dr","Old Lagunitas Rd","Old Lake Rd","Old Lakeside Rd S","Old Lamont Rd","Old Lamson Rd",
            "Old Lancaster Rd","Old Landmark Ln","Old Lane","Old Lantern Rd","Old Las Vegas Hwy","Old Lee Hwy",
            "Old Leeds Rd","Old Leland Road Rear","Old Leslie Street","Old Lexington Road","Old Lincoln Hwy",
            "Old Locke 3 Rd","Old Log Rd","Old Long Rd","Old Lusk Rd","Old M 28","Old M28","Old Main St",
            "Old Main Street","Old Mammoth Rd","Old Manchester Rd","Old Manitou Rd","Old Manoa Rd",
            "Old Maple Street","Old Marion Rd","Old Marple Rd","Old Maryvale Dr","Old Mashipacong Rd",
            "Old Maumelle Rd","Old Meadow Lane","Old Meadow Ln","Old Meeting House Rd","Old Michigan Ave",
            "Old Middlefield Road","Old Middleton Rd S","Old Middletown Rd","Old Milford Rd","Old Mill Cir",
            "Old Mill Ct","Old Mill Ln","Old Mill Loop","Old Mill Pond Rd","Old Mill Rd","Old Mill Rift Ct",
            "Old Mill Road","Old Mill Roads","Old Mill Run Rd","Old Millers Rd","Old Mine Rd","Old Mission Dr",
            "Old Monmouth Rd","Old Morin Rd","Old Mound Bayou Rd","Old Mt Rose Rd","Old Mtn Tpke Rd",
            "Old Musket Rd","Old Musko Road","Old N Main St","Old N Wildwood Blvd","Old Nashua Rd",
            "Old New St","Old New Utrecht Road","Old Newbridge Rd","Old North Danville Rd","Old North Groton Rd",
            "Old North Main Street","Old North Rd","Old North Road","Old Northfield Rd","Old Oak Ct",
            "Old Oak Lane","Old Oak Rd E","Old Oaks Ln","Old Orangeburg Rd","Old Orchard","Old Orchard Crescent",
            "Old Orchard Dr","Old Orchard Grove","Old Orchard Ln NE","Old Orchard Rd","Old Oregon Trl",
            "Old Organ Main St","Old Ouray Rd","Old Ox Rd","Old Oxford Ave","Old Oxford Road","Old Parish Rd",
            "Old Park Lane","Old Park Rd","Old Park Road","Old Park Sq","Old Peekskill Rd","Old Penn Loop",
            "Old Pennsylvania-Auburn Rd","Old Pesryville Rd","Old Peter","Old Peterbourgh Rd","Old Piedmont Gadsden Hwy",
            "Old Pink Hill Rd","Old Plainfield Pike","Old Plank Ln","Old Plank Rd","Old Pond Rd","Old Portage Road",
            "Old Portage St","Old Post Rd","Old Post Road","Old Priest Grade","Old Prospect Rd","Old Pueblito Rd",
            "Old Pump Station Rd","Old Pumpkin Hill Rd","Old Quarry Ln","Old Quarry Rd","Old Quarry Road",
            "Old Railroad Grd","Old Railroad Trestle","Old Ranch Rd","Old Rd","Old Rd N","Old Rew Coleville Rd",
            "Old Ridge Rd","Old Riley Rd","Old River Dr","Old River Rd","Old River Slough Rd","Old River St",
            "Old Road","Old Road Grade","Old Robinson Rd","Old Rock Meadow Road","Old Rollinsford Rd",
            "Old Round House Rd","Old Route 11","Old Route 17","Old Route 304","Old Route 36","Old Route 55",
            "Old Route 67","Old Route 9","Old Route 9W","Old Rt 110","Old Rt 28","Old Rt 38","Old Rt 50",
            "Old Rte 23","Old Rte 28","Old Rte 44","Old S Broadway","Old Salem","Old Sandy Rd","Old Santa Cruz Hwy",
            "Old School Forest Ln","Old School House Rd","Old School Rd","Old Schoolhouse Ln","Old Schoolhouse Rd",
            "Old Schoolhouse Road","Old Scugog Road","Old Selbysport Rd","Old Seney Rd","Old Senior Rd",
            "Old Sheep Davis Rd","Old Shelter Rd","Old Shelter Valley Road","Old Sherwood Rd","Old Shilo Road",
            "Old Shipyard Lane","Old Shohola Rd","Old Sierra Madre Rd","Old Silver","Old Simco Road",
            "Old Simcoe Road","Old Skyline","Old Som Ln","Old South Ave W","Old South Highland Ave",
            "Old South Meadow Road","Old Spanish Hwy","Old Spanish Trail Hwy","Old Spanish Trail Rd",
            "Old Spanish Trl","Old Spring St NW","Old Springfield Road","Old Spye Rd","Old Squan Rd",
            "Old St Rd","Old St Rte 31 Rd","Old Stable Drive","Old Stable Rd","Old Stage Coach Road",
            "Old Stage Rd","Old Stage Road","Old Stagecoach Rd","Old Stagecoach Run","Old State Hwy 17",
            "Old State Rd 12","Old State Road","Old State Route","Old State Route 10","Old State Route 68",
            "Old State Route 7","Old Station Lane","Old Steubenville Pike","Old Sthwy 52","Old Store Rd",
            "Old Sumerville Creek Rd","Old Summit Rd","Old Surre Lane","Old Swartswood Station Rd",
            "Old Taunton Road","Old Tavern Rd","Old Thompson Street","Old Three Creeks Rd","Old Three Rod Rd",
            "Old Tilbury Rd","Old Toll Rd","Old Toll Road","Old Toms River Rd","Old Tonawanda Creek Rd",
            "Old Town Ct","Old Town Road","Old Town Way","Old Towne","Old Townsend Rd","Old Trace Ct",
            "Old Trail Dr","Old Trails Rd","Old Trillium Lane","Old Trolley Rd","Old Trotting Park Rd",
            "Old Truckee Rd","Old Tuckahoe Rd","Old Turnpike Rd","Old Turnpike Road","Old U S Rd",
            "Old US 31 Hwy","Old US 31 Hwy N","Old US 40","Old US Hwy 1","Old US Hwy 13","Old US Hwy 131",
            "Old US Hwy 31","Old US Hwy 40","Old US Hwy 85","Old Unionville Rd","Old Victor Rd","Old Vienna Rd",
            "Old Village Road","Old Wadley Rd","Old Wagon Rd","Old Wallace Cem Rd","Old Warren Rd",
            "Old Warson Ct","Old Warwick Rd","Old Washoe Dr","Old Waterbury Rd","Old Webster Street",
            "Old Wendell Road","Old West Ave","Old West Chester Pike","Old Westford Road","Old Weston Road",
            "Old Wetumpka Hwy","Old Williams Ln","Old Winchester Road","Old Windmill Trl","Old Windsor Road",
            "Old Wood Rd","Old Wooler Road","Old Yellow Bluff Rd","Old Yonge Street","Old York Mills Road",
            "Old York Rd","Old York Road","Old Yosemite Coulterville Rd","Olde Carriage Lane","Olde Common Dr",
            "Olde Farm Lane","Olde Gate","Olde Lantern Court","Olde Madbury Ln","Olde New Jersey Ave",
            "Olde Orchard Rd","Olde Towne Ct","Olde Towne Trl","Olde Woode Rd","Oldenburg Way","Older Hill Rd",
            "Oldfield Dr","Oldham Rd","Oldham Road","Oldis St","Oldmill Road West Rd","Olds Ave","Oldspanish Trail Rd",
            "Oldstead Ct","Oldstone Ct","Oldtown Ave","Oldtown Cemetery Rd","Oldtown Rd SE","Oldwick Ct",
            "Oldwick Rd","Oldwood Ln","Oldwood Rd","Olea Ct","Oleander Ave","Oleander Ct","Oleander St",
            "Oleander Way","Oleary Place","Olema Valley","Olev Dr","Olga B Ter","Olgas Ct","Olguin Rd","Olin Ave",
            "Olin Dr","Olin Ln","Olinger Rd","Olinghouse Rd","Oliva Dr","Olivarian Rd","Olive","Olive Ave",
            "Olive Avenue","Olive Cir","Olive Ct","Olive Dr","Olive Lane","Olive Ln","Olive Pl","Olive Ranch Way",
            "Olive Rd","Olive St","Olive Street","Olive Tree Ct","Olive View Dr","Olivebranch Ln","Olivedale Dr",
            "Olivegate Ln","Oliver","Oliver Ave","Oliver Court","Oliver Dr","Oliver Ln","Oliver Pl","Oliver Place",
            "Oliver Rd","Oliver Sideroad","Oliver St","Oliver Street","Olivet Ave","Oliveto Rd","Olivewood Dr",
            "Olivewood Drive","Olivia Cir","Olivia Ct","Ollie Dr","Ollie McCullough Rd","Ollieve","Olmeda Ct",
            "Olmo Ct","Olmo Way","Olmstead Dr","Olmstead Pl","Olmstead Rd","Olney Ave","Olney Road","Olneyville Sq",
            "Olsen Dr","Olsen Ln","Olsen Pl NE","Olsen Rd","Olsen Rd NE","Olson Ave","Olson Ct","Olson Dr",
            "Olson St","Olua St","Oly Way","Olympia Ave","Olympia Blvd","Olympia Cir","Olympia Ct","Olympia Dr",
            "Olympia Fields Dr","Olympia Fields Row","Olympia Park Rd","Olympia St","Olympia St SW",
            "Olympia Way","Olympiad Way","Olympic Ave","Olympic Ct","Olympic Dr","Olympic Road","Olympus Avenue",
            "Olympus Dr","Olympus Dr NW","Omaha Dr","Omaha St NE","Omaha St SW","Omaha Union Rd","Omaha Way",
            "Omalley Way","Oman Street","Omar Rd NE","Omar St","Omar Way","Omega Rd E","Omega Rd W","Omega Road",
            "Omelia","Omer Gibson Dr","Omer St","Omira Dr","Omkaha Ave","Omni Ct","Omni Drive","Omo Ranch Rd",
            "On the Common","Ona Ln","Onandaga Street","Onava Ct NE","Onderdonk Lane","One Eye Creek Ct",
            "One Horse Ln","One Hundred Rd","One Mile Rd S","One Oak Ln","One-Hundred Thirty-Fourth St",
            "Oneal Rd","Oneida Ave","Oneida Avenue","Oneida Dr","Oneida Falls Dr","Oneida Lake Dr","Oneida Pl",
            "Oneida Rd","Oneida St","Oneida Street","Oneida Village Drive","Oneil Dr","Oneill Dr","Oneonta St",
            "Oneto Ct","Onge Street","Oniatara Ln","Onieda Avenue","Onion Valley Rd","Only Ct","Onondaga Ave",
            "Onondaga Creek Blvd","Onondaga St","Onrow Tubbs Rd","Onset Avenue","Onslow Court","Onsrud Ln",
            "Ontario Ave","Ontario Ct","Ontario Dr","Ontario Fwy","Ontario Pathways Rail Trail","Ontario Road",
            "Ontario St","Ontario Street","Ontario Street W","Ontio Rd","Onyx Ave","Onyx Cir","Onyx Ct",
            "Onyx Gate","Onyx Rd","Onyx St","Onyx Trl","Onyx Way","Opal Ave","Opal Ave SW","Opal Cir","Opal Ct",
            "Opal Lake Rd","Opal Ln","Opal Pl","Opal Rd","Opal St","Opalite Ln","Opalo Ln","Opalocka Rd","Opatut Ct",
            "Opechee St","Opel St","Open Pond Rd","Open Wood Pond Rd","Openwood Ln","Opera Aly","Opera St",
            "Operetta Way","Ophelia Ave","Ophelia Way","Ophir Hill Ct","Opine Rd","Opinicon Road","Opmar Road",
            "Oppenheim Ct","Opper Ave","Opportunity Rd","Opus Ct","Oquossoc Campground Rd","Oracle Rd",
            "Oran K Gragson Expy","Orange","Orange Aly","Orange Ave","Orange Ave E","Orange Avenue","Orange Blossom Ln",
            "Orange Blossom St","Orange Cir","Orange Cliff Ct","Orange Dr","Orange Fwy","Orange Grove Ln",
            "Orange Grove Rd","Orange Grove Way","Orange Knoll Ave","Orange Ln","Orange Rd","Orange St",
            "Orange Street","Orange Tree Ave","Orange Tree Ln","Orange Way","Orangeave","Orangeburg Rd",
            "Orangeburgh Rd","Orangefair Ave","Orangeglory Dr","Orangestone Way","Orangethorpe Ave",
            "Orangeview Dr","Oraton St","Orba Cir NE","Orbit Dr","Orbit St","Orca Ln","Orcas Ave","Orchard Aly",
            "Orchard Ave","Orchard Beach Rd","Orchard Blossom","Orchard Blvd","Orchard Circle","Orchard Court",
            "Orchard Creek Ln","Orchard Crest Dr","Orchard Ct","Orchard Dr","Orchard Drive","Orchard Glen Dr",
            "Orchard Green","Orchard Haven Ridge","Orchard Heights Drive","Orchard Hill Dr","Orchard Hill Drive",
            "Orchard Hill Ln","Orchard Hill Rd","Orchard Hill Road","Orchard Ln","Orchard Meadow Rd",
            "Orchard Meadows Dr","Orchard Park Cir","Orchard Park Dr","Orchard Park Drive","Orchard Pl",
            "Orchard Place","Orchard Point Road","Orchard Rd","Orchard Ridge Ave","Orchard Ridge Pky",
            "Orchard Road","Orchard Spring Cir NE","Orchard St","Orchard Street","Orchard Street Extension",
            "Orchard Ter","Orchard Terrace Ct","Orchard View Boulevard","Orchard View Dr","Orchard Way",
            "Orchardview Ct","Orchardview Dr","Orchid Ave","Orchid Ct","Orchid Dr","Orchid Hill Pl","Orchid Ln",
            "Orchid Pl","Orchid Ranch Way","Orchid St","Orchid Tree Ln","Orchid Way","Orchidea Plz","Orchis Rd",
            "Orchrad Park Ln","Orcutt Ave","Ord 2278","Ord Mountain Rd","Ordnance Street","Ordner Dr",
            "Ordonez Ct","Ordway Rd","Ordway St","Orebed Road","Oregano Cir","Oregon","Oregon Ave","Oregon Ct",
            "Oregon Dr","Oregon Mountain Rd","Oregon Rd","Oregon St","Oregon Street","Oregon Tpk","Oregon Way",
            "Oren Ct","Orenda Dr","Orfanos Rd","Orford Place","Organ Cres","Orgot Rd","Orhan St","Orick Ave",
            "Orient Ave","Orient St","Oriental Ave","Oriental Boulevard","Oriental Gdns","Oriental St",
            "Oriental Street","Oriental Wash","Origilia Ln","Orillia Ct","Orillia Dr","Orimat Road","Orinda Ct",
            "Oriole Ave","Oriole Dr","Oriole GO Station","Oriole Ln","Oriole Parkway","Oriole Pl","Oriole Road",
            "Oriole St","Oriole Way","Orion Ave","Orion Dr","Orion Ln","Orion Pl","Orion Rd NW","Orion St",
            "Orion Way","Oriskany Rd","Oriskany Street W","Orkney Beach Road","Orla Ct","Orland Street",
            "Orlando Ave","Orlando Dr","Orlando Rd","Orleans Rd","Orleans School Rd","Orleans St","Ormerod Ave",
            "Ormes St","Ormian Dr","Ormond Ave","Ormond Ct","Ormond Pl","Ormont Drive","Ormsby Crescent",
            "Ormsby Ln","Oro Canyon St","Oro Dam Blvd","Oro Grande Dr","Oro St","Oro-Medonte Line 3 Connector",
            "Oro-Medonte Line 5","Oro-Medonte Line 7 Connector","Oro-Medonte Line 7 Overpass",
            "Oro-Medonte Line 9 Connector","Orono Crown Lands Trail","Orono St","Orosco Ave","Orosz Blvd",
            "Oroville St","Oroville-Quincy Hwy","Orpha Rd","Orpha St","Orr Avenue","Orr Dr","Orr Farm Road",
            "Orr Rd","Orr St","Orrick Ave","Orris Rd","Orser Drive","Orshal Rd","Orsi Court","Orsi Drive","Orson Pl",
            "Ortega Ct","Ortega Ct NW","Ortega Ln","Ortega Rd","Orthodox St","Ortiz Dr NE","Ortiz St","Ortley Ave",
            "Ortolan Ln","Orton Ln","Orton Park Road","Orton Rd","Orv Trl","Orval Beckett Ct","Orvietto Ln",
            "Orville Ave","Orville Smith Rd","Osage Ave","Osage Circle","Osage Creek Rd","Osage Dr","Osage Hog Farm Rd",
            "Osage Orange Rd NE","Osage Rd","Osage Ridge Rd","Osage St","Osage Tr NW","Osage Trl","Osaugie Trail",
            "Osborn Blvd","Osborn Dr","Osborn Rd","Osborn St","Osborn Ter","Osborne Ave","Osborne Court",
            "Osborne Pl","Osborne Rd","Osborne Road","Osborne St","Osborne Street","Osborne Ter","Osbourne Ln",
            "Osbourne Road","Osburn Ave","Oscar Ave","Oscar Court","Oscar Dr","Oscar Drive","Oscar Peterson Boulevard",
            "Oscar Price Rd","Oscar Raul Dr","Oscar Rd","Osceola Ravine Way","Osceola Rd","Osceola Road",
            "Osceola Street","Osenda Ct","Osford St","Osgood Ave","Osgood Avenue","Osgood Pl SW","Osgood Place",
            "Osgood Rd","Osgood Road","Osgood St","Oshawa Boulevard N","Oshawa Boulevard S","Oshay Rd",
            "Osino","Oslo Ave","Oslo Dr","Osma Acres Rd","Oso Ave","Oso Grande Ct","Oso Grande Ct NE","Osos Way",
            "Osprey Boulevard","Osprey Ct","Osprey Dr","Osprey Drive","Osprey Lane","Osprey Ln","Osprey Pl",
            "Osprey Point Cir","Osprey St","Ossian Street","Ossipee Lake Rd","Ossipee Mountain Rd",
            "Ostento Way","Ostereh Blvd","Osterman Ave","Ostler Ct","Ostrander Park","Ostrom Ave","Ostronic Dr",
            "Ostronic Pl","Osuna Rd NW","Oswald Pl","Oswegathie Ln","Oswego Ave","Oswego Cir","Oswego Park Road",
            "Oswego Road","Oswego St","Otaw Cir","Otee Circle","Otero Ln","Otero Rd","Otetiana Cv","Othello Lane",
            "Otis Pl","Otis Place","Otis Rd","Otis St","Otis Way","Otley Ct","Otomites St","Otoyokwa Way","Otsego Ave",
            "Otsego County Line Rd","Otsego St","Otseningo St","Otsuago Club Rd","Ott Rd","Ott's Dr",
            "Ottavio Promenade","Ottawa Ave","Ottawa Ct","Ottawa Dr","Ottawa Ln","Ottawa Rd","Ottawa River Rd",
            "Ottawa St","Ottawa Way","Otten Cir","Otter Ave","Otter Creek Rd","Otter Ct","Otter Ct NW","Otter Lake Rd",
            "Otter Lake Road","Otter Ln","Otter Point Cir","Otter Rd","Otter River Road","Otter Road",
            "Otterby Road","Otto Allen Rd","Otto Ave","Otto Crescent","Otto Ln","Otto Maul Rd","Otto St",
            "Otto Way","Ottoboni Dr","Ottogan St","Ottoman Rd","Otty Way","Otwell Rd","Ouachita Rd 82","Ouachita Road 142",
            "Ouachita Road 236","Ouachita Road 25","Ouachita Road 318","Ouachita Road 345","Ouachita Road 382",
            "Ouachita Road 399","Ouachita Road 404","Ouachita Road 407","Ouachita Road 450","Ouachita Road 543",
            "Ouachita Road 67","Ouachita Road 68","Ouachita Road 70","Ouchita Road 507","Ouida Street",
            "Ouleout Rd","Our Children's Hwy","Our House Dam Rd","Our Lady of Lourdes Street","Our Rd",
            "Our St","Our Way","Ouray Rd NW","Ourland Avenue","Ours Trailer Ct","Ousby Rd","Ousterander Dr",
            "Out Back Way","Out of Way Rd","Outer Dr","Outing Club Rd","Outlaw Ln","Outlet Rd","Outlet Road",
            "Outlook Ave","Outlook Ct","Outlook Pl","Outlook Road","Outlook St","Outpost Rd","Outrigger Ct",
            "Outrigger Ln","Outrigger St","Outrigger Way","Outsen Rd","Outward Bound Drive Entrance",
            "Oval Dr","Oval Drive","Ovar Ct","Ovas Ct","Ovel St","Over Brook Ct","Over Brook Run Rd","Over St",
            "Overbaugh Place","Overbeck Ln","Overbrook Ave","Overbrook Dr","Overbrook Pl","Overbrook Place",
            "Overbrook Rd","Overbrook Road","Overcast St","Overheiser Rd","Overhill Dr","Overhill Drive",
            "Overhill Rd","Overholt Road","Overington St","Overland Ave","Overland Ct","Overland Dr",
            "Overland Drive","Overland Rd","Overland St","Overland Trce","Overlea Boulevard","Overlook",
            "Overlook Ave","Overlook Avenue","Overlook Blvd","Overlook Cir","Overlook Ct","Overlook Dr",
            "Overlook Dr NE","Overlook Pl","Overlook Rd","Overlook Road","Overlook Ter","Overlook Terrace",
            "Overlook Trl","Overlook Way","Overpeck Ave","Overpeck Ter","Overton Ave","Overton Crescent",
            "Overton Dr","Overton Pl","Overton Place","Overton Rd","Overview","Overview Cir","Overview Ct",
            "Overview Dr","Oviedo Ct","Ovington Court","Ovington Rd","Owasco Road","Owatonna St","Owego Rd",
            "Owego Street","Owen","Owen Boulevard","Owen Hollow Rd","Owen Pl","Owen Prather Hwy","Owen Road",
            "Owen St","Owena St","Oweno Place","Owens Ave SW","Owens Hill Rd","Owens Ln","Owens Rd","Owens River Rd",
            "Owenwood Drive","Owenyo Lone Pine Rd","Owl Canyon Rd","Owl Clan Ct","Owl Creek Rd","Owl Ct",
            "Owl Hill Pl","Owl Hollow Dr","Owl Ln","Owl Point","Owl Rd","Owl Ridge Drive","Owley Rd","Owlinguish Rd",
            "Owls Ct","Owls Foot Drive","Owls Head Dr","Owls Nest Rd","Owsianko Ln","Ox Pasture","Oxberry Rd",
            "Oxbow Ct","Oxbow Dr","Oxbow Ln","Oxbow Rd","Oxbow Road","Oxford","Oxford Ave","Oxford Ave NW",
            "Oxford Ave SE","Oxford Cir","Oxford Ct","Oxford Dr","Oxford Dr NE","Oxford Landing","Oxford Ln",
            "Oxford Oaks Dr","Oxford Pl","Oxford Rd","Oxford Rd S","Oxford Road","Oxford St","Oxford Street",
            "Oxford Ter","Oxford Valley Rd","Oxford Way","Oxholm Ave","Oxley Aly","Oxley Dr","Oxoboxo Cross Rd",
            "Oxtoby Lane","Oyster Bay Dr","Oyster Creek Dr","Oyster Rd","Ozark Automotive Rd","Ozark Crescent",
            "Ozark Dr","Ozark Rd","Ozark St SE","Ozark Trl","Ozga St","Ozier St","Ozzie Ct","P Cty","P Cypress St",
            "P Harrison Ln","P J -Spur","P M Rd","P Peach Orchard Rd","P Special Service Road","P St",
            "P St N","P St W","P Street","P108B","PAC Way","PATH","PCT","PCT Section C","Paananen Rd","Pabco Rd",
            "Pablo Rd","Pablo St","Paca Ct","Pace Dr","Pace Road","Pacecrest Ct","Paces Trl","Paceview Dr",
            "Pachaug State Forest","Pacheco Pass Hwy","Pacheco St","Pachino Boulevard","Pachuca Ct",
            "Pacific Ave","Pacific Ave SE","Pacific Avenue","Pacific Beach Dr","Pacific Blvd","Pacific Coast Hwy",
            "Pacific Cove Dr","Pacific Crest Nat Sc Trl","Pacific Crest National Scenic Trail",
            "Pacific Crest Trail","Pacific Ct","Pacific Heights Dr","Pacific Hwy","Pacific Pl","Pacific Queen Passage",
            "Pacific St","Pacific Street","Pacific Summit St","Pacific View Dr","Pacific Vista Pl",
            "Pack Trl","Packard Ave","Packard Boulevard","Packard Canyon Rd","Packard Ct","Packard Rd",
            "Packardville Road","Packer Ave","Packer Ct","Packer Way","Packers Bay Rd","Packerville Rd",
            "Packet Lane","Packhorse Rd","Packsaddle Rd E","Paco Ct","Paddington Ln","Paddington Road",
            "Paddle Gate","Paddle Pass","Paddle Road","Paddock Cir","Paddock Lane","Paddock Ln","Paddock Rd",
            "Paddock Road","Paddock Way","Paddy Ln","Padera Ct","Paderewski Ave","Paderewski Rd","Padgetts Rd",
            "Padilla Ln","Padina Cir","Padre Ct","Padre Dr","Padre Juan Canyon Rd","Padre Ln","Padre Serra Ln",
            "Padua Ct","Paducah Rd","Paducah Wells Rd","Paella Ln","Paerdegat 7th St","Pagan St","Page",
            "Page Ave","Page Ct","Page Dr","Page Hill Rd","Page Ln","Page Mill Rd","Page Mill Trail","Page Rd",
            "Page St","Page Street","Page Swamp Rd","Page Way","Pages Aly","Paget Street","Paha Pinto Rd",
            "Pahaska Way","Pahrump Valley Highway","Pahubich Dr","Paige Ave","Paige Street","Pail Factory Road",
            "Paine Ct","Paine Rd","Paine Road","Paine St","Paint Horse Rd","Paint Ln","Paint Water Pl","Paint Way",
            "Painted Hill Rd","Painted Hills Dr","Painted Post Drive","Painted Sands Cir","Painter Hill Rd",
            "Painter St","Paisano Dr","Paisano St NE","Paisley Boulevard East","Paisley Ct","Paisley Lane",
            "Paiute Ave","Paiute Ct","Pajarito Ln","Pajaro Ln","Pajaro Way","Pala Rd","Pala-Temecula Rd",
            "Palace Court","Palace Ct","Palace Drive","Palace Pkwy","Palace Street","Palace View Dr",
            "Palace Way","Paladino Avenue","Palamino Dr","Palamos Pl","Palapeta Ln","Palco Rd","Pale Star Ct",
            "Palegold St","Palencia Ave","Palermo Ct","Palermo Dr","Palermo Rd","Palermo Way","Palestine Rd",
            "Palfrey Street","Palimino Rd","Palin Ln","Palis Crescent","Palisade Ave","Palisade Cir",
            "Palisade Dr","Palisade Pl","Palisade Plz","Palisade Way","Palisade's Way","Palisades Ave",
            "Palisades Center Dr","Palisades Ct","Palisades Dr","Palisades Interstate Parkway",
            "Palisades Ln","Palisander Avenue","Paliser Crescent S","Palleschi Drive","Pallis Rd",
            "Palm","Palm Ave","Palm Beach Dr","Palm Blvd","Palm Cir","Palm Court Dr","Palm Ct","Palm Desert Dr",
            "Palm Dr","Palm Ln","Palm Meadows Dr","Palm Ranch St","Palm Rd","Palm Spring Ct","Palm Springs Ct",
            "Palm Springs Dr","Palm St","Palm Street","Palm Ter","Palm Tree Ln","Palm View Rd","Palm View St",
            "Palma Pl","Palma Plz","Palma Vista Ave","Palma de Pina","Palmac St","Palmacia Dr","Palmas Dr",
            "Palmcrest Rd","Palmcroft Rd","Palmdale St","Palmelto Ct","Palmer","Palmer Ave","Palmer Avenue",
            "Palmer Cir","Palmer Court","Palmer Ct","Palmer Dr","Palmer Farm Dr","Palmer Hill Rd","Palmer Ln",
            "Palmer Pl","Palmer Rd","Palmer Rd N","Palmer Road","Palmer Sq E","Palmer St","Palmer Street",
            "Palmer Way","Palmera Ct","Palmerson Dr","Palmerston Avenue","Palmerston Crescent","Palmerston Road",
            "Palmetto Dr","Palmetto Dr SE","Palmetto Ln","Palmetto St","Palmita Pl","Palms Center Dr",
            "Palmtree Crescent","Palmvalley Drive","Palmwood Ave","Palmwood Cir","Palmwood Dr","Palmyra Bridge Blvd",
            "Palo Alto Ave","Palo Alto Dr","Palo Comado Canyon Rd","Palo Verde","Palo Verde Cir","Palo Verde Dr",
            "Palo Verde Dr NW","Palo Verde Pl","Palo Verde Plz","Palo Verde Rd","Palo Verde St","Palo Verde Way",
            "Paloma Ave","Paloma Blanca Dr","Paloma Ct","Paloma Dr","Paloma Rd","Paloma Senda","Paloma Way",
            "Palomar Ave","Palomar Ct","Palomar Divide Rd","Palomar St","Palomas Dr NE","Palomas Dr SE",
            "Palombi Ct","Palomina Rd","Palomino Ct","Palomino Dr","Palomino Drive","Palomino Rd","Palomira Ct",
            "Palomitas Cir","Palora St","Paloran Ct","Palos Pl","Palos Verdes Ct","Palos Verdes Dr S",
            "Palowalla Rd","Palsa Ave","Pam Ct","Pam Drive","Pam Ln","Pam St","Pam's Ct","Pamela Ct","Pamela Dr",
            "Pamela Lane","Pamela Ln","Pamela Pl","Pamela Way","Pamela's Ter","Pamelia Ave","Pammer Rd",
            "Pammy Way","Pampa Peak","Pampas Ln","Pampas Rd","Pamphylia Ave","Panama Court","Panama Ct",
            "Panama Dr","Panama Mall","Panama St","Panaway Ct","Panaway Dr","Panay St","Pancake Hill Rd",
            "Pancake Lane","Pandolfi Ave","Pandy Lane","Pane Rd","Panel Ln","Panesi Ave","Pangborn Ln","Pangborne Ln",
            "Panguitch Dr","Panhandle Ct","Panhandle Pl","Pankow Ln","Panoche Access Rd","Panoche Rd",
            "Panola Ave","Panola Co","Panorama","Panorama Cir","Panorama Court","Panorama Ct","Panorama Dr",
            "Panorama Trail","Panorama Trl","Panoramic Dr","Pansy Ave","Pansy Dr","Pansy Ln","Pansy St",
            "Pantalis Ct","Panther Gap Rd","Panther Lake Campground Rd","Panther Path","Panther Point",
            "Panther Ridge Rd","Pantomine Boulevard","Pantry Road","Paocde W","Papago Ct","Papago Rd",
            "Papago St","Papakating Rd","Pape Avenue","Pape Bus Terminal","Paper Mill Road","Paper Rd",
            "Paper Town Road","Papetti","Papoose Runway","Papoose Trl","Papps Dr","Pappy's Ln","Paquette Dr",
            "Paquette Rd","Paquita St","Par 4 Dr","Par Ave","Par Avenue","Parada Loop","Parade Ground Rd",
            "Parade Hill Rd","Parade Ln","Parade Rd","Parade Road","Paradelle Crescent","Paradis Circle",
            "Paradise Ave","Paradise Boulevard","Paradise Cir","Paradise Ct SE","Paradise Dr","Paradise Hills Dr",
            "Paradise Lane","Paradise Lane Extension","Paradise Ln","Paradise Oaks","Paradise Pl",
            "Paradise Point","Paradise Point Dr","Paradise Ranchos Dr","Paradise Rd","Paradise Ridge Rd",
            "Paradise Road","Paradise St SE","Paradise Valley Rd","Paradise Way","Paragon Dr","Paragon Drive",
            "Paragon Place","Paraguay Ct","Paraiso Ave","Paraiso Pl","Paraiso St","Paraiso Way","Paraisol Pl",
            "Parakeet Rd","Parallel St","Paramore Court","Paramore Hill Rd","Paramount Dr","Paramount Drive",
            "Paramus Rd","Parasail Point Ave","Parasol Dr","Parc Niagara Park","Parcells Dr","Pardall Rd",
            "Pardall Tunnel","Pardee Ave","Pardee Ct","Pardee Ln","Pardee Pl","Pardee Rd Spur","Pardeeville Rd",
            "Parducci Dr","Pardue Rd","Pardun Rd","Pare Avenue","Parent Ave","Parham St","Parian Ave","Paridise Pl",
            "Paris Ave","Paris Dr","Paris Ln","Paris Street","Paris Valley Rd","Paris Way","Parise Dr","Parisen Ave",
            "Parish Lane","Parish Ln","Parisian Crescent","Parisian Dr","Parisian Ln","Park","Park 5 Rd",
            "Park Aly","Park Ave","Park Ave S","Park Avenue","Park Avenue Dr","Park Avenue E","Park Avenue W",
            "Park Blvd","Park Boulevard","Park Campground Rd","Park Cir","Park Circle","Park Circle Dr",
            "Park City Dr","Park Common Boulevard","Park Creek","Park Crescent","Park Crest Village",
            "Park Ct","Park Dr","Park Dr Clear Lake","Park Drive","Park E Dr","Park East Dr","Park Elm Ln",
            "Park Entrance Rd","Park Forest Ct","Park Forest Dr","Park Forest Road 805","Park Forest Trce",
            "Park Glen Drive","Park Groton Pl","Park Haven Ave","Park Heights Ct","Park Hill","Park Hill Avenue",
            "Park Hill Cir","Park Hill Ct","Park Hill Dr","Park Hill Lane","Park Hill St","Park Home Avenue",
            "Park Knoll Dr","Park Lane","Park Lane Circle","Park Lane Ct","Park Lane Drive","Park Ln",
            "Park Ln S","Park Meadows Dr","Park Melinda","Park Moabi Rd","Park Oak","Park Pl","Park Place",
            "Park Place Ave","Park Place Blvd","Park Place Condominiums","Park Place Ct","Park Place Dr",
            "Park Place Tr","Park Point Drive","Park Rd","Park Ridge Ct","Park Road","Park Road N","Park Roso",
            "Park Row","Park Service Road","Park Sheridan Ln","Park Sierra Dr","Park Slope","Park Slope Ter",
            "Park Sq","Park St","Park St W","Park Street","Park Street S","Park Street W","Park Ter","Park Terrace",
            "Park Terrace West","Park Towne Pl","Park Trail","Park Vallei Ln","Park View Dr","Park Vista",
            "Park Vly Dr","Park Way","Park West Ct","Parkcenter Ln","Parkchester Cir","Parkcrest Cir",
            "Parkdale Rd","Parkdale Road","Parke Ave","Parke Rd","Parkedge Ct","Parker - Smith Hill Rd",
            "Parker Ave","Parker Avenue","Parker Blvd","Parker Camp Road","Parker Court","Parker Ct",
            "Parker Dr","Parker Hill Avenue","Parker Hill Rd","Parker Ln","Parker Pl","Parker Ranch Trail - Fremont Older",
            "Parker Rd","Parker St","Parker Street","Parker Way","Parker's Lane","Parkers Glen Rd","Parkers Pasture",
            "Parkers Point Blvd","Parkersburg Tpke","Parkersville Ln","Parkette Place","Parkey Rd",
            "Parkfield Avenue","Parkfield Ct","Parkfield-Coalinga Rd","Parkhaven Dr","Parkhill Ln",
            "Parkhill Rd","Parkhill Road","Parkhill Road W","Parkhurst Drive","Parkhurst Pl","Parkhurst St",
            "Parking Row","Parkins Drive","Parkinson Ave","Parkland Ave","Parkland Avenue","Parkland Dr",
            "Parkland Hills Blvd","Parkland Plz","Parkland Rd","Parklyn Ct","Parkman Avenue","Parknorth Dr",
            "Parkplace Circle","Parkplace Dr","Parkridge Cir","Parkridge Dr","Parkridge Ln","Parkrose Rd",
            "Parks Ave","Parks Dr","Parks Ln","Parks Rd","Parkside Ave","Parkside Ave N","Parkside Avenue",
            "Parkside Blvd","Parkside Cir","Parkside Crescent","Parkside Dr","Parkside Drive","Parkside Ln",
            "Parkside Street","Parkton Avenue","Parktree Place NE","Parkvale Ct","Parkview Ave","Parkview Ave NW",
            "Parkview Avenue","Parkview Cir","Parkview Court","Parkview Ct","Parkview Dr","Parkview Drive",
            "Parkview Ln","Parkview Place","Parkview Rd","Parkview Ter","Parkville Rd","Parkway","Parkway Avenue",
            "Parkway Blvd","Parkway Blvd SW","Parkway Court","Parkway Dr","Parkway Dr N","Parkway Ln",
            "Parkway Pl","Parkway Rd","Parkway Trl","Parkwood Ave","Parkwood Court","Parkwood Dr","Parkwood Dr E",
            "Parkwood Drive","Parkwood Road","Parkwynne Rd","Parlanti Ln","Parliament Hill Place",
            "Parliament Street","Parlin Ln","Parma Ct","Parma St","Parma Way","Parmbelle Crescent","Parmelee Ave",
            "Parmelee Pl","Parmenter Place","Parmerton Dr","Parmley Pl","Parmly Pl","Parnell Crescent",
            "Parnell Rd","Parnelli Dr SW","Paros Rd","Paroubek St","Parque Rd","Parr Trail","Parratt Road",
            "Parrent Rd","Parrish Rd","Parrish St","Parron Ave","Parrot Cv","Parrot Way","Parrots Ferry Rd",
            "Parrott Drive","Parry Ave","Parry Dr","Parry Hollow Rd","Parry Rd","Parry St","Parsells Ct",
            "Parsler Pl","Parsnip Ln","Parson Dr","Parson Hills Rd","Parson Rd","Parson St","Parsons Court",
            "Parsons Ct","Parsons Lane","Parsons Ln","Parsons Path","Parsons Rd","Parsons Road","Parsons St",
            "Parsons Way","Partition Pl","Partition Rd","Partlow Ct","Partridge Ave","Partridge Dr","Partridge Hill Rd",
            "Partridge Hill Road","Partridge Ln","Partridge Place","Partridge Rd","Partridge Run",
            "Partridge Run St","Partridge St","Partridge St NW","Partridge Street","Partridge Trl",
            "Partridge Way","Partridgeberry Way","Partridgeville Road","Parvin St","Parwood Trl","Pasack Ave",
            "Pasadena Drive","Pasadena Freeway","Pasadena St","Pasala Ct","Pascack Ave","Paschall Ave",
            "Paschall Rd","Pasciak Rd","Paseo Allegre","Paseo Antiguo","Paseo Arroyo","Paseo Casino",
            "Paseo Cir","Paseo Circulo W","Paseo Corto","Paseo Encantada","Paseo Entrada","Paseo Espinazo",
            "Paseo Feliz","Paseo Granada","Paseo Grande","Paseo Largavista","Paseo Lindero","Paseo Pacifico",
            "Paseo Rayo del Sol","Paseo Rico","Paseo Rio Moreno","Paseo Sin Nombre","Paseo Talavera",
            "Paseo Unido St","Paseo Venezia","Paseo Verano","Paseo Village","Paseo Yolo","Paseo de Canto",
            "Paseo de Chilli","Paseo de Las Lomas Altas","Paseo de Los Portales Rd","Paseo de Los Robles Rd",
            "Paseo de San Antonio Rd","Paseo de Vaca","Paseo de Vega","Paseo de la Raza","Paseo del Norte NE",
            "Paseo del Norte Blvd NE","Paseo del Norte Boulevard","Paseo del Oro","Paseo del Sol",
            "Paseo del Tesoro","Paseo la Paz","Pasilla Rd NE","Paskenta Rd","Paso Ave","Paso Fino Pl SW",
            "Paso Pass Rd","Paso Robles Ct","Paso Tiempo Ln","Paso Way","Pass Rd","Passa Tempo Dr","Passado Ct",
            "Passaic Ave","Passaic County 648","Passaic County 652","Passaic St","Passaro Drive","Passeggi Ct",
            "Passenger Pick-Up/Drop Off, Taxis","Passenger Pick-Up/Drop-Off","Passiac Rd","Passmore Avenue",
            "Passons Blvd","Passumpsic Ave","Passyunk Ave","Pastel Pl","Pastiche Dr SE","Pastime Pl",
            "Pastoral Ct","Pasture Ct","Pasture Rd","Pat Ave","Pat Brooks Terrace","Pat Smith Ln","PatMcGeeTrail",
            "Patato Farm Rd","Patch Rd","Patchen Hollow Rd","Patches Pond Lane","Pate Dr","Pate Rd","Patel Pl",
            "Paterna Ln","Paterson Ave","Paterson Hamburg Tpke","Paterson Rd","Paterson St","Path Finder Ct",
            "Path No 39","Pathlane Road","Patience Ct NW","Patience Lane","Patillo Rd","Patina Drive",
            "Patina Rd","Patio Ave","Patio Dr","Patio Sierra","Patire Pl","Patlen Dr","Patman Grade Rd",
            "Pato Ln","Paton Road","Paton Terrace","Patos Pl","Patrica Ln","Patrice Dr.","Patrice Lane",
            "Patricia Ave","Patricia Avenue","Patricia Ct","Patricia Dr","Patricia Drive","Patricia Ln",
            "Patricia Lynn Ln","Patrician Court","Patrician Ct","Patricias Way","Patrick Cir","Patrick Dr",
            "Patrick Henry Pl","Patrick Ln","Patrick Pl","Patrick Pl NW","Patrick Rd","Patrick Road",
            "Patrick Sq","Patrick St","Patrick Street","Patriot Dr","Patriot Fwy","Patriot Fwy; United States Highway 54",
            "Patriot Ln","Patriot Park Pl","Patriot Pky","Patriots Ln","Patriots Road","Patriots Way",
            "Patrol Rd","Patsy St","Patt Rd","Patten Crescent","Patten Lane","Patten Ln","Patten Pl","Patten Street",
            "Patterson","Patterson Ave","Patterson Brook Rd","Patterson Creek Rd","Patterson Ct","Patterson Dr",
            "Patterson Ln","Patterson Rd","Patterson Road","Patterson St","Patterson Street","Pattersons Corners Road",
            "Patti Ann Dr","Patti Cake Ln","Patti Ct","Patti Ln","Pattison Ave","Pattison Court","Patton Ave",
            "Patton Cir","Patton Dr","Patton Hill Rd","Patton Ln","Patton Pl","Patton Rd","Patton Road",
            "Patton St","Pattonwood Dr","Patty","Patty Bowker Rd","Patty Ct","Patty Ln","Patullo Avenue",
            "Pauchaug Brook Road","Paudash Street","Pauhaska Rd","Paul Ave","Paul Co Mar Way","Paul Ct",
            "Paul David Street","Paul Drive","Paul Foster Road","Paul Jones Rd","Paul Joseph Lane",
            "Paul Kane Rd","Paul Kohner","Paul McMillan Dr","Paul R Lowery Rd","Paul Rd","Paul Road",
            "Paul Robeson Ct","Paul St","Paul Street","Paula Dr","Paula St","Paulding Pl","Paulette Dr",
            "Paulette Lane","Pauline Ave","Pauline Ct","Pauline Dr","Pauline Pl","Paulinskill Lake Rd",
            "Paull Street","Paulmier Pl","Paulo Ave","Paulsen Dr","Paulsen Ln","Paulson Rd","Pauma Ct","Paupack Dr",
            "Pavane Linkway","Paved Path","Pavilion Ave","Pavilion Way","Pavillion Ct","Pavillion Dr",
            "Pavonia Ave","Pavonia Ct","Pawn Dr","Pawnee Ave","Pawnee Ln","Pawnee Rd","Pawnee Road","Pawnee St",
            "Pawsey Street","Paxinosa Ave","Paxon Pl","Paxson Ave","Paxton Ct","Paxton St","Paxton Street",
            "Pay Roll Ave","Payan Rd","Paye Rd","Payette Dr","Paymogo Ct","Payne Crescent","Payne Ct","Payne Ct NE",
            "Payne Dr","Payne Glover Ln","Payne Lane Trl","Payne Ln","Payne Pl","Payne St","Paynes Creek Rd",
            "Paynter Dr","Payson Ave","Payson Ct","Payson Lane","Payson Ln","Payzac Avenue","Pea Creek Rd",
            "Pea Farm Rd","Pea Ridge Rd","Peabody Rd","Peabody Road","Peacan St","Peace Ct","Peace Lane",
            "Peace Road","Peace St","Peaceful Desert Ct","Peaceful Dr","Peaceful Prairie Ct","Peaceful Valley Ranch Rd",
            "Peaceful Valley Rd","Peach","Peach Aly","Peach Ave","Peach Ave NE","Peach Blossom Ave","Peach Blossom Dr",
            "Peach Blossom Ln","Peach Ct","Peach Dr","Peach Hill Court","Peach Ln","Peach Ln SW","Peach Orchard Point",
            "Peach Orchard Rd","Peach St","Peach Ter","Peach Tree","Peach Tree Ln","Peach Tree Rd","Peach Tree St",
            "Peachcrest Court","Peachtree Cir","Peachtree Dr","Peachtree Ln","Peachtree Park","Peachtree Rd",
            "Peachtree St","Peachwood Ct","Peacock Avenue","Peacock Cir","Peacock Ct","Peacock Dr","Peacock Hill Rd",
            "Peacock Ln","Peacock Loop","Peacock Rd","Peacock St","Peacock Way","Peak Ave","Peak Ln","Peak Point Boulevard",
            "Peak Rd","Peak St","Peak Trl","Peake Mountain Rd","Peaked Hill Rd","Peakwood Ct","Peanut Brittle Dr",
            "Pear Ave","Pear Blossom Ln","Pear Cir","Pear Ct","Pear Lake Trail","Pear Pl","Pear Rd","Pear St",
            "Pear Tree Cir","Pear Tree Mews","Pear Tree Road","Pearce Drive","Pearce St","Peardale Dr",
            "Peardale Ln","Pearl","Pearl Ave","Pearl Avenue","Pearl Blvd","Pearl Ct","Pearl Dr","Pearl Gate Court",
            "Pearl Harbor Memorial Turnpike Extension","Pearl Island Dr","Pearl Ln","Pearl Pl",
            "Pearl Rd","Pearl Springs Ave","Pearl St","Pearl St SW","Pearl Street","Pearl Street W","Pearl Terrace",
            "Pearldale Avenue","Pearly Pond Way","Pearne Ct","Pearson Ave","Pearson Avenue","Pearson Cir",
            "Pearson Ct","Pearson Rd","Pearson St","Pearson Street","Pearwood Ln","Pearwood St","Peas Eddy Br",
            "Peasant Valley Rd","Pease Ave","Pease Hill Rd","Pease Street","Peaslee Ct","Peat Bed Rd",
            "Peat Street","Peavin Falls Rd","Peavine Creek Cv","Peavine Rd","Peavine Ridge Rd","Peavy Rd",
            "Pebble Bch","Pebble Beach","Pebble Beach Blvd","Pebble Beach Dr","Pebble Beach Ln","Pebble Creek Dr",
            "Pebble Creek Ln","Pebble Ct","Pebble Dr","Pebble Hill Cir","Pebble Hill Rd S","Pebble Hills Bl",
            "Pebble Ln","Pebble Pl","Pebble River Ct","Pebble Shore Ct","Pebble Shore Dr","Pebblebeach Drive",
            "Pebblebrook Ln","Pebblehill Square","Pebbles St","Pebblestone Ave NW","Pebbleview Dr",
            "Pecan Ave","Pecan Ave SW","Pecan Ct","Pecan Dr","Pecan Drive","Pecan Ln","Pecan St","Pecan Valley Pl",
            "Peck Ave","Peck Brothers Road","Peck Dr","Peck Rd","Peck St","Peck Street","Peck Wadsworth Rd",
            "Peckham St","Pecks Ln","Pecks Valley Rd","Pecor St","Pecos Cir","Pecos Dr","Pecos Hwy","Pecwan Creek Rd",
            "Peddlers Ln","Pedestrian Wkwy","Pedra Dr","Pedretti Rd","Pedrick St","Pedricktown Center Sq Rd",
            "Pedrini Ter","Pedro St","Pee Wee Run Rd","Peek A Boo Rd","Peekay Dr","Peeks Hill Rd","Peel Dock Rd",
            "Peel Mill Cr Rd","Peel St","Peel Street","Peele Boulevard","Peeler Ave","Peels Lane","Peerless St",
            "Peevers Crescent","Peewee Rd","Pefferlaw Circle","Pefferlaw Road","Pega Rd","Pegasus Dr",
            "Pegasus Rd","Pegasus St","Peggy Ave","Peggy Ct","Peggy Ln","Peggys Ln","Peirce Road","Peladeau Street",
            "Pele St","Pelham Ave","Pelham Ct","Pelham Dr","Pelham Finale","Pelham Pky","Pelham Pl","Pelham Rd",
            "Pelham Street","Pelham Terrace","Pelham Walk","Pelican Breeze Ct","Pelican Ct","Pelican Lane",
            "Pelican Ln","Pelican Plz","Pelican Ranch Rd","Pelican Rd","Pelican Way","Pelick Pl","Pella Pl",
            "Pellack Dr","Pellatt Grove","Pelle Cir","Pelletier Court","Pellettown Rd","Pellicano Dr",
            "Pellier Ct","Pellizzari Pl","Peltier Ave","Peltier Avenue","Pelto Ct","Pem Lane","Pemberton Pl",
            "Pemberton St","Pembroke Ave","Pembroke Cir","Pembroke Ct","Pembroke Drive","Pembroke Ln",
            "Pembroke Pl","Pembroke Rd","Pembroke Street","Pembroke Trl","Pembrook Ave","Pembrook Dr",
            "Pemi River Heights","Pemican Court","Pen Hollow Ct","Pen Ln","Penacook Rd","Penacook Street",
            "Penarth Rd","Penasco St","Penbridge Dr","Penbrook St","Pendale Ct","Pendell Hill","Pender Ct",
            "Pender Rd","Pender Street","Pendergast Rd","Pendleton Hill Rd","Pendleton Lane","Pendleton Pl",
            "Pendleton St","Pendlewood Dr","Pendley Creek Rd","Pendola Dr","Pendrith Street","Penetang Street",
            "Penfield Ln","Penfield Rd","Pengel Ln","Pengiun Ct","Penguin Ct","Penguin Dr","Penguin Park",
            "Penhallow Road","Penhollow Ln","Peniel Road","Peninsula Ave","Peninsula Blvd","Peninsula Dr",
            "Peninsula Ln","Peninsula Point Road","Peninsula Road","Penjamo Dr","Penland Rd","Penn Ave",
            "Penn Blvd","Penn Central Railroad","Penn Dr","Penn Ln","Penn Mar Ave","Penn Oak Cir","Penn Road",
            "Penn St","Penn Valley Rd","Penna Ave","Penndarvis Ln W","Pennell Ct","Penner Dr","Penner St",
            "Penniman Ave","Penniman Rd","Penniman Street","Pennington - Rocky Hill Rd","Pennington Ave",
            "Pennington Ln","Pennington Pl SW","Pennington Rd","Pennington St","Pennrock Rd","Penns Ave",
            "Penns Gate Blvd","Penns Grove Auburn Rd","Penns Hill Road","Pennsbury Lane","Pennsbury Way",
            "Pennsgrove St","Pennswood Dr","Pennswood Rd","Pennsyl Point","Pennsylvania Ave","Pennsylvania Avenue",
            "Pennsylvania Dr","Pennsylvania Gulch Rd","Pennsylvania Railroad Ave","Pennsylvania Tpke NE",
            "Pennsylvania Turnpike","Pennsylvania Way","Penntroyal Ln","Pennwood Pl","Penny Ave","Penny Bank",
            "Penny Lane","Penny Ln","Penny Marie Ave","Penny Road","Penny Royal St","Penny Settlement Rd",
            "Penny St","Penny St SE","Pennycress Drive","Pennyhill Drive","Pennyroyal Ln","Penobscot Rd",
            "Penobscot St","Penon Blanco Lookout Rd","Penquin Dr","Penrith Way","Penrod Dr","Penrod Way",
            "Penrose Ave","Penrose Ct","Penrose Street","Penryn Rd","Pensacola Ct","Pensacola Pl","Penston Rd",
            "Penta Dr","Pentagon Boulevard","Pentland Dr","Penton St","Pentridge St","Pentucket Street",
            "Penwell Rd","Penwood Rd","Peon Ln","Peony Cir","Peony Ct","Peoples Rd NE","Peoples Road","Pepe Ct",
            "Pepin Dr","Pepin Rd","Pepo Dr","Pepper Ln","Pepper St","Pepper Tree Ct","Pepper Tree Drive",
            "Pepper Tree Ln","Pepper Tree Rd","Pepperbrooke Ln","Pepperbush Ct","Pepperbush Ln","Peppercorn Lane",
            "Pepperell Road","Peppergrass Dr S","Pepperidge Rd","Pepperidge Tree Ter","Peppermint Dr",
            "Peppermint Heights Rd","Peppermint Ln","Peppertree Ct S","Peppertree Dr","Peppertree Pl",
            "Peppertree St S","Pepperweed Rd","Pepperwood Ct","Pepperwood Dr","Pepperwood Ln","Pepperwood Springs Rd",
            "Peppy Pl","Pequannock St","Pequest Rd","Pequot Court","Pequot Lane","Pequot Road","Pequot St",
            "Pera Cir","Peral Ln","Peral Way","Peralta Ave","Peralta Canyon Trail","Peralta Ct","Peralta Pl",
            "Perata Ct","Percell Ln","Perch Dr","Perch Point","Perch Road","Perch St","Percha St","Perchard Ave",
            "Percheron Rd","Perciful St","Percival Ct","Percy Ave","Percy Blew Rd","Percy Crescent","Percy Nero Rd",
            "Percy St","Percy Street","Percy Way","Perdew Ave","Perdido Cir","Perdido Ct","Perdido Gate Dr",
            "Perdido St","Perdiz St","Perdue Hill Rd","Pere Marquette Dr","Pere Marquette Rail Trail",
            "Peregrine","Peregrine Grove","Peregrine Lane","Perennial Lane","Perennial Pl","Perez Pl",
            "Perezoso Ct","Perfectus Drive","Performance Dr","Perham Rd","Peri Pl","Perico Rd","Peridot Rd",
            "Peridot St","Perimeter Dr","Perimeter Rd","Perimeter Road N","Perimeter Road S","Perina Blvd",
            "Perivale Road","Periwinkle Ln","Perk Pl","Perkins Ave","Perkins Dr","Perkins Ln","Perkins Memorial Dr",
            "Perkins Pl","Perkins Rd","Perkins St","Perkins Street","Perkins Way","Perley Ave","Perley Avenue",
            "Perley Place","Perlite Rd","Perlite Way","Perlman Pl","Perma Ct","Permele Cir","Permfield Path",
            "Permission Tree Rd","Pernell Dr","Perran Drive","Perraud Dr","Perrin Avenue","Perrin Rd",
            "Perrine Ave","Perrine Ct","Perrott Ave","Perrugia Ln","Perry Ave","Perry Avenue","Perry Crescent",
            "Perry Ct","Perry Dr","Perry Hill Rd","Perry Hill Road","Perry Ln","Perry Meadow Rd","Perry Pl",
            "Perry Pond Rd","Perry Rd","Perry Ridge","Perry Road","Perry St","Perry Street","Perry Taylor Road",
            "Perrys Well Rd","Perryville Dr","Perryville Rd","Pershing Ave","Pershing Dr","Pershing Ln",
            "Pershing Loop","Pershing Pl","Pershing Road","Pershing St","Persimmon Ct","Persimmon Ln",
            "Persimmon St","Persimon St","Persinko St","Persons Rd","Persons St","Perth Ln","Perth Pl","Perth Road",
            "Perth St","Perthshire Street","Peru Ct","Peru Road","Peryl Road","Pescadero Creek Rd","Pescadero Ter",
            "Pescara St","Pesco Ct","Peshawar Avenue","Peshtigo Preserve Rd","Pest Rd","Pesula Rd","Pet Rock Rd",
            "Petalo Dr","Petaluma Boulevard South","Petaluma Ct","Petaluma Dr NE","Pete's Ln","Pete's Pass",
            "Peter Avenue","Peter Cheeseman Rd","Peter Dr","Peter Lynas Ct","Peter Point Rd","Peter Rupert Avenue",
            "Peter Street N","Peter Street S","Peter White Rd","Peterboro Rd","Peterborough Avenue",
            "Peterman Rd","Petermar Drive","Peters Cave Rd","Peters Dam Fire Road","Peters Dr","Peters Ln",
            "Peters Pike Road","Peters Pl","Peters Run Rd","Peters Street","Petersburg Rd","Petersburg Road",
            "Petersen Ln","Peterson Ave","Peterson Cir","Peterson Dr","Peterson Hollow Rd","Peterson Ln",
            "Peterson Rd","Peterson Ridge","Peterson Road","Peterson St","Peterson Street","Petes Blvd",
            "Peth Rd","Petit Ave","Petitt Ave","Petrel","Petrella Cir","Petricone Dr","Petricone Rd","Petrie Street",
            "Petrie Way","Petrified Forest Dr","Petro Rd","Petroglyph Rd","Petroleum Center Rd","Petronella Parkway",
            "Petronella Place","Pettee Brook Rd","Pettes Blvd","Pettet Drive","Petticoat Hill Road",
            "Petticoat Ln","Pettie Rd","Pettigrew Court","Pettigrew Place","Pettingill Rd","Pettinotti Rd",
            "Pettit Avenue","Pettit Ln","Pettit Pl","Pettit St","Petts Dr","Petty Ave","Petty Ln","Petty Pl",
            "Petty Rd","Petty St","Pettyboro Rd","Pettys Rd","Petunia Place","Petworth Road","Peublo Park Rd",
            "Peutz Valley Rd","Pevehouse Rd","Pevsner Rd","Peyho Ranch Rd","Peyton Pl","Peyton St","Pezzini Ln",
            "Pfc Dorcey Ct","Pfeffers Ln","Pfeiffer Big Sur","Pfeiffer Ranch Ct","Pfeiffer Rd","Pfersick Road",
            "Pg&E Station Rd","Phair Road","Phalanx Rd","Phares Ln","Pharmacy Avenue","Pheasant Ct","Pheasant Dr",
            "Pheasant Grove Ln","Pheasant Lane","Pheasant Ln","Pheasant Meadow Dr","Pheasant Rd","Pheasant Ridge Ave SE",
            "Pheasant Road","Pheasant Run","Pheasant Run Dr","Pheasant Run Ln","Pheasant Run Rd","Pheasant Run St",
            "Pheasant Run Way","Phelps Ave","Phelps Avenue","Phelps Dr","Phelps Pl","Phelps Place","Phelps Rd",
            "Phelps St","Phelps Street","Phenix Ave","Pheonix St","Pherdun Rd","Pherinwoods Ct","Phila Ave",
            "Philadelphia Ave","Philadelphia Blvd","Philadelphia Pike","Philadelphia Rd","Philan Cir",
            "Philan St","Philbrook Rd","Philip Road","Philips Ave","Philips Court","Philips Ct","Philips St",
            "Phillip Ave","Phillip Ct","Phillip Ln","Phillip Murray Avenue","Phillip Rd","Phillip St",
            "Phillip St. E.","Phillippi Ave","Phillips","Phillips Ave","Phillips Avenue","Phillips Beach Avenue",
            "Phillips Blvd","Phillips Brook Circle","Phillips Brook Rd","Phillips Co 275","Phillips Dr",
            "Phillips Ranch Rd","Phillips Rd","Phillips Road 211","Phillips Road 212","Phillips Road 223",
            "Phillips Road 225","Phillips Road 338","Phillips Road 415","Phillips Road 438","Phillips Road 462",
            "Phillips St","Phillips Street","Phillipstown Ln","Philmar Ave","Philmont Ave","Philo Greenwood Rd",
            "Phin Avenue","Phinney Pl","Phinney Road","Phipps St","Phlox Ter","Phoebe Ct","Phoebe Dr","Phoenix Ave",
            "Phoenix Ct","Phoenix Dr","Phoenix Lake Rd","Phoenix Way","Phone Cable Rd","Phone Line Rd",
            "Phullips Dr","Phyl Ct","Phyllis Ave","Phyllis Avenue","Phyllis Cir","Phyllis Dr","Phyllis Pl",
            "Phyllis St","Phyllis Way","Pia Mesa Rd","Piacenzia Ave","Piaget Ave","Pialorsi Ct","Piave Ave",
            "Picacho Rd","Picardo Ranch","Picasso Ct","Picasso Road","Piccadilly Cir","Piccadilly Ct",
            "Piccardo Ln","Piccolo Rd","Picked Petal Ct","Pickel Ln","Pickens Ave","Pickens County 78",
            "Pickens Mountain Rd","Pickens Street","Pickeral Lake Dr","Pickerel Ct","Pickerel Point",
            "Pickering Ave","Pickering Cir","Pickering Parkway","Pickering Way","Picket Rd","Pickett",
            "Pickett Crescent","Pickett Ln","Pickett Mtn Rd","Pickett Rd","Pickford Ave","Pickford Ln",
            "Pickford Way","Pickle Rd","Pickwick Apartment","Pickwick Apts Rd","Pickwick Ct","Pickwick Drive",
            "Pickwick Ln","Pickwick Road","Picnic Dr","Picnic Grove Rd","Pico Ave","Pico Canyon Rd","Pico Ct",
            "Pico Rivera Dr","Pico St","Pico Way","Picton Street","Picture Pl","Pidcock Ln","Piddock Rd",
            "Pidgeon Pond Rd","Pido Road","Pie Hill Rd","Piedmond Ln","Piedmont Ave NE","Piedmont Avenue",
            "Piedmont Court","Piedmont Dr","Piedmont Rd","Piedmont St","Piedmont Way","Piedra Azul Rd",
            "Piedra Rd","Piedra Vista Rd NE","Pier 65","Pier Ave","Pier Cove Ln","Pier Rd","Pier St","Piera Gardens",
            "Pierce","Pierce Ave","Pierce Avenue","Pierce Court","Pierce Ct","Pierce Dr","Pierce Ln","Pierce Pl",
            "Pierce Pt Rd","Pierce Rd","Pierce Run Rd","Pierce St","Pierce Street","Piercetown Rd","Piermont Ave",
            "Piermont Ave S","Piermont Pl","Piermont Rd","Pierpont Pl","Pierpont St","Pierre Lallement Southwest Corridor Park",
            "Pierre Place","Pierrepont Pl","Pierrepont St","Piersall Ave","Piersall Rd","Piersanti Dr",
            "Pierson Ave","Pierson Ln","Pierson Rd","Pierson St","Piersons Ln","Pigalle St","Pigeon Creek Road",
            "Pigeon Cv","Pigeon Hollow Rd","Pigeon Island Road","Pigeon Spring Rd","Pigeon St","Piggot Ln",
            "Pigs Aly","Pihl Street","Pike Ct","Pike Drive","Pike Lake 17 Route","Pike Lake 1a Route",
            "Pike Rd","Pike River Rd","Pike St","Pike Street","Pikes Aly","Pikes Ln","Pikes Peak Dr","Pikes Peak Rd",
            "Pikeview Ln","Pilar Meadows Dr; Pilar Meadows Dr NE","Pilger Ct","Pilgrams Path","Pilgrim Ave",
            "Pilgrim Circle","Pilgrim Ct","Pilgrim Dr","Pilgrim Highway","Pilgrim Rd","Pilgrim Rest Rd",
            "Pilgrim Road","Pilgrim Street","Pilkey Road","Pillar Point Bluff Trail","Pillie Rd","Pilling Street",
            "Pillsbury Ave","Pilot Dr","Pilot Knob Dr","Pilot Street","Piltz Rd","Pima Canyon Trail",
            "Pima Ct","Pima Lane","Pima Rd","Pima Way","Pimental Creek","Pimlico Ct","Pimlico Way","Pimper Rd",
            "Pin High Cir","Pin Oak","Pin Oak Ct","Pin Oak Dr","Pin Oak Ln","Pin Oak Rd","Pinache Ct","Pinafore Dr",
            "Pinal Dr","Pinal Ln","Pinal Rd","Pinata Rd","Pinchill Lane","Pinckney Rd","Pincrest School Rd",
            "Pindle Ave","Pindle Ln","Pine","Pine 36th Cutoff","Pine Acre Blvd","Pine Acre Dr","Pine Aly",
            "Pine Ave","Pine Avenue N","Pine Bloom St","Pine Bluff Arsenal","Pine Blvd","Pine Bough Ct",
            "Pine Brook Dr","Pine Canyon Rd","Pine Cir","Pine Cluster Ln","Pine Cone Cir","Pine Cone Ct",
            "Pine Cone Dr","Pine Cone Rd","Pine Cone Way","Pine Cones Dr","Pine Cove Rd","Pine Creek Cir",
            "Pine Creek Ct","Pine Creek Rd","Pine Cres","Pine Crescent","Pine Crest Trl","Pine Ct","Pine Dale Rd",
            "Pine Dr","Pine Dr SW","Pine Dr W","Pine Drive","Pine Flat Rd","Pine Flower Ct","Pine Forest Dr",
            "Pine Gate Place","Pine Glen Dr","Pine Grove Ave","Pine Grove Avenue","Pine Grove Bc",
            "Pine Grove Rd","Pine Grove Road","Pine Grove Ter","Pine Grove Volcano Rd","Pine Haven St",
            "Pine Hill Blvd","Pine Hill Cir W","Pine Hill Court","Pine Hill Ct","Pine Hill Dr","Pine Hill Ln",
            "Pine Hill Rd","Pine Hill Road","Pine Holler Rd","Pine Hollow Ct","Pine Hollow Dr","Pine Hollow Rd",
            "Pine Hurst Dr","Pine Island Dr NE","Pine Island Lake Rd","Pine Island Road","Pine Island Ter",
            "Pine Knoll Dr","Pine Knoll Rd","Pine Lane Rd","Pine Ledge Rd","Pine Ln","Pine Log Ct","Pine Manor Dr",
            "Pine Meadow Cir","Pine Meadow Rd","Pine Meadows Ct","Pine Mesa Ct","Pine Mountain Dr",
            "Pine Mountain Rd","Pine Needle Ct","Pine Needles Dr","Pine Nook Road","Pine Oaks Dr",
            "Pine Orchard Dr","Pine Park Ave","Pine Park Ct SE","Pine Pl","Pine Place","Pine Poin Road",
            "Pine Point Avenue","Pine Point Ln","Pine Pointe Ave","Pine Rd","Pine Rd Ln","Pine Ridge",
            "Pine Ridge Ave","Pine Ridge Blvd","Pine Ridge Cir","Pine Ridge Dr","Pine Ridge Drive",
            "Pine Ridge Rd","Pine Ridge Way","Pine River Dr","Pine Road","Pine Rock Road","Pine Run Dr",
            "Pine Shore Rd","Pine Shore Road","Pine Song Ln","Pine Springs Way","Pine Spur Rd","Pine St",
            "Pine St NE","Pine Street","Pine Street S","Pine Stump Ave","Pine Swamp Rd","Pine T C","Pine Tavern Elmer Rd",
            "Pine Ter","Pine Terrace Rd","Pine Tree Cir","Pine Tree Circle","Pine Tree Crescent","Pine Tree Ct",
            "Pine Tree Dr","Pine Tree Ln","Pine Tree Rd","Pine Tree Road","Pine Tree Shilling Rd",
            "Pine Tree Trail","Pine Tree Trl","Pine Vall Lane","Pine Valley","Pine Valley Acres","Pine Valley Ave",
            "Pine Valley Crescent","Pine Valley Drive","Pine Valley Ln","Pine Valley Rd","Pine Valley Way",
            "Pine View Cir","Pine View Dr","Pine View St","Pine Way","Pine Woods Dr","Pine Woods Rd",
            "Pine York Avenue","Pine Zette Ln","Pineacre Ln","Pineapple Pl","Pinebluff St","Pinebrook",
            "Pinebrook Ct","Pinebrook Dr","Pinebrook Hollow","Pinebrook Lane","Pinebrook Pl","Pineburr Ct",
            "Pinecone Ct","Pinecone Dr","Pinecrest Cir","Pinecrest Dr","Pinecrest Rd","Pinedale Ave",
            "Pinedale Avenue","Pinedale Crescent","Pinedale Dr","Pinedale Dr SW","Pinedale Rd","Pineforest Place",
            "Pinefork Rd","Pineglen Rd","Pinegrove Ave","Pinegrove Avenue","Pinehaven Ln","Pinehaven Rd",
            "Pinehill Blvd","Pinehill Dr SW","Pinehill Drive","Pinehill Road","Pinehurst Cir","Pinehurst Ct",
            "Pinehurst Dr","Pinehurst Drive","Pinehurst Estates","Pinehurst Rd","Pinehurst St","Pinehurst Street",
            "Pinehurst Way","Pineland Avenue","Pineland Pl","Pineland Rd","Pineledge Dr","Pineledge Dr N",
            "Pinella Way","Pinemeadow Ave","Pinemeadow Boulevard","Pinemore Boulevard","Pineneedle Rd",
            "Pineneedles","Pinenut Cir","Pineoakyo Rd","Pineridge Dr E","Pinery Lane","Pines Brook Rd",
            "Pines Lake Dr W","Pines Park Dr","Pines Rd","Pines Road","Pines St","Pinetree Ln","Pinetree Rd",
            "Pinette Street","Pinevale Rd","Pinevale Road","Pineview Cemetery Rd","Pineview Ct","Pineview Dr",
            "Pineview Oval","Pineview Rd","Pineview St","Pineview Ter","Pineview Way","Pineway Avenue",
            "Pinewood","Pinewood Ave","Pinewood Blvd","Pinewood Ct","Pinewood Cv","Pinewood Dr","Pinewood Ln",
            "Pinewood Pl","Pinewood Rd","Pinewood School Road","Pinewood Shrs","Pinewood Trail","Pinewood Trl",
            "Pinewood Village","Pinewwod Rd","Piney Creek Loop","Piney Creek Rd W","Piney Dr","Piney Grove Rd",
            "Piney Loop","Piney Rd","Pineywoods Rd","Pingel Road","Pinion Dr","Pinion Pine Dr","Pinion Rd",
            "Pink Aly","Pinkerton St","Pinkham Notch Rd","Pinkie Rd","Pinnacle Dr","Pinnacle Hill Rd",
            "Pinnacle Rd","Pinnacle Ridge Ave","Pinnacle Street S","Pinnard St","Pinnardville Hts Rd",
            "Pinnehill Rd","Pinney St","Pino Rd","Pinoak Ct SE","Pinocha","Pinon Ave","Pinon Creek Ct SE",
            "Pinon Creek Rd SE","Pinon Dr","Pinon Draw Rd","Pinon Rd","Pinon St","Pinot Ave","Pinson Aly",
            "Pinson Dr","Pinson Plz","Pinson Valley Aly S","Pintadas St","Pintail Ct","Pintail Dr","Pintail Drive",
            "Pintail Lake Rd","Pintail Ln","Pintail Path","Pintail Rd SW","Pintail Trce","Pinto Ct","Pinto Dr",
            "Pinto Ln","Pinto Pl","Pinto Rd","Pinto Trl","Pinto Way","Pinwheel","Pinwood Estates Rd","Pinyon St",
            "Pinzon Ave","Pioche Ct","Pion Canyon Ct","Pioneer Cir","Pioneer Circle","Pioneer Creek",
            "Pioneer Ct","Pioneer Dr","Pioneer Dr E","Pioneer Ln","Pioneer Pa","Pioneer Rd","Pioneer Road",
            "Pioneer St","Pioneer Trl","Pipe Creek Rd","Pipe Line Rd","Pipe Springs Rd","Pipe St","Pipeline Line Rd",
            "Pipeline Rd","Pipeline Road","Piper Ave","Piper Ct","Piper Dr","Piper Hill Rd","Piper Rd","Piper Road",
            "Piper St","Piperbrook Crescent","Pipers Ln","Pipers Reach","Pipil Ct","Piping Rock Rd","Pipit Ct",
            "Pipkin St","Pippin Knoll","Pippin Orchard Rd","Pippin St","Pirani Hdq Rd","Pirate","Pirate Ln",
            "Pirates Cove Rd","Pirotte Dr","Pirsch Ln","Pirtle Rd","Piru Blvd","Pisa Ave","Pisa Dr NW","Pisano",
            "Piscassic Rd","Piscataqua Rd","Piscataquog River Pk","Pisgah Mountain Road","Pisgah Rd",
            "Pismo State Bch","Pistache Ave","Pistol Dr","Pistol Range Rd","Pit / Fire Road","Pit Rd",
            "Pit River Rd","Pitch Pine Rd","Pitcher Ct","Pitcher Dr","Pitcher Hill Rd","Pitcher P Lane",
            "Pitcherville Road","Pitchford Hollow Rd","Pitfield Road","Pithole Rd","Pitkin Avenue",
            "Pitkin Ln","Pitman Ave","Pitman Downer Rd","Pitman Rd","Pitman Road","Pitman Street","Pitney Ct",
            "Pitney Ridge Rd","Pitt Ave","Pitt Pl","Pitt Rd","Pitta St","Pittman Ave","Pittman St","Pittman Wash Trail",
            "Pittriver","Pitts Ave","Pitts Creek Rd","Pittsburgh Ave","Pittsburgh Dr","Pittsfield Road",
            "Pittsford","Pittsford Mendon Center Rd","Pittsford St","Pittsford Way","Pittston Road",
            "Pitzenbarger St","Piute St","Piute Trl","Piva Avenue","Piver Rd","Pixley Hill Road","Pixley Road",
            "Pk Plaza Dr","Pla Vada Dr","Place Dr","Place d'Armes","Place du Casimir","Placentia Boulevard",
            "Placer Ave","Placer Dr","Placer Street","Placerita Mtwy","Placid Avenue","Placid Ct","Placid Dr",
            "Placid Ln","Placid Road","Placid St","Placid Street","Placid View Pl","Placita Aurelia",
            "Placita Loma","Placita Rancho Agave","Placita San Leandro","Plain St","Plain Street",
            "Plain View Rd","Plainfield Ave","Plainfield Avenue","Plainfield Pike","Plainfield Rd",
            "Plainfield Road","Plainfield St","Plainfield Street","Plains Ct","Plains Dr","Plains Rd",
            "Plains Road","Plains St","Plaintree Drive","Plane Hill Rd","Plane Ln","Plane St","Planet Ct NW",
            "Planet St","Planeta Rd","Plank Rd","Plank Road Hollow","Plank St","Planks Lane","Plant Ln",
            "Plant Rd","Plant St","Plant Ter","Plantation Ave","Plantation Cir","Plantation Ct","Plantation Dr",
            "Plantation Rd","Plantation Ridge Rd","Plantation Street","Plantation Way","Plantations Rd",
            "Planter's Wood Court","Planters Dr","Planters Pl","Plantersville Rd","Planting Field Road",
            "Plasse Rd","Plastermill Rd","Plata Caleta","Plata Pico Dr","Plateau Ave","Plateau Dr","Plateau Rd",
            "Plateau St","Plater Rd","Platina Rd","Platou Dr","Platt Ave","Platt Dr","Platt Ln","Platt Pl N",
            "Platt Rd","Platt St","Platte Dr","Platte Rd","Platten RD","Platts Mills Rd","Plattsburg Ave",
            "Plaudit Trl","Playa Dr","Playa del Rey Dr","Playa del Sol","Playa del Sol Dr","Player Ct",
            "Player Pl","Players Cir","Playground Dr","Playhouse Park Rd","Plaza","Plaza Blanca St","Plaza Blvd",
            "Plaza Central Ln","Plaza Chica Way","Plaza Cuesta","Plaza Dr","Plaza Lane","Plaza Ln","Plaza Pky",
            "Plaza Rd","Plaza Rica Ct","Plaza Square","Plaza St","Plaza St E","Plaza St W","Plaza Toluca",
            "Plaza Way","Plaza de Las Flores","Plaza de Santa Fe","Plaza de la Cruz","Plaza del Amigo",
            "Plaza del Mar","Plaza del Padre","Plaza del Prado","Plaza del Puerto","Plazoleta","Pleasant",
            "Pleasant Acres","Pleasant Ave","Pleasant Avenue","Pleasant Brook St","Pleasant Cir","Pleasant Court",
            "Pleasant Ct","Pleasant Dale Pl","Pleasant Dale Valley Rd","Pleasant Dr","Pleasant Drive",
            "Pleasant Forest Cv","Pleasant Grove Rd","Pleasant Hidaway","Pleasant Hill","Pleasant Hill Dr",
            "Pleasant Hill Lane","Pleasant Hill Point","Pleasant Hill Rd","Pleasant Hill Road",
            "Pleasant Hollow Rd","Pleasant Ln","Pleasant Oaks Ct","Pleasant Oaks Dr","Pleasant Pl",
            "Pleasant Point Rd","Pleasant Pond Rd","Pleasant Rd","Pleasant Ridge Church Rd","Pleasant Ridge Dr",
            "Pleasant Ridge Rd","Pleasant Road","Pleasant Run Rd","Pleasant St","Pleasant St.","Pleasant Street",
            "Pleasant Street Extension","Pleasant Valley","Pleasant Valley Dr","Pleasant Valley Overlook",
            "Pleasant Valley Pl","Pleasant Valley Place","Pleasant Valley Rd","Pleasant Valley Rd NE",
            "Pleasant Valley Road","Pleasant Valley Street","Pleasant View Ave","Pleasant View Avenue",
            "Pleasant View Cir","Pleasant View Dr","Pleasant View Drive","Pleasant View Rd","Pleasant View St",
            "Pleasant Way","Pleasanton Cir","Pleasants Valley Rd","Pleasantview Ave","Pleasantway Dr",
            "Pleasent Pl","Pleasonton Rd","Pleasure Ave","Pleasure Bay Road","Pleasure Street","Pleiades Pl",
            "Pleiku St","Plessinger Ln","Pletcher Rd","Plevin Cut","Plews Ct","Pliny Street","Plover Ct",
            "Plover Hill Road","Plover St","Plover Street","Plum","Plum Aly","Plum Ave","Plum Blossom Ct",
            "Plum Dr","Plum Lane","Plum Ln","Plum St","Plum Street","Plum Tree","Plum Tree Ct","Pluma Ct","Plumas Ave",
            "Plumas Ct","Plumb 1st St","Plumb Ln","Plumb Pl","Plumb Road","Plumbago Rd","Plumblossom Ct",
            "Plumbush Rd","Plumer Hill Rd","Plumeria Ct","Plumerias Ct","Plummer Ave","Plummer Rd","Plummer St",
            "Plumtree Court","Plumtree Ct","Plumtree Pl","Plumtree Rd","Plumwood St","Plunder Ave","Plural Ink Ranch",
            "Plush Mill Rd","Plushanski Rd","Pluto St","Pluton St","Plymbride Crescent","Plymbridge Crescent",
            "Plymouth Ave","Plymouth Avenue","Plymouth Ct","Plymouth Dr","Plymouth Lk Dr","Plymouth Ln",
            "Plymouth Pl","Plymouth Rd","Plymouth Road","Plymouth Service Dr","Plymouth St","Plymouth Street",
            "Plymouth Valley Dr","Plymouth Way","Plympton Circle","Plywood Mill Rd","Plywood Place",
            "Poachers Run","Poague Rd","Poana Ave","Poar Dr","Poca Rd","Pocahontas Ln","Pocantico Ave","Pocatello Dr",
            "Pochassic Street","Pocito Ln","Poco Loco Rd NE","Pocohontas Ave","Pocono Cir","Pocono Mountain Lake Dr",
            "Pocono Rd","Pocotaligo Rd","Podunk Rd","Podunk Spur Rd","Poe Ave","Poe Rd","Poe St","Poe Ter",
            "Poerr Dr","Poets Ln","Poets Walkway","Pogonia Street","Pogue Rd","Pogue Road","Pohatcong Ave",
            "Pohono","Poillon Ct","Poindexter St","Poinsettia Park","Poinsettia St","Point Abbaye","Point Arena Pl",
            "Point Ave","Point Bonita Trail","Point Breeze Ave","Point Corazza Vista","Point Crescent",
            "Point Ct","Point Dr","Point Kathy Cir","Point Lakeview Rd","Point Ln","Point Mountain Rd",
            "Point O' Pines Rd","Point Paradise Blvd","Point Pleasant Rd","Point Rd","Point Reyes Ct",
            "Point Russo","Point Sal Cir","Point Sal Rd","Point San Bruno Blvd","Point Shop Ln","Point St",
            "Point Sublime Trl","Point Trl","Point View Pl","Point View Rd","Pointe Pl","Pointe Ranier Ave",
            "Pointe South Dr","Pointe Sur","Pointed Oak Pl","Pointer Pl","Poirier Way","Poisson Court",
            "Poke Ct","Poker Flat Rd","Poker Flats Rd","Poker Ln","Pokie Dr","Pokovich Ln","Poland Rd","Poland St",
            "Polar Pl","Polaris Ave","Polaris Cir","Polaris Pky","Polaris Rd","Polaris St","Polasky Rd",
            "Pole Cat Rd","Pole Line Rd","Pole Rd","Pole Ridge Rd","Polenta Crescent","Polhemus St","Poli Ln",
            "Policarpio Trl","Polin Pl","Poling Ave","Poling Farm Ct","Polish Hill Rd","Polizzi Pl","Polk 304 Rd",
            "Polk Ave","Polk Cir","Polk Creek Rd","Polk Ct","Polk Dr","Polk Meeting House Rd","Polk Rd",
            "Polk Road 125","Polk Road 127","Polk Road 139","Polk Road 16","Polk Road 191","Polk Road 196",
            "Polk Road 207","Polk Road 213","Polk Road 22","Polk Road 228","Polk Road 252","Polk Road 26",
            "Polk Road 261","Polk Road 263","Polk Road 29","Polk Road 302","Polk Road 40","Polk Road 41 N",
            "Polk Road 410","Polk Road 444","Polk Road 449","Polk Road 461","Polk Road 482","Polk Road 494",
            "Polk Road 538","Polk Road 56","Polk Road 605","Polk Road 631","Polk Road 664","Polk Road 69",
            "Polk Road 700","Polk Road 704","Polk Road 72","Polk Road 74","Polk Road 9","Polk St","Polk Walk",
            "Polkville-Vail Rd","Polkwood Ct","Pollak Ct","Pollan Rd","Pollara Ln","Pollard Street","Pollard Way",
            "Polled Hereford Dr","Pollock Rd","Pollock St","Polloway Road","Pollution Control Facility",
            "Polly Geraci Trail","Polly Pl","Polly Rd","Polly St","Polly's Path","Polly's Pl","Pollys Dr",
            "Polo Bay Cir","Polo Rd","Polonia Way","Polpis Road","Polson","Polson St","Polvo del Oro Pl NW",
            "Poly Place","Poly St","Pomander Walk","Pomegranate Cir","Pomelo Ct","Pomelo Dr","Pomering Rd",
            "Pomeroy Avenue","Pomeroy Rd","Pomeroy St","Pommel Ave","Pomo Ct","Pomo Lake Dr","Pomo St","Pomo Way",
            "Pomona Ave","Pomona Court","Pomona Ct","Pomona Dr","Pomona Fwy","Pomona Rd","Pomona St","Pompano Ct",
            "Pompano Ln","Pompeii Dr","Pompom Ct","Pomponio Truck Trail","Ponca Dr SW","Ponca St","Ponce de Leon Avenue",
            "Ponce de Leon Ct","Pond Brook Rd","Pond Creek Rd","Pond Dr","Pond Farm Road","Pond Hill Rd",
            "Pond Hse Rd","Pond Ln","Pond Mdws","Pond Meadow","Pond Meadows Rd","Pond Rd","Pond Road","Pond St",
            "Pond Street","Pond View","Pond View Cir","Pond View Dr","Pond View Lane","Pond View Ln",
            "Pond View Rd","Pond Way","Ponda Rosa Dr","Ponder Ln","Ponder Rd","Ponderhill Way","Ponderosa Cir",
            "Ponderosa Ct","Ponderosa Ct NE","Ponderosa Dr","Ponderosa Ln","Ponderosa Loop","Ponderosa Pl",
            "Ponderosa Rd","Ponderosa St","Ponderosa Way","Ponds Ct","Ponds Edge Way","Pondside Dr","Pondview Avenue",
            "Pondview Court","Pondview Ct","Pondview Dr","Pont Lane","Pontchartrain Dr","Pontiac Lake Rd",
            "Pontiac Ln","Pontiac Pl","Pontiac Rd","Pontiac St","Pontiac Street","Pontypool Road","Pony Ct",
            "Pony Express Trl","Pony Farm Rd","Pony Rd","Pony Soldier Ave","Pony St","Pooewin St","Pool Dr",
            "Pool Place","Pool Rd","Pool St","Pool Station Rd","Poole Power Plant Rd","Poole Street",
            "Pooler Rd","Pooley Dr","Poor Farm Rd","Poor Town Road","Poore House Lane","Poores Lane",
            "Poorhouse Rd","Popcorn Ln","Pope Ave","Pope Cir","Pope Ct","Pope Rd","Pope St","Pope Street","Popes Ravine Rd",
            "Poplar","Poplar Aly","Poplar Ave","Poplar Ave NW","Poplar Avenue","Poplar Beach","Poplar Brook Ln",
            "Poplar Corner Rd","Poplar Ct","Poplar Dr","Poplar Dr SW","Poplar Garden Ln","Poplar Heights Drive",
            "Poplar Lane","Poplar Ln","Poplar Pa Crescent","Poplar Pl","Poplar Plains Road","Poplar Ranch Cv",
            "Poplar Rd","Poplar Springs Rd","Poplar St","Poplar Street","Poplar Ter","Poplar Tree Bay Rd",
            "Pople Rd","Poplin Ave","Popo Ln","Popowski Ave","Poppinga Way","Popponesset Island Road",
            "Popponessett Road","Poppy Ave","Poppy Ln","Poppy Valley Rd","Poppy's Pl","Pops Ct","Popular Ln",
            "Porcelain St","Porch Hollow Rd","Porchmill Rd","Porcupine Avenue","Porcupine Lake Rd",
            "Porcupine Path","Pordoe Aly","Porfirio Diaz St","Porsche Strauss","Port Arthur Ave","Port Ave",
            "Port Gibson Ct","Port Hoov Road","Port Kenyon Rd","Port Ln","Port Maitland Road","Port Master Drive",
            "Port Od Oswego Authority","Port Rd 21","Port Rd J","Port Richmond Ave","Port Royal Trail",
            "Port Rush Row","Port Sill Ct","Port St","Port Stan Parkway","Port Street W","Port Union Road",
            "Port Watson Street","Port-Emporium Rd","Portage Ave","Portage Drive","Portage Road","Portales Rd",
            "Porter Ave","Porter Avenue","Porter Cir","Porter Creek Rd","Porter Dr","Porter Ln","Porter Pl",
            "Porter Rd","Porter Road","Porter St","Porterfield Creek Dr","Porters Rd","Porters Simmental Ln",
            "Portia Way","Portland Aly","Portland Ave","Portland Court","Portland Dr","Portland Rd","Porto Alegre Ct",
            "Portofino Ave","Portola Ave","Portola Ct","Portola Dr","Portola Green Cir","Portola Rd",
            "Portola St","Portrero","Ports O Call","Portsdown Road","Portside Dr","Portsmith Rd","Portsmoth Ave",
            "Portsmouth Ave","Portsmouth Avenue","Portsmouth Dr","Portsmouth Ln","Portsmouth Street",
            "Portulaca Pl","Portwood Ln","Porvenir Ct","Posa Chanet Blvd","Posada Ct","Posada Ln","Poseidon Dr",
            "Posey Ave","Posey Cir","Positano Ln","Poso Ave","Poso Canal","Poso Creek Ln","Poso Rd","Poso St",
            "Possaghi Rd","Possehl Rd","Possum Berry Ln","Possum Hill Rd","Possum Hollow Ct","Possum Trot Rd",
            "Post Aly","Post Ave","Post Ct","Post Farm Rd","Post Ln","Post Oak Drive","Post Oak Pl","Post Oak Rd",
            "Post Oaks Ln","Post Oaks Pl","Post Office Alley","Post Office Ln","Post Office Rd","Post Pl",
            "Post Ranch Rd","Post Rd","Post Rds","Post Road","Post St","Posted Rd 18","Poster Ln","Posterity Pl",
            "Poston Ln","Poston Rd","Potash Hill Road Branch","Potash Rd","Potash Street","Potato Hill Rd S",
            "Potato Is Road","Potato Rd","Poteau Mountain Rd","Poteau Mtn Rd","Potenza Ln","Potero Rd",
            "Poth Road","Poth Street","Potlatch 599 Pvt","Potlatch 626 Pvt","Potomac Dr","Potomac Street",
            "Potomac Way","Potosi St","Potpourri Dr","Potrero Ave","Potrero St","Potrero Way","Pots Falls Rd",
            "Potsdam Road","Pott Hole Valley","Potter","Potter Ave","Potter Brook Rd","Potter Ct SE",
            "Potter Dr","Potter Drive","Potter Hill Rd","Potter Ln","Potter Mountain Road","Potter Rd",
            "Potter Road","Potter Settlement Road","Potters Ln","Pottery Road","Potts Rd","Poucher Street",
            "Poulette Street","Poulin Dr","Poulin St","Poulos Road","Pound Hill Rd","Pound Hills Way",
            "Pound Rd","Pourroy Rd","Pouse Rd","Poutre Rd","Poverty Hill Rd","Poverty Ln","Poverty Square Road",
            "Poway Rd","Powder Horn Green","Powder Horn Pl","Powder House Ln","Powder House Road",
            "Powder Mill Hollow Rd","Powder Mill Rd","Powder Mill Road","Powder Mill Trail","Powder Ridge Rd",
            "Powder River Ct","Powderhorn Ct","Powderhorn Dr","Powderhouse Lane","Powderhouse Road",
            "Powell","Powell Ave","Powell Canyon Rd","Powell Chapel Rd","Powell Ct","Powell Cv","Powell Dr",
            "Powell Hill Rd","Powell Ln","Powell Place Rd","Powell Rd","Powell Road","Powell St","Powell St SE",
            "Powell Trl","Powelltown Rd","Power Ave","Power House Road","Power Line Maint Rd","Power Line Rd",
            "Power Line Re","Power Street","Powerhouse","Powerhouse Rd","Powerline","Powerline Drive",
            "Powerline Rd","Powerline Trail","Powers Ave","Powers Avenue","Powers Dr","Powers Rd","Powers Road",
            "Powers St","Powers Street","Powley Street","Pownal Dr","Pr 1516","Pr 1700","Pr Rd 1404","Pr Rd 1475",
            "Pr Rd 1650","Pr Rd 1790","Practice Dr","Pradera Ave","Praderia Cir","Prager St","Prague Ave",
            "Prahl Ln","Prahl Rd","Prairie Ave","Prairie City Rd","Prairie Creek Rd","Prairie Day Dr",
            "Prairie Grove Lake Rd","Prairie Lake Rd","Prairie Ln","Prairie St","Prairie Stone Pl",
            "Prairie View Rd S","Prairie View Trail","Prairie Vista","Prairie Way","Prairieview Cir",
            "Prairiewind Ln","Praline Dr","Prall Pl","Pralle Ln","Prater St","Pratt Ave","Pratt Ave NE",
            "Pratt Cres.","Pratt Ln","Pratt Rd","Pratt St","Pratt's Marina Road","Pratt's Road","Praytor Dr",
            "Preacher Hill Rd","Preakness Cir","Preakness Way","Preamble Dr","Preble Ct","Preble Street",
            "Precinct Street","Precision Way","Precourt St","Predial Way","Prell Ln","Prelog Ln","Premier Place",
            "Premier Street","Premisy Hill Rd","Prence Road","Prennan Avenue","Prentice Avenue","Prentice Hill Rd",
            "Prentice Rd","Prentice St","Prentis Road","Prentiss St","Prentiss Way","Presby Place","Prescot Cir",
            "Prescott Ave","Prescott Avenue","Prescott Dr","Prescott Heights Dr","Prescott Hill","Prescott Ln",
            "Prescott Pl","Prescott Rd","Prescott Road","Prescott St","Prescott Street","Prescott Terrace",
            "Prescott Way","Preserve Pl","Presevation Lake Wildlife","Presho School Rd","President Avenue",
            "President Drive","President St","President Street","Presidential Apartment","Presidential Dr",
            "Presidio Ave","Presidio Way","Presley Ln","Presque Isle Ave","Presson Pl","Prestige Court NW",
            "Prestige Dr","Prestige Drive","Preston Ave","Preston Cir","Preston King Trl","Preston Pl",
            "Preston Place","Preston Rd","Preston Road","Preston St","Preston Street","Prestwick Crescent",
            "Prestwick Ct","Prestwick Drive","Pretty Brook Rd","Pretzer Rd","Preu Ln","Preventorium Rd",
            "Price","Price Ave","Price Avenue","Price Canyon Rd","Price Ct","Price Dr","Price Lake Rd","Price Ln",
            "Price Rd","Price Street W","Prices Ln","Prichard Avenue","Prickly Pear Rd","Priddle Road",
            "Pride Rd","Pride St","Pride Way","Prides Xing","Pridham Court","Priest Point Ln","Priest St",
            "Prim Rose Ln","Primavera Bay","Primavera Dr","Primavera Plz","Primeau Aly","Primera Ct",
            "Primero Dr","Primont Drive","Primrose Ave","Primrose Crescent","Primrose Ct","Primrose Ln",
            "Primrose Path","Primrose Pl","Primrose St","Primula Ct","Prince Albert Court","Prince Albert Ct",
            "Prince Albert Dr","Prince Albert St","Prince Ave","Prince Charles Drive","Prince Charles Way",
            "Prince Cir","Prince Ct","Prince Edward Boulevard","Prince Edward Drive North","Prince Edward Rd",
            "Prince Edward Street","Prince Henry Court","Prince Ln","Prince Philip Boulevard","Prince Place Rd",
            "Prince Rd","Prince Rodgers Ave","Prince Rodgers Way","Prince Rupert Avenue","Prince St",
            "Prince Street","Prince William Street","Princehorn Ave NW","Princess Anne Crescent",
            "Princess Ave","Princess Avenue","Princess Crescent","Princess Helen Rd","Princess Ln",
            "Princess Margaret Boulevard","Princess Royal Avenue","Princess Royal Drive","Princess Street",
            "Princeton Arms E","Princeton Ave","Princeton Blvd","Princeton Crescent","Princeton Ct",
            "Princeton Dr","Princeton Drive","Princeton Gate Blvd","Princeton Hightstown Rd","Princeton Ln",
            "Princeton Oval","Princeton Pl","Princeton Rd","Princeton Road","Princeton St","Princeton Street",
            "Princeton Terrace","Princeton Way","Princeway Drive","Princewood Ave","Principals Way",
            "Principe","Princton Ct","Prindan Ln","Prindle Hill Road","Prine Rd","Pringle Ct","Pringle Rd",
            "Pringle St","Pringle Street","Pringle Way","Prins Alexander Cir","Printery St","Printing House Pl",
            "Prior Ct","Prior Ln","Priscilla Lane","Priscilla Ln","Priscilla Street","Prism Ln","Prison Rd",
            "Pritchard Court","Pritchard Rd","Pritchard Way","Private Dr","Private Drive 1044","Private Drive 335",
            "Private Drive 3672","Private Drive 5019","Private Drive St. John's Rehab Hospital",
            "Private Drive at 53-57 White Rd","Private Rd","Private Rd 2226","Private Rd 2262",
            "Private Rd 2561","Private Rd 2563","Private Rd 2590","Private Rd 3379","Private Rd 3548",
            "Private Rd 3557","Private Rd 3572","Private Road 633","Private West 4","Privateer Ct",
            "Privet Crescent","Privet Ct","Privet Dr","Privet St","Privete Dr","Probert St","Probst Ave",
            "Probst Rd","Procious Maysel","Proctor","Proctor Ave","Proctor Avenue","Proctor Ln","Proctor Road",
            "Proctor Street","Proctor Valley Rd","Proctoria Rd","Procyon St","Produce Rd","Production Dr",
            "Production Way","Professional Ct","Professors Row","Progress Ave","Progress Avenue","Progress Court",
            "Progress Dr","Progress Drive","Progress Ridge","Progress St","Project Ave","Promanade","Promelia Court",
            "Promenade","Promenade Canal du Nord Drive","Promenade Drive","Promenade Terminal",
            "Promenade Way","Promenado Dr","Prominence Rd","Promise Ln","Proper View","Prospect","Prospect Ave",
            "Prospect Ave N","Prospect Ave NW","Prospect Avenue","Prospect Ct","Prospect Dr","Prospect Dr SE",
            "Prospect Expressway","Prospect Hill","Prospect Hill Avenue","Prospect Hill Rd","Prospect Hill Road",
            "Prospect Junction Rd","Prospect Park","Prospect Park W","Prospect Pl","Prospect Place",
            "Prospect Rd","Prospect Right of Way","Prospect St","Prospect Street","Prospect Ter","Prospect Village",
            "Prospector Ct","Prospector Ln","Prosper Ridge Rd","Prosper St","Proudfoot Street","Prout Ln",
            "Prout St","Prouty Ln","Provence Court","Providence Ave","Providence Church Rd","Providence Ct",
            "Providence Estates Ct","Providence Ln","Providence Ranch Rd","Providence Rd","Providence Street",
            "Provident Ct","Province Brook Ln","Province Brook Rd","Province Lake Rd","Province Line Rd",
            "Province Rd","Provincial Ct","Provo Dr","Provost Ave","Prudence Ln","Pruitt Ln","Pruitt Rd",
            "Prune Lake Rd","Prune Rd","Prunner Road","Prunty St","Prunus Cir","Prussian Hill Rd","Pry Dr",
            "Pryce St","Pryor St","Pschorn Ln","Ptarmigan Dr","Public Access Point Rd","Public Access Rd",
            "Public Alley 422","Public Alley 431","Public Alley 819","Public Alley 909","Public Landing Rd",
            "Public Ln","Public Row","Public School","Public School Road","Puccini Drive","Pudding Ln",
            "Puddingstone Ct","Puddleby Ln","Pueblo Bonita Ave","Pueblo Chico Ct","Pueblo Corona Ln",
            "Pueblo Ct","Pueblo Dorado Pl","Pueblo Dr","Pueblo Jacona","Pueblo Ln","Pueblo Place NW",
            "Pueblo Rd","Pueblo Road","Pueblo St","Pueblo Trl","Puente Dr","Puente Ln","Puente Way","Puerta Ct",
            "Puerta Ln","Puerta Phoenix","Puerto Blanco Dr","Puerto Verde Cir","Puesta del Sol","Puffin Glade",
            "Puffin Rd","Pugsley","Pugsley Avenue","Puh Nay Fitch St","Pukaville Pl","Pulaski Ave","Pulaski Bridge",
            "Pulaski Hwy","Pulaski Skwy","Pulaski St","Puleo Plz","Pullen Pl","Pullins Rd","Pullman Ave",
            "Pullman Ct SE","Pullman Pl","Pullman Place","Pullman St","Pulpit Dr","Pulpit Hill Road",
            "Pulpit Rock","Pulpit Rock Rd","Pulsifer Dr","Pulsipher Ln","Pulver Drive","Puma Dr","Puma Way",
            "Pumice Ln","Pump Rd 1","Pump St","Pump Station Rd","Pump Station Road","Pumphouse Rd","Pumping Station Rd",
            "Pumpkin Hill","Pumpkin Hill Rd","Pumpkin Lane","Pumpkin St","Pumpkin Swamp Rd","Pund Rd",
            "Punjab Ave","Punki Bo Rd","Punkin Hill Rd","Punkin Ln","Punta Arenas Ct","Punta Ln","Punto Alto Ct",
            "Punto de Vista","Puppy Creek Rd","Purbook Court","Purcell Ct","Purcell Rd","Purcell Square",
            "Purchase St","Purchase Street","Purdin Ave","Purdue Ave","Purdue Avenue","Purdue Ct","Purdue Dr",
            "Purdue St","Purdy Ln","Purdy Ranch Rd","Purdy St","Pure Ct","Purgatory Ct","Purifoy Dr","Purinton Road",
            "Purisma Pl","Puritan Avenue","Puritan Lane","Puritan Rd","Puritan Road","Purple Heart Blvd",
            "Purple Heart Highway","Purple Lake","Purple Martin Way","Purple Rose Ln","Purple Sage Ave",
            "Purple Sage Ct","Purple Vale Ct","Purple Way","Pursel Drive","Pursel St","Purvis Ave","Purvis Street",
            "Pusan Way","Putman Rd NW","Putnam Ave","Putnam Court","Putnam Dr","Putnam Hts","Putnam Pike",
            "Putnam Pl","Putnam Rd","Putnam Road","Putnam St","Putnam Way","Putney Landing Rd","Putney Ln",
            "Putney Ridge Rd","Putnum Ln","Putter Cir","Putter Pl","Putter Way","Putters Ct","Putting Green",
            "Putting Green Circle","Puzack Ln","Pvt Rd","Pvtrd","Pyburn Avenue","Pye Ln","Pykeview Drive",
            "Pyle Ave","Pym St","Pynchon Road","Pyramid Ave","Pyramid Hills Rd","Pyramid Pines Dr","Pyramid Point Ct",
            "Pyramid Rd","Pyramid St","Pyrenees Pl","Pyrite Ave","Pyrite Court","Pyrite Dr","Pyrite St",
            "Q Ave","Q Ct","Q R 60","Q R 63","Q R 66","Q R Ai","Q R Bh","Q R Q","Q R T","Q St S","QEW","QEW - Hamilton",
            "QEW Toronto","Qr A L","Qr Ab","Qr Z","Qramp","Quabbin Road","Quackenbush Pl","Quafaloma Rd","Quaid St",
            "Quail Ave","Quail Beak Way","Quail Bush Cir","Quail Court","Quail Cove Ct","Quail Creek Dr",
            "Quail Ct","Quail Dr","Quail Hill Dr","Quail Hill Ln","Quail Hill Rd","Quail Hill Road","Quail Hollow",
            "Quail Hollow Ave","Quail Hollow Ct","Quail Hollow St NW","Quail Landing Ct","Quail Ln",
            "Quail Meadows Ln","Quail Nest Way","Quail Rd","Quail Ridge Ct","Quail Run","Quail Run Boulevard",
            "Quail Run Ct","Quail Run Dr","Quail Run Rd","Quail Run Trl","Quail Springs Rd","Quail St",
            "Quail Tree Ct","Quail Trl","Quail Trl St","Quail Valley Crescent","Quail Valley Drive",
            "Quail Valley Lane","Quail Valley Pl","Quail Valley Rd","Quail View Way","Quail Walk",
            "Quail Way","Quailhollow Dr","Quailridge Ct","Quailridge Ln","Quailrun Ln","Quaint Ranch St",
            "Quaint Ridge Trl","Quaint St","Quake Ln","Quaker Church Rd","Quaker Hill Rd","Quaker House Lane",
            "Quaker Lane","Quaker Ln","Quaker Ln Connector Rd","Quaker Plz","Quaker Ridge Ln","Quaker Ridge Road",
            "Quaker Road","Quaker Run","Quaker St","Quaker Street","Quaker Village Drive","Quakerbridge Ct",
            "Quakerbridge Rd","Quakertown Rd","Quale Canyon Rd","Quality Farms","Quality Rd","Qualls Rd",
            "Quantico Ct","Quantz Crescent","Quarry Ln","Quarry Pont Court","Quarry Rd","Quarry St","Quarry View Dr",
            "Quarrystone Way","Quarte Horse Rd","Quarter Horse Lane","Quarter Horse Ln","Quarter Horse Rd",
            "Quarter Line Rd","Quarter Mile Ln","Quarterhorse Lane","Quarterhorse Rd","Quarterline Rd",
            "Quartermaster Rd","Quarterstaff Dr","Quartet Dr","Quartz Ave","Quartz Dr","Quartz Hill Rd",
            "Quartz Mine Rd","Quartz Rd","Quartz St","Quartz Trl","Quartz Valley Rd","Quartzite Rd","Quasar Dr",
            "Quassapaug Rd","Quay Bk","Quay Dr","Quay Rd","Quay Road 54","Quay Road 61","Quay Road 62","Quay Road 64",
            "Quay Road 64.4","Quay Road 93","Quay Road 94","Quay Road L","Quay Road M","Quay St","Quay Street",
            "Quebec Pl","Quechan Rd","Queen Ann Rd","Queen Anne Ct","Queen Anne Dr","Queen Anne Ln","Queen Anne Rd",
            "Queen Anne Street","Queen Anne's Lace","Queen Ave","Queen Bee Rd","Queen Charlotte Way",
            "Queen City Ave","Queen Creek Pl","Queen Creek Rd; W Queen Creek Rd","Queen Ct","Queen Elisabeth Way",
            "Queen Elizabeth Way","Queen Esther Dr","Queen Filomena Avenue","Queen Mountain Rd",
            "Queen St","Queen Street","Queen Street East","Queen Street N","Queen Street S","Queen Street W",
            "Queen Street West","Queen Victoria Street","Queen Victoria Way","Queen's Park Crescent West",
            "Queen's Plate Drive","Queen's Quay East","Queen's Quay West","Queens Ave","Queens Avenue",
            "Queens Blvd","Queens Borough Ct","Queens Ct","Queens Guard Walk","Queens Ln","Queens Park Ave",
            "Queens Plz S","Queens Rd","Queens Walk","Queens Way","Queens-Midtown Expressway","Queensberry Crescent",
            "Queensboro Bridge upper level","Queensboro Circle","Queensboro Rd","Queensbridge Dr",
            "Queensbridge Drive","Queensbury Ct","Queenscliff Ct","Queensgate Boulevard","Queensland Avenue",
            "Queensland Road","Queensridge Ct","Queenston Crescent","Queenstown Rd","Queensvil Sideroad",
            "Quentin Rd","Quentin Road","Quenton Rd","Quesan Pl","Questhaven Rd","Quetico Court","Quezon Ave",
            "Quick Dr","Quidnet Road","Quien Sabe Rd","Quiet Arrow","Quiet Arrow Dr","Quiet Bend Ct",
            "Quiet Breeze Ct","Quiet Ct","Quiet Hills Dr","Quiet Ln","Quiet Pine Dr","Quietwood Drive",
            "Quigley Court","Quigley Rd","Quijote Ln","Quill Court","Quillman Rd","Quimby Ave","Quimby Rd",
            "Quimico St","Quin-Mo-Lak Road","Quinan Drive","Quinapoxet Avenue","Quinby Rd","Quince Ave",
            "Quince Ln","Quince Rd SE","Quince St","Quincy Ave","Quincy Avenue","Quincy Ct","Quincy Dr",
            "Quincy Ln","Quincy Pl SE","Quincy Rd","Quincy St","Quincy St NE","Quincy St SE","Quincy Way",
            "Quincy la Porte Rd","Quinhagak Ln","Quinlan Ave","Quinlan Farm Rd","Quinn Ave","Quinn Cir",
            "Quinn Drive","Quinn Manor Dr","Quinn Rd","Quinn Road E","Quinn St","Quinncrest Ln","Quinns Lane",
            "Quinta Ave","Quintana Rd","Quintearo St","Quintessence Road NE","Quire","Quirk Street","Quitman Ave",
            "Quitman County Line Rd","Quitman Rd","Quito Ln","Quito Rd","Quivera Ct","Quivira Dr","Quize Ln",
            "R 50","R 83","R 85","R Chaves Rd","R L Palenske St","R Rd","R St","R W Hoyt Way","R-Rock Rd","R.E. Olds Freeway",
            "R12 Road","R14 Road","R436","RCAF Road","Raaberg Way","Rabaioli","Rabbit Ct","Rabbit Ln","Rabbit Path Rd",
            "Rabbit Rd","Rabbit Ridge Rd","Rabbit Run","Rabbit Springs Rd","Rabbitbrush Dr","Rabbits Ln",
            "Rabbitt Run Rd","Rabbittown Rd","Rabon Ln","Raboth Road","Raby Rd","Raccoon Ct","Raccoon Rd",
            "Raccoon Run","Raccoon Street","Raccoon Trl","Raccoon Way","Race Brook Rd","Race Course Ln",
            "Race St","Race Track Rd","Racetrack Cir","Racetrack Rd","Racetrack Valley Rd","Rachael Ave",
            "Racheal Dr","Rachel","Rachel Ct","Rachel Ln","Rachel Rd","Rachel Road","Racine Avenue","Racine Ct",
            "Racine Dr","Rackett Rd","Rackety T Road","Rackocy Ct","Racoon Run","Racquet Rd","Racquette Point Rd",
            "Radaker St","Radanovich Blvd","Radar Rd","Radar Station Rd","Radar Street","Radbourne Rd",
            "Radcliff Rd","Radcliffe Dr","Radcliffe Road","Radcliffe St","Raddatz Dr","Rader Ave","Rader Ln",
            "Radford Drive","Radford St","Radiant Way","Radigan Ave","Radio Rd","Radio Tower Rd","Radner Street",
            "Radnor Rd","Rado Ln","Rado Ridge Rd","Radstock Dr","Radvliffe Boulevard","Radyburg Pl","Rae Cir",
            "Rae Crescent","Rae Ct","Rae Ln","Rae St","Raebel Pl SW","Raeder Dr","Rael Rd","Raesly Hill Rd",
            "Rafello Dr","Rafi Way","Raftsman Cove","Ragan Creek Rd","Ragged Hill Road","Raggedy Ann Ln",
            "Raglan Road","Raglan Street","Ragtime Cir","Rahilly Rd","Rahming Ln","Rahway (White)","Rahway Ave",
            "Rahway Valley","Raigosa Rd","Rail Rd","Rail Road St","Railbranch Rd","Railey Avenue","Railroad AVE",
            "Railroad Aly","Railroad Ave","Railroad Ave S","Railroad Ave.","Railroad Avenue","Railroad Bed",
            "Railroad Bed Rd","Railroad Cir","Railroad Dr","Railroad Dump Rd","Railroad Ln","Railroad Mountain Rd",
            "Railroad Rd","Railroad St","Railroad St SW","Railroad Terrace","Railsedge Rd","Railton Lane",
            "Railway Ave W","Railway Siding Road","Railway St","Railway Street","Railyard Dr","Raimer Way",
            "Rain Drop Rd","Rain Storm Ct","Rain Tree Ln","Raina Dr","Rainbird Cir","Rainbird Ct","Rainbow",
            "Rainbow Ave","Rainbow Bridge","Rainbow Cir","Rainbow Cliff Ct","Rainbow Cv","Rainbow Dr",
            "Rainbow Dr W","Rainbow Gardens Road","Rainbow Glen Rd","Rainbow Lake Rd","Rainbow Ln",
            "Rainbow Lodge Rd","Rainbow Rd","Rainbow Ridge Road","Rainbow Ridge Dr W","Rainbow Ridge Rd",
            "Rainbow Shores","Rainbow St","Rainbow Valley Rd","Rainbows End Way","Rainburst Ct","Raine Rd",
            "Rainer Rd","Raines Ave","Raines Street","Rainey Court","Rainey Rd","Rainey St","Rainflower Ln",
            "Raingley Road","Rainhill Dr","Rainie Road","Rainier Ct","Raining Hills St","Rainrock Ct",
            "Rainrock Rd","Rains Avenue","Raintree Cir","Raintree Ct","Raintree Dr","Raintree Is","Raintree Ln",
            "Raintree Pky","Rainwater Ct","Raisen Cir","Rajah Street","Raker Rd","Rakewood Crescent",
            "Raleigh Cir","Raleigh Cir N","Raleigh Ct","Raleigh Dr","Raleigh Pass","Raleigh Pl","Raleigh St",
            "Rall Rd","Ralph Ave","Ralph Ave SE","Ralph Avenue","Ralph Ct","Ralph Dr","Ralph Ln","Ralph St",
            "Ralph Street","Ralphs Ave","Ralphs Rd","Ralston Rd","Ralston Ridge","Ralston St","Ram Ct","Ram Rd",
            "Ram Springs Rd","Ram Trl SE","Rama-Dalt Road","Ramada","Ramada Plz","Ramapo Avenue","Ramapo Dr",
            "Ramapo Park","Ramapo Rd","Ramapo Trl","Rambler Rd","Ramblers Lodge","Ramblewood","Ramblewood Dr",
            "Ramblewood Rd","Rambling Brook Dr","Rambling Meadow Dr","Rambling Road","Rambling Rose Dr",
            "Rambo Ln","Rambo Rd","Ramclark Ln","Ramel Lynn Rd","Ramey Dr","Ramey Rd","Ramhurst Dr","Ramille Ct",
            "Ramland Rd","Ramm Dr","Ramon Dr","Ramon St","Ramona Ave","Ramona Blvd","Ramona Ct","Ramona Dr",
            "Ramona Rd","Ramona St","Ramonet Drive","Ramos Farm Rd","Ramos Way","Ramp","Ramp - Rt 44 Eb To Commerce Way",
            "Ramp Ave","Ramp Buffalo Skyway to Delaware Avenue","Ramp I 390 South to US 20A",
            "Ramp I 90 East to I 390 South","Ramp I 90 to I 390","Ramp NY 15 to I 390 South",
            "Ramp Town Cen Sum E","Ramp US 20 & NY 5 to I390 South","Ramp US 20A to I 390 North",
            "Ramp to 11 north","Ramp to 400 north","Ramp to 400/12 south (Trans-Canada)","Ramp to 410 north",
            "Ramp to 427 North","Ramp to Campus Road","Ramp to Fasken Drive","Ramp to Highway 409",
            "Ramp to I 90","Ramp to Pine Street","Ramp to QEW Toronto","Ramp to Silver Dart Drive",
            "Ramp to The West Mall and Evans Avenue","Ramp to Thorold Stone Road east","Ramp to US 219",
            "Ramp to [17] Cawthra Road","Ramp-rt 125 Conn To Rt 495 Sb","Ramp-rt 495 Nb To Commonwealth Dr",
            "Ramp-rt 495 Nb To Rt 125 Conn","Ramp-rt 495 Sb To Rt 125 Conn","Ramp-rt 495 Sb To Rt 125 Nb",
            "Ramp-rt 495 Sb To Rt 125 Sb","Rampart Rd","Ramsay Road","Ramsdell Place","Ramsdell Rd",
            "Ramsey Dr","Ramsey Ln","Ramsey Rd","Ramsey Ridge Rd","Ramsey Shore Rd E","Ramsey St","Ramsey Way",
            "Ramsgate Dr","Ramsgate Pl","Ramsgate Road","Ramsgate Way","Ramshorn Road","Ramsy Ln","Ramtown-Greenville Rd",
            "Ramuda Ln","Ran Rd","Ranch Acre Rd","Ranch Ct","Ranch Dr","Ranch Hill Cv","Ranch Ln","Ranch Rd",
            "Ranch Ridge Cv E","Ranch Ridge Cv W","Ranch Road","Ranch Road 1058","Ranch Road 1412",
            "Ranch Road 2397","Ranch Road 2587","Ranch Road 3331","Ranch Road 687","Ranch View Ln",
            "Rancheria Creek Rd","Rancheria Dr","Rancheria Rd","Ranchero Ct","Ranchero Dr","Ranchette Rd",
            "Ranchita Canyon Rd","Ranchita Cir","Ranchito Dr","Ranchitos Ave","Ranchitos Ln","Ranchland Rd",
            "Rancho Aqua Hedonia","Rancho California Rd","Rancho Cir","Rancho Coast Way","Rancho Cordova St",
            "Rancho Ct","Rancho Dos Rios","Rancho Dr","Rancho Gaviota Ct","Rancho Hills Dr","Rancho Maria Rd",
            "Rancho Palmeras","Rancho Palms","Rancho Ramon Dr","Rancho Rd","Rancho Ridge Dr","Rancho Santa Barbara Dr",
            "Rancho Sequoia Dr","Rancho Verde Cir","Rancho Verde Dr","Rancho Villa Rd","Rancho Vista Dr",
            "Rancho de Fruta Ln","Rancho de Palomas Dr NE","Rancho del Sol","Ranchos Sin Vaca",
            "Rancocas Creek","Rancocas Ct","Rancocas Dr W","Rancocas Mt Holly Rd","Rancocas Rd","Rand Ave",
            "Rand Ct","Rand Rd","Rand St","Rand Street","Rand's Br","Randal St","Randall Ave","Randall Avenue",
            "Randall Cir","Randall Dr","Randall Drive","Randall Hill Rd","Randall Ln","Randall North Rd",
            "Randall Pl","Randall Rd","Randall Road","Randall St","Randall Trl","Randall Way","Randallsville Rd",
            "Randel Jean Way","Randell Beach Rd","Randi Ln","Randle Rd","Randlett Rd","Randlett St","Randolph Ave",
            "Randolph Ave SE","Randolph Ct","Randolph Dr","Randolph Pl","Randolph Rd","Randolph Road",
            "Randolph St","Randolph St NW","Randolph Street","Randolph Way","Random Oaks Rd","Rands Road",
            "Randsburg Rd","Randtz Mill Rd","Randy Ct","Randy Ln","Randy Rd","Ranere Ct","Raney Ln","Ranfield Rd",
            "Rang Creek","Range Avenue","Range Heights Circle","Range Heights Terrace","Range Line Road",
            "Range Rd","Range Road","Range View Ave","Rangeley Road","Rangeline Park Blvd","Ranger Ave",
            "Ranger Cir","Ranger Ct","Ranger Dr","Ranger Rd","Ranger St","Ranger Station Rd","Rangeview Dr",
            "Rangeway Road","Rangley Road","Rangoon Road","Rangoon St","Rankin Rd","Rankin St","Ranlett Ave",
            "Ranney Ave","Ranny Hill Rd","Ransom Rd","Ransom St","Ransomville Rd","Ranson Rd","Ranson St",
            "Ranstead St","Ranstone Gardens","Ranthom Ave","Rantool St","Rantoul Street","Rapelye St",
            "Rapert Avenue","Raphael Ct","Raphael Rivera Way","Raphael Street","Rapid City Rd","Rapid City Rd NW",
            "Rapid St","Rapids Road","Rapley Trl","Rappleyea Rd","Raptudee Dr","Raritan Ave","Raritan Blvd",
            "Raritan Rd","Raritan Reach Rd","Raritan Road","Raritan St","Rasberry Ln","Rascal Ct","Rasin Bee Runne",
            "Raskulinecz Rd","Rasmussen St","Rasor Rd","Raspas Hill Rd","Raspberry Ln","Raspberry Place",
            "Raspberry Rd","Raspberry Way","Rasselas Rd","Rater Rd","Rathbun Pl","Rathbun St","Rathburn",
            "Rathburn Ave","Rathburn Rd","Rathburn Road","Rathburn Road East","Rathburn Road West",
            "Rathburn Street","Rathell Rd","Rathfon Road","Rathgeber Dr","Rathlin Court","Rathmore Crescent",
            "Ratliff St","Rattler Rd","Rattlesnake Ct","Rattlesnake Gulch","Rattlesnake Ln","Rattlesnake Mountain Bdy Trl",
            "Rattlesnake Rd","Rattlesnake Ridge Rd","Rattlesnake Road","Rattlesnake Springs Rd",
            "Ratto Way","Rattray Park Drive","Rau St","Raub Hollow Rd","Rauber St","Rauch Rd","Rauhala Rd",
            "Raupp Rd","Ravanna St SE","Raven Ave","Raven Ct","Raven Dr","Raven Lane","Raven Rd","Raven Rock Rd",
            "Raven St","Raven Wood","Ravenbury Road","Ravencrest Ct","Ravenglen","Ravenhill","Ravenhurst Ave",
            "Ravens Rock","Ravens Way","Ravensbourne Crescent","Ravenscrest Drive","Ravenscroft Road",
            "Ravenswoo Road","Ravenwood","Ravenwood Ave","Ravenwood Dr","Ravenwood Pl NW","Ravin Rd",
            "Ravine Ave","Ravine Court","Ravine Ct","Ravine Dr","Ravine Drive","Ravine Park S","Ravine Rd",
            "Ravine Road","Ravine Trl","Rawhide Dr","Rawhide Pl","Rawle St","Rawlings Drive","Rawlinson Avenue",
            "Rawls Rd","Rawson Hill Drive","Ray Ave","Ray Ave SE","Ray Avenue","Ray Bass Rd","Ray Blvd",
            "Ray Coaker Hwy","Ray Ct","Ray Family Ln","Ray Lawson Boulevard","Ray St","Ray St S","Ray Street",
            "Ray Way","Raycroft Avenue","Raydol Ave","Rayfield Dr","Rayland Rd","Rayle Rd","Raylynn Ln",
            "Raymar Ct","Raymer St","Raymerville Drive","Raymond Ave","Raymond Avenue","Raymond Blvd",
            "Raymond Cir","Raymond Ct","Raymond Dr","Raymond Loop","Raymond Pl","Raymond Rd","Raymond Road",
            "Raymond Robertson Rd","Raymond St","Raymond Street","Raymonde Way","Raymonds Ln","Raymor Ct",
            "Raynel Rd","Rayner Rd","Rayner St","Raynes Dr","Raynette Ct","Raynolds St","Rayos de Luz","Rays Ct SW",
            "Rays Ln","Rayser St","Raytheon Rd","Raytmond Reed Blvd","Razorback Dr","Razorback Ln","Razorback Rd",
            "Rd 410 Loop","Rea Ave","Read Ave","Read Drive","Read Ln","Read Rd","Read St","Read Street","Readburn Rd",
            "Reade Street","Reader Ranch Rd","Reading Ave","Reading Ave SE","Reading-wakefield Rotary",
            "Readmond Rd","Readsboro Road","Ready Camp Rd","Ready St","Reagan Hill Rd","Reagan Ln","Reagan Pl",
            "Reagan Rd","Ream St NW","Reams Ct","Reams Rd","Reamwood Ave","Rear Powderly St","Rear Pure",
            "Rear Williams St","Reardon Rd","Reardon St","Reasoner Ln","Reata Pass","Reba Rd","Rebahene Plz",
            "Rebecca Ct","Rebecca Dr","Rebecca Lane","Rebecca Ln","Rebecca Pl","Rebecca Rd","Rebecca Street",
            "Rebecca Way","Rebeckahs Way","Rebeh Cv","Rebel Ave","Rebel Ct","Rebel Ln","Rebel Rd","Reber Rd",
            "Rebonito Rd","Rec Rd 11 N 65 D","Reclamation Rd","Record Ranch Rd","Recreation Dr","Recreation Pl",
            "Recreation Road","Rector Creek Rd","Rector Ln","Rector Rd","Rector St","Rectory Road","Recycling Center Rd",
            "Recycling Ln","Red Bain Lake","Red Bank Primary School Drivew","Red Bark Ln","Red Barn Dr",
            "Red Barn Rd","Red Barrel Dr","Red Bench Rd","Red Birch Ct","Red Bird Ln","Red Bluff Rd",
            "Red Bluff Trl","Red Bridge Campground","Red Bridge Rd","Red Brush Rd","Red Bud Ln","Red Cap Rd",
            "Red Cedar Dr","Red Cedar Ln","Red Cedar Rd","Red Cliff Lane","Red Clover Road","Red Coach Ct",
            "Red Coat Ln","Red Comet Ct","Red Cow Rd","Red Creek Rd","Red Dog Way","Red Dot Rd","Red Fern Ct",
            "Red Fir Rd","Red Fir Trl","Red Fork Bayou Rd","Red Fox Lane","Red Fox Ln","Red Fox Rd","Red Fox Rd NE",
            "Red Fox Way","Red Gable Ln","Red Gully Dr","Red Gum Ct","Red Hawk Cir","Red Hawk Ln","Red Hill Dr",
            "Red Hill Rd","Red Hills Ln","Red Hollow Dr","Red Hook Ln","Red Horse and Willow Tanks Rd",
            "Red Jacket Drive Rd","Red Knoll Rd","Red Lake Rd","Red Leaf Ln","Red Leaf Rd","Red Lion Ct NW",
            "Red Lion Rd","Red Maple Avenue","Red Maple Ct","Red Maple Dr","Red Maple Ln","Red Maple Road",
            "Red Mill Ln","Red Mountain Creek Rd","Red Mountain Rd","Red Mountain Rd NE","Red Mud Rd",
            "Red Oak","Red Oak N","Red Oak S","Red Oak Avenue","Red Oak Cir","Red Oak Crescent","Red Oak Ct",
            "Red Oak Dr","Red Oak Drive","Red Oak Ln","Red Oak Rd","Red Oak Run","Red Oak Ter","Red Oaks Dr",
            "Red Pass Lake Rd","Red Pine Crescent","Red Pines Dr","Red Raven Rd","Red Rd","Red River Rd",
            "Red Road 55","Red Robin Dr","Red Robinway","Red Rock Canyon","Red Rock Ct","Red Rock Hwy",
            "Red Rock Lane","Red Rock Ln","Red Rock Park main access road","Red Rock Ranch Rd",
            "Red Rock Rd","Red Rose Ln","Red Scott Cir","Red Shale Ct","Red Sky Rd NE","Red Sky Trl",
            "Red Springs Cut Off Rd","Red Squirrel Pl","Red Tail Dr","Red Tail Rd","Red Tip Ln","Red Valley Rd",
            "Red Wolf Way","Red Yucca Lane","Redbank Rd","Redbank Road","Redberry Ln","Redberry Parkway",
            "Redbird Crest Ln","Redbird Dr","Redbird Ln","Redbird Rd","Redbrook Ln","Redbud Ct","Redbud Cv",
            "Redbud Ln","Redbud Rd","Redbush Ter","Redcliff Boulevard","Redco Road","Reddick Road","Redding Ln",
            "Redding Rd","Redding Rd NW","Redding St","Redding Way","Reddington St","Redemption Rock Trail",
            "Redfern Dr","Redfield Canyon Rd","Redford Place","Redhawk Ln","Redkey Road","Redland Crescent E",
            "Redland Crescent W","Redleaf Ln","Redleaf Rd","Redlon Court","Redman Dr","Redmire St","Redmond Ridge Rd",
            "Redmond St","Redmont Rd NE","Redneck Dr","Rednor Road","Redoak Ct","Redondo Ave","Redondo Beach Ave",
            "Redondo Creek","Redondo Ct","Redondo Pl","Redondo St","Redpath Avenue","Redpath Road","Redpoll Court",
            "Redpost Ct","Redrock Dr","Redrock Ln","Redrock Way","Redstone Ln","Redstone Rd","Redstone Road",
            "Redstone Ter","Redthorn Court","Redus St","Redview Ct","Redwall Dr","Redway Road","Redwing Dr",
            "Redwood","Redwood Ave","Redwood Cir","Redwood Creek Rd","Redwood Ct","Redwood Dr","Redwood Drive",
            "Redwood Flat","Redwood Grove Rd","Redwood Highway","Redwood House Rd","Redwood Hwy","Redwood Ln",
            "Redwood Ln SE","Redwood Park Rd","Redwood Rd","Redwood Rise","Redwood Road","Redwood Springs Dr",
            "Redwood St","Redwood Street","Redwood Trails Cir","Redwood Way","Reece Way","Reed Ave","Reed Cir",
            "Reed Court","Reed Creek Rd","Reed Ct","Reed Dr","Reed Dr S","Reed Ln","Reed Mountain Rd","Reed Rd",
            "Reed St","Reed Street","Reede St","Reeder Ave","Reedland St","Reedles Rd","Reedmere St","Reeds Bay Road",
            "Reeds Lake Rd","Reeds Rd","Reef Ct","Reega Ave","Reen Dr","Reene Dr","Rees Rd","Rees St","Rees Street",
            "Reese Ave","Reese Ct","Reese River Rd","Reese St","Reetey Ave","Reeve Rd","Reeves Ct","Reeves Pheasant Way",
            "Reeves Pl","Reeves Rd","Reeves Station Rd","Reflections Ln","Reforma Rd","Refractories Dr",
            "Refuge Rd","Rega Pl","Regal Ave","Regal Ct","Regal Ct SW","Regal Dr","Regal Road","Regal St","Regal Sunset Ave",
            "Regal Vista Ave","Regal Way","Regan Dr","Regan Lee Ln","Regar Cir","Regatta Dr","Regatta Drive",
            "Regatta Row","Regency Ct","Regency Dr","Regency Drive","Regency Hill","Regency Hill Rd",
            "Regency Square","Regency St","Regency Way","Regent Ave","Regent Ct","Regent Dr","Regent Park Ct",
            "Regent Place","Regent Rd","Regent St","Regent Street","Regents","Regents Rd","Regents Terrace",
            "Reger Ct","Regiment Way","Regina Ave","Regina Avenue","Regina Ct","Regina Dr","Regina Terrace",
            "Regina Way","Regio Dr","Regional 21 Road","Regional 39 Road","Regional 45 Road","Regional 81 Road",
            "Regional High School Road","Regional Road","Regional Road 507","Regional Road 57",
            "Regis St","Regis Street","Registry Rd","Regner Ct","Regulus Rd","Regwill Avenue","Rehill Ct",
            "Rei St","Reibel St","Reichembach Dr","Reichling Ln","Reichswald Court","Reid Ave","Reid Drive",
            "Reid Rd","Reid Rotary","Reid Street","Reid Street W E","Reids Road","Reidy Dr","Reiff Rd",
            "Reikens Trl","Reilly St","Reillywood Ave","Reiman Ln","Reimer Rd","Reims Ct","Reims Dr","Reinclaud Ct",
            "Reindeer Ln","Reindeer Pl","Reindeer Trl","Reinhardt Rd","Reinman Rd","Reinmann Dr","Reins Way",
            "Reinway Ct","Reis Ave","Reiser St","Reisling Pl","Reiss Ln","Reith Way","Reldyes Ave","Relf Rd",
            "Relich Ave","Relief Route 54/70","Relief Rte","Reliez Manor","Rella Dr","Relroy Court","Remanso Rd",
            "Rembrandt Dr","Rembrandt Ln","Remembrance Drive","Remington Ave","Remington Blvd","Remington Ct",
            "Remington Drive","Remington Mine Rd","Remington Pky","Remington Rd","Remington Way","Remla St",
            "Remmey St","Remo Court","Remoleno St","Remont Cir","Remount Dr","Rempas Ct NW","Rempert Rd",
            "Remsen Ave","Remsen Pl","Remsen Rd","Remsen St","Remuda Dr","Ren Rock Rd","Rena Ct","Rena St",
            "Renaissance Blvd","Renaissance Blvd W","Renaissance Dr","Renaissance Pl","Renard Run",
            "Renarl Ave","Renas Way","Renata Ct","Renato Ct","Renberg Drive","Renders Ln","Rendova St","Rene Pl",
            "Renee Ct","Renee Cv","Renee Dr","Renee Drive","Renee Ln","Renee St","Renee Way","Renforth Drive",
            "Renfrew Ave","Renfrew Pl","Renfrew Rd","Renfroe Rd","Reniff Rd","Renken Dr","Rennard Dr","Rennie Ave",
            "Rennie Rd","Reno Ave","Reno Drive","Reno Loop Rd N","Reno Rd","Reno St","Renoak Way","Renova Drive",
            "Renown Road","Renshaw Rd","Renshaw St","Rensselaer Rd","Rentar Ln","Renville St","Renwick Ave",
            "Renwick Heights Rd","Renwick Ln","Renwick Place","Renyold's Cross Rd","Reo Ct","Reo Dr",
            "Repetto Ave","Replin Road","Reposa Way","Repton Ave","Requa St","Rescia St","Research Dr","Research Ln",
            "Research Rd SE","Research Way","Reseau Ave","Reseda Ave","Reservation Rd","Reserve St","Reservior Rd",
            "Reservior Road","Reservoir Ave","Reservoir Dam Rd","Reservoir Dr","Reservoir Hill Rd",
            "Reservoir Ln","Reservoir Park","Reservoir Place Dr","Reservoir Rd","Reservoir Road","Reservoir Run",
            "Reservoir St","Reservoir Street","Resica Falls Rd","Resitol Dr","Resolute Crescent","Resort Rd",
            "Rest Cloud Rd","Rest Glen Road","Restdale Rd","Restever Gate","Restful Ln","Restlawn Cemetery",
            "Reston Rd","Restrick Ct","Retabalo Rd","Retiro Way","Retner St","Retread Rd","Retta Ln","Retta St",
            "Rettigdale Way","Reuben St","Reuter Place","Revelle College Dr.","Revenue Run","Revere",
            "Revere Beach Parkway","Revere Ct","Revere Dr","Revere Pl","Revere Rd","Revere St","Revere Street",
            "Reverend J J Walters Ave","Review Pl","Revilo Avenue","Revis Ave","Revis Cutoff","Revolution Ln",
            "Rew Rd","Rewana Way","Rewe Street","Rex Ave","Rex Lake Cir","Rex Rd","Rex Ter","Rexall Ct","Rexburg Cir",
            "Rexdale Boulevard","Rexford Dr","Rexford Pl","Rexford St","Rexleigh Dr","Rexleigh Drive",
            "Rexton Road","Rexwood Ave","Rexwood Road","Rey de Copas Ln","Reyburn Dr","Reycraft Dr","Reyna Pl",
            "Reyna Rd","Reynard Ct","Reynard Dr","Reynard Lane","Reynold Cir","Reynold Dr","Reynold Pl",
            "Reynolds Ct","Reynolds Dr","Reynolds Drive","Reynolds Ln","Reynolds Pl","Reynolds Pond Rd",
            "Reynolds Rd","Reynolds St","Reynolds Street","Reytan Boulevard","Rhapsody Rd","Rhea Ln",
            "Rhea Run","Rhebergen Rd","Rheims Ct","Rhett Rd","Rhimes","Rhine Blvd","Rhine Ct","Rhinos Pl","Rhoades Way",
            "Rhoads Ln","Rhoda Ave","Rhode Island Pl NE","Rhode Island Road","Rhode Island St","Rhode Island St NE",
            "Rhode St","Rhodes Avenue","Rhodes Bailey Road","Rhodes Dr","Rhodes Ln","Rhodes Place","Rhodes Rd",
            "Rhodes Street","Rhodesia Rd","Rhonda Boulevard","Rhonda Dr","Rhonda Ln","Rhone Ln","Rhone Valley Way",
            "Rhone Way","Rhus St","Rhyl Avenue","Rhyolite Dr","Riale Ave","Rialto Ave","Rialto Drive","Rialto Ln",
            "Rialto Way","Riant Street","Riata Ct","Riata Valley Cir","Ribaud Ave","Ribblesdale Drive",
            "Ribe Rd","Ribeiro Ln","Ribier Ct","Ricardo Ln","Ricardo Rd","Rice Ave","Rice Canyon Rd","Rice Cir",
            "Rice Circle","Rice Creek Rd","Rice Ln","Rice Rd","Rice Road","Rice St","Rice Street","Riceville Rd",
            "Rich","Rich Ave","Rich Ct","Rich Rd","Rich Street","Rich Valley Rd","Richard","Richard Ave","Richard Clark Drive",
            "Richard Ct","Richard Dr","Richard Drive","Richard Ln","Richard Rd","Richard St","Richard Street",
            "Richard Ter","Richard Travis Rd","Richard Weeks Ln","Richardo Dr","Richards Ave","Richards Blvd",
            "Richards Dr","Richards Rd","Richards Road","Richards St","Richards Street","Richards Way",
            "Richardson Ave","Richardson Avenue","Richardson Canyon Rd","Richardson Ln","Richardson Rd",
            "Richardson Road","Richardson St","Richardson Street","Richboro Newtown Rd","Richdale Ave",
            "Riche Ave","Richelieu Circle","Richelieu Drive","Richfield Place","Richford Ter","Richgrove Dr",
            "Richie Avenue","Richie Perez Jr Dr","Richland Ave","Richland Ct","Richland Road","Richler Drive",
            "Richley Rd","Richline Hill Rd","Richline Rd","Richman Rd","Richmond Ave","Richmond Avenue",
            "Richmond Court","Richmond Crescent","Richmond Ct","Richmond Drive","Richmond Hill Dr",
            "Richmond Hill Rd","Richmond Hill Road","Richmond Ln","Richmond Mills Road","Richmond Pky",
            "Richmond Rd","Richmond Road","Richmond St","Richmond Street","Richmond Street East","Richmond Street West",
            "Richmond Ter","Richmonde Ct","Richmont Rd","Richolson","Richview Court","Richview Road",
            "Richville Bridge Rd","Richwood Dr","Richwood Rd","Rick Rd","Rickdale Rd","Ricket Rd","Rickets Rd",
            "Rickey Dr","Rickey St","Rickingham Dr","Ricklan Drive","Ricks Ln","Ricks Ranch Rd","Ricksue St",
            "Rickwood Caverns Rd","Rickwood Ct NW","Rickwood Lane","Ricky Ct","Ricky Rd","Rico Dr S",
            "Riddell Road","Riddie Pl","Riddle Ave","Riddle Hill Road","Riddle St","Rideau Ferry Road",
            "Rideau Lake Road","Rideau Street","Rideout Way","Rider St","Riders Run","Riders Switch",
            "Ridge","Ridge Ave","Ridge Ave SE","Ridge Avenue","Ridge Blvd","Ridge Crest Dr","Ridge Ct","Ridge Ct S",
            "Ridge Dr","Ridge Dr B","Ridge Drive Park","Ridge Line","Ridge Ln","Ridge Loop","Ridge Mesa Ct",
            "Ridge Pine Rd","Ridge Pl","Ridge Point Drive","Ridge Rd","Ridge Road","Ridge Route Rd","Ridge St",
            "Ridge Street","Ridge Ter","Ridge Top Court","Ridge Top Rd","Ridge Trail","Ridge Valley Dr",
            "Ridge View Ct","Ridge View Heights","Ridge View Rd","Ridge Way","Ridge Way Rd","Ridge Willow",
            "Ridge Wood Pl","Ridge-Line","Ridgebury Blvd","Ridgecrest","Ridgecrest Blvd","Ridgecrest Cir",
            "Ridgecrest Ct","Ridgecrest Dr","Ridgecrest Pl","Ridgecrest Rd","Ridgecrest Rd SE","Ridgecrest Road",
            "Ridgecrest Ter NW","Ridgecrest Terrace","Ridgedale Ave","Ridgedale Cir","Ridgefield Ave",
            "Ridgefield Dr","Ridgefield Road","Ridgegate Row","Ridgegate St","Ridgeland St","Ridgeland Ter",
            "Ridgeley St","Ridgeline Dr","Ridgely Pl NW","Ridgemar Rd","Ridgemont Ct","Ridgemont Dr",
            "Ridgemont Plz","Ridgemont Rd","Ridgemoor Rd","Ridgemoor Way","Ridgemount Crescent","Ridgemount Dr",
            "Ridgepath Ct","Ridgeside Dr","Ridgeside St","Ridgestone Court","Ridgeton Ln","Ridgevalley Crescent",
            "Ridgeview Ave","Ridgeview Cir","Ridgeview Ct","Ridgeview Dr","Ridgeview Drive South",
            "Ridgeview Ln","Ridgeview Rd","Ridgeview Ter","Ridgeway","Ridgeway Ave","Ridgeway Avenue",
            "Ridgeway Pl","Ridgeway Rd","Ridgeway Road","Ridgeway St","Ridgewood Ave","Ridgewood Avenue",
            "Ridgewood Ct SE","Ridgewood Dr","Ridgewood Drive Extension","Ridgewood Hill Rd","Ridgewood Ln",
            "Ridgewood Pl","Ridgewood Rd","Ridgewood Road","Ridgewood St","Ridgewood Ter","Ridgewood Way",
            "Ridgley Rd","Ridley Ave","Ridley Boulevard","Ridley Crescent","Ridley Ct","Ridout Street",
            "Riefler Rd","Riegelsville Warren Glen Rd","Riehl Rd","Riel Drive","Rieman Rd","Riesling Ct",
            "Riesling Pl","Riffle Run 16/20","Rifle Camp Rd","Rifle Dr","Rifle River Rd","Riga St","Rigel Ave",
            "Rigel Dr SW","Rigens Plz","Rigg Rd","Rigg St","Riggs Crest Rd","Riggs St","Riggsville Rd","Right of Way",
            "Righter Parkway","Righter St","Righters Mill Rd","Rigoni Rd","Riker Ave","Riley","Riley Ave",
            "Riley Cir","Riley Ct","Riley Dr","Riley Rd","Riley St","Riley Switch Road","Rill Ave","Rilla Way",
            "Rillington Cir","Rim Ct","Rim Rd","Rim Rock Dr","Rim Rock Way","Rim View Ln","Rimby Ave","Rimfield Dr",
            "Rimmele Rd","Rimrock Dr","Rimrock Rd","Rimwood Circle","Rinaldo Road","Rinard Rd","Rincon Ave",
            "Rincon Ct","Rincon Dr","Rincon Rd","Rincon de Cholla","Rinconada Dr","Rindge Rd","Rindge Road",
            "Rines Rd","Ring Rd","Ring Road","Ring St","Ringe Rd","Ringer Rd","Ringgold St","Ringold St","Ringwood Ln",
            "Rio Abajo Dr","Rio Abajo Rd SE","Rio Alto Dr","Rio Arriba County Road 0077","Rio Arriba Ct NE",
            "Rio Ave SW","Rio Bravo Dr","Rio Chico Cir","Rio Colorado Ranchos","Rio Communities Way",
            "Rio Dixon Rd","Rio Dorado","Rio Dosa Dr","Rio Encanto Ct","Rio Grande Ave","Rio Grande Ct",
            "Rio Grande St","Rio Lindo Shores Dr","Rio Mariel Dr","Rio Mimbres Rd NE","Rio Mirada Dr",
            "Rio Orilla Ln NW","Rio Penasco Rd","Rio Poco Dr","Rio Puerco","Rio Rd","Rio Seco Ct","Rio Seco Dr",
            "Rio St","Rio Valle Ct","Rio Valley","Rio Verde Cir","Rio Verde Dr","Rio Vista","Rio Vista Ct",
            "Rio Vista Dr","Rio Vista Dr NE","Rio Vista Ln","Rio Way","Rio Wrangler Pk","Rios Canyon Rd",
            "Rios St","Rip Rap Rd","Ripley Ave","Ripley Ct","Ripley Landing Rd","Ripley Lane","Ripley Ln",
            "Ripley Rd","Ripley St","Ripple Ln","Ripple Stream St","Ripple Way","Risebrough Circuit",
            "Risecliff Dr","Riseley St","Rishi Ridge Rd","Rising Hill Way","Rising Legend Way","Rising Sun Ct",
            "Rising Sun Rd","Rising Sun Tavern Rd","Risku Rd","Risley Ave","Risman Dr","Risso Court",
            "Rita Avenue","Rita Cir","Rita Ct","Rita Dr","Rita Lane","Rita Pl","Ritchie Ave","Ritchie Avenue",
            "Ritchie Cir","Ritchie Ct","Ritchie St","Ritchscott Dr","Ritorto Court","Ritsema Ct","Ritson Road",
            "Ritson Road South","Rittenhouse Ave E","Rittenhouse Ct","Rittenhouse Square","Ritter Dr",
            "Ritts Mill Rd","Ritz Ave","Riva Blvd","Riva Dr","Riva Ridge Ct","Riva Ridge Rd","Rivard Lane",
            "Rivas Canyon Rd","Riveerside Ln","River","River Annex Rd","River Ave","River Bank Rd","River Bend Dr",
            "River Bend Rd","River Birch Cv","River Birch Rd","River Blue Run Rd","River Bluff St",
            "River Blvd","River Breeze Dr","River Bridge Rd","River Cir","River Crescent","River Crest Circle North",
            "River Crossing Way","River Ct","River Dell Rd","River Ditch","River Dr","River Drive South",
            "River Edge Ln","River Edge Rd","River Farms Dr","River Front Dr","River Gardens Dr","River Head Rd",
            "River Heights Dr","River Heights Road","River Hill Dr","River Keep Pl","River Lane","River Lea Lane",
            "River Levee","River Ln","River Look Ln","River Meadow Court","River Mist","River Mt Rd",
            "River Oak Ln","River Oaks Dr","River Park Ave","River Park Cir","River Park Dr","River Pky",
            "River Place","River Pointe","River Rd","River Rd E","River Ridge Boulevard","River Ridge Rd",
            "River Road","River Road Cir","River Run Rd","River Running Rd","River St","River St SE",
            "River Street","River Terrace","River Trace Cv","River Trl","River Valley Crescent","River Valley Dr",
            "River Valley Rd","River View Avenue","River View Dr","River View Ln","River Vista Dr",
            "River Walk","River Walk Cir","River Woodland Trl","Riverbank Court","Riverbank Dr","Riverbank Ln",
            "Riverbank Rd","Riverbank Road","Riverbend Ct","Riverbend Drive","Riverbend Way","Riverbirch Ct",
            "Riverbrook Ct","Rivercrest Ct","Rivercrest Rd","Riverdale Ave","Riverdale Avenue","Riverdale Dr",
            "Riverdale Drive","Riverdale Rd","Riveredge Drive","Riveredge Rd","Riveredge Trl","Riverflowage Rd",
            "Riverfront Cir","Riverfront Dr","Riverhill","Riverlake West Dr","Riverlands Avenue","Riverlea Road",
            "Rivermill Boulevard","Rivermont Ct","Rivermont Rd","Riverpark Dr","Riverrock Dr","Rivers Edge Ln",
            "Rivers Edge Trl","Rivers End Rd","Rivers St","Riversbend Dr","Riverside Ave","Riverside Avenue",
            "Riverside Boulevard","Riverside Cemetery Rd","Riverside Ct","Riverside Dr","Riverside Dr W",
            "Riverside Drive","Riverside Drive South","Riverside Ln","Riverside Manor Trl","Riverside Park",
            "Riverside Parkway","Riverside Pl","Riverside Rd","Riverside St","Riverside Terrace","Riverside Way",
            "Riverspray Crescent","Riverstone Ct","Riverton Ave","Riverton Rose Trl","Rivertrail",
            "Riverveiw Dr","Riverview","Riverview Ave","Riverview Avenue","Riverview Boulevard","Riverview Cv",
            "Riverview Dr","Riverview Dr; Vista del Monte","Riverview Drive","Riverview Heights",
            "Riverview Ln","Riverview Pky S","Riverview Pl","Riverview Place","Riverview Rd","Riverview St",
            "Riverview Street","Riverview Ter","Riverwalk","Riverwalk Dr","Riverwalk Drive","Riverwood Ct",
            "Riverwood Dr","Riverwood Park Road","Riverwoods Trl","Rives Junction Rd","Rivet Street",
            "Riviera Ave","Riviera Cir","Riviera Ct","Riviera Dr","Riviera Drive","Riviera Ln","Rivington Ave",
            "Rivington Street","Rivulet Street","Rix Mills Rd","Roach Street","Road 100","Road 1030",
            "Road 104","Road 1054","Road 109A","Road 11","Road 11/13","Road 1108","Road 112","Road 114","Road 120",
            "Road 126","Road 128","Road 130","Road 1315","Road 1317","Road 132","Road 1326","Road 14","Road 1400",
            "Road 142","Road 144","Road 148","Road 15","Road 15 3/4","Road 1517","Road 153","Road 156","Road 16",
            "Road 160","Road 164","Road 166","Road 168","Road 172","Road 178","Road 1783","Road 180","Road 1800",
            "Road 184","Road 188","Road 19","Road 20","Road 200","Road 204","Road 206","Road 208","Road 21","Road 2125",
            "Road 22","Road 220","Road 223","Road 224","Road 229","Road 23","Road 232","Road 2350","Road 2391",
            "Road 24","Road 243","Road 248","Road 25","Road 25 1/2","Road 258","Road 26","Road 260","Road 262",
            "Road 2633","Road 28","Road 286","Road 292","Road 2957","Road 2960","Road 3","Road 30","Road 303",
            "Road 304","Road 3059","Road 307","Road 308","Road 311","Road 3118","Road 3151","Road 32","Road 326",
            "Road 3315","Road 3335","Road 34","Road 34 3/4","Road 3538","Road 3629","Road 3674","Road 3778",
            "Road 3795","Road 3925","Road 4","Road 40","Road 400","Road 401","Road 403","Road 412","Road 4140",
            "Road 417","Road 426","Road 428","Road 435","Road 4599","Road 4660","Road 471","Road 4775","Road 49",
            "Road 4A","Road 5018","Road 509","Road 5209","Road 5280","Road 5285","Road 5570","Road 562","Road 61",
            "Road 6194","Road 6299","Road 6360","Road 6405","Road 6486","Road 6557","Road 6670","Road 6677",
            "Road 6689","Road 67150","Road 6737","Road 6786","Road 6788","Road 69","Road 6900","Road 7190",
            "Road 72","Road 7240","Road 7560","Road 8003","Road 8022","Road 8029","Road 8085","Road 84","Road 88",
            "Road 894","Road 9","Road 92B","Road 9403","Road 95B","Road 96","Road A","Road Aa","Road B","Road E",
            "Road Gg","Road Hh","Road I","Road J 5","Road Kill Rd","Road N Bia 121","Road N7601","Road Nr56B",
            "Road Number 6","Road Runner Ln","Road Runner Loop","Road To Grandma's House","Road To Water Dist",
            "Road Z","Roadmaster Ln","Roadrunner Dr","Roadrunner Ln","Roads End","Roadside Park Dr","Roadway",
            "Roadway 'b'","Roan Ave","Roan Ct","Roanoke Ave","Roanoke Ct","Roanoke Rd","Roanoke Road","Roaring Brook Rd",
            "Roaring Lion Ave","Roaring Plains","Roaring River Dr","Roaring Rock Rd","Roaring Rocks Rd",
            "Roark Ave","Roat St","Rob Pomeroy Rd","Robak Dr","Roban Ave","Robber's Gulch","Robbie Ave",
            "Robbie Burns Road","Robbie Crescent","Robbiedowell Rd","Robbin Ave","Robbins","Robbins Avenue",
            "Robbins Ct","Robbins Dr","Robbins Point Dr","Robbins Road","Robbins St","Robbins Street",
            "Robbinsville Edinburg Rd","Robby Rd","Roberson Rd","Robert Adams Drive","Robert C Keri Ct",
            "Robert Cir","Robert Ct","Robert Dr","Robert E Lee Way","Robert F Wagner Sr Place","Robert J Miller Air Park",
            "Robert King Ln","Robert Kirtley Dr","Robert Llyod Ln","Robert M Copeland Circle","Robert Moses Pkwy",
            "Robert Moses Pky","Robert Pearson Ct","Robert Pl","Robert Rd","Robert Road","Robert Rogers Rd",
            "Robert St","Robert Street","Robert Ter","Robert Warfield Ct","Robert Way","Robert Wynn St",
            "Roberta Ave","Roberta Bay","Roberta Ct","Roberta Dr","Roberta Pl NE","Roberta Rd","Roberta St",
            "Roberts Aly","Roberts Ave","Roberts Ave W","Roberts Chapel Rd","Roberts Cir","Roberts Dr",
            "Roberts Lane","Roberts Ln","Roberts Loop","Roberts Pl","Roberts Rd","Roberts Ridge St Joseph Rd",
            "Roberts Road","Roberts St","Roberts St SW","Roberts Way","Robertsfield Crescent","Robertson Ave",
            "Robertson Close","Robertson Crescent","Robertson Gin Rd","Robertson Lake Rd","Robertson Lane",
            "Robertson Place","Robertson Rd","Robertson St","Robertson Street","Robeth Ln","Robey Ter",
            "Robillard Road","Robin","Robin Ave NE","Robin Cir","Robin Ct","Robin Dr","Robin Hill Rd","Robin Hood Drive",
            "Robin Hood Lane","Robin Hood Rd","Robin Hood Road","Robin Ln","Robin Pl","Robin Rd","Robin Road",
            "Robin St","Robin Street","Robin Terrace","Robin Way","Robin's Nest Drive","Robindale Ave",
            "Robindale Road","Robindale St","Robinhaven Dr","Robinhood Dr","Robinhood Dr SE","Robinhood Extended",
            "Robinhood Lane","Robins Island Road","Robinson Aly","Robinson Ave","Robinson Avenue",
            "Robinson Canyon Rd","Robinson Court","Robinson Ct","Robinson Dr","Robinson Ln","Robinson Loop",
            "Robinson Place","Robinson Point Rd","Robinson Rd","Robinson Ridge Rd","Robinson Road",
            "Robinson St","Robinson Street","Robinson Stub Rd","Robinwood Blvd","Robinwood Ct","Robinwood Dr",
            "Robinwood Farm","Robinwood Rd","Robinwood Road","Robison Acres Rd","Robison Ct","Robitisha Ave",
            "Roble Ave","Roble Rd","Roble St","Roble Wash","Robles Way","Roblin Avenue","Roblin Road","Roblocke Avenue",
            "Robson Cir S","Robuffa St","Robwil Dr","Robyn Road","Roca Ct","Rocca Secca Rd","Rocco St","Rochambeau Rd",
            "Rochambeau Street","Rochdale Avenue","Rochdale Rd","Roche Dr","Roche Way","Rochedale Ln",
            "Rochelle Ave","Rochelle Ct","Rochelle Dr","Rochelle Drive","Rochelle Pl","Rocher Pl","Rochester St",
            "Rochester Water Authority","Rochlen St","Rochman Boulevard","Rocio St","Rock Beach Rd",
            "Rock Bridge Rd","Rock Chuck Cir","Rock City St","Rock Creek Campground","Rock Creek Church Rd",
            "Rock Creek Dr","Rock Creek Rd","Rock Creek Trl","Rock Crest Ln","Rock Crest St","Rock Cros Lane",
            "Rock Ct","Rock Cut Rd","Rock Gap Rd","Rock Glen Ln","Rock Haven Dr","Rock Hill Ln","Rock Hole Ln",
            "Rock Hollow Rd","Rock House Rd","Rock Island Dr","Rock Island St","Rock Ledge Ln","Rock Ln",
            "Rock Mill Run","Rock Mills Rd","Rock N Pines Rd","Rock O'dundee Road","Rock Oak Rd","Rock Pine Dr",
            "Rock Pit Rd","Rock Pl","Rock Quarry Rd","Rock Rd","Rock Ridge Rd","Rock River Rd","Rock Spring Cir",
            "Rock Spring Rd","Rock Springs Ct","Rock Springs Rd","Rock St","Rock Strain Dr","Rock Street",
            "Rock Terrace Trl","Rock n' Wood Rd","Rockafellows Mill Rd","Rockawack Ave","Rockaway Avenue",
            "Rockaway Beach Place","Rockaway Ct","Rockaway Ln","Rockaway Point Blvd","Rockaway Road",
            "Rockaway St","Rockbottom St","Rockbound Ct","Rockbound Ln","Rockbridge Ct","Rockcastle Drive",
            "Rockcliffe Boulevard","Rockcliffe Road","Rockcreek Way","Rockdale Avenue","Rockdale Ct",
            "Rockdale Dr","Rockdale Park","Rockdale Rd","Rockefeller Road","Rockelm Avenue","Rocker Cir",
            "Rockfield Dr","Rockford Ave","Rockford Court","Rockford Pines","Rockford Rd","Rockhaven Rd",
            "Rockhill Dr","Rockhill Road","Rockhurst Dr","Rockhurst Ln","Rocking Chair Rd","Rocking Horse Dr",
            "Rocking Horse Rd","Rocking K Ranch Rd","Rocking Spear Ranch Rd","Rocking Star Ct",
            "Rockingham Avenue","Rockingham Park Blvd","Rockingham Place","Rockingham Rd","Rockingham St",
            "Rockland Ave","Rockland Ave N","Rockland Ave S","Rockland Circle","Rockland Court","Rockland Ct",
            "Rockland Dr","Rockland Lake Rd","Rockland Rd","Rockland St","Rockland Street","Rocklands Road",
            "Rocklawn Avenue","Rockledge","Rockledge Ave","Rockledge Cir","Rockledge Ct","Rockledge Dr",
            "Rockledge Pl","Rockledge Rd","Rockledge St","Rockleigh Rd","Rocklin Mobile Home Park",
            "Rocklyn Ct","Rockmeadow Road","Rockne Dr","Rockoak Rd","Rockoff Ct","Rockport Ave","Rockport Crescent",
            "Rockport Dr","Rockport Way","Rockridge Ave","Rockside Woods Blvd","Rocksprings Road",
            "Rockstone Ct","Rockstone Rd","Rocktown Lambertville Rd","Rocktown Rd","Rockvale Road",
            "Rockview Ave","Rockview Cir","Rockview Dr","Rockville Heights","Rockville Rd","Rockwell Ave",
            "Rockwell Ct","Rockwell Dr","Rockwell Rd","Rockwell Road","Rockwell Springs Ct","Rockwell St",
            "Rockwood Avenue","Rockwood Drive","Rockwood Pl","Rockwood Rd","Rockwood St","Rockwood Ter",
            "Rocky Bayou Ridge Rd","Rocky Branch Rd","Rocky Brook Drive","Rocky Ct","Rocky Dell Rd",
            "Rocky Dundee Rd","Rocky Heights Rd","Rocky Hill Rd","Rocky Hill Road","Rocky Lane","Rocky Ln",
            "Rocky Peak Fire Road","Rocky Pine Rd","Rocky Plains Dr","Rocky Plains Rd","Rocky Point Trail",
            "Rocky Pound Rd","Rocky Ranch Rd","Rocky Rd","Rocky Ridge Road","Rocky Ridge Dr","Rocky Ridge Ln",
            "Rocky Ridge Rd","Rocky Road","Rocky Road Ave","Rocky Run Parkway","Rocky St","Rocky Top Rd",
            "Rocky Way","Rocky Woods Street","Rocoso Rd","Rod & Gun Club Rd","Rod Ct","Rod Laver Ln",
            "Rod Smith Pl","Rodd's Lane","Rodda Boulevard","Rodear Rd","Rodel St","Roden Place","Roden Rd",
            "Rodeo","Rodeo Ave","Rodeo Ct","Rodeo Dr","Rodeo Rd","Rodeo Road","Rodes Aly","Rodes Rd","Rodger Way",
            "Rodgers Dr","Rodgers Mountain Way","Rodi Cv","Rodick Road","Rodman Ave NE","Rodman St","Rodney Ln",
            "Rodney Rd","Rodney Street","Rodriguez Rd","Rodriguez Spur Truck Trail","Rodriguez St",
            "Roe Ave","Roe Ln","Roe Rd","Roe St","Roebling Street","Roehampton Avenue","Roehampton Crescent",
            "Roemer Rd","Roeser Road","Roetzer St","Roff Ave","Roff St","Roger Dr","Roger Hollow Rd","Roger Rd",
            "Roger St","Roger Street","Rogers Ave","Rogers Dr","Rogers Ln","Rogers Pl","Rogers Place","Rogers Rd",
            "Rogers Road","Rogers St","Rogers Way","Roggen Ln","Roggia Rd","Rogo St","Rogue River Natl Forest",
            "Rohatyn St","Rohnert Park Expressway","Rohrer Dr","Rojas Dr","Rojo Cir","Rokeby Pl","Roki Blvd",
            "Roland Ave","Roland Ln","Roland Pl","Roland Road","Roland St","Roland Wiley Rd","Roleson","Rolewicz Ln",
            "Roll St","Rolland Ave","Roller Coaster Rd","Rolleston Road","Rolling Acres Dr","Rolling Acres Drive",
            "Rolling Ct","Rolling Forest Dr","Rolling Glen Dr","Rolling Green","Rolling Green Dr",
            "Rolling Hill Ave","Rolling Hill Ct","Rolling Hill Dr","Rolling Hills Cir","Rolling Hills Ct",
            "Rolling Hills Ln","Rolling Hills Rd","Rolling Meadow Ct","Rolling Meadow Ln","Rolling Meadows",
            "Rolling Meadows Cir","Rolling Meadows Dr","Rolling Oaks Ln","Rolling Rd","Rolling Ridge Dr",
            "Rolling Ridge Rd","Rolling Ridge Road","Rolling River Ln","Rolling Way","Rolling Woods Dr",
            "Rollingwood Dr","Rollingwood Drive","Rollins Ave","Rollins Dr","Rollins Street","Rollinson Road",
            "Rollo Drive","Rollo Ln","Rollo Rd","Roma Ave NE","Roma St","Roma Street","Romac Drive","Romae Ct",
            "Romain Pky","Romaine Ave","Romaine Pl","Romaine St","Roman Blvd","Roman Dr","Roman Ln","Roman Way",
            "Romana Dr","Romanesca Dr","Romano Ave","Romanowski St","Romar St","Rome Avenue","Rome Blvd",
            "Rome Dr","Rome Oneida Road","Rome Rd","Rome Road","Rome St","Romeika Rd","Romeo Ct","Romero Ave",
            "Romero Canyon Rd","Romero Ln","Romero St","Rometown Drive","Romfield Circuit","Romford Ln",
            "Romney Dr","Romo St","Romola Road","Romola St","Romolo Pl","Romualda Ct","Ron Ave","Ron Mace Cir",
            "Ronald Ct","Ronald Dr","Ronald Ln","Ronald Rd","Ronald Way","Roncesvalles Avenue","Roncy Rd",
            "Ronda Lane","Rondale Cir NW","Rondaxe Mt Trl","Rondeau Drive","Rondeau Street","Rondelle Place",
            "Rondo Rd","Ronita Ln","Ronna Ct","Ronnail Rd","Ronnie Dr","Ronnie Way","Rook Pl","Rookery Cir",
            "Rooks Dr","Rookwood Dr","Rooney Cir","Rooney Gate","Roop Rd","Roosa Rd","Roosevelt","Roosevelt Ave",
            "Roosevelt Ave NE","Roosevelt Avenue","Roosevelt Blvd","Roosevelt Cir E","Roosevelt Court",
            "Roosevelt Dr","Roosevelt Pl","Roosevelt Rd","Roosevelt Road","Roosevelt St","Roosevelt Street",
            "Roosevelt Ter","Roosevelt Trl","Rooseveltown Access Rd","Roots Ln","Rope Rd","Roper Rd",
            "Roper Street","Ropes Street","Rorer St","Rosa Circle","Rosa Ln","Rosa M Richarson Ave","Rosa Parks Dr",
            "Rosa Rd","Rosa St","Rosal Rd","Rosalia Ln","Rosalia St","Rosalie Ave NW","Rosalie St","Rosalie Way",
            "Rosalind Dr","Rosalita Ave","Rosalita Dr","Rosalyn Ct","Rosanna Crescent","Rosanne St","Rosary Ave",
            "Rosbolt Rd","Rosboro Loop","Roscoe Ave","Rose Abbey Drive","Rose Aly","Rose Arbor Cir","Rose Ave",
            "Rose Avenue","Rose Branch Drive","Rose Bush Way","Rose Cir","Rose Ct","Rose Cyn Ln","Rose Dr",
            "Rose Garden St","Rose Glen Rd","Rose Glen Road","Rose Glen Road N","Rose Haven Ave","Rose Heather St",
            "Rose Hill Ave","Rose Hill Cutoff Rd","Rose Hill St","Rose Hollow Hill","Rose Kennedy Dr",
            "Rose Lane","Rose Lane Rd","Rose Ln","Rose Marie Dr","Rose Meadow Court","Rose Meadow Pl",
            "Rose Park Drive","Rose Ranch Rd","Rose Rd","Rose Reflet Pl","Rose Rita Ter","Rose St","Rose Stone",
            "Rose Street","Rose Terrace","Rose Tree Dr","Rose Trl","Rose Valley Crescent","Rose Valley Rd",
            "Rose Vista Ct","Rose Way","Rose of Sharon Ln","Rose of Trallee Pl","Roseanne Ln","Rosebank Mt Olive Rd",
            "Rosebank Pl","Rosebank Road","Rosebank Road S","Roseberry St","Rosebery Ct","Rosebrook Hill Rd",
            "Rosebud Ave","Rosebud Ct","Rosebud Rd","Rosebush Ct","Rosebush Road","Rosecliff Dr","Rosecrans Ave",
            "Rosecrest Rd","Rosedale","Rosedale Ave","Rosedale Avenue","Rosedale Dr","Rosedale Heights Drive",
            "Rosedale Hwy","Rosedale Road","Rosedale Road N","Rosedale Ter","Rosedale Valley Road",
            "Rosedene Road","Rosefield Dr","Rosehaven Ln","Rosehill Avenue","Rosehill Pl","Roseland Ave",
            "Roseland Cir","Roseland Ct","Roseland Rd","Roseland St","Roselawn Avenue","Rosell Ave","Roselle Ave",
            "Roselyn Ter","Roseman Creek Rd","Rosemar Ter","Rosemarie Crescent","Rosemarie St","Rosemary",
            "Rosemary Ave","Rosemary Ct","Rosemary Drive","Rosemary Lane","Rosemary Ln","Rosemary St",
            "Rosemead Blvd","Rosemead Blvd / SR-19 South (/ Ramona Blvd) offramp","Rosemont Aly",
            "Rosemont Ave","Rosemont Ave NE","Rosemont Ave NW","Rosemont Cir","Rosemont Ct","Rosemont Dr",
            "Rosemore Ct","Rosemount St","Rosena Lane","Rosendale Dr","Rosendo Garcia Rd SW","Rosenfeld Drive",
            "Rosenkrans Ln","Rosenthal Street","Rosenwald St","Rosestone Ln","Roseton Ave","Rosetown Rd",
            "Rosevelt Ave","Rosevelt Rd B","Roseview Ln","Roseville Byp","Roseville Bypass","Roseway Ct",
            "Roseway Drive","Rosewood Ave","Rosewood Blvd","Rosewood Cir","Rosewood Ct","Rosewood Dr",
            "Rosewood Drive","Rosewood Ln","Rosewood Pl","Rosewood St","Rosewood Ter","Roseworthy Dr",
            "Roshell Rd","Rosie Ln","Rosilee","Rosina Ct","Rosina Pl","Rosinante Rd","Rosita St","Roslyn","Roslyn Ave NW",
            "Roslyn Ave SW","Roslyn Ct","Roslyn Rd","Roslyndale Ave","Rosmere Street","Rosol Ln","Ross Alley",
            "Ross Ave","Ross Clark Cir","Ross Corner Rd","Ross Crossing Rd","Ross Ct","Ross Dr","Ross Gate Way",
            "Ross Ln","Ross Park Blvd","Ross Pl","Ross Place","Ross Rd","Ross Road","Ross St","Ross Station Rd",
            "Ross Street","Rossdale Ct","Rosseau Road","Rossen Pl","Rosseter Street","Rossi Ct","Rossi Rd",
            "Rossie-Macomb Rd","Rossini Ct NE","Rossini Ln","Rossland Road W","Rossman Street","Rossmore Ave",
            "Rossmore Dr","Rossmore Road","Rosstrevor Road","Roswall Ln","Roswell Creek Rd","Roswell Ln",
            "Roswell St","Roswell Ter","Rosy Hill Rd","Rosy Ridge Ct","Roszel Rd","Rotary Dr","Rotary Lane",
            "Rotary Rd","Rote Hill Road","Roth Rd","Rothbury Dr","Rother Ln","Rotherby Cir","Rothsay Avenue",
            "Rothwell Ct","Rottau Ave","Rotterdam Rd E","Rotunda Dr","Rou Cir","Rouch Rd","Rouen","Rouge Bank Drive",
            "Rouge Highlands Drive","Rouge River Drive","Rouge St","Rouge Street","Rouge Valley Drive",
            "Rougecrest Drive","Rougemount Drive","Rouleau Dr","Roulx Dr","Roumfort Ave","Round Hill Ct",
            "Round Hill Rd","Round Hill School Rd","Round House Rd","Round Island","Round Lake Road",
            "Round Mountain Rd","Round Pond Rd","Round Ridge Rd","Round Robin St","Round Table Rd",
            "Round Top Dr","Round Top Loop Trail","Round Valley Rd","Round-Up Rd","Roundelay Court",
            "Roundheaed Mountain","Roundhill Ct","Roundhouse","Roundhouse Rd","Roundsville Ln","Roundtop Rd",
            "Roundtree Blvd","Roundtree Road","Roundup Ave","Roundup Dr","Roundup Trl","Roundwood Dr",
            "Rounseville Road","Roupp Ln","Rourke Place","Rourke Rd","Rouse Ave","Rouse Rd","Rouses Rd",
            "Rousseau Ln","Rousso Rd","Route 1","Route 10","Route 116","Route 140","Route 15","Route 2","Route 2007",
            "Route 202","Route 22","Route 22 Eastbound","Route 22 Westbound","Route 24","Route 24 Eastbound",
            "Route 240","Route 3","Route 340","Route 380","Route 39N93","Route 44","Route 506","Route 506 Spur",
            "Route 5113","Route 57","Route 59","Route 611","Route 615","Route 645","Route 66","Route 7a","Route 8",
            "Route 94","Route 9W S","Routt St","Rovinelli Road","Roving Trl","Rowan Ct","Rowan Dr","Rowan Walk",
            "Rowanwood Avenue","Rowdis Rd","Rowdy Creek Rd","Rowe Ct","Rowe Rd","Rowe Street","Roweland Ct",
            "Rowell Avenue","Rowell Rd","Rowena Road","Rowetown Rd","Rowland Ave","Rowland Ave SE","Rowland Dr",
            "Rowland Rd","Rowland St","Rowland Street","Rowlee Ave","Rowlee Rd","Rowley Ave","Rowley Avenue",
            "Rowley Ct","Rowley St","Rowntree Dairy Road","Rowntree Mill Road","Rowyn Cir","Roxanna Dr",
            "Roxanna Drive","Roxanne Ave","Roxanne Crescent","Roxborough Drive","Roxborough Lane",
            "Roxburg Hill Rd","Roxburgh Dr","Roxburgh Ln","Roxbury Ct","Roxbury Dr","Roxbury Ln","Roxbury Street",
            "Roxella Ln","Roxford Rd","Roxie Way","Roxton Pl","Roxwood Cir","Roy Ave","Roy Ct","Roy Horn Way",
            "Roy Janes Rd","Roy Keyes Rd","Roy Ln","Roy Mountain Rd","Roy Rainey Avenue","Roy Rd","Roy Rogers Rd",
            "Roy St","Roy Street","Roy Webb Rd","Royal Ave","Royal Avenue","Royal Chapin Crescent","Royal Cir",
            "Royal Court","Royal Crest Dr","Royal Crest Ln","Royal Ct","Royal Dolnoch Ct","Royal Doulton Drive",
            "Royal Dr","Royal Estate Drive","Royal Grand","Royal Henley Boulevard","Royal Heritage Ct",
            "Royal Ln","Royal Meadow Pl","Royal Oak Beach Dr","Royal Oak Ct","Royal Oak Dr","Royal Oak Drive",
            "Royal Oak Rd","Royal Oak Road","Royal Oaks Dr","Royal Oaks Road","Royal Orchard Boulevard",
            "Royal Orchard Dr","Royal Palm St","Royal Par Drive","Royal Park Ter","Royal Pine Cir",
            "Royal Pky","Royal Rd","Royal Ridge Ave","Royal Ridge Blvd","Royal Ridge Crescent","Royal Ridge Ml",
            "Royal Road","Royal Sage Ct","Royal Saint George Dr","Royal Spruce Pl","Royal St","Royal Street",
            "Royal Valley St","Royal View Dr","Royal Villa Ct","Royal Vista Road","Royal Vista Ter",
            "Royal Way","Royal Woods Ct","Royal York Road","Royalcrest Road","Royalton Drive","Royalton Pl",
            "Royalwood Ct","Royce Ave","Royce Ct","Roycehaven Dr","Roycroft Blvd","Roycroft Road","Royden St",
            "Royena Dr","Royene Ct NE","Royer Ave","Royston Rd","Roysun Road","Roytec Road","Rozmus Ct",
            "Rsa Rd","Rt 9 Wb To Cedar Street","Rte 438 Extended","Ruben","Ruben St","Rubicon Rd","Rubin Street",
            "Rubino Rd","Rubio Ave","Ruby","Ruby Ave","Ruby Ct","Ruby Dr","Ruby Lake","Ruby Ln","Ruby Pl","Ruby Pl NE",
            "Ruby Rd","Ruby Rd NE","Ruby St","Ruby's Rd","Rucereto Ave","Rucker Dr","Ruckman Ave","Ruckman St",
            "Rudd Ct","Rudder Ct","Rudder Dr","Rudderow Ave","Ruddy Ave","Rudell Road","Rudes Rd","Rudge Rd",
            "Rudman Cir","Rudman Dr","Rudnick Ct","Rudolph Ave","Rudolph Rd","Rudy Ct","Rudy Dr","Rudy Rd",
            "Rudy Rd W","Rudy Robinson Way","Rudy's Ln","Rue Avallon","Rue Caen Crescent","Rue Cambon",
            "Rue Chateau","Rue Lafayette","Rue Maison N","Rue Mediterra Dr","Rue St Moritz","Rue Way",
            "Rue de Monte Carlo","Rue de Yoe","Ruella Pl","Ruelle Lundy's Lane","Rues Ln","Rufe Dunnahoo Rd",
            "Ruff Rd","Rufford Road","Ruft Rd","Rufus Ct","Rufus Henry Rd","Rufus Rd","Rugby Cir","Rugby Rd",
            "Rugged Ave","Ruggles Avenue","Rugh St","Ruiz Canyon Dr","Ruiz Ct","Rujean Ln","Rule Dr","Rumba Rd",
            "Rummell Ave NE","Rumph Ave","Rumriver St","Rumsey Ln","Rumsey Rd","Rumsey Road","Rumson Ct",
            "Rumson Pl","Rumson Rd","Rumstick Rd","Runco Crest Ln","Runcocas Rd","Rundle Road","Runnalls Road",
            "Runnells Hall Rd","Runnels St","Running Brook Ct","Running Brook Dr","Running Elk Rd",
            "Running Horse Rd","Running Oak Dr","Running Ridge Rd","Running Springs Ln","Runningbrook Drive",
            "Runnymede Road","Runshaw Pl","Runyon Canyon Rd; Runyan Canyon Rd","Runyon Dr","Runyons Ln",
            "Rupell Rd","Rupert Avenue","Rupert Street","Rupinski Rd","Ruppe","Rural Ave","Rural Street",
            "Rusfield Street","Rush Blvd","Rush Creek Trail","Rush Creek Way","Rush Landing Rd","Rush Lane",
            "Rush Ln","Rush Meadow Rd","Rush Mendon Townline Rd","Rush St","Rush Street","Rushbrooke Avenue",
            "Rushing Rd","Rushingbrook Drive","Rushleigh Rd","Rushmore Ct","Rushton Ct","Rushton Dr",
            "Rushton Ridge","Rushton Road","Rushton St","Ruskin Ln","Ruskin Rd","Ruskin Road","Rusnell Rd",
            "Russ Monica Ct","Russ Randall St","Russ Road","Russ Street","Russel Temple Rd","Russell Ave",
            "Russell Avenue","Russell Ct","Russell Hill Road","Russell Jarvis Drive","Russell Ln",
            "Russell Mills Road","Russell Pl","Russell Rd","Russell Road","Russell St","Russell Station Rd",
            "Russell Street","Russell Street W","Russell Ter","Russell Tpke","Russell Turnpike Rd",
            "Russell View Road","Russell Woods Road","Russells Way","Russellville Rd","Russet Dr",
            "Russet Lake Dr","Russet Ln","Russett Avenue","Russett Road","Russett St","Russia Street",
            "Russian Dr","Rust Avenue","Rust Ln","Rust Memorial Rd","Rust Street","Rusten Ln","Rustic Acres Mobile Home Park",
            "Rustic Ba Road","Rustic Canyon Dr","Rustic Dr","Rustic Hills Rd","Rustic Ln","Rustic Oak Ct",
            "Rustic Pl","Rustic Place","Rustic Road","Rustic Trail Rd","Rustling Winds Ave","Ruston Rd",
            "Rusty Dusty Rd","Rusty Nail Dr","Rusty Oak Trl","Rusty Spur","Rustywood Drive","Ruta Ct",
            "Rutgers Ave","Rutgers Ct","Rutgers Dr","Rutgers Pl","Rutgers Rd","Rutgers Resh Rd","Rutgers St",
            "Rutgers Ter","Rutgers Way","Ruth","Ruth Ave","Ruth Cir","Ruth Circle","Ruth Ct","Ruth Dr","Ruth Dump Rd",
            "Ruth Hill Rd","Ruth Ln","Ruth Pl","Ruth Rd","Ruth St","Ruth Way","Ruth Way Rd","Ruthelen Ct","Rutherdale Rd",
            "Rutherford Ave","Rutherford Avenue","Rutherford Blvd","Rutherford Drive","Rutherford Rd",
            "Rutherford Road","Ruthie Ln","Ruthin Rd","Ruthven Pl","Ruthven St","Rutland Ave","Rutland Ct",
            "Rutland Ln","Rutland Road","Rutland St","Rutland St N","Rutland Street","Rutledge","Rutledge Dr",
            "Rutledge Loop Rd","Rutledge Pl","Rutledge Rd","Rutledge Walk","Rutledge Way","Ruttenberry Rd",
            "Rutz Rd","Rvcomstock St","Ryals Ln","Ryals St","Ryan Ave","Ryan Cir","Ryan Ct","Ryan Dr","Ryan Hwy",
            "Ryan Lake Rd","Ryan Ln","Ryan Pl","Ryan Place","Ryan Rd","Ryan Road","Ryan St","Ryan Wesley St",
            "Ryans Way","Rydal Dr","Rydall Mill Road","Rydalmount Rd","Rydell Ln","Rydell Rd","Ryder Ave",
            "Ryder Cup Ln","Ryder Road","Ryders Lane","Ryders Ln","Rye Hill Rd E","Rye Rd","Rye St","Ryefield Dr",
            "Ryer's Ln","Ryerson Ave","Ryerson Pl","Ryerson Rd","Ryerson St","Ryerson Street","Ryeside Ave",
            "Rykert Crescent","Rylander Avenue","Ryle Rd","Rymon Rd","Rynden Rd","Rynearson Village Apartment",
            "Rysdyke Dr","S","S 109th Avenue","S 109th Pl","S 10th Pl","S 10th St","S 11th St","S 124th Drive",
            "S 12th St","S 13th Ave","S 13th St","S 14th Ave","S 14th Pl","S 14th St","S 154th Pl","S 154th St",
            "S 155th St","S 15th Ave","S 15th St","S 166th Ave","S 16th St","S 172nd St","S 17th Ave","S 17th St",
            "S 185th Dr","S 18th St","S 193rd Way","S 194th St","S 19th Ave","S 19th St","S 1st Ave","S 1st Pl",
            "S 1st St","S 204th Ave","S 20th Ave","S 20th St","S 213th St","S 22nd St","S 23rd Ave","S 23rd St",
            "S 24th St","S 24th Way","S 25th Ave","S 25th St","S 26th St","S 27th Dr","S 27th St","S 28th Ave",
            "S 28th St","S 29th St","S 2nd Ave","S 2nd Pl","S 2nd St","S 30th St","S 31st Ave","S 31st St",
            "S 31st Way","S 32nd Ave","S 32nd Pl","S 32nd St","S 33rd St","S 33rd Street","S 34th Cir","S 34th Pl",
            "S 34th St","S 35th St","S 36th St","S 38th Ave","S 38th St","S 39th St","S 3rd Ave","S 3rd St",
            "S 40th Pl","S 40th St","S 41st Pl","S 41st St","S 43rd Pl","S 43rd St","S 44th St","S 45th Ave",
            "S 45th Pl","S 46th St","S 48 St","S 48th Ct","S 49th Pl","S 4th Ave","S 4th Pl","S 4th St","S 4th St; N 4th St",
            "S 5 Mile Rd","S 535th Ave","S 54th St","S 56th St","S 57th St","S 59th St","S 5th Ave","S 5th St",
            "S 60th St","S 61st St","S 66th St","S 69th St","S 6th","S 6th Ave","S 6th St","S 7 Rd","S 70th St",
            "S 71st Drive","S 72nd Cir","S 74th St","S 78th Pl","S 78th St","S 7th Ave","S 7th St","S 7th Street",
            "S 81st St","S 84th St","S 88th St","S 89th St","S 8th Ave","S 8th Place West","S 8th St","S 8th St W",
            "S 90th St","S 91st St","S 92nd Cir","S 92nd Pl","S 92nd St","S 93rd St","S 94th Dr","S 96th Cir",
            "S 9th Ave","S 9th St","S A St","S Abalone Dr","S Abbey","S Abbott Rd","S Acacia Rd","S Academy Ave",
            "S Acorn Ln","S Aduana Ct","S Agate St","S Aikens St","S Airport Connector","S Airstrip Rd",
            "S Alder Dr","S Alder St","S Allen St","S Allison St","S Alma St","S Alta Ave","S Alto Mesa Dr",
            "S Alvernon Way","S America Pond Rd","S American St","S Americas Ave","S Anderson Rd",
            "S Angel Fire Pl","S Anita Dr","S Ann Rd","S Ann St","S Anniston Ave","S Anton Pl","S Anzac Ave",
            "S Apache Dr","S Apache Pass Rd","S Applecross Rd","S Arizona Ave","S Arkansas Ave","S Armstrong Ave",
            "S Ash Ave","S Ash St","S Ashby Ave","S Atlantic Ave","S Audlen Ter","S Audrey Rd","S Austin Rd",
            "S Autumn St","S Avenida Kaye","S Avenida Lysanne","S Avenida Planeta","S Avenue 22 E",
            "S Avenue 31 E","S Avenue 4 1/2 E","S Avenue 46 E","S Avenue 6 E","S Avenue A 3/4",
            "S Avocado Ct","S Ayers Road","S Aztec Ct","S Azurite Dr","S Badger Canyon","S Balboa Rd",
            "S Balboa St","S Baltimore Ave","S Banning St","S Bardell Ave","S Barnard Rd","S Barnes St",
            "S Barnstead Rd","S Barranca St","S Barrow Pl","S Bascom Ave","S Baton Rouge Ave","S Bayside Rd",
            "S Beach Ave","S Beach Dr","S Beagle St","S Beaver St","S Beech St","S Beechwood Ave","S Belden St",
            "S Belle Dr","S Bent Ln","S Berbro St","S Berrywood Cir","S Bethel Ave","S Bettina Way","S Beulah St",
            "S Bigford Rd","S Billingsgate Cir NW","S Biloxi Trce","S Bishop","S Bishop Ave","S Blackberry Ln",
            "S Blackstone Ave","S Blackstone St","S Blair Ave","S Blythe Ave","S Bobine St","S Bollinger Ct",
            "S Bonsall St","S Borboa Pl","S Bosque Rd","S Boston Ave","S Boston Pl","S Boulder St","S Bouvier St",
            "S Bowman Ave","S Boyd Pky","S Boykin","S Bradley Rd","S Brady Cir","S Branch Rd","S Branch Way",
            "S Branciforte Ave","S Brandon Rd","S Brandriff Ave","S Brewster Rd","S Bridge Plz","S Bridge St",
            "S Brighton Ave","S Brighton Cir N","S Broad St","S Broadview St","S Broadway St","S Brook Dr",
            "S Brookside Dr","S Brown St","S Brush St","S Bryan Ave","S Bucks Town Road","S Buena Vista Dr",
            "S Buffalo St","S Bullard St","S Burgess Rd","S Burk St","S Burke Street","S Burnaby Dr",
            "S Burnett St","S Burnside Ave","S Butte Ave","S Byfield St","S Cabrillo Hwy","S Calderon",
            "S Caldwell St","S Caliente Ct","S Calle Pomo","S Calle Portal","S Camac St","S Camaro Ct",
            "S Cambridge Dr","S Camellia Dr","S Cameron Ln","S Camino Tetaviecti","S Campview Trl",
            "S Canby St","S Canon Dr","S Canterbury Ave","S Canton St","S Capitol St","S Carlsbad Vista Cir",
            "S Carlton Ave","S Carlton Park Pl","S Carmen Cir","S Carmine","S Carpenter St","S Cascadilla Ave",
            "S Cassia Way","S Cassidy Dr","S Cathay Pl","S Cayuga St","S Cecil Circle Dr","S Cedar Rd",
            "S Cedar St","S Cedarbrook Rd","S Centennial St","S Center Ave","S Center Dr","S Center St",
            "S Central Ave","S Central St","S Chactaw Pl","S Chadwick St","S Chamberlin","S Chardonnay St",
            "S Charleston Pl","S Chateau Fresno Ave","S Chatsworth","S Chelsea Park Pl","S Cherokee",
            "S Cherry Ave","S Cherry Cir","S Cherry Ln","S Chester Ave","S Chester St","S Chestnut St",
            "S Chieftain St","S Childs St","S China Lake Blvd","S Chinowth Street","S Chiswick Ln",
            "S Church St","S Cimmeron Trl","S Circle Dr","S Citrus Ave","S Clare Ave","S Clarion Ave",
            "S Clark Dr","S Claudina St","S Clay St","S Cleveland","S Cleveland St","S Cline St","S Clinton Ave",
            "S Clinton St","S Cloverdale Blvd","S Cloverdale Dr","S Cluff Ranch Rd","S Clymar Ave",
            "S Cochise Cir","S Cochran Rd","S Colby St","S Cold Creek Rd","S Cole Ave","S College Ave",
            "S College Dr","S Collings Ave","S Colonial Dr","S Colorado St","S Colusa Ave","S Commercial St",
            "S Commons","S Concourse","S Concourse St","S Congress Ave","S Connard St","S Connector Rd",
            "S Cookman Ave","S Copia St","S Corabelle Ave","S Coral St","S Cord Ave","S Corinth Rd","S Corlies St",
            "S Corn St","S Cornelia Ave","S Coryell Island","S Cottontail Ln","S Cottonwood St","S County Center Drive",
            "S County Line Dr","S County Road 103","S County Road 217","S County Road 275","S County Road 309",
            "S County Road 421","S County Road 668","S County Trl","S Covell St","S Covington Ave",
            "S Cow Creek Rd","S Craycroft Rd","S Creek Ln","S Crestview St","S Crimea St","S Crockett Rd",
            "S Crooked Ln","S Crosby Ave","S Croskey St","S Cross St","S Culver St","S Cummings Ave",
            "S Cummings Rd","S Curtis Rd","S Cypress St","S D St","S Dalton St","S Dancove Dr","S Dapple Gray",
            "S Darien St","S David Dr","S Davis","S Davis Ave","S Davis St","S Daysha Cir","S Daysville Rd",
            "S Dayton Dr","S Dean Ave","S Dean Road","S Dean St","S Deane Ln","S Dearborn St","S Dearing Ave",
            "S Deep Hollow Rd","S Deer","S Deer Pl","S Deer Trail Dr","S Delany Hill Rd","S Delaware Ave",
            "S Delaware Street","S Delfina Dr","S Delhi St","S Dennis Rd","S Denver Ave","S Depot Loop",
            "S Desert Blvd","S Desert Flower Ct","S Desert Trail Dr","S Desnouettes St","S Desota",
            "S Dewitt Ave","S Dexter St","S Diamond Rd","S Dittmar Dr","S Division St","S Division Street",
            "S Dockery Ave","S Dockside Ln","S Dogwood Rd","S Dogwood St","S Dorchester Rd","S Dorsey Ln",
            "S Dory Roe Rd","S Doubloon Ct","S Douglas Ave","S Douglas St","S Dove St","S Drake Rd","S Dudley Rd E",
            "S Dune Rd","S Dwight Pl","S E 1st St","S E Ave","S E Griffin Dr","S E St","S East St","S Eastview",
            "S Eastwick Ter","S Eastwood Cir","S Edgewater Ave","S Edgewood Rd","S Edgewood St","S Edinburgh Ave",
            "S Edison St","S Egg Harbor Rd","S Eldorado St","S Elena Dr","S Elizabeth St","S Elk Rd",
            "S Elliott Pl","S Ellison Ln","S Elm St","S Elmhurst Ave","S Elmwood Ave","S Elmwood Rd",
            "S Emerald Dr","S Emerson St","S Emperor Blvd","S Erie St","S Erin","S Escocia Ln","S Escuela Rd",
            "S Esmeralda St","S Esperanza St","S Essex Ave","S Esther Ln","S Estrella Parkway","S Eucalyptus Ave",
            "S Euclid Ave","S Eufaula Ave","S Eunice Ave","S Evergreen Ave","S Ewing St","S Exeter Ave",
            "S Exeter Ct","S F St","S Fair Ave","S Fairfield Dr","S Fairview St","S Fairway Dr","S Falling Leaf Dr SE",
            "S Fancher Ave","S Felton St","S Ferguson Rd","S Fern Ave","S Finley Ave","S Fisher Rd","S Fisher Way",
            "S Fitzhugh St","S Fletcher Rd","S Flooter Rd","S Florence Ln","S Fontana St","S Foothill Ave",
            "S Foothill Blvd","S Force Rd","S Forest Ave","S Forest Dr","S Fork Dr","S Fork Rd","S Forty Ranch Ln",
            "S Fountain St","S Fox Ave","S Frailey Ave","S Franc's Ave","S Frank St","S Frankfort Ave",
            "S Franklin Ave","S Franklin St","S Frazier St","S Front St","S Frontier St","S Fuller St",
            "S Futrall Dr","S Gage Ave","S Gallini Ln","S Gamay St","S Garnet Rd","S Gaston Ave","S Gate Trl",
            "S General Kearny Rd","S Genesee Dr","S Genesee Street","S Geneva Ave","S Georgia Ave",
            "S Gill St","S Gilmore Rd","S Glenwood Rd","S Gold St","S Golfwood Ave","S Gonser St","S Goodfellow Rd",
            "S Goodsell Ave","S Governor Printz Blvd","S Gowdy St","S Graham Cir","S Granada Ave",
            "S Grand Ave","S Grand Canyon Dr","S Grande","S Grandee Ave","S Granite Pl","S Grant Ave",
            "S Grant St","S Grantland Ave","S Granville Ave","S Grasshopper Rd","S Gray Rd","S Green Rd",
            "S Greenbush Rd","S Greene Ave","S Greenway Ave","S Greenwich St","S Greenwood","S Grenoble Cir",
            "S Grippen Ave","S Grove St","S Grover Ave","S Guadalupe Rd","S Gwen de Fortuna Cir","S H St",
            "S Hacienda Dr","S Haladay Ave","S Hall","S Halstead St","S Hamilton St","S Hammett St","S Hampton Cir",
            "S Hampton Hill Ct","S Hancock St","S Hano Rd","S Harbor Dr","S Harbor Way","S Harcourt Ave",
            "S Hardt St","S Harmony St","S Harold Dr","S Harold St","S Harrington Tt","S Harris St","S Harrison St",
            "S Harshaw St","S Harvard Blvd","S Hassett","S Havasupai Pl","S Hawk Lane","S Hawley Rd",
            "S Hay St","S Hayes Rd","S Heard St","S Heathdale Ave","S Hedgehog Dr","S Helberta Ave","S Helix Ave",
            "S Hemlock Ave","S Hemlock Rd","S Hereford","S Hess Rd","S Hewer Rd","S Hewitt Dr","S Hickory St",
            "S Hicks St","S Highland Ave","S Highland Dr","S Highland Rd","S Hill Ave","S Hill Island Rd",
            "S Hill Ln","S Hill Rd","S Hill St","S Hillcrest Dr","S Hillman St","S Hills St","S Hillside Ave",
            "S Hillside Dr","S Hilltop Ave","S Hilltop Dr","S Hirst St","S Holbrook Ln","S Hollenbeck Rd",
            "S Holly Ave","S Holly St","S Hollywood Blvd","S Hollywood St","S Home Ave","S Homestead Ln",
            "S Homestead Rd","S Homsy Ave","S Hopkins Lake Dr","S Horticultural Dr","S Howard St",
            "S Hudson Ave","S Humphreys Ave","S Hunters Ridge St","S Hurd St","S Hyder Ave","S I Pl",
            "S I St","S Idlewood Rd","S Indiana Ave","S Indianola Ave","S Interlochen Rd","S Irene Blvd",
            "S Iris Ave","S Iris St","S Iroquois Ln","S Irving St","S Irwin St","S Ithan Ave","S Ivy Ave",
            "S Ivy St","S Izard St","S Jacana Ln","S Jackson Ave","S Jackson St","S Jacob St","S Jamaica Cir",
            "S James Rd","S Jeffrey","S Jerge Dr","S Jersey Ave","S Jersey Blvd","S Jessup St","S Jetty Rd",
            "S Joanne Ave","S Joe Ray Dr","S Johnson Ave","S Johnson Blvd","S Johnson Chapel Rd","S Johnson St",
            "S Jones Rd","S Joplin","S Jornada Rd","S Joseph Dr","S Joshua Ln","S Juliano Rd","S June Ct",
            "S Juniper St","S K St","S Kansas Ave","S Karla Dr","S Kathleen Dr","S Kaweah River Dr","S Kaylee Dr",
            "S Keene Ave","S Keldon Rd","S Kenbrook St SE","S Kendall Ave","S Kenmore St","S Kenwood Ln",
            "S Kevin Dr","S Key Biscayne Dr","S Kimberlee Way","S Kimbles Rd","S Kimmel St","S King St",
            "S Kingston Ave","S Kino Pky","S Kinzie St","S Knapp Ct","S Knight Ln","S Lafayette St","S Laguna Dam Rd",
            "S Lake Cir","S Lake Dr","S Lake Enchantment Trl","S Lake Forest Dr","S Lake Pl","S Lake Rd",
            "S Lake Sequoyah Dr","S Lake Shore Dr","S Lake St","S Lakeshore Rd","S Lakeside Cir","S Lakeside Rd",
            "S Lakeview Ct","S Lakeview Dr","S Lamar Ct","S Lancaster Ave","S Lane Dr","S Larkin Ave",
            "S Larry St","S Las Flores Dr","S Laspina St","S Latta St","S Laurel Ave","S Laurel St","S Lawrence Ave",
            "S Lawrence St","S Lazy Deer Trl","S Leary Dr","S Lebanon Ln","S Lee Roy Jordan Rd","S Leila St",
            "S Leipzig Ave","S Leithgow St","S Leithgow Way","S Lemon St","S Leslie","S Leslie St","S Leswing Ave",
            "S Levitt St","S Lewis Rd","S Lewis St","S Libby Rd","S Liberty St","S Lilburn Dr","S Lillie Ln",
            "S Lily Ave","S Limping Water Row","S Lincoln Ave","S Lincoln Dr","S Lincoln St","S Linda Cir",
            "S Linden Ave","S Litchfield St","S Liverpool Ave","S Lockhart Rd","S Locust Dr","S Locust St",
            "S Locust Street","S Logan Ave","S Longfellow Ave","S Lorena Ave","S Lorena St","S Lorraine Pl",
            "S Los Angeles Dr","S Los Feliz Dr","S Los Gatos Ln","S Lotus Ave","S Lower Sacramento Rd",
            "S Lower Woods Rd","S Lundy","S Lupin Ln","S Lyle Ave","S Lyon Ave","S M 129","S Mace","S Mace Dr",
            "S Mackinac Ave","S Madera Ave","S Madison Ave","S Magma Rd","S Magnolia Ave","S Main Dr",
            "S Main St","S Main Street","S Malin Rd","S Maltby Ct","S Mandan Ct","S Manhattan Pl","S Mann Ave",
            "S Mansfield Ave","S Mansion Ave","S Manzanita Dr","S Manzanita St","S Maple Ave","S Maple Ct",
            "S Marce Ln","S Marginal Hwy","S Maricopa Ct","S Marigold Pl","S Marin Dr","S Marion Ave",
            "S Marion Way","S Mariposa Ave","S Mars Dr","S Marshall Ave","S Marshall St","S Marston St",
            "S Martin St","S Mary Ave","S Maryland Pky","S Maselli St","S Matthew St","S Mayfair Ave",
            "S Mayo Ave","S Mc Bride St","S Mc Kinley Ave","S McCall Ave","S McCarran Blvd","S McClure Rd",
            "S McKelvey Ave","S McKinnon Ave","S McMillan Rd","S McMullin Grd","S Meade Ave","S Meadow Rd",
            "S Meadow Street","S Medrick Pl","S Melbourne Ave","S Melville St","S Mercantile St","S Meridian Ave",
            "S Mesa Hills Dr","S Mesa Hills St","S Mesita","S Mesquite St","S Mesquite Tree Ln","S Metropolitan Ave",
            "S Miami Ave","S Middlesex Ave","S Midland Dr","S Midler Avenue","S Miera Rd","S Milham Dr",
            "S Military Rd","S Mill Rd","S Millbourne Ave","S Miller Creek Pl","S Miller St","S Millikin Rd",
            "S Minges Rd","S Minne-Wa-Wa","S Miranda St","S Mission Rd","S Missouri Ave","S Missouri St",
            "S Mitchell Ave","S Mohave Tr","S Mohler Road","S Mole St","S Mon Cem Rd","S Mono Vista Rd",
            "S Monroe St","S Monsey Rd","S Monte Carlo Ct","S Monte Vista Dr","S Monterey Ave","S Montgomery St",
            "S Montreal Pl","S Morgan Cir SW","S Morgan Rd","S Morley Ave","S Morris Ave","S Mosley Rd",
            "S Mount Vernon Ave","S Mountain Ct","S Mountain Pond Rd","S Mountain Rd","S Mountain Site Dr",
            "S Mountain St","S Mountainview Dr","S Muirfield Rd","S Mulberry St","S Mullins St","S Murry St",
            "S Myrtle Ave","S Myrtle St","S Myrtlewood Cir","S Myrtlewood St","S N St","S Nancy Ct","S Napa Ave",
            "S Napa Ln","S Nassau Ave","S Nebraska St","S Nesmith Ave","S Nevins Rd","S New Ardmore Ave",
            "S New Haven Ave","S New Middletown Rd","S New St","S Newark St","S Newberry Rd","S Newkirk St",
            "S Newman Rd","S Newport Dr","S Newton Lake Dr","S Nickel St","S Niles Rd","S Norfolk St",
            "S Norma St","S Norman Ave","S North Plains Rd","S Norton Ave","S Nottingham Dr","S Nugget Rd",
            "S Nurmi Ave","S O St","S Oak Ave","S Oak Ct","S Oak Park Ct","S Oak Rd","S Oak St","S Oakwood St",
            "S Ocean Ave","S Ocean Pky","S Ocotillo Ln","S Ogden Cir","S Ogden St","S Ohio Ave","S Ohio St",
            "S Oidak Wog","S Ok St","S Old Cincinnati Rd","S Old Stage Rd","S Oleander St","S Olive St",
            "S Oliver Dr","S Ontario St","S Opal St","S Oracle Cir","S Orange Ave","S Oregon St","S Oriental Ave",
            "S Ormus Ave","S Osage Dr","S Owl Head Ranch Rd","S Oxford Valley Rd","S Oxley","S Pablo Dr",
            "S Pacific Ave","S Paddock St","S Page Ave","S Palm Dr","S Palo Verde Ave","S Palo Verde Dr",
            "S Palo Verde Ln","S Palo Verde Road","S Paradise Ln","S Parawan St","S Paris Ave","S Park Ave",
            "S Park Ave NW","S Park Dr","S Park Ln","S Park Pl","S Park Rd","S Park St","S Parker Ave","S Parkwood",
            "S Pascack Rd","S Paseo Bandera","S Paseo del Cilantro","S Patrick Way","S Patriot Pl",
            "S Peach St","S Pear St","S Pecan Cir","S Pecos Rd","S Pedersen Ave","S Pelham Ave","S Pembroke Ln",
            "S Pendleton St","S Penn Ave","S Penn St","S Pennington Dr","S Pennsylvania Ave","S Peppertree St",
            "S Percy St","S Pere Marquette Hwy","S Persimmon St","S Petaluma Ave","S Petersburg Rd",
            "S Pewaukee St","S Philip St","S Phoenix Pl","S Pickel Ave","S Pickens Ave","S Pico Ct","S Pilgrim Ave",
            "S Pilot St","S Pima Dr","S Pine Mountain Rd","S Pine St","S Pinecrest Ln","S Pinnacle Ct",
            "S Pinon Ave","S Placita Almeja","S Placita Asta Vieja","S Placita de la Picaza","S Plantation St",
            "S Platti Rd","S Pleasant Dr","S Plumas St","S Plymouth Rd","S Plymouth St","S Poets Path",
            "S Point Blvd","S Pond Rd","S Ponderosa Way","S Poplar Ave","S Poplar St","S Poppy Ave","S Port Dr",
            "S Port Road 15","S Porter St","S Portland Ave","S Pottery Rd","S Powers Avenue","S Prairie Pl",
            "S Preakness Ct","S Prescott St","S Price Ave","S Princeton St","S Pruess Ave","S Pueblo Blvd",
            "S Queen Palm Ct","S R 40","S R 4007","S R 509","S R St","S Race St","S Racine","S Radne Ln","S Railroad Ave",
            "S Railroad St","S Railway St","S Raleigh Ave","S Ramona Dr","S Ranch Rd","S Rancho Dr","S Randolph Ave",
            "S Randolphville Rd","S Randy St","S Ranger St","S Ranger Way","S Ray Rd","S Rea Ave","S Read Ave",
            "S Reading St","S Reams Dr","S Redberg Cir","S Redtail Trl","S Reed St","S Reese St","S Reilly Rd",
            "S Renee Ave","S Reserve Rd","S Reservoir Dr","S Rice St","S Richards Ave","S Richmond Ave",
            "S Ridge Ct","S Ridge Rd","S Ridgeley Dr","S Ridgeview Ct","S Ridgeway St","S Ridgewood Pl",
            "S Riley St","S Rim Rd NE","S River Dr","S River Rd","S River Rose Rd","S Riverside Dr","S Riverview Dr",
            "S Riverview Rd","S Roanoke","S Roberts Rd","S Rochdale Ave","S Roche St","S Rock St","S Rodehaver Rd",
            "S Rodriguez Ave","S Rogers Ln","S Rolling Rd","S Roosevelt Blvd","S Roosevelt Rd B","S Roosevelt Rd X",
            "S Roosevelt Road 26","S Roosevelt Road 37","S Roosevelt Road 6 1/2","S Roosevelt Road Ac",
            "S Roosevelt Road Aj","S Roosevelt Road B","S Roosevelt Road G","S Roosevelt Road L",
            "S Roosevelt Road Q","S Roosevelt Road Z","S Roosevelt Road au","S Rose Cir","S Rose St",
            "S Rosedale St","S Rosella St","S Roseville St","S Rosewood St","S Ross Rd","S Rosser Rd",
            "S Roughrider St","S Rue 13","S Running Brook Ct","S S St","S Sabrina Cir","S Sage St","S Saginaw St",
            "S Sahuaro St","S Salford St","S Salida Pl","S Salina Street","S San Antonio Rd","S San Jose Dr",
            "S San Mateo Drive","S San Tomas Aquino Rd","S Sandbar Ln","S Sandra Ave","S Santa Clara St",
            "S Santa Fe St","S Santa Monica St","S Santa Rita Ave","S Santa Rosa St","S Santistevan Rd",
            "S Sarah Way","S Sawyer Cir","S Scallop Dr","S Scarlet Maple Ln","S Schilleman Rd","S School Ave",
            "S Schuman St","S Sconondoa St","S Scott Ave","S Scott St","S Sean Dr","S Seeley St","S Service Road",
            "S Seton Ave","S Seville Blvd","S Seward Avenue","S Shackleville Rd","S Shafer Dr","S Sharon St",
            "S Sharp Dr","S Shasta Pl","S Shawmut St","S Shell Ave","S Shelly Dr","S Sheridan Rd","S Sherman Ave",
            "S Shirk Rd","S Shore Dr","S Shore Rd","S Short St","S Sierra St","S Sierra View St","S Sierra Vista Dr",
            "S Sierra Vista St","S Sierra Way","S Silver Birch Pl","S Simms Ave","S Siskiyou Loop",
            "S Slate St","S Slater Cir","S Slater Ct","S Smith Ave","S Snow Prairie Rd","S Snyder Ave",
            "S Snyder St","S Somerset Ave","S Sonoita Hwy","S Sonoma Ave","S Sovereign Ave","S Spencer",
            "S Spider Rock Rd","S Spring Mill Rd","S Spring St","S Springs Dr","S Spruce Rd","S Spur St",
            "S St","S St Andrews Pl","S St Joseph St","S St Malo St","S St T St Aly","S Staghorn Ln",
            "S Stanford Ave","S Stanislaus Ave","S Stanley Pl","S Stanley St","S State Highway 45",
            "S State St","S State Street","S Station Ave","S Stearns Road","S Steele Dr","S Stephanie St",
            "S Stevens St","S Stevenson St","S Stinson St","S Stoddard Ave","S Stoneacre Ave","S Stoney Creek Rd",
            "S Stover St","S Stresa Way","S Stringtown Ave","S Sugarmill Rd","S Summit Ave","S Summit Rd",
            "S Summit St","S Sundance Ave","S Sundance Trl","S Sunset Pines","S Sunset Shores Dr",
            "S Sunset St","S Sutherland Dr","S Sutro Ter","S Swanson St","S Swarthmore Ave","S Swathmore Ct",
            "S Sword St SW","S Sycamore St","S Sydenham St","S T St","S Tabor Dr","S Tall Tree Ln","S Talmadge St",
            "S Taylor St","S Tegner Rd","S Teilman Ave","S Tercera Pl","S Terhune Ave","S Terrace Cir",
            "S Terrell Ct","S Terripin","S Texas Ave","S Thompson Rd","S Thorson Ave","S Tierra Verde Pl",
            "S Tilden St","S Tioga Way","S Tolosa Pl","S Toltec Buttes Rd","S Tomlinson Ln","S Tommy Ct",
            "S Tomsik","S Tomsik St","S Tongass Hwy","S Topaz Pl","S Torrey Pines","S Torrey Pines Dr",
            "S Trails End Pl","S Treat St","S Treece Rd","S Trenton Ave","S Trevino Ct","S Trish Ct",
            "S Troy Ave","S Tucana Ct","S Tulane St","S Tulare St","S Tulip St","S Tupman St","S Twin Creek Rd",
            "S Twin Peaks Rd","S Tyndall Ave","S U St","S Uber St","S Umbrella St","S Union Ave","S Union St",
            "S Vail St","S Valencia St","S Valentine Ave","S Valle Verde Dr","S Valley Forge Rd","S Valley Rd",
            "S Valley View Blvd","S Van Dr","S Van Etten St","S Van Ness St","S Vanzant Rd","S Vaquero Pl",
            "S Vaughn Lake Rd","S Vekol Valley Rd","S Vendome Ave","S Venice Blvd","S Ventu Park Rd",
            "S Ventura Service Road","S Verbena Ave","S Verdin Ave","S Via Entrada","S Via Serena",
            "S Via Toscano","S Via Vello Rd","S Via Vista Rios","S Vicki Ln","S Vickie Ct","S Victoria Ave",
            "S Victoria Pl","S View Ln","S View St","S Vine Ave","S Vine St","S Vineyard Blvd","S Virginia St",
            "S Vista Dr","S Vista Valle Dr","S Voyager Dr","S Wabash Ave","S Walker Rd","S Walleye Ln",
            "S Walnut St","S Walters Ave","S Warner St","S Warnock St","S Warren Ave","S Warwick Rd",
            "S Washington Ave","S Washington St","S Water St","S Water St SE","S Watson Rd","S Watts St",
            "S Webster Ave","S Weed Rd","S Weller St","S Wells Ave","S Wesley Ave","S West Ave","S West Ct",
            "S West St","S Westchester Avenue","S Western Hills Rd","S Westover Rd","S Westward Ave",
            "S Westwood Cir","S Whitacre St","S Whitney Ave","S Wildwood","S Willhite Rd","S William St",
            "S Williams Ave","S Williams St","S Williamston Rd","S Willow Ln","S Willow St","S Wilson Ave",
            "S Winchester Blvd","S Winding Oak Dr","S Windy Ridge Ct","S Winery Ave","S Winners Cir",
            "S Winton Rd","S Wisteria Ave","S Wixon Ln","S Woodcock Rd","S Woodcrest Ave","S Woodcrest Rd",
            "S Woodin Rd","S Woodlawn Ave","S Woods Rd","S Woodside Ave","S Woodstock St","S Work St",
            "S Wrightwood St","S Wycliff Ave","S Yale Ave","S Yam Ave","S Yarbrough Dr","S York Ave",
            "S Yuba Ave","S Yucca Terrace Ave","S Yuma St","S del Rancho Cir","S del Rey Ave","S el Canasta Way",
            "S el Capitan Way","S el Pomar Rd","S el Thuma Real","S la Canada Dr","S la Corta Dr",
            "S la Donna Ln","S la Hureta Cir","S la Rosa Dr","S. Rittenhouse Square","S554J","S63Bb",
            "S71F","SCE / Landing Strip","SCE Power Plant","SCE South","SE 13th Ct","SE 168th St","SE 1st St",
            "SE 2nd St","SE 3rd St","SE 6th St","SE 8th St","SE 9th St","SE Diablo View Ln","SE G St","SE Hollow Rd",
            "SE Midcities Dr","SE Mount Hope Pl","SE Sawgrass","SE St Andrews Blvd","SE Townline Rd",
            "SW 11th Ave","SW 11th St","SW 15th St","SW 3rd St","SW 5th St","SW Avon Glen Pl","SW Central Ave",
            "SW Davinbrook St","SW Henderson Rd","SW Hopi Cir","SW Lakeshore Dr","SW Railroad St",
            "SW Sitka Ct","Sabbaday Ln","Sabin Dr","Sabin Street","Sabina Court","Sabina St NE","Sabina Ter",
            "Sabinas Ct","Sabine St","Sabino St","Sable Ave","Sable Ct","Sable Dr","Sable Loop","Sabodan St",
            "Sabra Cir","Sabre","Sabrina Dr","Sabrina Ln","Sabrosa Dr NE","Sabroso Ct","Sac St","Sacaton Flats Rd",
            "Sachem Avenue","Sachem Rd","Sachem St","Sachem Street","Sachems Place","Sachs Dr","Sacia Ave",
            "Sackett Hill Rd","Sackett St","Sackman Street","Sackville Green","Sackville Place","Sackville Street",
            "Sacra Via St","Sacramento","Sacramento Canyon Rd","Sacramento Dr","Sacramento Rd","Sacramento St",
            "Sacred Heart Drive","Sacuillo St","Sadaqueda St","Saddle Ave","Saddle Back Dr","Saddle Crescent",
            "Saddle Ct","Saddle Dr","Saddle Horn Pl","Saddle Ln","Saddle Peak Rd","Saddle Peak Trl","Saddle Rd",
            "Saddle Ridge Cir","Saddle Ridge Rd","Saddle River","Saddle River Ave","Saddle River Rd",
            "Saddle Rock Rd","Saddleback Dr","Saddleback Rd","Saddlebred Ct","Saddlebrook Creek","Saddlebrook Ln",
            "Saddlecreek Cir","Saddlecreek Court","Saddlehorn Ln","Saddlehorn Trl","Saddler Rd","Saddleridge",
            "Saddlerock Canyon Rd","Saddlewood Ct","Sadek Way","Sadie Ln","Sadlee Cove Crescent","Sadler Drive",
            "Sadler Pl","Sadler Rd","Sadler Street","Sadlo Dr","Sadowski Pky","Saenz Rd","Saerwood Ln","Safari Drive",
            "Safety Way","Safflower Ct","Safflower Pl","Safford Pl","Safford St","Saffron Drive","Saffron Street",
            "Saffron Way","Sagamore Avenue","Sagamore Hill","Sagamore Ln","Sagamore Rd","Sagamore Road",
            "Sage","Sage Ave","Sage Brush","Sage Brush Point Rd","Sage Brush Tr","Sage Calley Rd","Sage Ct",
            "Sage Dr","Sage Drive","Sage Flats Rd","Sage Hill Dr","Sage Ln","Sage Rd","Sage St","Sage Way",
            "Sagebrush Ave","Sagebrush Ln","Sagebrush St","Sagebrush Trl","Sagebrush Way","Sagecrest Dr",
            "Sagecrest St","Sagefield Rd","Sagehen Rd","Sagemore Way","Sager Creek Rd","Sagewood Avenue",
            "Sagewood Dr","Saginaw Cir","Saginaw Crescent","Saginaw St","Sago St","Saguara Dr","Saguaro Dr",
            "Saguaro Rd","Saguaro Shadows Pl","Sagunto","Sagwon Ave","Sahale Ln","Sahalee Dr","Sahalee Ln",
            "Sahara Way","Sahuaro Dr","Sahwa Rd","Sail Bay Dr","Sail Point St","Sailers Way","Sailfish Bay Cir",
            "Sailmaker Ct","Sailors Cv","Sailors Way","Sailwind Ct","Saint Albans Pl","Saint Andrews Ct",
            "Saint Andrews Dr","Saint Andrews Ln","Saint Anthony Rd","Saint Anthony St","Saint Augustine Ct",
            "Saint Augustine St","Saint Bartholomew Street","Saint Bonaventure Cemetery","Saint Charles Ave",
            "Saint Charles Pl","Saint Charles St","Saint Christopher Dr","Saint Clair Blvd","Saint Clair Rd",
            "Saint Clairsville St","Saint Davids Rd","Saint Demetrios Ave","Saint Denis Avenue",
            "Saint Dr","Saint Francis Avenue","Saint George Pl","Saint Georges Ave","Saint Georges Road",
            "Saint Helena Dr","Saint Hubert Drive","Saint James Ave","Saint James Avenue","Saint Joh Road",
            "Saint John Ave","Saint Johns Road","Saint Joseph St","Saint Josephs Villa Dr","Saint Lawrence Ave",
            "Saint Lo Drive","Saint Louis Ave","Saint Lucie Drive","Saint Luke St","Saint Lukes Pl",
            "Saint Lukes Place","Saint Marks Place","Saint Martin Ct","Saint Martin Pl","Saint Mary Ave",
            "Saint Marys Ave","Saint Marys Dr","Saint Marys St","Saint Marys Street","Saint Matthew S Dr",
            "Saint Nicholas Avenue","Saint Nicholas Place","Saint Norbert Dr","Saint Onge Rd","Saint Patricks Cemetery",
            "Saint Pau Road","Saint Paul St","Saint Paul Street","Saint Pauls Ave","Saint Pauls Court",
            "Saint Pierre St","Saint Stevens Court","Saint Tropez Pl","Saint Victor Drive","Saint Yorre Ct",
            "Saipan Dr","Sais Ave","Sakina St","Sakura Way","Sal Si Puedes Rd","Salade Dr","Salamanca Ave",
            "Salamanca Cir","Salazar St","Salem","Salem County 611","Salem County 635","Salem County 662",
            "Salem Ct","Salem Dr","Salem Ln","Salem Mountain Road","Salem Pky","Salem Pl","Salem Rd","Salem Road",
            "Salem St","Salem Street","Salem Xing","Salem-Marblehead","Salerno Rd","Salford Dr","Salice Way",
            "Salina Meadows Dr","Salina Rd","Salina St","Salinas Dr","Salinas Rd","Saline Valley Rd",
            "Salinger Court","Salisbury Ave","Salisbury Circle","Salisbury Ct","Salisbury Ln","Salisbury Rd",
            "Salisbury St","Salisbury Street","Salix Ct","Salley Ln","Sallie St","Sally Ln","Sally Rd","Sally St",
            "Salmar Ave","Salmer St","Salmon Ave","Salmon Berry Ct","Salmon Creek Rd","Salmon Falls Dr",
            "Salmon Falls Rd","Salmon Lake Road","Salmon Lake Rd","Salmon Rd","Salmon River Cir",
            "Salmon River Rd","Salmonsen Dr","Salome Rd","Salon Rd","Saloon Ct","Salsa Ct","Salsburg Rd",
            "Salsbury Dr","Salsbury Rd","Salt Brush Ln","Salt Creek Rd","Salt Evaporation Plan St",
            "Salt Pond Road","Salt Rd","Salt Springs Reservoir Rd","Salt Water Wash Rd","Saltbrush Ave",
            "Salter Court","Salter Ln","Salter Pl","Salters Avenue","Saltgrass Dr","Saltmarsh Ave","Saltonstall Square",
            "Salty Dog Rd","Saltzburg Ln","Saluda Lane","Salvadore St","Salvail Ct","Salvatiera St","Salvator Way",
            "Salvatore Ct","Salyer Mad River Rd","Salzburg Ct","Sam Adams Rd","Sam Clemens Ave","Sam Frustaglio Drive",
            "Sam Hill Mine Ct","Sam Snead","Sam St","Sam Tyree Rd","Sam Weinroth Rd","Samantha Ct","Samantha Dr",
            "Samantha Ln","Samantha Way","Samanthas Way","Samaria Rd","Samaritan Ct","Samarkand Dr","Sameth",
            "Sami Dr","Sammons Ave","Samoa Cir","Samoha Cir","Samoset Trl","Sample Rd","Sampson Ave","Sampson Avenue",
            "Sampson Rd","Sampson St","Sampson State Park","Sams Way","Samson Ln","Samson Rd","Samsondale Plz",
            "Samuel Cir","Samuel Dr","Samuel Ln","Samuel St","Samuel Street","San Acacia Rd SW","San Agustin",
            "San Andreas Dr","San Andreas Rd","San Andreas St","San Andres Ave","San Andres Ave NW",
            "San Anselmo Ave","San Anselmo Ln","San Antonio Cir","San Antonio Dr","San Antonio Rd",
            "San Antonio Rd W","San Antonio St NW","San Badger Way","San Benancio Rd","San Bernardino Freeway",
            "San Bernardino Fwy","San Bernardino St","San Bruno Ave","San Carlos Ave","San Carlos Ct",
            "San Carlos Dr","San Carvante Ct","San Cayetano Rd","San Clemente Ave","San Clemente Ln",
            "San Clemente Pl","San Clemente Rd","San Cristobal Rd SW","San Diego Ave","San Diego Freeway",
            "San Dieguito Dr","San Dimas Ln","San Domingo Aly","San Elizario Rd","San Esteban Ave",
            "San Felipe Ct","San Fernando","San Fernando Dr","San Fernando Way","San Francesca Dr",
            "San Francisco","San Francisco Ave","San Francisco Bay Trail","San Francisco Dr","San Gabrial Dr",
            "San Gabriel Ave","San Gabriel Blvd","San Gabriel Canyon Rd","San Gabriel Cir","San Gabriel River Bike Path",
            "San Giorgio","San Guillermo Rd","San Hill Trail","San Ignacio Ct NE","San Ildefonso St",
            "San Jacinto Dr","San Jacinto Ridge Truck Trail","San Jacinto River Rd","San Joaquin",
            "San Joaquin Ave","San Joaquin Ct","San Joaquin Dr","San Jose Ave","San Jose Cir","San Jose Dr",
            "San Jose Ranch Rd","San Jose Rd","San Juan","San Juan Aly","San Juan Ave","San Juan Canyon Rd",
            "San Juan Dr","San Juan Grade Rd","San Juan Hollister Rd","San Juan Ln","San Juan Rd",
            "San Jule Ct","San Justo Rd","San Lucas Ave","San Lucas Dr","San Luis Ave","San Luis Dr",
            "San Luis Rey","San Luis Rey Ave","San Luis Rey Ct","San Luis Rey Rd","San Luis St","San Mar St",
            "San Marco Ave","San Marco Dr","San Marcos Ct","San Marcos Rd","San Marie Dr","San Marin St",
            "San Marino Ct","San Marino Ln","San Mateo Ave","San Mateo Blvd NE","San Mateo Dr","San Miguel",
            "San Miguel Avenue","San Miguel Ct","San Miguel Rd","San Miguel St","San Miguel Trl","San Miguel Way",
            "San Nicholas Ct","San Pablo","San Pablo Ave","San Pablo Ct","San Pablo Dr","San Pablo St SE",
            "San Pablo Way","San Pascual Ave","San Pasqual St","San Pasqual Way","San Patricio Dr",
            "San Paula Ave","San Paulo Way","San Pedro","San Pedro Ave","San Pedro Cir","San Pedro Pl",
            "San Pedro Rd","San Pedro View","San Pierre Ct","San Rafael Ave","San Rafael Dr","San Rafael St",
            "San Ramon Ave SE","San Ramon Rd","San Ramon Way","San Raphael","San Remo Way","San Ricardo Dr",
            "San Rogue Ct","San Rosa Way","San Rose Dr","San Saba Pl","San Simeon Pl","San Simeon State Park",
            "San Simeon Way","San Souci Cir","San Souci Dr","San Ssuci Road","San Taela Ct","San Tomas Ct",
            "San Tropez Dr","San Vicente","San Vicente Rd","Sanarita Ct","Sanbar Ct","Sanborn Ct","Sanborn Dr",
            "Sanborn Rd","Sanbury Rd","Sanchez Cir","Sanchez Cv","Sanchez Rd","Sanctuary Hill Cir","Sanctuary Lane",
            "Sanctuary Ln","Sanctuary Way","Sand Banks Court","Sand Bar Ct","Sand Bar Lane","Sand Bar Road",
            "Sand Bay Road","Sand Brook Rd","Sand Canyon Rd","Sand Canyon Road","Sand Castle Ln","Sand Coral Dr",
            "Sand Creek Rd","Sand Dune Ln","Sand Flat Rd","Sand Hill Lane","Sand Hill Rd","Sand Hill Road",
            "Sand Hollow Rd","Sand Hollow Wash Rd","Sand Lake Circle","Sand Lake Rd","Sand Ln","Sand Oaks Rd",
            "Sand Pebble Dr","Sand Pl","Sand Rd","Sand Ridge Rd","Sand Shark Ct","Sand Springs Rd","Sand St",
            "Sand Stream Ln","Sand Street","Sand Trap Dr","Sand Valley Rd","Sand Valley Street","Sand-Dale Rd",
            "Sandaba Road","Sandalwood Ct","Sandalwood Dr","Sandalwood Parkway E","Sandalwood Parkway East",
            "Sandalwood Place","Sandaraska Road","Sandario Rd","Sandbar Ct","Sandbed Rd","Sandberg St",
            "Sandborn Rd","Sandbox Rd","Sandbriar Ln","Sandcliffe Road","Sandelwood Dr","Sander St","Sanderling Ct",
            "Sanders Ct","Sanders Dr","Sanders Rd","Sanders St","Sanderson Brook Road","Sanderson Crescent",
            "Sanderson Drive","Sanderson Ln","Sanderson Rd","Sandfield Dr","Sandford Road","Sandford St",
            "Sandhill Boulevard","Sandhill Rd","Sandhill St","Sandhurst Circle","Sandhurst Crescent",
            "Sandhurst Ln","Sandhurst St NW","Sandi Way","Sandia","Sandia Ave","Sandia Crest Scenic Hyway",
            "Sandia Dr","Sandia St","Sandia Way","Sandland Dr","Sandlewood Ct","Sandlewood Lane","Sandlewood Ln",
            "Sandlewood Pl","Sandlewood Rd","Sandman Blvd","Sandmist Ave","Sandora St","Sandorf St","Sandoval Ln",
            "Sandoval Rd","Sandown Avenue","Sandown Lane","Sandpines Dr","Sandpiper Ct","Sandpiper Dr",
            "Sandpiper Ln","Sandpiper Pl","Sandpiper Way","Sandpoint Way","Sandquist Rd","Sandra Circle",
            "Sandra Crescent","Sandra Ct","Sandra Dr","Sandra Drive","Sandra Ln","Sandra Pl","Sandra Pond Road",
            "Sandra Road","Sandra Street East","Sandridge Way","Sandringham Drive","Sandringham Place",
            "Sandringham Rd","Sandrini Rd","Sands","Sands Point Dr","Sands Rd","Sands St","Sandsprings Dr",
            "Sandstone Cir","Sandstone Cl","Sandstone Ct","Sandstone Dr","Sandstone Drive","Sandstone Trl",
            "Sandstone Way","Sandusky Dr","Sandwich Road","Sandwich Slopes Rd","Sandwich Street","Sandwood Dr NE",
            "Sandy Acres Ln","Sandy Ann Dr","Sandy Beach Ln","Sandy Beach Rd","Sandy Beach Road","Sandy Bottom Rd",
            "Sandy Bowers Ave","Sandy Brook Rd","Sandy Cir","Sandy Creek","Sandy Creek Rd","Sandy Creek Way",
            "Sandy Ct","Sandy Cv","Sandy Dr","Sandy Fork Cir","Sandy Hill Rd","Sandy Hoo Road","Sandy Island Dr",
            "Sandy Landing Rd","Sandy Lane","Sandy Ln","Sandy Ln NW","Sandy Neck Way","Sandy Pines Blvd",
            "Sandy Pl","Sandy Point Ct","Sandy Rd","Sandy Rid Court","Sandy Ridge Rd","Sandy Ridge Way",
            "Sandy St","Sandy Trail","Sandy Trl","Sandy Way","Sandybrook Ln","Sandyside Dr","Sanford Ave",
            "Sanford Dr","Sanford Pl","Sanford Rd","Sanford Rd N","Sanford St","Sangallo St","Sanger Ave",
            "Sanger Hill Rd","Sangria Ln","Sanibel Shore Ave","Sanicle Way","Sankey Road","Sanmott Trl",
            "Sann Road","Sanrick Dr","Sans Baker Rd","Sans Souci Ter","Sansom St","Sansom Walk","Sansome Street",
            "Sansote St","Sansousa St","Santa Ana Blvd","Santa Ana Rd","Santa Ana River Trail","Santa Barbara Ave",
            "Santa Barbara Cir","Santa Barbara Place","Santa Barbara St","Santa Buena Way","Santa Cir",
            "Santa Clara Ave","Santa Clara Ct","Santa Clara Pl","Santa Clara St","Santa Clara Trl",
            "Santa Claudia St","Santa Cruz Ct","Santa Cruz Drive","Santa Cruz Ln","Santa Cruz Rd",
            "Santa Fe Ave","Santa Fe Canal","Santa Fe Ct","Santa Fe Fire Road","Santa Fe Grd","Santa Fe Highlands Dr",
            "Santa Fe Ln","Santa Fe Rd","Santa Fe Trl","Santa Fe Way","Santa Flora Ct","Santa Florita Ave",
            "Santa Ines Way","Santa Inez Cir","Santa Isabel Trail","Santa Lucia Ave","Santa Lucia Ct",
            "Santa Lucia Dr","Santa Margarita Ct","Santa Margarita Rd","Santa Margarita St","Santa Maria",
            "Santa Maria Ct","Santa Maria Ct NW","Santa Maria Dr","Santa Maria Ln","Santa Maria St",
            "Santa Monica","Santa Monica Ave","Santa Monica Ct","Santa Monica Freeway","Santa Monica Way",
            "Santa Paula Ct","Santa Paula Fwy","Santa Paula St","Santa Rita Dr","Santa Rita Ranch Rd",
            "Santa Rita Rd","Santa Rita St","Santa Rosa Ave","Santa Rosa Dr","Santa Rosa Rd","Santa Rosalia Way",
            "Santa Susanna Pl","Santa Teresa Blvd","Santa Theresa Ct","Santa Ynez Ridge Rd","Santa Ynez St",
            "Santa Ynez Trail","Santa Ysabel","Santamont Rd","Santana Ct","Santana Dr","Santana Rd","Santander Ln",
            "Santanna Ave","Santaquin Dr","Sante Fe Rd","Santecito Dr","Santee Pl","Santello Dr","Santiago Creek Tr",
            "Santiago Rd SW","Santiago St","Santina Way","Santini Pl","Santo Domingo Ct","Santo Domingo Trl N",
            "Santo Nino Pl","Santo Pl","Santo Tomas Ct NW","Santo Ysidro Rd","Santolina Dr","Santone Avenue",
            "Santoni Ln","Santos Dr","Santos St","Santoy Rd","Santry Road","Sanwood Boulevard","Sao Paulo Drive",
            "Sap House Rd","Sapilla Creek Rd","Sapling St","Saponi St","Sapp Ln","Sapphire Dr","Sapphire Light St",
            "Sapphire Ln","Sapphire Point Ave","Sapphire Ridge Rd","Sapphire St","Sapps Run Rd","Sapsucker Woods Rd",
            "Sapunor Way","Saqmmons St","Sara Ln","Sara's Cir","Sarab Ln","Saragosa Ave","Sarah Ave","Sarah Cir",
            "Sarah Ct","Sarah Dr","Sarah Jane Court","Sarah Lane","Sarah Ln","Sarah Lynn Ln","Sarah Pl",
            "Sarah Run Ln","Sarah Sherman Lane","Sarah St","Sarah Street","Saral Ln","Saranac St","Sarasota Ln",
            "Saratoga Ave","Saratoga Cir","Saratoga Ct","Saratoga Dr","Saratoga Drive","Saratoga Gap Trail",
            "Saratoga Lake Dr","Saratoga Road","Saratoga St","Saratoga Ter","Saratoga Trl","Saratoga Way",
            "Sarazen Ave","Sarcona Ct","Sardis Church Rd","Sardis Court","Sardis Rd","Sardis-Airport Rd",
            "Saren Ct","Sargent","Sargent Ave","Sargent Avenue","Sargent Canyon Rd","Sargent Creek","Sargent Dr",
            "Sargent Ln","Sargent Rd","Sargent St","Sargent Street","Sargent T.m. Dion Way","Sargent's Pond Rd",
            "Sari Cir","Sarita Ave","Sarno Ave","Sarona Ln","Saroni Dr","Sarrell Ct","Sartell Rd","Sarty Road",
            "Sasemine Way","Sash Ct","Sashel Ln","Sassafras Dr","Sassafras Ln","Sassafras Run","Sassafras St",
            "Sassafras Tr","Sassafrass St","Satellite Dr","Saterlee Hollow","Saticoy Pl","Saticoy St",
            "Satmar Dr","Satsuma Dr","Satterfield Dr","Satterfield Ln W","Satterlee St","Sattes St","Satucket Road",
            "Saturley Rd","Saturn Cir","Saturn Dr","Saturn Ln","Saturn Pl","Sauber Ct","Sauer Avenue","Saugeen Crescent",
            "Saunders Creek Rd","Saunders Ln","Saunders Rd","Saunders Rd SE","Saunders Road","Saunders Settlement Road",
            "Saunders St","Saunders Street","Sauterne Way","Sauvignon Ct","Sauxhead Lake Rd","Sava Dr SE",
            "Savage Rd","Savage River Rd","Savage Road","Savana Ln","Savana St","Savanah Oaks","Savannah Ave",
            "Savannah Cir","Savannah Ct","Savannah Dr","Savannah Rd","Savannah St","Savara Rd","Saverio Ct",
            "Saville Ave","Saville Court","Savin Street","Savinelli Road","Savio Rd","Savoie Ct","Savona Pl",
            "Savoy Blvd","Savoy Creek Rd","Savoy Crescent","Savoy Rd","Savoy Road","Savoy St","Savoy Street",
            "Saw Mill Branch Rd","Saw Mill Ln","Saw Mill Rd","Sawbuck Rd","Sawdust Trl","Sawgrass Ct",
            "Sawgrass Glen","Sawgrass Ln","Sawgrass Way Dr","Sawkill Meadow Ln","Sawmill Aly","Sawmill Creek Rd",
            "Sawmill Crossover","Sawmill Dr","Sawmill Gulch Rd","Sawmill Ln","Sawmill Mountain Rd",
            "Sawmill Rd","Sawmill Rd NW","Sawmill Rd SE","Sawmill Road","Sawmill Trailers","Sawmill Way",
            "Sawtelle Blvd","Sawtooth Rd","Sawyer Avenue","Sawyer Camp Trail","Sawyer Ferry Rd","Sawyer Hgts Rd",
            "Sawyer Meadow Rd","Sawyer Mesa Rd","Sawyer Mountain Rd","Sawyer Rd","Sawyer Road","Sawyer Street",
            "Sawyer Way","Sawyers Bar Rd","Sawyers Bay","Saxon Ave","Saxon Pl","Saxonia Ave","Saxony Cir NW",
            "Saxony Ct","Saxony Ln","Saybrook Aly","Saybrook Ave","Saybrook Ln","Saybrook Rd","Sayerson Rd",
            "Sayles St","Saylor Ct S","Sayre Dr","Sayre St","Sayres Neck Rd","Sayres Pl","Sb St 1","Sbar Blvd",
            "Scadding Street","Scajaquada Pky","Scally Ln","Scammel St","Scandia Court","Scandia Rd",
            "Scandid Hemmer Rd","Scannel Ave","Scantic Meadow Rd","Scanty Bag Cove Rd","Scanwood Dr",
            "Scarboro Avenue","Scarboro Dr","Scarborough Ave","Scarborough Ct","Scarborough Dr","Scarborough Golf Club Road",
            "Scarborough Ln","Scarborough Pl","Scarborough Way","Scarborough-Pickering Townline Road",
            "Scarbrough Ln","Scarden Avenue","Scarface Dr","Scarface Rd","Scargo Hill Road","Scarlet",
            "Scarlet Ct","Scarlet Drive","Scarlet Oak Ave","Scarlet Oak Dr","Scarlet Tanger Cir","Scarlett Road",
            "Scarp Canyon","Scarpa Ln","Scarth Court","Scattered Oaks Dr","Scattertree Ln","Scenic Ave",
            "Scenic Cir","Scenic Court","Scenic Dr","Scenic Drive","Scenic Harbor Dr","Scenic Highway Rd",
            "Scenic Hills Dr","Scenic Hollow Rd","Scenic Ln","Scenic Pines Dr NE","Scenic Shores Dr",
            "Scenic Ter","Scenic Trl","Scenic View Cir","Scenic View Ln","Schabloski Rd","Schadd's Rd",
            "Schaefer Ave","Schaefer Avenue","Schaeffer Rd","Schaer St","Schafer Rd","Schaffer Ave","Schaffer Cir",
            "Schall Rd","Schantz Ave","Schauer Pl SW","Schaumberg Pl","Scheivert Ave","Schelbert Ter",
            "Schell Rd","Schelling Ter","Schells Dr","Schenck Ave","Schencks Mill Line Rd","Schenectady Avenue",
            "Scher Pl","Scheu Park","Scheurich Ln","Schevchenko St","Schick Court","Schill Pl","Schiller Ave",
            "Schiller Rd","Schilling Rd","Schillings Ct","Schimmel St","Schindler Ct","Schindler Dr",
            "Schipper St","Schirra Dr","Schisler Crescent","Schisler Road","Schlage Rd","Schlemm","Schlentz Hill Rd",
            "Schley Ave","Schley Pl","Schley St","Schley Street","Schlitz Rd","Schlomann Dr","Schmidt","Schmidt Ave",
            "Schmidt Lane Number 15","Schmidt Pl","Schmidt Rd","Schmidts Pl","Schmitt Ln","Schmitt Rd",
            "Schnabl Blvd","Schneberger Dr","Schneider Ave","Schneider Ct","Schneider Road","Schneiders Crossing Rd NW",
            "Schnieder Rd","Schnurr Dr","Schocopee Rd","Schoefer Ln","Schoenborn St","Scholar Ct","Scholastic Dr",
            "Scholfield Avenue N","Scholfield Avenue S","Schollar Ln","Scholle Rd","Schollview Ave",
            "Scholten Rd","Scholten Road","Schomberg Road","Schonchin Lookout Trail","Schoodac Rd",
            "School Access Rd","School Ave","School Avenue","School Bus Loop","School Dr","School Driveway",
            "School Forest Rd","School House Court","School House Hill Rd","School House Ln","School House Rd",
            "School House Road","School Ln","School Parking Lot","School Rd","School Road","School St",
            "School St NW","School Street","School Street North","School Way","Schoolcraft Dr","Schoolcraft Rd",
            "Schooley Dr","Schoolhouse Cir","Schoolhouse Ct","Schoolhouse Ln","Schoolhouse Rd","Schoolhouse Road",
            "Schooner Dr","Schooner Dr NW","Schoonmaker Pl","Schoonover Dr","Schoonover Rd","Schopper Rd",
            "Schor Ave","Schorn Ct","Schraalenburg Way","Schraalenburgh Rd","Schrade Ln","Schrader Rd",
            "Schramsberg Ct","Schrepfer Rd","Schroeder Ln","Schroeder Rd","Schroo Rd","Schubert Ct","Schuldt Ln",
            "Schuler Ranch Dr","Schuler Rd","Schull Ct","Schulte St","Schultz Ct","Schultz Dr","Schultz Rd",
            "Schultz Sideroad","Schultz Walk","Schumaker Road","Schupbach Rd","Schuyler Ave","Schuyler Baldwin Dr",
            "Schuyler Ct","Schuyler Dr","Schuyler Ln","Schuyler Pl","Schuyler Rd","Schuyler St","Schuylkill Ave",
            "Schuylkill Expressway","Schuylkill River Trail","Schwab Ln","Schwartz Creek Rd","Schwartz Dr",
            "Schwartz Pl","Schwartz Rd","Schwarzkopf Dr","Schweer Dr","Schweid Ct","Schweikerts Walk",
            "Schwenker Pl","Schwitier Ave","Sciberras Road","Scimitar Way","Sciota St","Scioto Cir","Scituate Ave",
            "Scituate Pl","Scituate Vista Dr","Scobie Rd","Scofield Ave","Scofield Hill Rd","Scofield Rd",
            "Scola Rd","Scoles Ave","Scollard Road","Scolly St","Scoonover Dr","Scooter Ln","Scooter St",
            "Scorpio Dr","Scorpion Rd","Scorpion Rd Rd","Scotch Broom Ln","Scotch Crst","Scotch Dr","Scotch Hill Rd",
            "Scotch Hollow Rd","Scotch Line Road E","Scotch Pine Circle","Scotchpine Dr","Scotia Way",
            "Scotland Ct","Scotland Heights Road","Scotland Hill Rd","Scotland Rd","Scotland Street",
            "Scots Way","Scott Ave","Scott Avenue","Scott Brook Rd","Scott Cemetery Rd","Scott Crescent",
            "Scott Ct","Scott Dr","Scott Farm Rd","Scott Forge Rd","Scott Hill Rd","Scott Hollow Rd",
            "Scott Ln","Scott Orchard Rd","Scott Pl","Scott Raison Rd","Scott Ray Way","Scott Rd","Scott River Road",
            "Scott Road","Scott Robin Rd","Scott St","Scott St NE","Scott Street","Scott Ter","Scott's Road",
            "Scotte St","Scottie Ct","Scotts Church Road","Scotts Cir","Scotts Crossing Rd","Scotts Dr",
            "Scotts Flat Rd","Scotts Lane","Scotts Right of Way","Scotts Road","Scottsbluff St","Scottsboro Hwy",
            "Scottsdale Cir","Scottsdale Ct","Scottsdale St","Scottsmoor Ct","Scottsridge Rd","Scottsville Rd",
            "Scotty Dr","Scotty Ln","Scourie Ln","Scout Ct","Scout Dr","Scout Lake Rd","Scout Ln","Scout Rd",
            "Scout Road","Scouten Rd","Scoutshire Camp Rd","Scovill Rd","Scranton Rd","Scrap Ln","Scrapetown Rd",
            "Scratchup Rd","Screaming Eagle Dr","Screech Owl","Scribner Rd","Scrimshaw Ct","Scufflegrit Rd",
            "Scugog 14 Line Road","Scugog 4 Line Road","Scugog Street","Sculptured Beach","Sea Belle Ave",
            "Sea Biscuit Ct","Sea Bluff Ln","Sea Breeze Ave","Sea Breeze Ct","Sea Dream Ave","Sea Drift Ln",
            "Sea Gate Ct","Sea Grape Ln","Sea Horse Dr","Sea Horse Way","Sea Island Ct","Sea Island Path",
            "Sea King Pl","Sea Kist Ave","Sea Knight Ct","Sea Lion Cir","Sea Otter Ln","Sea Pines Ct",
            "Sea Pines Ln","Sea Pines Rd","Sea Ranch Ave","Sea Ranch Way","Sea Raven Dr","Sea Ridge Rd",
            "Sea Shell Cir","Sea Shell Ln","Sea Shore Rd","Sea Street","Sea Tern Ct","Sea Vale St","Sea View Avenue",
            "Sea Wall","Seabee St","Seabird Way","Seabiscuit Dr","Seaboard Ct","Seabreeze Ave","Seabreeze Road",
            "Seabreeze Walk","Seabright Ave","Seabright Ct","Seabrook Ct","Seabrook Dr","Seaburn Place",
            "Seaburn St","Seabury Ct","Seabury Dr","Seacliff","Seacliff Dr","Seacliff Way","Seacoast Terrace",
            "Seadrift Ct","Seafair Dr","Seafarer Court","Seafarrer Rd","Seafoam Ct","Seafoam St","Seaford Dr",
            "Seaford Ter","Seaforth Avenue","Seagall Rd","Seagate Circle","Seager Court","Seager Hill Rd",
            "Seagull Ave","Seagull Dr","Seagull Drive","Seagull Ln","Seagull Road","Seagull St NE","Seahawk St",
            "Seahorse Ln","Seal Ct","Seal Walk","Sealand St","Sealer Rd","Seals Pl","Seaman","Seaman Ave","Seaman Rd",
            "Seaman St","Sean Dr","Sean Haggerty Dr","Sean St","Sean Way","Seapowet Ave","Searchlight St",
            "Searing Ln","Searles Dry Lake Rd","Searles Rd","Searles Station Cutoff","Sears Avenue",
            "Sears Cv","Sears Ln","Sears Pl","Sears Rd","Sears Road","Sears St","Searsville Rd","Seascape Ct",
            "Seascape Rd","Seaside Ave","Seaside Park Ave","Seaside Pl","Seaside Rd","Seaside School Rd",
            "Seaside St","Seaside Ter","Season Rd","Seasons Ave","Seasons Ln","Seasons Valley Ct","Seaton Dr",
            "Seaton Drive","Seaton Rd","Seaver Ave","Seaver Street","Seaverns Xing","Seaview Ave","Seaview Avenue",
            "Seaview Cir","Seaview Dr","Seaview Gardens","Seaview Ln","Seaview Manor Rd","Seaview Rd",
            "Seaview Ridge Dr","Seavor St","Seawall Avenue","Seawatch Ln","Seawind Ct","Seawind Dr","Seawood Way",
            "Seaworld Dr","Seay Cir","Sebastian Rd","Sebastian St","Sebastopol Rd","Sebec Ln","Sebec Street",
            "Sebert Ave","Seburn Road","Secane Pl","Secaucus Rd","Secluded Acres Ct","Secluded Cir","Second Avenue",
            "Second Class","Second Dug Hill Road","Second Los Angeles Aqueduct","Second Outlet Rd",
            "Second Road E","Second St","Second Street","Second Street - Morrisburg","Second Street M",
            "Second Street S","Secor Ave","Secor Rd","Secord Avenue","Secord Road","Secory St","Secret Ravine Parkway",
            "Secretariat Ln","Section 22 Rd","Section Line Rd","Section Rd","Section St","Security Ln",
            "Sedalia Dr","Sedge Pl","Sedgegrass Way","Sedgemount Drive","Sedgewick Crescent","Sedgewick Ct",
            "Sedglea Street","Sedgwick Ave","Sedgwick St","Sedley Dr","Sedllins View Ct","Sedona Ct",
            "Sedona Glen","Sedore Avenue","Sedrev Rd NE","See Dr","Seebee Ln","Seebick Aly","Seed Farm Rd",
            "Seed Lake Rd","Seed Orchard Rd","Seedling Way","Seehaver Road","Seeley Rd","Seeley Storms Dr",
            "Seeley's Run","Seely Creek Rd","Seely Hill Rd","Seely Ln","Seelye Rd","Seena Dr","Sees Aly",
            "Sees Chapel Rd","Sees St","Sega Dr","Segar St","Segatti Cir","Segco Rd","Seggar Avenue","Segovia Road",
            "Segsworth Way","Seguine Rd","Segundo St","Seiad Creek Rd","Seidman Ave","Seigel Street",
            "Seigler Springs Rd","Seiler Ct","Seiler Rd","Seine Ave","Seine Ct","Selandia Ln","Selbourne Chase",
            "Selby Ct","Selby Dr","Selby St","Selden Dr","Seles Rd","Seligman Dr","Seline Crescent","Selkirk Cir",
            "Selkirk Ct","Selkirk Dr","Selkirk Street","Sellers Avenue","Sellersville Rd","Selma Ave",
            "Selma St","Selmar Ter","Selnik Rd","Selva Dr","Selvage Rd","Seminara Cir","Seminary Ave","Seminary Dr",
            "Seminary Pl","Seminary St","Semino Rd","Seminola Ave","Seminole","Seminole Ave","Seminole Avenue",
            "Seminole Ct","Seminole Dr","Seminole Ln","Seminole Pl","Seminole Rd","Seminole St","Seminole Triangle",
            "Seminole Trl","Seminole Trl N","Seminole Way","Semmes St","Semmilon Ln","Sen Claude Pepper Dr",
            "Sen Styles Bridge Hwy","Senasac Ave","Senate Rd","Senate St","Senator Boulevard","Senda Luna Llena",
            "Sendero Pl","Sendero Way","Sendick Road","Seneca Aly","Seneca Army Depot","Seneca Ave","Seneca Ct",
            "Seneca Dr","Seneca Drive","Seneca Hill Drive","Seneca Lake Rd","Seneca Ln","Seneca Pl","Seneca Rd",
            "Seneca St","Seneca Trl","Seneca Turnpike","Seneca Way","Senestraro Way","Seney Rd","Senger Pl",
            "Sengstacken Dr","Senic Way","Senna Ct","Senter Rd","Senter St","Sentiivel Ct","Sentinel Cir",
            "Sentinel Dr","Sentinel Rd","Sentry Ct","Sentry Hill Ln","Sepra Dr","September Cir","Septiembre Dr",
            "Sepulveda Blvd","Sepviva St","Sequan Ln","Sequan Truck Trail","Sequanota Rd","Sequim Cmn",
            "Sequoia Avenue","Sequoia Blvd","Sequoia Ct","Sequoia Dr","Sequoia Grove Drive","Sequoia Ln",
            "Sequoia Rd","Sequoia Way","Sequoia Way; Sequoia Dr","Sequoyah Dr","Sequoyah Ln","Serafina St",
            "Serena Cir","Serenata Way","Serendipity Ln","Serene","Serene Ave","Serene Valley Ct","Serene Way",
            "Serenity Ct","Serenity Dr","Serenity Pl","Sereno Ave","Sergeant Andrew Brucher Rd","Sergeant St",
            "Sergent Ct","Sergent Rd","Serpent Ln","Serpentine Dr","Serpentine Ln","Serpentine Rd","Serra Dr",
            "Serra Way","Serramonte St","Serrano Ave","Serrano Ln","Serrano Pl","Serravista Ave","Serrento Park Ct",
            "Serreta","Service Rd","Service Road","Service Road 393","Servis Rd","Serviss Rd","Sesame St",
            "Sesame Street","Sesame Way","Sesqui Dr","Sessions St","Sesta Rd","Sestina Ct NW","Seth Ct",
            "Seth Rd","Seton","Seton Dr","Seton Hall Dr","Seton Rd","Seton Trail","Seton Trail (Woods Loop)",
            "Setter Dr NE","Setting Sun Blvd","Setting Sun Drive","Setting Sun St","Settlement Rd",
            "Settlers Green","Settlers Hill Rd","Seven Acre Rd","Seven Bank","Seven Bar Loop Road NW",
            "Seven Hills Curve","Seven Hills Road","Seven Mile Dr","Seven Mile Rd","Seven Oak Cir",
            "Seven Oak Ct","Seven Pines Rd","Seven Rd","Seven Rivers Hwy","Seven Springs Loop Trail",
            "Seven Springs Mountain Rd","Seven Star Road","Seven by Nine Rd","Sevenoaks Circle",
            "Seventeenth Street","Seventh Avenue","Seventh Line","Seventh Shoreway","Seventh Street",
            "Severance Dr","Severance Hill Rd","Severance Lane","Severance Rd","Severance Terrace",
            "Severn St","Severn Street","Seville Blvd","Seville Ct","Seville Dr","Seville Ln","Sewage Disposal Rd",
            "Sewage Lagoon Rd","Sewall Rd","Sewanee Rd","Seward Ave","Seward Dr","Seward Highway","Sewell Ave",
            "Sewell Dr","Sewell Rd","Sewer Bed Rd","Sewer Pond Rd","Sextant Ct","Sextant Dr","Seymour Ave",
            "Seymour Avenue","Seymour Canyon Rd","Seymour Dr","Seymour Estates","Seymour Rd","Seymour St",
            "Seymour Street","Seymour Street E","Sfc 104","Sfc 211","Sfc 277","Sfc 311","Sfc 345","Sfc 722",
            "Sfc 831","Sfc 937","Sgotto Boulevard","Sgt Beers Ln","Sgt Wilding Way","Shackamaxon St",
            "Shackelford Ave","Shackletown Rd","Shad Bush Ave","Shad Rd","Shad Roe Ln","Shad Way","Shadberry Drive",
            "Shaddix Dr","Shaddox Ave","Shadduck Rd","Shade Tree Ln","Shadeland Ave","Shadeland Drive",
            "Shademaster Drive","Shades Creek Pky","Shades Crest Rd","Shades of Death Rd","Shadford Rd",
            "Shadlock Street","Shadow Bend Dr","Shadow Breeze St","Shadow Brook Way","Shadow Cr Road",
            "Shadow Creek Dr","Shadow Creek Rd","Shadow Crest Dr","Shadow Falls St","Shadow Farm Rd",
            "Shadow Glen Ln","Shadow Hill Dr","Shadow Hill Rd","Shadow Lake Dr","Shadow Lawn Dr","Shadow Leaf Dr",
            "Shadow Ln","Shadow Mountain Rd","Shadow Mountain Way","Shadow Mtn Rd","Shadow Oak Ct",
            "Shadow Oak Dr","Shadow Oaks Dr","Shadow Pines Dr","Shadow Rd","Shadow Ridge (driveway)",
            "Shadow Ridge Ave NE","Shadow Ridge Rd","Shadow Valley Rd","Shadowbrook Rd","Shadowlawn Dr",
            "Shadowlawn Way","Shadowline Cv","Shadowline Dr","Shadowood Dr","Shadowood Ln","Shadowrock Rd",
            "Shadowstone Ct","Shadowvale Way","Shadrack Ln","Shadrak Ln","Shadwell Ct","Shady","Shady Beach Blvd",
            "Shady Bend Rd","Shady Brook Cove Rd","Shady Brook Dr","Shady Creek Dr","Shady Ct","Shady Dell Ln",
            "Shady Dr","Shady Glade Ct","Shady Grove Dr","Shady Grove Ln","Shady Grove Rd","Shady Hill Lane",
            "Shady Hollow Ct","Shady Hollow Drive","Shady Knoll Ln","Shady Lair Ct","Shady Lake Dr",
            "Shady Lane","Shady Lane Dr","Shady Ln","Shady Ln Rd","Shady Nook","Shady Oak Ct","Shady Oak Dr",
            "Shady Oak Ln","Shady Oaks Dr","Shady Oaks Drive","Shady Pine Ln SE","Shady Rest Trail Network",
            "Shady Ridge Ln","Shady Rock Rd","Shady Shores","Shady St","Shady Tree Cir","Shady Tree Ct",
            "Shady Trl","Shady Valley Cir","Shady Valley Ln","Shadycrest Ct","Shadycroft Dr","Shadyglenn Trl",
            "Shadygrove Ct","Shadyridge Ave","Shadyside Ave","Shadyside Ct","Shadyside Dr","Shadyside Pl",
            "Shadyview Dr","Shaeffer St","Shafer Ave","Shaffer Rd","Shaft Road","Shafter Rd","Shaftesbury Street",
            "Shaftsburg Rd","Shaftsbury Ave","Shaggy Pines Road","Shahan Ct","Shahan Dr","Shahan St",
            "Shaindell Street","Shake Mill Dr","Shake Rag Hollow Rd N","Shaker Blvd","Shaker Hill Rd",
            "Shaker Rd","Shaker Road","Shakespeare Crescent","Shakespeare Ave","Shale Hill Rd","Shale Rock Road",
            "Shale St","Shaler Blvd","Shales Road","Shalimar Dr","Shalimar Pl","Shallcross Pass","Shallen Dr",
            "Shallimar Boulevard","Shallow Creek Rd","Shallow Mist Ct","Shallowford Court","Shalom Crescent",
            "Shamburger Rd","Shamley Dr","Shamrock Avenue","Shamrock Cir","Shamrock Ct","Shamrock Dr",
            "Shamrock Lane","Shamrock Ln","Shamrock Pl","Shamrock Rd NW","Shamrock St","Shamrock Street",
            "Shamrock Way","Shamu Ct","Shanagarr Drive","Shanahan Ln","Shanahan Trail","Shandwick Dr",
            "Shane Cir","Shane Ln","Shanghai St","Shangri-la Ln","Shanks Drive","Shannahan Dr","Shannon Ave",
            "Shannon Circle","Shannon Ct","Shannon Dr","Shannon Drive","Shannon Ln","Shannon Rd","Shannon Road",
            "Shannon St","Shannon Street","Shannon Valley Rd","Shannondoah Way","Shannonville Road",
            "Shanonville Rd","Shanty Rd","Shanty Sh Road","Shapen Way","Share Dr","Sharhart Heights Rd",
            "Sharilyn Ln","Shark River Rd","Sharlene Rd","Sharmon Palms Ln","Sharon Ave","Sharon Blvd",
            "Sharon Ct","Sharon Dr","Sharon Drive","Sharon Gardens Ct","Sharon Hollow Rd","Sharon Lee Drive",
            "Sharon Ln","Sharon Pky","Sharon Pl","Sharon Rd","Sharon St","Sharon Street","Sharonwood Ave NW",
            "Sharp Dr","Sharp Rd","Sharp St","Sharp Way","Sharpe Ave","Sharpe Rd","Sharpe St.","Sharpe Street",
            "Sharpecroft Boulevard","Sharpes Lake Rd","Sharps Cove Rd","Sharps Hill","Sharps Rd","Sharrer Rd",
            "Sharrmont Ct","Sharron Ct","Sharron Drive","Sharrotts Ln","Sharry Dr","Sharswood St","Sharyn Drive",
            "Shasta Cir S","Shasta Ct","Shasta Dam Blvd","Shasta Dr","Shasta Pl","Shasta St","Shasta Trl",
            "Shasta Way","Shatto St","Shattuck Arms Blvd","Shattuck Avenue","Shattuck Ln","Shattuck Street",
            "Shaughnessy Boulevard","Shaun Ct","Shaunessy Ct","Shauro Ln","Shaver Avenue North","Shaver Avenue South",
            "Shaver Rd","Shaver St","Shaw Ave","Shaw Cir","Shaw Ct","Shaw Farms Ct","Shaw Ln","Shaw Pl","Shaw Rd",
            "Shaw Ridge Rd","Shaw Road","Shaw St","Shaw Street","Shaw Trl","Shawanaga Trail","Shawbridge Avenue",
            "Shawmut Avenue","Shawmut Gr Rd","Shawmut Street","Shawmutt Rd","Shawn Avenue","Shawn Ct",
            "Shawn Dr","Shawn Rd","Shawnee Ave","Shawnee Circle","Shawnee Ct","Shawnee Dr","Shawnee Drive",
            "Shawnee Ln","Shawnee Path","Shawnee Rd","Shawnee Trl","Shaws Lane","Shaws Mill Rd","Shawsheen Street",
            "Shawson Drive","Shawtown Rd","Shay Lake Ln","Shea Drive","Shea Rd","Shea St","Shea Street",
            "Sheaff Ln","Sheanwater Ln","Shear Rd","Shearin Ave","Shears Rd","Shearwater St","Sheath Road",
            "Sheck Rd","Shedd Canyon Rd","Sheddsville Rd","Sheelen's Xing","Sheep Pens Rd","Sheep Pond Road",
            "Sheep Ranch Rd","Sheep Trl","Sheepcamp Dr","Sheepfield Farms Rd","Sheepshead Bay Road",
            "Sheerbrooke Ct","Sheet Ln","Sheets Ln","Sheffield Ave","Sheffield Ct","Sheffield Dr","Sheffield Ln",
            "Sheffield Post","Sheffield Rd","Sheffield Road","Sheffield St","Sheffield Street","Sheffield Way",
            "Shefford Ln","Sheila Cir","Sheila Dr","Sheila Lane","Sheila St","Sheila St SE","Sheila Way",
            "Sheilah Ct","Shelawna","Shelbourne Ct","Shelbourne Drive","Shelbourne Pl","Shelbourne St",
            "Shelburn Ave","Shelburne Rd","Shelby Ave","Shelby Ct","Shelby Dr","Shelby Jackson Rd","Shelby Ln",
            "Shelby St","Sheldon Ave","Sheldon Avenue","Sheldon Ct","Sheldon Dr","Sheldon Rd","Sheldon Road",
            "Sheldon St","Sheldon Street","Sheldon Ter","Sheldrake Court","Shelford Rd","Shelia Ave",
            "Shelias Dr","Shell Beach Ln","Shell Beach Rd","Shell Creek Rd","Shell Ct","Shell Dr","Shell Flower Ln",
            "Shell Flower Rd","Shell Gate Rd","Shell Rd","Shell Turn St","Shellaray Drive","Shelley Ave",
            "Shelley Cir","Shelley Ct","Shelley Drive","Shelley Lane","Shelley Ln","Shelley Rd","Shelley St",
            "Shellfield Rd","Shelly Creek Rd","Shelly Ct","Shelly Dr","Shelly Lane","Shelly Ln","Shelly St",
            "Shelome Ct","Shelter Cove Dr","Shelter Cove Rd","Shelter Ln","Shelter Valley Road","Sheltered Cove Rd",
            "Sheltering Pines St","Shelterwood Cir","Shelterwood Ln","Sheltie Ave","Shelton Butte Rd",
            "Shelton Ln","Shelton Rd","Shelton Street","Shelva","Shenandoah Dr","Shenandoah Mtn Rd","Shenandoah Pl",
            "Shenandoah Trl","Shenley Ct","Shepard Ave","Shepard Avenue","Shepard Canyon","Shepard Pl NE",
            "Shepard Rd","Shepard Road","Shepard Spring Blvd","Shepard St","Shepard Street","Shepard Valley Rd",
            "Shepard Way","Shepardson Place Road","Sheperd Rd","Shephard Ave","Shephard Pl","Shepherd Ave",
            "Shepherd Lane","Shepherds Knoll Rd","Shepler Church Ave SW","Sheppard Ave","Sheppard Avenue",
            "Sheppard Avenue E","Sheppard Avenue East","Sheppard Avenue W","Sheppard Avenue West",
            "Sheppard Rd","Sheppard St","Sheppards Trail","Sherbear Dr","Sherborne Ct","Sherbourne Drive",
            "Sherbourne Street North","Sherbrook Court","Sherbrook Ct","Sherbrooke Cir","Sherbrooke Ct",
            "Sherbrooke Street","Sherburne Ct","Sherburne Pl","Shereen Ct","Sherer St","Sheridan Ave",
            "Sheridan Avenue","Sheridan Bay Park","Sheridan Court","Sheridan Ct","Sheridan Dr","Sheridan Ln",
            "Sheridan Pl","Sheridan Rapids Road","Sheridan Rd","Sheridan Road","Sheridan Sq","Sheridan St",
            "Sheridan Street","Sheridan Terrace","Sheriff St","Sherin Court","Shering Crescent","Sherlock Pl",
            "Sherman Aly","Sherman Ave","Sherman Creek Rd","Sherman Dr","Sherman Drive","Sherman Hill Rd",
            "Sherman Pl","Sherman Place","Sherman Rd","Sherman St","Sherman Street","Sherman Way","Shermantown Rd",
            "Shermon Rd","Shero Rd","Sherrer Ave","Sherri Ct","Sherrill St","Sherrington Ln","Sherrit Ln",
            "Sherrod Ct","Sherry Ann Pl","Sherry Ct","Sherry Lee Lane","Sherry Ln","Sherry Rd","Sherry St",
            "Sherstone Dr","Sherway Drive","Sherwin Trail","Sherwood Aly","Sherwood Ave","Sherwood Avenue",
            "Sherwood Cir","Sherwood Circle","Sherwood Ct","Sherwood Downs","Sherwood Dr","Sherwood Forest",
            "Sherwood Forest Dr","Sherwood Forest Drive","Sherwood Hill Dr","Sherwood Lane","Sherwood Ln",
            "Sherwood Mills Boulevard","Sherwood Pl","Sherwood Rd","Sherwood Springs Road","Sherwood St",
            "Shetland Cir","Shetland Ct","Shetland Dr","Shetland Ln","Shetland Pl SW","Shetland Rd","Shetland Road",
            "Shetland St","Shetler Rd","Shevelin Rd","Shevington Dr","Shewbert St","Shewchenko Ave","Shiawassee Dr",
            "Shiawassee Shores","Shields Ln","Shields Rd","Shields St","Shields Street","Shielings Rd",
            "Shiells Canyon Rd","Shifflett Rd","Shillelagh Ln","Shillinger Aly","Shillington Avenue",
            "Shillington Place","Shiloh Canyon","Shiloh Dr","Shiloh School Ln","Shiloh St","Shimer Ave",
            "Shimer St","Shimmering Way","Shimmins Ridge Rd","Shims St","Shinarump Rd","Shine Dr","Shine Johnston Rd",
            "Shine Rd","Shingle Landing Dr","Shingle Mill Rd","Shingle Oak Ct","Shingle Oak Dr","Shingle Pass Rd",
            "Shingle Springs Dr","Shinn St","Shinnecock Trl","Ship Ave","Ship Pond Road","Ship Ways Avenue",
            "Shipe St","Shipka Court","Shipley Rd","Shipley St","Shipman Rd","Shipp Crescent","Shippees Road",
            "Shippen St","Shipps Way","Ships Channnel","Ships Dr","Shipyard Dr","Shiral Pte Dr N","Shire Ct",
            "Shire Dr S","Shire Rd","Shirkey Ln","Shirlene Pl","Shirley Ave","Shirley Avenue","Shirley Cir",
            "Shirley Ct","Shirley Dr","Shirley Drive","Shirley J Ln","Shirley Ln","Shirley Road","Shirley St",
            "Shirley St NE","Shirley Street","Shirley Ter","Shirley Way","Shirleys Ct","Shirly Ln","Shirlynn Ct",
            "Shirrick Drive","Shive Pl","Shively Flat Rd","Shively Rd","Shively Summer Rd","Shivers Ln",
            "Shoal Creek Dr","Shoal Creek Rd","Shoal Pl","Shoal Point Road","Shoalhaven Dr","Shoemaker Ave",
            "Shoemaker Hill Rd","Shoemaker Road","Sholtz Terrace","Shoman Rd","Shonna Way","Shook Rd",
            "Shoot Flying Hill Road","Shooting Star Ct","Shop Rd","Shoppers Rd","Shops Blvd","Shore Acres Dr",
            "Shore Ave","Shore Blvd","Shore Breeze Dr","Shore Concourse","Shore Cove Ave","Shore Dr",
            "Shore Drive","Shore Haven Ct","Shore Isle Pl","Shore Ln","Shore Parkway","Shore Parkway North",
            "Shore Pky","Shore Rd","Shore Road","Shore Trail","Shore Wood Dr","Shorebird Way","Shorecres Road",
            "Shorecrest Dr","Shoreham Court","Shoreham Ct","Shoreham St","Shoreline Ct","Shoreline Dr",
            "Shoreline Drive","Shoreline Hwy","Shoreline Rd","Shores Camp Rd","Shores Ct","Shoreside Ct",
            "Shoreside Dr","Shoreside Road","Shoreview Ave","Shoreview Drive","Shorewood Acres Rd",
            "Shorewood Ave","Shorewood Dr","Shorn Dr","Shorncliffe Avenue","Shorncliffe Road","Shorrock St",
            "Short","Short Aly","Short Ave","Short Cir","Short Crescent","Short Ct","Short Gait Cir","Short Grade Rd",
            "Short Ham Green Ln","Short Hill Rd","Short Hinsdale Ave","Short Ln","Short Pl","Short Place",
            "Short Point Road","Short Putt Rd","Short Rail Rd","Short Rd","Short Road","Short St","Short Street",
            "Short Way","Short Way Dr","Short-Term and Long-Term Parking","Shortcut Dr","Shortcut To Pincherry",
            "Shorter Ave SE","Shorthorn Ct","Shorthorn Dr","Shortland Cir","Shortleaf St","Shortline Ct",
            "Shortman Rd","Shortt Ave","Shortt Street","Shortway Rd","Shorty St","Shoshana Drive","Shoshana Pl",
            "Shoshannah Ln","Shoshone Ave","Shoshone Dr","Shoshone Ln","Shoshone Rd","Shoshone Rd NE",
            "Shoshone Trl","Shoshoni Loop","Shoshoni Rd","Shot Gun Rd","Shotgun Dr","Shotgun Ln","Shotwell Park",
            "Shotwell St","Shovehead Dr","Shoveler Ct","Show Ct","Showell Pond Cir","Showplace Ln","Shreve Rd",
            "Shreves Aly","Shrewsbury Ave","Shrewsbury Dr","Shrewsbury River Brg","Shrewsbury Square",
            "Shrewsbury Street","Shrewsbury Yard","Shrine St","Shuart Rd","Shuff Ln","Shugart Rd","Shultis Brook Rd",
            "Shults St","Shultz Dr","Shultz Rd","Shultz St","Shuman Circle","Shun Pike","Shunoski Ln","Shunpike Rd",
            "Shurie Road","Shurite Rd","Shust Rd","Shuter Street","Shutesbury Road","Shutt St","Shutter Ct",
            "Shuttle Dr","Shylock Dr","Siari Kuta","Sias Ave","Sibbald Crescent","Sibel Ct","Siberia Rd",
            "Sibila Rd NW","Sibitt Avenue","Sibley Avenue N","Sibley Rd","Sibley St NW","Sibley Street",
            "Siboney Villa Cir","Sicard Hollow Rd","Sickenberger Ln","Sickler Rd","Sickles Ave","Sickrad Dr",
            "Sicomoro St","Sid's Ct","Siddall Rd","Side St","Sidehill Rd","Sideline 22 Road","Sideline 28 Road",
            "Sideoaks Lane","Sides Rd","Sidewalk","Sidewinder St","Sidney Ave","Sidney Dr","Sidney Jones Ln",
            "Sidney Smith Rd","Sidney St","Sidney Street","Sidney Ter","Sidonia Ave","Sidwell Rd","Sieber Pl",
            "Siemer Ln","Siemon Rd","Siempre Verde Dr NE","Siena Ave","Siena Ct","Siena Dr","Sienna Dr",
            "Sienna Trl","Sierra Alta Way","Sierra Ave","Sierra Blanca Rd NE","Sierra Center Pky",
            "Sierra Creek Ln","Sierra Crest Dr","Sierra Ct","Sierra Dr","Sierra Glen","Sierra Grande",
            "Sierra Hwy","Sierra Leon Rd","Sierra Linda Dr","Sierra Madre Dr","Sierra Oak Ct","Sierra Paseo Ln",
            "Sierra Pine Ct","Sierra Pky","Sierra Rd","Sierra Reyes Ln","Sierra Rojo Ln","Sierra Sky Dr",
            "Sierra Summit Dr","Sierra Trl","Sierra Valley Road","Sierra View Dr","Sierra View Rd",
            "Sierra Vista Ave","Sierra Vista Cir","Sierra Vista Dr","Sierra Way","Sierra del Sol",
            "Siesta Ct","Siesta Ln","Siesta Rock","Siesta Way","Sigma Chi Rd NE","Sigmond Cir","Sign Rd",
            "Signal Avenue","Signal Peak Rd","Signal Point Rd","Signature Dr","Signet Drive","Signet Ln",
            "Sigourney Street","Sigtim Dr","Siirila Rd","Sikorsky St","Sikorsky Way","Silas Hill Drive",
            "Silas Rd","Silcox Ln","Silcreek Dr","Sile Rd","Silent Night","Silent Path Way","Silent Way",
            "Silent Wings Way","Siles Ave","Silesia Court","Silica Ave","Silica Sand Rd","Silicon Ave",
            "Silk Pl","Silk Tree Ct","Silkwood Crescent","Silkwood Ct","Sill Pl","Sill Rd","Sillers Avenue",
            "Sills Road","Silmoro Court","Silo Rd","Silsby Rd","Silva Ct","Silva Place","Silva Rd","Silvaire Dr",
            "Silver","Silver Ave","Silver Avenue","Silver Bay Trl","Silver Beech Ct","Silver Beech Rd",
            "Silver Birch Avenue","Silver Birch Lane","Silver Birch Rd","Silver Birch Road","Silver Birch Trail",
            "Silver Bridge Rd","Silver Buckle Rd","Silver Bullet Dr","Silver Canyon Rd","Silver Castle St",
            "Silver Chisel Ave","Silver Cir","Silver Cliff Way","Silver Clipper Pl","Silver Cloud St",
            "Silver Creek Cir","Silver Creek Ct","Silver Creek Dr","Silver Creek Valley Rd","Silver Creek Valley Trail",
            "Silver Crest Dr","Silver Ct","Silver Cv","Silver Dart Drive","Silver Fish Truck Trail",
            "Silver Fox Court","Silver Fox Ct","Silver Fox Cv","Silver Fox Ln","Silver Frost St","Silver Glen Ave",
            "Silver Hawk Ct","Silver Heights Drive","Silver Hill Ave","Silver Hill Dr","Silver Lake Ave",
            "Silver Lake Ct","Silver Lake Dr","Silver Lake Rd","Silver Lane Rd","Silver Leaf Ct","Silver Leaf Dr",
            "Silver Leaf Ln","Silver Linden Drive","Silver Ln","Silver Lode Dr","Silver Maple Court",
            "Silver Maple Dr","Silver Maple Drive","Silver Maple Ln","Silver Maple Road","Silver Maples Park",
            "Silver Meadow Ct","Silver Mine Trl","Silver Mtn Rd","Silver Nugget St","Silver Oak Cir",
            "Silver Oak Dr","Silver Oaks Dr","Silver Peak Ave","Silver Place","Silver Ridge St","Silver Road",
            "Silver Rose Crescent","Silver Sage","Silver Shade Xing","Silver Shadow Path","Silver Spear Road",
            "Silver Spring Rd","Silver Springs Boulevard","Silver Springs Dr","Silver Springs Ln",
            "Silver Spruce Cir","Silver Spur Cir","Silver Spur Trl","Silver St","Silver Star Boulevard",
            "Silver Star Dr","Silver Star Trl","Silver Stream Avenue","Silver Street","Silver Tank Rd",
            "Silver Tip Ln","Silverado Dr","Silverado Ranch Boulevard","Silvercliff Ct","Silvercrest Ct NW",
            "Silverdale Road","Silverfield Way","Silverhawk Ct","Silverod Pl","Silverside Ave","Silverside Rd",
            "Silverside Road","Silverspur Dr","Silverstone Drive","Silverstone St","Silverthorn Ln",
            "Silverthorne Dr","Silverthorne Rd","Silvertide Dr","Silverton Cir","Silverton Dr","Silvertree Ct",
            "Silverwoo Crescent","Silverwood","Silverwood Ct","Silverwood Dr","Silverwood Loop","Silvery Ave",
            "Silvestri Ln","Silvia Pl","Simcoe Rd","Simcoe Road","Simcoe Road 169","Simcoe Street","Simcoe Street North",
            "Simcoe Street South","Simcoesid Avenue","Simmons Drive","Simmons St","Simon Dr","Simon St",
            "Simonds Rd","Simoni Rd","Simons Ave","Simons Ct","Simonston Boulevard","Simplicity Ct NW",
            "Simpson Ave","Simpson Avenue","Simpson Cir SE","Simpson Ct","Simpson Ln","Simpson Pl","Simpson Pt Rd",
            "Simpson Rd","Simpson Road","Sims Ave","Sims Cir","Sims Hawkins Rd","Sims Ln","Sims Place Rd",
            "Sims Rd","Sims St","Sinawik Cabin","Sincerbeaux Rd","Sinclair Ave","Sinclair Pl","Sinclair St",
            "Sindoni Ln","Sing Rd","Sing Sing Road","Singac Ct","Singer Ave","Singer Pl","Singer Rd","Singer St",
            "Singing Eagle Rd","Singing Sands Rd","Singingwood Dr","Singleton Ct","Singleton Cv","Singley Ln",
            "Singley Rd","Sinnicks Avenue","Sinnott Road","Sinola Dr","Sinton Pl","Sioux Avenue","Sioux Cir",
            "Sioux City Ct","Sioux Creek Dr","Sioux Ct","Sioux Ln","Sioux Rd","Sioux River Cir","Sioux Trail Rd",
            "Sioux Trl","Sip Ave","Sip St","Sipappin Road 21","Sipp Ave","Sir Bedevere Place","Sir Francis Drake Blvd",
            "Sir Gareth Court","Sir John A. MacDonald Boulevard","Sir John's Homestead","Sir Lancelot Cir",
            "Sir Lawrence Ct","Sir Monahan St","Sir Percival Court","Sir Sanford Fleming Drive",
            "Sirard Ln","Siri Rd","Sirianni Ln","Sirina Court","Sirius Dr","Sirles Rd","Sirman Lane","Sirocco Dr",
            "Sirocco Drive","Sirrine Rd","Siscoe Pl","Siskiyou Dr","Sisley Ct","Sisman Avenue","Sisnerac Rd",
            "Sisson Dr","Sisson Hill Branch Road","Sisson Pond Rd","Sisson Road","Sister Bluff Condo Rd",
            "Sit Mill Rd","Sitgreaves Dr","Sitka Ave","Sitka Dr","Sitting Bull Cir","Sitts Rd","Sivigny Street",
            "Siwerts Way","Six Foot Bay Road","Six Foot Road","Six House Ln","Six Mile Crk Rd","Six Rivers Land",
            "Sixteen Road","Sixteenth Street","Sixth Avenue","Sixth Road","Sixth Street","Sixty Fifth Street",
            "Sixty Seventh Street","Sixty Third Street","Skaggs Dr","Skaggs Rd","Skaggs Springs Rd",
            "Skagit River Ct","Skagway","Skagway Rd","Skahan Road","Skakum Road","Skanee Rd","Skannie Ln",
            "Skating Lane","Skating Rink Rd","Skeet Club Rd","Skeeter's Aly","Skeetfield Point Rd",
            "Skelding Road","Skeleton Pass Rd","Skellenger Rd","Skellie Rd","Skellinger Rd","Skelmore Crescent",
            "Skelton Butte Rd","Ski Hill Road","Ski Ln","Ski Park Hwy","Ski Rio Rd","Ski Run Blvd","Ski Trails Rd",
            "Ski-Doo Cir","Skidmore Ct","Skiff Lane","Skiff Way","Skillen St","Skillings Rd","Skillman Ave",
            "Skillman Ter","Skilpadde Ln","Skimmer Ct","Skinkle Road","Skinner Cir","Skinner Dr","Skinner Ln SE",
            "Skinner Park Road","Skinner Rd","Skinner St","Skiparee Rd","Skipper Ln","Skippers Blvd",
            "Skippers Drive","Skipton Dr","Skokie Ct","Skookumchuck Trail","Skowhegan Dr","Skunk Creek Rd",
            "Skunk Hollow Rd","Skunk Run","Skuttle Ct","Sky Ball Rd","Sky Harbour Rd","Sky High Ct","Sky Hill Cir",
            "Sky Line Dr","Sky Ln","Sky Mountain Way","Sky Park Dr","Sky Ranch Dr","Sky Rd","Sky Ridge Ln",
            "Sky Rim Dr","Sky Top Dr","Sky Valley Rd","Sky View Dr","Sky View Gardens Rd","SkyWalk","Skybird Lane",
            "Skycrest Ct","Skydeck Road","Skye Ln","Skyeagle","Skyfarm Dr","Skyhawk Dr","Skyhawk Ln","Skylan Ln",
            "Skyland Way","Skylane St NW","Skylark Dr","Skylark Pl","Skylark St","Skyline","Skyline Ave",
            "Skyline Blvd","Skyline Ct","Skyline Dr","Skyline Drive","Skyline Rd","Skyline Rd NE","Skyline Ridge Ct NE",
            "Skyline Road","Skyline Ter","Skyline Truck Trail","Skytop Airport","Skytop Rd","Skyview Ct",
            "Skyview Dr","Skyview Path","Skyview Rd","Skyview Ter","Skyview Way","Skyward Ln","Skyward Way",
            "Skyway Avenue","Skyway Dr","Skyway Drive","Skyway Ln","Skyway Rd","Skywood Dr","Slab City Rd",
            "Slack Ave","Slack Rd","Slack Road","Slade Avenue","Slade St","Sladek Rd","Slaghrt Rd","Slagle Rd",
            "Slalom Drive","Slape St","Slash Pine Dr","Slate Creek Dr","Slate Creek Rd","Slate Dr","Slate Gap Point Rd",
            "Slate Gap Rd E","Slate Mountain Mine Rd","Slate Mountain Rd","Slater Court","Slater Dr",
            "Slater Rd","Slater St","Slater West Dr","Slaterfield Ave","Slaton","Slaugh Ct","Slaughter Dr",
            "Slayton Ave","Sledge Rd","Sledge St","Sleepert Mill Ln","Sleepy Fox Dr","Sleepy Hollow",
            "Sleepy Hollow Ct","Sleepy Hollow Dr","Sleepy Hollow Ln","Sleepy Hollow Rd","Sleepy Hollow Way",
            "Sleepy Valley Rd","Sleepy Willow Dr","Sleighride Rd","Sleight Rd","Slicer Ave","Slick Ford Rd",
            "Slick Lizzard Rd","Slide Inn Rd","Slide Mountain Dr","Slidell Crescent","Slim St","Slivka Rd",
            "Sloan Ave","Sloan Ct","Sloan Cyn Rd","Sloan Ln","Sloan Rd","Sloat Blvd","Sloat Pl","Slocum Canyon Rd",
            "Slocum Ln","Slocum Pl","Slocum Road","Slocum St","Slocum Street","Slocum Way","Sloley Road",
            "Sloop Ct","Slope Dr","Slosson Ave","Slosson Ln","Slotter Rd","Slough Road","Sluice St","Slum Guillion Gulch",
            "Slumpstone Way","Slusaric Rd","Slusher Dr","Sly Song Cir","Sm-50","Small Brook Ln","Small Rd",
            "Small Tract Rd","Smalley St","Smallwood Ln","Smallwood Rd","Smeaton Rd","Smiley Ferry Rd",
            "Smiley Rd","Smiley St","Smith","Smith Ave","Smith Avenue","Smith Bay Avenue","Smith Branch Rd",
            "Smith Camp Ln","Smith Chapel Rd NE","Smith Circle","Smith Court","Smith Creek Ln","Smith Ct",
            "Smith Dr","Smith Drive","Smith Farm Rd","Smith Hill Rd","Smith Hill Road","Smith Lake Dam Rd",
            "Smith Ln","Smith Loop","Smith Mountain Lookout Rd","Smith Pl","Smith Point Road","Smith Pt Rd",
            "Smith Rd","Smith Rd 1","Smith Road","Smith St","Smith Street","Smith Street E","Smith Ter",
            "Smith Way","Smith and Georgia Rd","Smithers Rd","Smithfield Ave","Smithfield Crescent",
            "Smithfield Ct","Smithfield Dr","Smithneck Rd","Smithridge Park","Smiths Falls Avenue",
            "Smiths Rd","Smithson Rd","Smithville Road","Smithwood Drive","Smock Ave","Smoke Dr","Smoke Peak St",
            "Smoke Rise","Smoke St","Smoke Tree Ct","Smoke Tree Dr","Smoke Tree Ln","Smoke Tree Ter",
            "Smokehouse Rd","Smoker Rd","Smokerise Dr","Smokes Point Road","Smoketree Cir","Smoketree Rd",
            "Smokey Ct","Smokie Hollow Rd","Smugglers Point","Smullen Ave","Smullen St","Smylie Rd","Smyth Ferry Rd",
            "Smythe St","Snaffel Pl","Snake Drive","Snake Hill Rd","Snake Rd","Snake River Ave","Snake Trail",
            "Snake Trl","Snapdragon Ct","Snapdragon Dr","Snapper Lane","Snedeker Rd","Sneech Pond Rd",
            "Snell Rd","Snider Drive","Snipatuit Road","Snively Rd","Snively Street","Snodgrass Rd","Snooks Cir",
            "Snoop St","Snoopy Ln","Snow","Snow Camp Rd","Snow Chief Ct","Snow Crest Rd","Snow Ct","Snow Dr",
            "Snow Hawk Dr","Snow Hill Rd","Snow Lake Rd","Snow Ln","Snow Mountain Avenue","Snow Rd","Snow Ridge Rd",
            "Snow Road","Snow Shoe Dr","Snow Shoe Rd","Snow Shoe Way","Snow St","Snow View Dr","Snowball Creek Rd E",
            "Snowberry Ln","Snowbridge Rd","Snowburg Rd","Snowcreek / Mammoth Creek Trail","Snowcreek St",
            "Snowcrest Ave","Snowcrest Avenue","Snowcrest Drive","Snowden Street","Snowdrift Cir",
            "Snowdrop Dr","Snowflake Ct NW","Snowflake Dr","Snowhill Dr","Snows Ct","Snows Rd","Snowshoe Ln",
            "Snowshoe Trl","Snowstorm Rd","Snowy Creek Way","Snowy Ln","Snowy Owl Lane","Snug Ct","Snug Harbor",
            "Snug Harbor Drive","Snug Harbor Ln","Snugsboro Rd","Snyder Ave","Snyder Avenue","Snyder Cir",
            "Snyder Dr","Snyder Hill Rd","Snyder Ln","Snyder Rd","Snyder Road","Snyder St","Snydersville Rd",
            "Snye River Road","Soapberry Way","Soares Ave","Soaring Ct","Soave Ln","Sobb Ave","Sobieski St",
            "Society Hill Drive North","Society Hill Way","Society Pl","Sockeye Ln","Socorro Dr","Soda Bay Dr",
            "Soda Bay Rd","Soda Lake - San Diego Creek Rd","Soda Lake Rd","Soda Springs Ct","Soda Springs Dr",
            "Soda Springs Pl","Soda Springs Rd","Sodalite Rd","Soden Ln","Soder Rd","Sodum Rd","Soelro Ct",
            "Soft Dirt Trail","Soft Springs St","Soft Whispers St","Sohier Road","Sola Ct","Solan Pl",
            "Solana Ct","Solano Ln","Solar Ave","Solar Cir","Solar Ct SE","Solar Way","Solar Wind St","Solare St",
            "Soldier Hill Rd","Soldiers Camp Rd","Soldiers Canyon Ln","Soldiers Field Road","Sole Road",
            "Soledad Prison Rd","Soles Ct","Soles Ln","Soliday Ct","Solitare Ln","Solitude Ave","Solloway St",
            "Soloeste Way","Soloman Ct","Solomon Rd","Solomon St","Solon Street","Solono Canyon Dr","Solvay Rd",
            "Solway Avenue","Solway Ct","Solway Rd","Soma Ct","Sombra Rd NW","Sombra del Norte Pl","Sombre de Luna",
            "Sombrero Court","Somerford Ct","Somergrove Crescent","Somers Ave","Somers Avenue","Somers Loop",
            "Somers Point Rd","Somersby Way","Somerset","Somerset Ave","Somerset Cir","Somerset Close St",
            "Somerset Ct","Somerset Dr","Somerset Drive","Somerset Gate","Somerset Ln","Somerset Park Cir",
            "Somerset Pky","Somerset Pl","Somerset Rd","Somerset Rise","Somerset Road","Somerset Springs Dr",
            "Somerset St","Somerset Terrace","Somerton Ave","Somerton St","Somerville Rd","Somerville Street",
            "Somerworth Dr","Somis Rd","Sommer Ct","Sommer Ln","Sommer Pl","Sommerville Drive","Sonata Ln NW",
            "Soncy Rd","Songbird Dr","Songbird Lane","Songbird Ln","Songbird Way","Songwood Drive","Sonia Ln",
            "Sonja Maria Way","Sonlite Ln","Sonnet St","Sonnie Ct","Sonny Cir","Sonny Ln","Sonny Street",
            "Sonoma Ave","Sonoma Ct","Sonoma Rd","Sonoma St","Sonoma Street","Sonoma Way","Sonora Ave","Sonora Ct",
            "Sonora Pass Hwy","Sonora Rd","Sonora St NW","Sonriente Trl","Sonrisa","Sontag Ln","Sonyea Road",
            "Sooky Cir","Sooy Rd","Soper Creek Drive","Soper Rd","Sopher Rd","Sopher's Landing Road",
            "Sophia Dr","Sophia Drive","Sophia Road","Sophia St","Sophia Street E","Sophia Street W",
            "Sophia Way","Sora Drive","Sorel Crescent","Sorensen St","Sorenson Rd","Sorghum Hollow Rd",
            "Soria Ct","Sorlyn Avenue","Sorman Ter","Sorrel Ln","Sorrell Ave","Sorrell St","Sorrento Avenue",
            "Sorrento Dr","Sorrento Drive","Sorrento Street","Sosnowitz St","Sotelo Ave","Sothern Lane",
            "Sotnick St","Sotol Cir","Sotol Dr","Souix Dr","Soules Road","Soulsbyville Rd","Sour Rd","Souter Rd",
            "South 19th Avenue","South 1st Street","South 350 East","South 3rd Street","South 400 East",
            "South 5th Street","South 9th Street","South A St","South Angel Fire Road","South Arm Rd",
            "South Ashburnham Road","South Athol Road","South Ave","South Avenue","South Avenue A",
            "South Bal Street","South Balsam Street","South Bay Blvd","South Bay Pass","South Beaver Lake Lane",
            "South Blvd","South Bogue Rd","South Bolton Road","South Border","South Border Rd","South Branch Rd",
            "South Broadway","South Brook Dr","South Butler Rd","South Campus Dr","South Cayuga Road",
            "South Charlame Terrace","South Circle Dr","South Cove Ct","South Cove Ln","South Crystal Street",
            "South Ct","South Dakota Ave","South Deerfield Dr","South Delancey Street","South Dr",
            "South Drive","South Dyer Lake Dr","South East Grant Ave","South Edge Dr","South Edgely Avenue",
            "South Elliott Place","South Elm Street","South Fork Lookout Rd","South Fork Trail",
            "South Forks Rd","South Gables Dr","South Gertruda Avenue","South Gibson Rd","South Gillis Canyon Rd",
            "South Grade Rd","South Grand Street","South Great Oaks Pky","South Grimsby Road #10",
            "South Hall Ct","South Hangar Rd","South Highland Ave","South Hill Rd","South Hills Dr SW",
            "South Island Trail","South Jason Drive","South Jetty Rd","South Junior Terrace","South Kahshe Lake Road",
            "South Lake Dr","South Lake Drive","South Lake Rd","South Light Plant Rd","South Ln","South Loop Rd",
            "South Main Rd","South Main St","South Main Street","South Mal","South Maple St","South Mast Rd",
            "South Meadow Road","South Meadows Pky","South Millway","South Mission Rd","South Navajo Loop",
            "South Normandy Avenue","South Ogden Annex","South Oxford Road","South Park Ave","South Park Canyon Road",
            "South Park Road","South Part Road Branch","South Path","South Paudash Lake Road",
            "South Pl","South Pleasant Street","South Point Way","South Pointe Cir","South Porter Street",
            "South Rainbow Dr","South Ravine St","South Rd","South Richwood Avenue","South Ridge Ave",
            "South Ridge Ct","South Ridge Rd","South Ridge Road","South River Road","South River Rd",
            "South Road","South Road Extension","South Russell Street","South Sacramento Fwy","South Sal Road",
            "South Sandisfield-new Marlboro Road","South Service Road","South Service Road West",
            "South Sheridan Way","South Shields Avenue","South Shipley Street","South Shipp","South Shirkshire Road",
            "South Shore Dr","South Shore Rd","South Side Pl","South Slope St","South Soda Rd","South Sparrow Lake Road",
            "South Spencer Road","South St","South St SW","South Station Ave","South Street","South Street East",
            "South Street Rd","South Sturbridge Road","South Summer Street","South Surf Ct","South Trl",
            "South Unionville Avenue","South Valley Frwy RMRd","South Valley Road","South Walnut Street",
            "South Walter Street","South Way","South Willow Rd","South Wing Viaduct","South Woodrow Boulevard",
            "South Worcester Street","South Worthington St","Southampton Dr","Southampton Rd","Southard Rd",
            "Southard St","Southbridge Court","Southbridge Road","Southbridge Street","Southbrook Dr",
            "Southbrook Way","Southcreek Ct","Southcreek Road","Southcrest Ave","Southcrest Dr","Southdale Drive",
            "Southdown Road","Southeast Turn","Southerland Drive","Southern Artery","Southern Blvd",
            "Southern Cross St","Southern Dr","Southern Hills Dr","Southern Oaks Dr","Southern Oaks Ln",
            "Southern Pine Way","Southern Pky","Southern Tier Expressway","Southern Trl","Southern Way",
            "Southfield Dr","Southfield Lane","Southfield Rd","Southfield Service Dr","Southfield Village",
            "Southfork Ln","Southfork Rd","Southfork Thruway","Southfront Rd","Southgate Court","Southgate Ct",
            "Southgate Dr","Southill Drive","Southington Rd","Southington Town Line Rd","Southland St",
            "Southland Terrace","Southlea Avenue","Southmead Road","Southmoor Cir NE","Southorn Road",
            "Southpass Dr","Southpaw Ln","Southpoint Cv","Southport Pky","Southport Way","Southridge Ct",
            "Southridge Cv","Southridge Dr","Southridge Rd","Southshire Dr","Southshore Dr","Southshore Meadows",
            "Southside Ave","Southside Avenue","Southside Dr","Southside Rd","Southview Ave","Southview Dr",
            "Southview Drive","Southview Ter","Southward Ave","Southwark Rd","Southwart Ct","Southwell Drive",
            "Southwell Ln","Southwest A St","Southwest Dr","Southwest Main Street","Southwest Shearwater Place",
            "Southwest Way","Southwestern Run","Southwick Ave","Southwick St","Southwick Street","Southwind Cir",
            "Southwind Dr","Southwind Drive","Southwind Rd","Southwinds Dr","Southwood Cir","Southwood Crescent",
            "Southwood Dr","Southwood Lake Dr","Southwood Ln","Southwood Rd","Southwood Road","Southwood Street",
            "Southwoods Dr","Southworth Rd","Southworth Street","Souza Dr","Souza Rd","Souza St","Sovereign Gate",
            "Soverel Ter","Sovey St","Sowles Rd","Spa Spring Rd","Spa St","Space St","Space Way","Spade Bit Dr",
            "Spadina Avenue","Spadina Avenue North","Spadina Road","Spaeth Rd","Spall Rd S Spur","Spanbridge Road",
            "Spanish Corral Ln","Spanish Fort Blvd","Spanish Moss Ave","Spanish Moss Ln","Spanish St",
            "Spanish Trl","Spar Ave","Spar Close","Spar Dr","Spar Street","Sparhawk Drive","Sparhawk Rd",
            "Sparkle Crest Ave","Sparkle St","Sparkman Dr NW","Sparks Blvd","Sparks Rd","Sparks St","Sparman Pl",
            "Sparrow","Sparrow Cir","Sparrow Court","Sparrow Ct","Sparrow Dr","Sparrow Glen Way","Sparrow Hawk Ct",
            "Sparrow Ln","Sparrow Park Rd","Sparrow Rd","Sparrow St","Sparrow Turn","Sparrowbush Rd",
            "Sparrowhawk Point Dr","Sparta Ave","Sparta Dr","Spartan Avenue","Spartan Dr","Spartan Rd",
            "Spartan Way","Spartansburg Hwy","Sparwood Court","Spatter Cone Rd","Spaulding Ave","Spaulding Ln",
            "Spaulding Rd","Spaulding St","Spaulding Tpke","Spawning Run Ln","Spear Rd","Spear Road",
            "Spearmint Dr","Spears Ln","Specht Dr","Special Service Road","Spectrum","Spectrum Pointe Dr",
            "Speedway","Speedway Ave","Speedway Oval","Speedway Overlook","Speedway Rd","Speedwell Avenue",
            "Speer Ave","Speer St","Spell Rd","Spellman St","Spem","Spence Lane","Spence Street","Spencer Ave",
            "Spencer Cir","Spencer Court","Spencer Ct","Spencer Hill Rd","Spencer Ln","Spencer Pl","Spencer Rd",
            "Spencer Road","Spencer St","Spencer Street","Spencer-Glenville-Weston","Spender Hill Farm Rd",
            "Spenvalley Drive","Sperling Ct","Sperry Rd","Sphinx Ct","Spice Apple Ln","Spice Bush Cir",
            "Spicer Circle","Spicer Meadow Rd","Spicer Rd","Spicer Square","Spicewood Cir","Spicewood Ct",
            "Spider Hill Rd","Spielman Rd","Spiers Crescent","Spigno Pl","Spike St","Spiller Circle",
            "Spinaker Close","Spinaker Way","Spindle Point Rd","Spindrift Ln","Spindrift Pl","Spindrift Rd",
            "Spindrift Way","Spinet Dr","Spinnaker Cir","Spinnaker Ct","Spinnaker Way","Spinner Dr","Spinner Point Ct",
            "Spinney Ave","Spirea Dr","Spirea Ln","Spirit Dr","Spirit Lake Dr","Spirit Mountain Loop",
            "Spirit Trail Pl NE","Spirit Valley","Spitfire Ct","Spitfire St","Spivey Rd","Split Acres Dr",
            "Split Maple Court","Split Maple Gate","Split Oak Cir","Split Oak Dr","Split Rail Ct",
            "Split Rail Lane","Split Rail St","Split Rock Cir","Split Rock Ct","Split Rock Dr","Split Rock Ln",
            "Split Rock Rd","Split Rock Road","Spofford Avenue","Spofford Rd","Spofford Street","Spokane Dr",
            "Spoke Ct","Spoke St","Spoleto Dr","Spook Ridge Rd","Spook Rock Rd","Spoonbill Ave","Spoonbill Ct",
            "Spoonbill Hollow","Spoonbill Ln","Spooner Dr","Spooner Rd","Spooner Road","Spoonger Rd",
            "Sports Dr","Sportsman Club Rd","Sportsman Lake Rd","Sportsmans Way","Sportsmens Rd","Spout Spring",
            "Spragg Circle","Spraggins Rd","Sprague Aly","Sprague Ave","Sprague Dr","Sprague Street",
            "Spray Avenue","Spray Ln","Sprig Ct","Sprig Trail","Spring Alley","Spring Aly","Spring Ave",
            "Spring Avenue","Spring Bank South Rd","Spring Berry Gate","Spring Blossom St","Spring Brook Cir",
            "Spring Brook Rd","Spring Brook Road","Spring Canyon Ln","Spring Court","Spring Creek Ln",
            "Spring Creek Pl","Spring Creek Rd","Spring Creek Road","Spring Crk Rd","Spring Ct","Spring Dr",
            "Spring Farm Road","Spring Flower Dr","Spring Forest Square","Spring Garden Ave","Spring Garden Boulevard",
            "Spring Garden Rd","Spring Garden Road","Spring Garden St","Spring Garden Street","Spring Green Rd",
            "Spring Gulch Rd","Spring Hill Ln","Spring Hill Rd","Spring Hollow Rd","Spring Hunter Ct",
            "Spring Lake Ct","Spring Lake Dr","Spring Lake Rd","Spring Lane","Spring Ln","Spring Meadow Ln",
            "Spring Meadows Dr","Spring Mill Ct","Spring Mill Dr","Spring Mountain Rd","Spring Pl",
            "Spring Rd","Spring Rd NE","Spring Road","Spring St","Spring St SW","Spring Street","Spring Town Road",
            "Spring Trl","Spring Valley Ave","Spring Valley Cir","Spring Valley Cir SW","Spring Valley Dr",
            "Spring Valley Market Pl","Spring Valley Ranch Rd","Spring Valley Rd","Spring Valley Way",
            "Spring View Drive","Spring View Ln","Spring Water Dr","Spring Way","Spring Willow Ct",
            "Springbank Avenue","Springbank Rd","Springbrook Ave","Springbrook Ct","Springbrook Drive",
            "Springbrook Mhp","Springburn Crescent","Springcreek Rd","Springcrest Blvd","Springdale Ave",
            "Springdale Avenue","Springdale Dr","Springdale Garden Rd","Springdale Greendell Rd",
            "Springdale Rd","Springdale Ter","Springer Ave","Springer Blvd","Springer Rd","Springers Rd",
            "Springfield Ave","Springfield Cir","Springfield Ct","Springfield Dr NE","Springfield Pvt Dr",
            "Springfield Rd","Springfield Street","Springhaven Rd","Springhill Ave","Springhill Church Rd",
            "Springhill Ct","Springhill Drive","Springhill Farms","Springhom Road","Springhouse Lane West; Cross Creek Dr",
            "Springland Ct","Springlawn Rd","Springs Ct","Springside Avenue","Springside Pl","Springsteen Ct",
            "Springtime Cndo","Springtime Ln","Springton Mews Cir","Springvale Dr","Springview Ct",
            "Springview Dr","Springview Rd","Springville Blvd","Springwater Ln","Springway Ln","Springwood Heights Crescent",
            "Springwood Way","Sprinkle Ave","Sprinkle Ct","Sprinkle Rd","Sproul Rd","Sproul St","Spruce",
            "Spruce Ave","Spruce Brook Rd","Spruce Court","Spruce Ct","Spruce Dr","Spruce Grove Road",
            "Spruce Gulch Rd","Spruce Haven St","Spruce Hill Rd","Spruce Hill Road","Spruce Hollow Dr NE",
            "Spruce Lake Ave","Spruce Lake Rd","Spruce Ln","Spruce Mountain Way","Spruce Park","Spruce Pl",
            "Spruce Rd","Spruce Rd NW","Spruce Road","Spruce Run","Spruce St","Spruce Street","Spruce Ter",
            "Spruce Trailways Rd","Spruce Tree Cir","Spruce Tree Lane","Spruce Trl","Spruce Way","Spruceland Ter",
            "Spruceside Crescent","Sprucewood Crescent","Sprucewood Drive","Sprucewood Ln","Sprugen Way",
            "Spry St","Spuce Hen Rd","Spunkmeyer Way","Spunky Hollow Rd","Spunn Rd","Spur Dr","Spur Ln",
            "Spur Rd","Spurce Ln","Spurgeon Rd","Spurlin St","Spurlock Dr","Spurlock Rd","Spurlock Rd-Union Ridge Rd",
            "Spurs St","Spy Glass Dr","Spy Glass Hill Dr","Spy Glass Ln","Spyglass Blvd","Spyglass Ct",
            "Spyglass Dr","Spyglass Hill","Spyglass Ln","Spyglass Pl","Spyglass Pl SE","Spyglass Rd",
            "Spyrock Rd","Squadrilli Way","Squall Trail","Squam Lake Rd","Squantum Rd","Square St","Squash Lake Ln",
            "Squaw Canyon Rd","Squaw Creek Rd","Squaw Dr","Squaw Rd","Squaw Trl","Squaw Valley Rd","Squire Baker's Lane",
            "Squire Cir","Squire Ct","Squire Dr","Squire Drive","Squire Ln","Squire Rd","Squire Street",
            "Squire Way","Squires Avenue","Squires Beach Road","Squires Dr","Squires Ln","Squires Rd",
            "Squires Row","Squirewood Ct NE","Squirrel Ct","Squirrel Dr","Squirrel Hollow","Squirrelwood Rd",
            "Sr1013","Sr2006","Sr2016","Sr2021","Sr3001","Sr3002","Sr3014","Sr4001","Srigley Street","Ss Bar Ranch Rd",
            "St Albans Court","St Albans Pl","St Albans Rd","St Albans St","St Aloysius St","St Andrews Boulevard",
            "St Andrews Ct","St Andrews Dr","St Andrews Ln","St Andrews Pky","St Andrews Pl","St Andrews Rd",
            "St Andrews St SW","St Andrews Way","St Anthony Ave","St Anthony Ln","St Arthur","St Asaphs Ave",
            "St Augustine Dr","St Augustine Ln","St Augustine Way","St Bernard Dr","St Candor","St Christopher Dr",
            "St Clair Ave","St Clair County 42","St Clair Ct","St Clair St","St Cloud Way","St Cornelius Cemetery",
            "St Davids Ln","St Davids Road","St Davids St","St Dennis Ln","St Edward","St Egbert","St Elmos Dr",
            "St Emillion Ct","St Francis Rd NW","St Francis Way","St George Ave","St George Cir","St George Dr",
            "St George Rd","St Georges Clarks Corner Road","St Germaine Pl","St Helena St","St Helene Pl",
            "St Hwy","St Hwy Rd","St James Ave","St James Dr","St James Pl","St James Rd","St Jean St; 7th St",
            "St John Pl","St John Rd","St John St","St John's Ave","St John's Creek Rd","St Johns Pl",
            "St Johns Rd","St Joseph St","St Jude Dr","St Lakes Ct","St Lawrence","St Lawrence Ave","St Lawrence Ledges Rd",
            "St Louis Ave","St Marks Ave","St Marks Pl","St Martins Ave","St Martins Ct","St Martins Rd",
            "St Mary Dr","St Mary's Street","St Marys Ct","St Marys Dr NE","St Marys Pl","St Marys St",
            "St Marys Ter","St Mayeul Dr","St Michael Dr","St Moritz Dr","St Moritz Way","St Nicholas Ave",
            "St No 7","St Patrick Ct","St Patrick Street","St Paul Ave","St Paul Dr","St Paul Street West",
            "St Pauls Ave","St Peter Dr","St Peters Dome Rd","St Peters Way","St Phillips Pl","St Rita's School",
            "St Rt 2","St Rtc 49","St Stephen Ave","St Thomas St","St Tikhons Rd","St Wynten's Court",
            "St. Andrews Avenue","St. Andrews Pl","St. Aubyn's Crescent","St. Augustine Drive",
            "St. Charles Street","St. Chris Road","St. Clair Avenue East","St. Clair Avenue West",
            "St. Dennis Drive","St. Dismas Street","St. Edmunds Drive","St. George Street","St. Germain Drive",
            "St. Germain Avenue","St. Germaine Avenue","St. James Avenue","St. James Court","St. James Street",
            "St. John' Sideroad","St. John's Sideroad East","St. Josep Street","St. Joseph Street",
            "St. Joseph Valley Parkway","St. Lawrence Street","St. Lawrence Avenue","St. Lawrence Street",
            "St. Lawrence Street - Morrisburg","St. Lawrence Street W","St. Leonard's Avenue",
            "St. Leonards Avenue","St. Louis Place","St. Mark's Road","St. Marty's Avenue","St. Mary's Avenue",
            "St. Mary's Road","St. Mary's Street","St. Ola Road","St. Patrick Avenue","St. Patrick Street",
            "St. Patrick's Market","St. Paul Street","St. Phillips Road","St.Luke's Road","Stacey Cir",
            "Stacey Ct","Stacey St","Staci Ln","Stacie Ct","Stack Grd","Stackhouse St","Stackhouse Street",
            "Stacy Ct","Stacy Dr","Stacy Ln","Stacy Rd","Staddens Bridge Rd SE","Stadelbauer Drive","Stadelman Ct",
            "Stadium Ave","Stadium Ct","Stadium Dr","Stadium Pl","Stadium Rd","Stadium Road","Stadium Way",
            "Staff Avenue","Staff Rd","Staff Sgt James Parker Rd","Staffehl Dr","Stafford Crescent",
            "Stafford Ct","Stafford Dr","Stafford Park Blvd","Stafford Rd","Stafford Road","Stafford Ter",
            "Stafford Way","Staffordshire Dr","Stag","Stag Drive","Stag Haven","Stag Lake East","Stag St",
            "Stage Ave","Stage Bandit","Stage Coach Road","Stage Coach Dr","Stage Coach Rd","Stage Coach Road",
            "Stage Rd","Stage Road","Stagecoach Ct","Stagecoach Dr","Stagecoach Ln","Stagecoach Rd","Stagecoach Trl",
            "Stagecoach Way","Stageline Ct","Stager St","Stagg Run","Stagg St","Stagg Walk","Staghorn Dr",
            "Staghorn Way","Stags Leap Way","Stahala Dr","Stahl Ln","Stahl Rd","Staie Rd","Staker Hill Rd",
            "Stal Mar Cir","Stalcup Cir","Stallings Ave","Stallion Dr","Stallion Ln","Stameroff Ct","Stamford Ln",
            "Stamford Rd","Stamford St","Stamford Street","Stamos Ct","Stamper St","Stan Crest Dr","Stan Michels Promenade",
            "Stan Roberts Sr Ave","Standard Mill Rd","Standard Pl","Standard St","Stander Dr","Standing Boy Ct",
            "Standish Ave NE","Standish Avenue","Standish Dr","Standish Ln","Standish Way","Standish-Hickey State Recreation Area",
            "Standrich St","Stanford Ave","Stanford Ct","Stanford Dr NE","Stanford Dr SE","Stanford Rd",
            "Stanford St","Stanford Way","Stange Ave","Stangle Rd","Stanhope Ave","Stanie Brae Dr","Stanislaus Ave",
            "Stanislaus St","Stanley","Stanley Ave","Stanley Avenue","Stanley Benn Ln","Stanley Crescent",
            "Stanley Ct","Stanley Drive NW","Stanley Ln NW","Stanley Pl","Stanley Rd","Stanley Road",
            "Stanley St","Stanley Street","Stanley Ter","Stanley Terrace","Stanley Way","Stanorm Ln",
            "Stansbury Ave","Stantack Road North","Stanton Ct","Stanton Hill Rd","Stanton Lebanon Rd",
            "Stanton Ln","Stanton Rd","Stanton Road","Stanton St","Stanton Station Rd","Stanton-Ogletown Rd",
            "Stantonville Dr","Stanwell Rd","Stanwin Ave","Stanwix Street","Stanwood Badger Rd","Stanwood Ln",
            "Stanyan Rd","Staple Ct","Staple Street","Stapleford Terrace","Stapler Pl","Staples","Staples Street",
            "Stapleton Ln","Staplin Rd","Star Acres Dr","Star Ave","Star Board Ct","Star Bush Ct","Star Chase Pl",
            "Star Crest Ln","Star Eye St NE","Star Fire Cir","Star Gazer Ln","Star Hill Road","Star Lake Rd",
            "Star Ledger Plz","Star Line Rd","Star Ln","Star Meadow Dr","Star Splitter Ct","Star St",
            "Star Thistle Ln","Starbird Avenue","Starbird Dr","Starboard Ct","Starboard Dr","Starboard St",
            "Starbottle Ct","Starbrook St","Starbuck Ave","Starch Mill Rd","Starchief St","Starcrest",
            "Starcrest Dr","Stardust Ct","Stardust Dr","Stardust Drive","Stardust Ln","Stardust St","Stare St",
            "Starfield Ln","Starfire Ct","Starfish Dr","Starfish Ln","Stargaze Ln","Stargaze Way","Stargazer Drive",
            "Stargazer Ln","Stargell Drive","Stargrass Rd","Staring Ln","Stark Ave","Stark Drive","Stark Hill Rd",
            "Stark Ln","Stark St","Starkin Rd","Starland Dr","Starlight Avenue","Starlight Cir","Starlight Dr",
            "Starlight Ln","Starlight Peak Dr","Starlight Rd","Starlight Way","Starline Dr","Starling Ave",
            "Starling Boulevard","Starling Ln","Starling Rd","Starlite Dr","Starlite Ln","Starlite Way",
            "Starnes Dr N","Starns St","Starr Ave","Starr Crescent","Starr Pass Trail","Starr Rd","Starrucca Creek Rd",
            "Starview Dr","Starwood Dr","Starwood Road","State Highway 3","State A St","State Ave","State Ct",
            "State Docks Rd","State Fair Blvd","State Farm Pky","State Farm Road","State Highway 1",
            "State Highway 10","State Highway 100","State Highway 101","State Highway 102","State Highway 103",
            "State Highway 104","State Highway 107","State Highway 111","State Highway 112","State Highway 113",
            "State Highway 118","State Highway 11A","State Highway 12","State Highway 121","State Highway 123",
            "State Highway 124","State Highway 125","State Highway 126","State Highway 128","State Highway 12A",
            "State Highway 12B","State Highway 131","State Highway 133 (Spur)","State Highway 136",
            "State Highway 139","State Highway 14","State Highway 140","State Highway 144 W","State Highway 155",
            "State Highway 159","State Highway 16","State Highway 160","State Highway 164","State Highway 165",
            "State Highway 166","State Highway 167","State Highway 168","State Highway 169-S","State Highway 17",
            "State Highway 172","State Highway 173","State Highway 174","State Highway 178","State Highway 17A",
            "State Highway 17C","State Highway 18","State Highway 180","State Highway 181","State Highway 184",
            "State Highway 185","State Highway 188","State Highway 19","State Highway 190","State Highway 193",
            "State Highway 195","State Highway 198","State Highway 2","State Highway 20","State Highway 20 W",
            "State Highway 200","State Highway 201","State Highway 2033","State Highway 204","State Highway 205",
            "State Highway 208","State Highway 209","State Highway 21","State Highway 213","State Highway 214",
            "State Highway 214 E","State Highway 217","State Highway 22","State Highway 220","State Highway 222",
            "State Highway 225","State Highway 226","State Highway 23","State Highway 235","State Highway 238",
            "State Highway 24","State Highway 248","State Highway 249","State Highway 250","State Highway 252",
            "State Highway 253","State Highway 255","State Highway 26","State Highway 264","State Highway 267",
            "State Highway 27","State Highway 275","State Highway 279","State Highway 28","State Highway 280",
            "State Highway 281","State Highway 285","State Highway 289","State Highway 29","State Highway 293",
            "State Highway 299","State Highway 3","State Highway 30","State Highway 300","State Highway 301 N",
            "State Highway 303","State Highway 303 N","State Highway 303 S","State Highway 304",
            "State Highway 305","State Highway 307","State Highway 309","State Highway 31","State Highway 314",
            "State Highway 318","State Highway 32","State Highway 325","State Highway 33","State Highway 330",
            "State Highway 332","State Highway 336","State Highway 338","State Highway 339","State Highway 34",
            "State Highway 340","State Highway 348","State Highway 349","State Highway 35 South",
            "State Highway 352","State Highway 355","State Highway 36","State Highway 363","State Highway 365",
            "State Highway 369","State Highway 37","State Highway 370","State Highway 371","State Highway 373",
            "State Highway 375","State Highway 377","State Highway 379","State Highway 38","State Highway 39",
            "State Highway 390","State Highway 391","State Highway 396","State Highway 399","State Highway 4",
            "State Highway 400","State Highway 400 North","State Highway 400 South","State Highway 41",
            "State Highway 414","State Highway 415","State Highway 41A","State Highway 43","State Highway 430",
            "State Highway 434","State Highway 436","State Highway 441","State Highway 448","State Highway 45",
            "State Highway 450","State Highway 46","State Highway 465","State Highway 47 W","State Highway 481",
            "State Highway 49","State Highway 5","State Highway 509","State Highway 51","State Highway 52",
            "State Highway 53","State Highway 531","State Highway 537","State Highway 55","State Highway 57 (Chaco Loop Road)",
            "State Highway 58","State Highway 581","State Highway 59","State Highway 590","State Highway 5S",
            "State Highway 60","State Highway 602","State Highway 61","State Highway 62","State Highway 64",
            "State Highway 64B","State Highway 65","State Highway 66","State Highway 67","State Highway 690",
            "State Highway 695","State Highway 7","State Highway 70","State Highway 71","State Highway 72",
            "State Highway 73","State Highway 74","State Highway 75","State Highway 77","State Highway 78",
            "State Highway 789","State Highway 79","State Highway 790","State Highway 793","State Highway 8",
            "State Highway 80","State Highway 806","State Highway 812","State Highway 82","State Highway 83",
            "State Highway 839","State Highway 84","State Highway 844","State Highway 86","State Highway 87",
            "State Highway 88","State Highway 89","State Highway 8A","State Highway 9","State Highway 90",
            "State Highway 905","State Highway 92","State Highway 922","State Highway 94","State Highway 95",
            "State Highway 96","State Highway 962J","State Highway 96A","State Highway 97","State Highway 971",
            "State Highway 98","State Highway 99","State Highway 99; CA 99","State Highway 9D",
            "State Highway CC","State Highway D","State Highway KK","State Highway Loop 375","State Highway N",
            "State Highway P","State Highway V","State Highway Z","State Hill Rd","State Hwy 10 Business Route",
            "State Hwy 18 Spur","State Line Dr","State Line Rd","State Line Road","State Loop 375",
            "State Loop 504","State Lot Rd","State Park Ave","State Park Rd","State Park Road","State Pk Rd",
            "State Rd","State Rd 206","State Road","State Road 3003","State Road 502","State Road 75",
            "State Road East","State Road T","State Rock Rd","State Route 1","State Route 10","State Route 100",
            "State Route 101","State Route 1011","State Route 1017","State Route 101A","State Route 102",
            "State Route 103","State Route 1039","State Route 104","State Route 105","State Route 108",
            "State Route 109","State Route 11","State Route 110","State Route 111","State Route 113",
            "State Route 114","State Route 117","State Route 118","State Route 119","State Route 12",
            "State Route 120","State Route 123","State Route 124","State Route 126","State Route 128",
            "State Route 129","State Route 12A","State Route 13","State Route 131","State Route 132",
            "State Route 134","State Route 135","State Route 137","State Route 138","State Route 139",
            "State Route 14","State Route 140","State Route 1432","State Route 144","State Route 145",
            "State Route 146","State Route 147","State Route 14A","State Route 15","State Route 152",
            "State Route 152A","State Route 154","State Route 155","State Route 157","State Route 16",
            "State Route 160","State Route 161","State Route 162","State Route 165","State Route 166",
            "State Route 167","State Route 169","State Route 17","State Route 17 Northbound","State Route 171",
            "State Route 172","State Route 173","State Route 175","State Route 178","State Route 179",
            "State Route 18","State Route 181","State Route 183","State Route 185","State Route 187",
            "State Route 191","State Route 195","State Route 199","State Route 2","State Route 2009",
            "State Route 2010","State Route 2016","State Route 204","State Route 207","State Route 21",
            "State Route 215","State Route 219","State Route 22","State Route 220","State Route 221",
            "State Route 227","State Route 23","State Route 233","State Route 239","State Route 24",
            "State Route 244","State Route 248","State Route 25","State Route 253","State Route 258",
            "State Route 260","State Route 261","State Route 262","State Route 264","State Route 269",
            "State Route 27","State Route 271","State Route 277","State Route 278","State Route 279",
            "State Route 28","State Route 28 (Bypass)","State Route 288","State Route 29","State Route 299",
            "State Route 3","State Route 30","State Route 3001","State Route 3004","State Route 3005",
            "State Route 3007","State Route 302","State Route 3023","State Route 304","State Route 305",
            "State Route 31","State Route 31 N","State Route 32","State Route 325","State Route 328",
            "State Route 33","State Route 331","State Route 339","State Route 34","State Route 343",
            "State Route 344","State Route 346","State Route 349","State Route 35","State Route 356",
            "State Route 36","State Route 362","State Route 364","State Route 366","State Route 370",
            "State Route 374","State Route 377","State Route 38","State Route 386","State Route 39",
            "State Route 3A","State Route 3C","State Route 4","State Route 40","State Route 400","State Route 4002",
            "State Route 4015","State Route 402","State Route 408","State Route 41","State Route 419",
            "State Route 42","State Route 434","State Route 437","State Route 45","State Route 453",
            "State Route 46","State Route 47","State Route 48","State Route 49","State Route 5","State Route 50",
            "State Route 51","State Route 512","State Route 518","State Route 52","State Route 527",
            "State Route 53","State Route 530","State Route 54","State Route 540","State Route 547",
            "State Route 549","State Route 55","State Route 550","State Route 554","State Route 558",
            "State Route 566","State Route 576","State Route 58","State Route 590","State Route 60",
            "State Route 602","State Route 604","State Route 61","State Route 611","State Route 62",
            "State Route 620","State Route 621","State Route 63","State Route 632","State Route 65",
            "State Route 66","State Route 668","State Route 67","State Route 68","State Route 689",
            "State Route 69","State Route 7","State Route 71","State Route 715","State Route 72","State Route 73",
            "State Route 75","State Route 751","State Route 77","State Route 790","State Route 807",
            "State Route 81","State Route 82","State Route 83","State Route 85","State Route 872",
            "State Route 88","State Route 89","State Route 9","State Route 90","State Route 91","State Route 92",
            "State Route 93","State Route 94","State Route 958","State Route 96","State Route 99",
            "State Route F","State School at Industry Oatka","State Spur 233","State Spur 86","State St",
            "State Street","Stately Way","Staten Brake Rd","Staten Island Expressway","Statesboro Rd",
            "Statesir Pl","Statesman Square","Statford Ln","Statile Ct","Station Ashard Cutoff","Station Ave",
            "Station Dr","Station Hill Rd","Station Ln","Station Pky","Station Rd","Station Road","Station St",
            "Station Street","Statler Avenue","Staton Elementary Bus Drop","Statton Acres Rd","Statz Ct",
            "Staub Ln","Staudt Ct","Staughter Ln","Staunton Road","Stave Crescent","Stave Landing Rd",
            "Stave Mill Rd","Staverville Rd","Stavola Rd","Stawberry Ln","Stayman Ave","Staynor Crescent",
            "Steadman Loop","Steam Mill Rd","Steamboat Cove Ct","Steamboat East","Steamwells Rd","Stearman Dr",
            "Stearn St","Stearns Rd","Stearns Square","Stebbins Ave","Stebbins Dr","Stebbins St","Steckler St",
            "Stedman Street","Steel Rd","Steel Street","Steele Ave","Steele Bridge Rd","Steele Ct","Steele Ln",
            "Steele Rd","Steele St","Steeles Avenue","Steeles Avenue / Woodbine Avenue","Steeles Avenue East",
            "Steeles Avenue West","Steeles Line","Steelhead Blvd","Steelhead Cir","Steelman Ave","Steelmantown Rd",
            "Steely Ct","Steely Ridge Rd","Steendom Ln","Steep Hollow Ct","Steep Hollow Lane","Steep Ln",
            "Steepbank Crescent","Steephill Rd","Steeple Chase Ct","Steeple Chase Way","Steeple Ct",
            "Steeple View Dr","Steeplechase Ct","Steeplechase Dr","Steeplechase Drive","Steeplechase Ln",
            "Steering Ln","Steetham Ln","Stein Dr","Stein Rd","Stein St","Steinbech Pl","Steinber St","Steinberg Ave",
            "Steiner Rd","Steinfest Rd","Steinkrau Drive","Steinway Ct","Steinway St","Stelfox St","Stella Ave",
            "Stella Court","Stella Ct","Stella Dr","Stella Lake Rd","Stella St","Stella Street","Stellarator Rd",
            "Steller Court NW","Stellick Avenue","Stembridge Rd","Stemley Bridge Rd","Stemley Rd",
            "Stempek Ln","Stempert Rd","Stemrose Way","Stenbeck Place","Stennis St","Stephan Ave","Stephan Bridge Rd",
            "Stephanie Ave","Stephanie Dr","Stephanie Drive","Stephanie Jo Ln","Stephanie Ln","Stephanie Rd",
            "Stephanie St","Stephen Ave","Stephen Avenue","Stephen Dr","Stephen Drive","Stephen Park Road",
            "Stephen Pl","Stephen Street","Stephen Ter","Stephen Terrace","Stephens Ave","Stephens Canyon Rd",
            "Stephens Court","Stephens Dr","Stephens Park Rd","Stephens Rd","Stephens Ridge Rd","Stephens St",
            "Stephensburg Rd","Stephenson Ave","Stephenson Ct","Stephenson Point Road","Stephenson St",
            "Stepleton Dr","Steppe St","Steppingstone Court","Steprock Ct","Sterling Ave","Sterling Ct",
            "Sterling Dr","Sterling Hwy","Sterling Ln","Sterling Park","Sterling Pines Rd","Sterling Pky",
            "Sterling Pl","Sterling Road","Sterling St","Sterling Street","Sterling Ter","Stern Cir",
            "Stern Dr","Sternberg Rd","Sterns Rd","Stetner St","Stetser Ave","Stetson Avenue","Stetson Cir",
            "Stetson Ct","Stetson Ln","Stetson Pl","Stetson Rd","Stetson Shrine Lane","Stetson St","Stetson Street",
            "Stetson Way","Steuben Ave","Steuben Ct","Steuben Dr","Steuben Pl","Steuben St","Steubenville Pike Rd",
            "Steusser Lake Rd","Steve St","Steven Avenue","Steven Ct","Steven Street","Stevens Ave","Stevens Canyon Rd",
            "Stevens Circle Dr","Stevens Court","Stevens Creek Boulevard","Stevens Creek Nature Trail",
            "Stevens Ct","Stevens Dr","Stevens Dr NE","Stevens Hill Rd","Stevens Ln","Stevens Mine Rd",
            "Stevens Pass Rd","Stevens Pl","Stevens Rd","Stevens Road","Stevens St","Stevens Street",
            "Stevens Way","Stevenson Ave","Stevenson Blvd","Stevenson Boulevard","Stevenson Ct","Stevenson Path",
            "Stevenson Peak","Stevenson Pl","Stevenson Rd","Stevenson Road","Stevenson Road South",
            "Stevenson St","Stever Ave","Stever Ct","Steward Aly","Steward Rd","Stewards Ln","Stewart","Stewart Ave",
            "Stewart Ave SE","Stewart Boulevard","Stewart Ct","Stewart Dr","Stewart Drive","Stewart Lane",
            "Stewart Pl","Stewart Ranch Rd","Stewart Rd","Stewart Road","Stewart St","Stewart Street",
            "Stewart Way","Stickle Rd","Sticklebract Dr","Stickney Rd","Stidham Rd","Stiebe Rd","Stien Ln",
            "Stiers Rd","Stiffler Rd","Stiger St","Stiles Ct","Stiles Ct W","Stiles Pl","Stiles Rd","Stiles Terrace",
            "Still Breeze Way","Still Brook Rd","Still Harbor Ln","Still Hollow Rd","Still Moon Cres",
            "Still Pond Way","Still Rd","Still River Road","Still Water Rd","Stilles St","Stillewll Ave",
            "Stillman Ave","Stillman Rd","Stillman St","Stillmeadow Rd","Stillmeadow Road","Stillpond Ter",
            "Stillwater Ave NW","Stillwater Bridge Road","Stillwater Cir","Stillwater Ln","Stillwater Rd",
            "Stillwell Ave","Stillwell Cir","Stillwell Ct","Stillwell Rd","Stillwell St","Stiltner Ln",
            "Stilwell Rd","Stine Rd","Stinett Rd","Stinger St","Stingray","Stinkwater Well Rd","Stinson Crescent",
            "Stinson Lake Rd","Stinziano Street","Stirling Ct","Stirrup Ct","Stirup Ct","Stites Dr","Stivers Rd",
            "Stobbe Ln","Stobo Ln","Stocco Court","Stock Avenue","Stock Tank Rd","Stockbridge Court",
            "Stockbridge Dr","Stockbridge Ln","Stockbridge Rd","Stockbridge Road","Stockdale Ln","Stockdale Rd",
            "Stockdale Road","Stockell Ln","Stockholm Rd","Stockholm Road","Stockhorse Ln","Stocking St",
            "Stockman St","Stockport Rd","Stockton Ave","Stockton Ct","Stockton Dr","Stockton Hill Rd",
            "Stockton Ln","Stockton Pl","Stockton Rd","Stockton St","Stockton Street","Stockwell Mine Rd",
            "Stoddard Ave","Stoddard Place","Stoddard Rd","Stoddard Road","Stoddard St","Stoddard Street",
            "Stoddard Terrace","Stoddard Valley Rd","Stoffel Rd","Stoker Rd","Stokes Ave","Stokes Ct",
            "Stokes Farm Rd","Stokes Pl","Stokes Rd","Stokes Road","Stokes St","Stokes Way","Stokesbury St",
            "Stokley St","Stokum Ln","Stomper Way","Stone Aly","Stone Arch Rd","Stone Ave","Stone Brae",
            "Stone Bridge Rd","Stone Canyon Ct","Stone Canyon Trail","Stone Church Dr","Stone Church Rd",
            "Stone Cir","Stone Corral Creek","Stone Court Cir","Stone Creek Rd","Stone Ct","Stone Dr",
            "Stone Fence Cir","Stone Fence Rd","Stone Fence Road","Stone Gate Ct","Stone Gate Drive",
            "Stone Gate Pl","Stone Harbor Ave","Stone Harbor Ct","Stone Harbour Dr","Stone Haven Dr",
            "Stone Haven Way","Stone Hedge Drive","Stone Hill Drive","Stone Hill Rd","Stone House Ln",
            "Stone House Rd","Stone House Road","Stone Lake","Stone Ln","Stone Mason Drive","Stone Meadow Cir",
            "Stone Mill Dr","Stone Mountain Ln","Stone Oak Way","Stone Pl","Stone Quarry Rd","Stone Rd",
            "Stone Ridge Dr","Stone Ridge Ln","Stone Ridge Rd","Stone River Dr","Stone Road","Stone School Rd",
            "Stone St","Stone Street","Stone Street South","Stone Tower Dr","Stone Walk Ct","Stone Way",
            "Stonebriar Drive","Stonebridge Avenue","Stonebridge Ct","Stonebridge Dr","Stonebridge Dr SW",
            "Stonebridge Drive","Stonebridge Gate","Stonebridge Ln","Stonebridge Rd","Stonebridge Road",
            "Stonebrier Dr","Stonebrier Ln","Stonecliff Rd","Stonecraft Place","Stonecrest Ct","Stonecrop Dr",
            "Stonecutters Lane","Stonedale Placeway","Stonedge Way","Stonefield Ct","Stonegate Ct",
            "Stonegate Dr","Stonegate Pky","Stonegate Place","Stonegate Road","Stonegate Shores Dr",
            "Stonegate Way","Stoneham Dr","Stonehampton Court","Stonehaven Ct","Stonehaven Dr","Stonehaven Drive",
            "Stonehaven Way","Stoneheath Crescent","Stonehedge","Stonehedge Ct","Stonehenge Dr","Stonehenge Rd",
            "Stonehill Ln","Stonehill Rd","Stonehill Run","Stonehouse Ct","Stonehouse Ln","Stonehouse Rd",
            "Stonehurst Blvd","Stonehurst Dr","Stoneleigh Dr","Stoneleigh St","Stonemill Dr","Stoneport Rd",
            "Stoneridge Ln","Stoneridge Rd","Stones Falls Rd","Stones Run","Stonesifer Ct","Stonewall Canyon Rd",
            "Stonewall Dr","Stonewall St NE","Stonewood Ct","Stoney Bridge Rd","Stoney Brook Ln","Stoney Brook Rd",
            "Stoney Brooke Drive","Stoney Creek Rd","Stoney Point Dr","Stoney Point Rd","Stoney Point Road S",
            "Stoney Rd","Stoney Run Rd Addition","Stoneybrook Ct","Stoneybrook Road","Stoneycreek Dr",
            "Stoneykirk Cir","Stoneypoint Campground Rd","Stony Beach Road","Stony Brick Rd","Stony Brook Dr",
            "Stony Brook Ln","Stony Brook Rd","Stony Brook Road","Stony Brook State Park","Stony Creek Rd",
            "Stony Creek Trail Rd","Stony Fork Creek Rd","Stony Fork Rd","Stony Hill Ct","Stony Hill Dr",
            "Stony Hill Rd","Stony Ln","Stony Mill Ln","Stony Point Rd","Stony Rd","Stony River Ct","Stony Squabble Rd",
            "Stonybrook Ct","Stonybrook Dr","Stonybrook Pl","Stonybrook Rd","Stoops Ln","Stoopville Rd",
            "Store Rd","Storer Ct","Storey Ave","Storey Avenue","Storey Crescent","Storey Rd","Storica Drive",
            "Storig Ave","Storm Hill Dr","Storm Rd","Stormont Avenue","Stormount Avenue","Storms Drive",
            "Storms Island Rd","Stormy Ln","Stormy Point Rd","Stormy Way","Storrs Rd","Story Ave","Story Book Ln",
            "Story Ln","Story St","Story Street","Stouffville Road","Stough St","Stoughton Ave","Stoughton Pl",
            "Stour Ln","Stout Ct","Stouts Rd","Stoutt Dr","Stovall Florida Rd","Stover Rd","Stow Ave","Stow Ln",
            "Stow Road","Stowe Ave NW","Stowe Bay Rd","Stowe Ct","Stowe Hill Rd","Stowe Ln","Stowe Road No 1",
            "Stowe St","Stowell St","Stoy Ave","Stoyk Rd","Strabane Avenue","Strachan Avenue","Strafford St",
            "Straight Dr","Straight Run Rd","Straight St","Straits Road","Straitsmouth Way","Straitsville Rd",
            "Straitwood Ct","Stranburg Ave","Strandhill Road","Strang Rd","Strange Street","Strasbourg Ln",
            "Strasenburgh Dr","Stratcor Roads","Stratford Ave","Stratford Ct","Stratford Dr","Stratford Ln",
            "Stratford Pl","Stratford Rd","Stratford Road","Stratford Trl","Strathallan Drive","Strathburn Boulevard",
            "Strathcona","Strathcona Avenue","Strathcona Drive","Strathearn Avenue","Strathern Road",
            "Strathgowan Crescent","Strathmore Boulevard","Strathmore Pl","Strathroy Court","Stratton Court",
            "Stratton Dr","Stratton Drive","Stratton Pl","Straub Ln","Strauch Dr","Straughn","Strauss Ct",
            "Strauss Dr","Strauss St","Straw Berry","Strawberry Ave","Strawberry Cr Rd","Strawberry Hill Court",
            "Strawberry Hill Ct","Strawberry Hill Rd","Strawberry Landing","Strawberry Ln","Strawberry Ln NE",
            "Strawberry Ln SW","Strawberry Rd","Strawberry Roan Way","Strawberry Sq","Strawbridge Ct",
            "Strawflower Ln","Strawn Dr","Straws Point","Strawtown Rd","Stream Ct","Street Four","Street Lake Ln",
            "Street Rd","Streeter Pond Dr","Streeter Rd","Streeter St","Streetfarm Rd","Streets of Arnoldsburg",
            "Streety Rd","Strehle Ln","Strepy Ave","Strichen Cir","Stricker Avenue","Strickland Ave",
            "Strickland Blvd","Strickland Mine Ct","Stride Way","Stringer Rd","Stringer Road","Striper Cmn",
            "Striper Rd","Stripling Dr","Strobridge Hill","Strohan Street","Strohl Rd","Strolling Hills Rd",
            "Strong Bow","Strong Ct SE","Strong Dr","Strong Pl","Strong Rd","Strong St","Strong Street",
            "Strongbox Court","Strongs Pl","Stroud Dr","Stroud's Lane","Strouds Run Rd","Struble Hollow Rd",
            "Struyk Ave","Stryker Rd","Stuart Ave","Stuart Cir","Stuart Ct","Stuart Pl","Stuart Road","Stuart St",
            "Stuart Street","Stub Road","Stubble Brook Rd","Stubbs Street","Studdford Ct","Student Lane",
            "Studio Rd","Studio St","Stuhr Pl","Stula Ln","Stull Run Rd","Stulman Ave","Stults Ave","Stumm Pl",
            "Stump Ln","Stump Rd","Stumpfield Mountain Rd","Stumpy Rd","Sturbridge Dr","Sturbridge Dr E",
            "Sturbridge Dr W","Sturbridge Ln","Sturbridge Road","Sturdy Oak Ct","Sturgeon Dr","Sturgeon River Rd",
            "Sturgeon Road","Sturgill Ln","Sturms Pl","Sturr Dr","Sturtevant Road","Stutley Rd","Stutson St",
            "Stutz Dr NE","Stuyvesant Ave","Stuyvesant Ct","Stuyvesant Rd","Stuyvesant Walk","Styles Ct",
            "Styx Hill Rd","Su Lew Ave SW","Suavez Cir","Subic Ln","Substation Roads","Suburban Hills Dr",
            "Suburban Ln","Suburban Rd","Suburban Way","Suburbia Dr","Suburbia Ter","Subway Avenue","Successio Crescent",
            "Such St","Sucinto Ln","Sucker River Rd","Suckow Rd","Sudan Ave","Sudan Ln","Sudan Loop","Sudbury Ln",
            "Sudsbury Rd","Sue Ave","Sue Cir SE","Sueda Ranch Rd","Suez St","Suffex Ct","Suffield Street",
            "Suffolk Ct","Suffolk Ln","Suffolk Pl","Suffolk Road","Suffolk St","Suffolk Street","Suffolk Street Court",
            "Sugan Rd","Sugar Bush Hill Road","Sugar Creek Rd","Sugar Hill Rd","Sugar Hill Road","Sugar Ln",
            "Sugar Loaf Ln","Sugar Loaf Rd","Sugar Loaf Street","Sugar Loaf West","Sugar Maple Dr",
            "Sugar Maple Lane","Sugar Maple Rd","Sugar Oak Dr","Sugar Pine Ave","Sugar Pine Cir","Sugar Pine Ct",
            "Sugar Pine Dr","Sugar Pine Dr S","Sugar Pine Rd","Sugar Plum Ln","Sugar Rd","Sugar St","Sugar Tree Cir",
            "Sugarberry Ln","Sugarbush Court","Sugarbush Rd","Sugarbush Square","Sugarcane Ct","Sugarhouse Rd",
            "Sugarloaf Dr","Sugarloaf Street","Sugarloaf Trl","Sugarmills Cir","Sugarpine Ln","Sugarpine Rd",
            "Sugartree Rd","Suissevalle Ave","Suitor Rd","Sujeto Rd NW","Sukat Rd","Suksi Rd","Sulfrian Rd",
            "Sulgrave Crescent","Sulgrave Ln","Sulgrave Rd","Sulky Dr NE","Sulky Rd","Sulky Way","Sulligent Lake Rd",
            "Sullivan Ave","Sullivan Avenue","Sullivan Dr","Sullivan Drive","Sullivan Falls Rd","Sullivan Farm Dr",
            "Sullivan Ln","Sullivan Point","Sullivan Rd","Sullivan Road","Sullivan St","Sullivan Street",
            "Sullivan Unp","Sullivan Way","Sully Ct","Sulphide Road","Sulphur Spring Rd","Sulphur Spring Rd SE",
            "Sultana Avenue","Sultana St","Sultana Street","Sultze Ave","Sumac Ln","Sumac Rd","Sumac St",
            "Sumach Rd","Sumark Way","Sumbler Road","Sumerset Pky","Summer Ave","Summer Ave NE","Summer Avenue",
            "Summer Chase Rd","Summer Cir E","Summer Cir W","Summer Country Dr","Summer Creek Ct",
            "Summer Ct","Summer Dr","Summer Glen Dr","Summer Harvest Ave","Summer Hills Rd","Summer Homes Rd",
            "Summer Ln","Summer Meadow St","Summer Pl","Summer Ridge Dr","Summer Sands Ct","Summer Savory Ct",
            "Summer Set Cir","Summer Squash Way","Summer St","Summer Star Pl","Summer Storm Cir","Summer Street",
            "Summer Sun Way","Summer Wind Ct","Summer Xing","Summercrest Ln","Summerday Ct","Summerfield Ct",
            "Summerfield Dr","Summerfield Pl","Summerfield Rd","Summergreen Ln","Summerheights Dr",
            "Summerhill Ave","Summerhill Avenue","Summerhill Ct","Summerhill Ln","Summerlane St","Summerlin Pkwy",
            "Summerlin Pky","Summerlyn Dr","Summers Dr","Summers Eve Ln","Summers Rd","Summers Road",
            "Summerset Dr","Summerset Way","Summerside Ave","Summerside Drive","Summersville Dr NW",
            "Summersweet Tr","Summerville Rd","Summerwind Ave NE","Summerwood Cir","Summerwood St",
            "Summit","Summit Ascent","Summit Ave","Summit Avenue","Summit Church Rd","Summit Circle",
            "Summit Ct","Summit Dr","Summit Dr NW","Summit Drive Number 15","Summit Hill Dr","Summit Hills Dr",
            "Summit Hills Dr NE","Summit Hills Rd NE","Summit Level Rd","Summit Ln","Summit Oak Dr",
            "Summit Oaks","Summit Pl","Summit Point Dr","Summit Rd","Summit Rd NE","Summit Sq","Summit St",
            "Summit Stone Ave","Summit Street","Summit Trl","Summit View Dr","Summitt Chase Dr NW",
            "Summitt Rd","Sumner Ave","Sumner Avenue","Sumner Ct","Sumner Dr","Sumner Rd","Sumner St","Sumner Street",
            "Sumner-Miss 321 Rd","Sumners Ln","Sumption Ct","Sumter St","Sun Ave","Sun Avenue","Sun Beau Ct",
            "Sun Bolt Way","Sun Cliffs St","Sun Ct","Sun Ln","Sun Mountain Blvd","Sun Pine Dr","Sun Pl",
            "Sun Ray Rd","Sun Rd","Sun River Ct","Sun Row Drive","Sun Shadow Ave","Sun Sprite Way","Sun Stone Ct",
            "Sun Swept Dr","Sun Swept Way","Sun Ter","Sun Trail Ln","Sun Valley","Sun Valley Dr","Sun Valley Rd",
            "Sun Via Dr","Sun West Ter","Sunapee","Sunapee St","Sunapee Valley Lower Rd","Sunbay Rd",
            "Sunbeam Rd","Sunberry Dr","Sunbonnet Ave","Sunbonnet Dr","Sunbow Ave","Sunburst Cir","Sunburst Ct",
            "Sunburst Dr","Sunburst Ln","Sunburst Square","Sunburst St","Sunbury Cir","Sunbury Dr","Suncook Ter",
            "Suncook Valley Hwy S","Suncook Valley Rd","Suncrest Ave","Suncrest Cir","Suncrest Cv",
            "Suncrest Dr","Suncrest Drive","Sundale Dr","Sundance Ct","Sundance Dr","Sundance Kid Rd",
            "Sundance Ln","Sundance Road","Sundance Shores St","Sundance St","Sundance Ter","Sundance Trl",
            "Sunday Rd","Sundberg Ave","Sunderland Ct","Sunderland Rd","Sunderland Road","Sundew Dr",
            "Sundew Ln","Sundial Bridge","Sundown Cir","Sundown Cv","Sundown Dr","Sundown Ln","Sundown Pass",
            "Sundown Rd","Sundown Trl","Sundrops Ct","Sunever Rd","Sunfair Rd","Sunfield Ave","Sunfield Rd",
            "Sunfield Way","Sunfish Ave SW","Sunfish Ct","Sunfish Rd","Sunflower","Sunflower Ave","Sunflower Cir",
            "Sunflower Ct","Sunflower Ct NW","Sunflower Dr","Sunflower Dr SW","Sunflower Ln","Sunflower Pl",
            "Sunflower Rd","Sunflower River Rd","Sunflower St","Sunglow Ave","Sunglow Ln","Sungrove Ln",
            "Sunken Trl","Sunkist Trl","Sunland","Sunland Ave","Sunlight Peak St","Sunlit Valley Dr",
            "Sunnidale Boulevard","Sunningdale Ave NE","Sunningdale Bend","Sunningdale Ct NE","Sunny Glen Ave",
            "Sunny Hill Ct","Sunny Hill Rd","Sunny Knoll Rd","Sunny Lane Rd","Sunny Ln","Sunny Meadow Ct",
            "Sunny Oak Ct","Sunny Oaks Ranch Rd","Sunny Plain Avenue","Sunny Ridge","Sunny Ridge Ln",
            "Sunny Sands Dr","Sunny Slope Ln","Sunny Springs St","Sunny View Rd","Sunny Vista","Sunny Vista Rd",
            "Sunny Way","Sunnybrae Blvd","Sunnybrook Cir N","Sunnybrook Ct","Sunnybrook Dr","Sunnybrook Ln",
            "Sunnybrook Rd","Sunnycrest Road","Sunnydale Ct","Sunnydale Dr","Sunnydale Drive","Sunnydale Rd",
            "Sunnyfield Ter","Sunnyfield Way","Sunnyhill Drive","Sunnyhills Ct","Sunnypoin Drive",
            "Sunnyside Ave","Sunnyside Avenue","Sunnyside Cir","Sunnyside Ct","Sunnyside Dr","Sunnyside Dr NW",
            "Sunnyside Ln","Sunnyside Rd","Sunnyside Street","Sunnyside Terrace","Sunnyslope","Sunnyslope Ave",
            "Sunnyslope Rd","Sunnyvale Dr","Sunnyview Dr SW","Sunnyview Street","Sunnywood Dr","Sunpark Ln",
            "Sunport Blvd","Sunport Blvd SE","Sunray Crest","Sunray Dr","Sunray Ln","Sunridge Ave","Sunridge Ct",
            "Sunridge Heights Parkway","Sunridge Rd","Sunridge St","Sunrise","Sunrise Ave","Sunrise Avenue",
            "Sunrise Bay Ave","Sunrise Blvd E","Sunrise Cir","Sunrise Cir N","Sunrise Court","Sunrise Cove Ave",
            "Sunrise Crescent","Sunrise Ct","Sunrise Dr","Sunrise Drive","Sunrise Lane","Sunrise Ln",
            "Sunrise Mountain Rd","Sunrise Park St","Sunrise Pl","Sunrise Rd","Sunrise Ridge","Sunrise St",
            "Sunrise Ter","Sunrise Trl","Sunrise Vista Way","Sunrise Way","Sunrose","Sunset W","Sunset Ave",
            "Sunset Ave E","Sunset Avenue","Sunset Bay","Sunset Bay Dr","Sunset Bay Rd","Sunset Beach Rd",
            "Sunset Blvd","Sunset Boulevard","Sunset Cir","Sunset Cir NW","Sunset Cove Rd","Sunset Ct",
            "Sunset Cv","Sunset Dr","Sunset Dr 1","Sunset Dr E","Sunset Dr SW","Sunset Drive","Sunset Gardens Rd SW",
            "Sunset Harbor Ct","Sunset Hill Rd","Sunset Hills Rd","Sunset Hts","Sunset Inn Limecrest Rd",
            "Sunset Ln","Sunset Meadows Ln","Sunset Mesa","Sunset Mountain Way","Sunset Overlook",
            "Sunset Path","Sunset Peak Mtwy","Sunset Pl","Sunset Plaza Ter","Sunset Point Pl","Sunset Ranch Dr",
            "Sunset Rd","Sunset Ridge","Sunset Ridge Ct","Sunset Ridge Dr","Sunset Ridge Rd","Sunset Ridge Truck Trail",
            "Sunset Road","Sunset Rock","Sunset Rock Rd","Sunset St","Sunset Street","Sunset Ter","Sunset Trl",
            "Sunset Valley Drive","Sunset Valley Mobile Home Park","Sunset View Rd","Sunset Villa Dr",
            "Sunset Vista Ave","Sunshine Ave","Sunshine Ct","Sunshine Dr","Sunshine Ln","Sunshine Mountain Rd",
            "Sunshine Pl","Sunshine Rd","Sunshine Ter","Sunshine Ter SE","Sunshine Trail Rd","Sunshine Village Drive",
            "Sunshine Way","Sunshines Pl","Sunside Ave","Sunspot Highway","Sunstone Ct","Sunstone Ter",
            "Sunsweet Ln","Suntru St","Sunvalley Cv","Sunvalley Dr","Sunview Dr","Sunward Dr SW","Sunwind Ave",
            "Sunwood Ln","Suny Agric Colonel","Suny Entrance","Supai Dr","Supan Rd","Superior Ave","Superior Ct",
            "Superior St","Superstition Dr SE","Superstition Springs Ctr","Support Ct","Supreme Ct",
            "Surf Ave","Surf Breaker St","Surf Ct","Surf Dr","Surf Rd","Surf Spray Cir","Surfcove Cir","Surfside Road",
            "Surfsound Ct","Surfwood","Surfwood Dr","Surfwood Ln","Surgeons Dr","Surim Ct","Surlingham Ct",
            "Surmay Ave SW","Surprise Ln","Surprise St","Surrey Cir","Surrey Court","Surrey Ct","Surrey Dr",
            "Surrey Hill Ln","Surrey Hills Ct","Surrey Lane","Surrey Ln","Surrey Pl","Surrey Rd","Surrey St",
            "Surry Lane","Survey Circle","Susan Ave","Susan Court","Susan Ct","Susan Dr","Susan Drive","Susan Lee Ln",
            "Susan Ln","Susan Pl","Susan Rd","Susan St","Susan Way","Susie Ln","Susitna River-Mac Laren River Trl",
            "Suskin Pl","Susquehanna Ave","Susquehanna Rd","Susquehanock Trl","Susquehenna Ln","Sussex Ave",
            "Sussex Avenue","Sussex Cir","Sussex Ct","Sussex Ct NE","Sussex Highway","Sussex Pl","Sussex Rd",
            "Sussex St","Sussex Street","Sussex Street N","Sussex Street S","Sussex Way","Sutcliffe Hwy",
            "Sutherlan Place","Sutherlan Way","Sutherland Ave","Sutherland Avenue","Sutherland Road",
            "Sutherland Trail","Sutliff Ave","Sutliff Hill Rd","Sutphen Rd","Sutphin Rd","Sutro Ave",
            "Sutter Ave","Sutter Cir","Sutter Creek Ranchos Rd","Sutter Creek Rd","Sutter Creek Volcano Rd",
            "Sutter Pl","Sutter St","Sutter Way","Sutters Fort St","Sutters Mill Rd","Suttles Rd","Sutton",
            "Sutton Ave","Sutton Avenue","Sutton Ct","Sutton Dr","Sutton Drive","Sutton Ln","Sutton Pl",
            "Sutton Rd","Sutton Street","Sutton Way","Suwanee Dr","Suwanee St","Suydam Rd","Suydam St","Suydam Street",
            "Suzanne Ave","Suzanne Dr","Suzanne Ln SE","Suzanne Way","Suzette Ave","Suzi Way","Suzuki Ct",
            "Suzy Street","Swadly Way","Swagger Creek Rd","Swain Ave","Swain Ct","Swain Pl","Swain Rd","Swain St",
            "Swaledale Dr","Swall Rd","Swallow Court","Swallow Dr","Swallow Trl","Swallows Ln","Swallowtail Road",
            "Swamp Lakes Rd","Swamp Rd","Swamp Road","Swan Avenue","Swan Cir","Swan Ct","Swan Dr","Swan Drive",
            "Swan Hollow Rd","Swan Lake Rd","Swan Ln","Swan Park Road","Swan Pl","Swan Pointe Dr","Swan Pointe Rd",
            "Swan Rd","Swan Road","Swan St","Swan Street","Swanage Dr","Swanbrook St","Swanee Ln","Swangate Way",
            "Swanka Blvd","Swann Bridge Rd","Swann Dr","Swans Chance Ave","Swans Way","Swansea Rd","Swanson Dr",
            "Swanson Way","Swanton Rd","Swanwick Avenue","Swart Hollow Rd","Swarthmorewood Ln","Swartwood Ave",
            "Swartwood Rd","Swartz Rd","Swartz Trl","Swasey Street","Swath Pl","Swayze Drive","Swayze St",
            "Swearengin Rd","Sweatt Ln","Sweatt St","Swede Hill Rd","Swede Rd","Sweden Hill Rd","Swedesboro Rd",
            "Sweeney Dr","Sweeney Rd","Sweeney St","Sweeny Rd","Sweet Acres Dr","Sweet Basil Dr","Sweet Bay",
            "Sweet Briar Ct","Sweet Briar Pl","Sweet Briar Rd","Sweet Gum Cir","Sweet Gum Dr","Sweet Gum Loop",
            "Sweet Hill Rd","Sweet Leilani Ave","Sweet Ln","Sweet Maple Way","Sweet Meadow Dr","Sweet Pond Rd",
            "Sweet Rd","Sweet Springs St","Sweet Valley Rd","Sweetbell Ct","Sweetbriar Lane","Sweetbriar St",
            "Sweetbrier Ave","Sweetbrook Rd","Sweetfern Ln","Sweetheart City Rd N","Sweeting St","Sweetland Rd",
            "Sweetpea Rd","Sweetriver Boulevard","Sweets Point Rd","Sweetser Terrace","Sweetwater Dr",
            "Sweetwater Pl","Sweetwater St","Sweetwater Way","Sweetway Ct","Swenson Ct","Swenson Dr",
            "Swenson Street","Swider Dr","Swiehart Ln","Swift Ave","Swift Cir","Swift Ct","Swift Rap Road",
            "Swift Rd","Swift St","Swiftwater Dr","Swiftwater Ln","Swigert Ct","Swilley Rd","Swinburne St",
            "Swingle Ave","Swingle Canyon Rd","Swink Rd","Swinnerton St","Swiss Garden Rd","Swiss Hill Rd N",
            "Swiss Ranch Rd","Swiss Rd","Swiss St","Switchback Trail","Switzer Hill Rd","Sword Street",
            "Swordfish Drive","Sybaris St","Sybil Ct","Sycamore","Sycamore Ave","Sycamore Ave SE","Sycamore Avenue",
            "Sycamore Court","Sycamore Ct","Sycamore Dr","Sycamore Ln","Sycamore Mills Rd","Sycamore Path",
            "Sycamore Pl","Sycamore Rd","Sycamore Springs Cir","Sycamore St","Sycamore Trl","Sycamore Valley Dr",
            "Sycamore Way","Sycene Ct","Sycuan Way","Sydel Court","Sydenham Mill Street","Sydenham Road",
            "Sydenham Street","Sydney Ave","Sydney Ct","Sydney Ln","Sydnor Ave","Sye Ali Rd","Sykes Gap",
            "Sykes Rd","Sykes St","Sylacauga Fayetteville Hwy","Sylamore Rd","Syler Ct","Sylmar Ave",
            "Sylvamdur Ave","Sylvan Ave","Sylvan Cir","Sylvan Crescent","Sylvan Ct","Sylvan Ct NE","Sylvan Dr",
            "Sylvan Gl Drive","Sylvan Lake Pl","Sylvan Lake Rd","Sylvan Ln","Sylvan Oak Way","Sylvan Pl",
            "Sylvan Pl W","Sylvan Rd","Sylvan Shore Rd","Sylvan St","Sylvan Street","Sylvan Ter","Sylvan Valley Estates",
            "Sylvan Valleyway","Sylvan Way","Sylvania Ave","Sylvania Pl","Sylvania Way","Sylvanus Ct",
            "Sylvester Drive","Sylvester Rd","Sylvester Road","Sylvester St","Sylvia Cir","Sylvia Court",
            "Sylvia Ln","Sylvia St","Sylvie Ln","Symes Pond Rd","Symes Road","Symington Pl","Symmes Creek Rd",
            "Symmes Crk Rd","Symphony Cir","Symphony Court","Symphony St","Syndor Ave","Synergy Dr","Synott Pl",
            "Syracuse Ct","Syrah Ct","Syretta St","Syrian Hill Rd","Syrithas Way","Szedga Rd","Szymoniak Hwy",
            "T 200","T 271","T 422","T Arnold","T Ct","T J Allen Ln","T J Ln","T Jefferson Ave","T St","T St U St Aly",
            "T-1 Ln","T-130","T-141","T-333","T-339","T-358","T-466","T-48","T-91","T-Bird Ln","T1137","T121","T137","T1445",
            "T301","T304","T310","T311","T314","T339","T351","T361","T369","T370","T380","T387","T396","T398","T412","T414","T418","T429",
            "T436","T440","T441","T442","T451","T454","T457","T467","T468","T482","T515","T538","T559","T566","T567","T570","T575","T577",
            "T580","T596","T609","T612","T621","T623","T63","T655","T66","T662","T714","T83","T846","T933","Tabacco Rd","Tabard Gate",
            "Taber Pl","Taber St","Tabernacle Chatsworth Rd","Tabernacle Rd","Tabernacle Road","Tabitha Ave",
            "Tabitha Plaskette Road","Table Bluff Rd","Table Mountain Rd","Table Mtn Rd","Tablito Rd",
            "Taboose Creek Rd","Tabor Rd","Tabor St","Tabuenca","Tacana St","Tacc Trail","Tachi Dr","Tachick Ln",
            "Tackberry Road","Tackett Mountain Rd","Tackle Box Ct","Tacoma Ave","Tacoma Dr","Tacoma Narrows St",
            "Tacoma St","Tacoma Street","Tacomic Dr","Tacon St","Taconic Trail","Tadcaster Place","Tadin Ln",
            "Tadpole Rd","Tafoni Trail","Taft Ave","Taft Bay Dr","Taft Ct","Taft Hill Road","Taft Ln","Taft Place",
            "Taft Pointe","Taft Rd","Taft St","Taft Street","Taggart Rd","Tahachapi Ave","Tahiti St NE",
            "Tahoe Cir","Tahoe Ct","Tahoe Park Ave","Tahoe Rd","Tahoe Rim Trail","Tahoe Ski Bowl Way",
            "Tahoe Woods Blvd","Tai Ln","Tailrace Ln","Tainter Court","Taipei Dr","Takamara Rd","Takamine Rd",
            "Takoma St","Taladro Cir","Talavera Dr","Talbot Ave","Talbot Cir","Talbot Ct","Talbot Dr","Talbot Pl",
            "Talbot Rd","Talbot Way","Talbott","Talcott Ave","Talcott Rd","Talcott St","Talina Court","Tall Grass Trail",
            "Tall Meadow Ct","Tall Oak Ln","Tall Oak Rd","Tall Oaks Dr","Tall Oaks Ln","Tall Pine Ln",
            "Tall Pine Road","Tall Pine Trl","Tall Pine Way","Tall Pines Dr","Tall Timber Cv","Tall Timbers Dr",
            "Tall Tree Drive","Tall View S","Talladega Ct","Talladega Downs","Talladega St SE","Tallahatchie Ave",
            "Tallahatta Springs Rd","Tallant Rd","Tallapoosa St","Tallen Dr","Tallent Ave","Talley Ave",
            "Talley Pl","Talley St","Tallmadge Ave","Tallman Pl","Tallman St","Tallman Street","Tallwood Ct",
            "Tallwood Dr","Tallwood Ln","Tallwood Road","Tally Ho Ct","Tally Lane","Talmadge Rd","Talmage Ave",
            "Talon Court","Talwood Drive","Tamagnini Ct","Tamal Plz","Tamany Ct","Tamar Ct","Tamara Ct",
            "Tamara Dr","Tamara St","Tamarac Ave","Tamarac Dr","Tamarac Lane","Tamarac Ln","Tamarac Street",
            "Tamarack","Tamarack Cir NE","Tamarack Ct","Tamarack Dr","Tamarack Drive","Tamarack Lane",
            "Tamarack Ln","Tamarack Rd","Tamarack St","Tamarack Trail","Tamarack Trl","Tamarack Way",
            "Tamarind Ave","Tamarind Way","Tamarisk Ave","Tamarisk Ct","Tamarisk Ravine Ct","Tamarisk Way",
            "Tamarron Dr","Tamayo Dr","Tamblin Rd","Tambling Lake Ln","Tambour Way","Tamer Lane","Tamerind St",
            "Tamerisk Ct","Tamiami Dr","Tammany Park","Tammi Ct","Tamminen Rd","Tammy Ave","Tammy Little Dr",
            "Tammy Ln","Tammy's Way","Tampa Ave","Tampa Rd","Tampa Road","Tampa St","Tampa Ter","Tampico Court",
            "Tampico Rd","Tampico Road","Tampion Ave","Tamryn Blvd","Tamworth Pl","Tamworth Road","Tamyran Rd",
            "Tan Oak Way","Tanager Avenue","Tanager Circle","Tanager Dr","Tanager Way","Tanana-Allakaket Winter Trl",
            "Tanbark Ct","Tanbark Ln","Tandler Ave","Tandridge Crescent","Tanera Crescent","Tanganyka Ct",
            "Tangen Street","Tangerine Ct","Tangle Briarway","Tangleberry Cv","Tangled Spur Ct","Tanglewood Ave",
            "Tanglewood Cir","Tanglewood Ct","Tanglewood Dr","Tanglewood Hollow Road","Tanglewood Ln",
            "Tanglewood Road","Tanglewood Trail","Tanglewood Trl","Tango Ct","Tania Ct","Tanjo Court",
            "Tank Farm Rd","Tank Farm Road","Tank Ln","Tank Xing","Tanker Rd","Tannda St","Tannehill Lease Rd",
            "Tannenewe Street","Tanner Cir","Tanner Dr","Tanner Ln","Tanner Rd","Tanners Brook Rd","Tannery Creek Crescent",
            "Tannery Ct","Tannery Hill","Tannery Ln","Tannery Road","Tannery Run Cir","Tanneyanns Ln",
            "Tanneyhill Dr","Tannybrooke Condos","Tanque Verde Ridge Trail","Tansboro Rd","Tansey Dr",
            "Tansy Circle","Tanto Ct","Tanton Rd","Tanwood Mobile Home Park","Tanya Drive","Tanya Ln",
            "Tanzer Court","Taos","Taos County Rd Cb-115","Taos County Road Cb-115","Taos Ct","Taos Ln",
            "Taos Meadows Dr NE","Taos Rd","Taos St","Tapia Canyon Rd","Tapir Ct","Tapley 1/4 Line","Tapo Canyon Rd",
            "Tapoop Ave","Tapp Rd","Tappan Ave","Tappan Rd","Tappan Street","Tapper Trl","Tapscott Rd","Tapscott Road",
            "Tar Rd","Tara Blvd","Tara Cir","Tara Common","Tara Dr","Tara Drive","Tara Ln","Tara Rd","Tara Road",
            "Tara St","Taramina Court","Tarango St","Tarantella Ln","Tarawild Ct","Tarbell Rd","Tarbert Road",
            "Tarbox Ln","Tarbutt Street","Targosh Rd","Targum Rd","Tarkiln Rd","Tarkington Ct","Tarman Dr",
            "Tarpley","Tarpon Ave","Tarragon Ct","Tarrs Lane West","Tarryton Ave","Tarsus Crescent","Tartan Cir",
            "Tartan Rd","Tartt Ave","Tasha Court","Tasha Dr","Tashmoo Drive","Tasimu Ct","Tasker Ln","Tasley Ct",
            "Tasman Bay","Tasmania Ct","Tate Ave","Tate Creek Rd","Tate Rd","Taterboro Rd","Tatman Street",
            "Tatmans Rd SE","Tatnall Street","Tatonka Dr","Tatra Drive","Tattersall Pl","Tattinger Avenue",
            "Tatum Rd","Tau Rd","Tau St","Taubert Avenue","Taunton Rd","Taunton Road","Tauras Ct","Taurus Dr",
            "Tausend St","Tauton Blvd","Taves Ave","Tavistock Ct","Tavistock Road","Tawa Ct","Tawes Trail",
            "Tawny Ln","Tawny Rd","Tawnya Cir","Tawsee Dr","Taxi Rd","Taxilane A","Taylor Ave","Taylor Ave N",
            "Taylor Canyon Rd","Taylor Cir","Taylor Court","Taylor Ct","Taylor Dr","Taylor Hicks Dr",
            "Taylor Hill Dr","Taylor Hill Rd","Taylor Hill Road","Taylor Hill Road Branch","Taylor Lane",
            "Taylor Line","Taylor Ln","Taylor Mills Drive N","Taylor Mills Drive S","Taylor Pl","Taylor Ranch Dr NW",
            "Taylor Rd","Taylor Ridge Rd","Taylor Road","Taylor St","Taylor Street","Taylor Trl","Taylor Way",
            "Taylor-Kidd Boulevard","Taylors Aly","Taylors Ferry Rd","Taylors Mill Rd","Taylorwood Avenue",
            "Tays St","Taysham Crescent","Tayview Drive","Taywood St","Tazewell Ct","Tea Party Cir","Tea Rose St",
            "Tea Tree Ct","Teaberry Cir","Teaberry Ct","Teaberry Ln","Teabury Ln","Teachers St","Teaderman Rd",
            "Teague Hightop Rd","Teague Hill Ln","Teak Hollow Ct","Teak Ln","Teakwood Avenue","Teakwood Dr",
            "Teakwood Drive","Teakwood Gate","Teakwood Rd","Teakwood St","Teakwood St NE","Teal","Teal Ave",
            "Teal Ct","Teal Dr","Teal Rd","Teal Trail","Teal Trl","Teal Way","Teancum Ct","Teaneck Rd","Teasdale Pl",
            "Teatree Ct","Tecado Ter","Tecate Cypress Tr","Tech Center Ct","Tech Center Dr","Techno Cv",
            "Technology Dr","Technology Way","Tecolote Trl","Tecopa Rd","Tecumseh Avenue","Tecumseh Drive",
            "Tecumseh Park Drive","Tecumseh Pl","Tecumseh St","Tecumseth Crescent","Tecumseth Street",
            "Ted Kennedy Way","Ted Kipf Rd","Ted Pl","Ted Williams Pky","Tedder Street","Teddy Bear Ln",
            "Teddy Ln","Teddy Rd","Teddy St","Teddy White Rd","Tedesco Circle","Tedford Lane","Tedford Way",
            "Tedoc Rd","Tee Lake Rd","Tee Lake Woods Rd","Tee Pee Ln","Tee's Lane; County 26 Road",
            "Teen Dr","Teens Run Rd","Teesdale Place","Teeside Court","Teeswater Road","Tefft Road","Tehama Dam Dr",
            "Tehama St","Tehama Street","Tejon St","Tekening Dr","Telecom Road","Telefair Way","Telegraph Avenue",
            "Telegraph Canyon","Telegraph Creek Rd","Telegraph Hill Ave","Telegraph Mine Rd","Telegraph Rd",
            "Telegraph Road","Telephone Rd","Telephone Road","Teleport Dr","Television Road","Telfair Ave",
            "Telfair Rd","Telfer Ln","Telford Drive","Telford St","Telic Run Rd","Tell Pl","Teller Ln","Tellidora Trl",
            "Tellier Rd","Telon Ct","Temecula Ct","Temelpa Trail","Temi Rd","Tempe Ct","Temperanc Street",
            "Temperance Dr","Temperance Hill Rd","Temperance House Rd","Temperate Ct","Tempest Cir",
            "Tempiute Mine Rd","Templar Dr","Temple Ave","Temple Bar Back Rd","Temple Bar Crescent",
            "Temple Cir","Temple Ct","Temple Dr","Temple Hill Rd","Temple Lane","Temple Ln","Temple Pl",
            "Temple St","Temple Street","Temple-West Crescent","Templeton Way","Templo Way","Ten Acre Rd",
            "Ten Eych Maine Rd","Ten Eyck St","Ten Eyck Street","Ten Mile Brook Rd","Ten Mile River Rd",
            "Ten Oaks Way","Ten Rod Rd","Tenabo Way","Tenaja Truck Trail","Tenakill Dr","Tenakill Pky",
            "Tenbury Ln","Tenby Street","Tenda Dr","Tenderfoot Ct","Tendring Rd","Tenipite Way","Tenmile Cutoff Rd",
            "Tennant Ln","Tennent St","Tennessee Acres Dr","Tennessee Ave","Tennessee Pl SE","Tennessee St",
            "Tennessee Valley Rd","Tennessee Valley Trail","Tenney Mountain","Tenneyson","Tennis Court",
            "Tennis Court Ln","Tennis Ct","Tennis Ln","Tenny","Tennyson Ave","Tennyson Avenue","Tennyson Dr",
            "Tennyson Street","Tenorite Ct","Tensley Ln","Tenth Line West","Tenth Road E","Tenth Street",
            "Teoc Rd","Teodora Pl","Tepi Ln","Ter Br","Tercel Dr","Tercero Rd","Tere Ct","Terence Dr","Teresa",
            "Teresa Dr","Teresa Ln","Teresa Pl","Teresa St","Teresa Way","Teresian Way","Teresina Court NW",
            "Terhune Ct","Term Terrace","Terminal Blvd","Terminal Dock Rd","Terminal Dr S","Terminal Place",
            "Termination Ct","Termoli St","Tern Ct","Tern St","Ternbury Sq","Terner Way","Terness Ave","Ternie Ln",
            "Terns Landing Rd","Terra Cotta Pl","Terra Cotta Rd","Terra Cv","Terra Vista Ct","Terrace Ave",
            "Terrace Avenue","Terrace Ct","Terrace Dorms Dr","Terrace Dr","Terrace Drive","Terrace Hills Dr",
            "Terrace Lane","Terrace Ln","Terrace Loop","Terrace Park Dr","Terrace Pky","Terrace Pl","Terrace Rd",
            "Terrace St","Terrace View Ct","Terrace Way","Terracima","Terracina St","Terracita Way","Terrance Ct",
            "Terrano Ln","Terrapin Creek Rd W","Terrapin Ln","Terraview Boulevard","Terraview Heights Drive",
            "Terrazzo Ave","Terrazzo Dr","Terre Vista Dr","Terrell Rd","Terrence Ct","Terrence Ter","Terri Ann Ct",
            "Terri Ct","Terrie Ct","Terrill Ave","Terrior Dr","Terry Ave","Terry Cir","Terry Court","Terry Dr",
            "Terry Dr SE","Terry Ln","Terry Lou Avenue","Terry Mill Rd","Terry Rd","Terry St","Terry Street",
            "Terry Ter","Terryhill Crescent","Terrylynn Dr","Tesla Crescent","Tesota Way","Tess Dr","Tessmer Rd",
            "Testa St","Testerman Way","Teston Boulevard","Teston Road","Tetbury Crescent","Teton Hills St",
            "Teton Pl","Tetotom Park Way","Tewa Ct","Tewas Rd SE","Tewsbury Dr","Texas Ave","Texas Canyon Rd",
            "Texas Ct","Texas Dr","Texas Hill Rd","Texas Rd","Texas Road","Texas St","Texas Tech Ag Farm Drvw",
            "Th 39","Thacher Court","Thacher St","Thackeray Ct","Thackeray Road","Thagard Way","Thahir Street",
            "Thai Cv","Thames Blvd","Thames Court","Thames Way","Thanet Rd","Tharptown Spring Rd","Thatch Ave",
            "Thatcher Ave","Thatcher Rd","Thatcher Street","Thatchwood Ct","Thatchwood Dr","Thatford Ave",
            "Thayer Ln","Thayer Rd","Thayer Road","Thayer Street","Thayne Rd","The Arena St","The Banks",
            "The Beate Lane","The Blvd","The Bog Rd","The Boom Rd","The Bridle Walk","The Buckley Way",
            "The Chase","The Cir","The Collegeway","The Crags","The Credit Woodlands","The Cut","The Donway East",
            "The Donway West","The Dr","The East Mall","The Embarcadero","The Enclosure","The Esplanade N",
            "The Fairways","The Fell Sway","The Forks Rd","The Glade","The Glen Road","The Green","The Kingsway",
            "The Knob Rd","The Knoll","The Laurels","The Lenape Trl","The Ln","The Mall","The Maste N","The Meadows",
            "The Old Rd","The Oval","The Parkway","The Pky","The Plains Rd","The Plaza","The Plz","The Pond Road",
            "The Prado St","The Promenade","The Queensway","The Queensway S","The Rand","The Strand",
            "The Strip","The Toledo","The Trl","The Trl N","The Village Blvd","The West Mall","The Westway",
            "Theater 16.8 Dr","Theatre Dr","Theatre St","Theim Ave","Theiner Trl","Theis Ln","Thelen Rd",
            "Thelma Avenue","Thelma Ct","Thelma Dr","Thelma St","Thenia Ln","Theo Way","Theodore","Theodore Place",
            "Theodore Roosevelt Dr","Theodore St","Theodore Street","Theresa Dr","Theresa Ln","Theresa Springs Rd",
            "Therriault Hill","Thessen Aly","Theta Ct","Theta Dr","Theurer Park","Theus Cir","Thicket Ct",
            "Thicketwood Boulevard","Thickson Road N","Thiel Road","Thiells Rd","Thiem Ave","Thiesen Rd",
            "Thilk Dr","Thimble Berryway","Thinleaf Ln","Third Avenue","Third Hill Rd","Third Lane","Third Line Dummer Road N",
            "Third Louth Avenue","Third Road","Third Street","Third Street South","Thirteenth Street",
            "Thirtieth Street","Thirty First Street","Thirty Five Canyon Rd","Thirza Pl","This Is It Ln",
            "Thistle Ave","Thistle Berry Ct","Thistle Creek Rd","Thistle Down","Thistle Down Boulevard",
            "Thistle Hill Rd","Thistle Passway","Thistle Pl","Thistle Pond Dr","Thistle Road","Thistle St",
            "Thistle Way","Thistlewood Dr","Thistlewood Rd","Thollen St","Thomas Ave","Thomas B Landers Road",
            "Thomas Blvd","Thomas Circle","Thomas Clapp Road","Thomas Ct","Thomas Dr","Thomas Elgie Drive",
            "Thomas L Pky","Thomas Ln","Thomas Loop","Thomas Loop Rd","Thomas McKean Building","Thomas Mill Rd",
            "Thomas Mountain Rd","Thomas Pl","Thomas Pl NE","Thomas Rd","Thomas Road","Thomas St","Thomas Street",
            "Thomas Taylor Dr","Thomas Ter","Thomasville Ct","Thompkins Dr","Thompson","Thompson Ave",
            "Thompson Dr","Thompson Drive","Thompson Falls Dr","Thompson Hill Rd","Thompson Ln","Thompson Park",
            "Thompson Pl","Thompson Private Dr","Thompson Quarry Dr","Thompson Rd","Thompson Rd S",
            "Thompson Ridge","Thompson Road","Thompson St","Thompson Station Rd","Thompson Street",
            "Thompson Way","Thompsons Dr","Thompsonville Rd","Thomsen Cir","Thomson Ave","Thomson Road",
            "Thomson Street","Thona St","Thorah Concession 2 Road","Thorah Concession 4 Road",
            "Thorah Concession 5 Road","Thorah Concession 6B Road","Thorah Park Boulevard",
            "Thoreao Dr","Thoreau Ct","Thoreau Drive","Thoreau Way","Thoreson Ct","Thorington Ct N","Thorn Ave",
            "Thorn Hedge St","Thorn Hill Estates","Thorn Lodge Drive","Thorn Pl","Thorn Ridge Ln",
            "Thorn St","Thorn Tree Dr","Thorn Tree Rd","Thorn Way","Thornapple","Thornapple Rd","Thornberry Summit Rd",
            "Thornbrook Pl","Thornbury Ln","Thornchester Ct","Thorncliffe Park Drive","Thorndale Pl",
            "Thorndale Ter","Thornden Park Dr","Thorndike Pond Rd","Thorndike Street","Thorndyke Street",
            "Thorne Junction","Thorne Pl","Thorne Rd","Thorne St","Thornell Place","Thorner St","Thornham Cir NW",
            "Thornhill","Thornhill Avenue","Thornhill Crescent","Thornhill Dr","Thornhill Rd","Thornhill Way",
            "Thornhill Woods","Thornicroft Way","Thornlea Road","Thornlodg Drive","Thornolden Ave",
            "Thornridge Dr","Thornridge Dr NW","Thornridge Drive","Thornridge Rd","Thornside Dr","Thornton Ave",
            "Thornton Cir S","Thornton Court","Thornton Ct","Thornton Drive","Thornton Ferry Road II",
            "Thornton Place","Thornton Rd","Thornton Road","Thornton Road N","Thornton St","Thornton Street",
            "Thornton Way","Thornwild Dr","Thornwood Blvd","Thornwood Crescent","Thornwood Cv","Thornwood Dr",
            "Thornwood Ln","Thornwoods Dr","Thorny Brae Drive","Thorold Gate","Thorold Stone Road",
            "Thoroughbred Crescent","Thoroughbred St","Thoroughfare Rd","Thorp Rd","Thorp St","Thorpe Ave",
            "Thorpe Dr","Thorpe Hill Rd","Thorsby Court","Thorsen River Dr","Thorson Dr","Thorton Ave",
            "Thorton Lake Rd","Thorton Rd SE","Thousand Acre Road","Thousand Island Lake Rd","Thousand Islands Parkway",
            "Thousand Pines Dr","Thrall Rd","Thrams St","Thrasher Ave","Thrasher Ln","Three Finger Jack",
            "Three Lakes Lp Rd","Three Mile Canyon","Three Mile Rd","Three Palms Dr","Three Rock Rd",
            "Three Springs Dr","Three Springs Rd","Three Valleys Drive","Throckmorton Ave","Throne Pl",
            "Thrush Dr","Thrush Field Way","Thrush Road","Thrush St","Thrushwoo Drive","Thrushwood Ln",
            "Thumb Lake Rd","Thunder 1 K Landing","Thunder Bridge Road","Thunder Grove","Thunder Head Ln",
            "Thunder Rd","Thunder Road","Thunderbird Cir","Thunderbird Ct","Thunderbird Dr","Thunderbird Rd",
            "Thunderbird Way","Thunderbolt Cir","Thurber Avenue","Thurber Rd","Thurber St","Thurgood Ave",
            "Thurgood Marshall Ln","Thurgood Ter","Thurmond Ave","Thurston Ave","Thurston Ter","Thurstoni Road",
            "Thwaite Avenue","Thyra Avenue","Tiama Rd","Tiana Court","Tiara Ave","Tiara Blanca Ct","Tiara Dr",
            "Tiara Point Cir","Tibbals Way","Tibbett St","Tibbiass Ln","Tibbitts Rd","Tibbs Ct","Tiber Ave",
            "Tiber Dr","Tibessart Ct","Tiburon Rd","Tice Crescent","Tice Dr","Tice Pl","Tice Road","Tice St",
            "Tichenor Ave","Ticonderoga Dr","Ticonderoga Ln","Tidal Wave Loop","Tidbury Street","Tide Ave",
            "Tide Dr","Tide Pl","Tidelands Ave","Tidepool Ct","Tidewater Ct","Tidewater Farm Rd","Tidewater Street",
            "Tidioute Enterprise Rd","Tidwell Dr","Tidwell Rd","Tiempo Rd","Tier Drop Trl","Tiernan St",
            "Tierney Dr","Tierney Rd","Tierney Street","Tierra Avenue","Tierra Blanca Rd","Tierra Dr",
            "Tierra Mesa","Tierra Montanosa","Tierra Monte Ct","Tierra Rd","Tierra Rejada Rd","Tierra Sabrosa",
            "Tierra Verde E","Tierra de Palmas Dr","Tierra del Sol Dr","Tietz Rd","Tiffany Cir","Tiffany Ct",
            "Tiffany Dr","Tiffany Ln","Tiffany Pines Dr NE","Tiffany Place","Tiffany Rd","Tiffany Road",
            "Tiffany West Way","Tiffin Cir SE","Tiffin Dr","Tiffin Street","Tiffollo Ln","Tifft Ave",
            "Tiger Cir","Tiger Cube Rd","Tiger Dr","Tiger Lily","Tiger Lily Ct","Tiger Lily Street","Tiger Tail Ln",
            "Tiger Woods Ave","Tigerlily Ln","Tigertail Ct","Tightwire","Tijeras Ct","Tijeras Rd","Tilbury Ct",
            "Tilden Ave","Tilden Pl","Tilden St","Till Sideroad","Tillamook Rd","Tiller Dr","Tilles Ave",
            "Tilley Road","Tillicountry Cir","Tillicum Way","Tillie Square","Tillie St SW","Tillie Way",
            "Tillingham Keep Boulevard","Tillinghast Ave","Tillison Avenue","Tillison Way","Tillman Ln",
            "Tillou Ln","Tilsworth Ln","Tilton Ave","Tilton Club","Tilton Ct","Tilton Ln","Tilton Road Cir",
            "Tilton St","Tilton Terrace","Tiltons Corner Rd","Tilyard Ct","Tim Hill Rd","Tim King Rd",
            "Tim O Connor Rd","Timber Bend Rd","Timber Canyon Ct","Timber Creek Apartment","Timber Ct",
            "Timber Glen Dr","Timber Haul Rd","Timber Hill Ln","Timber Hollow St","Timber Lane","Timber Ln",
            "Timber Mill Avenue","Timber Oak Ct","Timber Oaks Dr","Timber Point Way","Timber Rd","Timber Ridge Ct",
            "Timber Ridge Dr","Timber Ridge Rd","Timber St","Timber Ter","Timber Tr","Timber Trail","Timber Trails Rd SW",
            "Timber Trails St","Timber Trl","Timber Woods Dr N","Timberbank Boulevard","Timbercreek Ln",
            "Timbercrest Cir","Timberhill Ct","Timberhill Terrace","Timberidge Ct","Timberlake Ct",
            "Timberlake Dr","Timberlake Rd","Timberland Dr","Timberland Ln","Timberlane","Timberlane Ct",
            "Timberlane Dr","Timberlane Drive","Timberlane Rd","Timberlin Avenue","Timberlin Dr","Timberline",
            "Timberline Dr","Timberline Rd","Timberlink Dr","Timberlodge Ct","Timberlodge Ln","Timbermill Crescent",
            "Timberridge Trl","Timbers Circle","Timbertop Crescent","Timberview Ct NE","Timberview St NW",
            "Timberwood Way","Timbrook Dr","Timchek Dr","Timerline Dr","Times Ave","Times Avenue","Times Road",
            "Timlin Rd","Timm Mine Rd","Timmins Gardens","Timmons Park Rd","Timmsdale Crescent","Timmus Rd",
            "Timmy Ave","Timothy Court","Timothy Ct","Timothy Dr","Timothy Drew Way","Timothy Lane","Timothy Ln",
            "Timothy Pl","Timothy Street","Timpson Drive","Timpson Pl","Timrod Rd","Tims Ln","Tims Rd","Tin Mountain Rd",
            "Tina Ave","Tina Avenue","Tina Dr","Tina Drive","Tina Pl","Tina Road","Tina St","Tinari Dr","Tindall Ln",
            "Tindall Ranch Rd","Tindalls Wharf Rd","Tindalo Rd","Tindaro Ter","Tindell Ave","Tinder Box Ter",
            "Tinder Rd","Tine Ave","Tineham Court","Tinemaha Creek","Tinemaha Rd","Tingley Lake Rd","Tingley Rd",
            "Tinicum","Tinicum Island Rd","Tinka Ranch Way","Tinker Rd","Tinkers Lane","Tinkertown Dr",
            "Tinkham Rd","Tinnie Rd","Tinnin Ln","Tinny Ln","Tinside Rd","Tinsmith Ct","Tinta Creek","Tintern Road",
            "Tinton Ave","Tinton Crescent","Tiny Ave","Tiny Ln","Tiny Pebble Way","Tioga Ave","Tioga Cir",
            "Tioga Ct","Tioga Dr","Tioga Ln","Tioga Pass Rd","Tioga St","Tiogue Ave","Tiona Rd","Tionesta Rd",
            "Tionesta St","Tip Top Rd","Tipperary Ln","Tipperary St","Tippet Way","Tipping Way","Tippipah Spring Rd",
            "Tippo Rd","Tipton House Rd","Tipton Ln","Tiptop Rd","Tireman St","Tisbury Ct","Tisbury Street",
            "Tisdale St","Tish Ct","Tish Tang A Tang Ridge","Tishimingo Ct","Titan Dr","Titan St","Titania Ct",
            "Titanium Ave","Titgen Ave","Titman Rd","Tittabawassee Trl","Titus Ave","Titus Canyon Rd",
            "Titus Ct","Tiverton Ct","Tivoli Ct","Tivoli St","Tiwa Trce","Tj King Rd","Tkalis Dr","To 27 north",
            "To 27 south","To 2A","To 401 East","To 427 (to 401 West)","To 50 north","To Airport Rd",
            "To Cawthra Road","To Dixie Road","To Dundas Street East","To Highway 401","To Pearson Airport",
            "To Pearson Airport, Viscount Road, and ̅7̲̅/̅ Airport Road","To QEW and Gardiner Expressway",
            "To Terminal 1","To Terminal 1 Arrivals","To Terminal 1 Arrivals (and who knows where else?)",
            "To Terminal 1 Departures","To Terminal 3","To Third Line","To Woodbine","Toad Rd","Toas Ave",
            "Toback Rd","Tobbaco Rd","Tober Road","Tobey Br","Tobey Ct","Tobey Rd","Tobey Street","Tobias Rd",
            "Tobin Dr","Tobira Dr","Toboggan Ln","Toboggan Ridge","Toboggan Run","Toby & Diane","Tocata Dr",
            "Toccoa Falls","Todd Ave","Todd Brook Drive","Todd Ct","Todd Dr","Todd Hill Ct","Todd Hill Rd",
            "Todd Ln","Todd Road","Todd St","Todd Way","Todd's Aly","Todds Rd","Toddy Brook Rd","Todt Hill Ct",
            "Tody Bole Lane","Toepher Rd","Toetuck Dr","Tofte Ln","Toftwoods Way","Toga Ave","Tohickon Valley Dr",
            "Tohickon Valley Rd","Toiyabe St","Toiyabe Trl","Tokarz Rd","Tokatee Ct","Tokay Ln","Tolan St",
            "Tolbert Ln","Toledo Ave","Toledo Crescent","Toledo Ct","Toledo St","Toliver Rd","Toll Dr","Toll Rd",
            "Toll St","Tollbar Court","Tollendal Mill Road","Tolles St","Tollgate Rd","Tollhouse Rd",
            "Tolliver Rd","Tolman Pond Rd","Toltec Ct","Toltec Trl","Toluca Ct","Toluca Dr","Tom Dick and Harry Rd",
            "Tom Dr","Tom Ln","Tom Mascarenos Rd","Tom May Rd","Tom Mays Park Access Rd","Tom Nevers Road",
            "Tom Polk Cir","Tom Quick Rd","Tom Shaw Rd","Tom Ulozas Dr","Tom Williams Rd","Tomahawk Dr",
            "Tomahawk Ln","Tomahawk Rd","Tomahawk Tr","Tomahawk Trl","Tomales Bay","Tomales Point","Tomales Point Trail",
            "Tomasee Cir","Tomasini Way","Tomasita Ct NE","Tomatillo Ct","Tombaugh Ave","Tombstone Trail Rd",
            "Tombstone Trl","Tomco Cv","Tomel Court","Tomken Road","Tomki Rd","Tomkins Ave","Tomlee Ave",
            "Tomlinson Mill Rd","Tommie Harris Rd","Tommy Dr","Tommy Ln","Tommy Lot Rd","Tommy Moe Dr",
            "Tommy St","Tompkins Ave","Tompkins Lane","Tompkins Pl","Tompkins St","Toms Ln","Toms River East High School",
            "Tomwood Ave","Tona Cir","Tonawanda Creek Rd","Tonawanda Dr","Tonawanda St","Tondreau Ct",
            "Tone St","Tonella Rd","Tongie Point","Toni Dr","Toniso Dr","Tonkawa Trl","Tonkin Ct","Tonkin Rd",
            "Tonni St","Tonopah Ln","Tonry Ln","Tonsor St","Tony Acosta Ct","Tony Ct","Tony Lema Dr","Tony Look Trail",
            "Tony St","Toomin Dr","Tooth Acres Way","Top Cir","Top Gallant Ct","Top Mesa Rd","Top St","Top of the Oaks",
            "Topake Ln","Topal Ct","Topaz Cir","Topaz Dr","Topaz Ln","Topaz Sq","Topaz St","Topeka Dr","Topeka Road",
            "Topo Rd","Toppans Ln","Toppien Rd","Tops Drive","Topsfield Ln","Topsham Corinth Rd","Topside Cir",
            "Topside Rd","Topspin Dr","Topview Dr","Toquop Wash","Tor Ave","Tor View Ave","Torac Rd","Torbert Street",
            "Torbram Road","Tori Ln","Torii Street","Tornado Drive","Torne Rd","Tornillo Ct","Toro Cir",
            "Toro Creek Rd","Toronto Ct","Toronto St","Toronto Street","Toronto Street N","Toronto Way",
            "Toronto Zoo Road","Torpitt Road","Torrance Woods","Torre Ramel Ln","Torreen Tajique Loop Rd",
            "Torremolinos Ct","Torrente Way","Torreon Dr","Torreon Tajique Loop Rd","Torresdale","Torrey Hill Rd",
            "Torrey Lane","Torrey Ln","Torrey Pine Ct","Torrey Pine Ln","Torrey Pine Pl","Torrey Pines",
            "Torrey Point Ct","Torry Ave","Torteso Pl","Tortoise Close","Torwood Street","Tory Ct","Tory Dale Ct",
            "Tory Lane","Tory Ln","Toscana Ct","Toscana Way","Totem","Totem Pole Cir","Totem Trail","Toth Dr",
            "Totman Street","Toto Loma Ln","Totomee Ln","Totowa Ave","Totowa Rd","Totten Ln","Totten St",
            "Tottenham Court","Tottenham Ct","Tottenham Road","Toucan Ct","Toucan Dr","Touchstone Drive",
            "Toughnut St","Toulon Street","Tourmaline Ave","Tournade Pl","Tournament Dr","Tournament Way",
            "Tours Ln","Tourtellot Hill Rd","Tow Cir","Tow Rd SE","Tow Way","Towanda Rd NE","Towbin Ave",
            "Towbridge Cir","Towbridge Ct","Towe Rd","Towels Ln","Tower Ave","Tower Bridge","Tower Bridge Crescent",
            "Tower Bridge Gateway","Tower Court","Tower Dr","Tower Drive","Tower Hill Ave","Tower Hill Circle",
            "Tower Hill Ct","Tower Hill Road","Tower Lin Road","Tower Mhp","Tower Pk Dr","Tower Rd","Tower Ridge Rd",
            "Tower Road","Tower St","Tower St SE","Tower View Dr","Towering Vista Pl","Towers Ln","Towerville Rd",
            "Towhee Dr","Towhee Ln","Towle Cir","Towle Ln","Town Center Dr","Town Center Dr NW","Town Center Rd",
            "Town Creek Rd","Town Creek Truck Trail","Town Farm Rd","Town Farm Road","Town Forest Rd",
            "Town Forest Road","Town Garage Rd","Town Hall Drive","Town Hall Rd","Town Highway 2",
            "Town Hill Rd","Town Hill Road","Town House Cir","Town House Drive","Town House Rd","Town Hwy",
            "Town Hwy 1","Town Hwy 1039","Town Hwy 1117","Town Hwy 1160","Town Hwy 1163","Town Hwy 129",
            "Town Hwy 17","Town Hwy 18","Town Hwy 216","Town Hwy 219","Town Hwy 241","Town Hwy 242B",
            "Town Hwy 294","Town Hwy 303","Town Hwy 366","Town Hwy 40","Town Hwy 408","Town Hwy 457",
            "Town Hwy 469","Town Hwy 49","Town Hwy 62","Town Landing Rd","Town Line","Town Line Lake Park",
            "Town Line Rd","Town Rd","Town Road J J","Town South Dr","Town St S","Town Way","Town Well Rd",
            "Town-way","Towne Avenue","Towne Dr","Towne Hill Rd","Towne Ln","Towne Pl","Towne St","Towner Ave NE",
            "Towner Ave NW","Towner Dr","Townhall Rd","Townley Avenue","Townley Hwy","Townline Rd","Townline Road E",
            "Townline Road W","Towns Rd","Towns St","Townsend Ave","Townsend Ct","Townsend Ford","Townsend Pl",
            "Townsend Rd","Townsend Road","Townsend St","Townsend Ter","Townsend Way","Townsgate Drive",
            "Townsgate Gate","Township Highway 1","Township Highway 1038","Township Highway 1040",
            "Township Highway 1091","Township Highway 11","Township Highway 1106","Township Highway 1165",
            "Township Highway 130","Township Highway 1315","Township Highway 145","Township Highway 2115",
            "Township Highway 2116","Township Highway 214","Township Highway 215 A","Township Highway 2173",
            "Township Highway 235","Township Highway 242","Township Highway 298","Township Highway 301",
            "Township Highway 307","Township Highway 326","Township Highway 3486","Township Highway 4305",
            "Township Highway 432","Township Highway 442","Township Highway 451","Township Highway 471",
            "Township Highway 477","Township Highway 500","Township Highway 502A","Township Highway 512",
            "Township Highway 5241","Township Highway 60","Township Highway 602","Township Highway 660",
            "Township Highway 67","Township Highway 6735","Township Highway 6760","Township Highway 7486",
            "Township Highway 91","Township Highway 9403","Township Highway 952","Township Highway 9625",
            "Township Line Rd","Township Ln","Township Rd 195","Township Road 100","Township Road 1003",
            "Township Road 1004","Township Road 1097","Township Road 1143","Township Road 1165",
            "Township Road 119 NW","Township Road 1210","Township Road 1219","Township Road 1263",
            "Township Road 140","Township Road 177A","Township Road 184","Township Road 19","Township Road 2",
            "Township Road 203","Township Road 217","Township Road 2300","Township Road 25","Township Road 251",
            "Township Road 252","Township Road 26","Township Road 3050","Township Road 312","Township Road 350",
            "Township Road 3621","Township Road 372","Township Road 381","Township Road 383","Township Road 402",
            "Township Road 437A","Township Road 440","Township Road 450","Township Road 454","Township Road 475",
            "Township Road 479","Township Road 53","Township Road 54","Township Road 55","Township Road 59",
            "Township Road 683","Township Road 68A","Township Road 73","Township Road 88","Township Road 932",
            "Towpath Ln","Towpath Road","Towsow Estates","Toyan Ct","Toynevale Road","Toyon Ave","Toyon Dr",
            "Tr Pk Rd","Trabert Cir","Trabuco Rd","Tracamp St","Trace Cir","Tracey Brook Rd","Tracey Ln",
            "Tracey Park Place","Tracey Place","Tracey Road","Tracey Street","Tracey's Road","Trachtenberg Ct",
            "Traci Dr","Tracie Court","Track Dr","Track Ln","Track St","Tracter Trl","Traction Ave","Tractor Trl",
            "Tracy Ave","Tracy Ct","Tracy Ln","Tracy Lynn Ln","Tracy Pl","Tracy Rd","Tracy Ridge Rec Area",
            "Tracy Street","Tracy Ter","Trade Center Ave","Trade School Drive","Trade Way","Tradewind Avenue",
            "Tradewinds Ave","Tradewinds Ct","Tradewinds Dr","Trading Cove Dr","Trading Post Ct","Trading Post Ln",
            "Tradition Way","Traditions Way","Trafalgar Ct","Trafalgar Rd","Trafalgar Road","Trafalgar Square",
            "Trafalgar St","Traffic Cir","Trafford St","Tragia Avenue","Trahern Rd","Trail","Trail 14","Trail 16",
            "Trail 2","Trail Canyon Rd","Trail Cir","Trail End","Trail End Dr","Trail Rd","Trail Ridge Lane",
            "Trail Road B","Trail Road S","Trail Run Rd","Trail West","Trailee Court","Trailer Court Ln",
            "Trailer Park","Trailer Prk Entrance","Trailhead Parking","Trailhead Place","Trailmaster Drive",
            "Trailor Park Rd","Trailridge Crescent","Trails End Access Trail","Trails End Rd","Trails Xing",
            "Trailsbrook Terrace","Trailside Pl","Trailside Way","Trailway","Trailwood Crescent","Trailwood Rd",
            "Traina Ct","Trainor Court","Traister Dr","Trajan Ct","Trakey St","Tram Hollow Rd","Trammell St",
            "Tramonti Ct","Tramview Ln NE","Tramway Knoll Pl NE","Tramway Rd","Tranby Avenue","Tranquil Drive",
            "Tranquility Ln","Tranquility Ridge Ct","Trans Am Dr","Trans Mountain Rd","Trans-Canada Trail",
            "TransCanada Highway","Transit Ave","Transit Road","Transit St","Transmission Line Rd",
            "Transom Ct","Transport Way","Transportation Wy","Tranter Trail","Trantor Pl","Trapelo Road",
            "Trappers Lane","Trappers Ln","Trappist Cir","Trask Road","Trask St","Trauners Lakeside Dr",
            "Trautwein Cres","Trava Ln","Travelite Dr","Traver Road","Travers Ave","Travers Pl","Travers St",
            "Travers Street","Traverse Ct","Traverse St","Traverse Station Rd","Travis","Travis Ave",
            "Travis Ct","Travis Dr","Travis Rd","Travois Cir","Trawley Crescent","Trawood Dr","Traylor Rd",
            "Traynor Trail","Treadwell Ave","Treadwells Drive","Treasure Box Rd","Treasure Island Rd",
            "Treasure Ln","Treasure Road","Treasure St","Treat Hwy","Treat Rd","Treat St","Trebecca Ln",
            "Treble Cove Road","Trebol Ct","Trebor Dr","Trebuchet Dr","Tredmore Drive","Tredwell Ave",
            "Tree Farm Rd","Tree Line Dr","Tree St","Tree Swallow Ct","Tree Top Rd","Tree View Rd","Treehaven Ct",
            "Treelawn Boulevard","Treeline Ct","Treeline Dr","Treelyn Ct","Treepond Ct","Treetop Ln",
            "Treetop Rd","Treetops","Treetops Dr","Treeview Drive","Tregony Bow","Treguboff Ave","Trek Trl",
            "Trelawn Parkway","Trelawne Drive","Trellis Ct","Trellis View Ave","Tremain Rd","Tremblay Avenue",
            "Trembly Ridge Rd","Tremont Ave","Tremont Cir","Tremont Drive","Tremont Pl","Tremont Place",
            "Tremont Sq","Tremont St","Tremont Street","Trempes Grand Ave","Trenear Road","Trenholm Dr",
            "Trenholm Heights Dr","Trenier Dr","Trent Court","Trent Drive","Trent Ln","Trent Pl","Trent Rd",
            "Trent River Road","Trent Street S","Trentham Ave","Trenton","Trenton Ave","Trenton Cir",
            "Trenton Dr","Trenton Falls Rd","Trenton Fwy","Trenton Lakewood Rd","Trenton Rd","Trenton Road",
            "Trenton St","Trenton Street","Trenton-Frankford Road","Trentview Crescent","Trenum Dr",
            "Tres Hijos Pl","Trescartes Ave","Tresimene Ct NE","Trestle Glen Ct","Trestle Lake Dr",
            "Treston Pl","Trevena Rd","Treverton Drive","Trevino Circle","Trevor Lake Dr","Trevor Pl",
            "Trey Ln","Trey Ter SE","Treynor Trl","Tri River Campground Rd","Trian Ct","Triangle Blvd",
            "Triangle Dr","Triangle Trail","Tribal Rd 723","Tribal Road 26","Tribal Road 58","Tribal Road 63 SW",
            "Tribal Road 92","Tribal Route 701","Tribbett Ave","Tribbett Rd","Tribble Rd","Triborough Brg",
            "Tribune St","Tributary Plz","Trick Rd","Trickling Stream","Tricont Avenue","Tricorne Ct",
            "Trident Maple St","Triesan Way","Trifone Road","Triller Avenue","Trillium Crescent","Trillium Dr",
            "Trillium Trl","Trillium Way","Trillum Ct","Trim Ln","Trimble Ave","Trimble Court","Trimble Ln",
            "Trimbleford Ln","Trimmer Springs Rd","Trina Dr","Trinas Way","Trinidad Crescent","Trinidad Dr",
            "Trinidad St","Trinity Alps Ct","Trinity Ave","Trinity Circle","Trinity Court","Trinity Ct",
            "Trinity Lake Dr","Trinity Ln","Trinity Mountain Rd","Trinity Pass Rd","Trinity Pl","Trinity St",
            "Trinity Way","Trio Ct","Triple B Rd","Triple Creek Trl SE","Triple Diamond Way","Triple H Ln",
            "Triple J Ln","Tripoli Rd","Tripp Ln","Tripp St","Tripps Ln","Tripps Rd","Tripptown Rd","Triquillano Ln",
            "Tristram Cir","Triton Ct NW","Triton Pl","Tritt Cir","Trivett Ln","Troast Rd","Trocadero","Trocha Way",
            "Troika Court","Troja St","Trojan Cir","Trojan Crescent","Trojan Pl","Trojes Ave","Trolley Car Ln",
            "Trolley Rd","Tromble Rd","Tromley Drive","Trona Rd","Troon Ct","Troon Ter","Troop K Rd","Troost Ave",
            "Troost Trl","Trophy Hills Dr","Trophy Trl","Tropic Ct","Tropicana Ct","Trosello Ln","Trossach Rd",
            "Trossach St","Trotta Dr","Trotter Ct","Trotter Ln","Trotter Way","Trotters Lane","Trotters Ln",
            "Trotters Ridge Run","Trotting Park Cir","Trotwood Avenue","Trotwood Park","Trough Springs Ridge",
            "Troup Rd","Troup Road","Troupe St","Trousdale Drive","Trout Brook Dr","Trout Creek Rd","Trout Ct",
            "Trout Island Ct","Trout Lake Road","Trout Ln","Trout Rd","Trout Run Rd","Trout St","Trout Way",
            "Troutbrooke Drive","Trow Rd","Trowbridge Drive","Trowbridge Place","Trowbridge Rd","Trowbridge St",
            "Trowbridge Way","Troy Ave","Troy Avenue","Troy Breland Rd","Troy Ct","Troy Dr","Troy Ln","Troy Rd",
            "Troy Street","Troyer Court","Troyon St","Truck 541","Truck Parking","Truck Trail Road","Truckee Meadows Pl",
            "Truckee St","Trudeau Avenue","Trudeau Ct","Trudel St","Trudelle Street","Trudy Dr","Trudy Lane",
            "Trudy Ln","True Davidson Drive","Trueman Avenue","Truett Trl","Trujillo Way","Truk Lagoon Dr",
            "Trull Ln","Trull Rd","Trulls Road","Truman Aldrich Pky","Truman Ct","Truman Pl","Truman St",
            "Trumbull St","Trump Dr","Trumpet Ct","Trumpeter Street","Trundlebed Ln","Trunfio Lane","Trunkeyville Rd",
            "Truscott Dr","Truscott Drive","Trussville Clay Rd","Trustworthy Ave","Truth Ter","Truxton Street",
            "Tryon Ave","Tryon Dr","Tryon Rd","Tsa Be Toh Cir","Tschirky Rd","Tsienneto Rd","Tsippaih Road 29",
            "Tuba St","Tuber Canyon Rd","Tuberose St","Tuck Ln","Tuckahoe Rd","Tuckahoe Ter","Tuckahoe-Mount Pleasant Rd",
            "Tucked Away Trl","Tucker Ave","Tucker Avenue","Tucker Cir","Tucker Ct","Tucker Dr","Tucker Lane",
            "Tucker Ln","Tucker Rd","Tucker St","Tucker Street","Tuckerman Crossover","Tuckerman Street",
            "Tuckerton","Tucumcari Cir","Tudor Cir","Tudor City Place","Tudor Ct","Tudor Dr","Tudor Gate",
            "Tudor Hill Rd","Tudor Ln","Tudor Oval","Tudor Rd","Tudor Road","Tudor Terrace","Tuell St NW",
            "Tuers Ave","Tufco Ln","Tuff Campground Rd","Tufford Road","Tufts Circle","Tufts Ct","Tufts Rd",
            "Tufts Street","Tufts Trl","Tuftsville Road","Tug Boat Ct","Tugalo Rd","Tujunga Ave","Tujunga Dr",
            "Tulane Crescent","Tulane Ct","Tulane Rd","Tulane St","Tulare Ave","Tulare Ct","Tulare Rd","Tulare Santa Fe Trl",
            "Tulare St","Tule Dr","Tule Lake Ln","Tule River Cir","Tule River Dr","Tule River Way","Tuleburg Levee",
            "Tulgeywood Ln","Tulio St","Tulip Ave","Tulip Cir","Tulip Court","Tulip Ct","Tulip Dr","Tulip Ln",
            "Tulip Pl","Tulip Rd","Tulip Rd NE","Tulip St","Tulip Street","Tulip Ter","Tulip Tree Cir","Tulip Tree Dr",
            "Tulip Trl","Tulip Way","Tuliptree Ln","Tulita Dr","Tuller Ct","Tuller Drive","Tulloch Rd","Tullow Dr",
            "Tully Rd","Tully St","Tulsa St","Tumble Falls Rd","Tumble Idell Rd","Tumble Weed Trl","Tumble-Weed Trl",
            "Tumblebrook Ln","Tumbledown Road","Tumbleweed Ave","Tumbleweed Rd","Tumbleweed St","Tumbling Creek Rd",
            "Tumbling Mcd Rd","Tumbling Tree St","Tumeric Ln","Tumwater St","Tuna Cross Roa","Tuna Path",
            "Tunbridge Crescent","Tunbridge Road","Tunica National Pkwy","Tunisia Ave","Tunison Ct",
            "Tunison Rd","Tunnel Canon","Tunnel Hill Rd","Tunnel Hill Rd NE","Tunnel Rd","Tunnel Road",
            "Tunnel Springs Rd","Tunney Ave","Tunstall St","Tunstead Ave","Tunxis Cir","Tuolumne Dr",
            "Tuolumne Rd","Tuolumne River","Tupelo Ct","Tupman Rd","Tupper Hill Rd","Tupper St","Tupper Street",
            "Turberville Rd","Turf Dr","Turf Mobile Home Park","Turff Avenue","Turfway Park Ct","Turkey Buzzard Bridge Rd",
            "Turkey Creek Ln W","Turkey Creek Rd","Turkey Heaven Mtn Rd","Turkey Hill","Turkey Hill Rd",
            "Turkey Jim Rd","Turkey Ln","Turkey Pen Rd","Turkey Ridge Rd","Turkey Run Ln","Turkey Run Rd",
            "Turkey Street","Turkey Track Rd","Turkey Trl","Turkey Trot Ln","Turkey Trot Rd","Turkey Trot Tr",
            "Turko Ave","Turley St","Turlock Rd","Turn Here Rd","Turnabout Ln","Turnage Ln","Turnback Trl",
            "Turnberry Ct","Turnberry Dr","Turnberry Ln","Turnberry Way","Turnbridge Ct","Turnbridge Row",
            "Turnbuckle Ln","Turnbuckle Rd","Turnbull Road","Turnbury","Turnbury Ct","Turner","Turner Addition",
            "Turner Ave","Turner Avenue","Turner Canyon Rd","Turner Dr","Turner Hill Rd","Turner Industial Way",
            "Turner Lane","Turner Rd","Turner Rd E","Turner Road","Turner St","Turner's Ave","Turners Falls Road",
            "Turning Leaf Dr","Turning Mill Lane","Turnpike Park","Turnpike Rd","Turnpike Road","Turnstone Ct",
            "Turnstone Dr","Turnstone Ln","Turntable Bay Rd","Turntree Ct","Turnwood Rd","Turqueries Ave",
            "Turquoise Ave","Turquoise Ct","Turquoise Dr","Turquoise Way","Turrietta Ln SW","Turrill Brook Dr",
            "Turtle Access Rd","Turtle Back","Turtle Back (Orange)","Turtle Creek Circle","Turtle Creek Rd",
            "Turtle Key Dr","Turtle Lk Railroad","Turtle Ln","Turtle Mountain Cir","Turtle Point Stable Rd",
            "Turtle Pond Road","Turtle Rd","Turtle Rock Rd","Turtle St","Turtle Vista Cir","Turtledove Ct",
            "Tuscaloosa Ln","Tuscaloosa Rd","Tuscaloosa St","Tuscan River Way","Tuscani Drive","Tuscany Court",
            "Tuscany Ct","Tuscarora Ave","Tuscarora Dr","Tuscarora Rd","Tuscarora St","Tuscola Pl","Tustin St",
            "Tutor Rd","Tuttle Ave NE","Tuttle Ct","Tuttle Rd","Tuttle Road","Tuttle St","Tuttle's Rd","Tuttles Corner Dingmans Rd",
            "Tuvira Ln","Tuxedo Dr","Tuxedo Rd","Tuxford St","Tuxill Sq","Tv Tower Rd","Twain Harte Ct",
            "Twain St","Tweed Brook Rd","Tweed Road","Tweedale Dr","Tweedsmuir Crescent","Tweentown Close",
            "Twelfth Avenue","Twells Ave","Twelve Corners Road","Twelve Oaks Ln","Twenty First Street",
            "Twenty-First Street","Twenty-Third Street","Twentyeighth St","Twentynine Outerhighway",
            "Twica Ln","Twichell Rd","Twig Ct","Twig Ln","Twigg Ln","Twigg Rd","Twilight","Twilight Ave","Twilight Star Dr",
            "Twilight Trl","Twilley Lands","Twin Ave","Twin Branch Cir","Twin Bridges Rd","Twin Brook Ln",
            "Twin Brook Rd","Twin Brooks Dr","Twin Brooks Road","Twin Buttes Dr NE","Twin Church Rd",
            "Twin Cir","Twin Cities Memorial Hwy","Twin Cottage Ln","Twin Dr","Twin Elms","Twin Elms Ln",
            "Twin Hills Crescent","Twin Lake Villa Rd","Twin Lakes Blvd","Twin Lakes Dr","Twin Lakes Rd",
            "Twin Leaf Trl","Twin Light Ct","Twin Ln W","Twin Manor","Twin Mt Cir","Twin Oak Ave","Twin Oak Ct SW",
            "Twin Oak Dr","Twin Oaks Ave","Twin Oaks Dell","Twin Oaks Dr","Twin Oaks Road","Twin Peaks Ct",
            "Twin Peaks Rd","Twin Pine Ln","Twin Pines Dr","Twin Pines Ln","Twin Pines Loop","Twin Pond Rd",
            "Twin Ridge Ct","Twin Rivers Dr","Twin Springs Canyon","Twin Springs Ln","Twin Springs Rd",
            "Twin Trees Rd","Twin Wells Rd","Twin-Oaks","TwinMaple Drive","Twinberry Ct","Twinboro Ln",
            "Twining Cir","Twining Rd","Twinney Drive","Twins Ct","Twins Dr","Twist","Twist Dr","Twisted Oak Ave",
            "Twisted Oak Street","Twisted Oaks Ct","Twitchell Dam Rd","Two Bridges Rd","Two Bridges Rd; Passaic Ave",
            "Two Mile Creek Road","Two Mile Rd","Two Penny Run W","Two Ponds Road","Two Rivers Dam Rd",
            "Two Rod Hwy","Twombley Ln","Twombly Ave","Twombly Ct","Twp 1091","Twp 143","Twp 162","Twp 169",
            "Twp 19","Twp 2329","Twp 24","Twp 256","Twp 27","Twp 279","Twp 281","Twp 316","Twp 339","Twp 399","Twp 45",
            "Twp 606","Twp 69","Twp 8","Twp Hwp 468","Twp Hy 499","Twp Hy 609","Twp Road 150","Twyford Road",
            "Txr Rd","Tyandaga Court","Tybo Cir","Tyburn Rd","Tyee St","Tygert Rd","Tyler","Tyler Ave","Tyler Ct",
            "Tyler Dr","Tyler Drive","Tyler Foote Rd","Tyler Hill Rd","Tyler Hollow Rd","Tyler Lake Heights Extended",
            "Tyler Lake Rd","Tyler Loop Rd","Tyler Park","Tyler Pl","Tyler Rd","Tyler Rd NW","Tyler St",
            "Tyler Street","Tyler Ter","Tylers Mill Rd","Tyndale Road","Tyneburn Crescent","Tynegrove Road",
            "Tynevale Drive","Tyneview Lane","Tyng Street","Tyngsboro Road","Tyoga Rd","Tyro Rd","Tyrrell Pl",
            "Tyrrell Rd","Tysen Ln","Tysley St","Tyson Ln","Tyson Pl","Tyson Swine","U Dantz Run","U S C G Entrance St",
            "U S Forest Service 445","U St","U.S. Route 101","US 11","US 15 North","US Forest Service Road 12S01",
            "US Forest Service Road 5180","US Highway 219","US Hwy 1 (Bypass)","US Hwy 422 (Alt)",
            "US Hwy Forest Service Rd 551","US Hwy Forrestry 556","US Route 4","US Route 5","US Veterans Hospital Loop",
            "US-60","Udall Ln","Uffington Cir","Uhland St","Uhthoff Line","Ukraine Road","Ullman Ave","Ulman Rd",
            "Ulman Road","Ulric St","Ulrich Ln","Ultimate Ct","Ulu Ct","Ulysses Ave","Ulysses Ct","Ulysses Place",
            "Ulysses Rd","Umberland Ct","Umberto St","Umetco Roads","Umtali Rd","Un Rd","Una Way","Unamed Unimproved Ag Rd Prrd",
            "Unami Ct","Uncle Ephhriams Road","Uncle Harrys Rd","Uncle Johns Way","Undercliff Ave",
            "Undercliff Rd","Underground walkway","Underhill Ave","Underhill Dr","Underpass Gate",
            "Underpass Rd","Underpass Road","Underwood Ave","Underwood Ct","Underwood Dr","Underwood Hill Rd",
            "Underwood Ln","Underwood Rd","Underwood St","Uneta St","Unforgettable Ave","Ungava Dr","Unger Rd",
            "Unicorn Rd","Union Aly","Union Ave","Union Ave Loop","Union Avenue","Union Blvd","Union Canyon",
            "Union Center Maine Highway","Union City Trail","Union Corners Rd","Union Ct","Union Dr",
            "Union Hill Dr","Union Hill Rd","Union Mission Ln","Union Pacific Ave","Union Park Road",
            "Union Pl","Union Place","Union Rd","Union Rd 327","Union Rd 711","Union Rd 742","Union Ridge Rd",
            "Union Road 175","Union School Road","Union Springs Rd","Union Sq","Union Square East",
            "Union St","Union Street","Union Sugar Ave","Union T Rd","Union Valley Rd","Union Way","Unionlake Rd",
            "Uniontown Flushing Rd","Unionvale-Kenwood Rd","Unitas Road","United Circle","United Ln",
            "United Rd","United States Ave","United States Ave E","United States Highway 1","United States Highway 1 (express)",
            "United States Highway 1 (local)","United States Highway 1 (truck)","United States Highway 101",
            "United States Highway 11","United States Highway 12","United States Highway 13",
            "United States Highway 13 (Bus)","United States Highway 130","United States Highway 141",
            "United States Highway 15","United States Highway 160","United States Highway 163",
            "United States Highway 167 S","United States Highway 180","United States Highway 191",
            "United States Highway 199","United States Highway 1; Lincoln Hwy","United States Highway 20",
            "United States Highway 202","United States Highway 206","United States Highway 206 N",
            "United States Highway 209","United States Highway 211","United States Highway 219",
            "United States Highway 219 (Business)","United States Highway 219 South","United States Highway 22",
            "United States Highway 220","United States Highway 23","United States Highway 231",
            "United States Highway 26","United States Highway 278","United States Highway 280",
            "United States Highway 285","United States Highway 287","United States Highway 29",
            "United States Highway 3","United States Highway 302","United States Highway 31",
            "United States Highway 322","United States Highway 340","United States Highway 35",
            "United States Highway 36","United States Highway 371","United States Highway 385",
            "United States Highway 395","United States Highway 4","United States Highway 40",
            "United States Highway 41","United States Highway 412","United States Highway 43",
            "United States Highway 431","United States Highway 45","United States Highway 46",
            "United States Highway 49","United States Highway 49 S","United States Highway 49E",
            "United States Highway 49W","United States Highway 5","United States Highway 50",
            "United States Highway 54","United States Highway 550","United States Highway 6",
            "United States Highway 60","United States Highway 61","United States Highway 62",
            "United States Highway 62 (Bus)","United States Highway 62(Bus)","United States Highway 63",
            "United States Highway 64","United States Highway 65","United States Highway 65; United States Highway 65 South",
            "United States Highway 66","United States Highway 67 N","United States Highway 7",
            "United States Highway 70","United States Highway 71","United States Highway 72",
            "United States Highway 78","United States Highway 79","United States Highway 80",
            "United States Highway 81","United States Highway 82","United States Highway 82 E",
            "United States Highway 84","United States Highway 85 (Alt)","United States Highway 87",
            "United States Highway 87; United States Highway 287","United States Highway 89",
            "United States Highway 9","United States Highway 93","United States Highway 95",
            "United States Highway 98","United States Highway 9W","United States Highway Fs 2601",
            "United States Route 50","United States Route 93","United States Route 95","United Way",
            "Unity Road","Unity Street","Univ Heights Acc Rd","Universal Dr","Universe Dr","University Ave",
            "University Avenue","University Avenue W","University Blvd","University Blvd E","University Blvd NE",
            "University Boulevard SE","University Cir","University Ct","University Dr","University Dr NE",
            "University Dr NW","University Park Dr","University Pl","University Rd","University Ring Road",
            "University St","University Street","University Way","University of Rochester","Unknown",
            "Unknown Rd","Unkown","Unnamed","Unnamed Rd","Unnamed Rd A","Unnamed Road","Unnamed Road I",
            "Unnammed Aly","Uno Drive","Upas Street","Updike Rd","Upham Terrace","Uphill Way","Upjohn Dr",
            "Upland Ave","Upland Ct","Upland Ct NE","Upland Fields Road","Upland Pl","Upland Road","Uplands Avenue",
            "Uplands Way","Upp Ct","Upper Ardmore Rd","Upper Bear River Rd","Upper Big Chute Road",
            "Upper Canada Drive","Upper Canada Road","Upper Charles Trail","Upper Church Street",
            "Upper Clark Ave","Upper Coast Guard Base Access","Upper County Road","Upper Creek Rd",
            "Upper Cross Rd","Upper Deer Creek Ln","Upper Dorray Rd","Upper Dr","Upper East Ln","Upper Fords Creek Rd",
            "Upper Front Street","Upper High Meadow Trail","Upper Highland Crescent","Upper Hourglass Rd",
            "Upper Jaffrey Rd","Upper Kingtown Rd","Upper Lake Dr","Upper Lakeview Dr","Upper Log Rd",
            "Upper Los Berros Rd","Upper Main St","Upper Mattole Canyon Rd","Upper Middle Road",
            "Upper Mountain Ave","Upper Mountain Rd","Upper Murphy Valley Rd","Upper Narrows Rd",
            "Upper Olive St","Upper Orchard Pass","Upper Park Ave","Upper Potter Brook Rd","Upper Rapids Boulevard",
            "Upper Rd","Upper Ridge Rd","Upper Rouge Trail","Upper Saddle River Rd","Upper Sarepta Rd",
            "Upper Slash Road","Upper Spruce Ct","Upper St","Upper Street","Upper Suncook Ln","Upper Terrace Rd",
            "Upper W Thomas Rd","Upper Weir Rd","Upper Wolf Run","Upper Woods Rd","Upsan Down","Upshaw Pl",
            "Upson Ave","Upson Rd","Upton Ave","Upton Dr","Upton Rd","Upton Spur","Upton Street","Upton Way",
            "Uranus Dr","Urbana Ln","Urbana Rd","Urbandale Avenue","Ureco Terrace","Ureka Dr","Urie Rd",
            "Urner St","Ursa Ave","Ursa Starway","Ursinus Rd","Ursula Rd","Urtuzuastegu St","Usaf Test Site",
            "Usal Rd","Useadoor Street","Usfs 155","Usfs 2293","Usfs 2439","Usfs 24N 44","Usfs 42 N 22",
            "Usfs 42 N13","Usfs 42 N22","Usfs 43 N 01","Usfs 43 N 17","Usfs 43 N15","Usfs 43 N35","Usfs 43 N39",
            "Usfs 43 N52","Usfs 44 N 02","Usfs 44 N 10Y","Usfs 44 N 11 Y","Usfs 44 N01","Usfs 44 N03",
            "Usfs 44 N13","Usfs 44 N21","Usfs 44 N22","Usfs 44 N89","Usfs 445","Usfs 45 N 11 Y","Usfs 45 N 14 Y",
            "Usfs 5180","Usher Dr","Usherwood Street","Usry Ave","Uss Tennessee Rd","Ut 349","Utah Ave",
            "Utah Pl","Utah Ridge Rd","Utah St","Utah St NE","Utah Tr W","Utah Way","Ute Ave","Ute Creek Ranch Rd",
            "Ute Ct","Ute St","Utica Ditch Flume","Utica St","Utica Street","Utley Road","Utnage Dr","Utne Ct",
            "Uttecht Tr","Utton Ave","Uva Ct","Uva Way","Uvas Park Dr","Uvas Valley Rd NE","Uxbridge-Pickering Townline Road",
            "V Ave","V F W Rd","V Miller Prestonway","V Rd","V St","V St W St Aly","V Street","VILLA CELAJE",
            "Vacation Land Dr","Vacation Pl","Vacation Rd","Vaccaro Pl","Vaccaro Rd","Vaden Rd","Vaduz Ct",
            "Vagabond St","Vahlsing Way","Vail Ave","Vail Avenue","Vail Ct","Vail Dr","Vail Lake Rd","Vail Ln",
            "Vail Place","Vail Rd","Vail St","Vail Trl","Vaill Rd","Vair V Cour","Val Bark Cir","Val Cir","Val Ct",
            "Val Dechiana Ave","Val Disere Pl","Val Dr","Val Jean Dr","Val Lee Ln","Val Mar Dr","Val St",
            "Val Vista Pl","Valandora Ct","Valarie St","Valaspen St","Valcourt Pl","Valdaz Rd","Valdez Ln",
            "Vale Dr","Vale Ln","Vale Pl","Vale Rd","Vale St","Vale Street","Valence Way","Valencia Ave","Valencia Ct",
            "Valencia Dr","Valencia Dr NE","Valenciia Rd","Valentine Dr","Valentine Lane","Valentine St",
            "Valentine Street","Valentine Ter","Valentino Rd","Valentino St NW","Valenza Ln","Valeria Ave",
            "Valeria Boulevard","Valerie Dr","Valerie Pl","Valerie Rd","Valerio Ct","Valewood Court",
            "Valewood Ct","Valgrande Way","Valhaven Dr SW","Valiant Ln","Valinda St","Valindo Way","Valis Rd",
            "Valkyrie Way","Valle Grande Trl N","Valle Rd","Valle Rio St","Valle Sorisa","Valle Vista Ct",
            "Valle Vista Rd","Valle de Arareco","Vallecito Ave","Vallecito Ln","Vallecitos Dr","Vallejo Dr",
            "Vallejo St","Valles Rd","Valley","Valley Ave","Valley Blvd","Valley Brook Cir","Valley Brook Rd",
            "Valley Center Rd","Valley Cir","Valley Court Rd","Valley Cove Rd","Valley Crescent","Valley Crest Dr",
            "Valley Ct","Valley Dr","Valley Drive","Valley Farm Road","Valley Field Dr","Valley Ford Estero Rd",
            "Valley Ford Franklin School Rd","Valley Forge Ave","Valley Forge Dr","Valley Forge Pl",
            "Valley Forge Way","Valley Heights Dr","Valley Hi Dr","Valley Hill Dr","Valley House Dr",
            "Valley Knolls Rd","Valley Ln","Valley Oak Ct","Valley Oak Dr","Valley Oak Ln","Valley Pky",
            "Valley Pl","Valley Quail Dr","Valley Rd","Valley Ridge Cir","Valley Ridge Crescent","Valley Ridge Dr",
            "Valley Road","Valley Run Cir","Valley Spring SE","Valley St","Valley Street","Valley Ter",
            "Valley View Ave","Valley View Ave N","Valley View Blvd","Valley View Cir","Valley View Ct",
            "Valley View Dr","Valley View Estates","Valley View Ln","Valley View Rd","Valley View St",
            "Valley View Ter","Valley View Terrace","Valley Vista Ave","Valley Vista Blvd","Valley Vista Dr",
            "Valley Vista Rd","Valley Way","Valleybrook Dr","Valleycrest Avenue","Valleydale Mobile Home Park",
            "Valleyford Avenue","Valleymede Drive","Valleypark Dr","Valleystream Circle","Valleyvie Drive",
            "Valleyview","Valleyview Dr","Valleyview Drive","Valleyview Rd","Valleyview Ter","Valleywood Drive",
            "Valli Dr","Valliant Dr","Valloncliffe Road","Valmarie Avenue","Valmonte Glen","Valmora St",
            "Valner Way","Valonia St","Valor Boulevard","Valor Ct","Valorie Ln","Valverde Pl SW","Van Allen Road - Morrisburg",
            "Van Allen St","Van Arsdale Ct","Van Auken Dr","Van Auken Rd","Van Ben Schoter Rd","Van Binsberger Blvd",
            "Van Blarcoms Lane","Van Bolen Way","Van Born Rd","Van Brackle Rd","Van Brummel Ln","Van Brunt St",
            "Van Buren","Van Buren Ave","Van Buren Blvd","Van Buren Dr","Van Buren Pl SE","Van Buren Rd",
            "Van Buren St","Van Buren Street","Van Buskirk St","Van Campen Way","Van Cleaf Ln","Van Cleef St",
            "Van Cleep Ln","Van Cortlandt Ave","Van Cortlandt Ter","Van Courtland Pl","Van Ct","Van Dean St",
            "Van Deusen Rd","Van Dixon Dr","Van Dressen Rd","Van Duesen Rd","Van Dusen Boulevard",
            "Van Duzer St","Van Dyke Ave","Van Dyke Ct","Van Dyke Dr","Van Dyke Pl","Van Dyke Rd","Van Ella Rd",
            "Van Emburgh Ave","Van Epps St","Van Ess Way","Van Etten Rd","Van Fossen Rd","Van Gelder Court",
            "Van Giesen Dr","Van Gogh St","Van Horn Pl","Van Horn Rd","Van Horn St","Van Horn Street",
            "Van Horne Avenue","Van Houten Ave","Van Houten Avenue","Van Houten St","Van Kal St","Van Kirk NE",
            "Van Kirk St","Van Luven Road","Van Luyn Ter","Van Mar Ave","Van Mara Dr","Van Meter Dr",
            "Van Meter St","Van Name Ave","Van Natta Dr","Van Neis Road","Van Ness Rd","Van Nest Ave",
            "Van Neste Dr","Van Nostrand Ave","Van Nostrand Ct","Van Olinda St","Van Orden Ln","Van Orden St",
            "Van Patten Ave","Van Pelt Dr","Van Pelt Ln","Van Pelt Pl","Van Peyma St","Van Pl SW","Van Pooka Ct",
            "Van Ranseleer Ave","Van Rensaller Ave","Van Reyper Pl","Van Riper Ave","Van Riper Dr",
            "Van Riper St","Van Salter Rd","Van Sciver St","Van Sickle Rd","Van Stallen St","Van Tu Ln",
            "Van Valin Pl","Van Velsor Pl","Van Vleck Rd","Van Vleck Road","Van Vorst St","Van Winkle St",
            "Van Wormer Rd","Van Wyck Road","Van Zant Rd","Van Zile St","Vanada Dr","Vanatta Dr","Vanatta Rd",
            "Vanauley Walk","Vanbremer St","Vanbuskirk Gulf Rd","Vance Ave","Vance Drive","Vance Rd",
            "Vance St","Vancouver Ave","Vancouver Ct","Vancouver Rd","Vancouver Street","Vandalia St",
            "Vandam Street","Vandegrift Boulevard","Vandelinda Ave","Vandenburg Blvd","Vandenburg St",
            "Vanderbilt Ave","Vanderbilt Avenue","Vanderbilt Ct","Vanderbilt Pl","Vanderbilt Rd","Vandercamp Ctr",
            "Vanderhoof Rd","Vanderhurst Rd","Vanderlin Park","Vanderlip","Vanderpool St","Vanderslice Rd",
            "Vanderveer Dr","Vandervere Rd","Vandervoort Avenue","Vandervoort Place","Vandervoort St",
            "Vanderwall Dr","Vandeveer Dr","Vandever Avenue","Vandien Ct","Vandike St","Vandorf Sideroad",
            "Vanduyne Ave","Vanduzee St","Vandy Ave","Vane Street","Vanessa Ct","Vanessa Dr","Vanessa St",
            "Vanetten Rd","Vanhook St","Vanier Lane","Vanilla Ct","Vanity Court","Vanity Crescent","Vankirk Road",
            "Vankurin Rd","Vanmulligan Ave","Vann Dr","Vann Main","Vann St","Vanna Court","Vanoni Ln","Vanore Dr",
            "Vanover Dr","Vans Ave F","Vans Beach Rd","Vans Ranch Rd","Vansco Road","Vantage Dr","Vantage Point Dr",
            "Vanwood Road","Vanzant","Vanzant Rd","Vaquero","Vaquero Dr","Vaquero Rd","Varden Ct","Vare Ave",
            "Varency Drive","Varese Ct","Varet St","Varga Ln","Vargas Ct","Varick Avenue","Varick St","Varick Street",
            "Varin Dr","Varline","Varnard Terrace","Varnell Rd","Varner Ln","Varney Rd","Varuna Dr","Vasco Rd",
            "Vasconcellos Avenue","Vasey Road","Vasey Road (Trans-Canada)","Vashell Way","Vasilion Pl NW",
            "Vasona Park Rd","Vasquez Road","Vassar","Vassar Ave","Vassar Ave W","Vassar Circle","Vassar Dr",
            "Vassar Ln","Vassar Pl","Vassar Rd","Vassar St","Vassar Way","Vasselle Crescent","Vath St","Vauclain Ln",
            "Vaughan Dr","Vaughan Road","Vaughan St","Vaughn Ave","Vaughn Rd","Vaya Enpaz Dr","Vayo St",
            "Veatch","Veater Ranch Rd","Veazey Rd","Veblem Ave","Vedder Rd","Veeder Fire Road","Veeder Ln",
            "Vega Ct","Vega Dr","Vegas St","Veit Rd","Veitenheimer Rd","Velado St","Velasquez Rd SE","Veldor Park",
            "Veldran Ave","Vellanto Way","Vellore Avenue","Vellore Park Avenue","Vellore Woods Boulevard",
            "Velma Cir","Velmar Drive","Velverde Pk Rd","Velvet Leaf Dr","Vema Dr","Venable St","Venado Ct",
            "Venado Dr","Venecia Ln","Veneno St","Venetia St","Venetia View Cir","Venette St","Venezia Ct",
            "Venice Ave","Venice Ave NE","Venice Ct","Venice Dr","Venice Ln","Venice St","Venice Way","Venita Ct",
            "Venn Crescent","Venna Pl","Venora Way","Venray Dr","Venta Avenue","Ventana Dr","Ventana Village Ln",
            "Ventana Way","Ventose Place NW","Ventris Rd","Ventura Ave","Ventura Cir","Ventura Ct","Ventura Dr",
            "Ventura Dr SE","Ventura Freeway","Ventura Fwy","Ventura St","Ventura Way","Venture Ave NW",
            "Venture Ct","Venture Ln","Venue Dr","Venus Ct","Venus Ct NE","Venus Dr","Venus Drive","Venus Ln",
            "Venus Loop","Venus St","Vera Ave","Vera Cruz","Vera Cruz Dr","Vera Cruz Rd NE","Vera Ct","Vera Mar Ct",
            "Vera St","Vera Street","Verado Rd NE","Veragua Dr","Veranda Ave","Veranda Dr","Veranda Rd NE",
            "Veranda Way","Verano Ave","Verano Ct","Verano Way","Verbena","Verbena Cmn","Verbena Dr","Verbeno Rd",
            "Verboom St","Vercelli Ct","Vercelli Ln","Verdant Rd","Verde","Verde Ct","Verde Dr","Verde Rd",
            "Verde St","Verde Vista","Verde Vista Dr","Verde Vista Ln","Verde Vista Pl","Verdemour Ave",
            "Verdi Peak Rd","Verdi Road","Verdies Ct","Verdin Dr","Verdin Pl","Verdolaga","Verdosa Dr","Verdugo Dr",
            "Verdun Road","Verga Ave","Verhoeff Pl","Verhoeven Drive","Verity Court","Verkade Ln","Verle Dr",
            "Vermark Lane","Vermeer Dr","Vermejo Park Cir","Vermillion Ln","Vermont Ave","Vermont Ct",
            "Vermont Made Acres","Vermont Route 110","Vermont Route 25","Vermont St","Vermont St NE",
            "Vermont St SE","Vermont Street","Vermont Ter","Vermont Trl","Verna Ct","Vernace Way","Vernage Ln",
            "Vernal Ave","Vernal Dr","Vernal Pl","Vernal St","Vernal Woods Ct","Vernelle Ave","Verner Ave",
            "Vernette Ave","Vernon Ave","Vernon Blvd","Vernon Greenways","Vernon Harris Rd","Vernon Ln",
            "Vernon Place","Vernon Rd","Vernon Rd N","Vernon Road","Vernon St","Vernon Street","Vernon Way",
            "Vernon Xing","Vernot Ln","Verobeach Boulevard","Verona Ave","Verona Ct","Verona Dr","Verona Street",
            "Veronica Ct","Veronica Drive","Veronica Ln","Veronica Pl","Versailles Blvd","Versalles Ln",
            "Versye Ave","Vervalen St","Vescovo Road","Vesey Ave","Vesey Street","Vesper Ave","Vesper Ln",
            "Vespucci Rd","Vessel Crescent","Vest St","Vesta Ct","Vesta Drive","Vesta St","Vestal Ave","Vestavia Dr",
            "Vestry Street","Veteran's Way","Veterans Ave","Veterans Avenue","Veterans Blvd","Veterans Dr",
            "Veterans Ln","Veterans Memorial Dr","Veterans Memorial Drive","Veterans Memorial Highway",
            "Veterans Of Foreign Wars Highway","Veterans Of Foreign Wars Memorial Drive",
            "Veterans Of Foreign Wars Parkway","Veterans Pkwy","Veterans Pl","Vetrini Ln","Vetrone Dr",
            "Vfw Way","Vi Ct","Via Adarme","Via Alicia","Via Alista","Via Allegre","Via Alta","Via Altamira",
            "Via Altis","Via Amante","Via Ambiente","Via Anade","Via Andeta","Via Appia Ln","Via Aquario Dr",
            "Via Aurelia","Via Badalona","Via Baron","Via Barri","Via Beatraiz","Via Beliz","Via Beltran",
            "Via Blairo Cir","Via Blanco","Via Bonita","Via Bordeaux","Via Brea","Via Campo","Via Campo Verde",
            "Via Candella","Via Cerrada","Via Cima","Via Clavel","Via Contenta","Via Cordaro","Via Corona",
            "Via Corral","Via Cresta","Via Cristina Way","Via Cuesta Arriba","Via Delfin","Via Delicia",
            "Via Di Autostrada","Via Diego Ter","Via Don Luis","Via Eboli","Via Ensenada","Via Entrada",
            "Via Estrella","Via Faisan","Via Felicita","Via Feliz","Via Fresa","Via Gavilan","Via Gracia",
            "Via Hermosa St","Via Hondonada","Via Impreso","Via Industria","Via Italia","Via Jacinto",
            "Via Jalapa","Via Jero","Via Juana Ln","Via Lampara","Via Lindo","Via Lombardi","Via Luis Ct",
            "Via Macduffee Rd NE","Via Mariposa","Via Mariposa W","Via Marisol","Via Maya","Via Mazarron St",
            "Via Mencia","Via Mesita","Via Mirage","Via Montanez","Via Montecito","Via Montigo","Via Naranja",
            "Via Nautila","Via Navarra","Via Nuevo","Via Pacifica","Via Palermo","Via Palestha","Via Paloma",
            "Via Paradiso St","Via Parte","Via Pequena","Via Perdiz","Via Petalos","Via Plata","Via Posada Street",
            "Via Quedo","Via Quivera","Via Rancho Rd","Via Ravello","Via Ravenna","Via Riata St","Via Ridge",
            "Via Robles Ln","Via Roma Pl","Via Romaya","Via Rosado","Via Rueda","Via Salerno","Via San Marino",
            "Via Santee","Via Santo Tomas","Via Semi","Via Serena","Via Sevilla","Via Si","Via Sonora","Via Sonrisa",
            "Via Sorrento","Via Sur Ave","Via Susana","Via Terracina","Via Terrado","Via Terreno","Via Valeroso",
            "Via Valverde","Via Velasques","Via Veneto","Via Venezia","Via Verano","Via Viento","Via Visalia",
            "Via Vista Rd","Via Vita","Via de Gavilan","Via de Las Montanas","Via de Luccia","Via de Mercados",
            "Via de Olivia","Via de Pescara","Via de Suenos","Via de la Rosa","Via del Aquacate","Via del Caballo",
            "Via del Campo","Via del Cinco Rd","Via del Corvo","Via del Palma","Via del Prado","Via del Rey",
            "Via del Sol Ave","Via la Contera Dr","Via la Estrella","Via la Gitana","Via la Merced",
            "Via la Naranja","Vialpando St","Viamede Crescent","Vianey Rd","Vibernum Ter","Vibora Rd",
            "Viburnum Circle","Viburnum Ct","Vice Ln","Vicente St","Viceroy Ln","Viceroy Rd","Vick Dr","Vick Park B Rd",
            "Vickers Dr","Vickers Road","Vicki Dr","Vicki Run","Vickie Ave","Vicks Ln","Vicks Pl","Vicksburg Ave",
            "Vicksburg Cir SW","Vicross Road","Victor Ave","Victor Avenue","Victor Byrd Rd","Victor Dr",
            "Victor Egypt Road","Victor Emmanuel Avenue","Victor Pl","Victor Rd","Victor Road","Victor St",
            "Victora Ln","Victoria Ave","Victoria Avenue","Victoria Avenue N","Victoria Avenue S",
            "Victoria Cir","Victoria Court","Victoria Crescent","Victoria Ct","Victoria Dr","Victoria Ln",
            "Victoria Mine Back Rd","Victoria Park Avenue","Victoria Park Crescent - Morrisburg",
            "Victoria Pl","Victoria Rd","Victoria Road","Victoria St","Victoria St N","Victoria Street",
            "Victoria Street Lane","Victoria Street N","Victoria Terrace","Victoria Way","Victory Ave",
            "Victory Avenue","Victory Blvd","Victory Crescent","Victory Ct","Victory Dr","Victory Drive",
            "Victory Grove Rd","Victory Hwy","Victory Ln","Victory Rd","Victory Road","Victory St","Vida Ct",
            "Vidal Dr","Vidy Dr","Viebrock Way","Viejas Creek Trl","Viejas View Ln","Viejo Dr","Viella Street",
            "Vienna Ave","Vienna Ct","Vienna Hills Rd","Vienna Road","Viento Ct","Viento del Montagna Ave",
            "View","View Ave","View Crest","View Crest Circle","View Dr","View Heights Way","View Park Dr",
            "View Pl","View Pointe","View Ridge Dr","View St","View Street","Viewesta Rd","Viewland Rd",
            "Viewmont Ter","Viewmount Avenue","Viewpoint Ct","Viewpoint Dr","Viewpointe Blvd","Viewridge Dr",
            "Vigil Ave","Viking Ct","Viking Dr","Viking Drive","Viking Rd","Viking Ter","Viking Trl","Viking Way",
            "Vilanella Rd NE","Villa Alta Way","Villa Alturas","Villa Ave","Villa Avenue","Villa Capri Ct",
            "Villa Cir","Villa Ct","Villa Dr","Villa Drive","Villa Drive - Williamsburg","Villa Knoll Ct",
            "Villa Laguna","Villa Linda Way","Villa Mallorca Pl","Villa Maria Ct","Villa Mora Ave",
            "Villa Nova Street","Villa Park St","Villa Pl","Villa Road","Villa Sedona Way","Villa St",
            "Villa Walsher Ln","Villa Way","Villa at the Woods","Villa del Mar Rd","Village 24","Village 25",
            "Village 3","Village 33","Village 34","Village 39","Village 44","Village 9","Village Ave","Village Blvd",
            "Village Blvd N","Village Brook Ln","Village Brook Way","Village Cir","Village Cir E",
            "Village Ct","Village Dr","Village Dr E","Village Dr W","Village Drive","Village Dump Rd",
            "Village Estate Rd","Village Estates Trl","Village Falls Way","Village Gate Ct","Village Glen Ct",
            "Village Green Blvd","Village Green Cir","Village Green Ct","Village Green Drive","Village Green Ln",
            "Village Green Moble Home Park","Village Grn","Village Hill Road","Village Inn Ln",
            "Village Lane","Village Ln","Village Ml","Village Parkway","Village Pky","Village Plz","Village Point Ln",
            "Village Rd","Village Rd E","Village Rd W","Village Road North","Village Sq","Village Station Cir",
            "Village Street","Village Trl","Village Turn","Village View Rd","Village Walk Cir","Village Way",
            "Village Woods Dr","Villages Drive","Villagewood Manor Townhouses","Villamar Way","Villanelle Rd",
            "Villanova Ct","Villanova Dr","Villanova St","Villanueva St","Villareal Dr","Villas Ct","Villas Dr",
            "Villena","Viller's Street","Villiage Oaks","Villines Pl","Vimy Ridge Road","Vince Tofany Blvd",
            "Vincent Circle","Vincent Dr","Vincent Fire Road","Vincent Leavitt Way","Vincent Ln","Vincent St",
            "Vincent Street","Vincent Way","Vincentown Columbus Rd","Vincenzo Ct","Vindale Rd","Vine Ave",
            "Vine Cir","Vine Cliff Boulevard","Vine Ct","Vine Dr","Vine Lane","Vine Pl","Vine St","Vine Street",
            "Vine Street Expy","Vineland Ave","Vineland Avenue","Vinewood Cv","Vinewood Ln","Viney Grove Rd",
            "Vineyard Ave","Vineyard Dr","Vineyard Easement","Vineyard Ln","Vineyard Pl","Vineyard Rd",
            "Vineyard Ridge Court NE","Vineyard Way","Vining Rd","Vinmar Ct","Vinson Cv","Vintage Dr",
            "Vintage Dr NE","Vintage Pl","Vintage Rd","Vintage Way","Vintner Dr NE","Vinton Avenue","Vinton Rd",
            "Vinton Street","Viola Ct","Viola Dr","Viola Ln","Viola Way","Violet Ave","Violet Bouquet Way",
            "Violet Ct","Violet Dr","Violet Hall Road","Violet Ln","Violet St","Violet Trl","Violeta Ln",
            "Vip Rd","Viper Rd","Virden St","Virenius Rd","Vireo Dr","Virgie St","Virgil Ave","Virgil Ct","Virgil Pl",
            "Virgil St","Virginia Ave","Virginia Ave S","Virginia Avenue","Virginia Ct","Virginia Dr",
            "Virginia Lake Rd","Virginia Lakes Rd","Virginia Ln","Virginia Oaks","Virginia Park Rd",
            "Virginia Pl","Virginia Rd","Virginia Road","Virginia St","Virginia Way","Virgo Dr","Visalia Rd",
            "Visalia St","Viscaino Way","Visconti Way","Vision Drive","Vision St","Vissaraga Rd","Vista",
            "Vista Alta Dr","Vista Ave","Vista Boulevard","Vista Cir","Vista Court","Vista Ct","Vista Dr",
            "Vista Dr W","Vista Encantada","Vista Glen St","Vista Grande","Vista Grande Cir","Vista Grande Dr",
            "Vista Grande St","Vista Grande Way","Vista Grove Cir","Vista Hill","Vista Huerto","Vista Humber Drive",
            "Vista Knolls Dr","Vista Lago Tr","Vista Ln","Vista Lomas Dr","Vista Luguna Dr","Vista Manzano",
            "Vista Panorama","Vista Parque Ct","Vista Paseador","Vista Pines Ln","Vista Pl","Vista Place",
            "Vista Rambia","Vista Rd","Vista Ridge Dr","Vista Rio Rd","Vista Robles","Vista Royal","Vista Sandia Rd",
            "Vista Ter","Vista Verde Ct","Vista Vereda","Vista View Dr","Vista Viva Lane SW","Vista Way",
            "Vista de Las Cruces Rd","Vista de Las Ondas","Vista del Cerro NE","Vista del Huerta Dr",
            "Vista del Monte Ave","Vista del Monte Pl","Vista del Oro Pl","Vista del Rio","Vista del Sol",
            "Vista del Sur Way","Vista del Valle","Vista del Valle Dr","Vista el Rincon","Vistameadow Ct",
            "Vistamont Cir N","Vistanna Dr","Vistawood Ct","Vistula Path","Vito Court","Vittori Ln","Vitus Ln",
            "Vivian Ave","Vivian Creek Road","Vivian Ct","Vivian Ln","Vivian Plz","Vivian Road","Vivian St",
            "Vivian Ter","Vivienne Ct","Viviney St","Vivio Rd","Vladic Ln","Vogel Ave","Vohs Pl","Voight Rd",
            "Voisin Ct","Voit Ave","Volano Rd","Volante Rd","Volcanoville Rd","Volga Avenue","Volk Ave",
            "Volker Ln","Vollar Dr","Vollick's Road","Vollmer Peak Trail","Volt Pl","Volunteer St NE",
            "Volvo Ct","Vomac Rd","Vomel Dr","Von Braun Ave","Von Steuben Ct","Voorhees Ave","Voorhees Pl",
            "Voorhees St","Voorhess Ct","Voorhies Ave","Voorhis Pl","Voris St","Vosburgh Dr","Vose St","Votaw Dr",
            "Voting House Rd","Voyager St","Vreeland Ave","Vreeland Ter","Vroman Hill Rd","Vtn Rd","Vuelta Pl",
            "Vultee Dr","Vutaw Ln","W 10 Mile Rd","W 102nd St","W 103rd St","W 105th St","W 107th St","W 10th",
            "W 10th Ave","W 10th St","W 118th Pl","W 119th Pl","W 119th St","W 11th Pl","W 11th St","W 12 Mile Rd",
            "W 120th St","W 120th Ter","W 123rd St","W 125th St","W 12th Pl","W 12th St","W 130th St","W 131st St",
            "W 132nd St","W 133rd St","W 135th St","W 136th St","W 137th St","W 13th Ave","W 13th Pl","W 13th St",
            "W 144th Ave","W 145th St","W 147th St","W 149th St","W 14th Ave","W 14th St","W 150th St","W 154th St",
            "W 15th St","W 162nd St","W 164th St","W 166th St","W 16th Pl","W 16th St","W 17 Mile Rd","W 170th St",
            "W 172nd St","W 175th St","W 176th St","W 179th St","W 17th Pl","W 180th St","W 184th St","W 18th Ave",
            "W 18th Pl","W 18th St","W 19 Mile Rd","W 19th Pl","W 19th St","W 1st Ave","W 1st St","W 2 Mile Rd",
            "W 206th St","W 207th St","W 209th St","W 20th Ave","W 20th Ln","W 20th St","W 214th St","W 21st Ln",
            "W 21st St","W 222nd St","W 223rd St","W 224th St","W 226th St","W 229th St","W 22nd St","W 23rd St",
            "W 240th St","W 242nd St","W 249th St","W 24th Pl","W 24th St","W 254th St","W 25th Pl","W 25th St",
            "W 26th Ave","W 26th Pl","W 26th St","W 27th Ln","W 27th St","W 28th Dr","W 28th St","W 29th St",
            "W 2nd Ave","W 2nd Ct","W 2nd Pl","W 2nd St","W 31st Ave","W 31st St","W 32nd Ave","W 32nd Pl",
            "W 32nd St","W 3578 Rd","W 35th St","W 36th St","W 37th Pl","W 37th St","W 38th St","W 39th St",
            "W 3rd Ave","W 3rd Extended","W 3rd St","W 400 South","W 41st St","W 42nd Pl","W 42nd St","W 43rd St",
            "W 45th St","W 46th St","W 47th St","W 48 1/2 Rd","W 4th","W 4th Ave","W 4th St","W 50th St","W 51st St",
            "W 52nd St","W 53rd St","W 58th St","W 5th Ave","W 5th St","W 61st St","W 625 N","W 64th St","W 66th Pl",
            "W 67th Way","W 69th St","W 6th","W 6th St","W 74th Pl","W 74th St","W 760 N","W 77th Ave","W 77th St",
            "W 79th St","W 7st St","W 7th Ave","W 7th Pl","W 7th St","W 8 Mile Rd","W 800 N","W 82nd St","W 83rd Pl",
            "W 84th St","W 89th St","W 8th Ave","W 8th St","W 90th St","W 99th St","W 9th Ave","W 9th St","W A Barr Rd",
            "W A St","W Abbottsford Ave","W Abo Loop","W Acacia Blvd","W Adams","W Adams Ave","W Adams St",
            "W Adelaide Way","W Adkisson St","W Agate Ave","W Airdrie St","W Alamar Ln","W Alamos Ave",
            "W Albacore Way","W Albanus St","W Albany St","W Alcott Ave","W Alejo Rd","W Alexander Rd",
            "W Alger Smith Rd","W Alice Ave","W Alice St","W Alila Ave","W Allen St","W Alma","W Almirnte Dr",
            "W Alomar Ave","W Altadena Ave","W Alvarado Rd","W Amelia Ave","W Amelia Dr","W Amerige Ave",
            "W Anacapa Cir","W Anderson Trl","W Andrews Ave","W Anita Ave","W Anita Dr","W Ann Arbor Rd",
            "W Ann St","W Annadale Ave","W Antonio Dr","W Anway Pl","W Applewood St","W Arbor St","W Arivaca Rd",
            "W Arizona St","W Armstrong Way","W Army St","W Arnold Dr","W Arrow Hwy","W Ash Ave","W Ash St",
            "W Ashcroft Ave","W Ashdale St","W Atlantic Ave","W Atlantic St","W Auburn Dr","W Augusta Ave",
            "W Aurora Ct","W Avalon Dr","W Avenida Alessandro","W Avenue 140th","W Avenue 40","W Avenue A",
            "W Avenue B-4","W Avenue C-12","W Avenue D11","W Avenue F-8","W Avenue G","W Avenue L-3",
            "W Avenue L6","W Averill St","W Avon Ave","W Azalea Dr","W Azalea Ln","W B McCullar Rd","W B St",
            "W Baatz Rd","W Baker Ave","W Baltimore St","W Bangs Ave","W Bank Rd","W Barbara Ave","W Barrel Cactus Ln",
            "W Barrow Dr","W Barstow Ave","W Baseline Rd","W Bawkey Rd","W Bay Ave","W Bay Point Rd",
            "W Bay Shore Dr","W Bay Way","W Baylor Dr","W Bayview Ave","W Bayview Dr","W Beach Ave","W Beach Dr",
            "W Beacon Rd","W Beaman Ct","W Beard Ln","W Beardsley Dr","W Beaver Pond Rd","W Becker Ln",
            "W Bedford Ave","W Beech Ave","W Beechwood Dr","W Bell Dr","W Belle St","W Belleview Ct",
            "W Belleview St","W Belmont Ave","W Benson Ave","W Bent Oak Cir NW","W Benton Dr","W Bergon Dr",
            "W Berkley St","W Bernard Ave","W Bethany","W Bingham St","W Birch Ave","W Birch Ct","W Birch St",
            "W Birchwood Ave","W Birchwood Dr","W Bishop Dr","W Black Ln","W Blair Tract","W Bland St",
            "W Blood Rd","W Bluffview Dr","W Bonita Dr","W Booth St","W Bord Ranch Rd","W Boston Pl",
            "W Boston St","W Boulevard Pky","W Bowen Rd","W Br","W Braden Rd","W Bradford Pl","W Brewer Ave",
            "W Briar Ave","W Briardale Ave","W Bridge St","W Brier Cir","W Brill St","W Bristol St","W Britton Dr",
            "W Broad St","W Broadway","W Brockbank St","W Brook Dr","W Brookhaven Rd","W Brookline Dr",
            "W Brooks Ave","W Brooks St","W Brookthorpe Cir","W Broome St","W Brown Ave","W Brown St",
            "W Browning Rd","W Brush Creek Loop","W Buchanan St","W Buck Rd","W Buckskin Frank Rd",
            "W Buckskin Trl","W Bud Rd","W Buena Vista Ave","W Bungalow Ct","W Burnside Ave","W Burnt Dam Rd",
            "W Burr Oak","W Burt Lake Rd","W Bush St","W Butler St","W Byfield Dr","W C C","W C St","W Cadillac Rd",
            "W Cain St","W Caldwell Ave","W Calico Pl","W California","W California Ct","W Calle Alvord",
            "W Calle Amadeo","W Calle Carmela","W Calle Lago","W Calle Montoya","W Calle Montuoso",
            "W Calle Poquito","W Cambridge Ave","W Cambridge Dr","W Cameo St","W Camila Rd","W Camino Alba",
            "W Camino Granada","W Camino de Urania","W Canal Dr","W Canary Way","W Candlelight Dr",
            "W Canyon Creek Dr","W Canyon Dr","W Capistrano Ave","W Capitol Expy","W Caribbean Ln",
            "W Carlton Pl","W Carmellia Ave","W Carnoustie Rd","W Carol Ave","W Carolina Ave","W Carpenter Hill Rd",
            "W Carpenter Rd","W Carriage Rd","W Carson Dr","W Carter Rd","W Cartier Ave","W Casgrove Rd",
            "W Cass City Rd","W Cassim Ln","W Catalonia Dr","W Catalpa St","W Cathy Cir","W Cayuga St",
            "W Cedar Ave","W Cedar St","W Centennial Dr","W Center Rd","W Center St","W Central Ave",
            "W Central St","W Centre Ct","W Cerini Ave","W Chambers Avenue","W Channel St","W Chapel Dr",
            "W Chapel Fork Rd","W Charleston Ave","W Chavez Ave","W Cheery Lynn Rd","W Cheney Woods Tr",
            "W Chennault Ave","W Cherry Aly","W Cherry Ave","W Cherry Ct","W Cherry St","W Cheryl Dr",
            "W Cheryll Ave","W Chester Pike","W Chestnut Ave","W Chestnut St","W Chicago Ave","W Chicago St",
            "W Chippewa St","W Cholla Estate Dr","W Christoffersen Pky","W Christopher Dr","W Church Ct",
            "W Church Rd","W Church St","W Circle Dr","W Citrine Pl","W Citrus Way","W City Ave","W Clarion Dr",
            "W Clark Rd","W Clark St","W Clarkedale Rd","W Clarkson Ave","W Clarkstown Rd","W Clary St E",
            "W Clay St","W Clayton Ave","W Clearfield Rd","W Clearfield St","W Cleo Ave","W Cleveland Ave",
            "W Cleveland St","W Cliff Rd","W Clinton Ave","W Clinton St","W Cloverdale Ave","W Club Dr",
            "W Co 12 5/10 St","W Coast Dr","W Coffee St","W Coldwater Brook Rd","W Coleman Rd","W Coler St",
            "W College Ave","W College Pky","W Collingswood Ave","W Collins Rd","W Cologne-Port Republic Rd",
            "W Colona St","W Columbia Ave","W Columbia St","W Comanche Dr","W Commerce Ave","W Commerce St",
            "W Commercial Ave","W Commodore Blvd","W Comstock Dr","W Concord St","W Concourse","W Congress St",
            "W Conklin Ave","W Conn","W Coogan Dr","W Cool Water","W Coolidge St","W Cooper Ave","W Cooper St",
            "W Cornell St","W Corning St","W Cornwall St","W Coronado Rd","W Cortez St","W Corydon St",
            "W Cottage Ln","W Cotton Ln","W Cougar Ave","W Coulter St","W Country Ave","W Country Club Rd",
            "W Country Ln","W County Line Rd","W County Road 1068","W County Road 1212","W County Road 1276",
            "W County Road 314","W County Road 330","W County Road 34","W County Road 368","W County Road 410",
            "W County Road 458","W County Road 498","W County Road 506","W County Road 602","W County Road 634",
            "W County Road 650","W County Road 828","W Court Ave","W Courtland St","W Cowles St","W Cram Ave",
            "W Cresse Ave","W Cressey St","W Crocus Rd","W Cromwell Ave","W Cross St","W Crum Creek Dr",
            "W Crystal Ln","W Crystal View Ct","W Curlis Ave","W Curtis Ranch Rd","W Cutler Ct","W Cypress Ave",
            "W Cypress Rd","W Cypress St","W D Ln","W Daffodil Ln","W Dale Cir","W Dale St","W Dallas Ave",
            "W Damsen Ave","W Dana St","W Dangeau Ave","W Dannenberg Rd","W Dartmouth Ave","W Date Ave",
            "W Davis Ct","W Davis Ln","W Davis St","W Dawnview Dr","W Decatur Ave","W Delason Ave","W Delaware Ave",
            "W Delfina Dr","W Delhi Rd","W Dellwood Pky","W Denise Ct","W Denton Ln","W Deodar Dr","W Desert Grass Ln",
            "W Desert Inn Dr","W Desert Inn Rd","W Detroit St","W Devils Kitchen Rd","W Devon Dr",
            "W Diablo Dr","W Dickens St","W Dison Ave","W Dodd Rd","W Doe Ave","W Dogwood St","W Dolbrook Way",
            "W Dolphin Way","W Doren Ter","W Doris Dr","W Dove Rd","W Dovewood Ln","W Dowlen Rd","W Drake Cir",
            "W Dressel Trl","W Dublin St","W Duncannon Ave","W Dune Dr","W Eagle St","W Earhart Way",
            "W Earl Ave","W Earl Dr S","W Earlham Ter","W Earll Dr","W Eaton Hwy","W Echo Ln","W Echo Valley Rd",
            "W Eddy School Rd","W Edge Water Dr","W Edgewood Ave","W Edgewood Dr","W Efken","W Eggleston St",
            "W El Sol","W Elderberry St","W Eldorado Ln","W Elgenia Ave","W Elgin St","W Elkhorn Boulevard",
            "W Elko St","W Ellery Ave","W Elm Ave","W Elm St","W Elmhurst Ave","W Elro Dr","W Emory Rd",
            "W Enchantment Ln","W End Ave","W End Ln","W Esperanza Dr","W Estes Way","W Estrella Dr",
            "W Eugie Ave","W Evergreen Ct","W Evergreen Rd","W Excelsior Ave","W Fairgrove Rd","W Fairview Ct",
            "W Falling Leaf Dr SE","W Fancy Tract Rd","W Faught Rd","W Faunce Landing Rd","W Fawn St",
            "W Fay Ave","W Fedora Ave","W Feemster Ct","W Fern St","W Fernwood Beach","W Ferris St","W Fetzer Rd",
            "W Filer St","W Fillmore Ave","W Fir Ave","W Firebaugh Ave","W Firth St","W Fisher Ave","W Fisher Lake Rd",
            "W Flamingo Rd","W Fletcher St","W Flint St","W Flipper St","W Flora St","W Floyd St","W Fontana Cir",
            "W Foothill Blvd","W Forbes Rd","W Forest Ave","W Forest Dr","W Fountain Way","W Four Feathers Ln",
            "W Fourway Dr","W Franciscan Trl","W Frank Ave","W Franklin Ave","W Franklin St","W Frederick St",
            "W Freeway Ln","W Fremont Ave","W Fresno St","W Frias Ave","W Front","W Front Cir","W Front St",
            "W Frontage Rd","W G St","W Gage Ave","W Galaxy Ave","W Gamble Dr","W Gamble St","W Garfield Ave",
            "W Garland Ave","W Garvey Ave S","W Gary Ave","W Geeter Rd","W Gelding Dr","W Gemstone Dr",
            "W Genematas Dr","W Genesee St","W Genesee Street","W Genesee Tpke","W Genesee Turnpike",
            "W George St","W Georgia Ave","W Gibbs St","W Gilman St","W Girard Ave","W Girard Blvd","W Glade Ln",
            "W Gladys Ave","W Glencoe St","W Glentana St","W Glenwood Ave","W Glenwood St","W Golden Ln",
            "W Goodemote Rd","W Grampion Cir SW","W Grand Ave","W Grand River Ave","W Grand St","W Grandview Rd",
            "W Granger Rd","W Grant Ave","W Grant Line Rd","W Grant Rd","W Grant St","W Grape St","W Green Hill Rd",
            "W Green Rd","W Green St","W Greenburg St","W Greenlee St","W Greenway Rd","W Greenwood Ave",
            "W Griffin St","W Griggs Ave","W Grove St","W Gubler Ave","W Gum St","W Guy Rd","W H St","W Hacienda Ave",
            "W Haleh Ave","W Hall Ave","W Hall Rd","W Hammer Ln","W Hammond Ave","W Hampden Ave","W Hampton Way",
            "W Hansberry St","W Harding Ave","W Harding Rd","W Harkins Ct","W Harold Ct","W Harrison Ave",
            "W Harrison St","W Harvard Pl","W Harvey St","W Harwood Rd","W Hatcher Rd","W Hawthorne St",
            "W Hays St","W Hayward Ave","W Hayward Rd","W Hazel St","W Heart Lake Dr","W Heather Lynn Ln",
            "W Heiress Lake Rd","W Helms Mnr","W Hemlock St","W Henderson Ave","W Henderson St","W Hendrickson Ave",
            "W Henry St","W Herbison Rd","W Hereford Ave","W Herndon Ave","W Herrick Ave","W Hidalgo Ave",
            "W Hidden Ln","W Higgins St","W High Ave","W High St","W Highland Ave","W Highland Ct","W Highline Canal St",
            "W Hill Dr","W Hill Ln","W Hill Rd","W Hill St","W Hillcrest Dr","W Hillsdale Dr","W Hillside Ct",
            "W Hillside Dr","W Hilton St","W Hinds Ave","W Hoag Rd","W Holladay St","W Holland Ave","W Hollis St",
            "W Holly Ave","W Holly Oak Dr","W Holly St","W Hollywood Ave","W Hollywood Ct","W Holmes Rd",
            "W Home St","W Hopi St","W Hopkins St","W Hopkins Vista Dr","W Hoppe Rd","W Horn Lake Rd",
            "W Horton St","W Houchin Way","W Howell Rd","W Hubbell Hill Rd","W Hudson Dr","W Hughes St",
            "W Humboldt St","W Hunnington Dr","W Hunt Rd","W Huntington Dr","W Huron St","W I St","W Ian Pl",
            "W Idahome St","W Ideal Aly","W Iguana","W Imlay City Rd","W Imuris Pl","W Ina Rd","W Indianapolis Ave",
            "W Industry Way","W Inman Ave","W Inyokern Rd","W Iris Ave","W Irma Ln","W Iron Kettle St",
            "W Ironwood Dr","W Irvin","W Island Rd","W Island St","W Ithaca Rd","W Ivanhoe Ct","W Ivesbrook St",
            "W J St","W Jacinto View Rd","W Jackson Blvd","W Jackson St","W James St","W Jamet St","W Jasper St",
            "W Jeffrey St","W Jenan Dr","W Jenny Lin Rd","W Jersey Ave","W Jno C McHaney Dr","W Joffre Ave",
            "W John Ronza Cir","W Johnson Ave","W Johnson St","W Joshua Ln","W Judith Dr","W Judson St",
            "W Juniper Shadows Way","W Kalama Cir","W Kamm Ave","W Kaylynn Dr","W Keats Ave","W Keller Dr",
            "W Kelley","W Kelso Rd","W Kemp Ave","W Ken D Dr","W Kendall Ave","W Kennedy Dr","W Kent Rd",
            "W Kentucky Ave","W Kerbey Ave","W Kibler Rd","W Kilarea Ave","W King St","W Kingfisher Way",
            "W Kings Hwy","W Kingwood Ave","W Kinney St","W Kipp Ave","W Knight Ave","W L Rider St","W L St",
            "W Lafayette Ave","W Lafayette St","W Laguna Ave","W Lake Dr","W Lake Mead Blvd","W Lake Montcalm Rd",
            "W Lake Rd","W Lake Road","W Lakeshore Dr","W Lakeview Dr","W Lakewood Dr","W Lamar Rd","W Land Park Dr",
            "W Lark Ave","W Larson Ln","W Las Positas Blvd","W Laura St","W Laurel Ave","W Laurel Ln",
            "W Laurel St","W Lavenia Ave","W Leamy Ave","W Lee Ave","W Lee St","W Lelia St","W Lemon St",
            "W Leonard St","W Lerdo Hwy","W Leslie Ct","W Leslie Ln","W Leucadia Blvd","W Levi Ave","W Levi Rd",
            "W Lewis Ave","W Lexington Ave","W Liberty Rd","W Liberty St","W Libra Dr","W Lilac Rd","W Lincoln Cir",
            "W Lincoln Rd","W Linden Ave","W Linden St","W Lindner Ave","W Line Rd","W Line Road","W Linne Rd",
            "W Lippincott St","W Lisa Ln","W Little League Dr","W Lloyd Ave","W Ln","W Locust St","W Lois Dr",
            "W Lone Cactus Dr","W Long Creek Pl","W Long Lake Rd","W Longport Ave","W Lookout Ave",
            "W Lopez St","W Loquat Ave","W Los Altos Ave","W Los Lagos Vista","W Lotus Blossom Ct",
            "W Louis Ave","W Louisiana St","W Lower Buckeye Rd","W Lucero Ave","W Luke Ave","W Lum Wash Ct",
            "W Lycoming St","W Lynhurst Ave","W Lynn Rd","W M 28","W Madison Ave","W Madrid Rd","W Magill Ave",
            "W Magnolia Ave","W Mahone Dr","W Main","W Main Ave","W Main Rd","W Main St","W Main Street",
            "W Malloryville Rd","W Mance Ave","W Manheim St","W Mann Ave","W Manning Ave","W Manor Ave",
            "W Manor Way","W Mantua Ave","W Maple","W Maple Ave","W Maplemere Rd","W Maplewood Dr","W Maplewood Mal",
            "W Marigold Ln","W Marine Way","W Mariposa St","W Market St","W Markham St","W Marr St","W Martha Ct",
            "W Martin Ave","W Martinez Ln","W Mary Ave","W Maryland Ave","W Mason St","W Massachusetts Ave",
            "W Master St","W May St","W Mayfair St","W Mayo Pl","W Mc Gee Rd","W Mc Kamey St","W McCourt St",
            "W McKeen St","W McNeal St","W Meadow Ln","W Medina Ave","W Medlock Ave","W Meinert Park Rd",
            "W Memory Ln","W Menlo Ave","W Mentor St","W Merced St","W Merchant St","W Merion Ave","W Merritt St",
            "W Mesa Ave","W Mesa Verde","W Mesa Verde Ln","W Mesquite Ave","W Michigan Ave","W Middle Ave",
            "W Mill St","W Millcreek Rd","W Miller Rd","W Mimosa Dr","W Mineo Ave","W Minford St","W Mirasol Dr",
            "W Mission Ln","W Missouri Ave","W Mitchell Rd","W Moapa St","W Moberly Ave","W Moccasin Ave",
            "W Mohawk St","W Moltke St","W Momote Dr","W Mongaup Trl","W Monroe","W Monroe St","W Monsoon Trl",
            "W Montana St","W Monte Vista Dr","W Montebello Ave","W Montecito Ave","W Montego Ln",
            "W Monterey Ave","W Monterey Ln","W Monterey St","W Montezuma Ave","W Montgomery Ave",
            "W Moonsong Pl","W Moreland Street","W Morris Ave","W Morrow St","W Morton","W Moss Mill Rd",
            "W Moss St","W Mount Maria Rd","W Mount Vernon Ave","W Mravlag Pl","W Mulberry Aly","W Mulberry Dr",
            "W Murray Creek Rd","W Myrtle Ave","W N E College Road","W Najo Ln","W Nancy Ave","W Naples Dr",
            "W Narberth Ter","W Nashua Pl","W Natchez Point","W Natoma Dr","W Nelson Pl","W Nelson St",
            "W Nevada St","W Nevin Rd","W Nevso Dr","W New Jersey Ave","W New York Ave","W Newell Ave",
            "W Newgrove Ave","W Nicholas Dr","W Nickel Ave","W Nickel St","W Nicklaus Dr","W Noble Ave",
            "W Noble Avenue","W North Shore Dr","W North St","W North Way","W Northend Ave","W Northern Ave",
            "W Northfield Rd","W Northview Ave","W Noyes Blvd","W Nugget St","W Nutmeg St","W Nyack Rd",
            "W Nyack Way","W Nye Ln","W Oak Ave","W Oak Ct","W Oak Grove Rd","W Oak St","W Oak View Dr",
            "W Oakland Ave","W Occupado Dr","W Ocean Dr","W Oceanview Dr","W Ocotillo Ln","W Ogden","W Ogden Rd",
            "W Ohio Ave","W Ohio St","W Oklahoma St","W Oldam Rd","W Oldfield St","W Olive Ave","W Olla Cir",
            "W Olson Ave","W Orange Ave","W Orchard St","W Orchid Ln","W Orion St","W Orr St","W Osage Ave",
            "W Oswego Ave","W Outer Dr","W Oviatt Rd","W Oxford St","W Pablo Dr","W Pacific Ave","W Packwood Ave",
            "W Paige Ave","W Paisano Dr","W Paisano Dr; United States Highway 85","W Palace Ave",
            "W Palm Ave","W Palm St","W Palmer Ave","W Palmer Ct","W Palo Alto Ave","W Panoche Rd","W Papeete St",
            "W Parade Ave","W Parade St","W Paradise Dr","W Park Ave","W Park Dr","W Park Ln","W Park Rd",
            "W Park Sq","W Park St","W Parkcrest","W Parker Dr","W Parkview Ct","W Parkway Dr","W Pasadena Ave",
            "W Pasquale St","W Passaic St","W Patricia Ann Ln","W Patrick Ct","W Paul Ave","W Peach St",
            "W Pearl Ave","W Pearl Rd","W Pebble Rd","W Pecan Ct","W Pecan St","W Pelican Ct","W Pembrey Dr",
            "W Pennington Dr","W Pennslvania Ave","W Pennsylvania Ct","W Pennwood Ave","W Perch Ave",
            "W Perry St","W Phelps Rd","W Phoenix Ave","W Pickerel Lake Rd","W Pico Rd","W Pierce Rd",
            "W Pike Lake Ln","W Pine","W Pine Ave","W Pine Haven Dr","W Pine St","W Pinehurst Dr","W Pinewood Dr",
            "W Pinewood Ln","W Pinnacle Peak Rd","W Pioneer Street","W Placita Malaga","W Placita Rio Pecos",
            "W Placita del Comenzar","W Placitado Los Vientos","W Pleasant St","W Poinsettia Dr",
            "W Point Ave","W Pointe Rd","W Porter Ave","W Posey St","W Prescott Rd","W Preston Ave","W Preston Rd",
            "W Prickly Pear Ln","W Princeton Cir","W Princeton St","W Prospect Ave","W Prossick Rd",
            "W Pryor Ct","W Pueblo St","W Purdue Ave","W Pursel Ln","W Putnam Ave","W Quackenbush Ave",
            "W Queen Ln","W Quincy Ave","W R Ln","W Radigan Ave","W Railroad Ave","W Railroad St","W Railway",
            "W Rainbow Ridge Ct","W Raines Rd","W Ramon Rd","W Ramp","W Ranch Rd","W Ranchito Verde",
            "W Randolph Ave","W Random Way","W Rayburn Rd","W Raymon Ave","W Red Coach Ave","W Redcut",
            "W Redfield Rd","W Redman Ave","W Rednord Dr","W Redwood Ave","W Regena Ave","W Renfroe Rd",
            "W Resthaven Pl","W Reynard Ln","W Reynolds Rd","W Rialto Ave","W Rich St","W Richardson Ave",
            "W Ridge Dr","W Rindge Rd","W Ripple Rd","W River Ave","W River Edge Ave","W River Oak Ave",
            "W River Pky","W River Rd","W River St","W River Styx Rd","W River Vista Dr","W Rivers End Dr",
            "W Rivershore Dr","W Riverside Ave","W Riverside Ct","W Riverside Dr","W Riverview Dr",
            "W Road R","W Road Rw","W Robert Ave","W Roberts Ave","W Robin Rd","W Robindale St","W Robinson Ave",
            "W Robinson St","W Robinwood Ln","W Rochester Ave","W Rockrose Way","W Rodgers Ave","W Roma Ave",
            "W Roma Ct","W Romany Rd","W Romley Ave","W Rudolf Dr","W Rundle Ave","W Running Brook Ln",
            "W Runyon St","W Rush Ave","W Russell St","W Rusty Nail Ln","W Ry St","W Ryan Ave","W Sable Ct",
            "W Saddle Club","W Saddle Horn Dr","W Saddle River Rd","W Sage Dr","W Saginaw Ave","W Saginaw Rd",
            "W Saginaw Way","W Sago Palm","W Saguaro St","W Saint Clair St","W Saint Louis Ave","W Salem Rd",
            "W Samalayuca Dr","W Sample Ave","W San Bruno Ave","W San Ignacio","W San Joaquin Ranch Rd",
            "W San Joaquin St","W San Jose Ave","W San Lucia Ave","W Sand Creek Ave","W Sand Dune Ln",
            "W Sandpiper Way","W Sands Ct","W Sandtown Rd SW","W Santa Ana Ave","W Santa Fe St","W Santa Inez Ave",
            "W Santiago Dr","W Schiller St","W School St","W Scott Ave","W Sedgley Ave","W Seldon Ln",
            "W Seltzer St","W Seneca St","W Serene Ave","W Seymour Dr","W Seymour Street","W Sharon Ave",
            "W Shasta Ave","W Shawnee Dr","W Shelby Dr","W Shelton Ave","W Shepard St","W Sherman Ave",
            "W Sherman Island Rd","W Sherman Lake Dr","W Sherman St","W Sherman Street","W Sherwood Dr",
            "W Sherwood Rd","W Shields Rd","W Shirley Ct","W Shore Ave","W Shore Dr","W Shore Manor Rd",
            "W Shore Rd","W Side Ave","W Side Lake Rd","W Side Rd","W Sierra Ave","W Sierra Dr","W Silander",
            "W Silver Lake Loop Rd","W Silver Lake Rd","W Skipper Rd","W Smith St","W Snell St","W Somerdale Rd",
            "W Somerset St","W Sonora Ave","W South River Rd","W South St","W Southbrooke Cir","W Southgate Ave",
            "W Southwood Dr","W Splendor Dr","W Spoonbill Dr","W Spring Ave","W Spring Oak Cir","W Spring St",
            "W Sproul Rd","W Spruce Ave","W Spruce St","W Star St","W Starburst Ct","W State Line Rd",
            "W State Route 82","W State St","W Stephen Ave","W Sterner St","W Stetson Ave","W Stevens Ave",
            "W Stewart St","W Stiles St","W Stormer Rd","W Straford Dr","W Straits Ave","W Stuart Ave",
            "W Substation Ln","W Summerlin Pky","W Summit Ave","W Summit St","W Sunflower Ave","W Sunset Ave",
            "W Sunset Blvd","W Sunset St","W Sunshine Dr","W Surrey Ave","W Susan St","W Sussex Way",
            "W Swanson Ave","W Swift Trl","W Syracuse Ave","W Tasman Dr","W Taylor Ave","W Taylor St",
            "W Teco Ave","W Tecumseh Ave","W Temple St","W Terrace Ln","W Terry Clove Rd","W Terry Ct",
            "W Thar Rd","W Thayer St","W Thistlepoppy Loop","W Thomas","W Thomas St","W Thoroughbred Rd",
            "W Thorpe Rd","W Thousand Oaks Blvd","W Thunder Rd","W Timberleaf Dr","W Tina Ln","W Tioga Street",
            "W Tola Ave","W Tollan Dr","W Tollin Rd","W Tomahawk Way","W Tompkins St","W Tonada Dr","W Tonopah Dr",
            "W Tonto Dr","W Topeka Dr","W Torero Rd","W Torino Ave","W Toronto St","W Townley Ave","W Townline Rd",
            "W Trail Blazer Dr","W Tropicana Ave","W Truckee River Ranch Rd","W Tucker Ave","W Tucker St",
            "W Tuckey Ln","W Tufa St","W Tuna Way","W Tuolumne Rd","W Turney Ave","W Tycoon Rd","W Tyler Ave",
            "W Underwood St","W Union Ave","W Union Rd","W Union St","W Union Tpke","W United States Highway 60",
            "W University Ave","W Utah St","W V W Ave","W Val Verde Ave","W Valley Brook Rd","W Valley Rd",
            "W Valley St","W Valliere St","W Van Buren Rd","W Vanden Dr","W Vanzant Rd","W Vassar Ave",
            "W Vassar Ct","W Vaugine","W Verde Way","W Vereda Azul","W Vermont Ave","W Verona Ave","W Via Campana de Cobre",
            "W Via Dichosa","W Victor Ave","W Victoria Dr","W Victory St","W Villa Linda Dr","W Villa Theresa Dr",
            "W Village Cir","W Vineyard Ct","W Vista Grande Ct","W Vogt Rd","W Waddell Ct","W Wade Pl",
            "W Wagon Wheels Dr","W Wagoner Rd","W Wahl Rd","W Wall Rd","W Wall St","W Walnut Ave","W Walnut Dr",
            "W Walnut Ln","W Walnut Rd","W Walnut St","W Walton Blvd","W Warren Dr","W Washington","W Washington Ave",
            "W Washington Rd","W Washington St","W Water St","W Waterwheel Ct","W Wathen Ave","W Wayne Ave",
            "W Wayne Ter","W Weldon Ave","W Welling Ave","W West Covina Pky","W West Jersey Ave","W Western Reserve Rd",
            "W Westgate Ave","W Westmoreland St","W Weymouth Rd","W Whiptail Ct","W Whitman Ct","W Whitmore Ave",
            "W Wilbur Rd","W Wildey St","W Wildrose Ave","W Wiley St","W Wilkinson Rd","W Willetta St",
            "W William St","W Williams Ave","W Williams St","W Willow Creek Dr","W Willow Hwy","W Wilson",
            "W Wilson Ave","W Wilt St","W Winchester Easement","W Wind Ct","W Windermere Ter","W Windmill Ln",
            "W Windsong Ln","W Windsor Ave","W Windsor St","W Wingohocking St","W Winn Dr","W Winnemucca Blvd",
            "W Winona St","W Wisconsin Ave","W Wisteria Pl","W Wolf Ave","W Wood St","W Woodbine Dr",
            "W Woodbound Dr","W Woodbury Rd","W Woodcrest Ave","W Woodland Ave","W Woodlawn Ave","W Woods Rd",
            "W Wren Dr","W Yew St","W Yosemite Ave","W Zeralda St","W Zion Pl","W de Ville Pl","W del Rio St",
            "W del Sol Ln","W el Camino Viejo","W el Camino del Terra","W el Cortez Pl","W el Roblar Dr",
            "W la Alameda","W la Madre Way","W la Salle St","W la Vida Ave","W. R. Allen Road","W11090",
            "W12600","W174","W3012-A","W325","W376","W665","W730","W882 Pvt","W971 Pvt","WPA Rd","WPA Rd N","Wa Ba Yuba Dr",
            "Wa Pai Shone Cir","Waalkes St","Waban Avenue","Wabasee Trl NE","Wabash Ave","Wabash Avenue",
            "Wabash Dr","Wabasso Ct","Wabasso Street","Wabon Circle","Wachs Way","Wachusett Avenue","Wachusett Street",
            "Waco Ave SW","Waco Ct","Waco St","Wadas Dr","Waddell Road","Wade Ave","Wade Avenue","Wade Chapel Rd",
            "Wade Court","Wade Dr","Wade Rd","Wade River Cir","Wade Road","Wade Square","Wade St","Wadham St",
            "Wadi Dr","Wading Place Road","Wadleigh Place","Wadsworth Ave","Wadsworth Avenue","Wadsworth Crescent",
            "Wadsworth Ct","Wadsworth Rd","Wadsworth St","Wadsworth Street","Waffle Point","Waford Rd",
            "Wagele Dr","Wager Rd","Wagg Road","Waggoners Wells Lane","Wagner Addition","Wagner Ave",
            "Wagner Ct","Wagner Dr","Wagner Grove Trail","Wagner Ln","Wagner Mine Rd","Wagner Rd","Wagner St",
            "Wagon Glen","Wagon Ln","Wagon Rd","Wagon Trail Cv","Wagon Trail Ln","Wagon Trailway","Wagon Trl",
            "Wagon Wheel Cir","Wagon Wheel Ct","Wagon Wheel Dr","Wagon Wheel Rd","Wagoneer Ct","Wagonette Ct",
            "Wah Ta Wah Dr","Wah-Ta-Wah Dr","Wahkiakum Ave","Wahl St","Wahler Pl","Wahoo Dr","Wahwahtaysee Trl",
            "Waiford Cir","Waikiki Dr","Wainfleet Dunnville Townline Road","Wainfleet Road","Wainwright Ave",
            "Wainwright Rd","Wainwright St","Wait St","Waite Corner Road","Waits River Rd","Waitsfield Dr S",
            "Wakeby Road","Wakefield Avenue","Wakefield Cir","Wakefield Crescent","Wakefield Ct","Wakefield Dr",
            "Wakefield Drive","Wakefield Pl","Wakefield Rd NE","Wakefield St","Wakefield Ter","Wakehurst Pl",
            "Wakehurst Rd","Wakelee Dr","Wakeley Rd","Wakelin Court","Wakely Boulevard","Walasek Mulcoy Rd",
            "Walberger Rd","Walbridge Dr","Walck Dr","Walcott Rd","Wald Ct","Waldeck","Waldeck Ct","Walden Ave",
            "Walden Cir","Walden Circle","Walden Ct","Walden Dr","Walden Point Rd","Walden Pond Ln","Walden St",
            "Walden Street","Walden Way","Walden Woods Dr","Walder Avenue","Waldie Lane","Waldingfield Road",
            "Waldman Ave","Waldmer Dr","Waldo Ln","Waldo Point Harbor Gate 5 Rd","Waldon","Waldon Dr",
            "Waldon Rd","Waldon Ridge Dr","Waldorf Ave","Waldorf Court","Waldorf Dr","Waldorf St","Waldot Road",
            "Waldron","Waldron Rd","Waldwick Ave","Wales Avenue","Wales Rd","Wales Ridge Apartment","Waleswood Rd",
            "Waley Rd","Walford Ct","Walhonding Rd","Walingwood Dr","Walk Ct","Walk Rd","Walkabout Rd","Walkeen Koziol Road",
            "Walker","Walker Air Base Aux Lnd Fld 1","Walker Ave","Walker Avenue","Walker Co Shoal Creek Rd",
            "Walker Court","Walker Ct","Walker Ct NE","Walker Dr","Walker Dr SE","Walker Gap","Walker Ln",
            "Walker Pond Rd","Walker Rd","Walker Rd NE","Walker Road","Walker Run","Walker St","Walker Street",
            "Walker Way","Walkeridge Dr","Walkerville Road","Walking Horse Ln","Wall Ave","Wall Church Rd",
            "Wall Crest Ct","Wall Pt. Rd","Wall St","Wall Street","Walla Walla Ln","Wallabout St","Wallabout Street",
            "Wallaby Ln","Wallace Avenue","Wallace Avenue S","Wallace Chapel Rd","Wallace Cross Rd",
            "Wallace Ct","Wallace Dr","Wallace Dr SE","Wallace Drive","Wallace Farm Rd","Wallace Hill Rd",
            "Wallace Ln","Wallace P Road","Wallace Pl","Wallace Place","Wallace Rd","Wallace Rd NE","Wallace Road",
            "Wallace St","Wallace Street","Wallace Way","Wallapai Ln","Wallberg Ave","Wallbridge-Loyalist Road",
            "Wallen Ave SW","Wallenberg Cir","Wallenburg Dr","Wallens Hill Rd","Waller Rd","Waller St",
            "Walley Street","Walling Blvd","Walling Rd","Wallis Ave","Wallis Crescent","Wallis Drive",
            "Wallis Way","Wallkill Ave","Wallner Dr","Walls Ln","Walls Ln NE","Walls Rd W","Wallstown Rd",
            "Wallum Pond Street","Walmart Blvd","Walmer Road","Walmore Rd","Waln Run Cir","Waln St","Walnut",
            "Walnut Ave","Walnut Ave SW","Walnut Avenue","Walnut Cir E","Walnut Court","Walnut Creek Rd",
            "Walnut Ct","Walnut Dr","Walnut Draw Rd","Walnut Drive","Walnut Ext D","Walnut Glen","Walnut Grove",
            "Walnut Grove Campground","Walnut Grove Rd","Walnut Hill Blvd","Walnut Hill Dr","Walnut Hill Road",
            "Walnut Lake Rd","Walnut Ln","Walnut Plain Road","Walnut Rd","Walnut Shadows Ct","Walnut St",
            "Walnut St SW","Walnut Street","Walnut Street W","Walnut Street West","Walnut Ter","Walnut Valley Rd",
            "Walpi Ovi","Walpole Crescent","Walpole Pl","Walpole Road","Walrath Rd","Walraven Dr","Walser Rd",
            "Walsh Ave","Walsh Court","Walsh Dr","Walsh Drive","Walsh Rd","Walsingham Dr","Walston Rd","Walt Gilbert Rd",
            "Walt Whitman Bridge","Walter Ave","Walter Avenue","Walter Boyles Rd","Walter Ct","Walter Dr",
            "Walter E Foran Blvd","Walter Hammond Pl","Walter Rd","Walter Scott Way","Walter St","Walter Street",
            "Walters Chapel Rd","Walters Dr","Walters Rd","Walters St","Walters Way","Waltham Ave","Waltham Dr",
            "Waltham Rd","Waltham Road","Waltham St","Waltham Street","Walthery Ave","Walton Ave","Walton Cemetery Rd",
            "Walton Cir","Walton Ct","Walton Dr","Walton Park Dr","Walton Pl","Walton Rd","Walton St","Walton Street",
            "Walton Way","Waltonia Rd","Waltrous Ave","Waltz Rd","Walupa Way","Walzford Rd","Wamesit Street",
            "Wamisco Road","Wampanoag Dr","Wamsutta Road","Wanakah Heights","Wanamaker Ave","Wanamassa Pl",
            "Wanamassa Point Rd","Wanda Ave","Wanda Ct","Wanda Street","Wanda Way","Wandering Ivy St",
            "Wandering Ln","Wangumbaug Dr","Wannamaker Way","Wanner Ln","Wanner Rd","Wanstead Dr","Wantage Ave",
            "Wantanopa Crescent","Wanzia Ct","Wapaska Crescent","Waples Ct","Waquoit Road","Warbel Ln",
            "Warber Blvd","Warbington Dr","Warbler Rd","Warburton Avenue","Ward Ave","Ward Avenue","Ward Blvd",
            "Ward Creek","Ward Ct","Ward Dr","Ward Drive","Ward Hill Road","Ward Meadows","Ward Memorial Blvd",
            "Ward Pl","Ward Rd","Ward Road","Ward Robert Pl","Ward St","Ward Street","Ward Ter","Ward Way",
            "Wardecke Rd","Warden Avenue","Warden Bus Terminal","Wardensville Pike","Warder Dr","Wardwell Dr",
            "Ware Corner Road","Ware Enfield Road","Ware Rd","Ware River Valley Rail Trail","Ware Road",
            "Ware St","Ware Street","Wareham Street","Warehouse Dr","Warehouse Point Rd","Warehouse Road",
            "Warfield Ave","Warfield Place","Warfle Rd","Warham St","Warhol Avenue","Warick Rd","Waring Ave",
            "Waring Dr","Waring Rd","Warkdale Drive","Warm Glen Ave","Warm Springs Blvd","Warm Springs Rd",
            "Warminste Sideroad","Warmsprings","Warner Ct","Warner Dr","Warner Ln","Warner Rd","Warner Road",
            "Warner St","Warner Way","Warnica Avenue","Warnock Glencoe Rd","Warnock Rd","Warnsworth Street",
            "Warren Ave","Warren Ave E","Warren Avenue","Warren Blvd","Warren Bradley Street","Warren Court",
            "Warren Crescent","Warren Ct","Warren Dr","Warren Hts","Warren Pky","Warren Pl","Warren Place",
            "Warren Ranch Rd","Warren Rd","Warren Rd (Vacated)","Warren Road","Warren St","Warren Street",
            "Warren Ter","Warren Way","Warrendale Gate","Warrenton Pl","Warrenton St","Warrick Pl","Warring Rd",
            "Warring Street","Warrington Ave","Warrington Pl","Warrior Dr","Warrior Way","Warsaw Ave",
            "Warsaw Rd","Warsaw Road","Warsaw St","Warvet Crescent","Warwick Ave","Warwick Avenue","Warwick Ct",
            "Warwick Dr","Warwick Estates Dr","Warwick Glen Dr","Warwick Hills Rd","Warwick Pl","Warwick Rd",
            "Warwick Road","Warwick St","Warwick Tpke","Wasaga Rd","Wasatch Dr","Wasburn Ln","Wascana Avenue",
            "Wasco Cv","Washago Crescent","Washburn Ave","Washburn Avenue","Washburn Island Road",
            "Washburn Ln","Washburn Rd","Washburn Road","Washington","Washington Ave","Washington Ave S",
            "Washington Avenue","Washington Blvd","Washington Bridge","Washington Court","Washington Ct",
            "Washington Dr","Washington Lane","Washington Ln","Washington Mountain Road","Washington Pike",
            "Washington Pl","Washington Pond Rd","Washington Ranch Rd","Washington Rd","Washington Rock Rd",
            "Washington Square North","Washington St","Washington St NW","Washington State Road",
            "Washington Street","Washington Tpke","Washington Valley Rd","Washington Way","Washinton Ave",
            "Washita Cemt Loop","Washo Ct","Washoe St","Washtenaw Ter","Wasioja Rd","Wassuc Rd","Wastena Ter",
            "Wasteway No 6","Watch Hill Road","Water Ave","Water Canyon Rd","Water Cress Dr","Water Farm Road",
            "Water Mill Ct","Water Mill Rd","Water Oak Dr","Water Rd","Water St","Water Street","Water Street E",
            "Water Tower Cir","Water Tower Rd","Water Treatment Rd","Water Way","Water Wheel Creek Trail",
            "Water Works Row","Waterbridge Dr","Waterbrook Dr","Waterbury Ct","Waterbury Street","Waterbury Way",
            "Watercroft Ct","Waterfall Ct","Waterfall Ln","Waterford Ave","Waterford Ct","Waterford Gate",
            "Waterford Pl","Waterford Road","Waterford Trail","Waterford Way","Waterfront","Waterfront Cir",
            "Waterfront Rd","Waterfront Ter","Waterfront Trail","Waterfront Trail, Hamilton Beach Trail",
            "Watergap","Watergate Ct","Watergate Dr SW","Waterhole Way","Waterhouse Rd","Waterlilly Trail",
            "Waterline Rd","Waterloo Dr","Waterloo Ln","Waterloo Rd","Waterloo St","Waterloo Valley Rd",
            "Waterlot Lane","Waterman Ave","Waterman Avenue","Waterman Dr","Waterman Rd","Watermark Pky",
            "Watermill Ct","Waters Edge","Waters Edge Dr","Waters End Rd","Waters St","Waters Way","Watersedge Dr",
            "Watersedge Road","Waterside Cir","Waterside Ct","Waterside Dr","Waterside Drive","Waterside Ln",
            "Waterside Pky","Waterslide Ln","Watersmeet Cir","Waterstone Ln","Waterton Rd","Waterton Way",
            "Watertower Rd","Watertown Dr","Watertown Rd","Waterview Avenue","Waterview Blvd","Waterview Dr",
            "Waterview Ln","Waterview Pl","Waterville Acres Rd","Waterville Rd","Waterway Ct","Waterworks Ave",
            "Wateska Boulevard","Watford Ln","Watkins Glen Dr","Watkins Rd","Watkins Rd S","Watkins Way",
            "Watkinson Avenue","Watoquadoc Road","Watrous St","Watson Ave","Watson Avenue","Watson Ct",
            "Watson Dr","Watson Pl","Watson Rd","Watson Road","Watson St","Watson Street E","Watson Way",
            "Watsons Corners Road","Watt Avenue","Watt Dr","Watterson Troughs Rd","Wattova Dr NW",
            "Watts Mill Rd","Watts Rd","Watts Street","Waubun Rd","Waucantuck Road","Waucoba Rd","Waucoba Saline Rd",
            "Waughaw Rd","Waukeena Lake Rd","Waukewan Rd","Waulron Street","Waumbec Rd","Wausau Rd","Wauwinet Road",
            "Wave Crest Ct","Wave Dr","Wave Street","Waveland Ct","Waveland Park Rd","Waverly Ave","Waverly Ln",
            "Waverly Oaks","Waverly Oaks Drive","Waverly Pl","Waverly Place","Waverly Road","Waverly St",
            "Waverly St.","Waverly Street","Waverly Street N","Waverly Way","Wawa Trl","Wawana Ct","Wawanowin Club Rd",
            "Wawecus Road","Waxwing Pl","Way Rd","Wayburn Way","Waycross Dr","Wayfair Ln","Wayfarer Dr",
            "Wayfield Rd","Wayland Dr","Wayland Drive","Wayland St","Waymar Ct","Wayne Ave","Wayne Avenue",
            "Wayne Cir","Wayne Court","Wayne Crescent","Wayne Ct","Wayne Davis Rd S","Wayne Dr","Wayne Drive",
            "Wayne Ln","Wayne Newton","Wayne Newton Blvd","Wayne Phifer Rd N","Wayne Pl","Wayne Rd","Wayne St",
            "Wayne Ter","Wayne Twp 1079","Wayne Way","Wayne's Ln","Waynes L Ln","Waynesboro Way","Waynesbrooke Rd",
            "Wayside Avenue","Wayside Dr","Wayside Dr SE","Wayside Ln","Wayside Pl","Wayside Rd","Wayside Way",
            "Wc Rd 88","Wccdchuck Pky","We St","Weahkee Dr","Weald Way","Weare Rd","Wearimus Rd","Weather Bury Cir SE",
            "Weather Ln","Weather Vane Dr","Weather Wax Ct","Weather Wood Ln","Weatherbee Rd","Weatherby Dr",
            "Weatherby Ln","Weatherhead Road","Weatherill Road","Weatherly Cir","Weatherly Dr","Weathers Pl",
            "Weatherstone Crescent","Weathervane Dr","Weaver Ave","Weaver Dr","Weaver Hills Dr","Weaver Hollow Rd",
            "Weaver House Rd","Weaver Ln","Weaver Rd","Weaver Road Ramp","Weaver St","Weaver Street",
            "Weavers Farm Road","Web Road","Webb","Webb Aly","Webb Ave","Webb Ct","Webb Depot Rd","Webb Dr",
            "Webb Hill Road Spur","Webb Ln","Webb Rd","Webb Road","Webb St","Webb Street","Webb Way","Webber Crescent",
            "Webber Ln","Webber Pl","Webber Rd","Webber St","Weber Ave","Weber Ln","Weber Rd","Weber St","Webster",
            "Webster Ave","Webster Avenue","Webster Boulevard","Webster Brook Road Spur","Webster Court",
            "Webster Ct","Webster Drive 1","Webster Ford Rd","Webster Pl","Webster Place","Webster Rd",
            "Webster Road","Webster St","Webster Street","Webster Terrace","Weddel Ave","Weddington St",
            "Wedel Ave","Wedge Ct","Wedge Rd","Wedgefield Ct","Wedgemere Street","Wedgewood Ave","Wedgewood Cir",
            "Wedgewood Ct","Wedgewood Dr","Wedgewood Drive","Wedgewood Ln","Wedgewood Pky","Wedgewood Rd",
            "Wedgewood Road","Wedgewood St","Wedgeworth Dr","Wedowee Cove Dr","Wee Gwas St","Wee Ln",
            "Wee Road","Weed Rd","Weeden Road","Weedin Ct","Weedpatch Hwy","Weeks Dr","Weeks Rd","Weeks St",
            "Weeks Way","Weemasoul Rd","Weepah Rd","Weeping Willow Ln","Weepingridge Ct","Weequahic Park Dr",
            "Weese Road","Weevil Dr","Wegman Dr","Wegmans Market St","Wehr Road","Wehrle Drive","Weigands Ln",
            "Weigum Rd","Weiher Ct","Weiler Rd","Weiler St","Weilers Ln","Weiman Ave","Weiner St","Weingart Rd",
            "Weir Court Rd","Weir Crescent","Weir Road","Weir Street","Weir's Sdrd","Weirs Rd","Weirton Ave",
            "Weiser Ct","Weiss Ave","Weiss Lake Blvd","Weiss Rd","Weiss Ter","Welbanks Road","Welbourne Pl",
            "Welch Ave","Welch Creek Rd","Welch Dr","Welch Pl","Welch Rd","Welch St","Welcher Avenue","Welchview Ct",
            "Welcome Ave NW","Welcome Church Rd","Welcome Court","Welcome St","Welcome Street","Welcome Way",
            "Weld Street","Weldon Ave","Weldon Avenue","Weldon Canyon Mtwy","Weldon Ct","Weldon Ln","Weldon Pl",
            "Weldon Rd","Weldon Road","Weldrick Road East","Welfleet Drive","Welham Road","Welkin Gate",
            "Well Four Rd","Well Rd","Welland Ave.","Welland Canal Parkway","Welland Ln","Welland Road",
            "Welland Street","Welland canals trail","Wellandvale Drive","Wellbrook Cir","Welle Rd",
            "Weller Ave","Weller Pl","Weller Rd","Weller Street","Weller Ter Davidson Lane L-2","Welles Cir",
            "Welles Dr","Wellesley Drive","Wellesley Island State Park","Wellesley St","Wellesley Street",
            "Wellesley Street West","Wellesley Trl","Wellesly Ave","Wellesworth Drive","Wellfleet Dr",
            "Wellfleet Ln","Welling Pl","Welling Way","Wellingsley Avenue","Wellingto Street","Wellingto Street E",
            "Wellington Ave","Wellington Cir","Wellington Cir NW","Wellington Court","Wellington Ct",
            "Wellington Ctf","Wellington Dr","Wellington Pl","Wellington Rd","Wellington St","Wellington Street",
            "Wellington Street E","Wellington Street East","Wellington Street W","Wellington Street West",
            "Wellington Woods Ct","Wellintong Pl","Wellman Ter","Wells Ave","Wells Bay Lakefront",
            "Wells Bridge Rd","Wells Ct","Wells Dr NE","Wells Fargo St","Wells Park Road","Wells Pl",
            "Wells Rd","Wells Run Rd","Wells St","Wellsley Way","Wellsweet Lane","Welrus Street","Welsh Hill Rd",
            "Welsh St","Welsh Street","Welsh Woods Rd","Welshire Dr","Welstead Drive","Welton St","Welwyn Drive",
            "Wembley Ct","Wembley Ct SW","Wembury Road","Wenborn Rd","Wendakee Drive","Wendbrook Ln",
            "Wendel Way","Wendell Ave","Wendell Avenue","Wendell Cv","Wendell Depot Road","Wendell Rd",
            "Wendell Road","Wendell Way","Wenden Court","Wendham Pl","Wendigo Trail","Wendling Ct","Wendling Soda Creek Rd",
            "Wendover Ave","Wendy","Wendy Ave","Wendy Cicle","Wendy Cir","Wendy Ct","Wendy Dr","Wendy Ln","Wendy Pl",
            "Wendy Way","Wengers Mill Rd","Wenlock Avenue","Wenlock Rd","Wenonah Ave","Wenonah Dr","Wenonah Place",
            "Wensley Ave","Wenso Rd","Wenstrum Ave","Wentworth","Wentworth Avenue","Wentworth Cir","Wentworth Dr",
            "Wentworth Ln","Wentworth Rd","Wentworth St","Wentworth Street West","Wentworth Ter","Wentz Ave",
            "Werimus Rd","Werle Rd","Werner St","Wersonick St","Wertheim Pl","Wery Dr","Weschase Cir SE",
            "Wescott Ct","Wescott Dr","Wescott Rd","Wescott Road","Wesel Rd","Weser Ave","Weslemkoon Lake Road",
            "Wesley Aly","Wesley Ave","Wesley Avenue","Wesley Chapel Rd","Wesley Ct","Wesley Dr","Wesley J Ln",
            "Wesley Rd","Wesley St","Wesleyan Ave","Wesleyville Road","Wesmur Road","Weso St","Wesobulga Rd",
            "Wessel Drive","Wessex Rd","Wessex Road","Wessington Ave","West 102nd Street","West 103rd Street",
            "West 104th Street","West 105th Street","West 109th Street","West 111th Street","West 112th Street",
            "West 115th Street","West 116th Street","West 118th Street","West 121st Street","West 128th Street",
            "West 12th Street","West 130th Street","West 132nd Street","West 133rd St","West 133rd Street",
            "West 135th Street","West 136th Street","West 140th Street","West 141st Street","West 143rd Street",
            "West 144th Street","West 145th Street","West 148th Street","West 154th Street","West 155th Street",
            "West 156th Street","West 165th Street","West 168th Street","West 170th Street","West 172nd Street",
            "West 177th Street","West 183rd Street","West 185th Street","West 186th Street","West 187th Street",
            "West 189th Street","West 190th Street","West 191st Street","West 192nd Street","West 196th Street",
            "West 1st Street","West 203rd Street","West 20th Street","West 214th Street","West 215th Street",
            "West 219th Street","West 227th Street","West 22nd Street","West 230th Street","West 231st Street",
            "West 234th Street","West 238th Street","West 23rd Street","West 242nd Street","West 24th Street",
            "West 252nd Street","West 25th Street","West 27th Street","West 28th Street","West 31st Street",
            "West 32nd Street","West 33rd Street","West 37th Street","West 41st Street","West 46th Street",
            "West 47th Street","West 48th Street","West 49th Street","West 4th Street","West 50th Street",
            "West 51st St","West 53rd Street","West 54th Street","West 55th Street","West 57th Street",
            "West 59th Street","West 60th Street","West 64th Street","West 66th Street","West 68th Street",
            "West 69th Street","West 6th Street","West 70th Street","West 79th Street","West 7th Street",
            "West 81st Street","West 88th Street","West 8th Street","West 9th Street","West Acton Road",
            "West Aldea Street","West Allendale Avenue","West Alvarado Road","West Ave","West Ave NW",
            "West Avenue","West Baldwin St","West Bare Hill Road","West Beach Road","West Bellevue Avenue",
            "West Belt Line Trail","West Blvd","West Boylston Street","West Branch Aly","West Branch Road",
            "West Brick Rd","West Broadway","West Butte Rd","West Catron","West Cecil Ave","West Cedargren Rd",
            "West Cherry Tree Ln","West Chester Pike","West Close","West Coast Blvd","West Cordova St",
            "West Coronado Road","West Cove Rd","West Cranford Road","West Ct","West Cummington Road",
            "West Davisville Road","West Deane Park Drive","West Deerfield Lower Road","West Deerfield Upper Road",
            "West Dr","West Drew St","West Drive","West End Ave","West End Dr","West End Rd","West Falls Creek Rd",
            "West Falmouth Highway","West Fork Red Box Rd","West Fourth Street","West Front Sb Onramp",
            "West Gill Road","West Gilmore Rd","West Green Street","West Grove Street","West Hawley Road",
            "West Heard Rd","West Hill Dr","West Hill Rd","West Historic Hwy 66","West Houston Street",
            "West Humber Recreational Trail","West Hunt Club Rd","West Hyannisport Circle","West Joppa Rd",
            "West Justis Street","West Lake Ave","West Lake Dr NE","West Lake Rd","West Lane","West Leigh Dr",
            "West Leonard Ct","West Leyden Road","West Line Rd","West Little Turtle Way","West Ln",
            "West Long Pond Road","West Loop","West Main","West Main St","West Main Street","West Maple Ct",
            "West Meetinghouse Road","West Middle Ave","West Mosby Rd","West Mountain Road","West New Mexico 44",
            "West North Park Pl","West Oaks Dr","West Orange Road","West Palm Court","West Park Street",
            "West Pearce Street","West Pelham Road","West Pier","West Pky","West Plz","West Point Dr",
            "West Point Rd","West Princeton Road","West Rd","West Ridge Trail","West River Dr","West Road",
            "West Roxbury Parkway","West Ryan Ave","West Seneca Rd","West Shore Boulevard","West Shore Cir",
            "West Shore Dr","West Shore Expressway","West Shore Pky","West Shore Rd","West Shore Road",
            "West Side Ave","West Side Rd","West Sixth Street","West St","West Steet","West Street","West Street N",
            "West Sturbridge Road","West Sub Station Rd","West Taylor Street","West Tisbury Road",
            "West Toronto Railpath","West Toronto Street","West Townsend Road","West U St","West Vaughn Street",
            "West Victoria Ct","West View Dr","West View Ln","West View St","West View Way","West Villa Street",
            "West Virginia Ave","West Virginia Dr","West Virginia St","West Way","West Wheelock St",
            "West Whyte Ave","West Wind Loop","West Wind Shores","West Wood Dr","Westacott Crescent",
            "Westacre Dr","Westboro Dr","Westbound Service Station","Westbourne Ct","Westbourne Dr",
            "Westbranch Rd","Westbridge Way","Westbrook Ave","Westbrook Avenue","Westbrook Ct","Westbrook Dr",
            "Westbrook Rd","Westbrook Road","Westbrook Street","Westbury Ct","Westbury Rd","Westchester Crescent",
            "Westchester Ct","Westchester Ln","Westchester Rd","Westchester Ter","Westcott Ave","Westcott Beach State Park",
            "Westcott Blvd","Westcott Rd","Westcreek Drive","Westcroft Avenue","Westdale Avenue","Westdale Road",
            "Westend Ave","Westerly Pl","Westerly Ter","Westerman Ct","Western Ave","Western Ave SW",
            "Western Avenue","Western Boulevard","Western Dr","Western Drive","Western Heights Blvd",
            "Western Heights Dr","Western Hills Dr S","Western Hills Rd","Western Ln","Western Meadows Rd NW",
            "Western Pine Dr","Western Rd","Western Reach","Western Saddle Ct","Western Shore Ln",
            "Western Skies","Western States 100 mile Course","Western Sunset Ct","Western Trl",
            "Westervelt Pl","Westervelt Rd","Westfall Ln","Westfall Town Dr","Westfield Camden Tpke",
            "Westfield Dr","Westfield Rd","Westfield St","Westford Cir","Westford Road","Westgate Boulevard",
            "Westgate Dr","Westgate Park Drive","Westgate Pl","Westgate Rd","Westgate Road","Westhill Dr",
            "Westhills Dr","Westholm Blvd","Westin Pl","Westlake Ave","Westlake Avenue","Westlake Blvd",
            "Westlake Cir","Westlake Ct","Westlake Drive","Westlake Ln","Westland Avenue","Westland Ct",
            "Westland Estates","Westland Rd","Westlea Drive","Westledge Ter","Westley Ln","Westline Dr",
            "Westlock Road","Westlund Avenue","Westman Road","Westminister Cv","Westminster Ave","Westminster Ct",
            "Westminster Dr","Westminster Drive","Westminster Park","Westminster Pl","Westminster Rd",
            "Westminster St","Westminster Street","Westmont Ave","Westmont Dr","Westmont Ln","Westmont Rd",
            "Westmoor Dr","Westmoore Rd","Westmore Cv","Westmore Drive","Westmoreland Avenue","Westmoreland Dr",
            "Westmoreland Drive","Westmount Avenue","Westmount Drive S","Westolivia Trail","Weston",
            "Weston Ave","Weston Cir","Weston Ct","Weston Rd","Weston Road","Weston Road North","Weston St",
            "Westover Ave","Westover Ct","Westover Dr","Westover Pl","Westover Rd","Westpark Ct","Westpark Drive",
            "Westpark Rd","Westpine Dr","Westpoint","Westport Ave","Westport Ln","Westport Road","Westran Road",
            "Westray Ct NE","Westridge Cir","Westridge Ct","Westridge Dr","Westridge Pl","Westridge Rd",
            "Westridge Road","Westridge St","Westrose Avenue","Westshore Mal","Westside Blvd","Westside Dr",
            "Westside Drive","Westside Fwy","Westside Rd","Westside Woods Rd","Westside-Spur","Westtown Lake Dr",
            "Westview Ave","Westview Circle","Westview Dr","Westview Ln","Westview Pl","Westview Rd",
            "Westview St","Westview Street","Westview Ter","Westview Terrace","Westview Way","Westway 18",
            "Westway Road","Westwind","Westwind Acres","Westwind Dr","Westwind Ranch Rd","Westwinds Drive - Morrisburg",
            "Westwood Ave","Westwood Avenue","Westwood Cir","Westwood Cir SW","Westwood Dr","Westwood Logging Road",
            "Westwood Pl","Westwood Rd","Westwood Road","Westwood St","Westwood Street","Westwood Terrace",
            "Westwood Trace","Westwood Way","Wethersfield Rd","Wethersfield Road","Wetland Trl","Wetmore Ave",
            "Wetmore Park","Wetona Rd","Wetsand Ct","Wetwhistle","Wewoka Cir","Wewoka Dr","Wexford Ct","Wexford Dr",
            "Wexford Pl","Wexford Way","Wexler Ct","Wexler Pl","Weyand Ct","Weyant Ter","Weybosset Street",
            "Weybridge Ct","Weybridge Pl","Weybright Court","Weyburn Square","Weyburne Ave","Weyco 455",
            "Weyco Rd 22493","Weyco Rd 22553","Weyco Rd 53810","Weyco Rd 53813","Weyerhaeuser 24000 Rd",
            "Weyl St","Weymouth Ln","Weymouth Pl","Weymouth St","Weymouth Street","Weyrick Dr","Wgmf Rd",
            "Whale Creek Ct W","Whale Point Ln","Whalers Dr","Whalers Walk","Whaley Ln","Whaley Rd","Wharburton Pl",
            "Wharf Dr","Wharf Lane","Wharf Road","Wharf St","Wharfside Lane","Wharton","Wharton Creek Rd",
            "Wharton Ct","Wharton Rd","Wharton Street","Wharton Way","Whately Road","Whatley Ct","Whatley Ln",
            "Whealkate Ave","Wheat Hill Dr","Wheat St","Wheatfiel Road","Wheatfield Plz","Wheatfield Way",
            "Wheatfild Ct","Wheatgrass Ln","Wheathill Street","Wheatland Way","Wheatlands Ct","Wheaton Ave",
            "Wheaton Ct","Wheaton Rd","Wheaton Way","Wheatsheaf Crescent","Wheatsheaf Ln","Wheatsheaf Rd",
            "Wheatsheaf Street","Wheatstone Rd","Wheel Ct","Wheeler Ave","Wheeler Avenue","Wheeler Cir",
            "Wheeler Crescent","Wheeler Cross Rd","Wheeler Ct","Wheeler Dam Rd","Wheeler Dr","Wheeler Lane",
            "Wheeler Ln","Wheeler Pass Rd","Wheeler Rd","Wheeler Rd SW","Wheeler Road","Wheeler Springs Rd",
            "Wheeler St","Wheeler Street","Wheeler Ter","Wheeler Tr","Wheelers Ln","Wheelers T P Rd",
            "Wheeling Ave","Wheelock Dr","Whelan Ct","Whelden Lane","Wheler Dr","Whetstone Rd","Whetstone St",
            "Which Way","Whickham Ct","Whiffle Tree Circle","Whig Lane Rd","Whilabout Terrace","Whimbrel Road",
            "Whinn Rd","Whipoorwill Ct","Whippany Rd","Whippdale Ave","Whippet Run","Whipple Ave","Whipple Dr",
            "Whipple Lake Ct","Whipple Mills","Whipple Rd","Whipple St","Whipple T Lane","Whippoorwill Ln",
            "Whippoorwill Way","Whipporwill Cv","Whipstock Rd","Whirlaway St","Whirlpool Rapids Bridge",
            "Whirlwind Cir","Whirlwind Rd","Whiskey Aly","Whiskey Bottle Rd","Whiskey Creek Rd","Whiskey Hollow",
            "Whiskey Ln","Whiskeytown-Shasta-Trinity Nra","Whisper Ct","Whisper Ln","Whisper Way E",
            "Whisper Wind Cir","Whisper Wind Rd","Whispering Brooke Dr","Whispering Creek","Whispering Ct",
            "Whispering Hill","Whispering Hill Cir","Whispering Meadows Ln","Whispering Palms Trl",
            "Whispering Pine","Whispering Pine Ave","Whispering Pine Rd","Whispering Pines Ct",
            "Whispering Pines Dr","Whispering Pines Ln","Whispering Pines Rd","Whispering Rod Rd",
            "Whispering Springs Dr","Whispering Trl","Whisperwood Ct","Whistle Ln","Whistler Ln","Whistler Place",
            "Whistling Swan Ln","Whitaker Ave","Whitaker Bluff Rd","Whitaker Rd","Whitaker Way","Whitbread Avenue",
            "Whitburn Crescent","Whitburn Street","Whitby","Whitby Cir","Whitby Rd","Whitby Road","Whitcher St",
            "Whitcomb Lane","Whitcomb Rd","Whitcomb St","Whitcomb Way","White Abbey Park","White Anchor Cv",
            "White Angel Mesa","White Ave","White Avenue","White Beeches Dr","White Bir Way","White Birch Ct",
            "White Birch Dr","White Birch Ln","White Birch Rd","White Birch Ridge Rd","White Birch Way",
            "White Cedar","White City Rd","White Cliffe Drive","White Cloud Cir","White Clover Ln",
            "White Clover Way","White Ct","White Deer Plz","White Deer Rock Rd","White Dove Ct","White Dove Dr",
            "White Dove Ln","White Dr","White Elm Road","White Fal Road","White Flats Rd","White Fox Trl",
            "White Game Club","White Hall Ct","White Heather Boulevard","White Horse","White Horse Dr SE",
            "White Horse Ln","White Horse Pike","White Horse Rd W","White Horse Tr","White Island Road",
            "White Knoll Rd","White Lake Rd","White Lake Road","White Lion Dr","White Ln","White Meadow Rd",
            "White Meadow St","White Mountain Hwy","White Mountain Rd","White Oak Ave","White Oak Boulevard",
            "White Oak Crescent","White Oak Dr","White Oak Rd","White Oak Ridge Rd","White Oak Trl",
            "White Oak Way","White Oaks Dr","White Owl Ct","White Pine","White Pine Acres","White Pine County Road 18",
            "White Pine County Road 21","White Pine County Road 3","White Pine County Road 31",
            "White Pine County Road 37","White Pine County Road 47","White Pine Ct","White Pine Dr",
            "White Pine Ln","White Pine Trail","White Pl","White Plains Rd","White Pond Dr","White Quail Ct",
            "White Rabbit Trl","White Rd","White Rim Pl NE","White River Cir","White Road","White Roc Road",
            "White Rock Rd","White Rock Ter","White Sands Dr","White Snake Hill Rd","White St","White Stag Connector",
            "White Stallion Ct","White Stone Way","White Street","White Street Place","White Swan Dr",
            "White Tail Ct","White Tail Ln","White Tail Pl","White Tail Rd","White Trail","White Way",
            "White Wing Dr","White Wolf Canyon","White Woods Rd","White's Hill Avenue","White's Road",
            "Whitebird Trl","Whitecap Drive","Whitefiel Drive","Whitefish Dr","Whitefish Rd","Whitegate Ave",
            "Whitehall Ct","Whitehall Pl","Whitehall Rd","Whitehall Road","Whitehall Street","Whitehaven St",
            "Whitehead Highway","Whitehead Place","Whitehead Rd","Whitehorn Avenue","Whitehorn Dr",
            "Whitehouse Rd","Whitehouse Trl","Whitekirk Dr","Whiteleas Avenue","Whiteman Creek Rd",
            "Whiteman St","Whiteoak Drive","Whiteoak Ln","Whiterock Ave","Whiterose Ct","Whites City Rd",
            "Whites Court","Whites Gap Rd","Whites Grove Rd","Whites Hill Rd","Whites La Road","Whites Road",
            "Whiteside Street","Whiteston Drive","Whitestone Ct","Whitesville Rd","Whitetail Cir",
            "Whitetail Trl","Whitevale Road","Whitewater Brook Rd","Whitewood","Whitewood Ave","Whitewood Cir",
            "Whitewood Ct","Whitewood Ln","Whitewood Rd","Whitey Rd","Whitfield Rd SE","Whitfield Road",
            "Whitford Ave","Whitford Ct","Whitford Rd","Whitford Road","Whitford St","Whithorn Cir","Whiting Blvd",
            "Whiting Dr","Whiting Rd","Whiting Way","Whitingham St SE","Whitlow St","Whitman Ave","Whitman Ct",
            "Whitman Dr","Whitman Rd","Whitman Road","Whitman St","Whitman Ter","Whitmarsh Hollow","Whitmer Ln",
            "Whitmore Lake Rd","Whitmore Rd","Whitmore St","Whitnall Hwy","Whitney","Whitney Ave","Whitney Avenue",
            "Whitney Beach Rd","Whitney Blvd","Whitney Court - Morrisburg","Whitney Ct","Whitney Dr",
            "Whitney Hill Rd","Whitney Ln","Whitney Pl","Whitney Rd","Whitney Road","Whitney St","Whitney Street",
            "Whitney Valley Hts","Whitney Way","Whiton Avenue","Whits End","Whitsell Rd","Whittaker Avenue",
            "Whittaker Dr","Whittaker Road","Whittaker St","Whittemore Gulch Trail","Whittemore St",
            "Whitten Neck Rd","Whitten Pl","Whittenton Street","Whittier Ave","Whittier Avenue","Whittier Blvd",
            "Whittier Court","Whittier Ct","Whittier Dr","Whittier Hill Rd","Whittier Rd","Whittier Road",
            "Whittier St","Whittier Street","Whittle Ave","Whittle Bridge Rd","Whittum Avenue","Whitwell Drive",
            "Whitworth St","Whortley Cir","Wianno Way","Wibird St","Wible Ct","Wible Rd","Wichita Ave","Wichita Way",
            "Wick Rd","Wickaboag Valley Road","Wicked Creek Rd","Wickendon Ct","Wickens Rd","Wickersham Ave",
            "Wickersham Ln","Wicket Gate","Wickford Rd","Wickham Dr","Wickham Ln","Wickham Pl","Wickins Creek Ct",
            "Wicklam Road","Wickland St","Wicks Ave","Wicks Ln","Wickshire Ln","Wickson Trail","Wickware Gate",
            "Widdicombe Hill Boulevard","Widdock St","Wide Canyon Rd","Widgeon Dr","Widmer Street",
            "Widow Sweets Rd","Widow Valley Rd","Wiebe Ave","Wieck Dr","Wiese Way","Wiesner Ln","Wiess St",
            "Wiessman Way","Wiggins Farm Dr","Wiggins Rd","Wight St","Wight Street","Wightman Ct","Wigley Ln NW",
            "Wigwam","Wigwam Ln","Wigwam Rd","Wigwam Way","Wigwoss Court","Wigwoss Drive","Wilber Ave","Wilber St",
            "Wilber Ter","Wilbert Ave","Wilbraham Road","Wilbur Ave","Wilbur Court","Wilbur Ct","Wilbur Fisk Rd",
            "Wilbur Hicks Rd","Wilbur Rd","Wilbur St","Wilbur Street","Wilburs Way","Wilce Drive","Wilclay Avenue",
            "Wilcox","Wilcox Ave","Wilcox Ct","Wilcox Hill Rd","Wilcox Pl","Wilcox Rd","Wilcox St","Wilcox Street",
            "Wilcoxson Dr","Wilcroft Court","Wild Acre","Wild Acres Dr","Wild Azalea Ln","Wild Bill Way",
            "Wild Branch Rd","Wild Briarway","Wild Burro Trail","Wild Cherry Cv","Wild Creek Way",
            "Wild Dew Ct","Wild Draw Dr","Wild Goose Ln","Wild Grass Rd","Wild Hedge Ln","Wild Hog Rd",
            "Wild Horse Creek","Wild Horse Ct","Wild Horse Pl","Wild Horse Rd","Wild Horse Winery Ct",
            "Wild Indigo Ln","Wild Lilac Ct","Wild Lilac Trl","Wild Oak","Wild Oak Ct","Wild Oak Dr",
            "Wild Oak Lane","Wild Oak Ln","Wild Oaks Dr","Wild Oat Pl","Wild Orchid Ct","Wild River Rd",
            "Wild Rose Dr","Wild Rose Ln","Wild Rose Pl","Wild Rose Street","Wild Turkey Road","Wild Turkey Way",
            "Wild Way","Wild Wood Rd","Wild Wood Ridge Trl","Wildbranch Dr","Wildcat Canyon Rd","Wildcat Hollow",
            "Wildcat Loop Trail","Wildcat Rd","Wilde Ave","Wilde Court","Wilde Ln","Wildell Rd","Wilder Rd",
            "Wilder Ridge Rd","Wilder Road","Wilder St","Wilderhold Rd","Wilderness Ave","Wilderness Ct",
            "Wilderness Dr","Wilderness Gate Rd","Wilderness Heights Rd","Wilderness Ln","Wilderness Loop",
            "Wilderness Rd","Wilderness Trail","Wilderness Trl","Wilders Pass","Wildewood Ln","Wildey Rd",
            "Wildfire Ln","Wildfire Way","Wildflowe Court","Wildflower Cir","Wildflower Ct","Wildflower Dr",
            "Wildflower Ln","Wildflower Pl","Wildflower Rd","Wildflower St","Wildflower Trl","Wildfong Dr",
            "Wildgrass Road","Wildhorse Dr","Wildhorse Ln","Wilding Rd","Wilding Way","Wildland","Wildlife Blvd",
            "Wildlife Ln","Wildlife Run","Wildridge Ct NE","Wildrose Ct","Wildrose Dr","Wildrose Ln",
            "Wildrose Rd","Wildrose St","Wildrose Ter","Wildsky Road","Wildwood","Wildwood Ave","Wildwood Avenue",
            "Wildwood Crescent","Wildwood Ct","Wildwood Dr","Wildwood Dr SE","Wildwood Heights Dr",
            "Wildwood Lane","Wildwood Ln","Wildwood Pl","Wildwood Place","Wildwood Rd","Wildwood Ter",
            "Wildwood Tr","Wildwood Trl","Wildwood Xing","Wiles Dr","Wiley Dr","Wiley Rd","Wiley St","Wiley Street",
            "Wiley Well Rd","Wilford Road","Wilfred Ave","Wilfred Street","Wilfred Way","Wilfrid Laurier Crescent",
            "Wilgar Road","Wilhelm Dr","Wilhelmina Avenue","Wilheln Pl","Wilke Dr","Wilke Ln","Wilkens Dr",
            "Wilkerson Pl","Wilkes Ave","Wilkes Barre Tpke","Wilkes St","Wilkes Way","Wilket Road","Wilkey Way",
            "Wilkie Dr","Wilkins Ave","Wilkins Street","Wilkinson Ave","Wilkinson Hill Rd","Wilkinson Pl",
            "Wilkinson Rd","Wilks Pond Rd","Wilks St","Will Arthur Stewart Rd","Will Bantley Rd","Will Johnson Road",
            "Will Rd","Will Rogers Ln","Will Sheldon Rd","Will St","Willalee Ave","Willand Rd","Willard Ave",
            "Willard Ave SW","Willard Avenue","Willard Clark Cir","Willard Rd","Willard St","Willard Street",
            "Willborough Pl","Willbruck Drive","Willdew Ave","Willella Pl","Willer Ln","Willers Rd","Willert St",
            "Willet Ave SE","Willet Ct","Willet St","Willets Avenue","Willett Drive","Willever Lake Rd",
            "Willey Pond Rd","William","William Ave","William B Terry Drive","William Berczy Boulevard",
            "William Booth Avenue","William Booth Crescent","William Childress Ln","William Ct",
            "William Davidson Street","William Demarest Pl","William Ellery Pl","William Howton Rd",
            "William L Gaiter Pky","William Law Rd","William Oscar Emery Dr","William Paca Pl",
            "William Reuben Dr","William Road","William S. Canning Boulevard","William St","William Steet",
            "William Street","William Street N","William Tell Trl","William Way","William Wood Ct",
            "Williamee Rd","Williams","Williams Ave","Williams Avenue","Williams Butte","Williams Court",
            "Williams Creek Rd","Williams Ct","Williams Dr","Williams Drive","Williams Ln","Williams Pky",
            "Williams Pl","Williams Plz","Williams Rd","Williams St","Williams St E","Williams St SE",
            "Williams Street","Williams Way","Williams Well Rd","Williamsburg N","Williamsburg Bridge",
            "Williamsburg Ct","Williamsburg Dr","Williamsburg Ln","Williamsburg Pl","Williamsburg Rd",
            "Williamsburg St","Williamsom Rd","Williamson Ave","Williamson Avenue","Williamson Dr",
            "Williamson Drive W","Williamson Rd","Williamson Road","Williamson St","Williamsport St",
            "Williford Rd","Willimette St","Willinda St","Willing St","Willingdon Avenue","Willingdon Boulevard",
            "Willingham Dr","Willings Way","Willis Ave","Willis Bean Rd","Willis Ct","Willis Dr","Willis Drive",
            "Willis Rd","Willis Road","Willis St","Willis St NE","Willis Street","Willits Ave","Willobough Ln",
            "Willopete Dr","Willoughb Boulevard","Willoughby Avenue","Willow Ave","Willow Ave NE",
            "Willow Avenue","Willow Bark Way","Willow Bend Ct","Willow Bend Rd","Willow Brook Cir",
            "Willow Brook Rd","Willow Canyon Ct","Willow Cir","Willow Court","Willow Creek 112 Rd",
            "Willow Creek Dr","Willow Creek Drive","Willow Creek Ln","Willow Creek Ranch Rd","Willow Creek Rd",
            "Willow Crescent","Willow Crest Ave","Willow Ct","Willow Ct SE","Willow Dr","Willow Glen Rd",
            "Willow Green Dr","Willow Grove Boulevard","Willow Grove Pky","Willow Grove Rd","Willow Heights Boulevard",
            "Willow Hills Creek","Willow La Road","Willow Lake Ridge","Willow Landing Rd","Willow Lane",
            "Willow Ln","Willow Meadow Ct","Willow Oak Ct","Willow Oak Dr","Willow Pass","Willow Pass Rd",
            "Willow Pl","Willow Point","Willow Point Cir","Willow Point Ct","Willow Point Rd","Willow Point Road",
            "Willow Pond Ln","Willow Ranch Rd","Willow Ranch St","Willow Rd","Willow Rd NW","Willow Ridge",
            "Willow Ridge Rd","Willow Ridge Trl","Willow Road","Willow Rock Acres Rd","Willow Springs Rd",
            "Willow St","Willow Street","Willow Street Extension","Willow Ter","Willow Tr","Willow Tree Dr",
            "Willow Trl","Willow View Ct","Willow Way","Willow Way Pl","Willow Wood Ct","Willow Wood Park N",
            "Willowbank Boulevard","Willowbank Ln","Willowbrook Ave","Willowbrook Cemetery","Willowbrook Cir",
            "Willowbrook Ct","Willowbrook Dr","Willowbrook Dr SW","Willowbrook Drive","Willowbrook Pky",
            "Willowbrook Rd","Willowbrook Road","Willowbrook Trl","Willowburn Rd","Willowcreek Blvd",
            "Willowcrest Dr NW","Willowcroft Rd","Willowdale Avenue","Willowgate St","Willowhaven Ave",
            "Willowicke Dr","Willowlake Rd","Willowmont Ave","Willowood Ln","Willowood Rd","Willowridge Road",
            "Willowrow Ave NE","Willows Lane","Willows Rd","Willowside Court","Willowside Rd","Willowvale Gardens",
            "Willowwood Ct","Wills Canyon Rd","Wills Creek Rd","Wills Ferry Road","Wills Lane","Wills Ln",
            "Wills St","Wills Way Cir E","Willumae Dr","Wilma Ave","Wilma Dr","Wilma K Rd","Wilma Road",
            "Wilma Street","Wilmans Dr","Wilmar St","Wilmer Georgetown Rd","Wilmer Tanner Williams Rd",
            "Wilmington Ave","Wilmington Rd NW","Wilmont Drive","Wilmont Rd","Wilmont Road","Wilmot Dr SE",
            "Wilmot Rd","Wilmot Trail","Wilmoth Ct","Wilno Avenue","Wilrose Ct","Wilsey Hill Rd","Wilsey St",
            "Wilshire Blvd","Wilshire Dr","Wilshire Ln","Wilshire St","Wilshire Way","Wilson","Wilson Ave",
            "Wilson Avenue","Wilson Bend Rd","Wilson Creek Dr","Wilson Ct","Wilson Dr","Wilson Drive",
            "Wilson Farm Rd","Wilson Heights Boulevard","Wilson Hill Rd","Wilson Hurley Ct NE",
            "Wilson Hurley Pl NE","Wilson Lake Dr","Wilson Ln","Wilson Mill Rd","Wilson Mtn Rd","Wilson North Bus Terminal (unused)",
            "Wilson Park Dr","Wilson Pl","Wilson Pl NW","Wilson Place","Wilson Po Road","Wilson Po Road N",
            "Wilson Point Road S","Wilson Rd","Wilson Road North","Wilson Springs Rd","Wilson St",
            "Wilson Street","Wilson Ter","Wilson Terrace","Wilson Way","Wilt Rd","Wilton Rd","Wilton Way",
            "Wilton's Corner Blvd","Wiltse Cross Rd","Wiltsey Rd","Wiltshire Boulevard","Wiltshire Ct",
            "Wiltshire Dr","Wiltsie Rd","Wilward Rd","Wilwick Way","Wilwin Rd","Wiman Pl","Wimbledon Cir",
            "Wimbledon Circle","Wimbledon Dr","Wimbledon Pl","Wimbledon Rd","Wimbleton Rd","Wimbleton Road",
            "Wimbleton Way","Wimple St","Wimple Way","Wimpole St","Winans Ave","Winant Ave","Wincanton Rd",
            "Winchedster Dr","Winchell Way","Winchendon Street","Winches Dr","Wincheste Terrace","Winchester Ave",
            "Winchester Blvd","Winchester Ct","Winchester Dr","Winchester Hill Rd","Winchester Ln",
            "Winchester Pl","Winchester Rd","Winchester St","Winchester Street","Winchester Ter","Winchester Way",
            "Wincrest Drive","Wind Brook Cir","Wind Cave Trail","Wind Mill Rd","Wind Pl","Wind Point Rd",
            "Wind Prairie St","Wind Rd","Windamere Ave","Windansea St","Windbeam Rd","Windbridge Dr",
            "Windchime Dr","Windcliff Dr NE","Windcroft","Windcroft Court","Windemere","Windemere Cir",
            "Windemere Dr","Windemere Road","Windemere St","Windermere Ave","Windermere Avenue","Windermere Ct",
            "Windermere Rd","Windermere Road","Windfall Rd","Windfall Way","Windflower Ave","Windflower Ct",
            "Windflower Way","Windgate Dr","Windham Ct","Windham Dr","Windham St","Windham Wash Rd","Windharp Dr",
            "Windhill Crescent","Winding Brook Ln","Winding Creek Dr","Winding Creek Ln","Winding Dr",
            "Winding Hill Rd","Winding Ln","Winding Ridge Cir","Winding Ridge Rd","Winding River Ct",
            "Winding River Cv","Winding River Ln","Winding Shores","Winding Stair Trl","Winding Stairs Rd",
            "Winding Trail","Winding Trl","Winding Way","Winding Way Rd","Winding Wood","Windingbrook Ct",
            "Windle Way","Windlestraw Rd","Windmere Dr","Windmill Cir","Windmill Ct","Windmill Ct NW",
            "Windmill Dr","Windmill Lane","Windmill Ln","Windmill Rd","Windmill Trail Rd","Windoga Ct",
            "Windom St","Windom Way","Windover Drive","Window Rack Blvd","Windridge Dr","Windridge Drive",
            "Windrim Ave","Windrow Street","Windrush Ln","Windsford Cir","Windsong Ct","Windsong Dr",
            "Windsong Ln","Windsong Pl","Windsong St","Windsor Ave","Windsor Avenue","Windsor Center Dr",
            "Windsor Church-Pleasant Ridge Rd S","Windsor Cir","Windsor Court Road","Windsor Ct",
            "Windsor Dr","Windsor Drive","Windsor Gate","Windsor Green Rd","Windsor Ln","Windsor Palms Dr",
            "Windsor Pl","Windsor Rd","Windsor Road","Windsor St","Windsor Street","Windsor Ter","Windsor Trce",
            "Windsor Village Ln","Windsor Way","Windstar Ln","Windstream Way","Windsurfers Cove","Windswept",
            "Windswept Pl","Windtree Ct","Windtree Ln","Windwalker Way","Windward Cir","Windward Ct",
            "Windward Dr","Windward Drive","Windward Ln","Windward Way","Windwood Drive","Windwood Ln",
            "Windwood Loop","Windy Acres Dr","Windy Bush Rd","Windy Ct","Windy Golfway","Windy Hill Ln",
            "Windy Hill Rd","Windy Hollow Rd","Windy Knoll Rd","Windy Ln","Windy Ridge","Windy Ridge Way",
            "Windy Way","Wine Glass Rd","Winedale Ln","Winegar Rd","Winegrape Dr","Wineman Rd","Winen Way",
            "Winesap Point","Winetka Rd","Winewood Ct SE","Winfield Ave","Winfield Cir","Winfield Dr",
            "Winfield Ln","Winfield Place","Winfield Rd","Winfield Trce","Winfred Ave","Winfred Ct","Wing Ave SE",
            "Wing Hill Road","Wing Ln","Wing Road","Wingarden Crescent","Wingate Ct","Wingate Ln","Wingate Rd",
            "Wingate St","Wingate Ter","Wingbrook Ave","Winged Foot Cir","Winged Foot Ct SE","Winged Foot Dr",
            "Winged Foot Way","Winges Road","Wingfield Springs Dr","Wingfield St","Wingfield Way",
            "Wingfoot Pl","Wingfoot St","Wingreen Court","Wingrove Avenue","Wingrove Lane","Winifred Ct",
            "Winifred St","Winkelman Rd","Winkle Way","Winkler","Winkler Ct","Winkler Rd","Winks Ln","Winman Ct",
            "Winmir","Winnebago St","Winnemucca to the Sea Highway","Winner Pl","Winnetka Rd","Winnfred Avenue",
            "Winnifred Road","Winnimere Rd","Winnipeg Avenue","Winnipeg Com","Winnipesaukee St","Winona Ave",
            "Winona Blvd","Winona Ct","Winona Dr","Winona Rd","Winona St","Winona Ter","Winridge Ave","Winrock Dr",
            "Winrock Loop NE","Winscombe Ct","Winship Ln","Winship Street","Winslow Ave","Winslow Avenue",
            "Winslow Ct","Winslow Gray Road","Winslow Place","Winslow Rd","Winslow Ter","Winsor Ave",
            "Winsor Cir","Winsor Rd","Winsor Road","Winsor Way","Winstead","Winston","Winston Churchill Boulevard",
            "Winston County 8","Winston Ct","Winston Dr","Winston Ln","Winston Rd","Winston Road","Winston St",
            "Wint Dunn Rd","Winter Amber Ct","Winter Ave","Winter Avenue","Winter Brook Dr","Winter Court",
            "Winter Creek Rd","Winter Dr","Winter Garden Vineland Road","Winter Gardens Dr","Winter Haven Ln",
            "Winter Hill Ln","Winter Lily Ct","Winter Ln","Winter Oak Way","Winter Park Ave","Winter Park Dr",
            "Winter Rd","Winter Set Dr","Winter St","Winter Street","Winter Trl","Winter Way","Winterberry Ct",
            "Winterberry Lane","Winterberry Ln","Winterberry Rd","Winterbourne Drive","Winterbrook Way",
            "Winterburn Pl","Wintercreek Way","Wintercrest St","Wintergreen Ct","Wintergreen Dr","Wintergreen Grove",
            "Wintergreen Rd","Wintermute Rd","Winterpark Dr","Winterpark Mobile Home Park","Winterport Court",
            "Winters Ave","Winters Rd","Winterton Way","Winterview Dr","Winterville Road","Winterwind Cir",
            "Winterwood Way SE","Winther Way","Winthorpe Road","Winthrop Avenue","Winthrop Court",
            "Winthrop Dr","Winthrop Pl","Winthrop Rd","Winthrop St","Winthrop Street","Winton Ct","Winton Pky",
            "Winton Pl","Winton Place Design Ctr","Winton Rd","Winton Road","Winton St","Wintun Ct","Winway Ct",
            "Winwood Ln","Winyah Ave","Wipple Way","Wirble Rd","Wire Rd","Wiregrass Rd","Wirht Ave","Wis Dnr Road & Land",
            "Wisconsin St","Wisdom Pl","Wise Rd","Wiseman Court","Wiser Rd","Wish Cir","Wishart St","Wishaw Ct",
            "Wishbone Cir E","Wishbone Circle West","Wishbone Rd","Wishing Well Cir","Wishing Well Drive",
            "Wishing Well Rd","Wisker Avenue","Wisner Road","Wisner St NE","Wisniewicz Rd","Wissa Powey Trl",
            "Wissahickon Trl","Wisse Ct","Wissinoming St","Wister Rd","Wisteria Ave","Wisteria Ct","Wisteria Dr",
            "Wisteria Ln","Wisteria Rd","Wisteria Road","Wisteria Shade Ave","Wisteria St","Witch Hazel Rd",
            "Witch Trot Ln","Witham Ln","Withee St","Witherbee Avenue","Witherbee Terrace","Withers Street",
            "Withrow Avenue","Witmer Road","Witrey Road","Witry Ct","Witt Ln","Witte St","Witteman Pl","Witter Street",
            "Wittich Ter","Witts End Dr","Wittum Way","Witwer St NE","Wixom St","Wmeco Access Road","Wo To Ga Pass",
            "Woburn Avenue","Woburn Woods Lane","Woehr Ave","Wofford Heights Blvd","Wolahi Rd","Wolcott Ln",
            "Wolcott Rd","Wolcott Road","Wolcott Street","Wolcott Woods","Wolf Bay Ter","Wolf Canyon Rd",
            "Wolf Cir","Wolf Creek Ct","Wolf Creek Rd","Wolf Ct","Wolf Hill Rd","Wolf Lake Dr","Wolf Lake Rd",
            "Wolf Ln","Wolf Pond Rd","Wolf Rd","Wolf Run","Wolf Run Rd","Wolf Springs Rd N","Wolf St","Wolf Street",
            "Wolf Trl","Wolfanger Hill Rd","Wolfback Ridge Rd","Wolfe Island Ferry Dock","Wolfe Rd",
            "Wolfer Rd","Wolfersdorf Rd","Wolff St","Wolfgang Rd","Wolfinger Way","Wolford Ct","Wolford Rd",
            "Wolfrey Avenue","Wolkoff Ln","Wollacott St","Wollaston Road S","Wolseley Avenue","Wolsely Street",
            "Wolverhampton Place","Wolverine","Wolverine Blvd NE","Wolverine Dr","Wolverine St","Wolverines Ln",
            "Wolverton Avenue","Wolverton Dr","Wolverton St","Wolverton Way","Womack Rd","Womble Silver Rd",
            "Wompatuck Road","Womrath St","Wonalancet Rd","Wonder Lake Dr","Wonder Ln","Wonderment Way",
            "Wood","Wood Acres","Wood Aly","Wood Ave","Wood Avenue","Wood Canyon Rd","Wood Canyon Trail",
            "Wood Cir","Wood Dale Ct","Wood Dr","Wood Duck Avenue","Wood Duck Lake Game Tr","Wood Haven Ln",
            "Wood Haven St","Wood Hill Rd","Wood Land Rd","Wood Lark Dr","Wood Ln","Wood Mill Pl","Wood Park Dr",
            "Wood Pl","Wood Ranch Dr","Wood Ranch Rd","Wood Rd","Wood Rive Bend","Wood River Cir","Wood Road",
            "Wood Sorrel Way","Wood St","Wood Stone Rd","Wood Street","Wood Thrush Ave","Wood Thrush Avenue",
            "Wood Thrush Cir","Wood Turtle Ct","Wood Valley Rd","Wood Way","Woodacre Rd","Woodale Ave",
            "Woodale Road","Woodall St","Woodard Pl","Woodard Rd","Woodard Valley","Woodbank Pl","Woodbend Ct",
            "Woodberry Rd","Woodbine","Woodbine Ave","Woodbine Avenue","Woodbine Lane","Woodbine Ln",
            "Woodbine Pl","Woodbine Rd","Woodbine Road","Woodbine St","Woodbine Street","Woodbound Rd",
            "Woodbriar Dr","Woodbriar Ln","Woodbridge Ave","Woodbridge Centre Dr","Woodbridge Cir",
            "Woodbridge Commons Way","Woodbridge Dr","Woodbridge Rd","Woodbridge St","Woodbridge Street",
            "Woodbridge Way","Woodbrook Cir","Woodbrook Ct","Woodbrook Dr","Woodbrook Rd","Woodbrook Road",
            "Woodbrooke Rd","Woodburne Dr","Woodbury","Woodbury Ave","Woodbury Avenue","Woodbury Court",
            "Woodbury Ct","Woodbury Dr","Woodbury Glassboro Rd","Woodbury Ln","Woodbury Rd","Woodbury St",
            "Woodchase Dr","Woodchopper Spring","Woodchuck Ct","Woodchuck Hill Rd","Woodchuck Hill Road",
            "Woodchuck Hollow","Woodchuck Rd","Woodcliff Ave","Woodcliff Ct","Woodcliff Drive","Woodcliff St",
            "Woodcliff Way","Woodcliffe Ter","Woodcock Rd","Woodcock Street","Woodcraft Way","Woodcreek Ct",
            "Woodcreek Xing","Woodcrest Circle","Woodcrest Court","Woodcrest Ct","Woodcrest Dr","Woodcrest Drive",
            "Woodcrest Ln","Woodcrest Rd","Woodcrest Road","Wooddale Ave","Wooddale Dr","Wooddale Rd",
            "Wooded Acres Dr","Wooded Bluff","Wooded Way Dr","Woodeden Drive","Woodeden Road","Wooden Ave",
            "Wooden Valley Rd","Woodfern Dr SE","Woodfield Ct","Woodfield Dr","Woodfield Ln","Woodfield Rd",
            "Woodfield Road","Woodflower","Woodford Ln","Woodford Rd","Woodford Tehachapi Rd","Woodford-Tehachapi Rd",
            "Woodgate Ave","Woodgate Road","Woodgate Street","Woodglen Dr","Woodglen Drive","Woodglen Ln",
            "Woodham Rd","Woodhaven Blvd SW","Woodhaven Crescent","Woodhaven Ct","Woodhaven Dr","Woodhaven Pl",
            "Woodhaven Rd","Woodhaven Way","Woodhill","Woodhill Ave","Woodhill Ln","Woodhills Way","Woodhollow Dr",
            "Woodhouse Crescent","Woodhull Hedgesville Rd","Woodhull St","Woodhurst Crescent","Woodin Rd",
            "Woodingham","Woodlake Ct","Woodland","Woodland Acres","Woodland Acres Crescent","Woodland Ave",
            "Woodland Ave NW","Woodland Ave SW","Woodland Avenue","Woodland Chase Blvd","Woodland Cir",
            "Woodland Cove Ct","Woodland Ct","Woodland Ct N","Woodland Dr","Woodland Drive","Woodland Estates Dr",
            "Woodland Forrest Dr","Woodland Hill Rd","Woodland Hills Blvd","Woodland Hills Cir",
            "Woodland Hills Dr","Woodland Hills Rd","Woodland Hts","Woodland Ln","Woodland Pl","Woodland Rd",
            "Woodland Road","Woodland St","Woodland St NE","Woodland Street","Woodland Ter","Woodland Trail",
            "Woodland Trce","Woodland Trl","Woodland Villa Cir","Woodland Way","Woodlands Ave","Woodlands Rd",
            "Woodlane Rd","Woodlark Ct","Woodlark Ln","Woodlark Pl","Woodlawn Ave","Woodlawn Ave SE",
            "Woodlawn Avenue","Woodlawn Cir","Woodlawn Ct","Woodlawn Dr","Woodlawn Rd","Woodlawn Road",
            "Woodlawn Ter","Woodledge Dr","Woodlee Ct","Woodlee Rd","Woodleigh Ln","Woodleigh Rd","Woodlen Rd",
            "Woodley Ct","Woodley Rd","Woodlot Crescent","Woodlot Ct","Woodman Creek Rd","Woodman Village Driveway",
            "Woodmansee Ave","Woodmansee Way","Woodmark Dr NE","Woodmeadow Ln","Woodmere Ave","Woodmere Pl",
            "Woodmere St","Woodmont Avenue","Woodmont Dr","Woodmont Rd","Woodmore St","Woodmount Avenue",
            "Woodmount Crescent","Woodnut Pl","Woodpecker Ridge","Woodpecker Rte","Woodport Rd","Woodrick Ave",
            "Woodridge Cir","Woodridge Ct","Woodridge Dr","Woodridge Rd","Woodridge Road","Woodring St",
            "Woodroe Ave","Woodrose Dr","Woodrow Ave","Woodrow Avenue","Woodrow Bean Transmountain Rd",
            "Woodrow Bean Transmoutain Rd","Woodrow Pate Rd","Woodrow Rd","Woodrow St","Woodrow Street",
            "Woodrow Terrace","Woodruff Ave","Woodruff Ln","Woodruff Pl","Woodruff Rd","Woodrun Ct","Woods Ave",
            "Woods Blvd","Woods Ct","Woods Dr","Woods Edge Ave","Woods Edge Ct","Woods Edge Dr","Woods End Rd",
            "Woods Ferry Rd","Woods Hill Rd","Woods Ln","Woods Pl","Woods Rd","Woods St","Woods Trail","Woods View Ln",
            "Woods Way","Woodsdale Ct","Woodsedge Dr","Woodsend Dr","Woodsfield Ct","Woodshed Rd","Woodshire N",
            "Woodside Aly","Woodside Ave","Woodside Ave NE","Woodside Avenue","Woodside Cir","Woodside Circle",
            "Woodside Court","Woodside Cv","Woodside Dr","Woodside Dr S","Woodside Drive","Woodside Ln",
            "Woodside Pl","Woodside Rd","Woodside St","Woodside Trl","Woodside Way","Woodson Ave","Woodsong Dr",
            "Woodspring Cir","Woodsprings Rd","Woodstock Ave","Woodstock Ct","Woodstock Dr","Woodstock Rd",
            "Woodstone Avenue","Woodstone Pl","Woodstone Rd","Woodstown Rd","Woodstream Ct","Woodsway Rd",
            "Woodthrush Cir","Woodthrush Court","Woodthrush Trl W","Woodtrail Court","Woodvale Loop",
            "Woodvalley Ct","Woodview Avenue","Woodview Ct","Woodview Dr","Woodview Rd","Woodview Road",
            "Woodville Ave","Woodville Avenue","Woodville Drive","Woodville Road","Woodward","Woodward Ave",
            "Woodward Avenue","Woodward Ct NE","Woodward Dr","Woodward Heights Way","Woodward Rd",
            "Woodward St","Woodwardia Ave","Woodway Dr","Woodwind Way","Woodwinds Hill Dr","Woodworth Rd",
            "Woodworth Way","Woody Ln","Woody Rd","Woodycrest Ave","Wool St","Woolenscote Circle","Wooley Rd",
            "Wooley St","Wooley Way","Woolley Ave","Woollomes Ave","Woolman Ct","Woolman Dr","Woolman Ln",
            "Woolsey Ct","Woolsley Ct","Woolston Dr","Woolverton Rd","Woolworth Street","Wooster Ave",
            "Wooster Smith Dr","Wooten Dr","Wootten Way South","Worcester Ave","Worcester Avenue",
            "Worcester Court","Worcester Providence Turnpike","Worcester Road","Worcester Square",
            "Worcester St","Worcester Street","Worcester Street Branch","Worchester Dr","Worden Ave",
            "Worden Cemetery Rd","Wordsworth Rd","Worekowsky Rd","Worington Dr","Work Right Cir","Work St",
            "Workman Ct","Workman Pl","Workman Rd","Workman St","Worl Ave","World Trade Center Road",
            "World Way W","Worman Dr","Wormell Rd","Wormer","Wornkey Bend","Worster Ave","Worth Ave","Worth Dr",
            "Worth Rd","Worth St","Worth Street","Worthen Dr","Worthen St","Worthey Trl","Worthigton Drive",
            "Worthington Avenue","Worthington Crescent","Worthington Dr","Worthington Rd","Worthington Road",
            "Worthington St","Worthington Way","Wortman Rd","Worzel Rd","Wotten Road","Wpc Road","Wrangle Hill Road",
            "Wrangler Ct","Wrangler Rd","Wrangler Way","Wray St NE","Wren","Wren Ct","Wren Dr","Wren Ln","Wren Loop",
            "Wren Rd","Wren St","Wren Way","Wrentham Rd","Wrenwood Ave","Wrenwood Court","Wrenwood Dr","Wrexham Ct",
            "Wrexham Rd","Wrick Ave","Wright Ave","Wright Avenue","Wright Cir","Wright Crescent","Wright Ct",
            "Wright Debow Rd","Wright Dr","Wright Drive","Wright Ln","Wright Park","Wright Pl","Wright Rd",
            "Wright St","Wright Street","Wright Ter","Wright Way","Wrighter Lake Rd","Wrightman Way",
            "Wrights Ave","Wrights Ct","Wrightstown Cookstown Rd","Wrightstown Georgetown Rd","Wrightwood Dr",
            "Wrigley Rd","Wrong Way Rd","Wsmr P Route 20","Wsmr S Route 301","Wsmr S Route 324","Wsmr S Route 3606",
            "Wsmr S Route 3617","Wsmr S Route 3702","Wsmr S Route 3703","Wsmr S Route 3806","Wsmr S Rt 202",
            "Wsmr S Rt 297","Wulff Rd","Wupatki Ln","Wurtz St","Wyalong Way","Wyandemere Dr","Wyandot Rd",
            "Wyandotte Ave","Wyandotte Rd","Wyandotte Street","Wyant Rd","Wyatt Ave","Wyatt Court","Wychwood Avenue",
            "Wychwood Drive","Wychwood Rd","Wyckerly Dr","Wyckoff Ave","Wyckoff Avenue","Wyckoff Dr",
            "Wyckoff Mills Rd","Wyckoff St","Wyckwood Ct","Wycliff Ct","Wycliffe Way","Wycombe Dr","Wye Bridge Dr",
            "Wye Valley Road","Wyers Dr","Wyett Ln","Wykoff Way","Wykoff Way; Blue Bird Canyon Dr",
            "Wylie Road-Horton Rd","Wylie St","Wyllis Hill","Wylly Rd","Wyllys Street","Wyly Ct","Wyman Rd",
            "Wymanlea Avenue","Wynard Rd","Wynatt Dr","Wynatt St","Wynbrooke Ct","Wyncrest Rd","Wyndale Ave",
            "Wyndam Rd","Wyndate Dr","Wyndcliff Crescent","Wyndcliffe Ln","Wyndemere Ave","Wyndermere Way",
            "Wyndham Ct","Wyndham Dr","Wyndham Ln","Wyndham Pl","Wyndham Rd","Wyndmoor Dr","Wyndmoor Rd",
            "Wyndmoor Way","Wyndridge Cir","Wyndwood Rd","Wynes Road","Wynfield Ln","Wynford Drive","Wyngate Ter",
            "Wynne Ave","Wynne Rd","Wynnefield Ave","Wynnewood Ct","Wynnewood Dr","Wynstra Ln","Wyo Rd",
            "Wyola Dr","Wyoming Ave","Wyoming Avenue","Wyoming Blvd","Wyoming Dr","Wyoming Street","Wyoming Trl",
            "Wysocki Drive","Wystone Ave","Wythe Avenue","Wythe Place","Wythe Way","Wytoshi Way","Wyworry Ln",
            "X-B Mhp","X4 Ave","Xander Loop","Xavier Ave","Xavier St","Xenia Ct","Xochimilco","Y St S","Y-10",
            "Yacht Ave","Yacht Club Cv","Yadanza Ct","Yafa Ct","Yager Ave","Yahi Trail","Yahweh Ct","Yakima Ct",
            "Yale Ave","Yale Ave NW","Yale Crescent","Yale Ct","Yale Dr","Yale Drive","Yale Extended","Yale Lane",
            "Yale Pl","Yale Rd","Yale Road","Yale St","Yale Street","Yale Ter","Yalta Ct NE","Yamaha Rd","Yampa St",
            "Yanavitch Rd","Yankee Ct","Yankee Division Highway","Yankee Hill Rd","Yankee Line","Yankee St",
            "Yaqui Gulch Rd","Yarboro Dr","Yarbrough Ln","Yard Ave","Yard Drive","Yardgate Way","Yardley Newtown Rd",
            "Yardley Rd","Yardley Station Dr","Yardley Way","Yarker Road","Yarmouth Ave","Yarmouth Ct",
            "Yarmouth Dr","Yarmouth Rd","Yarnall St","Yarnell St","Yarrow Ct","Yarrow Ln","Yarrow Pl","Yarrow Way",
            "Yasi Terrace","Yasui Ct","Yates Ave","Yates Ave South Access Rd","Yates Ln","Yates Pl","Yates Rd",
            "Yates St","Yates Street","Yatescastle Drive","Yava Rd","Yavapai Dr","Yavapai St","Yaw Bridge Rd",
            "Yax Rd","Yazzie Ln","Ybarra Dr","Ye Olde Hwy","Yeager Rd","Yeargin Aly","Yearling Trl","Yecla Ln",
            "Yeger Rd","Yehnen Road 2","Yehnen Side Road 2","Yelder Rd","Yellow Avens Boulevard","Yellow Creek Rd",
            "Yellow Dog Trl","Yellow Hammer Rd","Yellow Marigold Ct","Yellow Oak Dr","Yellow Pine Ave",
            "Yellow Pine Dr","Yellow River","Yellow Rose Ct","Yellowbrick Rd","Yellowhea Trail","Yellowpine St NW",
            "Yellowstone Dr","Yellowstone Rd","Yellowstone River Dr","Yellowstone Way","Yellowtail Way",
            "Yelping Hill Rd","Yeoman Avenue","Yeomans Way","Yerba Santa Rd","Yerba St","Yeschek Ln",
            "Yespe Ct","Yettford Rd","Yew Court","Yew Dr","Ygnacio Valley Rd","Yishuv Pky","Yitha Ct","Yoakim Rd",
            "Yock Wock Rd","Yoda Ct","Yoho Avenue","Yokley Cv","Yolanda Way","Yolla Bolla Ct","Yolla Bolly Rd",
            "Yonge Street","Yonge Street North","Yorba Ave","Yorba Linda Blvd","Yorba Linda Pl","Yori Ave",
            "York","York Aly","York Ave","York Avenue","York Boulevard","York Ct","York Dr","York Gate Boulevard",
            "York Ln","York Mills Road","York Mountain Rd","York Pl SW","York Place","York Pond Rd","York Rd",
            "York Ridge Road","York Road","York St","York Street","York University Busway","York Way",
            "York-Durh Line","Yorkdale Crescent","Yorkharbor Ln","Yorkleigh Avenue","Yorkminster Road",
            "Yorksboro Ln","Yorkship Sq","Yorkshire Blvd","Yorkshire Ct","Yorkshire Cv","Yorkshire Dr",
            "Yorkshire Ln","Yorkshire Pl","Yorkshire Rd","Yorkshire St","Yorktown","Yorktown Colony",
            "Yorktown Ct","Yorktown Dr","Yorktown Ln","Yorktown Pl","Yorktown Rd","Yorkville Dr","Yorkville Drive",
            "Yorkville Ranch Rd","Yoruba Rd NE","Yosemite Arms Apartment","Yosemite Avenue","Yosemite Ct",
            "Yosemite Dr","Yosemite Falls Ave","Yosemite National Park Rd","Yosemite Oaks Rd","Yosemite Pl",
            "Yosemite Rd","Yosky Rd","Yost Pl","Yost Ranch Rd","Yost School Rd","Youmans Dr","Young Crescent",
            "Young Ln","Young Pl","Young St","Young St NE","Young Street","Young Way","Young Wo Cir","Young's P Road",
            "Youngdale St","Youngs Ln","Youngs Rd","Youngstown Ave","Youngstown Ln","Youngstown Rd","Youngstown Salem Rd",
            "Youngwood Cir","Yqui St","Ysela Ave","Yuba Cir","Yuba Pass Rd","Yucatan Ave","Yucatan Road",
            "Yucatan St","Yucatan Way","Yucca Ave","Yucca Ct","Yucca Dr","Yucca Heights","Yucca Ln N","Yucca Ranch Rd",
            "Yucca Street","Yucca Tree Ct","Yucca Trl","Yuen-Veritas Ln","Yuile Court","Yukon Annex",
            "Yukon Ave","Yukon Ct NW","Yukon Dr","Yukon Drive","Yukon Place","Yukon Rd","Yukon Street","Yulewood Cir",
            "Yuma Ave","Yuma Ln","Yuma St","Yuma Trl","Yverdon Ct","Yvonne Ave","Yvonne Avenue","Yvonne Cir",
            "Yvonne Ct","Yvonne Ln","Yvonne Street","Yvonne Way","Z St","Zablo Ln","Zabriskie Ave","Zacatepec",
            "Zach Ct","Zachary Ln","Zachery Ln","Zack Williams Rd","Zackery Ct","Zadek Rd","Zafra Ct","Zagaway",
            "Zalewski Dr","Zambrano Dr","Zan Dr","Zan St","Zana Pl NE","Zanes Rd","Zanleoni Pl","Zante Court",
            "Zapata Cir","Zapata Pl","Zaph Avenue","Zappettini Ct","Zaragoza View","Zarate Ct","Zator Avenue",
            "Zaunerowicz Rd","Zebley Shore Rd E","Zee Street","Zehndner Ave","Zeigler Rd","Zeke Rd","Zekes Rd",
            "Zelkovia Ln","Zellwood St","Zeman Ave","Zemic Rd","Zenaida Ln","Zenner St","Zenta Rd","Zenway Boulevard",
            "Zep Rd W","Zepher Rd","Zephyr Ave","Zephyr Cove Ct","Zephyr Road","Zerker Rd","Zermatt Dr",
            "Zertucne Rd","Zeus Ct","Zhigag Dr","Zia Rd","Zia Trce","Ziba Ln","Ziblut Ct","Ziegler Dr","Zierdt Rd",
            "Ziggy Ct","Zils Rd","Zimm Ln","Zimmer Dr","Zimmer Rd","Zimmer Spur","Zimmerman Ct","Zimmerman Ln",
            "Zimmerman Ranch Rd","Zimmerman Rd","Zimny Rd","Zina Way","Zinc Cuttoff Rd N","Zinc Mine Rd",
            "Zinc St","Zinfandel Ln","Zinfindel St","Zink Dr","Zink Ln","Zio Carlo Drive","Zion Loop","Zion Pl",
            "Zion St","Zion Way","Zircon Cir","Zircon Ct","Zircon Ln","Zircon Way","Zirkel Ave","Zlotkin Cir",
            "Zoar Ave","Zoar Road","Zoar St","Zoba Dr","Zodiak Ave","Zoe St","Zola Ave","Zolad Rd","Zolder St",
            "Zonesco Ct NE","Zoo Drive North","Zoological St","Zorich Rd","Zorn Ln","Zoro Ln","Zugibe Ct",
            "Zula Dr","Zuma Ridge Mtwy","Zuni Ct SE","Zuni Dr","Zuni Ln","Zuni Rd SE","Zuni St","Zupan Ave",
            "Zurcher Ave","Zurlo Way","Zwellino Ln","Zwiefel Rd"];
        self.Address1 = str(random.randint(1, 9999)) + ' ' + random.choice(streets);
        return;
    
    def address3(self, zip, city, county, state):
        zips = { "00501": { "city" : "HOLTSVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "01001": { "city" : "AGAWAM", "state" : "MA", "county" : "HAMPDEN" },
            "01002": { "city" : "AMHERST", "state" : "MA", "county" : "HAMPSHIRE" },
            "01003": { "city" : "AMHERST", "state" : "MA", "county" : "HAMPSHIRE" },
            "01004": { "city" : "AMHERST", "state" : "MA", "county" : "HAMPSHIRE" },
            "01005": { "city" : "BARRE", "state" : "MA", "county" : "WORCESTER" },
            "01007": { "city" : "BELCHERTOWN", "state" : "MA", "county" : "HAMPSHIRE" },
            "01008": { "city" : "BLANDFORD", "state" : "MA", "county" : "HAMPDEN" },
            "01009": { "city" : "BONDSVILLE", "state" : "MA", "county" : "HAMPDEN" },
            "01010": { "city" : "BRIMFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01011": { "city" : "CHESTER", "state" : "MA", "county" : "HAMPDEN" },
            "01012": { "city" : "CHESTERFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01013": { "city" : "CHICOPEE", "state" : "MA", "county" : "HAMPDEN" },
            "01014": { "city" : "CHICOPEE", "state" : "MA", "county" : "HAMPDEN" },
            "01020": { "city" : "CHICOPEE", "state" : "MA", "county" : "HAMPDEN" },
            "01021": { "city" : "CHICOPEE", "state" : "MA", "county" : "HAMPDEN" },
            "01022": { "city" : "CHICOPEE", "state" : "MA", "county" : "HAMPDEN" },
            "01026": { "city" : "CUMMINGTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01027": { "city" : "EASTHAMPTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01028": { "city" : "EAST LONGMEADOW", "state" : "MA", "county" : "HAMPDEN" },
            "01029": { "city" : "EAST OTIS", "state" : "MA", "county" : "BERKSHIRE" },
            "01030": { "city" : "FEEDING HILLS", "state" : "MA", "county" : "HAMPDEN" },
            "01031": { "city" : "GILBERTVILLE", "state" : "MA", "county" : "WORCESTER" },
            "01032": { "city" : "GOSHEN", "state" : "MA", "county" : "HAMPSHIRE" },
            "01033": { "city" : "GRANBY", "state" : "MA", "county" : "HAMPSHIRE" },
            "01034": { "city" : "GRANVILLE", "state" : "MA", "county" : "HAMPDEN" },
            "01035": { "city" : "HADLEY", "state" : "MA", "county" : "HAMPSHIRE" },
            "01036": { "city" : "HAMPDEN", "state" : "MA", "county" : "HAMPDEN" },
            "01037": { "city" : "HARDWICK", "state" : "MA", "county" : "WORCESTER" },
            "01038": { "city" : "HATFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01039": { "city" : "HAYDENVILLE", "state" : "MA", "county" : "HAMPSHIRE" },
            "01040": { "city" : "HOLYOKE", "state" : "MA", "county" : "HAMPDEN" },
            "01041": { "city" : "HOLYOKE", "state" : "MA", "county" : "HAMPDEN" },
            "01050": { "city" : "HUNTINGTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01053": { "city" : "LEEDS", "state" : "MA", "county" : "HAMPSHIRE" },
            "01054": { "city" : "LEVERETT", "state" : "MA", "county" : "FRANKLIN" },
            "01056": { "city" : "LUDLOW", "state" : "MA", "county" : "HAMPDEN" },
            "01057": { "city" : "MONSON", "state" : "MA", "county" : "HAMPDEN" },
            "01059": { "city" : "NORTH AMHERST", "state" : "MA", "county" : "HAMPSHIRE" },
            "01060": { "city" : "NORTHAMPTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01061": { "city" : "NORTHAMPTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01062": { "city" : "FLORENCE", "state" : "MA", "county" : "HAMPSHIRE" },
            "01063": { "city" : "NORTHAMPTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01066": { "city" : "NORTH HATFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01068": { "city" : "OAKHAM", "state" : "MA", "county" : "WORCESTER" },
            "01069": { "city" : "PALMER", "state" : "MA", "county" : "HAMPDEN" },
            "01070": { "city" : "PLAINFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01071": { "city" : "RUSSELL", "state" : "MA", "county" : "HAMPDEN" },
            "01072": { "city" : "SHUTESBURY", "state" : "MA", "county" : "FRANKLIN" },
            "01073": { "city" : "SOUTHAMPTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01074": { "city" : "SOUTH BARRE", "state" : "MA", "county" : "WORCESTER" },
            "01075": { "city" : "SOUTH HADLEY", "state" : "MA", "county" : "HAMPSHIRE" },
            "01077": { "city" : "SOUTHWICK", "state" : "MA", "county" : "HAMPDEN" },
            "01079": { "city" : "THORNDIKE", "state" : "MA", "county" : "HAMPDEN" },
            "01080": { "city" : "THREE RIVERS", "state" : "MA", "county" : "HAMPDEN" },
            "01081": { "city" : "WALES", "state" : "MA", "county" : "HAMPDEN" },"01082": { "city" : "WARE", "state" : "MA", "county" : "HAMPSHIRE" },
            "01083": { "city" : "WARREN", "state" : "MA", "county" : "WORCESTER" },
            "01084": { "city" : "WEST CHESTERFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01085": { "city" : "WESTFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01086": { "city" : "WESTFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01088": { "city" : "WEST HATFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01089": { "city" : "WEST SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01090": { "city" : "WEST SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01092": { "city" : "WEST WARREN", "state" : "MA", "county" : "WORCESTER" },
            "01093": { "city" : "WHATELY", "state" : "MA", "county" : "FRANKLIN" },
            "01094": { "city" : "WHEELWRIGHT", "state" : "MA", "county" : "WORCESTER" },
            "01095": { "city" : "WILBRAHAM", "state" : "MA", "county" : "HAMPDEN" },
            "01096": { "city" : "WILLIAMSBURG", "state" : "MA", "county" : "HAMPSHIRE" },
            "01098": { "city" : "WORTHINGTON", "state" : "MA", "county" : "HAMPSHIRE" },
            "01101": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01102": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01103": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01104": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01105": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01106": { "city" : "LONGMEADOW", "state" : "MA", "county" : "HAMPDEN" },
            "01107": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01108": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01109": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01111": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01115": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01116": { "city" : "LONGMEADOW", "state" : "MA", "county" : "HAMPDEN" },
            "01118": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01119": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01128": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01129": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01138": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01139": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01144": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01151": { "city" : "INDIAN ORCHARD", "state" : "MA", "county" : "HAMPDEN" },
            "01199": { "city" : "SPRINGFIELD", "state" : "MA", "county" : "HAMPDEN" },
            "01201": { "city" : "PITTSFIELD", "state" : "MA", "county" : "BERKSHIRE" },
            "01202": { "city" : "PITTSFIELD", "state" : "MA", "county" : "BERKSHIRE" },
            "01203": { "city" : "PITTSFIELD", "state" : "MA", "county" : "BERKSHIRE" },
            "01220": { "city" : "ADAMS", "state" : "MA", "county" : "BERKSHIRE" },
            "01222": { "city" : "ASHLEY FALLS", "state" : "MA", "county" : "BERKSHIRE" },
            "01223": { "city" : "BECKET", "state" : "MA", "county" : "BERKSHIRE" },
            "01224": { "city" : "BERKSHIRE", "state" : "MA", "county" : "BERKSHIRE" },
            "01225": { "city" : "CHESHIRE", "state" : "MA", "county" : "BERKSHIRE" },
            "01226": { "city" : "DALTON", "state" : "MA", "county" : "BERKSHIRE" },
            "01227": { "city" : "DALTON", "state" : "MA", "county" : "BERKSHIRE" },
            "01229": { "city" : "GLENDALE", "state" : "MA", "county" : "BERKSHIRE" },
            "01230": { "city" : "GREAT BARRINGTON", "state" : "MA", "county" : "BERKSHIRE" },
            "01235": { "city" : "HINSDALE", "state" : "MA", "county" : "BERKSHIRE" },
            "01236": { "city" : "HOUSATONIC", "state" : "MA", "county" : "BERKSHIRE" },
            "01237": { "city" : "LANESBORO", "state" : "MA", "county" : "BERKSHIRE" },
            "01238": { "city" : "LEE", "state" : "MA", "county" : "BERKSHIRE" },"01240": { "city" : "LENOX", "state" : "MA", "county" : "BERKSHIRE" },
            "01242": { "city" : "LENOX DALE", "state" : "MA", "county" : "BERKSHIRE" },
            "01243": { "city" : "MIDDLEFIELD", "state" : "MA", "county" : "HAMPSHIRE" },
            "01244": { "city" : "MILL RIVER", "state" : "MA", "county" : "BERKSHIRE" },
            "01245": { "city" : "MONTEREY", "state" : "MA", "county" : "BERKSHIRE" },
            "01247": { "city" : "NORTH ADAMS", "state" : "MA", "county" : "BERKSHIRE" },
            "01252": { "city" : "NORTH EGREMONT", "state" : "MA", "county" : "BERKSHIRE" },
            "01253": { "city" : "OTIS", "state" : "MA", "county" : "BERKSHIRE" },
            "01254": { "city" : "RICHMOND", "state" : "MA", "county" : "BERKSHIRE" },
            "01255": { "city" : "SANDISFIELD", "state" : "MA", "county" : "BERKSHIRE" },
            "01256": { "city" : "SAVOY", "state" : "MA", "county" : "BERKSHIRE" },
            "01257": { "city" : "SHEFFIELD", "state" : "MA", "county" : "BERKSHIRE" },
            "01258": { "city" : "SOUTH EGREMONT", "state" : "MA", "county" : "BERKSHIRE" },
            "01259": { "city" : "SOUTHFIELD", "state" : "MA", "county" : "BERKSHIRE" },
            "01260": { "city" : "SOUTH LEE", "state" : "MA", "county" : "BERKSHIRE" },
            "01262": { "city" : "STOCKBRIDGE", "state" : "MA", "county" : "BERKSHIRE" },
            "01264": { "city" : "TYRINGHAM", "state" : "MA", "county" : "BERKSHIRE" },
            "01266": { "city" : "WEST STOCKBRIDGE", "state" : "MA", "county" : "BERKSHIRE" },
            "01267": { "city" : "WILLIAMSTOWN", "state" : "MA", "county" : "BERKSHIRE" },
            "01270": { "city" : "WINDSOR", "state" : "MA", "county" : "BERKSHIRE" },
            "01301": { "city" : "GREENFIELD", "state" : "MA", "county" : "FRANKLIN" },
            "01302": { "city" : "GREENFIELD", "state" : "MA", "county" : "FRANKLIN" },
            "01330": { "city" : "ASHFIELD", "state" : "MA", "county" : "FRANKLIN" },
            "01331": { "city" : "ATHOL", "state" : "MA", "county" : "WORCESTER" },
            "01337": { "city" : "BERNARDSTON", "state" : "MA", "county" : "FRANKLIN" },
            "01338": { "city" : "BUCKLAND", "state" : "MA", "county" : "FRANKLIN" },
            "01339": { "city" : "CHARLEMONT", "state" : "MA", "county" : "FRANKLIN" },
            "01340": { "city" : "COLRAIN", "state" : "MA", "county" : "FRANKLIN" },
            "01341": { "city" : "CONWAY", "state" : "MA", "county" : "FRANKLIN" },
            "01342": { "city" : "DEERFIELD", "state" : "MA", "county" : "FRANKLIN" },
            "01343": { "city" : "DRURY", "state" : "MA", "county" : "BERKSHIRE" },
            "01344": { "city" : "ERVING", "state" : "MA", "county" : "FRANKLIN" },
            "01346": { "city" : "HEATH", "state" : "MA", "county" : "FRANKLIN" },
            "01347": { "city" : "LAKE PLEASANT", "state" : "MA", "county" : "FRANKLIN" },
            "01349": { "city" : "MILLERS FALLS", "state" : "MA", "county" : "FRANKLIN" },
            "01350": { "city" : "MONROE BRIDGE", "state" : "MA", "county" : "FRANKLIN" },
            "01351": { "city" : "MONTAGUE", "state" : "MA", "county" : "FRANKLIN" },
            "01354": { "city" : "GILL", "state" : "MA", "county" : "FRANKLIN" },"01355": { "city" : "NEW SALEM", "state" : "MA", "county" : "FRANKLIN" },
            "01360": { "city" : "NORTHFIELD", "state" : "MA", "county" : "FRANKLIN" },
            "01364": { "city" : "ORANGE", "state" : "MA", "county" : "FRANKLIN" },
            "01366": { "city" : "PETERSHAM", "state" : "MA", "county" : "WORCESTER" },
            "01367": { "city" : "ROWE", "state" : "MA", "county" : "FRANKLIN" },"01368": { "city" : "ROYALSTON", "state" : "MA", "county" : "WORCESTER" },
            "01370": { "city" : "SHELBURNE FALLS", "state" : "MA", "county" : "FRANKLIN" },
            "01373": { "city" : "SOUTH DEERFIELD", "state" : "MA", "county" : "FRANKLIN" },
            "01375": { "city" : "SUNDERLAND", "state" : "MA", "county" : "FRANKLIN" },
            "01376": { "city" : "TURNERS FALLS", "state" : "MA", "county" : "FRANKLIN" },
            "01378": { "city" : "WARWICK", "state" : "MA", "county" : "FRANKLIN" },
            "01379": { "city" : "WENDELL", "state" : "MA", "county" : "FRANKLIN" },
            "01380": { "city" : "WENDELL DEPOT", "state" : "MA", "county" : "FRANKLIN" },
            "01420": { "city" : "FITCHBURG", "state" : "MA", "county" : "WORCESTER" },
            "01430": { "city" : "ASHBURNHAM", "state" : "MA", "county" : "WORCESTER" },
            "01431": { "city" : "ASHBY", "state" : "MA", "county" : "MIDDLESEX" },
            "01432": { "city" : "AYER", "state" : "MA", "county" : "MIDDLESEX" },
            "01434": { "city" : "DEVENS", "state" : "MA", "county" : "MIDDLESEX" },
            "01436": { "city" : "BALDWINVILLE", "state" : "MA", "county" : "WORCESTER" },
            "01438": { "city" : "EAST TEMPLETON", "state" : "MA", "county" : "WORCESTER" },
            "01440": { "city" : "GARDNER", "state" : "MA", "county" : "WORCESTER" },
            "01441": { "city" : "WESTMINSTER", "state" : "MA", "county" : "WORCESTER" },
            "01450": { "city" : "GROTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01451": { "city" : "HARVARD", "state" : "MA", "county" : "WORCESTER" },
            "01452": { "city" : "HUBBARDSTON", "state" : "MA", "county" : "WORCESTER" },
            "01453": { "city" : "LEOMINSTER", "state" : "MA", "county" : "WORCESTER" },
            "01460": { "city" : "LITTLETON", "state" : "MA", "county" : "MIDDLESEX" },
            "01462": { "city" : "LUNENBURG", "state" : "MA", "county" : "WORCESTER" },
            "01463": { "city" : "PEPPERELL", "state" : "MA", "county" : "MIDDLESEX" },
            "01464": { "city" : "SHIRLEY", "state" : "MA", "county" : "MIDDLESEX" },
            "01467": { "city" : "STILL RIVER", "state" : "MA", "county" : "WORCESTER" },
            "01468": { "city" : "TEMPLETON", "state" : "MA", "county" : "WORCESTER" },
            "01469": { "city" : "TOWNSEND", "state" : "MA", "county" : "MIDDLESEX" },
            "01470": { "city" : "GROTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01471": { "city" : "GROTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01472": { "city" : "WEST GROTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01473": { "city" : "WESTMINSTER", "state" : "MA", "county" : "WORCESTER" },
            "01474": { "city" : "WEST TOWNSEND", "state" : "MA", "county" : "MIDDLESEX" },
            "01475": { "city" : "WINCHENDON", "state" : "MA", "county" : "WORCESTER" },
            "01477": { "city" : "WINCHENDON SPRINGS", "state" : "MA", "county" : "WORCESTER" },
            "01501": { "city" : "AUBURN", "state" : "MA", "county" : "WORCESTER" },
            "01503": { "city" : "BERLIN", "state" : "MA", "county" : "WORCESTER" },
            "01504": { "city" : "BLACKSTONE", "state" : "MA", "county" : "WORCESTER" },
            "01505": { "city" : "BOYLSTON", "state" : "MA", "county" : "WORCESTER" },
            "01506": { "city" : "BROOKFIELD", "state" : "MA", "county" : "WORCESTER" },
            "01507": { "city" : "CHARLTON", "state" : "MA", "county" : "WORCESTER" },
            "01508": { "city" : "CHARLTON CITY", "state" : "MA", "county" : "WORCESTER" },
            "01509": { "city" : "CHARLTON DEPOT", "state" : "MA", "county" : "WORCESTER" },
            "01510": { "city" : "CLINTON", "state" : "MA", "county" : "WORCESTER" },
            "01515": { "city" : "EAST BROOKFIELD", "state" : "MA", "county" : "WORCESTER" },
            "01516": { "city" : "DOUGLAS", "state" : "MA", "county" : "WORCESTER" },
            "01518": { "city" : "FISKDALE", "state" : "MA", "county" : "WORCESTER" },
            "01519": { "city" : "GRAFTON", "state" : "MA", "county" : "WORCESTER" },
            "01520": { "city" : "HOLDEN", "state" : "MA", "county" : "WORCESTER" },
            "01521": { "city" : "HOLLAND", "state" : "MA", "county" : "HAMPDEN" },
            "01522": { "city" : "JEFFERSON", "state" : "MA", "county" : "WORCESTER" },
            "01523": { "city" : "LANCASTER", "state" : "MA", "county" : "WORCESTER" },
            "01524": { "city" : "LEICESTER", "state" : "MA", "county" : "WORCESTER" },
            "01525": { "city" : "LINWOOD", "state" : "MA", "county" : "WORCESTER" },
            "01526": { "city" : "MANCHAUG", "state" : "MA", "county" : "WORCESTER" },
            "01527": { "city" : "MILLBURY", "state" : "MA", "county" : "WORCESTER" },
            "01529": { "city" : "MILLVILLE", "state" : "MA", "county" : "WORCESTER" },
            "01531": { "city" : "NEW BRAINTREE", "state" : "MA", "county" : "WORCESTER" },
            "01532": { "city" : "NORTHBOROUGH", "state" : "MA", "county" : "WORCESTER" },
            "01534": { "city" : "NORTHBRIDGE", "state" : "MA", "county" : "WORCESTER" },
            "01535": { "city" : "NORTH BROOKFIELD", "state" : "MA", "county" : "WORCESTER" },
            "01536": { "city" : "NORTH GRAFTON", "state" : "MA", "county" : "WORCESTER" },
            "01537": { "city" : "NORTH OXFORD", "state" : "MA", "county" : "WORCESTER" },
            "01538": { "city" : "NORTH UXBRIDGE", "state" : "MA", "county" : "WORCESTER" },
            "01540": { "city" : "OXFORD", "state" : "MA", "county" : "WORCESTER" },
            "01541": { "city" : "PRINCETON", "state" : "MA", "county" : "WORCESTER" },
            "01542": { "city" : "ROCHDALE", "state" : "MA", "county" : "WORCESTER" },
            "01543": { "city" : "RUTLAND", "state" : "MA", "county" : "WORCESTER" },
            "01545": { "city" : "SHREWSBURY", "state" : "MA", "county" : "WORCESTER" },
            "01550": { "city" : "SOUTHBRIDGE", "state" : "MA", "county" : "WORCESTER" },
            "01560": { "city" : "SOUTH GRAFTON", "state" : "MA", "county" : "WORCESTER" },
            "01561": { "city" : "SOUTH LANCASTER", "state" : "MA", "county" : "WORCESTER" },
            "01562": { "city" : "SPENCER", "state" : "MA", "county" : "WORCESTER" },
            "01564": { "city" : "STERLING", "state" : "MA", "county" : "WORCESTER" },
            "01566": { "city" : "STURBRIDGE", "state" : "MA", "county" : "WORCESTER" },
            "01568": { "city" : "UPTON", "state" : "MA", "county" : "WORCESTER" },
            "01569": { "city" : "UXBRIDGE", "state" : "MA", "county" : "WORCESTER" },
            "01570": { "city" : "WEBSTER", "state" : "MA", "county" : "WORCESTER" },
            "01571": { "city" : "DUDLEY", "state" : "MA", "county" : "WORCESTER" },
            "01580": { "city" : "WESTBOROUGH", "state" : "MA", "county" : "WORCESTER" },
            "01581": { "city" : "WESTBOROUGH", "state" : "MA", "county" : "WORCESTER" },
            "01582": { "city" : "WESTBOROUGH", "state" : "MA", "county" : "WORCESTER" },
            "01583": { "city" : "WEST BOYLSTON", "state" : "MA", "county" : "WORCESTER" },
            "01585": { "city" : "WEST BROOKFIELD", "state" : "MA", "county" : "WORCESTER" },
            "01588": { "city" : "WHITINSVILLE", "state" : "MA", "county" : "WORCESTER" },
            "01590": { "city" : "SUTTON", "state" : "MA", "county" : "WORCESTER" },
            "01601": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01602": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01603": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01604": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01605": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01606": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01607": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01608": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01609": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01610": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01611": { "city" : "CHERRY VALLEY", "state" : "MA", "county" : "WORCESTER" },
            "01612": { "city" : "PAXTON", "state" : "MA", "county" : "WORCESTER" },
            "01613": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01614": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01615": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01653": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01655": { "city" : "WORCESTER", "state" : "MA", "county" : "WORCESTER" },
            "01701": { "city" : "FRAMINGHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "01702": { "city" : "FRAMINGHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "01703": { "city" : "FRAMINGHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "01704": { "city" : "FRAMINGHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "01718": { "city" : "VILLAGE OF NAGOG WOODS", "state" : "MA", "county" : "MIDDLESEX" },
            "01719": { "city" : "BOXBOROUGH", "state" : "MA", "county" : "MIDDLESEX" },
            "01720": { "city" : "ACTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01721": { "city" : "ASHLAND", "state" : "MA", "county" : "MIDDLESEX" },
            "01730": { "city" : "BEDFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "01731": { "city" : "HANSCOM AFB", "state" : "MA", "county" : "MIDDLESEX" },
            "01740": { "city" : "BOLTON", "state" : "MA", "county" : "WORCESTER" },
            "01741": { "city" : "CARLISLE", "state" : "MA", "county" : "MIDDLESEX" },
            "01742": { "city" : "CONCORD", "state" : "MA", "county" : "MIDDLESEX" },
            "01745": { "city" : "FAYVILLE", "state" : "MA", "county" : "WORCESTER" },
            "01746": { "city" : "HOLLISTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01747": { "city" : "HOPEDALE", "state" : "MA", "county" : "WORCESTER" },
            "01748": { "city" : "HOPKINTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01749": { "city" : "HUDSON", "state" : "MA", "county" : "MIDDLESEX" },
            "01752": { "city" : "MARLBOROUGH", "state" : "MA", "county" : "MIDDLESEX" },
            "01754": { "city" : "MAYNARD", "state" : "MA", "county" : "MIDDLESEX" },
            "01756": { "city" : "MENDON", "state" : "MA", "county" : "WORCESTER" },
            "01757": { "city" : "MILFORD", "state" : "MA", "county" : "WORCESTER" },
            "01760": { "city" : "NATICK", "state" : "MA", "county" : "MIDDLESEX" },
            "01770": { "city" : "SHERBORN", "state" : "MA", "county" : "MIDDLESEX" },
            "01772": { "city" : "SOUTHBOROUGH", "state" : "MA", "county" : "WORCESTER" },
            "01773": { "city" : "LINCOLN", "state" : "MA", "county" : "MIDDLESEX" },
            "01775": { "city" : "STOW", "state" : "MA", "county" : "MIDDLESEX" },
            "01776": { "city" : "SUDBURY", "state" : "MA", "county" : "MIDDLESEX" },
            "01778": { "city" : "WAYLAND", "state" : "MA", "county" : "MIDDLESEX" },
            "01784": { "city" : "WOODVILLE", "state" : "MA", "county" : "MIDDLESEX" },
            "01801": { "city" : "WOBURN", "state" : "MA", "county" : "MIDDLESEX" },
            "01803": { "city" : "BURLINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01805": { "city" : "BURLINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01807": { "city" : "WOBURN", "state" : "MA", "county" : "MIDDLESEX" },
            "01810": { "city" : "ANDOVER", "state" : "MA", "county" : "ESSEX" },"01821": { "city" : "BILLERICA", "state" : "MA", "county" : "MIDDLESEX" },
            "01822": { "city" : "BILLERICA", "state" : "MA", "county" : "MIDDLESEX" },
            "01824": { "city" : "CHELMSFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "01826": { "city" : "DRACUT", "state" : "MA", "county" : "MIDDLESEX" },
            "01827": { "city" : "DUNSTABLE", "state" : "MA", "county" : "MIDDLESEX" },
            "01830": { "city" : "HAVERHILL", "state" : "MA", "county" : "ESSEX" },
            "01831": { "city" : "HAVERHILL", "state" : "MA", "county" : "ESSEX" },
            "01832": { "city" : "HAVERHILL", "state" : "MA", "county" : "ESSEX" },
            "01833": { "city" : "GEORGETOWN", "state" : "MA", "county" : "ESSEX" },
            "01834": { "city" : "GROVELAND", "state" : "MA", "county" : "ESSEX" },
            "01835": { "city" : "HAVERHILL", "state" : "MA", "county" : "ESSEX" },
            "01840": { "city" : "LAWRENCE", "state" : "MA", "county" : "ESSEX" },
            "01841": { "city" : "LAWRENCE", "state" : "MA", "county" : "ESSEX" },
            "01842": { "city" : "LAWRENCE", "state" : "MA", "county" : "ESSEX" },
            "01843": { "city" : "LAWRENCE", "state" : "MA", "county" : "ESSEX" },
            "01844": { "city" : "METHUEN", "state" : "MA", "county" : "ESSEX" },"01845": { "city" : "NORTH ANDOVER", "state" : "MA", "county" : "ESSEX" },
            "01850": { "city" : "LOWELL", "state" : "MA", "county" : "MIDDLESEX" },
            "01851": { "city" : "LOWELL", "state" : "MA", "county" : "MIDDLESEX" },
            "01852": { "city" : "LOWELL", "state" : "MA", "county" : "MIDDLESEX" },
            "01853": { "city" : "LOWELL", "state" : "MA", "county" : "MIDDLESEX" },
            "01854": { "city" : "LOWELL", "state" : "MA", "county" : "MIDDLESEX" },
            "01860": { "city" : "MERRIMAC", "state" : "MA", "county" : "ESSEX" },
            "01862": { "city" : "NORTH BILLERICA", "state" : "MA", "county" : "MIDDLESEX" },
            "01863": { "city" : "NORTH CHELMSFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "01864": { "city" : "NORTH READING", "state" : "MA", "county" : "MIDDLESEX" },
            "01865": { "city" : "NUTTING LAKE", "state" : "MA", "county" : "MIDDLESEX" },
            "01866": { "city" : "PINEHURST", "state" : "MA", "county" : "MIDDLESEX" },
            "01867": { "city" : "READING", "state" : "MA", "county" : "MIDDLESEX" },
            "01876": { "city" : "TEWKSBURY", "state" : "MA", "county" : "MIDDLESEX" },
            "01879": { "city" : "TYNGSBORO", "state" : "MA", "county" : "MIDDLESEX" },
            "01880": { "city" : "WAKEFIELD", "state" : "MA", "county" : "MIDDLESEX" },
            "01885": { "city" : "WEST BOXFORD", "state" : "MA", "county" : "ESSEX" },
            "01886": { "city" : "WESTFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "01887": { "city" : "WILMINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "01888": { "city" : "WOBURN", "state" : "MA", "county" : "MIDDLESEX" },
            "01889": { "city" : "NORTH READING", "state" : "MA", "county" : "MIDDLESEX" },
            "01890": { "city" : "WINCHESTER", "state" : "MA", "county" : "MIDDLESEX" },
            "01901": { "city" : "LYNN", "state" : "MA", "county" : "ESSEX" },"01902": { "city" : "LYNN", "state" : "MA", "county" : "ESSEX" },
            "01903": { "city" : "LYNN", "state" : "MA", "county" : "ESSEX" },"01904": { "city" : "LYNN", "state" : "MA", "county" : "ESSEX" },
            "01905": { "city" : "LYNN", "state" : "MA", "county" : "ESSEX" },"01906": { "city" : "SAUGUS", "state" : "MA", "county" : "ESSEX" },
            "01907": { "city" : "SWAMPSCOTT", "state" : "MA", "county" : "ESSEX" },
            "01908": { "city" : "NAHANT", "state" : "MA", "county" : "ESSEX" },"01910": { "city" : "LYNN", "state" : "MA", "county" : "ESSEX" },
            "01913": { "city" : "AMESBURY", "state" : "MA", "county" : "ESSEX" },
            "01915": { "city" : "BEVERLY", "state" : "MA", "county" : "ESSEX" },"01921": { "city" : "BOXFORD", "state" : "MA", "county" : "ESSEX" },
            "01922": { "city" : "BYFIELD", "state" : "MA", "county" : "ESSEX" },"01923": { "city" : "DANVERS", "state" : "MA", "county" : "ESSEX" },
            "01929": { "city" : "ESSEX", "state" : "MA", "county" : "ESSEX" },"01930": { "city" : "GLOUCESTER", "state" : "MA", "county" : "ESSEX" },
            "01931": { "city" : "GLOUCESTER", "state" : "MA", "county" : "ESSEX" },
            "01936": { "city" : "HAMILTON", "state" : "MA", "county" : "ESSEX" },
            "01937": { "city" : "HATHORNE", "state" : "MA", "county" : "ESSEX" },
            "01938": { "city" : "IPSWICH", "state" : "MA", "county" : "ESSEX" },"01940": { "city" : "LYNNFIELD", "state" : "MA", "county" : "ESSEX" },
            "01944": { "city" : "MANCHESTER", "state" : "MA", "county" : "ESSEX" },
            "01945": { "city" : "MARBLEHEAD", "state" : "MA", "county" : "ESSEX" },
            "01949": { "city" : "MIDDLETON", "state" : "MA", "county" : "ESSEX" },
            "01950": { "city" : "NEWBURYPORT", "state" : "MA", "county" : "ESSEX" },
            "01951": { "city" : "NEWBURY", "state" : "MA", "county" : "ESSEX" },"01952": { "city" : "SALISBURY", "state" : "MA", "county" : "ESSEX" },
            "01960": { "city" : "PEABODY", "state" : "MA", "county" : "ESSEX" },"01961": { "city" : "PEABODY", "state" : "MA", "county" : "ESSEX" },
            "01965": { "city" : "PRIDES CROSSING", "state" : "MA", "county" : "ESSEX" },
            "01966": { "city" : "ROCKPORT", "state" : "MA", "county" : "ESSEX" },
            "01969": { "city" : "ROWLEY", "state" : "MA", "county" : "ESSEX" },"01970": { "city" : "SALEM", "state" : "MA", "county" : "ESSEX" },
            "01982": { "city" : "SOUTH HAMILTON", "state" : "MA", "county" : "ESSEX" },
            "01983": { "city" : "TOPSFIELD", "state" : "MA", "county" : "ESSEX" },
            "01984": { "city" : "WENHAM", "state" : "MA", "county" : "ESSEX" },"01985": { "city" : "WEST NEWBURY", "state" : "MA", "county" : "ESSEX" },
            "02018": { "city" : "ACCORD", "state" : "MA", "county" : "PLYMOUTH" },
            "02019": { "city" : "BELLINGHAM", "state" : "MA", "county" : "NORFOLK" },
            "02020": { "city" : "BRANT ROCK", "state" : "MA", "county" : "PLYMOUTH" },
            "02021": { "city" : "CANTON", "state" : "MA", "county" : "NORFOLK" },
            "02025": { "city" : "COHASSET", "state" : "MA", "county" : "NORFOLK" },
            "02026": { "city" : "DEDHAM", "state" : "MA", "county" : "NORFOLK" },
            "02027": { "city" : "DEDHAM", "state" : "MA", "county" : "NORFOLK" },
            "02030": { "city" : "DOVER", "state" : "MA", "county" : "NORFOLK" },"02031": { "city" : "EAST MANSFIELD", "state" : "MA", "county" : "BRISTOL" },
            "02032": { "city" : "EAST WALPOLE", "state" : "MA", "county" : "NORFOLK" },
            "02035": { "city" : "FOXBORO", "state" : "MA", "county" : "NORFOLK" },
            "02038": { "city" : "FRANKLIN", "state" : "MA", "county" : "NORFOLK" },
            "02040": { "city" : "GREENBUSH", "state" : "MA", "county" : "PLYMOUTH" },
            "02041": { "city" : "GREEN HARBOR", "state" : "MA", "county" : "PLYMOUTH" },
            "02043": { "city" : "HINGHAM", "state" : "MA", "county" : "PLYMOUTH" },
            "02045": { "city" : "HULL", "state" : "MA", "county" : "PLYMOUTH" },"02047": { "city" : "HUMAROCK", "state" : "MA", "county" : "PLYMOUTH" },
            "02048": { "city" : "MANSFIELD", "state" : "MA", "county" : "BRISTOL" },
            "02050": { "city" : "MARSHFIELD", "state" : "MA", "county" : "PLYMOUTH" },
            "02051": { "city" : "MARSHFIELD HILLS", "state" : "MA", "county" : "PLYMOUTH" },
            "02052": { "city" : "MEDFIELD", "state" : "MA", "county" : "NORFOLK" },
            "02053": { "city" : "MEDWAY", "state" : "MA", "county" : "NORFOLK" },
            "02054": { "city" : "MILLIS", "state" : "MA", "county" : "NORFOLK" },
            "02056": { "city" : "NORFOLK", "state" : "MA", "county" : "NORFOLK" },
            "02059": { "city" : "NORTH MARSHFIELD", "state" : "MA", "county" : "PLYMOUTH" },
            "02060": { "city" : "NORTH SCITUATE", "state" : "MA", "county" : "PLYMOUTH" },
            "02061": { "city" : "NORWELL", "state" : "MA", "county" : "PLYMOUTH" },
            "02062": { "city" : "NORWOOD", "state" : "MA", "county" : "NORFOLK" },
            "02065": { "city" : "OCEAN BLUFF", "state" : "MA", "county" : "PLYMOUTH" },
            "02066": { "city" : "SCITUATE", "state" : "MA", "county" : "PLYMOUTH" },
            "02067": { "city" : "SHARON", "state" : "MA", "county" : "NORFOLK" },
            "02070": { "city" : "SHELDONVILLE", "state" : "MA", "county" : "NORFOLK" },
            "02071": { "city" : "SOUTH WALPOLE", "state" : "MA", "county" : "NORFOLK" },
            "02072": { "city" : "STOUGHTON", "state" : "MA", "county" : "NORFOLK" },
            "02081": { "city" : "WALPOLE", "state" : "MA", "county" : "NORFOLK" },
            "02090": { "city" : "WESTWOOD", "state" : "MA", "county" : "NORFOLK" },
            "02093": { "city" : "WRENTHAM", "state" : "MA", "county" : "NORFOLK" },
            "02108": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02109": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02110": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02111": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02112": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02113": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02114": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02115": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02116": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02117": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02118": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02119": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02120": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02121": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02122": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02123": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02124": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02125": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02126": { "city" : "MATTAPAN", "state" : "MA", "county" : "SUFFOLK" },
            "02127": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02128": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02129": { "city" : "CHARLESTOWN", "state" : "MA", "county" : "SUFFOLK" },
            "02130": { "city" : "JAMAICA PLAIN", "state" : "MA", "county" : "SUFFOLK" },
            "02131": { "city" : "ROSLINDALE", "state" : "MA", "county" : "SUFFOLK" },
            "02132": { "city" : "WEST ROXBURY", "state" : "MA", "county" : "SUFFOLK" },
            "02133": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02134": { "city" : "ALLSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02135": { "city" : "BRIGHTON", "state" : "MA", "county" : "SUFFOLK" },
            "02136": { "city" : "HYDE PARK", "state" : "MA", "county" : "SUFFOLK" },
            "02137": { "city" : "READVILLE", "state" : "MA", "county" : "SUFFOLK" },
            "02138": { "city" : "CAMBRIDGE", "state" : "MA", "county" : "MIDDLESEX" },
            "02139": { "city" : "CAMBRIDGE", "state" : "MA", "county" : "MIDDLESEX" },
            "02140": { "city" : "CAMBRIDGE", "state" : "MA", "county" : "MIDDLESEX" },
            "02141": { "city" : "CAMBRIDGE", "state" : "MA", "county" : "MIDDLESEX" },
            "02142": { "city" : "CAMBRIDGE", "state" : "MA", "county" : "MIDDLESEX" },
            "02143": { "city" : "SOMERVILLE", "state" : "MA", "county" : "MIDDLESEX" },
            "02144": { "city" : "SOMERVILLE", "state" : "MA", "county" : "MIDDLESEX" },
            "02145": { "city" : "SOMERVILLE", "state" : "MA", "county" : "MIDDLESEX" },
            "02148": { "city" : "MALDEN", "state" : "MA", "county" : "MIDDLESEX" },
            "02149": { "city" : "EVERETT", "state" : "MA", "county" : "MIDDLESEX" },
            "02150": { "city" : "CHELSEA", "state" : "MA", "county" : "SUFFOLK" },
            "02151": { "city" : "REVERE", "state" : "MA", "county" : "SUFFOLK" },
            "02152": { "city" : "WINTHROP", "state" : "MA", "county" : "SUFFOLK" },
            "02153": { "city" : "MEDFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "02155": { "city" : "MEDFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "02156": { "city" : "WEST MEDFORD", "state" : "MA", "county" : "MIDDLESEX" },
            "02163": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02169": { "city" : "QUINCY", "state" : "MA", "county" : "NORFOLK" },
            "02170": { "city" : "QUINCY", "state" : "MA", "county" : "NORFOLK" },
            "02171": { "city" : "QUINCY", "state" : "MA", "county" : "NORFOLK" },
            "02176": { "city" : "MELROSE", "state" : "MA", "county" : "MIDDLESEX" },
            "02180": { "city" : "STONEHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "02184": { "city" : "BRAINTREE", "state" : "MA", "county" : "NORFOLK" },
            "02185": { "city" : "BRAINTREE", "state" : "MA", "county" : "NORFOLK" },
            "02186": { "city" : "MILTON", "state" : "MA", "county" : "NORFOLK" },
            "02187": { "city" : "MILTON VILLAGE", "state" : "MA", "county" : "NORFOLK" },
            "02188": { "city" : "WEYMOUTH", "state" : "MA", "county" : "NORFOLK" },
            "02189": { "city" : "EAST WEYMOUTH", "state" : "MA", "county" : "NORFOLK" },
            "02190": { "city" : "SOUTH WEYMOUTH", "state" : "MA", "county" : "NORFOLK" },
            "02191": { "city" : "NORTH WEYMOUTH", "state" : "MA", "county" : "NORFOLK" },
            "02196": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02199": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02201": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02203": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02205": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02210": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02211": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02212": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02215": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02217": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02222": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02228": { "city" : "EAST BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02238": { "city" : "CAMBRIDGE", "state" : "MA", "county" : "MIDDLESEX" },
            "02269": { "city" : "QUINCY", "state" : "MA", "county" : "NORFOLK" },
            "02283": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02284": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02297": { "city" : "BOSTON", "state" : "MA", "county" : "SUFFOLK" },
            "02301": { "city" : "BROCKTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02302": { "city" : "BROCKTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02303": { "city" : "BROCKTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02304": { "city" : "BROCKTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02305": { "city" : "BROCKTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02322": { "city" : "AVON", "state" : "MA", "county" : "NORFOLK" },"02324": { "city" : "BRIDGEWATER", "state" : "MA", "county" : "PLYMOUTH" },
            "02325": { "city" : "BRIDGEWATER", "state" : "MA", "county" : "PLYMOUTH" },
            "02327": { "city" : "BRYANTVILLE", "state" : "MA", "county" : "PLYMOUTH" },
            "02330": { "city" : "CARVER", "state" : "MA", "county" : "PLYMOUTH" },
            "02331": { "city" : "DUXBURY", "state" : "MA", "county" : "PLYMOUTH" },
            "02332": { "city" : "DUXBURY", "state" : "MA", "county" : "PLYMOUTH" },
            "02333": { "city" : "EAST BRIDGEWATER", "state" : "MA", "county" : "PLYMOUTH" },
            "02334": { "city" : "EASTON", "state" : "MA", "county" : "BRISTOL" },
            "02337": { "city" : "ELMWOOD", "state" : "MA", "county" : "PLYMOUTH" },
            "02338": { "city" : "HALIFAX", "state" : "MA", "county" : "PLYMOUTH" },
            "02339": { "city" : "HANOVER", "state" : "MA", "county" : "PLYMOUTH" },
            "02340": { "city" : "HANOVER", "state" : "MA", "county" : "PLYMOUTH" },
            "02341": { "city" : "HANSON", "state" : "MA", "county" : "PLYMOUTH" },
            "02343": { "city" : "HOLBROOK", "state" : "MA", "county" : "NORFOLK" },
            "02344": { "city" : "MIDDLEBORO", "state" : "MA", "county" : "PLYMOUTH" },
            "02345": { "city" : "MANOMET", "state" : "MA", "county" : "PLYMOUTH" },
            "02346": { "city" : "MIDDLEBORO", "state" : "MA", "county" : "PLYMOUTH" },
            "02347": { "city" : "LAKEVILLE", "state" : "MA", "county" : "PLYMOUTH" },
            "02348": { "city" : "LAKEVILLE", "state" : "MA", "county" : "PLYMOUTH" },
            "02349": { "city" : "MIDDLEBORO", "state" : "MA", "county" : "PLYMOUTH" },
            "02350": { "city" : "MONPONSETT", "state" : "MA", "county" : "PLYMOUTH" },
            "02351": { "city" : "ABINGTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02355": { "city" : "NORTH CARVER", "state" : "MA", "county" : "PLYMOUTH" },
            "02356": { "city" : "NORTH EASTON", "state" : "MA", "county" : "BRISTOL" },
            "02357": { "city" : "NORTH EASTON", "state" : "MA", "county" : "BRISTOL" },
            "02358": { "city" : "NORTH PEMBROKE", "state" : "MA", "county" : "PLYMOUTH" },
            "02359": { "city" : "PEMBROKE", "state" : "MA", "county" : "PLYMOUTH" },
            "02360": { "city" : "PLYMOUTH", "state" : "MA", "county" : "PLYMOUTH" },
            "02361": { "city" : "PLYMOUTH", "state" : "MA", "county" : "PLYMOUTH" },
            "02362": { "city" : "PLYMOUTH", "state" : "MA", "county" : "PLYMOUTH" },
            "02364": { "city" : "KINGSTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02366": { "city" : "SOUTH CARVER", "state" : "MA", "county" : "PLYMOUTH" },
            "02367": { "city" : "PLYMPTON", "state" : "MA", "county" : "PLYMOUTH" },
            "02368": { "city" : "RANDOLPH", "state" : "MA", "county" : "NORFOLK" },
            "02370": { "city" : "ROCKLAND", "state" : "MA", "county" : "PLYMOUTH" },
            "02375": { "city" : "SOUTH EASTON", "state" : "MA", "county" : "BRISTOL" },
            "02379": { "city" : "WEST BRIDGEWATER", "state" : "MA", "county" : "PLYMOUTH" },
            "02381": { "city" : "WHITE HORSE BEACH", "state" : "MA", "county" : "PLYMOUTH" },
            "02382": { "city" : "WHITMAN", "state" : "MA", "county" : "PLYMOUTH" },
            "02420": { "city" : "LEXINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02421": { "city" : "LEXINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02445": { "city" : "BROOKLINE", "state" : "MA", "county" : "NORFOLK" },
            "02446": { "city" : "BROOKLINE", "state" : "MA", "county" : "NORFOLK" },
            "02447": { "city" : "BROOKLINE VILLAGE", "state" : "MA", "county" : "NORFOLK" },
            "02451": { "city" : "WALTHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "02452": { "city" : "WALTHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "02453": { "city" : "WALTHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "02454": { "city" : "WALTHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "02455": { "city" : "NORTH WALTHAM", "state" : "MA", "county" : "MIDDLESEX" },
            "02456": { "city" : "NEW TOWN", "state" : "MA", "county" : "MIDDLESEX" },
            "02457": { "city" : "BABSON PARK", "state" : "MA", "county" : "NORFOLK" },
            "02458": { "city" : "NEWTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02459": { "city" : "NEWTON CENTER", "state" : "MA", "county" : "MIDDLESEX" },
            "02460": { "city" : "NEWTONVILLE", "state" : "MA", "county" : "MIDDLESEX" },
            "02461": { "city" : "NEWTON HIGHLANDS", "state" : "MA", "county" : "MIDDLESEX" },
            "02462": { "city" : "NEWTON LOWER FALLS", "state" : "MA", "county" : "MIDDLESEX" },
            "02464": { "city" : "NEWTON UPPER FALLS", "state" : "MA", "county" : "MIDDLESEX" },
            "02465": { "city" : "WEST NEWTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02466": { "city" : "AUBURNDALE", "state" : "MA", "county" : "MIDDLESEX" },
            "02467": { "city" : "CHESTNUT HILL", "state" : "MA", "county" : "MIDDLESEX" },
            "02468": { "city" : "WABAN", "state" : "MA", "county" : "MIDDLESEX" },
            "02471": { "city" : "WATERTOWN", "state" : "MA", "county" : "MIDDLESEX" },
            "02472": { "city" : "WATERTOWN", "state" : "MA", "county" : "MIDDLESEX" },
            "02474": { "city" : "ARLINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02475": { "city" : "ARLINGTON HEIGHTS", "state" : "MA", "county" : "MIDDLESEX" },
            "02476": { "city" : "ARLINGTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02478": { "city" : "BELMONT", "state" : "MA", "county" : "MIDDLESEX" },
            "02479": { "city" : "WAVERLEY", "state" : "MA", "county" : "MIDDLESEX" },
            "02481": { "city" : "WELLESLEY HILLS", "state" : "MA", "county" : "NORFOLK" },
            "02482": { "city" : "WELLESLEY", "state" : "MA", "county" : "NORFOLK" },
            "02492": { "city" : "NEEDHAM", "state" : "MA", "county" : "NORFOLK" },
            "02493": { "city" : "WESTON", "state" : "MA", "county" : "MIDDLESEX" },
            "02494": { "city" : "NEEDHAM HEIGHTS", "state" : "MA", "county" : "NORFOLK" },
            "02495": { "city" : "NONANTUM", "state" : "MA", "county" : "MIDDLESEX" },
            "02532": { "city" : "BUZZARDS BAY", "state" : "MA", "county" : "BARNSTABLE" },
            "02534": { "city" : "CATAUMET", "state" : "MA", "county" : "BARNSTABLE" },
            "02535": { "city" : "CHILMARK", "state" : "MA", "county" : "DUKES" },
            "02536": { "city" : "EAST FALMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02537": { "city" : "EAST SANDWICH", "state" : "MA", "county" : "BARNSTABLE" },
            "02538": { "city" : "EAST WAREHAM", "state" : "MA", "county" : "PLYMOUTH" },
            "02539": { "city" : "EDGARTOWN", "state" : "MA", "county" : "DUKES" },
            "02540": { "city" : "FALMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02541": { "city" : "FALMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02542": { "city" : "BUZZARDS BAY", "state" : "MA", "county" : "BARNSTABLE" },
            "02543": { "city" : "WOODS HOLE", "state" : "MA", "county" : "BARNSTABLE" },
            "02552": { "city" : "MENEMSHA", "state" : "MA", "county" : "DUKES" },
            "02553": { "city" : "MONUMENT BEACH", "state" : "MA", "county" : "BARNSTABLE" },
            "02554": { "city" : "NANTUCKET", "state" : "MA", "county" : "NANTUCKET" },
            "02556": { "city" : "NORTH FALMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02557": { "city" : "OAK BLUFFS", "state" : "MA", "county" : "DUKES" },
            "02558": { "city" : "ONSET", "state" : "MA", "county" : "PLYMOUTH" },
            "02559": { "city" : "POCASSET", "state" : "MA", "county" : "BARNSTABLE" },
            "02561": { "city" : "SAGAMORE", "state" : "MA", "county" : "BARNSTABLE" },
            "02562": { "city" : "SAGAMORE BEACH", "state" : "MA", "county" : "BARNSTABLE" },
            "02563": { "city" : "SANDWICH", "state" : "MA", "county" : "BARNSTABLE" },
            "02564": { "city" : "SIASCONSET", "state" : "MA", "county" : "NANTUCKET" },
            "02568": { "city" : "VINEYARD HAVEN", "state" : "MA", "county" : "DUKES" },
            "02571": { "city" : "WAREHAM", "state" : "MA", "county" : "PLYMOUTH" },
            "02574": { "city" : "WEST FALMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02575": { "city" : "WEST TISBURY", "state" : "MA", "county" : "DUKES" },
            "02576": { "city" : "WEST WAREHAM", "state" : "MA", "county" : "PLYMOUTH" },
            "02584": { "city" : "NANTUCKET", "state" : "MA", "county" : "NANTUCKET" },
            "02601": { "city" : "HYANNIS", "state" : "MA", "county" : "BARNSTABLE" },
            "02630": { "city" : "BARNSTABLE", "state" : "MA", "county" : "BARNSTABLE" },
            "02631": { "city" : "BREWSTER", "state" : "MA", "county" : "BARNSTABLE" },
            "02632": { "city" : "CENTERVILLE", "state" : "MA", "county" : "BARNSTABLE" },
            "02633": { "city" : "CHATHAM", "state" : "MA", "county" : "BARNSTABLE" },
            "02634": { "city" : "CENTERVILLE", "state" : "MA", "county" : "BARNSTABLE" },
            "02635": { "city" : "COTUIT", "state" : "MA", "county" : "BARNSTABLE" },
            "02637": { "city" : "CUMMAQUID", "state" : "MA", "county" : "BARNSTABLE" },
            "02638": { "city" : "DENNIS", "state" : "MA", "county" : "BARNSTABLE" },
            "02639": { "city" : "DENNIS PORT", "state" : "MA", "county" : "BARNSTABLE" },
            "02641": { "city" : "EAST DENNIS", "state" : "MA", "county" : "BARNSTABLE" },
            "02642": { "city" : "EASTHAM", "state" : "MA", "county" : "BARNSTABLE" },
            "02643": { "city" : "EAST ORLEANS", "state" : "MA", "county" : "BARNSTABLE" },
            "02644": { "city" : "FORESTDALE", "state" : "MA", "county" : "BARNSTABLE" },
            "02645": { "city" : "HARWICH", "state" : "MA", "county" : "BARNSTABLE" },
            "02646": { "city" : "HARWICH PORT", "state" : "MA", "county" : "BARNSTABLE" },
            "02647": { "city" : "HYANNIS PORT", "state" : "MA", "county" : "BARNSTABLE" },
            "02648": { "city" : "MARSTONS MILLS", "state" : "MA", "county" : "BARNSTABLE" },
            "02649": { "city" : "MASHPEE", "state" : "MA", "county" : "BARNSTABLE" },
            "02650": { "city" : "NORTH CHATHAM", "state" : "MA", "county" : "BARNSTABLE" },
            "02651": { "city" : "NORTH EASTHAM", "state" : "MA", "county" : "BARNSTABLE" },
            "02652": { "city" : "NORTH TRURO", "state" : "MA", "county" : "BARNSTABLE" },
            "02653": { "city" : "ORLEANS", "state" : "MA", "county" : "BARNSTABLE" },
            "02655": { "city" : "OSTERVILLE", "state" : "MA", "county" : "BARNSTABLE" },
            "02657": { "city" : "PROVINCETOWN", "state" : "MA", "county" : "BARNSTABLE" },
            "02659": { "city" : "SOUTH CHATHAM", "state" : "MA", "county" : "BARNSTABLE" },
            "02660": { "city" : "SOUTH DENNIS", "state" : "MA", "county" : "BARNSTABLE" },
            "02661": { "city" : "SOUTH HARWICH", "state" : "MA", "county" : "BARNSTABLE" },
            "02662": { "city" : "SOUTH ORLEANS", "state" : "MA", "county" : "BARNSTABLE" },
            "02663": { "city" : "SOUTH WELLFLEET", "state" : "MA", "county" : "BARNSTABLE" },
            "02664": { "city" : "SOUTH YARMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02666": { "city" : "TRURO", "state" : "MA", "county" : "BARNSTABLE" },
            "02667": { "city" : "WELLFLEET", "state" : "MA", "county" : "BARNSTABLE" },
            "02668": { "city" : "WEST BARNSTABLE", "state" : "MA", "county" : "BARNSTABLE" },
            "02669": { "city" : "WEST CHATHAM", "state" : "MA", "county" : "BARNSTABLE" },
            "02670": { "city" : "WEST DENNIS", "state" : "MA", "county" : "BARNSTABLE" },
            "02671": { "city" : "WEST HARWICH", "state" : "MA", "county" : "BARNSTABLE" },
            "02672": { "city" : "WEST HYANNISPORT", "state" : "MA", "county" : "BARNSTABLE" },
            "02673": { "city" : "WEST YARMOUTH", "state" : "MA", "county" : "BARNSTABLE" },
            "02675": { "city" : "YARMOUTH PORT", "state" : "MA", "county" : "BARNSTABLE" },
            "02702": { "city" : "ASSONET", "state" : "MA", "county" : "BRISTOL" },
            "02703": { "city" : "ATTLEBORO", "state" : "MA", "county" : "BRISTOL" },
            "02712": { "city" : "CHARTLEY", "state" : "MA", "county" : "BRISTOL" },
            "02713": { "city" : "CUTTYHUNK", "state" : "MA", "county" : "DUKES" },
            "02714": { "city" : "DARTMOUTH", "state" : "MA", "county" : "BRISTOL" },
            "02715": { "city" : "DIGHTON", "state" : "MA", "county" : "BRISTOL" },
            "02717": { "city" : "EAST FREETOWN", "state" : "MA", "county" : "BRISTOL" },
            "02718": { "city" : "EAST TAUNTON", "state" : "MA", "county" : "BRISTOL" },
            "02719": { "city" : "FAIRHAVEN", "state" : "MA", "county" : "BRISTOL" },
            "02720": { "city" : "FALL RIVER", "state" : "MA", "county" : "BRISTOL" },
            "02721": { "city" : "FALL RIVER", "state" : "MA", "county" : "BRISTOL" },
            "02722": { "city" : "FALL RIVER", "state" : "MA", "county" : "BRISTOL" },
            "02723": { "city" : "FALL RIVER", "state" : "MA", "county" : "BRISTOL" },
            "02724": { "city" : "FALL RIVER", "state" : "MA", "county" : "BRISTOL" },
            "02725": { "city" : "SOMERSET", "state" : "MA", "county" : "BRISTOL" },
            "02726": { "city" : "SOMERSET", "state" : "MA", "county" : "BRISTOL" },
            "02738": { "city" : "MARION", "state" : "MA", "county" : "PLYMOUTH" },
            "02739": { "city" : "MATTAPOISETT", "state" : "MA", "county" : "PLYMOUTH" },
            "02740": { "city" : "NEW BEDFORD", "state" : "MA", "county" : "BRISTOL" },
            "02741": { "city" : "NEW BEDFORD", "state" : "MA", "county" : "BRISTOL" },
            "02742": { "city" : "NEW BEDFORD", "state" : "MA", "county" : "BRISTOL" },
            "02743": { "city" : "ACUSHNET", "state" : "MA", "county" : "BRISTOL" },
            "02744": { "city" : "NEW BEDFORD", "state" : "MA", "county" : "BRISTOL" },
            "02745": { "city" : "NEW BEDFORD", "state" : "MA", "county" : "BRISTOL" },
            "02746": { "city" : "NEW BEDFORD", "state" : "MA", "county" : "BRISTOL" },
            "02747": { "city" : "NORTH DARTMOUTH", "state" : "MA", "county" : "BRISTOL" },
            "02748": { "city" : "SOUTH DARTMOUTH", "state" : "MA", "county" : "BRISTOL" },
            "02760": { "city" : "NORTH ATTLEBORO", "state" : "MA", "county" : "BRISTOL" },
            "02761": { "city" : "NORTH ATTLEBORO", "state" : "MA", "county" : "BRISTOL" },
            "02762": { "city" : "PLAINVILLE", "state" : "MA", "county" : "NORFOLK" },
            "02763": { "city" : "ATTLEBORO FALLS", "state" : "MA", "county" : "BRISTOL" },
            "02764": { "city" : "NORTH DIGHTON", "state" : "MA", "county" : "BRISTOL" },
            "02766": { "city" : "NORTON", "state" : "MA", "county" : "BRISTOL" },
            "02767": { "city" : "RAYNHAM", "state" : "MA", "county" : "BRISTOL" },
            "02768": { "city" : "RAYNHAM CENTER", "state" : "MA", "county" : "BRISTOL" },
            "02769": { "city" : "REHOBOTH", "state" : "MA", "county" : "BRISTOL" },
            "02770": { "city" : "ROCHESTER", "state" : "MA", "county" : "PLYMOUTH" },
            "02771": { "city" : "SEEKONK", "state" : "MA", "county" : "BRISTOL" },
            "02777": { "city" : "SWANSEA", "state" : "MA", "county" : "BRISTOL" },
            "02779": { "city" : "BERKLEY", "state" : "MA", "county" : "BRISTOL" },
            "02780": { "city" : "TAUNTON", "state" : "MA", "county" : "BRISTOL" },
            "02790": { "city" : "WESTPORT", "state" : "MA", "county" : "BRISTOL" },
            "02791": { "city" : "WESTPORT POINT", "state" : "MA", "county" : "BRISTOL" },
            "02801": { "city" : "ADAMSVILLE", "state" : "RI", "county" : "NEWPORT" },
            "02802": { "city" : "ALBION", "state" : "RI", "county" : "PROVIDENCE" },
            "02804": { "city" : "ASHAWAY", "state" : "RI", "county" : "WASHINGTON" },
            "02806": { "city" : "BARRINGTON", "state" : "RI", "county" : "BRISTOL" },
            "02807": { "city" : "BLOCK ISLAND", "state" : "RI", "county" : "WASHINGTON" },
            "02808": { "city" : "BRADFORD", "state" : "RI", "county" : "WASHINGTON" },
            "02809": { "city" : "BRISTOL", "state" : "RI", "county" : "BRISTOL" },
            "02812": { "city" : "CAROLINA", "state" : "RI", "county" : "WASHINGTON" },
            "02813": { "city" : "CHARLESTOWN", "state" : "RI", "county" : "WASHINGTON" },
            "02814": { "city" : "CHEPACHET", "state" : "RI", "county" : "PROVIDENCE" },
            "02815": { "city" : "CLAYVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02816": { "city" : "COVENTRY", "state" : "RI", "county" : "KENT" },"02817": { "city" : "WEST GREENWICH", "state" : "RI", "county" : "KENT" },
            "02818": { "city" : "EAST GREENWICH", "state" : "RI", "county" : "KENT" },
            "02822": { "city" : "EXETER", "state" : "RI", "county" : "WASHINGTON" },
            "02823": { "city" : "FISKEVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02824": { "city" : "FORESTDALE", "state" : "RI", "county" : "PROVIDENCE" },
            "02825": { "city" : "FOSTER", "state" : "RI", "county" : "PROVIDENCE" },
            "02826": { "city" : "GLENDALE", "state" : "RI", "county" : "PROVIDENCE" },
            "02827": { "city" : "GREENE", "state" : "RI", "county" : "KENT" },"02828": { "city" : "GREENVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02829": { "city" : "HARMONY", "state" : "RI", "county" : "PROVIDENCE" },
            "02830": { "city" : "HARRISVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02831": { "city" : "HOPE", "state" : "RI", "county" : "PROVIDENCE" },
            "02832": { "city" : "HOPE VALLEY", "state" : "RI", "county" : "WASHINGTON" },
            "02833": { "city" : "HOPKINTON", "state" : "RI", "county" : "WASHINGTON" },
            "02835": { "city" : "JAMESTOWN", "state" : "RI", "county" : "NEWPORT" },
            "02836": { "city" : "KENYON", "state" : "RI", "county" : "WASHINGTON" },
            "02837": { "city" : "LITTLE COMPTON", "state" : "RI", "county" : "NEWPORT" },
            "02838": { "city" : "MANVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02839": { "city" : "MAPLEVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02840": { "city" : "NEWPORT", "state" : "RI", "county" : "NEWPORT" },
            "02841": { "city" : "NEWPORT", "state" : "RI", "county" : "NEWPORT" },
            "02842": { "city" : "MIDDLETOWN", "state" : "RI", "county" : "NEWPORT" },
            "02852": { "city" : "NORTH KINGSTOWN", "state" : "RI", "county" : "WASHINGTON" },
            "02854": { "city" : "NORTH KINGSTOWN", "state" : "RI", "county" : "WASHINGTON" },
            "02857": { "city" : "NORTH SCITUATE", "state" : "RI", "county" : "PROVIDENCE" },
            "02858": { "city" : "OAKLAND", "state" : "RI", "county" : "PROVIDENCE" },
            "02859": { "city" : "PASCOAG", "state" : "RI", "county" : "PROVIDENCE" },
            "02860": { "city" : "PAWTUCKET", "state" : "RI", "county" : "PROVIDENCE" },
            "02861": { "city" : "PAWTUCKET", "state" : "RI", "county" : "PROVIDENCE" },
            "02862": { "city" : "PAWTUCKET", "state" : "RI", "county" : "PROVIDENCE" },
            "02863": { "city" : "CENTRAL FALLS", "state" : "RI", "county" : "PROVIDENCE" },
            "02864": { "city" : "CUMBERLAND", "state" : "RI", "county" : "PROVIDENCE" },
            "02865": { "city" : "LINCOLN", "state" : "RI", "county" : "PROVIDENCE" },
            "02871": { "city" : "PORTSMOUTH", "state" : "RI", "county" : "NEWPORT" },
            "02872": { "city" : "PRUDENCE ISLAND", "state" : "RI", "county" : "BRISTOL" },
            "02873": { "city" : "ROCKVILLE", "state" : "RI", "county" : "WASHINGTON" },
            "02874": { "city" : "SAUNDERSTOWN", "state" : "RI", "county" : "WASHINGTON" },
            "02875": { "city" : "SHANNOCK", "state" : "RI", "county" : "WASHINGTON" },
            "02876": { "city" : "SLATERSVILLE", "state" : "RI", "county" : "PROVIDENCE" },
            "02877": { "city" : "SLOCUM", "state" : "RI", "county" : "WASHINGTON" },
            "02878": { "city" : "TIVERTON", "state" : "RI", "county" : "NEWPORT" },
            "02879": { "city" : "WAKEFIELD", "state" : "RI", "county" : "WASHINGTON" },
            "02880": { "city" : "WAKEFIELD", "state" : "RI", "county" : "WASHINGTON" },
            "02881": { "city" : "KINGSTON", "state" : "RI", "county" : "WASHINGTON" },
            "02882": { "city" : "NARRAGANSETT", "state" : "RI", "county" : "WASHINGTON" },
            "02883": { "city" : "PEACE DALE", "state" : "RI", "county" : "WASHINGTON" },
            "02885": { "city" : "WARREN", "state" : "RI", "county" : "BRISTOL" },
            "02886": { "city" : "WARWICK", "state" : "RI", "county" : "KENT" },"02887": { "city" : "WARWICK", "state" : "RI", "county" : "KENT" },
            "02888": { "city" : "WARWICK", "state" : "RI", "county" : "KENT" },"02889": { "city" : "WARWICK", "state" : "RI", "county" : "KENT" },
            "02891": { "city" : "WESTERLY", "state" : "RI", "county" : "WASHINGTON" },
            "02892": { "city" : "WEST KINGSTON", "state" : "RI", "county" : "WASHINGTON" },
            "02893": { "city" : "WEST WARWICK", "state" : "RI", "county" : "KENT" },
            "02894": { "city" : "WOOD RIVER JUNCTION", "state" : "RI", "county" : "WASHINGTON" },
            "02895": { "city" : "WOONSOCKET", "state" : "RI", "county" : "PROVIDENCE" },
            "02896": { "city" : "NORTH SMITHFIELD", "state" : "RI", "county" : "PROVIDENCE" },
            "02898": { "city" : "WYOMING", "state" : "RI", "county" : "WASHINGTON" },
            "02901": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02902": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02903": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02904": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02905": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02906": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02907": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02908": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02909": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02910": { "city" : "CRANSTON", "state" : "RI", "county" : "PROVIDENCE" },
            "02911": { "city" : "NORTH PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02912": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02914": { "city" : "EAST PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02915": { "city" : "RIVERSIDE", "state" : "RI", "county" : "PROVIDENCE" },
            "02916": { "city" : "RUMFORD", "state" : "RI", "county" : "PROVIDENCE" },
            "02917": { "city" : "SMITHFIELD", "state" : "RI", "county" : "PROVIDENCE" },
            "02918": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "02919": { "city" : "JOHNSTON", "state" : "RI", "county" : "PROVIDENCE" },
            "02920": { "city" : "CRANSTON", "state" : "RI", "county" : "PROVIDENCE" },
            "02921": { "city" : "CRANSTON", "state" : "RI", "county" : "PROVIDENCE" },
            "02940": { "city" : "PROVIDENCE", "state" : "RI", "county" : "PROVIDENCE" },
            "03031": { "city" : "AMHERST", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03032": { "city" : "AUBURN", "state" : "NH", "county" : "ROCKINGHAM" },
            "03033": { "city" : "BROOKLINE", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03034": { "city" : "CANDIA", "state" : "NH", "county" : "ROCKINGHAM" },
            "03036": { "city" : "CHESTER", "state" : "NH", "county" : "ROCKINGHAM" },
            "03037": { "city" : "DEERFIELD", "state" : "NH", "county" : "ROCKINGHAM" },
            "03038": { "city" : "DERRY", "state" : "NH", "county" : "ROCKINGHAM" },
            "03040": { "city" : "EAST CANDIA", "state" : "NH", "county" : "ROCKINGHAM" },
            "03041": { "city" : "EAST DERRY", "state" : "NH", "county" : "ROCKINGHAM" },
            "03042": { "city" : "EPPING", "state" : "NH", "county" : "ROCKINGHAM" },
            "03043": { "city" : "FRANCESTOWN", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03044": { "city" : "FREMONT", "state" : "NH", "county" : "ROCKINGHAM" },
            "03045": { "city" : "GOFFSTOWN", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03046": { "city" : "DUNBARTON", "state" : "NH", "county" : "MERRIMACK" },
            "03047": { "city" : "GREENFIELD", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03048": { "city" : "GREENVILLE", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03049": { "city" : "HOLLIS", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03051": { "city" : "HUDSON", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03052": { "city" : "LITCHFIELD", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03053": { "city" : "LONDONDERRY", "state" : "NH", "county" : "ROCKINGHAM" },
            "03054": { "city" : "MERRIMACK", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03055": { "city" : "MILFORD", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03057": { "city" : "MONT VERNON", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03060": { "city" : "NASHUA", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03061": { "city" : "NASHUA", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03062": { "city" : "NASHUA", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03063": { "city" : "NASHUA", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03064": { "city" : "NASHUA", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03070": { "city" : "NEW BOSTON", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03071": { "city" : "NEW IPSWICH", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03073": { "city" : "NORTH SALEM", "state" : "NH", "county" : "ROCKINGHAM" },
            "03076": { "city" : "PELHAM", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03077": { "city" : "RAYMOND", "state" : "NH", "county" : "ROCKINGHAM" },
            "03079": { "city" : "SALEM", "state" : "NH", "county" : "ROCKINGHAM" },
            "03082": { "city" : "LYNDEBOROUGH", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03084": { "city" : "TEMPLE", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03086": { "city" : "WILTON", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03087": { "city" : "WINDHAM", "state" : "NH", "county" : "ROCKINGHAM" },
            "03101": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03102": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03103": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03104": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03105": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03106": { "city" : "HOOKSETT", "state" : "NH", "county" : "MERRIMACK" },
            "03107": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03108": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03109": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03110": { "city" : "BEDFORD", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03111": { "city" : "MANCHESTER", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03215": { "city" : "WATERVILLE VALLEY", "state" : "NH", "county" : "GRAFTON" },
            "03216": { "city" : "ANDOVER", "state" : "NH", "county" : "MERRIMACK" },
            "03217": { "city" : "ASHLAND", "state" : "NH", "county" : "GRAFTON" },
            "03218": { "city" : "BARNSTEAD", "state" : "NH", "county" : "BELKNAP" },
            "03220": { "city" : "BELMONT", "state" : "NH", "county" : "BELKNAP" },
            "03221": { "city" : "BRADFORD", "state" : "NH", "county" : "MERRIMACK" },
            "03222": { "city" : "BRISTOL", "state" : "NH", "county" : "GRAFTON" },
            "03223": { "city" : "CAMPTON", "state" : "NH", "county" : "GRAFTON" },
            "03224": { "city" : "CANTERBURY", "state" : "NH", "county" : "MERRIMACK" },
            "03225": { "city" : "CENTER BARNSTEAD", "state" : "NH", "county" : "BELKNAP" },
            "03226": { "city" : "CENTER HARBOR", "state" : "NH", "county" : "BELKNAP" },
            "03227": { "city" : "CENTER SANDWICH", "state" : "NH", "county" : "CARROLL" },
            "03229": { "city" : "CONTOOCOOK", "state" : "NH", "county" : "MERRIMACK" },
            "03230": { "city" : "DANBURY", "state" : "NH", "county" : "MERRIMACK" },
            "03231": { "city" : "EAST ANDOVER", "state" : "NH", "county" : "MERRIMACK" },
            "03233": { "city" : "ELKINS", "state" : "NH", "county" : "MERRIMACK" },
            "03234": { "city" : "EPSOM", "state" : "NH", "county" : "MERRIMACK" },
            "03235": { "city" : "FRANKLIN", "state" : "NH", "county" : "MERRIMACK" },
            "03237": { "city" : "GILMANTON", "state" : "NH", "county" : "BELKNAP" },
            "03240": { "city" : "GRAFTON", "state" : "NH", "county" : "GRAFTON" },
            "03241": { "city" : "HEBRON", "state" : "NH", "county" : "GRAFTON" },
            "03242": { "city" : "HENNIKER", "state" : "NH", "county" : "MERRIMACK" },
            "03243": { "city" : "HILL", "state" : "NH", "county" : "MERRIMACK" },
            "03244": { "city" : "HILLSBOROUGH", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03245": { "city" : "HOLDERNESS", "state" : "NH", "county" : "GRAFTON" },
            "03246": { "city" : "LACONIA", "state" : "NH", "county" : "BELKNAP" },
            "03247": { "city" : "LACONIA", "state" : "NH", "county" : "BELKNAP" },
            "03249": { "city" : "GILFORD", "state" : "NH", "county" : "BELKNAP" },
            "03251": { "city" : "LINCOLN", "state" : "NH", "county" : "GRAFTON" },
            "03252": { "city" : "LOCHMERE", "state" : "NH", "county" : "BELKNAP" },
            "03253": { "city" : "MEREDITH", "state" : "NH", "county" : "BELKNAP" },
            "03254": { "city" : "MOULTONBOROUGH", "state" : "NH", "county" : "CARROLL" },
            "03255": { "city" : "NEWBURY", "state" : "NH", "county" : "MERRIMACK" },
            "03256": { "city" : "NEW HAMPTON", "state" : "NH", "county" : "BELKNAP" },
            "03257": { "city" : "NEW LONDON", "state" : "NH", "county" : "MERRIMACK" },
            "03258": { "city" : "CHICHESTER", "state" : "NH", "county" : "MERRIMACK" },
            "03259": { "city" : "NORTH SANDWICH", "state" : "NH", "county" : "CARROLL" },
            "03260": { "city" : "NORTH SUTTON", "state" : "NH", "county" : "MERRIMACK" },
            "03261": { "city" : "NORTHWOOD", "state" : "NH", "county" : "ROCKINGHAM" },
            "03262": { "city" : "NORTH WOODSTOCK", "state" : "NH", "county" : "GRAFTON" },
            "03263": { "city" : "PITTSFIELD", "state" : "NH", "county" : "MERRIMACK" },
            "03264": { "city" : "PLYMOUTH", "state" : "NH", "county" : "GRAFTON" },
            "03266": { "city" : "RUMNEY", "state" : "NH", "county" : "GRAFTON" },
            "03268": { "city" : "SALISBURY", "state" : "NH", "county" : "MERRIMACK" },
            "03269": { "city" : "SANBORNTON", "state" : "NH", "county" : "BELKNAP" },
            "03272": { "city" : "SOUTH NEWBURY", "state" : "NH", "county" : "MERRIMACK" },
            "03273": { "city" : "SOUTH SUTTON", "state" : "NH", "county" : "MERRIMACK" },
            "03275": { "city" : "SUNCOOK", "state" : "NH", "county" : "MERRIMACK" },
            "03276": { "city" : "TILTON", "state" : "NH", "county" : "BELKNAP" },
            "03278": { "city" : "WARNER", "state" : "NH", "county" : "MERRIMACK" },
            "03279": { "city" : "WARREN", "state" : "NH", "county" : "GRAFTON" },
            "03280": { "city" : "WASHINGTON", "state" : "NH", "county" : "SULLIVAN" },
            "03281": { "city" : "WEARE", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03282": { "city" : "WENTWORTH", "state" : "NH", "county" : "GRAFTON" },
            "03284": { "city" : "SPRINGFIELD", "state" : "NH", "county" : "SULLIVAN" },
            "03285": { "city" : "THORNTON", "state" : "NH", "county" : "GRAFTON" },
            "03287": { "city" : "WILMOT", "state" : "NH", "county" : "MERRIMACK" },
            "03289": { "city" : "WINNISQUAM", "state" : "NH", "county" : "BELKNAP" },
            "03290": { "city" : "NOTTINGHAM", "state" : "NH", "county" : "ROCKINGHAM" },
            "03291": { "city" : "WEST NOTTINGHAM", "state" : "NH", "county" : "ROCKINGHAM" },
            "03293": { "city" : "WOODSTOCK", "state" : "NH", "county" : "GRAFTON" },
            "03301": { "city" : "CONCORD", "state" : "NH", "county" : "MERRIMACK" },
            "03302": { "city" : "CONCORD", "state" : "NH", "county" : "MERRIMACK" },
            "03303": { "city" : "CONCORD", "state" : "NH", "county" : "MERRIMACK" },
            "03304": { "city" : "BOW", "state" : "NH", "county" : "MERRIMACK" },"03307": { "city" : "LOUDON", "state" : "NH", "county" : "MERRIMACK" },
            "03431": { "city" : "KEENE", "state" : "NH", "county" : "CHESHIRE" },
            "03435": { "city" : "KEENE", "state" : "NH", "county" : "CHESHIRE" },
            "03440": { "city" : "ANTRIM", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03441": { "city" : "ASHUELOT", "state" : "NH", "county" : "CHESHIRE" },
            "03442": { "city" : "BENNINGTON", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03443": { "city" : "CHESTERFIELD", "state" : "NH", "county" : "CHESHIRE" },
            "03444": { "city" : "DUBLIN", "state" : "NH", "county" : "CHESHIRE" },
            "03445": { "city" : "SULLIVAN", "state" : "NH", "county" : "CHESHIRE" },
            "03446": { "city" : "SWANZEY", "state" : "NH", "county" : "CHESHIRE" },
            "03447": { "city" : "FITZWILLIAM", "state" : "NH", "county" : "CHESHIRE" },
            "03448": { "city" : "GILSUM", "state" : "NH", "county" : "CHESHIRE" },
            "03449": { "city" : "HANCOCK", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03450": { "city" : "HARRISVILLE", "state" : "NH", "county" : "CHESHIRE" },
            "03451": { "city" : "HINSDALE", "state" : "NH", "county" : "CHESHIRE" },
            "03452": { "city" : "JAFFREY", "state" : "NH", "county" : "CHESHIRE" },
            "03455": { "city" : "MARLBOROUGH", "state" : "NH", "county" : "CHESHIRE" },
            "03456": { "city" : "MARLOW", "state" : "NH", "county" : "CHESHIRE" },
            "03457": { "city" : "NELSON", "state" : "NH", "county" : "CHESHIRE" },
            "03458": { "city" : "PETERBOROUGH", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03461": { "city" : "RINDGE", "state" : "NH", "county" : "CHESHIRE" },
            "03462": { "city" : "SPOFFORD", "state" : "NH", "county" : "CHESHIRE" },
            "03464": { "city" : "STODDARD", "state" : "NH", "county" : "CHESHIRE" },
            "03465": { "city" : "TROY", "state" : "NH", "county" : "CHESHIRE" },"03466": { "city" : "WEST CHESTERFIELD", "state" : "NH", "county" : "CHESHIRE" },
            "03467": { "city" : "WESTMORELAND", "state" : "NH", "county" : "CHESHIRE" },
            "03468": { "city" : "WEST PETERBOROUGH", "state" : "NH", "county" : "HILLSBOROUGH" },
            "03469": { "city" : "WEST SWANZEY", "state" : "NH", "county" : "CHESHIRE" },
            "03470": { "city" : "WINCHESTER", "state" : "NH", "county" : "CHESHIRE" },
            "03561": { "city" : "LITTLETON", "state" : "NH", "county" : "GRAFTON" },
            "03570": { "city" : "BERLIN", "state" : "NH", "county" : "COOS" },"03574": { "city" : "BETHLEHEM", "state" : "NH", "county" : "GRAFTON" },
            "03575": { "city" : "BRETTON WOODS", "state" : "NH", "county" : "COOS" },
            "03576": { "city" : "COLEBROOK", "state" : "NH", "county" : "COOS" },
            "03579": { "city" : "ERROL", "state" : "NH", "county" : "COOS" },"03580": { "city" : "FRANCONIA", "state" : "NH", "county" : "GRAFTON" },
            "03581": { "city" : "GORHAM", "state" : "NH", "county" : "COOS" },"03582": { "city" : "GROVETON", "state" : "NH", "county" : "COOS" },
            "03583": { "city" : "JEFFERSON", "state" : "NH", "county" : "COOS" },
            "03584": { "city" : "LANCASTER", "state" : "NH", "county" : "COOS" },
            "03585": { "city" : "LISBON", "state" : "NH", "county" : "GRAFTON" },
            "03586": { "city" : "SUGAR HILL", "state" : "NH", "county" : "GRAFTON" },
            "03588": { "city" : "MILAN", "state" : "NH", "county" : "COOS" },"03589": { "city" : "MOUNT WASHINGTON", "state" : "NH", "county" : "COOS" },
            "03590": { "city" : "NORTH STRATFORD", "state" : "NH", "county" : "COOS" },
            "03592": { "city" : "PITTSBURG", "state" : "NH", "county" : "COOS" },
            "03593": { "city" : "RANDOLPH", "state" : "NH", "county" : "COOS" },"03595": { "city" : "TWIN MOUNTAIN", "state" : "NH", "county" : "COOS" },
            "03597": { "city" : "WEST STEWARTSTOWN", "state" : "NH", "county" : "COOS" },
            "03598": { "city" : "WHITEFIELD", "state" : "NH", "county" : "COOS" },
            "03601": { "city" : "ACWORTH", "state" : "NH", "county" : "SULLIVAN" },
            "03602": { "city" : "ALSTEAD", "state" : "NH", "county" : "CHESHIRE" },
            "03603": { "city" : "CHARLESTOWN", "state" : "NH", "county" : "SULLIVAN" },
            "03604": { "city" : "DREWSVILLE", "state" : "NH", "county" : "CHESHIRE" },
            "03605": { "city" : "LEMPSTER", "state" : "NH", "county" : "SULLIVAN" },
            "03607": { "city" : "SOUTH ACWORTH", "state" : "NH", "county" : "SULLIVAN" },
            "03608": { "city" : "WALPOLE", "state" : "NH", "county" : "CHESHIRE" },
            "03609": { "city" : "NORTH WALPOLE", "state" : "NH", "county" : "CHESHIRE" },
            "03740": { "city" : "BATH", "state" : "NH", "county" : "GRAFTON" },"03741": { "city" : "CANAAN", "state" : "NH", "county" : "GRAFTON" },
            "03743": { "city" : "CLAREMONT", "state" : "NH", "county" : "SULLIVAN" },
            "03745": { "city" : "CORNISH", "state" : "NH", "county" : "SULLIVAN" },
            "03746": { "city" : "CORNISH FLAT", "state" : "NH", "county" : "SULLIVAN" },
            "03748": { "city" : "ENFIELD", "state" : "NH", "county" : "GRAFTON" },
            "03749": { "city" : "ENFIELD CENTER", "state" : "NH", "county" : "GRAFTON" },
            "03750": { "city" : "ETNA", "state" : "NH", "county" : "GRAFTON" },"03751": { "city" : "GEORGES MILLS", "state" : "NH", "county" : "SULLIVAN" },
            "03752": { "city" : "GOSHEN", "state" : "NH", "county" : "SULLIVAN" },
            "03753": { "city" : "GRANTHAM", "state" : "NH", "county" : "SULLIVAN" },
            "03754": { "city" : "GUILD", "state" : "NH", "county" : "SULLIVAN" },
            "03755": { "city" : "HANOVER", "state" : "NH", "county" : "GRAFTON" },
            "03756": { "city" : "LEBANON", "state" : "NH", "county" : "GRAFTON" },
            "03765": { "city" : "HAVERHILL", "state" : "NH", "county" : "GRAFTON" },
            "03766": { "city" : "LEBANON", "state" : "NH", "county" : "GRAFTON" },
            "03768": { "city" : "LYME", "state" : "NH", "county" : "GRAFTON" },"03769": { "city" : "LYME CENTER", "state" : "NH", "county" : "GRAFTON" },
            "03770": { "city" : "MERIDEN", "state" : "NH", "county" : "SULLIVAN" },
            "03771": { "city" : "MONROE", "state" : "NH", "county" : "GRAFTON" },
            "03773": { "city" : "NEWPORT", "state" : "NH", "county" : "SULLIVAN" },
            "03774": { "city" : "NORTH HAVERHILL", "state" : "NH", "county" : "GRAFTON" },
            "03777": { "city" : "ORFORD", "state" : "NH", "county" : "GRAFTON" },
            "03779": { "city" : "PIERMONT", "state" : "NH", "county" : "GRAFTON" },
            "03780": { "city" : "PIKE", "state" : "NH", "county" : "GRAFTON" },"03781": { "city" : "PLAINFIELD", "state" : "NH", "county" : "SULLIVAN" },
            "03782": { "city" : "SUNAPEE", "state" : "NH", "county" : "SULLIVAN" },
            "03784": { "city" : "WEST LEBANON", "state" : "NH", "county" : "GRAFTON" },
            "03785": { "city" : "WOODSVILLE", "state" : "NH", "county" : "GRAFTON" },
            "03801": { "city" : "PORTSMOUTH", "state" : "NH", "county" : "ROCKINGHAM" },
            "03802": { "city" : "PORTSMOUTH", "state" : "NH", "county" : "ROCKINGHAM" },
            "03803": { "city" : "PORTSMOUTH", "state" : "NH", "county" : "ROCKINGHAM" },
            "03804": { "city" : "PORTSMOUTH", "state" : "NH", "county" : "ROCKINGHAM" },
            "03805": { "city" : "NEWINGTON", "state" : "NH", "county" : "STRAFFORD" },
            "03809": { "city" : "ALTON", "state" : "NH", "county" : "BELKNAP" },"03810": { "city" : "ALTON BAY", "state" : "NH", "county" : "BELKNAP" },
            "03811": { "city" : "ATKINSON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03812": { "city" : "BARTLETT", "state" : "NH", "county" : "CARROLL" },
            "03813": { "city" : "CENTER CONWAY", "state" : "NH", "county" : "CARROLL" },
            "03814": { "city" : "CENTER OSSIPEE", "state" : "NH", "county" : "CARROLL" },
            "03815": { "city" : "CENTER STRAFFORD", "state" : "NH", "county" : "STRAFFORD" },
            "03816": { "city" : "CENTER TUFTONBORO", "state" : "NH", "county" : "CARROLL" },
            "03817": { "city" : "CHOCORUA", "state" : "NH", "county" : "CARROLL" },
            "03818": { "city" : "CONWAY", "state" : "NH", "county" : "CARROLL" },
            "03819": { "city" : "DANVILLE", "state" : "NH", "county" : "ROCKINGHAM" },
            "03820": { "city" : "DOVER", "state" : "NH", "county" : "STRAFFORD" },
            "03821": { "city" : "DOVER", "state" : "NH", "county" : "STRAFFORD" },
            "03823": { "city" : "MADBURY", "state" : "NH", "county" : "STRAFFORD" },
            "03824": { "city" : "DURHAM", "state" : "NH", "county" : "STRAFFORD" },
            "03825": { "city" : "BARRINGTON", "state" : "NH", "county" : "STRAFFORD" },
            "03826": { "city" : "EAST HAMPSTEAD", "state" : "NH", "county" : "ROCKINGHAM" },
            "03827": { "city" : "EAST KINGSTON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03830": { "city" : "EAST WAKEFIELD", "state" : "NH", "county" : "CARROLL" },
            "03832": { "city" : "EATON CENTER", "state" : "NH", "county" : "CARROLL" },
            "03833": { "city" : "EXETER", "state" : "NH", "county" : "ROCKINGHAM" },
            "03835": { "city" : "FARMINGTON", "state" : "NH", "county" : "STRAFFORD" },
            "03836": { "city" : "FREEDOM", "state" : "NH", "county" : "CARROLL" },
            "03837": { "city" : "GILMANTON IRON WORKS", "state" : "NH", "county" : "BELKNAP" },
            "03838": { "city" : "GLEN", "state" : "NH", "county" : "CARROLL" },"03839": { "city" : "ROCHESTER", "state" : "NH", "county" : "STRAFFORD" },
            "03840": { "city" : "GREENLAND", "state" : "NH", "county" : "ROCKINGHAM" },
            "03841": { "city" : "HAMPSTEAD", "state" : "NH", "county" : "ROCKINGHAM" },
            "03842": { "city" : "HAMPTON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03843": { "city" : "HAMPTON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03844": { "city" : "HAMPTON FALLS", "state" : "NH", "county" : "ROCKINGHAM" },
            "03845": { "city" : "INTERVALE", "state" : "NH", "county" : "CARROLL" },
            "03846": { "city" : "JACKSON", "state" : "NH", "county" : "CARROLL" },
            "03847": { "city" : "KEARSARGE", "state" : "NH", "county" : "CARROLL" },
            "03848": { "city" : "KINGSTON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03849": { "city" : "MADISON", "state" : "NH", "county" : "CARROLL" },
            "03850": { "city" : "MELVIN VILLAGE", "state" : "NH", "county" : "CARROLL" },
            "03851": { "city" : "MILTON", "state" : "NH", "county" : "STRAFFORD" },
            "03852": { "city" : "MILTON MILLS", "state" : "NH", "county" : "STRAFFORD" },
            "03853": { "city" : "MIRROR LAKE", "state" : "NH", "county" : "CARROLL" },
            "03854": { "city" : "NEW CASTLE", "state" : "NH", "county" : "ROCKINGHAM" },
            "03855": { "city" : "NEW DURHAM", "state" : "NH", "county" : "STRAFFORD" },
            "03856": { "city" : "NEWFIELDS", "state" : "NH", "county" : "ROCKINGHAM" },
            "03857": { "city" : "NEWMARKET", "state" : "NH", "county" : "ROCKINGHAM" },
            "03858": { "city" : "NEWTON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03859": { "city" : "NEWTON JUNCTION", "state" : "NH", "county" : "ROCKINGHAM" },
            "03860": { "city" : "NORTH CONWAY", "state" : "NH", "county" : "CARROLL" },
            "03861": { "city" : "LEE", "state" : "NH", "county" : "STRAFFORD" },"03862": { "city" : "NORTH HAMPTON", "state" : "NH", "county" : "ROCKINGHAM" },
            "03864": { "city" : "OSSIPEE", "state" : "NH", "county" : "CARROLL" },
            "03865": { "city" : "PLAISTOW", "state" : "NH", "county" : "ROCKINGHAM" },
            "03866": { "city" : "ROCHESTER", "state" : "NH", "county" : "STRAFFORD" },
            "03867": { "city" : "ROCHESTER", "state" : "NH", "county" : "STRAFFORD" },
            "03868": { "city" : "ROCHESTER", "state" : "NH", "county" : "STRAFFORD" },
            "03869": { "city" : "ROLLINSFORD", "state" : "NH", "county" : "STRAFFORD" },
            "03870": { "city" : "RYE", "state" : "NH", "county" : "ROCKINGHAM" },
            "03871": { "city" : "RYE BEACH", "state" : "NH", "county" : "ROCKINGHAM" },
            "03872": { "city" : "SANBORNVILLE", "state" : "NH", "county" : "CARROLL" },
            "03873": { "city" : "SANDOWN", "state" : "NH", "county" : "ROCKINGHAM" },
            "03874": { "city" : "SEABROOK", "state" : "NH", "county" : "ROCKINGHAM" },
            "03875": { "city" : "SILVER LAKE", "state" : "NH", "county" : "CARROLL" },
            "03878": { "city" : "SOMERSWORTH", "state" : "NH", "county" : "STRAFFORD" },
            "03882": { "city" : "EFFINGHAM", "state" : "NH", "county" : "CARROLL" },
            "03883": { "city" : "SOUTH TAMWORTH", "state" : "NH", "county" : "CARROLL" },
            "03884": { "city" : "STRAFFORD", "state" : "NH", "county" : "STRAFFORD" },
            "03885": { "city" : "STRATHAM", "state" : "NH", "county" : "ROCKINGHAM" },
            "03886": { "city" : "TAMWORTH", "state" : "NH", "county" : "CARROLL" },
            "03887": { "city" : "UNION", "state" : "NH", "county" : "CARROLL" },"03890": { "city" : "WEST OSSIPEE", "state" : "NH", "county" : "CARROLL" },
            "03894": { "city" : "WOLFEBORO", "state" : "NH", "county" : "CARROLL" },
            "03896": { "city" : "WOLFEBORO FALLS", "state" : "NH", "county" : "CARROLL" },
            "03897": { "city" : "WONALANCET", "state" : "NH", "county" : "CARROLL" },
            "03901": { "city" : "BERWICK", "state" : "ME", "county" : "YORK" },"03902": { "city" : "CAPE NEDDICK", "state" : "ME", "county" : "YORK" },
            "03903": { "city" : "ELIOT", "state" : "ME", "county" : "YORK" },"03904": { "city" : "KITTERY", "state" : "ME", "county" : "YORK" },
            "03905": { "city" : "KITTERY POINT", "state" : "ME", "county" : "YORK" },
            "03906": { "city" : "NORTH BERWICK", "state" : "ME", "county" : "YORK" },
            "03907": { "city" : "OGUNQUIT", "state" : "ME", "county" : "YORK" },"03908": { "city" : "SOUTH BERWICK", "state" : "ME", "county" : "YORK" },
            "03909": { "city" : "YORK", "state" : "ME", "county" : "YORK" },"03910": { "city" : "YORK BEACH", "state" : "ME", "county" : "YORK" },
            "03911": { "city" : "YORK HARBOR", "state" : "ME", "county" : "YORK" },
            "04001": { "city" : "ACTON", "state" : "ME", "county" : "YORK" },"04002": { "city" : "ALFRED", "state" : "ME", "county" : "YORK" },
            "04003": { "city" : "BAILEY ISLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04004": { "city" : "BAR MILLS", "state" : "ME", "county" : "YORK" },
            "04005": { "city" : "BIDDEFORD", "state" : "ME", "county" : "YORK" },
            "04006": { "city" : "BIDDEFORD POOL", "state" : "ME", "county" : "YORK" },
            "04007": { "city" : "BIDDEFORD", "state" : "ME", "county" : "YORK" },
            "04008": { "city" : "BOWDOINHAM", "state" : "ME", "county" : "SAGADAHOC" },
            "04009": { "city" : "BRIDGTON", "state" : "ME", "county" : "CUMBERLAND" },
            "04010": { "city" : "BROWNFIELD", "state" : "ME", "county" : "OXFORD" },
            "04011": { "city" : "BRUNSWICK", "state" : "ME", "county" : "CUMBERLAND" },
            "04013": { "city" : "BUSTINS ISLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04014": { "city" : "CAPE PORPOISE", "state" : "ME", "county" : "YORK" },
            "04015": { "city" : "CASCO", "state" : "ME", "county" : "CUMBERLAND" },
            "04016": { "city" : "CENTER LOVELL", "state" : "ME", "county" : "OXFORD" },
            "04017": { "city" : "CHEBEAGUE ISLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04020": { "city" : "CORNISH", "state" : "ME", "county" : "YORK" },"04021": { "city" : "CUMBERLAND CENTER", "state" : "ME", "county" : "CUMBERLAND" },
            "04022": { "city" : "DENMARK", "state" : "ME", "county" : "OXFORD" },
            "04024": { "city" : "EAST BALDWIN", "state" : "ME", "county" : "CUMBERLAND" },
            "04027": { "city" : "LEBANON", "state" : "ME", "county" : "YORK" },"04028": { "city" : "EAST PARSONSFIELD", "state" : "ME", "county" : "YORK" },
            "04029": { "city" : "SEBAGO", "state" : "ME", "county" : "CUMBERLAND" },
            "04030": { "city" : "EAST WATERBORO", "state" : "ME", "county" : "YORK" },
            "04032": { "city" : "FREEPORT", "state" : "ME", "county" : "CUMBERLAND" },
            "04033": { "city" : "FREEPORT", "state" : "ME", "county" : "CUMBERLAND" },
            "04034": { "city" : "FREEPORT", "state" : "ME", "county" : "CUMBERLAND" },
            "04037": { "city" : "FRYEBURG", "state" : "ME", "county" : "OXFORD" },
            "04038": { "city" : "GORHAM", "state" : "ME", "county" : "CUMBERLAND" },
            "04039": { "city" : "GRAY", "state" : "ME", "county" : "CUMBERLAND" },
            "04040": { "city" : "HARRISON", "state" : "ME", "county" : "CUMBERLAND" },
            "04041": { "city" : "HIRAM", "state" : "ME", "county" : "OXFORD" },"04042": { "city" : "HOLLIS CENTER", "state" : "ME", "county" : "YORK" },
            "04043": { "city" : "KENNEBUNK", "state" : "ME", "county" : "YORK" },
            "04046": { "city" : "KENNEBUNKPORT", "state" : "ME", "county" : "YORK" },
            "04047": { "city" : "PARSONSFIELD", "state" : "ME", "county" : "YORK" },
            "04048": { "city" : "LIMERICK", "state" : "ME", "county" : "YORK" },"04049": { "city" : "LIMINGTON", "state" : "ME", "county" : "YORK" },
            "04050": { "city" : "LONG ISLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04051": { "city" : "LOVELL", "state" : "ME", "county" : "OXFORD" },"04054": { "city" : "MOODY", "state" : "ME", "county" : "YORK" },
            "04055": { "city" : "NAPLES", "state" : "ME", "county" : "CUMBERLAND" },
            "04056": { "city" : "NEWFIELD", "state" : "ME", "county" : "YORK" },"04057": { "city" : "NORTH BRIDGTON", "state" : "ME", "county" : "CUMBERLAND" },
            "04061": { "city" : "NORTH WATERBORO", "state" : "ME", "county" : "YORK" },
            "04062": { "city" : "WINDHAM", "state" : "ME", "county" : "CUMBERLAND" },
            "04063": { "city" : "OCEAN PARK", "state" : "ME", "county" : "YORK" },
            "04064": { "city" : "OLD ORCHARD BEACH", "state" : "ME", "county" : "YORK" },
            "04066": { "city" : "ORRS ISLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04068": { "city" : "PORTER", "state" : "ME", "county" : "OXFORD" },"04069": { "city" : "POWNAL", "state" : "ME", "county" : "CUMBERLAND" },
            "04070": { "city" : "SCARBOROUGH", "state" : "ME", "county" : "CUMBERLAND" },
            "04071": { "city" : "RAYMOND", "state" : "ME", "county" : "CUMBERLAND" },
            "04072": { "city" : "SACO", "state" : "ME", "county" : "YORK" },"04073": { "city" : "SANFORD", "state" : "ME", "county" : "YORK" },
            "04074": { "city" : "SCARBOROUGH", "state" : "ME", "county" : "CUMBERLAND" },
            "04076": { "city" : "SHAPLEIGH", "state" : "ME", "county" : "YORK" },
            "04077": { "city" : "SOUTH CASCO", "state" : "ME", "county" : "CUMBERLAND" },
            "04078": { "city" : "SOUTH FREEPORT", "state" : "ME", "county" : "CUMBERLAND" },
            "04079": { "city" : "HARPSWELL", "state" : "ME", "county" : "CUMBERLAND" },
            "04082": { "city" : "SOUTH WINDHAM", "state" : "ME", "county" : "CUMBERLAND" },
            "04083": { "city" : "SPRINGVALE", "state" : "ME", "county" : "YORK" },
            "04084": { "city" : "STANDISH", "state" : "ME", "county" : "CUMBERLAND" },
            "04085": { "city" : "STEEP FALLS", "state" : "ME", "county" : "CUMBERLAND" },
            "04086": { "city" : "TOPSHAM", "state" : "ME", "county" : "SAGADAHOC" },
            "04087": { "city" : "WATERBORO", "state" : "ME", "county" : "YORK" },
            "04088": { "city" : "WATERFORD", "state" : "ME", "county" : "OXFORD" },
            "04090": { "city" : "WELLS", "state" : "ME", "county" : "YORK" },"04091": { "city" : "WEST BALDWIN", "state" : "ME", "county" : "CUMBERLAND" },
            "04092": { "city" : "WESTBROOK", "state" : "ME", "county" : "CUMBERLAND" },
            "04093": { "city" : "BUXTON", "state" : "ME", "county" : "YORK" },"04094": { "city" : "WEST KENNEBUNK", "state" : "ME", "county" : "YORK" },
            "04095": { "city" : "WEST NEWFIELD", "state" : "ME", "county" : "YORK" },
            "04096": { "city" : "YARMOUTH", "state" : "ME", "county" : "CUMBERLAND" },
            "04097": { "city" : "NORTH YARMOUTH", "state" : "ME", "county" : "CUMBERLAND" },
            "04098": { "city" : "WESTBROOK", "state" : "ME", "county" : "CUMBERLAND" },
            "04101": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04102": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04103": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04104": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04105": { "city" : "FALMOUTH", "state" : "ME", "county" : "CUMBERLAND" },
            "04106": { "city" : "SOUTH PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04107": { "city" : "CAPE ELIZABETH", "state" : "ME", "county" : "CUMBERLAND" },
            "04108": { "city" : "PEAKS ISLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04109": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04110": { "city" : "CUMBERLAND FORESIDE", "state" : "ME", "county" : "CUMBERLAND" },
            "04112": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04116": { "city" : "SOUTH PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04122": { "city" : "PORTLAND", "state" : "ME", "county" : "CUMBERLAND" },
            "04210": { "city" : "AUBURN", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04211": { "city" : "AUBURN", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04212": { "city" : "AUBURN", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04216": { "city" : "ANDOVER", "state" : "ME", "county" : "OXFORD" },
            "04217": { "city" : "BETHEL", "state" : "ME", "county" : "OXFORD" },"04219": { "city" : "BRYANT POND", "state" : "ME", "county" : "OXFORD" },
            "04220": { "city" : "BUCKFIELD", "state" : "ME", "county" : "OXFORD" },
            "04221": { "city" : "CANTON", "state" : "ME", "county" : "OXFORD" },"04222": { "city" : "DURHAM", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04224": { "city" : "DIXFIELD", "state" : "ME", "county" : "OXFORD" },
            "04225": { "city" : "DRYDEN", "state" : "ME", "county" : "FRANKLIN" },
            "04226": { "city" : "EAST ANDOVER", "state" : "ME", "county" : "OXFORD" },
            "04227": { "city" : "EAST DIXFIELD", "state" : "ME", "county" : "FRANKLIN" },
            "04228": { "city" : "EAST LIVERMORE", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04230": { "city" : "EAST POLAND", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04231": { "city" : "STONEHAM", "state" : "ME", "county" : "OXFORD" },
            "04234": { "city" : "EAST WILTON", "state" : "ME", "county" : "FRANKLIN" },
            "04236": { "city" : "GREENE", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04237": { "city" : "HANOVER", "state" : "ME", "county" : "OXFORD" },
            "04238": { "city" : "HEBRON", "state" : "ME", "county" : "OXFORD" },"04239": { "city" : "JAY", "state" : "ME", "county" : "FRANKLIN" },
            "04240": { "city" : "LEWISTON", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04241": { "city" : "LEWISTON", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04243": { "city" : "LEWISTON", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04250": { "city" : "LISBON", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04252": { "city" : "LISBON FALLS", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04253": { "city" : "LIVERMORE", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04254": { "city" : "LIVERMORE FALLS", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04255": { "city" : "GREENWOOD", "state" : "ME", "county" : "OXFORD" },
            "04256": { "city" : "MECHANIC FALLS", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04257": { "city" : "MEXICO", "state" : "ME", "county" : "OXFORD" },"04258": { "city" : "MINOT", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04259": { "city" : "MONMOUTH", "state" : "ME", "county" : "KENNEBEC" },
            "04260": { "city" : "NEW GLOUCESTER", "state" : "ME", "county" : "CUMBERLAND" },
            "04261": { "city" : "NEWRY", "state" : "ME", "county" : "OXFORD" },"04262": { "city" : "NORTH JAY", "state" : "ME", "county" : "FRANKLIN" },
            "04263": { "city" : "LEEDS", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04265": { "city" : "NORTH MONMOUTH", "state" : "ME", "county" : "KENNEBEC" },
            "04266": { "city" : "NORTH TURNER", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04267": { "city" : "NORTH WATERFORD", "state" : "ME", "county" : "OXFORD" },
            "04268": { "city" : "NORWAY", "state" : "ME", "county" : "OXFORD" },"04270": { "city" : "OXFORD", "state" : "ME", "county" : "OXFORD" },
            "04271": { "city" : "PARIS", "state" : "ME", "county" : "OXFORD" },"04274": { "city" : "POLAND", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04275": { "city" : "ROXBURY", "state" : "ME", "county" : "OXFORD" },
            "04276": { "city" : "RUMFORD", "state" : "ME", "county" : "OXFORD" },
            "04280": { "city" : "SABATTUS", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04281": { "city" : "SOUTH PARIS", "state" : "ME", "county" : "OXFORD" },
            "04282": { "city" : "TURNER", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04284": { "city" : "WAYNE", "state" : "ME", "county" : "KENNEBEC" },
            "04285": { "city" : "WELD", "state" : "ME", "county" : "FRANKLIN" },"04286": { "city" : "WEST BETHEL", "state" : "ME", "county" : "OXFORD" },
            "04287": { "city" : "BOWDOIN", "state" : "ME", "county" : "SAGADAHOC" },
            "04288": { "city" : "WEST MINOT", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04289": { "city" : "WEST PARIS", "state" : "ME", "county" : "OXFORD" },
            "04290": { "city" : "PERU", "state" : "ME", "county" : "OXFORD" },"04291": { "city" : "WEST POLAND", "state" : "ME", "county" : "ANDROSCOGGIN" },
            "04292": { "city" : "SUMNER", "state" : "ME", "county" : "OXFORD" },"04294": { "city" : "WILTON", "state" : "ME", "county" : "FRANKLIN" },
            "04330": { "city" : "AUGUSTA", "state" : "ME", "county" : "KENNEBEC" },
            "04332": { "city" : "AUGUSTA", "state" : "ME", "county" : "KENNEBEC" },
            "04333": { "city" : "AUGUSTA", "state" : "ME", "county" : "KENNEBEC" },
            "04336": { "city" : "AUGUSTA", "state" : "ME", "county" : "KENNEBEC" },
            "04338": { "city" : "AUGUSTA", "state" : "ME", "county" : "KENNEBEC" },
            "04341": { "city" : "COOPERS MILLS", "state" : "ME", "county" : "LINCOLN" },
            "04342": { "city" : "DRESDEN", "state" : "ME", "county" : "LINCOLN" },
            "04343": { "city" : "EAST WINTHROP", "state" : "ME", "county" : "KENNEBEC" },
            "04344": { "city" : "FARMINGDALE", "state" : "ME", "county" : "KENNEBEC" },
            "04345": { "city" : "GARDINER", "state" : "ME", "county" : "KENNEBEC" },
            "04346": { "city" : "RANDOLPH", "state" : "ME", "county" : "KENNEBEC" },
            "04347": { "city" : "HALLOWELL", "state" : "ME", "county" : "KENNEBEC" },
            "04348": { "city" : "JEFFERSON", "state" : "ME", "county" : "LINCOLN" },
            "04349": { "city" : "KENTS HILL", "state" : "ME", "county" : "KENNEBEC" },
            "04350": { "city" : "LITCHFIELD", "state" : "ME", "county" : "KENNEBEC" },
            "04351": { "city" : "MANCHESTER", "state" : "ME", "county" : "KENNEBEC" },
            "04352": { "city" : "MOUNT VERNON", "state" : "ME", "county" : "KENNEBEC" },
            "04353": { "city" : "WHITEFIELD", "state" : "ME", "county" : "LINCOLN" },
            "04354": { "city" : "PALERMO", "state" : "ME", "county" : "WALDO" },"04355": { "city" : "READFIELD", "state" : "ME", "county" : "KENNEBEC" },
            "04357": { "city" : "RICHMOND", "state" : "ME", "county" : "SAGADAHOC" },
            "04358": { "city" : "SOUTH CHINA", "state" : "ME", "county" : "KENNEBEC" },
            "04359": { "city" : "SOUTH GARDINER", "state" : "ME", "county" : "KENNEBEC" },
            "04360": { "city" : "VIENNA", "state" : "ME", "county" : "KENNEBEC" },
            "04363": { "city" : "WINDSOR", "state" : "ME", "county" : "KENNEBEC" },
            "04364": { "city" : "WINTHROP", "state" : "ME", "county" : "KENNEBEC" },
            "04401": { "city" : "BANGOR", "state" : "ME", "county" : "PENOBSCOT" },
            "04402": { "city" : "BANGOR", "state" : "ME", "county" : "PENOBSCOT" },
            "04406": { "city" : "ABBOT", "state" : "ME", "county" : "PISCATAQUIS" },
            "04408": { "city" : "AURORA", "state" : "ME", "county" : "HANCOCK" },
            "04410": { "city" : "BRADFORD", "state" : "ME", "county" : "PENOBSCOT" },
            "04411": { "city" : "BRADLEY", "state" : "ME", "county" : "PENOBSCOT" },
            "04412": { "city" : "BREWER", "state" : "ME", "county" : "PENOBSCOT" },
            "04413": { "city" : "BROOKTON", "state" : "ME", "county" : "WASHINGTON" },
            "04414": { "city" : "BROWNVILLE", "state" : "ME", "county" : "PISCATAQUIS" },
            "04415": { "city" : "BROWNVILLE JUNCTION", "state" : "ME", "county" : "PISCATAQUIS" },
            "04416": { "city" : "BUCKSPORT", "state" : "ME", "county" : "HANCOCK" },
            "04417": { "city" : "BURLINGTON", "state" : "ME", "county" : "PENOBSCOT" },
            "04418": { "city" : "GREENBUSH", "state" : "ME", "county" : "PENOBSCOT" },
            "04419": { "city" : "CARMEL", "state" : "ME", "county" : "PENOBSCOT" },
            "04420": { "city" : "CASTINE", "state" : "ME", "county" : "HANCOCK" },
            "04421": { "city" : "CASTINE", "state" : "ME", "county" : "HANCOCK" },
            "04422": { "city" : "CHARLESTON", "state" : "ME", "county" : "PENOBSCOT" },
            "04424": { "city" : "DANFORTH", "state" : "ME", "county" : "WASHINGTON" },
            "04426": { "city" : "DOVER FOXCROFT", "state" : "ME", "county" : "PISCATAQUIS" },
            "04427": { "city" : "CORINTH", "state" : "ME", "county" : "PENOBSCOT" },
            "04428": { "city" : "EDDINGTON", "state" : "ME", "county" : "PENOBSCOT" },
            "04429": { "city" : "HOLDEN", "state" : "ME", "county" : "PENOBSCOT" },
            "04430": { "city" : "EAST MILLINOCKET", "state" : "ME", "county" : "PENOBSCOT" },
            "04431": { "city" : "EAST ORLAND", "state" : "ME", "county" : "HANCOCK" },
            "04434": { "city" : "ETNA", "state" : "ME", "county" : "PENOBSCOT" },
            "04435": { "city" : "EXETER", "state" : "ME", "county" : "PENOBSCOT" },
            "04438": { "city" : "FRANKFORT", "state" : "ME", "county" : "WALDO" },
            "04441": { "city" : "GREENVILLE", "state" : "ME", "county" : "PISCATAQUIS" },
            "04442": { "city" : "GREENVILLE JUNCTION", "state" : "ME", "county" : "PISCATAQUIS" },
            "04443": { "city" : "GUILFORD", "state" : "ME", "county" : "PISCATAQUIS" },
            "04444": { "city" : "HAMPDEN", "state" : "ME", "county" : "PENOBSCOT" },
            "04448": { "city" : "HOWLAND", "state" : "ME", "county" : "PENOBSCOT" },
            "04449": { "city" : "HUDSON", "state" : "ME", "county" : "PENOBSCOT" },
            "04450": { "city" : "KENDUSKEAG", "state" : "ME", "county" : "PENOBSCOT" },
            "04451": { "city" : "KINGMAN", "state" : "ME", "county" : "PENOBSCOT" },
            "04453": { "city" : "LAGRANGE", "state" : "ME", "county" : "PENOBSCOT" },
            "04455": { "city" : "LEE", "state" : "ME", "county" : "PENOBSCOT" },"04456": { "city" : "LEVANT", "state" : "ME", "county" : "PENOBSCOT" },
            "04457": { "city" : "LINCOLN", "state" : "ME", "county" : "PENOBSCOT" },
            "04459": { "city" : "MATTAWAMKEAG", "state" : "ME", "county" : "PENOBSCOT" },
            "04460": { "city" : "MEDWAY", "state" : "ME", "county" : "PENOBSCOT" },
            "04461": { "city" : "MILFORD", "state" : "ME", "county" : "PENOBSCOT" },
            "04462": { "city" : "MILLINOCKET", "state" : "ME", "county" : "PENOBSCOT" },
            "04463": { "city" : "MILO", "state" : "ME", "county" : "PISCATAQUIS" },
            "04464": { "city" : "MONSON", "state" : "ME", "county" : "PISCATAQUIS" },
            "04468": { "city" : "OLD TOWN", "state" : "ME", "county" : "PENOBSCOT" },
            "04469": { "city" : "ORONO", "state" : "ME", "county" : "PENOBSCOT" },
            "04471": { "city" : "ORIENT", "state" : "ME", "county" : "AROOSTOOK" },
            "04472": { "city" : "ORLAND", "state" : "ME", "county" : "HANCOCK" },
            "04473": { "city" : "ORONO", "state" : "ME", "county" : "PENOBSCOT" },
            "04474": { "city" : "ORRINGTON", "state" : "ME", "county" : "PENOBSCOT" },
            "04475": { "city" : "PASSADUMKEAG", "state" : "ME", "county" : "PENOBSCOT" },
            "04476": { "city" : "PENOBSCOT", "state" : "ME", "county" : "HANCOCK" },
            "04478": { "city" : "ROCKWOOD", "state" : "ME", "county" : "SOMERSET" },
            "04479": { "city" : "SANGERVILLE", "state" : "ME", "county" : "PISCATAQUIS" },
            "04481": { "city" : "SEBEC", "state" : "ME", "county" : "PISCATAQUIS" },
            "04485": { "city" : "SHIRLEY MILLS", "state" : "ME", "county" : "PISCATAQUIS" },
            "04487": { "city" : "SPRINGFIELD", "state" : "ME", "county" : "PENOBSCOT" },
            "04488": { "city" : "STETSON", "state" : "ME", "county" : "PENOBSCOT" },
            "04489": { "city" : "STILLWATER", "state" : "ME", "county" : "PENOBSCOT" },
            "04490": { "city" : "TOPSFIELD", "state" : "ME", "county" : "WASHINGTON" },
            "04491": { "city" : "VANCEBORO", "state" : "ME", "county" : "WASHINGTON" },
            "04492": { "city" : "WAITE", "state" : "ME", "county" : "WASHINGTON" },
            "04493": { "city" : "WEST ENFIELD", "state" : "ME", "county" : "PENOBSCOT" },
            "04495": { "city" : "WINN", "state" : "ME", "county" : "PENOBSCOT" },
            "04496": { "city" : "WINTERPORT", "state" : "ME", "county" : "WALDO" },
            "04497": { "city" : "WYTOPITLOCK", "state" : "ME", "county" : "AROOSTOOK" },
            "04530": { "city" : "BATH", "state" : "ME", "county" : "SAGADAHOC" },
            "04535": { "city" : "ALNA", "state" : "ME", "county" : "LINCOLN" },"04537": { "city" : "BOOTHBAY", "state" : "ME", "county" : "LINCOLN" },
            "04538": { "city" : "BOOTHBAY HARBOR", "state" : "ME", "county" : "LINCOLN" },
            "04539": { "city" : "BRISTOL", "state" : "ME", "county" : "LINCOLN" },
            "04541": { "city" : "CHAMBERLAIN", "state" : "ME", "county" : "LINCOLN" },
            "04543": { "city" : "DAMARISCOTTA", "state" : "ME", "county" : "LINCOLN" },
            "04544": { "city" : "EAST BOOTHBAY", "state" : "ME", "county" : "LINCOLN" },
            "04547": { "city" : "FRIENDSHIP", "state" : "ME", "county" : "KNOX" },
            "04548": { "city" : "GEORGETOWN", "state" : "ME", "county" : "SAGADAHOC" },
            "04549": { "city" : "ISLE OF SPRINGS", "state" : "ME", "county" : "LINCOLN" },
            "04551": { "city" : "BREMEN", "state" : "ME", "county" : "LINCOLN" },
            "04553": { "city" : "NEWCASTLE", "state" : "ME", "county" : "LINCOLN" },
            "04554": { "city" : "NEW HARBOR", "state" : "ME", "county" : "LINCOLN" },
            "04555": { "city" : "NOBLEBORO", "state" : "ME", "county" : "LINCOLN" },
            "04556": { "city" : "EDGECOMB", "state" : "ME", "county" : "LINCOLN" },
            "04558": { "city" : "PEMAQUID", "state" : "ME", "county" : "LINCOLN" },
            "04562": { "city" : "PHIPPSBURG", "state" : "ME", "county" : "SAGADAHOC" },
            "04563": { "city" : "CUSHING", "state" : "ME", "county" : "KNOX" },"04564": { "city" : "ROUND POND", "state" : "ME", "county" : "LINCOLN" },
            "04565": { "city" : "SEBASCO ESTATES", "state" : "ME", "county" : "SAGADAHOC" },
            "04568": { "city" : "SOUTH BRISTOL", "state" : "ME", "county" : "LINCOLN" },
            "04570": { "city" : "SQUIRREL ISLAND", "state" : "ME", "county" : "LINCOLN" },
            "04571": { "city" : "TREVETT", "state" : "ME", "county" : "LINCOLN" },
            "04572": { "city" : "WALDOBORO", "state" : "ME", "county" : "LINCOLN" },
            "04573": { "city" : "WALPOLE", "state" : "ME", "county" : "LINCOLN" },
            "04574": { "city" : "WASHINGTON", "state" : "ME", "county" : "KNOX" },
            "04575": { "city" : "WEST BOOTHBAY HARBOR", "state" : "ME", "county" : "LINCOLN" },
            "04576": { "city" : "SOUTHPORT", "state" : "ME", "county" : "LINCOLN" },
            "04578": { "city" : "WISCASSET", "state" : "ME", "county" : "LINCOLN" },
            "04579": { "city" : "WOOLWICH", "state" : "ME", "county" : "SAGADAHOC" },
            "04605": { "city" : "ELLSWORTH", "state" : "ME", "county" : "HANCOCK" },
            "04606": { "city" : "ADDISON", "state" : "ME", "county" : "WASHINGTON" },
            "04607": { "city" : "GOULDSBORO", "state" : "ME", "county" : "HANCOCK" },
            "04609": { "city" : "BAR HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04611": { "city" : "BEALS", "state" : "ME", "county" : "WASHINGTON" },
            "04612": { "city" : "BERNARD", "state" : "ME", "county" : "HANCOCK" },
            "04613": { "city" : "BIRCH HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04614": { "city" : "BLUE HILL", "state" : "ME", "county" : "HANCOCK" },
            "04616": { "city" : "BROOKLIN", "state" : "ME", "county" : "HANCOCK" },
            "04617": { "city" : "BROOKSVILLE", "state" : "ME", "county" : "HANCOCK" },
            "04619": { "city" : "CALAIS", "state" : "ME", "county" : "WASHINGTON" },
            "04622": { "city" : "CHERRYFIELD", "state" : "ME", "county" : "WASHINGTON" },
            "04623": { "city" : "COLUMBIA FALLS", "state" : "ME", "county" : "WASHINGTON" },
            "04624": { "city" : "COREA", "state" : "ME", "county" : "HANCOCK" },"04625": { "city" : "CRANBERRY ISLES", "state" : "ME", "county" : "HANCOCK" },
            "04626": { "city" : "CUTLER", "state" : "ME", "county" : "WASHINGTON" },
            "04627": { "city" : "DEER ISLE", "state" : "ME", "county" : "HANCOCK" },
            "04628": { "city" : "DENNYSVILLE", "state" : "ME", "county" : "WASHINGTON" },
            "04629": { "city" : "EAST BLUE HILL", "state" : "ME", "county" : "HANCOCK" },
            "04630": { "city" : "EAST MACHIAS", "state" : "ME", "county" : "WASHINGTON" },
            "04631": { "city" : "EASTPORT", "state" : "ME", "county" : "WASHINGTON" },
            "04634": { "city" : "FRANKLIN", "state" : "ME", "county" : "HANCOCK" },
            "04635": { "city" : "FRENCHBORO", "state" : "ME", "county" : "HANCOCK" },
            "04637": { "city" : "GRAND LAKE STREAM", "state" : "ME", "county" : "WASHINGTON" },
            "04640": { "city" : "HANCOCK", "state" : "ME", "county" : "HANCOCK" },
            "04642": { "city" : "HARBORSIDE", "state" : "ME", "county" : "HANCOCK" },
            "04643": { "city" : "HARRINGTON", "state" : "ME", "county" : "WASHINGTON" },
            "04644": { "city" : "HULLS COVE", "state" : "ME", "county" : "HANCOCK" },
            "04645": { "city" : "ISLE AU HAUT", "state" : "ME", "county" : "KNOX" },
            "04646": { "city" : "ISLESFORD", "state" : "ME", "county" : "HANCOCK" },
            "04648": { "city" : "JONESBORO", "state" : "ME", "county" : "WASHINGTON" },
            "04649": { "city" : "JONESPORT", "state" : "ME", "county" : "WASHINGTON" },
            "04650": { "city" : "LITTLE DEER ISLE", "state" : "ME", "county" : "HANCOCK" },
            "04652": { "city" : "LUBEC", "state" : "ME", "county" : "WASHINGTON" },
            "04653": { "city" : "BASS HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04654": { "city" : "MACHIAS", "state" : "ME", "county" : "WASHINGTON" },
            "04655": { "city" : "MACHIASPORT", "state" : "ME", "county" : "WASHINGTON" },
            "04657": { "city" : "MEDDYBEMPS", "state" : "ME", "county" : "WASHINGTON" },
            "04658": { "city" : "MILBRIDGE", "state" : "ME", "county" : "WASHINGTON" },
            "04660": { "city" : "MOUNT DESERT", "state" : "ME", "county" : "HANCOCK" },
            "04662": { "city" : "NORTHEAST HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04664": { "city" : "SULLIVAN", "state" : "ME", "county" : "HANCOCK" },
            "04666": { "city" : "PEMBROKE", "state" : "ME", "county" : "WASHINGTON" },
            "04667": { "city" : "PERRY", "state" : "ME", "county" : "WASHINGTON" },
            "04668": { "city" : "PRINCETON", "state" : "ME", "county" : "WASHINGTON" },
            "04669": { "city" : "PROSPECT HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04671": { "city" : "ROBBINSTON", "state" : "ME", "county" : "WASHINGTON" },
            "04672": { "city" : "SALSBURY COVE", "state" : "ME", "county" : "HANCOCK" },
            "04673": { "city" : "SARGENTVILLE", "state" : "ME", "county" : "HANCOCK" },
            "04674": { "city" : "SEAL COVE", "state" : "ME", "county" : "HANCOCK" },
            "04675": { "city" : "SEAL HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04676": { "city" : "SEDGWICK", "state" : "ME", "county" : "HANCOCK" },
            "04677": { "city" : "SORRENTO", "state" : "ME", "county" : "HANCOCK" },
            "04679": { "city" : "SOUTHWEST HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04680": { "city" : "STEUBEN", "state" : "ME", "county" : "WASHINGTON" },
            "04681": { "city" : "STONINGTON", "state" : "ME", "county" : "HANCOCK" },
            "04683": { "city" : "SUNSET", "state" : "ME", "county" : "HANCOCK" },
            "04684": { "city" : "SURRY", "state" : "ME", "county" : "HANCOCK" },"04685": { "city" : "SWANS ISLAND", "state" : "ME", "county" : "HANCOCK" },
            "04686": { "city" : "WESLEY", "state" : "ME", "county" : "WASHINGTON" },
            "04691": { "city" : "WHITING", "state" : "ME", "county" : "WASHINGTON" },
            "04693": { "city" : "WINTER HARBOR", "state" : "ME", "county" : "HANCOCK" },
            "04694": { "city" : "BAILEYVILLE", "state" : "ME", "county" : "WASHINGTON" },
            "04730": { "city" : "HOULTON", "state" : "ME", "county" : "AROOSTOOK" },
            "04732": { "city" : "ASHLAND", "state" : "ME", "county" : "AROOSTOOK" },
            "04733": { "city" : "BENEDICTA", "state" : "ME", "county" : "AROOSTOOK" },
            "04734": { "city" : "BLAINE", "state" : "ME", "county" : "AROOSTOOK" },
            "04735": { "city" : "BRIDGEWATER", "state" : "ME", "county" : "AROOSTOOK" },
            "04736": { "city" : "CARIBOU", "state" : "ME", "county" : "AROOSTOOK" },
            "04737": { "city" : "CLAYTON LAKE", "state" : "ME", "county" : "AROOSTOOK" },
            "04738": { "city" : "CROUSEVILLE", "state" : "ME", "county" : "AROOSTOOK" },
            "04739": { "city" : "EAGLE LAKE", "state" : "ME", "county" : "AROOSTOOK" },
            "04740": { "city" : "EASTON", "state" : "ME", "county" : "AROOSTOOK" },
            "04742": { "city" : "FORT FAIRFIELD", "state" : "ME", "county" : "AROOSTOOK" },
            "04743": { "city" : "FORT KENT", "state" : "ME", "county" : "AROOSTOOK" },
            "04744": { "city" : "FORT KENT MILLS", "state" : "ME", "county" : "AROOSTOOK" },
            "04745": { "city" : "FRENCHVILLE", "state" : "ME", "county" : "AROOSTOOK" },
            "04746": { "city" : "GRAND ISLE", "state" : "ME", "county" : "AROOSTOOK" },
            "04747": { "city" : "ISLAND FALLS", "state" : "ME", "county" : "AROOSTOOK" },
            "04750": { "city" : "LIMESTONE", "state" : "ME", "county" : "AROOSTOOK" },
            "04751": { "city" : "LIMESTONE", "state" : "ME", "county" : "AROOSTOOK" },
            "04756": { "city" : "MADAWASKA", "state" : "ME", "county" : "AROOSTOOK" },
            "04757": { "city" : "MAPLETON", "state" : "ME", "county" : "AROOSTOOK" },
            "04758": { "city" : "MARS HILL", "state" : "ME", "county" : "AROOSTOOK" },
            "04760": { "city" : "MONTICELLO", "state" : "ME", "county" : "AROOSTOOK" },
            "04761": { "city" : "NEW LIMERICK", "state" : "ME", "county" : "AROOSTOOK" },
            "04762": { "city" : "NEW SWEDEN", "state" : "ME", "county" : "AROOSTOOK" },
            "04763": { "city" : "OAKFIELD", "state" : "ME", "county" : "AROOSTOOK" },
            "04764": { "city" : "OXBOW", "state" : "ME", "county" : "AROOSTOOK" },
            "04765": { "city" : "PATTEN", "state" : "ME", "county" : "PENOBSCOT" },
            "04766": { "city" : "PERHAM", "state" : "ME", "county" : "AROOSTOOK" },
            "04768": { "city" : "PORTAGE", "state" : "ME", "county" : "AROOSTOOK" },
            "04769": { "city" : "PRESQUE ISLE", "state" : "ME", "county" : "AROOSTOOK" },
            "04772": { "city" : "SAINT AGATHA", "state" : "ME", "county" : "AROOSTOOK" },
            "04773": { "city" : "SAINT DAVID", "state" : "ME", "county" : "AROOSTOOK" },
            "04774": { "city" : "SAINT FRANCIS", "state" : "ME", "county" : "AROOSTOOK" },
            "04776": { "city" : "SHERMAN", "state" : "ME", "county" : "AROOSTOOK" },
            "04777": { "city" : "STACYVILLE", "state" : "ME", "county" : "PENOBSCOT" },
            "04779": { "city" : "SINCLAIR", "state" : "ME", "county" : "AROOSTOOK" },
            "04780": { "city" : "SMYRNA MILLS", "state" : "ME", "county" : "AROOSTOOK" },
            "04781": { "city" : "WALLAGRASS", "state" : "ME", "county" : "AROOSTOOK" },
            "04783": { "city" : "STOCKHOLM", "state" : "ME", "county" : "AROOSTOOK" },
            "04785": { "city" : "VAN BUREN", "state" : "ME", "county" : "AROOSTOOK" },
            "04786": { "city" : "WASHBURN", "state" : "ME", "county" : "AROOSTOOK" },
            "04787": { "city" : "WESTFIELD", "state" : "ME", "county" : "AROOSTOOK" },
            "04841": { "city" : "ROCKLAND", "state" : "ME", "county" : "KNOX" },"04843": { "city" : "CAMDEN", "state" : "ME", "county" : "KNOX" },
            "04846": { "city" : "GLEN COVE", "state" : "ME", "county" : "KNOX" },
            "04847": { "city" : "HOPE", "state" : "ME", "county" : "KNOX" },"04848": { "city" : "ISLESBORO", "state" : "ME", "county" : "WALDO" },
            "04849": { "city" : "LINCOLNVILLE", "state" : "ME", "county" : "WALDO" },
            "04850": { "city" : "LINCOLNVILLE CENTER", "state" : "ME", "county" : "WALDO" },
            "04851": { "city" : "MATINICUS", "state" : "ME", "county" : "KNOX" },
            "04852": { "city" : "MONHEGAN", "state" : "ME", "county" : "LINCOLN" },
            "04853": { "city" : "NORTH HAVEN", "state" : "ME", "county" : "KNOX" },
            "04854": { "city" : "OWLS HEAD", "state" : "ME", "county" : "KNOX" },
            "04855": { "city" : "PORT CLYDE", "state" : "ME", "county" : "KNOX" },
            "04856": { "city" : "ROCKPORT", "state" : "ME", "county" : "KNOX" },"04858": { "city" : "SOUTH THOMASTON", "state" : "ME", "county" : "KNOX" },
            "04859": { "city" : "SPRUCE HEAD", "state" : "ME", "county" : "KNOX" },
            "04860": { "city" : "TENANTS HARBOR", "state" : "ME", "county" : "KNOX" },
            "04861": { "city" : "THOMASTON", "state" : "ME", "county" : "KNOX" },
            "04862": { "city" : "UNION", "state" : "ME", "county" : "KNOX" },"04863": { "city" : "VINALHAVEN", "state" : "ME", "county" : "KNOX" },
            "04864": { "city" : "WARREN", "state" : "ME", "county" : "KNOX" },"04865": { "city" : "WEST ROCKPORT", "state" : "ME", "county" : "KNOX" },
            "04901": { "city" : "WATERVILLE", "state" : "ME", "county" : "KENNEBEC" },
            "04903": { "city" : "WATERVILLE", "state" : "ME", "county" : "KENNEBEC" },
            "04910": { "city" : "ALBION", "state" : "ME", "county" : "KENNEBEC" },
            "04911": { "city" : "ANSON", "state" : "ME", "county" : "SOMERSET" },
            "04912": { "city" : "ATHENS", "state" : "ME", "county" : "SOMERSET" },
            "04915": { "city" : "BELFAST", "state" : "ME", "county" : "WALDO" },"04917": { "city" : "BELGRADE", "state" : "ME", "county" : "KENNEBEC" },
            "04918": { "city" : "BELGRADE LAKES", "state" : "ME", "county" : "KENNEBEC" },
            "04920": { "city" : "BINGHAM", "state" : "ME", "county" : "SOMERSET" },
            "04921": { "city" : "BROOKS", "state" : "ME", "county" : "WALDO" },"04922": { "city" : "BURNHAM", "state" : "ME", "county" : "WALDO" },
            "04923": { "city" : "CAMBRIDGE", "state" : "ME", "county" : "SOMERSET" },
            "04924": { "city" : "CANAAN", "state" : "ME", "county" : "SOMERSET" },
            "04925": { "city" : "CARATUNK", "state" : "ME", "county" : "SOMERSET" },
            "04926": { "city" : "CHINA VILLAGE", "state" : "ME", "county" : "KENNEBEC" },
            "04927": { "city" : "CLINTON", "state" : "ME", "county" : "KENNEBEC" },
            "04928": { "city" : "CORINNA", "state" : "ME", "county" : "PENOBSCOT" },
            "04929": { "city" : "DETROIT", "state" : "ME", "county" : "SOMERSET" },
            "04930": { "city" : "DEXTER", "state" : "ME", "county" : "PENOBSCOT" },
            "04932": { "city" : "DIXMONT", "state" : "ME", "county" : "PENOBSCOT" },
            "04933": { "city" : "EAST NEWPORT", "state" : "ME", "county" : "PENOBSCOT" },
            "04935": { "city" : "EAST VASSALBORO", "state" : "ME", "county" : "KENNEBEC" },
            "04936": { "city" : "EUSTIS", "state" : "ME", "county" : "FRANKLIN" },
            "04937": { "city" : "FAIRFIELD", "state" : "ME", "county" : "SOMERSET" },
            "04938": { "city" : "FARMINGTON", "state" : "ME", "county" : "FRANKLIN" },
            "04939": { "city" : "GARLAND", "state" : "ME", "county" : "PENOBSCOT" },
            "04940": { "city" : "FARMINGTON FALLS", "state" : "ME", "county" : "FRANKLIN" },
            "04941": { "city" : "FREEDOM", "state" : "ME", "county" : "WALDO" },"04942": { "city" : "HARMONY", "state" : "ME", "county" : "SOMERSET" },
            "04943": { "city" : "HARTLAND", "state" : "ME", "county" : "SOMERSET" },
            "04944": { "city" : "HINCKLEY", "state" : "ME", "county" : "SOMERSET" },
            "04945": { "city" : "JACKMAN", "state" : "ME", "county" : "SOMERSET" },
            "04947": { "city" : "KINGFIELD", "state" : "ME", "county" : "FRANKLIN" },
            "04949": { "city" : "LIBERTY", "state" : "ME", "county" : "WALDO" },"04950": { "city" : "MADISON", "state" : "ME", "county" : "SOMERSET" },
            "04951": { "city" : "MONROE", "state" : "ME", "county" : "WALDO" },"04952": { "city" : "MORRILL", "state" : "ME", "county" : "WALDO" },
            "04953": { "city" : "NEWPORT", "state" : "ME", "county" : "PENOBSCOT" },
            "04954": { "city" : "NEW PORTLAND", "state" : "ME", "county" : "SOMERSET" },
            "04955": { "city" : "NEW SHARON", "state" : "ME", "county" : "FRANKLIN" },
            "04956": { "city" : "NEW VINEYARD", "state" : "ME", "county" : "FRANKLIN" },
            "04957": { "city" : "NORRIDGEWOCK", "state" : "ME", "county" : "SOMERSET" },
            "04958": { "city" : "NORTH ANSON", "state" : "ME", "county" : "SOMERSET" },
            "04961": { "city" : "NEW PORTLAND", "state" : "ME", "county" : "SOMERSET" },
            "04962": { "city" : "NORTH VASSALBORO", "state" : "ME", "county" : "KENNEBEC" },
            "04963": { "city" : "OAKLAND", "state" : "ME", "county" : "KENNEBEC" },
            "04964": { "city" : "OQUOSSOC", "state" : "ME", "county" : "FRANKLIN" },
            "04965": { "city" : "PALMYRA", "state" : "ME", "county" : "SOMERSET" },
            "04966": { "city" : "PHILLIPS", "state" : "ME", "county" : "FRANKLIN" },
            "04967": { "city" : "PITTSFIELD", "state" : "ME", "county" : "SOMERSET" },
            "04969": { "city" : "PLYMOUTH", "state" : "ME", "county" : "PENOBSCOT" },
            "04970": { "city" : "RANGELEY", "state" : "ME", "county" : "FRANKLIN" },
            "04971": { "city" : "SAINT ALBANS", "state" : "ME", "county" : "SOMERSET" },
            "04973": { "city" : "SEARSMONT", "state" : "ME", "county" : "WALDO" },
            "04974": { "city" : "SEARSPORT", "state" : "ME", "county" : "WALDO" },
            "04975": { "city" : "SHAWMUT", "state" : "ME", "county" : "SOMERSET" },
            "04976": { "city" : "SKOWHEGAN", "state" : "ME", "county" : "SOMERSET" },
            "04978": { "city" : "SMITHFIELD", "state" : "ME", "county" : "SOMERSET" },
            "04979": { "city" : "SOLON", "state" : "ME", "county" : "SOMERSET" },
            "04981": { "city" : "STOCKTON SPRINGS", "state" : "ME", "county" : "WALDO" },
            "04982": { "city" : "STRATTON", "state" : "ME", "county" : "FRANKLIN" },
            "04983": { "city" : "STRONG", "state" : "ME", "county" : "FRANKLIN" },
            "04984": { "city" : "TEMPLE", "state" : "ME", "county" : "FRANKLIN" },
            "04985": { "city" : "WEST FORKS", "state" : "ME", "county" : "SOMERSET" },
            "04986": { "city" : "THORNDIKE", "state" : "ME", "county" : "WALDO" },
            "04987": { "city" : "TROY", "state" : "ME", "county" : "WALDO" },"04988": { "city" : "UNITY", "state" : "ME", "county" : "WALDO" },
            "04989": { "city" : "VASSALBORO", "state" : "ME", "county" : "KENNEBEC" },
            "04992": { "city" : "WEST FARMINGTON", "state" : "ME", "county" : "FRANKLIN" },
            "05001": { "city" : "WHITE RIVER JUNCTION", "state" : "VT", "county" : "WINDSOR" },
            "05009": { "city" : "WHITE RIVER JUNCTION", "state" : "VT", "county" : "WINDSOR" },
            "05030": { "city" : "ASCUTNEY", "state" : "VT", "county" : "WINDSOR" },
            "05031": { "city" : "BARNARD", "state" : "VT", "county" : "WINDSOR" },
            "05032": { "city" : "BETHEL", "state" : "VT", "county" : "WINDSOR" },
            "05033": { "city" : "BRADFORD", "state" : "VT", "county" : "ORANGE" },
            "05034": { "city" : "BRIDGEWATER", "state" : "VT", "county" : "WINDSOR" },
            "05035": { "city" : "BRIDGEWATER CORNERS", "state" : "VT", "county" : "WINDSOR" },
            "05036": { "city" : "BROOKFIELD", "state" : "VT", "county" : "ORANGE" },
            "05037": { "city" : "BROWNSVILLE", "state" : "VT", "county" : "WINDSOR" },
            "05038": { "city" : "CHELSEA", "state" : "VT", "county" : "ORANGE" },
            "05039": { "city" : "CORINTH", "state" : "VT", "county" : "ORANGE" },
            "05040": { "city" : "EAST CORINTH", "state" : "VT", "county" : "ORANGE" },
            "05041": { "city" : "EAST RANDOLPH", "state" : "VT", "county" : "ORANGE" },
            "05042": { "city" : "EAST RYEGATE", "state" : "VT", "county" : "CALEDONIA" },
            "05043": { "city" : "EAST THETFORD", "state" : "VT", "county" : "ORANGE" },
            "05045": { "city" : "FAIRLEE", "state" : "VT", "county" : "ORANGE" },
            "05046": { "city" : "GROTON", "state" : "VT", "county" : "CALEDONIA" },
            "05047": { "city" : "HARTFORD", "state" : "VT", "county" : "WINDSOR" },
            "05048": { "city" : "HARTLAND", "state" : "VT", "county" : "WINDSOR" },
            "05049": { "city" : "HARTLAND FOUR CORNERS", "state" : "VT", "county" : "WINDSOR" },
            "05050": { "city" : "MC INDOE FALLS", "state" : "VT", "county" : "CALEDONIA" },
            "05051": { "city" : "NEWBURY", "state" : "VT", "county" : "ORANGE" },
            "05052": { "city" : "NORTH HARTLAND", "state" : "VT", "county" : "WINDSOR" },
            "05053": { "city" : "NORTH POMFRET", "state" : "VT", "county" : "WINDSOR" },
            "05054": { "city" : "NORTH THETFORD", "state" : "VT", "county" : "ORANGE" },
            "05055": { "city" : "NORWICH", "state" : "VT", "county" : "WINDSOR" },
            "05056": { "city" : "PLYMOUTH", "state" : "VT", "county" : "WINDSOR" },
            "05058": { "city" : "POST MILLS", "state" : "VT", "county" : "ORANGE" },
            "05059": { "city" : "QUECHEE", "state" : "VT", "county" : "WINDSOR" },
            "05060": { "city" : "RANDOLPH", "state" : "VT", "county" : "ORANGE" },
            "05061": { "city" : "RANDOLPH CENTER", "state" : "VT", "county" : "ORANGE" },
            "05062": { "city" : "READING", "state" : "VT", "county" : "WINDSOR" },
            "05065": { "city" : "SHARON", "state" : "VT", "county" : "WINDSOR" },
            "05067": { "city" : "SOUTH POMFRET", "state" : "VT", "county" : "WINDSOR" },
            "05068": { "city" : "SOUTH ROYALTON", "state" : "VT", "county" : "WINDSOR" },
            "05069": { "city" : "SOUTH RYEGATE", "state" : "VT", "county" : "CALEDONIA" },
            "05070": { "city" : "SOUTH STRAFFORD", "state" : "VT", "county" : "ORANGE" },
            "05071": { "city" : "SOUTH WOODSTOCK", "state" : "VT", "county" : "WINDSOR" },
            "05072": { "city" : "STRAFFORD", "state" : "VT", "county" : "ORANGE" },
            "05073": { "city" : "TAFTSVILLE", "state" : "VT", "county" : "WINDSOR" },
            "05074": { "city" : "THETFORD", "state" : "VT", "county" : "ORANGE" },
            "05075": { "city" : "THETFORD CENTER", "state" : "VT", "county" : "ORANGE" },
            "05076": { "city" : "TOPSHAM", "state" : "VT", "county" : "ORANGE" },
            "05077": { "city" : "TUNBRIDGE", "state" : "VT", "county" : "ORANGE" },
            "05079": { "city" : "VERSHIRE", "state" : "VT", "county" : "ORANGE" },
            "05081": { "city" : "WELLS RIVER", "state" : "VT", "county" : "ORANGE" },
            "05083": { "city" : "WEST FAIRLEE", "state" : "VT", "county" : "ORANGE" },
            "05084": { "city" : "WEST HARTFORD", "state" : "VT", "county" : "WINDSOR" },
            "05085": { "city" : "WEST NEWBURY", "state" : "VT", "county" : "ORANGE" },
            "05086": { "city" : "WEST TOPSHAM", "state" : "VT", "county" : "ORANGE" },
            "05088": { "city" : "WILDER", "state" : "VT", "county" : "WINDSOR" },
            "05089": { "city" : "WINDSOR", "state" : "VT", "county" : "WINDSOR" },
            "05091": { "city" : "WOODSTOCK", "state" : "VT", "county" : "WINDSOR" },
            "05101": { "city" : "BELLOWS FALLS", "state" : "VT", "county" : "WINDHAM" },
            "05141": { "city" : "CAMBRIDGEPORT", "state" : "VT", "county" : "WINDHAM" },
            "05142": { "city" : "CAVENDISH", "state" : "VT", "county" : "WINDSOR" },
            "05143": { "city" : "CHESTER", "state" : "VT", "county" : "WINDSOR" },
            "05146": { "city" : "GRAFTON", "state" : "VT", "county" : "WINDHAM" },
            "05148": { "city" : "LONDONDERRY", "state" : "VT", "county" : "WINDHAM" },
            "05149": { "city" : "LUDLOW", "state" : "VT", "county" : "WINDSOR" },
            "05150": { "city" : "NORTH SPRINGFIELD", "state" : "VT", "county" : "WINDSOR" },
            "05151": { "city" : "PERKINSVILLE", "state" : "VT", "county" : "WINDSOR" },
            "05152": { "city" : "PERU", "state" : "VT", "county" : "BENNINGTON" },
            "05153": { "city" : "PROCTORSVILLE", "state" : "VT", "county" : "WINDSOR" },
            "05154": { "city" : "SAXTONS RIVER", "state" : "VT", "county" : "WINDHAM" },
            "05155": { "city" : "SOUTH LONDONDERRY", "state" : "VT", "county" : "WINDHAM" },
            "05156": { "city" : "SPRINGFIELD", "state" : "VT", "county" : "WINDSOR" },
            "05158": { "city" : "WESTMINSTER", "state" : "VT", "county" : "WINDHAM" },
            "05159": { "city" : "WESTMINSTER STATION", "state" : "VT", "county" : "WINDHAM" },
            "05161": { "city" : "WESTON", "state" : "VT", "county" : "WINDSOR" },
            "05201": { "city" : "BENNINGTON", "state" : "VT", "county" : "BENNINGTON" },
            "05250": { "city" : "ARLINGTON", "state" : "VT", "county" : "BENNINGTON" },
            "05251": { "city" : "DORSET", "state" : "VT", "county" : "BENNINGTON" },
            "05252": { "city" : "EAST ARLINGTON", "state" : "VT", "county" : "BENNINGTON" },
            "05253": { "city" : "EAST DORSET", "state" : "VT", "county" : "BENNINGTON" },
            "05254": { "city" : "MANCHESTER", "state" : "VT", "county" : "BENNINGTON" },
            "05255": { "city" : "MANCHESTER CENTER", "state" : "VT", "county" : "BENNINGTON" },
            "05257": { "city" : "NORTH BENNINGTON", "state" : "VT", "county" : "BENNINGTON" },
            "05260": { "city" : "NORTH POWNAL", "state" : "VT", "county" : "BENNINGTON" },
            "05261": { "city" : "POWNAL", "state" : "VT", "county" : "BENNINGTON" },
            "05262": { "city" : "SHAFTSBURY", "state" : "VT", "county" : "BENNINGTON" },
            "05301": { "city" : "BRATTLEBORO", "state" : "VT", "county" : "WINDHAM" },
            "05302": { "city" : "BRATTLEBORO", "state" : "VT", "county" : "WINDHAM" },
            "05303": { "city" : "BRATTLEBORO", "state" : "VT", "county" : "WINDHAM" },
            "05304": { "city" : "BRATTLEBORO", "state" : "VT", "county" : "WINDHAM" },
            "05340": { "city" : "BONDVILLE", "state" : "VT", "county" : "BENNINGTON" },
            "05341": { "city" : "EAST DOVER", "state" : "VT", "county" : "WINDHAM" },
            "05342": { "city" : "JACKSONVILLE", "state" : "VT", "county" : "WINDHAM" },
            "05343": { "city" : "JAMAICA", "state" : "VT", "county" : "WINDHAM" },
            "05344": { "city" : "MARLBORO", "state" : "VT", "county" : "WINDHAM" },
            "05345": { "city" : "NEWFANE", "state" : "VT", "county" : "WINDHAM" },
            "05346": { "city" : "PUTNEY", "state" : "VT", "county" : "WINDHAM" },
            "05350": { "city" : "READSBORO", "state" : "VT", "county" : "BENNINGTON" },
            "05351": { "city" : "SOUTH NEWFANE", "state" : "VT", "county" : "WINDHAM" },
            "05352": { "city" : "STAMFORD", "state" : "VT", "county" : "BENNINGTON" },
            "05353": { "city" : "TOWNSHEND", "state" : "VT", "county" : "WINDHAM" },
            "05354": { "city" : "VERNON", "state" : "VT", "county" : "WINDHAM" },
            "05355": { "city" : "WARDSBORO", "state" : "VT", "county" : "WINDHAM" },
            "05356": { "city" : "WEST DOVER", "state" : "VT", "county" : "WINDHAM" },
            "05357": { "city" : "WEST DUMMERSTON", "state" : "VT", "county" : "WINDHAM" },
            "05358": { "city" : "WEST HALIFAX", "state" : "VT", "county" : "WINDHAM" },
            "05359": { "city" : "WEST TOWNSHEND", "state" : "VT", "county" : "WINDHAM" },
            "05360": { "city" : "WEST WARDSBORO", "state" : "VT", "county" : "WINDHAM" },
            "05361": { "city" : "WHITINGHAM", "state" : "VT", "county" : "WINDHAM" },
            "05362": { "city" : "WILLIAMSVILLE", "state" : "VT", "county" : "WINDHAM" },
            "05363": { "city" : "WILMINGTON", "state" : "VT", "county" : "WINDHAM" },
            "05401": { "city" : "BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05402": { "city" : "BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05403": { "city" : "SOUTH BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05404": { "city" : "WINOOSKI", "state" : "VT", "county" : "CHITTENDEN" },
            "05405": { "city" : "BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05406": { "city" : "BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05407": { "city" : "SOUTH BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05408": { "city" : "BURLINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05439": { "city" : "COLCHESTER", "state" : "VT", "county" : "CHITTENDEN" },
            "05440": { "city" : "ALBURGH", "state" : "VT", "county" : "GRAND ISLE" },
            "05441": { "city" : "BAKERSFIELD", "state" : "VT", "county" : "FRANKLIN" },
            "05442": { "city" : "BELVIDERE CENTER", "state" : "VT", "county" : "LAMOILLE" },
            "05443": { "city" : "BRISTOL", "state" : "VT", "county" : "ADDISON" },
            "05444": { "city" : "CAMBRIDGE", "state" : "VT", "county" : "CHITTENDEN" },
            "05445": { "city" : "CHARLOTTE", "state" : "VT", "county" : "CHITTENDEN" },
            "05446": { "city" : "COLCHESTER", "state" : "VT", "county" : "CHITTENDEN" },
            "05447": { "city" : "EAST BERKSHIRE", "state" : "VT", "county" : "FRANKLIN" },
            "05448": { "city" : "EAST FAIRFIELD", "state" : "VT", "county" : "FRANKLIN" },
            "05449": { "city" : "COLCHESTER", "state" : "VT", "county" : "CHITTENDEN" },
            "05450": { "city" : "ENOSBURG FALLS", "state" : "VT", "county" : "FRANKLIN" },
            "05451": { "city" : "ESSEX", "state" : "VT", "county" : "CHITTENDEN" },
            "05452": { "city" : "ESSEX JUNCTION", "state" : "VT", "county" : "CHITTENDEN" },
            "05453": { "city" : "ESSEX JUNCTION", "state" : "VT", "county" : "CHITTENDEN" },
            "05454": { "city" : "FAIRFAX", "state" : "VT", "county" : "CHITTENDEN" },
            "05455": { "city" : "FAIRFIELD", "state" : "VT", "county" : "FRANKLIN" },
            "05456": { "city" : "FERRISBURGH", "state" : "VT", "county" : "ADDISON" },
            "05457": { "city" : "FRANKLIN", "state" : "VT", "county" : "FRANKLIN" },
            "05458": { "city" : "GRAND ISLE", "state" : "VT", "county" : "GRAND ISLE" },
            "05459": { "city" : "HIGHGATE CENTER", "state" : "VT", "county" : "FRANKLIN" },
            "05460": { "city" : "HIGHGATE SPRINGS", "state" : "VT", "county" : "FRANKLIN" },
            "05461": { "city" : "HINESBURG", "state" : "VT", "county" : "CHITTENDEN" },
            "05462": { "city" : "HUNTINGTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05463": { "city" : "ISLE LA MOTTE", "state" : "VT", "county" : "GRAND ISLE" },
            "05464": { "city" : "JEFFERSONVILLE", "state" : "VT", "county" : "LAMOILLE" },
            "05465": { "city" : "JERICHO", "state" : "VT", "county" : "CHITTENDEN" },
            "05466": { "city" : "JONESVILLE", "state" : "VT", "county" : "CHITTENDEN" },
            "05468": { "city" : "MILTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05469": { "city" : "MONKTON", "state" : "VT", "county" : "ADDISON" },
            "05470": { "city" : "MONTGOMERY", "state" : "VT", "county" : "FRANKLIN" },
            "05471": { "city" : "MONTGOMERY CENTER", "state" : "VT", "county" : "FRANKLIN" },
            "05472": { "city" : "NEW HAVEN", "state" : "VT", "county" : "ADDISON" },
            "05473": { "city" : "NORTH FERRISBURGH", "state" : "VT", "county" : "ADDISON" },
            "05474": { "city" : "NORTH HERO", "state" : "VT", "county" : "GRAND ISLE" },
            "05476": { "city" : "RICHFORD", "state" : "VT", "county" : "FRANKLIN" },
            "05477": { "city" : "RICHMOND", "state" : "VT", "county" : "CHITTENDEN" },
            "05478": { "city" : "SAINT ALBANS", "state" : "VT", "county" : "FRANKLIN" },
            "05479": { "city" : "SAINT ALBANS", "state" : "VT", "county" : "FRANKLIN" },
            "05481": { "city" : "SAINT ALBANS BAY", "state" : "VT", "county" : "FRANKLIN" },
            "05482": { "city" : "SHELBURNE", "state" : "VT", "county" : "CHITTENDEN" },
            "05483": { "city" : "SHELDON", "state" : "VT", "county" : "FRANKLIN" },
            "05485": { "city" : "SHELDON SPRINGS", "state" : "VT", "county" : "FRANKLIN" },
            "05486": { "city" : "SOUTH HERO", "state" : "VT", "county" : "GRAND ISLE" },
            "05487": { "city" : "STARKSBORO", "state" : "VT", "county" : "ADDISON" },
            "05488": { "city" : "SWANTON", "state" : "VT", "county" : "FRANKLIN" },
            "05489": { "city" : "UNDERHILL", "state" : "VT", "county" : "CHITTENDEN" },
            "05490": { "city" : "UNDERHILL CENTER", "state" : "VT", "county" : "CHITTENDEN" },
            "05491": { "city" : "VERGENNES", "state" : "VT", "county" : "ADDISON" },
            "05492": { "city" : "WATERVILLE", "state" : "VT", "county" : "LAMOILLE" },
            "05494": { "city" : "WESTFORD", "state" : "VT", "county" : "CHITTENDEN" },
            "05495": { "city" : "WILLISTON", "state" : "VT", "county" : "CHITTENDEN" },
            "05601": { "city" : "MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05602": { "city" : "MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05604": { "city" : "MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05620": { "city" : "MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05633": { "city" : "MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05640": { "city" : "ADAMANT", "state" : "VT", "county" : "WASHINGTON" },
            "05641": { "city" : "BARRE", "state" : "VT", "county" : "WASHINGTON" },
            "05647": { "city" : "CABOT", "state" : "VT", "county" : "WASHINGTON" },
            "05648": { "city" : "CALAIS", "state" : "VT", "county" : "WASHINGTON" },
            "05649": { "city" : "EAST BARRE", "state" : "VT", "county" : "WASHINGTON" },
            "05650": { "city" : "EAST CALAIS", "state" : "VT", "county" : "WASHINGTON" },
            "05651": { "city" : "EAST MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05652": { "city" : "EDEN", "state" : "VT", "county" : "LAMOILLE" },"05653": { "city" : "EDEN MILLS", "state" : "VT", "county" : "LAMOILLE" },
            "05654": { "city" : "GRANITEVILLE", "state" : "VT", "county" : "WASHINGTON" },
            "05655": { "city" : "HYDE PARK", "state" : "VT", "county" : "LAMOILLE" },
            "05656": { "city" : "JOHNSON", "state" : "VT", "county" : "LAMOILLE" },
            "05657": { "city" : "LAKE ELMORE", "state" : "VT", "county" : "LAMOILLE" },
            "05658": { "city" : "MARSHFIELD", "state" : "VT", "county" : "WASHINGTON" },
            "05660": { "city" : "MORETOWN", "state" : "VT", "county" : "WASHINGTON" },
            "05661": { "city" : "MORRISVILLE", "state" : "VT", "county" : "LAMOILLE" },
            "05662": { "city" : "MOSCOW", "state" : "VT", "county" : "LAMOILLE" },
            "05663": { "city" : "NORTHFIELD", "state" : "VT", "county" : "WASHINGTON" },
            "05664": { "city" : "NORTHFIELD FALLS", "state" : "VT", "county" : "WASHINGTON" },
            "05665": { "city" : "NORTH HYDE PARK", "state" : "VT", "county" : "LAMOILLE" },
            "05666": { "city" : "NORTH MONTPELIER", "state" : "VT", "county" : "WASHINGTON" },
            "05667": { "city" : "PLAINFIELD", "state" : "VT", "county" : "WASHINGTON" },
            "05669": { "city" : "ROXBURY", "state" : "VT", "county" : "ADDISON" },
            "05670": { "city" : "SOUTH BARRE", "state" : "VT", "county" : "WASHINGTON" },
            "05671": { "city" : "WATERBURY", "state" : "VT", "county" : "WASHINGTON" },
            "05672": { "city" : "STOWE", "state" : "VT", "county" : "LAMOILLE" },
            "05673": { "city" : "WAITSFIELD", "state" : "VT", "county" : "WASHINGTON" },
            "05674": { "city" : "WARREN", "state" : "VT", "county" : "WASHINGTON" },
            "05675": { "city" : "WASHINGTON", "state" : "VT", "county" : "ORANGE" },
            "05676": { "city" : "WATERBURY", "state" : "VT", "county" : "WASHINGTON" },
            "05677": { "city" : "WATERBURY CENTER", "state" : "VT", "county" : "WASHINGTON" },
            "05678": { "city" : "WEBSTERVILLE", "state" : "VT", "county" : "WASHINGTON" },
            "05679": { "city" : "WILLIAMSTOWN", "state" : "VT", "county" : "ORANGE" },
            "05680": { "city" : "WOLCOTT", "state" : "VT", "county" : "LAMOILLE" },
            "05681": { "city" : "WOODBURY", "state" : "VT", "county" : "WASHINGTON" },
            "05682": { "city" : "WORCESTER", "state" : "VT", "county" : "WASHINGTON" },
            "05701": { "city" : "RUTLAND", "state" : "VT", "county" : "RUTLAND" },
            "05702": { "city" : "RUTLAND", "state" : "VT", "county" : "RUTLAND" },
            "05730": { "city" : "BELMONT", "state" : "VT", "county" : "RUTLAND" },
            "05731": { "city" : "BENSON", "state" : "VT", "county" : "RUTLAND" },
            "05732": { "city" : "BOMOSEEN", "state" : "VT", "county" : "RUTLAND" },
            "05733": { "city" : "BRANDON", "state" : "VT", "county" : "RUTLAND" },
            "05734": { "city" : "BRIDPORT", "state" : "VT", "county" : "ADDISON" },
            "05735": { "city" : "CASTLETON", "state" : "VT", "county" : "RUTLAND" },
            "05736": { "city" : "CENTER RUTLAND", "state" : "VT", "county" : "RUTLAND" },
            "05737": { "city" : "CHITTENDEN", "state" : "VT", "county" : "RUTLAND" },
            "05738": { "city" : "CUTTINGSVILLE", "state" : "VT", "county" : "RUTLAND" },
            "05739": { "city" : "DANBY", "state" : "VT", "county" : "RUTLAND" },"05740": { "city" : "EAST MIDDLEBURY", "state" : "VT", "county" : "ADDISON" },
            "05741": { "city" : "EAST POULTNEY", "state" : "VT", "county" : "RUTLAND" },
            "05742": { "city" : "EAST WALLINGFORD", "state" : "VT", "county" : "RUTLAND" },
            "05743": { "city" : "FAIR HAVEN", "state" : "VT", "county" : "RUTLAND" },
            "05744": { "city" : "FLORENCE", "state" : "VT", "county" : "RUTLAND" },
            "05745": { "city" : "FOREST DALE", "state" : "VT", "county" : "RUTLAND" },
            "05746": { "city" : "GAYSVILLE", "state" : "VT", "county" : "WINDSOR" },
            "05747": { "city" : "GRANVILLE", "state" : "VT", "county" : "ADDISON" },
            "05748": { "city" : "HANCOCK", "state" : "VT", "county" : "ADDISON" },
            "05750": { "city" : "HYDEVILLE", "state" : "VT", "county" : "RUTLAND" },
            "05751": { "city" : "KILLINGTON", "state" : "VT", "county" : "RUTLAND" },
            "05753": { "city" : "MIDDLEBURY", "state" : "VT", "county" : "ADDISON" },
            "05757": { "city" : "MIDDLETOWN SPRINGS", "state" : "VT", "county" : "RUTLAND" },
            "05758": { "city" : "MOUNT HOLLY", "state" : "VT", "county" : "RUTLAND" },
            "05759": { "city" : "NORTH CLARENDON", "state" : "VT", "county" : "RUTLAND" },
            "05760": { "city" : "ORWELL", "state" : "VT", "county" : "ADDISON" },
            "05761": { "city" : "PAWLET", "state" : "VT", "county" : "RUTLAND" },
            "05762": { "city" : "PITTSFIELD", "state" : "VT", "county" : "RUTLAND" },
            "05763": { "city" : "PITTSFORD", "state" : "VT", "county" : "RUTLAND" },
            "05764": { "city" : "POULTNEY", "state" : "VT", "county" : "RUTLAND" },
            "05765": { "city" : "PROCTOR", "state" : "VT", "county" : "RUTLAND" },
            "05766": { "city" : "RIPTON", "state" : "VT", "county" : "ADDISON" },
            "05767": { "city" : "ROCHESTER", "state" : "VT", "county" : "WINDSOR" },
            "05768": { "city" : "RUPERT", "state" : "VT", "county" : "BENNINGTON" },
            "05769": { "city" : "SALISBURY", "state" : "VT", "county" : "ADDISON" },
            "05770": { "city" : "SHOREHAM", "state" : "VT", "county" : "ADDISON" },
            "05772": { "city" : "STOCKBRIDGE", "state" : "VT", "county" : "WINDSOR" },
            "05773": { "city" : "WALLINGFORD", "state" : "VT", "county" : "RUTLAND" },
            "05774": { "city" : "WELLS", "state" : "VT", "county" : "RUTLAND" },"05775": { "city" : "WEST PAWLET", "state" : "VT", "county" : "RUTLAND" },
            "05776": { "city" : "WEST RUPERT", "state" : "VT", "county" : "BENNINGTON" },
            "05777": { "city" : "WEST RUTLAND", "state" : "VT", "county" : "RUTLAND" },
            "05778": { "city" : "WHITING", "state" : "VT", "county" : "ADDISON" },
            "05819": { "city" : "SAINT JOHNSBURY", "state" : "VT", "county" : "CALEDONIA" },
            "05820": { "city" : "ALBANY", "state" : "VT", "county" : "ORLEANS" },
            "05821": { "city" : "BARNET", "state" : "VT", "county" : "CALEDONIA" },
            "05822": { "city" : "BARTON", "state" : "VT", "county" : "ORLEANS" },
            "05823": { "city" : "BEEBE PLAIN", "state" : "VT", "county" : "ORLEANS" },
            "05824": { "city" : "CONCORD", "state" : "VT", "county" : "ESSEX" },"05825": { "city" : "COVENTRY", "state" : "VT", "county" : "ORLEANS" },
            "05826": { "city" : "CRAFTSBURY", "state" : "VT", "county" : "ORLEANS" },
            "05827": { "city" : "CRAFTSBURY COMMON", "state" : "VT", "county" : "ORLEANS" },
            "05828": { "city" : "DANVILLE", "state" : "VT", "county" : "CALEDONIA" },
            "05829": { "city" : "DERBY", "state" : "VT", "county" : "ORLEANS" },"05830": { "city" : "DERBY LINE", "state" : "VT", "county" : "ORLEANS" },
            "05832": { "city" : "EAST BURKE", "state" : "VT", "county" : "CALEDONIA" },
            "05833": { "city" : "EAST CHARLESTON", "state" : "VT", "county" : "ORLEANS" },
            "05836": { "city" : "EAST HARDWICK", "state" : "VT", "county" : "CALEDONIA" },
            "05838": { "city" : "EAST SAINT JOHNSBURY", "state" : "VT", "county" : "CALEDONIA" },
            "05839": { "city" : "GLOVER", "state" : "VT", "county" : "ORLEANS" },
            "05840": { "city" : "GRANBY", "state" : "VT", "county" : "ESSEX" },"05841": { "city" : "GREENSBORO", "state" : "VT", "county" : "ORLEANS" },
            "05842": { "city" : "GREENSBORO BEND", "state" : "VT", "county" : "ORLEANS" },
            "05843": { "city" : "HARDWICK", "state" : "VT", "county" : "CALEDONIA" },
            "05845": { "city" : "IRASBURG", "state" : "VT", "county" : "ORLEANS" },
            "05846": { "city" : "ISLAND POND", "state" : "VT", "county" : "ESSEX" },
            "05847": { "city" : "LOWELL", "state" : "VT", "county" : "ORLEANS" },
            "05848": { "city" : "LOWER WATERFORD", "state" : "VT", "county" : "CALEDONIA" },
            "05849": { "city" : "LYNDON", "state" : "VT", "county" : "CALEDONIA" },
            "05850": { "city" : "LYNDON CENTER", "state" : "VT", "county" : "CALEDONIA" },
            "05851": { "city" : "LYNDONVILLE", "state" : "VT", "county" : "CALEDONIA" },
            "05853": { "city" : "MORGAN", "state" : "VT", "county" : "ORLEANS" },
            "05855": { "city" : "NEWPORT", "state" : "VT", "county" : "ORLEANS" },
            "05857": { "city" : "NEWPORT CENTER", "state" : "VT", "county" : "ORLEANS" },
            "05858": { "city" : "NORTH CONCORD", "state" : "VT", "county" : "ESSEX" },
            "05859": { "city" : "NORTH TROY", "state" : "VT", "county" : "ORLEANS" },
            "05860": { "city" : "ORLEANS", "state" : "VT", "county" : "ORLEANS" },
            "05861": { "city" : "PASSUMPSIC", "state" : "VT", "county" : "CALEDONIA" },
            "05862": { "city" : "PEACHAM", "state" : "VT", "county" : "CALEDONIA" },
            "05863": { "city" : "SAINT JOHNSBURY CENTER", "state" : "VT", "county" : "CALEDONIA" },
            "05866": { "city" : "SHEFFIELD", "state" : "VT", "county" : "CALEDONIA" },
            "05867": { "city" : "SUTTON", "state" : "VT", "county" : "CALEDONIA" },
            "05868": { "city" : "TROY", "state" : "VT", "county" : "ORLEANS" },"05871": { "city" : "WEST BURKE", "state" : "VT", "county" : "CALEDONIA" },
            "05872": { "city" : "WEST CHARLESTON", "state" : "VT", "county" : "ORLEANS" },
            "05873": { "city" : "WEST DANVILLE", "state" : "VT", "county" : "CALEDONIA" },
            "05874": { "city" : "WESTFIELD", "state" : "VT", "county" : "ORLEANS" },
            "05875": { "city" : "WEST GLOVER", "state" : "VT", "county" : "ORLEANS" },
            "05901": { "city" : "AVERILL", "state" : "VT", "county" : "ESSEX" },"05902": { "city" : "BEECHER FALLS", "state" : "VT", "county" : "ESSEX" },
            "05903": { "city" : "CANAAN", "state" : "VT", "county" : "ESSEX" },"05904": { "city" : "GILMAN", "state" : "VT", "county" : "ESSEX" },
            "05905": { "city" : "GUILDHALL", "state" : "VT", "county" : "ESSEX" },
            "05906": { "city" : "LUNENBURG", "state" : "VT", "county" : "ESSEX" },
            "05907": { "city" : "NORTON", "state" : "VT", "county" : "ESSEX" },"06001": { "city" : "AVON", "state" : "CT", "county" : "HARTFORD" },
            "06002": { "city" : "BLOOMFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06006": { "city" : "WINDSOR", "state" : "CT", "county" : "HARTFORD" },
            "06010": { "city" : "BRISTOL", "state" : "CT", "county" : "HARTFORD" },
            "06011": { "city" : "BRISTOL", "state" : "CT", "county" : "HARTFORD" },
            "06013": { "city" : "BURLINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06016": { "city" : "BROAD BROOK", "state" : "CT", "county" : "HARTFORD" },
            "06018": { "city" : "CANAAN", "state" : "CT", "county" : "LITCHFIELD" },
            "06019": { "city" : "CANTON", "state" : "CT", "county" : "HARTFORD" },
            "06020": { "city" : "CANTON CENTER", "state" : "CT", "county" : "HARTFORD" },
            "06021": { "city" : "COLEBROOK", "state" : "CT", "county" : "LITCHFIELD" },
            "06022": { "city" : "COLLINSVILLE", "state" : "CT", "county" : "HARTFORD" },
            "06023": { "city" : "EAST BERLIN", "state" : "CT", "county" : "HARTFORD" },
            "06024": { "city" : "EAST CANAAN", "state" : "CT", "county" : "LITCHFIELD" },
            "06025": { "city" : "EAST GLASTONBURY", "state" : "CT", "county" : "HARTFORD" },
            "06026": { "city" : "EAST GRANBY", "state" : "CT", "county" : "HARTFORD" },
            "06027": { "city" : "EAST HARTLAND", "state" : "CT", "county" : "HARTFORD" },
            "06028": { "city" : "EAST WINDSOR HILL", "state" : "CT", "county" : "HARTFORD" },
            "06029": { "city" : "ELLINGTON", "state" : "CT", "county" : "TOLLAND" },
            "06030": { "city" : "FARMINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06031": { "city" : "FALLS VILLAGE", "state" : "CT", "county" : "LITCHFIELD" },
            "06032": { "city" : "FARMINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06033": { "city" : "GLASTONBURY", "state" : "CT", "county" : "HARTFORD" },
            "06034": { "city" : "FARMINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06035": { "city" : "GRANBY", "state" : "CT", "county" : "HARTFORD" },
            "06037": { "city" : "BERLIN", "state" : "CT", "county" : "HARTFORD" },
            "06039": { "city" : "LAKEVILLE", "state" : "CT", "county" : "LITCHFIELD" },
            "06040": { "city" : "MANCHESTER", "state" : "CT", "county" : "HARTFORD" },
            "06041": { "city" : "MANCHESTER", "state" : "CT", "county" : "HARTFORD" },
            "06042": { "city" : "MANCHESTER", "state" : "CT", "county" : "HARTFORD" },
            "06043": { "city" : "BOLTON", "state" : "CT", "county" : "TOLLAND" },
            "06045": { "city" : "MANCHESTER", "state" : "CT", "county" : "HARTFORD" },
            "06050": { "city" : "NEW BRITAIN", "state" : "CT", "county" : "HARTFORD" },
            "06051": { "city" : "NEW BRITAIN", "state" : "CT", "county" : "HARTFORD" },
            "06052": { "city" : "NEW BRITAIN", "state" : "CT", "county" : "HARTFORD" },
            "06053": { "city" : "NEW BRITAIN", "state" : "CT", "county" : "HARTFORD" },
            "06057": { "city" : "NEW HARTFORD", "state" : "CT", "county" : "LITCHFIELD" },
            "06058": { "city" : "NORFOLK", "state" : "CT", "county" : "LITCHFIELD" },
            "06059": { "city" : "NORTH CANTON", "state" : "CT", "county" : "HARTFORD" },
            "06060": { "city" : "NORTH GRANBY", "state" : "CT", "county" : "HARTFORD" },
            "06061": { "city" : "PINE MEADOW", "state" : "CT", "county" : "LITCHFIELD" },
            "06062": { "city" : "PLAINVILLE", "state" : "CT", "county" : "HARTFORD" },
            "06063": { "city" : "BARKHAMSTED", "state" : "CT", "county" : "LITCHFIELD" },
            "06064": { "city" : "POQUONOCK", "state" : "CT", "county" : "HARTFORD" },
            "06065": { "city" : "RIVERTON", "state" : "CT", "county" : "LITCHFIELD" },
            "06066": { "city" : "VERNON ROCKVILLE", "state" : "CT", "county" : "TOLLAND" },
            "06067": { "city" : "ROCKY HILL", "state" : "CT", "county" : "HARTFORD" },
            "06068": { "city" : "SALISBURY", "state" : "CT", "county" : "LITCHFIELD" },
            "06069": { "city" : "SHARON", "state" : "CT", "county" : "LITCHFIELD" },
            "06070": { "city" : "SIMSBURY", "state" : "CT", "county" : "HARTFORD" },
            "06071": { "city" : "SOMERS", "state" : "CT", "county" : "TOLLAND" },
            "06072": { "city" : "SOMERSVILLE", "state" : "CT", "county" : "TOLLAND" },
            "06073": { "city" : "SOUTH GLASTONBURY", "state" : "CT", "county" : "HARTFORD" },
            "06074": { "city" : "SOUTH WINDSOR", "state" : "CT", "county" : "HARTFORD" },
            "06075": { "city" : "STAFFORD", "state" : "CT", "county" : "TOLLAND" },
            "06076": { "city" : "STAFFORD SPRINGS", "state" : "CT", "county" : "TOLLAND" },
            "06077": { "city" : "STAFFORDVILLE", "state" : "CT", "county" : "TOLLAND" },
            "06078": { "city" : "SUFFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06079": { "city" : "TACONIC", "state" : "CT", "county" : "LITCHFIELD" },
            "06080": { "city" : "SUFFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06081": { "city" : "TARIFFVILLE", "state" : "CT", "county" : "HARTFORD" },
            "06082": { "city" : "ENFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06083": { "city" : "ENFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06084": { "city" : "TOLLAND", "state" : "CT", "county" : "TOLLAND" },
            "06085": { "city" : "UNIONVILLE", "state" : "CT", "county" : "HARTFORD" },
            "06088": { "city" : "EAST WINDSOR", "state" : "CT", "county" : "HARTFORD" },
            "06089": { "city" : "WEATOGUE", "state" : "CT", "county" : "HARTFORD" },
            "06090": { "city" : "WEST GRANBY", "state" : "CT", "county" : "HARTFORD" },
            "06091": { "city" : "WEST HARTLAND", "state" : "CT", "county" : "HARTFORD" },
            "06092": { "city" : "WEST SIMSBURY", "state" : "CT", "county" : "HARTFORD" },
            "06093": { "city" : "WEST SUFFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06094": { "city" : "WINCHESTER CENTER", "state" : "CT", "county" : "LITCHFIELD" },
            "06095": { "city" : "WINDSOR", "state" : "CT", "county" : "HARTFORD" },
            "06096": { "city" : "WINDSOR LOCKS", "state" : "CT", "county" : "HARTFORD" },
            "06098": { "city" : "WINSTED", "state" : "CT", "county" : "LITCHFIELD" },
            "06101": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06102": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06103": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06105": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06106": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06107": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06108": { "city" : "EAST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06109": { "city" : "WETHERSFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06110": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06111": { "city" : "NEWINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06112": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06114": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06115": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06117": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06118": { "city" : "EAST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06119": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06120": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06123": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06126": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06127": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06128": { "city" : "EAST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06129": { "city" : "WETHERSFIELD", "state" : "CT", "county" : "HARTFORD" },
            "06131": { "city" : "NEWINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06132": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06133": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06134": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06137": { "city" : "WEST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06138": { "city" : "EAST HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06140": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06141": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06142": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06143": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06144": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06145": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06146": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06147": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06150": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06151": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06152": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06153": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06155": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06156": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06160": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06183": { "city" : "HARTFORD", "state" : "CT", "county" : "HARTFORD" },
            "06226": { "city" : "WILLIMANTIC", "state" : "CT", "county" : "WINDHAM" },
            "06230": { "city" : "ABINGTON", "state" : "CT", "county" : "WINDHAM" },
            "06231": { "city" : "AMSTON", "state" : "CT", "county" : "TOLLAND" },
            "06232": { "city" : "ANDOVER", "state" : "CT", "county" : "TOLLAND" },
            "06233": { "city" : "BALLOUVILLE", "state" : "CT", "county" : "WINDHAM" },
            "06234": { "city" : "BROOKLYN", "state" : "CT", "county" : "WINDHAM" },
            "06235": { "city" : "CHAPLIN", "state" : "CT", "county" : "WINDHAM" },
            "06237": { "city" : "COLUMBIA", "state" : "CT", "county" : "TOLLAND" },
            "06238": { "city" : "COVENTRY", "state" : "CT", "county" : "TOLLAND" },
            "06239": { "city" : "DANIELSON", "state" : "CT", "county" : "WINDHAM" },
            "06241": { "city" : "DAYVILLE", "state" : "CT", "county" : "WINDHAM" },
            "06242": { "city" : "EASTFORD", "state" : "CT", "county" : "WINDHAM" },
            "06243": { "city" : "EAST KILLINGLY", "state" : "CT", "county" : "WINDHAM" },
            "06244": { "city" : "EAST WOODSTOCK", "state" : "CT", "county" : "WINDHAM" },
            "06245": { "city" : "FABYAN", "state" : "CT", "county" : "WINDHAM" },
            "06246": { "city" : "GROSVENOR DALE", "state" : "CT", "county" : "WINDHAM" },
            "06247": { "city" : "HAMPTON", "state" : "CT", "county" : "WINDHAM" },
            "06248": { "city" : "HEBRON", "state" : "CT", "county" : "TOLLAND" },
            "06249": { "city" : "LEBANON", "state" : "CT", "county" : "NEW LONDON" },
            "06250": { "city" : "MANSFIELD CENTER", "state" : "CT", "county" : "TOLLAND" },
            "06251": { "city" : "MANSFIELD DEPOT", "state" : "CT", "county" : "TOLLAND" },
            "06254": { "city" : "NORTH FRANKLIN", "state" : "CT", "county" : "NEW LONDON" },
            "06255": { "city" : "NORTH GROSVENORDALE", "state" : "CT", "county" : "WINDHAM" },
            "06256": { "city" : "NORTH WINDHAM", "state" : "CT", "county" : "WINDHAM" },
            "06258": { "city" : "POMFRET", "state" : "CT", "county" : "WINDHAM" },
            "06259": { "city" : "POMFRET CENTER", "state" : "CT", "county" : "WINDHAM" },
            "06260": { "city" : "PUTNAM", "state" : "CT", "county" : "WINDHAM" },
            "06262": { "city" : "QUINEBAUG", "state" : "CT", "county" : "WINDHAM" },
            "06263": { "city" : "ROGERS", "state" : "CT", "county" : "WINDHAM" },
            "06264": { "city" : "SCOTLAND", "state" : "CT", "county" : "WINDHAM" },
            "06266": { "city" : "SOUTH WINDHAM", "state" : "CT", "county" : "WINDHAM" },
            "06267": { "city" : "SOUTH WOODSTOCK", "state" : "CT", "county" : "WINDHAM" },
            "06268": { "city" : "STORRS MANSFIELD", "state" : "CT", "county" : "TOLLAND" },
            "06269": { "city" : "STORRS MANSFIELD", "state" : "CT", "county" : "TOLLAND" },
            "06277": { "city" : "THOMPSON", "state" : "CT", "county" : "WINDHAM" },
            "06278": { "city" : "ASHFORD", "state" : "CT", "county" : "WINDHAM" },
            "06279": { "city" : "WILLINGTON", "state" : "CT", "county" : "TOLLAND" },
            "06280": { "city" : "WINDHAM", "state" : "CT", "county" : "WINDHAM" },
            "06281": { "city" : "WOODSTOCK", "state" : "CT", "county" : "WINDHAM" },
            "06282": { "city" : "WOODSTOCK VALLEY", "state" : "CT", "county" : "WINDHAM" },
            "06320": { "city" : "NEW LONDON", "state" : "CT", "county" : "NEW LONDON" },
            "06330": { "city" : "BALTIC", "state" : "CT", "county" : "NEW LONDON" },
            "06331": { "city" : "CANTERBURY", "state" : "CT", "county" : "WINDHAM" },
            "06332": { "city" : "CENTRAL VILLAGE", "state" : "CT", "county" : "WINDHAM" },
            "06333": { "city" : "EAST LYME", "state" : "CT", "county" : "NEW LONDON" },
            "06334": { "city" : "BOZRAH", "state" : "CT", "county" : "NEW LONDON" },
            "06335": { "city" : "GALES FERRY", "state" : "CT", "county" : "NEW LONDON" },
            "06336": { "city" : "GILMAN", "state" : "CT", "county" : "NEW LONDON" },
            "06338": { "city" : "MASHANTUCKET", "state" : "CT", "county" : "NEW LONDON" },
            "06339": { "city" : "LEDYARD", "state" : "CT", "county" : "NEW LONDON" },
            "06340": { "city" : "GROTON", "state" : "CT", "county" : "NEW LONDON" },
            "06349": { "city" : "GROTON", "state" : "CT", "county" : "NEW LONDON" },
            "06350": { "city" : "HANOVER", "state" : "CT", "county" : "NEW LONDON" },
            "06351": { "city" : "JEWETT CITY", "state" : "CT", "county" : "NEW LONDON" },
            "06353": { "city" : "MONTVILLE", "state" : "CT", "county" : "NEW LONDON" },
            "06354": { "city" : "MOOSUP", "state" : "CT", "county" : "WINDHAM" },
            "06355": { "city" : "MYSTIC", "state" : "CT", "county" : "NEW LONDON" },
            "06357": { "city" : "NIANTIC", "state" : "CT", "county" : "NEW LONDON" },
            "06359": { "city" : "NORTH STONINGTON", "state" : "CT", "county" : "NEW LONDON" },
            "06360": { "city" : "NORWICH", "state" : "CT", "county" : "NEW LONDON" },
            "06365": { "city" : "PRESTON", "state" : "CT", "county" : "NEW LONDON" },
            "06370": { "city" : "OAKDALE", "state" : "CT", "county" : "NEW LONDON" },
            "06371": { "city" : "OLD LYME", "state" : "CT", "county" : "NEW LONDON" },
            "06372": { "city" : "OLD MYSTIC", "state" : "CT", "county" : "NEW LONDON" },
            "06373": { "city" : "ONECO", "state" : "CT", "county" : "WINDHAM" },"06374": { "city" : "PLAINFIELD", "state" : "CT", "county" : "WINDHAM" },
            "06375": { "city" : "QUAKER HILL", "state" : "CT", "county" : "NEW LONDON" },
            "06376": { "city" : "SOUTH LYME", "state" : "CT", "county" : "NEW LONDON" },
            "06377": { "city" : "STERLING", "state" : "CT", "county" : "WINDHAM" },
            "06378": { "city" : "STONINGTON", "state" : "CT", "county" : "NEW LONDON" },
            "06379": { "city" : "PAWCATUCK", "state" : "CT", "county" : "NEW LONDON" },
            "06380": { "city" : "TAFTVILLE", "state" : "CT", "county" : "NEW LONDON" },
            "06382": { "city" : "UNCASVILLE", "state" : "CT", "county" : "NEW LONDON" },
            "06383": { "city" : "VERSAILLES", "state" : "CT", "county" : "NEW LONDON" },
            "06384": { "city" : "VOLUNTOWN", "state" : "CT", "county" : "NEW LONDON" },
            "06385": { "city" : "WATERFORD", "state" : "CT", "county" : "NEW LONDON" },
            "06387": { "city" : "WAUREGAN", "state" : "CT", "county" : "WINDHAM" },
            "06388": { "city" : "WEST MYSTIC", "state" : "CT", "county" : "NEW LONDON" },
            "06389": { "city" : "YANTIC", "state" : "CT", "county" : "NEW LONDON" },
            "06390": { "city" : "FISHERS ISLAND", "state" : "NY", "county" : "SUFFOLK" },
            "06401": { "city" : "ANSONIA", "state" : "CT", "county" : "NEW HAVEN" },
            "06403": { "city" : "BEACON FALLS", "state" : "CT", "county" : "NEW HAVEN" },
            "06404": { "city" : "BOTSFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06405": { "city" : "BRANFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06408": { "city" : "CHESHIRE", "state" : "CT", "county" : "NEW HAVEN" },
            "06409": { "city" : "CENTERBROOK", "state" : "CT", "county" : "MIDDLESEX" },
            "06410": { "city" : "CHESHIRE", "state" : "CT", "county" : "NEW HAVEN" },
            "06411": { "city" : "CHESHIRE", "state" : "CT", "county" : "NEW HAVEN" },
            "06412": { "city" : "CHESTER", "state" : "CT", "county" : "MIDDLESEX" },
            "06413": { "city" : "CLINTON", "state" : "CT", "county" : "MIDDLESEX" },
            "06414": { "city" : "COBALT", "state" : "CT", "county" : "MIDDLESEX" },
            "06415": { "city" : "COLCHESTER", "state" : "CT", "county" : "NEW LONDON" },
            "06416": { "city" : "CROMWELL", "state" : "CT", "county" : "MIDDLESEX" },
            "06417": { "city" : "DEEP RIVER", "state" : "CT", "county" : "MIDDLESEX" },
            "06418": { "city" : "DERBY", "state" : "CT", "county" : "NEW HAVEN" },
            "06419": { "city" : "KILLINGWORTH", "state" : "CT", "county" : "MIDDLESEX" },
            "06420": { "city" : "SALEM", "state" : "CT", "county" : "NEW LONDON" },
            "06422": { "city" : "DURHAM", "state" : "CT", "county" : "MIDDLESEX" },
            "06423": { "city" : "EAST HADDAM", "state" : "CT", "county" : "MIDDLESEX" },
            "06424": { "city" : "EAST HAMPTON", "state" : "CT", "county" : "MIDDLESEX" },
            "06426": { "city" : "ESSEX", "state" : "CT", "county" : "MIDDLESEX" },
            "06437": { "city" : "GUILFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06438": { "city" : "HADDAM", "state" : "CT", "county" : "MIDDLESEX" },
            "06439": { "city" : "HADLYME", "state" : "CT", "county" : "NEW LONDON" },
            "06440": { "city" : "HAWLEYVILLE", "state" : "CT", "county" : "FAIRFIELD" },
            "06441": { "city" : "HIGGANUM", "state" : "CT", "county" : "MIDDLESEX" },
            "06442": { "city" : "IVORYTON", "state" : "CT", "county" : "MIDDLESEX" },
            "06443": { "city" : "MADISON", "state" : "CT", "county" : "NEW HAVEN" },
            "06444": { "city" : "MARION", "state" : "CT", "county" : "HARTFORD" },
            "06447": { "city" : "MARLBOROUGH", "state" : "CT", "county" : "HARTFORD" },
            "06450": { "city" : "MERIDEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06451": { "city" : "MERIDEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06455": { "city" : "MIDDLEFIELD", "state" : "CT", "county" : "MIDDLESEX" },
            "06456": { "city" : "MIDDLE HADDAM", "state" : "CT", "county" : "MIDDLESEX" },
            "06457": { "city" : "MIDDLETOWN", "state" : "CT", "county" : "MIDDLESEX" },
            "06459": { "city" : "MIDDLETOWN", "state" : "CT", "county" : "MIDDLESEX" },
            "06460": { "city" : "MILFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06461": { "city" : "MILFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06467": { "city" : "MILLDALE", "state" : "CT", "county" : "HARTFORD" },
            "06468": { "city" : "MONROE", "state" : "CT", "county" : "FAIRFIELD" },
            "06469": { "city" : "MOODUS", "state" : "CT", "county" : "MIDDLESEX" },
            "06470": { "city" : "NEWTOWN", "state" : "CT", "county" : "FAIRFIELD" },
            "06471": { "city" : "NORTH BRANFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06472": { "city" : "NORTHFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06473": { "city" : "NORTH HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06475": { "city" : "OLD SAYBROOK", "state" : "CT", "county" : "MIDDLESEX" },
            "06477": { "city" : "ORANGE", "state" : "CT", "county" : "NEW HAVEN" },
            "06478": { "city" : "OXFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06479": { "city" : "PLANTSVILLE", "state" : "CT", "county" : "HARTFORD" },
            "06480": { "city" : "PORTLAND", "state" : "CT", "county" : "MIDDLESEX" },
            "06481": { "city" : "ROCKFALL", "state" : "CT", "county" : "MIDDLESEX" },
            "06482": { "city" : "SANDY HOOK", "state" : "CT", "county" : "FAIRFIELD" },
            "06483": { "city" : "SEYMOUR", "state" : "CT", "county" : "NEW HAVEN" },
            "06484": { "city" : "SHELTON", "state" : "CT", "county" : "FAIRFIELD" },
            "06487": { "city" : "SOUTH BRITAIN", "state" : "CT", "county" : "NEW HAVEN" },
            "06488": { "city" : "SOUTHBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06489": { "city" : "SOUTHINGTON", "state" : "CT", "county" : "HARTFORD" },
            "06491": { "city" : "STEVENSON", "state" : "CT", "county" : "FAIRFIELD" },
            "06492": { "city" : "WALLINGFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06493": { "city" : "WALLINGFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06495": { "city" : "WALLINGFORD", "state" : "CT", "county" : "NEW HAVEN" },
            "06498": { "city" : "WESTBROOK", "state" : "CT", "county" : "MIDDLESEX" },
            "06501": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06503": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06504": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06505": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06506": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06507": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06508": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06509": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06510": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06511": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06512": { "city" : "EAST HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06513": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06514": { "city" : "HAMDEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06515": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06516": { "city" : "WEST HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06517": { "city" : "HAMDEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06518": { "city" : "HAMDEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06519": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06520": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06524": { "city" : "BETHANY", "state" : "CT", "county" : "NEW HAVEN" },
            "06525": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06530": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06531": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06532": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06534": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06536": { "city" : "NEW HAVEN", "state" : "CT", "county" : "NEW HAVEN" },
            "06601": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06602": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06604": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06605": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06606": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06607": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06608": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06610": { "city" : "BRIDGEPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06611": { "city" : "TRUMBULL", "state" : "CT", "county" : "FAIRFIELD" },
            "06612": { "city" : "EASTON", "state" : "CT", "county" : "FAIRFIELD" },
            "06614": { "city" : "STRATFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06615": { "city" : "STRATFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06701": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06702": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06703": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06704": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06705": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06706": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06708": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06710": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06712": { "city" : "PROSPECT", "state" : "CT", "county" : "NEW HAVEN" },
            "06716": { "city" : "WOLCOTT", "state" : "CT", "county" : "NEW HAVEN" },
            "06720": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06721": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06722": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06723": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06724": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06749": { "city" : "WATERBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06750": { "city" : "BANTAM", "state" : "CT", "county" : "LITCHFIELD" },
            "06751": { "city" : "BETHLEHEM", "state" : "CT", "county" : "LITCHFIELD" },
            "06752": { "city" : "BRIDGEWATER", "state" : "CT", "county" : "LITCHFIELD" },
            "06753": { "city" : "CORNWALL", "state" : "CT", "county" : "LITCHFIELD" },
            "06754": { "city" : "CORNWALL BRIDGE", "state" : "CT", "county" : "LITCHFIELD" },
            "06755": { "city" : "GAYLORDSVILLE", "state" : "CT", "county" : "LITCHFIELD" },
            "06756": { "city" : "GOSHEN", "state" : "CT", "county" : "LITCHFIELD" },
            "06757": { "city" : "KENT", "state" : "CT", "county" : "LITCHFIELD" },
            "06758": { "city" : "LAKESIDE", "state" : "CT", "county" : "LITCHFIELD" },
            "06759": { "city" : "LITCHFIELD", "state" : "CT", "county" : "LITCHFIELD" },
            "06762": { "city" : "MIDDLEBURY", "state" : "CT", "county" : "NEW HAVEN" },
            "06763": { "city" : "MORRIS", "state" : "CT", "county" : "LITCHFIELD" },
            "06770": { "city" : "NAUGATUCK", "state" : "CT", "county" : "NEW HAVEN" },
            "06776": { "city" : "NEW MILFORD", "state" : "CT", "county" : "LITCHFIELD" },
            "06777": { "city" : "NEW PRESTON MARBLE DALE", "state" : "CT", "county" : "LITCHFIELD" },
            "06778": { "city" : "NORTHFIELD", "state" : "CT", "county" : "LITCHFIELD" },
            "06779": { "city" : "OAKVILLE", "state" : "CT", "county" : "LITCHFIELD" },
            "06781": { "city" : "PEQUABUCK", "state" : "CT", "county" : "LITCHFIELD" },
            "06782": { "city" : "PLYMOUTH", "state" : "CT", "county" : "LITCHFIELD" },
            "06783": { "city" : "ROXBURY", "state" : "CT", "county" : "LITCHFIELD" },
            "06784": { "city" : "SHERMAN", "state" : "CT", "county" : "FAIRFIELD" },
            "06785": { "city" : "SOUTH KENT", "state" : "CT", "county" : "LITCHFIELD" },
            "06786": { "city" : "TERRYVILLE", "state" : "CT", "county" : "LITCHFIELD" },
            "06787": { "city" : "THOMASTON", "state" : "CT", "county" : "LITCHFIELD" },
            "06790": { "city" : "TORRINGTON", "state" : "CT", "county" : "LITCHFIELD" },
            "06791": { "city" : "HARWINTON", "state" : "CT", "county" : "LITCHFIELD" },
            "06793": { "city" : "WASHINGTON", "state" : "CT", "county" : "LITCHFIELD" },
            "06794": { "city" : "WASHINGTON DEPOT", "state" : "CT", "county" : "LITCHFIELD" },
            "06795": { "city" : "WATERTOWN", "state" : "CT", "county" : "LITCHFIELD" },
            "06796": { "city" : "WEST CORNWALL", "state" : "CT", "county" : "LITCHFIELD" },
            "06798": { "city" : "WOODBURY", "state" : "CT", "county" : "LITCHFIELD" },
            "06801": { "city" : "BETHEL", "state" : "CT", "county" : "FAIRFIELD" },
            "06804": { "city" : "BROOKFIELD", "state" : "CT", "county" : "FAIRFIELD" },
            "06807": { "city" : "COS COB", "state" : "CT", "county" : "FAIRFIELD" },
            "06810": { "city" : "DANBURY", "state" : "CT", "county" : "FAIRFIELD" },
            "06811": { "city" : "DANBURY", "state" : "CT", "county" : "FAIRFIELD" },
            "06812": { "city" : "NEW FAIRFIELD", "state" : "CT", "county" : "FAIRFIELD" },
            "06813": { "city" : "DANBURY", "state" : "CT", "county" : "FAIRFIELD" },
            "06816": { "city" : "DANBURY", "state" : "CT", "county" : "FAIRFIELD" },
            "06817": { "city" : "DANBURY", "state" : "CT", "county" : "FAIRFIELD" },
            "06820": { "city" : "DARIEN", "state" : "CT", "county" : "FAIRFIELD" },
            "06824": { "city" : "FAIRFIELD", "state" : "CT", "county" : "FAIRFIELD" },
            "06825": { "city" : "FAIRFIELD", "state" : "CT", "county" : "FAIRFIELD" },
            "06828": { "city" : "FAIRFIELD", "state" : "CT", "county" : "FAIRFIELD" },
            "06829": { "city" : "GEORGETOWN", "state" : "CT", "county" : "FAIRFIELD" },
            "06830": { "city" : "GREENWICH", "state" : "CT", "county" : "FAIRFIELD" },
            "06831": { "city" : "GREENWICH", "state" : "CT", "county" : "FAIRFIELD" },
            "06836": { "city" : "GREENWICH", "state" : "CT", "county" : "FAIRFIELD" },
            "06838": { "city" : "GREENS FARMS", "state" : "CT", "county" : "FAIRFIELD" },
            "06840": { "city" : "NEW CANAAN", "state" : "CT", "county" : "FAIRFIELD" },
            "06850": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06851": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06852": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06853": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06854": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06855": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06856": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06857": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06860": { "city" : "NORWALK", "state" : "CT", "county" : "FAIRFIELD" },
            "06870": { "city" : "OLD GREENWICH", "state" : "CT", "county" : "FAIRFIELD" },
            "06875": { "city" : "REDDING CENTER", "state" : "CT", "county" : "FAIRFIELD" },
            "06876": { "city" : "REDDING RIDGE", "state" : "CT", "county" : "FAIRFIELD" },
            "06877": { "city" : "RIDGEFIELD", "state" : "CT", "county" : "FAIRFIELD" },
            "06878": { "city" : "RIVERSIDE", "state" : "CT", "county" : "FAIRFIELD" },
            "06880": { "city" : "WESTPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06881": { "city" : "WESTPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06883": { "city" : "WESTON", "state" : "CT", "county" : "FAIRFIELD" },
            "06889": { "city" : "WESTPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06890": { "city" : "SOUTHPORT", "state" : "CT", "county" : "FAIRFIELD" },
            "06896": { "city" : "REDDING", "state" : "CT", "county" : "FAIRFIELD" },
            "06897": { "city" : "WILTON", "state" : "CT", "county" : "FAIRFIELD" },
            "06901": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06902": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06903": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06904": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06905": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06906": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06907": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06911": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06912": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06913": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06921": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06922": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06926": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "06927": { "city" : "STAMFORD", "state" : "CT", "county" : "FAIRFIELD" },
            "07001": { "city" : "AVENEL", "state" : "NJ", "county" : "MIDDLESEX" },
            "07002": { "city" : "BAYONNE", "state" : "NJ", "county" : "HUDSON" },
            "07003": { "city" : "BLOOMFIELD", "state" : "NJ", "county" : "ESSEX" },
            "07004": { "city" : "FAIRFIELD", "state" : "NJ", "county" : "ESSEX" },
            "07005": { "city" : "BOONTON", "state" : "NJ", "county" : "MORRIS" },
            "07006": { "city" : "CALDWELL", "state" : "NJ", "county" : "ESSEX" },
            "07007": { "city" : "CALDWELL", "state" : "NJ", "county" : "ESSEX" },
            "07008": { "city" : "CARTERET", "state" : "NJ", "county" : "MIDDLESEX" },
            "07009": { "city" : "CEDAR GROVE", "state" : "NJ", "county" : "ESSEX" },
            "07010": { "city" : "CLIFFSIDE PARK", "state" : "NJ", "county" : "BERGEN" },
            "07011": { "city" : "CLIFTON", "state" : "NJ", "county" : "PASSAIC" },
            "07012": { "city" : "CLIFTON", "state" : "NJ", "county" : "PASSAIC" },
            "07013": { "city" : "CLIFTON", "state" : "NJ", "county" : "PASSAIC" },
            "07014": { "city" : "CLIFTON", "state" : "NJ", "county" : "PASSAIC" },
            "07015": { "city" : "CLIFTON", "state" : "NJ", "county" : "PASSAIC" },
            "07016": { "city" : "CRANFORD", "state" : "NJ", "county" : "UNION" },
            "07017": { "city" : "EAST ORANGE", "state" : "NJ", "county" : "ESSEX" },
            "07018": { "city" : "EAST ORANGE", "state" : "NJ", "county" : "ESSEX" },
            "07019": { "city" : "EAST ORANGE", "state" : "NJ", "county" : "ESSEX" },
            "07020": { "city" : "EDGEWATER", "state" : "NJ", "county" : "BERGEN" },
            "07021": { "city" : "ESSEX FELLS", "state" : "NJ", "county" : "ESSEX" },
            "07022": { "city" : "FAIRVIEW", "state" : "NJ", "county" : "BERGEN" },
            "07023": { "city" : "FANWOOD", "state" : "NJ", "county" : "UNION" },"07024": { "city" : "FORT LEE", "state" : "NJ", "county" : "BERGEN" },
            "07026": { "city" : "GARFIELD", "state" : "NJ", "county" : "BERGEN" },
            "07027": { "city" : "GARWOOD", "state" : "NJ", "county" : "UNION" },"07028": { "city" : "GLEN RIDGE", "state" : "NJ", "county" : "ESSEX" },
            "07029": { "city" : "HARRISON", "state" : "NJ", "county" : "HUDSON" },
            "07030": { "city" : "HOBOKEN", "state" : "NJ", "county" : "HUDSON" },
            "07031": { "city" : "NORTH ARLINGTON", "state" : "NJ", "county" : "BERGEN" },
            "07032": { "city" : "KEARNY", "state" : "NJ", "county" : "HUDSON" },"07033": { "city" : "KENILWORTH", "state" : "NJ", "county" : "UNION" },
            "07034": { "city" : "LAKE HIAWATHA", "state" : "NJ", "county" : "MORRIS" },
            "07035": { "city" : "LINCOLN PARK", "state" : "NJ", "county" : "MORRIS" },
            "07036": { "city" : "LINDEN", "state" : "NJ", "county" : "UNION" },"07039": { "city" : "LIVINGSTON", "state" : "NJ", "county" : "ESSEX" },
            "07040": { "city" : "MAPLEWOOD", "state" : "NJ", "county" : "ESSEX" },
            "07041": { "city" : "MILLBURN", "state" : "NJ", "county" : "ESSEX" },
            "07042": { "city" : "MONTCLAIR", "state" : "NJ", "county" : "ESSEX" },
            "07043": { "city" : "MONTCLAIR", "state" : "NJ", "county" : "ESSEX" },
            "07044": { "city" : "VERONA", "state" : "NJ", "county" : "ESSEX" },"07045": { "city" : "MONTVILLE", "state" : "NJ", "county" : "MORRIS" },
            "07046": { "city" : "MOUNTAIN LAKES", "state" : "NJ", "county" : "MORRIS" },
            "07047": { "city" : "NORTH BERGEN", "state" : "NJ", "county" : "HUDSON" },
            "07050": { "city" : "ORANGE", "state" : "NJ", "county" : "ESSEX" },"07051": { "city" : "ORANGE", "state" : "NJ", "county" : "ESSEX" },
            "07052": { "city" : "WEST ORANGE", "state" : "NJ", "county" : "ESSEX" },
            "07054": { "city" : "PARSIPPANY", "state" : "NJ", "county" : "MORRIS" },
            "07055": { "city" : "PASSAIC", "state" : "NJ", "county" : "PASSAIC" },
            "07057": { "city" : "WALLINGTON", "state" : "NJ", "county" : "BERGEN" },
            "07058": { "city" : "PINE BROOK", "state" : "NJ", "county" : "MORRIS" },
            "07059": { "city" : "WARREN", "state" : "NJ", "county" : "SOMERSET" },
            "07060": { "city" : "PLAINFIELD", "state" : "NJ", "county" : "UNION" },
            "07061": { "city" : "PLAINFIELD", "state" : "NJ", "county" : "UNION" },
            "07062": { "city" : "PLAINFIELD", "state" : "NJ", "county" : "UNION" },
            "07063": { "city" : "PLAINFIELD", "state" : "NJ", "county" : "UNION" },
            "07064": { "city" : "PORT READING", "state" : "NJ", "county" : "MIDDLESEX" },
            "07065": { "city" : "RAHWAY", "state" : "NJ", "county" : "UNION" },"07066": { "city" : "CLARK", "state" : "NJ", "county" : "UNION" },
            "07067": { "city" : "COLONIA", "state" : "NJ", "county" : "MIDDLESEX" },
            "07068": { "city" : "ROSELAND", "state" : "NJ", "county" : "ESSEX" },
            "07069": { "city" : "WATCHUNG", "state" : "NJ", "county" : "SOMERSET" },
            "07070": { "city" : "RUTHERFORD", "state" : "NJ", "county" : "BERGEN" },
            "07071": { "city" : "LYNDHURST", "state" : "NJ", "county" : "BERGEN" },
            "07072": { "city" : "CARLSTADT", "state" : "NJ", "county" : "BERGEN" },
            "07073": { "city" : "EAST RUTHERFORD", "state" : "NJ", "county" : "BERGEN" },
            "07074": { "city" : "MOONACHIE", "state" : "NJ", "county" : "BERGEN" },
            "07075": { "city" : "WOOD RIDGE", "state" : "NJ", "county" : "BERGEN" },
            "07076": { "city" : "SCOTCH PLAINS", "state" : "NJ", "county" : "UNION" },
            "07077": { "city" : "SEWAREN", "state" : "NJ", "county" : "MIDDLESEX" },
            "07078": { "city" : "SHORT HILLS", "state" : "NJ", "county" : "ESSEX" },
            "07079": { "city" : "SOUTH ORANGE", "state" : "NJ", "county" : "ESSEX" },
            "07080": { "city" : "SOUTH PLAINFIELD", "state" : "NJ", "county" : "MIDDLESEX" },
            "07081": { "city" : "SPRINGFIELD", "state" : "NJ", "county" : "UNION" },
            "07082": { "city" : "TOWACO", "state" : "NJ", "county" : "MORRIS" },"07083": { "city" : "UNION", "state" : "NJ", "county" : "UNION" },
            "07086": { "city" : "WEEHAWKEN", "state" : "NJ", "county" : "HUDSON" },
            "07087": { "city" : "UNION CITY", "state" : "NJ", "county" : "HUDSON" },
            "07088": { "city" : "VAUXHALL", "state" : "NJ", "county" : "UNION" },
            "07090": { "city" : "WESTFIELD", "state" : "NJ", "county" : "UNION" },
            "07091": { "city" : "WESTFIELD", "state" : "NJ", "county" : "UNION" },
            "07092": { "city" : "MOUNTAINSIDE", "state" : "NJ", "county" : "UNION" },
            "07093": { "city" : "WEST NEW YORK", "state" : "NJ", "county" : "HUDSON" },
            "07094": { "city" : "SECAUCUS", "state" : "NJ", "county" : "HUDSON" },
            "07095": { "city" : "WOODBRIDGE", "state" : "NJ", "county" : "MIDDLESEX" },
            "07096": { "city" : "SECAUCUS", "state" : "NJ", "county" : "HUDSON" },
            "07097": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07099": { "city" : "KEARNY", "state" : "NJ", "county" : "HUDSON" },"07101": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },
            "07102": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },"07103": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },
            "07104": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },"07105": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },
            "07106": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },"07107": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },
            "07108": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },"07109": { "city" : "BELLEVILLE", "state" : "NJ", "county" : "ESSEX" },
            "07110": { "city" : "NUTLEY", "state" : "NJ", "county" : "ESSEX" },"07111": { "city" : "IRVINGTON", "state" : "NJ", "county" : "ESSEX" },
            "07112": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },"07114": { "city" : "NEWARK", "state" : "NJ", "county" : "ESSEX" },
            "07201": { "city" : "ELIZABETH", "state" : "NJ", "county" : "UNION" },
            "07202": { "city" : "ELIZABETH", "state" : "NJ", "county" : "UNION" },
            "07203": { "city" : "ROSELLE", "state" : "NJ", "county" : "UNION" },"07204": { "city" : "ROSELLE PARK", "state" : "NJ", "county" : "UNION" },
            "07205": { "city" : "HILLSIDE", "state" : "NJ", "county" : "UNION" },
            "07206": { "city" : "ELIZABETHPORT", "state" : "NJ", "county" : "UNION" },
            "07207": { "city" : "ELIZABETH", "state" : "NJ", "county" : "UNION" },
            "07208": { "city" : "ELIZABETH", "state" : "NJ", "county" : "UNION" },
            "07302": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07303": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07304": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07305": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07306": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07307": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07308": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07310": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07311": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07395": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07399": { "city" : "JERSEY CITY", "state" : "NJ", "county" : "HUDSON" },
            "07401": { "city" : "ALLENDALE", "state" : "NJ", "county" : "BERGEN" },
            "07403": { "city" : "BLOOMINGDALE", "state" : "NJ", "county" : "PASSAIC" },
            "07405": { "city" : "BUTLER", "state" : "NJ", "county" : "MORRIS" },"07407": { "city" : "ELMWOOD PARK", "state" : "NJ", "county" : "BERGEN" },
            "07410": { "city" : "FAIR LAWN", "state" : "NJ", "county" : "BERGEN" },
            "07416": { "city" : "FRANKLIN", "state" : "NJ", "county" : "SUSSEX" },
            "07417": { "city" : "FRANKLIN LAKES", "state" : "NJ", "county" : "BERGEN" },
            "07418": { "city" : "GLENWOOD", "state" : "NJ", "county" : "SUSSEX" },
            "07419": { "city" : "HAMBURG", "state" : "NJ", "county" : "SUSSEX" },
            "07420": { "city" : "HASKELL", "state" : "NJ", "county" : "PASSAIC" },
            "07421": { "city" : "HEWITT", "state" : "NJ", "county" : "PASSAIC" },
            "07422": { "city" : "HIGHLAND LAKES", "state" : "NJ", "county" : "SUSSEX" },
            "07423": { "city" : "HO HO KUS", "state" : "NJ", "county" : "BERGEN" },
            "07424": { "city" : "LITTLE FALLS", "state" : "NJ", "county" : "PASSAIC" },
            "07428": { "city" : "MC AFEE", "state" : "NJ", "county" : "SUSSEX" },
            "07430": { "city" : "MAHWAH", "state" : "NJ", "county" : "BERGEN" },"07432": { "city" : "MIDLAND PARK", "state" : "NJ", "county" : "BERGEN" },
            "07435": { "city" : "NEWFOUNDLAND", "state" : "NJ", "county" : "PASSAIC" },
            "07436": { "city" : "OAKLAND", "state" : "NJ", "county" : "BERGEN" },
            "07438": { "city" : "OAK RIDGE", "state" : "NJ", "county" : "PASSAIC" },
            "07439": { "city" : "OGDENSBURG", "state" : "NJ", "county" : "SUSSEX" },
            "07440": { "city" : "PEQUANNOCK", "state" : "NJ", "county" : "MORRIS" },
            "07442": { "city" : "POMPTON LAKES", "state" : "NJ", "county" : "PASSAIC" },
            "07444": { "city" : "POMPTON PLAINS", "state" : "NJ", "county" : "MORRIS" },
            "07446": { "city" : "RAMSEY", "state" : "NJ", "county" : "BERGEN" },"07450": { "city" : "RIDGEWOOD", "state" : "NJ", "county" : "BERGEN" },
            "07451": { "city" : "RIDGEWOOD", "state" : "NJ", "county" : "BERGEN" },
            "07452": { "city" : "GLEN ROCK", "state" : "NJ", "county" : "BERGEN" },
            "07456": { "city" : "RINGWOOD", "state" : "NJ", "county" : "PASSAIC" },
            "07457": { "city" : "RIVERDALE", "state" : "NJ", "county" : "MORRIS" },
            "07458": { "city" : "SADDLE RIVER", "state" : "NJ", "county" : "BERGEN" },
            "07460": { "city" : "STOCKHOLM", "state" : "NJ", "county" : "SUSSEX" },
            "07461": { "city" : "SUSSEX", "state" : "NJ", "county" : "SUSSEX" },"07462": { "city" : "VERNON", "state" : "NJ", "county" : "SUSSEX" },
            "07463": { "city" : "WALDWICK", "state" : "NJ", "county" : "BERGEN" },
            "07465": { "city" : "WANAQUE", "state" : "NJ", "county" : "PASSAIC" },
            "07470": { "city" : "WAYNE", "state" : "NJ", "county" : "PASSAIC" },"07474": { "city" : "WAYNE", "state" : "NJ", "county" : "PASSAIC" },
            "07480": { "city" : "WEST MILFORD", "state" : "NJ", "county" : "PASSAIC" },
            "07481": { "city" : "WYCKOFF", "state" : "NJ", "county" : "BERGEN" },
            "07495": { "city" : "MAHWAH", "state" : "NJ", "county" : "BERGEN" },"07501": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07502": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07503": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07504": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07505": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07506": { "city" : "HAWTHORNE", "state" : "NJ", "county" : "PASSAIC" },
            "07507": { "city" : "HAWTHORNE", "state" : "NJ", "county" : "PASSAIC" },
            "07508": { "city" : "HALEDON", "state" : "NJ", "county" : "PASSAIC" },
            "07509": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07510": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07511": { "city" : "TOTOWA", "state" : "NJ", "county" : "PASSAIC" },
            "07512": { "city" : "TOTOWA", "state" : "NJ", "county" : "PASSAIC" },
            "07513": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07514": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07522": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07524": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07533": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07538": { "city" : "HALEDON", "state" : "NJ", "county" : "PASSAIC" },
            "07543": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07544": { "city" : "PATERSON", "state" : "NJ", "county" : "PASSAIC" },
            "07601": { "city" : "HACKENSACK", "state" : "NJ", "county" : "BERGEN" },
            "07602": { "city" : "HACKENSACK", "state" : "NJ", "county" : "BERGEN" },
            "07603": { "city" : "BOGOTA", "state" : "NJ", "county" : "BERGEN" },"07604": { "city" : "HASBROUCK HEIGHTS", "state" : "NJ", "county" : "BERGEN" },
            "07605": { "city" : "LEONIA", "state" : "NJ", "county" : "BERGEN" },"07606": { "city" : "SOUTH HACKENSACK", "state" : "NJ", "county" : "BERGEN" },
            "07607": { "city" : "MAYWOOD", "state" : "NJ", "county" : "BERGEN" },
            "07608": { "city" : "TETERBORO", "state" : "NJ", "county" : "BERGEN" },
            "07620": { "city" : "ALPINE", "state" : "NJ", "county" : "BERGEN" },"07621": { "city" : "BERGENFIELD", "state" : "NJ", "county" : "BERGEN" },
            "07624": { "city" : "CLOSTER", "state" : "NJ", "county" : "BERGEN" },
            "07626": { "city" : "CRESSKILL", "state" : "NJ", "county" : "BERGEN" },
            "07627": { "city" : "DEMAREST", "state" : "NJ", "county" : "BERGEN" },
            "07628": { "city" : "DUMONT", "state" : "NJ", "county" : "BERGEN" },"07630": { "city" : "EMERSON", "state" : "NJ", "county" : "BERGEN" },
            "07631": { "city" : "ENGLEWOOD", "state" : "NJ", "county" : "BERGEN" },
            "07632": { "city" : "ENGLEWOOD CLIFFS", "state" : "NJ", "county" : "BERGEN" },
            "07640": { "city" : "HARRINGTON PARK", "state" : "NJ", "county" : "BERGEN" },
            "07641": { "city" : "HAWORTH", "state" : "NJ", "county" : "BERGEN" },
            "07642": { "city" : "HILLSDALE", "state" : "NJ", "county" : "BERGEN" },
            "07643": { "city" : "LITTLE FERRY", "state" : "NJ", "county" : "BERGEN" },
            "07644": { "city" : "LODI", "state" : "NJ", "county" : "BERGEN" },"07645": { "city" : "MONTVALE", "state" : "NJ", "county" : "BERGEN" },
            "07646": { "city" : "NEW MILFORD", "state" : "NJ", "county" : "BERGEN" },
            "07647": { "city" : "NORTHVALE", "state" : "NJ", "county" : "BERGEN" },
            "07648": { "city" : "NORWOOD", "state" : "NJ", "county" : "BERGEN" },
            "07649": { "city" : "ORADELL", "state" : "NJ", "county" : "BERGEN" },
            "07650": { "city" : "PALISADES PARK", "state" : "NJ", "county" : "BERGEN" },
            "07652": { "city" : "PARAMUS", "state" : "NJ", "county" : "BERGEN" },
            "07653": { "city" : "PARAMUS", "state" : "NJ", "county" : "BERGEN" },
            "07656": { "city" : "PARK RIDGE", "state" : "NJ", "county" : "BERGEN" },
            "07657": { "city" : "RIDGEFIELD", "state" : "NJ", "county" : "BERGEN" },
            "07660": { "city" : "RIDGEFIELD PARK", "state" : "NJ", "county" : "BERGEN" },
            "07661": { "city" : "RIVER EDGE", "state" : "NJ", "county" : "BERGEN" },
            "07662": { "city" : "ROCHELLE PARK", "state" : "NJ", "county" : "BERGEN" },
            "07663": { "city" : "SADDLE BROOK", "state" : "NJ", "county" : "BERGEN" },
            "07666": { "city" : "TEANECK", "state" : "NJ", "county" : "BERGEN" },
            "07670": { "city" : "TENAFLY", "state" : "NJ", "county" : "BERGEN" },
            "07675": { "city" : "WESTWOOD", "state" : "NJ", "county" : "BERGEN" },
            "07676": { "city" : "TOWNSHIP OF WASHINGTON", "state" : "NJ", "county" : "BERGEN" },
            "07677": { "city" : "WOODCLIFF LAKE", "state" : "NJ", "county" : "BERGEN" },
            "07701": { "city" : "RED BANK", "state" : "NJ", "county" : "MONMOUTH" },
            "07702": { "city" : "SHREWSBURY", "state" : "NJ", "county" : "MONMOUTH" },
            "07703": { "city" : "FORT MONMOUTH", "state" : "NJ", "county" : "MONMOUTH" },
            "07704": { "city" : "FAIR HAVEN", "state" : "NJ", "county" : "MONMOUTH" },
            "07709": { "city" : "RED BANK", "state" : "NJ", "county" : "MONMOUTH" },
            "07710": { "city" : "ADELPHIA", "state" : "NJ", "county" : "MONMOUTH" },
            "07711": { "city" : "ALLENHURST", "state" : "NJ", "county" : "MONMOUTH" },
            "07712": { "city" : "ASBURY PARK", "state" : "NJ", "county" : "MONMOUTH" },
            "07715": { "city" : "BELMAR", "state" : "NJ", "county" : "MONMOUTH" },
            "07716": { "city" : "ATLANTIC HIGHLANDS", "state" : "NJ", "county" : "MONMOUTH" },
            "07717": { "city" : "AVON BY THE SEA", "state" : "NJ", "county" : "MONMOUTH" },
            "07718": { "city" : "BELFORD", "state" : "NJ", "county" : "MONMOUTH" },
            "07719": { "city" : "BELMAR", "state" : "NJ", "county" : "MONMOUTH" },
            "07720": { "city" : "BRADLEY BEACH", "state" : "NJ", "county" : "MONMOUTH" },
            "07721": { "city" : "CLIFFWOOD", "state" : "NJ", "county" : "MONMOUTH" },
            "07722": { "city" : "COLTS NECK", "state" : "NJ", "county" : "MONMOUTH" },
            "07723": { "city" : "DEAL", "state" : "NJ", "county" : "MONMOUTH" },"07724": { "city" : "EATONTOWN", "state" : "NJ", "county" : "MONMOUTH" },
            "07726": { "city" : "ENGLISHTOWN", "state" : "NJ", "county" : "MONMOUTH" },
            "07727": { "city" : "FARMINGDALE", "state" : "NJ", "county" : "MONMOUTH" },
            "07728": { "city" : "FREEHOLD", "state" : "NJ", "county" : "MONMOUTH" },
            "07730": { "city" : "HAZLET", "state" : "NJ", "county" : "MONMOUTH" },
            "07731": { "city" : "HOWELL", "state" : "NJ", "county" : "MONMOUTH" },
            "07732": { "city" : "HIGHLANDS", "state" : "NJ", "county" : "MONMOUTH" },
            "07733": { "city" : "HOLMDEL", "state" : "NJ", "county" : "MONMOUTH" },
            "07734": { "city" : "KEANSBURG", "state" : "NJ", "county" : "MONMOUTH" },
            "07735": { "city" : "KEYPORT", "state" : "NJ", "county" : "MONMOUTH" },
            "07737": { "city" : "LEONARDO", "state" : "NJ", "county" : "MONMOUTH" },
            "07738": { "city" : "LINCROFT", "state" : "NJ", "county" : "MONMOUTH" },
            "07739": { "city" : "LITTLE SILVER", "state" : "NJ", "county" : "MONMOUTH" },
            "07740": { "city" : "LONG BRANCH", "state" : "NJ", "county" : "MONMOUTH" },
            "07746": { "city" : "MARLBORO", "state" : "NJ", "county" : "MONMOUTH" },
            "07747": { "city" : "MATAWAN", "state" : "NJ", "county" : "MONMOUTH" },
            "07748": { "city" : "MIDDLETOWN", "state" : "NJ", "county" : "MONMOUTH" },
            "07750": { "city" : "MONMOUTH BEACH", "state" : "NJ", "county" : "MONMOUTH" },
            "07751": { "city" : "MORGANVILLE", "state" : "NJ", "county" : "MONMOUTH" },
            "07752": { "city" : "NAVESINK", "state" : "NJ", "county" : "MONMOUTH" },
            "07753": { "city" : "NEPTUNE", "state" : "NJ", "county" : "MONMOUTH" },
            "07754": { "city" : "NEPTUNE", "state" : "NJ", "county" : "MONMOUTH" },
            "07755": { "city" : "OAKHURST", "state" : "NJ", "county" : "MONMOUTH" },
            "07756": { "city" : "OCEAN GROVE", "state" : "NJ", "county" : "MONMOUTH" },
            "07757": { "city" : "OCEANPORT", "state" : "NJ", "county" : "MONMOUTH" },
            "07758": { "city" : "PORT MONMOUTH", "state" : "NJ", "county" : "MONMOUTH" },
            "07760": { "city" : "RUMSON", "state" : "NJ", "county" : "MONMOUTH" },
            "07762": { "city" : "SPRING LAKE", "state" : "NJ", "county" : "MONMOUTH" },
            "07763": { "city" : "TENNENT", "state" : "NJ", "county" : "MONMOUTH" },
            "07764": { "city" : "WEST LONG BRANCH", "state" : "NJ", "county" : "MONMOUTH" },
            "07765": { "city" : "WICKATUNK", "state" : "NJ", "county" : "MONMOUTH" },
            "07801": { "city" : "DOVER", "state" : "NJ", "county" : "MORRIS" },"07802": { "city" : "DOVER", "state" : "NJ", "county" : "MORRIS" },
            "07803": { "city" : "MINE HILL", "state" : "NJ", "county" : "MORRIS" },
            "07806": { "city" : "PICATINNY ARSENAL", "state" : "NJ", "county" : "MORRIS" },
            "07820": { "city" : "ALLAMUCHY", "state" : "NJ", "county" : "WARREN" },
            "07821": { "city" : "ANDOVER", "state" : "NJ", "county" : "SUSSEX" },
            "07822": { "city" : "AUGUSTA", "state" : "NJ", "county" : "SUSSEX" },
            "07823": { "city" : "BELVIDERE", "state" : "NJ", "county" : "WARREN" },
            "07825": { "city" : "BLAIRSTOWN", "state" : "NJ", "county" : "WARREN" },
            "07826": { "city" : "BRANCHVILLE", "state" : "NJ", "county" : "SUSSEX" },
            "07827": { "city" : "MONTAGUE", "state" : "NJ", "county" : "SUSSEX" },
            "07828": { "city" : "BUDD LAKE", "state" : "NJ", "county" : "MORRIS" },
            "07829": { "city" : "BUTTZVILLE", "state" : "NJ", "county" : "WARREN" },
            "07830": { "city" : "CALIFON", "state" : "NJ", "county" : "HUNTERDON" },
            "07831": { "city" : "CHANGEWATER", "state" : "NJ", "county" : "WARREN" },
            "07832": { "city" : "COLUMBIA", "state" : "NJ", "county" : "WARREN" },
            "07833": { "city" : "DELAWARE", "state" : "NJ", "county" : "WARREN" },
            "07834": { "city" : "DENVILLE", "state" : "NJ", "county" : "MORRIS" },
            "07836": { "city" : "FLANDERS", "state" : "NJ", "county" : "MORRIS" },
            "07838": { "city" : "GREAT MEADOWS", "state" : "NJ", "county" : "WARREN" },
            "07839": { "city" : "GREENDELL", "state" : "NJ", "county" : "SUSSEX" },
            "07840": { "city" : "HACKETTSTOWN", "state" : "NJ", "county" : "WARREN" },
            "07842": { "city" : "HIBERNIA", "state" : "NJ", "county" : "MORRIS" },
            "07843": { "city" : "HOPATCONG", "state" : "NJ", "county" : "SUSSEX" },
            "07844": { "city" : "HOPE", "state" : "NJ", "county" : "WARREN" },"07845": { "city" : "IRONIA", "state" : "NJ", "county" : "MORRIS" },
            "07846": { "city" : "JOHNSONBURG", "state" : "NJ", "county" : "WARREN" },
            "07847": { "city" : "KENVIL", "state" : "NJ", "county" : "MORRIS" },"07848": { "city" : "LAFAYETTE", "state" : "NJ", "county" : "SUSSEX" },
            "07849": { "city" : "LAKE HOPATCONG", "state" : "NJ", "county" : "MORRIS" },
            "07850": { "city" : "LANDING", "state" : "NJ", "county" : "MORRIS" },
            "07851": { "city" : "LAYTON", "state" : "NJ", "county" : "SUSSEX" },"07852": { "city" : "LEDGEWOOD", "state" : "NJ", "county" : "MORRIS" },
            "07853": { "city" : "LONG VALLEY", "state" : "NJ", "county" : "MORRIS" },
            "07855": { "city" : "MIDDLEVILLE", "state" : "NJ", "county" : "SUSSEX" },
            "07856": { "city" : "MOUNT ARLINGTON", "state" : "NJ", "county" : "MORRIS" },
            "07857": { "city" : "NETCONG", "state" : "NJ", "county" : "MORRIS" },
            "07860": { "city" : "NEWTON", "state" : "NJ", "county" : "SUSSEX" },"07863": { "city" : "OXFORD", "state" : "NJ", "county" : "WARREN" },
            "07865": { "city" : "PORT MURRAY", "state" : "NJ", "county" : "WARREN" },
            "07866": { "city" : "ROCKAWAY", "state" : "NJ", "county" : "MORRIS" },
            "07869": { "city" : "RANDOLPH", "state" : "NJ", "county" : "MORRIS" },
            "07870": { "city" : "SCHOOLEYS MOUNTAIN", "state" : "NJ", "county" : "MORRIS" },
            "07871": { "city" : "SPARTA", "state" : "NJ", "county" : "SUSSEX" },"07874": { "city" : "STANHOPE", "state" : "NJ", "county" : "SUSSEX" },
            "07875": { "city" : "STILLWATER", "state" : "NJ", "county" : "SUSSEX" },
            "07876": { "city" : "SUCCASUNNA", "state" : "NJ", "county" : "MORRIS" },
            "07877": { "city" : "SWARTSWOOD", "state" : "NJ", "county" : "SUSSEX" },
            "07878": { "city" : "MOUNT TABOR", "state" : "NJ", "county" : "MORRIS" },
            "07879": { "city" : "TRANQUILITY", "state" : "NJ", "county" : "SUSSEX" },
            "07880": { "city" : "VIENNA", "state" : "NJ", "county" : "WARREN" },"07881": { "city" : "WALLPACK CENTER", "state" : "NJ", "county" : "SUSSEX" },
            "07882": { "city" : "WASHINGTON", "state" : "NJ", "county" : "WARREN" },
            "07885": { "city" : "WHARTON", "state" : "NJ", "county" : "MORRIS" },
            "07890": { "city" : "BRANCHVILLE", "state" : "NJ", "county" : "SUSSEX" },
            "07901": { "city" : "SUMMIT", "state" : "NJ", "county" : "UNION" },"07902": { "city" : "SUMMIT", "state" : "NJ", "county" : "UNION" },
            "07920": { "city" : "BASKING RIDGE", "state" : "NJ", "county" : "SOMERSET" },
            "07921": { "city" : "BEDMINSTER", "state" : "NJ", "county" : "SOMERSET" },
            "07922": { "city" : "BERKELEY HEIGHTS", "state" : "NJ", "county" : "UNION" },
            "07924": { "city" : "BERNARDSVILLE", "state" : "NJ", "county" : "SOMERSET" },
            "07926": { "city" : "BROOKSIDE", "state" : "NJ", "county" : "MORRIS" },
            "07927": { "city" : "CEDAR KNOLLS", "state" : "NJ", "county" : "MORRIS" },
            "07928": { "city" : "CHATHAM", "state" : "NJ", "county" : "MORRIS" },
            "07930": { "city" : "CHESTER", "state" : "NJ", "county" : "MORRIS" },
            "07931": { "city" : "FAR HILLS", "state" : "NJ", "county" : "SOMERSET" },
            "07932": { "city" : "FLORHAM PARK", "state" : "NJ", "county" : "MORRIS" },
            "07933": { "city" : "GILLETTE", "state" : "NJ", "county" : "MORRIS" },
            "07934": { "city" : "GLADSTONE", "state" : "NJ", "county" : "SOMERSET" },
            "07935": { "city" : "GREEN VILLAGE", "state" : "NJ", "county" : "MORRIS" },
            "07936": { "city" : "EAST HANOVER", "state" : "NJ", "county" : "MORRIS" },
            "07938": { "city" : "LIBERTY CORNER", "state" : "NJ", "county" : "SOMERSET" },
            "07939": { "city" : "LYONS", "state" : "NJ", "county" : "SOMERSET" },
            "07940": { "city" : "MADISON", "state" : "NJ", "county" : "MORRIS" },
            "07945": { "city" : "MENDHAM", "state" : "NJ", "county" : "MORRIS" },
            "07946": { "city" : "MILLINGTON", "state" : "NJ", "county" : "MORRIS" },
            "07950": { "city" : "MORRIS PLAINS", "state" : "NJ", "county" : "MORRIS" },
            "07960": { "city" : "MORRISTOWN", "state" : "NJ", "county" : "MORRIS" },
            "07961": { "city" : "MORRISTOWN", "state" : "NJ", "county" : "MORRIS" },
            "07962": { "city" : "MORRISTOWN", "state" : "NJ", "county" : "MORRIS" },
            "07963": { "city" : "MORRISTOWN", "state" : "NJ", "county" : "MORRIS" },
            "07970": { "city" : "MOUNT FREEDOM", "state" : "NJ", "county" : "MORRIS" },
            "07974": { "city" : "NEW PROVIDENCE", "state" : "NJ", "county" : "UNION" },
            "07976": { "city" : "NEW VERNON", "state" : "NJ", "county" : "MORRIS" },
            "07977": { "city" : "PEAPACK", "state" : "NJ", "county" : "SOMERSET" },
            "07978": { "city" : "PLUCKEMIN", "state" : "NJ", "county" : "SOMERSET" },
            "07979": { "city" : "POTTERSVILLE", "state" : "NJ", "county" : "HUNTERDON" },
            "07980": { "city" : "STIRLING", "state" : "NJ", "county" : "MORRIS" },
            "07981": { "city" : "WHIPPANY", "state" : "NJ", "county" : "MORRIS" },
            "08001": { "city" : "ALLOWAY", "state" : "NJ", "county" : "SALEM" },"08002": { "city" : "CHERRY HILL", "state" : "NJ", "county" : "CAMDEN" },
            "08003": { "city" : "CHERRY HILL", "state" : "NJ", "county" : "CAMDEN" },
            "08004": { "city" : "ATCO", "state" : "NJ", "county" : "CAMDEN" },"08005": { "city" : "BARNEGAT", "state" : "NJ", "county" : "OCEAN" },
            "08006": { "city" : "BARNEGAT LIGHT", "state" : "NJ", "county" : "OCEAN" },
            "08007": { "city" : "BARRINGTON", "state" : "NJ", "county" : "CAMDEN" },
            "08008": { "city" : "BEACH HAVEN", "state" : "NJ", "county" : "OCEAN" },
            "08009": { "city" : "BERLIN", "state" : "NJ", "county" : "CAMDEN" },"08010": { "city" : "BEVERLY", "state" : "NJ", "county" : "BURLINGTON" },
            "08011": { "city" : "BIRMINGHAM", "state" : "NJ", "county" : "BURLINGTON" },
            "08012": { "city" : "BLACKWOOD", "state" : "NJ", "county" : "CAMDEN" },
            "08014": { "city" : "BRIDGEPORT", "state" : "NJ", "county" : "GLOUCESTER" },
            "08015": { "city" : "BROWNS MILLS", "state" : "NJ", "county" : "BURLINGTON" },
            "08016": { "city" : "BURLINGTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08018": { "city" : "CEDAR BROOK", "state" : "NJ", "county" : "CAMDEN" },
            "08019": { "city" : "CHATSWORTH", "state" : "NJ", "county" : "BURLINGTON" },
            "08020": { "city" : "CLARKSBORO", "state" : "NJ", "county" : "GLOUCESTER" },
            "08021": { "city" : "CLEMENTON", "state" : "NJ", "county" : "CAMDEN" },
            "08022": { "city" : "COLUMBUS", "state" : "NJ", "county" : "BURLINGTON" },
            "08023": { "city" : "DEEPWATER", "state" : "NJ", "county" : "SALEM" },
            "08025": { "city" : "EWAN", "state" : "NJ", "county" : "GLOUCESTER" },
            "08026": { "city" : "GIBBSBORO", "state" : "NJ", "county" : "CAMDEN" },
            "08027": { "city" : "GIBBSTOWN", "state" : "NJ", "county" : "GLOUCESTER" },
            "08028": { "city" : "GLASSBORO", "state" : "NJ", "county" : "GLOUCESTER" },
            "08029": { "city" : "GLENDORA", "state" : "NJ", "county" : "CAMDEN" },
            "08030": { "city" : "GLOUCESTER CITY", "state" : "NJ", "county" : "CAMDEN" },
            "08031": { "city" : "BELLMAWR", "state" : "NJ", "county" : "CAMDEN" },
            "08032": { "city" : "GRENLOCH", "state" : "NJ", "county" : "GLOUCESTER" },
            "08033": { "city" : "HADDONFIELD", "state" : "NJ", "county" : "CAMDEN" },
            "08034": { "city" : "CHERRY HILL", "state" : "NJ", "county" : "CAMDEN" },
            "08035": { "city" : "HADDON HEIGHTS", "state" : "NJ", "county" : "CAMDEN" },
            "08036": { "city" : "HAINESPORT", "state" : "NJ", "county" : "BURLINGTON" },
            "08037": { "city" : "HAMMONTON", "state" : "NJ", "county" : "ATLANTIC" },
            "08038": { "city" : "HANCOCKS BRIDGE", "state" : "NJ", "county" : "SALEM" },
            "08039": { "city" : "HARRISONVILLE", "state" : "NJ", "county" : "GLOUCESTER" },
            "08041": { "city" : "JOBSTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08042": { "city" : "JULIUSTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08043": { "city" : "VOORHEES", "state" : "NJ", "county" : "CAMDEN" },
            "08045": { "city" : "LAWNSIDE", "state" : "NJ", "county" : "CAMDEN" },
            "08046": { "city" : "WILLINGBORO", "state" : "NJ", "county" : "BURLINGTON" },
            "08048": { "city" : "LUMBERTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08049": { "city" : "MAGNOLIA", "state" : "NJ", "county" : "CAMDEN" },
            "08050": { "city" : "MANAHAWKIN", "state" : "NJ", "county" : "OCEAN" },
            "08051": { "city" : "MANTUA", "state" : "NJ", "county" : "GLOUCESTER" },
            "08052": { "city" : "MAPLE SHADE", "state" : "NJ", "county" : "BURLINGTON" },
            "08053": { "city" : "MARLTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08054": { "city" : "MOUNT LAUREL", "state" : "NJ", "county" : "BURLINGTON" },
            "08055": { "city" : "MEDFORD", "state" : "NJ", "county" : "BURLINGTON" },
            "08056": { "city" : "MICKLETON", "state" : "NJ", "county" : "GLOUCESTER" },
            "08057": { "city" : "MOORESTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08059": { "city" : "MOUNT EPHRAIM", "state" : "NJ", "county" : "CAMDEN" },
            "08060": { "city" : "MOUNT HOLLY", "state" : "NJ", "county" : "BURLINGTON" },
            "08061": { "city" : "MOUNT ROYAL", "state" : "NJ", "county" : "GLOUCESTER" },
            "08062": { "city" : "MULLICA HILL", "state" : "NJ", "county" : "GLOUCESTER" },
            "08063": { "city" : "NATIONAL PARK", "state" : "NJ", "county" : "GLOUCESTER" },
            "08064": { "city" : "NEW LISBON", "state" : "NJ", "county" : "BURLINGTON" },
            "08065": { "city" : "PALMYRA", "state" : "NJ", "county" : "BURLINGTON" },
            "08066": { "city" : "PAULSBORO", "state" : "NJ", "county" : "GLOUCESTER" },
            "08067": { "city" : "PEDRICKTOWN", "state" : "NJ", "county" : "SALEM" },
            "08068": { "city" : "PEMBERTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08069": { "city" : "PENNS GROVE", "state" : "NJ", "county" : "SALEM" },
            "08070": { "city" : "PENNSVILLE", "state" : "NJ", "county" : "SALEM" },
            "08071": { "city" : "PITMAN", "state" : "NJ", "county" : "GLOUCESTER" },
            "08072": { "city" : "QUINTON", "state" : "NJ", "county" : "SALEM" },"08073": { "city" : "RANCOCAS", "state" : "NJ", "county" : "BURLINGTON" },
            "08074": { "city" : "RICHWOOD", "state" : "NJ", "county" : "GLOUCESTER" },
            "08075": { "city" : "RIVERSIDE", "state" : "NJ", "county" : "BURLINGTON" },
            "08076": { "city" : "RIVERTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08077": { "city" : "RIVERTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08078": { "city" : "RUNNEMEDE", "state" : "NJ", "county" : "CAMDEN" },
            "08079": { "city" : "SALEM", "state" : "NJ", "county" : "SALEM" },"08080": { "city" : "SEWELL", "state" : "NJ", "county" : "GLOUCESTER" },
            "08081": { "city" : "SICKLERVILLE", "state" : "NJ", "county" : "CAMDEN" },
            "08083": { "city" : "SOMERDALE", "state" : "NJ", "county" : "CAMDEN" },
            "08084": { "city" : "STRATFORD", "state" : "NJ", "county" : "CAMDEN" },
            "08085": { "city" : "SWEDESBORO", "state" : "NJ", "county" : "GLOUCESTER" },
            "08086": { "city" : "THOROFARE", "state" : "NJ", "county" : "GLOUCESTER" },
            "08087": { "city" : "TUCKERTON", "state" : "NJ", "county" : "OCEAN" },
            "08088": { "city" : "VINCENTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08089": { "city" : "WATERFORD WORKS", "state" : "NJ", "county" : "CAMDEN" },
            "08090": { "city" : "WENONAH", "state" : "NJ", "county" : "GLOUCESTER" },
            "08091": { "city" : "WEST BERLIN", "state" : "NJ", "county" : "CAMDEN" },
            "08092": { "city" : "WEST CREEK", "state" : "NJ", "county" : "OCEAN" },
            "08093": { "city" : "WESTVILLE", "state" : "NJ", "county" : "GLOUCESTER" },
            "08094": { "city" : "WILLIAMSTOWN", "state" : "NJ", "county" : "GLOUCESTER" },
            "08095": { "city" : "WINSLOW", "state" : "NJ", "county" : "CAMDEN" },
            "08096": { "city" : "DEPTFORD", "state" : "NJ", "county" : "GLOUCESTER" },
            "08097": { "city" : "WOODBURY HEIGHTS", "state" : "NJ", "county" : "GLOUCESTER" },
            "08098": { "city" : "WOODSTOWN", "state" : "NJ", "county" : "SALEM" },
            "08099": { "city" : "BELLMAWR", "state" : "NJ", "county" : "CAMDEN" },
            "08101": { "city" : "CAMDEN", "state" : "NJ", "county" : "CAMDEN" },"08102": { "city" : "CAMDEN", "state" : "NJ", "county" : "CAMDEN" },
            "08103": { "city" : "CAMDEN", "state" : "NJ", "county" : "CAMDEN" },"08104": { "city" : "CAMDEN", "state" : "NJ", "county" : "CAMDEN" },
            "08105": { "city" : "CAMDEN", "state" : "NJ", "county" : "CAMDEN" },"08106": { "city" : "AUDUBON", "state" : "NJ", "county" : "CAMDEN" },
            "08107": { "city" : "OAKLYN", "state" : "NJ", "county" : "CAMDEN" },"08108": { "city" : "COLLINGSWOOD", "state" : "NJ", "county" : "CAMDEN" },
            "08109": { "city" : "MERCHANTVILLE", "state" : "NJ", "county" : "CAMDEN" },
            "08110": { "city" : "PENNSAUKEN", "state" : "NJ", "county" : "CAMDEN" },
            "08201": { "city" : "ABSECON", "state" : "NJ", "county" : "ATLANTIC" },
            "08202": { "city" : "AVALON", "state" : "NJ", "county" : "CAPE MAY" },
            "08203": { "city" : "BRIGANTINE", "state" : "NJ", "county" : "ATLANTIC" },
            "08204": { "city" : "CAPE MAY", "state" : "NJ", "county" : "CAPE MAY" },
            "08205": { "city" : "ABSECON", "state" : "NJ", "county" : "ATLANTIC" },
            "08210": { "city" : "CAPE MAY COURT HOUSE", "state" : "NJ", "county" : "CAPE MAY" },
            "08212": { "city" : "CAPE MAY POINT", "state" : "NJ", "county" : "CAPE MAY" },
            "08213": { "city" : "COLOGNE", "state" : "NJ", "county" : "ATLANTIC" },
            "08214": { "city" : "DENNISVILLE", "state" : "NJ", "county" : "CAPE MAY" },
            "08215": { "city" : "EGG HARBOR CITY", "state" : "NJ", "county" : "ATLANTIC" },
            "08217": { "city" : "ELWOOD", "state" : "NJ", "county" : "ATLANTIC" },
            "08218": { "city" : "GOSHEN", "state" : "NJ", "county" : "CAPE MAY" },
            "08219": { "city" : "GREEN CREEK", "state" : "NJ", "county" : "CAPE MAY" },
            "08220": { "city" : "LEEDS POINT", "state" : "NJ", "county" : "ATLANTIC" },
            "08221": { "city" : "LINWOOD", "state" : "NJ", "county" : "ATLANTIC" },
            "08223": { "city" : "MARMORA", "state" : "NJ", "county" : "CAPE MAY" },
            "08224": { "city" : "NEW GRETNA", "state" : "NJ", "county" : "BURLINGTON" },
            "08225": { "city" : "NORTHFIELD", "state" : "NJ", "county" : "ATLANTIC" },
            "08226": { "city" : "OCEAN CITY", "state" : "NJ", "county" : "CAPE MAY" },
            "08230": { "city" : "OCEAN VIEW", "state" : "NJ", "county" : "CAPE MAY" },
            "08231": { "city" : "OCEANVILLE", "state" : "NJ", "county" : "ATLANTIC" },
            "08232": { "city" : "PLEASANTVILLE", "state" : "NJ", "county" : "ATLANTIC" },
            "08234": { "city" : "EGG HARBOR TOWNSHIP", "state" : "NJ", "county" : "ATLANTIC" },
            "08240": { "city" : "POMONA", "state" : "NJ", "county" : "ATLANTIC" },
            "08241": { "city" : "PORT REPUBLIC", "state" : "NJ", "county" : "ATLANTIC" },
            "08242": { "city" : "RIO GRANDE", "state" : "NJ", "county" : "CAPE MAY" },
            "08243": { "city" : "SEA ISLE CITY", "state" : "NJ", "county" : "CAPE MAY" },
            "08244": { "city" : "SOMERS POINT", "state" : "NJ", "county" : "ATLANTIC" },
            "08245": { "city" : "SOUTH DENNIS", "state" : "NJ", "county" : "CAPE MAY" },
            "08246": { "city" : "SOUTH SEAVILLE", "state" : "NJ", "county" : "CAPE MAY" },
            "08247": { "city" : "STONE HARBOR", "state" : "NJ", "county" : "CAPE MAY" },
            "08248": { "city" : "STRATHMERE", "state" : "NJ", "county" : "CAPE MAY" },
            "08250": { "city" : "TUCKAHOE", "state" : "NJ", "county" : "CAPE MAY" },
            "08251": { "city" : "VILLAS", "state" : "NJ", "county" : "CAPE MAY" },
            "08252": { "city" : "WHITESBORO", "state" : "NJ", "county" : "CAPE MAY" },
            "08260": { "city" : "WILDWOOD", "state" : "NJ", "county" : "CAPE MAY" },
            "08270": { "city" : "WOODBINE", "state" : "NJ", "county" : "CAPE MAY" },
            "08302": { "city" : "BRIDGETON", "state" : "NJ", "county" : "CUMBERLAND" },
            "08310": { "city" : "BUENA", "state" : "NJ", "county" : "ATLANTIC" },
            "08311": { "city" : "CEDARVILLE", "state" : "NJ", "county" : "CUMBERLAND" },
            "08312": { "city" : "CLAYTON", "state" : "NJ", "county" : "GLOUCESTER" },
            "08313": { "city" : "DEERFIELD STREET", "state" : "NJ", "county" : "CUMBERLAND" },
            "08314": { "city" : "DELMONT", "state" : "NJ", "county" : "CUMBERLAND" },
            "08315": { "city" : "DIVIDING CREEK", "state" : "NJ", "county" : "CUMBERLAND" },
            "08316": { "city" : "DORCHESTER", "state" : "NJ", "county" : "CUMBERLAND" },
            "08317": { "city" : "DOROTHY", "state" : "NJ", "county" : "ATLANTIC" },
            "08318": { "city" : "ELMER", "state" : "NJ", "county" : "SALEM" },"08319": { "city" : "ESTELL MANOR", "state" : "NJ", "county" : "ATLANTIC" },
            "08320": { "city" : "FAIRTON", "state" : "NJ", "county" : "CUMBERLAND" },
            "08321": { "city" : "FORTESCUE", "state" : "NJ", "county" : "CUMBERLAND" },
            "08322": { "city" : "FRANKLINVILLE", "state" : "NJ", "county" : "GLOUCESTER" },
            "08323": { "city" : "GREENWICH", "state" : "NJ", "county" : "CUMBERLAND" },
            "08324": { "city" : "HEISLERVILLE", "state" : "NJ", "county" : "CUMBERLAND" },
            "08326": { "city" : "LANDISVILLE", "state" : "NJ", "county" : "ATLANTIC" },
            "08327": { "city" : "LEESBURG", "state" : "NJ", "county" : "CUMBERLAND" },
            "08328": { "city" : "MALAGA", "state" : "NJ", "county" : "GLOUCESTER" },
            "08329": { "city" : "MAURICETOWN", "state" : "NJ", "county" : "CUMBERLAND" },
            "08330": { "city" : "MAYS LANDING", "state" : "NJ", "county" : "ATLANTIC" },
            "08332": { "city" : "MILLVILLE", "state" : "NJ", "county" : "CUMBERLAND" },
            "08340": { "city" : "MILMAY", "state" : "NJ", "county" : "ATLANTIC" },
            "08341": { "city" : "MINOTOLA", "state" : "NJ", "county" : "ATLANTIC" },
            "08342": { "city" : "MIZPAH", "state" : "NJ", "county" : "ATLANTIC" },
            "08343": { "city" : "MONROEVILLE", "state" : "NJ", "county" : "SALEM" },
            "08344": { "city" : "NEWFIELD", "state" : "NJ", "county" : "GLOUCESTER" },
            "08345": { "city" : "NEWPORT", "state" : "NJ", "county" : "CUMBERLAND" },
            "08346": { "city" : "NEWTONVILLE", "state" : "NJ", "county" : "ATLANTIC" },
            "08347": { "city" : "NORMA", "state" : "NJ", "county" : "SALEM" },"08348": { "city" : "PORT ELIZABETH", "state" : "NJ", "county" : "CUMBERLAND" },
            "08349": { "city" : "PORT NORRIS", "state" : "NJ", "county" : "CUMBERLAND" },
            "08350": { "city" : "RICHLAND", "state" : "NJ", "county" : "ATLANTIC" },
            "08352": { "city" : "ROSENHAYN", "state" : "NJ", "county" : "CUMBERLAND" },
            "08353": { "city" : "SHILOH", "state" : "NJ", "county" : "CUMBERLAND" },
            "08360": { "city" : "VINELAND", "state" : "NJ", "county" : "CUMBERLAND" },
            "08361": { "city" : "VINELAND", "state" : "NJ", "county" : "CUMBERLAND" },
            "08362": { "city" : "VINELAND", "state" : "NJ", "county" : "CUMBERLAND" },
            "08401": { "city" : "ATLANTIC CITY", "state" : "NJ", "county" : "ATLANTIC" },
            "08402": { "city" : "MARGATE CITY", "state" : "NJ", "county" : "ATLANTIC" },
            "08403": { "city" : "LONGPORT", "state" : "NJ", "county" : "ATLANTIC" },
            "08404": { "city" : "ATLANTIC CITY", "state" : "NJ", "county" : "ATLANTIC" },
            "08405": { "city" : "ATLANTIC CITY", "state" : "NJ", "county" : "ATLANTIC" },
            "08406": { "city" : "VENTNOR CITY", "state" : "NJ", "county" : "ATLANTIC" },
            "08501": { "city" : "ALLENTOWN", "state" : "NJ", "county" : "MONMOUTH" },
            "08502": { "city" : "BELLE MEAD", "state" : "NJ", "county" : "SOMERSET" },
            "08504": { "city" : "BLAWENBURG", "state" : "NJ", "county" : "SOMERSET" },
            "08505": { "city" : "BORDENTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08510": { "city" : "MILLSTONE TOWNSHIP", "state" : "NJ", "county" : "MONMOUTH" },
            "08511": { "city" : "COOKSTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08512": { "city" : "CRANBURY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08514": { "city" : "CREAM RIDGE", "state" : "NJ", "county" : "MONMOUTH" },
            "08515": { "city" : "CHESTERFIELD", "state" : "NJ", "county" : "BURLINGTON" },
            "08518": { "city" : "FLORENCE", "state" : "NJ", "county" : "BURLINGTON" },
            "08520": { "city" : "HIGHTSTOWN", "state" : "NJ", "county" : "MERCER" },
            "08525": { "city" : "HOPEWELL", "state" : "NJ", "county" : "MERCER" },
            "08526": { "city" : "IMLAYSTOWN", "state" : "NJ", "county" : "MONMOUTH" },
            "08527": { "city" : "JACKSON", "state" : "NJ", "county" : "OCEAN" },"08528": { "city" : "KINGSTON", "state" : "NJ", "county" : "SOMERSET" },
            "08530": { "city" : "LAMBERTVILLE", "state" : "NJ", "county" : "HUNTERDON" },
            "08533": { "city" : "NEW EGYPT", "state" : "NJ", "county" : "OCEAN" },
            "08534": { "city" : "PENNINGTON", "state" : "NJ", "county" : "MERCER" },
            "08535": { "city" : "MILLSTONE TOWNSHIP", "state" : "NJ", "county" : "MONMOUTH" },
            "08536": { "city" : "PLAINSBORO", "state" : "NJ", "county" : "MIDDLESEX" },
            "08540": { "city" : "PRINCETON", "state" : "NJ", "county" : "MERCER" },
            "08541": { "city" : "PRINCETON", "state" : "NJ", "county" : "MERCER" },
            "08542": { "city" : "PRINCETON", "state" : "NJ", "county" : "MERCER" },
            "08543": { "city" : "PRINCETON", "state" : "NJ", "county" : "MERCER" },
            "08544": { "city" : "PRINCETON", "state" : "NJ", "county" : "MERCER" },
            "08550": { "city" : "PRINCETON JUNCTION", "state" : "NJ", "county" : "MERCER" },
            "08551": { "city" : "RINGOES", "state" : "NJ", "county" : "HUNTERDON" },
            "08553": { "city" : "ROCKY HILL", "state" : "NJ", "county" : "SOMERSET" },
            "08554": { "city" : "ROEBLING", "state" : "NJ", "county" : "BURLINGTON" },
            "08555": { "city" : "ROOSEVELT", "state" : "NJ", "county" : "MONMOUTH" },
            "08556": { "city" : "ROSEMONT", "state" : "NJ", "county" : "HUNTERDON" },
            "08557": { "city" : "SERGEANTSVILLE", "state" : "NJ", "county" : "HUNTERDON" },
            "08558": { "city" : "SKILLMAN", "state" : "NJ", "county" : "SOMERSET" },
            "08559": { "city" : "STOCKTON", "state" : "NJ", "county" : "HUNTERDON" },
            "08560": { "city" : "TITUSVILLE", "state" : "NJ", "county" : "MERCER" },
            "08561": { "city" : "WINDSOR", "state" : "NJ", "county" : "MERCER" },
            "08562": { "city" : "WRIGHTSTOWN", "state" : "NJ", "county" : "BURLINGTON" },
            "08601": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08602": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08603": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08604": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08605": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08606": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08607": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08608": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08609": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08610": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08611": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08618": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08619": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08620": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08625": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08628": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08629": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08638": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08640": { "city" : "FORT DIX", "state" : "NJ", "county" : "BURLINGTON" },
            "08641": { "city" : "TRENTON", "state" : "NJ", "county" : "BURLINGTON" },
            "08646": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08647": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08648": { "city" : "LAWRENCE TOWNSHIP", "state" : "NJ", "county" : "MERCER" },
            "08650": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08666": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08690": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08691": { "city" : "TRENTON", "state" : "NJ", "county" : "MERCER" },
            "08701": { "city" : "LAKEWOOD", "state" : "NJ", "county" : "OCEAN" },
            "08720": { "city" : "ALLENWOOD", "state" : "NJ", "county" : "MONMOUTH" },
            "08721": { "city" : "BAYVILLE", "state" : "NJ", "county" : "OCEAN" },
            "08722": { "city" : "BEACHWOOD", "state" : "NJ", "county" : "OCEAN" },
            "08723": { "city" : "BRICK", "state" : "NJ", "county" : "OCEAN" },"08724": { "city" : "BRICK", "state" : "NJ", "county" : "OCEAN" },
            "08730": { "city" : "BRIELLE", "state" : "NJ", "county" : "MONMOUTH" },
            "08731": { "city" : "FORKED RIVER", "state" : "NJ", "county" : "OCEAN" },
            "08732": { "city" : "ISLAND HEIGHTS", "state" : "NJ", "county" : "OCEAN" },
            "08733": { "city" : "LAKEHURST", "state" : "NJ", "county" : "OCEAN" },
            "08734": { "city" : "LANOKA HARBOR", "state" : "NJ", "county" : "OCEAN" },
            "08735": { "city" : "LAVALLETTE", "state" : "NJ", "county" : "OCEAN" },
            "08736": { "city" : "MANASQUAN", "state" : "NJ", "county" : "MONMOUTH" },
            "08738": { "city" : "MANTOLOKING", "state" : "NJ", "county" : "OCEAN" },
            "08739": { "city" : "NORMANDY BEACH", "state" : "NJ", "county" : "OCEAN" },
            "08740": { "city" : "OCEAN GATE", "state" : "NJ", "county" : "OCEAN" },
            "08741": { "city" : "PINE BEACH", "state" : "NJ", "county" : "OCEAN" },
            "08742": { "city" : "POINT PLEASANT BEACH", "state" : "NJ", "county" : "OCEAN" },
            "08750": { "city" : "SEA GIRT", "state" : "NJ", "county" : "MONMOUTH" },
            "08751": { "city" : "SEASIDE HEIGHTS", "state" : "NJ", "county" : "OCEAN" },
            "08752": { "city" : "SEASIDE PARK", "state" : "NJ", "county" : "OCEAN" },
            "08753": { "city" : "TOMS RIVER", "state" : "NJ", "county" : "OCEAN" },
            "08754": { "city" : "TOMS RIVER", "state" : "NJ", "county" : "OCEAN" },
            "08755": { "city" : "TOMS RIVER", "state" : "NJ", "county" : "OCEAN" },
            "08756": { "city" : "TOMS RIVER", "state" : "NJ", "county" : "OCEAN" },
            "08757": { "city" : "TOMS RIVER", "state" : "NJ", "county" : "OCEAN" },
            "08758": { "city" : "WARETOWN", "state" : "NJ", "county" : "OCEAN" },
            "08759": { "city" : "MANCHESTER TOWNSHIP", "state" : "NJ", "county" : "OCEAN" },
            "08801": { "city" : "ANNANDALE", "state" : "NJ", "county" : "HUNTERDON" },
            "08802": { "city" : "ASBURY", "state" : "NJ", "county" : "HUNTERDON" },
            "08803": { "city" : "BAPTISTOWN", "state" : "NJ", "county" : "HUNTERDON" },
            "08804": { "city" : "BLOOMSBURY", "state" : "NJ", "county" : "HUNTERDON" },
            "08805": { "city" : "BOUND BROOK", "state" : "NJ", "county" : "SOMERSET" },
            "08807": { "city" : "BRIDGEWATER", "state" : "NJ", "county" : "SOMERSET" },
            "08808": { "city" : "BROADWAY", "state" : "NJ", "county" : "WARREN" },
            "08809": { "city" : "CLINTON", "state" : "NJ", "county" : "HUNTERDON" },
            "08810": { "city" : "DAYTON", "state" : "NJ", "county" : "MIDDLESEX" },
            "08812": { "city" : "DUNELLEN", "state" : "NJ", "county" : "MIDDLESEX" },
            "08816": { "city" : "EAST BRUNSWICK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08817": { "city" : "EDISON", "state" : "NJ", "county" : "MIDDLESEX" },
            "08818": { "city" : "EDISON", "state" : "NJ", "county" : "MIDDLESEX" },
            "08820": { "city" : "EDISON", "state" : "NJ", "county" : "MIDDLESEX" },
            "08821": { "city" : "FLAGTOWN", "state" : "NJ", "county" : "SOMERSET" },
            "08822": { "city" : "FLEMINGTON", "state" : "NJ", "county" : "HUNTERDON" },
            "08823": { "city" : "FRANKLIN PARK", "state" : "NJ", "county" : "SOMERSET" },
            "08824": { "city" : "KENDALL PARK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08825": { "city" : "FRENCHTOWN", "state" : "NJ", "county" : "HUNTERDON" },
            "08826": { "city" : "GLEN GARDNER", "state" : "NJ", "county" : "HUNTERDON" },
            "08827": { "city" : "HAMPTON", "state" : "NJ", "county" : "HUNTERDON" },
            "08828": { "city" : "HELMETTA", "state" : "NJ", "county" : "MIDDLESEX" },
            "08829": { "city" : "HIGH BRIDGE", "state" : "NJ", "county" : "HUNTERDON" },
            "08830": { "city" : "ISELIN", "state" : "NJ", "county" : "MIDDLESEX" },
            "08831": { "city" : "MONROE TOWNSHIP", "state" : "NJ", "county" : "MIDDLESEX" },
            "08832": { "city" : "KEASBEY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08833": { "city" : "LEBANON", "state" : "NJ", "county" : "HUNTERDON" },
            "08835": { "city" : "MANVILLE", "state" : "NJ", "county" : "SOMERSET" },
            "08836": { "city" : "MARTINSVILLE", "state" : "NJ", "county" : "SOMERSET" },
            "08837": { "city" : "EDISON", "state" : "NJ", "county" : "MIDDLESEX" },
            "08840": { "city" : "METUCHEN", "state" : "NJ", "county" : "MIDDLESEX" },
            "08844": { "city" : "HILLSBOROUGH", "state" : "NJ", "county" : "SOMERSET" },
            "08846": { "city" : "MIDDLESEX", "state" : "NJ", "county" : "MIDDLESEX" },
            "08848": { "city" : "MILFORD", "state" : "NJ", "county" : "HUNTERDON" },
            "08850": { "city" : "MILLTOWN", "state" : "NJ", "county" : "MIDDLESEX" },
            "08852": { "city" : "MONMOUTH JUNCTION", "state" : "NJ", "county" : "MIDDLESEX" },
            "08853": { "city" : "NESHANIC STATION", "state" : "NJ", "county" : "SOMERSET" },
            "08854": { "city" : "PISCATAWAY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08855": { "city" : "PISCATAWAY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08857": { "city" : "OLD BRIDGE", "state" : "NJ", "county" : "MIDDLESEX" },
            "08858": { "city" : "OLDWICK", "state" : "NJ", "county" : "HUNTERDON" },
            "08859": { "city" : "PARLIN", "state" : "NJ", "county" : "MIDDLESEX" },
            "08861": { "city" : "PERTH AMBOY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08862": { "city" : "PERTH AMBOY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08863": { "city" : "FORDS", "state" : "NJ", "county" : "MIDDLESEX" },
            "08865": { "city" : "PHILLIPSBURG", "state" : "NJ", "county" : "WARREN" },
            "08867": { "city" : "PITTSTOWN", "state" : "NJ", "county" : "HUNTERDON" },
            "08868": { "city" : "QUAKERTOWN", "state" : "NJ", "county" : "HUNTERDON" },
            "08869": { "city" : "RARITAN", "state" : "NJ", "county" : "SOMERSET" },
            "08870": { "city" : "READINGTON", "state" : "NJ", "county" : "HUNTERDON" },
            "08871": { "city" : "SAYREVILLE", "state" : "NJ", "county" : "MIDDLESEX" },
            "08872": { "city" : "SAYREVILLE", "state" : "NJ", "county" : "MIDDLESEX" },
            "08873": { "city" : "SOMERSET", "state" : "NJ", "county" : "SOMERSET" },
            "08875": { "city" : "SOMERSET", "state" : "NJ", "county" : "SOMERSET" },
            "08876": { "city" : "SOMERVILLE", "state" : "NJ", "county" : "SOMERSET" },
            "08879": { "city" : "SOUTH AMBOY", "state" : "NJ", "county" : "MIDDLESEX" },
            "08880": { "city" : "SOUTH BOUND BROOK", "state" : "NJ", "county" : "SOMERSET" },
            "08882": { "city" : "SOUTH RIVER", "state" : "NJ", "county" : "MIDDLESEX" },
            "08884": { "city" : "SPOTSWOOD", "state" : "NJ", "county" : "MIDDLESEX" },
            "08885": { "city" : "STANTON", "state" : "NJ", "county" : "HUNTERDON" },
            "08886": { "city" : "STEWARTSVILLE", "state" : "NJ", "county" : "WARREN" },
            "08887": { "city" : "THREE BRIDGES", "state" : "NJ", "county" : "HUNTERDON" },
            "08888": { "city" : "WHITEHOUSE", "state" : "NJ", "county" : "HUNTERDON" },
            "08889": { "city" : "WHITEHOUSE STATION", "state" : "NJ", "county" : "HUNTERDON" },
            "08890": { "city" : "ZAREPHATH", "state" : "NJ", "county" : "SOMERSET" },
            "08899": { "city" : "EDISON", "state" : "NJ", "county" : "MIDDLESEX" },
            "08901": { "city" : "NEW BRUNSWICK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08902": { "city" : "NORTH BRUNSWICK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08903": { "city" : "NEW BRUNSWICK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08904": { "city" : "HIGHLAND PARK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08906": { "city" : "NEW BRUNSWICK", "state" : "NJ", "county" : "MIDDLESEX" },
            "08933": { "city" : "NEW BRUNSWICK", "state" : "NJ", "county" : "MIDDLESEX" },
            "10001": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10002": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10003": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10004": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10005": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10006": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10007": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10008": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10009": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10010": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10011": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10012": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10013": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10014": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10016": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10017": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10018": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10019": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10020": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10021": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10022": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10023": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10024": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10025": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10026": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10027": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10028": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10029": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10030": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10031": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10032": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10033": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10034": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10035": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10036": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10037": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10038": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10039": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10040": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10041": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10043": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10044": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10045": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10046": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10055": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10065": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10069": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10072": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10075": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10080": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10081": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10082": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10087": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10090": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10094": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10096": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10101": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10102": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10103": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10104": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10105": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10106": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10107": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10108": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10109": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10110": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10111": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10112": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10113": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10115": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10116": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10117": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10118": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10119": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10120": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10121": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10122": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10123": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10124": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10125": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10126": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10128": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10129": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10138": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10150": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10151": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10152": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10153": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10154": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10155": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10156": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10158": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10159": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10160": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10162": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10163": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10164": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10165": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10166": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10167": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10168": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10169": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10170": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10171": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10172": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10173": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10174": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10175": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10176": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10177": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10178": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10179": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10185": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10199": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10203": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10213": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10260": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10261": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10265": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10268": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10270": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10271": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10272": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10274": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10275": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10276": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10278": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10279": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10280": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10281": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10282": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10285": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10286": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10292": { "city" : "NEW YORK", "state" : "NY", "county" : "NEW YORK" },
            "10301": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10302": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10303": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10304": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10305": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10306": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10307": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10308": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10309": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10310": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10311": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10312": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10313": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10314": { "city" : "STATEN ISLAND", "state" : "NY", "county" : "RICHMOND" },
            "10451": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10452": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10453": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10454": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10455": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10456": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10457": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10458": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10459": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10460": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10461": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10462": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10463": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10464": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10465": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10466": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10467": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10468": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10469": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10470": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10471": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10472": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10473": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10474": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10475": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },"10499": { "city" : "BRONX", "state" : "NY", "county" : "BRONX" },
            "10501": { "city" : "AMAWALK", "state" : "NY", "county" : "WESTCHESTER" },
            "10502": { "city" : "ARDSLEY", "state" : "NY", "county" : "WESTCHESTER" },
            "10503": { "city" : "ARDSLEY ON HUDSON", "state" : "NY", "county" : "WESTCHESTER" },
            "10504": { "city" : "ARMONK", "state" : "NY", "county" : "WESTCHESTER" },
            "10505": { "city" : "BALDWIN PLACE", "state" : "NY", "county" : "WESTCHESTER" },
            "10506": { "city" : "BEDFORD", "state" : "NY", "county" : "WESTCHESTER" },
            "10507": { "city" : "BEDFORD HILLS", "state" : "NY", "county" : "WESTCHESTER" },
            "10509": { "city" : "BREWSTER", "state" : "NY", "county" : "PUTNAM" },
            "10510": { "city" : "BRIARCLIFF MANOR", "state" : "NY", "county" : "WESTCHESTER" },
            "10511": { "city" : "BUCHANAN", "state" : "NY", "county" : "WESTCHESTER" },
            "10512": { "city" : "CARMEL", "state" : "NY", "county" : "PUTNAM" },"10514": { "city" : "CHAPPAQUA", "state" : "NY", "county" : "WESTCHESTER" },
            "10516": { "city" : "COLD SPRING", "state" : "NY", "county" : "PUTNAM" },
            "10517": { "city" : "CROMPOND", "state" : "NY", "county" : "WESTCHESTER" },
            "10518": { "city" : "CROSS RIVER", "state" : "NY", "county" : "WESTCHESTER" },
            "10519": { "city" : "CROTON FALLS", "state" : "NY", "county" : "WESTCHESTER" },
            "10520": { "city" : "CROTON ON HUDSON", "state" : "NY", "county" : "WESTCHESTER" },
            "10521": { "city" : "CROTON ON HUDSON", "state" : "NY", "county" : "WESTCHESTER" },
            "10522": { "city" : "DOBBS FERRY", "state" : "NY", "county" : "WESTCHESTER" },
            "10523": { "city" : "ELMSFORD", "state" : "NY", "county" : "WESTCHESTER" },
            "10524": { "city" : "GARRISON", "state" : "NY", "county" : "PUTNAM" },
            "10526": { "city" : "GOLDENS BRIDGE", "state" : "NY", "county" : "WESTCHESTER" },
            "10527": { "city" : "GRANITE SPRINGS", "state" : "NY", "county" : "WESTCHESTER" },
            "10528": { "city" : "HARRISON", "state" : "NY", "county" : "WESTCHESTER" },
            "10530": { "city" : "HARTSDALE", "state" : "NY", "county" : "WESTCHESTER" },
            "10532": { "city" : "HAWTHORNE", "state" : "NY", "county" : "WESTCHESTER" },
            "10533": { "city" : "IRVINGTON", "state" : "NY", "county" : "WESTCHESTER" },
            "10535": { "city" : "JEFFERSON VALLEY", "state" : "NY", "county" : "WESTCHESTER" },
            "10536": { "city" : "KATONAH", "state" : "NY", "county" : "WESTCHESTER" },
            "10537": { "city" : "LAKE PEEKSKILL", "state" : "NY", "county" : "PUTNAM" },
            "10538": { "city" : "LARCHMONT", "state" : "NY", "county" : "WESTCHESTER" },
            "10540": { "city" : "LINCOLNDALE", "state" : "NY", "county" : "WESTCHESTER" },
            "10541": { "city" : "MAHOPAC", "state" : "NY", "county" : "PUTNAM" },
            "10542": { "city" : "MAHOPAC FALLS", "state" : "NY", "county" : "PUTNAM" },
            "10543": { "city" : "MAMARONECK", "state" : "NY", "county" : "WESTCHESTER" },
            "10545": { "city" : "MARYKNOLL", "state" : "NY", "county" : "WESTCHESTER" },
            "10546": { "city" : "MILLWOOD", "state" : "NY", "county" : "WESTCHESTER" },
            "10547": { "city" : "MOHEGAN LAKE", "state" : "NY", "county" : "WESTCHESTER" },
            "10548": { "city" : "MONTROSE", "state" : "NY", "county" : "WESTCHESTER" },
            "10549": { "city" : "MOUNT KISCO", "state" : "NY", "county" : "WESTCHESTER" },
            "10550": { "city" : "MOUNT VERNON", "state" : "NY", "county" : "WESTCHESTER" },
            "10551": { "city" : "MOUNT VERNON", "state" : "NY", "county" : "WESTCHESTER" },
            "10552": { "city" : "MOUNT VERNON", "state" : "NY", "county" : "WESTCHESTER" },
            "10553": { "city" : "MOUNT VERNON", "state" : "NY", "county" : "WESTCHESTER" },
            "10560": { "city" : "NORTH SALEM", "state" : "NY", "county" : "WESTCHESTER" },
            "10562": { "city" : "OSSINING", "state" : "NY", "county" : "WESTCHESTER" },
            "10566": { "city" : "PEEKSKILL", "state" : "NY", "county" : "WESTCHESTER" },
            "10567": { "city" : "CORTLANDT MANOR", "state" : "NY", "county" : "WESTCHESTER" },
            "10570": { "city" : "PLEASANTVILLE", "state" : "NY", "county" : "WESTCHESTER" },
            "10573": { "city" : "PORT CHESTER", "state" : "NY", "county" : "WESTCHESTER" },
            "10576": { "city" : "POUND RIDGE", "state" : "NY", "county" : "WESTCHESTER" },
            "10577": { "city" : "PURCHASE", "state" : "NY", "county" : "WESTCHESTER" },
            "10578": { "city" : "PURDYS", "state" : "NY", "county" : "WESTCHESTER" },
            "10579": { "city" : "PUTNAM VALLEY", "state" : "NY", "county" : "PUTNAM" },
            "10580": { "city" : "RYE", "state" : "NY", "county" : "WESTCHESTER" },
            "10583": { "city" : "SCARSDALE", "state" : "NY", "county" : "WESTCHESTER" },
            "10587": { "city" : "SHENOROCK", "state" : "NY", "county" : "WESTCHESTER" },
            "10588": { "city" : "SHRUB OAK", "state" : "NY", "county" : "WESTCHESTER" },
            "10589": { "city" : "SOMERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10590": { "city" : "SOUTH SALEM", "state" : "NY", "county" : "WESTCHESTER" },
            "10591": { "city" : "TARRYTOWN", "state" : "NY", "county" : "WESTCHESTER" },
            "10594": { "city" : "THORNWOOD", "state" : "NY", "county" : "WESTCHESTER" },
            "10595": { "city" : "VALHALLA", "state" : "NY", "county" : "WESTCHESTER" },
            "10596": { "city" : "VERPLANCK", "state" : "NY", "county" : "WESTCHESTER" },
            "10597": { "city" : "WACCABUC", "state" : "NY", "county" : "WESTCHESTER" },
            "10598": { "city" : "YORKTOWN HEIGHTS", "state" : "NY", "county" : "WESTCHESTER" },
            "10601": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10602": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10603": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10604": { "city" : "WEST HARRISON", "state" : "NY", "county" : "WESTCHESTER" },
            "10605": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10606": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10607": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10610": { "city" : "WHITE PLAINS", "state" : "NY", "county" : "WESTCHESTER" },
            "10701": { "city" : "YONKERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10702": { "city" : "YONKERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10703": { "city" : "YONKERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10704": { "city" : "YONKERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10705": { "city" : "YONKERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10706": { "city" : "HASTINGS ON HUDSON", "state" : "NY", "county" : "WESTCHESTER" },
            "10707": { "city" : "TUCKAHOE", "state" : "NY", "county" : "WESTCHESTER" },
            "10708": { "city" : "BRONXVILLE", "state" : "NY", "county" : "WESTCHESTER" },
            "10709": { "city" : "EASTCHESTER", "state" : "NY", "county" : "WESTCHESTER" },
            "10710": { "city" : "YONKERS", "state" : "NY", "county" : "WESTCHESTER" },
            "10801": { "city" : "NEW ROCHELLE", "state" : "NY", "county" : "WESTCHESTER" },
            "10802": { "city" : "NEW ROCHELLE", "state" : "NY", "county" : "WESTCHESTER" },
            "10803": { "city" : "PELHAM", "state" : "NY", "county" : "WESTCHESTER" },
            "10804": { "city" : "NEW ROCHELLE", "state" : "NY", "county" : "WESTCHESTER" },
            "10805": { "city" : "NEW ROCHELLE", "state" : "NY", "county" : "WESTCHESTER" },
            "10901": { "city" : "SUFFERN", "state" : "NY", "county" : "ROCKLAND" },
            "10910": { "city" : "ARDEN", "state" : "NY", "county" : "ORANGE" },"10911": { "city" : "BEAR MOUNTAIN", "state" : "NY", "county" : "ROCKLAND" },
            "10912": { "city" : "BELLVALE", "state" : "NY", "county" : "ORANGE" },
            "10913": { "city" : "BLAUVELT", "state" : "NY", "county" : "ROCKLAND" },
            "10914": { "city" : "BLOOMING GROVE", "state" : "NY", "county" : "ORANGE" },
            "10915": { "city" : "BULLVILLE", "state" : "NY", "county" : "ORANGE" },
            "10916": { "city" : "CAMPBELL HALL", "state" : "NY", "county" : "ORANGE" },
            "10917": { "city" : "CENTRAL VALLEY", "state" : "NY", "county" : "ORANGE" },
            "10918": { "city" : "CHESTER", "state" : "NY", "county" : "ORANGE" },
            "10919": { "city" : "CIRCLEVILLE", "state" : "NY", "county" : "ORANGE" },
            "10920": { "city" : "CONGERS", "state" : "NY", "county" : "ROCKLAND" },
            "10921": { "city" : "FLORIDA", "state" : "NY", "county" : "ORANGE" },
            "10922": { "city" : "FORT MONTGOMERY", "state" : "NY", "county" : "ORANGE" },
            "10923": { "city" : "GARNERVILLE", "state" : "NY", "county" : "ROCKLAND" },
            "10924": { "city" : "GOSHEN", "state" : "NY", "county" : "ORANGE" },"10925": { "city" : "GREENWOOD LAKE", "state" : "NY", "county" : "ORANGE" },
            "10926": { "city" : "HARRIMAN", "state" : "NY", "county" : "ORANGE" },
            "10927": { "city" : "HAVERSTRAW", "state" : "NY", "county" : "ROCKLAND" },
            "10928": { "city" : "HIGHLAND FALLS", "state" : "NY", "county" : "ORANGE" },
            "10930": { "city" : "HIGHLAND MILLS", "state" : "NY", "county" : "ORANGE" },
            "10931": { "city" : "HILLBURN", "state" : "NY", "county" : "ROCKLAND" },
            "10932": { "city" : "HOWELLS", "state" : "NY", "county" : "ORANGE" },
            "10933": { "city" : "JOHNSON", "state" : "NY", "county" : "ORANGE" },
            "10940": { "city" : "MIDDLETOWN", "state" : "NY", "county" : "ORANGE" },
            "10941": { "city" : "MIDDLETOWN", "state" : "NY", "county" : "ORANGE" },
            "10949": { "city" : "MONROE", "state" : "NY", "county" : "ORANGE" },"10950": { "city" : "MONROE", "state" : "NY", "county" : "ORANGE" },
            "10952": { "city" : "MONSEY", "state" : "NY", "county" : "ROCKLAND" },
            "10953": { "city" : "MOUNTAINVILLE", "state" : "NY", "county" : "ORANGE" },
            "10954": { "city" : "NANUET", "state" : "NY", "county" : "ROCKLAND" },
            "10956": { "city" : "NEW CITY", "state" : "NY", "county" : "ROCKLAND" },
            "10958": { "city" : "NEW HAMPTON", "state" : "NY", "county" : "ORANGE" },
            "10959": { "city" : "NEW MILFORD", "state" : "NY", "county" : "ORANGE" },
            "10960": { "city" : "NYACK", "state" : "NY", "county" : "ROCKLAND" },
            "10962": { "city" : "ORANGEBURG", "state" : "NY", "county" : "ROCKLAND" },
            "10963": { "city" : "OTISVILLE", "state" : "NY", "county" : "ORANGE" },
            "10964": { "city" : "PALISADES", "state" : "NY", "county" : "ROCKLAND" },
            "10965": { "city" : "PEARL RIVER", "state" : "NY", "county" : "ROCKLAND" },
            "10968": { "city" : "PIERMONT", "state" : "NY", "county" : "ROCKLAND" },
            "10969": { "city" : "PINE ISLAND", "state" : "NY", "county" : "ORANGE" },
            "10970": { "city" : "POMONA", "state" : "NY", "county" : "ROCKLAND" },
            "10973": { "city" : "SLATE HILL", "state" : "NY", "county" : "ORANGE" },
            "10974": { "city" : "SLOATSBURG", "state" : "NY", "county" : "ROCKLAND" },
            "10975": { "city" : "SOUTHFIELDS", "state" : "NY", "county" : "ORANGE" },
            "10976": { "city" : "SPARKILL", "state" : "NY", "county" : "ROCKLAND" },
            "10977": { "city" : "SPRING VALLEY", "state" : "NY", "county" : "ROCKLAND" },
            "10979": { "city" : "STERLING FOREST", "state" : "NY", "county" : "ORANGE" },
            "10980": { "city" : "STONY POINT", "state" : "NY", "county" : "ROCKLAND" },
            "10981": { "city" : "SUGAR LOAF", "state" : "NY", "county" : "ORANGE" },
            "10982": { "city" : "TALLMAN", "state" : "NY", "county" : "ROCKLAND" },
            "10983": { "city" : "TAPPAN", "state" : "NY", "county" : "ROCKLAND" },
            "10984": { "city" : "THIELLS", "state" : "NY", "county" : "ROCKLAND" },
            "10985": { "city" : "THOMPSON RIDGE", "state" : "NY", "county" : "ORANGE" },
            "10986": { "city" : "TOMKINS COVE", "state" : "NY", "county" : "ROCKLAND" },
            "10987": { "city" : "TUXEDO PARK", "state" : "NY", "county" : "ORANGE" },
            "10988": { "city" : "UNIONVILLE", "state" : "NY", "county" : "ORANGE" },
            "10989": { "city" : "VALLEY COTTAGE", "state" : "NY", "county" : "ROCKLAND" },
            "10990": { "city" : "WARWICK", "state" : "NY", "county" : "ORANGE" },
            "10992": { "city" : "WASHINGTONVILLE", "state" : "NY", "county" : "ORANGE" },
            "10993": { "city" : "WEST HAVERSTRAW", "state" : "NY", "county" : "ROCKLAND" },
            "10994": { "city" : "WEST NYACK", "state" : "NY", "county" : "ROCKLAND" },
            "10996": { "city" : "WEST POINT", "state" : "NY", "county" : "ORANGE" },
            "10998": { "city" : "WESTTOWN", "state" : "NY", "county" : "ORANGE" },
            "11001": { "city" : "FLORAL PARK", "state" : "NY", "county" : "NASSAU" },
            "11002": { "city" : "FLORAL PARK", "state" : "NY", "county" : "NASSAU" },
            "11003": { "city" : "ELMONT", "state" : "NY", "county" : "NASSAU" },"11004": { "city" : "GLEN OAKS", "state" : "NY", "county" : "QUEENS" },
            "11005": { "city" : "FLORAL PARK", "state" : "NY", "county" : "QUEENS" },
            "11010": { "city" : "FRANKLIN SQUARE", "state" : "NY", "county" : "NASSAU" },
            "11020": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11021": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11022": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11023": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11024": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11026": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11027": { "city" : "GREAT NECK", "state" : "NY", "county" : "NASSAU" },
            "11030": { "city" : "MANHASSET", "state" : "NY", "county" : "NASSAU" },
            "11040": { "city" : "NEW HYDE PARK", "state" : "NY", "county" : "NASSAU" },
            "11042": { "city" : "NEW HYDE PARK", "state" : "NY", "county" : "NASSAU" },
            "11050": { "city" : "PORT WASHINGTON", "state" : "NY", "county" : "NASSAU" },
            "11051": { "city" : "PORT WASHINGTON", "state" : "NY", "county" : "NASSAU" },
            "11055": { "city" : "PORT WASHINGTON", "state" : "NY", "county" : "NASSAU" },
            "11096": { "city" : "INWOOD", "state" : "NY", "county" : "NASSAU" },"11101": { "city" : "LONG ISLAND CITY", "state" : "NY", "county" : "QUEENS" },
            "11102": { "city" : "ASTORIA", "state" : "NY", "county" : "QUEENS" },
            "11103": { "city" : "ASTORIA", "state" : "NY", "county" : "QUEENS" },
            "11104": { "city" : "SUNNYSIDE", "state" : "NY", "county" : "QUEENS" },
            "11105": { "city" : "ASTORIA", "state" : "NY", "county" : "QUEENS" },
            "11106": { "city" : "ASTORIA", "state" : "NY", "county" : "QUEENS" },
            "11109": { "city" : "LONG ISLAND CITY", "state" : "NY", "county" : "QUEENS" },
            "11120": { "city" : "LONG ISLAND CITY", "state" : "NY", "county" : "QUEENS" },
            "11201": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11202": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11203": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11204": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11205": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11206": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11207": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11208": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11209": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11210": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11211": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11212": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11213": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11214": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11215": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11216": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11217": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11218": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11219": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11220": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11221": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11222": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11223": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11224": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11225": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11226": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11228": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11229": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11230": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11231": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11232": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11233": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11234": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11235": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11236": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11237": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11238": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11239": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11240": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11241": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11242": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11243": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11245": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11247": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11249": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11251": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11252": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11256": { "city" : "BROOKLYN", "state" : "NY", "county" : "KINGS" },
            "11351": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11352": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11354": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11355": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11356": { "city" : "COLLEGE POINT", "state" : "NY", "county" : "QUEENS" },
            "11357": { "city" : "WHITESTONE", "state" : "NY", "county" : "QUEENS" },
            "11358": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11359": { "city" : "BAYSIDE", "state" : "NY", "county" : "QUEENS" },
            "11360": { "city" : "BAYSIDE", "state" : "NY", "county" : "QUEENS" },
            "11361": { "city" : "BAYSIDE", "state" : "NY", "county" : "QUEENS" },
            "11362": { "city" : "LITTLE NECK", "state" : "NY", "county" : "QUEENS" },
            "11363": { "city" : "LITTLE NECK", "state" : "NY", "county" : "QUEENS" },
            "11364": { "city" : "OAKLAND GARDENS", "state" : "NY", "county" : "QUEENS" },
            "11365": { "city" : "FRESH MEADOWS", "state" : "NY", "county" : "QUEENS" },
            "11366": { "city" : "FRESH MEADOWS", "state" : "NY", "county" : "QUEENS" },
            "11367": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11368": { "city" : "CORONA", "state" : "NY", "county" : "QUEENS" },"11369": { "city" : "EAST ELMHURST", "state" : "NY", "county" : "QUEENS" },
            "11370": { "city" : "EAST ELMHURST", "state" : "NY", "county" : "QUEENS" },
            "11371": { "city" : "FLUSHING", "state" : "NY", "county" : "QUEENS" },
            "11372": { "city" : "JACKSON HEIGHTS", "state" : "NY", "county" : "QUEENS" },
            "11373": { "city" : "ELMHURST", "state" : "NY", "county" : "QUEENS" },
            "11374": { "city" : "REGO PARK", "state" : "NY", "county" : "QUEENS" },
            "11375": { "city" : "FOREST HILLS", "state" : "NY", "county" : "QUEENS" },
            "11377": { "city" : "WOODSIDE", "state" : "NY", "county" : "QUEENS" },
            "11378": { "city" : "MASPETH", "state" : "NY", "county" : "QUEENS" },
            "11379": { "city" : "MIDDLE VILLAGE", "state" : "NY", "county" : "QUEENS" },
            "11380": { "city" : "ELMHURST", "state" : "NY", "county" : "QUEENS" },
            "11385": { "city" : "RIDGEWOOD", "state" : "NY", "county" : "QUEENS" },
            "11386": { "city" : "RIDGEWOOD", "state" : "NY", "county" : "QUEENS" },
            "11405": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11411": { "city" : "CAMBRIA HEIGHTS", "state" : "NY", "county" : "QUEENS" },
            "11412": { "city" : "SAINT ALBANS", "state" : "NY", "county" : "QUEENS" },
            "11413": { "city" : "SPRINGFIELD GARDENS", "state" : "NY", "county" : "QUEENS" },
            "11414": { "city" : "HOWARD BEACH", "state" : "NY", "county" : "QUEENS" },
            "11415": { "city" : "KEW GARDENS", "state" : "NY", "county" : "QUEENS" },
            "11416": { "city" : "OZONE PARK", "state" : "NY", "county" : "QUEENS" },
            "11417": { "city" : "OZONE PARK", "state" : "NY", "county" : "QUEENS" },
            "11418": { "city" : "RICHMOND HILL", "state" : "NY", "county" : "QUEENS" },
            "11419": { "city" : "SOUTH RICHMOND HILL", "state" : "NY", "county" : "QUEENS" },
            "11420": { "city" : "SOUTH OZONE PARK", "state" : "NY", "county" : "QUEENS" },
            "11421": { "city" : "WOODHAVEN", "state" : "NY", "county" : "QUEENS" },
            "11422": { "city" : "ROSEDALE", "state" : "NY", "county" : "QUEENS" },
            "11423": { "city" : "HOLLIS", "state" : "NY", "county" : "QUEENS" },"11424": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11425": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11426": { "city" : "BELLEROSE", "state" : "NY", "county" : "QUEENS" },
            "11427": { "city" : "QUEENS VILLAGE", "state" : "NY", "county" : "QUEENS" },
            "11428": { "city" : "QUEENS VILLAGE", "state" : "NY", "county" : "QUEENS" },
            "11429": { "city" : "QUEENS VILLAGE", "state" : "NY", "county" : "QUEENS" },
            "11430": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11431": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11432": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11433": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11434": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11435": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11436": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11439": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11451": { "city" : "JAMAICA", "state" : "NY", "county" : "QUEENS" },
            "11501": { "city" : "MINEOLA", "state" : "NY", "county" : "NASSAU" },
            "11507": { "city" : "ALBERTSON", "state" : "NY", "county" : "NASSAU" },
            "11509": { "city" : "ATLANTIC BEACH", "state" : "NY", "county" : "NASSAU" },
            "11510": { "city" : "BALDWIN", "state" : "NY", "county" : "NASSAU" },
            "11514": { "city" : "CARLE PLACE", "state" : "NY", "county" : "NASSAU" },
            "11516": { "city" : "CEDARHURST", "state" : "NY", "county" : "NASSAU" },
            "11518": { "city" : "EAST ROCKAWAY", "state" : "NY", "county" : "NASSAU" },
            "11520": { "city" : "FREEPORT", "state" : "NY", "county" : "NASSAU" },
            "11530": { "city" : "GARDEN CITY", "state" : "NY", "county" : "NASSAU" },
            "11531": { "city" : "GARDEN CITY", "state" : "NY", "county" : "NASSAU" },
            "11542": { "city" : "GLEN COVE", "state" : "NY", "county" : "NASSAU" },
            "11545": { "city" : "GLEN HEAD", "state" : "NY", "county" : "NASSAU" },
            "11547": { "city" : "GLENWOOD LANDING", "state" : "NY", "county" : "NASSAU" },
            "11548": { "city" : "GREENVALE", "state" : "NY", "county" : "NASSAU" },
            "11549": { "city" : "HEMPSTEAD", "state" : "NY", "county" : "NASSAU" },
            "11550": { "city" : "HEMPSTEAD", "state" : "NY", "county" : "NASSAU" },
            "11551": { "city" : "HEMPSTEAD", "state" : "NY", "county" : "NASSAU" },
            "11552": { "city" : "WEST HEMPSTEAD", "state" : "NY", "county" : "NASSAU" },
            "11553": { "city" : "UNIONDALE", "state" : "NY", "county" : "NASSAU" },
            "11554": { "city" : "EAST MEADOW", "state" : "NY", "county" : "NASSAU" },
            "11555": { "city" : "UNIONDALE", "state" : "NY", "county" : "NASSAU" },
            "11556": { "city" : "UNIONDALE", "state" : "NY", "county" : "NASSAU" },
            "11557": { "city" : "HEWLETT", "state" : "NY", "county" : "NASSAU" },
            "11558": { "city" : "ISLAND PARK", "state" : "NY", "county" : "NASSAU" },
            "11559": { "city" : "LAWRENCE", "state" : "NY", "county" : "NASSAU" },
            "11560": { "city" : "LOCUST VALLEY", "state" : "NY", "county" : "NASSAU" },
            "11561": { "city" : "LONG BEACH", "state" : "NY", "county" : "NASSAU" },
            "11563": { "city" : "LYNBROOK", "state" : "NY", "county" : "NASSAU" },
            "11565": { "city" : "MALVERNE", "state" : "NY", "county" : "NASSAU" },
            "11566": { "city" : "MERRICK", "state" : "NY", "county" : "NASSAU" },
            "11568": { "city" : "OLD WESTBURY", "state" : "NY", "county" : "NASSAU" },
            "11569": { "city" : "POINT LOOKOUT", "state" : "NY", "county" : "NASSAU" },
            "11570": { "city" : "ROCKVILLE CENTRE", "state" : "NY", "county" : "NASSAU" },
            "11571": { "city" : "ROCKVILLE CENTRE", "state" : "NY", "county" : "NASSAU" },
            "11572": { "city" : "OCEANSIDE", "state" : "NY", "county" : "NASSAU" },
            "11575": { "city" : "ROOSEVELT", "state" : "NY", "county" : "NASSAU" },
            "11576": { "city" : "ROSLYN", "state" : "NY", "county" : "NASSAU" },"11577": { "city" : "ROSLYN HEIGHTS", "state" : "NY", "county" : "NASSAU" },
            "11579": { "city" : "SEA CLIFF", "state" : "NY", "county" : "NASSAU" },
            "11580": { "city" : "VALLEY STREAM", "state" : "NY", "county" : "NASSAU" },
            "11581": { "city" : "VALLEY STREAM", "state" : "NY", "county" : "NASSAU" },
            "11582": { "city" : "VALLEY STREAM", "state" : "NY", "county" : "NASSAU" },
            "11590": { "city" : "WESTBURY", "state" : "NY", "county" : "NASSAU" },
            "11594": { "city" : "WESTBURY", "state" : "NY", "county" : "NASSAU" },
            "11596": { "city" : "WILLISTON PARK", "state" : "NY", "county" : "NASSAU" },
            "11598": { "city" : "WOODMERE", "state" : "NY", "county" : "NASSAU" },
            "11599": { "city" : "GARDEN CITY", "state" : "NY", "county" : "NASSAU" },
            "11690": { "city" : "FAR ROCKAWAY", "state" : "NY", "county" : "QUEENS" },
            "11691": { "city" : "FAR ROCKAWAY", "state" : "NY", "county" : "QUEENS" },
            "11692": { "city" : "ARVERNE", "state" : "NY", "county" : "QUEENS" },
            "11693": { "city" : "FAR ROCKAWAY", "state" : "NY", "county" : "QUEENS" },
            "11694": { "city" : "ROCKAWAY PARK", "state" : "NY", "county" : "QUEENS" },
            "11695": { "city" : "FAR ROCKAWAY", "state" : "NY", "county" : "QUEENS" },
            "11697": { "city" : "BREEZY POINT", "state" : "NY", "county" : "QUEENS" },
            "11701": { "city" : "AMITYVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11702": { "city" : "BABYLON", "state" : "NY", "county" : "SUFFOLK" },
            "11703": { "city" : "NORTH BABYLON", "state" : "NY", "county" : "SUFFOLK" },
            "11704": { "city" : "WEST BABYLON", "state" : "NY", "county" : "SUFFOLK" },
            "11705": { "city" : "BAYPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11706": { "city" : "BAY SHORE", "state" : "NY", "county" : "SUFFOLK" },
            "11707": { "city" : "WEST BABYLON", "state" : "NY", "county" : "SUFFOLK" },
            "11709": { "city" : "BAYVILLE", "state" : "NY", "county" : "NASSAU" },
            "11710": { "city" : "BELLMORE", "state" : "NY", "county" : "NASSAU" },
            "11713": { "city" : "BELLPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11714": { "city" : "BETHPAGE", "state" : "NY", "county" : "NASSAU" },
            "11715": { "city" : "BLUE POINT", "state" : "NY", "county" : "SUFFOLK" },
            "11716": { "city" : "BOHEMIA", "state" : "NY", "county" : "SUFFOLK" },
            "11717": { "city" : "BRENTWOOD", "state" : "NY", "county" : "SUFFOLK" },
            "11718": { "city" : "BRIGHTWATERS", "state" : "NY", "county" : "SUFFOLK" },
            "11719": { "city" : "BROOKHAVEN", "state" : "NY", "county" : "SUFFOLK" },
            "11720": { "city" : "CENTEREACH", "state" : "NY", "county" : "SUFFOLK" },
            "11721": { "city" : "CENTERPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11722": { "city" : "CENTRAL ISLIP", "state" : "NY", "county" : "SUFFOLK" },
            "11724": { "city" : "COLD SPRING HARBOR", "state" : "NY", "county" : "SUFFOLK" },
            "11725": { "city" : "COMMACK", "state" : "NY", "county" : "SUFFOLK" },
            "11726": { "city" : "COPIAGUE", "state" : "NY", "county" : "SUFFOLK" },
            "11727": { "city" : "CORAM", "state" : "NY", "county" : "SUFFOLK" },"11729": { "city" : "DEER PARK", "state" : "NY", "county" : "SUFFOLK" },
            "11730": { "city" : "EAST ISLIP", "state" : "NY", "county" : "SUFFOLK" },
            "11731": { "city" : "EAST NORTHPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11732": { "city" : "EAST NORWICH", "state" : "NY", "county" : "NASSAU" },
            "11733": { "city" : "EAST SETAUKET", "state" : "NY", "county" : "SUFFOLK" },
            "11735": { "city" : "FARMINGDALE", "state" : "NY", "county" : "NASSAU" },
            "11736": { "city" : "FARMINGDALE", "state" : "NY", "county" : "NASSAU" },
            "11737": { "city" : "FARMINGDALE", "state" : "NY", "county" : "NASSAU" },
            "11738": { "city" : "FARMINGVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11739": { "city" : "GREAT RIVER", "state" : "NY", "county" : "SUFFOLK" },
            "11740": { "city" : "GREENLAWN", "state" : "NY", "county" : "SUFFOLK" },
            "11741": { "city" : "HOLBROOK", "state" : "NY", "county" : "SUFFOLK" },
            "11742": { "city" : "HOLTSVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11743": { "city" : "HUNTINGTON", "state" : "NY", "county" : "SUFFOLK" },
            "11746": { "city" : "HUNTINGTON STATION", "state" : "NY", "county" : "SUFFOLK" },
            "11747": { "city" : "MELVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11749": { "city" : "ISLANDIA", "state" : "NY", "county" : "SUFFOLK" },
            "11751": { "city" : "ISLIP", "state" : "NY", "county" : "SUFFOLK" },"11752": { "city" : "ISLIP TERRACE", "state" : "NY", "county" : "SUFFOLK" },
            "11753": { "city" : "JERICHO", "state" : "NY", "county" : "NASSAU" },
            "11754": { "city" : "KINGS PARK", "state" : "NY", "county" : "SUFFOLK" },
            "11755": { "city" : "LAKE GROVE", "state" : "NY", "county" : "SUFFOLK" },
            "11756": { "city" : "LEVITTOWN", "state" : "NY", "county" : "NASSAU" },
            "11757": { "city" : "LINDENHURST", "state" : "NY", "county" : "SUFFOLK" },
            "11758": { "city" : "MASSAPEQUA", "state" : "NY", "county" : "NASSAU" },
            "11760": { "city" : "ISLANDIA", "state" : "NY", "county" : "SUFFOLK" },
            "11762": { "city" : "MASSAPEQUA PARK", "state" : "NY", "county" : "NASSAU" },
            "11763": { "city" : "MEDFORD", "state" : "NY", "county" : "SUFFOLK" },
            "11764": { "city" : "MILLER PLACE", "state" : "NY", "county" : "SUFFOLK" },
            "11765": { "city" : "MILL NECK", "state" : "NY", "county" : "NASSAU" },
            "11766": { "city" : "MOUNT SINAI", "state" : "NY", "county" : "SUFFOLK" },
            "11767": { "city" : "NESCONSET", "state" : "NY", "county" : "SUFFOLK" },
            "11768": { "city" : "NORTHPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11769": { "city" : "OAKDALE", "state" : "NY", "county" : "SUFFOLK" },
            "11770": { "city" : "OCEAN BEACH", "state" : "NY", "county" : "SUFFOLK" },
            "11771": { "city" : "OYSTER BAY", "state" : "NY", "county" : "NASSAU" },
            "11772": { "city" : "PATCHOGUE", "state" : "NY", "county" : "SUFFOLK" },
            "11773": { "city" : "SYOSSET", "state" : "NY", "county" : "NASSAU" },
            "11774": { "city" : "FARMINGDALE", "state" : "NY", "county" : "NASSAU" },
            "11775": { "city" : "MELVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11776": { "city" : "PORT JEFFERSON STATION", "state" : "NY", "county" : "SUFFOLK" },
            "11777": { "city" : "PORT JEFFERSON", "state" : "NY", "county" : "SUFFOLK" },
            "11778": { "city" : "ROCKY POINT", "state" : "NY", "county" : "SUFFOLK" },
            "11779": { "city" : "RONKONKOMA", "state" : "NY", "county" : "SUFFOLK" },
            "11780": { "city" : "SAINT JAMES", "state" : "NY", "county" : "SUFFOLK" },
            "11782": { "city" : "SAYVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11783": { "city" : "SEAFORD", "state" : "NY", "county" : "NASSAU" },
            "11784": { "city" : "SELDEN", "state" : "NY", "county" : "SUFFOLK" },
            "11786": { "city" : "SHOREHAM", "state" : "NY", "county" : "SUFFOLK" },
            "11787": { "city" : "SMITHTOWN", "state" : "NY", "county" : "SUFFOLK" },
            "11788": { "city" : "HAUPPAUGE", "state" : "NY", "county" : "SUFFOLK" },
            "11789": { "city" : "SOUND BEACH", "state" : "NY", "county" : "SUFFOLK" },
            "11790": { "city" : "STONY BROOK", "state" : "NY", "county" : "SUFFOLK" },
            "11791": { "city" : "SYOSSET", "state" : "NY", "county" : "NASSAU" },
            "11792": { "city" : "WADING RIVER", "state" : "NY", "county" : "SUFFOLK" },
            "11793": { "city" : "WANTAGH", "state" : "NY", "county" : "NASSAU" },
            "11794": { "city" : "STONY BROOK", "state" : "NY", "county" : "SUFFOLK" },
            "11795": { "city" : "WEST ISLIP", "state" : "NY", "county" : "SUFFOLK" },
            "11796": { "city" : "WEST SAYVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11797": { "city" : "WOODBURY", "state" : "NY", "county" : "NASSAU" },
            "11798": { "city" : "WYANDANCH", "state" : "NY", "county" : "SUFFOLK" },
            "11801": { "city" : "HICKSVILLE", "state" : "NY", "county" : "NASSAU" },
            "11802": { "city" : "HICKSVILLE", "state" : "NY", "county" : "NASSAU" },
            "11803": { "city" : "PLAINVIEW", "state" : "NY", "county" : "NASSAU" },
            "11804": { "city" : "OLD BETHPAGE", "state" : "NY", "county" : "NASSAU" },
            "11815": { "city" : "HICKSVILLE", "state" : "NY", "county" : "NASSAU" },
            "11853": { "city" : "JERICHO", "state" : "NY", "county" : "NASSAU" },
            "11901": { "city" : "RIVERHEAD", "state" : "NY", "county" : "SUFFOLK" },
            "11930": { "city" : "AMAGANSETT", "state" : "NY", "county" : "SUFFOLK" },
            "11931": { "city" : "AQUEBOGUE", "state" : "NY", "county" : "SUFFOLK" },
            "11932": { "city" : "BRIDGEHAMPTON", "state" : "NY", "county" : "SUFFOLK" },
            "11933": { "city" : "CALVERTON", "state" : "NY", "county" : "SUFFOLK" },
            "11934": { "city" : "CENTER MORICHES", "state" : "NY", "county" : "SUFFOLK" },
            "11935": { "city" : "CUTCHOGUE", "state" : "NY", "county" : "SUFFOLK" },
            "11937": { "city" : "EAST HAMPTON", "state" : "NY", "county" : "SUFFOLK" },
            "11939": { "city" : "EAST MARION", "state" : "NY", "county" : "SUFFOLK" },
            "11940": { "city" : "EAST MORICHES", "state" : "NY", "county" : "SUFFOLK" },
            "11941": { "city" : "EASTPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11942": { "city" : "EAST QUOGUE", "state" : "NY", "county" : "SUFFOLK" },
            "11944": { "city" : "GREENPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11946": { "city" : "HAMPTON BAYS", "state" : "NY", "county" : "SUFFOLK" },
            "11947": { "city" : "JAMESPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11948": { "city" : "LAUREL", "state" : "NY", "county" : "SUFFOLK" },
            "11949": { "city" : "MANORVILLE", "state" : "NY", "county" : "SUFFOLK" },
            "11950": { "city" : "MASTIC", "state" : "NY", "county" : "SUFFOLK" },
            "11951": { "city" : "MASTIC BEACH", "state" : "NY", "county" : "SUFFOLK" },
            "11952": { "city" : "MATTITUCK", "state" : "NY", "county" : "SUFFOLK" },
            "11953": { "city" : "MIDDLE ISLAND", "state" : "NY", "county" : "SUFFOLK" },
            "11954": { "city" : "MONTAUK", "state" : "NY", "county" : "SUFFOLK" },
            "11955": { "city" : "MORICHES", "state" : "NY", "county" : "SUFFOLK" },
            "11956": { "city" : "NEW SUFFOLK", "state" : "NY", "county" : "SUFFOLK" },
            "11957": { "city" : "ORIENT", "state" : "NY", "county" : "SUFFOLK" },
            "11958": { "city" : "PECONIC", "state" : "NY", "county" : "SUFFOLK" },
            "11959": { "city" : "QUOGUE", "state" : "NY", "county" : "SUFFOLK" },
            "11960": { "city" : "REMSENBURG", "state" : "NY", "county" : "SUFFOLK" },
            "11961": { "city" : "RIDGE", "state" : "NY", "county" : "SUFFOLK" },"11962": { "city" : "SAGAPONACK", "state" : "NY", "county" : "SUFFOLK" },
            "11963": { "city" : "SAG HARBOR", "state" : "NY", "county" : "SUFFOLK" },
            "11964": { "city" : "SHELTER ISLAND", "state" : "NY", "county" : "SUFFOLK" },
            "11965": { "city" : "SHELTER ISLAND HEIGHTS", "state" : "NY", "county" : "SUFFOLK" },
            "11967": { "city" : "SHIRLEY", "state" : "NY", "county" : "SUFFOLK" },
            "11968": { "city" : "SOUTHAMPTON", "state" : "NY", "county" : "SUFFOLK" },
            "11969": { "city" : "SOUTHAMPTON", "state" : "NY", "county" : "SUFFOLK" },
            "11970": { "city" : "SOUTH JAMESPORT", "state" : "NY", "county" : "SUFFOLK" },
            "11971": { "city" : "SOUTHOLD", "state" : "NY", "county" : "SUFFOLK" },
            "11972": { "city" : "SPEONK", "state" : "NY", "county" : "SUFFOLK" },
            "11973": { "city" : "UPTON", "state" : "NY", "county" : "SUFFOLK" },"11975": { "city" : "WAINSCOTT", "state" : "NY", "county" : "SUFFOLK" },
            "11976": { "city" : "WATER MILL", "state" : "NY", "county" : "SUFFOLK" },
            "11977": { "city" : "WESTHAMPTON", "state" : "NY", "county" : "SUFFOLK" },
            "11978": { "city" : "WESTHAMPTON BEACH", "state" : "NY", "county" : "SUFFOLK" },
            "11980": { "city" : "YAPHANK", "state" : "NY", "county" : "SUFFOLK" },
            "12007": { "city" : "ALCOVE", "state" : "NY", "county" : "ALBANY" },"12008": { "city" : "ALPLAUS", "state" : "NY", "county" : "SCHENECTADY" },
            "12009": { "city" : "ALTAMONT", "state" : "NY", "county" : "ALBANY" },
            "12010": { "city" : "AMSTERDAM", "state" : "NY", "county" : "MONTGOMERY" },
            "12015": { "city" : "ATHENS", "state" : "NY", "county" : "GREENE" },"12016": { "city" : "AURIESVILLE", "state" : "NY", "county" : "MONTGOMERY" },
            "12017": { "city" : "AUSTERLITZ", "state" : "NY", "county" : "COLUMBIA" },
            "12018": { "city" : "AVERILL PARK", "state" : "NY", "county" : "RENSSELAER" },
            "12019": { "city" : "BALLSTON LAKE", "state" : "NY", "county" : "SARATOGA" },
            "12020": { "city" : "BALLSTON SPA", "state" : "NY", "county" : "SARATOGA" },
            "12022": { "city" : "BERLIN", "state" : "NY", "county" : "RENSSELAER" },
            "12023": { "city" : "BERNE", "state" : "NY", "county" : "ALBANY" },"12025": { "city" : "BROADALBIN", "state" : "NY", "county" : "FULTON" },
            "12027": { "city" : "BURNT HILLS", "state" : "NY", "county" : "SARATOGA" },
            "12028": { "city" : "BUSKIRK", "state" : "NY", "county" : "RENSSELAER" },
            "12029": { "city" : "CANAAN", "state" : "NY", "county" : "COLUMBIA" },
            "12031": { "city" : "CARLISLE", "state" : "NY", "county" : "SCHOHARIE" },
            "12032": { "city" : "CAROGA LAKE", "state" : "NY", "county" : "FULTON" },
            "12033": { "city" : "CASTLETON ON HUDSON", "state" : "NY", "county" : "RENSSELAER" },
            "12035": { "city" : "CENTRAL BRIDGE", "state" : "NY", "county" : "SCHOHARIE" },
            "12036": { "city" : "CHARLOTTEVILLE", "state" : "NY", "county" : "SCHOHARIE" },
            "12037": { "city" : "CHATHAM", "state" : "NY", "county" : "COLUMBIA" },
            "12040": { "city" : "CHERRY PLAIN", "state" : "NY", "county" : "RENSSELAER" },
            "12041": { "city" : "CLARKSVILLE", "state" : "NY", "county" : "ALBANY" },
            "12042": { "city" : "CLIMAX", "state" : "NY", "county" : "GREENE" },"12043": { "city" : "COBLESKILL", "state" : "NY", "county" : "SCHOHARIE" },
            "12045": { "city" : "COEYMANS", "state" : "NY", "county" : "ALBANY" },
            "12046": { "city" : "COEYMANS HOLLOW", "state" : "NY", "county" : "ALBANY" },
            "12047": { "city" : "COHOES", "state" : "NY", "county" : "ALBANY" },"12050": { "city" : "COLUMBIAVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12051": { "city" : "COXSACKIE", "state" : "NY", "county" : "GREENE" },
            "12052": { "city" : "CROPSEYVILLE", "state" : "NY", "county" : "RENSSELAER" },
            "12053": { "city" : "DELANSON", "state" : "NY", "county" : "SCHENECTADY" },
            "12054": { "city" : "DELMAR", "state" : "NY", "county" : "ALBANY" },"12055": { "city" : "DORMANSVILLE", "state" : "NY", "county" : "ALBANY" },
            "12056": { "city" : "DUANESBURG", "state" : "NY", "county" : "SCHENECTADY" },
            "12057": { "city" : "EAGLE BRIDGE", "state" : "NY", "county" : "RENSSELAER" },
            "12058": { "city" : "EARLTON", "state" : "NY", "county" : "GREENE" },
            "12059": { "city" : "EAST BERNE", "state" : "NY", "county" : "ALBANY" },
            "12060": { "city" : "EAST CHATHAM", "state" : "NY", "county" : "COLUMBIA" },
            "12061": { "city" : "EAST GREENBUSH", "state" : "NY", "county" : "RENSSELAER" },
            "12062": { "city" : "EAST NASSAU", "state" : "NY", "county" : "RENSSELAER" },
            "12063": { "city" : "EAST SCHODACK", "state" : "NY", "county" : "RENSSELAER" },
            "12064": { "city" : "EAST WORCESTER", "state" : "NY", "county" : "OTSEGO" },
            "12065": { "city" : "CLIFTON PARK", "state" : "NY", "county" : "SARATOGA" },
            "12066": { "city" : "ESPERANCE", "state" : "NY", "county" : "MONTGOMERY" },
            "12067": { "city" : "FEURA BUSH", "state" : "NY", "county" : "ALBANY" },
            "12068": { "city" : "FONDA", "state" : "NY", "county" : "MONTGOMERY" },
            "12069": { "city" : "FORT HUNTER", "state" : "NY", "county" : "MONTGOMERY" },
            "12070": { "city" : "FORT JOHNSON", "state" : "NY", "county" : "MONTGOMERY" },
            "12071": { "city" : "FULTONHAM", "state" : "NY", "county" : "SCHOHARIE" },
            "12072": { "city" : "FULTONVILLE", "state" : "NY", "county" : "MONTGOMERY" },
            "12073": { "city" : "GALLUPVILLE", "state" : "NY", "county" : "SCHOHARIE" },
            "12074": { "city" : "GALWAY", "state" : "NY", "county" : "SARATOGA" },
            "12075": { "city" : "GHENT", "state" : "NY", "county" : "COLUMBIA" },
            "12076": { "city" : "GILBOA", "state" : "NY", "county" : "SCHOHARIE" },
            "12077": { "city" : "GLENMONT", "state" : "NY", "county" : "ALBANY" },
            "12078": { "city" : "GLOVERSVILLE", "state" : "NY", "county" : "FULTON" },
            "12082": { "city" : "GRAFTON", "state" : "NY", "county" : "RENSSELAER" },
            "12083": { "city" : "GREENVILLE", "state" : "NY", "county" : "GREENE" },
            "12084": { "city" : "GUILDERLAND", "state" : "NY", "county" : "ALBANY" },
            "12085": { "city" : "GUILDERLAND CENTER", "state" : "NY", "county" : "ALBANY" },
            "12086": { "city" : "HAGAMAN", "state" : "NY", "county" : "MONTGOMERY" },
            "12087": { "city" : "HANNACROIX", "state" : "NY", "county" : "GREENE" },
            "12089": { "city" : "HOOSICK", "state" : "NY", "county" : "RENSSELAER" },
            "12090": { "city" : "HOOSICK FALLS", "state" : "NY", "county" : "RENSSELAER" },
            "12092": { "city" : "HOWES CAVE", "state" : "NY", "county" : "SCHOHARIE" },
            "12093": { "city" : "JEFFERSON", "state" : "NY", "county" : "SCHOHARIE" },
            "12094": { "city" : "JOHNSONVILLE", "state" : "NY", "county" : "RENSSELAER" },
            "12095": { "city" : "JOHNSTOWN", "state" : "NY", "county" : "FULTON" },
            "12106": { "city" : "KINDERHOOK", "state" : "NY", "county" : "COLUMBIA" },
            "12107": { "city" : "KNOX", "state" : "NY", "county" : "ALBANY" },"12108": { "city" : "LAKE PLEASANT", "state" : "NY", "county" : "HAMILTON" },
            "12110": { "city" : "LATHAM", "state" : "NY", "county" : "ALBANY" },"12116": { "city" : "MARYLAND", "state" : "NY", "county" : "OTSEGO" },
            "12117": { "city" : "MAYFIELD", "state" : "NY", "county" : "FULTON" },
            "12118": { "city" : "MECHANICVILLE", "state" : "NY", "county" : "SARATOGA" },
            "12120": { "city" : "MEDUSA", "state" : "NY", "county" : "ALBANY" },"12121": { "city" : "MELROSE", "state" : "NY", "county" : "RENSSELAER" },
            "12122": { "city" : "MIDDLEBURGH", "state" : "NY", "county" : "SCHOHARIE" },
            "12123": { "city" : "NASSAU", "state" : "NY", "county" : "RENSSELAER" },
            "12124": { "city" : "NEW BALTIMORE", "state" : "NY", "county" : "GREENE" },
            "12125": { "city" : "NEW LEBANON", "state" : "NY", "county" : "COLUMBIA" },
            "12128": { "city" : "NEWTONVILLE", "state" : "NY", "county" : "ALBANY" },
            "12130": { "city" : "NIVERVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12131": { "city" : "NORTH BLENHEIM", "state" : "NY", "county" : "SCHOHARIE" },
            "12132": { "city" : "NORTH CHATHAM", "state" : "NY", "county" : "COLUMBIA" },
            "12133": { "city" : "NORTH HOOSICK", "state" : "NY", "county" : "RENSSELAER" },
            "12134": { "city" : "NORTHVILLE", "state" : "NY", "county" : "FULTON" },
            "12136": { "city" : "OLD CHATHAM", "state" : "NY", "county" : "COLUMBIA" },
            "12137": { "city" : "PATTERSONVILLE", "state" : "NY", "county" : "SCHENECTADY" },
            "12138": { "city" : "PETERSBURG", "state" : "NY", "county" : "RENSSELAER" },
            "12139": { "city" : "PISECO", "state" : "NY", "county" : "HAMILTON" },
            "12140": { "city" : "POESTENKILL", "state" : "NY", "county" : "RENSSELAER" },
            "12141": { "city" : "QUAKER STREET", "state" : "NY", "county" : "SCHENECTADY" },
            "12143": { "city" : "RAVENA", "state" : "NY", "county" : "ALBANY" },"12144": { "city" : "RENSSELAER", "state" : "NY", "county" : "RENSSELAER" },
            "12147": { "city" : "RENSSELAERVILLE", "state" : "NY", "county" : "ALBANY" },
            "12148": { "city" : "REXFORD", "state" : "NY", "county" : "SARATOGA" },
            "12149": { "city" : "RICHMONDVILLE", "state" : "NY", "county" : "SCHOHARIE" },
            "12150": { "city" : "ROTTERDAM JUNCTION", "state" : "NY", "county" : "SCHENECTADY" },
            "12151": { "city" : "ROUND LAKE", "state" : "NY", "county" : "SARATOGA" },
            "12153": { "city" : "SAND LAKE", "state" : "NY", "county" : "RENSSELAER" },
            "12154": { "city" : "SCHAGHTICOKE", "state" : "NY", "county" : "RENSSELAER" },
            "12155": { "city" : "SCHENEVUS", "state" : "NY", "county" : "OTSEGO" },
            "12156": { "city" : "SCHODACK LANDING", "state" : "NY", "county" : "RENSSELAER" },
            "12157": { "city" : "SCHOHARIE", "state" : "NY", "county" : "SCHOHARIE" },
            "12158": { "city" : "SELKIRK", "state" : "NY", "county" : "ALBANY" },
            "12159": { "city" : "SLINGERLANDS", "state" : "NY", "county" : "ALBANY" },
            "12160": { "city" : "SLOANSVILLE", "state" : "NY", "county" : "SCHOHARIE" },
            "12161": { "city" : "SOUTH BETHLEHEM", "state" : "NY", "county" : "ALBANY" },
            "12164": { "city" : "SPECULATOR", "state" : "NY", "county" : "HAMILTON" },
            "12165": { "city" : "SPENCERTOWN", "state" : "NY", "county" : "COLUMBIA" },
            "12166": { "city" : "SPRAKERS", "state" : "NY", "county" : "MONTGOMERY" },
            "12167": { "city" : "STAMFORD", "state" : "NY", "county" : "DELAWARE" },
            "12168": { "city" : "STEPHENTOWN", "state" : "NY", "county" : "RENSSELAER" },
            "12169": { "city" : "STEPHENTOWN", "state" : "NY", "county" : "RENSSELAER" },
            "12170": { "city" : "STILLWATER", "state" : "NY", "county" : "SARATOGA" },
            "12172": { "city" : "STOTTVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12173": { "city" : "STUYVESANT", "state" : "NY", "county" : "COLUMBIA" },
            "12174": { "city" : "STUYVESANT FALLS", "state" : "NY", "county" : "COLUMBIA" },
            "12175": { "city" : "SUMMIT", "state" : "NY", "county" : "SCHOHARIE" },
            "12176": { "city" : "SURPRISE", "state" : "NY", "county" : "GREENE" },
            "12177": { "city" : "TRIBES HILL", "state" : "NY", "county" : "MONTGOMERY" },
            "12180": { "city" : "TROY", "state" : "NY", "county" : "RENSSELAER" },
            "12181": { "city" : "TROY", "state" : "NY", "county" : "RENSSELAER" },
            "12182": { "city" : "TROY", "state" : "NY", "county" : "RENSSELAER" },
            "12183": { "city" : "TROY", "state" : "NY", "county" : "ALBANY" },"12184": { "city" : "VALATIE", "state" : "NY", "county" : "COLUMBIA" },
            "12185": { "city" : "VALLEY FALLS", "state" : "NY", "county" : "RENSSELAER" },
            "12186": { "city" : "VOORHEESVILLE", "state" : "NY", "county" : "ALBANY" },
            "12187": { "city" : "WARNERVILLE", "state" : "NY", "county" : "SCHOHARIE" },
            "12188": { "city" : "WATERFORD", "state" : "NY", "county" : "SARATOGA" },
            "12189": { "city" : "WATERVLIET", "state" : "NY", "county" : "ALBANY" },
            "12190": { "city" : "WELLS", "state" : "NY", "county" : "HAMILTON" },
            "12192": { "city" : "WEST COXSACKIE", "state" : "NY", "county" : "GREENE" },
            "12193": { "city" : "WESTERLO", "state" : "NY", "county" : "ALBANY" },
            "12194": { "city" : "WEST FULTON", "state" : "NY", "county" : "SCHOHARIE" },
            "12195": { "city" : "WEST LEBANON", "state" : "NY", "county" : "COLUMBIA" },
            "12196": { "city" : "WEST SAND LAKE", "state" : "NY", "county" : "RENSSELAER" },
            "12197": { "city" : "WORCESTER", "state" : "NY", "county" : "OTSEGO" },
            "12198": { "city" : "WYNANTSKILL", "state" : "NY", "county" : "RENSSELAER" },
            "12201": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12202": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12203": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12204": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12205": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12206": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12207": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12208": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12209": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12210": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12211": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12212": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12220": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12222": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12223": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12224": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12225": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12226": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12227": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12228": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12230": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12231": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12233": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12234": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12235": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12237": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12238": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12240": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12242": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12243": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12246": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12247": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12250": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12256": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },
            "12260": { "city" : "ALBANY", "state" : "NY", "county" : "ALBANY" },"12301": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12302": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12303": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12304": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12305": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12306": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12307": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12308": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12309": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12325": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12345": { "city" : "SCHENECTADY", "state" : "NY", "county" : "SCHENECTADY" },
            "12401": { "city" : "KINGSTON", "state" : "NY", "county" : "ULSTER" },
            "12402": { "city" : "KINGSTON", "state" : "NY", "county" : "ULSTER" },
            "12404": { "city" : "ACCORD", "state" : "NY", "county" : "ULSTER" },"12405": { "city" : "ACRA", "state" : "NY", "county" : "GREENE" },
            "12406": { "city" : "ARKVILLE", "state" : "NY", "county" : "DELAWARE" },
            "12407": { "city" : "ASHLAND", "state" : "NY", "county" : "GREENE" },
            "12409": { "city" : "BEARSVILLE", "state" : "NY", "county" : "ULSTER" },
            "12410": { "city" : "BIG INDIAN", "state" : "NY", "county" : "ULSTER" },
            "12411": { "city" : "BLOOMINGTON", "state" : "NY", "county" : "ULSTER" },
            "12412": { "city" : "BOICEVILLE", "state" : "NY", "county" : "ULSTER" },
            "12413": { "city" : "CAIRO", "state" : "NY", "county" : "GREENE" },"12414": { "city" : "CATSKILL", "state" : "NY", "county" : "GREENE" },
            "12416": { "city" : "CHICHESTER", "state" : "NY", "county" : "ULSTER" },
            "12417": { "city" : "CONNELLY", "state" : "NY", "county" : "ULSTER" },
            "12418": { "city" : "CORNWALLVILLE", "state" : "NY", "county" : "GREENE" },
            "12419": { "city" : "COTTEKILL", "state" : "NY", "county" : "ULSTER" },
            "12420": { "city" : "CRAGSMOOR", "state" : "NY", "county" : "ULSTER" },
            "12421": { "city" : "DENVER", "state" : "NY", "county" : "DELAWARE" },
            "12422": { "city" : "DURHAM", "state" : "NY", "county" : "GREENE" },"12423": { "city" : "EAST DURHAM", "state" : "NY", "county" : "GREENE" },
            "12424": { "city" : "EAST JEWETT", "state" : "NY", "county" : "GREENE" },
            "12427": { "city" : "ELKA PARK", "state" : "NY", "county" : "GREENE" },
            "12428": { "city" : "ELLENVILLE", "state" : "NY", "county" : "ULSTER" },
            "12429": { "city" : "ESOPUS", "state" : "NY", "county" : "ULSTER" },"12430": { "city" : "FLEISCHMANNS", "state" : "NY", "county" : "DELAWARE" },
            "12431": { "city" : "FREEHOLD", "state" : "NY", "county" : "GREENE" },
            "12432": { "city" : "GLASCO", "state" : "NY", "county" : "ULSTER" },"12433": { "city" : "GLENFORD", "state" : "NY", "county" : "ULSTER" },
            "12434": { "city" : "GRAND GORGE", "state" : "NY", "county" : "DELAWARE" },
            "12435": { "city" : "GREENFIELD PARK", "state" : "NY", "county" : "ULSTER" },
            "12436": { "city" : "HAINES FALLS", "state" : "NY", "county" : "GREENE" },
            "12438": { "city" : "HALCOTTSVILLE", "state" : "NY", "county" : "DELAWARE" },
            "12439": { "city" : "HENSONVILLE", "state" : "NY", "county" : "GREENE" },
            "12440": { "city" : "HIGH FALLS", "state" : "NY", "county" : "ULSTER" },
            "12441": { "city" : "HIGHMOUNT", "state" : "NY", "county" : "ULSTER" },
            "12442": { "city" : "HUNTER", "state" : "NY", "county" : "GREENE" },"12443": { "city" : "HURLEY", "state" : "NY", "county" : "ULSTER" },
            "12444": { "city" : "JEWETT", "state" : "NY", "county" : "GREENE" },"12446": { "city" : "KERHONKSON", "state" : "NY", "county" : "ULSTER" },
            "12448": { "city" : "LAKE HILL", "state" : "NY", "county" : "ULSTER" },
            "12449": { "city" : "LAKE KATRINE", "state" : "NY", "county" : "ULSTER" },
            "12450": { "city" : "LANESVILLE", "state" : "NY", "county" : "GREENE" },
            "12451": { "city" : "LEEDS", "state" : "NY", "county" : "GREENE" },"12452": { "city" : "LEXINGTON", "state" : "NY", "county" : "GREENE" },
            "12453": { "city" : "MALDEN ON HUDSON", "state" : "NY", "county" : "ULSTER" },
            "12454": { "city" : "MAPLECREST", "state" : "NY", "county" : "GREENE" },
            "12455": { "city" : "MARGARETVILLE", "state" : "NY", "county" : "DELAWARE" },
            "12456": { "city" : "MOUNT MARION", "state" : "NY", "county" : "ULSTER" },
            "12457": { "city" : "MOUNT TREMPER", "state" : "NY", "county" : "ULSTER" },
            "12458": { "city" : "NAPANOCH", "state" : "NY", "county" : "ULSTER" },
            "12459": { "city" : "NEW KINGSTON", "state" : "NY", "county" : "DELAWARE" },
            "12460": { "city" : "OAK HILL", "state" : "NY", "county" : "GREENE" },
            "12461": { "city" : "OLIVEBRIDGE", "state" : "NY", "county" : "ULSTER" },
            "12463": { "city" : "PALENVILLE", "state" : "NY", "county" : "GREENE" },
            "12464": { "city" : "PHOENICIA", "state" : "NY", "county" : "ULSTER" },
            "12465": { "city" : "PINE HILL", "state" : "NY", "county" : "ULSTER" },
            "12466": { "city" : "PORT EWEN", "state" : "NY", "county" : "ULSTER" },
            "12468": { "city" : "PRATTSVILLE", "state" : "NY", "county" : "GREENE" },
            "12469": { "city" : "PRESTON HOLLOW", "state" : "NY", "county" : "ALBANY" },
            "12470": { "city" : "PURLING", "state" : "NY", "county" : "GREENE" },
            "12471": { "city" : "RIFTON", "state" : "NY", "county" : "ULSTER" },"12472": { "city" : "ROSENDALE", "state" : "NY", "county" : "ULSTER" },
            "12473": { "city" : "ROUND TOP", "state" : "NY", "county" : "GREENE" },
            "12474": { "city" : "ROXBURY", "state" : "NY", "county" : "DELAWARE" },
            "12475": { "city" : "RUBY", "state" : "NY", "county" : "ULSTER" },"12477": { "city" : "SAUGERTIES", "state" : "NY", "county" : "ULSTER" },
            "12480": { "city" : "SHANDAKEN", "state" : "NY", "county" : "ULSTER" },
            "12481": { "city" : "SHOKAN", "state" : "NY", "county" : "ULSTER" },"12482": { "city" : "SOUTH CAIRO", "state" : "NY", "county" : "GREENE" },
            "12483": { "city" : "SPRING GLEN", "state" : "NY", "county" : "ULSTER" },
            "12484": { "city" : "STONE RIDGE", "state" : "NY", "county" : "ULSTER" },
            "12485": { "city" : "TANNERSVILLE", "state" : "NY", "county" : "GREENE" },
            "12486": { "city" : "TILLSON", "state" : "NY", "county" : "ULSTER" },
            "12487": { "city" : "ULSTER PARK", "state" : "NY", "county" : "ULSTER" },
            "12489": { "city" : "WAWARSING", "state" : "NY", "county" : "ULSTER" },
            "12490": { "city" : "WEST CAMP", "state" : "NY", "county" : "ULSTER" },
            "12491": { "city" : "WEST HURLEY", "state" : "NY", "county" : "ULSTER" },
            "12492": { "city" : "WEST KILL", "state" : "NY", "county" : "GREENE" },
            "12493": { "city" : "WEST PARK", "state" : "NY", "county" : "ULSTER" },
            "12494": { "city" : "WEST SHOKAN", "state" : "NY", "county" : "ULSTER" },
            "12495": { "city" : "WILLOW", "state" : "NY", "county" : "ULSTER" },"12496": { "city" : "WINDHAM", "state" : "NY", "county" : "GREENE" },
            "12498": { "city" : "WOODSTOCK", "state" : "NY", "county" : "ULSTER" },
            "12501": { "city" : "AMENIA", "state" : "NY", "county" : "DUTCHESS" },
            "12502": { "city" : "ANCRAM", "state" : "NY", "county" : "COLUMBIA" },
            "12503": { "city" : "ANCRAMDALE", "state" : "NY", "county" : "COLUMBIA" },
            "12504": { "city" : "ANNANDALE ON HUDSON", "state" : "NY", "county" : "DUTCHESS" },
            "12506": { "city" : "BANGALL", "state" : "NY", "county" : "DUTCHESS" },
            "12507": { "city" : "BARRYTOWN", "state" : "NY", "county" : "DUTCHESS" },
            "12508": { "city" : "BEACON", "state" : "NY", "county" : "DUTCHESS" },
            "12510": { "city" : "BILLINGS", "state" : "NY", "county" : "DUTCHESS" },
            "12511": { "city" : "CASTLE POINT", "state" : "NY", "county" : "DUTCHESS" },
            "12512": { "city" : "CHELSEA", "state" : "NY", "county" : "DUTCHESS" },
            "12513": { "city" : "CLAVERACK", "state" : "NY", "county" : "COLUMBIA" },
            "12514": { "city" : "CLINTON CORNERS", "state" : "NY", "county" : "DUTCHESS" },
            "12515": { "city" : "CLINTONDALE", "state" : "NY", "county" : "ULSTER" },
            "12516": { "city" : "COPAKE", "state" : "NY", "county" : "COLUMBIA" },
            "12517": { "city" : "COPAKE FALLS", "state" : "NY", "county" : "COLUMBIA" },
            "12518": { "city" : "CORNWALL", "state" : "NY", "county" : "ORANGE" },
            "12520": { "city" : "CORNWALL ON HUDSON", "state" : "NY", "county" : "ORANGE" },
            "12521": { "city" : "CRARYVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12522": { "city" : "DOVER PLAINS", "state" : "NY", "county" : "DUTCHESS" },
            "12523": { "city" : "ELIZAVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12524": { "city" : "FISHKILL", "state" : "NY", "county" : "DUTCHESS" },
            "12525": { "city" : "GARDINER", "state" : "NY", "county" : "ULSTER" },
            "12526": { "city" : "GERMANTOWN", "state" : "NY", "county" : "COLUMBIA" },
            "12527": { "city" : "GLENHAM", "state" : "NY", "county" : "DUTCHESS" },
            "12528": { "city" : "HIGHLAND", "state" : "NY", "county" : "ULSTER" },
            "12529": { "city" : "HILLSDALE", "state" : "NY", "county" : "COLUMBIA" },
            "12530": { "city" : "HOLLOWVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12531": { "city" : "HOLMES", "state" : "NY", "county" : "DUTCHESS" },
            "12533": { "city" : "HOPEWELL JUNCTION", "state" : "NY", "county" : "DUTCHESS" },
            "12534": { "city" : "HUDSON", "state" : "NY", "county" : "COLUMBIA" },
            "12537": { "city" : "HUGHSONVILLE", "state" : "NY", "county" : "DUTCHESS" },
            "12538": { "city" : "HYDE PARK", "state" : "NY", "county" : "DUTCHESS" },
            "12540": { "city" : "LAGRANGEVILLE", "state" : "NY", "county" : "DUTCHESS" },
            "12541": { "city" : "LIVINGSTON", "state" : "NY", "county" : "COLUMBIA" },
            "12542": { "city" : "MARLBORO", "state" : "NY", "county" : "ULSTER" },
            "12543": { "city" : "MAYBROOK", "state" : "NY", "county" : "ORANGE" },
            "12544": { "city" : "MELLENVILLE", "state" : "NY", "county" : "COLUMBIA" },
            "12545": { "city" : "MILLBROOK", "state" : "NY", "county" : "DUTCHESS" },
            "12546": { "city" : "MILLERTON", "state" : "NY", "county" : "DUTCHESS" },
            "12547": { "city" : "MILTON", "state" : "NY", "county" : "ULSTER" },"12548": { "city" : "MODENA", "state" : "NY", "county" : "ULSTER" },
            "12549": { "city" : "MONTGOMERY", "state" : "NY", "county" : "ORANGE" },
            "12550": { "city" : "NEWBURGH", "state" : "NY", "county" : "ORANGE" },
            "12551": { "city" : "NEWBURGH", "state" : "NY", "county" : "ORANGE" },
            "12552": { "city" : "NEWBURGH", "state" : "NY", "county" : "ORANGE" },
            "12553": { "city" : "NEW WINDSOR", "state" : "NY", "county" : "ORANGE" },
            "12555": { "city" : "NEWBURGH", "state" : "NY", "county" : "ORANGE" },
            "12561": { "city" : "NEW PALTZ", "state" : "NY", "county" : "ULSTER" },
            "12563": { "city" : "PATTERSON", "state" : "NY", "county" : "PUTNAM" },
            "12564": { "city" : "PAWLING", "state" : "NY", "county" : "DUTCHESS" },
            "12565": { "city" : "PHILMONT", "state" : "NY", "county" : "COLUMBIA" },
            "12566": { "city" : "PINE BUSH", "state" : "NY", "county" : "ORANGE" },
            "12567": { "city" : "PINE PLAINS", "state" : "NY", "county" : "DUTCHESS" },
            "12568": { "city" : "PLATTEKILL", "state" : "NY", "county" : "ULSTER" },
            "12569": { "city" : "PLEASANT VALLEY", "state" : "NY", "county" : "DUTCHESS" },
            "12570": { "city" : "POUGHQUAG", "state" : "NY", "county" : "DUTCHESS" },
            "12571": { "city" : "RED HOOK", "state" : "NY", "county" : "DUTCHESS" },
            "12572": { "city" : "RHINEBECK", "state" : "NY", "county" : "DUTCHESS" },
            "12574": { "city" : "RHINECLIFF", "state" : "NY", "county" : "DUTCHESS" },
            "12575": { "city" : "ROCK TAVERN", "state" : "NY", "county" : "ORANGE" },
            "12577": { "city" : "SALISBURY MILLS", "state" : "NY", "county" : "ORANGE" },
            "12578": { "city" : "SALT POINT", "state" : "NY", "county" : "DUTCHESS" },
            "12580": { "city" : "STAATSBURG", "state" : "NY", "county" : "DUTCHESS" },
            "12581": { "city" : "STANFORDVILLE", "state" : "NY", "county" : "DUTCHESS" },
            "12582": { "city" : "STORMVILLE", "state" : "NY", "county" : "DUTCHESS" },
            "12583": { "city" : "TIVOLI", "state" : "NY", "county" : "DUTCHESS" },
            "12584": { "city" : "VAILS GATE", "state" : "NY", "county" : "ORANGE" },
            "12585": { "city" : "VERBANK", "state" : "NY", "county" : "DUTCHESS" },
            "12586": { "city" : "WALDEN", "state" : "NY", "county" : "ORANGE" },"12588": { "city" : "WALKER VALLEY", "state" : "NY", "county" : "ULSTER" },
            "12589": { "city" : "WALLKILL", "state" : "NY", "county" : "ULSTER" },
            "12590": { "city" : "WAPPINGERS FALLS", "state" : "NY", "county" : "DUTCHESS" },
            "12592": { "city" : "WASSAIC", "state" : "NY", "county" : "DUTCHESS" },
            "12594": { "city" : "WINGDALE", "state" : "NY", "county" : "DUTCHESS" },
            "12601": { "city" : "POUGHKEEPSIE", "state" : "NY", "county" : "DUTCHESS" },
            "12602": { "city" : "POUGHKEEPSIE", "state" : "NY", "county" : "DUTCHESS" },
            "12603": { "city" : "POUGHKEEPSIE", "state" : "NY", "county" : "DUTCHESS" },
            "12604": { "city" : "POUGHKEEPSIE", "state" : "NY", "county" : "DUTCHESS" },
            "12701": { "city" : "MONTICELLO", "state" : "NY", "county" : "SULLIVAN" },
            "12719": { "city" : "BARRYVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12720": { "city" : "BETHEL", "state" : "NY", "county" : "SULLIVAN" },
            "12721": { "city" : "BLOOMINGBURG", "state" : "NY", "county" : "SULLIVAN" },
            "12722": { "city" : "BURLINGHAM", "state" : "NY", "county" : "SULLIVAN" },
            "12723": { "city" : "CALLICOON", "state" : "NY", "county" : "SULLIVAN" },
            "12724": { "city" : "CALLICOON CENTER", "state" : "NY", "county" : "SULLIVAN" },
            "12725": { "city" : "CLARYVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12726": { "city" : "COCHECTON", "state" : "NY", "county" : "SULLIVAN" },
            "12727": { "city" : "COCHECTON CENTER", "state" : "NY", "county" : "SULLIVAN" },
            "12729": { "city" : "CUDDEBACKVILLE", "state" : "NY", "county" : "ORANGE" },
            "12732": { "city" : "ELDRED", "state" : "NY", "county" : "SULLIVAN" },
            "12733": { "city" : "FALLSBURG", "state" : "NY", "county" : "SULLIVAN" },
            "12734": { "city" : "FERNDALE", "state" : "NY", "county" : "SULLIVAN" },
            "12736": { "city" : "FREMONT CENTER", "state" : "NY", "county" : "SULLIVAN" },
            "12737": { "city" : "GLEN SPEY", "state" : "NY", "county" : "SULLIVAN" },
            "12738": { "city" : "GLEN WILD", "state" : "NY", "county" : "SULLIVAN" },
            "12740": { "city" : "GRAHAMSVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12741": { "city" : "HANKINS", "state" : "NY", "county" : "SULLIVAN" },
            "12742": { "city" : "HARRIS", "state" : "NY", "county" : "SULLIVAN" },
            "12743": { "city" : "HIGHLAND LAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12745": { "city" : "HORTONVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12746": { "city" : "HUGUENOT", "state" : "NY", "county" : "ORANGE" },
            "12747": { "city" : "HURLEYVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12748": { "city" : "JEFFERSONVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12749": { "city" : "KAUNEONGA LAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12750": { "city" : "KENOZA LAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12751": { "city" : "KIAMESHA LAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12752": { "city" : "LAKE HUNTINGTON", "state" : "NY", "county" : "SULLIVAN" },
            "12754": { "city" : "LIBERTY", "state" : "NY", "county" : "SULLIVAN" },
            "12758": { "city" : "LIVINGSTON MANOR", "state" : "NY", "county" : "SULLIVAN" },
            "12759": { "city" : "LOCH SHELDRAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12760": { "city" : "LONG EDDY", "state" : "NY", "county" : "SULLIVAN" },
            "12762": { "city" : "MONGAUP VALLEY", "state" : "NY", "county" : "SULLIVAN" },
            "12763": { "city" : "MOUNTAIN DALE", "state" : "NY", "county" : "SULLIVAN" },
            "12764": { "city" : "NARROWSBURG", "state" : "NY", "county" : "SULLIVAN" },
            "12765": { "city" : "NEVERSINK", "state" : "NY", "county" : "SULLIVAN" },
            "12766": { "city" : "NORTH BRANCH", "state" : "NY", "county" : "SULLIVAN" },
            "12767": { "city" : "OBERNBURG", "state" : "NY", "county" : "SULLIVAN" },
            "12768": { "city" : "PARKSVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12770": { "city" : "POND EDDY", "state" : "NY", "county" : "SULLIVAN" },
            "12771": { "city" : "PORT JERVIS", "state" : "NY", "county" : "ORANGE" },
            "12775": { "city" : "ROCK HILL", "state" : "NY", "county" : "SULLIVAN" },
            "12776": { "city" : "ROSCOE", "state" : "NY", "county" : "SULLIVAN" },
            "12777": { "city" : "FORESTBURGH", "state" : "NY", "county" : "SULLIVAN" },
            "12778": { "city" : "SMALLWOOD", "state" : "NY", "county" : "SULLIVAN" },
            "12779": { "city" : "SOUTH FALLSBURG", "state" : "NY", "county" : "SULLIVAN" },
            "12780": { "city" : "SPARROW BUSH", "state" : "NY", "county" : "ORANGE" },
            "12781": { "city" : "SUMMITVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12783": { "city" : "SWAN LAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12784": { "city" : "THOMPSONVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12785": { "city" : "WESTBROOKVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12786": { "city" : "WHITE LAKE", "state" : "NY", "county" : "SULLIVAN" },
            "12787": { "city" : "WHITE SULPHUR SPRINGS", "state" : "NY", "county" : "SULLIVAN" },
            "12788": { "city" : "WOODBOURNE", "state" : "NY", "county" : "SULLIVAN" },
            "12789": { "city" : "WOODRIDGE", "state" : "NY", "county" : "SULLIVAN" },
            "12790": { "city" : "WURTSBORO", "state" : "NY", "county" : "SULLIVAN" },
            "12791": { "city" : "YOUNGSVILLE", "state" : "NY", "county" : "SULLIVAN" },
            "12792": { "city" : "YULAN", "state" : "NY", "county" : "SULLIVAN" },
            "12801": { "city" : "GLENS FALLS", "state" : "NY", "county" : "WARREN" },
            "12803": { "city" : "SOUTH GLENS FALLS", "state" : "NY", "county" : "SARATOGA" },
            "12804": { "city" : "QUEENSBURY", "state" : "NY", "county" : "WARREN" },
            "12808": { "city" : "ADIRONDACK", "state" : "NY", "county" : "WARREN" },
            "12809": { "city" : "ARGYLE", "state" : "NY", "county" : "WASHINGTON" },
            "12810": { "city" : "ATHOL", "state" : "NY", "county" : "WARREN" },"12811": { "city" : "BAKERS MILLS", "state" : "NY", "county" : "WARREN" },
            "12812": { "city" : "BLUE MOUNTAIN LAKE", "state" : "NY", "county" : "HAMILTON" },
            "12814": { "city" : "BOLTON LANDING", "state" : "NY", "county" : "WARREN" },
            "12815": { "city" : "BRANT LAKE", "state" : "NY", "county" : "WARREN" },
            "12816": { "city" : "CAMBRIDGE", "state" : "NY", "county" : "WASHINGTON" },
            "12817": { "city" : "CHESTERTOWN", "state" : "NY", "county" : "WARREN" },
            "12819": { "city" : "CLEMONS", "state" : "NY", "county" : "WASHINGTON" },
            "12820": { "city" : "CLEVERDALE", "state" : "NY", "county" : "WARREN" },
            "12821": { "city" : "COMSTOCK", "state" : "NY", "county" : "WASHINGTON" },
            "12822": { "city" : "CORINTH", "state" : "NY", "county" : "SARATOGA" },
            "12823": { "city" : "COSSAYUNA", "state" : "NY", "county" : "WASHINGTON" },
            "12824": { "city" : "DIAMOND POINT", "state" : "NY", "county" : "WARREN" },
            "12827": { "city" : "FORT ANN", "state" : "NY", "county" : "WASHINGTON" },
            "12828": { "city" : "FORT EDWARD", "state" : "NY", "county" : "WASHINGTON" },
            "12831": { "city" : "GANSEVOORT", "state" : "NY", "county" : "SARATOGA" },
            "12832": { "city" : "GRANVILLE", "state" : "NY", "county" : "WASHINGTON" },
            "12833": { "city" : "GREENFIELD CENTER", "state" : "NY", "county" : "SARATOGA" },
            "12834": { "city" : "GREENWICH", "state" : "NY", "county" : "WASHINGTON" },
            "12835": { "city" : "HADLEY", "state" : "NY", "county" : "SARATOGA" },
            "12836": { "city" : "HAGUE", "state" : "NY", "county" : "WARREN" },"12837": { "city" : "HAMPTON", "state" : "NY", "county" : "WASHINGTON" },
            "12838": { "city" : "HARTFORD", "state" : "NY", "county" : "WASHINGTON" },
            "12839": { "city" : "HUDSON FALLS", "state" : "NY", "county" : "WASHINGTON" },
            "12841": { "city" : "HULETTS LANDING", "state" : "NY", "county" : "WASHINGTON" },
            "12842": { "city" : "INDIAN LAKE", "state" : "NY", "county" : "HAMILTON" },
            "12843": { "city" : "JOHNSBURG", "state" : "NY", "county" : "WARREN" },
            "12844": { "city" : "KATTSKILL BAY", "state" : "NY", "county" : "WARREN" },
            "12845": { "city" : "LAKE GEORGE", "state" : "NY", "county" : "WARREN" },
            "12846": { "city" : "LAKE LUZERNE", "state" : "NY", "county" : "WARREN" },
            "12847": { "city" : "LONG LAKE", "state" : "NY", "county" : "HAMILTON" },
            "12848": { "city" : "MIDDLE FALLS", "state" : "NY", "county" : "WASHINGTON" },
            "12849": { "city" : "MIDDLE GRANVILLE", "state" : "NY", "county" : "WASHINGTON" },
            "12850": { "city" : "MIDDLE GROVE", "state" : "NY", "county" : "SARATOGA" },
            "12851": { "city" : "MINERVA", "state" : "NY", "county" : "ESSEX" },"12852": { "city" : "NEWCOMB", "state" : "NY", "county" : "ESSEX" },
            "12853": { "city" : "NORTH CREEK", "state" : "NY", "county" : "WARREN" },
            "12854": { "city" : "NORTH GRANVILLE", "state" : "NY", "county" : "WASHINGTON" },
            "12855": { "city" : "NORTH HUDSON", "state" : "NY", "county" : "ESSEX" },
            "12856": { "city" : "NORTH RIVER", "state" : "NY", "county" : "WARREN" },
            "12857": { "city" : "OLMSTEDVILLE", "state" : "NY", "county" : "ESSEX" },
            "12858": { "city" : "PARADOX", "state" : "NY", "county" : "ESSEX" },"12859": { "city" : "PORTER CORNERS", "state" : "NY", "county" : "SARATOGA" },
            "12860": { "city" : "POTTERSVILLE", "state" : "NY", "county" : "WARREN" },
            "12861": { "city" : "PUTNAM STATION", "state" : "NY", "county" : "WASHINGTON" },
            "12862": { "city" : "RIPARIUS", "state" : "NY", "county" : "WARREN" },
            "12863": { "city" : "ROCK CITY FALLS", "state" : "NY", "county" : "SARATOGA" },
            "12864": { "city" : "SABAEL", "state" : "NY", "county" : "HAMILTON" },
            "12865": { "city" : "SALEM", "state" : "NY", "county" : "WASHINGTON" },
            "12866": { "city" : "SARATOGA SPRINGS", "state" : "NY", "county" : "SARATOGA" },
            "12870": { "city" : "SCHROON LAKE", "state" : "NY", "county" : "ESSEX" },
            "12871": { "city" : "SCHUYLERVILLE", "state" : "NY", "county" : "SARATOGA" },
            "12872": { "city" : "SEVERANCE", "state" : "NY", "county" : "ESSEX" },
            "12873": { "city" : "SHUSHAN", "state" : "NY", "county" : "WASHINGTON" },
            "12874": { "city" : "SILVER BAY", "state" : "NY", "county" : "WARREN" },
            "12878": { "city" : "STONY CREEK", "state" : "NY", "county" : "WARREN" },
            "12883": { "city" : "TICONDEROGA", "state" : "NY", "county" : "ESSEX" },
            "12884": { "city" : "VICTORY MILLS", "state" : "NY", "county" : "SARATOGA" },
            "12885": { "city" : "WARRENSBURG", "state" : "NY", "county" : "WARREN" },
            "12886": { "city" : "WEVERTOWN", "state" : "NY", "county" : "WARREN" },
            "12887": { "city" : "WHITEHALL", "state" : "NY", "county" : "WASHINGTON" },
            "12901": { "city" : "PLATTSBURGH", "state" : "NY", "county" : "CLINTON" },
            "12903": { "city" : "PLATTSBURGH", "state" : "NY", "county" : "CLINTON" },
            "12910": { "city" : "ALTONA", "state" : "NY", "county" : "CLINTON" },
            "12911": { "city" : "KEESEVILLE", "state" : "NY", "county" : "CLINTON" },
            "12912": { "city" : "AU SABLE FORKS", "state" : "NY", "county" : "CLINTON" },
            "12913": { "city" : "BLOOMINGDALE", "state" : "NY", "county" : "ESSEX" },
            "12914": { "city" : "BOMBAY", "state" : "NY", "county" : "FRANKLIN" },
            "12915": { "city" : "BRAINARDSVILLE", "state" : "NY", "county" : "FRANKLIN" },
            "12916": { "city" : "BRUSHTON", "state" : "NY", "county" : "FRANKLIN" },
            "12917": { "city" : "BURKE", "state" : "NY", "county" : "FRANKLIN" },
            "12918": { "city" : "CADYVILLE", "state" : "NY", "county" : "CLINTON" },
            "12919": { "city" : "CHAMPLAIN", "state" : "NY", "county" : "CLINTON" },
            "12920": { "city" : "CHATEAUGAY", "state" : "NY", "county" : "FRANKLIN" },
            "12921": { "city" : "CHAZY", "state" : "NY", "county" : "CLINTON" },"12922": { "city" : "CHILDWOLD", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "12923": { "city" : "CHURUBUSCO", "state" : "NY", "county" : "CLINTON" },
            "12924": { "city" : "KEESEVILLE", "state" : "NY", "county" : "CLINTON" },
            "12926": { "city" : "CONSTABLE", "state" : "NY", "county" : "FRANKLIN" },
            "12927": { "city" : "CRANBERRY LAKE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "12928": { "city" : "CROWN POINT", "state" : "NY", "county" : "ESSEX" },
            "12929": { "city" : "DANNEMORA", "state" : "NY", "county" : "CLINTON" },
            "12930": { "city" : "DICKINSON CENTER", "state" : "NY", "county" : "FRANKLIN" },
            "12932": { "city" : "ELIZABETHTOWN", "state" : "NY", "county" : "ESSEX" },
            "12933": { "city" : "ELLENBURG", "state" : "NY", "county" : "CLINTON" },
            "12934": { "city" : "ELLENBURG CENTER", "state" : "NY", "county" : "CLINTON" },
            "12935": { "city" : "ELLENBURG DEPOT", "state" : "NY", "county" : "CLINTON" },
            "12936": { "city" : "ESSEX", "state" : "NY", "county" : "ESSEX" },"12937": { "city" : "FORT COVINGTON", "state" : "NY", "county" : "FRANKLIN" },
            "12939": { "city" : "GABRIELS", "state" : "NY", "county" : "FRANKLIN" },
            "12941": { "city" : "JAY", "state" : "NY", "county" : "ESSEX" },"12942": { "city" : "KEENE", "state" : "NY", "county" : "ESSEX" },
            "12943": { "city" : "KEENE VALLEY", "state" : "NY", "county" : "ESSEX" },
            "12944": { "city" : "KEESEVILLE", "state" : "NY", "county" : "CLINTON" },
            "12945": { "city" : "LAKE CLEAR", "state" : "NY", "county" : "FRANKLIN" },
            "12946": { "city" : "LAKE PLACID", "state" : "NY", "county" : "ESSEX" },
            "12949": { "city" : "LAWRENCEVILLE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "12950": { "city" : "LEWIS", "state" : "NY", "county" : "ESSEX" },"12952": { "city" : "LYON MOUNTAIN", "state" : "NY", "county" : "CLINTON" },
            "12953": { "city" : "MALONE", "state" : "NY", "county" : "FRANKLIN" },
            "12955": { "city" : "LYON MOUNTAIN", "state" : "NY", "county" : "CLINTON" },
            "12956": { "city" : "MINEVILLE", "state" : "NY", "county" : "ESSEX" },
            "12957": { "city" : "MOIRA", "state" : "NY", "county" : "FRANKLIN" },
            "12958": { "city" : "MOOERS", "state" : "NY", "county" : "CLINTON" },
            "12959": { "city" : "MOOERS FORKS", "state" : "NY", "county" : "CLINTON" },
            "12960": { "city" : "MORIAH", "state" : "NY", "county" : "ESSEX" },"12961": { "city" : "MORIAH CENTER", "state" : "NY", "county" : "ESSEX" },
            "12962": { "city" : "MORRISONVILLE", "state" : "NY", "county" : "CLINTON" },
            "12964": { "city" : "NEW RUSSIA", "state" : "NY", "county" : "ESSEX" },
            "12965": { "city" : "NICHOLVILLE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "12966": { "city" : "NORTH BANGOR", "state" : "NY", "county" : "FRANKLIN" },
            "12967": { "city" : "NORTH LAWRENCE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "12969": { "city" : "OWLS HEAD", "state" : "NY", "county" : "FRANKLIN" },
            "12970": { "city" : "PAUL SMITHS", "state" : "NY", "county" : "FRANKLIN" },
            "12972": { "city" : "PERU", "state" : "NY", "county" : "CLINTON" },"12973": { "city" : "PIERCEFIELD", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "12974": { "city" : "PORT HENRY", "state" : "NY", "county" : "ESSEX" },
            "12975": { "city" : "PORT KENT", "state" : "NY", "county" : "ESSEX" },
            "12976": { "city" : "RAINBOW LAKE", "state" : "NY", "county" : "FRANKLIN" },
            "12977": { "city" : "RAY BROOK", "state" : "NY", "county" : "ESSEX" },
            "12978": { "city" : "REDFORD", "state" : "NY", "county" : "CLINTON" },
            "12979": { "city" : "ROUSES POINT", "state" : "NY", "county" : "CLINTON" },
            "12980": { "city" : "SAINT REGIS FALLS", "state" : "NY", "county" : "FRANKLIN" },
            "12981": { "city" : "SARANAC", "state" : "NY", "county" : "CLINTON" },
            "12983": { "city" : "SARANAC LAKE", "state" : "NY", "county" : "FRANKLIN" },
            "12985": { "city" : "SCHUYLER FALLS", "state" : "NY", "county" : "CLINTON" },
            "12986": { "city" : "TUPPER LAKE", "state" : "NY", "county" : "FRANKLIN" },
            "12987": { "city" : "UPPER JAY", "state" : "NY", "county" : "ESSEX" },
            "12989": { "city" : "VERMONTVILLE", "state" : "NY", "county" : "FRANKLIN" },
            "12992": { "city" : "WEST CHAZY", "state" : "NY", "county" : "CLINTON" },
            "12993": { "city" : "WESTPORT", "state" : "NY", "county" : "ESSEX" },
            "12996": { "city" : "WILLSBORO", "state" : "NY", "county" : "ESSEX" },
            "12997": { "city" : "WILMINGTON", "state" : "NY", "county" : "ESSEX" },
            "12998": { "city" : "WITHERBEE", "state" : "NY", "county" : "ESSEX" },
            "13020": { "city" : "APULIA STATION", "state" : "NY", "county" : "ONONDAGA" },
            "13021": { "city" : "AUBURN", "state" : "NY", "county" : "CAYUGA" },"13022": { "city" : "AUBURN", "state" : "NY", "county" : "CAYUGA" },
            "13024": { "city" : "AUBURN", "state" : "NY", "county" : "CAYUGA" },"13026": { "city" : "AURORA", "state" : "NY", "county" : "CAYUGA" },
            "13027": { "city" : "BALDWINSVILLE", "state" : "NY", "county" : "ONONDAGA" },
            "13028": { "city" : "BERNHARDS BAY", "state" : "NY", "county" : "OSWEGO" },
            "13029": { "city" : "BREWERTON", "state" : "NY", "county" : "ONONDAGA" },
            "13030": { "city" : "BRIDGEPORT", "state" : "NY", "county" : "ONONDAGA" },
            "13031": { "city" : "CAMILLUS", "state" : "NY", "county" : "ONONDAGA" },
            "13032": { "city" : "CANASTOTA", "state" : "NY", "county" : "MADISON" },
            "13033": { "city" : "CATO", "state" : "NY", "county" : "CAYUGA" },"13034": { "city" : "CAYUGA", "state" : "NY", "county" : "CAYUGA" },
            "13035": { "city" : "CAZENOVIA", "state" : "NY", "county" : "MADISON" },
            "13036": { "city" : "CENTRAL SQUARE", "state" : "NY", "county" : "OSWEGO" },
            "13037": { "city" : "CHITTENANGO", "state" : "NY", "county" : "MADISON" },
            "13039": { "city" : "CICERO", "state" : "NY", "county" : "ONONDAGA" },
            "13040": { "city" : "CINCINNATUS", "state" : "NY", "county" : "CORTLAND" },
            "13041": { "city" : "CLAY", "state" : "NY", "county" : "ONONDAGA" },"13042": { "city" : "CLEVELAND", "state" : "NY", "county" : "OSWEGO" },
            "13043": { "city" : "CLOCKVILLE", "state" : "NY", "county" : "MADISON" },
            "13044": { "city" : "CONSTANTIA", "state" : "NY", "county" : "OSWEGO" },
            "13045": { "city" : "CORTLAND", "state" : "NY", "county" : "CORTLAND" },
            "13051": { "city" : "DELPHI FALLS", "state" : "NY", "county" : "ONONDAGA" },
            "13052": { "city" : "DE RUYTER", "state" : "NY", "county" : "MADISON" },
            "13053": { "city" : "DRYDEN", "state" : "NY", "county" : "TOMPKINS" },
            "13054": { "city" : "DURHAMVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13057": { "city" : "EAST SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13060": { "city" : "ELBRIDGE", "state" : "NY", "county" : "ONONDAGA" },
            "13061": { "city" : "ERIEVILLE", "state" : "NY", "county" : "MADISON" },
            "13063": { "city" : "FABIUS", "state" : "NY", "county" : "ONONDAGA" },
            "13064": { "city" : "FAIR HAVEN", "state" : "NY", "county" : "CAYUGA" },
            "13065": { "city" : "FAYETTE", "state" : "NY", "county" : "SENECA" },
            "13066": { "city" : "FAYETTEVILLE", "state" : "NY", "county" : "ONONDAGA" },
            "13068": { "city" : "FREEVILLE", "state" : "NY", "county" : "TOMPKINS" },
            "13069": { "city" : "FULTON", "state" : "NY", "county" : "OSWEGO" },"13071": { "city" : "GENOA", "state" : "NY", "county" : "CAYUGA" },
            "13072": { "city" : "GEORGETOWN", "state" : "NY", "county" : "MADISON" },
            "13073": { "city" : "GROTON", "state" : "NY", "county" : "TOMPKINS" },
            "13074": { "city" : "HANNIBAL", "state" : "NY", "county" : "OSWEGO" },
            "13076": { "city" : "HASTINGS", "state" : "NY", "county" : "OSWEGO" },
            "13077": { "city" : "HOMER", "state" : "NY", "county" : "CORTLAND" },
            "13078": { "city" : "JAMESVILLE", "state" : "NY", "county" : "ONONDAGA" },
            "13080": { "city" : "JORDAN", "state" : "NY", "county" : "ONONDAGA" },
            "13081": { "city" : "KING FERRY", "state" : "NY", "county" : "CAYUGA" },
            "13082": { "city" : "KIRKVILLE", "state" : "NY", "county" : "ONONDAGA" },
            "13083": { "city" : "LACONA", "state" : "NY", "county" : "OSWEGO" },"13084": { "city" : "LA FAYETTE", "state" : "NY", "county" : "ONONDAGA" },
            "13087": { "city" : "LITTLE YORK", "state" : "NY", "county" : "CORTLAND" },
            "13088": { "city" : "LIVERPOOL", "state" : "NY", "county" : "ONONDAGA" },
            "13089": { "city" : "LIVERPOOL", "state" : "NY", "county" : "ONONDAGA" },
            "13090": { "city" : "LIVERPOOL", "state" : "NY", "county" : "ONONDAGA" },
            "13092": { "city" : "LOCKE", "state" : "NY", "county" : "CAYUGA" },"13093": { "city" : "LYCOMING", "state" : "NY", "county" : "OSWEGO" },
            "13101": { "city" : "MC GRAW", "state" : "NY", "county" : "CORTLAND" },
            "13102": { "city" : "MC LEAN", "state" : "NY", "county" : "TOMPKINS" },
            "13103": { "city" : "MALLORY", "state" : "NY", "county" : "OSWEGO" },
            "13104": { "city" : "MANLIUS", "state" : "NY", "county" : "ONONDAGA" },
            "13107": { "city" : "MAPLE VIEW", "state" : "NY", "county" : "OSWEGO" },
            "13108": { "city" : "MARCELLUS", "state" : "NY", "county" : "ONONDAGA" },
            "13110": { "city" : "MARIETTA", "state" : "NY", "county" : "ONONDAGA" },
            "13111": { "city" : "MARTVILLE", "state" : "NY", "county" : "CAYUGA" },
            "13112": { "city" : "MEMPHIS", "state" : "NY", "county" : "ONONDAGA" },
            "13113": { "city" : "MERIDIAN", "state" : "NY", "county" : "CAYUGA" },
            "13114": { "city" : "MEXICO", "state" : "NY", "county" : "OSWEGO" },"13115": { "city" : "MINETTO", "state" : "NY", "county" : "OSWEGO" },
            "13116": { "city" : "MINOA", "state" : "NY", "county" : "ONONDAGA" },
            "13117": { "city" : "MONTEZUMA", "state" : "NY", "county" : "CAYUGA" },
            "13118": { "city" : "MORAVIA", "state" : "NY", "county" : "CAYUGA" },
            "13119": { "city" : "MOTTVILLE", "state" : "NY", "county" : "ONONDAGA" },
            "13120": { "city" : "NEDROW", "state" : "NY", "county" : "ONONDAGA" },
            "13121": { "city" : "NEW HAVEN", "state" : "NY", "county" : "OSWEGO" },
            "13122": { "city" : "NEW WOODSTOCK", "state" : "NY", "county" : "MADISON" },
            "13123": { "city" : "NORTH BAY", "state" : "NY", "county" : "ONEIDA" },
            "13124": { "city" : "NORTH PITCHER", "state" : "NY", "county" : "CHENANGO" },
            "13126": { "city" : "OSWEGO", "state" : "NY", "county" : "OSWEGO" },"13131": { "city" : "PARISH", "state" : "NY", "county" : "OSWEGO" },
            "13132": { "city" : "PENNELLVILLE", "state" : "NY", "county" : "OSWEGO" },
            "13135": { "city" : "PHOENIX", "state" : "NY", "county" : "OSWEGO" },
            "13136": { "city" : "PITCHER", "state" : "NY", "county" : "CHENANGO" },
            "13137": { "city" : "PLAINVILLE", "state" : "NY", "county" : "ONONDAGA" },
            "13138": { "city" : "POMPEY", "state" : "NY", "county" : "ONONDAGA" },
            "13139": { "city" : "POPLAR RIDGE", "state" : "NY", "county" : "CAYUGA" },
            "13140": { "city" : "PORT BYRON", "state" : "NY", "county" : "CAYUGA" },
            "13141": { "city" : "PREBLE", "state" : "NY", "county" : "CORTLAND" },
            "13142": { "city" : "PULASKI", "state" : "NY", "county" : "OSWEGO" },
            "13143": { "city" : "RED CREEK", "state" : "NY", "county" : "WAYNE" },
            "13144": { "city" : "RICHLAND", "state" : "NY", "county" : "OSWEGO" },
            "13145": { "city" : "SANDY CREEK", "state" : "NY", "county" : "OSWEGO" },
            "13146": { "city" : "SAVANNAH", "state" : "NY", "county" : "WAYNE" },
            "13147": { "city" : "SCIPIO CENTER", "state" : "NY", "county" : "CAYUGA" },
            "13148": { "city" : "SENECA FALLS", "state" : "NY", "county" : "SENECA" },
            "13152": { "city" : "SKANEATELES", "state" : "NY", "county" : "ONONDAGA" },
            "13153": { "city" : "SKANEATELES FALLS", "state" : "NY", "county" : "ONONDAGA" },
            "13154": { "city" : "SOUTH BUTLER", "state" : "NY", "county" : "WAYNE" },
            "13155": { "city" : "SOUTH OTSELIC", "state" : "NY", "county" : "CHENANGO" },
            "13156": { "city" : "STERLING", "state" : "NY", "county" : "CAYUGA" },
            "13157": { "city" : "SYLVAN BEACH", "state" : "NY", "county" : "ONEIDA" },
            "13158": { "city" : "TRUXTON", "state" : "NY", "county" : "CORTLAND" },
            "13159": { "city" : "TULLY", "state" : "NY", "county" : "ONONDAGA" },
            "13160": { "city" : "UNION SPRINGS", "state" : "NY", "county" : "CAYUGA" },
            "13162": { "city" : "VERONA BEACH", "state" : "NY", "county" : "ONEIDA" },
            "13163": { "city" : "WAMPSVILLE", "state" : "NY", "county" : "MADISON" },
            "13164": { "city" : "WARNERS", "state" : "NY", "county" : "ONONDAGA" },
            "13165": { "city" : "WATERLOO", "state" : "NY", "county" : "SENECA" },
            "13166": { "city" : "WEEDSPORT", "state" : "NY", "county" : "CAYUGA" },
            "13167": { "city" : "WEST MONROE", "state" : "NY", "county" : "OSWEGO" },
            "13201": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13202": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13203": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13204": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13205": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13206": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13207": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13208": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13209": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13210": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13211": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13212": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13214": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13215": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13217": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13218": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13219": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13220": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13221": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13224": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13244": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13250": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13261": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13290": { "city" : "SYRACUSE", "state" : "NY", "county" : "ONONDAGA" },
            "13301": { "city" : "ALDER CREEK", "state" : "NY", "county" : "ONEIDA" },
            "13302": { "city" : "ALTMAR", "state" : "NY", "county" : "OSWEGO" },"13303": { "city" : "AVA", "state" : "NY", "county" : "ONEIDA" },
            "13304": { "city" : "BARNEVELD", "state" : "NY", "county" : "ONEIDA" },
            "13305": { "city" : "BEAVER FALLS", "state" : "NY", "county" : "LEWIS" },
            "13308": { "city" : "BLOSSVALE", "state" : "NY", "county" : "ONEIDA" },
            "13309": { "city" : "BOONVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13310": { "city" : "BOUCKVILLE", "state" : "NY", "county" : "MADISON" },
            "13312": { "city" : "BRANTINGHAM", "state" : "NY", "county" : "LEWIS" },
            "13313": { "city" : "BRIDGEWATER", "state" : "NY", "county" : "ONEIDA" },
            "13314": { "city" : "BROOKFIELD", "state" : "NY", "county" : "MADISON" },
            "13315": { "city" : "BURLINGTON FLATS", "state" : "NY", "county" : "OTSEGO" },
            "13316": { "city" : "CAMDEN", "state" : "NY", "county" : "ONEIDA" },"13317": { "city" : "CANAJOHARIE", "state" : "NY", "county" : "MONTGOMERY" },
            "13318": { "city" : "CASSVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13319": { "city" : "CHADWICKS", "state" : "NY", "county" : "ONEIDA" },
            "13320": { "city" : "CHERRY VALLEY", "state" : "NY", "county" : "OTSEGO" },
            "13321": { "city" : "CLARK MILLS", "state" : "NY", "county" : "ONEIDA" },
            "13322": { "city" : "CLAYVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13323": { "city" : "CLINTON", "state" : "NY", "county" : "ONEIDA" },
            "13324": { "city" : "COLD BROOK", "state" : "NY", "county" : "HERKIMER" },
            "13325": { "city" : "CONSTABLEVILLE", "state" : "NY", "county" : "LEWIS" },
            "13326": { "city" : "COOPERSTOWN", "state" : "NY", "county" : "OTSEGO" },
            "13327": { "city" : "CROGHAN", "state" : "NY", "county" : "LEWIS" },"13328": { "city" : "DEANSBORO", "state" : "NY", "county" : "ONEIDA" },
            "13329": { "city" : "DOLGEVILLE", "state" : "NY", "county" : "HERKIMER" },
            "13331": { "city" : "EAGLE BAY", "state" : "NY", "county" : "HERKIMER" },
            "13332": { "city" : "EARLVILLE", "state" : "NY", "county" : "CHENANGO" },
            "13333": { "city" : "EAST SPRINGFIELD", "state" : "NY", "county" : "OTSEGO" },
            "13334": { "city" : "EATON", "state" : "NY", "county" : "MADISON" },"13335": { "city" : "EDMESTON", "state" : "NY", "county" : "OTSEGO" },
            "13337": { "city" : "FLY CREEK", "state" : "NY", "county" : "OTSEGO" },
            "13338": { "city" : "FORESTPORT", "state" : "NY", "county" : "ONEIDA" },
            "13339": { "city" : "FORT PLAIN", "state" : "NY", "county" : "MONTGOMERY" },
            "13340": { "city" : "FRANKFORT", "state" : "NY", "county" : "HERKIMER" },
            "13341": { "city" : "FRANKLIN SPRINGS", "state" : "NY", "county" : "ONEIDA" },
            "13342": { "city" : "GARRATTSVILLE", "state" : "NY", "county" : "OTSEGO" },
            "13343": { "city" : "GLENFIELD", "state" : "NY", "county" : "LEWIS" },
            "13345": { "city" : "GREIG", "state" : "NY", "county" : "LEWIS" },"13346": { "city" : "HAMILTON", "state" : "NY", "county" : "MADISON" },
            "13348": { "city" : "HARTWICK", "state" : "NY", "county" : "OTSEGO" },
            "13350": { "city" : "HERKIMER", "state" : "NY", "county" : "HERKIMER" },
            "13352": { "city" : "HINCKLEY", "state" : "NY", "county" : "ONEIDA" },
            "13353": { "city" : "HOFFMEISTER", "state" : "NY", "county" : "HAMILTON" },
            "13354": { "city" : "HOLLAND PATENT", "state" : "NY", "county" : "ONEIDA" },
            "13355": { "city" : "HUBBARDSVILLE", "state" : "NY", "county" : "MADISON" },
            "13357": { "city" : "ILION", "state" : "NY", "county" : "HERKIMER" },
            "13360": { "city" : "INLET", "state" : "NY", "county" : "HAMILTON" },
            "13361": { "city" : "JORDANVILLE", "state" : "NY", "county" : "HERKIMER" },
            "13362": { "city" : "KNOXBORO", "state" : "NY", "county" : "ONEIDA" },
            "13363": { "city" : "LEE CENTER", "state" : "NY", "county" : "ONEIDA" },
            "13364": { "city" : "LEONARDSVILLE", "state" : "NY", "county" : "MADISON" },
            "13365": { "city" : "LITTLE FALLS", "state" : "NY", "county" : "HERKIMER" },
            "13367": { "city" : "LOWVILLE", "state" : "NY", "county" : "LEWIS" },
            "13368": { "city" : "LYONS FALLS", "state" : "NY", "county" : "LEWIS" },
            "13401": { "city" : "MC CONNELLSVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13402": { "city" : "MADISON", "state" : "NY", "county" : "MADISON" },
            "13403": { "city" : "MARCY", "state" : "NY", "county" : "ONEIDA" },"13404": { "city" : "MARTINSBURG", "state" : "NY", "county" : "LEWIS" },
            "13406": { "city" : "MIDDLEVILLE", "state" : "NY", "county" : "HERKIMER" },
            "13407": { "city" : "MOHAWK", "state" : "NY", "county" : "HERKIMER" },
            "13408": { "city" : "MORRISVILLE", "state" : "NY", "county" : "MADISON" },
            "13409": { "city" : "MUNNSVILLE", "state" : "NY", "county" : "MADISON" },
            "13410": { "city" : "NELLISTON", "state" : "NY", "county" : "MONTGOMERY" },
            "13411": { "city" : "NEW BERLIN", "state" : "NY", "county" : "CHENANGO" },
            "13413": { "city" : "NEW HARTFORD", "state" : "NY", "county" : "ONEIDA" },
            "13416": { "city" : "NEWPORT", "state" : "NY", "county" : "HERKIMER" },
            "13417": { "city" : "NEW YORK MILLS", "state" : "NY", "county" : "ONEIDA" },
            "13418": { "city" : "NORTH BROOKFIELD", "state" : "NY", "county" : "MADISON" },
            "13420": { "city" : "OLD FORGE", "state" : "NY", "county" : "HERKIMER" },
            "13421": { "city" : "ONEIDA", "state" : "NY", "county" : "MADISON" },
            "13424": { "city" : "ORISKANY", "state" : "NY", "county" : "ONEIDA" },
            "13425": { "city" : "ORISKANY FALLS", "state" : "NY", "county" : "ONEIDA" },
            "13426": { "city" : "ORWELL", "state" : "NY", "county" : "OSWEGO" },"13428": { "city" : "PALATINE BRIDGE", "state" : "NY", "county" : "MONTGOMERY" },
            "13431": { "city" : "POLAND", "state" : "NY", "county" : "HERKIMER" },
            "13433": { "city" : "PORT LEYDEN", "state" : "NY", "county" : "LEWIS" },
            "13435": { "city" : "PROSPECT", "state" : "NY", "county" : "ONEIDA" },
            "13436": { "city" : "RAQUETTE LAKE", "state" : "NY", "county" : "HAMILTON" },
            "13437": { "city" : "REDFIELD", "state" : "NY", "county" : "OSWEGO" },
            "13438": { "city" : "REMSEN", "state" : "NY", "county" : "ONEIDA" },"13439": { "city" : "RICHFIELD SPRINGS", "state" : "NY", "county" : "OTSEGO" },
            "13440": { "city" : "ROME", "state" : "NY", "county" : "ONEIDA" },"13441": { "city" : "ROME", "state" : "NY", "county" : "ONEIDA" },
            "13442": { "city" : "ROME", "state" : "NY", "county" : "ONEIDA" },"13450": { "city" : "ROSEBOOM", "state" : "NY", "county" : "OTSEGO" },
            "13452": { "city" : "SAINT JOHNSVILLE", "state" : "NY", "county" : "MONTGOMERY" },
            "13454": { "city" : "SALISBURY CENTER", "state" : "NY", "county" : "HERKIMER" },
            "13455": { "city" : "SANGERFIELD", "state" : "NY", "county" : "ONEIDA" },
            "13456": { "city" : "SAUQUOIT", "state" : "NY", "county" : "ONEIDA" },
            "13457": { "city" : "SCHUYLER LAKE", "state" : "NY", "county" : "OTSEGO" },
            "13459": { "city" : "SHARON SPRINGS", "state" : "NY", "county" : "SCHOHARIE" },
            "13460": { "city" : "SHERBURNE", "state" : "NY", "county" : "CHENANGO" },
            "13461": { "city" : "SHERRILL", "state" : "NY", "county" : "ONEIDA" },
            "13464": { "city" : "SMYRNA", "state" : "NY", "county" : "CHENANGO" },
            "13465": { "city" : "SOLSVILLE", "state" : "NY", "county" : "MADISON" },
            "13468": { "city" : "SPRINGFIELD CENTER", "state" : "NY", "county" : "OTSEGO" },
            "13469": { "city" : "STITTVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13470": { "city" : "STRATFORD", "state" : "NY", "county" : "FULTON" },
            "13471": { "city" : "TABERG", "state" : "NY", "county" : "ONEIDA" },"13472": { "city" : "THENDARA", "state" : "NY", "county" : "HERKIMER" },
            "13473": { "city" : "TURIN", "state" : "NY", "county" : "LEWIS" },"13475": { "city" : "VAN HORNESVILLE", "state" : "NY", "county" : "HERKIMER" },
            "13476": { "city" : "VERNON", "state" : "NY", "county" : "ONEIDA" },"13477": { "city" : "VERNON CENTER", "state" : "NY", "county" : "ONEIDA" },
            "13478": { "city" : "VERONA", "state" : "NY", "county" : "ONEIDA" },"13479": { "city" : "WASHINGTON MILLS", "state" : "NY", "county" : "ONEIDA" },
            "13480": { "city" : "WATERVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13482": { "city" : "WEST BURLINGTON", "state" : "NY", "county" : "OTSEGO" },
            "13483": { "city" : "WESTDALE", "state" : "NY", "county" : "ONEIDA" },
            "13484": { "city" : "WEST EATON", "state" : "NY", "county" : "MADISON" },
            "13485": { "city" : "WEST EDMESTON", "state" : "NY", "county" : "MADISON" },
            "13486": { "city" : "WESTERNVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13488": { "city" : "WESTFORD", "state" : "NY", "county" : "OTSEGO" },
            "13489": { "city" : "WEST LEYDEN", "state" : "NY", "county" : "LEWIS" },
            "13490": { "city" : "WESTMORELAND", "state" : "NY", "county" : "ONEIDA" },
            "13491": { "city" : "WEST WINFIELD", "state" : "NY", "county" : "HERKIMER" },
            "13492": { "city" : "WHITESBORO", "state" : "NY", "county" : "ONEIDA" },
            "13493": { "city" : "WILLIAMSTOWN", "state" : "NY", "county" : "OSWEGO" },
            "13494": { "city" : "WOODGATE", "state" : "NY", "county" : "ONEIDA" },
            "13495": { "city" : "YORKVILLE", "state" : "NY", "county" : "ONEIDA" },
            "13501": { "city" : "UTICA", "state" : "NY", "county" : "ONEIDA" },"13502": { "city" : "UTICA", "state" : "NY", "county" : "ONEIDA" },
            "13503": { "city" : "UTICA", "state" : "NY", "county" : "ONEIDA" },"13504": { "city" : "UTICA", "state" : "NY", "county" : "ONEIDA" },
            "13505": { "city" : "UTICA", "state" : "NY", "county" : "ONEIDA" },"13601": { "city" : "WATERTOWN", "state" : "NY", "county" : "JEFFERSON" },
            "13602": { "city" : "FORT DRUM", "state" : "NY", "county" : "JEFFERSON" },
            "13603": { "city" : "WATERTOWN", "state" : "NY", "county" : "JEFFERSON" },
            "13605": { "city" : "ADAMS", "state" : "NY", "county" : "JEFFERSON" },
            "13606": { "city" : "ADAMS CENTER", "state" : "NY", "county" : "JEFFERSON" },
            "13607": { "city" : "ALEXANDRIA BAY", "state" : "NY", "county" : "JEFFERSON" },
            "13608": { "city" : "ANTWERP", "state" : "NY", "county" : "JEFFERSON" },
            "13611": { "city" : "BELLEVILLE", "state" : "NY", "county" : "JEFFERSON" },
            "13612": { "city" : "BLACK RIVER", "state" : "NY", "county" : "JEFFERSON" },
            "13613": { "city" : "BRASHER FALLS", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13614": { "city" : "BRIER HILL", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13615": { "city" : "BROWNVILLE", "state" : "NY", "county" : "JEFFERSON" },
            "13616": { "city" : "CALCIUM", "state" : "NY", "county" : "JEFFERSON" },
            "13617": { "city" : "CANTON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13618": { "city" : "CAPE VINCENT", "state" : "NY", "county" : "JEFFERSON" },
            "13619": { "city" : "CARTHAGE", "state" : "NY", "county" : "JEFFERSON" },
            "13620": { "city" : "CASTORLAND", "state" : "NY", "county" : "LEWIS" },
            "13621": { "city" : "CHASE MILLS", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13622": { "city" : "CHAUMONT", "state" : "NY", "county" : "JEFFERSON" },
            "13623": { "city" : "CHIPPEWA BAY", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13624": { "city" : "CLAYTON", "state" : "NY", "county" : "JEFFERSON" },
            "13625": { "city" : "COLTON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13626": { "city" : "COPENHAGEN", "state" : "NY", "county" : "LEWIS" },
            "13627": { "city" : "DEER RIVER", "state" : "NY", "county" : "LEWIS" },
            "13628": { "city" : "DEFERIET", "state" : "NY", "county" : "JEFFERSON" },
            "13630": { "city" : "DE KALB JUNCTION", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13631": { "city" : "DENMARK", "state" : "NY", "county" : "LEWIS" },"13632": { "city" : "DEPAUVILLE", "state" : "NY", "county" : "JEFFERSON" },
            "13633": { "city" : "DE PEYSTER", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13634": { "city" : "DEXTER", "state" : "NY", "county" : "JEFFERSON" },
            "13635": { "city" : "EDWARDS", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13636": { "city" : "ELLISBURG", "state" : "NY", "county" : "JEFFERSON" },
            "13637": { "city" : "EVANS MILLS", "state" : "NY", "county" : "JEFFERSON" },
            "13638": { "city" : "FELTS MILLS", "state" : "NY", "county" : "JEFFERSON" },
            "13639": { "city" : "FINE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13640": { "city" : "WELLESLEY ISLAND", "state" : "NY", "county" : "JEFFERSON" },
            "13641": { "city" : "FISHERS LANDING", "state" : "NY", "county" : "JEFFERSON" },
            "13642": { "city" : "GOUVERNEUR", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13643": { "city" : "GREAT BEND", "state" : "NY", "county" : "JEFFERSON" },
            "13645": { "city" : "HAILESBORO", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13646": { "city" : "HAMMOND", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13647": { "city" : "HANNAWA FALLS", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13648": { "city" : "HARRISVILLE", "state" : "NY", "county" : "LEWIS" },
            "13649": { "city" : "HELENA", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13650": { "city" : "HENDERSON", "state" : "NY", "county" : "JEFFERSON" },
            "13651": { "city" : "HENDERSON HARBOR", "state" : "NY", "county" : "JEFFERSON" },
            "13652": { "city" : "HERMON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13654": { "city" : "HEUVELTON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13655": { "city" : "HOGANSBURG", "state" : "NY", "county" : "FRANKLIN" },
            "13656": { "city" : "LA FARGEVILLE", "state" : "NY", "county" : "JEFFERSON" },
            "13658": { "city" : "LISBON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13659": { "city" : "LORRAINE", "state" : "NY", "county" : "JEFFERSON" },
            "13660": { "city" : "MADRID", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13661": { "city" : "MANNSVILLE", "state" : "NY", "county" : "JEFFERSON" },
            "13662": { "city" : "MASSENA", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13664": { "city" : "MORRISTOWN", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13665": { "city" : "NATURAL BRIDGE", "state" : "NY", "county" : "JEFFERSON" },
            "13666": { "city" : "NEWTON FALLS", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13667": { "city" : "NORFOLK", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13668": { "city" : "NORWOOD", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13669": { "city" : "OGDENSBURG", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13670": { "city" : "OSWEGATCHIE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13671": { "city" : "OXBOW", "state" : "NY", "county" : "JEFFERSON" },
            "13672": { "city" : "PARISHVILLE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13673": { "city" : "PHILADELPHIA", "state" : "NY", "county" : "JEFFERSON" },
            "13674": { "city" : "PIERREPONT MANOR", "state" : "NY", "county" : "JEFFERSON" },
            "13675": { "city" : "PLESSIS", "state" : "NY", "county" : "JEFFERSON" },
            "13676": { "city" : "POTSDAM", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13678": { "city" : "RAYMONDVILLE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13679": { "city" : "REDWOOD", "state" : "NY", "county" : "JEFFERSON" },
            "13680": { "city" : "RENSSELAER FALLS", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13681": { "city" : "RICHVILLE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13682": { "city" : "RODMAN", "state" : "NY", "county" : "JEFFERSON" },
            "13683": { "city" : "ROOSEVELTOWN", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13684": { "city" : "RUSSELL", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13685": { "city" : "SACKETS HARBOR", "state" : "NY", "county" : "JEFFERSON" },
            "13687": { "city" : "SOUTH COLTON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13690": { "city" : "STAR LAKE", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13691": { "city" : "THERESA", "state" : "NY", "county" : "JEFFERSON" },
            "13692": { "city" : "THOUSAND ISLAND PARK", "state" : "NY", "county" : "JEFFERSON" },
            "13693": { "city" : "THREE MILE BAY", "state" : "NY", "county" : "JEFFERSON" },
            "13694": { "city" : "WADDINGTON", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13695": { "city" : "WANAKENA", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13696": { "city" : "WEST STOCKHOLM", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13697": { "city" : "WINTHROP", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13699": { "city" : "POTSDAM", "state" : "NY", "county" : "SAINT LAWRENCE" },
            "13730": { "city" : "AFTON", "state" : "NY", "county" : "CHENANGO" },
            "13731": { "city" : "ANDES", "state" : "NY", "county" : "DELAWARE" },
            "13732": { "city" : "APALACHIN", "state" : "NY", "county" : "TIOGA" },
            "13733": { "city" : "BAINBRIDGE", "state" : "NY", "county" : "CHENANGO" },
            "13734": { "city" : "BARTON", "state" : "NY", "county" : "TIOGA" },"13736": { "city" : "BERKSHIRE", "state" : "NY", "county" : "TIOGA" },
            "13738": { "city" : "BLODGETT MILLS", "state" : "NY", "county" : "CORTLAND" },
            "13739": { "city" : "BLOOMVILLE", "state" : "NY", "county" : "DELAWARE" },
            "13740": { "city" : "BOVINA CENTER", "state" : "NY", "county" : "DELAWARE" },
            "13743": { "city" : "CANDOR", "state" : "NY", "county" : "TIOGA" },"13744": { "city" : "CASTLE CREEK", "state" : "NY", "county" : "BROOME" },
            "13745": { "city" : "CHENANGO BRIDGE", "state" : "NY", "county" : "BROOME" },
            "13746": { "city" : "CHENANGO FORKS", "state" : "NY", "county" : "BROOME" },
            "13747": { "city" : "COLLIERSVILLE", "state" : "NY", "county" : "OTSEGO" },
            "13748": { "city" : "CONKLIN", "state" : "NY", "county" : "BROOME" },
            "13750": { "city" : "DAVENPORT", "state" : "NY", "county" : "DELAWARE" },
            "13751": { "city" : "DAVENPORT CENTER", "state" : "NY", "county" : "DELAWARE" },
            "13752": { "city" : "DELANCEY", "state" : "NY", "county" : "DELAWARE" },
            "13753": { "city" : "DELHI", "state" : "NY", "county" : "DELAWARE" },
            "13754": { "city" : "DEPOSIT", "state" : "NY", "county" : "BROOME" },
            "13755": { "city" : "DOWNSVILLE", "state" : "NY", "county" : "DELAWARE" },
            "13756": { "city" : "EAST BRANCH", "state" : "NY", "county" : "DELAWARE" },
            "13757": { "city" : "EAST MEREDITH", "state" : "NY", "county" : "DELAWARE" },
            "13760": { "city" : "ENDICOTT", "state" : "NY", "county" : "BROOME" },
            "13761": { "city" : "ENDICOTT", "state" : "NY", "county" : "BROOME" },
            "13762": { "city" : "ENDWELL", "state" : "NY", "county" : "BROOME" },
            "13763": { "city" : "ENDICOTT", "state" : "NY", "county" : "BROOME" },
            "13774": { "city" : "FISHS EDDY", "state" : "NY", "county" : "DELAWARE" },
            "13775": { "city" : "FRANKLIN", "state" : "NY", "county" : "DELAWARE" },
            "13776": { "city" : "GILBERTSVILLE", "state" : "NY", "county" : "OTSEGO" },
            "13777": { "city" : "GLEN AUBREY", "state" : "NY", "county" : "BROOME" },
            "13778": { "city" : "GREENE", "state" : "NY", "county" : "CHENANGO" },
            "13780": { "city" : "GUILFORD", "state" : "NY", "county" : "CHENANGO" },
            "13782": { "city" : "HAMDEN", "state" : "NY", "county" : "DELAWARE" },
            "13783": { "city" : "HANCOCK", "state" : "NY", "county" : "DELAWARE" },
            "13784": { "city" : "HARFORD", "state" : "NY", "county" : "CORTLAND" },
            "13786": { "city" : "HARPERSFIELD", "state" : "NY", "county" : "DELAWARE" },
            "13787": { "city" : "HARPURSVILLE", "state" : "NY", "county" : "BROOME" },
            "13788": { "city" : "HOBART", "state" : "NY", "county" : "DELAWARE" },
            "13790": { "city" : "JOHNSON CITY", "state" : "NY", "county" : "BROOME" },
            "13794": { "city" : "KILLAWOG", "state" : "NY", "county" : "BROOME" },
            "13795": { "city" : "KIRKWOOD", "state" : "NY", "county" : "BROOME" },
            "13796": { "city" : "LAURENS", "state" : "NY", "county" : "OTSEGO" },
            "13797": { "city" : "LISLE", "state" : "NY", "county" : "BROOME" },"13801": { "city" : "MC DONOUGH", "state" : "NY", "county" : "CHENANGO" },
            "13802": { "city" : "MAINE", "state" : "NY", "county" : "BROOME" },"13803": { "city" : "MARATHON", "state" : "NY", "county" : "CORTLAND" },
            "13804": { "city" : "MASONVILLE", "state" : "NY", "county" : "DELAWARE" },
            "13807": { "city" : "MILFORD", "state" : "NY", "county" : "OTSEGO" },
            "13808": { "city" : "MORRIS", "state" : "NY", "county" : "OTSEGO" },"13809": { "city" : "MOUNT UPTON", "state" : "NY", "county" : "CHENANGO" },
            "13810": { "city" : "MOUNT VISION", "state" : "NY", "county" : "OTSEGO" },
            "13811": { "city" : "NEWARK VALLEY", "state" : "NY", "county" : "TIOGA" },
            "13812": { "city" : "NICHOLS", "state" : "NY", "county" : "TIOGA" },"13813": { "city" : "NINEVEH", "state" : "NY", "county" : "BROOME" },
            "13814": { "city" : "NORTH NORWICH", "state" : "NY", "county" : "CHENANGO" },
            "13815": { "city" : "NORWICH", "state" : "NY", "county" : "CHENANGO" },
            "13820": { "city" : "ONEONTA", "state" : "NY", "county" : "OTSEGO" },
            "13825": { "city" : "OTEGO", "state" : "NY", "county" : "OTSEGO" },"13826": { "city" : "OUAQUAGA", "state" : "NY", "county" : "BROOME" },
            "13827": { "city" : "OWEGO", "state" : "NY", "county" : "TIOGA" },"13830": { "city" : "OXFORD", "state" : "NY", "county" : "CHENANGO" },
            "13832": { "city" : "PLYMOUTH", "state" : "NY", "county" : "CHENANGO" },
            "13833": { "city" : "PORT CRANE", "state" : "NY", "county" : "BROOME" },
            "13834": { "city" : "PORTLANDVILLE", "state" : "NY", "county" : "OTSEGO" },
            "13835": { "city" : "RICHFORD", "state" : "NY", "county" : "TIOGA" },
            "13838": { "city" : "SIDNEY", "state" : "NY", "county" : "DELAWARE" },
            "13839": { "city" : "SIDNEY CENTER", "state" : "NY", "county" : "DELAWARE" },
            "13840": { "city" : "SMITHBORO", "state" : "NY", "county" : "TIOGA" },
            "13841": { "city" : "SMITHVILLE FLATS", "state" : "NY", "county" : "CHENANGO" },
            "13842": { "city" : "SOUTH KORTRIGHT", "state" : "NY", "county" : "DELAWARE" },
            "13843": { "city" : "SOUTH NEW BERLIN", "state" : "NY", "county" : "CHENANGO" },
            "13844": { "city" : "SOUTH PLYMOUTH", "state" : "NY", "county" : "CHENANGO" },
            "13845": { "city" : "TIOGA CENTER", "state" : "NY", "county" : "TIOGA" },
            "13846": { "city" : "TREADWELL", "state" : "NY", "county" : "DELAWARE" },
            "13847": { "city" : "TROUT CREEK", "state" : "NY", "county" : "DELAWARE" },
            "13848": { "city" : "TUNNEL", "state" : "NY", "county" : "BROOME" },"13849": { "city" : "UNADILLA", "state" : "NY", "county" : "OTSEGO" },
            "13850": { "city" : "VESTAL", "state" : "NY", "county" : "BROOME" },"13851": { "city" : "VESTAL", "state" : "NY", "county" : "BROOME" },
            "13856": { "city" : "WALTON", "state" : "NY", "county" : "DELAWARE" },
            "13859": { "city" : "WELLS BRIDGE", "state" : "NY", "county" : "OTSEGO" },
            "13860": { "city" : "WEST DAVENPORT", "state" : "NY", "county" : "DELAWARE" },
            "13861": { "city" : "WEST ONEONTA", "state" : "NY", "county" : "OTSEGO" },
            "13862": { "city" : "WHITNEY POINT", "state" : "NY", "county" : "BROOME" },
            "13863": { "city" : "WILLET", "state" : "NY", "county" : "CORTLAND" },
            "13864": { "city" : "WILLSEYVILLE", "state" : "NY", "county" : "TIOGA" },
            "13865": { "city" : "WINDSOR", "state" : "NY", "county" : "BROOME" },
            "13901": { "city" : "BINGHAMTON", "state" : "NY", "county" : "BROOME" },
            "13902": { "city" : "BINGHAMTON", "state" : "NY", "county" : "BROOME" },
            "13903": { "city" : "BINGHAMTON", "state" : "NY", "county" : "BROOME" },
            "13904": { "city" : "BINGHAMTON", "state" : "NY", "county" : "BROOME" },
            "13905": { "city" : "BINGHAMTON", "state" : "NY", "county" : "BROOME" },
            "14001": { "city" : "AKRON", "state" : "NY", "county" : "ERIE" },"14004": { "city" : "ALDEN", "state" : "NY", "county" : "ERIE" },
            "14005": { "city" : "ALEXANDER", "state" : "NY", "county" : "GENESEE" },
            "14006": { "city" : "ANGOLA", "state" : "NY", "county" : "ERIE" },"14008": { "city" : "APPLETON", "state" : "NY", "county" : "NIAGARA" },
            "14009": { "city" : "ARCADE", "state" : "NY", "county" : "WYOMING" },
            "14010": { "city" : "ATHOL SPRINGS", "state" : "NY", "county" : "ERIE" },
            "14011": { "city" : "ATTICA", "state" : "NY", "county" : "WYOMING" },
            "14012": { "city" : "BARKER", "state" : "NY", "county" : "NIAGARA" },
            "14013": { "city" : "BASOM", "state" : "NY", "county" : "GENESEE" },"14020": { "city" : "BATAVIA", "state" : "NY", "county" : "GENESEE" },
            "14021": { "city" : "BATAVIA", "state" : "NY", "county" : "GENESEE" },
            "14024": { "city" : "BLISS", "state" : "NY", "county" : "WYOMING" },"14025": { "city" : "BOSTON", "state" : "NY", "county" : "ERIE" },
            "14026": { "city" : "BOWMANSVILLE", "state" : "NY", "county" : "ERIE" },
            "14027": { "city" : "BRANT", "state" : "NY", "county" : "ERIE" },"14028": { "city" : "BURT", "state" : "NY", "county" : "NIAGARA" },
            "14029": { "city" : "CENTERVILLE", "state" : "NY", "county" : "ALLEGANY" },
            "14030": { "city" : "CHAFFEE", "state" : "NY", "county" : "ERIE" },"14031": { "city" : "CLARENCE", "state" : "NY", "county" : "ERIE" },
            "14032": { "city" : "CLARENCE CENTER", "state" : "NY", "county" : "ERIE" },
            "14033": { "city" : "COLDEN", "state" : "NY", "county" : "ERIE" },"14034": { "city" : "COLLINS", "state" : "NY", "county" : "ERIE" },
            "14035": { "city" : "COLLINS CENTER", "state" : "NY", "county" : "ERIE" },
            "14036": { "city" : "CORFU", "state" : "NY", "county" : "GENESEE" },"14037": { "city" : "COWLESVILLE", "state" : "NY", "county" : "WYOMING" },
            "14038": { "city" : "CRITTENDEN", "state" : "NY", "county" : "ERIE" },
            "14039": { "city" : "DALE", "state" : "NY", "county" : "WYOMING" },"14040": { "city" : "DARIEN CENTER", "state" : "NY", "county" : "GENESEE" },
            "14041": { "city" : "DAYTON", "state" : "NY", "county" : "CATTARAUGUS" },
            "14042": { "city" : "DELEVAN", "state" : "NY", "county" : "CATTARAUGUS" },
            "14043": { "city" : "DEPEW", "state" : "NY", "county" : "ERIE" },"14047": { "city" : "DERBY", "state" : "NY", "county" : "ERIE" },
            "14048": { "city" : "DUNKIRK", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14051": { "city" : "EAST AMHERST", "state" : "NY", "county" : "ERIE" },
            "14052": { "city" : "EAST AURORA", "state" : "NY", "county" : "ERIE" },
            "14054": { "city" : "EAST BETHANY", "state" : "NY", "county" : "GENESEE" },
            "14055": { "city" : "EAST CONCORD", "state" : "NY", "county" : "ERIE" },
            "14056": { "city" : "EAST PEMBROKE", "state" : "NY", "county" : "GENESEE" },
            "14057": { "city" : "EDEN", "state" : "NY", "county" : "ERIE" },"14058": { "city" : "ELBA", "state" : "NY", "county" : "GENESEE" },
            "14059": { "city" : "ELMA", "state" : "NY", "county" : "ERIE" },"14060": { "city" : "FARMERSVILLE STATION", "state" : "NY", "county" : "CATTARAUGUS" },
            "14061": { "city" : "FARNHAM", "state" : "NY", "county" : "ERIE" },"14062": { "city" : "FORESTVILLE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14063": { "city" : "FREDONIA", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14065": { "city" : "FREEDOM", "state" : "NY", "county" : "CATTARAUGUS" },
            "14066": { "city" : "GAINESVILLE", "state" : "NY", "county" : "WYOMING" },
            "14067": { "city" : "GASPORT", "state" : "NY", "county" : "NIAGARA" },
            "14068": { "city" : "GETZVILLE", "state" : "NY", "county" : "ERIE" },
            "14069": { "city" : "GLENWOOD", "state" : "NY", "county" : "ERIE" },"14070": { "city" : "GOWANDA", "state" : "NY", "county" : "CATTARAUGUS" },
            "14072": { "city" : "GRAND ISLAND", "state" : "NY", "county" : "ERIE" },
            "14075": { "city" : "HAMBURG", "state" : "NY", "county" : "ERIE" },"14080": { "city" : "HOLLAND", "state" : "NY", "county" : "ERIE" },
            "14081": { "city" : "IRVING", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14082": { "city" : "JAVA CENTER", "state" : "NY", "county" : "WYOMING" },
            "14083": { "city" : "JAVA VILLAGE", "state" : "NY", "county" : "WYOMING" },
            "14085": { "city" : "LAKE VIEW", "state" : "NY", "county" : "ERIE" },
            "14086": { "city" : "LANCASTER", "state" : "NY", "county" : "ERIE" },
            "14091": { "city" : "LAWTONS", "state" : "NY", "county" : "ERIE" },"14092": { "city" : "LEWISTON", "state" : "NY", "county" : "NIAGARA" },
            "14094": { "city" : "LOCKPORT", "state" : "NY", "county" : "NIAGARA" },
            "14095": { "city" : "LOCKPORT", "state" : "NY", "county" : "NIAGARA" },
            "14098": { "city" : "LYNDONVILLE", "state" : "NY", "county" : "ORLEANS" },
            "14101": { "city" : "MACHIAS", "state" : "NY", "county" : "CATTARAUGUS" },
            "14102": { "city" : "MARILLA", "state" : "NY", "county" : "ERIE" },"14103": { "city" : "MEDINA", "state" : "NY", "county" : "ORLEANS" },
            "14105": { "city" : "MIDDLEPORT", "state" : "NY", "county" : "NIAGARA" },
            "14107": { "city" : "MODEL CITY", "state" : "NY", "county" : "NIAGARA" },
            "14108": { "city" : "NEWFANE", "state" : "NY", "county" : "NIAGARA" },
            "14109": { "city" : "NIAGARA UNIVERSITY", "state" : "NY", "county" : "NIAGARA" },
            "14110": { "city" : "NORTH BOSTON", "state" : "NY", "county" : "ERIE" },
            "14111": { "city" : "NORTH COLLINS", "state" : "NY", "county" : "ERIE" },
            "14112": { "city" : "NORTH EVANS", "state" : "NY", "county" : "ERIE" },
            "14113": { "city" : "NORTH JAVA", "state" : "NY", "county" : "WYOMING" },
            "14120": { "city" : "NORTH TONAWANDA", "state" : "NY", "county" : "NIAGARA" },
            "14125": { "city" : "OAKFIELD", "state" : "NY", "county" : "GENESEE" },
            "14126": { "city" : "OLCOTT", "state" : "NY", "county" : "NIAGARA" },
            "14127": { "city" : "ORCHARD PARK", "state" : "NY", "county" : "ERIE" },
            "14129": { "city" : "PERRYSBURG", "state" : "NY", "county" : "CATTARAUGUS" },
            "14130": { "city" : "PIKE", "state" : "NY", "county" : "WYOMING" },"14131": { "city" : "RANSOMVILLE", "state" : "NY", "county" : "NIAGARA" },
            "14132": { "city" : "SANBORN", "state" : "NY", "county" : "NIAGARA" },
            "14133": { "city" : "SANDUSKY", "state" : "NY", "county" : "CATTARAUGUS" },
            "14134": { "city" : "SARDINIA", "state" : "NY", "county" : "ERIE" },"14135": { "city" : "SHERIDAN", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14136": { "city" : "SILVER CREEK", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14138": { "city" : "SOUTH DAYTON", "state" : "NY", "county" : "CATTARAUGUS" },
            "14139": { "city" : "SOUTH WALES", "state" : "NY", "county" : "ERIE" },
            "14140": { "city" : "SPRING BROOK", "state" : "NY", "county" : "ERIE" },
            "14141": { "city" : "SPRINGVILLE", "state" : "NY", "county" : "ERIE" },
            "14143": { "city" : "STAFFORD", "state" : "NY", "county" : "GENESEE" },
            "14144": { "city" : "STELLA NIAGARA", "state" : "NY", "county" : "NIAGARA" },
            "14145": { "city" : "STRYKERSVILLE", "state" : "NY", "county" : "WYOMING" },
            "14150": { "city" : "TONAWANDA", "state" : "NY", "county" : "ERIE" },
            "14151": { "city" : "TONAWANDA", "state" : "NY", "county" : "ERIE" },
            "14166": { "city" : "VAN BUREN POINT", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14167": { "city" : "VARYSBURG", "state" : "NY", "county" : "WYOMING" },
            "14169": { "city" : "WALES CENTER", "state" : "NY", "county" : "ERIE" },
            "14170": { "city" : "WEST FALLS", "state" : "NY", "county" : "ERIE" },
            "14171": { "city" : "WEST VALLEY", "state" : "NY", "county" : "CATTARAUGUS" },
            "14172": { "city" : "WILSON", "state" : "NY", "county" : "NIAGARA" },
            "14173": { "city" : "YORKSHIRE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14174": { "city" : "YOUNGSTOWN", "state" : "NY", "county" : "NIAGARA" },
            "14201": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14202": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14203": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14204": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14205": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14206": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14207": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14208": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14209": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14210": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14211": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14212": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14213": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14214": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14215": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14216": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14217": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14218": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14219": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14220": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14221": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14222": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14223": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14224": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14225": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14226": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14227": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14228": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14231": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14240": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14260": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14261": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14263": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14270": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14272": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },"14273": { "city" : "BUFFALO", "state" : "NY", "county" : "ERIE" },
            "14301": { "city" : "NIAGARA FALLS", "state" : "NY", "county" : "NIAGARA" },
            "14302": { "city" : "NIAGARA FALLS", "state" : "NY", "county" : "NIAGARA" },
            "14303": { "city" : "NIAGARA FALLS", "state" : "NY", "county" : "NIAGARA" },
            "14304": { "city" : "NIAGARA FALLS", "state" : "NY", "county" : "NIAGARA" },
            "14305": { "city" : "NIAGARA FALLS", "state" : "NY", "county" : "NIAGARA" },
            "14410": { "city" : "ADAMS BASIN", "state" : "NY", "county" : "MONROE" },
            "14411": { "city" : "ALBION", "state" : "NY", "county" : "ORLEANS" },
            "14413": { "city" : "ALTON", "state" : "NY", "county" : "WAYNE" },"14414": { "city" : "AVON", "state" : "NY", "county" : "LIVINGSTON" },
            "14415": { "city" : "BELLONA", "state" : "NY", "county" : "YATES" },"14416": { "city" : "BERGEN", "state" : "NY", "county" : "GENESEE" },
            "14418": { "city" : "BRANCHPORT", "state" : "NY", "county" : "YATES" },
            "14420": { "city" : "BROCKPORT", "state" : "NY", "county" : "MONROE" },
            "14422": { "city" : "BYRON", "state" : "NY", "county" : "GENESEE" },"14423": { "city" : "CALEDONIA", "state" : "NY", "county" : "LIVINGSTON" },
            "14424": { "city" : "CANANDAIGUA", "state" : "NY", "county" : "ONTARIO" },
            "14425": { "city" : "FARMINGTON", "state" : "NY", "county" : "ONTARIO" },
            "14427": { "city" : "CASTILE", "state" : "NY", "county" : "WYOMING" },
            "14428": { "city" : "CHURCHVILLE", "state" : "NY", "county" : "MONROE" },
            "14429": { "city" : "CLARENDON", "state" : "NY", "county" : "ORLEANS" },
            "14430": { "city" : "CLARKSON", "state" : "NY", "county" : "MONROE" },
            "14432": { "city" : "CLIFTON SPRINGS", "state" : "NY", "county" : "ONTARIO" },
            "14433": { "city" : "CLYDE", "state" : "NY", "county" : "WAYNE" },"14435": { "city" : "CONESUS", "state" : "NY", "county" : "LIVINGSTON" },
            "14437": { "city" : "DANSVILLE", "state" : "NY", "county" : "LIVINGSTON" },
            "14441": { "city" : "DRESDEN", "state" : "NY", "county" : "YATES" },"14443": { "city" : "EAST BLOOMFIELD", "state" : "NY", "county" : "ONTARIO" },
            "14445": { "city" : "EAST ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14449": { "city" : "EAST WILLIAMSON", "state" : "NY", "county" : "WAYNE" },
            "14450": { "city" : "FAIRPORT", "state" : "NY", "county" : "MONROE" },
            "14452": { "city" : "FANCHER", "state" : "NY", "county" : "ORLEANS" },
            "14453": { "city" : "FISHERS", "state" : "NY", "county" : "ONTARIO" },
            "14454": { "city" : "GENESEO", "state" : "NY", "county" : "LIVINGSTON" },
            "14456": { "city" : "GENEVA", "state" : "NY", "county" : "ONTARIO" },
            "14461": { "city" : "GORHAM", "state" : "NY", "county" : "ONTARIO" },
            "14462": { "city" : "GROVELAND", "state" : "NY", "county" : "LIVINGSTON" },
            "14463": { "city" : "HALL", "state" : "NY", "county" : "ONTARIO" },"14464": { "city" : "HAMLIN", "state" : "NY", "county" : "MONROE" },
            "14466": { "city" : "HEMLOCK", "state" : "NY", "county" : "LIVINGSTON" },
            "14467": { "city" : "HENRIETTA", "state" : "NY", "county" : "MONROE" },
            "14468": { "city" : "HILTON", "state" : "NY", "county" : "MONROE" },"14469": { "city" : "BLOOMFIELD", "state" : "NY", "county" : "ONTARIO" },
            "14470": { "city" : "HOLLEY", "state" : "NY", "county" : "ORLEANS" },
            "14471": { "city" : "HONEOYE", "state" : "NY", "county" : "ONTARIO" },
            "14472": { "city" : "HONEOYE FALLS", "state" : "NY", "county" : "MONROE" },
            "14475": { "city" : "IONIA", "state" : "NY", "county" : "ONTARIO" },"14476": { "city" : "KENDALL", "state" : "NY", "county" : "ORLEANS" },
            "14477": { "city" : "KENT", "state" : "NY", "county" : "ORLEANS" },"14478": { "city" : "KEUKA PARK", "state" : "NY", "county" : "YATES" },
            "14479": { "city" : "KNOWLESVILLE", "state" : "NY", "county" : "ORLEANS" },
            "14480": { "city" : "LAKEVILLE", "state" : "NY", "county" : "LIVINGSTON" },
            "14481": { "city" : "LEICESTER", "state" : "NY", "county" : "LIVINGSTON" },
            "14482": { "city" : "LE ROY", "state" : "NY", "county" : "GENESEE" },
            "14485": { "city" : "LIMA", "state" : "NY", "county" : "LIVINGSTON" },
            "14486": { "city" : "LINWOOD", "state" : "NY", "county" : "GENESEE" },
            "14487": { "city" : "LIVONIA", "state" : "NY", "county" : "LIVINGSTON" },
            "14488": { "city" : "LIVONIA CENTER", "state" : "NY", "county" : "LIVINGSTON" },
            "14489": { "city" : "LYONS", "state" : "NY", "county" : "WAYNE" },"14502": { "city" : "MACEDON", "state" : "NY", "county" : "WAYNE" },
            "14504": { "city" : "MANCHESTER", "state" : "NY", "county" : "ONTARIO" },
            "14505": { "city" : "MARION", "state" : "NY", "county" : "WAYNE" },"14506": { "city" : "MENDON", "state" : "NY", "county" : "MONROE" },
            "14507": { "city" : "MIDDLESEX", "state" : "NY", "county" : "YATES" },
            "14508": { "city" : "MORTON", "state" : "NY", "county" : "MONROE" },"14510": { "city" : "MOUNT MORRIS", "state" : "NY", "county" : "LIVINGSTON" },
            "14511": { "city" : "MUMFORD", "state" : "NY", "county" : "MONROE" },
            "14512": { "city" : "NAPLES", "state" : "NY", "county" : "ONTARIO" },
            "14513": { "city" : "NEWARK", "state" : "NY", "county" : "WAYNE" },"14514": { "city" : "NORTH CHILI", "state" : "NY", "county" : "MONROE" },
            "14515": { "city" : "NORTH GREECE", "state" : "NY", "county" : "MONROE" },
            "14516": { "city" : "NORTH ROSE", "state" : "NY", "county" : "WAYNE" },
            "14517": { "city" : "NUNDA", "state" : "NY", "county" : "LIVINGSTON" },
            "14518": { "city" : "OAKS CORNERS", "state" : "NY", "county" : "ONTARIO" },
            "14519": { "city" : "ONTARIO", "state" : "NY", "county" : "WAYNE" },"14520": { "city" : "ONTARIO CENTER", "state" : "NY", "county" : "WAYNE" },
            "14521": { "city" : "OVID", "state" : "NY", "county" : "SENECA" },"14522": { "city" : "PALMYRA", "state" : "NY", "county" : "WAYNE" },
            "14525": { "city" : "PAVILION", "state" : "NY", "county" : "GENESEE" },
            "14526": { "city" : "PENFIELD", "state" : "NY", "county" : "MONROE" },
            "14527": { "city" : "PENN YAN", "state" : "NY", "county" : "YATES" },
            "14529": { "city" : "PERKINSVILLE", "state" : "NY", "county" : "STEUBEN" },
            "14530": { "city" : "PERRY", "state" : "NY", "county" : "WYOMING" },"14532": { "city" : "PHELPS", "state" : "NY", "county" : "ONTARIO" },
            "14533": { "city" : "PIFFARD", "state" : "NY", "county" : "LIVINGSTON" },
            "14534": { "city" : "PITTSFORD", "state" : "NY", "county" : "MONROE" },
            "14536": { "city" : "PORTAGEVILLE", "state" : "NY", "county" : "WYOMING" },
            "14537": { "city" : "PORT GIBSON", "state" : "NY", "county" : "ONTARIO" },
            "14538": { "city" : "PULTNEYVILLE", "state" : "NY", "county" : "WAYNE" },
            "14539": { "city" : "RETSOF", "state" : "NY", "county" : "LIVINGSTON" },
            "14541": { "city" : "ROMULUS", "state" : "NY", "county" : "SENECA" },
            "14542": { "city" : "ROSE", "state" : "NY", "county" : "WAYNE" },"14543": { "city" : "RUSH", "state" : "NY", "county" : "MONROE" },
            "14544": { "city" : "RUSHVILLE", "state" : "NY", "county" : "YATES" },
            "14545": { "city" : "SCOTTSBURG", "state" : "NY", "county" : "LIVINGSTON" },
            "14546": { "city" : "SCOTTSVILLE", "state" : "NY", "county" : "MONROE" },
            "14547": { "city" : "SENECA CASTLE", "state" : "NY", "county" : "ONTARIO" },
            "14548": { "city" : "SHORTSVILLE", "state" : "NY", "county" : "ONTARIO" },
            "14549": { "city" : "SILVER LAKE", "state" : "NY", "county" : "WYOMING" },
            "14550": { "city" : "SILVER SPRINGS", "state" : "NY", "county" : "WYOMING" },
            "14551": { "city" : "SODUS", "state" : "NY", "county" : "WAYNE" },"14555": { "city" : "SODUS POINT", "state" : "NY", "county" : "WAYNE" },
            "14556": { "city" : "SONYEA", "state" : "NY", "county" : "LIVINGSTON" },
            "14557": { "city" : "SOUTH BYRON", "state" : "NY", "county" : "GENESEE" },
            "14558": { "city" : "SOUTH LIMA", "state" : "NY", "county" : "LIVINGSTON" },
            "14559": { "city" : "SPENCERPORT", "state" : "NY", "county" : "MONROE" },
            "14560": { "city" : "SPRINGWATER", "state" : "NY", "county" : "LIVINGSTON" },
            "14561": { "city" : "STANLEY", "state" : "NY", "county" : "ONTARIO" },
            "14563": { "city" : "UNION HILL", "state" : "NY", "county" : "WAYNE" },
            "14564": { "city" : "VICTOR", "state" : "NY", "county" : "ONTARIO" },
            "14568": { "city" : "WALWORTH", "state" : "NY", "county" : "WAYNE" },
            "14569": { "city" : "WARSAW", "state" : "NY", "county" : "WYOMING" },
            "14571": { "city" : "WATERPORT", "state" : "NY", "county" : "ORLEANS" },
            "14572": { "city" : "WAYLAND", "state" : "NY", "county" : "STEUBEN" },
            "14580": { "city" : "WEBSTER", "state" : "NY", "county" : "MONROE" },
            "14585": { "city" : "WEST BLOOMFIELD", "state" : "NY", "county" : "ONTARIO" },
            "14586": { "city" : "WEST HENRIETTA", "state" : "NY", "county" : "MONROE" },
            "14588": { "city" : "WILLARD", "state" : "NY", "county" : "SENECA" },
            "14589": { "city" : "WILLIAMSON", "state" : "NY", "county" : "WAYNE" },
            "14590": { "city" : "WOLCOTT", "state" : "NY", "county" : "WAYNE" },"14591": { "city" : "WYOMING", "state" : "NY", "county" : "WYOMING" },
            "14592": { "city" : "YORK", "state" : "NY", "county" : "LIVINGSTON" },
            "14602": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14603": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14604": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14605": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14606": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14607": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14608": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14609": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14610": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14611": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14612": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14613": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14614": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14615": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14616": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14617": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14618": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14619": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14620": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14621": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14622": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14623": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14624": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14625": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14626": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14627": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14638": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14639": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14642": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14643": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14644": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14646": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14647": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14649": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14650": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14652": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14653": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14692": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14694": { "city" : "ROCHESTER", "state" : "NY", "county" : "MONROE" },
            "14701": { "city" : "JAMESTOWN", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14702": { "city" : "JAMESTOWN", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14706": { "city" : "ALLEGANY", "state" : "NY", "county" : "CATTARAUGUS" },
            "14709": { "city" : "ANGELICA", "state" : "NY", "county" : "ALLEGANY" },
            "14710": { "city" : "ASHVILLE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14711": { "city" : "BELFAST", "state" : "NY", "county" : "ALLEGANY" },
            "14712": { "city" : "BEMUS POINT", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14715": { "city" : "BOLIVAR", "state" : "NY", "county" : "ALLEGANY" },
            "14716": { "city" : "BROCTON", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14717": { "city" : "CANEADEA", "state" : "NY", "county" : "ALLEGANY" },
            "14718": { "city" : "CASSADAGA", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14719": { "city" : "CATTARAUGUS", "state" : "NY", "county" : "CATTARAUGUS" },
            "14720": { "city" : "CELORON", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14721": { "city" : "CERES", "state" : "NY", "county" : "ALLEGANY" },
            "14722": { "city" : "CHAUTAUQUA", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14723": { "city" : "CHERRY CREEK", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14724": { "city" : "CLYMER", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14726": { "city" : "CONEWANGO VALLEY", "state" : "NY", "county" : "CATTARAUGUS" },
            "14727": { "city" : "CUBA", "state" : "NY", "county" : "ALLEGANY" },"14728": { "city" : "DEWITTVILLE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14729": { "city" : "EAST OTTO", "state" : "NY", "county" : "CATTARAUGUS" },
            "14730": { "city" : "EAST RANDOLPH", "state" : "NY", "county" : "CATTARAUGUS" },
            "14731": { "city" : "ELLICOTTVILLE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14732": { "city" : "ELLINGTON", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14733": { "city" : "FALCONER", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14735": { "city" : "FILLMORE", "state" : "NY", "county" : "ALLEGANY" },
            "14736": { "city" : "FINDLEY LAKE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14737": { "city" : "FRANKLINVILLE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14738": { "city" : "FREWSBURG", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14739": { "city" : "FRIENDSHIP", "state" : "NY", "county" : "ALLEGANY" },
            "14740": { "city" : "GERRY", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14741": { "city" : "GREAT VALLEY", "state" : "NY", "county" : "CATTARAUGUS" },
            "14742": { "city" : "GREENHURST", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14743": { "city" : "HINSDALE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14744": { "city" : "HOUGHTON", "state" : "NY", "county" : "ALLEGANY" },
            "14745": { "city" : "HUME", "state" : "NY", "county" : "ALLEGANY" },"14747": { "city" : "KENNEDY", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14748": { "city" : "KILL BUCK", "state" : "NY", "county" : "CATTARAUGUS" },
            "14750": { "city" : "LAKEWOOD", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14751": { "city" : "LEON", "state" : "NY", "county" : "CATTARAUGUS" },
            "14752": { "city" : "LILY DALE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14753": { "city" : "LIMESTONE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14754": { "city" : "LITTLE GENESEE", "state" : "NY", "county" : "ALLEGANY" },
            "14755": { "city" : "LITTLE VALLEY", "state" : "NY", "county" : "CATTARAUGUS" },
            "14756": { "city" : "MAPLE SPRINGS", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14757": { "city" : "MAYVILLE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14760": { "city" : "OLEAN", "state" : "NY", "county" : "CATTARAUGUS" },
            "14766": { "city" : "OTTO", "state" : "NY", "county" : "CATTARAUGUS" },
            "14767": { "city" : "PANAMA", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14769": { "city" : "PORTLAND", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14770": { "city" : "PORTVILLE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14772": { "city" : "RANDOLPH", "state" : "NY", "county" : "CATTARAUGUS" },
            "14774": { "city" : "RICHBURG", "state" : "NY", "county" : "ALLEGANY" },
            "14775": { "city" : "RIPLEY", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14777": { "city" : "RUSHFORD", "state" : "NY", "county" : "ALLEGANY" },
            "14778": { "city" : "SAINT BONAVENTURE", "state" : "NY", "county" : "CATTARAUGUS" },
            "14779": { "city" : "SALAMANCA", "state" : "NY", "county" : "CATTARAUGUS" },
            "14781": { "city" : "SHERMAN", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14782": { "city" : "SINCLAIRVILLE", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14783": { "city" : "STEAMBURG", "state" : "NY", "county" : "CATTARAUGUS" },
            "14784": { "city" : "STOCKTON", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14785": { "city" : "STOW", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14786": { "city" : "WEST CLARKSVILLE", "state" : "NY", "county" : "ALLEGANY" },
            "14787": { "city" : "WESTFIELD", "state" : "NY", "county" : "CHAUTAUQUA" },
            "14788": { "city" : "WESTONS MILLS", "state" : "NY", "county" : "CATTARAUGUS" },
            "14801": { "city" : "ADDISON", "state" : "NY", "county" : "STEUBEN" },
            "14802": { "city" : "ALFRED", "state" : "NY", "county" : "ALLEGANY" },
            "14803": { "city" : "ALFRED STATION", "state" : "NY", "county" : "ALLEGANY" },
            "14804": { "city" : "ALMOND", "state" : "NY", "county" : "ALLEGANY" },
            "14805": { "city" : "ALPINE", "state" : "NY", "county" : "SCHUYLER" },
            "14806": { "city" : "ANDOVER", "state" : "NY", "county" : "ALLEGANY" },
            "14807": { "city" : "ARKPORT", "state" : "NY", "county" : "STEUBEN" },
            "14808": { "city" : "ATLANTA", "state" : "NY", "county" : "STEUBEN" },
            "14809": { "city" : "AVOCA", "state" : "NY", "county" : "STEUBEN" },"14810": { "city" : "BATH", "state" : "NY", "county" : "STEUBEN" },
            "14812": { "city" : "BEAVER DAMS", "state" : "NY", "county" : "SCHUYLER" },
            "14813": { "city" : "BELMONT", "state" : "NY", "county" : "ALLEGANY" },
            "14814": { "city" : "BIG FLATS", "state" : "NY", "county" : "CHEMUNG" },
            "14815": { "city" : "BRADFORD", "state" : "NY", "county" : "SCHUYLER" },
            "14816": { "city" : "BREESPORT", "state" : "NY", "county" : "CHEMUNG" },
            "14817": { "city" : "BROOKTONDALE", "state" : "NY", "county" : "TOMPKINS" },
            "14818": { "city" : "BURDETT", "state" : "NY", "county" : "SCHUYLER" },
            "14819": { "city" : "CAMERON", "state" : "NY", "county" : "STEUBEN" },
            "14820": { "city" : "CAMERON MILLS", "state" : "NY", "county" : "STEUBEN" },
            "14821": { "city" : "CAMPBELL", "state" : "NY", "county" : "STEUBEN" },
            "14822": { "city" : "CANASERAGA", "state" : "NY", "county" : "ALLEGANY" },
            "14823": { "city" : "CANISTEO", "state" : "NY", "county" : "STEUBEN" },
            "14824": { "city" : "CAYUTA", "state" : "NY", "county" : "SCHUYLER" },
            "14825": { "city" : "CHEMUNG", "state" : "NY", "county" : "CHEMUNG" },
            "14826": { "city" : "COHOCTON", "state" : "NY", "county" : "STEUBEN" },
            "14827": { "city" : "COOPERS PLAINS", "state" : "NY", "county" : "STEUBEN" },
            "14830": { "city" : "CORNING", "state" : "NY", "county" : "STEUBEN" },
            "14831": { "city" : "CORNING", "state" : "NY", "county" : "STEUBEN" },
            "14836": { "city" : "DALTON", "state" : "NY", "county" : "LIVINGSTON" },
            "14837": { "city" : "DUNDEE", "state" : "NY", "county" : "YATES" },"14838": { "city" : "ERIN", "state" : "NY", "county" : "CHEMUNG" },
            "14839": { "city" : "GREENWOOD", "state" : "NY", "county" : "STEUBEN" },
            "14840": { "city" : "HAMMONDSPORT", "state" : "NY", "county" : "STEUBEN" },
            "14841": { "city" : "HECTOR", "state" : "NY", "county" : "SCHUYLER" },
            "14842": { "city" : "HIMROD", "state" : "NY", "county" : "YATES" },"14843": { "city" : "HORNELL", "state" : "NY", "county" : "STEUBEN" },
            "14845": { "city" : "HORSEHEADS", "state" : "NY", "county" : "CHEMUNG" },
            "14846": { "city" : "HUNT", "state" : "NY", "county" : "LIVINGSTON" },
            "14847": { "city" : "INTERLAKEN", "state" : "NY", "county" : "SENECA" },
            "14850": { "city" : "ITHACA", "state" : "NY", "county" : "TOMPKINS" },
            "14851": { "city" : "ITHACA", "state" : "NY", "county" : "TOMPKINS" },
            "14852": { "city" : "ITHACA", "state" : "NY", "county" : "TOMPKINS" },
            "14853": { "city" : "ITHACA", "state" : "NY", "county" : "TOMPKINS" },
            "14854": { "city" : "JACKSONVILLE", "state" : "NY", "county" : "TOMPKINS" },
            "14855": { "city" : "JASPER", "state" : "NY", "county" : "STEUBEN" },
            "14856": { "city" : "KANONA", "state" : "NY", "county" : "STEUBEN" },
            "14857": { "city" : "LAKEMONT", "state" : "NY", "county" : "YATES" },
            "14858": { "city" : "LINDLEY", "state" : "NY", "county" : "STEUBEN" },
            "14859": { "city" : "LOCKWOOD", "state" : "NY", "county" : "TIOGA" },
            "14860": { "city" : "LODI", "state" : "NY", "county" : "SENECA" },"14861": { "city" : "LOWMAN", "state" : "NY", "county" : "CHEMUNG" },
            "14863": { "city" : "MECKLENBURG", "state" : "NY", "county" : "SCHUYLER" },
            "14864": { "city" : "MILLPORT", "state" : "NY", "county" : "CHEMUNG" },
            "14865": { "city" : "MONTOUR FALLS", "state" : "NY", "county" : "SCHUYLER" },
            "14867": { "city" : "NEWFIELD", "state" : "NY", "county" : "TOMPKINS" },
            "14869": { "city" : "ODESSA", "state" : "NY", "county" : "SCHUYLER" },
            "14870": { "city" : "PAINTED POST", "state" : "NY", "county" : "STEUBEN" },
            "14871": { "city" : "PINE CITY", "state" : "NY", "county" : "CHEMUNG" },
            "14872": { "city" : "PINE VALLEY", "state" : "NY", "county" : "CHEMUNG" },
            "14873": { "city" : "PRATTSBURGH", "state" : "NY", "county" : "STEUBEN" },
            "14874": { "city" : "PULTENEY", "state" : "NY", "county" : "STEUBEN" },
            "14876": { "city" : "READING CENTER", "state" : "NY", "county" : "SCHUYLER" },
            "14877": { "city" : "REXVILLE", "state" : "NY", "county" : "STEUBEN" },
            "14878": { "city" : "ROCK STREAM", "state" : "NY", "county" : "SCHUYLER" },
            "14879": { "city" : "SAVONA", "state" : "NY", "county" : "STEUBEN" },
            "14880": { "city" : "SCIO", "state" : "NY", "county" : "ALLEGANY" },"14881": { "city" : "SLATERVILLE SPRINGS", "state" : "NY", "county" : "TOMPKINS" },
            "14882": { "city" : "LANSING", "state" : "NY", "county" : "TOMPKINS" },
            "14883": { "city" : "SPENCER", "state" : "NY", "county" : "TIOGA" },"14884": { "city" : "SWAIN", "state" : "NY", "county" : "ALLEGANY" },
            "14885": { "city" : "TROUPSBURG", "state" : "NY", "county" : "STEUBEN" },
            "14886": { "city" : "TRUMANSBURG", "state" : "NY", "county" : "TOMPKINS" },
            "14887": { "city" : "TYRONE", "state" : "NY", "county" : "SCHUYLER" },
            "14889": { "city" : "VAN ETTEN", "state" : "NY", "county" : "CHEMUNG" },
            "14891": { "city" : "WATKINS GLEN", "state" : "NY", "county" : "SCHUYLER" },
            "14892": { "city" : "WAVERLY", "state" : "NY", "county" : "TIOGA" },"14893": { "city" : "WAYNE", "state" : "NY", "county" : "SCHUYLER" },
            "14894": { "city" : "WELLSBURG", "state" : "NY", "county" : "CHEMUNG" },
            "14895": { "city" : "WELLSVILLE", "state" : "NY", "county" : "ALLEGANY" },
            "14897": { "city" : "WHITESVILLE", "state" : "NY", "county" : "ALLEGANY" },
            "14898": { "city" : "WOODHULL", "state" : "NY", "county" : "STEUBEN" },
            "14901": { "city" : "ELMIRA", "state" : "NY", "county" : "CHEMUNG" },
            "14902": { "city" : "ELMIRA", "state" : "NY", "county" : "CHEMUNG" },
            "14903": { "city" : "ELMIRA", "state" : "NY", "county" : "CHEMUNG" },
            "14904": { "city" : "ELMIRA", "state" : "NY", "county" : "CHEMUNG" },
            "14905": { "city" : "ELMIRA", "state" : "NY", "county" : "CHEMUNG" },
            "15001": { "city" : "ALIQUIPPA", "state" : "PA", "county" : "BEAVER" },
            "15003": { "city" : "AMBRIDGE", "state" : "PA", "county" : "BEAVER" },
            "15004": { "city" : "ATLASBURG", "state" : "PA", "county" : "WASHINGTON" },
            "15005": { "city" : "BADEN", "state" : "PA", "county" : "BEAVER" },"15006": { "city" : "BAIRDFORD", "state" : "PA", "county" : "ALLEGHENY" },
            "15007": { "city" : "BAKERSTOWN", "state" : "PA", "county" : "ALLEGHENY" },
            "15009": { "city" : "BEAVER", "state" : "PA", "county" : "BEAVER" },"15010": { "city" : "BEAVER FALLS", "state" : "PA", "county" : "BEAVER" },
            "15012": { "city" : "BELLE VERNON", "state" : "PA", "county" : "FAYETTE" },
            "15014": { "city" : "BRACKENRIDGE", "state" : "PA", "county" : "ALLEGHENY" },
            "15015": { "city" : "BRADFORDWOODS", "state" : "PA", "county" : "ALLEGHENY" },
            "15017": { "city" : "BRIDGEVILLE", "state" : "PA", "county" : "ALLEGHENY" },
            "15018": { "city" : "BUENA VISTA", "state" : "PA", "county" : "ALLEGHENY" },
            "15019": { "city" : "BULGER", "state" : "PA", "county" : "WASHINGTON" },
            "15020": { "city" : "BUNOLA", "state" : "PA", "county" : "ALLEGHENY" },
            "15021": { "city" : "BURGETTSTOWN", "state" : "PA", "county" : "WASHINGTON" },
            "15022": { "city" : "CHARLEROI", "state" : "PA", "county" : "WASHINGTON" },
            "15024": { "city" : "CHESWICK", "state" : "PA", "county" : "ALLEGHENY" },
            "15025": { "city" : "CLAIRTON", "state" : "PA", "county" : "ALLEGHENY" },
            "15026": { "city" : "CLINTON", "state" : "PA", "county" : "BEAVER" },
            "15027": { "city" : "CONWAY", "state" : "PA", "county" : "BEAVER" },"15028": { "city" : "COULTERS", "state" : "PA", "county" : "ALLEGHENY" },
            "15030": { "city" : "CREIGHTON", "state" : "PA", "county" : "ALLEGHENY" },
            "15031": { "city" : "CUDDY", "state" : "PA", "county" : "ALLEGHENY" },
            "15032": { "city" : "CURTISVILLE", "state" : "PA", "county" : "ALLEGHENY" },
            "15033": { "city" : "DONORA", "state" : "PA", "county" : "WASHINGTON" },
            "15034": { "city" : "DRAVOSBURG", "state" : "PA", "county" : "ALLEGHENY" },
            "15035": { "city" : "EAST MC KEESPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15037": { "city" : "ELIZABETH", "state" : "PA", "county" : "ALLEGHENY" },
            "15038": { "city" : "ELRAMA", "state" : "PA", "county" : "WASHINGTON" },
            "15042": { "city" : "FREEDOM", "state" : "PA", "county" : "BEAVER" },
            "15043": { "city" : "GEORGETOWN", "state" : "PA", "county" : "BEAVER" },
            "15044": { "city" : "GIBSONIA", "state" : "PA", "county" : "ALLEGHENY" },
            "15045": { "city" : "GLASSPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15046": { "city" : "CRESCENT", "state" : "PA", "county" : "ALLEGHENY" },
            "15047": { "city" : "GREENOCK", "state" : "PA", "county" : "ALLEGHENY" },
            "15049": { "city" : "HARWICK", "state" : "PA", "county" : "ALLEGHENY" },
            "15050": { "city" : "HOOKSTOWN", "state" : "PA", "county" : "BEAVER" },
            "15051": { "city" : "INDIANOLA", "state" : "PA", "county" : "ALLEGHENY" },
            "15052": { "city" : "INDUSTRY", "state" : "PA", "county" : "BEAVER" },
            "15053": { "city" : "JOFFRE", "state" : "PA", "county" : "WASHINGTON" },
            "15054": { "city" : "LANGELOTH", "state" : "PA", "county" : "WASHINGTON" },
            "15055": { "city" : "LAWRENCE", "state" : "PA", "county" : "WASHINGTON" },
            "15056": { "city" : "LEETSDALE", "state" : "PA", "county" : "ALLEGHENY" },
            "15057": { "city" : "MC DONALD", "state" : "PA", "county" : "WASHINGTON" },
            "15059": { "city" : "MIDLAND", "state" : "PA", "county" : "BEAVER" },
            "15060": { "city" : "MIDWAY", "state" : "PA", "county" : "WASHINGTON" },
            "15061": { "city" : "MONACA", "state" : "PA", "county" : "BEAVER" },"15062": { "city" : "MONESSEN", "state" : "PA", "county" : "WESTMORELAND" },
            "15063": { "city" : "MONONGAHELA", "state" : "PA", "county" : "WASHINGTON" },
            "15064": { "city" : "MORGAN", "state" : "PA", "county" : "ALLEGHENY" },
            "15065": { "city" : "NATRONA HEIGHTS", "state" : "PA", "county" : "ALLEGHENY" },
            "15066": { "city" : "NEW BRIGHTON", "state" : "PA", "county" : "BEAVER" },
            "15067": { "city" : "NEW EAGLE", "state" : "PA", "county" : "WASHINGTON" },
            "15068": { "city" : "NEW KENSINGTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15069": { "city" : "NEW KENSINGTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15071": { "city" : "OAKDALE", "state" : "PA", "county" : "ALLEGHENY" },
            "15072": { "city" : "PRICEDALE", "state" : "PA", "county" : "WESTMORELAND" },
            "15074": { "city" : "ROCHESTER", "state" : "PA", "county" : "BEAVER" },
            "15075": { "city" : "RURAL RIDGE", "state" : "PA", "county" : "ALLEGHENY" },
            "15076": { "city" : "RUSSELLTON", "state" : "PA", "county" : "ALLEGHENY" },
            "15077": { "city" : "SHIPPINGPORT", "state" : "PA", "county" : "BEAVER" },
            "15078": { "city" : "SLOVAN", "state" : "PA", "county" : "WASHINGTON" },
            "15081": { "city" : "SOUTH HEIGHTS", "state" : "PA", "county" : "BEAVER" },
            "15082": { "city" : "STURGEON", "state" : "PA", "county" : "ALLEGHENY" },
            "15083": { "city" : "SUTERSVILLE", "state" : "PA", "county" : "WESTMORELAND" },
            "15084": { "city" : "TARENTUM", "state" : "PA", "county" : "ALLEGHENY" },
            "15085": { "city" : "TRAFFORD", "state" : "PA", "county" : "WESTMORELAND" },
            "15086": { "city" : "WARRENDALE", "state" : "PA", "county" : "ALLEGHENY" },
            "15087": { "city" : "WEBSTER", "state" : "PA", "county" : "WESTMORELAND" },
            "15088": { "city" : "WEST ELIZABETH", "state" : "PA", "county" : "ALLEGHENY" },
            "15089": { "city" : "WEST NEWTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15090": { "city" : "WEXFORD", "state" : "PA", "county" : "ALLEGHENY" },
            "15091": { "city" : "WILDWOOD", "state" : "PA", "county" : "ALLEGHENY" },
            "15095": { "city" : "WARRENDALE", "state" : "PA", "county" : "ALLEGHENY" },
            "15096": { "city" : "WARRENDALE", "state" : "PA", "county" : "ALLEGHENY" },
            "15101": { "city" : "ALLISON PARK", "state" : "PA", "county" : "ALLEGHENY" },
            "15102": { "city" : "BETHEL PARK", "state" : "PA", "county" : "ALLEGHENY" },
            "15104": { "city" : "BRADDOCK", "state" : "PA", "county" : "ALLEGHENY" },
            "15106": { "city" : "CARNEGIE", "state" : "PA", "county" : "ALLEGHENY" },
            "15108": { "city" : "CORAOPOLIS", "state" : "PA", "county" : "ALLEGHENY" },
            "15110": { "city" : "DUQUESNE", "state" : "PA", "county" : "ALLEGHENY" },
            "15112": { "city" : "EAST PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15116": { "city" : "GLENSHAW", "state" : "PA", "county" : "ALLEGHENY" },
            "15120": { "city" : "HOMESTEAD", "state" : "PA", "county" : "ALLEGHENY" },
            "15122": { "city" : "WEST MIFFLIN", "state" : "PA", "county" : "ALLEGHENY" },
            "15123": { "city" : "WEST MIFFLIN", "state" : "PA", "county" : "ALLEGHENY" },
            "15126": { "city" : "IMPERIAL", "state" : "PA", "county" : "ALLEGHENY" },
            "15127": { "city" : "INGOMAR", "state" : "PA", "county" : "ALLEGHENY" },
            "15129": { "city" : "SOUTH PARK", "state" : "PA", "county" : "ALLEGHENY" },
            "15131": { "city" : "MCKEESPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15132": { "city" : "MCKEESPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15133": { "city" : "MCKEESPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15134": { "city" : "MCKEESPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15135": { "city" : "MCKEESPORT", "state" : "PA", "county" : "ALLEGHENY" },
            "15136": { "city" : "MC KEES ROCKS", "state" : "PA", "county" : "ALLEGHENY" },
            "15137": { "city" : "NORTH VERSAILLES", "state" : "PA", "county" : "ALLEGHENY" },
            "15139": { "city" : "OAKMONT", "state" : "PA", "county" : "ALLEGHENY" },
            "15140": { "city" : "PITCAIRN", "state" : "PA", "county" : "ALLEGHENY" },
            "15142": { "city" : "PRESTO", "state" : "PA", "county" : "ALLEGHENY" },
            "15143": { "city" : "SEWICKLEY", "state" : "PA", "county" : "ALLEGHENY" },
            "15144": { "city" : "SPRINGDALE", "state" : "PA", "county" : "ALLEGHENY" },
            "15145": { "city" : "TURTLE CREEK", "state" : "PA", "county" : "ALLEGHENY" },
            "15146": { "city" : "MONROEVILLE", "state" : "PA", "county" : "ALLEGHENY" },
            "15147": { "city" : "VERONA", "state" : "PA", "county" : "ALLEGHENY" },
            "15148": { "city" : "WILMERDING", "state" : "PA", "county" : "ALLEGHENY" },
            "15201": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15202": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15203": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15204": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15205": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15206": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15207": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15208": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15209": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15210": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15211": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15212": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15213": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15214": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15215": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15216": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15217": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15218": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15219": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15220": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15221": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15222": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15223": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15224": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15225": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15226": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15227": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15228": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15229": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15230": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15231": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15232": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15233": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15234": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15235": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15236": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15237": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15238": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15239": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15240": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15241": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15242": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15243": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15244": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15257": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15258": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15259": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15260": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15261": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15262": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15272": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15275": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15276": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15278": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15282": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15290": { "city" : "PITTSBURGH", "state" : "PA", "county" : "ALLEGHENY" },
            "15301": { "city" : "WASHINGTON", "state" : "PA", "county" : "WASHINGTON" },
            "15310": { "city" : "ALEPPO", "state" : "PA", "county" : "GREENE" },"15311": { "city" : "AMITY", "state" : "PA", "county" : "WASHINGTON" },
            "15312": { "city" : "AVELLA", "state" : "PA", "county" : "WASHINGTON" },
            "15313": { "city" : "BEALLSVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15314": { "city" : "BENTLEYVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15315": { "city" : "BOBTOWN", "state" : "PA", "county" : "GREENE" },
            "15316": { "city" : "BRAVE", "state" : "PA", "county" : "GREENE" },"15317": { "city" : "CANONSBURG", "state" : "PA", "county" : "WASHINGTON" },
            "15320": { "city" : "CARMICHAELS", "state" : "PA", "county" : "GREENE" },
            "15321": { "city" : "CECIL", "state" : "PA", "county" : "WASHINGTON" },
            "15322": { "city" : "CLARKSVILLE", "state" : "PA", "county" : "GREENE" },
            "15323": { "city" : "CLAYSVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15324": { "city" : "COKEBURG", "state" : "PA", "county" : "WASHINGTON" },
            "15325": { "city" : "CRUCIBLE", "state" : "PA", "county" : "GREENE" },
            "15327": { "city" : "DILLINER", "state" : "PA", "county" : "GREENE" },
            "15329": { "city" : "PROSPERITY", "state" : "PA", "county" : "WASHINGTON" },
            "15330": { "city" : "EIGHTY FOUR", "state" : "PA", "county" : "WASHINGTON" },
            "15331": { "city" : "ELLSWORTH", "state" : "PA", "county" : "WASHINGTON" },
            "15332": { "city" : "FINLEYVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15333": { "city" : "FREDERICKTOWN", "state" : "PA", "county" : "WASHINGTON" },
            "15334": { "city" : "GARARDS FORT", "state" : "PA", "county" : "GREENE" },
            "15336": { "city" : "GASTONVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15337": { "city" : "GRAYSVILLE", "state" : "PA", "county" : "GREENE" },
            "15338": { "city" : "GREENSBORO", "state" : "PA", "county" : "GREENE" },
            "15339": { "city" : "HENDERSONVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15340": { "city" : "HICKORY", "state" : "PA", "county" : "WASHINGTON" },
            "15341": { "city" : "HOLBROOK", "state" : "PA", "county" : "GREENE" },
            "15342": { "city" : "HOUSTON", "state" : "PA", "county" : "WASHINGTON" },
            "15344": { "city" : "JEFFERSON", "state" : "PA", "county" : "GREENE" },
            "15345": { "city" : "MARIANNA", "state" : "PA", "county" : "WASHINGTON" },
            "15346": { "city" : "MATHER", "state" : "PA", "county" : "GREENE" },"15347": { "city" : "MEADOW LANDS", "state" : "PA", "county" : "WASHINGTON" },
            "15348": { "city" : "MILLSBORO", "state" : "PA", "county" : "WASHINGTON" },
            "15349": { "city" : "MOUNT MORRIS", "state" : "PA", "county" : "GREENE" },
            "15350": { "city" : "MUSE", "state" : "PA", "county" : "WASHINGTON" },
            "15351": { "city" : "NEMACOLIN", "state" : "PA", "county" : "GREENE" },
            "15352": { "city" : "NEW FREEPORT", "state" : "PA", "county" : "GREENE" },
            "15353": { "city" : "NINEVEH", "state" : "PA", "county" : "GREENE" },
            "15357": { "city" : "RICES LANDING", "state" : "PA", "county" : "GREENE" },
            "15358": { "city" : "RICHEYVILLE", "state" : "PA", "county" : "WASHINGTON" },
            "15359": { "city" : "ROGERSVILLE", "state" : "PA", "county" : "GREENE" },
            "15360": { "city" : "SCENERY HILL", "state" : "PA", "county" : "WASHINGTON" },
            "15362": { "city" : "SPRAGGS", "state" : "PA", "county" : "GREENE" },
            "15363": { "city" : "STRABANE", "state" : "PA", "county" : "WASHINGTON" },
            "15364": { "city" : "SYCAMORE", "state" : "PA", "county" : "GREENE" },
            "15365": { "city" : "TAYLORSTOWN", "state" : "PA", "county" : "WASHINGTON" },
            "15367": { "city" : "VENETIA", "state" : "PA", "county" : "WASHINGTON" },
            "15368": { "city" : "VESTABURG", "state" : "PA", "county" : "WASHINGTON" },
            "15370": { "city" : "WAYNESBURG", "state" : "PA", "county" : "GREENE" },
            "15376": { "city" : "WEST ALEXANDER", "state" : "PA", "county" : "WASHINGTON" },
            "15377": { "city" : "WEST FINLEY", "state" : "PA", "county" : "WASHINGTON" },
            "15378": { "city" : "WESTLAND", "state" : "PA", "county" : "WASHINGTON" },
            "15379": { "city" : "WEST MIDDLETOWN", "state" : "PA", "county" : "WASHINGTON" },
            "15380": { "city" : "WIND RIDGE", "state" : "PA", "county" : "GREENE" },
            "15401": { "city" : "UNIONTOWN", "state" : "PA", "county" : "FAYETTE" },
            "15410": { "city" : "ADAH", "state" : "PA", "county" : "FAYETTE" },"15411": { "city" : "ADDISON", "state" : "PA", "county" : "SOMERSET" },
            "15412": { "city" : "ALLENPORT", "state" : "PA", "county" : "WASHINGTON" },
            "15413": { "city" : "ALLISON", "state" : "PA", "county" : "FAYETTE" },
            "15415": { "city" : "BRIER HILL", "state" : "PA", "county" : "FAYETTE" },
            "15416": { "city" : "BROWNFIELD", "state" : "PA", "county" : "FAYETTE" },
            "15417": { "city" : "BROWNSVILLE", "state" : "PA", "county" : "FAYETTE" },
            "15419": { "city" : "CALIFORNIA", "state" : "PA", "county" : "WASHINGTON" },
            "15420": { "city" : "CARDALE", "state" : "PA", "county" : "FAYETTE" },
            "15421": { "city" : "CHALK HILL", "state" : "PA", "county" : "FAYETTE" },
            "15423": { "city" : "COAL CENTER", "state" : "PA", "county" : "WASHINGTON" },
            "15424": { "city" : "CONFLUENCE", "state" : "PA", "county" : "SOMERSET" },
            "15425": { "city" : "CONNELLSVILLE", "state" : "PA", "county" : "FAYETTE" },
            "15427": { "city" : "DAISYTOWN", "state" : "PA", "county" : "WASHINGTON" },
            "15428": { "city" : "DAWSON", "state" : "PA", "county" : "FAYETTE" },
            "15430": { "city" : "DICKERSON RUN", "state" : "PA", "county" : "FAYETTE" },
            "15431": { "city" : "DUNBAR", "state" : "PA", "county" : "FAYETTE" },
            "15432": { "city" : "DUNLEVY", "state" : "PA", "county" : "WASHINGTON" },
            "15433": { "city" : "EAST MILLSBORO", "state" : "PA", "county" : "FAYETTE" },
            "15434": { "city" : "ELCO", "state" : "PA", "county" : "WASHINGTON" },
            "15435": { "city" : "FAIRBANK", "state" : "PA", "county" : "FAYETTE" },
            "15436": { "city" : "FAIRCHANCE", "state" : "PA", "county" : "FAYETTE" },
            "15437": { "city" : "FARMINGTON", "state" : "PA", "county" : "FAYETTE" },
            "15438": { "city" : "FAYETTE CITY", "state" : "PA", "county" : "FAYETTE" },
            "15440": { "city" : "GIBBON GLADE", "state" : "PA", "county" : "FAYETTE" },
            "15442": { "city" : "GRINDSTONE", "state" : "PA", "county" : "FAYETTE" },
            "15444": { "city" : "HILLER", "state" : "PA", "county" : "FAYETTE" },
            "15445": { "city" : "HOPWOOD", "state" : "PA", "county" : "FAYETTE" },
            "15446": { "city" : "INDIAN HEAD", "state" : "PA", "county" : "FAYETTE" },
            "15448": { "city" : "JACOBS CREEK", "state" : "PA", "county" : "WESTMORELAND" },
            "15449": { "city" : "KEISTERVILLE", "state" : "PA", "county" : "FAYETTE" },
            "15450": { "city" : "LA BELLE", "state" : "PA", "county" : "FAYETTE" },
            "15451": { "city" : "LAKE LYNN", "state" : "PA", "county" : "FAYETTE" },
            "15454": { "city" : "LECKRONE", "state" : "PA", "county" : "FAYETTE" },
            "15455": { "city" : "LEISENRING", "state" : "PA", "county" : "FAYETTE" },
            "15456": { "city" : "LEMONT FURNACE", "state" : "PA", "county" : "FAYETTE" },
            "15458": { "city" : "MC CLELLANDTOWN", "state" : "PA", "county" : "FAYETTE" },
            "15459": { "city" : "MARKLEYSBURG", "state" : "PA", "county" : "FAYETTE" },
            "15460": { "city" : "MARTIN", "state" : "PA", "county" : "FAYETTE" },
            "15461": { "city" : "MASONTOWN", "state" : "PA", "county" : "FAYETTE" },
            "15462": { "city" : "MELCROFT", "state" : "PA", "county" : "FAYETTE" },
            "15463": { "city" : "MERRITTSTOWN", "state" : "PA", "county" : "FAYETTE" },
            "15464": { "city" : "MILL RUN", "state" : "PA", "county" : "FAYETTE" },
            "15465": { "city" : "MOUNT BRADDOCK", "state" : "PA", "county" : "FAYETTE" },
            "15466": { "city" : "NEWELL", "state" : "PA", "county" : "FAYETTE" },
            "15467": { "city" : "NEW GENEVA", "state" : "PA", "county" : "FAYETTE" },
            "15468": { "city" : "NEW SALEM", "state" : "PA", "county" : "FAYETTE" },
            "15469": { "city" : "NORMALVILLE", "state" : "PA", "county" : "FAYETTE" },
            "15470": { "city" : "OHIOPYLE", "state" : "PA", "county" : "FAYETTE" },
            "15472": { "city" : "OLIVER", "state" : "PA", "county" : "FAYETTE" },
            "15473": { "city" : "PERRYOPOLIS", "state" : "PA", "county" : "FAYETTE" },
            "15474": { "city" : "POINT MARION", "state" : "PA", "county" : "FAYETTE" },
            "15475": { "city" : "REPUBLIC", "state" : "PA", "county" : "FAYETTE" },
            "15477": { "city" : "ROSCOE", "state" : "PA", "county" : "WASHINGTON" },
            "15478": { "city" : "SMITHFIELD", "state" : "PA", "county" : "FAYETTE" },
            "15479": { "city" : "SMITHTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15480": { "city" : "SMOCK", "state" : "PA", "county" : "FAYETTE" },"15482": { "city" : "STAR JUNCTION", "state" : "PA", "county" : "FAYETTE" },
            "15483": { "city" : "STOCKDALE", "state" : "PA", "county" : "WASHINGTON" },
            "15484": { "city" : "ULEDI", "state" : "PA", "county" : "FAYETTE" },"15485": { "city" : "URSINA", "state" : "PA", "county" : "SOMERSET" },
            "15486": { "city" : "VANDERBILT", "state" : "PA", "county" : "FAYETTE" },
            "15488": { "city" : "WALTERSBURG", "state" : "PA", "county" : "FAYETTE" },
            "15489": { "city" : "WEST LEISENRING", "state" : "PA", "county" : "FAYETTE" },
            "15490": { "city" : "WHITE", "state" : "PA", "county" : "FAYETTE" },"15501": { "city" : "SOMERSET", "state" : "PA", "county" : "SOMERSET" },
            "15502": { "city" : "HIDDEN VALLEY", "state" : "PA", "county" : "SOMERSET" },
            "15520": { "city" : "ACOSTA", "state" : "PA", "county" : "SOMERSET" },
            "15521": { "city" : "ALUM BANK", "state" : "PA", "county" : "BEDFORD" },
            "15522": { "city" : "BEDFORD", "state" : "PA", "county" : "BEDFORD" },
            "15530": { "city" : "BERLIN", "state" : "PA", "county" : "SOMERSET" },
            "15531": { "city" : "BOSWELL", "state" : "PA", "county" : "SOMERSET" },
            "15532": { "city" : "BOYNTON", "state" : "PA", "county" : "SOMERSET" },
            "15533": { "city" : "BREEZEWOOD", "state" : "PA", "county" : "BEDFORD" },
            "15534": { "city" : "BUFFALO MILLS", "state" : "PA", "county" : "BEDFORD" },
            "15535": { "city" : "CLEARVILLE", "state" : "PA", "county" : "BEDFORD" },
            "15536": { "city" : "CRYSTAL SPRING", "state" : "PA", "county" : "FULTON" },
            "15537": { "city" : "EVERETT", "state" : "PA", "county" : "BEDFORD" },
            "15538": { "city" : "FAIRHOPE", "state" : "PA", "county" : "SOMERSET" },
            "15539": { "city" : "FISHERTOWN", "state" : "PA", "county" : "BEDFORD" },
            "15540": { "city" : "FORT HILL", "state" : "PA", "county" : "SOMERSET" },
            "15541": { "city" : "FRIEDENS", "state" : "PA", "county" : "SOMERSET" },
            "15542": { "city" : "GARRETT", "state" : "PA", "county" : "SOMERSET" },
            "15545": { "city" : "HYNDMAN", "state" : "PA", "county" : "BEDFORD" },
            "15546": { "city" : "JENNERS", "state" : "PA", "county" : "SOMERSET" },
            "15547": { "city" : "JENNERSTOWN", "state" : "PA", "county" : "SOMERSET" },
            "15549": { "city" : "LISTIE", "state" : "PA", "county" : "SOMERSET" },
            "15550": { "city" : "MANNS CHOICE", "state" : "PA", "county" : "BEDFORD" },
            "15551": { "city" : "MARKLETON", "state" : "PA", "county" : "SOMERSET" },
            "15552": { "city" : "MEYERSDALE", "state" : "PA", "county" : "SOMERSET" },
            "15553": { "city" : "NEW BALTIMORE", "state" : "PA", "county" : "SOMERSET" },
            "15554": { "city" : "NEW PARIS", "state" : "PA", "county" : "BEDFORD" },
            "15557": { "city" : "ROCKWOOD", "state" : "PA", "county" : "SOMERSET" },
            "15558": { "city" : "SALISBURY", "state" : "PA", "county" : "SOMERSET" },
            "15559": { "city" : "SCHELLSBURG", "state" : "PA", "county" : "BEDFORD" },
            "15560": { "city" : "SHANKSVILLE", "state" : "PA", "county" : "SOMERSET" },
            "15561": { "city" : "SIPESVILLE", "state" : "PA", "county" : "SOMERSET" },
            "15562": { "city" : "SPRINGS", "state" : "PA", "county" : "SOMERSET" },
            "15563": { "city" : "STOYSTOWN", "state" : "PA", "county" : "SOMERSET" },
            "15564": { "city" : "WELLERSBURG", "state" : "PA", "county" : "SOMERSET" },
            "15565": { "city" : "WEST SALISBURY", "state" : "PA", "county" : "SOMERSET" },
            "15601": { "city" : "GREENSBURG", "state" : "PA", "county" : "WESTMORELAND" },
            "15605": { "city" : "GREENSBURG", "state" : "PA", "county" : "WESTMORELAND" },
            "15610": { "city" : "ACME", "state" : "PA", "county" : "WESTMORELAND" },
            "15611": { "city" : "ADAMSBURG", "state" : "PA", "county" : "WESTMORELAND" },
            "15612": { "city" : "ALVERTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15613": { "city" : "APOLLO", "state" : "PA", "county" : "WESTMORELAND" },
            "15615": { "city" : "ARDARA", "state" : "PA", "county" : "WESTMORELAND" },
            "15616": { "city" : "ARMBRUST", "state" : "PA", "county" : "WESTMORELAND" },
            "15617": { "city" : "ARONA", "state" : "PA", "county" : "WESTMORELAND" },
            "15618": { "city" : "AVONMORE", "state" : "PA", "county" : "WESTMORELAND" },
            "15619": { "city" : "BOVARD", "state" : "PA", "county" : "WESTMORELAND" },
            "15620": { "city" : "BRADENVILLE", "state" : "PA", "county" : "WESTMORELAND" },
            "15621": { "city" : "CALUMET", "state" : "PA", "county" : "WESTMORELAND" },
            "15622": { "city" : "CHAMPION", "state" : "PA", "county" : "WESTMORELAND" },
            "15623": { "city" : "CLARIDGE", "state" : "PA", "county" : "WESTMORELAND" },
            "15624": { "city" : "CRABTREE", "state" : "PA", "county" : "WESTMORELAND" },
            "15625": { "city" : "DARRAGH", "state" : "PA", "county" : "WESTMORELAND" },
            "15626": { "city" : "DELMONT", "state" : "PA", "county" : "WESTMORELAND" },
            "15627": { "city" : "DERRY", "state" : "PA", "county" : "WESTMORELAND" },
            "15628": { "city" : "DONEGAL", "state" : "PA", "county" : "WESTMORELAND" },
            "15629": { "city" : "EAST VANDERGRIFT", "state" : "PA", "county" : "WESTMORELAND" },
            "15631": { "city" : "EVERSON", "state" : "PA", "county" : "FAYETTE" },
            "15632": { "city" : "EXPORT", "state" : "PA", "county" : "WESTMORELAND" },
            "15633": { "city" : "FORBES ROAD", "state" : "PA", "county" : "WESTMORELAND" },
            "15634": { "city" : "GRAPEVILLE", "state" : "PA", "county" : "WESTMORELAND" },
            "15635": { "city" : "HANNASTOWN", "state" : "PA", "county" : "WESTMORELAND" },
            "15636": { "city" : "HARRISON CITY", "state" : "PA", "county" : "WESTMORELAND" },
            "15637": { "city" : "HERMINIE", "state" : "PA", "county" : "WESTMORELAND" },
            "15638": { "city" : "HOSTETTER", "state" : "PA", "county" : "WESTMORELAND" },
            "15639": { "city" : "HUNKER", "state" : "PA", "county" : "WESTMORELAND" },
            "15640": { "city" : "HUTCHINSON", "state" : "PA", "county" : "WESTMORELAND" },
            "15641": { "city" : "HYDE PARK", "state" : "PA", "county" : "WESTMORELAND" },
            "15642": { "city" : "IRWIN", "state" : "PA", "county" : "WESTMORELAND" },
            "15644": { "city" : "JEANNETTE", "state" : "PA", "county" : "WESTMORELAND" },
            "15646": { "city" : "JONES MILLS", "state" : "PA", "county" : "WESTMORELAND" },
            "15647": { "city" : "LARIMER", "state" : "PA", "county" : "WESTMORELAND" },
            "15650": { "city" : "LATROBE", "state" : "PA", "county" : "WESTMORELAND" },
            "15655": { "city" : "LAUGHLINTOWN", "state" : "PA", "county" : "WESTMORELAND" },
            "15656": { "city" : "LEECHBURG", "state" : "PA", "county" : "ARMSTRONG" },
            "15658": { "city" : "LIGONIER", "state" : "PA", "county" : "WESTMORELAND" },
            "15660": { "city" : "LOWBER", "state" : "PA", "county" : "WESTMORELAND" },
            "15661": { "city" : "LOYALHANNA", "state" : "PA", "county" : "WESTMORELAND" },
            "15662": { "city" : "LUXOR", "state" : "PA", "county" : "WESTMORELAND" },
            "15663": { "city" : "MADISON", "state" : "PA", "county" : "WESTMORELAND" },
            "15664": { "city" : "MAMMOTH", "state" : "PA", "county" : "WESTMORELAND" },
            "15665": { "city" : "MANOR", "state" : "PA", "county" : "WESTMORELAND" },
            "15666": { "city" : "MOUNT PLEASANT", "state" : "PA", "county" : "WESTMORELAND" },
            "15668": { "city" : "MURRYSVILLE", "state" : "PA", "county" : "WESTMORELAND" },
            "15670": { "city" : "NEW ALEXANDRIA", "state" : "PA", "county" : "WESTMORELAND" },
            "15671": { "city" : "NEW DERRY", "state" : "PA", "county" : "WESTMORELAND" },
            "15672": { "city" : "NEW STANTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15673": { "city" : "NORTH APOLLO", "state" : "PA", "county" : "ARMSTRONG" },
            "15674": { "city" : "NORVELT", "state" : "PA", "county" : "WESTMORELAND" },
            "15675": { "city" : "PENN", "state" : "PA", "county" : "WESTMORELAND" },
            "15676": { "city" : "PLEASANT UNITY", "state" : "PA", "county" : "WESTMORELAND" },
            "15677": { "city" : "RECTOR", "state" : "PA", "county" : "WESTMORELAND" },
            "15678": { "city" : "RILLTON", "state" : "PA", "county" : "WESTMORELAND" },
            "15679": { "city" : "RUFFS DALE", "state" : "PA", "county" : "WESTMORELAND" },
            "15680": { "city" : "SALINA", "state" : "PA", "county" : "WESTMORELAND" },
            "15681": { "city" : "SALTSBURG", "state" : "PA", "county" : "INDIANA" },
            "15682": { "city" : "SCHENLEY", "state" : "PA", "county" : "ARMSTRONG" },
            "15683": { "city" : "SCOTTDALE", "state" : "PA", "county" : "WESTMORELAND" },
            "15684": { "city" : "SLICKVILLE", "state" : "PA", "county" : "WESTMORELAND" },
            "15685": { "city" : "SOUTHWEST", "state" : "PA", "county" : "WESTMORELAND" },
            "15686": { "city" : "SPRING CHURCH", "state" : "PA", "county" : "ARMSTRONG" },
            "15687": { "city" : "STAHLSTOWN", "state" : "PA", "county" : "WESTMORELAND" },
            "15688": { "city" : "TARRS", "state" : "PA", "county" : "WESTMORELAND" },
            "15689": { "city" : "UNITED", "state" : "PA", "county" : "WESTMORELAND" },
            "15690": { "city" : "VANDERGRIFT", "state" : "PA", "county" : "WESTMORELAND" },
            "15691": { "city" : "WENDEL", "state" : "PA", "county" : "WESTMORELAND" },
            "15692": { "city" : "WESTMORELAND CITY", "state" : "PA", "county" : "WESTMORELAND" },
            "15693": { "city" : "WHITNEY", "state" : "PA", "county" : "WESTMORELAND" },
            "15695": { "city" : "WYANO", "state" : "PA", "county" : "WESTMORELAND" },
            "15696": { "city" : "YOUNGSTOWN", "state" : "PA", "county" : "WESTMORELAND" },
            "15697": { "city" : "YOUNGWOOD", "state" : "PA", "county" : "WESTMORELAND" },
            "15698": { "city" : "YUKON", "state" : "PA", "county" : "WESTMORELAND" },
            "15701": { "city" : "INDIANA", "state" : "PA", "county" : "INDIANA" },
            "15705": { "city" : "INDIANA", "state" : "PA", "county" : "INDIANA" },
            "15710": { "city" : "ALVERDA", "state" : "PA", "county" : "INDIANA" },
            "15711": { "city" : "ANITA", "state" : "PA", "county" : "JEFFERSON" },
            "15712": { "city" : "ARCADIA", "state" : "PA", "county" : "INDIANA" },
            "15713": { "city" : "AULTMAN", "state" : "PA", "county" : "INDIANA" },
            "15714": { "city" : "NORTHERN CAMBRIA", "state" : "PA", "county" : "CAMBRIA" },
            "15715": { "city" : "BIG RUN", "state" : "PA", "county" : "JEFFERSON" },
            "15716": { "city" : "BLACK LICK", "state" : "PA", "county" : "INDIANA" },
            "15717": { "city" : "BLAIRSVILLE", "state" : "PA", "county" : "INDIANA" },
            "15720": { "city" : "BRUSH VALLEY", "state" : "PA", "county" : "INDIANA" },
            "15721": { "city" : "BURNSIDE", "state" : "PA", "county" : "CLEARFIELD" },
            "15722": { "city" : "CARROLLTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15723": { "city" : "CHAMBERSVILLE", "state" : "PA", "county" : "INDIANA" },
            "15724": { "city" : "CHERRY TREE", "state" : "PA", "county" : "INDIANA" },
            "15725": { "city" : "CLARKSBURG", "state" : "PA", "county" : "INDIANA" },
            "15728": { "city" : "CLYMER", "state" : "PA", "county" : "INDIANA" },
            "15729": { "city" : "COMMODORE", "state" : "PA", "county" : "INDIANA" },
            "15730": { "city" : "COOLSPRING", "state" : "PA", "county" : "JEFFERSON" },
            "15731": { "city" : "CORAL", "state" : "PA", "county" : "INDIANA" },"15732": { "city" : "CREEKSIDE", "state" : "PA", "county" : "INDIANA" },
            "15733": { "city" : "DE LANCEY", "state" : "PA", "county" : "JEFFERSON" },
            "15734": { "city" : "DIXONVILLE", "state" : "PA", "county" : "INDIANA" },
            "15736": { "city" : "ELDERTON", "state" : "PA", "county" : "ARMSTRONG" },
            "15737": { "city" : "ELMORA", "state" : "PA", "county" : "CAMBRIA" },
            "15738": { "city" : "EMEIGH", "state" : "PA", "county" : "CAMBRIA" },
            "15739": { "city" : "ERNEST", "state" : "PA", "county" : "INDIANA" },
            "15741": { "city" : "GIPSY", "state" : "PA", "county" : "INDIANA" },"15742": { "city" : "GLEN CAMPBELL", "state" : "PA", "county" : "INDIANA" },
            "15744": { "city" : "HAMILTON", "state" : "PA", "county" : "JEFFERSON" },
            "15745": { "city" : "HEILWOOD", "state" : "PA", "county" : "INDIANA" },
            "15746": { "city" : "HILLSDALE", "state" : "PA", "county" : "INDIANA" },
            "15747": { "city" : "HOME", "state" : "PA", "county" : "INDIANA" },"15748": { "city" : "HOMER CITY", "state" : "PA", "county" : "INDIANA" },
            "15750": { "city" : "JOSEPHINE", "state" : "PA", "county" : "INDIANA" },
            "15752": { "city" : "KENT", "state" : "PA", "county" : "INDIANA" },"15753": { "city" : "LA JOSE", "state" : "PA", "county" : "CLEARFIELD" },
            "15754": { "city" : "LUCERNEMINES", "state" : "PA", "county" : "INDIANA" },
            "15756": { "city" : "MC INTYRE", "state" : "PA", "county" : "INDIANA" },
            "15757": { "city" : "MAHAFFEY", "state" : "PA", "county" : "CLEARFIELD" },
            "15758": { "city" : "MARCHAND", "state" : "PA", "county" : "INDIANA" },
            "15759": { "city" : "MARION CENTER", "state" : "PA", "county" : "INDIANA" },
            "15760": { "city" : "MARSTELLER", "state" : "PA", "county" : "CAMBRIA" },
            "15761": { "city" : "MENTCLE", "state" : "PA", "county" : "INDIANA" },
            "15762": { "city" : "NICKTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15763": { "city" : "NORTHPOINT", "state" : "PA", "county" : "INDIANA" },
            "15764": { "city" : "OLIVEBURG", "state" : "PA", "county" : "JEFFERSON" },
            "15765": { "city" : "PENN RUN", "state" : "PA", "county" : "INDIANA" },
            "15767": { "city" : "PUNXSUTAWNEY", "state" : "PA", "county" : "JEFFERSON" },
            "15770": { "city" : "RINGGOLD", "state" : "PA", "county" : "JEFFERSON" },
            "15771": { "city" : "ROCHESTER MILLS", "state" : "PA", "county" : "INDIANA" },
            "15772": { "city" : "ROSSITER", "state" : "PA", "county" : "INDIANA" },
            "15773": { "city" : "SAINT BENEDICT", "state" : "PA", "county" : "CAMBRIA" },
            "15774": { "city" : "SHELOCTA", "state" : "PA", "county" : "INDIANA" },
            "15775": { "city" : "SPANGLER", "state" : "PA", "county" : "CAMBRIA" },
            "15776": { "city" : "SPRANKLE MILLS", "state" : "PA", "county" : "JEFFERSON" },
            "15777": { "city" : "STARFORD", "state" : "PA", "county" : "INDIANA" },
            "15778": { "city" : "TIMBLIN", "state" : "PA", "county" : "JEFFERSON" },
            "15779": { "city" : "TORRANCE", "state" : "PA", "county" : "WESTMORELAND" },
            "15780": { "city" : "VALIER", "state" : "PA", "county" : "JEFFERSON" },
            "15781": { "city" : "WALSTON", "state" : "PA", "county" : "JEFFERSON" },
            "15783": { "city" : "WEST LEBANON", "state" : "PA", "county" : "INDIANA" },
            "15784": { "city" : "WORTHVILLE", "state" : "PA", "county" : "JEFFERSON" },
            "15801": { "city" : "DU BOIS", "state" : "PA", "county" : "CLEARFIELD" },
            "15821": { "city" : "BENEZETT", "state" : "PA", "county" : "ELK" },"15823": { "city" : "BROCKPORT", "state" : "PA", "county" : "ELK" },
            "15824": { "city" : "BROCKWAY", "state" : "PA", "county" : "JEFFERSON" },
            "15825": { "city" : "BROOKVILLE", "state" : "PA", "county" : "JEFFERSON" },
            "15827": { "city" : "BYRNEDALE", "state" : "PA", "county" : "ELK" },"15828": { "city" : "CLARINGTON", "state" : "PA", "county" : "FOREST" },
            "15829": { "city" : "CORSICA", "state" : "PA", "county" : "JEFFERSON" },
            "15831": { "city" : "DAGUS MINES", "state" : "PA", "county" : "ELK" },
            "15832": { "city" : "DRIFTWOOD", "state" : "PA", "county" : "CAMERON" },
            "15834": { "city" : "EMPORIUM", "state" : "PA", "county" : "CAMERON" },
            "15840": { "city" : "FALLS CREEK", "state" : "PA", "county" : "JEFFERSON" },
            "15841": { "city" : "FORCE", "state" : "PA", "county" : "ELK" },"15845": { "city" : "JOHNSONBURG", "state" : "PA", "county" : "ELK" },
            "15846": { "city" : "KERSEY", "state" : "PA", "county" : "ELK" },"15847": { "city" : "KNOX DALE", "state" : "PA", "county" : "JEFFERSON" },
            "15848": { "city" : "LUTHERSBURG", "state" : "PA", "county" : "CLEARFIELD" },
            "15849": { "city" : "PENFIELD", "state" : "PA", "county" : "CLEARFIELD" },
            "15851": { "city" : "REYNOLDSVILLE", "state" : "PA", "county" : "JEFFERSON" },
            "15853": { "city" : "RIDGWAY", "state" : "PA", "county" : "ELK" },"15856": { "city" : "ROCKTON", "state" : "PA", "county" : "CLEARFIELD" },
            "15857": { "city" : "SAINT MARYS", "state" : "PA", "county" : "ELK" },
            "15860": { "city" : "SIGEL", "state" : "PA", "county" : "JEFFERSON" },
            "15861": { "city" : "SINNAMAHONING", "state" : "PA", "county" : "CAMERON" },
            "15863": { "city" : "STUMP CREEK", "state" : "PA", "county" : "JEFFERSON" },
            "15864": { "city" : "SUMMERVILLE", "state" : "PA", "county" : "JEFFERSON" },
            "15865": { "city" : "SYKESVILLE", "state" : "PA", "county" : "JEFFERSON" },
            "15866": { "city" : "TROUTVILLE", "state" : "PA", "county" : "CLEARFIELD" },
            "15868": { "city" : "WEEDVILLE", "state" : "PA", "county" : "ELK" },"15870": { "city" : "WILCOX", "state" : "PA", "county" : "ELK" },
            "15901": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15902": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15904": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15905": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15906": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15907": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15909": { "city" : "JOHNSTOWN", "state" : "PA", "county" : "CAMBRIA" },
            "15920": { "city" : "ARMAGH", "state" : "PA", "county" : "INDIANA" },
            "15921": { "city" : "BEAVERDALE", "state" : "PA", "county" : "CAMBRIA" },
            "15922": { "city" : "BELSANO", "state" : "PA", "county" : "CAMBRIA" },
            "15923": { "city" : "BOLIVAR", "state" : "PA", "county" : "WESTMORELAND" },
            "15924": { "city" : "CAIRNBROOK", "state" : "PA", "county" : "SOMERSET" },
            "15926": { "city" : "CENTRAL CITY", "state" : "PA", "county" : "SOMERSET" },
            "15927": { "city" : "COLVER", "state" : "PA", "county" : "CAMBRIA" },
            "15928": { "city" : "DAVIDSVILLE", "state" : "PA", "county" : "SOMERSET" },
            "15929": { "city" : "DILLTOWN", "state" : "PA", "county" : "INDIANA" },
            "15930": { "city" : "DUNLO", "state" : "PA", "county" : "CAMBRIA" },"15931": { "city" : "EBENSBURG", "state" : "PA", "county" : "CAMBRIA" },
            "15934": { "city" : "ELTON", "state" : "PA", "county" : "CAMBRIA" },"15935": { "city" : "HOLLSOPPLE", "state" : "PA", "county" : "SOMERSET" },
            "15936": { "city" : "HOOVERSVILLE", "state" : "PA", "county" : "SOMERSET" },
            "15937": { "city" : "JEROME", "state" : "PA", "county" : "SOMERSET" },
            "15938": { "city" : "LILLY", "state" : "PA", "county" : "CAMBRIA" },"15940": { "city" : "LORETTO", "state" : "PA", "county" : "CAMBRIA" },
            "15942": { "city" : "MINERAL POINT", "state" : "PA", "county" : "CAMBRIA" },
            "15943": { "city" : "NANTY GLO", "state" : "PA", "county" : "CAMBRIA" },
            "15944": { "city" : "NEW FLORENCE", "state" : "PA", "county" : "WESTMORELAND" },
            "15945": { "city" : "PARKHILL", "state" : "PA", "county" : "CAMBRIA" },
            "15946": { "city" : "PORTAGE", "state" : "PA", "county" : "CAMBRIA" },
            "15948": { "city" : "REVLOC", "state" : "PA", "county" : "CAMBRIA" },
            "15949": { "city" : "ROBINSON", "state" : "PA", "county" : "INDIANA" },
            "15951": { "city" : "SAINT MICHAEL", "state" : "PA", "county" : "CAMBRIA" },
            "15952": { "city" : "SALIX", "state" : "PA", "county" : "CAMBRIA" },"15953": { "city" : "SEANOR", "state" : "PA", "county" : "SOMERSET" },
            "15954": { "city" : "SEWARD", "state" : "PA", "county" : "WESTMORELAND" },
            "15955": { "city" : "SIDMAN", "state" : "PA", "county" : "CAMBRIA" },
            "15956": { "city" : "SOUTH FORK", "state" : "PA", "county" : "CAMBRIA" },
            "15957": { "city" : "STRONGSTOWN", "state" : "PA", "county" : "INDIANA" },
            "15958": { "city" : "SUMMERHILL", "state" : "PA", "county" : "CAMBRIA" },
            "15959": { "city" : "TIRE HILL", "state" : "PA", "county" : "SOMERSET" },
            "15960": { "city" : "TWIN ROCKS", "state" : "PA", "county" : "CAMBRIA" },
            "15961": { "city" : "VINTONDALE", "state" : "PA", "county" : "CAMBRIA" },
            "15962": { "city" : "WILMORE", "state" : "PA", "county" : "CAMBRIA" },
            "15963": { "city" : "WINDBER", "state" : "PA", "county" : "SOMERSET" },
            "16001": { "city" : "BUTLER", "state" : "PA", "county" : "BUTLER" },"16002": { "city" : "BUTLER", "state" : "PA", "county" : "BUTLER" },
            "16003": { "city" : "BUTLER", "state" : "PA", "county" : "BUTLER" },"16016": { "city" : "BOYERS", "state" : "PA", "county" : "BUTLER" },
            "16017": { "city" : "BOYERS", "state" : "PA", "county" : "BUTLER" },"16018": { "city" : "BOYERS", "state" : "PA", "county" : "BUTLER" },
            "16020": { "city" : "BOYERS", "state" : "PA", "county" : "BUTLER" },"16021": { "city" : "BRANCHTON", "state" : "PA", "county" : "BUTLER" },
            "16022": { "city" : "BRUIN", "state" : "PA", "county" : "BUTLER" },"16023": { "city" : "CABOT", "state" : "PA", "county" : "BUTLER" },
            "16024": { "city" : "CALLERY", "state" : "PA", "county" : "BUTLER" },
            "16025": { "city" : "CHICORA", "state" : "PA", "county" : "BUTLER" },
            "16027": { "city" : "CONNOQUENESSING", "state" : "PA", "county" : "BUTLER" },
            "16028": { "city" : "EAST BRADY", "state" : "PA", "county" : "CLARION" },
            "16029": { "city" : "EAST BUTLER", "state" : "PA", "county" : "BUTLER" },
            "16030": { "city" : "EAU CLAIRE", "state" : "PA", "county" : "BUTLER" },
            "16033": { "city" : "EVANS CITY", "state" : "PA", "county" : "BUTLER" },
            "16034": { "city" : "FENELTON", "state" : "PA", "county" : "BUTLER" },
            "16035": { "city" : "FORESTVILLE", "state" : "PA", "county" : "BUTLER" },
            "16036": { "city" : "FOXBURG", "state" : "PA", "county" : "CLARION" },
            "16037": { "city" : "HARMONY", "state" : "PA", "county" : "BUTLER" },
            "16038": { "city" : "HARRISVILLE", "state" : "PA", "county" : "BUTLER" },
            "16039": { "city" : "HERMAN", "state" : "PA", "county" : "BUTLER" },"16040": { "city" : "HILLIARDS", "state" : "PA", "county" : "BUTLER" },
            "16041": { "city" : "KARNS CITY", "state" : "PA", "county" : "BUTLER" },
            "16045": { "city" : "LYNDORA", "state" : "PA", "county" : "BUTLER" },
            "16046": { "city" : "MARS", "state" : "PA", "county" : "BUTLER" },"16048": { "city" : "NORTH WASHINGTON", "state" : "PA", "county" : "BUTLER" },
            "16049": { "city" : "PARKER", "state" : "PA", "county" : "ARMSTRONG" },
            "16050": { "city" : "PETROLIA", "state" : "PA", "county" : "BUTLER" },
            "16051": { "city" : "PORTERSVILLE", "state" : "PA", "county" : "BUTLER" },
            "16052": { "city" : "PROSPECT", "state" : "PA", "county" : "BUTLER" },
            "16053": { "city" : "RENFREW", "state" : "PA", "county" : "BUTLER" },
            "16054": { "city" : "SAINT PETERSBURG", "state" : "PA", "county" : "CLARION" },
            "16055": { "city" : "SARVER", "state" : "PA", "county" : "BUTLER" },"16056": { "city" : "SAXONBURG", "state" : "PA", "county" : "BUTLER" },
            "16057": { "city" : "SLIPPERY ROCK", "state" : "PA", "county" : "BUTLER" },
            "16058": { "city" : "TURKEY CITY", "state" : "PA", "county" : "CLARION" },
            "16059": { "city" : "VALENCIA", "state" : "PA", "county" : "BUTLER" },
            "16061": { "city" : "WEST SUNBURY", "state" : "PA", "county" : "BUTLER" },
            "16063": { "city" : "ZELIENOPLE", "state" : "PA", "county" : "BUTLER" },
            "16066": { "city" : "CRANBERRY TWP", "state" : "PA", "county" : "BUTLER" },
            "16101": { "city" : "NEW CASTLE", "state" : "PA", "county" : "LAWRENCE" },
            "16102": { "city" : "NEW CASTLE", "state" : "PA", "county" : "LAWRENCE" },
            "16103": { "city" : "NEW CASTLE", "state" : "PA", "county" : "LAWRENCE" },
            "16105": { "city" : "NEW CASTLE", "state" : "PA", "county" : "LAWRENCE" },
            "16107": { "city" : "NEW CASTLE", "state" : "PA", "county" : "LAWRENCE" },
            "16108": { "city" : "NEW CASTLE", "state" : "PA", "county" : "LAWRENCE" },
            "16110": { "city" : "ADAMSVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16111": { "city" : "ATLANTIC", "state" : "PA", "county" : "CRAWFORD" },
            "16112": { "city" : "BESSEMER", "state" : "PA", "county" : "LAWRENCE" },
            "16113": { "city" : "CLARK", "state" : "PA", "county" : "MERCER" },"16114": { "city" : "CLARKS MILLS", "state" : "PA", "county" : "MERCER" },
            "16115": { "city" : "DARLINGTON", "state" : "PA", "county" : "BEAVER" },
            "16116": { "city" : "EDINBURG", "state" : "PA", "county" : "LAWRENCE" },
            "16117": { "city" : "ELLWOOD CITY", "state" : "PA", "county" : "LAWRENCE" },
            "16120": { "city" : "ENON VALLEY", "state" : "PA", "county" : "LAWRENCE" },
            "16121": { "city" : "FARRELL", "state" : "PA", "county" : "MERCER" },
            "16123": { "city" : "FOMBELL", "state" : "PA", "county" : "BEAVER" },
            "16124": { "city" : "FREDONIA", "state" : "PA", "county" : "MERCER" },
            "16125": { "city" : "GREENVILLE", "state" : "PA", "county" : "MERCER" },
            "16127": { "city" : "GROVE CITY", "state" : "PA", "county" : "MERCER" },
            "16130": { "city" : "HADLEY", "state" : "PA", "county" : "MERCER" },"16131": { "city" : "HARTSTOWN", "state" : "PA", "county" : "CRAWFORD" },
            "16132": { "city" : "HILLSVILLE", "state" : "PA", "county" : "LAWRENCE" },
            "16133": { "city" : "JACKSON CENTER", "state" : "PA", "county" : "MERCER" },
            "16134": { "city" : "JAMESTOWN", "state" : "PA", "county" : "MERCER" },
            "16136": { "city" : "KOPPEL", "state" : "PA", "county" : "BEAVER" },"16137": { "city" : "MERCER", "state" : "PA", "county" : "MERCER" },
            "16140": { "city" : "NEW BEDFORD", "state" : "PA", "county" : "LAWRENCE" },
            "16141": { "city" : "NEW GALILEE", "state" : "PA", "county" : "BEAVER" },
            "16142": { "city" : "NEW WILMINGTON", "state" : "PA", "county" : "LAWRENCE" },
            "16143": { "city" : "PULASKI", "state" : "PA", "county" : "LAWRENCE" },
            "16145": { "city" : "SANDY LAKE", "state" : "PA", "county" : "MERCER" },
            "16146": { "city" : "SHARON", "state" : "PA", "county" : "MERCER" },"16148": { "city" : "HERMITAGE", "state" : "PA", "county" : "MERCER" },
            "16150": { "city" : "SHARPSVILLE", "state" : "PA", "county" : "MERCER" },
            "16151": { "city" : "SHEAKLEYVILLE", "state" : "PA", "county" : "MERCER" },
            "16153": { "city" : "STONEBORO", "state" : "PA", "county" : "MERCER" },
            "16154": { "city" : "TRANSFER", "state" : "PA", "county" : "MERCER" },
            "16155": { "city" : "VILLA MARIA", "state" : "PA", "county" : "LAWRENCE" },
            "16156": { "city" : "VOLANT", "state" : "PA", "county" : "LAWRENCE" },
            "16157": { "city" : "WAMPUM", "state" : "PA", "county" : "LAWRENCE" },
            "16159": { "city" : "WEST MIDDLESEX", "state" : "PA", "county" : "MERCER" },
            "16160": { "city" : "WEST PITTSBURG", "state" : "PA", "county" : "LAWRENCE" },
            "16161": { "city" : "WHEATLAND", "state" : "PA", "county" : "MERCER" },
            "16172": { "city" : "NEW WILMINGTON", "state" : "PA", "county" : "LAWRENCE" },
            "16201": { "city" : "KITTANNING", "state" : "PA", "county" : "ARMSTRONG" },
            "16210": { "city" : "ADRIAN", "state" : "PA", "county" : "ARMSTRONG" },
            "16211": { "city" : "BEYER", "state" : "PA", "county" : "INDIANA" },"16212": { "city" : "CADOGAN", "state" : "PA", "county" : "ARMSTRONG" },
            "16213": { "city" : "CALLENSBURG", "state" : "PA", "county" : "CLARION" },
            "16214": { "city" : "CLARION", "state" : "PA", "county" : "CLARION" },
            "16217": { "city" : "COOKSBURG", "state" : "PA", "county" : "FOREST" },
            "16218": { "city" : "COWANSVILLE", "state" : "PA", "county" : "ARMSTRONG" },
            "16220": { "city" : "CROWN", "state" : "PA", "county" : "CLARION" },"16222": { "city" : "DAYTON", "state" : "PA", "county" : "ARMSTRONG" },
            "16223": { "city" : "DISTANT", "state" : "PA", "county" : "ARMSTRONG" },
            "16224": { "city" : "FAIRMOUNT CITY", "state" : "PA", "county" : "CLARION" },
            "16226": { "city" : "FORD CITY", "state" : "PA", "county" : "ARMSTRONG" },
            "16228": { "city" : "FORD CLIFF", "state" : "PA", "county" : "ARMSTRONG" },
            "16229": { "city" : "FREEPORT", "state" : "PA", "county" : "ARMSTRONG" },
            "16230": { "city" : "HAWTHORN", "state" : "PA", "county" : "CLARION" },
            "16232": { "city" : "KNOX", "state" : "PA", "county" : "CLARION" },"16233": { "city" : "LEEPER", "state" : "PA", "county" : "CLARION" },
            "16234": { "city" : "LIMESTONE", "state" : "PA", "county" : "CLARION" },
            "16235": { "city" : "LUCINDA", "state" : "PA", "county" : "CLARION" },
            "16236": { "city" : "MC GRANN", "state" : "PA", "county" : "ARMSTRONG" },
            "16238": { "city" : "MANORVILLE", "state" : "PA", "county" : "ARMSTRONG" },
            "16239": { "city" : "MARIENVILLE", "state" : "PA", "county" : "FOREST" },
            "16240": { "city" : "MAYPORT", "state" : "PA", "county" : "CLARION" },
            "16242": { "city" : "NEW BETHLEHEM", "state" : "PA", "county" : "CLARION" },
            "16244": { "city" : "NU MINE", "state" : "PA", "county" : "ARMSTRONG" },
            "16245": { "city" : "OAK RIDGE", "state" : "PA", "county" : "ARMSTRONG" },
            "16246": { "city" : "PLUMVILLE", "state" : "PA", "county" : "INDIANA" },
            "16248": { "city" : "RIMERSBURG", "state" : "PA", "county" : "CLARION" },
            "16249": { "city" : "RURAL VALLEY", "state" : "PA", "county" : "ARMSTRONG" },
            "16250": { "city" : "SAGAMORE", "state" : "PA", "county" : "ARMSTRONG" },
            "16253": { "city" : "SEMINOLE", "state" : "PA", "county" : "ARMSTRONG" },
            "16254": { "city" : "SHIPPENVILLE", "state" : "PA", "county" : "CLARION" },
            "16255": { "city" : "SLIGO", "state" : "PA", "county" : "CLARION" },"16256": { "city" : "SMICKSBURG", "state" : "PA", "county" : "INDIANA" },
            "16258": { "city" : "STRATTANVILLE", "state" : "PA", "county" : "CLARION" },
            "16259": { "city" : "TEMPLETON", "state" : "PA", "county" : "ARMSTRONG" },
            "16260": { "city" : "VOWINCKEL", "state" : "PA", "county" : "CLARION" },
            "16262": { "city" : "WORTHINGTON", "state" : "PA", "county" : "ARMSTRONG" },
            "16263": { "city" : "YATESBORO", "state" : "PA", "county" : "ARMSTRONG" },
            "16301": { "city" : "OIL CITY", "state" : "PA", "county" : "VENANGO" },
            "16311": { "city" : "CARLTON", "state" : "PA", "county" : "MERCER" },
            "16312": { "city" : "CHANDLERS VALLEY", "state" : "PA", "county" : "WARREN" },
            "16313": { "city" : "CLARENDON", "state" : "PA", "county" : "WARREN" },
            "16314": { "city" : "COCHRANTON", "state" : "PA", "county" : "CRAWFORD" },
            "16316": { "city" : "CONNEAUT LAKE", "state" : "PA", "county" : "CRAWFORD" },
            "16317": { "city" : "COOPERSTOWN", "state" : "PA", "county" : "VENANGO" },
            "16319": { "city" : "CRANBERRY", "state" : "PA", "county" : "VENANGO" },
            "16321": { "city" : "EAST HICKORY", "state" : "PA", "county" : "FOREST" },
            "16322": { "city" : "ENDEAVOR", "state" : "PA", "county" : "FOREST" },
            "16323": { "city" : "FRANKLIN", "state" : "PA", "county" : "VENANGO" },
            "16326": { "city" : "FRYBURG", "state" : "PA", "county" : "CLARION" },
            "16327": { "city" : "GUYS MILLS", "state" : "PA", "county" : "CRAWFORD" },
            "16328": { "city" : "HYDETOWN", "state" : "PA", "county" : "CRAWFORD" },
            "16329": { "city" : "IRVINE", "state" : "PA", "county" : "WARREN" },"16331": { "city" : "KOSSUTH", "state" : "PA", "county" : "CLARION" },
            "16333": { "city" : "LUDLOW", "state" : "PA", "county" : "MCKEAN" },"16334": { "city" : "MARBLE", "state" : "PA", "county" : "CLARION" },
            "16335": { "city" : "MEADVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16340": { "city" : "PITTSFIELD", "state" : "PA", "county" : "WARREN" },
            "16341": { "city" : "PLEASANTVILLE", "state" : "PA", "county" : "VENANGO" },
            "16342": { "city" : "POLK", "state" : "PA", "county" : "VENANGO" },"16343": { "city" : "RENO", "state" : "PA", "county" : "VENANGO" },
            "16344": { "city" : "ROUSEVILLE", "state" : "PA", "county" : "VENANGO" },
            "16345": { "city" : "RUSSELL", "state" : "PA", "county" : "WARREN" },
            "16346": { "city" : "SENECA", "state" : "PA", "county" : "VENANGO" },
            "16347": { "city" : "SHEFFIELD", "state" : "PA", "county" : "WARREN" },
            "16350": { "city" : "SUGAR GROVE", "state" : "PA", "county" : "WARREN" },
            "16351": { "city" : "TIDIOUTE", "state" : "PA", "county" : "WARREN" },
            "16352": { "city" : "TIONA", "state" : "PA", "county" : "WARREN" },"16353": { "city" : "TIONESTA", "state" : "PA", "county" : "FOREST" },
            "16354": { "city" : "TITUSVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16360": { "city" : "TOWNVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16361": { "city" : "TYLERSBURG", "state" : "PA", "county" : "CLARION" },
            "16362": { "city" : "UTICA", "state" : "PA", "county" : "VENANGO" },"16364": { "city" : "VENUS", "state" : "PA", "county" : "VENANGO" },
            "16365": { "city" : "WARREN", "state" : "PA", "county" : "WARREN" },"16370": { "city" : "WEST HICKORY", "state" : "PA", "county" : "FOREST" },
            "16371": { "city" : "YOUNGSVILLE", "state" : "PA", "county" : "WARREN" },
            "16372": { "city" : "CLINTONVILLE", "state" : "PA", "county" : "VENANGO" },
            "16373": { "city" : "EMLENTON", "state" : "PA", "county" : "VENANGO" },
            "16374": { "city" : "KENNERDELL", "state" : "PA", "county" : "VENANGO" },
            "16375": { "city" : "LAMARTINE", "state" : "PA", "county" : "CLARION" },
            "16401": { "city" : "ALBION", "state" : "PA", "county" : "ERIE" },"16402": { "city" : "BEAR LAKE", "state" : "PA", "county" : "WARREN" },
            "16403": { "city" : "CAMBRIDGE SPRINGS", "state" : "PA", "county" : "CRAWFORD" },
            "16404": { "city" : "CENTERVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16405": { "city" : "COLUMBUS", "state" : "PA", "county" : "WARREN" },
            "16406": { "city" : "CONNEAUTVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16407": { "city" : "CORRY", "state" : "PA", "county" : "ERIE" },"16410": { "city" : "CRANESVILLE", "state" : "PA", "county" : "ERIE" },
            "16411": { "city" : "EAST SPRINGFIELD", "state" : "PA", "county" : "ERIE" },
            "16412": { "city" : "EDINBORO", "state" : "PA", "county" : "ERIE" },"16415": { "city" : "FAIRVIEW", "state" : "PA", "county" : "ERIE" },
            "16416": { "city" : "GARLAND", "state" : "PA", "county" : "WARREN" },
            "16417": { "city" : "GIRARD", "state" : "PA", "county" : "ERIE" },"16420": { "city" : "GRAND VALLEY", "state" : "PA", "county" : "WARREN" },
            "16421": { "city" : "HARBORCREEK", "state" : "PA", "county" : "ERIE" },
            "16422": { "city" : "HARMONSBURG", "state" : "PA", "county" : "CRAWFORD" },
            "16423": { "city" : "LAKE CITY", "state" : "PA", "county" : "ERIE" },
            "16424": { "city" : "LINESVILLE", "state" : "PA", "county" : "CRAWFORD" },
            "16426": { "city" : "MC KEAN", "state" : "PA", "county" : "ERIE" },"16427": { "city" : "MILL VILLAGE", "state" : "PA", "county" : "ERIE" },
            "16428": { "city" : "NORTH EAST", "state" : "PA", "county" : "ERIE" },
            "16430": { "city" : "NORTH SPRINGFIELD", "state" : "PA", "county" : "ERIE" },
            "16433": { "city" : "SAEGERTOWN", "state" : "PA", "county" : "CRAWFORD" },
            "16434": { "city" : "SPARTANSBURG", "state" : "PA", "county" : "CRAWFORD" },
            "16435": { "city" : "SPRINGBORO", "state" : "PA", "county" : "CRAWFORD" },
            "16436": { "city" : "SPRING CREEK", "state" : "PA", "county" : "WARREN" },
            "16438": { "city" : "UNION CITY", "state" : "PA", "county" : "ERIE" },
            "16440": { "city" : "VENANGO", "state" : "PA", "county" : "CRAWFORD" },
            "16441": { "city" : "WATERFORD", "state" : "PA", "county" : "ERIE" },
            "16442": { "city" : "WATTSBURG", "state" : "PA", "county" : "ERIE" },
            "16443": { "city" : "WEST SPRINGFIELD", "state" : "PA", "county" : "ERIE" },
            "16444": { "city" : "EDINBORO", "state" : "PA", "county" : "ERIE" },"16475": { "city" : "ALBION", "state" : "PA", "county" : "ERIE" },
            "16501": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16502": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16503": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16504": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16505": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16506": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16507": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16508": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16509": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16510": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16511": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16512": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16514": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16515": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16530": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16531": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16534": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16541": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16544": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16546": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16550": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16563": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },
            "16565": { "city" : "ERIE", "state" : "PA", "county" : "ERIE" },"16601": { "city" : "ALTOONA", "state" : "PA", "county" : "BLAIR" },
            "16602": { "city" : "ALTOONA", "state" : "PA", "county" : "BLAIR" },"16603": { "city" : "ALTOONA", "state" : "PA", "county" : "BLAIR" },
            "16611": { "city" : "ALEXANDRIA", "state" : "PA", "county" : "HUNTINGDON" },
            "16613": { "city" : "ASHVILLE", "state" : "PA", "county" : "CAMBRIA" },
            "16616": { "city" : "BECCARIA", "state" : "PA", "county" : "CLEARFIELD" },
            "16617": { "city" : "BELLWOOD", "state" : "PA", "county" : "BLAIR" },
            "16619": { "city" : "BLANDBURG", "state" : "PA", "county" : "CAMBRIA" },
            "16620": { "city" : "BRISBIN", "state" : "PA", "county" : "CLEARFIELD" },
            "16621": { "city" : "BROAD TOP", "state" : "PA", "county" : "HUNTINGDON" },
            "16622": { "city" : "CALVIN", "state" : "PA", "county" : "HUNTINGDON" },
            "16623": { "city" : "CASSVILLE", "state" : "PA", "county" : "HUNTINGDON" },
            "16624": { "city" : "CHEST SPRINGS", "state" : "PA", "county" : "CAMBRIA" },
            "16625": { "city" : "CLAYSBURG", "state" : "PA", "county" : "BLAIR" },
            "16627": { "city" : "COALPORT", "state" : "PA", "county" : "CLEARFIELD" },
            "16629": { "city" : "COUPON", "state" : "PA", "county" : "CAMBRIA" },
            "16630": { "city" : "CRESSON", "state" : "PA", "county" : "CAMBRIA" },
            "16631": { "city" : "CURRYVILLE", "state" : "PA", "county" : "BLAIR" },
            "16633": { "city" : "DEFIANCE", "state" : "PA", "county" : "BEDFORD" },
            "16634": { "city" : "DUDLEY", "state" : "PA", "county" : "HUNTINGDON" },
            "16635": { "city" : "DUNCANSVILLE", "state" : "PA", "county" : "BLAIR" },
            "16636": { "city" : "DYSART", "state" : "PA", "county" : "CAMBRIA" },
            "16637": { "city" : "EAST FREEDOM", "state" : "PA", "county" : "BLAIR" },
            "16638": { "city" : "ENTRIKEN", "state" : "PA", "county" : "HUNTINGDON" },
            "16639": { "city" : "FALLENTIMBER", "state" : "PA", "county" : "CAMBRIA" },
            "16640": { "city" : "FLINTON", "state" : "PA", "county" : "CAMBRIA" },
            "16641": { "city" : "GALLITZIN", "state" : "PA", "county" : "CAMBRIA" },
            "16644": { "city" : "GLASGOW", "state" : "PA", "county" : "CAMBRIA" },
            "16645": { "city" : "GLEN HOPE", "state" : "PA", "county" : "CLEARFIELD" },
            "16646": { "city" : "HASTINGS", "state" : "PA", "county" : "CAMBRIA" },
            "16647": { "city" : "HESSTON", "state" : "PA", "county" : "HUNTINGDON" },
            "16648": { "city" : "HOLLIDAYSBURG", "state" : "PA", "county" : "BLAIR" },
            "16650": { "city" : "HOPEWELL", "state" : "PA", "county" : "BEDFORD" },
            "16651": { "city" : "HOUTZDALE", "state" : "PA", "county" : "CLEARFIELD" },
            "16652": { "city" : "HUNTINGDON", "state" : "PA", "county" : "HUNTINGDON" },
            "16654": { "city" : "HUNTINGDON", "state" : "PA", "county" : "HUNTINGDON" },
            "16655": { "city" : "IMLER", "state" : "PA", "county" : "BEDFORD" },"16656": { "city" : "IRVONA", "state" : "PA", "county" : "CLEARFIELD" },
            "16657": { "city" : "JAMES CREEK", "state" : "PA", "county" : "HUNTINGDON" },
            "16659": { "city" : "LOYSBURG", "state" : "PA", "county" : "BEDFORD" },
            "16660": { "city" : "MC CONNELLSTOWN", "state" : "PA", "county" : "HUNTINGDON" },
            "16661": { "city" : "MADERA", "state" : "PA", "county" : "CLEARFIELD" },
            "16662": { "city" : "MARTINSBURG", "state" : "PA", "county" : "BLAIR" },
            "16663": { "city" : "MORANN", "state" : "PA", "county" : "CLEARFIELD" },
            "16664": { "city" : "NEW ENTERPRISE", "state" : "PA", "county" : "BEDFORD" },
            "16665": { "city" : "NEWRY", "state" : "PA", "county" : "BLAIR" },"16666": { "city" : "OSCEOLA MILLS", "state" : "PA", "county" : "CLEARFIELD" },
            "16667": { "city" : "OSTERBURG", "state" : "PA", "county" : "BEDFORD" },
            "16668": { "city" : "PATTON", "state" : "PA", "county" : "CAMBRIA" },
            "16669": { "city" : "PETERSBURG", "state" : "PA", "county" : "HUNTINGDON" },
            "16671": { "city" : "RAMEY", "state" : "PA", "county" : "CLEARFIELD" },
            "16672": { "city" : "RIDDLESBURG", "state" : "PA", "county" : "BEDFORD" },
            "16673": { "city" : "ROARING SPRING", "state" : "PA", "county" : "BLAIR" },
            "16674": { "city" : "ROBERTSDALE", "state" : "PA", "county" : "HUNTINGDON" },
            "16675": { "city" : "SAINT BONIFACE", "state" : "PA", "county" : "CAMBRIA" },
            "16677": { "city" : "SANDY RIDGE", "state" : "PA", "county" : "CENTRE" },
            "16678": { "city" : "SAXTON", "state" : "PA", "county" : "BEDFORD" },
            "16679": { "city" : "SIX MILE RUN", "state" : "PA", "county" : "BEDFORD" },
            "16680": { "city" : "SMITHMILL", "state" : "PA", "county" : "CLEARFIELD" },
            "16681": { "city" : "SMOKERUN", "state" : "PA", "county" : "CLEARFIELD" },
            "16682": { "city" : "SPROUL", "state" : "PA", "county" : "BLAIR" },"16683": { "city" : "SPRUCE CREEK", "state" : "PA", "county" : "HUNTINGDON" },
            "16684": { "city" : "TIPTON", "state" : "PA", "county" : "BLAIR" },"16685": { "city" : "TODD", "state" : "PA", "county" : "HUNTINGDON" },
            "16686": { "city" : "TYRONE", "state" : "PA", "county" : "BLAIR" },"16689": { "city" : "WATERFALL", "state" : "PA", "county" : "FULTON" },
            "16692": { "city" : "WESTOVER", "state" : "PA", "county" : "CLEARFIELD" },
            "16693": { "city" : "WILLIAMSBURG", "state" : "PA", "county" : "BLAIR" },
            "16695": { "city" : "WOODBURY", "state" : "PA", "county" : "BEDFORD" },
            "16698": { "city" : "HOUTZDALE", "state" : "PA", "county" : "CLEARFIELD" },
            "16699": { "city" : "CRESSON", "state" : "PA", "county" : "CAMBRIA" },
            "16701": { "city" : "BRADFORD", "state" : "PA", "county" : "MCKEAN" },
            "16720": { "city" : "AUSTIN", "state" : "PA", "county" : "POTTER" },"16724": { "city" : "CROSBY", "state" : "PA", "county" : "MCKEAN" },
            "16725": { "city" : "CUSTER CITY", "state" : "PA", "county" : "MCKEAN" },
            "16726": { "city" : "CYCLONE", "state" : "PA", "county" : "MCKEAN" },
            "16727": { "city" : "DERRICK CITY", "state" : "PA", "county" : "MCKEAN" },
            "16728": { "city" : "DE YOUNG", "state" : "PA", "county" : "ELK" },"16729": { "city" : "DUKE CENTER", "state" : "PA", "county" : "MCKEAN" },
            "16730": { "city" : "EAST SMETHPORT", "state" : "PA", "county" : "MCKEAN" },
            "16731": { "city" : "ELDRED", "state" : "PA", "county" : "MCKEAN" },"16732": { "city" : "GIFFORD", "state" : "PA", "county" : "MCKEAN" },
            "16733": { "city" : "HAZEL HURST", "state" : "PA", "county" : "MCKEAN" },
            "16734": { "city" : "JAMES CITY", "state" : "PA", "county" : "ELK" },
            "16735": { "city" : "KANE", "state" : "PA", "county" : "MCKEAN" },"16738": { "city" : "LEWIS RUN", "state" : "PA", "county" : "MCKEAN" },
            "16740": { "city" : "MOUNT JEWETT", "state" : "PA", "county" : "MCKEAN" },
            "16743": { "city" : "PORT ALLEGANY", "state" : "PA", "county" : "MCKEAN" },
            "16744": { "city" : "REW", "state" : "PA", "county" : "MCKEAN" },"16745": { "city" : "RIXFORD", "state" : "PA", "county" : "MCKEAN" },
            "16746": { "city" : "ROULETTE", "state" : "PA", "county" : "POTTER" },
            "16748": { "city" : "SHINGLEHOUSE", "state" : "PA", "county" : "POTTER" },
            "16749": { "city" : "SMETHPORT", "state" : "PA", "county" : "MCKEAN" },
            "16750": { "city" : "TURTLEPOINT", "state" : "PA", "county" : "MCKEAN" },
            "16801": { "city" : "STATE COLLEGE", "state" : "PA", "county" : "CENTRE" },
            "16802": { "city" : "UNIVERSITY PARK", "state" : "PA", "county" : "CENTRE" },
            "16803": { "city" : "STATE COLLEGE", "state" : "PA", "county" : "CENTRE" },
            "16804": { "city" : "STATE COLLEGE", "state" : "PA", "county" : "CENTRE" },
            "16805": { "city" : "STATE COLLEGE", "state" : "PA", "county" : "CENTRE" },
            "16820": { "city" : "AARONSBURG", "state" : "PA", "county" : "CENTRE" },
            "16821": { "city" : "ALLPORT", "state" : "PA", "county" : "CLEARFIELD" },
            "16822": { "city" : "BEECH CREEK", "state" : "PA", "county" : "CLINTON" },
            "16823": { "city" : "BELLEFONTE", "state" : "PA", "county" : "CENTRE" },
            "16825": { "city" : "BIGLER", "state" : "PA", "county" : "CLEARFIELD" },
            "16826": { "city" : "BLANCHARD", "state" : "PA", "county" : "CENTRE" },
            "16827": { "city" : "BOALSBURG", "state" : "PA", "county" : "CENTRE" },
            "16828": { "city" : "CENTRE HALL", "state" : "PA", "county" : "CENTRE" },
            "16829": { "city" : "CLARENCE", "state" : "PA", "county" : "CENTRE" },
            "16830": { "city" : "CLEARFIELD", "state" : "PA", "county" : "CLEARFIELD" },
            "16832": { "city" : "COBURN", "state" : "PA", "county" : "CENTRE" },"16833": { "city" : "CURWENSVILLE", "state" : "PA", "county" : "CLEARFIELD" },
            "16834": { "city" : "DRIFTING", "state" : "PA", "county" : "CLEARFIELD" },
            "16835": { "city" : "FLEMING", "state" : "PA", "county" : "CENTRE" },
            "16836": { "city" : "FRENCHVILLE", "state" : "PA", "county" : "CLEARFIELD" },
            "16837": { "city" : "GLEN RICHEY", "state" : "PA", "county" : "CLEARFIELD" },
            "16838": { "city" : "GRAMPIAN", "state" : "PA", "county" : "CLEARFIELD" },
            "16839": { "city" : "GRASSFLAT", "state" : "PA", "county" : "CLEARFIELD" },
            "16840": { "city" : "HAWK RUN", "state" : "PA", "county" : "CLEARFIELD" },
            "16841": { "city" : "HOWARD", "state" : "PA", "county" : "CENTRE" },"16843": { "city" : "HYDE", "state" : "PA", "county" : "CLEARFIELD" },
            "16844": { "city" : "JULIAN", "state" : "PA", "county" : "CENTRE" },"16845": { "city" : "KARTHAUS", "state" : "PA", "county" : "CLEARFIELD" },
            "16847": { "city" : "KYLERTOWN", "state" : "PA", "county" : "CLEARFIELD" },
            "16848": { "city" : "LAMAR", "state" : "PA", "county" : "CLINTON" },"16849": { "city" : "LANSE", "state" : "PA", "county" : "CLEARFIELD" },
            "16851": { "city" : "LEMONT", "state" : "PA", "county" : "CENTRE" },"16852": { "city" : "MADISONBURG", "state" : "PA", "county" : "CENTRE" },
            "16853": { "city" : "MILESBURG", "state" : "PA", "county" : "CENTRE" },
            "16854": { "city" : "MILLHEIM", "state" : "PA", "county" : "CENTRE" },
            "16855": { "city" : "MINERAL SPRINGS", "state" : "PA", "county" : "CLEARFIELD" },
            "16856": { "city" : "MINGOVILLE", "state" : "PA", "county" : "CENTRE" },
            "16858": { "city" : "MORRISDALE", "state" : "PA", "county" : "CLEARFIELD" },
            "16859": { "city" : "MOSHANNON", "state" : "PA", "county" : "CENTRE" },
            "16860": { "city" : "MUNSON", "state" : "PA", "county" : "CLEARFIELD" },
            "16861": { "city" : "NEW MILLPORT", "state" : "PA", "county" : "CLEARFIELD" },
            "16863": { "city" : "OLANTA", "state" : "PA", "county" : "CLEARFIELD" },
            "16865": { "city" : "PENNSYLVANIA FURNACE", "state" : "PA", "county" : "CENTRE" },
            "16866": { "city" : "PHILIPSBURG", "state" : "PA", "county" : "CENTRE" },
            "16868": { "city" : "PINE GROVE MILLS", "state" : "PA", "county" : "CENTRE" },
            "16870": { "city" : "PORT MATILDA", "state" : "PA", "county" : "CENTRE" },
            "16872": { "city" : "REBERSBURG", "state" : "PA", "county" : "CENTRE" },
            "16873": { "city" : "SHAWVILLE", "state" : "PA", "county" : "CLEARFIELD" },
            "16874": { "city" : "SNOW SHOE", "state" : "PA", "county" : "CENTRE" },
            "16875": { "city" : "SPRING MILLS", "state" : "PA", "county" : "CENTRE" },
            "16876": { "city" : "WALLACETON", "state" : "PA", "county" : "CLEARFIELD" },
            "16877": { "city" : "WARRIORS MARK", "state" : "PA", "county" : "HUNTINGDON" },
            "16878": { "city" : "WEST DECATUR", "state" : "PA", "county" : "CLEARFIELD" },
            "16879": { "city" : "WINBURNE", "state" : "PA", "county" : "CLEARFIELD" },
            "16881": { "city" : "WOODLAND", "state" : "PA", "county" : "CLEARFIELD" },
            "16882": { "city" : "WOODWARD", "state" : "PA", "county" : "CENTRE" },
            "16901": { "city" : "WELLSBORO", "state" : "PA", "county" : "TIOGA" },
            "16911": { "city" : "ARNOT", "state" : "PA", "county" : "TIOGA" },"16912": { "city" : "BLOSSBURG", "state" : "PA", "county" : "TIOGA" },
            "16914": { "city" : "COLUMBIA CROSS ROADS", "state" : "PA", "county" : "BRADFORD" },
            "16915": { "city" : "COUDERSPORT", "state" : "PA", "county" : "POTTER" },
            "16917": { "city" : "COVINGTON", "state" : "PA", "county" : "TIOGA" },
            "16920": { "city" : "ELKLAND", "state" : "PA", "county" : "TIOGA" },"16921": { "city" : "GAINES", "state" : "PA", "county" : "TIOGA" },
            "16922": { "city" : "GALETON", "state" : "PA", "county" : "POTTER" },
            "16923": { "city" : "GENESEE", "state" : "PA", "county" : "POTTER" },
            "16925": { "city" : "GILLETT", "state" : "PA", "county" : "BRADFORD" },
            "16926": { "city" : "GRANVILLE SUMMIT", "state" : "PA", "county" : "BRADFORD" },
            "16927": { "city" : "HARRISON VALLEY", "state" : "PA", "county" : "POTTER" },
            "16928": { "city" : "KNOXVILLE", "state" : "PA", "county" : "TIOGA" },
            "16929": { "city" : "LAWRENCEVILLE", "state" : "PA", "county" : "TIOGA" },
            "16930": { "city" : "LIBERTY", "state" : "PA", "county" : "TIOGA" },"16932": { "city" : "MAINESBURG", "state" : "PA", "county" : "TIOGA" },
            "16933": { "city" : "MANSFIELD", "state" : "PA", "county" : "TIOGA" },
            "16935": { "city" : "MIDDLEBURY CENTER", "state" : "PA", "county" : "TIOGA" },
            "16936": { "city" : "MILLERTON", "state" : "PA", "county" : "TIOGA" },
            "16937": { "city" : "MILLS", "state" : "PA", "county" : "POTTER" },"16938": { "city" : "MORRIS", "state" : "PA", "county" : "TIOGA" },
            "16939": { "city" : "MORRIS RUN", "state" : "PA", "county" : "TIOGA" },
            "16940": { "city" : "NELSON", "state" : "PA", "county" : "TIOGA" },"16941": { "city" : "GENESEE", "state" : "PA", "county" : "POTTER" },
            "16942": { "city" : "OSCEOLA", "state" : "PA", "county" : "TIOGA" },"16943": { "city" : "SABINSVILLE", "state" : "PA", "county" : "TIOGA" },
            "16945": { "city" : "SYLVANIA", "state" : "PA", "county" : "BRADFORD" },
            "16946": { "city" : "TIOGA", "state" : "PA", "county" : "TIOGA" },"16947": { "city" : "TROY", "state" : "PA", "county" : "BRADFORD" },
            "16948": { "city" : "ULYSSES", "state" : "PA", "county" : "POTTER" },
            "16950": { "city" : "WESTFIELD", "state" : "PA", "county" : "TIOGA" },
            "17001": { "city" : "CAMP HILL", "state" : "PA", "county" : "CUMBERLAND" },
            "17002": { "city" : "ALLENSVILLE", "state" : "PA", "county" : "MIFFLIN" },
            "17003": { "city" : "ANNVILLE", "state" : "PA", "county" : "LEBANON" },
            "17004": { "city" : "BELLEVILLE", "state" : "PA", "county" : "MIFFLIN" },
            "17005": { "city" : "BERRYSBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17006": { "city" : "BLAIN", "state" : "PA", "county" : "PERRY" },"17007": { "city" : "BOILING SPRINGS", "state" : "PA", "county" : "CUMBERLAND" },
            "17009": { "city" : "BURNHAM", "state" : "PA", "county" : "MIFFLIN" },
            "17010": { "city" : "CAMPBELLTOWN", "state" : "PA", "county" : "LEBANON" },
            "17011": { "city" : "CAMP HILL", "state" : "PA", "county" : "CUMBERLAND" },
            "17012": { "city" : "CAMP HILL", "state" : "PA", "county" : "CUMBERLAND" },
            "17013": { "city" : "CARLISLE", "state" : "PA", "county" : "CUMBERLAND" },
            "17014": { "city" : "COCOLAMUS", "state" : "PA", "county" : "JUNIATA" },
            "17015": { "city" : "CARLISLE", "state" : "PA", "county" : "CUMBERLAND" },
            "17016": { "city" : "CORNWALL", "state" : "PA", "county" : "LEBANON" },
            "17017": { "city" : "DALMATIA", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17018": { "city" : "DAUPHIN", "state" : "PA", "county" : "DAUPHIN" },
            "17019": { "city" : "DILLSBURG", "state" : "PA", "county" : "YORK" },
            "17020": { "city" : "DUNCANNON", "state" : "PA", "county" : "PERRY" },
            "17021": { "city" : "EAST WATERFORD", "state" : "PA", "county" : "JUNIATA" },
            "17022": { "city" : "ELIZABETHTOWN", "state" : "PA", "county" : "LANCASTER" },
            "17023": { "city" : "ELIZABETHVILLE", "state" : "PA", "county" : "DAUPHIN" },
            "17024": { "city" : "ELLIOTTSBURG", "state" : "PA", "county" : "PERRY" },
            "17025": { "city" : "ENOLA", "state" : "PA", "county" : "CUMBERLAND" },
            "17026": { "city" : "FREDERICKSBURG", "state" : "PA", "county" : "LEBANON" },
            "17027": { "city" : "GRANTHAM", "state" : "PA", "county" : "CUMBERLAND" },
            "17028": { "city" : "GRANTVILLE", "state" : "PA", "county" : "DAUPHIN" },
            "17029": { "city" : "GRANVILLE", "state" : "PA", "county" : "MIFFLIN" },
            "17030": { "city" : "GRATZ", "state" : "PA", "county" : "DAUPHIN" },"17032": { "city" : "HALIFAX", "state" : "PA", "county" : "DAUPHIN" },
            "17033": { "city" : "HERSHEY", "state" : "PA", "county" : "DAUPHIN" },
            "17034": { "city" : "HIGHSPIRE", "state" : "PA", "county" : "DAUPHIN" },
            "17035": { "city" : "HONEY GROVE", "state" : "PA", "county" : "JUNIATA" },
            "17036": { "city" : "HUMMELSTOWN", "state" : "PA", "county" : "DAUPHIN" },
            "17037": { "city" : "ICKESBURG", "state" : "PA", "county" : "PERRY" },
            "17038": { "city" : "JONESTOWN", "state" : "PA", "county" : "LEBANON" },
            "17039": { "city" : "KLEINFELTERSVILLE", "state" : "PA", "county" : "LEBANON" },
            "17040": { "city" : "LANDISBURG", "state" : "PA", "county" : "PERRY" },
            "17041": { "city" : "LAWN", "state" : "PA", "county" : "LEBANON" },"17042": { "city" : "LEBANON", "state" : "PA", "county" : "LEBANON" },
            "17043": { "city" : "LEMOYNE", "state" : "PA", "county" : "CUMBERLAND" },
            "17044": { "city" : "LEWISTOWN", "state" : "PA", "county" : "MIFFLIN" },
            "17045": { "city" : "LIVERPOOL", "state" : "PA", "county" : "PERRY" },
            "17046": { "city" : "LEBANON", "state" : "PA", "county" : "LEBANON" },
            "17047": { "city" : "LOYSVILLE", "state" : "PA", "county" : "PERRY" },
            "17048": { "city" : "LYKENS", "state" : "PA", "county" : "DAUPHIN" },
            "17049": { "city" : "MC ALISTERVILLE", "state" : "PA", "county" : "JUNIATA" },
            "17050": { "city" : "MECHANICSBURG", "state" : "PA", "county" : "CUMBERLAND" },
            "17051": { "city" : "MC VEYTOWN", "state" : "PA", "county" : "MIFFLIN" },
            "17052": { "city" : "MAPLETON DEPOT", "state" : "PA", "county" : "HUNTINGDON" },
            "17053": { "city" : "MARYSVILLE", "state" : "PA", "county" : "PERRY" },
            "17054": { "city" : "MATTAWANA", "state" : "PA", "county" : "MIFFLIN" },
            "17055": { "city" : "MECHANICSBURG", "state" : "PA", "county" : "CUMBERLAND" },
            "17056": { "city" : "MEXICO", "state" : "PA", "county" : "JUNIATA" },
            "17057": { "city" : "MIDDLETOWN", "state" : "PA", "county" : "DAUPHIN" },
            "17058": { "city" : "MIFFLIN", "state" : "PA", "county" : "JUNIATA" },
            "17059": { "city" : "MIFFLINTOWN", "state" : "PA", "county" : "JUNIATA" },
            "17060": { "city" : "MILL CREEK", "state" : "PA", "county" : "HUNTINGDON" },
            "17061": { "city" : "MILLERSBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17062": { "city" : "MILLERSTOWN", "state" : "PA", "county" : "PERRY" },
            "17063": { "city" : "MILROY", "state" : "PA", "county" : "MIFFLIN" },
            "17064": { "city" : "MOUNT GRETNA", "state" : "PA", "county" : "LEBANON" },
            "17065": { "city" : "MOUNT HOLLY SPRINGS", "state" : "PA", "county" : "CUMBERLAND" },
            "17066": { "city" : "MOUNT UNION", "state" : "PA", "county" : "HUNTINGDON" },
            "17067": { "city" : "MYERSTOWN", "state" : "PA", "county" : "LEBANON" },
            "17068": { "city" : "NEW BLOOMFIELD", "state" : "PA", "county" : "PERRY" },
            "17069": { "city" : "NEW BUFFALO", "state" : "PA", "county" : "PERRY" },
            "17070": { "city" : "NEW CUMBERLAND", "state" : "PA", "county" : "CUMBERLAND" },
            "17071": { "city" : "NEW GERMANTOWN", "state" : "PA", "county" : "PERRY" },
            "17072": { "city" : "NEW KINGSTOWN", "state" : "PA", "county" : "CUMBERLAND" },
            "17073": { "city" : "NEWMANSTOWN", "state" : "PA", "county" : "LEBANON" },
            "17074": { "city" : "NEWPORT", "state" : "PA", "county" : "PERRY" },"17075": { "city" : "NEWTON HAMILTON", "state" : "PA", "county" : "MIFFLIN" },
            "17076": { "city" : "OAKLAND MILLS", "state" : "PA", "county" : "JUNIATA" },
            "17077": { "city" : "ONO", "state" : "PA", "county" : "LEBANON" },"17078": { "city" : "PALMYRA", "state" : "PA", "county" : "LEBANON" },
            "17080": { "city" : "PILLOW", "state" : "PA", "county" : "DAUPHIN" },
            "17081": { "city" : "PLAINFIELD", "state" : "PA", "county" : "CUMBERLAND" },
            "17082": { "city" : "PORT ROYAL", "state" : "PA", "county" : "JUNIATA" },
            "17083": { "city" : "QUENTIN", "state" : "PA", "county" : "LEBANON" },
            "17084": { "city" : "REEDSVILLE", "state" : "PA", "county" : "MIFFLIN" },
            "17085": { "city" : "REXMONT", "state" : "PA", "county" : "LEBANON" },
            "17086": { "city" : "RICHFIELD", "state" : "PA", "county" : "JUNIATA" },
            "17087": { "city" : "RICHLAND", "state" : "PA", "county" : "LEBANON" },
            "17088": { "city" : "SCHAEFFERSTOWN", "state" : "PA", "county" : "LEBANON" },
            "17089": { "city" : "CAMP HILL", "state" : "PA", "county" : "CUMBERLAND" },
            "17090": { "city" : "SHERMANS DALE", "state" : "PA", "county" : "PERRY" },
            "17093": { "city" : "SUMMERDALE", "state" : "PA", "county" : "CUMBERLAND" },
            "17094": { "city" : "THOMPSONTOWN", "state" : "PA", "county" : "JUNIATA" },
            "17097": { "city" : "WICONISCO", "state" : "PA", "county" : "DAUPHIN" },
            "17098": { "city" : "WILLIAMSTOWN", "state" : "PA", "county" : "DAUPHIN" },
            "17099": { "city" : "YEAGERTOWN", "state" : "PA", "county" : "MIFFLIN" },
            "17101": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17102": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17103": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17104": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17105": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17106": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17107": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17108": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17109": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17110": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17111": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17112": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17113": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17120": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17122": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17123": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17125": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17126": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17130": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17140": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17177": { "city" : "HARRISBURG", "state" : "PA", "county" : "DAUPHIN" },
            "17201": { "city" : "CHAMBERSBURG", "state" : "PA", "county" : "FRANKLIN" },
            "17202": { "city" : "CHAMBERSBURG", "state" : "PA", "county" : "FRANKLIN" },
            "17211": { "city" : "ARTEMAS", "state" : "PA", "county" : "BEDFORD" },
            "17212": { "city" : "BIG COVE TANNERY", "state" : "PA", "county" : "FULTON" },
            "17213": { "city" : "BLAIRS MILLS", "state" : "PA", "county" : "HUNTINGDON" },
            "17214": { "city" : "BLUE RIDGE SUMMIT", "state" : "PA", "county" : "FRANKLIN" },
            "17215": { "city" : "BURNT CABINS", "state" : "PA", "county" : "FULTON" },
            "17217": { "city" : "CONCORD", "state" : "PA", "county" : "FRANKLIN" },
            "17219": { "city" : "DOYLESBURG", "state" : "PA", "county" : "FRANKLIN" },
            "17220": { "city" : "DRY RUN", "state" : "PA", "county" : "FRANKLIN" },
            "17221": { "city" : "FANNETTSBURG", "state" : "PA", "county" : "FRANKLIN" },
            "17222": { "city" : "FAYETTEVILLE", "state" : "PA", "county" : "FRANKLIN" },
            "17223": { "city" : "FORT LITTLETON", "state" : "PA", "county" : "FULTON" },
            "17224": { "city" : "FORT LOUDON", "state" : "PA", "county" : "FRANKLIN" },
            "17225": { "city" : "GREENCASTLE", "state" : "PA", "county" : "FRANKLIN" },
            "17228": { "city" : "HARRISONVILLE", "state" : "PA", "county" : "FULTON" },
            "17229": { "city" : "HUSTONTOWN", "state" : "PA", "county" : "FULTON" },
            "17231": { "city" : "LEMASTERS", "state" : "PA", "county" : "FRANKLIN" },
            "17233": { "city" : "MC CONNELLSBURG", "state" : "PA", "county" : "FULTON" },
            "17235": { "city" : "MARION", "state" : "PA", "county" : "FRANKLIN" },
            "17236": { "city" : "MERCERSBURG", "state" : "PA", "county" : "FRANKLIN" },
            "17237": { "city" : "MONT ALTO", "state" : "PA", "county" : "FRANKLIN" },
            "17238": { "city" : "NEEDMORE", "state" : "PA", "county" : "FULTON" },
            "17239": { "city" : "NEELYTON", "state" : "PA", "county" : "HUNTINGDON" },
            "17240": { "city" : "NEWBURG", "state" : "PA", "county" : "CUMBERLAND" },
            "17241": { "city" : "NEWVILLE", "state" : "PA", "county" : "CUMBERLAND" },
            "17243": { "city" : "ORBISONIA", "state" : "PA", "county" : "HUNTINGDON" },
            "17244": { "city" : "ORRSTOWN", "state" : "PA", "county" : "FRANKLIN" },
            "17246": { "city" : "PLEASANT HALL", "state" : "PA", "county" : "FRANKLIN" },
            "17247": { "city" : "QUINCY", "state" : "PA", "county" : "FRANKLIN" },
            "17249": { "city" : "ROCKHILL FURNACE", "state" : "PA", "county" : "HUNTINGDON" },
            "17250": { "city" : "ROUZERVILLE", "state" : "PA", "county" : "FRANKLIN" },
            "17251": { "city" : "ROXBURY", "state" : "PA", "county" : "FRANKLIN" },
            "17252": { "city" : "SAINT THOMAS", "state" : "PA", "county" : "FRANKLIN" },
            "17253": { "city" : "SALTILLO", "state" : "PA", "county" : "HUNTINGDON" },
            "17254": { "city" : "SCOTLAND", "state" : "PA", "county" : "FRANKLIN" },
            "17255": { "city" : "SHADE GAP", "state" : "PA", "county" : "HUNTINGDON" },
            "17256": { "city" : "SHADY GROVE", "state" : "PA", "county" : "FRANKLIN" },
            "17257": { "city" : "SHIPPENSBURG", "state" : "PA", "county" : "CUMBERLAND" },
            "17260": { "city" : "SHIRLEYSBURG", "state" : "PA", "county" : "HUNTINGDON" },
            "17261": { "city" : "SOUTH MOUNTAIN", "state" : "PA", "county" : "FRANKLIN" },
            "17262": { "city" : "SPRING RUN", "state" : "PA", "county" : "FRANKLIN" },
            "17263": { "city" : "STATE LINE", "state" : "PA", "county" : "FRANKLIN" },
            "17264": { "city" : "THREE SPRINGS", "state" : "PA", "county" : "HUNTINGDON" },
            "17265": { "city" : "UPPERSTRASBURG", "state" : "PA", "county" : "FRANKLIN" },
            "17266": { "city" : "WALNUT BOTTOM", "state" : "PA", "county" : "CUMBERLAND" },
            "17267": { "city" : "WARFORDSBURG", "state" : "PA", "county" : "FULTON" },
            "17268": { "city" : "WAYNESBORO", "state" : "PA", "county" : "FRANKLIN" },
            "17270": { "city" : "WILLIAMSON", "state" : "PA", "county" : "FRANKLIN" },
            "17271": { "city" : "WILLOW HILL", "state" : "PA", "county" : "FRANKLIN" },
            "17272": { "city" : "ZULLINGER", "state" : "PA", "county" : "FRANKLIN" },
            "17301": { "city" : "ABBOTTSTOWN", "state" : "PA", "county" : "ADAMS" },
            "17302": { "city" : "AIRVILLE", "state" : "PA", "county" : "YORK" },"17303": { "city" : "ARENDTSVILLE", "state" : "PA", "county" : "ADAMS" },
            "17304": { "city" : "ASPERS", "state" : "PA", "county" : "ADAMS" },"17306": { "city" : "BENDERSVILLE", "state" : "PA", "county" : "ADAMS" },
            "17307": { "city" : "BIGLERVILLE", "state" : "PA", "county" : "ADAMS" },
            "17309": { "city" : "BROGUE", "state" : "PA", "county" : "YORK" },"17310": { "city" : "CASHTOWN", "state" : "PA", "county" : "ADAMS" },
            "17311": { "city" : "CODORUS", "state" : "PA", "county" : "YORK" },"17312": { "city" : "CRALEY", "state" : "PA", "county" : "YORK" },
            "17313": { "city" : "DALLASTOWN", "state" : "PA", "county" : "YORK" },
            "17314": { "city" : "DELTA", "state" : "PA", "county" : "YORK" },"17315": { "city" : "DOVER", "state" : "PA", "county" : "YORK" },
            "17316": { "city" : "EAST BERLIN", "state" : "PA", "county" : "ADAMS" },
            "17317": { "city" : "EAST PROSPECT", "state" : "PA", "county" : "YORK" },
            "17318": { "city" : "EMIGSVILLE", "state" : "PA", "county" : "YORK" },
            "17319": { "city" : "ETTERS", "state" : "PA", "county" : "YORK" },"17320": { "city" : "FAIRFIELD", "state" : "PA", "county" : "ADAMS" },
            "17321": { "city" : "FAWN GROVE", "state" : "PA", "county" : "YORK" },
            "17322": { "city" : "FELTON", "state" : "PA", "county" : "YORK" },"17323": { "city" : "FRANKLINTOWN", "state" : "PA", "county" : "YORK" },
            "17324": { "city" : "GARDNERS", "state" : "PA", "county" : "ADAMS" },
            "17325": { "city" : "GETTYSBURG", "state" : "PA", "county" : "ADAMS" },
            "17327": { "city" : "GLEN ROCK", "state" : "PA", "county" : "YORK" },
            "17329": { "city" : "GLENVILLE", "state" : "PA", "county" : "YORK" },
            "17331": { "city" : "HANOVER", "state" : "PA", "county" : "YORK" },"17332": { "city" : "HANOVER", "state" : "PA", "county" : "YORK" },
            "17334": { "city" : "HANOVER", "state" : "PA", "county" : "YORK" },"17339": { "city" : "LEWISBERRY", "state" : "PA", "county" : "YORK" },
            "17340": { "city" : "LITTLESTOWN", "state" : "PA", "county" : "ADAMS" },
            "17342": { "city" : "LOGANVILLE", "state" : "PA", "county" : "YORK" },
            "17343": { "city" : "MC KNIGHTSTOWN", "state" : "PA", "county" : "ADAMS" },
            "17344": { "city" : "MC SHERRYSTOWN", "state" : "PA", "county" : "ADAMS" },
            "17345": { "city" : "MANCHESTER", "state" : "PA", "county" : "YORK" },
            "17347": { "city" : "MOUNT WOLF", "state" : "PA", "county" : "YORK" },
            "17349": { "city" : "NEW FREEDOM", "state" : "PA", "county" : "YORK" },
            "17350": { "city" : "NEW OXFORD", "state" : "PA", "county" : "ADAMS" },
            "17352": { "city" : "NEW PARK", "state" : "PA", "county" : "YORK" },"17353": { "city" : "ORRTANNA", "state" : "PA", "county" : "ADAMS" },
            "17355": { "city" : "RAILROAD", "state" : "PA", "county" : "YORK" },"17356": { "city" : "RED LION", "state" : "PA", "county" : "YORK" },
            "17358": { "city" : "ROSSVILLE", "state" : "PA", "county" : "YORK" },
            "17360": { "city" : "SEVEN VALLEYS", "state" : "PA", "county" : "YORK" },
            "17361": { "city" : "SHREWSBURY", "state" : "PA", "county" : "YORK" },
            "17362": { "city" : "SPRING GROVE", "state" : "PA", "county" : "YORK" },
            "17363": { "city" : "STEWARTSTOWN", "state" : "PA", "county" : "YORK" },
            "17364": { "city" : "THOMASVILLE", "state" : "PA", "county" : "YORK" },
            "17365": { "city" : "WELLSVILLE", "state" : "PA", "county" : "YORK" },
            "17366": { "city" : "WINDSOR", "state" : "PA", "county" : "YORK" },"17368": { "city" : "WRIGHTSVILLE", "state" : "PA", "county" : "YORK" },
            "17370": { "city" : "YORK HAVEN", "state" : "PA", "county" : "YORK" },
            "17371": { "city" : "YORK NEW SALEM", "state" : "PA", "county" : "YORK" },
            "17372": { "city" : "YORK SPRINGS", "state" : "PA", "county" : "ADAMS" },
            "17375": { "city" : "PEACH GLEN", "state" : "PA", "county" : "ADAMS" },
            "17401": { "city" : "YORK", "state" : "PA", "county" : "YORK" },"17402": { "city" : "YORK", "state" : "PA", "county" : "YORK" },
            "17403": { "city" : "YORK", "state" : "PA", "county" : "YORK" },"17404": { "city" : "YORK", "state" : "PA", "county" : "YORK" },
            "17405": { "city" : "YORK", "state" : "PA", "county" : "YORK" },"17406": { "city" : "YORK", "state" : "PA", "county" : "YORK" },
            "17407": { "city" : "YORK", "state" : "PA", "county" : "YORK" },"17408": { "city" : "YORK", "state" : "PA", "county" : "YORK" },
            "17501": { "city" : "AKRON", "state" : "PA", "county" : "LANCASTER" },
            "17502": { "city" : "BAINBRIDGE", "state" : "PA", "county" : "LANCASTER" },
            "17503": { "city" : "BART", "state" : "PA", "county" : "LANCASTER" },
            "17504": { "city" : "BAUSMAN", "state" : "PA", "county" : "LANCASTER" },
            "17505": { "city" : "BIRD IN HAND", "state" : "PA", "county" : "LANCASTER" },
            "17506": { "city" : "BLUE BALL", "state" : "PA", "county" : "LANCASTER" },
            "17507": { "city" : "BOWMANSVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17508": { "city" : "BROWNSTOWN", "state" : "PA", "county" : "LANCASTER" },
            "17509": { "city" : "CHRISTIANA", "state" : "PA", "county" : "LANCASTER" },
            "17512": { "city" : "COLUMBIA", "state" : "PA", "county" : "LANCASTER" },
            "17516": { "city" : "CONESTOGA", "state" : "PA", "county" : "LANCASTER" },
            "17517": { "city" : "DENVER", "state" : "PA", "county" : "LANCASTER" },
            "17518": { "city" : "DRUMORE", "state" : "PA", "county" : "LANCASTER" },
            "17519": { "city" : "EAST EARL", "state" : "PA", "county" : "LANCASTER" },
            "17520": { "city" : "EAST PETERSBURG", "state" : "PA", "county" : "LANCASTER" },
            "17521": { "city" : "ELM", "state" : "PA", "county" : "LANCASTER" },"17522": { "city" : "EPHRATA", "state" : "PA", "county" : "LANCASTER" },
            "17527": { "city" : "GAP", "state" : "PA", "county" : "LANCASTER" },"17528": { "city" : "GOODVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17529": { "city" : "GORDONVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17532": { "city" : "HOLTWOOD", "state" : "PA", "county" : "LANCASTER" },
            "17533": { "city" : "HOPELAND", "state" : "PA", "county" : "LANCASTER" },
            "17534": { "city" : "INTERCOURSE", "state" : "PA", "county" : "LANCASTER" },
            "17535": { "city" : "KINZERS", "state" : "PA", "county" : "LANCASTER" },
            "17536": { "city" : "KIRKWOOD", "state" : "PA", "county" : "LANCASTER" },
            "17537": { "city" : "LAMPETER", "state" : "PA", "county" : "LANCASTER" },
            "17538": { "city" : "LANDISVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17540": { "city" : "LEOLA", "state" : "PA", "county" : "LANCASTER" },
            "17543": { "city" : "LITITZ", "state" : "PA", "county" : "LANCASTER" },
            "17545": { "city" : "MANHEIM", "state" : "PA", "county" : "LANCASTER" },
            "17547": { "city" : "MARIETTA", "state" : "PA", "county" : "LANCASTER" },
            "17549": { "city" : "MARTINDALE", "state" : "PA", "county" : "LANCASTER" },
            "17550": { "city" : "MAYTOWN", "state" : "PA", "county" : "LANCASTER" },
            "17551": { "city" : "MILLERSVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17552": { "city" : "MOUNT JOY", "state" : "PA", "county" : "LANCASTER" },
            "17554": { "city" : "MOUNTVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17555": { "city" : "NARVON", "state" : "PA", "county" : "LANCASTER" },
            "17557": { "city" : "NEW HOLLAND", "state" : "PA", "county" : "LANCASTER" },
            "17560": { "city" : "NEW PROVIDENCE", "state" : "PA", "county" : "LANCASTER" },
            "17562": { "city" : "PARADISE", "state" : "PA", "county" : "LANCASTER" },
            "17563": { "city" : "PEACH BOTTOM", "state" : "PA", "county" : "LANCASTER" },
            "17564": { "city" : "PENRYN", "state" : "PA", "county" : "LANCASTER" },
            "17565": { "city" : "PEQUEA", "state" : "PA", "county" : "LANCASTER" },
            "17566": { "city" : "QUARRYVILLE", "state" : "PA", "county" : "LANCASTER" },
            "17567": { "city" : "REAMSTOWN", "state" : "PA", "county" : "LANCASTER" },
            "17568": { "city" : "REFTON", "state" : "PA", "county" : "LANCASTER" },
            "17569": { "city" : "REINHOLDS", "state" : "PA", "county" : "LANCASTER" },
            "17570": { "city" : "RHEEMS", "state" : "PA", "county" : "LANCASTER" },
            "17572": { "city" : "RONKS", "state" : "PA", "county" : "LANCASTER" },
            "17575": { "city" : "SILVER SPRING", "state" : "PA", "county" : "LANCASTER" },
            "17576": { "city" : "SMOKETOWN", "state" : "PA", "county" : "LANCASTER" },
            "17578": { "city" : "STEVENS", "state" : "PA", "county" : "LANCASTER" },
            "17579": { "city" : "STRASBURG", "state" : "PA", "county" : "LANCASTER" },
            "17580": { "city" : "TALMAGE", "state" : "PA", "county" : "LANCASTER" },
            "17581": { "city" : "TERRE HILL", "state" : "PA", "county" : "LANCASTER" },
            "17582": { "city" : "WASHINGTON BORO", "state" : "PA", "county" : "LANCASTER" },
            "17583": { "city" : "WEST WILLOW", "state" : "PA", "county" : "LANCASTER" },
            "17584": { "city" : "WILLOW STREET", "state" : "PA", "county" : "LANCASTER" },
            "17585": { "city" : "WITMER", "state" : "PA", "county" : "LANCASTER" },
            "17601": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17602": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17603": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17604": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17605": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17606": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17607": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17608": { "city" : "LANCASTER", "state" : "PA", "county" : "LANCASTER" },
            "17701": { "city" : "WILLIAMSPORT", "state" : "PA", "county" : "LYCOMING" },
            "17702": { "city" : "WILLIAMSPORT", "state" : "PA", "county" : "LYCOMING" },
            "17703": { "city" : "WILLIAMSPORT", "state" : "PA", "county" : "LYCOMING" },
            "17705": { "city" : "WILLIAMSPORT", "state" : "PA", "county" : "LYCOMING" },
            "17720": { "city" : "ANTES FORT", "state" : "PA", "county" : "LYCOMING" },
            "17721": { "city" : "AVIS", "state" : "PA", "county" : "CLINTON" },"17723": { "city" : "CAMMAL", "state" : "PA", "county" : "LYCOMING" },
            "17724": { "city" : "CANTON", "state" : "PA", "county" : "BRADFORD" },
            "17726": { "city" : "CASTANEA", "state" : "PA", "county" : "CLINTON" },
            "17727": { "city" : "CEDAR RUN", "state" : "PA", "county" : "LYCOMING" },
            "17728": { "city" : "COGAN STATION", "state" : "PA", "county" : "LYCOMING" },
            "17729": { "city" : "CROSS FORK", "state" : "PA", "county" : "POTTER" },
            "17730": { "city" : "DEWART", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17731": { "city" : "EAGLES MERE", "state" : "PA", "county" : "SULLIVAN" },
            "17737": { "city" : "HUGHESVILLE", "state" : "PA", "county" : "LYCOMING" },
            "17740": { "city" : "JERSEY SHORE", "state" : "PA", "county" : "LYCOMING" },
            "17742": { "city" : "LAIRDSVILLE", "state" : "PA", "county" : "LYCOMING" },
            "17744": { "city" : "LINDEN", "state" : "PA", "county" : "LYCOMING" },
            "17745": { "city" : "LOCK HAVEN", "state" : "PA", "county" : "CLINTON" },
            "17747": { "city" : "LOGANTON", "state" : "PA", "county" : "CLINTON" },
            "17748": { "city" : "MC ELHATTAN", "state" : "PA", "county" : "CLINTON" },
            "17749": { "city" : "MC EWENSVILLE", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17750": { "city" : "MACKEYVILLE", "state" : "PA", "county" : "CLINTON" },
            "17751": { "city" : "MILL HALL", "state" : "PA", "county" : "CLINTON" },
            "17752": { "city" : "MONTGOMERY", "state" : "PA", "county" : "LYCOMING" },
            "17754": { "city" : "MONTOURSVILLE", "state" : "PA", "county" : "LYCOMING" },
            "17756": { "city" : "MUNCY", "state" : "PA", "county" : "LYCOMING" },
            "17758": { "city" : "MUNCY VALLEY", "state" : "PA", "county" : "SULLIVAN" },
            "17760": { "city" : "NORTH BEND", "state" : "PA", "county" : "CLINTON" },
            "17762": { "city" : "PICTURE ROCKS", "state" : "PA", "county" : "LYCOMING" },
            "17763": { "city" : "RALSTON", "state" : "PA", "county" : "LYCOMING" },
            "17764": { "city" : "RENOVO", "state" : "PA", "county" : "CLINTON" },
            "17765": { "city" : "ROARING BRANCH", "state" : "PA", "county" : "TIOGA" },
            "17767": { "city" : "SALONA", "state" : "PA", "county" : "CLINTON" },
            "17768": { "city" : "SHUNK", "state" : "PA", "county" : "SULLIVAN" },
            "17769": { "city" : "SLATE RUN", "state" : "PA", "county" : "LYCOMING" },
            "17771": { "city" : "TROUT RUN", "state" : "PA", "county" : "LYCOMING" },
            "17772": { "city" : "TURBOTVILLE", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17773": { "city" : "TYLERSVILLE", "state" : "PA", "county" : "CLINTON" },
            "17774": { "city" : "UNITYVILLE", "state" : "PA", "county" : "LYCOMING" },
            "17776": { "city" : "WATERVILLE", "state" : "PA", "county" : "LYCOMING" },
            "17777": { "city" : "WATSONTOWN", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17778": { "city" : "WESTPORT", "state" : "PA", "county" : "CLINTON" },
            "17779": { "city" : "WOOLRICH", "state" : "PA", "county" : "CLINTON" },
            "17801": { "city" : "SUNBURY", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17810": { "city" : "ALLENWOOD", "state" : "PA", "county" : "UNION" },
            "17812": { "city" : "BEAVER SPRINGS", "state" : "PA", "county" : "SNYDER" },
            "17813": { "city" : "BEAVERTOWN", "state" : "PA", "county" : "SNYDER" },
            "17814": { "city" : "BENTON", "state" : "PA", "county" : "COLUMBIA" },
            "17815": { "city" : "BLOOMSBURG", "state" : "PA", "county" : "COLUMBIA" },
            "17820": { "city" : "CATAWISSA", "state" : "PA", "county" : "COLUMBIA" },
            "17821": { "city" : "DANVILLE", "state" : "PA", "county" : "MONTOUR" },
            "17822": { "city" : "DANVILLE", "state" : "PA", "county" : "MONTOUR" },
            "17823": { "city" : "DORNSIFE", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17824": { "city" : "ELYSBURG", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17827": { "city" : "FREEBURG", "state" : "PA", "county" : "SNYDER" },
            "17829": { "city" : "HARTLETON", "state" : "PA", "county" : "UNION" },
            "17830": { "city" : "HERNDON", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17831": { "city" : "HUMMELS WHARF", "state" : "PA", "county" : "SNYDER" },
            "17832": { "city" : "MARION HEIGHTS", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17833": { "city" : "KREAMER", "state" : "PA", "county" : "SNYDER" },
            "17834": { "city" : "KULPMONT", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17835": { "city" : "LAURELTON", "state" : "PA", "county" : "UNION" },
            "17836": { "city" : "LECK KILL", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17837": { "city" : "LEWISBURG", "state" : "PA", "county" : "UNION" },
            "17839": { "city" : "LIGHTSTREET", "state" : "PA", "county" : "COLUMBIA" },
            "17840": { "city" : "LOCUST GAP", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17841": { "city" : "MC CLURE", "state" : "PA", "county" : "MIFFLIN" },
            "17842": { "city" : "MIDDLEBURG", "state" : "PA", "county" : "SNYDER" },
            "17844": { "city" : "MIFFLINBURG", "state" : "PA", "county" : "UNION" },
            "17845": { "city" : "MILLMONT", "state" : "PA", "county" : "UNION" },
            "17846": { "city" : "MILLVILLE", "state" : "PA", "county" : "COLUMBIA" },
            "17847": { "city" : "MILTON", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17850": { "city" : "MONTANDON", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17851": { "city" : "MOUNT CARMEL", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17853": { "city" : "MOUNT PLEASANT MILLS", "state" : "PA", "county" : "SNYDER" },
            "17855": { "city" : "NEW BERLIN", "state" : "PA", "county" : "UNION" },
            "17856": { "city" : "NEW COLUMBIA", "state" : "PA", "county" : "UNION" },
            "17857": { "city" : "NORTHUMBERLAND", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17858": { "city" : "NUMIDIA", "state" : "PA", "county" : "COLUMBIA" },
            "17859": { "city" : "ORANGEVILLE", "state" : "PA", "county" : "COLUMBIA" },
            "17860": { "city" : "PAXINOS", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17861": { "city" : "PAXTONVILLE", "state" : "PA", "county" : "SNYDER" },
            "17862": { "city" : "PENNS CREEK", "state" : "PA", "county" : "SNYDER" },
            "17864": { "city" : "PORT TREVORTON", "state" : "PA", "county" : "SNYDER" },
            "17865": { "city" : "POTTS GROVE", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17866": { "city" : "COAL TOWNSHIP", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17867": { "city" : "REBUCK", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17868": { "city" : "RIVERSIDE", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17870": { "city" : "SELINSGROVE", "state" : "PA", "county" : "SNYDER" },
            "17872": { "city" : "SHAMOKIN", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17876": { "city" : "SHAMOKIN DAM", "state" : "PA", "county" : "SNYDER" },
            "17877": { "city" : "SNYDERTOWN", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17878": { "city" : "STILLWATER", "state" : "PA", "county" : "COLUMBIA" },
            "17880": { "city" : "SWENGEL", "state" : "PA", "county" : "UNION" },"17881": { "city" : "TREVORTON", "state" : "PA", "county" : "NORTHUMBERLAND" },
            "17883": { "city" : "VICKSBURG", "state" : "PA", "county" : "UNION" },
            "17884": { "city" : "WASHINGTONVILLE", "state" : "PA", "county" : "MONTOUR" },
            "17885": { "city" : "WEIKERT", "state" : "PA", "county" : "UNION" },"17886": { "city" : "WEST MILTON", "state" : "PA", "county" : "UNION" },
            "17887": { "city" : "WHITE DEER", "state" : "PA", "county" : "UNION" },
            "17888": { "city" : "WILBURTON", "state" : "PA", "county" : "COLUMBIA" },
            "17889": { "city" : "WINFIELD", "state" : "PA", "county" : "UNION" },
            "17901": { "city" : "POTTSVILLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17920": { "city" : "ARISTES", "state" : "PA", "county" : "COLUMBIA" },
            "17921": { "city" : "ASHLAND", "state" : "PA", "county" : "SCHUYLKILL" },
            "17922": { "city" : "AUBURN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17923": { "city" : "BRANCHDALE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17925": { "city" : "BROCKTON", "state" : "PA", "county" : "SCHUYLKILL" },
            "17929": { "city" : "CRESSONA", "state" : "PA", "county" : "SCHUYLKILL" },
            "17930": { "city" : "CUMBOLA", "state" : "PA", "county" : "SCHUYLKILL" },
            "17931": { "city" : "FRACKVILLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17933": { "city" : "FRIEDENSBURG", "state" : "PA", "county" : "SCHUYLKILL" },
            "17934": { "city" : "GILBERTON", "state" : "PA", "county" : "SCHUYLKILL" },
            "17935": { "city" : "GIRARDVILLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17936": { "city" : "GORDON", "state" : "PA", "county" : "SCHUYLKILL" },
            "17938": { "city" : "HEGINS", "state" : "PA", "county" : "SCHUYLKILL" },
            "17941": { "city" : "KLINGERSTOWN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17942": { "city" : "LANDINGVILLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17943": { "city" : "LAVELLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17944": { "city" : "LLEWELLYN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17945": { "city" : "LOCUSTDALE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17946": { "city" : "LOST CREEK", "state" : "PA", "county" : "SCHUYLKILL" },
            "17948": { "city" : "MAHANOY CITY", "state" : "PA", "county" : "SCHUYLKILL" },
            "17949": { "city" : "MAHANOY PLANE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17951": { "city" : "MAR LIN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17952": { "city" : "MARY D", "state" : "PA", "county" : "SCHUYLKILL" },
            "17953": { "city" : "MIDDLEPORT", "state" : "PA", "county" : "SCHUYLKILL" },
            "17954": { "city" : "MINERSVILLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17957": { "city" : "MUIR", "state" : "PA", "county" : "SCHUYLKILL" },
            "17959": { "city" : "NEW PHILADELPHIA", "state" : "PA", "county" : "SCHUYLKILL" },
            "17960": { "city" : "NEW RINGGOLD", "state" : "PA", "county" : "SCHUYLKILL" },
            "17961": { "city" : "ORWIGSBURG", "state" : "PA", "county" : "SCHUYLKILL" },
            "17963": { "city" : "PINE GROVE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17964": { "city" : "PITMAN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17965": { "city" : "PORT CARBON", "state" : "PA", "county" : "SCHUYLKILL" },
            "17966": { "city" : "RAVINE", "state" : "PA", "county" : "SCHUYLKILL" },
            "17967": { "city" : "RINGTOWN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17968": { "city" : "SACRAMENTO", "state" : "PA", "county" : "SCHUYLKILL" },
            "17970": { "city" : "SAINT CLAIR", "state" : "PA", "county" : "SCHUYLKILL" },
            "17972": { "city" : "SCHUYLKILL HAVEN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17974": { "city" : "SELTZER", "state" : "PA", "county" : "SCHUYLKILL" },
            "17976": { "city" : "SHENANDOAH", "state" : "PA", "county" : "SCHUYLKILL" },
            "17978": { "city" : "SPRING GLEN", "state" : "PA", "county" : "SCHUYLKILL" },
            "17979": { "city" : "SUMMIT STATION", "state" : "PA", "county" : "SCHUYLKILL" },
            "17980": { "city" : "TOWER CITY", "state" : "PA", "county" : "SCHUYLKILL" },
            "17981": { "city" : "TREMONT", "state" : "PA", "county" : "SCHUYLKILL" },
            "17982": { "city" : "TUSCARORA", "state" : "PA", "county" : "SCHUYLKILL" },
            "17983": { "city" : "VALLEY VIEW", "state" : "PA", "county" : "SCHUYLKILL" },
            "17985": { "city" : "ZION GROVE", "state" : "PA", "county" : "SCHUYLKILL" },
            "18001": { "city" : "LEHIGH VALLEY", "state" : "PA", "county" : "NORTHAMPTON" },
            "18002": { "city" : "LEHIGH VALLEY", "state" : "PA", "county" : "NORTHAMPTON" },
            "18003": { "city" : "LEHIGH VALLEY", "state" : "PA", "county" : "NORTHAMPTON" },
            "18010": { "city" : "ACKERMANVILLE", "state" : "PA", "county" : "NORTHAMPTON" },
            "18011": { "city" : "ALBURTIS", "state" : "PA", "county" : "LEHIGH" },
            "18012": { "city" : "AQUASHICOLA", "state" : "PA", "county" : "CARBON" },
            "18013": { "city" : "BANGOR", "state" : "PA", "county" : "NORTHAMPTON" },
            "18014": { "city" : "BATH", "state" : "PA", "county" : "NORTHAMPTON" },
            "18015": { "city" : "BETHLEHEM", "state" : "PA", "county" : "NORTHAMPTON" },
            "18016": { "city" : "BETHLEHEM", "state" : "PA", "county" : "NORTHAMPTON" },
            "18017": { "city" : "BETHLEHEM", "state" : "PA", "county" : "NORTHAMPTON" },
            "18018": { "city" : "BETHLEHEM", "state" : "PA", "county" : "NORTHAMPTON" },
            "18020": { "city" : "BETHLEHEM", "state" : "PA", "county" : "NORTHAMPTON" },
            "18025": { "city" : "BETHLEHEM", "state" : "PA", "county" : "LEHIGH" },
            "18030": { "city" : "BOWMANSTOWN", "state" : "PA", "county" : "CARBON" },
            "18031": { "city" : "BREINIGSVILLE", "state" : "PA", "county" : "LEHIGH" },
            "18032": { "city" : "CATASAUQUA", "state" : "PA", "county" : "LEHIGH" },
            "18034": { "city" : "CENTER VALLEY", "state" : "PA", "county" : "LEHIGH" },
            "18035": { "city" : "CHERRYVILLE", "state" : "PA", "county" : "NORTHAMPTON" },
            "18036": { "city" : "COOPERSBURG", "state" : "PA", "county" : "LEHIGH" },
            "18037": { "city" : "COPLAY", "state" : "PA", "county" : "LEHIGH" },"18038": { "city" : "DANIELSVILLE", "state" : "PA", "county" : "NORTHAMPTON" },
            "18039": { "city" : "DURHAM", "state" : "PA", "county" : "BUCKS" },"18040": { "city" : "EASTON", "state" : "PA", "county" : "NORTHAMPTON" },
            "18041": { "city" : "EAST GREENVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "18042": { "city" : "EASTON", "state" : "PA", "county" : "NORTHAMPTON" },
            "18043": { "city" : "EASTON", "state" : "PA", "county" : "NORTHAMPTON" },
            "18044": { "city" : "EASTON", "state" : "PA", "county" : "NORTHAMPTON" },
            "18045": { "city" : "EASTON", "state" : "PA", "county" : "NORTHAMPTON" },
            "18046": { "city" : "EAST TEXAS", "state" : "PA", "county" : "LEHIGH" },
            "18049": { "city" : "EMMAUS", "state" : "PA", "county" : "LEHIGH" },"18050": { "city" : "FLICKSVILLE", "state" : "PA", "county" : "NORTHAMPTON" },
            "18051": { "city" : "FOGELSVILLE", "state" : "PA", "county" : "LEHIGH" },
            "18052": { "city" : "WHITEHALL", "state" : "PA", "county" : "LEHIGH" },
            "18053": { "city" : "GERMANSVILLE", "state" : "PA", "county" : "LEHIGH" },
            "18054": { "city" : "GREEN LANE", "state" : "PA", "county" : "MONTGOMERY" },
            "18055": { "city" : "HELLERTOWN", "state" : "PA", "county" : "NORTHAMPTON" },
            "18056": { "city" : "HEREFORD", "state" : "PA", "county" : "BERKS" },
            "18058": { "city" : "KUNKLETOWN", "state" : "PA", "county" : "MONROE" },
            "18059": { "city" : "LAURYS STATION", "state" : "PA", "county" : "LEHIGH" },
            "18060": { "city" : "LIMEPORT", "state" : "PA", "county" : "LEHIGH" },
            "18062": { "city" : "MACUNGIE", "state" : "PA", "county" : "LEHIGH" },
            "18063": { "city" : "MARTINS CREEK", "state" : "PA", "county" : "NORTHAMPTON" },
            "18064": { "city" : "NAZARETH", "state" : "PA", "county" : "NORTHAMPTON" },
            "18065": { "city" : "NEFFS", "state" : "PA", "county" : "LEHIGH" },"18066": { "city" : "NEW TRIPOLI", "state" : "PA", "county" : "LEHIGH" },
            "18067": { "city" : "NORTHAMPTON", "state" : "PA", "county" : "NORTHAMPTON" },
            "18068": { "city" : "OLD ZIONSVILLE", "state" : "PA", "county" : "LEHIGH" },
            "18069": { "city" : "OREFIELD", "state" : "PA", "county" : "LEHIGH" },
            "18070": { "city" : "PALM", "state" : "PA", "county" : "MONTGOMERY" },
            "18071": { "city" : "PALMERTON", "state" : "PA", "county" : "CARBON" },
            "18072": { "city" : "PEN ARGYL", "state" : "PA", "county" : "NORTHAMPTON" },
            "18073": { "city" : "PENNSBURG", "state" : "PA", "county" : "MONTGOMERY" },
            "18074": { "city" : "PERKIOMENVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "18076": { "city" : "RED HILL", "state" : "PA", "county" : "MONTGOMERY" },
            "18077": { "city" : "RIEGELSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18078": { "city" : "SCHNECKSVILLE", "state" : "PA", "county" : "LEHIGH" },
            "18079": { "city" : "SLATEDALE", "state" : "PA", "county" : "LEHIGH" },
            "18080": { "city" : "SLATINGTON", "state" : "PA", "county" : "LEHIGH" },
            "18081": { "city" : "SPRINGTOWN", "state" : "PA", "county" : "BUCKS" },
            "18083": { "city" : "STOCKERTOWN", "state" : "PA", "county" : "NORTHAMPTON" },
            "18084": { "city" : "SUMNEYTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "18085": { "city" : "TATAMY", "state" : "PA", "county" : "NORTHAMPTON" },
            "18086": { "city" : "TREICHLERS", "state" : "PA", "county" : "NORTHAMPTON" },
            "18087": { "city" : "TREXLERTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18088": { "city" : "WALNUTPORT", "state" : "PA", "county" : "NORTHAMPTON" },
            "18091": { "city" : "WIND GAP", "state" : "PA", "county" : "NORTHAMPTON" },
            "18092": { "city" : "ZIONSVILLE", "state" : "PA", "county" : "LEHIGH" },
            "18098": { "city" : "EMMAUS", "state" : "PA", "county" : "LEHIGH" },"18101": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18102": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18103": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18104": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18105": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18106": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18109": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18195": { "city" : "ALLENTOWN", "state" : "PA", "county" : "LEHIGH" },
            "18201": { "city" : "HAZLETON", "state" : "PA", "county" : "LUZERNE" },
            "18202": { "city" : "HAZLETON", "state" : "PA", "county" : "LUZERNE" },
            "18210": { "city" : "ALBRIGHTSVILLE", "state" : "PA", "county" : "CARBON" },
            "18211": { "city" : "ANDREAS", "state" : "PA", "county" : "SCHUYLKILL" },
            "18212": { "city" : "ASHFIELD", "state" : "PA", "county" : "CARBON" },
            "18214": { "city" : "BARNESVILLE", "state" : "PA", "county" : "SCHUYLKILL" },
            "18216": { "city" : "BEAVER MEADOWS", "state" : "PA", "county" : "CARBON" },
            "18218": { "city" : "COALDALE", "state" : "PA", "county" : "SCHUYLKILL" },
            "18219": { "city" : "CONYNGHAM", "state" : "PA", "county" : "LUZERNE" },
            "18220": { "city" : "DELANO", "state" : "PA", "county" : "SCHUYLKILL" },
            "18221": { "city" : "DRIFTON", "state" : "PA", "county" : "LUZERNE" },
            "18222": { "city" : "DRUMS", "state" : "PA", "county" : "LUZERNE" },"18223": { "city" : "EBERVALE", "state" : "PA", "county" : "LUZERNE" },
            "18224": { "city" : "FREELAND", "state" : "PA", "county" : "LUZERNE" },
            "18225": { "city" : "HARLEIGH", "state" : "PA", "county" : "LUZERNE" },
            "18229": { "city" : "JIM THORPE", "state" : "PA", "county" : "CARBON" },
            "18231": { "city" : "KELAYRES", "state" : "PA", "county" : "SCHUYLKILL" },
            "18232": { "city" : "LANSFORD", "state" : "PA", "county" : "CARBON" },
            "18234": { "city" : "LATTIMER MINES", "state" : "PA", "county" : "LUZERNE" },
            "18235": { "city" : "LEHIGHTON", "state" : "PA", "county" : "CARBON" },
            "18237": { "city" : "MCADOO", "state" : "PA", "county" : "SCHUYLKILL" },
            "18239": { "city" : "MILNESVILLE", "state" : "PA", "county" : "LUZERNE" },
            "18240": { "city" : "NESQUEHONING", "state" : "PA", "county" : "CARBON" },
            "18241": { "city" : "NUREMBERG", "state" : "PA", "county" : "SCHUYLKILL" },
            "18244": { "city" : "PARRYVILLE", "state" : "PA", "county" : "CARBON" },
            "18245": { "city" : "QUAKAKE", "state" : "PA", "county" : "SCHUYLKILL" },
            "18246": { "city" : "ROCK GLEN", "state" : "PA", "county" : "LUZERNE" },
            "18247": { "city" : "SAINT JOHNS", "state" : "PA", "county" : "LUZERNE" },
            "18248": { "city" : "SHEPPTON", "state" : "PA", "county" : "SCHUYLKILL" },
            "18249": { "city" : "SUGARLOAF", "state" : "PA", "county" : "LUZERNE" },
            "18250": { "city" : "SUMMIT HILL", "state" : "PA", "county" : "CARBON" },
            "18251": { "city" : "SYBERTSVILLE", "state" : "PA", "county" : "LUZERNE" },
            "18252": { "city" : "TAMAQUA", "state" : "PA", "county" : "SCHUYLKILL" },
            "18254": { "city" : "TRESCKOW", "state" : "PA", "county" : "CARBON" },
            "18255": { "city" : "WEATHERLY", "state" : "PA", "county" : "CARBON" },
            "18256": { "city" : "WESTON", "state" : "PA", "county" : "LUZERNE" },
            "18301": { "city" : "EAST STROUDSBURG", "state" : "PA", "county" : "MONROE" },
            "18302": { "city" : "EAST STROUDSBURG", "state" : "PA", "county" : "MONROE" },
            "18320": { "city" : "ANALOMINK", "state" : "PA", "county" : "MONROE" },
            "18321": { "city" : "BARTONSVILLE", "state" : "PA", "county" : "MONROE" },
            "18322": { "city" : "BRODHEADSVILLE", "state" : "PA", "county" : "MONROE" },
            "18323": { "city" : "BUCK HILL FALLS", "state" : "PA", "county" : "MONROE" },
            "18324": { "city" : "BUSHKILL", "state" : "PA", "county" : "PIKE" },"18325": { "city" : "CANADENSIS", "state" : "PA", "county" : "MONROE" },
            "18326": { "city" : "CRESCO", "state" : "PA", "county" : "MONROE" },"18327": { "city" : "DELAWARE WATER GAP", "state" : "PA", "county" : "MONROE" },
            "18328": { "city" : "DINGMANS FERRY", "state" : "PA", "county" : "PIKE" },
            "18330": { "city" : "EFFORT", "state" : "PA", "county" : "MONROE" },"18331": { "city" : "GILBERT", "state" : "PA", "county" : "MONROE" },
            "18332": { "city" : "HENRYVILLE", "state" : "PA", "county" : "MONROE" },
            "18333": { "city" : "KRESGEVILLE", "state" : "PA", "county" : "MONROE" },
            "18334": { "city" : "LONG POND", "state" : "PA", "county" : "MONROE" },
            "18335": { "city" : "MARSHALLS CREEK", "state" : "PA", "county" : "MONROE" },
            "18336": { "city" : "MATAMORAS", "state" : "PA", "county" : "PIKE" },
            "18337": { "city" : "MILFORD", "state" : "PA", "county" : "PIKE" },"18340": { "city" : "MILLRIFT", "state" : "PA", "county" : "PIKE" },
            "18341": { "city" : "MINISINK HILLS", "state" : "PA", "county" : "MONROE" },
            "18342": { "city" : "MOUNTAINHOME", "state" : "PA", "county" : "MONROE" },
            "18343": { "city" : "MOUNT BETHEL", "state" : "PA", "county" : "NORTHAMPTON" },
            "18344": { "city" : "MOUNT POCONO", "state" : "PA", "county" : "MONROE" },
            "18346": { "city" : "POCONO SUMMIT", "state" : "PA", "county" : "MONROE" },
            "18347": { "city" : "POCONO LAKE", "state" : "PA", "county" : "MONROE" },
            "18348": { "city" : "POCONO LAKE PRESERVE", "state" : "PA", "county" : "MONROE" },
            "18349": { "city" : "POCONO MANOR", "state" : "PA", "county" : "MONROE" },
            "18350": { "city" : "POCONO PINES", "state" : "PA", "county" : "MONROE" },
            "18351": { "city" : "PORTLAND", "state" : "PA", "county" : "NORTHAMPTON" },
            "18352": { "city" : "REEDERS", "state" : "PA", "county" : "MONROE" },
            "18353": { "city" : "SAYLORSBURG", "state" : "PA", "county" : "MONROE" },
            "18354": { "city" : "SCIOTA", "state" : "PA", "county" : "MONROE" },"18355": { "city" : "SCOTRUN", "state" : "PA", "county" : "MONROE" },
            "18356": { "city" : "SHAWNEE ON DELAWARE", "state" : "PA", "county" : "MONROE" },
            "18357": { "city" : "SKYTOP", "state" : "PA", "county" : "MONROE" },"18360": { "city" : "STROUDSBURG", "state" : "PA", "county" : "MONROE" },
            "18370": { "city" : "SWIFTWATER", "state" : "PA", "county" : "MONROE" },
            "18371": { "city" : "TAMIMENT", "state" : "PA", "county" : "PIKE" },"18372": { "city" : "TANNERSVILLE", "state" : "PA", "county" : "MONROE" },
            "18403": { "city" : "ARCHBALD", "state" : "PA", "county" : "LACKAWANNA" },
            "18405": { "city" : "BEACH LAKE", "state" : "PA", "county" : "WAYNE" },
            "18407": { "city" : "CARBONDALE", "state" : "PA", "county" : "LACKAWANNA" },
            "18410": { "city" : "CHINCHILLA", "state" : "PA", "county" : "LACKAWANNA" },
            "18411": { "city" : "CLARKS SUMMIT", "state" : "PA", "county" : "LACKAWANNA" },
            "18413": { "city" : "CLIFFORD", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18414": { "city" : "DALTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18415": { "city" : "DAMASCUS", "state" : "PA", "county" : "WAYNE" },
            "18416": { "city" : "ELMHURST", "state" : "PA", "county" : "LACKAWANNA" },
            "18417": { "city" : "EQUINUNK", "state" : "PA", "county" : "WAYNE" },
            "18419": { "city" : "FACTORYVILLE", "state" : "PA", "county" : "WYOMING" },
            "18420": { "city" : "FLEETVILLE", "state" : "PA", "county" : "LACKAWANNA" },
            "18421": { "city" : "FOREST CITY", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18424": { "city" : "GOULDSBORO", "state" : "PA", "county" : "WAYNE" },
            "18425": { "city" : "GREELEY", "state" : "PA", "county" : "PIKE" },"18426": { "city" : "GREENTOWN", "state" : "PA", "county" : "PIKE" },
            "18427": { "city" : "HAMLIN", "state" : "PA", "county" : "WAYNE" },"18428": { "city" : "HAWLEY", "state" : "PA", "county" : "PIKE" },
            "18431": { "city" : "HONESDALE", "state" : "PA", "county" : "WAYNE" },
            "18433": { "city" : "JERMYN", "state" : "PA", "county" : "LACKAWANNA" },
            "18434": { "city" : "JESSUP", "state" : "PA", "county" : "LACKAWANNA" },
            "18435": { "city" : "LACKAWAXEN", "state" : "PA", "county" : "PIKE" },
            "18436": { "city" : "LAKE ARIEL", "state" : "PA", "county" : "WAYNE" },
            "18437": { "city" : "LAKE COMO", "state" : "PA", "county" : "WAYNE" },
            "18438": { "city" : "LAKEVILLE", "state" : "PA", "county" : "WAYNE" },
            "18439": { "city" : "LAKEWOOD", "state" : "PA", "county" : "WAYNE" },
            "18440": { "city" : "LA PLUME", "state" : "PA", "county" : "LACKAWANNA" },
            "18441": { "city" : "LENOXVILLE", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18443": { "city" : "MILANVILLE", "state" : "PA", "county" : "WAYNE" },
            "18444": { "city" : "MOSCOW", "state" : "PA", "county" : "LACKAWANNA" },
            "18445": { "city" : "NEWFOUNDLAND", "state" : "PA", "county" : "WAYNE" },
            "18446": { "city" : "NICHOLSON", "state" : "PA", "county" : "WYOMING" },
            "18447": { "city" : "OLYPHANT", "state" : "PA", "county" : "LACKAWANNA" },
            "18448": { "city" : "OLYPHANT", "state" : "PA", "county" : "LACKAWANNA" },
            "18449": { "city" : "ORSON", "state" : "PA", "county" : "WAYNE" },"18451": { "city" : "PAUPACK", "state" : "PA", "county" : "PIKE" },
            "18452": { "city" : "PECKVILLE", "state" : "PA", "county" : "LACKAWANNA" },
            "18453": { "city" : "PLEASANT MOUNT", "state" : "PA", "county" : "WAYNE" },
            "18454": { "city" : "POYNTELLE", "state" : "PA", "county" : "WAYNE" },
            "18455": { "city" : "PRESTON PARK", "state" : "PA", "county" : "WAYNE" },
            "18456": { "city" : "PROMPTON", "state" : "PA", "county" : "WAYNE" },
            "18457": { "city" : "ROWLAND", "state" : "PA", "county" : "PIKE" },"18458": { "city" : "SHOHOLA", "state" : "PA", "county" : "PIKE" },
            "18459": { "city" : "SOUTH CANAAN", "state" : "PA", "county" : "WAYNE" },
            "18460": { "city" : "SOUTH STERLING", "state" : "PA", "county" : "WAYNE" },
            "18461": { "city" : "STARLIGHT", "state" : "PA", "county" : "WAYNE" },
            "18462": { "city" : "STARRUCCA", "state" : "PA", "county" : "WAYNE" },
            "18463": { "city" : "STERLING", "state" : "PA", "county" : "WAYNE" },
            "18464": { "city" : "TAFTON", "state" : "PA", "county" : "PIKE" },"18465": { "city" : "THOMPSON", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18466": { "city" : "TOBYHANNA", "state" : "PA", "county" : "MONROE" },
            "18469": { "city" : "TYLER HILL", "state" : "PA", "county" : "WAYNE" },
            "18470": { "city" : "UNION DALE", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18471": { "city" : "WAVERLY", "state" : "PA", "county" : "LACKAWANNA" },
            "18472": { "city" : "WAYMART", "state" : "PA", "county" : "WAYNE" },"18473": { "city" : "WHITE MILLS", "state" : "PA", "county" : "WAYNE" },
            "18501": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18502": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18503": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18504": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18505": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18507": { "city" : "MOOSIC", "state" : "PA", "county" : "LACKAWANNA" },
            "18508": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18509": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18510": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18512": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18515": { "city" : "SCRANTON", "state" : "PA", "county" : "LACKAWANNA" },
            "18517": { "city" : "TAYLOR", "state" : "PA", "county" : "LACKAWANNA" },
            "18518": { "city" : "OLD FORGE", "state" : "PA", "county" : "LACKAWANNA" },
            "18519": { "city" : "DICKSON CITY", "state" : "PA", "county" : "LACKAWANNA" },
            "18601": { "city" : "BEACH HAVEN", "state" : "PA", "county" : "LUZERNE" },
            "18602": { "city" : "BEAR CREEK", "state" : "PA", "county" : "LUZERNE" },
            "18603": { "city" : "BERWICK", "state" : "PA", "county" : "COLUMBIA" },
            "18610": { "city" : "BLAKESLEE", "state" : "PA", "county" : "MONROE" },
            "18611": { "city" : "CAMBRA", "state" : "PA", "county" : "LUZERNE" },
            "18612": { "city" : "DALLAS", "state" : "PA", "county" : "LUZERNE" },
            "18614": { "city" : "DUSHORE", "state" : "PA", "county" : "SULLIVAN" },
            "18615": { "city" : "FALLS", "state" : "PA", "county" : "WYOMING" },"18616": { "city" : "FORKSVILLE", "state" : "PA", "county" : "SULLIVAN" },
            "18617": { "city" : "GLEN LYON", "state" : "PA", "county" : "LUZERNE" },
            "18618": { "city" : "HARVEYS LAKE", "state" : "PA", "county" : "LUZERNE" },
            "18619": { "city" : "HILLSGROVE", "state" : "PA", "county" : "SULLIVAN" },
            "18621": { "city" : "HUNLOCK CREEK", "state" : "PA", "county" : "LUZERNE" },
            "18622": { "city" : "HUNTINGTON MILLS", "state" : "PA", "county" : "LUZERNE" },
            "18623": { "city" : "LACEYVILLE", "state" : "PA", "county" : "WYOMING" },
            "18624": { "city" : "LAKE HARMONY", "state" : "PA", "county" : "CARBON" },
            "18625": { "city" : "LAKE WINOLA", "state" : "PA", "county" : "WYOMING" },
            "18626": { "city" : "LAPORTE", "state" : "PA", "county" : "SULLIVAN" },
            "18627": { "city" : "LEHMAN", "state" : "PA", "county" : "LUZERNE" },
            "18628": { "city" : "LOPEZ", "state" : "PA", "county" : "SULLIVAN" },
            "18629": { "city" : "MEHOOPANY", "state" : "PA", "county" : "WYOMING" },
            "18630": { "city" : "MESHOPPEN", "state" : "PA", "county" : "WYOMING" },
            "18631": { "city" : "MIFFLINVILLE", "state" : "PA", "county" : "COLUMBIA" },
            "18632": { "city" : "MILDRED", "state" : "PA", "county" : "SULLIVAN" },
            "18634": { "city" : "NANTICOKE", "state" : "PA", "county" : "LUZERNE" },
            "18635": { "city" : "NESCOPECK", "state" : "PA", "county" : "LUZERNE" },
            "18636": { "city" : "NOXEN", "state" : "PA", "county" : "WYOMING" },"18640": { "city" : "PITTSTON", "state" : "PA", "county" : "LUZERNE" },
            "18641": { "city" : "PITTSTON", "state" : "PA", "county" : "LUZERNE" },
            "18642": { "city" : "DURYEA", "state" : "PA", "county" : "LUZERNE" },
            "18643": { "city" : "PITTSTON", "state" : "PA", "county" : "LUZERNE" },
            "18644": { "city" : "WYOMING", "state" : "PA", "county" : "LUZERNE" },
            "18651": { "city" : "PLYMOUTH", "state" : "PA", "county" : "LUZERNE" },
            "18654": { "city" : "SHAWANESE", "state" : "PA", "county" : "LUZERNE" },
            "18655": { "city" : "SHICKSHINNY", "state" : "PA", "county" : "LUZERNE" },
            "18656": { "city" : "SWEET VALLEY", "state" : "PA", "county" : "LUZERNE" },
            "18657": { "city" : "TUNKHANNOCK", "state" : "PA", "county" : "WYOMING" },
            "18660": { "city" : "WAPWALLOPEN", "state" : "PA", "county" : "LUZERNE" },
            "18661": { "city" : "WHITE HAVEN", "state" : "PA", "county" : "LUZERNE" },
            "18701": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18702": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18703": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18704": { "city" : "KINGSTON", "state" : "PA", "county" : "LUZERNE" },
            "18705": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18706": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18707": { "city" : "MOUNTAIN TOP", "state" : "PA", "county" : "LUZERNE" },
            "18708": { "city" : "SHAVERTOWN", "state" : "PA", "county" : "LUZERNE" },
            "18709": { "city" : "LUZERNE", "state" : "PA", "county" : "LUZERNE" },
            "18710": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18711": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18762": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18764": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18765": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18766": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18773": { "city" : "WILKES BARRE", "state" : "PA", "county" : "LUZERNE" },
            "18801": { "city" : "MONTROSE", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18810": { "city" : "ATHENS", "state" : "PA", "county" : "BRADFORD" },
            "18812": { "city" : "BRACKNEY", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18813": { "city" : "BROOKLYN", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18814": { "city" : "BURLINGTON", "state" : "PA", "county" : "BRADFORD" },
            "18815": { "city" : "CAMPTOWN", "state" : "PA", "county" : "BRADFORD" },
            "18816": { "city" : "DIMOCK", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18817": { "city" : "EAST SMITHFIELD", "state" : "PA", "county" : "BRADFORD" },
            "18818": { "city" : "FRIENDSVILLE", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18821": { "city" : "GREAT BEND", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18822": { "city" : "HALLSTEAD", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18823": { "city" : "HARFORD", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18824": { "city" : "HOP BOTTOM", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18825": { "city" : "JACKSON", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18826": { "city" : "KINGSLEY", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18827": { "city" : "LANESBORO", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18828": { "city" : "LAWTON", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18829": { "city" : "LE RAYSVILLE", "state" : "PA", "county" : "BRADFORD" },
            "18830": { "city" : "LITTLE MEADOWS", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18831": { "city" : "MILAN", "state" : "PA", "county" : "BRADFORD" },
            "18832": { "city" : "MONROETON", "state" : "PA", "county" : "BRADFORD" },
            "18833": { "city" : "NEW ALBANY", "state" : "PA", "county" : "BRADFORD" },
            "18834": { "city" : "NEW MILFORD", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18837": { "city" : "ROME", "state" : "PA", "county" : "BRADFORD" },"18840": { "city" : "SAYRE", "state" : "PA", "county" : "BRADFORD" },
            "18842": { "city" : "SOUTH GIBSON", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18843": { "city" : "SOUTH MONTROSE", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18844": { "city" : "SPRINGVILLE", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18845": { "city" : "STEVENSVILLE", "state" : "PA", "county" : "BRADFORD" },
            "18846": { "city" : "SUGAR RUN", "state" : "PA", "county" : "BRADFORD" },
            "18847": { "city" : "SUSQUEHANNA", "state" : "PA", "county" : "SUSQUEHANNA" },
            "18848": { "city" : "TOWANDA", "state" : "PA", "county" : "BRADFORD" },
            "18850": { "city" : "ULSTER", "state" : "PA", "county" : "BRADFORD" },
            "18851": { "city" : "WARREN CENTER", "state" : "PA", "county" : "BRADFORD" },
            "18853": { "city" : "WYALUSING", "state" : "PA", "county" : "BRADFORD" },
            "18854": { "city" : "WYSOX", "state" : "PA", "county" : "BRADFORD" },
            "18901": { "city" : "DOYLESTOWN", "state" : "PA", "county" : "BUCKS" },
            "18902": { "city" : "DOYLESTOWN", "state" : "PA", "county" : "BUCKS" },
            "18910": { "city" : "BEDMINSTER", "state" : "PA", "county" : "BUCKS" },
            "18911": { "city" : "BLOOMING GLEN", "state" : "PA", "county" : "BUCKS" },
            "18912": { "city" : "BUCKINGHAM", "state" : "PA", "county" : "BUCKS" },
            "18913": { "city" : "CARVERSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18914": { "city" : "CHALFONT", "state" : "PA", "county" : "BUCKS" },
            "18915": { "city" : "COLMAR", "state" : "PA", "county" : "MONTGOMERY" },
            "18916": { "city" : "DANBORO", "state" : "PA", "county" : "BUCKS" },"18917": { "city" : "DUBLIN", "state" : "PA", "county" : "BUCKS" },
            "18918": { "city" : "EARLINGTON", "state" : "PA", "county" : "MONTGOMERY" },
            "18920": { "city" : "ERWINNA", "state" : "PA", "county" : "BUCKS" },"18921": { "city" : "FERNDALE", "state" : "PA", "county" : "BUCKS" },
            "18922": { "city" : "FOREST GROVE", "state" : "PA", "county" : "BUCKS" },
            "18923": { "city" : "FOUNTAINVILLE", "state" : "PA", "county" : "BUCKS" },
            "18924": { "city" : "FRANCONIA", "state" : "PA", "county" : "MONTGOMERY" },
            "18925": { "city" : "FURLONG", "state" : "PA", "county" : "BUCKS" },"18927": { "city" : "HILLTOWN", "state" : "PA", "county" : "BUCKS" },
            "18928": { "city" : "HOLICONG", "state" : "PA", "county" : "BUCKS" },
            "18929": { "city" : "JAMISON", "state" : "PA", "county" : "BUCKS" },"18930": { "city" : "KINTNERSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18931": { "city" : "LAHASKA", "state" : "PA", "county" : "BUCKS" },"18932": { "city" : "LINE LEXINGTON", "state" : "PA", "county" : "BUCKS" },
            "18933": { "city" : "LUMBERVILLE", "state" : "PA", "county" : "BUCKS" },
            "18934": { "city" : "MECHANICSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18935": { "city" : "MILFORD SQUARE", "state" : "PA", "county" : "BUCKS" },
            "18936": { "city" : "MONTGOMERYVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "18938": { "city" : "NEW HOPE", "state" : "PA", "county" : "BUCKS" },
            "18940": { "city" : "NEWTOWN", "state" : "PA", "county" : "BUCKS" },"18942": { "city" : "OTTSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18943": { "city" : "PENNS PARK", "state" : "PA", "county" : "BUCKS" },
            "18944": { "city" : "PERKASIE", "state" : "PA", "county" : "BUCKS" },
            "18946": { "city" : "PINEVILLE", "state" : "PA", "county" : "BUCKS" },
            "18947": { "city" : "PIPERSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18949": { "city" : "PLUMSTEADVILLE", "state" : "PA", "county" : "BUCKS" },
            "18950": { "city" : "POINT PLEASANT", "state" : "PA", "county" : "BUCKS" },
            "18951": { "city" : "QUAKERTOWN", "state" : "PA", "county" : "BUCKS" },
            "18953": { "city" : "REVERE", "state" : "PA", "county" : "BUCKS" },"18954": { "city" : "RICHBORO", "state" : "PA", "county" : "BUCKS" },
            "18955": { "city" : "RICHLANDTOWN", "state" : "PA", "county" : "BUCKS" },
            "18956": { "city" : "RUSHLAND", "state" : "PA", "county" : "BUCKS" },
            "18957": { "city" : "SALFORD", "state" : "PA", "county" : "MONTGOMERY" },
            "18958": { "city" : "SALFORDVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "18960": { "city" : "SELLERSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18962": { "city" : "SILVERDALE", "state" : "PA", "county" : "BUCKS" },
            "18963": { "city" : "SOLEBURY", "state" : "PA", "county" : "BUCKS" },
            "18964": { "city" : "SOUDERTON", "state" : "PA", "county" : "MONTGOMERY" },
            "18966": { "city" : "SOUTHAMPTON", "state" : "PA", "county" : "BUCKS" },
            "18968": { "city" : "SPINNERSTOWN", "state" : "PA", "county" : "BUCKS" },
            "18969": { "city" : "TELFORD", "state" : "PA", "county" : "MONTGOMERY" },
            "18970": { "city" : "TRUMBAUERSVILLE", "state" : "PA", "county" : "BUCKS" },
            "18971": { "city" : "TYLERSPORT", "state" : "PA", "county" : "MONTGOMERY" },
            "18972": { "city" : "UPPER BLACK EDDY", "state" : "PA", "county" : "BUCKS" },
            "18974": { "city" : "WARMINSTER", "state" : "PA", "county" : "BUCKS" },
            "18976": { "city" : "WARRINGTON", "state" : "PA", "county" : "BUCKS" },
            "18977": { "city" : "WASHINGTON CROSSING", "state" : "PA", "county" : "BUCKS" },
            "18979": { "city" : "WOXALL", "state" : "PA", "county" : "MONTGOMERY" },
            "18980": { "city" : "WYCOMBE", "state" : "PA", "county" : "BUCKS" },"18981": { "city" : "ZIONHILL", "state" : "PA", "county" : "BUCKS" },
            "18991": { "city" : "WARMINSTER", "state" : "PA", "county" : "BUCKS" },
            "19001": { "city" : "ABINGTON", "state" : "PA", "county" : "MONTGOMERY" },
            "19002": { "city" : "AMBLER", "state" : "PA", "county" : "MONTGOMERY" },
            "19003": { "city" : "ARDMORE", "state" : "PA", "county" : "MONTGOMERY" },
            "19004": { "city" : "BALA CYNWYD", "state" : "PA", "county" : "MONTGOMERY" },
            "19006": { "city" : "HUNTINGDON VALLEY", "state" : "PA", "county" : "MONTGOMERY" },
            "19007": { "city" : "BRISTOL", "state" : "PA", "county" : "BUCKS" },"19008": { "city" : "BROOMALL", "state" : "PA", "county" : "DELAWARE" },
            "19009": { "city" : "BRYN ATHYN", "state" : "PA", "county" : "MONTGOMERY" },
            "19010": { "city" : "BRYN MAWR", "state" : "PA", "county" : "DELAWARE" },
            "19012": { "city" : "CHELTENHAM", "state" : "PA", "county" : "MONTGOMERY" },
            "19013": { "city" : "CHESTER", "state" : "PA", "county" : "DELAWARE" },
            "19014": { "city" : "ASTON", "state" : "PA", "county" : "DELAWARE" },
            "19015": { "city" : "BROOKHAVEN", "state" : "PA", "county" : "DELAWARE" },
            "19016": { "city" : "CHESTER", "state" : "PA", "county" : "DELAWARE" },
            "19017": { "city" : "CHESTER HEIGHTS", "state" : "PA", "county" : "DELAWARE" },
            "19018": { "city" : "CLIFTON HEIGHTS", "state" : "PA", "county" : "DELAWARE" },
            "19019": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19020": { "city" : "BENSALEM", "state" : "PA", "county" : "BUCKS" },
            "19021": { "city" : "CROYDON", "state" : "PA", "county" : "BUCKS" },"19022": { "city" : "CRUM LYNNE", "state" : "PA", "county" : "DELAWARE" },
            "19023": { "city" : "DARBY", "state" : "PA", "county" : "DELAWARE" },
            "19025": { "city" : "DRESHER", "state" : "PA", "county" : "MONTGOMERY" },
            "19026": { "city" : "DREXEL HILL", "state" : "PA", "county" : "DELAWARE" },
            "19027": { "city" : "ELKINS PARK", "state" : "PA", "county" : "MONTGOMERY" },
            "19028": { "city" : "EDGEMONT", "state" : "PA", "county" : "DELAWARE" },
            "19029": { "city" : "ESSINGTON", "state" : "PA", "county" : "DELAWARE" },
            "19030": { "city" : "FAIRLESS HILLS", "state" : "PA", "county" : "BUCKS" },
            "19031": { "city" : "FLOURTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "19032": { "city" : "FOLCROFT", "state" : "PA", "county" : "DELAWARE" },
            "19033": { "city" : "FOLSOM", "state" : "PA", "county" : "DELAWARE" },
            "19034": { "city" : "FORT WASHINGTON", "state" : "PA", "county" : "MONTGOMERY" },
            "19035": { "city" : "GLADWYNE", "state" : "PA", "county" : "MONTGOMERY" },
            "19036": { "city" : "GLENOLDEN", "state" : "PA", "county" : "DELAWARE" },
            "19037": { "city" : "GLEN RIDDLE LIMA", "state" : "PA", "county" : "DELAWARE" },
            "19038": { "city" : "GLENSIDE", "state" : "PA", "county" : "MONTGOMERY" },
            "19039": { "city" : "GRADYVILLE", "state" : "PA", "county" : "DELAWARE" },
            "19040": { "city" : "HATBORO", "state" : "PA", "county" : "MONTGOMERY" },
            "19041": { "city" : "HAVERFORD", "state" : "PA", "county" : "MONTGOMERY" },
            "19043": { "city" : "HOLMES", "state" : "PA", "county" : "DELAWARE" },
            "19044": { "city" : "HORSHAM", "state" : "PA", "county" : "MONTGOMERY" },
            "19046": { "city" : "JENKINTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "19047": { "city" : "LANGHORNE", "state" : "PA", "county" : "BUCKS" },
            "19048": { "city" : "FORT WASHINGTON", "state" : "PA", "county" : "BUCKS" },
            "19050": { "city" : "LANSDOWNE", "state" : "PA", "county" : "DELAWARE" },
            "19052": { "city" : "LENNI", "state" : "PA", "county" : "DELAWARE" },
            "19053": { "city" : "FEASTERVILLE TREVOSE", "state" : "PA", "county" : "BUCKS" },
            "19054": { "city" : "LEVITTOWN", "state" : "PA", "county" : "BUCKS" },
            "19055": { "city" : "LEVITTOWN", "state" : "PA", "county" : "BUCKS" },
            "19056": { "city" : "LEVITTOWN", "state" : "PA", "county" : "BUCKS" },
            "19057": { "city" : "LEVITTOWN", "state" : "PA", "county" : "BUCKS" },
            "19058": { "city" : "LEVITTOWN", "state" : "PA", "county" : "BUCKS" },
            "19060": { "city" : "GARNET VALLEY", "state" : "PA", "county" : "DELAWARE" },
            "19061": { "city" : "MARCUS HOOK", "state" : "PA", "county" : "DELAWARE" },
            "19063": { "city" : "MEDIA", "state" : "PA", "county" : "DELAWARE" },
            "19064": { "city" : "SPRINGFIELD", "state" : "PA", "county" : "DELAWARE" },
            "19065": { "city" : "MEDIA", "state" : "PA", "county" : "DELAWARE" },
            "19066": { "city" : "MERION STATION", "state" : "PA", "county" : "MONTGOMERY" },
            "19067": { "city" : "MORRISVILLE", "state" : "PA", "county" : "BUCKS" },
            "19070": { "city" : "MORTON", "state" : "PA", "county" : "DELAWARE" },
            "19072": { "city" : "NARBERTH", "state" : "PA", "county" : "MONTGOMERY" },
            "19073": { "city" : "NEWTOWN SQUARE", "state" : "PA", "county" : "DELAWARE" },
            "19074": { "city" : "NORWOOD", "state" : "PA", "county" : "DELAWARE" },
            "19075": { "city" : "ORELAND", "state" : "PA", "county" : "MONTGOMERY" },
            "19076": { "city" : "PROSPECT PARK", "state" : "PA", "county" : "DELAWARE" },
            "19078": { "city" : "RIDLEY PARK", "state" : "PA", "county" : "DELAWARE" },
            "19079": { "city" : "SHARON HILL", "state" : "PA", "county" : "DELAWARE" },
            "19080": { "city" : "WAYNE", "state" : "PA", "county" : "DELAWARE" },
            "19081": { "city" : "SWARTHMORE", "state" : "PA", "county" : "DELAWARE" },
            "19082": { "city" : "UPPER DARBY", "state" : "PA", "county" : "DELAWARE" },
            "19083": { "city" : "HAVERTOWN", "state" : "PA", "county" : "DELAWARE" },
            "19085": { "city" : "VILLANOVA", "state" : "PA", "county" : "DELAWARE" },
            "19086": { "city" : "WALLINGFORD", "state" : "PA", "county" : "DELAWARE" },
            "19087": { "city" : "WAYNE", "state" : "PA", "county" : "DELAWARE" },
            "19088": { "city" : "WAYNE", "state" : "PA", "county" : "DELAWARE" },
            "19090": { "city" : "WILLOW GROVE", "state" : "PA", "county" : "MONTGOMERY" },
            "19091": { "city" : "MEDIA", "state" : "PA", "county" : "DELAWARE" },
            "19092": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19094": { "city" : "WOODLYN", "state" : "PA", "county" : "DELAWARE" },
            "19095": { "city" : "WYNCOTE", "state" : "PA", "county" : "MONTGOMERY" },
            "19096": { "city" : "WYNNEWOOD", "state" : "PA", "county" : "MONTGOMERY" },
            "19101": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19102": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19103": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19104": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19105": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19106": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19107": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19108": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19109": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19110": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19111": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19112": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19113": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "DELAWARE" },
            "19114": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19115": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19116": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19118": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19119": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19120": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19121": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19122": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19123": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19124": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19125": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19126": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19127": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19128": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19129": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19130": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19131": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19132": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19133": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19134": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19135": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19136": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19137": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19138": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19139": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19140": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19141": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19142": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19143": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19144": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19145": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19146": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19147": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19148": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19149": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19150": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19151": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19152": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19153": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19154": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19155": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19160": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19162": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19170": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19176": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19181": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19187": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19188": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19192": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19255": { "city" : "PHILADELPHIA", "state" : "PA", "county" : "PHILADELPHIA" },
            "19301": { "city" : "PAOLI", "state" : "PA", "county" : "CHESTER" },"19310": { "city" : "ATGLEN", "state" : "PA", "county" : "CHESTER" },
            "19311": { "city" : "AVONDALE", "state" : "PA", "county" : "CHESTER" },
            "19312": { "city" : "BERWYN", "state" : "PA", "county" : "CHESTER" },
            "19316": { "city" : "BRANDAMORE", "state" : "PA", "county" : "CHESTER" },
            "19317": { "city" : "CHADDS FORD", "state" : "PA", "county" : "DELAWARE" },
            "19318": { "city" : "CHATHAM", "state" : "PA", "county" : "CHESTER" },
            "19319": { "city" : "CHEYNEY", "state" : "PA", "county" : "DELAWARE" },
            "19320": { "city" : "COATESVILLE", "state" : "PA", "county" : "CHESTER" },
            "19330": { "city" : "COCHRANVILLE", "state" : "PA", "county" : "CHESTER" },
            "19331": { "city" : "CONCORDVILLE", "state" : "PA", "county" : "DELAWARE" },
            "19333": { "city" : "DEVON", "state" : "PA", "county" : "CHESTER" },"19335": { "city" : "DOWNINGTOWN", "state" : "PA", "county" : "CHESTER" },
            "19339": { "city" : "CONCORDVILLE", "state" : "PA", "county" : "DELAWARE" },
            "19341": { "city" : "EXTON", "state" : "PA", "county" : "CHESTER" },"19342": { "city" : "GLEN MILLS", "state" : "PA", "county" : "DELAWARE" },
            "19343": { "city" : "GLENMOORE", "state" : "PA", "county" : "CHESTER" },
            "19344": { "city" : "HONEY BROOK", "state" : "PA", "county" : "CHESTER" },
            "19345": { "city" : "IMMACULATA", "state" : "PA", "county" : "CHESTER" },
            "19346": { "city" : "KELTON", "state" : "PA", "county" : "CHESTER" },
            "19347": { "city" : "KEMBLESVILLE", "state" : "PA", "county" : "CHESTER" },
            "19348": { "city" : "KENNETT SQUARE", "state" : "PA", "county" : "CHESTER" },
            "19350": { "city" : "LANDENBERG", "state" : "PA", "county" : "CHESTER" },
            "19351": { "city" : "LEWISVILLE", "state" : "PA", "county" : "CHESTER" },
            "19352": { "city" : "LINCOLN UNIVERSITY", "state" : "PA", "county" : "CHESTER" },
            "19353": { "city" : "LIONVILLE", "state" : "PA", "county" : "CHESTER" },
            "19354": { "city" : "LYNDELL", "state" : "PA", "county" : "CHESTER" },
            "19355": { "city" : "MALVERN", "state" : "PA", "county" : "CHESTER" },
            "19357": { "city" : "MENDENHALL", "state" : "PA", "county" : "CHESTER" },
            "19358": { "city" : "MODENA", "state" : "PA", "county" : "CHESTER" },
            "19360": { "city" : "NEW LONDON", "state" : "PA", "county" : "CHESTER" },
            "19362": { "city" : "NOTTINGHAM", "state" : "PA", "county" : "CHESTER" },
            "19363": { "city" : "OXFORD", "state" : "PA", "county" : "CHESTER" },
            "19365": { "city" : "PARKESBURG", "state" : "PA", "county" : "CHESTER" },
            "19366": { "city" : "POCOPSON", "state" : "PA", "county" : "CHESTER" },
            "19367": { "city" : "POMEROY", "state" : "PA", "county" : "CHESTER" },
            "19369": { "city" : "SADSBURYVILLE", "state" : "PA", "county" : "CHESTER" },
            "19371": { "city" : "SUPLEE", "state" : "PA", "county" : "CHESTER" },
            "19372": { "city" : "THORNDALE", "state" : "PA", "county" : "CHESTER" },
            "19373": { "city" : "THORNTON", "state" : "PA", "county" : "DELAWARE" },
            "19374": { "city" : "TOUGHKENAMON", "state" : "PA", "county" : "CHESTER" },
            "19375": { "city" : "UNIONVILLE", "state" : "PA", "county" : "CHESTER" },
            "19376": { "city" : "WAGONTOWN", "state" : "PA", "county" : "CHESTER" },
            "19380": { "city" : "WEST CHESTER", "state" : "PA", "county" : "CHESTER" },
            "19381": { "city" : "WEST CHESTER", "state" : "PA", "county" : "CHESTER" },
            "19382": { "city" : "WEST CHESTER", "state" : "PA", "county" : "CHESTER" },
            "19383": { "city" : "WEST CHESTER", "state" : "PA", "county" : "CHESTER" },
            "19390": { "city" : "WEST GROVE", "state" : "PA", "county" : "CHESTER" },
            "19395": { "city" : "WESTTOWN", "state" : "PA", "county" : "CHESTER" },
            "19399": { "city" : "SOUTHEASTERN", "state" : "PA", "county" : "CHESTER" },
            "19401": { "city" : "NORRISTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "19403": { "city" : "NORRISTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "19404": { "city" : "NORRISTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "19405": { "city" : "BRIDGEPORT", "state" : "PA", "county" : "MONTGOMERY" },
            "19406": { "city" : "KING OF PRUSSIA", "state" : "PA", "county" : "MONTGOMERY" },
            "19407": { "city" : "AUDUBON", "state" : "PA", "county" : "MONTGOMERY" },
            "19408": { "city" : "EAGLEVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19409": { "city" : "FAIRVIEW VILLAGE", "state" : "PA", "county" : "MONTGOMERY" },
            "19420": { "city" : "ARCOLA", "state" : "PA", "county" : "MONTGOMERY" },
            "19421": { "city" : "BIRCHRUNVILLE", "state" : "PA", "county" : "CHESTER" },
            "19422": { "city" : "BLUE BELL", "state" : "PA", "county" : "MONTGOMERY" },
            "19423": { "city" : "CEDARS", "state" : "PA", "county" : "MONTGOMERY" },
            "19424": { "city" : "BLUE BELL", "state" : "PA", "county" : "MONTGOMERY" },
            "19425": { "city" : "CHESTER SPRINGS", "state" : "PA", "county" : "CHESTER" },
            "19426": { "city" : "COLLEGEVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19428": { "city" : "CONSHOHOCKEN", "state" : "PA", "county" : "MONTGOMERY" },
            "19429": { "city" : "CONSHOHOCKEN", "state" : "PA", "county" : "MONTGOMERY" },
            "19430": { "city" : "CREAMERY", "state" : "PA", "county" : "MONTGOMERY" },
            "19432": { "city" : "DEVAULT", "state" : "PA", "county" : "CHESTER" },
            "19435": { "city" : "FREDERICK", "state" : "PA", "county" : "MONTGOMERY" },
            "19436": { "city" : "GWYNEDD", "state" : "PA", "county" : "MONTGOMERY" },
            "19437": { "city" : "GWYNEDD VALLEY", "state" : "PA", "county" : "MONTGOMERY" },
            "19438": { "city" : "HARLEYSVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19440": { "city" : "HATFIELD", "state" : "PA", "county" : "MONTGOMERY" },
            "19442": { "city" : "KIMBERTON", "state" : "PA", "county" : "CHESTER" },
            "19443": { "city" : "KULPSVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19444": { "city" : "LAFAYETTE HILL", "state" : "PA", "county" : "MONTGOMERY" },
            "19446": { "city" : "LANSDALE", "state" : "PA", "county" : "MONTGOMERY" },
            "19450": { "city" : "LEDERACH", "state" : "PA", "county" : "MONTGOMERY" },
            "19451": { "city" : "MAINLAND", "state" : "PA", "county" : "MONTGOMERY" },
            "19453": { "city" : "MONT CLARE", "state" : "PA", "county" : "MONTGOMERY" },
            "19454": { "city" : "NORTH WALES", "state" : "PA", "county" : "MONTGOMERY" },
            "19456": { "city" : "OAKS", "state" : "PA", "county" : "MONTGOMERY" },
            "19457": { "city" : "PARKER FORD", "state" : "PA", "county" : "CHESTER" },
            "19460": { "city" : "PHOENIXVILLE", "state" : "PA", "county" : "CHESTER" },
            "19462": { "city" : "PLYMOUTH MEETING", "state" : "PA", "county" : "MONTGOMERY" },
            "19464": { "city" : "POTTSTOWN", "state" : "PA", "county" : "MONTGOMERY" },
            "19465": { "city" : "POTTSTOWN", "state" : "PA", "county" : "CHESTER" },
            "19468": { "city" : "ROYERSFORD", "state" : "PA", "county" : "MONTGOMERY" },
            "19470": { "city" : "SAINT PETERS", "state" : "PA", "county" : "CHESTER" },
            "19472": { "city" : "SASSAMANSVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19473": { "city" : "SCHWENKSVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19474": { "city" : "SKIPPACK", "state" : "PA", "county" : "MONTGOMERY" },
            "19475": { "city" : "SPRING CITY", "state" : "PA", "county" : "CHESTER" },
            "19477": { "city" : "SPRING HOUSE", "state" : "PA", "county" : "MONTGOMERY" },
            "19478": { "city" : "SPRING MOUNT", "state" : "PA", "county" : "MONTGOMERY" },
            "19480": { "city" : "UWCHLAND", "state" : "PA", "county" : "CHESTER" },
            "19481": { "city" : "VALLEY FORGE", "state" : "PA", "county" : "CHESTER" },
            "19482": { "city" : "VALLEY FORGE", "state" : "PA", "county" : "CHESTER" },
            "19484": { "city" : "VALLEY FORGE", "state" : "PA", "county" : "MONTGOMERY" },
            "19486": { "city" : "WEST POINT", "state" : "PA", "county" : "MONTGOMERY" },
            "19490": { "city" : "WORCESTER", "state" : "PA", "county" : "MONTGOMERY" },
            "19492": { "city" : "ZIEGLERVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19501": { "city" : "ADAMSTOWN", "state" : "PA", "county" : "LANCASTER" },
            "19503": { "city" : "BALLY", "state" : "PA", "county" : "BERKS" },"19504": { "city" : "BARTO", "state" : "PA", "county" : "BERKS" },
            "19505": { "city" : "BECHTELSVILLE", "state" : "PA", "county" : "BERKS" },
            "19506": { "city" : "BERNVILLE", "state" : "PA", "county" : "BERKS" },
            "19507": { "city" : "BETHEL", "state" : "PA", "county" : "BERKS" },"19508": { "city" : "BIRDSBORO", "state" : "PA", "county" : "BERKS" },
            "19510": { "city" : "BLANDON", "state" : "PA", "county" : "BERKS" },"19511": { "city" : "BOWERS", "state" : "PA", "county" : "BERKS" },
            "19512": { "city" : "BOYERTOWN", "state" : "PA", "county" : "BERKS" },
            "19516": { "city" : "CENTERPORT", "state" : "PA", "county" : "BERKS" },
            "19518": { "city" : "DOUGLASSVILLE", "state" : "PA", "county" : "BERKS" },
            "19519": { "city" : "EARLVILLE", "state" : "PA", "county" : "BERKS" },
            "19520": { "city" : "ELVERSON", "state" : "PA", "county" : "CHESTER" },
            "19522": { "city" : "FLEETWOOD", "state" : "PA", "county" : "BERKS" },
            "19523": { "city" : "GEIGERTOWN", "state" : "PA", "county" : "BERKS" },
            "19525": { "city" : "GILBERTSVILLE", "state" : "PA", "county" : "MONTGOMERY" },
            "19526": { "city" : "HAMBURG", "state" : "PA", "county" : "BERKS" },"19529": { "city" : "KEMPTON", "state" : "PA", "county" : "BERKS" },
            "19530": { "city" : "KUTZTOWN", "state" : "PA", "county" : "BERKS" },
            "19533": { "city" : "LEESPORT", "state" : "PA", "county" : "BERKS" },
            "19534": { "city" : "LENHARTSVILLE", "state" : "PA", "county" : "BERKS" },
            "19535": { "city" : "LIMEKILN", "state" : "PA", "county" : "BERKS" },
            "19536": { "city" : "LYON STATION", "state" : "PA", "county" : "BERKS" },
            "19538": { "city" : "MAXATAWNY", "state" : "PA", "county" : "BERKS" },
            "19539": { "city" : "MERTZTOWN", "state" : "PA", "county" : "BERKS" },
            "19540": { "city" : "MOHNTON", "state" : "PA", "county" : "BERKS" },"19541": { "city" : "MOHRSVILLE", "state" : "PA", "county" : "BERKS" },
            "19542": { "city" : "MONOCACY STATION", "state" : "PA", "county" : "BERKS" },
            "19543": { "city" : "MORGANTOWN", "state" : "PA", "county" : "BERKS" },
            "19544": { "city" : "MOUNT AETNA", "state" : "PA", "county" : "BERKS" },
            "19545": { "city" : "NEW BERLINVILLE", "state" : "PA", "county" : "BERKS" },
            "19547": { "city" : "OLEY", "state" : "PA", "county" : "BERKS" },"19548": { "city" : "PINE FORGE", "state" : "PA", "county" : "BERKS" },
            "19549": { "city" : "PORT CLINTON", "state" : "PA", "county" : "SCHUYLKILL" },
            "19550": { "city" : "REHRERSBURG", "state" : "PA", "county" : "BERKS" },
            "19551": { "city" : "ROBESONIA", "state" : "PA", "county" : "BERKS" },
            "19554": { "city" : "SHARTLESVILLE", "state" : "PA", "county" : "BERKS" },
            "19555": { "city" : "SHOEMAKERSVILLE", "state" : "PA", "county" : "BERKS" },
            "19559": { "city" : "STRAUSSTOWN", "state" : "PA", "county" : "BERKS" },
            "19560": { "city" : "TEMPLE", "state" : "PA", "county" : "BERKS" },"19562": { "city" : "TOPTON", "state" : "PA", "county" : "BERKS" },
            "19564": { "city" : "VIRGINVILLE", "state" : "PA", "county" : "BERKS" },
            "19565": { "city" : "WERNERSVILLE", "state" : "PA", "county" : "BERKS" },
            "19567": { "city" : "WOMELSDORF", "state" : "PA", "county" : "BERKS" },
            "19601": { "city" : "READING", "state" : "PA", "county" : "BERKS" },"19602": { "city" : "READING", "state" : "PA", "county" : "BERKS" },
            "19603": { "city" : "READING", "state" : "PA", "county" : "BERKS" },"19604": { "city" : "READING", "state" : "PA", "county" : "BERKS" },
            "19605": { "city" : "READING", "state" : "PA", "county" : "BERKS" },"19606": { "city" : "READING", "state" : "PA", "county" : "BERKS" },
            "19607": { "city" : "READING", "state" : "PA", "county" : "BERKS" },"19608": { "city" : "READING", "state" : "PA", "county" : "BERKS" },
            "19609": { "city" : "READING", "state" : "PA", "county" : "BERKS" },"19610": { "city" : "READING", "state" : "PA", "county" : "BERKS" },
            "19611": { "city" : "READING", "state" : "PA", "county" : "BERKS" },"19612": { "city" : "READING", "state" : "PA", "county" : "BERKS" },
            "19701": { "city" : "BEAR", "state" : "DE", "county" : "NEW CASTLE" },
            "19702": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19703": { "city" : "CLAYMONT", "state" : "DE", "county" : "NEW CASTLE" },
            "19706": { "city" : "DELAWARE CITY", "state" : "DE", "county" : "NEW CASTLE" },
            "19707": { "city" : "HOCKESSIN", "state" : "DE", "county" : "NEW CASTLE" },
            "19708": { "city" : "KIRKWOOD", "state" : "DE", "county" : "NEW CASTLE" },
            "19709": { "city" : "MIDDLETOWN", "state" : "DE", "county" : "NEW CASTLE" },
            "19710": { "city" : "MONTCHANIN", "state" : "DE", "county" : "NEW CASTLE" },
            "19711": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19713": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19714": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19715": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19716": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19717": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19718": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19720": { "city" : "NEW CASTLE", "state" : "DE", "county" : "NEW CASTLE" },
            "19721": { "city" : "NEW CASTLE", "state" : "DE", "county" : "NEW CASTLE" },
            "19726": { "city" : "NEWARK", "state" : "DE", "county" : "NEW CASTLE" },
            "19730": { "city" : "ODESSA", "state" : "DE", "county" : "NEW CASTLE" },
            "19731": { "city" : "PORT PENN", "state" : "DE", "county" : "NEW CASTLE" },
            "19732": { "city" : "ROCKLAND", "state" : "DE", "county" : "NEW CASTLE" },
            "19733": { "city" : "SAINT GEORGES", "state" : "DE", "county" : "NEW CASTLE" },
            "19734": { "city" : "TOWNSEND", "state" : "DE", "county" : "NEW CASTLE" },
            "19735": { "city" : "WINTERTHUR", "state" : "DE", "county" : "NEW CASTLE" },
            "19736": { "city" : "YORKLYN", "state" : "DE", "county" : "NEW CASTLE" },
            "19801": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19802": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19803": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19804": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19805": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19806": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19807": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19808": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19809": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19810": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19850": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19880": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19884": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19890": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19894": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19897": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19898": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19899": { "city" : "WILMINGTON", "state" : "DE", "county" : "NEW CASTLE" },
            "19901": { "city" : "DOVER", "state" : "DE", "county" : "KENT" },"19902": { "city" : "DOVER AFB", "state" : "DE", "county" : "KENT" },
            "19903": { "city" : "DOVER", "state" : "DE", "county" : "KENT" },"19904": { "city" : "DOVER", "state" : "DE", "county" : "KENT" },
            "19905": { "city" : "DOVER", "state" : "DE", "county" : "KENT" },"19930": { "city" : "BETHANY BEACH", "state" : "DE", "county" : "SUSSEX" },
            "19931": { "city" : "BETHEL", "state" : "DE", "county" : "SUSSEX" },"19933": { "city" : "BRIDGEVILLE", "state" : "DE", "county" : "SUSSEX" },
            "19934": { "city" : "CAMDEN WYOMING", "state" : "DE", "county" : "KENT" },
            "19936": { "city" : "CHESWOLD", "state" : "DE", "county" : "KENT" },"19938": { "city" : "CLAYTON", "state" : "DE", "county" : "KENT" },
            "19939": { "city" : "DAGSBORO", "state" : "DE", "county" : "SUSSEX" },
            "19940": { "city" : "DELMAR", "state" : "DE", "county" : "SUSSEX" },"19941": { "city" : "ELLENDALE", "state" : "DE", "county" : "SUSSEX" },
            "19943": { "city" : "FELTON", "state" : "DE", "county" : "KENT" },"19944": { "city" : "FENWICK ISLAND", "state" : "DE", "county" : "SUSSEX" },
            "19945": { "city" : "FRANKFORD", "state" : "DE", "county" : "SUSSEX" },
            "19946": { "city" : "FREDERICA", "state" : "DE", "county" : "KENT" },
            "19947": { "city" : "GEORGETOWN", "state" : "DE", "county" : "SUSSEX" },
            "19950": { "city" : "GREENWOOD", "state" : "DE", "county" : "SUSSEX" },
            "19951": { "city" : "HARBESON", "state" : "DE", "county" : "SUSSEX" },
            "19952": { "city" : "HARRINGTON", "state" : "DE", "county" : "KENT" },
            "19953": { "city" : "HARTLY", "state" : "DE", "county" : "KENT" },"19954": { "city" : "HOUSTON", "state" : "DE", "county" : "KENT" },
            "19955": { "city" : "KENTON", "state" : "DE", "county" : "KENT" },"19956": { "city" : "LAUREL", "state" : "DE", "county" : "SUSSEX" },
            "19958": { "city" : "LEWES", "state" : "DE", "county" : "SUSSEX" },"19960": { "city" : "LINCOLN", "state" : "DE", "county" : "SUSSEX" },
            "19961": { "city" : "LITTLE CREEK", "state" : "DE", "county" : "KENT" },
            "19962": { "city" : "MAGNOLIA", "state" : "DE", "county" : "KENT" },"19963": { "city" : "MILFORD", "state" : "DE", "county" : "SUSSEX" },
            "19964": { "city" : "MARYDEL", "state" : "DE", "county" : "KENT" },"19966": { "city" : "MILLSBORO", "state" : "DE", "county" : "SUSSEX" },
            "19967": { "city" : "MILLVILLE", "state" : "DE", "county" : "SUSSEX" },
            "19968": { "city" : "MILTON", "state" : "DE", "county" : "SUSSEX" },"19969": { "city" : "NASSAU", "state" : "DE", "county" : "SUSSEX" },
            "19970": { "city" : "OCEAN VIEW", "state" : "DE", "county" : "SUSSEX" },
            "19971": { "city" : "DEWEY BEACH", "state" : "DE", "county" : "SUSSEX" },
            "19973": { "city" : "SEAFORD", "state" : "DE", "county" : "SUSSEX" },
            "19975": { "city" : "SELBYVILLE", "state" : "DE", "county" : "SUSSEX" },
            "19977": { "city" : "SMYRNA", "state" : "DE", "county" : "KENT" },"19979": { "city" : "VIOLA", "state" : "DE", "county" : "KENT" },
            "19980": { "city" : "WOODSIDE", "state" : "DE", "county" : "KENT" },"20001": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20002": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20003": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20004": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20005": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20006": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20007": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20008": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20009": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20010": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20011": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20012": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20013": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20015": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20016": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20017": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20018": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20019": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20020": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20024": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20026": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20027": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20029": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20030": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20032": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20033": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20035": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20036": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20037": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20038": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20039": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20040": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20041": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20042": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20044": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20045": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20046": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20049": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20050": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20052": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20055": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20056": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20057": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20059": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20060": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20061": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20062": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20064": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20065": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20066": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20067": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20068": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20070": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20071": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20075": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20076": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20080": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20081": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20082": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20090": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20091": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20101": { "city" : "DULLES", "state" : "VA", "county" : "LOUDOUN" },
            "20102": { "city" : "DULLES", "state" : "VA", "county" : "LOUDOUN" },
            "20103": { "city" : "DULLES", "state" : "VA", "county" : "LOUDOUN" },
            "20104": { "city" : "DULLES", "state" : "VA", "county" : "LOUDOUN" },
            "20105": { "city" : "ALDIE", "state" : "VA", "county" : "LOUDOUN" },"20106": { "city" : "AMISSVILLE", "state" : "VA", "county" : "CULPEPER" },
            "20108": { "city" : "MANASSAS", "state" : "VA", "county" : "MANASSAS CITY" },
            "20109": { "city" : "MANASSAS", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20110": { "city" : "MANASSAS", "state" : "VA", "county" : "MANASSAS CITY" },
            "20111": { "city" : "MANASSAS", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20112": { "city" : "MANASSAS", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20113": { "city" : "MANASSAS", "state" : "VA", "county" : "MANASSAS PARK CITY" },
            "20115": { "city" : "MARSHALL", "state" : "VA", "county" : "FAUQUIER" },
            "20116": { "city" : "MARSHALL", "state" : "VA", "county" : "FAUQUIER" },
            "20117": { "city" : "MIDDLEBURG", "state" : "VA", "county" : "LOUDOUN" },
            "20118": { "city" : "MIDDLEBURG", "state" : "VA", "county" : "LOUDOUN" },
            "20119": { "city" : "CATLETT", "state" : "VA", "county" : "FAUQUIER" },
            "20120": { "city" : "CENTREVILLE", "state" : "VA", "county" : "FAIRFAX" },
            "20121": { "city" : "CENTREVILLE", "state" : "VA", "county" : "FAIRFAX" },
            "20122": { "city" : "CENTREVILLE", "state" : "VA", "county" : "FAIRFAX" },
            "20124": { "city" : "CLIFTON", "state" : "VA", "county" : "FAIRFAX" },
            "20128": { "city" : "ORLEAN", "state" : "VA", "county" : "FAUQUIER" },
            "20129": { "city" : "PAEONIAN SPRINGS", "state" : "VA", "county" : "LOUDOUN" },
            "20130": { "city" : "PARIS", "state" : "VA", "county" : "CLARKE" },"20131": { "city" : "PHILOMONT", "state" : "VA", "county" : "LOUDOUN" },
            "20132": { "city" : "PURCELLVILLE", "state" : "VA", "county" : "LOUDOUN" },
            "20134": { "city" : "PURCELLVILLE", "state" : "VA", "county" : "LOUDOUN" },
            "20135": { "city" : "BLUEMONT", "state" : "VA", "county" : "CLARKE" },
            "20136": { "city" : "BRISTOW", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20137": { "city" : "BROAD RUN", "state" : "VA", "county" : "FAUQUIER" },
            "20138": { "city" : "CALVERTON", "state" : "VA", "county" : "FAUQUIER" },
            "20139": { "city" : "CASANOVA", "state" : "VA", "county" : "FAUQUIER" },
            "20140": { "city" : "RECTORTOWN", "state" : "VA", "county" : "FAUQUIER" },
            "20141": { "city" : "ROUND HILL", "state" : "VA", "county" : "LOUDOUN" },
            "20142": { "city" : "ROUND HILL", "state" : "VA", "county" : "LOUDOUN" },
            "20143": { "city" : "CATHARPIN", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20144": { "city" : "DELAPLANE", "state" : "VA", "county" : "FAUQUIER" },
            "20146": { "city" : "ASHBURN", "state" : "VA", "county" : "LOUDOUN" },
            "20147": { "city" : "ASHBURN", "state" : "VA", "county" : "LOUDOUN" },
            "20148": { "city" : "ASHBURN", "state" : "VA", "county" : "LOUDOUN" },
            "20151": { "city" : "CHANTILLY", "state" : "VA", "county" : "FAIRFAX" },
            "20152": { "city" : "CHANTILLY", "state" : "VA", "county" : "LOUDOUN" },
            "20153": { "city" : "CHANTILLY", "state" : "VA", "county" : "FAIRFAX" },
            "20155": { "city" : "GAINESVILLE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20156": { "city" : "GAINESVILLE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20158": { "city" : "HAMILTON", "state" : "VA", "county" : "LOUDOUN" },
            "20159": { "city" : "HAMILTON", "state" : "VA", "county" : "LOUDOUN" },
            "20160": { "city" : "LINCOLN", "state" : "VA", "county" : "LOUDOUN" },
            "20163": { "city" : "STERLING", "state" : "VA", "county" : "LOUDOUN" },
            "20164": { "city" : "STERLING", "state" : "VA", "county" : "LOUDOUN" },
            "20165": { "city" : "STERLING", "state" : "VA", "county" : "LOUDOUN" },
            "20166": { "city" : "STERLING", "state" : "VA", "county" : "LOUDOUN" },
            "20167": { "city" : "STERLING", "state" : "VA", "county" : "LOUDOUN" },
            "20168": { "city" : "HAYMARKET", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20169": { "city" : "HAYMARKET", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20170": { "city" : "HERNDON", "state" : "VA", "county" : "FAIRFAX" },
            "20171": { "city" : "HERNDON", "state" : "VA", "county" : "FAIRFAX" },
            "20172": { "city" : "HERNDON", "state" : "VA", "county" : "FAIRFAX" },
            "20175": { "city" : "LEESBURG", "state" : "VA", "county" : "LOUDOUN" },
            "20176": { "city" : "LEESBURG", "state" : "VA", "county" : "LOUDOUN" },
            "20177": { "city" : "LEESBURG", "state" : "VA", "county" : "LOUDOUN" },
            "20178": { "city" : "LEESBURG", "state" : "VA", "county" : "LOUDOUN" },
            "20180": { "city" : "LOVETTSVILLE", "state" : "VA", "county" : "LOUDOUN" },
            "20181": { "city" : "NOKESVILLE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20182": { "city" : "NOKESVILLE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "20184": { "city" : "UPPERVILLE", "state" : "VA", "county" : "FAUQUIER" },
            "20185": { "city" : "UPPERVILLE", "state" : "VA", "county" : "FAUQUIER" },
            "20186": { "city" : "WARRENTON", "state" : "VA", "county" : "FAUQUIER" },
            "20187": { "city" : "WARRENTON", "state" : "VA", "county" : "FAUQUIER" },
            "20188": { "city" : "WARRENTON", "state" : "VA", "county" : "FAUQUIER" },
            "20190": { "city" : "RESTON", "state" : "VA", "county" : "FAIRFAX" },
            "20191": { "city" : "RESTON", "state" : "VA", "county" : "FAIRFAX" },
            "20192": { "city" : "HERNDON", "state" : "VA", "county" : "FAIRFAX" },
            "20194": { "city" : "RESTON", "state" : "VA", "county" : "FAIRFAX" },
            "20195": { "city" : "RESTON", "state" : "VA", "county" : "FAIRFAX" },
            "20196": { "city" : "RESTON", "state" : "VA", "county" : "FAIRFAX" },
            "20197": { "city" : "WATERFORD", "state" : "VA", "county" : "LOUDOUN" },
            "20198": { "city" : "THE PLAINS", "state" : "VA", "county" : "FAUQUIER" },
            "20201": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20202": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20206": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20207": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20210": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20212": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20213": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20214": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20217": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20219": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20220": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20222": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20223": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20224": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20226": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20227": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20228": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20229": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20230": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20233": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20237": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20240": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20242": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20250": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20260": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20301": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20303": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20306": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20307": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20310": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20314": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20317": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20318": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20319": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20330": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20340": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20350": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20370": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20372": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20373": { "city" : "NAVAL ANACOST ANNEX", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20374": { "city" : "WASHINGTON NAVY YARD", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20375": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20376": { "city" : "WASHINGTON NAVY YARD", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20380": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20388": { "city" : "WASHINGTON NAVY YARD", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20392": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20393": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20395": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20398": { "city" : "WASHINGTON NAVY YARD", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20401": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20403": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20405": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20407": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20408": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20410": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20413": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20415": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20416": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20418": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20420": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20421": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20422": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20426": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20429": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20431": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20433": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20435": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20436": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20439": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20447": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20451": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20460": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20463": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20472": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20501": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20502": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20503": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20505": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20506": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20507": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20508": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20510": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20515": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20520": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20521": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20522": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20523": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20526": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20527": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20528": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20529": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20530": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20532": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20534": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20535": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20536": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20540": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20543": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20544": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20546": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20547": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20548": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20549": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20551": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20552": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20553": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20554": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20560": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20565": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20566": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20570": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20571": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20577": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20579": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20580": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20581": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20585": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20590": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20591": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20593": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20594": { "city" : "WASHINGTON", "state" : "DC", "county" : "DISTRICT OF COLUMBIA" },
            "20598": { "city" : "DHS", "state" : "VA", "county" : "LOUDOUN" },"20601": { "city" : "WALDORF", "state" : "MD", "county" : "CHARLES" },
            "20602": { "city" : "WALDORF", "state" : "MD", "county" : "CHARLES" },
            "20603": { "city" : "WALDORF", "state" : "MD", "county" : "CHARLES" },
            "20604": { "city" : "WALDORF", "state" : "MD", "county" : "CHARLES" },
            "20607": { "city" : "ACCOKEEK", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20608": { "city" : "AQUASCO", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20609": { "city" : "AVENUE", "state" : "MD", "county" : "SAINT MARYS" },
            "20610": { "city" : "BARSTOW", "state" : "MD", "county" : "CALVERT" },
            "20611": { "city" : "BEL ALTON", "state" : "MD", "county" : "CHARLES" },
            "20612": { "city" : "BENEDICT", "state" : "MD", "county" : "CHARLES" },
            "20613": { "city" : "BRANDYWINE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20615": { "city" : "BROOMES ISLAND", "state" : "MD", "county" : "CALVERT" },
            "20616": { "city" : "BRYANS ROAD", "state" : "MD", "county" : "CHARLES" },
            "20617": { "city" : "BRYANTOWN", "state" : "MD", "county" : "CHARLES" },
            "20618": { "city" : "BUSHWOOD", "state" : "MD", "county" : "SAINT MARYS" },
            "20619": { "city" : "CALIFORNIA", "state" : "MD", "county" : "SAINT MARYS" },
            "20620": { "city" : "CALLAWAY", "state" : "MD", "county" : "SAINT MARYS" },
            "20621": { "city" : "CHAPTICO", "state" : "MD", "county" : "SAINT MARYS" },
            "20622": { "city" : "CHARLOTTE HALL", "state" : "MD", "county" : "SAINT MARYS" },
            "20623": { "city" : "CHELTENHAM", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20624": { "city" : "CLEMENTS", "state" : "MD", "county" : "SAINT MARYS" },
            "20625": { "city" : "COBB ISLAND", "state" : "MD", "county" : "CHARLES" },
            "20626": { "city" : "COLTONS POINT", "state" : "MD", "county" : "SAINT MARYS" },
            "20627": { "city" : "COMPTON", "state" : "MD", "county" : "SAINT MARYS" },
            "20628": { "city" : "DAMERON", "state" : "MD", "county" : "SAINT MARYS" },
            "20629": { "city" : "DOWELL", "state" : "MD", "county" : "CALVERT" },
            "20630": { "city" : "DRAYDEN", "state" : "MD", "county" : "SAINT MARYS" },
            "20632": { "city" : "FAULKNER", "state" : "MD", "county" : "CHARLES" },
            "20634": { "city" : "GREAT MILLS", "state" : "MD", "county" : "SAINT MARYS" },
            "20635": { "city" : "HELEN", "state" : "MD", "county" : "SAINT MARYS" },
            "20636": { "city" : "HOLLYWOOD", "state" : "MD", "county" : "SAINT MARYS" },
            "20637": { "city" : "HUGHESVILLE", "state" : "MD", "county" : "CHARLES" },
            "20639": { "city" : "HUNTINGTOWN", "state" : "MD", "county" : "CALVERT" },
            "20640": { "city" : "INDIAN HEAD", "state" : "MD", "county" : "CHARLES" },
            "20643": { "city" : "IRONSIDES", "state" : "MD", "county" : "CHARLES" },
            "20645": { "city" : "ISSUE", "state" : "MD", "county" : "CHARLES" },"20646": { "city" : "LA PLATA", "state" : "MD", "county" : "CHARLES" },
            "20650": { "city" : "LEONARDTOWN", "state" : "MD", "county" : "SAINT MARYS" },
            "20653": { "city" : "LEXINGTON PARK", "state" : "MD", "county" : "SAINT MARYS" },
            "20656": { "city" : "LOVEVILLE", "state" : "MD", "county" : "SAINT MARYS" },
            "20657": { "city" : "LUSBY", "state" : "MD", "county" : "CALVERT" },"20658": { "city" : "MARBURY", "state" : "MD", "county" : "CHARLES" },
            "20659": { "city" : "MECHANICSVILLE", "state" : "MD", "county" : "SAINT MARYS" },
            "20660": { "city" : "MORGANZA", "state" : "MD", "county" : "SAINT MARYS" },
            "20661": { "city" : "MOUNT VICTORIA", "state" : "MD", "county" : "CHARLES" },
            "20662": { "city" : "NANJEMOY", "state" : "MD", "county" : "CHARLES" },
            "20664": { "city" : "NEWBURG", "state" : "MD", "county" : "CHARLES" },
            "20667": { "city" : "PARK HALL", "state" : "MD", "county" : "SAINT MARYS" },
            "20670": { "city" : "PATUXENT RIVER", "state" : "MD", "county" : "SAINT MARYS" },
            "20674": { "city" : "PINEY POINT", "state" : "MD", "county" : "SAINT MARYS" },
            "20675": { "city" : "POMFRET", "state" : "MD", "county" : "CHARLES" },
            "20676": { "city" : "PORT REPUBLIC", "state" : "MD", "county" : "CALVERT" },
            "20677": { "city" : "PORT TOBACCO", "state" : "MD", "county" : "CHARLES" },
            "20678": { "city" : "PRINCE FREDERICK", "state" : "MD", "county" : "CALVERT" },
            "20680": { "city" : "RIDGE", "state" : "MD", "county" : "SAINT MARYS" },
            "20684": { "city" : "SAINT INIGOES", "state" : "MD", "county" : "SAINT MARYS" },
            "20685": { "city" : "SAINT LEONARD", "state" : "MD", "county" : "CALVERT" },
            "20686": { "city" : "SAINT MARYS CITY", "state" : "MD", "county" : "SAINT MARYS" },
            "20687": { "city" : "SCOTLAND", "state" : "MD", "county" : "SAINT MARYS" },
            "20688": { "city" : "SOLOMONS", "state" : "MD", "county" : "CALVERT" },
            "20689": { "city" : "SUNDERLAND", "state" : "MD", "county" : "CALVERT" },
            "20690": { "city" : "TALL TIMBERS", "state" : "MD", "county" : "SAINT MARYS" },
            "20692": { "city" : "VALLEY LEE", "state" : "MD", "county" : "SAINT MARYS" },
            "20693": { "city" : "WELCOME", "state" : "MD", "county" : "CHARLES" },
            "20695": { "city" : "WHITE PLAINS", "state" : "MD", "county" : "CHARLES" },
            "20701": { "city" : "ANNAPOLIS JUNCTION", "state" : "MD", "county" : "HOWARD" },
            "20703": { "city" : "LANHAM", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20704": { "city" : "BELTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20705": { "city" : "BELTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20706": { "city" : "LANHAM", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20707": { "city" : "LAUREL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20708": { "city" : "LAUREL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20709": { "city" : "LAUREL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20710": { "city" : "BLADENSBURG", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20711": { "city" : "LOTHIAN", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20712": { "city" : "MOUNT RAINIER", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20714": { "city" : "NORTH BEACH", "state" : "MD", "county" : "CALVERT" },
            "20715": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20716": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20717": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20718": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20719": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20720": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20721": { "city" : "BOWIE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20722": { "city" : "BRENTWOOD", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20723": { "city" : "LAUREL", "state" : "MD", "county" : "HOWARD" },"20724": { "city" : "LAUREL", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20725": { "city" : "LAUREL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20726": { "city" : "LAUREL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20731": { "city" : "CAPITOL HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20732": { "city" : "CHESAPEAKE BEACH", "state" : "MD", "county" : "CALVERT" },
            "20733": { "city" : "CHURCHTON", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20735": { "city" : "CLINTON", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20736": { "city" : "OWINGS", "state" : "MD", "county" : "CALVERT" },
            "20737": { "city" : "RIVERDALE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20738": { "city" : "RIVERDALE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20740": { "city" : "COLLEGE PARK", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20741": { "city" : "COLLEGE PARK", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20742": { "city" : "COLLEGE PARK", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20743": { "city" : "CAPITOL HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20744": { "city" : "FORT WASHINGTON", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20745": { "city" : "OXON HILL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20746": { "city" : "SUITLAND", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20747": { "city" : "DISTRICT HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20748": { "city" : "TEMPLE HILLS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20749": { "city" : "FORT WASHINGTON", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20750": { "city" : "OXON HILL", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20751": { "city" : "DEALE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20753": { "city" : "DISTRICT HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20754": { "city" : "DUNKIRK", "state" : "MD", "county" : "CALVERT" },
            "20755": { "city" : "FORT GEORGE G MEADE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20757": { "city" : "TEMPLE HILLS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20758": { "city" : "FRIENDSHIP", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20759": { "city" : "FULTON", "state" : "MD", "county" : "HOWARD" },"20762": { "city" : "ANDREWS AIR FORCE BASE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20763": { "city" : "SAVAGE", "state" : "MD", "county" : "HOWARD" },"20764": { "city" : "SHADY SIDE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20765": { "city" : "GALESVILLE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20768": { "city" : "GREENBELT", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20769": { "city" : "GLENN DALE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20770": { "city" : "GREENBELT", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20771": { "city" : "GREENBELT", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20772": { "city" : "UPPER MARLBORO", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20773": { "city" : "UPPER MARLBORO", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20774": { "city" : "UPPER MARLBORO", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20775": { "city" : "UPPER MARLBORO", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20776": { "city" : "HARWOOD", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20777": { "city" : "HIGHLAND", "state" : "MD", "county" : "HOWARD" },
            "20778": { "city" : "WEST RIVER", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20779": { "city" : "TRACYS LANDING", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "20781": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20782": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20783": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20784": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20785": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20787": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20788": { "city" : "HYATTSVILLE", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20790": { "city" : "CAPITOL HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20791": { "city" : "CAPITOL HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20792": { "city" : "UPPER MARLBORO", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20794": { "city" : "JESSUP", "state" : "MD", "county" : "HOWARD" },"20797": { "city" : "SOUTHERN MD FACILITY", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20799": { "city" : "CAPITOL HEIGHTS", "state" : "MD", "county" : "PRINCE GEORGES" },
            "20810": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20812": { "city" : "GLEN ECHO", "state" : "MD", "county" : "MONTGOMERY" },
            "20813": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20814": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20815": { "city" : "CHEVY CHASE", "state" : "MD", "county" : "MONTGOMERY" },
            "20816": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20817": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20818": { "city" : "CABIN JOHN", "state" : "MD", "county" : "MONTGOMERY" },
            "20824": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20827": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20830": { "city" : "OLNEY", "state" : "MD", "county" : "MONTGOMERY" },
            "20832": { "city" : "OLNEY", "state" : "MD", "county" : "MONTGOMERY" },
            "20833": { "city" : "BROOKEVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20837": { "city" : "POOLESVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20838": { "city" : "BARNESVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20839": { "city" : "BEALLSVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20841": { "city" : "BOYDS", "state" : "MD", "county" : "MONTGOMERY" },
            "20842": { "city" : "DICKERSON", "state" : "MD", "county" : "MONTGOMERY" },
            "20847": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20848": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20849": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20850": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20851": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20852": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20853": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20854": { "city" : "POTOMAC", "state" : "MD", "county" : "MONTGOMERY" },
            "20855": { "city" : "DERWOOD", "state" : "MD", "county" : "MONTGOMERY" },
            "20857": { "city" : "ROCKVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20859": { "city" : "POTOMAC", "state" : "MD", "county" : "MONTGOMERY" },
            "20860": { "city" : "SANDY SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20861": { "city" : "ASHTON", "state" : "MD", "county" : "MONTGOMERY" },
            "20862": { "city" : "BRINKLOW", "state" : "MD", "county" : "MONTGOMERY" },
            "20866": { "city" : "BURTONSVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20868": { "city" : "SPENCERVILLE", "state" : "MD", "county" : "MONTGOMERY" },
            "20871": { "city" : "CLARKSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20872": { "city" : "DAMASCUS", "state" : "MD", "county" : "MONTGOMERY" },
            "20874": { "city" : "GERMANTOWN", "state" : "MD", "county" : "MONTGOMERY" },
            "20875": { "city" : "GERMANTOWN", "state" : "MD", "county" : "MONTGOMERY" },
            "20876": { "city" : "GERMANTOWN", "state" : "MD", "county" : "MONTGOMERY" },
            "20877": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20878": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20879": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20880": { "city" : "WASHINGTON GROVE", "state" : "MD", "county" : "MONTGOMERY" },
            "20882": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20883": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20884": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20885": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20886": { "city" : "MONTGOMERY VILLAGE", "state" : "MD", "county" : "MONTGOMERY" },
            "20889": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20891": { "city" : "KENSINGTON", "state" : "MD", "county" : "MONTGOMERY" },
            "20892": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20894": { "city" : "BETHESDA", "state" : "MD", "county" : "MONTGOMERY" },
            "20895": { "city" : "KENSINGTON", "state" : "MD", "county" : "MONTGOMERY" },
            "20896": { "city" : "GARRETT PARK", "state" : "MD", "county" : "MONTGOMERY" },
            "20897": { "city" : "SUBURB MARYLAND FAC", "state" : "MD", "county" : "MONTGOMERY" },
            "20898": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20899": { "city" : "GAITHERSBURG", "state" : "MD", "county" : "MONTGOMERY" },
            "20901": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20902": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20903": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20904": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20905": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20906": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20907": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20908": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20910": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20911": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20912": { "city" : "TAKOMA PARK", "state" : "MD", "county" : "MONTGOMERY" },
            "20913": { "city" : "TAKOMA PARK", "state" : "MD", "county" : "MONTGOMERY" },
            "20914": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20915": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20916": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20918": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "20993": { "city" : "SILVER SPRING", "state" : "MD", "county" : "MONTGOMERY" },
            "21001": { "city" : "ABERDEEN", "state" : "MD", "county" : "HARFORD" },
            "21005": { "city" : "ABERDEEN PROVING GROUND", "state" : "MD", "county" : "HARFORD" },
            "21009": { "city" : "ABINGDON", "state" : "MD", "county" : "HARFORD" },
            "21010": { "city" : "GUNPOWDER", "state" : "MD", "county" : "HARFORD" },
            "21012": { "city" : "ARNOLD", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21013": { "city" : "BALDWIN", "state" : "MD", "county" : "BALTIMORE" },
            "21014": { "city" : "BEL AIR", "state" : "MD", "county" : "HARFORD" },
            "21015": { "city" : "BEL AIR", "state" : "MD", "county" : "HARFORD" },
            "21017": { "city" : "BELCAMP", "state" : "MD", "county" : "HARFORD" },
            "21018": { "city" : "BENSON", "state" : "MD", "county" : "HARFORD" },
            "21020": { "city" : "BORING", "state" : "MD", "county" : "BALTIMORE" },
            "21022": { "city" : "BROOKLANDVILLE", "state" : "MD", "county" : "BALTIMORE" },
            "21023": { "city" : "BUTLER", "state" : "MD", "county" : "BALTIMORE" },
            "21027": { "city" : "CHASE", "state" : "MD", "county" : "BALTIMORE" },
            "21028": { "city" : "CHURCHVILLE", "state" : "MD", "county" : "HARFORD" },
            "21029": { "city" : "CLARKSVILLE", "state" : "MD", "county" : "HOWARD" },
            "21030": { "city" : "COCKEYSVILLE", "state" : "MD", "county" : "BALTIMORE" },
            "21031": { "city" : "HUNT VALLEY", "state" : "MD", "county" : "BALTIMORE" },
            "21032": { "city" : "CROWNSVILLE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21034": { "city" : "DARLINGTON", "state" : "MD", "county" : "HARFORD" },
            "21035": { "city" : "DAVIDSONVILLE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21036": { "city" : "DAYTON", "state" : "MD", "county" : "HOWARD" },"21037": { "city" : "EDGEWATER", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21040": { "city" : "EDGEWOOD", "state" : "MD", "county" : "HARFORD" },
            "21041": { "city" : "ELLICOTT CITY", "state" : "MD", "county" : "HOWARD" },
            "21042": { "city" : "ELLICOTT CITY", "state" : "MD", "county" : "HOWARD" },
            "21043": { "city" : "ELLICOTT CITY", "state" : "MD", "county" : "HOWARD" },
            "21044": { "city" : "COLUMBIA", "state" : "MD", "county" : "HOWARD" },
            "21045": { "city" : "COLUMBIA", "state" : "MD", "county" : "HOWARD" },
            "21046": { "city" : "COLUMBIA", "state" : "MD", "county" : "HOWARD" },
            "21047": { "city" : "FALLSTON", "state" : "MD", "county" : "HARFORD" },
            "21048": { "city" : "FINKSBURG", "state" : "MD", "county" : "CARROLL" },
            "21050": { "city" : "FOREST HILL", "state" : "MD", "county" : "HARFORD" },
            "21051": { "city" : "FORK", "state" : "MD", "county" : "BALTIMORE" },
            "21052": { "city" : "FORT HOWARD", "state" : "MD", "county" : "BALTIMORE" },
            "21053": { "city" : "FREELAND", "state" : "MD", "county" : "BALTIMORE" },
            "21054": { "city" : "GAMBRILLS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21056": { "city" : "GIBSON ISLAND", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21057": { "city" : "GLEN ARM", "state" : "MD", "county" : "BALTIMORE" },
            "21060": { "city" : "GLEN BURNIE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21061": { "city" : "GLEN BURNIE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21062": { "city" : "GLEN BURNIE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21065": { "city" : "HUNT VALLEY", "state" : "MD", "county" : "BALTIMORE" },
            "21071": { "city" : "GLYNDON", "state" : "MD", "county" : "BALTIMORE" },
            "21074": { "city" : "HAMPSTEAD", "state" : "MD", "county" : "CARROLL" },
            "21075": { "city" : "ELKRIDGE", "state" : "MD", "county" : "HOWARD" },
            "21076": { "city" : "HANOVER", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21077": { "city" : "HARMANS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21078": { "city" : "HAVRE DE GRACE", "state" : "MD", "county" : "HARFORD" },
            "21082": { "city" : "HYDES", "state" : "MD", "county" : "BALTIMORE" },
            "21084": { "city" : "JARRETTSVILLE", "state" : "MD", "county" : "HARFORD" },
            "21085": { "city" : "JOPPA", "state" : "MD", "county" : "HARFORD" },"21087": { "city" : "KINGSVILLE", "state" : "MD", "county" : "BALTIMORE" },
            "21088": { "city" : "LINEBORO", "state" : "MD", "county" : "CARROLL" },
            "21090": { "city" : "LINTHICUM HEIGHTS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21092": { "city" : "LONG GREEN", "state" : "MD", "county" : "BALTIMORE" },
            "21093": { "city" : "LUTHERVILLE TIMONIUM", "state" : "MD", "county" : "BALTIMORE" },
            "21094": { "city" : "LUTHERVILLE TIMONIUM", "state" : "MD", "county" : "BALTIMORE" },
            "21102": { "city" : "MANCHESTER", "state" : "MD", "county" : "CARROLL" },
            "21104": { "city" : "MARRIOTTSVILLE", "state" : "MD", "county" : "CARROLL" },
            "21105": { "city" : "MARYLAND LINE", "state" : "MD", "county" : "BALTIMORE" },
            "21106": { "city" : "MAYO", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21108": { "city" : "MILLERSVILLE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21111": { "city" : "MONKTON", "state" : "MD", "county" : "BALTIMORE" },
            "21113": { "city" : "ODENTON", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21114": { "city" : "CROFTON", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21117": { "city" : "OWINGS MILLS", "state" : "MD", "county" : "BALTIMORE" },
            "21120": { "city" : "PARKTON", "state" : "MD", "county" : "BALTIMORE" },
            "21122": { "city" : "PASADENA", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21123": { "city" : "PASADENA", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21128": { "city" : "PERRY HALL", "state" : "MD", "county" : "BALTIMORE" },
            "21130": { "city" : "PERRYMAN", "state" : "MD", "county" : "HARFORD" },
            "21131": { "city" : "PHOENIX", "state" : "MD", "county" : "BALTIMORE" },
            "21132": { "city" : "PYLESVILLE", "state" : "MD", "county" : "HARFORD" },
            "21133": { "city" : "RANDALLSTOWN", "state" : "MD", "county" : "BALTIMORE" },
            "21136": { "city" : "REISTERSTOWN", "state" : "MD", "county" : "BALTIMORE" },
            "21139": { "city" : "RIDERWOOD", "state" : "MD", "county" : "BALTIMORE" },
            "21140": { "city" : "RIVA", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21144": { "city" : "SEVERN", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21146": { "city" : "SEVERNA PARK", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21150": { "city" : "SIMPSONVILLE", "state" : "MD", "county" : "HOWARD" },
            "21152": { "city" : "SPARKS GLENCOE", "state" : "MD", "county" : "BALTIMORE" },
            "21153": { "city" : "STEVENSON", "state" : "MD", "county" : "BALTIMORE" },
            "21154": { "city" : "STREET", "state" : "MD", "county" : "HARFORD" },
            "21155": { "city" : "UPPERCO", "state" : "MD", "county" : "BALTIMORE" },
            "21156": { "city" : "UPPER FALLS", "state" : "MD", "county" : "BALTIMORE" },
            "21157": { "city" : "WESTMINSTER", "state" : "MD", "county" : "CARROLL" },
            "21158": { "city" : "WESTMINSTER", "state" : "MD", "county" : "CARROLL" },
            "21160": { "city" : "WHITEFORD", "state" : "MD", "county" : "HARFORD" },
            "21161": { "city" : "WHITE HALL", "state" : "MD", "county" : "HARFORD" },
            "21162": { "city" : "WHITE MARSH", "state" : "MD", "county" : "BALTIMORE" },
            "21163": { "city" : "WOODSTOCK", "state" : "MD", "county" : "HOWARD" },
            "21201": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21202": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21203": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21204": { "city" : "TOWSON", "state" : "MD", "county" : "BALTIMORE" },
            "21205": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21206": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21207": { "city" : "GWYNN OAK", "state" : "MD", "county" : "BALTIMORE" },
            "21208": { "city" : "PIKESVILLE", "state" : "MD", "county" : "BALTIMORE" },
            "21209": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21210": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21211": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21212": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21213": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21214": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21215": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21216": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21217": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21218": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21219": { "city" : "SPARROWS POINT", "state" : "MD", "county" : "BALTIMORE" },
            "21220": { "city" : "MIDDLE RIVER", "state" : "MD", "county" : "BALTIMORE" },
            "21221": { "city" : "ESSEX", "state" : "MD", "county" : "BALTIMORE" },
            "21222": { "city" : "DUNDALK", "state" : "MD", "county" : "BALTIMORE" },
            "21223": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21224": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21225": { "city" : "BROOKLYN", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21226": { "city" : "CURTIS BAY", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21227": { "city" : "HALETHORPE", "state" : "MD", "county" : "BALTIMORE" },
            "21228": { "city" : "CATONSVILLE", "state" : "MD", "county" : "BALTIMORE" },
            "21229": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21230": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21231": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21233": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21234": { "city" : "PARKVILLE", "state" : "MD", "county" : "BALTIMORE" },
            "21235": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21236": { "city" : "NOTTINGHAM", "state" : "MD", "county" : "BALTIMORE" },
            "21237": { "city" : "ROSEDALE", "state" : "MD", "county" : "BALTIMORE" },
            "21239": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21240": { "city" : "BALTIMORE", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21241": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21244": { "city" : "WINDSOR MILL", "state" : "MD", "county" : "BALTIMORE" },
            "21250": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE" },
            "21251": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21252": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE" },
            "21265": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21273": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21278": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21282": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE" },
            "21284": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE" },
            "21285": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE" },
            "21286": { "city" : "TOWSON", "state" : "MD", "county" : "BALTIMORE" },
            "21287": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21290": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21297": { "city" : "BALTIMORE", "state" : "MD", "county" : "BALTIMORE CITY" },
            "21401": { "city" : "ANNAPOLIS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21402": { "city" : "ANNAPOLIS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21403": { "city" : "ANNAPOLIS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21404": { "city" : "ANNAPOLIS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21405": { "city" : "ANNAPOLIS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21409": { "city" : "ANNAPOLIS", "state" : "MD", "county" : "ANNE ARUNDEL" },
            "21501": { "city" : "CUMBERLAND", "state" : "MD", "county" : "ALLEGANY" },
            "21502": { "city" : "CUMBERLAND", "state" : "MD", "county" : "ALLEGANY" },
            "21503": { "city" : "CUMBERLAND", "state" : "MD", "county" : "ALLEGANY" },
            "21504": { "city" : "CUMBERLAND", "state" : "MD", "county" : "ALLEGANY" },
            "21505": { "city" : "CUMBERLAND", "state" : "MD", "county" : "ALLEGANY" },
            "21520": { "city" : "ACCIDENT", "state" : "MD", "county" : "GARRETT" },
            "21521": { "city" : "BARTON", "state" : "MD", "county" : "ALLEGANY" },
            "21522": { "city" : "BITTINGER", "state" : "MD", "county" : "GARRETT" },
            "21523": { "city" : "BLOOMINGTON", "state" : "MD", "county" : "GARRETT" },
            "21524": { "city" : "CORRIGANVILLE", "state" : "MD", "county" : "ALLEGANY" },
            "21528": { "city" : "ECKHART MINES", "state" : "MD", "county" : "ALLEGANY" },
            "21529": { "city" : "ELLERSLIE", "state" : "MD", "county" : "ALLEGANY" },
            "21530": { "city" : "FLINTSTONE", "state" : "MD", "county" : "ALLEGANY" },
            "21531": { "city" : "FRIENDSVILLE", "state" : "MD", "county" : "GARRETT" },
            "21532": { "city" : "FROSTBURG", "state" : "MD", "county" : "ALLEGANY" },
            "21536": { "city" : "GRANTSVILLE", "state" : "MD", "county" : "GARRETT" },
            "21538": { "city" : "KITZMILLER", "state" : "MD", "county" : "GARRETT" },
            "21539": { "city" : "LONACONING", "state" : "MD", "county" : "ALLEGANY" },
            "21540": { "city" : "LUKE", "state" : "MD", "county" : "ALLEGANY" },"21541": { "city" : "MC HENRY", "state" : "MD", "county" : "GARRETT" },
            "21542": { "city" : "MIDLAND", "state" : "MD", "county" : "ALLEGANY" },
            "21543": { "city" : "MIDLOTHIAN", "state" : "MD", "county" : "ALLEGANY" },
            "21545": { "city" : "MOUNT SAVAGE", "state" : "MD", "county" : "ALLEGANY" },
            "21550": { "city" : "OAKLAND", "state" : "MD", "county" : "GARRETT" },
            "21555": { "city" : "OLDTOWN", "state" : "MD", "county" : "ALLEGANY" },
            "21556": { "city" : "PINTO", "state" : "MD", "county" : "ALLEGANY" },
            "21557": { "city" : "RAWLINGS", "state" : "MD", "county" : "ALLEGANY" },
            "21561": { "city" : "SWANTON", "state" : "MD", "county" : "GARRETT" },
            "21562": { "city" : "WESTERNPORT", "state" : "MD", "county" : "ALLEGANY" },
            "21601": { "city" : "EASTON", "state" : "MD", "county" : "TALBOT" },"21607": { "city" : "BARCLAY", "state" : "MD", "county" : "QUEEN ANNES" },
            "21610": { "city" : "BETTERTON", "state" : "MD", "county" : "KENT" },
            "21612": { "city" : "BOZMAN", "state" : "MD", "county" : "TALBOT" },"21613": { "city" : "CAMBRIDGE", "state" : "MD", "county" : "DORCHESTER" },
            "21617": { "city" : "CENTREVILLE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21619": { "city" : "CHESTER", "state" : "MD", "county" : "QUEEN ANNES" },
            "21620": { "city" : "CHESTERTOWN", "state" : "MD", "county" : "KENT" },
            "21622": { "city" : "CHURCH CREEK", "state" : "MD", "county" : "DORCHESTER" },
            "21623": { "city" : "CHURCH HILL", "state" : "MD", "county" : "QUEEN ANNES" },
            "21624": { "city" : "CLAIBORNE", "state" : "MD", "county" : "TALBOT" },
            "21625": { "city" : "CORDOVA", "state" : "MD", "county" : "TALBOT" },
            "21628": { "city" : "CRUMPTON", "state" : "MD", "county" : "QUEEN ANNES" },
            "21629": { "city" : "DENTON", "state" : "MD", "county" : "CAROLINE" },
            "21631": { "city" : "EAST NEW MARKET", "state" : "MD", "county" : "DORCHESTER" },
            "21632": { "city" : "FEDERALSBURG", "state" : "MD", "county" : "CAROLINE" },
            "21634": { "city" : "FISHING CREEK", "state" : "MD", "county" : "DORCHESTER" },
            "21635": { "city" : "GALENA", "state" : "MD", "county" : "KENT" },"21636": { "city" : "GOLDSBORO", "state" : "MD", "county" : "CAROLINE" },
            "21638": { "city" : "GRASONVILLE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21639": { "city" : "GREENSBORO", "state" : "MD", "county" : "CAROLINE" },
            "21640": { "city" : "HENDERSON", "state" : "MD", "county" : "CAROLINE" },
            "21641": { "city" : "HILLSBORO", "state" : "MD", "county" : "CAROLINE" },
            "21643": { "city" : "HURLOCK", "state" : "MD", "county" : "DORCHESTER" },
            "21644": { "city" : "INGLESIDE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21645": { "city" : "KENNEDYVILLE", "state" : "MD", "county" : "KENT" },
            "21647": { "city" : "MCDANIEL", "state" : "MD", "county" : "TALBOT" },
            "21648": { "city" : "MADISON", "state" : "MD", "county" : "DORCHESTER" },
            "21649": { "city" : "MARYDEL", "state" : "MD", "county" : "CAROLINE" },
            "21650": { "city" : "MASSEY", "state" : "MD", "county" : "KENT" },"21651": { "city" : "MILLINGTON", "state" : "MD", "county" : "KENT" },
            "21652": { "city" : "NEAVITT", "state" : "MD", "county" : "TALBOT" },
            "21653": { "city" : "NEWCOMB", "state" : "MD", "county" : "TALBOT" },
            "21654": { "city" : "OXFORD", "state" : "MD", "county" : "TALBOT" },"21655": { "city" : "PRESTON", "state" : "MD", "county" : "CAROLINE" },
            "21656": { "city" : "PRICE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21657": { "city" : "QUEEN ANNE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21658": { "city" : "QUEENSTOWN", "state" : "MD", "county" : "QUEEN ANNES" },
            "21659": { "city" : "RHODESDALE", "state" : "MD", "county" : "DORCHESTER" },
            "21660": { "city" : "RIDGELY", "state" : "MD", "county" : "CAROLINE" },
            "21661": { "city" : "ROCK HALL", "state" : "MD", "county" : "KENT" },
            "21662": { "city" : "ROYAL OAK", "state" : "MD", "county" : "TALBOT" },
            "21663": { "city" : "SAINT MICHAELS", "state" : "MD", "county" : "TALBOT" },
            "21664": { "city" : "SECRETARY", "state" : "MD", "county" : "DORCHESTER" },
            "21665": { "city" : "SHERWOOD", "state" : "MD", "county" : "TALBOT" },
            "21666": { "city" : "STEVENSVILLE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21667": { "city" : "STILL POND", "state" : "MD", "county" : "KENT" },
            "21668": { "city" : "SUDLERSVILLE", "state" : "MD", "county" : "QUEEN ANNES" },
            "21669": { "city" : "TAYLORS ISLAND", "state" : "MD", "county" : "DORCHESTER" },
            "21671": { "city" : "TILGHMAN", "state" : "MD", "county" : "TALBOT" },
            "21672": { "city" : "TODDVILLE", "state" : "MD", "county" : "DORCHESTER" },
            "21673": { "city" : "TRAPPE", "state" : "MD", "county" : "TALBOT" },"21676": { "city" : "WITTMAN", "state" : "MD", "county" : "TALBOT" },
            "21677": { "city" : "WOOLFORD", "state" : "MD", "county" : "DORCHESTER" },
            "21678": { "city" : "WORTON", "state" : "MD", "county" : "KENT" },"21679": { "city" : "WYE MILLS", "state" : "MD", "county" : "TALBOT" },
            "21701": { "city" : "FREDERICK", "state" : "MD", "county" : "FREDERICK" },
            "21702": { "city" : "FREDERICK", "state" : "MD", "county" : "FREDERICK" },
            "21703": { "city" : "FREDERICK", "state" : "MD", "county" : "FREDERICK" },
            "21704": { "city" : "FREDERICK", "state" : "MD", "county" : "FREDERICK" },
            "21705": { "city" : "FREDERICK", "state" : "MD", "county" : "FREDERICK" },
            "21709": { "city" : "FREDERICK", "state" : "MD", "county" : "FREDERICK" },
            "21710": { "city" : "ADAMSTOWN", "state" : "MD", "county" : "FREDERICK" },
            "21711": { "city" : "BIG POOL", "state" : "MD", "county" : "WASHINGTON" },
            "21713": { "city" : "BOONSBORO", "state" : "MD", "county" : "WASHINGTON" },
            "21714": { "city" : "BRADDOCK HEIGHTS", "state" : "MD", "county" : "FREDERICK" },
            "21715": { "city" : "BROWNSVILLE", "state" : "MD", "county" : "WASHINGTON" },
            "21716": { "city" : "BRUNSWICK", "state" : "MD", "county" : "FREDERICK" },
            "21717": { "city" : "BUCKEYSTOWN", "state" : "MD", "county" : "FREDERICK" },
            "21718": { "city" : "BURKITTSVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21719": { "city" : "CASCADE", "state" : "MD", "county" : "WASHINGTON" },
            "21720": { "city" : "CAVETOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21721": { "city" : "CHEWSVILLE", "state" : "MD", "county" : "WASHINGTON" },
            "21722": { "city" : "CLEAR SPRING", "state" : "MD", "county" : "WASHINGTON" },
            "21723": { "city" : "COOKSVILLE", "state" : "MD", "county" : "HOWARD" },
            "21727": { "city" : "EMMITSBURG", "state" : "MD", "county" : "FREDERICK" },
            "21733": { "city" : "FAIRPLAY", "state" : "MD", "county" : "WASHINGTON" },
            "21734": { "city" : "FUNKSTOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21737": { "city" : "GLENELG", "state" : "MD", "county" : "HOWARD" },
            "21738": { "city" : "GLENWOOD", "state" : "MD", "county" : "HOWARD" },
            "21740": { "city" : "HAGERSTOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21741": { "city" : "HAGERSTOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21742": { "city" : "HAGERSTOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21746": { "city" : "HAGERSTOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21748": { "city" : "HAGERSTOWN", "state" : "MD", "county" : "WASHINGTON" },
            "21750": { "city" : "HANCOCK", "state" : "MD", "county" : "WASHINGTON" },
            "21754": { "city" : "IJAMSVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21755": { "city" : "JEFFERSON", "state" : "MD", "county" : "FREDERICK" },
            "21756": { "city" : "KEEDYSVILLE", "state" : "MD", "county" : "WASHINGTON" },
            "21757": { "city" : "KEYMAR", "state" : "MD", "county" : "CARROLL" },
            "21758": { "city" : "KNOXVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21762": { "city" : "LIBERTYTOWN", "state" : "MD", "county" : "FREDERICK" },
            "21765": { "city" : "LISBON", "state" : "MD", "county" : "HOWARD" },"21766": { "city" : "LITTLE ORLEANS", "state" : "MD", "county" : "ALLEGANY" },
            "21767": { "city" : "MAUGANSVILLE", "state" : "MD", "county" : "WASHINGTON" },
            "21769": { "city" : "MIDDLETOWN", "state" : "MD", "county" : "FREDERICK" },
            "21770": { "city" : "MONROVIA", "state" : "MD", "county" : "FREDERICK" },
            "21771": { "city" : "MOUNT AIRY", "state" : "MD", "county" : "FREDERICK" },
            "21773": { "city" : "MYERSVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21774": { "city" : "NEW MARKET", "state" : "MD", "county" : "FREDERICK" },
            "21775": { "city" : "NEW MIDWAY", "state" : "MD", "county" : "FREDERICK" },
            "21776": { "city" : "NEW WINDSOR", "state" : "MD", "county" : "CARROLL" },
            "21777": { "city" : "POINT OF ROCKS", "state" : "MD", "county" : "FREDERICK" },
            "21778": { "city" : "ROCKY RIDGE", "state" : "MD", "county" : "FREDERICK" },
            "21779": { "city" : "ROHRERSVILLE", "state" : "MD", "county" : "WASHINGTON" },
            "21780": { "city" : "SABILLASVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21781": { "city" : "SAINT JAMES", "state" : "MD", "county" : "WASHINGTON" },
            "21782": { "city" : "SHARPSBURG", "state" : "MD", "county" : "WASHINGTON" },
            "21783": { "city" : "SMITHSBURG", "state" : "MD", "county" : "WASHINGTON" },
            "21784": { "city" : "SYKESVILLE", "state" : "MD", "county" : "CARROLL" },
            "21787": { "city" : "TANEYTOWN", "state" : "MD", "county" : "CARROLL" },
            "21788": { "city" : "THURMONT", "state" : "MD", "county" : "FREDERICK" },
            "21790": { "city" : "TUSCARORA", "state" : "MD", "county" : "FREDERICK" },
            "21791": { "city" : "UNION BRIDGE", "state" : "MD", "county" : "CARROLL" },
            "21792": { "city" : "UNIONVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21793": { "city" : "WALKERSVILLE", "state" : "MD", "county" : "FREDERICK" },
            "21794": { "city" : "WEST FRIENDSHIP", "state" : "MD", "county" : "HOWARD" },
            "21795": { "city" : "WILLIAMSPORT", "state" : "MD", "county" : "WASHINGTON" },
            "21797": { "city" : "WOODBINE", "state" : "MD", "county" : "HOWARD" },
            "21798": { "city" : "WOODSBORO", "state" : "MD", "county" : "FREDERICK" },
            "21801": { "city" : "SALISBURY", "state" : "MD", "county" : "WICOMICO" },
            "21802": { "city" : "SALISBURY", "state" : "MD", "county" : "WICOMICO" },
            "21803": { "city" : "SALISBURY", "state" : "MD", "county" : "WICOMICO" },
            "21804": { "city" : "SALISBURY", "state" : "MD", "county" : "WICOMICO" },
            "21810": { "city" : "ALLEN", "state" : "MD", "county" : "WICOMICO" },
            "21811": { "city" : "BERLIN", "state" : "MD", "county" : "WORCESTER" },
            "21813": { "city" : "BISHOPVILLE", "state" : "MD", "county" : "WORCESTER" },
            "21814": { "city" : "BIVALVE", "state" : "MD", "county" : "WICOMICO" },
            "21817": { "city" : "CRISFIELD", "state" : "MD", "county" : "SOMERSET" },
            "21821": { "city" : "DEAL ISLAND", "state" : "MD", "county" : "SOMERSET" },
            "21822": { "city" : "EDEN", "state" : "MD", "county" : "WORCESTER" },
            "21824": { "city" : "EWELL", "state" : "MD", "county" : "SOMERSET" },
            "21826": { "city" : "FRUITLAND", "state" : "MD", "county" : "WICOMICO" },
            "21829": { "city" : "GIRDLETREE", "state" : "MD", "county" : "WORCESTER" },
            "21830": { "city" : "HEBRON", "state" : "MD", "county" : "WICOMICO" },
            "21835": { "city" : "LINKWOOD", "state" : "MD", "county" : "DORCHESTER" },
            "21837": { "city" : "MARDELA SPRINGS", "state" : "MD", "county" : "WICOMICO" },
            "21838": { "city" : "MARION STATION", "state" : "MD", "county" : "SOMERSET" },
            "21840": { "city" : "NANTICOKE", "state" : "MD", "county" : "WICOMICO" },
            "21841": { "city" : "NEWARK", "state" : "MD", "county" : "WORCESTER" },
            "21842": { "city" : "OCEAN CITY", "state" : "MD", "county" : "WORCESTER" },
            "21843": { "city" : "OCEAN CITY", "state" : "MD", "county" : "WORCESTER" },
            "21849": { "city" : "PARSONSBURG", "state" : "MD", "county" : "WICOMICO" },
            "21850": { "city" : "PITTSVILLE", "state" : "MD", "county" : "WICOMICO" },
            "21851": { "city" : "POCOMOKE CITY", "state" : "MD", "county" : "WORCESTER" },
            "21852": { "city" : "POWELLVILLE", "state" : "MD", "county" : "WICOMICO" },
            "21853": { "city" : "PRINCESS ANNE", "state" : "MD", "county" : "SOMERSET" },
            "21856": { "city" : "QUANTICO", "state" : "MD", "county" : "WICOMICO" },
            "21857": { "city" : "REHOBETH", "state" : "MD", "county" : "SOMERSET" },
            "21861": { "city" : "SHARPTOWN", "state" : "MD", "county" : "WICOMICO" },
            "21862": { "city" : "SHOWELL", "state" : "MD", "county" : "WORCESTER" },
            "21863": { "city" : "SNOW HILL", "state" : "MD", "county" : "WORCESTER" },
            "21864": { "city" : "STOCKTON", "state" : "MD", "county" : "WORCESTER" },
            "21865": { "city" : "TYASKIN", "state" : "MD", "county" : "WICOMICO" },
            "21866": { "city" : "TYLERTON", "state" : "MD", "county" : "SOMERSET" },
            "21869": { "city" : "VIENNA", "state" : "MD", "county" : "DORCHESTER" },
            "21871": { "city" : "WESTOVER", "state" : "MD", "county" : "SOMERSET" },
            "21872": { "city" : "WHALEYVILLE", "state" : "MD", "county" : "WORCESTER" },
            "21874": { "city" : "WILLARDS", "state" : "MD", "county" : "WICOMICO" },
            "21875": { "city" : "DELMAR", "state" : "MD", "county" : "WICOMICO" },
            "21890": { "city" : "WESTOVER", "state" : "MD", "county" : "SOMERSET" },
            "21901": { "city" : "NORTH EAST", "state" : "MD", "county" : "CECIL" },
            "21902": { "city" : "PERRY POINT", "state" : "MD", "county" : "CECIL" },
            "21903": { "city" : "PERRYVILLE", "state" : "MD", "county" : "CECIL" },
            "21904": { "city" : "PORT DEPOSIT", "state" : "MD", "county" : "CECIL" },
            "21911": { "city" : "RISING SUN", "state" : "MD", "county" : "CECIL" },
            "21912": { "city" : "WARWICK", "state" : "MD", "county" : "CECIL" },"21913": { "city" : "CECILTON", "state" : "MD", "county" : "CECIL" },
            "21914": { "city" : "CHARLESTOWN", "state" : "MD", "county" : "CECIL" },
            "21915": { "city" : "CHESAPEAKE CITY", "state" : "MD", "county" : "CECIL" },
            "21916": { "city" : "CHILDS", "state" : "MD", "county" : "CECIL" },"21917": { "city" : "COLORA", "state" : "MD", "county" : "CECIL" },
            "21918": { "city" : "CONOWINGO", "state" : "MD", "county" : "CECIL" },
            "21919": { "city" : "EARLEVILLE", "state" : "MD", "county" : "CECIL" },
            "21920": { "city" : "ELK MILLS", "state" : "MD", "county" : "CECIL" },
            "21921": { "city" : "ELKTON", "state" : "MD", "county" : "CECIL" },"21922": { "city" : "ELKTON", "state" : "MD", "county" : "CECIL" },
            "21930": { "city" : "GEORGETOWN", "state" : "MD", "county" : "CECIL" },
            "22003": { "city" : "ANNANDALE", "state" : "VA", "county" : "FAIRFAX" },
            "22009": { "city" : "BURKE", "state" : "VA", "county" : "FAIRFAX" },"22015": { "city" : "BURKE", "state" : "VA", "county" : "FAIRFAX" },
            "22025": { "city" : "DUMFRIES", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22026": { "city" : "DUMFRIES", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22027": { "city" : "DUNN LORING", "state" : "VA", "county" : "FAIRFAX" },
            "22030": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX CITY" },
            "22031": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22032": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22033": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22034": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22035": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22036": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22037": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX" },
            "22038": { "city" : "FAIRFAX", "state" : "VA", "county" : "FAIRFAX CITY" },
            "22039": { "city" : "FAIRFAX STATION", "state" : "VA", "county" : "FAIRFAX" },
            "22040": { "city" : "FALLS CHURCH", "state" : "VA", "county" : "FALLS CHURCH CITY" },
            "22041": { "city" : "FALLS CHURCH", "state" : "VA", "county" : "FAIRFAX" },
            "22042": { "city" : "FALLS CHURCH", "state" : "VA", "county" : "FAIRFAX" },
            "22043": { "city" : "FALLS CHURCH", "state" : "VA", "county" : "FAIRFAX" },
            "22044": { "city" : "FALLS CHURCH", "state" : "VA", "county" : "FAIRFAX" },
            "22046": { "city" : "FALLS CHURCH", "state" : "VA", "county" : "FALLS CHURCH CITY" },
            "22060": { "city" : "FORT BELVOIR", "state" : "VA", "county" : "FAIRFAX" },
            "22066": { "city" : "GREAT FALLS", "state" : "VA", "county" : "FAIRFAX" },
            "22079": { "city" : "LORTON", "state" : "VA", "county" : "FAIRFAX" },
            "22081": { "city" : "MERRIFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22082": { "city" : "MERRIFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22096": { "city" : "RESTON", "state" : "VA", "county" : "FAIRFAX" },
            "22101": { "city" : "MC LEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22102": { "city" : "MC LEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22103": { "city" : "WEST MCLEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22106": { "city" : "MC LEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22107": { "city" : "MC LEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22108": { "city" : "MC LEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22109": { "city" : "MC LEAN", "state" : "VA", "county" : "FAIRFAX" },
            "22116": { "city" : "MERRIFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22118": { "city" : "MERRIFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22119": { "city" : "MERRIFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22121": { "city" : "MOUNT VERNON", "state" : "VA", "county" : "FAIRFAX" },
            "22122": { "city" : "NEWINGTON", "state" : "VA", "county" : "FAIRFAX" },
            "22124": { "city" : "OAKTON", "state" : "VA", "county" : "FAIRFAX" },
            "22125": { "city" : "OCCOQUAN", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22134": { "city" : "QUANTICO", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22135": { "city" : "QUANTICO", "state" : "VA", "county" : "STAFFORD" },
            "22150": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22151": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22152": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22153": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22158": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22159": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22161": { "city" : "SPRINGFIELD", "state" : "VA", "county" : "FAIRFAX" },
            "22172": { "city" : "TRIANGLE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22180": { "city" : "VIENNA", "state" : "VA", "county" : "FAIRFAX" },
            "22181": { "city" : "VIENNA", "state" : "VA", "county" : "FAIRFAX" },
            "22182": { "city" : "VIENNA", "state" : "VA", "county" : "FAIRFAX" },
            "22183": { "city" : "VIENNA", "state" : "VA", "county" : "FAIRFAX" },
            "22185": { "city" : "VIENNA", "state" : "VA", "county" : "FAIRFAX" },
            "22191": { "city" : "WOODBRIDGE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22192": { "city" : "WOODBRIDGE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22193": { "city" : "WOODBRIDGE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22194": { "city" : "WOODBRIDGE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22195": { "city" : "WOODBRIDGE", "state" : "VA", "county" : "PRINCE WILLIAM" },
            "22199": { "city" : "LORTON", "state" : "VA", "county" : "FAIRFAX" },
            "22201": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22202": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22203": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22204": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22205": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22206": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22207": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22209": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22210": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22211": { "city" : "FORT MYER", "state" : "VA", "county" : "ARLINGTON" },
            "22212": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22213": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22214": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22215": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22216": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22217": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22219": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22226": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22230": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22240": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22242": { "city" : "ARLINGTON", "state" : "VA", "county" : "ARLINGTON" },
            "22301": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22302": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22303": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22304": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22305": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22306": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22307": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22308": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22309": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22310": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22311": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22312": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22313": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22314": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22315": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "FAIRFAX" },
            "22320": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22331": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22332": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22350": { "city" : "ALEXANDRIA", "state" : "VA", "county" : "ALEXANDRIA CITY" },
            "22401": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "FREDERICKSBURG CITY" },
            "22402": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "FREDERICKSBURG CITY" },
            "22403": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "STAFFORD" },
            "22404": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "FREDERICKSBURG CITY" },
            "22405": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "STAFFORD" },
            "22406": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "STAFFORD" },
            "22407": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "SPOTSYLVANIA" },
            "22408": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "SPOTSYLVANIA" },
            "22412": { "city" : "FREDERICKSBURG", "state" : "VA", "county" : "STAFFORD" },
            "22427": { "city" : "BOWLING GREEN", "state" : "VA", "county" : "CAROLINE" },
            "22432": { "city" : "BURGESS", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22433": { "city" : "BURR HILL", "state" : "VA", "county" : "ORANGE" },
            "22435": { "city" : "CALLAO", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22436": { "city" : "CARET", "state" : "VA", "county" : "ESSEX" },"22437": { "city" : "CENTER CROSS", "state" : "VA", "county" : "ESSEX" },
            "22438": { "city" : "CHAMPLAIN", "state" : "VA", "county" : "ESSEX" },
            "22442": { "city" : "COLES POINT", "state" : "VA", "county" : "WESTMORELAND" },
            "22443": { "city" : "COLONIAL BEACH", "state" : "VA", "county" : "WESTMORELAND" },
            "22446": { "city" : "CORBIN", "state" : "VA", "county" : "CAROLINE" },
            "22448": { "city" : "DAHLGREN", "state" : "VA", "county" : "KING GEORGE" },
            "22454": { "city" : "DUNNSVILLE", "state" : "VA", "county" : "ESSEX" },
            "22456": { "city" : "EDWARDSVILLE", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22460": { "city" : "FARNHAM", "state" : "VA", "county" : "RICHMOND" },
            "22463": { "city" : "GARRISONVILLE", "state" : "VA", "county" : "STAFFORD" },
            "22469": { "city" : "HAGUE", "state" : "VA", "county" : "WESTMORELAND" },
            "22471": { "city" : "HARTWOOD", "state" : "VA", "county" : "STAFFORD" },
            "22472": { "city" : "HAYNESVILLE", "state" : "VA", "county" : "RICHMOND" },
            "22473": { "city" : "HEATHSVILLE", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22476": { "city" : "HUSTLE", "state" : "VA", "county" : "ESSEX" },"22480": { "city" : "IRVINGTON", "state" : "VA", "county" : "LANCASTER" },
            "22481": { "city" : "JERSEY", "state" : "VA", "county" : "KING GEORGE" },
            "22482": { "city" : "KILMARNOCK", "state" : "VA", "county" : "LANCASTER" },
            "22485": { "city" : "KING GEORGE", "state" : "VA", "county" : "KING GEORGE" },
            "22488": { "city" : "KINSALE", "state" : "VA", "county" : "WESTMORELAND" },
            "22501": { "city" : "LADYSMITH", "state" : "VA", "county" : "CAROLINE" },
            "22503": { "city" : "LANCASTER", "state" : "VA", "county" : "LANCASTER" },
            "22504": { "city" : "LANEVIEW", "state" : "VA", "county" : "ESSEX" },
            "22507": { "city" : "LIVELY", "state" : "VA", "county" : "LANCASTER" },
            "22508": { "city" : "LOCUST GROVE", "state" : "VA", "county" : "ORANGE" },
            "22509": { "city" : "LORETTO", "state" : "VA", "county" : "ESSEX" },"22511": { "city" : "LOTTSBURG", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22514": { "city" : "MILFORD", "state" : "VA", "county" : "CAROLINE" },
            "22517": { "city" : "MOLLUSK", "state" : "VA", "county" : "LANCASTER" },
            "22520": { "city" : "MONTROSS", "state" : "VA", "county" : "WESTMORELAND" },
            "22523": { "city" : "MORATTICO", "state" : "VA", "county" : "LANCASTER" },
            "22524": { "city" : "MOUNT HOLLY", "state" : "VA", "county" : "WESTMORELAND" },
            "22526": { "city" : "NINDE", "state" : "VA", "county" : "KING GEORGE" },
            "22529": { "city" : "OLDHAMS", "state" : "VA", "county" : "WESTMORELAND" },
            "22530": { "city" : "OPHELIA", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22534": { "city" : "PARTLOW", "state" : "VA", "county" : "SPOTSYLVANIA" },
            "22535": { "city" : "PORT ROYAL", "state" : "VA", "county" : "CAROLINE" },
            "22538": { "city" : "RAPPAHANNOCK ACADEMY", "state" : "VA", "county" : "CAROLINE" },
            "22539": { "city" : "REEDVILLE", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22542": { "city" : "RHOADESVILLE", "state" : "VA", "county" : "ORANGE" },
            "22544": { "city" : "ROLLINS FORK", "state" : "VA", "county" : "KING GEORGE" },
            "22545": { "city" : "RUBY", "state" : "VA", "county" : "STAFFORD" },"22546": { "city" : "RUTHER GLEN", "state" : "VA", "county" : "CAROLINE" },
            "22547": { "city" : "SEALSTON", "state" : "VA", "county" : "KING GEORGE" },
            "22548": { "city" : "SHARPS", "state" : "VA", "county" : "RICHMOND" },
            "22551": { "city" : "SPOTSYLVANIA", "state" : "VA", "county" : "SPOTSYLVANIA" },
            "22552": { "city" : "SPARTA", "state" : "VA", "county" : "CAROLINE" },
            "22553": { "city" : "SPOTSYLVANIA", "state" : "VA", "county" : "SPOTSYLVANIA" },
            "22554": { "city" : "STAFFORD", "state" : "VA", "county" : "STAFFORD" },
            "22555": { "city" : "STAFFORD", "state" : "VA", "county" : "STAFFORD" },
            "22556": { "city" : "STAFFORD", "state" : "VA", "county" : "STAFFORD" },
            "22558": { "city" : "STRATFORD", "state" : "VA", "county" : "WESTMORELAND" },
            "22560": { "city" : "TAPPAHANNOCK", "state" : "VA", "county" : "ESSEX" },
            "22565": { "city" : "THORNBURG", "state" : "VA", "county" : "SPOTSYLVANIA" },
            "22567": { "city" : "UNIONVILLE", "state" : "VA", "county" : "ORANGE" },
            "22570": { "city" : "VILLAGE", "state" : "VA", "county" : "RICHMOND" },
            "22572": { "city" : "WARSAW", "state" : "VA", "county" : "RICHMOND" },
            "22576": { "city" : "WEEMS", "state" : "VA", "county" : "LANCASTER" },
            "22578": { "city" : "WHITE STONE", "state" : "VA", "county" : "LANCASTER" },
            "22579": { "city" : "WICOMICO CHURCH", "state" : "VA", "county" : "NORTHUMBERLAND" },
            "22580": { "city" : "WOODFORD", "state" : "VA", "county" : "CAROLINE" },
            "22601": { "city" : "WINCHESTER", "state" : "VA", "county" : "WINCHESTER CITY" },
            "22602": { "city" : "WINCHESTER", "state" : "VA", "county" : "FREDERICK" },
            "22603": { "city" : "WINCHESTER", "state" : "VA", "county" : "FREDERICK" },
            "22604": { "city" : "WINCHESTER", "state" : "VA", "county" : "WINCHESTER CITY" },
            "22610": { "city" : "BENTONVILLE", "state" : "VA", "county" : "WARREN" },
            "22611": { "city" : "BERRYVILLE", "state" : "VA", "county" : "CLARKE" },
            "22620": { "city" : "BOYCE", "state" : "VA", "county" : "CLARKE" },"22623": { "city" : "CHESTER GAP", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22624": { "city" : "CLEAR BROOK", "state" : "VA", "county" : "FREDERICK" },
            "22625": { "city" : "CROSS JUNCTION", "state" : "VA", "county" : "FREDERICK" },
            "22626": { "city" : "FISHERS HILL", "state" : "VA", "county" : "SHENANDOAH" },
            "22627": { "city" : "FLINT HILL", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22630": { "city" : "FRONT ROYAL", "state" : "VA", "county" : "WARREN" },
            "22637": { "city" : "GORE", "state" : "VA", "county" : "FREDERICK" },
            "22639": { "city" : "HUME", "state" : "VA", "county" : "FAUQUIER" },"22640": { "city" : "HUNTLY", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22641": { "city" : "STRASBURG", "state" : "VA", "county" : "SHENANDOAH" },
            "22642": { "city" : "LINDEN", "state" : "VA", "county" : "WARREN" },"22643": { "city" : "MARKHAM", "state" : "VA", "county" : "FAUQUIER" },
            "22644": { "city" : "MAURERTOWN", "state" : "VA", "county" : "SHENANDOAH" },
            "22645": { "city" : "MIDDLETOWN", "state" : "VA", "county" : "FREDERICK" },
            "22646": { "city" : "MILLWOOD", "state" : "VA", "county" : "CLARKE" },
            "22649": { "city" : "MIDDLETOWN", "state" : "VA", "county" : "WARREN" },
            "22650": { "city" : "RILEYVILLE", "state" : "VA", "county" : "PAGE" },
            "22652": { "city" : "FORT VALLEY", "state" : "VA", "county" : "SHENANDOAH" },
            "22654": { "city" : "STAR TANNERY", "state" : "VA", "county" : "FREDERICK" },
            "22655": { "city" : "STEPHENS CITY", "state" : "VA", "county" : "FREDERICK" },
            "22656": { "city" : "STEPHENSON", "state" : "VA", "county" : "FREDERICK" },
            "22657": { "city" : "STRASBURG", "state" : "VA", "county" : "SHENANDOAH" },
            "22660": { "city" : "TOMS BROOK", "state" : "VA", "county" : "SHENANDOAH" },
            "22663": { "city" : "WHITE POST", "state" : "VA", "county" : "CLARKE" },
            "22664": { "city" : "WOODSTOCK", "state" : "VA", "county" : "SHENANDOAH" },
            "22701": { "city" : "CULPEPER", "state" : "VA", "county" : "CULPEPER" },
            "22709": { "city" : "ARODA", "state" : "VA", "county" : "MADISON" },"22711": { "city" : "BANCO", "state" : "VA", "county" : "MADISON" },
            "22712": { "city" : "BEALETON", "state" : "VA", "county" : "FAUQUIER" },
            "22713": { "city" : "BOSTON", "state" : "VA", "county" : "CULPEPER" },
            "22714": { "city" : "BRANDY STATION", "state" : "VA", "county" : "CULPEPER" },
            "22715": { "city" : "BRIGHTWOOD", "state" : "VA", "county" : "MADISON" },
            "22716": { "city" : "CASTLETON", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22718": { "city" : "ELKWOOD", "state" : "VA", "county" : "CULPEPER" },
            "22719": { "city" : "ETLAN", "state" : "VA", "county" : "MADISON" },"22720": { "city" : "GOLDVEIN", "state" : "VA", "county" : "FAUQUIER" },
            "22721": { "city" : "GRAVES MILL", "state" : "VA", "county" : "MADISON" },
            "22722": { "city" : "HAYWOOD", "state" : "VA", "county" : "MADISON" },
            "22723": { "city" : "HOOD", "state" : "VA", "county" : "MADISON" },"22724": { "city" : "JEFFERSONTON", "state" : "VA", "county" : "CULPEPER" },
            "22725": { "city" : "LEON", "state" : "VA", "county" : "MADISON" },"22726": { "city" : "LIGNUM", "state" : "VA", "county" : "CULPEPER" },
            "22727": { "city" : "MADISON", "state" : "VA", "county" : "MADISON" },
            "22728": { "city" : "MIDLAND", "state" : "VA", "county" : "FAUQUIER" },
            "22729": { "city" : "MITCHELLS", "state" : "VA", "county" : "CULPEPER" },
            "22730": { "city" : "OAKPARK", "state" : "VA", "county" : "MADISON" },
            "22731": { "city" : "PRATTS", "state" : "VA", "county" : "MADISON" },
            "22732": { "city" : "RADIANT", "state" : "VA", "county" : "MADISON" },
            "22733": { "city" : "RAPIDAN", "state" : "VA", "county" : "CULPEPER" },
            "22734": { "city" : "REMINGTON", "state" : "VA", "county" : "FAUQUIER" },
            "22735": { "city" : "REVA", "state" : "VA", "county" : "MADISON" },"22736": { "city" : "RICHARDSVILLE", "state" : "VA", "county" : "CULPEPER" },
            "22737": { "city" : "RIXEYVILLE", "state" : "VA", "county" : "CULPEPER" },
            "22738": { "city" : "ROCHELLE", "state" : "VA", "county" : "MADISON" },
            "22740": { "city" : "SPERRYVILLE", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22741": { "city" : "STEVENSBURG", "state" : "VA", "county" : "CULPEPER" },
            "22742": { "city" : "SUMERDUCK", "state" : "VA", "county" : "FAUQUIER" },
            "22743": { "city" : "SYRIA", "state" : "VA", "county" : "MADISON" },"22746": { "city" : "VIEWTOWN", "state" : "VA", "county" : "CULPEPER" },
            "22747": { "city" : "WASHINGTON", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22748": { "city" : "WOLFTOWN", "state" : "VA", "county" : "MADISON" },
            "22749": { "city" : "WOODVILLE", "state" : "VA", "county" : "RAPPAHANNOCK" },
            "22801": { "city" : "HARRISONBURG", "state" : "VA", "county" : "HARRISONBURG CITY" },
            "22802": { "city" : "HARRISONBURG", "state" : "VA", "county" : "HARRISONBURG CITY" },
            "22803": { "city" : "HARRISONBURG", "state" : "VA", "county" : "HARRISONBURG CITY" },
            "22807": { "city" : "HARRISONBURG", "state" : "VA", "county" : "HARRISONBURG CITY" },
            "22810": { "city" : "BASYE", "state" : "VA", "county" : "SHENANDOAH" },
            "22811": { "city" : "BERGTON", "state" : "VA", "county" : "ROCKINGHAM" },
            "22812": { "city" : "BRIDGEWATER", "state" : "VA", "county" : "ROCKINGHAM" },
            "22815": { "city" : "BROADWAY", "state" : "VA", "county" : "ROCKINGHAM" },
            "22820": { "city" : "CRIDERS", "state" : "VA", "county" : "ROCKINGHAM" },
            "22821": { "city" : "DAYTON", "state" : "VA", "county" : "ROCKINGHAM" },
            "22824": { "city" : "EDINBURG", "state" : "VA", "county" : "SHENANDOAH" },
            "22827": { "city" : "ELKTON", "state" : "VA", "county" : "ROCKINGHAM" },
            "22830": { "city" : "FULKS RUN", "state" : "VA", "county" : "ROCKINGHAM" },
            "22831": { "city" : "HINTON", "state" : "VA", "county" : "ROCKINGHAM" },
            "22832": { "city" : "KEEZLETOWN", "state" : "VA", "county" : "ROCKINGHAM" },
            "22833": { "city" : "LACEY SPRING", "state" : "VA", "county" : "ROCKINGHAM" },
            "22834": { "city" : "LINVILLE", "state" : "VA", "county" : "ROCKINGHAM" },
            "22835": { "city" : "LURAY", "state" : "VA", "county" : "PAGE" },"22840": { "city" : "MC GAHEYSVILLE", "state" : "VA", "county" : "ROCKINGHAM" },
            "22841": { "city" : "MOUNT CRAWFORD", "state" : "VA", "county" : "ROCKINGHAM" },
            "22842": { "city" : "MOUNT JACKSON", "state" : "VA", "county" : "SHENANDOAH" },
            "22843": { "city" : "MOUNT SOLON", "state" : "VA", "county" : "AUGUSTA" },
            "22844": { "city" : "NEW MARKET", "state" : "VA", "county" : "SHENANDOAH" },
            "22845": { "city" : "ORKNEY SPRINGS", "state" : "VA", "county" : "SHENANDOAH" },
            "22846": { "city" : "PENN LAIRD", "state" : "VA", "county" : "ROCKINGHAM" },
            "22847": { "city" : "QUICKSBURG", "state" : "VA", "county" : "SHENANDOAH" },
            "22849": { "city" : "SHENANDOAH", "state" : "VA", "county" : "PAGE" },
            "22850": { "city" : "SINGERS GLEN", "state" : "VA", "county" : "ROCKINGHAM" },
            "22851": { "city" : "STANLEY", "state" : "VA", "county" : "PAGE" },"22853": { "city" : "TIMBERVILLE", "state" : "VA", "county" : "ROCKINGHAM" },
            "22901": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "22902": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "CHARLOTTESVILLE CITY" },
            "22903": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "CHARLOTTESVILLE CITY" },
            "22904": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "CHARLOTTESVILLE CITY" },
            "22905": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "CHARLOTTESVILLE CITY" },
            "22906": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "CHARLOTTESVILLE CITY" },
            "22908": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "CHARLOTTESVILLE CITY" },
            "22909": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "22911": { "city" : "CHARLOTTESVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "22920": { "city" : "AFTON", "state" : "VA", "county" : "NELSON" },"22922": { "city" : "ARRINGTON", "state" : "VA", "county" : "NELSON" },
            "22923": { "city" : "BARBOURSVILLE", "state" : "VA", "county" : "ORANGE" },
            "22924": { "city" : "BATESVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "22931": { "city" : "COVESVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "22932": { "city" : "CROZET", "state" : "VA", "county" : "ALBEMARLE" },
            "22935": { "city" : "DYKE", "state" : "VA", "county" : "GREENE" },"22936": { "city" : "EARLYSVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "22937": { "city" : "ESMONT", "state" : "VA", "county" : "ALBEMARLE" },
            "22938": { "city" : "FABER", "state" : "VA", "county" : "NELSON" },"22939": { "city" : "FISHERSVILLE", "state" : "VA", "county" : "AUGUSTA" },
            "22940": { "city" : "FREE UNION", "state" : "VA", "county" : "ALBEMARLE" },
            "22942": { "city" : "GORDONSVILLE", "state" : "VA", "county" : "ORANGE" },
            "22943": { "city" : "GREENWOOD", "state" : "VA", "county" : "ALBEMARLE" },
            "22945": { "city" : "IVY", "state" : "VA", "county" : "ALBEMARLE" },"22946": { "city" : "KEENE", "state" : "VA", "county" : "ALBEMARLE" },
            "22947": { "city" : "KESWICK", "state" : "VA", "county" : "ALBEMARLE" },
            "22948": { "city" : "LOCUST DALE", "state" : "VA", "county" : "MADISON" },
            "22949": { "city" : "LOVINGSTON", "state" : "VA", "county" : "NELSON" },
            "22952": { "city" : "LYNDHURST", "state" : "VA", "county" : "AUGUSTA" },
            "22957": { "city" : "MONTPELIER STATION", "state" : "VA", "county" : "ORANGE" },
            "22958": { "city" : "NELLYSFORD", "state" : "VA", "county" : "NELSON" },
            "22959": { "city" : "NORTH GARDEN", "state" : "VA", "county" : "ALBEMARLE" },
            "22960": { "city" : "ORANGE", "state" : "VA", "county" : "ORANGE" },"22963": { "city" : "PALMYRA", "state" : "VA", "county" : "FLUVANNA" },
            "22964": { "city" : "PINEY RIVER", "state" : "VA", "county" : "NELSON" },
            "22965": { "city" : "QUINQUE", "state" : "VA", "county" : "GREENE" },
            "22967": { "city" : "ROSELAND", "state" : "VA", "county" : "NELSON" },
            "22968": { "city" : "RUCKERSVILLE", "state" : "VA", "county" : "GREENE" },
            "22969": { "city" : "SCHUYLER", "state" : "VA", "county" : "NELSON" },
            "22971": { "city" : "SHIPMAN", "state" : "VA", "county" : "NELSON" },
            "22972": { "city" : "SOMERSET", "state" : "VA", "county" : "ORANGE" },
            "22973": { "city" : "STANARDSVILLE", "state" : "VA", "county" : "GREENE" },
            "22974": { "city" : "TROY", "state" : "VA", "county" : "FLUVANNA" },"22976": { "city" : "TYRO", "state" : "VA", "county" : "NELSON" },
            "22980": { "city" : "WAYNESBORO", "state" : "VA", "county" : "WAYNESBORO CITY" },
            "22987": { "city" : "WHITE HALL", "state" : "VA", "county" : "ALBEMARLE" },
            "22989": { "city" : "WOODBERRY FOREST", "state" : "VA", "county" : "MADISON" },
            "23001": { "city" : "ACHILLES", "state" : "VA", "county" : "GLOUCESTER" },
            "23002": { "city" : "AMELIA COURT HOUSE", "state" : "VA", "county" : "AMELIA" },
            "23003": { "city" : "ARK", "state" : "VA", "county" : "GLOUCESTER" },
            "23004": { "city" : "ARVONIA", "state" : "VA", "county" : "BUCKINGHAM" },
            "23005": { "city" : "ASHLAND", "state" : "VA", "county" : "HANOVER" },
            "23009": { "city" : "AYLETT", "state" : "VA", "county" : "KING WILLIAM" },
            "23011": { "city" : "BARHAMSVILLE", "state" : "VA", "county" : "NEW KENT" },
            "23014": { "city" : "BEAUMONT", "state" : "VA", "county" : "GOOCHLAND" },
            "23015": { "city" : "BEAVERDAM", "state" : "VA", "county" : "HANOVER" },
            "23018": { "city" : "BENA", "state" : "VA", "county" : "GLOUCESTER" },
            "23021": { "city" : "BOHANNON", "state" : "VA", "county" : "MATHEWS" },
            "23022": { "city" : "BREMO BLUFF", "state" : "VA", "county" : "FLUVANNA" },
            "23023": { "city" : "BRUINGTON", "state" : "VA", "county" : "KING AND QUEEN" },
            "23024": { "city" : "BUMPASS", "state" : "VA", "county" : "LOUISA" },
            "23025": { "city" : "CARDINAL", "state" : "VA", "county" : "MATHEWS" },
            "23027": { "city" : "CARTERSVILLE", "state" : "VA", "county" : "CUMBERLAND" },
            "23030": { "city" : "CHARLES CITY", "state" : "VA", "county" : "CHARLES CITY" },
            "23031": { "city" : "CHRISTCHURCH", "state" : "VA", "county" : "MIDDLESEX" },
            "23032": { "city" : "CHURCH VIEW", "state" : "VA", "county" : "MIDDLESEX" },
            "23035": { "city" : "COBBS CREEK", "state" : "VA", "county" : "MATHEWS" },
            "23038": { "city" : "COLUMBIA", "state" : "VA", "county" : "GOOCHLAND" },
            "23039": { "city" : "CROZIER", "state" : "VA", "county" : "GOOCHLAND" },
            "23040": { "city" : "CUMBERLAND", "state" : "VA", "county" : "CUMBERLAND" },
            "23043": { "city" : "DELTAVILLE", "state" : "VA", "county" : "MIDDLESEX" },
            "23045": { "city" : "DIGGS", "state" : "VA", "county" : "MATHEWS" },"23047": { "city" : "DOSWELL", "state" : "VA", "county" : "HANOVER" },
            "23050": { "city" : "DUTTON", "state" : "VA", "county" : "GLOUCESTER" },
            "23055": { "city" : "FORK UNION", "state" : "VA", "county" : "FLUVANNA" },
            "23056": { "city" : "FOSTER", "state" : "VA", "county" : "MATHEWS" },
            "23058": { "city" : "GLEN ALLEN", "state" : "VA", "county" : "HENRICO" },
            "23059": { "city" : "GLEN ALLEN", "state" : "VA", "county" : "HENRICO" },
            "23060": { "city" : "GLEN ALLEN", "state" : "VA", "county" : "HENRICO" },
            "23061": { "city" : "GLOUCESTER", "state" : "VA", "county" : "GLOUCESTER" },
            "23062": { "city" : "GLOUCESTER POINT", "state" : "VA", "county" : "GLOUCESTER" },
            "23063": { "city" : "GOOCHLAND", "state" : "VA", "county" : "GOOCHLAND" },
            "23064": { "city" : "GRIMSTEAD", "state" : "VA", "county" : "MATHEWS" },
            "23065": { "city" : "GUM SPRING", "state" : "VA", "county" : "GOOCHLAND" },
            "23066": { "city" : "GWYNN", "state" : "VA", "county" : "MATHEWS" },"23067": { "city" : "HADENSVILLE", "state" : "VA", "county" : "GOOCHLAND" },
            "23068": { "city" : "HALLIEFORD", "state" : "VA", "county" : "MATHEWS" },
            "23069": { "city" : "HANOVER", "state" : "VA", "county" : "HANOVER" },
            "23070": { "city" : "HARDYVILLE", "state" : "VA", "county" : "MIDDLESEX" },
            "23071": { "city" : "HARTFIELD", "state" : "VA", "county" : "MIDDLESEX" },
            "23072": { "city" : "HAYES", "state" : "VA", "county" : "GLOUCESTER" },
            "23075": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23076": { "city" : "HUDGINS", "state" : "VA", "county" : "MATHEWS" },
            "23079": { "city" : "JAMAICA", "state" : "VA", "county" : "MIDDLESEX" },
            "23081": { "city" : "JAMESTOWN", "state" : "VA", "county" : "JAMES CITY" },
            "23083": { "city" : "JETERSVILLE", "state" : "VA", "county" : "AMELIA" },
            "23084": { "city" : "KENTS STORE", "state" : "VA", "county" : "FLUVANNA" },
            "23085": { "city" : "KING AND QUEEN COURT HOUSE", "state" : "VA", "county" : "KING AND QUEEN" },
            "23086": { "city" : "KING WILLIAM", "state" : "VA", "county" : "KING WILLIAM" },
            "23089": { "city" : "LANEXA", "state" : "VA", "county" : "NEW KENT" },
            "23090": { "city" : "LIGHTFOOT", "state" : "VA", "county" : "YORK" },
            "23091": { "city" : "LITTLE PLYMOUTH", "state" : "VA", "county" : "KING AND QUEEN" },
            "23092": { "city" : "LOCUST HILL", "state" : "VA", "county" : "MIDDLESEX" },
            "23093": { "city" : "LOUISA", "state" : "VA", "county" : "LOUISA" },"23101": { "city" : "MACON", "state" : "VA", "county" : "POWHATAN" },
            "23102": { "city" : "MAIDENS", "state" : "VA", "county" : "GOOCHLAND" },
            "23103": { "city" : "MANAKIN SABOT", "state" : "VA", "county" : "GOOCHLAND" },
            "23105": { "city" : "MANNBORO", "state" : "VA", "county" : "AMELIA" },
            "23106": { "city" : "MANQUIN", "state" : "VA", "county" : "KING WILLIAM" },
            "23107": { "city" : "MARYUS", "state" : "VA", "county" : "GLOUCESTER" },
            "23108": { "city" : "MASCOT", "state" : "VA", "county" : "KING AND QUEEN" },
            "23109": { "city" : "MATHEWS", "state" : "VA", "county" : "MATHEWS" },
            "23110": { "city" : "MATTAPONI", "state" : "VA", "county" : "KING AND QUEEN" },
            "23111": { "city" : "MECHANICSVILLE", "state" : "VA", "county" : "HANOVER" },
            "23112": { "city" : "MIDLOTHIAN", "state" : "VA", "county" : "CHESTERFIELD" },
            "23113": { "city" : "MIDLOTHIAN", "state" : "VA", "county" : "CHESTERFIELD" },
            "23114": { "city" : "MIDLOTHIAN", "state" : "VA", "county" : "CHESTERFIELD" },
            "23115": { "city" : "MILLERS TAVERN", "state" : "VA", "county" : "ESSEX" },
            "23116": { "city" : "MECHANICSVILLE", "state" : "VA", "county" : "HANOVER" },
            "23117": { "city" : "MINERAL", "state" : "VA", "county" : "LOUISA" },
            "23119": { "city" : "MOON", "state" : "VA", "county" : "MATHEWS" },"23120": { "city" : "MOSELEY", "state" : "VA", "county" : "CHESTERFIELD" },
            "23123": { "city" : "NEW CANTON", "state" : "VA", "county" : "BUCKINGHAM" },
            "23124": { "city" : "NEW KENT", "state" : "VA", "county" : "NEW KENT" },
            "23125": { "city" : "NEW POINT", "state" : "VA", "county" : "MATHEWS" },
            "23126": { "city" : "NEWTOWN", "state" : "VA", "county" : "KING AND QUEEN" },
            "23127": { "city" : "NORGE", "state" : "VA", "county" : "JAMES CITY" },
            "23128": { "city" : "NORTH", "state" : "VA", "county" : "MATHEWS" },"23129": { "city" : "OILVILLE", "state" : "VA", "county" : "GOOCHLAND" },
            "23130": { "city" : "ONEMO", "state" : "VA", "county" : "MATHEWS" },"23131": { "city" : "ORDINARY", "state" : "VA", "county" : "GLOUCESTER" },
            "23138": { "city" : "PORT HAYWOOD", "state" : "VA", "county" : "MATHEWS" },
            "23139": { "city" : "POWHATAN", "state" : "VA", "county" : "POWHATAN" },
            "23140": { "city" : "PROVIDENCE FORGE", "state" : "VA", "county" : "NEW KENT" },
            "23141": { "city" : "QUINTON", "state" : "VA", "county" : "NEW KENT" },
            "23146": { "city" : "ROCKVILLE", "state" : "VA", "county" : "HANOVER" },
            "23148": { "city" : "SAINT STEPHENS CHURCH", "state" : "VA", "county" : "KING AND QUEEN" },
            "23149": { "city" : "SALUDA", "state" : "VA", "county" : "MIDDLESEX" },
            "23150": { "city" : "SANDSTON", "state" : "VA", "county" : "HENRICO" },
            "23153": { "city" : "SANDY HOOK", "state" : "VA", "county" : "GOOCHLAND" },
            "23154": { "city" : "SCHLEY", "state" : "VA", "county" : "GLOUCESTER" },
            "23156": { "city" : "SHACKLEFORDS", "state" : "VA", "county" : "KING AND QUEEN" },
            "23160": { "city" : "STATE FARM", "state" : "VA", "county" : "GOOCHLAND" },
            "23161": { "city" : "STEVENSVILLE", "state" : "VA", "county" : "KING AND QUEEN" },
            "23162": { "city" : "STUDLEY", "state" : "VA", "county" : "HANOVER" },
            "23163": { "city" : "SUSAN", "state" : "VA", "county" : "MATHEWS" },"23168": { "city" : "TOANO", "state" : "VA", "county" : "JAMES CITY" },
            "23169": { "city" : "TOPPING", "state" : "VA", "county" : "MIDDLESEX" },
            "23173": { "city" : "UNIVERSITY OF RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23175": { "city" : "URBANNA", "state" : "VA", "county" : "MIDDLESEX" },
            "23176": { "city" : "WAKE", "state" : "VA", "county" : "MIDDLESEX" },
            "23177": { "city" : "WALKERTON", "state" : "VA", "county" : "KING AND QUEEN" },
            "23178": { "city" : "WARE NECK", "state" : "VA", "county" : "GLOUCESTER" },
            "23180": { "city" : "WATER VIEW", "state" : "VA", "county" : "MIDDLESEX" },
            "23181": { "city" : "WEST POINT", "state" : "VA", "county" : "KING WILLIAM" },
            "23183": { "city" : "WHITE MARSH", "state" : "VA", "county" : "GLOUCESTER" },
            "23184": { "city" : "WICOMICO", "state" : "VA", "county" : "GLOUCESTER" },
            "23185": { "city" : "WILLIAMSBURG", "state" : "VA", "county" : "JAMES CITY" },
            "23186": { "city" : "WILLIAMSBURG", "state" : "VA", "county" : "WILLIAMSBURG CITY" },
            "23187": { "city" : "WILLIAMSBURG", "state" : "VA", "county" : "WILLIAMSBURG CITY" },
            "23188": { "city" : "WILLIAMSBURG", "state" : "VA", "county" : "JAMES CITY" },
            "23190": { "city" : "WOODS CROSS ROADS", "state" : "VA", "county" : "GLOUCESTER" },
            "23192": { "city" : "MONTPELIER", "state" : "VA", "county" : "HANOVER" },
            "23218": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23219": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23220": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23221": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23222": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23223": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23224": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23225": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23226": { "city" : "RICHMOND", "state" : "VA", "county" : "HENRICO" },
            "23227": { "city" : "RICHMOND", "state" : "VA", "county" : "HENRICO" },
            "23228": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23229": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23230": { "city" : "RICHMOND", "state" : "VA", "county" : "HENRICO" },
            "23231": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23232": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23233": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23234": { "city" : "RICHMOND", "state" : "VA", "county" : "CHESTERFIELD" },
            "23235": { "city" : "RICHMOND", "state" : "VA", "county" : "CHESTERFIELD" },
            "23236": { "city" : "RICHMOND", "state" : "VA", "county" : "CHESTERFIELD" },
            "23237": { "city" : "RICHMOND", "state" : "VA", "county" : "CHESTERFIELD" },
            "23238": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23240": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23241": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23242": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23249": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23250": { "city" : "RICHMOND", "state" : "VA", "county" : "HENRICO" },
            "23255": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23260": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23261": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23273": { "city" : "HENRICO", "state" : "VA", "county" : "RICHMOND CITY" },
            "23279": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23284": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23288": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23294": { "city" : "HENRICO", "state" : "VA", "county" : "HENRICO" },
            "23297": { "city" : "RICHMOND", "state" : "VA", "county" : "CHESTERFIELD" },
            "23298": { "city" : "RICHMOND", "state" : "VA", "county" : "RICHMOND CITY" },
            "23301": { "city" : "ACCOMAC", "state" : "VA", "county" : "ACCOMACK" },
            "23302": { "city" : "ASSAWOMAN", "state" : "VA", "county" : "ACCOMACK" },
            "23303": { "city" : "ATLANTIC", "state" : "VA", "county" : "ACCOMACK" },
            "23304": { "city" : "BATTERY PARK", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23306": { "city" : "BELLE HAVEN", "state" : "VA", "county" : "ACCOMACK" },
            "23307": { "city" : "BIRDSNEST", "state" : "VA", "county" : "NORTHAMPTON" },
            "23308": { "city" : "BLOXOM", "state" : "VA", "county" : "ACCOMACK" },
            "23310": { "city" : "CAPE CHARLES", "state" : "VA", "county" : "NORTHAMPTON" },
            "23313": { "city" : "CAPEVILLE", "state" : "VA", "county" : "NORTHAMPTON" },
            "23314": { "city" : "CARROLLTON", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23315": { "city" : "CARRSVILLE", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23316": { "city" : "CHERITON", "state" : "VA", "county" : "NORTHAMPTON" },
            "23320": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23321": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23322": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23323": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23324": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23325": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23326": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23327": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23328": { "city" : "CHESAPEAKE", "state" : "VA", "county" : "CHESAPEAKE CITY" },
            "23336": { "city" : "CHINCOTEAGUE ISLAND", "state" : "VA", "county" : "ACCOMACK" },
            "23337": { "city" : "WALLOPS ISLAND", "state" : "VA", "county" : "ACCOMACK" },
            "23341": { "city" : "CRADDOCKVILLE", "state" : "VA", "county" : "ACCOMACK" },
            "23345": { "city" : "DAVIS WHARF", "state" : "VA", "county" : "ACCOMACK" },
            "23347": { "city" : "EASTVILLE", "state" : "VA", "county" : "NORTHAMPTON" },
            "23350": { "city" : "EXMORE", "state" : "VA", "county" : "NORTHAMPTON" },
            "23354": { "city" : "FRANKTOWN", "state" : "VA", "county" : "NORTHAMPTON" },
            "23356": { "city" : "GREENBACKVILLE", "state" : "VA", "county" : "ACCOMACK" },
            "23357": { "city" : "GREENBUSH", "state" : "VA", "county" : "ACCOMACK" },
            "23358": { "city" : "HACKSNECK", "state" : "VA", "county" : "ACCOMACK" },
            "23359": { "city" : "HALLWOOD", "state" : "VA", "county" : "ACCOMACK" },
            "23389": { "city" : "HARBORTON", "state" : "VA", "county" : "ACCOMACK" },
            "23395": { "city" : "HORNTOWN", "state" : "VA", "county" : "ACCOMACK" },
            "23396": { "city" : "OAK HALL", "state" : "VA", "county" : "ACCOMACK" },
            "23397": { "city" : "ISLE OF WIGHT", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23398": { "city" : "JAMESVILLE", "state" : "VA", "county" : "NORTHAMPTON" },
            "23401": { "city" : "KELLER", "state" : "VA", "county" : "ACCOMACK" },
            "23404": { "city" : "LOCUSTVILLE", "state" : "VA", "county" : "ACCOMACK" },
            "23405": { "city" : "MACHIPONGO", "state" : "VA", "county" : "NORTHAMPTON" },
            "23407": { "city" : "MAPPSVILLE", "state" : "VA", "county" : "ACCOMACK" },
            "23408": { "city" : "MARIONVILLE", "state" : "VA", "county" : "NORTHAMPTON" },
            "23409": { "city" : "MEARS", "state" : "VA", "county" : "ACCOMACK" },
            "23410": { "city" : "MELFA", "state" : "VA", "county" : "ACCOMACK" },
            "23413": { "city" : "NASSAWADOX", "state" : "VA", "county" : "NORTHAMPTON" },
            "23414": { "city" : "NELSONIA", "state" : "VA", "county" : "ACCOMACK" },
            "23415": { "city" : "NEW CHURCH", "state" : "VA", "county" : "ACCOMACK" },
            "23416": { "city" : "OAK HALL", "state" : "VA", "county" : "ACCOMACK" },
            "23417": { "city" : "ONANCOCK", "state" : "VA", "county" : "ACCOMACK" },
            "23418": { "city" : "ONLEY", "state" : "VA", "county" : "ACCOMACK" },
            "23419": { "city" : "OYSTER", "state" : "VA", "county" : "NORTHAMPTON" },
            "23420": { "city" : "PAINTER", "state" : "VA", "county" : "ACCOMACK" },
            "23421": { "city" : "PARKSLEY", "state" : "VA", "county" : "ACCOMACK" },
            "23422": { "city" : "PUNGOTEAGUE", "state" : "VA", "county" : "ACCOMACK" },
            "23423": { "city" : "QUINBY", "state" : "VA", "county" : "ACCOMACK" },
            "23424": { "city" : "RESCUE", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23426": { "city" : "SANFORD", "state" : "VA", "county" : "ACCOMACK" },
            "23427": { "city" : "SAXIS", "state" : "VA", "county" : "ACCOMACK" },
            "23430": { "city" : "SMITHFIELD", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23431": { "city" : "SMITHFIELD", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23432": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23433": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23434": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23435": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23436": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23437": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23438": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23439": { "city" : "SUFFOLK", "state" : "VA", "county" : "SUFFOLK CITY" },
            "23440": { "city" : "TANGIER", "state" : "VA", "county" : "ACCOMACK" },
            "23441": { "city" : "TASLEY", "state" : "VA", "county" : "ACCOMACK" },
            "23442": { "city" : "TEMPERANCEVILLE", "state" : "VA", "county" : "ACCOMACK" },
            "23443": { "city" : "TOWNSEND", "state" : "VA", "county" : "NORTHAMPTON" },
            "23450": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23451": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23452": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23453": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23454": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23455": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23456": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23457": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23458": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23459": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23460": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23461": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23462": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23463": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23464": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23465": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23466": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23467": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23471": { "city" : "VIRGINIA BEACH", "state" : "VA", "county" : "VIRGINIA BEACH CITY" },
            "23480": { "city" : "WACHAPREAGUE", "state" : "VA", "county" : "ACCOMACK" },
            "23482": { "city" : "WARDTOWN", "state" : "VA", "county" : "NORTHAMPTON" },
            "23483": { "city" : "WATTSVILLE", "state" : "VA", "county" : "ACCOMACK" },
            "23486": { "city" : "WILLIS WHARF", "state" : "VA", "county" : "NORTHAMPTON" },
            "23487": { "city" : "WINDSOR", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23501": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23502": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23503": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23504": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23505": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23506": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23507": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23508": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23509": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23510": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23511": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23512": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23513": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23514": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23515": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23517": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23518": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23520": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23521": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23523": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23529": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23541": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23551": { "city" : "NORFOLK", "state" : "VA", "county" : "NORFOLK CITY" },
            "23601": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23602": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23603": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23604": { "city" : "FORT EUSTIS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23605": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23606": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23607": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23608": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23609": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23612": { "city" : "NEWPORT NEWS", "state" : "VA", "county" : "NEWPORT NEWS CITY" },
            "23630": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23651": { "city" : "FORT MONROE", "state" : "VA", "county" : "HAMPTON CITY" },
            "23661": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23662": { "city" : "POQUOSON", "state" : "VA", "county" : "POQUOSON CITY" },
            "23663": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23664": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23665": { "city" : "HAMPTON", "state" : "VA", "county" : "YORK" },"23666": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23667": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23668": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23669": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23670": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23681": { "city" : "HAMPTON", "state" : "VA", "county" : "HAMPTON CITY" },
            "23690": { "city" : "YORKTOWN", "state" : "VA", "county" : "YORK" },"23691": { "city" : "YORKTOWN", "state" : "VA", "county" : "YORK" },
            "23692": { "city" : "YORKTOWN", "state" : "VA", "county" : "YORK" },"23693": { "city" : "YORKTOWN", "state" : "VA", "county" : "YORK" },
            "23694": { "city" : "LACKEY", "state" : "VA", "county" : "YORK" },"23696": { "city" : "SEAFORD", "state" : "VA", "county" : "YORK" },
            "23701": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23702": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23703": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23704": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23705": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23707": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23708": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23709": { "city" : "PORTSMOUTH", "state" : "VA", "county" : "PORTSMOUTH CITY" },
            "23801": { "city" : "FORT LEE", "state" : "VA", "county" : "PRINCE GEORGE" },
            "23803": { "city" : "PETERSBURG", "state" : "VA", "county" : "PETERSBURG CITY" },
            "23804": { "city" : "PETERSBURG", "state" : "VA", "county" : "PETERSBURG CITY" },
            "23805": { "city" : "PETERSBURG", "state" : "VA", "county" : "PETERSBURG CITY" },
            "23806": { "city" : "PETERSBURG", "state" : "VA", "county" : "PETERSBURG CITY" },
            "23821": { "city" : "ALBERTA", "state" : "VA", "county" : "BRUNSWICK" },
            "23822": { "city" : "AMMON", "state" : "VA", "county" : "DINWIDDIE" },
            "23824": { "city" : "BLACKSTONE", "state" : "VA", "county" : "NOTTOWAY" },
            "23827": { "city" : "BOYKINS", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23828": { "city" : "BRANCHVILLE", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23829": { "city" : "CAPRON", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23830": { "city" : "CARSON", "state" : "VA", "county" : "DINWIDDIE" },
            "23831": { "city" : "CHESTER", "state" : "VA", "county" : "CHESTERFIELD" },
            "23832": { "city" : "CHESTERFIELD", "state" : "VA", "county" : "CHESTERFIELD" },
            "23833": { "city" : "CHURCH ROAD", "state" : "VA", "county" : "DINWIDDIE" },
            "23834": { "city" : "COLONIAL HEIGHTS", "state" : "VA", "county" : "COLONIAL HEIGHTS CITY" },
            "23836": { "city" : "CHESTER", "state" : "VA", "county" : "CHESTERFIELD" },
            "23837": { "city" : "COURTLAND", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23838": { "city" : "CHESTERFIELD", "state" : "VA", "county" : "CHESTERFIELD" },
            "23839": { "city" : "DENDRON", "state" : "VA", "county" : "SURRY" },"23840": { "city" : "DEWITT", "state" : "VA", "county" : "DINWIDDIE" },
            "23841": { "city" : "DINWIDDIE", "state" : "VA", "county" : "DINWIDDIE" },
            "23842": { "city" : "DISPUTANTA", "state" : "VA", "county" : "PRINCE GEORGE" },
            "23843": { "city" : "DOLPHIN", "state" : "VA", "county" : "BRUNSWICK" },
            "23844": { "city" : "DREWRYVILLE", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23845": { "city" : "EBONY", "state" : "VA", "county" : "BRUNSWICK" },
            "23846": { "city" : "ELBERON", "state" : "VA", "county" : "SURRY" },"23847": { "city" : "EMPORIA", "state" : "VA", "county" : "GREENSVILLE" },
            "23850": { "city" : "FORD", "state" : "VA", "county" : "DINWIDDIE" },
            "23851": { "city" : "FRANKLIN", "state" : "VA", "county" : "FRANKLIN CITY" },
            "23856": { "city" : "FREEMAN", "state" : "VA", "county" : "BRUNSWICK" },
            "23857": { "city" : "GASBURG", "state" : "VA", "county" : "BRUNSWICK" },
            "23860": { "city" : "HOPEWELL", "state" : "VA", "county" : "HOPEWELL CITY" },
            "23866": { "city" : "IVOR", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23867": { "city" : "JARRATT", "state" : "VA", "county" : "GREENSVILLE" },
            "23868": { "city" : "LAWRENCEVILLE", "state" : "VA", "county" : "BRUNSWICK" },
            "23870": { "city" : "JARRATT", "state" : "VA", "county" : "GREENSVILLE" },
            "23872": { "city" : "MC KENNEY", "state" : "VA", "county" : "DINWIDDIE" },
            "23874": { "city" : "NEWSOMS", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23875": { "city" : "PRINCE GEORGE", "state" : "VA", "county" : "PRINCE GEORGE" },
            "23876": { "city" : "RAWLINGS", "state" : "VA", "county" : "BRUNSWICK" },
            "23878": { "city" : "SEDLEY", "state" : "VA", "county" : "SOUTHAMPTON" },
            "23879": { "city" : "SKIPPERS", "state" : "VA", "county" : "GREENSVILLE" },
            "23881": { "city" : "SPRING GROVE", "state" : "VA", "county" : "SURRY" },
            "23882": { "city" : "STONY CREEK", "state" : "VA", "county" : "SUSSEX" },
            "23883": { "city" : "SURRY", "state" : "VA", "county" : "SURRY" },"23884": { "city" : "SUSSEX", "state" : "VA", "county" : "SUSSEX" },
            "23885": { "city" : "SUTHERLAND", "state" : "VA", "county" : "DINWIDDIE" },
            "23887": { "city" : "VALENTINES", "state" : "VA", "county" : "BRUNSWICK" },
            "23888": { "city" : "WAKEFIELD", "state" : "VA", "county" : "SUSSEX" },
            "23889": { "city" : "WARFIELD", "state" : "VA", "county" : "BRUNSWICK" },
            "23890": { "city" : "WAVERLY", "state" : "VA", "county" : "SUSSEX" },
            "23891": { "city" : "WAVERLY", "state" : "VA", "county" : "SUSSEX" },
            "23893": { "city" : "WHITE PLAINS", "state" : "VA", "county" : "BRUNSWICK" },
            "23894": { "city" : "WILSONS", "state" : "VA", "county" : "DINWIDDIE" },
            "23897": { "city" : "YALE", "state" : "VA", "county" : "SUSSEX" },"23898": { "city" : "ZUNI", "state" : "VA", "county" : "ISLE OF WIGHT" },
            "23899": { "city" : "CLAREMONT", "state" : "VA", "county" : "SURRY" },
            "23901": { "city" : "FARMVILLE", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23909": { "city" : "FARMVILLE", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23915": { "city" : "BASKERVILLE", "state" : "VA", "county" : "MECKLENBURG" },
            "23917": { "city" : "BOYDTON", "state" : "VA", "county" : "MECKLENBURG" },
            "23919": { "city" : "BRACEY", "state" : "VA", "county" : "MECKLENBURG" },
            "23920": { "city" : "BRODNAX", "state" : "VA", "county" : "BRUNSWICK" },
            "23921": { "city" : "BUCKINGHAM", "state" : "VA", "county" : "BUCKINGHAM" },
            "23922": { "city" : "BURKEVILLE", "state" : "VA", "county" : "NOTTOWAY" },
            "23923": { "city" : "CHARLOTTE COURT HOUSE", "state" : "VA", "county" : "CHARLOTTE" },
            "23924": { "city" : "CHASE CITY", "state" : "VA", "county" : "MECKLENBURG" },
            "23927": { "city" : "CLARKSVILLE", "state" : "VA", "county" : "MECKLENBURG" },
            "23930": { "city" : "CREWE", "state" : "VA", "county" : "NOTTOWAY" },
            "23934": { "city" : "CULLEN", "state" : "VA", "county" : "CHARLOTTE" },
            "23936": { "city" : "DILLWYN", "state" : "VA", "county" : "BUCKINGHAM" },
            "23937": { "city" : "DRAKES BRANCH", "state" : "VA", "county" : "CHARLOTTE" },
            "23938": { "city" : "DUNDAS", "state" : "VA", "county" : "LUNENBURG" },
            "23939": { "city" : "EVERGREEN", "state" : "VA", "county" : "APPOMATTOX" },
            "23942": { "city" : "GREEN BAY", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23943": { "city" : "HAMPDEN SYDNEY", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23944": { "city" : "KENBRIDGE", "state" : "VA", "county" : "LUNENBURG" },
            "23947": { "city" : "KEYSVILLE", "state" : "VA", "county" : "CHARLOTTE" },
            "23950": { "city" : "LA CROSSE", "state" : "VA", "county" : "MECKLENBURG" },
            "23952": { "city" : "LUNENBURG", "state" : "VA", "county" : "LUNENBURG" },
            "23954": { "city" : "MEHERRIN", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23955": { "city" : "NOTTOWAY", "state" : "VA", "county" : "NOTTOWAY" },
            "23958": { "city" : "PAMPLIN", "state" : "VA", "county" : "APPOMATTOX" },
            "23959": { "city" : "PHENIX", "state" : "VA", "county" : "CHARLOTTE" },
            "23960": { "city" : "PROSPECT", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23962": { "city" : "RANDOLPH", "state" : "VA", "county" : "CHARLOTTE" },
            "23963": { "city" : "RED HOUSE", "state" : "VA", "county" : "CHARLOTTE" },
            "23964": { "city" : "RED OAK", "state" : "VA", "county" : "CHARLOTTE" },
            "23966": { "city" : "RICE", "state" : "VA", "county" : "PRINCE EDWARD" },
            "23967": { "city" : "SAXE", "state" : "VA", "county" : "CHARLOTTE" },
            "23968": { "city" : "SKIPWITH", "state" : "VA", "county" : "MECKLENBURG" },
            "23970": { "city" : "SOUTH HILL", "state" : "VA", "county" : "MECKLENBURG" },
            "23974": { "city" : "VICTORIA", "state" : "VA", "county" : "LUNENBURG" },
            "23976": { "city" : "WYLLIESBURG", "state" : "VA", "county" : "CHARLOTTE" },
            "24001": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24002": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24004": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24006": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24007": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24008": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24010": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24011": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24012": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24013": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24014": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24015": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24016": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24017": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24018": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE" },
            "24019": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE" },
            "24020": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE" },
            "24022": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24023": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24024": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24025": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24026": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24027": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24028": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24029": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24033": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24034": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24035": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24036": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24037": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24038": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24040": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24043": { "city" : "ROANOKE", "state" : "VA", "county" : "ROANOKE CITY" },
            "24053": { "city" : "ARARAT", "state" : "VA", "county" : "PATRICK" },
            "24054": { "city" : "AXTON", "state" : "VA", "county" : "HENRY" },"24055": { "city" : "BASSETT", "state" : "VA", "county" : "HENRY" },
            "24058": { "city" : "BELSPRING", "state" : "VA", "county" : "PULASKI" },
            "24059": { "city" : "BENT MOUNTAIN", "state" : "VA", "county" : "ROANOKE" },
            "24060": { "city" : "BLACKSBURG", "state" : "VA", "county" : "MONTGOMERY" },
            "24061": { "city" : "BLACKSBURG", "state" : "VA", "county" : "MONTGOMERY" },
            "24062": { "city" : "BLACKSBURG", "state" : "VA", "county" : "MONTGOMERY" },
            "24063": { "city" : "BLACKSBURG", "state" : "VA", "county" : "MONTGOMERY" },
            "24064": { "city" : "BLUE RIDGE", "state" : "VA", "county" : "BOTETOURT" },
            "24065": { "city" : "BOONES MILL", "state" : "VA", "county" : "FRANKLIN" },
            "24066": { "city" : "BUCHANAN", "state" : "VA", "county" : "BOTETOURT" },
            "24067": { "city" : "CALLAWAY", "state" : "VA", "county" : "FRANKLIN" },
            "24068": { "city" : "CHRISTIANSBURG", "state" : "VA", "county" : "MONTGOMERY" },
            "24069": { "city" : "CASCADE", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24070": { "city" : "CATAWBA", "state" : "VA", "county" : "ROANOKE" },
            "24072": { "city" : "CHECK", "state" : "VA", "county" : "FLOYD" },"24073": { "city" : "CHRISTIANSBURG", "state" : "VA", "county" : "MONTGOMERY" },
            "24076": { "city" : "CLAUDVILLE", "state" : "VA", "county" : "PATRICK" },
            "24077": { "city" : "CLOVERDALE", "state" : "VA", "county" : "BOTETOURT" },
            "24078": { "city" : "COLLINSVILLE", "state" : "VA", "county" : "HENRY" },
            "24079": { "city" : "COPPER HILL", "state" : "VA", "county" : "FLOYD" },
            "24082": { "city" : "CRITZ", "state" : "VA", "county" : "PATRICK" },"24083": { "city" : "DALEVILLE", "state" : "VA", "county" : "BOTETOURT" },
            "24084": { "city" : "DUBLIN", "state" : "VA", "county" : "PULASKI" },
            "24085": { "city" : "EAGLE ROCK", "state" : "VA", "county" : "BOTETOURT" },
            "24086": { "city" : "EGGLESTON", "state" : "VA", "county" : "GILES" },
            "24087": { "city" : "ELLISTON", "state" : "VA", "county" : "MONTGOMERY" },
            "24088": { "city" : "FERRUM", "state" : "VA", "county" : "FRANKLIN" },
            "24089": { "city" : "FIELDALE", "state" : "VA", "county" : "HENRY" },
            "24090": { "city" : "FINCASTLE", "state" : "VA", "county" : "BOTETOURT" },
            "24091": { "city" : "FLOYD", "state" : "VA", "county" : "FLOYD" },"24092": { "city" : "GLADE HILL", "state" : "VA", "county" : "FRANKLIN" },
            "24093": { "city" : "GLEN LYN", "state" : "VA", "county" : "GILES" },
            "24095": { "city" : "GOODVIEW", "state" : "VA", "county" : "BEDFORD" },
            "24101": { "city" : "HARDY", "state" : "VA", "county" : "FRANKLIN" },
            "24102": { "city" : "HENRY", "state" : "VA", "county" : "FRANKLIN" },
            "24104": { "city" : "HUDDLESTON", "state" : "VA", "county" : "BEDFORD" },
            "24105": { "city" : "INDIAN VALLEY", "state" : "VA", "county" : "FLOYD" },
            "24111": { "city" : "MC COY", "state" : "VA", "county" : "MONTGOMERY" },
            "24112": { "city" : "MARTINSVILLE", "state" : "VA", "county" : "MARTINSVILLE CITY" },
            "24113": { "city" : "MARTINSVILLE", "state" : "VA", "county" : "MARTINSVILLE CITY" },
            "24114": { "city" : "MARTINSVILLE", "state" : "VA", "county" : "MARTINSVILLE CITY" },
            "24115": { "city" : "MARTINSVILLE", "state" : "VA", "county" : "MARTINSVILLE CITY" },
            "24120": { "city" : "MEADOWS OF DAN", "state" : "VA", "county" : "PATRICK" },
            "24121": { "city" : "MONETA", "state" : "VA", "county" : "BEDFORD" },
            "24122": { "city" : "MONTVALE", "state" : "VA", "county" : "BEDFORD" },
            "24124": { "city" : "NARROWS", "state" : "VA", "county" : "GILES" },"24126": { "city" : "NEWBERN", "state" : "VA", "county" : "PULASKI" },
            "24127": { "city" : "NEW CASTLE", "state" : "VA", "county" : "CRAIG" },
            "24128": { "city" : "NEWPORT", "state" : "VA", "county" : "GILES" },"24129": { "city" : "NEW RIVER", "state" : "VA", "county" : "PULASKI" },
            "24131": { "city" : "PAINT BANK", "state" : "VA", "county" : "CRAIG" },
            "24132": { "city" : "PARROTT", "state" : "VA", "county" : "PULASKI" },
            "24133": { "city" : "PATRICK SPRINGS", "state" : "VA", "county" : "PATRICK" },
            "24134": { "city" : "PEARISBURG", "state" : "VA", "county" : "GILES" },
            "24136": { "city" : "PEMBROKE", "state" : "VA", "county" : "GILES" },
            "24137": { "city" : "PENHOOK", "state" : "VA", "county" : "FRANKLIN" },
            "24138": { "city" : "PILOT", "state" : "VA", "county" : "MONTGOMERY" },
            "24139": { "city" : "PITTSVILLE", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24141": { "city" : "RADFORD", "state" : "VA", "county" : "RADFORD" },
            "24142": { "city" : "RADFORD", "state" : "VA", "county" : "RADFORD" },
            "24143": { "city" : "RADFORD", "state" : "VA", "county" : "RADFORD" },
            "24147": { "city" : "RICH CREEK", "state" : "VA", "county" : "GILES" },
            "24148": { "city" : "RIDGEWAY", "state" : "VA", "county" : "HENRY" },
            "24149": { "city" : "RINER", "state" : "VA", "county" : "MONTGOMERY" },
            "24150": { "city" : "RIPPLEMEAD", "state" : "VA", "county" : "GILES" },
            "24151": { "city" : "ROCKY MOUNT", "state" : "VA", "county" : "FRANKLIN" },
            "24153": { "city" : "SALEM", "state" : "VA", "county" : "SALEM" },"24155": { "city" : "ROANOKE", "state" : "VA", "county" : "SALEM" },
            "24161": { "city" : "SANDY LEVEL", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24162": { "city" : "SHAWSVILLE", "state" : "VA", "county" : "MONTGOMERY" },
            "24165": { "city" : "SPENCER", "state" : "VA", "county" : "HENRY" },"24168": { "city" : "STANLEYTOWN", "state" : "VA", "county" : "HENRY" },
            "24171": { "city" : "STUART", "state" : "VA", "county" : "PATRICK" },
            "24174": { "city" : "THAXTON", "state" : "VA", "county" : "BEDFORD" },
            "24175": { "city" : "TROUTVILLE", "state" : "VA", "county" : "BOTETOURT" },
            "24176": { "city" : "UNION HALL", "state" : "VA", "county" : "FRANKLIN" },
            "24177": { "city" : "VESTA", "state" : "VA", "county" : "PATRICK" },"24179": { "city" : "VINTON", "state" : "VA", "county" : "ROANOKE" },
            "24184": { "city" : "WIRTZ", "state" : "VA", "county" : "FRANKLIN" },
            "24185": { "city" : "WOOLWINE", "state" : "VA", "county" : "PATRICK" },
            "24201": { "city" : "BRISTOL", "state" : "VA", "county" : "BRISTOL" },
            "24202": { "city" : "BRISTOL", "state" : "VA", "county" : "WASHINGTON" },
            "24203": { "city" : "BRISTOL", "state" : "VA", "county" : "BRISTOL" },
            "24209": { "city" : "BRISTOL", "state" : "VA", "county" : "BRISTOL" },
            "24210": { "city" : "ABINGDON", "state" : "VA", "county" : "WASHINGTON" },
            "24211": { "city" : "ABINGDON", "state" : "VA", "county" : "WASHINGTON" },
            "24212": { "city" : "ABINGDON", "state" : "VA", "county" : "WASHINGTON" },
            "24215": { "city" : "ANDOVER", "state" : "VA", "county" : "WISE" },"24216": { "city" : "APPALACHIA", "state" : "VA", "county" : "WISE" },
            "24217": { "city" : "BEE", "state" : "VA", "county" : "DICKENSON" },"24218": { "city" : "BEN HUR", "state" : "VA", "county" : "LEE" },
            "24219": { "city" : "BIG STONE GAP", "state" : "VA", "county" : "WISE" },
            "24220": { "city" : "BIRCHLEAF", "state" : "VA", "county" : "DICKENSON" },
            "24224": { "city" : "CASTLEWOOD", "state" : "VA", "county" : "RUSSELL" },
            "24225": { "city" : "CLEVELAND", "state" : "VA", "county" : "RUSSELL" },
            "24226": { "city" : "CLINCHCO", "state" : "VA", "county" : "DICKENSON" },
            "24228": { "city" : "CLINTWOOD", "state" : "VA", "county" : "DICKENSON" },
            "24230": { "city" : "COEBURN", "state" : "VA", "county" : "WISE" },"24236": { "city" : "DAMASCUS", "state" : "VA", "county" : "WASHINGTON" },
            "24237": { "city" : "DANTE", "state" : "VA", "county" : "RUSSELL" },"24239": { "city" : "DAVENPORT", "state" : "VA", "county" : "BUCHANAN" },
            "24243": { "city" : "DRYDEN", "state" : "VA", "county" : "LEE" },"24244": { "city" : "DUFFIELD", "state" : "VA", "county" : "SCOTT" },
            "24245": { "city" : "DUNGANNON", "state" : "VA", "county" : "SCOTT" },
            "24246": { "city" : "EAST STONE GAP", "state" : "VA", "county" : "WISE" },
            "24248": { "city" : "EWING", "state" : "VA", "county" : "LEE" },"24250": { "city" : "FORT BLACKMORE", "state" : "VA", "county" : "SCOTT" },
            "24251": { "city" : "GATE CITY", "state" : "VA", "county" : "SCOTT" },
            "24256": { "city" : "HAYSI", "state" : "VA", "county" : "DICKENSON" },
            "24258": { "city" : "HILTONS", "state" : "VA", "county" : "SCOTT" },"24260": { "city" : "HONAKER", "state" : "VA", "county" : "RUSSELL" },
            "24263": { "city" : "JONESVILLE", "state" : "VA", "county" : "LEE" },
            "24265": { "city" : "KEOKEE", "state" : "VA", "county" : "LEE" },"24266": { "city" : "LEBANON", "state" : "VA", "county" : "RUSSELL" },
            "24269": { "city" : "MC CLURE", "state" : "VA", "county" : "DICKENSON" },
            "24270": { "city" : "MENDOTA", "state" : "VA", "county" : "WASHINGTON" },
            "24271": { "city" : "NICKELSVILLE", "state" : "VA", "county" : "SCOTT" },
            "24272": { "city" : "NORA", "state" : "VA", "county" : "DICKENSON" },
            "24273": { "city" : "NORTON", "state" : "VA", "county" : "NORTON CITY" },
            "24277": { "city" : "PENNINGTON GAP", "state" : "VA", "county" : "LEE" },
            "24279": { "city" : "POUND", "state" : "VA", "county" : "WISE" },"24280": { "city" : "ROSEDALE", "state" : "VA", "county" : "RUSSELL" },
            "24281": { "city" : "ROSE HILL", "state" : "VA", "county" : "LEE" },"24282": { "city" : "SAINT CHARLES", "state" : "VA", "county" : "LEE" },
            "24283": { "city" : "SAINT PAUL", "state" : "VA", "county" : "WISE" },
            "24290": { "city" : "WEBER CITY", "state" : "VA", "county" : "SCOTT" },
            "24292": { "city" : "WHITETOP", "state" : "VA", "county" : "GRAYSON" },
            "24293": { "city" : "WISE", "state" : "VA", "county" : "WISE" },"24301": { "city" : "PULASKI", "state" : "VA", "county" : "PULASKI" },
            "24311": { "city" : "ATKINS", "state" : "VA", "county" : "SMYTH" },"24312": { "city" : "AUSTINVILLE", "state" : "VA", "county" : "WYTHE" },
            "24313": { "city" : "BARREN SPRINGS", "state" : "VA", "county" : "WYTHE" },
            "24314": { "city" : "BASTIAN", "state" : "VA", "county" : "BLAND" },"24315": { "city" : "BLAND", "state" : "VA", "county" : "BLAND" },
            "24316": { "city" : "BROADFORD", "state" : "VA", "county" : "TAZEWELL" },
            "24317": { "city" : "CANA", "state" : "VA", "county" : "CARROLL" },"24318": { "city" : "CERES", "state" : "VA", "county" : "BLAND" },
            "24319": { "city" : "CHILHOWIE", "state" : "VA", "county" : "SMYTH" },
            "24323": { "city" : "CROCKETT", "state" : "VA", "county" : "WYTHE" },
            "24324": { "city" : "DRAPER", "state" : "VA", "county" : "PULASKI" },
            "24325": { "city" : "DUGSPUR", "state" : "VA", "county" : "CARROLL" },
            "24326": { "city" : "ELK CREEK", "state" : "VA", "county" : "GRAYSON" },
            "24327": { "city" : "EMORY", "state" : "VA", "county" : "WASHINGTON" },
            "24328": { "city" : "FANCY GAP", "state" : "VA", "county" : "CARROLL" },
            "24330": { "city" : "FRIES", "state" : "VA", "county" : "GRAYSON" },"24333": { "city" : "GALAX", "state" : "VA", "county" : "GALAX CITY" },
            "24340": { "city" : "GLADE SPRING", "state" : "VA", "county" : "WASHINGTON" },
            "24343": { "city" : "HILLSVILLE", "state" : "VA", "county" : "CARROLL" },
            "24347": { "city" : "HIWASSEE", "state" : "VA", "county" : "PULASKI" },
            "24348": { "city" : "INDEPENDENCE", "state" : "VA", "county" : "GRAYSON" },
            "24350": { "city" : "IVANHOE", "state" : "VA", "county" : "WYTHE" },"24351": { "city" : "LAMBSBURG", "state" : "VA", "county" : "CARROLL" },
            "24352": { "city" : "LAUREL FORK", "state" : "VA", "county" : "CARROLL" },
            "24354": { "city" : "MARION", "state" : "VA", "county" : "SMYTH" },"24360": { "city" : "MAX MEADOWS", "state" : "VA", "county" : "WYTHE" },
            "24361": { "city" : "MEADOWVIEW", "state" : "VA", "county" : "WASHINGTON" },
            "24363": { "city" : "MOUTH OF WILSON", "state" : "VA", "county" : "GRAYSON" },
            "24366": { "city" : "ROCKY GAP", "state" : "VA", "county" : "BLAND" },
            "24368": { "city" : "RURAL RETREAT", "state" : "VA", "county" : "WYTHE" },
            "24370": { "city" : "SALTVILLE", "state" : "VA", "county" : "SMYTH" },
            "24374": { "city" : "SPEEDWELL", "state" : "VA", "county" : "WYTHE" },
            "24375": { "city" : "SUGAR GROVE", "state" : "VA", "county" : "SMYTH" },
            "24377": { "city" : "TANNERSVILLE", "state" : "VA", "county" : "TAZEWELL" },
            "24378": { "city" : "TROUTDALE", "state" : "VA", "county" : "GRAYSON" },
            "24380": { "city" : "WILLIS", "state" : "VA", "county" : "FLOYD" },"24381": { "city" : "WOODLAWN", "state" : "VA", "county" : "CARROLL" },
            "24382": { "city" : "WYTHEVILLE", "state" : "VA", "county" : "WYTHE" },
            "24401": { "city" : "STAUNTON", "state" : "VA", "county" : "STAUNTON CITY" },
            "24402": { "city" : "STAUNTON", "state" : "VA", "county" : "STAUNTON CITY" },
            "24411": { "city" : "AUGUSTA SPRINGS", "state" : "VA", "county" : "AUGUSTA" },
            "24413": { "city" : "BLUE GRASS", "state" : "VA", "county" : "HIGHLAND" },
            "24416": { "city" : "BUENA VISTA", "state" : "VA", "county" : "BUENA VISTA CITY" },
            "24421": { "city" : "CHURCHVILLE", "state" : "VA", "county" : "AUGUSTA" },
            "24422": { "city" : "CLIFTON FORGE", "state" : "VA", "county" : "ALLEGHANY" },
            "24426": { "city" : "COVINGTON", "state" : "VA", "county" : "COVINGTON CITY" },
            "24430": { "city" : "CRAIGSVILLE", "state" : "VA", "county" : "AUGUSTA" },
            "24431": { "city" : "CRIMORA", "state" : "VA", "county" : "AUGUSTA" },
            "24432": { "city" : "DEERFIELD", "state" : "VA", "county" : "AUGUSTA" },
            "24433": { "city" : "DOE HILL", "state" : "VA", "county" : "HIGHLAND" },
            "24435": { "city" : "FAIRFIELD", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24437": { "city" : "FORT DEFIANCE", "state" : "VA", "county" : "AUGUSTA" },
            "24439": { "city" : "GOSHEN", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24440": { "city" : "GREENVILLE", "state" : "VA", "county" : "AUGUSTA" },
            "24441": { "city" : "GROTTOES", "state" : "VA", "county" : "ROCKINGHAM" },
            "24442": { "city" : "HEAD WATERS", "state" : "VA", "county" : "HIGHLAND" },
            "24445": { "city" : "HOT SPRINGS", "state" : "VA", "county" : "BATH" },
            "24448": { "city" : "IRON GATE", "state" : "VA", "county" : "ALLEGHANY" },
            "24450": { "city" : "LEXINGTON", "state" : "VA", "county" : "LEXINGTON CITY" },
            "24457": { "city" : "LOW MOOR", "state" : "VA", "county" : "ALLEGHANY" },
            "24458": { "city" : "MC DOWELL", "state" : "VA", "county" : "HIGHLAND" },
            "24459": { "city" : "MIDDLEBROOK", "state" : "VA", "county" : "AUGUSTA" },
            "24460": { "city" : "MILLBORO", "state" : "VA", "county" : "BATH" },"24463": { "city" : "MINT SPRING", "state" : "VA", "county" : "AUGUSTA" },
            "24464": { "city" : "MONTEBELLO", "state" : "VA", "county" : "NELSON" },
            "24465": { "city" : "MONTEREY", "state" : "VA", "county" : "HIGHLAND" },
            "24467": { "city" : "MOUNT SIDNEY", "state" : "VA", "county" : "AUGUSTA" },
            "24468": { "city" : "MUSTOE", "state" : "VA", "county" : "HIGHLAND" },
            "24469": { "city" : "NEW HOPE", "state" : "VA", "county" : "AUGUSTA" },
            "24471": { "city" : "PORT REPUBLIC", "state" : "VA", "county" : "ROCKINGHAM" },
            "24472": { "city" : "RAPHINE", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24473": { "city" : "ROCKBRIDGE BATHS", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24474": { "city" : "SELMA", "state" : "VA", "county" : "ALLEGHANY" },
            "24476": { "city" : "STEELES TAVERN", "state" : "VA", "county" : "AUGUSTA" },
            "24477": { "city" : "STUARTS DRAFT", "state" : "VA", "county" : "AUGUSTA" },
            "24479": { "city" : "SWOOPE", "state" : "VA", "county" : "AUGUSTA" },
            "24482": { "city" : "VERONA", "state" : "VA", "county" : "AUGUSTA" },
            "24483": { "city" : "VESUVIUS", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24484": { "city" : "WARM SPRINGS", "state" : "VA", "county" : "BATH" },
            "24485": { "city" : "WEST AUGUSTA", "state" : "VA", "county" : "AUGUSTA" },
            "24486": { "city" : "WEYERS CAVE", "state" : "VA", "county" : "AUGUSTA" },
            "24487": { "city" : "WILLIAMSVILLE", "state" : "VA", "county" : "BATH" },
            "24501": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24502": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24503": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24504": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24505": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24506": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24514": { "city" : "LYNCHBURG", "state" : "VA", "county" : "LYNCHBURG CITY" },
            "24517": { "city" : "ALTAVISTA", "state" : "VA", "county" : "CAMPBELL" },
            "24520": { "city" : "ALTON", "state" : "VA", "county" : "HALIFAX" },"24521": { "city" : "AMHERST", "state" : "VA", "county" : "AMHERST" },
            "24522": { "city" : "APPOMATTOX", "state" : "VA", "county" : "APPOMATTOX" },
            "24523": { "city" : "BEDFORD", "state" : "VA", "county" : "BEDFORD" },
            "24526": { "city" : "BIG ISLAND", "state" : "VA", "county" : "BEDFORD" },
            "24527": { "city" : "BLAIRS", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24528": { "city" : "BROOKNEAL", "state" : "VA", "county" : "CAMPBELL" },
            "24529": { "city" : "BUFFALO JUNCTION", "state" : "VA", "county" : "MECKLENBURG" },
            "24530": { "city" : "CALLANDS", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24531": { "city" : "CHATHAM", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24533": { "city" : "CLIFFORD", "state" : "VA", "county" : "AMHERST" },
            "24534": { "city" : "CLOVER", "state" : "VA", "county" : "HALIFAX" },
            "24535": { "city" : "CLUSTER SPRINGS", "state" : "VA", "county" : "HALIFAX" },
            "24536": { "city" : "COLEMAN FALLS", "state" : "VA", "county" : "BEDFORD" },
            "24538": { "city" : "CONCORD", "state" : "VA", "county" : "CAMPBELL" },
            "24539": { "city" : "CRYSTAL HILL", "state" : "VA", "county" : "HALIFAX" },
            "24540": { "city" : "DANVILLE", "state" : "VA", "county" : "DANVILLE CITY" },
            "24541": { "city" : "DANVILLE", "state" : "VA", "county" : "DANVILLE CITY" },
            "24543": { "city" : "DANVILLE", "state" : "VA", "county" : "DANVILLE CITY" },
            "24549": { "city" : "DRY FORK", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24550": { "city" : "EVINGTON", "state" : "VA", "county" : "CAMPBELL" },
            "24551": { "city" : "FOREST", "state" : "VA", "county" : "BEDFORD" },
            "24553": { "city" : "GLADSTONE", "state" : "VA", "county" : "NELSON" },
            "24554": { "city" : "GLADYS", "state" : "VA", "county" : "CAMPBELL" },
            "24555": { "city" : "GLASGOW", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24556": { "city" : "GOODE", "state" : "VA", "county" : "BEDFORD" },"24557": { "city" : "GRETNA", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24558": { "city" : "HALIFAX", "state" : "VA", "county" : "HALIFAX" },
            "24562": { "city" : "HOWARDSVILLE", "state" : "VA", "county" : "BUCKINGHAM" },
            "24563": { "city" : "HURT", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24565": { "city" : "JAVA", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24566": { "city" : "KEELING", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24569": { "city" : "LONG ISLAND", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24570": { "city" : "LOWRY", "state" : "VA", "county" : "BEDFORD" },"24571": { "city" : "LYNCH STATION", "state" : "VA", "county" : "CAMPBELL" },
            "24572": { "city" : "MADISON HEIGHTS", "state" : "VA", "county" : "AMHERST" },
            "24574": { "city" : "MONROE", "state" : "VA", "county" : "AMHERST" },
            "24577": { "city" : "NATHALIE", "state" : "VA", "county" : "HALIFAX" },
            "24578": { "city" : "NATURAL BRIDGE", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24579": { "city" : "NATURAL BRIDGE STATION", "state" : "VA", "county" : "ROCKBRIDGE" },
            "24580": { "city" : "NELSON", "state" : "VA", "county" : "MECKLENBURG" },
            "24581": { "city" : "NORWOOD", "state" : "VA", "county" : "NELSON" },
            "24586": { "city" : "RINGGOLD", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24588": { "city" : "RUSTBURG", "state" : "VA", "county" : "CAMPBELL" },
            "24589": { "city" : "SCOTTSBURG", "state" : "VA", "county" : "HALIFAX" },
            "24590": { "city" : "SCOTTSVILLE", "state" : "VA", "county" : "ALBEMARLE" },
            "24592": { "city" : "SOUTH BOSTON", "state" : "VA", "county" : "HALIFAX" },
            "24593": { "city" : "SPOUT SPRING", "state" : "VA", "county" : "APPOMATTOX" },
            "24594": { "city" : "SUTHERLIN", "state" : "VA", "county" : "PITTSYLVANIA" },
            "24595": { "city" : "SWEET BRIAR", "state" : "VA", "county" : "AMHERST" },
            "24597": { "city" : "VERNON HILL", "state" : "VA", "county" : "HALIFAX" },
            "24598": { "city" : "VIRGILINA", "state" : "VA", "county" : "HALIFAX" },
            "24599": { "city" : "WINGINA", "state" : "VA", "county" : "BUCKINGHAM" },
            "24601": { "city" : "AMONATE", "state" : "VA", "county" : "TAZEWELL" },
            "24602": { "city" : "BANDY", "state" : "VA", "county" : "TAZEWELL" },
            "24603": { "city" : "BIG ROCK", "state" : "VA", "county" : "BUCHANAN" },
            "24604": { "city" : "BISHOP", "state" : "VA", "county" : "TAZEWELL" },
            "24605": { "city" : "BLUEFIELD", "state" : "VA", "county" : "TAZEWELL" },
            "24606": { "city" : "BOISSEVAIN", "state" : "VA", "county" : "TAZEWELL" },
            "24607": { "city" : "BREAKS", "state" : "VA", "county" : "DICKENSON" },
            "24608": { "city" : "BURKES GARDEN", "state" : "VA", "county" : "TAZEWELL" },
            "24609": { "city" : "CEDAR BLUFF", "state" : "VA", "county" : "TAZEWELL" },
            "24612": { "city" : "DORAN", "state" : "VA", "county" : "TAZEWELL" },
            "24613": { "city" : "FALLS MILLS", "state" : "VA", "county" : "TAZEWELL" },
            "24614": { "city" : "GRUNDY", "state" : "VA", "county" : "BUCHANAN" },
            "24620": { "city" : "HURLEY", "state" : "VA", "county" : "BUCHANAN" },
            "24622": { "city" : "JEWELL RIDGE", "state" : "VA", "county" : "TAZEWELL" },
            "24624": { "city" : "KEEN MOUNTAIN", "state" : "VA", "county" : "BUCHANAN" },
            "24627": { "city" : "MAVISDALE", "state" : "VA", "county" : "BUCHANAN" },
            "24628": { "city" : "MAXIE", "state" : "VA", "county" : "BUCHANAN" },
            "24630": { "city" : "NORTH TAZEWELL", "state" : "VA", "county" : "TAZEWELL" },
            "24631": { "city" : "OAKWOOD", "state" : "VA", "county" : "BUCHANAN" },
            "24634": { "city" : "PILGRIMS KNOB", "state" : "VA", "county" : "BUCHANAN" },
            "24635": { "city" : "POCAHONTAS", "state" : "VA", "county" : "TAZEWELL" },
            "24637": { "city" : "POUNDING MILL", "state" : "VA", "county" : "TAZEWELL" },
            "24639": { "city" : "RAVEN", "state" : "VA", "county" : "BUCHANAN" },
            "24640": { "city" : "RED ASH", "state" : "VA", "county" : "TAZEWELL" },
            "24641": { "city" : "RICHLANDS", "state" : "VA", "county" : "TAZEWELL" },
            "24646": { "city" : "ROWE", "state" : "VA", "county" : "BUCHANAN" },"24647": { "city" : "SHORTT GAP", "state" : "VA", "county" : "BUCHANAN" },
            "24649": { "city" : "SWORDS CREEK", "state" : "VA", "county" : "RUSSELL" },
            "24651": { "city" : "TAZEWELL", "state" : "VA", "county" : "TAZEWELL" },
            "24656": { "city" : "VANSANT", "state" : "VA", "county" : "BUCHANAN" },
            "24657": { "city" : "WHITEWOOD", "state" : "VA", "county" : "BUCHANAN" },
            "24658": { "city" : "WOLFORD", "state" : "VA", "county" : "BUCHANAN" },
            "24701": { "city" : "BLUEFIELD", "state" : "WV", "county" : "MERCER" },
            "24712": { "city" : "ATHENS", "state" : "WV", "county" : "MERCER" },"24714": { "city" : "BEESON", "state" : "WV", "county" : "MERCER" },
            "24715": { "city" : "BRAMWELL", "state" : "WV", "county" : "MERCER" },
            "24716": { "city" : "BUD", "state" : "WV", "county" : "WYOMING" },"24724": { "city" : "FREEMAN", "state" : "WV", "county" : "MERCER" },
            "24726": { "city" : "HERNDON", "state" : "WV", "county" : "WYOMING" },
            "24729": { "city" : "HIAWATHA", "state" : "WV", "county" : "MERCER" },
            "24731": { "city" : "KEGLEY", "state" : "WV", "county" : "MERCER" },"24732": { "city" : "KELLYSVILLE", "state" : "WV", "county" : "MERCER" },
            "24733": { "city" : "LASHMEET", "state" : "WV", "county" : "MERCER" },
            "24736": { "city" : "MATOAKA", "state" : "WV", "county" : "MERCER" },
            "24737": { "city" : "MONTCALM", "state" : "WV", "county" : "MERCER" },
            "24739": { "city" : "OAKVALE", "state" : "WV", "county" : "MERCER" },
            "24740": { "city" : "PRINCETON", "state" : "WV", "county" : "MERCER" },
            "24747": { "city" : "ROCK", "state" : "WV", "county" : "MERCER" },"24751": { "city" : "WOLFE", "state" : "WV", "county" : "MERCER" },
            "24801": { "city" : "WELCH", "state" : "WV", "county" : "MCDOWELL" },
            "24808": { "city" : "ANAWALT", "state" : "WV", "county" : "MCDOWELL" },
            "24811": { "city" : "AVONDALE", "state" : "WV", "county" : "MCDOWELL" },
            "24815": { "city" : "BERWIND", "state" : "WV", "county" : "MCDOWELL" },
            "24817": { "city" : "BRADSHAW", "state" : "WV", "county" : "MCDOWELL" },
            "24818": { "city" : "BRENTON", "state" : "WV", "county" : "WYOMING" },
            "24822": { "city" : "CLEAR FORK", "state" : "WV", "county" : "WYOMING" },
            "24823": { "city" : "COAL MOUNTAIN", "state" : "WV", "county" : "WYOMING" },
            "24826": { "city" : "CUCUMBER", "state" : "WV", "county" : "MCDOWELL" },
            "24827": { "city" : "CYCLONE", "state" : "WV", "county" : "WYOMING" },
            "24828": { "city" : "DAVY", "state" : "WV", "county" : "MCDOWELL" },"24829": { "city" : "ECKMAN", "state" : "WV", "county" : "MCDOWELL" },
            "24830": { "city" : "ELBERT", "state" : "WV", "county" : "MCDOWELL" },
            "24831": { "city" : "ELKHORN", "state" : "WV", "county" : "MCDOWELL" },
            "24836": { "city" : "GARY", "state" : "WV", "county" : "MCDOWELL" },"24839": { "city" : "HANOVER", "state" : "WV", "county" : "WYOMING" },
            "24844": { "city" : "IAEGER", "state" : "WV", "county" : "MCDOWELL" },
            "24845": { "city" : "IKES FORK", "state" : "WV", "county" : "WYOMING" },
            "24847": { "city" : "ITMANN", "state" : "WV", "county" : "WYOMING" },
            "24849": { "city" : "JESSE", "state" : "WV", "county" : "WYOMING" },"24850": { "city" : "JOLO", "state" : "WV", "county" : "MCDOWELL" },
            "24851": { "city" : "JUSTICE", "state" : "WV", "county" : "MINGO" },"24853": { "city" : "KIMBALL", "state" : "WV", "county" : "MCDOWELL" },
            "24854": { "city" : "KOPPERSTON", "state" : "WV", "county" : "WYOMING" },
            "24857": { "city" : "LYNCO", "state" : "WV", "county" : "WYOMING" },"24859": { "city" : "MARIANNA", "state" : "WV", "county" : "WYOMING" },
            "24860": { "city" : "MATHENY", "state" : "WV", "county" : "WYOMING" },
            "24861": { "city" : "MAYBEURY", "state" : "WV", "county" : "MCDOWELL" },
            "24862": { "city" : "MOHAWK", "state" : "WV", "county" : "MCDOWELL" },
            "24866": { "city" : "NEWHALL", "state" : "WV", "county" : "MCDOWELL" },
            "24867": { "city" : "NEW RICHMOND", "state" : "WV", "county" : "WYOMING" },
            "24868": { "city" : "NORTHFORK", "state" : "WV", "county" : "MCDOWELL" },
            "24870": { "city" : "OCEANA", "state" : "WV", "county" : "WYOMING" },
            "24871": { "city" : "PAGETON", "state" : "WV", "county" : "MCDOWELL" },
            "24872": { "city" : "PANTHER", "state" : "WV", "county" : "MCDOWELL" },
            "24873": { "city" : "PAYNESVILLE", "state" : "WV", "county" : "MCDOWELL" },
            "24874": { "city" : "PINEVILLE", "state" : "WV", "county" : "WYOMING" },
            "24878": { "city" : "PREMIER", "state" : "WV", "county" : "MCDOWELL" },
            "24879": { "city" : "RAYSAL", "state" : "WV", "county" : "MCDOWELL" },
            "24880": { "city" : "ROCK VIEW", "state" : "WV", "county" : "WYOMING" },
            "24881": { "city" : "RODERFIELD", "state" : "WV", "county" : "MCDOWELL" },
            "24882": { "city" : "SIMON", "state" : "WV", "county" : "WYOMING" },"24884": { "city" : "SQUIRE", "state" : "WV", "county" : "MCDOWELL" },
            "24888": { "city" : "THORPE", "state" : "WV", "county" : "MCDOWELL" },
            "24892": { "city" : "WAR", "state" : "WV", "county" : "MCDOWELL" },"24894": { "city" : "WARRIORMINE", "state" : "WV", "county" : "MCDOWELL" },
            "24895": { "city" : "WILCOE", "state" : "WV", "county" : "MCDOWELL" },
            "24901": { "city" : "LEWISBURG", "state" : "WV", "county" : "GREENBRIER" },
            "24902": { "city" : "FAIRLEA", "state" : "WV", "county" : "GREENBRIER" },
            "24910": { "city" : "ALDERSON", "state" : "WV", "county" : "MONROE" },
            "24915": { "city" : "ARBOVALE", "state" : "WV", "county" : "POCAHONTAS" },
            "24916": { "city" : "ASBURY", "state" : "WV", "county" : "GREENBRIER" },
            "24918": { "city" : "BALLARD", "state" : "WV", "county" : "MONROE" },
            "24920": { "city" : "BARTOW", "state" : "WV", "county" : "POCAHONTAS" },
            "24924": { "city" : "BUCKEYE", "state" : "WV", "county" : "POCAHONTAS" },
            "24925": { "city" : "CALDWELL", "state" : "WV", "county" : "GREENBRIER" },
            "24927": { "city" : "CASS", "state" : "WV", "county" : "POCAHONTAS" },
            "24931": { "city" : "CRAWLEY", "state" : "WV", "county" : "GREENBRIER" },
            "24934": { "city" : "DUNMORE", "state" : "WV", "county" : "POCAHONTAS" },
            "24935": { "city" : "FOREST HILL", "state" : "WV", "county" : "SUMMERS" },
            "24938": { "city" : "FRANKFORD", "state" : "WV", "county" : "GREENBRIER" },
            "24941": { "city" : "GAP MILLS", "state" : "WV", "county" : "MONROE" },
            "24944": { "city" : "GREEN BANK", "state" : "WV", "county" : "POCAHONTAS" },
            "24945": { "city" : "GREENVILLE", "state" : "WV", "county" : "MONROE" },
            "24946": { "city" : "HILLSBORO", "state" : "WV", "county" : "POCAHONTAS" },
            "24951": { "city" : "LINDSIDE", "state" : "WV", "county" : "MONROE" },
            "24954": { "city" : "MARLINTON", "state" : "WV", "county" : "POCAHONTAS" },
            "24957": { "city" : "MAXWELTON", "state" : "WV", "county" : "GREENBRIER" },
            "24962": { "city" : "PENCE SPRINGS", "state" : "WV", "county" : "SUMMERS" },
            "24963": { "city" : "PETERSTOWN", "state" : "WV", "county" : "MONROE" },
            "24966": { "city" : "RENICK", "state" : "WV", "county" : "GREENBRIER" },
            "24970": { "city" : "RONCEVERTE", "state" : "WV", "county" : "GREENBRIER" },
            "24974": { "city" : "SECONDCREEK", "state" : "WV", "county" : "MONROE" },
            "24976": { "city" : "SINKS GROVE", "state" : "WV", "county" : "MONROE" },
            "24977": { "city" : "SMOOT", "state" : "WV", "county" : "GREENBRIER" },
            "24981": { "city" : "TALCOTT", "state" : "WV", "county" : "SUMMERS" },
            "24983": { "city" : "UNION", "state" : "WV", "county" : "MONROE" },"24986": { "city" : "WHITE SULPHUR SPRINGS", "state" : "WV", "county" : "GREENBRIER" },
            "24991": { "city" : "WILLIAMSBURG", "state" : "WV", "county" : "GREENBRIER" },
            "24993": { "city" : "WOLFCREEK", "state" : "WV", "county" : "MONROE" },
            "25002": { "city" : "ALLOY", "state" : "WV", "county" : "FAYETTE" },"25003": { "city" : "ALUM CREEK", "state" : "WV", "county" : "KANAWHA" },
            "25005": { "city" : "AMMA", "state" : "WV", "county" : "ROANE" },"25009": { "city" : "ASHFORD", "state" : "WV", "county" : "BOONE" },
            "25011": { "city" : "BANCROFT", "state" : "WV", "county" : "PUTNAM" },
            "25015": { "city" : "BELLE", "state" : "WV", "county" : "KANAWHA" },"25019": { "city" : "BICKMORE", "state" : "WV", "county" : "CLAY" },
            "25021": { "city" : "BIM", "state" : "WV", "county" : "BOONE" },"25024": { "city" : "BLOOMINGROSE", "state" : "WV", "county" : "BOONE" },
            "25026": { "city" : "BLUE CREEK", "state" : "WV", "county" : "KANAWHA" },
            "25030": { "city" : "BOMONT", "state" : "WV", "county" : "CLAY" },"25031": { "city" : "BOOMER", "state" : "WV", "county" : "FAYETTE" },
            "25033": { "city" : "BUFFALO", "state" : "WV", "county" : "PUTNAM" },
            "25035": { "city" : "CABIN CREEK", "state" : "WV", "county" : "KANAWHA" },
            "25036": { "city" : "CANNELTON", "state" : "WV", "county" : "FAYETTE" },
            "25039": { "city" : "CEDAR GROVE", "state" : "WV", "county" : "KANAWHA" },
            "25040": { "city" : "CHARLTON HEIGHTS", "state" : "WV", "county" : "FAYETTE" },
            "25043": { "city" : "CLAY", "state" : "WV", "county" : "CLAY" },"25044": { "city" : "CLEAR CREEK", "state" : "WV", "county" : "RALEIGH" },
            "25045": { "city" : "CLENDENIN", "state" : "WV", "county" : "KANAWHA" },
            "25047": { "city" : "CLOTHIER", "state" : "WV", "county" : "LOGAN" },
            "25048": { "city" : "COLCORD", "state" : "WV", "county" : "RALEIGH" },
            "25049": { "city" : "COMFORT", "state" : "WV", "county" : "BOONE" },"25051": { "city" : "COSTA", "state" : "WV", "county" : "BOONE" },
            "25053": { "city" : "DANVILLE", "state" : "WV", "county" : "BOONE" },
            "25054": { "city" : "DAWES", "state" : "WV", "county" : "KANAWHA" },"25059": { "city" : "DIXIE", "state" : "WV", "county" : "NICHOLAS" },
            "25062": { "city" : "DRY CREEK", "state" : "WV", "county" : "RALEIGH" },
            "25063": { "city" : "DUCK", "state" : "WV", "county" : "CLAY" },"25064": { "city" : "DUNBAR", "state" : "WV", "county" : "KANAWHA" },
            "25067": { "city" : "EAST BANK", "state" : "WV", "county" : "KANAWHA" },
            "25070": { "city" : "ELEANOR", "state" : "WV", "county" : "PUTNAM" },
            "25071": { "city" : "ELKVIEW", "state" : "WV", "county" : "KANAWHA" },
            "25075": { "city" : "ESKDALE", "state" : "WV", "county" : "KANAWHA" },
            "25076": { "city" : "ETHEL", "state" : "WV", "county" : "LOGAN" },"25079": { "city" : "FALLING ROCK", "state" : "WV", "county" : "KANAWHA" },
            "25081": { "city" : "FOSTER", "state" : "WV", "county" : "BOONE" },"25082": { "city" : "FRAZIERS BOTTOM", "state" : "WV", "county" : "PUTNAM" },
            "25083": { "city" : "GALLAGHER", "state" : "WV", "county" : "KANAWHA" },
            "25085": { "city" : "GAULEY BRIDGE", "state" : "WV", "county" : "FAYETTE" },
            "25086": { "city" : "GLASGOW", "state" : "WV", "county" : "KANAWHA" },
            "25088": { "city" : "GLEN", "state" : "WV", "county" : "CLAY" },"25090": { "city" : "GLEN FERRIS", "state" : "WV", "county" : "FAYETTE" },
            "25102": { "city" : "HANDLEY", "state" : "WV", "county" : "KANAWHA" },
            "25103": { "city" : "HANSFORD", "state" : "WV", "county" : "KANAWHA" },
            "25106": { "city" : "HENDERSON", "state" : "WV", "county" : "MASON" },
            "25107": { "city" : "HERNSHAW", "state" : "WV", "county" : "KANAWHA" },
            "25108": { "city" : "HEWETT", "state" : "WV", "county" : "BOONE" },"25109": { "city" : "HOMETOWN", "state" : "WV", "county" : "PUTNAM" },
            "25110": { "city" : "HUGHESTON", "state" : "WV", "county" : "KANAWHA" },
            "25111": { "city" : "INDORE", "state" : "WV", "county" : "CLAY" },"25112": { "city" : "INSTITUTE", "state" : "WV", "county" : "KANAWHA" },
            "25113": { "city" : "IVYDALE", "state" : "WV", "county" : "CLAY" },"25114": { "city" : "JEFFREY", "state" : "WV", "county" : "BOONE" },
            "25115": { "city" : "KANAWHA FALLS", "state" : "WV", "county" : "FAYETTE" },
            "25118": { "city" : "KIMBERLY", "state" : "WV", "county" : "FAYETTE" },
            "25119": { "city" : "KINCAID", "state" : "WV", "county" : "FAYETTE" },
            "25121": { "city" : "LAKE", "state" : "WV", "county" : "LOGAN" },"25123": { "city" : "LEON", "state" : "WV", "county" : "MASON" },
            "25124": { "city" : "LIBERTY", "state" : "WV", "county" : "PUTNAM" },
            "25125": { "city" : "LIZEMORES", "state" : "WV", "county" : "CLAY" },
            "25126": { "city" : "LONDON", "state" : "WV", "county" : "KANAWHA" },
            "25130": { "city" : "MADISON", "state" : "WV", "county" : "BOONE" },"25132": { "city" : "MAMMOTH", "state" : "WV", "county" : "KANAWHA" },
            "25133": { "city" : "MAYSEL", "state" : "WV", "county" : "CLAY" },"25134": { "city" : "MIAMI", "state" : "WV", "county" : "KANAWHA" },
            "25136": { "city" : "MONTGOMERY", "state" : "WV", "county" : "FAYETTE" },
            "25139": { "city" : "MOUNT CARBON", "state" : "WV", "county" : "FAYETTE" },
            "25140": { "city" : "NAOMA", "state" : "WV", "county" : "RALEIGH" },"25141": { "city" : "NEBO", "state" : "WV", "county" : "CLAY" },
            "25142": { "city" : "NELLIS", "state" : "WV", "county" : "BOONE" },"25143": { "city" : "NITRO", "state" : "WV", "county" : "KANAWHA" },
            "25148": { "city" : "ORGAS", "state" : "WV", "county" : "BOONE" },"25152": { "city" : "PAGE", "state" : "WV", "county" : "FAYETTE" },
            "25154": { "city" : "PEYTONA", "state" : "WV", "county" : "BOONE" },"25156": { "city" : "PINCH", "state" : "WV", "county" : "KANAWHA" },
            "25159": { "city" : "POCA", "state" : "WV", "county" : "PUTNAM" },"25160": { "city" : "POND GAP", "state" : "WV", "county" : "KANAWHA" },
            "25161": { "city" : "POWELLTON", "state" : "WV", "county" : "FAYETTE" },
            "25162": { "city" : "PRATT", "state" : "WV", "county" : "KANAWHA" },"25164": { "city" : "PROCIOUS", "state" : "WV", "county" : "CLAY" },
            "25165": { "city" : "RACINE", "state" : "WV", "county" : "BOONE" },"25168": { "city" : "RED HOUSE", "state" : "WV", "county" : "PUTNAM" },
            "25169": { "city" : "RIDGEVIEW", "state" : "WV", "county" : "BOONE" },
            "25173": { "city" : "ROBSON", "state" : "WV", "county" : "FAYETTE" },
            "25174": { "city" : "ROCK CREEK", "state" : "WV", "county" : "RALEIGH" },
            "25177": { "city" : "SAINT ALBANS", "state" : "WV", "county" : "KANAWHA" },
            "25180": { "city" : "SAXON", "state" : "WV", "county" : "BOONE" },"25181": { "city" : "SETH", "state" : "WV", "county" : "BOONE" },
            "25183": { "city" : "SHARPLES", "state" : "WV", "county" : "LOGAN" },
            "25185": { "city" : "MOUNT OLIVE", "state" : "WV", "county" : "FAYETTE" },
            "25186": { "city" : "SMITHERS", "state" : "WV", "county" : "FAYETTE" },
            "25187": { "city" : "SOUTHSIDE", "state" : "WV", "county" : "MASON" },
            "25193": { "city" : "SYLVESTER", "state" : "WV", "county" : "BOONE" },
            "25201": { "city" : "TAD", "state" : "WV", "county" : "KANAWHA" },"25202": { "city" : "TORNADO", "state" : "WV", "county" : "KANAWHA" },
            "25203": { "city" : "TURTLE CREEK", "state" : "WV", "county" : "BOONE" },
            "25205": { "city" : "UNEEDA", "state" : "WV", "county" : "BOONE" },"25206": { "city" : "VAN", "state" : "WV", "county" : "BOONE" },
            "25208": { "city" : "WHARTON", "state" : "WV", "county" : "BOONE" },"25209": { "city" : "WHITESVILLE", "state" : "WV", "county" : "BOONE" },
            "25213": { "city" : "WINFIELD", "state" : "WV", "county" : "PUTNAM" },
            "25214": { "city" : "WINIFREDE", "state" : "WV", "county" : "KANAWHA" },
            "25234": { "city" : "ARNOLDSBURG", "state" : "WV", "county" : "CALHOUN" },
            "25235": { "city" : "CHLOE", "state" : "WV", "county" : "CALHOUN" },"25239": { "city" : "COTTAGEVILLE", "state" : "WV", "county" : "JACKSON" },
            "25241": { "city" : "EVANS", "state" : "WV", "county" : "JACKSON" },"25243": { "city" : "GANDEEVILLE", "state" : "WV", "county" : "ROANE" },
            "25244": { "city" : "GAY", "state" : "WV", "county" : "JACKSON" },"25245": { "city" : "GIVEN", "state" : "WV", "county" : "JACKSON" },
            "25247": { "city" : "HARTFORD", "state" : "WV", "county" : "MASON" },
            "25248": { "city" : "KENNA", "state" : "WV", "county" : "JACKSON" },"25251": { "city" : "LEFT HAND", "state" : "WV", "county" : "ROANE" },
            "25252": { "city" : "LE ROY", "state" : "WV", "county" : "JACKSON" },
            "25253": { "city" : "LETART", "state" : "WV", "county" : "MASON" },"25259": { "city" : "LOONEYVILLE", "state" : "WV", "county" : "ROANE" },
            "25260": { "city" : "MASON", "state" : "WV", "county" : "MASON" },"25261": { "city" : "MILLSTONE", "state" : "WV", "county" : "CALHOUN" },
            "25262": { "city" : "MILLWOOD", "state" : "WV", "county" : "JACKSON" },
            "25264": { "city" : "MOUNT ALTO", "state" : "WV", "county" : "MASON" },
            "25265": { "city" : "NEW HAVEN", "state" : "WV", "county" : "MASON" },
            "25266": { "city" : "NEWTON", "state" : "WV", "county" : "ROANE" },"25267": { "city" : "NORMANTOWN", "state" : "WV", "county" : "GILMER" },
            "25268": { "city" : "ORMA", "state" : "WV", "county" : "CALHOUN" },"25270": { "city" : "REEDY", "state" : "WV", "county" : "ROANE" },
            "25271": { "city" : "RIPLEY", "state" : "WV", "county" : "JACKSON" },
            "25275": { "city" : "SANDYVILLE", "state" : "WV", "county" : "JACKSON" },
            "25276": { "city" : "SPENCER", "state" : "WV", "county" : "ROANE" },"25285": { "city" : "WALLBACK", "state" : "WV", "county" : "CLAY" },
            "25286": { "city" : "WALTON", "state" : "WV", "county" : "ROANE" },"25287": { "city" : "WEST COLUMBIA", "state" : "WV", "county" : "MASON" },
            "25301": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25302": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25303": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25304": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25305": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25306": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25309": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25311": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25312": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25313": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25314": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25315": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25317": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25320": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25321": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25322": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25323": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25324": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25325": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25326": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25327": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25328": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25329": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25330": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25331": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25332": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25333": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25334": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25336": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25338": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25339": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25350": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25356": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25357": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25358": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25360": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25361": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25362": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25364": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25365": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25375": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25387": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25389": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25396": { "city" : "CHARLESTON", "state" : "WV", "county" : "KANAWHA" },
            "25401": { "city" : "MARTINSBURG", "state" : "WV", "county" : "BERKELEY" },
            "25402": { "city" : "MARTINSBURG", "state" : "WV", "county" : "BERKELEY" },
            "25403": { "city" : "MARTINSBURG", "state" : "WV", "county" : "BERKELEY" },
            "25404": { "city" : "MARTINSBURG", "state" : "WV", "county" : "BERKELEY" },
            "25405": { "city" : "MARTINSBURG", "state" : "WV", "county" : "BERKELEY" },
            "25411": { "city" : "BERKELEY SPRINGS", "state" : "WV", "county" : "MORGAN" },
            "25413": { "city" : "BUNKER HILL", "state" : "WV", "county" : "BERKELEY" },
            "25414": { "city" : "CHARLES TOWN", "state" : "WV", "county" : "JEFFERSON" },
            "25419": { "city" : "FALLING WATERS", "state" : "WV", "county" : "BERKELEY" },
            "25420": { "city" : "GERRARDSTOWN", "state" : "WV", "county" : "BERKELEY" },
            "25421": { "city" : "GLENGARY", "state" : "WV", "county" : "BERKELEY" },
            "25422": { "city" : "GREAT CACAPON", "state" : "WV", "county" : "MORGAN" },
            "25423": { "city" : "HALLTOWN", "state" : "WV", "county" : "JEFFERSON" },
            "25425": { "city" : "HARPERS FERRY", "state" : "WV", "county" : "JEFFERSON" },
            "25427": { "city" : "HEDGESVILLE", "state" : "WV", "county" : "BERKELEY" },
            "25428": { "city" : "INWOOD", "state" : "WV", "county" : "BERKELEY" },
            "25430": { "city" : "KEARNEYSVILLE", "state" : "WV", "county" : "JEFFERSON" },
            "25431": { "city" : "LEVELS", "state" : "WV", "county" : "HAMPSHIRE" },
            "25432": { "city" : "MILLVILLE", "state" : "WV", "county" : "JEFFERSON" },
            "25434": { "city" : "PAW PAW", "state" : "WV", "county" : "MORGAN" },
            "25438": { "city" : "RANSON", "state" : "WV", "county" : "JEFFERSON" },
            "25440": { "city" : "RIDGEWAY", "state" : "WV", "county" : "BERKELEY" },
            "25441": { "city" : "RIPPON", "state" : "WV", "county" : "JEFFERSON" },
            "25442": { "city" : "SHENANDOAH JUNCTION", "state" : "WV", "county" : "JEFFERSON" },
            "25443": { "city" : "SHEPHERDSTOWN", "state" : "WV", "county" : "JEFFERSON" },
            "25444": { "city" : "SLANESVILLE", "state" : "WV", "county" : "HAMPSHIRE" },
            "25446": { "city" : "SUMMIT POINT", "state" : "WV", "county" : "JEFFERSON" },
            "25501": { "city" : "ALKOL", "state" : "WV", "county" : "LINCOLN" },"25502": { "city" : "APPLE GROVE", "state" : "WV", "county" : "MASON" },
            "25503": { "city" : "ASHTON", "state" : "WV", "county" : "MASON" },"25504": { "city" : "BARBOURSVILLE", "state" : "WV", "county" : "CABELL" },
            "25506": { "city" : "BRANCHLAND", "state" : "WV", "county" : "LINCOLN" },
            "25507": { "city" : "CEREDO", "state" : "WV", "county" : "WAYNE" },"25508": { "city" : "CHAPMANVILLE", "state" : "WV", "county" : "LOGAN" },
            "25510": { "city" : "CULLODEN", "state" : "WV", "county" : "CABELL" },
            "25511": { "city" : "DUNLOW", "state" : "WV", "county" : "WAYNE" },"25512": { "city" : "EAST LYNN", "state" : "WV", "county" : "WAYNE" },
            "25514": { "city" : "FORT GAY", "state" : "WV", "county" : "WAYNE" },
            "25515": { "city" : "GALLIPOLIS FERRY", "state" : "WV", "county" : "MASON" },
            "25517": { "city" : "GENOA", "state" : "WV", "county" : "WAYNE" },"25520": { "city" : "GLENWOOD", "state" : "WV", "county" : "MASON" },
            "25521": { "city" : "GRIFFITHSVILLE", "state" : "WV", "county" : "LINCOLN" },
            "25523": { "city" : "HAMLIN", "state" : "WV", "county" : "LINCOLN" },
            "25524": { "city" : "HARTS", "state" : "WV", "county" : "LINCOLN" },"25526": { "city" : "HURRICANE", "state" : "WV", "county" : "PUTNAM" },
            "25529": { "city" : "JULIAN", "state" : "WV", "county" : "BOONE" },"25530": { "city" : "KENOVA", "state" : "WV", "county" : "WAYNE" },
            "25534": { "city" : "KIAHSVILLE", "state" : "WV", "county" : "WAYNE" },
            "25535": { "city" : "LAVALETTE", "state" : "WV", "county" : "WAYNE" },
            "25537": { "city" : "LESAGE", "state" : "WV", "county" : "CABELL" },"25540": { "city" : "MIDKIFF", "state" : "WV", "county" : "LINCOLN" },
            "25541": { "city" : "MILTON", "state" : "WV", "county" : "CABELL" },"25545": { "city" : "ONA", "state" : "WV", "county" : "CABELL" },
            "25547": { "city" : "PECKS MILL", "state" : "WV", "county" : "LOGAN" },
            "25550": { "city" : "POINT PLEASANT", "state" : "WV", "county" : "MASON" },
            "25555": { "city" : "PRICHARD", "state" : "WV", "county" : "WAYNE" },
            "25557": { "city" : "RANGER", "state" : "WV", "county" : "LINCOLN" },
            "25559": { "city" : "SALT ROCK", "state" : "WV", "county" : "CABELL" },
            "25560": { "city" : "SCOTT DEPOT", "state" : "WV", "county" : "PUTNAM" },
            "25562": { "city" : "SHOALS", "state" : "WV", "county" : "WAYNE" },"25564": { "city" : "SOD", "state" : "WV", "county" : "LINCOLN" },
            "25565": { "city" : "SPURLOCKVILLE", "state" : "WV", "county" : "LINCOLN" },
            "25567": { "city" : "SUMERCO", "state" : "WV", "county" : "LINCOLN" },
            "25569": { "city" : "TEAYS", "state" : "WV", "county" : "PUTNAM" },"25570": { "city" : "WAYNE", "state" : "WV", "county" : "WAYNE" },
            "25571": { "city" : "WEST HAMLIN", "state" : "WV", "county" : "LINCOLN" },
            "25573": { "city" : "YAWKEY", "state" : "WV", "county" : "LINCOLN" },
            "25601": { "city" : "LOGAN", "state" : "WV", "county" : "LOGAN" },"25606": { "city" : "ACCOVILLE", "state" : "WV", "county" : "LOGAN" },
            "25607": { "city" : "AMHERSTDALE", "state" : "WV", "county" : "LOGAN" },
            "25608": { "city" : "BAISDEN", "state" : "WV", "county" : "MINGO" },"25611": { "city" : "BRUNO", "state" : "WV", "county" : "LOGAN" },
            "25612": { "city" : "CHAUNCEY", "state" : "WV", "county" : "LOGAN" },
            "25614": { "city" : "CORA", "state" : "WV", "county" : "LOGAN" },"25617": { "city" : "DAVIN", "state" : "WV", "county" : "LOGAN" },
            "25621": { "city" : "GILBERT", "state" : "WV", "county" : "MINGO" },"25625": { "city" : "HOLDEN", "state" : "WV", "county" : "LOGAN" },
            "25628": { "city" : "KISTLER", "state" : "WV", "county" : "LOGAN" },"25630": { "city" : "LORADO", "state" : "WV", "county" : "LOGAN" },
            "25632": { "city" : "LYBURN", "state" : "WV", "county" : "LOGAN" },"25634": { "city" : "MALLORY", "state" : "WV", "county" : "LOGAN" },
            "25635": { "city" : "MAN", "state" : "WV", "county" : "LOGAN" },"25637": { "city" : "MOUNT GAY", "state" : "WV", "county" : "LOGAN" },
            "25638": { "city" : "OMAR", "state" : "WV", "county" : "LOGAN" },"25639": { "city" : "PEACH CREEK", "state" : "WV", "county" : "LOGAN" },
            "25646": { "city" : "STOLLINGS", "state" : "WV", "county" : "LOGAN" },
            "25647": { "city" : "SWITZER", "state" : "WV", "county" : "LOGAN" },"25649": { "city" : "VERDUNVILLE", "state" : "WV", "county" : "LOGAN" },
            "25650": { "city" : "VERNER", "state" : "WV", "county" : "MINGO" },"25651": { "city" : "WHARNCLIFFE", "state" : "WV", "county" : "MINGO" },
            "25652": { "city" : "WHITMAN", "state" : "WV", "county" : "LOGAN" },"25653": { "city" : "WILKINSON", "state" : "WV", "county" : "LOGAN" },
            "25654": { "city" : "YOLYN", "state" : "WV", "county" : "LOGAN" },"25661": { "city" : "WILLIAMSON", "state" : "WV", "county" : "MINGO" },
            "25666": { "city" : "BREEDEN", "state" : "WV", "county" : "MINGO" },"25667": { "city" : "CHATTAROY", "state" : "WV", "county" : "MINGO" },
            "25669": { "city" : "CRUM", "state" : "WV", "county" : "WAYNE" },"25670": { "city" : "DELBARTON", "state" : "WV", "county" : "MINGO" },
            "25671": { "city" : "DINGESS", "state" : "WV", "county" : "MINGO" },"25672": { "city" : "EDGARTON", "state" : "WV", "county" : "MINGO" },
            "25674": { "city" : "KERMIT", "state" : "WV", "county" : "MINGO" },"25676": { "city" : "LENORE", "state" : "WV", "county" : "MINGO" },
            "25678": { "city" : "MATEWAN", "state" : "WV", "county" : "MINGO" },"25685": { "city" : "NAUGATUCK", "state" : "WV", "county" : "MINGO" },
            "25686": { "city" : "NEWTOWN", "state" : "WV", "county" : "MINGO" },"25688": { "city" : "NORTH MATEWAN", "state" : "WV", "county" : "MINGO" },
            "25690": { "city" : "RAGLAND", "state" : "WV", "county" : "MINGO" },"25691": { "city" : "RAWL", "state" : "WV", "county" : "MINGO" },
            "25692": { "city" : "RED JACKET", "state" : "WV", "county" : "MINGO" },
            "25696": { "city" : "VARNEY", "state" : "WV", "county" : "MINGO" },"25701": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25702": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25703": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25704": { "city" : "HUNTINGTON", "state" : "WV", "county" : "WAYNE" },
            "25705": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25706": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25707": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25708": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25709": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25710": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25713": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25714": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25715": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25716": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25717": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25718": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25719": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25721": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25722": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25723": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25724": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25725": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25726": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25727": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25728": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25729": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25755": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25770": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25771": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25773": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25774": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25776": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25778": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25779": { "city" : "HUNTINGTON", "state" : "WV", "county" : "CABELL" },
            "25801": { "city" : "BECKLEY", "state" : "WV", "county" : "RALEIGH" },
            "25802": { "city" : "BECKLEY", "state" : "WV", "county" : "RALEIGH" },
            "25810": { "city" : "ALLEN JUNCTION", "state" : "WV", "county" : "WYOMING" },
            "25812": { "city" : "ANSTED", "state" : "WV", "county" : "FAYETTE" },
            "25813": { "city" : "BEAVER", "state" : "WV", "county" : "RALEIGH" },
            "25817": { "city" : "BOLT", "state" : "WV", "county" : "RALEIGH" },"25818": { "city" : "BRADLEY", "state" : "WV", "county" : "RALEIGH" },
            "25820": { "city" : "CAMP CREEK", "state" : "WV", "county" : "MERCER" },
            "25823": { "city" : "COAL CITY", "state" : "WV", "county" : "RALEIGH" },
            "25825": { "city" : "COOL RIDGE", "state" : "WV", "county" : "RALEIGH" },
            "25827": { "city" : "CRAB ORCHARD", "state" : "WV", "county" : "RALEIGH" },
            "25831": { "city" : "DANESE", "state" : "WV", "county" : "FAYETTE" },
            "25832": { "city" : "DANIELS", "state" : "WV", "county" : "RALEIGH" },
            "25833": { "city" : "DOTHAN", "state" : "WV", "county" : "FAYETTE" },
            "25836": { "city" : "ECCLES", "state" : "WV", "county" : "RALEIGH" },
            "25837": { "city" : "EDMOND", "state" : "WV", "county" : "FAYETTE" },
            "25839": { "city" : "FAIRDALE", "state" : "WV", "county" : "RALEIGH" },
            "25840": { "city" : "FAYETTEVILLE", "state" : "WV", "county" : "FAYETTE" },
            "25841": { "city" : "FLAT TOP", "state" : "WV", "county" : "MERCER" },
            "25843": { "city" : "GHENT", "state" : "WV", "county" : "RALEIGH" },"25844": { "city" : "GLEN DANIEL", "state" : "WV", "county" : "RALEIGH" },
            "25845": { "city" : "GLEN FORK", "state" : "WV", "county" : "WYOMING" },
            "25846": { "city" : "GLEN JEAN", "state" : "WV", "county" : "FAYETTE" },
            "25848": { "city" : "GLEN ROGERS", "state" : "WV", "county" : "WYOMING" },
            "25849": { "city" : "GLEN WHITE", "state" : "WV", "county" : "RALEIGH" },
            "25851": { "city" : "HARPER", "state" : "WV", "county" : "RALEIGH" },
            "25854": { "city" : "HICO", "state" : "WV", "county" : "FAYETTE" },"25855": { "city" : "HILLTOP", "state" : "WV", "county" : "FAYETTE" },
            "25860": { "city" : "LANARK", "state" : "WV", "county" : "RALEIGH" },
            "25862": { "city" : "LANSING", "state" : "WV", "county" : "FAYETTE" },
            "25864": { "city" : "LAYLAND", "state" : "WV", "county" : "FAYETTE" },
            "25865": { "city" : "LESTER", "state" : "WV", "county" : "RALEIGH" },
            "25866": { "city" : "LOCHGELLY", "state" : "WV", "county" : "FAYETTE" },
            "25868": { "city" : "LOOKOUT", "state" : "WV", "county" : "FAYETTE" },
            "25870": { "city" : "MABEN", "state" : "WV", "county" : "WYOMING" },"25871": { "city" : "MABSCOTT", "state" : "WV", "county" : "RALEIGH" },
            "25873": { "city" : "MAC ARTHUR", "state" : "WV", "county" : "RALEIGH" },
            "25876": { "city" : "SAULSVILLE", "state" : "WV", "county" : "WYOMING" },
            "25878": { "city" : "MIDWAY", "state" : "WV", "county" : "RALEIGH" },
            "25879": { "city" : "MINDEN", "state" : "WV", "county" : "FAYETTE" },
            "25880": { "city" : "MOUNT HOPE", "state" : "WV", "county" : "FAYETTE" },
            "25882": { "city" : "MULLENS", "state" : "WV", "county" : "WYOMING" },
            "25901": { "city" : "OAK HILL", "state" : "WV", "county" : "FAYETTE" },
            "25904": { "city" : "PAX", "state" : "WV", "county" : "FAYETTE" },"25906": { "city" : "PINEY VIEW", "state" : "WV", "county" : "RALEIGH" },
            "25907": { "city" : "PRINCE", "state" : "WV", "county" : "FAYETTE" },
            "25909": { "city" : "PROSPERITY", "state" : "WV", "county" : "RALEIGH" },
            "25911": { "city" : "RALEIGH", "state" : "WV", "county" : "RALEIGH" },
            "25915": { "city" : "RHODELL", "state" : "WV", "county" : "RALEIGH" },
            "25917": { "city" : "SCARBRO", "state" : "WV", "county" : "FAYETTE" },
            "25918": { "city" : "SHADY SPRING", "state" : "WV", "county" : "RALEIGH" },
            "25919": { "city" : "SKELTON", "state" : "WV", "county" : "RALEIGH" },
            "25920": { "city" : "SLAB FORK", "state" : "WV", "county" : "RALEIGH" },
            "25921": { "city" : "SOPHIA", "state" : "WV", "county" : "RALEIGH" },
            "25922": { "city" : "SPANISHBURG", "state" : "WV", "county" : "MERCER" },
            "25927": { "city" : "STANAFORD", "state" : "WV", "county" : "RALEIGH" },
            "25928": { "city" : "STEPHENSON", "state" : "WV", "county" : "WYOMING" },
            "25932": { "city" : "SURVEYOR", "state" : "WV", "county" : "RALEIGH" },
            "25936": { "city" : "THURMOND", "state" : "WV", "county" : "FAYETTE" },
            "25938": { "city" : "VICTOR", "state" : "WV", "county" : "FAYETTE" },
            "25942": { "city" : "WINONA", "state" : "WV", "county" : "FAYETTE" },
            "25951": { "city" : "HINTON", "state" : "WV", "county" : "SUMMERS" },
            "25958": { "city" : "CHARMCO", "state" : "WV", "county" : "GREENBRIER" },
            "25962": { "city" : "RAINELLE", "state" : "WV", "county" : "GREENBRIER" },
            "25966": { "city" : "GREEN SULPHUR SPRINGS", "state" : "WV", "county" : "SUMMERS" },
            "25969": { "city" : "JUMPING BRANCH", "state" : "WV", "county" : "SUMMERS" },
            "25971": { "city" : "LERONA", "state" : "WV", "county" : "MERCER" },"25976": { "city" : "MEADOW BRIDGE", "state" : "WV", "county" : "FAYETTE" },
            "25978": { "city" : "NIMITZ", "state" : "WV", "county" : "SUMMERS" },
            "25979": { "city" : "PIPESTEM", "state" : "WV", "county" : "SUMMERS" },
            "25981": { "city" : "QUINWOOD", "state" : "WV", "county" : "GREENBRIER" },
            "25984": { "city" : "RUPERT", "state" : "WV", "county" : "GREENBRIER" },
            "25985": { "city" : "SANDSTONE", "state" : "WV", "county" : "SUMMERS" },
            "25986": { "city" : "SPRING DALE", "state" : "WV", "county" : "FAYETTE" },
            "25989": { "city" : "WHITE OAK", "state" : "WV", "county" : "RALEIGH" },
            "26003": { "city" : "WHEELING", "state" : "WV", "county" : "OHIO" },"26030": { "city" : "BEECH BOTTOM", "state" : "WV", "county" : "BROOKE" },
            "26031": { "city" : "BENWOOD", "state" : "WV", "county" : "MARSHALL" },
            "26032": { "city" : "BETHANY", "state" : "WV", "county" : "BROOKE" },
            "26033": { "city" : "CAMERON", "state" : "WV", "county" : "MARSHALL" },
            "26034": { "city" : "CHESTER", "state" : "WV", "county" : "HANCOCK" },
            "26035": { "city" : "COLLIERS", "state" : "WV", "county" : "BROOKE" },
            "26036": { "city" : "DALLAS", "state" : "WV", "county" : "MARSHALL" },
            "26037": { "city" : "FOLLANSBEE", "state" : "WV", "county" : "BROOKE" },
            "26038": { "city" : "GLEN DALE", "state" : "WV", "county" : "MARSHALL" },
            "26039": { "city" : "GLEN EASTON", "state" : "WV", "county" : "MARSHALL" },
            "26040": { "city" : "MCMECHEN", "state" : "WV", "county" : "MARSHALL" },
            "26041": { "city" : "MOUNDSVILLE", "state" : "WV", "county" : "MARSHALL" },
            "26047": { "city" : "NEW CUMBERLAND", "state" : "WV", "county" : "HANCOCK" },
            "26050": { "city" : "NEWELL", "state" : "WV", "county" : "HANCOCK" },
            "26055": { "city" : "PROCTOR", "state" : "WV", "county" : "MARSHALL" },
            "26056": { "city" : "NEW MANCHESTER", "state" : "WV", "county" : "HANCOCK" },
            "26058": { "city" : "SHORT CREEK", "state" : "WV", "county" : "BROOKE" },
            "26059": { "city" : "TRIADELPHIA", "state" : "WV", "county" : "OHIO" },
            "26060": { "city" : "VALLEY GROVE", "state" : "WV", "county" : "OHIO" },
            "26062": { "city" : "WEIRTON", "state" : "WV", "county" : "HANCOCK" },
            "26070": { "city" : "WELLSBURG", "state" : "WV", "county" : "BROOKE" },
            "26074": { "city" : "WEST LIBERTY", "state" : "WV", "county" : "OHIO" },
            "26101": { "city" : "PARKERSBURG", "state" : "WV", "county" : "WOOD" },
            "26102": { "city" : "PARKERSBURG", "state" : "WV", "county" : "WOOD" },
            "26103": { "city" : "PARKERSBURG", "state" : "WV", "county" : "WOOD" },
            "26104": { "city" : "PARKERSBURG", "state" : "WV", "county" : "WOOD" },
            "26105": { "city" : "VIENNA", "state" : "WV", "county" : "WOOD" },"26106": { "city" : "PARKERSBURG", "state" : "WV", "county" : "WOOD" },
            "26120": { "city" : "MINERAL WELLS", "state" : "WV", "county" : "WOOD" },
            "26121": { "city" : "MINERAL WELLS", "state" : "WV", "county" : "WOOD" },
            "26133": { "city" : "BELLEVILLE", "state" : "WV", "county" : "WOOD" },
            "26134": { "city" : "BELMONT", "state" : "WV", "county" : "PLEASANTS" },
            "26136": { "city" : "BIG BEND", "state" : "WV", "county" : "CALHOUN" },
            "26137": { "city" : "BIG SPRINGS", "state" : "WV", "county" : "CALHOUN" },
            "26141": { "city" : "CRESTON", "state" : "WV", "county" : "WIRT" },"26142": { "city" : "DAVISVILLE", "state" : "WV", "county" : "WOOD" },
            "26143": { "city" : "ELIZABETH", "state" : "WV", "county" : "WIRT" },
            "26146": { "city" : "FRIENDLY", "state" : "WV", "county" : "TYLER" },
            "26147": { "city" : "GRANTSVILLE", "state" : "WV", "county" : "CALHOUN" },
            "26148": { "city" : "MACFARLAN", "state" : "WV", "county" : "RITCHIE" },
            "26149": { "city" : "MIDDLEBOURNE", "state" : "WV", "county" : "TYLER" },
            "26150": { "city" : "MINERAL WELLS", "state" : "WV", "county" : "WOOD" },
            "26151": { "city" : "MOUNT ZION", "state" : "WV", "county" : "CALHOUN" },
            "26152": { "city" : "MUNDAY", "state" : "WV", "county" : "CALHOUN" },
            "26155": { "city" : "NEW MARTINSVILLE", "state" : "WV", "county" : "WETZEL" },
            "26159": { "city" : "PADEN CITY", "state" : "WV", "county" : "WETZEL" },
            "26160": { "city" : "PALESTINE", "state" : "WV", "county" : "WIRT" },
            "26161": { "city" : "PETROLEUM", "state" : "WV", "county" : "RITCHIE" },
            "26162": { "city" : "PORTERS FALLS", "state" : "WV", "county" : "WETZEL" },
            "26164": { "city" : "RAVENSWOOD", "state" : "WV", "county" : "JACKSON" },
            "26167": { "city" : "READER", "state" : "WV", "county" : "WETZEL" },"26169": { "city" : "ROCKPORT", "state" : "WV", "county" : "WOOD" },
            "26170": { "city" : "SAINT MARYS", "state" : "WV", "county" : "PLEASANTS" },
            "26175": { "city" : "SISTERSVILLE", "state" : "WV", "county" : "TYLER" },
            "26178": { "city" : "SMITHVILLE", "state" : "WV", "county" : "RITCHIE" },
            "26180": { "city" : "WALKER", "state" : "WV", "county" : "WOOD" },"26181": { "city" : "WASHINGTON", "state" : "WV", "county" : "WOOD" },
            "26184": { "city" : "WAVERLY", "state" : "WV", "county" : "WOOD" },"26187": { "city" : "WILLIAMSTOWN", "state" : "WV", "county" : "WOOD" },
            "26201": { "city" : "BUCKHANNON", "state" : "WV", "county" : "UPSHUR" },
            "26202": { "city" : "FENWICK", "state" : "WV", "county" : "NICHOLAS" },
            "26203": { "city" : "ERBACON", "state" : "WV", "county" : "WEBSTER" },
            "26205": { "city" : "CRAIGSVILLE", "state" : "WV", "county" : "NICHOLAS" },
            "26206": { "city" : "COWEN", "state" : "WV", "county" : "WEBSTER" },"26208": { "city" : "CAMDEN ON GAULEY", "state" : "WV", "county" : "WEBSTER" },
            "26209": { "city" : "SNOWSHOE", "state" : "WV", "county" : "POCAHONTAS" },
            "26210": { "city" : "ADRIAN", "state" : "WV", "county" : "UPSHUR" },"26215": { "city" : "CLEVELAND", "state" : "WV", "county" : "UPSHUR" },
            "26217": { "city" : "DIANA", "state" : "WV", "county" : "WEBSTER" },"26218": { "city" : "FRENCH CREEK", "state" : "WV", "county" : "UPSHUR" },
            "26222": { "city" : "HACKER VALLEY", "state" : "WV", "county" : "WEBSTER" },
            "26224": { "city" : "HELVETIA", "state" : "WV", "county" : "RANDOLPH" },
            "26228": { "city" : "KANAWHA HEAD", "state" : "WV", "county" : "UPSHUR" },
            "26234": { "city" : "ROCK CAVE", "state" : "WV", "county" : "UPSHUR" },
            "26237": { "city" : "TALLMANSVILLE", "state" : "WV", "county" : "UPSHUR" },
            "26238": { "city" : "VOLGA", "state" : "WV", "county" : "BARBOUR" },"26241": { "city" : "ELKINS", "state" : "WV", "county" : "RANDOLPH" },
            "26250": { "city" : "BELINGTON", "state" : "WV", "county" : "BARBOUR" },
            "26253": { "city" : "BEVERLY", "state" : "WV", "county" : "RANDOLPH" },
            "26254": { "city" : "BOWDEN", "state" : "WV", "county" : "TUCKER" },"26257": { "city" : "COALTON", "state" : "WV", "county" : "RANDOLPH" },
            "26259": { "city" : "DAILEY", "state" : "WV", "county" : "RANDOLPH" },
            "26260": { "city" : "DAVIS", "state" : "WV", "county" : "TUCKER" },"26261": { "city" : "RICHWOOD", "state" : "WV", "county" : "NICHOLAS" },
            "26263": { "city" : "DRYFORK", "state" : "WV", "county" : "RANDOLPH" },
            "26264": { "city" : "DURBIN", "state" : "WV", "county" : "POCAHONTAS" },
            "26266": { "city" : "UPPERGLADE", "state" : "WV", "county" : "WEBSTER" },
            "26267": { "city" : "ELLAMORE", "state" : "WV", "county" : "RANDOLPH" },
            "26268": { "city" : "GLADY", "state" : "WV", "county" : "RANDOLPH" },
            "26269": { "city" : "HAMBLETON", "state" : "WV", "county" : "TUCKER" },
            "26270": { "city" : "HARMAN", "state" : "WV", "county" : "RANDOLPH" },
            "26271": { "city" : "HENDRICKS", "state" : "WV", "county" : "TUCKER" },
            "26273": { "city" : "HUTTONSVILLE", "state" : "WV", "county" : "RANDOLPH" },
            "26275": { "city" : "JUNIOR", "state" : "WV", "county" : "BARBOUR" },
            "26276": { "city" : "KERENS", "state" : "WV", "county" : "RANDOLPH" },
            "26278": { "city" : "MABIE", "state" : "WV", "county" : "RANDOLPH" },
            "26280": { "city" : "MILL CREEK", "state" : "WV", "county" : "RANDOLPH" },
            "26282": { "city" : "MONTERVILLE", "state" : "WV", "county" : "RANDOLPH" },
            "26283": { "city" : "MONTROSE", "state" : "WV", "county" : "RANDOLPH" },
            "26285": { "city" : "NORTON", "state" : "WV", "county" : "RANDOLPH" },
            "26287": { "city" : "PARSONS", "state" : "WV", "county" : "TUCKER" },
            "26288": { "city" : "WEBSTER SPRINGS", "state" : "WV", "county" : "WEBSTER" },
            "26291": { "city" : "SLATYFORK", "state" : "WV", "county" : "POCAHONTAS" },
            "26292": { "city" : "THOMAS", "state" : "WV", "county" : "TUCKER" },"26293": { "city" : "VALLEY BEND", "state" : "WV", "county" : "RANDOLPH" },
            "26294": { "city" : "VALLEY HEAD", "state" : "WV", "county" : "RANDOLPH" },
            "26301": { "city" : "CLARKSBURG", "state" : "WV", "county" : "HARRISON" },
            "26302": { "city" : "CLARKSBURG", "state" : "WV", "county" : "HARRISON" },
            "26306": { "city" : "CLARKSBURG", "state" : "WV", "county" : "HARRISON" },
            "26320": { "city" : "ALMA", "state" : "WV", "county" : "TYLER" },"26321": { "city" : "ALUM BRIDGE", "state" : "WV", "county" : "LEWIS" },
            "26323": { "city" : "ANMOORE", "state" : "WV", "county" : "HARRISON" },
            "26327": { "city" : "BEREA", "state" : "WV", "county" : "RITCHIE" },"26330": { "city" : "BRIDGEPORT", "state" : "WV", "county" : "HARRISON" },
            "26335": { "city" : "BURNSVILLE", "state" : "WV", "county" : "BRAXTON" },
            "26337": { "city" : "CAIRO", "state" : "WV", "county" : "RITCHIE" },"26338": { "city" : "CAMDEN", "state" : "WV", "county" : "LEWIS" },
            "26339": { "city" : "CENTER POINT", "state" : "WV", "county" : "DODDRIDGE" },
            "26342": { "city" : "COXS MILLS", "state" : "WV", "county" : "GILMER" },
            "26343": { "city" : "CRAWFORD", "state" : "WV", "county" : "LEWIS" },
            "26346": { "city" : "ELLENBORO", "state" : "WV", "county" : "RITCHIE" },
            "26347": { "city" : "FLEMINGTON", "state" : "WV", "county" : "TAYLOR" },
            "26348": { "city" : "FOLSOM", "state" : "WV", "county" : "WETZEL" },"26349": { "city" : "GALLOWAY", "state" : "WV", "county" : "BARBOUR" },
            "26351": { "city" : "GLENVILLE", "state" : "WV", "county" : "GILMER" },
            "26354": { "city" : "GRAFTON", "state" : "WV", "county" : "TAYLOR" },
            "26361": { "city" : "GYPSY", "state" : "WV", "county" : "HARRISON" },
            "26362": { "city" : "HARRISVILLE", "state" : "WV", "county" : "RITCHIE" },
            "26366": { "city" : "HAYWOOD", "state" : "WV", "county" : "HARRISON" },
            "26369": { "city" : "HEPZIBAH", "state" : "WV", "county" : "HARRISON" },
            "26372": { "city" : "HORNER", "state" : "WV", "county" : "LEWIS" },"26374": { "city" : "INDEPENDENCE", "state" : "WV", "county" : "PRESTON" },
            "26376": { "city" : "IRELAND", "state" : "WV", "county" : "LEWIS" },"26377": { "city" : "JACKSONBURG", "state" : "WV", "county" : "WETZEL" },
            "26378": { "city" : "JANE LEW", "state" : "WV", "county" : "LEWIS" },
            "26384": { "city" : "LINN", "state" : "WV", "county" : "GILMER" },"26385": { "city" : "LOST CREEK", "state" : "WV", "county" : "HARRISON" },
            "26386": { "city" : "LUMBERPORT", "state" : "WV", "county" : "HARRISON" },
            "26404": { "city" : "MEADOWBROOK", "state" : "WV", "county" : "HARRISON" },
            "26405": { "city" : "MOATSVILLE", "state" : "WV", "county" : "BARBOUR" },
            "26408": { "city" : "MOUNT CLARE", "state" : "WV", "county" : "HARRISON" },
            "26410": { "city" : "NEWBURG", "state" : "WV", "county" : "PRESTON" },
            "26411": { "city" : "NEW MILTON", "state" : "WV", "county" : "DODDRIDGE" },
            "26415": { "city" : "PENNSBORO", "state" : "WV", "county" : "RITCHIE" },
            "26416": { "city" : "PHILIPPI", "state" : "WV", "county" : "BARBOUR" },
            "26419": { "city" : "PINE GROVE", "state" : "WV", "county" : "WETZEL" },
            "26421": { "city" : "PULLMAN", "state" : "WV", "county" : "RITCHIE" },
            "26422": { "city" : "REYNOLDSVILLE", "state" : "WV", "county" : "HARRISON" },
            "26425": { "city" : "ROWLESBURG", "state" : "WV", "county" : "PRESTON" },
            "26426": { "city" : "SALEM", "state" : "WV", "county" : "HARRISON" },
            "26430": { "city" : "SAND FORK", "state" : "WV", "county" : "GILMER" },
            "26431": { "city" : "SHINNSTON", "state" : "WV", "county" : "HARRISON" },
            "26435": { "city" : "SIMPSON", "state" : "WV", "county" : "TAYLOR" },
            "26436": { "city" : "SMITHBURG", "state" : "WV", "county" : "DODDRIDGE" },
            "26437": { "city" : "SMITHFIELD", "state" : "WV", "county" : "WETZEL" },
            "26438": { "city" : "SPELTER", "state" : "WV", "county" : "HARRISON" },
            "26440": { "city" : "THORNTON", "state" : "WV", "county" : "TAYLOR" },
            "26443": { "city" : "TROY", "state" : "WV", "county" : "GILMER" },"26444": { "city" : "TUNNELTON", "state" : "WV", "county" : "PRESTON" },
            "26447": { "city" : "WALKERSVILLE", "state" : "WV", "county" : "LEWIS" },
            "26448": { "city" : "WALLACE", "state" : "WV", "county" : "HARRISON" },
            "26451": { "city" : "WEST MILFORD", "state" : "WV", "county" : "HARRISON" },
            "26452": { "city" : "WESTON", "state" : "WV", "county" : "LEWIS" },"26456": { "city" : "WEST UNION", "state" : "WV", "county" : "DODDRIDGE" },
            "26501": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26502": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26504": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26505": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26506": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26507": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26508": { "city" : "MORGANTOWN", "state" : "WV", "county" : "MONONGALIA" },
            "26519": { "city" : "ALBRIGHT", "state" : "WV", "county" : "PRESTON" },
            "26520": { "city" : "ARTHURDALE", "state" : "WV", "county" : "PRESTON" },
            "26521": { "city" : "BLACKSVILLE", "state" : "WV", "county" : "MONONGALIA" },
            "26524": { "city" : "BRETZ", "state" : "WV", "county" : "PRESTON" },"26525": { "city" : "BRUCETON MILLS", "state" : "WV", "county" : "PRESTON" },
            "26527": { "city" : "CASSVILLE", "state" : "WV", "county" : "MONONGALIA" },
            "26531": { "city" : "DELLSLOW", "state" : "WV", "county" : "MONONGALIA" },
            "26534": { "city" : "GRANVILLE", "state" : "WV", "county" : "MONONGALIA" },
            "26537": { "city" : "KINGWOOD", "state" : "WV", "county" : "PRESTON" },
            "26541": { "city" : "MAIDSVILLE", "state" : "WV", "county" : "MONONGALIA" },
            "26542": { "city" : "MASONTOWN", "state" : "WV", "county" : "PRESTON" },
            "26543": { "city" : "OSAGE", "state" : "WV", "county" : "MONONGALIA" },
            "26544": { "city" : "PENTRESS", "state" : "WV", "county" : "MONONGALIA" },
            "26546": { "city" : "PURSGLOVE", "state" : "WV", "county" : "MONONGALIA" },
            "26547": { "city" : "REEDSVILLE", "state" : "WV", "county" : "PRESTON" },
            "26554": { "city" : "FAIRMONT", "state" : "WV", "county" : "MARION" },
            "26555": { "city" : "FAIRMONT", "state" : "WV", "county" : "MARION" },
            "26559": { "city" : "BARRACKVILLE", "state" : "WV", "county" : "MARION" },
            "26560": { "city" : "BAXTER", "state" : "WV", "county" : "MARION" },"26562": { "city" : "BURTON", "state" : "WV", "county" : "WETZEL" },
            "26563": { "city" : "CAROLINA", "state" : "WV", "county" : "MARION" },
            "26568": { "city" : "ENTERPRISE", "state" : "WV", "county" : "HARRISON" },
            "26570": { "city" : "FAIRVIEW", "state" : "WV", "county" : "MARION" },
            "26571": { "city" : "FARMINGTON", "state" : "WV", "county" : "MARION" },
            "26574": { "city" : "GRANT TOWN", "state" : "WV", "county" : "MARION" },
            "26575": { "city" : "HUNDRED", "state" : "WV", "county" : "WETZEL" },
            "26576": { "city" : "IDAMAY", "state" : "WV", "county" : "MARION" },"26578": { "city" : "KINGMONT", "state" : "WV", "county" : "MARION" },
            "26581": { "city" : "LITTLETON", "state" : "WV", "county" : "WETZEL" },
            "26582": { "city" : "MANNINGTON", "state" : "WV", "county" : "MARION" },
            "26585": { "city" : "METZ", "state" : "WV", "county" : "MARION" },"26586": { "city" : "MONTANA MINES", "state" : "WV", "county" : "MARION" },
            "26587": { "city" : "RACHEL", "state" : "WV", "county" : "MARION" },"26588": { "city" : "RIVESVILLE", "state" : "WV", "county" : "MARION" },
            "26590": { "city" : "WANA", "state" : "WV", "county" : "MONONGALIA" },
            "26591": { "city" : "WORTHINGTON", "state" : "WV", "county" : "MARION" },
            "26601": { "city" : "SUTTON", "state" : "WV", "county" : "BRAXTON" },
            "26610": { "city" : "BIRCH RIVER", "state" : "WV", "county" : "NICHOLAS" },
            "26611": { "city" : "CEDARVILLE", "state" : "WV", "county" : "GILMER" },
            "26615": { "city" : "COPEN", "state" : "WV", "county" : "BRAXTON" },"26619": { "city" : "EXCHANGE", "state" : "WV", "county" : "BRAXTON" },
            "26621": { "city" : "FLATWOODS", "state" : "WV", "county" : "BRAXTON" },
            "26623": { "city" : "FRAMETOWN", "state" : "WV", "county" : "BRAXTON" },
            "26624": { "city" : "GASSAWAY", "state" : "WV", "county" : "BRAXTON" },
            "26627": { "city" : "HEATERS", "state" : "WV", "county" : "BRAXTON" },
            "26629": { "city" : "LITTLE BIRCH", "state" : "WV", "county" : "BRAXTON" },
            "26636": { "city" : "ROSEDALE", "state" : "WV", "county" : "GILMER" },
            "26638": { "city" : "SHOCK", "state" : "WV", "county" : "GILMER" },"26651": { "city" : "SUMMERSVILLE", "state" : "WV", "county" : "NICHOLAS" },
            "26656": { "city" : "BELVA", "state" : "WV", "county" : "NICHOLAS" },
            "26660": { "city" : "CALVIN", "state" : "WV", "county" : "NICHOLAS" },
            "26662": { "city" : "CANVAS", "state" : "WV", "county" : "NICHOLAS" },
            "26667": { "city" : "DRENNEN", "state" : "WV", "county" : "NICHOLAS" },
            "26671": { "city" : "GILBOA", "state" : "WV", "county" : "NICHOLAS" },
            "26675": { "city" : "KESLERS CROSS LANES", "state" : "WV", "county" : "NICHOLAS" },
            "26676": { "city" : "LEIVASY", "state" : "WV", "county" : "NICHOLAS" },
            "26678": { "city" : "MOUNT LOOKOUT", "state" : "WV", "county" : "NICHOLAS" },
            "26679": { "city" : "MOUNT NEBO", "state" : "WV", "county" : "NICHOLAS" },
            "26680": { "city" : "NALLEN", "state" : "WV", "county" : "FAYETTE" },
            "26681": { "city" : "NETTIE", "state" : "WV", "county" : "NICHOLAS" },
            "26684": { "city" : "POOL", "state" : "WV", "county" : "NICHOLAS" },"26690": { "city" : "SWISS", "state" : "WV", "county" : "NICHOLAS" },
            "26704": { "city" : "AUGUSTA", "state" : "WV", "county" : "HAMPSHIRE" },
            "26705": { "city" : "AURORA", "state" : "WV", "county" : "PRESTON" },
            "26707": { "city" : "BAYARD", "state" : "WV", "county" : "GRANT" },"26710": { "city" : "BURLINGTON", "state" : "WV", "county" : "MINERAL" },
            "26711": { "city" : "CAPON BRIDGE", "state" : "WV", "county" : "HAMPSHIRE" },
            "26714": { "city" : "DELRAY", "state" : "WV", "county" : "HAMPSHIRE" },
            "26716": { "city" : "EGLON", "state" : "WV", "county" : "PRESTON" },"26717": { "city" : "ELK GARDEN", "state" : "WV", "county" : "MINERAL" },
            "26719": { "city" : "FORT ASHBY", "state" : "WV", "county" : "MINERAL" },
            "26720": { "city" : "GORMANIA", "state" : "WV", "county" : "GRANT" },
            "26722": { "city" : "GREEN SPRING", "state" : "WV", "county" : "HAMPSHIRE" },
            "26726": { "city" : "KEYSER", "state" : "WV", "county" : "MINERAL" },
            "26731": { "city" : "LAHMANSVILLE", "state" : "WV", "county" : "GRANT" },
            "26739": { "city" : "MOUNT STORM", "state" : "WV", "county" : "GRANT" },
            "26743": { "city" : "NEW CREEK", "state" : "WV", "county" : "MINERAL" },
            "26750": { "city" : "PIEDMONT", "state" : "WV", "county" : "MINERAL" },
            "26753": { "city" : "RIDGELEY", "state" : "WV", "county" : "MINERAL" },
            "26755": { "city" : "RIO", "state" : "WV", "county" : "HAMPSHIRE" },"26757": { "city" : "ROMNEY", "state" : "WV", "county" : "HAMPSHIRE" },
            "26761": { "city" : "SHANKS", "state" : "WV", "county" : "HAMPSHIRE" },
            "26763": { "city" : "SPRINGFIELD", "state" : "WV", "county" : "HAMPSHIRE" },
            "26764": { "city" : "TERRA ALTA", "state" : "WV", "county" : "PRESTON" },
            "26767": { "city" : "WILEY FORD", "state" : "WV", "county" : "MINERAL" },
            "26801": { "city" : "BAKER", "state" : "WV", "county" : "HARDY" },"26802": { "city" : "BRANDYWINE", "state" : "WV", "county" : "PENDLETON" },
            "26804": { "city" : "CIRCLEVILLE", "state" : "WV", "county" : "PENDLETON" },
            "26807": { "city" : "FRANKLIN", "state" : "WV", "county" : "PENDLETON" },
            "26808": { "city" : "HIGH VIEW", "state" : "WV", "county" : "HAMPSHIRE" },
            "26810": { "city" : "LOST CITY", "state" : "WV", "county" : "HARDY" },
            "26812": { "city" : "MATHIAS", "state" : "WV", "county" : "HARDY" },"26814": { "city" : "RIVERTON", "state" : "WV", "county" : "PENDLETON" },
            "26815": { "city" : "SUGAR GROVE", "state" : "WV", "county" : "PENDLETON" },
            "26817": { "city" : "BLOOMERY", "state" : "WV", "county" : "HAMPSHIRE" },
            "26818": { "city" : "FISHER", "state" : "WV", "county" : "HARDY" },"26823": { "city" : "CAPON SPRINGS", "state" : "WV", "county" : "HAMPSHIRE" },
            "26833": { "city" : "MAYSVILLE", "state" : "WV", "county" : "GRANT" },
            "26836": { "city" : "MOOREFIELD", "state" : "WV", "county" : "HARDY" },
            "26845": { "city" : "OLD FIELDS", "state" : "WV", "county" : "HARDY" },
            "26847": { "city" : "PETERSBURG", "state" : "WV", "county" : "GRANT" },
            "26851": { "city" : "WARDENSVILLE", "state" : "WV", "county" : "HARDY" },
            "26852": { "city" : "PURGITSVILLE", "state" : "WV", "county" : "HAMPSHIRE" },
            "26855": { "city" : "CABINS", "state" : "WV", "county" : "GRANT" },"26865": { "city" : "YELLOW SPRING", "state" : "WV", "county" : "HAMPSHIRE" },
            "26866": { "city" : "UPPER TRACT", "state" : "WV", "county" : "PENDLETON" },
            "26884": { "city" : "SENECA ROCKS", "state" : "WV", "county" : "PENDLETON" },
            "26886": { "city" : "ONEGO", "state" : "WV", "county" : "PENDLETON" },
            "27006": { "city" : "ADVANCE", "state" : "NC", "county" : "DAVIE" },"27007": { "city" : "ARARAT", "state" : "NC", "county" : "SURRY" },
            "27009": { "city" : "BELEWS CREEK", "state" : "NC", "county" : "FORSYTH" },
            "27010": { "city" : "BETHANIA", "state" : "NC", "county" : "FORSYTH" },
            "27011": { "city" : "BOONVILLE", "state" : "NC", "county" : "YADKIN" },
            "27012": { "city" : "CLEMMONS", "state" : "NC", "county" : "FORSYTH" },
            "27013": { "city" : "CLEVELAND", "state" : "NC", "county" : "ROWAN" },
            "27014": { "city" : "COOLEEMEE", "state" : "NC", "county" : "DAVIE" },
            "27016": { "city" : "DANBURY", "state" : "NC", "county" : "STOKES" },
            "27017": { "city" : "DOBSON", "state" : "NC", "county" : "SURRY" },"27018": { "city" : "EAST BEND", "state" : "NC", "county" : "YADKIN" },
            "27019": { "city" : "GERMANTON", "state" : "NC", "county" : "STOKES" },
            "27020": { "city" : "HAMPTONVILLE", "state" : "NC", "county" : "YADKIN" },
            "27021": { "city" : "KING", "state" : "NC", "county" : "STOKES" },"27022": { "city" : "LAWSONVILLE", "state" : "NC", "county" : "STOKES" },
            "27023": { "city" : "LEWISVILLE", "state" : "NC", "county" : "FORSYTH" },
            "27024": { "city" : "LOWGAP", "state" : "NC", "county" : "SURRY" },"27025": { "city" : "MADISON", "state" : "NC", "county" : "ROCKINGHAM" },
            "27027": { "city" : "MAYODAN", "state" : "NC", "county" : "ROCKINGHAM" },
            "27028": { "city" : "MOCKSVILLE", "state" : "NC", "county" : "DAVIE" },
            "27030": { "city" : "MOUNT AIRY", "state" : "NC", "county" : "SURRY" },
            "27031": { "city" : "WHITE PLAINS", "state" : "NC", "county" : "SURRY" },
            "27040": { "city" : "PFAFFTOWN", "state" : "NC", "county" : "FORSYTH" },
            "27041": { "city" : "PILOT MOUNTAIN", "state" : "NC", "county" : "SURRY" },
            "27042": { "city" : "PINE HALL", "state" : "NC", "county" : "STOKES" },
            "27043": { "city" : "PINNACLE", "state" : "NC", "county" : "STOKES" },
            "27045": { "city" : "RURAL HALL", "state" : "NC", "county" : "FORSYTH" },
            "27046": { "city" : "SANDY RIDGE", "state" : "NC", "county" : "STOKES" },
            "27047": { "city" : "SILOAM", "state" : "NC", "county" : "SURRY" },"27048": { "city" : "STONEVILLE", "state" : "NC", "county" : "ROCKINGHAM" },
            "27049": { "city" : "TOAST", "state" : "NC", "county" : "SURRY" },"27050": { "city" : "TOBACCOVILLE", "state" : "NC", "county" : "FORSYTH" },
            "27051": { "city" : "WALKERTOWN", "state" : "NC", "county" : "FORSYTH" },
            "27052": { "city" : "WALNUT COVE", "state" : "NC", "county" : "STOKES" },
            "27053": { "city" : "WESTFIELD", "state" : "NC", "county" : "SURRY" },
            "27054": { "city" : "WOODLEAF", "state" : "NC", "county" : "ROWAN" },
            "27055": { "city" : "YADKINVILLE", "state" : "NC", "county" : "YADKIN" },
            "27094": { "city" : "RURAL HALL", "state" : "NC", "county" : "FORSYTH" },
            "27101": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27102": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27103": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27104": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27105": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27106": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27107": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27108": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27109": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27110": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27113": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27114": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27115": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27116": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27117": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27120": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27127": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27130": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27150": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27152": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27155": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27157": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27199": { "city" : "WINSTON SALEM", "state" : "NC", "county" : "FORSYTH" },
            "27201": { "city" : "ALAMANCE", "state" : "NC", "county" : "ALAMANCE" },
            "27202": { "city" : "ALTAMAHAW", "state" : "NC", "county" : "ALAMANCE" },
            "27203": { "city" : "ASHEBORO", "state" : "NC", "county" : "RANDOLPH" },
            "27204": { "city" : "ASHEBORO", "state" : "NC", "county" : "RANDOLPH" },
            "27205": { "city" : "ASHEBORO", "state" : "NC", "county" : "RANDOLPH" },
            "27207": { "city" : "BEAR CREEK", "state" : "NC", "county" : "CHATHAM" },
            "27208": { "city" : "BENNETT", "state" : "NC", "county" : "CHATHAM" },
            "27209": { "city" : "BISCOE", "state" : "NC", "county" : "MONTGOMERY" },
            "27212": { "city" : "BLANCH", "state" : "NC", "county" : "CASWELL" },
            "27213": { "city" : "BONLEE", "state" : "NC", "county" : "CHATHAM" },
            "27214": { "city" : "BROWNS SUMMIT", "state" : "NC", "county" : "GUILFORD" },
            "27215": { "city" : "BURLINGTON", "state" : "NC", "county" : "ALAMANCE" },
            "27216": { "city" : "BURLINGTON", "state" : "NC", "county" : "ALAMANCE" },
            "27217": { "city" : "BURLINGTON", "state" : "NC", "county" : "ALAMANCE" },
            "27228": { "city" : "BYNUM", "state" : "NC", "county" : "CHATHAM" },"27229": { "city" : "CANDOR", "state" : "NC", "county" : "MONTGOMERY" },
            "27230": { "city" : "CEDAR FALLS", "state" : "NC", "county" : "RANDOLPH" },
            "27231": { "city" : "CEDAR GROVE", "state" : "NC", "county" : "ORANGE" },
            "27233": { "city" : "CLIMAX", "state" : "NC", "county" : "GUILFORD" },
            "27235": { "city" : "COLFAX", "state" : "NC", "county" : "GUILFORD" },
            "27237": { "city" : "CUMNOCK", "state" : "NC", "county" : "LEE" },"27239": { "city" : "DENTON", "state" : "NC", "county" : "DAVIDSON" },
            "27242": { "city" : "EAGLE SPRINGS", "state" : "NC", "county" : "MOORE" },
            "27243": { "city" : "EFLAND", "state" : "NC", "county" : "ORANGE" },"27244": { "city" : "ELON", "state" : "NC", "county" : "ALAMANCE" },
            "27247": { "city" : "ETHER", "state" : "NC", "county" : "MONTGOMERY" },
            "27248": { "city" : "FRANKLINVILLE", "state" : "NC", "county" : "RANDOLPH" },
            "27249": { "city" : "GIBSONVILLE", "state" : "NC", "county" : "GUILFORD" },
            "27252": { "city" : "GOLDSTON", "state" : "NC", "county" : "CHATHAM" },
            "27253": { "city" : "GRAHAM", "state" : "NC", "county" : "ALAMANCE" },
            "27256": { "city" : "GULF", "state" : "NC", "county" : "CHATHAM" },"27258": { "city" : "HAW RIVER", "state" : "NC", "county" : "ALAMANCE" },
            "27259": { "city" : "HIGHFALLS", "state" : "NC", "county" : "MOORE" },
            "27260": { "city" : "HIGH POINT", "state" : "NC", "county" : "GUILFORD" },
            "27261": { "city" : "HIGH POINT", "state" : "NC", "county" : "GUILFORD" },
            "27262": { "city" : "HIGH POINT", "state" : "NC", "county" : "GUILFORD" },
            "27263": { "city" : "HIGH POINT", "state" : "NC", "county" : "GUILFORD" },
            "27264": { "city" : "HIGH POINT", "state" : "NC", "county" : "GUILFORD" },
            "27265": { "city" : "HIGH POINT", "state" : "NC", "county" : "GUILFORD" },
            "27278": { "city" : "HILLSBOROUGH", "state" : "NC", "county" : "ORANGE" },
            "27281": { "city" : "JACKSON SPRINGS", "state" : "NC", "county" : "MOORE" },
            "27282": { "city" : "JAMESTOWN", "state" : "NC", "county" : "GUILFORD" },
            "27283": { "city" : "JULIAN", "state" : "NC", "county" : "GUILFORD" },
            "27284": { "city" : "KERNERSVILLE", "state" : "NC", "county" : "FORSYTH" },
            "27285": { "city" : "KERNERSVILLE", "state" : "NC", "county" : "FORSYTH" },
            "27288": { "city" : "EDEN", "state" : "NC", "county" : "ROCKINGHAM" },
            "27289": { "city" : "EDEN", "state" : "NC", "county" : "ROCKINGHAM" },
            "27291": { "city" : "LEASBURG", "state" : "NC", "county" : "CASWELL" },
            "27292": { "city" : "LEXINGTON", "state" : "NC", "county" : "DAVIDSON" },
            "27293": { "city" : "LEXINGTON", "state" : "NC", "county" : "DAVIDSON" },
            "27294": { "city" : "LEXINGTON", "state" : "NC", "county" : "DAVIDSON" },
            "27295": { "city" : "LEXINGTON", "state" : "NC", "county" : "DAVIDSON" },
            "27298": { "city" : "LIBERTY", "state" : "NC", "county" : "RANDOLPH" },
            "27299": { "city" : "LINWOOD", "state" : "NC", "county" : "DAVIDSON" },
            "27301": { "city" : "MC LEANSVILLE", "state" : "NC", "county" : "GUILFORD" },
            "27302": { "city" : "MEBANE", "state" : "NC", "county" : "ALAMANCE" },
            "27305": { "city" : "MILTON", "state" : "NC", "county" : "CASWELL" },
            "27306": { "city" : "MOUNT GILEAD", "state" : "NC", "county" : "MONTGOMERY" },
            "27310": { "city" : "OAK RIDGE", "state" : "NC", "county" : "GUILFORD" },
            "27311": { "city" : "PELHAM", "state" : "NC", "county" : "CASWELL" },
            "27312": { "city" : "PITTSBORO", "state" : "NC", "county" : "CHATHAM" },
            "27313": { "city" : "PLEASANT GARDEN", "state" : "NC", "county" : "GUILFORD" },
            "27314": { "city" : "PROSPECT HILL", "state" : "NC", "county" : "CASWELL" },
            "27315": { "city" : "PROVIDENCE", "state" : "NC", "county" : "CASWELL" },
            "27316": { "city" : "RAMSEUR", "state" : "NC", "county" : "RANDOLPH" },
            "27317": { "city" : "RANDLEMAN", "state" : "NC", "county" : "RANDOLPH" },
            "27320": { "city" : "REIDSVILLE", "state" : "NC", "county" : "ROCKINGHAM" },
            "27323": { "city" : "REIDSVILLE", "state" : "NC", "county" : "ROCKINGHAM" },
            "27325": { "city" : "ROBBINS", "state" : "NC", "county" : "MOORE" },"27326": { "city" : "RUFFIN", "state" : "NC", "county" : "ROCKINGHAM" },
            "27330": { "city" : "SANFORD", "state" : "NC", "county" : "LEE" },"27331": { "city" : "SANFORD", "state" : "NC", "county" : "LEE" },
            "27332": { "city" : "SANFORD", "state" : "NC", "county" : "LEE" },"27340": { "city" : "SAXAPAHAW", "state" : "NC", "county" : "ALAMANCE" },
            "27341": { "city" : "SEAGROVE", "state" : "NC", "county" : "RANDOLPH" },
            "27342": { "city" : "SEDALIA", "state" : "NC", "county" : "GUILFORD" },
            "27343": { "city" : "SEMORA", "state" : "NC", "county" : "PERSON" },"27344": { "city" : "SILER CITY", "state" : "NC", "county" : "CHATHAM" },
            "27349": { "city" : "SNOW CAMP", "state" : "NC", "county" : "ALAMANCE" },
            "27350": { "city" : "SOPHIA", "state" : "NC", "county" : "RANDOLPH" },
            "27351": { "city" : "SOUTHMONT", "state" : "NC", "county" : "DAVIDSON" },
            "27355": { "city" : "STALEY", "state" : "NC", "county" : "RANDOLPH" },
            "27356": { "city" : "STAR", "state" : "NC", "county" : "MONTGOMERY" },
            "27357": { "city" : "STOKESDALE", "state" : "NC", "county" : "GUILFORD" },
            "27358": { "city" : "SUMMERFIELD", "state" : "NC", "county" : "GUILFORD" },
            "27359": { "city" : "SWEPSONVILLE", "state" : "NC", "county" : "ALAMANCE" },
            "27360": { "city" : "THOMASVILLE", "state" : "NC", "county" : "DAVIDSON" },
            "27361": { "city" : "THOMASVILLE", "state" : "NC", "county" : "DAVIDSON" },
            "27370": { "city" : "TRINITY", "state" : "NC", "county" : "RANDOLPH" },
            "27371": { "city" : "TROY", "state" : "NC", "county" : "MONTGOMERY" },
            "27373": { "city" : "WALLBURG", "state" : "NC", "county" : "DAVIDSON" },
            "27374": { "city" : "WELCOME", "state" : "NC", "county" : "DAVIDSON" },
            "27375": { "city" : "WENTWORTH", "state" : "NC", "county" : "ROCKINGHAM" },
            "27376": { "city" : "WEST END", "state" : "NC", "county" : "MOORE" },
            "27377": { "city" : "WHITSETT", "state" : "NC", "county" : "GUILFORD" },
            "27379": { "city" : "YANCEYVILLE", "state" : "NC", "county" : "CASWELL" },
            "27401": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27402": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27403": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27404": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27405": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27406": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27407": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27408": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27409": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27410": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27411": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27412": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27415": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27416": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27417": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27419": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27420": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27425": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27427": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27429": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27435": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27438": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27455": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27495": { "city" : "GREENSBORO", "state" : "NC", "county" : "GUILFORD" },
            "27501": { "city" : "ANGIER", "state" : "NC", "county" : "HARNETT" },
            "27502": { "city" : "APEX", "state" : "NC", "county" : "WAKE" },"27503": { "city" : "BAHAMA", "state" : "NC", "county" : "DURHAM" },
            "27504": { "city" : "BENSON", "state" : "NC", "county" : "JOHNSTON" },
            "27505": { "city" : "BROADWAY", "state" : "NC", "county" : "LEE" },"27506": { "city" : "BUIES CREEK", "state" : "NC", "county" : "HARNETT" },
            "27507": { "city" : "BULLOCK", "state" : "NC", "county" : "GRANVILLE" },
            "27508": { "city" : "BUNN", "state" : "NC", "county" : "FRANKLIN" },"27509": { "city" : "BUTNER", "state" : "NC", "county" : "GRANVILLE" },
            "27510": { "city" : "CARRBORO", "state" : "NC", "county" : "ORANGE" },
            "27511": { "city" : "CARY", "state" : "NC", "county" : "WAKE" },"27512": { "city" : "CARY", "state" : "NC", "county" : "WAKE" },
            "27513": { "city" : "CARY", "state" : "NC", "county" : "WAKE" },"27514": { "city" : "CHAPEL HILL", "state" : "NC", "county" : "ORANGE" },
            "27515": { "city" : "CHAPEL HILL", "state" : "NC", "county" : "ORANGE" },
            "27516": { "city" : "CHAPEL HILL", "state" : "NC", "county" : "ORANGE" },
            "27517": { "city" : "CHAPEL HILL", "state" : "NC", "county" : "ORANGE" },
            "27518": { "city" : "CARY", "state" : "NC", "county" : "WAKE" },"27519": { "city" : "CARY", "state" : "NC", "county" : "WAKE" },
            "27520": { "city" : "CLAYTON", "state" : "NC", "county" : "JOHNSTON" },
            "27521": { "city" : "COATS", "state" : "NC", "county" : "HARNETT" },"27522": { "city" : "CREEDMOOR", "state" : "NC", "county" : "GRANVILLE" },
            "27523": { "city" : "APEX", "state" : "NC", "county" : "WAKE" },"27524": { "city" : "FOUR OAKS", "state" : "NC", "county" : "JOHNSTON" },
            "27525": { "city" : "FRANKLINTON", "state" : "NC", "county" : "FRANKLIN" },
            "27526": { "city" : "FUQUAY VARINA", "state" : "NC", "county" : "WAKE" },
            "27527": { "city" : "CLAYTON", "state" : "NC", "county" : "JOHNSTON" },
            "27528": { "city" : "CLAYTON", "state" : "NC", "county" : "JOHNSTON" },
            "27529": { "city" : "GARNER", "state" : "NC", "county" : "WAKE" },"27530": { "city" : "GOLDSBORO", "state" : "NC", "county" : "WAYNE" },
            "27531": { "city" : "GOLDSBORO", "state" : "NC", "county" : "WAYNE" },
            "27532": { "city" : "GOLDSBORO", "state" : "NC", "county" : "WAYNE" },
            "27533": { "city" : "GOLDSBORO", "state" : "NC", "county" : "WAYNE" },
            "27534": { "city" : "GOLDSBORO", "state" : "NC", "county" : "WAYNE" },
            "27536": { "city" : "HENDERSON", "state" : "NC", "county" : "VANCE" },
            "27537": { "city" : "HENDERSON", "state" : "NC", "county" : "VANCE" },
            "27539": { "city" : "APEX", "state" : "NC", "county" : "WAKE" },"27540": { "city" : "HOLLY SPRINGS", "state" : "NC", "county" : "WAKE" },
            "27541": { "city" : "HURDLE MILLS", "state" : "NC", "county" : "PERSON" },
            "27542": { "city" : "KENLY", "state" : "NC", "county" : "JOHNSTON" },
            "27543": { "city" : "KIPLING", "state" : "NC", "county" : "HARNETT" },
            "27544": { "city" : "KITTRELL", "state" : "NC", "county" : "VANCE" },
            "27545": { "city" : "KNIGHTDALE", "state" : "NC", "county" : "WAKE" },
            "27546": { "city" : "LILLINGTON", "state" : "NC", "county" : "HARNETT" },
            "27549": { "city" : "LOUISBURG", "state" : "NC", "county" : "FRANKLIN" },
            "27551": { "city" : "MACON", "state" : "NC", "county" : "WARREN" },"27552": { "city" : "MAMERS", "state" : "NC", "county" : "HARNETT" },
            "27553": { "city" : "MANSON", "state" : "NC", "county" : "VANCE" },"27555": { "city" : "MICRO", "state" : "NC", "county" : "JOHNSTON" },
            "27556": { "city" : "MIDDLEBURG", "state" : "NC", "county" : "VANCE" },
            "27557": { "city" : "MIDDLESEX", "state" : "NC", "county" : "NASH" },
            "27559": { "city" : "MONCURE", "state" : "NC", "county" : "CHATHAM" },
            "27560": { "city" : "MORRISVILLE", "state" : "NC", "county" : "WAKE" },
            "27562": { "city" : "NEW HILL", "state" : "NC", "county" : "WAKE" },"27563": { "city" : "NORLINA", "state" : "NC", "county" : "WARREN" },
            "27565": { "city" : "OXFORD", "state" : "NC", "county" : "GRANVILLE" },
            "27568": { "city" : "PINE LEVEL", "state" : "NC", "county" : "JOHNSTON" },
            "27569": { "city" : "PRINCETON", "state" : "NC", "county" : "JOHNSTON" },
            "27570": { "city" : "RIDGEWAY", "state" : "NC", "county" : "WARREN" },
            "27571": { "city" : "ROLESVILLE", "state" : "NC", "county" : "WAKE" },
            "27572": { "city" : "ROUGEMONT", "state" : "NC", "county" : "DURHAM" },
            "27573": { "city" : "ROXBORO", "state" : "NC", "county" : "PERSON" },
            "27574": { "city" : "ROXBORO", "state" : "NC", "county" : "PERSON" },
            "27576": { "city" : "SELMA", "state" : "NC", "county" : "JOHNSTON" },
            "27577": { "city" : "SMITHFIELD", "state" : "NC", "county" : "JOHNSTON" },
            "27581": { "city" : "STEM", "state" : "NC", "county" : "GRANVILLE" },
            "27582": { "city" : "STOVALL", "state" : "NC", "county" : "GRANVILLE" },
            "27583": { "city" : "TIMBERLAKE", "state" : "NC", "county" : "PERSON" },
            "27584": { "city" : "TOWNSVILLE", "state" : "NC", "county" : "VANCE" },
            "27586": { "city" : "VAUGHAN", "state" : "NC", "county" : "WARREN" },
            "27587": { "city" : "WAKE FOREST", "state" : "NC", "county" : "WAKE" },
            "27588": { "city" : "WAKE FOREST", "state" : "NC", "county" : "WAKE" },
            "27589": { "city" : "WARRENTON", "state" : "NC", "county" : "WARREN" },
            "27591": { "city" : "WENDELL", "state" : "NC", "county" : "WAKE" },"27592": { "city" : "WILLOW SPRING", "state" : "NC", "county" : "WAKE" },
            "27593": { "city" : "WILSONS MILLS", "state" : "NC", "county" : "JOHNSTON" },
            "27594": { "city" : "WISE", "state" : "NC", "county" : "WARREN" },"27596": { "city" : "YOUNGSVILLE", "state" : "NC", "county" : "FRANKLIN" },
            "27597": { "city" : "ZEBULON", "state" : "NC", "county" : "WAKE" },"27599": { "city" : "CHAPEL HILL", "state" : "NC", "county" : "ORANGE" },
            "27601": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27602": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27603": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27604": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27605": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27606": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27607": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27608": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27609": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27610": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27611": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27612": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27613": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27614": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27615": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27616": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27617": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27619": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27620": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27622": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27623": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27624": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27627": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27628": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27629": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27635": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27636": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27650": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27658": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27661": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27668": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27675": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27676": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27695": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27697": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27698": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },
            "27699": { "city" : "RALEIGH", "state" : "NC", "county" : "WAKE" },"27701": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27702": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27703": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27704": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27705": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27706": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27707": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27708": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27709": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27710": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27711": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27712": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27713": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27715": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27717": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },
            "27722": { "city" : "DURHAM", "state" : "NC", "county" : "DURHAM" },"27801": { "city" : "ROCKY MOUNT", "state" : "NC", "county" : "EDGECOMBE" },
            "27802": { "city" : "ROCKY MOUNT", "state" : "NC", "county" : "EDGECOMBE" },
            "27803": { "city" : "ROCKY MOUNT", "state" : "NC", "county" : "NASH" },
            "27804": { "city" : "ROCKY MOUNT", "state" : "NC", "county" : "NASH" },
            "27805": { "city" : "AULANDER", "state" : "NC", "county" : "BERTIE" },
            "27806": { "city" : "AURORA", "state" : "NC", "county" : "BEAUFORT" },
            "27807": { "city" : "BAILEY", "state" : "NC", "county" : "NASH" },"27808": { "city" : "BATH", "state" : "NC", "county" : "BEAUFORT" },
            "27809": { "city" : "BATTLEBORO", "state" : "NC", "county" : "EDGECOMBE" },
            "27810": { "city" : "BELHAVEN", "state" : "NC", "county" : "BEAUFORT" },
            "27811": { "city" : "BELLARTHUR", "state" : "NC", "county" : "PITT" },
            "27812": { "city" : "BETHEL", "state" : "NC", "county" : "PITT" },"27813": { "city" : "BLACK CREEK", "state" : "NC", "county" : "WILSON" },
            "27814": { "city" : "BLOUNTS CREEK", "state" : "NC", "county" : "BEAUFORT" },
            "27816": { "city" : "CASTALIA", "state" : "NC", "county" : "NASH" },"27817": { "city" : "CHOCOWINITY", "state" : "NC", "county" : "BEAUFORT" },
            "27818": { "city" : "COMO", "state" : "NC", "county" : "HERTFORD" },"27819": { "city" : "CONETOE", "state" : "NC", "county" : "EDGECOMBE" },
            "27820": { "city" : "CONWAY", "state" : "NC", "county" : "NORTHAMPTON" },
            "27821": { "city" : "EDWARD", "state" : "NC", "county" : "BEAUFORT" },
            "27822": { "city" : "ELM CITY", "state" : "NC", "county" : "WILSON" },
            "27823": { "city" : "ENFIELD", "state" : "NC", "county" : "HALIFAX" },
            "27824": { "city" : "ENGELHARD", "state" : "NC", "county" : "HYDE" },
            "27825": { "city" : "EVERETTS", "state" : "NC", "county" : "MARTIN" },
            "27826": { "city" : "FAIRFIELD", "state" : "NC", "county" : "HYDE" },
            "27827": { "city" : "FALKLAND", "state" : "NC", "county" : "PITT" },"27828": { "city" : "FARMVILLE", "state" : "NC", "county" : "PITT" },
            "27829": { "city" : "FOUNTAIN", "state" : "NC", "county" : "PITT" },"27830": { "city" : "FREMONT", "state" : "NC", "county" : "WAYNE" },
            "27831": { "city" : "GARYSBURG", "state" : "NC", "county" : "NORTHAMPTON" },
            "27832": { "city" : "GASTON", "state" : "NC", "county" : "NORTHAMPTON" },
            "27833": { "city" : "GREENVILLE", "state" : "NC", "county" : "PITT" },
            "27834": { "city" : "GREENVILLE", "state" : "NC", "county" : "PITT" },
            "27835": { "city" : "GREENVILLE", "state" : "NC", "county" : "PITT" },
            "27836": { "city" : "GREENVILLE", "state" : "NC", "county" : "PITT" },
            "27837": { "city" : "GRIMESLAND", "state" : "NC", "county" : "PITT" },
            "27839": { "city" : "HALIFAX", "state" : "NC", "county" : "HALIFAX" },
            "27840": { "city" : "HAMILTON", "state" : "NC", "county" : "MARTIN" },
            "27841": { "city" : "HASSELL", "state" : "NC", "county" : "MARTIN" },
            "27842": { "city" : "HENRICO", "state" : "NC", "county" : "NORTHAMPTON" },
            "27843": { "city" : "HOBGOOD", "state" : "NC", "county" : "HALIFAX" },
            "27844": { "city" : "HOLLISTER", "state" : "NC", "county" : "HALIFAX" },
            "27845": { "city" : "JACKSON", "state" : "NC", "county" : "NORTHAMPTON" },
            "27846": { "city" : "JAMESVILLE", "state" : "NC", "county" : "MARTIN" },
            "27847": { "city" : "KELFORD", "state" : "NC", "county" : "BERTIE" },
            "27849": { "city" : "LEWISTON WOODVILLE", "state" : "NC", "county" : "BERTIE" },
            "27850": { "city" : "LITTLETON", "state" : "NC", "county" : "HALIFAX" },
            "27851": { "city" : "LUCAMA", "state" : "NC", "county" : "WILSON" },"27852": { "city" : "MACCLESFIELD", "state" : "NC", "county" : "EDGECOMBE" },
            "27853": { "city" : "MARGARETTSVILLE", "state" : "NC", "county" : "NORTHAMPTON" },
            "27855": { "city" : "MURFREESBORO", "state" : "NC", "county" : "HERTFORD" },
            "27856": { "city" : "NASHVILLE", "state" : "NC", "county" : "NASH" },
            "27857": { "city" : "OAK CITY", "state" : "NC", "county" : "MARTIN" },
            "27858": { "city" : "GREENVILLE", "state" : "NC", "county" : "PITT" },
            "27860": { "city" : "PANTEGO", "state" : "NC", "county" : "BEAUFORT" },
            "27862": { "city" : "PENDLETON", "state" : "NC", "county" : "NORTHAMPTON" },
            "27863": { "city" : "PIKEVILLE", "state" : "NC", "county" : "WAYNE" },
            "27864": { "city" : "PINETOPS", "state" : "NC", "county" : "EDGECOMBE" },
            "27865": { "city" : "PINETOWN", "state" : "NC", "county" : "BEAUFORT" },
            "27866": { "city" : "PLEASANT HILL", "state" : "NC", "county" : "NORTHAMPTON" },
            "27867": { "city" : "POTECASI", "state" : "NC", "county" : "NORTHAMPTON" },
            "27868": { "city" : "RED OAK", "state" : "NC", "county" : "NASH" },"27869": { "city" : "RICH SQUARE", "state" : "NC", "county" : "NORTHAMPTON" },
            "27870": { "city" : "ROANOKE RAPIDS", "state" : "NC", "county" : "HALIFAX" },
            "27871": { "city" : "ROBERSONVILLE", "state" : "NC", "county" : "MARTIN" },
            "27872": { "city" : "ROXOBEL", "state" : "NC", "county" : "BERTIE" },
            "27873": { "city" : "SARATOGA", "state" : "NC", "county" : "WILSON" },
            "27874": { "city" : "SCOTLAND NECK", "state" : "NC", "county" : "HALIFAX" },
            "27875": { "city" : "SCRANTON", "state" : "NC", "county" : "HYDE" },"27876": { "city" : "SEABOARD", "state" : "NC", "county" : "NORTHAMPTON" },
            "27877": { "city" : "SEVERN", "state" : "NC", "county" : "NORTHAMPTON" },
            "27878": { "city" : "SHARPSBURG", "state" : "NC", "county" : "NASH" },
            "27879": { "city" : "SIMPSON", "state" : "NC", "county" : "PITT" },"27880": { "city" : "SIMS", "state" : "NC", "county" : "WILSON" },
            "27881": { "city" : "SPEED", "state" : "NC", "county" : "EDGECOMBE" },
            "27882": { "city" : "SPRING HOPE", "state" : "NC", "county" : "NASH" },
            "27883": { "city" : "STANTONSBURG", "state" : "NC", "county" : "WILSON" },
            "27884": { "city" : "STOKES", "state" : "NC", "county" : "PITT" },"27885": { "city" : "SWANQUARTER", "state" : "NC", "county" : "HYDE" },
            "27886": { "city" : "TARBORO", "state" : "NC", "county" : "EDGECOMBE" },
            "27887": { "city" : "TILLERY", "state" : "NC", "county" : "HALIFAX" },
            "27888": { "city" : "WALSTONBURG", "state" : "NC", "county" : "GREENE" },
            "27889": { "city" : "WASHINGTON", "state" : "NC", "county" : "BEAUFORT" },
            "27890": { "city" : "WELDON", "state" : "NC", "county" : "HALIFAX" },
            "27891": { "city" : "WHITAKERS", "state" : "NC", "county" : "NASH" },
            "27892": { "city" : "WILLIAMSTON", "state" : "NC", "county" : "MARTIN" },
            "27893": { "city" : "WILSON", "state" : "NC", "county" : "WILSON" },"27894": { "city" : "WILSON", "state" : "NC", "county" : "WILSON" },
            "27895": { "city" : "WILSON", "state" : "NC", "county" : "WILSON" },"27896": { "city" : "WILSON", "state" : "NC", "county" : "WILSON" },
            "27897": { "city" : "WOODLAND", "state" : "NC", "county" : "NORTHAMPTON" },
            "27906": { "city" : "ELIZABETH CITY", "state" : "NC", "county" : "PASQUOTANK" },
            "27907": { "city" : "ELIZABETH CITY", "state" : "NC", "county" : "PASQUOTANK" },
            "27909": { "city" : "ELIZABETH CITY", "state" : "NC", "county" : "PASQUOTANK" },
            "27910": { "city" : "AHOSKIE", "state" : "NC", "county" : "HERTFORD" },
            "27915": { "city" : "AVON", "state" : "NC", "county" : "DARE" },"27916": { "city" : "AYDLETT", "state" : "NC", "county" : "CURRITUCK" },
            "27917": { "city" : "BARCO", "state" : "NC", "county" : "CURRITUCK" },
            "27919": { "city" : "BELVIDERE", "state" : "NC", "county" : "PERQUIMANS" },
            "27920": { "city" : "BUXTON", "state" : "NC", "county" : "DARE" },"27921": { "city" : "CAMDEN", "state" : "NC", "county" : "CAMDEN" },
            "27922": { "city" : "COFIELD", "state" : "NC", "county" : "HERTFORD" },
            "27923": { "city" : "COINJOCK", "state" : "NC", "county" : "CURRITUCK" },
            "27924": { "city" : "COLERAIN", "state" : "NC", "county" : "BERTIE" },
            "27925": { "city" : "COLUMBIA", "state" : "NC", "county" : "TYRRELL" },
            "27926": { "city" : "CORAPEAKE", "state" : "NC", "county" : "GATES" },
            "27927": { "city" : "COROLLA", "state" : "NC", "county" : "CURRITUCK" },
            "27928": { "city" : "CRESWELL", "state" : "NC", "county" : "WASHINGTON" },
            "27929": { "city" : "CURRITUCK", "state" : "NC", "county" : "CURRITUCK" },
            "27930": { "city" : "DURANTS NECK", "state" : "NC", "county" : "PERQUIMANS" },
            "27932": { "city" : "EDENTON", "state" : "NC", "county" : "CHOWAN" },
            "27935": { "city" : "EURE", "state" : "NC", "county" : "GATES" },"27936": { "city" : "FRISCO", "state" : "NC", "county" : "DARE" },
            "27937": { "city" : "GATES", "state" : "NC", "county" : "GATES" },"27938": { "city" : "GATESVILLE", "state" : "NC", "county" : "GATES" },
            "27939": { "city" : "GRANDY", "state" : "NC", "county" : "CURRITUCK" },
            "27941": { "city" : "HARBINGER", "state" : "NC", "county" : "CURRITUCK" },
            "27942": { "city" : "HARRELLSVILLE", "state" : "NC", "county" : "HERTFORD" },
            "27943": { "city" : "HATTERAS", "state" : "NC", "county" : "DARE" },"27944": { "city" : "HERTFORD", "state" : "NC", "county" : "PERQUIMANS" },
            "27946": { "city" : "HOBBSVILLE", "state" : "NC", "county" : "GATES" },
            "27947": { "city" : "JARVISBURG", "state" : "NC", "county" : "CURRITUCK" },
            "27948": { "city" : "KILL DEVIL HILLS", "state" : "NC", "county" : "DARE" },
            "27949": { "city" : "KITTY HAWK", "state" : "NC", "county" : "DARE" },
            "27950": { "city" : "KNOTTS ISLAND", "state" : "NC", "county" : "CURRITUCK" },
            "27953": { "city" : "MANNS HARBOR", "state" : "NC", "county" : "DARE" },
            "27954": { "city" : "MANTEO", "state" : "NC", "county" : "DARE" },"27956": { "city" : "MAPLE", "state" : "NC", "county" : "CURRITUCK" },
            "27957": { "city" : "MERRY HILL", "state" : "NC", "county" : "BERTIE" },
            "27958": { "city" : "MOYOCK", "state" : "NC", "county" : "CURRITUCK" },
            "27959": { "city" : "NAGS HEAD", "state" : "NC", "county" : "DARE" },
            "27960": { "city" : "OCRACOKE", "state" : "NC", "county" : "HYDE" },"27962": { "city" : "PLYMOUTH", "state" : "NC", "county" : "WASHINGTON" },
            "27964": { "city" : "POINT HARBOR", "state" : "NC", "county" : "CURRITUCK" },
            "27965": { "city" : "POPLAR BRANCH", "state" : "NC", "county" : "CURRITUCK" },
            "27966": { "city" : "POWELLS POINT", "state" : "NC", "county" : "CURRITUCK" },
            "27967": { "city" : "POWELLSVILLE", "state" : "NC", "county" : "BERTIE" },
            "27968": { "city" : "RODANTHE", "state" : "NC", "county" : "DARE" },"27970": { "city" : "ROPER", "state" : "NC", "county" : "WASHINGTON" },
            "27972": { "city" : "SALVO", "state" : "NC", "county" : "DARE" },"27973": { "city" : "SHAWBORO", "state" : "NC", "county" : "CURRITUCK" },
            "27974": { "city" : "SHILOH", "state" : "NC", "county" : "CAMDEN" },"27976": { "city" : "SOUTH MILLS", "state" : "NC", "county" : "CAMDEN" },
            "27978": { "city" : "STUMPY POINT", "state" : "NC", "county" : "DARE" },
            "27979": { "city" : "SUNBURY", "state" : "NC", "county" : "GATES" },"27980": { "city" : "TYNER", "state" : "NC", "county" : "CHOWAN" },
            "27981": { "city" : "WANCHESE", "state" : "NC", "county" : "DARE" },"27982": { "city" : "WAVES", "state" : "NC", "county" : "DARE" },
            "27983": { "city" : "WINDSOR", "state" : "NC", "county" : "BERTIE" },
            "27985": { "city" : "WINFALL", "state" : "NC", "county" : "PERQUIMANS" },
            "27986": { "city" : "WINTON", "state" : "NC", "county" : "HERTFORD" },
            "28001": { "city" : "ALBEMARLE", "state" : "NC", "county" : "STANLY" },
            "28002": { "city" : "ALBEMARLE", "state" : "NC", "county" : "STANLY" },
            "28006": { "city" : "ALEXIS", "state" : "NC", "county" : "GASTON" },"28007": { "city" : "ANSONVILLE", "state" : "NC", "county" : "ANSON" },
            "28009": { "city" : "BADIN", "state" : "NC", "county" : "STANLY" },"28010": { "city" : "BARIUM SPRINGS", "state" : "NC", "county" : "IREDELL" },
            "28012": { "city" : "BELMONT", "state" : "NC", "county" : "GASTON" },
            "28016": { "city" : "BESSEMER CITY", "state" : "NC", "county" : "GASTON" },
            "28017": { "city" : "BOILING SPRINGS", "state" : "NC", "county" : "CLEVELAND" },
            "28018": { "city" : "BOSTIC", "state" : "NC", "county" : "RUTHERFORD" },
            "28019": { "city" : "CAROLEEN", "state" : "NC", "county" : "RUTHERFORD" },
            "28020": { "city" : "CASAR", "state" : "NC", "county" : "CLEVELAND" },
            "28021": { "city" : "CHERRYVILLE", "state" : "NC", "county" : "GASTON" },
            "28023": { "city" : "CHINA GROVE", "state" : "NC", "county" : "ROWAN" },
            "28024": { "city" : "CLIFFSIDE", "state" : "NC", "county" : "RUTHERFORD" },
            "28025": { "city" : "CONCORD", "state" : "NC", "county" : "CABARRUS" },
            "28026": { "city" : "CONCORD", "state" : "NC", "county" : "CABARRUS" },
            "28027": { "city" : "CONCORD", "state" : "NC", "county" : "CABARRUS" },
            "28031": { "city" : "CORNELIUS", "state" : "NC", "county" : "MECKLENBURG" },
            "28032": { "city" : "CRAMERTON", "state" : "NC", "county" : "GASTON" },
            "28033": { "city" : "CROUSE", "state" : "NC", "county" : "LINCOLN" },
            "28034": { "city" : "DALLAS", "state" : "NC", "county" : "GASTON" },"28035": { "city" : "DAVIDSON", "state" : "NC", "county" : "MECKLENBURG" },
            "28036": { "city" : "DAVIDSON", "state" : "NC", "county" : "MECKLENBURG" },
            "28037": { "city" : "DENVER", "state" : "NC", "county" : "LINCOLN" },
            "28038": { "city" : "EARL", "state" : "NC", "county" : "CLEVELAND" },
            "28039": { "city" : "EAST SPENCER", "state" : "NC", "county" : "ROWAN" },
            "28040": { "city" : "ELLENBORO", "state" : "NC", "county" : "RUTHERFORD" },
            "28041": { "city" : "FAITH", "state" : "NC", "county" : "ROWAN" },"28042": { "city" : "FALLSTON", "state" : "NC", "county" : "CLEVELAND" },
            "28043": { "city" : "FOREST CITY", "state" : "NC", "county" : "RUTHERFORD" },
            "28052": { "city" : "GASTONIA", "state" : "NC", "county" : "GASTON" },
            "28053": { "city" : "GASTONIA", "state" : "NC", "county" : "GASTON" },
            "28054": { "city" : "GASTONIA", "state" : "NC", "county" : "GASTON" },
            "28055": { "city" : "GASTONIA", "state" : "NC", "county" : "GASTON" },
            "28056": { "city" : "GASTONIA", "state" : "NC", "county" : "GASTON" },
            "28070": { "city" : "HUNTERSVILLE", "state" : "NC", "county" : "MECKLENBURG" },
            "28071": { "city" : "GOLD HILL", "state" : "NC", "county" : "ROWAN" },
            "28072": { "city" : "GRANITE QUARRY", "state" : "NC", "county" : "ROWAN" },
            "28073": { "city" : "GROVER", "state" : "NC", "county" : "CLEVELAND" },
            "28074": { "city" : "HARRIS", "state" : "NC", "county" : "RUTHERFORD" },
            "28075": { "city" : "HARRISBURG", "state" : "NC", "county" : "CABARRUS" },
            "28076": { "city" : "HENRIETTA", "state" : "NC", "county" : "RUTHERFORD" },
            "28077": { "city" : "HIGH SHOALS", "state" : "NC", "county" : "GASTON" },
            "28078": { "city" : "HUNTERSVILLE", "state" : "NC", "county" : "MECKLENBURG" },
            "28079": { "city" : "INDIAN TRAIL", "state" : "NC", "county" : "UNION" },
            "28080": { "city" : "IRON STATION", "state" : "NC", "county" : "LINCOLN" },
            "28081": { "city" : "KANNAPOLIS", "state" : "NC", "county" : "CABARRUS" },
            "28082": { "city" : "KANNAPOLIS", "state" : "NC", "county" : "CABARRUS" },
            "28083": { "city" : "KANNAPOLIS", "state" : "NC", "county" : "CABARRUS" },
            "28086": { "city" : "KINGS MOUNTAIN", "state" : "NC", "county" : "CLEVELAND" },
            "28088": { "city" : "LANDIS", "state" : "NC", "county" : "ROWAN" },"28089": { "city" : "LATTIMORE", "state" : "NC", "county" : "CLEVELAND" },
            "28090": { "city" : "LAWNDALE", "state" : "NC", "county" : "CLEVELAND" },
            "28091": { "city" : "LILESVILLE", "state" : "NC", "county" : "ANSON" },
            "28092": { "city" : "LINCOLNTON", "state" : "NC", "county" : "LINCOLN" },
            "28093": { "city" : "LINCOLNTON", "state" : "NC", "county" : "LINCOLN" },
            "28097": { "city" : "LOCUST", "state" : "NC", "county" : "STANLY" },"28098": { "city" : "LOWELL", "state" : "NC", "county" : "GASTON" },
            "28101": { "city" : "MC ADENVILLE", "state" : "NC", "county" : "GASTON" },
            "28102": { "city" : "MC FARLAN", "state" : "NC", "county" : "ANSON" },
            "28103": { "city" : "MARSHVILLE", "state" : "NC", "county" : "UNION" },
            "28104": { "city" : "MATTHEWS", "state" : "NC", "county" : "UNION" },
            "28105": { "city" : "MATTHEWS", "state" : "NC", "county" : "MECKLENBURG" },
            "28106": { "city" : "MATTHEWS", "state" : "NC", "county" : "MECKLENBURG" },
            "28107": { "city" : "MIDLAND", "state" : "NC", "county" : "CABARRUS" },
            "28108": { "city" : "MINERAL SPRINGS", "state" : "NC", "county" : "UNION" },
            "28109": { "city" : "MISENHEIMER", "state" : "NC", "county" : "STANLY" },
            "28110": { "city" : "MONROE", "state" : "NC", "county" : "UNION" },"28111": { "city" : "MONROE", "state" : "NC", "county" : "UNION" },
            "28112": { "city" : "MONROE", "state" : "NC", "county" : "UNION" },"28114": { "city" : "MOORESBORO", "state" : "NC", "county" : "CLEVELAND" },
            "28115": { "city" : "MOORESVILLE", "state" : "NC", "county" : "IREDELL" },
            "28117": { "city" : "MOORESVILLE", "state" : "NC", "county" : "IREDELL" },
            "28119": { "city" : "MORVEN", "state" : "NC", "county" : "ANSON" },"28120": { "city" : "MOUNT HOLLY", "state" : "NC", "county" : "GASTON" },
            "28123": { "city" : "MOUNT MOURNE", "state" : "NC", "county" : "IREDELL" },
            "28124": { "city" : "MOUNT PLEASANT", "state" : "NC", "county" : "CABARRUS" },
            "28125": { "city" : "MOUNT ULLA", "state" : "NC", "county" : "ROWAN" },
            "28126": { "city" : "NEWELL", "state" : "NC", "county" : "MECKLENBURG" },
            "28127": { "city" : "NEW LONDON", "state" : "NC", "county" : "STANLY" },
            "28128": { "city" : "NORWOOD", "state" : "NC", "county" : "STANLY" },
            "28129": { "city" : "OAKBORO", "state" : "NC", "county" : "STANLY" },
            "28130": { "city" : "PAW CREEK", "state" : "NC", "county" : "MECKLENBURG" },
            "28133": { "city" : "PEACHLAND", "state" : "NC", "county" : "ANSON" },
            "28134": { "city" : "PINEVILLE", "state" : "NC", "county" : "MECKLENBURG" },
            "28135": { "city" : "POLKTON", "state" : "NC", "county" : "ANSON" },"28136": { "city" : "POLKVILLE", "state" : "NC", "county" : "CLEVELAND" },
            "28137": { "city" : "RICHFIELD", "state" : "NC", "county" : "STANLY" },
            "28138": { "city" : "ROCKWELL", "state" : "NC", "county" : "ROWAN" },
            "28139": { "city" : "RUTHERFORDTON", "state" : "NC", "county" : "RUTHERFORD" },
            "28144": { "city" : "SALISBURY", "state" : "NC", "county" : "ROWAN" },
            "28145": { "city" : "SALISBURY", "state" : "NC", "county" : "ROWAN" },
            "28146": { "city" : "SALISBURY", "state" : "NC", "county" : "ROWAN" },
            "28147": { "city" : "SALISBURY", "state" : "NC", "county" : "ROWAN" },
            "28150": { "city" : "SHELBY", "state" : "NC", "county" : "CLEVELAND" },
            "28151": { "city" : "SHELBY", "state" : "NC", "county" : "CLEVELAND" },
            "28152": { "city" : "SHELBY", "state" : "NC", "county" : "CLEVELAND" },
            "28159": { "city" : "SPENCER", "state" : "NC", "county" : "ROWAN" },"28160": { "city" : "SPINDALE", "state" : "NC", "county" : "RUTHERFORD" },
            "28163": { "city" : "STANFIELD", "state" : "NC", "county" : "STANLY" },
            "28164": { "city" : "STANLEY", "state" : "NC", "county" : "GASTON" },
            "28166": { "city" : "TROUTMAN", "state" : "NC", "county" : "IREDELL" },
            "28167": { "city" : "UNION MILLS", "state" : "NC", "county" : "RUTHERFORD" },
            "28168": { "city" : "VALE", "state" : "NC", "county" : "LINCOLN" },"28169": { "city" : "WACO", "state" : "NC", "county" : "CLEVELAND" },
            "28170": { "city" : "WADESBORO", "state" : "NC", "county" : "ANSON" },
            "28173": { "city" : "WAXHAW", "state" : "NC", "county" : "UNION" },"28174": { "city" : "WINGATE", "state" : "NC", "county" : "UNION" },
            "28201": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28202": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28203": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28204": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28205": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28206": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28207": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28208": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28209": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28210": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28211": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28212": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28213": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28214": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28215": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28216": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28217": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28218": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28219": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28220": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28221": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28222": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28223": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28224": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28226": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28227": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28228": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28229": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28230": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28231": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28232": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28233": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28234": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28235": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28236": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28237": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28241": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28244": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28246": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28247": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28253": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28255": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28256": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28260": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28262": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28265": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28266": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28269": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28270": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28271": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28272": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28273": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28274": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28277": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28278": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28280": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28281": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28282": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28284": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28285": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28287": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28288": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28297": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28299": { "city" : "CHARLOTTE", "state" : "NC", "county" : "MECKLENBURG" },
            "28301": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28302": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28303": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28304": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28305": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28306": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28307": { "city" : "FORT BRAGG", "state" : "NC", "county" : "CUMBERLAND" },
            "28308": { "city" : "POPE A F B", "state" : "NC", "county" : "CUMBERLAND" },
            "28309": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28310": { "city" : "FORT BRAGG", "state" : "NC", "county" : "CUMBERLAND" },
            "28311": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28312": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28314": { "city" : "FAYETTEVILLE", "state" : "NC", "county" : "CUMBERLAND" },
            "28315": { "city" : "ABERDEEN", "state" : "NC", "county" : "MOORE" },
            "28318": { "city" : "AUTRYVILLE", "state" : "NC", "county" : "SAMPSON" },
            "28319": { "city" : "BARNESVILLE", "state" : "NC", "county" : "ROBESON" },
            "28320": { "city" : "BLADENBORO", "state" : "NC", "county" : "BLADEN" },
            "28323": { "city" : "BUNNLEVEL", "state" : "NC", "county" : "HARNETT" },
            "28325": { "city" : "CALYPSO", "state" : "NC", "county" : "DUPLIN" },
            "28326": { "city" : "CAMERON", "state" : "NC", "county" : "HARNETT" },
            "28327": { "city" : "CARTHAGE", "state" : "NC", "county" : "MOORE" },
            "28328": { "city" : "CLINTON", "state" : "NC", "county" : "SAMPSON" },
            "28329": { "city" : "CLINTON", "state" : "NC", "county" : "SAMPSON" },
            "28330": { "city" : "CORDOVA", "state" : "NC", "county" : "RICHMOND" },
            "28331": { "city" : "CUMBERLAND", "state" : "NC", "county" : "CUMBERLAND" },
            "28332": { "city" : "DUBLIN", "state" : "NC", "county" : "BLADEN" },"28333": { "city" : "DUDLEY", "state" : "NC", "county" : "WAYNE" },
            "28334": { "city" : "DUNN", "state" : "NC", "county" : "HARNETT" },"28335": { "city" : "DUNN", "state" : "NC", "county" : "HARNETT" },
            "28337": { "city" : "ELIZABETHTOWN", "state" : "NC", "county" : "BLADEN" },
            "28338": { "city" : "ELLERBE", "state" : "NC", "county" : "RICHMOND" },
            "28339": { "city" : "ERWIN", "state" : "NC", "county" : "HARNETT" },"28340": { "city" : "FAIRMONT", "state" : "NC", "county" : "ROBESON" },
            "28341": { "city" : "FAISON", "state" : "NC", "county" : "DUPLIN" },"28342": { "city" : "FALCON", "state" : "NC", "county" : "CUMBERLAND" },
            "28343": { "city" : "GIBSON", "state" : "NC", "county" : "SCOTLAND" },
            "28344": { "city" : "GODWIN", "state" : "NC", "county" : "SAMPSON" },
            "28345": { "city" : "HAMLET", "state" : "NC", "county" : "RICHMOND" },
            "28347": { "city" : "HOFFMAN", "state" : "NC", "county" : "RICHMOND" },
            "28348": { "city" : "HOPE MILLS", "state" : "NC", "county" : "CUMBERLAND" },
            "28349": { "city" : "KENANSVILLE", "state" : "NC", "county" : "DUPLIN" },
            "28350": { "city" : "LAKEVIEW", "state" : "NC", "county" : "MOORE" },
            "28351": { "city" : "LAUREL HILL", "state" : "NC", "county" : "SCOTLAND" },
            "28352": { "city" : "LAURINBURG", "state" : "NC", "county" : "SCOTLAND" },
            "28353": { "city" : "LAURINBURG", "state" : "NC", "county" : "SCOTLAND" },
            "28355": { "city" : "LEMON SPRINGS", "state" : "NC", "county" : "LEE" },
            "28356": { "city" : "LINDEN", "state" : "NC", "county" : "CUMBERLAND" },
            "28357": { "city" : "LUMBER BRIDGE", "state" : "NC", "county" : "ROBESON" },
            "28358": { "city" : "LUMBERTON", "state" : "NC", "county" : "ROBESON" },
            "28359": { "city" : "LUMBERTON", "state" : "NC", "county" : "ROBESON" },
            "28360": { "city" : "LUMBERTON", "state" : "NC", "county" : "ROBESON" },
            "28362": { "city" : "MARIETTA", "state" : "NC", "county" : "ROBESON" },
            "28363": { "city" : "MARSTON", "state" : "NC", "county" : "RICHMOND" },
            "28364": { "city" : "MAXTON", "state" : "NC", "county" : "ROBESON" },
            "28365": { "city" : "MOUNT OLIVE", "state" : "NC", "county" : "WAYNE" },
            "28366": { "city" : "NEWTON GROVE", "state" : "NC", "county" : "SAMPSON" },
            "28367": { "city" : "NORMAN", "state" : "NC", "county" : "RICHMOND" },
            "28368": { "city" : "OLIVIA", "state" : "NC", "county" : "HARNETT" },
            "28369": { "city" : "ORRUM", "state" : "NC", "county" : "ROBESON" },"28370": { "city" : "PINEHURST", "state" : "NC", "county" : "MOORE" },
            "28371": { "city" : "PARKTON", "state" : "NC", "county" : "ROBESON" },
            "28372": { "city" : "PEMBROKE", "state" : "NC", "county" : "ROBESON" },
            "28373": { "city" : "PINEBLUFF", "state" : "NC", "county" : "MOORE" },
            "28374": { "city" : "PINEHURST", "state" : "NC", "county" : "MOORE" },
            "28375": { "city" : "PROCTORVILLE", "state" : "NC", "county" : "ROBESON" },
            "28376": { "city" : "RAEFORD", "state" : "NC", "county" : "HOKE" },"28377": { "city" : "RED SPRINGS", "state" : "NC", "county" : "ROBESON" },
            "28378": { "city" : "REX", "state" : "NC", "county" : "ROBESON" },"28379": { "city" : "ROCKINGHAM", "state" : "NC", "county" : "RICHMOND" },
            "28380": { "city" : "ROCKINGHAM", "state" : "NC", "county" : "RICHMOND" },
            "28382": { "city" : "ROSEBORO", "state" : "NC", "county" : "SAMPSON" },
            "28383": { "city" : "ROWLAND", "state" : "NC", "county" : "ROBESON" },
            "28384": { "city" : "SAINT PAULS", "state" : "NC", "county" : "ROBESON" },
            "28385": { "city" : "SALEMBURG", "state" : "NC", "county" : "SAMPSON" },
            "28386": { "city" : "SHANNON", "state" : "NC", "county" : "ROBESON" },
            "28387": { "city" : "SOUTHERN PINES", "state" : "NC", "county" : "MOORE" },
            "28388": { "city" : "SOUTHERN PINES", "state" : "NC", "county" : "MOORE" },
            "28390": { "city" : "SPRING LAKE", "state" : "NC", "county" : "CUMBERLAND" },
            "28391": { "city" : "STEDMAN", "state" : "NC", "county" : "CUMBERLAND" },
            "28392": { "city" : "TAR HEEL", "state" : "NC", "county" : "BLADEN" },
            "28393": { "city" : "TURKEY", "state" : "NC", "county" : "SAMPSON" },
            "28394": { "city" : "VASS", "state" : "NC", "county" : "MOORE" },"28395": { "city" : "WADE", "state" : "NC", "county" : "CUMBERLAND" },
            "28396": { "city" : "WAGRAM", "state" : "NC", "county" : "SCOTLAND" },
            "28398": { "city" : "WARSAW", "state" : "NC", "county" : "DUPLIN" },"28399": { "city" : "WHITE OAK", "state" : "NC", "county" : "BLADEN" },
            "28401": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28402": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28403": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28404": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28405": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28406": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28407": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28408": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28409": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28410": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28411": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28412": { "city" : "WILMINGTON", "state" : "NC", "county" : "NEW HANOVER" },
            "28420": { "city" : "ASH", "state" : "NC", "county" : "BRUNSWICK" },"28421": { "city" : "ATKINSON", "state" : "NC", "county" : "PENDER" },
            "28422": { "city" : "BOLIVIA", "state" : "NC", "county" : "BRUNSWICK" },
            "28423": { "city" : "BOLTON", "state" : "NC", "county" : "COLUMBUS" },
            "28424": { "city" : "BRUNSWICK", "state" : "NC", "county" : "COLUMBUS" },
            "28425": { "city" : "BURGAW", "state" : "NC", "county" : "PENDER" },"28428": { "city" : "CAROLINA BEACH", "state" : "NC", "county" : "NEW HANOVER" },
            "28429": { "city" : "CASTLE HAYNE", "state" : "NC", "county" : "NEW HANOVER" },
            "28430": { "city" : "CERRO GORDO", "state" : "NC", "county" : "COLUMBUS" },
            "28431": { "city" : "CHADBOURN", "state" : "NC", "county" : "COLUMBUS" },
            "28432": { "city" : "CLARENDON", "state" : "NC", "county" : "COLUMBUS" },
            "28433": { "city" : "CLARKTON", "state" : "NC", "county" : "BLADEN" },
            "28434": { "city" : "COUNCIL", "state" : "NC", "county" : "BLADEN" },
            "28435": { "city" : "CURRIE", "state" : "NC", "county" : "PENDER" },"28436": { "city" : "DELCO", "state" : "NC", "county" : "COLUMBUS" },
            "28438": { "city" : "EVERGREEN", "state" : "NC", "county" : "COLUMBUS" },
            "28439": { "city" : "FAIR BLUFF", "state" : "NC", "county" : "COLUMBUS" },
            "28441": { "city" : "GARLAND", "state" : "NC", "county" : "SAMPSON" },
            "28442": { "city" : "HALLSBORO", "state" : "NC", "county" : "COLUMBUS" },
            "28443": { "city" : "HAMPSTEAD", "state" : "NC", "county" : "PENDER" },
            "28444": { "city" : "HARRELLS", "state" : "NC", "county" : "SAMPSON" },
            "28445": { "city" : "HOLLY RIDGE", "state" : "NC", "county" : "ONSLOW" },
            "28447": { "city" : "IVANHOE", "state" : "NC", "county" : "SAMPSON" },
            "28448": { "city" : "KELLY", "state" : "NC", "county" : "BLADEN" },"28449": { "city" : "KURE BEACH", "state" : "NC", "county" : "NEW HANOVER" },
            "28450": { "city" : "LAKE WACCAMAW", "state" : "NC", "county" : "COLUMBUS" },
            "28451": { "city" : "LELAND", "state" : "NC", "county" : "BRUNSWICK" },
            "28452": { "city" : "LONGWOOD", "state" : "NC", "county" : "BRUNSWICK" },
            "28453": { "city" : "MAGNOLIA", "state" : "NC", "county" : "DUPLIN" },
            "28454": { "city" : "MAPLE HILL", "state" : "NC", "county" : "PENDER" },
            "28455": { "city" : "NAKINA", "state" : "NC", "county" : "COLUMBUS" },
            "28456": { "city" : "RIEGELWOOD", "state" : "NC", "county" : "COLUMBUS" },
            "28457": { "city" : "ROCKY POINT", "state" : "NC", "county" : "PENDER" },
            "28458": { "city" : "ROSE HILL", "state" : "NC", "county" : "DUPLIN" },
            "28459": { "city" : "SHALLOTTE", "state" : "NC", "county" : "BRUNSWICK" },
            "28460": { "city" : "SNEADS FERRY", "state" : "NC", "county" : "ONSLOW" },
            "28461": { "city" : "SOUTHPORT", "state" : "NC", "county" : "BRUNSWICK" },
            "28462": { "city" : "SUPPLY", "state" : "NC", "county" : "BRUNSWICK" },
            "28463": { "city" : "TABOR CITY", "state" : "NC", "county" : "COLUMBUS" },
            "28464": { "city" : "TEACHEY", "state" : "NC", "county" : "DUPLIN" },
            "28465": { "city" : "OAK ISLAND", "state" : "NC", "county" : "BRUNSWICK" },
            "28466": { "city" : "WALLACE", "state" : "NC", "county" : "DUPLIN" },
            "28467": { "city" : "CALABASH", "state" : "NC", "county" : "BRUNSWICK" },
            "28468": { "city" : "SUNSET BEACH", "state" : "NC", "county" : "BRUNSWICK" },
            "28469": { "city" : "OCEAN ISLE BEACH", "state" : "NC", "county" : "BRUNSWICK" },
            "28470": { "city" : "SHALLOTTE", "state" : "NC", "county" : "BRUNSWICK" },
            "28472": { "city" : "WHITEVILLE", "state" : "NC", "county" : "COLUMBUS" },
            "28478": { "city" : "WILLARD", "state" : "NC", "county" : "PENDER" },
            "28479": { "city" : "WINNABOW", "state" : "NC", "county" : "BRUNSWICK" },
            "28480": { "city" : "WRIGHTSVILLE BEACH", "state" : "NC", "county" : "NEW HANOVER" },
            "28501": { "city" : "KINSTON", "state" : "NC", "county" : "LENOIR" },
            "28502": { "city" : "KINSTON", "state" : "NC", "county" : "LENOIR" },
            "28503": { "city" : "KINSTON", "state" : "NC", "county" : "LENOIR" },
            "28504": { "city" : "KINSTON", "state" : "NC", "county" : "LENOIR" },
            "28508": { "city" : "ALBERTSON", "state" : "NC", "county" : "DUPLIN" },
            "28509": { "city" : "ALLIANCE", "state" : "NC", "county" : "PAMLICO" },
            "28510": { "city" : "ARAPAHOE", "state" : "NC", "county" : "PAMLICO" },
            "28511": { "city" : "ATLANTIC", "state" : "NC", "county" : "CARTERET" },
            "28512": { "city" : "ATLANTIC BEACH", "state" : "NC", "county" : "CARTERET" },
            "28513": { "city" : "AYDEN", "state" : "NC", "county" : "PITT" },"28515": { "city" : "BAYBORO", "state" : "NC", "county" : "PAMLICO" },
            "28516": { "city" : "BEAUFORT", "state" : "NC", "county" : "CARTERET" },
            "28518": { "city" : "BEULAVILLE", "state" : "NC", "county" : "DUPLIN" },
            "28519": { "city" : "BRIDGETON", "state" : "NC", "county" : "CRAVEN" },
            "28520": { "city" : "CEDAR ISLAND", "state" : "NC", "county" : "CARTERET" },
            "28521": { "city" : "CHINQUAPIN", "state" : "NC", "county" : "DUPLIN" },
            "28522": { "city" : "COMFORT", "state" : "NC", "county" : "JONES" },"28523": { "city" : "COVE CITY", "state" : "NC", "county" : "CRAVEN" },
            "28524": { "city" : "DAVIS", "state" : "NC", "county" : "CARTERET" },
            "28525": { "city" : "DEEP RUN", "state" : "NC", "county" : "LENOIR" },
            "28526": { "city" : "DOVER", "state" : "NC", "county" : "CRAVEN" },"28527": { "city" : "ERNUL", "state" : "NC", "county" : "CRAVEN" },
            "28528": { "city" : "GLOUCESTER", "state" : "NC", "county" : "CARTERET" },
            "28529": { "city" : "GRANTSBORO", "state" : "NC", "county" : "PAMLICO" },
            "28530": { "city" : "GRIFTON", "state" : "NC", "county" : "PITT" },"28531": { "city" : "HARKERS ISLAND", "state" : "NC", "county" : "CARTERET" },
            "28532": { "city" : "HAVELOCK", "state" : "NC", "county" : "CRAVEN" },
            "28533": { "city" : "CHERRY POINT", "state" : "NC", "county" : "CRAVEN" },
            "28537": { "city" : "HOBUCKEN", "state" : "NC", "county" : "PAMLICO" },
            "28538": { "city" : "HOOKERTON", "state" : "NC", "county" : "GREENE" },
            "28539": { "city" : "HUBERT", "state" : "NC", "county" : "ONSLOW" },"28540": { "city" : "JACKSONVILLE", "state" : "NC", "county" : "ONSLOW" },
            "28541": { "city" : "JACKSONVILLE", "state" : "NC", "county" : "ONSLOW" },
            "28542": { "city" : "CAMP LEJEUNE", "state" : "NC", "county" : "ONSLOW" },
            "28543": { "city" : "TARAWA TERRACE", "state" : "NC", "county" : "ONSLOW" },
            "28544": { "city" : "MIDWAY PARK", "state" : "NC", "county" : "ONSLOW" },
            "28545": { "city" : "MCCUTCHEON FIELD", "state" : "NC", "county" : "ONSLOW" },
            "28546": { "city" : "JACKSONVILLE", "state" : "NC", "county" : "ONSLOW" },
            "28547": { "city" : "CAMP LEJEUNE", "state" : "NC", "county" : "ONSLOW" },
            "28551": { "city" : "LA GRANGE", "state" : "NC", "county" : "LENOIR" },
            "28552": { "city" : "LOWLAND", "state" : "NC", "county" : "PAMLICO" },
            "28553": { "city" : "MARSHALLBERG", "state" : "NC", "county" : "CARTERET" },
            "28554": { "city" : "MAURY", "state" : "NC", "county" : "GREENE" },"28555": { "city" : "MAYSVILLE", "state" : "NC", "county" : "JONES" },
            "28556": { "city" : "MERRITT", "state" : "NC", "county" : "PAMLICO" },
            "28557": { "city" : "MOREHEAD CITY", "state" : "NC", "county" : "CARTERET" },
            "28560": { "city" : "NEW BERN", "state" : "NC", "county" : "CRAVEN" },
            "28561": { "city" : "NEW BERN", "state" : "NC", "county" : "CRAVEN" },
            "28562": { "city" : "NEW BERN", "state" : "NC", "county" : "CRAVEN" },
            "28563": { "city" : "NEW BERN", "state" : "NC", "county" : "CRAVEN" },
            "28564": { "city" : "NEW BERN", "state" : "NC", "county" : "CRAVEN" },
            "28570": { "city" : "NEWPORT", "state" : "NC", "county" : "CARTERET" },
            "28571": { "city" : "ORIENTAL", "state" : "NC", "county" : "PAMLICO" },
            "28572": { "city" : "PINK HILL", "state" : "NC", "county" : "LENOIR" },
            "28573": { "city" : "POLLOCKSVILLE", "state" : "NC", "county" : "JONES" },
            "28574": { "city" : "RICHLANDS", "state" : "NC", "county" : "ONSLOW" },
            "28575": { "city" : "SALTER PATH", "state" : "NC", "county" : "CARTERET" },
            "28577": { "city" : "SEALEVEL", "state" : "NC", "county" : "CARTERET" },
            "28578": { "city" : "SEVEN SPRINGS", "state" : "NC", "county" : "WAYNE" },
            "28579": { "city" : "SMYRNA", "state" : "NC", "county" : "CARTERET" },
            "28580": { "city" : "SNOW HILL", "state" : "NC", "county" : "GREENE" },
            "28581": { "city" : "STACY", "state" : "NC", "county" : "CARTERET" },
            "28582": { "city" : "STELLA", "state" : "NC", "county" : "CARTERET" },
            "28583": { "city" : "STONEWALL", "state" : "NC", "county" : "PAMLICO" },
            "28584": { "city" : "SWANSBORO", "state" : "NC", "county" : "ONSLOW" },
            "28585": { "city" : "TRENTON", "state" : "NC", "county" : "JONES" },"28586": { "city" : "VANCEBORO", "state" : "NC", "county" : "CRAVEN" },
            "28587": { "city" : "VANDEMERE", "state" : "NC", "county" : "PAMLICO" },
            "28589": { "city" : "WILLISTON", "state" : "NC", "county" : "CARTERET" },
            "28590": { "city" : "WINTERVILLE", "state" : "NC", "county" : "PITT" },
            "28594": { "city" : "EMERALD ISLE", "state" : "NC", "county" : "CARTERET" },
            "28601": { "city" : "HICKORY", "state" : "NC", "county" : "CATAWBA" },
            "28602": { "city" : "HICKORY", "state" : "NC", "county" : "CATAWBA" },
            "28603": { "city" : "HICKORY", "state" : "NC", "county" : "CATAWBA" },
            "28604": { "city" : "BANNER ELK", "state" : "NC", "county" : "AVERY" },
            "28605": { "city" : "BLOWING ROCK", "state" : "NC", "county" : "WATAUGA" },
            "28606": { "city" : "BOOMER", "state" : "NC", "county" : "WILKES" },"28607": { "city" : "BOONE", "state" : "NC", "county" : "WATAUGA" },
            "28608": { "city" : "BOONE", "state" : "NC", "county" : "WATAUGA" },"28609": { "city" : "CATAWBA", "state" : "NC", "county" : "CATAWBA" },
            "28610": { "city" : "CLAREMONT", "state" : "NC", "county" : "CATAWBA" },
            "28611": { "city" : "COLLETTSVILLE", "state" : "NC", "county" : "CALDWELL" },
            "28612": { "city" : "CONNELLYS SPRINGS", "state" : "NC", "county" : "BURKE" },
            "28613": { "city" : "CONOVER", "state" : "NC", "county" : "CATAWBA" },
            "28615": { "city" : "CRESTON", "state" : "NC", "county" : "ASHE" },"28616": { "city" : "CROSSNORE", "state" : "NC", "county" : "AVERY" },
            "28617": { "city" : "CRUMPLER", "state" : "NC", "county" : "ASHE" },"28618": { "city" : "DEEP GAP", "state" : "NC", "county" : "WATAUGA" },
            "28619": { "city" : "DREXEL", "state" : "NC", "county" : "BURKE" },"28621": { "city" : "ELKIN", "state" : "NC", "county" : "SURRY" },
            "28622": { "city" : "ELK PARK", "state" : "NC", "county" : "AVERY" },
            "28623": { "city" : "ENNICE", "state" : "NC", "county" : "ALLEGHANY" },
            "28624": { "city" : "FERGUSON", "state" : "NC", "county" : "WILKES" },
            "28625": { "city" : "STATESVILLE", "state" : "NC", "county" : "IREDELL" },
            "28626": { "city" : "FLEETWOOD", "state" : "NC", "county" : "ASHE" },
            "28627": { "city" : "GLADE VALLEY", "state" : "NC", "county" : "ALLEGHANY" },
            "28628": { "city" : "GLEN ALPINE", "state" : "NC", "county" : "BURKE" },
            "28629": { "city" : "GLENDALE SPRINGS", "state" : "NC", "county" : "ASHE" },
            "28630": { "city" : "GRANITE FALLS", "state" : "NC", "county" : "CALDWELL" },
            "28631": { "city" : "GRASSY CREEK", "state" : "NC", "county" : "ASHE" },
            "28633": { "city" : "LENOIR", "state" : "NC", "county" : "CALDWELL" },
            "28634": { "city" : "HARMONY", "state" : "NC", "county" : "IREDELL" },
            "28635": { "city" : "HAYS", "state" : "NC", "county" : "WILKES" },"28636": { "city" : "HIDDENITE", "state" : "NC", "county" : "ALEXANDER" },
            "28637": { "city" : "HILDEBRAN", "state" : "NC", "county" : "BURKE" },
            "28638": { "city" : "HUDSON", "state" : "NC", "county" : "CALDWELL" },
            "28640": { "city" : "JEFFERSON", "state" : "NC", "county" : "ASHE" },
            "28641": { "city" : "JONAS RIDGE", "state" : "NC", "county" : "BURKE" },
            "28642": { "city" : "JONESVILLE", "state" : "NC", "county" : "YADKIN" },
            "28643": { "city" : "LANSING", "state" : "NC", "county" : "ASHE" },"28644": { "city" : "LAUREL SPRINGS", "state" : "NC", "county" : "ALLEGHANY" },
            "28645": { "city" : "LENOIR", "state" : "NC", "county" : "CALDWELL" },
            "28646": { "city" : "LINVILLE", "state" : "NC", "county" : "AVERY" },
            "28647": { "city" : "LINVILLE FALLS", "state" : "NC", "county" : "BURKE" },
            "28649": { "city" : "MC GRADY", "state" : "NC", "county" : "WILKES" },
            "28650": { "city" : "MAIDEN", "state" : "NC", "county" : "CATAWBA" },
            "28651": { "city" : "MILLERS CREEK", "state" : "NC", "county" : "WILKES" },
            "28652": { "city" : "MINNEAPOLIS", "state" : "NC", "county" : "AVERY" },
            "28653": { "city" : "MONTEZUMA", "state" : "NC", "county" : "AVERY" },
            "28654": { "city" : "MORAVIAN FALLS", "state" : "NC", "county" : "WILKES" },
            "28655": { "city" : "MORGANTON", "state" : "NC", "county" : "BURKE" },
            "28656": { "city" : "NORTH WILKESBORO", "state" : "NC", "county" : "WILKES" },
            "28657": { "city" : "NEWLAND", "state" : "NC", "county" : "AVERY" },"28658": { "city" : "NEWTON", "state" : "NC", "county" : "CATAWBA" },
            "28659": { "city" : "NORTH WILKESBORO", "state" : "NC", "county" : "WILKES" },
            "28660": { "city" : "OLIN", "state" : "NC", "county" : "IREDELL" },"28661": { "city" : "PATTERSON", "state" : "NC", "county" : "CALDWELL" },
            "28662": { "city" : "PINEOLA", "state" : "NC", "county" : "AVERY" },"28663": { "city" : "PINEY CREEK", "state" : "NC", "county" : "ALLEGHANY" },
            "28664": { "city" : "PLUMTREE", "state" : "NC", "county" : "AVERY" },
            "28665": { "city" : "PURLEAR", "state" : "NC", "county" : "WILKES" },
            "28666": { "city" : "ICARD", "state" : "NC", "county" : "BURKE" },"28667": { "city" : "RHODHISS", "state" : "NC", "county" : "CALDWELL" },
            "28668": { "city" : "ROARING GAP", "state" : "NC", "county" : "ALLEGHANY" },
            "28669": { "city" : "ROARING RIVER", "state" : "NC", "county" : "WILKES" },
            "28670": { "city" : "RONDA", "state" : "NC", "county" : "WILKES" },"28671": { "city" : "RUTHERFORD COLLEGE", "state" : "NC", "county" : "BURKE" },
            "28672": { "city" : "SCOTTVILLE", "state" : "NC", "county" : "ASHE" },
            "28673": { "city" : "SHERRILLS FORD", "state" : "NC", "county" : "CATAWBA" },
            "28675": { "city" : "SPARTA", "state" : "NC", "county" : "ALLEGHANY" },
            "28676": { "city" : "STATE ROAD", "state" : "NC", "county" : "SURRY" },
            "28677": { "city" : "STATESVILLE", "state" : "NC", "county" : "IREDELL" },
            "28678": { "city" : "STONY POINT", "state" : "NC", "county" : "ALEXANDER" },
            "28679": { "city" : "SUGAR GROVE", "state" : "NC", "county" : "WATAUGA" },
            "28680": { "city" : "MORGANTON", "state" : "NC", "county" : "BURKE" },
            "28681": { "city" : "TAYLORSVILLE", "state" : "NC", "county" : "ALEXANDER" },
            "28682": { "city" : "TERRELL", "state" : "NC", "county" : "CATAWBA" },
            "28683": { "city" : "THURMOND", "state" : "NC", "county" : "WILKES" },
            "28684": { "city" : "TODD", "state" : "NC", "county" : "ASHE" },"28685": { "city" : "TRAPHILL", "state" : "NC", "county" : "WILKES" },
            "28687": { "city" : "STATESVILLE", "state" : "NC", "county" : "IREDELL" },
            "28689": { "city" : "UNION GROVE", "state" : "NC", "county" : "IREDELL" },
            "28690": { "city" : "VALDESE", "state" : "NC", "county" : "BURKE" },"28691": { "city" : "VALLE CRUCIS", "state" : "NC", "county" : "WATAUGA" },
            "28692": { "city" : "VILAS", "state" : "NC", "county" : "WATAUGA" },"28693": { "city" : "WARRENSVILLE", "state" : "NC", "county" : "ASHE" },
            "28694": { "city" : "WEST JEFFERSON", "state" : "NC", "county" : "ASHE" },
            "28697": { "city" : "WILKESBORO", "state" : "NC", "county" : "WILKES" },
            "28698": { "city" : "ZIONVILLE", "state" : "NC", "county" : "WATAUGA" },
            "28699": { "city" : "SCOTTS", "state" : "NC", "county" : "IREDELL" },
            "28701": { "city" : "ALEXANDER", "state" : "NC", "county" : "BUNCOMBE" },
            "28702": { "city" : "ALMOND", "state" : "NC", "county" : "SWAIN" },"28704": { "city" : "ARDEN", "state" : "NC", "county" : "BUNCOMBE" },
            "28705": { "city" : "BAKERSVILLE", "state" : "NC", "county" : "MITCHELL" },
            "28707": { "city" : "BALSAM", "state" : "NC", "county" : "JACKSON" },
            "28708": { "city" : "BALSAM GROVE", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28709": { "city" : "BARNARDSVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28710": { "city" : "BAT CAVE", "state" : "NC", "county" : "HENDERSON" },
            "28711": { "city" : "BLACK MOUNTAIN", "state" : "NC", "county" : "BUNCOMBE" },
            "28712": { "city" : "BREVARD", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28713": { "city" : "BRYSON CITY", "state" : "NC", "county" : "SWAIN" },
            "28714": { "city" : "BURNSVILLE", "state" : "NC", "county" : "YANCEY" },
            "28715": { "city" : "CANDLER", "state" : "NC", "county" : "BUNCOMBE" },
            "28716": { "city" : "CANTON", "state" : "NC", "county" : "HAYWOOD" },
            "28717": { "city" : "CASHIERS", "state" : "NC", "county" : "JACKSON" },
            "28718": { "city" : "CEDAR MOUNTAIN", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28719": { "city" : "CHEROKEE", "state" : "NC", "county" : "SWAIN" },
            "28720": { "city" : "CHIMNEY ROCK", "state" : "NC", "county" : "RUTHERFORD" },
            "28721": { "city" : "CLYDE", "state" : "NC", "county" : "HAYWOOD" },"28722": { "city" : "COLUMBUS", "state" : "NC", "county" : "POLK" },
            "28723": { "city" : "CULLOWHEE", "state" : "NC", "county" : "JACKSON" },
            "28724": { "city" : "DANA", "state" : "NC", "county" : "HENDERSON" },
            "28725": { "city" : "DILLSBORO", "state" : "NC", "county" : "JACKSON" },
            "28726": { "city" : "EAST FLAT ROCK", "state" : "NC", "county" : "HENDERSON" },
            "28727": { "city" : "EDNEYVILLE", "state" : "NC", "county" : "HENDERSON" },
            "28728": { "city" : "ENKA", "state" : "NC", "county" : "BUNCOMBE" },"28729": { "city" : "ETOWAH", "state" : "NC", "county" : "HENDERSON" },
            "28730": { "city" : "FAIRVIEW", "state" : "NC", "county" : "BUNCOMBE" },
            "28731": { "city" : "FLAT ROCK", "state" : "NC", "county" : "HENDERSON" },
            "28732": { "city" : "FLETCHER", "state" : "NC", "county" : "HENDERSON" },
            "28733": { "city" : "FONTANA DAM", "state" : "NC", "county" : "GRAHAM" },
            "28734": { "city" : "FRANKLIN", "state" : "NC", "county" : "MACON" },
            "28735": { "city" : "GERTON", "state" : "NC", "county" : "HENDERSON" },
            "28736": { "city" : "GLENVILLE", "state" : "NC", "county" : "JACKSON" },
            "28737": { "city" : "GLENWOOD", "state" : "NC", "county" : "MCDOWELL" },
            "28738": { "city" : "HAZELWOOD", "state" : "NC", "county" : "HAYWOOD" },
            "28739": { "city" : "HENDERSONVILLE", "state" : "NC", "county" : "HENDERSON" },
            "28740": { "city" : "GREEN MOUNTAIN", "state" : "NC", "county" : "YANCEY" },
            "28741": { "city" : "HIGHLANDS", "state" : "NC", "county" : "MACON" },
            "28742": { "city" : "HORSE SHOE", "state" : "NC", "county" : "HENDERSON" },
            "28743": { "city" : "HOT SPRINGS", "state" : "NC", "county" : "MADISON" },
            "28744": { "city" : "FRANKLIN", "state" : "NC", "county" : "MACON" },
            "28745": { "city" : "LAKE JUNALUSKA", "state" : "NC", "county" : "HAYWOOD" },
            "28746": { "city" : "LAKE LURE", "state" : "NC", "county" : "RUTHERFORD" },
            "28747": { "city" : "LAKE TOXAWAY", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28748": { "city" : "LEICESTER", "state" : "NC", "county" : "BUNCOMBE" },
            "28749": { "city" : "LITTLE SWITZERLAND", "state" : "NC", "county" : "MCDOWELL" },
            "28750": { "city" : "LYNN", "state" : "NC", "county" : "POLK" },"28751": { "city" : "MAGGIE VALLEY", "state" : "NC", "county" : "HAYWOOD" },
            "28752": { "city" : "MARION", "state" : "NC", "county" : "MCDOWELL" },
            "28753": { "city" : "MARSHALL", "state" : "NC", "county" : "MADISON" },
            "28754": { "city" : "MARS HILL", "state" : "NC", "county" : "MADISON" },
            "28755": { "city" : "MICAVILLE", "state" : "NC", "county" : "YANCEY" },
            "28756": { "city" : "MILL SPRING", "state" : "NC", "county" : "POLK" },
            "28757": { "city" : "MONTREAT", "state" : "NC", "county" : "BUNCOMBE" },
            "28758": { "city" : "MOUNTAIN HOME", "state" : "NC", "county" : "HENDERSON" },
            "28759": { "city" : "MILLS RIVER", "state" : "NC", "county" : "HENDERSON" },
            "28760": { "city" : "NAPLES", "state" : "NC", "county" : "HENDERSON" },
            "28761": { "city" : "NEBO", "state" : "NC", "county" : "MCDOWELL" },"28762": { "city" : "OLD FORT", "state" : "NC", "county" : "MCDOWELL" },
            "28763": { "city" : "OTTO", "state" : "NC", "county" : "MACON" },"28765": { "city" : "PENLAND", "state" : "NC", "county" : "MITCHELL" },
            "28766": { "city" : "PENROSE", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28768": { "city" : "PISGAH FOREST", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28770": { "city" : "RIDGECREST", "state" : "NC", "county" : "BUNCOMBE" },
            "28771": { "city" : "ROBBINSVILLE", "state" : "NC", "county" : "GRAHAM" },
            "28772": { "city" : "ROSMAN", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28773": { "city" : "SALUDA", "state" : "NC", "county" : "POLK" },"28774": { "city" : "SAPPHIRE", "state" : "NC", "county" : "TRANSYLVANIA" },
            "28775": { "city" : "SCALY MOUNTAIN", "state" : "NC", "county" : "MACON" },
            "28776": { "city" : "SKYLAND", "state" : "NC", "county" : "BUNCOMBE" },
            "28777": { "city" : "SPRUCE PINE", "state" : "NC", "county" : "MITCHELL" },
            "28778": { "city" : "SWANNANOA", "state" : "NC", "county" : "BUNCOMBE" },
            "28779": { "city" : "SYLVA", "state" : "NC", "county" : "JACKSON" },"28781": { "city" : "TOPTON", "state" : "NC", "county" : "CHEROKEE" },
            "28782": { "city" : "TRYON", "state" : "NC", "county" : "POLK" },"28783": { "city" : "TUCKASEGEE", "state" : "NC", "county" : "JACKSON" },
            "28784": { "city" : "TUXEDO", "state" : "NC", "county" : "HENDERSON" },
            "28785": { "city" : "WAYNESVILLE", "state" : "NC", "county" : "HAYWOOD" },
            "28786": { "city" : "WAYNESVILLE", "state" : "NC", "county" : "HAYWOOD" },
            "28787": { "city" : "WEAVERVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28788": { "city" : "WEBSTER", "state" : "NC", "county" : "JACKSON" },
            "28789": { "city" : "WHITTIER", "state" : "NC", "county" : "JACKSON" },
            "28790": { "city" : "ZIRCONIA", "state" : "NC", "county" : "HENDERSON" },
            "28791": { "city" : "HENDERSONVILLE", "state" : "NC", "county" : "HENDERSON" },
            "28792": { "city" : "HENDERSONVILLE", "state" : "NC", "county" : "HENDERSON" },
            "28793": { "city" : "HENDERSONVILLE", "state" : "NC", "county" : "HENDERSON" },
            "28801": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28802": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28803": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28804": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28805": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28806": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28810": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28813": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28814": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28815": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28816": { "city" : "ASHEVILLE", "state" : "NC", "county" : "BUNCOMBE" },
            "28901": { "city" : "ANDREWS", "state" : "NC", "county" : "CHEROKEE" },
            "28902": { "city" : "BRASSTOWN", "state" : "NC", "county" : "CLAY" },
            "28904": { "city" : "HAYESVILLE", "state" : "NC", "county" : "CLAY" },
            "28905": { "city" : "MARBLE", "state" : "NC", "county" : "CHEROKEE" },
            "28906": { "city" : "MURPHY", "state" : "NC", "county" : "CHEROKEE" },
            "28909": { "city" : "WARNE", "state" : "NC", "county" : "CLAY" },"29001": { "city" : "ALCOLU", "state" : "SC", "county" : "CLARENDON" },
            "29002": { "city" : "BALLENTINE", "state" : "SC", "county" : "RICHLAND" },
            "29003": { "city" : "BAMBERG", "state" : "SC", "county" : "BAMBERG" },
            "29006": { "city" : "BATESBURG", "state" : "SC", "county" : "LEXINGTON" },
            "29009": { "city" : "BETHUNE", "state" : "SC", "county" : "KERSHAW" },
            "29010": { "city" : "BISHOPVILLE", "state" : "SC", "county" : "LEE" },
            "29014": { "city" : "BLACKSTOCK", "state" : "SC", "county" : "CHESTER" },
            "29015": { "city" : "BLAIR", "state" : "SC", "county" : "FAIRFIELD" },
            "29016": { "city" : "BLYTHEWOOD", "state" : "SC", "county" : "RICHLAND" },
            "29018": { "city" : "BOWMAN", "state" : "SC", "county" : "ORANGEBURG" },
            "29020": { "city" : "CAMDEN", "state" : "SC", "county" : "KERSHAW" },
            "29021": { "city" : "CAMDEN", "state" : "SC", "county" : "KERSHAW" },
            "29030": { "city" : "CAMERON", "state" : "SC", "county" : "CALHOUN" },
            "29031": { "city" : "CARLISLE", "state" : "SC", "county" : "UNION" },
            "29032": { "city" : "CASSATT", "state" : "SC", "county" : "KERSHAW" },
            "29033": { "city" : "CAYCE", "state" : "SC", "county" : "LEXINGTON" },
            "29036": { "city" : "CHAPIN", "state" : "SC", "county" : "LEXINGTON" },
            "29037": { "city" : "CHAPPELLS", "state" : "SC", "county" : "NEWBERRY" },
            "29038": { "city" : "COPE", "state" : "SC", "county" : "ORANGEBURG" },
            "29039": { "city" : "CORDOVA", "state" : "SC", "county" : "ORANGEBURG" },
            "29040": { "city" : "DALZELL", "state" : "SC", "county" : "SUMTER" },
            "29041": { "city" : "DAVIS STATION", "state" : "SC", "county" : "CLARENDON" },
            "29042": { "city" : "DENMARK", "state" : "SC", "county" : "BAMBERG" },
            "29044": { "city" : "EASTOVER", "state" : "SC", "county" : "RICHLAND" },
            "29045": { "city" : "ELGIN", "state" : "SC", "county" : "KERSHAW" },"29046": { "city" : "ELLIOTT", "state" : "SC", "county" : "LEE" },
            "29047": { "city" : "ELLOREE", "state" : "SC", "county" : "ORANGEBURG" },
            "29048": { "city" : "EUTAWVILLE", "state" : "SC", "county" : "ORANGEBURG" },
            "29051": { "city" : "GABLE", "state" : "SC", "county" : "CLARENDON" },
            "29052": { "city" : "GADSDEN", "state" : "SC", "county" : "RICHLAND" },
            "29053": { "city" : "GASTON", "state" : "SC", "county" : "LEXINGTON" },
            "29054": { "city" : "GILBERT", "state" : "SC", "county" : "LEXINGTON" },
            "29055": { "city" : "GREAT FALLS", "state" : "SC", "county" : "CHESTER" },
            "29056": { "city" : "GREELEYVILLE", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29058": { "city" : "HEATH SPRINGS", "state" : "SC", "county" : "LANCASTER" },
            "29059": { "city" : "HOLLY HILL", "state" : "SC", "county" : "ORANGEBURG" },
            "29061": { "city" : "HOPKINS", "state" : "SC", "county" : "RICHLAND" },
            "29062": { "city" : "HORATIO", "state" : "SC", "county" : "SUMTER" },
            "29063": { "city" : "IRMO", "state" : "SC", "county" : "RICHLAND" },"29065": { "city" : "JENKINSVILLE", "state" : "SC", "county" : "FAIRFIELD" },
            "29067": { "city" : "KERSHAW", "state" : "SC", "county" : "LANCASTER" },
            "29069": { "city" : "LAMAR", "state" : "SC", "county" : "DARLINGTON" },
            "29070": { "city" : "LEESVILLE", "state" : "SC", "county" : "LEXINGTON" },
            "29071": { "city" : "LEXINGTON", "state" : "SC", "county" : "LEXINGTON" },
            "29072": { "city" : "LEXINGTON", "state" : "SC", "county" : "LEXINGTON" },
            "29073": { "city" : "LEXINGTON", "state" : "SC", "county" : "LEXINGTON" },
            "29074": { "city" : "LIBERTY HILL", "state" : "SC", "county" : "KERSHAW" },
            "29075": { "city" : "LITTLE MOUNTAIN", "state" : "SC", "county" : "NEWBERRY" },
            "29078": { "city" : "LUGOFF", "state" : "SC", "county" : "KERSHAW" },
            "29079": { "city" : "LYDIA", "state" : "SC", "county" : "DARLINGTON" },
            "29080": { "city" : "LYNCHBURG", "state" : "SC", "county" : "LEE" },"29081": { "city" : "EHRHARDT", "state" : "SC", "county" : "BAMBERG" },
            "29082": { "city" : "LODGE", "state" : "SC", "county" : "COLLETON" },
            "29101": { "city" : "MC BEE", "state" : "SC", "county" : "CHESTERFIELD" },
            "29102": { "city" : "MANNING", "state" : "SC", "county" : "CLARENDON" },
            "29104": { "city" : "MAYESVILLE", "state" : "SC", "county" : "SUMTER" },
            "29105": { "city" : "MONETTA", "state" : "SC", "county" : "AIKEN" },"29107": { "city" : "NEESES", "state" : "SC", "county" : "ORANGEBURG" },
            "29108": { "city" : "NEWBERRY", "state" : "SC", "county" : "NEWBERRY" },
            "29111": { "city" : "NEW ZION", "state" : "SC", "county" : "CLARENDON" },
            "29112": { "city" : "NORTH", "state" : "SC", "county" : "ORANGEBURG" },
            "29113": { "city" : "NORWAY", "state" : "SC", "county" : "ORANGEBURG" },
            "29114": { "city" : "OLANTA", "state" : "SC", "county" : "FLORENCE" },
            "29115": { "city" : "ORANGEBURG", "state" : "SC", "county" : "ORANGEBURG" },
            "29116": { "city" : "ORANGEBURG", "state" : "SC", "county" : "ORANGEBURG" },
            "29117": { "city" : "ORANGEBURG", "state" : "SC", "county" : "ORANGEBURG" },
            "29118": { "city" : "ORANGEBURG", "state" : "SC", "county" : "ORANGEBURG" },
            "29122": { "city" : "PEAK", "state" : "SC", "county" : "NEWBERRY" },"29123": { "city" : "PELION", "state" : "SC", "county" : "LEXINGTON" },
            "29125": { "city" : "PINEWOOD", "state" : "SC", "county" : "SUMTER" },
            "29126": { "city" : "POMARIA", "state" : "SC", "county" : "NEWBERRY" },
            "29127": { "city" : "PROSPERITY", "state" : "SC", "county" : "NEWBERRY" },
            "29128": { "city" : "REMBERT", "state" : "SC", "county" : "SUMTER" },
            "29129": { "city" : "RIDGE SPRING", "state" : "SC", "county" : "SALUDA" },
            "29130": { "city" : "RIDGEWAY", "state" : "SC", "county" : "FAIRFIELD" },
            "29133": { "city" : "ROWESVILLE", "state" : "SC", "county" : "ORANGEBURG" },
            "29135": { "city" : "SAINT MATTHEWS", "state" : "SC", "county" : "CALHOUN" },
            "29137": { "city" : "SALLEY", "state" : "SC", "county" : "AIKEN" },"29138": { "city" : "SALUDA", "state" : "SC", "county" : "SALUDA" },
            "29142": { "city" : "SANTEE", "state" : "SC", "county" : "ORANGEBURG" },
            "29145": { "city" : "SILVERSTREET", "state" : "SC", "county" : "NEWBERRY" },
            "29146": { "city" : "SPRINGFIELD", "state" : "SC", "county" : "ORANGEBURG" },
            "29147": { "city" : "STATE PARK", "state" : "SC", "county" : "RICHLAND" },
            "29148": { "city" : "SUMMERTON", "state" : "SC", "county" : "CLARENDON" },
            "29150": { "city" : "SUMTER", "state" : "SC", "county" : "SUMTER" },"29151": { "city" : "SUMTER", "state" : "SC", "county" : "SUMTER" },
            "29152": { "city" : "SHAW A F B", "state" : "SC", "county" : "SUMTER" },
            "29153": { "city" : "SUMTER", "state" : "SC", "county" : "SUMTER" },"29154": { "city" : "SUMTER", "state" : "SC", "county" : "SUMTER" },
            "29160": { "city" : "SWANSEA", "state" : "SC", "county" : "LEXINGTON" },
            "29161": { "city" : "TIMMONSVILLE", "state" : "SC", "county" : "FLORENCE" },
            "29162": { "city" : "TURBEVILLE", "state" : "SC", "county" : "CLARENDON" },
            "29163": { "city" : "VANCE", "state" : "SC", "county" : "ORANGEBURG" },
            "29164": { "city" : "WAGENER", "state" : "SC", "county" : "AIKEN" },"29166": { "city" : "WARD", "state" : "SC", "county" : "SALUDA" },
            "29168": { "city" : "WEDGEFIELD", "state" : "SC", "county" : "SUMTER" },
            "29169": { "city" : "WEST COLUMBIA", "state" : "SC", "county" : "LEXINGTON" },
            "29170": { "city" : "WEST COLUMBIA", "state" : "SC", "county" : "LEXINGTON" },
            "29171": { "city" : "WEST COLUMBIA", "state" : "SC", "county" : "LEXINGTON" },
            "29172": { "city" : "WEST COLUMBIA", "state" : "SC", "county" : "LEXINGTON" },
            "29175": { "city" : "WESTVILLE", "state" : "SC", "county" : "KERSHAW" },
            "29177": { "city" : "WHITE ROCK", "state" : "SC", "county" : "RICHLAND" },
            "29178": { "city" : "WHITMIRE", "state" : "SC", "county" : "NEWBERRY" },
            "29180": { "city" : "WINNSBORO", "state" : "SC", "county" : "FAIRFIELD" },
            "29201": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29202": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29203": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29204": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29205": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29206": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29207": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29208": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29209": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29210": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29211": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29212": { "city" : "COLUMBIA", "state" : "SC", "county" : "LEXINGTON" },
            "29214": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29215": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29216": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29217": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29218": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29219": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29220": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29221": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29222": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29223": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29224": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29225": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29226": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29227": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29228": { "city" : "COLUMBIA", "state" : "SC", "county" : "LEXINGTON" },
            "29229": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29230": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29240": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29250": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29260": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29290": { "city" : "COLUMBIA", "state" : "SC", "county" : "RICHLAND" },
            "29301": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29302": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29303": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29304": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29305": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29306": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29307": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29316": { "city" : "BOILING SPRINGS", "state" : "SC", "county" : "SPARTANBURG" },
            "29318": { "city" : "BOILING SPRINGS", "state" : "SC", "county" : "SPARTANBURG" },
            "29319": { "city" : "SPARTANBURG", "state" : "SC", "county" : "SPARTANBURG" },
            "29320": { "city" : "ARCADIA", "state" : "SC", "county" : "SPARTANBURG" },
            "29321": { "city" : "BUFFALO", "state" : "SC", "county" : "UNION" },"29322": { "city" : "CAMPOBELLO", "state" : "SC", "county" : "SPARTANBURG" },
            "29323": { "city" : "CHESNEE", "state" : "SC", "county" : "SPARTANBURG" },
            "29324": { "city" : "CLIFTON", "state" : "SC", "county" : "SPARTANBURG" },
            "29325": { "city" : "CLINTON", "state" : "SC", "county" : "LAURENS" },
            "29329": { "city" : "CONVERSE", "state" : "SC", "county" : "SPARTANBURG" },
            "29330": { "city" : "COWPENS", "state" : "SC", "county" : "SPARTANBURG" },
            "29331": { "city" : "CROSS ANCHOR", "state" : "SC", "county" : "SPARTANBURG" },
            "29332": { "city" : "CROSS HILL", "state" : "SC", "county" : "LAURENS" },
            "29333": { "city" : "DRAYTON", "state" : "SC", "county" : "SPARTANBURG" },
            "29334": { "city" : "DUNCAN", "state" : "SC", "county" : "SPARTANBURG" },
            "29335": { "city" : "ENOREE", "state" : "SC", "county" : "SPARTANBURG" },
            "29336": { "city" : "FAIRFOREST", "state" : "SC", "county" : "SPARTANBURG" },
            "29338": { "city" : "FINGERVILLE", "state" : "SC", "county" : "SPARTANBURG" },
            "29340": { "city" : "GAFFNEY", "state" : "SC", "county" : "CHEROKEE" },
            "29341": { "city" : "GAFFNEY", "state" : "SC", "county" : "CHEROKEE" },
            "29342": { "city" : "GAFFNEY", "state" : "SC", "county" : "CHEROKEE" },
            "29346": { "city" : "GLENDALE", "state" : "SC", "county" : "SPARTANBURG" },
            "29348": { "city" : "GRAMLING", "state" : "SC", "county" : "SPARTANBURG" },
            "29349": { "city" : "INMAN", "state" : "SC", "county" : "SPARTANBURG" },
            "29351": { "city" : "JOANNA", "state" : "SC", "county" : "LAURENS" },
            "29353": { "city" : "JONESVILLE", "state" : "SC", "county" : "UNION" },
            "29355": { "city" : "KINARDS", "state" : "SC", "county" : "NEWBERRY" },
            "29356": { "city" : "LANDRUM", "state" : "SC", "county" : "SPARTANBURG" },
            "29360": { "city" : "LAURENS", "state" : "SC", "county" : "LAURENS" },
            "29364": { "city" : "LOCKHART", "state" : "SC", "county" : "UNION" },
            "29365": { "city" : "LYMAN", "state" : "SC", "county" : "SPARTANBURG" },
            "29368": { "city" : "MAYO", "state" : "SC", "county" : "SPARTANBURG" },
            "29369": { "city" : "MOORE", "state" : "SC", "county" : "SPARTANBURG" },
            "29370": { "city" : "MOUNTVILLE", "state" : "SC", "county" : "LAURENS" },
            "29372": { "city" : "PACOLET", "state" : "SC", "county" : "SPARTANBURG" },
            "29373": { "city" : "PACOLET MILLS", "state" : "SC", "county" : "SPARTANBURG" },
            "29374": { "city" : "PAULINE", "state" : "SC", "county" : "SPARTANBURG" },
            "29375": { "city" : "REIDVILLE", "state" : "SC", "county" : "SPARTANBURG" },
            "29376": { "city" : "ROEBUCK", "state" : "SC", "county" : "SPARTANBURG" },
            "29377": { "city" : "STARTEX", "state" : "SC", "county" : "SPARTANBURG" },
            "29378": { "city" : "UNA", "state" : "SC", "county" : "SPARTANBURG" },
            "29379": { "city" : "UNION", "state" : "SC", "county" : "UNION" },"29384": { "city" : "WATERLOO", "state" : "SC", "county" : "LAURENS" },
            "29385": { "city" : "WELLFORD", "state" : "SC", "county" : "SPARTANBURG" },
            "29386": { "city" : "WHITE STONE", "state" : "SC", "county" : "SPARTANBURG" },
            "29388": { "city" : "WOODRUFF", "state" : "SC", "county" : "SPARTANBURG" },
            "29395": { "city" : "JONESVILLE", "state" : "SC", "county" : "UNION" },
            "29401": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29402": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29403": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29404": { "city" : "CHARLESTON AFB", "state" : "SC", "county" : "CHARLESTON" },
            "29405": { "city" : "NORTH CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29406": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29407": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29409": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29410": { "city" : "HANAHAN", "state" : "SC", "county" : "BERKELEY" },
            "29412": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29413": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29414": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29415": { "city" : "NORTH CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29416": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29417": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29418": { "city" : "NORTH CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29419": { "city" : "NORTH CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29420": { "city" : "NORTH CHARLESTON", "state" : "SC", "county" : "DORCHESTER" },
            "29422": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29423": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29424": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29425": { "city" : "CHARLESTON", "state" : "SC", "county" : "CHARLESTON" },
            "29426": { "city" : "ADAMS RUN", "state" : "SC", "county" : "CHARLESTON" },
            "29429": { "city" : "AWENDAW", "state" : "SC", "county" : "CHARLESTON" },
            "29431": { "city" : "BONNEAU", "state" : "SC", "county" : "BERKELEY" },
            "29432": { "city" : "BRANCHVILLE", "state" : "SC", "county" : "ORANGEBURG" },
            "29433": { "city" : "CANADYS", "state" : "SC", "county" : "COLLETON" },
            "29434": { "city" : "CORDESVILLE", "state" : "SC", "county" : "BERKELEY" },
            "29435": { "city" : "COTTAGEVILLE", "state" : "SC", "county" : "COLLETON" },
            "29436": { "city" : "CROSS", "state" : "SC", "county" : "BERKELEY" },
            "29437": { "city" : "DORCHESTER", "state" : "SC", "county" : "DORCHESTER" },
            "29438": { "city" : "EDISTO ISLAND", "state" : "SC", "county" : "COLLETON" },
            "29439": { "city" : "FOLLY BEACH", "state" : "SC", "county" : "CHARLESTON" },
            "29440": { "city" : "GEORGETOWN", "state" : "SC", "county" : "GEORGETOWN" },
            "29442": { "city" : "GEORGETOWN", "state" : "SC", "county" : "GEORGETOWN" },
            "29445": { "city" : "GOOSE CREEK", "state" : "SC", "county" : "BERKELEY" },
            "29446": { "city" : "GREEN POND", "state" : "SC", "county" : "COLLETON" },
            "29447": { "city" : "GROVER", "state" : "SC", "county" : "DORCHESTER" },
            "29448": { "city" : "HARLEYVILLE", "state" : "SC", "county" : "DORCHESTER" },
            "29449": { "city" : "HOLLYWOOD", "state" : "SC", "county" : "CHARLESTON" },
            "29450": { "city" : "HUGER", "state" : "SC", "county" : "BERKELEY" },
            "29451": { "city" : "ISLE OF PALMS", "state" : "SC", "county" : "CHARLESTON" },
            "29452": { "city" : "JACKSONBORO", "state" : "SC", "county" : "COLLETON" },
            "29453": { "city" : "JAMESTOWN", "state" : "SC", "county" : "BERKELEY" },
            "29455": { "city" : "JOHNS ISLAND", "state" : "SC", "county" : "CHARLESTON" },
            "29456": { "city" : "LADSON", "state" : "SC", "county" : "BERKELEY" },
            "29457": { "city" : "JOHNS ISLAND", "state" : "SC", "county" : "CHARLESTON" },
            "29458": { "city" : "MC CLELLANVILLE", "state" : "SC", "county" : "CHARLESTON" },
            "29461": { "city" : "MONCKS CORNER", "state" : "SC", "county" : "BERKELEY" },
            "29464": { "city" : "MOUNT PLEASANT", "state" : "SC", "county" : "CHARLESTON" },
            "29465": { "city" : "MOUNT PLEASANT", "state" : "SC", "county" : "CHARLESTON" },
            "29466": { "city" : "MOUNT PLEASANT", "state" : "SC", "county" : "CHARLESTON" },
            "29468": { "city" : "PINEVILLE", "state" : "SC", "county" : "BERKELEY" },
            "29469": { "city" : "PINOPOLIS", "state" : "SC", "county" : "BERKELEY" },
            "29470": { "city" : "RAVENEL", "state" : "SC", "county" : "CHARLESTON" },
            "29471": { "city" : "REEVESVILLE", "state" : "SC", "county" : "DORCHESTER" },
            "29472": { "city" : "RIDGEVILLE", "state" : "SC", "county" : "DORCHESTER" },
            "29474": { "city" : "ROUND O", "state" : "SC", "county" : "COLLETON" },
            "29475": { "city" : "RUFFIN", "state" : "SC", "county" : "COLLETON" },
            "29476": { "city" : "RUSSELLVILLE", "state" : "SC", "county" : "BERKELEY" },
            "29477": { "city" : "SAINT GEORGE", "state" : "SC", "county" : "DORCHESTER" },
            "29479": { "city" : "SAINT STEPHEN", "state" : "SC", "county" : "BERKELEY" },
            "29481": { "city" : "SMOAKS", "state" : "SC", "county" : "COLLETON" },
            "29482": { "city" : "SULLIVANS ISLAND", "state" : "SC", "county" : "CHARLESTON" },
            "29483": { "city" : "SUMMERVILLE", "state" : "SC", "county" : "DORCHESTER" },
            "29484": { "city" : "SUMMERVILLE", "state" : "SC", "county" : "DORCHESTER" },
            "29485": { "city" : "SUMMERVILLE", "state" : "SC", "county" : "DORCHESTER" },
            "29487": { "city" : "WADMALAW ISLAND", "state" : "SC", "county" : "CHARLESTON" },
            "29488": { "city" : "WALTERBORO", "state" : "SC", "county" : "COLLETON" },
            "29492": { "city" : "CHARLESTON", "state" : "SC", "county" : "BERKELEY" },
            "29493": { "city" : "WILLIAMS", "state" : "SC", "county" : "COLLETON" },
            "29501": { "city" : "FLORENCE", "state" : "SC", "county" : "FLORENCE" },
            "29502": { "city" : "FLORENCE", "state" : "SC", "county" : "FLORENCE" },
            "29503": { "city" : "FLORENCE", "state" : "SC", "county" : "FLORENCE" },
            "29504": { "city" : "FLORENCE", "state" : "SC", "county" : "FLORENCE" },
            "29505": { "city" : "FLORENCE", "state" : "SC", "county" : "FLORENCE" },
            "29506": { "city" : "FLORENCE", "state" : "SC", "county" : "FLORENCE" },
            "29510": { "city" : "ANDREWS", "state" : "SC", "county" : "GEORGETOWN" },
            "29511": { "city" : "AYNOR", "state" : "SC", "county" : "HORRY" },"29512": { "city" : "BENNETTSVILLE", "state" : "SC", "county" : "MARLBORO" },
            "29516": { "city" : "BLENHEIM", "state" : "SC", "county" : "MARLBORO" },
            "29518": { "city" : "CADES", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29519": { "city" : "CENTENARY", "state" : "SC", "county" : "MARION" },
            "29520": { "city" : "CHERAW", "state" : "SC", "county" : "CHESTERFIELD" },
            "29525": { "city" : "CLIO", "state" : "SC", "county" : "MARLBORO" },"29526": { "city" : "CONWAY", "state" : "SC", "county" : "HORRY" },
            "29527": { "city" : "CONWAY", "state" : "SC", "county" : "HORRY" },"29528": { "city" : "CONWAY", "state" : "SC", "county" : "HORRY" },
            "29530": { "city" : "COWARD", "state" : "SC", "county" : "FLORENCE" },
            "29532": { "city" : "DARLINGTON", "state" : "SC", "county" : "DARLINGTON" },
            "29536": { "city" : "DILLON", "state" : "SC", "county" : "DILLON" },"29540": { "city" : "DARLINGTON", "state" : "SC", "county" : "DARLINGTON" },
            "29541": { "city" : "EFFINGHAM", "state" : "SC", "county" : "FLORENCE" },
            "29543": { "city" : "FORK", "state" : "SC", "county" : "DILLON" },"29544": { "city" : "GALIVANTS FERRY", "state" : "SC", "county" : "HORRY" },
            "29545": { "city" : "GREEN SEA", "state" : "SC", "county" : "HORRY" },
            "29546": { "city" : "GRESHAM", "state" : "SC", "county" : "MARION" },
            "29547": { "city" : "HAMER", "state" : "SC", "county" : "DILLON" },"29550": { "city" : "HARTSVILLE", "state" : "SC", "county" : "DARLINGTON" },
            "29551": { "city" : "HARTSVILLE", "state" : "SC", "county" : "DARLINGTON" },
            "29554": { "city" : "HEMINGWAY", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29555": { "city" : "JOHNSONVILLE", "state" : "SC", "county" : "FLORENCE" },
            "29556": { "city" : "KINGSTREE", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29560": { "city" : "LAKE CITY", "state" : "SC", "county" : "FLORENCE" },
            "29563": { "city" : "LAKE VIEW", "state" : "SC", "county" : "DILLON" },
            "29564": { "city" : "LANE", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29565": { "city" : "LATTA", "state" : "SC", "county" : "DILLON" },"29566": { "city" : "LITTLE RIVER", "state" : "SC", "county" : "HORRY" },
            "29567": { "city" : "LITTLE ROCK", "state" : "SC", "county" : "DILLON" },
            "29568": { "city" : "LONGS", "state" : "SC", "county" : "HORRY" },"29569": { "city" : "LORIS", "state" : "SC", "county" : "HORRY" },
            "29570": { "city" : "MC COLL", "state" : "SC", "county" : "MARLBORO" },
            "29571": { "city" : "MARION", "state" : "SC", "county" : "MARION" },"29572": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29573": { "city" : "MINTURN", "state" : "SC", "county" : "DILLON" },
            "29574": { "city" : "MULLINS", "state" : "SC", "county" : "MARION" },
            "29575": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29576": { "city" : "MURRELLS INLET", "state" : "SC", "county" : "HORRY" },
            "29577": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29578": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29579": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29580": { "city" : "NESMITH", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29581": { "city" : "NICHOLS", "state" : "SC", "county" : "HORRY" },"29582": { "city" : "NORTH MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29583": { "city" : "PAMPLICO", "state" : "SC", "county" : "FLORENCE" },
            "29584": { "city" : "PATRICK", "state" : "SC", "county" : "CHESTERFIELD" },
            "29585": { "city" : "PAWLEYS ISLAND", "state" : "SC", "county" : "GEORGETOWN" },
            "29587": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29588": { "city" : "MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29590": { "city" : "SALTERS", "state" : "SC", "county" : "WILLIAMSBURG" },
            "29591": { "city" : "SCRANTON", "state" : "SC", "county" : "FLORENCE" },
            "29592": { "city" : "SELLERS", "state" : "SC", "county" : "MARION" },
            "29593": { "city" : "SOCIETY HILL", "state" : "SC", "county" : "DARLINGTON" },
            "29594": { "city" : "TATUM", "state" : "SC", "county" : "MARLBORO" },
            "29596": { "city" : "WALLACE", "state" : "SC", "county" : "MARLBORO" },
            "29597": { "city" : "NORTH MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29598": { "city" : "NORTH MYRTLE BEACH", "state" : "SC", "county" : "HORRY" },
            "29601": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29602": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29603": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29604": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29605": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29606": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29607": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29608": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29609": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29610": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29611": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29612": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29613": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29614": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29615": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29616": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29617": { "city" : "GREENVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29620": { "city" : "ABBEVILLE", "state" : "SC", "county" : "ABBEVILLE" },
            "29621": { "city" : "ANDERSON", "state" : "SC", "county" : "ANDERSON" },
            "29622": { "city" : "ANDERSON", "state" : "SC", "county" : "ANDERSON" },
            "29623": { "city" : "ANDERSON", "state" : "SC", "county" : "ANDERSON" },
            "29624": { "city" : "ANDERSON", "state" : "SC", "county" : "ANDERSON" },
            "29625": { "city" : "ANDERSON", "state" : "SC", "county" : "ANDERSON" },
            "29626": { "city" : "ANDERSON", "state" : "SC", "county" : "ANDERSON" },
            "29627": { "city" : "BELTON", "state" : "SC", "county" : "ANDERSON" },
            "29628": { "city" : "CALHOUN FALLS", "state" : "SC", "county" : "ABBEVILLE" },
            "29630": { "city" : "CENTRAL", "state" : "SC", "county" : "PICKENS" },
            "29631": { "city" : "CLEMSON", "state" : "SC", "county" : "PICKENS" },
            "29632": { "city" : "CLEMSON", "state" : "SC", "county" : "PICKENS" },
            "29633": { "city" : "CLEMSON", "state" : "SC", "county" : "PICKENS" },
            "29634": { "city" : "CLEMSON", "state" : "SC", "county" : "PICKENS" },
            "29635": { "city" : "CLEVELAND", "state" : "SC", "county" : "GREENVILLE" },
            "29636": { "city" : "CONESTEE", "state" : "SC", "county" : "GREENVILLE" },
            "29638": { "city" : "DONALDS", "state" : "SC", "county" : "ABBEVILLE" },
            "29639": { "city" : "DUE WEST", "state" : "SC", "county" : "ABBEVILLE" },
            "29640": { "city" : "EASLEY", "state" : "SC", "county" : "PICKENS" },
            "29641": { "city" : "EASLEY", "state" : "SC", "county" : "PICKENS" },
            "29642": { "city" : "EASLEY", "state" : "SC", "county" : "PICKENS" },
            "29643": { "city" : "FAIR PLAY", "state" : "SC", "county" : "OCONEE" },
            "29644": { "city" : "FOUNTAIN INN", "state" : "SC", "county" : "GREENVILLE" },
            "29645": { "city" : "GRAY COURT", "state" : "SC", "county" : "LAURENS" },
            "29646": { "city" : "GREENWOOD", "state" : "SC", "county" : "GREENWOOD" },
            "29647": { "city" : "GREENWOOD", "state" : "SC", "county" : "GREENWOOD" },
            "29648": { "city" : "GREENWOOD", "state" : "SC", "county" : "GREENWOOD" },
            "29649": { "city" : "GREENWOOD", "state" : "SC", "county" : "GREENWOOD" },
            "29650": { "city" : "GREER", "state" : "SC", "county" : "GREENVILLE" },
            "29651": { "city" : "GREER", "state" : "SC", "county" : "GREENVILLE" },
            "29652": { "city" : "GREER", "state" : "SC", "county" : "GREENVILLE" },
            "29653": { "city" : "HODGES", "state" : "SC", "county" : "GREENWOOD" },
            "29654": { "city" : "HONEA PATH", "state" : "SC", "county" : "ANDERSON" },
            "29655": { "city" : "IVA", "state" : "SC", "county" : "ANDERSON" },"29656": { "city" : "LA FRANCE", "state" : "SC", "county" : "ANDERSON" },
            "29657": { "city" : "LIBERTY", "state" : "SC", "county" : "PICKENS" },
            "29658": { "city" : "LONG CREEK", "state" : "SC", "county" : "OCONEE" },
            "29659": { "city" : "LOWNDESVILLE", "state" : "SC", "county" : "ABBEVILLE" },
            "29661": { "city" : "MARIETTA", "state" : "SC", "county" : "GREENVILLE" },
            "29662": { "city" : "MAULDIN", "state" : "SC", "county" : "GREENVILLE" },
            "29664": { "city" : "MOUNTAIN REST", "state" : "SC", "county" : "OCONEE" },
            "29665": { "city" : "NEWRY", "state" : "SC", "county" : "OCONEE" },"29666": { "city" : "NINETY SIX", "state" : "SC", "county" : "GREENWOOD" },
            "29667": { "city" : "NORRIS", "state" : "SC", "county" : "PICKENS" },
            "29669": { "city" : "PELZER", "state" : "SC", "county" : "ANDERSON" },
            "29670": { "city" : "PENDLETON", "state" : "SC", "county" : "ANDERSON" },
            "29671": { "city" : "PICKENS", "state" : "SC", "county" : "PICKENS" },
            "29672": { "city" : "SENECA", "state" : "SC", "county" : "OCONEE" },"29673": { "city" : "PIEDMONT", "state" : "SC", "county" : "GREENVILLE" },
            "29675": { "city" : "RICHLAND", "state" : "SC", "county" : "OCONEE" },
            "29676": { "city" : "SALEM", "state" : "SC", "county" : "OCONEE" },"29677": { "city" : "SANDY SPRINGS", "state" : "SC", "county" : "ANDERSON" },
            "29678": { "city" : "SENECA", "state" : "SC", "county" : "OCONEE" },"29679": { "city" : "SENECA", "state" : "SC", "county" : "OCONEE" },
            "29680": { "city" : "SIMPSONVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29681": { "city" : "SIMPSONVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29682": { "city" : "SIX MILE", "state" : "SC", "county" : "PICKENS" },
            "29683": { "city" : "SLATER", "state" : "SC", "county" : "GREENVILLE" },
            "29684": { "city" : "STARR", "state" : "SC", "county" : "ANDERSON" },
            "29685": { "city" : "SUNSET", "state" : "SC", "county" : "PICKENS" },
            "29686": { "city" : "TAMASSEE", "state" : "SC", "county" : "OCONEE" },
            "29687": { "city" : "TAYLORS", "state" : "SC", "county" : "GREENVILLE" },
            "29688": { "city" : "TIGERVILLE", "state" : "SC", "county" : "GREENVILLE" },
            "29689": { "city" : "TOWNVILLE", "state" : "SC", "county" : "ANDERSON" },
            "29690": { "city" : "TRAVELERS REST", "state" : "SC", "county" : "GREENVILLE" },
            "29691": { "city" : "WALHALLA", "state" : "SC", "county" : "OCONEE" },
            "29692": { "city" : "WARE SHOALS", "state" : "SC", "county" : "GREENWOOD" },
            "29693": { "city" : "WESTMINSTER", "state" : "SC", "county" : "OCONEE" },
            "29696": { "city" : "WEST UNION", "state" : "SC", "county" : "OCONEE" },
            "29697": { "city" : "WILLIAMSTON", "state" : "SC", "county" : "ANDERSON" },
            "29702": { "city" : "BLACKSBURG", "state" : "SC", "county" : "CHEROKEE" },
            "29703": { "city" : "BOWLING GREEN", "state" : "SC", "county" : "YORK" },
            "29704": { "city" : "CATAWBA", "state" : "SC", "county" : "YORK" },"29706": { "city" : "CHESTER", "state" : "SC", "county" : "CHESTER" },
            "29707": { "city" : "FORT MILL", "state" : "SC", "county" : "LANCASTER" },
            "29708": { "city" : "FORT MILL", "state" : "SC", "county" : "YORK" },
            "29709": { "city" : "CHESTERFIELD", "state" : "SC", "county" : "CHESTERFIELD" },
            "29710": { "city" : "CLOVER", "state" : "SC", "county" : "YORK" },"29712": { "city" : "EDGEMOOR", "state" : "SC", "county" : "CHESTER" },
            "29714": { "city" : "FORT LAWN", "state" : "SC", "county" : "CHESTER" },
            "29715": { "city" : "FORT MILL", "state" : "SC", "county" : "YORK" },
            "29716": { "city" : "FORT MILL", "state" : "SC", "county" : "YORK" },
            "29717": { "city" : "HICKORY GROVE", "state" : "SC", "county" : "YORK" },
            "29718": { "city" : "JEFFERSON", "state" : "SC", "county" : "CHESTERFIELD" },
            "29720": { "city" : "LANCASTER", "state" : "SC", "county" : "LANCASTER" },
            "29721": { "city" : "LANCASTER", "state" : "SC", "county" : "LANCASTER" },
            "29724": { "city" : "LANDO", "state" : "SC", "county" : "CHESTER" },"29726": { "city" : "MC CONNELLS", "state" : "SC", "county" : "YORK" },
            "29727": { "city" : "MOUNT CROGHAN", "state" : "SC", "county" : "CHESTERFIELD" },
            "29728": { "city" : "PAGELAND", "state" : "SC", "county" : "CHESTERFIELD" },
            "29729": { "city" : "RICHBURG", "state" : "SC", "county" : "CHESTER" },
            "29730": { "city" : "ROCK HILL", "state" : "SC", "county" : "YORK" },
            "29731": { "city" : "ROCK HILL", "state" : "SC", "county" : "YORK" },
            "29732": { "city" : "ROCK HILL", "state" : "SC", "county" : "YORK" },
            "29733": { "city" : "ROCK HILL", "state" : "SC", "county" : "YORK" },
            "29741": { "city" : "RUBY", "state" : "SC", "county" : "CHESTERFIELD" },
            "29742": { "city" : "SHARON", "state" : "SC", "county" : "YORK" },"29743": { "city" : "SMYRNA", "state" : "SC", "county" : "YORK" },
            "29744": { "city" : "VAN WYCK", "state" : "SC", "county" : "LANCASTER" },
            "29745": { "city" : "YORK", "state" : "SC", "county" : "YORK" },"29801": { "city" : "AIKEN", "state" : "SC", "county" : "AIKEN" },
            "29802": { "city" : "AIKEN", "state" : "SC", "county" : "AIKEN" },"29803": { "city" : "AIKEN", "state" : "SC", "county" : "AIKEN" },
            "29804": { "city" : "AIKEN", "state" : "SC", "county" : "AIKEN" },"29805": { "city" : "AIKEN", "state" : "SC", "county" : "AIKEN" },
            "29808": { "city" : "AIKEN", "state" : "SC", "county" : "AIKEN" },"29809": { "city" : "NEW ELLENTON", "state" : "SC", "county" : "AIKEN" },
            "29810": { "city" : "ALLENDALE", "state" : "SC", "county" : "ALLENDALE" },
            "29812": { "city" : "BARNWELL", "state" : "SC", "county" : "BARNWELL" },
            "29813": { "city" : "HILDA", "state" : "SC", "county" : "BARNWELL" },
            "29816": { "city" : "BATH", "state" : "SC", "county" : "AIKEN" },"29817": { "city" : "BLACKVILLE", "state" : "SC", "county" : "BARNWELL" },
            "29819": { "city" : "BRADLEY", "state" : "SC", "county" : "GREENWOOD" },
            "29821": { "city" : "CLARKS HILL", "state" : "SC", "county" : "MCCORMICK" },
            "29822": { "city" : "CLEARWATER", "state" : "SC", "county" : "AIKEN" },
            "29824": { "city" : "EDGEFIELD", "state" : "SC", "county" : "EDGEFIELD" },
            "29826": { "city" : "ELKO", "state" : "SC", "county" : "BARNWELL" },"29827": { "city" : "FAIRFAX", "state" : "SC", "county" : "ALLENDALE" },
            "29828": { "city" : "GLOVERVILLE", "state" : "SC", "county" : "AIKEN" },
            "29829": { "city" : "GRANITEVILLE", "state" : "SC", "county" : "AIKEN" },
            "29831": { "city" : "JACKSON", "state" : "SC", "county" : "AIKEN" },"29832": { "city" : "JOHNSTON", "state" : "SC", "county" : "EDGEFIELD" },
            "29834": { "city" : "LANGLEY", "state" : "SC", "county" : "AIKEN" },"29835": { "city" : "MC CORMICK", "state" : "SC", "county" : "MCCORMICK" },
            "29836": { "city" : "MARTIN", "state" : "SC", "county" : "ALLENDALE" },
            "29838": { "city" : "MODOC", "state" : "SC", "county" : "MCCORMICK" },
            "29839": { "city" : "MONTMORENCI", "state" : "SC", "county" : "AIKEN" },
            "29840": { "city" : "MOUNT CARMEL", "state" : "SC", "county" : "MCCORMICK" },
            "29841": { "city" : "NORTH AUGUSTA", "state" : "SC", "county" : "AIKEN" },
            "29842": { "city" : "BEECH ISLAND", "state" : "SC", "county" : "AIKEN" },
            "29843": { "city" : "OLAR", "state" : "SC", "county" : "BAMBERG" },"29844": { "city" : "PARKSVILLE", "state" : "SC", "county" : "MCCORMICK" },
            "29845": { "city" : "PLUM BRANCH", "state" : "SC", "county" : "MCCORMICK" },
            "29846": { "city" : "SYCAMORE", "state" : "SC", "county" : "ALLENDALE" },
            "29847": { "city" : "TRENTON", "state" : "SC", "county" : "EDGEFIELD" },
            "29848": { "city" : "TROY", "state" : "SC", "county" : "GREENWOOD" },
            "29849": { "city" : "ULMER", "state" : "SC", "county" : "ALLENDALE" },
            "29850": { "city" : "VAUCLUSE", "state" : "SC", "county" : "AIKEN" },
            "29851": { "city" : "WARRENVILLE", "state" : "SC", "county" : "AIKEN" },
            "29853": { "city" : "WILLISTON", "state" : "SC", "county" : "BARNWELL" },
            "29856": { "city" : "WINDSOR", "state" : "SC", "county" : "AIKEN" },"29860": { "city" : "NORTH AUGUSTA", "state" : "SC", "county" : "AIKEN" },
            "29861": { "city" : "NORTH AUGUSTA", "state" : "SC", "county" : "AIKEN" },
            "29901": { "city" : "BEAUFORT", "state" : "SC", "county" : "BEAUFORT" },
            "29902": { "city" : "BEAUFORT", "state" : "SC", "county" : "BEAUFORT" },
            "29903": { "city" : "BEAUFORT", "state" : "SC", "county" : "BEAUFORT" },
            "29904": { "city" : "BEAUFORT", "state" : "SC", "county" : "BEAUFORT" },
            "29905": { "city" : "BEAUFORT", "state" : "SC", "county" : "BEAUFORT" },
            "29906": { "city" : "BEAUFORT", "state" : "SC", "county" : "BEAUFORT" },
            "29907": { "city" : "LADYS ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29909": { "city" : "OKATIE", "state" : "SC", "county" : "BEAUFORT" },
            "29910": { "city" : "BLUFFTON", "state" : "SC", "county" : "BEAUFORT" },
            "29911": { "city" : "BRUNSON", "state" : "SC", "county" : "HAMPTON" },
            "29912": { "city" : "COOSAWHATCHIE", "state" : "SC", "county" : "JASPER" },
            "29915": { "city" : "DAUFUSKIE ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29916": { "city" : "EARLY BRANCH", "state" : "SC", "county" : "HAMPTON" },
            "29918": { "city" : "ESTILL", "state" : "SC", "county" : "HAMPTON" },
            "29920": { "city" : "SAINT HELENA ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29921": { "city" : "FURMAN", "state" : "SC", "county" : "HAMPTON" },
            "29922": { "city" : "GARNETT", "state" : "SC", "county" : "HAMPTON" },
            "29923": { "city" : "GIFFORD", "state" : "SC", "county" : "HAMPTON" },
            "29924": { "city" : "HAMPTON", "state" : "SC", "county" : "HAMPTON" },
            "29925": { "city" : "HILTON HEAD ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29926": { "city" : "HILTON HEAD ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29927": { "city" : "HARDEEVILLE", "state" : "SC", "county" : "JASPER" },
            "29928": { "city" : "HILTON HEAD ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29929": { "city" : "ISLANDTON", "state" : "SC", "county" : "COLLETON" },
            "29931": { "city" : "LOBECO", "state" : "SC", "county" : "BEAUFORT" },
            "29932": { "city" : "LURAY", "state" : "SC", "county" : "HAMPTON" },"29934": { "city" : "PINELAND", "state" : "SC", "county" : "JASPER" },
            "29935": { "city" : "PORT ROYAL", "state" : "SC", "county" : "BEAUFORT" },
            "29936": { "city" : "RIDGELAND", "state" : "SC", "county" : "JASPER" },
            "29938": { "city" : "HILTON HEAD ISLAND", "state" : "SC", "county" : "BEAUFORT" },
            "29939": { "city" : "SCOTIA", "state" : "SC", "county" : "HAMPTON" },
            "29940": { "city" : "SEABROOK", "state" : "SC", "county" : "BEAUFORT" },
            "29941": { "city" : "SHELDON", "state" : "SC", "county" : "BEAUFORT" },
            "29943": { "city" : "TILLMAN", "state" : "SC", "county" : "JASPER" },
            "29944": { "city" : "VARNVILLE", "state" : "SC", "county" : "HAMPTON" },
            "29945": { "city" : "YEMASSEE", "state" : "SC", "county" : "HAMPTON" },
            "30002": { "city" : "AVONDALE ESTATES", "state" : "GA", "county" : "DEKALB" },
            "30003": { "city" : "NORCROSS", "state" : "GA", "county" : "GWINNETT" },
            "30004": { "city" : "ALPHARETTA", "state" : "GA", "county" : "FULTON" },
            "30005": { "city" : "ALPHARETTA", "state" : "GA", "county" : "FULTON" },
            "30006": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30007": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },
            "30008": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30009": { "city" : "ALPHARETTA", "state" : "GA", "county" : "FULTON" },
            "30010": { "city" : "NORCROSS", "state" : "GA", "county" : "GWINNETT" },
            "30011": { "city" : "AUBURN", "state" : "GA", "county" : "BARROW" },"30012": { "city" : "CONYERS", "state" : "GA", "county" : "ROCKDALE" },
            "30013": { "city" : "CONYERS", "state" : "GA", "county" : "ROCKDALE" },
            "30014": { "city" : "COVINGTON", "state" : "GA", "county" : "NEWTON" },
            "30015": { "city" : "COVINGTON", "state" : "GA", "county" : "NEWTON" },
            "30016": { "city" : "COVINGTON", "state" : "GA", "county" : "NEWTON" },
            "30017": { "city" : "GRAYSON", "state" : "GA", "county" : "GWINNETT" },
            "30018": { "city" : "JERSEY", "state" : "GA", "county" : "WALTON" },"30019": { "city" : "DACULA", "state" : "GA", "county" : "GWINNETT" },
            "30021": { "city" : "CLARKSTON", "state" : "GA", "county" : "DEKALB" },
            "30022": { "city" : "ALPHARETTA", "state" : "GA", "county" : "FULTON" },
            "30023": { "city" : "ALPHARETTA", "state" : "GA", "county" : "FULTON" },
            "30024": { "city" : "SUWANEE", "state" : "GA", "county" : "GWINNETT" },
            "30025": { "city" : "SOCIAL CIRCLE", "state" : "GA", "county" : "WALTON" },
            "30026": { "city" : "NORTH METRO", "state" : "GA", "county" : "GWINNETT" },
            "30028": { "city" : "CUMMING", "state" : "GA", "county" : "FORSYTH" },
            "30029": { "city" : "NORTH METRO", "state" : "GA", "county" : "GWINNETT" },
            "30030": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30031": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30032": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30033": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30034": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30035": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30036": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30037": { "city" : "DECATUR", "state" : "GA", "county" : "DEKALB" },
            "30038": { "city" : "LITHONIA", "state" : "GA", "county" : "DEKALB" },
            "30039": { "city" : "SNELLVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30040": { "city" : "CUMMING", "state" : "GA", "county" : "FORSYTH" },
            "30041": { "city" : "CUMMING", "state" : "GA", "county" : "FORSYTH" },
            "30042": { "city" : "LAWRENCEVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30043": { "city" : "LAWRENCEVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30044": { "city" : "LAWRENCEVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30045": { "city" : "LAWRENCEVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30046": { "city" : "LAWRENCEVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30047": { "city" : "LILBURN", "state" : "GA", "county" : "GWINNETT" },
            "30048": { "city" : "LILBURN", "state" : "GA", "county" : "GWINNETT" },
            "30049": { "city" : "LAWRENCEVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30052": { "city" : "LOGANVILLE", "state" : "GA", "county" : "WALTON" },
            "30054": { "city" : "OXFORD", "state" : "GA", "county" : "NEWTON" },"30055": { "city" : "MANSFIELD", "state" : "GA", "county" : "NEWTON" },
            "30056": { "city" : "NEWBORN", "state" : "GA", "county" : "NEWTON" },
            "30058": { "city" : "LITHONIA", "state" : "GA", "county" : "DEKALB" },
            "30060": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30061": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },
            "30062": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30063": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },
            "30064": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30065": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },
            "30066": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30067": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },
            "30068": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30069": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },
            "30070": { "city" : "PORTERDALE", "state" : "GA", "county" : "NEWTON" },
            "30071": { "city" : "NORCROSS", "state" : "GA", "county" : "GWINNETT" },
            "30072": { "city" : "PINE LAKE", "state" : "GA", "county" : "DEKALB" },
            "30074": { "city" : "REDAN", "state" : "GA", "county" : "DEKALB" },"30075": { "city" : "ROSWELL", "state" : "GA", "county" : "FULTON" },
            "30076": { "city" : "ROSWELL", "state" : "GA", "county" : "FULTON" },
            "30077": { "city" : "ROSWELL", "state" : "GA", "county" : "FULTON" },
            "30078": { "city" : "SNELLVILLE", "state" : "GA", "county" : "GWINNETT" },
            "30079": { "city" : "SCOTTDALE", "state" : "GA", "county" : "DEKALB" },
            "30080": { "city" : "SMYRNA", "state" : "GA", "county" : "COBB" },"30081": { "city" : "SMYRNA", "state" : "GA", "county" : "COBB" },
            "30082": { "city" : "SMYRNA", "state" : "GA", "county" : "COBB" },"30083": { "city" : "STONE MOUNTAIN", "state" : "GA", "county" : "DEKALB" },
            "30084": { "city" : "TUCKER", "state" : "GA", "county" : "DEKALB" },"30085": { "city" : "TUCKER", "state" : "GA", "county" : "DEKALB" },
            "30086": { "city" : "STONE MOUNTAIN", "state" : "GA", "county" : "DEKALB" },
            "30087": { "city" : "STONE MOUNTAIN", "state" : "GA", "county" : "DEKALB" },
            "30088": { "city" : "STONE MOUNTAIN", "state" : "GA", "county" : "DEKALB" },
            "30090": { "city" : "MARIETTA", "state" : "GA", "county" : "COBB" },"30091": { "city" : "NORCROSS", "state" : "GA", "county" : "GWINNETT" },
            "30092": { "city" : "NORCROSS", "state" : "GA", "county" : "GWINNETT" },
            "30093": { "city" : "NORCROSS", "state" : "GA", "county" : "GWINNETT" },
            "30094": { "city" : "CONYERS", "state" : "GA", "county" : "ROCKDALE" },
            "30095": { "city" : "DULUTH", "state" : "GA", "county" : "GWINNETT" },
            "30096": { "city" : "DULUTH", "state" : "GA", "county" : "GWINNETT" },
            "30097": { "city" : "DULUTH", "state" : "GA", "county" : "FULTON" },"30098": { "city" : "DULUTH", "state" : "GA", "county" : "GWINNETT" },
            "30099": { "city" : "DULUTH", "state" : "GA", "county" : "GWINNETT" },
            "30101": { "city" : "ACWORTH", "state" : "GA", "county" : "COBB" },"30102": { "city" : "ACWORTH", "state" : "GA", "county" : "CHEROKEE" },
            "30103": { "city" : "ADAIRSVILLE", "state" : "GA", "county" : "BARTOW" },
            "30104": { "city" : "ARAGON", "state" : "GA", "county" : "POLK" },"30105": { "city" : "ARMUCHEE", "state" : "GA", "county" : "FLOYD" },
            "30106": { "city" : "AUSTELL", "state" : "GA", "county" : "COBB" },"30107": { "city" : "BALL GROUND", "state" : "GA", "county" : "CHEROKEE" },
            "30108": { "city" : "BOWDON", "state" : "GA", "county" : "CARROLL" },
            "30109": { "city" : "BOWDON JUNCTION", "state" : "GA", "county" : "CARROLL" },
            "30110": { "city" : "BREMEN", "state" : "GA", "county" : "HARALSON" },
            "30111": { "city" : "CLARKDALE", "state" : "GA", "county" : "COBB" },
            "30112": { "city" : "CARROLLTON", "state" : "GA", "county" : "CARROLL" },
            "30113": { "city" : "BUCHANAN", "state" : "GA", "county" : "HARALSON" },
            "30114": { "city" : "CANTON", "state" : "GA", "county" : "CHEROKEE" },
            "30115": { "city" : "CANTON", "state" : "GA", "county" : "CHEROKEE" },
            "30116": { "city" : "CARROLLTON", "state" : "GA", "county" : "CARROLL" },
            "30117": { "city" : "CARROLLTON", "state" : "GA", "county" : "CARROLL" },
            "30118": { "city" : "CARROLLTON", "state" : "GA", "county" : "CARROLL" },
            "30119": { "city" : "CARROLLTON", "state" : "GA", "county" : "CARROLL" },
            "30120": { "city" : "CARTERSVILLE", "state" : "GA", "county" : "BARTOW" },
            "30121": { "city" : "CARTERSVILLE", "state" : "GA", "county" : "BARTOW" },
            "30122": { "city" : "LITHIA SPRINGS", "state" : "GA", "county" : "DOUGLAS" },
            "30123": { "city" : "CASSVILLE", "state" : "GA", "county" : "BARTOW" },
            "30124": { "city" : "CAVE SPRING", "state" : "GA", "county" : "FLOYD" },
            "30125": { "city" : "CEDARTOWN", "state" : "GA", "county" : "POLK" },
            "30126": { "city" : "MABLETON", "state" : "GA", "county" : "COBB" },"30127": { "city" : "POWDER SPRINGS", "state" : "GA", "county" : "COBB" },
            "30129": { "city" : "COOSA", "state" : "GA", "county" : "FLOYD" },"30132": { "city" : "DALLAS", "state" : "GA", "county" : "PAULDING" },
            "30133": { "city" : "DOUGLASVILLE", "state" : "GA", "county" : "DOUGLAS" },
            "30134": { "city" : "DOUGLASVILLE", "state" : "GA", "county" : "DOUGLAS" },
            "30135": { "city" : "DOUGLASVILLE", "state" : "GA", "county" : "DOUGLAS" },
            "30137": { "city" : "EMERSON", "state" : "GA", "county" : "BARTOW" },
            "30139": { "city" : "FAIRMOUNT", "state" : "GA", "county" : "GORDON" },
            "30140": { "city" : "FELTON", "state" : "GA", "county" : "HARALSON" },
            "30141": { "city" : "HIRAM", "state" : "GA", "county" : "PAULDING" },
            "30142": { "city" : "HOLLY SPRINGS", "state" : "GA", "county" : "CHEROKEE" },
            "30143": { "city" : "JASPER", "state" : "GA", "county" : "PICKENS" },
            "30144": { "city" : "KENNESAW", "state" : "GA", "county" : "COBB" },"30145": { "city" : "KINGSTON", "state" : "GA", "county" : "BARTOW" },
            "30146": { "city" : "LEBANON", "state" : "GA", "county" : "CHEROKEE" },
            "30147": { "city" : "LINDALE", "state" : "GA", "county" : "FLOYD" },"30148": { "city" : "MARBLE HILL", "state" : "GA", "county" : "PICKENS" },
            "30149": { "city" : "MOUNT BERRY", "state" : "GA", "county" : "FLOYD" },
            "30150": { "city" : "MOUNT ZION", "state" : "GA", "county" : "CARROLL" },
            "30151": { "city" : "NELSON", "state" : "GA", "county" : "CHEROKEE" },
            "30152": { "city" : "KENNESAW", "state" : "GA", "county" : "COBB" },"30153": { "city" : "ROCKMART", "state" : "GA", "county" : "POLK" },
            "30154": { "city" : "DOUGLASVILLE", "state" : "GA", "county" : "DOUGLAS" },
            "30156": { "city" : "KENNESAW", "state" : "GA", "county" : "COBB" },"30157": { "city" : "DALLAS", "state" : "GA", "county" : "PAULDING" },
            "30161": { "city" : "ROME", "state" : "GA", "county" : "FLOYD" },"30162": { "city" : "ROME", "state" : "GA", "county" : "FLOYD" },
            "30163": { "city" : "ROME", "state" : "GA", "county" : "FLOYD" },"30164": { "city" : "ROME", "state" : "GA", "county" : "FLOYD" },
            "30165": { "city" : "ROME", "state" : "GA", "county" : "FLOYD" },"30168": { "city" : "AUSTELL", "state" : "GA", "county" : "COBB" },
            "30169": { "city" : "CANTON", "state" : "GA", "county" : "CHEROKEE" },
            "30170": { "city" : "ROOPVILLE", "state" : "GA", "county" : "CARROLL" },
            "30171": { "city" : "RYDAL", "state" : "GA", "county" : "BARTOW" },"30172": { "city" : "SHANNON", "state" : "GA", "county" : "FLOYD" },
            "30173": { "city" : "SILVER CREEK", "state" : "GA", "county" : "FLOYD" },
            "30175": { "city" : "TALKING ROCK", "state" : "GA", "county" : "PICKENS" },
            "30176": { "city" : "TALLAPOOSA", "state" : "GA", "county" : "HARALSON" },
            "30177": { "city" : "TATE", "state" : "GA", "county" : "PICKENS" },"30178": { "city" : "TAYLORSVILLE", "state" : "GA", "county" : "BARTOW" },
            "30179": { "city" : "TEMPLE", "state" : "GA", "county" : "CARROLL" },
            "30180": { "city" : "VILLA RICA", "state" : "GA", "county" : "CARROLL" },
            "30182": { "city" : "WACO", "state" : "GA", "county" : "HARALSON" },"30183": { "city" : "WALESKA", "state" : "GA", "county" : "CHEROKEE" },
            "30184": { "city" : "WHITE", "state" : "GA", "county" : "BARTOW" },"30185": { "city" : "WHITESBURG", "state" : "GA", "county" : "CARROLL" },
            "30187": { "city" : "WINSTON", "state" : "GA", "county" : "DOUGLAS" },
            "30188": { "city" : "WOODSTOCK", "state" : "GA", "county" : "CHEROKEE" },
            "30189": { "city" : "WOODSTOCK", "state" : "GA", "county" : "CHEROKEE" },
            "30204": { "city" : "BARNESVILLE", "state" : "GA", "county" : "LAMAR" },
            "30205": { "city" : "BROOKS", "state" : "GA", "county" : "FAYETTE" },
            "30206": { "city" : "CONCORD", "state" : "GA", "county" : "PIKE" },"30212": { "city" : "EXPERIMENT", "state" : "GA", "county" : "SPALDING" },
            "30213": { "city" : "FAIRBURN", "state" : "GA", "county" : "FULTON" },
            "30214": { "city" : "FAYETTEVILLE", "state" : "GA", "county" : "FAYETTE" },
            "30215": { "city" : "FAYETTEVILLE", "state" : "GA", "county" : "FAYETTE" },
            "30216": { "city" : "FLOVILLA", "state" : "GA", "county" : "BUTTS" },
            "30217": { "city" : "FRANKLIN", "state" : "GA", "county" : "HEARD" },
            "30218": { "city" : "GAY", "state" : "GA", "county" : "MERIWETHER" },
            "30220": { "city" : "GRANTVILLE", "state" : "GA", "county" : "COWETA" },
            "30222": { "city" : "GREENVILLE", "state" : "GA", "county" : "MERIWETHER" },
            "30223": { "city" : "GRIFFIN", "state" : "GA", "county" : "SPALDING" },
            "30224": { "city" : "GRIFFIN", "state" : "GA", "county" : "SPALDING" },
            "30228": { "city" : "HAMPTON", "state" : "GA", "county" : "HENRY" },"30229": { "city" : "HARALSON", "state" : "GA", "county" : "COWETA" },
            "30230": { "city" : "HOGANSVILLE", "state" : "GA", "county" : "TROUP" },
            "30233": { "city" : "JACKSON", "state" : "GA", "county" : "BUTTS" },"30234": { "city" : "JENKINSBURG", "state" : "GA", "county" : "BUTTS" },
            "30236": { "city" : "JONESBORO", "state" : "GA", "county" : "CLAYTON" },
            "30237": { "city" : "JONESBORO", "state" : "GA", "county" : "CLAYTON" },
            "30238": { "city" : "JONESBORO", "state" : "GA", "county" : "CLAYTON" },
            "30240": { "city" : "LAGRANGE", "state" : "GA", "county" : "TROUP" },
            "30241": { "city" : "LAGRANGE", "state" : "GA", "county" : "TROUP" },
            "30248": { "city" : "LOCUST GROVE", "state" : "GA", "county" : "HENRY" },
            "30250": { "city" : "LOVEJOY", "state" : "GA", "county" : "CLAYTON" },
            "30251": { "city" : "LUTHERSVILLE", "state" : "GA", "county" : "MERIWETHER" },
            "30252": { "city" : "MCDONOUGH", "state" : "GA", "county" : "HENRY" },
            "30253": { "city" : "MCDONOUGH", "state" : "GA", "county" : "HENRY" },
            "30256": { "city" : "MEANSVILLE", "state" : "GA", "county" : "PIKE" },
            "30257": { "city" : "MILNER", "state" : "GA", "county" : "LAMAR" },"30258": { "city" : "MOLENA", "state" : "GA", "county" : "PIKE" },
            "30259": { "city" : "MORELAND", "state" : "GA", "county" : "COWETA" },
            "30260": { "city" : "MORROW", "state" : "GA", "county" : "CLAYTON" },
            "30261": { "city" : "LAGRANGE", "state" : "GA", "county" : "TROUP" },
            "30263": { "city" : "NEWNAN", "state" : "GA", "county" : "COWETA" },"30264": { "city" : "NEWNAN", "state" : "GA", "county" : "COWETA" },
            "30265": { "city" : "NEWNAN", "state" : "GA", "county" : "COWETA" },"30266": { "city" : "ORCHARD HILL", "state" : "GA", "county" : "SPALDING" },
            "30268": { "city" : "PALMETTO", "state" : "GA", "county" : "FULTON" },
            "30269": { "city" : "PEACHTREE CITY", "state" : "GA", "county" : "FAYETTE" },
            "30271": { "city" : "NEWNAN", "state" : "GA", "county" : "COWETA" },"30272": { "city" : "RED OAK", "state" : "GA", "county" : "FULTON" },
            "30273": { "city" : "REX", "state" : "GA", "county" : "CLAYTON" },"30274": { "city" : "RIVERDALE", "state" : "GA", "county" : "CLAYTON" },
            "30275": { "city" : "SARGENT", "state" : "GA", "county" : "COWETA" },
            "30276": { "city" : "SENOIA", "state" : "GA", "county" : "COWETA" },"30277": { "city" : "SHARPSBURG", "state" : "GA", "county" : "COWETA" },
            "30281": { "city" : "STOCKBRIDGE", "state" : "GA", "county" : "HENRY" },
            "30284": { "city" : "SUNNY SIDE", "state" : "GA", "county" : "COWETA" },
            "30285": { "city" : "THE ROCK", "state" : "GA", "county" : "UPSON" },
            "30286": { "city" : "THOMASTON", "state" : "GA", "county" : "UPSON" },
            "30287": { "city" : "MORROW", "state" : "GA", "county" : "CLAYTON" },
            "30288": { "city" : "CONLEY", "state" : "GA", "county" : "CLAYTON" },
            "30289": { "city" : "TURIN", "state" : "GA", "county" : "COWETA" },"30290": { "city" : "TYRONE", "state" : "GA", "county" : "FAYETTE" },
            "30291": { "city" : "UNION CITY", "state" : "GA", "county" : "FULTON" },
            "30292": { "city" : "WILLIAMSON", "state" : "GA", "county" : "PIKE" },
            "30293": { "city" : "WOODBURY", "state" : "GA", "county" : "MERIWETHER" },
            "30294": { "city" : "ELLENWOOD", "state" : "GA", "county" : "DEKALB" },
            "30295": { "city" : "ZEBULON", "state" : "GA", "county" : "PIKE" },"30296": { "city" : "RIVERDALE", "state" : "GA", "county" : "CLAYTON" },
            "30297": { "city" : "FOREST PARK", "state" : "GA", "county" : "CLAYTON" },
            "30298": { "city" : "FOREST PARK", "state" : "GA", "county" : "CLAYTON" },
            "30301": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30302": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30303": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30304": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30305": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30306": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30307": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30308": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30309": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30310": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30311": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30312": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30313": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30314": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30315": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30316": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30317": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30318": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30319": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30320": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30321": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30322": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30324": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30325": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30326": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30327": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30328": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30329": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30330": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30331": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30332": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30333": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30334": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30336": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30337": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30338": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30339": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30340": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30341": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30342": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30343": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30344": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30345": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30346": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30347": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30348": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30349": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30350": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30353": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30354": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30355": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30356": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30357": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30358": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30359": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30360": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30361": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30362": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30363": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30364": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30366": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "30370": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30371": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30375": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30376": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30377": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30378": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30379": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30380": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30390": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30392": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30396": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "30401": { "city" : "SWAINSBORO", "state" : "GA", "county" : "EMANUEL" },
            "30410": { "city" : "AILEY", "state" : "GA", "county" : "MONTGOMERY" },
            "30411": { "city" : "ALAMO", "state" : "GA", "county" : "WHEELER" },"30412": { "city" : "ALSTON", "state" : "GA", "county" : "MONTGOMERY" },
            "30413": { "city" : "BARTOW", "state" : "GA", "county" : "JEFFERSON" },
            "30414": { "city" : "BELLVILLE", "state" : "GA", "county" : "EVANS" },
            "30415": { "city" : "BROOKLET", "state" : "GA", "county" : "BULLOCH" },
            "30417": { "city" : "CLAXTON", "state" : "GA", "county" : "EVANS" },"30420": { "city" : "COBBTOWN", "state" : "GA", "county" : "TATTNALL" },
            "30421": { "city" : "COLLINS", "state" : "GA", "county" : "TATTNALL" },
            "30423": { "city" : "DAISY", "state" : "GA", "county" : "EVANS" },"30424": { "city" : "DOVER", "state" : "GA", "county" : "SCREVEN" },
            "30425": { "city" : "GARFIELD", "state" : "GA", "county" : "EMANUEL" },
            "30426": { "city" : "GIRARD", "state" : "GA", "county" : "BURKE" },"30427": { "city" : "GLENNVILLE", "state" : "GA", "county" : "TATTNALL" },
            "30428": { "city" : "GLENWOOD", "state" : "GA", "county" : "WHEELER" },
            "30429": { "city" : "HAGAN", "state" : "GA", "county" : "EVANS" },"30434": { "city" : "LOUISVILLE", "state" : "GA", "county" : "JEFFERSON" },
            "30436": { "city" : "LYONS", "state" : "GA", "county" : "TOOMBS" },"30438": { "city" : "MANASSAS", "state" : "GA", "county" : "TATTNALL" },
            "30439": { "city" : "METTER", "state" : "GA", "county" : "CANDLER" },
            "30441": { "city" : "MIDVILLE", "state" : "GA", "county" : "BURKE" },
            "30442": { "city" : "MILLEN", "state" : "GA", "county" : "JENKINS" },
            "30445": { "city" : "MOUNT VERNON", "state" : "GA", "county" : "MONTGOMERY" },
            "30446": { "city" : "NEWINGTON", "state" : "GA", "county" : "SCREVEN" },
            "30448": { "city" : "NUNEZ", "state" : "GA", "county" : "EMANUEL" },"30449": { "city" : "OLIVER", "state" : "GA", "county" : "SCREVEN" },
            "30450": { "city" : "PORTAL", "state" : "GA", "county" : "BULLOCH" },
            "30451": { "city" : "PULASKI", "state" : "GA", "county" : "CANDLER" },
            "30452": { "city" : "REGISTER", "state" : "GA", "county" : "BULLOCH" },
            "30453": { "city" : "REIDSVILLE", "state" : "GA", "county" : "TATTNALL" },
            "30454": { "city" : "ROCKLEDGE", "state" : "GA", "county" : "LAURENS" },
            "30455": { "city" : "ROCKY FORD", "state" : "GA", "county" : "SCREVEN" },
            "30456": { "city" : "SARDIS", "state" : "GA", "county" : "BURKE" },"30457": { "city" : "SOPERTON", "state" : "GA", "county" : "TREUTLEN" },
            "30458": { "city" : "STATESBORO", "state" : "GA", "county" : "BULLOCH" },
            "30459": { "city" : "STATESBORO", "state" : "GA", "county" : "BULLOCH" },
            "30460": { "city" : "STATESBORO", "state" : "GA", "county" : "BULLOCH" },
            "30461": { "city" : "STATESBORO", "state" : "GA", "county" : "BULLOCH" },
            "30464": { "city" : "STILLMORE", "state" : "GA", "county" : "EMANUEL" },
            "30467": { "city" : "SYLVANIA", "state" : "GA", "county" : "SCREVEN" },
            "30470": { "city" : "TARRYTOWN", "state" : "GA", "county" : "MONTGOMERY" },
            "30471": { "city" : "TWIN CITY", "state" : "GA", "county" : "EMANUEL" },
            "30473": { "city" : "UVALDA", "state" : "GA", "county" : "MONTGOMERY" },
            "30474": { "city" : "VIDALIA", "state" : "GA", "county" : "TOOMBS" },
            "30475": { "city" : "VIDALIA", "state" : "GA", "county" : "TOOMBS" },
            "30477": { "city" : "WADLEY", "state" : "GA", "county" : "JEFFERSON" },
            "30501": { "city" : "GAINESVILLE", "state" : "GA", "county" : "HALL" },
            "30502": { "city" : "CHESTNUT MOUNTAIN", "state" : "GA", "county" : "HALL" },
            "30503": { "city" : "GAINESVILLE", "state" : "GA", "county" : "HALL" },
            "30504": { "city" : "GAINESVILLE", "state" : "GA", "county" : "HALL" },
            "30506": { "city" : "GAINESVILLE", "state" : "GA", "county" : "HALL" },
            "30507": { "city" : "GAINESVILLE", "state" : "GA", "county" : "HALL" },
            "30510": { "city" : "ALTO", "state" : "GA", "county" : "HABERSHAM" },
            "30511": { "city" : "BALDWIN", "state" : "GA", "county" : "BANKS" },"30512": { "city" : "BLAIRSVILLE", "state" : "GA", "county" : "UNION" },
            "30513": { "city" : "BLUE RIDGE", "state" : "GA", "county" : "FANNIN" },
            "30514": { "city" : "BLAIRSVILLE", "state" : "GA", "county" : "UNION" },
            "30515": { "city" : "BUFORD", "state" : "GA", "county" : "GWINNETT" },
            "30516": { "city" : "BOWERSVILLE", "state" : "GA", "county" : "HART" },
            "30517": { "city" : "BRASELTON", "state" : "GA", "county" : "JACKSON" },
            "30518": { "city" : "BUFORD", "state" : "GA", "county" : "GWINNETT" },
            "30519": { "city" : "BUFORD", "state" : "GA", "county" : "GWINNETT" },
            "30520": { "city" : "CANON", "state" : "GA", "county" : "FRANKLIN" },
            "30521": { "city" : "CARNESVILLE", "state" : "GA", "county" : "FRANKLIN" },
            "30522": { "city" : "CHERRY LOG", "state" : "GA", "county" : "GILMER" },
            "30523": { "city" : "CLARKESVILLE", "state" : "GA", "county" : "HABERSHAM" },
            "30525": { "city" : "CLAYTON", "state" : "GA", "county" : "RABUN" },"30527": { "city" : "CLERMONT", "state" : "GA", "county" : "HALL" },
            "30528": { "city" : "CLEVELAND", "state" : "GA", "county" : "WHITE" },
            "30529": { "city" : "COMMERCE", "state" : "GA", "county" : "JACKSON" },
            "30530": { "city" : "COMMERCE", "state" : "GA", "county" : "BANKS" },
            "30531": { "city" : "CORNELIA", "state" : "GA", "county" : "HABERSHAM" },
            "30533": { "city" : "DAHLONEGA", "state" : "GA", "county" : "LUMPKIN" },
            "30534": { "city" : "DAWSONVILLE", "state" : "GA", "county" : "DAWSON" },
            "30535": { "city" : "DEMOREST", "state" : "GA", "county" : "HABERSHAM" },
            "30536": { "city" : "ELLIJAY", "state" : "GA", "county" : "GILMER" },
            "30537": { "city" : "DILLARD", "state" : "GA", "county" : "RABUN" },"30538": { "city" : "EASTANOLLEE", "state" : "GA", "county" : "STEPHENS" },
            "30539": { "city" : "EAST ELLIJAY", "state" : "GA", "county" : "GILMER" },
            "30540": { "city" : "ELLIJAY", "state" : "GA", "county" : "GILMER" },
            "30541": { "city" : "EPWORTH", "state" : "GA", "county" : "FANNIN" },
            "30542": { "city" : "FLOWERY BRANCH", "state" : "GA", "county" : "HALL" },
            "30543": { "city" : "GILLSVILLE", "state" : "GA", "county" : "HALL" },
            "30544": { "city" : "DEMOREST", "state" : "GA", "county" : "HABERSHAM" },
            "30545": { "city" : "HELEN", "state" : "GA", "county" : "WHITE" },"30546": { "city" : "HIAWASSEE", "state" : "GA", "county" : "TOWNS" },
            "30547": { "city" : "HOMER", "state" : "GA", "county" : "BANKS" },"30548": { "city" : "HOSCHTON", "state" : "GA", "county" : "JACKSON" },
            "30549": { "city" : "JEFFERSON", "state" : "GA", "county" : "JACKSON" },
            "30552": { "city" : "LAKEMONT", "state" : "GA", "county" : "RABUN" },
            "30553": { "city" : "LAVONIA", "state" : "GA", "county" : "FRANKLIN" },
            "30554": { "city" : "LULA", "state" : "GA", "county" : "HALL" },"30555": { "city" : "MC CAYSVILLE", "state" : "GA", "county" : "FANNIN" },
            "30557": { "city" : "MARTIN", "state" : "GA", "county" : "STEPHENS" },
            "30558": { "city" : "MAYSVILLE", "state" : "GA", "county" : "BANKS" },
            "30559": { "city" : "MINERAL BLUFF", "state" : "GA", "county" : "FANNIN" },
            "30560": { "city" : "MORGANTON", "state" : "GA", "county" : "FANNIN" },
            "30562": { "city" : "MOUNTAIN CITY", "state" : "GA", "county" : "RABUN" },
            "30563": { "city" : "MOUNT AIRY", "state" : "GA", "county" : "HABERSHAM" },
            "30564": { "city" : "MURRAYVILLE", "state" : "GA", "county" : "HALL" },
            "30565": { "city" : "NICHOLSON", "state" : "GA", "county" : "JACKSON" },
            "30566": { "city" : "OAKWOOD", "state" : "GA", "county" : "HALL" },"30567": { "city" : "PENDERGRASS", "state" : "GA", "county" : "JACKSON" },
            "30568": { "city" : "RABUN GAP", "state" : "GA", "county" : "RABUN" },
            "30571": { "city" : "SAUTEE NACOOCHEE", "state" : "GA", "county" : "WHITE" },
            "30572": { "city" : "SUCHES", "state" : "GA", "county" : "UNION" },"30573": { "city" : "TALLULAH FALLS", "state" : "GA", "county" : "RABUN" },
            "30575": { "city" : "TALMO", "state" : "GA", "county" : "JACKSON" },"30576": { "city" : "TIGER", "state" : "GA", "county" : "RABUN" },
            "30577": { "city" : "TOCCOA", "state" : "GA", "county" : "STEPHENS" },
            "30580": { "city" : "TURNERVILLE", "state" : "GA", "county" : "HABERSHAM" },
            "30581": { "city" : "WILEY", "state" : "GA", "county" : "RABUN" },"30582": { "city" : "YOUNG HARRIS", "state" : "GA", "county" : "TOWNS" },
            "30597": { "city" : "DAHLONEGA", "state" : "GA", "county" : "LUMPKIN" },
            "30598": { "city" : "TOCCOA FALLS", "state" : "GA", "county" : "STEPHENS" },
            "30601": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },"30602": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },
            "30603": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },"30604": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },
            "30605": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },"30606": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },
            "30607": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },"30608": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },
            "30612": { "city" : "ATHENS", "state" : "GA", "county" : "CLARKE" },"30619": { "city" : "ARNOLDSVILLE", "state" : "GA", "county" : "OGLETHORPE" },
            "30620": { "city" : "BETHLEHEM", "state" : "GA", "county" : "BARROW" },
            "30621": { "city" : "BISHOP", "state" : "GA", "county" : "OCONEE" },"30622": { "city" : "BOGART", "state" : "GA", "county" : "OCONEE" },
            "30623": { "city" : "BOSTWICK", "state" : "GA", "county" : "MORGAN" },
            "30624": { "city" : "BOWMAN", "state" : "GA", "county" : "ELBERT" },"30625": { "city" : "BUCKHEAD", "state" : "GA", "county" : "MORGAN" },
            "30627": { "city" : "CARLTON", "state" : "GA", "county" : "MADISON" },
            "30628": { "city" : "COLBERT", "state" : "GA", "county" : "MADISON" },
            "30629": { "city" : "COMER", "state" : "GA", "county" : "MADISON" },"30630": { "city" : "CRAWFORD", "state" : "GA", "county" : "OGLETHORPE" },
            "30631": { "city" : "CRAWFORDVILLE", "state" : "GA", "county" : "TALIAFERRO" },
            "30633": { "city" : "DANIELSVILLE", "state" : "GA", "county" : "MADISON" },
            "30634": { "city" : "DEWY ROSE", "state" : "GA", "county" : "ELBERT" },
            "30635": { "city" : "ELBERTON", "state" : "GA", "county" : "ELBERT" },
            "30638": { "city" : "FARMINGTON", "state" : "GA", "county" : "OCONEE" },
            "30639": { "city" : "FRANKLIN SPRINGS", "state" : "GA", "county" : "FRANKLIN" },
            "30641": { "city" : "GOOD HOPE", "state" : "GA", "county" : "WALTON" },
            "30642": { "city" : "GREENSBORO", "state" : "GA", "county" : "GREENE" },
            "30643": { "city" : "HARTWELL", "state" : "GA", "county" : "HART" },"30645": { "city" : "HIGH SHOALS", "state" : "GA", "county" : "MORGAN" },
            "30646": { "city" : "HULL", "state" : "GA", "county" : "MADISON" },"30647": { "city" : "ILA", "state" : "GA", "county" : "MADISON" },
            "30648": { "city" : "LEXINGTON", "state" : "GA", "county" : "OGLETHORPE" },
            "30650": { "city" : "MADISON", "state" : "GA", "county" : "MORGAN" },
            "30655": { "city" : "MONROE", "state" : "GA", "county" : "WALTON" },"30656": { "city" : "MONROE", "state" : "GA", "county" : "WALTON" },
            "30660": { "city" : "RAYLE", "state" : "GA", "county" : "WILKES" },"30662": { "city" : "ROYSTON", "state" : "GA", "county" : "FRANKLIN" },
            "30663": { "city" : "RUTLEDGE", "state" : "GA", "county" : "MORGAN" },
            "30664": { "city" : "SHARON", "state" : "GA", "county" : "TALIAFERRO" },
            "30665": { "city" : "SILOAM", "state" : "GA", "county" : "GREENE" },"30666": { "city" : "STATHAM", "state" : "GA", "county" : "BARROW" },
            "30667": { "city" : "STEPHENS", "state" : "GA", "county" : "OGLETHORPE" },
            "30668": { "city" : "TIGNALL", "state" : "GA", "county" : "WILKES" },
            "30669": { "city" : "UNION POINT", "state" : "GA", "county" : "GREENE" },
            "30673": { "city" : "WASHINGTON", "state" : "GA", "county" : "WILKES" },
            "30677": { "city" : "WATKINSVILLE", "state" : "GA", "county" : "OCONEE" },
            "30678": { "city" : "WHITE PLAINS", "state" : "GA", "county" : "GREENE" },
            "30680": { "city" : "WINDER", "state" : "GA", "county" : "BARROW" },"30683": { "city" : "WINTERVILLE", "state" : "GA", "county" : "CLARKE" },
            "30701": { "city" : "CALHOUN", "state" : "GA", "county" : "GORDON" },
            "30703": { "city" : "CALHOUN", "state" : "GA", "county" : "GORDON" },
            "30705": { "city" : "CHATSWORTH", "state" : "GA", "county" : "MURRAY" },
            "30707": { "city" : "CHICKAMAUGA", "state" : "GA", "county" : "WALKER" },
            "30708": { "city" : "CISCO", "state" : "GA", "county" : "MURRAY" },"30710": { "city" : "COHUTTA", "state" : "GA", "county" : "WHITFIELD" },
            "30711": { "city" : "CRANDALL", "state" : "GA", "county" : "MURRAY" },
            "30719": { "city" : "DALTON", "state" : "GA", "county" : "WHITFIELD" },
            "30720": { "city" : "DALTON", "state" : "GA", "county" : "WHITFIELD" },
            "30721": { "city" : "DALTON", "state" : "GA", "county" : "WHITFIELD" },
            "30722": { "city" : "DALTON", "state" : "GA", "county" : "WHITFIELD" },
            "30724": { "city" : "ETON", "state" : "GA", "county" : "MURRAY" },"30725": { "city" : "FLINTSTONE", "state" : "GA", "county" : "WALKER" },
            "30726": { "city" : "GRAYSVILLE", "state" : "GA", "county" : "CATOOSA" },
            "30728": { "city" : "LA FAYETTE", "state" : "GA", "county" : "WALKER" },
            "30730": { "city" : "LYERLY", "state" : "GA", "county" : "CHATTOOGA" },
            "30731": { "city" : "MENLO", "state" : "GA", "county" : "CHATTOOGA" },
            "30732": { "city" : "OAKMAN", "state" : "GA", "county" : "GORDON" },"30733": { "city" : "PLAINVILLE", "state" : "GA", "county" : "GORDON" },
            "30734": { "city" : "RANGER", "state" : "GA", "county" : "GORDON" },"30735": { "city" : "RESACA", "state" : "GA", "county" : "GORDON" },
            "30736": { "city" : "RINGGOLD", "state" : "GA", "county" : "CATOOSA" },
            "30738": { "city" : "RISING FAWN", "state" : "GA", "county" : "DADE" },
            "30739": { "city" : "ROCK SPRING", "state" : "GA", "county" : "WALKER" },
            "30740": { "city" : "ROCKY FACE", "state" : "GA", "county" : "WHITFIELD" },
            "30741": { "city" : "ROSSVILLE", "state" : "GA", "county" : "WALKER" },
            "30742": { "city" : "FORT OGLETHORPE", "state" : "GA", "county" : "CATOOSA" },
            "30746": { "city" : "SUGAR VALLEY", "state" : "GA", "county" : "GORDON" },
            "30747": { "city" : "SUMMERVILLE", "state" : "GA", "county" : "CHATTOOGA" },
            "30750": { "city" : "LOOKOUT MOUNTAIN", "state" : "GA", "county" : "WALKER" },
            "30751": { "city" : "TENNGA", "state" : "GA", "county" : "MURRAY" },"30752": { "city" : "TRENTON", "state" : "GA", "county" : "DADE" },
            "30753": { "city" : "TRION", "state" : "GA", "county" : "CHATTOOGA" },
            "30755": { "city" : "TUNNEL HILL", "state" : "GA", "county" : "WHITFIELD" },
            "30756": { "city" : "VARNELL", "state" : "GA", "county" : "CATOOSA" },
            "30757": { "city" : "WILDWOOD", "state" : "GA", "county" : "DADE" },"30802": { "city" : "APPLING", "state" : "GA", "county" : "COLUMBIA" },
            "30803": { "city" : "AVERA", "state" : "GA", "county" : "JEFFERSON" },
            "30805": { "city" : "BLYTHE", "state" : "GA", "county" : "RICHMOND" },
            "30806": { "city" : "BONEVILLE", "state" : "GA", "county" : "MCDUFFIE" },
            "30807": { "city" : "CAMAK", "state" : "GA", "county" : "WARREN" },"30808": { "city" : "DEARING", "state" : "GA", "county" : "MCDUFFIE" },
            "30809": { "city" : "EVANS", "state" : "GA", "county" : "COLUMBIA" },
            "30810": { "city" : "GIBSON", "state" : "GA", "county" : "GLASCOCK" },
            "30812": { "city" : "GRACEWOOD", "state" : "GA", "county" : "RICHMOND" },
            "30813": { "city" : "GROVETOWN", "state" : "GA", "county" : "COLUMBIA" },
            "30814": { "city" : "HARLEM", "state" : "GA", "county" : "COLUMBIA" },
            "30815": { "city" : "HEPHZIBAH", "state" : "GA", "county" : "RICHMOND" },
            "30816": { "city" : "KEYSVILLE", "state" : "GA", "county" : "BURKE" },
            "30817": { "city" : "LINCOLNTON", "state" : "GA", "county" : "LINCOLN" },
            "30818": { "city" : "MATTHEWS", "state" : "GA", "county" : "JEFFERSON" },
            "30819": { "city" : "MESENA", "state" : "GA", "county" : "WARREN" },"30820": { "city" : "MITCHELL", "state" : "GA", "county" : "GLASCOCK" },
            "30821": { "city" : "NORWOOD", "state" : "GA", "county" : "WARREN" },
            "30822": { "city" : "PERKINS", "state" : "GA", "county" : "JENKINS" },
            "30823": { "city" : "STAPLETON", "state" : "GA", "county" : "JEFFERSON" },
            "30824": { "city" : "THOMSON", "state" : "GA", "county" : "MCDUFFIE" },
            "30828": { "city" : "WARRENTON", "state" : "GA", "county" : "WARREN" },
            "30830": { "city" : "WAYNESBORO", "state" : "GA", "county" : "BURKE" },
            "30833": { "city" : "WRENS", "state" : "GA", "county" : "JEFFERSON" },
            "30901": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30903": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30904": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30905": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30906": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30907": { "city" : "AUGUSTA", "state" : "GA", "county" : "COLUMBIA" },
            "30909": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30912": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30913": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30914": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30916": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "30917": { "city" : "AUGUSTA", "state" : "GA", "county" : "COLUMBIA" },
            "30919": { "city" : "AUGUSTA", "state" : "GA", "county" : "RICHMOND" },
            "31001": { "city" : "ABBEVILLE", "state" : "GA", "county" : "WILCOX" },
            "31002": { "city" : "ADRIAN", "state" : "GA", "county" : "EMANUEL" },
            "31003": { "city" : "ALLENTOWN", "state" : "GA", "county" : "WILKINSON" },
            "31004": { "city" : "BOLINGBROKE", "state" : "GA", "county" : "MONROE" },
            "31005": { "city" : "BONAIRE", "state" : "GA", "county" : "HOUSTON" },
            "31006": { "city" : "BUTLER", "state" : "GA", "county" : "TAYLOR" },"31007": { "city" : "BYROMVILLE", "state" : "GA", "county" : "DOOLY" },
            "31008": { "city" : "BYRON", "state" : "GA", "county" : "PEACH" },"31009": { "city" : "CADWELL", "state" : "GA", "county" : "LAURENS" },
            "31010": { "city" : "CORDELE", "state" : "GA", "county" : "CRISP" },"31011": { "city" : "CHAUNCEY", "state" : "GA", "county" : "DODGE" },
            "31012": { "city" : "CHESTER", "state" : "GA", "county" : "DODGE" },"31013": { "city" : "CLINCHFIELD", "state" : "GA", "county" : "HOUSTON" },
            "31014": { "city" : "COCHRAN", "state" : "GA", "county" : "BLECKLEY" },
            "31015": { "city" : "CORDELE", "state" : "GA", "county" : "CRISP" },"31016": { "city" : "CULLODEN", "state" : "GA", "county" : "MONROE" },
            "31017": { "city" : "DANVILLE", "state" : "GA", "county" : "TWIGGS" },
            "31018": { "city" : "DAVISBORO", "state" : "GA", "county" : "WASHINGTON" },
            "31019": { "city" : "DEXTER", "state" : "GA", "county" : "LAURENS" },
            "31020": { "city" : "DRY BRANCH", "state" : "GA", "county" : "TWIGGS" },
            "31021": { "city" : "DUBLIN", "state" : "GA", "county" : "LAURENS" },
            "31022": { "city" : "DUDLEY", "state" : "GA", "county" : "LAURENS" },
            "31023": { "city" : "EASTMAN", "state" : "GA", "county" : "DODGE" },"31024": { "city" : "EATONTON", "state" : "GA", "county" : "PUTNAM" },
            "31025": { "city" : "ELKO", "state" : "GA", "county" : "HOUSTON" },"31027": { "city" : "EAST DUBLIN", "state" : "GA", "county" : "LAURENS" },
            "31028": { "city" : "CENTERVILLE", "state" : "GA", "county" : "HOUSTON" },
            "31029": { "city" : "FORSYTH", "state" : "GA", "county" : "MONROE" },
            "31030": { "city" : "FORT VALLEY", "state" : "GA", "county" : "PEACH" },
            "31031": { "city" : "GORDON", "state" : "GA", "county" : "WILKINSON" },
            "31032": { "city" : "GRAY", "state" : "GA", "county" : "JONES" },"31033": { "city" : "HADDOCK", "state" : "GA", "county" : "JONES" },
            "31034": { "city" : "HARDWICK", "state" : "GA", "county" : "BALDWIN" },
            "31035": { "city" : "HARRISON", "state" : "GA", "county" : "WASHINGTON" },
            "31036": { "city" : "HAWKINSVILLE", "state" : "GA", "county" : "PULASKI" },
            "31037": { "city" : "HELENA", "state" : "GA", "county" : "TELFAIR" },
            "31038": { "city" : "HILLSBORO", "state" : "GA", "county" : "JASPER" },
            "31040": { "city" : "DUBLIN", "state" : "GA", "county" : "LAURENS" },
            "31041": { "city" : "IDEAL", "state" : "GA", "county" : "MACON" },"31042": { "city" : "IRWINTON", "state" : "GA", "county" : "WILKINSON" },
            "31044": { "city" : "JEFFERSONVILLE", "state" : "GA", "county" : "TWIGGS" },
            "31045": { "city" : "JEWELL", "state" : "GA", "county" : "WARREN" },"31046": { "city" : "JULIETTE", "state" : "GA", "county" : "MONROE" },
            "31047": { "city" : "KATHLEEN", "state" : "GA", "county" : "HOUSTON" },
            "31049": { "city" : "KITE", "state" : "GA", "county" : "JOHNSON" },"31050": { "city" : "KNOXVILLE", "state" : "GA", "county" : "CRAWFORD" },
            "31051": { "city" : "LILLY", "state" : "GA", "county" : "DOOLY" },"31052": { "city" : "LIZELLA", "state" : "GA", "county" : "BIBB" },
            "31054": { "city" : "MC INTYRE", "state" : "GA", "county" : "WILKINSON" },
            "31055": { "city" : "MC RAE", "state" : "GA", "county" : "TELFAIR" },
            "31057": { "city" : "MARSHALLVILLE", "state" : "GA", "county" : "MACON" },
            "31058": { "city" : "MAUK", "state" : "GA", "county" : "MARION" },"31059": { "city" : "MILLEDGEVILLE", "state" : "GA", "county" : "BALDWIN" },
            "31060": { "city" : "MILAN", "state" : "GA", "county" : "DODGE" },"31061": { "city" : "MILLEDGEVILLE", "state" : "GA", "county" : "BALDWIN" },
            "31062": { "city" : "MILLEDGEVILLE", "state" : "GA", "county" : "BALDWIN" },
            "31063": { "city" : "MONTEZUMA", "state" : "GA", "county" : "MACON" },
            "31064": { "city" : "MONTICELLO", "state" : "GA", "county" : "JASPER" },
            "31065": { "city" : "MONTROSE", "state" : "GA", "county" : "LAURENS" },
            "31066": { "city" : "MUSELLA", "state" : "GA", "county" : "CRAWFORD" },
            "31067": { "city" : "OCONEE", "state" : "GA", "county" : "WASHINGTON" },
            "31068": { "city" : "OGLETHORPE", "state" : "GA", "county" : "MACON" },
            "31069": { "city" : "PERRY", "state" : "GA", "county" : "HOUSTON" },"31070": { "city" : "PINEHURST", "state" : "GA", "county" : "DOOLY" },
            "31071": { "city" : "PINEVIEW", "state" : "GA", "county" : "WILCOX" },
            "31072": { "city" : "PITTS", "state" : "GA", "county" : "WILCOX" },"31075": { "city" : "RENTZ", "state" : "GA", "county" : "LAURENS" },
            "31076": { "city" : "REYNOLDS", "state" : "GA", "county" : "TAYLOR" },
            "31077": { "city" : "RHINE", "state" : "GA", "county" : "DODGE" },"31078": { "city" : "ROBERTA", "state" : "GA", "county" : "CRAWFORD" },
            "31079": { "city" : "ROCHELLE", "state" : "GA", "county" : "WILCOX" },
            "31081": { "city" : "RUPERT", "state" : "GA", "county" : "TAYLOR" },"31082": { "city" : "SANDERSVILLE", "state" : "GA", "county" : "WASHINGTON" },
            "31083": { "city" : "SCOTLAND", "state" : "GA", "county" : "TELFAIR" },
            "31085": { "city" : "SHADY DALE", "state" : "GA", "county" : "JASPER" },
            "31086": { "city" : "SMARR", "state" : "GA", "county" : "MONROE" },"31087": { "city" : "SPARTA", "state" : "GA", "county" : "HANCOCK" },
            "31088": { "city" : "WARNER ROBINS", "state" : "GA", "county" : "HOUSTON" },
            "31089": { "city" : "TENNILLE", "state" : "GA", "county" : "WASHINGTON" },
            "31090": { "city" : "TOOMSBORO", "state" : "GA", "county" : "WILKINSON" },
            "31091": { "city" : "UNADILLA", "state" : "GA", "county" : "DOOLY" },
            "31092": { "city" : "VIENNA", "state" : "GA", "county" : "DOOLY" },"31093": { "city" : "WARNER ROBINS", "state" : "GA", "county" : "HOUSTON" },
            "31094": { "city" : "WARTHEN", "state" : "GA", "county" : "WASHINGTON" },
            "31095": { "city" : "WARNER ROBINS", "state" : "GA", "county" : "HOUSTON" },
            "31096": { "city" : "WRIGHTSVILLE", "state" : "GA", "county" : "JOHNSON" },
            "31097": { "city" : "YATESVILLE", "state" : "GA", "county" : "UPSON" },
            "31098": { "city" : "WARNER ROBINS", "state" : "GA", "county" : "HOUSTON" },
            "31099": { "city" : "WARNER ROBINS", "state" : "GA", "county" : "HOUSTON" },
            "31106": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31107": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31119": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "31126": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31131": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31139": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31141": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "31145": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "31146": { "city" : "ATLANTA", "state" : "GA", "county" : "DEKALB" },
            "31150": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31156": { "city" : "ATLANTA", "state" : "GA", "county" : "FULTON" },
            "31201": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31202": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31203": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31204": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31205": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31206": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31207": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31208": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31209": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31210": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31211": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31212": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31213": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31216": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31217": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31220": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31221": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31295": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },
            "31297": { "city" : "MACON", "state" : "GA", "county" : "BIBB" },"31301": { "city" : "ALLENHURST", "state" : "GA", "county" : "LIBERTY" },
            "31302": { "city" : "BLOOMINGDALE", "state" : "GA", "county" : "CHATHAM" },
            "31303": { "city" : "CLYO", "state" : "GA", "county" : "EFFINGHAM" },
            "31304": { "city" : "CRESCENT", "state" : "GA", "county" : "MCINTOSH" },
            "31305": { "city" : "DARIEN", "state" : "GA", "county" : "MCINTOSH" },
            "31307": { "city" : "EDEN", "state" : "GA", "county" : "EFFINGHAM" },
            "31308": { "city" : "ELLABELL", "state" : "GA", "county" : "BRYAN" },
            "31309": { "city" : "FLEMING", "state" : "GA", "county" : "LIBERTY" },
            "31310": { "city" : "HINESVILLE", "state" : "GA", "county" : "LIBERTY" },
            "31312": { "city" : "GUYTON", "state" : "GA", "county" : "EFFINGHAM" },
            "31313": { "city" : "HINESVILLE", "state" : "GA", "county" : "LIBERTY" },
            "31314": { "city" : "FORT STEWART", "state" : "GA", "county" : "LIBERTY" },
            "31315": { "city" : "FORT STEWART", "state" : "GA", "county" : "LIBERTY" },
            "31316": { "city" : "LUDOWICI", "state" : "GA", "county" : "LONG" },"31318": { "city" : "MELDRIM", "state" : "GA", "county" : "EFFINGHAM" },
            "31319": { "city" : "MERIDIAN", "state" : "GA", "county" : "MCINTOSH" },
            "31320": { "city" : "MIDWAY", "state" : "GA", "county" : "LIBERTY" },
            "31321": { "city" : "PEMBROKE", "state" : "GA", "county" : "BRYAN" },
            "31322": { "city" : "POOLER", "state" : "GA", "county" : "CHATHAM" },
            "31323": { "city" : "RICEBORO", "state" : "GA", "county" : "LIBERTY" },
            "31324": { "city" : "RICHMOND HILL", "state" : "GA", "county" : "BRYAN" },
            "31326": { "city" : "RINCON", "state" : "GA", "county" : "EFFINGHAM" },
            "31328": { "city" : "TYBEE ISLAND", "state" : "GA", "county" : "CHATHAM" },
            "31329": { "city" : "SPRINGFIELD", "state" : "GA", "county" : "EFFINGHAM" },
            "31331": { "city" : "TOWNSEND", "state" : "GA", "county" : "MCINTOSH" },
            "31333": { "city" : "WALTHOURVILLE", "state" : "GA", "county" : "LIBERTY" },
            "31401": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31402": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31403": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31404": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31405": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31406": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31407": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31408": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31409": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31410": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31411": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31412": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31414": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31415": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31416": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31418": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31419": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31420": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31421": { "city" : "SAVANNAH", "state" : "GA", "county" : "CHATHAM" },
            "31501": { "city" : "WAYCROSS", "state" : "GA", "county" : "WARE" },"31502": { "city" : "WAYCROSS", "state" : "GA", "county" : "WARE" },
            "31503": { "city" : "WAYCROSS", "state" : "GA", "county" : "WARE" },"31510": { "city" : "ALMA", "state" : "GA", "county" : "BACON" },
            "31512": { "city" : "AMBROSE", "state" : "GA", "county" : "COFFEE" },
            "31513": { "city" : "BAXLEY", "state" : "GA", "county" : "APPLING" },
            "31515": { "city" : "BAXLEY", "state" : "GA", "county" : "APPLING" },
            "31516": { "city" : "BLACKSHEAR", "state" : "GA", "county" : "PIERCE" },
            "31518": { "city" : "BRISTOL", "state" : "GA", "county" : "PIERCE" },
            "31519": { "city" : "BROXTON", "state" : "GA", "county" : "COFFEE" },
            "31520": { "city" : "BRUNSWICK", "state" : "GA", "county" : "GLYNN" },
            "31521": { "city" : "BRUNSWICK", "state" : "GA", "county" : "GLYNN" },
            "31522": { "city" : "SAINT SIMONS ISLAND", "state" : "GA", "county" : "GLYNN" },
            "31523": { "city" : "BRUNSWICK", "state" : "GA", "county" : "GLYNN" },
            "31524": { "city" : "BRUNSWICK", "state" : "GA", "county" : "GLYNN" },
            "31525": { "city" : "BRUNSWICK", "state" : "GA", "county" : "GLYNN" },
            "31527": { "city" : "JEKYLL ISLAND", "state" : "GA", "county" : "GLYNN" },
            "31532": { "city" : "DENTON", "state" : "GA", "county" : "JEFF DAVIS" },
            "31533": { "city" : "DOUGLAS", "state" : "GA", "county" : "COFFEE" },
            "31534": { "city" : "DOUGLAS", "state" : "GA", "county" : "COFFEE" },
            "31535": { "city" : "DOUGLAS", "state" : "GA", "county" : "COFFEE" },
            "31537": { "city" : "FOLKSTON", "state" : "GA", "county" : "CHARLTON" },
            "31539": { "city" : "HAZLEHURST", "state" : "GA", "county" : "JEFF DAVIS" },
            "31542": { "city" : "HOBOKEN", "state" : "GA", "county" : "BRANTLEY" },
            "31543": { "city" : "HORTENSE", "state" : "GA", "county" : "BRANTLEY" },
            "31544": { "city" : "JACKSONVILLE", "state" : "GA", "county" : "TELFAIR" },
            "31545": { "city" : "JESUP", "state" : "GA", "county" : "WAYNE" },"31546": { "city" : "JESUP", "state" : "GA", "county" : "WAYNE" },
            "31547": { "city" : "KINGS BAY", "state" : "GA", "county" : "CAMDEN" },
            "31548": { "city" : "KINGSLAND", "state" : "GA", "county" : "CAMDEN" },
            "31549": { "city" : "LUMBER CITY", "state" : "GA", "county" : "TELFAIR" },
            "31550": { "city" : "MANOR", "state" : "GA", "county" : "WARE" },"31551": { "city" : "MERSHON", "state" : "GA", "county" : "PIERCE" },
            "31552": { "city" : "MILLWOOD", "state" : "GA", "county" : "WARE" },"31553": { "city" : "NAHUNTA", "state" : "GA", "county" : "BRANTLEY" },
            "31554": { "city" : "NICHOLLS", "state" : "GA", "county" : "COFFEE" },
            "31555": { "city" : "ODUM", "state" : "GA", "county" : "WAYNE" },"31556": { "city" : "OFFERMAN", "state" : "GA", "county" : "PIERCE" },
            "31557": { "city" : "PATTERSON", "state" : "GA", "county" : "PIERCE" },
            "31558": { "city" : "SAINT MARYS", "state" : "GA", "county" : "CAMDEN" },
            "31560": { "city" : "SCREVEN", "state" : "GA", "county" : "WAYNE" },"31561": { "city" : "SEA ISLAND", "state" : "GA", "county" : "GLYNN" },
            "31562": { "city" : "SAINT GEORGE", "state" : "GA", "county" : "CHARLTON" },
            "31563": { "city" : "SURRENCY", "state" : "GA", "county" : "APPLING" },
            "31564": { "city" : "WARESBORO", "state" : "GA", "county" : "WARE" },
            "31565": { "city" : "WAVERLY", "state" : "GA", "county" : "CAMDEN" },
            "31566": { "city" : "WAYNESVILLE", "state" : "GA", "county" : "BRANTLEY" },
            "31567": { "city" : "WEST GREEN", "state" : "GA", "county" : "COFFEE" },
            "31568": { "city" : "WHITE OAK", "state" : "GA", "county" : "CAMDEN" },
            "31569": { "city" : "WOODBINE", "state" : "GA", "county" : "CAMDEN" },
            "31598": { "city" : "JESUP", "state" : "GA", "county" : "WAYNE" },"31601": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31602": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31603": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31604": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31605": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31606": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31620": { "city" : "ADEL", "state" : "GA", "county" : "COOK" },"31622": { "city" : "ALAPAHA", "state" : "GA", "county" : "BERRIEN" },
            "31623": { "city" : "ARGYLE", "state" : "GA", "county" : "CLINCH" },"31624": { "city" : "AXSON", "state" : "GA", "county" : "ATKINSON" },
            "31625": { "city" : "BARNEY", "state" : "GA", "county" : "BROOKS" },"31626": { "city" : "BOSTON", "state" : "GA", "county" : "THOMAS" },
            "31627": { "city" : "CECIL", "state" : "GA", "county" : "COOK" },"31629": { "city" : "DIXIE", "state" : "GA", "county" : "BROOKS" },
            "31630": { "city" : "DU PONT", "state" : "GA", "county" : "CLINCH" },
            "31631": { "city" : "FARGO", "state" : "GA", "county" : "CLINCH" },"31632": { "city" : "HAHIRA", "state" : "GA", "county" : "LOWNDES" },
            "31634": { "city" : "HOMERVILLE", "state" : "GA", "county" : "CLINCH" },
            "31635": { "city" : "LAKELAND", "state" : "GA", "county" : "LANIER" },
            "31636": { "city" : "LAKE PARK", "state" : "GA", "county" : "LOWNDES" },
            "31637": { "city" : "LENOX", "state" : "GA", "county" : "COOK" },"31638": { "city" : "MORVEN", "state" : "GA", "county" : "BROOKS" },
            "31639": { "city" : "NASHVILLE", "state" : "GA", "county" : "BERRIEN" },
            "31641": { "city" : "NAYLOR", "state" : "GA", "county" : "LOWNDES" },
            "31642": { "city" : "PEARSON", "state" : "GA", "county" : "ATKINSON" },
            "31643": { "city" : "QUITMAN", "state" : "GA", "county" : "BROOKS" },
            "31645": { "city" : "RAY CITY", "state" : "GA", "county" : "BERRIEN" },
            "31647": { "city" : "SPARKS", "state" : "GA", "county" : "COOK" },"31648": { "city" : "STATENVILLE", "state" : "GA", "county" : "ECHOLS" },
            "31649": { "city" : "STOCKTON", "state" : "GA", "county" : "LANIER" },
            "31650": { "city" : "WILLACOOCHEE", "state" : "GA", "county" : "ATKINSON" },
            "31698": { "city" : "VALDOSTA", "state" : "GA", "county" : "LOWNDES" },
            "31699": { "city" : "MOODY A F B", "state" : "GA", "county" : "LOWNDES" },
            "31701": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31702": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31703": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31704": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31705": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31706": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31707": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31708": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31709": { "city" : "AMERICUS", "state" : "GA", "county" : "SUMTER" },
            "31711": { "city" : "ANDERSONVILLE", "state" : "GA", "county" : "SUMTER" },
            "31712": { "city" : "ARABI", "state" : "GA", "county" : "CRISP" },"31714": { "city" : "ASHBURN", "state" : "GA", "county" : "TURNER" },
            "31716": { "city" : "BACONTON", "state" : "GA", "county" : "MITCHELL" },
            "31719": { "city" : "AMERICUS", "state" : "GA", "county" : "SUMTER" },
            "31720": { "city" : "BARWICK", "state" : "GA", "county" : "BROOKS" },
            "31721": { "city" : "ALBANY", "state" : "GA", "county" : "DOUGHERTY" },
            "31722": { "city" : "BERLIN", "state" : "GA", "county" : "COLQUITT" },
            "31727": { "city" : "BROOKFIELD", "state" : "GA", "county" : "TIFT" },
            "31730": { "city" : "CAMILLA", "state" : "GA", "county" : "MITCHELL" },
            "31733": { "city" : "CHULA", "state" : "GA", "county" : "TIFT" },"31735": { "city" : "COBB", "state" : "GA", "county" : "SUMTER" },
            "31738": { "city" : "COOLIDGE", "state" : "GA", "county" : "THOMAS" },
            "31743": { "city" : "DE SOTO", "state" : "GA", "county" : "SUMTER" },
            "31744": { "city" : "DOERUN", "state" : "GA", "county" : "COLQUITT" },
            "31747": { "city" : "ELLENTON", "state" : "GA", "county" : "COLQUITT" },
            "31749": { "city" : "ENIGMA", "state" : "GA", "county" : "BERRIEN" },
            "31750": { "city" : "FITZGERALD", "state" : "GA", "county" : "BEN HILL" },
            "31753": { "city" : "FUNSTON", "state" : "GA", "county" : "COLQUITT" },
            "31756": { "city" : "HARTSFIELD", "state" : "GA", "county" : "COLQUITT" },
            "31757": { "city" : "THOMASVILLE", "state" : "GA", "county" : "THOMAS" },
            "31758": { "city" : "THOMASVILLE", "state" : "GA", "county" : "THOMAS" },
            "31760": { "city" : "IRWINVILLE", "state" : "GA", "county" : "IRWIN" },
            "31763": { "city" : "LEESBURG", "state" : "GA", "county" : "LEE" },"31764": { "city" : "LESLIE", "state" : "GA", "county" : "SUMTER" },
            "31765": { "city" : "MEIGS", "state" : "GA", "county" : "THOMAS" },"31768": { "city" : "MOULTRIE", "state" : "GA", "county" : "COLQUITT" },
            "31771": { "city" : "NORMAN PARK", "state" : "GA", "county" : "COLQUITT" },
            "31772": { "city" : "OAKFIELD", "state" : "GA", "county" : "WORTH" },
            "31773": { "city" : "OCHLOCKNEE", "state" : "GA", "county" : "THOMAS" },
            "31774": { "city" : "OCILLA", "state" : "GA", "county" : "IRWIN" },"31775": { "city" : "OMEGA", "state" : "GA", "county" : "TIFT" },
            "31776": { "city" : "MOULTRIE", "state" : "GA", "county" : "COLQUITT" },
            "31778": { "city" : "PAVO", "state" : "GA", "county" : "THOMAS" },"31779": { "city" : "PELHAM", "state" : "GA", "county" : "MITCHELL" },
            "31780": { "city" : "PLAINS", "state" : "GA", "county" : "SUMTER" },"31781": { "city" : "POULAN", "state" : "GA", "county" : "WORTH" },
            "31782": { "city" : "PUTNEY", "state" : "GA", "county" : "DOUGHERTY" },
            "31783": { "city" : "REBECCA", "state" : "GA", "county" : "TURNER" },
            "31784": { "city" : "SALE CITY", "state" : "GA", "county" : "MITCHELL" },
            "31787": { "city" : "SMITHVILLE", "state" : "GA", "county" : "LEE" },
            "31788": { "city" : "MOULTRIE", "state" : "GA", "county" : "COLQUITT" },
            "31789": { "city" : "SUMNER", "state" : "GA", "county" : "WORTH" },"31790": { "city" : "SYCAMORE", "state" : "GA", "county" : "TURNER" },
            "31791": { "city" : "SYLVESTER", "state" : "GA", "county" : "WORTH" },
            "31792": { "city" : "THOMASVILLE", "state" : "GA", "county" : "THOMAS" },
            "31793": { "city" : "TIFTON", "state" : "GA", "county" : "TIFT" },"31794": { "city" : "TIFTON", "state" : "GA", "county" : "TIFT" },
            "31795": { "city" : "TY TY", "state" : "GA", "county" : "TIFT" },"31796": { "city" : "WARWICK", "state" : "GA", "county" : "WORTH" },
            "31798": { "city" : "WRAY", "state" : "GA", "county" : "IRWIN" },"31799": { "city" : "THOMASVILLE", "state" : "GA", "county" : "THOMAS" },
            "31801": { "city" : "BOX SPRINGS", "state" : "GA", "county" : "TALBOT" },
            "31803": { "city" : "BUENA VISTA", "state" : "GA", "county" : "MARION" },
            "31804": { "city" : "CATAULA", "state" : "GA", "county" : "HARRIS" },
            "31805": { "city" : "CUSSETA", "state" : "GA", "county" : "CHATTAHOOCHEE" },
            "31806": { "city" : "ELLAVILLE", "state" : "GA", "county" : "SCHLEY" },
            "31807": { "city" : "ELLERSLIE", "state" : "GA", "county" : "HARRIS" },
            "31808": { "city" : "FORTSON", "state" : "GA", "county" : "MUSCOGEE" },
            "31810": { "city" : "GENEVA", "state" : "GA", "county" : "TALBOT" },"31811": { "city" : "HAMILTON", "state" : "GA", "county" : "HARRIS" },
            "31812": { "city" : "JUNCTION CITY", "state" : "GA", "county" : "TALBOT" },
            "31815": { "city" : "LUMPKIN", "state" : "GA", "county" : "STEWART" },
            "31816": { "city" : "MANCHESTER", "state" : "GA", "county" : "MERIWETHER" },
            "31820": { "city" : "MIDLAND", "state" : "GA", "county" : "MUSCOGEE" },
            "31821": { "city" : "OMAHA", "state" : "GA", "county" : "STEWART" },"31822": { "city" : "PINE MOUNTAIN", "state" : "GA", "county" : "HARRIS" },
            "31823": { "city" : "PINE MOUNTAIN VALLEY", "state" : "GA", "county" : "HARRIS" },
            "31824": { "city" : "PRESTON", "state" : "GA", "county" : "WEBSTER" },
            "31825": { "city" : "RICHLAND", "state" : "GA", "county" : "STEWART" },
            "31826": { "city" : "SHILOH", "state" : "GA", "county" : "HARRIS" },"31827": { "city" : "TALBOTTON", "state" : "GA", "county" : "TALBOT" },
            "31829": { "city" : "UPATOI", "state" : "GA", "county" : "MUSCOGEE" },
            "31830": { "city" : "WARM SPRINGS", "state" : "GA", "county" : "MERIWETHER" },
            "31831": { "city" : "WAVERLY HALL", "state" : "GA", "county" : "HARRIS" },
            "31832": { "city" : "WESTON", "state" : "GA", "county" : "WEBSTER" },
            "31833": { "city" : "WEST POINT", "state" : "GA", "county" : "TROUP" },
            "31836": { "city" : "WOODLAND", "state" : "GA", "county" : "TALBOT" },
            "31901": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31902": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31903": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31904": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31905": { "city" : "FORT BENNING", "state" : "GA", "county" : "MUSCOGEE" },
            "31906": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31907": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31908": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31909": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31914": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31917": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31993": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "31995": { "city" : "FORT BENNING", "state" : "GA", "county" : "MUSCOGEE" },
            "31999": { "city" : "COLUMBUS", "state" : "GA", "county" : "MUSCOGEE" },
            "32003": { "city" : "FLEMING ISLAND", "state" : "FL", "county" : "CLAY" },
            "32004": { "city" : "PONTE VEDRA BEACH", "state" : "FL", "county" : "SAINT JOHNS" },
            "32006": { "city" : "FLEMING ISLAND", "state" : "FL", "county" : "CLAY" },
            "32007": { "city" : "BOSTWICK", "state" : "FL", "county" : "PUTNAM" },
            "32008": { "city" : "BRANFORD", "state" : "FL", "county" : "SUWANNEE" },
            "32009": { "city" : "BRYCEVILLE", "state" : "FL", "county" : "NASSAU" },
            "32011": { "city" : "CALLAHAN", "state" : "FL", "county" : "NASSAU" },
            "32013": { "city" : "DAY", "state" : "FL", "county" : "LAFAYETTE" },"32024": { "city" : "LAKE CITY", "state" : "FL", "county" : "COLUMBIA" },
            "32025": { "city" : "LAKE CITY", "state" : "FL", "county" : "COLUMBIA" },
            "32026": { "city" : "RAIFORD", "state" : "FL", "county" : "UNION" },"32033": { "city" : "ELKTON", "state" : "FL", "county" : "SAINT JOHNS" },
            "32034": { "city" : "FERNANDINA BEACH", "state" : "FL", "county" : "NASSAU" },
            "32035": { "city" : "FERNANDINA BEACH", "state" : "FL", "county" : "NASSAU" },
            "32038": { "city" : "FORT WHITE", "state" : "FL", "county" : "COLUMBIA" },
            "32040": { "city" : "GLEN SAINT MARY", "state" : "FL", "county" : "BAKER" },
            "32041": { "city" : "YULEE", "state" : "FL", "county" : "NASSAU" },"32042": { "city" : "GRAHAM", "state" : "FL", "county" : "BRADFORD" },
            "32043": { "city" : "GREEN COVE SPRINGS", "state" : "FL", "county" : "CLAY" },
            "32044": { "city" : "HAMPTON", "state" : "FL", "county" : "BRADFORD" },
            "32046": { "city" : "HILLIARD", "state" : "FL", "county" : "NASSAU" },
            "32050": { "city" : "MIDDLEBURG", "state" : "FL", "county" : "CLAY" },
            "32052": { "city" : "JASPER", "state" : "FL", "county" : "HAMILTON" },
            "32053": { "city" : "JENNINGS", "state" : "FL", "county" : "HAMILTON" },
            "32054": { "city" : "LAKE BUTLER", "state" : "FL", "county" : "UNION" },
            "32055": { "city" : "LAKE CITY", "state" : "FL", "county" : "COLUMBIA" },
            "32056": { "city" : "LAKE CITY", "state" : "FL", "county" : "COLUMBIA" },
            "32058": { "city" : "LAWTEY", "state" : "FL", "county" : "BRADFORD" },
            "32059": { "city" : "LEE", "state" : "FL", "county" : "MADISON" },"32060": { "city" : "LIVE OAK", "state" : "FL", "county" : "SUWANNEE" },
            "32061": { "city" : "LULU", "state" : "FL", "county" : "COLUMBIA" },"32062": { "city" : "MC ALPIN", "state" : "FL", "county" : "SUWANNEE" },
            "32063": { "city" : "MACCLENNY", "state" : "FL", "county" : "BAKER" },
            "32064": { "city" : "LIVE OAK", "state" : "FL", "county" : "SUWANNEE" },
            "32065": { "city" : "ORANGE PARK", "state" : "FL", "county" : "CLAY" },
            "32066": { "city" : "MAYO", "state" : "FL", "county" : "LAFAYETTE" },
            "32067": { "city" : "ORANGE PARK", "state" : "FL", "county" : "CLAY" },
            "32068": { "city" : "MIDDLEBURG", "state" : "FL", "county" : "CLAY" },
            "32071": { "city" : "O BRIEN", "state" : "FL", "county" : "SUWANNEE" },
            "32072": { "city" : "OLUSTEE", "state" : "FL", "county" : "BAKER" },"32073": { "city" : "ORANGE PARK", "state" : "FL", "county" : "CLAY" },
            "32079": { "city" : "PENNEY FARMS", "state" : "FL", "county" : "CLAY" },
            "32080": { "city" : "SAINT AUGUSTINE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32081": { "city" : "PONTE VEDRA", "state" : "FL", "county" : "SAINT JOHNS" },
            "32082": { "city" : "PONTE VEDRA BEACH", "state" : "FL", "county" : "SAINT JOHNS" },
            "32083": { "city" : "RAIFORD", "state" : "FL", "county" : "UNION" },"32084": { "city" : "SAINT AUGUSTINE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32085": { "city" : "SAINT AUGUSTINE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32086": { "city" : "SAINT AUGUSTINE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32087": { "city" : "SANDERSON", "state" : "FL", "county" : "BAKER" },
            "32091": { "city" : "STARKE", "state" : "FL", "county" : "BRADFORD" },
            "32092": { "city" : "SAINT AUGUSTINE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32094": { "city" : "WELLBORN", "state" : "FL", "county" : "SUWANNEE" },
            "32095": { "city" : "SAINT AUGUSTINE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32096": { "city" : "WHITE SPRINGS", "state" : "FL", "county" : "HAMILTON" },
            "32097": { "city" : "YULEE", "state" : "FL", "county" : "NASSAU" },"32099": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32102": { "city" : "ASTOR", "state" : "FL", "county" : "LAKE" },"32105": { "city" : "BARBERVILLE", "state" : "FL", "county" : "VOLUSIA" },
            "32110": { "city" : "BUNNELL", "state" : "FL", "county" : "FLAGLER" },
            "32111": { "city" : "CANDLER", "state" : "FL", "county" : "MARION" },
            "32112": { "city" : "CRESCENT CITY", "state" : "FL", "county" : "PUTNAM" },
            "32113": { "city" : "CITRA", "state" : "FL", "county" : "MARION" },"32114": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32115": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32116": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32117": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32118": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32119": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32120": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32121": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32122": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32123": { "city" : "PORT ORANGE", "state" : "FL", "county" : "VOLUSIA" },
            "32124": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32125": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32126": { "city" : "DAYTONA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32127": { "city" : "PORT ORANGE", "state" : "FL", "county" : "VOLUSIA" },
            "32128": { "city" : "PORT ORANGE", "state" : "FL", "county" : "VOLUSIA" },
            "32129": { "city" : "PORT ORANGE", "state" : "FL", "county" : "VOLUSIA" },
            "32130": { "city" : "DE LEON SPRINGS", "state" : "FL", "county" : "VOLUSIA" },
            "32131": { "city" : "EAST PALATKA", "state" : "FL", "county" : "PUTNAM" },
            "32132": { "city" : "EDGEWATER", "state" : "FL", "county" : "VOLUSIA" },
            "32133": { "city" : "EASTLAKE WEIR", "state" : "FL", "county" : "MARION" },
            "32134": { "city" : "FORT MC COY", "state" : "FL", "county" : "MARION" },
            "32135": { "city" : "PALM COAST", "state" : "FL", "county" : "FLAGLER" },
            "32136": { "city" : "FLAGLER BEACH", "state" : "FL", "county" : "FLAGLER" },
            "32137": { "city" : "PALM COAST", "state" : "FL", "county" : "FLAGLER" },
            "32138": { "city" : "GRANDIN", "state" : "FL", "county" : "PUTNAM" },
            "32139": { "city" : "GEORGETOWN", "state" : "FL", "county" : "PUTNAM" },
            "32140": { "city" : "FLORAHOME", "state" : "FL", "county" : "PUTNAM" },
            "32141": { "city" : "EDGEWATER", "state" : "FL", "county" : "VOLUSIA" },
            "32142": { "city" : "PALM COAST", "state" : "FL", "county" : "FLAGLER" },
            "32145": { "city" : "HASTINGS", "state" : "FL", "county" : "SAINT JOHNS" },
            "32147": { "city" : "HOLLISTER", "state" : "FL", "county" : "PUTNAM" },
            "32148": { "city" : "INTERLACHEN", "state" : "FL", "county" : "PUTNAM" },
            "32149": { "city" : "EDGAR", "state" : "FL", "county" : "PUTNAM" },"32157": { "city" : "LAKE COMO", "state" : "FL", "county" : "PUTNAM" },
            "32158": { "city" : "LADY LAKE", "state" : "FL", "county" : "LAKE" },
            "32159": { "city" : "LADY LAKE", "state" : "FL", "county" : "LAKE" },
            "32160": { "city" : "LAKE GENEVA", "state" : "FL", "county" : "CLAY" },
            "32162": { "city" : "THE VILLAGES", "state" : "FL", "county" : "SUMTER" },
            "32163": { "city" : "THE VILLAGES", "state" : "FL", "county" : "SUMTER" },
            "32164": { "city" : "PALM COAST", "state" : "FL", "county" : "FLAGLER" },
            "32168": { "city" : "NEW SMYRNA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32169": { "city" : "NEW SMYRNA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32170": { "city" : "NEW SMYRNA BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32173": { "city" : "ORMOND BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32174": { "city" : "ORMOND BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32175": { "city" : "ORMOND BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32176": { "city" : "ORMOND BEACH", "state" : "FL", "county" : "VOLUSIA" },
            "32177": { "city" : "PALATKA", "state" : "FL", "county" : "PUTNAM" },
            "32178": { "city" : "PALATKA", "state" : "FL", "county" : "PUTNAM" },
            "32179": { "city" : "OCKLAWAHA", "state" : "FL", "county" : "MARION" },
            "32180": { "city" : "PIERSON", "state" : "FL", "county" : "VOLUSIA" },
            "32181": { "city" : "POMONA PARK", "state" : "FL", "county" : "PUTNAM" },
            "32182": { "city" : "ORANGE SPRINGS", "state" : "FL", "county" : "MARION" },
            "32183": { "city" : "OCKLAWAHA", "state" : "FL", "county" : "MARION" },
            "32185": { "city" : "PUTNAM HALL", "state" : "FL", "county" : "PUTNAM" },
            "32187": { "city" : "SAN MATEO", "state" : "FL", "county" : "PUTNAM" },
            "32189": { "city" : "SATSUMA", "state" : "FL", "county" : "PUTNAM" },
            "32190": { "city" : "SEVILLE", "state" : "FL", "county" : "VOLUSIA" },
            "32192": { "city" : "SPARR", "state" : "FL", "county" : "MARION" },"32193": { "city" : "WELAKA", "state" : "FL", "county" : "PUTNAM" },
            "32195": { "city" : "WEIRSDALE", "state" : "FL", "county" : "MARION" },
            "32201": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32202": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32203": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32204": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32205": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32206": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32207": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32208": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32209": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32210": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32211": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32212": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32214": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32215": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32216": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32217": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32218": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32219": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32220": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32221": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32222": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32223": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32224": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32225": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32226": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32227": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32228": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32229": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32230": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32231": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32232": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32233": { "city" : "ATLANTIC BEACH", "state" : "FL", "county" : "DUVAL" },
            "32234": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32235": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32236": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32238": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32239": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32240": { "city" : "JACKSONVILLE BEACH", "state" : "FL", "county" : "DUVAL" },
            "32241": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32244": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32245": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32246": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32247": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32250": { "city" : "JACKSONVILLE BEACH", "state" : "FL", "county" : "DUVAL" },
            "32254": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32255": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32256": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32257": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32258": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32259": { "city" : "SAINT JOHNS", "state" : "FL", "county" : "SAINT JOHNS" },
            "32260": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "SAINT JOHNS" },
            "32266": { "city" : "NEPTUNE BEACH", "state" : "FL", "county" : "DUVAL" },
            "32277": { "city" : "JACKSONVILLE", "state" : "FL", "county" : "DUVAL" },
            "32301": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32302": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32303": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32304": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32305": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32306": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32307": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32308": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32309": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32310": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32311": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32312": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32313": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32314": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32315": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32316": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32317": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32318": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32320": { "city" : "APALACHICOLA", "state" : "FL", "county" : "FRANKLIN" },
            "32321": { "city" : "BRISTOL", "state" : "FL", "county" : "LIBERTY" },
            "32322": { "city" : "CARRABELLE", "state" : "FL", "county" : "FRANKLIN" },
            "32323": { "city" : "LANARK VILLAGE", "state" : "FL", "county" : "FRANKLIN" },
            "32324": { "city" : "CHATTAHOOCHEE", "state" : "FL", "county" : "GADSDEN" },
            "32326": { "city" : "CRAWFORDVILLE", "state" : "FL", "county" : "WAKULLA" },
            "32327": { "city" : "CRAWFORDVILLE", "state" : "FL", "county" : "WAKULLA" },
            "32328": { "city" : "EASTPOINT", "state" : "FL", "county" : "FRANKLIN" },
            "32329": { "city" : "APALACHICOLA", "state" : "FL", "county" : "FRANKLIN" },
            "32330": { "city" : "GREENSBORO", "state" : "FL", "county" : "GADSDEN" },
            "32331": { "city" : "GREENVILLE", "state" : "FL", "county" : "MADISON" },
            "32332": { "city" : "GRETNA", "state" : "FL", "county" : "GADSDEN" },
            "32333": { "city" : "HAVANA", "state" : "FL", "county" : "GADSDEN" },
            "32334": { "city" : "HOSFORD", "state" : "FL", "county" : "LIBERTY" },
            "32336": { "city" : "LAMONT", "state" : "FL", "county" : "JEFFERSON" },
            "32337": { "city" : "LLOYD", "state" : "FL", "county" : "JEFFERSON" },
            "32340": { "city" : "MADISON", "state" : "FL", "county" : "MADISON" },
            "32341": { "city" : "MADISON", "state" : "FL", "county" : "MADISON" },
            "32343": { "city" : "MIDWAY", "state" : "FL", "county" : "GADSDEN" },
            "32344": { "city" : "MONTICELLO", "state" : "FL", "county" : "JEFFERSON" },
            "32345": { "city" : "MONTICELLO", "state" : "FL", "county" : "JEFFERSON" },
            "32346": { "city" : "PANACEA", "state" : "FL", "county" : "WAKULLA" },
            "32347": { "city" : "PERRY", "state" : "FL", "county" : "TAYLOR" },"32348": { "city" : "PERRY", "state" : "FL", "county" : "TAYLOR" },
            "32350": { "city" : "PINETTA", "state" : "FL", "county" : "MADISON" },
            "32351": { "city" : "QUINCY", "state" : "FL", "county" : "GADSDEN" },
            "32352": { "city" : "QUINCY", "state" : "FL", "county" : "GADSDEN" },
            "32353": { "city" : "QUINCY", "state" : "FL", "county" : "GADSDEN" },
            "32355": { "city" : "SAINT MARKS", "state" : "FL", "county" : "WAKULLA" },
            "32356": { "city" : "SALEM", "state" : "FL", "county" : "TAYLOR" },"32357": { "city" : "SHADY GROVE", "state" : "FL", "county" : "TAYLOR" },
            "32358": { "city" : "SOPCHOPPY", "state" : "FL", "county" : "WAKULLA" },
            "32359": { "city" : "STEINHATCHEE", "state" : "FL", "county" : "TAYLOR" },
            "32360": { "city" : "TELOGIA", "state" : "FL", "county" : "LIBERTY" },
            "32361": { "city" : "WACISSA", "state" : "FL", "county" : "JEFFERSON" },
            "32362": { "city" : "WOODVILLE", "state" : "FL", "county" : "LEON" },
            "32395": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32399": { "city" : "TALLAHASSEE", "state" : "FL", "county" : "LEON" },
            "32401": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32402": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32403": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32404": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32405": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32406": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32407": { "city" : "PANAMA CITY BEACH", "state" : "FL", "county" : "BAY" },
            "32408": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32409": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32410": { "city" : "MEXICO BEACH", "state" : "FL", "county" : "BAY" },
            "32411": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32412": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32413": { "city" : "PANAMA CITY BEACH", "state" : "FL", "county" : "BAY" },
            "32417": { "city" : "PANAMA CITY", "state" : "FL", "county" : "BAY" },
            "32420": { "city" : "ALFORD", "state" : "FL", "county" : "JACKSON" },
            "32421": { "city" : "ALTHA", "state" : "FL", "county" : "CALHOUN" },"32422": { "city" : "ARGYLE", "state" : "FL", "county" : "WALTON" },
            "32423": { "city" : "BASCOM", "state" : "FL", "county" : "JACKSON" },
            "32424": { "city" : "BLOUNTSTOWN", "state" : "FL", "county" : "CALHOUN" },
            "32425": { "city" : "BONIFAY", "state" : "FL", "county" : "HOLMES" },
            "32426": { "city" : "CAMPBELLTON", "state" : "FL", "county" : "JACKSON" },
            "32427": { "city" : "CARYVILLE", "state" : "FL", "county" : "WASHINGTON" },
            "32428": { "city" : "CHIPLEY", "state" : "FL", "county" : "WASHINGTON" },
            "32430": { "city" : "CLARKSVILLE", "state" : "FL", "county" : "CALHOUN" },
            "32431": { "city" : "COTTONDALE", "state" : "FL", "county" : "JACKSON" },
            "32433": { "city" : "DEFUNIAK SPRINGS", "state" : "FL", "county" : "WALTON" },
            "32434": { "city" : "MOSSY HEAD", "state" : "FL", "county" : "WALTON" },
            "32435": { "city" : "DEFUNIAK SPRINGS", "state" : "FL", "county" : "WALTON" },
            "32437": { "city" : "EBRO", "state" : "FL", "county" : "WASHINGTON" },
            "32438": { "city" : "FOUNTAIN", "state" : "FL", "county" : "BAY" },"32439": { "city" : "FREEPORT", "state" : "FL", "county" : "WALTON" },
            "32440": { "city" : "GRACEVILLE", "state" : "FL", "county" : "JACKSON" },
            "32442": { "city" : "GRAND RIDGE", "state" : "FL", "county" : "JACKSON" },
            "32443": { "city" : "GREENWOOD", "state" : "FL", "county" : "JACKSON" },
            "32444": { "city" : "LYNN HAVEN", "state" : "FL", "county" : "BAY" },
            "32445": { "city" : "MALONE", "state" : "FL", "county" : "JACKSON" },
            "32446": { "city" : "MARIANNA", "state" : "FL", "county" : "JACKSON" },
            "32447": { "city" : "MARIANNA", "state" : "FL", "county" : "JACKSON" },
            "32448": { "city" : "MARIANNA", "state" : "FL", "county" : "JACKSON" },
            "32449": { "city" : "WEWAHITCHKA", "state" : "FL", "county" : "CALHOUN" },
            "32452": { "city" : "NOMA", "state" : "FL", "county" : "HOLMES" },"32455": { "city" : "PONCE DE LEON", "state" : "FL", "county" : "WALTON" },
            "32456": { "city" : "PORT SAINT JOE", "state" : "FL", "county" : "GULF" },
            "32457": { "city" : "PORT SAINT JOE", "state" : "FL", "county" : "GULF" },
            "32459": { "city" : "SANTA ROSA BEACH", "state" : "FL", "county" : "WALTON" },
            "32460": { "city" : "SNEADS", "state" : "FL", "county" : "JACKSON" },
            "32461": { "city" : "ROSEMARY BEACH", "state" : "FL", "county" : "WALTON" },
            "32462": { "city" : "VERNON", "state" : "FL", "county" : "WASHINGTON" },
            "32463": { "city" : "WAUSAU", "state" : "FL", "county" : "WASHINGTON" },
            "32464": { "city" : "WESTVILLE", "state" : "FL", "county" : "HOLMES" },
            "32465": { "city" : "WEWAHITCHKA", "state" : "FL", "county" : "GULF" },
            "32466": { "city" : "YOUNGSTOWN", "state" : "FL", "county" : "BAY" },
            "32501": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32502": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32503": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32504": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32505": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32506": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32507": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32508": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32509": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32511": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32512": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32513": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32514": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32516": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32520": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32521": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32522": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32523": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32524": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32526": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32530": { "city" : "BAGDAD", "state" : "FL", "county" : "SANTA ROSA" },
            "32531": { "city" : "BAKER", "state" : "FL", "county" : "OKALOOSA" },
            "32533": { "city" : "CANTONMENT", "state" : "FL", "county" : "ESCAMBIA" },
            "32534": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32535": { "city" : "CENTURY", "state" : "FL", "county" : "ESCAMBIA" },
            "32536": { "city" : "CRESTVIEW", "state" : "FL", "county" : "OKALOOSA" },
            "32537": { "city" : "MILLIGAN", "state" : "FL", "county" : "OKALOOSA" },
            "32538": { "city" : "PAXTON", "state" : "FL", "county" : "WALTON" },"32539": { "city" : "CRESTVIEW", "state" : "FL", "county" : "OKALOOSA" },
            "32540": { "city" : "DESTIN", "state" : "FL", "county" : "OKALOOSA" },
            "32541": { "city" : "DESTIN", "state" : "FL", "county" : "OKALOOSA" },
            "32542": { "city" : "EGLIN AFB", "state" : "FL", "county" : "OKALOOSA" },
            "32544": { "city" : "HURLBURT FIELD", "state" : "FL", "county" : "OKALOOSA" },
            "32547": { "city" : "FORT WALTON BEACH", "state" : "FL", "county" : "OKALOOSA" },
            "32548": { "city" : "FORT WALTON BEACH", "state" : "FL", "county" : "OKALOOSA" },
            "32549": { "city" : "FORT WALTON BEACH", "state" : "FL", "county" : "OKALOOSA" },
            "32550": { "city" : "MIRAMAR BEACH", "state" : "FL", "county" : "WALTON" },
            "32560": { "city" : "GONZALEZ", "state" : "FL", "county" : "ESCAMBIA" },
            "32561": { "city" : "GULF BREEZE", "state" : "FL", "county" : "SANTA ROSA" },
            "32562": { "city" : "GULF BREEZE", "state" : "FL", "county" : "SANTA ROSA" },
            "32563": { "city" : "GULF BREEZE", "state" : "FL", "county" : "SANTA ROSA" },
            "32564": { "city" : "HOLT", "state" : "FL", "county" : "OKALOOSA" },"32565": { "city" : "JAY", "state" : "FL", "county" : "SANTA ROSA" },
            "32566": { "city" : "NAVARRE", "state" : "FL", "county" : "SANTA ROSA" },
            "32567": { "city" : "LAUREL HILL", "state" : "FL", "county" : "OKALOOSA" },
            "32568": { "city" : "MC DAVID", "state" : "FL", "county" : "ESCAMBIA" },
            "32569": { "city" : "MARY ESTHER", "state" : "FL", "county" : "OKALOOSA" },
            "32570": { "city" : "MILTON", "state" : "FL", "county" : "SANTA ROSA" },
            "32571": { "city" : "MILTON", "state" : "FL", "county" : "SANTA ROSA" },
            "32572": { "city" : "MILTON", "state" : "FL", "county" : "SANTA ROSA" },
            "32577": { "city" : "MOLINO", "state" : "FL", "county" : "ESCAMBIA" },
            "32578": { "city" : "NICEVILLE", "state" : "FL", "county" : "OKALOOSA" },
            "32579": { "city" : "SHALIMAR", "state" : "FL", "county" : "OKALOOSA" },
            "32580": { "city" : "VALPARAISO", "state" : "FL", "county" : "OKALOOSA" },
            "32583": { "city" : "MILTON", "state" : "FL", "county" : "SANTA ROSA" },
            "32588": { "city" : "NICEVILLE", "state" : "FL", "county" : "OKALOOSA" },
            "32591": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32592": { "city" : "PENSACOLA", "state" : "FL", "county" : "ESCAMBIA" },
            "32601": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32602": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32603": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32604": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32605": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32606": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32607": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32608": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32609": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32610": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32611": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32613": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32614": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32615": { "city" : "ALACHUA", "state" : "FL", "county" : "ALACHUA" },
            "32616": { "city" : "ALACHUA", "state" : "FL", "county" : "ALACHUA" },
            "32617": { "city" : "ANTHONY", "state" : "FL", "county" : "MARION" },
            "32618": { "city" : "ARCHER", "state" : "FL", "county" : "ALACHUA" },
            "32619": { "city" : "BELL", "state" : "FL", "county" : "GILCHRIST" },
            "32621": { "city" : "BRONSON", "state" : "FL", "county" : "LEVY" },"32622": { "city" : "BROOKER", "state" : "FL", "county" : "BRADFORD" },
            "32625": { "city" : "CEDAR KEY", "state" : "FL", "county" : "LEVY" },
            "32626": { "city" : "CHIEFLAND", "state" : "FL", "county" : "LEVY" },
            "32627": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32628": { "city" : "CROSS CITY", "state" : "FL", "county" : "DIXIE" },
            "32631": { "city" : "EARLETON", "state" : "FL", "county" : "ALACHUA" },
            "32634": { "city" : "FAIRFIELD", "state" : "FL", "county" : "MARION" },
            "32635": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32639": { "city" : "GULF HAMMOCK", "state" : "FL", "county" : "LEVY" },
            "32640": { "city" : "HAWTHORNE", "state" : "FL", "county" : "ALACHUA" },
            "32641": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32643": { "city" : "HIGH SPRINGS", "state" : "FL", "county" : "ALACHUA" },
            "32644": { "city" : "CHIEFLAND", "state" : "FL", "county" : "LEVY" },
            "32648": { "city" : "HORSESHOE BEACH", "state" : "FL", "county" : "DIXIE" },
            "32653": { "city" : "GAINESVILLE", "state" : "FL", "county" : "ALACHUA" },
            "32654": { "city" : "ISLAND GROVE", "state" : "FL", "county" : "ALACHUA" },
            "32655": { "city" : "HIGH SPRINGS", "state" : "FL", "county" : "ALACHUA" },
            "32656": { "city" : "KEYSTONE HEIGHTS", "state" : "FL", "county" : "CLAY" },
            "32658": { "city" : "LA CROSSE", "state" : "FL", "county" : "ALACHUA" },
            "32662": { "city" : "LOCHLOOSA", "state" : "FL", "county" : "ALACHUA" },
            "32663": { "city" : "LOWELL", "state" : "FL", "county" : "MARION" },"32664": { "city" : "MC INTOSH", "state" : "FL", "county" : "MARION" },
            "32666": { "city" : "MELROSE", "state" : "FL", "county" : "PUTNAM" },
            "32667": { "city" : "MICANOPY", "state" : "FL", "county" : "ALACHUA" },
            "32668": { "city" : "MORRISTON", "state" : "FL", "county" : "LEVY" },
            "32669": { "city" : "NEWBERRY", "state" : "FL", "county" : "ALACHUA" },
            "32680": { "city" : "OLD TOWN", "state" : "FL", "county" : "DIXIE" },
            "32681": { "city" : "ORANGE LAKE", "state" : "FL", "county" : "MARION" },
            "32683": { "city" : "OTTER CREEK", "state" : "FL", "county" : "LEVY" },
            "32686": { "city" : "REDDICK", "state" : "FL", "county" : "MARION" },
            "32692": { "city" : "SUWANNEE", "state" : "FL", "county" : "DIXIE" },
            "32693": { "city" : "TRENTON", "state" : "FL", "county" : "GILCHRIST" },
            "32694": { "city" : "WALDO", "state" : "FL", "county" : "ALACHUA" },"32696": { "city" : "WILLISTON", "state" : "FL", "county" : "LEVY" },
            "32697": { "city" : "WORTHINGTON SPRINGS", "state" : "FL", "county" : "UNION" },
            "32701": { "city" : "ALTAMONTE SPRINGS", "state" : "FL", "county" : "SEMINOLE" },
            "32702": { "city" : "ALTOONA", "state" : "FL", "county" : "LAKE" },"32703": { "city" : "APOPKA", "state" : "FL", "county" : "ORANGE" },
            "32704": { "city" : "APOPKA", "state" : "FL", "county" : "ORANGE" },"32706": { "city" : "CASSADAGA", "state" : "FL", "county" : "VOLUSIA" },
            "32707": { "city" : "CASSELBERRY", "state" : "FL", "county" : "SEMINOLE" },
            "32708": { "city" : "WINTER SPRINGS", "state" : "FL", "county" : "SEMINOLE" },
            "32709": { "city" : "CHRISTMAS", "state" : "FL", "county" : "ORANGE" },
            "32710": { "city" : "CLARCONA", "state" : "FL", "county" : "ORANGE" },
            "32712": { "city" : "APOPKA", "state" : "FL", "county" : "ORANGE" },"32713": { "city" : "DEBARY", "state" : "FL", "county" : "VOLUSIA" },
            "32714": { "city" : "ALTAMONTE SPRINGS", "state" : "FL", "county" : "SEMINOLE" },
            "32715": { "city" : "ALTAMONTE SPRINGS", "state" : "FL", "county" : "SEMINOLE" },
            "32716": { "city" : "ALTAMONTE SPRINGS", "state" : "FL", "county" : "SEMINOLE" },
            "32718": { "city" : "CASSELBERRY", "state" : "FL", "county" : "SEMINOLE" },
            "32719": { "city" : "WINTER SPRINGS", "state" : "FL", "county" : "SEMINOLE" },
            "32720": { "city" : "DELAND", "state" : "FL", "county" : "VOLUSIA" },
            "32721": { "city" : "DELAND", "state" : "FL", "county" : "VOLUSIA" },
            "32722": { "city" : "GLENWOOD", "state" : "FL", "county" : "VOLUSIA" },
            "32723": { "city" : "DELAND", "state" : "FL", "county" : "VOLUSIA" },
            "32724": { "city" : "DELAND", "state" : "FL", "county" : "VOLUSIA" },
            "32725": { "city" : "DELTONA", "state" : "FL", "county" : "VOLUSIA" },
            "32726": { "city" : "EUSTIS", "state" : "FL", "county" : "LAKE" },"32727": { "city" : "EUSTIS", "state" : "FL", "county" : "LAKE" },
            "32728": { "city" : "DELTONA", "state" : "FL", "county" : "VOLUSIA" },
            "32730": { "city" : "CASSELBERRY", "state" : "FL", "county" : "SEMINOLE" },
            "32732": { "city" : "GENEVA", "state" : "FL", "county" : "SEMINOLE" },
            "32733": { "city" : "GOLDENROD", "state" : "FL", "county" : "SEMINOLE" },
            "32735": { "city" : "GRAND ISLAND", "state" : "FL", "county" : "LAKE" },
            "32736": { "city" : "EUSTIS", "state" : "FL", "county" : "LAKE" },"32738": { "city" : "DELTONA", "state" : "FL", "county" : "VOLUSIA" },
            "32739": { "city" : "DELTONA", "state" : "FL", "county" : "VOLUSIA" },
            "32744": { "city" : "LAKE HELEN", "state" : "FL", "county" : "VOLUSIA" },
            "32745": { "city" : "MID FLORIDA", "state" : "FL", "county" : "SEMINOLE" },
            "32746": { "city" : "LAKE MARY", "state" : "FL", "county" : "SEMINOLE" },
            "32747": { "city" : "LAKE MONROE", "state" : "FL", "county" : "SEMINOLE" },
            "32750": { "city" : "LONGWOOD", "state" : "FL", "county" : "SEMINOLE" },
            "32751": { "city" : "MAITLAND", "state" : "FL", "county" : "ORANGE" },
            "32752": { "city" : "LONGWOOD", "state" : "FL", "county" : "SEMINOLE" },
            "32753": { "city" : "DEBARY", "state" : "FL", "county" : "VOLUSIA" },
            "32754": { "city" : "MIMS", "state" : "FL", "county" : "BREVARD" },"32756": { "city" : "MOUNT DORA", "state" : "FL", "county" : "LAKE" },
            "32757": { "city" : "MOUNT DORA", "state" : "FL", "county" : "LAKE" },
            "32759": { "city" : "OAK HILL", "state" : "FL", "county" : "VOLUSIA" },
            "32762": { "city" : "OVIEDO", "state" : "FL", "county" : "SEMINOLE" },
            "32763": { "city" : "ORANGE CITY", "state" : "FL", "county" : "VOLUSIA" },
            "32764": { "city" : "OSTEEN", "state" : "FL", "county" : "VOLUSIA" },
            "32765": { "city" : "OVIEDO", "state" : "FL", "county" : "SEMINOLE" },
            "32766": { "city" : "OVIEDO", "state" : "FL", "county" : "SEMINOLE" },
            "32767": { "city" : "PAISLEY", "state" : "FL", "county" : "LAKE" },"32768": { "city" : "PLYMOUTH", "state" : "FL", "county" : "ORANGE" },
            "32771": { "city" : "SANFORD", "state" : "FL", "county" : "SEMINOLE" },
            "32772": { "city" : "SANFORD", "state" : "FL", "county" : "SEMINOLE" },
            "32773": { "city" : "SANFORD", "state" : "FL", "county" : "SEMINOLE" },
            "32774": { "city" : "ORANGE CITY", "state" : "FL", "county" : "VOLUSIA" },
            "32775": { "city" : "SCOTTSMOOR", "state" : "FL", "county" : "BREVARD" },
            "32776": { "city" : "SORRENTO", "state" : "FL", "county" : "LAKE" },"32777": { "city" : "TANGERINE", "state" : "FL", "county" : "ORANGE" },
            "32778": { "city" : "TAVARES", "state" : "FL", "county" : "LAKE" },"32779": { "city" : "LONGWOOD", "state" : "FL", "county" : "SEMINOLE" },
            "32780": { "city" : "TITUSVILLE", "state" : "FL", "county" : "BREVARD" },
            "32781": { "city" : "TITUSVILLE", "state" : "FL", "county" : "BREVARD" },
            "32782": { "city" : "TITUSVILLE", "state" : "FL", "county" : "BREVARD" },
            "32783": { "city" : "TITUSVILLE", "state" : "FL", "county" : "BREVARD" },
            "32784": { "city" : "UMATILLA", "state" : "FL", "county" : "LAKE" },"32789": { "city" : "WINTER PARK", "state" : "FL", "county" : "ORANGE" },
            "32790": { "city" : "WINTER PARK", "state" : "FL", "county" : "ORANGE" },
            "32791": { "city" : "LONGWOOD", "state" : "FL", "county" : "SEMINOLE" },
            "32792": { "city" : "WINTER PARK", "state" : "FL", "county" : "ORANGE" },
            "32793": { "city" : "WINTER PARK", "state" : "FL", "county" : "ORANGE" },
            "32794": { "city" : "MAITLAND", "state" : "FL", "county" : "ORANGE" },
            "32795": { "city" : "LAKE MARY", "state" : "FL", "county" : "SEMINOLE" },
            "32796": { "city" : "TITUSVILLE", "state" : "FL", "county" : "BREVARD" },
            "32798": { "city" : "ZELLWOOD", "state" : "FL", "county" : "ORANGE" },
            "32799": { "city" : "MID FLORIDA", "state" : "FL", "county" : "SEMINOLE" },
            "32801": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32802": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32803": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32804": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32805": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32806": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32807": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32808": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32809": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32810": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32811": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32812": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32814": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32815": { "city" : "ORLANDO", "state" : "FL", "county" : "BREVARD" },
            "32816": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32817": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32818": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32819": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32820": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32821": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32822": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32824": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32825": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32826": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32827": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32828": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32829": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32830": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32831": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32832": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32833": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32834": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32835": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32836": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32837": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32839": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32853": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32854": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32855": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32856": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32857": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32858": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32859": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32860": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32861": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32862": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32867": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32868": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32869": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32872": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32877": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32878": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32887": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32897": { "city" : "ORLANDO", "state" : "FL", "county" : "ORANGE" },
            "32899": { "city" : "ORLANDO", "state" : "FL", "county" : "BREVARD" },
            "32901": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32902": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32903": { "city" : "INDIALANTIC", "state" : "FL", "county" : "BREVARD" },
            "32904": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32905": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32906": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32907": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32908": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32909": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32910": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32911": { "city" : "PALM BAY", "state" : "FL", "county" : "BREVARD" },
            "32912": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32919": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32920": { "city" : "CAPE CANAVERAL", "state" : "FL", "county" : "BREVARD" },
            "32922": { "city" : "COCOA", "state" : "FL", "county" : "BREVARD" },"32923": { "city" : "COCOA", "state" : "FL", "county" : "BREVARD" },
            "32924": { "city" : "COCOA", "state" : "FL", "county" : "BREVARD" },"32925": { "city" : "PATRICK AFB", "state" : "FL", "county" : "BREVARD" },
            "32926": { "city" : "COCOA", "state" : "FL", "county" : "BREVARD" },"32927": { "city" : "COCOA", "state" : "FL", "county" : "BREVARD" },
            "32931": { "city" : "COCOA BEACH", "state" : "FL", "county" : "BREVARD" },
            "32932": { "city" : "COCOA BEACH", "state" : "FL", "county" : "BREVARD" },
            "32934": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32935": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32936": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32937": { "city" : "SATELLITE BEACH", "state" : "FL", "county" : "BREVARD" },
            "32940": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32941": { "city" : "MELBOURNE", "state" : "FL", "county" : "BREVARD" },
            "32948": { "city" : "FELLSMERE", "state" : "FL", "county" : "INDIAN RIVER" },
            "32949": { "city" : "GRANT", "state" : "FL", "county" : "BREVARD" },"32950": { "city" : "MALABAR", "state" : "FL", "county" : "BREVARD" },
            "32951": { "city" : "MELBOURNE BEACH", "state" : "FL", "county" : "BREVARD" },
            "32952": { "city" : "MERRITT ISLAND", "state" : "FL", "county" : "BREVARD" },
            "32953": { "city" : "MERRITT ISLAND", "state" : "FL", "county" : "BREVARD" },
            "32954": { "city" : "MERRITT ISLAND", "state" : "FL", "county" : "BREVARD" },
            "32955": { "city" : "ROCKLEDGE", "state" : "FL", "county" : "BREVARD" },
            "32956": { "city" : "ROCKLEDGE", "state" : "FL", "county" : "BREVARD" },
            "32957": { "city" : "ROSELAND", "state" : "FL", "county" : "INDIAN RIVER" },
            "32958": { "city" : "SEBASTIAN", "state" : "FL", "county" : "INDIAN RIVER" },
            "32959": { "city" : "SHARPES", "state" : "FL", "county" : "BREVARD" },
            "32960": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32961": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32962": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32963": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32964": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32965": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32966": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32967": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32968": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32969": { "city" : "VERO BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32970": { "city" : "WABASSO", "state" : "FL", "county" : "INDIAN RIVER" },
            "32971": { "city" : "WINTER BEACH", "state" : "FL", "county" : "INDIAN RIVER" },
            "32976": { "city" : "SEBASTIAN", "state" : "FL", "county" : "BREVARD" },
            "32978": { "city" : "SEBASTIAN", "state" : "FL", "county" : "INDIAN RIVER" },
            "33001": { "city" : "LONG KEY", "state" : "FL", "county" : "MONROE" },
            "33002": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33004": { "city" : "DANIA", "state" : "FL", "county" : "BROWARD" },"33008": { "city" : "HALLANDALE", "state" : "FL", "county" : "BROWARD" },
            "33009": { "city" : "HALLANDALE", "state" : "FL", "county" : "BROWARD" },
            "33010": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33011": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33012": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33013": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33014": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33015": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33016": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33017": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33018": { "city" : "HIALEAH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33019": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33020": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33021": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33022": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33023": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33024": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33025": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33026": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33027": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33028": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33029": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33030": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33031": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33032": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33033": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33034": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33035": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33036": { "city" : "ISLAMORADA", "state" : "FL", "county" : "MONROE" },
            "33037": { "city" : "KEY LARGO", "state" : "FL", "county" : "MONROE" },
            "33039": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33040": { "city" : "KEY WEST", "state" : "FL", "county" : "MONROE" },
            "33041": { "city" : "KEY WEST", "state" : "FL", "county" : "MONROE" },
            "33042": { "city" : "SUMMERLAND KEY", "state" : "FL", "county" : "MONROE" },
            "33043": { "city" : "BIG PINE KEY", "state" : "FL", "county" : "MONROE" },
            "33045": { "city" : "KEY WEST", "state" : "FL", "county" : "MONROE" },
            "33050": { "city" : "MARATHON", "state" : "FL", "county" : "MONROE" },
            "33051": { "city" : "KEY COLONY BEACH", "state" : "FL", "county" : "MONROE" },
            "33052": { "city" : "MARATHON SHORES", "state" : "FL", "county" : "MONROE" },
            "33054": { "city" : "OPA LOCKA", "state" : "FL", "county" : "MIAMI-DADE" },
            "33055": { "city" : "OPA LOCKA", "state" : "FL", "county" : "MIAMI-DADE" },
            "33056": { "city" : "OPA LOCKA", "state" : "FL", "county" : "MIAMI-DADE" },
            "33060": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33061": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33062": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33063": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33064": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33065": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33066": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33067": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33068": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33069": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33070": { "city" : "TAVERNIER", "state" : "FL", "county" : "MONROE" },
            "33071": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33073": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33074": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33075": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33076": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33077": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33081": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33082": { "city" : "PEMBROKE PINES", "state" : "FL", "county" : "BROWARD" },
            "33083": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33084": { "city" : "HOLLYWOOD", "state" : "FL", "county" : "BROWARD" },
            "33090": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33092": { "city" : "HOMESTEAD", "state" : "FL", "county" : "MIAMI-DADE" },
            "33093": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33097": { "city" : "POMPANO BEACH", "state" : "FL", "county" : "BROWARD" },
            "33101": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33102": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33109": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33111": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33112": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33114": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33116": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33119": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33122": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33124": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33125": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33126": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33127": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33128": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33129": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33130": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33131": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33132": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33133": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33134": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33135": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33136": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33137": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33138": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33139": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33140": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33141": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33142": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33143": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33144": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33145": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33146": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33147": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33149": { "city" : "KEY BISCAYNE", "state" : "FL", "county" : "MIAMI-DADE" },
            "33150": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33151": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33152": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33153": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33154": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33155": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33156": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33157": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33158": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33159": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33160": { "city" : "NORTH MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33161": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33162": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33163": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33164": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33165": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33166": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33167": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33168": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33169": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33170": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33172": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33173": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33174": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33175": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33176": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33177": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33178": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33179": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33180": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33181": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33182": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33183": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33184": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33185": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33186": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33187": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33188": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33189": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33190": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33193": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33194": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33196": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33197": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33199": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33222": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33231": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33233": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33238": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33239": { "city" : "MIAMI BEACH", "state" : "FL", "county" : "MIAMI-DADE" },
            "33242": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33243": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33245": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33247": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33255": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33256": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33257": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33261": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33265": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33266": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33269": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33280": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33283": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33296": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33299": { "city" : "MIAMI", "state" : "FL", "county" : "MIAMI-DADE" },
            "33301": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33302": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33303": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33304": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33305": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33306": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33307": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33308": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33309": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33310": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33311": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33312": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33313": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33314": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33315": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33316": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33317": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33318": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33319": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33320": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33321": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33322": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33323": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33324": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33325": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33326": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33327": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33328": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33329": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33330": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33331": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33332": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33334": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33335": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33336": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33337": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33338": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33339": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33340": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33345": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33346": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33348": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33349": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33351": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33355": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33359": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33388": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33394": { "city" : "FORT LAUDERDALE", "state" : "FL", "county" : "BROWARD" },
            "33401": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33402": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33403": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33404": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33405": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33406": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33407": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33408": { "city" : "NORTH PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33409": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33410": { "city" : "PALM BEACH GARDENS", "state" : "FL", "county" : "PALM BEACH" },
            "33411": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33412": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33413": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33414": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33415": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33416": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33417": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33418": { "city" : "PALM BEACH GARDENS", "state" : "FL", "county" : "PALM BEACH" },
            "33419": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33420": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33421": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33422": { "city" : "WEST PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33424": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33425": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33426": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33427": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33428": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33429": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33430": { "city" : "BELLE GLADE", "state" : "FL", "county" : "PALM BEACH" },
            "33431": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33432": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33433": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33434": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33435": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33436": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33437": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33438": { "city" : "CANAL POINT", "state" : "FL", "county" : "PALM BEACH" },
            "33440": { "city" : "CLEWISTON", "state" : "FL", "county" : "HENDRY" },
            "33441": { "city" : "DEERFIELD BEACH", "state" : "FL", "county" : "BROWARD" },
            "33442": { "city" : "DEERFIELD BEACH", "state" : "FL", "county" : "BROWARD" },
            "33443": { "city" : "DEERFIELD BEACH", "state" : "FL", "county" : "BROWARD" },
            "33444": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33445": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33446": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33448": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33449": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33454": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33455": { "city" : "HOBE SOUND", "state" : "FL", "county" : "MARTIN" },
            "33458": { "city" : "JUPITER", "state" : "FL", "county" : "PALM BEACH" },
            "33459": { "city" : "LAKE HARBOR", "state" : "FL", "county" : "PALM BEACH" },
            "33460": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33461": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33462": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33463": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33464": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33465": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33466": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33467": { "city" : "LAKE WORTH", "state" : "FL", "county" : "PALM BEACH" },
            "33468": { "city" : "JUPITER", "state" : "FL", "county" : "PALM BEACH" },
            "33469": { "city" : "JUPITER", "state" : "FL", "county" : "PALM BEACH" },
            "33470": { "city" : "LOXAHATCHEE", "state" : "FL", "county" : "PALM BEACH" },
            "33471": { "city" : "MOORE HAVEN", "state" : "FL", "county" : "GLADES" },
            "33472": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33473": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33474": { "city" : "BOYNTON BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33475": { "city" : "HOBE SOUND", "state" : "FL", "county" : "MARTIN" },
            "33476": { "city" : "PAHOKEE", "state" : "FL", "county" : "PALM BEACH" },
            "33477": { "city" : "JUPITER", "state" : "FL", "county" : "PALM BEACH" },
            "33478": { "city" : "JUPITER", "state" : "FL", "county" : "PALM BEACH" },
            "33480": { "city" : "PALM BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33481": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33482": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33483": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33484": { "city" : "DELRAY BEACH", "state" : "FL", "county" : "PALM BEACH" },
            "33486": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33487": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33488": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33493": { "city" : "SOUTH BAY", "state" : "FL", "county" : "PALM BEACH" },
            "33496": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33497": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33498": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33499": { "city" : "BOCA RATON", "state" : "FL", "county" : "PALM BEACH" },
            "33503": { "city" : "BALM", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33508": { "city" : "BRANDON", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33509": { "city" : "BRANDON", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33510": { "city" : "BRANDON", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33511": { "city" : "BRANDON", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33513": { "city" : "BUSHNELL", "state" : "FL", "county" : "SUMTER" },
            "33514": { "city" : "CENTER HILL", "state" : "FL", "county" : "SUMTER" },
            "33521": { "city" : "COLEMAN", "state" : "FL", "county" : "SUMTER" },
            "33523": { "city" : "DADE CITY", "state" : "FL", "county" : "PASCO" },
            "33524": { "city" : "CRYSTAL SPRINGS", "state" : "FL", "county" : "PASCO" },
            "33525": { "city" : "DADE CITY", "state" : "FL", "county" : "PASCO" },
            "33526": { "city" : "DADE CITY", "state" : "FL", "county" : "PASCO" },
            "33527": { "city" : "DOVER", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33530": { "city" : "DURANT", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33534": { "city" : "GIBSONTON", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33537": { "city" : "LACOOCHEE", "state" : "FL", "county" : "PASCO" },
            "33538": { "city" : "LAKE PANASOFFKEE", "state" : "FL", "county" : "SUMTER" },
            "33539": { "city" : "ZEPHYRHILLS", "state" : "FL", "county" : "PASCO" },
            "33540": { "city" : "ZEPHYRHILLS", "state" : "FL", "county" : "PASCO" },
            "33541": { "city" : "ZEPHYRHILLS", "state" : "FL", "county" : "PASCO" },
            "33542": { "city" : "ZEPHYRHILLS", "state" : "FL", "county" : "PASCO" },
            "33543": { "city" : "WESLEY CHAPEL", "state" : "FL", "county" : "PASCO" },
            "33544": { "city" : "WESLEY CHAPEL", "state" : "FL", "county" : "PASCO" },
            "33545": { "city" : "WESLEY CHAPEL", "state" : "FL", "county" : "PASCO" },
            "33547": { "city" : "LITHIA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33548": { "city" : "LUTZ", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33549": { "city" : "LUTZ", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33550": { "city" : "MANGO", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33556": { "city" : "ODESSA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33558": { "city" : "LUTZ", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33559": { "city" : "LUTZ", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33563": { "city" : "PLANT CITY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33564": { "city" : "PLANT CITY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33565": { "city" : "PLANT CITY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33566": { "city" : "PLANT CITY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33567": { "city" : "PLANT CITY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33568": { "city" : "RIVERVIEW", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33569": { "city" : "RIVERVIEW", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33570": { "city" : "RUSKIN", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33571": { "city" : "SUN CITY CENTER", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33572": { "city" : "APOLLO BEACH", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33573": { "city" : "SUN CITY CENTER", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33574": { "city" : "SAINT LEO", "state" : "FL", "county" : "PASCO" },
            "33575": { "city" : "RUSKIN", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33576": { "city" : "SAN ANTONIO", "state" : "FL", "county" : "PASCO" },
            "33578": { "city" : "RIVERVIEW", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33579": { "city" : "RIVERVIEW", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33583": { "city" : "SEFFNER", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33584": { "city" : "SEFFNER", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33585": { "city" : "SUMTERVILLE", "state" : "FL", "county" : "SUMTER" },
            "33586": { "city" : "SUN CITY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33587": { "city" : "SYDNEY", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33592": { "city" : "THONOTOSASSA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33593": { "city" : "TRILBY", "state" : "FL", "county" : "PASCO" },"33594": { "city" : "VALRICO", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33595": { "city" : "VALRICO", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33596": { "city" : "VALRICO", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33597": { "city" : "WEBSTER", "state" : "FL", "county" : "SUMTER" },
            "33598": { "city" : "WIMAUMA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33601": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33602": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33603": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33604": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33605": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33606": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33607": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33608": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33609": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33610": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33611": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33612": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33613": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33614": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33615": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33616": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33617": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33618": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33619": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33620": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33621": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33622": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33623": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33624": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33625": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33626": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33629": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33630": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33633": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33634": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33635": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33637": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33646": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33647": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33661": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33662": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33672": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33673": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33674": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33675": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33677": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33679": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33680": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33681": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33682": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33684": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33685": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33686": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33687": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33688": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33689": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33694": { "city" : "TAMPA", "state" : "FL", "county" : "HILLSBOROUGH" },
            "33701": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33702": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33703": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33704": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33705": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33706": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33707": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33708": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33709": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33710": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33711": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33712": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33713": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33714": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33715": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33716": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33729": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33730": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33731": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33732": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33733": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33734": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33736": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33737": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33738": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33740": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33741": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33742": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33743": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33744": { "city" : "BAY PINES", "state" : "FL", "county" : "PINELLAS" },
            "33747": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33755": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33756": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33757": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33758": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33759": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33760": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33761": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33762": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33763": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33764": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33765": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33766": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33767": { "city" : "CLEARWATER BEACH", "state" : "FL", "county" : "PINELLAS" },
            "33769": { "city" : "CLEARWATER", "state" : "FL", "county" : "PINELLAS" },
            "33770": { "city" : "LARGO", "state" : "FL", "county" : "PINELLAS" },
            "33771": { "city" : "LARGO", "state" : "FL", "county" : "PINELLAS" },
            "33772": { "city" : "SEMINOLE", "state" : "FL", "county" : "PINELLAS" },
            "33773": { "city" : "LARGO", "state" : "FL", "county" : "PINELLAS" },
            "33774": { "city" : "LARGO", "state" : "FL", "county" : "PINELLAS" },
            "33775": { "city" : "SEMINOLE", "state" : "FL", "county" : "PINELLAS" },
            "33776": { "city" : "SEMINOLE", "state" : "FL", "county" : "PINELLAS" },
            "33777": { "city" : "SEMINOLE", "state" : "FL", "county" : "PINELLAS" },
            "33778": { "city" : "LARGO", "state" : "FL", "county" : "PINELLAS" },
            "33779": { "city" : "LARGO", "state" : "FL", "county" : "PINELLAS" },
            "33780": { "city" : "PINELLAS PARK", "state" : "FL", "county" : "PINELLAS" },
            "33781": { "city" : "PINELLAS PARK", "state" : "FL", "county" : "PINELLAS" },
            "33782": { "city" : "PINELLAS PARK", "state" : "FL", "county" : "PINELLAS" },
            "33784": { "city" : "SAINT PETERSBURG", "state" : "FL", "county" : "PINELLAS" },
            "33785": { "city" : "INDIAN ROCKS BEACH", "state" : "FL", "county" : "PINELLAS" },
            "33786": { "city" : "BELLEAIR BEACH", "state" : "FL", "county" : "PINELLAS" },
            "33801": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33802": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },
            "33803": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33804": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },
            "33805": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33806": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },
            "33807": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33809": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },
            "33810": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33811": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },
            "33812": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33813": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },
            "33815": { "city" : "LAKELAND", "state" : "FL", "county" : "POLK" },"33820": { "city" : "ALTURAS", "state" : "FL", "county" : "POLK" },
            "33823": { "city" : "AUBURNDALE", "state" : "FL", "county" : "POLK" },
            "33825": { "city" : "AVON PARK", "state" : "FL", "county" : "HIGHLANDS" },
            "33826": { "city" : "AVON PARK", "state" : "FL", "county" : "HIGHLANDS" },
            "33827": { "city" : "BABSON PARK", "state" : "FL", "county" : "POLK" },
            "33830": { "city" : "BARTOW", "state" : "FL", "county" : "POLK" },"33831": { "city" : "BARTOW", "state" : "FL", "county" : "POLK" },
            "33834": { "city" : "BOWLING GREEN", "state" : "FL", "county" : "HARDEE" },
            "33835": { "city" : "BRADLEY", "state" : "FL", "county" : "POLK" },"33836": { "city" : "DAVENPORT", "state" : "FL", "county" : "POLK" },
            "33837": { "city" : "DAVENPORT", "state" : "FL", "county" : "POLK" },
            "33838": { "city" : "DUNDEE", "state" : "FL", "county" : "POLK" },"33839": { "city" : "EAGLE LAKE", "state" : "FL", "county" : "POLK" },
            "33840": { "city" : "EATON PARK", "state" : "FL", "county" : "POLK" },
            "33841": { "city" : "FORT MEADE", "state" : "FL", "county" : "POLK" },
            "33843": { "city" : "FROSTPROOF", "state" : "FL", "county" : "POLK" },
            "33844": { "city" : "HAINES CITY", "state" : "FL", "county" : "POLK" },
            "33845": { "city" : "HAINES CITY", "state" : "FL", "county" : "POLK" },
            "33846": { "city" : "HIGHLAND CITY", "state" : "FL", "county" : "POLK" },
            "33847": { "city" : "HOMELAND", "state" : "FL", "county" : "POLK" },"33848": { "city" : "INTERCESSION CITY", "state" : "FL", "county" : "OSCEOLA" },
            "33849": { "city" : "KATHLEEN", "state" : "FL", "county" : "POLK" },"33850": { "city" : "LAKE ALFRED", "state" : "FL", "county" : "POLK" },
            "33851": { "city" : "LAKE HAMILTON", "state" : "FL", "county" : "POLK" },
            "33852": { "city" : "LAKE PLACID", "state" : "FL", "county" : "HIGHLANDS" },
            "33853": { "city" : "LAKE WALES", "state" : "FL", "county" : "POLK" },
            "33854": { "city" : "LAKESHORE", "state" : "FL", "county" : "POLK" },
            "33855": { "city" : "INDIAN LAKE ESTATES", "state" : "FL", "county" : "POLK" },
            "33856": { "city" : "NALCREST", "state" : "FL", "county" : "POLK" },"33857": { "city" : "LORIDA", "state" : "FL", "county" : "HIGHLANDS" },
            "33858": { "city" : "LOUGHMAN", "state" : "FL", "county" : "POLK" },"33859": { "city" : "LAKE WALES", "state" : "FL", "county" : "POLK" },
            "33860": { "city" : "MULBERRY", "state" : "FL", "county" : "POLK" },"33862": { "city" : "LAKE PLACID", "state" : "FL", "county" : "HIGHLANDS" },
            "33863": { "city" : "NICHOLS", "state" : "FL", "county" : "POLK" },"33865": { "city" : "ONA", "state" : "FL", "county" : "HARDEE" },
            "33867": { "city" : "RIVER RANCH", "state" : "FL", "county" : "POLK" },
            "33868": { "city" : "POLK CITY", "state" : "FL", "county" : "POLK" },
            "33870": { "city" : "SEBRING", "state" : "FL", "county" : "HIGHLANDS" },
            "33871": { "city" : "SEBRING", "state" : "FL", "county" : "HIGHLANDS" },
            "33872": { "city" : "SEBRING", "state" : "FL", "county" : "HIGHLANDS" },
            "33873": { "city" : "WAUCHULA", "state" : "FL", "county" : "HARDEE" },
            "33875": { "city" : "SEBRING", "state" : "FL", "county" : "HIGHLANDS" },
            "33876": { "city" : "SEBRING", "state" : "FL", "county" : "HIGHLANDS" },
            "33877": { "city" : "WAVERLY", "state" : "FL", "county" : "POLK" },"33880": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33881": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33882": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33883": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33884": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33885": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33888": { "city" : "WINTER HAVEN", "state" : "FL", "county" : "POLK" },
            "33890": { "city" : "ZOLFO SPRINGS", "state" : "FL", "county" : "HARDEE" },
            "33896": { "city" : "DAVENPORT", "state" : "FL", "county" : "POLK" },
            "33897": { "city" : "DAVENPORT", "state" : "FL", "county" : "POLK" },
            "33898": { "city" : "LAKE WALES", "state" : "FL", "county" : "POLK" },
            "33901": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33902": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33903": { "city" : "NORTH FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33904": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33905": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33906": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33907": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33908": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33909": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33910": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33911": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33912": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33913": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33914": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33915": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33916": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33917": { "city" : "NORTH FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33918": { "city" : "NORTH FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33919": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33920": { "city" : "ALVA", "state" : "FL", "county" : "LEE" },"33921": { "city" : "BOCA GRANDE", "state" : "FL", "county" : "LEE" },
            "33922": { "city" : "BOKEELIA", "state" : "FL", "county" : "LEE" },"33924": { "city" : "CAPTIVA", "state" : "FL", "county" : "LEE" },
            "33928": { "city" : "ESTERO", "state" : "FL", "county" : "LEE" },"33929": { "city" : "ESTERO", "state" : "FL", "county" : "LEE" },
            "33930": { "city" : "FELDA", "state" : "FL", "county" : "HENDRY" },"33931": { "city" : "FORT MYERS BEACH", "state" : "FL", "county" : "LEE" },
            "33932": { "city" : "FORT MYERS BEACH", "state" : "FL", "county" : "LEE" },
            "33935": { "city" : "LABELLE", "state" : "FL", "county" : "HENDRY" },
            "33936": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33938": { "city" : "MURDOCK", "state" : "FL", "county" : "CHARLOTTE" },
            "33944": { "city" : "PALMDALE", "state" : "FL", "county" : "GLADES" },
            "33945": { "city" : "PINELAND", "state" : "FL", "county" : "LEE" },"33946": { "city" : "PLACIDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33947": { "city" : "ROTONDA WEST", "state" : "FL", "county" : "CHARLOTTE" },
            "33948": { "city" : "PORT CHARLOTTE", "state" : "FL", "county" : "CHARLOTTE" },
            "33949": { "city" : "PORT CHARLOTTE", "state" : "FL", "county" : "CHARLOTTE" },
            "33950": { "city" : "PUNTA GORDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33951": { "city" : "PUNTA GORDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33952": { "city" : "PORT CHARLOTTE", "state" : "FL", "county" : "CHARLOTTE" },
            "33953": { "city" : "PORT CHARLOTTE", "state" : "FL", "county" : "CHARLOTTE" },
            "33954": { "city" : "PORT CHARLOTTE", "state" : "FL", "county" : "CHARLOTTE" },
            "33955": { "city" : "PUNTA GORDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33956": { "city" : "SAINT JAMES CITY", "state" : "FL", "county" : "LEE" },
            "33957": { "city" : "SANIBEL", "state" : "FL", "county" : "LEE" },"33960": { "city" : "VENUS", "state" : "FL", "county" : "HIGHLANDS" },
            "33965": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33966": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33967": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "33970": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33971": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33972": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33973": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33974": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33975": { "city" : "LABELLE", "state" : "FL", "county" : "HENDRY" },
            "33976": { "city" : "LEHIGH ACRES", "state" : "FL", "county" : "LEE" },
            "33980": { "city" : "PUNTA GORDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33981": { "city" : "PORT CHARLOTTE", "state" : "FL", "county" : "CHARLOTTE" },
            "33982": { "city" : "PUNTA GORDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33983": { "city" : "PUNTA GORDA", "state" : "FL", "county" : "CHARLOTTE" },
            "33990": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33991": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33993": { "city" : "CAPE CORAL", "state" : "FL", "county" : "LEE" },
            "33994": { "city" : "FORT MYERS", "state" : "FL", "county" : "LEE" },
            "34101": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34102": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34103": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34104": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34105": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34106": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34107": { "city" : "VANDERBILT BEACH", "state" : "FL", "county" : "COLLIER" },
            "34108": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34109": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34110": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34112": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34113": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34114": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34116": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34117": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34119": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34120": { "city" : "NAPLES", "state" : "FL", "county" : "COLLIER" },
            "34133": { "city" : "BONITA SPRINGS", "state" : "FL", "county" : "LEE" },
            "34134": { "city" : "BONITA SPRINGS", "state" : "FL", "county" : "LEE" },
            "34135": { "city" : "BONITA SPRINGS", "state" : "FL", "county" : "LEE" },
            "34136": { "city" : "BONITA SPRINGS", "state" : "FL", "county" : "LEE" },
            "34137": { "city" : "COPELAND", "state" : "FL", "county" : "COLLIER" },
            "34138": { "city" : "CHOKOLOSKEE", "state" : "FL", "county" : "COLLIER" },
            "34139": { "city" : "EVERGLADES CITY", "state" : "FL", "county" : "COLLIER" },
            "34140": { "city" : "GOODLAND", "state" : "FL", "county" : "COLLIER" },
            "34141": { "city" : "OCHOPEE", "state" : "FL", "county" : "MIAMI-DADE" },
            "34142": { "city" : "IMMOKALEE", "state" : "FL", "county" : "COLLIER" },
            "34143": { "city" : "IMMOKALEE", "state" : "FL", "county" : "COLLIER" },
            "34145": { "city" : "MARCO ISLAND", "state" : "FL", "county" : "COLLIER" },
            "34146": { "city" : "MARCO ISLAND", "state" : "FL", "county" : "COLLIER" },
            "34201": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34202": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34203": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34204": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34205": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34206": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34207": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34208": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34209": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34210": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34211": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34212": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34215": { "city" : "CORTEZ", "state" : "FL", "county" : "MANATEE" },
            "34216": { "city" : "ANNA MARIA", "state" : "FL", "county" : "MANATEE" },
            "34217": { "city" : "BRADENTON BEACH", "state" : "FL", "county" : "MANATEE" },
            "34218": { "city" : "HOLMES BEACH", "state" : "FL", "county" : "MANATEE" },
            "34219": { "city" : "PARRISH", "state" : "FL", "county" : "MANATEE" },
            "34220": { "city" : "PALMETTO", "state" : "FL", "county" : "MANATEE" },
            "34221": { "city" : "PALMETTO", "state" : "FL", "county" : "MANATEE" },
            "34222": { "city" : "ELLENTON", "state" : "FL", "county" : "MANATEE" },
            "34223": { "city" : "ENGLEWOOD", "state" : "FL", "county" : "SARASOTA" },
            "34224": { "city" : "ENGLEWOOD", "state" : "FL", "county" : "CHARLOTTE" },
            "34228": { "city" : "LONGBOAT KEY", "state" : "FL", "county" : "MANATEE" },
            "34229": { "city" : "OSPREY", "state" : "FL", "county" : "SARASOTA" },
            "34230": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34231": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34232": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34233": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34234": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34235": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34236": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34237": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34238": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34239": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34240": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34241": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34242": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34243": { "city" : "SARASOTA", "state" : "FL", "county" : "MANATEE" },
            "34250": { "city" : "TERRA CEIA", "state" : "FL", "county" : "MANATEE" },
            "34251": { "city" : "MYAKKA CITY", "state" : "FL", "county" : "MANATEE" },
            "34260": { "city" : "SARASOTA", "state" : "FL", "county" : "MANATEE" },
            "34264": { "city" : "ONECO", "state" : "FL", "county" : "MANATEE" },"34265": { "city" : "ARCADIA", "state" : "FL", "county" : "DE SOTO" },
            "34266": { "city" : "ARCADIA", "state" : "FL", "county" : "DE SOTO" },
            "34267": { "city" : "FORT OGDEN", "state" : "FL", "county" : "DE SOTO" },
            "34268": { "city" : "NOCATEE", "state" : "FL", "county" : "DE SOTO" },
            "34269": { "city" : "ARCADIA", "state" : "FL", "county" : "DE SOTO" },
            "34270": { "city" : "TALLEVAST", "state" : "FL", "county" : "MANATEE" },
            "34272": { "city" : "LAUREL", "state" : "FL", "county" : "SARASOTA" },
            "34274": { "city" : "NOKOMIS", "state" : "FL", "county" : "SARASOTA" },
            "34275": { "city" : "NOKOMIS", "state" : "FL", "county" : "SARASOTA" },
            "34276": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34277": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34278": { "city" : "SARASOTA", "state" : "FL", "county" : "SARASOTA" },
            "34280": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34282": { "city" : "BRADENTON", "state" : "FL", "county" : "MANATEE" },
            "34284": { "city" : "VENICE", "state" : "FL", "county" : "SARASOTA" },
            "34285": { "city" : "VENICE", "state" : "FL", "county" : "SARASOTA" },
            "34286": { "city" : "NORTH PORT", "state" : "FL", "county" : "SARASOTA" },
            "34287": { "city" : "NORTH PORT", "state" : "FL", "county" : "SARASOTA" },
            "34288": { "city" : "NORTH PORT", "state" : "FL", "county" : "SARASOTA" },
            "34289": { "city" : "NORTH PORT", "state" : "FL", "county" : "SARASOTA" },
            "34290": { "city" : "NORTH PORT", "state" : "FL", "county" : "SARASOTA" },
            "34291": { "city" : "NORTH PORT", "state" : "FL", "county" : "SARASOTA" },
            "34292": { "city" : "VENICE", "state" : "FL", "county" : "SARASOTA" },
            "34293": { "city" : "VENICE", "state" : "FL", "county" : "SARASOTA" },
            "34295": { "city" : "ENGLEWOOD", "state" : "FL", "county" : "SARASOTA" },
            "34420": { "city" : "BELLEVIEW", "state" : "FL", "county" : "MARION" },
            "34421": { "city" : "BELLEVIEW", "state" : "FL", "county" : "MARION" },
            "34423": { "city" : "CRYSTAL RIVER", "state" : "FL", "county" : "CITRUS" },
            "34428": { "city" : "CRYSTAL RIVER", "state" : "FL", "county" : "CITRUS" },
            "34429": { "city" : "CRYSTAL RIVER", "state" : "FL", "county" : "CITRUS" },
            "34430": { "city" : "DUNNELLON", "state" : "FL", "county" : "MARION" },
            "34431": { "city" : "DUNNELLON", "state" : "FL", "county" : "MARION" },
            "34432": { "city" : "DUNNELLON", "state" : "FL", "county" : "MARION" },
            "34433": { "city" : "DUNNELLON", "state" : "FL", "county" : "CITRUS" },
            "34434": { "city" : "DUNNELLON", "state" : "FL", "county" : "CITRUS" },
            "34436": { "city" : "FLORAL CITY", "state" : "FL", "county" : "CITRUS" },
            "34442": { "city" : "HERNANDO", "state" : "FL", "county" : "CITRUS" },
            "34445": { "city" : "HOLDER", "state" : "FL", "county" : "CITRUS" },"34446": { "city" : "HOMOSASSA", "state" : "FL", "county" : "CITRUS" },
            "34447": { "city" : "HOMOSASSA SPRINGS", "state" : "FL", "county" : "CITRUS" },
            "34448": { "city" : "HOMOSASSA", "state" : "FL", "county" : "CITRUS" },
            "34449": { "city" : "INGLIS", "state" : "FL", "county" : "LEVY" },"34450": { "city" : "INVERNESS", "state" : "FL", "county" : "CITRUS" },
            "34451": { "city" : "INVERNESS", "state" : "FL", "county" : "CITRUS" },
            "34452": { "city" : "INVERNESS", "state" : "FL", "county" : "CITRUS" },
            "34453": { "city" : "INVERNESS", "state" : "FL", "county" : "CITRUS" },
            "34460": { "city" : "LECANTO", "state" : "FL", "county" : "CITRUS" },
            "34461": { "city" : "LECANTO", "state" : "FL", "county" : "CITRUS" },
            "34464": { "city" : "BEVERLY HILLS", "state" : "FL", "county" : "CITRUS" },
            "34465": { "city" : "BEVERLY HILLS", "state" : "FL", "county" : "CITRUS" },
            "34470": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34471": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34472": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34473": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34474": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34475": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34476": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34477": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34478": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34479": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34480": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34481": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34482": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },"34483": { "city" : "OCALA", "state" : "FL", "county" : "MARION" },
            "34484": { "city" : "OXFORD", "state" : "FL", "county" : "SUMTER" },"34487": { "city" : "HOMOSASSA", "state" : "FL", "county" : "CITRUS" },
            "34488": { "city" : "SILVER SPRINGS", "state" : "FL", "county" : "MARION" },
            "34489": { "city" : "SILVER SPRINGS", "state" : "FL", "county" : "MARION" },
            "34491": { "city" : "SUMMERFIELD", "state" : "FL", "county" : "MARION" },
            "34492": { "city" : "SUMMERFIELD", "state" : "FL", "county" : "MARION" },
            "34498": { "city" : "YANKEETOWN", "state" : "FL", "county" : "LEVY" },
            "34601": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34602": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34603": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34604": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34605": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34606": { "city" : "SPRING HILL", "state" : "FL", "county" : "HERNANDO" },
            "34607": { "city" : "SPRING HILL", "state" : "FL", "county" : "HERNANDO" },
            "34608": { "city" : "SPRING HILL", "state" : "FL", "county" : "HERNANDO" },
            "34609": { "city" : "SPRING HILL", "state" : "FL", "county" : "HERNANDO" },
            "34610": { "city" : "SPRING HILL", "state" : "FL", "county" : "PASCO" },
            "34611": { "city" : "SPRING HILL", "state" : "FL", "county" : "HERNANDO" },
            "34613": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34614": { "city" : "BROOKSVILLE", "state" : "FL", "county" : "HERNANDO" },
            "34636": { "city" : "ISTACHATTA", "state" : "FL", "county" : "HERNANDO" },
            "34637": { "city" : "LAND O LAKES", "state" : "FL", "county" : "PASCO" },
            "34638": { "city" : "LAND O LAKES", "state" : "FL", "county" : "PASCO" },
            "34639": { "city" : "LAND O LAKES", "state" : "FL", "county" : "PASCO" },
            "34652": { "city" : "NEW PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34653": { "city" : "NEW PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34654": { "city" : "NEW PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34655": { "city" : "NEW PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34656": { "city" : "NEW PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34660": { "city" : "OZONA", "state" : "FL", "county" : "PINELLAS" },
            "34661": { "city" : "NOBLETON", "state" : "FL", "county" : "HERNANDO" },
            "34667": { "city" : "HUDSON", "state" : "FL", "county" : "PASCO" },"34668": { "city" : "PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34669": { "city" : "HUDSON", "state" : "FL", "county" : "PASCO" },"34673": { "city" : "PORT RICHEY", "state" : "FL", "county" : "PASCO" },
            "34674": { "city" : "HUDSON", "state" : "FL", "county" : "PASCO" },"34677": { "city" : "OLDSMAR", "state" : "FL", "county" : "PINELLAS" },
            "34679": { "city" : "ARIPEKA", "state" : "FL", "county" : "PASCO" },"34680": { "city" : "ELFERS", "state" : "FL", "county" : "PASCO" },
            "34681": { "city" : "CRYSTAL BEACH", "state" : "FL", "county" : "PINELLAS" },
            "34682": { "city" : "PALM HARBOR", "state" : "FL", "county" : "PINELLAS" },
            "34683": { "city" : "PALM HARBOR", "state" : "FL", "county" : "PINELLAS" },
            "34684": { "city" : "PALM HARBOR", "state" : "FL", "county" : "PINELLAS" },
            "34685": { "city" : "PALM HARBOR", "state" : "FL", "county" : "PINELLAS" },
            "34688": { "city" : "TARPON SPRINGS", "state" : "FL", "county" : "PINELLAS" },
            "34689": { "city" : "TARPON SPRINGS", "state" : "FL", "county" : "PINELLAS" },
            "34690": { "city" : "HOLIDAY", "state" : "FL", "county" : "PASCO" },"34691": { "city" : "HOLIDAY", "state" : "FL", "county" : "PASCO" },
            "34695": { "city" : "SAFETY HARBOR", "state" : "FL", "county" : "PINELLAS" },
            "34697": { "city" : "DUNEDIN", "state" : "FL", "county" : "PINELLAS" },
            "34698": { "city" : "DUNEDIN", "state" : "FL", "county" : "PINELLAS" },
            "34705": { "city" : "ASTATULA", "state" : "FL", "county" : "LAKE" },"34711": { "city" : "CLERMONT", "state" : "FL", "county" : "LAKE" },
            "34712": { "city" : "CLERMONT", "state" : "FL", "county" : "LAKE" },"34713": { "city" : "CLERMONT", "state" : "FL", "county" : "LAKE" },
            "34714": { "city" : "CLERMONT", "state" : "FL", "county" : "LAKE" },"34715": { "city" : "CLERMONT", "state" : "FL", "county" : "LAKE" },
            "34729": { "city" : "FERNDALE", "state" : "FL", "county" : "LAKE" },"34731": { "city" : "FRUITLAND PARK", "state" : "FL", "county" : "LAKE" },
            "34734": { "city" : "GOTHA", "state" : "FL", "county" : "ORANGE" },"34736": { "city" : "GROVELAND", "state" : "FL", "county" : "LAKE" },
            "34737": { "city" : "HOWEY IN THE HILLS", "state" : "FL", "county" : "LAKE" },
            "34739": { "city" : "KENANSVILLE", "state" : "FL", "county" : "OSCEOLA" },
            "34740": { "city" : "KILLARNEY", "state" : "FL", "county" : "ORANGE" },
            "34741": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34742": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34743": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34744": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34745": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34746": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34747": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34748": { "city" : "LEESBURG", "state" : "FL", "county" : "LAKE" },"34749": { "city" : "LEESBURG", "state" : "FL", "county" : "LAKE" },
            "34753": { "city" : "MASCOTTE", "state" : "FL", "county" : "LAKE" },"34755": { "city" : "MINNEOLA", "state" : "FL", "county" : "LAKE" },
            "34756": { "city" : "MONTVERDE", "state" : "FL", "county" : "LAKE" },
            "34758": { "city" : "KISSIMMEE", "state" : "FL", "county" : "OSCEOLA" },
            "34759": { "city" : "KISSIMMEE", "state" : "FL", "county" : "POLK" },
            "34760": { "city" : "OAKLAND", "state" : "FL", "county" : "ORANGE" },
            "34761": { "city" : "OCOEE", "state" : "FL", "county" : "ORANGE" },"34762": { "city" : "OKAHUMPKA", "state" : "FL", "county" : "LAKE" },
            "34769": { "city" : "SAINT CLOUD", "state" : "FL", "county" : "OSCEOLA" },
            "34770": { "city" : "SAINT CLOUD", "state" : "FL", "county" : "OSCEOLA" },
            "34771": { "city" : "SAINT CLOUD", "state" : "FL", "county" : "OSCEOLA" },
            "34772": { "city" : "SAINT CLOUD", "state" : "FL", "county" : "OSCEOLA" },
            "34773": { "city" : "SAINT CLOUD", "state" : "FL", "county" : "OSCEOLA" },
            "34777": { "city" : "WINTER GARDEN", "state" : "FL", "county" : "ORANGE" },
            "34778": { "city" : "WINTER GARDEN", "state" : "FL", "county" : "ORANGE" },
            "34785": { "city" : "WILDWOOD", "state" : "FL", "county" : "SUMTER" },
            "34786": { "city" : "WINDERMERE", "state" : "FL", "county" : "ORANGE" },
            "34787": { "city" : "WINTER GARDEN", "state" : "FL", "county" : "ORANGE" },
            "34788": { "city" : "LEESBURG", "state" : "FL", "county" : "LAKE" },"34789": { "city" : "LEESBURG", "state" : "FL", "county" : "LAKE" },
            "34797": { "city" : "YALAHA", "state" : "FL", "county" : "LAKE" },"34945": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34946": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34947": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34948": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34949": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34950": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34951": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34952": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34953": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34954": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34956": { "city" : "INDIANTOWN", "state" : "FL", "county" : "MARTIN" },
            "34957": { "city" : "JENSEN BEACH", "state" : "FL", "county" : "MARTIN" },
            "34958": { "city" : "JENSEN BEACH", "state" : "FL", "county" : "MARTIN" },
            "34972": { "city" : "OKEECHOBEE", "state" : "FL", "county" : "OKEECHOBEE" },
            "34973": { "city" : "OKEECHOBEE", "state" : "FL", "county" : "OKEECHOBEE" },
            "34974": { "city" : "OKEECHOBEE", "state" : "FL", "county" : "OKEECHOBEE" },
            "34979": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34981": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34982": { "city" : "FORT PIERCE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34983": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34984": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34985": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34986": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34987": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34988": { "city" : "PORT SAINT LUCIE", "state" : "FL", "county" : "SAINT LUCIE" },
            "34990": { "city" : "PALM CITY", "state" : "FL", "county" : "MARTIN" },
            "34991": { "city" : "PALM CITY", "state" : "FL", "county" : "MARTIN" },
            "34992": { "city" : "PORT SALERNO", "state" : "FL", "county" : "MARTIN" },
            "34994": { "city" : "STUART", "state" : "FL", "county" : "MARTIN" },"34995": { "city" : "STUART", "state" : "FL", "county" : "MARTIN" },
            "34996": { "city" : "STUART", "state" : "FL", "county" : "MARTIN" },"34997": { "city" : "STUART", "state" : "FL", "county" : "MARTIN" },
            "35004": { "city" : "MOODY", "state" : "AL", "county" : "SAINT CLAIR" },
            "35005": { "city" : "ADAMSVILLE", "state" : "AL", "county" : "JEFFERSON" },
            "35006": { "city" : "ADGER", "state" : "AL", "county" : "JEFFERSON" },
            "35007": { "city" : "ALABASTER", "state" : "AL", "county" : "SHELBY" },
            "35010": { "city" : "ALEXANDER CITY", "state" : "AL", "county" : "TALLAPOOSA" },
            "35011": { "city" : "ALEXANDER CITY", "state" : "AL", "county" : "TALLAPOOSA" },
            "35013": { "city" : "ALLGOOD", "state" : "AL", "county" : "BLOUNT" },
            "35014": { "city" : "ALPINE", "state" : "AL", "county" : "TALLADEGA" },
            "35015": { "city" : "ALTON", "state" : "AL", "county" : "JEFFERSON" },
            "35016": { "city" : "ARAB", "state" : "AL", "county" : "MARSHALL" },"35019": { "city" : "BAILEYTON", "state" : "AL", "county" : "CULLMAN" },
            "35020": { "city" : "BESSEMER", "state" : "AL", "county" : "JEFFERSON" },
            "35021": { "city" : "BESSEMER", "state" : "AL", "county" : "JEFFERSON" },
            "35022": { "city" : "BESSEMER", "state" : "AL", "county" : "JEFFERSON" },
            "35023": { "city" : "BESSEMER", "state" : "AL", "county" : "JEFFERSON" },
            "35031": { "city" : "BLOUNTSVILLE", "state" : "AL", "county" : "BLOUNT" },
            "35032": { "city" : "BON AIR", "state" : "AL", "county" : "TALLADEGA" },
            "35033": { "city" : "BREMEN", "state" : "AL", "county" : "CULLMAN" },
            "35034": { "city" : "BRENT", "state" : "AL", "county" : "BIBB" },"35035": { "city" : "BRIERFIELD", "state" : "AL", "county" : "BIBB" },
            "35036": { "city" : "BROOKSIDE", "state" : "AL", "county" : "JEFFERSON" },
            "35040": { "city" : "CALERA", "state" : "AL", "county" : "SHELBY" },"35042": { "city" : "CENTREVILLE", "state" : "AL", "county" : "BIBB" },
            "35043": { "city" : "CHELSEA", "state" : "AL", "county" : "SHELBY" },
            "35044": { "city" : "CHILDERSBURG", "state" : "AL", "county" : "TALLADEGA" },
            "35045": { "city" : "CLANTON", "state" : "AL", "county" : "CHILTON" },
            "35046": { "city" : "CLANTON", "state" : "AL", "county" : "CHILTON" },
            "35048": { "city" : "CLAY", "state" : "AL", "county" : "JEFFERSON" },
            "35049": { "city" : "CLEVELAND", "state" : "AL", "county" : "BLOUNT" },
            "35051": { "city" : "COLUMBIANA", "state" : "AL", "county" : "SHELBY" },
            "35052": { "city" : "COOK SPRINGS", "state" : "AL", "county" : "SAINT CLAIR" },
            "35053": { "city" : "CRANE HILL", "state" : "AL", "county" : "CULLMAN" },
            "35054": { "city" : "CROPWELL", "state" : "AL", "county" : "SAINT CLAIR" },
            "35055": { "city" : "CULLMAN", "state" : "AL", "county" : "CULLMAN" },
            "35056": { "city" : "CULLMAN", "state" : "AL", "county" : "CULLMAN" },
            "35057": { "city" : "CULLMAN", "state" : "AL", "county" : "CULLMAN" },
            "35058": { "city" : "CULLMAN", "state" : "AL", "county" : "CULLMAN" },
            "35060": { "city" : "DOCENA", "state" : "AL", "county" : "JEFFERSON" },
            "35061": { "city" : "DOLOMITE", "state" : "AL", "county" : "JEFFERSON" },
            "35062": { "city" : "DORA", "state" : "AL", "county" : "JEFFERSON" },
            "35063": { "city" : "EMPIRE", "state" : "AL", "county" : "WALKER" },"35064": { "city" : "FAIRFIELD", "state" : "AL", "county" : "JEFFERSON" },
            "35068": { "city" : "FULTONDALE", "state" : "AL", "county" : "JEFFERSON" },
            "35070": { "city" : "GARDEN CITY", "state" : "AL", "county" : "CULLMAN" },
            "35071": { "city" : "GARDENDALE", "state" : "AL", "county" : "JEFFERSON" },
            "35072": { "city" : "GOODWATER", "state" : "AL", "county" : "COOSA" },
            "35073": { "city" : "GRAYSVILLE", "state" : "AL", "county" : "JEFFERSON" },
            "35074": { "city" : "GREEN POND", "state" : "AL", "county" : "BIBB" },
            "35077": { "city" : "HANCEVILLE", "state" : "AL", "county" : "CULLMAN" },
            "35078": { "city" : "HARPERSVILLE", "state" : "AL", "county" : "SHELBY" },
            "35079": { "city" : "HAYDEN", "state" : "AL", "county" : "BLOUNT" },"35080": { "city" : "HELENA", "state" : "AL", "county" : "SHELBY" },
            "35082": { "city" : "HOLLINS", "state" : "AL", "county" : "CLAY" },"35083": { "city" : "HOLLY POND", "state" : "AL", "county" : "CULLMAN" },
            "35085": { "city" : "JEMISON", "state" : "AL", "county" : "CHILTON" },
            "35087": { "city" : "JOPPA", "state" : "AL", "county" : "CULLMAN" },"35089": { "city" : "KELLYTON", "state" : "AL", "county" : "COOSA" },
            "35091": { "city" : "KIMBERLY", "state" : "AL", "county" : "JEFFERSON" },
            "35094": { "city" : "LEEDS", "state" : "AL", "county" : "JEFFERSON" },
            "35096": { "city" : "LINCOLN", "state" : "AL", "county" : "TALLADEGA" },
            "35097": { "city" : "LOCUST FORK", "state" : "AL", "county" : "BLOUNT" },
            "35098": { "city" : "LOGAN", "state" : "AL", "county" : "CULLMAN" },"35111": { "city" : "MC CALLA", "state" : "AL", "county" : "JEFFERSON" },
            "35112": { "city" : "MARGARET", "state" : "AL", "county" : "SAINT CLAIR" },
            "35114": { "city" : "MAYLENE", "state" : "AL", "county" : "SHELBY" },
            "35115": { "city" : "MONTEVALLO", "state" : "AL", "county" : "SHELBY" },
            "35116": { "city" : "MORRIS", "state" : "AL", "county" : "JEFFERSON" },
            "35117": { "city" : "MOUNT OLIVE", "state" : "AL", "county" : "JEFFERSON" },
            "35118": { "city" : "MULGA", "state" : "AL", "county" : "JEFFERSON" },
            "35119": { "city" : "NEW CASTLE", "state" : "AL", "county" : "JEFFERSON" },
            "35120": { "city" : "ODENVILLE", "state" : "AL", "county" : "SAINT CLAIR" },
            "35121": { "city" : "ONEONTA", "state" : "AL", "county" : "BLOUNT" },
            "35123": { "city" : "PALMERDALE", "state" : "AL", "county" : "JEFFERSON" },
            "35124": { "city" : "PELHAM", "state" : "AL", "county" : "SHELBY" },"35125": { "city" : "PELL CITY", "state" : "AL", "county" : "SAINT CLAIR" },
            "35126": { "city" : "PINSON", "state" : "AL", "county" : "JEFFERSON" },
            "35127": { "city" : "PLEASANT GROVE", "state" : "AL", "county" : "JEFFERSON" },
            "35128": { "city" : "PELL CITY", "state" : "AL", "county" : "SAINT CLAIR" },
            "35130": { "city" : "QUINTON", "state" : "AL", "county" : "WALKER" },
            "35131": { "city" : "RAGLAND", "state" : "AL", "county" : "SAINT CLAIR" },
            "35133": { "city" : "REMLAP", "state" : "AL", "county" : "BLOUNT" },"35135": { "city" : "RIVERSIDE", "state" : "AL", "county" : "SAINT CLAIR" },
            "35136": { "city" : "ROCKFORD", "state" : "AL", "county" : "COOSA" },
            "35137": { "city" : "SAGINAW", "state" : "AL", "county" : "SHELBY" },
            "35139": { "city" : "SAYRE", "state" : "AL", "county" : "JEFFERSON" },
            "35142": { "city" : "SHANNON", "state" : "AL", "county" : "JEFFERSON" },
            "35143": { "city" : "SHELBY", "state" : "AL", "county" : "SHELBY" },"35146": { "city" : "SPRINGVILLE", "state" : "AL", "county" : "SAINT CLAIR" },
            "35147": { "city" : "STERRETT", "state" : "AL", "county" : "SHELBY" },
            "35148": { "city" : "SUMITON", "state" : "AL", "county" : "WALKER" },
            "35149": { "city" : "SYCAMORE", "state" : "AL", "county" : "TALLADEGA" },
            "35150": { "city" : "SYLACAUGA", "state" : "AL", "county" : "TALLADEGA" },
            "35151": { "city" : "SYLACAUGA", "state" : "AL", "county" : "TALLADEGA" },
            "35160": { "city" : "TALLADEGA", "state" : "AL", "county" : "TALLADEGA" },
            "35161": { "city" : "TALLADEGA", "state" : "AL", "county" : "TALLADEGA" },
            "35171": { "city" : "THORSBY", "state" : "AL", "county" : "CHILTON" },
            "35172": { "city" : "TRAFFORD", "state" : "AL", "county" : "JEFFERSON" },
            "35173": { "city" : "TRUSSVILLE", "state" : "AL", "county" : "JEFFERSON" },
            "35175": { "city" : "UNION GROVE", "state" : "AL", "county" : "MARSHALL" },
            "35176": { "city" : "VANDIVER", "state" : "AL", "county" : "SHELBY" },
            "35178": { "city" : "VINCENT", "state" : "AL", "county" : "SHELBY" },
            "35179": { "city" : "VINEMONT", "state" : "AL", "county" : "CULLMAN" },
            "35180": { "city" : "WARRIOR", "state" : "AL", "county" : "JEFFERSON" },
            "35181": { "city" : "WATSON", "state" : "AL", "county" : "JEFFERSON" },
            "35182": { "city" : "WATTSVILLE", "state" : "AL", "county" : "SAINT CLAIR" },
            "35183": { "city" : "WEOGUFKA", "state" : "AL", "county" : "COOSA" },
            "35184": { "city" : "WEST BLOCTON", "state" : "AL", "county" : "BIBB" },
            "35185": { "city" : "WESTOVER", "state" : "AL", "county" : "SHELBY" },
            "35186": { "city" : "WILSONVILLE", "state" : "AL", "county" : "SHELBY" },
            "35187": { "city" : "WILTON", "state" : "AL", "county" : "SHELBY" },"35188": { "city" : "WOODSTOCK", "state" : "AL", "county" : "BIBB" },
            "35201": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35202": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35203": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35204": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35205": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35206": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35207": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35208": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35209": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35210": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35211": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35212": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35213": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35214": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35215": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35216": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35217": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35218": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35219": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35220": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35221": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35222": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35223": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35224": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35226": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35228": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35229": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35231": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35232": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35233": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35234": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35235": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35236": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35237": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35238": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35242": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "SHELBY" },
            "35243": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35244": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35246": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35249": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35253": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35254": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35255": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35259": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35260": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35261": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35266": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35283": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35285": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35291": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35294": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35295": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35298": { "city" : "BIRMINGHAM", "state" : "AL", "county" : "JEFFERSON" },
            "35401": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35402": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35403": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35404": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35405": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35406": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35407": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35440": { "city" : "ABERNANT", "state" : "AL", "county" : "TUSCALOOSA" },
            "35441": { "city" : "AKRON", "state" : "AL", "county" : "HALE" },"35442": { "city" : "ALICEVILLE", "state" : "AL", "county" : "PICKENS" },
            "35443": { "city" : "BOLIGEE", "state" : "AL", "county" : "GREENE" },
            "35444": { "city" : "BROOKWOOD", "state" : "AL", "county" : "TUSCALOOSA" },
            "35446": { "city" : "BUHL", "state" : "AL", "county" : "TUSCALOOSA" },
            "35447": { "city" : "CARROLLTON", "state" : "AL", "county" : "PICKENS" },
            "35448": { "city" : "CLINTON", "state" : "AL", "county" : "GREENE" },
            "35449": { "city" : "COALING", "state" : "AL", "county" : "TUSCALOOSA" },
            "35452": { "city" : "COKER", "state" : "AL", "county" : "TUSCALOOSA" },
            "35453": { "city" : "COTTONDALE", "state" : "AL", "county" : "TUSCALOOSA" },
            "35456": { "city" : "DUNCANVILLE", "state" : "AL", "county" : "TUSCALOOSA" },
            "35457": { "city" : "ECHOLA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35459": { "city" : "EMELLE", "state" : "AL", "county" : "SUMTER" },"35460": { "city" : "EPES", "state" : "AL", "county" : "SUMTER" },
            "35461": { "city" : "ETHELSVILLE", "state" : "AL", "county" : "PICKENS" },
            "35462": { "city" : "EUTAW", "state" : "AL", "county" : "GREENE" },"35463": { "city" : "FOSTERS", "state" : "AL", "county" : "TUSCALOOSA" },
            "35464": { "city" : "GAINESVILLE", "state" : "AL", "county" : "SUMTER" },
            "35466": { "city" : "GORDO", "state" : "AL", "county" : "PICKENS" },"35469": { "city" : "KNOXVILLE", "state" : "AL", "county" : "GREENE" },
            "35470": { "city" : "LIVINGSTON", "state" : "AL", "county" : "SUMTER" },
            "35471": { "city" : "MC SHAN", "state" : "AL", "county" : "PICKENS" },
            "35473": { "city" : "NORTHPORT", "state" : "AL", "county" : "TUSCALOOSA" },
            "35474": { "city" : "MOUNDVILLE", "state" : "AL", "county" : "HALE" },
            "35475": { "city" : "NORTHPORT", "state" : "AL", "county" : "TUSCALOOSA" },
            "35476": { "city" : "NORTHPORT", "state" : "AL", "county" : "TUSCALOOSA" },
            "35477": { "city" : "PANOLA", "state" : "AL", "county" : "SUMTER" },"35478": { "city" : "PETERSON", "state" : "AL", "county" : "TUSCALOOSA" },
            "35480": { "city" : "RALPH", "state" : "AL", "county" : "TUSCALOOSA" },
            "35481": { "city" : "REFORM", "state" : "AL", "county" : "PICKENS" },
            "35486": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35487": { "city" : "TUSCALOOSA", "state" : "AL", "county" : "TUSCALOOSA" },
            "35490": { "city" : "VANCE", "state" : "AL", "county" : "TUSCALOOSA" },
            "35501": { "city" : "JASPER", "state" : "AL", "county" : "WALKER" },"35502": { "city" : "JASPER", "state" : "AL", "county" : "WALKER" },
            "35503": { "city" : "JASPER", "state" : "AL", "county" : "WALKER" },"35504": { "city" : "JASPER", "state" : "AL", "county" : "WALKER" },
            "35540": { "city" : "ADDISON", "state" : "AL", "county" : "WINSTON" },
            "35541": { "city" : "ARLEY", "state" : "AL", "county" : "WINSTON" },"35542": { "city" : "BANKSTON", "state" : "AL", "county" : "FAYETTE" },
            "35543": { "city" : "BEAR CREEK", "state" : "AL", "county" : "MARION" },
            "35544": { "city" : "BEAVERTON", "state" : "AL", "county" : "LAMAR" },
            "35545": { "city" : "BELK", "state" : "AL", "county" : "FAYETTE" },"35546": { "city" : "BERRY", "state" : "AL", "county" : "FAYETTE" },
            "35548": { "city" : "BRILLIANT", "state" : "AL", "county" : "MARION" },
            "35549": { "city" : "CARBON HILL", "state" : "AL", "county" : "WALKER" },
            "35550": { "city" : "CORDOVA", "state" : "AL", "county" : "WALKER" },
            "35552": { "city" : "DETROIT", "state" : "AL", "county" : "LAMAR" },"35553": { "city" : "DOUBLE SPRINGS", "state" : "AL", "county" : "WINSTON" },
            "35554": { "city" : "ELDRIDGE", "state" : "AL", "county" : "WALKER" },
            "35555": { "city" : "FAYETTE", "state" : "AL", "county" : "FAYETTE" },
            "35559": { "city" : "GLEN ALLEN", "state" : "AL", "county" : "FAYETTE" },
            "35560": { "city" : "GOODSPRINGS", "state" : "AL", "county" : "WALKER" },
            "35563": { "city" : "GUIN", "state" : "AL", "county" : "MARION" },"35564": { "city" : "HACKLEBURG", "state" : "AL", "county" : "MARION" },
            "35565": { "city" : "HALEYVILLE", "state" : "AL", "county" : "WINSTON" },
            "35570": { "city" : "HAMILTON", "state" : "AL", "county" : "MARION" },
            "35571": { "city" : "HODGES", "state" : "AL", "county" : "FRANKLIN" },
            "35572": { "city" : "HOUSTON", "state" : "AL", "county" : "WINSTON" },
            "35573": { "city" : "KANSAS", "state" : "AL", "county" : "WALKER" },"35574": { "city" : "KENNEDY", "state" : "AL", "county" : "LAMAR" },
            "35575": { "city" : "LYNN", "state" : "AL", "county" : "WINSTON" },"35576": { "city" : "MILLPORT", "state" : "AL", "county" : "LAMAR" },
            "35577": { "city" : "NATURAL BRIDGE", "state" : "AL", "county" : "WINSTON" },
            "35578": { "city" : "NAUVOO", "state" : "AL", "county" : "WALKER" },"35579": { "city" : "OAKMAN", "state" : "AL", "county" : "WALKER" },
            "35580": { "city" : "PARRISH", "state" : "AL", "county" : "WALKER" },
            "35581": { "city" : "PHIL CAMPBELL", "state" : "AL", "county" : "FRANKLIN" },
            "35582": { "city" : "RED BAY", "state" : "AL", "county" : "FRANKLIN" },
            "35584": { "city" : "SIPSEY", "state" : "AL", "county" : "WALKER" },"35585": { "city" : "SPRUCE PINE", "state" : "AL", "county" : "FRANKLIN" },
            "35586": { "city" : "SULLIGENT", "state" : "AL", "county" : "LAMAR" },
            "35587": { "city" : "TOWNLEY", "state" : "AL", "county" : "WALKER" },
            "35592": { "city" : "VERNON", "state" : "AL", "county" : "LAMAR" },"35593": { "city" : "VINA", "state" : "AL", "county" : "FRANKLIN" },
            "35594": { "city" : "WINFIELD", "state" : "AL", "county" : "MARION" },
            "35601": { "city" : "DECATUR", "state" : "AL", "county" : "MORGAN" },
            "35602": { "city" : "DECATUR", "state" : "AL", "county" : "MORGAN" },
            "35603": { "city" : "DECATUR", "state" : "AL", "county" : "MORGAN" },
            "35609": { "city" : "DECATUR", "state" : "AL", "county" : "MORGAN" },
            "35610": { "city" : "ANDERSON", "state" : "AL", "county" : "LAUDERDALE" },
            "35611": { "city" : "ATHENS", "state" : "AL", "county" : "LIMESTONE" },
            "35612": { "city" : "ATHENS", "state" : "AL", "county" : "LIMESTONE" },
            "35613": { "city" : "ATHENS", "state" : "AL", "county" : "LIMESTONE" },
            "35614": { "city" : "ATHENS", "state" : "AL", "county" : "LIMESTONE" },
            "35615": { "city" : "BELLE MINA", "state" : "AL", "county" : "LIMESTONE" },
            "35616": { "city" : "CHEROKEE", "state" : "AL", "county" : "COLBERT" },
            "35617": { "city" : "CLOVERDALE", "state" : "AL", "county" : "LAUDERDALE" },
            "35618": { "city" : "COURTLAND", "state" : "AL", "county" : "LAWRENCE" },
            "35619": { "city" : "DANVILLE", "state" : "AL", "county" : "MORGAN" },
            "35620": { "city" : "ELKMONT", "state" : "AL", "county" : "LIMESTONE" },
            "35621": { "city" : "EVA", "state" : "AL", "county" : "MORGAN" },"35622": { "city" : "FALKVILLE", "state" : "AL", "county" : "MORGAN" },
            "35630": { "city" : "FLORENCE", "state" : "AL", "county" : "LAUDERDALE" },
            "35631": { "city" : "FLORENCE", "state" : "AL", "county" : "LAUDERDALE" },
            "35632": { "city" : "FLORENCE", "state" : "AL", "county" : "LAUDERDALE" },
            "35633": { "city" : "FLORENCE", "state" : "AL", "county" : "LAUDERDALE" },
            "35634": { "city" : "FLORENCE", "state" : "AL", "county" : "LAUDERDALE" },
            "35640": { "city" : "HARTSELLE", "state" : "AL", "county" : "MORGAN" },
            "35643": { "city" : "HILLSBORO", "state" : "AL", "county" : "LAWRENCE" },
            "35645": { "city" : "KILLEN", "state" : "AL", "county" : "LAUDERDALE" },
            "35646": { "city" : "LEIGHTON", "state" : "AL", "county" : "COLBERT" },
            "35647": { "city" : "LESTER", "state" : "AL", "county" : "LIMESTONE" },
            "35648": { "city" : "LEXINGTON", "state" : "AL", "county" : "LAUDERDALE" },
            "35649": { "city" : "MOORESVILLE", "state" : "AL", "county" : "LIMESTONE" },
            "35650": { "city" : "MOULTON", "state" : "AL", "county" : "LAWRENCE" },
            "35651": { "city" : "MOUNT HOPE", "state" : "AL", "county" : "LAWRENCE" },
            "35652": { "city" : "ROGERSVILLE", "state" : "AL", "county" : "LAUDERDALE" },
            "35653": { "city" : "RUSSELLVILLE", "state" : "AL", "county" : "FRANKLIN" },
            "35654": { "city" : "RUSSELLVILLE", "state" : "AL", "county" : "FRANKLIN" },
            "35660": { "city" : "SHEFFIELD", "state" : "AL", "county" : "COLBERT" },
            "35661": { "city" : "MUSCLE SHOALS", "state" : "AL", "county" : "COLBERT" },
            "35662": { "city" : "MUSCLE SHOALS", "state" : "AL", "county" : "COLBERT" },
            "35670": { "city" : "SOMERVILLE", "state" : "AL", "county" : "MORGAN" },
            "35671": { "city" : "TANNER", "state" : "AL", "county" : "LIMESTONE" },
            "35672": { "city" : "TOWN CREEK", "state" : "AL", "county" : "LAWRENCE" },
            "35673": { "city" : "TRINITY", "state" : "AL", "county" : "MORGAN" },
            "35674": { "city" : "TUSCUMBIA", "state" : "AL", "county" : "COLBERT" },
            "35677": { "city" : "WATERLOO", "state" : "AL", "county" : "LAUDERDALE" },
            "35739": { "city" : "ARDMORE", "state" : "AL", "county" : "LIMESTONE" },
            "35740": { "city" : "BRIDGEPORT", "state" : "AL", "county" : "JACKSON" },
            "35741": { "city" : "BROWNSBORO", "state" : "AL", "county" : "MADISON" },
            "35742": { "city" : "CAPSHAW", "state" : "AL", "county" : "LIMESTONE" },
            "35744": { "city" : "DUTTON", "state" : "AL", "county" : "JACKSON" },
            "35745": { "city" : "ESTILLFORK", "state" : "AL", "county" : "JACKSON" },
            "35747": { "city" : "GRANT", "state" : "AL", "county" : "MARSHALL" },
            "35748": { "city" : "GURLEY", "state" : "AL", "county" : "MADISON" },
            "35749": { "city" : "HARVEST", "state" : "AL", "county" : "MADISON" },
            "35750": { "city" : "HAZEL GREEN", "state" : "AL", "county" : "MADISON" },
            "35751": { "city" : "HOLLYTREE", "state" : "AL", "county" : "JACKSON" },
            "35752": { "city" : "HOLLYWOOD", "state" : "AL", "county" : "JACKSON" },
            "35754": { "city" : "LACEYS SPRING", "state" : "AL", "county" : "MORGAN" },
            "35755": { "city" : "LANGSTON", "state" : "AL", "county" : "JACKSON" },
            "35756": { "city" : "MADISON", "state" : "AL", "county" : "LIMESTONE" },
            "35757": { "city" : "MADISON", "state" : "AL", "county" : "MADISON" },
            "35758": { "city" : "MADISON", "state" : "AL", "county" : "MADISON" },
            "35759": { "city" : "MERIDIANVILLE", "state" : "AL", "county" : "MADISON" },
            "35760": { "city" : "NEW HOPE", "state" : "AL", "county" : "MADISON" },
            "35761": { "city" : "NEW MARKET", "state" : "AL", "county" : "MADISON" },
            "35762": { "city" : "NORMAL", "state" : "AL", "county" : "MADISON" },
            "35763": { "city" : "OWENS CROSS ROADS", "state" : "AL", "county" : "MADISON" },
            "35764": { "city" : "PAINT ROCK", "state" : "AL", "county" : "JACKSON" },
            "35765": { "city" : "PISGAH", "state" : "AL", "county" : "JACKSON" },
            "35766": { "city" : "PRINCETON", "state" : "AL", "county" : "JACKSON" },
            "35767": { "city" : "RYLAND", "state" : "AL", "county" : "MADISON" },
            "35768": { "city" : "SCOTTSBORO", "state" : "AL", "county" : "JACKSON" },
            "35769": { "city" : "SCOTTSBORO", "state" : "AL", "county" : "JACKSON" },
            "35771": { "city" : "SECTION", "state" : "AL", "county" : "JACKSON" },
            "35772": { "city" : "STEVENSON", "state" : "AL", "county" : "JACKSON" },
            "35773": { "city" : "TONEY", "state" : "AL", "county" : "MADISON" },"35774": { "city" : "TRENTON", "state" : "AL", "county" : "JACKSON" },
            "35775": { "city" : "VALHERMOSO SPRINGS", "state" : "AL", "county" : "MORGAN" },
            "35776": { "city" : "WOODVILLE", "state" : "AL", "county" : "JACKSON" },
            "35801": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35802": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35803": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35804": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35805": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35806": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35807": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35808": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35809": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35810": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35811": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35812": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35813": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35814": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35815": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35816": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35824": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35893": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35896": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35898": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35899": { "city" : "HUNTSVILLE", "state" : "AL", "county" : "MADISON" },
            "35901": { "city" : "GADSDEN", "state" : "AL", "county" : "ETOWAH" },
            "35902": { "city" : "GADSDEN", "state" : "AL", "county" : "ETOWAH" },
            "35903": { "city" : "GADSDEN", "state" : "AL", "county" : "ETOWAH" },
            "35904": { "city" : "GADSDEN", "state" : "AL", "county" : "ETOWAH" },
            "35905": { "city" : "GADSDEN", "state" : "AL", "county" : "ETOWAH" },
            "35906": { "city" : "RAINBOW CITY", "state" : "AL", "county" : "ETOWAH" },
            "35907": { "city" : "GADSDEN", "state" : "AL", "county" : "ETOWAH" },
            "35950": { "city" : "ALBERTVILLE", "state" : "AL", "county" : "MARSHALL" },
            "35951": { "city" : "ALBERTVILLE", "state" : "AL", "county" : "MARSHALL" },
            "35952": { "city" : "ALTOONA", "state" : "AL", "county" : "ETOWAH" },
            "35953": { "city" : "ASHVILLE", "state" : "AL", "county" : "SAINT CLAIR" },
            "35954": { "city" : "ATTALLA", "state" : "AL", "county" : "ETOWAH" },
            "35956": { "city" : "BOAZ", "state" : "AL", "county" : "ETOWAH" },"35957": { "city" : "BOAZ", "state" : "AL", "county" : "MARSHALL" },
            "35958": { "city" : "BRYANT", "state" : "AL", "county" : "JACKSON" },
            "35959": { "city" : "CEDAR BLUFF", "state" : "AL", "county" : "CHEROKEE" },
            "35960": { "city" : "CENTRE", "state" : "AL", "county" : "CHEROKEE" },
            "35961": { "city" : "COLLINSVILLE", "state" : "AL", "county" : "DE KALB" },
            "35962": { "city" : "CROSSVILLE", "state" : "AL", "county" : "DE KALB" },
            "35963": { "city" : "DAWSON", "state" : "AL", "county" : "DE KALB" },
            "35964": { "city" : "DOUGLAS", "state" : "AL", "county" : "MARSHALL" },
            "35966": { "city" : "FLAT ROCK", "state" : "AL", "county" : "JACKSON" },
            "35967": { "city" : "FORT PAYNE", "state" : "AL", "county" : "DE KALB" },
            "35968": { "city" : "FORT PAYNE", "state" : "AL", "county" : "DE KALB" },
            "35971": { "city" : "FYFFE", "state" : "AL", "county" : "DE KALB" },"35972": { "city" : "GALLANT", "state" : "AL", "county" : "ETOWAH" },
            "35973": { "city" : "GAYLESVILLE", "state" : "AL", "county" : "CHEROKEE" },
            "35974": { "city" : "GERALDINE", "state" : "AL", "county" : "DE KALB" },
            "35975": { "city" : "GROVEOAK", "state" : "AL", "county" : "DE KALB" },
            "35976": { "city" : "GUNTERSVILLE", "state" : "AL", "county" : "MARSHALL" },
            "35978": { "city" : "HENAGAR", "state" : "AL", "county" : "DE KALB" },
            "35979": { "city" : "HIGDON", "state" : "AL", "county" : "JACKSON" },
            "35980": { "city" : "HORTON", "state" : "AL", "county" : "MARSHALL" },
            "35981": { "city" : "IDER", "state" : "AL", "county" : "DE KALB" },"35983": { "city" : "LEESBURG", "state" : "AL", "county" : "CHEROKEE" },
            "35984": { "city" : "MENTONE", "state" : "AL", "county" : "DE KALB" },
            "35986": { "city" : "RAINSVILLE", "state" : "AL", "county" : "DE KALB" },
            "35987": { "city" : "STEELE", "state" : "AL", "county" : "SAINT CLAIR" },
            "35988": { "city" : "SYLVANIA", "state" : "AL", "county" : "DE KALB" },
            "35989": { "city" : "VALLEY HEAD", "state" : "AL", "county" : "DE KALB" },
            "35990": { "city" : "WALNUT GROVE", "state" : "AL", "county" : "ETOWAH" },
            "36003": { "city" : "AUTAUGAVILLE", "state" : "AL", "county" : "AUTAUGA" },
            "36005": { "city" : "BANKS", "state" : "AL", "county" : "PIKE" },"36006": { "city" : "BILLINGSLEY", "state" : "AL", "county" : "AUTAUGA" },
            "36008": { "city" : "BOOTH", "state" : "AL", "county" : "AUTAUGA" },"36009": { "city" : "BRANTLEY", "state" : "AL", "county" : "CRENSHAW" },
            "36010": { "city" : "BRUNDIDGE", "state" : "AL", "county" : "PIKE" },
            "36013": { "city" : "CECIL", "state" : "AL", "county" : "MONTGOMERY" },
            "36015": { "city" : "CHAPMAN", "state" : "AL", "county" : "BUTLER" },
            "36016": { "city" : "CLAYTON", "state" : "AL", "county" : "BARBOUR" },
            "36017": { "city" : "CLIO", "state" : "AL", "county" : "BARBOUR" },"36020": { "city" : "COOSADA", "state" : "AL", "county" : "ELMORE" },
            "36022": { "city" : "DEATSVILLE", "state" : "AL", "county" : "ELMORE" },
            "36023": { "city" : "EAST TALLASSEE", "state" : "AL", "county" : "TALLAPOOSA" },
            "36024": { "city" : "ECLECTIC", "state" : "AL", "county" : "ELMORE" },
            "36025": { "city" : "ELMORE", "state" : "AL", "county" : "ELMORE" },"36026": { "city" : "EQUALITY", "state" : "AL", "county" : "COOSA" },
            "36027": { "city" : "EUFAULA", "state" : "AL", "county" : "BARBOUR" },
            "36028": { "city" : "DOZIER", "state" : "AL", "county" : "CRENSHAW" },
            "36029": { "city" : "FITZPATRICK", "state" : "AL", "county" : "BULLOCK" },
            "36030": { "city" : "FOREST HOME", "state" : "AL", "county" : "BUTLER" },
            "36032": { "city" : "FORT DEPOSIT", "state" : "AL", "county" : "LOWNDES" },
            "36033": { "city" : "GEORGIANA", "state" : "AL", "county" : "BUTLER" },
            "36034": { "city" : "GLENWOOD", "state" : "AL", "county" : "CRENSHAW" },
            "36035": { "city" : "GOSHEN", "state" : "AL", "county" : "PIKE" },"36036": { "city" : "GRADY", "state" : "AL", "county" : "MONTGOMERY" },
            "36037": { "city" : "GREENVILLE", "state" : "AL", "county" : "BUTLER" },
            "36038": { "city" : "GANTT", "state" : "AL", "county" : "COVINGTON" },
            "36039": { "city" : "HARDAWAY", "state" : "AL", "county" : "MACON" },
            "36040": { "city" : "HAYNEVILLE", "state" : "AL", "county" : "LOWNDES" },
            "36041": { "city" : "HIGHLAND HOME", "state" : "AL", "county" : "CRENSHAW" },
            "36042": { "city" : "HONORAVILLE", "state" : "AL", "county" : "CRENSHAW" },
            "36043": { "city" : "HOPE HULL", "state" : "AL", "county" : "MONTGOMERY" },
            "36045": { "city" : "KENT", "state" : "AL", "county" : "ELMORE" },"36046": { "city" : "LAPINE", "state" : "AL", "county" : "MONTGOMERY" },
            "36047": { "city" : "LETOHATCHEE", "state" : "AL", "county" : "LOWNDES" },
            "36048": { "city" : "LOUISVILLE", "state" : "AL", "county" : "BARBOUR" },
            "36049": { "city" : "LUVERNE", "state" : "AL", "county" : "CRENSHAW" },
            "36051": { "city" : "MARBURY", "state" : "AL", "county" : "AUTAUGA" },
            "36052": { "city" : "MATHEWS", "state" : "AL", "county" : "MONTGOMERY" },
            "36053": { "city" : "MIDWAY", "state" : "AL", "county" : "BULLOCK" },
            "36054": { "city" : "MILLBROOK", "state" : "AL", "county" : "ELMORE" },
            "36057": { "city" : "MOUNT MEIGS", "state" : "AL", "county" : "MONTGOMERY" },
            "36064": { "city" : "PIKE ROAD", "state" : "AL", "county" : "MONTGOMERY" },
            "36065": { "city" : "PINE LEVEL", "state" : "AL", "county" : "MONTGOMERY" },
            "36066": { "city" : "PRATTVILLE", "state" : "AL", "county" : "AUTAUGA" },
            "36067": { "city" : "PRATTVILLE", "state" : "AL", "county" : "AUTAUGA" },
            "36068": { "city" : "PRATTVILLE", "state" : "AL", "county" : "AUTAUGA" },
            "36069": { "city" : "RAMER", "state" : "AL", "county" : "MONTGOMERY" },
            "36071": { "city" : "RUTLEDGE", "state" : "AL", "county" : "CRENSHAW" },
            "36072": { "city" : "EUFAULA", "state" : "AL", "county" : "BARBOUR" },
            "36075": { "city" : "SHORTER", "state" : "AL", "county" : "MACON" },"36078": { "city" : "TALLASSEE", "state" : "AL", "county" : "ELMORE" },
            "36079": { "city" : "TROY", "state" : "AL", "county" : "PIKE" },"36080": { "city" : "TITUS", "state" : "AL", "county" : "ELMORE" },
            "36081": { "city" : "TROY", "state" : "AL", "county" : "PIKE" },"36082": { "city" : "TROY", "state" : "AL", "county" : "PIKE" },
            "36083": { "city" : "TUSKEGEE", "state" : "AL", "county" : "MACON" },
            "36087": { "city" : "TUSKEGEE INSTITUTE", "state" : "AL", "county" : "MACON" },
            "36088": { "city" : "TUSKEGEE INSTITUTE", "state" : "AL", "county" : "MACON" },
            "36089": { "city" : "UNION SPRINGS", "state" : "AL", "county" : "BULLOCK" },
            "36091": { "city" : "VERBENA", "state" : "AL", "county" : "CHILTON" },
            "36092": { "city" : "WETUMPKA", "state" : "AL", "county" : "ELMORE" },
            "36093": { "city" : "WETUMPKA", "state" : "AL", "county" : "ELMORE" },
            "36101": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36102": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36103": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36104": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36105": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36106": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36107": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36108": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36109": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36110": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36111": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36112": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36113": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36114": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36115": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36116": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36117": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36118": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36120": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36121": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36123": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36124": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36125": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36130": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36131": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36140": { "city" : "MONTGOMERY", "state" : "AL", "county" : "MONTGOMERY" },
            "36201": { "city" : "ANNISTON", "state" : "AL", "county" : "CALHOUN" },
            "36202": { "city" : "ANNISTON", "state" : "AL", "county" : "CALHOUN" },
            "36203": { "city" : "OXFORD", "state" : "AL", "county" : "CALHOUN" },
            "36204": { "city" : "ANNISTON", "state" : "AL", "county" : "CALHOUN" },
            "36205": { "city" : "ANNISTON", "state" : "AL", "county" : "CALHOUN" },
            "36206": { "city" : "ANNISTON", "state" : "AL", "county" : "CALHOUN" },
            "36207": { "city" : "ANNISTON", "state" : "AL", "county" : "CALHOUN" },
            "36250": { "city" : "ALEXANDRIA", "state" : "AL", "county" : "CALHOUN" },
            "36251": { "city" : "ASHLAND", "state" : "AL", "county" : "CLAY" },"36253": { "city" : "BYNUM", "state" : "AL", "county" : "CALHOUN" },
            "36254": { "city" : "CHOCCOLOCCO", "state" : "AL", "county" : "CALHOUN" },
            "36255": { "city" : "CRAGFORD", "state" : "AL", "county" : "CLAY" },"36256": { "city" : "DAVISTON", "state" : "AL", "county" : "TALLAPOOSA" },
            "36257": { "city" : "DE ARMANVILLE", "state" : "AL", "county" : "CALHOUN" },
            "36258": { "city" : "DELTA", "state" : "AL", "county" : "CLAY" },"36260": { "city" : "EASTABOGA", "state" : "AL", "county" : "CALHOUN" },
            "36261": { "city" : "EDWARDSVILLE", "state" : "AL", "county" : "CLEBURNE" },
            "36262": { "city" : "FRUITHURST", "state" : "AL", "county" : "CLEBURNE" },
            "36263": { "city" : "GRAHAM", "state" : "AL", "county" : "RANDOLPH" },
            "36264": { "city" : "HEFLIN", "state" : "AL", "county" : "CLEBURNE" },
            "36265": { "city" : "JACKSONVILLE", "state" : "AL", "county" : "CALHOUN" },
            "36266": { "city" : "LINEVILLE", "state" : "AL", "county" : "CLAY" },
            "36267": { "city" : "MILLERVILLE", "state" : "AL", "county" : "CLAY" },
            "36268": { "city" : "MUNFORD", "state" : "AL", "county" : "TALLADEGA" },
            "36269": { "city" : "MUSCADINE", "state" : "AL", "county" : "CLEBURNE" },
            "36271": { "city" : "OHATCHEE", "state" : "AL", "county" : "CALHOUN" },
            "36272": { "city" : "PIEDMONT", "state" : "AL", "county" : "CALHOUN" },
            "36273": { "city" : "RANBURNE", "state" : "AL", "county" : "CLEBURNE" },
            "36274": { "city" : "ROANOKE", "state" : "AL", "county" : "RANDOLPH" },
            "36276": { "city" : "WADLEY", "state" : "AL", "county" : "RANDOLPH" },
            "36277": { "city" : "WEAVER", "state" : "AL", "county" : "CALHOUN" },
            "36278": { "city" : "WEDOWEE", "state" : "AL", "county" : "RANDOLPH" },
            "36279": { "city" : "WELLINGTON", "state" : "AL", "county" : "CALHOUN" },
            "36280": { "city" : "WOODLAND", "state" : "AL", "county" : "RANDOLPH" },
            "36301": { "city" : "DOTHAN", "state" : "AL", "county" : "HOUSTON" },
            "36302": { "city" : "DOTHAN", "state" : "AL", "county" : "HOUSTON" },
            "36303": { "city" : "DOTHAN", "state" : "AL", "county" : "HOUSTON" },
            "36304": { "city" : "DOTHAN", "state" : "AL", "county" : "HOUSTON" },
            "36305": { "city" : "DOTHAN", "state" : "AL", "county" : "HOUSTON" },
            "36310": { "city" : "ABBEVILLE", "state" : "AL", "county" : "HENRY" },
            "36311": { "city" : "ARITON", "state" : "AL", "county" : "DALE" },"36312": { "city" : "ASHFORD", "state" : "AL", "county" : "HOUSTON" },
            "36313": { "city" : "BELLWOOD", "state" : "AL", "county" : "GENEVA" },
            "36314": { "city" : "BLACK", "state" : "AL", "county" : "GENEVA" },"36316": { "city" : "CHANCELLOR", "state" : "AL", "county" : "GENEVA" },
            "36317": { "city" : "CLOPTON", "state" : "AL", "county" : "HENRY" },"36318": { "city" : "COFFEE SPRINGS", "state" : "AL", "county" : "GENEVA" },
            "36319": { "city" : "COLUMBIA", "state" : "AL", "county" : "HOUSTON" },
            "36320": { "city" : "COTTONWOOD", "state" : "AL", "county" : "HOUSTON" },
            "36321": { "city" : "COWARTS", "state" : "AL", "county" : "HOUSTON" },
            "36322": { "city" : "DALEVILLE", "state" : "AL", "county" : "DALE" },
            "36323": { "city" : "ELBA", "state" : "AL", "county" : "COFFEE" },"36330": { "city" : "ENTERPRISE", "state" : "AL", "county" : "COFFEE" },
            "36331": { "city" : "ENTERPRISE", "state" : "AL", "county" : "COFFEE" },
            "36340": { "city" : "GENEVA", "state" : "AL", "county" : "GENEVA" },"36343": { "city" : "GORDON", "state" : "AL", "county" : "HOUSTON" },
            "36344": { "city" : "HARTFORD", "state" : "AL", "county" : "GENEVA" },
            "36345": { "city" : "HEADLAND", "state" : "AL", "county" : "HENRY" },
            "36346": { "city" : "JACK", "state" : "AL", "county" : "COFFEE" },"36349": { "city" : "MALVERN", "state" : "AL", "county" : "GENEVA" },
            "36350": { "city" : "MIDLAND CITY", "state" : "AL", "county" : "DALE" },
            "36351": { "city" : "NEW BROCKTON", "state" : "AL", "county" : "COFFEE" },
            "36352": { "city" : "NEWTON", "state" : "AL", "county" : "DALE" },"36353": { "city" : "NEWVILLE", "state" : "AL", "county" : "HENRY" },
            "36360": { "city" : "OZARK", "state" : "AL", "county" : "DALE" },"36361": { "city" : "OZARK", "state" : "AL", "county" : "DALE" },
            "36362": { "city" : "FORT RUCKER", "state" : "AL", "county" : "DALE" },
            "36370": { "city" : "PANSEY", "state" : "AL", "county" : "HOUSTON" },
            "36371": { "city" : "PINCKARD", "state" : "AL", "county" : "DALE" },"36373": { "city" : "SHORTERVILLE", "state" : "AL", "county" : "HENRY" },
            "36374": { "city" : "SKIPPERVILLE", "state" : "AL", "county" : "DALE" },
            "36375": { "city" : "SLOCOMB", "state" : "AL", "county" : "GENEVA" },
            "36376": { "city" : "WEBB", "state" : "AL", "county" : "HOUSTON" },"36401": { "city" : "EVERGREEN", "state" : "AL", "county" : "CONECUH" },
            "36420": { "city" : "ANDALUSIA", "state" : "AL", "county" : "COVINGTON" },
            "36421": { "city" : "ANDALUSIA", "state" : "AL", "county" : "COVINGTON" },
            "36425": { "city" : "BEATRICE", "state" : "AL", "county" : "MONROE" },
            "36426": { "city" : "BREWTON", "state" : "AL", "county" : "ESCAMBIA" },
            "36427": { "city" : "BREWTON", "state" : "AL", "county" : "ESCAMBIA" },
            "36429": { "city" : "BROOKLYN", "state" : "AL", "county" : "CONECUH" },
            "36432": { "city" : "CASTLEBERRY", "state" : "AL", "county" : "CONECUH" },
            "36435": { "city" : "COY", "state" : "AL", "county" : "WILCOX" },"36436": { "city" : "DICKINSON", "state" : "AL", "county" : "CLARKE" },
            "36439": { "city" : "EXCEL", "state" : "AL", "county" : "MONROE" },"36441": { "city" : "FLOMATON", "state" : "AL", "county" : "ESCAMBIA" },
            "36442": { "city" : "FLORALA", "state" : "AL", "county" : "COVINGTON" },
            "36444": { "city" : "FRANKLIN", "state" : "AL", "county" : "MONROE" },
            "36445": { "city" : "FRISCO CITY", "state" : "AL", "county" : "MONROE" },
            "36446": { "city" : "FULTON", "state" : "AL", "county" : "CLARKE" },"36451": { "city" : "GROVE HILL", "state" : "AL", "county" : "CLARKE" },
            "36453": { "city" : "KINSTON", "state" : "AL", "county" : "COFFEE" },
            "36454": { "city" : "LENOX", "state" : "AL", "county" : "CONECUH" },"36456": { "city" : "MC KENZIE", "state" : "AL", "county" : "BUTLER" },
            "36458": { "city" : "MEXIA", "state" : "AL", "county" : "MONROE" },"36460": { "city" : "MONROEVILLE", "state" : "AL", "county" : "MONROE" },
            "36461": { "city" : "MONROEVILLE", "state" : "AL", "county" : "MONROE" },
            "36462": { "city" : "MONROEVILLE", "state" : "AL", "county" : "MONROE" },
            "36467": { "city" : "OPP", "state" : "AL", "county" : "COVINGTON" },"36470": { "city" : "PERDUE HILL", "state" : "AL", "county" : "MONROE" },
            "36471": { "city" : "PETERMAN", "state" : "AL", "county" : "MONROE" },
            "36473": { "city" : "RANGE", "state" : "AL", "county" : "CONECUH" },"36474": { "city" : "RED LEVEL", "state" : "AL", "county" : "COVINGTON" },
            "36475": { "city" : "REPTON", "state" : "AL", "county" : "CONECUH" },
            "36476": { "city" : "RIVER FALLS", "state" : "AL", "county" : "COVINGTON" },
            "36477": { "city" : "SAMSON", "state" : "AL", "county" : "GENEVA" },"36480": { "city" : "URIAH", "state" : "AL", "county" : "MONROE" },
            "36481": { "city" : "VREDENBURGH", "state" : "AL", "county" : "MONROE" },
            "36482": { "city" : "WHATLEY", "state" : "AL", "county" : "CLARKE" },
            "36483": { "city" : "WING", "state" : "AL", "county" : "COVINGTON" },
            "36502": { "city" : "ATMORE", "state" : "AL", "county" : "ESCAMBIA" },
            "36503": { "city" : "ATMORE", "state" : "AL", "county" : "ESCAMBIA" },
            "36504": { "city" : "ATMORE", "state" : "AL", "county" : "ESCAMBIA" },
            "36505": { "city" : "AXIS", "state" : "AL", "county" : "MOBILE" },"36507": { "city" : "BAY MINETTE", "state" : "AL", "county" : "BALDWIN" },
            "36509": { "city" : "BAYOU LA BATRE", "state" : "AL", "county" : "MOBILE" },
            "36511": { "city" : "BON SECOUR", "state" : "AL", "county" : "BALDWIN" },
            "36512": { "city" : "BUCKS", "state" : "AL", "county" : "MOBILE" },"36513": { "city" : "CALVERT", "state" : "AL", "county" : "WASHINGTON" },
            "36515": { "city" : "CARLTON", "state" : "AL", "county" : "CLARKE" },
            "36518": { "city" : "CHATOM", "state" : "AL", "county" : "WASHINGTON" },
            "36521": { "city" : "CHUNCHULA", "state" : "AL", "county" : "MOBILE" },
            "36522": { "city" : "CITRONELLE", "state" : "AL", "county" : "MOBILE" },
            "36523": { "city" : "CODEN", "state" : "AL", "county" : "MOBILE" },"36524": { "city" : "COFFEEVILLE", "state" : "AL", "county" : "CLARKE" },
            "36525": { "city" : "CREOLA", "state" : "AL", "county" : "MOBILE" },"36526": { "city" : "DAPHNE", "state" : "AL", "county" : "BALDWIN" },
            "36527": { "city" : "SPANISH FORT", "state" : "AL", "county" : "BALDWIN" },
            "36528": { "city" : "DAUPHIN ISLAND", "state" : "AL", "county" : "MOBILE" },
            "36530": { "city" : "ELBERTA", "state" : "AL", "county" : "BALDWIN" },
            "36532": { "city" : "FAIRHOPE", "state" : "AL", "county" : "BALDWIN" },
            "36533": { "city" : "FAIRHOPE", "state" : "AL", "county" : "BALDWIN" },
            "36535": { "city" : "FOLEY", "state" : "AL", "county" : "BALDWIN" },"36536": { "city" : "FOLEY", "state" : "AL", "county" : "BALDWIN" },
            "36538": { "city" : "FRANKVILLE", "state" : "AL", "county" : "WASHINGTON" },
            "36539": { "city" : "FRUITDALE", "state" : "AL", "county" : "WASHINGTON" },
            "36540": { "city" : "GAINESTOWN", "state" : "AL", "county" : "CLARKE" },
            "36541": { "city" : "GRAND BAY", "state" : "AL", "county" : "MOBILE" },
            "36542": { "city" : "GULF SHORES", "state" : "AL", "county" : "BALDWIN" },
            "36543": { "city" : "HUXFORD", "state" : "AL", "county" : "ESCAMBIA" },
            "36544": { "city" : "IRVINGTON", "state" : "AL", "county" : "MOBILE" },
            "36545": { "city" : "JACKSON", "state" : "AL", "county" : "CLARKE" },
            "36547": { "city" : "GULF SHORES", "state" : "AL", "county" : "BALDWIN" },
            "36548": { "city" : "LEROY", "state" : "AL", "county" : "WASHINGTON" },
            "36549": { "city" : "LILLIAN", "state" : "AL", "county" : "BALDWIN" },
            "36550": { "city" : "LITTLE RIVER", "state" : "AL", "county" : "BALDWIN" },
            "36551": { "city" : "LOXLEY", "state" : "AL", "county" : "BALDWIN" },
            "36553": { "city" : "MC INTOSH", "state" : "AL", "county" : "WASHINGTON" },
            "36555": { "city" : "MAGNOLIA SPRINGS", "state" : "AL", "county" : "BALDWIN" },
            "36556": { "city" : "MALCOLM", "state" : "AL", "county" : "WASHINGTON" },
            "36558": { "city" : "MILLRY", "state" : "AL", "county" : "WASHINGTON" },
            "36559": { "city" : "MONTROSE", "state" : "AL", "county" : "BALDWIN" },
            "36560": { "city" : "MOUNT VERNON", "state" : "AL", "county" : "MOBILE" },
            "36561": { "city" : "ORANGE BEACH", "state" : "AL", "county" : "BALDWIN" },
            "36562": { "city" : "PERDIDO", "state" : "AL", "county" : "BALDWIN" },
            "36564": { "city" : "POINT CLEAR", "state" : "AL", "county" : "BALDWIN" },
            "36567": { "city" : "ROBERTSDALE", "state" : "AL", "county" : "BALDWIN" },
            "36568": { "city" : "SAINT ELMO", "state" : "AL", "county" : "MOBILE" },
            "36569": { "city" : "SAINT STEPHENS", "state" : "AL", "county" : "WASHINGTON" },
            "36571": { "city" : "SARALAND", "state" : "AL", "county" : "MOBILE" },
            "36572": { "city" : "SATSUMA", "state" : "AL", "county" : "MOBILE" },
            "36574": { "city" : "SEMINOLE", "state" : "AL", "county" : "BALDWIN" },
            "36575": { "city" : "SEMMES", "state" : "AL", "county" : "MOBILE" },"36576": { "city" : "SILVERHILL", "state" : "AL", "county" : "BALDWIN" },
            "36577": { "city" : "SPANISH FORT", "state" : "AL", "county" : "BALDWIN" },
            "36578": { "city" : "STAPLETON", "state" : "AL", "county" : "BALDWIN" },
            "36579": { "city" : "STOCKTON", "state" : "AL", "county" : "BALDWIN" },
            "36580": { "city" : "SUMMERDALE", "state" : "AL", "county" : "BALDWIN" },
            "36581": { "city" : "SUNFLOWER", "state" : "AL", "county" : "WASHINGTON" },
            "36582": { "city" : "THEODORE", "state" : "AL", "county" : "MOBILE" },
            "36583": { "city" : "TIBBIE", "state" : "AL", "county" : "WASHINGTON" },
            "36584": { "city" : "VINEGAR BEND", "state" : "AL", "county" : "WASHINGTON" },
            "36585": { "city" : "WAGARVILLE", "state" : "AL", "county" : "WASHINGTON" },
            "36587": { "city" : "WILMER", "state" : "AL", "county" : "MOBILE" },"36590": { "city" : "THEODORE", "state" : "AL", "county" : "MOBILE" },
            "36601": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36602": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36603": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36604": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36605": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36606": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36607": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36608": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36609": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36610": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36611": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36612": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36613": { "city" : "EIGHT MILE", "state" : "AL", "county" : "MOBILE" },
            "36615": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36616": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36617": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36618": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36619": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36625": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36630": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36633": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36640": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36641": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36644": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36652": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36660": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36663": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36670": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36671": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36685": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36688": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36689": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36691": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36693": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },"36695": { "city" : "MOBILE", "state" : "AL", "county" : "MOBILE" },
            "36701": { "city" : "SELMA", "state" : "AL", "county" : "DALLAS" },"36702": { "city" : "SELMA", "state" : "AL", "county" : "DALLAS" },
            "36703": { "city" : "SELMA", "state" : "AL", "county" : "DALLAS" },"36720": { "city" : "ALBERTA", "state" : "AL", "county" : "WILCOX" },
            "36722": { "city" : "ARLINGTON", "state" : "AL", "county" : "WILCOX" },
            "36726": { "city" : "CAMDEN", "state" : "AL", "county" : "WILCOX" },"36727": { "city" : "CAMPBELL", "state" : "AL", "county" : "CLARKE" },
            "36728": { "city" : "CATHERINE", "state" : "AL", "county" : "WILCOX" },
            "36732": { "city" : "DEMOPOLIS", "state" : "AL", "county" : "MARENGO" },
            "36736": { "city" : "DIXONS MILLS", "state" : "AL", "county" : "MARENGO" },
            "36738": { "city" : "FAUNSDALE", "state" : "AL", "county" : "MARENGO" },
            "36740": { "city" : "FORKLAND", "state" : "AL", "county" : "GREENE" },
            "36742": { "city" : "GALLION", "state" : "AL", "county" : "MARENGO" },
            "36744": { "city" : "GREENSBORO", "state" : "AL", "county" : "HALE" },
            "36748": { "city" : "LINDEN", "state" : "AL", "county" : "MARENGO" },
            "36749": { "city" : "JONES", "state" : "AL", "county" : "AUTAUGA" },"36750": { "city" : "MAPLESVILLE", "state" : "AL", "county" : "CHILTON" },
            "36751": { "city" : "LOWER PEACH TREE", "state" : "AL", "county" : "WILCOX" },
            "36752": { "city" : "LOWNDESBORO", "state" : "AL", "county" : "LOWNDES" },
            "36753": { "city" : "MC WILLIAMS", "state" : "AL", "county" : "WILCOX" },
            "36756": { "city" : "MARION", "state" : "AL", "county" : "PERRY" },"36758": { "city" : "PLANTERSVILLE", "state" : "AL", "county" : "DALLAS" },
            "36759": { "city" : "MARION JUNCTION", "state" : "AL", "county" : "DALLAS" },
            "36761": { "city" : "MINTER", "state" : "AL", "county" : "DALLAS" },"36762": { "city" : "MORVIN", "state" : "AL", "county" : "CLARKE" },
            "36763": { "city" : "MYRTLEWOOD", "state" : "AL", "county" : "MARENGO" },
            "36764": { "city" : "NANAFALIA", "state" : "AL", "county" : "MARENGO" },
            "36765": { "city" : "NEWBERN", "state" : "AL", "county" : "HALE" },"36766": { "city" : "OAK HILL", "state" : "AL", "county" : "WILCOX" },
            "36767": { "city" : "ORRVILLE", "state" : "AL", "county" : "DALLAS" },
            "36768": { "city" : "PINE APPLE", "state" : "AL", "county" : "WILCOX" },
            "36769": { "city" : "PINE HILL", "state" : "AL", "county" : "WILCOX" },
            "36773": { "city" : "SAFFORD", "state" : "AL", "county" : "DALLAS" },
            "36775": { "city" : "SARDIS", "state" : "AL", "county" : "DALLAS" },"36776": { "city" : "SAWYERVILLE", "state" : "AL", "county" : "HALE" },
            "36782": { "city" : "SWEET WATER", "state" : "AL", "county" : "MARENGO" },
            "36783": { "city" : "THOMASTON", "state" : "AL", "county" : "MARENGO" },
            "36784": { "city" : "THOMASVILLE", "state" : "AL", "county" : "CLARKE" },
            "36785": { "city" : "TYLER", "state" : "AL", "county" : "LOWNDES" },"36786": { "city" : "UNIONTOWN", "state" : "AL", "county" : "PERRY" },
            "36790": { "city" : "STANTON", "state" : "AL", "county" : "CHILTON" },
            "36792": { "city" : "RANDOLPH", "state" : "AL", "county" : "BIBB" },"36793": { "city" : "LAWLEY", "state" : "AL", "county" : "BIBB" },
            "36801": { "city" : "OPELIKA", "state" : "AL", "county" : "LEE" },"36802": { "city" : "OPELIKA", "state" : "AL", "county" : "LEE" },
            "36803": { "city" : "OPELIKA", "state" : "AL", "county" : "LEE" },"36804": { "city" : "OPELIKA", "state" : "AL", "county" : "LEE" },
            "36830": { "city" : "AUBURN", "state" : "AL", "county" : "LEE" },"36831": { "city" : "AUBURN", "state" : "AL", "county" : "LEE" },
            "36832": { "city" : "AUBURN", "state" : "AL", "county" : "LEE" },"36849": { "city" : "AUBURN UNIVERSITY", "state" : "AL", "county" : "LEE" },
            "36850": { "city" : "CAMP HILL", "state" : "AL", "county" : "TALLAPOOSA" },
            "36851": { "city" : "COTTONTON", "state" : "AL", "county" : "RUSSELL" },
            "36852": { "city" : "CUSSETA", "state" : "AL", "county" : "LEE" },"36853": { "city" : "DADEVILLE", "state" : "AL", "county" : "TALLAPOOSA" },
            "36854": { "city" : "VALLEY", "state" : "AL", "county" : "CHAMBERS" },
            "36855": { "city" : "FIVE POINTS", "state" : "AL", "county" : "CHAMBERS" },
            "36856": { "city" : "FORT MITCHELL", "state" : "AL", "county" : "RUSSELL" },
            "36858": { "city" : "HATCHECHUBBEE", "state" : "AL", "county" : "RUSSELL" },
            "36859": { "city" : "HOLY TRINITY", "state" : "AL", "county" : "RUSSELL" },
            "36860": { "city" : "HURTSBORO", "state" : "AL", "county" : "RUSSELL" },
            "36861": { "city" : "JACKSONS GAP", "state" : "AL", "county" : "TALLAPOOSA" },
            "36862": { "city" : "LAFAYETTE", "state" : "AL", "county" : "CHAMBERS" },
            "36863": { "city" : "LANETT", "state" : "AL", "county" : "CHAMBERS" },
            "36865": { "city" : "LOACHAPOKA", "state" : "AL", "county" : "LEE" },
            "36866": { "city" : "NOTASULGA", "state" : "AL", "county" : "MACON" },
            "36867": { "city" : "PHENIX CITY", "state" : "AL", "county" : "RUSSELL" },
            "36868": { "city" : "PHENIX CITY", "state" : "AL", "county" : "RUSSELL" },
            "36869": { "city" : "PHENIX CITY", "state" : "AL", "county" : "RUSSELL" },
            "36870": { "city" : "PHENIX CITY", "state" : "AL", "county" : "LEE" },
            "36871": { "city" : "PITTSVIEW", "state" : "AL", "county" : "RUSSELL" },
            "36872": { "city" : "VALLEY", "state" : "AL", "county" : "LEE" },"36874": { "city" : "SALEM", "state" : "AL", "county" : "LEE" },
            "36875": { "city" : "SEALE", "state" : "AL", "county" : "RUSSELL" },"36877": { "city" : "SMITHS STATION", "state" : "AL", "county" : "LEE" },
            "36879": { "city" : "WAVERLY", "state" : "AL", "county" : "LEE" },"36901": { "city" : "BELLAMY", "state" : "AL", "county" : "SUMTER" },
            "36904": { "city" : "BUTLER", "state" : "AL", "county" : "CHOCTAW" },
            "36907": { "city" : "CUBA", "state" : "AL", "county" : "SUMTER" },"36908": { "city" : "GILBERTOWN", "state" : "AL", "county" : "CHOCTAW" },
            "36910": { "city" : "JACHIN", "state" : "AL", "county" : "CHOCTAW" },
            "36912": { "city" : "LISMAN", "state" : "AL", "county" : "CHOCTAW" },
            "36913": { "city" : "MELVIN", "state" : "AL", "county" : "CHOCTAW" },
            "36915": { "city" : "NEEDHAM", "state" : "AL", "county" : "CHOCTAW" },
            "36916": { "city" : "PENNINGTON", "state" : "AL", "county" : "CHOCTAW" },
            "36919": { "city" : "SILAS", "state" : "AL", "county" : "CHOCTAW" },"36921": { "city" : "TOXEY", "state" : "AL", "county" : "CHOCTAW" },
            "36922": { "city" : "WARD", "state" : "AL", "county" : "CHOCTAW" },"36925": { "city" : "YORK", "state" : "AL", "county" : "SUMTER" },
            "37010": { "city" : "ADAMS", "state" : "TN", "county" : "ROBERTSON" },
            "37011": { "city" : "ANTIOCH", "state" : "TN", "county" : "DAVIDSON" },
            "37012": { "city" : "ALEXANDRIA", "state" : "TN", "county" : "DEKALB" },
            "37013": { "city" : "ANTIOCH", "state" : "TN", "county" : "DAVIDSON" },
            "37014": { "city" : "ARRINGTON", "state" : "TN", "county" : "WILLIAMSON" },
            "37015": { "city" : "ASHLAND CITY", "state" : "TN", "county" : "CHEATHAM" },
            "37016": { "city" : "AUBURNTOWN", "state" : "TN", "county" : "CANNON" },
            "37018": { "city" : "BEECHGROVE", "state" : "TN", "county" : "COFFEE" },
            "37019": { "city" : "BELFAST", "state" : "TN", "county" : "MARSHALL" },
            "37020": { "city" : "BELL BUCKLE", "state" : "TN", "county" : "BEDFORD" },
            "37022": { "city" : "BETHPAGE", "state" : "TN", "county" : "SUMNER" },
            "37023": { "city" : "BIG ROCK", "state" : "TN", "county" : "STEWART" },
            "37024": { "city" : "BRENTWOOD", "state" : "TN", "county" : "WILLIAMSON" },
            "37025": { "city" : "BON AQUA", "state" : "TN", "county" : "HICKMAN" },
            "37026": { "city" : "BRADYVILLE", "state" : "TN", "county" : "CANNON" },
            "37027": { "city" : "BRENTWOOD", "state" : "TN", "county" : "WILLIAMSON" },
            "37028": { "city" : "BUMPUS MILLS", "state" : "TN", "county" : "STEWART" },
            "37029": { "city" : "BURNS", "state" : "TN", "county" : "DICKSON" },"37030": { "city" : "CARTHAGE", "state" : "TN", "county" : "SMITH" },
            "37031": { "city" : "CASTALIAN SPRINGS", "state" : "TN", "county" : "SUMNER" },
            "37032": { "city" : "CEDAR HILL", "state" : "TN", "county" : "ROBERTSON" },
            "37033": { "city" : "CENTERVILLE", "state" : "TN", "county" : "HICKMAN" },
            "37034": { "city" : "CHAPEL HILL", "state" : "TN", "county" : "MARSHALL" },
            "37035": { "city" : "CHAPMANSBORO", "state" : "TN", "county" : "CHEATHAM" },
            "37036": { "city" : "CHARLOTTE", "state" : "TN", "county" : "DICKSON" },
            "37037": { "city" : "CHRISTIANA", "state" : "TN", "county" : "RUTHERFORD" },
            "37040": { "city" : "CLARKSVILLE", "state" : "TN", "county" : "MONTGOMERY" },
            "37041": { "city" : "CLARKSVILLE", "state" : "TN", "county" : "MONTGOMERY" },
            "37042": { "city" : "CLARKSVILLE", "state" : "TN", "county" : "MONTGOMERY" },
            "37043": { "city" : "CLARKSVILLE", "state" : "TN", "county" : "MONTGOMERY" },
            "37044": { "city" : "CLARKSVILLE", "state" : "TN", "county" : "MONTGOMERY" },
            "37046": { "city" : "COLLEGE GROVE", "state" : "TN", "county" : "WILLIAMSON" },
            "37047": { "city" : "CORNERSVILLE", "state" : "TN", "county" : "MARSHALL" },
            "37048": { "city" : "COTTONTOWN", "state" : "TN", "county" : "SUMNER" },
            "37049": { "city" : "CROSS PLAINS", "state" : "TN", "county" : "ROBERTSON" },
            "37050": { "city" : "CUMBERLAND CITY", "state" : "TN", "county" : "STEWART" },
            "37051": { "city" : "CUMBERLAND FURNACE", "state" : "TN", "county" : "DICKSON" },
            "37052": { "city" : "CUNNINGHAM", "state" : "TN", "county" : "MONTGOMERY" },
            "37055": { "city" : "DICKSON", "state" : "TN", "county" : "DICKSON" },
            "37056": { "city" : "DICKSON", "state" : "TN", "county" : "DICKSON" },
            "37057": { "city" : "DIXON SPRINGS", "state" : "TN", "county" : "SMITH" },
            "37058": { "city" : "DOVER", "state" : "TN", "county" : "STEWART" },"37059": { "city" : "DOWELLTOWN", "state" : "TN", "county" : "DEKALB" },
            "37060": { "city" : "EAGLEVILLE", "state" : "TN", "county" : "RUTHERFORD" },
            "37061": { "city" : "ERIN", "state" : "TN", "county" : "HOUSTON" },"37062": { "city" : "FAIRVIEW", "state" : "TN", "county" : "WILLIAMSON" },
            "37063": { "city" : "FOSTERVILLE", "state" : "TN", "county" : "RUTHERFORD" },
            "37064": { "city" : "FRANKLIN", "state" : "TN", "county" : "WILLIAMSON" },
            "37065": { "city" : "FRANKLIN", "state" : "TN", "county" : "WILLIAMSON" },
            "37066": { "city" : "GALLATIN", "state" : "TN", "county" : "SUMNER" },
            "37067": { "city" : "FRANKLIN", "state" : "TN", "county" : "WILLIAMSON" },
            "37068": { "city" : "FRANKLIN", "state" : "TN", "county" : "WILLIAMSON" },
            "37069": { "city" : "FRANKLIN", "state" : "TN", "county" : "WILLIAMSON" },
            "37070": { "city" : "GOODLETTSVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37071": { "city" : "GLADEVILLE", "state" : "TN", "county" : "WILSON" },
            "37072": { "city" : "GOODLETTSVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37073": { "city" : "GREENBRIER", "state" : "TN", "county" : "ROBERTSON" },
            "37074": { "city" : "HARTSVILLE", "state" : "TN", "county" : "TROUSDALE" },
            "37075": { "city" : "HENDERSONVILLE", "state" : "TN", "county" : "SUMNER" },
            "37076": { "city" : "HERMITAGE", "state" : "TN", "county" : "DAVIDSON" },
            "37077": { "city" : "HENDERSONVILLE", "state" : "TN", "county" : "SUMNER" },
            "37078": { "city" : "HURRICANE MILLS", "state" : "TN", "county" : "HUMPHREYS" },
            "37079": { "city" : "INDIAN MOUND", "state" : "TN", "county" : "STEWART" },
            "37080": { "city" : "JOELTON", "state" : "TN", "county" : "DAVIDSON" },
            "37082": { "city" : "KINGSTON SPRINGS", "state" : "TN", "county" : "CHEATHAM" },
            "37083": { "city" : "LAFAYETTE", "state" : "TN", "county" : "MACON" },
            "37085": { "city" : "LASCASSAS", "state" : "TN", "county" : "RUTHERFORD" },
            "37086": { "city" : "LA VERGNE", "state" : "TN", "county" : "RUTHERFORD" },
            "37087": { "city" : "LEBANON", "state" : "TN", "county" : "WILSON" },
            "37088": { "city" : "LEBANON", "state" : "TN", "county" : "WILSON" },
            "37089": { "city" : "LA VERGNE", "state" : "TN", "county" : "RUTHERFORD" },
            "37090": { "city" : "LEBANON", "state" : "TN", "county" : "WILSON" },
            "37091": { "city" : "LEWISBURG", "state" : "TN", "county" : "MARSHALL" },
            "37095": { "city" : "LIBERTY", "state" : "TN", "county" : "DEKALB" },
            "37096": { "city" : "LINDEN", "state" : "TN", "county" : "PERRY" },"37097": { "city" : "LOBELVILLE", "state" : "TN", "county" : "PERRY" },
            "37098": { "city" : "LYLES", "state" : "TN", "county" : "HICKMAN" },"37101": { "city" : "MC EWEN", "state" : "TN", "county" : "HUMPHREYS" },
            "37110": { "city" : "MC MINNVILLE", "state" : "TN", "county" : "WARREN" },
            "37111": { "city" : "MC MINNVILLE", "state" : "TN", "county" : "WARREN" },
            "37115": { "city" : "MADISON", "state" : "TN", "county" : "DAVIDSON" },
            "37116": { "city" : "MADISON", "state" : "TN", "county" : "DAVIDSON" },
            "37118": { "city" : "MILTON", "state" : "TN", "county" : "RUTHERFORD" },
            "37121": { "city" : "MOUNT JULIET", "state" : "TN", "county" : "WILSON" },
            "37122": { "city" : "MOUNT JULIET", "state" : "TN", "county" : "WILSON" },
            "37127": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37128": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37129": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37130": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37131": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37132": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37133": { "city" : "MURFREESBORO", "state" : "TN", "county" : "RUTHERFORD" },
            "37134": { "city" : "NEW JOHNSONVILLE", "state" : "TN", "county" : "HUMPHREYS" },
            "37135": { "city" : "NOLENSVILLE", "state" : "TN", "county" : "WILLIAMSON" },
            "37137": { "city" : "NUNNELLY", "state" : "TN", "county" : "HICKMAN" },
            "37138": { "city" : "OLD HICKORY", "state" : "TN", "county" : "DAVIDSON" },
            "37140": { "city" : "ONLY", "state" : "TN", "county" : "HICKMAN" },"37141": { "city" : "ORLINDA", "state" : "TN", "county" : "ROBERTSON" },
            "37142": { "city" : "PALMYRA", "state" : "TN", "county" : "MONTGOMERY" },
            "37143": { "city" : "PEGRAM", "state" : "TN", "county" : "CHEATHAM" },
            "37144": { "city" : "PETERSBURG", "state" : "TN", "county" : "LINCOLN" },
            "37145": { "city" : "PLEASANT SHADE", "state" : "TN", "county" : "SMITH" },
            "37146": { "city" : "PLEASANT VIEW", "state" : "TN", "county" : "CHEATHAM" },
            "37148": { "city" : "PORTLAND", "state" : "TN", "county" : "SUMNER" },
            "37149": { "city" : "READYVILLE", "state" : "TN", "county" : "CANNON" },
            "37150": { "city" : "RED BOILING SPRINGS", "state" : "TN", "county" : "MACON" },
            "37151": { "city" : "RIDDLETON", "state" : "TN", "county" : "SMITH" },
            "37152": { "city" : "RIDGETOP", "state" : "TN", "county" : "ROBERTSON" },
            "37153": { "city" : "ROCKVALE", "state" : "TN", "county" : "RUTHERFORD" },
            "37160": { "city" : "SHELBYVILLE", "state" : "TN", "county" : "BEDFORD" },
            "37162": { "city" : "SHELBYVILLE", "state" : "TN", "county" : "BEDFORD" },
            "37166": { "city" : "SMITHVILLE", "state" : "TN", "county" : "DEKALB" },
            "37167": { "city" : "SMYRNA", "state" : "TN", "county" : "RUTHERFORD" },
            "37171": { "city" : "SOUTHSIDE", "state" : "TN", "county" : "MONTGOMERY" },
            "37172": { "city" : "SPRINGFIELD", "state" : "TN", "county" : "ROBERTSON" },
            "37174": { "city" : "SPRING HILL", "state" : "TN", "county" : "MAURY" },
            "37175": { "city" : "STEWART", "state" : "TN", "county" : "HOUSTON" },
            "37178": { "city" : "TENNESSEE RIDGE", "state" : "TN", "county" : "HOUSTON" },
            "37179": { "city" : "THOMPSONS STATION", "state" : "TN", "county" : "WILLIAMSON" },
            "37180": { "city" : "UNIONVILLE", "state" : "TN", "county" : "BEDFORD" },
            "37181": { "city" : "VANLEER", "state" : "TN", "county" : "DICKSON" },
            "37183": { "city" : "WARTRACE", "state" : "TN", "county" : "BEDFORD" },
            "37184": { "city" : "WATERTOWN", "state" : "TN", "county" : "WILSON" },
            "37185": { "city" : "WAVERLY", "state" : "TN", "county" : "HUMPHREYS" },
            "37186": { "city" : "WESTMORELAND", "state" : "TN", "county" : "SUMNER" },
            "37187": { "city" : "WHITE BLUFF", "state" : "TN", "county" : "DICKSON" },
            "37188": { "city" : "WHITE HOUSE", "state" : "TN", "county" : "ROBERTSON" },
            "37189": { "city" : "WHITES CREEK", "state" : "TN", "county" : "DAVIDSON" },
            "37190": { "city" : "WOODBURY", "state" : "TN", "county" : "CANNON" },
            "37191": { "city" : "WOODLAWN", "state" : "TN", "county" : "MONTGOMERY" },
            "37201": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37202": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37203": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37204": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37205": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37206": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37207": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37208": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37209": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37210": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37211": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37212": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37213": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37214": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37215": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37216": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37217": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37218": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37219": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37220": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37221": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37222": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37224": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37227": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37228": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37229": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37230": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37232": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37234": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37235": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37236": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37238": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37240": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37242": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37243": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37244": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37249": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37250": { "city" : "NASHVILLE", "state" : "TN", "county" : "DAVIDSON" },
            "37301": { "city" : "ALTAMONT", "state" : "TN", "county" : "GRUNDY" },
            "37302": { "city" : "APISON", "state" : "TN", "county" : "HAMILTON" },
            "37303": { "city" : "ATHENS", "state" : "TN", "county" : "MCMINN" },"37304": { "city" : "BAKEWELL", "state" : "TN", "county" : "HAMILTON" },
            "37305": { "city" : "BEERSHEBA SPRINGS", "state" : "TN", "county" : "GRUNDY" },
            "37306": { "city" : "BELVIDERE", "state" : "TN", "county" : "FRANKLIN" },
            "37307": { "city" : "BENTON", "state" : "TN", "county" : "POLK" },"37308": { "city" : "BIRCHWOOD", "state" : "TN", "county" : "HAMILTON" },
            "37309": { "city" : "CALHOUN", "state" : "TN", "county" : "MCMINN" },
            "37310": { "city" : "CHARLESTON", "state" : "TN", "county" : "BRADLEY" },
            "37311": { "city" : "CLEVELAND", "state" : "TN", "county" : "BRADLEY" },
            "37312": { "city" : "CLEVELAND", "state" : "TN", "county" : "BRADLEY" },
            "37313": { "city" : "COALMONT", "state" : "TN", "county" : "GRUNDY" },
            "37314": { "city" : "COKER CREEK", "state" : "TN", "county" : "MONROE" },
            "37315": { "city" : "COLLEGEDALE", "state" : "TN", "county" : "HAMILTON" },
            "37316": { "city" : "CONASAUGA", "state" : "TN", "county" : "POLK" },
            "37317": { "city" : "COPPERHILL", "state" : "TN", "county" : "POLK" },
            "37318": { "city" : "COWAN", "state" : "TN", "county" : "FRANKLIN" },
            "37320": { "city" : "CLEVELAND", "state" : "TN", "county" : "BRADLEY" },
            "37321": { "city" : "DAYTON", "state" : "TN", "county" : "RHEA" },"37322": { "city" : "DECATUR", "state" : "TN", "county" : "MEIGS" },
            "37323": { "city" : "CLEVELAND", "state" : "TN", "county" : "BRADLEY" },
            "37324": { "city" : "DECHERD", "state" : "TN", "county" : "FRANKLIN" },
            "37325": { "city" : "DELANO", "state" : "TN", "county" : "POLK" },"37326": { "city" : "DUCKTOWN", "state" : "TN", "county" : "POLK" },
            "37327": { "city" : "DUNLAP", "state" : "TN", "county" : "SEQUATCHIE" },
            "37328": { "city" : "ELORA", "state" : "TN", "county" : "LINCOLN" },"37329": { "city" : "ENGLEWOOD", "state" : "TN", "county" : "MCMINN" },
            "37330": { "city" : "ESTILL SPRINGS", "state" : "TN", "county" : "FRANKLIN" },
            "37331": { "city" : "ETOWAH", "state" : "TN", "county" : "MCMINN" },"37332": { "city" : "EVENSVILLE", "state" : "TN", "county" : "RHEA" },
            "37333": { "city" : "FARNER", "state" : "TN", "county" : "POLK" },"37334": { "city" : "FAYETTEVILLE", "state" : "TN", "county" : "LINCOLN" },
            "37335": { "city" : "FLINTVILLE", "state" : "TN", "county" : "LINCOLN" },
            "37336": { "city" : "GEORGETOWN", "state" : "TN", "county" : "MEIGS" },
            "37337": { "city" : "GRANDVIEW", "state" : "TN", "county" : "RHEA" },
            "37338": { "city" : "GRAYSVILLE", "state" : "TN", "county" : "RHEA" },
            "37339": { "city" : "GRUETLI LAAGER", "state" : "TN", "county" : "GRUNDY" },
            "37340": { "city" : "GUILD", "state" : "TN", "county" : "MARION" },"37341": { "city" : "HARRISON", "state" : "TN", "county" : "HAMILTON" },
            "37342": { "city" : "HILLSBORO", "state" : "TN", "county" : "COFFEE" },
            "37343": { "city" : "HIXSON", "state" : "TN", "county" : "HAMILTON" },
            "37345": { "city" : "HUNTLAND", "state" : "TN", "county" : "FRANKLIN" },
            "37347": { "city" : "JASPER", "state" : "TN", "county" : "MARION" },"37348": { "city" : "KELSO", "state" : "TN", "county" : "LINCOLN" },
            "37349": { "city" : "MANCHESTER", "state" : "TN", "county" : "COFFEE" },
            "37350": { "city" : "LOOKOUT MOUNTAIN", "state" : "TN", "county" : "HAMILTON" },
            "37352": { "city" : "LYNCHBURG", "state" : "TN", "county" : "MOORE" },
            "37353": { "city" : "MC DONALD", "state" : "TN", "county" : "BRADLEY" },
            "37354": { "city" : "MADISONVILLE", "state" : "TN", "county" : "MONROE" },
            "37355": { "city" : "MANCHESTER", "state" : "TN", "county" : "COFFEE" },
            "37356": { "city" : "MONTEAGLE", "state" : "TN", "county" : "GRUNDY" },
            "37357": { "city" : "MORRISON", "state" : "TN", "county" : "WARREN" },
            "37359": { "city" : "MULBERRY", "state" : "TN", "county" : "LINCOLN" },
            "37360": { "city" : "NORMANDY", "state" : "TN", "county" : "BEDFORD" },
            "37361": { "city" : "OCOEE", "state" : "TN", "county" : "POLK" },"37362": { "city" : "OLD FORT", "state" : "TN", "county" : "POLK" },
            "37363": { "city" : "OOLTEWAH", "state" : "TN", "county" : "HAMILTON" },
            "37364": { "city" : "CLEVELAND", "state" : "TN", "county" : "BRADLEY" },
            "37365": { "city" : "PALMER", "state" : "TN", "county" : "GRUNDY" },"37366": { "city" : "PELHAM", "state" : "TN", "county" : "GRUNDY" },
            "37367": { "city" : "PIKEVILLE", "state" : "TN", "county" : "BLEDSOE" },
            "37369": { "city" : "RELIANCE", "state" : "TN", "county" : "POLK" },"37370": { "city" : "RICEVILLE", "state" : "TN", "county" : "MCMINN" },
            "37371": { "city" : "ATHENS", "state" : "TN", "county" : "MCMINN" },"37373": { "city" : "SALE CREEK", "state" : "TN", "county" : "HAMILTON" },
            "37374": { "city" : "SEQUATCHIE", "state" : "TN", "county" : "MARION" },
            "37375": { "city" : "SEWANEE", "state" : "TN", "county" : "FRANKLIN" },
            "37376": { "city" : "SHERWOOD", "state" : "TN", "county" : "FRANKLIN" },
            "37377": { "city" : "SIGNAL MOUNTAIN", "state" : "TN", "county" : "HAMILTON" },
            "37378": { "city" : "SMARTT", "state" : "TN", "county" : "WARREN" },"37379": { "city" : "SODDY DAISY", "state" : "TN", "county" : "HAMILTON" },
            "37380": { "city" : "SOUTH PITTSBURG", "state" : "TN", "county" : "MARION" },
            "37381": { "city" : "SPRING CITY", "state" : "TN", "county" : "RHEA" },
            "37382": { "city" : "SUMMITVILLE", "state" : "TN", "county" : "COFFEE" },
            "37383": { "city" : "SEWANEE", "state" : "TN", "county" : "FRANKLIN" },
            "37384": { "city" : "SODDY DAISY", "state" : "TN", "county" : "HAMILTON" },
            "37385": { "city" : "TELLICO PLAINS", "state" : "TN", "county" : "MONROE" },
            "37387": { "city" : "TRACY CITY", "state" : "TN", "county" : "GRUNDY" },
            "37388": { "city" : "TULLAHOMA", "state" : "TN", "county" : "COFFEE" },
            "37389": { "city" : "ARNOLD A F B", "state" : "TN", "county" : "COFFEE" },
            "37391": { "city" : "TURTLETOWN", "state" : "TN", "county" : "POLK" },
            "37394": { "city" : "VIOLA", "state" : "TN", "county" : "WARREN" },"37396": { "city" : "WHITESIDE", "state" : "TN", "county" : "MARION" },
            "37397": { "city" : "WHITWELL", "state" : "TN", "county" : "SEQUATCHIE" },
            "37398": { "city" : "WINCHESTER", "state" : "TN", "county" : "FRANKLIN" },
            "37401": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37402": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37403": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37404": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37405": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37406": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37407": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37408": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37409": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37410": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37411": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37412": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37414": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37415": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37416": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37419": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37421": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37422": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37424": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37450": { "city" : "CHATTANOOGA", "state" : "TN", "county" : "HAMILTON" },
            "37501": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "37601": { "city" : "JOHNSON CITY", "state" : "TN", "county" : "WASHINGTON" },
            "37602": { "city" : "JOHNSON CITY", "state" : "TN", "county" : "WASHINGTON" },
            "37604": { "city" : "JOHNSON CITY", "state" : "TN", "county" : "WASHINGTON" },
            "37605": { "city" : "JOHNSON CITY", "state" : "TN", "county" : "WASHINGTON" },
            "37614": { "city" : "JOHNSON CITY", "state" : "TN", "county" : "WASHINGTON" },
            "37615": { "city" : "JOHNSON CITY", "state" : "TN", "county" : "WASHINGTON" },
            "37616": { "city" : "AFTON", "state" : "TN", "county" : "GREENE" },"37617": { "city" : "BLOUNTVILLE", "state" : "TN", "county" : "SULLIVAN" },
            "37618": { "city" : "BLUFF CITY", "state" : "TN", "county" : "SULLIVAN" },
            "37620": { "city" : "BRISTOL", "state" : "TN", "county" : "SULLIVAN" },
            "37621": { "city" : "BRISTOL", "state" : "TN", "county" : "SULLIVAN" },
            "37625": { "city" : "BRISTOL", "state" : "TN", "county" : "SULLIVAN" },
            "37640": { "city" : "BUTLER", "state" : "TN", "county" : "JOHNSON" },
            "37641": { "city" : "CHUCKEY", "state" : "TN", "county" : "GREENE" },
            "37642": { "city" : "CHURCH HILL", "state" : "TN", "county" : "HAWKINS" },
            "37643": { "city" : "ELIZABETHTON", "state" : "TN", "county" : "CARTER" },
            "37644": { "city" : "ELIZABETHTON", "state" : "TN", "county" : "CARTER" },
            "37645": { "city" : "MOUNT CARMEL", "state" : "TN", "county" : "HAWKINS" },
            "37650": { "city" : "ERWIN", "state" : "TN", "county" : "UNICOI" },"37656": { "city" : "FALL BRANCH", "state" : "TN", "county" : "WASHINGTON" },
            "37657": { "city" : "FLAG POND", "state" : "TN", "county" : "UNICOI" },
            "37658": { "city" : "HAMPTON", "state" : "TN", "county" : "CARTER" },
            "37659": { "city" : "JONESBOROUGH", "state" : "TN", "county" : "WASHINGTON" },
            "37660": { "city" : "KINGSPORT", "state" : "TN", "county" : "SULLIVAN" },
            "37662": { "city" : "KINGSPORT", "state" : "TN", "county" : "SULLIVAN" },
            "37663": { "city" : "KINGSPORT", "state" : "TN", "county" : "SULLIVAN" },
            "37664": { "city" : "KINGSPORT", "state" : "TN", "county" : "SULLIVAN" },
            "37665": { "city" : "KINGSPORT", "state" : "TN", "county" : "SULLIVAN" },
            "37680": { "city" : "LAUREL BLOOMERY", "state" : "TN", "county" : "JOHNSON" },
            "37681": { "city" : "LIMESTONE", "state" : "TN", "county" : "WASHINGTON" },
            "37682": { "city" : "MILLIGAN COLLEGE", "state" : "TN", "county" : "CARTER" },
            "37683": { "city" : "MOUNTAIN CITY", "state" : "TN", "county" : "JOHNSON" },
            "37684": { "city" : "MOUNTAIN HOME", "state" : "TN", "county" : "WASHINGTON" },
            "37686": { "city" : "PINEY FLATS", "state" : "TN", "county" : "SULLIVAN" },
            "37687": { "city" : "ROAN MOUNTAIN", "state" : "TN", "county" : "CARTER" },
            "37688": { "city" : "SHADY VALLEY", "state" : "TN", "county" : "JOHNSON" },
            "37690": { "city" : "TELFORD", "state" : "TN", "county" : "WASHINGTON" },
            "37691": { "city" : "TRADE", "state" : "TN", "county" : "JOHNSON" },"37692": { "city" : "UNICOI", "state" : "TN", "county" : "UNICOI" },
            "37694": { "city" : "WATAUGA", "state" : "TN", "county" : "CARTER" },
            "37701": { "city" : "ALCOA", "state" : "TN", "county" : "BLOUNT" },"37705": { "city" : "ANDERSONVILLE", "state" : "TN", "county" : "ANDERSON" },
            "37707": { "city" : "ARTHUR", "state" : "TN", "county" : "CLAIBORNE" },
            "37708": { "city" : "BEAN STATION", "state" : "TN", "county" : "GRAINGER" },
            "37709": { "city" : "BLAINE", "state" : "TN", "county" : "GRAINGER" },
            "37710": { "city" : "BRICEVILLE", "state" : "TN", "county" : "ANDERSON" },
            "37711": { "city" : "BULLS GAP", "state" : "TN", "county" : "HAWKINS" },
            "37713": { "city" : "BYBEE", "state" : "TN", "county" : "COCKE" },"37714": { "city" : "CARYVILLE", "state" : "TN", "county" : "CAMPBELL" },
            "37715": { "city" : "CLAIRFIELD", "state" : "TN", "county" : "CLAIBORNE" },
            "37716": { "city" : "CLINTON", "state" : "TN", "county" : "ANDERSON" },
            "37717": { "city" : "CLINTON", "state" : "TN", "county" : "ANDERSON" },
            "37719": { "city" : "COALFIELD", "state" : "TN", "county" : "MORGAN" },
            "37721": { "city" : "CORRYTON", "state" : "TN", "county" : "KNOX" },"37722": { "city" : "COSBY", "state" : "TN", "county" : "COCKE" },
            "37723": { "city" : "CRAB ORCHARD", "state" : "TN", "county" : "CUMBERLAND" },
            "37724": { "city" : "CUMBERLAND GAP", "state" : "TN", "county" : "CLAIBORNE" },
            "37725": { "city" : "DANDRIDGE", "state" : "TN", "county" : "JEFFERSON" },
            "37726": { "city" : "DEER LODGE", "state" : "TN", "county" : "MORGAN" },
            "37727": { "city" : "DEL RIO", "state" : "TN", "county" : "COCKE" },"37729": { "city" : "DUFF", "state" : "TN", "county" : "CAMPBELL" },
            "37730": { "city" : "EAGAN", "state" : "TN", "county" : "CLAIBORNE" },
            "37731": { "city" : "EIDSON", "state" : "TN", "county" : "HAWKINS" },
            "37732": { "city" : "ELGIN", "state" : "TN", "county" : "SCOTT" },"37733": { "city" : "RUGBY", "state" : "TN", "county" : "MORGAN" },
            "37737": { "city" : "FRIENDSVILLE", "state" : "TN", "county" : "BLOUNT" },
            "37738": { "city" : "GATLINBURG", "state" : "TN", "county" : "SEVIER" },
            "37742": { "city" : "GREENBACK", "state" : "TN", "county" : "LOUDON" },
            "37743": { "city" : "GREENEVILLE", "state" : "TN", "county" : "GREENE" },
            "37744": { "city" : "GREENEVILLE", "state" : "TN", "county" : "GREENE" },
            "37745": { "city" : "GREENEVILLE", "state" : "TN", "county" : "GREENE" },
            "37748": { "city" : "HARRIMAN", "state" : "TN", "county" : "ROANE" },
            "37752": { "city" : "HARROGATE", "state" : "TN", "county" : "CLAIBORNE" },
            "37753": { "city" : "HARTFORD", "state" : "TN", "county" : "COCKE" },
            "37754": { "city" : "HEISKELL", "state" : "TN", "county" : "KNOX" },"37755": { "city" : "HELENWOOD", "state" : "TN", "county" : "SCOTT" },
            "37756": { "city" : "HUNTSVILLE", "state" : "TN", "county" : "SCOTT" },
            "37757": { "city" : "JACKSBORO", "state" : "TN", "county" : "CAMPBELL" },
            "37760": { "city" : "JEFFERSON CITY", "state" : "TN", "county" : "JEFFERSON" },
            "37762": { "city" : "JELLICO", "state" : "TN", "county" : "CAMPBELL" },
            "37763": { "city" : "KINGSTON", "state" : "TN", "county" : "ROANE" },
            "37764": { "city" : "KODAK", "state" : "TN", "county" : "SEVIER" },"37766": { "city" : "LA FOLLETTE", "state" : "TN", "county" : "CAMPBELL" },
            "37769": { "city" : "LAKE CITY", "state" : "TN", "county" : "ANDERSON" },
            "37770": { "city" : "LANCING", "state" : "TN", "county" : "MORGAN" },
            "37771": { "city" : "LENOIR CITY", "state" : "TN", "county" : "LOUDON" },
            "37772": { "city" : "LENOIR CITY", "state" : "TN", "county" : "LOUDON" },
            "37773": { "city" : "LONE MOUNTAIN", "state" : "TN", "county" : "CLAIBORNE" },
            "37774": { "city" : "LOUDON", "state" : "TN", "county" : "LOUDON" },"37777": { "city" : "LOUISVILLE", "state" : "TN", "county" : "BLOUNT" },
            "37778": { "city" : "LOWLAND", "state" : "TN", "county" : "HAMBLEN" },
            "37779": { "city" : "LUTTRELL", "state" : "TN", "county" : "UNION" },
            "37801": { "city" : "MARYVILLE", "state" : "TN", "county" : "BLOUNT" },
            "37802": { "city" : "MARYVILLE", "state" : "TN", "county" : "BLOUNT" },
            "37803": { "city" : "MARYVILLE", "state" : "TN", "county" : "BLOUNT" },
            "37804": { "city" : "MARYVILLE", "state" : "TN", "county" : "BLOUNT" },
            "37806": { "city" : "MASCOT", "state" : "TN", "county" : "KNOX" },"37807": { "city" : "MAYNARDVILLE", "state" : "TN", "county" : "UNION" },
            "37809": { "city" : "MIDWAY", "state" : "TN", "county" : "GREENE" },"37810": { "city" : "MOHAWK", "state" : "TN", "county" : "GREENE" },
            "37811": { "city" : "MOORESBURG", "state" : "TN", "county" : "HAWKINS" },
            "37813": { "city" : "MORRISTOWN", "state" : "TN", "county" : "HAMBLEN" },
            "37814": { "city" : "MORRISTOWN", "state" : "TN", "county" : "HAMBLEN" },
            "37815": { "city" : "MORRISTOWN", "state" : "TN", "county" : "HAMBLEN" },
            "37816": { "city" : "MORRISTOWN", "state" : "TN", "county" : "HAMBLEN" },
            "37818": { "city" : "MOSHEIM", "state" : "TN", "county" : "GREENE" },
            "37819": { "city" : "NEWCOMB", "state" : "TN", "county" : "CAMPBELL" },
            "37820": { "city" : "NEW MARKET", "state" : "TN", "county" : "JEFFERSON" },
            "37821": { "city" : "NEWPORT", "state" : "TN", "county" : "COCKE" },"37822": { "city" : "NEWPORT", "state" : "TN", "county" : "COCKE" },
            "37824": { "city" : "NEW TAZEWELL", "state" : "TN", "county" : "CLAIBORNE" },
            "37825": { "city" : "NEW TAZEWELL", "state" : "TN", "county" : "CLAIBORNE" },
            "37826": { "city" : "NIOTA", "state" : "TN", "county" : "MCMINN" },"37828": { "city" : "NORRIS", "state" : "TN", "county" : "ANDERSON" },
            "37829": { "city" : "OAKDALE", "state" : "TN", "county" : "MORGAN" },
            "37830": { "city" : "OAK RIDGE", "state" : "TN", "county" : "ANDERSON" },
            "37831": { "city" : "OAK RIDGE", "state" : "TN", "county" : "ANDERSON" },
            "37840": { "city" : "OLIVER SPRINGS", "state" : "TN", "county" : "ROANE" },
            "37841": { "city" : "ONEIDA", "state" : "TN", "county" : "SCOTT" },"37843": { "city" : "PARROTTSVILLE", "state" : "TN", "county" : "COCKE" },
            "37845": { "city" : "PETROS", "state" : "TN", "county" : "MORGAN" },"37846": { "city" : "PHILADELPHIA", "state" : "TN", "county" : "LOUDON" },
            "37847": { "city" : "PIONEER", "state" : "TN", "county" : "CAMPBELL" },
            "37848": { "city" : "POWDER SPRINGS", "state" : "TN", "county" : "GRAINGER" },
            "37849": { "city" : "POWELL", "state" : "TN", "county" : "KNOX" },"37852": { "city" : "ROBBINS", "state" : "TN", "county" : "SCOTT" },
            "37853": { "city" : "ROCKFORD", "state" : "TN", "county" : "BLOUNT" },
            "37854": { "city" : "ROCKWOOD", "state" : "TN", "county" : "ROANE" },
            "37857": { "city" : "ROGERSVILLE", "state" : "TN", "county" : "HAWKINS" },
            "37860": { "city" : "RUSSELLVILLE", "state" : "TN", "county" : "HAMBLEN" },
            "37861": { "city" : "RUTLEDGE", "state" : "TN", "county" : "GRAINGER" },
            "37862": { "city" : "SEVIERVILLE", "state" : "TN", "county" : "SEVIER" },
            "37863": { "city" : "PIGEON FORGE", "state" : "TN", "county" : "SEVIER" },
            "37864": { "city" : "SEVIERVILLE", "state" : "TN", "county" : "SEVIER" },
            "37865": { "city" : "SEYMOUR", "state" : "TN", "county" : "SEVIER" },
            "37866": { "city" : "SHARPS CHAPEL", "state" : "TN", "county" : "UNION" },
            "37868": { "city" : "PIGEON FORGE", "state" : "TN", "county" : "SEVIER" },
            "37869": { "city" : "SNEEDVILLE", "state" : "TN", "county" : "HANCOCK" },
            "37870": { "city" : "SPEEDWELL", "state" : "TN", "county" : "CLAIBORNE" },
            "37871": { "city" : "STRAWBERRY PLAINS", "state" : "TN", "county" : "JEFFERSON" },
            "37872": { "city" : "SUNBRIGHT", "state" : "TN", "county" : "MORGAN" },
            "37873": { "city" : "SURGOINSVILLE", "state" : "TN", "county" : "HAWKINS" },
            "37874": { "city" : "SWEETWATER", "state" : "TN", "county" : "MONROE" },
            "37876": { "city" : "SEVIERVILLE", "state" : "TN", "county" : "SEVIER" },
            "37877": { "city" : "TALBOTT", "state" : "TN", "county" : "HAMBLEN" },
            "37878": { "city" : "TALLASSEE", "state" : "TN", "county" : "BLOUNT" },
            "37879": { "city" : "TAZEWELL", "state" : "TN", "county" : "CLAIBORNE" },
            "37880": { "city" : "TEN MILE", "state" : "TN", "county" : "MEIGS" },
            "37881": { "city" : "THORN HILL", "state" : "TN", "county" : "GRAINGER" },
            "37882": { "city" : "TOWNSEND", "state" : "TN", "county" : "BLOUNT" },
            "37885": { "city" : "VONORE", "state" : "TN", "county" : "MONROE" },"37886": { "city" : "WALLAND", "state" : "TN", "county" : "BLOUNT" },
            "37887": { "city" : "WARTBURG", "state" : "TN", "county" : "MORGAN" },
            "37888": { "city" : "WASHBURN", "state" : "TN", "county" : "GRAINGER" },
            "37890": { "city" : "WHITE PINE", "state" : "TN", "county" : "JEFFERSON" },
            "37891": { "city" : "WHITESBURG", "state" : "TN", "county" : "HAMBLEN" },
            "37892": { "city" : "WINFIELD", "state" : "TN", "county" : "SCOTT" },
            "37901": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37902": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37909": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37912": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37914": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37915": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37916": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37917": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37918": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37919": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37920": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37921": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37922": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37923": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37924": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37927": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37928": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37929": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37930": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37931": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37932": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37933": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37934": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37938": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37939": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37940": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37950": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37996": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "37998": { "city" : "KNOXVILLE", "state" : "TN", "county" : "KNOX" },
            "38001": { "city" : "ALAMO", "state" : "TN", "county" : "CROCKETT" },
            "38002": { "city" : "ARLINGTON", "state" : "TN", "county" : "SHELBY" },
            "38004": { "city" : "ATOKA", "state" : "TN", "county" : "TIPTON" },"38006": { "city" : "BELLS", "state" : "TN", "county" : "CROCKETT" },
            "38007": { "city" : "BOGOTA", "state" : "TN", "county" : "DYER" },"38008": { "city" : "BOLIVAR", "state" : "TN", "county" : "HARDEMAN" },
            "38011": { "city" : "BRIGHTON", "state" : "TN", "county" : "TIPTON" },
            "38012": { "city" : "BROWNSVILLE", "state" : "TN", "county" : "HAYWOOD" },
            "38014": { "city" : "BRUNSWICK", "state" : "TN", "county" : "SHELBY" },
            "38015": { "city" : "BURLISON", "state" : "TN", "county" : "TIPTON" },
            "38016": { "city" : "CORDOVA", "state" : "TN", "county" : "SHELBY" },
            "38017": { "city" : "COLLIERVILLE", "state" : "TN", "county" : "SHELBY" },
            "38018": { "city" : "CORDOVA", "state" : "TN", "county" : "SHELBY" },
            "38019": { "city" : "COVINGTON", "state" : "TN", "county" : "TIPTON" },
            "38021": { "city" : "CROCKETT MILLS", "state" : "TN", "county" : "CROCKETT" },
            "38023": { "city" : "DRUMMONDS", "state" : "TN", "county" : "TIPTON" },
            "38024": { "city" : "DYERSBURG", "state" : "TN", "county" : "DYER" },
            "38025": { "city" : "DYERSBURG", "state" : "TN", "county" : "DYER" },
            "38027": { "city" : "COLLIERVILLE", "state" : "TN", "county" : "SHELBY" },
            "38028": { "city" : "EADS", "state" : "TN", "county" : "SHELBY" },"38029": { "city" : "ELLENDALE", "state" : "TN", "county" : "SHELBY" },
            "38030": { "city" : "FINLEY", "state" : "TN", "county" : "DYER" },"38034": { "city" : "FRIENDSHIP", "state" : "TN", "county" : "CROCKETT" },
            "38036": { "city" : "GALLAWAY", "state" : "TN", "county" : "FAYETTE" },
            "38037": { "city" : "GATES", "state" : "TN", "county" : "LAUDERDALE" },
            "38039": { "city" : "GRAND JUNCTION", "state" : "TN", "county" : "HARDEMAN" },
            "38040": { "city" : "HALLS", "state" : "TN", "county" : "LAUDERDALE" },
            "38041": { "city" : "HENNING", "state" : "TN", "county" : "LAUDERDALE" },
            "38042": { "city" : "HICKORY VALLEY", "state" : "TN", "county" : "HARDEMAN" },
            "38044": { "city" : "HORNSBY", "state" : "TN", "county" : "HARDEMAN" },
            "38046": { "city" : "LA GRANGE", "state" : "TN", "county" : "FAYETTE" },
            "38047": { "city" : "LENOX", "state" : "TN", "county" : "DYER" },"38048": { "city" : "MACON", "state" : "TN", "county" : "FAYETTE" },
            "38049": { "city" : "MASON", "state" : "TN", "county" : "TIPTON" },"38050": { "city" : "MAURY CITY", "state" : "TN", "county" : "CROCKETT" },
            "38052": { "city" : "MIDDLETON", "state" : "TN", "county" : "HARDEMAN" },
            "38053": { "city" : "MILLINGTON", "state" : "TN", "county" : "SHELBY" },
            "38054": { "city" : "MILLINGTON", "state" : "TN", "county" : "SHELBY" },
            "38055": { "city" : "MILLINGTON", "state" : "TN", "county" : "SHELBY" },
            "38057": { "city" : "MOSCOW", "state" : "TN", "county" : "FAYETTE" },
            "38058": { "city" : "MUNFORD", "state" : "TN", "county" : "TIPTON" },
            "38059": { "city" : "NEWBERN", "state" : "TN", "county" : "DYER" },"38060": { "city" : "OAKLAND", "state" : "TN", "county" : "FAYETTE" },
            "38061": { "city" : "POCAHONTAS", "state" : "TN", "county" : "HARDEMAN" },
            "38063": { "city" : "RIPLEY", "state" : "TN", "county" : "LAUDERDALE" },
            "38066": { "city" : "ROSSVILLE", "state" : "TN", "county" : "FAYETTE" },
            "38067": { "city" : "SAULSBURY", "state" : "TN", "county" : "HARDEMAN" },
            "38068": { "city" : "SOMERVILLE", "state" : "TN", "county" : "FAYETTE" },
            "38069": { "city" : "STANTON", "state" : "TN", "county" : "HAYWOOD" },
            "38070": { "city" : "TIGRETT", "state" : "TN", "county" : "DYER" },"38071": { "city" : "TIPTON", "state" : "TN", "county" : "TIPTON" },
            "38075": { "city" : "WHITEVILLE", "state" : "TN", "county" : "HARDEMAN" },
            "38076": { "city" : "WILLISTON", "state" : "TN", "county" : "FAYETTE" },
            "38077": { "city" : "WYNNBURG", "state" : "TN", "county" : "LAKE" },"38079": { "city" : "TIPTONVILLE", "state" : "TN", "county" : "LAKE" },
            "38080": { "city" : "RIDGELY", "state" : "TN", "county" : "LAKE" },"38083": { "city" : "MILLINGTON", "state" : "TN", "county" : "SHELBY" },
            "38088": { "city" : "CORDOVA", "state" : "TN", "county" : "SHELBY" },
            "38101": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38103": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38104": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38105": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38106": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38107": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38108": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38109": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38111": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38112": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38113": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38114": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38115": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38116": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38117": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38118": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38119": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38120": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38122": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38124": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38125": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38126": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38127": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38128": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38130": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38131": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38132": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38133": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38134": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38135": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38137": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38138": { "city" : "GERMANTOWN", "state" : "TN", "county" : "SHELBY" },
            "38139": { "city" : "GERMANTOWN", "state" : "TN", "county" : "SHELBY" },
            "38141": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38150": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38151": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38152": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38157": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38159": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38163": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38167": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38168": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38173": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38174": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38175": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38177": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38181": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38182": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38183": { "city" : "GERMANTOWN", "state" : "TN", "county" : "SHELBY" },
            "38184": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38186": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38187": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38190": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38193": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38194": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38197": { "city" : "MEMPHIS", "state" : "TN", "county" : "SHELBY" },
            "38201": { "city" : "MC KENZIE", "state" : "TN", "county" : "CARROLL" },
            "38220": { "city" : "ATWOOD", "state" : "TN", "county" : "CARROLL" },
            "38221": { "city" : "BIG SANDY", "state" : "TN", "county" : "BENTON" },
            "38222": { "city" : "BUCHANAN", "state" : "TN", "county" : "HENRY" },
            "38224": { "city" : "COTTAGE GROVE", "state" : "TN", "county" : "HENRY" },
            "38225": { "city" : "DRESDEN", "state" : "TN", "county" : "WEAKLEY" },
            "38226": { "city" : "DUKEDOM", "state" : "TN", "county" : "WEAKLEY" },
            "38229": { "city" : "GLEASON", "state" : "TN", "county" : "WEAKLEY" },
            "38230": { "city" : "GREENFIELD", "state" : "TN", "county" : "WEAKLEY" },
            "38231": { "city" : "HENRY", "state" : "TN", "county" : "HENRY" },"38232": { "city" : "HORNBEAK", "state" : "TN", "county" : "OBION" },
            "38233": { "city" : "KENTON", "state" : "TN", "county" : "GIBSON" },"38235": { "city" : "MC LEMORESVILLE", "state" : "TN", "county" : "CARROLL" },
            "38236": { "city" : "MANSFIELD", "state" : "TN", "county" : "HENRY" },
            "38237": { "city" : "MARTIN", "state" : "TN", "county" : "WEAKLEY" },
            "38238": { "city" : "MARTIN", "state" : "TN", "county" : "WEAKLEY" },
            "38240": { "city" : "OBION", "state" : "TN", "county" : "OBION" },"38241": { "city" : "PALMERSVILLE", "state" : "TN", "county" : "WEAKLEY" },
            "38242": { "city" : "PARIS", "state" : "TN", "county" : "HENRY" },"38251": { "city" : "PURYEAR", "state" : "TN", "county" : "HENRY" },
            "38253": { "city" : "RIVES", "state" : "TN", "county" : "OBION" },"38254": { "city" : "SAMBURG", "state" : "TN", "county" : "OBION" },
            "38255": { "city" : "SHARON", "state" : "TN", "county" : "WEAKLEY" },
            "38256": { "city" : "SPRINGVILLE", "state" : "TN", "county" : "HENRY" },
            "38257": { "city" : "SOUTH FULTON", "state" : "TN", "county" : "OBION" },
            "38258": { "city" : "TREZEVANT", "state" : "TN", "county" : "CARROLL" },
            "38259": { "city" : "TRIMBLE", "state" : "TN", "county" : "DYER" },"38260": { "city" : "TROY", "state" : "TN", "county" : "OBION" },
            "38261": { "city" : "UNION CITY", "state" : "TN", "county" : "OBION" },
            "38271": { "city" : "WOODLAND MILLS", "state" : "TN", "county" : "OBION" },
            "38281": { "city" : "UNION CITY", "state" : "TN", "county" : "OBION" },
            "38301": { "city" : "JACKSON", "state" : "TN", "county" : "MADISON" },
            "38302": { "city" : "JACKSON", "state" : "TN", "county" : "MADISON" },
            "38303": { "city" : "JACKSON", "state" : "TN", "county" : "MADISON" },
            "38305": { "city" : "JACKSON", "state" : "TN", "county" : "MADISON" },
            "38308": { "city" : "JACKSON", "state" : "TN", "county" : "MADISON" },
            "38310": { "city" : "ADAMSVILLE", "state" : "TN", "county" : "MCNAIRY" },
            "38311": { "city" : "BATH SPRINGS", "state" : "TN", "county" : "DECATUR" },
            "38313": { "city" : "BEECH BLUFF", "state" : "TN", "county" : "MADISON" },
            "38314": { "city" : "JACKSON", "state" : "TN", "county" : "MADISON" },
            "38315": { "city" : "BETHEL SPRINGS", "state" : "TN", "county" : "MCNAIRY" },
            "38316": { "city" : "BRADFORD", "state" : "TN", "county" : "GIBSON" },
            "38317": { "city" : "BRUCETON", "state" : "TN", "county" : "CARROLL" },
            "38318": { "city" : "BUENA VISTA", "state" : "TN", "county" : "CARROLL" },
            "38320": { "city" : "CAMDEN", "state" : "TN", "county" : "BENTON" },"38321": { "city" : "CEDAR GROVE", "state" : "TN", "county" : "CARROLL" },
            "38324": { "city" : "CLARKSBURG", "state" : "TN", "county" : "CARROLL" },
            "38326": { "city" : "COUNCE", "state" : "TN", "county" : "HARDIN" },"38327": { "city" : "CRUMP", "state" : "TN", "county" : "HARDIN" },
            "38328": { "city" : "DARDEN", "state" : "TN", "county" : "HENDERSON" },
            "38329": { "city" : "DECATURVILLE", "state" : "TN", "county" : "DECATUR" },
            "38330": { "city" : "DYER", "state" : "TN", "county" : "GIBSON" },"38332": { "city" : "ENVILLE", "state" : "TN", "county" : "CHESTER" },
            "38333": { "city" : "EVA", "state" : "TN", "county" : "BENTON" },"38334": { "city" : "FINGER", "state" : "TN", "county" : "MCNAIRY" },
            "38337": { "city" : "GADSDEN", "state" : "TN", "county" : "CROCKETT" },
            "38338": { "city" : "GIBSON", "state" : "TN", "county" : "GIBSON" },"38339": { "city" : "GUYS", "state" : "TN", "county" : "MCNAIRY" },
            "38340": { "city" : "HENDERSON", "state" : "TN", "county" : "CHESTER" },
            "38341": { "city" : "HOLLADAY", "state" : "TN", "county" : "BENTON" },
            "38342": { "city" : "HOLLOW ROCK", "state" : "TN", "county" : "CARROLL" },
            "38343": { "city" : "HUMBOLDT", "state" : "TN", "county" : "GIBSON" },
            "38344": { "city" : "HUNTINGDON", "state" : "TN", "county" : "CARROLL" },
            "38345": { "city" : "HURON", "state" : "TN", "county" : "HENDERSON" },
            "38346": { "city" : "IDLEWILD", "state" : "TN", "county" : "GIBSON" },
            "38347": { "city" : "JACKS CREEK", "state" : "TN", "county" : "CHESTER" },
            "38348": { "city" : "LAVINIA", "state" : "TN", "county" : "CARROLL" },
            "38351": { "city" : "LEXINGTON", "state" : "TN", "county" : "HENDERSON" },
            "38352": { "city" : "LURAY", "state" : "TN", "county" : "CHESTER" },"38355": { "city" : "MEDINA", "state" : "TN", "county" : "GIBSON" },
            "38356": { "city" : "MEDON", "state" : "TN", "county" : "MADISON" },"38357": { "city" : "MICHIE", "state" : "TN", "county" : "MCNAIRY" },
            "38358": { "city" : "MILAN", "state" : "TN", "county" : "GIBSON" },"38359": { "city" : "MILLEDGEVILLE", "state" : "TN", "county" : "MCNAIRY" },
            "38361": { "city" : "MORRIS CHAPEL", "state" : "TN", "county" : "HARDIN" },
            "38362": { "city" : "OAKFIELD", "state" : "TN", "county" : "MADISON" },
            "38363": { "city" : "PARSONS", "state" : "TN", "county" : "DECATUR" },
            "38365": { "city" : "PICKWICK DAM", "state" : "TN", "county" : "HARDIN" },
            "38366": { "city" : "PINSON", "state" : "TN", "county" : "MADISON" },
            "38367": { "city" : "RAMER", "state" : "TN", "county" : "MCNAIRY" },"38368": { "city" : "REAGAN", "state" : "TN", "county" : "HENDERSON" },
            "38369": { "city" : "RUTHERFORD", "state" : "TN", "county" : "GIBSON" },
            "38370": { "city" : "SALTILLO", "state" : "TN", "county" : "HARDIN" },
            "38371": { "city" : "SARDIS", "state" : "TN", "county" : "HENDERSON" },
            "38372": { "city" : "SAVANNAH", "state" : "TN", "county" : "HARDIN" },
            "38374": { "city" : "SCOTTS HILL", "state" : "TN", "county" : "DECATUR" },
            "38375": { "city" : "SELMER", "state" : "TN", "county" : "MCNAIRY" },
            "38376": { "city" : "SHILOH", "state" : "TN", "county" : "HARDIN" },"38378": { "city" : "SPRING CREEK", "state" : "TN", "county" : "MADISON" },
            "38379": { "city" : "STANTONVILLE", "state" : "TN", "county" : "MCNAIRY" },
            "38380": { "city" : "SUGAR TREE", "state" : "TN", "county" : "DECATUR" },
            "38381": { "city" : "TOONE", "state" : "TN", "county" : "HARDEMAN" },
            "38382": { "city" : "TRENTON", "state" : "TN", "county" : "GIBSON" },
            "38388": { "city" : "WILDERSVILLE", "state" : "TN", "county" : "HENDERSON" },
            "38389": { "city" : "YORKVILLE", "state" : "TN", "county" : "GIBSON" },
            "38390": { "city" : "YUMA", "state" : "TN", "county" : "CARROLL" },"38391": { "city" : "DENMARK", "state" : "TN", "county" : "MADISON" },
            "38392": { "city" : "MERCER", "state" : "TN", "county" : "MADISON" },
            "38401": { "city" : "COLUMBIA", "state" : "TN", "county" : "MAURY" },
            "38402": { "city" : "COLUMBIA", "state" : "TN", "county" : "MAURY" },
            "38425": { "city" : "CLIFTON", "state" : "TN", "county" : "WAYNE" },"38449": { "city" : "ARDMORE", "state" : "TN", "county" : "GILES" },
            "38450": { "city" : "COLLINWOOD", "state" : "TN", "county" : "WAYNE" },
            "38451": { "city" : "CULLEOKA", "state" : "TN", "county" : "MAURY" },
            "38452": { "city" : "CYPRESS INN", "state" : "TN", "county" : "WAYNE" },
            "38453": { "city" : "DELLROSE", "state" : "TN", "county" : "LINCOLN" },
            "38454": { "city" : "DUCK RIVER", "state" : "TN", "county" : "HICKMAN" },
            "38455": { "city" : "ELKTON", "state" : "TN", "county" : "GILES" },"38456": { "city" : "ETHRIDGE", "state" : "TN", "county" : "LAWRENCE" },
            "38457": { "city" : "FIVE POINTS", "state" : "TN", "county" : "LAWRENCE" },
            "38459": { "city" : "FRANKEWING", "state" : "TN", "county" : "LINCOLN" },
            "38460": { "city" : "GOODSPRING", "state" : "TN", "county" : "GILES" },
            "38461": { "city" : "HAMPSHIRE", "state" : "TN", "county" : "MAURY" },
            "38462": { "city" : "HOHENWALD", "state" : "TN", "county" : "LEWIS" },
            "38463": { "city" : "IRON CITY", "state" : "TN", "county" : "LAWRENCE" },
            "38464": { "city" : "LAWRENCEBURG", "state" : "TN", "county" : "LAWRENCE" },
            "38468": { "city" : "LEOMA", "state" : "TN", "county" : "LAWRENCE" },
            "38469": { "city" : "LORETTO", "state" : "TN", "county" : "LAWRENCE" },
            "38471": { "city" : "LUTTS", "state" : "TN", "county" : "WAYNE" },"38472": { "city" : "LYNNVILLE", "state" : "TN", "county" : "GILES" },
            "38473": { "city" : "MINOR HILL", "state" : "TN", "county" : "GILES" },
            "38474": { "city" : "MOUNT PLEASANT", "state" : "TN", "county" : "MAURY" },
            "38475": { "city" : "OLIVEHILL", "state" : "TN", "county" : "HARDIN" },
            "38476": { "city" : "PRIMM SPRINGS", "state" : "TN", "county" : "WILLIAMSON" },
            "38477": { "city" : "PROSPECT", "state" : "TN", "county" : "GILES" },
            "38478": { "city" : "PULASKI", "state" : "TN", "county" : "GILES" },"38481": { "city" : "SAINT JOSEPH", "state" : "TN", "county" : "LAWRENCE" },
            "38482": { "city" : "SANTA FE", "state" : "TN", "county" : "MAURY" },
            "38483": { "city" : "SUMMERTOWN", "state" : "TN", "county" : "LAWRENCE" },
            "38485": { "city" : "WAYNESBORO", "state" : "TN", "county" : "WAYNE" },
            "38486": { "city" : "WESTPOINT", "state" : "TN", "county" : "LAWRENCE" },
            "38487": { "city" : "WILLIAMSPORT", "state" : "TN", "county" : "MAURY" },
            "38488": { "city" : "TAFT", "state" : "TN", "county" : "LINCOLN" },"38501": { "city" : "COOKEVILLE", "state" : "TN", "county" : "PUTNAM" },
            "38502": { "city" : "COOKEVILLE", "state" : "TN", "county" : "PUTNAM" },
            "38503": { "city" : "COOKEVILLE", "state" : "TN", "county" : "PUTNAM" },
            "38504": { "city" : "ALLARDT", "state" : "TN", "county" : "FENTRESS" },
            "38505": { "city" : "COOKEVILLE", "state" : "TN", "county" : "PUTNAM" },
            "38506": { "city" : "COOKEVILLE", "state" : "TN", "county" : "PUTNAM" },
            "38541": { "city" : "ALLONS", "state" : "TN", "county" : "OVERTON" },
            "38543": { "city" : "ALPINE", "state" : "TN", "county" : "OVERTON" },
            "38544": { "city" : "BAXTER", "state" : "TN", "county" : "PUTNAM" },"38545": { "city" : "BLOOMINGTON SPRINGS", "state" : "TN", "county" : "PUTNAM" },
            "38547": { "city" : "BRUSH CREEK", "state" : "TN", "county" : "SMITH" },
            "38548": { "city" : "BUFFALO VALLEY", "state" : "TN", "county" : "PUTNAM" },
            "38549": { "city" : "BYRDSTOWN", "state" : "TN", "county" : "PICKETT" },
            "38550": { "city" : "CAMPAIGN", "state" : "TN", "county" : "WARREN" },
            "38551": { "city" : "CELINA", "state" : "TN", "county" : "CLAY" },"38552": { "city" : "CHESTNUT MOUND", "state" : "TN", "county" : "SMITH" },
            "38553": { "city" : "CLARKRANGE", "state" : "TN", "county" : "FENTRESS" },
            "38554": { "city" : "CRAWFORD", "state" : "TN", "county" : "OVERTON" },
            "38555": { "city" : "CROSSVILLE", "state" : "TN", "county" : "CUMBERLAND" },
            "38556": { "city" : "JAMESTOWN", "state" : "TN", "county" : "FENTRESS" },
            "38557": { "city" : "CROSSVILLE", "state" : "TN", "county" : "CUMBERLAND" },
            "38558": { "city" : "CROSSVILLE", "state" : "TN", "county" : "CUMBERLAND" },
            "38559": { "city" : "DOYLE", "state" : "TN", "county" : "WHITE" },"38560": { "city" : "ELMWOOD", "state" : "TN", "county" : "SMITH" },
            "38562": { "city" : "GAINESBORO", "state" : "TN", "county" : "JACKSON" },
            "38563": { "city" : "GORDONSVILLE", "state" : "TN", "county" : "SMITH" },
            "38564": { "city" : "GRANVILLE", "state" : "TN", "county" : "JACKSON" },
            "38565": { "city" : "GRIMSLEY", "state" : "TN", "county" : "FENTRESS" },
            "38567": { "city" : "HICKMAN", "state" : "TN", "county" : "SMITH" },"38568": { "city" : "HILHAM", "state" : "TN", "county" : "OVERTON" },
            "38569": { "city" : "LANCASTER", "state" : "TN", "county" : "SMITH" },
            "38570": { "city" : "LIVINGSTON", "state" : "TN", "county" : "OVERTON" },
            "38571": { "city" : "CROSSVILLE", "state" : "TN", "county" : "CUMBERLAND" },
            "38572": { "city" : "CROSSVILLE", "state" : "TN", "county" : "CUMBERLAND" },
            "38573": { "city" : "MONROE", "state" : "TN", "county" : "OVERTON" },
            "38574": { "city" : "MONTEREY", "state" : "TN", "county" : "PUTNAM" },
            "38575": { "city" : "MOSS", "state" : "TN", "county" : "CLAY" },"38577": { "city" : "PALL MALL", "state" : "TN", "county" : "FENTRESS" },
            "38578": { "city" : "PLEASANT HILL", "state" : "TN", "county" : "CUMBERLAND" },
            "38579": { "city" : "QUEBECK", "state" : "TN", "county" : "WHITE" },"38580": { "city" : "RICKMAN", "state" : "TN", "county" : "OVERTON" },
            "38581": { "city" : "ROCK ISLAND", "state" : "TN", "county" : "WARREN" },
            "38582": { "city" : "SILVER POINT", "state" : "TN", "county" : "PUTNAM" },
            "38583": { "city" : "SPARTA", "state" : "TN", "county" : "WHITE" },"38585": { "city" : "SPENCER", "state" : "TN", "county" : "VAN BUREN" },
            "38587": { "city" : "WALLING", "state" : "TN", "county" : "WHITE" },"38588": { "city" : "WHITLEYVILLE", "state" : "TN", "county" : "JACKSON" },
            "38601": { "city" : "ABBEVILLE", "state" : "MS", "county" : "LAFAYETTE" },
            "38602": { "city" : "ARKABUTLA", "state" : "MS", "county" : "TATE" },
            "38603": { "city" : "ASHLAND", "state" : "MS", "county" : "BENTON" },
            "38606": { "city" : "BATESVILLE", "state" : "MS", "county" : "PANOLA" },
            "38609": { "city" : "BELEN", "state" : "MS", "county" : "QUITMAN" },"38610": { "city" : "BLUE MOUNTAIN", "state" : "MS", "county" : "TIPPAH" },
            "38611": { "city" : "BYHALIA", "state" : "MS", "county" : "MARSHALL" },
            "38614": { "city" : "CLARKSDALE", "state" : "MS", "county" : "COAHOMA" },
            "38617": { "city" : "COAHOMA", "state" : "MS", "county" : "COAHOMA" },
            "38618": { "city" : "COLDWATER", "state" : "MS", "county" : "TATE" },
            "38619": { "city" : "COMO", "state" : "MS", "county" : "PANOLA" },"38620": { "city" : "COURTLAND", "state" : "MS", "county" : "PANOLA" },
            "38621": { "city" : "CRENSHAW", "state" : "MS", "county" : "PANOLA" },
            "38622": { "city" : "CROWDER", "state" : "MS", "county" : "QUITMAN" },
            "38623": { "city" : "DARLING", "state" : "MS", "county" : "QUITMAN" },
            "38625": { "city" : "DUMAS", "state" : "MS", "county" : "TIPPAH" },"38626": { "city" : "DUNDEE", "state" : "MS", "county" : "TUNICA" },
            "38627": { "city" : "ETTA", "state" : "MS", "county" : "UNION" },"38629": { "city" : "FALKNER", "state" : "MS", "county" : "TIPPAH" },
            "38631": { "city" : "FRIARS POINT", "state" : "MS", "county" : "COAHOMA" },
            "38632": { "city" : "HERNANDO", "state" : "MS", "county" : "DESOTO" },
            "38633": { "city" : "HICKORY FLAT", "state" : "MS", "county" : "BENTON" },
            "38634": { "city" : "HOLLY SPRINGS", "state" : "MS", "county" : "MARSHALL" },
            "38635": { "city" : "HOLLY SPRINGS", "state" : "MS", "county" : "MARSHALL" },
            "38637": { "city" : "HORN LAKE", "state" : "MS", "county" : "DESOTO" },
            "38638": { "city" : "INDEPENDENCE", "state" : "MS", "county" : "TATE" },
            "38639": { "city" : "JONESTOWN", "state" : "MS", "county" : "COAHOMA" },
            "38641": { "city" : "LAKE CORMORANT", "state" : "MS", "county" : "DESOTO" },
            "38642": { "city" : "LAMAR", "state" : "MS", "county" : "MARSHALL" },
            "38643": { "city" : "LAMBERT", "state" : "MS", "county" : "QUITMAN" },
            "38644": { "city" : "LULA", "state" : "MS", "county" : "COAHOMA" },"38645": { "city" : "LYON", "state" : "MS", "county" : "COAHOMA" },
            "38646": { "city" : "MARKS", "state" : "MS", "county" : "QUITMAN" },"38647": { "city" : "MICHIGAN CITY", "state" : "MS", "county" : "BENTON" },
            "38649": { "city" : "MOUNT PLEASANT", "state" : "MS", "county" : "MARSHALL" },
            "38650": { "city" : "MYRTLE", "state" : "MS", "county" : "UNION" },"38651": { "city" : "NESBIT", "state" : "MS", "county" : "DESOTO" },
            "38652": { "city" : "NEW ALBANY", "state" : "MS", "county" : "UNION" },
            "38654": { "city" : "OLIVE BRANCH", "state" : "MS", "county" : "DESOTO" },
            "38655": { "city" : "OXFORD", "state" : "MS", "county" : "LAFAYETTE" },
            "38658": { "city" : "POPE", "state" : "MS", "county" : "PANOLA" },"38659": { "city" : "POTTS CAMP", "state" : "MS", "county" : "MARSHALL" },
            "38661": { "city" : "RED BANKS", "state" : "MS", "county" : "MARSHALL" },
            "38663": { "city" : "RIPLEY", "state" : "MS", "county" : "TIPPAH" },"38664": { "city" : "ROBINSONVILLE", "state" : "MS", "county" : "TUNICA" },
            "38665": { "city" : "SARAH", "state" : "MS", "county" : "PANOLA" },"38666": { "city" : "SARDIS", "state" : "MS", "county" : "PANOLA" },
            "38668": { "city" : "SENATOBIA", "state" : "MS", "county" : "TATE" },
            "38670": { "city" : "SLEDGE", "state" : "MS", "county" : "TUNICA" },"38671": { "city" : "SOUTHAVEN", "state" : "MS", "county" : "DESOTO" },
            "38672": { "city" : "SOUTHAVEN", "state" : "MS", "county" : "DESOTO" },
            "38673": { "city" : "TAYLOR", "state" : "MS", "county" : "LAFAYETTE" },
            "38674": { "city" : "TIPLERSVILLE", "state" : "MS", "county" : "TIPPAH" },
            "38676": { "city" : "TUNICA", "state" : "MS", "county" : "TUNICA" },"38677": { "city" : "UNIVERSITY", "state" : "MS", "county" : "LAFAYETTE" },
            "38679": { "city" : "VICTORIA", "state" : "MS", "county" : "MARSHALL" },
            "38680": { "city" : "WALLS", "state" : "MS", "county" : "DESOTO" },"38683": { "city" : "WALNUT", "state" : "MS", "county" : "TIPPAH" },
            "38685": { "city" : "WATERFORD", "state" : "MS", "county" : "MARSHALL" },
            "38701": { "city" : "GREENVILLE", "state" : "MS", "county" : "WASHINGTON" },
            "38702": { "city" : "GREENVILLE", "state" : "MS", "county" : "WASHINGTON" },
            "38703": { "city" : "GREENVILLE", "state" : "MS", "county" : "WASHINGTON" },
            "38704": { "city" : "GREENVILLE", "state" : "MS", "county" : "WASHINGTON" },
            "38720": { "city" : "ALLIGATOR", "state" : "MS", "county" : "BOLIVAR" },
            "38721": { "city" : "ANGUILLA", "state" : "MS", "county" : "SHARKEY" },
            "38722": { "city" : "ARCOLA", "state" : "MS", "county" : "WASHINGTON" },
            "38723": { "city" : "AVON", "state" : "MS", "county" : "WASHINGTON" },
            "38725": { "city" : "BENOIT", "state" : "MS", "county" : "BOLIVAR" },
            "38726": { "city" : "BEULAH", "state" : "MS", "county" : "BOLIVAR" },
            "38730": { "city" : "BOYLE", "state" : "MS", "county" : "BOLIVAR" },"38731": { "city" : "CHATHAM", "state" : "MS", "county" : "WASHINGTON" },
            "38732": { "city" : "CLEVELAND", "state" : "MS", "county" : "BOLIVAR" },
            "38733": { "city" : "CLEVELAND", "state" : "MS", "county" : "BOLIVAR" },
            "38736": { "city" : "DODDSVILLE", "state" : "MS", "county" : "SUNFLOWER" },
            "38737": { "city" : "DREW", "state" : "MS", "county" : "SUNFLOWER" },
            "38738": { "city" : "PARCHMAN", "state" : "MS", "county" : "SUNFLOWER" },
            "38739": { "city" : "DUBLIN", "state" : "MS", "county" : "COAHOMA" },
            "38740": { "city" : "DUNCAN", "state" : "MS", "county" : "BOLIVAR" },
            "38744": { "city" : "GLEN ALLAN", "state" : "MS", "county" : "WASHINGTON" },
            "38745": { "city" : "GRACE", "state" : "MS", "county" : "ISSAQUENA" },
            "38746": { "city" : "GUNNISON", "state" : "MS", "county" : "BOLIVAR" },
            "38748": { "city" : "HOLLANDALE", "state" : "MS", "county" : "WASHINGTON" },
            "38749": { "city" : "HOLLY RIDGE", "state" : "MS", "county" : "SUNFLOWER" },
            "38751": { "city" : "INDIANOLA", "state" : "MS", "county" : "SUNFLOWER" },
            "38753": { "city" : "INVERNESS", "state" : "MS", "county" : "SUNFLOWER" },
            "38754": { "city" : "ISOLA", "state" : "MS", "county" : "HUMPHREYS" },
            "38756": { "city" : "LELAND", "state" : "MS", "county" : "WASHINGTON" },
            "38759": { "city" : "MERIGOLD", "state" : "MS", "county" : "BOLIVAR" },
            "38760": { "city" : "METCALFE", "state" : "MS", "county" : "WASHINGTON" },
            "38761": { "city" : "MOORHEAD", "state" : "MS", "county" : "SUNFLOWER" },
            "38762": { "city" : "MOUND BAYOU", "state" : "MS", "county" : "BOLIVAR" },
            "38765": { "city" : "PANTHER BURN", "state" : "MS", "county" : "SHARKEY" },
            "38767": { "city" : "RENA LARA", "state" : "MS", "county" : "COAHOMA" },
            "38768": { "city" : "ROME", "state" : "MS", "county" : "SUNFLOWER" },
            "38769": { "city" : "ROSEDALE", "state" : "MS", "county" : "BOLIVAR" },
            "38771": { "city" : "RULEVILLE", "state" : "MS", "county" : "SUNFLOWER" },
            "38772": { "city" : "SCOTT", "state" : "MS", "county" : "BOLIVAR" },"38773": { "city" : "SHAW", "state" : "MS", "county" : "BOLIVAR" },
            "38774": { "city" : "SHELBY", "state" : "MS", "county" : "BOLIVAR" },
            "38776": { "city" : "STONEVILLE", "state" : "MS", "county" : "WASHINGTON" },
            "38778": { "city" : "SUNFLOWER", "state" : "MS", "county" : "SUNFLOWER" },
            "38780": { "city" : "WAYSIDE", "state" : "MS", "county" : "WASHINGTON" },
            "38782": { "city" : "WINTERVILLE", "state" : "MS", "county" : "WASHINGTON" },
            "38801": { "city" : "TUPELO", "state" : "MS", "county" : "LEE" },"38802": { "city" : "TUPELO", "state" : "MS", "county" : "LEE" },
            "38803": { "city" : "TUPELO", "state" : "MS", "county" : "LEE" },"38804": { "city" : "TUPELO", "state" : "MS", "county" : "LEE" },
            "38820": { "city" : "ALGOMA", "state" : "MS", "county" : "PONTOTOC" },
            "38821": { "city" : "AMORY", "state" : "MS", "county" : "MONROE" },"38824": { "city" : "BALDWYN", "state" : "MS", "county" : "LEE" },
            "38825": { "city" : "BECKER", "state" : "MS", "county" : "MONROE" },"38826": { "city" : "BELDEN", "state" : "MS", "county" : "LEE" },
            "38827": { "city" : "BELMONT", "state" : "MS", "county" : "TISHOMINGO" },
            "38828": { "city" : "BLUE SPRINGS", "state" : "MS", "county" : "UNION" },
            "38829": { "city" : "BOONEVILLE", "state" : "MS", "county" : "PRENTISS" },
            "38833": { "city" : "BURNSVILLE", "state" : "MS", "county" : "TISHOMINGO" },
            "38834": { "city" : "CORINTH", "state" : "MS", "county" : "ALCORN" },
            "38835": { "city" : "CORINTH", "state" : "MS", "county" : "ALCORN" },
            "38838": { "city" : "DENNIS", "state" : "MS", "county" : "TISHOMINGO" },
            "38839": { "city" : "DERMA", "state" : "MS", "county" : "CALHOUN" },"38841": { "city" : "ECRU", "state" : "MS", "county" : "PONTOTOC" },
            "38843": { "city" : "FULTON", "state" : "MS", "county" : "ITAWAMBA" },
            "38844": { "city" : "GATTMAN", "state" : "MS", "county" : "MONROE" },
            "38846": { "city" : "GLEN", "state" : "MS", "county" : "ALCORN" },"38847": { "city" : "GOLDEN", "state" : "MS", "county" : "TISHOMINGO" },
            "38848": { "city" : "GREENWOOD SPRINGS", "state" : "MS", "county" : "MONROE" },
            "38849": { "city" : "GUNTOWN", "state" : "MS", "county" : "LEE" },"38850": { "city" : "HOULKA", "state" : "MS", "county" : "CHICKASAW" },
            "38851": { "city" : "HOUSTON", "state" : "MS", "county" : "CHICKASAW" },
            "38852": { "city" : "IUKA", "state" : "MS", "county" : "TISHOMINGO" },
            "38855": { "city" : "MANTACHIE", "state" : "MS", "county" : "ITAWAMBA" },
            "38856": { "city" : "MARIETTA", "state" : "MS", "county" : "PRENTISS" },
            "38857": { "city" : "MOOREVILLE", "state" : "MS", "county" : "LEE" },
            "38858": { "city" : "NETTLETON", "state" : "MS", "county" : "ITAWAMBA" },
            "38859": { "city" : "NEW SITE", "state" : "MS", "county" : "PRENTISS" },
            "38860": { "city" : "OKOLONA", "state" : "MS", "county" : "CHICKASAW" },
            "38862": { "city" : "PLANTERSVILLE", "state" : "MS", "county" : "LEE" },
            "38863": { "city" : "PONTOTOC", "state" : "MS", "county" : "PONTOTOC" },
            "38864": { "city" : "RANDOLPH", "state" : "MS", "county" : "PONTOTOC" },
            "38865": { "city" : "RIENZI", "state" : "MS", "county" : "ALCORN" },"38866": { "city" : "SALTILLO", "state" : "MS", "county" : "LEE" },
            "38868": { "city" : "SHANNON", "state" : "MS", "county" : "LEE" },"38869": { "city" : "SHERMAN", "state" : "MS", "county" : "PONTOTOC" },
            "38870": { "city" : "SMITHVILLE", "state" : "MS", "county" : "MONROE" },
            "38871": { "city" : "THAXTON", "state" : "MS", "county" : "PONTOTOC" },
            "38873": { "city" : "TISHOMINGO", "state" : "MS", "county" : "TISHOMINGO" },
            "38874": { "city" : "TOCCOPOLA", "state" : "MS", "county" : "LAFAYETTE" },
            "38876": { "city" : "TREMONT", "state" : "MS", "county" : "ITAWAMBA" },
            "38877": { "city" : "VAN VLEET", "state" : "MS", "county" : "CHICKASAW" },
            "38878": { "city" : "VARDAMAN", "state" : "MS", "county" : "CALHOUN" },
            "38879": { "city" : "VERONA", "state" : "MS", "county" : "LEE" },"38880": { "city" : "WHEELER", "state" : "MS", "county" : "PRENTISS" },
            "38901": { "city" : "GRENADA", "state" : "MS", "county" : "GRENADA" },
            "38902": { "city" : "GRENADA", "state" : "MS", "county" : "GRENADA" },
            "38913": { "city" : "BANNER", "state" : "MS", "county" : "CALHOUN" },
            "38914": { "city" : "BIG CREEK", "state" : "MS", "county" : "CALHOUN" },
            "38915": { "city" : "BRUCE", "state" : "MS", "county" : "CALHOUN" },"38916": { "city" : "CALHOUN CITY", "state" : "MS", "county" : "CALHOUN" },
            "38917": { "city" : "CARROLLTON", "state" : "MS", "county" : "CARROLL" },
            "38920": { "city" : "CASCILLA", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38921": { "city" : "CHARLESTON", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38922": { "city" : "COFFEEVILLE", "state" : "MS", "county" : "YALOBUSHA" },
            "38923": { "city" : "COILA", "state" : "MS", "county" : "CARROLL" },"38924": { "city" : "CRUGER", "state" : "MS", "county" : "HOLMES" },
            "38925": { "city" : "DUCK HILL", "state" : "MS", "county" : "MONTGOMERY" },
            "38926": { "city" : "ELLIOTT", "state" : "MS", "county" : "GRENADA" },
            "38927": { "city" : "ENID", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38928": { "city" : "GLENDORA", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38929": { "city" : "GORE SPRINGS", "state" : "MS", "county" : "GRENADA" },
            "38930": { "city" : "GREENWOOD", "state" : "MS", "county" : "LEFLORE" },
            "38935": { "city" : "GREENWOOD", "state" : "MS", "county" : "LEFLORE" },
            "38940": { "city" : "HOLCOMB", "state" : "MS", "county" : "GRENADA" },
            "38941": { "city" : "ITTA BENA", "state" : "MS", "county" : "LEFLORE" },
            "38943": { "city" : "MC CARLEY", "state" : "MS", "county" : "CARROLL" },
            "38944": { "city" : "MINTER CITY", "state" : "MS", "county" : "LEFLORE" },
            "38946": { "city" : "MORGAN CITY", "state" : "MS", "county" : "LEFLORE" },
            "38947": { "city" : "NORTH CARROLLTON", "state" : "MS", "county" : "CARROLL" },
            "38948": { "city" : "OAKLAND", "state" : "MS", "county" : "YALOBUSHA" },
            "38949": { "city" : "PARIS", "state" : "MS", "county" : "LAFAYETTE" },
            "38950": { "city" : "PHILIPP", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38951": { "city" : "PITTSBORO", "state" : "MS", "county" : "CALHOUN" },
            "38952": { "city" : "SCHLATER", "state" : "MS", "county" : "LEFLORE" },
            "38953": { "city" : "SCOBEY", "state" : "MS", "county" : "YALOBUSHA" },
            "38954": { "city" : "SIDON", "state" : "MS", "county" : "CARROLL" },"38955": { "city" : "SLATE SPRING", "state" : "MS", "county" : "CALHOUN" },
            "38957": { "city" : "SUMNER", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38960": { "city" : "TIE PLANT", "state" : "MS", "county" : "GRENADA" },
            "38961": { "city" : "TILLATOBA", "state" : "MS", "county" : "YALOBUSHA" },
            "38963": { "city" : "TUTWILER", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38964": { "city" : "VANCE", "state" : "MS", "county" : "QUITMAN" },"38965": { "city" : "WATER VALLEY", "state" : "MS", "county" : "YALOBUSHA" },
            "38966": { "city" : "WEBB", "state" : "MS", "county" : "TALLAHATCHIE" },
            "38967": { "city" : "WINONA", "state" : "MS", "county" : "MONTGOMERY" },
            "39038": { "city" : "BELZONI", "state" : "MS", "county" : "HUMPHREYS" },
            "39039": { "city" : "BENTON", "state" : "MS", "county" : "YAZOO" },"39040": { "city" : "BENTONIA", "state" : "MS", "county" : "YAZOO" },
            "39041": { "city" : "BOLTON", "state" : "MS", "county" : "HINDS" },"39042": { "city" : "BRANDON", "state" : "MS", "county" : "RANKIN" },
            "39043": { "city" : "BRANDON", "state" : "MS", "county" : "RANKIN" },
            "39044": { "city" : "BRAXTON", "state" : "MS", "county" : "SIMPSON" },
            "39045": { "city" : "CAMDEN", "state" : "MS", "county" : "MADISON" },
            "39046": { "city" : "CANTON", "state" : "MS", "county" : "MADISON" },
            "39047": { "city" : "BRANDON", "state" : "MS", "county" : "RANKIN" },
            "39051": { "city" : "CARTHAGE", "state" : "MS", "county" : "LEAKE" },
            "39054": { "city" : "CARY", "state" : "MS", "county" : "SHARKEY" },"39056": { "city" : "CLINTON", "state" : "MS", "county" : "HINDS" },
            "39057": { "city" : "CONEHATTA", "state" : "MS", "county" : "NEWTON" },
            "39058": { "city" : "CLINTON", "state" : "MS", "county" : "HINDS" },"39059": { "city" : "CRYSTAL SPRINGS", "state" : "MS", "county" : "COPIAH" },
            "39060": { "city" : "CLINTON", "state" : "MS", "county" : "HINDS" },"39061": { "city" : "DELTA CITY", "state" : "MS", "county" : "SHARKEY" },
            "39062": { "city" : "D LO", "state" : "MS", "county" : "SIMPSON" },"39063": { "city" : "DURANT", "state" : "MS", "county" : "HOLMES" },
            "39066": { "city" : "EDWARDS", "state" : "MS", "county" : "HINDS" },"39067": { "city" : "ETHEL", "state" : "MS", "county" : "ATTALA" },
            "39069": { "city" : "FAYETTE", "state" : "MS", "county" : "JEFFERSON" },
            "39071": { "city" : "FLORA", "state" : "MS", "county" : "MADISON" },"39073": { "city" : "FLORENCE", "state" : "MS", "county" : "RANKIN" },
            "39074": { "city" : "FOREST", "state" : "MS", "county" : "SCOTT" },"39077": { "city" : "GALLMAN", "state" : "MS", "county" : "COPIAH" },
            "39078": { "city" : "GEORGETOWN", "state" : "MS", "county" : "COPIAH" },
            "39079": { "city" : "GOODMAN", "state" : "MS", "county" : "HOLMES" },
            "39080": { "city" : "HARPERVILLE", "state" : "MS", "county" : "SCOTT" },
            "39082": { "city" : "HARRISVILLE", "state" : "MS", "county" : "SIMPSON" },
            "39083": { "city" : "HAZLEHURST", "state" : "MS", "county" : "COPIAH" },
            "39086": { "city" : "HERMANVILLE", "state" : "MS", "county" : "CLAIBORNE" },
            "39087": { "city" : "HILLSBORO", "state" : "MS", "county" : "SCOTT" },
            "39088": { "city" : "HOLLY BLUFF", "state" : "MS", "county" : "YAZOO" },
            "39090": { "city" : "KOSCIUSKO", "state" : "MS", "county" : "ATTALA" },
            "39092": { "city" : "LAKE", "state" : "MS", "county" : "SCOTT" },"39094": { "city" : "LENA", "state" : "MS", "county" : "LEAKE" },
            "39095": { "city" : "LEXINGTON", "state" : "MS", "county" : "HOLMES" },
            "39096": { "city" : "LORMAN", "state" : "MS", "county" : "JEFFERSON" },
            "39097": { "city" : "LOUISE", "state" : "MS", "county" : "HUMPHREYS" },
            "39098": { "city" : "LUDLOW", "state" : "MS", "county" : "SCOTT" },"39107": { "city" : "MC ADAMS", "state" : "MS", "county" : "ATTALA" },
            "39108": { "city" : "MC COOL", "state" : "MS", "county" : "ATTALA" },
            "39109": { "city" : "MADDEN", "state" : "MS", "county" : "LEAKE" },"39110": { "city" : "MADISON", "state" : "MS", "county" : "MADISON" },
            "39111": { "city" : "MAGEE", "state" : "MS", "county" : "SIMPSON" },"39113": { "city" : "MAYERSVILLE", "state" : "MS", "county" : "ISSAQUENA" },
            "39114": { "city" : "MENDENHALL", "state" : "MS", "county" : "SIMPSON" },
            "39115": { "city" : "MIDNIGHT", "state" : "MS", "county" : "HUMPHREYS" },
            "39116": { "city" : "MIZE", "state" : "MS", "county" : "SMITH" },"39117": { "city" : "MORTON", "state" : "MS", "county" : "SCOTT" },
            "39119": { "city" : "MOUNT OLIVE", "state" : "MS", "county" : "COVINGTON" },
            "39120": { "city" : "NATCHEZ", "state" : "MS", "county" : "ADAMS" },"39121": { "city" : "NATCHEZ", "state" : "MS", "county" : "ADAMS" },
            "39122": { "city" : "NATCHEZ", "state" : "MS", "county" : "ADAMS" },"39130": { "city" : "MADISON", "state" : "MS", "county" : "MADISON" },
            "39140": { "city" : "NEWHEBRON", "state" : "MS", "county" : "LAWRENCE" },
            "39144": { "city" : "PATTISON", "state" : "MS", "county" : "CLAIBORNE" },
            "39145": { "city" : "PELAHATCHIE", "state" : "MS", "county" : "RANKIN" },
            "39146": { "city" : "PICKENS", "state" : "MS", "county" : "HOLMES" },
            "39148": { "city" : "PINEY WOODS", "state" : "MS", "county" : "RANKIN" },
            "39149": { "city" : "PINOLA", "state" : "MS", "county" : "SIMPSON" },
            "39150": { "city" : "PORT GIBSON", "state" : "MS", "county" : "CLAIBORNE" },
            "39151": { "city" : "PUCKETT", "state" : "MS", "county" : "RANKIN" },
            "39152": { "city" : "PULASKI", "state" : "MS", "county" : "SCOTT" },"39153": { "city" : "RALEIGH", "state" : "MS", "county" : "SMITH" },
            "39154": { "city" : "RAYMOND", "state" : "MS", "county" : "HINDS" },"39156": { "city" : "REDWOOD", "state" : "MS", "county" : "WARREN" },
            "39157": { "city" : "RIDGELAND", "state" : "MS", "county" : "MADISON" },
            "39158": { "city" : "RIDGELAND", "state" : "MS", "county" : "MADISON" },
            "39159": { "city" : "ROLLING FORK", "state" : "MS", "county" : "SHARKEY" },
            "39160": { "city" : "SALLIS", "state" : "MS", "county" : "ATTALA" },"39161": { "city" : "SANDHILL", "state" : "MS", "county" : "RANKIN" },
            "39162": { "city" : "SATARTIA", "state" : "MS", "county" : "YAZOO" },
            "39163": { "city" : "SHARON", "state" : "MS", "county" : "MADISON" },
            "39165": { "city" : "SIBLEY", "state" : "MS", "county" : "ADAMS" },"39166": { "city" : "SILVER CITY", "state" : "MS", "county" : "HUMPHREYS" },
            "39167": { "city" : "STAR", "state" : "MS", "county" : "RANKIN" },"39168": { "city" : "TAYLORSVILLE", "state" : "MS", "county" : "SMITH" },
            "39169": { "city" : "TCHULA", "state" : "MS", "county" : "HOLMES" },"39170": { "city" : "TERRY", "state" : "MS", "county" : "HINDS" },
            "39171": { "city" : "THOMASTOWN", "state" : "MS", "county" : "LEAKE" },
            "39173": { "city" : "TINSLEY", "state" : "MS", "county" : "YAZOO" },"39174": { "city" : "TOUGALOO", "state" : "MS", "county" : "HINDS" },
            "39175": { "city" : "UTICA", "state" : "MS", "county" : "HINDS" },"39176": { "city" : "VAIDEN", "state" : "MS", "county" : "CARROLL" },
            "39177": { "city" : "VALLEY PARK", "state" : "MS", "county" : "ISSAQUENA" },
            "39179": { "city" : "VAUGHAN", "state" : "MS", "county" : "YAZOO" },"39180": { "city" : "VICKSBURG", "state" : "MS", "county" : "WARREN" },
            "39181": { "city" : "VICKSBURG", "state" : "MS", "county" : "WARREN" },
            "39182": { "city" : "VICKSBURG", "state" : "MS", "county" : "WARREN" },
            "39183": { "city" : "VICKSBURG", "state" : "MS", "county" : "WARREN" },
            "39189": { "city" : "WALNUT GROVE", "state" : "MS", "county" : "LEAKE" },
            "39190": { "city" : "WASHINGTON", "state" : "MS", "county" : "ADAMS" },
            "39191": { "city" : "WESSON", "state" : "MS", "county" : "COPIAH" },"39192": { "city" : "WEST", "state" : "MS", "county" : "HOLMES" },
            "39193": { "city" : "WHITFIELD", "state" : "MS", "county" : "RANKIN" },
            "39194": { "city" : "YAZOO CITY", "state" : "MS", "county" : "YAZOO" },
            "39201": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39202": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39203": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39204": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39205": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39206": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39207": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39208": { "city" : "PEARL", "state" : "MS", "county" : "RANKIN" },
            "39209": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39210": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39211": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39212": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39213": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39215": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39216": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39217": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39218": { "city" : "RICHLAND", "state" : "MS", "county" : "RANKIN" },
            "39225": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39232": { "city" : "FLOWOOD", "state" : "MS", "county" : "RANKIN" },
            "39236": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39269": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39272": { "city" : "BYRAM", "state" : "MS", "county" : "HINDS" },"39282": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39283": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39284": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39286": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39288": { "city" : "PEARL", "state" : "MS", "county" : "RANKIN" },
            "39289": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },"39296": { "city" : "JACKSON", "state" : "MS", "county" : "HINDS" },
            "39298": { "city" : "JACKSON", "state" : "MS", "county" : "RANKIN" },
            "39301": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39302": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39303": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39304": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39305": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39307": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39309": { "city" : "MERIDIAN", "state" : "MS", "county" : "LAUDERDALE" },
            "39320": { "city" : "BAILEY", "state" : "MS", "county" : "LAUDERDALE" },
            "39322": { "city" : "BUCKATUNNA", "state" : "MS", "county" : "WAYNE" },
            "39323": { "city" : "CHUNKY", "state" : "MS", "county" : "NEWTON" },"39324": { "city" : "CLARA", "state" : "MS", "county" : "WAYNE" },
            "39325": { "city" : "COLLINSVILLE", "state" : "MS", "county" : "LAUDERDALE" },
            "39326": { "city" : "DALEVILLE", "state" : "MS", "county" : "LAUDERDALE" },
            "39327": { "city" : "DECATUR", "state" : "MS", "county" : "NEWTON" },
            "39328": { "city" : "DE KALB", "state" : "MS", "county" : "KEMPER" },
            "39330": { "city" : "ENTERPRISE", "state" : "MS", "county" : "CLARKE" },
            "39332": { "city" : "HICKORY", "state" : "MS", "county" : "NEWTON" },
            "39335": { "city" : "LAUDERDALE", "state" : "MS", "county" : "LAUDERDALE" },
            "39336": { "city" : "LAWRENCE", "state" : "MS", "county" : "NEWTON" },
            "39337": { "city" : "LITTLE ROCK", "state" : "MS", "county" : "NEWTON" },
            "39338": { "city" : "LOUIN", "state" : "MS", "county" : "JASPER" },"39339": { "city" : "LOUISVILLE", "state" : "MS", "county" : "WINSTON" },
            "39341": { "city" : "MACON", "state" : "MS", "county" : "NOXUBEE" },"39342": { "city" : "MARION", "state" : "MS", "county" : "LAUDERDALE" },
            "39345": { "city" : "NEWTON", "state" : "MS", "county" : "NEWTON" },"39346": { "city" : "NOXAPATER", "state" : "MS", "county" : "WINSTON" },
            "39347": { "city" : "PACHUTA", "state" : "MS", "county" : "CLARKE" },
            "39348": { "city" : "PAULDING", "state" : "MS", "county" : "JASPER" },
            "39350": { "city" : "PHILADELPHIA", "state" : "MS", "county" : "NESHOBA" },
            "39352": { "city" : "PORTERVILLE", "state" : "MS", "county" : "KEMPER" },
            "39354": { "city" : "PRESTON", "state" : "MS", "county" : "KEMPER" },
            "39355": { "city" : "QUITMAN", "state" : "MS", "county" : "CLARKE" },
            "39356": { "city" : "ROSE HILL", "state" : "MS", "county" : "JASPER" },
            "39358": { "city" : "SCOOBA", "state" : "MS", "county" : "KEMPER" },"39359": { "city" : "SEBASTOPOL", "state" : "MS", "county" : "SCOTT" },
            "39360": { "city" : "SHUBUTA", "state" : "MS", "county" : "CLARKE" },
            "39361": { "city" : "SHUQUALAK", "state" : "MS", "county" : "NOXUBEE" },
            "39362": { "city" : "STATE LINE", "state" : "MS", "county" : "GREENE" },
            "39363": { "city" : "STONEWALL", "state" : "MS", "county" : "CLARKE" },
            "39364": { "city" : "TOOMSUBA", "state" : "MS", "county" : "LAUDERDALE" },
            "39365": { "city" : "UNION", "state" : "MS", "county" : "NESHOBA" },"39366": { "city" : "VOSSBURG", "state" : "MS", "county" : "JASPER" },
            "39367": { "city" : "WAYNESBORO", "state" : "MS", "county" : "WAYNE" },
            "39401": { "city" : "HATTIESBURG", "state" : "MS", "county" : "FORREST" },
            "39402": { "city" : "HATTIESBURG", "state" : "MS", "county" : "FORREST" },
            "39403": { "city" : "HATTIESBURG", "state" : "MS", "county" : "FORREST" },
            "39404": { "city" : "HATTIESBURG", "state" : "MS", "county" : "FORREST" },
            "39406": { "city" : "HATTIESBURG", "state" : "MS", "county" : "FORREST" },
            "39407": { "city" : "HATTIESBURG", "state" : "MS", "county" : "FORREST" },
            "39421": { "city" : "BASSFIELD", "state" : "MS", "county" : "JEFFERSON DAVIS" },
            "39422": { "city" : "BAY SPRINGS", "state" : "MS", "county" : "JASPER" },
            "39423": { "city" : "BEAUMONT", "state" : "MS", "county" : "PERRY" },
            "39425": { "city" : "BROOKLYN", "state" : "MS", "county" : "FORREST" },
            "39426": { "city" : "CARRIERE", "state" : "MS", "county" : "PEARL RIVER" },
            "39427": { "city" : "CARSON", "state" : "MS", "county" : "JEFFERSON DAVIS" },
            "39428": { "city" : "COLLINS", "state" : "MS", "county" : "COVINGTON" },
            "39429": { "city" : "COLUMBIA", "state" : "MS", "county" : "MARION" },
            "39437": { "city" : "ELLISVILLE", "state" : "MS", "county" : "JONES" },
            "39439": { "city" : "HEIDELBERG", "state" : "MS", "county" : "JASPER" },
            "39440": { "city" : "LAUREL", "state" : "MS", "county" : "JONES" },"39441": { "city" : "LAUREL", "state" : "MS", "county" : "JONES" },
            "39442": { "city" : "LAUREL", "state" : "MS", "county" : "JONES" },"39443": { "city" : "LAUREL", "state" : "MS", "county" : "JONES" },
            "39451": { "city" : "LEAKESVILLE", "state" : "MS", "county" : "GREENE" },
            "39452": { "city" : "LUCEDALE", "state" : "MS", "county" : "GEORGE" },
            "39455": { "city" : "LUMBERTON", "state" : "MS", "county" : "LAMAR" },
            "39456": { "city" : "MC LAIN", "state" : "MS", "county" : "GREENE" },
            "39457": { "city" : "MC NEILL", "state" : "MS", "county" : "PEARL RIVER" },
            "39459": { "city" : "MOSELLE", "state" : "MS", "county" : "JONES" },"39461": { "city" : "NEELY", "state" : "MS", "county" : "GREENE" },
            "39462": { "city" : "NEW AUGUSTA", "state" : "MS", "county" : "PERRY" },
            "39463": { "city" : "NICHOLSON", "state" : "MS", "county" : "PEARL RIVER" },
            "39464": { "city" : "OVETT", "state" : "MS", "county" : "JONES" },"39465": { "city" : "PETAL", "state" : "MS", "county" : "FORREST" },
            "39466": { "city" : "PICAYUNE", "state" : "MS", "county" : "PEARL RIVER" },
            "39470": { "city" : "POPLARVILLE", "state" : "MS", "county" : "PEARL RIVER" },
            "39474": { "city" : "PRENTISS", "state" : "MS", "county" : "JEFFERSON DAVIS" },
            "39475": { "city" : "PURVIS", "state" : "MS", "county" : "LAMAR" },"39476": { "city" : "RICHTON", "state" : "MS", "county" : "PERRY" },
            "39477": { "city" : "SANDERSVILLE", "state" : "MS", "county" : "JONES" },
            "39478": { "city" : "SANDY HOOK", "state" : "MS", "county" : "MARION" },
            "39479": { "city" : "SEMINARY", "state" : "MS", "county" : "COVINGTON" },
            "39480": { "city" : "SOSO", "state" : "MS", "county" : "JONES" },"39481": { "city" : "STRINGER", "state" : "MS", "county" : "JASPER" },
            "39482": { "city" : "SUMRALL", "state" : "MS", "county" : "LAMAR" },"39483": { "city" : "FOXWORTH", "state" : "MS", "county" : "MARION" },
            "39501": { "city" : "GULFPORT", "state" : "MS", "county" : "HARRISON" },
            "39502": { "city" : "GULFPORT", "state" : "MS", "county" : "HARRISON" },
            "39503": { "city" : "GULFPORT", "state" : "MS", "county" : "HARRISON" },
            "39505": { "city" : "GULFPORT", "state" : "MS", "county" : "HARRISON" },
            "39506": { "city" : "GULFPORT", "state" : "MS", "county" : "HARRISON" },
            "39507": { "city" : "GULFPORT", "state" : "MS", "county" : "HARRISON" },
            "39520": { "city" : "BAY SAINT LOUIS", "state" : "MS", "county" : "HANCOCK" },
            "39521": { "city" : "BAY SAINT LOUIS", "state" : "MS", "county" : "HANCOCK" },
            "39522": { "city" : "STENNIS SPACE CENTER", "state" : "MS", "county" : "HANCOCK" },
            "39525": { "city" : "DIAMONDHEAD", "state" : "MS", "county" : "HANCOCK" },
            "39529": { "city" : "STENNIS SPACE CENTER", "state" : "MS", "county" : "HANCOCK" },
            "39530": { "city" : "BILOXI", "state" : "MS", "county" : "HARRISON" },
            "39531": { "city" : "BILOXI", "state" : "MS", "county" : "HARRISON" },
            "39532": { "city" : "BILOXI", "state" : "MS", "county" : "HARRISON" },
            "39533": { "city" : "BILOXI", "state" : "MS", "county" : "HARRISON" },
            "39534": { "city" : "BILOXI", "state" : "MS", "county" : "HARRISON" },
            "39535": { "city" : "BILOXI", "state" : "MS", "county" : "HARRISON" },
            "39540": { "city" : "DIBERVILLE", "state" : "MS", "county" : "HARRISON" },
            "39552": { "city" : "ESCATAWPA", "state" : "MS", "county" : "JACKSON" },
            "39553": { "city" : "GAUTIER", "state" : "MS", "county" : "JACKSON" },
            "39555": { "city" : "HURLEY", "state" : "MS", "county" : "JACKSON" },
            "39556": { "city" : "KILN", "state" : "MS", "county" : "HANCOCK" },"39558": { "city" : "LAKESHORE", "state" : "MS", "county" : "HANCOCK" },
            "39560": { "city" : "LONG BEACH", "state" : "MS", "county" : "HARRISON" },
            "39561": { "city" : "MC HENRY", "state" : "MS", "county" : "STONE" },
            "39562": { "city" : "MOSS POINT", "state" : "MS", "county" : "JACKSON" },
            "39563": { "city" : "MOSS POINT", "state" : "MS", "county" : "JACKSON" },
            "39564": { "city" : "OCEAN SPRINGS", "state" : "MS", "county" : "JACKSON" },
            "39565": { "city" : "VANCLEAVE", "state" : "MS", "county" : "JACKSON" },
            "39566": { "city" : "OCEAN SPRINGS", "state" : "MS", "county" : "JACKSON" },
            "39567": { "city" : "PASCAGOULA", "state" : "MS", "county" : "JACKSON" },
            "39568": { "city" : "PASCAGOULA", "state" : "MS", "county" : "JACKSON" },
            "39569": { "city" : "PASCAGOULA", "state" : "MS", "county" : "JACKSON" },
            "39571": { "city" : "PASS CHRISTIAN", "state" : "MS", "county" : "HARRISON" },
            "39572": { "city" : "PEARLINGTON", "state" : "MS", "county" : "HANCOCK" },
            "39573": { "city" : "PERKINSTON", "state" : "MS", "county" : "STONE" },
            "39574": { "city" : "SAUCIER", "state" : "MS", "county" : "HARRISON" },
            "39576": { "city" : "WAVELAND", "state" : "MS", "county" : "HANCOCK" },
            "39577": { "city" : "WIGGINS", "state" : "MS", "county" : "STONE" },"39581": { "city" : "PASCAGOULA", "state" : "MS", "county" : "JACKSON" },
            "39601": { "city" : "BROOKHAVEN", "state" : "MS", "county" : "LINCOLN" },
            "39602": { "city" : "BROOKHAVEN", "state" : "MS", "county" : "LINCOLN" },
            "39603": { "city" : "BROOKHAVEN", "state" : "MS", "county" : "LINCOLN" },
            "39629": { "city" : "BOGUE CHITTO", "state" : "MS", "county" : "LINCOLN" },
            "39630": { "city" : "BUDE", "state" : "MS", "county" : "FRANKLIN" },"39631": { "city" : "CENTREVILLE", "state" : "MS", "county" : "WILKINSON" },
            "39632": { "city" : "CHATAWA", "state" : "MS", "county" : "PIKE" },"39633": { "city" : "CROSBY", "state" : "MS", "county" : "AMITE" },
            "39635": { "city" : "FERNWOOD", "state" : "MS", "county" : "PIKE" },"39638": { "city" : "GLOSTER", "state" : "MS", "county" : "AMITE" },
            "39641": { "city" : "JAYESS", "state" : "MS", "county" : "LAWRENCE" },
            "39643": { "city" : "KOKOMO", "state" : "MS", "county" : "MARION" },"39645": { "city" : "LIBERTY", "state" : "MS", "county" : "AMITE" },
            "39647": { "city" : "MC CALL CREEK", "state" : "MS", "county" : "FRANKLIN" },
            "39648": { "city" : "MCCOMB", "state" : "MS", "county" : "PIKE" },"39649": { "city" : "MCCOMB", "state" : "MS", "county" : "PIKE" },
            "39652": { "city" : "MAGNOLIA", "state" : "MS", "county" : "PIKE" },"39653": { "city" : "MEADVILLE", "state" : "MS", "county" : "FRANKLIN" },
            "39654": { "city" : "MONTICELLO", "state" : "MS", "county" : "LAWRENCE" },
            "39656": { "city" : "OAK VALE", "state" : "MS", "county" : "LAWRENCE" },
            "39657": { "city" : "OSYKA", "state" : "MS", "county" : "PIKE" },"39661": { "city" : "ROXIE", "state" : "MS", "county" : "FRANKLIN" },
            "39662": { "city" : "RUTH", "state" : "MS", "county" : "LINCOLN" },"39663": { "city" : "SILVER CREEK", "state" : "MS", "county" : "LAWRENCE" },
            "39664": { "city" : "SMITHDALE", "state" : "MS", "county" : "AMITE" },
            "39665": { "city" : "SONTAG", "state" : "MS", "county" : "LAWRENCE" },
            "39666": { "city" : "SUMMIT", "state" : "MS", "county" : "PIKE" },"39667": { "city" : "TYLERTOWN", "state" : "MS", "county" : "WALTHALL" },
            "39668": { "city" : "UNION CHURCH", "state" : "MS", "county" : "JEFFERSON" },
            "39669": { "city" : "WOODVILLE", "state" : "MS", "county" : "WILKINSON" },
            "39701": { "city" : "COLUMBUS", "state" : "MS", "county" : "LOWNDES" },
            "39702": { "city" : "COLUMBUS", "state" : "MS", "county" : "LOWNDES" },
            "39703": { "city" : "COLUMBUS", "state" : "MS", "county" : "LOWNDES" },
            "39704": { "city" : "COLUMBUS", "state" : "MS", "county" : "LOWNDES" },
            "39705": { "city" : "COLUMBUS", "state" : "MS", "county" : "LOWNDES" },
            "39710": { "city" : "COLUMBUS", "state" : "MS", "county" : "LOWNDES" },
            "39730": { "city" : "ABERDEEN", "state" : "MS", "county" : "MONROE" },
            "39735": { "city" : "ACKERMAN", "state" : "MS", "county" : "CHOCTAW" },
            "39736": { "city" : "ARTESIA", "state" : "MS", "county" : "LOWNDES" },
            "39737": { "city" : "BELLEFONTAINE", "state" : "MS", "county" : "WEBSTER" },
            "39739": { "city" : "BROOKSVILLE", "state" : "MS", "county" : "NOXUBEE" },
            "39740": { "city" : "CALEDONIA", "state" : "MS", "county" : "MONROE" },
            "39741": { "city" : "CEDARBLUFF", "state" : "MS", "county" : "CLAY" },
            "39743": { "city" : "CRAWFORD", "state" : "MS", "county" : "LOWNDES" },
            "39744": { "city" : "EUPORA", "state" : "MS", "county" : "WEBSTER" },
            "39745": { "city" : "FRENCH CAMP", "state" : "MS", "county" : "CHOCTAW" },
            "39746": { "city" : "HAMILTON", "state" : "MS", "county" : "MONROE" },
            "39747": { "city" : "KILMICHAEL", "state" : "MS", "county" : "MONTGOMERY" },
            "39750": { "city" : "MABEN", "state" : "MS", "county" : "WEBSTER" },"39751": { "city" : "MANTEE", "state" : "MS", "county" : "WEBSTER" },
            "39752": { "city" : "MATHISTON", "state" : "MS", "county" : "WEBSTER" },
            "39753": { "city" : "MAYHEW", "state" : "MS", "county" : "LOWNDES" },
            "39754": { "city" : "MONTPELIER", "state" : "MS", "county" : "CLAY" },
            "39755": { "city" : "PHEBA", "state" : "MS", "county" : "CLAY" },"39756": { "city" : "PRAIRIE", "state" : "MS", "county" : "MONROE" },
            "39759": { "city" : "STARKVILLE", "state" : "MS", "county" : "OKTIBBEHA" },
            "39760": { "city" : "STARKVILLE", "state" : "MS", "county" : "OKTIBBEHA" },
            "39762": { "city" : "MISSISSIPPI STATE", "state" : "MS", "county" : "OKTIBBEHA" },
            "39766": { "city" : "STEENS", "state" : "MS", "county" : "LOWNDES" },
            "39767": { "city" : "STEWART", "state" : "MS", "county" : "MONTGOMERY" },
            "39769": { "city" : "STURGIS", "state" : "MS", "county" : "OKTIBBEHA" },
            "39771": { "city" : "WALTHALL", "state" : "MS", "county" : "WEBSTER" },
            "39772": { "city" : "WEIR", "state" : "MS", "county" : "CHOCTAW" },"39773": { "city" : "WEST POINT", "state" : "MS", "county" : "CLAY" },
            "39776": { "city" : "WOODLAND", "state" : "MS", "county" : "CHICKASAW" },
            "39813": { "city" : "ARLINGTON", "state" : "GA", "county" : "CALHOUN" },
            "39815": { "city" : "ATTAPULGUS", "state" : "GA", "county" : "DECATUR" },
            "39817": { "city" : "BAINBRIDGE", "state" : "GA", "county" : "DECATUR" },
            "39818": { "city" : "BAINBRIDGE", "state" : "GA", "county" : "DECATUR" },
            "39819": { "city" : "BAINBRIDGE", "state" : "GA", "county" : "DECATUR" },
            "39823": { "city" : "BLAKELY", "state" : "GA", "county" : "EARLY" },"39824": { "city" : "BLUFFTON", "state" : "GA", "county" : "CLAY" },
            "39825": { "city" : "BRINSON", "state" : "GA", "county" : "DECATUR" },
            "39826": { "city" : "BRONWOOD", "state" : "GA", "county" : "TERRELL" },
            "39827": { "city" : "CAIRO", "state" : "GA", "county" : "GRADY" },"39828": { "city" : "CAIRO", "state" : "GA", "county" : "GRADY" },
            "39829": { "city" : "CALVARY", "state" : "GA", "county" : "GRADY" },"39832": { "city" : "CEDAR SPRINGS", "state" : "GA", "county" : "EARLY" },
            "39834": { "city" : "CLIMAX", "state" : "GA", "county" : "DECATUR" },
            "39836": { "city" : "COLEMAN", "state" : "GA", "county" : "RANDOLPH" },
            "39837": { "city" : "COLQUITT", "state" : "GA", "county" : "MILLER" },
            "39840": { "city" : "CUTHBERT", "state" : "GA", "county" : "RANDOLPH" },
            "39841": { "city" : "DAMASCUS", "state" : "GA", "county" : "EARLY" },
            "39842": { "city" : "DAWSON", "state" : "GA", "county" : "TERRELL" },
            "39845": { "city" : "DONALSONVILLE", "state" : "GA", "county" : "SEMINOLE" },
            "39846": { "city" : "EDISON", "state" : "GA", "county" : "CALHOUN" },
            "39851": { "city" : "FORT GAINES", "state" : "GA", "county" : "CLAY" },
            "39854": { "city" : "GEORGETOWN", "state" : "GA", "county" : "QUITMAN" },
            "39859": { "city" : "IRON CITY", "state" : "GA", "county" : "SEMINOLE" },
            "39861": { "city" : "JAKIN", "state" : "GA", "county" : "EARLY" },"39862": { "city" : "LEARY", "state" : "GA", "county" : "CALHOUN" },
            "39866": { "city" : "MORGAN", "state" : "GA", "county" : "CALHOUN" },
            "39867": { "city" : "MORRIS", "state" : "GA", "county" : "QUITMAN" },
            "39870": { "city" : "NEWTON", "state" : "GA", "county" : "BAKER" },"39877": { "city" : "PARROTT", "state" : "GA", "county" : "TERRELL" },
            "39885": { "city" : "SASSER", "state" : "GA", "county" : "TERRELL" },
            "39886": { "city" : "SHELLMAN", "state" : "GA", "county" : "RANDOLPH" },
            "39897": { "city" : "WHIGHAM", "state" : "GA", "county" : "GRADY" },"40003": { "city" : "BAGDAD", "state" : "KY", "county" : "SHELBY" },
            "40004": { "city" : "BARDSTOWN", "state" : "KY", "county" : "NELSON" },
            "40006": { "city" : "BEDFORD", "state" : "KY", "county" : "TRIMBLE" },
            "40007": { "city" : "BETHLEHEM", "state" : "KY", "county" : "HENRY" },
            "40008": { "city" : "BLOOMFIELD", "state" : "KY", "county" : "NELSON" },
            "40009": { "city" : "BRADFORDSVILLE", "state" : "KY", "county" : "MARION" },
            "40010": { "city" : "BUCKNER", "state" : "KY", "county" : "OLDHAM" },
            "40011": { "city" : "CAMPBELLSBURG", "state" : "KY", "county" : "HENRY" },
            "40012": { "city" : "CHAPLIN", "state" : "KY", "county" : "NELSON" },
            "40013": { "city" : "COXS CREEK", "state" : "KY", "county" : "NELSON" },
            "40014": { "city" : "CRESTWOOD", "state" : "KY", "county" : "OLDHAM" },
            "40018": { "city" : "EASTWOOD", "state" : "KY", "county" : "JEFFERSON" },
            "40019": { "city" : "EMINENCE", "state" : "KY", "county" : "HENRY" },
            "40020": { "city" : "FAIRFIELD", "state" : "KY", "county" : "NELSON" },
            "40022": { "city" : "FINCHVILLE", "state" : "KY", "county" : "SHELBY" },
            "40023": { "city" : "FISHERVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40025": { "city" : "GLENVIEW", "state" : "KY", "county" : "JEFFERSON" },
            "40026": { "city" : "GOSHEN", "state" : "KY", "county" : "OLDHAM" },"40027": { "city" : "HARRODS CREEK", "state" : "KY", "county" : "JEFFERSON" },
            "40031": { "city" : "LA GRANGE", "state" : "KY", "county" : "OLDHAM" },
            "40032": { "city" : "LA GRANGE", "state" : "KY", "county" : "OLDHAM" },
            "40033": { "city" : "LEBANON", "state" : "KY", "county" : "MARION" },
            "40036": { "city" : "LOCKPORT", "state" : "KY", "county" : "HENRY" },
            "40037": { "city" : "LORETTO", "state" : "KY", "county" : "MARION" },
            "40040": { "city" : "MACKVILLE", "state" : "KY", "county" : "WASHINGTON" },
            "40041": { "city" : "MASONIC HOME", "state" : "KY", "county" : "JEFFERSON" },
            "40045": { "city" : "MILTON", "state" : "KY", "county" : "TRIMBLE" },
            "40046": { "city" : "MOUNT EDEN", "state" : "KY", "county" : "SPENCER" },
            "40047": { "city" : "MOUNT WASHINGTON", "state" : "KY", "county" : "BULLITT" },
            "40048": { "city" : "NAZARETH", "state" : "KY", "county" : "NELSON" },
            "40049": { "city" : "NERINX", "state" : "KY", "county" : "MARION" },"40050": { "city" : "NEW CASTLE", "state" : "KY", "county" : "HENRY" },
            "40051": { "city" : "NEW HAVEN", "state" : "KY", "county" : "NELSON" },
            "40052": { "city" : "NEW HOPE", "state" : "KY", "county" : "NELSON" },
            "40055": { "city" : "PENDLETON", "state" : "KY", "county" : "HENRY" },
            "40056": { "city" : "PEWEE VALLEY", "state" : "KY", "county" : "OLDHAM" },
            "40057": { "city" : "PLEASUREVILLE", "state" : "KY", "county" : "HENRY" },
            "40058": { "city" : "PORT ROYAL", "state" : "KY", "county" : "HENRY" },
            "40059": { "city" : "PROSPECT", "state" : "KY", "county" : "JEFFERSON" },
            "40060": { "city" : "RAYWICK", "state" : "KY", "county" : "MARION" },
            "40061": { "city" : "SAINT CATHARINE", "state" : "KY", "county" : "WASHINGTON" },
            "40062": { "city" : "SAINT FRANCIS", "state" : "KY", "county" : "MARION" },
            "40063": { "city" : "SAINT MARY", "state" : "KY", "county" : "MARION" },
            "40065": { "city" : "SHELBYVILLE", "state" : "KY", "county" : "SHELBY" },
            "40066": { "city" : "SHELBYVILLE", "state" : "KY", "county" : "SHELBY" },
            "40067": { "city" : "SIMPSONVILLE", "state" : "KY", "county" : "SHELBY" },
            "40068": { "city" : "SMITHFIELD", "state" : "KY", "county" : "HENRY" },
            "40069": { "city" : "SPRINGFIELD", "state" : "KY", "county" : "WASHINGTON" },
            "40070": { "city" : "SULPHUR", "state" : "KY", "county" : "HENRY" },"40071": { "city" : "TAYLORSVILLE", "state" : "KY", "county" : "SPENCER" },
            "40075": { "city" : "TURNERS STATION", "state" : "KY", "county" : "HENRY" },
            "40076": { "city" : "WADDY", "state" : "KY", "county" : "SHELBY" },"40077": { "city" : "WESTPORT", "state" : "KY", "county" : "OLDHAM" },
            "40078": { "city" : "WILLISBURG", "state" : "KY", "county" : "WASHINGTON" },
            "40104": { "city" : "BATTLETOWN", "state" : "KY", "county" : "MEADE" },
            "40107": { "city" : "BOSTON", "state" : "KY", "county" : "NELSON" },"40108": { "city" : "BRANDENBURG", "state" : "KY", "county" : "MEADE" },
            "40109": { "city" : "BROOKS", "state" : "KY", "county" : "BULLITT" },
            "40110": { "city" : "CLERMONT", "state" : "KY", "county" : "BULLITT" },
            "40111": { "city" : "CLOVERPORT", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40115": { "city" : "CUSTER", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40117": { "city" : "EKRON", "state" : "KY", "county" : "MEADE" },"40118": { "city" : "FAIRDALE", "state" : "KY", "county" : "JEFFERSON" },
            "40119": { "city" : "FALLS OF ROUGH", "state" : "KY", "county" : "GRAYSON" },
            "40121": { "city" : "FORT KNOX", "state" : "KY", "county" : "HARDIN" },
            "40122": { "city" : "FORT KNOX", "state" : "KY", "county" : "HARDIN" },
            "40129": { "city" : "HILLVIEW", "state" : "KY", "county" : "BULLITT" },
            "40140": { "city" : "GARFIELD", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40142": { "city" : "GUSTON", "state" : "KY", "county" : "MEADE" },"40143": { "city" : "HARDINSBURG", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40144": { "city" : "HARNED", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40145": { "city" : "HUDSON", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40146": { "city" : "IRVINGTON", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40150": { "city" : "LEBANON JUNCTION", "state" : "KY", "county" : "BULLITT" },
            "40152": { "city" : "MC DANIELS", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40153": { "city" : "MC QUADY", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40155": { "city" : "MULDRAUGH", "state" : "KY", "county" : "MEADE" },
            "40157": { "city" : "PAYNEVILLE", "state" : "KY", "county" : "MEADE" },
            "40159": { "city" : "RADCLIFF", "state" : "KY", "county" : "HARDIN" },
            "40160": { "city" : "RADCLIFF", "state" : "KY", "county" : "HARDIN" },
            "40161": { "city" : "RHODELIA", "state" : "KY", "county" : "MEADE" },
            "40162": { "city" : "RINEYVILLE", "state" : "KY", "county" : "HARDIN" },
            "40165": { "city" : "SHEPHERDSVILLE", "state" : "KY", "county" : "BULLITT" },
            "40170": { "city" : "STEPHENSPORT", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40171": { "city" : "UNION STAR", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40175": { "city" : "VINE GROVE", "state" : "KY", "county" : "HARDIN" },
            "40176": { "city" : "WEBSTER", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40177": { "city" : "WEST POINT", "state" : "KY", "county" : "HARDIN" },
            "40178": { "city" : "WESTVIEW", "state" : "KY", "county" : "BRECKINRIDGE" },
            "40201": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40202": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40203": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40204": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40205": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40206": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40207": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40208": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40209": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40210": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40211": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40212": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40213": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40214": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40215": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40216": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40217": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40218": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40219": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40220": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40221": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40222": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40223": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40224": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40225": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40228": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40229": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40231": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40232": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40233": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40241": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40242": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40243": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40245": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40250": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40251": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40252": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40253": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40255": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40256": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40257": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40258": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40259": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40261": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40266": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40268": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40269": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40270": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40272": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40280": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40282": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40289": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40291": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40292": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40294": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40295": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40297": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40298": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40299": { "city" : "LOUISVILLE", "state" : "KY", "county" : "JEFFERSON" },
            "40310": { "city" : "BURGIN", "state" : "KY", "county" : "MERCER" },"40311": { "city" : "CARLISLE", "state" : "KY", "county" : "NICHOLAS" },
            "40312": { "city" : "CLAY CITY", "state" : "KY", "county" : "POWELL" },
            "40313": { "city" : "CLEARFIELD", "state" : "KY", "county" : "ROWAN" },
            "40317": { "city" : "ELLIOTTVILLE", "state" : "KY", "county" : "ROWAN" },
            "40319": { "city" : "FARMERS", "state" : "KY", "county" : "ROWAN" },"40322": { "city" : "FRENCHBURG", "state" : "KY", "county" : "MENIFEE" },
            "40324": { "city" : "GEORGETOWN", "state" : "KY", "county" : "SCOTT" },
            "40328": { "city" : "GRAVEL SWITCH", "state" : "KY", "county" : "MARION" },
            "40330": { "city" : "HARRODSBURG", "state" : "KY", "county" : "MERCER" },
            "40334": { "city" : "HOPE", "state" : "KY", "county" : "BATH" },"40336": { "city" : "IRVINE", "state" : "KY", "county" : "ESTILL" },
            "40337": { "city" : "JEFFERSONVILLE", "state" : "KY", "county" : "MONTGOMERY" },
            "40339": { "city" : "KEENE", "state" : "KY", "county" : "JESSAMINE" },
            "40340": { "city" : "NICHOLASVILLE", "state" : "KY", "county" : "JESSAMINE" },
            "40342": { "city" : "LAWRENCEBURG", "state" : "KY", "county" : "ANDERSON" },
            "40346": { "city" : "MEANS", "state" : "KY", "county" : "MENIFEE" },"40347": { "city" : "MIDWAY", "state" : "KY", "county" : "WOODFORD" },
            "40348": { "city" : "MILLERSBURG", "state" : "KY", "county" : "BOURBON" },
            "40350": { "city" : "MOOREFIELD", "state" : "KY", "county" : "NICHOLAS" },
            "40351": { "city" : "MOREHEAD", "state" : "KY", "county" : "ROWAN" },
            "40353": { "city" : "MOUNT STERLING", "state" : "KY", "county" : "MONTGOMERY" },
            "40355": { "city" : "NEW LIBERTY", "state" : "KY", "county" : "OWEN" },
            "40356": { "city" : "NICHOLASVILLE", "state" : "KY", "county" : "JESSAMINE" },
            "40357": { "city" : "NORTH MIDDLETOWN", "state" : "KY", "county" : "BOURBON" },
            "40358": { "city" : "OLYMPIA", "state" : "KY", "county" : "BATH" },"40359": { "city" : "OWENTON", "state" : "KY", "county" : "OWEN" },
            "40360": { "city" : "OWINGSVILLE", "state" : "KY", "county" : "BATH" },
            "40361": { "city" : "PARIS", "state" : "KY", "county" : "BOURBON" },"40362": { "city" : "PARIS", "state" : "KY", "county" : "BOURBON" },
            "40363": { "city" : "PERRY PARK", "state" : "KY", "county" : "OWEN" },
            "40366": { "city" : "PRESTON", "state" : "KY", "county" : "BATH" },"40370": { "city" : "SADIEVILLE", "state" : "KY", "county" : "SCOTT" },
            "40371": { "city" : "SALT LICK", "state" : "KY", "county" : "BATH" },
            "40372": { "city" : "SALVISA", "state" : "KY", "county" : "MERCER" },
            "40374": { "city" : "SHARPSBURG", "state" : "KY", "county" : "BATH" },
            "40376": { "city" : "SLADE", "state" : "KY", "county" : "POWELL" },"40379": { "city" : "STAMPING GROUND", "state" : "KY", "county" : "SCOTT" },
            "40380": { "city" : "STANTON", "state" : "KY", "county" : "POWELL" },
            "40383": { "city" : "VERSAILLES", "state" : "KY", "county" : "WOODFORD" },
            "40384": { "city" : "VERSAILLES", "state" : "KY", "county" : "WOODFORD" },
            "40385": { "city" : "WACO", "state" : "KY", "county" : "MADISON" },"40387": { "city" : "WELLINGTON", "state" : "KY", "county" : "MENIFEE" },
            "40390": { "city" : "WILMORE", "state" : "KY", "county" : "JESSAMINE" },
            "40391": { "city" : "WINCHESTER", "state" : "KY", "county" : "CLARK" },
            "40392": { "city" : "WINCHESTER", "state" : "KY", "county" : "CLARK" },
            "40402": { "city" : "ANNVILLE", "state" : "KY", "county" : "JACKSON" },
            "40403": { "city" : "BEREA", "state" : "KY", "county" : "MADISON" },"40404": { "city" : "BEREA", "state" : "KY", "county" : "MADISON" },
            "40405": { "city" : "BIGHILL", "state" : "KY", "county" : "MADISON" },
            "40409": { "city" : "BRODHEAD", "state" : "KY", "county" : "ROCKCASTLE" },
            "40410": { "city" : "BRYANTSVILLE", "state" : "KY", "county" : "GARRARD" },
            "40419": { "city" : "CRAB ORCHARD", "state" : "KY", "county" : "LINCOLN" },
            "40422": { "city" : "DANVILLE", "state" : "KY", "county" : "BOYLE" },
            "40423": { "city" : "DANVILLE", "state" : "KY", "county" : "BOYLE" },
            "40434": { "city" : "GRAY HAWK", "state" : "KY", "county" : "JACKSON" },
            "40437": { "city" : "HUSTONVILLE", "state" : "KY", "county" : "LINCOLN" },
            "40440": { "city" : "JUNCTION CITY", "state" : "KY", "county" : "BOYLE" },
            "40442": { "city" : "KINGS MOUNTAIN", "state" : "KY", "county" : "LINCOLN" },
            "40444": { "city" : "LANCASTER", "state" : "KY", "county" : "GARRARD" },
            "40445": { "city" : "LIVINGSTON", "state" : "KY", "county" : "ROCKCASTLE" },
            "40446": { "city" : "LANCASTER", "state" : "KY", "county" : "GARRARD" },
            "40447": { "city" : "MC KEE", "state" : "KY", "county" : "JACKSON" },
            "40448": { "city" : "MC KINNEY", "state" : "KY", "county" : "LINCOLN" },
            "40456": { "city" : "MOUNT VERNON", "state" : "KY", "county" : "ROCKCASTLE" },
            "40460": { "city" : "ORLANDO", "state" : "KY", "county" : "ROCKCASTLE" },
            "40461": { "city" : "PAINT LICK", "state" : "KY", "county" : "GARRARD" },
            "40464": { "city" : "PARKSVILLE", "state" : "KY", "county" : "BOYLE" },
            "40468": { "city" : "PERRYVILLE", "state" : "KY", "county" : "BOYLE" },
            "40472": { "city" : "RAVENNA", "state" : "KY", "county" : "ESTILL" },
            "40473": { "city" : "RENFRO VALLEY", "state" : "KY", "county" : "ROCKCASTLE" },
            "40475": { "city" : "RICHMOND", "state" : "KY", "county" : "MADISON" },
            "40476": { "city" : "RICHMOND", "state" : "KY", "county" : "MADISON" },
            "40481": { "city" : "SANDGAP", "state" : "KY", "county" : "JACKSON" },
            "40484": { "city" : "STANFORD", "state" : "KY", "county" : "LINCOLN" },
            "40486": { "city" : "TYNER", "state" : "KY", "county" : "JACKSON" },"40489": { "city" : "WAYNESBURG", "state" : "KY", "county" : "LINCOLN" },
            "40492": { "city" : "WILDIE", "state" : "KY", "county" : "ROCKCASTLE" },
            "40495": { "city" : "WINSTON", "state" : "KY", "county" : "ESTILL" },
            "40502": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40503": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40504": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40505": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40506": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40507": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40508": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40509": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40510": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40511": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40512": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40513": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40514": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40515": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40516": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40517": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40522": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40523": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40524": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40533": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40536": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40544": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40546": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40550": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40555": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40574": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40575": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40576": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40578": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40579": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40580": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40581": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40582": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40583": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40588": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40591": { "city" : "LEXINGTON", "state" : "KY", "county" : "FAYETTE" },
            "40601": { "city" : "FRANKFORT", "state" : "KY", "county" : "FRANKLIN" },
            "40602": { "city" : "FRANKFORT", "state" : "KY", "county" : "FRANKLIN" },
            "40603": { "city" : "FRANKFORT", "state" : "KY", "county" : "FRANKLIN" },
            "40604": { "city" : "FRANKFORT", "state" : "KY", "county" : "FRANKLIN" },
            "40621": { "city" : "FRANKFORT", "state" : "KY", "county" : "FRANKLIN" },
            "40701": { "city" : "CORBIN", "state" : "KY", "county" : "WHITLEY" },
            "40702": { "city" : "CORBIN", "state" : "KY", "county" : "WHITLEY" },
            "40729": { "city" : "EAST BERNSTADT", "state" : "KY", "county" : "LAUREL" },
            "40730": { "city" : "EMLYN", "state" : "KY", "county" : "WHITLEY" },"40734": { "city" : "GRAY", "state" : "KY", "county" : "KNOX" },
            "40737": { "city" : "KEAVY", "state" : "KY", "county" : "LAUREL" },"40740": { "city" : "LILY", "state" : "KY", "county" : "LAUREL" },
            "40741": { "city" : "LONDON", "state" : "KY", "county" : "LAUREL" },"40742": { "city" : "LONDON", "state" : "KY", "county" : "LAUREL" },
            "40743": { "city" : "LONDON", "state" : "KY", "county" : "LAUREL" },"40744": { "city" : "LONDON", "state" : "KY", "county" : "LAUREL" },
            "40755": { "city" : "PITTSBURG", "state" : "KY", "county" : "LAUREL" },
            "40759": { "city" : "ROCKHOLDS", "state" : "KY", "county" : "WHITLEY" },
            "40763": { "city" : "SILER", "state" : "KY", "county" : "WHITLEY" },"40769": { "city" : "WILLIAMSBURG", "state" : "KY", "county" : "WHITLEY" },
            "40771": { "city" : "WOODBINE", "state" : "KY", "county" : "KNOX" },"40801": { "city" : "AGES BROOKSIDE", "state" : "KY", "county" : "HARLAN" },
            "40803": { "city" : "ASHER", "state" : "KY", "county" : "LESLIE" },"40806": { "city" : "BAXTER", "state" : "KY", "county" : "HARLAN" },
            "40807": { "city" : "BENHAM", "state" : "KY", "county" : "HARLAN" },"40808": { "city" : "BIG LAUREL", "state" : "KY", "county" : "HARLAN" },
            "40810": { "city" : "BLEDSOE", "state" : "KY", "county" : "HARLAN" },
            "40813": { "city" : "CALVIN", "state" : "KY", "county" : "BELL" },"40815": { "city" : "CAWOOD", "state" : "KY", "county" : "HARLAN" },
            "40818": { "city" : "COALGOOD", "state" : "KY", "county" : "HARLAN" },
            "40819": { "city" : "COLDIRON", "state" : "KY", "county" : "HARLAN" },
            "40820": { "city" : "CRANKS", "state" : "KY", "county" : "HARLAN" },"40823": { "city" : "CUMBERLAND", "state" : "KY", "county" : "HARLAN" },
            "40824": { "city" : "DAYHOIT", "state" : "KY", "county" : "HARLAN" },
            "40826": { "city" : "EOLIA", "state" : "KY", "county" : "LETCHER" },"40827": { "city" : "ESSIE", "state" : "KY", "county" : "LESLIE" },
            "40828": { "city" : "EVARTS", "state" : "KY", "county" : "HARLAN" },"40829": { "city" : "GRAYS KNOB", "state" : "KY", "county" : "HARLAN" },
            "40831": { "city" : "HARLAN", "state" : "KY", "county" : "HARLAN" },"40843": { "city" : "HOLMES MILL", "state" : "KY", "county" : "HARLAN" },
            "40844": { "city" : "HOSKINSTON", "state" : "KY", "county" : "LESLIE" },
            "40845": { "city" : "HULEN", "state" : "KY", "county" : "BELL" },"40847": { "city" : "KENVIR", "state" : "KY", "county" : "HARLAN" },
            "40849": { "city" : "LEJUNIOR", "state" : "KY", "county" : "HARLAN" },
            "40854": { "city" : "LOYALL", "state" : "KY", "county" : "HARLAN" },"40855": { "city" : "LYNCH", "state" : "KY", "county" : "HARLAN" },
            "40856": { "city" : "MIRACLE", "state" : "KY", "county" : "BELL" },"40862": { "city" : "PARTRIDGE", "state" : "KY", "county" : "LETCHER" },
            "40863": { "city" : "PATHFORK", "state" : "KY", "county" : "HARLAN" },
            "40865": { "city" : "PUTNEY", "state" : "KY", "county" : "HARLAN" },"40868": { "city" : "STINNETT", "state" : "KY", "county" : "LESLIE" },
            "40870": { "city" : "TOTZ", "state" : "KY", "county" : "HARLAN" },"40873": { "city" : "WALLINS CREEK", "state" : "KY", "county" : "HARLAN" },
            "40874": { "city" : "WARBRANCH", "state" : "KY", "county" : "LESLIE" },
            "40902": { "city" : "ARJAY", "state" : "KY", "county" : "BELL" },"40903": { "city" : "ARTEMUS", "state" : "KY", "county" : "KNOX" },
            "40906": { "city" : "BARBOURVILLE", "state" : "KY", "county" : "KNOX" },
            "40913": { "city" : "BEVERLY", "state" : "KY", "county" : "BELL" },"40914": { "city" : "BIG CREEK", "state" : "KY", "county" : "CLAY" },
            "40915": { "city" : "BIMBLE", "state" : "KY", "county" : "KNOX" },"40921": { "city" : "BRYANTS STORE", "state" : "KY", "county" : "KNOX" },
            "40923": { "city" : "CANNON", "state" : "KY", "county" : "KNOX" },"40927": { "city" : "CLOSPLINT", "state" : "KY", "county" : "HARLAN" },
            "40930": { "city" : "DEWITT", "state" : "KY", "county" : "KNOX" },"40932": { "city" : "FALL ROCK", "state" : "KY", "county" : "CLAY" },
            "40935": { "city" : "FLAT LICK", "state" : "KY", "county" : "KNOX" },
            "40939": { "city" : "FOURMILE", "state" : "KY", "county" : "BELL" },"40940": { "city" : "FRAKES", "state" : "KY", "county" : "BELL" },
            "40941": { "city" : "GARRARD", "state" : "KY", "county" : "CLAY" },"40943": { "city" : "GIRDLER", "state" : "KY", "county" : "KNOX" },
            "40946": { "city" : "GREEN ROAD", "state" : "KY", "county" : "KNOX" },
            "40949": { "city" : "HEIDRICK", "state" : "KY", "county" : "KNOX" },"40951": { "city" : "HIMA", "state" : "KY", "county" : "CLAY" },
            "40953": { "city" : "HINKLE", "state" : "KY", "county" : "KNOX" },"40955": { "city" : "INGRAM", "state" : "KY", "county" : "BELL" },
            "40958": { "city" : "KETTLE ISLAND", "state" : "KY", "county" : "BELL" },
            "40962": { "city" : "MANCHESTER", "state" : "KY", "county" : "CLAY" },
            "40964": { "city" : "MARY ALICE", "state" : "KY", "county" : "HARLAN" },
            "40965": { "city" : "MIDDLESBORO", "state" : "KY", "county" : "BELL" },
            "40972": { "city" : "ONEIDA", "state" : "KY", "county" : "CLAY" },"40977": { "city" : "PINEVILLE", "state" : "KY", "county" : "BELL" },
            "40979": { "city" : "ROARK", "state" : "KY", "county" : "LESLIE" },"40983": { "city" : "SEXTONS CREEK", "state" : "KY", "county" : "CLAY" },
            "40988": { "city" : "STONEY FORK", "state" : "KY", "county" : "BELL" },
            "40997": { "city" : "WALKER", "state" : "KY", "county" : "KNOX" },"41001": { "city" : "ALEXANDRIA", "state" : "KY", "county" : "CAMPBELL" },
            "41002": { "city" : "AUGUSTA", "state" : "KY", "county" : "BRACKEN" },
            "41003": { "city" : "BERRY", "state" : "KY", "county" : "HARRISON" },
            "41004": { "city" : "BROOKSVILLE", "state" : "KY", "county" : "BRACKEN" },
            "41005": { "city" : "BURLINGTON", "state" : "KY", "county" : "BOONE" },
            "41006": { "city" : "BUTLER", "state" : "KY", "county" : "PENDLETON" },
            "41007": { "city" : "CALIFORNIA", "state" : "KY", "county" : "CAMPBELL" },
            "41008": { "city" : "CARROLLTON", "state" : "KY", "county" : "CARROLL" },
            "41010": { "city" : "CORINTH", "state" : "KY", "county" : "GRANT" },"41011": { "city" : "COVINGTON", "state" : "KY", "county" : "KENTON" },
            "41012": { "city" : "COVINGTON", "state" : "KY", "county" : "KENTON" },
            "41014": { "city" : "COVINGTON", "state" : "KY", "county" : "KENTON" },
            "41015": { "city" : "LATONIA", "state" : "KY", "county" : "KENTON" },
            "41016": { "city" : "COVINGTON", "state" : "KY", "county" : "KENTON" },
            "41017": { "city" : "FT MITCHELL", "state" : "KY", "county" : "KENTON" },
            "41018": { "city" : "ERLANGER", "state" : "KY", "county" : "KENTON" },
            "41019": { "city" : "COVINGTON", "state" : "KY", "county" : "KENTON" },
            "41022": { "city" : "FLORENCE", "state" : "KY", "county" : "BOONE" },
            "41030": { "city" : "CRITTENDEN", "state" : "KY", "county" : "GRANT" },
            "41031": { "city" : "CYNTHIANA", "state" : "KY", "county" : "HARRISON" },
            "41033": { "city" : "DE MOSSVILLE", "state" : "KY", "county" : "PENDLETON" },
            "41034": { "city" : "DOVER", "state" : "KY", "county" : "MASON" },"41035": { "city" : "DRY RIDGE", "state" : "KY", "county" : "GRANT" },
            "41037": { "city" : "ELIZAVILLE", "state" : "KY", "county" : "FLEMING" },
            "41039": { "city" : "EWING", "state" : "KY", "county" : "FLEMING" },"41040": { "city" : "FALMOUTH", "state" : "KY", "county" : "PENDLETON" },
            "41041": { "city" : "FLEMINGSBURG", "state" : "KY", "county" : "FLEMING" },
            "41042": { "city" : "FLORENCE", "state" : "KY", "county" : "BOONE" },
            "41043": { "city" : "FOSTER", "state" : "KY", "county" : "BRACKEN" },
            "41044": { "city" : "GERMANTOWN", "state" : "KY", "county" : "BRACKEN" },
            "41045": { "city" : "GHENT", "state" : "KY", "county" : "CARROLL" },"41046": { "city" : "GLENCOE", "state" : "KY", "county" : "GALLATIN" },
            "41048": { "city" : "HEBRON", "state" : "KY", "county" : "BOONE" },"41049": { "city" : "HILLSBORO", "state" : "KY", "county" : "FLEMING" },
            "41051": { "city" : "INDEPENDENCE", "state" : "KY", "county" : "KENTON" },
            "41052": { "city" : "JONESVILLE", "state" : "KY", "county" : "GRANT" },
            "41053": { "city" : "KENTON", "state" : "KY", "county" : "KENTON" },"41054": { "city" : "MASON", "state" : "KY", "county" : "GRANT" },
            "41055": { "city" : "MAYSLICK", "state" : "KY", "county" : "MASON" },
            "41056": { "city" : "MAYSVILLE", "state" : "KY", "county" : "MASON" },
            "41059": { "city" : "MELBOURNE", "state" : "KY", "county" : "CAMPBELL" },
            "41061": { "city" : "MILFORD", "state" : "KY", "county" : "BRACKEN" },
            "41063": { "city" : "MORNING VIEW", "state" : "KY", "county" : "KENTON" },
            "41064": { "city" : "MOUNT OLIVET", "state" : "KY", "county" : "ROBERTSON" },
            "41071": { "city" : "NEWPORT", "state" : "KY", "county" : "CAMPBELL" },
            "41072": { "city" : "NEWPORT", "state" : "KY", "county" : "CAMPBELL" },
            "41073": { "city" : "BELLEVUE", "state" : "KY", "county" : "CAMPBELL" },
            "41074": { "city" : "DAYTON", "state" : "KY", "county" : "CAMPBELL" },
            "41075": { "city" : "FORT THOMAS", "state" : "KY", "county" : "CAMPBELL" },
            "41076": { "city" : "NEWPORT", "state" : "KY", "county" : "CAMPBELL" },
            "41080": { "city" : "PETERSBURG", "state" : "KY", "county" : "BOONE" },
            "41081": { "city" : "PLUMMERS LANDING", "state" : "KY", "county" : "FLEMING" },
            "41083": { "city" : "SANDERS", "state" : "KY", "county" : "CARROLL" },
            "41085": { "city" : "SILVER GROVE", "state" : "KY", "county" : "CAMPBELL" },
            "41086": { "city" : "SPARTA", "state" : "KY", "county" : "GALLATIN" },
            "41091": { "city" : "UNION", "state" : "KY", "county" : "BOONE" },"41092": { "city" : "VERONA", "state" : "KY", "county" : "BOONE" },
            "41093": { "city" : "WALLINGFORD", "state" : "KY", "county" : "FLEMING" },
            "41094": { "city" : "WALTON", "state" : "KY", "county" : "BOONE" },"41095": { "city" : "WARSAW", "state" : "KY", "county" : "GALLATIN" },
            "41096": { "city" : "WASHINGTON", "state" : "KY", "county" : "MASON" },
            "41097": { "city" : "WILLIAMSTOWN", "state" : "KY", "county" : "GRANT" },
            "41098": { "city" : "WORTHVILLE", "state" : "KY", "county" : "CARROLL" },
            "41099": { "city" : "NEWPORT", "state" : "KY", "county" : "CAMPBELL" },
            "41101": { "city" : "ASHLAND", "state" : "KY", "county" : "BOYD" },"41102": { "city" : "ASHLAND", "state" : "KY", "county" : "BOYD" },
            "41105": { "city" : "ASHLAND", "state" : "KY", "county" : "BOYD" },"41121": { "city" : "ARGILLITE", "state" : "KY", "county" : "GREENUP" },
            "41124": { "city" : "BLAINE", "state" : "KY", "county" : "LAWRENCE" },
            "41128": { "city" : "CARTER", "state" : "KY", "county" : "CARTER" },"41129": { "city" : "CATLETTSBURG", "state" : "KY", "county" : "BOYD" },
            "41132": { "city" : "DENTON", "state" : "KY", "county" : "CARTER" },"41135": { "city" : "EMERSON", "state" : "KY", "county" : "LEWIS" },
            "41139": { "city" : "FLATWOODS", "state" : "KY", "county" : "GREENUP" },
            "41141": { "city" : "GARRISON", "state" : "KY", "county" : "LEWIS" },
            "41142": { "city" : "GRAHN", "state" : "KY", "county" : "CARTER" },"41143": { "city" : "GRAYSON", "state" : "KY", "county" : "CARTER" },
            "41144": { "city" : "GREENUP", "state" : "KY", "county" : "GREENUP" },
            "41146": { "city" : "HITCHINS", "state" : "KY", "county" : "CARTER" },
            "41149": { "city" : "ISONVILLE", "state" : "KY", "county" : "ELLIOTT" },
            "41159": { "city" : "MARTHA", "state" : "KY", "county" : "LAWRENCE" },
            "41164": { "city" : "OLIVE HILL", "state" : "KY", "county" : "CARTER" },
            "41166": { "city" : "QUINCY", "state" : "KY", "county" : "LEWIS" },"41168": { "city" : "RUSH", "state" : "KY", "county" : "BOYD" },
            "41169": { "city" : "RUSSELL", "state" : "KY", "county" : "GREENUP" },
            "41171": { "city" : "SANDY HOOK", "state" : "KY", "county" : "ELLIOTT" },
            "41173": { "city" : "SOLDIER", "state" : "KY", "county" : "CARTER" },
            "41174": { "city" : "SOUTH PORTSMOUTH", "state" : "KY", "county" : "GREENUP" },
            "41175": { "city" : "SOUTH SHORE", "state" : "KY", "county" : "GREENUP" },
            "41179": { "city" : "VANCEBURG", "state" : "KY", "county" : "LEWIS" },
            "41180": { "city" : "WEBBVILLE", "state" : "KY", "county" : "LAWRENCE" },
            "41181": { "city" : "WILLARD", "state" : "KY", "county" : "CARTER" },
            "41183": { "city" : "WORTHINGTON", "state" : "KY", "county" : "GREENUP" },
            "41189": { "city" : "TOLLESBORO", "state" : "KY", "county" : "LEWIS" },
            "41201": { "city" : "ADAMS", "state" : "KY", "county" : "LAWRENCE" },
            "41203": { "city" : "BEAUTY", "state" : "KY", "county" : "MARTIN" },"41204": { "city" : "BOONS CAMP", "state" : "KY", "county" : "JOHNSON" },
            "41214": { "city" : "DEBORD", "state" : "KY", "county" : "MARTIN" },"41216": { "city" : "EAST POINT", "state" : "KY", "county" : "JOHNSON" },
            "41219": { "city" : "FLATGAP", "state" : "KY", "county" : "JOHNSON" },
            "41222": { "city" : "HAGERHILL", "state" : "KY", "county" : "JOHNSON" },
            "41224": { "city" : "INEZ", "state" : "KY", "county" : "MARTIN" },"41226": { "city" : "KEATON", "state" : "KY", "county" : "JOHNSON" },
            "41230": { "city" : "LOUISA", "state" : "KY", "county" : "LAWRENCE" },
            "41231": { "city" : "LOVELY", "state" : "KY", "county" : "MARTIN" },"41232": { "city" : "LOWMANSVILLE", "state" : "KY", "county" : "LAWRENCE" },
            "41234": { "city" : "MEALLY", "state" : "KY", "county" : "JOHNSON" },
            "41238": { "city" : "OIL SPRINGS", "state" : "KY", "county" : "JOHNSON" },
            "41240": { "city" : "PAINTSVILLE", "state" : "KY", "county" : "JOHNSON" },
            "41250": { "city" : "PILGRIM", "state" : "KY", "county" : "MARTIN" },
            "41254": { "city" : "RIVER", "state" : "KY", "county" : "JOHNSON" },"41255": { "city" : "SITKA", "state" : "KY", "county" : "JOHNSON" },
            "41256": { "city" : "STAFFORDSVILLE", "state" : "KY", "county" : "JOHNSON" },
            "41257": { "city" : "STAMBAUGH", "state" : "KY", "county" : "JOHNSON" },
            "41260": { "city" : "THELMA", "state" : "KY", "county" : "JOHNSON" },
            "41262": { "city" : "TOMAHAWK", "state" : "KY", "county" : "MARTIN" },
            "41263": { "city" : "TUTOR KEY", "state" : "KY", "county" : "JOHNSON" },
            "41264": { "city" : "ULYSSES", "state" : "KY", "county" : "LAWRENCE" },
            "41265": { "city" : "VAN LEAR", "state" : "KY", "county" : "JOHNSON" },
            "41267": { "city" : "WARFIELD", "state" : "KY", "county" : "MARTIN" },
            "41268": { "city" : "WEST VAN LEAR", "state" : "KY", "county" : "JOHNSON" },
            "41274": { "city" : "WITTENSVILLE", "state" : "KY", "county" : "JOHNSON" },
            "41301": { "city" : "CAMPTON", "state" : "KY", "county" : "WOLFE" },"41311": { "city" : "BEATTYVILLE", "state" : "KY", "county" : "LEE" },
            "41313": { "city" : "BETHANY", "state" : "KY", "county" : "WOLFE" },"41314": { "city" : "BOONEVILLE", "state" : "KY", "county" : "OWSLEY" },
            "41317": { "city" : "CLAYHOLE", "state" : "KY", "county" : "BREATHITT" },
            "41332": { "city" : "HAZEL GREEN", "state" : "KY", "county" : "WOLFE" },
            "41339": { "city" : "JACKSON", "state" : "KY", "county" : "BREATHITT" },
            "41347": { "city" : "LONE", "state" : "KY", "county" : "LEE" },"41348": { "city" : "LOST CREEK", "state" : "KY", "county" : "BREATHITT" },
            "41352": { "city" : "MIZE", "state" : "KY", "county" : "MORGAN" },"41360": { "city" : "PINE RIDGE", "state" : "KY", "county" : "WOLFE" },
            "41365": { "city" : "ROGERS", "state" : "KY", "county" : "WOLFE" },"41385": { "city" : "VANCLEVE", "state" : "KY", "county" : "BREATHITT" },
            "41386": { "city" : "VINCENT", "state" : "KY", "county" : "OWSLEY" },
            "41390": { "city" : "WHICK", "state" : "KY", "county" : "BREATHITT" },
            "41397": { "city" : "ZOE", "state" : "KY", "county" : "LEE" },"41413": { "city" : "CROCKETT", "state" : "KY", "county" : "MORGAN" },
            "41425": { "city" : "EZEL", "state" : "KY", "county" : "MORGAN" },"41426": { "city" : "FALCON", "state" : "KY", "county" : "MAGOFFIN" },
            "41451": { "city" : "MALONE", "state" : "KY", "county" : "MORGAN" },"41464": { "city" : "ROYALTON", "state" : "KY", "county" : "MAGOFFIN" },
            "41465": { "city" : "SALYERSVILLE", "state" : "KY", "county" : "MAGOFFIN" },
            "41472": { "city" : "WEST LIBERTY", "state" : "KY", "county" : "MORGAN" },
            "41477": { "city" : "WRIGLEY", "state" : "KY", "county" : "MORGAN" },
            "41501": { "city" : "PIKEVILLE", "state" : "KY", "county" : "PIKE" },
            "41502": { "city" : "PIKEVILLE", "state" : "KY", "county" : "PIKE" },
            "41503": { "city" : "SOUTH WILLIAMSON", "state" : "KY", "county" : "PIKE" },
            "41512": { "city" : "ASHCAMP", "state" : "KY", "county" : "PIKE" },"41513": { "city" : "BELCHER", "state" : "KY", "county" : "PIKE" },
            "41514": { "city" : "BELFRY", "state" : "KY", "county" : "PIKE" },"41517": { "city" : "BURDINE", "state" : "KY", "county" : "LETCHER" },
            "41519": { "city" : "CANADA", "state" : "KY", "county" : "PIKE" },"41520": { "city" : "DORTON", "state" : "KY", "county" : "PIKE" },
            "41522": { "city" : "ELKHORN CITY", "state" : "KY", "county" : "PIKE" },
            "41524": { "city" : "FEDSCREEK", "state" : "KY", "county" : "PIKE" },
            "41526": { "city" : "FORDS BRANCH", "state" : "KY", "county" : "PIKE" },
            "41527": { "city" : "FOREST HILLS", "state" : "KY", "county" : "PIKE" },
            "41528": { "city" : "FREEBURN", "state" : "KY", "county" : "PIKE" },"41531": { "city" : "HARDY", "state" : "KY", "county" : "PIKE" },
            "41534": { "city" : "HELLIER", "state" : "KY", "county" : "PIKE" },"41537": { "city" : "JENKINS", "state" : "KY", "county" : "LETCHER" },
            "41538": { "city" : "JONANCY", "state" : "KY", "county" : "PIKE" },"41539": { "city" : "KIMPER", "state" : "KY", "county" : "PIKE" },
            "41540": { "city" : "LICK CREEK", "state" : "KY", "county" : "PIKE" },
            "41542": { "city" : "LOOKOUT", "state" : "KY", "county" : "PIKE" },"41543": { "city" : "MC ANDREWS", "state" : "KY", "county" : "PIKE" },
            "41544": { "city" : "MC CARR", "state" : "KY", "county" : "PIKE" },"41547": { "city" : "MAJESTIC", "state" : "KY", "county" : "PIKE" },
            "41548": { "city" : "MOUTHCARD", "state" : "KY", "county" : "PIKE" },
            "41549": { "city" : "MYRA", "state" : "KY", "county" : "PIKE" },"41553": { "city" : "PHELPS", "state" : "KY", "county" : "PIKE" },
            "41554": { "city" : "PHYLLIS", "state" : "KY", "county" : "PIKE" },"41555": { "city" : "PINSONFORK", "state" : "KY", "county" : "PIKE" },
            "41557": { "city" : "RACCOON", "state" : "KY", "county" : "PIKE" },"41558": { "city" : "RANSOM", "state" : "KY", "county" : "PIKE" },
            "41559": { "city" : "REGINA", "state" : "KY", "county" : "PIKE" },"41560": { "city" : "ROBINSON CREEK", "state" : "KY", "county" : "PIKE" },
            "41561": { "city" : "ROCKHOUSE", "state" : "KY", "county" : "PIKE" },
            "41562": { "city" : "SHELBIANA", "state" : "KY", "county" : "PIKE" },
            "41563": { "city" : "SHELBY GAP", "state" : "KY", "county" : "PIKE" },
            "41564": { "city" : "SIDNEY", "state" : "KY", "county" : "PIKE" },"41566": { "city" : "STEELE", "state" : "KY", "county" : "PIKE" },
            "41567": { "city" : "STONE", "state" : "KY", "county" : "PIKE" },"41568": { "city" : "STOPOVER", "state" : "KY", "county" : "PIKE" },
            "41571": { "city" : "VARNEY", "state" : "KY", "county" : "PIKE" },"41572": { "city" : "VIRGIE", "state" : "KY", "county" : "PIKE" },
            "41601": { "city" : "ALLEN", "state" : "KY", "county" : "FLOYD" },"41602": { "city" : "AUXIER", "state" : "KY", "county" : "FLOYD" },
            "41603": { "city" : "BANNER", "state" : "KY", "county" : "FLOYD" },"41604": { "city" : "BEAVER", "state" : "KY", "county" : "FLOYD" },
            "41605": { "city" : "BETSY LAYNE", "state" : "KY", "county" : "FLOYD" },
            "41606": { "city" : "BEVINSVILLE", "state" : "KY", "county" : "FLOYD" },
            "41607": { "city" : "BLUE RIVER", "state" : "KY", "county" : "FLOYD" },
            "41612": { "city" : "BYPRO", "state" : "KY", "county" : "FLOYD" },"41615": { "city" : "DANA", "state" : "KY", "county" : "FLOYD" },
            "41616": { "city" : "DAVID", "state" : "KY", "county" : "FLOYD" },"41619": { "city" : "DRIFT", "state" : "KY", "county" : "FLOYD" },
            "41621": { "city" : "DWALE", "state" : "KY", "county" : "FLOYD" },"41622": { "city" : "EASTERN", "state" : "KY", "county" : "FLOYD" },
            "41630": { "city" : "GARRETT", "state" : "KY", "county" : "FLOYD" },"41631": { "city" : "GRETHEL", "state" : "KY", "county" : "FLOYD" },
            "41632": { "city" : "GUNLOCK", "state" : "KY", "county" : "MAGOFFIN" },
            "41635": { "city" : "HAROLD", "state" : "KY", "county" : "FLOYD" },"41636": { "city" : "HI HAT", "state" : "KY", "county" : "FLOYD" },
            "41640": { "city" : "HUEYSVILLE", "state" : "KY", "county" : "FLOYD" },
            "41642": { "city" : "IVEL", "state" : "KY", "county" : "FLOYD" },"41643": { "city" : "LACKEY", "state" : "KY", "county" : "FLOYD" },
            "41645": { "city" : "LANGLEY", "state" : "KY", "county" : "FLOYD" },"41647": { "city" : "MC DOWELL", "state" : "KY", "county" : "FLOYD" },
            "41649": { "city" : "MARTIN", "state" : "KY", "county" : "FLOYD" },"41650": { "city" : "MELVIN", "state" : "KY", "county" : "FLOYD" },
            "41651": { "city" : "MINNIE", "state" : "KY", "county" : "FLOYD" },"41653": { "city" : "PRESTONSBURG", "state" : "KY", "county" : "FLOYD" },
            "41655": { "city" : "PRINTER", "state" : "KY", "county" : "FLOYD" },"41659": { "city" : "STANVILLE", "state" : "KY", "county" : "FLOYD" },
            "41660": { "city" : "TEABERRY", "state" : "KY", "county" : "FLOYD" },
            "41666": { "city" : "WAYLAND", "state" : "KY", "county" : "FLOYD" },"41667": { "city" : "WEEKSBURY", "state" : "KY", "county" : "FLOYD" },
            "41669": { "city" : "WHEELWRIGHT", "state" : "KY", "county" : "FLOYD" },
            "41701": { "city" : "HAZARD", "state" : "KY", "county" : "PERRY" },"41702": { "city" : "HAZARD", "state" : "KY", "county" : "PERRY" },
            "41712": { "city" : "ARY", "state" : "KY", "county" : "PERRY" },"41713": { "city" : "AVAWAM", "state" : "KY", "county" : "PERRY" },
            "41714": { "city" : "BEAR BRANCH", "state" : "KY", "county" : "LESLIE" },
            "41719": { "city" : "BONNYMAN", "state" : "KY", "county" : "PERRY" },
            "41721": { "city" : "BUCKHORN", "state" : "KY", "county" : "PERRY" },
            "41722": { "city" : "BULAN", "state" : "KY", "county" : "PERRY" },"41723": { "city" : "BUSY", "state" : "KY", "county" : "PERRY" },
            "41725": { "city" : "CARRIE", "state" : "KY", "county" : "KNOTT" },"41727": { "city" : "CHAVIES", "state" : "KY", "county" : "PERRY" },
            "41729": { "city" : "COMBS", "state" : "KY", "county" : "PERRY" },"41731": { "city" : "CORNETTSVILLE", "state" : "KY", "county" : "PERRY" },
            "41739": { "city" : "DWARF", "state" : "KY", "county" : "PERRY" },"41740": { "city" : "EMMALENA", "state" : "KY", "county" : "KNOTT" },
            "41743": { "city" : "FISTY", "state" : "KY", "county" : "KNOTT" },"41745": { "city" : "GAYS CREEK", "state" : "KY", "county" : "PERRY" },
            "41746": { "city" : "HAPPY", "state" : "KY", "county" : "PERRY" },"41749": { "city" : "HYDEN", "state" : "KY", "county" : "LESLIE" },
            "41751": { "city" : "JEFF", "state" : "KY", "county" : "PERRY" },"41754": { "city" : "KRYPTON", "state" : "KY", "county" : "PERRY" },
            "41759": { "city" : "SASSAFRAS", "state" : "KY", "county" : "KNOTT" },
            "41760": { "city" : "SCUDDY", "state" : "KY", "county" : "PERRY" },"41762": { "city" : "SIZEROCK", "state" : "KY", "county" : "LESLIE" },
            "41763": { "city" : "SLEMP", "state" : "KY", "county" : "PERRY" },"41764": { "city" : "SMILAX", "state" : "KY", "county" : "LESLIE" },
            "41766": { "city" : "THOUSANDSTICKS", "state" : "KY", "county" : "LESLIE" },
            "41772": { "city" : "VEST", "state" : "KY", "county" : "KNOTT" },"41773": { "city" : "VICCO", "state" : "KY", "county" : "PERRY" },
            "41774": { "city" : "VIPER", "state" : "KY", "county" : "PERRY" },"41776": { "city" : "WOOTON", "state" : "KY", "county" : "LESLIE" },
            "41777": { "city" : "YEADDISS", "state" : "KY", "county" : "LESLIE" },
            "41804": { "city" : "BLACKEY", "state" : "KY", "county" : "LETCHER" },
            "41810": { "city" : "CROMONA", "state" : "KY", "county" : "LETCHER" },
            "41812": { "city" : "DEANE", "state" : "KY", "county" : "LETCHER" },"41815": { "city" : "ERMINE", "state" : "KY", "county" : "LETCHER" },
            "41817": { "city" : "GARNER", "state" : "KY", "county" : "KNOTT" },"41819": { "city" : "GORDON", "state" : "KY", "county" : "LETCHER" },
            "41821": { "city" : "HALLIE", "state" : "KY", "county" : "LETCHER" },
            "41822": { "city" : "HINDMAN", "state" : "KY", "county" : "KNOTT" },"41824": { "city" : "ISOM", "state" : "KY", "county" : "LETCHER" },
            "41825": { "city" : "JACKHORN", "state" : "KY", "county" : "LETCHER" },
            "41826": { "city" : "JEREMIAH", "state" : "KY", "county" : "LETCHER" },
            "41828": { "city" : "KITE", "state" : "KY", "county" : "KNOTT" },"41831": { "city" : "LEBURN", "state" : "KY", "county" : "KNOTT" },
            "41833": { "city" : "LINEFORK", "state" : "KY", "county" : "LETCHER" },
            "41834": { "city" : "LITTCARR", "state" : "KY", "county" : "KNOTT" },
            "41835": { "city" : "MC ROBERTS", "state" : "KY", "county" : "LETCHER" },
            "41836": { "city" : "MALLIE", "state" : "KY", "county" : "KNOTT" },"41837": { "city" : "MAYKING", "state" : "KY", "county" : "LETCHER" },
            "41838": { "city" : "MILLSTONE", "state" : "KY", "county" : "LETCHER" },
            "41839": { "city" : "MOUSIE", "state" : "KY", "county" : "KNOTT" },"41840": { "city" : "NEON", "state" : "KY", "county" : "LETCHER" },
            "41843": { "city" : "PINE TOP", "state" : "KY", "county" : "KNOTT" },
            "41844": { "city" : "PIPPA PASSES", "state" : "KY", "county" : "KNOTT" },
            "41845": { "city" : "PREMIUM", "state" : "KY", "county" : "LETCHER" },
            "41847": { "city" : "REDFOX", "state" : "KY", "county" : "KNOTT" },"41848": { "city" : "ROXANA", "state" : "KY", "county" : "LETCHER" },
            "41855": { "city" : "THORNTON", "state" : "KY", "county" : "LETCHER" },
            "41858": { "city" : "WHITESBURG", "state" : "KY", "county" : "LETCHER" },
            "41859": { "city" : "DEMA", "state" : "KY", "county" : "KNOTT" },"41861": { "city" : "RAVEN", "state" : "KY", "county" : "KNOTT" },
            "41862": { "city" : "TOPMOST", "state" : "KY", "county" : "KNOTT" },"42001": { "city" : "PADUCAH", "state" : "KY", "county" : "MCCRACKEN" },
            "42002": { "city" : "PADUCAH", "state" : "KY", "county" : "MCCRACKEN" },
            "42003": { "city" : "PADUCAH", "state" : "KY", "county" : "MCCRACKEN" },
            "42020": { "city" : "ALMO", "state" : "KY", "county" : "CALLOWAY" },"42021": { "city" : "ARLINGTON", "state" : "KY", "county" : "CARLISLE" },
            "42022": { "city" : "BANDANA", "state" : "KY", "county" : "BALLARD" },
            "42023": { "city" : "BARDWELL", "state" : "KY", "county" : "CARLISLE" },
            "42024": { "city" : "BARLOW", "state" : "KY", "county" : "BALLARD" },
            "42025": { "city" : "BENTON", "state" : "KY", "county" : "MARSHALL" },
            "42027": { "city" : "BOAZ", "state" : "KY", "county" : "GRAVES" },"42028": { "city" : "BURNA", "state" : "KY", "county" : "LIVINGSTON" },
            "42029": { "city" : "CALVERT CITY", "state" : "KY", "county" : "MARSHALL" },
            "42031": { "city" : "CLINTON", "state" : "KY", "county" : "HICKMAN" },
            "42032": { "city" : "COLUMBUS", "state" : "KY", "county" : "HICKMAN" },
            "42033": { "city" : "CRAYNE", "state" : "KY", "county" : "CRITTENDEN" },
            "42035": { "city" : "CUNNINGHAM", "state" : "KY", "county" : "CARLISLE" },
            "42036": { "city" : "DEXTER", "state" : "KY", "county" : "CALLOWAY" },
            "42038": { "city" : "EDDYVILLE", "state" : "KY", "county" : "LYON" },
            "42039": { "city" : "FANCY FARM", "state" : "KY", "county" : "GRAVES" },
            "42040": { "city" : "FARMINGTON", "state" : "KY", "county" : "GRAVES" },
            "42041": { "city" : "FULTON", "state" : "KY", "county" : "FULTON" },"42044": { "city" : "GILBERTSVILLE", "state" : "KY", "county" : "MARSHALL" },
            "42045": { "city" : "GRAND RIVERS", "state" : "KY", "county" : "LIVINGSTON" },
            "42047": { "city" : "HAMPTON", "state" : "KY", "county" : "LIVINGSTON" },
            "42048": { "city" : "HARDIN", "state" : "KY", "county" : "MARSHALL" },
            "42049": { "city" : "HAZEL", "state" : "KY", "county" : "CALLOWAY" },
            "42050": { "city" : "HICKMAN", "state" : "KY", "county" : "FULTON" },
            "42051": { "city" : "HICKORY", "state" : "KY", "county" : "GRAVES" },
            "42053": { "city" : "KEVIL", "state" : "KY", "county" : "MCCRACKEN" },
            "42054": { "city" : "KIRKSEY", "state" : "KY", "county" : "CALLOWAY" },
            "42055": { "city" : "KUTTAWA", "state" : "KY", "county" : "LYON" },"42056": { "city" : "LA CENTER", "state" : "KY", "county" : "BALLARD" },
            "42058": { "city" : "LEDBETTER", "state" : "KY", "county" : "LIVINGSTON" },
            "42060": { "city" : "LOVELACEVILLE", "state" : "KY", "county" : "BALLARD" },
            "42061": { "city" : "LOWES", "state" : "KY", "county" : "GRAVES" },"42064": { "city" : "MARION", "state" : "KY", "county" : "CRITTENDEN" },
            "42066": { "city" : "MAYFIELD", "state" : "KY", "county" : "GRAVES" },
            "42069": { "city" : "MELBER", "state" : "KY", "county" : "GRAVES" },"42070": { "city" : "MILBURN", "state" : "KY", "county" : "CARLISLE" },
            "42071": { "city" : "MURRAY", "state" : "KY", "county" : "CALLOWAY" },
            "42076": { "city" : "NEW CONCORD", "state" : "KY", "county" : "CALLOWAY" },
            "42078": { "city" : "SALEM", "state" : "KY", "county" : "LIVINGSTON" },
            "42079": { "city" : "SEDALIA", "state" : "KY", "county" : "GRAVES" },
            "42081": { "city" : "SMITHLAND", "state" : "KY", "county" : "LIVINGSTON" },
            "42082": { "city" : "SYMSONIA", "state" : "KY", "county" : "GRAVES" },
            "42083": { "city" : "TILINE", "state" : "KY", "county" : "LIVINGSTON" },
            "42085": { "city" : "WATER VALLEY", "state" : "KY", "county" : "GRAVES" },
            "42086": { "city" : "WEST PADUCAH", "state" : "KY", "county" : "MCCRACKEN" },
            "42087": { "city" : "WICKLIFFE", "state" : "KY", "county" : "BALLARD" },
            "42088": { "city" : "WINGO", "state" : "KY", "county" : "GRAVES" },"42101": { "city" : "BOWLING GREEN", "state" : "KY", "county" : "WARREN" },
            "42102": { "city" : "BOWLING GREEN", "state" : "KY", "county" : "WARREN" },
            "42103": { "city" : "BOWLING GREEN", "state" : "KY", "county" : "WARREN" },
            "42104": { "city" : "BOWLING GREEN", "state" : "KY", "county" : "WARREN" },
            "42120": { "city" : "ADOLPHUS", "state" : "KY", "county" : "ALLEN" },
            "42122": { "city" : "ALVATON", "state" : "KY", "county" : "WARREN" },
            "42123": { "city" : "AUSTIN", "state" : "KY", "county" : "BARREN" },"42127": { "city" : "CAVE CITY", "state" : "KY", "county" : "BARREN" },
            "42129": { "city" : "EDMONTON", "state" : "KY", "county" : "METCALFE" },
            "42130": { "city" : "EIGHTY EIGHT", "state" : "KY", "county" : "BARREN" },
            "42131": { "city" : "ETOILE", "state" : "KY", "county" : "BARREN" },"42133": { "city" : "FOUNTAIN RUN", "state" : "KY", "county" : "MONROE" },
            "42134": { "city" : "FRANKLIN", "state" : "KY", "county" : "SIMPSON" },
            "42135": { "city" : "FRANKLIN", "state" : "KY", "county" : "SIMPSON" },
            "42140": { "city" : "GAMALIEL", "state" : "KY", "county" : "MONROE" },
            "42141": { "city" : "GLASGOW", "state" : "KY", "county" : "BARREN" },
            "42142": { "city" : "GLASGOW", "state" : "KY", "county" : "BARREN" },
            "42151": { "city" : "HESTAND", "state" : "KY", "county" : "MONROE" },
            "42152": { "city" : "HISEVILLE", "state" : "KY", "county" : "BARREN" },
            "42154": { "city" : "KNOB LICK", "state" : "KY", "county" : "METCALFE" },
            "42156": { "city" : "LUCAS", "state" : "KY", "county" : "BARREN" },"42159": { "city" : "OAKLAND", "state" : "KY", "county" : "WARREN" },
            "42160": { "city" : "PARK CITY", "state" : "KY", "county" : "BARREN" },
            "42163": { "city" : "ROCKY HILL", "state" : "KY", "county" : "EDMONSON" },
            "42164": { "city" : "SCOTTSVILLE", "state" : "KY", "county" : "ALLEN" },
            "42166": { "city" : "SUMMER SHADE", "state" : "KY", "county" : "METCALFE" },
            "42167": { "city" : "TOMPKINSVILLE", "state" : "KY", "county" : "MONROE" },
            "42170": { "city" : "WOODBURN", "state" : "KY", "county" : "WARREN" },
            "42171": { "city" : "SMITHS GROVE", "state" : "KY", "county" : "WARREN" },
            "42201": { "city" : "ABERDEEN", "state" : "KY", "county" : "BUTLER" },
            "42202": { "city" : "ADAIRVILLE", "state" : "KY", "county" : "LOGAN" },
            "42204": { "city" : "ALLENSVILLE", "state" : "KY", "county" : "TODD" },
            "42206": { "city" : "AUBURN", "state" : "KY", "county" : "LOGAN" },"42207": { "city" : "BEE SPRING", "state" : "KY", "county" : "EDMONSON" },
            "42210": { "city" : "BROWNSVILLE", "state" : "KY", "county" : "EDMONSON" },
            "42211": { "city" : "CADIZ", "state" : "KY", "county" : "TRIGG" },"42214": { "city" : "CENTER", "state" : "KY", "county" : "METCALFE" },
            "42215": { "city" : "CERULEAN", "state" : "KY", "county" : "TRIGG" },
            "42216": { "city" : "CLIFTY", "state" : "KY", "county" : "TODD" },"42217": { "city" : "CROFTON", "state" : "KY", "county" : "CHRISTIAN" },
            "42219": { "city" : "DUNBAR", "state" : "KY", "county" : "BUTLER" },"42220": { "city" : "ELKTON", "state" : "KY", "county" : "TODD" },
            "42221": { "city" : "FAIRVIEW", "state" : "KY", "county" : "CHRISTIAN" },
            "42223": { "city" : "FORT CAMPBELL", "state" : "KY", "county" : "CHRISTIAN" },
            "42232": { "city" : "GRACEY", "state" : "KY", "county" : "CHRISTIAN" },
            "42234": { "city" : "GUTHRIE", "state" : "KY", "county" : "TODD" },"42236": { "city" : "HERNDON", "state" : "KY", "county" : "CHRISTIAN" },
            "42240": { "city" : "HOPKINSVILLE", "state" : "KY", "county" : "CHRISTIAN" },
            "42241": { "city" : "HOPKINSVILLE", "state" : "KY", "county" : "CHRISTIAN" },
            "42254": { "city" : "LA FAYETTE", "state" : "KY", "county" : "CHRISTIAN" },
            "42256": { "city" : "LEWISBURG", "state" : "KY", "county" : "LOGAN" },
            "42259": { "city" : "MAMMOTH CAVE", "state" : "KY", "county" : "EDMONSON" },
            "42261": { "city" : "MORGANTOWN", "state" : "KY", "county" : "BUTLER" },
            "42262": { "city" : "OAK GROVE", "state" : "KY", "county" : "CHRISTIAN" },
            "42265": { "city" : "OLMSTEAD", "state" : "KY", "county" : "LOGAN" },
            "42266": { "city" : "PEMBROKE", "state" : "KY", "county" : "CHRISTIAN" },
            "42273": { "city" : "ROCHESTER", "state" : "KY", "county" : "BUTLER" },
            "42274": { "city" : "ROCKFIELD", "state" : "KY", "county" : "WARREN" },
            "42275": { "city" : "ROUNDHILL", "state" : "KY", "county" : "EDMONSON" },
            "42276": { "city" : "RUSSELLVILLE", "state" : "KY", "county" : "LOGAN" },
            "42280": { "city" : "SHARON GROVE", "state" : "KY", "county" : "TODD" },
            "42283": { "city" : "SOUTH UNION", "state" : "KY", "county" : "LOGAN" },
            "42285": { "city" : "SWEEDEN", "state" : "KY", "county" : "EDMONSON" },
            "42286": { "city" : "TRENTON", "state" : "KY", "county" : "TODD" },"42288": { "city" : "WOODBURY", "state" : "KY", "county" : "BUTLER" },
            "42301": { "city" : "OWENSBORO", "state" : "KY", "county" : "DAVIESS" },
            "42302": { "city" : "OWENSBORO", "state" : "KY", "county" : "DAVIESS" },
            "42303": { "city" : "OWENSBORO", "state" : "KY", "county" : "DAVIESS" },
            "42304": { "city" : "OWENSBORO", "state" : "KY", "county" : "DAVIESS" },
            "42320": { "city" : "BEAVER DAM", "state" : "KY", "county" : "OHIO" },
            "42321": { "city" : "BEECH CREEK", "state" : "KY", "county" : "MUHLENBERG" },
            "42322": { "city" : "BEECH GROVE", "state" : "KY", "county" : "MCLEAN" },
            "42323": { "city" : "BEECHMONT", "state" : "KY", "county" : "MUHLENBERG" },
            "42324": { "city" : "BELTON", "state" : "KY", "county" : "MUHLENBERG" },
            "42325": { "city" : "BREMEN", "state" : "KY", "county" : "MUHLENBERG" },
            "42327": { "city" : "CALHOUN", "state" : "KY", "county" : "MCLEAN" },
            "42328": { "city" : "CENTERTOWN", "state" : "KY", "county" : "OHIO" },
            "42330": { "city" : "CENTRAL CITY", "state" : "KY", "county" : "MUHLENBERG" },
            "42332": { "city" : "CLEATON", "state" : "KY", "county" : "MUHLENBERG" },
            "42333": { "city" : "CROMWELL", "state" : "KY", "county" : "OHIO" },"42337": { "city" : "DRAKESBORO", "state" : "KY", "county" : "MUHLENBERG" },
            "42338": { "city" : "DUNDEE", "state" : "KY", "county" : "OHIO" },"42339": { "city" : "DUNMOR", "state" : "KY", "county" : "MUHLENBERG" },
            "42343": { "city" : "FORDSVILLE", "state" : "KY", "county" : "OHIO" },
            "42344": { "city" : "GRAHAM", "state" : "KY", "county" : "MUHLENBERG" },
            "42345": { "city" : "GREENVILLE", "state" : "KY", "county" : "MUHLENBERG" },
            "42347": { "city" : "HARTFORD", "state" : "KY", "county" : "OHIO" },"42348": { "city" : "HAWESVILLE", "state" : "KY", "county" : "HANCOCK" },
            "42349": { "city" : "HORSE BRANCH", "state" : "KY", "county" : "OHIO" },
            "42350": { "city" : "ISLAND", "state" : "KY", "county" : "MCLEAN" },"42351": { "city" : "LEWISPORT", "state" : "KY", "county" : "HANCOCK" },
            "42352": { "city" : "LIVERMORE", "state" : "KY", "county" : "MCLEAN" },
            "42354": { "city" : "MC HENRY", "state" : "KY", "county" : "OHIO" },"42355": { "city" : "MACEO", "state" : "KY", "county" : "DAVIESS" },
            "42356": { "city" : "MAPLE MOUNT", "state" : "KY", "county" : "DAVIESS" },
            "42361": { "city" : "OLATON", "state" : "KY", "county" : "OHIO" },"42366": { "city" : "PHILPOT", "state" : "KY", "county" : "DAVIESS" },
            "42367": { "city" : "POWDERLY", "state" : "KY", "county" : "MUHLENBERG" },
            "42368": { "city" : "REYNOLDS STATION", "state" : "KY", "county" : "OHIO" },
            "42369": { "city" : "ROCKPORT", "state" : "KY", "county" : "OHIO" },"42370": { "city" : "ROSINE", "state" : "KY", "county" : "OHIO" },
            "42371": { "city" : "RUMSEY", "state" : "KY", "county" : "MCLEAN" },"42372": { "city" : "SACRAMENTO", "state" : "KY", "county" : "MCLEAN" },
            "42374": { "city" : "SOUTH CARROLLTON", "state" : "KY", "county" : "MUHLENBERG" },
            "42376": { "city" : "UTICA", "state" : "KY", "county" : "DAVIESS" },"42378": { "city" : "WHITESVILLE", "state" : "KY", "county" : "DAVIESS" },
            "42403": { "city" : "BLACKFORD", "state" : "KY", "county" : "WEBSTER" },
            "42404": { "city" : "CLAY", "state" : "KY", "county" : "WEBSTER" },"42406": { "city" : "CORYDON", "state" : "KY", "county" : "HENDERSON" },
            "42408": { "city" : "DAWSON SPRINGS", "state" : "KY", "county" : "HOPKINS" },
            "42409": { "city" : "DIXON", "state" : "KY", "county" : "WEBSTER" },"42410": { "city" : "EARLINGTON", "state" : "KY", "county" : "HOPKINS" },
            "42411": { "city" : "FREDONIA", "state" : "KY", "county" : "CALDWELL" },
            "42413": { "city" : "HANSON", "state" : "KY", "county" : "HOPKINS" },
            "42419": { "city" : "HENDERSON", "state" : "KY", "county" : "HENDERSON" },
            "42420": { "city" : "HENDERSON", "state" : "KY", "county" : "HENDERSON" },
            "42431": { "city" : "MADISONVILLE", "state" : "KY", "county" : "HOPKINS" },
            "42436": { "city" : "MANITOU", "state" : "KY", "county" : "HOPKINS" },
            "42437": { "city" : "MORGANFIELD", "state" : "KY", "county" : "UNION" },
            "42440": { "city" : "MORTONS GAP", "state" : "KY", "county" : "HOPKINS" },
            "42441": { "city" : "NEBO", "state" : "KY", "county" : "HOPKINS" },"42442": { "city" : "NORTONVILLE", "state" : "KY", "county" : "HOPKINS" },
            "42444": { "city" : "POOLE", "state" : "KY", "county" : "WEBSTER" },"42445": { "city" : "PRINCETON", "state" : "KY", "county" : "CALDWELL" },
            "42450": { "city" : "PROVIDENCE", "state" : "KY", "county" : "WEBSTER" },
            "42451": { "city" : "REED", "state" : "KY", "county" : "HENDERSON" },
            "42452": { "city" : "ROBARDS", "state" : "KY", "county" : "HENDERSON" },
            "42453": { "city" : "SAINT CHARLES", "state" : "KY", "county" : "HOPKINS" },
            "42455": { "city" : "SEBREE", "state" : "KY", "county" : "WEBSTER" },
            "42456": { "city" : "SLAUGHTERS", "state" : "KY", "county" : "WEBSTER" },
            "42457": { "city" : "SMITH MILLS", "state" : "KY", "county" : "HENDERSON" },
            "42458": { "city" : "SPOTTSVILLE", "state" : "KY", "county" : "HENDERSON" },
            "42459": { "city" : "STURGIS", "state" : "KY", "county" : "UNION" },"42460": { "city" : "SULLIVAN", "state" : "KY", "county" : "UNION" },
            "42461": { "city" : "UNIONTOWN", "state" : "KY", "county" : "UNION" },
            "42462": { "city" : "WAVERLY", "state" : "KY", "county" : "UNION" },"42463": { "city" : "WHEATCROFT", "state" : "KY", "county" : "WEBSTER" },
            "42464": { "city" : "WHITE PLAINS", "state" : "KY", "county" : "HOPKINS" },
            "42501": { "city" : "SOMERSET", "state" : "KY", "county" : "PULASKI" },
            "42502": { "city" : "SOMERSET", "state" : "KY", "county" : "PULASKI" },
            "42503": { "city" : "SOMERSET", "state" : "KY", "county" : "PULASKI" },
            "42516": { "city" : "BETHELRIDGE", "state" : "KY", "county" : "CASEY" },
            "42518": { "city" : "BRONSTON", "state" : "KY", "county" : "PULASKI" },
            "42519": { "city" : "BURNSIDE", "state" : "KY", "county" : "PULASKI" },
            "42528": { "city" : "DUNNVILLE", "state" : "KY", "county" : "CASEY" },
            "42533": { "city" : "FERGUSON", "state" : "KY", "county" : "PULASKI" },
            "42539": { "city" : "LIBERTY", "state" : "KY", "county" : "CASEY" },"42541": { "city" : "MIDDLEBURG", "state" : "KY", "county" : "CASEY" },
            "42544": { "city" : "NANCY", "state" : "KY", "county" : "PULASKI" },"42553": { "city" : "SCIENCE HILL", "state" : "KY", "county" : "PULASKI" },
            "42558": { "city" : "TATEVILLE", "state" : "KY", "county" : "PULASKI" },
            "42564": { "city" : "WEST SOMERSET", "state" : "KY", "county" : "PULASKI" },
            "42565": { "city" : "WINDSOR", "state" : "KY", "county" : "CASEY" },"42566": { "city" : "YOSEMITE", "state" : "KY", "county" : "CASEY" },
            "42567": { "city" : "EUBANK", "state" : "KY", "county" : "PULASKI" },
            "42602": { "city" : "ALBANY", "state" : "KY", "county" : "CLINTON" },
            "42603": { "city" : "ALPHA", "state" : "KY", "county" : "CLINTON" },"42629": { "city" : "JAMESTOWN", "state" : "KY", "county" : "RUSSELL" },
            "42631": { "city" : "MARSHES SIDING", "state" : "KY", "county" : "MCCREARY" },
            "42633": { "city" : "MONTICELLO", "state" : "KY", "county" : "WAYNE" },
            "42634": { "city" : "PARKERS LAKE", "state" : "KY", "county" : "MCCREARY" },
            "42635": { "city" : "PINE KNOT", "state" : "KY", "county" : "MCCREARY" },
            "42638": { "city" : "REVELO", "state" : "KY", "county" : "MCCREARY" },
            "42642": { "city" : "RUSSELL SPRINGS", "state" : "KY", "county" : "RUSSELL" },
            "42647": { "city" : "STEARNS", "state" : "KY", "county" : "MCCREARY" },
            "42649": { "city" : "STRUNK", "state" : "KY", "county" : "MCCREARY" },
            "42653": { "city" : "WHITLEY CITY", "state" : "KY", "county" : "MCCREARY" },
            "42701": { "city" : "ELIZABETHTOWN", "state" : "KY", "county" : "HARDIN" },
            "42702": { "city" : "ELIZABETHTOWN", "state" : "KY", "county" : "HARDIN" },
            "42712": { "city" : "BIG CLIFTY", "state" : "KY", "county" : "GRAYSON" },
            "42713": { "city" : "BONNIEVILLE", "state" : "KY", "county" : "HART" },
            "42715": { "city" : "BREEDING", "state" : "KY", "county" : "ADAIR" },
            "42716": { "city" : "BUFFALO", "state" : "KY", "county" : "LARUE" },"42717": { "city" : "BURKESVILLE", "state" : "KY", "county" : "CUMBERLAND" },
            "42718": { "city" : "CAMPBELLSVILLE", "state" : "KY", "county" : "TAYLOR" },
            "42719": { "city" : "CAMPBELLSVILLE", "state" : "KY", "county" : "TAYLOR" },
            "42721": { "city" : "CANEYVILLE", "state" : "KY", "county" : "GRAYSON" },
            "42722": { "city" : "CANMER", "state" : "KY", "county" : "HART" },"42724": { "city" : "CECILIA", "state" : "KY", "county" : "HARDIN" },
            "42726": { "city" : "CLARKSON", "state" : "KY", "county" : "GRAYSON" },
            "42728": { "city" : "COLUMBIA", "state" : "KY", "county" : "ADAIR" },
            "42729": { "city" : "CUB RUN", "state" : "KY", "county" : "HART" },"42731": { "city" : "DUBRE", "state" : "KY", "county" : "CUMBERLAND" },
            "42732": { "city" : "EASTVIEW", "state" : "KY", "county" : "HARDIN" },
            "42733": { "city" : "ELK HORN", "state" : "KY", "county" : "TAYLOR" },
            "42740": { "city" : "GLENDALE", "state" : "KY", "county" : "HARDIN" },
            "42741": { "city" : "GLENS FORK", "state" : "KY", "county" : "ADAIR" },
            "42743": { "city" : "GREENSBURG", "state" : "KY", "county" : "GREEN" },
            "42746": { "city" : "HARDYVILLE", "state" : "KY", "county" : "HART" },
            "42748": { "city" : "HODGENVILLE", "state" : "KY", "county" : "LARUE" },
            "42749": { "city" : "HORSE CAVE", "state" : "KY", "county" : "HART" },
            "42753": { "city" : "KNIFLEY", "state" : "KY", "county" : "ADAIR" },"42754": { "city" : "LEITCHFIELD", "state" : "KY", "county" : "GRAYSON" },
            "42755": { "city" : "LEITCHFIELD", "state" : "KY", "county" : "GRAYSON" },
            "42757": { "city" : "MAGNOLIA", "state" : "KY", "county" : "LARUE" },
            "42758": { "city" : "MANNSVILLE", "state" : "KY", "county" : "TAYLOR" },
            "42759": { "city" : "MARROWBONE", "state" : "KY", "county" : "CUMBERLAND" },
            "42762": { "city" : "MILLWOOD", "state" : "KY", "county" : "GRAYSON" },
            "42764": { "city" : "MOUNT SHERMAN", "state" : "KY", "county" : "LARUE" },
            "42765": { "city" : "MUNFORDVILLE", "state" : "KY", "county" : "HART" },
            "42776": { "city" : "SONORA", "state" : "KY", "county" : "HARDIN" },"42782": { "city" : "SUMMERSVILLE", "state" : "KY", "county" : "GREEN" },
            "42784": { "city" : "UPTON", "state" : "KY", "county" : "HARDIN" },"42788": { "city" : "WHITE MILLS", "state" : "KY", "county" : "HARDIN" },
            "43001": { "city" : "ALEXANDRIA", "state" : "OH", "county" : "LICKING" },
            "43002": { "city" : "AMLIN", "state" : "OH", "county" : "FRANKLIN" },
            "43003": { "city" : "ASHLEY", "state" : "OH", "county" : "DELAWARE" },
            "43004": { "city" : "BLACKLICK", "state" : "OH", "county" : "FRANKLIN" },
            "43005": { "city" : "BLADENSBURG", "state" : "OH", "county" : "KNOX" },
            "43006": { "city" : "BRINKHAVEN", "state" : "OH", "county" : "KNOX" },
            "43007": { "city" : "BROADWAY", "state" : "OH", "county" : "UNION" },
            "43008": { "city" : "BUCKEYE LAKE", "state" : "OH", "county" : "LICKING" },
            "43009": { "city" : "CABLE", "state" : "OH", "county" : "CHAMPAIGN" },
            "43010": { "city" : "CATAWBA", "state" : "OH", "county" : "CLARK" },"43011": { "city" : "CENTERBURG", "state" : "OH", "county" : "KNOX" },
            "43013": { "city" : "CROTON", "state" : "OH", "county" : "LICKING" },
            "43014": { "city" : "DANVILLE", "state" : "OH", "county" : "KNOX" },"43015": { "city" : "DELAWARE", "state" : "OH", "county" : "DELAWARE" },
            "43016": { "city" : "DUBLIN", "state" : "OH", "county" : "FRANKLIN" },
            "43017": { "city" : "DUBLIN", "state" : "OH", "county" : "FRANKLIN" },
            "43018": { "city" : "ETNA", "state" : "OH", "county" : "LICKING" },"43019": { "city" : "FREDERICKTOWN", "state" : "OH", "county" : "KNOX" },
            "43021": { "city" : "GALENA", "state" : "OH", "county" : "DELAWARE" },
            "43022": { "city" : "GAMBIER", "state" : "OH", "county" : "KNOX" },"43023": { "city" : "GRANVILLE", "state" : "OH", "county" : "LICKING" },
            "43025": { "city" : "HEBRON", "state" : "OH", "county" : "LICKING" },
            "43026": { "city" : "HILLIARD", "state" : "OH", "county" : "FRANKLIN" },
            "43027": { "city" : "HOMER", "state" : "OH", "county" : "LICKING" },"43028": { "city" : "HOWARD", "state" : "OH", "county" : "KNOX" },
            "43029": { "city" : "IRWIN", "state" : "OH", "county" : "UNION" },"43030": { "city" : "JACKSONTOWN", "state" : "OH", "county" : "LICKING" },
            "43031": { "city" : "JOHNSTOWN", "state" : "OH", "county" : "LICKING" },
            "43032": { "city" : "KILBOURNE", "state" : "OH", "county" : "DELAWARE" },
            "43033": { "city" : "KIRKERSVILLE", "state" : "OH", "county" : "LICKING" },
            "43035": { "city" : "LEWIS CENTER", "state" : "OH", "county" : "DELAWARE" },
            "43036": { "city" : "MAGNETIC SPRINGS", "state" : "OH", "county" : "UNION" },
            "43037": { "city" : "MARTINSBURG", "state" : "OH", "county" : "KNOX" },
            "43040": { "city" : "MARYSVILLE", "state" : "OH", "county" : "UNION" },
            "43041": { "city" : "MARYSVILLE", "state" : "OH", "county" : "UNION" },
            "43044": { "city" : "MECHANICSBURG", "state" : "OH", "county" : "CHAMPAIGN" },
            "43045": { "city" : "MILFORD CENTER", "state" : "OH", "county" : "UNION" },
            "43046": { "city" : "MILLERSPORT", "state" : "OH", "county" : "FAIRFIELD" },
            "43047": { "city" : "MINGO", "state" : "OH", "county" : "CHAMPAIGN" },
            "43048": { "city" : "MOUNT LIBERTY", "state" : "OH", "county" : "KNOX" },
            "43050": { "city" : "MOUNT VERNON", "state" : "OH", "county" : "KNOX" },
            "43054": { "city" : "NEW ALBANY", "state" : "OH", "county" : "FRANKLIN" },
            "43055": { "city" : "NEWARK", "state" : "OH", "county" : "LICKING" },
            "43056": { "city" : "HEATH", "state" : "OH", "county" : "LICKING" },"43058": { "city" : "NEWARK", "state" : "OH", "county" : "LICKING" },
            "43060": { "city" : "NORTH LEWISBURG", "state" : "OH", "county" : "CHAMPAIGN" },
            "43061": { "city" : "OSTRANDER", "state" : "OH", "county" : "DELAWARE" },
            "43062": { "city" : "PATASKALA", "state" : "OH", "county" : "LICKING" },
            "43064": { "city" : "PLAIN CITY", "state" : "OH", "county" : "MADISON" },
            "43065": { "city" : "POWELL", "state" : "OH", "county" : "DELAWARE" },
            "43066": { "city" : "RADNOR", "state" : "OH", "county" : "DELAWARE" },
            "43067": { "city" : "RAYMOND", "state" : "OH", "county" : "UNION" },"43068": { "city" : "REYNOLDSBURG", "state" : "OH", "county" : "FRANKLIN" },
            "43069": { "city" : "REYNOLDSBURG", "state" : "OH", "county" : "FRANKLIN" },
            "43070": { "city" : "ROSEWOOD", "state" : "OH", "county" : "CHAMPAIGN" },
            "43071": { "city" : "SAINT LOUISVILLE", "state" : "OH", "county" : "LICKING" },
            "43072": { "city" : "SAINT PARIS", "state" : "OH", "county" : "CHAMPAIGN" },
            "43073": { "city" : "SUMMIT STATION", "state" : "OH", "county" : "LICKING" },
            "43074": { "city" : "SUNBURY", "state" : "OH", "county" : "DELAWARE" },
            "43076": { "city" : "THORNVILLE", "state" : "OH", "county" : "PERRY" },
            "43077": { "city" : "UNIONVILLE CENTER", "state" : "OH", "county" : "UNION" },
            "43078": { "city" : "URBANA", "state" : "OH", "county" : "CHAMPAIGN" },
            "43080": { "city" : "UTICA", "state" : "OH", "county" : "LICKING" },"43081": { "city" : "WESTERVILLE", "state" : "OH", "county" : "FRANKLIN" },
            "43082": { "city" : "WESTERVILLE", "state" : "OH", "county" : "DELAWARE" },
            "43083": { "city" : "WESTVILLE", "state" : "OH", "county" : "CHAMPAIGN" },
            "43084": { "city" : "WOODSTOCK", "state" : "OH", "county" : "CHAMPAIGN" },
            "43085": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43086": { "city" : "WESTERVILLE", "state" : "OH", "county" : "FRANKLIN" },
            "43101": { "city" : "ADELPHI", "state" : "OH", "county" : "ROSS" },"43102": { "city" : "AMANDA", "state" : "OH", "county" : "FAIRFIELD" },
            "43103": { "city" : "ASHVILLE", "state" : "OH", "county" : "PICKAWAY" },
            "43105": { "city" : "BALTIMORE", "state" : "OH", "county" : "FAIRFIELD" },
            "43106": { "city" : "BLOOMINGBURG", "state" : "OH", "county" : "FAYETTE" },
            "43107": { "city" : "BREMEN", "state" : "OH", "county" : "FAIRFIELD" },
            "43109": { "city" : "BRICE", "state" : "OH", "county" : "FRANKLIN" },
            "43110": { "city" : "CANAL WINCHESTER", "state" : "OH", "county" : "FRANKLIN" },
            "43111": { "city" : "CARBON HILL", "state" : "OH", "county" : "HOCKING" },
            "43112": { "city" : "CARROLL", "state" : "OH", "county" : "FAIRFIELD" },
            "43113": { "city" : "CIRCLEVILLE", "state" : "OH", "county" : "PICKAWAY" },
            "43115": { "city" : "CLARKSBURG", "state" : "OH", "county" : "ROSS" },
            "43116": { "city" : "COMMERCIAL POINT", "state" : "OH", "county" : "PICKAWAY" },
            "43119": { "city" : "GALLOWAY", "state" : "OH", "county" : "FRANKLIN" },
            "43123": { "city" : "GROVE CITY", "state" : "OH", "county" : "FRANKLIN" },
            "43125": { "city" : "GROVEPORT", "state" : "OH", "county" : "FRANKLIN" },
            "43126": { "city" : "HARRISBURG", "state" : "OH", "county" : "FRANKLIN" },
            "43127": { "city" : "HAYDENVILLE", "state" : "OH", "county" : "HOCKING" },
            "43128": { "city" : "JEFFERSONVILLE", "state" : "OH", "county" : "FAYETTE" },
            "43130": { "city" : "LANCASTER", "state" : "OH", "county" : "FAIRFIELD" },
            "43135": { "city" : "LAURELVILLE", "state" : "OH", "county" : "HOCKING" },
            "43136": { "city" : "LITHOPOLIS", "state" : "OH", "county" : "FAIRFIELD" },
            "43137": { "city" : "LOCKBOURNE", "state" : "OH", "county" : "FRANKLIN" },
            "43138": { "city" : "LOGAN", "state" : "OH", "county" : "HOCKING" },"43140": { "city" : "LONDON", "state" : "OH", "county" : "MADISON" },
            "43142": { "city" : "MILLEDGEVILLE", "state" : "OH", "county" : "FAYETTE" },
            "43143": { "city" : "MOUNT STERLING", "state" : "OH", "county" : "MADISON" },
            "43144": { "city" : "MURRAY CITY", "state" : "OH", "county" : "HOCKING" },
            "43145": { "city" : "NEW HOLLAND", "state" : "OH", "county" : "PICKAWAY" },
            "43146": { "city" : "ORIENT", "state" : "OH", "county" : "PICKAWAY" },
            "43147": { "city" : "PICKERINGTON", "state" : "OH", "county" : "FAIRFIELD" },
            "43148": { "city" : "PLEASANTVILLE", "state" : "OH", "county" : "FAIRFIELD" },
            "43149": { "city" : "ROCKBRIDGE", "state" : "OH", "county" : "HOCKING" },
            "43150": { "city" : "RUSHVILLE", "state" : "OH", "county" : "FAIRFIELD" },
            "43151": { "city" : "SEDALIA", "state" : "OH", "county" : "MADISON" },
            "43152": { "city" : "SOUTH BLOOMINGVILLE", "state" : "OH", "county" : "HOCKING" },
            "43153": { "city" : "SOUTH SOLON", "state" : "OH", "county" : "MADISON" },
            "43154": { "city" : "STOUTSVILLE", "state" : "OH", "county" : "FAIRFIELD" },
            "43155": { "city" : "SUGAR GROVE", "state" : "OH", "county" : "FAIRFIELD" },
            "43156": { "city" : "TARLTON", "state" : "OH", "county" : "PICKAWAY" },
            "43157": { "city" : "THURSTON", "state" : "OH", "county" : "FAIRFIELD" },
            "43158": { "city" : "UNION FURNACE", "state" : "OH", "county" : "HOCKING" },
            "43160": { "city" : "WASHINGTON COURT HOUSE", "state" : "OH", "county" : "FAYETTE" },
            "43162": { "city" : "WEST JEFFERSON", "state" : "OH", "county" : "MADISON" },
            "43163": { "city" : "WEST RUSHVILLE", "state" : "OH", "county" : "FAIRFIELD" },
            "43164": { "city" : "WILLIAMSPORT", "state" : "OH", "county" : "PICKAWAY" },
            "43201": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43202": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43203": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43204": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43205": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43206": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43207": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43209": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43210": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43211": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43212": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43213": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43214": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43215": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43216": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43217": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43218": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43219": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43220": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43221": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43222": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43223": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43224": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43226": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43227": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43228": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43229": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43230": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43231": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43232": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43234": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43235": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43236": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43240": { "city" : "COLUMBUS", "state" : "OH", "county" : "DELAWARE" },
            "43251": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43260": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43266": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43271": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43287": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43291": { "city" : "COLUMBUS", "state" : "OH", "county" : "FRANKLIN" },
            "43301": { "city" : "MARION", "state" : "OH", "county" : "MARION" },"43302": { "city" : "MARION", "state" : "OH", "county" : "MARION" },
            "43306": { "city" : "MARION", "state" : "OH", "county" : "MARION" },"43307": { "city" : "MARION", "state" : "OH", "county" : "MARION" },
            "43310": { "city" : "BELLE CENTER", "state" : "OH", "county" : "LOGAN" },
            "43311": { "city" : "BELLEFONTAINE", "state" : "OH", "county" : "LOGAN" },
            "43314": { "city" : "CALEDONIA", "state" : "OH", "county" : "MARION" },
            "43315": { "city" : "CARDINGTON", "state" : "OH", "county" : "MORROW" },
            "43316": { "city" : "CAREY", "state" : "OH", "county" : "WYANDOT" },"43317": { "city" : "CHESTERVILLE", "state" : "OH", "county" : "MORROW" },
            "43318": { "city" : "DE GRAFF", "state" : "OH", "county" : "LOGAN" },
            "43319": { "city" : "EAST LIBERTY", "state" : "OH", "county" : "LOGAN" },
            "43320": { "city" : "EDISON", "state" : "OH", "county" : "MORROW" },"43321": { "city" : "FULTON", "state" : "OH", "county" : "MORROW" },
            "43322": { "city" : "GREEN CAMP", "state" : "OH", "county" : "MARION" },
            "43323": { "city" : "HARPSTER", "state" : "OH", "county" : "WYANDOT" },
            "43324": { "city" : "HUNTSVILLE", "state" : "OH", "county" : "LOGAN" },
            "43325": { "city" : "IBERIA", "state" : "OH", "county" : "MORROW" },"43326": { "city" : "KENTON", "state" : "OH", "county" : "HARDIN" },
            "43330": { "city" : "KIRBY", "state" : "OH", "county" : "WYANDOT" },"43331": { "city" : "LAKEVIEW", "state" : "OH", "county" : "LOGAN" },
            "43332": { "city" : "LA RUE", "state" : "OH", "county" : "MARION" },"43333": { "city" : "LEWISTOWN", "state" : "OH", "county" : "LOGAN" },
            "43334": { "city" : "MARENGO", "state" : "OH", "county" : "MORROW" },
            "43335": { "city" : "MARTEL", "state" : "OH", "county" : "MARION" },"43336": { "city" : "MIDDLEBURG", "state" : "OH", "county" : "LOGAN" },
            "43337": { "city" : "MORRAL", "state" : "OH", "county" : "MARION" },"43338": { "city" : "MOUNT GILEAD", "state" : "OH", "county" : "MORROW" },
            "43340": { "city" : "MOUNT VICTORY", "state" : "OH", "county" : "HARDIN" },
            "43341": { "city" : "NEW BLOOMINGTON", "state" : "OH", "county" : "MARION" },
            "43342": { "city" : "PROSPECT", "state" : "OH", "county" : "MARION" },
            "43343": { "city" : "QUINCY", "state" : "OH", "county" : "LOGAN" },"43344": { "city" : "RICHWOOD", "state" : "OH", "county" : "UNION" },
            "43345": { "city" : "RIDGEWAY", "state" : "OH", "county" : "HARDIN" },
            "43346": { "city" : "ROUNDHEAD", "state" : "OH", "county" : "HARDIN" },
            "43347": { "city" : "RUSHSYLVANIA", "state" : "OH", "county" : "LOGAN" },
            "43348": { "city" : "RUSSELLS POINT", "state" : "OH", "county" : "LOGAN" },
            "43349": { "city" : "SHAUCK", "state" : "OH", "county" : "MORROW" },"43350": { "city" : "SPARTA", "state" : "OH", "county" : "MORROW" },
            "43351": { "city" : "UPPER SANDUSKY", "state" : "OH", "county" : "WYANDOT" },
            "43356": { "city" : "WALDO", "state" : "OH", "county" : "MARION" },"43357": { "city" : "WEST LIBERTY", "state" : "OH", "county" : "LOGAN" },
            "43358": { "city" : "WEST MANSFIELD", "state" : "OH", "county" : "LOGAN" },
            "43359": { "city" : "WHARTON", "state" : "OH", "county" : "WYANDOT" },
            "43360": { "city" : "ZANESFIELD", "state" : "OH", "county" : "LOGAN" },
            "43402": { "city" : "BOWLING GREEN", "state" : "OH", "county" : "WOOD" },
            "43403": { "city" : "BOWLING GREEN", "state" : "OH", "county" : "WOOD" },
            "43406": { "city" : "BRADNER", "state" : "OH", "county" : "WOOD" },"43407": { "city" : "BURGOON", "state" : "OH", "county" : "SANDUSKY" },
            "43408": { "city" : "CLAY CENTER", "state" : "OH", "county" : "OTTAWA" },
            "43410": { "city" : "CLYDE", "state" : "OH", "county" : "SANDUSKY" },
            "43412": { "city" : "CURTICE", "state" : "OH", "county" : "OTTAWA" },
            "43413": { "city" : "CYGNET", "state" : "OH", "county" : "WOOD" },"43414": { "city" : "DUNBRIDGE", "state" : "OH", "county" : "WOOD" },
            "43416": { "city" : "ELMORE", "state" : "OH", "county" : "OTTAWA" },"43420": { "city" : "FREMONT", "state" : "OH", "county" : "SANDUSKY" },
            "43430": { "city" : "GENOA", "state" : "OH", "county" : "OTTAWA" },"43431": { "city" : "GIBSONBURG", "state" : "OH", "county" : "SANDUSKY" },
            "43432": { "city" : "GRAYTOWN", "state" : "OH", "county" : "OTTAWA" },
            "43433": { "city" : "GYPSUM", "state" : "OH", "county" : "OTTAWA" },"43435": { "city" : "HELENA", "state" : "OH", "county" : "SANDUSKY" },
            "43437": { "city" : "JERRY CITY", "state" : "OH", "county" : "WOOD" },
            "43438": { "city" : "KELLEYS ISLAND", "state" : "OH", "county" : "ERIE" },
            "43439": { "city" : "LACARNE", "state" : "OH", "county" : "OTTAWA" },
            "43440": { "city" : "LAKESIDE MARBLEHEAD", "state" : "OH", "county" : "OTTAWA" },
            "43441": { "city" : "LEMOYNE", "state" : "OH", "county" : "WOOD" },"43442": { "city" : "LINDSEY", "state" : "OH", "county" : "SANDUSKY" },
            "43443": { "city" : "LUCKEY", "state" : "OH", "county" : "WOOD" },"43445": { "city" : "MARTIN", "state" : "OH", "county" : "OTTAWA" },
            "43446": { "city" : "MIDDLE BASS", "state" : "OH", "county" : "OTTAWA" },
            "43447": { "city" : "MILLBURY", "state" : "OH", "county" : "WOOD" },"43449": { "city" : "OAK HARBOR", "state" : "OH", "county" : "OTTAWA" },
            "43450": { "city" : "PEMBERVILLE", "state" : "OH", "county" : "WOOD" },
            "43451": { "city" : "PORTAGE", "state" : "OH", "county" : "WOOD" },"43452": { "city" : "PORT CLINTON", "state" : "OH", "county" : "OTTAWA" },
            "43456": { "city" : "PUT IN BAY", "state" : "OH", "county" : "OTTAWA" },
            "43457": { "city" : "RISINGSUN", "state" : "OH", "county" : "WOOD" },
            "43458": { "city" : "ROCKY RIDGE", "state" : "OH", "county" : "OTTAWA" },
            "43460": { "city" : "ROSSFORD", "state" : "OH", "county" : "WOOD" },"43462": { "city" : "RUDOLPH", "state" : "OH", "county" : "WOOD" },
            "43463": { "city" : "STONY RIDGE", "state" : "OH", "county" : "WOOD" },
            "43464": { "city" : "VICKERY", "state" : "OH", "county" : "SANDUSKY" },
            "43465": { "city" : "WALBRIDGE", "state" : "OH", "county" : "WOOD" },
            "43466": { "city" : "WAYNE", "state" : "OH", "county" : "WOOD" },"43468": { "city" : "WILLISTON", "state" : "OH", "county" : "OTTAWA" },
            "43469": { "city" : "WOODVILLE", "state" : "OH", "county" : "SANDUSKY" },
            "43501": { "city" : "ALVORDTON", "state" : "OH", "county" : "WILLIAMS" },
            "43502": { "city" : "ARCHBOLD", "state" : "OH", "county" : "FULTON" },
            "43504": { "city" : "BERKEY", "state" : "OH", "county" : "LUCAS" },"43505": { "city" : "BLAKESLEE", "state" : "OH", "county" : "WILLIAMS" },
            "43506": { "city" : "BRYAN", "state" : "OH", "county" : "WILLIAMS" },
            "43511": { "city" : "CUSTAR", "state" : "OH", "county" : "WOOD" },"43512": { "city" : "DEFIANCE", "state" : "OH", "county" : "DEFIANCE" },
            "43515": { "city" : "DELTA", "state" : "OH", "county" : "FULTON" },"43516": { "city" : "DESHLER", "state" : "OH", "county" : "HENRY" },
            "43517": { "city" : "EDGERTON", "state" : "OH", "county" : "WILLIAMS" },
            "43518": { "city" : "EDON", "state" : "OH", "county" : "WILLIAMS" },"43519": { "city" : "EVANSPORT", "state" : "OH", "county" : "DEFIANCE" },
            "43520": { "city" : "FARMER", "state" : "OH", "county" : "DEFIANCE" },
            "43521": { "city" : "FAYETTE", "state" : "OH", "county" : "FULTON" },
            "43522": { "city" : "GRAND RAPIDS", "state" : "OH", "county" : "WOOD" },
            "43523": { "city" : "GRELTON", "state" : "OH", "county" : "HENRY" },"43524": { "city" : "HAMLER", "state" : "OH", "county" : "HENRY" },
            "43525": { "city" : "HASKINS", "state" : "OH", "county" : "WOOD" },"43526": { "city" : "HICKSVILLE", "state" : "OH", "county" : "DEFIANCE" },
            "43527": { "city" : "HOLGATE", "state" : "OH", "county" : "HENRY" },"43528": { "city" : "HOLLAND", "state" : "OH", "county" : "LUCAS" },
            "43529": { "city" : "HOYTVILLE", "state" : "OH", "county" : "WOOD" },
            "43530": { "city" : "JEWELL", "state" : "OH", "county" : "DEFIANCE" },
            "43531": { "city" : "KUNKLE", "state" : "OH", "county" : "WILLIAMS" },
            "43532": { "city" : "LIBERTY CENTER", "state" : "OH", "county" : "HENRY" },
            "43533": { "city" : "LYONS", "state" : "OH", "county" : "FULTON" },"43534": { "city" : "MC CLURE", "state" : "OH", "county" : "HENRY" },
            "43535": { "city" : "MALINTA", "state" : "OH", "county" : "HENRY" },"43536": { "city" : "MARK CENTER", "state" : "OH", "county" : "DEFIANCE" },
            "43537": { "city" : "MAUMEE", "state" : "OH", "county" : "LUCAS" },"43540": { "city" : "METAMORA", "state" : "OH", "county" : "FULTON" },
            "43541": { "city" : "MILTON CENTER", "state" : "OH", "county" : "WOOD" },
            "43542": { "city" : "MONCLOVA", "state" : "OH", "county" : "LUCAS" },
            "43543": { "city" : "MONTPELIER", "state" : "OH", "county" : "WILLIAMS" },
            "43545": { "city" : "NAPOLEON", "state" : "OH", "county" : "HENRY" },
            "43547": { "city" : "NEAPOLIS", "state" : "OH", "county" : "LUCAS" },
            "43548": { "city" : "NEW BAVARIA", "state" : "OH", "county" : "HENRY" },
            "43549": { "city" : "NEY", "state" : "OH", "county" : "DEFIANCE" },"43550": { "city" : "OKOLONA", "state" : "OH", "county" : "HENRY" },
            "43551": { "city" : "PERRYSBURG", "state" : "OH", "county" : "WOOD" },
            "43552": { "city" : "PERRYSBURG", "state" : "OH", "county" : "WOOD" },
            "43553": { "city" : "PETTISVILLE", "state" : "OH", "county" : "FULTON" },
            "43554": { "city" : "PIONEER", "state" : "OH", "county" : "WILLIAMS" },
            "43555": { "city" : "RIDGEVILLE CORNERS", "state" : "OH", "county" : "HENRY" },
            "43556": { "city" : "SHERWOOD", "state" : "OH", "county" : "DEFIANCE" },
            "43557": { "city" : "STRYKER", "state" : "OH", "county" : "WILLIAMS" },
            "43558": { "city" : "SWANTON", "state" : "OH", "county" : "FULTON" },
            "43560": { "city" : "SYLVANIA", "state" : "OH", "county" : "LUCAS" },
            "43565": { "city" : "TONTOGANY", "state" : "OH", "county" : "WOOD" },
            "43566": { "city" : "WATERVILLE", "state" : "OH", "county" : "LUCAS" },
            "43567": { "city" : "WAUSEON", "state" : "OH", "county" : "FULTON" },
            "43569": { "city" : "WESTON", "state" : "OH", "county" : "WOOD" },"43570": { "city" : "WEST UNITY", "state" : "OH", "county" : "WILLIAMS" },
            "43571": { "city" : "WHITEHOUSE", "state" : "OH", "county" : "LUCAS" },
            "43601": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43603": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43604": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43605": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43606": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43607": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43608": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43609": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43610": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43611": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43612": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43613": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43614": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43615": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43616": { "city" : "OREGON", "state" : "OH", "county" : "LUCAS" },"43617": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43618": { "city" : "OREGON", "state" : "OH", "county" : "LUCAS" },"43619": { "city" : "NORTHWOOD", "state" : "OH", "county" : "WOOD" },
            "43620": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43623": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43635": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43652": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43659": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43660": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43697": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },"43699": { "city" : "TOLEDO", "state" : "OH", "county" : "LUCAS" },
            "43701": { "city" : "ZANESVILLE", "state" : "OH", "county" : "MUSKINGUM" },
            "43702": { "city" : "ZANESVILLE", "state" : "OH", "county" : "MUSKINGUM" },
            "43711": { "city" : "AVA", "state" : "OH", "county" : "NOBLE" },"43713": { "city" : "BARNESVILLE", "state" : "OH", "county" : "BELMONT" },
            "43716": { "city" : "BEALLSVILLE", "state" : "OH", "county" : "MONROE" },
            "43717": { "city" : "BELLE VALLEY", "state" : "OH", "county" : "NOBLE" },
            "43718": { "city" : "BELMONT", "state" : "OH", "county" : "BELMONT" },
            "43719": { "city" : "BETHESDA", "state" : "OH", "county" : "BELMONT" },
            "43720": { "city" : "BLUE ROCK", "state" : "OH", "county" : "MUSKINGUM" },
            "43721": { "city" : "BROWNSVILLE", "state" : "OH", "county" : "LICKING" },
            "43722": { "city" : "BUFFALO", "state" : "OH", "county" : "GUERNSEY" },
            "43723": { "city" : "BYESVILLE", "state" : "OH", "county" : "GUERNSEY" },
            "43724": { "city" : "CALDWELL", "state" : "OH", "county" : "NOBLE" },
            "43725": { "city" : "CAMBRIDGE", "state" : "OH", "county" : "GUERNSEY" },
            "43727": { "city" : "CHANDLERSVILLE", "state" : "OH", "county" : "MUSKINGUM" },
            "43728": { "city" : "CHESTERHILL", "state" : "OH", "county" : "MORGAN" },
            "43730": { "city" : "CORNING", "state" : "OH", "county" : "PERRY" },"43731": { "city" : "CROOKSVILLE", "state" : "OH", "county" : "PERRY" },
            "43732": { "city" : "CUMBERLAND", "state" : "OH", "county" : "GUERNSEY" },
            "43733": { "city" : "DERWENT", "state" : "OH", "county" : "GUERNSEY" },
            "43734": { "city" : "DUNCAN FALLS", "state" : "OH", "county" : "MUSKINGUM" },
            "43735": { "city" : "EAST FULTONHAM", "state" : "OH", "county" : "MUSKINGUM" },
            "43738": { "city" : "FULTONHAM", "state" : "OH", "county" : "MUSKINGUM" },
            "43739": { "city" : "GLENFORD", "state" : "OH", "county" : "PERRY" },
            "43740": { "city" : "GRATIOT", "state" : "OH", "county" : "LICKING" },
            "43746": { "city" : "HOPEWELL", "state" : "OH", "county" : "MUSKINGUM" },
            "43747": { "city" : "JERUSALEM", "state" : "OH", "county" : "MONROE" },
            "43748": { "city" : "JUNCTION CITY", "state" : "OH", "county" : "PERRY" },
            "43749": { "city" : "KIMBOLTON", "state" : "OH", "county" : "GUERNSEY" },
            "43750": { "city" : "KIPLING", "state" : "OH", "county" : "GUERNSEY" },
            "43752": { "city" : "LAINGS", "state" : "OH", "county" : "MONROE" },"43754": { "city" : "LEWISVILLE", "state" : "OH", "county" : "MONROE" },
            "43755": { "city" : "LORE CITY", "state" : "OH", "county" : "GUERNSEY" },
            "43756": { "city" : "MCCONNELSVILLE", "state" : "OH", "county" : "MORGAN" },
            "43757": { "city" : "MALAGA", "state" : "OH", "county" : "MONROE" },"43758": { "city" : "MALTA", "state" : "OH", "county" : "MORGAN" },
            "43759": { "city" : "MORRISTOWN", "state" : "OH", "county" : "BELMONT" },
            "43760": { "city" : "MOUNT PERRY", "state" : "OH", "county" : "PERRY" },
            "43761": { "city" : "MOXAHALA", "state" : "OH", "county" : "PERRY" },
            "43762": { "city" : "NEW CONCORD", "state" : "OH", "county" : "MUSKINGUM" },
            "43764": { "city" : "NEW LEXINGTON", "state" : "OH", "county" : "PERRY" },
            "43766": { "city" : "NEW STRAITSVILLE", "state" : "OH", "county" : "PERRY" },
            "43767": { "city" : "NORWICH", "state" : "OH", "county" : "MUSKINGUM" },
            "43768": { "city" : "OLD WASHINGTON", "state" : "OH", "county" : "GUERNSEY" },
            "43771": { "city" : "PHILO", "state" : "OH", "county" : "MUSKINGUM" },
            "43772": { "city" : "PLEASANT CITY", "state" : "OH", "county" : "GUERNSEY" },
            "43773": { "city" : "QUAKER CITY", "state" : "OH", "county" : "GUERNSEY" },
            "43777": { "city" : "ROSEVILLE", "state" : "OH", "county" : "MUSKINGUM" },
            "43778": { "city" : "SALESVILLE", "state" : "OH", "county" : "GUERNSEY" },
            "43779": { "city" : "SARAHSVILLE", "state" : "OH", "county" : "NOBLE" },
            "43780": { "city" : "SENECAVILLE", "state" : "OH", "county" : "GUERNSEY" },
            "43782": { "city" : "SHAWNEE", "state" : "OH", "county" : "PERRY" },"43783": { "city" : "SOMERSET", "state" : "OH", "county" : "PERRY" },
            "43786": { "city" : "STAFFORD", "state" : "OH", "county" : "MONROE" },
            "43787": { "city" : "STOCKPORT", "state" : "OH", "county" : "MORGAN" },
            "43788": { "city" : "SUMMERFIELD", "state" : "OH", "county" : "NOBLE" },
            "43791": { "city" : "WHITE COTTAGE", "state" : "OH", "county" : "MUSKINGUM" },
            "43793": { "city" : "WOODSFIELD", "state" : "OH", "county" : "MONROE" },
            "43802": { "city" : "ADAMSVILLE", "state" : "OH", "county" : "MUSKINGUM" },
            "43803": { "city" : "BAKERSVILLE", "state" : "OH", "county" : "COSHOCTON" },
            "43804": { "city" : "BALTIC", "state" : "OH", "county" : "TUSCARAWAS" },
            "43805": { "city" : "BLISSFIELD", "state" : "OH", "county" : "COSHOCTON" },
            "43811": { "city" : "CONESVILLE", "state" : "OH", "county" : "COSHOCTON" },
            "43812": { "city" : "COSHOCTON", "state" : "OH", "county" : "COSHOCTON" },
            "43821": { "city" : "DRESDEN", "state" : "OH", "county" : "MUSKINGUM" },
            "43822": { "city" : "FRAZEYSBURG", "state" : "OH", "county" : "MUSKINGUM" },
            "43824": { "city" : "FRESNO", "state" : "OH", "county" : "COSHOCTON" },
            "43830": { "city" : "NASHPORT", "state" : "OH", "county" : "MUSKINGUM" },
            "43832": { "city" : "NEWCOMERSTOWN", "state" : "OH", "county" : "TUSCARAWAS" },
            "43836": { "city" : "PLAINFIELD", "state" : "OH", "county" : "COSHOCTON" },
            "43837": { "city" : "PORT WASHINGTON", "state" : "OH", "county" : "TUSCARAWAS" },
            "43840": { "city" : "STONE CREEK", "state" : "OH", "county" : "TUSCARAWAS" },
            "43842": { "city" : "TRINWAY", "state" : "OH", "county" : "MUSKINGUM" },
            "43843": { "city" : "WALHONDING", "state" : "OH", "county" : "COSHOCTON" },
            "43844": { "city" : "WARSAW", "state" : "OH", "county" : "COSHOCTON" },
            "43845": { "city" : "WEST LAFAYETTE", "state" : "OH", "county" : "COSHOCTON" },
            "43901": { "city" : "ADENA", "state" : "OH", "county" : "JEFFERSON" },
            "43902": { "city" : "ALLEDONIA", "state" : "OH", "county" : "BELMONT" },
            "43903": { "city" : "AMSTERDAM", "state" : "OH", "county" : "JEFFERSON" },
            "43905": { "city" : "BARTON", "state" : "OH", "county" : "BELMONT" },
            "43906": { "city" : "BELLAIRE", "state" : "OH", "county" : "BELMONT" },
            "43907": { "city" : "CADIZ", "state" : "OH", "county" : "HARRISON" },
            "43908": { "city" : "BERGHOLZ", "state" : "OH", "county" : "JEFFERSON" },
            "43909": { "city" : "BLAINE", "state" : "OH", "county" : "BELMONT" },
            "43910": { "city" : "BLOOMINGDALE", "state" : "OH", "county" : "JEFFERSON" },
            "43912": { "city" : "BRIDGEPORT", "state" : "OH", "county" : "BELMONT" },
            "43913": { "city" : "BRILLIANT", "state" : "OH", "county" : "JEFFERSON" },
            "43914": { "city" : "CAMERON", "state" : "OH", "county" : "MONROE" },
            "43915": { "city" : "CLARINGTON", "state" : "OH", "county" : "MONROE" },
            "43916": { "city" : "COLERAIN", "state" : "OH", "county" : "BELMONT" },
            "43917": { "city" : "DILLONVALE", "state" : "OH", "county" : "JEFFERSON" },
            "43920": { "city" : "EAST LIVERPOOL", "state" : "OH", "county" : "COLUMBIANA" },
            "43925": { "city" : "EAST SPRINGFIELD", "state" : "OH", "county" : "JEFFERSON" },
            "43926": { "city" : "EMPIRE", "state" : "OH", "county" : "JEFFERSON" },
            "43927": { "city" : "FAIRPOINT", "state" : "OH", "county" : "BELMONT" },
            "43928": { "city" : "GLENCOE", "state" : "OH", "county" : "BELMONT" },
            "43930": { "city" : "HAMMONDSVILLE", "state" : "OH", "county" : "JEFFERSON" },
            "43931": { "city" : "HANNIBAL", "state" : "OH", "county" : "MONROE" },
            "43932": { "city" : "IRONDALE", "state" : "OH", "county" : "JEFFERSON" },
            "43933": { "city" : "JACOBSBURG", "state" : "OH", "county" : "BELMONT" },
            "43934": { "city" : "LANSING", "state" : "OH", "county" : "BELMONT" },
            "43935": { "city" : "MARTINS FERRY", "state" : "OH", "county" : "BELMONT" },
            "43937": { "city" : "MAYNARD", "state" : "OH", "county" : "BELMONT" },
            "43938": { "city" : "MINGO JUNCTION", "state" : "OH", "county" : "JEFFERSON" },
            "43939": { "city" : "MOUNT PLEASANT", "state" : "OH", "county" : "JEFFERSON" },
            "43940": { "city" : "NEFFS", "state" : "OH", "county" : "BELMONT" },"43942": { "city" : "POWHATAN POINT", "state" : "OH", "county" : "BELMONT" },
            "43943": { "city" : "RAYLAND", "state" : "OH", "county" : "JEFFERSON" },
            "43944": { "city" : "RICHMOND", "state" : "OH", "county" : "JEFFERSON" },
            "43945": { "city" : "SALINEVILLE", "state" : "OH", "county" : "COLUMBIANA" },
            "43946": { "city" : "SARDIS", "state" : "OH", "county" : "MONROE" },"43947": { "city" : "SHADYSIDE", "state" : "OH", "county" : "BELMONT" },
            "43948": { "city" : "SMITHFIELD", "state" : "OH", "county" : "JEFFERSON" },
            "43950": { "city" : "SAINT CLAIRSVILLE", "state" : "OH", "county" : "BELMONT" },
            "43951": { "city" : "LAFFERTY", "state" : "OH", "county" : "BELMONT" },
            "43952": { "city" : "STEUBENVILLE", "state" : "OH", "county" : "JEFFERSON" },
            "43953": { "city" : "STEUBENVILLE", "state" : "OH", "county" : "JEFFERSON" },
            "43961": { "city" : "STRATTON", "state" : "OH", "county" : "JEFFERSON" },
            "43962": { "city" : "SUMMITVILLE", "state" : "OH", "county" : "COLUMBIANA" },
            "43963": { "city" : "TILTONSVILLE", "state" : "OH", "county" : "JEFFERSON" },
            "43964": { "city" : "TORONTO", "state" : "OH", "county" : "JEFFERSON" },
            "43967": { "city" : "WARNOCK", "state" : "OH", "county" : "BELMONT" },
            "43968": { "city" : "WELLSVILLE", "state" : "OH", "county" : "COLUMBIANA" },
            "43971": { "city" : "YORKVILLE", "state" : "OH", "county" : "JEFFERSON" },
            "43972": { "city" : "BANNOCK", "state" : "OH", "county" : "BELMONT" },
            "43973": { "city" : "FREEPORT", "state" : "OH", "county" : "HARRISON" },
            "43974": { "city" : "HARRISVILLE", "state" : "OH", "county" : "HARRISON" },
            "43976": { "city" : "HOPEDALE", "state" : "OH", "county" : "HARRISON" },
            "43977": { "city" : "FLUSHING", "state" : "OH", "county" : "BELMONT" },
            "43981": { "city" : "NEW ATHENS", "state" : "OH", "county" : "HARRISON" },
            "43983": { "city" : "PIEDMONT", "state" : "OH", "county" : "BELMONT" },
            "43986": { "city" : "JEWETT", "state" : "OH", "county" : "HARRISON" },
            "43988": { "city" : "SCIO", "state" : "OH", "county" : "HARRISON" },"44001": { "city" : "AMHERST", "state" : "OH", "county" : "LORAIN" },
            "44003": { "city" : "ANDOVER", "state" : "OH", "county" : "ASHTABULA" },
            "44004": { "city" : "ASHTABULA", "state" : "OH", "county" : "ASHTABULA" },
            "44005": { "city" : "ASHTABULA", "state" : "OH", "county" : "ASHTABULA" },
            "44010": { "city" : "AUSTINBURG", "state" : "OH", "county" : "ASHTABULA" },
            "44011": { "city" : "AVON", "state" : "OH", "county" : "LORAIN" },"44012": { "city" : "AVON LAKE", "state" : "OH", "county" : "LORAIN" },
            "44017": { "city" : "BEREA", "state" : "OH", "county" : "CUYAHOGA" },
            "44021": { "city" : "BURTON", "state" : "OH", "county" : "GEAUGA" },"44022": { "city" : "CHAGRIN FALLS", "state" : "OH", "county" : "CUYAHOGA" },
            "44023": { "city" : "CHAGRIN FALLS", "state" : "OH", "county" : "GEAUGA" },
            "44024": { "city" : "CHARDON", "state" : "OH", "county" : "GEAUGA" },
            "44026": { "city" : "CHESTERLAND", "state" : "OH", "county" : "GEAUGA" },
            "44028": { "city" : "COLUMBIA STATION", "state" : "OH", "county" : "LORAIN" },
            "44030": { "city" : "CONNEAUT", "state" : "OH", "county" : "ASHTABULA" },
            "44032": { "city" : "DORSET", "state" : "OH", "county" : "ASHTABULA" },
            "44033": { "city" : "EAST CLARIDON", "state" : "OH", "county" : "GEAUGA" },
            "44035": { "city" : "ELYRIA", "state" : "OH", "county" : "LORAIN" },"44036": { "city" : "ELYRIA", "state" : "OH", "county" : "LORAIN" },
            "44039": { "city" : "NORTH RIDGEVILLE", "state" : "OH", "county" : "LORAIN" },
            "44040": { "city" : "GATES MILLS", "state" : "OH", "county" : "CUYAHOGA" },
            "44041": { "city" : "GENEVA", "state" : "OH", "county" : "ASHTABULA" },
            "44044": { "city" : "GRAFTON", "state" : "OH", "county" : "LORAIN" },
            "44045": { "city" : "GRAND RIVER", "state" : "OH", "county" : "LAKE" },
            "44046": { "city" : "HUNTSBURG", "state" : "OH", "county" : "GEAUGA" },
            "44047": { "city" : "JEFFERSON", "state" : "OH", "county" : "ASHTABULA" },
            "44048": { "city" : "KINGSVILLE", "state" : "OH", "county" : "ASHTABULA" },
            "44049": { "city" : "KIPTON", "state" : "OH", "county" : "LORAIN" },"44050": { "city" : "LAGRANGE", "state" : "OH", "county" : "LORAIN" },
            "44052": { "city" : "LORAIN", "state" : "OH", "county" : "LORAIN" },"44053": { "city" : "LORAIN", "state" : "OH", "county" : "LORAIN" },
            "44054": { "city" : "SHEFFIELD LAKE", "state" : "OH", "county" : "LORAIN" },
            "44055": { "city" : "LORAIN", "state" : "OH", "county" : "LORAIN" },"44056": { "city" : "MACEDONIA", "state" : "OH", "county" : "SUMMIT" },
            "44057": { "city" : "MADISON", "state" : "OH", "county" : "LAKE" },"44060": { "city" : "MENTOR", "state" : "OH", "county" : "LAKE" },
            "44061": { "city" : "MENTOR", "state" : "OH", "county" : "LAKE" },"44062": { "city" : "MIDDLEFIELD", "state" : "OH", "county" : "GEAUGA" },
            "44064": { "city" : "MONTVILLE", "state" : "OH", "county" : "GEAUGA" },
            "44065": { "city" : "NEWBURY", "state" : "OH", "county" : "GEAUGA" },
            "44067": { "city" : "NORTHFIELD", "state" : "OH", "county" : "SUMMIT" },
            "44068": { "city" : "NORTH KINGSVILLE", "state" : "OH", "county" : "ASHTABULA" },
            "44070": { "city" : "NORTH OLMSTED", "state" : "OH", "county" : "CUYAHOGA" },
            "44072": { "city" : "NOVELTY", "state" : "OH", "county" : "GEAUGA" },
            "44073": { "city" : "NOVELTY", "state" : "OH", "county" : "GEAUGA" },
            "44074": { "city" : "OBERLIN", "state" : "OH", "county" : "LORAIN" },
            "44076": { "city" : "ORWELL", "state" : "OH", "county" : "ASHTABULA" },
            "44077": { "city" : "PAINESVILLE", "state" : "OH", "county" : "LAKE" },
            "44080": { "city" : "PARKMAN", "state" : "OH", "county" : "GEAUGA" },
            "44081": { "city" : "PERRY", "state" : "OH", "county" : "LAKE" },"44082": { "city" : "PIERPONT", "state" : "OH", "county" : "ASHTABULA" },
            "44084": { "city" : "ROCK CREEK", "state" : "OH", "county" : "ASHTABULA" },
            "44085": { "city" : "ROME", "state" : "OH", "county" : "ASHTABULA" },
            "44086": { "city" : "THOMPSON", "state" : "OH", "county" : "GEAUGA" },
            "44087": { "city" : "TWINSBURG", "state" : "OH", "county" : "SUMMIT" },
            "44088": { "city" : "UNIONVILLE", "state" : "OH", "county" : "ASHTABULA" },
            "44089": { "city" : "VERMILION", "state" : "OH", "county" : "ERIE" },
            "44090": { "city" : "WELLINGTON", "state" : "OH", "county" : "LORAIN" },
            "44092": { "city" : "WICKLIFFE", "state" : "OH", "county" : "LAKE" },
            "44093": { "city" : "WILLIAMSFIELD", "state" : "OH", "county" : "ASHTABULA" },
            "44094": { "city" : "WILLOUGHBY", "state" : "OH", "county" : "LAKE" },
            "44095": { "city" : "EASTLAKE", "state" : "OH", "county" : "LAKE" },"44096": { "city" : "WILLOUGHBY", "state" : "OH", "county" : "LAKE" },
            "44097": { "city" : "EASTLAKE", "state" : "OH", "county" : "LAKE" },"44099": { "city" : "WINDSOR", "state" : "OH", "county" : "ASHTABULA" },
            "44101": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44102": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44103": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44104": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44105": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44106": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44107": { "city" : "LAKEWOOD", "state" : "OH", "county" : "CUYAHOGA" },
            "44108": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44109": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44110": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44111": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44112": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44113": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44114": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44115": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44116": { "city" : "ROCKY RIVER", "state" : "OH", "county" : "CUYAHOGA" },
            "44117": { "city" : "EUCLID", "state" : "OH", "county" : "CUYAHOGA" },
            "44118": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44119": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44120": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44121": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44122": { "city" : "BEACHWOOD", "state" : "OH", "county" : "CUYAHOGA" },
            "44123": { "city" : "EUCLID", "state" : "OH", "county" : "CUYAHOGA" },
            "44124": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44125": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44126": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44127": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44128": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44129": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44130": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44131": { "city" : "INDEPENDENCE", "state" : "OH", "county" : "CUYAHOGA" },
            "44132": { "city" : "EUCLID", "state" : "OH", "county" : "CUYAHOGA" },
            "44133": { "city" : "NORTH ROYALTON", "state" : "OH", "county" : "CUYAHOGA" },
            "44134": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44135": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44136": { "city" : "STRONGSVILLE", "state" : "OH", "county" : "CUYAHOGA" },
            "44137": { "city" : "MAPLE HEIGHTS", "state" : "OH", "county" : "CUYAHOGA" },
            "44138": { "city" : "OLMSTED FALLS", "state" : "OH", "county" : "CUYAHOGA" },
            "44139": { "city" : "SOLON", "state" : "OH", "county" : "CUYAHOGA" },
            "44140": { "city" : "BAY VILLAGE", "state" : "OH", "county" : "CUYAHOGA" },
            "44141": { "city" : "BRECKSVILLE", "state" : "OH", "county" : "CUYAHOGA" },
            "44142": { "city" : "BROOK PARK", "state" : "OH", "county" : "CUYAHOGA" },
            "44143": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44144": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44145": { "city" : "WESTLAKE", "state" : "OH", "county" : "CUYAHOGA" },
            "44146": { "city" : "BEDFORD", "state" : "OH", "county" : "CUYAHOGA" },
            "44147": { "city" : "BROADVIEW HEIGHTS", "state" : "OH", "county" : "CUYAHOGA" },
            "44149": { "city" : "STRONGSVILLE", "state" : "OH", "county" : "CUYAHOGA" },
            "44181": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44190": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44192": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44193": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44194": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44195": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44199": { "city" : "CLEVELAND", "state" : "OH", "county" : "CUYAHOGA" },
            "44201": { "city" : "ATWATER", "state" : "OH", "county" : "PORTAGE" },
            "44202": { "city" : "AURORA", "state" : "OH", "county" : "PORTAGE" },
            "44203": { "city" : "BARBERTON", "state" : "OH", "county" : "SUMMIT" },
            "44210": { "city" : "BATH", "state" : "OH", "county" : "SUMMIT" },"44211": { "city" : "BRADY LAKE", "state" : "OH", "county" : "PORTAGE" },
            "44212": { "city" : "BRUNSWICK", "state" : "OH", "county" : "MEDINA" },
            "44214": { "city" : "BURBANK", "state" : "OH", "county" : "WAYNE" },"44215": { "city" : "CHIPPEWA LAKE", "state" : "OH", "county" : "MEDINA" },
            "44216": { "city" : "CLINTON", "state" : "OH", "county" : "SUMMIT" },
            "44217": { "city" : "CRESTON", "state" : "OH", "county" : "WAYNE" },"44221": { "city" : "CUYAHOGA FALLS", "state" : "OH", "county" : "SUMMIT" },
            "44222": { "city" : "CUYAHOGA FALLS", "state" : "OH", "county" : "SUMMIT" },
            "44223": { "city" : "CUYAHOGA FALLS", "state" : "OH", "county" : "SUMMIT" },
            "44224": { "city" : "STOW", "state" : "OH", "county" : "SUMMIT" },"44230": { "city" : "DOYLESTOWN", "state" : "OH", "county" : "WAYNE" },
            "44231": { "city" : "GARRETTSVILLE", "state" : "OH", "county" : "PORTAGE" },
            "44232": { "city" : "GREEN", "state" : "OH", "county" : "SUMMIT" },"44233": { "city" : "HINCKLEY", "state" : "OH", "county" : "MEDINA" },
            "44234": { "city" : "HIRAM", "state" : "OH", "county" : "PORTAGE" },"44235": { "city" : "HOMERVILLE", "state" : "OH", "county" : "MEDINA" },
            "44236": { "city" : "HUDSON", "state" : "OH", "county" : "SUMMIT" },"44237": { "city" : "HUDSON", "state" : "OH", "county" : "SUMMIT" },
            "44240": { "city" : "KENT", "state" : "OH", "county" : "PORTAGE" },"44241": { "city" : "STREETSBORO", "state" : "OH", "county" : "PORTAGE" },
            "44242": { "city" : "KENT", "state" : "OH", "county" : "PORTAGE" },"44243": { "city" : "KENT", "state" : "OH", "county" : "PORTAGE" },
            "44250": { "city" : "LAKEMORE", "state" : "OH", "county" : "SUMMIT" },
            "44251": { "city" : "WESTFIELD CENTER", "state" : "OH", "county" : "MEDINA" },
            "44253": { "city" : "LITCHFIELD", "state" : "OH", "county" : "MEDINA" },
            "44254": { "city" : "LODI", "state" : "OH", "county" : "MEDINA" },"44255": { "city" : "MANTUA", "state" : "OH", "county" : "PORTAGE" },
            "44256": { "city" : "MEDINA", "state" : "OH", "county" : "MEDINA" },"44258": { "city" : "MEDINA", "state" : "OH", "county" : "MEDINA" },
            "44260": { "city" : "MOGADORE", "state" : "OH", "county" : "PORTAGE" },
            "44262": { "city" : "MUNROE FALLS", "state" : "OH", "county" : "SUMMIT" },
            "44264": { "city" : "PENINSULA", "state" : "OH", "county" : "SUMMIT" },
            "44265": { "city" : "RANDOLPH", "state" : "OH", "county" : "PORTAGE" },
            "44266": { "city" : "RAVENNA", "state" : "OH", "county" : "PORTAGE" },
            "44270": { "city" : "RITTMAN", "state" : "OH", "county" : "WAYNE" },"44272": { "city" : "ROOTSTOWN", "state" : "OH", "county" : "PORTAGE" },
            "44273": { "city" : "SEVILLE", "state" : "OH", "county" : "MEDINA" },
            "44274": { "city" : "SHARON CENTER", "state" : "OH", "county" : "MEDINA" },
            "44275": { "city" : "SPENCER", "state" : "OH", "county" : "MEDINA" },
            "44276": { "city" : "STERLING", "state" : "OH", "county" : "WAYNE" },
            "44278": { "city" : "TALLMADGE", "state" : "OH", "county" : "SUMMIT" },
            "44280": { "city" : "VALLEY CITY", "state" : "OH", "county" : "MEDINA" },
            "44281": { "city" : "WADSWORTH", "state" : "OH", "county" : "MEDINA" },
            "44282": { "city" : "WADSWORTH", "state" : "OH", "county" : "MEDINA" },
            "44285": { "city" : "WAYLAND", "state" : "OH", "county" : "PORTAGE" },
            "44286": { "city" : "RICHFIELD", "state" : "OH", "county" : "SUMMIT" },
            "44287": { "city" : "WEST SALEM", "state" : "OH", "county" : "WAYNE" },
            "44288": { "city" : "WINDHAM", "state" : "OH", "county" : "PORTAGE" },
            "44301": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44302": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44303": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44304": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44305": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44306": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44307": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44308": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44309": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44310": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44311": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44312": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44313": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44314": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44315": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44316": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44317": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44319": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44320": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44321": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44325": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44326": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },
            "44333": { "city" : "AKRON", "state" : "OH", "county" : "SUMMIT" },"44334": { "city" : "FAIRLAWN", "state" : "OH", "county" : "SUMMIT" },
            "44401": { "city" : "BERLIN CENTER", "state" : "OH", "county" : "MAHONING" },
            "44402": { "city" : "BRISTOLVILLE", "state" : "OH", "county" : "TRUMBULL" },
            "44403": { "city" : "BROOKFIELD", "state" : "OH", "county" : "TRUMBULL" },
            "44404": { "city" : "BURGHILL", "state" : "OH", "county" : "TRUMBULL" },
            "44405": { "city" : "CAMPBELL", "state" : "OH", "county" : "MAHONING" },
            "44406": { "city" : "CANFIELD", "state" : "OH", "county" : "MAHONING" },
            "44408": { "city" : "COLUMBIANA", "state" : "OH", "county" : "COLUMBIANA" },
            "44410": { "city" : "CORTLAND", "state" : "OH", "county" : "TRUMBULL" },
            "44411": { "city" : "DEERFIELD", "state" : "OH", "county" : "PORTAGE" },
            "44412": { "city" : "DIAMOND", "state" : "OH", "county" : "PORTAGE" },
            "44413": { "city" : "EAST PALESTINE", "state" : "OH", "county" : "COLUMBIANA" },
            "44415": { "city" : "ELKTON", "state" : "OH", "county" : "COLUMBIANA" },
            "44416": { "city" : "ELLSWORTH", "state" : "OH", "county" : "MAHONING" },
            "44417": { "city" : "FARMDALE", "state" : "OH", "county" : "TRUMBULL" },
            "44418": { "city" : "FOWLER", "state" : "OH", "county" : "TRUMBULL" },
            "44420": { "city" : "GIRARD", "state" : "OH", "county" : "TRUMBULL" },
            "44422": { "city" : "GREENFORD", "state" : "OH", "county" : "MAHONING" },
            "44423": { "city" : "HANOVERTON", "state" : "OH", "county" : "COLUMBIANA" },
            "44424": { "city" : "HARTFORD", "state" : "OH", "county" : "TRUMBULL" },
            "44425": { "city" : "HUBBARD", "state" : "OH", "county" : "TRUMBULL" },
            "44427": { "city" : "KENSINGTON", "state" : "OH", "county" : "COLUMBIANA" },
            "44428": { "city" : "KINSMAN", "state" : "OH", "county" : "TRUMBULL" },
            "44429": { "city" : "LAKE MILTON", "state" : "OH", "county" : "MAHONING" },
            "44430": { "city" : "LEAVITTSBURG", "state" : "OH", "county" : "TRUMBULL" },
            "44431": { "city" : "LEETONIA", "state" : "OH", "county" : "COLUMBIANA" },
            "44432": { "city" : "LISBON", "state" : "OH", "county" : "COLUMBIANA" },
            "44436": { "city" : "LOWELLVILLE", "state" : "OH", "county" : "MAHONING" },
            "44437": { "city" : "MC DONALD", "state" : "OH", "county" : "TRUMBULL" },
            "44438": { "city" : "MASURY", "state" : "OH", "county" : "TRUMBULL" },
            "44439": { "city" : "MESOPOTAMIA", "state" : "OH", "county" : "TRUMBULL" },
            "44440": { "city" : "MINERAL RIDGE", "state" : "OH", "county" : "TRUMBULL" },
            "44441": { "city" : "NEGLEY", "state" : "OH", "county" : "COLUMBIANA" },
            "44442": { "city" : "NEW MIDDLETOWN", "state" : "OH", "county" : "MAHONING" },
            "44443": { "city" : "NEW SPRINGFIELD", "state" : "OH", "county" : "MAHONING" },
            "44444": { "city" : "NEWTON FALLS", "state" : "OH", "county" : "TRUMBULL" },
            "44445": { "city" : "NEW WATERFORD", "state" : "OH", "county" : "COLUMBIANA" },
            "44446": { "city" : "NILES", "state" : "OH", "county" : "TRUMBULL" },
            "44449": { "city" : "NORTH BENTON", "state" : "OH", "county" : "PORTAGE" },
            "44450": { "city" : "NORTH BLOOMFIELD", "state" : "OH", "county" : "TRUMBULL" },
            "44451": { "city" : "NORTH JACKSON", "state" : "OH", "county" : "MAHONING" },
            "44452": { "city" : "NORTH LIMA", "state" : "OH", "county" : "MAHONING" },
            "44453": { "city" : "ORANGEVILLE", "state" : "OH", "county" : "TRUMBULL" },
            "44454": { "city" : "PETERSBURG", "state" : "OH", "county" : "MAHONING" },
            "44455": { "city" : "ROGERS", "state" : "OH", "county" : "COLUMBIANA" },
            "44460": { "city" : "SALEM", "state" : "OH", "county" : "COLUMBIANA" },
            "44470": { "city" : "SOUTHINGTON", "state" : "OH", "county" : "TRUMBULL" },
            "44471": { "city" : "STRUTHERS", "state" : "OH", "county" : "MAHONING" },
            "44473": { "city" : "VIENNA", "state" : "OH", "county" : "TRUMBULL" },
            "44481": { "city" : "WARREN", "state" : "OH", "county" : "TRUMBULL" },
            "44482": { "city" : "WARREN", "state" : "OH", "county" : "TRUMBULL" },
            "44483": { "city" : "WARREN", "state" : "OH", "county" : "TRUMBULL" },
            "44484": { "city" : "WARREN", "state" : "OH", "county" : "TRUMBULL" },
            "44485": { "city" : "WARREN", "state" : "OH", "county" : "TRUMBULL" },
            "44488": { "city" : "WARREN", "state" : "OH", "county" : "TRUMBULL" },
            "44490": { "city" : "WASHINGTONVILLE", "state" : "OH", "county" : "COLUMBIANA" },
            "44491": { "city" : "WEST FARMINGTON", "state" : "OH", "county" : "TRUMBULL" },
            "44492": { "city" : "WEST POINT", "state" : "OH", "county" : "COLUMBIANA" },
            "44493": { "city" : "WINONA", "state" : "OH", "county" : "COLUMBIANA" },
            "44501": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44502": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44503": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44504": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44505": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44506": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44507": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44509": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44510": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44511": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44512": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44513": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44514": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44515": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44555": { "city" : "YOUNGSTOWN", "state" : "OH", "county" : "MAHONING" },
            "44601": { "city" : "ALLIANCE", "state" : "OH", "county" : "STARK" },
            "44606": { "city" : "APPLE CREEK", "state" : "OH", "county" : "WAYNE" },
            "44607": { "city" : "AUGUSTA", "state" : "OH", "county" : "CARROLL" },
            "44608": { "city" : "BEACH CITY", "state" : "OH", "county" : "STARK" },
            "44609": { "city" : "BELOIT", "state" : "OH", "county" : "MAHONING" },
            "44610": { "city" : "BERLIN", "state" : "OH", "county" : "HOLMES" },"44611": { "city" : "BIG PRAIRIE", "state" : "OH", "county" : "HOLMES" },
            "44612": { "city" : "BOLIVAR", "state" : "OH", "county" : "TUSCARAWAS" },
            "44613": { "city" : "BREWSTER", "state" : "OH", "county" : "STARK" },
            "44614": { "city" : "CANAL FULTON", "state" : "OH", "county" : "STARK" },
            "44615": { "city" : "CARROLLTON", "state" : "OH", "county" : "CARROLL" },
            "44617": { "city" : "CHARM", "state" : "OH", "county" : "HOLMES" },"44618": { "city" : "DALTON", "state" : "OH", "county" : "WAYNE" },
            "44619": { "city" : "DAMASCUS", "state" : "OH", "county" : "MAHONING" },
            "44620": { "city" : "DELLROY", "state" : "OH", "county" : "CARROLL" },
            "44621": { "city" : "DENNISON", "state" : "OH", "county" : "TUSCARAWAS" },
            "44622": { "city" : "DOVER", "state" : "OH", "county" : "TUSCARAWAS" },
            "44624": { "city" : "DUNDEE", "state" : "OH", "county" : "TUSCARAWAS" },
            "44625": { "city" : "EAST ROCHESTER", "state" : "OH", "county" : "COLUMBIANA" },
            "44626": { "city" : "EAST SPARTA", "state" : "OH", "county" : "STARK" },
            "44627": { "city" : "FREDERICKSBURG", "state" : "OH", "county" : "WAYNE" },
            "44628": { "city" : "GLENMONT", "state" : "OH", "county" : "HOLMES" },
            "44629": { "city" : "GNADENHUTTEN", "state" : "OH", "county" : "TUSCARAWAS" },
            "44630": { "city" : "GREENTOWN", "state" : "OH", "county" : "STARK" },
            "44632": { "city" : "HARTVILLE", "state" : "OH", "county" : "STARK" },
            "44633": { "city" : "HOLMESVILLE", "state" : "OH", "county" : "HOLMES" },
            "44634": { "city" : "HOMEWORTH", "state" : "OH", "county" : "COLUMBIANA" },
            "44636": { "city" : "KIDRON", "state" : "OH", "county" : "WAYNE" },"44637": { "city" : "KILLBUCK", "state" : "OH", "county" : "HOLMES" },
            "44638": { "city" : "LAKEVILLE", "state" : "OH", "county" : "HOLMES" },
            "44639": { "city" : "LEESVILLE", "state" : "OH", "county" : "CARROLL" },
            "44640": { "city" : "LIMAVILLE", "state" : "OH", "county" : "STARK" },
            "44641": { "city" : "LOUISVILLE", "state" : "OH", "county" : "STARK" },
            "44643": { "city" : "MAGNOLIA", "state" : "OH", "county" : "STARK" },
            "44644": { "city" : "MALVERN", "state" : "OH", "county" : "CARROLL" },
            "44645": { "city" : "MARSHALLVILLE", "state" : "OH", "county" : "WAYNE" },
            "44646": { "city" : "MASSILLON", "state" : "OH", "county" : "STARK" },
            "44647": { "city" : "MASSILLON", "state" : "OH", "county" : "STARK" },
            "44648": { "city" : "MASSILLON", "state" : "OH", "county" : "STARK" },
            "44650": { "city" : "MAXIMO", "state" : "OH", "county" : "STARK" },"44651": { "city" : "MECHANICSTOWN", "state" : "OH", "county" : "CARROLL" },
            "44652": { "city" : "MIDDLEBRANCH", "state" : "OH", "county" : "STARK" },
            "44653": { "city" : "MIDVALE", "state" : "OH", "county" : "TUSCARAWAS" },
            "44654": { "city" : "MILLERSBURG", "state" : "OH", "county" : "HOLMES" },
            "44656": { "city" : "MINERAL CITY", "state" : "OH", "county" : "TUSCARAWAS" },
            "44657": { "city" : "MINERVA", "state" : "OH", "county" : "STARK" },"44659": { "city" : "MOUNT EATON", "state" : "OH", "county" : "WAYNE" },
            "44660": { "city" : "MOUNT HOPE", "state" : "OH", "county" : "HOLMES" },
            "44661": { "city" : "NASHVILLE", "state" : "OH", "county" : "HOLMES" },
            "44662": { "city" : "NAVARRE", "state" : "OH", "county" : "STARK" },"44663": { "city" : "NEW PHILADELPHIA", "state" : "OH", "county" : "TUSCARAWAS" },
            "44665": { "city" : "NORTH GEORGETOWN", "state" : "OH", "county" : "COLUMBIANA" },
            "44666": { "city" : "NORTH LAWRENCE", "state" : "OH", "county" : "STARK" },
            "44667": { "city" : "ORRVILLE", "state" : "OH", "county" : "WAYNE" },
            "44669": { "city" : "PARIS", "state" : "OH", "county" : "STARK" },"44670": { "city" : "ROBERTSVILLE", "state" : "OH", "county" : "STARK" },
            "44671": { "city" : "SANDYVILLE", "state" : "OH", "county" : "TUSCARAWAS" },
            "44672": { "city" : "SEBRING", "state" : "OH", "county" : "MAHONING" },
            "44675": { "city" : "SHERRODSVILLE", "state" : "OH", "county" : "CARROLL" },
            "44676": { "city" : "SHREVE", "state" : "OH", "county" : "WAYNE" },"44677": { "city" : "SMITHVILLE", "state" : "OH", "county" : "WAYNE" },
            "44678": { "city" : "SOMERDALE", "state" : "OH", "county" : "TUSCARAWAS" },
            "44680": { "city" : "STRASBURG", "state" : "OH", "county" : "TUSCARAWAS" },
            "44681": { "city" : "SUGARCREEK", "state" : "OH", "county" : "TUSCARAWAS" },
            "44682": { "city" : "TUSCARAWAS", "state" : "OH", "county" : "TUSCARAWAS" },
            "44683": { "city" : "UHRICHSVILLE", "state" : "OH", "county" : "TUSCARAWAS" },
            "44685": { "city" : "UNIONTOWN", "state" : "OH", "county" : "STARK" },
            "44687": { "city" : "WALNUT CREEK", "state" : "OH", "county" : "HOLMES" },
            "44688": { "city" : "WAYNESBURG", "state" : "OH", "county" : "STARK" },
            "44689": { "city" : "WILMOT", "state" : "OH", "county" : "STARK" },"44690": { "city" : "WINESBURG", "state" : "OH", "county" : "HOLMES" },
            "44691": { "city" : "WOOSTER", "state" : "OH", "county" : "WAYNE" },"44693": { "city" : "DEERSVILLE", "state" : "OH", "county" : "HARRISON" },
            "44695": { "city" : "BOWERSTON", "state" : "OH", "county" : "HARRISON" },
            "44697": { "city" : "ZOAR", "state" : "OH", "county" : "TUSCARAWAS" },
            "44699": { "city" : "TIPPECANOE", "state" : "OH", "county" : "HARRISON" },
            "44701": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44702": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44703": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44704": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44705": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44706": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44707": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44708": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44709": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44710": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44711": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44714": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44718": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44720": { "city" : "NORTH CANTON", "state" : "OH", "county" : "STARK" },
            "44721": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44730": { "city" : "EAST CANTON", "state" : "OH", "county" : "STARK" },
            "44735": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },"44750": { "city" : "CANTON", "state" : "OH", "county" : "STARK" },
            "44802": { "city" : "ALVADA", "state" : "OH", "county" : "SENECA" },"44804": { "city" : "ARCADIA", "state" : "OH", "county" : "HANCOCK" },
            "44805": { "city" : "ASHLAND", "state" : "OH", "county" : "ASHLAND" },
            "44807": { "city" : "ATTICA", "state" : "OH", "county" : "SENECA" },"44809": { "city" : "BASCOM", "state" : "OH", "county" : "SENECA" },
            "44811": { "city" : "BELLEVUE", "state" : "OH", "county" : "HURON" },
            "44813": { "city" : "BELLVILLE", "state" : "OH", "county" : "RICHLAND" },
            "44814": { "city" : "BERLIN HEIGHTS", "state" : "OH", "county" : "ERIE" },
            "44815": { "city" : "BETTSVILLE", "state" : "OH", "county" : "SENECA" },
            "44816": { "city" : "BIRMINGHAM", "state" : "OH", "county" : "ERIE" },
            "44817": { "city" : "BLOOMDALE", "state" : "OH", "county" : "WOOD" },
            "44818": { "city" : "BLOOMVILLE", "state" : "OH", "county" : "SENECA" },
            "44820": { "city" : "BUCYRUS", "state" : "OH", "county" : "CRAWFORD" },
            "44822": { "city" : "BUTLER", "state" : "OH", "county" : "RICHLAND" },
            "44824": { "city" : "CASTALIA", "state" : "OH", "county" : "ERIE" },"44825": { "city" : "CHATFIELD", "state" : "OH", "county" : "CRAWFORD" },
            "44826": { "city" : "COLLINS", "state" : "OH", "county" : "HURON" },"44827": { "city" : "CRESTLINE", "state" : "OH", "county" : "CRAWFORD" },
            "44828": { "city" : "FLAT ROCK", "state" : "OH", "county" : "SENECA" },
            "44830": { "city" : "FOSTORIA", "state" : "OH", "county" : "SENECA" },
            "44833": { "city" : "GALION", "state" : "OH", "county" : "CRAWFORD" },
            "44836": { "city" : "GREEN SPRINGS", "state" : "OH", "county" : "SENECA" },
            "44837": { "city" : "GREENWICH", "state" : "OH", "county" : "HURON" },
            "44838": { "city" : "HAYESVILLE", "state" : "OH", "county" : "ASHLAND" },
            "44839": { "city" : "HURON", "state" : "OH", "county" : "ERIE" },"44840": { "city" : "JEROMESVILLE", "state" : "OH", "county" : "ASHLAND" },
            "44841": { "city" : "KANSAS", "state" : "OH", "county" : "SENECA" },"44842": { "city" : "LOUDONVILLE", "state" : "OH", "county" : "ASHLAND" },
            "44843": { "city" : "LUCAS", "state" : "OH", "county" : "RICHLAND" },
            "44844": { "city" : "MC CUTCHENVILLE", "state" : "OH", "county" : "WYANDOT" },
            "44845": { "city" : "MELMORE", "state" : "OH", "county" : "SENECA" },
            "44846": { "city" : "MILAN", "state" : "OH", "county" : "ERIE" },"44847": { "city" : "MONROEVILLE", "state" : "OH", "county" : "HURON" },
            "44848": { "city" : "NANKIN", "state" : "OH", "county" : "ASHLAND" },
            "44849": { "city" : "NEVADA", "state" : "OH", "county" : "WYANDOT" },
            "44850": { "city" : "NEW HAVEN", "state" : "OH", "county" : "HURON" },
            "44851": { "city" : "NEW LONDON", "state" : "OH", "county" : "HURON" },
            "44853": { "city" : "NEW RIEGEL", "state" : "OH", "county" : "SENECA" },
            "44854": { "city" : "NEW WASHINGTON", "state" : "OH", "county" : "CRAWFORD" },
            "44855": { "city" : "NORTH FAIRFIELD", "state" : "OH", "county" : "HURON" },
            "44856": { "city" : "NORTH ROBINSON", "state" : "OH", "county" : "CRAWFORD" },
            "44857": { "city" : "NORWALK", "state" : "OH", "county" : "HURON" },"44859": { "city" : "NOVA", "state" : "OH", "county" : "ASHLAND" },
            "44861": { "city" : "OLD FORT", "state" : "OH", "county" : "SENECA" },
            "44862": { "city" : "ONTARIO", "state" : "OH", "county" : "RICHLAND" },
            "44864": { "city" : "PERRYSVILLE", "state" : "OH", "county" : "ASHLAND" },
            "44865": { "city" : "PLYMOUTH", "state" : "OH", "county" : "HURON" },
            "44866": { "city" : "POLK", "state" : "OH", "county" : "ASHLAND" },"44867": { "city" : "REPUBLIC", "state" : "OH", "county" : "SENECA" },
            "44870": { "city" : "SANDUSKY", "state" : "OH", "county" : "ERIE" },"44871": { "city" : "SANDUSKY", "state" : "OH", "county" : "ERIE" },
            "44874": { "city" : "SAVANNAH", "state" : "OH", "county" : "ASHLAND" },
            "44875": { "city" : "SHELBY", "state" : "OH", "county" : "RICHLAND" },
            "44878": { "city" : "SHILOH", "state" : "OH", "county" : "RICHLAND" },
            "44880": { "city" : "SULLIVAN", "state" : "OH", "county" : "ASHLAND" },
            "44881": { "city" : "SULPHUR SPRINGS", "state" : "OH", "county" : "CRAWFORD" },
            "44882": { "city" : "SYCAMORE", "state" : "OH", "county" : "WYANDOT" },
            "44883": { "city" : "TIFFIN", "state" : "OH", "county" : "SENECA" },"44887": { "city" : "TIRO", "state" : "OH", "county" : "CRAWFORD" },
            "44888": { "city" : "WILLARD", "state" : "OH", "county" : "HURON" },"44889": { "city" : "WAKEMAN", "state" : "OH", "county" : "HURON" },
            "44890": { "city" : "WILLARD", "state" : "OH", "county" : "HURON" },"44901": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "44902": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "44903": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "44904": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "44905": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "44906": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "44907": { "city" : "MANSFIELD", "state" : "OH", "county" : "RICHLAND" },
            "45001": { "city" : "ADDYSTON", "state" : "OH", "county" : "HAMILTON" },
            "45002": { "city" : "CLEVES", "state" : "OH", "county" : "HAMILTON" },
            "45003": { "city" : "COLLEGE CORNER", "state" : "OH", "county" : "BUTLER" },
            "45004": { "city" : "COLLINSVILLE", "state" : "OH", "county" : "BUTLER" },
            "45005": { "city" : "FRANKLIN", "state" : "OH", "county" : "WARREN" },
            "45011": { "city" : "HAMILTON", "state" : "OH", "county" : "BUTLER" },
            "45012": { "city" : "HAMILTON", "state" : "OH", "county" : "BUTLER" },
            "45013": { "city" : "HAMILTON", "state" : "OH", "county" : "BUTLER" },
            "45014": { "city" : "FAIRFIELD", "state" : "OH", "county" : "BUTLER" },
            "45015": { "city" : "HAMILTON", "state" : "OH", "county" : "BUTLER" },
            "45018": { "city" : "FAIRFIELD", "state" : "OH", "county" : "BUTLER" },
            "45026": { "city" : "HAMILTON", "state" : "OH", "county" : "BUTLER" },
            "45030": { "city" : "HARRISON", "state" : "OH", "county" : "HAMILTON" },
            "45032": { "city" : "HARVEYSBURG", "state" : "OH", "county" : "WARREN" },
            "45033": { "city" : "HOOVEN", "state" : "OH", "county" : "HAMILTON" },
            "45034": { "city" : "KINGS MILLS", "state" : "OH", "county" : "WARREN" },
            "45036": { "city" : "LEBANON", "state" : "OH", "county" : "WARREN" },
            "45039": { "city" : "MAINEVILLE", "state" : "OH", "county" : "WARREN" },
            "45040": { "city" : "MASON", "state" : "OH", "county" : "WARREN" },"45041": { "city" : "MIAMITOWN", "state" : "OH", "county" : "HAMILTON" },
            "45042": { "city" : "MIDDLETOWN", "state" : "OH", "county" : "BUTLER" },
            "45043": { "city" : "MIDDLETOWN", "state" : "OH", "county" : "BUTLER" },
            "45044": { "city" : "MIDDLETOWN", "state" : "OH", "county" : "BUTLER" },
            "45050": { "city" : "MONROE", "state" : "OH", "county" : "BUTLER" },"45051": { "city" : "MOUNT SAINT JOSEPH", "state" : "OH", "county" : "HAMILTON" },
            "45052": { "city" : "NORTH BEND", "state" : "OH", "county" : "HAMILTON" },
            "45053": { "city" : "OKEANA", "state" : "OH", "county" : "BUTLER" },"45054": { "city" : "OREGONIA", "state" : "OH", "county" : "WARREN" },
            "45055": { "city" : "OVERPECK", "state" : "OH", "county" : "BUTLER" },
            "45056": { "city" : "OXFORD", "state" : "OH", "county" : "BUTLER" },"45061": { "city" : "ROSS", "state" : "OH", "county" : "BUTLER" },
            "45062": { "city" : "SEVEN MILE", "state" : "OH", "county" : "BUTLER" },
            "45063": { "city" : "SHANDON", "state" : "OH", "county" : "BUTLER" },
            "45064": { "city" : "SOMERVILLE", "state" : "OH", "county" : "BUTLER" },
            "45065": { "city" : "SOUTH LEBANON", "state" : "OH", "county" : "WARREN" },
            "45066": { "city" : "SPRINGBORO", "state" : "OH", "county" : "WARREN" },
            "45067": { "city" : "TRENTON", "state" : "OH", "county" : "BUTLER" },
            "45068": { "city" : "WAYNESVILLE", "state" : "OH", "county" : "WARREN" },
            "45069": { "city" : "WEST CHESTER", "state" : "OH", "county" : "BUTLER" },
            "45070": { "city" : "WEST ELKTON", "state" : "OH", "county" : "PREBLE" },
            "45071": { "city" : "WEST CHESTER", "state" : "OH", "county" : "BUTLER" },
            "45101": { "city" : "ABERDEEN", "state" : "OH", "county" : "BROWN" },
            "45102": { "city" : "AMELIA", "state" : "OH", "county" : "CLERMONT" },
            "45103": { "city" : "BATAVIA", "state" : "OH", "county" : "CLERMONT" },
            "45105": { "city" : "BENTONVILLE", "state" : "OH", "county" : "ADAMS" },
            "45106": { "city" : "BETHEL", "state" : "OH", "county" : "CLERMONT" },
            "45107": { "city" : "BLANCHESTER", "state" : "OH", "county" : "CLINTON" },
            "45110": { "city" : "BUFORD", "state" : "OH", "county" : "HIGHLAND" },
            "45111": { "city" : "CAMP DENNISON", "state" : "OH", "county" : "HAMILTON" },
            "45113": { "city" : "CLARKSVILLE", "state" : "OH", "county" : "CLINTON" },
            "45114": { "city" : "CUBA", "state" : "OH", "county" : "CLINTON" },"45115": { "city" : "DECATUR", "state" : "OH", "county" : "BROWN" },
            "45118": { "city" : "FAYETTEVILLE", "state" : "OH", "county" : "BROWN" },
            "45119": { "city" : "FEESBURG", "state" : "OH", "county" : "BROWN" },
            "45120": { "city" : "FELICITY", "state" : "OH", "county" : "CLERMONT" },
            "45121": { "city" : "GEORGETOWN", "state" : "OH", "county" : "BROWN" },
            "45122": { "city" : "GOSHEN", "state" : "OH", "county" : "CLERMONT" },
            "45123": { "city" : "GREENFIELD", "state" : "OH", "county" : "HIGHLAND" },
            "45130": { "city" : "HAMERSVILLE", "state" : "OH", "county" : "BROWN" },
            "45131": { "city" : "HIGGINSPORT", "state" : "OH", "county" : "BROWN" },
            "45133": { "city" : "HILLSBORO", "state" : "OH", "county" : "HIGHLAND" },
            "45135": { "city" : "LEESBURG", "state" : "OH", "county" : "HIGHLAND" },
            "45138": { "city" : "LEES CREEK", "state" : "OH", "county" : "CLINTON" },
            "45140": { "city" : "LOVELAND", "state" : "OH", "county" : "CLERMONT" },
            "45142": { "city" : "LYNCHBURG", "state" : "OH", "county" : "HIGHLAND" },
            "45144": { "city" : "MANCHESTER", "state" : "OH", "county" : "ADAMS" },
            "45145": { "city" : "MARATHON", "state" : "OH", "county" : "CLERMONT" },
            "45146": { "city" : "MARTINSVILLE", "state" : "OH", "county" : "CLINTON" },
            "45147": { "city" : "MIAMIVILLE", "state" : "OH", "county" : "CLERMONT" },
            "45148": { "city" : "MIDLAND", "state" : "OH", "county" : "CLINTON" },
            "45150": { "city" : "MILFORD", "state" : "OH", "county" : "CLERMONT" },
            "45152": { "city" : "MORROW", "state" : "OH", "county" : "WARREN" },"45153": { "city" : "MOSCOW", "state" : "OH", "county" : "CLERMONT" },
            "45154": { "city" : "MOUNT ORAB", "state" : "OH", "county" : "BROWN" },
            "45155": { "city" : "MOWRYSTOWN", "state" : "OH", "county" : "HIGHLAND" },
            "45157": { "city" : "NEW RICHMOND", "state" : "OH", "county" : "CLERMONT" },
            "45158": { "city" : "NEWTONSVILLE", "state" : "OH", "county" : "CLERMONT" },
            "45159": { "city" : "NEW VIENNA", "state" : "OH", "county" : "CLINTON" },
            "45160": { "city" : "OWENSVILLE", "state" : "OH", "county" : "CLERMONT" },
            "45162": { "city" : "PLEASANT PLAIN", "state" : "OH", "county" : "WARREN" },
            "45164": { "city" : "PORT WILLIAM", "state" : "OH", "county" : "CLINTON" },
            "45167": { "city" : "RIPLEY", "state" : "OH", "county" : "BROWN" },"45168": { "city" : "RUSSELLVILLE", "state" : "OH", "county" : "BROWN" },
            "45169": { "city" : "SABINA", "state" : "OH", "county" : "CLINTON" },
            "45171": { "city" : "SARDINIA", "state" : "OH", "county" : "BROWN" },
            "45172": { "city" : "SINKING SPRING", "state" : "OH", "county" : "HIGHLAND" },
            "45174": { "city" : "TERRACE PARK", "state" : "OH", "county" : "HAMILTON" },
            "45176": { "city" : "WILLIAMSBURG", "state" : "OH", "county" : "CLERMONT" },
            "45177": { "city" : "WILMINGTON", "state" : "OH", "county" : "CLINTON" },
            "45201": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45202": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45203": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45204": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45205": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45206": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45207": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45208": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45209": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45211": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45212": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45213": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45214": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45215": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45216": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45217": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45218": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45219": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45220": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45221": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45222": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45223": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45224": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45225": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45226": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45227": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45228": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45229": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45230": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45231": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45232": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45233": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45234": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45235": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45236": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45237": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45238": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45239": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45240": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45241": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45242": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45243": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45244": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45245": { "city" : "CINCINNATI", "state" : "OH", "county" : "CLERMONT" },
            "45246": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45247": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45248": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45249": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45250": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45251": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45252": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45253": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45254": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45255": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45258": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45262": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45263": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45264": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45267": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45268": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45274": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45275": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45280": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45296": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45299": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "45301": { "city" : "ALPHA", "state" : "OH", "county" : "GREENE" },"45302": { "city" : "ANNA", "state" : "OH", "county" : "SHELBY" },
            "45303": { "city" : "ANSONIA", "state" : "OH", "county" : "DARKE" },"45304": { "city" : "ARCANUM", "state" : "OH", "county" : "DARKE" },
            "45305": { "city" : "BELLBROOK", "state" : "OH", "county" : "GREENE" },
            "45306": { "city" : "BOTKINS", "state" : "OH", "county" : "SHELBY" },
            "45307": { "city" : "BOWERSVILLE", "state" : "OH", "county" : "GREENE" },
            "45308": { "city" : "BRADFORD", "state" : "OH", "county" : "MIAMI" },
            "45309": { "city" : "BROOKVILLE", "state" : "OH", "county" : "MONTGOMERY" },
            "45310": { "city" : "BURKETTSVILLE", "state" : "OH", "county" : "MERCER" },
            "45311": { "city" : "CAMDEN", "state" : "OH", "county" : "PREBLE" },"45312": { "city" : "CASSTOWN", "state" : "OH", "county" : "MIAMI" },
            "45314": { "city" : "CEDARVILLE", "state" : "OH", "county" : "GREENE" },
            "45315": { "city" : "CLAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45316": { "city" : "CLIFTON", "state" : "OH", "county" : "GREENE" },
            "45317": { "city" : "CONOVER", "state" : "OH", "county" : "MIAMI" },"45318": { "city" : "COVINGTON", "state" : "OH", "county" : "MIAMI" },
            "45319": { "city" : "DONNELSVILLE", "state" : "OH", "county" : "CLARK" },
            "45320": { "city" : "EATON", "state" : "OH", "county" : "PREBLE" },"45321": { "city" : "ELDORADO", "state" : "OH", "county" : "PREBLE" },
            "45322": { "city" : "ENGLEWOOD", "state" : "OH", "county" : "MONTGOMERY" },
            "45323": { "city" : "ENON", "state" : "OH", "county" : "CLARK" },"45324": { "city" : "FAIRBORN", "state" : "OH", "county" : "GREENE" },
            "45325": { "city" : "FARMERSVILLE", "state" : "OH", "county" : "MONTGOMERY" },
            "45326": { "city" : "FLETCHER", "state" : "OH", "county" : "MIAMI" },
            "45327": { "city" : "GERMANTOWN", "state" : "OH", "county" : "MONTGOMERY" },
            "45328": { "city" : "GETTYSBURG", "state" : "OH", "county" : "DARKE" },
            "45330": { "city" : "GRATIS", "state" : "OH", "county" : "PREBLE" },"45331": { "city" : "GREENVILLE", "state" : "OH", "county" : "DARKE" },
            "45332": { "city" : "HOLLANSBURG", "state" : "OH", "county" : "DARKE" },
            "45333": { "city" : "HOUSTON", "state" : "OH", "county" : "SHELBY" },
            "45334": { "city" : "JACKSON CENTER", "state" : "OH", "county" : "SHELBY" },
            "45335": { "city" : "JAMESTOWN", "state" : "OH", "county" : "GREENE" },
            "45336": { "city" : "KETTLERSVILLE", "state" : "OH", "county" : "SHELBY" },
            "45337": { "city" : "LAURA", "state" : "OH", "county" : "MIAMI" },"45338": { "city" : "LEWISBURG", "state" : "OH", "county" : "PREBLE" },
            "45339": { "city" : "LUDLOW FALLS", "state" : "OH", "county" : "MIAMI" },
            "45340": { "city" : "MAPLEWOOD", "state" : "OH", "county" : "SHELBY" },
            "45341": { "city" : "MEDWAY", "state" : "OH", "county" : "CLARK" },"45342": { "city" : "MIAMISBURG", "state" : "OH", "county" : "MONTGOMERY" },
            "45343": { "city" : "MIAMISBURG", "state" : "OH", "county" : "MONTGOMERY" },
            "45344": { "city" : "NEW CARLISLE", "state" : "OH", "county" : "CLARK" },
            "45345": { "city" : "NEW LEBANON", "state" : "OH", "county" : "MONTGOMERY" },
            "45346": { "city" : "NEW MADISON", "state" : "OH", "county" : "DARKE" },
            "45347": { "city" : "NEW PARIS", "state" : "OH", "county" : "PREBLE" },
            "45348": { "city" : "NEW WESTON", "state" : "OH", "county" : "DARKE" },
            "45349": { "city" : "NORTH HAMPTON", "state" : "OH", "county" : "CLARK" },
            "45350": { "city" : "NORTH STAR", "state" : "OH", "county" : "DARKE" },
            "45351": { "city" : "OSGOOD", "state" : "OH", "county" : "DARKE" },"45352": { "city" : "PALESTINE", "state" : "OH", "county" : "DARKE" },
            "45353": { "city" : "PEMBERTON", "state" : "OH", "county" : "SHELBY" },
            "45354": { "city" : "PHILLIPSBURG", "state" : "OH", "county" : "MONTGOMERY" },
            "45356": { "city" : "PIQUA", "state" : "OH", "county" : "MIAMI" },"45358": { "city" : "PITSBURG", "state" : "OH", "county" : "DARKE" },
            "45359": { "city" : "PLEASANT HILL", "state" : "OH", "county" : "MIAMI" },
            "45360": { "city" : "PORT JEFFERSON", "state" : "OH", "county" : "SHELBY" },
            "45361": { "city" : "POTSDAM", "state" : "OH", "county" : "MIAMI" },"45362": { "city" : "ROSSBURG", "state" : "OH", "county" : "DARKE" },
            "45363": { "city" : "RUSSIA", "state" : "OH", "county" : "SHELBY" },"45365": { "city" : "SIDNEY", "state" : "OH", "county" : "SHELBY" },
            "45368": { "city" : "SOUTH CHARLESTON", "state" : "OH", "county" : "CLARK" },
            "45369": { "city" : "SOUTH VIENNA", "state" : "OH", "county" : "CLARK" },
            "45370": { "city" : "SPRING VALLEY", "state" : "OH", "county" : "GREENE" },
            "45371": { "city" : "TIPP CITY", "state" : "OH", "county" : "MIAMI" },
            "45372": { "city" : "TREMONT CITY", "state" : "OH", "county" : "CLARK" },
            "45373": { "city" : "TROY", "state" : "OH", "county" : "MIAMI" },"45377": { "city" : "VANDALIA", "state" : "OH", "county" : "MONTGOMERY" },
            "45378": { "city" : "VERONA", "state" : "OH", "county" : "PREBLE" },"45380": { "city" : "VERSAILLES", "state" : "OH", "county" : "DARKE" },
            "45381": { "city" : "WEST ALEXANDRIA", "state" : "OH", "county" : "PREBLE" },
            "45382": { "city" : "WEST MANCHESTER", "state" : "OH", "county" : "PREBLE" },
            "45383": { "city" : "WEST MILTON", "state" : "OH", "county" : "MIAMI" },
            "45384": { "city" : "WILBERFORCE", "state" : "OH", "county" : "GREENE" },
            "45385": { "city" : "XENIA", "state" : "OH", "county" : "GREENE" },"45387": { "city" : "YELLOW SPRINGS", "state" : "OH", "county" : "GREENE" },
            "45388": { "city" : "YORKSHIRE", "state" : "OH", "county" : "DARKE" },
            "45389": { "city" : "CHRISTIANSBURG", "state" : "OH", "county" : "CHAMPAIGN" },
            "45390": { "city" : "UNION CITY", "state" : "OH", "county" : "DARKE" },
            "45401": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45402": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45403": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45404": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45405": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45406": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45408": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45409": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45410": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45412": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45413": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45414": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45415": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45416": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45417": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45418": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45419": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45420": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45422": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45423": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45424": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45426": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45427": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45428": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45429": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45430": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45431": { "city" : "DAYTON", "state" : "OH", "county" : "GREENE" },"45432": { "city" : "DAYTON", "state" : "OH", "county" : "GREENE" },
            "45433": { "city" : "DAYTON", "state" : "OH", "county" : "GREENE" },"45434": { "city" : "DAYTON", "state" : "OH", "county" : "GREENE" },
            "45435": { "city" : "DAYTON", "state" : "OH", "county" : "GREENE" },"45437": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45439": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45440": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45441": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45448": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45449": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45458": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45459": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45469": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45470": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45475": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45479": { "city" : "DAYTON", "state" : "OH", "county" : "MONTGOMERY" },
            "45501": { "city" : "SPRINGFIELD", "state" : "OH", "county" : "CLARK" },
            "45502": { "city" : "SPRINGFIELD", "state" : "OH", "county" : "CLARK" },
            "45503": { "city" : "SPRINGFIELD", "state" : "OH", "county" : "CLARK" },
            "45504": { "city" : "SPRINGFIELD", "state" : "OH", "county" : "CLARK" },
            "45505": { "city" : "SPRINGFIELD", "state" : "OH", "county" : "CLARK" },
            "45506": { "city" : "SPRINGFIELD", "state" : "OH", "county" : "CLARK" },
            "45601": { "city" : "CHILLICOTHE", "state" : "OH", "county" : "ROSS" },
            "45612": { "city" : "BAINBRIDGE", "state" : "OH", "county" : "ROSS" },
            "45613": { "city" : "BEAVER", "state" : "OH", "county" : "PIKE" },"45614": { "city" : "BIDWELL", "state" : "OH", "county" : "GALLIA" },
            "45616": { "city" : "BLUE CREEK", "state" : "OH", "county" : "ADAMS" },
            "45617": { "city" : "BOURNEVILLE", "state" : "OH", "county" : "ROSS" },
            "45618": { "city" : "CHERRY FORK", "state" : "OH", "county" : "ADAMS" },
            "45619": { "city" : "CHESAPEAKE", "state" : "OH", "county" : "LAWRENCE" },
            "45620": { "city" : "CHESHIRE", "state" : "OH", "county" : "GALLIA" },
            "45621": { "city" : "COALTON", "state" : "OH", "county" : "JACKSON" },
            "45622": { "city" : "CREOLA", "state" : "OH", "county" : "VINTON" },"45623": { "city" : "CROWN CITY", "state" : "OH", "county" : "GALLIA" },
            "45628": { "city" : "FRANKFORT", "state" : "OH", "county" : "ROSS" },
            "45629": { "city" : "FRANKLIN FURNACE", "state" : "OH", "county" : "SCIOTO" },
            "45630": { "city" : "FRIENDSHIP", "state" : "OH", "county" : "SCIOTO" },
            "45631": { "city" : "GALLIPOLIS", "state" : "OH", "county" : "GALLIA" },
            "45634": { "city" : "HAMDEN", "state" : "OH", "county" : "VINTON" },"45636": { "city" : "HAVERHILL", "state" : "OH", "county" : "SCIOTO" },
            "45638": { "city" : "IRONTON", "state" : "OH", "county" : "LAWRENCE" },
            "45640": { "city" : "JACKSON", "state" : "OH", "county" : "JACKSON" },
            "45644": { "city" : "KINGSTON", "state" : "OH", "county" : "ROSS" },"45645": { "city" : "KITTS HILL", "state" : "OH", "county" : "LAWRENCE" },
            "45646": { "city" : "LATHAM", "state" : "OH", "county" : "PIKE" },"45647": { "city" : "LONDONDERRY", "state" : "OH", "county" : "ROSS" },
            "45648": { "city" : "LUCASVILLE", "state" : "OH", "county" : "SCIOTO" },
            "45650": { "city" : "LYNX", "state" : "OH", "county" : "ADAMS" },"45651": { "city" : "MC ARTHUR", "state" : "OH", "county" : "VINTON" },
            "45652": { "city" : "MC DERMOTT", "state" : "OH", "county" : "SCIOTO" },
            "45653": { "city" : "MINFORD", "state" : "OH", "county" : "SCIOTO" },
            "45654": { "city" : "NEW PLYMOUTH", "state" : "OH", "county" : "VINTON" },
            "45656": { "city" : "OAK HILL", "state" : "OH", "county" : "JACKSON" },
            "45657": { "city" : "OTWAY", "state" : "OH", "county" : "SCIOTO" },"45658": { "city" : "PATRIOT", "state" : "OH", "county" : "GALLIA" },
            "45659": { "city" : "PEDRO", "state" : "OH", "county" : "LAWRENCE" },
            "45660": { "city" : "PEEBLES", "state" : "OH", "county" : "ADAMS" },"45661": { "city" : "PIKETON", "state" : "OH", "county" : "PIKE" },
            "45662": { "city" : "PORTSMOUTH", "state" : "OH", "county" : "SCIOTO" },
            "45663": { "city" : "WEST PORTSMOUTH", "state" : "OH", "county" : "SCIOTO" },
            "45669": { "city" : "PROCTORVILLE", "state" : "OH", "county" : "LAWRENCE" },
            "45671": { "city" : "RARDEN", "state" : "OH", "county" : "SCIOTO" },"45672": { "city" : "RAY", "state" : "OH", "county" : "VINTON" },
            "45673": { "city" : "RICHMOND DALE", "state" : "OH", "county" : "ROSS" },
            "45674": { "city" : "RIO GRANDE", "state" : "OH", "county" : "GALLIA" },
            "45678": { "city" : "SCOTTOWN", "state" : "OH", "county" : "LAWRENCE" },
            "45679": { "city" : "SEAMAN", "state" : "OH", "county" : "ADAMS" },"45680": { "city" : "SOUTH POINT", "state" : "OH", "county" : "LAWRENCE" },
            "45681": { "city" : "SOUTH SALEM", "state" : "OH", "county" : "ROSS" },
            "45682": { "city" : "SOUTH WEBSTER", "state" : "OH", "county" : "SCIOTO" },
            "45684": { "city" : "STOUT", "state" : "OH", "county" : "ADAMS" },"45685": { "city" : "THURMAN", "state" : "OH", "county" : "GALLIA" },
            "45686": { "city" : "VINTON", "state" : "OH", "county" : "GALLIA" },"45687": { "city" : "WAKEFIELD", "state" : "OH", "county" : "PIKE" },
            "45688": { "city" : "WATERLOO", "state" : "OH", "county" : "LAWRENCE" },
            "45690": { "city" : "WAVERLY", "state" : "OH", "county" : "PIKE" },"45692": { "city" : "WELLSTON", "state" : "OH", "county" : "JACKSON" },
            "45693": { "city" : "WEST UNION", "state" : "OH", "county" : "ADAMS" },
            "45694": { "city" : "WHEELERSBURG", "state" : "OH", "county" : "SCIOTO" },
            "45695": { "city" : "WILKESVILLE", "state" : "OH", "county" : "VINTON" },
            "45696": { "city" : "WILLOW WOOD", "state" : "OH", "county" : "LAWRENCE" },
            "45697": { "city" : "WINCHESTER", "state" : "OH", "county" : "ADAMS" },
            "45698": { "city" : "ZALESKI", "state" : "OH", "county" : "VINTON" },
            "45699": { "city" : "LUCASVILLE", "state" : "OH", "county" : "SCIOTO" },
            "45701": { "city" : "ATHENS", "state" : "OH", "county" : "ATHENS" },"45710": { "city" : "ALBANY", "state" : "OH", "county" : "ATHENS" },
            "45711": { "city" : "AMESVILLE", "state" : "OH", "county" : "ATHENS" },
            "45712": { "city" : "BARLOW", "state" : "OH", "county" : "WASHINGTON" },
            "45713": { "city" : "BARTLETT", "state" : "OH", "county" : "WASHINGTON" },
            "45714": { "city" : "BELPRE", "state" : "OH", "county" : "WASHINGTON" },
            "45715": { "city" : "BEVERLY", "state" : "OH", "county" : "WASHINGTON" },
            "45716": { "city" : "BUCHTEL", "state" : "OH", "county" : "ATHENS" },
            "45719": { "city" : "CHAUNCEY", "state" : "OH", "county" : "ATHENS" },
            "45720": { "city" : "CHESTER", "state" : "OH", "county" : "MEIGS" },"45723": { "city" : "COOLVILLE", "state" : "OH", "county" : "ATHENS" },
            "45724": { "city" : "CUTLER", "state" : "OH", "county" : "WASHINGTON" },
            "45727": { "city" : "DEXTER CITY", "state" : "OH", "county" : "NOBLE" },
            "45729": { "city" : "FLEMING", "state" : "OH", "county" : "WASHINGTON" },
            "45732": { "city" : "GLOUSTER", "state" : "OH", "county" : "ATHENS" },
            "45734": { "city" : "GRAYSVILLE", "state" : "OH", "county" : "WASHINGTON" },
            "45735": { "city" : "GUYSVILLE", "state" : "OH", "county" : "ATHENS" },
            "45739": { "city" : "HOCKINGPORT", "state" : "OH", "county" : "ATHENS" },
            "45740": { "city" : "JACKSONVILLE", "state" : "OH", "county" : "ATHENS" },
            "45741": { "city" : "LANGSVILLE", "state" : "OH", "county" : "MEIGS" },
            "45742": { "city" : "LITTLE HOCKING", "state" : "OH", "county" : "WASHINGTON" },
            "45743": { "city" : "LONG BOTTOM", "state" : "OH", "county" : "MEIGS" },
            "45744": { "city" : "LOWELL", "state" : "OH", "county" : "WASHINGTON" },
            "45745": { "city" : "LOWER SALEM", "state" : "OH", "county" : "WASHINGTON" },
            "45746": { "city" : "MACKSBURG", "state" : "OH", "county" : "WASHINGTON" },
            "45750": { "city" : "MARIETTA", "state" : "OH", "county" : "WASHINGTON" },
            "45760": { "city" : "MIDDLEPORT", "state" : "OH", "county" : "MEIGS" },
            "45761": { "city" : "MILLFIELD", "state" : "OH", "county" : "ATHENS" },
            "45764": { "city" : "NELSONVILLE", "state" : "OH", "county" : "ATHENS" },
            "45766": { "city" : "NEW MARSHFIELD", "state" : "OH", "county" : "ATHENS" },
            "45767": { "city" : "NEW MATAMORAS", "state" : "OH", "county" : "WASHINGTON" },
            "45768": { "city" : "NEWPORT", "state" : "OH", "county" : "WASHINGTON" },
            "45769": { "city" : "POMEROY", "state" : "OH", "county" : "MEIGS" },"45770": { "city" : "PORTLAND", "state" : "OH", "county" : "MEIGS" },
            "45771": { "city" : "RACINE", "state" : "OH", "county" : "MEIGS" },"45772": { "city" : "REEDSVILLE", "state" : "OH", "county" : "MEIGS" },
            "45773": { "city" : "RENO", "state" : "OH", "county" : "WASHINGTON" },
            "45775": { "city" : "RUTLAND", "state" : "OH", "county" : "MEIGS" },"45776": { "city" : "SHADE", "state" : "OH", "county" : "ATHENS" },
            "45777": { "city" : "SHARPSBURG", "state" : "OH", "county" : "ATHENS" },
            "45778": { "city" : "STEWART", "state" : "OH", "county" : "ATHENS" },
            "45779": { "city" : "SYRACUSE", "state" : "OH", "county" : "MEIGS" },
            "45780": { "city" : "THE PLAINS", "state" : "OH", "county" : "ATHENS" },
            "45782": { "city" : "TRIMBLE", "state" : "OH", "county" : "ATHENS" },
            "45783": { "city" : "TUPPERS PLAINS", "state" : "OH", "county" : "MEIGS" },
            "45784": { "city" : "VINCENT", "state" : "OH", "county" : "WASHINGTON" },
            "45786": { "city" : "WATERFORD", "state" : "OH", "county" : "WASHINGTON" },
            "45787": { "city" : "WATERTOWN", "state" : "OH", "county" : "WASHINGTON" },
            "45788": { "city" : "WHIPPLE", "state" : "OH", "county" : "WASHINGTON" },
            "45789": { "city" : "WINGETT RUN", "state" : "OH", "county" : "WASHINGTON" },
            "45801": { "city" : "LIMA", "state" : "OH", "county" : "ALLEN" },"45802": { "city" : "LIMA", "state" : "OH", "county" : "ALLEN" },
            "45804": { "city" : "LIMA", "state" : "OH", "county" : "ALLEN" },"45805": { "city" : "LIMA", "state" : "OH", "county" : "ALLEN" },
            "45806": { "city" : "LIMA", "state" : "OH", "county" : "AUGLAIZE" },"45807": { "city" : "LIMA", "state" : "OH", "county" : "ALLEN" },
            "45808": { "city" : "BEAVERDAM", "state" : "OH", "county" : "ALLEN" },
            "45809": { "city" : "GOMER", "state" : "OH", "county" : "ALLEN" },"45810": { "city" : "ADA", "state" : "OH", "county" : "HARDIN" },
            "45812": { "city" : "ALGER", "state" : "OH", "county" : "HARDIN" },"45813": { "city" : "ANTWERP", "state" : "OH", "county" : "PAULDING" },
            "45814": { "city" : "ARLINGTON", "state" : "OH", "county" : "HANCOCK" },
            "45815": { "city" : "BELMORE", "state" : "OH", "county" : "PUTNAM" },
            "45816": { "city" : "BENTON RIDGE", "state" : "OH", "county" : "HANCOCK" },
            "45817": { "city" : "BLUFFTON", "state" : "OH", "county" : "ALLEN" },
            "45819": { "city" : "BUCKLAND", "state" : "OH", "county" : "AUGLAIZE" },
            "45820": { "city" : "CAIRO", "state" : "OH", "county" : "ALLEN" },"45821": { "city" : "CECIL", "state" : "OH", "county" : "PAULDING" },
            "45822": { "city" : "CELINA", "state" : "OH", "county" : "MERCER" },"45826": { "city" : "CHICKASAW", "state" : "OH", "county" : "MERCER" },
            "45827": { "city" : "CLOVERDALE", "state" : "OH", "county" : "PUTNAM" },
            "45828": { "city" : "COLDWATER", "state" : "OH", "county" : "MERCER" },
            "45830": { "city" : "COLUMBUS GROVE", "state" : "OH", "county" : "PUTNAM" },
            "45831": { "city" : "CONTINENTAL", "state" : "OH", "county" : "PUTNAM" },
            "45832": { "city" : "CONVOY", "state" : "OH", "county" : "VAN WERT" },
            "45833": { "city" : "DELPHOS", "state" : "OH", "county" : "ALLEN" },"45835": { "city" : "DOLA", "state" : "OH", "county" : "HARDIN" },
            "45836": { "city" : "DUNKIRK", "state" : "OH", "county" : "HARDIN" },
            "45837": { "city" : "DUPONT", "state" : "OH", "county" : "PUTNAM" },"45838": { "city" : "ELGIN", "state" : "OH", "county" : "VAN WERT" },
            "45839": { "city" : "FINDLAY", "state" : "OH", "county" : "HANCOCK" },
            "45840": { "city" : "FINDLAY", "state" : "OH", "county" : "HANCOCK" },
            "45841": { "city" : "JENERA", "state" : "OH", "county" : "HANCOCK" },
            "45843": { "city" : "FOREST", "state" : "OH", "county" : "HARDIN" },"45844": { "city" : "FORT JENNINGS", "state" : "OH", "county" : "PUTNAM" },
            "45845": { "city" : "FORT LORAMIE", "state" : "OH", "county" : "SHELBY" },
            "45846": { "city" : "FORT RECOVERY", "state" : "OH", "county" : "MERCER" },
            "45848": { "city" : "GLANDORF", "state" : "OH", "county" : "PUTNAM" },
            "45849": { "city" : "GROVER HILL", "state" : "OH", "county" : "PAULDING" },
            "45850": { "city" : "HARROD", "state" : "OH", "county" : "ALLEN" },"45851": { "city" : "HAVILAND", "state" : "OH", "county" : "PAULDING" },
            "45853": { "city" : "KALIDA", "state" : "OH", "county" : "PUTNAM" },"45854": { "city" : "LAFAYETTE", "state" : "OH", "county" : "ALLEN" },
            "45855": { "city" : "LATTY", "state" : "OH", "county" : "PAULDING" },
            "45856": { "city" : "LEIPSIC", "state" : "OH", "county" : "PUTNAM" },
            "45858": { "city" : "MC COMB", "state" : "OH", "county" : "HANCOCK" },
            "45859": { "city" : "MC GUFFEY", "state" : "OH", "county" : "HARDIN" },
            "45860": { "city" : "MARIA STEIN", "state" : "OH", "county" : "MERCER" },
            "45861": { "city" : "MELROSE", "state" : "OH", "county" : "PAULDING" },
            "45862": { "city" : "MENDON", "state" : "OH", "county" : "MERCER" },"45863": { "city" : "MIDDLE POINT", "state" : "OH", "county" : "VAN WERT" },
            "45864": { "city" : "MILLER CITY", "state" : "OH", "county" : "PUTNAM" },
            "45865": { "city" : "MINSTER", "state" : "OH", "county" : "AUGLAIZE" },
            "45866": { "city" : "MONTEZUMA", "state" : "OH", "county" : "MERCER" },
            "45867": { "city" : "MOUNT BLANCHARD", "state" : "OH", "county" : "HANCOCK" },
            "45868": { "city" : "MOUNT CORY", "state" : "OH", "county" : "HANCOCK" },
            "45869": { "city" : "NEW BREMEN", "state" : "OH", "county" : "AUGLAIZE" },
            "45870": { "city" : "NEW HAMPSHIRE", "state" : "OH", "county" : "AUGLAIZE" },
            "45871": { "city" : "NEW KNOXVILLE", "state" : "OH", "county" : "AUGLAIZE" },
            "45872": { "city" : "NORTH BALTIMORE", "state" : "OH", "county" : "WOOD" },
            "45873": { "city" : "OAKWOOD", "state" : "OH", "county" : "PAULDING" },
            "45874": { "city" : "OHIO CITY", "state" : "OH", "county" : "VAN WERT" },
            "45875": { "city" : "OTTAWA", "state" : "OH", "county" : "PUTNAM" },"45876": { "city" : "OTTOVILLE", "state" : "OH", "county" : "PUTNAM" },
            "45877": { "city" : "PANDORA", "state" : "OH", "county" : "PUTNAM" },
            "45879": { "city" : "PAULDING", "state" : "OH", "county" : "PAULDING" },
            "45880": { "city" : "PAYNE", "state" : "OH", "county" : "PAULDING" },
            "45881": { "city" : "RAWSON", "state" : "OH", "county" : "HANCOCK" },
            "45882": { "city" : "ROCKFORD", "state" : "OH", "county" : "MERCER" },
            "45883": { "city" : "SAINT HENRY", "state" : "OH", "county" : "MERCER" },
            "45885": { "city" : "SAINT MARYS", "state" : "OH", "county" : "AUGLAIZE" },
            "45886": { "city" : "SCOTT", "state" : "OH", "county" : "VAN WERT" },
            "45887": { "city" : "SPENCERVILLE", "state" : "OH", "county" : "ALLEN" },
            "45888": { "city" : "UNIOPOLIS", "state" : "OH", "county" : "AUGLAIZE" },
            "45889": { "city" : "VAN BUREN", "state" : "OH", "county" : "HANCOCK" },
            "45890": { "city" : "VANLUE", "state" : "OH", "county" : "HANCOCK" },
            "45891": { "city" : "VAN WERT", "state" : "OH", "county" : "VAN WERT" },
            "45893": { "city" : "VAUGHNSVILLE", "state" : "OH", "county" : "PUTNAM" },
            "45894": { "city" : "VENEDOCIA", "state" : "OH", "county" : "VAN WERT" },
            "45895": { "city" : "WAPAKONETA", "state" : "OH", "county" : "AUGLAIZE" },
            "45896": { "city" : "WAYNESFIELD", "state" : "OH", "county" : "AUGLAIZE" },
            "45897": { "city" : "WILLIAMSTOWN", "state" : "OH", "county" : "HANCOCK" },
            "45898": { "city" : "WILLSHIRE", "state" : "OH", "county" : "VAN WERT" },
            "45899": { "city" : "WREN", "state" : "OH", "county" : "VAN WERT" },"45999": { "city" : "CINCINNATI", "state" : "OH", "county" : "HAMILTON" },
            "46001": { "city" : "ALEXANDRIA", "state" : "IN", "county" : "MADISON" },
            "46011": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46012": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46013": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46014": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46015": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46016": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46017": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46018": { "city" : "ANDERSON", "state" : "IN", "county" : "MADISON" },
            "46030": { "city" : "ARCADIA", "state" : "IN", "county" : "HAMILTON" },
            "46031": { "city" : "ATLANTA", "state" : "IN", "county" : "HAMILTON" },
            "46032": { "city" : "CARMEL", "state" : "IN", "county" : "HAMILTON" },
            "46033": { "city" : "CARMEL", "state" : "IN", "county" : "HAMILTON" },
            "46034": { "city" : "CICERO", "state" : "IN", "county" : "HAMILTON" },
            "46035": { "city" : "COLFAX", "state" : "IN", "county" : "CLINTON" },
            "46036": { "city" : "ELWOOD", "state" : "IN", "county" : "MADISON" },
            "46037": { "city" : "FISHERS", "state" : "IN", "county" : "HAMILTON" },
            "46038": { "city" : "FISHERS", "state" : "IN", "county" : "HAMILTON" },
            "46039": { "city" : "FOREST", "state" : "IN", "county" : "CLINTON" },
            "46040": { "city" : "FORTVILLE", "state" : "IN", "county" : "HANCOCK" },
            "46041": { "city" : "FRANKFORT", "state" : "IN", "county" : "CLINTON" },
            "46044": { "city" : "FRANKTON", "state" : "IN", "county" : "MADISON" },
            "46045": { "city" : "GOLDSMITH", "state" : "IN", "county" : "TIPTON" },
            "46047": { "city" : "HOBBS", "state" : "IN", "county" : "TIPTON" },"46048": { "city" : "INGALLS", "state" : "IN", "county" : "MADISON" },
            "46049": { "city" : "KEMPTON", "state" : "IN", "county" : "TIPTON" },
            "46050": { "city" : "KIRKLIN", "state" : "IN", "county" : "CLINTON" },
            "46051": { "city" : "LAPEL", "state" : "IN", "county" : "MADISON" },"46052": { "city" : "LEBANON", "state" : "IN", "county" : "BOONE" },
            "46055": { "city" : "MC CORDSVILLE", "state" : "IN", "county" : "HANCOCK" },
            "46056": { "city" : "MARKLEVILLE", "state" : "IN", "county" : "MADISON" },
            "46057": { "city" : "MICHIGANTOWN", "state" : "IN", "county" : "CLINTON" },
            "46058": { "city" : "MULBERRY", "state" : "IN", "county" : "CLINTON" },
            "46060": { "city" : "NOBLESVILLE", "state" : "IN", "county" : "HAMILTON" },
            "46061": { "city" : "NOBLESVILLE", "state" : "IN", "county" : "HAMILTON" },
            "46062": { "city" : "NOBLESVILLE", "state" : "IN", "county" : "HAMILTON" },
            "46063": { "city" : "ORESTES", "state" : "IN", "county" : "MADISON" },
            "46064": { "city" : "PENDLETON", "state" : "IN", "county" : "MADISON" },
            "46065": { "city" : "ROSSVILLE", "state" : "IN", "county" : "CLINTON" },
            "46067": { "city" : "SEDALIA", "state" : "IN", "county" : "CLINTON" },
            "46068": { "city" : "SHARPSVILLE", "state" : "IN", "county" : "TIPTON" },
            "46069": { "city" : "SHERIDAN", "state" : "IN", "county" : "HAMILTON" },
            "46070": { "city" : "SUMMITVILLE", "state" : "IN", "county" : "MADISON" },
            "46071": { "city" : "THORNTOWN", "state" : "IN", "county" : "BOONE" },
            "46072": { "city" : "TIPTON", "state" : "IN", "county" : "TIPTON" },"46074": { "city" : "WESTFIELD", "state" : "IN", "county" : "HAMILTON" },
            "46075": { "city" : "WHITESTOWN", "state" : "IN", "county" : "BOONE" },
            "46076": { "city" : "WINDFALL", "state" : "IN", "county" : "TIPTON" },
            "46077": { "city" : "ZIONSVILLE", "state" : "IN", "county" : "BOONE" },
            "46082": { "city" : "CARMEL", "state" : "IN", "county" : "HAMILTON" },
            "46085": { "city" : "FISHERS", "state" : "IN", "county" : "HAMILTON" },
            "46102": { "city" : "ADVANCE", "state" : "IN", "county" : "BOONE" },"46103": { "city" : "AMO", "state" : "IN", "county" : "HENDRICKS" },
            "46104": { "city" : "ARLINGTON", "state" : "IN", "county" : "RUSH" },
            "46105": { "city" : "BAINBRIDGE", "state" : "IN", "county" : "PUTNAM" },
            "46106": { "city" : "BARGERSVILLE", "state" : "IN", "county" : "JOHNSON" },
            "46107": { "city" : "BEECH GROVE", "state" : "IN", "county" : "MARION" },
            "46110": { "city" : "BOGGSTOWN", "state" : "IN", "county" : "SHELBY" },
            "46111": { "city" : "BROOKLYN", "state" : "IN", "county" : "MORGAN" },
            "46112": { "city" : "BROWNSBURG", "state" : "IN", "county" : "HENDRICKS" },
            "46113": { "city" : "CAMBY", "state" : "IN", "county" : "MORGAN" },"46115": { "city" : "CARTHAGE", "state" : "IN", "county" : "RUSH" },
            "46117": { "city" : "CHARLOTTESVILLE", "state" : "IN", "county" : "HANCOCK" },
            "46118": { "city" : "CLAYTON", "state" : "IN", "county" : "HENDRICKS" },
            "46120": { "city" : "CLOVERDALE", "state" : "IN", "county" : "PUTNAM" },
            "46121": { "city" : "COATESVILLE", "state" : "IN", "county" : "PUTNAM" },
            "46122": { "city" : "DANVILLE", "state" : "IN", "county" : "HENDRICKS" },
            "46123": { "city" : "AVON", "state" : "IN", "county" : "HENDRICKS" },
            "46124": { "city" : "EDINBURGH", "state" : "IN", "county" : "JOHNSON" },
            "46125": { "city" : "EMINENCE", "state" : "IN", "county" : "MORGAN" },
            "46126": { "city" : "FAIRLAND", "state" : "IN", "county" : "SHELBY" },
            "46127": { "city" : "FALMOUTH", "state" : "IN", "county" : "RUSH" },"46128": { "city" : "FILLMORE", "state" : "IN", "county" : "PUTNAM" },
            "46129": { "city" : "FINLY", "state" : "IN", "county" : "HANCOCK" },"46130": { "city" : "FOUNTAINTOWN", "state" : "IN", "county" : "SHELBY" },
            "46131": { "city" : "FRANKLIN", "state" : "IN", "county" : "JOHNSON" },
            "46133": { "city" : "GLENWOOD", "state" : "IN", "county" : "FAYETTE" },
            "46135": { "city" : "GREENCASTLE", "state" : "IN", "county" : "PUTNAM" },
            "46140": { "city" : "GREENFIELD", "state" : "IN", "county" : "HANCOCK" },
            "46142": { "city" : "GREENWOOD", "state" : "IN", "county" : "JOHNSON" },
            "46143": { "city" : "GREENWOOD", "state" : "IN", "county" : "JOHNSON" },
            "46144": { "city" : "GWYNNEVILLE", "state" : "IN", "county" : "SHELBY" },
            "46146": { "city" : "HOMER", "state" : "IN", "county" : "RUSH" },"46147": { "city" : "JAMESTOWN", "state" : "IN", "county" : "BOONE" },
            "46148": { "city" : "KNIGHTSTOWN", "state" : "IN", "county" : "HENRY" },
            "46149": { "city" : "LIZTON", "state" : "IN", "county" : "HENDRICKS" },
            "46150": { "city" : "MANILLA", "state" : "IN", "county" : "RUSH" },"46151": { "city" : "MARTINSVILLE", "state" : "IN", "county" : "MORGAN" },
            "46154": { "city" : "MAXWELL", "state" : "IN", "county" : "HANCOCK" },
            "46155": { "city" : "MAYS", "state" : "IN", "county" : "RUSH" },"46156": { "city" : "MILROY", "state" : "IN", "county" : "RUSH" },
            "46157": { "city" : "MONROVIA", "state" : "IN", "county" : "MORGAN" },
            "46158": { "city" : "MOORESVILLE", "state" : "IN", "county" : "MORGAN" },
            "46160": { "city" : "MORGANTOWN", "state" : "IN", "county" : "MORGAN" },
            "46161": { "city" : "MORRISTOWN", "state" : "IN", "county" : "SHELBY" },
            "46162": { "city" : "NEEDHAM", "state" : "IN", "county" : "JOHNSON" },
            "46163": { "city" : "NEW PALESTINE", "state" : "IN", "county" : "HANCOCK" },
            "46164": { "city" : "NINEVEH", "state" : "IN", "county" : "JOHNSON" },
            "46165": { "city" : "NORTH SALEM", "state" : "IN", "county" : "HENDRICKS" },
            "46166": { "city" : "PARAGON", "state" : "IN", "county" : "MORGAN" },
            "46167": { "city" : "PITTSBORO", "state" : "IN", "county" : "HENDRICKS" },
            "46168": { "city" : "PLAINFIELD", "state" : "IN", "county" : "HENDRICKS" },
            "46170": { "city" : "PUTNAMVILLE", "state" : "IN", "county" : "PUTNAM" },
            "46171": { "city" : "REELSVILLE", "state" : "IN", "county" : "PUTNAM" },
            "46172": { "city" : "ROACHDALE", "state" : "IN", "county" : "PUTNAM" },
            "46173": { "city" : "RUSHVILLE", "state" : "IN", "county" : "RUSH" },
            "46175": { "city" : "RUSSELLVILLE", "state" : "IN", "county" : "PUTNAM" },
            "46176": { "city" : "SHELBYVILLE", "state" : "IN", "county" : "SHELBY" },
            "46180": { "city" : "STILESVILLE", "state" : "IN", "county" : "HENDRICKS" },
            "46181": { "city" : "TRAFALGAR", "state" : "IN", "county" : "JOHNSON" },
            "46182": { "city" : "WALDRON", "state" : "IN", "county" : "SHELBY" },
            "46183": { "city" : "WEST NEWTON", "state" : "IN", "county" : "MARION" },
            "46184": { "city" : "WHITELAND", "state" : "IN", "county" : "JOHNSON" },
            "46186": { "city" : "WILKINSON", "state" : "IN", "county" : "HANCOCK" },
            "46201": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46202": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46203": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46204": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46205": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46206": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46207": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46208": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46209": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46211": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46214": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46216": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46217": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46218": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46219": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46220": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46221": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46222": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46223": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46224": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46225": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46226": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46227": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46228": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46229": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46230": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46231": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46234": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46235": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46236": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46237": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46239": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46240": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46241": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46242": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46244": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46247": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46249": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46250": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46251": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46253": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46254": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46255": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46256": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46259": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46260": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46266": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46268": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46274": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46277": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46278": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46280": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "HAMILTON" },
            "46282": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46285": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46290": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "HAMILTON" },
            "46291": { "city" : "INDIANAPOLIS", "state" : "IN", "county" : "MARION" },
            "46301": { "city" : "BEVERLY SHORES", "state" : "IN", "county" : "PORTER" },
            "46302": { "city" : "BOONE GROVE", "state" : "IN", "county" : "PORTER" },
            "46303": { "city" : "CEDAR LAKE", "state" : "IN", "county" : "LAKE" },
            "46304": { "city" : "CHESTERTON", "state" : "IN", "county" : "PORTER" },
            "46307": { "city" : "CROWN POINT", "state" : "IN", "county" : "LAKE" },
            "46308": { "city" : "CROWN POINT", "state" : "IN", "county" : "LAKE" },
            "46310": { "city" : "DEMOTTE", "state" : "IN", "county" : "JASPER" },
            "46311": { "city" : "DYER", "state" : "IN", "county" : "LAKE" },"46312": { "city" : "EAST CHICAGO", "state" : "IN", "county" : "LAKE" },
            "46319": { "city" : "GRIFFITH", "state" : "IN", "county" : "LAKE" },"46320": { "city" : "HAMMOND", "state" : "IN", "county" : "LAKE" },
            "46321": { "city" : "MUNSTER", "state" : "IN", "county" : "LAKE" },"46322": { "city" : "HIGHLAND", "state" : "IN", "county" : "LAKE" },
            "46323": { "city" : "HAMMOND", "state" : "IN", "county" : "LAKE" },"46324": { "city" : "HAMMOND", "state" : "IN", "county" : "LAKE" },
            "46325": { "city" : "HAMMOND", "state" : "IN", "county" : "LAKE" },"46327": { "city" : "HAMMOND", "state" : "IN", "county" : "LAKE" },
            "46340": { "city" : "HANNA", "state" : "IN", "county" : "LA PORTE" },
            "46341": { "city" : "HEBRON", "state" : "IN", "county" : "PORTER" },"46342": { "city" : "HOBART", "state" : "IN", "county" : "LAKE" },
            "46345": { "city" : "KINGSBURY", "state" : "IN", "county" : "LA PORTE" },
            "46346": { "city" : "KINGSFORD HEIGHTS", "state" : "IN", "county" : "LA PORTE" },
            "46347": { "city" : "KOUTS", "state" : "IN", "county" : "PORTER" },"46348": { "city" : "LA CROSSE", "state" : "IN", "county" : "LA PORTE" },
            "46349": { "city" : "LAKE VILLAGE", "state" : "IN", "county" : "NEWTON" },
            "46350": { "city" : "LA PORTE", "state" : "IN", "county" : "LA PORTE" },
            "46352": { "city" : "LA PORTE", "state" : "IN", "county" : "LA PORTE" },
            "46355": { "city" : "LEROY", "state" : "IN", "county" : "LAKE" },"46356": { "city" : "LOWELL", "state" : "IN", "county" : "LAKE" },
            "46360": { "city" : "MICHIGAN CITY", "state" : "IN", "county" : "LA PORTE" },
            "46361": { "city" : "MICHIGAN CITY", "state" : "IN", "county" : "LA PORTE" },
            "46365": { "city" : "MILL CREEK", "state" : "IN", "county" : "LA PORTE" },
            "46366": { "city" : "NORTH JUDSON", "state" : "IN", "county" : "STARKE" },
            "46368": { "city" : "PORTAGE", "state" : "IN", "county" : "PORTER" },
            "46371": { "city" : "ROLLING PRAIRIE", "state" : "IN", "county" : "LA PORTE" },
            "46372": { "city" : "ROSELAWN", "state" : "IN", "county" : "NEWTON" },
            "46373": { "city" : "SAINT JOHN", "state" : "IN", "county" : "LAKE" },
            "46374": { "city" : "SAN PIERRE", "state" : "IN", "county" : "STARKE" },
            "46375": { "city" : "SCHERERVILLE", "state" : "IN", "county" : "LAKE" },
            "46376": { "city" : "SCHNEIDER", "state" : "IN", "county" : "LAKE" },
            "46377": { "city" : "SHELBY", "state" : "IN", "county" : "LAKE" },"46379": { "city" : "SUMAVA RESORTS", "state" : "IN", "county" : "NEWTON" },
            "46381": { "city" : "THAYER", "state" : "IN", "county" : "NEWTON" },"46382": { "city" : "UNION MILLS", "state" : "IN", "county" : "LA PORTE" },
            "46383": { "city" : "VALPARAISO", "state" : "IN", "county" : "PORTER" },
            "46384": { "city" : "VALPARAISO", "state" : "IN", "county" : "PORTER" },
            "46385": { "city" : "VALPARAISO", "state" : "IN", "county" : "PORTER" },
            "46390": { "city" : "WANATAH", "state" : "IN", "county" : "LA PORTE" },
            "46391": { "city" : "WESTVILLE", "state" : "IN", "county" : "LA PORTE" },
            "46392": { "city" : "WHEATFIELD", "state" : "IN", "county" : "JASPER" },
            "46393": { "city" : "WHEELER", "state" : "IN", "county" : "PORTER" },
            "46394": { "city" : "WHITING", "state" : "IN", "county" : "LAKE" },"46401": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },
            "46402": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },"46403": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },
            "46404": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },"46405": { "city" : "LAKE STATION", "state" : "IN", "county" : "LAKE" },
            "46406": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },"46407": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },
            "46408": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },"46409": { "city" : "GARY", "state" : "IN", "county" : "LAKE" },
            "46410": { "city" : "MERRILLVILLE", "state" : "IN", "county" : "LAKE" },
            "46411": { "city" : "MERRILLVILLE", "state" : "IN", "county" : "LAKE" },
            "46501": { "city" : "ARGOS", "state" : "IN", "county" : "MARSHALL" },
            "46502": { "city" : "ATWOOD", "state" : "IN", "county" : "KOSCIUSKO" },
            "46504": { "city" : "BOURBON", "state" : "IN", "county" : "MARSHALL" },
            "46506": { "city" : "BREMEN", "state" : "IN", "county" : "MARSHALL" },
            "46507": { "city" : "BRISTOL", "state" : "IN", "county" : "ELKHART" },
            "46508": { "city" : "BURKET", "state" : "IN", "county" : "KOSCIUSKO" },
            "46510": { "city" : "CLAYPOOL", "state" : "IN", "county" : "KOSCIUSKO" },
            "46511": { "city" : "CULVER", "state" : "IN", "county" : "MARSHALL" },
            "46513": { "city" : "DONALDSON", "state" : "IN", "county" : "MARSHALL" },
            "46514": { "city" : "ELKHART", "state" : "IN", "county" : "ELKHART" },
            "46515": { "city" : "ELKHART", "state" : "IN", "county" : "ELKHART" },
            "46516": { "city" : "ELKHART", "state" : "IN", "county" : "ELKHART" },
            "46517": { "city" : "ELKHART", "state" : "IN", "county" : "ELKHART" },
            "46524": { "city" : "ETNA GREEN", "state" : "IN", "county" : "KOSCIUSKO" },
            "46526": { "city" : "GOSHEN", "state" : "IN", "county" : "ELKHART" },
            "46527": { "city" : "GOSHEN", "state" : "IN", "county" : "ELKHART" },
            "46528": { "city" : "GOSHEN", "state" : "IN", "county" : "ELKHART" },
            "46530": { "city" : "GRANGER", "state" : "IN", "county" : "ST JOSEPH" },
            "46531": { "city" : "GROVERTOWN", "state" : "IN", "county" : "STARKE" },
            "46532": { "city" : "HAMLET", "state" : "IN", "county" : "STARKE" },"46534": { "city" : "KNOX", "state" : "IN", "county" : "STARKE" },
            "46536": { "city" : "LAKEVILLE", "state" : "IN", "county" : "ST JOSEPH" },
            "46537": { "city" : "LAPAZ", "state" : "IN", "county" : "MARSHALL" },
            "46538": { "city" : "LEESBURG", "state" : "IN", "county" : "KOSCIUSKO" },
            "46539": { "city" : "MENTONE", "state" : "IN", "county" : "KOSCIUSKO" },
            "46540": { "city" : "MIDDLEBURY", "state" : "IN", "county" : "ELKHART" },
            "46542": { "city" : "MILFORD", "state" : "IN", "county" : "KOSCIUSKO" },
            "46543": { "city" : "MILLERSBURG", "state" : "IN", "county" : "ELKHART" },
            "46544": { "city" : "MISHAWAKA", "state" : "IN", "county" : "ST JOSEPH" },
            "46545": { "city" : "MISHAWAKA", "state" : "IN", "county" : "ST JOSEPH" },
            "46546": { "city" : "MISHAWAKA", "state" : "IN", "county" : "ST JOSEPH" },
            "46550": { "city" : "NAPPANEE", "state" : "IN", "county" : "ELKHART" },
            "46552": { "city" : "NEW CARLISLE", "state" : "IN", "county" : "ST JOSEPH" },
            "46553": { "city" : "NEW PARIS", "state" : "IN", "county" : "ELKHART" },
            "46554": { "city" : "NORTH LIBERTY", "state" : "IN", "county" : "ST JOSEPH" },
            "46555": { "city" : "NORTH WEBSTER", "state" : "IN", "county" : "KOSCIUSKO" },
            "46556": { "city" : "NOTRE DAME", "state" : "IN", "county" : "ST JOSEPH" },
            "46561": { "city" : "OSCEOLA", "state" : "IN", "county" : "ST JOSEPH" },
            "46562": { "city" : "PIERCETON", "state" : "IN", "county" : "KOSCIUSKO" },
            "46563": { "city" : "PLYMOUTH", "state" : "IN", "county" : "MARSHALL" },
            "46565": { "city" : "SHIPSHEWANA", "state" : "IN", "county" : "LAGRANGE" },
            "46567": { "city" : "SYRACUSE", "state" : "IN", "county" : "KOSCIUSKO" },
            "46570": { "city" : "TIPPECANOE", "state" : "IN", "county" : "MARSHALL" },
            "46571": { "city" : "TOPEKA", "state" : "IN", "county" : "LAGRANGE" },
            "46572": { "city" : "TYNER", "state" : "IN", "county" : "MARSHALL" },
            "46573": { "city" : "WAKARUSA", "state" : "IN", "county" : "ELKHART" },
            "46574": { "city" : "WALKERTON", "state" : "IN", "county" : "ST JOSEPH" },
            "46580": { "city" : "WARSAW", "state" : "IN", "county" : "KOSCIUSKO" },
            "46581": { "city" : "WARSAW", "state" : "IN", "county" : "KOSCIUSKO" },
            "46582": { "city" : "WARSAW", "state" : "IN", "county" : "KOSCIUSKO" },
            "46590": { "city" : "WINONA LAKE", "state" : "IN", "county" : "KOSCIUSKO" },
            "46595": { "city" : "WYATT", "state" : "IN", "county" : "ST JOSEPH" },
            "46601": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46613": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46614": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46615": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46616": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46617": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46619": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46624": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46626": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46628": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46634": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46635": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46637": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46660": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46680": { "city" : "SOUTH BEND", "state" : "IN", "county" : "ST JOSEPH" },
            "46701": { "city" : "ALBION", "state" : "IN", "county" : "NOBLE" },"46702": { "city" : "ANDREWS", "state" : "IN", "county" : "HUNTINGTON" },
            "46703": { "city" : "ANGOLA", "state" : "IN", "county" : "STEUBEN" },
            "46704": { "city" : "ARCOLA", "state" : "IN", "county" : "ALLEN" },"46705": { "city" : "ASHLEY", "state" : "IN", "county" : "DE KALB" },
            "46706": { "city" : "AUBURN", "state" : "IN", "county" : "DE KALB" },
            "46710": { "city" : "AVILLA", "state" : "IN", "county" : "NOBLE" },"46711": { "city" : "BERNE", "state" : "IN", "county" : "ADAMS" },
            "46713": { "city" : "BIPPUS", "state" : "IN", "county" : "HUNTINGTON" },
            "46714": { "city" : "BLUFFTON", "state" : "IN", "county" : "WELLS" },
            "46721": { "city" : "BUTLER", "state" : "IN", "county" : "DE KALB" },
            "46723": { "city" : "CHURUBUSCO", "state" : "IN", "county" : "WHITLEY" },
            "46725": { "city" : "COLUMBIA CITY", "state" : "IN", "county" : "WHITLEY" },
            "46730": { "city" : "CORUNNA", "state" : "IN", "county" : "DE KALB" },
            "46731": { "city" : "CRAIGVILLE", "state" : "IN", "county" : "WELLS" },
            "46732": { "city" : "CROMWELL", "state" : "IN", "county" : "NOBLE" },
            "46733": { "city" : "DECATUR", "state" : "IN", "county" : "ADAMS" },"46737": { "city" : "FREMONT", "state" : "IN", "county" : "STEUBEN" },
            "46738": { "city" : "GARRETT", "state" : "IN", "county" : "DE KALB" },
            "46740": { "city" : "GENEVA", "state" : "IN", "county" : "ADAMS" },"46741": { "city" : "GRABILL", "state" : "IN", "county" : "ALLEN" },
            "46742": { "city" : "HAMILTON", "state" : "IN", "county" : "STEUBEN" },
            "46743": { "city" : "HARLAN", "state" : "IN", "county" : "ALLEN" },"46745": { "city" : "HOAGLAND", "state" : "IN", "county" : "ALLEN" },
            "46746": { "city" : "HOWE", "state" : "IN", "county" : "LAGRANGE" },"46747": { "city" : "HUDSON", "state" : "IN", "county" : "STEUBEN" },
            "46748": { "city" : "HUNTERTOWN", "state" : "IN", "county" : "ALLEN" },
            "46750": { "city" : "HUNTINGTON", "state" : "IN", "county" : "HUNTINGTON" },
            "46755": { "city" : "KENDALLVILLE", "state" : "IN", "county" : "NOBLE" },
            "46759": { "city" : "KEYSTONE", "state" : "IN", "county" : "WELLS" },
            "46760": { "city" : "KIMMELL", "state" : "IN", "county" : "NOBLE" },"46761": { "city" : "LAGRANGE", "state" : "IN", "county" : "LAGRANGE" },
            "46763": { "city" : "LAOTTO", "state" : "IN", "county" : "NOBLE" },"46764": { "city" : "LARWILL", "state" : "IN", "county" : "WHITLEY" },
            "46765": { "city" : "LEO", "state" : "IN", "county" : "ALLEN" },"46766": { "city" : "LIBERTY CENTER", "state" : "IN", "county" : "WELLS" },
            "46767": { "city" : "LIGONIER", "state" : "IN", "county" : "NOBLE" },
            "46769": { "city" : "LINN GROVE", "state" : "IN", "county" : "ADAMS" },
            "46770": { "city" : "MARKLE", "state" : "IN", "county" : "WELLS" },"46771": { "city" : "MONGO", "state" : "IN", "county" : "LAGRANGE" },
            "46772": { "city" : "MONROE", "state" : "IN", "county" : "ADAMS" },"46773": { "city" : "MONROEVILLE", "state" : "IN", "county" : "ALLEN" },
            "46774": { "city" : "NEW HAVEN", "state" : "IN", "county" : "ALLEN" },
            "46776": { "city" : "ORLAND", "state" : "IN", "county" : "STEUBEN" },
            "46777": { "city" : "OSSIAN", "state" : "IN", "county" : "WELLS" },"46778": { "city" : "PETROLEUM", "state" : "IN", "county" : "WELLS" },
            "46779": { "city" : "PLEASANT LAKE", "state" : "IN", "county" : "STEUBEN" },
            "46780": { "city" : "PLEASANT MILLS", "state" : "IN", "county" : "ADAMS" },
            "46781": { "city" : "PONETO", "state" : "IN", "county" : "WELLS" },"46782": { "city" : "PREBLE", "state" : "IN", "county" : "ADAMS" },
            "46783": { "city" : "ROANOKE", "state" : "IN", "county" : "HUNTINGTON" },
            "46784": { "city" : "ROME CITY", "state" : "IN", "county" : "NOBLE" },
            "46785": { "city" : "SAINT JOE", "state" : "IN", "county" : "DE KALB" },
            "46786": { "city" : "SOUTH MILFORD", "state" : "IN", "county" : "LAGRANGE" },
            "46787": { "city" : "SOUTH WHITLEY", "state" : "IN", "county" : "WHITLEY" },
            "46788": { "city" : "SPENCERVILLE", "state" : "IN", "county" : "ALLEN" },
            "46789": { "city" : "STROH", "state" : "IN", "county" : "LAGRANGE" },
            "46791": { "city" : "UNIONDALE", "state" : "IN", "county" : "WELLS" },
            "46792": { "city" : "WARREN", "state" : "IN", "county" : "HUNTINGTON" },
            "46793": { "city" : "WATERLOO", "state" : "IN", "county" : "DE KALB" },
            "46794": { "city" : "WAWAKA", "state" : "IN", "county" : "NOBLE" },"46795": { "city" : "WOLCOTTVILLE", "state" : "IN", "county" : "LAGRANGE" },
            "46796": { "city" : "WOLFLAKE", "state" : "IN", "county" : "NOBLE" },
            "46797": { "city" : "WOODBURN", "state" : "IN", "county" : "ALLEN" },
            "46798": { "city" : "YODER", "state" : "IN", "county" : "ALLEN" },"46799": { "city" : "ZANESVILLE", "state" : "IN", "county" : "ALLEN" },
            "46801": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46802": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46803": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46804": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46805": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46806": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46807": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46808": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46809": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46814": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46815": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46816": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46818": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46819": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46825": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46835": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46845": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46850": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46851": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46852": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46853": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46854": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46855": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46856": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46857": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46861": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46862": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46863": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46864": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46865": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46867": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46885": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46895": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46896": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46898": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46899": { "city" : "FORT WAYNE", "state" : "IN", "county" : "ALLEN" },
            "46901": { "city" : "KOKOMO", "state" : "IN", "county" : "HOWARD" },"46902": { "city" : "KOKOMO", "state" : "IN", "county" : "HOWARD" },
            "46903": { "city" : "KOKOMO", "state" : "IN", "county" : "HOWARD" },"46904": { "city" : "KOKOMO", "state" : "IN", "county" : "HOWARD" },
            "46910": { "city" : "AKRON", "state" : "IN", "county" : "FULTON" },"46911": { "city" : "AMBOY", "state" : "IN", "county" : "MIAMI" },
            "46913": { "city" : "BRINGHURST", "state" : "IN", "county" : "CARROLL" },
            "46914": { "city" : "BUNKER HILL", "state" : "IN", "county" : "MIAMI" },
            "46915": { "city" : "BURLINGTON", "state" : "IN", "county" : "CARROLL" },
            "46916": { "city" : "BURROWS", "state" : "IN", "county" : "CARROLL" },
            "46917": { "city" : "CAMDEN", "state" : "IN", "county" : "CARROLL" },
            "46919": { "city" : "CONVERSE", "state" : "IN", "county" : "MIAMI" },
            "46920": { "city" : "CUTLER", "state" : "IN", "county" : "CARROLL" },
            "46922": { "city" : "DELONG", "state" : "IN", "county" : "FULTON" },"46923": { "city" : "DELPHI", "state" : "IN", "county" : "CARROLL" },
            "46926": { "city" : "DENVER", "state" : "IN", "county" : "MIAMI" },"46928": { "city" : "FAIRMOUNT", "state" : "IN", "county" : "GRANT" },
            "46929": { "city" : "FLORA", "state" : "IN", "county" : "CARROLL" },"46930": { "city" : "FOWLERTON", "state" : "IN", "county" : "GRANT" },
            "46931": { "city" : "FULTON", "state" : "IN", "county" : "FULTON" },"46932": { "city" : "GALVESTON", "state" : "IN", "county" : "CASS" },
            "46933": { "city" : "GAS CITY", "state" : "IN", "county" : "GRANT" },
            "46936": { "city" : "GREENTOWN", "state" : "IN", "county" : "HOWARD" },
            "46937": { "city" : "HEMLOCK", "state" : "IN", "county" : "HOWARD" },
            "46938": { "city" : "JONESBORO", "state" : "IN", "county" : "GRANT" },
            "46939": { "city" : "KEWANNA", "state" : "IN", "county" : "FULTON" },
            "46940": { "city" : "LA FONTAINE", "state" : "IN", "county" : "WABASH" },
            "46941": { "city" : "LAGRO", "state" : "IN", "county" : "WABASH" },"46942": { "city" : "LAKE CICOTT", "state" : "IN", "county" : "CASS" },
            "46943": { "city" : "LAKETON", "state" : "IN", "county" : "WABASH" },
            "46945": { "city" : "LEITERS FORD", "state" : "IN", "county" : "FULTON" },
            "46946": { "city" : "LIBERTY MILLS", "state" : "IN", "county" : "WABASH" },
            "46947": { "city" : "LOGANSPORT", "state" : "IN", "county" : "CASS" },
            "46950": { "city" : "LUCERNE", "state" : "IN", "county" : "CASS" },"46951": { "city" : "MACY", "state" : "IN", "county" : "MIAMI" },
            "46952": { "city" : "MARION", "state" : "IN", "county" : "GRANT" },"46953": { "city" : "MARION", "state" : "IN", "county" : "GRANT" },
            "46957": { "city" : "MATTHEWS", "state" : "IN", "county" : "GRANT" },
            "46958": { "city" : "MEXICO", "state" : "IN", "county" : "MIAMI" },"46959": { "city" : "MIAMI", "state" : "IN", "county" : "MIAMI" },
            "46960": { "city" : "MONTEREY", "state" : "IN", "county" : "PULASKI" },
            "46961": { "city" : "NEW WAVERLY", "state" : "IN", "county" : "CASS" },
            "46962": { "city" : "NORTH MANCHESTER", "state" : "IN", "county" : "WABASH" },
            "46965": { "city" : "OAKFORD", "state" : "IN", "county" : "HOWARD" },
            "46967": { "city" : "ONWARD", "state" : "IN", "county" : "CASS" },"46970": { "city" : "PERU", "state" : "IN", "county" : "MIAMI" },
            "46971": { "city" : "GRISSOM ARB", "state" : "IN", "county" : "MIAMI" },
            "46974": { "city" : "ROANN", "state" : "IN", "county" : "WABASH" },"46975": { "city" : "ROCHESTER", "state" : "IN", "county" : "FULTON" },
            "46977": { "city" : "ROCKFIELD", "state" : "IN", "county" : "CARROLL" },
            "46978": { "city" : "ROYAL CENTER", "state" : "IN", "county" : "CASS" },
            "46979": { "city" : "RUSSIAVILLE", "state" : "IN", "county" : "HOWARD" },
            "46980": { "city" : "SERVIA", "state" : "IN", "county" : "WABASH" },"46982": { "city" : "SILVER LAKE", "state" : "IN", "county" : "KOSCIUSKO" },
            "46984": { "city" : "SOMERSET", "state" : "IN", "county" : "WABASH" },
            "46985": { "city" : "STAR CITY", "state" : "IN", "county" : "PULASKI" },
            "46986": { "city" : "SWAYZEE", "state" : "IN", "county" : "GRANT" },"46987": { "city" : "SWEETSER", "state" : "IN", "county" : "GRANT" },
            "46988": { "city" : "TWELVE MILE", "state" : "IN", "county" : "CASS" },
            "46989": { "city" : "UPLAND", "state" : "IN", "county" : "GRANT" },"46990": { "city" : "URBANA", "state" : "IN", "county" : "WABASH" },
            "46991": { "city" : "VAN BUREN", "state" : "IN", "county" : "GRANT" },
            "46992": { "city" : "WABASH", "state" : "IN", "county" : "WABASH" },"46994": { "city" : "WALTON", "state" : "IN", "county" : "CASS" },
            "46995": { "city" : "WEST MIDDLETON", "state" : "IN", "county" : "HOWARD" },
            "46996": { "city" : "WINAMAC", "state" : "IN", "county" : "PULASKI" },
            "47001": { "city" : "AURORA", "state" : "IN", "county" : "DEARBORN" },
            "47003": { "city" : "WEST COLLEGE CORNER", "state" : "IN", "county" : "UNION" },
            "47006": { "city" : "BATESVILLE", "state" : "IN", "county" : "RIPLEY" },
            "47010": { "city" : "BATH", "state" : "IN", "county" : "FRANKLIN" },"47011": { "city" : "BENNINGTON", "state" : "IN", "county" : "SWITZERLAND" },
            "47012": { "city" : "BROOKVILLE", "state" : "IN", "county" : "FRANKLIN" },
            "47016": { "city" : "CEDAR GROVE", "state" : "IN", "county" : "FRANKLIN" },
            "47017": { "city" : "CROSS PLAINS", "state" : "IN", "county" : "RIPLEY" },
            "47018": { "city" : "DILLSBORO", "state" : "IN", "county" : "DEARBORN" },
            "47019": { "city" : "EAST ENTERPRISE", "state" : "IN", "county" : "SWITZERLAND" },
            "47020": { "city" : "FLORENCE", "state" : "IN", "county" : "SWITZERLAND" },
            "47021": { "city" : "FRIENDSHIP", "state" : "IN", "county" : "RIPLEY" },
            "47022": { "city" : "GUILFORD", "state" : "IN", "county" : "DEARBORN" },
            "47023": { "city" : "HOLTON", "state" : "IN", "county" : "RIPLEY" },"47024": { "city" : "LAUREL", "state" : "IN", "county" : "FRANKLIN" },
            "47025": { "city" : "LAWRENCEBURG", "state" : "IN", "county" : "DEARBORN" },
            "47030": { "city" : "METAMORA", "state" : "IN", "county" : "FRANKLIN" },
            "47031": { "city" : "MILAN", "state" : "IN", "county" : "RIPLEY" },"47032": { "city" : "MOORES HILL", "state" : "IN", "county" : "DEARBORN" },
            "47033": { "city" : "MORRIS", "state" : "IN", "county" : "RIPLEY" },"47034": { "city" : "NAPOLEON", "state" : "IN", "county" : "RIPLEY" },
            "47035": { "city" : "NEW TRENTON", "state" : "IN", "county" : "FRANKLIN" },
            "47036": { "city" : "OLDENBURG", "state" : "IN", "county" : "FRANKLIN" },
            "47037": { "city" : "OSGOOD", "state" : "IN", "county" : "RIPLEY" },"47038": { "city" : "PATRIOT", "state" : "IN", "county" : "SWITZERLAND" },
            "47039": { "city" : "PIERCEVILLE", "state" : "IN", "county" : "RIPLEY" },
            "47040": { "city" : "RISING SUN", "state" : "IN", "county" : "OHIO" },
            "47041": { "city" : "SUNMAN", "state" : "IN", "county" : "RIPLEY" },"47042": { "city" : "VERSAILLES", "state" : "IN", "county" : "RIPLEY" },
            "47043": { "city" : "VEVAY", "state" : "IN", "county" : "SWITZERLAND" },
            "47060": { "city" : "WEST HARRISON", "state" : "IN", "county" : "DEARBORN" },
            "47102": { "city" : "AUSTIN", "state" : "IN", "county" : "SCOTT" },"47106": { "city" : "BORDEN", "state" : "IN", "county" : "CLARK" },
            "47108": { "city" : "CAMPBELLSBURG", "state" : "IN", "county" : "WASHINGTON" },
            "47110": { "city" : "CENTRAL", "state" : "IN", "county" : "HARRISON" },
            "47111": { "city" : "CHARLESTOWN", "state" : "IN", "county" : "CLARK" },
            "47112": { "city" : "CORYDON", "state" : "IN", "county" : "HARRISON" },
            "47114": { "city" : "CRANDALL", "state" : "IN", "county" : "HARRISON" },
            "47115": { "city" : "DEPAUW", "state" : "IN", "county" : "HARRISON" },
            "47116": { "city" : "ECKERTY", "state" : "IN", "county" : "CRAWFORD" },
            "47117": { "city" : "ELIZABETH", "state" : "IN", "county" : "HARRISON" },
            "47118": { "city" : "ENGLISH", "state" : "IN", "county" : "CRAWFORD" },
            "47119": { "city" : "FLOYDS KNOBS", "state" : "IN", "county" : "FLOYD" },
            "47120": { "city" : "FREDERICKSBURG", "state" : "IN", "county" : "WASHINGTON" },
            "47122": { "city" : "GEORGETOWN", "state" : "IN", "county" : "FLOYD" },
            "47124": { "city" : "GREENVILLE", "state" : "IN", "county" : "FLOYD" },
            "47125": { "city" : "HARDINSBURG", "state" : "IN", "county" : "WASHINGTON" },
            "47126": { "city" : "HENRYVILLE", "state" : "IN", "county" : "CLARK" },
            "47129": { "city" : "CLARKSVILLE", "state" : "IN", "county" : "CLARK" },
            "47130": { "city" : "JEFFERSONVILLE", "state" : "IN", "county" : "CLARK" },
            "47131": { "city" : "JEFFERSONVILLE", "state" : "IN", "county" : "CLARK" },
            "47135": { "city" : "LACONIA", "state" : "IN", "county" : "HARRISON" },
            "47136": { "city" : "LANESVILLE", "state" : "IN", "county" : "HARRISON" },
            "47137": { "city" : "LEAVENWORTH", "state" : "IN", "county" : "CRAWFORD" },
            "47138": { "city" : "LEXINGTON", "state" : "IN", "county" : "SCOTT" },
            "47139": { "city" : "LITTLE YORK", "state" : "IN", "county" : "WASHINGTON" },
            "47140": { "city" : "MARENGO", "state" : "IN", "county" : "CRAWFORD" },
            "47141": { "city" : "MARYSVILLE", "state" : "IN", "county" : "CLARK" },
            "47142": { "city" : "MAUCKPORT", "state" : "IN", "county" : "HARRISON" },
            "47143": { "city" : "MEMPHIS", "state" : "IN", "county" : "CLARK" },"47145": { "city" : "MILLTOWN", "state" : "IN", "county" : "CRAWFORD" },
            "47146": { "city" : "MOUNT SAINT FRANCIS", "state" : "IN", "county" : "FLOYD" },
            "47147": { "city" : "NABB", "state" : "IN", "county" : "CLARK" },"47150": { "city" : "NEW ALBANY", "state" : "IN", "county" : "FLOYD" },
            "47151": { "city" : "NEW ALBANY", "state" : "IN", "county" : "FLOYD" },
            "47160": { "city" : "NEW MIDDLETOWN", "state" : "IN", "county" : "HARRISON" },
            "47161": { "city" : "NEW SALISBURY", "state" : "IN", "county" : "HARRISON" },
            "47162": { "city" : "NEW WASHINGTON", "state" : "IN", "county" : "CLARK" },
            "47163": { "city" : "OTISCO", "state" : "IN", "county" : "CLARK" },"47164": { "city" : "PALMYRA", "state" : "IN", "county" : "HARRISON" },
            "47165": { "city" : "PEKIN", "state" : "IN", "county" : "WASHINGTON" },
            "47166": { "city" : "RAMSEY", "state" : "IN", "county" : "HARRISON" },
            "47167": { "city" : "SALEM", "state" : "IN", "county" : "WASHINGTON" },
            "47170": { "city" : "SCOTTSBURG", "state" : "IN", "county" : "SCOTT" },
            "47172": { "city" : "SELLERSBURG", "state" : "IN", "county" : "CLARK" },
            "47174": { "city" : "SULPHUR", "state" : "IN", "county" : "CRAWFORD" },
            "47175": { "city" : "TASWELL", "state" : "IN", "county" : "CRAWFORD" },
            "47177": { "city" : "UNDERWOOD", "state" : "IN", "county" : "SCOTT" },
            "47201": { "city" : "COLUMBUS", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47202": { "city" : "COLUMBUS", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47203": { "city" : "COLUMBUS", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47220": { "city" : "BROWNSTOWN", "state" : "IN", "county" : "JACKSON" },
            "47223": { "city" : "BUTLERVILLE", "state" : "IN", "county" : "JENNINGS" },
            "47224": { "city" : "CANAAN", "state" : "IN", "county" : "JEFFERSON" },
            "47225": { "city" : "CLARKSBURG", "state" : "IN", "county" : "DECATUR" },
            "47226": { "city" : "CLIFFORD", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47227": { "city" : "COMMISKEY", "state" : "IN", "county" : "JENNINGS" },
            "47229": { "city" : "CROTHERSVILLE", "state" : "IN", "county" : "JACKSON" },
            "47230": { "city" : "DEPUTY", "state" : "IN", "county" : "JEFFERSON" },
            "47231": { "city" : "DUPONT", "state" : "IN", "county" : "JEFFERSON" },
            "47232": { "city" : "ELIZABETHTOWN", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47234": { "city" : "FLAT ROCK", "state" : "IN", "county" : "SHELBY" },
            "47235": { "city" : "FREETOWN", "state" : "IN", "county" : "JACKSON" },
            "47236": { "city" : "GRAMMER", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47240": { "city" : "GREENSBURG", "state" : "IN", "county" : "DECATUR" },
            "47243": { "city" : "HANOVER", "state" : "IN", "county" : "JEFFERSON" },
            "47244": { "city" : "HARTSVILLE", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47245": { "city" : "HAYDEN", "state" : "IN", "county" : "JENNINGS" },
            "47246": { "city" : "HOPE", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47247": { "city" : "JONESVILLE", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47250": { "city" : "MADISON", "state" : "IN", "county" : "JEFFERSON" },
            "47260": { "city" : "MEDORA", "state" : "IN", "county" : "JACKSON" },
            "47261": { "city" : "MILLHOUSEN", "state" : "IN", "county" : "DECATUR" },
            "47263": { "city" : "NEW POINT", "state" : "IN", "county" : "DECATUR" },
            "47264": { "city" : "NORMAN", "state" : "IN", "county" : "JACKSON" },
            "47265": { "city" : "NORTH VERNON", "state" : "IN", "county" : "JENNINGS" },
            "47270": { "city" : "PARIS CROSSING", "state" : "IN", "county" : "JENNINGS" },
            "47272": { "city" : "SAINT PAUL", "state" : "IN", "county" : "DECATUR" },
            "47273": { "city" : "SCIPIO", "state" : "IN", "county" : "JENNINGS" },
            "47274": { "city" : "SEYMOUR", "state" : "IN", "county" : "JACKSON" },
            "47280": { "city" : "TAYLORSVILLE", "state" : "IN", "county" : "BARTHOLOMEW" },
            "47281": { "city" : "VALLONIA", "state" : "IN", "county" : "JACKSON" },
            "47282": { "city" : "VERNON", "state" : "IN", "county" : "JENNINGS" },
            "47283": { "city" : "WESTPORT", "state" : "IN", "county" : "DECATUR" },
            "47302": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47303": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47304": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47305": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47306": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47307": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47308": { "city" : "MUNCIE", "state" : "IN", "county" : "DELAWARE" },
            "47320": { "city" : "ALBANY", "state" : "IN", "county" : "DELAWARE" },
            "47324": { "city" : "BOSTON", "state" : "IN", "county" : "WAYNE" },"47325": { "city" : "BROWNSVILLE", "state" : "IN", "county" : "UNION" },
            "47326": { "city" : "BRYANT", "state" : "IN", "county" : "JAY" },"47327": { "city" : "CAMBRIDGE CITY", "state" : "IN", "county" : "WAYNE" },
            "47330": { "city" : "CENTERVILLE", "state" : "IN", "county" : "WAYNE" },
            "47331": { "city" : "CONNERSVILLE", "state" : "IN", "county" : "FAYETTE" },
            "47334": { "city" : "DALEVILLE", "state" : "IN", "county" : "DELAWARE" },
            "47335": { "city" : "DUBLIN", "state" : "IN", "county" : "WAYNE" },"47336": { "city" : "DUNKIRK", "state" : "IN", "county" : "JAY" },
            "47337": { "city" : "DUNREITH", "state" : "IN", "county" : "HENRY" },
            "47338": { "city" : "EATON", "state" : "IN", "county" : "DELAWARE" },
            "47339": { "city" : "ECONOMY", "state" : "IN", "county" : "WAYNE" },"47340": { "city" : "FARMLAND", "state" : "IN", "county" : "RANDOLPH" },
            "47341": { "city" : "FOUNTAIN CITY", "state" : "IN", "county" : "WAYNE" },
            "47342": { "city" : "GASTON", "state" : "IN", "county" : "DELAWARE" },
            "47345": { "city" : "GREENS FORK", "state" : "IN", "county" : "WAYNE" },
            "47346": { "city" : "HAGERSTOWN", "state" : "IN", "county" : "WAYNE" },
            "47348": { "city" : "HARTFORD CITY", "state" : "IN", "county" : "BLACKFORD" },
            "47351": { "city" : "KENNARD", "state" : "IN", "county" : "HENRY" },"47352": { "city" : "LEWISVILLE", "state" : "IN", "county" : "HENRY" },
            "47353": { "city" : "LIBERTY", "state" : "IN", "county" : "UNION" },"47354": { "city" : "LOSANTVILLE", "state" : "IN", "county" : "RANDOLPH" },
            "47355": { "city" : "LYNN", "state" : "IN", "county" : "RANDOLPH" },"47356": { "city" : "MIDDLETOWN", "state" : "IN", "county" : "HENRY" },
            "47357": { "city" : "MILTON", "state" : "IN", "county" : "WAYNE" },"47358": { "city" : "MODOC", "state" : "IN", "county" : "RANDOLPH" },
            "47359": { "city" : "MONTPELIER", "state" : "IN", "county" : "BLACKFORD" },
            "47360": { "city" : "MOORELAND", "state" : "IN", "county" : "HENRY" },
            "47361": { "city" : "MOUNT SUMMIT", "state" : "IN", "county" : "HENRY" },
            "47362": { "city" : "NEW CASTLE", "state" : "IN", "county" : "HENRY" },
            "47366": { "city" : "NEW LISBON", "state" : "IN", "county" : "HENRY" },
            "47367": { "city" : "OAKVILLE", "state" : "IN", "county" : "DELAWARE" },
            "47368": { "city" : "PARKER CITY", "state" : "IN", "county" : "RANDOLPH" },
            "47369": { "city" : "PENNVILLE", "state" : "IN", "county" : "JAY" },"47370": { "city" : "PERSHING", "state" : "IN", "county" : "WAYNE" },
            "47371": { "city" : "PORTLAND", "state" : "IN", "county" : "JAY" },"47373": { "city" : "REDKEY", "state" : "IN", "county" : "JAY" },
            "47374": { "city" : "RICHMOND", "state" : "IN", "county" : "WAYNE" },
            "47375": { "city" : "RICHMOND", "state" : "IN", "county" : "WAYNE" },
            "47380": { "city" : "RIDGEVILLE", "state" : "IN", "county" : "RANDOLPH" },
            "47381": { "city" : "SALAMONIA", "state" : "IN", "county" : "JAY" },"47382": { "city" : "SARATOGA", "state" : "IN", "county" : "RANDOLPH" },
            "47383": { "city" : "SELMA", "state" : "IN", "county" : "DELAWARE" },
            "47384": { "city" : "SHIRLEY", "state" : "IN", "county" : "HENRY" },"47385": { "city" : "SPICELAND", "state" : "IN", "county" : "HENRY" },
            "47386": { "city" : "SPRINGPORT", "state" : "IN", "county" : "HENRY" },
            "47387": { "city" : "STRAUGHN", "state" : "IN", "county" : "HENRY" },
            "47388": { "city" : "SULPHUR SPRINGS", "state" : "IN", "county" : "HENRY" },
            "47390": { "city" : "UNION CITY", "state" : "IN", "county" : "RANDOLPH" },
            "47392": { "city" : "WEBSTER", "state" : "IN", "county" : "WAYNE" },"47393": { "city" : "WILLIAMSBURG", "state" : "IN", "county" : "WAYNE" },
            "47394": { "city" : "WINCHESTER", "state" : "IN", "county" : "RANDOLPH" },
            "47396": { "city" : "YORKTOWN", "state" : "IN", "county" : "DELAWARE" },
            "47401": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47402": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47403": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47404": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47405": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47406": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47407": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47408": { "city" : "BLOOMINGTON", "state" : "IN", "county" : "MONROE" },
            "47420": { "city" : "AVOCA", "state" : "IN", "county" : "LAWRENCE" },
            "47421": { "city" : "BEDFORD", "state" : "IN", "county" : "LAWRENCE" },
            "47424": { "city" : "BLOOMFIELD", "state" : "IN", "county" : "GREENE" },
            "47426": { "city" : "CLEAR CREEK", "state" : "IN", "county" : "MONROE" },
            "47427": { "city" : "COAL CITY", "state" : "IN", "county" : "OWEN" },
            "47429": { "city" : "ELLETTSVILLE", "state" : "IN", "county" : "MONROE" },
            "47431": { "city" : "FREEDOM", "state" : "IN", "county" : "OWEN" },"47432": { "city" : "FRENCH LICK", "state" : "IN", "county" : "ORANGE" },
            "47433": { "city" : "GOSPORT", "state" : "IN", "county" : "OWEN" },"47434": { "city" : "HARRODSBURG", "state" : "IN", "county" : "MONROE" },
            "47435": { "city" : "HELMSBURG", "state" : "IN", "county" : "BROWN" },
            "47436": { "city" : "HELTONVILLE", "state" : "IN", "county" : "LAWRENCE" },
            "47437": { "city" : "HURON", "state" : "IN", "county" : "LAWRENCE" },
            "47438": { "city" : "JASONVILLE", "state" : "IN", "county" : "GREENE" },
            "47441": { "city" : "LINTON", "state" : "IN", "county" : "GREENE" },"47443": { "city" : "LYONS", "state" : "IN", "county" : "GREENE" },
            "47445": { "city" : "MIDLAND", "state" : "IN", "county" : "GREENE" },
            "47446": { "city" : "MITCHELL", "state" : "IN", "county" : "LAWRENCE" },
            "47448": { "city" : "NASHVILLE", "state" : "IN", "county" : "BROWN" },
            "47449": { "city" : "NEWBERRY", "state" : "IN", "county" : "GREENE" },
            "47451": { "city" : "OOLITIC", "state" : "IN", "county" : "LAWRENCE" },
            "47452": { "city" : "ORLEANS", "state" : "IN", "county" : "ORANGE" },
            "47453": { "city" : "OWENSBURG", "state" : "IN", "county" : "GREENE" },
            "47454": { "city" : "PAOLI", "state" : "IN", "county" : "ORANGE" },"47456": { "city" : "QUINCY", "state" : "IN", "county" : "OWEN" },
            "47457": { "city" : "SCOTLAND", "state" : "IN", "county" : "GREENE" },
            "47458": { "city" : "SMITHVILLE", "state" : "IN", "county" : "MONROE" },
            "47459": { "city" : "SOLSBERRY", "state" : "IN", "county" : "GREENE" },
            "47460": { "city" : "SPENCER", "state" : "IN", "county" : "OWEN" },"47462": { "city" : "SPRINGVILLE", "state" : "IN", "county" : "LAWRENCE" },
            "47463": { "city" : "STANFORD", "state" : "IN", "county" : "MONROE" },
            "47464": { "city" : "STINESVILLE", "state" : "IN", "county" : "MONROE" },
            "47465": { "city" : "SWITZ CITY", "state" : "IN", "county" : "GREENE" },
            "47467": { "city" : "TUNNELTON", "state" : "IN", "county" : "LAWRENCE" },
            "47468": { "city" : "UNIONVILLE", "state" : "IN", "county" : "MONROE" },
            "47469": { "city" : "WEST BADEN SPRINGS", "state" : "IN", "county" : "ORANGE" },
            "47470": { "city" : "WILLIAMS", "state" : "IN", "county" : "LAWRENCE" },
            "47471": { "city" : "WORTHINGTON", "state" : "IN", "county" : "GREENE" },
            "47501": { "city" : "WASHINGTON", "state" : "IN", "county" : "DAVIESS" },
            "47512": { "city" : "BICKNELL", "state" : "IN", "county" : "KNOX" },"47513": { "city" : "BIRDSEYE", "state" : "IN", "county" : "DUBOIS" },
            "47514": { "city" : "BRANCHVILLE", "state" : "IN", "county" : "PERRY" },
            "47515": { "city" : "BRISTOW", "state" : "IN", "county" : "PERRY" },"47516": { "city" : "BRUCEVILLE", "state" : "IN", "county" : "KNOX" },
            "47519": { "city" : "CANNELBURG", "state" : "IN", "county" : "DAVIESS" },
            "47520": { "city" : "CANNELTON", "state" : "IN", "county" : "PERRY" },
            "47521": { "city" : "CELESTINE", "state" : "IN", "county" : "DUBOIS" },
            "47522": { "city" : "CRANE", "state" : "IN", "county" : "MARTIN" },"47523": { "city" : "DALE", "state" : "IN", "county" : "SPENCER" },
            "47524": { "city" : "DECKER", "state" : "IN", "county" : "KNOX" },"47525": { "city" : "DERBY", "state" : "IN", "county" : "PERRY" },
            "47527": { "city" : "DUBOIS", "state" : "IN", "county" : "DUBOIS" },"47528": { "city" : "EDWARDSPORT", "state" : "IN", "county" : "KNOX" },
            "47529": { "city" : "ELNORA", "state" : "IN", "county" : "DAVIESS" },
            "47531": { "city" : "EVANSTON", "state" : "IN", "county" : "SPENCER" },
            "47532": { "city" : "FERDINAND", "state" : "IN", "county" : "DUBOIS" },
            "47535": { "city" : "FREELANDVILLE", "state" : "IN", "county" : "KNOX" },
            "47536": { "city" : "FULDA", "state" : "IN", "county" : "SPENCER" },"47537": { "city" : "GENTRYVILLE", "state" : "IN", "county" : "SPENCER" },
            "47541": { "city" : "HOLLAND", "state" : "IN", "county" : "DUBOIS" },
            "47542": { "city" : "HUNTINGBURG", "state" : "IN", "county" : "DUBOIS" },
            "47545": { "city" : "IRELAND", "state" : "IN", "county" : "DUBOIS" },
            "47546": { "city" : "JASPER", "state" : "IN", "county" : "DUBOIS" },"47547": { "city" : "JASPER", "state" : "IN", "county" : "DUBOIS" },
            "47549": { "city" : "JASPER", "state" : "IN", "county" : "DUBOIS" },"47550": { "city" : "LAMAR", "state" : "IN", "county" : "SPENCER" },
            "47551": { "city" : "LEOPOLD", "state" : "IN", "county" : "PERRY" },"47552": { "city" : "LINCOLN CITY", "state" : "IN", "county" : "SPENCER" },
            "47553": { "city" : "LOOGOOTEE", "state" : "IN", "county" : "MARTIN" },
            "47556": { "city" : "MARIAH HILL", "state" : "IN", "county" : "SPENCER" },
            "47557": { "city" : "MONROE CITY", "state" : "IN", "county" : "KNOX" },
            "47558": { "city" : "MONTGOMERY", "state" : "IN", "county" : "DAVIESS" },
            "47561": { "city" : "OAKTOWN", "state" : "IN", "county" : "KNOX" },"47562": { "city" : "ODON", "state" : "IN", "county" : "DAVIESS" },
            "47564": { "city" : "OTWELL", "state" : "IN", "county" : "PIKE" },"47567": { "city" : "PETERSBURG", "state" : "IN", "county" : "PIKE" },
            "47568": { "city" : "PLAINVILLE", "state" : "IN", "county" : "DAVIESS" },
            "47575": { "city" : "SAINT ANTHONY", "state" : "IN", "county" : "DUBOIS" },
            "47576": { "city" : "SAINT CROIX", "state" : "IN", "county" : "PERRY" },
            "47577": { "city" : "SAINT MEINRAD", "state" : "IN", "county" : "SPENCER" },
            "47578": { "city" : "SANDBORN", "state" : "IN", "county" : "KNOX" },"47579": { "city" : "SANTA CLAUS", "state" : "IN", "county" : "SPENCER" },
            "47580": { "city" : "SCHNELLVILLE", "state" : "IN", "county" : "DUBOIS" },
            "47581": { "city" : "SHOALS", "state" : "IN", "county" : "MARTIN" },"47584": { "city" : "SPURGEON", "state" : "IN", "county" : "PIKE" },
            "47585": { "city" : "STENDAL", "state" : "IN", "county" : "PIKE" },"47586": { "city" : "TELL CITY", "state" : "IN", "county" : "PERRY" },
            "47588": { "city" : "TROY", "state" : "IN", "county" : "SPENCER" },"47590": { "city" : "VELPEN", "state" : "IN", "county" : "PIKE" },
            "47591": { "city" : "VINCENNES", "state" : "IN", "county" : "KNOX" },
            "47596": { "city" : "WESTPHALIA", "state" : "IN", "county" : "KNOX" },
            "47597": { "city" : "WHEATLAND", "state" : "IN", "county" : "KNOX" },
            "47598": { "city" : "WINSLOW", "state" : "IN", "county" : "PIKE" },"47601": { "city" : "BOONVILLE", "state" : "IN", "county" : "WARRICK" },
            "47610": { "city" : "CHANDLER", "state" : "IN", "county" : "WARRICK" },
            "47611": { "city" : "CHRISNEY", "state" : "IN", "county" : "SPENCER" },
            "47612": { "city" : "CYNTHIANA", "state" : "IN", "county" : "POSEY" },
            "47613": { "city" : "ELBERFELD", "state" : "IN", "county" : "WARRICK" },
            "47615": { "city" : "GRANDVIEW", "state" : "IN", "county" : "SPENCER" },
            "47616": { "city" : "GRIFFIN", "state" : "IN", "county" : "POSEY" },"47617": { "city" : "HATFIELD", "state" : "IN", "county" : "SPENCER" },
            "47618": { "city" : "INGLEFIELD", "state" : "IN", "county" : "VANDERBURGH" },
            "47619": { "city" : "LYNNVILLE", "state" : "IN", "county" : "WARRICK" },
            "47620": { "city" : "MOUNT VERNON", "state" : "IN", "county" : "POSEY" },
            "47629": { "city" : "NEWBURGH", "state" : "IN", "county" : "WARRICK" },
            "47630": { "city" : "NEWBURGH", "state" : "IN", "county" : "WARRICK" },
            "47631": { "city" : "NEW HARMONY", "state" : "IN", "county" : "POSEY" },
            "47633": { "city" : "POSEYVILLE", "state" : "IN", "county" : "POSEY" },
            "47634": { "city" : "RICHLAND", "state" : "IN", "county" : "SPENCER" },
            "47635": { "city" : "ROCKPORT", "state" : "IN", "county" : "SPENCER" },
            "47637": { "city" : "TENNYSON", "state" : "IN", "county" : "WARRICK" },
            "47638": { "city" : "WADESVILLE", "state" : "IN", "county" : "POSEY" },
            "47639": { "city" : "HAUBSTADT", "state" : "IN", "county" : "GIBSON" },
            "47640": { "city" : "HAZLETON", "state" : "IN", "county" : "GIBSON" },
            "47647": { "city" : "BUCKSKIN", "state" : "IN", "county" : "GIBSON" },
            "47648": { "city" : "FORT BRANCH", "state" : "IN", "county" : "GIBSON" },
            "47649": { "city" : "FRANCISCO", "state" : "IN", "county" : "GIBSON" },
            "47654": { "city" : "MACKEY", "state" : "IN", "county" : "GIBSON" },"47660": { "city" : "OAKLAND CITY", "state" : "IN", "county" : "GIBSON" },
            "47665": { "city" : "OWENSVILLE", "state" : "IN", "county" : "GIBSON" },
            "47666": { "city" : "PATOKA", "state" : "IN", "county" : "GIBSON" },"47670": { "city" : "PRINCETON", "state" : "IN", "county" : "GIBSON" },
            "47683": { "city" : "SOMERVILLE", "state" : "IN", "county" : "GIBSON" },
            "47701": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47702": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47703": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47704": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47705": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47706": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47708": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47710": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47711": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47712": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47713": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47714": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47715": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47716": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47719": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47720": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47721": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47722": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47724": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47725": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47727": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47728": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47730": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47733": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47734": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47735": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47736": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47737": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47747": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47750": { "city" : "EVANSVILLE", "state" : "IN", "county" : "VANDERBURGH" },
            "47801": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47802": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47803": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47804": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47805": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47807": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47808": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47809": { "city" : "TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47831": { "city" : "BLANFORD", "state" : "IN", "county" : "VERMILLION" },
            "47832": { "city" : "BLOOMINGDALE", "state" : "IN", "county" : "PARKE" },
            "47833": { "city" : "BOWLING GREEN", "state" : "IN", "county" : "CLAY" },
            "47834": { "city" : "BRAZIL", "state" : "IN", "county" : "CLAY" },"47836": { "city" : "BRIDGETON", "state" : "IN", "county" : "PARKE" },
            "47837": { "city" : "CARBON", "state" : "IN", "county" : "CLAY" },"47838": { "city" : "CARLISLE", "state" : "IN", "county" : "SULLIVAN" },
            "47840": { "city" : "CENTERPOINT", "state" : "IN", "county" : "CLAY" },
            "47841": { "city" : "CLAY CITY", "state" : "IN", "county" : "CLAY" },
            "47842": { "city" : "CLINTON", "state" : "IN", "county" : "VERMILLION" },
            "47845": { "city" : "COALMONT", "state" : "IN", "county" : "CLAY" },"47846": { "city" : "CORY", "state" : "IN", "county" : "CLAY" },
            "47847": { "city" : "DANA", "state" : "IN", "county" : "VERMILLION" },
            "47848": { "city" : "DUGGER", "state" : "IN", "county" : "SULLIVAN" },
            "47849": { "city" : "FAIRBANKS", "state" : "IN", "county" : "SULLIVAN" },
            "47850": { "city" : "FARMERSBURG", "state" : "IN", "county" : "SULLIVAN" },
            "47851": { "city" : "FONTANET", "state" : "IN", "county" : "VIGO" },"47852": { "city" : "GRAYSVILLE", "state" : "IN", "county" : "SULLIVAN" },
            "47853": { "city" : "HARMONY", "state" : "IN", "county" : "CLAY" },"47854": { "city" : "HILLSDALE", "state" : "IN", "county" : "VERMILLION" },
            "47855": { "city" : "HYMERA", "state" : "IN", "county" : "SULLIVAN" },
            "47857": { "city" : "KNIGHTSVILLE", "state" : "IN", "county" : "CLAY" },
            "47858": { "city" : "LEWIS", "state" : "IN", "county" : "VIGO" },"47859": { "city" : "MARSHALL", "state" : "IN", "county" : "PARKE" },
            "47861": { "city" : "MEROM", "state" : "IN", "county" : "SULLIVAN" },
            "47862": { "city" : "MONTEZUMA", "state" : "IN", "county" : "PARKE" },
            "47865": { "city" : "PAXTON", "state" : "IN", "county" : "SULLIVAN" },
            "47866": { "city" : "PIMENTO", "state" : "IN", "county" : "VIGO" },"47868": { "city" : "POLAND", "state" : "IN", "county" : "OWEN" },
            "47869": { "city" : "PRAIRIE CREEK", "state" : "IN", "county" : "VIGO" },
            "47870": { "city" : "PRAIRIETON", "state" : "IN", "county" : "VIGO" },
            "47871": { "city" : "RILEY", "state" : "IN", "county" : "VIGO" },"47872": { "city" : "ROCKVILLE", "state" : "IN", "county" : "PARKE" },
            "47874": { "city" : "ROSEDALE", "state" : "IN", "county" : "PARKE" },
            "47875": { "city" : "SAINT BERNICE", "state" : "IN", "county" : "VERMILLION" },
            "47876": { "city" : "SAINT MARY OF THE WOODS", "state" : "IN", "county" : "VIGO" },
            "47878": { "city" : "SEELYVILLE", "state" : "IN", "county" : "VIGO" },
            "47879": { "city" : "SHELBURN", "state" : "IN", "county" : "SULLIVAN" },
            "47881": { "city" : "STAUNTON", "state" : "IN", "county" : "CLAY" },"47882": { "city" : "SULLIVAN", "state" : "IN", "county" : "SULLIVAN" },
            "47884": { "city" : "UNIVERSAL", "state" : "IN", "county" : "VERMILLION" },
            "47885": { "city" : "WEST TERRE HAUTE", "state" : "IN", "county" : "VIGO" },
            "47901": { "city" : "LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47902": { "city" : "LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47903": { "city" : "LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47904": { "city" : "LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47905": { "city" : "LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47906": { "city" : "WEST LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47907": { "city" : "WEST LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47909": { "city" : "LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47917": { "city" : "AMBIA", "state" : "IN", "county" : "BENTON" },"47918": { "city" : "ATTICA", "state" : "IN", "county" : "FOUNTAIN" },
            "47920": { "city" : "BATTLE GROUND", "state" : "IN", "county" : "TIPPECANOE" },
            "47921": { "city" : "BOSWELL", "state" : "IN", "county" : "BENTON" },
            "47922": { "city" : "BROOK", "state" : "IN", "county" : "NEWTON" },"47923": { "city" : "BROOKSTON", "state" : "IN", "county" : "WHITE" },
            "47924": { "city" : "BUCK CREEK", "state" : "IN", "county" : "TIPPECANOE" },
            "47925": { "city" : "BUFFALO", "state" : "IN", "county" : "WHITE" },"47926": { "city" : "BURNETTSVILLE", "state" : "IN", "county" : "WHITE" },
            "47928": { "city" : "CAYUGA", "state" : "IN", "county" : "VERMILLION" },
            "47929": { "city" : "CHALMERS", "state" : "IN", "county" : "WHITE" },
            "47930": { "city" : "CLARKS HILL", "state" : "IN", "county" : "TIPPECANOE" },
            "47932": { "city" : "COVINGTON", "state" : "IN", "county" : "FOUNTAIN" },
            "47933": { "city" : "CRAWFORDSVILLE", "state" : "IN", "county" : "MONTGOMERY" },
            "47935": { "city" : "CRAWFORDSVILLE", "state" : "IN", "county" : "MONTGOMERY" },
            "47936": { "city" : "CRAWFORDSVILLE", "state" : "IN", "county" : "MONTGOMERY" },
            "47940": { "city" : "DARLINGTON", "state" : "IN", "county" : "MONTGOMERY" },
            "47941": { "city" : "DAYTON", "state" : "IN", "county" : "TIPPECANOE" },
            "47942": { "city" : "EARL PARK", "state" : "IN", "county" : "BENTON" },
            "47943": { "city" : "FAIR OAKS", "state" : "IN", "county" : "JASPER" },
            "47944": { "city" : "FOWLER", "state" : "IN", "county" : "BENTON" },"47946": { "city" : "FRANCESVILLE", "state" : "IN", "county" : "PULASKI" },
            "47948": { "city" : "GOODLAND", "state" : "IN", "county" : "NEWTON" },
            "47949": { "city" : "HILLSBORO", "state" : "IN", "county" : "FOUNTAIN" },
            "47950": { "city" : "IDAVILLE", "state" : "IN", "county" : "WHITE" },
            "47951": { "city" : "KENTLAND", "state" : "IN", "county" : "NEWTON" },
            "47952": { "city" : "KINGMAN", "state" : "IN", "county" : "FOUNTAIN" },
            "47954": { "city" : "LADOGA", "state" : "IN", "county" : "MONTGOMERY" },
            "47955": { "city" : "LINDEN", "state" : "IN", "county" : "MONTGOMERY" },
            "47957": { "city" : "MEDARYVILLE", "state" : "IN", "county" : "PULASKI" },
            "47958": { "city" : "MELLOTT", "state" : "IN", "county" : "FOUNTAIN" },
            "47959": { "city" : "MONON", "state" : "IN", "county" : "WHITE" },"47960": { "city" : "MONTICELLO", "state" : "IN", "county" : "WHITE" },
            "47962": { "city" : "MONTMORENCI", "state" : "IN", "county" : "TIPPECANOE" },
            "47963": { "city" : "MOROCCO", "state" : "IN", "county" : "NEWTON" },
            "47965": { "city" : "NEW MARKET", "state" : "IN", "county" : "MONTGOMERY" },
            "47966": { "city" : "NEWPORT", "state" : "IN", "county" : "VERMILLION" },
            "47967": { "city" : "NEW RICHMOND", "state" : "IN", "county" : "MONTGOMERY" },
            "47968": { "city" : "NEW ROSS", "state" : "IN", "county" : "MONTGOMERY" },
            "47969": { "city" : "NEWTOWN", "state" : "IN", "county" : "FOUNTAIN" },
            "47970": { "city" : "OTTERBEIN", "state" : "IN", "county" : "BENTON" },
            "47971": { "city" : "OXFORD", "state" : "IN", "county" : "BENTON" },"47974": { "city" : "PERRYSVILLE", "state" : "IN", "county" : "VERMILLION" },
            "47975": { "city" : "PINE VILLAGE", "state" : "IN", "county" : "WARREN" },
            "47977": { "city" : "REMINGTON", "state" : "IN", "county" : "JASPER" },
            "47978": { "city" : "RENSSELAER", "state" : "IN", "county" : "JASPER" },
            "47980": { "city" : "REYNOLDS", "state" : "IN", "county" : "WHITE" },
            "47981": { "city" : "ROMNEY", "state" : "IN", "county" : "TIPPECANOE" },
            "47982": { "city" : "STATE LINE", "state" : "IN", "county" : "WARREN" },
            "47983": { "city" : "STOCKWELL", "state" : "IN", "county" : "TIPPECANOE" },
            "47986": { "city" : "TEMPLETON", "state" : "IN", "county" : "BENTON" },
            "47987": { "city" : "VEEDERSBURG", "state" : "IN", "county" : "FOUNTAIN" },
            "47988": { "city" : "WALLACE", "state" : "IN", "county" : "FOUNTAIN" },
            "47989": { "city" : "WAVELAND", "state" : "IN", "county" : "MONTGOMERY" },
            "47990": { "city" : "WAYNETOWN", "state" : "IN", "county" : "MONTGOMERY" },
            "47991": { "city" : "WEST LEBANON", "state" : "IN", "county" : "WARREN" },
            "47992": { "city" : "WESTPOINT", "state" : "IN", "county" : "TIPPECANOE" },
            "47993": { "city" : "WILLIAMSPORT", "state" : "IN", "county" : "WARREN" },
            "47994": { "city" : "WINGATE", "state" : "IN", "county" : "MONTGOMERY" },
            "47995": { "city" : "WOLCOTT", "state" : "IN", "county" : "WHITE" },"47996": { "city" : "WEST LAFAYETTE", "state" : "IN", "county" : "TIPPECANOE" },
            "47997": { "city" : "YEOMAN", "state" : "IN", "county" : "CARROLL" },
            "48001": { "city" : "ALGONAC", "state" : "MI", "county" : "SAINT CLAIR" },
            "48002": { "city" : "ALLENTON", "state" : "MI", "county" : "SAINT CLAIR" },
            "48003": { "city" : "ALMONT", "state" : "MI", "county" : "LAPEER" },"48004": { "city" : "ANCHORVILLE", "state" : "MI", "county" : "SAINT CLAIR" },
            "48005": { "city" : "ARMADA", "state" : "MI", "county" : "MACOMB" },"48006": { "city" : "AVOCA", "state" : "MI", "county" : "SAINT CLAIR" },
            "48007": { "city" : "TROY", "state" : "MI", "county" : "OAKLAND" },"48009": { "city" : "BIRMINGHAM", "state" : "MI", "county" : "OAKLAND" },
            "48012": { "city" : "BIRMINGHAM", "state" : "MI", "county" : "OAKLAND" },
            "48014": { "city" : "CAPAC", "state" : "MI", "county" : "SAINT CLAIR" },
            "48015": { "city" : "CENTER LINE", "state" : "MI", "county" : "MACOMB" },
            "48017": { "city" : "CLAWSON", "state" : "MI", "county" : "OAKLAND" },
            "48021": { "city" : "EASTPOINTE", "state" : "MI", "county" : "MACOMB" },
            "48022": { "city" : "EMMETT", "state" : "MI", "county" : "SAINT CLAIR" },
            "48023": { "city" : "FAIR HAVEN", "state" : "MI", "county" : "SAINT CLAIR" },
            "48025": { "city" : "FRANKLIN", "state" : "MI", "county" : "OAKLAND" },
            "48026": { "city" : "FRASER", "state" : "MI", "county" : "MACOMB" },"48027": { "city" : "GOODELLS", "state" : "MI", "county" : "SAINT CLAIR" },
            "48028": { "city" : "HARSENS ISLAND", "state" : "MI", "county" : "SAINT CLAIR" },
            "48030": { "city" : "HAZEL PARK", "state" : "MI", "county" : "OAKLAND" },
            "48032": { "city" : "JEDDO", "state" : "MI", "county" : "SAINT CLAIR" },
            "48033": { "city" : "SOUTHFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48034": { "city" : "SOUTHFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48035": { "city" : "CLINTON TOWNSHIP", "state" : "MI", "county" : "MACOMB" },
            "48036": { "city" : "CLINTON TOWNSHIP", "state" : "MI", "county" : "MACOMB" },
            "48037": { "city" : "SOUTHFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48038": { "city" : "CLINTON TOWNSHIP", "state" : "MI", "county" : "MACOMB" },
            "48039": { "city" : "MARINE CITY", "state" : "MI", "county" : "SAINT CLAIR" },
            "48040": { "city" : "MARYSVILLE", "state" : "MI", "county" : "SAINT CLAIR" },
            "48041": { "city" : "MEMPHIS", "state" : "MI", "county" : "SAINT CLAIR" },
            "48042": { "city" : "MACOMB", "state" : "MI", "county" : "MACOMB" },"48043": { "city" : "MOUNT CLEMENS", "state" : "MI", "county" : "MACOMB" },
            "48044": { "city" : "MACOMB", "state" : "MI", "county" : "MACOMB" },"48045": { "city" : "HARRISON TOWNSHIP", "state" : "MI", "county" : "MACOMB" },
            "48046": { "city" : "MOUNT CLEMENS", "state" : "MI", "county" : "MACOMB" },
            "48047": { "city" : "NEW BALTIMORE", "state" : "MI", "county" : "MACOMB" },
            "48048": { "city" : "NEW HAVEN", "state" : "MI", "county" : "MACOMB" },
            "48049": { "city" : "NORTH STREET", "state" : "MI", "county" : "SAINT CLAIR" },
            "48050": { "city" : "NEW HAVEN", "state" : "MI", "county" : "MACOMB" },
            "48051": { "city" : "NEW BALTIMORE", "state" : "MI", "county" : "MACOMB" },
            "48054": { "city" : "EAST CHINA", "state" : "MI", "county" : "SAINT CLAIR" },
            "48059": { "city" : "FORT GRATIOT", "state" : "MI", "county" : "SAINT CLAIR" },
            "48060": { "city" : "PORT HURON", "state" : "MI", "county" : "SAINT CLAIR" },
            "48061": { "city" : "PORT HURON", "state" : "MI", "county" : "SAINT CLAIR" },
            "48062": { "city" : "RICHMOND", "state" : "MI", "county" : "MACOMB" },
            "48063": { "city" : "COLUMBUS", "state" : "MI", "county" : "SAINT CLAIR" },
            "48064": { "city" : "CASCO", "state" : "MI", "county" : "SAINT CLAIR" },
            "48065": { "city" : "ROMEO", "state" : "MI", "county" : "MACOMB" },"48066": { "city" : "ROSEVILLE", "state" : "MI", "county" : "MACOMB" },
            "48067": { "city" : "ROYAL OAK", "state" : "MI", "county" : "OAKLAND" },
            "48068": { "city" : "ROYAL OAK", "state" : "MI", "county" : "OAKLAND" },
            "48069": { "city" : "PLEASANT RIDGE", "state" : "MI", "county" : "OAKLAND" },
            "48070": { "city" : "HUNTINGTON WOODS", "state" : "MI", "county" : "OAKLAND" },
            "48071": { "city" : "MADISON HEIGHTS", "state" : "MI", "county" : "OAKLAND" },
            "48072": { "city" : "BERKLEY", "state" : "MI", "county" : "OAKLAND" },
            "48073": { "city" : "ROYAL OAK", "state" : "MI", "county" : "OAKLAND" },
            "48074": { "city" : "SMITHS CREEK", "state" : "MI", "county" : "SAINT CLAIR" },
            "48075": { "city" : "SOUTHFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48076": { "city" : "SOUTHFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48079": { "city" : "SAINT CLAIR", "state" : "MI", "county" : "SAINT CLAIR" },
            "48080": { "city" : "SAINT CLAIR SHORES", "state" : "MI", "county" : "MACOMB" },
            "48081": { "city" : "SAINT CLAIR SHORES", "state" : "MI", "county" : "MACOMB" },
            "48082": { "city" : "SAINT CLAIR SHORES", "state" : "MI", "county" : "MACOMB" },
            "48083": { "city" : "TROY", "state" : "MI", "county" : "OAKLAND" },"48084": { "city" : "TROY", "state" : "MI", "county" : "OAKLAND" },
            "48085": { "city" : "TROY", "state" : "MI", "county" : "OAKLAND" },"48086": { "city" : "SOUTHFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48088": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },"48089": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },
            "48090": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },"48091": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },
            "48092": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },"48093": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },
            "48094": { "city" : "WASHINGTON", "state" : "MI", "county" : "MACOMB" },
            "48095": { "city" : "WASHINGTON", "state" : "MI", "county" : "MACOMB" },
            "48096": { "city" : "RAY", "state" : "MI", "county" : "MACOMB" },"48097": { "city" : "YALE", "state" : "MI", "county" : "SAINT CLAIR" },
            "48098": { "city" : "TROY", "state" : "MI", "county" : "OAKLAND" },"48099": { "city" : "TROY", "state" : "MI", "county" : "OAKLAND" },
            "48101": { "city" : "ALLEN PARK", "state" : "MI", "county" : "WAYNE" },
            "48103": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48104": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48105": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48106": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48107": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48108": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48109": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48110": { "city" : "AZALIA", "state" : "MI", "county" : "MONROE" },"48111": { "city" : "BELLEVILLE", "state" : "MI", "county" : "WAYNE" },
            "48112": { "city" : "BELLEVILLE", "state" : "MI", "county" : "WAYNE" },
            "48113": { "city" : "ANN ARBOR", "state" : "MI", "county" : "WASHTENAW" },
            "48114": { "city" : "BRIGHTON", "state" : "MI", "county" : "LIVINGSTON" },
            "48115": { "city" : "BRIDGEWATER", "state" : "MI", "county" : "WASHTENAW" },
            "48116": { "city" : "BRIGHTON", "state" : "MI", "county" : "LIVINGSTON" },
            "48117": { "city" : "CARLETON", "state" : "MI", "county" : "MONROE" },
            "48118": { "city" : "CHELSEA", "state" : "MI", "county" : "WASHTENAW" },
            "48120": { "city" : "DEARBORN", "state" : "MI", "county" : "WAYNE" },
            "48121": { "city" : "DEARBORN", "state" : "MI", "county" : "WAYNE" },
            "48122": { "city" : "MELVINDALE", "state" : "MI", "county" : "WAYNE" },
            "48123": { "city" : "DEARBORN", "state" : "MI", "county" : "WAYNE" },
            "48124": { "city" : "DEARBORN", "state" : "MI", "county" : "WAYNE" },
            "48125": { "city" : "DEARBORN HEIGHTS", "state" : "MI", "county" : "WAYNE" },
            "48126": { "city" : "DEARBORN", "state" : "MI", "county" : "WAYNE" },
            "48127": { "city" : "DEARBORN HEIGHTS", "state" : "MI", "county" : "WAYNE" },
            "48128": { "city" : "DEARBORN", "state" : "MI", "county" : "WAYNE" },
            "48130": { "city" : "DEXTER", "state" : "MI", "county" : "WASHTENAW" },
            "48131": { "city" : "DUNDEE", "state" : "MI", "county" : "MONROE" },"48133": { "city" : "ERIE", "state" : "MI", "county" : "MONROE" },
            "48134": { "city" : "FLAT ROCK", "state" : "MI", "county" : "WAYNE" },
            "48135": { "city" : "GARDEN CITY", "state" : "MI", "county" : "WAYNE" },
            "48136": { "city" : "GARDEN CITY", "state" : "MI", "county" : "WAYNE" },
            "48137": { "city" : "GREGORY", "state" : "MI", "county" : "LIVINGSTON" },
            "48138": { "city" : "GROSSE ILE", "state" : "MI", "county" : "WAYNE" },
            "48139": { "city" : "HAMBURG", "state" : "MI", "county" : "LIVINGSTON" },
            "48140": { "city" : "IDA", "state" : "MI", "county" : "MONROE" },"48141": { "city" : "INKSTER", "state" : "MI", "county" : "WAYNE" },
            "48143": { "city" : "LAKELAND", "state" : "MI", "county" : "LIVINGSTON" },
            "48144": { "city" : "LAMBERTVILLE", "state" : "MI", "county" : "MONROE" },
            "48145": { "city" : "LA SALLE", "state" : "MI", "county" : "MONROE" },
            "48146": { "city" : "LINCOLN PARK", "state" : "MI", "county" : "WAYNE" },
            "48150": { "city" : "LIVONIA", "state" : "MI", "county" : "WAYNE" },"48151": { "city" : "LIVONIA", "state" : "MI", "county" : "WAYNE" },
            "48152": { "city" : "LIVONIA", "state" : "MI", "county" : "WAYNE" },"48153": { "city" : "LIVONIA", "state" : "MI", "county" : "WAYNE" },
            "48154": { "city" : "LIVONIA", "state" : "MI", "county" : "WAYNE" },"48157": { "city" : "LUNA PIER", "state" : "MI", "county" : "MONROE" },
            "48158": { "city" : "MANCHESTER", "state" : "MI", "county" : "WASHTENAW" },
            "48159": { "city" : "MAYBEE", "state" : "MI", "county" : "MONROE" },"48160": { "city" : "MILAN", "state" : "MI", "county" : "MONROE" },
            "48161": { "city" : "MONROE", "state" : "MI", "county" : "MONROE" },"48162": { "city" : "MONROE", "state" : "MI", "county" : "MONROE" },
            "48164": { "city" : "NEW BOSTON", "state" : "MI", "county" : "WAYNE" },
            "48165": { "city" : "NEW HUDSON", "state" : "MI", "county" : "OAKLAND" },
            "48166": { "city" : "NEWPORT", "state" : "MI", "county" : "MONROE" },
            "48167": { "city" : "NORTHVILLE", "state" : "MI", "county" : "WAYNE" },
            "48168": { "city" : "NORTHVILLE", "state" : "MI", "county" : "WAYNE" },
            "48169": { "city" : "PINCKNEY", "state" : "MI", "county" : "LIVINGSTON" },
            "48170": { "city" : "PLYMOUTH", "state" : "MI", "county" : "WAYNE" },
            "48173": { "city" : "ROCKWOOD", "state" : "MI", "county" : "WAYNE" },
            "48174": { "city" : "ROMULUS", "state" : "MI", "county" : "WAYNE" },"48175": { "city" : "SALEM", "state" : "MI", "county" : "WASHTENAW" },
            "48176": { "city" : "SALINE", "state" : "MI", "county" : "WASHTENAW" },
            "48177": { "city" : "SAMARIA", "state" : "MI", "county" : "MONROE" },
            "48178": { "city" : "SOUTH LYON", "state" : "MI", "county" : "OAKLAND" },
            "48179": { "city" : "SOUTH ROCKWOOD", "state" : "MI", "county" : "MONROE" },
            "48180": { "city" : "TAYLOR", "state" : "MI", "county" : "WAYNE" },"48182": { "city" : "TEMPERANCE", "state" : "MI", "county" : "MONROE" },
            "48183": { "city" : "TRENTON", "state" : "MI", "county" : "WAYNE" },"48184": { "city" : "WAYNE", "state" : "MI", "county" : "WAYNE" },
            "48185": { "city" : "WESTLAND", "state" : "MI", "county" : "WAYNE" },
            "48186": { "city" : "WESTLAND", "state" : "MI", "county" : "WAYNE" },
            "48187": { "city" : "CANTON", "state" : "MI", "county" : "WAYNE" },"48188": { "city" : "CANTON", "state" : "MI", "county" : "WAYNE" },
            "48189": { "city" : "WHITMORE LAKE", "state" : "MI", "county" : "WASHTENAW" },
            "48190": { "city" : "WHITTAKER", "state" : "MI", "county" : "WASHTENAW" },
            "48191": { "city" : "WILLIS", "state" : "MI", "county" : "WASHTENAW" },
            "48192": { "city" : "WYANDOTTE", "state" : "MI", "county" : "WAYNE" },
            "48193": { "city" : "RIVERVIEW", "state" : "MI", "county" : "WAYNE" },
            "48195": { "city" : "SOUTHGATE", "state" : "MI", "county" : "WAYNE" },
            "48197": { "city" : "YPSILANTI", "state" : "MI", "county" : "WASHTENAW" },
            "48198": { "city" : "YPSILANTI", "state" : "MI", "county" : "WASHTENAW" },
            "48201": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48202": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48203": { "city" : "HIGHLAND PARK", "state" : "MI", "county" : "WAYNE" },
            "48204": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48205": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48206": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48207": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48208": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48209": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48210": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48211": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48212": { "city" : "HAMTRAMCK", "state" : "MI", "county" : "WAYNE" },
            "48213": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48214": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48215": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48216": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48217": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48218": { "city" : "RIVER ROUGE", "state" : "MI", "county" : "WAYNE" },
            "48219": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48220": { "city" : "FERNDALE", "state" : "MI", "county" : "OAKLAND" },
            "48221": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48222": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48223": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48224": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48225": { "city" : "HARPER WOODS", "state" : "MI", "county" : "WAYNE" },
            "48226": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48227": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48228": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48229": { "city" : "ECORSE", "state" : "MI", "county" : "WAYNE" },
            "48230": { "city" : "GROSSE POINTE", "state" : "MI", "county" : "WAYNE" },
            "48231": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48232": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48233": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48234": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48235": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48236": { "city" : "GROSSE POINTE", "state" : "MI", "county" : "WAYNE" },
            "48237": { "city" : "OAK PARK", "state" : "MI", "county" : "OAKLAND" },
            "48238": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48239": { "city" : "REDFORD", "state" : "MI", "county" : "WAYNE" },
            "48240": { "city" : "REDFORD", "state" : "MI", "county" : "WAYNE" },"48242": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48243": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48244": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48264": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48265": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48266": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48268": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48275": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48277": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },
            "48288": { "city" : "DETROIT", "state" : "MI", "county" : "WAYNE" },"48301": { "city" : "BLOOMFIELD HILLS", "state" : "MI", "county" : "OAKLAND" },
            "48302": { "city" : "BLOOMFIELD HILLS", "state" : "MI", "county" : "OAKLAND" },
            "48303": { "city" : "BLOOMFIELD HILLS", "state" : "MI", "county" : "OAKLAND" },
            "48304": { "city" : "BLOOMFIELD HILLS", "state" : "MI", "county" : "OAKLAND" },
            "48306": { "city" : "ROCHESTER", "state" : "MI", "county" : "OAKLAND" },
            "48307": { "city" : "ROCHESTER", "state" : "MI", "county" : "OAKLAND" },
            "48308": { "city" : "ROCHESTER", "state" : "MI", "county" : "OAKLAND" },
            "48309": { "city" : "ROCHESTER", "state" : "MI", "county" : "OAKLAND" },
            "48310": { "city" : "STERLING HEIGHTS", "state" : "MI", "county" : "MACOMB" },
            "48311": { "city" : "STERLING HEIGHTS", "state" : "MI", "county" : "MACOMB" },
            "48312": { "city" : "STERLING HEIGHTS", "state" : "MI", "county" : "MACOMB" },
            "48313": { "city" : "STERLING HEIGHTS", "state" : "MI", "county" : "MACOMB" },
            "48314": { "city" : "STERLING HEIGHTS", "state" : "MI", "county" : "MACOMB" },
            "48315": { "city" : "UTICA", "state" : "MI", "county" : "MACOMB" },"48316": { "city" : "UTICA", "state" : "MI", "county" : "MACOMB" },
            "48317": { "city" : "UTICA", "state" : "MI", "county" : "MACOMB" },"48318": { "city" : "UTICA", "state" : "MI", "county" : "MACOMB" },
            "48320": { "city" : "KEEGO HARBOR", "state" : "MI", "county" : "OAKLAND" },
            "48321": { "city" : "AUBURN HILLS", "state" : "MI", "county" : "OAKLAND" },
            "48322": { "city" : "WEST BLOOMFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48323": { "city" : "WEST BLOOMFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48324": { "city" : "WEST BLOOMFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48325": { "city" : "WEST BLOOMFIELD", "state" : "MI", "county" : "OAKLAND" },
            "48326": { "city" : "AUBURN HILLS", "state" : "MI", "county" : "OAKLAND" },
            "48327": { "city" : "WATERFORD", "state" : "MI", "county" : "OAKLAND" },
            "48328": { "city" : "WATERFORD", "state" : "MI", "county" : "OAKLAND" },
            "48329": { "city" : "WATERFORD", "state" : "MI", "county" : "OAKLAND" },
            "48330": { "city" : "DRAYTON PLAINS", "state" : "MI", "county" : "OAKLAND" },
            "48331": { "city" : "FARMINGTON", "state" : "MI", "county" : "OAKLAND" },
            "48332": { "city" : "FARMINGTON", "state" : "MI", "county" : "OAKLAND" },
            "48333": { "city" : "FARMINGTON", "state" : "MI", "county" : "OAKLAND" },
            "48334": { "city" : "FARMINGTON", "state" : "MI", "county" : "OAKLAND" },
            "48335": { "city" : "FARMINGTON", "state" : "MI", "county" : "OAKLAND" },
            "48336": { "city" : "FARMINGTON", "state" : "MI", "county" : "OAKLAND" },
            "48340": { "city" : "PONTIAC", "state" : "MI", "county" : "OAKLAND" },
            "48341": { "city" : "PONTIAC", "state" : "MI", "county" : "OAKLAND" },
            "48342": { "city" : "PONTIAC", "state" : "MI", "county" : "OAKLAND" },
            "48343": { "city" : "PONTIAC", "state" : "MI", "county" : "OAKLAND" },
            "48346": { "city" : "CLARKSTON", "state" : "MI", "county" : "OAKLAND" },
            "48347": { "city" : "CLARKSTON", "state" : "MI", "county" : "OAKLAND" },
            "48348": { "city" : "CLARKSTON", "state" : "MI", "county" : "OAKLAND" },
            "48350": { "city" : "DAVISBURG", "state" : "MI", "county" : "OAKLAND" },
            "48353": { "city" : "HARTLAND", "state" : "MI", "county" : "LIVINGSTON" },
            "48356": { "city" : "HIGHLAND", "state" : "MI", "county" : "OAKLAND" },
            "48357": { "city" : "HIGHLAND", "state" : "MI", "county" : "OAKLAND" },
            "48359": { "city" : "LAKE ORION", "state" : "MI", "county" : "OAKLAND" },
            "48360": { "city" : "LAKE ORION", "state" : "MI", "county" : "OAKLAND" },
            "48361": { "city" : "LAKE ORION", "state" : "MI", "county" : "OAKLAND" },
            "48362": { "city" : "LAKE ORION", "state" : "MI", "county" : "OAKLAND" },
            "48363": { "city" : "OAKLAND", "state" : "MI", "county" : "OAKLAND" },
            "48366": { "city" : "LAKEVILLE", "state" : "MI", "county" : "OAKLAND" },
            "48367": { "city" : "LEONARD", "state" : "MI", "county" : "OAKLAND" },
            "48370": { "city" : "OXFORD", "state" : "MI", "county" : "OAKLAND" },
            "48371": { "city" : "OXFORD", "state" : "MI", "county" : "OAKLAND" },
            "48374": { "city" : "NOVI", "state" : "MI", "county" : "OAKLAND" },"48375": { "city" : "NOVI", "state" : "MI", "county" : "OAKLAND" },
            "48376": { "city" : "NOVI", "state" : "MI", "county" : "OAKLAND" },"48377": { "city" : "NOVI", "state" : "MI", "county" : "OAKLAND" },
            "48380": { "city" : "MILFORD", "state" : "MI", "county" : "OAKLAND" },
            "48381": { "city" : "MILFORD", "state" : "MI", "county" : "OAKLAND" },
            "48382": { "city" : "COMMERCE TOWNSHIP", "state" : "MI", "county" : "OAKLAND" },
            "48383": { "city" : "WHITE LAKE", "state" : "MI", "county" : "OAKLAND" },
            "48386": { "city" : "WHITE LAKE", "state" : "MI", "county" : "OAKLAND" },
            "48387": { "city" : "UNION LAKE", "state" : "MI", "county" : "OAKLAND" },
            "48390": { "city" : "WALLED LAKE", "state" : "MI", "county" : "OAKLAND" },
            "48391": { "city" : "WALLED LAKE", "state" : "MI", "county" : "OAKLAND" },
            "48393": { "city" : "WIXOM", "state" : "MI", "county" : "OAKLAND" },"48397": { "city" : "WARREN", "state" : "MI", "county" : "MACOMB" },
            "48401": { "city" : "APPLEGATE", "state" : "MI", "county" : "SANILAC" },
            "48410": { "city" : "ARGYLE", "state" : "MI", "county" : "SANILAC" },
            "48411": { "city" : "ATLAS", "state" : "MI", "county" : "GENESEE" },"48412": { "city" : "ATTICA", "state" : "MI", "county" : "LAPEER" },
            "48413": { "city" : "BAD AXE", "state" : "MI", "county" : "HURON" },"48414": { "city" : "BANCROFT", "state" : "MI", "county" : "SHIAWASSEE" },
            "48415": { "city" : "BIRCH RUN", "state" : "MI", "county" : "SAGINAW" },
            "48416": { "city" : "BROWN CITY", "state" : "MI", "county" : "SANILAC" },
            "48417": { "city" : "BURT", "state" : "MI", "county" : "SAGINAW" },"48418": { "city" : "BYRON", "state" : "MI", "county" : "SHIAWASSEE" },
            "48419": { "city" : "CARSONVILLE", "state" : "MI", "county" : "SANILAC" },
            "48420": { "city" : "CLIO", "state" : "MI", "county" : "GENESEE" },"48421": { "city" : "COLUMBIAVILLE", "state" : "MI", "county" : "LAPEER" },
            "48422": { "city" : "CROSWELL", "state" : "MI", "county" : "SANILAC" },
            "48423": { "city" : "DAVISON", "state" : "MI", "county" : "GENESEE" },
            "48426": { "city" : "DECKER", "state" : "MI", "county" : "SANILAC" },
            "48427": { "city" : "DECKERVILLE", "state" : "MI", "county" : "SANILAC" },
            "48428": { "city" : "DRYDEN", "state" : "MI", "county" : "LAPEER" },"48429": { "city" : "DURAND", "state" : "MI", "county" : "SHIAWASSEE" },
            "48430": { "city" : "FENTON", "state" : "MI", "county" : "GENESEE" },
            "48432": { "city" : "FILION", "state" : "MI", "county" : "HURON" },"48433": { "city" : "FLUSHING", "state" : "MI", "county" : "GENESEE" },
            "48434": { "city" : "FORESTVILLE", "state" : "MI", "county" : "SANILAC" },
            "48435": { "city" : "FOSTORIA", "state" : "MI", "county" : "TUSCOLA" },
            "48436": { "city" : "GAINES", "state" : "MI", "county" : "GENESEE" },
            "48437": { "city" : "GENESEE", "state" : "MI", "county" : "GENESEE" },
            "48438": { "city" : "GOODRICH", "state" : "MI", "county" : "GENESEE" },
            "48439": { "city" : "GRAND BLANC", "state" : "MI", "county" : "GENESEE" },
            "48440": { "city" : "HADLEY", "state" : "MI", "county" : "LAPEER" },"48441": { "city" : "HARBOR BEACH", "state" : "MI", "county" : "HURON" },
            "48442": { "city" : "HOLLY", "state" : "MI", "county" : "OAKLAND" },"48444": { "city" : "IMLAY CITY", "state" : "MI", "county" : "LAPEER" },
            "48445": { "city" : "KINDE", "state" : "MI", "county" : "HURON" },"48446": { "city" : "LAPEER", "state" : "MI", "county" : "LAPEER" },
            "48449": { "city" : "LENNON", "state" : "MI", "county" : "GENESEE" },
            "48450": { "city" : "LEXINGTON", "state" : "MI", "county" : "SANILAC" },
            "48451": { "city" : "LINDEN", "state" : "MI", "county" : "GENESEE" },
            "48453": { "city" : "MARLETTE", "state" : "MI", "county" : "SANILAC" },
            "48454": { "city" : "MELVIN", "state" : "MI", "county" : "SANILAC" },
            "48455": { "city" : "METAMORA", "state" : "MI", "county" : "LAPEER" },
            "48456": { "city" : "MINDEN CITY", "state" : "MI", "county" : "SANILAC" },
            "48457": { "city" : "MONTROSE", "state" : "MI", "county" : "GENESEE" },
            "48458": { "city" : "MOUNT MORRIS", "state" : "MI", "county" : "GENESEE" },
            "48460": { "city" : "NEW LOTHROP", "state" : "MI", "county" : "SHIAWASSEE" },
            "48461": { "city" : "NORTH BRANCH", "state" : "MI", "county" : "LAPEER" },
            "48462": { "city" : "ORTONVILLE", "state" : "MI", "county" : "OAKLAND" },
            "48463": { "city" : "OTISVILLE", "state" : "MI", "county" : "GENESEE" },
            "48464": { "city" : "OTTER LAKE", "state" : "MI", "county" : "LAPEER" },
            "48465": { "city" : "PALMS", "state" : "MI", "county" : "SANILAC" },"48466": { "city" : "PECK", "state" : "MI", "county" : "SANILAC" },
            "48467": { "city" : "PORT AUSTIN", "state" : "MI", "county" : "HURON" },
            "48468": { "city" : "PORT HOPE", "state" : "MI", "county" : "HURON" },
            "48469": { "city" : "PORT SANILAC", "state" : "MI", "county" : "SANILAC" },
            "48470": { "city" : "RUTH", "state" : "MI", "county" : "HURON" },"48471": { "city" : "SANDUSKY", "state" : "MI", "county" : "SANILAC" },
            "48472": { "city" : "SNOVER", "state" : "MI", "county" : "SANILAC" },
            "48473": { "city" : "SWARTZ CREEK", "state" : "MI", "county" : "GENESEE" },
            "48475": { "city" : "UBLY", "state" : "MI", "county" : "HURON" },"48476": { "city" : "VERNON", "state" : "MI", "county" : "SHIAWASSEE" },
            "48480": { "city" : "GRAND BLANC", "state" : "MI", "county" : "GENESEE" },
            "48501": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48502": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48503": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48504": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48505": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48506": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48507": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48509": { "city" : "BURTON", "state" : "MI", "county" : "GENESEE" },
            "48519": { "city" : "BURTON", "state" : "MI", "county" : "GENESEE" },
            "48529": { "city" : "BURTON", "state" : "MI", "county" : "GENESEE" },
            "48531": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48532": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48550": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48551": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48552": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48553": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48554": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48556": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },
            "48557": { "city" : "FLINT", "state" : "MI", "county" : "GENESEE" },"48601": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48602": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48603": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48604": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48605": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48606": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48607": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48608": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48609": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48610": { "city" : "ALGER", "state" : "MI", "county" : "ARENAC" },"48611": { "city" : "AUBURN", "state" : "MI", "county" : "BAY" },
            "48612": { "city" : "BEAVERTON", "state" : "MI", "county" : "GLADWIN" },
            "48613": { "city" : "BENTLEY", "state" : "MI", "county" : "BAY" },"48614": { "city" : "BRANT", "state" : "MI", "county" : "SAGINAW" },
            "48615": { "city" : "BRECKENRIDGE", "state" : "MI", "county" : "GRATIOT" },
            "48616": { "city" : "CHESANING", "state" : "MI", "county" : "SAGINAW" },
            "48617": { "city" : "CLARE", "state" : "MI", "county" : "CLARE" },"48618": { "city" : "COLEMAN", "state" : "MI", "county" : "MIDLAND" },
            "48619": { "city" : "COMINS", "state" : "MI", "county" : "OSCODA" },"48620": { "city" : "EDENVILLE", "state" : "MI", "county" : "MIDLAND" },
            "48621": { "city" : "FAIRVIEW", "state" : "MI", "county" : "OSCODA" },
            "48622": { "city" : "FARWELL", "state" : "MI", "county" : "CLARE" },"48623": { "city" : "FREELAND", "state" : "MI", "county" : "SAGINAW" },
            "48624": { "city" : "GLADWIN", "state" : "MI", "county" : "GLADWIN" },
            "48625": { "city" : "HARRISON", "state" : "MI", "county" : "CLARE" },
            "48626": { "city" : "HEMLOCK", "state" : "MI", "county" : "SAGINAW" },
            "48627": { "city" : "HIGGINS LAKE", "state" : "MI", "county" : "ROSCOMMON" },
            "48628": { "city" : "HOPE", "state" : "MI", "county" : "MIDLAND" },"48629": { "city" : "HOUGHTON LAKE", "state" : "MI", "county" : "ROSCOMMON" },
            "48630": { "city" : "HOUGHTON LAKE HEIGHTS", "state" : "MI", "county" : "ROSCOMMON" },
            "48631": { "city" : "KAWKAWLIN", "state" : "MI", "county" : "BAY" },"48632": { "city" : "LAKE", "state" : "MI", "county" : "CLARE" },
            "48633": { "city" : "LAKE GEORGE", "state" : "MI", "county" : "CLARE" },
            "48634": { "city" : "LINWOOD", "state" : "MI", "county" : "BAY" },"48635": { "city" : "LUPTON", "state" : "MI", "county" : "OGEMAW" },
            "48636": { "city" : "LUZERNE", "state" : "MI", "county" : "OSCODA" },
            "48637": { "city" : "MERRILL", "state" : "MI", "county" : "SAGINAW" },
            "48638": { "city" : "SAGINAW", "state" : "MI", "county" : "SAGINAW" },
            "48640": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48641": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48642": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48647": { "city" : "MIO", "state" : "MI", "county" : "OSCODA" },"48649": { "city" : "OAKLEY", "state" : "MI", "county" : "SAGINAW" },
            "48650": { "city" : "PINCONNING", "state" : "MI", "county" : "BAY" },
            "48651": { "city" : "PRUDENVILLE", "state" : "MI", "county" : "ROSCOMMON" },
            "48652": { "city" : "RHODES", "state" : "MI", "county" : "GLADWIN" },
            "48653": { "city" : "ROSCOMMON", "state" : "MI", "county" : "ROSCOMMON" },
            "48654": { "city" : "ROSE CITY", "state" : "MI", "county" : "OGEMAW" },
            "48655": { "city" : "SAINT CHARLES", "state" : "MI", "county" : "SAGINAW" },
            "48656": { "city" : "SAINT HELEN", "state" : "MI", "county" : "ROSCOMMON" },
            "48657": { "city" : "SANFORD", "state" : "MI", "county" : "MIDLAND" },
            "48658": { "city" : "STANDISH", "state" : "MI", "county" : "ARENAC" },
            "48659": { "city" : "STERLING", "state" : "MI", "county" : "ARENAC" },
            "48661": { "city" : "WEST BRANCH", "state" : "MI", "county" : "OGEMAW" },
            "48662": { "city" : "WHEELER", "state" : "MI", "county" : "GRATIOT" },
            "48667": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48670": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48674": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48686": { "city" : "MIDLAND", "state" : "MI", "county" : "MIDLAND" },
            "48701": { "city" : "AKRON", "state" : "MI", "county" : "TUSCOLA" },"48703": { "city" : "AU GRES", "state" : "MI", "county" : "ARENAC" },
            "48705": { "city" : "BARTON CITY", "state" : "MI", "county" : "ALCONA" },
            "48706": { "city" : "BAY CITY", "state" : "MI", "county" : "BAY" },"48707": { "city" : "BAY CITY", "state" : "MI", "county" : "BAY" },
            "48708": { "city" : "BAY CITY", "state" : "MI", "county" : "BAY" },"48710": { "city" : "UNIVERSITY CENTER", "state" : "MI", "county" : "BAY" },
            "48720": { "city" : "BAY PORT", "state" : "MI", "county" : "HURON" },
            "48721": { "city" : "BLACK RIVER", "state" : "MI", "county" : "ALCONA" },
            "48722": { "city" : "BRIDGEPORT", "state" : "MI", "county" : "SAGINAW" },
            "48723": { "city" : "CARO", "state" : "MI", "county" : "TUSCOLA" },"48724": { "city" : "CARROLLTON", "state" : "MI", "county" : "SAGINAW" },
            "48725": { "city" : "CASEVILLE", "state" : "MI", "county" : "HURON" },
            "48726": { "city" : "CASS CITY", "state" : "MI", "county" : "TUSCOLA" },
            "48727": { "city" : "CLIFFORD", "state" : "MI", "county" : "LAPEER" },
            "48728": { "city" : "CURRAN", "state" : "MI", "county" : "ALCONA" },"48729": { "city" : "DEFORD", "state" : "MI", "county" : "TUSCOLA" },
            "48730": { "city" : "EAST TAWAS", "state" : "MI", "county" : "IOSCO" },
            "48731": { "city" : "ELKTON", "state" : "MI", "county" : "HURON" },"48732": { "city" : "ESSEXVILLE", "state" : "MI", "county" : "BAY" },
            "48733": { "city" : "FAIRGROVE", "state" : "MI", "county" : "TUSCOLA" },
            "48734": { "city" : "FRANKENMUTH", "state" : "MI", "county" : "SAGINAW" },
            "48735": { "city" : "GAGETOWN", "state" : "MI", "county" : "TUSCOLA" },
            "48737": { "city" : "GLENNIE", "state" : "MI", "county" : "ALCONA" },
            "48738": { "city" : "GREENBUSH", "state" : "MI", "county" : "ALCONA" },
            "48739": { "city" : "HALE", "state" : "MI", "county" : "IOSCO" },"48740": { "city" : "HARRISVILLE", "state" : "MI", "county" : "ALCONA" },
            "48741": { "city" : "KINGSTON", "state" : "MI", "county" : "TUSCOLA" },
            "48742": { "city" : "LINCOLN", "state" : "MI", "county" : "ALCONA" },
            "48743": { "city" : "LONG LAKE", "state" : "MI", "county" : "IOSCO" },
            "48744": { "city" : "MAYVILLE", "state" : "MI", "county" : "TUSCOLA" },
            "48745": { "city" : "MIKADO", "state" : "MI", "county" : "ALCONA" },"48746": { "city" : "MILLINGTON", "state" : "MI", "county" : "TUSCOLA" },
            "48747": { "city" : "MUNGER", "state" : "MI", "county" : "BAY" },"48748": { "city" : "NATIONAL CITY", "state" : "MI", "county" : "IOSCO" },
            "48749": { "city" : "OMER", "state" : "MI", "county" : "ARENAC" },"48750": { "city" : "OSCODA", "state" : "MI", "county" : "IOSCO" },
            "48754": { "city" : "OWENDALE", "state" : "MI", "county" : "HURON" },
            "48755": { "city" : "PIGEON", "state" : "MI", "county" : "HURON" },"48756": { "city" : "PRESCOTT", "state" : "MI", "county" : "OGEMAW" },
            "48757": { "city" : "REESE", "state" : "MI", "county" : "TUSCOLA" },"48758": { "city" : "RICHVILLE", "state" : "MI", "county" : "TUSCOLA" },
            "48759": { "city" : "SEBEWAING", "state" : "MI", "county" : "HURON" },
            "48760": { "city" : "SILVERWOOD", "state" : "MI", "county" : "LAPEER" },
            "48761": { "city" : "SOUTH BRANCH", "state" : "MI", "county" : "OGEMAW" },
            "48762": { "city" : "SPRUCE", "state" : "MI", "county" : "ALCONA" },"48763": { "city" : "TAWAS CITY", "state" : "MI", "county" : "IOSCO" },
            "48764": { "city" : "TAWAS CITY", "state" : "MI", "county" : "IOSCO" },
            "48765": { "city" : "TURNER", "state" : "MI", "county" : "ARENAC" },"48766": { "city" : "TWINING", "state" : "MI", "county" : "ARENAC" },
            "48767": { "city" : "UNIONVILLE", "state" : "MI", "county" : "TUSCOLA" },
            "48768": { "city" : "VASSAR", "state" : "MI", "county" : "TUSCOLA" },
            "48769": { "city" : "TUSCOLA", "state" : "MI", "county" : "TUSCOLA" },
            "48770": { "city" : "WHITTEMORE", "state" : "MI", "county" : "IOSCO" },
            "48787": { "city" : "FRANKENMUTH", "state" : "MI", "county" : "SAGINAW" },
            "48801": { "city" : "ALMA", "state" : "MI", "county" : "GRATIOT" },"48804": { "city" : "MOUNT PLEASANT", "state" : "MI", "county" : "ISABELLA" },
            "48805": { "city" : "OKEMOS", "state" : "MI", "county" : "INGHAM" },"48806": { "city" : "ASHLEY", "state" : "MI", "county" : "GRATIOT" },
            "48807": { "city" : "BANNISTER", "state" : "MI", "county" : "GRATIOT" },
            "48808": { "city" : "BATH", "state" : "MI", "county" : "CLINTON" },"48809": { "city" : "BELDING", "state" : "MI", "county" : "IONIA" },
            "48811": { "city" : "CARSON CITY", "state" : "MI", "county" : "MONTCALM" },
            "48812": { "city" : "CEDAR LAKE", "state" : "MI", "county" : "MONTCALM" },
            "48813": { "city" : "CHARLOTTE", "state" : "MI", "county" : "EATON" },
            "48815": { "city" : "CLARKSVILLE", "state" : "MI", "county" : "IONIA" },
            "48816": { "city" : "COHOCTAH", "state" : "MI", "county" : "LIVINGSTON" },
            "48817": { "city" : "CORUNNA", "state" : "MI", "county" : "SHIAWASSEE" },
            "48818": { "city" : "CRYSTAL", "state" : "MI", "county" : "MONTCALM" },
            "48819": { "city" : "DANSVILLE", "state" : "MI", "county" : "INGHAM" },
            "48820": { "city" : "DEWITT", "state" : "MI", "county" : "CLINTON" },
            "48821": { "city" : "DIMONDALE", "state" : "MI", "county" : "EATON" },
            "48822": { "city" : "EAGLE", "state" : "MI", "county" : "CLINTON" },"48823": { "city" : "EAST LANSING", "state" : "MI", "county" : "INGHAM" },
            "48824": { "city" : "EAST LANSING", "state" : "MI", "county" : "INGHAM" },
            "48826": { "city" : "EAST LANSING", "state" : "MI", "county" : "INGHAM" },
            "48827": { "city" : "EATON RAPIDS", "state" : "MI", "county" : "EATON" },
            "48829": { "city" : "EDMORE", "state" : "MI", "county" : "MONTCALM" },
            "48830": { "city" : "ELM HALL", "state" : "MI", "county" : "GRATIOT" },
            "48831": { "city" : "ELSIE", "state" : "MI", "county" : "CLINTON" },"48832": { "city" : "ELWELL", "state" : "MI", "county" : "GRATIOT" },
            "48833": { "city" : "EUREKA", "state" : "MI", "county" : "CLINTON" },
            "48834": { "city" : "FENWICK", "state" : "MI", "county" : "MONTCALM" },
            "48835": { "city" : "FOWLER", "state" : "MI", "county" : "CLINTON" },
            "48836": { "city" : "FOWLERVILLE", "state" : "MI", "county" : "LIVINGSTON" },
            "48837": { "city" : "GRAND LEDGE", "state" : "MI", "county" : "EATON" },
            "48838": { "city" : "GREENVILLE", "state" : "MI", "county" : "MONTCALM" },
            "48840": { "city" : "HASLETT", "state" : "MI", "county" : "INGHAM" },
            "48841": { "city" : "HENDERSON", "state" : "MI", "county" : "SHIAWASSEE" },
            "48842": { "city" : "HOLT", "state" : "MI", "county" : "INGHAM" },"48843": { "city" : "HOWELL", "state" : "MI", "county" : "LIVINGSTON" },
            "48844": { "city" : "HOWELL", "state" : "MI", "county" : "LIVINGSTON" },
            "48845": { "city" : "HUBBARDSTON", "state" : "MI", "county" : "IONIA" },
            "48846": { "city" : "IONIA", "state" : "MI", "county" : "IONIA" },"48847": { "city" : "ITHACA", "state" : "MI", "county" : "GRATIOT" },
            "48848": { "city" : "LAINGSBURG", "state" : "MI", "county" : "SHIAWASSEE" },
            "48849": { "city" : "LAKE ODESSA", "state" : "MI", "county" : "IONIA" },
            "48850": { "city" : "LAKEVIEW", "state" : "MI", "county" : "MONTCALM" },
            "48851": { "city" : "LYONS", "state" : "MI", "county" : "IONIA" },"48852": { "city" : "MCBRIDES", "state" : "MI", "county" : "MONTCALM" },
            "48853": { "city" : "MAPLE RAPIDS", "state" : "MI", "county" : "CLINTON" },
            "48854": { "city" : "MASON", "state" : "MI", "county" : "INGHAM" },"48855": { "city" : "HOWELL", "state" : "MI", "county" : "LIVINGSTON" },
            "48856": { "city" : "MIDDLETON", "state" : "MI", "county" : "GRATIOT" },
            "48857": { "city" : "MORRICE", "state" : "MI", "county" : "SHIAWASSEE" },
            "48858": { "city" : "MOUNT PLEASANT", "state" : "MI", "county" : "ISABELLA" },
            "48860": { "city" : "MUIR", "state" : "MI", "county" : "IONIA" },"48861": { "city" : "MULLIKEN", "state" : "MI", "county" : "EATON" },
            "48864": { "city" : "OKEMOS", "state" : "MI", "county" : "INGHAM" },"48865": { "city" : "ORLEANS", "state" : "MI", "county" : "IONIA" },
            "48866": { "city" : "OVID", "state" : "MI", "county" : "CLINTON" },"48867": { "city" : "OWOSSO", "state" : "MI", "county" : "SHIAWASSEE" },
            "48870": { "city" : "PALO", "state" : "MI", "county" : "IONIA" },"48871": { "city" : "PERRINTON", "state" : "MI", "county" : "GRATIOT" },
            "48872": { "city" : "PERRY", "state" : "MI", "county" : "SHIAWASSEE" },
            "48873": { "city" : "PEWAMO", "state" : "MI", "county" : "IONIA" },"48874": { "city" : "POMPEII", "state" : "MI", "county" : "GRATIOT" },
            "48875": { "city" : "PORTLAND", "state" : "MI", "county" : "IONIA" },
            "48876": { "city" : "POTTERVILLE", "state" : "MI", "county" : "EATON" },
            "48877": { "city" : "RIVERDALE", "state" : "MI", "county" : "GRATIOT" },
            "48878": { "city" : "ROSEBUSH", "state" : "MI", "county" : "ISABELLA" },
            "48879": { "city" : "SAINT JOHNS", "state" : "MI", "county" : "CLINTON" },
            "48880": { "city" : "SAINT LOUIS", "state" : "MI", "county" : "GRATIOT" },
            "48881": { "city" : "SARANAC", "state" : "MI", "county" : "IONIA" },"48882": { "city" : "SHAFTSBURG", "state" : "MI", "county" : "SHIAWASSEE" },
            "48883": { "city" : "SHEPHERD", "state" : "MI", "county" : "ISABELLA" },
            "48884": { "city" : "SHERIDAN", "state" : "MI", "county" : "MONTCALM" },
            "48885": { "city" : "SIDNEY", "state" : "MI", "county" : "MONTCALM" },
            "48886": { "city" : "SIX LAKES", "state" : "MI", "county" : "MONTCALM" },
            "48887": { "city" : "SMYRNA", "state" : "MI", "county" : "IONIA" },"48888": { "city" : "STANTON", "state" : "MI", "county" : "MONTCALM" },
            "48889": { "city" : "SUMNER", "state" : "MI", "county" : "GRATIOT" },
            "48890": { "city" : "SUNFIELD", "state" : "MI", "county" : "EATON" },
            "48891": { "city" : "VESTABURG", "state" : "MI", "county" : "MONTCALM" },
            "48892": { "city" : "WEBBERVILLE", "state" : "MI", "county" : "INGHAM" },
            "48893": { "city" : "WEIDMAN", "state" : "MI", "county" : "ISABELLA" },
            "48894": { "city" : "WESTPHALIA", "state" : "MI", "county" : "CLINTON" },
            "48895": { "city" : "WILLIAMSTON", "state" : "MI", "county" : "INGHAM" },
            "48896": { "city" : "WINN", "state" : "MI", "county" : "ISABELLA" },"48897": { "city" : "WOODLAND", "state" : "MI", "county" : "BARRY" },
            "48901": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48906": { "city" : "LANSING", "state" : "MI", "county" : "CLINTON" },
            "48908": { "city" : "LANSING", "state" : "MI", "county" : "EATON" },"48909": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48910": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48911": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48912": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48913": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48915": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48916": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48917": { "city" : "LANSING", "state" : "MI", "county" : "EATON" },"48918": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48921": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48933": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "48951": { "city" : "LANSING", "state" : "MI", "county" : "INGHAM" },
            "49001": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49002": { "city" : "PORTAGE", "state" : "MI", "county" : "KALAMAZOO" },
            "49003": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49004": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49005": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49006": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49007": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49008": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49009": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49010": { "city" : "ALLEGAN", "state" : "MI", "county" : "ALLEGAN" },
            "49011": { "city" : "ATHENS", "state" : "MI", "county" : "CALHOUN" },
            "49012": { "city" : "AUGUSTA", "state" : "MI", "county" : "KALAMAZOO" },
            "49013": { "city" : "BANGOR", "state" : "MI", "county" : "VAN BUREN" },
            "49014": { "city" : "BATTLE CREEK", "state" : "MI", "county" : "CALHOUN" },
            "49015": { "city" : "BATTLE CREEK", "state" : "MI", "county" : "CALHOUN" },
            "49016": { "city" : "BATTLE CREEK", "state" : "MI", "county" : "CALHOUN" },
            "49017": { "city" : "BATTLE CREEK", "state" : "MI", "county" : "CALHOUN" },
            "49019": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49020": { "city" : "BEDFORD", "state" : "MI", "county" : "CALHOUN" },
            "49021": { "city" : "BELLEVUE", "state" : "MI", "county" : "EATON" },
            "49022": { "city" : "BENTON HARBOR", "state" : "MI", "county" : "BERRIEN" },
            "49023": { "city" : "BENTON HARBOR", "state" : "MI", "county" : "BERRIEN" },
            "49024": { "city" : "PORTAGE", "state" : "MI", "county" : "KALAMAZOO" },
            "49026": { "city" : "BLOOMINGDALE", "state" : "MI", "county" : "VAN BUREN" },
            "49027": { "city" : "BREEDSVILLE", "state" : "MI", "county" : "VAN BUREN" },
            "49028": { "city" : "BRONSON", "state" : "MI", "county" : "BRANCH" },
            "49029": { "city" : "BURLINGTON", "state" : "MI", "county" : "CALHOUN" },
            "49030": { "city" : "BURR OAK", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49031": { "city" : "CASSOPOLIS", "state" : "MI", "county" : "CASS" },
            "49032": { "city" : "CENTREVILLE", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49033": { "city" : "CERESCO", "state" : "MI", "county" : "CALHOUN" },
            "49034": { "city" : "CLIMAX", "state" : "MI", "county" : "KALAMAZOO" },
            "49035": { "city" : "CLOVERDALE", "state" : "MI", "county" : "BARRY" },
            "49036": { "city" : "COLDWATER", "state" : "MI", "county" : "BRANCH" },
            "49037": { "city" : "BATTLE CREEK", "state" : "MI", "county" : "CALHOUN" },
            "49038": { "city" : "COLOMA", "state" : "MI", "county" : "BERRIEN" },
            "49040": { "city" : "COLON", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49041": { "city" : "COMSTOCK", "state" : "MI", "county" : "KALAMAZOO" },
            "49042": { "city" : "CONSTANTINE", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49043": { "city" : "COVERT", "state" : "MI", "county" : "VAN BUREN" },
            "49045": { "city" : "DECATUR", "state" : "MI", "county" : "VAN BUREN" },
            "49046": { "city" : "DELTON", "state" : "MI", "county" : "BARRY" },"49047": { "city" : "DOWAGIAC", "state" : "MI", "county" : "CASS" },
            "49048": { "city" : "KALAMAZOO", "state" : "MI", "county" : "KALAMAZOO" },
            "49050": { "city" : "DOWLING", "state" : "MI", "county" : "BARRY" },"49051": { "city" : "EAST LEROY", "state" : "MI", "county" : "CALHOUN" },
            "49052": { "city" : "FULTON", "state" : "MI", "county" : "KALAMAZOO" },
            "49053": { "city" : "GALESBURG", "state" : "MI", "county" : "KALAMAZOO" },
            "49055": { "city" : "GOBLES", "state" : "MI", "county" : "VAN BUREN" },
            "49056": { "city" : "GRAND JUNCTION", "state" : "MI", "county" : "VAN BUREN" },
            "49057": { "city" : "HARTFORD", "state" : "MI", "county" : "VAN BUREN" },
            "49058": { "city" : "HASTINGS", "state" : "MI", "county" : "BARRY" },
            "49060": { "city" : "HICKORY CORNERS", "state" : "MI", "county" : "BARRY" },
            "49061": { "city" : "JONES", "state" : "MI", "county" : "CASS" },"49062": { "city" : "KENDALL", "state" : "MI", "county" : "VAN BUREN" },
            "49064": { "city" : "LAWRENCE", "state" : "MI", "county" : "VAN BUREN" },
            "49065": { "city" : "LAWTON", "state" : "MI", "county" : "VAN BUREN" },
            "49066": { "city" : "LEONIDAS", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49067": { "city" : "MARCELLUS", "state" : "MI", "county" : "CASS" },
            "49068": { "city" : "MARSHALL", "state" : "MI", "county" : "CALHOUN" },
            "49070": { "city" : "MARTIN", "state" : "MI", "county" : "ALLEGAN" },
            "49071": { "city" : "MATTAWAN", "state" : "MI", "county" : "VAN BUREN" },
            "49072": { "city" : "MENDON", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49073": { "city" : "NASHVILLE", "state" : "MI", "county" : "BARRY" },
            "49074": { "city" : "NAZARETH", "state" : "MI", "county" : "KALAMAZOO" },
            "49075": { "city" : "NOTTAWA", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49076": { "city" : "OLIVET", "state" : "MI", "county" : "EATON" },"49077": { "city" : "OSHTEMO", "state" : "MI", "county" : "KALAMAZOO" },
            "49078": { "city" : "OTSEGO", "state" : "MI", "county" : "ALLEGAN" },
            "49079": { "city" : "PAW PAW", "state" : "MI", "county" : "VAN BUREN" },
            "49080": { "city" : "PLAINWELL", "state" : "MI", "county" : "ALLEGAN" },
            "49081": { "city" : "PORTAGE", "state" : "MI", "county" : "KALAMAZOO" },
            "49082": { "city" : "QUINCY", "state" : "MI", "county" : "BRANCH" },"49083": { "city" : "RICHLAND", "state" : "MI", "county" : "KALAMAZOO" },
            "49084": { "city" : "RIVERSIDE", "state" : "MI", "county" : "BERRIEN" },
            "49085": { "city" : "SAINT JOSEPH", "state" : "MI", "county" : "BERRIEN" },
            "49087": { "city" : "SCHOOLCRAFT", "state" : "MI", "county" : "KALAMAZOO" },
            "49088": { "city" : "SCOTTS", "state" : "MI", "county" : "KALAMAZOO" },
            "49089": { "city" : "SHERWOOD", "state" : "MI", "county" : "BRANCH" },
            "49090": { "city" : "SOUTH HAVEN", "state" : "MI", "county" : "VAN BUREN" },
            "49091": { "city" : "STURGIS", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49092": { "city" : "TEKONSHA", "state" : "MI", "county" : "CALHOUN" },
            "49093": { "city" : "THREE RIVERS", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49094": { "city" : "UNION CITY", "state" : "MI", "county" : "BRANCH" },
            "49095": { "city" : "VANDALIA", "state" : "MI", "county" : "CASS" },"49096": { "city" : "VERMONTVILLE", "state" : "MI", "county" : "EATON" },
            "49097": { "city" : "VICKSBURG", "state" : "MI", "county" : "KALAMAZOO" },
            "49098": { "city" : "WATERVLIET", "state" : "MI", "county" : "BERRIEN" },
            "49099": { "city" : "WHITE PIGEON", "state" : "MI", "county" : "SAINT JOSEPH" },
            "49101": { "city" : "BARODA", "state" : "MI", "county" : "BERRIEN" },
            "49102": { "city" : "BERRIEN CENTER", "state" : "MI", "county" : "BERRIEN" },
            "49103": { "city" : "BERRIEN SPRINGS", "state" : "MI", "county" : "BERRIEN" },
            "49104": { "city" : "BERRIEN SPRINGS", "state" : "MI", "county" : "BERRIEN" },
            "49106": { "city" : "BRIDGMAN", "state" : "MI", "county" : "BERRIEN" },
            "49107": { "city" : "BUCHANAN", "state" : "MI", "county" : "BERRIEN" },
            "49111": { "city" : "EAU CLAIRE", "state" : "MI", "county" : "BERRIEN" },
            "49112": { "city" : "EDWARDSBURG", "state" : "MI", "county" : "CASS" },
            "49113": { "city" : "GALIEN", "state" : "MI", "county" : "BERRIEN" },
            "49115": { "city" : "HARBERT", "state" : "MI", "county" : "BERRIEN" },
            "49116": { "city" : "LAKESIDE", "state" : "MI", "county" : "BERRIEN" },
            "49117": { "city" : "NEW BUFFALO", "state" : "MI", "county" : "BERRIEN" },
            "49119": { "city" : "NEW TROY", "state" : "MI", "county" : "BERRIEN" },
            "49120": { "city" : "NILES", "state" : "MI", "county" : "BERRIEN" },"49125": { "city" : "SAWYER", "state" : "MI", "county" : "BERRIEN" },
            "49126": { "city" : "SODUS", "state" : "MI", "county" : "BERRIEN" },"49127": { "city" : "STEVENSVILLE", "state" : "MI", "county" : "BERRIEN" },
            "49128": { "city" : "THREE OAKS", "state" : "MI", "county" : "BERRIEN" },
            "49129": { "city" : "UNION PIER", "state" : "MI", "county" : "BERRIEN" },
            "49130": { "city" : "UNION", "state" : "MI", "county" : "CASS" },"49201": { "city" : "JACKSON", "state" : "MI", "county" : "JACKSON" },
            "49202": { "city" : "JACKSON", "state" : "MI", "county" : "JACKSON" },
            "49203": { "city" : "JACKSON", "state" : "MI", "county" : "JACKSON" },
            "49204": { "city" : "JACKSON", "state" : "MI", "county" : "JACKSON" },
            "49220": { "city" : "ADDISON", "state" : "MI", "county" : "LENAWEE" },
            "49221": { "city" : "ADRIAN", "state" : "MI", "county" : "LENAWEE" },
            "49224": { "city" : "ALBION", "state" : "MI", "county" : "CALHOUN" },
            "49227": { "city" : "ALLEN", "state" : "MI", "county" : "HILLSDALE" },
            "49228": { "city" : "BLISSFIELD", "state" : "MI", "county" : "LENAWEE" },
            "49229": { "city" : "BRITTON", "state" : "MI", "county" : "LENAWEE" },
            "49230": { "city" : "BROOKLYN", "state" : "MI", "county" : "JACKSON" },
            "49232": { "city" : "CAMDEN", "state" : "MI", "county" : "HILLSDALE" },
            "49233": { "city" : "CEMENT CITY", "state" : "MI", "county" : "LENAWEE" },
            "49234": { "city" : "CLARKLAKE", "state" : "MI", "county" : "JACKSON" },
            "49235": { "city" : "CLAYTON", "state" : "MI", "county" : "LENAWEE" },
            "49236": { "city" : "CLINTON", "state" : "MI", "county" : "LENAWEE" },
            "49237": { "city" : "CONCORD", "state" : "MI", "county" : "JACKSON" },
            "49238": { "city" : "DEERFIELD", "state" : "MI", "county" : "LENAWEE" },
            "49239": { "city" : "FRONTIER", "state" : "MI", "county" : "HILLSDALE" },
            "49240": { "city" : "GRASS LAKE", "state" : "MI", "county" : "JACKSON" },
            "49241": { "city" : "HANOVER", "state" : "MI", "county" : "JACKSON" },
            "49242": { "city" : "HILLSDALE", "state" : "MI", "county" : "HILLSDALE" },
            "49245": { "city" : "HOMER", "state" : "MI", "county" : "CALHOUN" },"49246": { "city" : "HORTON", "state" : "MI", "county" : "JACKSON" },
            "49247": { "city" : "HUDSON", "state" : "MI", "county" : "LENAWEE" },
            "49248": { "city" : "JASPER", "state" : "MI", "county" : "LENAWEE" },
            "49249": { "city" : "JEROME", "state" : "MI", "county" : "HILLSDALE" },
            "49250": { "city" : "JONESVILLE", "state" : "MI", "county" : "HILLSDALE" },
            "49251": { "city" : "LESLIE", "state" : "MI", "county" : "INGHAM" },"49252": { "city" : "LITCHFIELD", "state" : "MI", "county" : "HILLSDALE" },
            "49253": { "city" : "MANITOU BEACH", "state" : "MI", "county" : "LENAWEE" },
            "49254": { "city" : "MICHIGAN CENTER", "state" : "MI", "county" : "JACKSON" },
            "49255": { "city" : "MONTGOMERY", "state" : "MI", "county" : "BRANCH" },
            "49256": { "city" : "MORENCI", "state" : "MI", "county" : "LENAWEE" },
            "49257": { "city" : "MOSCOW", "state" : "MI", "county" : "HILLSDALE" },
            "49258": { "city" : "MOSHERVILLE", "state" : "MI", "county" : "HILLSDALE" },
            "49259": { "city" : "MUNITH", "state" : "MI", "county" : "JACKSON" },
            "49261": { "city" : "NAPOLEON", "state" : "MI", "county" : "JACKSON" },
            "49262": { "city" : "NORTH ADAMS", "state" : "MI", "county" : "HILLSDALE" },
            "49264": { "city" : "ONONDAGA", "state" : "MI", "county" : "INGHAM" },
            "49265": { "city" : "ONSTED", "state" : "MI", "county" : "LENAWEE" },
            "49266": { "city" : "OSSEO", "state" : "MI", "county" : "HILLSDALE" },
            "49267": { "city" : "OTTAWA LAKE", "state" : "MI", "county" : "MONROE" },
            "49268": { "city" : "PALMYRA", "state" : "MI", "county" : "LENAWEE" },
            "49269": { "city" : "PARMA", "state" : "MI", "county" : "JACKSON" },"49270": { "city" : "PETERSBURG", "state" : "MI", "county" : "MONROE" },
            "49271": { "city" : "PITTSFORD", "state" : "MI", "county" : "HILLSDALE" },
            "49272": { "city" : "PLEASANT LAKE", "state" : "MI", "county" : "JACKSON" },
            "49274": { "city" : "READING", "state" : "MI", "county" : "HILLSDALE" },
            "49276": { "city" : "RIGA", "state" : "MI", "county" : "LENAWEE" },"49277": { "city" : "RIVES JUNCTION", "state" : "MI", "county" : "JACKSON" },
            "49279": { "city" : "SAND CREEK", "state" : "MI", "county" : "LENAWEE" },
            "49281": { "city" : "SOMERSET", "state" : "MI", "county" : "HILLSDALE" },
            "49282": { "city" : "SOMERSET CENTER", "state" : "MI", "county" : "HILLSDALE" },
            "49283": { "city" : "SPRING ARBOR", "state" : "MI", "county" : "JACKSON" },
            "49284": { "city" : "SPRINGPORT", "state" : "MI", "county" : "JACKSON" },
            "49285": { "city" : "STOCKBRIDGE", "state" : "MI", "county" : "INGHAM" },
            "49286": { "city" : "TECUMSEH", "state" : "MI", "county" : "LENAWEE" },
            "49287": { "city" : "TIPTON", "state" : "MI", "county" : "LENAWEE" },
            "49288": { "city" : "WALDRON", "state" : "MI", "county" : "HILLSDALE" },
            "49289": { "city" : "WESTON", "state" : "MI", "county" : "LENAWEE" },
            "49301": { "city" : "ADA", "state" : "MI", "county" : "KENT" },"49302": { "city" : "ALTO", "state" : "MI", "county" : "KENT" },
            "49303": { "city" : "BAILEY", "state" : "MI", "county" : "MUSKEGON" },
            "49304": { "city" : "BALDWIN", "state" : "MI", "county" : "LAKE" },"49305": { "city" : "BARRYTON", "state" : "MI", "county" : "MECOSTA" },
            "49306": { "city" : "BELMONT", "state" : "MI", "county" : "KENT" },"49307": { "city" : "BIG RAPIDS", "state" : "MI", "county" : "MECOSTA" },
            "49309": { "city" : "BITELY", "state" : "MI", "county" : "NEWAYGO" },
            "49310": { "city" : "BLANCHARD", "state" : "MI", "county" : "ISABELLA" },
            "49311": { "city" : "BRADLEY", "state" : "MI", "county" : "ALLEGAN" },
            "49312": { "city" : "BROHMAN", "state" : "MI", "county" : "NEWAYGO" },
            "49314": { "city" : "BURNIPS", "state" : "MI", "county" : "ALLEGAN" },
            "49315": { "city" : "BYRON CENTER", "state" : "MI", "county" : "KENT" },
            "49316": { "city" : "CALEDONIA", "state" : "MI", "county" : "KENT" },
            "49317": { "city" : "CANNONSBURG", "state" : "MI", "county" : "KENT" },
            "49318": { "city" : "CASNOVIA", "state" : "MI", "county" : "MUSKEGON" },
            "49319": { "city" : "CEDAR SPRINGS", "state" : "MI", "county" : "KENT" },
            "49320": { "city" : "CHIPPEWA LAKE", "state" : "MI", "county" : "MECOSTA" },
            "49321": { "city" : "COMSTOCK PARK", "state" : "MI", "county" : "KENT" },
            "49322": { "city" : "CORAL", "state" : "MI", "county" : "MONTCALM" },
            "49323": { "city" : "DORR", "state" : "MI", "county" : "ALLEGAN" },"49325": { "city" : "FREEPORT", "state" : "MI", "county" : "BARRY" },
            "49326": { "city" : "GOWEN", "state" : "MI", "county" : "KENT" },"49327": { "city" : "GRANT", "state" : "MI", "county" : "NEWAYGO" },
            "49328": { "city" : "HOPKINS", "state" : "MI", "county" : "ALLEGAN" },
            "49329": { "city" : "HOWARD CITY", "state" : "MI", "county" : "MONTCALM" },
            "49330": { "city" : "KENT CITY", "state" : "MI", "county" : "KENT" },
            "49331": { "city" : "LOWELL", "state" : "MI", "county" : "KENT" },"49332": { "city" : "MECOSTA", "state" : "MI", "county" : "MECOSTA" },
            "49333": { "city" : "MIDDLEVILLE", "state" : "MI", "county" : "BARRY" },
            "49335": { "city" : "MOLINE", "state" : "MI", "county" : "ALLEGAN" },
            "49336": { "city" : "MORLEY", "state" : "MI", "county" : "MECOSTA" },
            "49337": { "city" : "NEWAYGO", "state" : "MI", "county" : "NEWAYGO" },
            "49338": { "city" : "PARIS", "state" : "MI", "county" : "MECOSTA" },"49339": { "city" : "PIERSON", "state" : "MI", "county" : "MONTCALM" },
            "49340": { "city" : "REMUS", "state" : "MI", "county" : "MECOSTA" },"49341": { "city" : "ROCKFORD", "state" : "MI", "county" : "KENT" },
            "49342": { "city" : "RODNEY", "state" : "MI", "county" : "MECOSTA" },
            "49343": { "city" : "SAND LAKE", "state" : "MI", "county" : "KENT" },
            "49344": { "city" : "SHELBYVILLE", "state" : "MI", "county" : "ALLEGAN" },
            "49345": { "city" : "SPARTA", "state" : "MI", "county" : "KENT" },"49346": { "city" : "STANWOOD", "state" : "MI", "county" : "MECOSTA" },
            "49347": { "city" : "TRUFANT", "state" : "MI", "county" : "MONTCALM" },
            "49348": { "city" : "WAYLAND", "state" : "MI", "county" : "ALLEGAN" },
            "49349": { "city" : "WHITE CLOUD", "state" : "MI", "county" : "NEWAYGO" },
            "49351": { "city" : "ROCKFORD", "state" : "MI", "county" : "KENT" },"49355": { "city" : "ADA", "state" : "MI", "county" : "KENT" },
            "49401": { "city" : "ALLENDALE", "state" : "MI", "county" : "OTTAWA" },
            "49402": { "city" : "BRANCH", "state" : "MI", "county" : "MASON" },"49403": { "city" : "CONKLIN", "state" : "MI", "county" : "OTTAWA" },
            "49404": { "city" : "COOPERSVILLE", "state" : "MI", "county" : "OTTAWA" },
            "49405": { "city" : "CUSTER", "state" : "MI", "county" : "MASON" },"49406": { "city" : "DOUGLAS", "state" : "MI", "county" : "ALLEGAN" },
            "49408": { "city" : "FENNVILLE", "state" : "MI", "county" : "ALLEGAN" },
            "49409": { "city" : "FERRYSBURG", "state" : "MI", "county" : "OTTAWA" },
            "49410": { "city" : "FOUNTAIN", "state" : "MI", "county" : "MASON" },
            "49411": { "city" : "FREE SOIL", "state" : "MI", "county" : "MASON" },
            "49412": { "city" : "FREMONT", "state" : "MI", "county" : "NEWAYGO" },
            "49413": { "city" : "FREMONT", "state" : "MI", "county" : "NEWAYGO" },
            "49415": { "city" : "FRUITPORT", "state" : "MI", "county" : "MUSKEGON" },
            "49416": { "city" : "GLENN", "state" : "MI", "county" : "ALLEGAN" },"49417": { "city" : "GRAND HAVEN", "state" : "MI", "county" : "OTTAWA" },
            "49418": { "city" : "GRANDVILLE", "state" : "MI", "county" : "KENT" },
            "49419": { "city" : "HAMILTON", "state" : "MI", "county" : "ALLEGAN" },
            "49420": { "city" : "HART", "state" : "MI", "county" : "OCEANA" },"49421": { "city" : "HESPERIA", "state" : "MI", "county" : "OCEANA" },
            "49422": { "city" : "HOLLAND", "state" : "MI", "county" : "OTTAWA" },
            "49423": { "city" : "HOLLAND", "state" : "MI", "county" : "OTTAWA" },
            "49424": { "city" : "HOLLAND", "state" : "MI", "county" : "OTTAWA" },
            "49425": { "city" : "HOLTON", "state" : "MI", "county" : "MUSKEGON" },
            "49426": { "city" : "HUDSONVILLE", "state" : "MI", "county" : "OTTAWA" },
            "49427": { "city" : "JAMESTOWN", "state" : "MI", "county" : "OTTAWA" },
            "49428": { "city" : "JENISON", "state" : "MI", "county" : "OTTAWA" },
            "49429": { "city" : "JENISON", "state" : "MI", "county" : "OTTAWA" },
            "49430": { "city" : "LAMONT", "state" : "MI", "county" : "OTTAWA" },"49431": { "city" : "LUDINGTON", "state" : "MI", "county" : "MASON" },
            "49434": { "city" : "MACATAWA", "state" : "MI", "county" : "OTTAWA" },
            "49435": { "city" : "MARNE", "state" : "MI", "county" : "OTTAWA" },"49436": { "city" : "MEARS", "state" : "MI", "county" : "OCEANA" },
            "49437": { "city" : "MONTAGUE", "state" : "MI", "county" : "MUSKEGON" },
            "49440": { "city" : "MUSKEGON", "state" : "MI", "county" : "MUSKEGON" },
            "49441": { "city" : "MUSKEGON", "state" : "MI", "county" : "MUSKEGON" },
            "49442": { "city" : "MUSKEGON", "state" : "MI", "county" : "MUSKEGON" },
            "49443": { "city" : "MUSKEGON", "state" : "MI", "county" : "MUSKEGON" },
            "49444": { "city" : "MUSKEGON", "state" : "MI", "county" : "MUSKEGON" },
            "49445": { "city" : "MUSKEGON", "state" : "MI", "county" : "MUSKEGON" },
            "49446": { "city" : "NEW ERA", "state" : "MI", "county" : "OCEANA" },
            "49448": { "city" : "NUNICA", "state" : "MI", "county" : "OTTAWA" },"49449": { "city" : "PENTWATER", "state" : "MI", "county" : "OCEANA" },
            "49450": { "city" : "PULLMAN", "state" : "MI", "county" : "ALLEGAN" },
            "49451": { "city" : "RAVENNA", "state" : "MI", "county" : "MUSKEGON" },
            "49452": { "city" : "ROTHBURY", "state" : "MI", "county" : "OCEANA" },
            "49453": { "city" : "SAUGATUCK", "state" : "MI", "county" : "ALLEGAN" },
            "49454": { "city" : "SCOTTVILLE", "state" : "MI", "county" : "MASON" },
            "49455": { "city" : "SHELBY", "state" : "MI", "county" : "OCEANA" },"49456": { "city" : "SPRING LAKE", "state" : "MI", "county" : "OTTAWA" },
            "49457": { "city" : "TWIN LAKE", "state" : "MI", "county" : "MUSKEGON" },
            "49458": { "city" : "WALHALLA", "state" : "MI", "county" : "MASON" },
            "49459": { "city" : "WALKERVILLE", "state" : "MI", "county" : "OCEANA" },
            "49460": { "city" : "WEST OLIVE", "state" : "MI", "county" : "OTTAWA" },
            "49461": { "city" : "WHITEHALL", "state" : "MI", "county" : "MUSKEGON" },
            "49464": { "city" : "ZEELAND", "state" : "MI", "county" : "OTTAWA" },
            "49468": { "city" : "GRANDVILLE", "state" : "MI", "county" : "KENT" },
            "49501": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49502": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49503": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49504": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49505": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49506": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49507": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49508": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49509": { "city" : "WYOMING", "state" : "MI", "county" : "KENT" },"49510": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49512": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49514": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49515": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49516": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49518": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49519": { "city" : "WYOMING", "state" : "MI", "county" : "KENT" },"49523": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49525": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49528": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49530": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49534": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49544": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49546": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49548": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49560": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49588": { "city" : "GRAND RAPIDS", "state" : "MI", "county" : "KENT" },
            "49601": { "city" : "CADILLAC", "state" : "MI", "county" : "WEXFORD" },
            "49610": { "city" : "ACME", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49611": { "city" : "ALBA", "state" : "MI", "county" : "ANTRIM" },"49612": { "city" : "ALDEN", "state" : "MI", "county" : "ANTRIM" },
            "49613": { "city" : "ARCADIA", "state" : "MI", "county" : "MANISTEE" },
            "49614": { "city" : "BEAR LAKE", "state" : "MI", "county" : "MANISTEE" },
            "49615": { "city" : "BELLAIRE", "state" : "MI", "county" : "ANTRIM" },
            "49616": { "city" : "BENZONIA", "state" : "MI", "county" : "BENZIE" },
            "49617": { "city" : "BEULAH", "state" : "MI", "county" : "BENZIE" },"49618": { "city" : "BOON", "state" : "MI", "county" : "WEXFORD" },
            "49619": { "city" : "BRETHREN", "state" : "MI", "county" : "MANISTEE" },
            "49620": { "city" : "BUCKLEY", "state" : "MI", "county" : "WEXFORD" },
            "49621": { "city" : "CEDAR", "state" : "MI", "county" : "LEELANAU" },
            "49622": { "city" : "CENTRAL LAKE", "state" : "MI", "county" : "ANTRIM" },
            "49623": { "city" : "CHASE", "state" : "MI", "county" : "LAKE" },"49625": { "city" : "COPEMISH", "state" : "MI", "county" : "MANISTEE" },
            "49626": { "city" : "EASTLAKE", "state" : "MI", "county" : "MANISTEE" },
            "49627": { "city" : "EASTPORT", "state" : "MI", "county" : "ANTRIM" },
            "49628": { "city" : "ELBERTA", "state" : "MI", "county" : "BENZIE" },
            "49629": { "city" : "ELK RAPIDS", "state" : "MI", "county" : "ANTRIM" },
            "49630": { "city" : "EMPIRE", "state" : "MI", "county" : "LEELANAU" },
            "49631": { "city" : "EVART", "state" : "MI", "county" : "OSCEOLA" },"49632": { "city" : "FALMOUTH", "state" : "MI", "county" : "MISSAUKEE" },
            "49633": { "city" : "FIFE LAKE", "state" : "MI", "county" : "KALKASKA" },
            "49634": { "city" : "FILER CITY", "state" : "MI", "county" : "MANISTEE" },
            "49635": { "city" : "FRANKFORT", "state" : "MI", "county" : "BENZIE" },
            "49636": { "city" : "GLEN ARBOR", "state" : "MI", "county" : "LEELANAU" },
            "49637": { "city" : "GRAWN", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49638": { "city" : "HARRIETTA", "state" : "MI", "county" : "WEXFORD" },
            "49639": { "city" : "HERSEY", "state" : "MI", "county" : "OSCEOLA" },
            "49640": { "city" : "HONOR", "state" : "MI", "county" : "BENZIE" },"49642": { "city" : "IDLEWILD", "state" : "MI", "county" : "LAKE" },
            "49643": { "city" : "INTERLOCHEN", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49644": { "city" : "IRONS", "state" : "MI", "county" : "LAKE" },"49645": { "city" : "KALEVA", "state" : "MI", "county" : "MANISTEE" },
            "49646": { "city" : "KALKASKA", "state" : "MI", "county" : "KALKASKA" },
            "49648": { "city" : "KEWADIN", "state" : "MI", "county" : "ANTRIM" },
            "49649": { "city" : "KINGSLEY", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49650": { "city" : "LAKE ANN", "state" : "MI", "county" : "BENZIE" },
            "49651": { "city" : "LAKE CITY", "state" : "MI", "county" : "MISSAUKEE" },
            "49653": { "city" : "LAKE LEELANAU", "state" : "MI", "county" : "LEELANAU" },
            "49654": { "city" : "LELAND", "state" : "MI", "county" : "LEELANAU" },
            "49655": { "city" : "LEROY", "state" : "MI", "county" : "OSCEOLA" },"49656": { "city" : "LUTHER", "state" : "MI", "county" : "LAKE" },
            "49657": { "city" : "MC BAIN", "state" : "MI", "county" : "MISSAUKEE" },
            "49659": { "city" : "MANCELONA", "state" : "MI", "county" : "ANTRIM" },
            "49660": { "city" : "MANISTEE", "state" : "MI", "county" : "MANISTEE" },
            "49663": { "city" : "MANTON", "state" : "MI", "county" : "WEXFORD" },
            "49664": { "city" : "MAPLE CITY", "state" : "MI", "county" : "LEELANAU" },
            "49665": { "city" : "MARION", "state" : "MI", "county" : "OSCEOLA" },
            "49666": { "city" : "MAYFIELD", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49667": { "city" : "MERRITT", "state" : "MI", "county" : "MISSAUKEE" },
            "49668": { "city" : "MESICK", "state" : "MI", "county" : "WEXFORD" },
            "49670": { "city" : "NORTHPORT", "state" : "MI", "county" : "LEELANAU" },
            "49673": { "city" : "OLD MISSION", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49674": { "city" : "OMENA", "state" : "MI", "county" : "LEELANAU" },
            "49675": { "city" : "ONEKAMA", "state" : "MI", "county" : "MANISTEE" },
            "49676": { "city" : "RAPID CITY", "state" : "MI", "county" : "KALKASKA" },
            "49677": { "city" : "REED CITY", "state" : "MI", "county" : "OSCEOLA" },
            "49679": { "city" : "SEARS", "state" : "MI", "county" : "OSCEOLA" },"49680": { "city" : "SOUTH BOARDMAN", "state" : "MI", "county" : "KALKASKA" },
            "49682": { "city" : "SUTTONS BAY", "state" : "MI", "county" : "LEELANAU" },
            "49683": { "city" : "THOMPSONVILLE", "state" : "MI", "county" : "BENZIE" },
            "49684": { "city" : "TRAVERSE CITY", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49685": { "city" : "TRAVERSE CITY", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49686": { "city" : "TRAVERSE CITY", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49688": { "city" : "TUSTIN", "state" : "MI", "county" : "OSCEOLA" },
            "49689": { "city" : "WELLSTON", "state" : "MI", "county" : "MANISTEE" },
            "49690": { "city" : "WILLIAMSBURG", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49696": { "city" : "TRAVERSE CITY", "state" : "MI", "county" : "GRAND TRAVERSE" },
            "49701": { "city" : "MACKINAW CITY", "state" : "MI", "county" : "CHEBOYGAN" },
            "49705": { "city" : "AFTON", "state" : "MI", "county" : "CHEBOYGAN" },
            "49706": { "city" : "ALANSON", "state" : "MI", "county" : "EMMET" },"49707": { "city" : "ALPENA", "state" : "MI", "county" : "ALPENA" },
            "49709": { "city" : "ATLANTA", "state" : "MI", "county" : "MONTMORENCY" },
            "49710": { "city" : "BARBEAU", "state" : "MI", "county" : "CHIPPEWA" },
            "49711": { "city" : "BAY SHORE", "state" : "MI", "county" : "CHARLEVOIX" },
            "49712": { "city" : "BOYNE CITY", "state" : "MI", "county" : "CHARLEVOIX" },
            "49713": { "city" : "BOYNE FALLS", "state" : "MI", "county" : "CHARLEVOIX" },
            "49715": { "city" : "BRIMLEY", "state" : "MI", "county" : "CHIPPEWA" },
            "49716": { "city" : "BRUTUS", "state" : "MI", "county" : "EMMET" },"49717": { "city" : "BURT LAKE", "state" : "MI", "county" : "CHEBOYGAN" },
            "49718": { "city" : "CARP LAKE", "state" : "MI", "county" : "EMMET" },
            "49719": { "city" : "CEDARVILLE", "state" : "MI", "county" : "MACKINAC" },
            "49720": { "city" : "CHARLEVOIX", "state" : "MI", "county" : "CHARLEVOIX" },
            "49721": { "city" : "CHEBOYGAN", "state" : "MI", "county" : "CHEBOYGAN" },
            "49722": { "city" : "CONWAY", "state" : "MI", "county" : "EMMET" },"49723": { "city" : "CROSS VILLAGE", "state" : "MI", "county" : "EMMET" },
            "49724": { "city" : "DAFTER", "state" : "MI", "county" : "CHIPPEWA" },
            "49725": { "city" : "DE TOUR VILLAGE", "state" : "MI", "county" : "CHIPPEWA" },
            "49726": { "city" : "DRUMMOND ISLAND", "state" : "MI", "county" : "CHIPPEWA" },
            "49727": { "city" : "EAST JORDAN", "state" : "MI", "county" : "CHARLEVOIX" },
            "49728": { "city" : "ECKERMAN", "state" : "MI", "county" : "CHIPPEWA" },
            "49729": { "city" : "ELLSWORTH", "state" : "MI", "county" : "ANTRIM" },
            "49730": { "city" : "ELMIRA", "state" : "MI", "county" : "OTSEGO" },"49733": { "city" : "FREDERIC", "state" : "MI", "county" : "CRAWFORD" },
            "49734": { "city" : "GAYLORD", "state" : "MI", "county" : "OTSEGO" },
            "49735": { "city" : "GAYLORD", "state" : "MI", "county" : "OTSEGO" },
            "49736": { "city" : "GOETZVILLE", "state" : "MI", "county" : "CHIPPEWA" },
            "49737": { "city" : "GOOD HART", "state" : "MI", "county" : "EMMET" },
            "49738": { "city" : "GRAYLING", "state" : "MI", "county" : "CRAWFORD" },
            "49739": { "city" : "GRAYLING", "state" : "MI", "county" : "CRAWFORD" },
            "49740": { "city" : "HARBOR SPRINGS", "state" : "MI", "county" : "EMMET" },
            "49743": { "city" : "HAWKS", "state" : "MI", "county" : "PRESQUE ISLE" },
            "49744": { "city" : "HERRON", "state" : "MI", "county" : "ALPENA" },"49745": { "city" : "HESSEL", "state" : "MI", "county" : "MACKINAC" },
            "49746": { "city" : "HILLMAN", "state" : "MI", "county" : "MONTMORENCY" },
            "49747": { "city" : "HUBBARD LAKE", "state" : "MI", "county" : "ALPENA" },
            "49748": { "city" : "HULBERT", "state" : "MI", "county" : "CHIPPEWA" },
            "49749": { "city" : "INDIAN RIVER", "state" : "MI", "county" : "CHEBOYGAN" },
            "49751": { "city" : "JOHANNESBURG", "state" : "MI", "county" : "OTSEGO" },
            "49752": { "city" : "KINROSS", "state" : "MI", "county" : "CHIPPEWA" },
            "49753": { "city" : "LACHINE", "state" : "MI", "county" : "ALPENA" },
            "49755": { "city" : "LEVERING", "state" : "MI", "county" : "EMMET" },
            "49756": { "city" : "LEWISTON", "state" : "MI", "county" : "MONTMORENCY" },
            "49757": { "city" : "MACKINAC ISLAND", "state" : "MI", "county" : "MACKINAC" },
            "49759": { "city" : "MILLERSBURG", "state" : "MI", "county" : "PRESQUE ISLE" },
            "49760": { "city" : "MORAN", "state" : "MI", "county" : "MACKINAC" },
            "49761": { "city" : "MULLETT LAKE", "state" : "MI", "county" : "CHEBOYGAN" },
            "49762": { "city" : "NAUBINWAY", "state" : "MI", "county" : "MACKINAC" },
            "49764": { "city" : "ODEN", "state" : "MI", "county" : "EMMET" },"49765": { "city" : "ONAWAY", "state" : "MI", "county" : "PRESQUE ISLE" },
            "49766": { "city" : "OSSINEKE", "state" : "MI", "county" : "ALPENA" },
            "49768": { "city" : "PARADISE", "state" : "MI", "county" : "CHIPPEWA" },
            "49769": { "city" : "PELLSTON", "state" : "MI", "county" : "EMMET" },
            "49770": { "city" : "PETOSKEY", "state" : "MI", "county" : "EMMET" },
            "49774": { "city" : "PICKFORD", "state" : "MI", "county" : "CHIPPEWA" },
            "49775": { "city" : "POINTE AUX PINS", "state" : "MI", "county" : "MACKINAC" },
            "49776": { "city" : "POSEN", "state" : "MI", "county" : "PRESQUE ISLE" },
            "49777": { "city" : "PRESQUE ISLE", "state" : "MI", "county" : "PRESQUE ISLE" },
            "49779": { "city" : "ROGERS CITY", "state" : "MI", "county" : "PRESQUE ISLE" },
            "49780": { "city" : "RUDYARD", "state" : "MI", "county" : "CHIPPEWA" },
            "49781": { "city" : "SAINT IGNACE", "state" : "MI", "county" : "MACKINAC" },
            "49782": { "city" : "BEAVER ISLAND", "state" : "MI", "county" : "CHARLEVOIX" },
            "49783": { "city" : "SAULT SAINTE MARIE", "state" : "MI", "county" : "CHIPPEWA" },
            "49784": { "city" : "KINCHELOE", "state" : "MI", "county" : "CHIPPEWA" },
            "49786": { "city" : "KINCHELOE", "state" : "MI", "county" : "CHIPPEWA" },
            "49788": { "city" : "KINCHELOE", "state" : "MI", "county" : "CHIPPEWA" },
            "49791": { "city" : "TOPINABEE", "state" : "MI", "county" : "CHEBOYGAN" },
            "49792": { "city" : "TOWER", "state" : "MI", "county" : "CHEBOYGAN" },
            "49793": { "city" : "TROUT LAKE", "state" : "MI", "county" : "CHIPPEWA" },
            "49795": { "city" : "VANDERBILT", "state" : "MI", "county" : "OTSEGO" },
            "49796": { "city" : "WALLOON LAKE", "state" : "MI", "county" : "CHARLEVOIX" },
            "49797": { "city" : "WATERS", "state" : "MI", "county" : "OTSEGO" },"49799": { "city" : "WOLVERINE", "state" : "MI", "county" : "CHEBOYGAN" },
            "49801": { "city" : "IRON MOUNTAIN", "state" : "MI", "county" : "DICKINSON" },
            "49802": { "city" : "KINGSFORD", "state" : "MI", "county" : "DICKINSON" },
            "49805": { "city" : "ALLOUEZ", "state" : "MI", "county" : "KEWEENAW" },
            "49806": { "city" : "AU TRAIN", "state" : "MI", "county" : "ALGER" },
            "49807": { "city" : "BARK RIVER", "state" : "MI", "county" : "DELTA" },
            "49808": { "city" : "BIG BAY", "state" : "MI", "county" : "MARQUETTE" },
            "49812": { "city" : "CARNEY", "state" : "MI", "county" : "MENOMINEE" },
            "49814": { "city" : "CHAMPION", "state" : "MI", "county" : "MARQUETTE" },
            "49815": { "city" : "CHANNING", "state" : "MI", "county" : "DICKINSON" },
            "49816": { "city" : "CHATHAM", "state" : "MI", "county" : "ALGER" },"49817": { "city" : "COOKS", "state" : "MI", "county" : "SCHOOLCRAFT" },
            "49818": { "city" : "CORNELL", "state" : "MI", "county" : "DELTA" },"49819": { "city" : "ARNOLD", "state" : "MI", "county" : "MARQUETTE" },
            "49820": { "city" : "CURTIS", "state" : "MI", "county" : "MACKINAC" },
            "49821": { "city" : "DAGGETT", "state" : "MI", "county" : "MENOMINEE" },
            "49822": { "city" : "DEERTON", "state" : "MI", "county" : "ALGER" },"49825": { "city" : "EBEN JUNCTION", "state" : "MI", "county" : "ALGER" },
            "49826": { "city" : "RUMELY", "state" : "MI", "county" : "ALGER" },"49827": { "city" : "ENGADINE", "state" : "MI", "county" : "MACKINAC" },
            "49829": { "city" : "ESCANABA", "state" : "MI", "county" : "DELTA" },
            "49831": { "city" : "FELCH", "state" : "MI", "county" : "DICKINSON" },
            "49833": { "city" : "LITTLE LAKE", "state" : "MI", "county" : "MARQUETTE" },
            "49834": { "city" : "FOSTER CITY", "state" : "MI", "county" : "DICKINSON" },
            "49835": { "city" : "GARDEN", "state" : "MI", "county" : "DELTA" },"49836": { "city" : "GERMFASK", "state" : "MI", "county" : "SCHOOLCRAFT" },
            "49837": { "city" : "GLADSTONE", "state" : "MI", "county" : "DELTA" },
            "49838": { "city" : "GOULD CITY", "state" : "MI", "county" : "MACKINAC" },
            "49839": { "city" : "GRAND MARAIS", "state" : "MI", "county" : "ALGER" },
            "49840": { "city" : "GULLIVER", "state" : "MI", "county" : "SCHOOLCRAFT" },
            "49841": { "city" : "GWINN", "state" : "MI", "county" : "MARQUETTE" },
            "49845": { "city" : "HARRIS", "state" : "MI", "county" : "MENOMINEE" },
            "49847": { "city" : "HERMANSVILLE", "state" : "MI", "county" : "MENOMINEE" },
            "49848": { "city" : "INGALLS", "state" : "MI", "county" : "MENOMINEE" },
            "49849": { "city" : "ISHPEMING", "state" : "MI", "county" : "MARQUETTE" },
            "49852": { "city" : "LORETTO", "state" : "MI", "county" : "DICKINSON" },
            "49853": { "city" : "MC MILLAN", "state" : "MI", "county" : "LUCE" },
            "49854": { "city" : "MANISTIQUE", "state" : "MI", "county" : "SCHOOLCRAFT" },
            "49855": { "city" : "MARQUETTE", "state" : "MI", "county" : "MARQUETTE" },
            "49858": { "city" : "MENOMINEE", "state" : "MI", "county" : "MENOMINEE" },
            "49861": { "city" : "MICHIGAMME", "state" : "MI", "county" : "MARQUETTE" },
            "49862": { "city" : "MUNISING", "state" : "MI", "county" : "ALGER" },
            "49863": { "city" : "NADEAU", "state" : "MI", "county" : "MENOMINEE" },
            "49864": { "city" : "NAHMA", "state" : "MI", "county" : "DELTA" },"49866": { "city" : "NEGAUNEE", "state" : "MI", "county" : "MARQUETTE" },
            "49868": { "city" : "NEWBERRY", "state" : "MI", "county" : "LUCE" },"49870": { "city" : "NORWAY", "state" : "MI", "county" : "DICKINSON" },
            "49871": { "city" : "PALMER", "state" : "MI", "county" : "MARQUETTE" },
            "49872": { "city" : "PERKINS", "state" : "MI", "county" : "DELTA" },"49873": { "city" : "PERRONVILLE", "state" : "MI", "county" : "MENOMINEE" },
            "49874": { "city" : "POWERS", "state" : "MI", "county" : "MENOMINEE" },
            "49876": { "city" : "QUINNESEC", "state" : "MI", "county" : "DICKINSON" },
            "49877": { "city" : "RALPH", "state" : "MI", "county" : "DICKINSON" },
            "49878": { "city" : "RAPID RIVER", "state" : "MI", "county" : "DELTA" },
            "49879": { "city" : "REPUBLIC", "state" : "MI", "county" : "MARQUETTE" },
            "49880": { "city" : "ROCK", "state" : "MI", "county" : "DELTA" },"49881": { "city" : "SAGOLA", "state" : "MI", "county" : "DICKINSON" },
            "49883": { "city" : "SENEY", "state" : "MI", "county" : "SCHOOLCRAFT" },
            "49884": { "city" : "SHINGLETON", "state" : "MI", "county" : "ALGER" },
            "49885": { "city" : "SKANDIA", "state" : "MI", "county" : "MARQUETTE" },
            "49886": { "city" : "SPALDING", "state" : "MI", "county" : "MENOMINEE" },
            "49887": { "city" : "STEPHENSON", "state" : "MI", "county" : "MENOMINEE" },
            "49891": { "city" : "TRENARY", "state" : "MI", "county" : "ALGER" },"49892": { "city" : "VULCAN", "state" : "MI", "county" : "DICKINSON" },
            "49893": { "city" : "WALLACE", "state" : "MI", "county" : "MENOMINEE" },
            "49894": { "city" : "WELLS", "state" : "MI", "county" : "DELTA" },"49895": { "city" : "WETMORE", "state" : "MI", "county" : "ALGER" },
            "49896": { "city" : "WILSON", "state" : "MI", "county" : "MENOMINEE" },
            "49901": { "city" : "AHMEEK", "state" : "MI", "county" : "KEWEENAW" },
            "49902": { "city" : "ALPHA", "state" : "MI", "county" : "IRON" },"49903": { "city" : "AMASA", "state" : "MI", "county" : "IRON" },
            "49905": { "city" : "ATLANTIC MINE", "state" : "MI", "county" : "HOUGHTON" },
            "49908": { "city" : "BARAGA", "state" : "MI", "county" : "BARAGA" },"49910": { "city" : "BERGLAND", "state" : "MI", "county" : "ONTONAGON" },
            "49911": { "city" : "BESSEMER", "state" : "MI", "county" : "GOGEBIC" },
            "49912": { "city" : "BRUCE CROSSING", "state" : "MI", "county" : "ONTONAGON" },
            "49913": { "city" : "CALUMET", "state" : "MI", "county" : "HOUGHTON" },
            "49915": { "city" : "CASPIAN", "state" : "MI", "county" : "IRON" },"49916": { "city" : "CHASSELL", "state" : "MI", "county" : "HOUGHTON" },
            "49917": { "city" : "COPPER CITY", "state" : "MI", "county" : "HOUGHTON" },
            "49918": { "city" : "COPPER HARBOR", "state" : "MI", "county" : "KEWEENAW" },
            "49919": { "city" : "COVINGTON", "state" : "MI", "county" : "BARAGA" },
            "49920": { "city" : "CRYSTAL FALLS", "state" : "MI", "county" : "IRON" },
            "49921": { "city" : "DODGEVILLE", "state" : "MI", "county" : "HOUGHTON" },
            "49922": { "city" : "DOLLAR BAY", "state" : "MI", "county" : "HOUGHTON" },
            "49925": { "city" : "EWEN", "state" : "MI", "county" : "ONTONAGON" },
            "49927": { "city" : "GAASTRA", "state" : "MI", "county" : "IRON" },"49929": { "city" : "GREENLAND", "state" : "MI", "county" : "ONTONAGON" },
            "49930": { "city" : "HANCOCK", "state" : "MI", "county" : "HOUGHTON" },
            "49931": { "city" : "HOUGHTON", "state" : "MI", "county" : "HOUGHTON" },
            "49934": { "city" : "HUBBELL", "state" : "MI", "county" : "HOUGHTON" },
            "49935": { "city" : "IRON RIVER", "state" : "MI", "county" : "IRON" },
            "49938": { "city" : "IRONWOOD", "state" : "MI", "county" : "GOGEBIC" },
            "49945": { "city" : "LAKE LINDEN", "state" : "MI", "county" : "HOUGHTON" },
            "49946": { "city" : "LANSE", "state" : "MI", "county" : "BARAGA" },"49947": { "city" : "MARENISCO", "state" : "MI", "county" : "GOGEBIC" },
            "49948": { "city" : "MASS CITY", "state" : "MI", "county" : "ONTONAGON" },
            "49950": { "city" : "MOHAWK", "state" : "MI", "county" : "KEWEENAW" },
            "49952": { "city" : "NISULA", "state" : "MI", "county" : "HOUGHTON" },
            "49953": { "city" : "ONTONAGON", "state" : "MI", "county" : "ONTONAGON" },
            "49955": { "city" : "PAINESDALE", "state" : "MI", "county" : "HOUGHTON" },
            "49958": { "city" : "PELKIE", "state" : "MI", "county" : "HOUGHTON" },
            "49959": { "city" : "RAMSAY", "state" : "MI", "county" : "GOGEBIC" },
            "49960": { "city" : "ROCKLAND", "state" : "MI", "county" : "ONTONAGON" },
            "49962": { "city" : "SKANEE", "state" : "MI", "county" : "BARAGA" },"49963": { "city" : "SOUTH RANGE", "state" : "MI", "county" : "HOUGHTON" },
            "49964": { "city" : "STAMBAUGH", "state" : "MI", "county" : "IRON" },
            "49965": { "city" : "TOIVOLA", "state" : "MI", "county" : "HOUGHTON" },
            "49967": { "city" : "TROUT CREEK", "state" : "MI", "county" : "ONTONAGON" },
            "49968": { "city" : "WAKEFIELD", "state" : "MI", "county" : "GOGEBIC" },
            "49969": { "city" : "WATERSMEET", "state" : "MI", "county" : "GOGEBIC" },
            "49970": { "city" : "WATTON", "state" : "MI", "county" : "BARAGA" },"49971": { "city" : "WHITE PINE", "state" : "MI", "county" : "ONTONAGON" },
            "50001": { "city" : "ACKWORTH", "state" : "IA", "county" : "WARREN" },
            "50002": { "city" : "ADAIR", "state" : "IA", "county" : "ADAIR" },"50003": { "city" : "ADEL", "state" : "IA", "county" : "DALLAS" },
            "50005": { "city" : "ALBION", "state" : "IA", "county" : "MARSHALL" },
            "50006": { "city" : "ALDEN", "state" : "IA", "county" : "HARDIN" },"50007": { "city" : "ALLEMAN", "state" : "IA", "county" : "POLK" },
            "50008": { "city" : "ALLERTON", "state" : "IA", "county" : "WAYNE" },
            "50009": { "city" : "ALTOONA", "state" : "IA", "county" : "POLK" },"50010": { "city" : "AMES", "state" : "IA", "county" : "STORY" },
            "50011": { "city" : "AMES", "state" : "IA", "county" : "STORY" },"50012": { "city" : "AMES", "state" : "IA", "county" : "STORY" },
            "50014": { "city" : "AMES", "state" : "IA", "county" : "STORY" },"50020": { "city" : "ANITA", "state" : "IA", "county" : "CASS" },
            "50021": { "city" : "ANKENY", "state" : "IA", "county" : "POLK" },"50022": { "city" : "ATLANTIC", "state" : "IA", "county" : "CASS" },
            "50023": { "city" : "ANKENY", "state" : "IA", "county" : "POLK" },"50025": { "city" : "AUDUBON", "state" : "IA", "county" : "AUDUBON" },
            "50026": { "city" : "BAGLEY", "state" : "IA", "county" : "GUTHRIE" },
            "50027": { "city" : "BARNES CITY", "state" : "IA", "county" : "MAHASKA" },
            "50028": { "city" : "BAXTER", "state" : "IA", "county" : "JASPER" },"50029": { "city" : "BAYARD", "state" : "IA", "county" : "GUTHRIE" },
            "50031": { "city" : "BEAVER", "state" : "IA", "county" : "BOONE" },"50032": { "city" : "BERWICK", "state" : "IA", "county" : "POLK" },
            "50033": { "city" : "BEVINGTON", "state" : "IA", "county" : "MADISON" },
            "50034": { "city" : "BLAIRSBURG", "state" : "IA", "county" : "HAMILTON" },
            "50035": { "city" : "BONDURANT", "state" : "IA", "county" : "POLK" },
            "50036": { "city" : "BOONE", "state" : "IA", "county" : "BOONE" },"50038": { "city" : "BOONEVILLE", "state" : "IA", "county" : "DALLAS" },
            "50039": { "city" : "BOUTON", "state" : "IA", "county" : "DALLAS" },"50040": { "city" : "BOXHOLM", "state" : "IA", "county" : "BOONE" },
            "50041": { "city" : "BRADFORD", "state" : "IA", "county" : "FRANKLIN" },
            "50042": { "city" : "BRAYTON", "state" : "IA", "county" : "AUDUBON" },
            "50043": { "city" : "BUCKEYE", "state" : "IA", "county" : "HARDIN" },
            "50044": { "city" : "BUSSEY", "state" : "IA", "county" : "MARION" },"50046": { "city" : "CAMBRIDGE", "state" : "IA", "county" : "STORY" },
            "50047": { "city" : "CARLISLE", "state" : "IA", "county" : "WARREN" },
            "50048": { "city" : "CASEY", "state" : "IA", "county" : "GUTHRIE" },"50049": { "city" : "CHARITON", "state" : "IA", "county" : "LUCAS" },
            "50050": { "city" : "CHURDAN", "state" : "IA", "county" : "GREENE" },
            "50051": { "city" : "CLEMONS", "state" : "IA", "county" : "MARSHALL" },
            "50052": { "city" : "CLIO", "state" : "IA", "county" : "WAYNE" },"50054": { "city" : "COLFAX", "state" : "IA", "county" : "JASPER" },
            "50055": { "city" : "COLLINS", "state" : "IA", "county" : "STORY" },"50056": { "city" : "COLO", "state" : "IA", "county" : "STORY" },
            "50057": { "city" : "COLUMBIA", "state" : "IA", "county" : "MARION" },
            "50058": { "city" : "COON RAPIDS", "state" : "IA", "county" : "CARROLL" },
            "50059": { "city" : "COOPER", "state" : "IA", "county" : "GREENE" },"50060": { "city" : "CORYDON", "state" : "IA", "county" : "WAYNE" },
            "50061": { "city" : "CUMMING", "state" : "IA", "county" : "WARREN" },
            "50062": { "city" : "DALLAS", "state" : "IA", "county" : "MARION" },"50063": { "city" : "DALLAS CENTER", "state" : "IA", "county" : "DALLAS" },
            "50064": { "city" : "DANA", "state" : "IA", "county" : "GREENE" },"50065": { "city" : "DAVIS CITY", "state" : "IA", "county" : "DECATUR" },
            "50066": { "city" : "DAWSON", "state" : "IA", "county" : "DALLAS" },"50067": { "city" : "DECATUR", "state" : "IA", "county" : "DECATUR" },
            "50068": { "city" : "DERBY", "state" : "IA", "county" : "LUCAS" },"50069": { "city" : "DE SOTO", "state" : "IA", "county" : "DALLAS" },
            "50070": { "city" : "DEXTER", "state" : "IA", "county" : "DALLAS" },"50071": { "city" : "DOWS", "state" : "IA", "county" : "WRIGHT" },
            "50072": { "city" : "EARLHAM", "state" : "IA", "county" : "MADISON" },
            "50073": { "city" : "ELKHART", "state" : "IA", "county" : "POLK" },"50074": { "city" : "ELLSTON", "state" : "IA", "county" : "RINGGOLD" },
            "50075": { "city" : "ELLSWORTH", "state" : "IA", "county" : "HAMILTON" },
            "50076": { "city" : "EXIRA", "state" : "IA", "county" : "AUDUBON" },"50078": { "city" : "FERGUSON", "state" : "IA", "county" : "MARSHALL" },
            "50101": { "city" : "GALT", "state" : "IA", "county" : "WRIGHT" },"50102": { "city" : "GARDEN CITY", "state" : "IA", "county" : "HARDIN" },
            "50104": { "city" : "GIBSON", "state" : "IA", "county" : "KEOKUK" },"50105": { "city" : "GILBERT", "state" : "IA", "county" : "STORY" },
            "50106": { "city" : "GILMAN", "state" : "IA", "county" : "MARSHALL" },
            "50107": { "city" : "GRAND JUNCTION", "state" : "IA", "county" : "GREENE" },
            "50108": { "city" : "GRAND RIVER", "state" : "IA", "county" : "DECATUR" },
            "50109": { "city" : "GRANGER", "state" : "IA", "county" : "DALLAS" },
            "50110": { "city" : "GRAY", "state" : "IA", "county" : "AUDUBON" },"50111": { "city" : "GRIMES", "state" : "IA", "county" : "POLK" },
            "50112": { "city" : "GRINNELL", "state" : "IA", "county" : "POWESHIEK" },
            "50115": { "city" : "GUTHRIE CENTER", "state" : "IA", "county" : "GUTHRIE" },
            "50116": { "city" : "HAMILTON", "state" : "IA", "county" : "MARION" },
            "50117": { "city" : "HAMLIN", "state" : "IA", "county" : "AUDUBON" },
            "50118": { "city" : "HARTFORD", "state" : "IA", "county" : "WARREN" },
            "50119": { "city" : "HARVEY", "state" : "IA", "county" : "MARION" },"50120": { "city" : "HAVERHILL", "state" : "IA", "county" : "MARSHALL" },
            "50122": { "city" : "HUBBARD", "state" : "IA", "county" : "HARDIN" },
            "50123": { "city" : "HUMESTON", "state" : "IA", "county" : "WAYNE" },
            "50124": { "city" : "HUXLEY", "state" : "IA", "county" : "STORY" },"50125": { "city" : "INDIANOLA", "state" : "IA", "county" : "WARREN" },
            "50126": { "city" : "IOWA FALLS", "state" : "IA", "county" : "HARDIN" },
            "50128": { "city" : "JAMAICA", "state" : "IA", "county" : "GUTHRIE" },
            "50129": { "city" : "JEFFERSON", "state" : "IA", "county" : "GREENE" },
            "50130": { "city" : "JEWELL", "state" : "IA", "county" : "HAMILTON" },
            "50131": { "city" : "JOHNSTON", "state" : "IA", "county" : "POLK" },"50132": { "city" : "KAMRAR", "state" : "IA", "county" : "HAMILTON" },
            "50133": { "city" : "KELLERTON", "state" : "IA", "county" : "RINGGOLD" },
            "50134": { "city" : "KELLEY", "state" : "IA", "county" : "STORY" },"50135": { "city" : "KELLOGG", "state" : "IA", "county" : "JASPER" },
            "50136": { "city" : "KESWICK", "state" : "IA", "county" : "KEOKUK" },
            "50137": { "city" : "KILLDUFF", "state" : "IA", "county" : "JASPER" },
            "50138": { "city" : "KNOXVILLE", "state" : "IA", "county" : "MARION" },
            "50139": { "city" : "LACONA", "state" : "IA", "county" : "WARREN" },"50140": { "city" : "LAMONI", "state" : "IA", "county" : "DECATUR" },
            "50141": { "city" : "LAUREL", "state" : "IA", "county" : "MARSHALL" },
            "50142": { "city" : "LE GRAND", "state" : "IA", "county" : "MARSHALL" },
            "50143": { "city" : "LEIGHTON", "state" : "IA", "county" : "MAHASKA" },
            "50144": { "city" : "LEON", "state" : "IA", "county" : "DECATUR" },"50146": { "city" : "LINDEN", "state" : "IA", "county" : "DALLAS" },
            "50147": { "city" : "LINEVILLE", "state" : "IA", "county" : "WAYNE" },
            "50148": { "city" : "LISCOMB", "state" : "IA", "county" : "MARSHALL" },
            "50149": { "city" : "LORIMOR", "state" : "IA", "county" : "UNION" },"50150": { "city" : "LOVILIA", "state" : "IA", "county" : "MONROE" },
            "50151": { "city" : "LUCAS", "state" : "IA", "county" : "LUCAS" },"50152": { "city" : "LUTHER", "state" : "IA", "county" : "BOONE" },
            "50153": { "city" : "LYNNVILLE", "state" : "IA", "county" : "JASPER" },
            "50154": { "city" : "MC CALLSBURG", "state" : "IA", "county" : "STORY" },
            "50155": { "city" : "MACKSBURG", "state" : "IA", "county" : "MADISON" },
            "50156": { "city" : "MADRID", "state" : "IA", "county" : "BOONE" },"50157": { "city" : "MALCOM", "state" : "IA", "county" : "POWESHIEK" },
            "50158": { "city" : "MARSHALLTOWN", "state" : "IA", "county" : "MARSHALL" },
            "50160": { "city" : "MARTENSDALE", "state" : "IA", "county" : "WARREN" },
            "50161": { "city" : "MAXWELL", "state" : "IA", "county" : "STORY" },"50162": { "city" : "MELBOURNE", "state" : "IA", "county" : "MARSHALL" },
            "50163": { "city" : "MELCHER", "state" : "IA", "county" : "MARION" },
            "50164": { "city" : "MENLO", "state" : "IA", "county" : "GUTHRIE" },"50165": { "city" : "MILLERTON", "state" : "IA", "county" : "WAYNE" },
            "50166": { "city" : "MILO", "state" : "IA", "county" : "WARREN" },"50167": { "city" : "MINBURN", "state" : "IA", "county" : "DALLAS" },
            "50168": { "city" : "MINGO", "state" : "IA", "county" : "JASPER" },"50169": { "city" : "MITCHELLVILLE", "state" : "IA", "county" : "POLK" },
            "50170": { "city" : "MONROE", "state" : "IA", "county" : "JASPER" },"50171": { "city" : "MONTEZUMA", "state" : "IA", "county" : "POWESHIEK" },
            "50173": { "city" : "MONTOUR", "state" : "IA", "county" : "TAMA" },"50174": { "city" : "MURRAY", "state" : "IA", "county" : "CLARKE" },
            "50201": { "city" : "NEVADA", "state" : "IA", "county" : "STORY" },"50206": { "city" : "NEW PROVIDENCE", "state" : "IA", "county" : "HARDIN" },
            "50207": { "city" : "NEW SHARON", "state" : "IA", "county" : "MAHASKA" },
            "50208": { "city" : "NEWTON", "state" : "IA", "county" : "JASPER" },"50210": { "city" : "NEW VIRGINIA", "state" : "IA", "county" : "WARREN" },
            "50211": { "city" : "NORWALK", "state" : "IA", "county" : "WARREN" },
            "50212": { "city" : "OGDEN", "state" : "IA", "county" : "BOONE" },"50213": { "city" : "OSCEOLA", "state" : "IA", "county" : "CLARKE" },
            "50214": { "city" : "OTLEY", "state" : "IA", "county" : "MARION" },"50216": { "city" : "PANORA", "state" : "IA", "county" : "GUTHRIE" },
            "50217": { "city" : "PATON", "state" : "IA", "county" : "GREENE" },"50218": { "city" : "PATTERSON", "state" : "IA", "county" : "MADISON" },
            "50219": { "city" : "PELLA", "state" : "IA", "county" : "MARION" },"50220": { "city" : "PERRY", "state" : "IA", "county" : "DALLAS" },
            "50222": { "city" : "PERU", "state" : "IA", "county" : "MADISON" },"50223": { "city" : "PILOT MOUND", "state" : "IA", "county" : "BOONE" },
            "50225": { "city" : "PLEASANTVILLE", "state" : "IA", "county" : "MARION" },
            "50226": { "city" : "POLK CITY", "state" : "IA", "county" : "POLK" },
            "50228": { "city" : "PRAIRIE CITY", "state" : "IA", "county" : "JASPER" },
            "50229": { "city" : "PROLE", "state" : "IA", "county" : "WARREN" },"50230": { "city" : "RADCLIFFE", "state" : "IA", "county" : "HARDIN" },
            "50231": { "city" : "RANDALL", "state" : "IA", "county" : "HAMILTON" },
            "50232": { "city" : "REASNOR", "state" : "IA", "county" : "JASPER" },
            "50233": { "city" : "REDFIELD", "state" : "IA", "county" : "DALLAS" },
            "50234": { "city" : "RHODES", "state" : "IA", "county" : "MARSHALL" },
            "50235": { "city" : "RIPPEY", "state" : "IA", "county" : "GREENE" },"50236": { "city" : "ROLAND", "state" : "IA", "county" : "STORY" },
            "50237": { "city" : "RUNNELLS", "state" : "IA", "county" : "POLK" },"50238": { "city" : "RUSSELL", "state" : "IA", "county" : "LUCAS" },
            "50239": { "city" : "SAINT ANTHONY", "state" : "IA", "county" : "MARSHALL" },
            "50240": { "city" : "SAINT CHARLES", "state" : "IA", "county" : "MADISON" },
            "50241": { "city" : "SAINT MARYS", "state" : "IA", "county" : "WARREN" },
            "50242": { "city" : "SEARSBORO", "state" : "IA", "county" : "POWESHIEK" },
            "50243": { "city" : "SHELDAHL", "state" : "IA", "county" : "POLK" },"50244": { "city" : "SLATER", "state" : "IA", "county" : "STORY" },
            "50246": { "city" : "STANHOPE", "state" : "IA", "county" : "HAMILTON" },
            "50247": { "city" : "STATE CENTER", "state" : "IA", "county" : "MARSHALL" },
            "50248": { "city" : "STORY CITY", "state" : "IA", "county" : "STORY" },
            "50249": { "city" : "STRATFORD", "state" : "IA", "county" : "HAMILTON" },
            "50250": { "city" : "STUART", "state" : "IA", "county" : "GUTHRIE" },
            "50251": { "city" : "SULLY", "state" : "IA", "county" : "JASPER" },"50252": { "city" : "SWAN", "state" : "IA", "county" : "MARION" },
            "50254": { "city" : "THAYER", "state" : "IA", "county" : "UNION" },"50256": { "city" : "TRACY", "state" : "IA", "county" : "MARION" },
            "50257": { "city" : "TRURO", "state" : "IA", "county" : "MADISON" },"50258": { "city" : "UNION", "state" : "IA", "county" : "HARDIN" },
            "50259": { "city" : "GIFFORD", "state" : "IA", "county" : "HARDIN" },
            "50261": { "city" : "VAN METER", "state" : "IA", "county" : "DALLAS" },
            "50262": { "city" : "VAN WERT", "state" : "IA", "county" : "DECATUR" },
            "50263": { "city" : "WAUKEE", "state" : "IA", "county" : "DALLAS" },"50264": { "city" : "WELDON", "state" : "IA", "county" : "DECATUR" },
            "50265": { "city" : "WEST DES MOINES", "state" : "IA", "county" : "POLK" },
            "50266": { "city" : "WEST DES MOINES", "state" : "IA", "county" : "POLK" },
            "50268": { "city" : "WHAT CHEER", "state" : "IA", "county" : "KEOKUK" },
            "50271": { "city" : "WILLIAMS", "state" : "IA", "county" : "HAMILTON" },
            "50272": { "city" : "WILLIAMSON", "state" : "IA", "county" : "LUCAS" },
            "50273": { "city" : "WINTERSET", "state" : "IA", "county" : "MADISON" },
            "50274": { "city" : "WIOTA", "state" : "IA", "county" : "CASS" },"50275": { "city" : "WOODBURN", "state" : "IA", "county" : "CLARKE" },
            "50276": { "city" : "WOODWARD", "state" : "IA", "county" : "DALLAS" },
            "50277": { "city" : "YALE", "state" : "IA", "county" : "GUTHRIE" },"50278": { "city" : "ZEARING", "state" : "IA", "county" : "STORY" },
            "50301": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50302": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50303": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50304": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50305": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50306": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50307": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50309": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50310": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50311": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50312": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50313": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50314": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50315": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50316": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50317": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50318": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50319": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50320": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50321": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50322": { "city" : "URBANDALE", "state" : "IA", "county" : "POLK" },
            "50323": { "city" : "URBANDALE", "state" : "IA", "county" : "POLK" },
            "50324": { "city" : "WINDSOR HEIGHTS", "state" : "IA", "county" : "POLK" },
            "50325": { "city" : "CLIVE", "state" : "IA", "county" : "POLK" },"50327": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50328": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50332": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50333": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50334": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50391": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50392": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50393": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50394": { "city" : "DES MOINES", "state" : "IA", "county" : "POLK" },
            "50398": { "city" : "URBANDALE", "state" : "IA", "county" : "POLK" },
            "50401": { "city" : "MASON CITY", "state" : "IA", "county" : "CERRO GORDO" },
            "50402": { "city" : "MASON CITY", "state" : "IA", "county" : "CERRO GORDO" },
            "50420": { "city" : "ALEXANDER", "state" : "IA", "county" : "FRANKLIN" },
            "50421": { "city" : "BELMOND", "state" : "IA", "county" : "WRIGHT" },
            "50423": { "city" : "BRITT", "state" : "IA", "county" : "HANCOCK" },"50424": { "city" : "BUFFALO CENTER", "state" : "IA", "county" : "WINNEBAGO" },
            "50426": { "city" : "CARPENTER", "state" : "IA", "county" : "MITCHELL" },
            "50427": { "city" : "CHAPIN", "state" : "IA", "county" : "FRANKLIN" },
            "50428": { "city" : "CLEAR LAKE", "state" : "IA", "county" : "CERRO GORDO" },
            "50430": { "city" : "CORWITH", "state" : "IA", "county" : "HANCOCK" },
            "50431": { "city" : "COULTER", "state" : "IA", "county" : "FRANKLIN" },
            "50432": { "city" : "CRYSTAL LAKE", "state" : "IA", "county" : "HANCOCK" },
            "50433": { "city" : "DOUGHERTY", "state" : "IA", "county" : "CERRO GORDO" },
            "50434": { "city" : "FERTILE", "state" : "IA", "county" : "WORTH" },"50435": { "city" : "FLOYD", "state" : "IA", "county" : "FLOYD" },
            "50436": { "city" : "FOREST CITY", "state" : "IA", "county" : "WINNEBAGO" },
            "50438": { "city" : "GARNER", "state" : "IA", "county" : "HANCOCK" },
            "50439": { "city" : "GOODELL", "state" : "IA", "county" : "HANCOCK" },
            "50440": { "city" : "GRAFTON", "state" : "IA", "county" : "WORTH" },"50441": { "city" : "HAMPTON", "state" : "IA", "county" : "FRANKLIN" },
            "50444": { "city" : "HANLONTOWN", "state" : "IA", "county" : "WORTH" },
            "50446": { "city" : "JOICE", "state" : "IA", "county" : "WORTH" },"50447": { "city" : "KANAWHA", "state" : "IA", "county" : "HANCOCK" },
            "50448": { "city" : "KENSETT", "state" : "IA", "county" : "WORTH" },"50449": { "city" : "KLEMME", "state" : "IA", "county" : "HANCOCK" },
            "50450": { "city" : "LAKE MILLS", "state" : "IA", "county" : "WINNEBAGO" },
            "50451": { "city" : "LAKOTA", "state" : "IA", "county" : "KOSSUTH" },
            "50452": { "city" : "LATIMER", "state" : "IA", "county" : "FRANKLIN" },
            "50453": { "city" : "LELAND", "state" : "IA", "county" : "WINNEBAGO" },
            "50454": { "city" : "LITTLE CEDAR", "state" : "IA", "county" : "MITCHELL" },
            "50455": { "city" : "MC INTIRE", "state" : "IA", "county" : "MITCHELL" },
            "50456": { "city" : "MANLY", "state" : "IA", "county" : "WORTH" },"50457": { "city" : "MESERVEY", "state" : "IA", "county" : "CERRO GORDO" },
            "50458": { "city" : "NORA SPRINGS", "state" : "IA", "county" : "FLOYD" },
            "50459": { "city" : "NORTHWOOD", "state" : "IA", "county" : "WORTH" },
            "50460": { "city" : "ORCHARD", "state" : "IA", "county" : "MITCHELL" },
            "50461": { "city" : "OSAGE", "state" : "IA", "county" : "MITCHELL" },
            "50464": { "city" : "PLYMOUTH", "state" : "IA", "county" : "CERRO GORDO" },
            "50465": { "city" : "RAKE", "state" : "IA", "county" : "WINNEBAGO" },
            "50466": { "city" : "RICEVILLE", "state" : "IA", "county" : "HOWARD" },
            "50467": { "city" : "ROCK FALLS", "state" : "IA", "county" : "CERRO GORDO" },
            "50468": { "city" : "ROCKFORD", "state" : "IA", "county" : "FLOYD" },
            "50469": { "city" : "ROCKWELL", "state" : "IA", "county" : "CERRO GORDO" },
            "50470": { "city" : "ROWAN", "state" : "IA", "county" : "WRIGHT" },"50471": { "city" : "RUDD", "state" : "IA", "county" : "FLOYD" },
            "50472": { "city" : "SAINT ANSGAR", "state" : "IA", "county" : "MITCHELL" },
            "50473": { "city" : "SCARVILLE", "state" : "IA", "county" : "WINNEBAGO" },
            "50475": { "city" : "SHEFFIELD", "state" : "IA", "county" : "FRANKLIN" },
            "50476": { "city" : "STACYVILLE", "state" : "IA", "county" : "MITCHELL" },
            "50477": { "city" : "SWALEDALE", "state" : "IA", "county" : "CERRO GORDO" },
            "50478": { "city" : "THOMPSON", "state" : "IA", "county" : "WINNEBAGO" },
            "50479": { "city" : "THORNTON", "state" : "IA", "county" : "CERRO GORDO" },
            "50480": { "city" : "TITONKA", "state" : "IA", "county" : "KOSSUTH" },
            "50481": { "city" : "TOETERVILLE", "state" : "IA", "county" : "MITCHELL" },
            "50482": { "city" : "VENTURA", "state" : "IA", "county" : "CERRO GORDO" },
            "50483": { "city" : "WESLEY", "state" : "IA", "county" : "KOSSUTH" },
            "50484": { "city" : "WODEN", "state" : "IA", "county" : "HANCOCK" },"50501": { "city" : "FORT DODGE", "state" : "IA", "county" : "WEBSTER" },
            "50510": { "city" : "ALBERT CITY", "state" : "IA", "county" : "BUENA VISTA" },
            "50511": { "city" : "ALGONA", "state" : "IA", "county" : "KOSSUTH" },
            "50514": { "city" : "ARMSTRONG", "state" : "IA", "county" : "EMMET" },
            "50515": { "city" : "AYRSHIRE", "state" : "IA", "county" : "PALO ALTO" },
            "50516": { "city" : "BADGER", "state" : "IA", "county" : "WEBSTER" },
            "50517": { "city" : "BANCROFT", "state" : "IA", "county" : "KOSSUTH" },
            "50519": { "city" : "BODE", "state" : "IA", "county" : "HUMBOLDT" },"50520": { "city" : "BRADGATE", "state" : "IA", "county" : "HUMBOLDT" },
            "50521": { "city" : "BURNSIDE", "state" : "IA", "county" : "WEBSTER" },
            "50522": { "city" : "BURT", "state" : "IA", "county" : "KOSSUTH" },"50523": { "city" : "CALLENDER", "state" : "IA", "county" : "WEBSTER" },
            "50524": { "city" : "CLARE", "state" : "IA", "county" : "WEBSTER" },"50525": { "city" : "CLARION", "state" : "IA", "county" : "WRIGHT" },
            "50526": { "city" : "CLARION", "state" : "IA", "county" : "WRIGHT" },
            "50527": { "city" : "CURLEW", "state" : "IA", "county" : "PALO ALTO" },
            "50528": { "city" : "CYLINDER", "state" : "IA", "county" : "PALO ALTO" },
            "50529": { "city" : "DAKOTA CITY", "state" : "IA", "county" : "HUMBOLDT" },
            "50530": { "city" : "DAYTON", "state" : "IA", "county" : "WEBSTER" },
            "50531": { "city" : "DOLLIVER", "state" : "IA", "county" : "EMMET" },
            "50532": { "city" : "DUNCOMBE", "state" : "IA", "county" : "WEBSTER" },
            "50533": { "city" : "EAGLE GROVE", "state" : "IA", "county" : "WRIGHT" },
            "50535": { "city" : "EARLY", "state" : "IA", "county" : "SAC" },"50536": { "city" : "EMMETSBURG", "state" : "IA", "county" : "PALO ALTO" },
            "50538": { "city" : "FARNHAMVILLE", "state" : "IA", "county" : "CALHOUN" },
            "50539": { "city" : "FENTON", "state" : "IA", "county" : "KOSSUTH" },
            "50540": { "city" : "FONDA", "state" : "IA", "county" : "POCAHONTAS" },
            "50541": { "city" : "GILMORE CITY", "state" : "IA", "county" : "HUMBOLDT" },
            "50542": { "city" : "GOLDFIELD", "state" : "IA", "county" : "WRIGHT" },
            "50543": { "city" : "GOWRIE", "state" : "IA", "county" : "WEBSTER" },
            "50544": { "city" : "HARCOURT", "state" : "IA", "county" : "WEBSTER" },
            "50545": { "city" : "HARDY", "state" : "IA", "county" : "HUMBOLDT" },
            "50546": { "city" : "HAVELOCK", "state" : "IA", "county" : "POCAHONTAS" },
            "50548": { "city" : "HUMBOLDT", "state" : "IA", "county" : "HUMBOLDT" },
            "50551": { "city" : "JOLLEY", "state" : "IA", "county" : "CALHOUN" },
            "50552": { "city" : "KNIERIM", "state" : "IA", "county" : "CALHOUN" },
            "50554": { "city" : "LAURENS", "state" : "IA", "county" : "POCAHONTAS" },
            "50556": { "city" : "LEDYARD", "state" : "IA", "county" : "KOSSUTH" },
            "50557": { "city" : "LEHIGH", "state" : "IA", "county" : "WEBSTER" },
            "50558": { "city" : "LIVERMORE", "state" : "IA", "county" : "HUMBOLDT" },
            "50559": { "city" : "LONE ROCK", "state" : "IA", "county" : "KOSSUTH" },
            "50560": { "city" : "LU VERNE", "state" : "IA", "county" : "KOSSUTH" },
            "50561": { "city" : "LYTTON", "state" : "IA", "county" : "CALHOUN" },
            "50562": { "city" : "MALLARD", "state" : "IA", "county" : "PALO ALTO" },
            "50563": { "city" : "MANSON", "state" : "IA", "county" : "CALHOUN" },
            "50565": { "city" : "MARATHON", "state" : "IA", "county" : "BUENA VISTA" },
            "50566": { "city" : "MOORLAND", "state" : "IA", "county" : "WEBSTER" },
            "50567": { "city" : "NEMAHA", "state" : "IA", "county" : "SAC" },"50568": { "city" : "NEWELL", "state" : "IA", "county" : "BUENA VISTA" },
            "50569": { "city" : "OTHO", "state" : "IA", "county" : "WEBSTER" },"50570": { "city" : "OTTOSEN", "state" : "IA", "county" : "HUMBOLDT" },
            "50571": { "city" : "PALMER", "state" : "IA", "county" : "POCAHONTAS" },
            "50573": { "city" : "PLOVER", "state" : "IA", "county" : "POCAHONTAS" },
            "50574": { "city" : "POCAHONTAS", "state" : "IA", "county" : "POCAHONTAS" },
            "50575": { "city" : "POMEROY", "state" : "IA", "county" : "CALHOUN" },
            "50576": { "city" : "REMBRANDT", "state" : "IA", "county" : "BUENA VISTA" },
            "50577": { "city" : "RENWICK", "state" : "IA", "county" : "HUMBOLDT" },
            "50578": { "city" : "RINGSTED", "state" : "IA", "county" : "EMMET" },
            "50579": { "city" : "ROCKWELL CITY", "state" : "IA", "county" : "CALHOUN" },
            "50581": { "city" : "ROLFE", "state" : "IA", "county" : "POCAHONTAS" },
            "50582": { "city" : "RUTLAND", "state" : "IA", "county" : "HUMBOLDT" },
            "50583": { "city" : "SAC CITY", "state" : "IA", "county" : "SAC" },"50585": { "city" : "SIOUX RAPIDS", "state" : "IA", "county" : "BUENA VISTA" },
            "50586": { "city" : "SOMERS", "state" : "IA", "county" : "CALHOUN" },
            "50588": { "city" : "STORM LAKE", "state" : "IA", "county" : "BUENA VISTA" },
            "50590": { "city" : "SWEA CITY", "state" : "IA", "county" : "KOSSUTH" },
            "50591": { "city" : "THOR", "state" : "IA", "county" : "HUMBOLDT" },"50593": { "city" : "VARINA", "state" : "IA", "county" : "POCAHONTAS" },
            "50594": { "city" : "VINCENT", "state" : "IA", "county" : "WEBSTER" },
            "50595": { "city" : "WEBSTER CITY", "state" : "IA", "county" : "HAMILTON" },
            "50597": { "city" : "WEST BEND", "state" : "IA", "county" : "PALO ALTO" },
            "50598": { "city" : "WHITTEMORE", "state" : "IA", "county" : "KOSSUTH" },
            "50599": { "city" : "WOOLSTOCK", "state" : "IA", "county" : "WRIGHT" },
            "50601": { "city" : "ACKLEY", "state" : "IA", "county" : "HARDIN" },"50602": { "city" : "ALLISON", "state" : "IA", "county" : "BUTLER" },
            "50603": { "city" : "ALTA VISTA", "state" : "IA", "county" : "CHICKASAW" },
            "50604": { "city" : "APLINGTON", "state" : "IA", "county" : "BUTLER" },
            "50605": { "city" : "AREDALE", "state" : "IA", "county" : "BUTLER" },
            "50606": { "city" : "ARLINGTON", "state" : "IA", "county" : "FAYETTE" },
            "50607": { "city" : "AURORA", "state" : "IA", "county" : "BUCHANAN" },
            "50608": { "city" : "AUSTINVILLE", "state" : "IA", "county" : "BUTLER" },
            "50609": { "city" : "BEAMAN", "state" : "IA", "county" : "GRUNDY" },"50611": { "city" : "BRISTOW", "state" : "IA", "county" : "BUTLER" },
            "50612": { "city" : "BUCKINGHAM", "state" : "IA", "county" : "TAMA" },
            "50613": { "city" : "CEDAR FALLS", "state" : "IA", "county" : "BLACK HAWK" },
            "50614": { "city" : "CEDAR FALLS", "state" : "IA", "county" : "BLACK HAWK" },
            "50616": { "city" : "CHARLES CITY", "state" : "IA", "county" : "FLOYD" },
            "50619": { "city" : "CLARKSVILLE", "state" : "IA", "county" : "BUTLER" },
            "50620": { "city" : "COLWELL", "state" : "IA", "county" : "FLOYD" },"50621": { "city" : "CONRAD", "state" : "IA", "county" : "GRUNDY" },
            "50622": { "city" : "DENVER", "state" : "IA", "county" : "BREMER" },"50623": { "city" : "DEWAR", "state" : "IA", "county" : "BLACK HAWK" },
            "50624": { "city" : "DIKE", "state" : "IA", "county" : "GRUNDY" },"50625": { "city" : "DUMONT", "state" : "IA", "county" : "BUTLER" },
            "50626": { "city" : "DUNKERTON", "state" : "IA", "county" : "BLACK HAWK" },
            "50627": { "city" : "ELDORA", "state" : "IA", "county" : "HARDIN" },"50628": { "city" : "ELMA", "state" : "IA", "county" : "HOWARD" },
            "50629": { "city" : "FAIRBANK", "state" : "IA", "county" : "BUCHANAN" },
            "50630": { "city" : "FREDERICKSBURG", "state" : "IA", "county" : "CHICKASAW" },
            "50631": { "city" : "FREDERIKA", "state" : "IA", "county" : "BREMER" },
            "50632": { "city" : "GARWIN", "state" : "IA", "county" : "TAMA" },"50633": { "city" : "GENEVA", "state" : "IA", "county" : "FRANKLIN" },
            "50634": { "city" : "GILBERTVILLE", "state" : "IA", "county" : "BLACK HAWK" },
            "50635": { "city" : "GLADBROOK", "state" : "IA", "county" : "TAMA" },
            "50636": { "city" : "GREENE", "state" : "IA", "county" : "BUTLER" },"50638": { "city" : "GRUNDY CENTER", "state" : "IA", "county" : "GRUNDY" },
            "50641": { "city" : "HAZLETON", "state" : "IA", "county" : "BUCHANAN" },
            "50642": { "city" : "HOLLAND", "state" : "IA", "county" : "GRUNDY" },
            "50643": { "city" : "HUDSON", "state" : "IA", "county" : "BLACK HAWK" },
            "50644": { "city" : "INDEPENDENCE", "state" : "IA", "county" : "BUCHANAN" },
            "50645": { "city" : "IONIA", "state" : "IA", "county" : "CHICKASAW" },
            "50647": { "city" : "JANESVILLE", "state" : "IA", "county" : "BREMER" },
            "50648": { "city" : "JESUP", "state" : "IA", "county" : "BUCHANAN" },
            "50649": { "city" : "KESLEY", "state" : "IA", "county" : "BUTLER" },"50650": { "city" : "LAMONT", "state" : "IA", "county" : "BUCHANAN" },
            "50651": { "city" : "LA PORTE CITY", "state" : "IA", "county" : "BLACK HAWK" },
            "50652": { "city" : "LINCOLN", "state" : "IA", "county" : "TAMA" },"50653": { "city" : "MARBLE ROCK", "state" : "IA", "county" : "FLOYD" },
            "50654": { "city" : "MASONVILLE", "state" : "IA", "county" : "DELAWARE" },
            "50655": { "city" : "MAYNARD", "state" : "IA", "county" : "FAYETTE" },
            "50657": { "city" : "MORRISON", "state" : "IA", "county" : "GRUNDY" },
            "50658": { "city" : "NASHUA", "state" : "IA", "county" : "CHICKASAW" },
            "50659": { "city" : "NEW HAMPTON", "state" : "IA", "county" : "CHICKASAW" },
            "50660": { "city" : "NEW HARTFORD", "state" : "IA", "county" : "BUTLER" },
            "50661": { "city" : "NORTH WASHINGTON", "state" : "IA", "county" : "CHICKASAW" },
            "50662": { "city" : "OELWEIN", "state" : "IA", "county" : "FAYETTE" },
            "50664": { "city" : "ORAN", "state" : "IA", "county" : "FAYETTE" },"50665": { "city" : "PARKERSBURG", "state" : "IA", "county" : "BUTLER" },
            "50666": { "city" : "PLAINFIELD", "state" : "IA", "county" : "BREMER" },
            "50667": { "city" : "RAYMOND", "state" : "IA", "county" : "BLACK HAWK" },
            "50668": { "city" : "READLYN", "state" : "IA", "county" : "BREMER" },
            "50669": { "city" : "REINBECK", "state" : "IA", "county" : "GRUNDY" },
            "50670": { "city" : "SHELL ROCK", "state" : "IA", "county" : "BUTLER" },
            "50671": { "city" : "STANLEY", "state" : "IA", "county" : "BUCHANAN" },
            "50672": { "city" : "STEAMBOAT ROCK", "state" : "IA", "county" : "HARDIN" },
            "50673": { "city" : "STOUT", "state" : "IA", "county" : "GRUNDY" },"50674": { "city" : "SUMNER", "state" : "IA", "county" : "BREMER" },
            "50675": { "city" : "TRAER", "state" : "IA", "county" : "TAMA" },"50676": { "city" : "TRIPOLI", "state" : "IA", "county" : "BREMER" },
            "50677": { "city" : "WAVERLY", "state" : "IA", "county" : "BREMER" },
            "50680": { "city" : "WELLSBURG", "state" : "IA", "county" : "GRUNDY" },
            "50681": { "city" : "WESTGATE", "state" : "IA", "county" : "FAYETTE" },
            "50682": { "city" : "WINTHROP", "state" : "IA", "county" : "BUCHANAN" },
            "50701": { "city" : "WATERLOO", "state" : "IA", "county" : "BLACK HAWK" },
            "50702": { "city" : "WATERLOO", "state" : "IA", "county" : "BLACK HAWK" },
            "50703": { "city" : "WATERLOO", "state" : "IA", "county" : "BLACK HAWK" },
            "50704": { "city" : "WATERLOO", "state" : "IA", "county" : "BLACK HAWK" },
            "50706": { "city" : "WATERLOO", "state" : "IA", "county" : "BLACK HAWK" },
            "50707": { "city" : "EVANSDALE", "state" : "IA", "county" : "BLACK HAWK" },
            "50801": { "city" : "CRESTON", "state" : "IA", "county" : "UNION" },"50830": { "city" : "AFTON", "state" : "IA", "county" : "UNION" },
            "50831": { "city" : "ARISPE", "state" : "IA", "county" : "UNION" },"50833": { "city" : "BEDFORD", "state" : "IA", "county" : "TAYLOR" },
            "50835": { "city" : "BENTON", "state" : "IA", "county" : "RINGGOLD" },
            "50836": { "city" : "BLOCKTON", "state" : "IA", "county" : "TAYLOR" },
            "50837": { "city" : "BRIDGEWATER", "state" : "IA", "county" : "ADAIR" },
            "50839": { "city" : "CARBON", "state" : "IA", "county" : "ADAMS" },"50840": { "city" : "CLEARFIELD", "state" : "IA", "county" : "TAYLOR" },
            "50841": { "city" : "CORNING", "state" : "IA", "county" : "ADAMS" },"50843": { "city" : "CUMBERLAND", "state" : "IA", "county" : "CASS" },
            "50845": { "city" : "DIAGONAL", "state" : "IA", "county" : "RINGGOLD" },
            "50846": { "city" : "FONTANELLE", "state" : "IA", "county" : "ADAIR" },
            "50847": { "city" : "GRANT", "state" : "IA", "county" : "MONTGOMERY" },
            "50848": { "city" : "GRAVITY", "state" : "IA", "county" : "TAYLOR" },
            "50849": { "city" : "GREENFIELD", "state" : "IA", "county" : "ADAIR" },
            "50851": { "city" : "LENOX", "state" : "IA", "county" : "TAYLOR" },"50853": { "city" : "MASSENA", "state" : "IA", "county" : "CASS" },
            "50854": { "city" : "MOUNT AYR", "state" : "IA", "county" : "RINGGOLD" },
            "50857": { "city" : "NODAWAY", "state" : "IA", "county" : "ADAMS" },"50858": { "city" : "ORIENT", "state" : "IA", "county" : "ADAIR" },
            "50859": { "city" : "PRESCOTT", "state" : "IA", "county" : "ADAMS" },
            "50860": { "city" : "REDDING", "state" : "IA", "county" : "RINGGOLD" },
            "50861": { "city" : "SHANNON CITY", "state" : "IA", "county" : "UNION" },
            "50862": { "city" : "SHARPSBURG", "state" : "IA", "county" : "TAYLOR" },
            "50863": { "city" : "TINGLEY", "state" : "IA", "county" : "RINGGOLD" },
            "50864": { "city" : "VILLISCA", "state" : "IA", "county" : "MONTGOMERY" },
            "51001": { "city" : "AKRON", "state" : "IA", "county" : "PLYMOUTH" },
            "51002": { "city" : "ALTA", "state" : "IA", "county" : "BUENA VISTA" },
            "51003": { "city" : "ALTON", "state" : "IA", "county" : "SIOUX" },"51004": { "city" : "ANTHON", "state" : "IA", "county" : "WOODBURY" },
            "51005": { "city" : "AURELIA", "state" : "IA", "county" : "CHEROKEE" },
            "51006": { "city" : "BATTLE CREEK", "state" : "IA", "county" : "IDA" },
            "51007": { "city" : "BRONSON", "state" : "IA", "county" : "WOODBURY" },
            "51008": { "city" : "BRUNSVILLE", "state" : "IA", "county" : "PLYMOUTH" },
            "51009": { "city" : "CALUMET", "state" : "IA", "county" : "OBRIEN" },
            "51010": { "city" : "CASTANA", "state" : "IA", "county" : "MONONA" },
            "51012": { "city" : "CHEROKEE", "state" : "IA", "county" : "CHEROKEE" },
            "51014": { "city" : "CLEGHORN", "state" : "IA", "county" : "CHEROKEE" },
            "51015": { "city" : "CLIMBING HILL", "state" : "IA", "county" : "WOODBURY" },
            "51016": { "city" : "CORRECTIONVILLE", "state" : "IA", "county" : "WOODBURY" },
            "51018": { "city" : "CUSHING", "state" : "IA", "county" : "WOODBURY" },
            "51019": { "city" : "DANBURY", "state" : "IA", "county" : "WOODBURY" },
            "51020": { "city" : "GALVA", "state" : "IA", "county" : "IDA" },"51022": { "city" : "GRANVILLE", "state" : "IA", "county" : "SIOUX" },
            "51023": { "city" : "HAWARDEN", "state" : "IA", "county" : "SIOUX" },
            "51024": { "city" : "HINTON", "state" : "IA", "county" : "PLYMOUTH" },
            "51025": { "city" : "HOLSTEIN", "state" : "IA", "county" : "IDA" },"51026": { "city" : "HORNICK", "state" : "IA", "county" : "WOODBURY" },
            "51027": { "city" : "IRETON", "state" : "IA", "county" : "SIOUX" },"51028": { "city" : "KINGSLEY", "state" : "IA", "county" : "PLYMOUTH" },
            "51029": { "city" : "LARRABEE", "state" : "IA", "county" : "CHEROKEE" },
            "51030": { "city" : "LAWTON", "state" : "IA", "county" : "WOODBURY" },
            "51031": { "city" : "LE MARS", "state" : "IA", "county" : "PLYMOUTH" },
            "51033": { "city" : "LINN GROVE", "state" : "IA", "county" : "BUENA VISTA" },
            "51034": { "city" : "MAPLETON", "state" : "IA", "county" : "MONONA" },
            "51035": { "city" : "MARCUS", "state" : "IA", "county" : "CHEROKEE" },
            "51036": { "city" : "MAURICE", "state" : "IA", "county" : "SIOUX" },"51037": { "city" : "MERIDEN", "state" : "IA", "county" : "CHEROKEE" },
            "51038": { "city" : "MERRILL", "state" : "IA", "county" : "PLYMOUTH" },
            "51039": { "city" : "MOVILLE", "state" : "IA", "county" : "WOODBURY" },
            "51040": { "city" : "ONAWA", "state" : "IA", "county" : "MONONA" },"51041": { "city" : "ORANGE CITY", "state" : "IA", "county" : "SIOUX" },
            "51044": { "city" : "OTO", "state" : "IA", "county" : "WOODBURY" },"51045": { "city" : "OYENS", "state" : "IA", "county" : "PLYMOUTH" },
            "51046": { "city" : "PAULLINA", "state" : "IA", "county" : "OBRIEN" },
            "51047": { "city" : "PETERSON", "state" : "IA", "county" : "CLAY" },"51048": { "city" : "PIERSON", "state" : "IA", "county" : "WOODBURY" },
            "51049": { "city" : "QUIMBY", "state" : "IA", "county" : "CHEROKEE" },
            "51050": { "city" : "REMSEN", "state" : "IA", "county" : "PLYMOUTH" },
            "51052": { "city" : "SALIX", "state" : "IA", "county" : "WOODBURY" },
            "51053": { "city" : "SCHALLER", "state" : "IA", "county" : "SAC" },"51054": { "city" : "SERGEANT BLUFF", "state" : "IA", "county" : "WOODBURY" },
            "51055": { "city" : "SLOAN", "state" : "IA", "county" : "WOODBURY" },
            "51056": { "city" : "SMITHLAND", "state" : "IA", "county" : "WOODBURY" },
            "51058": { "city" : "SUTHERLAND", "state" : "IA", "county" : "OBRIEN" },
            "51060": { "city" : "UTE", "state" : "IA", "county" : "MONONA" },"51061": { "city" : "WASHTA", "state" : "IA", "county" : "CHEROKEE" },
            "51062": { "city" : "WESTFIELD", "state" : "IA", "county" : "PLYMOUTH" },
            "51063": { "city" : "WHITING", "state" : "IA", "county" : "MONONA" },
            "51101": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51102": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51103": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51104": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51105": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51106": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51108": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51109": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51111": { "city" : "SIOUX CITY", "state" : "IA", "county" : "WOODBURY" },
            "51201": { "city" : "SHELDON", "state" : "IA", "county" : "OBRIEN" },
            "51230": { "city" : "ALVORD", "state" : "IA", "county" : "LYON" },"51231": { "city" : "ARCHER", "state" : "IA", "county" : "OBRIEN" },
            "51232": { "city" : "ASHTON", "state" : "IA", "county" : "OSCEOLA" },
            "51234": { "city" : "BOYDEN", "state" : "IA", "county" : "SIOUX" },"51235": { "city" : "DOON", "state" : "IA", "county" : "LYON" },
            "51237": { "city" : "GEORGE", "state" : "IA", "county" : "LYON" },"51238": { "city" : "HOSPERS", "state" : "IA", "county" : "SIOUX" },
            "51239": { "city" : "HULL", "state" : "IA", "county" : "SIOUX" },"51240": { "city" : "INWOOD", "state" : "IA", "county" : "LYON" },
            "51241": { "city" : "LARCHWOOD", "state" : "IA", "county" : "LYON" },
            "51242": { "city" : "LESTER", "state" : "IA", "county" : "LYON" },"51243": { "city" : "LITTLE ROCK", "state" : "IA", "county" : "LYON" },
            "51244": { "city" : "MATLOCK", "state" : "IA", "county" : "SIOUX" },"51245": { "city" : "PRIMGHAR", "state" : "IA", "county" : "OBRIEN" },
            "51246": { "city" : "ROCK RAPIDS", "state" : "IA", "county" : "LYON" },
            "51247": { "city" : "ROCK VALLEY", "state" : "IA", "county" : "SIOUX" },
            "51248": { "city" : "SANBORN", "state" : "IA", "county" : "OBRIEN" },
            "51249": { "city" : "SIBLEY", "state" : "IA", "county" : "OSCEOLA" },
            "51250": { "city" : "SIOUX CENTER", "state" : "IA", "county" : "SIOUX" },
            "51301": { "city" : "SPENCER", "state" : "IA", "county" : "CLAY" },"51331": { "city" : "ARNOLDS PARK", "state" : "IA", "county" : "DICKINSON" },
            "51333": { "city" : "DICKENS", "state" : "IA", "county" : "CLAY" },"51334": { "city" : "ESTHERVILLE", "state" : "IA", "county" : "EMMET" },
            "51338": { "city" : "EVERLY", "state" : "IA", "county" : "CLAY" },"51340": { "city" : "FOSTORIA", "state" : "IA", "county" : "CLAY" },
            "51341": { "city" : "GILLETT GROVE", "state" : "IA", "county" : "CLAY" },
            "51342": { "city" : "GRAETTINGER", "state" : "IA", "county" : "PALO ALTO" },
            "51343": { "city" : "GREENVILLE", "state" : "IA", "county" : "CLAY" },
            "51345": { "city" : "HARRIS", "state" : "IA", "county" : "OSCEOLA" },
            "51346": { "city" : "HARTLEY", "state" : "IA", "county" : "OBRIEN" },
            "51347": { "city" : "LAKE PARK", "state" : "IA", "county" : "DICKINSON" },
            "51350": { "city" : "MELVIN", "state" : "IA", "county" : "OSCEOLA" },
            "51351": { "city" : "MILFORD", "state" : "IA", "county" : "DICKINSON" },
            "51354": { "city" : "OCHEYEDAN", "state" : "IA", "county" : "OSCEOLA" },
            "51355": { "city" : "OKOBOJI", "state" : "IA", "county" : "DICKINSON" },
            "51357": { "city" : "ROYAL", "state" : "IA", "county" : "CLAY" },"51358": { "city" : "RUTHVEN", "state" : "IA", "county" : "PALO ALTO" },
            "51360": { "city" : "SPIRIT LAKE", "state" : "IA", "county" : "DICKINSON" },
            "51363": { "city" : "SUPERIOR", "state" : "IA", "county" : "DICKINSON" },
            "51364": { "city" : "TERRIL", "state" : "IA", "county" : "DICKINSON" },
            "51365": { "city" : "WALLINGFORD", "state" : "IA", "county" : "EMMET" },
            "51366": { "city" : "WEBB", "state" : "IA", "county" : "CLAY" },"51401": { "city" : "CARROLL", "state" : "IA", "county" : "CARROLL" },
            "51430": { "city" : "ARCADIA", "state" : "IA", "county" : "CARROLL" },
            "51431": { "city" : "ARTHUR", "state" : "IA", "county" : "IDA" },"51432": { "city" : "ASPINWALL", "state" : "IA", "county" : "CRAWFORD" },
            "51433": { "city" : "AUBURN", "state" : "IA", "county" : "SAC" },"51436": { "city" : "BREDA", "state" : "IA", "county" : "CARROLL" },
            "51439": { "city" : "CHARTER OAK", "state" : "IA", "county" : "CRAWFORD" },
            "51440": { "city" : "DEDHAM", "state" : "IA", "county" : "CARROLL" },
            "51441": { "city" : "DELOIT", "state" : "IA", "county" : "CRAWFORD" },
            "51442": { "city" : "DENISON", "state" : "IA", "county" : "CRAWFORD" },
            "51443": { "city" : "GLIDDEN", "state" : "IA", "county" : "CARROLL" },
            "51444": { "city" : "HALBUR", "state" : "IA", "county" : "CARROLL" },
            "51445": { "city" : "IDA GROVE", "state" : "IA", "county" : "IDA" },"51446": { "city" : "IRWIN", "state" : "IA", "county" : "SHELBY" },
            "51447": { "city" : "KIRKMAN", "state" : "IA", "county" : "SHELBY" },
            "51448": { "city" : "KIRON", "state" : "IA", "county" : "CRAWFORD" },
            "51449": { "city" : "LAKE CITY", "state" : "IA", "county" : "CALHOUN" },
            "51450": { "city" : "LAKE VIEW", "state" : "IA", "county" : "SAC" },"51451": { "city" : "LANESBORO", "state" : "IA", "county" : "CARROLL" },
            "51452": { "city" : "LIDDERDALE", "state" : "IA", "county" : "CARROLL" },
            "51453": { "city" : "LOHRVILLE", "state" : "IA", "county" : "CALHOUN" },
            "51454": { "city" : "MANILLA", "state" : "IA", "county" : "CRAWFORD" },
            "51455": { "city" : "MANNING", "state" : "IA", "county" : "CARROLL" },
            "51458": { "city" : "ODEBOLT", "state" : "IA", "county" : "SAC" },"51459": { "city" : "RALSTON", "state" : "IA", "county" : "CARROLL" },
            "51461": { "city" : "SCHLESWIG", "state" : "IA", "county" : "CRAWFORD" },
            "51462": { "city" : "SCRANTON", "state" : "IA", "county" : "GREENE" },
            "51463": { "city" : "TEMPLETON", "state" : "IA", "county" : "CARROLL" },
            "51465": { "city" : "VAIL", "state" : "IA", "county" : "CRAWFORD" },"51466": { "city" : "WALL LAKE", "state" : "IA", "county" : "SAC" },
            "51467": { "city" : "WESTSIDE", "state" : "IA", "county" : "CRAWFORD" },
            "51501": { "city" : "COUNCIL BLUFFS", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51502": { "city" : "COUNCIL BLUFFS", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51503": { "city" : "COUNCIL BLUFFS", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51510": { "city" : "CARTER LAKE", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51520": { "city" : "ARION", "state" : "IA", "county" : "CRAWFORD" },
            "51521": { "city" : "AVOCA", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51523": { "city" : "BLENCOE", "state" : "IA", "county" : "MONONA" },
            "51525": { "city" : "CARSON", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51526": { "city" : "CRESCENT", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51527": { "city" : "DEFIANCE", "state" : "IA", "county" : "SHELBY" },
            "51528": { "city" : "DOW CITY", "state" : "IA", "county" : "CRAWFORD" },
            "51529": { "city" : "DUNLAP", "state" : "IA", "county" : "HARRISON" },
            "51530": { "city" : "EARLING", "state" : "IA", "county" : "SHELBY" },
            "51531": { "city" : "ELK HORN", "state" : "IA", "county" : "SHELBY" },
            "51532": { "city" : "ELLIOTT", "state" : "IA", "county" : "MONTGOMERY" },
            "51533": { "city" : "EMERSON", "state" : "IA", "county" : "MILLS" },"51534": { "city" : "GLENWOOD", "state" : "IA", "county" : "MILLS" },
            "51535": { "city" : "GRISWOLD", "state" : "IA", "county" : "CASS" },"51536": { "city" : "HANCOCK", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51537": { "city" : "HARLAN", "state" : "IA", "county" : "SHELBY" },"51540": { "city" : "HASTINGS", "state" : "IA", "county" : "MILLS" },
            "51541": { "city" : "HENDERSON", "state" : "IA", "county" : "MILLS" },
            "51542": { "city" : "HONEY CREEK", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51543": { "city" : "KIMBALLTON", "state" : "IA", "county" : "AUDUBON" },
            "51544": { "city" : "LEWIS", "state" : "IA", "county" : "CASS" },"51545": { "city" : "LITTLE SIOUX", "state" : "IA", "county" : "HARRISON" },
            "51546": { "city" : "LOGAN", "state" : "IA", "county" : "HARRISON" },
            "51548": { "city" : "MC CLELLAND", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51549": { "city" : "MACEDONIA", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51550": { "city" : "MAGNOLIA", "state" : "IA", "county" : "HARRISON" },
            "51551": { "city" : "MALVERN", "state" : "IA", "county" : "MILLS" },"51552": { "city" : "MARNE", "state" : "IA", "county" : "CASS" },
            "51553": { "city" : "MINDEN", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51554": { "city" : "MINEOLA", "state" : "IA", "county" : "MILLS" },"51555": { "city" : "MISSOURI VALLEY", "state" : "IA", "county" : "HARRISON" },
            "51556": { "city" : "MODALE", "state" : "IA", "county" : "HARRISON" },
            "51557": { "city" : "MONDAMIN", "state" : "IA", "county" : "HARRISON" },
            "51558": { "city" : "MOORHEAD", "state" : "IA", "county" : "MONONA" },
            "51559": { "city" : "NEOLA", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51560": { "city" : "OAKLAND", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51561": { "city" : "PACIFIC JUNCTION", "state" : "IA", "county" : "MILLS" },
            "51562": { "city" : "PANAMA", "state" : "IA", "county" : "SHELBY" },"51563": { "city" : "PERSIA", "state" : "IA", "county" : "HARRISON" },
            "51564": { "city" : "PISGAH", "state" : "IA", "county" : "HARRISON" },
            "51565": { "city" : "PORTSMOUTH", "state" : "IA", "county" : "SHELBY" },
            "51566": { "city" : "RED OAK", "state" : "IA", "county" : "MONTGOMERY" },
            "51570": { "city" : "SHELBY", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51571": { "city" : "SILVER CITY", "state" : "IA", "county" : "MILLS" },
            "51572": { "city" : "SOLDIER", "state" : "IA", "county" : "MONONA" },
            "51573": { "city" : "STANTON", "state" : "IA", "county" : "MONTGOMERY" },
            "51575": { "city" : "TREYNOR", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51576": { "city" : "UNDERWOOD", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51577": { "city" : "WALNUT", "state" : "IA", "county" : "POTTAWATTAMIE" },
            "51578": { "city" : "WESTPHALIA", "state" : "IA", "county" : "SHELBY" },
            "51579": { "city" : "WOODBINE", "state" : "IA", "county" : "HARRISON" },
            "51601": { "city" : "SHENANDOAH", "state" : "IA", "county" : "PAGE" },
            "51603": { "city" : "SHENANDOAH", "state" : "IA", "county" : "PAGE" },
            "51630": { "city" : "BLANCHARD", "state" : "IA", "county" : "PAGE" },
            "51631": { "city" : "BRADDYVILLE", "state" : "IA", "county" : "PAGE" },
            "51632": { "city" : "CLARINDA", "state" : "IA", "county" : "PAGE" },"51636": { "city" : "COIN", "state" : "IA", "county" : "PAGE" },
            "51637": { "city" : "COLLEGE SPRINGS", "state" : "IA", "county" : "PAGE" },
            "51638": { "city" : "ESSEX", "state" : "IA", "county" : "PAGE" },"51639": { "city" : "FARRAGUT", "state" : "IA", "county" : "FREMONT" },
            "51640": { "city" : "HAMBURG", "state" : "IA", "county" : "FREMONT" },
            "51645": { "city" : "IMOGENE", "state" : "IA", "county" : "FREMONT" },
            "51646": { "city" : "NEW MARKET", "state" : "IA", "county" : "TAYLOR" },
            "51647": { "city" : "NORTHBORO", "state" : "IA", "county" : "PAGE" },
            "51648": { "city" : "PERCIVAL", "state" : "IA", "county" : "FREMONT" },
            "51649": { "city" : "RANDOLPH", "state" : "IA", "county" : "FREMONT" },
            "51650": { "city" : "RIVERTON", "state" : "IA", "county" : "FREMONT" },
            "51651": { "city" : "SHAMBAUGH", "state" : "IA", "county" : "PAGE" },
            "51652": { "city" : "SIDNEY", "state" : "IA", "county" : "FREMONT" },
            "51653": { "city" : "TABOR", "state" : "IA", "county" : "FREMONT" },"51654": { "city" : "THURMAN", "state" : "IA", "county" : "FREMONT" },
            "52001": { "city" : "DUBUQUE", "state" : "IA", "county" : "DUBUQUE" },
            "52002": { "city" : "DUBUQUE", "state" : "IA", "county" : "DUBUQUE" },
            "52003": { "city" : "DUBUQUE", "state" : "IA", "county" : "DUBUQUE" },
            "52004": { "city" : "DUBUQUE", "state" : "IA", "county" : "DUBUQUE" },
            "52030": { "city" : "ANDREW", "state" : "IA", "county" : "JACKSON" },
            "52031": { "city" : "BELLEVUE", "state" : "IA", "county" : "JACKSON" },
            "52032": { "city" : "BERNARD", "state" : "IA", "county" : "DUBUQUE" },
            "52033": { "city" : "CASCADE", "state" : "IA", "county" : "DUBUQUE" },
            "52035": { "city" : "COLESBURG", "state" : "IA", "county" : "DELAWARE" },
            "52036": { "city" : "DELAWARE", "state" : "IA", "county" : "DELAWARE" },
            "52037": { "city" : "DELMAR", "state" : "IA", "county" : "CLINTON" },
            "52038": { "city" : "DUNDEE", "state" : "IA", "county" : "DELAWARE" },
            "52039": { "city" : "DURANGO", "state" : "IA", "county" : "DUBUQUE" },
            "52040": { "city" : "DYERSVILLE", "state" : "IA", "county" : "DUBUQUE" },
            "52041": { "city" : "EARLVILLE", "state" : "IA", "county" : "DELAWARE" },
            "52042": { "city" : "EDGEWOOD", "state" : "IA", "county" : "CLAYTON" },
            "52043": { "city" : "ELKADER", "state" : "IA", "county" : "CLAYTON" },
            "52044": { "city" : "ELKPORT", "state" : "IA", "county" : "CLAYTON" },
            "52045": { "city" : "EPWORTH", "state" : "IA", "county" : "DUBUQUE" },
            "52046": { "city" : "FARLEY", "state" : "IA", "county" : "DUBUQUE" },
            "52047": { "city" : "FARMERSBURG", "state" : "IA", "county" : "CLAYTON" },
            "52048": { "city" : "GARBER", "state" : "IA", "county" : "CLAYTON" },
            "52049": { "city" : "GARNAVILLO", "state" : "IA", "county" : "CLAYTON" },
            "52050": { "city" : "GREELEY", "state" : "IA", "county" : "DELAWARE" },
            "52052": { "city" : "GUTTENBERG", "state" : "IA", "county" : "CLAYTON" },
            "52053": { "city" : "HOLY CROSS", "state" : "IA", "county" : "DUBUQUE" },
            "52054": { "city" : "LA MOTTE", "state" : "IA", "county" : "JACKSON" },
            "52056": { "city" : "LUXEMBURG", "state" : "IA", "county" : "DUBUQUE" },
            "52057": { "city" : "MANCHESTER", "state" : "IA", "county" : "DELAWARE" },
            "52060": { "city" : "MAQUOKETA", "state" : "IA", "county" : "JACKSON" },
            "52064": { "city" : "MILES", "state" : "IA", "county" : "JACKSON" },"52065": { "city" : "NEW VIENNA", "state" : "IA", "county" : "DUBUQUE" },
            "52066": { "city" : "NORTH BUENA VISTA", "state" : "IA", "county" : "CLAYTON" },
            "52068": { "city" : "PEOSTA", "state" : "IA", "county" : "DUBUQUE" },
            "52069": { "city" : "PRESTON", "state" : "IA", "county" : "JACKSON" },
            "52070": { "city" : "SABULA", "state" : "IA", "county" : "JACKSON" },
            "52071": { "city" : "SAINT DONATUS", "state" : "IA", "county" : "JACKSON" },
            "52072": { "city" : "SAINT OLAF", "state" : "IA", "county" : "CLAYTON" },
            "52073": { "city" : "SHERRILL", "state" : "IA", "county" : "DUBUQUE" },
            "52074": { "city" : "SPRAGUEVILLE", "state" : "IA", "county" : "JACKSON" },
            "52075": { "city" : "SPRINGBROOK", "state" : "IA", "county" : "JACKSON" },
            "52076": { "city" : "STRAWBERRY POINT", "state" : "IA", "county" : "CLAYTON" },
            "52077": { "city" : "VOLGA", "state" : "IA", "county" : "CLAYTON" },"52078": { "city" : "WORTHINGTON", "state" : "IA", "county" : "DUBUQUE" },
            "52079": { "city" : "ZWINGLE", "state" : "IA", "county" : "DUBUQUE" },
            "52101": { "city" : "DECORAH", "state" : "IA", "county" : "WINNESHIEK" },
            "52132": { "city" : "CALMAR", "state" : "IA", "county" : "WINNESHIEK" },
            "52133": { "city" : "CASTALIA", "state" : "IA", "county" : "WINNESHIEK" },
            "52134": { "city" : "CHESTER", "state" : "IA", "county" : "HOWARD" },
            "52135": { "city" : "CLERMONT", "state" : "IA", "county" : "FAYETTE" },
            "52136": { "city" : "CRESCO", "state" : "IA", "county" : "HOWARD" },"52140": { "city" : "DORCHESTER", "state" : "IA", "county" : "ALLAMAKEE" },
            "52141": { "city" : "ELGIN", "state" : "IA", "county" : "FAYETTE" },"52142": { "city" : "FAYETTE", "state" : "IA", "county" : "FAYETTE" },
            "52144": { "city" : "FORT ATKINSON", "state" : "IA", "county" : "WINNESHIEK" },
            "52146": { "city" : "HARPERS FERRY", "state" : "IA", "county" : "ALLAMAKEE" },
            "52147": { "city" : "HAWKEYE", "state" : "IA", "county" : "FAYETTE" },
            "52149": { "city" : "HIGHLANDVILLE", "state" : "IA", "county" : "WINNESHIEK" },
            "52151": { "city" : "LANSING", "state" : "IA", "county" : "ALLAMAKEE" },
            "52154": { "city" : "LAWLER", "state" : "IA", "county" : "CHICKASAW" },
            "52155": { "city" : "LIME SPRINGS", "state" : "IA", "county" : "HOWARD" },
            "52156": { "city" : "LUANA", "state" : "IA", "county" : "CLAYTON" },"52157": { "city" : "MC GREGOR", "state" : "IA", "county" : "CLAYTON" },
            "52158": { "city" : "MARQUETTE", "state" : "IA", "county" : "CLAYTON" },
            "52159": { "city" : "MONONA", "state" : "IA", "county" : "CLAYTON" },
            "52160": { "city" : "NEW ALBIN", "state" : "IA", "county" : "ALLAMAKEE" },
            "52161": { "city" : "OSSIAN", "state" : "IA", "county" : "WINNESHIEK" },
            "52162": { "city" : "POSTVILLE", "state" : "IA", "county" : "ALLAMAKEE" },
            "52163": { "city" : "PROTIVIN", "state" : "IA", "county" : "HOWARD" },
            "52164": { "city" : "RANDALIA", "state" : "IA", "county" : "FAYETTE" },
            "52165": { "city" : "RIDGEWAY", "state" : "IA", "county" : "WINNESHIEK" },
            "52166": { "city" : "SAINT LUCAS", "state" : "IA", "county" : "FAYETTE" },
            "52168": { "city" : "SPILLVILLE", "state" : "IA", "county" : "WINNESHIEK" },
            "52169": { "city" : "WADENA", "state" : "IA", "county" : "FAYETTE" },
            "52170": { "city" : "WATERVILLE", "state" : "IA", "county" : "ALLAMAKEE" },
            "52171": { "city" : "WAUCOMA", "state" : "IA", "county" : "FAYETTE" },
            "52172": { "city" : "WAUKON", "state" : "IA", "county" : "ALLAMAKEE" },
            "52175": { "city" : "WEST UNION", "state" : "IA", "county" : "FAYETTE" },
            "52201": { "city" : "AINSWORTH", "state" : "IA", "county" : "WASHINGTON" },
            "52202": { "city" : "ALBURNETT", "state" : "IA", "county" : "LINN" },
            "52203": { "city" : "AMANA", "state" : "IA", "county" : "IOWA" },"52204": { "city" : "AMANA", "state" : "IA", "county" : "IOWA" },
            "52205": { "city" : "ANAMOSA", "state" : "IA", "county" : "JONES" },"52206": { "city" : "ATKINS", "state" : "IA", "county" : "BENTON" },
            "52207": { "city" : "BALDWIN", "state" : "IA", "county" : "JACKSON" },
            "52208": { "city" : "BELLE PLAINE", "state" : "IA", "county" : "BENTON" },
            "52209": { "city" : "BLAIRSTOWN", "state" : "IA", "county" : "BENTON" },
            "52210": { "city" : "BRANDON", "state" : "IA", "county" : "BUCHANAN" },
            "52211": { "city" : "BROOKLYN", "state" : "IA", "county" : "POWESHIEK" },
            "52212": { "city" : "CENTER JUNCTION", "state" : "IA", "county" : "JONES" },
            "52213": { "city" : "CENTER POINT", "state" : "IA", "county" : "LINN" },
            "52214": { "city" : "CENTRAL CITY", "state" : "IA", "county" : "LINN" },
            "52215": { "city" : "CHELSEA", "state" : "IA", "county" : "TAMA" },"52216": { "city" : "CLARENCE", "state" : "IA", "county" : "CEDAR" },
            "52217": { "city" : "CLUTIER", "state" : "IA", "county" : "TAMA" },"52218": { "city" : "COGGON", "state" : "IA", "county" : "LINN" },
            "52219": { "city" : "PRAIRIEBURG", "state" : "IA", "county" : "LINN" },
            "52220": { "city" : "CONROY", "state" : "IA", "county" : "IOWA" },"52221": { "city" : "GUERNSEY", "state" : "IA", "county" : "POWESHIEK" },
            "52222": { "city" : "DEEP RIVER", "state" : "IA", "county" : "POWESHIEK" },
            "52223": { "city" : "DELHI", "state" : "IA", "county" : "DELAWARE" },
            "52224": { "city" : "DYSART", "state" : "IA", "county" : "TAMA" },"52225": { "city" : "ELBERON", "state" : "IA", "county" : "TAMA" },
            "52227": { "city" : "ELY", "state" : "IA", "county" : "LINN" },"52228": { "city" : "FAIRFAX", "state" : "IA", "county" : "LINN" },
            "52229": { "city" : "GARRISON", "state" : "IA", "county" : "BENTON" },
            "52231": { "city" : "HARPER", "state" : "IA", "county" : "KEOKUK" },"52232": { "city" : "HARTWICK", "state" : "IA", "county" : "POWESHIEK" },
            "52233": { "city" : "HIAWATHA", "state" : "IA", "county" : "LINN" },"52235": { "city" : "HILLS", "state" : "IA", "county" : "JOHNSON" },
            "52236": { "city" : "HOMESTEAD", "state" : "IA", "county" : "IOWA" },
            "52237": { "city" : "HOPKINTON", "state" : "IA", "county" : "DELAWARE" },
            "52240": { "city" : "IOWA CITY", "state" : "IA", "county" : "JOHNSON" },
            "52241": { "city" : "CORALVILLE", "state" : "IA", "county" : "JOHNSON" },
            "52242": { "city" : "IOWA CITY", "state" : "IA", "county" : "JOHNSON" },
            "52243": { "city" : "IOWA CITY", "state" : "IA", "county" : "JOHNSON" },
            "52244": { "city" : "IOWA CITY", "state" : "IA", "county" : "JOHNSON" },
            "52245": { "city" : "IOWA CITY", "state" : "IA", "county" : "JOHNSON" },
            "52246": { "city" : "IOWA CITY", "state" : "IA", "county" : "JOHNSON" },
            "52247": { "city" : "KALONA", "state" : "IA", "county" : "WASHINGTON" },
            "52248": { "city" : "KEOTA", "state" : "IA", "county" : "KEOKUK" },"52249": { "city" : "KEYSTONE", "state" : "IA", "county" : "BENTON" },
            "52251": { "city" : "LADORA", "state" : "IA", "county" : "IOWA" },"52253": { "city" : "LISBON", "state" : "IA", "county" : "LINN" },
            "52254": { "city" : "LOST NATION", "state" : "IA", "county" : "CLINTON" },
            "52255": { "city" : "LOWDEN", "state" : "IA", "county" : "CEDAR" },"52257": { "city" : "LUZERNE", "state" : "IA", "county" : "BENTON" },
            "52301": { "city" : "MARENGO", "state" : "IA", "county" : "IOWA" },"52302": { "city" : "MARION", "state" : "IA", "county" : "LINN" },
            "52305": { "city" : "MARTELLE", "state" : "IA", "county" : "JONES" },
            "52306": { "city" : "MECHANICSVILLE", "state" : "IA", "county" : "CEDAR" },
            "52307": { "city" : "MIDDLE AMANA", "state" : "IA", "county" : "IOWA" },
            "52308": { "city" : "MILLERSBURG", "state" : "IA", "county" : "IOWA" },
            "52309": { "city" : "MONMOUTH", "state" : "IA", "county" : "JACKSON" },
            "52310": { "city" : "MONTICELLO", "state" : "IA", "county" : "JONES" },
            "52313": { "city" : "MOUNT AUBURN", "state" : "IA", "county" : "BENTON" },
            "52314": { "city" : "MOUNT VERNON", "state" : "IA", "county" : "LINN" },
            "52315": { "city" : "NEWHALL", "state" : "IA", "county" : "BENTON" },
            "52316": { "city" : "NORTH ENGLISH", "state" : "IA", "county" : "IOWA" },
            "52317": { "city" : "NORTH LIBERTY", "state" : "IA", "county" : "JOHNSON" },
            "52318": { "city" : "NORWAY", "state" : "IA", "county" : "BENTON" },"52319": { "city" : "OAKDALE", "state" : "IA", "county" : "JOHNSON" },
            "52320": { "city" : "OLIN", "state" : "IA", "county" : "JONES" },"52321": { "city" : "ONSLOW", "state" : "IA", "county" : "JONES" },
            "52322": { "city" : "OXFORD", "state" : "IA", "county" : "JOHNSON" },
            "52323": { "city" : "OXFORD JUNCTION", "state" : "IA", "county" : "JONES" },
            "52324": { "city" : "PALO", "state" : "IA", "county" : "LINN" },"52325": { "city" : "PARNELL", "state" : "IA", "county" : "IOWA" },
            "52326": { "city" : "QUASQUETON", "state" : "IA", "county" : "BUCHANAN" },
            "52327": { "city" : "RIVERSIDE", "state" : "IA", "county" : "WASHINGTON" },
            "52328": { "city" : "ROBINS", "state" : "IA", "county" : "LINN" },"52329": { "city" : "ROWLEY", "state" : "IA", "county" : "BUCHANAN" },
            "52330": { "city" : "RYAN", "state" : "IA", "county" : "DELAWARE" },"52332": { "city" : "SHELLSBURG", "state" : "IA", "county" : "BENTON" },
            "52333": { "city" : "SOLON", "state" : "IA", "county" : "JOHNSON" },"52334": { "city" : "SOUTH AMANA", "state" : "IA", "county" : "IOWA" },
            "52335": { "city" : "SOUTH ENGLISH", "state" : "IA", "county" : "KEOKUK" },
            "52336": { "city" : "SPRINGVILLE", "state" : "IA", "county" : "LINN" },
            "52337": { "city" : "STANWOOD", "state" : "IA", "county" : "CEDAR" },
            "52338": { "city" : "SWISHER", "state" : "IA", "county" : "JOHNSON" },
            "52339": { "city" : "TAMA", "state" : "IA", "county" : "TAMA" },"52340": { "city" : "TIFFIN", "state" : "IA", "county" : "JOHNSON" },
            "52341": { "city" : "TODDVILLE", "state" : "IA", "county" : "LINN" },
            "52342": { "city" : "TOLEDO", "state" : "IA", "county" : "TAMA" },"52344": { "city" : "TROY MILLS", "state" : "IA", "county" : "LINN" },
            "52345": { "city" : "URBANA", "state" : "IA", "county" : "BENTON" },"52346": { "city" : "VAN HORNE", "state" : "IA", "county" : "BENTON" },
            "52347": { "city" : "VICTOR", "state" : "IA", "county" : "IOWA" },"52349": { "city" : "VINTON", "state" : "IA", "county" : "BENTON" },
            "52351": { "city" : "WALFORD", "state" : "IA", "county" : "BENTON" },
            "52352": { "city" : "WALKER", "state" : "IA", "county" : "LINN" },"52353": { "city" : "WASHINGTON", "state" : "IA", "county" : "WASHINGTON" },
            "52354": { "city" : "WATKINS", "state" : "IA", "county" : "BENTON" },
            "52356": { "city" : "WELLMAN", "state" : "IA", "county" : "WASHINGTON" },
            "52358": { "city" : "WEST BRANCH", "state" : "IA", "county" : "CEDAR" },
            "52359": { "city" : "WEST CHESTER", "state" : "IA", "county" : "WASHINGTON" },
            "52361": { "city" : "WILLIAMSBURG", "state" : "IA", "county" : "IOWA" },
            "52362": { "city" : "WYOMING", "state" : "IA", "county" : "JONES" },"52401": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52402": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52403": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52404": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52405": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52406": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52407": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52408": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52409": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52410": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52411": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52498": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52499": { "city" : "CEDAR RAPIDS", "state" : "IA", "county" : "LINN" },
            "52501": { "city" : "OTTUMWA", "state" : "IA", "county" : "WAPELLO" },
            "52530": { "city" : "AGENCY", "state" : "IA", "county" : "WAPELLO" },
            "52531": { "city" : "ALBIA", "state" : "IA", "county" : "MONROE" },"52533": { "city" : "BATAVIA", "state" : "IA", "county" : "JEFFERSON" },
            "52534": { "city" : "BEACON", "state" : "IA", "county" : "MAHASKA" },
            "52535": { "city" : "BIRMINGHAM", "state" : "IA", "county" : "VAN BUREN" },
            "52536": { "city" : "BLAKESBURG", "state" : "IA", "county" : "WAPELLO" },
            "52537": { "city" : "BLOOMFIELD", "state" : "IA", "county" : "DAVIS" },
            "52540": { "city" : "BRIGHTON", "state" : "IA", "county" : "WASHINGTON" },
            "52542": { "city" : "CANTRIL", "state" : "IA", "county" : "VAN BUREN" },
            "52543": { "city" : "CEDAR", "state" : "IA", "county" : "MAHASKA" },"52544": { "city" : "CENTERVILLE", "state" : "IA", "county" : "APPANOOSE" },
            "52548": { "city" : "CHILLICOTHE", "state" : "IA", "county" : "WAPELLO" },
            "52549": { "city" : "CINCINNATI", "state" : "IA", "county" : "APPANOOSE" },
            "52550": { "city" : "DELTA", "state" : "IA", "county" : "KEOKUK" },"52551": { "city" : "DOUDS", "state" : "IA", "county" : "VAN BUREN" },
            "52552": { "city" : "DRAKESVILLE", "state" : "IA", "county" : "DAVIS" },
            "52553": { "city" : "EDDYVILLE", "state" : "IA", "county" : "WAPELLO" },
            "52554": { "city" : "ELDON", "state" : "IA", "county" : "WAPELLO" },"52555": { "city" : "EXLINE", "state" : "IA", "county" : "APPANOOSE" },
            "52556": { "city" : "FAIRFIELD", "state" : "IA", "county" : "JEFFERSON" },
            "52557": { "city" : "FAIRFIELD", "state" : "IA", "county" : "JEFFERSON" },
            "52560": { "city" : "FLORIS", "state" : "IA", "county" : "DAVIS" },"52561": { "city" : "FREMONT", "state" : "IA", "county" : "MAHASKA" },
            "52563": { "city" : "HEDRICK", "state" : "IA", "county" : "KEOKUK" },
            "52565": { "city" : "KEOSAUQUA", "state" : "IA", "county" : "VAN BUREN" },
            "52567": { "city" : "LIBERTYVILLE", "state" : "IA", "county" : "JEFFERSON" },
            "52568": { "city" : "MARTINSBURG", "state" : "IA", "county" : "KEOKUK" },
            "52569": { "city" : "MELROSE", "state" : "IA", "county" : "MONROE" },
            "52570": { "city" : "MILTON", "state" : "IA", "county" : "VAN BUREN" },
            "52571": { "city" : "MORAVIA", "state" : "IA", "county" : "APPANOOSE" },
            "52572": { "city" : "MOULTON", "state" : "IA", "county" : "APPANOOSE" },
            "52573": { "city" : "MOUNT STERLING", "state" : "IA", "county" : "VAN BUREN" },
            "52574": { "city" : "MYSTIC", "state" : "IA", "county" : "APPANOOSE" },
            "52576": { "city" : "OLLIE", "state" : "IA", "county" : "KEOKUK" },"52577": { "city" : "OSKALOOSA", "state" : "IA", "county" : "MAHASKA" },
            "52580": { "city" : "PACKWOOD", "state" : "IA", "county" : "JEFFERSON" },
            "52581": { "city" : "PLANO", "state" : "IA", "county" : "APPANOOSE" },
            "52583": { "city" : "PROMISE CITY", "state" : "IA", "county" : "WAYNE" },
            "52584": { "city" : "PULASKI", "state" : "IA", "county" : "DAVIS" },"52585": { "city" : "RICHLAND", "state" : "IA", "county" : "KEOKUK" },
            "52588": { "city" : "SELMA", "state" : "IA", "county" : "VAN BUREN" },
            "52590": { "city" : "SEYMOUR", "state" : "IA", "county" : "WAYNE" },"52591": { "city" : "SIGOURNEY", "state" : "IA", "county" : "KEOKUK" },
            "52594": { "city" : "UNIONVILLE", "state" : "IA", "county" : "APPANOOSE" },
            "52595": { "city" : "UNIVERSITY PARK", "state" : "IA", "county" : "MAHASKA" },
            "52601": { "city" : "BURLINGTON", "state" : "IA", "county" : "DES MOINES" },
            "52619": { "city" : "ARGYLE", "state" : "IA", "county" : "LEE" },"52620": { "city" : "BONAPARTE", "state" : "IA", "county" : "VAN BUREN" },
            "52621": { "city" : "CRAWFORDSVILLE", "state" : "IA", "county" : "WASHINGTON" },
            "52623": { "city" : "DANVILLE", "state" : "IA", "county" : "DES MOINES" },
            "52624": { "city" : "DENMARK", "state" : "IA", "county" : "LEE" },"52625": { "city" : "DONNELLSON", "state" : "IA", "county" : "LEE" },
            "52626": { "city" : "FARMINGTON", "state" : "IA", "county" : "VAN BUREN" },
            "52627": { "city" : "FORT MADISON", "state" : "IA", "county" : "LEE" },
            "52630": { "city" : "HILLSBORO", "state" : "IA", "county" : "HENRY" },
            "52631": { "city" : "HOUGHTON", "state" : "IA", "county" : "LEE" },"52632": { "city" : "KEOKUK", "state" : "IA", "county" : "LEE" },
            "52635": { "city" : "LOCKRIDGE", "state" : "IA", "county" : "JEFFERSON" },
            "52637": { "city" : "MEDIAPOLIS", "state" : "IA", "county" : "DES MOINES" },
            "52638": { "city" : "MIDDLETOWN", "state" : "IA", "county" : "DES MOINES" },
            "52639": { "city" : "MONTROSE", "state" : "IA", "county" : "LEE" },"52640": { "city" : "MORNING SUN", "state" : "IA", "county" : "LOUISA" },
            "52641": { "city" : "MOUNT PLEASANT", "state" : "IA", "county" : "HENRY" },
            "52644": { "city" : "MOUNT UNION", "state" : "IA", "county" : "HENRY" },
            "52645": { "city" : "NEW LONDON", "state" : "IA", "county" : "HENRY" },
            "52646": { "city" : "OAKVILLE", "state" : "IA", "county" : "LOUISA" },
            "52647": { "city" : "OLDS", "state" : "IA", "county" : "HENRY" },"52648": { "city" : "PILOT GROVE", "state" : "IA", "county" : "LEE" },
            "52649": { "city" : "SALEM", "state" : "IA", "county" : "HENRY" },"52650": { "city" : "SPERRY", "state" : "IA", "county" : "DES MOINES" },
            "52651": { "city" : "STOCKPORT", "state" : "IA", "county" : "VAN BUREN" },
            "52652": { "city" : "SWEDESBURG", "state" : "IA", "county" : "HENRY" },
            "52653": { "city" : "WAPELLO", "state" : "IA", "county" : "LOUISA" },
            "52654": { "city" : "WAYLAND", "state" : "IA", "county" : "HENRY" },"52655": { "city" : "WEST BURLINGTON", "state" : "IA", "county" : "DES MOINES" },
            "52656": { "city" : "WEST POINT", "state" : "IA", "county" : "LEE" },
            "52657": { "city" : "SAINT PAUL", "state" : "IA", "county" : "LEE" },
            "52658": { "city" : "WEVER", "state" : "IA", "county" : "LEE" },"52659": { "city" : "WINFIELD", "state" : "IA", "county" : "HENRY" },
            "52660": { "city" : "YARMOUTH", "state" : "IA", "county" : "DES MOINES" },
            "52701": { "city" : "ANDOVER", "state" : "IA", "county" : "CLINTON" },
            "52720": { "city" : "ATALISSA", "state" : "IA", "county" : "MUSCATINE" },
            "52721": { "city" : "BENNETT", "state" : "IA", "county" : "CEDAR" },"52722": { "city" : "BETTENDORF", "state" : "IA", "county" : "SCOTT" },
            "52726": { "city" : "BLUE GRASS", "state" : "IA", "county" : "SCOTT" },
            "52727": { "city" : "BRYANT", "state" : "IA", "county" : "CLINTON" },
            "52728": { "city" : "BUFFALO", "state" : "IA", "county" : "SCOTT" },"52729": { "city" : "CALAMUS", "state" : "IA", "county" : "CLINTON" },
            "52730": { "city" : "CAMANCHE", "state" : "IA", "county" : "CLINTON" },
            "52731": { "city" : "CHARLOTTE", "state" : "IA", "county" : "CLINTON" },
            "52732": { "city" : "CLINTON", "state" : "IA", "county" : "CLINTON" },
            "52733": { "city" : "CLINTON", "state" : "IA", "county" : "CLINTON" },
            "52737": { "city" : "COLUMBUS CITY", "state" : "IA", "county" : "LOUISA" },
            "52738": { "city" : "COLUMBUS JUNCTION", "state" : "IA", "county" : "LOUISA" },
            "52739": { "city" : "CONESVILLE", "state" : "IA", "county" : "MUSCATINE" },
            "52742": { "city" : "DE WITT", "state" : "IA", "county" : "CLINTON" },
            "52745": { "city" : "DIXON", "state" : "IA", "county" : "SCOTT" },"52746": { "city" : "DONAHUE", "state" : "IA", "county" : "SCOTT" },
            "52747": { "city" : "DURANT", "state" : "IA", "county" : "CEDAR" },"52748": { "city" : "ELDRIDGE", "state" : "IA", "county" : "SCOTT" },
            "52749": { "city" : "FRUITLAND", "state" : "IA", "county" : "MUSCATINE" },
            "52750": { "city" : "GOOSE LAKE", "state" : "IA", "county" : "CLINTON" },
            "52751": { "city" : "GRAND MOUND", "state" : "IA", "county" : "CLINTON" },
            "52752": { "city" : "GRANDVIEW", "state" : "IA", "county" : "LOUISA" },
            "52753": { "city" : "LE CLAIRE", "state" : "IA", "county" : "SCOTT" },
            "52754": { "city" : "LETTS", "state" : "IA", "county" : "LOUISA" },"52755": { "city" : "LONE TREE", "state" : "IA", "county" : "JOHNSON" },
            "52756": { "city" : "LONG GROVE", "state" : "IA", "county" : "SCOTT" },
            "52757": { "city" : "LOW MOOR", "state" : "IA", "county" : "CLINTON" },
            "52758": { "city" : "MC CAUSLAND", "state" : "IA", "county" : "SCOTT" },
            "52759": { "city" : "MONTPELIER", "state" : "IA", "county" : "MUSCATINE" },
            "52760": { "city" : "MOSCOW", "state" : "IA", "county" : "MUSCATINE" },
            "52761": { "city" : "MUSCATINE", "state" : "IA", "county" : "MUSCATINE" },
            "52765": { "city" : "NEW LIBERTY", "state" : "IA", "county" : "SCOTT" },
            "52766": { "city" : "NICHOLS", "state" : "IA", "county" : "MUSCATINE" },
            "52767": { "city" : "PLEASANT VALLEY", "state" : "IA", "county" : "SCOTT" },
            "52768": { "city" : "PRINCETON", "state" : "IA", "county" : "SCOTT" },
            "52769": { "city" : "STOCKTON", "state" : "IA", "county" : "MUSCATINE" },
            "52772": { "city" : "TIPTON", "state" : "IA", "county" : "CEDAR" },"52773": { "city" : "WALCOTT", "state" : "IA", "county" : "SCOTT" },
            "52774": { "city" : "WELTON", "state" : "IA", "county" : "MUSCATINE" },
            "52776": { "city" : "WEST LIBERTY", "state" : "IA", "county" : "MUSCATINE" },
            "52777": { "city" : "WHEATLAND", "state" : "IA", "county" : "CLINTON" },
            "52778": { "city" : "WILTON", "state" : "IA", "county" : "MUSCATINE" },
            "52801": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52802": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52803": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52804": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52805": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52806": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52807": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52808": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "52809": { "city" : "DAVENPORT", "state" : "IA", "county" : "SCOTT" },
            "53001": { "city" : "ADELL", "state" : "WI", "county" : "SHEBOYGAN" },
            "53002": { "city" : "ALLENTON", "state" : "WI", "county" : "WASHINGTON" },
            "53003": { "city" : "ASHIPPUN", "state" : "WI", "county" : "DODGE" },
            "53004": { "city" : "BELGIUM", "state" : "WI", "county" : "OZAUKEE" },
            "53005": { "city" : "BROOKFIELD", "state" : "WI", "county" : "WAUKESHA" },
            "53006": { "city" : "BROWNSVILLE", "state" : "WI", "county" : "DODGE" },
            "53007": { "city" : "BUTLER", "state" : "WI", "county" : "WAUKESHA" },
            "53008": { "city" : "BROOKFIELD", "state" : "WI", "county" : "WAUKESHA" },
            "53010": { "city" : "CAMPBELLSPORT", "state" : "WI", "county" : "FOND DU LAC" },
            "53011": { "city" : "CASCADE", "state" : "WI", "county" : "SHEBOYGAN" },
            "53012": { "city" : "CEDARBURG", "state" : "WI", "county" : "OZAUKEE" },
            "53013": { "city" : "CEDAR GROVE", "state" : "WI", "county" : "SHEBOYGAN" },
            "53014": { "city" : "CHILTON", "state" : "WI", "county" : "CALUMET" },
            "53015": { "city" : "CLEVELAND", "state" : "WI", "county" : "MANITOWOC" },
            "53016": { "city" : "CLYMAN", "state" : "WI", "county" : "DODGE" },"53017": { "city" : "COLGATE", "state" : "WI", "county" : "WASHINGTON" },
            "53018": { "city" : "DELAFIELD", "state" : "WI", "county" : "WAUKESHA" },
            "53019": { "city" : "EDEN", "state" : "WI", "county" : "FOND DU LAC" },
            "53020": { "city" : "ELKHART LAKE", "state" : "WI", "county" : "SHEBOYGAN" },
            "53021": { "city" : "FREDONIA", "state" : "WI", "county" : "OZAUKEE" },
            "53022": { "city" : "GERMANTOWN", "state" : "WI", "county" : "WASHINGTON" },
            "53023": { "city" : "GLENBEULAH", "state" : "WI", "county" : "SHEBOYGAN" },
            "53024": { "city" : "GRAFTON", "state" : "WI", "county" : "OZAUKEE" },
            "53026": { "city" : "GREENBUSH", "state" : "WI", "county" : "SHEBOYGAN" },
            "53027": { "city" : "HARTFORD", "state" : "WI", "county" : "WASHINGTON" },
            "53029": { "city" : "HARTLAND", "state" : "WI", "county" : "WAUKESHA" },
            "53031": { "city" : "HINGHAM", "state" : "WI", "county" : "SHEBOYGAN" },
            "53032": { "city" : "HORICON", "state" : "WI", "county" : "DODGE" },"53033": { "city" : "HUBERTUS", "state" : "WI", "county" : "WASHINGTON" },
            "53034": { "city" : "HUSTISFORD", "state" : "WI", "county" : "DODGE" },
            "53035": { "city" : "IRON RIDGE", "state" : "WI", "county" : "DODGE" },
            "53036": { "city" : "IXONIA", "state" : "WI", "county" : "JEFFERSON" },
            "53037": { "city" : "JACKSON", "state" : "WI", "county" : "WASHINGTON" },
            "53038": { "city" : "JOHNSON CREEK", "state" : "WI", "county" : "JEFFERSON" },
            "53039": { "city" : "JUNEAU", "state" : "WI", "county" : "DODGE" },"53040": { "city" : "KEWASKUM", "state" : "WI", "county" : "WASHINGTON" },
            "53042": { "city" : "KIEL", "state" : "WI", "county" : "MANITOWOC" },
            "53044": { "city" : "KOHLER", "state" : "WI", "county" : "SHEBOYGAN" },
            "53045": { "city" : "BROOKFIELD", "state" : "WI", "county" : "WAUKESHA" },
            "53046": { "city" : "LANNON", "state" : "WI", "county" : "WAUKESHA" },
            "53047": { "city" : "LEBANON", "state" : "WI", "county" : "DODGE" },"53048": { "city" : "LOMIRA", "state" : "WI", "county" : "DODGE" },
            "53049": { "city" : "MALONE", "state" : "WI", "county" : "FOND DU LAC" },
            "53050": { "city" : "MAYVILLE", "state" : "WI", "county" : "DODGE" },
            "53051": { "city" : "MENOMONEE FALLS", "state" : "WI", "county" : "WAUKESHA" },
            "53052": { "city" : "MENOMONEE FALLS", "state" : "WI", "county" : "WAUKESHA" },
            "53056": { "city" : "MERTON", "state" : "WI", "county" : "WAUKESHA" },
            "53057": { "city" : "MOUNT CALVARY", "state" : "WI", "county" : "FOND DU LAC" },
            "53058": { "city" : "NASHOTAH", "state" : "WI", "county" : "WAUKESHA" },
            "53059": { "city" : "NEOSHO", "state" : "WI", "county" : "DODGE" },"53060": { "city" : "NEWBURG", "state" : "WI", "county" : "WASHINGTON" },
            "53061": { "city" : "NEW HOLSTEIN", "state" : "WI", "county" : "CALUMET" },
            "53062": { "city" : "NEW HOLSTEIN", "state" : "WI", "county" : "CALUMET" },
            "53063": { "city" : "NEWTON", "state" : "WI", "county" : "MANITOWOC" },
            "53064": { "city" : "NORTH LAKE", "state" : "WI", "county" : "WAUKESHA" },
            "53065": { "city" : "OAKFIELD", "state" : "WI", "county" : "FOND DU LAC" },
            "53066": { "city" : "OCONOMOWOC", "state" : "WI", "county" : "WAUKESHA" },
            "53069": { "city" : "OKAUCHEE", "state" : "WI", "county" : "WAUKESHA" },
            "53070": { "city" : "OOSTBURG", "state" : "WI", "county" : "SHEBOYGAN" },
            "53072": { "city" : "PEWAUKEE", "state" : "WI", "county" : "WAUKESHA" },
            "53073": { "city" : "PLYMOUTH", "state" : "WI", "county" : "SHEBOYGAN" },
            "53074": { "city" : "PORT WASHINGTON", "state" : "WI", "county" : "OZAUKEE" },
            "53075": { "city" : "RANDOM LAKE", "state" : "WI", "county" : "SHEBOYGAN" },
            "53076": { "city" : "RICHFIELD", "state" : "WI", "county" : "WASHINGTON" },
            "53078": { "city" : "RUBICON", "state" : "WI", "county" : "DODGE" },"53079": { "city" : "SAINT CLOUD", "state" : "WI", "county" : "FOND DU LAC" },
            "53080": { "city" : "SAUKVILLE", "state" : "WI", "county" : "OZAUKEE" },
            "53081": { "city" : "SHEBOYGAN", "state" : "WI", "county" : "SHEBOYGAN" },
            "53082": { "city" : "SHEBOYGAN", "state" : "WI", "county" : "SHEBOYGAN" },
            "53083": { "city" : "SHEBOYGAN", "state" : "WI", "county" : "SHEBOYGAN" },
            "53085": { "city" : "SHEBOYGAN FALLS", "state" : "WI", "county" : "SHEBOYGAN" },
            "53086": { "city" : "SLINGER", "state" : "WI", "county" : "WASHINGTON" },
            "53088": { "city" : "STOCKBRIDGE", "state" : "WI", "county" : "CALUMET" },
            "53089": { "city" : "SUSSEX", "state" : "WI", "county" : "WAUKESHA" },
            "53090": { "city" : "WEST BEND", "state" : "WI", "county" : "WASHINGTON" },
            "53091": { "city" : "THERESA", "state" : "WI", "county" : "DODGE" },"53092": { "city" : "THIENSVILLE", "state" : "WI", "county" : "OZAUKEE" },
            "53093": { "city" : "WALDO", "state" : "WI", "county" : "SHEBOYGAN" },
            "53094": { "city" : "WATERTOWN", "state" : "WI", "county" : "JEFFERSON" },
            "53095": { "city" : "WEST BEND", "state" : "WI", "county" : "WASHINGTON" },
            "53097": { "city" : "MEQUON", "state" : "WI", "county" : "OZAUKEE" },
            "53098": { "city" : "WATERTOWN", "state" : "WI", "county" : "DODGE" },
            "53099": { "city" : "WOODLAND", "state" : "WI", "county" : "DODGE" },
            "53101": { "city" : "BASSETT", "state" : "WI", "county" : "KENOSHA" },
            "53102": { "city" : "BENET LAKE", "state" : "WI", "county" : "KENOSHA" },
            "53103": { "city" : "BIG BEND", "state" : "WI", "county" : "WAUKESHA" },
            "53104": { "city" : "BRISTOL", "state" : "WI", "county" : "KENOSHA" },
            "53105": { "city" : "BURLINGTON", "state" : "WI", "county" : "RACINE" },
            "53108": { "city" : "CALEDONIA", "state" : "WI", "county" : "RACINE" },
            "53109": { "city" : "CAMP LAKE", "state" : "WI", "county" : "KENOSHA" },
            "53110": { "city" : "CUDAHY", "state" : "WI", "county" : "MILWAUKEE" },
            "53114": { "city" : "DARIEN", "state" : "WI", "county" : "WALWORTH" },
            "53115": { "city" : "DELAVAN", "state" : "WI", "county" : "WALWORTH" },
            "53118": { "city" : "DOUSMAN", "state" : "WI", "county" : "WAUKESHA" },
            "53119": { "city" : "EAGLE", "state" : "WI", "county" : "WAUKESHA" },
            "53120": { "city" : "EAST TROY", "state" : "WI", "county" : "WALWORTH" },
            "53121": { "city" : "ELKHORN", "state" : "WI", "county" : "WALWORTH" },
            "53122": { "city" : "ELM GROVE", "state" : "WI", "county" : "WAUKESHA" },
            "53125": { "city" : "FONTANA", "state" : "WI", "county" : "WALWORTH" },
            "53126": { "city" : "FRANKSVILLE", "state" : "WI", "county" : "RACINE" },
            "53127": { "city" : "GENESEE DEPOT", "state" : "WI", "county" : "WAUKESHA" },
            "53128": { "city" : "GENOA CITY", "state" : "WI", "county" : "WALWORTH" },
            "53129": { "city" : "GREENDALE", "state" : "WI", "county" : "MILWAUKEE" },
            "53130": { "city" : "HALES CORNERS", "state" : "WI", "county" : "MILWAUKEE" },
            "53132": { "city" : "FRANKLIN", "state" : "WI", "county" : "MILWAUKEE" },
            "53137": { "city" : "HELENVILLE", "state" : "WI", "county" : "JEFFERSON" },
            "53138": { "city" : "HONEY CREEK", "state" : "WI", "county" : "WALWORTH" },
            "53139": { "city" : "KANSASVILLE", "state" : "WI", "county" : "RACINE" },
            "53140": { "city" : "KENOSHA", "state" : "WI", "county" : "KENOSHA" },
            "53141": { "city" : "KENOSHA", "state" : "WI", "county" : "KENOSHA" },
            "53142": { "city" : "KENOSHA", "state" : "WI", "county" : "KENOSHA" },
            "53143": { "city" : "KENOSHA", "state" : "WI", "county" : "KENOSHA" },
            "53144": { "city" : "KENOSHA", "state" : "WI", "county" : "KENOSHA" },
            "53146": { "city" : "NEW BERLIN", "state" : "WI", "county" : "WAUKESHA" },
            "53147": { "city" : "LAKE GENEVA", "state" : "WI", "county" : "WALWORTH" },
            "53148": { "city" : "LYONS", "state" : "WI", "county" : "WALWORTH" },
            "53149": { "city" : "MUKWONAGO", "state" : "WI", "county" : "WAUKESHA" },
            "53150": { "city" : "MUSKEGO", "state" : "WI", "county" : "WAUKESHA" },
            "53151": { "city" : "NEW BERLIN", "state" : "WI", "county" : "WAUKESHA" },
            "53152": { "city" : "NEW MUNSTER", "state" : "WI", "county" : "KENOSHA" },
            "53153": { "city" : "NORTH PRAIRIE", "state" : "WI", "county" : "WAUKESHA" },
            "53154": { "city" : "OAK CREEK", "state" : "WI", "county" : "MILWAUKEE" },
            "53156": { "city" : "PALMYRA", "state" : "WI", "county" : "JEFFERSON" },
            "53157": { "city" : "PELL LAKE", "state" : "WI", "county" : "WALWORTH" },
            "53158": { "city" : "PLEASANT PRAIRIE", "state" : "WI", "county" : "KENOSHA" },
            "53159": { "city" : "POWERS LAKE", "state" : "WI", "county" : "KENOSHA" },
            "53167": { "city" : "ROCHESTER", "state" : "WI", "county" : "RACINE" },
            "53168": { "city" : "SALEM", "state" : "WI", "county" : "KENOSHA" },"53170": { "city" : "SILVER LAKE", "state" : "WI", "county" : "KENOSHA" },
            "53171": { "city" : "SOMERS", "state" : "WI", "county" : "KENOSHA" },
            "53172": { "city" : "SOUTH MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53176": { "city" : "SPRINGFIELD", "state" : "WI", "county" : "WALWORTH" },
            "53177": { "city" : "STURTEVANT", "state" : "WI", "county" : "RACINE" },
            "53178": { "city" : "SULLIVAN", "state" : "WI", "county" : "JEFFERSON" },
            "53179": { "city" : "TREVOR", "state" : "WI", "county" : "KENOSHA" },
            "53181": { "city" : "TWIN LAKES", "state" : "WI", "county" : "KENOSHA" },
            "53182": { "city" : "UNION GROVE", "state" : "WI", "county" : "RACINE" },
            "53183": { "city" : "WALES", "state" : "WI", "county" : "WAUKESHA" },
            "53184": { "city" : "WALWORTH", "state" : "WI", "county" : "WALWORTH" },
            "53185": { "city" : "WATERFORD", "state" : "WI", "county" : "RACINE" },
            "53186": { "city" : "WAUKESHA", "state" : "WI", "county" : "WAUKESHA" },
            "53187": { "city" : "WAUKESHA", "state" : "WI", "county" : "WAUKESHA" },
            "53188": { "city" : "WAUKESHA", "state" : "WI", "county" : "WAUKESHA" },
            "53189": { "city" : "WAUKESHA", "state" : "WI", "county" : "WAUKESHA" },
            "53190": { "city" : "WHITEWATER", "state" : "WI", "county" : "WALWORTH" },
            "53191": { "city" : "WILLIAMS BAY", "state" : "WI", "county" : "WALWORTH" },
            "53192": { "city" : "WILMOT", "state" : "WI", "county" : "KENOSHA" },
            "53195": { "city" : "ZENDA", "state" : "WI", "county" : "WALWORTH" },
            "53199": { "city" : "SILVER LAKE", "state" : "WI", "county" : "KENOSHA" },
            "53201": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53202": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53203": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53204": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53205": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53206": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53207": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53208": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53209": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53210": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53211": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53212": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53213": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53214": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53215": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53216": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53217": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53218": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53219": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53220": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53221": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53222": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53223": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53224": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53225": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53226": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53227": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53228": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53233": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53234": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53235": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53237": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53259": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53274": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53278": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53288": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53293": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53295": { "city" : "MILWAUKEE", "state" : "WI", "county" : "MILWAUKEE" },
            "53401": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },"53402": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },
            "53403": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },"53404": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },
            "53405": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },"53406": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },
            "53407": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },"53408": { "city" : "RACINE", "state" : "WI", "county" : "RACINE" },
            "53501": { "city" : "AFTON", "state" : "WI", "county" : "ROCK" },"53502": { "city" : "ALBANY", "state" : "WI", "county" : "GREEN" },
            "53503": { "city" : "ARENA", "state" : "WI", "county" : "IOWA" },"53504": { "city" : "ARGYLE", "state" : "WI", "county" : "LAFAYETTE" },
            "53505": { "city" : "AVALON", "state" : "WI", "county" : "ROCK" },"53506": { "city" : "AVOCA", "state" : "WI", "county" : "IOWA" },
            "53507": { "city" : "BARNEVELD", "state" : "WI", "county" : "IOWA" },
            "53508": { "city" : "BELLEVILLE", "state" : "WI", "county" : "DANE" },
            "53510": { "city" : "BELMONT", "state" : "WI", "county" : "LAFAYETTE" },
            "53511": { "city" : "BELOIT", "state" : "WI", "county" : "ROCK" },"53512": { "city" : "BELOIT", "state" : "WI", "county" : "ROCK" },
            "53515": { "city" : "BLACK EARTH", "state" : "WI", "county" : "DANE" },
            "53516": { "city" : "BLANCHARDVILLE", "state" : "WI", "county" : "LAFAYETTE" },
            "53517": { "city" : "BLUE MOUNDS", "state" : "WI", "county" : "DANE" },
            "53518": { "city" : "BLUE RIVER", "state" : "WI", "county" : "GRANT" },
            "53520": { "city" : "BRODHEAD", "state" : "WI", "county" : "GREEN" },
            "53521": { "city" : "BROOKLYN", "state" : "WI", "county" : "GREEN" },
            "53522": { "city" : "BROWNTOWN", "state" : "WI", "county" : "GREEN" },
            "53523": { "city" : "CAMBRIDGE", "state" : "WI", "county" : "DANE" },
            "53525": { "city" : "CLINTON", "state" : "WI", "county" : "ROCK" },"53526": { "city" : "COBB", "state" : "WI", "county" : "IOWA" },
            "53527": { "city" : "COTTAGE GROVE", "state" : "WI", "county" : "DANE" },
            "53528": { "city" : "CROSS PLAINS", "state" : "WI", "county" : "DANE" },
            "53529": { "city" : "DANE", "state" : "WI", "county" : "DANE" },"53530": { "city" : "DARLINGTON", "state" : "WI", "county" : "LAFAYETTE" },
            "53531": { "city" : "DEERFIELD", "state" : "WI", "county" : "DANE" },
            "53532": { "city" : "DE FOREST", "state" : "WI", "county" : "DANE" },
            "53533": { "city" : "DODGEVILLE", "state" : "WI", "county" : "IOWA" },
            "53534": { "city" : "EDGERTON", "state" : "WI", "county" : "ROCK" },"53535": { "city" : "EDMUND", "state" : "WI", "county" : "IOWA" },
            "53536": { "city" : "EVANSVILLE", "state" : "WI", "county" : "ROCK" },
            "53537": { "city" : "FOOTVILLE", "state" : "WI", "county" : "ROCK" },
            "53538": { "city" : "FORT ATKINSON", "state" : "WI", "county" : "JEFFERSON" },
            "53540": { "city" : "GOTHAM", "state" : "WI", "county" : "RICHLAND" },
            "53541": { "city" : "GRATIOT", "state" : "WI", "county" : "LAFAYETTE" },
            "53542": { "city" : "HANOVER", "state" : "WI", "county" : "ROCK" },"53543": { "city" : "HIGHLAND", "state" : "WI", "county" : "IOWA" },
            "53544": { "city" : "HOLLANDALE", "state" : "WI", "county" : "IOWA" },
            "53545": { "city" : "JANESVILLE", "state" : "WI", "county" : "ROCK" },
            "53546": { "city" : "JANESVILLE", "state" : "WI", "county" : "ROCK" },
            "53547": { "city" : "JANESVILLE", "state" : "WI", "county" : "ROCK" },
            "53548": { "city" : "JANESVILLE", "state" : "WI", "county" : "ROCK" },
            "53549": { "city" : "JEFFERSON", "state" : "WI", "county" : "JEFFERSON" },
            "53550": { "city" : "JUDA", "state" : "WI", "county" : "GREEN" },"53551": { "city" : "LAKE MILLS", "state" : "WI", "county" : "JEFFERSON" },
            "53553": { "city" : "LINDEN", "state" : "WI", "county" : "IOWA" },"53554": { "city" : "LIVINGSTON", "state" : "WI", "county" : "GRANT" },
            "53555": { "city" : "LODI", "state" : "WI", "county" : "COLUMBIA" },"53556": { "city" : "LONE ROCK", "state" : "WI", "county" : "RICHLAND" },
            "53557": { "city" : "LOWELL", "state" : "WI", "county" : "DODGE" },"53558": { "city" : "MC FARLAND", "state" : "WI", "county" : "DANE" },
            "53559": { "city" : "MARSHALL", "state" : "WI", "county" : "DANE" },"53560": { "city" : "MAZOMANIE", "state" : "WI", "county" : "DANE" },
            "53561": { "city" : "MERRIMAC", "state" : "WI", "county" : "SAUK" },"53562": { "city" : "MIDDLETON", "state" : "WI", "county" : "DANE" },
            "53563": { "city" : "MILTON", "state" : "WI", "county" : "ROCK" },"53565": { "city" : "MINERAL POINT", "state" : "WI", "county" : "IOWA" },
            "53566": { "city" : "MONROE", "state" : "WI", "county" : "GREEN" },"53569": { "city" : "MONTFORT", "state" : "WI", "county" : "GRANT" },
            "53570": { "city" : "MONTICELLO", "state" : "WI", "county" : "GREEN" },
            "53571": { "city" : "MORRISONVILLE", "state" : "WI", "county" : "DANE" },
            "53572": { "city" : "MOUNT HOREB", "state" : "WI", "county" : "DANE" },
            "53573": { "city" : "MUSCODA", "state" : "WI", "county" : "GRANT" },"53574": { "city" : "NEW GLARUS", "state" : "WI", "county" : "GREEN" },
            "53575": { "city" : "OREGON", "state" : "WI", "county" : "DANE" },"53576": { "city" : "ORFORDVILLE", "state" : "WI", "county" : "ROCK" },
            "53577": { "city" : "PLAIN", "state" : "WI", "county" : "SAUK" },"53578": { "city" : "PRAIRIE DU SAC", "state" : "WI", "county" : "SAUK" },
            "53579": { "city" : "REESEVILLE", "state" : "WI", "county" : "DODGE" },
            "53580": { "city" : "REWEY", "state" : "WI", "county" : "IOWA" },"53581": { "city" : "RICHLAND CENTER", "state" : "WI", "county" : "RICHLAND" },
            "53582": { "city" : "RIDGEWAY", "state" : "WI", "county" : "IOWA" },"53583": { "city" : "SAUK CITY", "state" : "WI", "county" : "SAUK" },
            "53585": { "city" : "SHARON", "state" : "WI", "county" : "WALWORTH" },
            "53586": { "city" : "SHULLSBURG", "state" : "WI", "county" : "LAFAYETTE" },
            "53587": { "city" : "SOUTH WAYNE", "state" : "WI", "county" : "LAFAYETTE" },
            "53588": { "city" : "SPRING GREEN", "state" : "WI", "county" : "SAUK" },
            "53589": { "city" : "STOUGHTON", "state" : "WI", "county" : "DANE" },
            "53590": { "city" : "SUN PRAIRIE", "state" : "WI", "county" : "DANE" },
            "53593": { "city" : "VERONA", "state" : "WI", "county" : "DANE" },"53594": { "city" : "WATERLOO", "state" : "WI", "county" : "JEFFERSON" },
            "53595": { "city" : "DODGEVILLE", "state" : "WI", "county" : "IOWA" },
            "53596": { "city" : "SUN PRAIRIE", "state" : "WI", "county" : "DANE" },
            "53597": { "city" : "WAUNAKEE", "state" : "WI", "county" : "DANE" },"53598": { "city" : "WINDSOR", "state" : "WI", "county" : "DANE" },
            "53599": { "city" : "WOODFORD", "state" : "WI", "county" : "LAFAYETTE" },
            "53701": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53702": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53703": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53704": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53705": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53706": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53707": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53708": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53711": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53713": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53714": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53715": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53716": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53717": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53718": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53719": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53725": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53726": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53744": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53783": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53789": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53791": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },
            "53792": { "city" : "MADISON", "state" : "WI", "county" : "DANE" },"53801": { "city" : "BAGLEY", "state" : "WI", "county" : "GRANT" },
            "53802": { "city" : "BEETOWN", "state" : "WI", "county" : "GRANT" },"53803": { "city" : "BENTON", "state" : "WI", "county" : "LAFAYETTE" },
            "53804": { "city" : "BLOOMINGTON", "state" : "WI", "county" : "GRANT" },
            "53805": { "city" : "BOSCOBEL", "state" : "WI", "county" : "GRANT" },
            "53806": { "city" : "CASSVILLE", "state" : "WI", "county" : "GRANT" },
            "53807": { "city" : "CUBA CITY", "state" : "WI", "county" : "GRANT" },
            "53808": { "city" : "DICKEYVILLE", "state" : "WI", "county" : "GRANT" },
            "53809": { "city" : "FENNIMORE", "state" : "WI", "county" : "GRANT" },
            "53810": { "city" : "GLEN HAVEN", "state" : "WI", "county" : "GRANT" },
            "53811": { "city" : "HAZEL GREEN", "state" : "WI", "county" : "GRANT" },
            "53812": { "city" : "KIELER", "state" : "WI", "county" : "GRANT" },"53813": { "city" : "LANCASTER", "state" : "WI", "county" : "GRANT" },
            "53816": { "city" : "MOUNT HOPE", "state" : "WI", "county" : "GRANT" },
            "53817": { "city" : "PATCH GROVE", "state" : "WI", "county" : "GRANT" },
            "53818": { "city" : "PLATTEVILLE", "state" : "WI", "county" : "GRANT" },
            "53820": { "city" : "POTOSI", "state" : "WI", "county" : "GRANT" },"53821": { "city" : "PRAIRIE DU CHIEN", "state" : "WI", "county" : "CRAWFORD" },
            "53825": { "city" : "STITZER", "state" : "WI", "county" : "GRANT" },"53826": { "city" : "WAUZEKA", "state" : "WI", "county" : "CRAWFORD" },
            "53827": { "city" : "WOODMAN", "state" : "WI", "county" : "GRANT" },"53901": { "city" : "PORTAGE", "state" : "WI", "county" : "COLUMBIA" },
            "53910": { "city" : "ADAMS", "state" : "WI", "county" : "ADAMS" },"53911": { "city" : "ARLINGTON", "state" : "WI", "county" : "COLUMBIA" },
            "53913": { "city" : "BARABOO", "state" : "WI", "county" : "SAUK" },"53916": { "city" : "BEAVER DAM", "state" : "WI", "county" : "DODGE" },
            "53919": { "city" : "BRANDON", "state" : "WI", "county" : "FOND DU LAC" },
            "53920": { "city" : "BRIGGSVILLE", "state" : "WI", "county" : "MARQUETTE" },
            "53922": { "city" : "BURNETT", "state" : "WI", "county" : "DODGE" },"53923": { "city" : "CAMBRIA", "state" : "WI", "county" : "COLUMBIA" },
            "53924": { "city" : "CAZENOVIA", "state" : "WI", "county" : "RICHLAND" },
            "53925": { "city" : "COLUMBUS", "state" : "WI", "county" : "COLUMBIA" },
            "53926": { "city" : "DALTON", "state" : "WI", "county" : "GREEN LAKE" },
            "53927": { "city" : "DELLWOOD", "state" : "WI", "county" : "ADAMS" },
            "53928": { "city" : "DOYLESTOWN", "state" : "WI", "county" : "COLUMBIA" },
            "53929": { "city" : "ELROY", "state" : "WI", "county" : "JUNEAU" },"53930": { "city" : "ENDEAVOR", "state" : "WI", "county" : "MARQUETTE" },
            "53931": { "city" : "FAIRWATER", "state" : "WI", "county" : "FOND DU LAC" },
            "53932": { "city" : "FALL RIVER", "state" : "WI", "county" : "COLUMBIA" },
            "53933": { "city" : "FOX LAKE", "state" : "WI", "county" : "DODGE" },
            "53934": { "city" : "FRIENDSHIP", "state" : "WI", "county" : "ADAMS" },
            "53935": { "city" : "FRIESLAND", "state" : "WI", "county" : "COLUMBIA" },
            "53936": { "city" : "GRAND MARSH", "state" : "WI", "county" : "ADAMS" },
            "53937": { "city" : "HILLPOINT", "state" : "WI", "county" : "SAUK" },
            "53939": { "city" : "KINGSTON", "state" : "WI", "county" : "GREEN LAKE" },
            "53940": { "city" : "LAKE DELTON", "state" : "WI", "county" : "SAUK" },
            "53941": { "city" : "LA VALLE", "state" : "WI", "county" : "SAUK" },"53942": { "city" : "LIME RIDGE", "state" : "WI", "county" : "SAUK" },
            "53943": { "city" : "LOGANVILLE", "state" : "WI", "county" : "SAUK" },
            "53944": { "city" : "LYNDON STATION", "state" : "WI", "county" : "JUNEAU" },
            "53946": { "city" : "MARKESAN", "state" : "WI", "county" : "GREEN LAKE" },
            "53947": { "city" : "MARQUETTE", "state" : "WI", "county" : "GREEN LAKE" },
            "53948": { "city" : "MAUSTON", "state" : "WI", "county" : "JUNEAU" },
            "53949": { "city" : "MONTELLO", "state" : "WI", "county" : "MARQUETTE" },
            "53950": { "city" : "NEW LISBON", "state" : "WI", "county" : "JUNEAU" },
            "53951": { "city" : "NORTH FREEDOM", "state" : "WI", "county" : "SAUK" },
            "53952": { "city" : "OXFORD", "state" : "WI", "county" : "MARQUETTE" },
            "53953": { "city" : "PACKWAUKEE", "state" : "WI", "county" : "MARQUETTE" },
            "53954": { "city" : "PARDEEVILLE", "state" : "WI", "county" : "COLUMBIA" },
            "53955": { "city" : "POYNETTE", "state" : "WI", "county" : "COLUMBIA" },
            "53956": { "city" : "RANDOLPH", "state" : "WI", "county" : "DODGE" },
            "53959": { "city" : "REEDSBURG", "state" : "WI", "county" : "SAUK" },
            "53960": { "city" : "RIO", "state" : "WI", "county" : "COLUMBIA" },"53961": { "city" : "ROCK SPRINGS", "state" : "WI", "county" : "SAUK" },
            "53962": { "city" : "UNION CENTER", "state" : "WI", "county" : "JUNEAU" },
            "53963": { "city" : "WAUPUN", "state" : "WI", "county" : "DODGE" },"53964": { "city" : "WESTFIELD", "state" : "WI", "county" : "MARQUETTE" },
            "53965": { "city" : "WISCONSIN DELLS", "state" : "WI", "county" : "COLUMBIA" },
            "53968": { "city" : "WONEWOC", "state" : "WI", "county" : "JUNEAU" },
            "53969": { "city" : "WYOCENA", "state" : "WI", "county" : "COLUMBIA" },
            "54001": { "city" : "AMERY", "state" : "WI", "county" : "POLK" },"54002": { "city" : "BALDWIN", "state" : "WI", "county" : "SAINT CROIX" },
            "54003": { "city" : "BELDENVILLE", "state" : "WI", "county" : "PIERCE" },
            "54004": { "city" : "CLAYTON", "state" : "WI", "county" : "POLK" },"54005": { "city" : "CLEAR LAKE", "state" : "WI", "county" : "POLK" },
            "54006": { "city" : "CUSHING", "state" : "WI", "county" : "POLK" },"54007": { "city" : "DEER PARK", "state" : "WI", "county" : "SAINT CROIX" },
            "54009": { "city" : "DRESSER", "state" : "WI", "county" : "POLK" },"54010": { "city" : "EAST ELLSWORTH", "state" : "WI", "county" : "PIERCE" },
            "54011": { "city" : "ELLSWORTH", "state" : "WI", "county" : "PIERCE" },
            "54013": { "city" : "GLENWOOD CITY", "state" : "WI", "county" : "SAINT CROIX" },
            "54014": { "city" : "HAGER CITY", "state" : "WI", "county" : "PIERCE" },
            "54015": { "city" : "HAMMOND", "state" : "WI", "county" : "SAINT CROIX" },
            "54016": { "city" : "HUDSON", "state" : "WI", "county" : "SAINT CROIX" },
            "54017": { "city" : "NEW RICHMOND", "state" : "WI", "county" : "SAINT CROIX" },
            "54020": { "city" : "OSCEOLA", "state" : "WI", "county" : "POLK" },"54021": { "city" : "PRESCOTT", "state" : "WI", "county" : "PIERCE" },
            "54022": { "city" : "RIVER FALLS", "state" : "WI", "county" : "PIERCE" },
            "54023": { "city" : "ROBERTS", "state" : "WI", "county" : "SAINT CROIX" },
            "54024": { "city" : "SAINT CROIX FALLS", "state" : "WI", "county" : "POLK" },
            "54025": { "city" : "SOMERSET", "state" : "WI", "county" : "SAINT CROIX" },
            "54026": { "city" : "STAR PRAIRIE", "state" : "WI", "county" : "POLK" },
            "54027": { "city" : "WILSON", "state" : "WI", "county" : "SAINT CROIX" },
            "54028": { "city" : "WOODVILLE", "state" : "WI", "county" : "SAINT CROIX" },
            "54082": { "city" : "HOULTON", "state" : "WI", "county" : "SAINT CROIX" },
            "54101": { "city" : "ABRAMS", "state" : "WI", "county" : "OCONTO" },"54102": { "city" : "AMBERG", "state" : "WI", "county" : "MARINETTE" },
            "54103": { "city" : "ARMSTRONG CREEK", "state" : "WI", "county" : "FOREST" },
            "54104": { "city" : "ATHELSTANE", "state" : "WI", "county" : "MARINETTE" },
            "54106": { "city" : "BLACK CREEK", "state" : "WI", "county" : "OUTAGAMIE" },
            "54107": { "city" : "BONDUEL", "state" : "WI", "county" : "SHAWANO" },
            "54110": { "city" : "BRILLION", "state" : "WI", "county" : "CALUMET" },
            "54111": { "city" : "CECIL", "state" : "WI", "county" : "SHAWANO" },"54112": { "city" : "COLEMAN", "state" : "WI", "county" : "MARINETTE" },
            "54113": { "city" : "COMBINED LOCKS", "state" : "WI", "county" : "OUTAGAMIE" },
            "54114": { "city" : "CRIVITZ", "state" : "WI", "county" : "MARINETTE" },
            "54115": { "city" : "DE PERE", "state" : "WI", "county" : "BROWN" },"54119": { "city" : "DUNBAR", "state" : "WI", "county" : "MARINETTE" },
            "54120": { "city" : "FENCE", "state" : "WI", "county" : "FLORENCE" },
            "54121": { "city" : "FLORENCE", "state" : "WI", "county" : "FLORENCE" },
            "54123": { "city" : "FOREST JUNCTION", "state" : "WI", "county" : "CALUMET" },
            "54124": { "city" : "GILLETT", "state" : "WI", "county" : "OCONTO" },
            "54125": { "city" : "GOODMAN", "state" : "WI", "county" : "MARINETTE" },
            "54126": { "city" : "GREENLEAF", "state" : "WI", "county" : "BROWN" },
            "54127": { "city" : "GREEN VALLEY", "state" : "WI", "county" : "SHAWANO" },
            "54128": { "city" : "GRESHAM", "state" : "WI", "county" : "SHAWANO" },
            "54129": { "city" : "HILBERT", "state" : "WI", "county" : "CALUMET" },
            "54130": { "city" : "KAUKAUNA", "state" : "WI", "county" : "OUTAGAMIE" },
            "54131": { "city" : "FREEDOM", "state" : "WI", "county" : "OUTAGAMIE" },
            "54135": { "city" : "KESHENA", "state" : "WI", "county" : "MENOMINEE" },
            "54136": { "city" : "KIMBERLY", "state" : "WI", "county" : "OUTAGAMIE" },
            "54137": { "city" : "KRAKOW", "state" : "WI", "county" : "SHAWANO" },
            "54138": { "city" : "LAKEWOOD", "state" : "WI", "county" : "OCONTO" },
            "54139": { "city" : "LENA", "state" : "WI", "county" : "OCONTO" },"54140": { "city" : "LITTLE CHUTE", "state" : "WI", "county" : "OUTAGAMIE" },
            "54141": { "city" : "LITTLE SUAMICO", "state" : "WI", "county" : "OCONTO" },
            "54143": { "city" : "MARINETTE", "state" : "WI", "county" : "MARINETTE" },
            "54149": { "city" : "MOUNTAIN", "state" : "WI", "county" : "OCONTO" },
            "54150": { "city" : "NEOPIT", "state" : "WI", "county" : "MENOMINEE" },
            "54151": { "city" : "NIAGARA", "state" : "WI", "county" : "MARINETTE" },
            "54152": { "city" : "NICHOLS", "state" : "WI", "county" : "OUTAGAMIE" },
            "54153": { "city" : "OCONTO", "state" : "WI", "county" : "OCONTO" },"54154": { "city" : "OCONTO FALLS", "state" : "WI", "county" : "OCONTO" },
            "54155": { "city" : "ONEIDA", "state" : "WI", "county" : "BROWN" },"54156": { "city" : "PEMBINE", "state" : "WI", "county" : "MARINETTE" },
            "54157": { "city" : "PESHTIGO", "state" : "WI", "county" : "MARINETTE" },
            "54159": { "city" : "PORTERFIELD", "state" : "WI", "county" : "MARINETTE" },
            "54160": { "city" : "POTTER", "state" : "WI", "county" : "CALUMET" },
            "54161": { "city" : "POUND", "state" : "WI", "county" : "MARINETTE" },
            "54162": { "city" : "PULASKI", "state" : "WI", "county" : "BROWN" },"54165": { "city" : "SEYMOUR", "state" : "WI", "county" : "OUTAGAMIE" },
            "54166": { "city" : "SHAWANO", "state" : "WI", "county" : "SHAWANO" },
            "54169": { "city" : "SHERWOOD", "state" : "WI", "county" : "CALUMET" },
            "54170": { "city" : "SHIOCTON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54171": { "city" : "SOBIESKI", "state" : "WI", "county" : "OCONTO" },
            "54173": { "city" : "SUAMICO", "state" : "WI", "county" : "BROWN" },"54174": { "city" : "SURING", "state" : "WI", "county" : "OCONTO" },
            "54175": { "city" : "TOWNSEND", "state" : "WI", "county" : "OCONTO" },
            "54177": { "city" : "WAUSAUKEE", "state" : "WI", "county" : "MARINETTE" },
            "54180": { "city" : "WRIGHTSTOWN", "state" : "WI", "county" : "BROWN" },
            "54182": { "city" : "ZACHOW", "state" : "WI", "county" : "SHAWANO" },
            "54201": { "city" : "ALGOMA", "state" : "WI", "county" : "KEWAUNEE" },
            "54202": { "city" : "BAILEYS HARBOR", "state" : "WI", "county" : "DOOR" },
            "54204": { "city" : "BRUSSELS", "state" : "WI", "county" : "DOOR" },"54205": { "city" : "CASCO", "state" : "WI", "county" : "KEWAUNEE" },
            "54207": { "city" : "COLLINS", "state" : "WI", "county" : "MANITOWOC" },
            "54208": { "city" : "DENMARK", "state" : "WI", "county" : "BROWN" },"54209": { "city" : "EGG HARBOR", "state" : "WI", "county" : "DOOR" },
            "54210": { "city" : "ELLISON BAY", "state" : "WI", "county" : "DOOR" },
            "54211": { "city" : "EPHRAIM", "state" : "WI", "county" : "DOOR" },"54212": { "city" : "FISH CREEK", "state" : "WI", "county" : "DOOR" },
            "54213": { "city" : "FORESTVILLE", "state" : "WI", "county" : "DOOR" },
            "54214": { "city" : "FRANCIS CREEK", "state" : "WI", "county" : "MANITOWOC" },
            "54215": { "city" : "KELLNERSVILLE", "state" : "WI", "county" : "MANITOWOC" },
            "54216": { "city" : "KEWAUNEE", "state" : "WI", "county" : "KEWAUNEE" },
            "54217": { "city" : "LUXEMBURG", "state" : "WI", "county" : "KEWAUNEE" },
            "54220": { "city" : "MANITOWOC", "state" : "WI", "county" : "MANITOWOC" },
            "54221": { "city" : "MANITOWOC", "state" : "WI", "county" : "MANITOWOC" },
            "54226": { "city" : "MAPLEWOOD", "state" : "WI", "county" : "DOOR" },
            "54227": { "city" : "MARIBEL", "state" : "WI", "county" : "MANITOWOC" },
            "54228": { "city" : "MISHICOT", "state" : "WI", "county" : "MANITOWOC" },
            "54229": { "city" : "NEW FRANKEN", "state" : "WI", "county" : "BROWN" },
            "54230": { "city" : "REEDSVILLE", "state" : "WI", "county" : "MANITOWOC" },
            "54232": { "city" : "SAINT NAZIANZ", "state" : "WI", "county" : "MANITOWOC" },
            "54234": { "city" : "SISTER BAY", "state" : "WI", "county" : "DOOR" },
            "54235": { "city" : "STURGEON BAY", "state" : "WI", "county" : "DOOR" },
            "54240": { "city" : "TISCH MILLS", "state" : "WI", "county" : "MANITOWOC" },
            "54241": { "city" : "TWO RIVERS", "state" : "WI", "county" : "MANITOWOC" },
            "54245": { "city" : "VALDERS", "state" : "WI", "county" : "MANITOWOC" },
            "54246": { "city" : "WASHINGTON ISLAND", "state" : "WI", "county" : "DOOR" },
            "54247": { "city" : "WHITELAW", "state" : "WI", "county" : "MANITOWOC" },
            "54301": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54302": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54303": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54304": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54305": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54306": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54307": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54308": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54311": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54313": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54324": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54344": { "city" : "GREEN BAY", "state" : "WI", "county" : "BROWN" },
            "54401": { "city" : "WAUSAU", "state" : "WI", "county" : "MARATHON" },
            "54402": { "city" : "WAUSAU", "state" : "WI", "county" : "MARATHON" },
            "54403": { "city" : "WAUSAU", "state" : "WI", "county" : "MARATHON" },
            "54405": { "city" : "ABBOTSFORD", "state" : "WI", "county" : "CLARK" },
            "54406": { "city" : "AMHERST", "state" : "WI", "county" : "PORTAGE" },
            "54407": { "city" : "AMHERST JUNCTION", "state" : "WI", "county" : "PORTAGE" },
            "54408": { "city" : "ANIWA", "state" : "WI", "county" : "MARATHON" },
            "54409": { "city" : "ANTIGO", "state" : "WI", "county" : "LANGLADE" },
            "54410": { "city" : "ARPIN", "state" : "WI", "county" : "WOOD" },"54411": { "city" : "ATHENS", "state" : "WI", "county" : "MARATHON" },
            "54412": { "city" : "AUBURNDALE", "state" : "WI", "county" : "WOOD" },
            "54413": { "city" : "BABCOCK", "state" : "WI", "county" : "WOOD" },"54414": { "city" : "BIRNAMWOOD", "state" : "WI", "county" : "SHAWANO" },
            "54415": { "city" : "BLENKER", "state" : "WI", "county" : "WOOD" },"54416": { "city" : "BOWLER", "state" : "WI", "county" : "SHAWANO" },
            "54417": { "city" : "BROKAW", "state" : "WI", "county" : "MARATHON" },
            "54418": { "city" : "BRYANT", "state" : "WI", "county" : "LANGLADE" },
            "54420": { "city" : "CHILI", "state" : "WI", "county" : "CLARK" },"54421": { "city" : "COLBY", "state" : "WI", "county" : "CLARK" },
            "54422": { "city" : "CURTISS", "state" : "WI", "county" : "CLARK" },"54423": { "city" : "CUSTER", "state" : "WI", "county" : "PORTAGE" },
            "54424": { "city" : "DEERBROOK", "state" : "WI", "county" : "LANGLADE" },
            "54425": { "city" : "DORCHESTER", "state" : "WI", "county" : "CLARK" },
            "54426": { "city" : "EDGAR", "state" : "WI", "county" : "MARATHON" },
            "54427": { "city" : "ELAND", "state" : "WI", "county" : "MARATHON" },
            "54428": { "city" : "ELCHO", "state" : "WI", "county" : "LANGLADE" },
            "54429": { "city" : "ELDERON", "state" : "WI", "county" : "MARATHON" },
            "54430": { "city" : "ELTON", "state" : "WI", "county" : "LANGLADE" },
            "54433": { "city" : "GILMAN", "state" : "WI", "county" : "TAYLOR" },"54434": { "city" : "JUMP RIVER", "state" : "WI", "county" : "TAYLOR" },
            "54435": { "city" : "GLEASON", "state" : "WI", "county" : "LINCOLN" },
            "54436": { "city" : "GRANTON", "state" : "WI", "county" : "CLARK" },"54437": { "city" : "GREENWOOD", "state" : "WI", "county" : "CLARK" },
            "54440": { "city" : "HATLEY", "state" : "WI", "county" : "MARATHON" },
            "54441": { "city" : "HEWITT", "state" : "WI", "county" : "WOOD" },"54442": { "city" : "IRMA", "state" : "WI", "county" : "LINCOLN" },
            "54443": { "city" : "JUNCTION CITY", "state" : "WI", "county" : "PORTAGE" },
            "54446": { "city" : "LOYAL", "state" : "WI", "county" : "CLARK" },"54447": { "city" : "LUBLIN", "state" : "WI", "county" : "TAYLOR" },
            "54448": { "city" : "MARATHON", "state" : "WI", "county" : "MARATHON" },
            "54449": { "city" : "MARSHFIELD", "state" : "WI", "county" : "WOOD" },
            "54450": { "city" : "MATTOON", "state" : "WI", "county" : "SHAWANO" },
            "54451": { "city" : "MEDFORD", "state" : "WI", "county" : "TAYLOR" },
            "54452": { "city" : "MERRILL", "state" : "WI", "county" : "LINCOLN" },
            "54454": { "city" : "MILLADORE", "state" : "WI", "county" : "WOOD" },
            "54455": { "city" : "MOSINEE", "state" : "WI", "county" : "MARATHON" },
            "54456": { "city" : "NEILLSVILLE", "state" : "WI", "county" : "CLARK" },
            "54457": { "city" : "NEKOOSA", "state" : "WI", "county" : "WOOD" },"54458": { "city" : "NELSONVILLE", "state" : "WI", "county" : "PORTAGE" },
            "54459": { "city" : "OGEMA", "state" : "WI", "county" : "PRICE" },"54460": { "city" : "OWEN", "state" : "WI", "county" : "CLARK" },
            "54462": { "city" : "PEARSON", "state" : "WI", "county" : "LANGLADE" },
            "54463": { "city" : "PELICAN LAKE", "state" : "WI", "county" : "ONEIDA" },
            "54464": { "city" : "PHLOX", "state" : "WI", "county" : "LANGLADE" },
            "54465": { "city" : "PICKEREL", "state" : "WI", "county" : "LANGLADE" },
            "54466": { "city" : "PITTSVILLE", "state" : "WI", "county" : "WOOD" },
            "54467": { "city" : "PLOVER", "state" : "WI", "county" : "PORTAGE" },
            "54469": { "city" : "PORT EDWARDS", "state" : "WI", "county" : "WOOD" },
            "54470": { "city" : "RIB LAKE", "state" : "WI", "county" : "TAYLOR" },
            "54471": { "city" : "RINGLE", "state" : "WI", "county" : "MARATHON" },
            "54473": { "city" : "ROSHOLT", "state" : "WI", "county" : "PORTAGE" },
            "54474": { "city" : "ROTHSCHILD", "state" : "WI", "county" : "MARATHON" },
            "54475": { "city" : "RUDOLPH", "state" : "WI", "county" : "WOOD" },"54476": { "city" : "SCHOFIELD", "state" : "WI", "county" : "MARATHON" },
            "54479": { "city" : "SPENCER", "state" : "WI", "county" : "MARATHON" },
            "54480": { "city" : "STETSONVILLE", "state" : "WI", "county" : "TAYLOR" },
            "54481": { "city" : "STEVENS POINT", "state" : "WI", "county" : "PORTAGE" },
            "54482": { "city" : "STEVENS POINT", "state" : "WI", "county" : "PORTAGE" },
            "54484": { "city" : "STRATFORD", "state" : "WI", "county" : "MARATHON" },
            "54485": { "city" : "SUMMIT LAKE", "state" : "WI", "county" : "LANGLADE" },
            "54486": { "city" : "TIGERTON", "state" : "WI", "county" : "SHAWANO" },
            "54487": { "city" : "TOMAHAWK", "state" : "WI", "county" : "LINCOLN" },
            "54488": { "city" : "UNITY", "state" : "WI", "county" : "MARATHON" },
            "54489": { "city" : "VESPER", "state" : "WI", "county" : "WOOD" },"54490": { "city" : "WESTBORO", "state" : "WI", "county" : "TAYLOR" },
            "54491": { "city" : "WHITE LAKE", "state" : "WI", "county" : "LANGLADE" },
            "54493": { "city" : "WILLARD", "state" : "WI", "county" : "CLARK" },"54494": { "city" : "WISCONSIN RAPIDS", "state" : "WI", "county" : "WOOD" },
            "54495": { "city" : "WISCONSIN RAPIDS", "state" : "WI", "county" : "WOOD" },
            "54498": { "city" : "WITHEE", "state" : "WI", "county" : "CLARK" },"54499": { "city" : "WITTENBERG", "state" : "WI", "county" : "SHAWANO" },
            "54501": { "city" : "RHINELANDER", "state" : "WI", "county" : "ONEIDA" },
            "54511": { "city" : "ARGONNE", "state" : "WI", "county" : "FOREST" },
            "54512": { "city" : "BOULDER JUNCTION", "state" : "WI", "county" : "VILAS" },
            "54513": { "city" : "BRANTWOOD", "state" : "WI", "county" : "PRICE" },
            "54514": { "city" : "BUTTERNUT", "state" : "WI", "county" : "ASHLAND" },
            "54515": { "city" : "CATAWBA", "state" : "WI", "county" : "PRICE" },"54517": { "city" : "CLAM LAKE", "state" : "WI", "county" : "ASHLAND" },
            "54519": { "city" : "CONOVER", "state" : "WI", "county" : "VILAS" },"54520": { "city" : "CRANDON", "state" : "WI", "county" : "FOREST" },
            "54521": { "city" : "EAGLE RIVER", "state" : "WI", "county" : "VILAS" },
            "54524": { "city" : "FIFIELD", "state" : "WI", "county" : "PRICE" },"54525": { "city" : "GILE", "state" : "WI", "county" : "IRON" },
            "54526": { "city" : "GLEN FLORA", "state" : "WI", "county" : "RUSK" },
            "54527": { "city" : "GLIDDEN", "state" : "WI", "county" : "ASHLAND" },
            "54529": { "city" : "HARSHAW", "state" : "WI", "county" : "ONEIDA" },
            "54530": { "city" : "HAWKINS", "state" : "WI", "county" : "RUSK" },"54531": { "city" : "HAZELHURST", "state" : "WI", "county" : "ONEIDA" },
            "54532": { "city" : "HEAFFORD JUNCTION", "state" : "WI", "county" : "LINCOLN" },
            "54534": { "city" : "HURLEY", "state" : "WI", "county" : "IRON" },"54536": { "city" : "IRON BELT", "state" : "WI", "county" : "IRON" },
            "54537": { "city" : "KENNAN", "state" : "WI", "county" : "PRICE" },"54538": { "city" : "LAC DU FLAMBEAU", "state" : "WI", "county" : "VILAS" },
            "54539": { "city" : "LAKE TOMAHAWK", "state" : "WI", "county" : "ONEIDA" },
            "54540": { "city" : "LAND O LAKES", "state" : "WI", "county" : "VILAS" },
            "54541": { "city" : "LAONA", "state" : "WI", "county" : "FOREST" },"54542": { "city" : "LONG LAKE", "state" : "WI", "county" : "FLORENCE" },
            "54543": { "city" : "MC NAUGHTON", "state" : "WI", "county" : "ONEIDA" },
            "54545": { "city" : "MANITOWISH WATERS", "state" : "WI", "county" : "VILAS" },
            "54546": { "city" : "MELLEN", "state" : "WI", "county" : "ASHLAND" },
            "54547": { "city" : "MERCER", "state" : "WI", "county" : "IRON" },"54548": { "city" : "MINOCQUA", "state" : "WI", "county" : "ONEIDA" },
            "54550": { "city" : "MONTREAL", "state" : "WI", "county" : "IRON" },"54552": { "city" : "PARK FALLS", "state" : "WI", "county" : "PRICE" },
            "54554": { "city" : "PHELPS", "state" : "WI", "county" : "VILAS" },"54555": { "city" : "PHILLIPS", "state" : "WI", "county" : "PRICE" },
            "54556": { "city" : "PRENTICE", "state" : "WI", "county" : "PRICE" },
            "54557": { "city" : "PRESQUE ISLE", "state" : "WI", "county" : "VILAS" },
            "54558": { "city" : "SAINT GERMAIN", "state" : "WI", "county" : "VILAS" },
            "54559": { "city" : "SAXON", "state" : "WI", "county" : "IRON" },"54560": { "city" : "SAYNER", "state" : "WI", "county" : "VILAS" },
            "54561": { "city" : "STAR LAKE", "state" : "WI", "county" : "VILAS" },
            "54562": { "city" : "THREE LAKES", "state" : "WI", "county" : "ONEIDA" },
            "54563": { "city" : "TONY", "state" : "WI", "county" : "RUSK" },"54564": { "city" : "TRIPOLI", "state" : "WI", "county" : "ONEIDA" },
            "54565": { "city" : "UPSON", "state" : "WI", "county" : "IRON" },"54566": { "city" : "WABENO", "state" : "WI", "county" : "FOREST" },
            "54568": { "city" : "WOODRUFF", "state" : "WI", "county" : "ONEIDA" },
            "54601": { "city" : "LA CROSSE", "state" : "WI", "county" : "LA CROSSE" },
            "54602": { "city" : "LA CROSSE", "state" : "WI", "county" : "LA CROSSE" },
            "54603": { "city" : "LA CROSSE", "state" : "WI", "county" : "LA CROSSE" },
            "54610": { "city" : "ALMA", "state" : "WI", "county" : "BUFFALO" },"54611": { "city" : "ALMA CENTER", "state" : "WI", "county" : "JACKSON" },
            "54612": { "city" : "ARCADIA", "state" : "WI", "county" : "TREMPEALEAU" },
            "54613": { "city" : "ARKDALE", "state" : "WI", "county" : "ADAMS" },"54614": { "city" : "BANGOR", "state" : "WI", "county" : "LA CROSSE" },
            "54615": { "city" : "BLACK RIVER FALLS", "state" : "WI", "county" : "JACKSON" },
            "54616": { "city" : "BLAIR", "state" : "WI", "county" : "TREMPEALEAU" },
            "54618": { "city" : "CAMP DOUGLAS", "state" : "WI", "county" : "JUNEAU" },
            "54619": { "city" : "CASHTON", "state" : "WI", "county" : "MONROE" },
            "54621": { "city" : "CHASEBURG", "state" : "WI", "county" : "VERNON" },
            "54622": { "city" : "COCHRANE", "state" : "WI", "county" : "BUFFALO" },
            "54623": { "city" : "COON VALLEY", "state" : "WI", "county" : "VERNON" },
            "54624": { "city" : "DE SOTO", "state" : "WI", "county" : "VERNON" },
            "54625": { "city" : "DODGE", "state" : "WI", "county" : "TREMPEALEAU" },
            "54626": { "city" : "EASTMAN", "state" : "WI", "county" : "CRAWFORD" },
            "54627": { "city" : "ETTRICK", "state" : "WI", "county" : "TREMPEALEAU" },
            "54628": { "city" : "FERRYVILLE", "state" : "WI", "county" : "CRAWFORD" },
            "54629": { "city" : "FOUNTAIN CITY", "state" : "WI", "county" : "BUFFALO" },
            "54630": { "city" : "GALESVILLE", "state" : "WI", "county" : "TREMPEALEAU" },
            "54631": { "city" : "GAYS MILLS", "state" : "WI", "county" : "CRAWFORD" },
            "54632": { "city" : "GENOA", "state" : "WI", "county" : "VERNON" },"54634": { "city" : "HILLSBORO", "state" : "WI", "county" : "VERNON" },
            "54635": { "city" : "HIXTON", "state" : "WI", "county" : "JACKSON" },
            "54636": { "city" : "HOLMEN", "state" : "WI", "county" : "LA CROSSE" },
            "54637": { "city" : "HUSTLER", "state" : "WI", "county" : "JUNEAU" },
            "54638": { "city" : "KENDALL", "state" : "WI", "county" : "MONROE" },
            "54639": { "city" : "LA FARGE", "state" : "WI", "county" : "VERNON" },
            "54641": { "city" : "MATHER", "state" : "WI", "county" : "JUNEAU" },"54642": { "city" : "MELROSE", "state" : "WI", "county" : "JACKSON" },
            "54643": { "city" : "MILLSTON", "state" : "WI", "county" : "JACKSON" },
            "54644": { "city" : "MINDORO", "state" : "WI", "county" : "LA CROSSE" },
            "54645": { "city" : "MOUNT STERLING", "state" : "WI", "county" : "CRAWFORD" },
            "54646": { "city" : "NECEDAH", "state" : "WI", "county" : "JUNEAU" },
            "54648": { "city" : "NORWALK", "state" : "WI", "county" : "MONROE" },
            "54649": { "city" : "OAKDALE", "state" : "WI", "county" : "MONROE" },
            "54650": { "city" : "ONALASKA", "state" : "WI", "county" : "LA CROSSE" },
            "54651": { "city" : "ONTARIO", "state" : "WI", "county" : "VERNON" },
            "54652": { "city" : "READSTOWN", "state" : "WI", "county" : "VERNON" },
            "54653": { "city" : "ROCKLAND", "state" : "WI", "county" : "LA CROSSE" },
            "54654": { "city" : "SENECA", "state" : "WI", "county" : "CRAWFORD" },
            "54655": { "city" : "SOLDIERS GROVE", "state" : "WI", "county" : "CRAWFORD" },
            "54656": { "city" : "SPARTA", "state" : "WI", "county" : "MONROE" },"54657": { "city" : "STEUBEN", "state" : "WI", "county" : "CRAWFORD" },
            "54658": { "city" : "STODDARD", "state" : "WI", "county" : "VERNON" },
            "54659": { "city" : "TAYLOR", "state" : "WI", "county" : "JACKSON" },
            "54660": { "city" : "TOMAH", "state" : "WI", "county" : "MONROE" },"54661": { "city" : "TREMPEALEAU", "state" : "WI", "county" : "TREMPEALEAU" },
            "54664": { "city" : "VIOLA", "state" : "WI", "county" : "RICHLAND" },
            "54665": { "city" : "VIROQUA", "state" : "WI", "county" : "VERNON" },
            "54666": { "city" : "WARRENS", "state" : "WI", "county" : "MONROE" },
            "54667": { "city" : "WESTBY", "state" : "WI", "county" : "VERNON" },"54669": { "city" : "WEST SALEM", "state" : "WI", "county" : "LA CROSSE" },
            "54670": { "city" : "WILTON", "state" : "WI", "county" : "MONROE" },"54701": { "city" : "EAU CLAIRE", "state" : "WI", "county" : "EAU CLAIRE" },
            "54702": { "city" : "EAU CLAIRE", "state" : "WI", "county" : "EAU CLAIRE" },
            "54703": { "city" : "EAU CLAIRE", "state" : "WI", "county" : "EAU CLAIRE" },
            "54720": { "city" : "ALTOONA", "state" : "WI", "county" : "EAU CLAIRE" },
            "54721": { "city" : "ARKANSAW", "state" : "WI", "county" : "PEPIN" },
            "54722": { "city" : "AUGUSTA", "state" : "WI", "county" : "EAU CLAIRE" },
            "54723": { "city" : "BAY CITY", "state" : "WI", "county" : "PIERCE" },
            "54724": { "city" : "BLOOMER", "state" : "WI", "county" : "CHIPPEWA" },
            "54725": { "city" : "BOYCEVILLE", "state" : "WI", "county" : "DUNN" },
            "54726": { "city" : "BOYD", "state" : "WI", "county" : "CHIPPEWA" },"54727": { "city" : "CADOTT", "state" : "WI", "county" : "CHIPPEWA" },
            "54728": { "city" : "CHETEK", "state" : "WI", "county" : "BARRON" },"54729": { "city" : "CHIPPEWA FALLS", "state" : "WI", "county" : "CHIPPEWA" },
            "54730": { "city" : "COLFAX", "state" : "WI", "county" : "DUNN" },"54731": { "city" : "CONRATH", "state" : "WI", "county" : "RUSK" },
            "54732": { "city" : "CORNELL", "state" : "WI", "county" : "CHIPPEWA" },
            "54733": { "city" : "DALLAS", "state" : "WI", "county" : "BARRON" },"54734": { "city" : "DOWNING", "state" : "WI", "county" : "DUNN" },
            "54735": { "city" : "DOWNSVILLE", "state" : "WI", "county" : "DUNN" },
            "54736": { "city" : "DURAND", "state" : "WI", "county" : "PEPIN" },"54737": { "city" : "EAU GALLE", "state" : "WI", "county" : "DUNN" },
            "54738": { "city" : "ELEVA", "state" : "WI", "county" : "TREMPEALEAU" },
            "54739": { "city" : "ELK MOUND", "state" : "WI", "county" : "DUNN" },
            "54740": { "city" : "ELMWOOD", "state" : "WI", "county" : "PIERCE" },
            "54741": { "city" : "FAIRCHILD", "state" : "WI", "county" : "EAU CLAIRE" },
            "54742": { "city" : "FALL CREEK", "state" : "WI", "county" : "EAU CLAIRE" },
            "54743": { "city" : "GILMANTON", "state" : "WI", "county" : "BUFFALO" },
            "54745": { "city" : "HOLCOMBE", "state" : "WI", "county" : "CHIPPEWA" },
            "54746": { "city" : "HUMBIRD", "state" : "WI", "county" : "CLARK" },"54747": { "city" : "INDEPENDENCE", "state" : "WI", "county" : "TREMPEALEAU" },
            "54748": { "city" : "JIM FALLS", "state" : "WI", "county" : "CHIPPEWA" },
            "54749": { "city" : "KNAPP", "state" : "WI", "county" : "DUNN" },"54750": { "city" : "MAIDEN ROCK", "state" : "WI", "county" : "PIERCE" },
            "54751": { "city" : "MENOMONIE", "state" : "WI", "county" : "DUNN" },
            "54754": { "city" : "MERRILLAN", "state" : "WI", "county" : "JACKSON" },
            "54755": { "city" : "MONDOVI", "state" : "WI", "county" : "BUFFALO" },
            "54756": { "city" : "NELSON", "state" : "WI", "county" : "BUFFALO" },
            "54757": { "city" : "NEW AUBURN", "state" : "WI", "county" : "CHIPPEWA" },
            "54758": { "city" : "OSSEO", "state" : "WI", "county" : "TREMPEALEAU" },
            "54759": { "city" : "PEPIN", "state" : "WI", "county" : "PEPIN" },"54760": { "city" : "PIGEON FALLS", "state" : "WI", "county" : "TREMPEALEAU" },
            "54761": { "city" : "PLUM CITY", "state" : "WI", "county" : "PIERCE" },
            "54762": { "city" : "PRAIRIE FARM", "state" : "WI", "county" : "BARRON" },
            "54763": { "city" : "RIDGELAND", "state" : "WI", "county" : "DUNN" },
            "54764": { "city" : "ROCK FALLS", "state" : "WI", "county" : "DUNN" },
            "54765": { "city" : "SAND CREEK", "state" : "WI", "county" : "DUNN" },
            "54766": { "city" : "SHELDON", "state" : "WI", "county" : "RUSK" },"54767": { "city" : "SPRING VALLEY", "state" : "WI", "county" : "PIERCE" },
            "54768": { "city" : "STANLEY", "state" : "WI", "county" : "CHIPPEWA" },
            "54769": { "city" : "STOCKHOLM", "state" : "WI", "county" : "PEPIN" },
            "54770": { "city" : "STRUM", "state" : "WI", "county" : "TREMPEALEAU" },
            "54771": { "city" : "THORP", "state" : "WI", "county" : "CLARK" },"54772": { "city" : "WHEELER", "state" : "WI", "county" : "DUNN" },
            "54773": { "city" : "WHITEHALL", "state" : "WI", "county" : "TREMPEALEAU" },
            "54801": { "city" : "SPOONER", "state" : "WI", "county" : "WASHBURN" },
            "54805": { "city" : "ALMENA", "state" : "WI", "county" : "BARRON" },"54806": { "city" : "ASHLAND", "state" : "WI", "county" : "ASHLAND" },
            "54810": { "city" : "BALSAM LAKE", "state" : "WI", "county" : "POLK" },
            "54812": { "city" : "BARRON", "state" : "WI", "county" : "BARRON" },"54813": { "city" : "BARRONETT", "state" : "WI", "county" : "BARRON" },
            "54814": { "city" : "BAYFIELD", "state" : "WI", "county" : "BAYFIELD" },
            "54816": { "city" : "BENOIT", "state" : "WI", "county" : "BAYFIELD" },
            "54817": { "city" : "BIRCHWOOD", "state" : "WI", "county" : "WASHBURN" },
            "54818": { "city" : "BRILL", "state" : "WI", "county" : "BARRON" },"54819": { "city" : "BRUCE", "state" : "WI", "county" : "RUSK" },
            "54820": { "city" : "BRULE", "state" : "WI", "county" : "DOUGLAS" },"54821": { "city" : "CABLE", "state" : "WI", "county" : "BAYFIELD" },
            "54822": { "city" : "CAMERON", "state" : "WI", "county" : "BARRON" },
            "54824": { "city" : "CENTURIA", "state" : "WI", "county" : "POLK" },"54826": { "city" : "COMSTOCK", "state" : "WI", "county" : "BARRON" },
            "54827": { "city" : "CORNUCOPIA", "state" : "WI", "county" : "BAYFIELD" },
            "54828": { "city" : "COUDERAY", "state" : "WI", "county" : "SAWYER" },
            "54829": { "city" : "CUMBERLAND", "state" : "WI", "county" : "BARRON" },
            "54830": { "city" : "DANBURY", "state" : "WI", "county" : "BURNETT" },
            "54832": { "city" : "DRUMMOND", "state" : "WI", "county" : "BAYFIELD" },
            "54835": { "city" : "EXELAND", "state" : "WI", "county" : "SAWYER" },
            "54836": { "city" : "FOXBORO", "state" : "WI", "county" : "DOUGLAS" },
            "54837": { "city" : "FREDERIC", "state" : "WI", "county" : "POLK" },"54838": { "city" : "GORDON", "state" : "WI", "county" : "DOUGLAS" },
            "54839": { "city" : "GRAND VIEW", "state" : "WI", "county" : "BAYFIELD" },
            "54840": { "city" : "GRANTSBURG", "state" : "WI", "county" : "BURNETT" },
            "54841": { "city" : "HAUGEN", "state" : "WI", "county" : "BARRON" },"54842": { "city" : "HAWTHORNE", "state" : "WI", "county" : "DOUGLAS" },
            "54843": { "city" : "HAYWARD", "state" : "WI", "county" : "SAWYER" },
            "54844": { "city" : "HERBSTER", "state" : "WI", "county" : "BAYFIELD" },
            "54846": { "city" : "HIGH BRIDGE", "state" : "WI", "county" : "ASHLAND" },
            "54847": { "city" : "IRON RIVER", "state" : "WI", "county" : "BAYFIELD" },
            "54848": { "city" : "LADYSMITH", "state" : "WI", "county" : "RUSK" },
            "54849": { "city" : "LAKE NEBAGAMON", "state" : "WI", "county" : "DOUGLAS" },
            "54850": { "city" : "LA POINTE", "state" : "WI", "county" : "ASHLAND" },
            "54853": { "city" : "LUCK", "state" : "WI", "county" : "POLK" },"54854": { "city" : "MAPLE", "state" : "WI", "county" : "DOUGLAS" },
            "54855": { "city" : "MARENGO", "state" : "WI", "county" : "ASHLAND" },
            "54856": { "city" : "MASON", "state" : "WI", "county" : "BAYFIELD" },
            "54857": { "city" : "MIKANA", "state" : "WI", "county" : "BARRON" },"54858": { "city" : "MILLTOWN", "state" : "WI", "county" : "POLK" },
            "54859": { "city" : "MINONG", "state" : "WI", "county" : "WASHBURN" },
            "54861": { "city" : "ODANAH", "state" : "WI", "county" : "ASHLAND" },
            "54862": { "city" : "OJIBWA", "state" : "WI", "county" : "SAWYER" },"54864": { "city" : "POPLAR", "state" : "WI", "county" : "DOUGLAS" },
            "54865": { "city" : "PORT WING", "state" : "WI", "county" : "BAYFIELD" },
            "54867": { "city" : "RADISSON", "state" : "WI", "county" : "SAWYER" },
            "54868": { "city" : "RICE LAKE", "state" : "WI", "county" : "BARRON" },
            "54870": { "city" : "SARONA", "state" : "WI", "county" : "WASHBURN" },
            "54871": { "city" : "SHELL LAKE", "state" : "WI", "county" : "WASHBURN" },
            "54872": { "city" : "SIREN", "state" : "WI", "county" : "BURNETT" },"54873": { "city" : "SOLON SPRINGS", "state" : "WI", "county" : "DOUGLAS" },
            "54874": { "city" : "SOUTH RANGE", "state" : "WI", "county" : "DOUGLAS" },
            "54875": { "city" : "SPRINGBROOK", "state" : "WI", "county" : "WASHBURN" },
            "54876": { "city" : "STONE LAKE", "state" : "WI", "county" : "SAWYER" },
            "54880": { "city" : "SUPERIOR", "state" : "WI", "county" : "DOUGLAS" },
            "54888": { "city" : "TREGO", "state" : "WI", "county" : "WASHBURN" },
            "54889": { "city" : "TURTLE LAKE", "state" : "WI", "county" : "BARRON" },
            "54890": { "city" : "WASCOTT", "state" : "WI", "county" : "DOUGLAS" },
            "54891": { "city" : "WASHBURN", "state" : "WI", "county" : "BAYFIELD" },
            "54893": { "city" : "WEBSTER", "state" : "WI", "county" : "BURNETT" },
            "54895": { "city" : "WEYERHAEUSER", "state" : "WI", "county" : "RUSK" },
            "54896": { "city" : "WINTER", "state" : "WI", "county" : "SAWYER" },"54901": { "city" : "OSHKOSH", "state" : "WI", "county" : "WINNEBAGO" },
            "54902": { "city" : "OSHKOSH", "state" : "WI", "county" : "WINNEBAGO" },
            "54903": { "city" : "OSHKOSH", "state" : "WI", "county" : "WINNEBAGO" },
            "54904": { "city" : "OSHKOSH", "state" : "WI", "county" : "WINNEBAGO" },
            "54909": { "city" : "ALMOND", "state" : "WI", "county" : "PORTAGE" },
            "54911": { "city" : "APPLETON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54912": { "city" : "APPLETON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54913": { "city" : "APPLETON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54914": { "city" : "APPLETON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54915": { "city" : "APPLETON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54919": { "city" : "APPLETON", "state" : "WI", "county" : "OUTAGAMIE" },
            "54921": { "city" : "BANCROFT", "state" : "WI", "county" : "PORTAGE" },
            "54922": { "city" : "BEAR CREEK", "state" : "WI", "county" : "OUTAGAMIE" },
            "54923": { "city" : "BERLIN", "state" : "WI", "county" : "GREEN LAKE" },
            "54926": { "city" : "BIG FALLS", "state" : "WI", "county" : "WAUPACA" },
            "54927": { "city" : "BUTTE DES MORTS", "state" : "WI", "county" : "WINNEBAGO" },
            "54928": { "city" : "CAROLINE", "state" : "WI", "county" : "SHAWANO" },
            "54929": { "city" : "CLINTONVILLE", "state" : "WI", "county" : "WAUPACA" },
            "54930": { "city" : "COLOMA", "state" : "WI", "county" : "WAUSHARA" },
            "54931": { "city" : "DALE", "state" : "WI", "county" : "OUTAGAMIE" },
            "54932": { "city" : "ELDORADO", "state" : "WI", "county" : "FOND DU LAC" },
            "54933": { "city" : "EMBARRASS", "state" : "WI", "county" : "WAUPACA" },
            "54934": { "city" : "EUREKA", "state" : "WI", "county" : "WINNEBAGO" },
            "54935": { "city" : "FOND DU LAC", "state" : "WI", "county" : "FOND DU LAC" },
            "54936": { "city" : "FOND DU LAC", "state" : "WI", "county" : "FOND DU LAC" },
            "54937": { "city" : "FOND DU LAC", "state" : "WI", "county" : "FOND DU LAC" },
            "54940": { "city" : "FREMONT", "state" : "WI", "county" : "WAUPACA" },
            "54941": { "city" : "GREEN LAKE", "state" : "WI", "county" : "GREEN LAKE" },
            "54942": { "city" : "GREENVILLE", "state" : "WI", "county" : "OUTAGAMIE" },
            "54943": { "city" : "HANCOCK", "state" : "WI", "county" : "WAUSHARA" },
            "54944": { "city" : "HORTONVILLE", "state" : "WI", "county" : "OUTAGAMIE" },
            "54945": { "city" : "IOLA", "state" : "WI", "county" : "WAUPACA" },"54946": { "city" : "KING", "state" : "WI", "county" : "WAUPACA" },
            "54947": { "city" : "LARSEN", "state" : "WI", "county" : "WINNEBAGO" },
            "54948": { "city" : "LEOPOLIS", "state" : "WI", "county" : "SHAWANO" },
            "54949": { "city" : "MANAWA", "state" : "WI", "county" : "WAUPACA" },
            "54950": { "city" : "MARION", "state" : "WI", "county" : "WAUPACA" },
            "54952": { "city" : "MENASHA", "state" : "WI", "county" : "WINNEBAGO" },
            "54956": { "city" : "NEENAH", "state" : "WI", "county" : "WINNEBAGO" },
            "54957": { "city" : "NEENAH", "state" : "WI", "county" : "WINNEBAGO" },
            "54960": { "city" : "NESHKORO", "state" : "WI", "county" : "MARQUETTE" },
            "54961": { "city" : "NEW LONDON", "state" : "WI", "county" : "WAUPACA" },
            "54962": { "city" : "OGDENSBURG", "state" : "WI", "county" : "WAUPACA" },
            "54963": { "city" : "OMRO", "state" : "WI", "county" : "WINNEBAGO" },
            "54964": { "city" : "PICKETT", "state" : "WI", "county" : "WINNEBAGO" },
            "54965": { "city" : "PINE RIVER", "state" : "WI", "county" : "WAUSHARA" },
            "54966": { "city" : "PLAINFIELD", "state" : "WI", "county" : "WAUSHARA" },
            "54967": { "city" : "POY SIPPI", "state" : "WI", "county" : "WAUSHARA" },
            "54968": { "city" : "PRINCETON", "state" : "WI", "county" : "GREEN LAKE" },
            "54969": { "city" : "READFIELD", "state" : "WI", "county" : "WAUPACA" },
            "54970": { "city" : "REDGRANITE", "state" : "WI", "county" : "WAUSHARA" },
            "54971": { "city" : "RIPON", "state" : "WI", "county" : "FOND DU LAC" },
            "54974": { "city" : "ROSENDALE", "state" : "WI", "county" : "FOND DU LAC" },
            "54976": { "city" : "SAXEVILLE", "state" : "WI", "county" : "WAUSHARA" },
            "54977": { "city" : "SCANDINAVIA", "state" : "WI", "county" : "WAUPACA" },
            "54978": { "city" : "TILLEDA", "state" : "WI", "county" : "SHAWANO" },
            "54979": { "city" : "VAN DYNE", "state" : "WI", "county" : "FOND DU LAC" },
            "54980": { "city" : "WAUKAU", "state" : "WI", "county" : "WINNEBAGO" },
            "54981": { "city" : "WAUPACA", "state" : "WI", "county" : "WAUPACA" },
            "54982": { "city" : "WAUTOMA", "state" : "WI", "county" : "WAUSHARA" },
            "54983": { "city" : "WEYAUWEGA", "state" : "WI", "county" : "WAUPACA" },
            "54984": { "city" : "WILD ROSE", "state" : "WI", "county" : "WAUSHARA" },
            "54985": { "city" : "WINNEBAGO", "state" : "WI", "county" : "WINNEBAGO" },
            "54986": { "city" : "WINNECONNE", "state" : "WI", "county" : "WINNEBAGO" },
            "55001": { "city" : "AFTON", "state" : "MN", "county" : "WASHINGTON" },
            "55002": { "city" : "ALMELUND", "state" : "MN", "county" : "CHISAGO" },
            "55003": { "city" : "BAYPORT", "state" : "MN", "county" : "WASHINGTON" },
            "55005": { "city" : "BETHEL", "state" : "MN", "county" : "ANOKA" },"55006": { "city" : "BRAHAM", "state" : "MN", "county" : "ISANTI" },
            "55007": { "city" : "BROOK PARK", "state" : "MN", "county" : "PINE" },
            "55008": { "city" : "CAMBRIDGE", "state" : "MN", "county" : "ISANTI" },
            "55009": { "city" : "CANNON FALLS", "state" : "MN", "county" : "GOODHUE" },
            "55010": { "city" : "CASTLE ROCK", "state" : "MN", "county" : "DAKOTA" },
            "55011": { "city" : "CEDAR", "state" : "MN", "county" : "ANOKA" },"55012": { "city" : "CENTER CITY", "state" : "MN", "county" : "CHISAGO" },
            "55013": { "city" : "CHISAGO CITY", "state" : "MN", "county" : "CHISAGO" },
            "55014": { "city" : "CIRCLE PINES", "state" : "MN", "county" : "ANOKA" },
            "55016": { "city" : "COTTAGE GROVE", "state" : "MN", "county" : "WASHINGTON" },
            "55017": { "city" : "DALBO", "state" : "MN", "county" : "ISANTI" },"55018": { "city" : "DENNISON", "state" : "MN", "county" : "GOODHUE" },
            "55019": { "city" : "DUNDAS", "state" : "MN", "county" : "RICE" },"55020": { "city" : "ELKO", "state" : "MN", "county" : "SCOTT" },
            "55021": { "city" : "FARIBAULT", "state" : "MN", "county" : "RICE" },
            "55024": { "city" : "FARMINGTON", "state" : "MN", "county" : "DAKOTA" },
            "55025": { "city" : "FOREST LAKE", "state" : "MN", "county" : "WASHINGTON" },
            "55026": { "city" : "FRONTENAC", "state" : "MN", "county" : "GOODHUE" },
            "55027": { "city" : "GOODHUE", "state" : "MN", "county" : "GOODHUE" },
            "55029": { "city" : "GRANDY", "state" : "MN", "county" : "ISANTI" },"55030": { "city" : "GRASSTON", "state" : "MN", "county" : "PINE" },
            "55031": { "city" : "HAMPTON", "state" : "MN", "county" : "DAKOTA" },
            "55032": { "city" : "HARRIS", "state" : "MN", "county" : "CHISAGO" },
            "55033": { "city" : "HASTINGS", "state" : "MN", "county" : "DAKOTA" },
            "55036": { "city" : "HENRIETTE", "state" : "MN", "county" : "PINE" },
            "55037": { "city" : "HINCKLEY", "state" : "MN", "county" : "PINE" },"55038": { "city" : "HUGO", "state" : "MN", "county" : "WASHINGTON" },
            "55040": { "city" : "ISANTI", "state" : "MN", "county" : "ISANTI" },"55041": { "city" : "LAKE CITY", "state" : "MN", "county" : "WABASHA" },
            "55042": { "city" : "LAKE ELMO", "state" : "MN", "county" : "WASHINGTON" },
            "55043": { "city" : "LAKELAND", "state" : "MN", "county" : "WASHINGTON" },
            "55044": { "city" : "LAKEVILLE", "state" : "MN", "county" : "DAKOTA" },
            "55045": { "city" : "LINDSTROM", "state" : "MN", "county" : "CHISAGO" },
            "55046": { "city" : "LONSDALE", "state" : "MN", "county" : "RICE" },"55047": { "city" : "MARINE ON SAINT CROIX", "state" : "MN", "county" : "WASHINGTON" },
            "55049": { "city" : "MEDFORD", "state" : "MN", "county" : "STEELE" },
            "55051": { "city" : "MORA", "state" : "MN", "county" : "KANABEC" },"55052": { "city" : "MORRISTOWN", "state" : "MN", "county" : "RICE" },
            "55053": { "city" : "NERSTRAND", "state" : "MN", "county" : "RICE" },
            "55054": { "city" : "NEW MARKET", "state" : "MN", "county" : "SCOTT" },
            "55055": { "city" : "NEWPORT", "state" : "MN", "county" : "WASHINGTON" },
            "55056": { "city" : "NORTH BRANCH", "state" : "MN", "county" : "CHISAGO" },
            "55057": { "city" : "NORTHFIELD", "state" : "MN", "county" : "RICE" },
            "55060": { "city" : "OWATONNA", "state" : "MN", "county" : "STEELE" },
            "55063": { "city" : "PINE CITY", "state" : "MN", "county" : "PINE" },
            "55065": { "city" : "RANDOLPH", "state" : "MN", "county" : "DAKOTA" },
            "55066": { "city" : "RED WING", "state" : "MN", "county" : "GOODHUE" },
            "55067": { "city" : "ROCK CREEK", "state" : "MN", "county" : "PINE" },
            "55068": { "city" : "ROSEMOUNT", "state" : "MN", "county" : "DAKOTA" },
            "55069": { "city" : "RUSH CITY", "state" : "MN", "county" : "CHISAGO" },
            "55070": { "city" : "SAINT FRANCIS", "state" : "MN", "county" : "ANOKA" },
            "55071": { "city" : "SAINT PAUL PARK", "state" : "MN", "county" : "WASHINGTON" },
            "55072": { "city" : "SANDSTONE", "state" : "MN", "county" : "PINE" },
            "55073": { "city" : "SCANDIA", "state" : "MN", "county" : "WASHINGTON" },
            "55074": { "city" : "SHAFER", "state" : "MN", "county" : "CHISAGO" },
            "55075": { "city" : "SOUTH SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55076": { "city" : "INVER GROVE HEIGHTS", "state" : "MN", "county" : "DAKOTA" },
            "55077": { "city" : "INVER GROVE HEIGHTS", "state" : "MN", "county" : "DAKOTA" },
            "55078": { "city" : "STACY", "state" : "MN", "county" : "CHISAGO" },"55079": { "city" : "STACY", "state" : "MN", "county" : "CHISAGO" },
            "55080": { "city" : "STANCHFIELD", "state" : "MN", "county" : "ISANTI" },
            "55082": { "city" : "STILLWATER", "state" : "MN", "county" : "WASHINGTON" },
            "55084": { "city" : "TAYLORS FALLS", "state" : "MN", "county" : "CHISAGO" },
            "55085": { "city" : "VERMILLION", "state" : "MN", "county" : "DAKOTA" },
            "55087": { "city" : "WARSAW", "state" : "MN", "county" : "RICE" },"55088": { "city" : "WEBSTER", "state" : "MN", "county" : "RICE" },
            "55089": { "city" : "WELCH", "state" : "MN", "county" : "GOODHUE" },"55090": { "city" : "WILLERNIE", "state" : "MN", "county" : "WASHINGTON" },
            "55092": { "city" : "WYOMING", "state" : "MN", "county" : "CHISAGO" },
            "55101": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55102": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55103": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55104": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55105": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55106": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55107": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55108": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55109": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55110": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55111": { "city" : "SAINT PAUL", "state" : "MN", "county" : "HENNEPIN" },
            "55112": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55113": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55114": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55115": { "city" : "SAINT PAUL", "state" : "MN", "county" : "WASHINGTON" },
            "55116": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55117": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55118": { "city" : "SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55119": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55120": { "city" : "SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55121": { "city" : "SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55122": { "city" : "SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55123": { "city" : "SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55124": { "city" : "SAINT PAUL", "state" : "MN", "county" : "DAKOTA" },
            "55125": { "city" : "SAINT PAUL", "state" : "MN", "county" : "WASHINGTON" },
            "55126": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55127": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55128": { "city" : "SAINT PAUL", "state" : "MN", "county" : "WASHINGTON" },
            "55129": { "city" : "SAINT PAUL", "state" : "MN", "county" : "WASHINGTON" },
            "55130": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55133": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55144": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55146": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55150": { "city" : "MENDOTA", "state" : "MN", "county" : "DAKOTA" },
            "55155": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55164": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55165": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55170": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55175": { "city" : "SAINT PAUL", "state" : "MN", "county" : "RAMSEY" },
            "55301": { "city" : "ALBERTVILLE", "state" : "MN", "county" : "WRIGHT" },
            "55302": { "city" : "ANNANDALE", "state" : "MN", "county" : "WRIGHT" },
            "55303": { "city" : "ANOKA", "state" : "MN", "county" : "ANOKA" },"55304": { "city" : "ANDOVER", "state" : "MN", "county" : "ANOKA" },
            "55305": { "city" : "HOPKINS", "state" : "MN", "county" : "HENNEPIN" },
            "55306": { "city" : "BURNSVILLE", "state" : "MN", "county" : "DAKOTA" },
            "55307": { "city" : "ARLINGTON", "state" : "MN", "county" : "SIBLEY" },
            "55308": { "city" : "BECKER", "state" : "MN", "county" : "SHERBURNE" },
            "55309": { "city" : "BIG LAKE", "state" : "MN", "county" : "SHERBURNE" },
            "55310": { "city" : "BIRD ISLAND", "state" : "MN", "county" : "RENVILLE" },
            "55311": { "city" : "OSSEO", "state" : "MN", "county" : "HENNEPIN" },
            "55312": { "city" : "BROWNTON", "state" : "MN", "county" : "MCLEOD" },
            "55313": { "city" : "BUFFALO", "state" : "MN", "county" : "WRIGHT" },
            "55314": { "city" : "BUFFALO LAKE", "state" : "MN", "county" : "RENVILLE" },
            "55315": { "city" : "CARVER", "state" : "MN", "county" : "CARVER" },"55316": { "city" : "CHAMPLIN", "state" : "MN", "county" : "HENNEPIN" },
            "55317": { "city" : "CHANHASSEN", "state" : "MN", "county" : "CARVER" },
            "55318": { "city" : "CHASKA", "state" : "MN", "county" : "CARVER" },"55319": { "city" : "CLEAR LAKE", "state" : "MN", "county" : "SHERBURNE" },
            "55320": { "city" : "CLEARWATER", "state" : "MN", "county" : "WRIGHT" },
            "55321": { "city" : "COKATO", "state" : "MN", "county" : "WRIGHT" },"55322": { "city" : "COLOGNE", "state" : "MN", "county" : "CARVER" },
            "55323": { "city" : "CRYSTAL BAY", "state" : "MN", "county" : "HENNEPIN" },
            "55324": { "city" : "DARWIN", "state" : "MN", "county" : "MEEKER" },"55325": { "city" : "DASSEL", "state" : "MN", "county" : "MEEKER" },
            "55327": { "city" : "DAYTON", "state" : "MN", "county" : "HENNEPIN" },
            "55328": { "city" : "DELANO", "state" : "MN", "county" : "WRIGHT" },"55329": { "city" : "EDEN VALLEY", "state" : "MN", "county" : "MEEKER" },
            "55330": { "city" : "ELK RIVER", "state" : "MN", "county" : "SHERBURNE" },
            "55331": { "city" : "EXCELSIOR", "state" : "MN", "county" : "HENNEPIN" },
            "55332": { "city" : "FAIRFAX", "state" : "MN", "county" : "RENVILLE" },
            "55333": { "city" : "FRANKLIN", "state" : "MN", "county" : "RENVILLE" },
            "55334": { "city" : "GAYLORD", "state" : "MN", "county" : "SIBLEY" },
            "55335": { "city" : "GIBBON", "state" : "MN", "county" : "SIBLEY" },"55336": { "city" : "GLENCOE", "state" : "MN", "county" : "MCLEOD" },
            "55337": { "city" : "BURNSVILLE", "state" : "MN", "county" : "DAKOTA" },
            "55338": { "city" : "GREEN ISLE", "state" : "MN", "county" : "SIBLEY" },
            "55339": { "city" : "HAMBURG", "state" : "MN", "county" : "CARVER" },
            "55340": { "city" : "HAMEL", "state" : "MN", "county" : "HENNEPIN" },
            "55341": { "city" : "HANOVER", "state" : "MN", "county" : "WRIGHT" },
            "55342": { "city" : "HECTOR", "state" : "MN", "county" : "RENVILLE" },
            "55343": { "city" : "HOPKINS", "state" : "MN", "county" : "HENNEPIN" },
            "55344": { "city" : "EDEN PRAIRIE", "state" : "MN", "county" : "HENNEPIN" },
            "55345": { "city" : "MINNETONKA", "state" : "MN", "county" : "HENNEPIN" },
            "55346": { "city" : "EDEN PRAIRIE", "state" : "MN", "county" : "HENNEPIN" },
            "55347": { "city" : "EDEN PRAIRIE", "state" : "MN", "county" : "HENNEPIN" },
            "55348": { "city" : "MAPLE PLAIN", "state" : "MN", "county" : "HENNEPIN" },
            "55349": { "city" : "HOWARD LAKE", "state" : "MN", "county" : "WRIGHT" },
            "55350": { "city" : "HUTCHINSON", "state" : "MN", "county" : "MCLEOD" },
            "55352": { "city" : "JORDAN", "state" : "MN", "county" : "SCOTT" },"55353": { "city" : "KIMBALL", "state" : "MN", "county" : "STEARNS" },
            "55354": { "city" : "LESTER PRAIRIE", "state" : "MN", "county" : "MCLEOD" },
            "55355": { "city" : "LITCHFIELD", "state" : "MN", "county" : "MEEKER" },
            "55356": { "city" : "LONG LAKE", "state" : "MN", "county" : "HENNEPIN" },
            "55357": { "city" : "LORETTO", "state" : "MN", "county" : "HENNEPIN" },
            "55358": { "city" : "MAPLE LAKE", "state" : "MN", "county" : "WRIGHT" },
            "55359": { "city" : "MAPLE PLAIN", "state" : "MN", "county" : "HENNEPIN" },
            "55360": { "city" : "MAYER", "state" : "MN", "county" : "CARVER" },"55361": { "city" : "MINNETONKA BEACH", "state" : "MN", "county" : "HENNEPIN" },
            "55362": { "city" : "MONTICELLO", "state" : "MN", "county" : "WRIGHT" },
            "55363": { "city" : "MONTROSE", "state" : "MN", "county" : "WRIGHT" },
            "55364": { "city" : "MOUND", "state" : "MN", "county" : "HENNEPIN" },
            "55366": { "city" : "NEW AUBURN", "state" : "MN", "county" : "SIBLEY" },
            "55367": { "city" : "NEW GERMANY", "state" : "MN", "county" : "CARVER" },
            "55368": { "city" : "NORWOOD YOUNG AMERICA", "state" : "MN", "county" : "CARVER" },
            "55369": { "city" : "OSSEO", "state" : "MN", "county" : "HENNEPIN" },
            "55370": { "city" : "PLATO", "state" : "MN", "county" : "MCLEOD" },"55371": { "city" : "PRINCETON", "state" : "MN", "county" : "MILLE LACS" },
            "55372": { "city" : "PRIOR LAKE", "state" : "MN", "county" : "SCOTT" },
            "55373": { "city" : "ROCKFORD", "state" : "MN", "county" : "WRIGHT" },
            "55374": { "city" : "ROGERS", "state" : "MN", "county" : "HENNEPIN" },
            "55375": { "city" : "SAINT BONIFACIUS", "state" : "MN", "county" : "HENNEPIN" },
            "55376": { "city" : "SAINT MICHAEL", "state" : "MN", "county" : "WRIGHT" },
            "55377": { "city" : "SANTIAGO", "state" : "MN", "county" : "SHERBURNE" },
            "55378": { "city" : "SAVAGE", "state" : "MN", "county" : "SCOTT" },"55379": { "city" : "SHAKOPEE", "state" : "MN", "county" : "SCOTT" },
            "55381": { "city" : "SILVER LAKE", "state" : "MN", "county" : "MCLEOD" },
            "55382": { "city" : "SOUTH HAVEN", "state" : "MN", "county" : "WRIGHT" },
            "55384": { "city" : "SPRING PARK", "state" : "MN", "county" : "HENNEPIN" },
            "55385": { "city" : "STEWART", "state" : "MN", "county" : "MCLEOD" },
            "55386": { "city" : "VICTORIA", "state" : "MN", "county" : "CARVER" },
            "55387": { "city" : "WACONIA", "state" : "MN", "county" : "CARVER" },
            "55388": { "city" : "WATERTOWN", "state" : "MN", "county" : "CARVER" },
            "55389": { "city" : "WATKINS", "state" : "MN", "county" : "MEEKER" },
            "55390": { "city" : "WAVERLY", "state" : "MN", "county" : "WRIGHT" },
            "55391": { "city" : "WAYZATA", "state" : "MN", "county" : "HENNEPIN" },
            "55392": { "city" : "NAVARRE", "state" : "MN", "county" : "HENNEPIN" },
            "55395": { "city" : "WINSTED", "state" : "MN", "county" : "MCLEOD" },
            "55396": { "city" : "WINTHROP", "state" : "MN", "county" : "SIBLEY" },
            "55397": { "city" : "YOUNG AMERICA", "state" : "MN", "county" : "CARVER" },
            "55398": { "city" : "ZIMMERMAN", "state" : "MN", "county" : "SHERBURNE" },
            "55401": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55402": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55403": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55404": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55405": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55406": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55407": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55408": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55409": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55410": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55411": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55412": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55413": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55414": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55415": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55416": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55417": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55418": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55419": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55420": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55421": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "ANOKA" },
            "55422": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55423": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55424": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55425": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55426": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55427": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55428": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55429": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55430": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55431": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55432": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "ANOKA" },
            "55433": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "ANOKA" },
            "55434": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "ANOKA" },
            "55435": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55436": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55437": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55438": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55439": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55440": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55441": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55442": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55443": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55444": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55445": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55446": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55447": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55448": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "ANOKA" },
            "55449": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "ANOKA" },
            "55450": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55454": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55455": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55458": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55459": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55467": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55472": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55474": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55479": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55480": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55485": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55486": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55487": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55488": { "city" : "MINNEAPOLIS", "state" : "MN", "county" : "HENNEPIN" },
            "55572": { "city" : "ROCKFORD", "state" : "MN", "county" : "HENNEPIN" },
            "55601": { "city" : "BEAVER BAY", "state" : "MN", "county" : "LAKE" },
            "55602": { "city" : "BRIMSON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55603": { "city" : "FINLAND", "state" : "MN", "county" : "LAKE" },"55604": { "city" : "GRAND MARAIS", "state" : "MN", "county" : "COOK" },
            "55605": { "city" : "GRAND PORTAGE", "state" : "MN", "county" : "COOK" },
            "55606": { "city" : "HOVLAND", "state" : "MN", "county" : "COOK" },"55607": { "city" : "ISABELLA", "state" : "MN", "county" : "LAKE" },
            "55609": { "city" : "KNIFE RIVER", "state" : "MN", "county" : "LAKE" },
            "55612": { "city" : "LUTSEN", "state" : "MN", "county" : "COOK" },"55613": { "city" : "SCHROEDER", "state" : "MN", "county" : "COOK" },
            "55614": { "city" : "SILVER BAY", "state" : "MN", "county" : "LAKE" },
            "55615": { "city" : "TOFTE", "state" : "MN", "county" : "COOK" },"55616": { "city" : "TWO HARBORS", "state" : "MN", "county" : "LAKE" },
            "55701": { "city" : "ADOLPH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55702": { "city" : "ALBORN", "state" : "MN", "county" : "SAINT LOUIS" },
            "55703": { "city" : "ANGORA", "state" : "MN", "county" : "SAINT LOUIS" },
            "55704": { "city" : "ASKOV", "state" : "MN", "county" : "PINE" },"55705": { "city" : "AURORA", "state" : "MN", "county" : "SAINT LOUIS" },
            "55706": { "city" : "BABBITT", "state" : "MN", "county" : "SAINT LOUIS" },
            "55707": { "city" : "BARNUM", "state" : "MN", "county" : "CARLTON" },
            "55708": { "city" : "BIWABIK", "state" : "MN", "county" : "SAINT LOUIS" },
            "55709": { "city" : "BOVEY", "state" : "MN", "county" : "ITASCA" },"55710": { "city" : "BRITT", "state" : "MN", "county" : "SAINT LOUIS" },
            "55711": { "city" : "BROOKSTON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55712": { "city" : "BRUNO", "state" : "MN", "county" : "PINE" },"55713": { "city" : "BUHL", "state" : "MN", "county" : "SAINT LOUIS" },
            "55716": { "city" : "CALUMET", "state" : "MN", "county" : "ITASCA" },
            "55717": { "city" : "CANYON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55718": { "city" : "CARLTON", "state" : "MN", "county" : "CARLTON" },
            "55719": { "city" : "CHISHOLM", "state" : "MN", "county" : "SAINT LOUIS" },
            "55720": { "city" : "CLOQUET", "state" : "MN", "county" : "CARLTON" },
            "55721": { "city" : "COHASSET", "state" : "MN", "county" : "ITASCA" },
            "55722": { "city" : "COLERAINE", "state" : "MN", "county" : "ITASCA" },
            "55723": { "city" : "COOK", "state" : "MN", "county" : "SAINT LOUIS" },
            "55724": { "city" : "COTTON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55725": { "city" : "CRANE LAKE", "state" : "MN", "county" : "SAINT LOUIS" },
            "55726": { "city" : "CROMWELL", "state" : "MN", "county" : "CARLTON" },
            "55730": { "city" : "GRAND RAPIDS", "state" : "MN", "county" : "ITASCA" },
            "55731": { "city" : "ELY", "state" : "MN", "county" : "SAINT LOUIS" },
            "55732": { "city" : "EMBARRASS", "state" : "MN", "county" : "SAINT LOUIS" },
            "55733": { "city" : "ESKO", "state" : "MN", "county" : "CARLTON" },"55734": { "city" : "EVELETH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55735": { "city" : "FINLAYSON", "state" : "MN", "county" : "PINE" },
            "55736": { "city" : "FLOODWOOD", "state" : "MN", "county" : "SAINT LOUIS" },
            "55738": { "city" : "FORBES", "state" : "MN", "county" : "SAINT LOUIS" },
            "55741": { "city" : "GILBERT", "state" : "MN", "county" : "SAINT LOUIS" },
            "55742": { "city" : "GOODLAND", "state" : "MN", "county" : "ITASCA" },
            "55744": { "city" : "GRAND RAPIDS", "state" : "MN", "county" : "ITASCA" },
            "55746": { "city" : "HIBBING", "state" : "MN", "county" : "SAINT LOUIS" },
            "55748": { "city" : "HILL CITY", "state" : "MN", "county" : "AITKIN" },
            "55749": { "city" : "HOLYOKE", "state" : "MN", "county" : "CARLTON" },
            "55750": { "city" : "HOYT LAKES", "state" : "MN", "county" : "SAINT LOUIS" },
            "55751": { "city" : "IRON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55752": { "city" : "JACOBSON", "state" : "MN", "county" : "ITASCA" },
            "55753": { "city" : "KEEWATIN", "state" : "MN", "county" : "ITASCA" },
            "55756": { "city" : "KERRICK", "state" : "MN", "county" : "PINE" },"55757": { "city" : "KETTLE RIVER", "state" : "MN", "county" : "CARLTON" },
            "55758": { "city" : "KINNEY", "state" : "MN", "county" : "SAINT LOUIS" },
            "55760": { "city" : "MCGREGOR", "state" : "MN", "county" : "AITKIN" },
            "55763": { "city" : "MAKINEN", "state" : "MN", "county" : "SAINT LOUIS" },
            "55764": { "city" : "MARBLE", "state" : "MN", "county" : "ITASCA" },"55765": { "city" : "MEADOWLANDS", "state" : "MN", "county" : "SAINT LOUIS" },
            "55767": { "city" : "MOOSE LAKE", "state" : "MN", "county" : "CARLTON" },
            "55768": { "city" : "MOUNTAIN IRON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55769": { "city" : "NASHWAUK", "state" : "MN", "county" : "ITASCA" },
            "55771": { "city" : "ORR", "state" : "MN", "county" : "SAINT LOUIS" },
            "55775": { "city" : "PENGILLY", "state" : "MN", "county" : "ITASCA" },
            "55777": { "city" : "VIRGINIA", "state" : "MN", "county" : "SAINT LOUIS" },
            "55779": { "city" : "SAGINAW", "state" : "MN", "county" : "SAINT LOUIS" },
            "55780": { "city" : "SAWYER", "state" : "MN", "county" : "CARLTON" },
            "55781": { "city" : "SIDE LAKE", "state" : "MN", "county" : "SAINT LOUIS" },
            "55782": { "city" : "SOUDAN", "state" : "MN", "county" : "SAINT LOUIS" },
            "55783": { "city" : "STURGEON LAKE", "state" : "MN", "county" : "PINE" },
            "55784": { "city" : "SWAN RIVER", "state" : "MN", "county" : "ITASCA" },
            "55785": { "city" : "SWATARA", "state" : "MN", "county" : "CASS" },"55786": { "city" : "TACONITE", "state" : "MN", "county" : "ITASCA" },
            "55787": { "city" : "TAMARACK", "state" : "MN", "county" : "AITKIN" },
            "55790": { "city" : "TOWER", "state" : "MN", "county" : "SAINT LOUIS" },
            "55791": { "city" : "TWIG", "state" : "MN", "county" : "SAINT LOUIS" },
            "55792": { "city" : "VIRGINIA", "state" : "MN", "county" : "SAINT LOUIS" },
            "55793": { "city" : "WARBA", "state" : "MN", "county" : "ITASCA" },"55795": { "city" : "WILLOW RIVER", "state" : "MN", "county" : "PINE" },
            "55796": { "city" : "WINTON", "state" : "MN", "county" : "SAINT LOUIS" },
            "55797": { "city" : "WRENSHALL", "state" : "MN", "county" : "CARLTON" },
            "55798": { "city" : "WRIGHT", "state" : "MN", "county" : "CARLTON" },
            "55801": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55802": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55803": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55804": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55805": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55806": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55807": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55808": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55810": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55811": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55812": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55814": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55815": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55816": { "city" : "DULUTH", "state" : "MN", "county" : "SAINT LOUIS" },
            "55901": { "city" : "ROCHESTER", "state" : "MN", "county" : "OLMSTED" },
            "55902": { "city" : "ROCHESTER", "state" : "MN", "county" : "OLMSTED" },
            "55903": { "city" : "ROCHESTER", "state" : "MN", "county" : "OLMSTED" },
            "55904": { "city" : "ROCHESTER", "state" : "MN", "county" : "OLMSTED" },
            "55905": { "city" : "ROCHESTER", "state" : "MN", "county" : "OLMSTED" },
            "55906": { "city" : "ROCHESTER", "state" : "MN", "county" : "OLMSTED" },
            "55909": { "city" : "ADAMS", "state" : "MN", "county" : "MOWER" },"55910": { "city" : "ALTURA", "state" : "MN", "county" : "WINONA" },
            "55912": { "city" : "AUSTIN", "state" : "MN", "county" : "MOWER" },"55917": { "city" : "BLOOMING PRAIRIE", "state" : "MN", "county" : "STEELE" },
            "55918": { "city" : "BROWNSDALE", "state" : "MN", "county" : "MOWER" },
            "55919": { "city" : "BROWNSVILLE", "state" : "MN", "county" : "HOUSTON" },
            "55920": { "city" : "BYRON", "state" : "MN", "county" : "OLMSTED" },"55921": { "city" : "CALEDONIA", "state" : "MN", "county" : "HOUSTON" },
            "55922": { "city" : "CANTON", "state" : "MN", "county" : "FILLMORE" },
            "55923": { "city" : "CHATFIELD", "state" : "MN", "county" : "FILLMORE" },
            "55924": { "city" : "CLAREMONT", "state" : "MN", "county" : "DODGE" },
            "55925": { "city" : "DAKOTA", "state" : "MN", "county" : "WINONA" },"55926": { "city" : "DEXTER", "state" : "MN", "county" : "MOWER" },
            "55927": { "city" : "DODGE CENTER", "state" : "MN", "county" : "DODGE" },
            "55929": { "city" : "DOVER", "state" : "MN", "county" : "OLMSTED" },"55931": { "city" : "EITZEN", "state" : "MN", "county" : "HOUSTON" },
            "55932": { "city" : "ELGIN", "state" : "MN", "county" : "WABASHA" },"55933": { "city" : "ELKTON", "state" : "MN", "county" : "MOWER" },
            "55934": { "city" : "EYOTA", "state" : "MN", "county" : "OLMSTED" },"55935": { "city" : "FOUNTAIN", "state" : "MN", "county" : "FILLMORE" },
            "55936": { "city" : "GRAND MEADOW", "state" : "MN", "county" : "MOWER" },
            "55939": { "city" : "HARMONY", "state" : "MN", "county" : "FILLMORE" },
            "55940": { "city" : "HAYFIELD", "state" : "MN", "county" : "DODGE" },
            "55941": { "city" : "HOKAH", "state" : "MN", "county" : "HOUSTON" },"55942": { "city" : "HOMER", "state" : "MN", "county" : "WINONA" },
            "55943": { "city" : "HOUSTON", "state" : "MN", "county" : "HOUSTON" },
            "55944": { "city" : "KASSON", "state" : "MN", "county" : "DODGE" },"55945": { "city" : "KELLOGG", "state" : "MN", "county" : "WABASHA" },
            "55946": { "city" : "KENYON", "state" : "MN", "county" : "GOODHUE" },
            "55947": { "city" : "LA CRESCENT", "state" : "MN", "county" : "HOUSTON" },
            "55949": { "city" : "LANESBORO", "state" : "MN", "county" : "FILLMORE" },
            "55950": { "city" : "LANSING", "state" : "MN", "county" : "MOWER" },"55951": { "city" : "LE ROY", "state" : "MN", "county" : "MOWER" },
            "55952": { "city" : "LEWISTON", "state" : "MN", "county" : "WINONA" },
            "55953": { "city" : "LYLE", "state" : "MN", "county" : "MOWER" },"55954": { "city" : "MABEL", "state" : "MN", "county" : "FILLMORE" },
            "55955": { "city" : "MANTORVILLE", "state" : "MN", "county" : "DODGE" },
            "55956": { "city" : "MAZEPPA", "state" : "MN", "county" : "WABASHA" },
            "55957": { "city" : "MILLVILLE", "state" : "MN", "county" : "WABASHA" },
            "55959": { "city" : "MINNESOTA CITY", "state" : "MN", "county" : "WINONA" },
            "55960": { "city" : "ORONOCO", "state" : "MN", "county" : "OLMSTED" },
            "55961": { "city" : "OSTRANDER", "state" : "MN", "county" : "FILLMORE" },
            "55962": { "city" : "PETERSON", "state" : "MN", "county" : "FILLMORE" },
            "55963": { "city" : "PINE ISLAND", "state" : "MN", "county" : "GOODHUE" },
            "55964": { "city" : "PLAINVIEW", "state" : "MN", "county" : "WABASHA" },
            "55965": { "city" : "PRESTON", "state" : "MN", "county" : "FILLMORE" },
            "55967": { "city" : "RACINE", "state" : "MN", "county" : "MOWER" },"55969": { "city" : "ROLLINGSTONE", "state" : "MN", "county" : "WINONA" },
            "55970": { "city" : "ROSE CREEK", "state" : "MN", "county" : "MOWER" },
            "55971": { "city" : "RUSHFORD", "state" : "MN", "county" : "FILLMORE" },
            "55972": { "city" : "SAINT CHARLES", "state" : "MN", "county" : "WINONA" },
            "55973": { "city" : "SARGEANT", "state" : "MN", "county" : "MOWER" },
            "55974": { "city" : "SPRING GROVE", "state" : "MN", "county" : "HOUSTON" },
            "55975": { "city" : "SPRING VALLEY", "state" : "MN", "county" : "FILLMORE" },
            "55976": { "city" : "STEWARTVILLE", "state" : "MN", "county" : "OLMSTED" },
            "55977": { "city" : "TAOPI", "state" : "MN", "county" : "MOWER" },"55979": { "city" : "UTICA", "state" : "MN", "county" : "WINONA" },
            "55981": { "city" : "WABASHA", "state" : "MN", "county" : "WABASHA" },
            "55982": { "city" : "WALTHAM", "state" : "MN", "county" : "MOWER" },"55983": { "city" : "WANAMINGO", "state" : "MN", "county" : "GOODHUE" },
            "55985": { "city" : "WEST CONCORD", "state" : "MN", "county" : "DODGE" },
            "55987": { "city" : "WINONA", "state" : "MN", "county" : "WINONA" },"55988": { "city" : "STOCKTON", "state" : "MN", "county" : "WINONA" },
            "55990": { "city" : "WYKOFF", "state" : "MN", "county" : "FILLMORE" },
            "55991": { "city" : "ZUMBRO FALLS", "state" : "MN", "county" : "WABASHA" },
            "55992": { "city" : "ZUMBROTA", "state" : "MN", "county" : "GOODHUE" },
            "56001": { "city" : "MANKATO", "state" : "MN", "county" : "BLUE EARTH" },
            "56002": { "city" : "MANKATO", "state" : "MN", "county" : "BLUE EARTH" },
            "56003": { "city" : "MANKATO", "state" : "MN", "county" : "NICOLLET" },
            "56007": { "city" : "ALBERT LEA", "state" : "MN", "county" : "FREEBORN" },
            "56009": { "city" : "ALDEN", "state" : "MN", "county" : "FREEBORN" },
            "56010": { "city" : "AMBOY", "state" : "MN", "county" : "BLUE EARTH" },
            "56011": { "city" : "BELLE PLAINE", "state" : "MN", "county" : "SCOTT" },
            "56013": { "city" : "BLUE EARTH", "state" : "MN", "county" : "FARIBAULT" },
            "56014": { "city" : "BRICELYN", "state" : "MN", "county" : "FARIBAULT" },
            "56016": { "city" : "CLARKS GROVE", "state" : "MN", "county" : "FREEBORN" },
            "56017": { "city" : "CLEVELAND", "state" : "MN", "county" : "LE SUEUR" },
            "56019": { "city" : "COMFREY", "state" : "MN", "county" : "BROWN" },"56020": { "city" : "CONGER", "state" : "MN", "county" : "FREEBORN" },
            "56021": { "city" : "COURTLAND", "state" : "MN", "county" : "NICOLLET" },
            "56022": { "city" : "DARFUR", "state" : "MN", "county" : "WATONWAN" },
            "56023": { "city" : "DELAVAN", "state" : "MN", "county" : "FARIBAULT" },
            "56024": { "city" : "EAGLE LAKE", "state" : "MN", "county" : "BLUE EARTH" },
            "56025": { "city" : "EASTON", "state" : "MN", "county" : "FARIBAULT" },
            "56026": { "city" : "ELLENDALE", "state" : "MN", "county" : "STEELE" },
            "56027": { "city" : "ELMORE", "state" : "MN", "county" : "FARIBAULT" },
            "56028": { "city" : "ELYSIAN", "state" : "MN", "county" : "LE SUEUR" },
            "56029": { "city" : "EMMONS", "state" : "MN", "county" : "FREEBORN" },
            "56030": { "city" : "ESSIG", "state" : "MN", "county" : "BROWN" },"56031": { "city" : "FAIRMONT", "state" : "MN", "county" : "MARTIN" },
            "56032": { "city" : "FREEBORN", "state" : "MN", "county" : "FREEBORN" },
            "56033": { "city" : "FROST", "state" : "MN", "county" : "FARIBAULT" },
            "56034": { "city" : "GARDEN CITY", "state" : "MN", "county" : "BLUE EARTH" },
            "56035": { "city" : "GENEVA", "state" : "MN", "county" : "FREEBORN" },
            "56036": { "city" : "GLENVILLE", "state" : "MN", "county" : "FREEBORN" },
            "56037": { "city" : "GOOD THUNDER", "state" : "MN", "county" : "BLUE EARTH" },
            "56039": { "city" : "GRANADA", "state" : "MN", "county" : "MARTIN" },
            "56041": { "city" : "HANSKA", "state" : "MN", "county" : "BROWN" },"56042": { "city" : "HARTLAND", "state" : "MN", "county" : "FREEBORN" },
            "56043": { "city" : "HAYWARD", "state" : "MN", "county" : "FREEBORN" },
            "56044": { "city" : "HENDERSON", "state" : "MN", "county" : "SIBLEY" },
            "56045": { "city" : "HOLLANDALE", "state" : "MN", "county" : "FREEBORN" },
            "56046": { "city" : "HOPE", "state" : "MN", "county" : "STEELE" },"56047": { "city" : "HUNTLEY", "state" : "MN", "county" : "FARIBAULT" },
            "56048": { "city" : "JANESVILLE", "state" : "MN", "county" : "WASECA" },
            "56050": { "city" : "KASOTA", "state" : "MN", "county" : "LE SUEUR" },
            "56051": { "city" : "KIESTER", "state" : "MN", "county" : "FARIBAULT" },
            "56052": { "city" : "KILKENNY", "state" : "MN", "county" : "RICE" },"56054": { "city" : "LAFAYETTE", "state" : "MN", "county" : "NICOLLET" },
            "56055": { "city" : "LAKE CRYSTAL", "state" : "MN", "county" : "BLUE EARTH" },
            "56056": { "city" : "LA SALLE", "state" : "MN", "county" : "WATONWAN" },
            "56057": { "city" : "LE CENTER", "state" : "MN", "county" : "LE SUEUR" },
            "56058": { "city" : "LE SUEUR", "state" : "MN", "county" : "LE SUEUR" },
            "56060": { "city" : "LEWISVILLE", "state" : "MN", "county" : "WATONWAN" },
            "56062": { "city" : "MADELIA", "state" : "MN", "county" : "WATONWAN" },
            "56063": { "city" : "MADISON LAKE", "state" : "MN", "county" : "BLUE EARTH" },
            "56065": { "city" : "MAPLETON", "state" : "MN", "county" : "BLUE EARTH" },
            "56068": { "city" : "MINNESOTA LAKE", "state" : "MN", "county" : "FARIBAULT" },
            "56069": { "city" : "MONTGOMERY", "state" : "MN", "county" : "LE SUEUR" },
            "56071": { "city" : "NEW PRAGUE", "state" : "MN", "county" : "SCOTT" },
            "56072": { "city" : "NEW RICHLAND", "state" : "MN", "county" : "WASECA" },
            "56073": { "city" : "NEW ULM", "state" : "MN", "county" : "BROWN" },"56074": { "city" : "NICOLLET", "state" : "MN", "county" : "NICOLLET" },
            "56075": { "city" : "NORTHROP", "state" : "MN", "county" : "MARTIN" },
            "56078": { "city" : "PEMBERTON", "state" : "MN", "county" : "BLUE EARTH" },
            "56080": { "city" : "SAINT CLAIR", "state" : "MN", "county" : "BLUE EARTH" },
            "56081": { "city" : "SAINT JAMES", "state" : "MN", "county" : "WATONWAN" },
            "56082": { "city" : "SAINT PETER", "state" : "MN", "county" : "NICOLLET" },
            "56083": { "city" : "SANBORN", "state" : "MN", "county" : "REDWOOD" },
            "56085": { "city" : "SLEEPY EYE", "state" : "MN", "county" : "BROWN" },
            "56087": { "city" : "SPRINGFIELD", "state" : "MN", "county" : "BROWN" },
            "56088": { "city" : "TRUMAN", "state" : "MN", "county" : "MARTIN" },"56089": { "city" : "TWIN LAKES", "state" : "MN", "county" : "FREEBORN" },
            "56090": { "city" : "VERNON CENTER", "state" : "MN", "county" : "BLUE EARTH" },
            "56091": { "city" : "WALDORF", "state" : "MN", "county" : "WASECA" },
            "56093": { "city" : "WASECA", "state" : "MN", "county" : "WASECA" },"56096": { "city" : "WATERVILLE", "state" : "MN", "county" : "LE SUEUR" },
            "56097": { "city" : "WELLS", "state" : "MN", "county" : "FARIBAULT" },
            "56098": { "city" : "WINNEBAGO", "state" : "MN", "county" : "FARIBAULT" },
            "56101": { "city" : "WINDOM", "state" : "MN", "county" : "COTTONWOOD" },
            "56110": { "city" : "ADRIAN", "state" : "MN", "county" : "NOBLES" },"56111": { "city" : "ALPHA", "state" : "MN", "county" : "JACKSON" },
            "56113": { "city" : "ARCO", "state" : "MN", "county" : "LINCOLN" },"56114": { "city" : "AVOCA", "state" : "MN", "county" : "MURRAY" },
            "56115": { "city" : "BALATON", "state" : "MN", "county" : "LYON" },"56116": { "city" : "BEAVER CREEK", "state" : "MN", "county" : "ROCK" },
            "56117": { "city" : "BIGELOW", "state" : "MN", "county" : "NOBLES" },
            "56118": { "city" : "BINGHAM LAKE", "state" : "MN", "county" : "COTTONWOOD" },
            "56119": { "city" : "BREWSTER", "state" : "MN", "county" : "NOBLES" },
            "56120": { "city" : "BUTTERFIELD", "state" : "MN", "county" : "WATONWAN" },
            "56121": { "city" : "CEYLON", "state" : "MN", "county" : "MARTIN" },"56122": { "city" : "CHANDLER", "state" : "MN", "county" : "MURRAY" },
            "56123": { "city" : "CURRIE", "state" : "MN", "county" : "MURRAY" },"56125": { "city" : "DOVRAY", "state" : "MN", "county" : "MURRAY" },
            "56127": { "city" : "DUNNELL", "state" : "MN", "county" : "MARTIN" },
            "56128": { "city" : "EDGERTON", "state" : "MN", "county" : "PIPESTONE" },
            "56129": { "city" : "ELLSWORTH", "state" : "MN", "county" : "NOBLES" },
            "56131": { "city" : "FULDA", "state" : "MN", "county" : "MURRAY" },"56132": { "city" : "GARVIN", "state" : "MN", "county" : "LYON" },
            "56134": { "city" : "HARDWICK", "state" : "MN", "county" : "ROCK" },"56136": { "city" : "HENDRICKS", "state" : "MN", "county" : "LINCOLN" },
            "56137": { "city" : "HERON LAKE", "state" : "MN", "county" : "JACKSON" },
            "56138": { "city" : "HILLS", "state" : "MN", "county" : "ROCK" },"56139": { "city" : "HOLLAND", "state" : "MN", "county" : "PIPESTONE" },
            "56140": { "city" : "IHLEN", "state" : "MN", "county" : "PIPESTONE" },
            "56141": { "city" : "IONA", "state" : "MN", "county" : "MURRAY" },"56142": { "city" : "IVANHOE", "state" : "MN", "county" : "LINCOLN" },
            "56143": { "city" : "JACKSON", "state" : "MN", "county" : "JACKSON" },
            "56144": { "city" : "JASPER", "state" : "MN", "county" : "ROCK" },"56145": { "city" : "JEFFERS", "state" : "MN", "county" : "COTTONWOOD" },
            "56146": { "city" : "KANARANZI", "state" : "MN", "county" : "NOBLES" },
            "56147": { "city" : "KENNETH", "state" : "MN", "county" : "ROCK" },"56149": { "city" : "LAKE BENTON", "state" : "MN", "county" : "LINCOLN" },
            "56150": { "city" : "LAKEFIELD", "state" : "MN", "county" : "JACKSON" },
            "56151": { "city" : "LAKE WILSON", "state" : "MN", "county" : "MURRAY" },
            "56152": { "city" : "LAMBERTON", "state" : "MN", "county" : "REDWOOD" },
            "56153": { "city" : "LEOTA", "state" : "MN", "county" : "NOBLES" },"56155": { "city" : "LISMORE", "state" : "MN", "county" : "NOBLES" },
            "56156": { "city" : "LUVERNE", "state" : "MN", "county" : "ROCK" },"56157": { "city" : "LYND", "state" : "MN", "county" : "LYON" },
            "56158": { "city" : "MAGNOLIA", "state" : "MN", "county" : "ROCK" },"56159": { "city" : "MOUNTAIN LAKE", "state" : "MN", "county" : "COTTONWOOD" },
            "56160": { "city" : "ODIN", "state" : "MN", "county" : "WATONWAN" },"56161": { "city" : "OKABENA", "state" : "MN", "county" : "JACKSON" },
            "56162": { "city" : "ORMSBY", "state" : "MN", "county" : "MARTIN" },"56164": { "city" : "PIPESTONE", "state" : "MN", "county" : "PIPESTONE" },
            "56165": { "city" : "READING", "state" : "MN", "county" : "NOBLES" },
            "56166": { "city" : "REVERE", "state" : "MN", "county" : "REDWOOD" },
            "56167": { "city" : "ROUND LAKE", "state" : "MN", "county" : "NOBLES" },
            "56168": { "city" : "RUSHMORE", "state" : "MN", "county" : "NOBLES" },
            "56169": { "city" : "RUSSELL", "state" : "MN", "county" : "LYON" },"56170": { "city" : "RUTHTON", "state" : "MN", "county" : "PIPESTONE" },
            "56171": { "city" : "SHERBURN", "state" : "MN", "county" : "MARTIN" },
            "56172": { "city" : "SLAYTON", "state" : "MN", "county" : "MURRAY" },
            "56173": { "city" : "STEEN", "state" : "MN", "county" : "ROCK" },"56174": { "city" : "STORDEN", "state" : "MN", "county" : "COTTONWOOD" },
            "56175": { "city" : "TRACY", "state" : "MN", "county" : "LYON" },"56176": { "city" : "TRIMONT", "state" : "MN", "county" : "MARTIN" },
            "56178": { "city" : "TYLER", "state" : "MN", "county" : "LINCOLN" },"56180": { "city" : "WALNUT GROVE", "state" : "MN", "county" : "REDWOOD" },
            "56181": { "city" : "WELCOME", "state" : "MN", "county" : "MARTIN" },
            "56183": { "city" : "WESTBROOK", "state" : "MN", "county" : "COTTONWOOD" },
            "56185": { "city" : "WILMONT", "state" : "MN", "county" : "NOBLES" },
            "56186": { "city" : "WOODSTOCK", "state" : "MN", "county" : "PIPESTONE" },
            "56187": { "city" : "WORTHINGTON", "state" : "MN", "county" : "NOBLES" },
            "56201": { "city" : "WILLMAR", "state" : "MN", "county" : "KANDIYOHI" },
            "56207": { "city" : "ALBERTA", "state" : "MN", "county" : "STEVENS" },
            "56208": { "city" : "APPLETON", "state" : "MN", "county" : "SWIFT" },
            "56209": { "city" : "ATWATER", "state" : "MN", "county" : "KANDIYOHI" },
            "56210": { "city" : "BARRY", "state" : "MN", "county" : "BIG STONE" },
            "56211": { "city" : "BEARDSLEY", "state" : "MN", "county" : "BIG STONE" },
            "56212": { "city" : "BELLINGHAM", "state" : "MN", "county" : "LAC QUI PARLE" },
            "56214": { "city" : "BELVIEW", "state" : "MN", "county" : "REDWOOD" },
            "56215": { "city" : "BENSON", "state" : "MN", "county" : "SWIFT" },"56216": { "city" : "BLOMKEST", "state" : "MN", "county" : "KANDIYOHI" },
            "56218": { "city" : "BOYD", "state" : "MN", "county" : "LAC QUI PARLE" },
            "56219": { "city" : "BROWNS VALLEY", "state" : "MN", "county" : "TRAVERSE" },
            "56220": { "city" : "CANBY", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56221": { "city" : "CHOKIO", "state" : "MN", "county" : "STEVENS" },
            "56222": { "city" : "CLARA CITY", "state" : "MN", "county" : "CHIPPEWA" },
            "56223": { "city" : "CLARKFIELD", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56224": { "city" : "CLEMENTS", "state" : "MN", "county" : "REDWOOD" },
            "56225": { "city" : "CLINTON", "state" : "MN", "county" : "BIG STONE" },
            "56226": { "city" : "CLONTARF", "state" : "MN", "county" : "SWIFT" },
            "56227": { "city" : "CORRELL", "state" : "MN", "county" : "BIG STONE" },
            "56228": { "city" : "COSMOS", "state" : "MN", "county" : "MEEKER" },"56229": { "city" : "COTTONWOOD", "state" : "MN", "county" : "LYON" },
            "56230": { "city" : "DANUBE", "state" : "MN", "county" : "RENVILLE" },
            "56231": { "city" : "DANVERS", "state" : "MN", "county" : "SWIFT" },"56232": { "city" : "DAWSON", "state" : "MN", "county" : "LAC QUI PARLE" },
            "56235": { "city" : "DONNELLY", "state" : "MN", "county" : "STEVENS" },
            "56236": { "city" : "DUMONT", "state" : "MN", "county" : "TRAVERSE" },
            "56237": { "city" : "ECHO", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56239": { "city" : "GHENT", "state" : "MN", "county" : "LYON" },"56240": { "city" : "GRACEVILLE", "state" : "MN", "county" : "BIG STONE" },
            "56241": { "city" : "GRANITE FALLS", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56243": { "city" : "GROVE CITY", "state" : "MN", "county" : "MEEKER" },
            "56244": { "city" : "HANCOCK", "state" : "MN", "county" : "STEVENS" },
            "56245": { "city" : "HANLEY FALLS", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56248": { "city" : "HERMAN", "state" : "MN", "county" : "GRANT" },"56249": { "city" : "HOLLOWAY", "state" : "MN", "county" : "SWIFT" },
            "56251": { "city" : "KANDIYOHI", "state" : "MN", "county" : "KANDIYOHI" },
            "56252": { "city" : "KERKHOVEN", "state" : "MN", "county" : "SWIFT" },
            "56253": { "city" : "LAKE LILLIAN", "state" : "MN", "county" : "KANDIYOHI" },
            "56255": { "city" : "LUCAN", "state" : "MN", "county" : "REDWOOD" },"56256": { "city" : "MADISON", "state" : "MN", "county" : "LAC QUI PARLE" },
            "56257": { "city" : "MARIETTA", "state" : "MN", "county" : "LAC QUI PARLE" },
            "56258": { "city" : "MARSHALL", "state" : "MN", "county" : "LYON" },"56260": { "city" : "MAYNARD", "state" : "MN", "county" : "CHIPPEWA" },
            "56262": { "city" : "MILAN", "state" : "MN", "county" : "CHIPPEWA" },
            "56263": { "city" : "MILROY", "state" : "MN", "county" : "REDWOOD" },
            "56264": { "city" : "MINNEOTA", "state" : "MN", "county" : "LYON" },"56265": { "city" : "MONTEVIDEO", "state" : "MN", "county" : "CHIPPEWA" },
            "56266": { "city" : "MORGAN", "state" : "MN", "county" : "REDWOOD" },
            "56267": { "city" : "MORRIS", "state" : "MN", "county" : "STEVENS" },
            "56270": { "city" : "MORTON", "state" : "MN", "county" : "RENVILLE" },
            "56271": { "city" : "MURDOCK", "state" : "MN", "county" : "SWIFT" },"56273": { "city" : "NEW LONDON", "state" : "MN", "county" : "KANDIYOHI" },
            "56274": { "city" : "NORCROSS", "state" : "MN", "county" : "GRANT" },
            "56276": { "city" : "ODESSA", "state" : "MN", "county" : "BIG STONE" },
            "56277": { "city" : "OLIVIA", "state" : "MN", "county" : "RENVILLE" },
            "56278": { "city" : "ORTONVILLE", "state" : "MN", "county" : "BIG STONE" },
            "56279": { "city" : "PENNOCK", "state" : "MN", "county" : "KANDIYOHI" },
            "56280": { "city" : "PORTER", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56281": { "city" : "PRINSBURG", "state" : "MN", "county" : "KANDIYOHI" },
            "56282": { "city" : "RAYMOND", "state" : "MN", "county" : "KANDIYOHI" },
            "56283": { "city" : "REDWOOD FALLS", "state" : "MN", "county" : "REDWOOD" },
            "56284": { "city" : "RENVILLE", "state" : "MN", "county" : "RENVILLE" },
            "56285": { "city" : "SACRED HEART", "state" : "MN", "county" : "RENVILLE" },
            "56287": { "city" : "SEAFORTH", "state" : "MN", "county" : "REDWOOD" },
            "56288": { "city" : "SPICER", "state" : "MN", "county" : "KANDIYOHI" },
            "56289": { "city" : "SUNBURG", "state" : "MN", "county" : "KANDIYOHI" },
            "56291": { "city" : "TAUNTON", "state" : "MN", "county" : "LYON" },"56292": { "city" : "VESTA", "state" : "MN", "county" : "REDWOOD" },
            "56293": { "city" : "WABASSO", "state" : "MN", "county" : "REDWOOD" },
            "56294": { "city" : "WANDA", "state" : "MN", "county" : "REDWOOD" },"56295": { "city" : "WATSON", "state" : "MN", "county" : "CHIPPEWA" },
            "56296": { "city" : "WHEATON", "state" : "MN", "county" : "TRAVERSE" },
            "56297": { "city" : "WOOD LAKE", "state" : "MN", "county" : "YELLOW MEDICINE" },
            "56301": { "city" : "SAINT CLOUD", "state" : "MN", "county" : "STEARNS" },
            "56302": { "city" : "SAINT CLOUD", "state" : "MN", "county" : "STEARNS" },
            "56303": { "city" : "SAINT CLOUD", "state" : "MN", "county" : "STEARNS" },
            "56304": { "city" : "SAINT CLOUD", "state" : "MN", "county" : "BENTON" },
            "56307": { "city" : "ALBANY", "state" : "MN", "county" : "STEARNS" },
            "56308": { "city" : "ALEXANDRIA", "state" : "MN", "county" : "DOUGLAS" },
            "56309": { "city" : "ASHBY", "state" : "MN", "county" : "GRANT" },"56310": { "city" : "AVON", "state" : "MN", "county" : "STEARNS" },
            "56311": { "city" : "BARRETT", "state" : "MN", "county" : "GRANT" },"56312": { "city" : "BELGRADE", "state" : "MN", "county" : "STEARNS" },
            "56313": { "city" : "BOCK", "state" : "MN", "county" : "MILLE LACS" },
            "56314": { "city" : "BOWLUS", "state" : "MN", "county" : "MORRISON" },
            "56315": { "city" : "BRANDON", "state" : "MN", "county" : "DOUGLAS" },
            "56316": { "city" : "BROOTEN", "state" : "MN", "county" : "STEARNS" },
            "56317": { "city" : "BUCKMAN", "state" : "MN", "county" : "MORRISON" },
            "56318": { "city" : "BURTRUM", "state" : "MN", "county" : "TODD" },"56319": { "city" : "CARLOS", "state" : "MN", "county" : "DOUGLAS" },
            "56320": { "city" : "COLD SPRING", "state" : "MN", "county" : "STEARNS" },
            "56321": { "city" : "COLLEGEVILLE", "state" : "MN", "county" : "STEARNS" },
            "56323": { "city" : "CYRUS", "state" : "MN", "county" : "POPE" },"56324": { "city" : "DALTON", "state" : "MN", "county" : "OTTER TAIL" },
            "56325": { "city" : "ELROSA", "state" : "MN", "county" : "STEARNS" },
            "56326": { "city" : "EVANSVILLE", "state" : "MN", "county" : "DOUGLAS" },
            "56327": { "city" : "FARWELL", "state" : "MN", "county" : "DOUGLAS" },
            "56328": { "city" : "FLENSBURG", "state" : "MN", "county" : "MORRISON" },
            "56329": { "city" : "FOLEY", "state" : "MN", "county" : "BENTON" },"56330": { "city" : "FORESTON", "state" : "MN", "county" : "MILLE LACS" },
            "56331": { "city" : "FREEPORT", "state" : "MN", "county" : "STEARNS" },
            "56332": { "city" : "GARFIELD", "state" : "MN", "county" : "DOUGLAS" },
            "56333": { "city" : "GILMAN", "state" : "MN", "county" : "BENTON" },"56334": { "city" : "GLENWOOD", "state" : "MN", "county" : "POPE" },
            "56335": { "city" : "GREENWALD", "state" : "MN", "county" : "STEARNS" },
            "56336": { "city" : "GREY EAGLE", "state" : "MN", "county" : "TODD" },
            "56338": { "city" : "HILLMAN", "state" : "MN", "county" : "MORRISON" },
            "56339": { "city" : "HOFFMAN", "state" : "MN", "county" : "GRANT" },"56340": { "city" : "HOLDINGFORD", "state" : "MN", "county" : "STEARNS" },
            "56341": { "city" : "HOLMES CITY", "state" : "MN", "county" : "DOUGLAS" },
            "56342": { "city" : "ISLE", "state" : "MN", "county" : "MILLE LACS" },
            "56343": { "city" : "KENSINGTON", "state" : "MN", "county" : "DOUGLAS" },
            "56344": { "city" : "LASTRUP", "state" : "MN", "county" : "MORRISON" },
            "56345": { "city" : "LITTLE FALLS", "state" : "MN", "county" : "MORRISON" },
            "56347": { "city" : "LONG PRAIRIE", "state" : "MN", "county" : "TODD" },
            "56349": { "city" : "LOWRY", "state" : "MN", "county" : "POPE" },"56350": { "city" : "MC GRATH", "state" : "MN", "county" : "AITKIN" },
            "56352": { "city" : "MELROSE", "state" : "MN", "county" : "STEARNS" },
            "56353": { "city" : "MILACA", "state" : "MN", "county" : "MILLE LACS" },
            "56354": { "city" : "MILTONA", "state" : "MN", "county" : "DOUGLAS" },
            "56355": { "city" : "NELSON", "state" : "MN", "county" : "DOUGLAS" },
            "56356": { "city" : "NEW MUNICH", "state" : "MN", "county" : "STEARNS" },
            "56357": { "city" : "OAK PARK", "state" : "MN", "county" : "BENTON" },
            "56358": { "city" : "OGILVIE", "state" : "MN", "county" : "KANABEC" },
            "56359": { "city" : "ONAMIA", "state" : "MN", "county" : "MILLE LACS" },
            "56360": { "city" : "OSAKIS", "state" : "MN", "county" : "DOUGLAS" },
            "56361": { "city" : "PARKERS PRAIRIE", "state" : "MN", "county" : "OTTER TAIL" },
            "56362": { "city" : "PAYNESVILLE", "state" : "MN", "county" : "STEARNS" },
            "56363": { "city" : "PEASE", "state" : "MN", "county" : "MILLE LACS" },
            "56364": { "city" : "PIERZ", "state" : "MN", "county" : "MORRISON" },
            "56367": { "city" : "RICE", "state" : "MN", "county" : "BENTON" },"56368": { "city" : "RICHMOND", "state" : "MN", "county" : "STEARNS" },
            "56369": { "city" : "ROCKVILLE", "state" : "MN", "county" : "STEARNS" },
            "56371": { "city" : "ROSCOE", "state" : "MN", "county" : "STEARNS" },
            "56372": { "city" : "SAINT CLOUD", "state" : "MN", "county" : "STEARNS" },
            "56373": { "city" : "ROYALTON", "state" : "MN", "county" : "MORRISON" },
            "56374": { "city" : "SAINT JOSEPH", "state" : "MN", "county" : "STEARNS" },
            "56375": { "city" : "SAINT STEPHEN", "state" : "MN", "county" : "STEARNS" },
            "56376": { "city" : "SAINT MARTIN", "state" : "MN", "county" : "STEARNS" },
            "56377": { "city" : "SARTELL", "state" : "MN", "county" : "STEARNS" },
            "56378": { "city" : "SAUK CENTRE", "state" : "MN", "county" : "STEARNS" },
            "56379": { "city" : "SAUK RAPIDS", "state" : "MN", "county" : "BENTON" },
            "56381": { "city" : "STARBUCK", "state" : "MN", "county" : "POPE" },"56382": { "city" : "SWANVILLE", "state" : "MN", "county" : "MORRISON" },
            "56384": { "city" : "UPSALA", "state" : "MN", "county" : "MORRISON" },
            "56385": { "city" : "VILLARD", "state" : "MN", "county" : "POPE" },"56386": { "city" : "WAHKON", "state" : "MN", "county" : "MILLE LACS" },
            "56387": { "city" : "WAITE PARK", "state" : "MN", "county" : "STEARNS" },
            "56389": { "city" : "WEST UNION", "state" : "MN", "county" : "TODD" },
            "56401": { "city" : "BRAINERD", "state" : "MN", "county" : "CROW WING" },
            "56425": { "city" : "BAXTER", "state" : "MN", "county" : "CROW WING" },
            "56431": { "city" : "AITKIN", "state" : "MN", "county" : "AITKIN" },"56433": { "city" : "AKELEY", "state" : "MN", "county" : "HUBBARD" },
            "56434": { "city" : "ALDRICH", "state" : "MN", "county" : "WADENA" },
            "56435": { "city" : "BACKUS", "state" : "MN", "county" : "CASS" },"56436": { "city" : "BENEDICT", "state" : "MN", "county" : "HUBBARD" },
            "56437": { "city" : "BERTHA", "state" : "MN", "county" : "TODD" },"56438": { "city" : "BROWERVILLE", "state" : "MN", "county" : "TODD" },
            "56440": { "city" : "CLARISSA", "state" : "MN", "county" : "TODD" },"56441": { "city" : "CROSBY", "state" : "MN", "county" : "CROW WING" },
            "56442": { "city" : "CROSSLAKE", "state" : "MN", "county" : "CROW WING" },
            "56443": { "city" : "CUSHING", "state" : "MN", "county" : "MORRISON" },
            "56444": { "city" : "DEERWOOD", "state" : "MN", "county" : "CROW WING" },
            "56446": { "city" : "EAGLE BEND", "state" : "MN", "county" : "TODD" },
            "56447": { "city" : "EMILY", "state" : "MN", "county" : "CROW WING" },
            "56448": { "city" : "FIFTY LAKES", "state" : "MN", "county" : "CROW WING" },
            "56449": { "city" : "FORT RIPLEY", "state" : "MN", "county" : "CROW WING" },
            "56450": { "city" : "GARRISON", "state" : "MN", "county" : "CROW WING" },
            "56452": { "city" : "HACKENSACK", "state" : "MN", "county" : "CASS" },
            "56453": { "city" : "HEWITT", "state" : "MN", "county" : "TODD" },"56455": { "city" : "IRONTON", "state" : "MN", "county" : "CROW WING" },
            "56456": { "city" : "JENKINS", "state" : "MN", "county" : "CROW WING" },
            "56458": { "city" : "LAKE GEORGE", "state" : "MN", "county" : "HUBBARD" },
            "56461": { "city" : "LAPORTE", "state" : "MN", "county" : "HUBBARD" },
            "56464": { "city" : "MENAHGA", "state" : "MN", "county" : "WADENA" },
            "56465": { "city" : "MERRIFIELD", "state" : "MN", "county" : "CROW WING" },
            "56466": { "city" : "MOTLEY", "state" : "MN", "county" : "MORRISON" },
            "56467": { "city" : "NEVIS", "state" : "MN", "county" : "HUBBARD" },"56468": { "city" : "NISSWA", "state" : "MN", "county" : "CROW WING" },
            "56469": { "city" : "PALISADE", "state" : "MN", "county" : "AITKIN" },
            "56470": { "city" : "PARK RAPIDS", "state" : "MN", "county" : "HUBBARD" },
            "56472": { "city" : "PEQUOT LAKES", "state" : "MN", "county" : "CROW WING" },
            "56473": { "city" : "PILLAGER", "state" : "MN", "county" : "CASS" },"56474": { "city" : "PINE RIVER", "state" : "MN", "county" : "CASS" },
            "56475": { "city" : "RANDALL", "state" : "MN", "county" : "MORRISON" },
            "56477": { "city" : "SEBEKA", "state" : "MN", "county" : "WADENA" },"56478": { "city" : "NIMROD", "state" : "MN", "county" : "WADENA" },
            "56479": { "city" : "STAPLES", "state" : "MN", "county" : "TODD" },"56481": { "city" : "VERNDALE", "state" : "MN", "county" : "WADENA" },
            "56482": { "city" : "WADENA", "state" : "MN", "county" : "WADENA" },"56484": { "city" : "WALKER", "state" : "MN", "county" : "CASS" },
            "56501": { "city" : "DETROIT LAKES", "state" : "MN", "county" : "BECKER" },
            "56502": { "city" : "DETROIT LAKES", "state" : "MN", "county" : "BECKER" },
            "56510": { "city" : "ADA", "state" : "MN", "county" : "NORMAN" },"56511": { "city" : "AUDUBON", "state" : "MN", "county" : "BECKER" },
            "56514": { "city" : "BARNESVILLE", "state" : "MN", "county" : "CLAY" },
            "56515": { "city" : "BATTLE LAKE", "state" : "MN", "county" : "OTTER TAIL" },
            "56516": { "city" : "BEJOU", "state" : "MN", "county" : "MAHNOMEN" },
            "56517": { "city" : "BELTRAMI", "state" : "MN", "county" : "POLK" },"56518": { "city" : "BLUFFTON", "state" : "MN", "county" : "OTTER TAIL" },
            "56519": { "city" : "BORUP", "state" : "MN", "county" : "NORMAN" },"56520": { "city" : "BRECKENRIDGE", "state" : "MN", "county" : "WILKIN" },
            "56521": { "city" : "CALLAWAY", "state" : "MN", "county" : "BECKER" },
            "56522": { "city" : "CAMPBELL", "state" : "MN", "county" : "WILKIN" },
            "56523": { "city" : "CLIMAX", "state" : "MN", "county" : "POLK" },"56524": { "city" : "CLITHERALL", "state" : "MN", "county" : "OTTER TAIL" },
            "56525": { "city" : "COMSTOCK", "state" : "MN", "county" : "CLAY" },"56527": { "city" : "DEER CREEK", "state" : "MN", "county" : "OTTER TAIL" },
            "56528": { "city" : "DENT", "state" : "MN", "county" : "OTTER TAIL" },
            "56529": { "city" : "DILWORTH", "state" : "MN", "county" : "CLAY" },"56531": { "city" : "ELBOW LAKE", "state" : "MN", "county" : "GRANT" },
            "56533": { "city" : "ELIZABETH", "state" : "MN", "county" : "OTTER TAIL" },
            "56534": { "city" : "ERHARD", "state" : "MN", "county" : "OTTER TAIL" },
            "56535": { "city" : "ERSKINE", "state" : "MN", "county" : "POLK" },"56536": { "city" : "FELTON", "state" : "MN", "county" : "CLAY" },
            "56537": { "city" : "FERGUS FALLS", "state" : "MN", "county" : "OTTER TAIL" },
            "56538": { "city" : "FERGUS FALLS", "state" : "MN", "county" : "OTTER TAIL" },
            "56540": { "city" : "FERTILE", "state" : "MN", "county" : "POLK" },"56541": { "city" : "FLOM", "state" : "MN", "county" : "NORMAN" },
            "56542": { "city" : "FOSSTON", "state" : "MN", "county" : "POLK" },"56543": { "city" : "FOXHOME", "state" : "MN", "county" : "WILKIN" },
            "56544": { "city" : "FRAZEE", "state" : "MN", "county" : "BECKER" },"56545": { "city" : "GARY", "state" : "MN", "county" : "NORMAN" },
            "56546": { "city" : "GEORGETOWN", "state" : "MN", "county" : "CLAY" },
            "56547": { "city" : "GLYNDON", "state" : "MN", "county" : "CLAY" },"56548": { "city" : "HALSTAD", "state" : "MN", "county" : "NORMAN" },
            "56549": { "city" : "HAWLEY", "state" : "MN", "county" : "CLAY" },"56550": { "city" : "HENDRUM", "state" : "MN", "county" : "NORMAN" },
            "56551": { "city" : "HENNING", "state" : "MN", "county" : "OTTER TAIL" },
            "56552": { "city" : "HITTERDAL", "state" : "MN", "county" : "CLAY" },
            "56553": { "city" : "KENT", "state" : "MN", "county" : "WILKIN" },"56554": { "city" : "LAKE PARK", "state" : "MN", "county" : "BECKER" },
            "56556": { "city" : "MCINTOSH", "state" : "MN", "county" : "POLK" },"56557": { "city" : "MAHNOMEN", "state" : "MN", "county" : "MAHNOMEN" },
            "56560": { "city" : "MOORHEAD", "state" : "MN", "county" : "CLAY" },"56561": { "city" : "MOORHEAD", "state" : "MN", "county" : "CLAY" },
            "56562": { "city" : "MOORHEAD", "state" : "MN", "county" : "CLAY" },"56563": { "city" : "MOORHEAD", "state" : "MN", "county" : "CLAY" },
            "56565": { "city" : "NASHUA", "state" : "MN", "county" : "WILKIN" },"56566": { "city" : "NAYTAHWAUSH", "state" : "MN", "county" : "MAHNOMEN" },
            "56567": { "city" : "NEW YORK MILLS", "state" : "MN", "county" : "OTTER TAIL" },
            "56568": { "city" : "NIELSVILLE", "state" : "MN", "county" : "POLK" },
            "56569": { "city" : "OGEMA", "state" : "MN", "county" : "BECKER" },"56570": { "city" : "OSAGE", "state" : "MN", "county" : "BECKER" },
            "56571": { "city" : "OTTERTAIL", "state" : "MN", "county" : "OTTER TAIL" },
            "56572": { "city" : "PELICAN RAPIDS", "state" : "MN", "county" : "OTTER TAIL" },
            "56573": { "city" : "PERHAM", "state" : "MN", "county" : "OTTER TAIL" },
            "56574": { "city" : "PERLEY", "state" : "MN", "county" : "NORMAN" },"56575": { "city" : "PONSFORD", "state" : "MN", "county" : "BECKER" },
            "56576": { "city" : "RICHVILLE", "state" : "MN", "county" : "OTTER TAIL" },
            "56577": { "city" : "RICHWOOD", "state" : "MN", "county" : "BECKER" },
            "56578": { "city" : "ROCHERT", "state" : "MN", "county" : "BECKER" },
            "56579": { "city" : "ROTHSAY", "state" : "MN", "county" : "WILKIN" },
            "56580": { "city" : "SABIN", "state" : "MN", "county" : "CLAY" },"56581": { "city" : "SHELLY", "state" : "MN", "county" : "NORMAN" },
            "56583": { "city" : "TINTAH", "state" : "MN", "county" : "TRAVERSE" },
            "56584": { "city" : "TWIN VALLEY", "state" : "MN", "county" : "NORMAN" },
            "56585": { "city" : "ULEN", "state" : "MN", "county" : "CLAY" },"56586": { "city" : "UNDERWOOD", "state" : "MN", "county" : "OTTER TAIL" },
            "56587": { "city" : "VERGAS", "state" : "MN", "county" : "OTTER TAIL" },
            "56588": { "city" : "VINING", "state" : "MN", "county" : "OTTER TAIL" },
            "56589": { "city" : "WAUBUN", "state" : "MN", "county" : "BECKER" },"56590": { "city" : "WENDELL", "state" : "MN", "county" : "GRANT" },
            "56592": { "city" : "WINGER", "state" : "MN", "county" : "POLK" },"56593": { "city" : "WOLF LAKE", "state" : "MN", "county" : "BECKER" },
            "56594": { "city" : "WOLVERTON", "state" : "MN", "county" : "WILKIN" },
            "56601": { "city" : "BEMIDJI", "state" : "MN", "county" : "BELTRAMI" },
            "56619": { "city" : "BEMIDJI", "state" : "MN", "county" : "BELTRAMI" },
            "56621": { "city" : "BAGLEY", "state" : "MN", "county" : "CLEARWATER" },
            "56623": { "city" : "BAUDETTE", "state" : "MN", "county" : "LAKE OF THE WOODS" },
            "56626": { "city" : "BENA", "state" : "MN", "county" : "CASS" },"56627": { "city" : "BIG FALLS", "state" : "MN", "county" : "KOOCHICHING" },
            "56628": { "city" : "BIGFORK", "state" : "MN", "county" : "ITASCA" },
            "56629": { "city" : "BIRCHDALE", "state" : "MN", "county" : "KOOCHICHING" },
            "56630": { "city" : "BLACKDUCK", "state" : "MN", "county" : "BELTRAMI" },
            "56633": { "city" : "CASS LAKE", "state" : "MN", "county" : "CASS" },
            "56634": { "city" : "CLEARBROOK", "state" : "MN", "county" : "CLEARWATER" },
            "56636": { "city" : "DEER RIVER", "state" : "MN", "county" : "ITASCA" },
            "56637": { "city" : "TALMOON", "state" : "MN", "county" : "ITASCA" },
            "56639": { "city" : "EFFIE", "state" : "MN", "county" : "ITASCA" },"56641": { "city" : "FEDERAL DAM", "state" : "MN", "county" : "CASS" },
            "56644": { "city" : "GONVICK", "state" : "MN", "county" : "CLEARWATER" },
            "56646": { "city" : "GULLY", "state" : "MN", "county" : "POLK" },"56647": { "city" : "HINES", "state" : "MN", "county" : "BELTRAMI" },
            "56649": { "city" : "INTERNATIONAL FALLS", "state" : "MN", "county" : "KOOCHICHING" },
            "56650": { "city" : "KELLIHER", "state" : "MN", "county" : "BELTRAMI" },
            "56651": { "city" : "LENGBY", "state" : "MN", "county" : "MAHNOMEN" },
            "56652": { "city" : "LEONARD", "state" : "MN", "county" : "CLEARWATER" },
            "56653": { "city" : "LITTLEFORK", "state" : "MN", "county" : "KOOCHICHING" },
            "56654": { "city" : "LOMAN", "state" : "MN", "county" : "KOOCHICHING" },
            "56655": { "city" : "LONGVILLE", "state" : "MN", "county" : "CASS" },
            "56657": { "city" : "MARCELL", "state" : "MN", "county" : "ITASCA" },
            "56659": { "city" : "MAX", "state" : "MN", "county" : "ITASCA" },"56660": { "city" : "MIZPAH", "state" : "MN", "county" : "KOOCHICHING" },
            "56661": { "city" : "NORTHOME", "state" : "MN", "county" : "KOOCHICHING" },
            "56662": { "city" : "OUTING", "state" : "MN", "county" : "CASS" },"56663": { "city" : "PENNINGTON", "state" : "MN", "county" : "BELTRAMI" },
            "56667": { "city" : "PUPOSKY", "state" : "MN", "county" : "BELTRAMI" },
            "56668": { "city" : "RANIER", "state" : "MN", "county" : "KOOCHICHING" },
            "56669": { "city" : "KABETOGAMA", "state" : "MN", "county" : "KOOCHICHING" },
            "56670": { "city" : "REDBY", "state" : "MN", "county" : "BELTRAMI" },
            "56671": { "city" : "REDLAKE", "state" : "MN", "county" : "BELTRAMI" },
            "56672": { "city" : "REMER", "state" : "MN", "county" : "CASS" },"56673": { "city" : "ROOSEVELT", "state" : "MN", "county" : "ROSEAU" },
            "56676": { "city" : "SHEVLIN", "state" : "MN", "county" : "CLEARWATER" },
            "56678": { "city" : "SOLWAY", "state" : "MN", "county" : "BELTRAMI" },
            "56679": { "city" : "SOUTH INTERNATIONAL FALLS", "state" : "MN", "county" : "KOOCHICHING" },
            "56680": { "city" : "SPRING LAKE", "state" : "MN", "county" : "ITASCA" },
            "56681": { "city" : "SQUAW LAKE", "state" : "MN", "county" : "ITASCA" },
            "56683": { "city" : "TENSTRIKE", "state" : "MN", "county" : "BELTRAMI" },
            "56684": { "city" : "TRAIL", "state" : "MN", "county" : "POLK" },"56685": { "city" : "WASKISH", "state" : "MN", "county" : "BELTRAMI" },
            "56686": { "city" : "WILLIAMS", "state" : "MN", "county" : "LAKE OF THE WOODS" },
            "56701": { "city" : "THIEF RIVER FALLS", "state" : "MN", "county" : "PENNINGTON" },
            "56710": { "city" : "ALVARADO", "state" : "MN", "county" : "MARSHALL" },
            "56711": { "city" : "ANGLE INLET", "state" : "MN", "county" : "LAKE OF THE WOODS" },
            "56713": { "city" : "ARGYLE", "state" : "MN", "county" : "MARSHALL" },
            "56714": { "city" : "BADGER", "state" : "MN", "county" : "ROSEAU" },"56715": { "city" : "BROOKS", "state" : "MN", "county" : "RED LAKE" },
            "56716": { "city" : "CROOKSTON", "state" : "MN", "county" : "POLK" },
            "56721": { "city" : "EAST GRAND FORKS", "state" : "MN", "county" : "POLK" },
            "56722": { "city" : "EUCLID", "state" : "MN", "county" : "POLK" },"56723": { "city" : "FISHER", "state" : "MN", "county" : "POLK" },
            "56724": { "city" : "GATZKE", "state" : "MN", "county" : "MARSHALL" },
            "56725": { "city" : "GOODRIDGE", "state" : "MN", "county" : "PENNINGTON" },
            "56726": { "city" : "GREENBUSH", "state" : "MN", "county" : "ROSEAU" },
            "56727": { "city" : "GRYGLA", "state" : "MN", "county" : "MARSHALL" },
            "56728": { "city" : "HALLOCK", "state" : "MN", "county" : "KITTSON" },
            "56729": { "city" : "HALMA", "state" : "MN", "county" : "KITTSON" },"56731": { "city" : "HUMBOLDT", "state" : "MN", "county" : "KITTSON" },
            "56732": { "city" : "KARLSTAD", "state" : "MN", "county" : "KITTSON" },
            "56733": { "city" : "KENNEDY", "state" : "MN", "county" : "KITTSON" },
            "56734": { "city" : "LAKE BRONSON", "state" : "MN", "county" : "KITTSON" },
            "56735": { "city" : "LANCASTER", "state" : "MN", "county" : "KITTSON" },
            "56736": { "city" : "MENTOR", "state" : "MN", "county" : "POLK" },"56737": { "city" : "MIDDLE RIVER", "state" : "MN", "county" : "MARSHALL" },
            "56738": { "city" : "NEWFOLDEN", "state" : "MN", "county" : "MARSHALL" },
            "56741": { "city" : "OAK ISLAND", "state" : "MN", "county" : "LAKE OF THE WOODS" },
            "56742": { "city" : "OKLEE", "state" : "MN", "county" : "RED LAKE" },
            "56744": { "city" : "OSLO", "state" : "MN", "county" : "MARSHALL" },"56748": { "city" : "PLUMMER", "state" : "MN", "county" : "RED LAKE" },
            "56750": { "city" : "RED LAKE FALLS", "state" : "MN", "county" : "RED LAKE" },
            "56751": { "city" : "ROSEAU", "state" : "MN", "county" : "ROSEAU" },"56754": { "city" : "SAINT HILAIRE", "state" : "MN", "county" : "PENNINGTON" },
            "56755": { "city" : "SAINT VINCENT", "state" : "MN", "county" : "KITTSON" },
            "56756": { "city" : "SALOL", "state" : "MN", "county" : "ROSEAU" },"56757": { "city" : "STEPHEN", "state" : "MN", "county" : "MARSHALL" },
            "56758": { "city" : "STRANDQUIST", "state" : "MN", "county" : "MARSHALL" },
            "56759": { "city" : "STRATHCONA", "state" : "MN", "county" : "ROSEAU" },
            "56760": { "city" : "VIKING", "state" : "MN", "county" : "MARSHALL" },
            "56761": { "city" : "WANNASKA", "state" : "MN", "county" : "ROSEAU" },
            "56762": { "city" : "WARREN", "state" : "MN", "county" : "MARSHALL" },
            "56763": { "city" : "WARROAD", "state" : "MN", "county" : "ROSEAU" },
            "57001": { "city" : "ALCESTER", "state" : "SD", "county" : "UNION" },
            "57002": { "city" : "AURORA", "state" : "SD", "county" : "BROOKINGS" },
            "57003": { "city" : "BALTIC", "state" : "SD", "county" : "MINNEHAHA" },
            "57004": { "city" : "BERESFORD", "state" : "SD", "county" : "UNION" },
            "57005": { "city" : "BRANDON", "state" : "SD", "county" : "MINNEHAHA" },
            "57006": { "city" : "BROOKINGS", "state" : "SD", "county" : "BROOKINGS" },
            "57007": { "city" : "BROOKINGS", "state" : "SD", "county" : "BROOKINGS" },
            "57010": { "city" : "BURBANK", "state" : "SD", "county" : "CLAY" },"57012": { "city" : "CANISTOTA", "state" : "SD", "county" : "MCCOOK" },
            "57013": { "city" : "CANTON", "state" : "SD", "county" : "LINCOLN" },
            "57014": { "city" : "CENTERVILLE", "state" : "SD", "county" : "TURNER" },
            "57015": { "city" : "CHANCELLOR", "state" : "SD", "county" : "TURNER" },
            "57016": { "city" : "CHESTER", "state" : "SD", "county" : "LAKE" },"57017": { "city" : "COLMAN", "state" : "SD", "county" : "MOODY" },
            "57018": { "city" : "COLTON", "state" : "SD", "county" : "MINNEHAHA" },
            "57020": { "city" : "CROOKS", "state" : "SD", "county" : "MINNEHAHA" },
            "57021": { "city" : "DAVIS", "state" : "SD", "county" : "TURNER" },"57022": { "city" : "DELL RAPIDS", "state" : "SD", "county" : "MINNEHAHA" },
            "57024": { "city" : "EGAN", "state" : "SD", "county" : "MOODY" },"57025": { "city" : "ELK POINT", "state" : "SD", "county" : "UNION" },
            "57026": { "city" : "ELKTON", "state" : "SD", "county" : "BROOKINGS" },
            "57027": { "city" : "FAIRVIEW", "state" : "SD", "county" : "LINCOLN" },
            "57028": { "city" : "FLANDREAU", "state" : "SD", "county" : "MOODY" },
            "57029": { "city" : "FREEMAN", "state" : "SD", "county" : "HUTCHINSON" },
            "57030": { "city" : "GARRETSON", "state" : "SD", "county" : "MINNEHAHA" },
            "57031": { "city" : "GAYVILLE", "state" : "SD", "county" : "YANKTON" },
            "57032": { "city" : "HARRISBURG", "state" : "SD", "county" : "LINCOLN" },
            "57033": { "city" : "HARTFORD", "state" : "SD", "county" : "MINNEHAHA" },
            "57034": { "city" : "HUDSON", "state" : "SD", "county" : "LINCOLN" },
            "57035": { "city" : "HUMBOLDT", "state" : "SD", "county" : "MINNEHAHA" },
            "57036": { "city" : "HURLEY", "state" : "SD", "county" : "TURNER" },"57037": { "city" : "IRENE", "state" : "SD", "county" : "CLAY" },
            "57038": { "city" : "JEFFERSON", "state" : "SD", "county" : "UNION" },
            "57039": { "city" : "LENNOX", "state" : "SD", "county" : "LINCOLN" },
            "57040": { "city" : "LESTERVILLE", "state" : "SD", "county" : "YANKTON" },
            "57041": { "city" : "LYONS", "state" : "SD", "county" : "MINNEHAHA" },
            "57042": { "city" : "MADISON", "state" : "SD", "county" : "LAKE" },"57043": { "city" : "MARION", "state" : "SD", "county" : "TURNER" },
            "57045": { "city" : "MENNO", "state" : "SD", "county" : "HUTCHINSON" },
            "57046": { "city" : "MISSION HILL", "state" : "SD", "county" : "YANKTON" },
            "57047": { "city" : "MONROE", "state" : "SD", "county" : "TURNER" },"57048": { "city" : "MONTROSE", "state" : "SD", "county" : "MCCOOK" },
            "57049": { "city" : "NORTH SIOUX CITY", "state" : "SD", "county" : "UNION" },
            "57050": { "city" : "NUNDA", "state" : "SD", "county" : "LAKE" },"57051": { "city" : "OLDHAM", "state" : "SD", "county" : "KINGSBURY" },
            "57052": { "city" : "OLIVET", "state" : "SD", "county" : "HUTCHINSON" },
            "57053": { "city" : "PARKER", "state" : "SD", "county" : "TURNER" },"57054": { "city" : "RAMONA", "state" : "SD", "county" : "LAKE" },
            "57055": { "city" : "RENNER", "state" : "SD", "county" : "MINNEHAHA" },
            "57057": { "city" : "RUTLAND", "state" : "SD", "county" : "LAKE" },"57058": { "city" : "SALEM", "state" : "SD", "county" : "MCCOOK" },
            "57059": { "city" : "SCOTLAND", "state" : "SD", "county" : "BON HOMME" },
            "57061": { "city" : "SINAI", "state" : "SD", "county" : "BROOKINGS" },
            "57062": { "city" : "SPRINGFIELD", "state" : "SD", "county" : "BON HOMME" },
            "57063": { "city" : "TABOR", "state" : "SD", "county" : "BON HOMME" },
            "57064": { "city" : "TEA", "state" : "SD", "county" : "LINCOLN" },"57065": { "city" : "TRENT", "state" : "SD", "county" : "MOODY" },
            "57066": { "city" : "TYNDALL", "state" : "SD", "county" : "BON HOMME" },
            "57067": { "city" : "UTICA", "state" : "SD", "county" : "YANKTON" },"57068": { "city" : "VALLEY SPRINGS", "state" : "SD", "county" : "MINNEHAHA" },
            "57069": { "city" : "VERMILLION", "state" : "SD", "county" : "CLAY" },
            "57070": { "city" : "VIBORG", "state" : "SD", "county" : "TURNER" },"57071": { "city" : "VOLGA", "state" : "SD", "county" : "BROOKINGS" },
            "57072": { "city" : "VOLIN", "state" : "SD", "county" : "YANKTON" },"57073": { "city" : "WAKONDA", "state" : "SD", "county" : "CLAY" },
            "57075": { "city" : "WENTWORTH", "state" : "SD", "county" : "LAKE" },
            "57076": { "city" : "WINFRED", "state" : "SD", "county" : "LAKE" },"57077": { "city" : "WORTHING", "state" : "SD", "county" : "LINCOLN" },
            "57078": { "city" : "YANKTON", "state" : "SD", "county" : "YANKTON" },
            "57101": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57103": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57104": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57105": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57106": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57107": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57108": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "LINCOLN" },
            "57109": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57110": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57117": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57118": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57186": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57193": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57197": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57198": { "city" : "SIOUX FALLS", "state" : "SD", "county" : "MINNEHAHA" },
            "57201": { "city" : "WATERTOWN", "state" : "SD", "county" : "CODINGTON" },
            "57212": { "city" : "ARLINGTON", "state" : "SD", "county" : "KINGSBURY" },
            "57213": { "city" : "ASTORIA", "state" : "SD", "county" : "DEUEL" },"57214": { "city" : "BADGER", "state" : "SD", "county" : "KINGSBURY" },
            "57216": { "city" : "BIG STONE CITY", "state" : "SD", "county" : "GRANT" },
            "57217": { "city" : "BRADLEY", "state" : "SD", "county" : "CLARK" },"57218": { "city" : "BRANDT", "state" : "SD", "county" : "DEUEL" },
            "57219": { "city" : "BRISTOL", "state" : "SD", "county" : "DAY" },"57220": { "city" : "BRUCE", "state" : "SD", "county" : "BROOKINGS" },
            "57221": { "city" : "BRYANT", "state" : "SD", "county" : "HAMLIN" },"57223": { "city" : "CASTLEWOOD", "state" : "SD", "county" : "HAMLIN" },
            "57224": { "city" : "CLAIRE CITY", "state" : "SD", "county" : "ROBERTS" },
            "57225": { "city" : "CLARK", "state" : "SD", "county" : "CLARK" },"57226": { "city" : "CLEAR LAKE", "state" : "SD", "county" : "DEUEL" },
            "57227": { "city" : "CORONA", "state" : "SD", "county" : "ROBERTS" },
            "57231": { "city" : "DE SMET", "state" : "SD", "county" : "KINGSBURY" },
            "57232": { "city" : "EDEN", "state" : "SD", "county" : "MARSHALL" },"57233": { "city" : "ERWIN", "state" : "SD", "county" : "KINGSBURY" },
            "57234": { "city" : "ESTELLINE", "state" : "SD", "county" : "HAMLIN" },
            "57235": { "city" : "FLORENCE", "state" : "SD", "county" : "CODINGTON" },
            "57236": { "city" : "GARDEN CITY", "state" : "SD", "county" : "CLARK" },
            "57237": { "city" : "GARY", "state" : "SD", "county" : "DEUEL" },"57238": { "city" : "GOODWIN", "state" : "SD", "county" : "DEUEL" },
            "57239": { "city" : "GRENVILLE", "state" : "SD", "county" : "DAY" },"57241": { "city" : "HAYTI", "state" : "SD", "county" : "HAMLIN" },
            "57242": { "city" : "HAZEL", "state" : "SD", "county" : "HAMLIN" },"57243": { "city" : "HENRY", "state" : "SD", "county" : "CODINGTON" },
            "57245": { "city" : "KRANZBURG", "state" : "SD", "county" : "CODINGTON" },
            "57246": { "city" : "LABOLT", "state" : "SD", "county" : "GRANT" },"57247": { "city" : "LAKE CITY", "state" : "SD", "county" : "MARSHALL" },
            "57248": { "city" : "LAKE NORDEN", "state" : "SD", "county" : "HAMLIN" },
            "57249": { "city" : "LAKE PRESTON", "state" : "SD", "county" : "KINGSBURY" },
            "57251": { "city" : "MARVIN", "state" : "SD", "county" : "GRANT" },"57252": { "city" : "MILBANK", "state" : "SD", "county" : "GRANT" },
            "57253": { "city" : "MILBANK", "state" : "SD", "county" : "GRANT" },"57255": { "city" : "NEW EFFINGTON", "state" : "SD", "county" : "ROBERTS" },
            "57257": { "city" : "PEEVER", "state" : "SD", "county" : "ROBERTS" },
            "57258": { "city" : "RAYMOND", "state" : "SD", "county" : "CLARK" },"57259": { "city" : "REVILLO", "state" : "SD", "county" : "GRANT" },
            "57260": { "city" : "ROSHOLT", "state" : "SD", "county" : "ROBERTS" },
            "57261": { "city" : "ROSLYN", "state" : "SD", "county" : "DAY" },"57262": { "city" : "SISSETON", "state" : "SD", "county" : "ROBERTS" },
            "57263": { "city" : "SOUTH SHORE", "state" : "SD", "county" : "CODINGTON" },
            "57264": { "city" : "STOCKHOLM", "state" : "SD", "county" : "GRANT" },
            "57265": { "city" : "STRANDBURG", "state" : "SD", "county" : "GRANT" },
            "57266": { "city" : "SUMMIT", "state" : "SD", "county" : "ROBERTS" },
            "57268": { "city" : "TORONTO", "state" : "SD", "county" : "DEUEL" },"57269": { "city" : "TWIN BROOKS", "state" : "SD", "county" : "GRANT" },
            "57270": { "city" : "VEBLEN", "state" : "SD", "county" : "MARSHALL" },
            "57271": { "city" : "VIENNA", "state" : "SD", "county" : "CLARK" },"57272": { "city" : "WALLACE", "state" : "SD", "county" : "CODINGTON" },
            "57273": { "city" : "WAUBAY", "state" : "SD", "county" : "DAY" },"57274": { "city" : "WEBSTER", "state" : "SD", "county" : "DAY" },
            "57276": { "city" : "WHITE", "state" : "SD", "county" : "BROOKINGS" },
            "57278": { "city" : "WILLOW LAKE", "state" : "SD", "county" : "CLARK" },
            "57279": { "city" : "WILMOT", "state" : "SD", "county" : "ROBERTS" },
            "57301": { "city" : "MITCHELL", "state" : "SD", "county" : "DAVISON" },
            "57311": { "city" : "ALEXANDRIA", "state" : "SD", "county" : "HANSON" },
            "57312": { "city" : "ALPENA", "state" : "SD", "county" : "JERAULD" },
            "57313": { "city" : "ARMOUR", "state" : "SD", "county" : "DOUGLAS" },
            "57314": { "city" : "ARTESIAN", "state" : "SD", "county" : "SANBORN" },
            "57315": { "city" : "AVON", "state" : "SD", "county" : "BON HOMME" },
            "57317": { "city" : "BONESTEEL", "state" : "SD", "county" : "GREGORY" },
            "57319": { "city" : "BRIDGEWATER", "state" : "SD", "county" : "MCCOOK" },
            "57321": { "city" : "CANOVA", "state" : "SD", "county" : "MINER" },"57322": { "city" : "CARPENTER", "state" : "SD", "county" : "CLARK" },
            "57323": { "city" : "CARTHAGE", "state" : "SD", "county" : "MINER" },
            "57324": { "city" : "CAVOUR", "state" : "SD", "county" : "BEADLE" },"57325": { "city" : "CHAMBERLAIN", "state" : "SD", "county" : "BRULE" },
            "57328": { "city" : "CORSICA", "state" : "SD", "county" : "DOUGLAS" },
            "57329": { "city" : "DANTE", "state" : "SD", "county" : "CHARLES MIX" },
            "57330": { "city" : "DELMONT", "state" : "SD", "county" : "DOUGLAS" },
            "57331": { "city" : "DIMOCK", "state" : "SD", "county" : "HUTCHINSON" },
            "57332": { "city" : "EMERY", "state" : "SD", "county" : "HANSON" },"57334": { "city" : "ETHAN", "state" : "SD", "county" : "DAVISON" },
            "57335": { "city" : "FAIRFAX", "state" : "SD", "county" : "GREGORY" },
            "57337": { "city" : "FEDORA", "state" : "SD", "county" : "MINER" },"57339": { "city" : "FORT THOMPSON", "state" : "SD", "county" : "BUFFALO" },
            "57340": { "city" : "FULTON", "state" : "SD", "county" : "HANSON" },"57342": { "city" : "GEDDES", "state" : "SD", "county" : "CHARLES MIX" },
            "57344": { "city" : "HARRISON", "state" : "SD", "county" : "DOUGLAS" },
            "57345": { "city" : "HIGHMORE", "state" : "SD", "county" : "HYDE" },"57346": { "city" : "STEPHAN", "state" : "SD", "county" : "HYDE" },
            "57348": { "city" : "HITCHCOCK", "state" : "SD", "county" : "BEADLE" },
            "57349": { "city" : "HOWARD", "state" : "SD", "county" : "MINER" },"57350": { "city" : "HURON", "state" : "SD", "county" : "BEADLE" },
            "57353": { "city" : "IROQUOIS", "state" : "SD", "county" : "KINGSBURY" },
            "57354": { "city" : "KAYLOR", "state" : "SD", "county" : "HUTCHINSON" },
            "57355": { "city" : "KIMBALL", "state" : "SD", "county" : "BRULE" },"57356": { "city" : "LAKE ANDES", "state" : "SD", "county" : "CHARLES MIX" },
            "57358": { "city" : "LANE", "state" : "SD", "county" : "JERAULD" },"57359": { "city" : "LETCHER", "state" : "SD", "county" : "SANBORN" },
            "57361": { "city" : "MARTY", "state" : "SD", "county" : "CHARLES MIX" },
            "57362": { "city" : "MILLER", "state" : "SD", "county" : "HAND" },"57363": { "city" : "MOUNT VERNON", "state" : "SD", "county" : "DAVISON" },
            "57364": { "city" : "NEW HOLLAND", "state" : "SD", "county" : "DOUGLAS" },
            "57365": { "city" : "OACOMA", "state" : "SD", "county" : "LYMAN" },"57366": { "city" : "PARKSTON", "state" : "SD", "county" : "HUTCHINSON" },
            "57367": { "city" : "PICKSTOWN", "state" : "SD", "county" : "CHARLES MIX" },
            "57368": { "city" : "PLANKINTON", "state" : "SD", "county" : "AURORA" },
            "57369": { "city" : "PLATTE", "state" : "SD", "county" : "CHARLES MIX" },
            "57370": { "city" : "PUKWANA", "state" : "SD", "county" : "BRULE" },"57371": { "city" : "REE HEIGHTS", "state" : "SD", "county" : "HAND" },
            "57373": { "city" : "SAINT LAWRENCE", "state" : "SD", "county" : "HAND" },
            "57374": { "city" : "SPENCER", "state" : "SD", "county" : "MCCOOK" },
            "57375": { "city" : "STICKNEY", "state" : "SD", "county" : "AURORA" },
            "57376": { "city" : "TRIPP", "state" : "SD", "county" : "HUTCHINSON" },
            "57379": { "city" : "VIRGIL", "state" : "SD", "county" : "BEADLE" },"57380": { "city" : "WAGNER", "state" : "SD", "county" : "CHARLES MIX" },
            "57381": { "city" : "WESSINGTON", "state" : "SD", "county" : "BEADLE" },
            "57382": { "city" : "WESSINGTON SPRINGS", "state" : "SD", "county" : "JERAULD" },
            "57383": { "city" : "WHITE LAKE", "state" : "SD", "county" : "AURORA" },
            "57384": { "city" : "WOLSEY", "state" : "SD", "county" : "BEADLE" },"57385": { "city" : "WOONSOCKET", "state" : "SD", "county" : "SANBORN" },
            "57386": { "city" : "YALE", "state" : "SD", "county" : "BEADLE" },"57401": { "city" : "ABERDEEN", "state" : "SD", "county" : "BROWN" },
            "57402": { "city" : "ABERDEEN", "state" : "SD", "county" : "BROWN" },
            "57420": { "city" : "AKASKA", "state" : "SD", "county" : "WALWORTH" },
            "57421": { "city" : "AMHERST", "state" : "SD", "county" : "MARSHALL" },
            "57422": { "city" : "ANDOVER", "state" : "SD", "county" : "DAY" },"57424": { "city" : "ASHTON", "state" : "SD", "county" : "SPINK" },
            "57427": { "city" : "BATH", "state" : "SD", "county" : "BROWN" },"57428": { "city" : "BOWDLE", "state" : "SD", "county" : "EDMUNDS" },
            "57429": { "city" : "BRENTFORD", "state" : "SD", "county" : "SPINK" },
            "57430": { "city" : "BRITTON", "state" : "SD", "county" : "MARSHALL" },
            "57432": { "city" : "CLAREMONT", "state" : "SD", "county" : "BROWN" },
            "57433": { "city" : "COLUMBIA", "state" : "SD", "county" : "BROWN" },
            "57434": { "city" : "CONDE", "state" : "SD", "county" : "SPINK" },"57435": { "city" : "CRESBARD", "state" : "SD", "county" : "FAULK" },
            "57436": { "city" : "DOLAND", "state" : "SD", "county" : "SPINK" },"57437": { "city" : "EUREKA", "state" : "SD", "county" : "MCPHERSON" },
            "57438": { "city" : "FAULKTON", "state" : "SD", "county" : "FAULK" },
            "57439": { "city" : "FERNEY", "state" : "SD", "county" : "BROWN" },"57440": { "city" : "FRANKFORT", "state" : "SD", "county" : "SPINK" },
            "57441": { "city" : "FREDERICK", "state" : "SD", "county" : "BROWN" },
            "57442": { "city" : "GETTYSBURG", "state" : "SD", "county" : "POTTER" },
            "57445": { "city" : "GROTON", "state" : "SD", "county" : "BROWN" },"57446": { "city" : "HECLA", "state" : "SD", "county" : "BROWN" },
            "57448": { "city" : "HOSMER", "state" : "SD", "county" : "EDMUNDS" },
            "57449": { "city" : "HOUGHTON", "state" : "SD", "county" : "BROWN" },
            "57450": { "city" : "HOVEN", "state" : "SD", "county" : "POTTER" },"57451": { "city" : "IPSWICH", "state" : "SD", "county" : "EDMUNDS" },
            "57452": { "city" : "JAVA", "state" : "SD", "county" : "WALWORTH" },"57454": { "city" : "LANGFORD", "state" : "SD", "county" : "MARSHALL" },
            "57455": { "city" : "LEBANON", "state" : "SD", "county" : "POTTER" },
            "57456": { "city" : "LEOLA", "state" : "SD", "county" : "MCPHERSON" },
            "57457": { "city" : "LONGLAKE", "state" : "SD", "county" : "MCPHERSON" },
            "57460": { "city" : "MANSFIELD", "state" : "SD", "county" : "BROWN" },
            "57461": { "city" : "MELLETTE", "state" : "SD", "county" : "SPINK" },
            "57465": { "city" : "NORTHVILLE", "state" : "SD", "county" : "SPINK" },
            "57466": { "city" : "ONAKA", "state" : "SD", "county" : "FAULK" },"57467": { "city" : "ORIENT", "state" : "SD", "county" : "HAND" },
            "57468": { "city" : "PIERPONT", "state" : "SD", "county" : "DAY" },"57469": { "city" : "REDFIELD", "state" : "SD", "county" : "SPINK" },
            "57470": { "city" : "ROCKHAM", "state" : "SD", "county" : "FAULK" },"57471": { "city" : "ROSCOE", "state" : "SD", "county" : "EDMUNDS" },
            "57472": { "city" : "SELBY", "state" : "SD", "county" : "WALWORTH" },
            "57473": { "city" : "SENECA", "state" : "SD", "county" : "FAULK" },"57474": { "city" : "STRATFORD", "state" : "SD", "county" : "BROWN" },
            "57475": { "city" : "TOLSTOY", "state" : "SD", "county" : "POTTER" },
            "57476": { "city" : "TULARE", "state" : "SD", "county" : "SPINK" },"57477": { "city" : "TURTON", "state" : "SD", "county" : "SPINK" },
            "57479": { "city" : "WARNER", "state" : "SD", "county" : "BROWN" },"57481": { "city" : "WESTPORT", "state" : "SD", "county" : "BROWN" },
            "57501": { "city" : "PIERRE", "state" : "SD", "county" : "HUGHES" },"57520": { "city" : "AGAR", "state" : "SD", "county" : "SULLY" },
            "57521": { "city" : "BELVIDERE", "state" : "SD", "county" : "JACKSON" },
            "57522": { "city" : "BLUNT", "state" : "SD", "county" : "HUGHES" },"57523": { "city" : "BURKE", "state" : "SD", "county" : "GREGORY" },
            "57528": { "city" : "COLOME", "state" : "SD", "county" : "TRIPP" },"57529": { "city" : "DALLAS", "state" : "SD", "county" : "GREGORY" },
            "57531": { "city" : "DRAPER", "state" : "SD", "county" : "JONES" },"57532": { "city" : "FORT PIERRE", "state" : "SD", "county" : "STANLEY" },
            "57533": { "city" : "GREGORY", "state" : "SD", "county" : "GREGORY" },
            "57536": { "city" : "HARROLD", "state" : "SD", "county" : "HUGHES" },
            "57537": { "city" : "HAYES", "state" : "SD", "county" : "STANLEY" },"57540": { "city" : "HOLABIRD", "state" : "SD", "county" : "HYDE" },
            "57543": { "city" : "KADOKA", "state" : "SD", "county" : "JACKSON" },
            "57544": { "city" : "KENNEBEC", "state" : "SD", "county" : "LYMAN" },
            "57547": { "city" : "LONG VALLEY", "state" : "SD", "county" : "JACKSON" },
            "57548": { "city" : "LOWER BRULE", "state" : "SD", "county" : "LYMAN" },
            "57551": { "city" : "MARTIN", "state" : "SD", "county" : "BENNETT" },
            "57552": { "city" : "MIDLAND", "state" : "SD", "county" : "HAAKON" },
            "57553": { "city" : "MILESVILLE", "state" : "SD", "county" : "HAAKON" },
            "57555": { "city" : "MISSION", "state" : "SD", "county" : "TODD" },"57559": { "city" : "MURDO", "state" : "SD", "county" : "JONES" },
            "57560": { "city" : "NORRIS", "state" : "SD", "county" : "MELLETTE" },
            "57562": { "city" : "OKATON", "state" : "SD", "county" : "JONES" },"57564": { "city" : "ONIDA", "state" : "SD", "county" : "SULLY" },
            "57567": { "city" : "PHILIP", "state" : "SD", "county" : "HAAKON" },"57568": { "city" : "PRESHO", "state" : "SD", "county" : "LYMAN" },
            "57569": { "city" : "RELIANCE", "state" : "SD", "county" : "LYMAN" },
            "57570": { "city" : "ROSEBUD", "state" : "SD", "county" : "TODD" },"57572": { "city" : "SAINT FRANCIS", "state" : "SD", "county" : "TODD" },
            "57574": { "city" : "TUTHILL", "state" : "SD", "county" : "BENNETT" },
            "57576": { "city" : "VIVIAN", "state" : "SD", "county" : "LYMAN" },"57577": { "city" : "WANBLEE", "state" : "SD", "county" : "JACKSON" },
            "57579": { "city" : "WHITE RIVER", "state" : "SD", "county" : "MELLETTE" },
            "57580": { "city" : "WINNER", "state" : "SD", "county" : "TRIPP" },"57584": { "city" : "WITTEN", "state" : "SD", "county" : "TRIPP" },
            "57585": { "city" : "WOOD", "state" : "SD", "county" : "MELLETTE" },"57601": { "city" : "MOBRIDGE", "state" : "SD", "county" : "WALWORTH" },
            "57620": { "city" : "BISON", "state" : "SD", "county" : "PERKINS" },"57621": { "city" : "BULLHEAD", "state" : "SD", "county" : "CORSON" },
            "57623": { "city" : "DUPREE", "state" : "SD", "county" : "ZIEBACH" },
            "57625": { "city" : "EAGLE BUTTE", "state" : "SD", "county" : "DEWEY" },
            "57626": { "city" : "FAITH", "state" : "SD", "county" : "MEADE" },"57630": { "city" : "GLENCROSS", "state" : "SD", "county" : "DEWEY" },
            "57631": { "city" : "GLENHAM", "state" : "SD", "county" : "WALWORTH" },
            "57632": { "city" : "HERREID", "state" : "SD", "county" : "CAMPBELL" },
            "57633": { "city" : "ISABEL", "state" : "SD", "county" : "DEWEY" },"57634": { "city" : "KELDRON", "state" : "SD", "county" : "CORSON" },
            "57638": { "city" : "LEMMON", "state" : "SD", "county" : "PERKINS" },
            "57640": { "city" : "LODGEPOLE", "state" : "SD", "county" : "PERKINS" },
            "57641": { "city" : "MC INTOSH", "state" : "SD", "county" : "CORSON" },
            "57642": { "city" : "MC LAUGHLIN", "state" : "SD", "county" : "CORSON" },
            "57644": { "city" : "MEADOW", "state" : "SD", "county" : "PERKINS" },
            "57645": { "city" : "MORRISTOWN", "state" : "SD", "county" : "CORSON" },
            "57646": { "city" : "MOUND CITY", "state" : "SD", "county" : "CAMPBELL" },
            "57648": { "city" : "POLLOCK", "state" : "SD", "county" : "CAMPBELL" },
            "57649": { "city" : "PRAIRIE CITY", "state" : "SD", "county" : "PERKINS" },
            "57651": { "city" : "REVA", "state" : "SD", "county" : "HARDING" },"57652": { "city" : "RIDGEVIEW", "state" : "SD", "county" : "DEWEY" },
            "57656": { "city" : "TIMBER LAKE", "state" : "SD", "county" : "DEWEY" },
            "57658": { "city" : "WAKPALA", "state" : "SD", "county" : "CORSON" },
            "57660": { "city" : "WATAUGA", "state" : "SD", "county" : "CORSON" },
            "57701": { "city" : "RAPID CITY", "state" : "SD", "county" : "PENNINGTON" },
            "57702": { "city" : "RAPID CITY", "state" : "SD", "county" : "PENNINGTON" },
            "57703": { "city" : "RAPID CITY", "state" : "SD", "county" : "PENNINGTON" },
            "57706": { "city" : "ELLSWORTH AFB", "state" : "SD", "county" : "MEADE" },
            "57709": { "city" : "RAPID CITY", "state" : "SD", "county" : "PENNINGTON" },
            "57714": { "city" : "ALLEN", "state" : "SD", "county" : "BENNETT" },"57716": { "city" : "BATESLAND", "state" : "SD", "county" : "SHANNON" },
            "57717": { "city" : "BELLE FOURCHE", "state" : "SD", "county" : "BUTTE" },
            "57718": { "city" : "BLACK HAWK", "state" : "SD", "county" : "MEADE" },
            "57719": { "city" : "BOX ELDER", "state" : "SD", "county" : "PENNINGTON" },
            "57720": { "city" : "BUFFALO", "state" : "SD", "county" : "HARDING" },
            "57722": { "city" : "BUFFALO GAP", "state" : "SD", "county" : "CUSTER" },
            "57724": { "city" : "CAMP CROOK", "state" : "SD", "county" : "HARDING" },
            "57725": { "city" : "CAPUTA", "state" : "SD", "county" : "PENNINGTON" },
            "57730": { "city" : "CUSTER", "state" : "SD", "county" : "CUSTER" },"57732": { "city" : "DEADWOOD", "state" : "SD", "county" : "LAWRENCE" },
            "57735": { "city" : "EDGEMONT", "state" : "SD", "county" : "FALL RIVER" },
            "57737": { "city" : "ENNING", "state" : "SD", "county" : "MEADE" },"57738": { "city" : "FAIRBURN", "state" : "SD", "county" : "CUSTER" },
            "57741": { "city" : "FORT MEADE", "state" : "SD", "county" : "MEADE" },
            "57744": { "city" : "HERMOSA", "state" : "SD", "county" : "CUSTER" },
            "57745": { "city" : "HILL CITY", "state" : "SD", "county" : "PENNINGTON" },
            "57747": { "city" : "HOT SPRINGS", "state" : "SD", "county" : "FALL RIVER" },
            "57748": { "city" : "HOWES", "state" : "SD", "county" : "MEADE" },"57750": { "city" : "INTERIOR", "state" : "SD", "county" : "JACKSON" },
            "57751": { "city" : "KEYSTONE", "state" : "SD", "county" : "PENNINGTON" },
            "57752": { "city" : "KYLE", "state" : "SD", "county" : "SHANNON" },"57754": { "city" : "LEAD", "state" : "SD", "county" : "LAWRENCE" },
            "57755": { "city" : "LUDLOW", "state" : "SD", "county" : "HARDING" },
            "57756": { "city" : "MANDERSON", "state" : "SD", "county" : "SHANNON" },
            "57758": { "city" : "MUD BUTTE", "state" : "SD", "county" : "MEADE" },
            "57759": { "city" : "NEMO", "state" : "SD", "county" : "LAWRENCE" },"57760": { "city" : "NEWELL", "state" : "SD", "county" : "BUTTE" },
            "57761": { "city" : "NEW UNDERWOOD", "state" : "SD", "county" : "PENNINGTON" },
            "57762": { "city" : "NISLAND", "state" : "SD", "county" : "BUTTE" },"57763": { "city" : "OELRICHS", "state" : "SD", "county" : "FALL RIVER" },
            "57764": { "city" : "OGLALA", "state" : "SD", "county" : "SHANNON" },
            "57766": { "city" : "ORAL", "state" : "SD", "county" : "FALL RIVER" },
            "57767": { "city" : "OWANKA", "state" : "SD", "county" : "PENNINGTON" },
            "57769": { "city" : "PIEDMONT", "state" : "SD", "county" : "MEADE" },
            "57770": { "city" : "PINE RIDGE", "state" : "SD", "county" : "SHANNON" },
            "57772": { "city" : "PORCUPINE", "state" : "SD", "county" : "SHANNON" },
            "57773": { "city" : "PRINGLE", "state" : "SD", "county" : "CUSTER" },
            "57775": { "city" : "QUINN", "state" : "SD", "county" : "PENNINGTON" },
            "57779": { "city" : "SAINT ONGE", "state" : "SD", "county" : "LAWRENCE" },
            "57780": { "city" : "SCENIC", "state" : "SD", "county" : "PENNINGTON" },
            "57782": { "city" : "SMITHWICK", "state" : "SD", "county" : "FALL RIVER" },
            "57783": { "city" : "SPEARFISH", "state" : "SD", "county" : "LAWRENCE" },
            "57785": { "city" : "STURGIS", "state" : "SD", "county" : "MEADE" },"57787": { "city" : "UNION CENTER", "state" : "SD", "county" : "MEADE" },
            "57788": { "city" : "VALE", "state" : "SD", "county" : "BUTTE" },"57790": { "city" : "WALL", "state" : "SD", "county" : "PENNINGTON" },
            "57791": { "city" : "WASTA", "state" : "SD", "county" : "PENNINGTON" },
            "57792": { "city" : "WHITE OWL", "state" : "SD", "county" : "MEADE" },
            "57793": { "city" : "WHITEWOOD", "state" : "SD", "county" : "LAWRENCE" },
            "57799": { "city" : "SPEARFISH", "state" : "SD", "county" : "LAWRENCE" },
            "58001": { "city" : "ABERCROMBIE", "state" : "ND", "county" : "RICHLAND" },
            "58004": { "city" : "AMENIA", "state" : "ND", "county" : "CASS" },"58005": { "city" : "ARGUSVILLE", "state" : "ND", "county" : "CASS" },
            "58006": { "city" : "ARTHUR", "state" : "ND", "county" : "CASS" },"58007": { "city" : "AYR", "state" : "ND", "county" : "CASS" },
            "58008": { "city" : "BARNEY", "state" : "ND", "county" : "RICHLAND" },
            "58009": { "city" : "BLANCHARD", "state" : "ND", "county" : "TRAILL" },
            "58011": { "city" : "BUFFALO", "state" : "ND", "county" : "CASS" },"58012": { "city" : "CASSELTON", "state" : "ND", "county" : "CASS" },
            "58013": { "city" : "CAYUGA", "state" : "ND", "county" : "SARGENT" },
            "58015": { "city" : "CHRISTINE", "state" : "ND", "county" : "RICHLAND" },
            "58016": { "city" : "CLIFFORD", "state" : "ND", "county" : "TRAILL" },
            "58017": { "city" : "COGSWELL", "state" : "ND", "county" : "SARGENT" },
            "58018": { "city" : "COLFAX", "state" : "ND", "county" : "RICHLAND" },
            "58021": { "city" : "DAVENPORT", "state" : "ND", "county" : "CASS" },
            "58027": { "city" : "ENDERLIN", "state" : "ND", "county" : "RANSOM" },
            "58029": { "city" : "ERIE", "state" : "ND", "county" : "CASS" },"58030": { "city" : "FAIRMOUNT", "state" : "ND", "county" : "RICHLAND" },
            "58031": { "city" : "FINGAL", "state" : "ND", "county" : "BARNES" },"58032": { "city" : "FORMAN", "state" : "ND", "county" : "SARGENT" },
            "58033": { "city" : "FORT RANSOM", "state" : "ND", "county" : "RANSOM" },
            "58035": { "city" : "GALESBURG", "state" : "ND", "county" : "TRAILL" },
            "58036": { "city" : "GARDNER", "state" : "ND", "county" : "CASS" },"58038": { "city" : "GRANDIN", "state" : "ND", "county" : "CASS" },
            "58040": { "city" : "GWINNER", "state" : "ND", "county" : "SARGENT" },
            "58041": { "city" : "HANKINSON", "state" : "ND", "county" : "RICHLAND" },
            "58042": { "city" : "HARWOOD", "state" : "ND", "county" : "CASS" },"58043": { "city" : "HAVANA", "state" : "ND", "county" : "SARGENT" },
            "58045": { "city" : "HILLSBORO", "state" : "ND", "county" : "TRAILL" },
            "58046": { "city" : "HOPE", "state" : "ND", "county" : "STEELE" },"58047": { "city" : "HORACE", "state" : "ND", "county" : "CASS" },
            "58048": { "city" : "HUNTER", "state" : "ND", "county" : "CASS" },"58049": { "city" : "KATHRYN", "state" : "ND", "county" : "BARNES" },
            "58051": { "city" : "KINDRED", "state" : "ND", "county" : "CASS" },"58052": { "city" : "LEONARD", "state" : "ND", "county" : "CASS" },
            "58053": { "city" : "LIDGERWOOD", "state" : "ND", "county" : "RICHLAND" },
            "58054": { "city" : "LISBON", "state" : "ND", "county" : "RANSOM" },"58056": { "city" : "LUVERNE", "state" : "ND", "county" : "STEELE" },
            "58057": { "city" : "MCLEOD", "state" : "ND", "county" : "RICHLAND" },
            "58058": { "city" : "MANTADOR", "state" : "ND", "county" : "RICHLAND" },
            "58059": { "city" : "MAPLETON", "state" : "ND", "county" : "CASS" },"58060": { "city" : "MILNOR", "state" : "ND", "county" : "SARGENT" },
            "58061": { "city" : "MOORETON", "state" : "ND", "county" : "RICHLAND" },
            "58062": { "city" : "NOME", "state" : "ND", "county" : "BARNES" },"58063": { "city" : "ORISKA", "state" : "ND", "county" : "BARNES" },
            "58064": { "city" : "PAGE", "state" : "ND", "county" : "CASS" },"58065": { "city" : "PILLSBURY", "state" : "ND", "county" : "BARNES" },
            "58067": { "city" : "RUTLAND", "state" : "ND", "county" : "SARGENT" },
            "58068": { "city" : "SHELDON", "state" : "ND", "county" : "RANSOM" },
            "58071": { "city" : "TOWER CITY", "state" : "ND", "county" : "CASS" },
            "58072": { "city" : "VALLEY CITY", "state" : "ND", "county" : "BARNES" },
            "58074": { "city" : "WAHPETON", "state" : "ND", "county" : "RICHLAND" },
            "58075": { "city" : "WAHPETON", "state" : "ND", "county" : "RICHLAND" },
            "58076": { "city" : "WAHPETON", "state" : "ND", "county" : "RICHLAND" },
            "58077": { "city" : "WALCOTT", "state" : "ND", "county" : "RICHLAND" },
            "58078": { "city" : "WEST FARGO", "state" : "ND", "county" : "CASS" },
            "58079": { "city" : "WHEATLAND", "state" : "ND", "county" : "CASS" },
            "58081": { "city" : "WYNDMERE", "state" : "ND", "county" : "RICHLAND" },
            "58102": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },"58103": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },
            "58104": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },"58105": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },
            "58106": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },"58107": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },
            "58108": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },"58109": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },
            "58121": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },"58122": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },
            "58124": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },"58126": { "city" : "FARGO", "state" : "ND", "county" : "CASS" },
            "58201": { "city" : "GRAND FORKS", "state" : "ND", "county" : "GRAND FORKS" },
            "58202": { "city" : "GRAND FORKS", "state" : "ND", "county" : "GRAND FORKS" },
            "58203": { "city" : "GRAND FORKS", "state" : "ND", "county" : "GRAND FORKS" },
            "58204": { "city" : "GRAND FORKS AFB", "state" : "ND", "county" : "GRAND FORKS" },
            "58205": { "city" : "GRAND FORKS AFB", "state" : "ND", "county" : "GRAND FORKS" },
            "58206": { "city" : "GRAND FORKS", "state" : "ND", "county" : "GRAND FORKS" },
            "58207": { "city" : "GRAND FORKS", "state" : "ND", "county" : "GRAND FORKS" },
            "58208": { "city" : "GRAND FORKS", "state" : "ND", "county" : "GRAND FORKS" },
            "58210": { "city" : "ADAMS", "state" : "ND", "county" : "WALSH" },"58212": { "city" : "ANETA", "state" : "ND", "county" : "NELSON" },
            "58214": { "city" : "ARVILLA", "state" : "ND", "county" : "GRAND FORKS" },
            "58216": { "city" : "BATHGATE", "state" : "ND", "county" : "PEMBINA" },
            "58218": { "city" : "BUXTON", "state" : "ND", "county" : "TRAILL" },"58219": { "city" : "CALEDONIA", "state" : "ND", "county" : "TRAILL" },
            "58220": { "city" : "CAVALIER", "state" : "ND", "county" : "PEMBINA" },
            "58222": { "city" : "CRYSTAL", "state" : "ND", "county" : "PEMBINA" },
            "58223": { "city" : "CUMMINGS", "state" : "ND", "county" : "TRAILL" },
            "58224": { "city" : "DAHLEN", "state" : "ND", "county" : "NELSON" },"58225": { "city" : "DRAYTON", "state" : "ND", "county" : "PEMBINA" },
            "58227": { "city" : "EDINBURG", "state" : "ND", "county" : "WALSH" },
            "58228": { "city" : "EMERADO", "state" : "ND", "county" : "GRAND FORKS" },
            "58229": { "city" : "FAIRDALE", "state" : "ND", "county" : "WALSH" },
            "58230": { "city" : "FINLEY", "state" : "ND", "county" : "STEELE" },"58231": { "city" : "FORDVILLE", "state" : "ND", "county" : "WALSH" },
            "58233": { "city" : "FOREST RIVER", "state" : "ND", "county" : "WALSH" },
            "58235": { "city" : "GILBY", "state" : "ND", "county" : "GRAND FORKS" },
            "58236": { "city" : "GLASSTON", "state" : "ND", "county" : "PEMBINA" },
            "58237": { "city" : "GRAFTON", "state" : "ND", "county" : "WALSH" },"58238": { "city" : "HAMILTON", "state" : "ND", "county" : "PEMBINA" },
            "58239": { "city" : "HANNAH", "state" : "ND", "county" : "CAVALIER" },
            "58240": { "city" : "HATTON", "state" : "ND", "county" : "TRAILL" },"58241": { "city" : "HENSEL", "state" : "ND", "county" : "PEMBINA" },
            "58243": { "city" : "HOOPLE", "state" : "ND", "county" : "WALSH" },"58249": { "city" : "LANGDON", "state" : "ND", "county" : "CAVALIER" },
            "58250": { "city" : "LANKIN", "state" : "ND", "county" : "WALSH" },"58251": { "city" : "LARIMORE", "state" : "ND", "county" : "GRAND FORKS" },
            "58254": { "city" : "MCVILLE", "state" : "ND", "county" : "NELSON" },
            "58256": { "city" : "MANVEL", "state" : "ND", "county" : "GRAND FORKS" },
            "58257": { "city" : "MAYVILLE", "state" : "ND", "county" : "TRAILL" },
            "58258": { "city" : "MEKINOCK", "state" : "ND", "county" : "GRAND FORKS" },
            "58259": { "city" : "MICHIGAN", "state" : "ND", "county" : "NELSON" },
            "58260": { "city" : "MILTON", "state" : "ND", "county" : "CAVALIER" },
            "58261": { "city" : "MINTO", "state" : "ND", "county" : "WALSH" },"58262": { "city" : "MOUNTAIN", "state" : "ND", "county" : "PEMBINA" },
            "58265": { "city" : "NECHE", "state" : "ND", "county" : "PEMBINA" },"58266": { "city" : "NIAGARA", "state" : "ND", "county" : "GRAND FORKS" },
            "58267": { "city" : "NORTHWOOD", "state" : "ND", "county" : "GRAND FORKS" },
            "58269": { "city" : "OSNABROCK", "state" : "ND", "county" : "CAVALIER" },
            "58270": { "city" : "PARK RIVER", "state" : "ND", "county" : "WALSH" },
            "58271": { "city" : "PEMBINA", "state" : "ND", "county" : "PEMBINA" },
            "58272": { "city" : "PETERSBURG", "state" : "ND", "county" : "NELSON" },
            "58273": { "city" : "PISEK", "state" : "ND", "county" : "WALSH" },"58274": { "city" : "PORTLAND", "state" : "ND", "county" : "TRAILL" },
            "58275": { "city" : "REYNOLDS", "state" : "ND", "county" : "GRAND FORKS" },
            "58276": { "city" : "SAINT THOMAS", "state" : "ND", "county" : "PEMBINA" },
            "58277": { "city" : "SHARON", "state" : "ND", "county" : "STEELE" },"58278": { "city" : "THOMPSON", "state" : "ND", "county" : "GRAND FORKS" },
            "58281": { "city" : "WALES", "state" : "ND", "county" : "CAVALIER" },
            "58282": { "city" : "WALHALLA", "state" : "ND", "county" : "PEMBINA" },
            "58301": { "city" : "DEVILS LAKE", "state" : "ND", "county" : "RAMSEY" },
            "58311": { "city" : "ALSEN", "state" : "ND", "county" : "CAVALIER" },
            "58313": { "city" : "BALTA", "state" : "ND", "county" : "PIERCE" },"58316": { "city" : "BELCOURT", "state" : "ND", "county" : "ROLETTE" },
            "58317": { "city" : "BISBEE", "state" : "ND", "county" : "TOWNER" },"58318": { "city" : "BOTTINEAU", "state" : "ND", "county" : "BOTTINEAU" },
            "58321": { "city" : "BROCKET", "state" : "ND", "county" : "RAMSEY" },
            "58323": { "city" : "CALVIN", "state" : "ND", "county" : "CAVALIER" },
            "58324": { "city" : "CANDO", "state" : "ND", "county" : "TOWNER" },"58325": { "city" : "CHURCHS FERRY", "state" : "ND", "county" : "RAMSEY" },
            "58327": { "city" : "CRARY", "state" : "ND", "county" : "RAMSEY" },"58329": { "city" : "DUNSEITH", "state" : "ND", "county" : "ROLETTE" },
            "58330": { "city" : "EDMORE", "state" : "ND", "county" : "RAMSEY" },"58331": { "city" : "EGELAND", "state" : "ND", "county" : "TOWNER" },
            "58332": { "city" : "ESMOND", "state" : "ND", "county" : "BENSON" },"58335": { "city" : "FORT TOTTEN", "state" : "ND", "county" : "BENSON" },
            "58338": { "city" : "HAMPDEN", "state" : "ND", "county" : "RAMSEY" },
            "58339": { "city" : "HANSBORO", "state" : "ND", "county" : "TOWNER" },
            "58341": { "city" : "HARVEY", "state" : "ND", "county" : "WELLS" },"58344": { "city" : "LAKOTA", "state" : "ND", "county" : "NELSON" },
            "58345": { "city" : "LAWTON", "state" : "ND", "county" : "RAMSEY" },"58346": { "city" : "LEEDS", "state" : "ND", "county" : "BENSON" },
            "58348": { "city" : "MADDOCK", "state" : "ND", "county" : "BENSON" },
            "58351": { "city" : "MINNEWAUKAN", "state" : "ND", "county" : "BENSON" },
            "58352": { "city" : "MUNICH", "state" : "ND", "county" : "CAVALIER" },
            "58353": { "city" : "MYLO", "state" : "ND", "county" : "ROLETTE" },"58355": { "city" : "NEKOMA", "state" : "ND", "county" : "CAVALIER" },
            "58356": { "city" : "NEW ROCKFORD", "state" : "ND", "county" : "EDDY" },
            "58357": { "city" : "OBERON", "state" : "ND", "county" : "BENSON" },"58361": { "city" : "PEKIN", "state" : "ND", "county" : "NELSON" },
            "58363": { "city" : "PERTH", "state" : "ND", "county" : "TOWNER" },"58365": { "city" : "ROCKLAKE", "state" : "ND", "county" : "TOWNER" },
            "58366": { "city" : "ROLETTE", "state" : "ND", "county" : "ROLETTE" },
            "58367": { "city" : "ROLLA", "state" : "ND", "county" : "ROLETTE" },"58368": { "city" : "RUGBY", "state" : "ND", "county" : "PIERCE" },
            "58369": { "city" : "SAINT JOHN", "state" : "ND", "county" : "ROLETTE" },
            "58370": { "city" : "SAINT MICHAEL", "state" : "ND", "county" : "BENSON" },
            "58372": { "city" : "SARLES", "state" : "ND", "county" : "CAVALIER" },
            "58374": { "city" : "SHEYENNE", "state" : "ND", "county" : "EDDY" },"58377": { "city" : "STARKWEATHER", "state" : "ND", "county" : "RAMSEY" },
            "58380": { "city" : "TOLNA", "state" : "ND", "county" : "NELSON" },"58381": { "city" : "WARWICK", "state" : "ND", "county" : "BENSON" },
            "58382": { "city" : "WEBSTER", "state" : "ND", "county" : "RAMSEY" },
            "58384": { "city" : "WILLOW CITY", "state" : "ND", "county" : "BOTTINEAU" },
            "58385": { "city" : "WOLFORD", "state" : "ND", "county" : "PIERCE" },
            "58386": { "city" : "YORK", "state" : "ND", "county" : "BENSON" },"58401": { "city" : "JAMESTOWN", "state" : "ND", "county" : "STUTSMAN" },
            "58402": { "city" : "JAMESTOWN", "state" : "ND", "county" : "STUTSMAN" },
            "58405": { "city" : "JAMESTOWN", "state" : "ND", "county" : "STUTSMAN" },
            "58413": { "city" : "ASHLEY", "state" : "ND", "county" : "MCINTOSH" },
            "58415": { "city" : "BERLIN", "state" : "ND", "county" : "LAMOURE" },
            "58416": { "city" : "BINFORD", "state" : "ND", "county" : "GRIGGS" },
            "58418": { "city" : "BOWDON", "state" : "ND", "county" : "WELLS" },"58420": { "city" : "BUCHANAN", "state" : "ND", "county" : "STUTSMAN" },
            "58421": { "city" : "CARRINGTON", "state" : "ND", "county" : "FOSTER" },
            "58422": { "city" : "CATHAY", "state" : "ND", "county" : "WELLS" },"58423": { "city" : "CHASELEY", "state" : "ND", "county" : "WELLS" },
            "58424": { "city" : "CLEVELAND", "state" : "ND", "county" : "STUTSMAN" },
            "58425": { "city" : "COOPERSTOWN", "state" : "ND", "county" : "GRIGGS" },
            "58426": { "city" : "COURTENAY", "state" : "ND", "county" : "STUTSMAN" },
            "58428": { "city" : "DAWSON", "state" : "ND", "county" : "KIDDER" },"58429": { "city" : "DAZEY", "state" : "ND", "county" : "BARNES" },
            "58431": { "city" : "DICKEY", "state" : "ND", "county" : "LAMOURE" },
            "58433": { "city" : "EDGELEY", "state" : "ND", "county" : "LAMOURE" },
            "58436": { "city" : "ELLENDALE", "state" : "ND", "county" : "DICKEY" },
            "58438": { "city" : "FESSENDEN", "state" : "ND", "county" : "WELLS" },
            "58439": { "city" : "FORBES", "state" : "ND", "county" : "DICKEY" },"58440": { "city" : "FREDONIA", "state" : "ND", "county" : "LOGAN" },
            "58441": { "city" : "FULLERTON", "state" : "ND", "county" : "DICKEY" },
            "58442": { "city" : "GACKLE", "state" : "ND", "county" : "LOGAN" },"58443": { "city" : "GLENFIELD", "state" : "ND", "county" : "FOSTER" },
            "58444": { "city" : "GOODRICH", "state" : "ND", "county" : "SHERIDAN" },
            "58445": { "city" : "GRACE CITY", "state" : "ND", "county" : "FOSTER" },
            "58448": { "city" : "HANNAFORD", "state" : "ND", "county" : "GRIGGS" },
            "58451": { "city" : "HURDSFIELD", "state" : "ND", "county" : "WELLS" },
            "58454": { "city" : "JUD", "state" : "ND", "county" : "LAMOURE" },"58455": { "city" : "KENSAL", "state" : "ND", "county" : "STUTSMAN" },
            "58456": { "city" : "KULM", "state" : "ND", "county" : "LAMOURE" },"58458": { "city" : "LAMOURE", "state" : "ND", "county" : "LAMOURE" },
            "58460": { "city" : "LEHR", "state" : "ND", "county" : "MCINTOSH" },"58461": { "city" : "LITCHVILLE", "state" : "ND", "county" : "BARNES" },
            "58463": { "city" : "MCCLUSKY", "state" : "ND", "county" : "SHERIDAN" },
            "58464": { "city" : "MCHENRY", "state" : "ND", "county" : "FOSTER" },
            "58466": { "city" : "MARION", "state" : "ND", "county" : "LAMOURE" },
            "58467": { "city" : "MEDINA", "state" : "ND", "county" : "STUTSMAN" },
            "58472": { "city" : "MONTPELIER", "state" : "ND", "county" : "STUTSMAN" },
            "58474": { "city" : "OAKES", "state" : "ND", "county" : "DICKEY" },"58475": { "city" : "PETTIBONE", "state" : "ND", "county" : "KIDDER" },
            "58476": { "city" : "PINGREE", "state" : "ND", "county" : "STUTSMAN" },
            "58477": { "city" : "REGAN", "state" : "ND", "county" : "BURLEIGH" },
            "58478": { "city" : "ROBINSON", "state" : "ND", "county" : "KIDDER" },
            "58479": { "city" : "ROGERS", "state" : "ND", "county" : "BARNES" },"58480": { "city" : "SANBORN", "state" : "ND", "county" : "BARNES" },
            "58481": { "city" : "SPIRITWOOD", "state" : "ND", "county" : "BARNES" },
            "58482": { "city" : "STEELE", "state" : "ND", "county" : "KIDDER" },"58483": { "city" : "STREETER", "state" : "ND", "county" : "STUTSMAN" },
            "58484": { "city" : "SUTTON", "state" : "ND", "county" : "GRIGGS" },"58486": { "city" : "SYKESTON", "state" : "ND", "county" : "WELLS" },
            "58487": { "city" : "TAPPEN", "state" : "ND", "county" : "KIDDER" },"58488": { "city" : "TUTTLE", "state" : "ND", "county" : "KIDDER" },
            "58490": { "city" : "VERONA", "state" : "ND", "county" : "LAMOURE" },
            "58492": { "city" : "WIMBLEDON", "state" : "ND", "county" : "BARNES" },
            "58494": { "city" : "WING", "state" : "ND", "county" : "BURLEIGH" },"58495": { "city" : "WISHEK", "state" : "ND", "county" : "MCINTOSH" },
            "58496": { "city" : "WOODWORTH", "state" : "ND", "county" : "STUTSMAN" },
            "58497": { "city" : "YPSILANTI", "state" : "ND", "county" : "STUTSMAN" },
            "58501": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58502": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58503": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58504": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58505": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58506": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58507": { "city" : "BISMARCK", "state" : "ND", "county" : "BURLEIGH" },
            "58520": { "city" : "ALMONT", "state" : "ND", "county" : "MORTON" },"58521": { "city" : "BALDWIN", "state" : "ND", "county" : "BURLEIGH" },
            "58523": { "city" : "BEULAH", "state" : "ND", "county" : "MERCER" },"58524": { "city" : "BRADDOCK", "state" : "ND", "county" : "EMMONS" },
            "58528": { "city" : "CANNON BALL", "state" : "ND", "county" : "SIOUX" },
            "58529": { "city" : "CARSON", "state" : "ND", "county" : "GRANT" },"58530": { "city" : "CENTER", "state" : "ND", "county" : "OLIVER" },
            "58531": { "city" : "COLEHARBOR", "state" : "ND", "county" : "MCLEAN" },
            "58532": { "city" : "DRISCOLL", "state" : "ND", "county" : "BURLEIGH" },
            "58533": { "city" : "ELGIN", "state" : "ND", "county" : "GRANT" },"58535": { "city" : "FLASHER", "state" : "ND", "county" : "MORTON" },
            "58538": { "city" : "FORT YATES", "state" : "ND", "county" : "SIOUX" },
            "58540": { "city" : "GARRISON", "state" : "ND", "county" : "MCLEAN" },
            "58541": { "city" : "GOLDEN VALLEY", "state" : "ND", "county" : "MERCER" },
            "58542": { "city" : "HAGUE", "state" : "ND", "county" : "EMMONS" },"58544": { "city" : "HAZELTON", "state" : "ND", "county" : "EMMONS" },
            "58545": { "city" : "HAZEN", "state" : "ND", "county" : "MERCER" },"58549": { "city" : "KINTYRE", "state" : "ND", "county" : "EMMONS" },
            "58552": { "city" : "LINTON", "state" : "ND", "county" : "EMMONS" },"58554": { "city" : "MANDAN", "state" : "ND", "county" : "MORTON" },
            "58558": { "city" : "MENOKEN", "state" : "ND", "county" : "BURLEIGH" },
            "58559": { "city" : "MERCER", "state" : "ND", "county" : "MCLEAN" },"58561": { "city" : "NAPOLEON", "state" : "ND", "county" : "LOGAN" },
            "58562": { "city" : "NEW LEIPZIG", "state" : "ND", "county" : "GRANT" },
            "58563": { "city" : "NEW SALEM", "state" : "ND", "county" : "MORTON" },
            "58564": { "city" : "RALEIGH", "state" : "ND", "county" : "GRANT" },"58565": { "city" : "RIVERDALE", "state" : "ND", "county" : "MCLEAN" },
            "58566": { "city" : "SAINT ANTHONY", "state" : "ND", "county" : "MORTON" },
            "58568": { "city" : "SELFRIDGE", "state" : "ND", "county" : "SIOUX" },
            "58570": { "city" : "SOLEN", "state" : "ND", "county" : "SIOUX" },"58571": { "city" : "STANTON", "state" : "ND", "county" : "MERCER" },
            "58572": { "city" : "STERLING", "state" : "ND", "county" : "BURLEIGH" },
            "58573": { "city" : "STRASBURG", "state" : "ND", "county" : "EMMONS" },
            "58575": { "city" : "TURTLE LAKE", "state" : "ND", "county" : "MCLEAN" },
            "58576": { "city" : "UNDERWOOD", "state" : "ND", "county" : "MCLEAN" },
            "58577": { "city" : "WASHBURN", "state" : "ND", "county" : "MCLEAN" },
            "58579": { "city" : "WILTON", "state" : "ND", "county" : "MCLEAN" },"58580": { "city" : "ZAP", "state" : "ND", "county" : "MERCER" },
            "58581": { "city" : "ZEELAND", "state" : "ND", "county" : "MCINTOSH" },
            "58601": { "city" : "DICKINSON", "state" : "ND", "county" : "STARK" },
            "58602": { "city" : "DICKINSON", "state" : "ND", "county" : "STARK" },
            "58620": { "city" : "AMIDON", "state" : "ND", "county" : "SLOPE" },"58621": { "city" : "BEACH", "state" : "ND", "county" : "GOLDEN VALLEY" },
            "58622": { "city" : "BELFIELD", "state" : "ND", "county" : "STARK" },
            "58623": { "city" : "BOWMAN", "state" : "ND", "county" : "BOWMAN" },"58625": { "city" : "DODGE", "state" : "ND", "county" : "DUNN" },
            "58626": { "city" : "DUNN CENTER", "state" : "ND", "county" : "DUNN" },
            "58627": { "city" : "FAIRFIELD", "state" : "ND", "county" : "BILLINGS" },
            "58630": { "city" : "GLADSTONE", "state" : "ND", "county" : "STARK" },
            "58631": { "city" : "GLEN ULLIN", "state" : "ND", "county" : "MORTON" },
            "58632": { "city" : "GOLVA", "state" : "ND", "county" : "GOLDEN VALLEY" },
            "58634": { "city" : "GRASSY BUTTE", "state" : "ND", "county" : "MCKENZIE" },
            "58636": { "city" : "HALLIDAY", "state" : "ND", "county" : "DUNN" },"58638": { "city" : "HEBRON", "state" : "ND", "county" : "MORTON" },
            "58639": { "city" : "HETTINGER", "state" : "ND", "county" : "ADAMS" },
            "58640": { "city" : "KILLDEER", "state" : "ND", "county" : "DUNN" },"58642": { "city" : "MANNING", "state" : "ND", "county" : "DUNN" },
            "58643": { "city" : "MARMARTH", "state" : "ND", "county" : "SLOPE" },
            "58645": { "city" : "MEDORA", "state" : "ND", "county" : "BILLINGS" },
            "58646": { "city" : "MOTT", "state" : "ND", "county" : "HETTINGER" },
            "58647": { "city" : "NEW ENGLAND", "state" : "ND", "county" : "HETTINGER" },
            "58649": { "city" : "REEDER", "state" : "ND", "county" : "ADAMS" },"58650": { "city" : "REGENT", "state" : "ND", "county" : "HETTINGER" },
            "58651": { "city" : "RHAME", "state" : "ND", "county" : "BOWMAN" },"58652": { "city" : "RICHARDTON", "state" : "ND", "county" : "STARK" },
            "58653": { "city" : "SCRANTON", "state" : "ND", "county" : "BOWMAN" },
            "58654": { "city" : "SENTINEL BUTTE", "state" : "ND", "county" : "GOLDEN VALLEY" },
            "58655": { "city" : "SOUTH HEART", "state" : "ND", "county" : "STARK" },
            "58656": { "city" : "TAYLOR", "state" : "ND", "county" : "STARK" },"58701": { "city" : "MINOT", "state" : "ND", "county" : "WARD" },
            "58702": { "city" : "MINOT", "state" : "ND", "county" : "WARD" },"58703": { "city" : "MINOT", "state" : "ND", "county" : "WARD" },
            "58704": { "city" : "MINOT AFB", "state" : "ND", "county" : "WARD" },
            "58705": { "city" : "MINOT AFB", "state" : "ND", "county" : "WARD" },
            "58707": { "city" : "MINOT", "state" : "ND", "county" : "WARD" },"58710": { "city" : "ANAMOOSE", "state" : "ND", "county" : "MCHENRY" },
            "58711": { "city" : "ANTLER", "state" : "ND", "county" : "BOTTINEAU" },
            "58712": { "city" : "BALFOUR", "state" : "ND", "county" : "MCHENRY" },
            "58716": { "city" : "BENEDICT", "state" : "ND", "county" : "MCLEAN" },
            "58718": { "city" : "BERTHOLD", "state" : "ND", "county" : "WARD" },"58721": { "city" : "BOWBELLS", "state" : "ND", "county" : "BURKE" },
            "58722": { "city" : "BURLINGTON", "state" : "ND", "county" : "WARD" },
            "58723": { "city" : "BUTTE", "state" : "ND", "county" : "MCLEAN" },"58725": { "city" : "CARPIO", "state" : "ND", "county" : "WARD" },
            "58727": { "city" : "COLUMBUS", "state" : "ND", "county" : "BURKE" },
            "58730": { "city" : "CROSBY", "state" : "ND", "county" : "DIVIDE" },"58731": { "city" : "DEERING", "state" : "ND", "county" : "MCHENRY" },
            "58733": { "city" : "DES LACS", "state" : "ND", "county" : "WARD" },"58734": { "city" : "DONNYBROOK", "state" : "ND", "county" : "WARD" },
            "58735": { "city" : "DOUGLAS", "state" : "ND", "county" : "WARD" },"58736": { "city" : "DRAKE", "state" : "ND", "county" : "MCHENRY" },
            "58737": { "city" : "FLAXTON", "state" : "ND", "county" : "BURKE" },"58740": { "city" : "GLENBURN", "state" : "ND", "county" : "RENVILLE" },
            "58741": { "city" : "GRANVILLE", "state" : "ND", "county" : "MCHENRY" },
            "58744": { "city" : "KARLSRUHE", "state" : "ND", "county" : "MCHENRY" },
            "58746": { "city" : "KENMARE", "state" : "ND", "county" : "WARD" },"58748": { "city" : "KRAMER", "state" : "ND", "county" : "BOTTINEAU" },
            "58750": { "city" : "LANSFORD", "state" : "ND", "county" : "BOTTINEAU" },
            "58752": { "city" : "LIGNITE", "state" : "ND", "county" : "BURKE" },"58755": { "city" : "MCGREGOR", "state" : "ND", "county" : "WILLIAMS" },
            "58756": { "city" : "MAKOTI", "state" : "ND", "county" : "WARD" },"58757": { "city" : "MANDAREE", "state" : "ND", "county" : "MCKENZIE" },
            "58758": { "city" : "MARTIN", "state" : "ND", "county" : "SHERIDAN" },
            "58759": { "city" : "MAX", "state" : "ND", "county" : "MCLEAN" },"58760": { "city" : "MAXBASS", "state" : "ND", "county" : "BOTTINEAU" },
            "58761": { "city" : "MOHALL", "state" : "ND", "county" : "RENVILLE" },
            "58762": { "city" : "NEWBURG", "state" : "ND", "county" : "BOTTINEAU" },
            "58763": { "city" : "NEW TOWN", "state" : "ND", "county" : "MOUNTRAIL" },
            "58765": { "city" : "NOONAN", "state" : "ND", "county" : "DIVIDE" },"58768": { "city" : "NORWICH", "state" : "ND", "county" : "MCHENRY" },
            "58769": { "city" : "PALERMO", "state" : "ND", "county" : "MOUNTRAIL" },
            "58770": { "city" : "PARSHALL", "state" : "ND", "county" : "MOUNTRAIL" },
            "58771": { "city" : "PLAZA", "state" : "ND", "county" : "MOUNTRAIL" },
            "58772": { "city" : "PORTAL", "state" : "ND", "county" : "BURKE" },"58773": { "city" : "POWERS LAKE", "state" : "ND", "county" : "BURKE" },
            "58775": { "city" : "ROSEGLEN", "state" : "ND", "county" : "MCLEAN" },
            "58776": { "city" : "ROSS", "state" : "ND", "county" : "MOUNTRAIL" },
            "58778": { "city" : "RUSO", "state" : "ND", "county" : "MCLEAN" },"58779": { "city" : "RYDER", "state" : "ND", "county" : "WARD" },
            "58781": { "city" : "SAWYER", "state" : "ND", "county" : "WARD" },"58782": { "city" : "SHERWOOD", "state" : "ND", "county" : "RENVILLE" },
            "58783": { "city" : "SOURIS", "state" : "ND", "county" : "BOTTINEAU" },
            "58784": { "city" : "STANLEY", "state" : "ND", "county" : "MOUNTRAIL" },
            "58785": { "city" : "SURREY", "state" : "ND", "county" : "WARD" },"58787": { "city" : "TOLLEY", "state" : "ND", "county" : "RENVILLE" },
            "58788": { "city" : "TOWNER", "state" : "ND", "county" : "MCHENRY" },
            "58789": { "city" : "UPHAM", "state" : "ND", "county" : "MCHENRY" },"58790": { "city" : "VELVA", "state" : "ND", "county" : "MCHENRY" },
            "58792": { "city" : "VOLTAIRE", "state" : "ND", "county" : "MCHENRY" },
            "58793": { "city" : "WESTHOPE", "state" : "ND", "county" : "BOTTINEAU" },
            "58794": { "city" : "WHITE EARTH", "state" : "ND", "county" : "MOUNTRAIL" },
            "58795": { "city" : "WILDROSE", "state" : "ND", "county" : "WILLIAMS" },
            "58801": { "city" : "WILLISTON", "state" : "ND", "county" : "WILLIAMS" },
            "58802": { "city" : "WILLISTON", "state" : "ND", "county" : "WILLIAMS" },
            "58830": { "city" : "ALAMO", "state" : "ND", "county" : "WILLIAMS" },
            "58831": { "city" : "ALEXANDER", "state" : "ND", "county" : "MCKENZIE" },
            "58833": { "city" : "AMBROSE", "state" : "ND", "county" : "DIVIDE" },
            "58835": { "city" : "ARNEGARD", "state" : "ND", "county" : "MCKENZIE" },
            "58838": { "city" : "CARTWRIGHT", "state" : "ND", "county" : "MCKENZIE" },
            "58843": { "city" : "EPPING", "state" : "ND", "county" : "WILLIAMS" },
            "58844": { "city" : "FORTUNA", "state" : "ND", "county" : "DIVIDE" },
            "58845": { "city" : "GRENORA", "state" : "ND", "county" : "WILLIAMS" },
            "58847": { "city" : "KEENE", "state" : "ND", "county" : "MCKENZIE" },
            "58849": { "city" : "RAY", "state" : "ND", "county" : "WILLIAMS" },"58852": { "city" : "TIOGA", "state" : "ND", "county" : "WILLIAMS" },
            "58853": { "city" : "TRENTON", "state" : "ND", "county" : "WILLIAMS" },
            "58854": { "city" : "WATFORD CITY", "state" : "ND", "county" : "MCKENZIE" },
            "58856": { "city" : "ZAHL", "state" : "ND", "county" : "WILLIAMS" },"59001": { "city" : "ABSAROKEE", "state" : "MT", "county" : "STILLWATER" },
            "59003": { "city" : "ASHLAND", "state" : "MT", "county" : "ROSEBUD" },
            "59006": { "city" : "BALLANTINE", "state" : "MT", "county" : "YELLOWSTONE" },
            "59007": { "city" : "BEARCREEK", "state" : "MT", "county" : "CARBON" },
            "59008": { "city" : "BELFRY", "state" : "MT", "county" : "CARBON" },"59010": { "city" : "BIGHORN", "state" : "MT", "county" : "TREASURE" },
            "59011": { "city" : "BIG TIMBER", "state" : "MT", "county" : "SWEET GRASS" },
            "59012": { "city" : "BIRNEY", "state" : "MT", "county" : "ROSEBUD" },
            "59013": { "city" : "BOYD", "state" : "MT", "county" : "CARBON" },"59014": { "city" : "BRIDGER", "state" : "MT", "county" : "CARBON" },
            "59015": { "city" : "BROADVIEW", "state" : "MT", "county" : "YELLOWSTONE" },
            "59016": { "city" : "BUSBY", "state" : "MT", "county" : "BIG HORN" },
            "59018": { "city" : "CLYDE PARK", "state" : "MT", "county" : "PARK" },
            "59019": { "city" : "COLUMBUS", "state" : "MT", "county" : "STILLWATER" },
            "59020": { "city" : "COOKE CITY", "state" : "MT", "county" : "PARK" },
            "59022": { "city" : "CROW AGENCY", "state" : "MT", "county" : "BIG HORN" },
            "59024": { "city" : "CUSTER", "state" : "MT", "county" : "YELLOWSTONE" },
            "59025": { "city" : "DECKER", "state" : "MT", "county" : "BIG HORN" },
            "59026": { "city" : "EDGAR", "state" : "MT", "county" : "CARBON" },"59027": { "city" : "EMIGRANT", "state" : "MT", "county" : "PARK" },
            "59028": { "city" : "FISHTAIL", "state" : "MT", "county" : "STILLWATER" },
            "59029": { "city" : "FROMBERG", "state" : "MT", "county" : "CARBON" },
            "59030": { "city" : "GARDINER", "state" : "MT", "county" : "PARK" },"59031": { "city" : "GARRYOWEN", "state" : "MT", "county" : "BIG HORN" },
            "59032": { "city" : "GRASS RANGE", "state" : "MT", "county" : "FERGUS" },
            "59033": { "city" : "GREYCLIFF", "state" : "MT", "county" : "SWEET GRASS" },
            "59034": { "city" : "HARDIN", "state" : "MT", "county" : "BIG HORN" },
            "59035": { "city" : "YELLOWTAIL", "state" : "MT", "county" : "BIG HORN" },
            "59036": { "city" : "HARLOWTON", "state" : "MT", "county" : "WHEATLAND" },
            "59037": { "city" : "HUNTLEY", "state" : "MT", "county" : "YELLOWSTONE" },
            "59038": { "city" : "HYSHAM", "state" : "MT", "county" : "TREASURE" },
            "59039": { "city" : "INGOMAR", "state" : "MT", "county" : "ROSEBUD" },
            "59041": { "city" : "JOLIET", "state" : "MT", "county" : "CARBON" },"59043": { "city" : "LAME DEER", "state" : "MT", "county" : "ROSEBUD" },
            "59044": { "city" : "LAUREL", "state" : "MT", "county" : "YELLOWSTONE" },
            "59046": { "city" : "LAVINA", "state" : "MT", "county" : "GOLDEN VALLEY" },
            "59047": { "city" : "LIVINGSTON", "state" : "MT", "county" : "PARK" },
            "59050": { "city" : "LODGE GRASS", "state" : "MT", "county" : "BIG HORN" },
            "59052": { "city" : "MC LEOD", "state" : "MT", "county" : "SWEET GRASS" },
            "59053": { "city" : "MARTINSDALE", "state" : "MT", "county" : "MEAGHER" },
            "59054": { "city" : "MELSTONE", "state" : "MT", "county" : "MUSSELSHELL" },
            "59055": { "city" : "MELVILLE", "state" : "MT", "county" : "SWEET GRASS" },
            "59057": { "city" : "MOLT", "state" : "MT", "county" : "YELLOWSTONE" },
            "59059": { "city" : "MUSSELSHELL", "state" : "MT", "county" : "MUSSELSHELL" },
            "59061": { "city" : "NYE", "state" : "MT", "county" : "STILLWATER" },
            "59062": { "city" : "OTTER", "state" : "MT", "county" : "POWDER RIVER" },
            "59063": { "city" : "PARK CITY", "state" : "MT", "county" : "STILLWATER" },
            "59064": { "city" : "POMPEYS PILLAR", "state" : "MT", "county" : "YELLOWSTONE" },
            "59065": { "city" : "PRAY", "state" : "MT", "county" : "PARK" },"59066": { "city" : "PRYOR", "state" : "MT", "county" : "BIG HORN" },
            "59067": { "city" : "RAPELJE", "state" : "MT", "county" : "STILLWATER" },
            "59068": { "city" : "RED LODGE", "state" : "MT", "county" : "CARBON" },
            "59069": { "city" : "REED POINT", "state" : "MT", "county" : "STILLWATER" },
            "59070": { "city" : "ROBERTS", "state" : "MT", "county" : "CARBON" },
            "59071": { "city" : "ROSCOE", "state" : "MT", "county" : "CARBON" },"59072": { "city" : "ROUNDUP", "state" : "MT", "county" : "MUSSELSHELL" },
            "59074": { "city" : "RYEGATE", "state" : "MT", "county" : "GOLDEN VALLEY" },
            "59075": { "city" : "SAINT XAVIER", "state" : "MT", "county" : "BIG HORN" },
            "59078": { "city" : "SHAWMUT", "state" : "MT", "county" : "WHEATLAND" },
            "59079": { "city" : "SHEPHERD", "state" : "MT", "county" : "YELLOWSTONE" },
            "59081": { "city" : "SILVER GATE", "state" : "MT", "county" : "PARK" },
            "59085": { "city" : "TWO DOT", "state" : "MT", "county" : "WHEATLAND" },
            "59086": { "city" : "WILSALL", "state" : "MT", "county" : "PARK" },"59087": { "city" : "WINNETT", "state" : "MT", "county" : "PETROLEUM" },
            "59088": { "city" : "WORDEN", "state" : "MT", "county" : "YELLOWSTONE" },
            "59101": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59102": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59103": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59104": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59105": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59106": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59107": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59108": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59116": { "city" : "BILLINGS", "state" : "MT", "county" : "YELLOWSTONE" },
            "59201": { "city" : "WOLF POINT", "state" : "MT", "county" : "ROOSEVELT" },
            "59211": { "city" : "ANTELOPE", "state" : "MT", "county" : "SHERIDAN" },
            "59212": { "city" : "BAINVILLE", "state" : "MT", "county" : "ROOSEVELT" },
            "59213": { "city" : "BROCKTON", "state" : "MT", "county" : "ROOSEVELT" },
            "59214": { "city" : "BROCKWAY", "state" : "MT", "county" : "MCCONE" },
            "59215": { "city" : "CIRCLE", "state" : "MT", "county" : "MCCONE" },"59217": { "city" : "CRANE", "state" : "MT", "county" : "RICHLAND" },
            "59218": { "city" : "CULBERTSON", "state" : "MT", "county" : "ROOSEVELT" },
            "59219": { "city" : "DAGMAR", "state" : "MT", "county" : "SHERIDAN" },
            "59221": { "city" : "FAIRVIEW", "state" : "MT", "county" : "RICHLAND" },
            "59222": { "city" : "FLAXVILLE", "state" : "MT", "county" : "DANIELS" },
            "59223": { "city" : "FORT PECK", "state" : "MT", "county" : "VALLEY" },
            "59225": { "city" : "FRAZER", "state" : "MT", "county" : "VALLEY" },"59226": { "city" : "FROID", "state" : "MT", "county" : "ROOSEVELT" },
            "59230": { "city" : "GLASGOW", "state" : "MT", "county" : "VALLEY" },
            "59231": { "city" : "SAINT MARIE", "state" : "MT", "county" : "VALLEY" },
            "59241": { "city" : "HINSDALE", "state" : "MT", "county" : "VALLEY" },
            "59243": { "city" : "LAMBERT", "state" : "MT", "county" : "RICHLAND" },
            "59244": { "city" : "LARSLAN", "state" : "MT", "county" : "VALLEY" },
            "59247": { "city" : "MEDICINE LAKE", "state" : "MT", "county" : "SHERIDAN" },
            "59248": { "city" : "NASHUA", "state" : "MT", "county" : "VALLEY" },"59250": { "city" : "OPHEIM", "state" : "MT", "county" : "VALLEY" },
            "59252": { "city" : "OUTLOOK", "state" : "MT", "county" : "SHERIDAN" },
            "59253": { "city" : "PEERLESS", "state" : "MT", "county" : "DANIELS" },
            "59254": { "city" : "PLENTYWOOD", "state" : "MT", "county" : "SHERIDAN" },
            "59255": { "city" : "POPLAR", "state" : "MT", "county" : "ROOSEVELT" },
            "59256": { "city" : "RAYMOND", "state" : "MT", "county" : "SHERIDAN" },
            "59257": { "city" : "REDSTONE", "state" : "MT", "county" : "SHERIDAN" },
            "59259": { "city" : "RICHEY", "state" : "MT", "county" : "DAWSON" },"59260": { "city" : "RICHLAND", "state" : "MT", "county" : "VALLEY" },
            "59261": { "city" : "SACO", "state" : "MT", "county" : "PHILLIPS" },"59262": { "city" : "SAVAGE", "state" : "MT", "county" : "RICHLAND" },
            "59263": { "city" : "SCOBEY", "state" : "MT", "county" : "DANIELS" },
            "59270": { "city" : "SIDNEY", "state" : "MT", "county" : "RICHLAND" },
            "59273": { "city" : "VANDALIA", "state" : "MT", "county" : "VALLEY" },
            "59274": { "city" : "VIDA", "state" : "MT", "county" : "MCCONE" },"59275": { "city" : "WESTBY", "state" : "MT", "county" : "SHERIDAN" },
            "59276": { "city" : "WHITETAIL", "state" : "MT", "county" : "DANIELS" },
            "59301": { "city" : "MILES CITY", "state" : "MT", "county" : "CUSTER" },
            "59311": { "city" : "ALZADA", "state" : "MT", "county" : "CARTER" },"59313": { "city" : "BAKER", "state" : "MT", "county" : "FALLON" },
            "59314": { "city" : "BIDDLE", "state" : "MT", "county" : "POWDER RIVER" },
            "59315": { "city" : "BLOOMFIELD", "state" : "MT", "county" : "DAWSON" },
            "59317": { "city" : "BROADUS", "state" : "MT", "county" : "POWDER RIVER" },
            "59319": { "city" : "CAPITOL", "state" : "MT", "county" : "CARTER" },
            "59323": { "city" : "COLSTRIP", "state" : "MT", "county" : "ROSEBUD" },
            "59324": { "city" : "EKALAKA", "state" : "MT", "county" : "CARTER" },
            "59326": { "city" : "FALLON", "state" : "MT", "county" : "PRAIRIE" },
            "59327": { "city" : "FORSYTH", "state" : "MT", "county" : "ROSEBUD" },
            "59330": { "city" : "GLENDIVE", "state" : "MT", "county" : "DAWSON" },
            "59332": { "city" : "HAMMOND", "state" : "MT", "county" : "CARTER" },
            "59336": { "city" : "ISMAY", "state" : "MT", "county" : "CUSTER" },"59337": { "city" : "JORDAN", "state" : "MT", "county" : "GARFIELD" },
            "59338": { "city" : "KINSEY", "state" : "MT", "county" : "CUSTER" },"59339": { "city" : "LINDSAY", "state" : "MT", "county" : "DAWSON" },
            "59341": { "city" : "MILDRED", "state" : "MT", "county" : "PRAIRIE" },
            "59344": { "city" : "PLEVNA", "state" : "MT", "county" : "FALLON" },"59347": { "city" : "ROSEBUD", "state" : "MT", "county" : "ROSEBUD" },
            "59349": { "city" : "TERRY", "state" : "MT", "county" : "PRAIRIE" },"59351": { "city" : "VOLBORG", "state" : "MT", "county" : "CUSTER" },
            "59353": { "city" : "WIBAUX", "state" : "MT", "county" : "WIBAUX" },"59354": { "city" : "WILLARD", "state" : "MT", "county" : "FALLON" },
            "59401": { "city" : "GREAT FALLS", "state" : "MT", "county" : "CASCADE" },
            "59402": { "city" : "MALMSTROM A F B", "state" : "MT", "county" : "CASCADE" },
            "59403": { "city" : "GREAT FALLS", "state" : "MT", "county" : "CASCADE" },
            "59404": { "city" : "GREAT FALLS", "state" : "MT", "county" : "CASCADE" },
            "59405": { "city" : "GREAT FALLS", "state" : "MT", "county" : "CASCADE" },
            "59406": { "city" : "GREAT FALLS", "state" : "MT", "county" : "CASCADE" },
            "59410": { "city" : "AUGUSTA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59411": { "city" : "BABB", "state" : "MT", "county" : "GLACIER" },"59412": { "city" : "BELT", "state" : "MT", "county" : "CASCADE" },
            "59414": { "city" : "BLACK EAGLE", "state" : "MT", "county" : "CASCADE" },
            "59416": { "city" : "BRADY", "state" : "MT", "county" : "PONDERA" },"59417": { "city" : "BROWNING", "state" : "MT", "county" : "GLACIER" },
            "59418": { "city" : "BUFFALO", "state" : "MT", "county" : "FERGUS" },
            "59419": { "city" : "BYNUM", "state" : "MT", "county" : "TETON" },"59420": { "city" : "CARTER", "state" : "MT", "county" : "CHOUTEAU" },
            "59421": { "city" : "CASCADE", "state" : "MT", "county" : "CASCADE" },
            "59422": { "city" : "CHOTEAU", "state" : "MT", "county" : "TETON" },"59424": { "city" : "COFFEE CREEK", "state" : "MT", "county" : "FERGUS" },
            "59425": { "city" : "CONRAD", "state" : "MT", "county" : "PONDERA" },
            "59427": { "city" : "CUT BANK", "state" : "MT", "county" : "GLACIER" },
            "59430": { "city" : "DENTON", "state" : "MT", "county" : "FERGUS" },"59432": { "city" : "DUPUYER", "state" : "MT", "county" : "PONDERA" },
            "59433": { "city" : "DUTTON", "state" : "MT", "county" : "TETON" },"59434": { "city" : "EAST GLACIER PARK", "state" : "MT", "county" : "GLACIER" },
            "59435": { "city" : "ETHRIDGE", "state" : "MT", "county" : "TOOLE" },
            "59436": { "city" : "FAIRFIELD", "state" : "MT", "county" : "TETON" },
            "59440": { "city" : "FLOWEREE", "state" : "MT", "county" : "CHOUTEAU" },
            "59441": { "city" : "FOREST GROVE", "state" : "MT", "county" : "FERGUS" },
            "59442": { "city" : "FORT BENTON", "state" : "MT", "county" : "CHOUTEAU" },
            "59443": { "city" : "FORT SHAW", "state" : "MT", "county" : "CASCADE" },
            "59444": { "city" : "GALATA", "state" : "MT", "county" : "TOOLE" },"59446": { "city" : "GERALDINE", "state" : "MT", "county" : "CHOUTEAU" },
            "59447": { "city" : "GEYSER", "state" : "MT", "county" : "JUDITH BASIN" },
            "59448": { "city" : "HEART BUTTE", "state" : "MT", "county" : "PONDERA" },
            "59450": { "city" : "HIGHWOOD", "state" : "MT", "county" : "CHOUTEAU" },
            "59451": { "city" : "HILGER", "state" : "MT", "county" : "FERGUS" },"59452": { "city" : "HOBSON", "state" : "MT", "county" : "JUDITH BASIN" },
            "59453": { "city" : "JUDITH GAP", "state" : "MT", "county" : "WHEATLAND" },
            "59454": { "city" : "KEVIN", "state" : "MT", "county" : "TOOLE" },"59457": { "city" : "LEWISTOWN", "state" : "MT", "county" : "FERGUS" },
            "59460": { "city" : "LOMA", "state" : "MT", "county" : "CHOUTEAU" },"59462": { "city" : "MOCCASIN", "state" : "MT", "county" : "JUDITH BASIN" },
            "59463": { "city" : "MONARCH", "state" : "MT", "county" : "CASCADE" },
            "59464": { "city" : "MOORE", "state" : "MT", "county" : "FERGUS" },"59465": { "city" : "NEIHART", "state" : "MT", "county" : "CASCADE" },
            "59466": { "city" : "OILMONT", "state" : "MT", "county" : "TOOLE" },"59467": { "city" : "PENDROY", "state" : "MT", "county" : "TETON" },
            "59468": { "city" : "POWER", "state" : "MT", "county" : "TETON" },"59469": { "city" : "RAYNESFORD", "state" : "MT", "county" : "JUDITH BASIN" },
            "59471": { "city" : "ROY", "state" : "MT", "county" : "FERGUS" },"59472": { "city" : "SAND COULEE", "state" : "MT", "county" : "CASCADE" },
            "59474": { "city" : "SHELBY", "state" : "MT", "county" : "TOOLE" },"59477": { "city" : "SIMMS", "state" : "MT", "county" : "CASCADE" },
            "59479": { "city" : "STANFORD", "state" : "MT", "county" : "JUDITH BASIN" },
            "59480": { "city" : "STOCKETT", "state" : "MT", "county" : "CASCADE" },
            "59482": { "city" : "SUNBURST", "state" : "MT", "county" : "TOOLE" },
            "59483": { "city" : "SUN RIVER", "state" : "MT", "county" : "CASCADE" },
            "59484": { "city" : "SWEET GRASS", "state" : "MT", "county" : "TOOLE" },
            "59485": { "city" : "ULM", "state" : "MT", "county" : "CASCADE" },"59486": { "city" : "VALIER", "state" : "MT", "county" : "PONDERA" },
            "59487": { "city" : "VAUGHN", "state" : "MT", "county" : "CASCADE" },
            "59489": { "city" : "WINIFRED", "state" : "MT", "county" : "FERGUS" },
            "59501": { "city" : "HAVRE", "state" : "MT", "county" : "HILL" },"59520": { "city" : "BIG SANDY", "state" : "MT", "county" : "CHOUTEAU" },
            "59521": { "city" : "BOX ELDER", "state" : "MT", "county" : "HILL" },
            "59522": { "city" : "CHESTER", "state" : "MT", "county" : "LIBERTY" },
            "59523": { "city" : "CHINOOK", "state" : "MT", "county" : "BLAINE" },
            "59524": { "city" : "DODSON", "state" : "MT", "county" : "PHILLIPS" },
            "59525": { "city" : "GILDFORD", "state" : "MT", "county" : "HILL" },"59526": { "city" : "HARLEM", "state" : "MT", "county" : "BLAINE" },
            "59527": { "city" : "HAYS", "state" : "MT", "county" : "BLAINE" },"59528": { "city" : "HINGHAM", "state" : "MT", "county" : "HILL" },
            "59529": { "city" : "HOGELAND", "state" : "MT", "county" : "BLAINE" },
            "59530": { "city" : "INVERNESS", "state" : "MT", "county" : "HILL" },
            "59531": { "city" : "JOPLIN", "state" : "MT", "county" : "LIBERTY" },
            "59532": { "city" : "KREMLIN", "state" : "MT", "county" : "HILL" },"59535": { "city" : "LLOYD", "state" : "MT", "county" : "BLAINE" },
            "59537": { "city" : "LORING", "state" : "MT", "county" : "PHILLIPS" },
            "59538": { "city" : "MALTA", "state" : "MT", "county" : "PHILLIPS" },
            "59540": { "city" : "RUDYARD", "state" : "MT", "county" : "HILL" },"59542": { "city" : "TURNER", "state" : "MT", "county" : "BLAINE" },
            "59544": { "city" : "WHITEWATER", "state" : "MT", "county" : "PHILLIPS" },
            "59545": { "city" : "WHITLASH", "state" : "MT", "county" : "LIBERTY" },
            "59546": { "city" : "ZORTMAN", "state" : "MT", "county" : "PHILLIPS" },
            "59547": { "city" : "ZURICH", "state" : "MT", "county" : "BLAINE" },"59601": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59602": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59604": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59620": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59624": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59625": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59626": { "city" : "HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59631": { "city" : "BASIN", "state" : "MT", "county" : "JEFFERSON" },
            "59632": { "city" : "BOULDER", "state" : "MT", "county" : "JEFFERSON" },
            "59633": { "city" : "CANYON CREEK", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59634": { "city" : "CLANCY", "state" : "MT", "county" : "JEFFERSON" },
            "59635": { "city" : "EAST HELENA", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59636": { "city" : "FORT HARRISON", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59638": { "city" : "JEFFERSON CITY", "state" : "MT", "county" : "JEFFERSON" },
            "59639": { "city" : "LINCOLN", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59640": { "city" : "MARYSVILLE", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59642": { "city" : "RINGLING", "state" : "MT", "county" : "MEAGHER" },
            "59643": { "city" : "TOSTON", "state" : "MT", "county" : "BROADWATER" },
            "59644": { "city" : "TOWNSEND", "state" : "MT", "county" : "BROADWATER" },
            "59645": { "city" : "WHITE SULPHUR SPRINGS", "state" : "MT", "county" : "MEAGHER" },
            "59647": { "city" : "WINSTON", "state" : "MT", "county" : "BROADWATER" },
            "59648": { "city" : "WOLF CREEK", "state" : "MT", "county" : "LEWIS AND CLARK" },
            "59701": { "city" : "BUTTE", "state" : "MT", "county" : "SILVER BOW" },
            "59702": { "city" : "BUTTE", "state" : "MT", "county" : "SILVER BOW" },
            "59703": { "city" : "BUTTE", "state" : "MT", "county" : "SILVER BOW" },
            "59710": { "city" : "ALDER", "state" : "MT", "county" : "MADISON" },"59711": { "city" : "ANACONDA", "state" : "MT", "county" : "DEER LODGE" },
            "59713": { "city" : "AVON", "state" : "MT", "county" : "POWELL" },"59714": { "city" : "BELGRADE", "state" : "MT", "county" : "GALLATIN" },
            "59715": { "city" : "BOZEMAN", "state" : "MT", "county" : "GALLATIN" },
            "59716": { "city" : "BIG SKY", "state" : "MT", "county" : "GALLATIN" },
            "59717": { "city" : "BOZEMAN", "state" : "MT", "county" : "GALLATIN" },
            "59718": { "city" : "BOZEMAN", "state" : "MT", "county" : "GALLATIN" },
            "59719": { "city" : "BOZEMAN", "state" : "MT", "county" : "GALLATIN" },
            "59720": { "city" : "CAMERON", "state" : "MT", "county" : "MADISON" },
            "59721": { "city" : "CARDWELL", "state" : "MT", "county" : "JEFFERSON" },
            "59722": { "city" : "DEER LODGE", "state" : "MT", "county" : "POWELL" },
            "59724": { "city" : "DELL", "state" : "MT", "county" : "BEAVERHEAD" },
            "59725": { "city" : "DILLON", "state" : "MT", "county" : "BEAVERHEAD" },
            "59727": { "city" : "DIVIDE", "state" : "MT", "county" : "SILVER BOW" },
            "59728": { "city" : "ELLISTON", "state" : "MT", "county" : "POWELL" },
            "59729": { "city" : "ENNIS", "state" : "MT", "county" : "MADISON" },"59730": { "city" : "GALLATIN GATEWAY", "state" : "MT", "county" : "GALLATIN" },
            "59731": { "city" : "GARRISON", "state" : "MT", "county" : "POWELL" },
            "59732": { "city" : "GLEN", "state" : "MT", "county" : "BEAVERHEAD" },
            "59733": { "city" : "GOLD CREEK", "state" : "MT", "county" : "POWELL" },
            "59735": { "city" : "HARRISON", "state" : "MT", "county" : "MADISON" },
            "59736": { "city" : "JACKSON", "state" : "MT", "county" : "BEAVERHEAD" },
            "59739": { "city" : "LIMA", "state" : "MT", "county" : "BEAVERHEAD" },
            "59740": { "city" : "MC ALLISTER", "state" : "MT", "county" : "MADISON" },
            "59741": { "city" : "MANHATTAN", "state" : "MT", "county" : "GALLATIN" },
            "59743": { "city" : "MELROSE", "state" : "MT", "county" : "SILVER BOW" },
            "59745": { "city" : "NORRIS", "state" : "MT", "county" : "MADISON" },
            "59746": { "city" : "POLARIS", "state" : "MT", "county" : "BEAVERHEAD" },
            "59747": { "city" : "PONY", "state" : "MT", "county" : "MADISON" },"59748": { "city" : "RAMSAY", "state" : "MT", "county" : "SILVER BOW" },
            "59749": { "city" : "SHERIDAN", "state" : "MT", "county" : "MADISON" },
            "59750": { "city" : "BUTTE", "state" : "MT", "county" : "SILVER BOW" },
            "59751": { "city" : "SILVER STAR", "state" : "MT", "county" : "MADISON" },
            "59752": { "city" : "THREE FORKS", "state" : "MT", "county" : "GALLATIN" },
            "59754": { "city" : "TWIN BRIDGES", "state" : "MT", "county" : "MADISON" },
            "59755": { "city" : "VIRGINIA CITY", "state" : "MT", "county" : "MADISON" },
            "59756": { "city" : "WARM SPRINGS", "state" : "MT", "county" : "DEER LODGE" },
            "59758": { "city" : "WEST YELLOWSTONE", "state" : "MT", "county" : "GALLATIN" },
            "59759": { "city" : "WHITEHALL", "state" : "MT", "county" : "JEFFERSON" },
            "59760": { "city" : "WILLOW CREEK", "state" : "MT", "county" : "GALLATIN" },
            "59761": { "city" : "WISDOM", "state" : "MT", "county" : "BEAVERHEAD" },
            "59762": { "city" : "WISE RIVER", "state" : "MT", "county" : "BEAVERHEAD" },
            "59771": { "city" : "BOZEMAN", "state" : "MT", "county" : "GALLATIN" },
            "59772": { "city" : "BOZEMAN", "state" : "MT", "county" : "GALLATIN" },
            "59801": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59802": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59803": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59804": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59806": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59807": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59808": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59812": { "city" : "MISSOULA", "state" : "MT", "county" : "MISSOULA" },
            "59820": { "city" : "ALBERTON", "state" : "MT", "county" : "MINERAL" },
            "59821": { "city" : "ARLEE", "state" : "MT", "county" : "LAKE" },"59823": { "city" : "BONNER", "state" : "MT", "county" : "MISSOULA" },
            "59824": { "city" : "CHARLO", "state" : "MT", "county" : "LAKE" },"59825": { "city" : "CLINTON", "state" : "MT", "county" : "MISSOULA" },
            "59826": { "city" : "CONDON", "state" : "MT", "county" : "MISSOULA" },
            "59827": { "city" : "CONNER", "state" : "MT", "county" : "RAVALLI" },
            "59828": { "city" : "CORVALLIS", "state" : "MT", "county" : "RAVALLI" },
            "59829": { "city" : "DARBY", "state" : "MT", "county" : "RAVALLI" },"59830": { "city" : "DE BORGIA", "state" : "MT", "county" : "MINERAL" },
            "59831": { "city" : "DIXON", "state" : "MT", "county" : "SANDERS" },"59832": { "city" : "DRUMMOND", "state" : "MT", "county" : "GRANITE" },
            "59833": { "city" : "FLORENCE", "state" : "MT", "county" : "RAVALLI" },
            "59834": { "city" : "FRENCHTOWN", "state" : "MT", "county" : "MISSOULA" },
            "59837": { "city" : "HALL", "state" : "MT", "county" : "GRANITE" },"59840": { "city" : "HAMILTON", "state" : "MT", "county" : "RAVALLI" },
            "59841": { "city" : "PINESDALE", "state" : "MT", "county" : "RAVALLI" },
            "59842": { "city" : "HAUGAN", "state" : "MT", "county" : "MINERAL" },
            "59843": { "city" : "HELMVILLE", "state" : "MT", "county" : "POWELL" },
            "59844": { "city" : "HERON", "state" : "MT", "county" : "SANDERS" },"59845": { "city" : "HOT SPRINGS", "state" : "MT", "county" : "SANDERS" },
            "59846": { "city" : "HUSON", "state" : "MT", "county" : "MISSOULA" },
            "59847": { "city" : "LOLO", "state" : "MT", "county" : "MISSOULA" },"59848": { "city" : "LONEPINE", "state" : "MT", "county" : "SANDERS" },
            "59851": { "city" : "MILLTOWN", "state" : "MT", "county" : "MISSOULA" },
            "59853": { "city" : "NOXON", "state" : "MT", "county" : "SANDERS" },"59854": { "city" : "OVANDO", "state" : "MT", "county" : "POWELL" },
            "59855": { "city" : "PABLO", "state" : "MT", "county" : "LAKE" },"59856": { "city" : "PARADISE", "state" : "MT", "county" : "SANDERS" },
            "59858": { "city" : "PHILIPSBURG", "state" : "MT", "county" : "GRANITE" },
            "59859": { "city" : "PLAINS", "state" : "MT", "county" : "SANDERS" },
            "59860": { "city" : "POLSON", "state" : "MT", "county" : "LAKE" },"59863": { "city" : "RAVALLI", "state" : "MT", "county" : "LAKE" },
            "59864": { "city" : "RONAN", "state" : "MT", "county" : "LAKE" },"59865": { "city" : "SAINT IGNATIUS", "state" : "MT", "county" : "LAKE" },
            "59866": { "city" : "SAINT REGIS", "state" : "MT", "county" : "MINERAL" },
            "59867": { "city" : "SALTESE", "state" : "MT", "county" : "MINERAL" },
            "59868": { "city" : "SEELEY LAKE", "state" : "MT", "county" : "MISSOULA" },
            "59870": { "city" : "STEVENSVILLE", "state" : "MT", "county" : "RAVALLI" },
            "59871": { "city" : "SULA", "state" : "MT", "county" : "RAVALLI" },"59872": { "city" : "SUPERIOR", "state" : "MT", "county" : "MINERAL" },
            "59873": { "city" : "THOMPSON FALLS", "state" : "MT", "county" : "SANDERS" },
            "59874": { "city" : "TROUT CREEK", "state" : "MT", "county" : "SANDERS" },
            "59875": { "city" : "VICTOR", "state" : "MT", "county" : "RAVALLI" },
            "59901": { "city" : "KALISPELL", "state" : "MT", "county" : "FLATHEAD" },
            "59903": { "city" : "KALISPELL", "state" : "MT", "county" : "FLATHEAD" },
            "59904": { "city" : "KALISPELL", "state" : "MT", "county" : "FLATHEAD" },
            "59910": { "city" : "BIG ARM", "state" : "MT", "county" : "LAKE" },"59911": { "city" : "BIGFORK", "state" : "MT", "county" : "FLATHEAD" },
            "59912": { "city" : "COLUMBIA FALLS", "state" : "MT", "county" : "FLATHEAD" },
            "59913": { "city" : "CORAM", "state" : "MT", "county" : "FLATHEAD" },
            "59914": { "city" : "DAYTON", "state" : "MT", "county" : "LAKE" },"59915": { "city" : "ELMO", "state" : "MT", "county" : "LAKE" },
            "59916": { "city" : "ESSEX", "state" : "MT", "county" : "FLATHEAD" },
            "59917": { "city" : "EUREKA", "state" : "MT", "county" : "LINCOLN" },
            "59918": { "city" : "FORTINE", "state" : "MT", "county" : "LINCOLN" },
            "59919": { "city" : "HUNGRY HORSE", "state" : "MT", "county" : "FLATHEAD" },
            "59920": { "city" : "KILA", "state" : "MT", "county" : "FLATHEAD" },"59922": { "city" : "LAKESIDE", "state" : "MT", "county" : "FLATHEAD" },
            "59923": { "city" : "LIBBY", "state" : "MT", "county" : "LINCOLN" },"59925": { "city" : "MARION", "state" : "MT", "county" : "FLATHEAD" },
            "59926": { "city" : "MARTIN CITY", "state" : "MT", "county" : "FLATHEAD" },
            "59927": { "city" : "OLNEY", "state" : "MT", "county" : "FLATHEAD" },
            "59928": { "city" : "POLEBRIDGE", "state" : "MT", "county" : "FLATHEAD" },
            "59929": { "city" : "PROCTOR", "state" : "MT", "county" : "LAKE" },"59930": { "city" : "REXFORD", "state" : "MT", "county" : "LINCOLN" },
            "59931": { "city" : "ROLLINS", "state" : "MT", "county" : "LAKE" },"59932": { "city" : "SOMERS", "state" : "MT", "county" : "FLATHEAD" },
            "59933": { "city" : "STRYKER", "state" : "MT", "county" : "LINCOLN" },
            "59934": { "city" : "TREGO", "state" : "MT", "county" : "LINCOLN" },"59935": { "city" : "TROY", "state" : "MT", "county" : "LINCOLN" },
            "59936": { "city" : "WEST GLACIER", "state" : "MT", "county" : "FLATHEAD" },
            "59937": { "city" : "WHITEFISH", "state" : "MT", "county" : "FLATHEAD" },
            "60001": { "city" : "ALDEN", "state" : "IL", "county" : "MCHENRY" },"60002": { "city" : "ANTIOCH", "state" : "IL", "county" : "LAKE" },
            "60004": { "city" : "ARLINGTON HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60005": { "city" : "ARLINGTON HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60006": { "city" : "ARLINGTON HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60007": { "city" : "ELK GROVE VILLAGE", "state" : "IL", "county" : "COOK" },
            "60008": { "city" : "ROLLING MEADOWS", "state" : "IL", "county" : "COOK" },
            "60009": { "city" : "ELK GROVE VILLAGE", "state" : "IL", "county" : "COOK" },
            "60010": { "city" : "BARRINGTON", "state" : "IL", "county" : "LAKE" },
            "60011": { "city" : "BARRINGTON", "state" : "IL", "county" : "LAKE" },
            "60012": { "city" : "CRYSTAL LAKE", "state" : "IL", "county" : "MCHENRY" },
            "60013": { "city" : "CARY", "state" : "IL", "county" : "MCHENRY" },"60014": { "city" : "CRYSTAL LAKE", "state" : "IL", "county" : "MCHENRY" },
            "60015": { "city" : "DEERFIELD", "state" : "IL", "county" : "LAKE" },
            "60016": { "city" : "DES PLAINES", "state" : "IL", "county" : "COOK" },
            "60017": { "city" : "DES PLAINES", "state" : "IL", "county" : "COOK" },
            "60018": { "city" : "DES PLAINES", "state" : "IL", "county" : "COOK" },
            "60019": { "city" : "DES PLAINES", "state" : "IL", "county" : "COOK" },
            "60020": { "city" : "FOX LAKE", "state" : "IL", "county" : "LAKE" },"60021": { "city" : "FOX RIVER GROVE", "state" : "IL", "county" : "MCHENRY" },
            "60022": { "city" : "GLENCOE", "state" : "IL", "county" : "COOK" },"60025": { "city" : "GLENVIEW", "state" : "IL", "county" : "COOK" },
            "60026": { "city" : "GLENVIEW", "state" : "IL", "county" : "COOK" },"60029": { "city" : "GOLF", "state" : "IL", "county" : "COOK" },
            "60030": { "city" : "GRAYSLAKE", "state" : "IL", "county" : "LAKE" },
            "60031": { "city" : "GURNEE", "state" : "IL", "county" : "LAKE" },"60033": { "city" : "HARVARD", "state" : "IL", "county" : "MCHENRY" },
            "60034": { "city" : "HEBRON", "state" : "IL", "county" : "MCHENRY" },
            "60035": { "city" : "HIGHLAND PARK", "state" : "IL", "county" : "LAKE" },
            "60037": { "city" : "FORT SHERIDAN", "state" : "IL", "county" : "LAKE" },
            "60038": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },"60039": { "city" : "CRYSTAL LAKE", "state" : "IL", "county" : "MCHENRY" },
            "60040": { "city" : "HIGHWOOD", "state" : "IL", "county" : "LAKE" },"60041": { "city" : "INGLESIDE", "state" : "IL", "county" : "LAKE" },
            "60042": { "city" : "ISLAND LAKE", "state" : "IL", "county" : "LAKE" },
            "60043": { "city" : "KENILWORTH", "state" : "IL", "county" : "COOK" },
            "60044": { "city" : "LAKE BLUFF", "state" : "IL", "county" : "LAKE" },
            "60045": { "city" : "LAKE FOREST", "state" : "IL", "county" : "LAKE" },
            "60046": { "city" : "LAKE VILLA", "state" : "IL", "county" : "LAKE" },
            "60047": { "city" : "LAKE ZURICH", "state" : "IL", "county" : "LAKE" },
            "60048": { "city" : "LIBERTYVILLE", "state" : "IL", "county" : "LAKE" },
            "60049": { "city" : "LONG GROVE", "state" : "IL", "county" : "LAKE" },
            "60050": { "city" : "MCHENRY", "state" : "IL", "county" : "MCHENRY" },
            "60051": { "city" : "MCHENRY", "state" : "IL", "county" : "MCHENRY" },
            "60053": { "city" : "MORTON GROVE", "state" : "IL", "county" : "COOK" },
            "60055": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },"60056": { "city" : "MOUNT PROSPECT", "state" : "IL", "county" : "COOK" },
            "60060": { "city" : "MUNDELEIN", "state" : "IL", "county" : "LAKE" },
            "60061": { "city" : "VERNON HILLS", "state" : "IL", "county" : "LAKE" },
            "60062": { "city" : "NORTHBROOK", "state" : "IL", "county" : "COOK" },
            "60064": { "city" : "NORTH CHICAGO", "state" : "IL", "county" : "LAKE" },
            "60065": { "city" : "NORTHBROOK", "state" : "IL", "county" : "COOK" },
            "60067": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },"60068": { "city" : "PARK RIDGE", "state" : "IL", "county" : "COOK" },
            "60069": { "city" : "LINCOLNSHIRE", "state" : "IL", "county" : "LAKE" },
            "60070": { "city" : "PROSPECT HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60071": { "city" : "RICHMOND", "state" : "IL", "county" : "MCHENRY" },
            "60072": { "city" : "RINGWOOD", "state" : "IL", "county" : "MCHENRY" },
            "60073": { "city" : "ROUND LAKE", "state" : "IL", "county" : "LAKE" },
            "60074": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },"60075": { "city" : "RUSSELL", "state" : "IL", "county" : "LAKE" },
            "60076": { "city" : "SKOKIE", "state" : "IL", "county" : "COOK" },"60077": { "city" : "SKOKIE", "state" : "IL", "county" : "COOK" },
            "60078": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },"60079": { "city" : "WAUKEGAN", "state" : "IL", "county" : "LAKE" },
            "60081": { "city" : "SPRING GROVE", "state" : "IL", "county" : "MCHENRY" },
            "60082": { "city" : "TECHNY", "state" : "IL", "county" : "COOK" },"60083": { "city" : "WADSWORTH", "state" : "IL", "county" : "LAKE" },
            "60084": { "city" : "WAUCONDA", "state" : "IL", "county" : "LAKE" },"60085": { "city" : "WAUKEGAN", "state" : "IL", "county" : "LAKE" },
            "60087": { "city" : "WAUKEGAN", "state" : "IL", "county" : "LAKE" },"60088": { "city" : "GREAT LAKES", "state" : "IL", "county" : "LAKE" },
            "60089": { "city" : "BUFFALO GROVE", "state" : "IL", "county" : "LAKE" },
            "60090": { "city" : "WHEELING", "state" : "IL", "county" : "COOK" },"60091": { "city" : "WILMETTE", "state" : "IL", "county" : "COOK" },
            "60092": { "city" : "LIBERTYVILLE", "state" : "IL", "county" : "LAKE" },
            "60093": { "city" : "WINNETKA", "state" : "IL", "county" : "COOK" },"60094": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },
            "60095": { "city" : "PALATINE", "state" : "IL", "county" : "COOK" },"60096": { "city" : "WINTHROP HARBOR", "state" : "IL", "county" : "LAKE" },
            "60097": { "city" : "WONDER LAKE", "state" : "IL", "county" : "MCHENRY" },
            "60098": { "city" : "WOODSTOCK", "state" : "IL", "county" : "MCHENRY" },
            "60099": { "city" : "ZION", "state" : "IL", "county" : "LAKE" },"60101": { "city" : "ADDISON", "state" : "IL", "county" : "DUPAGE" },
            "60102": { "city" : "ALGONQUIN", "state" : "IL", "county" : "MCHENRY" },
            "60103": { "city" : "BARTLETT", "state" : "IL", "county" : "DUPAGE" },
            "60104": { "city" : "BELLWOOD", "state" : "IL", "county" : "COOK" },"60105": { "city" : "BENSENVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60106": { "city" : "BENSENVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60107": { "city" : "STREAMWOOD", "state" : "IL", "county" : "COOK" },
            "60108": { "city" : "BLOOMINGDALE", "state" : "IL", "county" : "DUPAGE" },
            "60109": { "city" : "BURLINGTON", "state" : "IL", "county" : "KANE" },
            "60110": { "city" : "CARPENTERSVILLE", "state" : "IL", "county" : "KANE" },
            "60111": { "city" : "CLARE", "state" : "IL", "county" : "DEKALB" },"60112": { "city" : "CORTLAND", "state" : "IL", "county" : "DEKALB" },
            "60113": { "city" : "CRESTON", "state" : "IL", "county" : "OGLE" },"60115": { "city" : "DEKALB", "state" : "IL", "county" : "DEKALB" },
            "60116": { "city" : "CAROL STREAM", "state" : "IL", "county" : "DUPAGE" },
            "60118": { "city" : "DUNDEE", "state" : "IL", "county" : "KANE" },"60119": { "city" : "ELBURN", "state" : "IL", "county" : "KANE" },
            "60120": { "city" : "ELGIN", "state" : "IL", "county" : "KANE" },"60121": { "city" : "ELGIN", "state" : "IL", "county" : "KANE" },
            "60123": { "city" : "ELGIN", "state" : "IL", "county" : "KANE" },"60124": { "city" : "ELGIN", "state" : "IL", "county" : "KANE" },
            "60126": { "city" : "ELMHURST", "state" : "IL", "county" : "DUPAGE" },
            "60128": { "city" : "CAROL STREAM", "state" : "IL", "county" : "DUPAGE" },
            "60129": { "city" : "ESMOND", "state" : "IL", "county" : "DEKALB" },"60130": { "city" : "FOREST PARK", "state" : "IL", "county" : "COOK" },
            "60131": { "city" : "FRANKLIN PARK", "state" : "IL", "county" : "COOK" },
            "60132": { "city" : "CAROL STREAM", "state" : "IL", "county" : "DUPAGE" },
            "60133": { "city" : "HANOVER PARK", "state" : "IL", "county" : "COOK" },
            "60134": { "city" : "GENEVA", "state" : "IL", "county" : "KANE" },"60135": { "city" : "GENOA", "state" : "IL", "county" : "DEKALB" },
            "60136": { "city" : "GILBERTS", "state" : "IL", "county" : "KANE" },"60137": { "city" : "GLEN ELLYN", "state" : "IL", "county" : "DUPAGE" },
            "60138": { "city" : "GLEN ELLYN", "state" : "IL", "county" : "DUPAGE" },
            "60139": { "city" : "GLENDALE HEIGHTS", "state" : "IL", "county" : "DUPAGE" },
            "60140": { "city" : "HAMPSHIRE", "state" : "IL", "county" : "KANE" },
            "60141": { "city" : "HINES", "state" : "IL", "county" : "COOK" },"60142": { "city" : "HUNTLEY", "state" : "IL", "county" : "MCHENRY" },
            "60143": { "city" : "ITASCA", "state" : "IL", "county" : "DUPAGE" },"60144": { "city" : "KANEVILLE", "state" : "IL", "county" : "KANE" },
            "60145": { "city" : "KINGSTON", "state" : "IL", "county" : "DEKALB" },
            "60146": { "city" : "KIRKLAND", "state" : "IL", "county" : "DEKALB" },
            "60147": { "city" : "LAFOX", "state" : "IL", "county" : "KANE" },"60148": { "city" : "LOMBARD", "state" : "IL", "county" : "DUPAGE" },
            "60150": { "city" : "MALTA", "state" : "IL", "county" : "DEKALB" },"60151": { "city" : "MAPLE PARK", "state" : "IL", "county" : "KANE" },
            "60152": { "city" : "MARENGO", "state" : "IL", "county" : "MCHENRY" },
            "60153": { "city" : "MAYWOOD", "state" : "IL", "county" : "COOK" },"60154": { "city" : "WESTCHESTER", "state" : "IL", "county" : "COOK" },
            "60155": { "city" : "BROADVIEW", "state" : "IL", "county" : "COOK" },
            "60156": { "city" : "LAKE IN THE HILLS", "state" : "IL", "county" : "MCHENRY" },
            "60157": { "city" : "MEDINAH", "state" : "IL", "county" : "DUPAGE" },
            "60159": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60160": { "city" : "MELROSE PARK", "state" : "IL", "county" : "COOK" },
            "60161": { "city" : "MELROSE PARK", "state" : "IL", "county" : "COOK" },
            "60162": { "city" : "HILLSIDE", "state" : "IL", "county" : "COOK" },"60163": { "city" : "BERKELEY", "state" : "IL", "county" : "COOK" },
            "60164": { "city" : "MELROSE PARK", "state" : "IL", "county" : "COOK" },
            "60165": { "city" : "STONE PARK", "state" : "IL", "county" : "COOK" },
            "60168": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60169": { "city" : "HOFFMAN ESTATES", "state" : "IL", "county" : "COOK" },
            "60170": { "city" : "PLATO CENTER", "state" : "IL", "county" : "KANE" },
            "60171": { "city" : "RIVER GROVE", "state" : "IL", "county" : "COOK" },
            "60172": { "city" : "ROSELLE", "state" : "IL", "county" : "DUPAGE" },
            "60173": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60174": { "city" : "SAINT CHARLES", "state" : "IL", "county" : "KANE" },
            "60175": { "city" : "SAINT CHARLES", "state" : "IL", "county" : "KANE" },
            "60176": { "city" : "SCHILLER PARK", "state" : "IL", "county" : "COOK" },
            "60177": { "city" : "SOUTH ELGIN", "state" : "IL", "county" : "KANE" },
            "60178": { "city" : "SYCAMORE", "state" : "IL", "county" : "DEKALB" },
            "60179": { "city" : "HOFFMAN ESTATES", "state" : "IL", "county" : "COOK" },
            "60180": { "city" : "UNION", "state" : "IL", "county" : "MCHENRY" },"60181": { "city" : "VILLA PARK", "state" : "IL", "county" : "DUPAGE" },
            "60183": { "city" : "WASCO", "state" : "IL", "county" : "KANE" },"60184": { "city" : "WAYNE", "state" : "IL", "county" : "DUPAGE" },
            "60185": { "city" : "WEST CHICAGO", "state" : "IL", "county" : "DUPAGE" },
            "60186": { "city" : "WEST CHICAGO", "state" : "IL", "county" : "DUPAGE" },
            "60187": { "city" : "WHEATON", "state" : "IL", "county" : "DUPAGE" },
            "60188": { "city" : "CAROL STREAM", "state" : "IL", "county" : "DUPAGE" },
            "60189": { "city" : "WHEATON", "state" : "IL", "county" : "DUPAGE" },
            "60190": { "city" : "WINFIELD", "state" : "IL", "county" : "DUPAGE" },
            "60191": { "city" : "WOOD DALE", "state" : "IL", "county" : "DUPAGE" },
            "60192": { "city" : "HOFFMAN ESTATES", "state" : "IL", "county" : "COOK" },
            "60193": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60194": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60195": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60196": { "city" : "SCHAUMBURG", "state" : "IL", "county" : "COOK" },
            "60197": { "city" : "CAROL STREAM", "state" : "IL", "county" : "DUPAGE" },
            "60199": { "city" : "CAROL STREAM", "state" : "IL", "county" : "DUPAGE" },
            "60201": { "city" : "EVANSTON", "state" : "IL", "county" : "COOK" },"60202": { "city" : "EVANSTON", "state" : "IL", "county" : "COOK" },
            "60203": { "city" : "EVANSTON", "state" : "IL", "county" : "COOK" },"60204": { "city" : "EVANSTON", "state" : "IL", "county" : "COOK" },
            "60208": { "city" : "EVANSTON", "state" : "IL", "county" : "COOK" },"60290": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60301": { "city" : "OAK PARK", "state" : "IL", "county" : "COOK" },"60302": { "city" : "OAK PARK", "state" : "IL", "county" : "COOK" },
            "60303": { "city" : "OAK PARK", "state" : "IL", "county" : "COOK" },"60304": { "city" : "OAK PARK", "state" : "IL", "county" : "COOK" },
            "60305": { "city" : "RIVER FOREST", "state" : "IL", "county" : "COOK" },
            "60401": { "city" : "BEECHER", "state" : "IL", "county" : "WILL" },"60402": { "city" : "BERWYN", "state" : "IL", "county" : "COOK" },
            "60403": { "city" : "CREST HILL", "state" : "IL", "county" : "WILL" },
            "60404": { "city" : "SHOREWOOD", "state" : "IL", "county" : "WILL" },
            "60406": { "city" : "BLUE ISLAND", "state" : "IL", "county" : "COOK" },
            "60407": { "city" : "BRACEVILLE", "state" : "IL", "county" : "GRUNDY" },
            "60408": { "city" : "BRAIDWOOD", "state" : "IL", "county" : "WILL" },
            "60409": { "city" : "CALUMET CITY", "state" : "IL", "county" : "COOK" },
            "60410": { "city" : "CHANNAHON", "state" : "IL", "county" : "WILL" },
            "60411": { "city" : "CHICAGO HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60412": { "city" : "CHICAGO HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60415": { "city" : "CHICAGO RIDGE", "state" : "IL", "county" : "COOK" },
            "60416": { "city" : "COAL CITY", "state" : "IL", "county" : "GRUNDY" },
            "60417": { "city" : "CRETE", "state" : "IL", "county" : "WILL" },"60419": { "city" : "DOLTON", "state" : "IL", "county" : "COOK" },
            "60420": { "city" : "DWIGHT", "state" : "IL", "county" : "LIVINGSTON" },
            "60421": { "city" : "ELWOOD", "state" : "IL", "county" : "WILL" },"60422": { "city" : "FLOSSMOOR", "state" : "IL", "county" : "COOK" },
            "60423": { "city" : "FRANKFORT", "state" : "IL", "county" : "WILL" },
            "60424": { "city" : "GARDNER", "state" : "IL", "county" : "GRUNDY" },
            "60425": { "city" : "GLENWOOD", "state" : "IL", "county" : "COOK" },"60426": { "city" : "HARVEY", "state" : "IL", "county" : "COOK" },
            "60428": { "city" : "MARKHAM", "state" : "IL", "county" : "COOK" },"60429": { "city" : "HAZEL CREST", "state" : "IL", "county" : "COOK" },
            "60430": { "city" : "HOMEWOOD", "state" : "IL", "county" : "COOK" },"60431": { "city" : "JOLIET", "state" : "IL", "county" : "WILL" },
            "60432": { "city" : "JOLIET", "state" : "IL", "county" : "WILL" },"60433": { "city" : "JOLIET", "state" : "IL", "county" : "WILL" },
            "60434": { "city" : "JOLIET", "state" : "IL", "county" : "WILL" },"60435": { "city" : "JOLIET", "state" : "IL", "county" : "WILL" },
            "60436": { "city" : "JOLIET", "state" : "IL", "county" : "WILL" },"60437": { "city" : "KINSMAN", "state" : "IL", "county" : "GRUNDY" },
            "60438": { "city" : "LANSING", "state" : "IL", "county" : "COOK" },"60439": { "city" : "LEMONT", "state" : "IL", "county" : "COOK" },
            "60440": { "city" : "BOLINGBROOK", "state" : "IL", "county" : "WILL" },
            "60441": { "city" : "LOCKPORT", "state" : "IL", "county" : "WILL" },"60442": { "city" : "MANHATTAN", "state" : "IL", "county" : "WILL" },
            "60443": { "city" : "MATTESON", "state" : "IL", "county" : "COOK" },"60444": { "city" : "MAZON", "state" : "IL", "county" : "GRUNDY" },
            "60445": { "city" : "MIDLOTHIAN", "state" : "IL", "county" : "COOK" },
            "60446": { "city" : "ROMEOVILLE", "state" : "IL", "county" : "WILL" },
            "60447": { "city" : "MINOOKA", "state" : "IL", "county" : "GRUNDY" },
            "60448": { "city" : "MOKENA", "state" : "IL", "county" : "WILL" },"60449": { "city" : "MONEE", "state" : "IL", "county" : "WILL" },
            "60450": { "city" : "MORRIS", "state" : "IL", "county" : "GRUNDY" },"60451": { "city" : "NEW LENOX", "state" : "IL", "county" : "WILL" },
            "60452": { "city" : "OAK FOREST", "state" : "IL", "county" : "COOK" },
            "60453": { "city" : "OAK LAWN", "state" : "IL", "county" : "COOK" },"60454": { "city" : "OAK LAWN", "state" : "IL", "county" : "COOK" },
            "60455": { "city" : "BRIDGEVIEW", "state" : "IL", "county" : "COOK" },
            "60456": { "city" : "HOMETOWN", "state" : "IL", "county" : "COOK" },"60457": { "city" : "HICKORY HILLS", "state" : "IL", "county" : "COOK" },
            "60458": { "city" : "JUSTICE", "state" : "IL", "county" : "COOK" },"60459": { "city" : "BURBANK", "state" : "IL", "county" : "COOK" },
            "60460": { "city" : "ODELL", "state" : "IL", "county" : "LIVINGSTON" },
            "60461": { "city" : "OLYMPIA FIELDS", "state" : "IL", "county" : "COOK" },
            "60462": { "city" : "ORLAND PARK", "state" : "IL", "county" : "COOK" },
            "60463": { "city" : "PALOS HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60464": { "city" : "PALOS PARK", "state" : "IL", "county" : "COOK" },
            "60465": { "city" : "PALOS HILLS", "state" : "IL", "county" : "COOK" },
            "60466": { "city" : "PARK FOREST", "state" : "IL", "county" : "COOK" },
            "60467": { "city" : "ORLAND PARK", "state" : "IL", "county" : "COOK" },
            "60468": { "city" : "PEOTONE", "state" : "IL", "county" : "WILL" },"60469": { "city" : "POSEN", "state" : "IL", "county" : "COOK" },
            "60470": { "city" : "RANSOM", "state" : "IL", "county" : "LA SALLE" },
            "60471": { "city" : "RICHTON PARK", "state" : "IL", "county" : "COOK" },
            "60472": { "city" : "ROBBINS", "state" : "IL", "county" : "COOK" },"60473": { "city" : "SOUTH HOLLAND", "state" : "IL", "county" : "COOK" },
            "60474": { "city" : "SOUTH WILMINGTON", "state" : "IL", "county" : "GRUNDY" },
            "60475": { "city" : "STEGER", "state" : "IL", "county" : "COOK" },"60476": { "city" : "THORNTON", "state" : "IL", "county" : "COOK" },
            "60477": { "city" : "TINLEY PARK", "state" : "IL", "county" : "COOK" },
            "60478": { "city" : "COUNTRY CLUB HILLS", "state" : "IL", "county" : "COOK" },
            "60479": { "city" : "VERONA", "state" : "IL", "county" : "GRUNDY" },"60480": { "city" : "WILLOW SPRINGS", "state" : "IL", "county" : "COOK" },
            "60481": { "city" : "WILMINGTON", "state" : "IL", "county" : "WILL" },
            "60482": { "city" : "WORTH", "state" : "IL", "county" : "COOK" },"60484": { "city" : "UNIVERSITY PARK", "state" : "IL", "county" : "WILL" },
            "60487": { "city" : "TINLEY PARK", "state" : "IL", "county" : "COOK" },
            "60490": { "city" : "BOLINGBROOK", "state" : "IL", "county" : "WILL" },
            "60491": { "city" : "HOMER GLEN", "state" : "IL", "county" : "WILL" },
            "60499": { "city" : "BEDFORD PARK", "state" : "IL", "county" : "COOK" },
            "60501": { "city" : "SUMMIT ARGO", "state" : "IL", "county" : "COOK" },
            "60502": { "city" : "AURORA", "state" : "IL", "county" : "DUPAGE" },"60503": { "city" : "AURORA", "state" : "IL", "county" : "DUPAGE" },
            "60504": { "city" : "AURORA", "state" : "IL", "county" : "DUPAGE" },"60505": { "city" : "AURORA", "state" : "IL", "county" : "KANE" },
            "60506": { "city" : "AURORA", "state" : "IL", "county" : "KANE" },"60507": { "city" : "AURORA", "state" : "IL", "county" : "KANE" },
            "60510": { "city" : "BATAVIA", "state" : "IL", "county" : "KANE" },"60511": { "city" : "BIG ROCK", "state" : "IL", "county" : "KANE" },
            "60512": { "city" : "BRISTOL", "state" : "IL", "county" : "KENDALL" },
            "60513": { "city" : "BROOKFIELD", "state" : "IL", "county" : "COOK" },
            "60514": { "city" : "CLARENDON HILLS", "state" : "IL", "county" : "DUPAGE" },
            "60515": { "city" : "DOWNERS GROVE", "state" : "IL", "county" : "DUPAGE" },
            "60516": { "city" : "DOWNERS GROVE", "state" : "IL", "county" : "DUPAGE" },
            "60517": { "city" : "WOODRIDGE", "state" : "IL", "county" : "DUPAGE" },
            "60518": { "city" : "EARLVILLE", "state" : "IL", "county" : "LA SALLE" },
            "60519": { "city" : "EOLA", "state" : "IL", "county" : "DUPAGE" },"60520": { "city" : "HINCKLEY", "state" : "IL", "county" : "DEKALB" },
            "60521": { "city" : "HINSDALE", "state" : "IL", "county" : "DUPAGE" },
            "60522": { "city" : "HINSDALE", "state" : "IL", "county" : "DUPAGE" },
            "60523": { "city" : "OAK BROOK", "state" : "IL", "county" : "DUPAGE" },
            "60525": { "city" : "LA GRANGE", "state" : "IL", "county" : "COOK" },
            "60526": { "city" : "LA GRANGE PARK", "state" : "IL", "county" : "COOK" },
            "60527": { "city" : "WILLOWBROOK", "state" : "IL", "county" : "DUPAGE" },
            "60530": { "city" : "LEE", "state" : "IL", "county" : "LEE" },"60531": { "city" : "LELAND", "state" : "IL", "county" : "LA SALLE" },
            "60532": { "city" : "LISLE", "state" : "IL", "county" : "DUPAGE" },"60534": { "city" : "LYONS", "state" : "IL", "county" : "COOK" },
            "60536": { "city" : "MILLBROOK", "state" : "IL", "county" : "KENDALL" },
            "60537": { "city" : "MILLINGTON", "state" : "IL", "county" : "KENDALL" },
            "60538": { "city" : "MONTGOMERY", "state" : "IL", "county" : "KENDALL" },
            "60539": { "city" : "MOOSEHEART", "state" : "IL", "county" : "KANE" },
            "60540": { "city" : "NAPERVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60541": { "city" : "NEWARK", "state" : "IL", "county" : "KENDALL" },
            "60542": { "city" : "NORTH AURORA", "state" : "IL", "county" : "KANE" },
            "60543": { "city" : "OSWEGO", "state" : "IL", "county" : "KENDALL" },
            "60544": { "city" : "PLAINFIELD", "state" : "IL", "county" : "WILL" },
            "60545": { "city" : "PLANO", "state" : "IL", "county" : "KENDALL" },"60546": { "city" : "RIVERSIDE", "state" : "IL", "county" : "COOK" },
            "60548": { "city" : "SANDWICH", "state" : "IL", "county" : "DEKALB" },
            "60549": { "city" : "SERENA", "state" : "IL", "county" : "LA SALLE" },
            "60550": { "city" : "SHABBONA", "state" : "IL", "county" : "DEKALB" },
            "60551": { "city" : "SHERIDAN", "state" : "IL", "county" : "LA SALLE" },
            "60552": { "city" : "SOMONAUK", "state" : "IL", "county" : "DEKALB" },
            "60553": { "city" : "STEWARD", "state" : "IL", "county" : "LEE" },"60554": { "city" : "SUGAR GROVE", "state" : "IL", "county" : "KANE" },
            "60555": { "city" : "WARRENVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60556": { "city" : "WATERMAN", "state" : "IL", "county" : "DEKALB" },
            "60557": { "city" : "WEDRON", "state" : "IL", "county" : "LA SALLE" },
            "60558": { "city" : "WESTERN SPRINGS", "state" : "IL", "county" : "COOK" },
            "60559": { "city" : "WESTMONT", "state" : "IL", "county" : "DUPAGE" },
            "60560": { "city" : "YORKVILLE", "state" : "IL", "county" : "KENDALL" },
            "60561": { "city" : "DARIEN", "state" : "IL", "county" : "DUPAGE" },"60563": { "city" : "NAPERVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60564": { "city" : "NAPERVILLE", "state" : "IL", "county" : "WILL" },
            "60565": { "city" : "NAPERVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60566": { "city" : "NAPERVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60567": { "city" : "NAPERVILLE", "state" : "IL", "county" : "DUPAGE" },
            "60585": { "city" : "PLAINFIELD", "state" : "IL", "county" : "WILL" },
            "60586": { "city" : "PLAINFIELD", "state" : "IL", "county" : "WILL" },
            "60598": { "city" : "AURORA", "state" : "IL", "county" : "DUPAGE" },"60601": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60602": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60603": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60604": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60605": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60606": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60607": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60608": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60609": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60610": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60611": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60612": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60613": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60614": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60615": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60616": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60617": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60618": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60619": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60620": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60621": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60622": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60623": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60624": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60625": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60626": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60628": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60629": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60630": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60631": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60632": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60633": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60634": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60636": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60637": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60638": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60639": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60640": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60641": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60642": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60643": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60644": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60645": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60646": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60647": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60649": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60651": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60652": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60653": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60654": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60655": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60656": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60657": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60659": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60660": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60661": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60664": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60666": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60670": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60673": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60674": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60675": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60678": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60680": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60681": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60684": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60685": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60687": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60689": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60690": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60691": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60693": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60694": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60696": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60697": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60699": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },"60701": { "city" : "CHICAGO", "state" : "IL", "county" : "COOK" },
            "60706": { "city" : "HARWOOD HEIGHTS", "state" : "IL", "county" : "COOK" },
            "60707": { "city" : "ELMWOOD PARK", "state" : "IL", "county" : "COOK" },
            "60712": { "city" : "LINCOLNWOOD", "state" : "IL", "county" : "COOK" },
            "60714": { "city" : "NILES", "state" : "IL", "county" : "COOK" },"60803": { "city" : "ALSIP", "state" : "IL", "county" : "COOK" },
            "60804": { "city" : "CICERO", "state" : "IL", "county" : "COOK" },"60805": { "city" : "EVERGREEN PARK", "state" : "IL", "county" : "COOK" },
            "60827": { "city" : "RIVERDALE", "state" : "IL", "county" : "COOK" },
            "60901": { "city" : "KANKAKEE", "state" : "IL", "county" : "KANKAKEE" },
            "60910": { "city" : "AROMA PARK", "state" : "IL", "county" : "KANKAKEE" },
            "60911": { "city" : "ASHKUM", "state" : "IL", "county" : "IROQUOIS" },
            "60912": { "city" : "BEAVERVILLE", "state" : "IL", "county" : "IROQUOIS" },
            "60913": { "city" : "BONFIELD", "state" : "IL", "county" : "KANKAKEE" },
            "60914": { "city" : "BOURBONNAIS", "state" : "IL", "county" : "KANKAKEE" },
            "60915": { "city" : "BRADLEY", "state" : "IL", "county" : "KANKAKEE" },
            "60917": { "city" : "BUCKINGHAM", "state" : "IL", "county" : "KANKAKEE" },
            "60918": { "city" : "BUCKLEY", "state" : "IL", "county" : "IROQUOIS" },
            "60919": { "city" : "CABERY", "state" : "IL", "county" : "FORD" },"60920": { "city" : "CAMPUS", "state" : "IL", "county" : "LIVINGSTON" },
            "60921": { "city" : "CHATSWORTH", "state" : "IL", "county" : "LIVINGSTON" },
            "60922": { "city" : "CHEBANSE", "state" : "IL", "county" : "IROQUOIS" },
            "60924": { "city" : "CISSNA PARK", "state" : "IL", "county" : "IROQUOIS" },
            "60927": { "city" : "CLIFTON", "state" : "IL", "county" : "IROQUOIS" },
            "60928": { "city" : "CRESCENT CITY", "state" : "IL", "county" : "IROQUOIS" },
            "60929": { "city" : "CULLOM", "state" : "IL", "county" : "LIVINGSTON" },
            "60930": { "city" : "DANFORTH", "state" : "IL", "county" : "IROQUOIS" },
            "60931": { "city" : "DONOVAN", "state" : "IL", "county" : "IROQUOIS" },
            "60932": { "city" : "EAST LYNN", "state" : "IL", "county" : "VERMILION" },
            "60933": { "city" : "ELLIOTT", "state" : "IL", "county" : "FORD" },"60934": { "city" : "EMINGTON", "state" : "IL", "county" : "LIVINGSTON" },
            "60935": { "city" : "ESSEX", "state" : "IL", "county" : "KANKAKEE" },
            "60936": { "city" : "GIBSON CITY", "state" : "IL", "county" : "FORD" },
            "60938": { "city" : "GILMAN", "state" : "IL", "county" : "IROQUOIS" },
            "60939": { "city" : "GOODWINE", "state" : "IL", "county" : "IROQUOIS" },
            "60940": { "city" : "GRANT PARK", "state" : "IL", "county" : "KANKAKEE" },
            "60941": { "city" : "HERSCHER", "state" : "IL", "county" : "KANKAKEE" },
            "60942": { "city" : "HOOPESTON", "state" : "IL", "county" : "VERMILION" },
            "60944": { "city" : "HOPKINS PARK", "state" : "IL", "county" : "KANKAKEE" },
            "60945": { "city" : "IROQUOIS", "state" : "IL", "county" : "IROQUOIS" },
            "60946": { "city" : "KEMPTON", "state" : "IL", "county" : "FORD" },"60948": { "city" : "LODA", "state" : "IL", "county" : "IROQUOIS" },
            "60949": { "city" : "LUDLOW", "state" : "IL", "county" : "CHAMPAIGN" },
            "60950": { "city" : "MANTENO", "state" : "IL", "county" : "KANKAKEE" },
            "60951": { "city" : "MARTINTON", "state" : "IL", "county" : "IROQUOIS" },
            "60952": { "city" : "MELVIN", "state" : "IL", "county" : "FORD" },"60953": { "city" : "MILFORD", "state" : "IL", "county" : "IROQUOIS" },
            "60954": { "city" : "MOMENCE", "state" : "IL", "county" : "KANKAKEE" },
            "60955": { "city" : "ONARGA", "state" : "IL", "county" : "IROQUOIS" },
            "60956": { "city" : "PAPINEAU", "state" : "IL", "county" : "IROQUOIS" },
            "60957": { "city" : "PAXTON", "state" : "IL", "county" : "FORD" },"60958": { "city" : "PEMBROKE TOWNSHIP", "state" : "IL", "county" : "KANKAKEE" },
            "60959": { "city" : "PIPER CITY", "state" : "IL", "county" : "FORD" },
            "60960": { "city" : "RANKIN", "state" : "IL", "county" : "VERMILION" },
            "60961": { "city" : "REDDICK", "state" : "IL", "county" : "KANKAKEE" },
            "60962": { "city" : "ROBERTS", "state" : "IL", "county" : "FORD" },"60963": { "city" : "ROSSVILLE", "state" : "IL", "county" : "VERMILION" },
            "60964": { "city" : "SAINT ANNE", "state" : "IL", "county" : "KANKAKEE" },
            "60966": { "city" : "SHELDON", "state" : "IL", "county" : "IROQUOIS" },
            "60967": { "city" : "STOCKLAND", "state" : "IL", "county" : "IROQUOIS" },
            "60968": { "city" : "THAWVILLE", "state" : "IL", "county" : "IROQUOIS" },
            "60969": { "city" : "UNION HILL", "state" : "IL", "county" : "KANKAKEE" },
            "60970": { "city" : "WATSEKA", "state" : "IL", "county" : "IROQUOIS" },
            "60973": { "city" : "WELLINGTON", "state" : "IL", "county" : "IROQUOIS" },
            "60974": { "city" : "WOODLAND", "state" : "IL", "county" : "IROQUOIS" },
            "61001": { "city" : "APPLE RIVER", "state" : "IL", "county" : "JO DAVIESS" },
            "61006": { "city" : "ASHTON", "state" : "IL", "county" : "LEE" },"61007": { "city" : "BAILEYVILLE", "state" : "IL", "county" : "OGLE" },
            "61008": { "city" : "BELVIDERE", "state" : "IL", "county" : "BOONE" },
            "61010": { "city" : "BYRON", "state" : "IL", "county" : "OGLE" },"61011": { "city" : "CALEDONIA", "state" : "IL", "county" : "BOONE" },
            "61012": { "city" : "CAPRON", "state" : "IL", "county" : "BOONE" },"61013": { "city" : "CEDARVILLE", "state" : "IL", "county" : "STEPHENSON" },
            "61014": { "city" : "CHADWICK", "state" : "IL", "county" : "CARROLL" },
            "61015": { "city" : "CHANA", "state" : "IL", "county" : "OGLE" },"61016": { "city" : "CHERRY VALLEY", "state" : "IL", "county" : "WINNEBAGO" },
            "61018": { "city" : "DAKOTA", "state" : "IL", "county" : "STEPHENSON" },
            "61019": { "city" : "DAVIS", "state" : "IL", "county" : "STEPHENSON" },
            "61020": { "city" : "DAVIS JUNCTION", "state" : "IL", "county" : "OGLE" },
            "61021": { "city" : "DIXON", "state" : "IL", "county" : "LEE" },"61024": { "city" : "DURAND", "state" : "IL", "county" : "WINNEBAGO" },
            "61025": { "city" : "EAST DUBUQUE", "state" : "IL", "county" : "JO DAVIESS" },
            "61027": { "city" : "ELEROY", "state" : "IL", "county" : "STEPHENSON" },
            "61028": { "city" : "ELIZABETH", "state" : "IL", "county" : "JO DAVIESS" },
            "61030": { "city" : "FORRESTON", "state" : "IL", "county" : "OGLE" },
            "61031": { "city" : "FRANKLIN GROVE", "state" : "IL", "county" : "LEE" },
            "61032": { "city" : "FREEPORT", "state" : "IL", "county" : "STEPHENSON" },
            "61036": { "city" : "GALENA", "state" : "IL", "county" : "JO DAVIESS" },
            "61037": { "city" : "GALT", "state" : "IL", "county" : "WHITESIDE" },
            "61038": { "city" : "GARDEN PRAIRIE", "state" : "IL", "county" : "BOONE" },
            "61039": { "city" : "GERMAN VALLEY", "state" : "IL", "county" : "STEPHENSON" },
            "61041": { "city" : "HANOVER", "state" : "IL", "county" : "JO DAVIESS" },
            "61042": { "city" : "HARMON", "state" : "IL", "county" : "LEE" },"61043": { "city" : "HOLCOMB", "state" : "IL", "county" : "OGLE" },
            "61044": { "city" : "KENT", "state" : "IL", "county" : "STEPHENSON" },
            "61046": { "city" : "LANARK", "state" : "IL", "county" : "CARROLL" },
            "61047": { "city" : "LEAF RIVER", "state" : "IL", "county" : "OGLE" },
            "61048": { "city" : "LENA", "state" : "IL", "county" : "STEPHENSON" },
            "61049": { "city" : "LINDENWOOD", "state" : "IL", "county" : "OGLE" },
            "61050": { "city" : "MC CONNELL", "state" : "IL", "county" : "STEPHENSON" },
            "61051": { "city" : "MILLEDGEVILLE", "state" : "IL", "county" : "CARROLL" },
            "61052": { "city" : "MONROE CENTER", "state" : "IL", "county" : "OGLE" },
            "61053": { "city" : "MOUNT CARROLL", "state" : "IL", "county" : "CARROLL" },
            "61054": { "city" : "MOUNT MORRIS", "state" : "IL", "county" : "OGLE" },
            "61057": { "city" : "NACHUSA", "state" : "IL", "county" : "LEE" },"61059": { "city" : "NORA", "state" : "IL", "county" : "JO DAVIESS" },
            "61060": { "city" : "ORANGEVILLE", "state" : "IL", "county" : "STEPHENSON" },
            "61061": { "city" : "OREGON", "state" : "IL", "county" : "OGLE" },"61062": { "city" : "PEARL CITY", "state" : "IL", "county" : "STEPHENSON" },
            "61063": { "city" : "PECATONICA", "state" : "IL", "county" : "WINNEBAGO" },
            "61064": { "city" : "POLO", "state" : "IL", "county" : "OGLE" },"61065": { "city" : "POPLAR GROVE", "state" : "IL", "county" : "BOONE" },
            "61067": { "city" : "RIDOTT", "state" : "IL", "county" : "STEPHENSON" },
            "61068": { "city" : "ROCHELLE", "state" : "IL", "county" : "OGLE" },"61070": { "city" : "ROCK CITY", "state" : "IL", "county" : "STEPHENSON" },
            "61071": { "city" : "ROCK FALLS", "state" : "IL", "county" : "WHITESIDE" },
            "61072": { "city" : "ROCKTON", "state" : "IL", "county" : "WINNEBAGO" },
            "61073": { "city" : "ROSCOE", "state" : "IL", "county" : "WINNEBAGO" },
            "61074": { "city" : "SAVANNA", "state" : "IL", "county" : "CARROLL" },
            "61075": { "city" : "SCALES MOUND", "state" : "IL", "county" : "JO DAVIESS" },
            "61077": { "city" : "SEWARD", "state" : "IL", "county" : "WINNEBAGO" },
            "61078": { "city" : "SHANNON", "state" : "IL", "county" : "CARROLL" },
            "61079": { "city" : "SHIRLAND", "state" : "IL", "county" : "WINNEBAGO" },
            "61080": { "city" : "SOUTH BELOIT", "state" : "IL", "county" : "WINNEBAGO" },
            "61081": { "city" : "STERLING", "state" : "IL", "county" : "WHITESIDE" },
            "61084": { "city" : "STILLMAN VALLEY", "state" : "IL", "county" : "OGLE" },
            "61085": { "city" : "STOCKTON", "state" : "IL", "county" : "JO DAVIESS" },
            "61087": { "city" : "WARREN", "state" : "IL", "county" : "JO DAVIESS" },
            "61088": { "city" : "WINNEBAGO", "state" : "IL", "county" : "WINNEBAGO" },
            "61089": { "city" : "WINSLOW", "state" : "IL", "county" : "STEPHENSON" },
            "61091": { "city" : "WOOSUNG", "state" : "IL", "county" : "OGLE" },"61101": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61102": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61103": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61104": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61105": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61106": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61107": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61108": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61109": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61110": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61111": { "city" : "LOVES PARK", "state" : "IL", "county" : "WINNEBAGO" },
            "61112": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61114": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61115": { "city" : "MACHESNEY PARK", "state" : "IL", "county" : "WINNEBAGO" },
            "61125": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61126": { "city" : "ROCKFORD", "state" : "IL", "county" : "WINNEBAGO" },
            "61130": { "city" : "LOVES PARK", "state" : "IL", "county" : "WINNEBAGO" },
            "61132": { "city" : "LOVES PARK", "state" : "IL", "county" : "WINNEBAGO" },
            "61201": { "city" : "ROCK ISLAND", "state" : "IL", "county" : "ROCK ISLAND" },
            "61204": { "city" : "ROCK ISLAND", "state" : "IL", "county" : "ROCK ISLAND" },
            "61230": { "city" : "ALBANY", "state" : "IL", "county" : "WHITESIDE" },
            "61231": { "city" : "ALEDO", "state" : "IL", "county" : "MERCER" },"61232": { "city" : "ANDALUSIA", "state" : "IL", "county" : "ROCK ISLAND" },
            "61233": { "city" : "ANDOVER", "state" : "IL", "county" : "HENRY" },"61234": { "city" : "ANNAWAN", "state" : "IL", "county" : "HENRY" },
            "61235": { "city" : "ATKINSON", "state" : "IL", "county" : "HENRY" },
            "61236": { "city" : "BARSTOW", "state" : "IL", "county" : "ROCK ISLAND" },
            "61237": { "city" : "BUFFALO PRAIRIE", "state" : "IL", "county" : "ROCK ISLAND" },
            "61238": { "city" : "CAMBRIDGE", "state" : "IL", "county" : "HENRY" },
            "61239": { "city" : "CARBON CLIFF", "state" : "IL", "county" : "ROCK ISLAND" },
            "61240": { "city" : "COAL VALLEY", "state" : "IL", "county" : "ROCK ISLAND" },
            "61241": { "city" : "COLONA", "state" : "IL", "county" : "HENRY" },"61242": { "city" : "CORDOVA", "state" : "IL", "county" : "ROCK ISLAND" },
            "61243": { "city" : "DEER GROVE", "state" : "IL", "county" : "WHITESIDE" },
            "61244": { "city" : "EAST MOLINE", "state" : "IL", "county" : "ROCK ISLAND" },
            "61250": { "city" : "ERIE", "state" : "IL", "county" : "WHITESIDE" },
            "61251": { "city" : "FENTON", "state" : "IL", "county" : "WHITESIDE" },
            "61252": { "city" : "FULTON", "state" : "IL", "county" : "WHITESIDE" },
            "61254": { "city" : "GENESEO", "state" : "IL", "county" : "HENRY" },"61256": { "city" : "HAMPTON", "state" : "IL", "county" : "ROCK ISLAND" },
            "61257": { "city" : "HILLSDALE", "state" : "IL", "county" : "ROCK ISLAND" },
            "61258": { "city" : "HOOPPOLE", "state" : "IL", "county" : "HENRY" },
            "61259": { "city" : "ILLINOIS CITY", "state" : "IL", "county" : "ROCK ISLAND" },
            "61260": { "city" : "JOY", "state" : "IL", "county" : "MERCER" },"61261": { "city" : "LYNDON", "state" : "IL", "county" : "WHITESIDE" },
            "61262": { "city" : "LYNN CENTER", "state" : "IL", "county" : "HENRY" },
            "61263": { "city" : "MATHERVILLE", "state" : "IL", "county" : "MERCER" },
            "61264": { "city" : "MILAN", "state" : "IL", "county" : "ROCK ISLAND" },
            "61265": { "city" : "MOLINE", "state" : "IL", "county" : "ROCK ISLAND" },
            "61266": { "city" : "MOLINE", "state" : "IL", "county" : "ROCK ISLAND" },
            "61270": { "city" : "MORRISON", "state" : "IL", "county" : "WHITESIDE" },
            "61272": { "city" : "NEW BOSTON", "state" : "IL", "county" : "MERCER" },
            "61273": { "city" : "ORION", "state" : "IL", "county" : "HENRY" },"61274": { "city" : "OSCO", "state" : "IL", "county" : "HENRY" },
            "61275": { "city" : "PORT BYRON", "state" : "IL", "county" : "ROCK ISLAND" },
            "61276": { "city" : "PREEMPTION", "state" : "IL", "county" : "MERCER" },
            "61277": { "city" : "PROPHETSTOWN", "state" : "IL", "county" : "WHITESIDE" },
            "61278": { "city" : "RAPIDS CITY", "state" : "IL", "county" : "ROCK ISLAND" },
            "61279": { "city" : "REYNOLDS", "state" : "IL", "county" : "ROCK ISLAND" },
            "61281": { "city" : "SHERRARD", "state" : "IL", "county" : "MERCER" },
            "61282": { "city" : "SILVIS", "state" : "IL", "county" : "ROCK ISLAND" },
            "61283": { "city" : "TAMPICO", "state" : "IL", "county" : "WHITESIDE" },
            "61284": { "city" : "TAYLOR RIDGE", "state" : "IL", "county" : "ROCK ISLAND" },
            "61285": { "city" : "THOMSON", "state" : "IL", "county" : "CARROLL" },
            "61299": { "city" : "ROCK ISLAND", "state" : "IL", "county" : "ROCK ISLAND" },
            "61301": { "city" : "LA SALLE", "state" : "IL", "county" : "LA SALLE" },
            "61310": { "city" : "AMBOY", "state" : "IL", "county" : "LEE" },"61311": { "city" : "ANCONA", "state" : "IL", "county" : "LIVINGSTON" },
            "61312": { "city" : "ARLINGTON", "state" : "IL", "county" : "BUREAU" },
            "61313": { "city" : "BLACKSTONE", "state" : "IL", "county" : "LIVINGSTON" },
            "61314": { "city" : "BUDA", "state" : "IL", "county" : "BUREAU" },"61315": { "city" : "BUREAU", "state" : "IL", "county" : "BUREAU" },
            "61316": { "city" : "CEDAR POINT", "state" : "IL", "county" : "LA SALLE" },
            "61317": { "city" : "CHERRY", "state" : "IL", "county" : "BUREAU" },"61318": { "city" : "COMPTON", "state" : "IL", "county" : "LEE" },
            "61319": { "city" : "CORNELL", "state" : "IL", "county" : "LIVINGSTON" },
            "61320": { "city" : "DALZELL", "state" : "IL", "county" : "BUREAU" },
            "61321": { "city" : "DANA", "state" : "IL", "county" : "LA SALLE" },"61322": { "city" : "DEPUE", "state" : "IL", "county" : "BUREAU" },
            "61323": { "city" : "DOVER", "state" : "IL", "county" : "BUREAU" },"61325": { "city" : "GRAND RIDGE", "state" : "IL", "county" : "LA SALLE" },
            "61326": { "city" : "GRANVILLE", "state" : "IL", "county" : "PUTNAM" },
            "61327": { "city" : "HENNEPIN", "state" : "IL", "county" : "PUTNAM" },
            "61328": { "city" : "KASBEER", "state" : "IL", "county" : "BUREAU" },
            "61329": { "city" : "LADD", "state" : "IL", "county" : "BUREAU" },"61330": { "city" : "LA MOILLE", "state" : "IL", "county" : "BUREAU" },
            "61332": { "city" : "LEONORE", "state" : "IL", "county" : "LA SALLE" },
            "61333": { "city" : "LONG POINT", "state" : "IL", "county" : "LIVINGSTON" },
            "61334": { "city" : "LOSTANT", "state" : "IL", "county" : "LA SALLE" },
            "61335": { "city" : "MC NABB", "state" : "IL", "county" : "PUTNAM" },
            "61336": { "city" : "MAGNOLIA", "state" : "IL", "county" : "PUTNAM" },
            "61337": { "city" : "MALDEN", "state" : "IL", "county" : "BUREAU" },"61338": { "city" : "MANLIUS", "state" : "IL", "county" : "BUREAU" },
            "61340": { "city" : "MARK", "state" : "IL", "county" : "PUTNAM" },"61341": { "city" : "MARSEILLES", "state" : "IL", "county" : "LA SALLE" },
            "61342": { "city" : "MENDOTA", "state" : "IL", "county" : "LA SALLE" },
            "61344": { "city" : "MINERAL", "state" : "IL", "county" : "BUREAU" },
            "61345": { "city" : "NEPONSET", "state" : "IL", "county" : "BUREAU" },
            "61348": { "city" : "OGLESBY", "state" : "IL", "county" : "LA SALLE" },
            "61349": { "city" : "OHIO", "state" : "IL", "county" : "BUREAU" },"61350": { "city" : "OTTAWA", "state" : "IL", "county" : "LA SALLE" },
            "61353": { "city" : "PAW PAW", "state" : "IL", "county" : "LEE" },"61354": { "city" : "PERU", "state" : "IL", "county" : "LA SALLE" },
            "61356": { "city" : "PRINCETON", "state" : "IL", "county" : "BUREAU" },
            "61358": { "city" : "RUTLAND", "state" : "IL", "county" : "LA SALLE" },
            "61359": { "city" : "SEATONVILLE", "state" : "IL", "county" : "BUREAU" },
            "61360": { "city" : "SENECA", "state" : "IL", "county" : "LA SALLE" },
            "61361": { "city" : "SHEFFIELD", "state" : "IL", "county" : "BUREAU" },
            "61362": { "city" : "SPRING VALLEY", "state" : "IL", "county" : "BUREAU" },
            "61363": { "city" : "STANDARD", "state" : "IL", "county" : "PUTNAM" },
            "61364": { "city" : "STREATOR", "state" : "IL", "county" : "LA SALLE" },
            "61367": { "city" : "SUBLETTE", "state" : "IL", "county" : "LEE" },"61368": { "city" : "TISKILWA", "state" : "IL", "county" : "BUREAU" },
            "61369": { "city" : "TOLUCA", "state" : "IL", "county" : "MARSHALL" },
            "61370": { "city" : "TONICA", "state" : "IL", "county" : "LA SALLE" },
            "61371": { "city" : "TRIUMPH", "state" : "IL", "county" : "LA SALLE" },
            "61372": { "city" : "TROY GROVE", "state" : "IL", "county" : "LA SALLE" },
            "61373": { "city" : "UTICA", "state" : "IL", "county" : "LA SALLE" },
            "61374": { "city" : "VAN ORIN", "state" : "IL", "county" : "BUREAU" },
            "61375": { "city" : "VARNA", "state" : "IL", "county" : "MARSHALL" },
            "61376": { "city" : "WALNUT", "state" : "IL", "county" : "BUREAU" },"61377": { "city" : "WENONA", "state" : "IL", "county" : "MARSHALL" },
            "61378": { "city" : "WEST BROOKLYN", "state" : "IL", "county" : "LEE" },
            "61379": { "city" : "WYANET", "state" : "IL", "county" : "BUREAU" },"61401": { "city" : "GALESBURG", "state" : "IL", "county" : "KNOX" },
            "61402": { "city" : "GALESBURG", "state" : "IL", "county" : "KNOX" },
            "61410": { "city" : "ABINGDON", "state" : "IL", "county" : "KNOX" },"61411": { "city" : "ADAIR", "state" : "IL", "county" : "MCDONOUGH" },
            "61412": { "city" : "ALEXIS", "state" : "IL", "county" : "MERCER" },"61413": { "city" : "ALPHA", "state" : "IL", "county" : "HENRY" },
            "61414": { "city" : "ALTONA", "state" : "IL", "county" : "KNOX" },"61415": { "city" : "AVON", "state" : "IL", "county" : "FULTON" },
            "61416": { "city" : "BARDOLPH", "state" : "IL", "county" : "MCDONOUGH" },
            "61417": { "city" : "BERWICK", "state" : "IL", "county" : "WARREN" },
            "61418": { "city" : "BIGGSVILLE", "state" : "IL", "county" : "HENDERSON" },
            "61419": { "city" : "BISHOP HILL", "state" : "IL", "county" : "HENRY" },
            "61420": { "city" : "BLANDINSVILLE", "state" : "IL", "county" : "MCDONOUGH" },
            "61421": { "city" : "BRADFORD", "state" : "IL", "county" : "STARK" },
            "61422": { "city" : "BUSHNELL", "state" : "IL", "county" : "MCDONOUGH" },
            "61423": { "city" : "CAMERON", "state" : "IL", "county" : "WARREN" },
            "61424": { "city" : "CAMP GROVE", "state" : "IL", "county" : "MARSHALL" },
            "61425": { "city" : "CARMAN", "state" : "IL", "county" : "HENDERSON" },
            "61427": { "city" : "CUBA", "state" : "IL", "county" : "FULTON" },"61428": { "city" : "DAHINDA", "state" : "IL", "county" : "KNOX" },
            "61430": { "city" : "EAST GALESBURG", "state" : "IL", "county" : "KNOX" },
            "61431": { "city" : "ELLISVILLE", "state" : "IL", "county" : "FULTON" },
            "61432": { "city" : "FAIRVIEW", "state" : "IL", "county" : "FULTON" },
            "61433": { "city" : "FIATT", "state" : "IL", "county" : "FULTON" },"61434": { "city" : "GALVA", "state" : "IL", "county" : "HENRY" },
            "61435": { "city" : "GERLAW", "state" : "IL", "county" : "WARREN" },"61436": { "city" : "GILSON", "state" : "IL", "county" : "KNOX" },
            "61437": { "city" : "GLADSTONE", "state" : "IL", "county" : "HENDERSON" },
            "61438": { "city" : "GOOD HOPE", "state" : "IL", "county" : "MCDONOUGH" },
            "61439": { "city" : "HENDERSON", "state" : "IL", "county" : "KNOX" },
            "61440": { "city" : "INDUSTRY", "state" : "IL", "county" : "MCDONOUGH" },
            "61441": { "city" : "IPAVA", "state" : "IL", "county" : "FULTON" },"61442": { "city" : "KEITHSBURG", "state" : "IL", "county" : "MERCER" },
            "61443": { "city" : "KEWANEE", "state" : "IL", "county" : "HENRY" },"61447": { "city" : "KIRKWOOD", "state" : "IL", "county" : "WARREN" },
            "61448": { "city" : "KNOXVILLE", "state" : "IL", "county" : "KNOX" },
            "61449": { "city" : "LA FAYETTE", "state" : "IL", "county" : "STARK" },
            "61450": { "city" : "LA HARPE", "state" : "IL", "county" : "HANCOCK" },
            "61451": { "city" : "LAURA", "state" : "IL", "county" : "PEORIA" },"61452": { "city" : "LITTLETON", "state" : "IL", "county" : "SCHUYLER" },
            "61453": { "city" : "LITTLE YORK", "state" : "IL", "county" : "WARREN" },
            "61454": { "city" : "LOMAX", "state" : "IL", "county" : "HENDERSON" },
            "61455": { "city" : "MACOMB", "state" : "IL", "county" : "MCDONOUGH" },
            "61458": { "city" : "MAQUON", "state" : "IL", "county" : "KNOX" },"61459": { "city" : "MARIETTA", "state" : "IL", "county" : "FULTON" },
            "61460": { "city" : "MEDIA", "state" : "IL", "county" : "HENDERSON" },
            "61462": { "city" : "MONMOUTH", "state" : "IL", "county" : "WARREN" },
            "61465": { "city" : "NEW WINDSOR", "state" : "IL", "county" : "MERCER" },
            "61466": { "city" : "NORTH HENDERSON", "state" : "IL", "county" : "MERCER" },
            "61467": { "city" : "ONEIDA", "state" : "IL", "county" : "KNOX" },"61468": { "city" : "OPHIEM", "state" : "IL", "county" : "HENRY" },
            "61469": { "city" : "OQUAWKA", "state" : "IL", "county" : "HENDERSON" },
            "61470": { "city" : "PRAIRIE CITY", "state" : "IL", "county" : "MCDONOUGH" },
            "61471": { "city" : "RARITAN", "state" : "IL", "county" : "HENDERSON" },
            "61472": { "city" : "RIO", "state" : "IL", "county" : "KNOX" },"61473": { "city" : "ROSEVILLE", "state" : "IL", "county" : "WARREN" },
            "61474": { "city" : "SAINT AUGUSTINE", "state" : "IL", "county" : "KNOX" },
            "61475": { "city" : "SCIOTA", "state" : "IL", "county" : "MCDONOUGH" },
            "61476": { "city" : "SEATON", "state" : "IL", "county" : "MERCER" },"61477": { "city" : "SMITHFIELD", "state" : "IL", "county" : "FULTON" },
            "61478": { "city" : "SMITHSHIRE", "state" : "IL", "county" : "WARREN" },
            "61479": { "city" : "SPEER", "state" : "IL", "county" : "STARK" },"61480": { "city" : "STRONGHURST", "state" : "IL", "county" : "HENDERSON" },
            "61482": { "city" : "TABLE GROVE", "state" : "IL", "county" : "FULTON" },
            "61483": { "city" : "TOULON", "state" : "IL", "county" : "STARK" },"61484": { "city" : "VERMONT", "state" : "IL", "county" : "FULTON" },
            "61485": { "city" : "VICTORIA", "state" : "IL", "county" : "KNOX" },"61486": { "city" : "VIOLA", "state" : "IL", "county" : "MERCER" },
            "61488": { "city" : "WATAGA", "state" : "IL", "county" : "KNOX" },"61489": { "city" : "WILLIAMSFIELD", "state" : "IL", "county" : "KNOX" },
            "61490": { "city" : "WOODHULL", "state" : "IL", "county" : "HENRY" },
            "61491": { "city" : "WYOMING", "state" : "IL", "county" : "STARK" },"61501": { "city" : "ASTORIA", "state" : "IL", "county" : "FULTON" },
            "61516": { "city" : "BENSON", "state" : "IL", "county" : "WOODFORD" },
            "61517": { "city" : "BRIMFIELD", "state" : "IL", "county" : "PEORIA" },
            "61519": { "city" : "BRYANT", "state" : "IL", "county" : "FULTON" },"61520": { "city" : "CANTON", "state" : "IL", "county" : "FULTON" },
            "61523": { "city" : "CHILLICOTHE", "state" : "IL", "county" : "PEORIA" },
            "61524": { "city" : "DUNFERMLINE", "state" : "IL", "county" : "FULTON" },
            "61525": { "city" : "DUNLAP", "state" : "IL", "county" : "PEORIA" },"61526": { "city" : "EDELSTEIN", "state" : "IL", "county" : "PEORIA" },
            "61528": { "city" : "EDWARDS", "state" : "IL", "county" : "PEORIA" },
            "61529": { "city" : "ELMWOOD", "state" : "IL", "county" : "PEORIA" },
            "61530": { "city" : "EUREKA", "state" : "IL", "county" : "WOODFORD" },
            "61531": { "city" : "FARMINGTON", "state" : "IL", "county" : "FULTON" },
            "61532": { "city" : "FOREST CITY", "state" : "IL", "county" : "MASON" },
            "61533": { "city" : "GLASFORD", "state" : "IL", "county" : "PEORIA" },
            "61534": { "city" : "GREEN VALLEY", "state" : "IL", "county" : "TAZEWELL" },
            "61535": { "city" : "GROVELAND", "state" : "IL", "county" : "TAZEWELL" },
            "61536": { "city" : "HANNA CITY", "state" : "IL", "county" : "PEORIA" },
            "61537": { "city" : "HENRY", "state" : "IL", "county" : "MARSHALL" },
            "61539": { "city" : "KINGSTON MINES", "state" : "IL", "county" : "PEORIA" },
            "61540": { "city" : "LACON", "state" : "IL", "county" : "MARSHALL" },
            "61541": { "city" : "LA ROSE", "state" : "IL", "county" : "MARSHALL" },
            "61542": { "city" : "LEWISTOWN", "state" : "IL", "county" : "FULTON" },
            "61543": { "city" : "LIVERPOOL", "state" : "IL", "county" : "FULTON" },
            "61544": { "city" : "LONDON MILLS", "state" : "IL", "county" : "FULTON" },
            "61545": { "city" : "LOWPOINT", "state" : "IL", "county" : "WOODFORD" },
            "61546": { "city" : "MANITO", "state" : "IL", "county" : "MASON" },"61547": { "city" : "MAPLETON", "state" : "IL", "county" : "PEORIA" },
            "61548": { "city" : "METAMORA", "state" : "IL", "county" : "WOODFORD" },
            "61550": { "city" : "MORTON", "state" : "IL", "county" : "TAZEWELL" },
            "61552": { "city" : "MOSSVILLE", "state" : "IL", "county" : "PEORIA" },
            "61553": { "city" : "NORRIS", "state" : "IL", "county" : "FULTON" },"61554": { "city" : "PEKIN", "state" : "IL", "county" : "TAZEWELL" },
            "61555": { "city" : "PEKIN", "state" : "IL", "county" : "TAZEWELL" },
            "61558": { "city" : "PEKIN", "state" : "IL", "county" : "TAZEWELL" },
            "61559": { "city" : "PRINCEVILLE", "state" : "IL", "county" : "PEORIA" },
            "61560": { "city" : "PUTNAM", "state" : "IL", "county" : "PUTNAM" },"61561": { "city" : "ROANOKE", "state" : "IL", "county" : "WOODFORD" },
            "61562": { "city" : "ROME", "state" : "IL", "county" : "PEORIA" },"61563": { "city" : "SAINT DAVID", "state" : "IL", "county" : "FULTON" },
            "61564": { "city" : "SOUTH PEKIN", "state" : "IL", "county" : "TAZEWELL" },
            "61565": { "city" : "SPARLAND", "state" : "IL", "county" : "MARSHALL" },
            "61567": { "city" : "TOPEKA", "state" : "IL", "county" : "MASON" },"61568": { "city" : "TREMONT", "state" : "IL", "county" : "TAZEWELL" },
            "61569": { "city" : "TRIVOLI", "state" : "IL", "county" : "PEORIA" },
            "61570": { "city" : "WASHBURN", "state" : "IL", "county" : "MARSHALL" },
            "61571": { "city" : "WASHINGTON", "state" : "IL", "county" : "TAZEWELL" },
            "61572": { "city" : "YATES CITY", "state" : "IL", "county" : "KNOX" },
            "61601": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61602": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61603": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61604": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61605": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61606": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61607": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61610": { "city" : "CREVE COEUR", "state" : "IL", "county" : "TAZEWELL" },
            "61611": { "city" : "EAST PEORIA", "state" : "IL", "county" : "TAZEWELL" },
            "61612": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61613": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61614": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61615": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61616": { "city" : "PEORIA HEIGHTS", "state" : "IL", "county" : "PEORIA" },
            "61625": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61629": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61630": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61634": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61635": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61636": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61637": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61639": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61641": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61643": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61650": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61651": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61652": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61653": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61654": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61655": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },
            "61656": { "city" : "PEORIA", "state" : "IL", "county" : "PEORIA" },"61701": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61702": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61704": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61705": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61709": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61710": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61720": { "city" : "ANCHOR", "state" : "IL", "county" : "MCLEAN" },"61721": { "city" : "ARMINGTON", "state" : "IL", "county" : "TAZEWELL" },
            "61722": { "city" : "ARROWSMITH", "state" : "IL", "county" : "MCLEAN" },
            "61723": { "city" : "ATLANTA", "state" : "IL", "county" : "LOGAN" },"61724": { "city" : "BELLFLOWER", "state" : "IL", "county" : "MCLEAN" },
            "61725": { "city" : "CARLOCK", "state" : "IL", "county" : "MCLEAN" },
            "61726": { "city" : "CHENOA", "state" : "IL", "county" : "MCLEAN" },"61727": { "city" : "CLINTON", "state" : "IL", "county" : "DEWITT" },
            "61728": { "city" : "COLFAX", "state" : "IL", "county" : "MCLEAN" },"61729": { "city" : "CONGERVILLE", "state" : "IL", "county" : "WOODFORD" },
            "61730": { "city" : "COOKSVILLE", "state" : "IL", "county" : "MCLEAN" },
            "61731": { "city" : "CROPSEY", "state" : "IL", "county" : "MCLEAN" },
            "61732": { "city" : "DANVERS", "state" : "IL", "county" : "MCLEAN" },
            "61733": { "city" : "DEER CREEK", "state" : "IL", "county" : "TAZEWELL" },
            "61734": { "city" : "DELAVAN", "state" : "IL", "county" : "TAZEWELL" },
            "61735": { "city" : "DEWITT", "state" : "IL", "county" : "DEWITT" },"61736": { "city" : "DOWNS", "state" : "IL", "county" : "MCLEAN" },
            "61737": { "city" : "ELLSWORTH", "state" : "IL", "county" : "MCLEAN" },
            "61738": { "city" : "EL PASO", "state" : "IL", "county" : "WOODFORD" },
            "61739": { "city" : "FAIRBURY", "state" : "IL", "county" : "LIVINGSTON" },
            "61740": { "city" : "FLANAGAN", "state" : "IL", "county" : "LIVINGSTON" },
            "61741": { "city" : "FORREST", "state" : "IL", "county" : "LIVINGSTON" },
            "61742": { "city" : "GOODFIELD", "state" : "IL", "county" : "WOODFORD" },
            "61743": { "city" : "GRAYMONT", "state" : "IL", "county" : "LIVINGSTON" },
            "61744": { "city" : "GRIDLEY", "state" : "IL", "county" : "MCLEAN" },
            "61745": { "city" : "HEYWORTH", "state" : "IL", "county" : "MCLEAN" },
            "61747": { "city" : "HOPEDALE", "state" : "IL", "county" : "TAZEWELL" },
            "61748": { "city" : "HUDSON", "state" : "IL", "county" : "MCLEAN" },"61749": { "city" : "KENNEY", "state" : "IL", "county" : "DEWITT" },
            "61750": { "city" : "LANE", "state" : "IL", "county" : "DEWITT" },"61751": { "city" : "LAWNDALE", "state" : "IL", "county" : "LOGAN" },
            "61752": { "city" : "LE ROY", "state" : "IL", "county" : "MCLEAN" },"61753": { "city" : "LEXINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61754": { "city" : "MC LEAN", "state" : "IL", "county" : "MCLEAN" },
            "61755": { "city" : "MACKINAW", "state" : "IL", "county" : "TAZEWELL" },
            "61756": { "city" : "MAROA", "state" : "IL", "county" : "MACON" },"61758": { "city" : "MERNA", "state" : "IL", "county" : "MCLEAN" },
            "61759": { "city" : "MINIER", "state" : "IL", "county" : "TAZEWELL" },
            "61760": { "city" : "MINONK", "state" : "IL", "county" : "WOODFORD" },
            "61761": { "city" : "NORMAL", "state" : "IL", "county" : "MCLEAN" },"61764": { "city" : "PONTIAC", "state" : "IL", "county" : "LIVINGSTON" },
            "61769": { "city" : "SAUNEMIN", "state" : "IL", "county" : "LIVINGSTON" },
            "61770": { "city" : "SAYBROOK", "state" : "IL", "county" : "MCLEAN" },
            "61771": { "city" : "SECOR", "state" : "IL", "county" : "WOODFORD" },
            "61772": { "city" : "SHIRLEY", "state" : "IL", "county" : "MCLEAN" },
            "61773": { "city" : "SIBLEY", "state" : "IL", "county" : "FORD" },"61774": { "city" : "STANFORD", "state" : "IL", "county" : "MCLEAN" },
            "61775": { "city" : "STRAWN", "state" : "IL", "county" : "LIVINGSTON" },
            "61776": { "city" : "TOWANDA", "state" : "IL", "county" : "MCLEAN" },
            "61777": { "city" : "WAPELLA", "state" : "IL", "county" : "DEWITT" },
            "61778": { "city" : "WAYNESVILLE", "state" : "IL", "county" : "DEWITT" },
            "61790": { "city" : "NORMAL", "state" : "IL", "county" : "MCLEAN" },"61791": { "city" : "BLOOMINGTON", "state" : "IL", "county" : "MCLEAN" },
            "61801": { "city" : "URBANA", "state" : "IL", "county" : "CHAMPAIGN" },
            "61802": { "city" : "URBANA", "state" : "IL", "county" : "CHAMPAIGN" },
            "61803": { "city" : "URBANA", "state" : "IL", "county" : "CHAMPAIGN" },
            "61810": { "city" : "ALLERTON", "state" : "IL", "county" : "VERMILION" },
            "61811": { "city" : "ALVIN", "state" : "IL", "county" : "VERMILION" },
            "61812": { "city" : "ARMSTRONG", "state" : "IL", "county" : "VERMILION" },
            "61813": { "city" : "BEMENT", "state" : "IL", "county" : "PIATT" },"61814": { "city" : "BISMARCK", "state" : "IL", "county" : "VERMILION" },
            "61815": { "city" : "BONDVILLE", "state" : "IL", "county" : "CHAMPAIGN" },
            "61816": { "city" : "BROADLANDS", "state" : "IL", "county" : "CHAMPAIGN" },
            "61817": { "city" : "CATLIN", "state" : "IL", "county" : "VERMILION" },
            "61818": { "city" : "CERRO GORDO", "state" : "IL", "county" : "PIATT" },
            "61820": { "city" : "CHAMPAIGN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61821": { "city" : "CHAMPAIGN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61822": { "city" : "CHAMPAIGN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61824": { "city" : "CHAMPAIGN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61825": { "city" : "CHAMPAIGN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61826": { "city" : "CHAMPAIGN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61830": { "city" : "CISCO", "state" : "IL", "county" : "PIATT" },"61832": { "city" : "DANVILLE", "state" : "IL", "county" : "VERMILION" },
            "61833": { "city" : "TILTON", "state" : "IL", "county" : "VERMILION" },
            "61834": { "city" : "DANVILLE", "state" : "IL", "county" : "VERMILION" },
            "61839": { "city" : "DE LAND", "state" : "IL", "county" : "PIATT" },"61840": { "city" : "DEWEY", "state" : "IL", "county" : "CHAMPAIGN" },
            "61841": { "city" : "FAIRMOUNT", "state" : "IL", "county" : "VERMILION" },
            "61842": { "city" : "FARMER CITY", "state" : "IL", "county" : "DEWITT" },
            "61843": { "city" : "FISHER", "state" : "IL", "county" : "CHAMPAIGN" },
            "61844": { "city" : "FITHIAN", "state" : "IL", "county" : "VERMILION" },
            "61845": { "city" : "FOOSLAND", "state" : "IL", "county" : "CHAMPAIGN" },
            "61846": { "city" : "GEORGETOWN", "state" : "IL", "county" : "VERMILION" },
            "61847": { "city" : "GIFFORD", "state" : "IL", "county" : "CHAMPAIGN" },
            "61848": { "city" : "HENNING", "state" : "IL", "county" : "VERMILION" },
            "61849": { "city" : "HOMER", "state" : "IL", "county" : "CHAMPAIGN" },
            "61850": { "city" : "INDIANOLA", "state" : "IL", "county" : "VERMILION" },
            "61851": { "city" : "IVESDALE", "state" : "IL", "county" : "CHAMPAIGN" },
            "61852": { "city" : "LONGVIEW", "state" : "IL", "county" : "CHAMPAIGN" },
            "61853": { "city" : "MAHOMET", "state" : "IL", "county" : "CHAMPAIGN" },
            "61854": { "city" : "MANSFIELD", "state" : "IL", "county" : "PIATT" },
            "61855": { "city" : "MILMINE", "state" : "IL", "county" : "PIATT" },"61856": { "city" : "MONTICELLO", "state" : "IL", "county" : "PIATT" },
            "61857": { "city" : "MUNCIE", "state" : "IL", "county" : "VERMILION" },
            "61858": { "city" : "OAKWOOD", "state" : "IL", "county" : "VERMILION" },
            "61859": { "city" : "OGDEN", "state" : "IL", "county" : "CHAMPAIGN" },
            "61862": { "city" : "PENFIELD", "state" : "IL", "county" : "CHAMPAIGN" },
            "61863": { "city" : "PESOTUM", "state" : "IL", "county" : "CHAMPAIGN" },
            "61864": { "city" : "PHILO", "state" : "IL", "county" : "CHAMPAIGN" },
            "61865": { "city" : "POTOMAC", "state" : "IL", "county" : "VERMILION" },
            "61866": { "city" : "RANTOUL", "state" : "IL", "county" : "CHAMPAIGN" },
            "61870": { "city" : "RIDGE FARM", "state" : "IL", "county" : "VERMILION" },
            "61871": { "city" : "ROYAL", "state" : "IL", "county" : "CHAMPAIGN" },
            "61872": { "city" : "SADORUS", "state" : "IL", "county" : "CHAMPAIGN" },
            "61873": { "city" : "SAINT JOSEPH", "state" : "IL", "county" : "CHAMPAIGN" },
            "61874": { "city" : "SAVOY", "state" : "IL", "county" : "CHAMPAIGN" },
            "61875": { "city" : "SEYMOUR", "state" : "IL", "county" : "CHAMPAIGN" },
            "61876": { "city" : "SIDELL", "state" : "IL", "county" : "VERMILION" },
            "61877": { "city" : "SIDNEY", "state" : "IL", "county" : "CHAMPAIGN" },
            "61878": { "city" : "THOMASBORO", "state" : "IL", "county" : "CHAMPAIGN" },
            "61880": { "city" : "TOLONO", "state" : "IL", "county" : "CHAMPAIGN" },
            "61882": { "city" : "WELDON", "state" : "IL", "county" : "DEWITT" },"61883": { "city" : "WESTVILLE", "state" : "IL", "county" : "VERMILION" },
            "61884": { "city" : "WHITE HEATH", "state" : "IL", "county" : "PIATT" },
            "61910": { "city" : "ARCOLA", "state" : "IL", "county" : "DOUGLAS" },
            "61911": { "city" : "ARTHUR", "state" : "IL", "county" : "DOUGLAS" },
            "61912": { "city" : "ASHMORE", "state" : "IL", "county" : "COLES" },"61913": { "city" : "ATWOOD", "state" : "IL", "county" : "DOUGLAS" },
            "61914": { "city" : "BETHANY", "state" : "IL", "county" : "MOULTRIE" },
            "61917": { "city" : "BROCTON", "state" : "IL", "county" : "EDGAR" },"61919": { "city" : "CAMARGO", "state" : "IL", "county" : "DOUGLAS" },
            "61920": { "city" : "CHARLESTON", "state" : "IL", "county" : "COLES" },
            "61924": { "city" : "CHRISMAN", "state" : "IL", "county" : "EDGAR" },
            "61925": { "city" : "DALTON CITY", "state" : "IL", "county" : "MOULTRIE" },
            "61928": { "city" : "GAYS", "state" : "IL", "county" : "MOULTRIE" },"61929": { "city" : "HAMMOND", "state" : "IL", "county" : "PIATT" },
            "61930": { "city" : "HINDSBORO", "state" : "IL", "county" : "DOUGLAS" },
            "61931": { "city" : "HUMBOLDT", "state" : "IL", "county" : "COLES" },
            "61932": { "city" : "HUME", "state" : "IL", "county" : "EDGAR" },"61933": { "city" : "KANSAS", "state" : "IL", "county" : "EDGAR" },
            "61936": { "city" : "LA PLACE", "state" : "IL", "county" : "PIATT" },
            "61937": { "city" : "LOVINGTON", "state" : "IL", "county" : "MOULTRIE" },
            "61938": { "city" : "MATTOON", "state" : "IL", "county" : "COLES" },"61940": { "city" : "METCALF", "state" : "IL", "county" : "EDGAR" },
            "61942": { "city" : "NEWMAN", "state" : "IL", "county" : "DOUGLAS" },
            "61943": { "city" : "OAKLAND", "state" : "IL", "county" : "COLES" },"61944": { "city" : "PARIS", "state" : "IL", "county" : "EDGAR" },
            "61949": { "city" : "REDMON", "state" : "IL", "county" : "EDGAR" },"61951": { "city" : "SULLIVAN", "state" : "IL", "county" : "MOULTRIE" },
            "61953": { "city" : "TUSCOLA", "state" : "IL", "county" : "DOUGLAS" },
            "61955": { "city" : "VERMILION", "state" : "IL", "county" : "EDGAR" },
            "61956": { "city" : "VILLA GROVE", "state" : "IL", "county" : "DOUGLAS" },
            "61957": { "city" : "WINDSOR", "state" : "IL", "county" : "SHELBY" },
            "62001": { "city" : "ALHAMBRA", "state" : "IL", "county" : "MADISON" },
            "62002": { "city" : "ALTON", "state" : "IL", "county" : "MADISON" },"62006": { "city" : "BATCHTOWN", "state" : "IL", "county" : "CALHOUN" },
            "62009": { "city" : "BENLD", "state" : "IL", "county" : "MACOUPIN" },
            "62010": { "city" : "BETHALTO", "state" : "IL", "county" : "MADISON" },
            "62011": { "city" : "BINGHAM", "state" : "IL", "county" : "FAYETTE" },
            "62012": { "city" : "BRIGHTON", "state" : "IL", "county" : "MACOUPIN" },
            "62013": { "city" : "BRUSSELS", "state" : "IL", "county" : "CALHOUN" },
            "62014": { "city" : "BUNKER HILL", "state" : "IL", "county" : "MACOUPIN" },
            "62015": { "city" : "BUTLER", "state" : "IL", "county" : "MONTGOMERY" },
            "62016": { "city" : "CARROLLTON", "state" : "IL", "county" : "GREENE" },
            "62017": { "city" : "COFFEEN", "state" : "IL", "county" : "MONTGOMERY" },
            "62018": { "city" : "COTTAGE HILLS", "state" : "IL", "county" : "MADISON" },
            "62019": { "city" : "DONNELLSON", "state" : "IL", "county" : "MONTGOMERY" },
            "62021": { "city" : "DORSEY", "state" : "IL", "county" : "MADISON" },
            "62022": { "city" : "DOW", "state" : "IL", "county" : "JERSEY" },"62023": { "city" : "EAGARVILLE", "state" : "IL", "county" : "MACOUPIN" },
            "62024": { "city" : "EAST ALTON", "state" : "IL", "county" : "MADISON" },
            "62025": { "city" : "EDWARDSVILLE", "state" : "IL", "county" : "MADISON" },
            "62026": { "city" : "EDWARDSVILLE", "state" : "IL", "county" : "MADISON" },
            "62027": { "city" : "ELDRED", "state" : "IL", "county" : "GREENE" },"62028": { "city" : "ELSAH", "state" : "IL", "county" : "JERSEY" },
            "62030": { "city" : "FIDELITY", "state" : "IL", "county" : "JERSEY" },
            "62031": { "city" : "FIELDON", "state" : "IL", "county" : "JERSEY" },
            "62032": { "city" : "FILLMORE", "state" : "IL", "county" : "MONTGOMERY" },
            "62033": { "city" : "GILLESPIE", "state" : "IL", "county" : "MACOUPIN" },
            "62034": { "city" : "GLEN CARBON", "state" : "IL", "county" : "MADISON" },
            "62035": { "city" : "GODFREY", "state" : "IL", "county" : "MADISON" },
            "62036": { "city" : "GOLDEN EAGLE", "state" : "IL", "county" : "CALHOUN" },
            "62037": { "city" : "GRAFTON", "state" : "IL", "county" : "JERSEY" },
            "62040": { "city" : "GRANITE CITY", "state" : "IL", "county" : "MADISON" },
            "62044": { "city" : "GREENFIELD", "state" : "IL", "county" : "GREENE" },
            "62045": { "city" : "HAMBURG", "state" : "IL", "county" : "CALHOUN" },
            "62046": { "city" : "HAMEL", "state" : "IL", "county" : "MADISON" },"62047": { "city" : "HARDIN", "state" : "IL", "county" : "CALHOUN" },
            "62048": { "city" : "HARTFORD", "state" : "IL", "county" : "MADISON" },
            "62049": { "city" : "HILLSBORO", "state" : "IL", "county" : "MONTGOMERY" },
            "62050": { "city" : "HILLVIEW", "state" : "IL", "county" : "GREENE" },
            "62051": { "city" : "IRVING", "state" : "IL", "county" : "MONTGOMERY" },
            "62052": { "city" : "JERSEYVILLE", "state" : "IL", "county" : "JERSEY" },
            "62053": { "city" : "KAMPSVILLE", "state" : "IL", "county" : "CALHOUN" },
            "62054": { "city" : "KANE", "state" : "IL", "county" : "GREENE" },"62056": { "city" : "LITCHFIELD", "state" : "IL", "county" : "MONTGOMERY" },
            "62058": { "city" : "LIVINGSTON", "state" : "IL", "county" : "MADISON" },
            "62059": { "city" : "LOVEJOY", "state" : "IL", "county" : "SAINT CLAIR" },
            "62060": { "city" : "MADISON", "state" : "IL", "county" : "MADISON" },
            "62061": { "city" : "MARINE", "state" : "IL", "county" : "MADISON" },
            "62062": { "city" : "MARYVILLE", "state" : "IL", "county" : "MADISON" },
            "62063": { "city" : "MEDORA", "state" : "IL", "county" : "JERSEY" },"62065": { "city" : "MICHAEL", "state" : "IL", "county" : "CALHOUN" },
            "62067": { "city" : "MORO", "state" : "IL", "county" : "MADISON" },"62069": { "city" : "MOUNT OLIVE", "state" : "IL", "county" : "MACOUPIN" },
            "62070": { "city" : "MOZIER", "state" : "IL", "county" : "CALHOUN" },
            "62071": { "city" : "NATIONAL STOCK YARDS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62074": { "city" : "NEW DOUGLAS", "state" : "IL", "county" : "MADISON" },
            "62075": { "city" : "NOKOMIS", "state" : "IL", "county" : "MONTGOMERY" },
            "62076": { "city" : "OHLMAN", "state" : "IL", "county" : "MONTGOMERY" },
            "62077": { "city" : "PANAMA", "state" : "IL", "county" : "MONTGOMERY" },
            "62079": { "city" : "PIASA", "state" : "IL", "county" : "MACOUPIN" },
            "62080": { "city" : "RAMSEY", "state" : "IL", "county" : "FAYETTE" },
            "62081": { "city" : "ROCKBRIDGE", "state" : "IL", "county" : "GREENE" },
            "62082": { "city" : "ROODHOUSE", "state" : "IL", "county" : "GREENE" },
            "62083": { "city" : "ROSAMOND", "state" : "IL", "county" : "CHRISTIAN" },
            "62084": { "city" : "ROXANA", "state" : "IL", "county" : "MADISON" },
            "62086": { "city" : "SORENTO", "state" : "IL", "county" : "BOND" },"62087": { "city" : "SOUTH ROXANA", "state" : "IL", "county" : "MADISON" },
            "62088": { "city" : "STAUNTON", "state" : "IL", "county" : "MACOUPIN" },
            "62089": { "city" : "TAYLOR SPRINGS", "state" : "IL", "county" : "MONTGOMERY" },
            "62090": { "city" : "VENICE", "state" : "IL", "county" : "MADISON" },
            "62091": { "city" : "WALSHVILLE", "state" : "IL", "county" : "MONTGOMERY" },
            "62092": { "city" : "WHITE HALL", "state" : "IL", "county" : "GREENE" },
            "62093": { "city" : "WILSONVILLE", "state" : "IL", "county" : "MACOUPIN" },
            "62094": { "city" : "WITT", "state" : "IL", "county" : "MONTGOMERY" },
            "62095": { "city" : "WOOD RIVER", "state" : "IL", "county" : "MADISON" },
            "62097": { "city" : "WORDEN", "state" : "IL", "county" : "MADISON" },
            "62098": { "city" : "WRIGHTS", "state" : "IL", "county" : "GREENE" },
            "62201": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62202": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62203": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62204": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62205": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62206": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62207": { "city" : "EAST SAINT LOUIS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62208": { "city" : "FAIRVIEW HEIGHTS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62214": { "city" : "ADDIEVILLE", "state" : "IL", "county" : "WASHINGTON" },
            "62215": { "city" : "ALBERS", "state" : "IL", "county" : "CLINTON" },
            "62216": { "city" : "AVISTON", "state" : "IL", "county" : "CLINTON" },
            "62217": { "city" : "BALDWIN", "state" : "IL", "county" : "RANDOLPH" },
            "62218": { "city" : "BARTELSO", "state" : "IL", "county" : "CLINTON" },
            "62219": { "city" : "BECKEMEYER", "state" : "IL", "county" : "CLINTON" },
            "62220": { "city" : "BELLEVILLE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62221": { "city" : "BELLEVILLE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62222": { "city" : "BELLEVILLE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62223": { "city" : "BELLEVILLE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62225": { "city" : "SCOTT AIR FORCE BASE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62226": { "city" : "BELLEVILLE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62230": { "city" : "BREESE", "state" : "IL", "county" : "CLINTON" },
            "62231": { "city" : "CARLYLE", "state" : "IL", "county" : "CLINTON" },
            "62232": { "city" : "CASEYVILLE", "state" : "IL", "county" : "SAINT CLAIR" },
            "62233": { "city" : "CHESTER", "state" : "IL", "county" : "RANDOLPH" },
            "62234": { "city" : "COLLINSVILLE", "state" : "IL", "county" : "MADISON" },
            "62236": { "city" : "COLUMBIA", "state" : "IL", "county" : "MONROE" },
            "62237": { "city" : "COULTERVILLE", "state" : "IL", "county" : "RANDOLPH" },
            "62238": { "city" : "CUTLER", "state" : "IL", "county" : "PERRY" },"62239": { "city" : "DUPO", "state" : "IL", "county" : "SAINT CLAIR" },
            "62240": { "city" : "EAST CARONDELET", "state" : "IL", "county" : "SAINT CLAIR" },
            "62241": { "city" : "ELLIS GROVE", "state" : "IL", "county" : "RANDOLPH" },
            "62242": { "city" : "EVANSVILLE", "state" : "IL", "county" : "RANDOLPH" },
            "62243": { "city" : "FREEBURG", "state" : "IL", "county" : "SAINT CLAIR" },
            "62244": { "city" : "FULTS", "state" : "IL", "county" : "MONROE" },"62245": { "city" : "GERMANTOWN", "state" : "IL", "county" : "CLINTON" },
            "62246": { "city" : "GREENVILLE", "state" : "IL", "county" : "BOND" },
            "62247": { "city" : "HAGARSTOWN", "state" : "IL", "county" : "FAYETTE" },
            "62248": { "city" : "HECKER", "state" : "IL", "county" : "MONROE" },"62249": { "city" : "HIGHLAND", "state" : "IL", "county" : "MADISON" },
            "62250": { "city" : "HOFFMAN", "state" : "IL", "county" : "CLINTON" },
            "62252": { "city" : "HUEY", "state" : "IL", "county" : "CLINTON" },"62253": { "city" : "KEYESPORT", "state" : "IL", "county" : "CLINTON" },
            "62254": { "city" : "LEBANON", "state" : "IL", "county" : "SAINT CLAIR" },
            "62255": { "city" : "LENZBURG", "state" : "IL", "county" : "SAINT CLAIR" },
            "62256": { "city" : "MAEYSTOWN", "state" : "IL", "county" : "MONROE" },
            "62257": { "city" : "MARISSA", "state" : "IL", "county" : "SAINT CLAIR" },
            "62258": { "city" : "MASCOUTAH", "state" : "IL", "county" : "SAINT CLAIR" },
            "62259": { "city" : "MENARD", "state" : "IL", "county" : "RANDOLPH" },
            "62260": { "city" : "MILLSTADT", "state" : "IL", "county" : "SAINT CLAIR" },
            "62261": { "city" : "MODOC", "state" : "IL", "county" : "RANDOLPH" },
            "62262": { "city" : "MULBERRY GROVE", "state" : "IL", "county" : "BOND" },
            "62263": { "city" : "NASHVILLE", "state" : "IL", "county" : "WASHINGTON" },
            "62264": { "city" : "NEW ATHENS", "state" : "IL", "county" : "SAINT CLAIR" },
            "62265": { "city" : "NEW BADEN", "state" : "IL", "county" : "CLINTON" },
            "62266": { "city" : "NEW MEMPHIS", "state" : "IL", "county" : "CLINTON" },
            "62268": { "city" : "OAKDALE", "state" : "IL", "county" : "WASHINGTON" },
            "62269": { "city" : "O FALLON", "state" : "IL", "county" : "SAINT CLAIR" },
            "62271": { "city" : "OKAWVILLE", "state" : "IL", "county" : "WASHINGTON" },
            "62272": { "city" : "PERCY", "state" : "IL", "county" : "RANDOLPH" },
            "62273": { "city" : "PIERRON", "state" : "IL", "county" : "BOND" },"62274": { "city" : "PINCKNEYVILLE", "state" : "IL", "county" : "PERRY" },
            "62275": { "city" : "POCAHONTAS", "state" : "IL", "county" : "BOND" },
            "62277": { "city" : "PRAIRIE DU ROCHER", "state" : "IL", "county" : "RANDOLPH" },
            "62278": { "city" : "RED BUD", "state" : "IL", "county" : "RANDOLPH" },
            "62279": { "city" : "RENAULT", "state" : "IL", "county" : "MONROE" },
            "62280": { "city" : "ROCKWOOD", "state" : "IL", "county" : "RANDOLPH" },
            "62281": { "city" : "SAINT JACOB", "state" : "IL", "county" : "MADISON" },
            "62282": { "city" : "SAINT LIBORY", "state" : "IL", "county" : "SAINT CLAIR" },
            "62284": { "city" : "SMITHBORO", "state" : "IL", "county" : "BOND" },
            "62285": { "city" : "SMITHTON", "state" : "IL", "county" : "SAINT CLAIR" },
            "62286": { "city" : "SPARTA", "state" : "IL", "county" : "RANDOLPH" },
            "62288": { "city" : "STEELEVILLE", "state" : "IL", "county" : "RANDOLPH" },
            "62289": { "city" : "SUMMERFIELD", "state" : "IL", "county" : "SAINT CLAIR" },
            "62292": { "city" : "TILDEN", "state" : "IL", "county" : "RANDOLPH" },
            "62293": { "city" : "TRENTON", "state" : "IL", "county" : "CLINTON" },
            "62294": { "city" : "TROY", "state" : "IL", "county" : "MADISON" },"62295": { "city" : "VALMEYER", "state" : "IL", "county" : "MONROE" },
            "62297": { "city" : "WALSH", "state" : "IL", "county" : "RANDOLPH" },
            "62298": { "city" : "WATERLOO", "state" : "IL", "county" : "MONROE" },
            "62301": { "city" : "QUINCY", "state" : "IL", "county" : "ADAMS" },"62305": { "city" : "QUINCY", "state" : "IL", "county" : "ADAMS" },
            "62306": { "city" : "QUINCY", "state" : "IL", "county" : "ADAMS" },"62311": { "city" : "AUGUSTA", "state" : "IL", "county" : "HANCOCK" },
            "62312": { "city" : "BARRY", "state" : "IL", "county" : "PIKE" },"62313": { "city" : "BASCO", "state" : "IL", "county" : "HANCOCK" },
            "62314": { "city" : "BAYLIS", "state" : "IL", "county" : "PIKE" },"62316": { "city" : "BOWEN", "state" : "IL", "county" : "HANCOCK" },
            "62319": { "city" : "CAMDEN", "state" : "IL", "county" : "SCHUYLER" },
            "62320": { "city" : "CAMP POINT", "state" : "IL", "county" : "ADAMS" },
            "62321": { "city" : "CARTHAGE", "state" : "IL", "county" : "HANCOCK" },
            "62323": { "city" : "CHAMBERSBURG", "state" : "IL", "county" : "PIKE" },
            "62324": { "city" : "CLAYTON", "state" : "IL", "county" : "ADAMS" },"62325": { "city" : "COATSBURG", "state" : "IL", "county" : "ADAMS" },
            "62326": { "city" : "COLCHESTER", "state" : "IL", "county" : "MCDONOUGH" },
            "62329": { "city" : "COLUSA", "state" : "IL", "county" : "HANCOCK" },
            "62330": { "city" : "DALLAS CITY", "state" : "IL", "county" : "HANCOCK" },
            "62334": { "city" : "ELVASTON", "state" : "IL", "county" : "HANCOCK" },
            "62336": { "city" : "FERRIS", "state" : "IL", "county" : "HANCOCK" },
            "62338": { "city" : "FOWLER", "state" : "IL", "county" : "ADAMS" },"62339": { "city" : "GOLDEN", "state" : "IL", "county" : "ADAMS" },
            "62340": { "city" : "GRIGGSVILLE", "state" : "IL", "county" : "PIKE" },
            "62341": { "city" : "HAMILTON", "state" : "IL", "county" : "HANCOCK" },
            "62343": { "city" : "HULL", "state" : "IL", "county" : "PIKE" },"62344": { "city" : "HUNTSVILLE", "state" : "IL", "county" : "SCHUYLER" },
            "62345": { "city" : "KINDERHOOK", "state" : "IL", "county" : "PIKE" },
            "62346": { "city" : "LA PRAIRIE", "state" : "IL", "county" : "ADAMS" },
            "62347": { "city" : "LIBERTY", "state" : "IL", "county" : "ADAMS" },"62348": { "city" : "LIMA", "state" : "IL", "county" : "ADAMS" },
            "62349": { "city" : "LORAINE", "state" : "IL", "county" : "ADAMS" },"62351": { "city" : "MENDON", "state" : "IL", "county" : "ADAMS" },
            "62352": { "city" : "MILTON", "state" : "IL", "county" : "PIKE" },"62353": { "city" : "MOUNT STERLING", "state" : "IL", "county" : "BROWN" },
            "62354": { "city" : "NAUVOO", "state" : "IL", "county" : "HANCOCK" },
            "62355": { "city" : "NEBO", "state" : "IL", "county" : "PIKE" },"62356": { "city" : "NEW CANTON", "state" : "IL", "county" : "PIKE" },
            "62357": { "city" : "NEW SALEM", "state" : "IL", "county" : "PIKE" },
            "62358": { "city" : "NIOTA", "state" : "IL", "county" : "HANCOCK" },"62359": { "city" : "PALOMA", "state" : "IL", "county" : "ADAMS" },
            "62360": { "city" : "PAYSON", "state" : "IL", "county" : "ADAMS" },"62361": { "city" : "PEARL", "state" : "IL", "county" : "PIKE" },
            "62362": { "city" : "PERRY", "state" : "IL", "county" : "PIKE" },"62363": { "city" : "PITTSFIELD", "state" : "IL", "county" : "PIKE" },
            "62365": { "city" : "PLAINVILLE", "state" : "IL", "county" : "ADAMS" },
            "62366": { "city" : "PLEASANT HILL", "state" : "IL", "county" : "PIKE" },
            "62367": { "city" : "PLYMOUTH", "state" : "IL", "county" : "HANCOCK" },
            "62370": { "city" : "ROCKPORT", "state" : "IL", "county" : "PIKE" },"62373": { "city" : "SUTTER", "state" : "IL", "county" : "HANCOCK" },
            "62374": { "city" : "TENNESSEE", "state" : "IL", "county" : "MCDONOUGH" },
            "62375": { "city" : "TIMEWELL", "state" : "IL", "county" : "BROWN" },
            "62376": { "city" : "URSA", "state" : "IL", "county" : "ADAMS" },"62378": { "city" : "VERSAILLES", "state" : "IL", "county" : "BROWN" },
            "62379": { "city" : "WARSAW", "state" : "IL", "county" : "HANCOCK" },
            "62380": { "city" : "WEST POINT", "state" : "IL", "county" : "HANCOCK" },
            "62401": { "city" : "EFFINGHAM", "state" : "IL", "county" : "EFFINGHAM" },
            "62410": { "city" : "ALLENDALE", "state" : "IL", "county" : "WABASH" },
            "62411": { "city" : "ALTAMONT", "state" : "IL", "county" : "EFFINGHAM" },
            "62413": { "city" : "ANNAPOLIS", "state" : "IL", "county" : "CRAWFORD" },
            "62414": { "city" : "BEECHER CITY", "state" : "IL", "county" : "EFFINGHAM" },
            "62417": { "city" : "BRIDGEPORT", "state" : "IL", "county" : "LAWRENCE" },
            "62418": { "city" : "BROWNSTOWN", "state" : "IL", "county" : "FAYETTE" },
            "62419": { "city" : "CALHOUN", "state" : "IL", "county" : "RICHLAND" },
            "62420": { "city" : "CASEY", "state" : "IL", "county" : "CLARK" },"62421": { "city" : "CLAREMONT", "state" : "IL", "county" : "RICHLAND" },
            "62422": { "city" : "COWDEN", "state" : "IL", "county" : "SHELBY" },"62423": { "city" : "DENNISON", "state" : "IL", "county" : "CLARK" },
            "62424": { "city" : "DIETERICH", "state" : "IL", "county" : "EFFINGHAM" },
            "62425": { "city" : "DUNDAS", "state" : "IL", "county" : "RICHLAND" },
            "62426": { "city" : "EDGEWOOD", "state" : "IL", "county" : "EFFINGHAM" },
            "62427": { "city" : "FLAT ROCK", "state" : "IL", "county" : "CRAWFORD" },
            "62428": { "city" : "GREENUP", "state" : "IL", "county" : "CUMBERLAND" },
            "62431": { "city" : "HERRICK", "state" : "IL", "county" : "SHELBY" },
            "62432": { "city" : "HIDALGO", "state" : "IL", "county" : "JASPER" },
            "62433": { "city" : "HUTSONVILLE", "state" : "IL", "county" : "CRAWFORD" },
            "62434": { "city" : "INGRAHAM", "state" : "IL", "county" : "CLAY" },"62436": { "city" : "JEWETT", "state" : "IL", "county" : "CUMBERLAND" },
            "62438": { "city" : "LAKEWOOD", "state" : "IL", "county" : "SHELBY" },
            "62439": { "city" : "LAWRENCEVILLE", "state" : "IL", "county" : "LAWRENCE" },
            "62440": { "city" : "LERNA", "state" : "IL", "county" : "COLES" },"62441": { "city" : "MARSHALL", "state" : "IL", "county" : "CLARK" },
            "62442": { "city" : "MARTINSVILLE", "state" : "IL", "county" : "CLARK" },
            "62443": { "city" : "MASON", "state" : "IL", "county" : "EFFINGHAM" },
            "62444": { "city" : "MODE", "state" : "IL", "county" : "SHELBY" },"62445": { "city" : "MONTROSE", "state" : "IL", "county" : "EFFINGHAM" },
            "62446": { "city" : "MOUNT ERIE", "state" : "IL", "county" : "WAYNE" },
            "62447": { "city" : "NEOGA", "state" : "IL", "county" : "CUMBERLAND" },
            "62448": { "city" : "NEWTON", "state" : "IL", "county" : "JASPER" },"62449": { "city" : "OBLONG", "state" : "IL", "county" : "CRAWFORD" },
            "62450": { "city" : "OLNEY", "state" : "IL", "county" : "RICHLAND" },
            "62451": { "city" : "PALESTINE", "state" : "IL", "county" : "CRAWFORD" },
            "62452": { "city" : "PARKERSBURG", "state" : "IL", "county" : "RICHLAND" },
            "62454": { "city" : "ROBINSON", "state" : "IL", "county" : "CRAWFORD" },
            "62458": { "city" : "SAINT ELMO", "state" : "IL", "county" : "FAYETTE" },
            "62459": { "city" : "SAINTE MARIE", "state" : "IL", "county" : "JASPER" },
            "62460": { "city" : "SAINT FRANCISVILLE", "state" : "IL", "county" : "LAWRENCE" },
            "62461": { "city" : "SHUMWAY", "state" : "IL", "county" : "EFFINGHAM" },
            "62462": { "city" : "SIGEL", "state" : "IL", "county" : "SHELBY" },"62463": { "city" : "STEWARDSON", "state" : "IL", "county" : "SHELBY" },
            "62464": { "city" : "STOY", "state" : "IL", "county" : "CRAWFORD" },"62465": { "city" : "STRASBURG", "state" : "IL", "county" : "SHELBY" },
            "62466": { "city" : "SUMNER", "state" : "IL", "county" : "LAWRENCE" },
            "62467": { "city" : "TEUTOPOLIS", "state" : "IL", "county" : "EFFINGHAM" },
            "62468": { "city" : "TOLEDO", "state" : "IL", "county" : "CUMBERLAND" },
            "62469": { "city" : "TRILLA", "state" : "IL", "county" : "COLES" },"62471": { "city" : "VANDALIA", "state" : "IL", "county" : "FAYETTE" },
            "62473": { "city" : "WATSON", "state" : "IL", "county" : "EFFINGHAM" },
            "62474": { "city" : "WESTFIELD", "state" : "IL", "county" : "CLARK" },
            "62475": { "city" : "WEST LIBERTY", "state" : "IL", "county" : "JASPER" },
            "62476": { "city" : "WEST SALEM", "state" : "IL", "county" : "EDWARDS" },
            "62477": { "city" : "WEST UNION", "state" : "IL", "county" : "CLARK" },
            "62478": { "city" : "WEST YORK", "state" : "IL", "county" : "CRAWFORD" },
            "62479": { "city" : "WHEELER", "state" : "IL", "county" : "JASPER" },
            "62480": { "city" : "WILLOW HILL", "state" : "IL", "county" : "JASPER" },
            "62481": { "city" : "YALE", "state" : "IL", "county" : "JASPER" },"62501": { "city" : "ARGENTA", "state" : "IL", "county" : "MACON" },
            "62510": { "city" : "ASSUMPTION", "state" : "IL", "county" : "CHRISTIAN" },
            "62512": { "city" : "BEASON", "state" : "IL", "county" : "LOGAN" },"62513": { "city" : "BLUE MOUND", "state" : "IL", "county" : "MACON" },
            "62514": { "city" : "BOODY", "state" : "IL", "county" : "MACON" },"62515": { "city" : "BUFFALO", "state" : "IL", "county" : "SANGAMON" },
            "62517": { "city" : "BULPITT", "state" : "IL", "county" : "CHRISTIAN" },
            "62518": { "city" : "CHESTNUT", "state" : "IL", "county" : "LOGAN" },
            "62519": { "city" : "CORNLAND", "state" : "IL", "county" : "LOGAN" },
            "62520": { "city" : "DAWSON", "state" : "IL", "county" : "SANGAMON" },
            "62521": { "city" : "DECATUR", "state" : "IL", "county" : "MACON" },"62522": { "city" : "DECATUR", "state" : "IL", "county" : "MACON" },
            "62523": { "city" : "DECATUR", "state" : "IL", "county" : "MACON" },"62524": { "city" : "DECATUR", "state" : "IL", "county" : "MACON" },
            "62525": { "city" : "DECATUR", "state" : "IL", "county" : "MACON" },"62526": { "city" : "DECATUR", "state" : "IL", "county" : "MACON" },
            "62530": { "city" : "DIVERNON", "state" : "IL", "county" : "SANGAMON" },
            "62531": { "city" : "EDINBURG", "state" : "IL", "county" : "CHRISTIAN" },
            "62532": { "city" : "ELWIN", "state" : "IL", "county" : "MACON" },"62533": { "city" : "FARMERSVILLE", "state" : "IL", "county" : "MONTGOMERY" },
            "62534": { "city" : "FINDLAY", "state" : "IL", "county" : "SHELBY" },
            "62535": { "city" : "FORSYTH", "state" : "IL", "county" : "MACON" },"62536": { "city" : "GLENARM", "state" : "IL", "county" : "SANGAMON" },
            "62537": { "city" : "HARRISTOWN", "state" : "IL", "county" : "MACON" },
            "62538": { "city" : "HARVEL", "state" : "IL", "county" : "MONTGOMERY" },
            "62539": { "city" : "ILLIOPOLIS", "state" : "IL", "county" : "SANGAMON" },
            "62540": { "city" : "KINCAID", "state" : "IL", "county" : "CHRISTIAN" },
            "62541": { "city" : "LAKE FORK", "state" : "IL", "county" : "LOGAN" },
            "62543": { "city" : "LATHAM", "state" : "IL", "county" : "LOGAN" },"62544": { "city" : "MACON", "state" : "IL", "county" : "MACON" },
            "62545": { "city" : "MECHANICSBURG", "state" : "IL", "county" : "SANGAMON" },
            "62546": { "city" : "MORRISONVILLE", "state" : "IL", "county" : "CHRISTIAN" },
            "62547": { "city" : "MOUNT AUBURN", "state" : "IL", "county" : "CHRISTIAN" },
            "62548": { "city" : "MOUNT PULASKI", "state" : "IL", "county" : "LOGAN" },
            "62549": { "city" : "MT ZION", "state" : "IL", "county" : "MACON" },"62550": { "city" : "MOWEAQUA", "state" : "IL", "county" : "CHRISTIAN" },
            "62551": { "city" : "NIANTIC", "state" : "IL", "county" : "MACON" },"62553": { "city" : "OCONEE", "state" : "IL", "county" : "SHELBY" },
            "62554": { "city" : "OREANA", "state" : "IL", "county" : "MACON" },"62555": { "city" : "OWANECO", "state" : "IL", "county" : "CHRISTIAN" },
            "62556": { "city" : "PALMER", "state" : "IL", "county" : "CHRISTIAN" },
            "62557": { "city" : "PANA", "state" : "IL", "county" : "CHRISTIAN" },
            "62558": { "city" : "PAWNEE", "state" : "IL", "county" : "SANGAMON" },
            "62560": { "city" : "RAYMOND", "state" : "IL", "county" : "MONTGOMERY" },
            "62561": { "city" : "RIVERTON", "state" : "IL", "county" : "SANGAMON" },
            "62563": { "city" : "ROCHESTER", "state" : "IL", "county" : "SANGAMON" },
            "62565": { "city" : "SHELBYVILLE", "state" : "IL", "county" : "SHELBY" },
            "62567": { "city" : "STONINGTON", "state" : "IL", "county" : "CHRISTIAN" },
            "62568": { "city" : "TAYLORVILLE", "state" : "IL", "county" : "CHRISTIAN" },
            "62570": { "city" : "TOVEY", "state" : "IL", "county" : "CHRISTIAN" },
            "62571": { "city" : "TOWER HILL", "state" : "IL", "county" : "SHELBY" },
            "62572": { "city" : "WAGGONER", "state" : "IL", "county" : "MONTGOMERY" },
            "62573": { "city" : "WARRENSBURG", "state" : "IL", "county" : "MACON" },
            "62601": { "city" : "ALEXANDER", "state" : "IL", "county" : "MORGAN" },
            "62610": { "city" : "ALSEY", "state" : "IL", "county" : "SCOTT" },"62611": { "city" : "ARENZVILLE", "state" : "IL", "county" : "CASS" },
            "62612": { "city" : "ASHLAND", "state" : "IL", "county" : "CASS" },"62613": { "city" : "ATHENS", "state" : "IL", "county" : "MENARD" },
            "62615": { "city" : "AUBURN", "state" : "IL", "county" : "SANGAMON" },
            "62617": { "city" : "BATH", "state" : "IL", "county" : "MASON" },"62618": { "city" : "BEARDSTOWN", "state" : "IL", "county" : "CASS" },
            "62621": { "city" : "BLUFFS", "state" : "IL", "county" : "SCOTT" },"62622": { "city" : "BLUFF SPRINGS", "state" : "IL", "county" : "CASS" },
            "62624": { "city" : "BROWNING", "state" : "IL", "county" : "SCHUYLER" },
            "62625": { "city" : "CANTRALL", "state" : "IL", "county" : "SANGAMON" },
            "62626": { "city" : "CARLINVILLE", "state" : "IL", "county" : "MACOUPIN" },
            "62627": { "city" : "CHANDLERVILLE", "state" : "IL", "county" : "CASS" },
            "62628": { "city" : "CHAPIN", "state" : "IL", "county" : "MORGAN" },"62629": { "city" : "CHATHAM", "state" : "IL", "county" : "SANGAMON" },
            "62630": { "city" : "CHESTERFIELD", "state" : "IL", "county" : "MACOUPIN" },
            "62631": { "city" : "CONCORD", "state" : "IL", "county" : "MORGAN" },
            "62633": { "city" : "EASTON", "state" : "IL", "county" : "MASON" },"62634": { "city" : "ELKHART", "state" : "IL", "county" : "LOGAN" },
            "62635": { "city" : "EMDEN", "state" : "IL", "county" : "LOGAN" },"62638": { "city" : "FRANKLIN", "state" : "IL", "county" : "MORGAN" },
            "62639": { "city" : "FREDERICK", "state" : "IL", "county" : "SCHUYLER" },
            "62640": { "city" : "GIRARD", "state" : "IL", "county" : "MACOUPIN" },
            "62642": { "city" : "GREENVIEW", "state" : "IL", "county" : "MENARD" },
            "62643": { "city" : "HARTSBURG", "state" : "IL", "county" : "LOGAN" },
            "62644": { "city" : "HAVANA", "state" : "IL", "county" : "MASON" },"62649": { "city" : "HETTICK", "state" : "IL", "county" : "MACOUPIN" },
            "62650": { "city" : "JACKSONVILLE", "state" : "IL", "county" : "MORGAN" },
            "62651": { "city" : "JACKSONVILLE", "state" : "IL", "county" : "MORGAN" },
            "62655": { "city" : "KILBOURNE", "state" : "IL", "county" : "MASON" },
            "62656": { "city" : "LINCOLN", "state" : "IL", "county" : "LOGAN" },"62660": { "city" : "LITERBERRY", "state" : "IL", "county" : "MORGAN" },
            "62661": { "city" : "LOAMI", "state" : "IL", "county" : "SANGAMON" },
            "62662": { "city" : "LOWDER", "state" : "IL", "county" : "SANGAMON" },
            "62663": { "city" : "MANCHESTER", "state" : "IL", "county" : "SCOTT" },
            "62664": { "city" : "MASON CITY", "state" : "IL", "county" : "MASON" },
            "62665": { "city" : "MEREDOSIA", "state" : "IL", "county" : "MORGAN" },
            "62666": { "city" : "MIDDLETOWN", "state" : "IL", "county" : "LOGAN" },
            "62667": { "city" : "MODESTO", "state" : "IL", "county" : "MACOUPIN" },
            "62668": { "city" : "MURRAYVILLE", "state" : "IL", "county" : "MORGAN" },
            "62670": { "city" : "NEW BERLIN", "state" : "IL", "county" : "SANGAMON" },
            "62671": { "city" : "NEW HOLLAND", "state" : "IL", "county" : "LOGAN" },
            "62672": { "city" : "NILWOOD", "state" : "IL", "county" : "MACOUPIN" },
            "62673": { "city" : "OAKFORD", "state" : "IL", "county" : "MENARD" },
            "62674": { "city" : "PALMYRA", "state" : "IL", "county" : "MACOUPIN" },
            "62675": { "city" : "PETERSBURG", "state" : "IL", "county" : "MENARD" },
            "62677": { "city" : "PLEASANT PLAINS", "state" : "IL", "county" : "SANGAMON" },
            "62681": { "city" : "RUSHVILLE", "state" : "IL", "county" : "SCHUYLER" },
            "62682": { "city" : "SAN JOSE", "state" : "IL", "county" : "MASON" },
            "62683": { "city" : "SCOTTVILLE", "state" : "IL", "county" : "MACOUPIN" },
            "62684": { "city" : "SHERMAN", "state" : "IL", "county" : "SANGAMON" },
            "62685": { "city" : "SHIPMAN", "state" : "IL", "county" : "MACOUPIN" },
            "62688": { "city" : "TALLULA", "state" : "IL", "county" : "MENARD" },
            "62689": { "city" : "THAYER", "state" : "IL", "county" : "SANGAMON" },
            "62690": { "city" : "VIRDEN", "state" : "IL", "county" : "MACOUPIN" },
            "62691": { "city" : "VIRGINIA", "state" : "IL", "county" : "CASS" },"62692": { "city" : "WAVERLY", "state" : "IL", "county" : "MORGAN" },
            "62693": { "city" : "WILLIAMSVILLE", "state" : "IL", "county" : "SANGAMON" },
            "62694": { "city" : "WINCHESTER", "state" : "IL", "county" : "SCOTT" },
            "62695": { "city" : "WOODSON", "state" : "IL", "county" : "MORGAN" },
            "62701": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62702": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62703": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62704": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62705": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62706": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62707": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62708": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62711": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62712": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62715": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62721": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62739": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62756": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62764": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62769": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62781": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62791": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62794": { "city" : "SPRINGFIELD", "state" : "IL", "county" : "SANGAMON" },
            "62801": { "city" : "CENTRALIA", "state" : "IL", "county" : "MARION" },
            "62803": { "city" : "HOYLETON", "state" : "IL", "county" : "WASHINGTON" },
            "62805": { "city" : "AKIN", "state" : "IL", "county" : "FRANKLIN" },"62806": { "city" : "ALBION", "state" : "IL", "county" : "EDWARDS" },
            "62807": { "city" : "ALMA", "state" : "IL", "county" : "MARION" },"62808": { "city" : "ASHLEY", "state" : "IL", "county" : "WASHINGTON" },
            "62809": { "city" : "BARNHILL", "state" : "IL", "county" : "WAYNE" },
            "62810": { "city" : "BELLE RIVE", "state" : "IL", "county" : "JEFFERSON" },
            "62811": { "city" : "BELLMONT", "state" : "IL", "county" : "WABASH" },
            "62812": { "city" : "BENTON", "state" : "IL", "county" : "FRANKLIN" },
            "62814": { "city" : "BLUFORD", "state" : "IL", "county" : "JEFFERSON" },
            "62815": { "city" : "BONE GAP", "state" : "IL", "county" : "EDWARDS" },
            "62816": { "city" : "BONNIE", "state" : "IL", "county" : "JEFFERSON" },
            "62817": { "city" : "BROUGHTON", "state" : "IL", "county" : "HAMILTON" },
            "62818": { "city" : "BROWNS", "state" : "IL", "county" : "EDWARDS" },
            "62819": { "city" : "BUCKNER", "state" : "IL", "county" : "FRANKLIN" },
            "62820": { "city" : "BURNT PRAIRIE", "state" : "IL", "county" : "WHITE" },
            "62821": { "city" : "CARMI", "state" : "IL", "county" : "WHITE" },"62822": { "city" : "CHRISTOPHER", "state" : "IL", "county" : "FRANKLIN" },
            "62823": { "city" : "CISNE", "state" : "IL", "county" : "WAYNE" },"62824": { "city" : "CLAY CITY", "state" : "IL", "county" : "CLAY" },
            "62825": { "city" : "COELLO", "state" : "IL", "county" : "FRANKLIN" },
            "62827": { "city" : "CROSSVILLE", "state" : "IL", "county" : "WHITE" },
            "62828": { "city" : "DAHLGREN", "state" : "IL", "county" : "HAMILTON" },
            "62829": { "city" : "DALE", "state" : "IL", "county" : "HAMILTON" },"62830": { "city" : "DIX", "state" : "IL", "county" : "JEFFERSON" },
            "62831": { "city" : "DU BOIS", "state" : "IL", "county" : "WASHINGTON" },
            "62832": { "city" : "DU QUOIN", "state" : "IL", "county" : "PERRY" },
            "62833": { "city" : "ELLERY", "state" : "IL", "county" : "EDWARDS" },
            "62835": { "city" : "ENFIELD", "state" : "IL", "county" : "WHITE" },"62836": { "city" : "EWING", "state" : "IL", "county" : "FRANKLIN" },
            "62837": { "city" : "FAIRFIELD", "state" : "IL", "county" : "WAYNE" },
            "62838": { "city" : "FARINA", "state" : "IL", "county" : "FAYETTE" },
            "62839": { "city" : "FLORA", "state" : "IL", "county" : "CLAY" },"62842": { "city" : "GEFF", "state" : "IL", "county" : "WAYNE" },
            "62843": { "city" : "GOLDEN GATE", "state" : "IL", "county" : "WAYNE" },
            "62844": { "city" : "GRAYVILLE", "state" : "IL", "county" : "WHITE" },
            "62846": { "city" : "INA", "state" : "IL", "county" : "JEFFERSON" },"62848": { "city" : "IRVINGTON", "state" : "IL", "county" : "WASHINGTON" },
            "62849": { "city" : "IUKA", "state" : "IL", "county" : "MARION" },"62850": { "city" : "JOHNSONVILLE", "state" : "IL", "county" : "WAYNE" },
            "62851": { "city" : "KEENES", "state" : "IL", "county" : "WAYNE" },"62852": { "city" : "KEENSBURG", "state" : "IL", "county" : "WABASH" },
            "62853": { "city" : "KELL", "state" : "IL", "county" : "MARION" },"62854": { "city" : "KINMUNDY", "state" : "IL", "county" : "MARION" },
            "62856": { "city" : "LOGAN", "state" : "IL", "county" : "FRANKLIN" },
            "62858": { "city" : "LOUISVILLE", "state" : "IL", "county" : "CLAY" },
            "62859": { "city" : "MC LEANSBORO", "state" : "IL", "county" : "HAMILTON" },
            "62860": { "city" : "MACEDONIA", "state" : "IL", "county" : "HAMILTON" },
            "62861": { "city" : "MAUNIE", "state" : "IL", "county" : "WHITE" },"62862": { "city" : "MILL SHOALS", "state" : "IL", "county" : "WHITE" },
            "62863": { "city" : "MOUNT CARMEL", "state" : "IL", "county" : "WABASH" },
            "62864": { "city" : "MOUNT VERNON", "state" : "IL", "county" : "JEFFERSON" },
            "62865": { "city" : "MULKEYTOWN", "state" : "IL", "county" : "FRANKLIN" },
            "62866": { "city" : "NASON", "state" : "IL", "county" : "JEFFERSON" },
            "62867": { "city" : "NEW HAVEN", "state" : "IL", "county" : "GALLATIN" },
            "62868": { "city" : "NOBLE", "state" : "IL", "county" : "RICHLAND" },
            "62869": { "city" : "NORRIS CITY", "state" : "IL", "county" : "WHITE" },
            "62870": { "city" : "ODIN", "state" : "IL", "county" : "MARION" },"62871": { "city" : "OMAHA", "state" : "IL", "county" : "GALLATIN" },
            "62872": { "city" : "OPDYKE", "state" : "IL", "county" : "JEFFERSON" },
            "62874": { "city" : "ORIENT", "state" : "IL", "county" : "FRANKLIN" },
            "62875": { "city" : "PATOKA", "state" : "IL", "county" : "MARION" },"62876": { "city" : "RADOM", "state" : "IL", "county" : "WASHINGTON" },
            "62877": { "city" : "RICHVIEW", "state" : "IL", "county" : "WASHINGTON" },
            "62878": { "city" : "RINARD", "state" : "IL", "county" : "WAYNE" },"62879": { "city" : "SAILOR SPRINGS", "state" : "IL", "county" : "CLAY" },
            "62880": { "city" : "SAINT PETER", "state" : "IL", "county" : "FAYETTE" },
            "62881": { "city" : "SALEM", "state" : "IL", "county" : "MARION" },"62882": { "city" : "SANDOVAL", "state" : "IL", "county" : "MARION" },
            "62883": { "city" : "SCHELLER", "state" : "IL", "county" : "JEFFERSON" },
            "62884": { "city" : "SESSER", "state" : "IL", "county" : "FRANKLIN" },
            "62885": { "city" : "SHOBONIER", "state" : "IL", "county" : "FAYETTE" },
            "62886": { "city" : "SIMS", "state" : "IL", "county" : "WAYNE" },"62887": { "city" : "SPRINGERTON", "state" : "IL", "county" : "WHITE" },
            "62888": { "city" : "TAMAROA", "state" : "IL", "county" : "PERRY" },"62889": { "city" : "TEXICO", "state" : "IL", "county" : "JEFFERSON" },
            "62890": { "city" : "THOMPSONVILLE", "state" : "IL", "county" : "FRANKLIN" },
            "62891": { "city" : "VALIER", "state" : "IL", "county" : "FRANKLIN" },
            "62892": { "city" : "VERNON", "state" : "IL", "county" : "MARION" },"62893": { "city" : "WALNUT HILL", "state" : "IL", "county" : "MARION" },
            "62894": { "city" : "WALTONVILLE", "state" : "IL", "county" : "JEFFERSON" },
            "62895": { "city" : "WAYNE CITY", "state" : "IL", "county" : "WAYNE" },
            "62896": { "city" : "WEST FRANKFORT", "state" : "IL", "county" : "FRANKLIN" },
            "62897": { "city" : "WHITTINGTON", "state" : "IL", "county" : "FRANKLIN" },
            "62898": { "city" : "WOODLAWN", "state" : "IL", "county" : "JEFFERSON" },
            "62899": { "city" : "XENIA", "state" : "IL", "county" : "CLAY" },"62901": { "city" : "CARBONDALE", "state" : "IL", "county" : "JACKSON" },
            "62902": { "city" : "CARBONDALE", "state" : "IL", "county" : "JACKSON" },
            "62903": { "city" : "CARBONDALE", "state" : "IL", "county" : "JACKSON" },
            "62905": { "city" : "ALTO PASS", "state" : "IL", "county" : "UNION" },
            "62906": { "city" : "ANNA", "state" : "IL", "county" : "UNION" },"62907": { "city" : "AVA", "state" : "IL", "county" : "JACKSON" },
            "62908": { "city" : "BELKNAP", "state" : "IL", "county" : "JOHNSON" },
            "62909": { "city" : "BOLES", "state" : "IL", "county" : "JOHNSON" },"62910": { "city" : "BROOKPORT", "state" : "IL", "county" : "MASSAC" },
            "62912": { "city" : "BUNCOMBE", "state" : "IL", "county" : "JOHNSON" },
            "62914": { "city" : "CAIRO", "state" : "IL", "county" : "ALEXANDER" },
            "62915": { "city" : "CAMBRIA", "state" : "IL", "county" : "WILLIAMSON" },
            "62916": { "city" : "CAMPBELL HILL", "state" : "IL", "county" : "JACKSON" },
            "62917": { "city" : "CARRIER MILLS", "state" : "IL", "county" : "SALINE" },
            "62918": { "city" : "CARTERVILLE", "state" : "IL", "county" : "WILLIAMSON" },
            "62919": { "city" : "CAVE IN ROCK", "state" : "IL", "county" : "HARDIN" },
            "62920": { "city" : "COBDEN", "state" : "IL", "county" : "UNION" },"62922": { "city" : "CREAL SPRINGS", "state" : "IL", "county" : "WILLIAMSON" },
            "62923": { "city" : "CYPRESS", "state" : "IL", "county" : "JOHNSON" },
            "62924": { "city" : "DE SOTO", "state" : "IL", "county" : "JACKSON" },
            "62926": { "city" : "DONGOLA", "state" : "IL", "county" : "UNION" },"62927": { "city" : "DOWELL", "state" : "IL", "county" : "JACKSON" },
            "62928": { "city" : "EDDYVILLE", "state" : "IL", "county" : "POPE" },
            "62930": { "city" : "ELDORADO", "state" : "IL", "county" : "SALINE" },
            "62931": { "city" : "ELIZABETHTOWN", "state" : "IL", "county" : "HARDIN" },
            "62932": { "city" : "ELKVILLE", "state" : "IL", "county" : "JACKSON" },
            "62933": { "city" : "ENERGY", "state" : "IL", "county" : "WILLIAMSON" },
            "62934": { "city" : "EQUALITY", "state" : "IL", "county" : "GALLATIN" },
            "62935": { "city" : "GALATIA", "state" : "IL", "county" : "SALINE" },
            "62938": { "city" : "GOLCONDA", "state" : "IL", "county" : "POPE" },"62939": { "city" : "GOREVILLE", "state" : "IL", "county" : "JOHNSON" },
            "62940": { "city" : "GORHAM", "state" : "IL", "county" : "JACKSON" },
            "62941": { "city" : "GRAND CHAIN", "state" : "IL", "county" : "PULASKI" },
            "62942": { "city" : "GRAND TOWER", "state" : "IL", "county" : "JACKSON" },
            "62943": { "city" : "GRANTSBURG", "state" : "IL", "county" : "JOHNSON" },
            "62946": { "city" : "HARRISBURG", "state" : "IL", "county" : "SALINE" },
            "62947": { "city" : "HEROD", "state" : "IL", "county" : "POPE" },"62948": { "city" : "HERRIN", "state" : "IL", "county" : "WILLIAMSON" },
            "62949": { "city" : "HURST", "state" : "IL", "county" : "WILLIAMSON" },
            "62950": { "city" : "JACOB", "state" : "IL", "county" : "JACKSON" },"62951": { "city" : "JOHNSTON CITY", "state" : "IL", "county" : "WILLIAMSON" },
            "62952": { "city" : "JONESBORO", "state" : "IL", "county" : "UNION" },
            "62953": { "city" : "JOPPA", "state" : "IL", "county" : "MASSAC" },"62954": { "city" : "JUNCTION", "state" : "IL", "county" : "GALLATIN" },
            "62955": { "city" : "KARBERS RIDGE", "state" : "IL", "county" : "HARDIN" },
            "62956": { "city" : "KARNAK", "state" : "IL", "county" : "PULASKI" },
            "62957": { "city" : "MC CLURE", "state" : "IL", "county" : "ALEXANDER" },
            "62958": { "city" : "MAKANDA", "state" : "IL", "county" : "JACKSON" },
            "62959": { "city" : "MARION", "state" : "IL", "county" : "WILLIAMSON" },
            "62960": { "city" : "METROPOLIS", "state" : "IL", "county" : "MASSAC" },
            "62962": { "city" : "MILLER CITY", "state" : "IL", "county" : "ALEXANDER" },
            "62963": { "city" : "MOUND CITY", "state" : "IL", "county" : "PULASKI" },
            "62964": { "city" : "MOUNDS", "state" : "IL", "county" : "PULASKI" },
            "62965": { "city" : "MUDDY", "state" : "IL", "county" : "SALINE" },"62966": { "city" : "MURPHYSBORO", "state" : "IL", "county" : "JACKSON" },
            "62967": { "city" : "NEW BURNSIDE", "state" : "IL", "county" : "JOHNSON" },
            "62969": { "city" : "OLIVE BRANCH", "state" : "IL", "county" : "ALEXANDER" },
            "62970": { "city" : "OLMSTED", "state" : "IL", "county" : "PULASKI" },
            "62972": { "city" : "OZARK", "state" : "IL", "county" : "JOHNSON" },"62973": { "city" : "PERKS", "state" : "IL", "county" : "PULASKI" },
            "62974": { "city" : "PITTSBURG", "state" : "IL", "county" : "WILLIAMSON" },
            "62975": { "city" : "POMONA", "state" : "IL", "county" : "JACKSON" },
            "62976": { "city" : "PULASKI", "state" : "IL", "county" : "PULASKI" },
            "62977": { "city" : "RALEIGH", "state" : "IL", "county" : "SALINE" },
            "62979": { "city" : "RIDGWAY", "state" : "IL", "county" : "GALLATIN" },
            "62982": { "city" : "ROSICLARE", "state" : "IL", "county" : "HARDIN" },
            "62983": { "city" : "ROYALTON", "state" : "IL", "county" : "FRANKLIN" },
            "62984": { "city" : "SHAWNEETOWN", "state" : "IL", "county" : "GALLATIN" },
            "62985": { "city" : "SIMPSON", "state" : "IL", "county" : "JOHNSON" },
            "62987": { "city" : "STONEFORT", "state" : "IL", "county" : "SALINE" },
            "62988": { "city" : "TAMMS", "state" : "IL", "county" : "ALEXANDER" },
            "62990": { "city" : "THEBES", "state" : "IL", "county" : "ALEXANDER" },
            "62992": { "city" : "ULLIN", "state" : "IL", "county" : "PULASKI" },"62994": { "city" : "VERGENNES", "state" : "IL", "county" : "JACKSON" },
            "62995": { "city" : "VIENNA", "state" : "IL", "county" : "JOHNSON" },
            "62996": { "city" : "VILLA RIDGE", "state" : "IL", "county" : "PULASKI" },
            "62997": { "city" : "WILLISVILLE", "state" : "IL", "county" : "PERRY" },
            "62998": { "city" : "WOLF LAKE", "state" : "IL", "county" : "UNION" },
            "62999": { "city" : "ZEIGLER", "state" : "IL", "county" : "FRANKLIN" },
            "63001": { "city" : "ALLENTON", "state" : "MO", "county" : "SAINT LOUIS" },
            "63005": { "city" : "CHESTERFIELD", "state" : "MO", "county" : "SAINT LOUIS" },
            "63006": { "city" : "CHESTERFIELD", "state" : "MO", "county" : "SAINT LOUIS" },
            "63010": { "city" : "ARNOLD", "state" : "MO", "county" : "JEFFERSON" },
            "63011": { "city" : "BALLWIN", "state" : "MO", "county" : "SAINT LOUIS" },
            "63012": { "city" : "BARNHART", "state" : "MO", "county" : "JEFFERSON" },
            "63013": { "city" : "BEAUFORT", "state" : "MO", "county" : "FRANKLIN" },
            "63014": { "city" : "BERGER", "state" : "MO", "county" : "FRANKLIN" },
            "63015": { "city" : "CATAWISSA", "state" : "MO", "county" : "FRANKLIN" },
            "63016": { "city" : "CEDAR HILL", "state" : "MO", "county" : "JEFFERSON" },
            "63017": { "city" : "CHESTERFIELD", "state" : "MO", "county" : "SAINT LOUIS" },
            "63019": { "city" : "CRYSTAL CITY", "state" : "MO", "county" : "JEFFERSON" },
            "63020": { "city" : "DE SOTO", "state" : "MO", "county" : "JEFFERSON" },
            "63021": { "city" : "BALLWIN", "state" : "MO", "county" : "SAINT LOUIS" },
            "63022": { "city" : "BALLWIN", "state" : "MO", "county" : "SAINT LOUIS" },
            "63023": { "city" : "DITTMER", "state" : "MO", "county" : "JEFFERSON" },
            "63024": { "city" : "BALLWIN", "state" : "MO", "county" : "SAINT LOUIS" },
            "63025": { "city" : "EUREKA", "state" : "MO", "county" : "SAINT LOUIS" },
            "63026": { "city" : "FENTON", "state" : "MO", "county" : "SAINT LOUIS" },
            "63028": { "city" : "FESTUS", "state" : "MO", "county" : "JEFFERSON" },
            "63030": { "city" : "FLETCHER", "state" : "MO", "county" : "JEFFERSON" },
            "63031": { "city" : "FLORISSANT", "state" : "MO", "county" : "SAINT LOUIS" },
            "63032": { "city" : "FLORISSANT", "state" : "MO", "county" : "SAINT LOUIS" },
            "63033": { "city" : "FLORISSANT", "state" : "MO", "county" : "SAINT LOUIS" },
            "63034": { "city" : "FLORISSANT", "state" : "MO", "county" : "SAINT LOUIS" },
            "63036": { "city" : "FRENCH VILLAGE", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63037": { "city" : "GERALD", "state" : "MO", "county" : "FRANKLIN" },
            "63038": { "city" : "GLENCOE", "state" : "MO", "county" : "SAINT LOUIS" },
            "63039": { "city" : "GRAY SUMMIT", "state" : "MO", "county" : "FRANKLIN" },
            "63040": { "city" : "GROVER", "state" : "MO", "county" : "SAINT LOUIS" },
            "63041": { "city" : "GRUBVILLE", "state" : "MO", "county" : "FRANKLIN" },
            "63042": { "city" : "HAZELWOOD", "state" : "MO", "county" : "SAINT LOUIS" },
            "63043": { "city" : "MARYLAND HEIGHTS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63044": { "city" : "BRIDGETON", "state" : "MO", "county" : "SAINT LOUIS" },
            "63045": { "city" : "EARTH CITY", "state" : "MO", "county" : "SAINT LOUIS" },
            "63047": { "city" : "HEMATITE", "state" : "MO", "county" : "JEFFERSON" },
            "63048": { "city" : "HERCULANEUM", "state" : "MO", "county" : "JEFFERSON" },
            "63049": { "city" : "HIGH RIDGE", "state" : "MO", "county" : "JEFFERSON" },
            "63050": { "city" : "HILLSBORO", "state" : "MO", "county" : "JEFFERSON" },
            "63051": { "city" : "HOUSE SPRINGS", "state" : "MO", "county" : "JEFFERSON" },
            "63052": { "city" : "IMPERIAL", "state" : "MO", "county" : "JEFFERSON" },
            "63053": { "city" : "KIMMSWICK", "state" : "MO", "county" : "JEFFERSON" },
            "63055": { "city" : "LABADIE", "state" : "MO", "county" : "FRANKLIN" },
            "63056": { "city" : "LESLIE", "state" : "MO", "county" : "FRANKLIN" },
            "63057": { "city" : "LIGUORI", "state" : "MO", "county" : "JEFFERSON" },
            "63060": { "city" : "LONEDELL", "state" : "MO", "county" : "FRANKLIN" },
            "63061": { "city" : "LUEBBERING", "state" : "MO", "county" : "FRANKLIN" },
            "63065": { "city" : "MAPAVILLE", "state" : "MO", "county" : "JEFFERSON" },
            "63066": { "city" : "MORSE MILL", "state" : "MO", "county" : "JEFFERSON" },
            "63068": { "city" : "NEW HAVEN", "state" : "MO", "county" : "FRANKLIN" },
            "63069": { "city" : "PACIFIC", "state" : "MO", "county" : "FRANKLIN" },
            "63070": { "city" : "PEVELY", "state" : "MO", "county" : "JEFFERSON" },
            "63071": { "city" : "RICHWOODS", "state" : "MO", "county" : "WASHINGTON" },
            "63072": { "city" : "ROBERTSVILLE", "state" : "MO", "county" : "FRANKLIN" },
            "63073": { "city" : "SAINT ALBANS", "state" : "MO", "county" : "FRANKLIN" },
            "63074": { "city" : "SAINT ANN", "state" : "MO", "county" : "SAINT LOUIS" },
            "63077": { "city" : "SAINT CLAIR", "state" : "MO", "county" : "FRANKLIN" },
            "63079": { "city" : "STANTON", "state" : "MO", "county" : "FRANKLIN" },
            "63080": { "city" : "SULLIVAN", "state" : "MO", "county" : "FRANKLIN" },
            "63084": { "city" : "UNION", "state" : "MO", "county" : "FRANKLIN" },
            "63087": { "city" : "VALLES MINES", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63088": { "city" : "VALLEY PARK", "state" : "MO", "county" : "SAINT LOUIS" },
            "63089": { "city" : "VILLA RIDGE", "state" : "MO", "county" : "FRANKLIN" },
            "63090": { "city" : "WASHINGTON", "state" : "MO", "county" : "FRANKLIN" },
            "63091": { "city" : "ROSEBUD", "state" : "MO", "county" : "GASCONADE" },
            "63099": { "city" : "FENTON", "state" : "MO", "county" : "SAINT LOUIS" },
            "63101": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63102": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63103": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63104": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63105": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63106": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63107": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63108": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63109": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63110": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63111": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63112": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63113": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63114": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63115": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63116": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63117": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63118": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63119": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63120": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63121": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63122": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63123": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63124": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63125": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63126": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63127": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63128": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63129": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63130": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63131": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63132": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63133": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63134": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63135": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63136": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63137": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63138": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63139": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63140": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63141": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63143": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63144": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63145": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63146": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63147": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63151": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63155": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63156": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63157": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63158": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63160": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63163": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63164": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63166": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63167": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63177": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63178": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63180": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63197": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63198": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS" },
            "63199": { "city" : "SAINT LOUIS", "state" : "MO", "county" : "SAINT LOUIS CITY" },
            "63301": { "city" : "SAINT CHARLES", "state" : "MO", "county" : "SAINT CHARLES" },
            "63302": { "city" : "SAINT CHARLES", "state" : "MO", "county" : "SAINT CHARLES" },
            "63303": { "city" : "SAINT CHARLES", "state" : "MO", "county" : "SAINT CHARLES" },
            "63304": { "city" : "SAINT CHARLES", "state" : "MO", "county" : "SAINT CHARLES" },
            "63330": { "city" : "ANNADA", "state" : "MO", "county" : "PIKE" },"63332": { "city" : "AUGUSTA", "state" : "MO", "county" : "SAINT CHARLES" },
            "63333": { "city" : "BELLFLOWER", "state" : "MO", "county" : "MONTGOMERY" },
            "63334": { "city" : "BOWLING GREEN", "state" : "MO", "county" : "PIKE" },
            "63336": { "city" : "CLARKSVILLE", "state" : "MO", "county" : "PIKE" },
            "63338": { "city" : "COTTLEVILLE", "state" : "MO", "county" : "SAINT CHARLES" },
            "63339": { "city" : "CURRYVILLE", "state" : "MO", "county" : "PIKE" },
            "63341": { "city" : "DEFIANCE", "state" : "MO", "county" : "SAINT CHARLES" },
            "63342": { "city" : "DUTZOW", "state" : "MO", "county" : "WARREN" },"63343": { "city" : "ELSBERRY", "state" : "MO", "county" : "LINCOLN" },
            "63344": { "city" : "EOLIA", "state" : "MO", "county" : "PIKE" },"63345": { "city" : "FARBER", "state" : "MO", "county" : "AUDRAIN" },
            "63346": { "city" : "FLINTHILL", "state" : "MO", "county" : "SAINT CHARLES" },
            "63347": { "city" : "FOLEY", "state" : "MO", "county" : "LINCOLN" },"63348": { "city" : "FORISTELL", "state" : "MO", "county" : "SAINT CHARLES" },
            "63349": { "city" : "HAWK POINT", "state" : "MO", "county" : "LINCOLN" },
            "63350": { "city" : "HIGH HILL", "state" : "MO", "county" : "MONTGOMERY" },
            "63351": { "city" : "JONESBURG", "state" : "MO", "county" : "MONTGOMERY" },
            "63352": { "city" : "LADDONIA", "state" : "MO", "county" : "AUDRAIN" },
            "63353": { "city" : "LOUISIANA", "state" : "MO", "county" : "PIKE" },
            "63357": { "city" : "MARTHASVILLE", "state" : "MO", "county" : "WARREN" },
            "63359": { "city" : "MIDDLETOWN", "state" : "MO", "county" : "MONTGOMERY" },
            "63361": { "city" : "MONTGOMERY CITY", "state" : "MO", "county" : "MONTGOMERY" },
            "63362": { "city" : "MOSCOW MILLS", "state" : "MO", "county" : "LINCOLN" },
            "63363": { "city" : "NEW FLORENCE", "state" : "MO", "county" : "MONTGOMERY" },
            "63365": { "city" : "NEW MELLE", "state" : "MO", "county" : "SAINT CHARLES" },
            "63366": { "city" : "O FALLON", "state" : "MO", "county" : "SAINT CHARLES" },
            "63367": { "city" : "LAKE SAINT LOUIS", "state" : "MO", "county" : "SAINT CHARLES" },
            "63368": { "city" : "O FALLON", "state" : "MO", "county" : "SAINT CHARLES" },
            "63369": { "city" : "OLD MONROE", "state" : "MO", "county" : "LINCOLN" },
            "63373": { "city" : "PORTAGE DES SIOUX", "state" : "MO", "county" : "SAINT CHARLES" },
            "63376": { "city" : "SAINT PETERS", "state" : "MO", "county" : "SAINT CHARLES" },
            "63377": { "city" : "SILEX", "state" : "MO", "county" : "LINCOLN" },"63379": { "city" : "TROY", "state" : "MO", "county" : "LINCOLN" },
            "63381": { "city" : "TRUXTON", "state" : "MO", "county" : "LINCOLN" },
            "63382": { "city" : "VANDALIA", "state" : "MO", "county" : "AUDRAIN" },
            "63383": { "city" : "WARRENTON", "state" : "MO", "county" : "WARREN" },
            "63384": { "city" : "WELLSVILLE", "state" : "MO", "county" : "MONTGOMERY" },
            "63385": { "city" : "WENTZVILLE", "state" : "MO", "county" : "SAINT CHARLES" },
            "63386": { "city" : "WEST ALTON", "state" : "MO", "county" : "SAINT CHARLES" },
            "63387": { "city" : "WHITESIDE", "state" : "MO", "county" : "LINCOLN" },
            "63388": { "city" : "WILLIAMSBURG", "state" : "MO", "county" : "CALLAWAY" },
            "63389": { "city" : "WINFIELD", "state" : "MO", "county" : "LINCOLN" },
            "63390": { "city" : "WRIGHT CITY", "state" : "MO", "county" : "WARREN" },
            "63401": { "city" : "HANNIBAL", "state" : "MO", "county" : "MARION" },
            "63430": { "city" : "ALEXANDRIA", "state" : "MO", "county" : "CLARK" },
            "63431": { "city" : "ANABEL", "state" : "MO", "county" : "MACON" },"63432": { "city" : "ARBELA", "state" : "MO", "county" : "SCOTLAND" },
            "63434": { "city" : "BETHEL", "state" : "MO", "county" : "SHELBY" },"63435": { "city" : "CANTON", "state" : "MO", "county" : "LEWIS" },
            "63436": { "city" : "CENTER", "state" : "MO", "county" : "RALLS" },"63437": { "city" : "CLARENCE", "state" : "MO", "county" : "SHELBY" },
            "63438": { "city" : "DURHAM", "state" : "MO", "county" : "LEWIS" },"63440": { "city" : "EWING", "state" : "MO", "county" : "LEWIS" },
            "63441": { "city" : "FRANKFORD", "state" : "MO", "county" : "PIKE" },
            "63442": { "city" : "GRANGER", "state" : "MO", "county" : "SCOTLAND" },
            "63443": { "city" : "HUNNEWELL", "state" : "MO", "county" : "SHELBY" },
            "63445": { "city" : "KAHOKA", "state" : "MO", "county" : "CLARK" },"63446": { "city" : "KNOX CITY", "state" : "MO", "county" : "KNOX" },
            "63447": { "city" : "LA BELLE", "state" : "MO", "county" : "LEWIS" },
            "63448": { "city" : "LA GRANGE", "state" : "MO", "county" : "LEWIS" },
            "63451": { "city" : "LEONARD", "state" : "MO", "county" : "SHELBY" },
            "63452": { "city" : "LEWISTOWN", "state" : "MO", "county" : "LEWIS" },
            "63453": { "city" : "LURAY", "state" : "MO", "county" : "CLARK" },"63454": { "city" : "MAYWOOD", "state" : "MO", "county" : "MARION" },
            "63456": { "city" : "MONROE CITY", "state" : "MO", "county" : "MONROE" },
            "63457": { "city" : "MONTICELLO", "state" : "MO", "county" : "LEWIS" },
            "63458": { "city" : "NEWARK", "state" : "MO", "county" : "KNOX" },"63459": { "city" : "NEW LONDON", "state" : "MO", "county" : "RALLS" },
            "63460": { "city" : "NOVELTY", "state" : "MO", "county" : "KNOX" },"63461": { "city" : "PALMYRA", "state" : "MO", "county" : "MARION" },
            "63462": { "city" : "PERRY", "state" : "MO", "county" : "RALLS" },"63463": { "city" : "PHILADELPHIA", "state" : "MO", "county" : "MARION" },
            "63464": { "city" : "PLEVNA", "state" : "MO", "county" : "KNOX" },"63465": { "city" : "REVERE", "state" : "MO", "county" : "CLARK" },
            "63467": { "city" : "SAVERTON", "state" : "MO", "county" : "RALLS" },
            "63468": { "city" : "SHELBINA", "state" : "MO", "county" : "SHELBY" },
            "63469": { "city" : "SHELBYVILLE", "state" : "MO", "county" : "SHELBY" },
            "63471": { "city" : "TAYLOR", "state" : "MO", "county" : "MARION" },"63472": { "city" : "WAYLAND", "state" : "MO", "county" : "CLARK" },
            "63473": { "city" : "WILLIAMSTOWN", "state" : "MO", "county" : "LEWIS" },
            "63474": { "city" : "WYACONDA", "state" : "MO", "county" : "CLARK" },
            "63501": { "city" : "KIRKSVILLE", "state" : "MO", "county" : "ADAIR" },
            "63530": { "city" : "ATLANTA", "state" : "MO", "county" : "MACON" },"63531": { "city" : "BARING", "state" : "MO", "county" : "KNOX" },
            "63532": { "city" : "BEVIER", "state" : "MO", "county" : "MACON" },"63533": { "city" : "BRASHEAR", "state" : "MO", "county" : "ADAIR" },
            "63534": { "city" : "CALLAO", "state" : "MO", "county" : "MACON" },"63535": { "city" : "COATSVILLE", "state" : "MO", "county" : "SCHUYLER" },
            "63536": { "city" : "DOWNING", "state" : "MO", "county" : "SCHUYLER" },
            "63537": { "city" : "EDINA", "state" : "MO", "county" : "KNOX" },"63538": { "city" : "ELMER", "state" : "MO", "county" : "MACON" },
            "63540": { "city" : "GIBBS", "state" : "MO", "county" : "ADAIR" },"63541": { "city" : "GLENWOOD", "state" : "MO", "county" : "SCHUYLER" },
            "63543": { "city" : "GORIN", "state" : "MO", "county" : "SCOTLAND" },
            "63544": { "city" : "GREEN CASTLE", "state" : "MO", "county" : "SULLIVAN" },
            "63545": { "city" : "GREEN CITY", "state" : "MO", "county" : "SULLIVAN" },
            "63546": { "city" : "GREENTOP", "state" : "MO", "county" : "ADAIR" },
            "63547": { "city" : "HURDLAND", "state" : "MO", "county" : "KNOX" },"63548": { "city" : "LANCASTER", "state" : "MO", "county" : "SCHUYLER" },
            "63549": { "city" : "LA PLATA", "state" : "MO", "county" : "MACON" },
            "63551": { "city" : "LIVONIA", "state" : "MO", "county" : "PUTNAM" },
            "63552": { "city" : "MACON", "state" : "MO", "county" : "MACON" },"63555": { "city" : "MEMPHIS", "state" : "MO", "county" : "SCOTLAND" },
            "63556": { "city" : "MILAN", "state" : "MO", "county" : "SULLIVAN" },
            "63557": { "city" : "NEW BOSTON", "state" : "MO", "county" : "LINN" },
            "63558": { "city" : "NEW CAMBRIA", "state" : "MO", "county" : "MACON" },
            "63559": { "city" : "NOVINGER", "state" : "MO", "county" : "ADAIR" },
            "63560": { "city" : "POLLOCK", "state" : "MO", "county" : "SULLIVAN" },
            "63561": { "city" : "QUEEN CITY", "state" : "MO", "county" : "SCHUYLER" },
            "63563": { "city" : "RUTLEDGE", "state" : "MO", "county" : "SCOTLAND" },
            "63565": { "city" : "UNIONVILLE", "state" : "MO", "county" : "PUTNAM" },
            "63566": { "city" : "WINIGAN", "state" : "MO", "county" : "SULLIVAN" },
            "63567": { "city" : "WORTHINGTON", "state" : "MO", "county" : "PUTNAM" },
            "63601": { "city" : "PARK HILLS", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63620": { "city" : "ANNAPOLIS", "state" : "MO", "county" : "IRON" },
            "63621": { "city" : "ARCADIA", "state" : "MO", "county" : "IRON" },"63622": { "city" : "BELGRADE", "state" : "MO", "county" : "WASHINGTON" },
            "63623": { "city" : "BELLEVIEW", "state" : "MO", "county" : "IRON" },
            "63624": { "city" : "BISMARCK", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63625": { "city" : "BLACK", "state" : "MO", "county" : "REYNOLDS" },
            "63626": { "city" : "BLACKWELL", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63627": { "city" : "BLOOMSDALE", "state" : "MO", "county" : "SAINTE GENEVIEVE" },
            "63628": { "city" : "BONNE TERRE", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63629": { "city" : "BUNKER", "state" : "MO", "county" : "REYNOLDS" },
            "63630": { "city" : "CADET", "state" : "MO", "county" : "WASHINGTON" },
            "63631": { "city" : "CALEDONIA", "state" : "MO", "county" : "WASHINGTON" },
            "63633": { "city" : "CENTERVILLE", "state" : "MO", "county" : "REYNOLDS" },
            "63636": { "city" : "DES ARC", "state" : "MO", "county" : "IRON" },"63637": { "city" : "DOE RUN", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63638": { "city" : "ELLINGTON", "state" : "MO", "county" : "REYNOLDS" },
            "63640": { "city" : "FARMINGTON", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63645": { "city" : "FREDERICKTOWN", "state" : "MO", "county" : "MADISON" },
            "63648": { "city" : "IRONDALE", "state" : "MO", "county" : "WASHINGTON" },
            "63650": { "city" : "IRONTON", "state" : "MO", "county" : "IRON" },"63651": { "city" : "KNOB LICK", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63653": { "city" : "LEADWOOD", "state" : "MO", "county" : "SAINT FRANCOIS" },
            "63654": { "city" : "LESTERVILLE", "state" : "MO", "county" : "REYNOLDS" },
            "63655": { "city" : "MARQUAND", "state" : "MO", "county" : "MADISON" },
            "63656": { "city" : "MIDDLE BROOK", "state" : "MO", "county" : "IRON" },
            "63660": { "city" : "MINERAL POINT", "state" : "MO", "county" : "WASHINGTON" },
            "63662": { "city" : "PATTON", "state" : "MO", "county" : "BOLLINGER" },
            "63663": { "city" : "PILOT KNOB", "state" : "MO", "county" : "IRON" },
            "63664": { "city" : "POTOSI", "state" : "MO", "county" : "WASHINGTON" },
            "63665": { "city" : "REDFORD", "state" : "MO", "county" : "REYNOLDS" },
            "63666": { "city" : "REYNOLDS", "state" : "MO", "county" : "REYNOLDS" },
            "63670": { "city" : "SAINTE GENEVIEVE", "state" : "MO", "county" : "SAINTE GENEVIEVE" },
            "63673": { "city" : "SAINT MARY", "state" : "MO", "county" : "SAINTE GENEVIEVE" },
            "63674": { "city" : "TIFF", "state" : "MO", "county" : "WASHINGTON" },
            "63675": { "city" : "VULCAN", "state" : "MO", "county" : "IRON" },"63701": { "city" : "CAPE GIRARDEAU", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63702": { "city" : "CAPE GIRARDEAU", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63703": { "city" : "CAPE GIRARDEAU", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63730": { "city" : "ADVANCE", "state" : "MO", "county" : "STODDARD" },
            "63732": { "city" : "ALTENBURG", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63735": { "city" : "BELL CITY", "state" : "MO", "county" : "STODDARD" },
            "63736": { "city" : "BENTON", "state" : "MO", "county" : "SCOTT" },"63739": { "city" : "BURFORDVILLE", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63740": { "city" : "CHAFFEE", "state" : "MO", "county" : "SCOTT" },"63742": { "city" : "COMMERCE", "state" : "MO", "county" : "SCOTT" },
            "63743": { "city" : "DAISY", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63744": { "city" : "DELTA", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63745": { "city" : "DUTCHTOWN", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63746": { "city" : "FARRAR", "state" : "MO", "county" : "PERRY" },"63747": { "city" : "FRIEDHEIM", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63748": { "city" : "FROHNA", "state" : "MO", "county" : "PERRY" },"63751": { "city" : "GLENALLEN", "state" : "MO", "county" : "BOLLINGER" },
            "63752": { "city" : "GORDONVILLE", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63755": { "city" : "JACKSON", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63758": { "city" : "KELSO", "state" : "MO", "county" : "SCOTT" },"63760": { "city" : "LEOPOLD", "state" : "MO", "county" : "BOLLINGER" },
            "63764": { "city" : "MARBLE HILL", "state" : "MO", "county" : "BOLLINGER" },
            "63766": { "city" : "MILLERSVILLE", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63767": { "city" : "MORLEY", "state" : "MO", "county" : "SCOTT" },"63769": { "city" : "OAK RIDGE", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63770": { "city" : "OLD APPLETON", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63771": { "city" : "ORAN", "state" : "MO", "county" : "SCOTT" },"63775": { "city" : "PERRYVILLE", "state" : "MO", "county" : "PERRY" },
            "63776": { "city" : "MC BRIDE", "state" : "MO", "county" : "PERRY" },
            "63779": { "city" : "POCAHONTAS", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63780": { "city" : "SCOTT CITY", "state" : "MO", "county" : "SCOTT" },
            "63781": { "city" : "SEDGEWICKVILLE", "state" : "MO", "county" : "BOLLINGER" },
            "63782": { "city" : "STURDIVANT", "state" : "MO", "county" : "BOLLINGER" },
            "63783": { "city" : "UNIONTOWN", "state" : "MO", "county" : "PERRY" },
            "63784": { "city" : "VANDUSER", "state" : "MO", "county" : "SCOTT" },
            "63785": { "city" : "WHITEWATER", "state" : "MO", "county" : "CAPE GIRARDEAU" },
            "63787": { "city" : "ZALMA", "state" : "MO", "county" : "BOLLINGER" },
            "63801": { "city" : "SIKESTON", "state" : "MO", "county" : "SCOTT" },
            "63820": { "city" : "ANNISTON", "state" : "MO", "county" : "MISSISSIPPI" },
            "63821": { "city" : "ARBYRD", "state" : "MO", "county" : "DUNKLIN" },
            "63822": { "city" : "BERNIE", "state" : "MO", "county" : "STODDARD" },
            "63823": { "city" : "BERTRAND", "state" : "MO", "county" : "MISSISSIPPI" },
            "63824": { "city" : "BLODGETT", "state" : "MO", "county" : "SCOTT" },
            "63825": { "city" : "BLOOMFIELD", "state" : "MO", "county" : "STODDARD" },
            "63826": { "city" : "BRAGGADOCIO", "state" : "MO", "county" : "PEMISCOT" },
            "63827": { "city" : "BRAGG CITY", "state" : "MO", "county" : "PEMISCOT" },
            "63829": { "city" : "CARDWELL", "state" : "MO", "county" : "DUNKLIN" },
            "63830": { "city" : "CARUTHERSVILLE", "state" : "MO", "county" : "PEMISCOT" },
            "63833": { "city" : "CATRON", "state" : "MO", "county" : "NEW MADRID" },
            "63834": { "city" : "CHARLESTON", "state" : "MO", "county" : "MISSISSIPPI" },
            "63837": { "city" : "CLARKTON", "state" : "MO", "county" : "DUNKLIN" },
            "63839": { "city" : "COOTER", "state" : "MO", "county" : "PEMISCOT" },
            "63840": { "city" : "DEERING", "state" : "MO", "county" : "PEMISCOT" },
            "63841": { "city" : "DEXTER", "state" : "MO", "county" : "STODDARD" },
            "63845": { "city" : "EAST PRAIRIE", "state" : "MO", "county" : "MISSISSIPPI" },
            "63846": { "city" : "ESSEX", "state" : "MO", "county" : "STODDARD" },
            "63847": { "city" : "GIBSON", "state" : "MO", "county" : "DUNKLIN" },
            "63848": { "city" : "GIDEON", "state" : "MO", "county" : "NEW MADRID" },
            "63849": { "city" : "GOBLER", "state" : "MO", "county" : "PEMISCOT" },
            "63851": { "city" : "HAYTI", "state" : "MO", "county" : "PEMISCOT" },
            "63852": { "city" : "HOLCOMB", "state" : "MO", "county" : "DUNKLIN" },
            "63853": { "city" : "HOLLAND", "state" : "MO", "county" : "PEMISCOT" },
            "63855": { "city" : "HORNERSVILLE", "state" : "MO", "county" : "DUNKLIN" },
            "63857": { "city" : "KENNETT", "state" : "MO", "county" : "DUNKLIN" },
            "63860": { "city" : "KEWANEE", "state" : "MO", "county" : "NEW MADRID" },
            "63862": { "city" : "LILBOURN", "state" : "MO", "county" : "NEW MADRID" },
            "63863": { "city" : "MALDEN", "state" : "MO", "county" : "DUNKLIN" },
            "63866": { "city" : "MARSTON", "state" : "MO", "county" : "NEW MADRID" },
            "63867": { "city" : "MATTHEWS", "state" : "MO", "county" : "NEW MADRID" },
            "63868": { "city" : "MOREHOUSE", "state" : "MO", "county" : "NEW MADRID" },
            "63869": { "city" : "NEW MADRID", "state" : "MO", "county" : "NEW MADRID" },
            "63870": { "city" : "PARMA", "state" : "MO", "county" : "NEW MADRID" },
            "63873": { "city" : "PORTAGEVILLE", "state" : "MO", "county" : "NEW MADRID" },
            "63874": { "city" : "RISCO", "state" : "MO", "county" : "NEW MADRID" },
            "63876": { "city" : "SENATH", "state" : "MO", "county" : "DUNKLIN" },
            "63877": { "city" : "STEELE", "state" : "MO", "county" : "PEMISCOT" },
            "63878": { "city" : "TALLAPOOSA", "state" : "MO", "county" : "NEW MADRID" },
            "63879": { "city" : "WARDELL", "state" : "MO", "county" : "PEMISCOT" },
            "63880": { "city" : "WHITEOAK", "state" : "MO", "county" : "DUNKLIN" },
            "63882": { "city" : "WYATT", "state" : "MO", "county" : "MISSISSIPPI" },
            "63901": { "city" : "POPLAR BLUFF", "state" : "MO", "county" : "BUTLER" },
            "63902": { "city" : "POPLAR BLUFF", "state" : "MO", "county" : "BUTLER" },
            "63932": { "city" : "BROSELEY", "state" : "MO", "county" : "BUTLER" },
            "63933": { "city" : "CAMPBELL", "state" : "MO", "county" : "DUNKLIN" },
            "63934": { "city" : "CLUBB", "state" : "MO", "county" : "WAYNE" },"63935": { "city" : "DONIPHAN", "state" : "MO", "county" : "RIPLEY" },
            "63936": { "city" : "DUDLEY", "state" : "MO", "county" : "STODDARD" },
            "63937": { "city" : "ELLSINORE", "state" : "MO", "county" : "CARTER" },
            "63939": { "city" : "FAIRDEALING", "state" : "MO", "county" : "RIPLEY" },
            "63940": { "city" : "FISK", "state" : "MO", "county" : "BUTLER" },"63941": { "city" : "FREMONT", "state" : "MO", "county" : "CARTER" },
            "63942": { "city" : "GATEWOOD", "state" : "MO", "county" : "RIPLEY" },
            "63943": { "city" : "GRANDIN", "state" : "MO", "county" : "CARTER" },
            "63944": { "city" : "GREENVILLE", "state" : "MO", "county" : "WAYNE" },
            "63945": { "city" : "HARVIELL", "state" : "MO", "county" : "BUTLER" },
            "63950": { "city" : "LODI", "state" : "MO", "county" : "WAYNE" },"63951": { "city" : "LOWNDES", "state" : "MO", "county" : "WAYNE" },
            "63952": { "city" : "MILL SPRING", "state" : "MO", "county" : "WAYNE" },
            "63953": { "city" : "NAYLOR", "state" : "MO", "county" : "RIPLEY" },"63954": { "city" : "NEELYVILLE", "state" : "MO", "county" : "BUTLER" },
            "63955": { "city" : "OXLY", "state" : "MO", "county" : "RIPLEY" },"63956": { "city" : "PATTERSON", "state" : "MO", "county" : "WAYNE" },
            "63957": { "city" : "PIEDMONT", "state" : "MO", "county" : "WAYNE" },
            "63960": { "city" : "PUXICO", "state" : "MO", "county" : "STODDARD" },
            "63961": { "city" : "QULIN", "state" : "MO", "county" : "BUTLER" },"63964": { "city" : "SILVA", "state" : "MO", "county" : "WAYNE" },
            "63965": { "city" : "VAN BUREN", "state" : "MO", "county" : "CARTER" },
            "63966": { "city" : "WAPPAPELLO", "state" : "MO", "county" : "WAYNE" },
            "63967": { "city" : "WILLIAMSVILLE", "state" : "MO", "county" : "WAYNE" },
            "64001": { "city" : "ALMA", "state" : "MO", "county" : "LAFAYETTE" },
            "64011": { "city" : "BATES CITY", "state" : "MO", "county" : "LAFAYETTE" },
            "64012": { "city" : "BELTON", "state" : "MO", "county" : "CASS" },"64013": { "city" : "BLUE SPRINGS", "state" : "MO", "county" : "JACKSON" },
            "64014": { "city" : "BLUE SPRINGS", "state" : "MO", "county" : "JACKSON" },
            "64015": { "city" : "BLUE SPRINGS", "state" : "MO", "county" : "JACKSON" },
            "64016": { "city" : "BUCKNER", "state" : "MO", "county" : "JACKSON" },
            "64017": { "city" : "CAMDEN", "state" : "MO", "county" : "RAY" },"64018": { "city" : "CAMDEN POINT", "state" : "MO", "county" : "PLATTE" },
            "64019": { "city" : "CENTERVIEW", "state" : "MO", "county" : "JOHNSON" },
            "64020": { "city" : "CONCORDIA", "state" : "MO", "county" : "LAFAYETTE" },
            "64021": { "city" : "CORDER", "state" : "MO", "county" : "LAFAYETTE" },
            "64022": { "city" : "DOVER", "state" : "MO", "county" : "LAFAYETTE" },
            "64024": { "city" : "EXCELSIOR SPRINGS", "state" : "MO", "county" : "CLAY" },
            "64028": { "city" : "FARLEY", "state" : "MO", "county" : "PLATTE" },"64029": { "city" : "GRAIN VALLEY", "state" : "MO", "county" : "JACKSON" },
            "64030": { "city" : "GRANDVIEW", "state" : "MO", "county" : "JACKSON" },
            "64034": { "city" : "GREENWOOD", "state" : "MO", "county" : "JACKSON" },
            "64035": { "city" : "HARDIN", "state" : "MO", "county" : "RAY" },"64036": { "city" : "HENRIETTA", "state" : "MO", "county" : "RAY" },
            "64037": { "city" : "HIGGINSVILLE", "state" : "MO", "county" : "LAFAYETTE" },
            "64040": { "city" : "HOLDEN", "state" : "MO", "county" : "JOHNSON" },
            "64048": { "city" : "HOLT", "state" : "MO", "county" : "CLAY" },"64050": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64051": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64052": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64053": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64054": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64055": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64056": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64057": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64058": { "city" : "INDEPENDENCE", "state" : "MO", "county" : "JACKSON" },
            "64060": { "city" : "KEARNEY", "state" : "MO", "county" : "CLAY" },"64061": { "city" : "KINGSVILLE", "state" : "MO", "county" : "JOHNSON" },
            "64062": { "city" : "LAWSON", "state" : "MO", "county" : "RAY" },"64063": { "city" : "LEES SUMMIT", "state" : "MO", "county" : "JACKSON" },
            "64064": { "city" : "LEES SUMMIT", "state" : "MO", "county" : "JACKSON" },
            "64065": { "city" : "LEES SUMMIT", "state" : "MO", "county" : "JACKSON" },
            "64066": { "city" : "LEVASY", "state" : "MO", "county" : "JACKSON" },
            "64067": { "city" : "LEXINGTON", "state" : "MO", "county" : "LAFAYETTE" },
            "64068": { "city" : "LIBERTY", "state" : "MO", "county" : "CLAY" },"64069": { "city" : "LIBERTY", "state" : "MO", "county" : "CLAY" },
            "64070": { "city" : "LONE JACK", "state" : "MO", "county" : "JACKSON" },
            "64071": { "city" : "MAYVIEW", "state" : "MO", "county" : "LAFAYETTE" },
            "64072": { "city" : "MISSOURI CITY", "state" : "MO", "county" : "CLAY" },
            "64073": { "city" : "MOSBY", "state" : "MO", "county" : "CLAY" },"64074": { "city" : "NAPOLEON", "state" : "MO", "county" : "LAFAYETTE" },
            "64075": { "city" : "OAK GROVE", "state" : "MO", "county" : "JACKSON" },
            "64076": { "city" : "ODESSA", "state" : "MO", "county" : "LAFAYETTE" },
            "64077": { "city" : "ORRICK", "state" : "MO", "county" : "RAY" },"64078": { "city" : "PECULIAR", "state" : "MO", "county" : "CASS" },
            "64079": { "city" : "PLATTE CITY", "state" : "MO", "county" : "PLATTE" },
            "64080": { "city" : "PLEASANT HILL", "state" : "MO", "county" : "CASS" },
            "64081": { "city" : "LEES SUMMIT", "state" : "MO", "county" : "JACKSON" },
            "64082": { "city" : "LEES SUMMIT", "state" : "MO", "county" : "JACKSON" },
            "64083": { "city" : "RAYMORE", "state" : "MO", "county" : "CASS" },"64084": { "city" : "RAYVILLE", "state" : "MO", "county" : "RAY" },
            "64085": { "city" : "RICHMOND", "state" : "MO", "county" : "RAY" },"64086": { "city" : "LEES SUMMIT", "state" : "MO", "county" : "JACKSON" },
            "64088": { "city" : "SIBLEY", "state" : "MO", "county" : "JACKSON" },
            "64089": { "city" : "SMITHVILLE", "state" : "MO", "county" : "CLAY" },
            "64090": { "city" : "STRASBURG", "state" : "MO", "county" : "CASS" },
            "64092": { "city" : "WALDRON", "state" : "MO", "county" : "PLATTE" },
            "64093": { "city" : "WARRENSBURG", "state" : "MO", "county" : "JOHNSON" },
            "64096": { "city" : "WAVERLY", "state" : "MO", "county" : "LAFAYETTE" },
            "64097": { "city" : "WELLINGTON", "state" : "MO", "county" : "LAFAYETTE" },
            "64098": { "city" : "WESTON", "state" : "MO", "county" : "PLATTE" },"64101": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64102": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64105": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64106": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64108": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64109": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64110": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64111": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64112": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64113": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64114": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64116": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64117": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64118": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64119": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64120": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64123": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64124": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64125": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64126": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64127": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64128": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64129": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64130": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64131": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64132": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64133": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64134": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64136": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64137": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64138": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64139": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64141": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64145": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64146": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64147": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64148": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64149": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64150": { "city" : "RIVERSIDE", "state" : "MO", "county" : "PLATTE" },
            "64151": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64152": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64153": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64154": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64155": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64156": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64157": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64158": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64161": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64163": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64164": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64165": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64166": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64167": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64168": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64170": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64171": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64188": { "city" : "KANSAS CITY", "state" : "MO", "county" : "CLAY" },
            "64190": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64191": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64192": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64195": { "city" : "KANSAS CITY", "state" : "MO", "county" : "PLATTE" },
            "64196": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64197": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64198": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64199": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "64401": { "city" : "AGENCY", "state" : "MO", "county" : "BUCHANAN" },
            "64402": { "city" : "ALBANY", "state" : "MO", "county" : "GENTRY" },"64420": { "city" : "ALLENDALE", "state" : "MO", "county" : "WORTH" },
            "64421": { "city" : "AMAZONIA", "state" : "MO", "county" : "ANDREW" },
            "64422": { "city" : "AMITY", "state" : "MO", "county" : "DEKALB" },"64423": { "city" : "BARNARD", "state" : "MO", "county" : "NODAWAY" },
            "64424": { "city" : "BETHANY", "state" : "MO", "county" : "HARRISON" },
            "64426": { "city" : "BLYTHEDALE", "state" : "MO", "county" : "HARRISON" },
            "64427": { "city" : "BOLCKOW", "state" : "MO", "county" : "ANDREW" },
            "64428": { "city" : "BURLINGTON JUNCTION", "state" : "MO", "county" : "NODAWAY" },
            "64429": { "city" : "CAMERON", "state" : "MO", "county" : "CLINTON" },
            "64430": { "city" : "CLARKSDALE", "state" : "MO", "county" : "DEKALB" },
            "64431": { "city" : "CLEARMONT", "state" : "MO", "county" : "NODAWAY" },
            "64432": { "city" : "CLYDE", "state" : "MO", "county" : "NODAWAY" },"64433": { "city" : "CONCEPTION", "state" : "MO", "county" : "NODAWAY" },
            "64434": { "city" : "CONCEPTION JUNCTION", "state" : "MO", "county" : "NODAWAY" },
            "64436": { "city" : "COSBY", "state" : "MO", "county" : "ANDREW" },"64437": { "city" : "CRAIG", "state" : "MO", "county" : "HOLT" },
            "64438": { "city" : "DARLINGTON", "state" : "MO", "county" : "GENTRY" },
            "64439": { "city" : "DEARBORN", "state" : "MO", "county" : "PLATTE" },
            "64440": { "city" : "DE KALB", "state" : "MO", "county" : "BUCHANAN" },
            "64441": { "city" : "DENVER", "state" : "MO", "county" : "WORTH" },"64442": { "city" : "EAGLEVILLE", "state" : "MO", "county" : "HARRISON" },
            "64443": { "city" : "EASTON", "state" : "MO", "county" : "BUCHANAN" },
            "64444": { "city" : "EDGERTON", "state" : "MO", "county" : "PLATTE" },
            "64445": { "city" : "ELMO", "state" : "MO", "county" : "NODAWAY" },"64446": { "city" : "FAIRFAX", "state" : "MO", "county" : "ATCHISON" },
            "64448": { "city" : "FAUCETT", "state" : "MO", "county" : "BUCHANAN" },
            "64449": { "city" : "FILLMORE", "state" : "MO", "county" : "ANDREW" },
            "64451": { "city" : "FOREST CITY", "state" : "MO", "county" : "HOLT" },
            "64453": { "city" : "GENTRY", "state" : "MO", "county" : "GENTRY" },"64454": { "city" : "GOWER", "state" : "MO", "county" : "CLINTON" },
            "64455": { "city" : "GRAHAM", "state" : "MO", "county" : "NODAWAY" },
            "64456": { "city" : "GRANT CITY", "state" : "MO", "county" : "WORTH" },
            "64457": { "city" : "GUILFORD", "state" : "MO", "county" : "NODAWAY" },
            "64458": { "city" : "HATFIELD", "state" : "MO", "county" : "HARRISON" },
            "64459": { "city" : "HELENA", "state" : "MO", "county" : "ANDREW" },"64461": { "city" : "HOPKINS", "state" : "MO", "county" : "NODAWAY" },
            "64463": { "city" : "KING CITY", "state" : "MO", "county" : "GENTRY" },
            "64465": { "city" : "LATHROP", "state" : "MO", "county" : "CLINTON" },
            "64466": { "city" : "MAITLAND", "state" : "MO", "county" : "HOLT" },"64468": { "city" : "MARYVILLE", "state" : "MO", "county" : "NODAWAY" },
            "64469": { "city" : "MAYSVILLE", "state" : "MO", "county" : "DEKALB" },
            "64470": { "city" : "MOUND CITY", "state" : "MO", "county" : "HOLT" },
            "64471": { "city" : "NEW HAMPTON", "state" : "MO", "county" : "HARRISON" },
            "64473": { "city" : "OREGON", "state" : "MO", "county" : "HOLT" },"64474": { "city" : "OSBORN", "state" : "MO", "county" : "DEKALB" },
            "64475": { "city" : "PARNELL", "state" : "MO", "county" : "NODAWAY" },
            "64476": { "city" : "PICKERING", "state" : "MO", "county" : "NODAWAY" },
            "64477": { "city" : "PLATTSBURG", "state" : "MO", "county" : "CLINTON" },
            "64479": { "city" : "RAVENWOOD", "state" : "MO", "county" : "NODAWAY" },
            "64480": { "city" : "REA", "state" : "MO", "county" : "ANDREW" },"64481": { "city" : "RIDGEWAY", "state" : "MO", "county" : "HARRISON" },
            "64482": { "city" : "ROCK PORT", "state" : "MO", "county" : "ATCHISON" },
            "64483": { "city" : "ROSENDALE", "state" : "MO", "county" : "ANDREW" },
            "64484": { "city" : "RUSHVILLE", "state" : "MO", "county" : "BUCHANAN" },
            "64485": { "city" : "SAVANNAH", "state" : "MO", "county" : "ANDREW" },
            "64486": { "city" : "SHERIDAN", "state" : "MO", "county" : "WORTH" },
            "64487": { "city" : "SKIDMORE", "state" : "MO", "county" : "NODAWAY" },
            "64489": { "city" : "STANBERRY", "state" : "MO", "county" : "GENTRY" },
            "64490": { "city" : "STEWARTSVILLE", "state" : "MO", "county" : "DEKALB" },
            "64491": { "city" : "TARKIO", "state" : "MO", "county" : "ATCHISON" },
            "64492": { "city" : "TRIMBLE", "state" : "MO", "county" : "CLINTON" },
            "64493": { "city" : "TURNEY", "state" : "MO", "county" : "CLINTON" },
            "64494": { "city" : "UNION STAR", "state" : "MO", "county" : "DEKALB" },
            "64496": { "city" : "WATSON", "state" : "MO", "county" : "ATCHISON" },
            "64497": { "city" : "WEATHERBY", "state" : "MO", "county" : "DEKALB" },
            "64498": { "city" : "WESTBORO", "state" : "MO", "county" : "ATCHISON" },
            "64501": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64502": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64503": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64504": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64505": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64506": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64507": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64508": { "city" : "SAINT JOSEPH", "state" : "MO", "county" : "BUCHANAN" },
            "64601": { "city" : "CHILLICOTHE", "state" : "MO", "county" : "LIVINGSTON" },
            "64620": { "city" : "ALTAMONT", "state" : "MO", "county" : "DAVIESS" },
            "64622": { "city" : "BOGARD", "state" : "MO", "county" : "CARROLL" },
            "64623": { "city" : "BOSWORTH", "state" : "MO", "county" : "CARROLL" },
            "64624": { "city" : "BRAYMER", "state" : "MO", "county" : "CALDWELL" },
            "64625": { "city" : "BRECKENRIDGE", "state" : "MO", "county" : "CALDWELL" },
            "64628": { "city" : "BROOKFIELD", "state" : "MO", "county" : "LINN" },
            "64630": { "city" : "BROWNING", "state" : "MO", "county" : "LINN" },"64631": { "city" : "BUCKLIN", "state" : "MO", "county" : "LINN" },
            "64632": { "city" : "CAINSVILLE", "state" : "MO", "county" : "HARRISON" },
            "64633": { "city" : "CARROLLTON", "state" : "MO", "county" : "CARROLL" },
            "64635": { "city" : "CHULA", "state" : "MO", "county" : "LIVINGSTON" },
            "64636": { "city" : "COFFEY", "state" : "MO", "county" : "DAVIESS" },
            "64637": { "city" : "COWGILL", "state" : "MO", "county" : "CALDWELL" },
            "64638": { "city" : "DAWN", "state" : "MO", "county" : "LIVINGSTON" },
            "64639": { "city" : "DE WITT", "state" : "MO", "county" : "CARROLL" },
            "64640": { "city" : "GALLATIN", "state" : "MO", "county" : "DAVIESS" },
            "64641": { "city" : "GALT", "state" : "MO", "county" : "GRUNDY" },"64642": { "city" : "GILMAN CITY", "state" : "MO", "county" : "HARRISON" },
            "64643": { "city" : "HALE", "state" : "MO", "county" : "CARROLL" },"64644": { "city" : "HAMILTON", "state" : "MO", "county" : "CALDWELL" },
            "64645": { "city" : "HARRIS", "state" : "MO", "county" : "SULLIVAN" },
            "64646": { "city" : "HUMPHREYS", "state" : "MO", "county" : "SULLIVAN" },
            "64648": { "city" : "JAMESPORT", "state" : "MO", "county" : "DAVIESS" },
            "64649": { "city" : "KIDDER", "state" : "MO", "county" : "CALDWELL" },
            "64650": { "city" : "KINGSTON", "state" : "MO", "county" : "CALDWELL" },
            "64651": { "city" : "LACLEDE", "state" : "MO", "county" : "LINN" },"64652": { "city" : "LAREDO", "state" : "MO", "county" : "GRUNDY" },
            "64653": { "city" : "LINNEUS", "state" : "MO", "county" : "LINN" },"64655": { "city" : "LUCERNE", "state" : "MO", "county" : "PUTNAM" },
            "64656": { "city" : "LUDLOW", "state" : "MO", "county" : "LIVINGSTON" },
            "64657": { "city" : "MC FALL", "state" : "MO", "county" : "GENTRY" },
            "64658": { "city" : "MARCELINE", "state" : "MO", "county" : "LINN" },
            "64659": { "city" : "MEADVILLE", "state" : "MO", "county" : "LINN" },
            "64660": { "city" : "MENDON", "state" : "MO", "county" : "CHARITON" },
            "64661": { "city" : "MERCER", "state" : "MO", "county" : "MERCER" },"64664": { "city" : "MOORESVILLE", "state" : "MO", "county" : "LIVINGSTON" },
            "64667": { "city" : "NEWTOWN", "state" : "MO", "county" : "SULLIVAN" },
            "64668": { "city" : "NORBORNE", "state" : "MO", "county" : "CARROLL" },
            "64670": { "city" : "PATTONSBURG", "state" : "MO", "county" : "DAVIESS" },
            "64671": { "city" : "POLO", "state" : "MO", "county" : "CALDWELL" },"64672": { "city" : "POWERSVILLE", "state" : "MO", "county" : "PUTNAM" },
            "64673": { "city" : "PRINCETON", "state" : "MO", "county" : "MERCER" },
            "64674": { "city" : "PURDIN", "state" : "MO", "county" : "LINN" },"64676": { "city" : "ROTHVILLE", "state" : "MO", "county" : "CHARITON" },
            "64679": { "city" : "SPICKARD", "state" : "MO", "county" : "GRUNDY" },
            "64681": { "city" : "SUMNER", "state" : "MO", "county" : "CHARITON" },
            "64682": { "city" : "TINA", "state" : "MO", "county" : "CARROLL" },"64683": { "city" : "TRENTON", "state" : "MO", "county" : "GRUNDY" },
            "64688": { "city" : "WHEELING", "state" : "MO", "county" : "LIVINGSTON" },
            "64689": { "city" : "WINSTON", "state" : "MO", "county" : "DAVIESS" },
            "64701": { "city" : "HARRISONVILLE", "state" : "MO", "county" : "CASS" },
            "64720": { "city" : "ADRIAN", "state" : "MO", "county" : "BATES" },"64722": { "city" : "AMORET", "state" : "MO", "county" : "BATES" },
            "64723": { "city" : "AMSTERDAM", "state" : "MO", "county" : "BATES" },
            "64724": { "city" : "APPLETON CITY", "state" : "MO", "county" : "SAINT CLAIR" },
            "64725": { "city" : "ARCHIE", "state" : "MO", "county" : "CASS" },"64726": { "city" : "BLAIRSTOWN", "state" : "MO", "county" : "HENRY" },
            "64728": { "city" : "BRONAUGH", "state" : "MO", "county" : "VERNON" },
            "64730": { "city" : "BUTLER", "state" : "MO", "county" : "BATES" },"64733": { "city" : "CHILHOWEE", "state" : "MO", "county" : "JOHNSON" },
            "64734": { "city" : "CLEVELAND", "state" : "MO", "county" : "CASS" },
            "64735": { "city" : "CLINTON", "state" : "MO", "county" : "HENRY" },"64738": { "city" : "COLLINS", "state" : "MO", "county" : "SAINT CLAIR" },
            "64739": { "city" : "CREIGHTON", "state" : "MO", "county" : "HENRY" },
            "64740": { "city" : "DEEPWATER", "state" : "MO", "county" : "HENRY" },
            "64741": { "city" : "DEERFIELD", "state" : "MO", "county" : "VERNON" },
            "64742": { "city" : "DREXEL", "state" : "MO", "county" : "BATES" },"64743": { "city" : "EAST LYNNE", "state" : "MO", "county" : "CASS" },
            "64744": { "city" : "EL DORADO SPRINGS", "state" : "MO", "county" : "CEDAR" },
            "64745": { "city" : "FOSTER", "state" : "MO", "county" : "BATES" },"64746": { "city" : "FREEMAN", "state" : "MO", "county" : "CASS" },
            "64747": { "city" : "GARDEN CITY", "state" : "MO", "county" : "CASS" },
            "64748": { "city" : "GOLDEN CITY", "state" : "MO", "county" : "BARTON" },
            "64750": { "city" : "HARWOOD", "state" : "MO", "county" : "VERNON" },
            "64752": { "city" : "HUME", "state" : "MO", "county" : "BATES" },"64755": { "city" : "JASPER", "state" : "MO", "county" : "JASPER" },
            "64756": { "city" : "JERICO SPRINGS", "state" : "MO", "county" : "CEDAR" },
            "64759": { "city" : "LAMAR", "state" : "MO", "county" : "BARTON" },"64761": { "city" : "LEETON", "state" : "MO", "county" : "JOHNSON" },
            "64762": { "city" : "LIBERAL", "state" : "MO", "county" : "BARTON" },
            "64763": { "city" : "LOWRY CITY", "state" : "MO", "county" : "SAINT CLAIR" },
            "64765": { "city" : "METZ", "state" : "MO", "county" : "VERNON" },"64767": { "city" : "MILO", "state" : "MO", "county" : "VERNON" },
            "64769": { "city" : "MINDENMINES", "state" : "MO", "county" : "BARTON" },
            "64770": { "city" : "MONTROSE", "state" : "MO", "county" : "HENRY" },
            "64771": { "city" : "MOUNDVILLE", "state" : "MO", "county" : "VERNON" },
            "64772": { "city" : "NEVADA", "state" : "MO", "county" : "VERNON" },"64776": { "city" : "OSCEOLA", "state" : "MO", "county" : "SAINT CLAIR" },
            "64778": { "city" : "RICHARDS", "state" : "MO", "county" : "VERNON" },
            "64779": { "city" : "RICH HILL", "state" : "MO", "county" : "BATES" },
            "64780": { "city" : "ROCKVILLE", "state" : "MO", "county" : "BATES" },
            "64781": { "city" : "ROSCOE", "state" : "MO", "county" : "SAINT CLAIR" },
            "64783": { "city" : "SCHELL CITY", "state" : "MO", "county" : "VERNON" },
            "64784": { "city" : "SHELDON", "state" : "MO", "county" : "VERNON" },
            "64788": { "city" : "URICH", "state" : "MO", "county" : "HENRY" },"64790": { "city" : "WALKER", "state" : "MO", "county" : "VERNON" },
            "64801": { "city" : "JOPLIN", "state" : "MO", "county" : "JASPER" },"64802": { "city" : "JOPLIN", "state" : "MO", "county" : "JASPER" },
            "64803": { "city" : "JOPLIN", "state" : "MO", "county" : "JASPER" },"64804": { "city" : "JOPLIN", "state" : "MO", "county" : "JASPER" },
            "64830": { "city" : "ALBA", "state" : "MO", "county" : "JASPER" },"64831": { "city" : "ANDERSON", "state" : "MO", "county" : "MCDONALD" },
            "64832": { "city" : "ASBURY", "state" : "MO", "county" : "BARTON" },"64833": { "city" : "AVILLA", "state" : "MO", "county" : "JASPER" },
            "64834": { "city" : "CARL JUNCTION", "state" : "MO", "county" : "JASPER" },
            "64835": { "city" : "CARTERVILLE", "state" : "MO", "county" : "JASPER" },
            "64836": { "city" : "CARTHAGE", "state" : "MO", "county" : "JASPER" },
            "64840": { "city" : "DIAMOND", "state" : "MO", "county" : "NEWTON" },
            "64841": { "city" : "DUENWEG", "state" : "MO", "county" : "JASPER" },
            "64842": { "city" : "FAIRVIEW", "state" : "MO", "county" : "NEWTON" },
            "64843": { "city" : "GOODMAN", "state" : "MO", "county" : "MCDONALD" },
            "64844": { "city" : "GRANBY", "state" : "MO", "county" : "NEWTON" },"64847": { "city" : "LANAGAN", "state" : "MO", "county" : "MCDONALD" },
            "64848": { "city" : "LA RUSSELL", "state" : "MO", "county" : "LAWRENCE" },
            "64850": { "city" : "NEOSHO", "state" : "MO", "county" : "NEWTON" },"64853": { "city" : "NEWTONIA", "state" : "MO", "county" : "NEWTON" },
            "64854": { "city" : "NOEL", "state" : "MO", "county" : "MCDONALD" },"64855": { "city" : "ORONOGO", "state" : "MO", "county" : "JASPER" },
            "64856": { "city" : "PINEVILLE", "state" : "MO", "county" : "MCDONALD" },
            "64857": { "city" : "PURCELL", "state" : "MO", "county" : "JASPER" },
            "64858": { "city" : "RACINE", "state" : "MO", "county" : "NEWTON" },"64859": { "city" : "REEDS", "state" : "MO", "county" : "JASPER" },
            "64861": { "city" : "ROCKY COMFORT", "state" : "MO", "county" : "MCDONALD" },
            "64862": { "city" : "SARCOXIE", "state" : "MO", "county" : "JASPER" },
            "64863": { "city" : "SOUTH WEST CITY", "state" : "MO", "county" : "MCDONALD" },
            "64864": { "city" : "SAGINAW", "state" : "MO", "county" : "NEWTON" },
            "64865": { "city" : "SENECA", "state" : "MO", "county" : "NEWTON" },"64866": { "city" : "STARK CITY", "state" : "MO", "county" : "NEWTON" },
            "64867": { "city" : "STELLA", "state" : "MO", "county" : "NEWTON" },"64868": { "city" : "TIFF CITY", "state" : "MO", "county" : "MCDONALD" },
            "64870": { "city" : "WEBB CITY", "state" : "MO", "county" : "JASPER" },
            "64873": { "city" : "WENTWORTH", "state" : "MO", "county" : "LAWRENCE" },
            "64874": { "city" : "WHEATON", "state" : "MO", "county" : "BARRY" },"64999": { "city" : "KANSAS CITY", "state" : "MO", "county" : "JACKSON" },
            "65001": { "city" : "ARGYLE", "state" : "MO", "county" : "OSAGE" },"65010": { "city" : "ASHLAND", "state" : "MO", "county" : "BOONE" },
            "65011": { "city" : "BARNETT", "state" : "MO", "county" : "MORGAN" },
            "65013": { "city" : "BELLE", "state" : "MO", "county" : "MARIES" },"65014": { "city" : "BLAND", "state" : "MO", "county" : "GASCONADE" },
            "65016": { "city" : "BONNOTS MILL", "state" : "MO", "county" : "OSAGE" },
            "65017": { "city" : "BRUMLEY", "state" : "MO", "county" : "MILLER" },
            "65018": { "city" : "CALIFORNIA", "state" : "MO", "county" : "MONITEAU" },
            "65020": { "city" : "CAMDENTON", "state" : "MO", "county" : "CAMDEN" },
            "65023": { "city" : "CENTERTOWN", "state" : "MO", "county" : "COLE" },
            "65024": { "city" : "CHAMOIS", "state" : "MO", "county" : "OSAGE" },"65025": { "city" : "CLARKSBURG", "state" : "MO", "county" : "MONITEAU" },
            "65026": { "city" : "ELDON", "state" : "MO", "county" : "MILLER" },"65032": { "city" : "EUGENE", "state" : "MO", "county" : "COLE" },
            "65034": { "city" : "FORTUNA", "state" : "MO", "county" : "MONITEAU" },
            "65035": { "city" : "FREEBURG", "state" : "MO", "county" : "OSAGE" },
            "65037": { "city" : "GRAVOIS MILLS", "state" : "MO", "county" : "MORGAN" },
            "65038": { "city" : "LAURIE", "state" : "MO", "county" : "MORGAN" },"65039": { "city" : "HARTSBURG", "state" : "MO", "county" : "BOONE" },
            "65040": { "city" : "HENLEY", "state" : "MO", "county" : "COLE" },"65041": { "city" : "HERMANN", "state" : "MO", "county" : "GASCONADE" },
            "65042": { "city" : "HIGH POINT", "state" : "MO", "county" : "MONITEAU" },
            "65043": { "city" : "HOLTS SUMMIT", "state" : "MO", "county" : "CALLAWAY" },
            "65046": { "city" : "JAMESTOWN", "state" : "MO", "county" : "MONITEAU" },
            "65047": { "city" : "KAISER", "state" : "MO", "county" : "MILLER" },"65048": { "city" : "KOELTZTOWN", "state" : "MO", "county" : "OSAGE" },
            "65049": { "city" : "LAKE OZARK", "state" : "MO", "county" : "CAMDEN" },
            "65050": { "city" : "LATHAM", "state" : "MO", "county" : "MONITEAU" },
            "65051": { "city" : "LINN", "state" : "MO", "county" : "OSAGE" },"65052": { "city" : "LINN CREEK", "state" : "MO", "county" : "CAMDEN" },
            "65053": { "city" : "LOHMAN", "state" : "MO", "county" : "COLE" },"65054": { "city" : "LOOSE CREEK", "state" : "MO", "county" : "OSAGE" },
            "65055": { "city" : "MC GIRK", "state" : "MO", "county" : "MONITEAU" },
            "65058": { "city" : "META", "state" : "MO", "county" : "OSAGE" },"65059": { "city" : "MOKANE", "state" : "MO", "county" : "CALLAWAY" },
            "65061": { "city" : "MORRISON", "state" : "MO", "county" : "GASCONADE" },
            "65062": { "city" : "MOUNT STERLING", "state" : "MO", "county" : "GASCONADE" },
            "65063": { "city" : "NEW BLOOMFIELD", "state" : "MO", "county" : "CALLAWAY" },
            "65064": { "city" : "OLEAN", "state" : "MO", "county" : "MILLER" },"65065": { "city" : "OSAGE BEACH", "state" : "MO", "county" : "CAMDEN" },
            "65066": { "city" : "OWENSVILLE", "state" : "MO", "county" : "GASCONADE" },
            "65067": { "city" : "PORTLAND", "state" : "MO", "county" : "CALLAWAY" },
            "65068": { "city" : "PRAIRIE HOME", "state" : "MO", "county" : "COOPER" },
            "65069": { "city" : "RHINELAND", "state" : "MO", "county" : "MONTGOMERY" },
            "65072": { "city" : "ROCKY MOUNT", "state" : "MO", "county" : "MORGAN" },
            "65074": { "city" : "RUSSELLVILLE", "state" : "MO", "county" : "COLE" },
            "65075": { "city" : "SAINT ELIZABETH", "state" : "MO", "county" : "MILLER" },
            "65076": { "city" : "SAINT THOMAS", "state" : "MO", "county" : "COLE" },
            "65077": { "city" : "STEEDMAN", "state" : "MO", "county" : "CALLAWAY" },
            "65078": { "city" : "STOVER", "state" : "MO", "county" : "MORGAN" },"65079": { "city" : "SUNRISE BEACH", "state" : "MO", "county" : "CAMDEN" },
            "65080": { "city" : "TEBBETTS", "state" : "MO", "county" : "CALLAWAY" },
            "65081": { "city" : "TIPTON", "state" : "MO", "county" : "MONITEAU" },
            "65082": { "city" : "TUSCUMBIA", "state" : "MO", "county" : "MILLER" },
            "65083": { "city" : "ULMAN", "state" : "MO", "county" : "MILLER" },"65084": { "city" : "VERSAILLES", "state" : "MO", "county" : "MORGAN" },
            "65085": { "city" : "WESTPHALIA", "state" : "MO", "county" : "OSAGE" },
            "65101": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65102": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65103": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65104": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65105": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65106": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65107": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65108": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65109": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65110": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65111": { "city" : "JEFFERSON CITY", "state" : "MO", "county" : "COLE" },
            "65201": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65202": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65203": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65205": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65211": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65212": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65215": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65216": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65217": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65218": { "city" : "COLUMBIA", "state" : "MO", "county" : "BOONE" },
            "65230": { "city" : "ARMSTRONG", "state" : "MO", "county" : "HOWARD" },
            "65231": { "city" : "AUXVASSE", "state" : "MO", "county" : "CALLAWAY" },
            "65232": { "city" : "BENTON CITY", "state" : "MO", "county" : "AUDRAIN" },
            "65233": { "city" : "BOONVILLE", "state" : "MO", "county" : "COOPER" },
            "65236": { "city" : "BRUNSWICK", "state" : "MO", "county" : "CHARITON" },
            "65237": { "city" : "BUNCETON", "state" : "MO", "county" : "COOPER" },
            "65239": { "city" : "CAIRO", "state" : "MO", "county" : "RANDOLPH" },
            "65240": { "city" : "CENTRALIA", "state" : "MO", "county" : "BOONE" },
            "65243": { "city" : "CLARK", "state" : "MO", "county" : "RANDOLPH" },
            "65244": { "city" : "CLIFTON HILL", "state" : "MO", "county" : "RANDOLPH" },
            "65247": { "city" : "EXCELLO", "state" : "MO", "county" : "MACON" },"65248": { "city" : "FAYETTE", "state" : "MO", "county" : "HOWARD" },
            "65250": { "city" : "FRANKLIN", "state" : "MO", "county" : "HOWARD" },
            "65251": { "city" : "FULTON", "state" : "MO", "county" : "CALLAWAY" },
            "65254": { "city" : "GLASGOW", "state" : "MO", "county" : "HOWARD" },
            "65255": { "city" : "HALLSVILLE", "state" : "MO", "county" : "BOONE" },
            "65256": { "city" : "HARRISBURG", "state" : "MO", "county" : "BOONE" },
            "65257": { "city" : "HIGBEE", "state" : "MO", "county" : "RANDOLPH" },
            "65258": { "city" : "HOLLIDAY", "state" : "MO", "county" : "MONROE" },
            "65259": { "city" : "HUNTSVILLE", "state" : "MO", "county" : "RANDOLPH" },
            "65260": { "city" : "JACKSONVILLE", "state" : "MO", "county" : "RANDOLPH" },
            "65261": { "city" : "KEYTESVILLE", "state" : "MO", "county" : "CHARITON" },
            "65262": { "city" : "KINGDOM CITY", "state" : "MO", "county" : "CALLAWAY" },
            "65263": { "city" : "MADISON", "state" : "MO", "county" : "MONROE" },
            "65264": { "city" : "MARTINSBURG", "state" : "MO", "county" : "AUDRAIN" },
            "65265": { "city" : "MEXICO", "state" : "MO", "county" : "AUDRAIN" },
            "65270": { "city" : "MOBERLY", "state" : "MO", "county" : "RANDOLPH" },
            "65274": { "city" : "NEW FRANKLIN", "state" : "MO", "county" : "HOWARD" },
            "65275": { "city" : "PARIS", "state" : "MO", "county" : "MONROE" },"65276": { "city" : "PILOT GROVE", "state" : "MO", "county" : "COOPER" },
            "65278": { "city" : "RENICK", "state" : "MO", "county" : "RANDOLPH" },
            "65279": { "city" : "ROCHEPORT", "state" : "MO", "county" : "BOONE" },
            "65280": { "city" : "RUSH HILL", "state" : "MO", "county" : "AUDRAIN" },
            "65281": { "city" : "SALISBURY", "state" : "MO", "county" : "CHARITON" },
            "65282": { "city" : "SANTA FE", "state" : "MO", "county" : "MONROE" },
            "65283": { "city" : "STOUTSVILLE", "state" : "MO", "county" : "MONROE" },
            "65284": { "city" : "STURGEON", "state" : "MO", "county" : "BOONE" },
            "65285": { "city" : "THOMPSON", "state" : "MO", "county" : "AUDRAIN" },
            "65286": { "city" : "TRIPLETT", "state" : "MO", "county" : "CHARITON" },
            "65287": { "city" : "WOOLDRIDGE", "state" : "MO", "county" : "COOPER" },
            "65301": { "city" : "SEDALIA", "state" : "MO", "county" : "PETTIS" },
            "65302": { "city" : "SEDALIA", "state" : "MO", "county" : "PETTIS" },
            "65305": { "city" : "WHITEMAN AIR FORCE BASE", "state" : "MO", "county" : "JOHNSON" },
            "65320": { "city" : "ARROW ROCK", "state" : "MO", "county" : "SALINE" },
            "65321": { "city" : "BLACKBURN", "state" : "MO", "county" : "SALINE" },
            "65322": { "city" : "BLACKWATER", "state" : "MO", "county" : "COOPER" },
            "65323": { "city" : "CALHOUN", "state" : "MO", "county" : "HENRY" },"65324": { "city" : "CLIMAX SPRINGS", "state" : "MO", "county" : "CAMDEN" },
            "65325": { "city" : "COLE CAMP", "state" : "MO", "county" : "BENTON" },
            "65326": { "city" : "EDWARDS", "state" : "MO", "county" : "BENTON" },
            "65327": { "city" : "EMMA", "state" : "MO", "county" : "LAFAYETTE" },
            "65329": { "city" : "FLORENCE", "state" : "MO", "county" : "MORGAN" },
            "65330": { "city" : "GILLIAM", "state" : "MO", "county" : "SALINE" },
            "65332": { "city" : "GREEN RIDGE", "state" : "MO", "county" : "PETTIS" },
            "65333": { "city" : "HOUSTONIA", "state" : "MO", "county" : "PETTIS" },
            "65334": { "city" : "HUGHESVILLE", "state" : "MO", "county" : "PETTIS" },
            "65335": { "city" : "IONIA", "state" : "MO", "county" : "BENTON" },"65336": { "city" : "KNOB NOSTER", "state" : "MO", "county" : "JOHNSON" },
            "65337": { "city" : "LA MONTE", "state" : "MO", "county" : "PETTIS" },
            "65338": { "city" : "LINCOLN", "state" : "MO", "county" : "BENTON" },
            "65339": { "city" : "MALTA BEND", "state" : "MO", "county" : "SALINE" },
            "65340": { "city" : "MARSHALL", "state" : "MO", "county" : "SALINE" },
            "65344": { "city" : "MIAMI", "state" : "MO", "county" : "SALINE" },"65345": { "city" : "MORA", "state" : "MO", "county" : "PETTIS" },
            "65347": { "city" : "NELSON", "state" : "MO", "county" : "SALINE" },"65348": { "city" : "OTTERVILLE", "state" : "MO", "county" : "COOPER" },
            "65349": { "city" : "SLATER", "state" : "MO", "county" : "SALINE" },"65350": { "city" : "SMITHTON", "state" : "MO", "county" : "PETTIS" },
            "65351": { "city" : "SWEET SPRINGS", "state" : "MO", "county" : "SALINE" },
            "65354": { "city" : "SYRACUSE", "state" : "MO", "county" : "MORGAN" },
            "65355": { "city" : "WARSAW", "state" : "MO", "county" : "BENTON" },"65360": { "city" : "WINDSOR", "state" : "MO", "county" : "HENRY" },
            "65401": { "city" : "ROLLA", "state" : "MO", "county" : "PHELPS" },"65402": { "city" : "ROLLA", "state" : "MO", "county" : "PHELPS" },
            "65409": { "city" : "ROLLA", "state" : "MO", "county" : "PHELPS" },"65438": { "city" : "BIRCH TREE", "state" : "MO", "county" : "SHANNON" },
            "65439": { "city" : "BIXBY", "state" : "MO", "county" : "IRON" },"65440": { "city" : "BOSS", "state" : "MO", "county" : "DENT" },
            "65441": { "city" : "BOURBON", "state" : "MO", "county" : "CRAWFORD" },
            "65443": { "city" : "BRINKTOWN", "state" : "MO", "county" : "MARIES" },
            "65444": { "city" : "BUCYRUS", "state" : "MO", "county" : "TEXAS" },"65446": { "city" : "CHERRYVILLE", "state" : "MO", "county" : "CRAWFORD" },
            "65449": { "city" : "COOK STA", "state" : "MO", "county" : "CRAWFORD" },
            "65452": { "city" : "CROCKER", "state" : "MO", "county" : "PULASKI" },
            "65453": { "city" : "CUBA", "state" : "MO", "county" : "CRAWFORD" },"65456": { "city" : "DAVISVILLE", "state" : "MO", "county" : "CRAWFORD" },
            "65457": { "city" : "DEVILS ELBOW", "state" : "MO", "county" : "PULASKI" },
            "65459": { "city" : "DIXON", "state" : "MO", "county" : "PULASKI" },"65461": { "city" : "DUKE", "state" : "MO", "county" : "PHELPS" },
            "65462": { "city" : "EDGAR SPRINGS", "state" : "MO", "county" : "PHELPS" },
            "65463": { "city" : "ELDRIDGE", "state" : "MO", "county" : "LACLEDE" },
            "65464": { "city" : "ELK CREEK", "state" : "MO", "county" : "TEXAS" },
            "65466": { "city" : "EMINENCE", "state" : "MO", "county" : "SHANNON" },
            "65468": { "city" : "EUNICE", "state" : "MO", "county" : "TEXAS" },"65470": { "city" : "FALCON", "state" : "MO", "county" : "LACLEDE" },
            "65473": { "city" : "FORT LEONARD WOOD", "state" : "MO", "county" : "PULASKI" },
            "65483": { "city" : "HOUSTON", "state" : "MO", "county" : "TEXAS" },"65484": { "city" : "HUGGINS", "state" : "MO", "county" : "TEXAS" },
            "65486": { "city" : "IBERIA", "state" : "MO", "county" : "MILLER" },"65501": { "city" : "JADWIN", "state" : "MO", "county" : "DENT" },
            "65529": { "city" : "JEROME", "state" : "MO", "county" : "PHELPS" },"65532": { "city" : "LAKE SPRING", "state" : "MO", "county" : "DENT" },
            "65534": { "city" : "LAQUEY", "state" : "MO", "county" : "PULASKI" },
            "65535": { "city" : "LEASBURG", "state" : "MO", "county" : "CRAWFORD" },
            "65536": { "city" : "LEBANON", "state" : "MO", "county" : "LACLEDE" },
            "65541": { "city" : "LENOX", "state" : "MO", "county" : "DENT" },"65542": { "city" : "LICKING", "state" : "MO", "county" : "TEXAS" },
            "65543": { "city" : "LYNCHBURG", "state" : "MO", "county" : "LACLEDE" },
            "65546": { "city" : "MONTIER", "state" : "MO", "county" : "SHANNON" },
            "65548": { "city" : "MOUNTAIN VIEW", "state" : "MO", "county" : "HOWELL" },
            "65550": { "city" : "NEWBURG", "state" : "MO", "county" : "PHELPS" },
            "65552": { "city" : "PLATO", "state" : "MO", "county" : "TEXAS" },"65555": { "city" : "RAYMONDVILLE", "state" : "MO", "county" : "TEXAS" },
            "65556": { "city" : "RICHLAND", "state" : "MO", "county" : "PULASKI" },
            "65557": { "city" : "ROBY", "state" : "MO", "county" : "TEXAS" },"65559": { "city" : "SAINT JAMES", "state" : "MO", "county" : "PHELPS" },
            "65560": { "city" : "SALEM", "state" : "MO", "county" : "DENT" },"65565": { "city" : "STEELVILLE", "state" : "MO", "county" : "CRAWFORD" },
            "65566": { "city" : "VIBURNUM", "state" : "MO", "county" : "IRON" },"65567": { "city" : "STOUTLAND", "state" : "MO", "county" : "LACLEDE" },
            "65570": { "city" : "SUCCESS", "state" : "MO", "county" : "TEXAS" },"65571": { "city" : "SUMMERSVILLE", "state" : "MO", "county" : "TEXAS" },
            "65580": { "city" : "VICHY", "state" : "MO", "county" : "MARIES" },"65582": { "city" : "VIENNA", "state" : "MO", "county" : "MARIES" },
            "65583": { "city" : "WAYNESVILLE", "state" : "MO", "county" : "PULASKI" },
            "65584": { "city" : "SAINT ROBERT", "state" : "MO", "county" : "PULASKI" },
            "65588": { "city" : "WINONA", "state" : "MO", "county" : "SHANNON" },
            "65589": { "city" : "YUKON", "state" : "MO", "county" : "TEXAS" },"65590": { "city" : "LONG LANE", "state" : "MO", "county" : "DALLAS" },
            "65591": { "city" : "MONTREAL", "state" : "MO", "county" : "CAMDEN" },
            "65601": { "city" : "ALDRICH", "state" : "MO", "county" : "POLK" },"65603": { "city" : "ARCOLA", "state" : "MO", "county" : "DADE" },
            "65604": { "city" : "ASH GROVE", "state" : "MO", "county" : "GREENE" },
            "65605": { "city" : "AURORA", "state" : "MO", "county" : "LAWRENCE" },
            "65606": { "city" : "ALTON", "state" : "MO", "county" : "OREGON" },"65608": { "city" : "AVA", "state" : "MO", "county" : "DOUGLAS" },
            "65609": { "city" : "BAKERSFIELD", "state" : "MO", "county" : "OZARK" },
            "65610": { "city" : "BILLINGS", "state" : "MO", "county" : "CHRISTIAN" },
            "65611": { "city" : "BLUE EYE", "state" : "MO", "county" : "STONE" },
            "65612": { "city" : "BOIS D ARC", "state" : "MO", "county" : "GREENE" },
            "65613": { "city" : "BOLIVAR", "state" : "MO", "county" : "POLK" },"65614": { "city" : "BRADLEYVILLE", "state" : "MO", "county" : "TANEY" },
            "65615": { "city" : "BRANSON", "state" : "MO", "county" : "TANEY" },"65616": { "city" : "BRANSON", "state" : "MO", "county" : "TANEY" },
            "65617": { "city" : "BRIGHTON", "state" : "MO", "county" : "POLK" },"65618": { "city" : "BRIXEY", "state" : "MO", "county" : "OZARK" },
            "65619": { "city" : "BROOKLINE", "state" : "MO", "county" : "GREENE" },
            "65620": { "city" : "BRUNER", "state" : "MO", "county" : "CHRISTIAN" },
            "65622": { "city" : "BUFFALO", "state" : "MO", "county" : "DALLAS" },
            "65623": { "city" : "BUTTERFLD", "state" : "MO", "county" : "BARRY" },
            "65624": { "city" : "CAPE FAIR", "state" : "MO", "county" : "STONE" },
            "65625": { "city" : "CASSVILLE", "state" : "MO", "county" : "BARRY" },
            "65626": { "city" : "CAULFIELD", "state" : "MO", "county" : "HOWELL" },
            "65627": { "city" : "CEDARCREEK", "state" : "MO", "county" : "TANEY" },
            "65629": { "city" : "CHADWICK", "state" : "MO", "county" : "CHRISTIAN" },
            "65630": { "city" : "CHESTNUTRIDGE", "state" : "MO", "county" : "CHRISTIAN" },
            "65631": { "city" : "CLEVER", "state" : "MO", "county" : "CHRISTIAN" },
            "65632": { "city" : "CONWAY", "state" : "MO", "county" : "LACLEDE" },
            "65633": { "city" : "CRANE", "state" : "MO", "county" : "STONE" },"65634": { "city" : "CROSS TIMBERS", "state" : "MO", "county" : "HICKORY" },
            "65635": { "city" : "DADEVILLE", "state" : "MO", "county" : "DADE" },
            "65636": { "city" : "DIGGINS", "state" : "MO", "county" : "WEBSTER" },
            "65637": { "city" : "DORA", "state" : "MO", "county" : "OZARK" },"65638": { "city" : "DRURY", "state" : "MO", "county" : "DOUGLAS" },
            "65640": { "city" : "DUNNEGAN", "state" : "MO", "county" : "POLK" },"65641": { "city" : "EAGLE ROCK", "state" : "MO", "county" : "BARRY" },
            "65644": { "city" : "ELKLAND", "state" : "MO", "county" : "DALLAS" },
            "65646": { "city" : "EVERTON", "state" : "MO", "county" : "DADE" },"65647": { "city" : "EXETER", "state" : "MO", "county" : "BARRY" },
            "65648": { "city" : "FAIR GROVE", "state" : "MO", "county" : "GREENE" },
            "65649": { "city" : "FAIR PLAY", "state" : "MO", "county" : "POLK" },
            "65650": { "city" : "FLEMINGTON", "state" : "MO", "county" : "POLK" },
            "65652": { "city" : "FORDLAND", "state" : "MO", "county" : "WEBSTER" },
            "65653": { "city" : "FORSYTH", "state" : "MO", "county" : "TANEY" },"65654": { "city" : "FREISTATT", "state" : "MO", "county" : "LAWRENCE" },
            "65655": { "city" : "GAINESVILLE", "state" : "MO", "county" : "OZARK" },
            "65656": { "city" : "GALENA", "state" : "MO", "county" : "STONE" },"65658": { "city" : "GOLDEN", "state" : "MO", "county" : "BARRY" },
            "65660": { "city" : "GRAFF", "state" : "MO", "county" : "WRIGHT" },"65661": { "city" : "GREENFIELD", "state" : "MO", "county" : "DADE" },
            "65662": { "city" : "GROVESPRING", "state" : "MO", "county" : "WRIGHT" },
            "65663": { "city" : "HALF WAY", "state" : "MO", "county" : "POLK" },"65664": { "city" : "HALLTOWN", "state" : "MO", "county" : "LAWRENCE" },
            "65666": { "city" : "HARDENVILLE", "state" : "MO", "county" : "OZARK" },
            "65667": { "city" : "HARTVILLE", "state" : "MO", "county" : "WRIGHT" },
            "65668": { "city" : "HERMITAGE", "state" : "MO", "county" : "HICKORY" },
            "65669": { "city" : "HIGHLANDVILLE", "state" : "MO", "county" : "CHRISTIAN" },
            "65672": { "city" : "HOLLISTER", "state" : "MO", "county" : "TANEY" },
            "65673": { "city" : "HOLLISTER", "state" : "MO", "county" : "TANEY" },
            "65674": { "city" : "HUMANSVILLE", "state" : "MO", "county" : "POLK" },
            "65675": { "city" : "HURLEY", "state" : "MO", "county" : "STONE" },"65676": { "city" : "ISABELLA", "state" : "MO", "county" : "OZARK" },
            "65679": { "city" : "KIRBYVILLE", "state" : "MO", "county" : "TANEY" },
            "65680": { "city" : "KISSEE MILLS", "state" : "MO", "county" : "TANEY" },
            "65681": { "city" : "LAMPE", "state" : "MO", "county" : "STONE" },"65682": { "city" : "LOCKWOOD", "state" : "MO", "county" : "DADE" },
            "65685": { "city" : "LOUISBURG", "state" : "MO", "county" : "DALLAS" },
            "65686": { "city" : "KIMBERLING CITY", "state" : "MO", "county" : "STONE" },
            "65688": { "city" : "BRANDSVILLE", "state" : "MO", "county" : "HOWELL" },
            "65689": { "city" : "CABOOL", "state" : "MO", "county" : "TEXAS" },"65690": { "city" : "COUCH", "state" : "MO", "county" : "OREGON" },
            "65692": { "city" : "KOSHKONONG", "state" : "MO", "county" : "OREGON" },
            "65702": { "city" : "MACOMB", "state" : "MO", "county" : "WRIGHT" },"65704": { "city" : "MANSFIELD", "state" : "MO", "county" : "WRIGHT" },
            "65705": { "city" : "MARIONVILLE", "state" : "MO", "county" : "LAWRENCE" },
            "65706": { "city" : "MARSHFIELD", "state" : "MO", "county" : "WEBSTER" },
            "65707": { "city" : "MILLER", "state" : "MO", "county" : "LAWRENCE" },
            "65708": { "city" : "MONETT", "state" : "MO", "county" : "BARRY" },"65710": { "city" : "MORRISVILLE", "state" : "MO", "county" : "POLK" },
            "65711": { "city" : "MOUNTAIN GROVE", "state" : "MO", "county" : "WRIGHT" },
            "65712": { "city" : "MOUNT VERNON", "state" : "MO", "county" : "LAWRENCE" },
            "65713": { "city" : "NIANGUA", "state" : "MO", "county" : "WEBSTER" },
            "65714": { "city" : "NIXA", "state" : "MO", "county" : "CHRISTIAN" },
            "65715": { "city" : "NOBLE", "state" : "MO", "county" : "OZARK" },"65717": { "city" : "NORWOOD", "state" : "MO", "county" : "WRIGHT" },
            "65720": { "city" : "OLDFIELD", "state" : "MO", "county" : "CHRISTIAN" },
            "65721": { "city" : "OZARK", "state" : "MO", "county" : "CHRISTIAN" },
            "65722": { "city" : "PHILLIPSBURG", "state" : "MO", "county" : "LACLEDE" },
            "65723": { "city" : "PIERCE CITY", "state" : "MO", "county" : "LAWRENCE" },
            "65724": { "city" : "PITTSBURG", "state" : "MO", "county" : "HICKORY" },
            "65725": { "city" : "PLEASANT HOPE", "state" : "MO", "county" : "GREENE" },
            "65726": { "city" : "POINT LOOKOUT", "state" : "MO", "county" : "TANEY" },
            "65727": { "city" : "POLK", "state" : "MO", "county" : "POLK" },"65728": { "city" : "PONCE DE LEON", "state" : "MO", "county" : "STONE" },
            "65729": { "city" : "PONTIAC", "state" : "MO", "county" : "OZARK" },"65730": { "city" : "POWELL", "state" : "MO", "county" : "MCDONALD" },
            "65731": { "city" : "POWERSITE", "state" : "MO", "county" : "TANEY" },
            "65732": { "city" : "PRESTON", "state" : "MO", "county" : "HICKORY" },
            "65733": { "city" : "PROTEM", "state" : "MO", "county" : "TANEY" },"65734": { "city" : "PURDY", "state" : "MO", "county" : "BARRY" },
            "65735": { "city" : "QUINCY", "state" : "MO", "county" : "HICKORY" },
            "65737": { "city" : "REEDS SPRING", "state" : "MO", "county" : "STONE" },
            "65738": { "city" : "REPUBLIC", "state" : "MO", "county" : "GREENE" },
            "65739": { "city" : "RIDGEDALE", "state" : "MO", "county" : "TANEY" },
            "65740": { "city" : "ROCKAWAY BEACH", "state" : "MO", "county" : "TANEY" },
            "65741": { "city" : "ROCKBRIDGE", "state" : "MO", "county" : "OZARK" },
            "65742": { "city" : "ROGERSVILLE", "state" : "MO", "county" : "WEBSTER" },
            "65745": { "city" : "SELIGMAN", "state" : "MO", "county" : "BARRY" },
            "65746": { "city" : "SEYMOUR", "state" : "MO", "county" : "WEBSTER" },
            "65747": { "city" : "SHELL KNOB", "state" : "MO", "county" : "BARRY" },
            "65752": { "city" : "SOUTH GREENFIELD", "state" : "MO", "county" : "DADE" },
            "65753": { "city" : "SPARTA", "state" : "MO", "county" : "CHRISTIAN" },
            "65754": { "city" : "SPOKANE", "state" : "MO", "county" : "CHRISTIAN" },
            "65755": { "city" : "SQUIRES", "state" : "MO", "county" : "DOUGLAS" },
            "65756": { "city" : "STOTTS CITY", "state" : "MO", "county" : "LAWRENCE" },
            "65757": { "city" : "STRAFFORD", "state" : "MO", "county" : "GREENE" },
            "65759": { "city" : "TANEYVILLE", "state" : "MO", "county" : "TANEY" },
            "65760": { "city" : "TECUMSEH", "state" : "MO", "county" : "OZARK" },
            "65761": { "city" : "THEODOSIA", "state" : "MO", "county" : "OZARK" },
            "65762": { "city" : "THORNFIELD", "state" : "MO", "county" : "OZARK" },
            "65764": { "city" : "TUNAS", "state" : "MO", "county" : "DALLAS" },"65765": { "city" : "TURNERS", "state" : "MO", "county" : "GREENE" },
            "65767": { "city" : "URBANA", "state" : "MO", "county" : "DALLAS" },"65768": { "city" : "VANZANT", "state" : "MO", "county" : "DOUGLAS" },
            "65769": { "city" : "VERONA", "state" : "MO", "county" : "LAWRENCE" },
            "65770": { "city" : "WALNUT GROVE", "state" : "MO", "county" : "GREENE" },
            "65771": { "city" : "WALNUT SHADE", "state" : "MO", "county" : "TANEY" },
            "65772": { "city" : "WASHBURN", "state" : "MO", "county" : "BARRY" },
            "65773": { "city" : "WASOLA", "state" : "MO", "county" : "OZARK" },"65774": { "city" : "WEAUBLEAU", "state" : "MO", "county" : "HICKORY" },
            "65775": { "city" : "WEST PLAINS", "state" : "MO", "county" : "HOWELL" },
            "65776": { "city" : "SOUTH FORK", "state" : "MO", "county" : "HOWELL" },
            "65777": { "city" : "MOODY", "state" : "MO", "county" : "HOWELL" },"65778": { "city" : "MYRTLE", "state" : "MO", "county" : "OREGON" },
            "65779": { "city" : "WHEATLAND", "state" : "MO", "county" : "HICKORY" },
            "65781": { "city" : "WILLARD", "state" : "MO", "county" : "GREENE" },
            "65783": { "city" : "WINDYVILLE", "state" : "MO", "county" : "DALLAS" },
            "65784": { "city" : "ZANONI", "state" : "MO", "county" : "OZARK" },"65785": { "city" : "STOCKTON", "state" : "MO", "county" : "CEDAR" },
            "65786": { "city" : "MACKS CREEK", "state" : "MO", "county" : "CAMDEN" },
            "65787": { "city" : "ROACH", "state" : "MO", "county" : "CAMDEN" },"65788": { "city" : "PEACE VALLEY", "state" : "MO", "county" : "HOWELL" },
            "65789": { "city" : "POMONA", "state" : "MO", "county" : "HOWELL" },"65790": { "city" : "POTTERSVILLE", "state" : "MO", "county" : "HOWELL" },
            "65791": { "city" : "THAYER", "state" : "MO", "county" : "OREGON" },"65793": { "city" : "WILLOW SPRINGS", "state" : "MO", "county" : "HOWELL" },
            "65801": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65802": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65803": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65804": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65805": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65806": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65807": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65808": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65809": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65810": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65814": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65897": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "65898": { "city" : "SPRINGFIELD", "state" : "MO", "county" : "GREENE" },
            "66002": { "city" : "ATCHISON", "state" : "KS", "county" : "ATCHISON" },
            "66006": { "city" : "BALDWIN CITY", "state" : "KS", "county" : "DOUGLAS" },
            "66007": { "city" : "BASEHOR", "state" : "KS", "county" : "LEAVENWORTH" },
            "66008": { "city" : "BENDENA", "state" : "KS", "county" : "DONIPHAN" },
            "66010": { "city" : "BLUE MOUND", "state" : "KS", "county" : "LINN" },
            "66012": { "city" : "BONNER SPRINGS", "state" : "KS", "county" : "WYANDOTTE" },
            "66013": { "city" : "BUCYRUS", "state" : "KS", "county" : "MIAMI" },"66014": { "city" : "CENTERVILLE", "state" : "KS", "county" : "ANDERSON" },
            "66015": { "city" : "COLONY", "state" : "KS", "county" : "ANDERSON" },
            "66017": { "city" : "DENTON", "state" : "KS", "county" : "DONIPHAN" },
            "66018": { "city" : "DE SOTO", "state" : "KS", "county" : "JOHNSON" },
            "66019": { "city" : "CLEARVIEW CITY", "state" : "KS", "county" : "JOHNSON" },
            "66020": { "city" : "EASTON", "state" : "KS", "county" : "LEAVENWORTH" },
            "66021": { "city" : "EDGERTON", "state" : "KS", "county" : "JOHNSON" },
            "66023": { "city" : "EFFINGHAM", "state" : "KS", "county" : "ATCHISON" },
            "66024": { "city" : "ELWOOD", "state" : "KS", "county" : "DONIPHAN" },
            "66025": { "city" : "EUDORA", "state" : "KS", "county" : "DOUGLAS" },
            "66026": { "city" : "FONTANA", "state" : "KS", "county" : "MIAMI" },"66027": { "city" : "FORT LEAVENWORTH", "state" : "KS", "county" : "LEAVENWORTH" },
            "66030": { "city" : "GARDNER", "state" : "KS", "county" : "JOHNSON" },
            "66031": { "city" : "NEW CENTURY", "state" : "KS", "county" : "JOHNSON" },
            "66032": { "city" : "GARNETT", "state" : "KS", "county" : "ANDERSON" },
            "66033": { "city" : "GREELEY", "state" : "KS", "county" : "ANDERSON" },
            "66035": { "city" : "HIGHLAND", "state" : "KS", "county" : "DONIPHAN" },
            "66036": { "city" : "HILLSDALE", "state" : "KS", "county" : "MIAMI" },
            "66039": { "city" : "KINCAID", "state" : "KS", "county" : "ANDERSON" },
            "66040": { "city" : "LACYGNE", "state" : "KS", "county" : "LINN" },"66041": { "city" : "LANCASTER", "state" : "KS", "county" : "ATCHISON" },
            "66042": { "city" : "LANE", "state" : "KS", "county" : "FRANKLIN" },"66043": { "city" : "LANSING", "state" : "KS", "county" : "LEAVENWORTH" },
            "66044": { "city" : "LAWRENCE", "state" : "KS", "county" : "DOUGLAS" },
            "66045": { "city" : "LAWRENCE", "state" : "KS", "county" : "DOUGLAS" },
            "66046": { "city" : "LAWRENCE", "state" : "KS", "county" : "DOUGLAS" },
            "66047": { "city" : "LAWRENCE", "state" : "KS", "county" : "DOUGLAS" },
            "66048": { "city" : "LEAVENWORTH", "state" : "KS", "county" : "LEAVENWORTH" },
            "66049": { "city" : "LAWRENCE", "state" : "KS", "county" : "DOUGLAS" },
            "66050": { "city" : "LECOMPTON", "state" : "KS", "county" : "SHAWNEE" },
            "66051": { "city" : "OLATHE", "state" : "KS", "county" : "JOHNSON" },
            "66052": { "city" : "LINWOOD", "state" : "KS", "county" : "LEAVENWORTH" },
            "66053": { "city" : "LOUISBURG", "state" : "KS", "county" : "MIAMI" },
            "66054": { "city" : "MC LOUTH", "state" : "KS", "county" : "JEFFERSON" },
            "66056": { "city" : "MOUND CITY", "state" : "KS", "county" : "LINN" },
            "66058": { "city" : "MUSCOTAH", "state" : "KS", "county" : "ATCHISON" },
            "66060": { "city" : "NORTONVILLE", "state" : "KS", "county" : "JEFFERSON" },
            "66061": { "city" : "OLATHE", "state" : "KS", "county" : "JOHNSON" },
            "66062": { "city" : "OLATHE", "state" : "KS", "county" : "JOHNSON" },
            "66063": { "city" : "OLATHE", "state" : "KS", "county" : "JOHNSON" },
            "66064": { "city" : "OSAWATOMIE", "state" : "KS", "county" : "MIAMI" },
            "66066": { "city" : "OSKALOOSA", "state" : "KS", "county" : "JEFFERSON" },
            "66067": { "city" : "OTTAWA", "state" : "KS", "county" : "FRANKLIN" },
            "66070": { "city" : "OZAWKIE", "state" : "KS", "county" : "JEFFERSON" },
            "66071": { "city" : "PAOLA", "state" : "KS", "county" : "MIAMI" },"66072": { "city" : "PARKER", "state" : "KS", "county" : "LINN" },
            "66073": { "city" : "PERRY", "state" : "KS", "county" : "JEFFERSON" },
            "66075": { "city" : "PLEASANTON", "state" : "KS", "county" : "LINN" },
            "66076": { "city" : "POMONA", "state" : "KS", "county" : "FRANKLIN" },
            "66078": { "city" : "PRINCETON", "state" : "KS", "county" : "FRANKLIN" },
            "66079": { "city" : "RANTOUL", "state" : "KS", "county" : "FRANKLIN" },
            "66080": { "city" : "RICHMOND", "state" : "KS", "county" : "FRANKLIN" },
            "66083": { "city" : "SPRING HILL", "state" : "KS", "county" : "JOHNSON" },
            "66085": { "city" : "STILWELL", "state" : "KS", "county" : "JOHNSON" },
            "66086": { "city" : "TONGANOXIE", "state" : "KS", "county" : "LEAVENWORTH" },
            "66087": { "city" : "TROY", "state" : "KS", "county" : "DONIPHAN" },"66088": { "city" : "VALLEY FALLS", "state" : "KS", "county" : "JEFFERSON" },
            "66090": { "city" : "WATHENA", "state" : "KS", "county" : "DONIPHAN" },
            "66091": { "city" : "WELDA", "state" : "KS", "county" : "ANDERSON" },
            "66092": { "city" : "WELLSVILLE", "state" : "KS", "county" : "FRANKLIN" },
            "66093": { "city" : "WESTPHALIA", "state" : "KS", "county" : "ANDERSON" },
            "66094": { "city" : "WHITE CLOUD", "state" : "KS", "county" : "DONIPHAN" },
            "66095": { "city" : "WILLIAMSBURG", "state" : "KS", "county" : "FRANKLIN" },
            "66097": { "city" : "WINCHESTER", "state" : "KS", "county" : "JEFFERSON" },
            "66101": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66102": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66103": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66104": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66105": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66106": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66109": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66110": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66111": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66112": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66113": { "city" : "EDWARDSVILLE", "state" : "KS", "county" : "WYANDOTTE" },
            "66115": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66117": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66118": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66119": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66160": { "city" : "KANSAS CITY", "state" : "KS", "county" : "WYANDOTTE" },
            "66201": { "city" : "MISSION", "state" : "KS", "county" : "JOHNSON" },
            "66202": { "city" : "MISSION", "state" : "KS", "county" : "JOHNSON" },
            "66203": { "city" : "SHAWNEE", "state" : "KS", "county" : "JOHNSON" },
            "66204": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66205": { "city" : "MISSION", "state" : "KS", "county" : "JOHNSON" },
            "66206": { "city" : "LEAWOOD", "state" : "KS", "county" : "JOHNSON" },
            "66207": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66208": { "city" : "PRAIRIE VILLAGE", "state" : "KS", "county" : "JOHNSON" },
            "66209": { "city" : "LEAWOOD", "state" : "KS", "county" : "JOHNSON" },
            "66210": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66211": { "city" : "LEAWOOD", "state" : "KS", "county" : "JOHNSON" },
            "66212": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66213": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66214": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66215": { "city" : "LENEXA", "state" : "KS", "county" : "JOHNSON" },
            "66216": { "city" : "SHAWNEE", "state" : "KS", "county" : "JOHNSON" },
            "66217": { "city" : "SHAWNEE", "state" : "KS", "county" : "JOHNSON" },
            "66218": { "city" : "SHAWNEE", "state" : "KS", "county" : "JOHNSON" },
            "66219": { "city" : "LENEXA", "state" : "KS", "county" : "JOHNSON" },
            "66220": { "city" : "LENEXA", "state" : "KS", "county" : "JOHNSON" },
            "66221": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66222": { "city" : "MISSION", "state" : "KS", "county" : "JOHNSON" },
            "66223": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66224": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66225": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66226": { "city" : "SHAWNEE", "state" : "KS", "county" : "JOHNSON" },
            "66227": { "city" : "LENEXA", "state" : "KS", "county" : "JOHNSON" },
            "66250": { "city" : "SHAWNEE MISSION", "state" : "KS", "county" : "JOHNSON" },
            "66251": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66282": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66283": { "city" : "OVERLAND PARK", "state" : "KS", "county" : "JOHNSON" },
            "66285": { "city" : "LENEXA", "state" : "KS", "county" : "JOHNSON" },
            "66286": { "city" : "SHAWNEE", "state" : "KS", "county" : "JOHNSON" },
            "66401": { "city" : "ALMA", "state" : "KS", "county" : "WABAUNSEE" },
            "66402": { "city" : "AUBURN", "state" : "KS", "county" : "SHAWNEE" },
            "66403": { "city" : "AXTELL", "state" : "KS", "county" : "MARSHALL" },
            "66404": { "city" : "BAILEYVILLE", "state" : "KS", "county" : "NEMAHA" },
            "66406": { "city" : "BEATTIE", "state" : "KS", "county" : "MARSHALL" },
            "66407": { "city" : "BELVUE", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66408": { "city" : "BERN", "state" : "KS", "county" : "NEMAHA" },"66409": { "city" : "BERRYTON", "state" : "KS", "county" : "SHAWNEE" },
            "66411": { "city" : "BLUE RAPIDS", "state" : "KS", "county" : "MARSHALL" },
            "66412": { "city" : "BREMEN", "state" : "KS", "county" : "MARSHALL" },
            "66413": { "city" : "BURLINGAME", "state" : "KS", "county" : "OSAGE" },
            "66414": { "city" : "CARBONDALE", "state" : "KS", "county" : "OSAGE" },
            "66415": { "city" : "CENTRALIA", "state" : "KS", "county" : "NEMAHA" },
            "66416": { "city" : "CIRCLEVILLE", "state" : "KS", "county" : "JACKSON" },
            "66417": { "city" : "CORNING", "state" : "KS", "county" : "NEMAHA" },
            "66418": { "city" : "DELIA", "state" : "KS", "county" : "JACKSON" },"66419": { "city" : "DENISON", "state" : "KS", "county" : "JACKSON" },
            "66420": { "city" : "DOVER", "state" : "KS", "county" : "SHAWNEE" },"66422": { "city" : "EMMETT", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66423": { "city" : "ESKRIDGE", "state" : "KS", "county" : "WABAUNSEE" },
            "66424": { "city" : "EVEREST", "state" : "KS", "county" : "BROWN" },"66425": { "city" : "FAIRVIEW", "state" : "KS", "county" : "BROWN" },
            "66427": { "city" : "FRANKFORT", "state" : "KS", "county" : "MARSHALL" },
            "66428": { "city" : "GOFF", "state" : "KS", "county" : "NEMAHA" },"66429": { "city" : "GRANTVILLE", "state" : "KS", "county" : "JEFFERSON" },
            "66431": { "city" : "HARVEYVILLE", "state" : "KS", "county" : "WABAUNSEE" },
            "66432": { "city" : "HAVENSVILLE", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66434": { "city" : "HIAWATHA", "state" : "KS", "county" : "BROWN" },
            "66436": { "city" : "HOLTON", "state" : "KS", "county" : "JACKSON" },
            "66438": { "city" : "HOME", "state" : "KS", "county" : "MARSHALL" },"66439": { "city" : "HORTON", "state" : "KS", "county" : "BROWN" },
            "66440": { "city" : "HOYT", "state" : "KS", "county" : "JACKSON" },"66441": { "city" : "JUNCTION CITY", "state" : "KS", "county" : "GEARY" },
            "66442": { "city" : "FORT RILEY", "state" : "KS", "county" : "GEARY" },
            "66449": { "city" : "LEONARDVILLE", "state" : "KS", "county" : "RILEY" },
            "66451": { "city" : "LYNDON", "state" : "KS", "county" : "OSAGE" },"66501": { "city" : "MC FARLAND", "state" : "KS", "county" : "WABAUNSEE" },
            "66502": { "city" : "MANHATTAN", "state" : "KS", "county" : "RILEY" },
            "66503": { "city" : "MANHATTAN", "state" : "KS", "county" : "RILEY" },
            "66505": { "city" : "MANHATTAN", "state" : "KS", "county" : "RILEY" },
            "66506": { "city" : "MANHATTAN", "state" : "KS", "county" : "RILEY" },
            "66507": { "city" : "MAPLE HILL", "state" : "KS", "county" : "WABAUNSEE" },
            "66508": { "city" : "MARYSVILLE", "state" : "KS", "county" : "MARSHALL" },
            "66509": { "city" : "MAYETTA", "state" : "KS", "county" : "JACKSON" },
            "66510": { "city" : "MELVERN", "state" : "KS", "county" : "OSAGE" },"66512": { "city" : "MERIDEN", "state" : "KS", "county" : "JEFFERSON" },
            "66514": { "city" : "MILFORD", "state" : "KS", "county" : "GEARY" },"66515": { "city" : "MORRILL", "state" : "KS", "county" : "BROWN" },
            "66516": { "city" : "NETAWAKA", "state" : "KS", "county" : "JACKSON" },
            "66517": { "city" : "OGDEN", "state" : "KS", "county" : "RILEY" },"66518": { "city" : "OKETO", "state" : "KS", "county" : "MARSHALL" },
            "66520": { "city" : "OLSBURG", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66521": { "city" : "ONAGA", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66523": { "city" : "OSAGE CITY", "state" : "KS", "county" : "OSAGE" },
            "66524": { "city" : "OVERBROOK", "state" : "KS", "county" : "OSAGE" },
            "66526": { "city" : "PAXICO", "state" : "KS", "county" : "WABAUNSEE" },
            "66527": { "city" : "POWHATTAN", "state" : "KS", "county" : "BROWN" },
            "66528": { "city" : "QUENEMO", "state" : "KS", "county" : "OSAGE" },"66531": { "city" : "RILEY", "state" : "KS", "county" : "RILEY" },
            "66532": { "city" : "ROBINSON", "state" : "KS", "county" : "BROWN" },
            "66533": { "city" : "ROSSVILLE", "state" : "KS", "county" : "SHAWNEE" },
            "66534": { "city" : "SABETHA", "state" : "KS", "county" : "NEMAHA" },
            "66535": { "city" : "SAINT GEORGE", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66536": { "city" : "SAINT MARYS", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66537": { "city" : "SCRANTON", "state" : "KS", "county" : "OSAGE" },
            "66538": { "city" : "SENECA", "state" : "KS", "county" : "NEMAHA" },"66539": { "city" : "SILVER LAKE", "state" : "KS", "county" : "SHAWNEE" },
            "66540": { "city" : "SOLDIER", "state" : "KS", "county" : "JACKSON" },
            "66541": { "city" : "SUMMERFIELD", "state" : "KS", "county" : "MARSHALL" },
            "66542": { "city" : "TECUMSEH", "state" : "KS", "county" : "SHAWNEE" },
            "66543": { "city" : "VASSAR", "state" : "KS", "county" : "OSAGE" },"66544": { "city" : "VERMILLION", "state" : "KS", "county" : "MARSHALL" },
            "66546": { "city" : "WAKARUSA", "state" : "KS", "county" : "SHAWNEE" },
            "66547": { "city" : "WAMEGO", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66548": { "city" : "WATERVILLE", "state" : "KS", "county" : "MARSHALL" },
            "66549": { "city" : "WESTMORELAND", "state" : "KS", "county" : "POTTAWATOMIE" },
            "66550": { "city" : "WETMORE", "state" : "KS", "county" : "NEMAHA" },
            "66552": { "city" : "WHITING", "state" : "KS", "county" : "JACKSON" },
            "66554": { "city" : "RANDOLPH", "state" : "KS", "county" : "RILEY" },
            "66601": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66603": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66604": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66605": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66606": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66607": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66608": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66609": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66610": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66611": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66612": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66614": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66615": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66616": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66617": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66618": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66619": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66621": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66622": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66624": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66629": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66636": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66667": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66683": { "city" : "TOPEKA", "state" : "KS", "county" : "SHAWNEE" },
            "66701": { "city" : "FORT SCOTT", "state" : "KS", "county" : "BOURBON" },
            "66710": { "city" : "ALTOONA", "state" : "KS", "county" : "WILSON" },
            "66711": { "city" : "ARCADIA", "state" : "KS", "county" : "CRAWFORD" },
            "66712": { "city" : "ARMA", "state" : "KS", "county" : "CRAWFORD" },"66713": { "city" : "BAXTER SPRINGS", "state" : "KS", "county" : "CHEROKEE" },
            "66714": { "city" : "BENEDICT", "state" : "KS", "county" : "WILSON" },
            "66716": { "city" : "BRONSON", "state" : "KS", "county" : "BOURBON" },
            "66717": { "city" : "BUFFALO", "state" : "KS", "county" : "WILSON" },
            "66720": { "city" : "CHANUTE", "state" : "KS", "county" : "NEOSHO" },
            "66724": { "city" : "CHEROKEE", "state" : "KS", "county" : "CRAWFORD" },
            "66725": { "city" : "COLUMBUS", "state" : "KS", "county" : "CHEROKEE" },
            "66728": { "city" : "CRESTLINE", "state" : "KS", "county" : "CHEROKEE" },
            "66732": { "city" : "ELSMORE", "state" : "KS", "county" : "ALLEN" },"66733": { "city" : "ERIE", "state" : "KS", "county" : "NEOSHO" },
            "66734": { "city" : "FARLINGTON", "state" : "KS", "county" : "CRAWFORD" },
            "66735": { "city" : "FRANKLIN", "state" : "KS", "county" : "CRAWFORD" },
            "66736": { "city" : "FREDONIA", "state" : "KS", "county" : "WILSON" },
            "66738": { "city" : "FULTON", "state" : "KS", "county" : "BOURBON" },
            "66739": { "city" : "GALENA", "state" : "KS", "county" : "CHEROKEE" },
            "66740": { "city" : "GALESBURG", "state" : "KS", "county" : "NEOSHO" },
            "66741": { "city" : "GARLAND", "state" : "KS", "county" : "BOURBON" },
            "66742": { "city" : "GAS", "state" : "KS", "county" : "ALLEN" },"66743": { "city" : "GIRARD", "state" : "KS", "county" : "CRAWFORD" },
            "66746": { "city" : "HEPLER", "state" : "KS", "county" : "CRAWFORD" },
            "66748": { "city" : "HUMBOLDT", "state" : "KS", "county" : "ALLEN" },
            "66749": { "city" : "IOLA", "state" : "KS", "county" : "ALLEN" },"66751": { "city" : "LA HARPE", "state" : "KS", "county" : "ALLEN" },
            "66753": { "city" : "MC CUNE", "state" : "KS", "county" : "CRAWFORD" },
            "66754": { "city" : "MAPLETON", "state" : "KS", "county" : "BOURBON" },
            "66755": { "city" : "MORAN", "state" : "KS", "county" : "ALLEN" },"66756": { "city" : "MULBERRY", "state" : "KS", "county" : "CRAWFORD" },
            "66757": { "city" : "NEODESHA", "state" : "KS", "county" : "WILSON" },
            "66758": { "city" : "NEOSHO FALLS", "state" : "KS", "county" : "COFFEY" },
            "66760": { "city" : "OPOLIS", "state" : "KS", "county" : "CRAWFORD" },
            "66761": { "city" : "PIQUA", "state" : "KS", "county" : "WOODSON" },"66762": { "city" : "PITTSBURG", "state" : "KS", "county" : "CRAWFORD" },
            "66763": { "city" : "FRONTENAC", "state" : "KS", "county" : "CRAWFORD" },
            "66767": { "city" : "PRESCOTT", "state" : "KS", "county" : "LINN" },"66769": { "city" : "REDFIELD", "state" : "KS", "county" : "BOURBON" },
            "66770": { "city" : "RIVERTON", "state" : "KS", "county" : "CHEROKEE" },
            "66771": { "city" : "SAINT PAUL", "state" : "KS", "county" : "NEOSHO" },
            "66772": { "city" : "SAVONBURG", "state" : "KS", "county" : "ALLEN" },
            "66773": { "city" : "SCAMMON", "state" : "KS", "county" : "CHEROKEE" },
            "66775": { "city" : "STARK", "state" : "KS", "county" : "NEOSHO" },"66776": { "city" : "THAYER", "state" : "KS", "county" : "NEOSHO" },
            "66777": { "city" : "TORONTO", "state" : "KS", "county" : "WOODSON" },
            "66778": { "city" : "TREECE", "state" : "KS", "county" : "CHEROKEE" },
            "66779": { "city" : "UNIONTOWN", "state" : "KS", "county" : "BOURBON" },
            "66780": { "city" : "WALNUT", "state" : "KS", "county" : "CRAWFORD" },
            "66781": { "city" : "WEIR", "state" : "KS", "county" : "CHEROKEE" },"66782": { "city" : "WEST MINERAL", "state" : "KS", "county" : "CHEROKEE" },
            "66783": { "city" : "YATES CENTER", "state" : "KS", "county" : "WOODSON" },
            "66801": { "city" : "EMPORIA", "state" : "KS", "county" : "LYON" },"66830": { "city" : "ADMIRE", "state" : "KS", "county" : "LYON" },
            "66833": { "city" : "ALLEN", "state" : "KS", "county" : "LYON" },"66834": { "city" : "ALTA VISTA", "state" : "KS", "county" : "WABAUNSEE" },
            "66835": { "city" : "AMERICUS", "state" : "KS", "county" : "LYON" },"66838": { "city" : "BURDICK", "state" : "KS", "county" : "MORRIS" },
            "66839": { "city" : "BURLINGTON", "state" : "KS", "county" : "COFFEY" },
            "66840": { "city" : "BURNS", "state" : "KS", "county" : "MARION" },"66842": { "city" : "CASSODAY", "state" : "KS", "county" : "BUTLER" },
            "66843": { "city" : "CEDAR POINT", "state" : "KS", "county" : "CHASE" },
            "66845": { "city" : "COTTONWOOD FALLS", "state" : "KS", "county" : "CHASE" },
            "66846": { "city" : "COUNCIL GROVE", "state" : "KS", "county" : "MORRIS" },
            "66849": { "city" : "DWIGHT", "state" : "KS", "county" : "MORRIS" },"66850": { "city" : "ELMDALE", "state" : "KS", "county" : "CHASE" },
            "66851": { "city" : "FLORENCE", "state" : "KS", "county" : "MARION" },
            "66852": { "city" : "GRIDLEY", "state" : "KS", "county" : "COFFEY" },
            "66853": { "city" : "HAMILTON", "state" : "KS", "county" : "GREENWOOD" },
            "66854": { "city" : "HARTFORD", "state" : "KS", "county" : "LYON" },"66855": { "city" : "LAMONT", "state" : "KS", "county" : "GREENWOOD" },
            "66856": { "city" : "LEBO", "state" : "KS", "county" : "COFFEY" },"66857": { "city" : "LE ROY", "state" : "KS", "county" : "COFFEY" },
            "66858": { "city" : "LINCOLNVILLE", "state" : "KS", "county" : "MARION" },
            "66859": { "city" : "LOST SPRINGS", "state" : "KS", "county" : "MARION" },
            "66860": { "city" : "MADISON", "state" : "KS", "county" : "GREENWOOD" },
            "66861": { "city" : "MARION", "state" : "KS", "county" : "MARION" },"66862": { "city" : "MATFIELD GREEN", "state" : "KS", "county" : "CHASE" },
            "66864": { "city" : "NEOSHO RAPIDS", "state" : "KS", "county" : "LYON" },
            "66865": { "city" : "OLPE", "state" : "KS", "county" : "LYON" },"66866": { "city" : "PEABODY", "state" : "KS", "county" : "MARION" },
            "66868": { "city" : "READING", "state" : "KS", "county" : "LYON" },"66869": { "city" : "STRONG CITY", "state" : "KS", "county" : "CHASE" },
            "66870": { "city" : "VIRGIL", "state" : "KS", "county" : "GREENWOOD" },
            "66871": { "city" : "WAVERLY", "state" : "KS", "county" : "COFFEY" },
            "66872": { "city" : "WHITE CITY", "state" : "KS", "county" : "MORRIS" },
            "66873": { "city" : "WILSEY", "state" : "KS", "county" : "MORRIS" },"66901": { "city" : "CONCORDIA", "state" : "KS", "county" : "CLOUD" },
            "66930": { "city" : "AGENDA", "state" : "KS", "county" : "REPUBLIC" },
            "66932": { "city" : "ATHOL", "state" : "KS", "county" : "SMITH" },"66933": { "city" : "BARNES", "state" : "KS", "county" : "WASHINGTON" },
            "66935": { "city" : "BELLEVILLE", "state" : "KS", "county" : "REPUBLIC" },
            "66936": { "city" : "BURR OAK", "state" : "KS", "county" : "JEWELL" },
            "66937": { "city" : "CLIFTON", "state" : "KS", "county" : "WASHINGTON" },
            "66938": { "city" : "CLYDE", "state" : "KS", "county" : "CLOUD" },"66939": { "city" : "COURTLAND", "state" : "KS", "county" : "REPUBLIC" },
            "66940": { "city" : "CUBA", "state" : "KS", "county" : "REPUBLIC" },"66941": { "city" : "ESBON", "state" : "KS", "county" : "JEWELL" },
            "66942": { "city" : "FORMOSO", "state" : "KS", "county" : "JEWELL" },
            "66943": { "city" : "GREENLEAF", "state" : "KS", "county" : "WASHINGTON" },
            "66944": { "city" : "HADDAM", "state" : "KS", "county" : "WASHINGTON" },
            "66945": { "city" : "HANOVER", "state" : "KS", "county" : "WASHINGTON" },
            "66948": { "city" : "JAMESTOWN", "state" : "KS", "county" : "CLOUD" },
            "66949": { "city" : "JEWELL", "state" : "KS", "county" : "JEWELL" },"66951": { "city" : "KENSINGTON", "state" : "KS", "county" : "SMITH" },
            "66952": { "city" : "LEBANON", "state" : "KS", "county" : "SMITH" },"66953": { "city" : "LINN", "state" : "KS", "county" : "WASHINGTON" },
            "66955": { "city" : "MAHASKA", "state" : "KS", "county" : "WASHINGTON" },
            "66956": { "city" : "MANKATO", "state" : "KS", "county" : "JEWELL" },
            "66958": { "city" : "MORROWVILLE", "state" : "KS", "county" : "WASHINGTON" },
            "66959": { "city" : "MUNDEN", "state" : "KS", "county" : "REPUBLIC" },
            "66960": { "city" : "NARKA", "state" : "KS", "county" : "REPUBLIC" },
            "66961": { "city" : "NORWAY", "state" : "KS", "county" : "REPUBLIC" },
            "66962": { "city" : "PALMER", "state" : "KS", "county" : "WASHINGTON" },
            "66963": { "city" : "RANDALL", "state" : "KS", "county" : "JEWELL" },
            "66964": { "city" : "REPUBLIC", "state" : "KS", "county" : "REPUBLIC" },
            "66966": { "city" : "SCANDIA", "state" : "KS", "county" : "REPUBLIC" },
            "66967": { "city" : "SMITH CENTER", "state" : "KS", "county" : "SMITH" },
            "66968": { "city" : "WASHINGTON", "state" : "KS", "county" : "WASHINGTON" },
            "66970": { "city" : "WEBBER", "state" : "KS", "county" : "JEWELL" },"67001": { "city" : "ANDALE", "state" : "KS", "county" : "SEDGWICK" },
            "67002": { "city" : "ANDOVER", "state" : "KS", "county" : "BUTLER" },
            "67003": { "city" : "ANTHONY", "state" : "KS", "county" : "HARPER" },
            "67004": { "city" : "ARGONIA", "state" : "KS", "county" : "SUMNER" },
            "67005": { "city" : "ARKANSAS CITY", "state" : "KS", "county" : "COWLEY" },
            "67008": { "city" : "ATLANTA", "state" : "KS", "county" : "COWLEY" },
            "67009": { "city" : "ATTICA", "state" : "KS", "county" : "HARPER" },"67010": { "city" : "AUGUSTA", "state" : "KS", "county" : "BUTLER" },
            "67012": { "city" : "BEAUMONT", "state" : "KS", "county" : "BUTLER" },
            "67013": { "city" : "BELLE PLAINE", "state" : "KS", "county" : "SUMNER" },
            "67016": { "city" : "BENTLEY", "state" : "KS", "county" : "SEDGWICK" },
            "67017": { "city" : "BENTON", "state" : "KS", "county" : "BUTLER" },"67018": { "city" : "BLUFF CITY", "state" : "KS", "county" : "HARPER" },
            "67019": { "city" : "BURDEN", "state" : "KS", "county" : "COWLEY" },"67020": { "city" : "BURRTON", "state" : "KS", "county" : "HARVEY" },
            "67021": { "city" : "BYERS", "state" : "KS", "county" : "PRATT" },"67022": { "city" : "CALDWELL", "state" : "KS", "county" : "SUMNER" },
            "67023": { "city" : "CAMBRIDGE", "state" : "KS", "county" : "COWLEY" },
            "67024": { "city" : "CEDAR VALE", "state" : "KS", "county" : "CHAUTAUQUA" },
            "67025": { "city" : "CHENEY", "state" : "KS", "county" : "SEDGWICK" },
            "67026": { "city" : "CLEARWATER", "state" : "KS", "county" : "SEDGWICK" },
            "67028": { "city" : "COATS", "state" : "KS", "county" : "PRATT" },"67029": { "city" : "COLDWATER", "state" : "KS", "county" : "COMANCHE" },
            "67030": { "city" : "COLWICH", "state" : "KS", "county" : "SEDGWICK" },
            "67031": { "city" : "CONWAY SPRINGS", "state" : "KS", "county" : "SUMNER" },
            "67035": { "city" : "CUNNINGHAM", "state" : "KS", "county" : "KINGMAN" },
            "67036": { "city" : "DANVILLE", "state" : "KS", "county" : "HARPER" },
            "67037": { "city" : "DERBY", "state" : "KS", "county" : "SEDGWICK" },
            "67038": { "city" : "DEXTER", "state" : "KS", "county" : "COWLEY" },"67039": { "city" : "DOUGLASS", "state" : "KS", "county" : "BUTLER" },
            "67041": { "city" : "ELBING", "state" : "KS", "county" : "BUTLER" },"67042": { "city" : "EL DORADO", "state" : "KS", "county" : "BUTLER" },
            "67045": { "city" : "EUREKA", "state" : "KS", "county" : "GREENWOOD" },
            "67047": { "city" : "FALL RIVER", "state" : "KS", "county" : "GREENWOOD" },
            "67049": { "city" : "FREEPORT", "state" : "KS", "county" : "HARPER" },
            "67050": { "city" : "GARDEN PLAIN", "state" : "KS", "county" : "SEDGWICK" },
            "67051": { "city" : "GEUDA SPRINGS", "state" : "KS", "county" : "SUMNER" },
            "67052": { "city" : "GODDARD", "state" : "KS", "county" : "SEDGWICK" },
            "67053": { "city" : "GOESSEL", "state" : "KS", "county" : "MARION" },
            "67054": { "city" : "GREENSBURG", "state" : "KS", "county" : "KIOWA" },
            "67056": { "city" : "HALSTEAD", "state" : "KS", "county" : "HARVEY" },
            "67057": { "city" : "HARDTNER", "state" : "KS", "county" : "BARBER" },
            "67058": { "city" : "HARPER", "state" : "KS", "county" : "HARPER" },"67059": { "city" : "HAVILAND", "state" : "KS", "county" : "KIOWA" },
            "67060": { "city" : "HAYSVILLE", "state" : "KS", "county" : "SEDGWICK" },
            "67061": { "city" : "HAZELTON", "state" : "KS", "county" : "BARBER" },
            "67062": { "city" : "HESSTON", "state" : "KS", "county" : "HARVEY" },
            "67063": { "city" : "HILLSBORO", "state" : "KS", "county" : "MARION" },
            "67065": { "city" : "ISABEL", "state" : "KS", "county" : "BARBER" },"67066": { "city" : "IUKA", "state" : "KS", "county" : "PRATT" },
            "67067": { "city" : "KECHI", "state" : "KS", "county" : "SEDGWICK" },
            "67068": { "city" : "KINGMAN", "state" : "KS", "county" : "KINGMAN" },
            "67070": { "city" : "KIOWA", "state" : "KS", "county" : "BARBER" },"67071": { "city" : "LAKE CITY", "state" : "KS", "county" : "BARBER" },
            "67072": { "city" : "LATHAM", "state" : "KS", "county" : "BUTLER" },"67073": { "city" : "LEHIGH", "state" : "KS", "county" : "MARION" },
            "67074": { "city" : "LEON", "state" : "KS", "county" : "BUTLER" },"67101": { "city" : "MAIZE", "state" : "KS", "county" : "SEDGWICK" },
            "67102": { "city" : "MAPLE CITY", "state" : "KS", "county" : "COWLEY" },
            "67103": { "city" : "MAYFIELD", "state" : "KS", "county" : "SUMNER" },
            "67104": { "city" : "MEDICINE LODGE", "state" : "KS", "county" : "BARBER" },
            "67105": { "city" : "MILAN", "state" : "KS", "county" : "SUMNER" },"67106": { "city" : "MILTON", "state" : "KS", "county" : "SUMNER" },
            "67107": { "city" : "MOUNDRIDGE", "state" : "KS", "county" : "MCPHERSON" },
            "67108": { "city" : "MOUNT HOPE", "state" : "KS", "county" : "SEDGWICK" },
            "67109": { "city" : "MULLINVILLE", "state" : "KS", "county" : "KIOWA" },
            "67110": { "city" : "MULVANE", "state" : "KS", "county" : "SEDGWICK" },
            "67111": { "city" : "MURDOCK", "state" : "KS", "county" : "KINGMAN" },
            "67112": { "city" : "NASHVILLE", "state" : "KS", "county" : "KINGMAN" },
            "67114": { "city" : "NEWTON", "state" : "KS", "county" : "HARVEY" },"67117": { "city" : "NORTH NEWTON", "state" : "KS", "county" : "HARVEY" },
            "67118": { "city" : "NORWICH", "state" : "KS", "county" : "KINGMAN" },
            "67119": { "city" : "OXFORD", "state" : "KS", "county" : "SUMNER" },"67120": { "city" : "PECK", "state" : "KS", "county" : "SUMNER" },
            "67123": { "city" : "POTWIN", "state" : "KS", "county" : "BUTLER" },"67124": { "city" : "PRATT", "state" : "KS", "county" : "PRATT" },
            "67127": { "city" : "PROTECTION", "state" : "KS", "county" : "COMANCHE" },
            "67131": { "city" : "ROCK", "state" : "KS", "county" : "COWLEY" },"67132": { "city" : "ROSALIA", "state" : "KS", "county" : "BUTLER" },
            "67133": { "city" : "ROSE HILL", "state" : "KS", "county" : "BUTLER" },
            "67134": { "city" : "SAWYER", "state" : "KS", "county" : "PRATT" },"67135": { "city" : "SEDGWICK", "state" : "KS", "county" : "HARVEY" },
            "67137": { "city" : "SEVERY", "state" : "KS", "county" : "GREENWOOD" },
            "67138": { "city" : "SHARON", "state" : "KS", "county" : "BARBER" },"67140": { "city" : "SOUTH HAVEN", "state" : "KS", "county" : "SUMNER" },
            "67142": { "city" : "SPIVEY", "state" : "KS", "county" : "KINGMAN" },
            "67144": { "city" : "TOWANDA", "state" : "KS", "county" : "BUTLER" },
            "67146": { "city" : "UDALL", "state" : "KS", "county" : "COWLEY" },"67147": { "city" : "VALLEY CENTER", "state" : "KS", "county" : "SEDGWICK" },
            "67149": { "city" : "VIOLA", "state" : "KS", "county" : "SEDGWICK" },
            "67151": { "city" : "WALTON", "state" : "KS", "county" : "HARVEY" },"67152": { "city" : "WELLINGTON", "state" : "KS", "county" : "SUMNER" },
            "67154": { "city" : "WHITEWATER", "state" : "KS", "county" : "BUTLER" },
            "67155": { "city" : "WILMORE", "state" : "KS", "county" : "COMANCHE" },
            "67156": { "city" : "WINFIELD", "state" : "KS", "county" : "COWLEY" },
            "67159": { "city" : "ZENDA", "state" : "KS", "county" : "KINGMAN" },"67201": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67202": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67203": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67204": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67205": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67206": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67207": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67208": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67209": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67210": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67211": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67212": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67213": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67214": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67215": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67216": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67217": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67218": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67219": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67220": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67221": { "city" : "MCCONNELL AFB", "state" : "KS", "county" : "SEDGWICK" },
            "67223": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67226": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67227": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67228": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67230": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67232": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67235": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67260": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67275": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67276": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67277": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67278": { "city" : "WICHITA", "state" : "KS", "county" : "SEDGWICK" },
            "67301": { "city" : "INDEPENDENCE", "state" : "KS", "county" : "MONTGOMERY" },
            "67330": { "city" : "ALTAMONT", "state" : "KS", "county" : "LABETTE" },
            "67332": { "city" : "BARTLETT", "state" : "KS", "county" : "LABETTE" },
            "67333": { "city" : "CANEY", "state" : "KS", "county" : "MONTGOMERY" },
            "67334": { "city" : "CHAUTAUQUA", "state" : "KS", "county" : "CHAUTAUQUA" },
            "67335": { "city" : "CHERRYVALE", "state" : "KS", "county" : "MONTGOMERY" },
            "67336": { "city" : "CHETOPA", "state" : "KS", "county" : "LABETTE" },
            "67337": { "city" : "COFFEYVILLE", "state" : "KS", "county" : "MONTGOMERY" },
            "67340": { "city" : "DEARING", "state" : "KS", "county" : "MONTGOMERY" },
            "67342": { "city" : "EDNA", "state" : "KS", "county" : "LABETTE" },"67344": { "city" : "ELK CITY", "state" : "KS", "county" : "MONTGOMERY" },
            "67345": { "city" : "ELK FALLS", "state" : "KS", "county" : "ELK" },"67346": { "city" : "GRENOLA", "state" : "KS", "county" : "ELK" },
            "67347": { "city" : "HAVANA", "state" : "KS", "county" : "MONTGOMERY" },
            "67349": { "city" : "HOWARD", "state" : "KS", "county" : "ELK" },"67351": { "city" : "LIBERTY", "state" : "KS", "county" : "MONTGOMERY" },
            "67352": { "city" : "LONGTON", "state" : "KS", "county" : "ELK" },"67353": { "city" : "MOLINE", "state" : "KS", "county" : "ELK" },
            "67354": { "city" : "MOUND VALLEY", "state" : "KS", "county" : "LABETTE" },
            "67355": { "city" : "NIOTAZE", "state" : "KS", "county" : "CHAUTAUQUA" },
            "67356": { "city" : "OSWEGO", "state" : "KS", "county" : "LABETTE" },
            "67357": { "city" : "PARSONS", "state" : "KS", "county" : "LABETTE" },
            "67360": { "city" : "PERU", "state" : "KS", "county" : "CHAUTAUQUA" },
            "67361": { "city" : "SEDAN", "state" : "KS", "county" : "CHAUTAUQUA" },
            "67363": { "city" : "SYCAMORE", "state" : "KS", "county" : "MONTGOMERY" },
            "67364": { "city" : "TYRO", "state" : "KS", "county" : "MONTGOMERY" },
            "67401": { "city" : "SALINA", "state" : "KS", "county" : "SALINE" },"67402": { "city" : "SALINA", "state" : "KS", "county" : "SALINE" },
            "67410": { "city" : "ABILENE", "state" : "KS", "county" : "DICKINSON" },
            "67416": { "city" : "ASSARIA", "state" : "KS", "county" : "SALINE" },
            "67417": { "city" : "AURORA", "state" : "KS", "county" : "CLOUD" },"67418": { "city" : "BARNARD", "state" : "KS", "county" : "LINCOLN" },
            "67420": { "city" : "BELOIT", "state" : "KS", "county" : "MITCHELL" },
            "67422": { "city" : "BENNINGTON", "state" : "KS", "county" : "OTTAWA" },
            "67423": { "city" : "BEVERLY", "state" : "KS", "county" : "LINCOLN" },
            "67425": { "city" : "BROOKVILLE", "state" : "KS", "county" : "SALINE" },
            "67427": { "city" : "BUSHTON", "state" : "KS", "county" : "RICE" },"67428": { "city" : "CANTON", "state" : "KS", "county" : "MCPHERSON" },
            "67430": { "city" : "CAWKER CITY", "state" : "KS", "county" : "MITCHELL" },
            "67431": { "city" : "CHAPMAN", "state" : "KS", "county" : "DICKINSON" },
            "67432": { "city" : "CLAY CENTER", "state" : "KS", "county" : "CLAY" },
            "67436": { "city" : "DELPHOS", "state" : "KS", "county" : "OTTAWA" },
            "67437": { "city" : "DOWNS", "state" : "KS", "county" : "OSBORNE" },"67438": { "city" : "DURHAM", "state" : "KS", "county" : "MARION" },
            "67439": { "city" : "ELLSWORTH", "state" : "KS", "county" : "ELLSWORTH" },
            "67441": { "city" : "ENTERPRISE", "state" : "KS", "county" : "DICKINSON" },
            "67442": { "city" : "FALUN", "state" : "KS", "county" : "SALINE" },"67443": { "city" : "GALVA", "state" : "KS", "county" : "MCPHERSON" },
            "67444": { "city" : "GENESEO", "state" : "KS", "county" : "RICE" },"67445": { "city" : "GLASCO", "state" : "KS", "county" : "CLOUD" },
            "67446": { "city" : "GLEN ELDER", "state" : "KS", "county" : "MITCHELL" },
            "67447": { "city" : "GREEN", "state" : "KS", "county" : "CLAY" },"67448": { "city" : "GYPSUM", "state" : "KS", "county" : "SALINE" },
            "67449": { "city" : "HERINGTON", "state" : "KS", "county" : "DICKINSON" },
            "67450": { "city" : "HOLYROOD", "state" : "KS", "county" : "ELLSWORTH" },
            "67451": { "city" : "HOPE", "state" : "KS", "county" : "DICKINSON" },
            "67452": { "city" : "HUNTER", "state" : "KS", "county" : "MITCHELL" },
            "67454": { "city" : "KANOPOLIS", "state" : "KS", "county" : "ELLSWORTH" },
            "67455": { "city" : "LINCOLN", "state" : "KS", "county" : "LINCOLN" },
            "67456": { "city" : "LINDSBORG", "state" : "KS", "county" : "MCPHERSON" },
            "67457": { "city" : "LITTLE RIVER", "state" : "KS", "county" : "RICE" },
            "67458": { "city" : "LONGFORD", "state" : "KS", "county" : "CLAY" },"67459": { "city" : "LORRAINE", "state" : "KS", "county" : "ELLSWORTH" },
            "67460": { "city" : "MCPHERSON", "state" : "KS", "county" : "MCPHERSON" },
            "67464": { "city" : "MARQUETTE", "state" : "KS", "county" : "MCPHERSON" },
            "67466": { "city" : "MILTONVALE", "state" : "KS", "county" : "CLOUD" },
            "67467": { "city" : "MINNEAPOLIS", "state" : "KS", "county" : "OTTAWA" },
            "67468": { "city" : "MORGANVILLE", "state" : "KS", "county" : "CLAY" },
            "67470": { "city" : "NEW CAMBRIA", "state" : "KS", "county" : "SALINE" },
            "67473": { "city" : "OSBORNE", "state" : "KS", "county" : "OSBORNE" },
            "67474": { "city" : "PORTIS", "state" : "KS", "county" : "OSBORNE" },
            "67475": { "city" : "RAMONA", "state" : "KS", "county" : "MARION" },"67476": { "city" : "ROXBURY", "state" : "KS", "county" : "MCPHERSON" },
            "67478": { "city" : "SIMPSON", "state" : "KS", "county" : "MITCHELL" },
            "67480": { "city" : "SOLOMON", "state" : "KS", "county" : "DICKINSON" },
            "67481": { "city" : "SYLVAN GROVE", "state" : "KS", "county" : "LINCOLN" },
            "67482": { "city" : "TALMAGE", "state" : "KS", "county" : "DICKINSON" },
            "67483": { "city" : "TAMPA", "state" : "KS", "county" : "MARION" },"67484": { "city" : "TESCOTT", "state" : "KS", "county" : "OTTAWA" },
            "67485": { "city" : "TIPTON", "state" : "KS", "county" : "MITCHELL" },
            "67487": { "city" : "WAKEFIELD", "state" : "KS", "county" : "CLAY" },
            "67490": { "city" : "WILSON", "state" : "KS", "county" : "ELLSWORTH" },
            "67491": { "city" : "WINDOM", "state" : "KS", "county" : "MCPHERSON" },
            "67492": { "city" : "WOODBINE", "state" : "KS", "county" : "DICKINSON" },
            "67501": { "city" : "HUTCHINSON", "state" : "KS", "county" : "RENO" },
            "67502": { "city" : "HUTCHINSON", "state" : "KS", "county" : "RENO" },
            "67504": { "city" : "HUTCHINSON", "state" : "KS", "county" : "RENO" },
            "67505": { "city" : "SOUTH HUTCHINSON", "state" : "KS", "county" : "RENO" },
            "67510": { "city" : "ABBYVILLE", "state" : "KS", "county" : "RENO" },
            "67511": { "city" : "ALBERT", "state" : "KS", "county" : "BARTON" },"67512": { "city" : "ALDEN", "state" : "KS", "county" : "RICE" },
            "67513": { "city" : "ALEXANDER", "state" : "KS", "county" : "RUSH" },
            "67514": { "city" : "ARLINGTON", "state" : "KS", "county" : "RENO" },
            "67515": { "city" : "ARNOLD", "state" : "KS", "county" : "NESS" },"67516": { "city" : "BAZINE", "state" : "KS", "county" : "NESS" },
            "67518": { "city" : "BEELER", "state" : "KS", "county" : "NESS" },"67519": { "city" : "BELPRE", "state" : "KS", "county" : "EDWARDS" },
            "67520": { "city" : "BISON", "state" : "KS", "county" : "RUSH" },"67521": { "city" : "BROWNELL", "state" : "KS", "county" : "NESS" },
            "67522": { "city" : "BUHLER", "state" : "KS", "county" : "RENO" },"67523": { "city" : "BURDETT", "state" : "KS", "county" : "PAWNEE" },
            "67524": { "city" : "CHASE", "state" : "KS", "county" : "RICE" },"67525": { "city" : "CLAFLIN", "state" : "KS", "county" : "BARTON" },
            "67526": { "city" : "ELLINWOOD", "state" : "KS", "county" : "BARTON" },
            "67529": { "city" : "GARFIELD", "state" : "KS", "county" : "PAWNEE" },
            "67530": { "city" : "GREAT BEND", "state" : "KS", "county" : "BARTON" },
            "67543": { "city" : "HAVEN", "state" : "KS", "county" : "RENO" },"67544": { "city" : "HOISINGTON", "state" : "KS", "county" : "BARTON" },
            "67545": { "city" : "HUDSON", "state" : "KS", "county" : "STAFFORD" },
            "67546": { "city" : "INMAN", "state" : "KS", "county" : "MCPHERSON" },
            "67547": { "city" : "KINSLEY", "state" : "KS", "county" : "EDWARDS" },
            "67548": { "city" : "LA CROSSE", "state" : "KS", "county" : "RUSH" },
            "67550": { "city" : "LARNED", "state" : "KS", "county" : "PAWNEE" },"67552": { "city" : "LEWIS", "state" : "KS", "county" : "EDWARDS" },
            "67553": { "city" : "LIEBENTHAL", "state" : "KS", "county" : "RUSH" },
            "67554": { "city" : "LYONS", "state" : "KS", "county" : "RICE" },"67556": { "city" : "MC CRACKEN", "state" : "KS", "county" : "RUSH" },
            "67557": { "city" : "MACKSVILLE", "state" : "KS", "county" : "STAFFORD" },
            "67560": { "city" : "NESS CITY", "state" : "KS", "county" : "NESS" },
            "67561": { "city" : "NICKERSON", "state" : "KS", "county" : "RENO" },
            "67563": { "city" : "OFFERLE", "state" : "KS", "county" : "EDWARDS" },
            "67564": { "city" : "OLMITZ", "state" : "KS", "county" : "BARTON" },"67565": { "city" : "OTIS", "state" : "KS", "county" : "RUSH" },
            "67566": { "city" : "PARTRIDGE", "state" : "KS", "county" : "RENO" },
            "67567": { "city" : "PAWNEE ROCK", "state" : "KS", "county" : "BARTON" },
            "67568": { "city" : "PLEVNA", "state" : "KS", "county" : "RENO" },"67570": { "city" : "PRETTY PRAIRIE", "state" : "KS", "county" : "RENO" },
            "67572": { "city" : "RANSOM", "state" : "KS", "county" : "NESS" },"67573": { "city" : "RAYMOND", "state" : "KS", "county" : "RICE" },
            "67574": { "city" : "ROZEL", "state" : "KS", "county" : "PAWNEE" },"67575": { "city" : "RUSH CENTER", "state" : "KS", "county" : "RUSH" },
            "67576": { "city" : "SAINT JOHN", "state" : "KS", "county" : "STAFFORD" },
            "67578": { "city" : "STAFFORD", "state" : "KS", "county" : "STAFFORD" },
            "67579": { "city" : "STERLING", "state" : "KS", "county" : "RICE" },"67581": { "city" : "SYLVIA", "state" : "KS", "county" : "RENO" },
            "67583": { "city" : "TURON", "state" : "KS", "county" : "RENO" },"67584": { "city" : "UTICA", "state" : "KS", "county" : "NESS" },
            "67585": { "city" : "YODER", "state" : "KS", "county" : "RENO" },"67601": { "city" : "HAYS", "state" : "KS", "county" : "ELLIS" },
            "67621": { "city" : "AGRA", "state" : "KS", "county" : "PHILLIPS" },"67622": { "city" : "ALMENA", "state" : "KS", "county" : "NORTON" },
            "67623": { "city" : "ALTON", "state" : "KS", "county" : "OSBORNE" },"67625": { "city" : "BOGUE", "state" : "KS", "county" : "GRAHAM" },
            "67626": { "city" : "BUNKER HILL", "state" : "KS", "county" : "RUSSELL" },
            "67627": { "city" : "CATHARINE", "state" : "KS", "county" : "ELLIS" },
            "67628": { "city" : "CEDAR", "state" : "KS", "county" : "SMITH" },"67629": { "city" : "CLAYTON", "state" : "KS", "county" : "NORTON" },
            "67631": { "city" : "COLLYER", "state" : "KS", "county" : "TREGO" },"67632": { "city" : "DAMAR", "state" : "KS", "county" : "ROOKS" },
            "67634": { "city" : "DORRANCE", "state" : "KS", "county" : "RUSSELL" },
            "67635": { "city" : "DRESDEN", "state" : "KS", "county" : "DECATUR" },
            "67637": { "city" : "ELLIS", "state" : "KS", "county" : "ELLIS" },"67638": { "city" : "GAYLORD", "state" : "KS", "county" : "SMITH" },
            "67639": { "city" : "GLADE", "state" : "KS", "county" : "PHILLIPS" },
            "67640": { "city" : "GORHAM", "state" : "KS", "county" : "RUSSELL" },
            "67642": { "city" : "HILL CITY", "state" : "KS", "county" : "GRAHAM" },
            "67643": { "city" : "JENNINGS", "state" : "KS", "county" : "DECATUR" },
            "67644": { "city" : "KIRWIN", "state" : "KS", "county" : "PHILLIPS" },
            "67645": { "city" : "LENORA", "state" : "KS", "county" : "NORTON" },"67646": { "city" : "LOGAN", "state" : "KS", "county" : "PHILLIPS" },
            "67647": { "city" : "LONG ISLAND", "state" : "KS", "county" : "PHILLIPS" },
            "67648": { "city" : "LUCAS", "state" : "KS", "county" : "RUSSELL" },"67649": { "city" : "LURAY", "state" : "KS", "county" : "RUSSELL" },
            "67650": { "city" : "MORLAND", "state" : "KS", "county" : "GRAHAM" },
            "67651": { "city" : "NATOMA", "state" : "KS", "county" : "OSBORNE" },
            "67653": { "city" : "NORCATUR", "state" : "KS", "county" : "DECATUR" },
            "67654": { "city" : "NORTON", "state" : "KS", "county" : "NORTON" },"67656": { "city" : "OGALLAH", "state" : "KS", "county" : "TREGO" },
            "67657": { "city" : "PALCO", "state" : "KS", "county" : "ROOKS" },"67658": { "city" : "PARADISE", "state" : "KS", "county" : "RUSSELL" },
            "67659": { "city" : "PENOKEE", "state" : "KS", "county" : "GRAHAM" },
            "67660": { "city" : "PFEIFER", "state" : "KS", "county" : "ELLIS" },"67661": { "city" : "PHILLIPSBURG", "state" : "KS", "county" : "PHILLIPS" },
            "67663": { "city" : "PLAINVILLE", "state" : "KS", "county" : "ROOKS" },
            "67664": { "city" : "PRAIRIE VIEW", "state" : "KS", "county" : "PHILLIPS" },
            "67665": { "city" : "RUSSELL", "state" : "KS", "county" : "RUSSELL" },
            "67667": { "city" : "SCHOENCHEN", "state" : "KS", "county" : "ELLIS" },
            "67669": { "city" : "STOCKTON", "state" : "KS", "county" : "ROOKS" },
            "67671": { "city" : "VICTORIA", "state" : "KS", "county" : "ELLIS" },
            "67672": { "city" : "WAKEENEY", "state" : "KS", "county" : "TREGO" },
            "67673": { "city" : "WALDO", "state" : "KS", "county" : "RUSSELL" },"67674": { "city" : "WALKER", "state" : "KS", "county" : "ELLIS" },
            "67675": { "city" : "WOODSTON", "state" : "KS", "county" : "ROOKS" },
            "67701": { "city" : "COLBY", "state" : "KS", "county" : "THOMAS" },"67730": { "city" : "ATWOOD", "state" : "KS", "county" : "RAWLINS" },
            "67731": { "city" : "BIRD CITY", "state" : "KS", "county" : "CHEYENNE" },
            "67732": { "city" : "BREWSTER", "state" : "KS", "county" : "THOMAS" },
            "67733": { "city" : "EDSON", "state" : "KS", "county" : "SHERMAN" },"67734": { "city" : "GEM", "state" : "KS", "county" : "THOMAS" },
            "67735": { "city" : "GOODLAND", "state" : "KS", "county" : "SHERMAN" },
            "67736": { "city" : "GOVE", "state" : "KS", "county" : "GOVE" },"67737": { "city" : "GRAINFIELD", "state" : "KS", "county" : "GOVE" },
            "67738": { "city" : "GRINNELL", "state" : "KS", "county" : "GOVE" },"67739": { "city" : "HERNDON", "state" : "KS", "county" : "RAWLINS" },
            "67740": { "city" : "HOXIE", "state" : "KS", "county" : "SHERIDAN" },
            "67741": { "city" : "KANORADO", "state" : "KS", "county" : "SHERMAN" },
            "67743": { "city" : "LEVANT", "state" : "KS", "county" : "THOMAS" },"67744": { "city" : "LUDELL", "state" : "KS", "county" : "RAWLINS" },
            "67745": { "city" : "MC DONALD", "state" : "KS", "county" : "RAWLINS" },
            "67747": { "city" : "MONUMENT", "state" : "KS", "county" : "LOGAN" },
            "67748": { "city" : "OAKLEY", "state" : "KS", "county" : "LOGAN" },"67749": { "city" : "OBERLIN", "state" : "KS", "county" : "DECATUR" },
            "67751": { "city" : "PARK", "state" : "KS", "county" : "GOVE" },"67752": { "city" : "QUINTER", "state" : "KS", "county" : "GOVE" },
            "67753": { "city" : "REXFORD", "state" : "KS", "county" : "THOMAS" },
            "67756": { "city" : "SAINT FRANCIS", "state" : "KS", "county" : "CHEYENNE" },
            "67757": { "city" : "SELDEN", "state" : "KS", "county" : "SHERIDAN" },
            "67758": { "city" : "SHARON SPRINGS", "state" : "KS", "county" : "WALLACE" },
            "67761": { "city" : "WALLACE", "state" : "KS", "county" : "WALLACE" },
            "67762": { "city" : "WESKAN", "state" : "KS", "county" : "WALLACE" },
            "67764": { "city" : "WINONA", "state" : "KS", "county" : "LOGAN" },"67801": { "city" : "DODGE CITY", "state" : "KS", "county" : "FORD" },
            "67831": { "city" : "ASHLAND", "state" : "KS", "county" : "CLARK" },"67834": { "city" : "BUCKLIN", "state" : "KS", "county" : "FORD" },
            "67835": { "city" : "CIMARRON", "state" : "KS", "county" : "GRAY" },"67836": { "city" : "COOLIDGE", "state" : "KS", "county" : "HAMILTON" },
            "67837": { "city" : "COPELAND", "state" : "KS", "county" : "GRAY" },"67838": { "city" : "DEERFIELD", "state" : "KS", "county" : "KEARNY" },
            "67839": { "city" : "DIGHTON", "state" : "KS", "county" : "LANE" },"67840": { "city" : "ENGLEWOOD", "state" : "KS", "county" : "CLARK" },
            "67841": { "city" : "ENSIGN", "state" : "KS", "county" : "GRAY" },"67842": { "city" : "FORD", "state" : "KS", "county" : "FORD" },
            "67844": { "city" : "FOWLER", "state" : "KS", "county" : "MEADE" },"67846": { "city" : "GARDEN CITY", "state" : "KS", "county" : "FINNEY" },
            "67849": { "city" : "HANSTON", "state" : "KS", "county" : "HODGEMAN" },
            "67850": { "city" : "HEALY", "state" : "KS", "county" : "LANE" },"67851": { "city" : "HOLCOMB", "state" : "KS", "county" : "FINNEY" },
            "67853": { "city" : "INGALLS", "state" : "KS", "county" : "GRAY" },"67854": { "city" : "JETMORE", "state" : "KS", "county" : "HODGEMAN" },
            "67855": { "city" : "JOHNSON", "state" : "KS", "county" : "STANTON" },
            "67857": { "city" : "KENDALL", "state" : "KS", "county" : "HAMILTON" },
            "67859": { "city" : "KISMET", "state" : "KS", "county" : "SEWARD" },"67860": { "city" : "LAKIN", "state" : "KS", "county" : "KEARNY" },
            "67861": { "city" : "LEOTI", "state" : "KS", "county" : "WICHITA" },"67862": { "city" : "MANTER", "state" : "KS", "county" : "STANTON" },
            "67863": { "city" : "MARIENTHAL", "state" : "KS", "county" : "WICHITA" },
            "67864": { "city" : "MEADE", "state" : "KS", "county" : "MEADE" },"67865": { "city" : "MINNEOLA", "state" : "KS", "county" : "CLARK" },
            "67867": { "city" : "MONTEZUMA", "state" : "KS", "county" : "GRAY" },
            "67868": { "city" : "PIERCEVILLE", "state" : "KS", "county" : "FINNEY" },
            "67869": { "city" : "PLAINS", "state" : "KS", "county" : "MEADE" },"67870": { "city" : "SATANTA", "state" : "KS", "county" : "HASKELL" },
            "67871": { "city" : "SCOTT CITY", "state" : "KS", "county" : "SCOTT" },
            "67876": { "city" : "SPEARVILLE", "state" : "KS", "county" : "FORD" },
            "67877": { "city" : "SUBLETTE", "state" : "KS", "county" : "HASKELL" },
            "67878": { "city" : "SYRACUSE", "state" : "KS", "county" : "HAMILTON" },
            "67879": { "city" : "TRIBUNE", "state" : "KS", "county" : "GREELEY" },
            "67880": { "city" : "ULYSSES", "state" : "KS", "county" : "GRANT" },"67882": { "city" : "WRIGHT", "state" : "KS", "county" : "FORD" },
            "67901": { "city" : "LIBERAL", "state" : "KS", "county" : "SEWARD" },
            "67905": { "city" : "LIBERAL", "state" : "KS", "county" : "SEWARD" },
            "67950": { "city" : "ELKHART", "state" : "KS", "county" : "MORTON" },
            "67951": { "city" : "HUGOTON", "state" : "KS", "county" : "STEVENS" },
            "67952": { "city" : "MOSCOW", "state" : "KS", "county" : "STEVENS" },
            "67953": { "city" : "RICHFIELD", "state" : "KS", "county" : "MORTON" },
            "67954": { "city" : "ROLLA", "state" : "KS", "county" : "MORTON" },"68001": { "city" : "ABIE", "state" : "NE", "county" : "BUTLER" },
            "68002": { "city" : "ARLINGTON", "state" : "NE", "county" : "WASHINGTON" },
            "68003": { "city" : "ASHLAND", "state" : "NE", "county" : "SAUNDERS" },
            "68004": { "city" : "BANCROFT", "state" : "NE", "county" : "CUMING" },
            "68005": { "city" : "BELLEVUE", "state" : "NE", "county" : "SARPY" },
            "68007": { "city" : "BENNINGTON", "state" : "NE", "county" : "DOUGLAS" },
            "68008": { "city" : "BLAIR", "state" : "NE", "county" : "WASHINGTON" },
            "68010": { "city" : "BOYS TOWN", "state" : "NE", "county" : "DOUGLAS" },
            "68014": { "city" : "BRUNO", "state" : "NE", "county" : "BUTLER" },"68015": { "city" : "CEDAR BLUFFS", "state" : "NE", "county" : "SAUNDERS" },
            "68016": { "city" : "CEDAR CREEK", "state" : "NE", "county" : "CASS" },
            "68017": { "city" : "CERESCO", "state" : "NE", "county" : "SAUNDERS" },
            "68018": { "city" : "COLON", "state" : "NE", "county" : "SAUNDERS" },
            "68019": { "city" : "CRAIG", "state" : "NE", "county" : "BURT" },"68020": { "city" : "DECATUR", "state" : "NE", "county" : "BURT" },
            "68022": { "city" : "ELKHORN", "state" : "NE", "county" : "DOUGLAS" },
            "68023": { "city" : "FORT CALHOUN", "state" : "NE", "county" : "WASHINGTON" },
            "68025": { "city" : "FREMONT", "state" : "NE", "county" : "DODGE" },"68026": { "city" : "FREMONT", "state" : "NE", "county" : "DODGE" },
            "68028": { "city" : "GRETNA", "state" : "NE", "county" : "SARPY" },"68029": { "city" : "HERMAN", "state" : "NE", "county" : "WASHINGTON" },
            "68030": { "city" : "HOMER", "state" : "NE", "county" : "DAKOTA" },"68031": { "city" : "HOOPER", "state" : "NE", "county" : "DODGE" },
            "68033": { "city" : "ITHACA", "state" : "NE", "county" : "SAUNDERS" },
            "68034": { "city" : "KENNARD", "state" : "NE", "county" : "WASHINGTON" },
            "68036": { "city" : "LINWOOD", "state" : "NE", "county" : "BUTLER" },
            "68037": { "city" : "LOUISVILLE", "state" : "NE", "county" : "CASS" },
            "68038": { "city" : "LYONS", "state" : "NE", "county" : "BURT" },"68039": { "city" : "MACY", "state" : "NE", "county" : "THURSTON" },
            "68040": { "city" : "MALMO", "state" : "NE", "county" : "SAUNDERS" },
            "68041": { "city" : "MEAD", "state" : "NE", "county" : "SAUNDERS" },"68042": { "city" : "MEMPHIS", "state" : "NE", "county" : "SAUNDERS" },
            "68044": { "city" : "NICKERSON", "state" : "NE", "county" : "DODGE" },
            "68045": { "city" : "OAKLAND", "state" : "NE", "county" : "BURT" },"68046": { "city" : "PAPILLION", "state" : "NE", "county" : "SARPY" },
            "68047": { "city" : "PENDER", "state" : "NE", "county" : "THURSTON" },
            "68048": { "city" : "PLATTSMOUTH", "state" : "NE", "county" : "CASS" },
            "68050": { "city" : "PRAGUE", "state" : "NE", "county" : "SAUNDERS" },
            "68056": { "city" : "ST COLUMBANS", "state" : "NE", "county" : "SARPY" },
            "68057": { "city" : "SCRIBNER", "state" : "NE", "county" : "DODGE" },
            "68058": { "city" : "SOUTH BEND", "state" : "NE", "county" : "CASS" },
            "68059": { "city" : "SPRINGFIELD", "state" : "NE", "county" : "SARPY" },
            "68061": { "city" : "TEKAMAH", "state" : "NE", "county" : "BURT" },"68062": { "city" : "THURSTON", "state" : "NE", "county" : "THURSTON" },
            "68063": { "city" : "UEHLING", "state" : "NE", "county" : "DODGE" },"68064": { "city" : "VALLEY", "state" : "NE", "county" : "DOUGLAS" },
            "68065": { "city" : "VALPARAISO", "state" : "NE", "county" : "SAUNDERS" },
            "68066": { "city" : "WAHOO", "state" : "NE", "county" : "SAUNDERS" },
            "68067": { "city" : "WALTHILL", "state" : "NE", "county" : "THURSTON" },
            "68068": { "city" : "WASHINGTON", "state" : "NE", "county" : "WASHINGTON" },
            "68069": { "city" : "WATERLOO", "state" : "NE", "county" : "DOUGLAS" },
            "68070": { "city" : "WESTON", "state" : "NE", "county" : "SAUNDERS" },
            "68071": { "city" : "WINNEBAGO", "state" : "NE", "county" : "THURSTON" },
            "68072": { "city" : "WINSLOW", "state" : "NE", "county" : "DODGE" },"68073": { "city" : "YUTAN", "state" : "NE", "county" : "SAUNDERS" },
            "68101": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68102": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68103": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68104": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68105": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68106": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68107": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68108": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68110": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68111": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68112": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68113": { "city" : "OFFUTT A F B", "state" : "NE", "county" : "SARPY" },
            "68114": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68116": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68117": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68118": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68119": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68120": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68122": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68123": { "city" : "BELLEVUE", "state" : "NE", "county" : "SARPY" },
            "68124": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68127": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68128": { "city" : "LA VISTA", "state" : "NE", "county" : "SARPY" },
            "68130": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68131": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68132": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68133": { "city" : "PAPILLION", "state" : "NE", "county" : "SARPY" },
            "68134": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68135": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68136": { "city" : "OMAHA", "state" : "NE", "county" : "SARPY" },"68137": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68138": { "city" : "OMAHA", "state" : "NE", "county" : "SARPY" },"68139": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68142": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68144": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68145": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68147": { "city" : "BELLEVUE", "state" : "NE", "county" : "SARPY" },
            "68152": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68154": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68157": { "city" : "OMAHA", "state" : "NE", "county" : "SARPY" },"68164": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68175": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68178": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68179": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68182": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68183": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68197": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },
            "68198": { "city" : "OMAHA", "state" : "NE", "county" : "DOUGLAS" },"68301": { "city" : "ADAMS", "state" : "NE", "county" : "GAGE" },
            "68303": { "city" : "ALEXANDRIA", "state" : "NE", "county" : "THAYER" },
            "68304": { "city" : "ALVO", "state" : "NE", "county" : "CASS" },"68305": { "city" : "AUBURN", "state" : "NE", "county" : "NEMAHA" },
            "68307": { "city" : "AVOCA", "state" : "NE", "county" : "CASS" },"68309": { "city" : "BARNESTON", "state" : "NE", "county" : "GAGE" },
            "68310": { "city" : "BEATRICE", "state" : "NE", "county" : "GAGE" },"68313": { "city" : "BEAVER CROSSING", "state" : "NE", "county" : "SEWARD" },
            "68314": { "city" : "BEE", "state" : "NE", "county" : "SEWARD" },"68315": { "city" : "BELVIDERE", "state" : "NE", "county" : "THAYER" },
            "68316": { "city" : "BENEDICT", "state" : "NE", "county" : "YORK" },"68317": { "city" : "BENNET", "state" : "NE", "county" : "LANCASTER" },
            "68318": { "city" : "BLUE SPRINGS", "state" : "NE", "county" : "GAGE" },
            "68319": { "city" : "BRADSHAW", "state" : "NE", "county" : "YORK" },"68320": { "city" : "BROCK", "state" : "NE", "county" : "NEMAHA" },
            "68321": { "city" : "BROWNVILLE", "state" : "NE", "county" : "NEMAHA" },
            "68322": { "city" : "BRUNING", "state" : "NE", "county" : "THAYER" },
            "68323": { "city" : "BURCHARD", "state" : "NE", "county" : "PAWNEE" },
            "68324": { "city" : "BURR", "state" : "NE", "county" : "OTOE" },"68325": { "city" : "BYRON", "state" : "NE", "county" : "THAYER" },
            "68326": { "city" : "CARLETON", "state" : "NE", "county" : "THAYER" },
            "68327": { "city" : "CHESTER", "state" : "NE", "county" : "THAYER" },
            "68328": { "city" : "CLATONIA", "state" : "NE", "county" : "GAGE" },"68329": { "city" : "COOK", "state" : "NE", "county" : "JOHNSON" },
            "68330": { "city" : "CORDOVA", "state" : "NE", "county" : "SEWARD" },
            "68331": { "city" : "CORTLAND", "state" : "NE", "county" : "GAGE" },"68332": { "city" : "CRAB ORCHARD", "state" : "NE", "county" : "JOHNSON" },
            "68333": { "city" : "CRETE", "state" : "NE", "county" : "SALINE" },"68335": { "city" : "DAVENPORT", "state" : "NE", "county" : "THAYER" },
            "68336": { "city" : "DAVEY", "state" : "NE", "county" : "LANCASTER" },
            "68337": { "city" : "DAWSON", "state" : "NE", "county" : "RICHARDSON" },
            "68338": { "city" : "DAYKIN", "state" : "NE", "county" : "JEFFERSON" },
            "68339": { "city" : "DENTON", "state" : "NE", "county" : "LANCASTER" },
            "68340": { "city" : "DESHLER", "state" : "NE", "county" : "THAYER" },
            "68341": { "city" : "DE WITT", "state" : "NE", "county" : "SALINE" },
            "68342": { "city" : "DILLER", "state" : "NE", "county" : "JEFFERSON" },
            "68343": { "city" : "DORCHESTER", "state" : "NE", "county" : "SALINE" },
            "68344": { "city" : "DOUGLAS", "state" : "NE", "county" : "OTOE" },"68345": { "city" : "DU BOIS", "state" : "NE", "county" : "PAWNEE" },
            "68346": { "city" : "DUNBAR", "state" : "NE", "county" : "OTOE" },"68347": { "city" : "EAGLE", "state" : "NE", "county" : "CASS" },
            "68348": { "city" : "ELK CREEK", "state" : "NE", "county" : "JOHNSON" },
            "68349": { "city" : "ELMWOOD", "state" : "NE", "county" : "CASS" },"68350": { "city" : "ENDICOTT", "state" : "NE", "county" : "JEFFERSON" },
            "68351": { "city" : "EXETER", "state" : "NE", "county" : "FILLMORE" },
            "68352": { "city" : "FAIRBURY", "state" : "NE", "county" : "JEFFERSON" },
            "68354": { "city" : "FAIRMONT", "state" : "NE", "county" : "FILLMORE" },
            "68355": { "city" : "FALLS CITY", "state" : "NE", "county" : "RICHARDSON" },
            "68357": { "city" : "FILLEY", "state" : "NE", "county" : "GAGE" },"68358": { "city" : "FIRTH", "state" : "NE", "county" : "LANCASTER" },
            "68359": { "city" : "FRIEND", "state" : "NE", "county" : "SALINE" },"68360": { "city" : "GARLAND", "state" : "NE", "county" : "SEWARD" },
            "68361": { "city" : "GENEVA", "state" : "NE", "county" : "FILLMORE" },
            "68362": { "city" : "GILEAD", "state" : "NE", "county" : "THAYER" },"68364": { "city" : "GOEHNER", "state" : "NE", "county" : "SEWARD" },
            "68365": { "city" : "GRAFTON", "state" : "NE", "county" : "FILLMORE" },
            "68366": { "city" : "GREENWOOD", "state" : "NE", "county" : "CASS" },
            "68367": { "city" : "GRESHAM", "state" : "NE", "county" : "YORK" },"68368": { "city" : "HALLAM", "state" : "NE", "county" : "LANCASTER" },
            "68370": { "city" : "HEBRON", "state" : "NE", "county" : "THAYER" },"68371": { "city" : "HENDERSON", "state" : "NE", "county" : "YORK" },
            "68372": { "city" : "HICKMAN", "state" : "NE", "county" : "LANCASTER" },
            "68375": { "city" : "HUBBELL", "state" : "NE", "county" : "THAYER" },
            "68376": { "city" : "HUMBOLDT", "state" : "NE", "county" : "RICHARDSON" },
            "68377": { "city" : "JANSEN", "state" : "NE", "county" : "JEFFERSON" },
            "68378": { "city" : "JOHNSON", "state" : "NE", "county" : "NEMAHA" },
            "68380": { "city" : "LEWISTON", "state" : "NE", "county" : "PAWNEE" },
            "68381": { "city" : "LIBERTY", "state" : "NE", "county" : "GAGE" },"68382": { "city" : "LORTON", "state" : "NE", "county" : "OTOE" },
            "68401": { "city" : "MC COOL JUNCTION", "state" : "NE", "county" : "YORK" },
            "68402": { "city" : "MALCOLM", "state" : "NE", "county" : "LANCASTER" },
            "68403": { "city" : "MANLEY", "state" : "NE", "county" : "CASS" },"68404": { "city" : "MARTELL", "state" : "NE", "county" : "LANCASTER" },
            "68405": { "city" : "MILFORD", "state" : "NE", "county" : "SEWARD" },
            "68406": { "city" : "MILLIGAN", "state" : "NE", "county" : "FILLMORE" },
            "68407": { "city" : "MURDOCK", "state" : "NE", "county" : "CASS" },"68409": { "city" : "MURRAY", "state" : "NE", "county" : "CASS" },
            "68410": { "city" : "NEBRASKA CITY", "state" : "NE", "county" : "OTOE" },
            "68413": { "city" : "NEHAWKA", "state" : "NE", "county" : "CASS" },"68414": { "city" : "NEMAHA", "state" : "NE", "county" : "NEMAHA" },
            "68415": { "city" : "ODELL", "state" : "NE", "county" : "GAGE" },"68416": { "city" : "OHIOWA", "state" : "NE", "county" : "FILLMORE" },
            "68417": { "city" : "OTOE", "state" : "NE", "county" : "OTOE" },"68418": { "city" : "PALMYRA", "state" : "NE", "county" : "OTOE" },
            "68419": { "city" : "PANAMA", "state" : "NE", "county" : "LANCASTER" },
            "68420": { "city" : "PAWNEE CITY", "state" : "NE", "county" : "PAWNEE" },
            "68421": { "city" : "PERU", "state" : "NE", "county" : "NEMAHA" },"68422": { "city" : "PICKRELL", "state" : "NE", "county" : "GAGE" },
            "68423": { "city" : "PLEASANT DALE", "state" : "NE", "county" : "SEWARD" },
            "68424": { "city" : "PLYMOUTH", "state" : "NE", "county" : "JEFFERSON" },
            "68428": { "city" : "RAYMOND", "state" : "NE", "county" : "LANCASTER" },
            "68429": { "city" : "REYNOLDS", "state" : "NE", "county" : "THAYER" },
            "68430": { "city" : "ROCA", "state" : "NE", "county" : "LANCASTER" },
            "68431": { "city" : "RULO", "state" : "NE", "county" : "RICHARDSON" },
            "68433": { "city" : "SALEM", "state" : "NE", "county" : "RICHARDSON" },
            "68434": { "city" : "SEWARD", "state" : "NE", "county" : "SEWARD" },"68436": { "city" : "SHICKLEY", "state" : "NE", "county" : "FILLMORE" },
            "68437": { "city" : "SHUBERT", "state" : "NE", "county" : "RICHARDSON" },
            "68438": { "city" : "SPRAGUE", "state" : "NE", "county" : "LANCASTER" },
            "68439": { "city" : "STAPLEHURST", "state" : "NE", "county" : "SEWARD" },
            "68440": { "city" : "STEELE CITY", "state" : "NE", "county" : "JEFFERSON" },
            "68441": { "city" : "STEINAUER", "state" : "NE", "county" : "PAWNEE" },
            "68442": { "city" : "STELLA", "state" : "NE", "county" : "RICHARDSON" },
            "68443": { "city" : "STERLING", "state" : "NE", "county" : "JOHNSON" },
            "68444": { "city" : "STRANG", "state" : "NE", "county" : "FILLMORE" },
            "68445": { "city" : "SWANTON", "state" : "NE", "county" : "SALINE" },
            "68446": { "city" : "SYRACUSE", "state" : "NE", "county" : "OTOE" },"68447": { "city" : "TABLE ROCK", "state" : "NE", "county" : "PAWNEE" },
            "68448": { "city" : "TALMAGE", "state" : "NE", "county" : "OTOE" },"68450": { "city" : "TECUMSEH", "state" : "NE", "county" : "JOHNSON" },
            "68452": { "city" : "ONG", "state" : "NE", "county" : "CLAY" },"68453": { "city" : "TOBIAS", "state" : "NE", "county" : "SALINE" },
            "68454": { "city" : "UNADILLA", "state" : "NE", "county" : "OTOE" },"68455": { "city" : "UNION", "state" : "NE", "county" : "CASS" },
            "68456": { "city" : "UTICA", "state" : "NE", "county" : "SEWARD" },"68457": { "city" : "VERDON", "state" : "NE", "county" : "RICHARDSON" },
            "68458": { "city" : "VIRGINIA", "state" : "NE", "county" : "GAGE" },"68460": { "city" : "WACO", "state" : "NE", "county" : "YORK" },
            "68461": { "city" : "WALTON", "state" : "NE", "county" : "LANCASTER" },
            "68462": { "city" : "WAVERLY", "state" : "NE", "county" : "LANCASTER" },
            "68463": { "city" : "WEEPING WATER", "state" : "NE", "county" : "CASS" },
            "68464": { "city" : "WESTERN", "state" : "NE", "county" : "SALINE" },
            "68465": { "city" : "WILBER", "state" : "NE", "county" : "SALINE" },"68466": { "city" : "WYMORE", "state" : "NE", "county" : "GAGE" },
            "68467": { "city" : "YORK", "state" : "NE", "county" : "YORK" },"68501": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68502": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68503": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68504": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68505": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68506": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68507": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68508": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68509": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68510": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68512": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68514": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68516": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68517": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68520": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68521": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68522": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68523": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68524": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68526": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68527": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68528": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68529": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68531": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68532": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68542": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68583": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68588": { "city" : "LINCOLN", "state" : "NE", "county" : "LANCASTER" },
            "68601": { "city" : "COLUMBUS", "state" : "NE", "county" : "PLATTE" },
            "68602": { "city" : "COLUMBUS", "state" : "NE", "county" : "PLATTE" },
            "68620": { "city" : "ALBION", "state" : "NE", "county" : "BOONE" },"68621": { "city" : "AMES", "state" : "NE", "county" : "DODGE" },
            "68622": { "city" : "BARTLETT", "state" : "NE", "county" : "WHEELER" },
            "68623": { "city" : "BELGRADE", "state" : "NE", "county" : "BOONE" },
            "68624": { "city" : "BELLWOOD", "state" : "NE", "county" : "BUTLER" },
            "68626": { "city" : "BRAINARD", "state" : "NE", "county" : "BUTLER" },
            "68627": { "city" : "CEDAR RAPIDS", "state" : "NE", "county" : "BOONE" },
            "68628": { "city" : "CLARKS", "state" : "NE", "county" : "MERRICK" },
            "68629": { "city" : "CLARKSON", "state" : "NE", "county" : "COLFAX" },
            "68631": { "city" : "CRESTON", "state" : "NE", "county" : "PLATTE" },
            "68632": { "city" : "DAVID CITY", "state" : "NE", "county" : "BUTLER" },
            "68633": { "city" : "DODGE", "state" : "NE", "county" : "DODGE" },"68634": { "city" : "DUNCAN", "state" : "NE", "county" : "PLATTE" },
            "68635": { "city" : "DWIGHT", "state" : "NE", "county" : "BUTLER" },"68636": { "city" : "ELGIN", "state" : "NE", "county" : "ANTELOPE" },
            "68637": { "city" : "ERICSON", "state" : "NE", "county" : "WHEELER" },
            "68638": { "city" : "FULLERTON", "state" : "NE", "county" : "NANCE" },
            "68640": { "city" : "GENOA", "state" : "NE", "county" : "NANCE" },"68641": { "city" : "HOWELLS", "state" : "NE", "county" : "COLFAX" },
            "68642": { "city" : "HUMPHREY", "state" : "NE", "county" : "PLATTE" },
            "68643": { "city" : "LEIGH", "state" : "NE", "county" : "COLFAX" },"68644": { "city" : "LINDSAY", "state" : "NE", "county" : "PLATTE" },
            "68647": { "city" : "MONROE", "state" : "NE", "county" : "PLATTE" },"68648": { "city" : "MORSE BLUFF", "state" : "NE", "county" : "SAUNDERS" },
            "68649": { "city" : "NORTH BEND", "state" : "NE", "county" : "DODGE" },
            "68651": { "city" : "OSCEOLA", "state" : "NE", "county" : "POLK" },"68652": { "city" : "PETERSBURG", "state" : "NE", "county" : "BOONE" },
            "68653": { "city" : "PLATTE CENTER", "state" : "NE", "county" : "PLATTE" },
            "68654": { "city" : "POLK", "state" : "NE", "county" : "POLK" },"68655": { "city" : "PRIMROSE", "state" : "NE", "county" : "BOONE" },
            "68658": { "city" : "RISING CITY", "state" : "NE", "county" : "BUTLER" },
            "68659": { "city" : "ROGERS", "state" : "NE", "county" : "COLFAX" },"68660": { "city" : "SAINT EDWARD", "state" : "NE", "county" : "BOONE" },
            "68661": { "city" : "SCHUYLER", "state" : "NE", "county" : "COLFAX" },
            "68662": { "city" : "SHELBY", "state" : "NE", "county" : "POLK" },"68663": { "city" : "SILVER CREEK", "state" : "NE", "county" : "MERRICK" },
            "68664": { "city" : "SNYDER", "state" : "NE", "county" : "DODGE" },"68665": { "city" : "SPALDING", "state" : "NE", "county" : "GREELEY" },
            "68666": { "city" : "STROMSBURG", "state" : "NE", "county" : "POLK" },
            "68667": { "city" : "SURPRISE", "state" : "NE", "county" : "BUTLER" },
            "68669": { "city" : "ULYSSES", "state" : "NE", "county" : "BUTLER" },
            "68701": { "city" : "NORFOLK", "state" : "NE", "county" : "MADISON" },
            "68702": { "city" : "NORFOLK", "state" : "NE", "county" : "MADISON" },
            "68710": { "city" : "ALLEN", "state" : "NE", "county" : "DIXON" },"68713": { "city" : "ATKINSON", "state" : "NE", "county" : "HOLT" },
            "68714": { "city" : "BASSETT", "state" : "NE", "county" : "ROCK" },"68715": { "city" : "BATTLE CREEK", "state" : "NE", "county" : "MADISON" },
            "68716": { "city" : "BEEMER", "state" : "NE", "county" : "CUMING" },"68717": { "city" : "BELDEN", "state" : "NE", "county" : "CEDAR" },
            "68718": { "city" : "BLOOMFIELD", "state" : "NE", "county" : "KNOX" },
            "68719": { "city" : "BRISTOW", "state" : "NE", "county" : "BOYD" },"68720": { "city" : "BRUNSWICK", "state" : "NE", "county" : "ANTELOPE" },
            "68722": { "city" : "BUTTE", "state" : "NE", "county" : "BOYD" },"68723": { "city" : "CARROLL", "state" : "NE", "county" : "WAYNE" },
            "68724": { "city" : "CENTER", "state" : "NE", "county" : "KNOX" },"68725": { "city" : "CHAMBERS", "state" : "NE", "county" : "HOLT" },
            "68726": { "city" : "CLEARWATER", "state" : "NE", "county" : "ANTELOPE" },
            "68727": { "city" : "COLERIDGE", "state" : "NE", "county" : "CEDAR" },
            "68728": { "city" : "CONCORD", "state" : "NE", "county" : "DIXON" },"68729": { "city" : "CREIGHTON", "state" : "NE", "county" : "KNOX" },
            "68730": { "city" : "CROFTON", "state" : "NE", "county" : "KNOX" },"68731": { "city" : "DAKOTA CITY", "state" : "NE", "county" : "DAKOTA" },
            "68732": { "city" : "DIXON", "state" : "NE", "county" : "DIXON" },"68733": { "city" : "EMERSON", "state" : "NE", "county" : "DAKOTA" },
            "68734": { "city" : "EMMET", "state" : "NE", "county" : "HOLT" },"68735": { "city" : "EWING", "state" : "NE", "county" : "HOLT" },
            "68736": { "city" : "FORDYCE", "state" : "NE", "county" : "CEDAR" },"68738": { "city" : "HADAR", "state" : "NE", "county" : "PIERCE" },
            "68739": { "city" : "HARTINGTON", "state" : "NE", "county" : "CEDAR" },
            "68740": { "city" : "HOSKINS", "state" : "NE", "county" : "WAYNE" },"68741": { "city" : "HUBBARD", "state" : "NE", "county" : "DAKOTA" },
            "68742": { "city" : "INMAN", "state" : "NE", "county" : "HOLT" },"68743": { "city" : "JACKSON", "state" : "NE", "county" : "DAKOTA" },
            "68745": { "city" : "LAUREL", "state" : "NE", "county" : "CEDAR" },"68746": { "city" : "LYNCH", "state" : "NE", "county" : "BOYD" },
            "68747": { "city" : "MCLEAN", "state" : "NE", "county" : "PIERCE" },"68748": { "city" : "MADISON", "state" : "NE", "county" : "MADISON" },
            "68749": { "city" : "MAGNET", "state" : "NE", "county" : "CEDAR" },"68752": { "city" : "MEADOW GROVE", "state" : "NE", "county" : "MADISON" },
            "68755": { "city" : "NAPER", "state" : "NE", "county" : "BOYD" },"68756": { "city" : "NELIGH", "state" : "NE", "county" : "ANTELOPE" },
            "68757": { "city" : "NEWCASTLE", "state" : "NE", "county" : "DIXON" },
            "68758": { "city" : "NEWMAN GROVE", "state" : "NE", "county" : "MADISON" },
            "68759": { "city" : "NEWPORT", "state" : "NE", "county" : "KEYA PAHA" },
            "68760": { "city" : "NIOBRARA", "state" : "NE", "county" : "KNOX" },"68761": { "city" : "OAKDALE", "state" : "NE", "county" : "ANTELOPE" },
            "68763": { "city" : "ONEILL", "state" : "NE", "county" : "HOLT" },"68764": { "city" : "ORCHARD", "state" : "NE", "county" : "ANTELOPE" },
            "68765": { "city" : "OSMOND", "state" : "NE", "county" : "PIERCE" },"68766": { "city" : "PAGE", "state" : "NE", "county" : "HOLT" },
            "68767": { "city" : "PIERCE", "state" : "NE", "county" : "PIERCE" },"68768": { "city" : "PILGER", "state" : "NE", "county" : "STANTON" },
            "68769": { "city" : "PLAINVIEW", "state" : "NE", "county" : "PIERCE" },
            "68770": { "city" : "PONCA", "state" : "NE", "county" : "DIXON" },"68771": { "city" : "RANDOLPH", "state" : "NE", "county" : "CEDAR" },
            "68773": { "city" : "ROYAL", "state" : "NE", "county" : "ANTELOPE" },
            "68774": { "city" : "SAINT HELENA", "state" : "NE", "county" : "CEDAR" },
            "68776": { "city" : "SOUTH SIOUX CITY", "state" : "NE", "county" : "DAKOTA" },
            "68777": { "city" : "SPENCER", "state" : "NE", "county" : "BOYD" },"68778": { "city" : "SPRINGVIEW", "state" : "NE", "county" : "KEYA PAHA" },
            "68779": { "city" : "STANTON", "state" : "NE", "county" : "STANTON" },
            "68780": { "city" : "STUART", "state" : "NE", "county" : "HOLT" },"68781": { "city" : "TILDEN", "state" : "NE", "county" : "MADISON" },
            "68783": { "city" : "VERDIGRE", "state" : "NE", "county" : "KNOX" },"68784": { "city" : "WAKEFIELD", "state" : "NE", "county" : "DIXON" },
            "68785": { "city" : "WATERBURY", "state" : "NE", "county" : "DIXON" },
            "68786": { "city" : "WAUSA", "state" : "NE", "county" : "KNOX" },"68787": { "city" : "WAYNE", "state" : "NE", "county" : "WAYNE" },
            "68788": { "city" : "WEST POINT", "state" : "NE", "county" : "CUMING" },
            "68789": { "city" : "WINNETOON", "state" : "NE", "county" : "KNOX" },
            "68790": { "city" : "WINSIDE", "state" : "NE", "county" : "WAYNE" },"68791": { "city" : "WISNER", "state" : "NE", "county" : "CUMING" },
            "68792": { "city" : "WYNOT", "state" : "NE", "county" : "CEDAR" },"68801": { "city" : "GRAND ISLAND", "state" : "NE", "county" : "HALL" },
            "68802": { "city" : "GRAND ISLAND", "state" : "NE", "county" : "HALL" },
            "68803": { "city" : "GRAND ISLAND", "state" : "NE", "county" : "HALL" },
            "68810": { "city" : "ALDA", "state" : "NE", "county" : "HALL" },"68812": { "city" : "AMHERST", "state" : "NE", "county" : "BUFFALO" },
            "68813": { "city" : "ANSELMO", "state" : "NE", "county" : "CUSTER" },
            "68814": { "city" : "ANSLEY", "state" : "NE", "county" : "CUSTER" },"68815": { "city" : "ARCADIA", "state" : "NE", "county" : "VALLEY" },
            "68816": { "city" : "ARCHER", "state" : "NE", "county" : "MERRICK" },
            "68817": { "city" : "ASHTON", "state" : "NE", "county" : "SHERMAN" },
            "68818": { "city" : "AURORA", "state" : "NE", "county" : "HAMILTON" },
            "68820": { "city" : "BOELUS", "state" : "NE", "county" : "HOWARD" },"68821": { "city" : "BREWSTER", "state" : "NE", "county" : "BLAINE" },
            "68822": { "city" : "BROKEN BOW", "state" : "NE", "county" : "CUSTER" },
            "68823": { "city" : "BURWELL", "state" : "NE", "county" : "GARFIELD" },
            "68824": { "city" : "CAIRO", "state" : "NE", "county" : "HALL" },"68825": { "city" : "CALLAWAY", "state" : "NE", "county" : "CUSTER" },
            "68826": { "city" : "CENTRAL CITY", "state" : "NE", "county" : "MERRICK" },
            "68827": { "city" : "CHAPMAN", "state" : "NE", "county" : "MERRICK" },
            "68828": { "city" : "COMSTOCK", "state" : "NE", "county" : "CUSTER" },
            "68831": { "city" : "DANNEBROG", "state" : "NE", "county" : "HOWARD" },
            "68832": { "city" : "DONIPHAN", "state" : "NE", "county" : "HALL" },"68833": { "city" : "DUNNING", "state" : "NE", "county" : "BLAINE" },
            "68834": { "city" : "EDDYVILLE", "state" : "NE", "county" : "DAWSON" },
            "68835": { "city" : "ELBA", "state" : "NE", "county" : "HOWARD" },"68836": { "city" : "ELM CREEK", "state" : "NE", "county" : "BUFFALO" },
            "68837": { "city" : "ELYRIA", "state" : "NE", "county" : "VALLEY" },"68838": { "city" : "FARWELL", "state" : "NE", "county" : "HOWARD" },
            "68840": { "city" : "GIBBON", "state" : "NE", "county" : "BUFFALO" },
            "68841": { "city" : "GILTNER", "state" : "NE", "county" : "HAMILTON" },
            "68842": { "city" : "GREELEY", "state" : "NE", "county" : "GREELEY" },
            "68843": { "city" : "HAMPTON", "state" : "NE", "county" : "HAMILTON" },
            "68844": { "city" : "HAZARD", "state" : "NE", "county" : "SHERMAN" },
            "68845": { "city" : "KEARNEY", "state" : "NE", "county" : "BUFFALO" },
            "68846": { "city" : "HORDVILLE", "state" : "NE", "county" : "HAMILTON" },
            "68847": { "city" : "KEARNEY", "state" : "NE", "county" : "BUFFALO" },
            "68848": { "city" : "KEARNEY", "state" : "NE", "county" : "BUFFALO" },
            "68849": { "city" : "KEARNEY", "state" : "NE", "county" : "BUFFALO" },
            "68850": { "city" : "LEXINGTON", "state" : "NE", "county" : "DAWSON" },
            "68852": { "city" : "LITCHFIELD", "state" : "NE", "county" : "SHERMAN" },
            "68853": { "city" : "LOUP CITY", "state" : "NE", "county" : "SHERMAN" },
            "68854": { "city" : "MARQUETTE", "state" : "NE", "county" : "HAMILTON" },
            "68855": { "city" : "MASON CITY", "state" : "NE", "county" : "CUSTER" },
            "68856": { "city" : "MERNA", "state" : "NE", "county" : "CUSTER" },"68858": { "city" : "MILLER", "state" : "NE", "county" : "BUFFALO" },
            "68859": { "city" : "NORTH LOUP", "state" : "NE", "county" : "VALLEY" },
            "68860": { "city" : "OCONTO", "state" : "NE", "county" : "CUSTER" },"68861": { "city" : "ODESSA", "state" : "NE", "county" : "BUFFALO" },
            "68862": { "city" : "ORD", "state" : "NE", "county" : "VALLEY" },"68863": { "city" : "OVERTON", "state" : "NE", "county" : "DAWSON" },
            "68864": { "city" : "PALMER", "state" : "NE", "county" : "MERRICK" },
            "68865": { "city" : "PHILLIPS", "state" : "NE", "county" : "HAMILTON" },
            "68866": { "city" : "PLEASANTON", "state" : "NE", "county" : "BUFFALO" },
            "68869": { "city" : "RAVENNA", "state" : "NE", "county" : "BUFFALO" },
            "68870": { "city" : "RIVERDALE", "state" : "NE", "county" : "BUFFALO" },
            "68871": { "city" : "ROCKVILLE", "state" : "NE", "county" : "SHERMAN" },
            "68872": { "city" : "SAINT LIBORY", "state" : "NE", "county" : "HOWARD" },
            "68873": { "city" : "SAINT PAUL", "state" : "NE", "county" : "HOWARD" },
            "68874": { "city" : "SARGENT", "state" : "NE", "county" : "CUSTER" },
            "68875": { "city" : "SCOTIA", "state" : "NE", "county" : "GREELEY" },
            "68876": { "city" : "SHELTON", "state" : "NE", "county" : "BUFFALO" },
            "68878": { "city" : "SUMNER", "state" : "NE", "county" : "DAWSON" },"68879": { "city" : "TAYLOR", "state" : "NE", "county" : "LOUP" },
            "68881": { "city" : "WESTERVILLE", "state" : "NE", "county" : "CUSTER" },
            "68882": { "city" : "WOLBACH", "state" : "NE", "county" : "GREELEY" },
            "68883": { "city" : "WOOD RIVER", "state" : "NE", "county" : "HALL" },
            "68901": { "city" : "HASTINGS", "state" : "NE", "county" : "ADAMS" },
            "68902": { "city" : "HASTINGS", "state" : "NE", "county" : "ADAMS" },
            "68920": { "city" : "ALMA", "state" : "NE", "county" : "HARLAN" },"68922": { "city" : "ARAPAHOE", "state" : "NE", "county" : "FURNAS" },
            "68923": { "city" : "ATLANTA", "state" : "NE", "county" : "PHELPS" },
            "68924": { "city" : "AXTELL", "state" : "NE", "county" : "KEARNEY" },
            "68925": { "city" : "AYR", "state" : "NE", "county" : "ADAMS" },"68926": { "city" : "BEAVER CITY", "state" : "NE", "county" : "FURNAS" },
            "68927": { "city" : "BERTRAND", "state" : "NE", "county" : "PHELPS" },
            "68928": { "city" : "BLADEN", "state" : "NE", "county" : "WEBSTER" },
            "68929": { "city" : "BLOOMINGTON", "state" : "NE", "county" : "FRANKLIN" },
            "68930": { "city" : "BLUE HILL", "state" : "NE", "county" : "WEBSTER" },
            "68932": { "city" : "CAMPBELL", "state" : "NE", "county" : "FRANKLIN" },
            "68933": { "city" : "CLAY CENTER", "state" : "NE", "county" : "CLAY" },
            "68934": { "city" : "DEWEESE", "state" : "NE", "county" : "CLAY" },"68935": { "city" : "EDGAR", "state" : "NE", "county" : "CLAY" },
            "68936": { "city" : "EDISON", "state" : "NE", "county" : "FURNAS" },"68937": { "city" : "ELWOOD", "state" : "NE", "county" : "GOSPER" },
            "68938": { "city" : "FAIRFIELD", "state" : "NE", "county" : "CLAY" },
            "68939": { "city" : "FRANKLIN", "state" : "NE", "county" : "FRANKLIN" },
            "68940": { "city" : "FUNK", "state" : "NE", "county" : "PHELPS" },"68941": { "city" : "GLENVIL", "state" : "NE", "county" : "CLAY" },
            "68942": { "city" : "GUIDE ROCK", "state" : "NE", "county" : "WEBSTER" },
            "68943": { "city" : "HARDY", "state" : "NE", "county" : "NUCKOLLS" },
            "68944": { "city" : "HARVARD", "state" : "NE", "county" : "CLAY" },"68945": { "city" : "HEARTWELL", "state" : "NE", "county" : "KEARNEY" },
            "68946": { "city" : "HENDLEY", "state" : "NE", "county" : "FURNAS" },
            "68947": { "city" : "HILDRETH", "state" : "NE", "county" : "FRANKLIN" },
            "68948": { "city" : "HOLBROOK", "state" : "NE", "county" : "FURNAS" },
            "68949": { "city" : "HOLDREGE", "state" : "NE", "county" : "PHELPS" },
            "68950": { "city" : "HOLSTEIN", "state" : "NE", "county" : "ADAMS" },
            "68952": { "city" : "INAVALE", "state" : "NE", "county" : "WEBSTER" },
            "68954": { "city" : "INLAND", "state" : "NE", "county" : "CLAY" },"68955": { "city" : "JUNIATA", "state" : "NE", "county" : "ADAMS" },
            "68956": { "city" : "KENESAW", "state" : "NE", "county" : "ADAMS" },"68957": { "city" : "LAWRENCE", "state" : "NE", "county" : "NUCKOLLS" },
            "68958": { "city" : "LOOMIS", "state" : "NE", "county" : "PHELPS" },"68959": { "city" : "MINDEN", "state" : "NE", "county" : "KEARNEY" },
            "68960": { "city" : "NAPONEE", "state" : "NE", "county" : "FRANKLIN" },
            "68961": { "city" : "NELSON", "state" : "NE", "county" : "NUCKOLLS" },
            "68964": { "city" : "OAK", "state" : "NE", "county" : "NUCKOLLS" },"68966": { "city" : "ORLEANS", "state" : "NE", "county" : "HARLAN" },
            "68967": { "city" : "OXFORD", "state" : "NE", "county" : "FURNAS" },"68969": { "city" : "RAGAN", "state" : "NE", "county" : "HARLAN" },
            "68970": { "city" : "RED CLOUD", "state" : "NE", "county" : "WEBSTER" },
            "68971": { "city" : "REPUBLICAN CITY", "state" : "NE", "county" : "HARLAN" },
            "68972": { "city" : "RIVERTON", "state" : "NE", "county" : "FRANKLIN" },
            "68973": { "city" : "ROSELAND", "state" : "NE", "county" : "ADAMS" },
            "68974": { "city" : "RUSKIN", "state" : "NE", "county" : "NUCKOLLS" },
            "68975": { "city" : "SARONVILLE", "state" : "NE", "county" : "CLAY" },
            "68976": { "city" : "SMITHFIELD", "state" : "NE", "county" : "GOSPER" },
            "68977": { "city" : "STAMFORD", "state" : "NE", "county" : "HARLAN" },
            "68978": { "city" : "SUPERIOR", "state" : "NE", "county" : "NUCKOLLS" },
            "68979": { "city" : "SUTTON", "state" : "NE", "county" : "CLAY" },"68980": { "city" : "TRUMBULL", "state" : "NE", "county" : "CLAY" },
            "68981": { "city" : "UPLAND", "state" : "NE", "county" : "FRANKLIN" },
            "68982": { "city" : "WILCOX", "state" : "NE", "county" : "KEARNEY" },
            "69001": { "city" : "MC COOK", "state" : "NE", "county" : "RED WILLOW" },
            "69020": { "city" : "BARTLEY", "state" : "NE", "county" : "RED WILLOW" },
            "69021": { "city" : "BENKELMAN", "state" : "NE", "county" : "DUNDY" },
            "69022": { "city" : "CAMBRIDGE", "state" : "NE", "county" : "FURNAS" },
            "69023": { "city" : "CHAMPION", "state" : "NE", "county" : "CHASE" },
            "69024": { "city" : "CULBERTSON", "state" : "NE", "county" : "HITCHCOCK" },
            "69025": { "city" : "CURTIS", "state" : "NE", "county" : "FRONTIER" },
            "69026": { "city" : "DANBURY", "state" : "NE", "county" : "RED WILLOW" },
            "69027": { "city" : "ENDERS", "state" : "NE", "county" : "CHASE" },"69028": { "city" : "EUSTIS", "state" : "NE", "county" : "FRONTIER" },
            "69029": { "city" : "FARNAM", "state" : "NE", "county" : "DAWSON" },"69030": { "city" : "HAIGLER", "state" : "NE", "county" : "DUNDY" },
            "69032": { "city" : "HAYES CENTER", "state" : "NE", "county" : "HAYES" },
            "69033": { "city" : "IMPERIAL", "state" : "NE", "county" : "CHASE" },
            "69034": { "city" : "INDIANOLA", "state" : "NE", "county" : "RED WILLOW" },
            "69036": { "city" : "LEBANON", "state" : "NE", "county" : "RED WILLOW" },
            "69037": { "city" : "MAX", "state" : "NE", "county" : "DUNDY" },"69038": { "city" : "MAYWOOD", "state" : "NE", "county" : "FRONTIER" },
            "69039": { "city" : "MOOREFIELD", "state" : "NE", "county" : "FRONTIER" },
            "69040": { "city" : "PALISADE", "state" : "NE", "county" : "HITCHCOCK" },
            "69043": { "city" : "STRATTON", "state" : "NE", "county" : "HITCHCOCK" },
            "69044": { "city" : "TRENTON", "state" : "NE", "county" : "HITCHCOCK" },
            "69045": { "city" : "WAUNETA", "state" : "NE", "county" : "CHASE" },"69046": { "city" : "WILSONVILLE", "state" : "NE", "county" : "FURNAS" },
            "69101": { "city" : "NORTH PLATTE", "state" : "NE", "county" : "LINCOLN" },
            "69103": { "city" : "NORTH PLATTE", "state" : "NE", "county" : "LINCOLN" },
            "69120": { "city" : "ARNOLD", "state" : "NE", "county" : "CUSTER" },"69121": { "city" : "ARTHUR", "state" : "NE", "county" : "ARTHUR" },
            "69122": { "city" : "BIG SPRINGS", "state" : "NE", "county" : "DEUEL" },
            "69123": { "city" : "BRADY", "state" : "NE", "county" : "LINCOLN" },"69125": { "city" : "BROADWATER", "state" : "NE", "county" : "MORRILL" },
            "69127": { "city" : "BRULE", "state" : "NE", "county" : "KEITH" },"69128": { "city" : "BUSHNELL", "state" : "NE", "county" : "KIMBALL" },
            "69129": { "city" : "CHAPPELL", "state" : "NE", "county" : "DEUEL" },
            "69130": { "city" : "COZAD", "state" : "NE", "county" : "DAWSON" },"69131": { "city" : "DALTON", "state" : "NE", "county" : "CHEYENNE" },
            "69133": { "city" : "DIX", "state" : "NE", "county" : "KIMBALL" },"69134": { "city" : "ELSIE", "state" : "NE", "county" : "PERKINS" },
            "69138": { "city" : "GOTHENBURG", "state" : "NE", "county" : "DAWSON" },
            "69140": { "city" : "GRANT", "state" : "NE", "county" : "PERKINS" },"69141": { "city" : "GURLEY", "state" : "NE", "county" : "CHEYENNE" },
            "69142": { "city" : "HALSEY", "state" : "NE", "county" : "THOMAS" },"69143": { "city" : "HERSHEY", "state" : "NE", "county" : "LINCOLN" },
            "69144": { "city" : "KEYSTONE", "state" : "NE", "county" : "KEITH" },
            "69145": { "city" : "KIMBALL", "state" : "NE", "county" : "KIMBALL" },
            "69146": { "city" : "LEMOYNE", "state" : "NE", "county" : "KEITH" },"69147": { "city" : "LEWELLEN", "state" : "NE", "county" : "GARDEN" },
            "69148": { "city" : "LISCO", "state" : "NE", "county" : "GARDEN" },"69149": { "city" : "LODGEPOLE", "state" : "NE", "county" : "CHEYENNE" },
            "69150": { "city" : "MADRID", "state" : "NE", "county" : "PERKINS" },
            "69151": { "city" : "MAXWELL", "state" : "NE", "county" : "LINCOLN" },
            "69152": { "city" : "MULLEN", "state" : "NE", "county" : "HOOKER" },"69153": { "city" : "OGALLALA", "state" : "NE", "county" : "KEITH" },
            "69154": { "city" : "OSHKOSH", "state" : "NE", "county" : "GARDEN" },
            "69155": { "city" : "PAXTON", "state" : "NE", "county" : "KEITH" },"69156": { "city" : "POTTER", "state" : "NE", "county" : "CHEYENNE" },
            "69157": { "city" : "PURDUM", "state" : "NE", "county" : "BLAINE" },"69160": { "city" : "SIDNEY", "state" : "NE", "county" : "CHEYENNE" },
            "69161": { "city" : "SENECA", "state" : "NE", "county" : "THOMAS" },"69162": { "city" : "SIDNEY", "state" : "NE", "county" : "CHEYENNE" },
            "69163": { "city" : "STAPLETON", "state" : "NE", "county" : "LOGAN" },
            "69165": { "city" : "SUTHERLAND", "state" : "NE", "county" : "LINCOLN" },
            "69166": { "city" : "THEDFORD", "state" : "NE", "county" : "THOMAS" },
            "69167": { "city" : "TRYON", "state" : "NE", "county" : "MCPHERSON" },
            "69168": { "city" : "VENANGO", "state" : "NE", "county" : "PERKINS" },
            "69169": { "city" : "WALLACE", "state" : "NE", "county" : "LINCOLN" },
            "69170": { "city" : "WELLFLEET", "state" : "NE", "county" : "LINCOLN" },
            "69171": { "city" : "WILLOW ISLAND", "state" : "NE", "county" : "DAWSON" },
            "69190": { "city" : "OSHKOSH", "state" : "NE", "county" : "GARDEN" },
            "69201": { "city" : "VALENTINE", "state" : "NE", "county" : "CHERRY" },
            "69210": { "city" : "AINSWORTH", "state" : "NE", "county" : "BROWN" },
            "69211": { "city" : "CODY", "state" : "NE", "county" : "CHERRY" },"69212": { "city" : "CROOKSTON", "state" : "NE", "county" : "CHERRY" },
            "69214": { "city" : "JOHNSTOWN", "state" : "NE", "county" : "BROWN" },
            "69216": { "city" : "KILGORE", "state" : "NE", "county" : "CHERRY" },
            "69217": { "city" : "LONG PINE", "state" : "NE", "county" : "BROWN" },
            "69218": { "city" : "MERRIMAN", "state" : "NE", "county" : "CHERRY" },
            "69219": { "city" : "NENZEL", "state" : "NE", "county" : "CHERRY" },"69220": { "city" : "SPARKS", "state" : "NE", "county" : "CHERRY" },
            "69221": { "city" : "WOOD LAKE", "state" : "NE", "county" : "CHERRY" },
            "69301": { "city" : "ALLIANCE", "state" : "NE", "county" : "BOX BUTTE" },
            "69333": { "city" : "ASHBY", "state" : "NE", "county" : "GRANT" },"69334": { "city" : "BAYARD", "state" : "NE", "county" : "MORRILL" },
            "69336": { "city" : "BRIDGEPORT", "state" : "NE", "county" : "MORRILL" },
            "69337": { "city" : "CHADRON", "state" : "NE", "county" : "DAWES" },"69339": { "city" : "CRAWFORD", "state" : "NE", "county" : "DAWES" },
            "69340": { "city" : "ELLSWORTH", "state" : "NE", "county" : "SHERIDAN" },
            "69341": { "city" : "GERING", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69343": { "city" : "GORDON", "state" : "NE", "county" : "SHERIDAN" },
            "69345": { "city" : "HARRISBURG", "state" : "NE", "county" : "BANNER" },
            "69346": { "city" : "HARRISON", "state" : "NE", "county" : "SIOUX" },
            "69347": { "city" : "HAY SPRINGS", "state" : "NE", "county" : "SHERIDAN" },
            "69348": { "city" : "HEMINGFORD", "state" : "NE", "county" : "BOX BUTTE" },
            "69350": { "city" : "HYANNIS", "state" : "NE", "county" : "GRANT" },"69351": { "city" : "LAKESIDE", "state" : "NE", "county" : "SHERIDAN" },
            "69352": { "city" : "LYMAN", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69353": { "city" : "MCGREW", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69355": { "city" : "MELBETA", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69356": { "city" : "MINATARE", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69357": { "city" : "MITCHELL", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69358": { "city" : "MORRILL", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69360": { "city" : "RUSHVILLE", "state" : "NE", "county" : "SHERIDAN" },
            "69361": { "city" : "SCOTTSBLUFF", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69363": { "city" : "SCOTTSBLUFF", "state" : "NE", "county" : "SCOTTS BLUFF" },
            "69365": { "city" : "WHITECLAY", "state" : "NE", "county" : "SHERIDAN" },
            "69366": { "city" : "WHITMAN", "state" : "NE", "county" : "GRANT" },"69367": { "city" : "WHITNEY", "state" : "NE", "county" : "DAWES" },
            "70001": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70002": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70003": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70004": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70005": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70006": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70009": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70010": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70011": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70030": { "city" : "DES ALLEMANDS", "state" : "LA", "county" : "SAINT CHARLES" },
            "70031": { "city" : "AMA", "state" : "LA", "county" : "SAINT CHARLES" },
            "70032": { "city" : "ARABI", "state" : "LA", "county" : "SAINT BERNARD" },
            "70033": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70036": { "city" : "BARATARIA", "state" : "LA", "county" : "JEFFERSON" },
            "70037": { "city" : "BELLE CHASSE", "state" : "LA", "county" : "PLAQUEMINES" },
            "70038": { "city" : "BOOTHVILLE", "state" : "LA", "county" : "PLAQUEMINES" },
            "70039": { "city" : "BOUTTE", "state" : "LA", "county" : "SAINT CHARLES" },
            "70040": { "city" : "BRAITHWAITE", "state" : "LA", "county" : "PLAQUEMINES" },
            "70041": { "city" : "BURAS", "state" : "LA", "county" : "PLAQUEMINES" },
            "70043": { "city" : "CHALMETTE", "state" : "LA", "county" : "SAINT BERNARD" },
            "70044": { "city" : "CHALMETTE", "state" : "LA", "county" : "SAINT BERNARD" },
            "70047": { "city" : "DESTREHAN", "state" : "LA", "county" : "SAINT CHARLES" },
            "70049": { "city" : "EDGARD", "state" : "LA", "county" : "ST JOHN THE BAPTIST" },
            "70050": { "city" : "EMPIRE", "state" : "LA", "county" : "PLAQUEMINES" },
            "70051": { "city" : "GARYVILLE", "state" : "LA", "county" : "ST JOHN THE BAPTIST" },
            "70052": { "city" : "GRAMERCY", "state" : "LA", "county" : "SAINT JAMES" },
            "70053": { "city" : "GRETNA", "state" : "LA", "county" : "JEFFERSON" },
            "70054": { "city" : "GRETNA", "state" : "LA", "county" : "JEFFERSON" },
            "70055": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70056": { "city" : "GRETNA", "state" : "LA", "county" : "JEFFERSON" },
            "70057": { "city" : "HAHNVILLE", "state" : "LA", "county" : "SAINT CHARLES" },
            "70058": { "city" : "HARVEY", "state" : "LA", "county" : "JEFFERSON" },
            "70059": { "city" : "HARVEY", "state" : "LA", "county" : "JEFFERSON" },
            "70060": { "city" : "METAIRIE", "state" : "LA", "county" : "JEFFERSON" },
            "70062": { "city" : "KENNER", "state" : "LA", "county" : "JEFFERSON" },
            "70063": { "city" : "KENNER", "state" : "LA", "county" : "JEFFERSON" },
            "70064": { "city" : "KENNER", "state" : "LA", "county" : "JEFFERSON" },
            "70065": { "city" : "KENNER", "state" : "LA", "county" : "JEFFERSON" },
            "70067": { "city" : "LAFITTE", "state" : "LA", "county" : "JEFFERSON" },
            "70068": { "city" : "LA PLACE", "state" : "LA", "county" : "ST JOHN THE BAPTIST" },
            "70069": { "city" : "LA PLACE", "state" : "LA", "county" : "ST JOHN THE BAPTIST" },
            "70070": { "city" : "LULING", "state" : "LA", "county" : "SAINT CHARLES" },
            "70071": { "city" : "LUTCHER", "state" : "LA", "county" : "SAINT JAMES" },
            "70072": { "city" : "MARRERO", "state" : "LA", "county" : "JEFFERSON" },
            "70073": { "city" : "MARRERO", "state" : "LA", "county" : "JEFFERSON" },
            "70075": { "city" : "MERAUX", "state" : "LA", "county" : "SAINT BERNARD" },
            "70076": { "city" : "MOUNT AIRY", "state" : "LA", "county" : "ST JOHN THE BAPTIST" },
            "70078": { "city" : "NEW SARPY", "state" : "LA", "county" : "SAINT CHARLES" },
            "70079": { "city" : "NORCO", "state" : "LA", "county" : "SAINT CHARLES" },
            "70080": { "city" : "PARADIS", "state" : "LA", "county" : "SAINT CHARLES" },
            "70082": { "city" : "POINTE A LA HACHE", "state" : "LA", "county" : "PLAQUEMINES" },
            "70083": { "city" : "PORT SULPHUR", "state" : "LA", "county" : "PLAQUEMINES" },
            "70084": { "city" : "RESERVE", "state" : "LA", "county" : "ST JOHN THE BAPTIST" },
            "70085": { "city" : "SAINT BERNARD", "state" : "LA", "county" : "SAINT BERNARD" },
            "70086": { "city" : "SAINT JAMES", "state" : "LA", "county" : "SAINT JAMES" },
            "70087": { "city" : "SAINT ROSE", "state" : "LA", "county" : "SAINT CHARLES" },
            "70090": { "city" : "VACHERIE", "state" : "LA", "county" : "SAINT JAMES" },
            "70091": { "city" : "VENICE", "state" : "LA", "county" : "PLAQUEMINES" },
            "70092": { "city" : "VIOLET", "state" : "LA", "county" : "SAINT BERNARD" },
            "70094": { "city" : "WESTWEGO", "state" : "LA", "county" : "JEFFERSON" },
            "70096": { "city" : "WESTWEGO", "state" : "LA", "county" : "JEFFERSON" },
            "70097": { "city" : "KENNER", "state" : "LA", "county" : "JEFFERSON" },
            "70112": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70113": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70114": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70115": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70116": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70117": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70118": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70119": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70121": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "JEFFERSON" },
            "70122": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70123": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "JEFFERSON" },
            "70124": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70125": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70126": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70127": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70128": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70129": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70130": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70131": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70139": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70140": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70141": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "JEFFERSON" },
            "70142": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70143": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70145": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70146": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70148": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70150": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70151": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70152": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70153": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70156": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70157": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70160": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70161": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70162": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70163": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70164": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70165": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70167": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70170": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70172": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70174": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70175": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70177": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70178": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70179": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70181": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "JEFFERSON" },
            "70182": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70183": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "JEFFERSON" },
            "70184": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70185": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70187": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70189": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70190": { "city" : "NEW ORLEANS", "state" : "LA", "county" : "ORLEANS" },
            "70301": { "city" : "THIBODAUX", "state" : "LA", "county" : "LAFOURCHE" },
            "70302": { "city" : "THIBODAUX", "state" : "LA", "county" : "LAFOURCHE" },
            "70310": { "city" : "THIBODAUX", "state" : "LA", "county" : "LAFOURCHE" },
            "70339": { "city" : "PIERRE PART", "state" : "LA", "county" : "ASSUMPTION" },
            "70340": { "city" : "AMELIA", "state" : "LA", "county" : "SAINT MARY" },
            "70341": { "city" : "BELLE ROSE", "state" : "LA", "county" : "ASSUMPTION" },
            "70342": { "city" : "BERWICK", "state" : "LA", "county" : "SAINT MARY" },
            "70343": { "city" : "BOURG", "state" : "LA", "county" : "TERREBONNE" },
            "70344": { "city" : "CHAUVIN", "state" : "LA", "county" : "TERREBONNE" },
            "70345": { "city" : "CUT OFF", "state" : "LA", "county" : "LAFOURCHE" },
            "70346": { "city" : "DONALDSONVILLE", "state" : "LA", "county" : "ASCENSION" },
            "70352": { "city" : "DONNER", "state" : "LA", "county" : "TERREBONNE" },
            "70353": { "city" : "DULAC", "state" : "LA", "county" : "TERREBONNE" },
            "70354": { "city" : "GALLIANO", "state" : "LA", "county" : "LAFOURCHE" },
            "70355": { "city" : "GHEENS", "state" : "LA", "county" : "LAFOURCHE" },
            "70356": { "city" : "GIBSON", "state" : "LA", "county" : "TERREBONNE" },
            "70357": { "city" : "GOLDEN MEADOW", "state" : "LA", "county" : "LAFOURCHE" },
            "70358": { "city" : "GRAND ISLE", "state" : "LA", "county" : "JEFFERSON" },
            "70359": { "city" : "GRAY", "state" : "LA", "county" : "TERREBONNE" },
            "70360": { "city" : "HOUMA", "state" : "LA", "county" : "TERREBONNE" },
            "70361": { "city" : "HOUMA", "state" : "LA", "county" : "TERREBONNE" },
            "70363": { "city" : "HOUMA", "state" : "LA", "county" : "TERREBONNE" },
            "70364": { "city" : "HOUMA", "state" : "LA", "county" : "TERREBONNE" },
            "70372": { "city" : "LABADIEVILLE", "state" : "LA", "county" : "ASSUMPTION" },
            "70373": { "city" : "LAROSE", "state" : "LA", "county" : "LAFOURCHE" },
            "70374": { "city" : "LOCKPORT", "state" : "LA", "county" : "LAFOURCHE" },
            "70375": { "city" : "MATHEWS", "state" : "LA", "county" : "LAFOURCHE" },
            "70377": { "city" : "MONTEGUT", "state" : "LA", "county" : "TERREBONNE" },
            "70380": { "city" : "MORGAN CITY", "state" : "LA", "county" : "SAINT MARY" },
            "70381": { "city" : "MORGAN CITY", "state" : "LA", "county" : "SAINT MARY" },
            "70390": { "city" : "NAPOLEONVILLE", "state" : "LA", "county" : "ASSUMPTION" },
            "70391": { "city" : "PAINCOURTVILLE", "state" : "LA", "county" : "ASSUMPTION" },
            "70392": { "city" : "PATTERSON", "state" : "LA", "county" : "SAINT MARY" },
            "70393": { "city" : "PLATTENVILLE", "state" : "LA", "county" : "ASSUMPTION" },
            "70394": { "city" : "RACELAND", "state" : "LA", "county" : "LAFOURCHE" },
            "70395": { "city" : "SCHRIEVER", "state" : "LA", "county" : "TERREBONNE" },
            "70397": { "city" : "THERIOT", "state" : "LA", "county" : "TERREBONNE" },
            "70401": { "city" : "HAMMOND", "state" : "LA", "county" : "TANGIPAHOA" },
            "70402": { "city" : "HAMMOND", "state" : "LA", "county" : "TANGIPAHOA" },
            "70403": { "city" : "HAMMOND", "state" : "LA", "county" : "TANGIPAHOA" },
            "70404": { "city" : "HAMMOND", "state" : "LA", "county" : "TANGIPAHOA" },
            "70420": { "city" : "ABITA SPRINGS", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70421": { "city" : "AKERS", "state" : "LA", "county" : "TANGIPAHOA" },
            "70422": { "city" : "AMITE", "state" : "LA", "county" : "TANGIPAHOA" },
            "70426": { "city" : "ANGIE", "state" : "LA", "county" : "WASHINGTON" },
            "70427": { "city" : "BOGALUSA", "state" : "LA", "county" : "WASHINGTON" },
            "70429": { "city" : "BOGALUSA", "state" : "LA", "county" : "WASHINGTON" },
            "70431": { "city" : "BUSH", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70433": { "city" : "COVINGTON", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70434": { "city" : "COVINGTON", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70435": { "city" : "COVINGTON", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70436": { "city" : "FLUKER", "state" : "LA", "county" : "TANGIPAHOA" },
            "70437": { "city" : "FOLSOM", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70438": { "city" : "FRANKLINTON", "state" : "LA", "county" : "WASHINGTON" },
            "70441": { "city" : "GREENSBURG", "state" : "LA", "county" : "SAINT HELENA" },
            "70442": { "city" : "HUSSER", "state" : "LA", "county" : "TANGIPAHOA" },
            "70443": { "city" : "INDEPENDENCE", "state" : "LA", "county" : "TANGIPAHOA" },
            "70444": { "city" : "KENTWOOD", "state" : "LA", "county" : "TANGIPAHOA" },
            "70445": { "city" : "LACOMBE", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70446": { "city" : "LORANGER", "state" : "LA", "county" : "TANGIPAHOA" },
            "70447": { "city" : "MADISONVILLE", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70448": { "city" : "MANDEVILLE", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70449": { "city" : "MAUREPAS", "state" : "LA", "county" : "LIVINGSTON" },
            "70450": { "city" : "MOUNT HERMON", "state" : "LA", "county" : "WASHINGTON" },
            "70451": { "city" : "NATALBANY", "state" : "LA", "county" : "TANGIPAHOA" },
            "70452": { "city" : "PEARL RIVER", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70453": { "city" : "PINE GROVE", "state" : "LA", "county" : "SAINT HELENA" },
            "70454": { "city" : "PONCHATOULA", "state" : "LA", "county" : "TANGIPAHOA" },
            "70455": { "city" : "ROBERT", "state" : "LA", "county" : "TANGIPAHOA" },
            "70456": { "city" : "ROSELAND", "state" : "LA", "county" : "TANGIPAHOA" },
            "70457": { "city" : "SAINT BENEDICT", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70458": { "city" : "SLIDELL", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70459": { "city" : "SLIDELL", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70460": { "city" : "SLIDELL", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70461": { "city" : "SLIDELL", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70462": { "city" : "SPRINGFIELD", "state" : "LA", "county" : "LIVINGSTON" },
            "70463": { "city" : "SUN", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70465": { "city" : "TANGIPAHOA", "state" : "LA", "county" : "TANGIPAHOA" },
            "70466": { "city" : "TICKFAW", "state" : "LA", "county" : "TANGIPAHOA" },
            "70467": { "city" : "VARNADO", "state" : "LA", "county" : "WASHINGTON" },
            "70469": { "city" : "SLIDELL", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70470": { "city" : "MANDEVILLE", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70471": { "city" : "MANDEVILLE", "state" : "LA", "county" : "SAINT TAMMANY" },
            "70501": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70502": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70503": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70504": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70505": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70506": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70507": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70508": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70509": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70510": { "city" : "ABBEVILLE", "state" : "LA", "county" : "VERMILION" },
            "70511": { "city" : "ABBEVILLE", "state" : "LA", "county" : "VERMILION" },
            "70512": { "city" : "ARNAUDVILLE", "state" : "LA", "county" : "SAINT LANDRY" },
            "70513": { "city" : "AVERY ISLAND", "state" : "LA", "county" : "IBERIA" },
            "70514": { "city" : "BALDWIN", "state" : "LA", "county" : "SAINT MARY" },
            "70515": { "city" : "BASILE", "state" : "LA", "county" : "EVANGELINE" },
            "70516": { "city" : "BRANCH", "state" : "LA", "county" : "ACADIA" },"70517": { "city" : "BREAUX BRIDGE", "state" : "LA", "county" : "SAINT MARTIN" },
            "70518": { "city" : "BROUSSARD", "state" : "LA", "county" : "LAFAYETTE" },
            "70519": { "city" : "CADE", "state" : "LA", "county" : "SAINT MARTIN" },
            "70520": { "city" : "CARENCRO", "state" : "LA", "county" : "LAFAYETTE" },
            "70521": { "city" : "CECILIA", "state" : "LA", "county" : "SAINT MARTIN" },
            "70522": { "city" : "CENTERVILLE", "state" : "LA", "county" : "SAINT MARY" },
            "70523": { "city" : "CHARENTON", "state" : "LA", "county" : "SAINT MARY" },
            "70524": { "city" : "CHATAIGNIER", "state" : "LA", "county" : "EVANGELINE" },
            "70525": { "city" : "CHURCH POINT", "state" : "LA", "county" : "ACADIA" },
            "70526": { "city" : "CROWLEY", "state" : "LA", "county" : "ACADIA" },
            "70527": { "city" : "CROWLEY", "state" : "LA", "county" : "ACADIA" },
            "70528": { "city" : "DELCAMBRE", "state" : "LA", "county" : "VERMILION" },
            "70529": { "city" : "DUSON", "state" : "LA", "county" : "LAFAYETTE" },
            "70531": { "city" : "EGAN", "state" : "LA", "county" : "ACADIA" },"70532": { "city" : "ELTON", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70533": { "city" : "ERATH", "state" : "LA", "county" : "VERMILION" },
            "70534": { "city" : "ESTHERWOOD", "state" : "LA", "county" : "ACADIA" },
            "70535": { "city" : "EUNICE", "state" : "LA", "county" : "SAINT LANDRY" },
            "70537": { "city" : "EVANGELINE", "state" : "LA", "county" : "ACADIA" },
            "70538": { "city" : "FRANKLIN", "state" : "LA", "county" : "SAINT MARY" },
            "70540": { "city" : "GARDEN CITY", "state" : "LA", "county" : "SAINT MARY" },
            "70541": { "city" : "GRAND COTEAU", "state" : "LA", "county" : "SAINT LANDRY" },
            "70542": { "city" : "GUEYDAN", "state" : "LA", "county" : "VERMILION" },
            "70543": { "city" : "IOTA", "state" : "LA", "county" : "ACADIA" },"70544": { "city" : "JEANERETTE", "state" : "LA", "county" : "IBERIA" },
            "70546": { "city" : "JENNINGS", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70548": { "city" : "KAPLAN", "state" : "LA", "county" : "VERMILION" },
            "70549": { "city" : "LAKE ARTHUR", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70550": { "city" : "LAWTELL", "state" : "LA", "county" : "SAINT LANDRY" },
            "70551": { "city" : "LEONVILLE", "state" : "LA", "county" : "SAINT LANDRY" },
            "70552": { "city" : "LOREAUVILLE", "state" : "LA", "county" : "IBERIA" },
            "70554": { "city" : "MAMOU", "state" : "LA", "county" : "EVANGELINE" },
            "70555": { "city" : "MAURICE", "state" : "LA", "county" : "VERMILION" },
            "70556": { "city" : "MERMENTAU", "state" : "LA", "county" : "ACADIA" },
            "70558": { "city" : "MILTON", "state" : "LA", "county" : "LAFAYETTE" },
            "70559": { "city" : "MORSE", "state" : "LA", "county" : "ACADIA" },"70560": { "city" : "NEW IBERIA", "state" : "LA", "county" : "IBERIA" },
            "70562": { "city" : "NEW IBERIA", "state" : "LA", "county" : "IBERIA" },
            "70563": { "city" : "NEW IBERIA", "state" : "LA", "county" : "IBERIA" },
            "70569": { "city" : "LYDIA", "state" : "LA", "county" : "IBERIA" },"70570": { "city" : "OPELOUSAS", "state" : "LA", "county" : "SAINT LANDRY" },
            "70571": { "city" : "OPELOUSAS", "state" : "LA", "county" : "SAINT LANDRY" },
            "70576": { "city" : "PINE PRAIRIE", "state" : "LA", "county" : "EVANGELINE" },
            "70577": { "city" : "PORT BARRE", "state" : "LA", "county" : "SAINT LANDRY" },
            "70578": { "city" : "RAYNE", "state" : "LA", "county" : "ACADIA" },"70580": { "city" : "REDDELL", "state" : "LA", "county" : "EVANGELINE" },
            "70581": { "city" : "ROANOKE", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70582": { "city" : "SAINT MARTINVILLE", "state" : "LA", "county" : "SAINT MARTIN" },
            "70583": { "city" : "SCOTT", "state" : "LA", "county" : "LAFAYETTE" },
            "70584": { "city" : "SUNSET", "state" : "LA", "county" : "SAINT LANDRY" },
            "70585": { "city" : "TURKEY CREEK", "state" : "LA", "county" : "EVANGELINE" },
            "70586": { "city" : "VILLE PLATTE", "state" : "LA", "county" : "EVANGELINE" },
            "70589": { "city" : "WASHINGTON", "state" : "LA", "county" : "SAINT LANDRY" },
            "70591": { "city" : "WELSH", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70592": { "city" : "YOUNGSVILLE", "state" : "LA", "county" : "LAFAYETTE" },
            "70593": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70596": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70598": { "city" : "LAFAYETTE", "state" : "LA", "county" : "LAFAYETTE" },
            "70601": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70602": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70605": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70606": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70607": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70609": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70611": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70612": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70615": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70616": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70629": { "city" : "LAKE CHARLES", "state" : "LA", "county" : "CALCASIEU" },
            "70630": { "city" : "BELL CITY", "state" : "LA", "county" : "CALCASIEU" },
            "70631": { "city" : "CAMERON", "state" : "LA", "county" : "CAMERON" },
            "70632": { "city" : "CREOLE", "state" : "LA", "county" : "CAMERON" },
            "70633": { "city" : "DEQUINCY", "state" : "LA", "county" : "CALCASIEU" },
            "70634": { "city" : "DERIDDER", "state" : "LA", "county" : "BEAUREGARD" },
            "70637": { "city" : "DRY CREEK", "state" : "LA", "county" : "BEAUREGARD" },
            "70638": { "city" : "ELIZABETH", "state" : "LA", "county" : "ALLEN" },
            "70639": { "city" : "EVANS", "state" : "LA", "county" : "VERNON" },"70640": { "city" : "FENTON", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70643": { "city" : "GRAND CHENIER", "state" : "LA", "county" : "CAMERON" },
            "70644": { "city" : "GRANT", "state" : "LA", "county" : "ALLEN" },"70645": { "city" : "HACKBERRY", "state" : "LA", "county" : "CAMERON" },
            "70646": { "city" : "HAYES", "state" : "LA", "county" : "CALCASIEU" },
            "70647": { "city" : "IOWA", "state" : "LA", "county" : "CALCASIEU" },
            "70648": { "city" : "KINDER", "state" : "LA", "county" : "ALLEN" },"70650": { "city" : "LACASSINE", "state" : "LA", "county" : "JEFFERSON DAVIS" },
            "70651": { "city" : "LEBLANC", "state" : "LA", "county" : "ALLEN" },"70652": { "city" : "LONGVILLE", "state" : "LA", "county" : "BEAUREGARD" },
            "70653": { "city" : "MERRYVILLE", "state" : "LA", "county" : "BEAUREGARD" },
            "70654": { "city" : "MITTIE", "state" : "LA", "county" : "ALLEN" },"70655": { "city" : "OBERLIN", "state" : "LA", "county" : "ALLEN" },
            "70656": { "city" : "PITKIN", "state" : "LA", "county" : "VERNON" },"70657": { "city" : "RAGLEY", "state" : "LA", "county" : "BEAUREGARD" },
            "70658": { "city" : "REEVES", "state" : "LA", "county" : "ALLEN" },"70659": { "city" : "ROSEPINE", "state" : "LA", "county" : "VERNON" },
            "70660": { "city" : "SINGER", "state" : "LA", "county" : "BEAUREGARD" },
            "70661": { "city" : "STARKS", "state" : "LA", "county" : "CALCASIEU" },
            "70662": { "city" : "SUGARTOWN", "state" : "LA", "county" : "BEAUREGARD" },
            "70663": { "city" : "SULPHUR", "state" : "LA", "county" : "CALCASIEU" },
            "70664": { "city" : "SULPHUR", "state" : "LA", "county" : "CALCASIEU" },
            "70665": { "city" : "SULPHUR", "state" : "LA", "county" : "CALCASIEU" },
            "70668": { "city" : "VINTON", "state" : "LA", "county" : "CALCASIEU" },
            "70669": { "city" : "WESTLAKE", "state" : "LA", "county" : "CALCASIEU" },
            "70704": { "city" : "BAKER", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70706": { "city" : "DENHAM SPRINGS", "state" : "LA", "county" : "LIVINGSTON" },
            "70707": { "city" : "GONZALES", "state" : "LA", "county" : "ASCENSION" },
            "70710": { "city" : "ADDIS", "state" : "LA", "county" : "WEST BATON ROUGE" },
            "70711": { "city" : "ALBANY", "state" : "LA", "county" : "LIVINGSTON" },
            "70712": { "city" : "ANGOLA", "state" : "LA", "county" : "WEST FELICIANA" },
            "70714": { "city" : "BAKER", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70715": { "city" : "BATCHELOR", "state" : "LA", "county" : "POINTE COUPEE" },
            "70718": { "city" : "BRITTANY", "state" : "LA", "county" : "ASCENSION" },
            "70719": { "city" : "BRUSLY", "state" : "LA", "county" : "WEST BATON ROUGE" },
            "70721": { "city" : "CARVILLE", "state" : "LA", "county" : "IBERVILLE" },
            "70722": { "city" : "CLINTON", "state" : "LA", "county" : "EAST FELICIANA" },
            "70723": { "city" : "CONVENT", "state" : "LA", "county" : "SAINT JAMES" },
            "70725": { "city" : "DARROW", "state" : "LA", "county" : "ASCENSION" },
            "70726": { "city" : "DENHAM SPRINGS", "state" : "LA", "county" : "LIVINGSTON" },
            "70727": { "city" : "DENHAM SPRINGS", "state" : "LA", "county" : "LIVINGSTON" },
            "70728": { "city" : "DUPLESSIS", "state" : "LA", "county" : "ASCENSION" },
            "70729": { "city" : "ERWINVILLE", "state" : "LA", "county" : "WEST BATON ROUGE" },
            "70730": { "city" : "ETHEL", "state" : "LA", "county" : "EAST FELICIANA" },
            "70732": { "city" : "FORDOCHE", "state" : "LA", "county" : "POINTE COUPEE" },
            "70733": { "city" : "FRENCH SETTLEMENT", "state" : "LA", "county" : "LIVINGSTON" },
            "70734": { "city" : "GEISMAR", "state" : "LA", "county" : "ASCENSION" },
            "70736": { "city" : "GLYNN", "state" : "LA", "county" : "POINTE COUPEE" },
            "70737": { "city" : "GONZALES", "state" : "LA", "county" : "ASCENSION" },
            "70738": { "city" : "BURNSIDE", "state" : "LA", "county" : "ASCENSION" },
            "70739": { "city" : "GREENWELL SPRINGS", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70740": { "city" : "GROSSE TETE", "state" : "LA", "county" : "IBERVILLE" },
            "70743": { "city" : "HESTER", "state" : "LA", "county" : "SAINT JAMES" },
            "70744": { "city" : "HOLDEN", "state" : "LA", "county" : "LIVINGSTON" },
            "70747": { "city" : "INNIS", "state" : "LA", "county" : "POINTE COUPEE" },
            "70748": { "city" : "JACKSON", "state" : "LA", "county" : "EAST FELICIANA" },
            "70749": { "city" : "JARREAU", "state" : "LA", "county" : "POINTE COUPEE" },
            "70750": { "city" : "KROTZ SPRINGS", "state" : "LA", "county" : "SAINT LANDRY" },
            "70752": { "city" : "LAKELAND", "state" : "LA", "county" : "POINTE COUPEE" },
            "70753": { "city" : "LETTSWORTH", "state" : "LA", "county" : "POINTE COUPEE" },
            "70754": { "city" : "LIVINGSTON", "state" : "LA", "county" : "LIVINGSTON" },
            "70755": { "city" : "LIVONIA", "state" : "LA", "county" : "POINTE COUPEE" },
            "70756": { "city" : "LOTTIE", "state" : "LA", "county" : "POINTE COUPEE" },
            "70757": { "city" : "MARINGOUIN", "state" : "LA", "county" : "IBERVILLE" },
            "70759": { "city" : "MORGANZA", "state" : "LA", "county" : "POINTE COUPEE" },
            "70760": { "city" : "NEW ROADS", "state" : "LA", "county" : "POINTE COUPEE" },
            "70761": { "city" : "NORWOOD", "state" : "LA", "county" : "EAST FELICIANA" },
            "70762": { "city" : "OSCAR", "state" : "LA", "county" : "POINTE COUPEE" },
            "70763": { "city" : "PAULINA", "state" : "LA", "county" : "SAINT JAMES" },
            "70764": { "city" : "PLAQUEMINE", "state" : "LA", "county" : "IBERVILLE" },
            "70765": { "city" : "PLAQUEMINE", "state" : "LA", "county" : "IBERVILLE" },
            "70767": { "city" : "PORT ALLEN", "state" : "LA", "county" : "WEST BATON ROUGE" },
            "70769": { "city" : "PRAIRIEVILLE", "state" : "LA", "county" : "ASCENSION" },
            "70770": { "city" : "PRIDE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70772": { "city" : "ROSEDALE", "state" : "LA", "county" : "IBERVILLE" },
            "70774": { "city" : "SAINT AMANT", "state" : "LA", "county" : "ASCENSION" },
            "70775": { "city" : "SAINT FRANCISVILLE", "state" : "LA", "county" : "WEST FELICIANA" },
            "70776": { "city" : "SAINT GABRIEL", "state" : "LA", "county" : "IBERVILLE" },
            "70777": { "city" : "SLAUGHTER", "state" : "LA", "county" : "EAST FELICIANA" },
            "70778": { "city" : "SORRENTO", "state" : "LA", "county" : "ASCENSION" },
            "70780": { "city" : "SUNSHINE", "state" : "LA", "county" : "IBERVILLE" },
            "70782": { "city" : "TUNICA", "state" : "LA", "county" : "WEST FELICIANA" },
            "70783": { "city" : "VENTRESS", "state" : "LA", "county" : "POINTE COUPEE" },
            "70784": { "city" : "WAKEFIELD", "state" : "LA", "county" : "WEST FELICIANA" },
            "70785": { "city" : "WALKER", "state" : "LA", "county" : "LIVINGSTON" },
            "70786": { "city" : "WATSON", "state" : "LA", "county" : "LIVINGSTON" },
            "70787": { "city" : "WEYANOKE", "state" : "LA", "county" : "WEST FELICIANA" },
            "70788": { "city" : "WHITE CASTLE", "state" : "LA", "county" : "IBERVILLE" },
            "70789": { "city" : "WILSON", "state" : "LA", "county" : "EAST FELICIANA" },
            "70791": { "city" : "ZACHARY", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70792": { "city" : "UNCLE SAM", "state" : "LA", "county" : "SAINT JAMES" },
            "70801": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70802": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70803": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70804": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70805": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70806": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70807": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70808": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70809": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70810": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70811": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70812": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70813": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70814": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70815": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70816": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70817": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70818": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70819": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70820": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70821": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70825": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70826": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70827": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70831": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70835": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70836": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70837": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70874": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70879": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70884": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70892": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70893": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70894": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70895": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70896": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "70898": { "city" : "BATON ROUGE", "state" : "LA", "county" : "EAST BATON ROUGE" },
            "71001": { "city" : "ARCADIA", "state" : "LA", "county" : "BIENVILLE" },
            "71002": { "city" : "ASHLAND", "state" : "LA", "county" : "NATCHITOCHES" },
            "71003": { "city" : "ATHENS", "state" : "LA", "county" : "CLAIBORNE" },
            "71004": { "city" : "BELCHER", "state" : "LA", "county" : "CADDO" },"71006": { "city" : "BENTON", "state" : "LA", "county" : "BOSSIER" },
            "71007": { "city" : "BETHANY", "state" : "LA", "county" : "CADDO" },"71008": { "city" : "BIENVILLE", "state" : "LA", "county" : "BIENVILLE" },
            "71009": { "city" : "BLANCHARD", "state" : "LA", "county" : "CADDO" },
            "71016": { "city" : "CASTOR", "state" : "LA", "county" : "BIENVILLE" },
            "71018": { "city" : "COTTON VALLEY", "state" : "LA", "county" : "WEBSTER" },
            "71019": { "city" : "COUSHATTA", "state" : "LA", "county" : "RED RIVER" },
            "71021": { "city" : "CULLEN", "state" : "LA", "county" : "WEBSTER" },
            "71023": { "city" : "DOYLINE", "state" : "LA", "county" : "WEBSTER" },
            "71024": { "city" : "DUBBERLY", "state" : "LA", "county" : "WEBSTER" },
            "71027": { "city" : "FRIERSON", "state" : "LA", "county" : "DE SOTO" },
            "71028": { "city" : "GIBSLAND", "state" : "LA", "county" : "BIENVILLE" },
            "71029": { "city" : "GILLIAM", "state" : "LA", "county" : "CADDO" },"71030": { "city" : "GLOSTER", "state" : "LA", "county" : "DE SOTO" },
            "71031": { "city" : "GOLDONNA", "state" : "LA", "county" : "NATCHITOCHES" },
            "71032": { "city" : "GRAND CANE", "state" : "LA", "county" : "DE SOTO" },
            "71033": { "city" : "GREENWOOD", "state" : "LA", "county" : "CADDO" },
            "71034": { "city" : "HALL SUMMIT", "state" : "LA", "county" : "RED RIVER" },
            "71037": { "city" : "HAUGHTON", "state" : "LA", "county" : "BOSSIER" },
            "71038": { "city" : "HAYNESVILLE", "state" : "LA", "county" : "CLAIBORNE" },
            "71039": { "city" : "HEFLIN", "state" : "LA", "county" : "WEBSTER" },
            "71040": { "city" : "HOMER", "state" : "LA", "county" : "CLAIBORNE" },
            "71043": { "city" : "HOSSTON", "state" : "LA", "county" : "CADDO" },"71044": { "city" : "IDA", "state" : "LA", "county" : "CADDO" },
            "71045": { "city" : "JAMESTOWN", "state" : "LA", "county" : "BIENVILLE" },
            "71046": { "city" : "KEATCHIE", "state" : "LA", "county" : "DE SOTO" },
            "71047": { "city" : "KEITHVILLE", "state" : "LA", "county" : "CADDO" },
            "71048": { "city" : "LISBON", "state" : "LA", "county" : "CLAIBORNE" },
            "71049": { "city" : "LOGANSPORT", "state" : "LA", "county" : "DE SOTO" },
            "71051": { "city" : "ELM GROVE", "state" : "LA", "county" : "BOSSIER" },
            "71052": { "city" : "MANSFIELD", "state" : "LA", "county" : "DE SOTO" },
            "71055": { "city" : "MINDEN", "state" : "LA", "county" : "WEBSTER" },
            "71058": { "city" : "MINDEN", "state" : "LA", "county" : "WEBSTER" },
            "71060": { "city" : "MOORINGSPORT", "state" : "LA", "county" : "CADDO" },
            "71061": { "city" : "OIL CITY", "state" : "LA", "county" : "CADDO" },
            "71063": { "city" : "PELICAN", "state" : "LA", "county" : "DE SOTO" },
            "71064": { "city" : "PLAIN DEALING", "state" : "LA", "county" : "BOSSIER" },
            "71065": { "city" : "PLEASANT HILL", "state" : "LA", "county" : "SABINE" },
            "71066": { "city" : "POWHATAN", "state" : "LA", "county" : "NATCHITOCHES" },
            "71067": { "city" : "PRINCETON", "state" : "LA", "county" : "BOSSIER" },
            "71068": { "city" : "RINGGOLD", "state" : "LA", "county" : "BIENVILLE" },
            "71069": { "city" : "RODESSA", "state" : "LA", "county" : "CADDO" },"71070": { "city" : "SALINE", "state" : "LA", "county" : "BIENVILLE" },
            "71071": { "city" : "SAREPTA", "state" : "LA", "county" : "WEBSTER" },
            "71072": { "city" : "SHONGALOO", "state" : "LA", "county" : "WEBSTER" },
            "71073": { "city" : "SIBLEY", "state" : "LA", "county" : "WEBSTER" },
            "71075": { "city" : "SPRINGHILL", "state" : "LA", "county" : "WEBSTER" },
            "71078": { "city" : "STONEWALL", "state" : "LA", "county" : "DE SOTO" },
            "71079": { "city" : "SUMMERFIELD", "state" : "LA", "county" : "CLAIBORNE" },
            "71080": { "city" : "TAYLOR", "state" : "LA", "county" : "BIENVILLE" },
            "71082": { "city" : "VIVIAN", "state" : "LA", "county" : "CADDO" },"71101": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71102": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71103": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71104": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71105": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71106": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71107": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71108": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71109": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71110": { "city" : "BARKSDALE AFB", "state" : "LA", "county" : "BOSSIER" },
            "71111": { "city" : "BOSSIER CITY", "state" : "LA", "county" : "BOSSIER" },
            "71112": { "city" : "BOSSIER CITY", "state" : "LA", "county" : "BOSSIER" },
            "71113": { "city" : "BOSSIER CITY", "state" : "LA", "county" : "BOSSIER" },
            "71115": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71118": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71119": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71120": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71129": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71130": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71133": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71134": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71135": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71136": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71137": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71138": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71148": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71149": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71150": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71151": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71161": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71162": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71163": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71164": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71165": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71166": { "city" : "SHREVEPORT", "state" : "LA", "county" : "CADDO" },
            "71171": { "city" : "BOSSIER CITY", "state" : "LA", "county" : "BOSSIER" },
            "71172": { "city" : "BOSSIER CITY", "state" : "LA", "county" : "BOSSIER" },
            "71201": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71202": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71203": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71207": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71209": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71210": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71211": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71212": { "city" : "MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71218": { "city" : "ARCHIBALD", "state" : "LA", "county" : "RICHLAND" },
            "71219": { "city" : "BASKIN", "state" : "LA", "county" : "FRANKLIN" },
            "71220": { "city" : "BASTROP", "state" : "LA", "county" : "MOREHOUSE" },
            "71221": { "city" : "BASTROP", "state" : "LA", "county" : "MOREHOUSE" },
            "71222": { "city" : "BERNICE", "state" : "LA", "county" : "UNION" },"71223": { "city" : "BONITA", "state" : "LA", "county" : "MOREHOUSE" },
            "71225": { "city" : "CALHOUN", "state" : "LA", "county" : "OUACHITA" },
            "71226": { "city" : "CHATHAM", "state" : "LA", "county" : "JACKSON" },
            "71227": { "city" : "CHOUDRANT", "state" : "LA", "county" : "LINCOLN" },
            "71229": { "city" : "COLLINSTON", "state" : "LA", "county" : "MOREHOUSE" },
            "71230": { "city" : "CROWVILLE", "state" : "LA", "county" : "FRANKLIN" },
            "71232": { "city" : "DELHI", "state" : "LA", "county" : "RICHLAND" },
            "71233": { "city" : "DELTA", "state" : "LA", "county" : "MADISON" },"71234": { "city" : "DOWNSVILLE", "state" : "LA", "county" : "UNION" },
            "71235": { "city" : "DUBACH", "state" : "LA", "county" : "LINCOLN" },
            "71237": { "city" : "EPPS", "state" : "LA", "county" : "WEST CARROLL" },
            "71238": { "city" : "EROS", "state" : "LA", "county" : "OUACHITA" },"71240": { "city" : "FAIRBANKS", "state" : "LA", "county" : "OUACHITA" },
            "71241": { "city" : "FARMERVILLE", "state" : "LA", "county" : "UNION" },
            "71242": { "city" : "FOREST", "state" : "LA", "county" : "WEST CARROLL" },
            "71243": { "city" : "FORT NECESSITY", "state" : "LA", "county" : "FRANKLIN" },
            "71245": { "city" : "GRAMBLING", "state" : "LA", "county" : "LINCOLN" },
            "71247": { "city" : "HODGE", "state" : "LA", "county" : "JACKSON" },"71249": { "city" : "JIGGER", "state" : "LA", "county" : "FRANKLIN" },
            "71250": { "city" : "JONES", "state" : "LA", "county" : "MOREHOUSE" },
            "71251": { "city" : "JONESBORO", "state" : "LA", "county" : "JACKSON" },
            "71253": { "city" : "KILBOURNE", "state" : "LA", "county" : "WEST CARROLL" },
            "71254": { "city" : "LAKE PROVIDENCE", "state" : "LA", "county" : "EAST CARROLL" },
            "71256": { "city" : "LILLIE", "state" : "LA", "county" : "UNION" },"71259": { "city" : "MANGHAM", "state" : "LA", "county" : "RICHLAND" },
            "71260": { "city" : "MARION", "state" : "LA", "county" : "UNION" },"71261": { "city" : "MER ROUGE", "state" : "LA", "county" : "MOREHOUSE" },
            "71263": { "city" : "OAK GROVE", "state" : "LA", "county" : "WEST CARROLL" },
            "71264": { "city" : "OAK RIDGE", "state" : "LA", "county" : "MOREHOUSE" },
            "71266": { "city" : "PIONEER", "state" : "LA", "county" : "WEST CARROLL" },
            "71268": { "city" : "QUITMAN", "state" : "LA", "county" : "JACKSON" },
            "71269": { "city" : "RAYVILLE", "state" : "LA", "county" : "RICHLAND" },
            "71270": { "city" : "RUSTON", "state" : "LA", "county" : "LINCOLN" },
            "71272": { "city" : "RUSTON", "state" : "LA", "county" : "LINCOLN" },
            "71273": { "city" : "RUSTON", "state" : "LA", "county" : "LINCOLN" },
            "71275": { "city" : "SIMSBORO", "state" : "LA", "county" : "LINCOLN" },
            "71276": { "city" : "SONDHEIMER", "state" : "LA", "county" : "EAST CARROLL" },
            "71277": { "city" : "SPEARSVILLE", "state" : "LA", "county" : "UNION" },
            "71279": { "city" : "START", "state" : "LA", "county" : "RICHLAND" },
            "71280": { "city" : "STERLINGTON", "state" : "LA", "county" : "OUACHITA" },
            "71281": { "city" : "SWARTZ", "state" : "LA", "county" : "OUACHITA" },
            "71282": { "city" : "TALLULAH", "state" : "LA", "county" : "MADISON" },
            "71284": { "city" : "TALLULAH", "state" : "LA", "county" : "MADISON" },
            "71286": { "city" : "TRANSYLVANIA", "state" : "LA", "county" : "EAST CARROLL" },
            "71291": { "city" : "WEST MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71292": { "city" : "WEST MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71294": { "city" : "WEST MONROE", "state" : "LA", "county" : "OUACHITA" },
            "71295": { "city" : "WINNSBORO", "state" : "LA", "county" : "FRANKLIN" },
            "71301": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71302": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71303": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71306": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71307": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71309": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71315": { "city" : "ALEXANDRIA", "state" : "LA", "county" : "RAPIDES" },
            "71320": { "city" : "BORDELONVILLE", "state" : "LA", "county" : "AVOYELLES" },
            "71322": { "city" : "BUNKIE", "state" : "LA", "county" : "AVOYELLES" },
            "71323": { "city" : "CENTER POINT", "state" : "LA", "county" : "AVOYELLES" },
            "71324": { "city" : "CHASE", "state" : "LA", "county" : "FRANKLIN" },
            "71325": { "city" : "CHENEYVILLE", "state" : "LA", "county" : "RAPIDES" },
            "71326": { "city" : "CLAYTON", "state" : "LA", "county" : "CONCORDIA" },
            "71327": { "city" : "COTTONPORT", "state" : "LA", "county" : "AVOYELLES" },
            "71328": { "city" : "DEVILLE", "state" : "LA", "county" : "RAPIDES" },
            "71329": { "city" : "DUPONT", "state" : "LA", "county" : "AVOYELLES" },
            "71330": { "city" : "ECHO", "state" : "LA", "county" : "RAPIDES" },"71331": { "city" : "EFFIE", "state" : "LA", "county" : "AVOYELLES" },
            "71333": { "city" : "EVERGREEN", "state" : "LA", "county" : "AVOYELLES" },
            "71334": { "city" : "FERRIDAY", "state" : "LA", "county" : "CONCORDIA" },
            "71336": { "city" : "GILBERT", "state" : "LA", "county" : "FRANKLIN" },
            "71339": { "city" : "HAMBURG", "state" : "LA", "county" : "AVOYELLES" },
            "71340": { "city" : "HARRISONBURG", "state" : "LA", "county" : "CATAHOULA" },
            "71341": { "city" : "HESSMER", "state" : "LA", "county" : "AVOYELLES" },
            "71342": { "city" : "JENA", "state" : "LA", "county" : "LA SALLE" },"71343": { "city" : "JONESVILLE", "state" : "LA", "county" : "CATAHOULA" },
            "71345": { "city" : "LEBEAU", "state" : "LA", "county" : "SAINT LANDRY" },
            "71346": { "city" : "LECOMPTE", "state" : "LA", "county" : "RAPIDES" },
            "71348": { "city" : "LIBUSE", "state" : "LA", "county" : "RAPIDES" },
            "71350": { "city" : "MANSURA", "state" : "LA", "county" : "AVOYELLES" },
            "71351": { "city" : "MARKSVILLE", "state" : "LA", "county" : "AVOYELLES" },
            "71353": { "city" : "MELVILLE", "state" : "LA", "county" : "SAINT LANDRY" },
            "71354": { "city" : "MONTEREY", "state" : "LA", "county" : "CONCORDIA" },
            "71355": { "city" : "MOREAUVILLE", "state" : "LA", "county" : "AVOYELLES" },
            "71356": { "city" : "MORROW", "state" : "LA", "county" : "SAINT LANDRY" },
            "71357": { "city" : "NEWELLTON", "state" : "LA", "county" : "TENSAS" },
            "71358": { "city" : "PALMETTO", "state" : "LA", "county" : "SAINT LANDRY" },
            "71360": { "city" : "PINEVILLE", "state" : "LA", "county" : "RAPIDES" },
            "71361": { "city" : "PINEVILLE", "state" : "LA", "county" : "RAPIDES" },
            "71362": { "city" : "PLAUCHEVILLE", "state" : "LA", "county" : "AVOYELLES" },
            "71363": { "city" : "RHINEHART", "state" : "LA", "county" : "CATAHOULA" },
            "71365": { "city" : "RUBY", "state" : "LA", "county" : "RAPIDES" },"71366": { "city" : "SAINT JOSEPH", "state" : "LA", "county" : "TENSAS" },
            "71367": { "city" : "SAINT LANDRY", "state" : "LA", "county" : "EVANGELINE" },
            "71368": { "city" : "SICILY ISLAND", "state" : "LA", "county" : "CATAHOULA" },
            "71369": { "city" : "SIMMESPORT", "state" : "LA", "county" : "AVOYELLES" },
            "71371": { "city" : "TROUT", "state" : "LA", "county" : "LA SALLE" },
            "71373": { "city" : "VIDALIA", "state" : "LA", "county" : "CONCORDIA" },
            "71375": { "city" : "WATERPROOF", "state" : "LA", "county" : "TENSAS" },
            "71378": { "city" : "WISNER", "state" : "LA", "county" : "FRANKLIN" },
            "71401": { "city" : "AIMWELL", "state" : "LA", "county" : "CATAHOULA" },
            "71403": { "city" : "ANACOCO", "state" : "LA", "county" : "VERNON" },
            "71404": { "city" : "ATLANTA", "state" : "LA", "county" : "WINN" },"71405": { "city" : "BALL", "state" : "LA", "county" : "RAPIDES" },
            "71406": { "city" : "BELMONT", "state" : "LA", "county" : "SABINE" },
            "71407": { "city" : "BENTLEY", "state" : "LA", "county" : "GRANT" },"71409": { "city" : "BOYCE", "state" : "LA", "county" : "RAPIDES" },
            "71410": { "city" : "CALVIN", "state" : "LA", "county" : "WINN" },"71411": { "city" : "CAMPTI", "state" : "LA", "county" : "NATCHITOCHES" },
            "71414": { "city" : "CLARENCE", "state" : "LA", "county" : "NATCHITOCHES" },
            "71415": { "city" : "CLARKS", "state" : "LA", "county" : "CALDWELL" },
            "71416": { "city" : "CLOUTIERVILLE", "state" : "LA", "county" : "NATCHITOCHES" },
            "71417": { "city" : "COLFAX", "state" : "LA", "county" : "GRANT" },"71418": { "city" : "COLUMBIA", "state" : "LA", "county" : "CALDWELL" },
            "71419": { "city" : "CONVERSE", "state" : "LA", "county" : "SABINE" },
            "71422": { "city" : "DODSON", "state" : "LA", "county" : "WINN" },"71423": { "city" : "DRY PRONG", "state" : "LA", "county" : "GRANT" },
            "71424": { "city" : "ELMER", "state" : "LA", "county" : "RAPIDES" },"71425": { "city" : "ENTERPRISE", "state" : "LA", "county" : "CATAHOULA" },
            "71426": { "city" : "FISHER", "state" : "LA", "county" : "SABINE" },"71427": { "city" : "FLATWOODS", "state" : "LA", "county" : "RAPIDES" },
            "71428": { "city" : "FLORA", "state" : "LA", "county" : "NATCHITOCHES" },
            "71429": { "city" : "FLORIEN", "state" : "LA", "county" : "SABINE" },
            "71430": { "city" : "FOREST HILL", "state" : "LA", "county" : "RAPIDES" },
            "71432": { "city" : "GEORGETOWN", "state" : "LA", "county" : "GRANT" },
            "71433": { "city" : "GLENMORA", "state" : "LA", "county" : "RAPIDES" },
            "71435": { "city" : "GRAYSON", "state" : "LA", "county" : "CALDWELL" },
            "71438": { "city" : "HINESTON", "state" : "LA", "county" : "RAPIDES" },
            "71439": { "city" : "HORNBECK", "state" : "LA", "county" : "VERNON" },
            "71440": { "city" : "JOYCE", "state" : "LA", "county" : "WINN" },"71441": { "city" : "KELLY", "state" : "LA", "county" : "CALDWELL" },
            "71443": { "city" : "KURTHWOOD", "state" : "LA", "county" : "VERNON" },
            "71446": { "city" : "LEESVILLE", "state" : "LA", "county" : "VERNON" },
            "71447": { "city" : "LENA", "state" : "LA", "county" : "RAPIDES" },"71448": { "city" : "LONGLEAF", "state" : "LA", "county" : "RAPIDES" },
            "71449": { "city" : "MANY", "state" : "LA", "county" : "SABINE" },"71450": { "city" : "MARTHAVILLE", "state" : "LA", "county" : "NATCHITOCHES" },
            "71452": { "city" : "MELROSE", "state" : "LA", "county" : "NATCHITOCHES" },
            "71454": { "city" : "MONTGOMERY", "state" : "LA", "county" : "GRANT" },
            "71455": { "city" : "MORA", "state" : "LA", "county" : "RAPIDES" },"71456": { "city" : "NATCHEZ", "state" : "LA", "county" : "NATCHITOCHES" },
            "71457": { "city" : "NATCHITOCHES", "state" : "LA", "county" : "NATCHITOCHES" },
            "71458": { "city" : "NATCHITOCHES", "state" : "LA", "county" : "NATCHITOCHES" },
            "71459": { "city" : "FORT POLK", "state" : "LA", "county" : "VERNON" },
            "71460": { "city" : "NEGREET", "state" : "LA", "county" : "SABINE" },
            "71461": { "city" : "NEWLLANO", "state" : "LA", "county" : "VERNON" },
            "71462": { "city" : "NOBLE", "state" : "LA", "county" : "SABINE" },"71463": { "city" : "OAKDALE", "state" : "LA", "county" : "ALLEN" },
            "71465": { "city" : "OLLA", "state" : "LA", "county" : "LA SALLE" },"71466": { "city" : "OTIS", "state" : "LA", "county" : "RAPIDES" },
            "71467": { "city" : "POLLOCK", "state" : "LA", "county" : "GRANT" },"71468": { "city" : "PROVENCAL", "state" : "LA", "county" : "NATCHITOCHES" },
            "71469": { "city" : "ROBELINE", "state" : "LA", "county" : "NATCHITOCHES" },
            "71472": { "city" : "SIEPER", "state" : "LA", "county" : "RAPIDES" },
            "71473": { "city" : "SIKES", "state" : "LA", "county" : "WINN" },"71474": { "city" : "SIMPSON", "state" : "LA", "county" : "VERNON" },
            "71475": { "city" : "SLAGLE", "state" : "LA", "county" : "VERNON" },"71477": { "city" : "TIOGA", "state" : "LA", "county" : "RAPIDES" },
            "71479": { "city" : "TULLOS", "state" : "LA", "county" : "LA SALLE" },
            "71480": { "city" : "URANIA", "state" : "LA", "county" : "LA SALLE" },
            "71483": { "city" : "WINNFIELD", "state" : "LA", "county" : "WINN" },
            "71485": { "city" : "WOODWORTH", "state" : "LA", "county" : "RAPIDES" },
            "71486": { "city" : "ZWOLLE", "state" : "LA", "county" : "SABINE" },"71496": { "city" : "LEESVILLE", "state" : "LA", "county" : "VERNON" },
            "71497": { "city" : "NATCHITOCHES", "state" : "LA", "county" : "NATCHITOCHES" },
            "71601": { "city" : "PINE BLUFF", "state" : "AR", "county" : "JEFFERSON" },
            "71602": { "city" : "WHITE HALL", "state" : "AR", "county" : "JEFFERSON" },
            "71603": { "city" : "PINE BLUFF", "state" : "AR", "county" : "JEFFERSON" },
            "71611": { "city" : "PINE BLUFF", "state" : "AR", "county" : "JEFFERSON" },
            "71612": { "city" : "WHITE HALL", "state" : "AR", "county" : "JEFFERSON" },
            "71613": { "city" : "PINE BLUFF", "state" : "AR", "county" : "JEFFERSON" },
            "71630": { "city" : "ARKANSAS CITY", "state" : "AR", "county" : "DESHA" },
            "71631": { "city" : "BANKS", "state" : "AR", "county" : "BRADLEY" },"71635": { "city" : "CROSSETT", "state" : "AR", "county" : "ASHLEY" },
            "71638": { "city" : "DERMOTT", "state" : "AR", "county" : "CHICOT" },
            "71639": { "city" : "DUMAS", "state" : "AR", "county" : "DESHA" },"71640": { "city" : "EUDORA", "state" : "AR", "county" : "CHICOT" },
            "71642": { "city" : "FOUNTAIN HILL", "state" : "AR", "county" : "ASHLEY" },
            "71643": { "city" : "GOULD", "state" : "AR", "county" : "LINCOLN" },"71644": { "city" : "GRADY", "state" : "AR", "county" : "LINCOLN" },
            "71646": { "city" : "HAMBURG", "state" : "AR", "county" : "ASHLEY" },
            "71647": { "city" : "HERMITAGE", "state" : "AR", "county" : "BRADLEY" },
            "71651": { "city" : "JERSEY", "state" : "AR", "county" : "BRADLEY" },
            "71652": { "city" : "KINGSLAND", "state" : "AR", "county" : "CLEVELAND" },
            "71653": { "city" : "LAKE VILLAGE", "state" : "AR", "county" : "CHICOT" },
            "71654": { "city" : "MC GEHEE", "state" : "AR", "county" : "DESHA" },
            "71655": { "city" : "MONTICELLO", "state" : "AR", "county" : "DREW" },
            "71656": { "city" : "MONTICELLO", "state" : "AR", "county" : "DREW" },
            "71657": { "city" : "MONTICELLO", "state" : "AR", "county" : "DREW" },
            "71658": { "city" : "MONTROSE", "state" : "AR", "county" : "ASHLEY" },
            "71660": { "city" : "NEW EDINBURG", "state" : "AR", "county" : "CLEVELAND" },
            "71661": { "city" : "PARKDALE", "state" : "AR", "county" : "ASHLEY" },
            "71662": { "city" : "PICKENS", "state" : "AR", "county" : "DESHA" },"71663": { "city" : "PORTLAND", "state" : "AR", "county" : "ASHLEY" },
            "71665": { "city" : "RISON", "state" : "AR", "county" : "CLEVELAND" },
            "71666": { "city" : "MC GEHEE", "state" : "AR", "county" : "DESHA" },
            "71667": { "city" : "STAR CITY", "state" : "AR", "county" : "LINCOLN" },
            "71670": { "city" : "TILLAR", "state" : "AR", "county" : "DESHA" },"71671": { "city" : "WARREN", "state" : "AR", "county" : "BRADLEY" },
            "71674": { "city" : "WATSON", "state" : "AR", "county" : "DESHA" },"71675": { "city" : "WILMAR", "state" : "AR", "county" : "DREW" },
            "71676": { "city" : "WILMOT", "state" : "AR", "county" : "ASHLEY" },"71677": { "city" : "WINCHESTER", "state" : "AR", "county" : "DREW" },
            "71701": { "city" : "CAMDEN", "state" : "AR", "county" : "OUACHITA" },
            "71711": { "city" : "CAMDEN", "state" : "AR", "county" : "OUACHITA" },
            "71720": { "city" : "BEARDEN", "state" : "AR", "county" : "OUACHITA" },
            "71721": { "city" : "BEIRNE", "state" : "AR", "county" : "CLARK" },"71722": { "city" : "BLUFF CITY", "state" : "AR", "county" : "NEVADA" },
            "71724": { "city" : "CALION", "state" : "AR", "county" : "UNION" },"71725": { "city" : "CARTHAGE", "state" : "AR", "county" : "DALLAS" },
            "71726": { "city" : "CHIDESTER", "state" : "AR", "county" : "OUACHITA" },
            "71728": { "city" : "CURTIS", "state" : "AR", "county" : "CLARK" },"71730": { "city" : "EL DORADO", "state" : "AR", "county" : "UNION" },
            "71731": { "city" : "EL DORADO", "state" : "AR", "county" : "UNION" },
            "71740": { "city" : "EMERSON", "state" : "AR", "county" : "COLUMBIA" },
            "71742": { "city" : "FORDYCE", "state" : "AR", "county" : "DALLAS" },
            "71743": { "city" : "GURDON", "state" : "AR", "county" : "CLARK" },"71744": { "city" : "HAMPTON", "state" : "AR", "county" : "CALHOUN" },
            "71745": { "city" : "HARRELL", "state" : "AR", "county" : "CALHOUN" },
            "71747": { "city" : "HUTTIG", "state" : "AR", "county" : "UNION" },"71748": { "city" : "IVAN", "state" : "AR", "county" : "DALLAS" },
            "71749": { "city" : "JUNCTION CITY", "state" : "AR", "county" : "UNION" },
            "71750": { "city" : "LAWSON", "state" : "AR", "county" : "UNION" },"71751": { "city" : "LOUANN", "state" : "AR", "county" : "OUACHITA" },
            "71752": { "city" : "MC NEIL", "state" : "AR", "county" : "COLUMBIA" },
            "71753": { "city" : "MAGNOLIA", "state" : "AR", "county" : "COLUMBIA" },
            "71754": { "city" : "MAGNOLIA", "state" : "AR", "county" : "COLUMBIA" },
            "71758": { "city" : "MOUNT HOLLY", "state" : "AR", "county" : "UNION" },
            "71759": { "city" : "NORPHLET", "state" : "AR", "county" : "UNION" },
            "71762": { "city" : "SMACKOVER", "state" : "AR", "county" : "UNION" },
            "71763": { "city" : "SPARKMAN", "state" : "AR", "county" : "DALLAS" },
            "71764": { "city" : "STEPHENS", "state" : "AR", "county" : "OUACHITA" },
            "71765": { "city" : "STRONG", "state" : "AR", "county" : "UNION" },"71766": { "city" : "THORNTON", "state" : "AR", "county" : "CALHOUN" },
            "71768": { "city" : "URBANA", "state" : "AR", "county" : "UNION" },"71770": { "city" : "WALDO", "state" : "AR", "county" : "COLUMBIA" },
            "71801": { "city" : "HOPE", "state" : "AR", "county" : "HEMPSTEAD" },
            "71802": { "city" : "HOPE", "state" : "AR", "county" : "HEMPSTEAD" },
            "71822": { "city" : "ASHDOWN", "state" : "AR", "county" : "LITTLE RIVER" },
            "71823": { "city" : "BEN LOMOND", "state" : "AR", "county" : "SEVIER" },
            "71825": { "city" : "BLEVINS", "state" : "AR", "county" : "HEMPSTEAD" },
            "71826": { "city" : "BRADLEY", "state" : "AR", "county" : "LAFAYETTE" },
            "71827": { "city" : "BUCKNER", "state" : "AR", "county" : "LAFAYETTE" },
            "71832": { "city" : "DE QUEEN", "state" : "AR", "county" : "SEVIER" },
            "71833": { "city" : "DIERKS", "state" : "AR", "county" : "HOWARD" },"71834": { "city" : "DODDRIDGE", "state" : "AR", "county" : "MILLER" },
            "71835": { "city" : "EMMET", "state" : "AR", "county" : "NEVADA" },"71836": { "city" : "FOREMAN", "state" : "AR", "county" : "LITTLE RIVER" },
            "71837": { "city" : "FOUKE", "state" : "AR", "county" : "MILLER" },"71838": { "city" : "FULTON", "state" : "AR", "county" : "HEMPSTEAD" },
            "71839": { "city" : "GARLAND CITY", "state" : "AR", "county" : "MILLER" },
            "71840": { "city" : "GENOA", "state" : "AR", "county" : "MILLER" },"71841": { "city" : "GILLHAM", "state" : "AR", "county" : "SEVIER" },
            "71842": { "city" : "HORATIO", "state" : "AR", "county" : "SEVIER" },
            "71845": { "city" : "LEWISVILLE", "state" : "AR", "county" : "LAFAYETTE" },
            "71846": { "city" : "LOCKESBURG", "state" : "AR", "county" : "SEVIER" },
            "71847": { "city" : "MC CASKILL", "state" : "AR", "county" : "HEMPSTEAD" },
            "71851": { "city" : "MINERAL SPRINGS", "state" : "AR", "county" : "HOWARD" },
            "71852": { "city" : "NASHVILLE", "state" : "AR", "county" : "HOWARD" },
            "71853": { "city" : "OGDEN", "state" : "AR", "county" : "LITTLE RIVER" },
            "71854": { "city" : "TEXARKANA", "state" : "AR", "county" : "MILLER" },
            "71855": { "city" : "OZAN", "state" : "AR", "county" : "HEMPSTEAD" },
            "71857": { "city" : "PRESCOTT", "state" : "AR", "county" : "NEVADA" },
            "71858": { "city" : "ROSSTON", "state" : "AR", "county" : "NEVADA" },
            "71859": { "city" : "SARATOGA", "state" : "AR", "county" : "HOWARD" },
            "71860": { "city" : "STAMPS", "state" : "AR", "county" : "LAFAYETTE" },
            "71861": { "city" : "TAYLOR", "state" : "AR", "county" : "COLUMBIA" },
            "71862": { "city" : "WASHINGTON", "state" : "AR", "county" : "HEMPSTEAD" },
            "71864": { "city" : "WILLISVILLE", "state" : "AR", "county" : "NEVADA" },
            "71865": { "city" : "WILTON", "state" : "AR", "county" : "LITTLE RIVER" },
            "71866": { "city" : "WINTHROP", "state" : "AR", "county" : "LITTLE RIVER" },
            "71901": { "city" : "HOT SPRINGS NATIONAL PARK", "state" : "AR", "county" : "GARLAND" },
            "71902": { "city" : "HOT SPRINGS NATIONAL PARK", "state" : "AR", "county" : "GARLAND" },
            "71903": { "city" : "HOT SPRINGS NATIONAL PARK", "state" : "AR", "county" : "GARLAND" },
            "71909": { "city" : "HOT SPRINGS VILLAGE", "state" : "AR", "county" : "GARLAND" },
            "71910": { "city" : "HOT SPRINGS VILLAGE", "state" : "AR", "county" : "GARLAND" },
            "71913": { "city" : "HOT SPRINGS NATIONAL PARK", "state" : "AR", "county" : "GARLAND" },
            "71914": { "city" : "HOT SPRINGS NATIONAL PARK", "state" : "AR", "county" : "GARLAND" },
            "71921": { "city" : "AMITY", "state" : "AR", "county" : "CLARK" },"71922": { "city" : "ANTOINE", "state" : "AR", "county" : "PIKE" },
            "71923": { "city" : "ARKADELPHIA", "state" : "AR", "county" : "CLARK" },
            "71929": { "city" : "BISMARCK", "state" : "AR", "county" : "HOT SPRING" },
            "71933": { "city" : "BONNERDALE", "state" : "AR", "county" : "HOT SPRING" },
            "71935": { "city" : "CADDO GAP", "state" : "AR", "county" : "MONTGOMERY" },
            "71937": { "city" : "COVE", "state" : "AR", "county" : "POLK" },"71940": { "city" : "DELIGHT", "state" : "AR", "county" : "PIKE" },
            "71941": { "city" : "DONALDSON", "state" : "AR", "county" : "HOT SPRING" },
            "71942": { "city" : "FRIENDSHIP", "state" : "AR", "county" : "HOT SPRING" },
            "71943": { "city" : "GLENWOOD", "state" : "AR", "county" : "PIKE" },"71944": { "city" : "GRANNIS", "state" : "AR", "county" : "POLK" },
            "71945": { "city" : "HATFIELD", "state" : "AR", "county" : "POLK" },"71949": { "city" : "JESSIEVILLE", "state" : "AR", "county" : "GARLAND" },
            "71950": { "city" : "KIRBY", "state" : "AR", "county" : "PIKE" },"71953": { "city" : "MENA", "state" : "AR", "county" : "POLK" },
            "71956": { "city" : "MOUNTAIN PINE", "state" : "AR", "county" : "GARLAND" },
            "71957": { "city" : "MOUNT IDA", "state" : "AR", "county" : "MONTGOMERY" },
            "71958": { "city" : "MURFREESBORO", "state" : "AR", "county" : "PIKE" },
            "71959": { "city" : "NEWHOPE", "state" : "AR", "county" : "PIKE" },"71960": { "city" : "NORMAN", "state" : "AR", "county" : "MONTGOMERY" },
            "71961": { "city" : "ODEN", "state" : "AR", "county" : "MONTGOMERY" },
            "71962": { "city" : "OKOLONA", "state" : "AR", "county" : "CLARK" },"71964": { "city" : "PEARCY", "state" : "AR", "county" : "GARLAND" },
            "71965": { "city" : "PENCIL BLUFF", "state" : "AR", "county" : "MONTGOMERY" },
            "71968": { "city" : "ROYAL", "state" : "AR", "county" : "GARLAND" },"71969": { "city" : "SIMS", "state" : "AR", "county" : "MONTGOMERY" },
            "71970": { "city" : "STORY", "state" : "AR", "county" : "MONTGOMERY" },
            "71971": { "city" : "UMPIRE", "state" : "AR", "county" : "HOWARD" },"71972": { "city" : "VANDERVOORT", "state" : "AR", "county" : "POLK" },
            "71973": { "city" : "WICKES", "state" : "AR", "county" : "POLK" },"71998": { "city" : "ARKADELPHIA", "state" : "AR", "county" : "CLARK" },
            "71999": { "city" : "ARKADELPHIA", "state" : "AR", "county" : "CLARK" },
            "72001": { "city" : "ADONA", "state" : "AR", "county" : "PERRY" },"72002": { "city" : "ALEXANDER", "state" : "AR", "county" : "SALINE" },
            "72003": { "city" : "ALMYRA", "state" : "AR", "county" : "ARKANSAS" },
            "72004": { "city" : "ALTHEIMER", "state" : "AR", "county" : "JEFFERSON" },
            "72006": { "city" : "AUGUSTA", "state" : "AR", "county" : "WOODRUFF" },
            "72007": { "city" : "AUSTIN", "state" : "AR", "county" : "LONOKE" },"72010": { "city" : "BALD KNOB", "state" : "AR", "county" : "WHITE" },
            "72011": { "city" : "BAUXITE", "state" : "AR", "county" : "SALINE" },
            "72012": { "city" : "BEEBE", "state" : "AR", "county" : "WHITE" },"72013": { "city" : "BEE BRANCH", "state" : "AR", "county" : "VAN BUREN" },
            "72014": { "city" : "BEEDEVILLE", "state" : "AR", "county" : "JACKSON" },
            "72015": { "city" : "BENTON", "state" : "AR", "county" : "SALINE" },"72016": { "city" : "BIGELOW", "state" : "AR", "county" : "PERRY" },
            "72017": { "city" : "BISCOE", "state" : "AR", "county" : "PRAIRIE" },
            "72018": { "city" : "BENTON", "state" : "AR", "county" : "SALINE" },"72019": { "city" : "BENTON", "state" : "AR", "county" : "SALINE" },
            "72020": { "city" : "BRADFORD", "state" : "AR", "county" : "WHITE" },
            "72021": { "city" : "BRINKLEY", "state" : "AR", "county" : "MONROE" },
            "72022": { "city" : "BRYANT", "state" : "AR", "county" : "SALINE" },"72023": { "city" : "CABOT", "state" : "AR", "county" : "LONOKE" },
            "72024": { "city" : "CARLISLE", "state" : "AR", "county" : "LONOKE" },
            "72025": { "city" : "CASA", "state" : "AR", "county" : "PERRY" },"72026": { "city" : "CASSCOE", "state" : "AR", "county" : "ARKANSAS" },
            "72027": { "city" : "CENTER RIDGE", "state" : "AR", "county" : "CONWAY" },
            "72028": { "city" : "CHOCTAW", "state" : "AR", "county" : "VAN BUREN" },
            "72029": { "city" : "CLARENDON", "state" : "AR", "county" : "MONROE" },
            "72030": { "city" : "CLEVELAND", "state" : "AR", "county" : "CONWAY" },
            "72031": { "city" : "CLINTON", "state" : "AR", "county" : "VAN BUREN" },
            "72032": { "city" : "CONWAY", "state" : "AR", "county" : "FAULKNER" },
            "72033": { "city" : "CONWAY", "state" : "AR", "county" : "FAULKNER" },
            "72034": { "city" : "CONWAY", "state" : "AR", "county" : "FAULKNER" },
            "72035": { "city" : "CONWAY", "state" : "AR", "county" : "FAULKNER" },
            "72036": { "city" : "COTTON PLANT", "state" : "AR", "county" : "WOODRUFF" },
            "72037": { "city" : "COY", "state" : "AR", "county" : "LONOKE" },"72038": { "city" : "CROCKETTS BLUFF", "state" : "AR", "county" : "ARKANSAS" },
            "72039": { "city" : "DAMASCUS", "state" : "AR", "county" : "VAN BUREN" },
            "72040": { "city" : "DES ARC", "state" : "AR", "county" : "PRAIRIE" },
            "72041": { "city" : "DE VALLS BLUFF", "state" : "AR", "county" : "PRAIRIE" },
            "72042": { "city" : "DE WITT", "state" : "AR", "county" : "ARKANSAS" },
            "72043": { "city" : "DIAZ", "state" : "AR", "county" : "JACKSON" },"72044": { "city" : "EDGEMONT", "state" : "AR", "county" : "CLEBURNE" },
            "72045": { "city" : "EL PASO", "state" : "AR", "county" : "WHITE" },"72046": { "city" : "ENGLAND", "state" : "AR", "county" : "LONOKE" },
            "72047": { "city" : "ENOLA", "state" : "AR", "county" : "FAULKNER" },
            "72051": { "city" : "FOX", "state" : "AR", "county" : "STONE" },"72052": { "city" : "GARNER", "state" : "AR", "county" : "WHITE" },
            "72053": { "city" : "COLLEGE STATION", "state" : "AR", "county" : "PULASKI" },
            "72055": { "city" : "GILLETT", "state" : "AR", "county" : "ARKANSAS" },
            "72057": { "city" : "GRAPEVINE", "state" : "AR", "county" : "GRANT" },
            "72058": { "city" : "GREENBRIER", "state" : "AR", "county" : "FAULKNER" },
            "72060": { "city" : "GRIFFITHVILLE", "state" : "AR", "county" : "WHITE" },
            "72061": { "city" : "GUY", "state" : "AR", "county" : "FAULKNER" },"72063": { "city" : "HATTIEVILLE", "state" : "AR", "county" : "CONWAY" },
            "72064": { "city" : "HAZEN", "state" : "AR", "county" : "PRAIRIE" },"72065": { "city" : "HENSLEY", "state" : "AR", "county" : "SALINE" },
            "72066": { "city" : "HICKORY PLAINS", "state" : "AR", "county" : "PRAIRIE" },
            "72067": { "city" : "HIGDEN", "state" : "AR", "county" : "CLEBURNE" },
            "72068": { "city" : "HIGGINSON", "state" : "AR", "county" : "WHITE" },
            "72069": { "city" : "HOLLY GROVE", "state" : "AR", "county" : "MONROE" },
            "72070": { "city" : "HOUSTON", "state" : "AR", "county" : "PERRY" },"72072": { "city" : "HUMNOKE", "state" : "AR", "county" : "LONOKE" },
            "72073": { "city" : "HUMPHREY", "state" : "AR", "county" : "JEFFERSON" },
            "72074": { "city" : "HUNTER", "state" : "AR", "county" : "WOODRUFF" },
            "72076": { "city" : "JACKSONVILLE", "state" : "AR", "county" : "PULASKI" },
            "72078": { "city" : "JACKSONVILLE", "state" : "AR", "county" : "PULASKI" },
            "72079": { "city" : "JEFFERSON", "state" : "AR", "county" : "JEFFERSON" },
            "72080": { "city" : "JERUSALEM", "state" : "AR", "county" : "CONWAY" },
            "72081": { "city" : "JUDSONIA", "state" : "AR", "county" : "WHITE" },
            "72082": { "city" : "KENSETT", "state" : "AR", "county" : "WHITE" },"72083": { "city" : "KEO", "state" : "AR", "county" : "LONOKE" },
            "72084": { "city" : "LEOLA", "state" : "AR", "county" : "GRANT" },"72086": { "city" : "LONOKE", "state" : "AR", "county" : "LONOKE" },
            "72087": { "city" : "LONSDALE", "state" : "AR", "county" : "GARLAND" },
            "72088": { "city" : "FAIRFIELD BAY", "state" : "AR", "county" : "VAN BUREN" },
            "72089": { "city" : "BRYANT", "state" : "AR", "county" : "SALINE" },"72099": { "city" : "LITTLE ROCK AIR FORCE BASE", "state" : "AR", "county" : "PULASKI" },
            "72101": { "city" : "MC CRORY", "state" : "AR", "county" : "WOODRUFF" },
            "72102": { "city" : "MC RAE", "state" : "AR", "county" : "WHITE" },"72103": { "city" : "MABELVALE", "state" : "AR", "county" : "SALINE" },
            "72104": { "city" : "MALVERN", "state" : "AR", "county" : "HOT SPRING" },
            "72105": { "city" : "JONES MILL", "state" : "AR", "county" : "HOT SPRING" },
            "72106": { "city" : "MAYFLOWER", "state" : "AR", "county" : "FAULKNER" },
            "72107": { "city" : "MENIFEE", "state" : "AR", "county" : "CONWAY" },
            "72108": { "city" : "MONROE", "state" : "AR", "county" : "MONROE" },"72110": { "city" : "MORRILTON", "state" : "AR", "county" : "CONWAY" },
            "72111": { "city" : "MOUNT VERNON", "state" : "AR", "county" : "FAULKNER" },
            "72112": { "city" : "NEWPORT", "state" : "AR", "county" : "JACKSON" },
            "72113": { "city" : "MAUMELLE", "state" : "AR", "county" : "PULASKI" },
            "72114": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72115": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72116": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72117": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72118": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72119": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72120": { "city" : "SHERWOOD", "state" : "AR", "county" : "PULASKI" },
            "72121": { "city" : "PANGBURN", "state" : "AR", "county" : "WHITE" },
            "72122": { "city" : "PARON", "state" : "AR", "county" : "SALINE" },"72123": { "city" : "PATTERSON", "state" : "AR", "county" : "WOODRUFF" },
            "72124": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72125": { "city" : "PERRY", "state" : "AR", "county" : "PERRY" },"72126": { "city" : "PERRYVILLE", "state" : "AR", "county" : "PERRY" },
            "72127": { "city" : "PLUMERVILLE", "state" : "AR", "county" : "CONWAY" },
            "72128": { "city" : "POYEN", "state" : "AR", "county" : "GRANT" },"72129": { "city" : "PRATTSVILLE", "state" : "AR", "county" : "GRANT" },
            "72130": { "city" : "PRIM", "state" : "AR", "county" : "CLEBURNE" },"72131": { "city" : "QUITMAN", "state" : "AR", "county" : "CLEBURNE" },
            "72132": { "city" : "REDFIELD", "state" : "AR", "county" : "JEFFERSON" },
            "72134": { "city" : "ROE", "state" : "AR", "county" : "MONROE" },"72135": { "city" : "ROLAND", "state" : "AR", "county" : "PULASKI" },
            "72136": { "city" : "ROMANCE", "state" : "AR", "county" : "WHITE" },"72137": { "city" : "ROSE BUD", "state" : "AR", "county" : "WHITE" },
            "72139": { "city" : "RUSSELL", "state" : "AR", "county" : "WHITE" },"72140": { "city" : "SAINT CHARLES", "state" : "AR", "county" : "ARKANSAS" },
            "72141": { "city" : "SCOTLAND", "state" : "AR", "county" : "VAN BUREN" },
            "72142": { "city" : "SCOTT", "state" : "AR", "county" : "PULASKI" },"72143": { "city" : "SEARCY", "state" : "AR", "county" : "WHITE" },
            "72145": { "city" : "SEARCY", "state" : "AR", "county" : "WHITE" },"72149": { "city" : "SEARCY", "state" : "AR", "county" : "WHITE" },
            "72150": { "city" : "SHERIDAN", "state" : "AR", "county" : "GRANT" },
            "72152": { "city" : "SHERRILL", "state" : "AR", "county" : "JEFFERSON" },
            "72153": { "city" : "SHIRLEY", "state" : "AR", "county" : "VAN BUREN" },
            "72156": { "city" : "SOLGOHACHIA", "state" : "AR", "county" : "CONWAY" },
            "72157": { "city" : "SPRINGFIELD", "state" : "AR", "county" : "CONWAY" },
            "72160": { "city" : "STUTTGART", "state" : "AR", "county" : "ARKANSAS" },
            "72164": { "city" : "SWEET HOME", "state" : "AR", "county" : "PULASKI" },
            "72167": { "city" : "TRASKWOOD", "state" : "AR", "county" : "SALINE" },
            "72168": { "city" : "TUCKER", "state" : "AR", "county" : "JEFFERSON" },
            "72169": { "city" : "TUPELO", "state" : "AR", "county" : "JACKSON" },
            "72170": { "city" : "ULM", "state" : "AR", "county" : "PRAIRIE" },"72173": { "city" : "VILONIA", "state" : "AR", "county" : "FAULKNER" },
            "72175": { "city" : "WABBASEKA", "state" : "AR", "county" : "JEFFERSON" },
            "72176": { "city" : "WARD", "state" : "AR", "county" : "LONOKE" },"72178": { "city" : "WEST POINT", "state" : "AR", "county" : "WHITE" },
            "72179": { "city" : "WILBURN", "state" : "AR", "county" : "CLEBURNE" },
            "72180": { "city" : "WOODSON", "state" : "AR", "county" : "PULASKI" },
            "72181": { "city" : "WOOSTER", "state" : "AR", "county" : "FAULKNER" },
            "72182": { "city" : "WRIGHT", "state" : "AR", "county" : "JEFFERSON" },
            "72183": { "city" : "WRIGHTSVILLE", "state" : "AR", "county" : "PULASKI" },
            "72190": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72199": { "city" : "NORTH LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72201": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72202": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72203": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72204": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72205": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72206": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72207": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72209": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72210": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72211": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72212": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72214": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72215": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72216": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72217": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72219": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72221": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72222": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72223": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72225": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72227": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72231": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72260": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72295": { "city" : "LITTLE ROCK", "state" : "AR", "county" : "PULASKI" },
            "72301": { "city" : "WEST MEMPHIS", "state" : "AR", "county" : "CRITTENDEN" },
            "72303": { "city" : "WEST MEMPHIS", "state" : "AR", "county" : "CRITTENDEN" },
            "72310": { "city" : "ARMOREL", "state" : "AR", "county" : "MISSISSIPPI" },
            "72311": { "city" : "AUBREY", "state" : "AR", "county" : "LEE" },"72312": { "city" : "BARTON", "state" : "AR", "county" : "PHILLIPS" },
            "72313": { "city" : "BASSETT", "state" : "AR", "county" : "MISSISSIPPI" },
            "72315": { "city" : "BLYTHEVILLE", "state" : "AR", "county" : "MISSISSIPPI" },
            "72316": { "city" : "BLYTHEVILLE", "state" : "AR", "county" : "MISSISSIPPI" },
            "72319": { "city" : "GOSNELL", "state" : "AR", "county" : "MISSISSIPPI" },
            "72320": { "city" : "BRICKEYS", "state" : "AR", "county" : "LEE" },"72321": { "city" : "BURDETTE", "state" : "AR", "county" : "MISSISSIPPI" },
            "72322": { "city" : "CALDWELL", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72324": { "city" : "CHERRY VALLEY", "state" : "AR", "county" : "CROSS" },
            "72325": { "city" : "CLARKEDALE", "state" : "AR", "county" : "CRITTENDEN" },
            "72326": { "city" : "COLT", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72327": { "city" : "CRAWFORDSVILLE", "state" : "AR", "county" : "CRITTENDEN" },
            "72328": { "city" : "CRUMROD", "state" : "AR", "county" : "PHILLIPS" },
            "72330": { "city" : "DYESS", "state" : "AR", "county" : "MISSISSIPPI" },
            "72331": { "city" : "EARLE", "state" : "AR", "county" : "CRITTENDEN" },
            "72332": { "city" : "EDMONDSON", "state" : "AR", "county" : "CRITTENDEN" },
            "72333": { "city" : "ELAINE", "state" : "AR", "county" : "PHILLIPS" },
            "72335": { "city" : "FORREST CITY", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72336": { "city" : "FORREST CITY", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72338": { "city" : "FRENCHMANS BAYOU", "state" : "AR", "county" : "MISSISSIPPI" },
            "72342": { "city" : "HELENA", "state" : "AR", "county" : "PHILLIPS" },
            "72346": { "city" : "HETH", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72347": { "city" : "HICKORY RIDGE", "state" : "AR", "county" : "CROSS" },
            "72348": { "city" : "HUGHES", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72350": { "city" : "JOINER", "state" : "AR", "county" : "MISSISSIPPI" },
            "72351": { "city" : "KEISER", "state" : "AR", "county" : "MISSISSIPPI" },
            "72354": { "city" : "LEPANTO", "state" : "AR", "county" : "POINSETT" },
            "72355": { "city" : "LEXA", "state" : "AR", "county" : "PHILLIPS" },"72358": { "city" : "LUXORA", "state" : "AR", "county" : "MISSISSIPPI" },
            "72359": { "city" : "MADISON", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72360": { "city" : "MARIANNA", "state" : "AR", "county" : "LEE" },"72364": { "city" : "MARION", "state" : "AR", "county" : "CRITTENDEN" },
            "72365": { "city" : "MARKED TREE", "state" : "AR", "county" : "POINSETT" },
            "72366": { "city" : "MARVELL", "state" : "AR", "county" : "PHILLIPS" },
            "72367": { "city" : "MELLWOOD", "state" : "AR", "county" : "PHILLIPS" },
            "72368": { "city" : "MORO", "state" : "AR", "county" : "LEE" },"72369": { "city" : "ONEIDA", "state" : "AR", "county" : "PHILLIPS" },
            "72370": { "city" : "OSCEOLA", "state" : "AR", "county" : "MISSISSIPPI" },
            "72372": { "city" : "PALESTINE", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72373": { "city" : "PARKIN", "state" : "AR", "county" : "CROSS" },"72374": { "city" : "POPLAR GROVE", "state" : "AR", "county" : "PHILLIPS" },
            "72376": { "city" : "PROCTOR", "state" : "AR", "county" : "CRITTENDEN" },
            "72384": { "city" : "TURRELL", "state" : "AR", "county" : "CRITTENDEN" },
            "72386": { "city" : "TYRONZA", "state" : "AR", "county" : "POINSETT" },
            "72389": { "city" : "WABASH", "state" : "AR", "county" : "PHILLIPS" },
            "72390": { "city" : "WEST HELENA", "state" : "AR", "county" : "PHILLIPS" },
            "72392": { "city" : "WHEATLEY", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72394": { "city" : "WIDENER", "state" : "AR", "county" : "SAINT FRANCIS" },
            "72395": { "city" : "WILSON", "state" : "AR", "county" : "MISSISSIPPI" },
            "72396": { "city" : "WYNNE", "state" : "AR", "county" : "CROSS" },"72401": { "city" : "JONESBORO", "state" : "AR", "county" : "CRAIGHEAD" },
            "72402": { "city" : "JONESBORO", "state" : "AR", "county" : "CRAIGHEAD" },
            "72403": { "city" : "JONESBORO", "state" : "AR", "county" : "CRAIGHEAD" },
            "72404": { "city" : "JONESBORO", "state" : "AR", "county" : "CRAIGHEAD" },
            "72410": { "city" : "ALICIA", "state" : "AR", "county" : "LAWRENCE" },
            "72411": { "city" : "BAY", "state" : "AR", "county" : "CRAIGHEAD" },"72412": { "city" : "BEECH GROVE", "state" : "AR", "county" : "GREENE" },
            "72413": { "city" : "BIGGERS", "state" : "AR", "county" : "RANDOLPH" },
            "72414": { "city" : "BLACK OAK", "state" : "AR", "county" : "CRAIGHEAD" },
            "72415": { "city" : "BLACK ROCK", "state" : "AR", "county" : "LAWRENCE" },
            "72416": { "city" : "BONO", "state" : "AR", "county" : "CRAIGHEAD" },
            "72417": { "city" : "BROOKLAND", "state" : "AR", "county" : "CRAIGHEAD" },
            "72419": { "city" : "CARAWAY", "state" : "AR", "county" : "CRAIGHEAD" },
            "72421": { "city" : "CASH", "state" : "AR", "county" : "CRAIGHEAD" },
            "72422": { "city" : "CORNING", "state" : "AR", "county" : "CLAY" },"72424": { "city" : "DATTO", "state" : "AR", "county" : "CLAY" },
            "72425": { "city" : "DELAPLAINE", "state" : "AR", "county" : "GREENE" },
            "72426": { "city" : "DELL", "state" : "AR", "county" : "MISSISSIPPI" },
            "72428": { "city" : "ETOWAH", "state" : "AR", "county" : "MISSISSIPPI" },
            "72429": { "city" : "FISHER", "state" : "AR", "county" : "POINSETT" },
            "72430": { "city" : "GREENWAY", "state" : "AR", "county" : "CLAY" },"72431": { "city" : "GRUBBS", "state" : "AR", "county" : "JACKSON" },
            "72432": { "city" : "HARRISBURG", "state" : "AR", "county" : "POINSETT" },
            "72433": { "city" : "HOXIE", "state" : "AR", "county" : "LAWRENCE" },
            "72434": { "city" : "IMBODEN", "state" : "AR", "county" : "LAWRENCE" },
            "72435": { "city" : "KNOBEL", "state" : "AR", "county" : "CLAY" },"72436": { "city" : "LAFE", "state" : "AR", "county" : "GREENE" },
            "72437": { "city" : "LAKE CITY", "state" : "AR", "county" : "CRAIGHEAD" },
            "72438": { "city" : "LEACHVILLE", "state" : "AR", "county" : "MISSISSIPPI" },
            "72439": { "city" : "LIGHT", "state" : "AR", "county" : "GREENE" },"72440": { "city" : "LYNN", "state" : "AR", "county" : "LAWRENCE" },
            "72441": { "city" : "MC DOUGAL", "state" : "AR", "county" : "CLAY" },
            "72442": { "city" : "MANILA", "state" : "AR", "county" : "MISSISSIPPI" },
            "72443": { "city" : "MARMADUKE", "state" : "AR", "county" : "GREENE" },
            "72444": { "city" : "MAYNARD", "state" : "AR", "county" : "RANDOLPH" },
            "72445": { "city" : "MINTURN", "state" : "AR", "county" : "LAWRENCE" },
            "72447": { "city" : "MONETTE", "state" : "AR", "county" : "CRAIGHEAD" },
            "72450": { "city" : "PARAGOULD", "state" : "AR", "county" : "GREENE" },
            "72451": { "city" : "PARAGOULD", "state" : "AR", "county" : "GREENE" },
            "72453": { "city" : "PEACH ORCHARD", "state" : "AR", "county" : "CLAY" },
            "72454": { "city" : "PIGGOTT", "state" : "AR", "county" : "CLAY" },"72455": { "city" : "POCAHONTAS", "state" : "AR", "county" : "RANDOLPH" },
            "72456": { "city" : "POLLARD", "state" : "AR", "county" : "CLAY" },"72457": { "city" : "PORTIA", "state" : "AR", "county" : "LAWRENCE" },
            "72458": { "city" : "POWHATAN", "state" : "AR", "county" : "LAWRENCE" },
            "72459": { "city" : "RAVENDEN", "state" : "AR", "county" : "LAWRENCE" },
            "72460": { "city" : "RAVENDEN SPRINGS", "state" : "AR", "county" : "RANDOLPH" },
            "72461": { "city" : "RECTOR", "state" : "AR", "county" : "CLAY" },"72462": { "city" : "REYNO", "state" : "AR", "county" : "RANDOLPH" },
            "72464": { "city" : "SAINT FRANCIS", "state" : "AR", "county" : "CLAY" },
            "72465": { "city" : "SEDGWICK", "state" : "AR", "county" : "LAWRENCE" },
            "72466": { "city" : "SMITHVILLE", "state" : "AR", "county" : "LAWRENCE" },
            "72467": { "city" : "STATE UNIVERSITY", "state" : "AR", "county" : "CRAIGHEAD" },
            "72469": { "city" : "STRAWBERRY", "state" : "AR", "county" : "LAWRENCE" },
            "72470": { "city" : "SUCCESS", "state" : "AR", "county" : "CLAY" },"72471": { "city" : "SWIFTON", "state" : "AR", "county" : "JACKSON" },
            "72472": { "city" : "TRUMANN", "state" : "AR", "county" : "POINSETT" },
            "72473": { "city" : "TUCKERMAN", "state" : "AR", "county" : "JACKSON" },
            "72474": { "city" : "WALCOTT", "state" : "AR", "county" : "GREENE" },
            "72475": { "city" : "WALDENBURG", "state" : "AR", "county" : "POINSETT" },
            "72476": { "city" : "WALNUT RIDGE", "state" : "AR", "county" : "LAWRENCE" },
            "72478": { "city" : "WARM SPRINGS", "state" : "AR", "county" : "RANDOLPH" },
            "72479": { "city" : "WEINER", "state" : "AR", "county" : "POINSETT" },
            "72482": { "city" : "WILLIFORD", "state" : "AR", "county" : "SHARP" },
            "72501": { "city" : "BATESVILLE", "state" : "AR", "county" : "INDEPENDENCE" },
            "72503": { "city" : "BATESVILLE", "state" : "AR", "county" : "INDEPENDENCE" },
            "72512": { "city" : "HORSESHOE BEND", "state" : "AR", "county" : "IZARD" },
            "72513": { "city" : "ASH FLAT", "state" : "AR", "county" : "SHARP" },
            "72517": { "city" : "BROCKWELL", "state" : "AR", "county" : "IZARD" },
            "72519": { "city" : "CALICO ROCK", "state" : "AR", "county" : "IZARD" },
            "72521": { "city" : "CAVE CITY", "state" : "AR", "county" : "SHARP" },
            "72522": { "city" : "CHARLOTTE", "state" : "AR", "county" : "INDEPENDENCE" },
            "72523": { "city" : "CONCORD", "state" : "AR", "county" : "CLEBURNE" },
            "72524": { "city" : "CORD", "state" : "AR", "county" : "INDEPENDENCE" },
            "72525": { "city" : "CHEROKEE VILLAGE", "state" : "AR", "county" : "SHARP" },
            "72526": { "city" : "CUSHMAN", "state" : "AR", "county" : "INDEPENDENCE" },
            "72527": { "city" : "DESHA", "state" : "AR", "county" : "INDEPENDENCE" },
            "72528": { "city" : "DOLPH", "state" : "AR", "county" : "IZARD" },"72529": { "city" : "CHEROKEE VILLAGE", "state" : "AR", "county" : "SHARP" },
            "72530": { "city" : "DRASCO", "state" : "AR", "county" : "CLEBURNE" },
            "72531": { "city" : "ELIZABETH", "state" : "AR", "county" : "FULTON" },
            "72532": { "city" : "EVENING SHADE", "state" : "AR", "county" : "SHARP" },
            "72533": { "city" : "FIFTY SIX", "state" : "AR", "county" : "STONE" },
            "72534": { "city" : "FLORAL", "state" : "AR", "county" : "INDEPENDENCE" },
            "72536": { "city" : "FRANKLIN", "state" : "AR", "county" : "IZARD" },
            "72537": { "city" : "GAMALIEL", "state" : "AR", "county" : "BAXTER" },
            "72538": { "city" : "GEPP", "state" : "AR", "county" : "FULTON" },"72539": { "city" : "GLENCOE", "state" : "AR", "county" : "FULTON" },
            "72540": { "city" : "GUION", "state" : "AR", "county" : "IZARD" },"72542": { "city" : "HARDY", "state" : "AR", "county" : "SHARP" },
            "72543": { "city" : "HEBER SPRINGS", "state" : "AR", "county" : "CLEBURNE" },
            "72544": { "city" : "HENDERSON", "state" : "AR", "county" : "BAXTER" },
            "72546": { "city" : "IDA", "state" : "AR", "county" : "CLEBURNE" },"72550": { "city" : "LOCUST GROVE", "state" : "AR", "county" : "INDEPENDENCE" },
            "72553": { "city" : "MAGNESS", "state" : "AR", "county" : "INDEPENDENCE" },
            "72554": { "city" : "MAMMOTH SPRING", "state" : "AR", "county" : "FULTON" },
            "72555": { "city" : "MARCELLA", "state" : "AR", "county" : "STONE" },
            "72556": { "city" : "MELBOURNE", "state" : "AR", "county" : "IZARD" },
            "72560": { "city" : "MOUNTAIN VIEW", "state" : "AR", "county" : "STONE" },
            "72561": { "city" : "MOUNT PLEASANT", "state" : "AR", "county" : "IZARD" },
            "72562": { "city" : "NEWARK", "state" : "AR", "county" : "INDEPENDENCE" },
            "72564": { "city" : "OIL TROUGH", "state" : "AR", "county" : "INDEPENDENCE" },
            "72565": { "city" : "OXFORD", "state" : "AR", "county" : "IZARD" },"72566": { "city" : "PINEVILLE", "state" : "AR", "county" : "IZARD" },
            "72567": { "city" : "PLEASANT GROVE", "state" : "AR", "county" : "STONE" },
            "72568": { "city" : "PLEASANT PLAINS", "state" : "AR", "county" : "INDEPENDENCE" },
            "72569": { "city" : "POUGHKEEPSIE", "state" : "AR", "county" : "SHARP" },
            "72571": { "city" : "ROSIE", "state" : "AR", "county" : "INDEPENDENCE" },
            "72572": { "city" : "SAFFELL", "state" : "AR", "county" : "LAWRENCE" },
            "72573": { "city" : "SAGE", "state" : "AR", "county" : "IZARD" },"72575": { "city" : "SALADO", "state" : "AR", "county" : "INDEPENDENCE" },
            "72576": { "city" : "SALEM", "state" : "AR", "county" : "FULTON" },"72577": { "city" : "SIDNEY", "state" : "AR", "county" : "SHARP" },
            "72578": { "city" : "STURKIE", "state" : "AR", "county" : "FULTON" },
            "72579": { "city" : "SULPHUR ROCK", "state" : "AR", "county" : "INDEPENDENCE" },
            "72581": { "city" : "TUMBLING SHOALS", "state" : "AR", "county" : "CLEBURNE" },
            "72583": { "city" : "VIOLA", "state" : "AR", "county" : "FULTON" },"72584": { "city" : "VIOLET HILL", "state" : "AR", "county" : "IZARD" },
            "72585": { "city" : "WIDEMAN", "state" : "AR", "county" : "IZARD" },"72601": { "city" : "HARRISON", "state" : "AR", "county" : "BOONE" },
            "72602": { "city" : "HARRISON", "state" : "AR", "county" : "BOONE" },
            "72611": { "city" : "ALPENA", "state" : "AR", "county" : "BOONE" },"72615": { "city" : "BERGMAN", "state" : "AR", "county" : "BOONE" },
            "72616": { "city" : "BERRYVILLE", "state" : "AR", "county" : "CARROLL" },
            "72617": { "city" : "BIG FLAT", "state" : "AR", "county" : "BAXTER" },
            "72619": { "city" : "BULL SHOALS", "state" : "AR", "county" : "MARION" },
            "72623": { "city" : "CLARKRIDGE", "state" : "AR", "county" : "BAXTER" },
            "72624": { "city" : "COMPTON", "state" : "AR", "county" : "NEWTON" },
            "72626": { "city" : "COTTER", "state" : "AR", "county" : "BAXTER" },"72628": { "city" : "DEER", "state" : "AR", "county" : "NEWTON" },
            "72629": { "city" : "DENNARD", "state" : "AR", "county" : "VAN BUREN" },
            "72630": { "city" : "DIAMOND CITY", "state" : "AR", "county" : "BOONE" },
            "72631": { "city" : "EUREKA SPRINGS", "state" : "AR", "county" : "CARROLL" },
            "72632": { "city" : "EUREKA SPRINGS", "state" : "AR", "county" : "CARROLL" },
            "72633": { "city" : "EVERTON", "state" : "AR", "county" : "BOONE" },"72634": { "city" : "FLIPPIN", "state" : "AR", "county" : "MARION" },
            "72635": { "city" : "GASSVILLE", "state" : "AR", "county" : "BAXTER" },
            "72636": { "city" : "GILBERT", "state" : "AR", "county" : "SEARCY" },
            "72638": { "city" : "GREEN FOREST", "state" : "AR", "county" : "CARROLL" },
            "72639": { "city" : "HARRIET", "state" : "AR", "county" : "SEARCY" },
            "72640": { "city" : "HASTY", "state" : "AR", "county" : "NEWTON" },"72641": { "city" : "JASPER", "state" : "AR", "county" : "NEWTON" },
            "72642": { "city" : "LAKEVIEW", "state" : "AR", "county" : "BAXTER" },
            "72644": { "city" : "LEAD HILL", "state" : "AR", "county" : "BOONE" },
            "72645": { "city" : "LESLIE", "state" : "AR", "county" : "SEARCY" },"72648": { "city" : "MARBLE FALLS", "state" : "AR", "county" : "NEWTON" },
            "72650": { "city" : "MARSHALL", "state" : "AR", "county" : "SEARCY" },
            "72651": { "city" : "MIDWAY", "state" : "AR", "county" : "BAXTER" },"72653": { "city" : "MOUNTAIN HOME", "state" : "AR", "county" : "BAXTER" },
            "72654": { "city" : "MOUNTAIN HOME", "state" : "AR", "county" : "BAXTER" },
            "72655": { "city" : "MOUNT JUDEA", "state" : "AR", "county" : "NEWTON" },
            "72657": { "city" : "TIMBO", "state" : "AR", "county" : "STONE" },"72658": { "city" : "NORFORK", "state" : "AR", "county" : "BAXTER" },
            "72659": { "city" : "NORFORK", "state" : "AR", "county" : "BAXTER" },
            "72660": { "city" : "OAK GROVE", "state" : "AR", "county" : "CARROLL" },
            "72661": { "city" : "OAKLAND", "state" : "AR", "county" : "MARION" },
            "72662": { "city" : "OMAHA", "state" : "AR", "county" : "BOONE" },"72663": { "city" : "ONIA", "state" : "AR", "county" : "STONE" },
            "72666": { "city" : "PARTHENON", "state" : "AR", "county" : "NEWTON" },
            "72668": { "city" : "PEEL", "state" : "AR", "county" : "MARION" },"72669": { "city" : "PINDALL", "state" : "AR", "county" : "SEARCY" },
            "72670": { "city" : "PONCA", "state" : "AR", "county" : "NEWTON" },"72672": { "city" : "PYATT", "state" : "AR", "county" : "MARION" },
            "72675": { "city" : "SAINT JOE", "state" : "AR", "county" : "SEARCY" },
            "72677": { "city" : "SUMMIT", "state" : "AR", "county" : "MARION" },"72679": { "city" : "TILLY", "state" : "AR", "county" : "POPE" },
            "72680": { "city" : "TIMBO", "state" : "AR", "county" : "STONE" },"72682": { "city" : "VALLEY SPRINGS", "state" : "AR", "county" : "BOONE" },
            "72683": { "city" : "VENDOR", "state" : "AR", "county" : "NEWTON" },"72685": { "city" : "WESTERN GROVE", "state" : "AR", "county" : "NEWTON" },
            "72687": { "city" : "YELLVILLE", "state" : "AR", "county" : "MARION" },
            "72701": { "city" : "FAYETTEVILLE", "state" : "AR", "county" : "WASHINGTON" },
            "72702": { "city" : "FAYETTEVILLE", "state" : "AR", "county" : "WASHINGTON" },
            "72703": { "city" : "FAYETTEVILLE", "state" : "AR", "county" : "WASHINGTON" },
            "72704": { "city" : "FAYETTEVILLE", "state" : "AR", "county" : "WASHINGTON" },
            "72711": { "city" : "AVOCA", "state" : "AR", "county" : "BENTON" },"72712": { "city" : "BENTONVILLE", "state" : "AR", "county" : "BENTON" },
            "72714": { "city" : "BELLA VISTA", "state" : "AR", "county" : "BENTON" },
            "72715": { "city" : "BELLA VISTA", "state" : "AR", "county" : "BENTON" },
            "72716": { "city" : "BENTONVILLE", "state" : "AR", "county" : "BENTON" },
            "72717": { "city" : "CANEHILL", "state" : "AR", "county" : "WASHINGTON" },
            "72718": { "city" : "CAVE SPRINGS", "state" : "AR", "county" : "BENTON" },
            "72719": { "city" : "CENTERTON", "state" : "AR", "county" : "BENTON" },
            "72721": { "city" : "COMBS", "state" : "AR", "county" : "MADISON" },"72722": { "city" : "DECATUR", "state" : "AR", "county" : "BENTON" },
            "72727": { "city" : "ELKINS", "state" : "AR", "county" : "WASHINGTON" },
            "72728": { "city" : "ELM SPRINGS", "state" : "AR", "county" : "WASHINGTON" },
            "72729": { "city" : "EVANSVILLE", "state" : "AR", "county" : "WASHINGTON" },
            "72730": { "city" : "FARMINGTON", "state" : "AR", "county" : "WASHINGTON" },
            "72732": { "city" : "GARFIELD", "state" : "AR", "county" : "BENTON" },
            "72733": { "city" : "GATEWAY", "state" : "AR", "county" : "BENTON" },
            "72734": { "city" : "GENTRY", "state" : "AR", "county" : "BENTON" },"72735": { "city" : "GOSHEN", "state" : "AR", "county" : "WASHINGTON" },
            "72736": { "city" : "GRAVETTE", "state" : "AR", "county" : "BENTON" },
            "72737": { "city" : "GREENLAND", "state" : "AR", "county" : "WASHINGTON" },
            "72738": { "city" : "HINDSVILLE", "state" : "AR", "county" : "MADISON" },
            "72739": { "city" : "HIWASSE", "state" : "AR", "county" : "BENTON" },
            "72740": { "city" : "HUNTSVILLE", "state" : "AR", "county" : "MADISON" },
            "72741": { "city" : "JOHNSON", "state" : "AR", "county" : "WASHINGTON" },
            "72742": { "city" : "KINGSTON", "state" : "AR", "county" : "MADISON" },
            "72744": { "city" : "LINCOLN", "state" : "AR", "county" : "WASHINGTON" },
            "72745": { "city" : "LOWELL", "state" : "AR", "county" : "BENTON" },"72749": { "city" : "MORROW", "state" : "AR", "county" : "WASHINGTON" },
            "72751": { "city" : "PEA RIDGE", "state" : "AR", "county" : "BENTON" },
            "72752": { "city" : "PETTIGREW", "state" : "AR", "county" : "MADISON" },
            "72753": { "city" : "PRAIRIE GROVE", "state" : "AR", "county" : "WASHINGTON" },
            "72756": { "city" : "ROGERS", "state" : "AR", "county" : "BENTON" },"72757": { "city" : "ROGERS", "state" : "AR", "county" : "BENTON" },
            "72758": { "city" : "ROGERS", "state" : "AR", "county" : "BENTON" },"72760": { "city" : "SAINT PAUL", "state" : "AR", "county" : "MADISON" },
            "72761": { "city" : "SILOAM SPRINGS", "state" : "AR", "county" : "BENTON" },
            "72762": { "city" : "SPRINGDALE", "state" : "AR", "county" : "WASHINGTON" },
            "72764": { "city" : "SPRINGDALE", "state" : "AR", "county" : "WASHINGTON" },
            "72765": { "city" : "SPRINGDALE", "state" : "AR", "county" : "WASHINGTON" },
            "72766": { "city" : "SPRINGDALE", "state" : "AR", "county" : "WASHINGTON" },
            "72768": { "city" : "SULPHUR SPRINGS", "state" : "AR", "county" : "BENTON" },
            "72769": { "city" : "SUMMERS", "state" : "AR", "county" : "WASHINGTON" },
            "72770": { "city" : "TONTITOWN", "state" : "AR", "county" : "WASHINGTON" },
            "72773": { "city" : "WESLEY", "state" : "AR", "county" : "MADISON" },
            "72774": { "city" : "WEST FORK", "state" : "AR", "county" : "WASHINGTON" },
            "72776": { "city" : "WITTER", "state" : "AR", "county" : "MADISON" },
            "72801": { "city" : "RUSSELLVILLE", "state" : "AR", "county" : "POPE" },
            "72802": { "city" : "RUSSELLVILLE", "state" : "AR", "county" : "POPE" },
            "72811": { "city" : "RUSSELLVILLE", "state" : "AR", "county" : "POPE" },
            "72812": { "city" : "RUSSELLVILLE", "state" : "AR", "county" : "POPE" },
            "72820": { "city" : "ALIX", "state" : "AR", "county" : "FRANKLIN" },"72821": { "city" : "ALTUS", "state" : "AR", "county" : "FRANKLIN" },
            "72823": { "city" : "ATKINS", "state" : "AR", "county" : "POPE" },"72824": { "city" : "BELLEVILLE", "state" : "AR", "county" : "YELL" },
            "72828": { "city" : "BRIGGSVILLE", "state" : "AR", "county" : "YELL" },
            "72829": { "city" : "CENTERVILLE", "state" : "AR", "county" : "YELL" },
            "72830": { "city" : "CLARKSVILLE", "state" : "AR", "county" : "JOHNSON" },
            "72832": { "city" : "COAL HILL", "state" : "AR", "county" : "JOHNSON" },
            "72833": { "city" : "DANVILLE", "state" : "AR", "county" : "YELL" },"72834": { "city" : "DARDANELLE", "state" : "AR", "county" : "YELL" },
            "72835": { "city" : "DELAWARE", "state" : "AR", "county" : "LOGAN" },
            "72837": { "city" : "DOVER", "state" : "AR", "county" : "POPE" },"72839": { "city" : "HAGARVILLE", "state" : "AR", "county" : "JOHNSON" },
            "72840": { "city" : "HARTMAN", "state" : "AR", "county" : "JOHNSON" },
            "72841": { "city" : "HARVEY", "state" : "AR", "county" : "SCOTT" },"72842": { "city" : "HAVANA", "state" : "AR", "county" : "YELL" },
            "72843": { "city" : "HECTOR", "state" : "AR", "county" : "POPE" },"72845": { "city" : "KNOXVILLE", "state" : "AR", "county" : "JOHNSON" },
            "72846": { "city" : "LAMAR", "state" : "AR", "county" : "JOHNSON" },"72847": { "city" : "LONDON", "state" : "AR", "county" : "POPE" },
            "72851": { "city" : "NEW BLAINE", "state" : "AR", "county" : "LOGAN" },
            "72852": { "city" : "OARK", "state" : "AR", "county" : "JOHNSON" },"72853": { "city" : "OLA", "state" : "AR", "county" : "YELL" },
            "72854": { "city" : "OZONE", "state" : "AR", "county" : "JOHNSON" },"72855": { "city" : "PARIS", "state" : "AR", "county" : "LOGAN" },
            "72856": { "city" : "PELSOR", "state" : "AR", "county" : "NEWTON" },"72857": { "city" : "PLAINVIEW", "state" : "AR", "county" : "YELL" },
            "72858": { "city" : "POTTSVILLE", "state" : "AR", "county" : "POPE" },
            "72860": { "city" : "ROVER", "state" : "AR", "county" : "YELL" },"72863": { "city" : "SCRANTON", "state" : "AR", "county" : "LOGAN" },
            "72865": { "city" : "SUBIACO", "state" : "AR", "county" : "LOGAN" },"72901": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72902": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72903": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72904": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72905": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72906": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72908": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72913": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72914": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72916": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72917": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72918": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72919": { "city" : "FORT SMITH", "state" : "AR", "county" : "SEBASTIAN" },
            "72921": { "city" : "ALMA", "state" : "AR", "county" : "CRAWFORD" },"72923": { "city" : "BARLING", "state" : "AR", "county" : "SEBASTIAN" },
            "72926": { "city" : "BOLES", "state" : "AR", "county" : "SCOTT" },"72927": { "city" : "BOONEVILLE", "state" : "AR", "county" : "LOGAN" },
            "72928": { "city" : "BRANCH", "state" : "AR", "county" : "FRANKLIN" },
            "72930": { "city" : "CECIL", "state" : "AR", "county" : "FRANKLIN" },
            "72932": { "city" : "CEDARVILLE", "state" : "AR", "county" : "CRAWFORD" },
            "72933": { "city" : "CHARLESTON", "state" : "AR", "county" : "FRANKLIN" },
            "72934": { "city" : "CHESTER", "state" : "AR", "county" : "CRAWFORD" },
            "72935": { "city" : "DYER", "state" : "AR", "county" : "CRAWFORD" },"72936": { "city" : "GREENWOOD", "state" : "AR", "county" : "SEBASTIAN" },
            "72937": { "city" : "HACKETT", "state" : "AR", "county" : "SEBASTIAN" },
            "72938": { "city" : "HARTFORD", "state" : "AR", "county" : "SEBASTIAN" },
            "72940": { "city" : "HUNTINGTON", "state" : "AR", "county" : "SEBASTIAN" },
            "72941": { "city" : "LAVACA", "state" : "AR", "county" : "SEBASTIAN" },
            "72943": { "city" : "MAGAZINE", "state" : "AR", "county" : "LOGAN" },
            "72944": { "city" : "MANSFIELD", "state" : "AR", "county" : "SCOTT" },
            "72945": { "city" : "MIDLAND", "state" : "AR", "county" : "SEBASTIAN" },
            "72946": { "city" : "MOUNTAINBURG", "state" : "AR", "county" : "CRAWFORD" },
            "72947": { "city" : "MULBERRY", "state" : "AR", "county" : "CRAWFORD" },
            "72948": { "city" : "NATURAL DAM", "state" : "AR", "county" : "CRAWFORD" },
            "72949": { "city" : "OZARK", "state" : "AR", "county" : "FRANKLIN" },
            "72950": { "city" : "PARKS", "state" : "AR", "county" : "SCOTT" },"72951": { "city" : "RATCLIFF", "state" : "AR", "county" : "LOGAN" },
            "72952": { "city" : "RUDY", "state" : "AR", "county" : "CRAWFORD" },"72956": { "city" : "VAN BUREN", "state" : "AR", "county" : "CRAWFORD" },
            "72957": { "city" : "VAN BUREN", "state" : "AR", "county" : "CRAWFORD" },
            "72958": { "city" : "WALDRON", "state" : "AR", "county" : "SCOTT" },"72959": { "city" : "WINSLOW", "state" : "AR", "county" : "WASHINGTON" },
            "73001": { "city" : "ALBERT", "state" : "OK", "county" : "CADDO" },"73002": { "city" : "ALEX", "state" : "OK", "county" : "GRADY" },
            "73003": { "city" : "EDMOND", "state" : "OK", "county" : "OKLAHOMA" },
            "73004": { "city" : "AMBER", "state" : "OK", "county" : "GRADY" },"73005": { "city" : "ANADARKO", "state" : "OK", "county" : "CADDO" },
            "73006": { "city" : "APACHE", "state" : "OK", "county" : "CADDO" },"73007": { "city" : "ARCADIA", "state" : "OK", "county" : "OKLAHOMA" },
            "73008": { "city" : "BETHANY", "state" : "OK", "county" : "OKLAHOMA" },
            "73009": { "city" : "BINGER", "state" : "OK", "county" : "CADDO" },"73010": { "city" : "BLANCHARD", "state" : "OK", "county" : "MCCLAIN" },
            "73011": { "city" : "BRADLEY", "state" : "OK", "county" : "GRADY" },"73012": { "city" : "EDMOND", "state" : "OK", "county" : "OKLAHOMA" },
            "73013": { "city" : "EDMOND", "state" : "OK", "county" : "OKLAHOMA" },
            "73014": { "city" : "CALUMET", "state" : "OK", "county" : "CANADIAN" },
            "73015": { "city" : "CARNEGIE", "state" : "OK", "county" : "CADDO" },
            "73016": { "city" : "CASHION", "state" : "OK", "county" : "KINGFISHER" },
            "73017": { "city" : "CEMENT", "state" : "OK", "county" : "CADDO" },"73018": { "city" : "CHICKASHA", "state" : "OK", "county" : "GRADY" },
            "73019": { "city" : "NORMAN", "state" : "OK", "county" : "CLEVELAND" },
            "73020": { "city" : "CHOCTAW", "state" : "OK", "county" : "OKLAHOMA" },
            "73021": { "city" : "COLONY", "state" : "OK", "county" : "WASHITA" },
            "73022": { "city" : "CONCHO", "state" : "OK", "county" : "CANADIAN" },
            "73023": { "city" : "CHICKASHA", "state" : "OK", "county" : "GRADY" },
            "73024": { "city" : "CORN", "state" : "OK", "county" : "WASHITA" },"73025": { "city" : "EDMOND", "state" : "OK", "county" : "OKLAHOMA" },
            "73026": { "city" : "NORMAN", "state" : "OK", "county" : "CLEVELAND" },
            "73027": { "city" : "COYLE", "state" : "OK", "county" : "LOGAN" },"73028": { "city" : "CRESCENT", "state" : "OK", "county" : "LOGAN" },
            "73029": { "city" : "CYRIL", "state" : "OK", "county" : "CADDO" },"73030": { "city" : "DAVIS", "state" : "OK", "county" : "MURRAY" },
            "73031": { "city" : "DIBBLE", "state" : "OK", "county" : "MCCLAIN" },
            "73032": { "city" : "DOUGHERTY", "state" : "OK", "county" : "MURRAY" },
            "73033": { "city" : "EAKLY", "state" : "OK", "county" : "CADDO" },"73034": { "city" : "EDMOND", "state" : "OK", "county" : "OKLAHOMA" },
            "73036": { "city" : "EL RENO", "state" : "OK", "county" : "CANADIAN" },
            "73038": { "city" : "FORT COBB", "state" : "OK", "county" : "CADDO" },
            "73040": { "city" : "GEARY", "state" : "OK", "county" : "BLAINE" },"73041": { "city" : "GOTEBO", "state" : "OK", "county" : "KIOWA" },
            "73042": { "city" : "GRACEMONT", "state" : "OK", "county" : "CADDO" },
            "73043": { "city" : "GREENFIELD", "state" : "OK", "county" : "BLAINE" },
            "73044": { "city" : "GUTHRIE", "state" : "OK", "county" : "LOGAN" },"73045": { "city" : "HARRAH", "state" : "OK", "county" : "OKLAHOMA" },
            "73047": { "city" : "HINTON", "state" : "OK", "county" : "CADDO" },"73048": { "city" : "HYDRO", "state" : "OK", "county" : "CADDO" },
            "73049": { "city" : "JONES", "state" : "OK", "county" : "OKLAHOMA" },
            "73050": { "city" : "LANGSTON", "state" : "OK", "county" : "LOGAN" },
            "73051": { "city" : "LEXINGTON", "state" : "OK", "county" : "CLEVELAND" },
            "73052": { "city" : "LINDSAY", "state" : "OK", "county" : "GARVIN" },
            "73053": { "city" : "LOOKEBA", "state" : "OK", "county" : "CADDO" },"73054": { "city" : "LUTHER", "state" : "OK", "county" : "OKLAHOMA" },
            "73055": { "city" : "MARLOW", "state" : "OK", "county" : "STEPHENS" },
            "73056": { "city" : "MARSHALL", "state" : "OK", "county" : "LOGAN" },
            "73057": { "city" : "MAYSVILLE", "state" : "OK", "county" : "GARVIN" },
            "73058": { "city" : "MERIDIAN", "state" : "OK", "county" : "LOGAN" },
            "73059": { "city" : "MINCO", "state" : "OK", "county" : "GRADY" },"73061": { "city" : "MORRISON", "state" : "OK", "county" : "NOBLE" },
            "73062": { "city" : "MOUNTAIN VIEW", "state" : "OK", "county" : "KIOWA" },
            "73063": { "city" : "MULHALL", "state" : "OK", "county" : "LOGAN" },"73064": { "city" : "MUSTANG", "state" : "OK", "county" : "CANADIAN" },
            "73065": { "city" : "NEWCASTLE", "state" : "OK", "county" : "MCCLAIN" },
            "73066": { "city" : "NICOMA PARK", "state" : "OK", "county" : "OKLAHOMA" },
            "73067": { "city" : "NINNEKAH", "state" : "OK", "county" : "GRADY" },
            "73068": { "city" : "NOBLE", "state" : "OK", "county" : "CLEVELAND" },
            "73069": { "city" : "NORMAN", "state" : "OK", "county" : "CLEVELAND" },
            "73070": { "city" : "NORMAN", "state" : "OK", "county" : "CLEVELAND" },
            "73071": { "city" : "NORMAN", "state" : "OK", "county" : "CLEVELAND" },
            "73072": { "city" : "NORMAN", "state" : "OK", "county" : "CLEVELAND" },
            "73073": { "city" : "ORLANDO", "state" : "OK", "county" : "LOGAN" },"73074": { "city" : "PAOLI", "state" : "OK", "county" : "GARVIN" },
            "73075": { "city" : "PAULS VALLEY", "state" : "OK", "county" : "GARVIN" },
            "73077": { "city" : "PERRY", "state" : "OK", "county" : "NOBLE" },"73078": { "city" : "PIEDMONT", "state" : "OK", "county" : "CANADIAN" },
            "73079": { "city" : "POCASSET", "state" : "OK", "county" : "GRADY" },
            "73080": { "city" : "PURCELL", "state" : "OK", "county" : "MCCLAIN" },
            "73082": { "city" : "RUSH SPRINGS", "state" : "OK", "county" : "GRADY" },
            "73083": { "city" : "EDMOND", "state" : "OK", "county" : "OKLAHOMA" },
            "73084": { "city" : "SPENCER", "state" : "OK", "county" : "OKLAHOMA" },
            "73085": { "city" : "YUKON", "state" : "OK", "county" : "CANADIAN" },
            "73086": { "city" : "SULPHUR", "state" : "OK", "county" : "MURRAY" },
            "73089": { "city" : "TUTTLE", "state" : "OK", "county" : "GRADY" },"73090": { "city" : "UNION CITY", "state" : "OK", "county" : "CANADIAN" },
            "73092": { "city" : "VERDEN", "state" : "OK", "county" : "GRADY" },"73093": { "city" : "WASHINGTON", "state" : "OK", "county" : "MCCLAIN" },
            "73094": { "city" : "WASHITA", "state" : "OK", "county" : "CADDO" },"73095": { "city" : "WAYNE", "state" : "OK", "county" : "MCCLAIN" },
            "73096": { "city" : "WEATHERFORD", "state" : "OK", "county" : "CUSTER" },
            "73097": { "city" : "WHEATLAND", "state" : "OK", "county" : "OKLAHOMA" },
            "73098": { "city" : "WYNNEWOOD", "state" : "OK", "county" : "GARVIN" },
            "73099": { "city" : "YUKON", "state" : "OK", "county" : "CANADIAN" },
            "73101": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73102": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73103": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73104": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73105": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73106": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73107": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73108": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73109": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73110": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73111": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73112": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73113": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73114": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73115": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73116": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73117": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73118": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73119": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73120": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73121": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73122": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73123": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73124": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73125": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73126": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73127": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73128": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73129": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73130": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73131": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73132": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73134": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73135": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73136": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73137": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73139": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73140": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73141": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73142": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73143": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73144": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73145": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73146": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73147": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73148": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73149": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73150": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73151": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73152": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73153": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "CLEVELAND" },
            "73154": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73155": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73156": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73157": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73159": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73160": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "CLEVELAND" },
            "73162": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73165": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "CLEVELAND" },
            "73169": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73170": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "CLEVELAND" },
            "73172": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73173": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73179": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73189": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "CLEVELAND" },
            "73190": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73194": { "city" : "OKLAHOMA CITY", "state" : "OK", "county" : "OKLAHOMA" },
            "73301": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"73344": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "73401": { "city" : "ARDMORE", "state" : "OK", "county" : "CARTER" },
            "73402": { "city" : "ARDMORE", "state" : "OK", "county" : "CARTER" },
            "73403": { "city" : "ARDMORE", "state" : "OK", "county" : "CARTER" },
            "73425": { "city" : "COUNTYLINE", "state" : "OK", "county" : "STEPHENS" },
            "73430": { "city" : "BURNEYVILLE", "state" : "OK", "county" : "LOVE" },
            "73432": { "city" : "COLEMAN", "state" : "OK", "county" : "JOHNSTON" },
            "73433": { "city" : "ELMORE CITY", "state" : "OK", "county" : "GARVIN" },
            "73434": { "city" : "FOSTER", "state" : "OK", "county" : "STEPHENS" },
            "73435": { "city" : "FOX", "state" : "OK", "county" : "CARTER" },"73436": { "city" : "GENE AUTRY", "state" : "OK", "county" : "CARTER" },
            "73438": { "city" : "HEALDTON", "state" : "OK", "county" : "CARTER" },
            "73439": { "city" : "KINGSTON", "state" : "OK", "county" : "MARSHALL" },
            "73440": { "city" : "LEBANON", "state" : "OK", "county" : "MARSHALL" },
            "73442": { "city" : "LOCO", "state" : "OK", "county" : "STEPHENS" },"73443": { "city" : "LONE GROVE", "state" : "OK", "county" : "CARTER" },
            "73444": { "city" : "HENNEPIN", "state" : "OK", "county" : "CARTER" },
            "73446": { "city" : "MADILL", "state" : "OK", "county" : "MARSHALL" },
            "73447": { "city" : "MANNSVILLE", "state" : "OK", "county" : "JOHNSTON" },
            "73448": { "city" : "MARIETTA", "state" : "OK", "county" : "LOVE" },"73449": { "city" : "MEAD", "state" : "OK", "county" : "BRYAN" },
            "73450": { "city" : "MILBURN", "state" : "OK", "county" : "JOHNSTON" },
            "73453": { "city" : "OVERBROOK", "state" : "OK", "county" : "LOVE" },
            "73455": { "city" : "RAVIA", "state" : "OK", "county" : "JOHNSTON" },
            "73456": { "city" : "RINGLING", "state" : "OK", "county" : "JEFFERSON" },
            "73458": { "city" : "SPRINGER", "state" : "OK", "county" : "CARTER" },
            "73459": { "city" : "THACKERVILLE", "state" : "OK", "county" : "LOVE" },
            "73460": { "city" : "TISHOMINGO", "state" : "OK", "county" : "JOHNSTON" },
            "73461": { "city" : "WAPANUCKA", "state" : "OK", "county" : "JOHNSTON" },
            "73463": { "city" : "WILSON", "state" : "OK", "county" : "CARTER" },"73481": { "city" : "RATLIFF CITY", "state" : "OK", "county" : "CARTER" },
            "73488": { "city" : "TUSSY", "state" : "OK", "county" : "CARTER" },"73491": { "city" : "VELMA", "state" : "OK", "county" : "STEPHENS" },
            "73501": { "city" : "LAWTON", "state" : "OK", "county" : "COMANCHE" },
            "73502": { "city" : "LAWTON", "state" : "OK", "county" : "COMANCHE" },
            "73503": { "city" : "FORT SILL", "state" : "OK", "county" : "COMANCHE" },
            "73505": { "city" : "LAWTON", "state" : "OK", "county" : "COMANCHE" },
            "73506": { "city" : "LAWTON", "state" : "OK", "county" : "COMANCHE" },
            "73507": { "city" : "LAWTON", "state" : "OK", "county" : "COMANCHE" },
            "73520": { "city" : "ADDINGTON", "state" : "OK", "county" : "JEFFERSON" },
            "73521": { "city" : "ALTUS", "state" : "OK", "county" : "JACKSON" },"73522": { "city" : "ALTUS", "state" : "OK", "county" : "JACKSON" },
            "73523": { "city" : "ALTUS AFB", "state" : "OK", "county" : "JACKSON" },
            "73526": { "city" : "BLAIR", "state" : "OK", "county" : "JACKSON" },"73527": { "city" : "CACHE", "state" : "OK", "county" : "COMANCHE" },
            "73528": { "city" : "CHATTANOOGA", "state" : "OK", "county" : "COMANCHE" },
            "73529": { "city" : "COMANCHE", "state" : "OK", "county" : "STEPHENS" },
            "73530": { "city" : "DAVIDSON", "state" : "OK", "county" : "TILLMAN" },
            "73531": { "city" : "DEVOL", "state" : "OK", "county" : "COTTON" },"73532": { "city" : "DUKE", "state" : "OK", "county" : "JACKSON" },
            "73533": { "city" : "DUNCAN", "state" : "OK", "county" : "STEPHENS" },
            "73534": { "city" : "DUNCAN", "state" : "OK", "county" : "STEPHENS" },
            "73536": { "city" : "DUNCAN", "state" : "OK", "county" : "STEPHENS" },
            "73537": { "city" : "ELDORADO", "state" : "OK", "county" : "JACKSON" },
            "73538": { "city" : "ELGIN", "state" : "OK", "county" : "COMANCHE" },
            "73539": { "city" : "ELMER", "state" : "OK", "county" : "JACKSON" },"73540": { "city" : "FAXON", "state" : "OK", "county" : "COMANCHE" },
            "73541": { "city" : "FLETCHER", "state" : "OK", "county" : "COMANCHE" },
            "73542": { "city" : "FREDERICK", "state" : "OK", "county" : "TILLMAN" },
            "73543": { "city" : "GERONIMO", "state" : "OK", "county" : "COMANCHE" },
            "73544": { "city" : "GOULD", "state" : "OK", "county" : "HARMON" },"73546": { "city" : "GRANDFIELD", "state" : "OK", "county" : "TILLMAN" },
            "73547": { "city" : "GRANITE", "state" : "OK", "county" : "GREER" },"73548": { "city" : "HASTINGS", "state" : "OK", "county" : "JEFFERSON" },
            "73549": { "city" : "HEADRICK", "state" : "OK", "county" : "JACKSON" },
            "73550": { "city" : "HOLLIS", "state" : "OK", "county" : "HARMON" },"73552": { "city" : "INDIAHOMA", "state" : "OK", "county" : "COMANCHE" },
            "73553": { "city" : "LOVELAND", "state" : "OK", "county" : "TILLMAN" },
            "73554": { "city" : "MANGUM", "state" : "OK", "county" : "GREER" },"73556": { "city" : "MARTHA", "state" : "OK", "county" : "JACKSON" },
            "73557": { "city" : "MEDICINE PARK", "state" : "OK", "county" : "COMANCHE" },
            "73559": { "city" : "MOUNTAIN PARK", "state" : "OK", "county" : "KIOWA" },
            "73560": { "city" : "OLUSTEE", "state" : "OK", "county" : "JACKSON" },
            "73561": { "city" : "OSCAR", "state" : "OK", "county" : "JEFFERSON" },
            "73562": { "city" : "RANDLETT", "state" : "OK", "county" : "COTTON" },
            "73564": { "city" : "ROOSEVELT", "state" : "OK", "county" : "KIOWA" },
            "73565": { "city" : "RYAN", "state" : "OK", "county" : "JEFFERSON" },
            "73566": { "city" : "SNYDER", "state" : "OK", "county" : "KIOWA" },"73567": { "city" : "STERLING", "state" : "OK", "county" : "COMANCHE" },
            "73568": { "city" : "TEMPLE", "state" : "OK", "county" : "COTTON" },"73569": { "city" : "TERRAL", "state" : "OK", "county" : "JEFFERSON" },
            "73570": { "city" : "TIPTON", "state" : "OK", "county" : "TILLMAN" },
            "73572": { "city" : "WALTERS", "state" : "OK", "county" : "COTTON" },
            "73573": { "city" : "WAURIKA", "state" : "OK", "county" : "JEFFERSON" },
            "73601": { "city" : "CLINTON", "state" : "OK", "county" : "CUSTER" },
            "73620": { "city" : "ARAPAHO", "state" : "OK", "county" : "CUSTER" },
            "73622": { "city" : "BESSIE", "state" : "OK", "county" : "WASHITA" },
            "73624": { "city" : "BURNS FLAT", "state" : "OK", "county" : "WASHITA" },
            "73625": { "city" : "BUTLER", "state" : "OK", "county" : "CUSTER" },"73626": { "city" : "CANUTE", "state" : "OK", "county" : "WASHITA" },
            "73627": { "city" : "CARTER", "state" : "OK", "county" : "BECKHAM" },
            "73628": { "city" : "CHEYENNE", "state" : "OK", "county" : "ROGER MILLS" },
            "73632": { "city" : "CORDELL", "state" : "OK", "county" : "WASHITA" },
            "73638": { "city" : "CRAWFORD", "state" : "OK", "county" : "ROGER MILLS" },
            "73639": { "city" : "CUSTER CITY", "state" : "OK", "county" : "CUSTER" },
            "73641": { "city" : "DILL CITY", "state" : "OK", "county" : "WASHITA" },
            "73642": { "city" : "DURHAM", "state" : "OK", "county" : "ROGER MILLS" },
            "73644": { "city" : "ELK CITY", "state" : "OK", "county" : "BECKHAM" },
            "73645": { "city" : "ERICK", "state" : "OK", "county" : "BECKHAM" },"73646": { "city" : "FAY", "state" : "OK", "county" : "DEWEY" },
            "73647": { "city" : "FOSS", "state" : "OK", "county" : "WASHITA" },"73648": { "city" : "ELK CITY", "state" : "OK", "county" : "BECKHAM" },
            "73650": { "city" : "HAMMON", "state" : "OK", "county" : "ROGER MILLS" },
            "73651": { "city" : "HOBART", "state" : "OK", "county" : "KIOWA" },"73654": { "city" : "LEEDEY", "state" : "OK", "county" : "DEWEY" },
            "73655": { "city" : "LONE WOLF", "state" : "OK", "county" : "KIOWA" },
            "73658": { "city" : "OAKWOOD", "state" : "OK", "county" : "DEWEY" },"73659": { "city" : "PUTNAM", "state" : "OK", "county" : "DEWEY" },
            "73660": { "city" : "REYDON", "state" : "OK", "county" : "ROGER MILLS" },
            "73661": { "city" : "ROCKY", "state" : "OK", "county" : "WASHITA" },"73662": { "city" : "SAYRE", "state" : "OK", "county" : "BECKHAM" },
            "73663": { "city" : "SEILING", "state" : "OK", "county" : "DEWEY" },"73664": { "city" : "SENTINEL", "state" : "OK", "county" : "WASHITA" },
            "73666": { "city" : "SWEETWATER", "state" : "OK", "county" : "ROGER MILLS" },
            "73667": { "city" : "TALOGA", "state" : "OK", "county" : "DEWEY" },"73668": { "city" : "TEXOLA", "state" : "OK", "county" : "BECKHAM" },
            "73669": { "city" : "THOMAS", "state" : "OK", "county" : "CUSTER" },"73673": { "city" : "WILLOW", "state" : "OK", "county" : "GREER" },
            "73701": { "city" : "ENID", "state" : "OK", "county" : "GARFIELD" },"73702": { "city" : "ENID", "state" : "OK", "county" : "GARFIELD" },
            "73703": { "city" : "ENID", "state" : "OK", "county" : "GARFIELD" },"73705": { "city" : "ENID", "state" : "OK", "county" : "GARFIELD" },
            "73706": { "city" : "ENID", "state" : "OK", "county" : "GARFIELD" },"73716": { "city" : "ALINE", "state" : "OK", "county" : "ALFALFA" },
            "73717": { "city" : "ALVA", "state" : "OK", "county" : "WOODS" },"73718": { "city" : "AMES", "state" : "OK", "county" : "MAJOR" },
            "73719": { "city" : "AMORITA", "state" : "OK", "county" : "ALFALFA" },
            "73720": { "city" : "BISON", "state" : "OK", "county" : "GARFIELD" },
            "73722": { "city" : "BURLINGTON", "state" : "OK", "county" : "ALFALFA" },
            "73724": { "city" : "CANTON", "state" : "OK", "county" : "BLAINE" },"73726": { "city" : "CARMEN", "state" : "OK", "county" : "ALFALFA" },
            "73727": { "city" : "CARRIER", "state" : "OK", "county" : "GARFIELD" },
            "73728": { "city" : "CHEROKEE", "state" : "OK", "county" : "ALFALFA" },
            "73729": { "city" : "CLEO SPRINGS", "state" : "OK", "county" : "MAJOR" },
            "73730": { "city" : "COVINGTON", "state" : "OK", "county" : "GARFIELD" },
            "73731": { "city" : "DACOMA", "state" : "OK", "county" : "WOODS" },"73733": { "city" : "DOUGLAS", "state" : "OK", "county" : "GARFIELD" },
            "73734": { "city" : "DOVER", "state" : "OK", "county" : "KINGFISHER" },
            "73735": { "city" : "DRUMMOND", "state" : "OK", "county" : "GARFIELD" },
            "73736": { "city" : "FAIRMONT", "state" : "OK", "county" : "GARFIELD" },
            "73737": { "city" : "FAIRVIEW", "state" : "OK", "county" : "MAJOR" },
            "73738": { "city" : "GARBER", "state" : "OK", "county" : "GARFIELD" },
            "73739": { "city" : "GOLTRY", "state" : "OK", "county" : "ALFALFA" },
            "73741": { "city" : "HELENA", "state" : "OK", "county" : "ALFALFA" },
            "73742": { "city" : "HENNESSEY", "state" : "OK", "county" : "KINGFISHER" },
            "73743": { "city" : "HILLSDALE", "state" : "OK", "county" : "GARFIELD" },
            "73744": { "city" : "HITCHCOCK", "state" : "OK", "county" : "BLAINE" },
            "73746": { "city" : "HOPETON", "state" : "OK", "county" : "WOODS" },"73747": { "city" : "ISABELLA", "state" : "OK", "county" : "MAJOR" },
            "73749": { "city" : "JET", "state" : "OK", "county" : "ALFALFA" },"73750": { "city" : "KINGFISHER", "state" : "OK", "county" : "KINGFISHER" },
            "73753": { "city" : "KREMLIN", "state" : "OK", "county" : "GARFIELD" },
            "73754": { "city" : "LAHOMA", "state" : "OK", "county" : "GARFIELD" },
            "73755": { "city" : "LONGDALE", "state" : "OK", "county" : "BLAINE" },
            "73756": { "city" : "LOYAL", "state" : "OK", "county" : "KINGFISHER" },
            "73757": { "city" : "LUCIEN", "state" : "OK", "county" : "NOBLE" },"73758": { "city" : "MANCHESTER", "state" : "OK", "county" : "GRANT" },
            "73759": { "city" : "MEDFORD", "state" : "OK", "county" : "GRANT" },"73760": { "city" : "MENO", "state" : "OK", "county" : "MAJOR" },
            "73761": { "city" : "NASH", "state" : "OK", "county" : "GRANT" },"73762": { "city" : "OKARCHE", "state" : "OK", "county" : "KINGFISHER" },
            "73763": { "city" : "OKEENE", "state" : "OK", "county" : "BLAINE" },"73764": { "city" : "OMEGA", "state" : "OK", "county" : "KINGFISHER" },
            "73766": { "city" : "POND CREEK", "state" : "OK", "county" : "GRANT" },
            "73768": { "city" : "RINGWOOD", "state" : "OK", "county" : "MAJOR" },
            "73770": { "city" : "SOUTHARD", "state" : "OK", "county" : "BLAINE" },
            "73771": { "city" : "WAKITA", "state" : "OK", "county" : "GRANT" },"73772": { "city" : "WATONGA", "state" : "OK", "county" : "BLAINE" },
            "73773": { "city" : "WAUKOMIS", "state" : "OK", "county" : "GARFIELD" },
            "73801": { "city" : "WOODWARD", "state" : "OK", "county" : "WOODWARD" },
            "73802": { "city" : "WOODWARD", "state" : "OK", "county" : "WOODWARD" },
            "73832": { "city" : "ARNETT", "state" : "OK", "county" : "ELLIS" },"73834": { "city" : "BUFFALO", "state" : "OK", "county" : "HARPER" },
            "73835": { "city" : "CAMARGO", "state" : "OK", "county" : "DEWEY" },"73838": { "city" : "CHESTER", "state" : "OK", "county" : "MAJOR" },
            "73840": { "city" : "FARGO", "state" : "OK", "county" : "ELLIS" },"73841": { "city" : "FORT SUPPLY", "state" : "OK", "county" : "WOODWARD" },
            "73842": { "city" : "FREEDOM", "state" : "OK", "county" : "WOODS" },"73843": { "city" : "GAGE", "state" : "OK", "county" : "ELLIS" },
            "73844": { "city" : "GATE", "state" : "OK", "county" : "BEAVER" },"73848": { "city" : "LAVERNE", "state" : "OK", "county" : "HARPER" },
            "73851": { "city" : "MAY", "state" : "OK", "county" : "HARPER" },"73852": { "city" : "MOORELAND", "state" : "OK", "county" : "WOODWARD" },
            "73853": { "city" : "MUTUAL", "state" : "OK", "county" : "WOODWARD" },
            "73857": { "city" : "SHARON", "state" : "OK", "county" : "WOODWARD" },
            "73858": { "city" : "SHATTUCK", "state" : "OK", "county" : "ELLIS" },
            "73859": { "city" : "VICI", "state" : "OK", "county" : "DEWEY" },"73860": { "city" : "WAYNOKA", "state" : "OK", "county" : "WOODS" },
            "73901": { "city" : "ADAMS", "state" : "OK", "county" : "TEXAS" },"73931": { "city" : "BALKO", "state" : "OK", "county" : "BEAVER" },
            "73932": { "city" : "BEAVER", "state" : "OK", "county" : "BEAVER" },"73933": { "city" : "BOISE CITY", "state" : "OK", "county" : "CIMARRON" },
            "73937": { "city" : "FELT", "state" : "OK", "county" : "CIMARRON" },"73938": { "city" : "FORGAN", "state" : "OK", "county" : "BEAVER" },
            "73939": { "city" : "GOODWELL", "state" : "OK", "county" : "TEXAS" },
            "73942": { "city" : "GUYMON", "state" : "OK", "county" : "TEXAS" },"73944": { "city" : "HARDESTY", "state" : "OK", "county" : "TEXAS" },
            "73945": { "city" : "HOOKER", "state" : "OK", "county" : "TEXAS" },"73946": { "city" : "KENTON", "state" : "OK", "county" : "CIMARRON" },
            "73947": { "city" : "KEYES", "state" : "OK", "county" : "CIMARRON" },
            "73949": { "city" : "TEXHOMA", "state" : "OK", "county" : "TEXAS" },"73950": { "city" : "TURPIN", "state" : "OK", "county" : "BEAVER" },
            "73951": { "city" : "TYRONE", "state" : "OK", "county" : "TEXAS" },"74001": { "city" : "AVANT", "state" : "OK", "county" : "OSAGE" },
            "74002": { "city" : "BARNSDALL", "state" : "OK", "county" : "OSAGE" },
            "74003": { "city" : "BARTLESVILLE", "state" : "OK", "county" : "WASHINGTON" },
            "74004": { "city" : "BARTLESVILLE", "state" : "OK", "county" : "WASHINGTON" },
            "74005": { "city" : "BARTLESVILLE", "state" : "OK", "county" : "WASHINGTON" },
            "74006": { "city" : "BARTLESVILLE", "state" : "OK", "county" : "WASHINGTON" },
            "74008": { "city" : "BIXBY", "state" : "OK", "county" : "TULSA" },"74010": { "city" : "BRISTOW", "state" : "OK", "county" : "CREEK" },
            "74011": { "city" : "BROKEN ARROW", "state" : "OK", "county" : "TULSA" },
            "74012": { "city" : "BROKEN ARROW", "state" : "OK", "county" : "TULSA" },
            "74013": { "city" : "BROKEN ARROW", "state" : "OK", "county" : "TULSA" },
            "74014": { "city" : "BROKEN ARROW", "state" : "OK", "county" : "WAGONER" },
            "74015": { "city" : "CATOOSA", "state" : "OK", "county" : "ROGERS" },
            "74016": { "city" : "CHELSEA", "state" : "OK", "county" : "ROGERS" },
            "74017": { "city" : "CLAREMORE", "state" : "OK", "county" : "ROGERS" },
            "74018": { "city" : "CLAREMORE", "state" : "OK", "county" : "ROGERS" },
            "74019": { "city" : "CLAREMORE", "state" : "OK", "county" : "ROGERS" },
            "74020": { "city" : "CLEVELAND", "state" : "OK", "county" : "PAWNEE" },
            "74021": { "city" : "COLLINSVILLE", "state" : "OK", "county" : "TULSA" },
            "74022": { "city" : "COPAN", "state" : "OK", "county" : "WASHINGTON" },
            "74023": { "city" : "CUSHING", "state" : "OK", "county" : "PAYNE" },"74026": { "city" : "DAVENPORT", "state" : "OK", "county" : "LINCOLN" },
            "74027": { "city" : "DELAWARE", "state" : "OK", "county" : "NOWATA" },
            "74028": { "city" : "DEPEW", "state" : "OK", "county" : "CREEK" },"74029": { "city" : "DEWEY", "state" : "OK", "county" : "WASHINGTON" },
            "74030": { "city" : "DRUMRIGHT", "state" : "OK", "county" : "CREEK" },
            "74031": { "city" : "FOYIL", "state" : "OK", "county" : "ROGERS" },"74032": { "city" : "GLENCOE", "state" : "OK", "county" : "PAYNE" },
            "74033": { "city" : "GLENPOOL", "state" : "OK", "county" : "TULSA" },
            "74034": { "city" : "HALLETT", "state" : "OK", "county" : "PAWNEE" },
            "74035": { "city" : "HOMINY", "state" : "OK", "county" : "OSAGE" },"74036": { "city" : "INOLA", "state" : "OK", "county" : "ROGERS" },
            "74037": { "city" : "JENKS", "state" : "OK", "county" : "TULSA" },"74038": { "city" : "JENNINGS", "state" : "OK", "county" : "PAWNEE" },
            "74039": { "city" : "KELLYVILLE", "state" : "OK", "county" : "CREEK" },
            "74041": { "city" : "KIEFER", "state" : "OK", "county" : "CREEK" },"74042": { "city" : "LENAPAH", "state" : "OK", "county" : "NOWATA" },
            "74043": { "city" : "LEONARD", "state" : "OK", "county" : "TULSA" },"74044": { "city" : "MANNFORD", "state" : "OK", "county" : "CREEK" },
            "74045": { "city" : "MARAMEC", "state" : "OK", "county" : "PAWNEE" },
            "74046": { "city" : "MILFAY", "state" : "OK", "county" : "CREEK" },"74047": { "city" : "MOUNDS", "state" : "OK", "county" : "CREEK" },
            "74048": { "city" : "NOWATA", "state" : "OK", "county" : "NOWATA" },"74050": { "city" : "OAKHURST", "state" : "OK", "county" : "TULSA" },
            "74051": { "city" : "OCHELATA", "state" : "OK", "county" : "WASHINGTON" },
            "74052": { "city" : "OILTON", "state" : "OK", "county" : "CREEK" },"74053": { "city" : "OOLOGAH", "state" : "OK", "county" : "ROGERS" },
            "74054": { "city" : "OSAGE", "state" : "OK", "county" : "OSAGE" },"74055": { "city" : "OWASSO", "state" : "OK", "county" : "TULSA" },
            "74056": { "city" : "PAWHUSKA", "state" : "OK", "county" : "OSAGE" },
            "74058": { "city" : "PAWNEE", "state" : "OK", "county" : "PAWNEE" },"74059": { "city" : "PERKINS", "state" : "OK", "county" : "PAYNE" },
            "74060": { "city" : "PRUE", "state" : "OK", "county" : "OSAGE" },"74061": { "city" : "RAMONA", "state" : "OK", "county" : "WASHINGTON" },
            "74062": { "city" : "RIPLEY", "state" : "OK", "county" : "PAYNE" },"74063": { "city" : "SAND SPRINGS", "state" : "OK", "county" : "TULSA" },
            "74066": { "city" : "SAPULPA", "state" : "OK", "county" : "CREEK" },"74067": { "city" : "SAPULPA", "state" : "OK", "county" : "CREEK" },
            "74068": { "city" : "SHAMROCK", "state" : "OK", "county" : "CREEK" },
            "74070": { "city" : "SKIATOOK", "state" : "OK", "county" : "TULSA" },
            "74071": { "city" : "SLICK", "state" : "OK", "county" : "CREEK" },"74072": { "city" : "S COFFEYVILLE", "state" : "OK", "county" : "NOWATA" },
            "74073": { "city" : "SPERRY", "state" : "OK", "county" : "TULSA" },"74074": { "city" : "STILLWATER", "state" : "OK", "county" : "PAYNE" },
            "74075": { "city" : "STILLWATER", "state" : "OK", "county" : "PAYNE" },
            "74076": { "city" : "STILLWATER", "state" : "OK", "county" : "PAYNE" },
            "74077": { "city" : "STILLWATER", "state" : "OK", "county" : "PAYNE" },
            "74078": { "city" : "STILLWATER", "state" : "OK", "county" : "PAYNE" },
            "74079": { "city" : "STROUD", "state" : "OK", "county" : "LINCOLN" },
            "74080": { "city" : "TALALA", "state" : "OK", "county" : "ROGERS" },"74081": { "city" : "TERLTON", "state" : "OK", "county" : "PAWNEE" },
            "74082": { "city" : "VERA", "state" : "OK", "county" : "WASHINGTON" },
            "74083": { "city" : "WANN", "state" : "OK", "county" : "NOWATA" },"74084": { "city" : "WYNONA", "state" : "OK", "county" : "OSAGE" },
            "74085": { "city" : "YALE", "state" : "OK", "county" : "PAYNE" },"74101": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74102": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74103": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74104": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74105": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74106": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74107": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74108": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74110": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74112": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74114": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74115": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74116": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74117": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74119": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74120": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74121": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74126": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74127": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74128": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74129": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74130": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74131": { "city" : "TULSA", "state" : "OK", "county" : "CREEK" },
            "74132": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74133": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74134": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74135": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74136": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74137": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74141": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74145": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74146": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74147": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74148": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74149": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74150": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74152": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74153": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74155": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74156": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74157": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74158": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74159": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74169": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74170": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74171": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },"74172": { "city" : "TULSA", "state" : "OK", "county" : "TULSA" },
            "74301": { "city" : "VINITA", "state" : "OK", "county" : "CRAIG" },"74330": { "city" : "ADAIR", "state" : "OK", "county" : "MAYES" },
            "74331": { "city" : "AFTON", "state" : "OK", "county" : "OTTAWA" },"74332": { "city" : "BIG CABIN", "state" : "OK", "county" : "CRAIG" },
            "74333": { "city" : "BLUEJACKET", "state" : "OK", "county" : "OTTAWA" },
            "74335": { "city" : "CARDIN", "state" : "OK", "county" : "OTTAWA" },"74337": { "city" : "CHOUTEAU", "state" : "OK", "county" : "MAYES" },
            "74338": { "city" : "COLCORD", "state" : "OK", "county" : "DELAWARE" },
            "74339": { "city" : "COMMERCE", "state" : "OK", "county" : "OTTAWA" },
            "74340": { "city" : "DISNEY", "state" : "OK", "county" : "MAYES" },"74342": { "city" : "EUCHA", "state" : "OK", "county" : "DELAWARE" },
            "74343": { "city" : "FAIRLAND", "state" : "OK", "county" : "OTTAWA" },
            "74344": { "city" : "GROVE", "state" : "OK", "county" : "DELAWARE" },
            "74345": { "city" : "GROVE", "state" : "OK", "county" : "DELAWARE" },
            "74346": { "city" : "JAY", "state" : "OK", "county" : "DELAWARE" },"74347": { "city" : "KANSAS", "state" : "OK", "county" : "DELAWARE" },
            "74349": { "city" : "KETCHUM", "state" : "OK", "county" : "MAYES" },"74350": { "city" : "LANGLEY", "state" : "OK", "county" : "MAYES" },
            "74352": { "city" : "LOCUST GROVE", "state" : "OK", "county" : "MAYES" },
            "74354": { "city" : "MIAMI", "state" : "OK", "county" : "OTTAWA" },"74355": { "city" : "MIAMI", "state" : "OK", "county" : "OTTAWA" },
            "74358": { "city" : "NORTH MIAMI", "state" : "OK", "county" : "OTTAWA" },
            "74359": { "city" : "OAKS", "state" : "OK", "county" : "DELAWARE" },"74360": { "city" : "PICHER", "state" : "OK", "county" : "OTTAWA" },
            "74361": { "city" : "PRYOR", "state" : "OK", "county" : "MAYES" },"74362": { "city" : "PRYOR", "state" : "OK", "county" : "MAYES" },
            "74363": { "city" : "QUAPAW", "state" : "OK", "county" : "OTTAWA" },"74364": { "city" : "ROSE", "state" : "OK", "county" : "MAYES" },
            "74365": { "city" : "SALINA", "state" : "OK", "county" : "MAYES" },"74366": { "city" : "SPAVINAW", "state" : "OK", "county" : "MAYES" },
            "74367": { "city" : "STRANG", "state" : "OK", "county" : "MAYES" },"74368": { "city" : "TWIN OAKS", "state" : "OK", "county" : "DELAWARE" },
            "74369": { "city" : "WELCH", "state" : "OK", "county" : "CRAIG" },"74370": { "city" : "WYANDOTTE", "state" : "OK", "county" : "OTTAWA" },
            "74401": { "city" : "MUSKOGEE", "state" : "OK", "county" : "MUSKOGEE" },
            "74402": { "city" : "MUSKOGEE", "state" : "OK", "county" : "MUSKOGEE" },
            "74403": { "city" : "MUSKOGEE", "state" : "OK", "county" : "MUSKOGEE" },
            "74421": { "city" : "BEGGS", "state" : "OK", "county" : "OKMULGEE" },
            "74422": { "city" : "BOYNTON", "state" : "OK", "county" : "MUSKOGEE" },
            "74423": { "city" : "BRAGGS", "state" : "OK", "county" : "MUSKOGEE" },
            "74425": { "city" : "CANADIAN", "state" : "OK", "county" : "PITTSBURG" },
            "74426": { "city" : "CHECOTAH", "state" : "OK", "county" : "MCINTOSH" },
            "74427": { "city" : "COOKSON", "state" : "OK", "county" : "CHEROKEE" },
            "74428": { "city" : "COUNCIL HILL", "state" : "OK", "county" : "MUSKOGEE" },
            "74429": { "city" : "COWETA", "state" : "OK", "county" : "WAGONER" },
            "74430": { "city" : "CROWDER", "state" : "OK", "county" : "PITTSBURG" },
            "74431": { "city" : "DEWAR", "state" : "OK", "county" : "OKMULGEE" },
            "74432": { "city" : "EUFAULA", "state" : "OK", "county" : "MCINTOSH" },
            "74434": { "city" : "FORT GIBSON", "state" : "OK", "county" : "MUSKOGEE" },
            "74435": { "city" : "GORE", "state" : "OK", "county" : "SEQUOYAH" },"74436": { "city" : "HASKELL", "state" : "OK", "county" : "MUSKOGEE" },
            "74437": { "city" : "HENRYETTA", "state" : "OK", "county" : "OKMULGEE" },
            "74438": { "city" : "HITCHITA", "state" : "OK", "county" : "MCINTOSH" },
            "74441": { "city" : "HULBERT", "state" : "OK", "county" : "CHEROKEE" },
            "74442": { "city" : "INDIANOLA", "state" : "OK", "county" : "PITTSBURG" },
            "74444": { "city" : "MOODYS", "state" : "OK", "county" : "CHEROKEE" },
            "74445": { "city" : "MORRIS", "state" : "OK", "county" : "OKMULGEE" },
            "74446": { "city" : "OKAY", "state" : "OK", "county" : "WAGONER" },"74447": { "city" : "OKMULGEE", "state" : "OK", "county" : "OKMULGEE" },
            "74450": { "city" : "OKTAHA", "state" : "OK", "county" : "MUSKOGEE" },
            "74451": { "city" : "PARK HILL", "state" : "OK", "county" : "CHEROKEE" },
            "74452": { "city" : "PEGGS", "state" : "OK", "county" : "CHEROKEE" },
            "74454": { "city" : "PORTER", "state" : "OK", "county" : "WAGONER" },
            "74455": { "city" : "PORUM", "state" : "OK", "county" : "MUSKOGEE" },
            "74456": { "city" : "PRESTON", "state" : "OK", "county" : "OKMULGEE" },
            "74457": { "city" : "PROCTOR", "state" : "OK", "county" : "ADAIR" },"74458": { "city" : "REDBIRD", "state" : "OK", "county" : "WAGONER" },
            "74460": { "city" : "SCHULTER", "state" : "OK", "county" : "OKMULGEE" },
            "74462": { "city" : "STIGLER", "state" : "OK", "county" : "HASKELL" },
            "74463": { "city" : "TAFT", "state" : "OK", "county" : "MUSKOGEE" },"74464": { "city" : "TAHLEQUAH", "state" : "OK", "county" : "CHEROKEE" },
            "74465": { "city" : "TAHLEQUAH", "state" : "OK", "county" : "CHEROKEE" },
            "74467": { "city" : "WAGONER", "state" : "OK", "county" : "WAGONER" },
            "74468": { "city" : "WAINWRIGHT", "state" : "OK", "county" : "MUSKOGEE" },
            "74469": { "city" : "WARNER", "state" : "OK", "county" : "MUSKOGEE" },
            "74470": { "city" : "WEBBERS FALLS", "state" : "OK", "county" : "MUSKOGEE" },
            "74471": { "city" : "WELLING", "state" : "OK", "county" : "CHEROKEE" },
            "74472": { "city" : "WHITEFIELD", "state" : "OK", "county" : "HASKELL" },
            "74477": { "city" : "WAGONER", "state" : "OK", "county" : "WAGONER" },
            "74501": { "city" : "MCALESTER", "state" : "OK", "county" : "PITTSBURG" },
            "74502": { "city" : "MCALESTER", "state" : "OK", "county" : "PITTSBURG" },
            "74521": { "city" : "ALBION", "state" : "OK", "county" : "PUSHMATAHA" },
            "74522": { "city" : "ALDERSON", "state" : "OK", "county" : "PITTSBURG" },
            "74523": { "city" : "ANTLERS", "state" : "OK", "county" : "PUSHMATAHA" },
            "74525": { "city" : "ATOKA", "state" : "OK", "county" : "ATOKA" },"74528": { "city" : "BLANCO", "state" : "OK", "county" : "PITTSBURG" },
            "74530": { "city" : "BROMIDE", "state" : "OK", "county" : "JOHNSTON" },
            "74531": { "city" : "CALVIN", "state" : "OK", "county" : "HUGHES" },"74533": { "city" : "CANEY", "state" : "OK", "county" : "ATOKA" },
            "74534": { "city" : "CENTRAHOMA", "state" : "OK", "county" : "COAL" },
            "74535": { "city" : "CLARITA", "state" : "OK", "county" : "COAL" },"74536": { "city" : "CLAYTON", "state" : "OK", "county" : "PUSHMATAHA" },
            "74538": { "city" : "COALGATE", "state" : "OK", "county" : "COAL" },"74540": { "city" : "DAISY", "state" : "OK", "county" : "ATOKA" },
            "74543": { "city" : "FINLEY", "state" : "OK", "county" : "PUSHMATAHA" },
            "74545": { "city" : "GOWEN", "state" : "OK", "county" : "LATIMER" },"74546": { "city" : "HAILEYVILLE", "state" : "OK", "county" : "PITTSBURG" },
            "74547": { "city" : "HARTSHORNE", "state" : "OK", "county" : "PITTSBURG" },
            "74549": { "city" : "KIAMICHI CHRISTIAN MISSION", "state" : "OK", "county" : "LE FLORE" },
            "74552": { "city" : "KINTA", "state" : "OK", "county" : "HASKELL" },"74553": { "city" : "KIOWA", "state" : "OK", "county" : "PITTSBURG" },
            "74554": { "city" : "KREBS", "state" : "OK", "county" : "PITTSBURG" },
            "74555": { "city" : "LANE", "state" : "OK", "county" : "ATOKA" },"74556": { "city" : "LEHIGH", "state" : "OK", "county" : "COAL" },
            "74557": { "city" : "MOYERS", "state" : "OK", "county" : "PUSHMATAHA" },
            "74558": { "city" : "NASHOBA", "state" : "OK", "county" : "PUSHMATAHA" },
            "74559": { "city" : "PANOLA", "state" : "OK", "county" : "LATIMER" },
            "74560": { "city" : "PITTSBURG", "state" : "OK", "county" : "PITTSBURG" },
            "74561": { "city" : "QUINTON", "state" : "OK", "county" : "PITTSBURG" },
            "74562": { "city" : "RATTAN", "state" : "OK", "county" : "PUSHMATAHA" },
            "74563": { "city" : "RED OAK", "state" : "OK", "county" : "LATIMER" },
            "74565": { "city" : "SAVANNA", "state" : "OK", "county" : "PITTSBURG" },
            "74569": { "city" : "STRINGTOWN", "state" : "OK", "county" : "ATOKA" },
            "74570": { "city" : "STUART", "state" : "OK", "county" : "HUGHES" },"74571": { "city" : "TALIHINA", "state" : "OK", "county" : "LATIMER" },
            "74572": { "city" : "TUPELO", "state" : "OK", "county" : "COAL" },"74574": { "city" : "TUSKAHOMA", "state" : "OK", "county" : "PUSHMATAHA" },
            "74576": { "city" : "WARDVILLE", "state" : "OK", "county" : "PITTSBURG" },
            "74578": { "city" : "WILBURTON", "state" : "OK", "county" : "LATIMER" },
            "74601": { "city" : "PONCA CITY", "state" : "OK", "county" : "KAY" },
            "74602": { "city" : "PONCA CITY", "state" : "OK", "county" : "KAY" },
            "74604": { "city" : "PONCA CITY", "state" : "OK", "county" : "KAY" },
            "74630": { "city" : "BILLINGS", "state" : "OK", "county" : "NOBLE" },
            "74631": { "city" : "BLACKWELL", "state" : "OK", "county" : "KAY" },"74632": { "city" : "BRAMAN", "state" : "OK", "county" : "KAY" },
            "74633": { "city" : "BURBANK", "state" : "OK", "county" : "OSAGE" },"74636": { "city" : "DEER CREEK", "state" : "OK", "county" : "GRANT" },
            "74637": { "city" : "FAIRFAX", "state" : "OK", "county" : "OSAGE" },"74640": { "city" : "HUNTER", "state" : "OK", "county" : "GARFIELD" },
            "74641": { "city" : "KAW CITY", "state" : "OK", "county" : "KAY" },"74643": { "city" : "LAMONT", "state" : "OK", "county" : "GRANT" },
            "74644": { "city" : "MARLAND", "state" : "OK", "county" : "NOBLE" },"74646": { "city" : "NARDIN", "state" : "OK", "county" : "KAY" },
            "74647": { "city" : "NEWKIRK", "state" : "OK", "county" : "KAY" },"74650": { "city" : "RALSTON", "state" : "OK", "county" : "PAWNEE" },
            "74651": { "city" : "RED ROCK", "state" : "OK", "county" : "NOBLE" },
            "74652": { "city" : "SHIDLER", "state" : "OK", "county" : "OSAGE" },"74653": { "city" : "TONKAWA", "state" : "OK", "county" : "KAY" },
            "74701": { "city" : "DURANT", "state" : "OK", "county" : "BRYAN" },"74702": { "city" : "DURANT", "state" : "OK", "county" : "BRYAN" },
            "74720": { "city" : "ACHILLE", "state" : "OK", "county" : "BRYAN" },"74721": { "city" : "ALBANY", "state" : "OK", "county" : "BRYAN" },
            "74722": { "city" : "BATTIEST", "state" : "OK", "county" : "MCCURTAIN" },
            "74723": { "city" : "BENNINGTON", "state" : "OK", "county" : "BRYAN" },
            "74724": { "city" : "BETHEL", "state" : "OK", "county" : "MCCURTAIN" },
            "74726": { "city" : "BOKCHITO", "state" : "OK", "county" : "BRYAN" },
            "74727": { "city" : "BOSWELL", "state" : "OK", "county" : "CHOCTAW" },
            "74728": { "city" : "BROKEN BOW", "state" : "OK", "county" : "MCCURTAIN" },
            "74729": { "city" : "CADDO", "state" : "OK", "county" : "BRYAN" },"74730": { "city" : "CALERA", "state" : "OK", "county" : "BRYAN" },
            "74731": { "city" : "CARTWRIGHT", "state" : "OK", "county" : "BRYAN" },
            "74733": { "city" : "COLBERT", "state" : "OK", "county" : "BRYAN" },"74734": { "city" : "EAGLETOWN", "state" : "OK", "county" : "MCCURTAIN" },
            "74735": { "city" : "FORT TOWSON", "state" : "OK", "county" : "CHOCTAW" },
            "74736": { "city" : "GARVIN", "state" : "OK", "county" : "MCCURTAIN" },
            "74738": { "city" : "GRANT", "state" : "OK", "county" : "CHOCTAW" },"74740": { "city" : "HAWORTH", "state" : "OK", "county" : "MCCURTAIN" },
            "74741": { "city" : "HENDRIX", "state" : "OK", "county" : "BRYAN" },"74743": { "city" : "HUGO", "state" : "OK", "county" : "CHOCTAW" },
            "74745": { "city" : "IDABEL", "state" : "OK", "county" : "MCCURTAIN" },
            "74748": { "city" : "KENEFIC", "state" : "OK", "county" : "JOHNSTON" },
            "74750": { "city" : "MILLERTON", "state" : "OK", "county" : "MCCURTAIN" },
            "74752": { "city" : "PICKENS", "state" : "OK", "county" : "MCCURTAIN" },
            "74753": { "city" : "PLATTER", "state" : "OK", "county" : "BRYAN" },"74754": { "city" : "RINGOLD", "state" : "OK", "county" : "MCCURTAIN" },
            "74755": { "city" : "RUFE", "state" : "OK", "county" : "MCCURTAIN" },
            "74756": { "city" : "SAWYER", "state" : "OK", "county" : "CHOCTAW" },
            "74759": { "city" : "SOPER", "state" : "OK", "county" : "CHOCTAW" },"74764": { "city" : "VALLIANT", "state" : "OK", "county" : "MCCURTAIN" },
            "74766": { "city" : "WRIGHT CITY", "state" : "OK", "county" : "MCCURTAIN" },
            "74801": { "city" : "SHAWNEE", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74802": { "city" : "SHAWNEE", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74804": { "city" : "SHAWNEE", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74818": { "city" : "SEMINOLE", "state" : "OK", "county" : "SEMINOLE" },
            "74820": { "city" : "ADA", "state" : "OK", "county" : "PONTOTOC" },"74821": { "city" : "ADA", "state" : "OK", "county" : "PONTOTOC" },
            "74824": { "city" : "AGRA", "state" : "OK", "county" : "LINCOLN" },"74825": { "city" : "ALLEN", "state" : "OK", "county" : "PONTOTOC" },
            "74826": { "city" : "ASHER", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74827": { "city" : "ATWOOD", "state" : "OK", "county" : "HUGHES" },"74829": { "city" : "BOLEY", "state" : "OK", "county" : "OKFUSKEE" },
            "74830": { "city" : "BOWLEGS", "state" : "OK", "county" : "SEMINOLE" },
            "74831": { "city" : "BYARS", "state" : "OK", "county" : "MCCLAIN" },"74832": { "city" : "CARNEY", "state" : "OK", "county" : "LINCOLN" },
            "74833": { "city" : "CASTLE", "state" : "OK", "county" : "OKFUSKEE" },
            "74834": { "city" : "CHANDLER", "state" : "OK", "county" : "LINCOLN" },
            "74837": { "city" : "CROMWELL", "state" : "OK", "county" : "SEMINOLE" },
            "74839": { "city" : "DUSTIN", "state" : "OK", "county" : "HUGHES" },"74840": { "city" : "EARLSBORO", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74842": { "city" : "FITTSTOWN", "state" : "OK", "county" : "PONTOTOC" },
            "74843": { "city" : "FITZHUGH", "state" : "OK", "county" : "PONTOTOC" },
            "74844": { "city" : "FRANCIS", "state" : "OK", "county" : "PONTOTOC" },
            "74848": { "city" : "HOLDENVILLE", "state" : "OK", "county" : "HUGHES" },
            "74849": { "city" : "KONAWA", "state" : "OK", "county" : "SEMINOLE" },
            "74850": { "city" : "LAMAR", "state" : "OK", "county" : "HUGHES" },"74851": { "city" : "MCLOUD", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74852": { "city" : "MACOMB", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74854": { "city" : "MAUD", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74855": { "city" : "MEEKER", "state" : "OK", "county" : "LINCOLN" },
            "74856": { "city" : "MILL CREEK", "state" : "OK", "county" : "JOHNSTON" },
            "74857": { "city" : "NEWALLA", "state" : "OK", "county" : "CLEVELAND" },
            "74859": { "city" : "OKEMAH", "state" : "OK", "county" : "OKFUSKEE" },
            "74860": { "city" : "PADEN", "state" : "OK", "county" : "OKFUSKEE" },
            "74864": { "city" : "PRAGUE", "state" : "OK", "county" : "LINCOLN" },
            "74865": { "city" : "ROFF", "state" : "OK", "county" : "PONTOTOC" },"74866": { "city" : "SAINT LOUIS", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74867": { "city" : "SASAKWA", "state" : "OK", "county" : "SEMINOLE" },
            "74868": { "city" : "SEMINOLE", "state" : "OK", "county" : "SEMINOLE" },
            "74869": { "city" : "SPARKS", "state" : "OK", "county" : "LINCOLN" },
            "74871": { "city" : "STONEWALL", "state" : "OK", "county" : "PONTOTOC" },
            "74872": { "city" : "STRATFORD", "state" : "OK", "county" : "GARVIN" },
            "74873": { "city" : "TECUMSEH", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74875": { "city" : "TRYON", "state" : "OK", "county" : "LINCOLN" },"74878": { "city" : "WANETTE", "state" : "OK", "county" : "POTTAWATOMIE" },
            "74880": { "city" : "WELEETKA", "state" : "OK", "county" : "OKFUSKEE" },
            "74881": { "city" : "WELLSTON", "state" : "OK", "county" : "LINCOLN" },
            "74883": { "city" : "WETUMKA", "state" : "OK", "county" : "HUGHES" },
            "74884": { "city" : "WEWOKA", "state" : "OK", "county" : "SEMINOLE" },
            "74901": { "city" : "ARKOMA", "state" : "OK", "county" : "LE FLORE" },
            "74902": { "city" : "POCOLA", "state" : "OK", "county" : "LE FLORE" },
            "74930": { "city" : "BOKOSHE", "state" : "OK", "county" : "LE FLORE" },
            "74931": { "city" : "BUNCH", "state" : "OK", "county" : "ADAIR" },"74932": { "city" : "CAMERON", "state" : "OK", "county" : "LE FLORE" },
            "74936": { "city" : "GANS", "state" : "OK", "county" : "SEQUOYAH" },"74937": { "city" : "HEAVENER", "state" : "OK", "county" : "LE FLORE" },
            "74939": { "city" : "HODGEN", "state" : "OK", "county" : "LE FLORE" },
            "74940": { "city" : "HOWE", "state" : "OK", "county" : "LE FLORE" },"74941": { "city" : "KEOTA", "state" : "OK", "county" : "HASKELL" },
            "74942": { "city" : "LEFLORE", "state" : "OK", "county" : "LE FLORE" },
            "74943": { "city" : "LEQUIRE", "state" : "OK", "county" : "HASKELL" },
            "74944": { "city" : "MCCURTAIN", "state" : "OK", "county" : "HASKELL" },
            "74945": { "city" : "MARBLE CITY", "state" : "OK", "county" : "SEQUOYAH" },
            "74946": { "city" : "MOFFETT", "state" : "OK", "county" : "SEQUOYAH" },
            "74947": { "city" : "MONROE", "state" : "OK", "county" : "LE FLORE" },
            "74948": { "city" : "MULDROW", "state" : "OK", "county" : "SEQUOYAH" },
            "74949": { "city" : "MUSE", "state" : "OK", "county" : "LE FLORE" },"74951": { "city" : "PANAMA", "state" : "OK", "county" : "LE FLORE" },
            "74953": { "city" : "POTEAU", "state" : "OK", "county" : "LE FLORE" },
            "74954": { "city" : "ROLAND", "state" : "OK", "county" : "SEQUOYAH" },
            "74955": { "city" : "SALLISAW", "state" : "OK", "county" : "SEQUOYAH" },
            "74956": { "city" : "SHADY POINT", "state" : "OK", "county" : "LE FLORE" },
            "74957": { "city" : "SMITHVILLE", "state" : "OK", "county" : "MCCURTAIN" },
            "74959": { "city" : "SPIRO", "state" : "OK", "county" : "LE FLORE" },
            "74960": { "city" : "STILWELL", "state" : "OK", "county" : "ADAIR" },
            "74962": { "city" : "VIAN", "state" : "OK", "county" : "SEQUOYAH" },"74963": { "city" : "WATSON", "state" : "OK", "county" : "MCCURTAIN" },
            "74964": { "city" : "WATTS", "state" : "OK", "county" : "ADAIR" },"74965": { "city" : "WESTVILLE", "state" : "OK", "county" : "ADAIR" },
            "74966": { "city" : "WISTER", "state" : "OK", "county" : "LE FLORE" },
            "75001": { "city" : "ADDISON", "state" : "TX", "county" : "DALLAS" },
            "75002": { "city" : "ALLEN", "state" : "TX", "county" : "COLLIN" },"75006": { "city" : "CARROLLTON", "state" : "TX", "county" : "DALLAS" },
            "75007": { "city" : "CARROLLTON", "state" : "TX", "county" : "DENTON" },
            "75009": { "city" : "CELINA", "state" : "TX", "county" : "COLLIN" },"75010": { "city" : "CARROLLTON", "state" : "TX", "county" : "DENTON" },
            "75011": { "city" : "CARROLLTON", "state" : "TX", "county" : "DALLAS" },
            "75013": { "city" : "ALLEN", "state" : "TX", "county" : "COLLIN" },"75014": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },
            "75015": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },"75016": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },
            "75017": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },"75019": { "city" : "COPPELL", "state" : "TX", "county" : "DALLAS" },
            "75020": { "city" : "DENISON", "state" : "TX", "county" : "GRAYSON" },
            "75021": { "city" : "DENISON", "state" : "TX", "county" : "GRAYSON" },
            "75022": { "city" : "FLOWER MOUND", "state" : "TX", "county" : "DENTON" },
            "75023": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },"75024": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },
            "75025": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },"75026": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },
            "75027": { "city" : "FLOWER MOUND", "state" : "TX", "county" : "DENTON" },
            "75028": { "city" : "FLOWER MOUND", "state" : "TX", "county" : "DENTON" },
            "75029": { "city" : "LEWISVILLE", "state" : "TX", "county" : "DENTON" },
            "75030": { "city" : "ROWLETT", "state" : "TX", "county" : "DALLAS" },
            "75032": { "city" : "ROCKWALL", "state" : "TX", "county" : "ROCKWALL" },
            "75033": { "city" : "FRISCO", "state" : "TX", "county" : "DENTON" },"75034": { "city" : "FRISCO", "state" : "TX", "county" : "DENTON" },
            "75035": { "city" : "FRISCO", "state" : "TX", "county" : "COLLIN" },"75037": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },
            "75038": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },"75039": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },
            "75040": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75041": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75042": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75043": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75044": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75045": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75046": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75047": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75048": { "city" : "SACHSE", "state" : "TX", "county" : "DALLAS" },"75049": { "city" : "GARLAND", "state" : "TX", "county" : "DALLAS" },
            "75050": { "city" : "GRAND PRAIRIE", "state" : "TX", "county" : "DALLAS" },
            "75051": { "city" : "GRAND PRAIRIE", "state" : "TX", "county" : "DALLAS" },
            "75052": { "city" : "GRAND PRAIRIE", "state" : "TX", "county" : "DALLAS" },
            "75053": { "city" : "GRAND PRAIRIE", "state" : "TX", "county" : "DALLAS" },
            "75054": { "city" : "GRAND PRAIRIE", "state" : "TX", "county" : "DALLAS" },
            "75056": { "city" : "THE COLONY", "state" : "TX", "county" : "DENTON" },
            "75057": { "city" : "LEWISVILLE", "state" : "TX", "county" : "DENTON" },
            "75058": { "city" : "GUNTER", "state" : "TX", "county" : "GRAYSON" },
            "75060": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },"75061": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },
            "75062": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },"75063": { "city" : "IRVING", "state" : "TX", "county" : "DALLAS" },
            "75065": { "city" : "LAKE DALLAS", "state" : "TX", "county" : "DENTON" },
            "75067": { "city" : "LEWISVILLE", "state" : "TX", "county" : "DENTON" },
            "75068": { "city" : "LITTLE ELM", "state" : "TX", "county" : "DENTON" },
            "75069": { "city" : "MCKINNEY", "state" : "TX", "county" : "COLLIN" },
            "75070": { "city" : "MCKINNEY", "state" : "TX", "county" : "COLLIN" },
            "75071": { "city" : "MCKINNEY", "state" : "TX", "county" : "COLLIN" },
            "75074": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },"75075": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },
            "75076": { "city" : "POTTSBORO", "state" : "TX", "county" : "GRAYSON" },
            "75077": { "city" : "LEWISVILLE", "state" : "TX", "county" : "DENTON" },
            "75078": { "city" : "PROSPER", "state" : "TX", "county" : "COLLIN" },
            "75080": { "city" : "RICHARDSON", "state" : "TX", "county" : "DALLAS" },
            "75081": { "city" : "RICHARDSON", "state" : "TX", "county" : "DALLAS" },
            "75082": { "city" : "RICHARDSON", "state" : "TX", "county" : "DALLAS" },
            "75083": { "city" : "RICHARDSON", "state" : "TX", "county" : "DALLAS" },
            "75085": { "city" : "RICHARDSON", "state" : "TX", "county" : "DALLAS" },
            "75086": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },"75087": { "city" : "ROCKWALL", "state" : "TX", "county" : "ROCKWALL" },
            "75088": { "city" : "ROWLETT", "state" : "TX", "county" : "DALLAS" },
            "75089": { "city" : "ROWLETT", "state" : "TX", "county" : "DALLAS" },
            "75090": { "city" : "SHERMAN", "state" : "TX", "county" : "GRAYSON" },
            "75091": { "city" : "SHERMAN", "state" : "TX", "county" : "GRAYSON" },
            "75092": { "city" : "SHERMAN", "state" : "TX", "county" : "GRAYSON" },
            "75093": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },"75094": { "city" : "PLANO", "state" : "TX", "county" : "COLLIN" },
            "75097": { "city" : "WESTON", "state" : "TX", "county" : "COLLIN" },"75098": { "city" : "WYLIE", "state" : "TX", "county" : "COLLIN" },
            "75101": { "city" : "BARDWELL", "state" : "TX", "county" : "ELLIS" },
            "75102": { "city" : "BARRY", "state" : "TX", "county" : "NAVARRO" },"75103": { "city" : "CANTON", "state" : "TX", "county" : "VAN ZANDT" },
            "75104": { "city" : "CEDAR HILL", "state" : "TX", "county" : "DALLAS" },
            "75105": { "city" : "CHATFIELD", "state" : "TX", "county" : "NAVARRO" },
            "75106": { "city" : "CEDAR HILL", "state" : "TX", "county" : "DALLAS" },
            "75109": { "city" : "CORSICANA", "state" : "TX", "county" : "NAVARRO" },
            "75110": { "city" : "CORSICANA", "state" : "TX", "county" : "NAVARRO" },
            "75114": { "city" : "CRANDALL", "state" : "TX", "county" : "KAUFMAN" },
            "75115": { "city" : "DESOTO", "state" : "TX", "county" : "DALLAS" },"75116": { "city" : "DUNCANVILLE", "state" : "TX", "county" : "DALLAS" },
            "75117": { "city" : "EDGEWOOD", "state" : "TX", "county" : "VAN ZANDT" },
            "75118": { "city" : "ELMO", "state" : "TX", "county" : "KAUFMAN" },"75119": { "city" : "ENNIS", "state" : "TX", "county" : "ELLIS" },
            "75120": { "city" : "ENNIS", "state" : "TX", "county" : "ELLIS" },"75121": { "city" : "COPEVILLE", "state" : "TX", "county" : "COLLIN" },
            "75123": { "city" : "DESOTO", "state" : "TX", "county" : "DALLAS" },"75124": { "city" : "EUSTACE", "state" : "TX", "county" : "HENDERSON" },
            "75125": { "city" : "FERRIS", "state" : "TX", "county" : "ELLIS" },"75126": { "city" : "FORNEY", "state" : "TX", "county" : "KAUFMAN" },
            "75127": { "city" : "FRUITVALE", "state" : "TX", "county" : "VAN ZANDT" },
            "75132": { "city" : "FATE", "state" : "TX", "county" : "ROCKWALL" },"75134": { "city" : "LANCASTER", "state" : "TX", "county" : "DALLAS" },
            "75135": { "city" : "CADDO MILLS", "state" : "TX", "county" : "HUNT" },
            "75137": { "city" : "DUNCANVILLE", "state" : "TX", "county" : "DALLAS" },
            "75138": { "city" : "DUNCANVILLE", "state" : "TX", "county" : "DALLAS" },
            "75140": { "city" : "GRAND SALINE", "state" : "TX", "county" : "VAN ZANDT" },
            "75141": { "city" : "HUTCHINS", "state" : "TX", "county" : "DALLAS" },
            "75142": { "city" : "KAUFMAN", "state" : "TX", "county" : "KAUFMAN" },
            "75143": { "city" : "KEMP", "state" : "TX", "county" : "KAUFMAN" },"75144": { "city" : "KERENS", "state" : "TX", "county" : "NAVARRO" },
            "75146": { "city" : "LANCASTER", "state" : "TX", "county" : "DALLAS" },
            "75147": { "city" : "MABANK", "state" : "TX", "county" : "KAUFMAN" },
            "75148": { "city" : "MALAKOFF", "state" : "TX", "county" : "HENDERSON" },
            "75149": { "city" : "MESQUITE", "state" : "TX", "county" : "DALLAS" },
            "75150": { "city" : "MESQUITE", "state" : "TX", "county" : "DALLAS" },
            "75151": { "city" : "CORSICANA", "state" : "TX", "county" : "NAVARRO" },
            "75152": { "city" : "PALMER", "state" : "TX", "county" : "ELLIS" },"75153": { "city" : "POWELL", "state" : "TX", "county" : "NAVARRO" },
            "75154": { "city" : "RED OAK", "state" : "TX", "county" : "ELLIS" },"75155": { "city" : "RICE", "state" : "TX", "county" : "NAVARRO" },
            "75156": { "city" : "MABANK", "state" : "TX", "county" : "HENDERSON" },
            "75157": { "city" : "ROSSER", "state" : "TX", "county" : "KAUFMAN" },
            "75158": { "city" : "SCURRY", "state" : "TX", "county" : "KAUFMAN" },
            "75159": { "city" : "SEAGOVILLE", "state" : "TX", "county" : "DALLAS" },
            "75160": { "city" : "TERRELL", "state" : "TX", "county" : "KAUFMAN" },
            "75161": { "city" : "TERRELL", "state" : "TX", "county" : "KAUFMAN" },
            "75163": { "city" : "TRINIDAD", "state" : "TX", "county" : "HENDERSON" },
            "75164": { "city" : "JOSEPHINE", "state" : "TX", "county" : "COLLIN" },
            "75165": { "city" : "WAXAHACHIE", "state" : "TX", "county" : "ELLIS" },
            "75166": { "city" : "LAVON", "state" : "TX", "county" : "COLLIN" },"75167": { "city" : "WAXAHACHIE", "state" : "TX", "county" : "ELLIS" },
            "75168": { "city" : "WAXAHACHIE", "state" : "TX", "county" : "ELLIS" },
            "75169": { "city" : "WILLS POINT", "state" : "TX", "county" : "VAN ZANDT" },
            "75172": { "city" : "WILMER", "state" : "TX", "county" : "DALLAS" },"75173": { "city" : "NEVADA", "state" : "TX", "county" : "COLLIN" },
            "75180": { "city" : "MESQUITE", "state" : "TX", "county" : "DALLAS" },
            "75181": { "city" : "MESQUITE", "state" : "TX", "county" : "DALLAS" },
            "75182": { "city" : "SUNNYVALE", "state" : "TX", "county" : "DALLAS" },
            "75185": { "city" : "MESQUITE", "state" : "TX", "county" : "DALLAS" },
            "75187": { "city" : "MESQUITE", "state" : "TX", "county" : "DALLAS" },
            "75189": { "city" : "ROYSE CITY", "state" : "TX", "county" : "ROCKWALL" },
            "75201": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75202": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75203": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75204": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75205": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75206": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75207": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75208": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75209": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75210": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75211": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75212": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75214": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75215": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75216": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75217": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75218": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75219": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75220": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75221": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75222": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75223": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75224": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75225": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75226": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75227": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75228": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75229": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75230": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75231": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75232": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75233": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75234": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75235": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75236": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75237": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75238": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75240": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75241": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75242": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75243": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75244": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75245": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75246": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75247": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75248": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75249": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75250": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75251": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75252": { "city" : "DALLAS", "state" : "TX", "county" : "COLLIN" },
            "75253": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75254": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75258": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75260": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75261": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75262": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75265": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75266": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75270": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75275": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75277": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75284": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75287": { "city" : "DALLAS", "state" : "TX", "county" : "COLLIN" },"75301": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75312": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75313": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75315": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75320": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75323": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75326": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75336": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75339": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75342": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75354": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75355": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75356": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75357": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75359": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75360": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75367": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75370": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75371": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75372": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75374": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75376": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75378": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75379": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75380": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75381": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75382": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75390": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },"75397": { "city" : "DALLAS", "state" : "TX", "county" : "DALLAS" },
            "75401": { "city" : "GREENVILLE", "state" : "TX", "county" : "HUNT" },
            "75402": { "city" : "GREENVILLE", "state" : "TX", "county" : "HUNT" },
            "75403": { "city" : "GREENVILLE", "state" : "TX", "county" : "HUNT" },
            "75404": { "city" : "GREENVILLE", "state" : "TX", "county" : "HUNT" },
            "75407": { "city" : "PRINCETON", "state" : "TX", "county" : "COLLIN" },
            "75409": { "city" : "ANNA", "state" : "TX", "county" : "COLLIN" },"75410": { "city" : "ALBA", "state" : "TX", "county" : "WOOD" },
            "75411": { "city" : "ARTHUR CITY", "state" : "TX", "county" : "LAMAR" },
            "75412": { "city" : "BAGWELL", "state" : "TX", "county" : "RED RIVER" },
            "75413": { "city" : "BAILEY", "state" : "TX", "county" : "FANNIN" },"75414": { "city" : "BELLS", "state" : "TX", "county" : "GRAYSON" },
            "75416": { "city" : "BLOSSOM", "state" : "TX", "county" : "LAMAR" },"75417": { "city" : "BOGATA", "state" : "TX", "county" : "RED RIVER" },
            "75418": { "city" : "BONHAM", "state" : "TX", "county" : "FANNIN" },"75420": { "city" : "BRASHEAR", "state" : "TX", "county" : "HOPKINS" },
            "75421": { "city" : "BROOKSTON", "state" : "TX", "county" : "LAMAR" },
            "75422": { "city" : "CAMPBELL", "state" : "TX", "county" : "HUNT" },"75423": { "city" : "CELESTE", "state" : "TX", "county" : "HUNT" },
            "75424": { "city" : "BLUE RIDGE", "state" : "TX", "county" : "COLLIN" },
            "75425": { "city" : "CHICOTA", "state" : "TX", "county" : "LAMAR" },"75426": { "city" : "CLARKSVILLE", "state" : "TX", "county" : "RED RIVER" },
            "75428": { "city" : "COMMERCE", "state" : "TX", "county" : "HUNT" },"75429": { "city" : "COMMERCE", "state" : "TX", "county" : "HUNT" },
            "75431": { "city" : "COMO", "state" : "TX", "county" : "HOPKINS" },"75432": { "city" : "COOPER", "state" : "TX", "county" : "DELTA" },
            "75433": { "city" : "CUMBY", "state" : "TX", "county" : "HOPKINS" },"75435": { "city" : "DEPORT", "state" : "TX", "county" : "LAMAR" },
            "75436": { "city" : "DETROIT", "state" : "TX", "county" : "RED RIVER" },
            "75437": { "city" : "DIKE", "state" : "TX", "county" : "HOPKINS" },"75438": { "city" : "DODD CITY", "state" : "TX", "county" : "FANNIN" },
            "75439": { "city" : "ECTOR", "state" : "TX", "county" : "FANNIN" },"75440": { "city" : "EMORY", "state" : "TX", "county" : "RAINS" },
            "75441": { "city" : "ENLOE", "state" : "TX", "county" : "DELTA" },"75442": { "city" : "FARMERSVILLE", "state" : "TX", "county" : "COLLIN" },
            "75443": { "city" : "GOBER", "state" : "TX", "county" : "FANNIN" },"75444": { "city" : "GOLDEN", "state" : "TX", "county" : "WOOD" },
            "75446": { "city" : "HONEY GROVE", "state" : "TX", "county" : "FANNIN" },
            "75447": { "city" : "IVANHOE", "state" : "TX", "county" : "FANNIN" },
            "75448": { "city" : "KLONDIKE", "state" : "TX", "county" : "DELTA" },
            "75449": { "city" : "LADONIA", "state" : "TX", "county" : "FANNIN" },
            "75450": { "city" : "LAKE CREEK", "state" : "TX", "county" : "DELTA" },
            "75451": { "city" : "LEESBURG", "state" : "TX", "county" : "CAMP" },"75452": { "city" : "LEONARD", "state" : "TX", "county" : "FANNIN" },
            "75453": { "city" : "LONE OAK", "state" : "TX", "county" : "HUNT" },"75454": { "city" : "MELISSA", "state" : "TX", "county" : "COLLIN" },
            "75455": { "city" : "MOUNT PLEASANT", "state" : "TX", "county" : "TITUS" },
            "75456": { "city" : "MOUNT PLEASANT", "state" : "TX", "county" : "TITUS" },
            "75457": { "city" : "MOUNT VERNON", "state" : "TX", "county" : "FRANKLIN" },
            "75458": { "city" : "MERIT", "state" : "TX", "county" : "HUNT" },"75459": { "city" : "HOWE", "state" : "TX", "county" : "GRAYSON" },
            "75460": { "city" : "PARIS", "state" : "TX", "county" : "LAMAR" },"75461": { "city" : "PARIS", "state" : "TX", "county" : "LAMAR" },
            "75462": { "city" : "PARIS", "state" : "TX", "county" : "LAMAR" },"75468": { "city" : "PATTONVILLE", "state" : "TX", "county" : "LAMAR" },
            "75469": { "city" : "PECAN GAP", "state" : "TX", "county" : "DELTA" },
            "75470": { "city" : "PETTY", "state" : "TX", "county" : "LAMAR" },"75471": { "city" : "PICKTON", "state" : "TX", "county" : "HOPKINS" },
            "75472": { "city" : "POINT", "state" : "TX", "county" : "RAINS" },"75473": { "city" : "POWDERLY", "state" : "TX", "county" : "LAMAR" },
            "75474": { "city" : "QUINLAN", "state" : "TX", "county" : "HUNT" },"75475": { "city" : "RANDOLPH", "state" : "TX", "county" : "FANNIN" },
            "75476": { "city" : "RAVENNA", "state" : "TX", "county" : "FANNIN" },
            "75477": { "city" : "ROXTON", "state" : "TX", "county" : "LAMAR" },"75478": { "city" : "SALTILLO", "state" : "TX", "county" : "HOPKINS" },
            "75479": { "city" : "SAVOY", "state" : "TX", "county" : "FANNIN" },"75480": { "city" : "SCROGGINS", "state" : "TX", "county" : "FRANKLIN" },
            "75481": { "city" : "SULPHUR BLUFF", "state" : "TX", "county" : "HOPKINS" },
            "75482": { "city" : "SULPHUR SPRINGS", "state" : "TX", "county" : "HOPKINS" },
            "75483": { "city" : "SULPHUR SPRINGS", "state" : "TX", "county" : "HOPKINS" },
            "75485": { "city" : "WESTMINSTER", "state" : "TX", "county" : "COLLIN" },
            "75486": { "city" : "SUMNER", "state" : "TX", "county" : "LAMAR" },"75487": { "city" : "TALCO", "state" : "TX", "county" : "FRANKLIN" },
            "75488": { "city" : "TELEPHONE", "state" : "TX", "county" : "FANNIN" },
            "75489": { "city" : "TOM BEAN", "state" : "TX", "county" : "GRAYSON" },
            "75490": { "city" : "TRENTON", "state" : "TX", "county" : "FANNIN" },
            "75491": { "city" : "WHITEWRIGHT", "state" : "TX", "county" : "GRAYSON" },
            "75492": { "city" : "WINDOM", "state" : "TX", "county" : "FANNIN" },"75493": { "city" : "WINFIELD", "state" : "TX", "county" : "TITUS" },
            "75494": { "city" : "WINNSBORO", "state" : "TX", "county" : "WOOD" },
            "75495": { "city" : "VAN ALSTYNE", "state" : "TX", "county" : "GRAYSON" },
            "75496": { "city" : "WOLFE CITY", "state" : "TX", "county" : "HUNT" },
            "75497": { "city" : "YANTIS", "state" : "TX", "county" : "WOOD" },"75501": { "city" : "TEXARKANA", "state" : "TX", "county" : "BOWIE" },
            "75503": { "city" : "TEXARKANA", "state" : "TX", "county" : "BOWIE" },
            "75504": { "city" : "TEXARKANA", "state" : "TX", "county" : "BOWIE" },
            "75505": { "city" : "TEXARKANA", "state" : "TX", "county" : "BOWIE" },
            "75507": { "city" : "TEXARKANA", "state" : "TX", "county" : "BOWIE" },
            "75550": { "city" : "ANNONA", "state" : "TX", "county" : "RED RIVER" },
            "75551": { "city" : "ATLANTA", "state" : "TX", "county" : "CASS" },"75554": { "city" : "AVERY", "state" : "TX", "county" : "RED RIVER" },
            "75555": { "city" : "BIVINS", "state" : "TX", "county" : "CASS" },"75556": { "city" : "BLOOMBURG", "state" : "TX", "county" : "CASS" },
            "75558": { "city" : "COOKVILLE", "state" : "TX", "county" : "TITUS" },
            "75559": { "city" : "DE KALB", "state" : "TX", "county" : "BOWIE" },"75560": { "city" : "DOUGLASSVILLE", "state" : "TX", "county" : "CASS" },
            "75561": { "city" : "HOOKS", "state" : "TX", "county" : "BOWIE" },"75563": { "city" : "LINDEN", "state" : "TX", "county" : "CASS" },
            "75565": { "city" : "MC LEOD", "state" : "TX", "county" : "CASS" },"75566": { "city" : "MARIETTA", "state" : "TX", "county" : "CASS" },
            "75567": { "city" : "MAUD", "state" : "TX", "county" : "BOWIE" },"75568": { "city" : "NAPLES", "state" : "TX", "county" : "MORRIS" },
            "75569": { "city" : "NASH", "state" : "TX", "county" : "BOWIE" },"75570": { "city" : "NEW BOSTON", "state" : "TX", "county" : "BOWIE" },
            "75571": { "city" : "OMAHA", "state" : "TX", "county" : "MORRIS" },"75572": { "city" : "QUEEN CITY", "state" : "TX", "county" : "CASS" },
            "75573": { "city" : "REDWATER", "state" : "TX", "county" : "BOWIE" },
            "75574": { "city" : "SIMMS", "state" : "TX", "county" : "BOWIE" },"75601": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75602": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75603": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75604": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75605": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75606": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75607": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75608": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75615": { "city" : "LONGVIEW", "state" : "TX", "county" : "GREGG" },
            "75630": { "city" : "AVINGER", "state" : "TX", "county" : "CASS" },"75631": { "city" : "BECKVILLE", "state" : "TX", "county" : "PANOLA" },
            "75633": { "city" : "CARTHAGE", "state" : "TX", "county" : "PANOLA" },
            "75636": { "city" : "CASON", "state" : "TX", "county" : "MORRIS" },"75637": { "city" : "CLAYTON", "state" : "TX", "county" : "PANOLA" },
            "75638": { "city" : "DAINGERFIELD", "state" : "TX", "county" : "MORRIS" },
            "75639": { "city" : "DE BERRY", "state" : "TX", "county" : "PANOLA" },
            "75640": { "city" : "DIANA", "state" : "TX", "county" : "UPSHUR" },"75641": { "city" : "EASTON", "state" : "TX", "county" : "GREGG" },
            "75642": { "city" : "ELYSIAN FIELDS", "state" : "TX", "county" : "HARRISON" },
            "75643": { "city" : "GARY", "state" : "TX", "county" : "PANOLA" },"75644": { "city" : "GILMER", "state" : "TX", "county" : "UPSHUR" },
            "75645": { "city" : "GILMER", "state" : "TX", "county" : "UPSHUR" },"75647": { "city" : "GLADEWATER", "state" : "TX", "county" : "GREGG" },
            "75650": { "city" : "HALLSVILLE", "state" : "TX", "county" : "HARRISON" },
            "75651": { "city" : "HARLETON", "state" : "TX", "county" : "HARRISON" },
            "75652": { "city" : "HENDERSON", "state" : "TX", "county" : "RUSK" },
            "75653": { "city" : "HENDERSON", "state" : "TX", "county" : "RUSK" },
            "75654": { "city" : "HENDERSON", "state" : "TX", "county" : "RUSK" },
            "75656": { "city" : "HUGHES SPRINGS", "state" : "TX", "county" : "CASS" },
            "75657": { "city" : "JEFFERSON", "state" : "TX", "county" : "MARION" },
            "75659": { "city" : "JONESVILLE", "state" : "TX", "county" : "HARRISON" },
            "75660": { "city" : "JUDSON", "state" : "TX", "county" : "GREGG" },"75661": { "city" : "KARNACK", "state" : "TX", "county" : "HARRISON" },
            "75662": { "city" : "KILGORE", "state" : "TX", "county" : "GREGG" },"75663": { "city" : "KILGORE", "state" : "TX", "county" : "GREGG" },
            "75666": { "city" : "LAIRD HILL", "state" : "TX", "county" : "RUSK" },
            "75667": { "city" : "LANEVILLE", "state" : "TX", "county" : "RUSK" },
            "75668": { "city" : "LONE STAR", "state" : "TX", "county" : "MORRIS" },
            "75669": { "city" : "LONG BRANCH", "state" : "TX", "county" : "PANOLA" },
            "75670": { "city" : "MARSHALL", "state" : "TX", "county" : "HARRISON" },
            "75671": { "city" : "MARSHALL", "state" : "TX", "county" : "HARRISON" },
            "75672": { "city" : "MARSHALL", "state" : "TX", "county" : "HARRISON" },
            "75680": { "city" : "MINDEN", "state" : "TX", "county" : "RUSK" },"75681": { "city" : "MOUNT ENTERPRISE", "state" : "TX", "county" : "RUSK" },
            "75682": { "city" : "NEW LONDON", "state" : "TX", "county" : "RUSK" },
            "75683": { "city" : "ORE CITY", "state" : "TX", "county" : "UPSHUR" },
            "75684": { "city" : "OVERTON", "state" : "TX", "county" : "RUSK" },"75685": { "city" : "PANOLA", "state" : "TX", "county" : "PANOLA" },
            "75686": { "city" : "PITTSBURG", "state" : "TX", "county" : "CAMP" },
            "75687": { "city" : "PRICE", "state" : "TX", "county" : "RUSK" },"75688": { "city" : "SCOTTSVILLE", "state" : "TX", "county" : "HARRISON" },
            "75689": { "city" : "SELMAN CITY", "state" : "TX", "county" : "RUSK" },
            "75691": { "city" : "TATUM", "state" : "TX", "county" : "RUSK" },"75692": { "city" : "WASKOM", "state" : "TX", "county" : "HARRISON" },
            "75693": { "city" : "WHITE OAK", "state" : "TX", "county" : "GREGG" },
            "75694": { "city" : "WOODLAWN", "state" : "TX", "county" : "HARRISON" },
            "75701": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75702": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75703": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75704": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75705": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75706": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75707": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75708": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75709": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75710": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75711": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75712": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75713": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },"75750": { "city" : "ARP", "state" : "TX", "county" : "SMITH" },
            "75751": { "city" : "ATHENS", "state" : "TX", "county" : "HENDERSON" },
            "75752": { "city" : "ATHENS", "state" : "TX", "county" : "HENDERSON" },
            "75754": { "city" : "BEN WHEELER", "state" : "TX", "county" : "VAN ZANDT" },
            "75755": { "city" : "BIG SANDY", "state" : "TX", "county" : "UPSHUR" },
            "75756": { "city" : "BROWNSBORO", "state" : "TX", "county" : "HENDERSON" },
            "75757": { "city" : "BULLARD", "state" : "TX", "county" : "SMITH" },"75758": { "city" : "CHANDLER", "state" : "TX", "county" : "HENDERSON" },
            "75759": { "city" : "CUNEY", "state" : "TX", "county" : "CHEROKEE" },
            "75760": { "city" : "CUSHING", "state" : "TX", "county" : "NACOGDOCHES" },
            "75762": { "city" : "FLINT", "state" : "TX", "county" : "SMITH" },"75763": { "city" : "FRANKSTON", "state" : "TX", "county" : "ANDERSON" },
            "75764": { "city" : "GALLATIN", "state" : "TX", "county" : "CHEROKEE" },
            "75765": { "city" : "HAWKINS", "state" : "TX", "county" : "WOOD" },"75766": { "city" : "JACKSONVILLE", "state" : "TX", "county" : "CHEROKEE" },
            "75770": { "city" : "LARUE", "state" : "TX", "county" : "HENDERSON" },
            "75771": { "city" : "LINDALE", "state" : "TX", "county" : "SMITH" },"75772": { "city" : "MAYDELLE", "state" : "TX", "county" : "CHEROKEE" },
            "75773": { "city" : "MINEOLA", "state" : "TX", "county" : "WOOD" },"75778": { "city" : "MURCHISON", "state" : "TX", "county" : "HENDERSON" },
            "75779": { "city" : "NECHES", "state" : "TX", "county" : "ANDERSON" },
            "75780": { "city" : "NEW SUMMERFIELD", "state" : "TX", "county" : "CHEROKEE" },
            "75782": { "city" : "POYNOR", "state" : "TX", "county" : "HENDERSON" },
            "75783": { "city" : "QUITMAN", "state" : "TX", "county" : "WOOD" },"75784": { "city" : "REKLAW", "state" : "TX", "county" : "CHEROKEE" },
            "75785": { "city" : "RUSK", "state" : "TX", "county" : "CHEROKEE" },"75788": { "city" : "SACUL", "state" : "TX", "county" : "NACOGDOCHES" },
            "75789": { "city" : "TROUP", "state" : "TX", "county" : "SMITH" },"75790": { "city" : "VAN", "state" : "TX", "county" : "VAN ZANDT" },
            "75791": { "city" : "WHITEHOUSE", "state" : "TX", "county" : "SMITH" },
            "75792": { "city" : "WINONA", "state" : "TX", "county" : "SMITH" },"75799": { "city" : "TYLER", "state" : "TX", "county" : "SMITH" },
            "75801": { "city" : "PALESTINE", "state" : "TX", "county" : "ANDERSON" },
            "75802": { "city" : "PALESTINE", "state" : "TX", "county" : "ANDERSON" },
            "75803": { "city" : "PALESTINE", "state" : "TX", "county" : "ANDERSON" },
            "75831": { "city" : "BUFFALO", "state" : "TX", "county" : "LEON" },"75832": { "city" : "CAYUGA", "state" : "TX", "county" : "ANDERSON" },
            "75833": { "city" : "CENTERVILLE", "state" : "TX", "county" : "LEON" },
            "75835": { "city" : "CROCKETT", "state" : "TX", "county" : "HOUSTON" },
            "75838": { "city" : "DONIE", "state" : "TX", "county" : "FREESTONE" },
            "75839": { "city" : "ELKHART", "state" : "TX", "county" : "ANDERSON" },
            "75840": { "city" : "FAIRFIELD", "state" : "TX", "county" : "FREESTONE" },
            "75844": { "city" : "GRAPELAND", "state" : "TX", "county" : "HOUSTON" },
            "75845": { "city" : "GROVETON", "state" : "TX", "county" : "TRINITY" },
            "75846": { "city" : "JEWETT", "state" : "TX", "county" : "LEON" },"75847": { "city" : "KENNARD", "state" : "TX", "county" : "HOUSTON" },
            "75848": { "city" : "KIRVIN", "state" : "TX", "county" : "FREESTONE" },
            "75849": { "city" : "LATEXO", "state" : "TX", "county" : "HOUSTON" },
            "75850": { "city" : "LEONA", "state" : "TX", "county" : "LEON" },"75851": { "city" : "LOVELADY", "state" : "TX", "county" : "HOUSTON" },
            "75852": { "city" : "MIDWAY", "state" : "TX", "county" : "MADISON" },
            "75853": { "city" : "MONTALBA", "state" : "TX", "county" : "ANDERSON" },
            "75855": { "city" : "OAKWOOD", "state" : "TX", "county" : "LEON" },"75856": { "city" : "PENNINGTON", "state" : "TX", "county" : "TRINITY" },
            "75858": { "city" : "RATCLIFF", "state" : "TX", "county" : "HOUSTON" },
            "75859": { "city" : "STREETMAN", "state" : "TX", "county" : "FREESTONE" },
            "75860": { "city" : "TEAGUE", "state" : "TX", "county" : "FREESTONE" },
            "75861": { "city" : "TENNESSEE COLONY", "state" : "TX", "county" : "ANDERSON" },
            "75862": { "city" : "TRINITY", "state" : "TX", "county" : "TRINITY" },
            "75865": { "city" : "WOODLAKE", "state" : "TX", "county" : "TRINITY" },
            "75901": { "city" : "LUFKIN", "state" : "TX", "county" : "ANGELINA" },
            "75902": { "city" : "LUFKIN", "state" : "TX", "county" : "ANGELINA" },
            "75903": { "city" : "LUFKIN", "state" : "TX", "county" : "ANGELINA" },
            "75904": { "city" : "LUFKIN", "state" : "TX", "county" : "ANGELINA" },
            "75915": { "city" : "LUFKIN", "state" : "TX", "county" : "ANGELINA" },
            "75925": { "city" : "ALTO", "state" : "TX", "county" : "CHEROKEE" },"75926": { "city" : "APPLE SPRINGS", "state" : "TX", "county" : "TRINITY" },
            "75928": { "city" : "BON WIER", "state" : "TX", "county" : "NEWTON" },
            "75929": { "city" : "BROADDUS", "state" : "TX", "county" : "SAN AUGUSTINE" },
            "75930": { "city" : "BRONSON", "state" : "TX", "county" : "SABINE" },
            "75931": { "city" : "BROOKELAND", "state" : "TX", "county" : "JASPER" },
            "75932": { "city" : "BURKEVILLE", "state" : "TX", "county" : "NEWTON" },
            "75933": { "city" : "CALL", "state" : "TX", "county" : "NEWTON" },"75934": { "city" : "CAMDEN", "state" : "TX", "county" : "POLK" },
            "75935": { "city" : "CENTER", "state" : "TX", "county" : "SHELBY" },"75936": { "city" : "CHESTER", "state" : "TX", "county" : "TYLER" },
            "75937": { "city" : "CHIRENO", "state" : "TX", "county" : "NACOGDOCHES" },
            "75938": { "city" : "COLMESNEIL", "state" : "TX", "county" : "TYLER" },
            "75939": { "city" : "CORRIGAN", "state" : "TX", "county" : "POLK" },"75941": { "city" : "DIBOLL", "state" : "TX", "county" : "ANGELINA" },
            "75942": { "city" : "DOUCETTE", "state" : "TX", "county" : "TYLER" },
            "75943": { "city" : "DOUGLASS", "state" : "TX", "county" : "NACOGDOCHES" },
            "75944": { "city" : "ETOILE", "state" : "TX", "county" : "NACOGDOCHES" },
            "75946": { "city" : "GARRISON", "state" : "TX", "county" : "NACOGDOCHES" },
            "75948": { "city" : "HEMPHILL", "state" : "TX", "county" : "SABINE" },
            "75949": { "city" : "HUNTINGTON", "state" : "TX", "county" : "ANGELINA" },
            "75951": { "city" : "JASPER", "state" : "TX", "county" : "JASPER" },"75954": { "city" : "JOAQUIN", "state" : "TX", "county" : "SHELBY" },
            "75956": { "city" : "KIRBYVILLE", "state" : "TX", "county" : "JASPER" },
            "75958": { "city" : "MARTINSVILLE", "state" : "TX", "county" : "NACOGDOCHES" },
            "75959": { "city" : "MILAM", "state" : "TX", "county" : "SABINE" },"75960": { "city" : "MOSCOW", "state" : "TX", "county" : "POLK" },
            "75961": { "city" : "NACOGDOCHES", "state" : "TX", "county" : "NACOGDOCHES" },
            "75962": { "city" : "NACOGDOCHES", "state" : "TX", "county" : "NACOGDOCHES" },
            "75963": { "city" : "NACOGDOCHES", "state" : "TX", "county" : "NACOGDOCHES" },
            "75964": { "city" : "NACOGDOCHES", "state" : "TX", "county" : "NACOGDOCHES" },
            "75965": { "city" : "NACOGDOCHES", "state" : "TX", "county" : "NACOGDOCHES" },
            "75966": { "city" : "NEWTON", "state" : "TX", "county" : "NEWTON" },"75968": { "city" : "PINELAND", "state" : "TX", "county" : "SABINE" },
            "75969": { "city" : "POLLOK", "state" : "TX", "county" : "ANGELINA" },
            "75972": { "city" : "SAN AUGUSTINE", "state" : "TX", "county" : "SAN AUGUSTINE" },
            "75973": { "city" : "SHELBYVILLE", "state" : "TX", "county" : "SHELBY" },
            "75974": { "city" : "TENAHA", "state" : "TX", "county" : "SHELBY" },"75975": { "city" : "TIMPSON", "state" : "TX", "county" : "SHELBY" },
            "75976": { "city" : "WELLS", "state" : "TX", "county" : "CHEROKEE" },
            "75977": { "city" : "WIERGATE", "state" : "TX", "county" : "NEWTON" },
            "75978": { "city" : "WODEN", "state" : "TX", "county" : "NACOGDOCHES" },
            "75979": { "city" : "WOODVILLE", "state" : "TX", "county" : "TYLER" },
            "75980": { "city" : "ZAVALLA", "state" : "TX", "county" : "ANGELINA" },
            "76001": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76002": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76003": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76004": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76005": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76006": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76007": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76008": { "city" : "ALEDO", "state" : "TX", "county" : "PARKER" },"76009": { "city" : "ALVARADO", "state" : "TX", "county" : "JOHNSON" },
            "76010": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76011": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76012": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76013": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76014": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76015": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76016": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76017": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76018": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76019": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76020": { "city" : "AZLE", "state" : "TX", "county" : "TARRANT" },"76021": { "city" : "BEDFORD", "state" : "TX", "county" : "TARRANT" },
            "76022": { "city" : "BEDFORD", "state" : "TX", "county" : "TARRANT" },
            "76023": { "city" : "BOYD", "state" : "TX", "county" : "WISE" },"76028": { "city" : "BURLESON", "state" : "TX", "county" : "JOHNSON" },
            "76031": { "city" : "CLEBURNE", "state" : "TX", "county" : "JOHNSON" },
            "76033": { "city" : "CLEBURNE", "state" : "TX", "county" : "JOHNSON" },
            "76034": { "city" : "COLLEYVILLE", "state" : "TX", "county" : "TARRANT" },
            "76035": { "city" : "CRESSON", "state" : "TX", "county" : "HOOD" },"76036": { "city" : "CROWLEY", "state" : "TX", "county" : "TARRANT" },
            "76039": { "city" : "EULESS", "state" : "TX", "county" : "TARRANT" },
            "76040": { "city" : "EULESS", "state" : "TX", "county" : "TARRANT" },
            "76041": { "city" : "FORRESTON", "state" : "TX", "county" : "ELLIS" },
            "76043": { "city" : "GLEN ROSE", "state" : "TX", "county" : "SOMERVELL" },
            "76044": { "city" : "GODLEY", "state" : "TX", "county" : "JOHNSON" },
            "76048": { "city" : "GRANBURY", "state" : "TX", "county" : "HOOD" },"76049": { "city" : "GRANBURY", "state" : "TX", "county" : "HOOD" },
            "76050": { "city" : "GRANDVIEW", "state" : "TX", "county" : "JOHNSON" },
            "76051": { "city" : "GRAPEVINE", "state" : "TX", "county" : "TARRANT" },
            "76052": { "city" : "HASLET", "state" : "TX", "county" : "TARRANT" },
            "76053": { "city" : "HURST", "state" : "TX", "county" : "TARRANT" },"76054": { "city" : "HURST", "state" : "TX", "county" : "TARRANT" },
            "76055": { "city" : "ITASCA", "state" : "TX", "county" : "HILL" },"76058": { "city" : "JOSHUA", "state" : "TX", "county" : "JOHNSON" },
            "76059": { "city" : "KEENE", "state" : "TX", "county" : "JOHNSON" },"76060": { "city" : "KENNEDALE", "state" : "TX", "county" : "TARRANT" },
            "76061": { "city" : "LILLIAN", "state" : "TX", "county" : "JOHNSON" },
            "76063": { "city" : "MANSFIELD", "state" : "TX", "county" : "TARRANT" },
            "76064": { "city" : "MAYPEARL", "state" : "TX", "county" : "ELLIS" },
            "76065": { "city" : "MIDLOTHIAN", "state" : "TX", "county" : "ELLIS" },
            "76066": { "city" : "MILLSAP", "state" : "TX", "county" : "PARKER" },
            "76067": { "city" : "MINERAL WELLS", "state" : "TX", "county" : "PALO PINTO" },
            "76068": { "city" : "MINERAL WELLS", "state" : "TX", "county" : "PALO PINTO" },
            "76070": { "city" : "NEMO", "state" : "TX", "county" : "SOMERVELL" },
            "76071": { "city" : "NEWARK", "state" : "TX", "county" : "WISE" },"76073": { "city" : "PARADISE", "state" : "TX", "county" : "WISE" },
            "76077": { "city" : "RAINBOW", "state" : "TX", "county" : "SOMERVELL" },
            "76078": { "city" : "RHOME", "state" : "TX", "county" : "WISE" },"76082": { "city" : "SPRINGTOWN", "state" : "TX", "county" : "PARKER" },
            "76084": { "city" : "VENUS", "state" : "TX", "county" : "JOHNSON" },"76085": { "city" : "WEATHERFORD", "state" : "TX", "county" : "PARKER" },
            "76086": { "city" : "WEATHERFORD", "state" : "TX", "county" : "PARKER" },
            "76087": { "city" : "WEATHERFORD", "state" : "TX", "county" : "PARKER" },
            "76088": { "city" : "WEATHERFORD", "state" : "TX", "county" : "PARKER" },
            "76092": { "city" : "SOUTHLAKE", "state" : "TX", "county" : "TARRANT" },
            "76093": { "city" : "RIO VISTA", "state" : "TX", "county" : "JOHNSON" },
            "76094": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76095": { "city" : "BEDFORD", "state" : "TX", "county" : "TARRANT" },
            "76096": { "city" : "ARLINGTON", "state" : "TX", "county" : "TARRANT" },
            "76097": { "city" : "BURLESON", "state" : "TX", "county" : "JOHNSON" },
            "76098": { "city" : "AZLE", "state" : "TX", "county" : "PARKER" },"76099": { "city" : "GRAPEVINE", "state" : "TX", "county" : "TARRANT" },
            "76101": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76102": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76103": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76104": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76105": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76106": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76107": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76108": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76109": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76110": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76111": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76112": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76113": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76114": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76115": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76116": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76117": { "city" : "HALTOM CITY", "state" : "TX", "county" : "TARRANT" },
            "76118": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76119": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76120": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76121": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76122": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76123": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76124": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76126": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76127": { "city" : "NAVAL AIR STATION/ JRB", "state" : "TX", "county" : "TARRANT" },
            "76129": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76131": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76132": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76133": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76134": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76135": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76136": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76137": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76140": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76147": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76148": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76150": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76155": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76161": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76162": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76163": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76164": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76166": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76177": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76179": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76180": { "city" : "NORTH RICHLAND HILLS", "state" : "TX", "county" : "TARRANT" },
            "76181": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76182": { "city" : "NORTH RICHLAND HILLS", "state" : "TX", "county" : "TARRANT" },
            "76185": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76192": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76196": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76199": { "city" : "FORT WORTH", "state" : "TX", "county" : "TARRANT" },
            "76201": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },"76202": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },
            "76203": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },"76204": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },
            "76205": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },"76206": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },
            "76207": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },"76208": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },
            "76209": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },"76210": { "city" : "DENTON", "state" : "TX", "county" : "DENTON" },
            "76225": { "city" : "ALVORD", "state" : "TX", "county" : "WISE" },"76226": { "city" : "ARGYLE", "state" : "TX", "county" : "DENTON" },
            "76227": { "city" : "AUBREY", "state" : "TX", "county" : "DENTON" },"76228": { "city" : "BELLEVUE", "state" : "TX", "county" : "CLAY" },
            "76230": { "city" : "BOWIE", "state" : "TX", "county" : "MONTAGUE" },
            "76233": { "city" : "COLLINSVILLE", "state" : "TX", "county" : "GRAYSON" },
            "76234": { "city" : "DECATUR", "state" : "TX", "county" : "WISE" },"76238": { "city" : "ERA", "state" : "TX", "county" : "COOKE" },
            "76239": { "city" : "FORESTBURG", "state" : "TX", "county" : "MONTAGUE" },
            "76240": { "city" : "GAINESVILLE", "state" : "TX", "county" : "COOKE" },
            "76241": { "city" : "GAINESVILLE", "state" : "TX", "county" : "COOKE" },
            "76244": { "city" : "KELLER", "state" : "TX", "county" : "TARRANT" },
            "76245": { "city" : "GORDONVILLE", "state" : "TX", "county" : "GRAYSON" },
            "76246": { "city" : "GREENWOOD", "state" : "TX", "county" : "WISE" },
            "76247": { "city" : "JUSTIN", "state" : "TX", "county" : "DENTON" },"76248": { "city" : "KELLER", "state" : "TX", "county" : "TARRANT" },
            "76249": { "city" : "KRUM", "state" : "TX", "county" : "DENTON" },"76250": { "city" : "LINDSAY", "state" : "TX", "county" : "COOKE" },
            "76251": { "city" : "MONTAGUE", "state" : "TX", "county" : "MONTAGUE" },
            "76252": { "city" : "MUENSTER", "state" : "TX", "county" : "COOKE" },
            "76253": { "city" : "MYRA", "state" : "TX", "county" : "COOKE" },"76255": { "city" : "NOCONA", "state" : "TX", "county" : "MONTAGUE" },
            "76258": { "city" : "PILOT POINT", "state" : "TX", "county" : "DENTON" },
            "76259": { "city" : "PONDER", "state" : "TX", "county" : "DENTON" },"76261": { "city" : "RINGGOLD", "state" : "TX", "county" : "MONTAGUE" },
            "76262": { "city" : "ROANOKE", "state" : "TX", "county" : "DENTON" },
            "76263": { "city" : "ROSSTON", "state" : "TX", "county" : "COOKE" },"76264": { "city" : "SADLER", "state" : "TX", "county" : "GRAYSON" },
            "76265": { "city" : "SAINT JO", "state" : "TX", "county" : "MONTAGUE" },
            "76266": { "city" : "SANGER", "state" : "TX", "county" : "DENTON" },"76267": { "city" : "SLIDELL", "state" : "TX", "county" : "WISE" },
            "76268": { "city" : "SOUTHMAYD", "state" : "TX", "county" : "GRAYSON" },
            "76270": { "city" : "SUNSET", "state" : "TX", "county" : "MONTAGUE" },
            "76271": { "city" : "TIOGA", "state" : "TX", "county" : "GRAYSON" },"76272": { "city" : "VALLEY VIEW", "state" : "TX", "county" : "COOKE" },
            "76273": { "city" : "WHITESBORO", "state" : "TX", "county" : "GRAYSON" },
            "76301": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76302": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76305": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76306": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76307": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76308": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76309": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76310": { "city" : "WICHITA FALLS", "state" : "TX", "county" : "WICHITA" },
            "76311": { "city" : "SHEPPARD AFB", "state" : "TX", "county" : "WICHITA" },
            "76351": { "city" : "ARCHER CITY", "state" : "TX", "county" : "ARCHER" },
            "76352": { "city" : "BLUEGROVE", "state" : "TX", "county" : "CLAY" },
            "76354": { "city" : "BURKBURNETT", "state" : "TX", "county" : "WICHITA" },
            "76357": { "city" : "BYERS", "state" : "TX", "county" : "CLAY" },"76360": { "city" : "ELECTRA", "state" : "TX", "county" : "WICHITA" },
            "76363": { "city" : "GOREE", "state" : "TX", "county" : "KNOX" },"76364": { "city" : "HARROLD", "state" : "TX", "county" : "WILBARGER" },
            "76365": { "city" : "HENRIETTA", "state" : "TX", "county" : "CLAY" },
            "76366": { "city" : "HOLLIDAY", "state" : "TX", "county" : "ARCHER" },
            "76367": { "city" : "IOWA PARK", "state" : "TX", "county" : "WICHITA" },
            "76369": { "city" : "KAMAY", "state" : "TX", "county" : "WICHITA" },"76370": { "city" : "MEGARGEL", "state" : "TX", "county" : "ARCHER" },
            "76371": { "city" : "MUNDAY", "state" : "TX", "county" : "KNOX" },"76372": { "city" : "NEWCASTLE", "state" : "TX", "county" : "YOUNG" },
            "76373": { "city" : "OKLAUNION", "state" : "TX", "county" : "WILBARGER" },
            "76374": { "city" : "OLNEY", "state" : "TX", "county" : "YOUNG" },"76377": { "city" : "PETROLIA", "state" : "TX", "county" : "CLAY" },
            "76379": { "city" : "SCOTLAND", "state" : "TX", "county" : "ARCHER" },
            "76380": { "city" : "SEYMOUR", "state" : "TX", "county" : "BAYLOR" },
            "76384": { "city" : "VERNON", "state" : "TX", "county" : "WILBARGER" },
            "76385": { "city" : "VERNON", "state" : "TX", "county" : "WILBARGER" },
            "76388": { "city" : "WEINERT", "state" : "TX", "county" : "HASKELL" },
            "76389": { "city" : "WINDTHORST", "state" : "TX", "county" : "ARCHER" },
            "76401": { "city" : "STEPHENVILLE", "state" : "TX", "county" : "ERATH" },
            "76402": { "city" : "STEPHENVILLE", "state" : "TX", "county" : "ERATH" },
            "76424": { "city" : "BRECKENRIDGE", "state" : "TX", "county" : "STEPHENS" },
            "76426": { "city" : "BRIDGEPORT", "state" : "TX", "county" : "WISE" },
            "76427": { "city" : "BRYSON", "state" : "TX", "county" : "JACK" },"76429": { "city" : "CADDO", "state" : "TX", "county" : "STEPHENS" },
            "76430": { "city" : "ALBANY", "state" : "TX", "county" : "SHACKELFORD" },
            "76431": { "city" : "CHICO", "state" : "TX", "county" : "WISE" },"76432": { "city" : "BLANKET", "state" : "TX", "county" : "BROWN" },
            "76433": { "city" : "BLUFF DALE", "state" : "TX", "county" : "ERATH" },
            "76435": { "city" : "CARBON", "state" : "TX", "county" : "EASTLAND" },
            "76436": { "city" : "CARLTON", "state" : "TX", "county" : "HAMILTON" },
            "76437": { "city" : "CISCO", "state" : "TX", "county" : "EASTLAND" },
            "76439": { "city" : "DENNIS", "state" : "TX", "county" : "PARKER" },"76442": { "city" : "COMANCHE", "state" : "TX", "county" : "COMANCHE" },
            "76443": { "city" : "CROSS PLAINS", "state" : "TX", "county" : "CALLAHAN" },
            "76444": { "city" : "DE LEON", "state" : "TX", "county" : "COMANCHE" },
            "76445": { "city" : "DESDEMONA", "state" : "TX", "county" : "EASTLAND" },
            "76446": { "city" : "DUBLIN", "state" : "TX", "county" : "ERATH" },"76448": { "city" : "EASTLAND", "state" : "TX", "county" : "EASTLAND" },
            "76449": { "city" : "GRAFORD", "state" : "TX", "county" : "PALO PINTO" },
            "76450": { "city" : "GRAHAM", "state" : "TX", "county" : "YOUNG" },"76452": { "city" : "ENERGY", "state" : "TX", "county" : "COMANCHE" },
            "76453": { "city" : "GORDON", "state" : "TX", "county" : "PALO PINTO" },
            "76454": { "city" : "GORMAN", "state" : "TX", "county" : "EASTLAND" },
            "76455": { "city" : "GUSTINE", "state" : "TX", "county" : "COMANCHE" },
            "76457": { "city" : "HICO", "state" : "TX", "county" : "HAMILTON" },"76458": { "city" : "JACKSBORO", "state" : "TX", "county" : "JACK" },
            "76459": { "city" : "JERMYN", "state" : "TX", "county" : "JACK" },"76460": { "city" : "LOVING", "state" : "TX", "county" : "YOUNG" },
            "76461": { "city" : "LINGLEVILLE", "state" : "TX", "county" : "ERATH" },
            "76462": { "city" : "LIPAN", "state" : "TX", "county" : "HOOD" },"76463": { "city" : "MINGUS", "state" : "TX", "county" : "PALO PINTO" },
            "76464": { "city" : "MORAN", "state" : "TX", "county" : "SHACKELFORD" },
            "76465": { "city" : "MORGAN MILL", "state" : "TX", "county" : "ERATH" },
            "76466": { "city" : "OLDEN", "state" : "TX", "county" : "EASTLAND" },
            "76468": { "city" : "PROCTOR", "state" : "TX", "county" : "COMANCHE" },
            "76469": { "city" : "PUTNAM", "state" : "TX", "county" : "CALLAHAN" },
            "76470": { "city" : "RANGER", "state" : "TX", "county" : "EASTLAND" },
            "76471": { "city" : "RISING STAR", "state" : "TX", "county" : "EASTLAND" },
            "76472": { "city" : "SANTO", "state" : "TX", "county" : "PALO PINTO" },
            "76474": { "city" : "SIDNEY", "state" : "TX", "county" : "COMANCHE" },
            "76475": { "city" : "STRAWN", "state" : "TX", "county" : "PALO PINTO" },
            "76476": { "city" : "TOLAR", "state" : "TX", "county" : "HOOD" },"76481": { "city" : "SOUTH BEND", "state" : "TX", "county" : "YOUNG" },
            "76483": { "city" : "THROCKMORTON", "state" : "TX", "county" : "THROCKMORTON" },
            "76484": { "city" : "PALO PINTO", "state" : "TX", "county" : "PALO PINTO" },
            "76485": { "city" : "PEASTER", "state" : "TX", "county" : "PARKER" },
            "76486": { "city" : "PERRIN", "state" : "TX", "county" : "JACK" },"76487": { "city" : "POOLVILLE", "state" : "TX", "county" : "PARKER" },
            "76491": { "city" : "WOODSON", "state" : "TX", "county" : "THROCKMORTON" },
            "76501": { "city" : "TEMPLE", "state" : "TX", "county" : "BELL" },"76502": { "city" : "TEMPLE", "state" : "TX", "county" : "BELL" },
            "76503": { "city" : "TEMPLE", "state" : "TX", "county" : "BELL" },"76504": { "city" : "TEMPLE", "state" : "TX", "county" : "BELL" },
            "76505": { "city" : "TEMPLE", "state" : "TX", "county" : "BELL" },"76508": { "city" : "TEMPLE", "state" : "TX", "county" : "BELL" },
            "76511": { "city" : "BARTLETT", "state" : "TX", "county" : "BELL" },"76513": { "city" : "BELTON", "state" : "TX", "county" : "BELL" },
            "76518": { "city" : "BUCKHOLTS", "state" : "TX", "county" : "MILAM" },
            "76519": { "city" : "BURLINGTON", "state" : "TX", "county" : "MILAM" },
            "76520": { "city" : "CAMERON", "state" : "TX", "county" : "MILAM" },"76522": { "city" : "COPPERAS COVE", "state" : "TX", "county" : "CORYELL" },
            "76523": { "city" : "DAVILLA", "state" : "TX", "county" : "MILAM" },"76524": { "city" : "EDDY", "state" : "TX", "county" : "MCLENNAN" },
            "76525": { "city" : "EVANT", "state" : "TX", "county" : "CORYELL" },"76526": { "city" : "FLAT", "state" : "TX", "county" : "CORYELL" },
            "76527": { "city" : "FLORENCE", "state" : "TX", "county" : "WILLIAMSON" },
            "76528": { "city" : "GATESVILLE", "state" : "TX", "county" : "CORYELL" },
            "76530": { "city" : "GRANGER", "state" : "TX", "county" : "WILLIAMSON" },
            "76531": { "city" : "HAMILTON", "state" : "TX", "county" : "HAMILTON" },
            "76533": { "city" : "HEIDENHEIMER", "state" : "TX", "county" : "BELL" },
            "76534": { "city" : "HOLLAND", "state" : "TX", "county" : "BELL" },"76537": { "city" : "JARRELL", "state" : "TX", "county" : "WILLIAMSON" },
            "76538": { "city" : "JONESBORO", "state" : "TX", "county" : "CORYELL" },
            "76539": { "city" : "KEMPNER", "state" : "TX", "county" : "LAMPASAS" },
            "76540": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },"76541": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },
            "76542": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },"76543": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },
            "76544": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },"76547": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },
            "76548": { "city" : "HARKER HEIGHTS", "state" : "TX", "county" : "BELL" },
            "76549": { "city" : "KILLEEN", "state" : "TX", "county" : "BELL" },"76550": { "city" : "LAMPASAS", "state" : "TX", "county" : "LAMPASAS" },
            "76554": { "city" : "LITTLE RIVER ACADEMY", "state" : "TX", "county" : "BELL" },
            "76556": { "city" : "MILANO", "state" : "TX", "county" : "MILAM" },"76557": { "city" : "MOODY", "state" : "TX", "county" : "MCLENNAN" },
            "76558": { "city" : "MOUND", "state" : "TX", "county" : "CORYELL" },"76559": { "city" : "NOLANVILLE", "state" : "TX", "county" : "BELL" },
            "76561": { "city" : "OGLESBY", "state" : "TX", "county" : "CORYELL" },
            "76564": { "city" : "PENDLETON", "state" : "TX", "county" : "BELL" },
            "76566": { "city" : "PURMELA", "state" : "TX", "county" : "CORYELL" },
            "76567": { "city" : "ROCKDALE", "state" : "TX", "county" : "MILAM" },
            "76569": { "city" : "ROGERS", "state" : "TX", "county" : "BELL" },"76570": { "city" : "ROSEBUD", "state" : "TX", "county" : "FALLS" },
            "76571": { "city" : "SALADO", "state" : "TX", "county" : "BELL" },"76573": { "city" : "SCHWERTNER", "state" : "TX", "county" : "WILLIAMSON" },
            "76574": { "city" : "TAYLOR", "state" : "TX", "county" : "WILLIAMSON" },
            "76577": { "city" : "THORNDALE", "state" : "TX", "county" : "MILAM" },
            "76578": { "city" : "THRALL", "state" : "TX", "county" : "WILLIAMSON" },
            "76579": { "city" : "TROY", "state" : "TX", "county" : "BELL" },"76596": { "city" : "GATESVILLE", "state" : "TX", "county" : "CORYELL" },
            "76599": { "city" : "GATESVILLE", "state" : "TX", "county" : "CORYELL" },
            "76621": { "city" : "ABBOTT", "state" : "TX", "county" : "HILL" },"76622": { "city" : "AQUILLA", "state" : "TX", "county" : "HILL" },
            "76623": { "city" : "AVALON", "state" : "TX", "county" : "ELLIS" },"76624": { "city" : "AXTELL", "state" : "TX", "county" : "MCLENNAN" },
            "76626": { "city" : "BLOOMING GROVE", "state" : "TX", "county" : "NAVARRO" },
            "76627": { "city" : "BLUM", "state" : "TX", "county" : "HILL" },"76628": { "city" : "BRANDON", "state" : "TX", "county" : "HILL" },
            "76629": { "city" : "BREMOND", "state" : "TX", "county" : "ROBERTSON" },
            "76630": { "city" : "BRUCEVILLE", "state" : "TX", "county" : "MCLENNAN" },
            "76631": { "city" : "BYNUM", "state" : "TX", "county" : "HILL" },"76632": { "city" : "CHILTON", "state" : "TX", "county" : "FALLS" },
            "76633": { "city" : "CHINA SPRING", "state" : "TX", "county" : "MCLENNAN" },
            "76634": { "city" : "CLIFTON", "state" : "TX", "county" : "BOSQUE" },
            "76635": { "city" : "COOLIDGE", "state" : "TX", "county" : "LIMESTONE" },
            "76636": { "city" : "COVINGTON", "state" : "TX", "county" : "HILL" },
            "76637": { "city" : "CRANFILLS GAP", "state" : "TX", "county" : "BOSQUE" },
            "76638": { "city" : "CRAWFORD", "state" : "TX", "county" : "MCLENNAN" },
            "76639": { "city" : "DAWSON", "state" : "TX", "county" : "NAVARRO" },
            "76640": { "city" : "ELM MOTT", "state" : "TX", "county" : "MCLENNAN" },
            "76641": { "city" : "FROST", "state" : "TX", "county" : "NAVARRO" },"76642": { "city" : "GROESBECK", "state" : "TX", "county" : "LIMESTONE" },
            "76643": { "city" : "HEWITT", "state" : "TX", "county" : "MCLENNAN" },
            "76644": { "city" : "LAGUNA PARK", "state" : "TX", "county" : "BOSQUE" },
            "76645": { "city" : "HILLSBORO", "state" : "TX", "county" : "HILL" },
            "76648": { "city" : "HUBBARD", "state" : "TX", "county" : "HILL" },"76649": { "city" : "IREDELL", "state" : "TX", "county" : "BOSQUE" },
            "76651": { "city" : "ITALY", "state" : "TX", "county" : "ELLIS" },"76652": { "city" : "KOPPERL", "state" : "TX", "county" : "BOSQUE" },
            "76653": { "city" : "KOSSE", "state" : "TX", "county" : "LIMESTONE" },
            "76654": { "city" : "LEROY", "state" : "TX", "county" : "MCLENNAN" },
            "76655": { "city" : "LORENA", "state" : "TX", "county" : "MCLENNAN" },
            "76656": { "city" : "LOTT", "state" : "TX", "county" : "FALLS" },"76657": { "city" : "MC GREGOR", "state" : "TX", "county" : "MCLENNAN" },
            "76660": { "city" : "MALONE", "state" : "TX", "county" : "HILL" },"76661": { "city" : "MARLIN", "state" : "TX", "county" : "FALLS" },
            "76664": { "city" : "MART", "state" : "TX", "county" : "MCLENNAN" },"76665": { "city" : "MERIDIAN", "state" : "TX", "county" : "BOSQUE" },
            "76666": { "city" : "MERTENS", "state" : "TX", "county" : "HILL" },"76667": { "city" : "MEXIA", "state" : "TX", "county" : "LIMESTONE" },
            "76670": { "city" : "MILFORD", "state" : "TX", "county" : "ELLIS" },"76671": { "city" : "MORGAN", "state" : "TX", "county" : "BOSQUE" },
            "76673": { "city" : "MOUNT CALM", "state" : "TX", "county" : "HILL" },
            "76676": { "city" : "PENELOPE", "state" : "TX", "county" : "HILL" },"76678": { "city" : "PRAIRIE HILL", "state" : "TX", "county" : "LIMESTONE" },
            "76679": { "city" : "PURDON", "state" : "TX", "county" : "NAVARRO" },
            "76680": { "city" : "REAGAN", "state" : "TX", "county" : "FALLS" },"76681": { "city" : "RICHLAND", "state" : "TX", "county" : "NAVARRO" },
            "76682": { "city" : "RIESEL", "state" : "TX", "county" : "MCLENNAN" },
            "76684": { "city" : "ROSS", "state" : "TX", "county" : "MCLENNAN" },"76685": { "city" : "SATIN", "state" : "TX", "county" : "FALLS" },
            "76686": { "city" : "TEHUACANA", "state" : "TX", "county" : "LIMESTONE" },
            "76687": { "city" : "THORNTON", "state" : "TX", "county" : "LIMESTONE" },
            "76689": { "city" : "VALLEY MILLS", "state" : "TX", "county" : "BOSQUE" },
            "76690": { "city" : "WALNUT SPRINGS", "state" : "TX", "county" : "BOSQUE" },
            "76691": { "city" : "WEST", "state" : "TX", "county" : "MCLENNAN" },"76692": { "city" : "WHITNEY", "state" : "TX", "county" : "HILL" },
            "76693": { "city" : "WORTHAM", "state" : "TX", "county" : "FREESTONE" },
            "76701": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76702": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76703": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76704": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76705": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76706": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76707": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76708": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76710": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76711": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76712": { "city" : "WOODWAY", "state" : "TX", "county" : "MCLENNAN" },
            "76714": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76715": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76716": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76798": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },
            "76799": { "city" : "WACO", "state" : "TX", "county" : "MCLENNAN" },"76801": { "city" : "BROWNWOOD", "state" : "TX", "county" : "BROWN" },
            "76802": { "city" : "EARLY", "state" : "TX", "county" : "BROWN" },"76803": { "city" : "BROWNWOOD", "state" : "TX", "county" : "BROWN" },
            "76804": { "city" : "BROWNWOOD", "state" : "TX", "county" : "BROWN" },
            "76820": { "city" : "ART", "state" : "TX", "county" : "MASON" },"76821": { "city" : "BALLINGER", "state" : "TX", "county" : "RUNNELS" },
            "76823": { "city" : "BANGS", "state" : "TX", "county" : "BROWN" },"76824": { "city" : "BEND", "state" : "TX", "county" : "SAN SABA" },
            "76825": { "city" : "BRADY", "state" : "TX", "county" : "MCCULLOCH" },
            "76827": { "city" : "BROOKESMITH", "state" : "TX", "county" : "BROWN" },
            "76828": { "city" : "BURKETT", "state" : "TX", "county" : "COLEMAN" },
            "76831": { "city" : "CASTELL", "state" : "TX", "county" : "LLANO" },"76832": { "city" : "CHEROKEE", "state" : "TX", "county" : "SAN SABA" },
            "76834": { "city" : "COLEMAN", "state" : "TX", "county" : "COLEMAN" },
            "76837": { "city" : "EDEN", "state" : "TX", "county" : "CONCHO" },"76841": { "city" : "FORT MC KAVETT", "state" : "TX", "county" : "MENARD" },
            "76842": { "city" : "FREDONIA", "state" : "TX", "county" : "MASON" },
            "76844": { "city" : "GOLDTHWAITE", "state" : "TX", "county" : "MILLS" },
            "76845": { "city" : "GOULDBUSK", "state" : "TX", "county" : "COLEMAN" },
            "76849": { "city" : "JUNCTION", "state" : "TX", "county" : "KIMBLE" },
            "76852": { "city" : "LOHN", "state" : "TX", "county" : "MCCULLOCH" },
            "76853": { "city" : "LOMETA", "state" : "TX", "county" : "LAMPASAS" },
            "76854": { "city" : "LONDON", "state" : "TX", "county" : "KIMBLE" },"76855": { "city" : "LOWAKE", "state" : "TX", "county" : "CONCHO" },
            "76856": { "city" : "MASON", "state" : "TX", "county" : "MASON" },"76857": { "city" : "MAY", "state" : "TX", "county" : "BROWN" },
            "76858": { "city" : "MELVIN", "state" : "TX", "county" : "MCCULLOCH" },
            "76859": { "city" : "MENARD", "state" : "TX", "county" : "MENARD" },"76861": { "city" : "MILES", "state" : "TX", "county" : "RUNNELS" },
            "76862": { "city" : "MILLERSVIEW", "state" : "TX", "county" : "CONCHO" },
            "76864": { "city" : "MULLIN", "state" : "TX", "county" : "MILLS" },"76866": { "city" : "PAINT ROCK", "state" : "TX", "county" : "CONCHO" },
            "76869": { "city" : "PONTOTOC", "state" : "TX", "county" : "MASON" },
            "76870": { "city" : "PRIDDY", "state" : "TX", "county" : "MILLS" },"76871": { "city" : "RICHLAND SPRINGS", "state" : "TX", "county" : "SAN SABA" },
            "76872": { "city" : "ROCHELLE", "state" : "TX", "county" : "MCCULLOCH" },
            "76873": { "city" : "ROCKWOOD", "state" : "TX", "county" : "COLEMAN" },
            "76874": { "city" : "ROOSEVELT", "state" : "TX", "county" : "KIMBLE" },
            "76875": { "city" : "ROWENA", "state" : "TX", "county" : "RUNNELS" },
            "76877": { "city" : "SAN SABA", "state" : "TX", "county" : "SAN SABA" },
            "76878": { "city" : "SANTA ANNA", "state" : "TX", "county" : "COLEMAN" },
            "76880": { "city" : "STAR", "state" : "TX", "county" : "MILLS" },"76882": { "city" : "TALPA", "state" : "TX", "county" : "COLEMAN" },
            "76884": { "city" : "VALERA", "state" : "TX", "county" : "COLEMAN" },
            "76885": { "city" : "VALLEY SPRING", "state" : "TX", "county" : "LLANO" },
            "76886": { "city" : "VERIBEST", "state" : "TX", "county" : "TOM GREEN" },
            "76887": { "city" : "VOCA", "state" : "TX", "county" : "MCCULLOCH" },
            "76888": { "city" : "VOSS", "state" : "TX", "county" : "COLEMAN" },"76890": { "city" : "ZEPHYR", "state" : "TX", "county" : "BROWN" },
            "76901": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76902": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76903": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76904": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76905": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76906": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76908": { "city" : "GOODFELLOW AFB", "state" : "TX", "county" : "TOM GREEN" },
            "76909": { "city" : "SAN ANGELO", "state" : "TX", "county" : "TOM GREEN" },
            "76930": { "city" : "BARNHART", "state" : "TX", "county" : "IRION" },
            "76932": { "city" : "BIG LAKE", "state" : "TX", "county" : "REAGAN" },
            "76933": { "city" : "BRONTE", "state" : "TX", "county" : "COKE" },"76934": { "city" : "CARLSBAD", "state" : "TX", "county" : "TOM GREEN" },
            "76935": { "city" : "CHRISTOVAL", "state" : "TX", "county" : "TOM GREEN" },
            "76936": { "city" : "ELDORADO", "state" : "TX", "county" : "SCHLEICHER" },
            "76937": { "city" : "EOLA", "state" : "TX", "county" : "CONCHO" },"76939": { "city" : "KNICKERBOCKER", "state" : "TX", "county" : "TOM GREEN" },
            "76940": { "city" : "MERETA", "state" : "TX", "county" : "TOM GREEN" },
            "76941": { "city" : "MERTZON", "state" : "TX", "county" : "IRION" },"76943": { "city" : "OZONA", "state" : "TX", "county" : "CROCKETT" },
            "76945": { "city" : "ROBERT LEE", "state" : "TX", "county" : "COKE" },
            "76949": { "city" : "SILVER", "state" : "TX", "county" : "COKE" },"76950": { "city" : "SONORA", "state" : "TX", "county" : "SUTTON" },
            "76951": { "city" : "STERLING CITY", "state" : "TX", "county" : "STERLING" },
            "76953": { "city" : "TENNYSON", "state" : "TX", "county" : "COKE" },"76955": { "city" : "VANCOURT", "state" : "TX", "county" : "TOM GREEN" },
            "76957": { "city" : "WALL", "state" : "TX", "county" : "TOM GREEN" },
            "76958": { "city" : "WATER VALLEY", "state" : "TX", "county" : "TOM GREEN" },
            "77001": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77002": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77003": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77004": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77005": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77006": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77007": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77008": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77009": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77010": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77011": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77012": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77013": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77014": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77015": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77016": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77017": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77018": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77019": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77020": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77021": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77022": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77023": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77024": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77025": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77026": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77027": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77028": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77029": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77030": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77031": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77032": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77033": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77034": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77035": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77036": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77037": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77038": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77039": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77040": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77041": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77042": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77043": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77044": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77045": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77046": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77047": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77048": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77049": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77050": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77051": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77052": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77053": { "city" : "HOUSTON", "state" : "TX", "county" : "FORT BEND" },
            "77054": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77055": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77056": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77057": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77058": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77059": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77060": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77061": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77062": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77063": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77064": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77065": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77066": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77067": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77068": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77069": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77070": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77071": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77072": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77073": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77074": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77075": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77076": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77077": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77078": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77079": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77080": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77081": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77082": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77083": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77084": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77085": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77086": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77087": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77088": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77089": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77090": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77091": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77092": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77093": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77094": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77095": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77096": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77098": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77099": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77201": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77203": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77204": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77205": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77206": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77207": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77208": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77210": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77213": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77215": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77217": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77218": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77219": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77220": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77221": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77222": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77223": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77224": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77225": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77226": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77227": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77228": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77229": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77230": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77231": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77233": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77234": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77235": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77236": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77237": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77238": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77240": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77241": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77242": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77243": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77244": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77245": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77248": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77249": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77251": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77252": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77253": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77254": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77255": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77256": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77257": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77258": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77259": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77261": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77262": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77263": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77265": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77266": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77267": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77268": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77269": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77270": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77271": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77272": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77273": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77274": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77275": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77277": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77279": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77280": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77282": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77284": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77287": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77288": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77289": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77290": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77291": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77292": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77293": { "city" : "HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77301": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77302": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77303": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77304": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77305": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77306": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77316": { "city" : "MONTGOMERY", "state" : "TX", "county" : "MONTGOMERY" },
            "77318": { "city" : "WILLIS", "state" : "TX", "county" : "MONTGOMERY" },
            "77320": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77325": { "city" : "KINGWOOD", "state" : "TX", "county" : "HARRIS" },
            "77326": { "city" : "ACE", "state" : "TX", "county" : "POLK" },"77327": { "city" : "CLEVELAND", "state" : "TX", "county" : "LIBERTY" },
            "77328": { "city" : "CLEVELAND", "state" : "TX", "county" : "LIBERTY" },
            "77331": { "city" : "COLDSPRING", "state" : "TX", "county" : "SAN JACINTO" },
            "77333": { "city" : "DOBBIN", "state" : "TX", "county" : "MONTGOMERY" },
            "77334": { "city" : "DODGE", "state" : "TX", "county" : "WALKER" },"77335": { "city" : "GOODRICH", "state" : "TX", "county" : "POLK" },
            "77336": { "city" : "HUFFMAN", "state" : "TX", "county" : "HARRIS" },
            "77337": { "city" : "HUFSMITH", "state" : "TX", "county" : "HARRIS" },
            "77338": { "city" : "HUMBLE", "state" : "TX", "county" : "HARRIS" },"77339": { "city" : "KINGWOOD", "state" : "TX", "county" : "HARRIS" },
            "77340": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77341": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77342": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77344": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77345": { "city" : "KINGWOOD", "state" : "TX", "county" : "HARRIS" },
            "77346": { "city" : "HUMBLE", "state" : "TX", "county" : "HARRIS" },"77347": { "city" : "HUMBLE", "state" : "TX", "county" : "HARRIS" },
            "77348": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77349": { "city" : "HUNTSVILLE", "state" : "TX", "county" : "WALKER" },
            "77350": { "city" : "LEGGETT", "state" : "TX", "county" : "POLK" },"77351": { "city" : "LIVINGSTON", "state" : "TX", "county" : "POLK" },
            "77353": { "city" : "MAGNOLIA", "state" : "TX", "county" : "MONTGOMERY" },
            "77354": { "city" : "MAGNOLIA", "state" : "TX", "county" : "MONTGOMERY" },
            "77355": { "city" : "MAGNOLIA", "state" : "TX", "county" : "MONTGOMERY" },
            "77356": { "city" : "MONTGOMERY", "state" : "TX", "county" : "MONTGOMERY" },
            "77357": { "city" : "NEW CANEY", "state" : "TX", "county" : "MONTGOMERY" },
            "77358": { "city" : "NEW WAVERLY", "state" : "TX", "county" : "WALKER" },
            "77359": { "city" : "OAKHURST", "state" : "TX", "county" : "SAN JACINTO" },
            "77360": { "city" : "ONALASKA", "state" : "TX", "county" : "POLK" },"77362": { "city" : "PINEHURST", "state" : "TX", "county" : "MONTGOMERY" },
            "77363": { "city" : "PLANTERSVILLE", "state" : "TX", "county" : "GRIMES" },
            "77364": { "city" : "POINTBLANK", "state" : "TX", "county" : "SAN JACINTO" },
            "77365": { "city" : "PORTER", "state" : "TX", "county" : "MONTGOMERY" },
            "77367": { "city" : "RIVERSIDE", "state" : "TX", "county" : "WALKER" },
            "77368": { "city" : "ROMAYOR", "state" : "TX", "county" : "LIBERTY" },
            "77369": { "city" : "RYE", "state" : "TX", "county" : "LIBERTY" },"77371": { "city" : "SHEPHERD", "state" : "TX", "county" : "SAN JACINTO" },
            "77372": { "city" : "SPLENDORA", "state" : "TX", "county" : "MONTGOMERY" },
            "77373": { "city" : "SPRING", "state" : "TX", "county" : "HARRIS" },"77374": { "city" : "THICKET", "state" : "TX", "county" : "HARDIN" },
            "77375": { "city" : "TOMBALL", "state" : "TX", "county" : "HARRIS" },
            "77376": { "city" : "VOTAW", "state" : "TX", "county" : "HARDIN" },"77377": { "city" : "TOMBALL", "state" : "TX", "county" : "HARRIS" },
            "77378": { "city" : "WILLIS", "state" : "TX", "county" : "MONTGOMERY" },
            "77379": { "city" : "SPRING", "state" : "TX", "county" : "HARRIS" },"77380": { "city" : "SPRING", "state" : "TX", "county" : "MONTGOMERY" },
            "77381": { "city" : "SPRING", "state" : "TX", "county" : "MONTGOMERY" },
            "77382": { "city" : "SPRING", "state" : "TX", "county" : "MONTGOMERY" },
            "77383": { "city" : "SPRING", "state" : "TX", "county" : "HARRIS" },"77384": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77385": { "city" : "CONROE", "state" : "TX", "county" : "MONTGOMERY" },
            "77386": { "city" : "SPRING", "state" : "TX", "county" : "MONTGOMERY" },
            "77387": { "city" : "SPRING", "state" : "TX", "county" : "MONTGOMERY" },
            "77388": { "city" : "SPRING", "state" : "TX", "county" : "HARRIS" },"77389": { "city" : "SPRING", "state" : "TX", "county" : "HARRIS" },
            "77391": { "city" : "SPRING", "state" : "TX", "county" : "HARRIS" },"77393": { "city" : "SPRING", "state" : "TX", "county" : "MONTGOMERY" },
            "77396": { "city" : "HUMBLE", "state" : "TX", "county" : "HARRIS" },"77399": { "city" : "LIVINGSTON", "state" : "TX", "county" : "POLK" },
            "77401": { "city" : "BELLAIRE", "state" : "TX", "county" : "HARRIS" },
            "77402": { "city" : "BELLAIRE", "state" : "TX", "county" : "HARRIS" },
            "77404": { "city" : "BAY CITY", "state" : "TX", "county" : "MATAGORDA" },
            "77406": { "city" : "RICHMOND", "state" : "TX", "county" : "FORT BEND" },
            "77407": { "city" : "RICHMOND", "state" : "TX", "county" : "FORT BEND" },
            "77410": { "city" : "CYPRESS", "state" : "TX", "county" : "HARRIS" },
            "77411": { "city" : "ALIEF", "state" : "TX", "county" : "HARRIS" },"77412": { "city" : "ALTAIR", "state" : "TX", "county" : "COLORADO" },
            "77413": { "city" : "BARKER", "state" : "TX", "county" : "HARRIS" },"77414": { "city" : "BAY CITY", "state" : "TX", "county" : "MATAGORDA" },
            "77415": { "city" : "CEDAR LANE", "state" : "TX", "county" : "MATAGORDA" },
            "77417": { "city" : "BEASLEY", "state" : "TX", "county" : "FORT BEND" },
            "77418": { "city" : "BELLVILLE", "state" : "TX", "county" : "AUSTIN" },
            "77419": { "city" : "BLESSING", "state" : "TX", "county" : "MATAGORDA" },
            "77420": { "city" : "BOLING", "state" : "TX", "county" : "WHARTON" },
            "77422": { "city" : "BRAZORIA", "state" : "TX", "county" : "BRAZORIA" },
            "77423": { "city" : "BROOKSHIRE", "state" : "TX", "county" : "WALLER" },
            "77426": { "city" : "CHAPPELL HILL", "state" : "TX", "county" : "WASHINGTON" },
            "77428": { "city" : "COLLEGEPORT", "state" : "TX", "county" : "MATAGORDA" },
            "77429": { "city" : "CYPRESS", "state" : "TX", "county" : "HARRIS" },
            "77430": { "city" : "DAMON", "state" : "TX", "county" : "BRAZORIA" },
            "77431": { "city" : "DANCIGER", "state" : "TX", "county" : "BRAZORIA" },
            "77432": { "city" : "DANEVANG", "state" : "TX", "county" : "WHARTON" },
            "77433": { "city" : "CYPRESS", "state" : "TX", "county" : "HARRIS" },
            "77434": { "city" : "EAGLE LAKE", "state" : "TX", "county" : "COLORADO" },
            "77435": { "city" : "EAST BERNARD", "state" : "TX", "county" : "WHARTON" },
            "77436": { "city" : "EGYPT", "state" : "TX", "county" : "WHARTON" },"77437": { "city" : "EL CAMPO", "state" : "TX", "county" : "WHARTON" },
            "77440": { "city" : "ELMATON", "state" : "TX", "county" : "MATAGORDA" },
            "77441": { "city" : "FULSHEAR", "state" : "TX", "county" : "FORT BEND" },
            "77442": { "city" : "GARWOOD", "state" : "TX", "county" : "COLORADO" },
            "77443": { "city" : "GLEN FLORA", "state" : "TX", "county" : "WHARTON" },
            "77444": { "city" : "GUY", "state" : "TX", "county" : "FORT BEND" },"77445": { "city" : "HEMPSTEAD", "state" : "TX", "county" : "WALLER" },
            "77446": { "city" : "PRAIRIE VIEW", "state" : "TX", "county" : "WALLER" },
            "77447": { "city" : "HOCKLEY", "state" : "TX", "county" : "HARRIS" },
            "77448": { "city" : "HUNGERFORD", "state" : "TX", "county" : "WHARTON" },
            "77449": { "city" : "KATY", "state" : "TX", "county" : "HARRIS" },"77450": { "city" : "KATY", "state" : "TX", "county" : "HARRIS" },
            "77451": { "city" : "KENDLETON", "state" : "TX", "county" : "FORT BEND" },
            "77452": { "city" : "KENNEY", "state" : "TX", "county" : "AUSTIN" },"77453": { "city" : "LANE CITY", "state" : "TX", "county" : "WHARTON" },
            "77454": { "city" : "LISSIE", "state" : "TX", "county" : "WHARTON" },
            "77455": { "city" : "LOUISE", "state" : "TX", "county" : "WHARTON" },
            "77456": { "city" : "MARKHAM", "state" : "TX", "county" : "MATAGORDA" },
            "77457": { "city" : "MATAGORDA", "state" : "TX", "county" : "MATAGORDA" },
            "77458": { "city" : "MIDFIELD", "state" : "TX", "county" : "MATAGORDA" },
            "77459": { "city" : "MISSOURI CITY", "state" : "TX", "county" : "FORT BEND" },
            "77460": { "city" : "NADA", "state" : "TX", "county" : "COLORADO" },"77461": { "city" : "NEEDVILLE", "state" : "TX", "county" : "FORT BEND" },
            "77463": { "city" : "OLD OCEAN", "state" : "TX", "county" : "BRAZORIA" },
            "77464": { "city" : "ORCHARD", "state" : "TX", "county" : "FORT BEND" },
            "77465": { "city" : "PALACIOS", "state" : "TX", "county" : "MATAGORDA" },
            "77466": { "city" : "PATTISON", "state" : "TX", "county" : "WALLER" },
            "77467": { "city" : "PIERCE", "state" : "TX", "county" : "WHARTON" },
            "77469": { "city" : "RICHMOND", "state" : "TX", "county" : "FORT BEND" },
            "77470": { "city" : "ROCK ISLAND", "state" : "TX", "county" : "COLORADO" },
            "77471": { "city" : "ROSENBERG", "state" : "TX", "county" : "FORT BEND" },
            "77473": { "city" : "SAN FELIPE", "state" : "TX", "county" : "AUSTIN" },
            "77474": { "city" : "SEALY", "state" : "TX", "county" : "AUSTIN" },"77475": { "city" : "SHERIDAN", "state" : "TX", "county" : "COLORADO" },
            "77476": { "city" : "SIMONTON", "state" : "TX", "county" : "FORT BEND" },
            "77477": { "city" : "STAFFORD", "state" : "TX", "county" : "FORT BEND" },
            "77478": { "city" : "SUGAR LAND", "state" : "TX", "county" : "FORT BEND" },
            "77479": { "city" : "SUGAR LAND", "state" : "TX", "county" : "FORT BEND" },
            "77480": { "city" : "SWEENY", "state" : "TX", "county" : "BRAZORIA" },
            "77481": { "city" : "THOMPSONS", "state" : "TX", "county" : "FORT BEND" },
            "77482": { "city" : "VAN VLECK", "state" : "TX", "county" : "MATAGORDA" },
            "77483": { "city" : "WADSWORTH", "state" : "TX", "county" : "MATAGORDA" },
            "77484": { "city" : "WALLER", "state" : "TX", "county" : "HARRIS" },"77485": { "city" : "WALLIS", "state" : "TX", "county" : "AUSTIN" },
            "77486": { "city" : "WEST COLUMBIA", "state" : "TX", "county" : "BRAZORIA" },
            "77487": { "city" : "SUGAR LAND", "state" : "TX", "county" : "FORT BEND" },
            "77488": { "city" : "WHARTON", "state" : "TX", "county" : "WHARTON" },
            "77489": { "city" : "MISSOURI CITY", "state" : "TX", "county" : "FORT BEND" },
            "77491": { "city" : "KATY", "state" : "TX", "county" : "HARRIS" },"77492": { "city" : "KATY", "state" : "TX", "county" : "HARRIS" },
            "77493": { "city" : "KATY", "state" : "TX", "county" : "HARRIS" },"77494": { "city" : "KATY", "state" : "TX", "county" : "FORT BEND" },
            "77496": { "city" : "SUGAR LAND", "state" : "TX", "county" : "FORT BEND" },
            "77497": { "city" : "STAFFORD", "state" : "TX", "county" : "FORT BEND" },
            "77498": { "city" : "SUGAR LAND", "state" : "TX", "county" : "FORT BEND" },
            "77501": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77502": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77503": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77504": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77505": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77506": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77507": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77508": { "city" : "PASADENA", "state" : "TX", "county" : "HARRIS" },
            "77510": { "city" : "SANTA FE", "state" : "TX", "county" : "GALVESTON" },
            "77511": { "city" : "ALVIN", "state" : "TX", "county" : "BRAZORIA" },
            "77512": { "city" : "ALVIN", "state" : "TX", "county" : "BRAZORIA" },
            "77514": { "city" : "ANAHUAC", "state" : "TX", "county" : "CHAMBERS" },
            "77515": { "city" : "ANGLETON", "state" : "TX", "county" : "BRAZORIA" },
            "77516": { "city" : "ANGLETON", "state" : "TX", "county" : "BRAZORIA" },
            "77517": { "city" : "SANTA FE", "state" : "TX", "county" : "GALVESTON" },
            "77518": { "city" : "BACLIFF", "state" : "TX", "county" : "GALVESTON" },
            "77519": { "city" : "BATSON", "state" : "TX", "county" : "HARDIN" },"77520": { "city" : "BAYTOWN", "state" : "TX", "county" : "HARRIS" },
            "77521": { "city" : "BAYTOWN", "state" : "TX", "county" : "HARRIS" },
            "77522": { "city" : "BAYTOWN", "state" : "TX", "county" : "HARRIS" },
            "77523": { "city" : "BAYTOWN", "state" : "TX", "county" : "CHAMBERS" },
            "77530": { "city" : "CHANNELVIEW", "state" : "TX", "county" : "HARRIS" },
            "77531": { "city" : "CLUTE", "state" : "TX", "county" : "BRAZORIA" },
            "77532": { "city" : "CROSBY", "state" : "TX", "county" : "HARRIS" },"77533": { "city" : "DAISETTA", "state" : "TX", "county" : "LIBERTY" },
            "77534": { "city" : "DANBURY", "state" : "TX", "county" : "BRAZORIA" },
            "77535": { "city" : "DAYTON", "state" : "TX", "county" : "LIBERTY" },
            "77536": { "city" : "DEER PARK", "state" : "TX", "county" : "HARRIS" },
            "77538": { "city" : "DEVERS", "state" : "TX", "county" : "LIBERTY" },
            "77539": { "city" : "DICKINSON", "state" : "TX", "county" : "GALVESTON" },
            "77541": { "city" : "FREEPORT", "state" : "TX", "county" : "BRAZORIA" },
            "77542": { "city" : "FREEPORT", "state" : "TX", "county" : "BRAZORIA" },
            "77545": { "city" : "FRESNO", "state" : "TX", "county" : "FORT BEND" },
            "77546": { "city" : "FRIENDSWOOD", "state" : "TX", "county" : "GALVESTON" },
            "77547": { "city" : "GALENA PARK", "state" : "TX", "county" : "HARRIS" },
            "77549": { "city" : "FRIENDSWOOD", "state" : "TX", "county" : "GALVESTON" },
            "77550": { "city" : "GALVESTON", "state" : "TX", "county" : "GALVESTON" },
            "77551": { "city" : "GALVESTON", "state" : "TX", "county" : "GALVESTON" },
            "77552": { "city" : "GALVESTON", "state" : "TX", "county" : "GALVESTON" },
            "77553": { "city" : "GALVESTON", "state" : "TX", "county" : "GALVESTON" },
            "77554": { "city" : "GALVESTON", "state" : "TX", "county" : "GALVESTON" },
            "77555": { "city" : "GALVESTON", "state" : "TX", "county" : "GALVESTON" },
            "77560": { "city" : "HANKAMER", "state" : "TX", "county" : "CHAMBERS" },
            "77561": { "city" : "HARDIN", "state" : "TX", "county" : "LIBERTY" },
            "77562": { "city" : "HIGHLANDS", "state" : "TX", "county" : "HARRIS" },
            "77563": { "city" : "HITCHCOCK", "state" : "TX", "county" : "GALVESTON" },
            "77564": { "city" : "HULL", "state" : "TX", "county" : "LIBERTY" },"77565": { "city" : "KEMAH", "state" : "TX", "county" : "GALVESTON" },
            "77566": { "city" : "LAKE JACKSON", "state" : "TX", "county" : "BRAZORIA" },
            "77568": { "city" : "LA MARQUE", "state" : "TX", "county" : "GALVESTON" },
            "77571": { "city" : "LA PORTE", "state" : "TX", "county" : "HARRIS" },
            "77572": { "city" : "LA PORTE", "state" : "TX", "county" : "HARRIS" },
            "77573": { "city" : "LEAGUE CITY", "state" : "TX", "county" : "GALVESTON" },
            "77574": { "city" : "LEAGUE CITY", "state" : "TX", "county" : "GALVESTON" },
            "77575": { "city" : "LIBERTY", "state" : "TX", "county" : "LIBERTY" },
            "77577": { "city" : "LIVERPOOL", "state" : "TX", "county" : "BRAZORIA" },
            "77578": { "city" : "MANVEL", "state" : "TX", "county" : "BRAZORIA" },
            "77580": { "city" : "MONT BELVIEU", "state" : "TX", "county" : "CHAMBERS" },
            "77581": { "city" : "PEARLAND", "state" : "TX", "county" : "BRAZORIA" },
            "77582": { "city" : "RAYWOOD", "state" : "TX", "county" : "LIBERTY" },
            "77583": { "city" : "ROSHARON", "state" : "TX", "county" : "BRAZORIA" },
            "77584": { "city" : "PEARLAND", "state" : "TX", "county" : "BRAZORIA" },
            "77585": { "city" : "SARATOGA", "state" : "TX", "county" : "HARDIN" },
            "77586": { "city" : "SEABROOK", "state" : "TX", "county" : "HARRIS" },
            "77587": { "city" : "SOUTH HOUSTON", "state" : "TX", "county" : "HARRIS" },
            "77588": { "city" : "PEARLAND", "state" : "TX", "county" : "BRAZORIA" },
            "77590": { "city" : "TEXAS CITY", "state" : "TX", "county" : "GALVESTON" },
            "77591": { "city" : "TEXAS CITY", "state" : "TX", "county" : "GALVESTON" },
            "77592": { "city" : "TEXAS CITY", "state" : "TX", "county" : "GALVESTON" },
            "77597": { "city" : "WALLISVILLE", "state" : "TX", "county" : "CHAMBERS" },
            "77598": { "city" : "WEBSTER", "state" : "TX", "county" : "HARRIS" },
            "77611": { "city" : "BRIDGE CITY", "state" : "TX", "county" : "ORANGE" },
            "77612": { "city" : "BUNA", "state" : "TX", "county" : "JASPER" },"77613": { "city" : "CHINA", "state" : "TX", "county" : "JEFFERSON" },
            "77614": { "city" : "DEWEYVILLE", "state" : "TX", "county" : "NEWTON" },
            "77615": { "city" : "EVADALE", "state" : "TX", "county" : "JASPER" },
            "77616": { "city" : "FRED", "state" : "TX", "county" : "TYLER" },"77617": { "city" : "GILCHRIST", "state" : "TX", "county" : "GALVESTON" },
            "77619": { "city" : "GROVES", "state" : "TX", "county" : "JEFFERSON" },
            "77622": { "city" : "HAMSHIRE", "state" : "TX", "county" : "JEFFERSON" },
            "77623": { "city" : "HIGH ISLAND", "state" : "TX", "county" : "GALVESTON" },
            "77624": { "city" : "HILLISTER", "state" : "TX", "county" : "TYLER" },
            "77625": { "city" : "KOUNTZE", "state" : "TX", "county" : "HARDIN" },
            "77626": { "city" : "MAURICEVILLE", "state" : "TX", "county" : "ORANGE" },
            "77627": { "city" : "NEDERLAND", "state" : "TX", "county" : "JEFFERSON" },
            "77629": { "city" : "NOME", "state" : "TX", "county" : "JEFFERSON" },
            "77630": { "city" : "ORANGE", "state" : "TX", "county" : "ORANGE" },"77631": { "city" : "ORANGE", "state" : "TX", "county" : "ORANGE" },
            "77632": { "city" : "ORANGE", "state" : "TX", "county" : "ORANGE" },"77639": { "city" : "ORANGEFIELD", "state" : "TX", "county" : "ORANGE" },
            "77640": { "city" : "PORT ARTHUR", "state" : "TX", "county" : "JEFFERSON" },
            "77641": { "city" : "PORT ARTHUR", "state" : "TX", "county" : "JEFFERSON" },
            "77642": { "city" : "PORT ARTHUR", "state" : "TX", "county" : "JEFFERSON" },
            "77643": { "city" : "PORT ARTHUR", "state" : "TX", "county" : "JEFFERSON" },
            "77650": { "city" : "PORT BOLIVAR", "state" : "TX", "county" : "GALVESTON" },
            "77651": { "city" : "PORT NECHES", "state" : "TX", "county" : "JEFFERSON" },
            "77655": { "city" : "SABINE PASS", "state" : "TX", "county" : "JEFFERSON" },
            "77656": { "city" : "SILSBEE", "state" : "TX", "county" : "HARDIN" },
            "77657": { "city" : "LUMBERTON", "state" : "TX", "county" : "HARDIN" },
            "77659": { "city" : "SOUR LAKE", "state" : "TX", "county" : "HARDIN" },
            "77660": { "city" : "SPURGER", "state" : "TX", "county" : "TYLER" },"77661": { "city" : "STOWELL", "state" : "TX", "county" : "CHAMBERS" },
            "77662": { "city" : "VIDOR", "state" : "TX", "county" : "ORANGE" },"77663": { "city" : "VILLAGE MILLS", "state" : "TX", "county" : "HARDIN" },
            "77664": { "city" : "WARREN", "state" : "TX", "county" : "TYLER" },"77665": { "city" : "WINNIE", "state" : "TX", "county" : "CHAMBERS" },
            "77670": { "city" : "VIDOR", "state" : "TX", "county" : "ORANGE" },"77701": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77702": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77703": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77704": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77705": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77706": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77707": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77708": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77709": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77710": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77713": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77720": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77725": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77726": { "city" : "BEAUMONT", "state" : "TX", "county" : "JEFFERSON" },
            "77801": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },"77802": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },
            "77803": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },"77805": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },
            "77806": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },"77807": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },
            "77808": { "city" : "BRYAN", "state" : "TX", "county" : "BRAZOS" },"77830": { "city" : "ANDERSON", "state" : "TX", "county" : "GRIMES" },
            "77831": { "city" : "BEDIAS", "state" : "TX", "county" : "GRIMES" },"77833": { "city" : "BRENHAM", "state" : "TX", "county" : "WASHINGTON" },
            "77834": { "city" : "BRENHAM", "state" : "TX", "county" : "WASHINGTON" },
            "77835": { "city" : "BURTON", "state" : "TX", "county" : "WASHINGTON" },
            "77836": { "city" : "CALDWELL", "state" : "TX", "county" : "BURLESON" },
            "77837": { "city" : "CALVERT", "state" : "TX", "county" : "ROBERTSON" },
            "77840": { "city" : "COLLEGE STATION", "state" : "TX", "county" : "BRAZOS" },
            "77841": { "city" : "COLLEGE STATION", "state" : "TX", "county" : "BRAZOS" },
            "77842": { "city" : "COLLEGE STATION", "state" : "TX", "county" : "BRAZOS" },
            "77843": { "city" : "COLLEGE STATION", "state" : "TX", "county" : "BRAZOS" },
            "77844": { "city" : "COLLEGE STATION", "state" : "TX", "county" : "BRAZOS" },
            "77845": { "city" : "COLLEGE STATION", "state" : "TX", "county" : "BRAZOS" },
            "77852": { "city" : "DEANVILLE", "state" : "TX", "county" : "BURLESON" },
            "77853": { "city" : "DIME BOX", "state" : "TX", "county" : "LEE" },"77855": { "city" : "FLYNN", "state" : "TX", "county" : "LEON" },
            "77856": { "city" : "FRANKLIN", "state" : "TX", "county" : "ROBERTSON" },
            "77857": { "city" : "GAUSE", "state" : "TX", "county" : "MILAM" },"77859": { "city" : "HEARNE", "state" : "TX", "county" : "ROBERTSON" },
            "77861": { "city" : "IOLA", "state" : "TX", "county" : "GRIMES" },"77862": { "city" : "KURTEN", "state" : "TX", "county" : "BRAZOS" },
            "77863": { "city" : "LYONS", "state" : "TX", "county" : "BURLESON" },
            "77864": { "city" : "MADISONVILLE", "state" : "TX", "county" : "MADISON" },
            "77865": { "city" : "MARQUEZ", "state" : "TX", "county" : "LEON" },"77866": { "city" : "MILLICAN", "state" : "TX", "county" : "BRAZOS" },
            "77867": { "city" : "MUMFORD", "state" : "TX", "county" : "ROBERTSON" },
            "77868": { "city" : "NAVASOTA", "state" : "TX", "county" : "GRIMES" },
            "77870": { "city" : "NEW BADEN", "state" : "TX", "county" : "ROBERTSON" },
            "77871": { "city" : "NORMANGEE", "state" : "TX", "county" : "LEON" },
            "77872": { "city" : "NORTH ZULCH", "state" : "TX", "county" : "MADISON" },
            "77873": { "city" : "RICHARDS", "state" : "TX", "county" : "GRIMES" },
            "77875": { "city" : "ROANS PRAIRIE", "state" : "TX", "county" : "GRIMES" },
            "77876": { "city" : "SHIRO", "state" : "TX", "county" : "GRIMES" },"77878": { "city" : "SNOOK", "state" : "TX", "county" : "BURLESON" },
            "77879": { "city" : "SOMERVILLE", "state" : "TX", "county" : "BURLESON" },
            "77880": { "city" : "WASHINGTON", "state" : "TX", "county" : "WASHINGTON" },
            "77881": { "city" : "WELLBORN", "state" : "TX", "county" : "BRAZOS" },
            "77882": { "city" : "WHEELOCK", "state" : "TX", "county" : "ROBERTSON" },
            "77901": { "city" : "VICTORIA", "state" : "TX", "county" : "VICTORIA" },
            "77902": { "city" : "VICTORIA", "state" : "TX", "county" : "VICTORIA" },
            "77903": { "city" : "VICTORIA", "state" : "TX", "county" : "VICTORIA" },
            "77904": { "city" : "VICTORIA", "state" : "TX", "county" : "VICTORIA" },
            "77905": { "city" : "VICTORIA", "state" : "TX", "county" : "VICTORIA" },
            "77950": { "city" : "AUSTWELL", "state" : "TX", "county" : "REFUGIO" },
            "77951": { "city" : "BLOOMINGTON", "state" : "TX", "county" : "VICTORIA" },
            "77954": { "city" : "CUERO", "state" : "TX", "county" : "DE WITT" },"77957": { "city" : "EDNA", "state" : "TX", "county" : "JACKSON" },
            "77960": { "city" : "FANNIN", "state" : "TX", "county" : "GOLIAD" },"77961": { "city" : "FRANCITAS", "state" : "TX", "county" : "JACKSON" },
            "77962": { "city" : "GANADO", "state" : "TX", "county" : "JACKSON" },
            "77963": { "city" : "GOLIAD", "state" : "TX", "county" : "GOLIAD" },"77964": { "city" : "HALLETTSVILLE", "state" : "TX", "county" : "LAVACA" },
            "77968": { "city" : "INEZ", "state" : "TX", "county" : "VICTORIA" },"77970": { "city" : "LA WARD", "state" : "TX", "county" : "JACKSON" },
            "77971": { "city" : "LOLITA", "state" : "TX", "county" : "JACKSON" },
            "77974": { "city" : "MEYERSVILLE", "state" : "TX", "county" : "DE WITT" },
            "77975": { "city" : "MOULTON", "state" : "TX", "county" : "LAVACA" },
            "77976": { "city" : "NURSERY", "state" : "TX", "county" : "VICTORIA" },
            "77977": { "city" : "PLACEDO", "state" : "TX", "county" : "VICTORIA" },
            "77978": { "city" : "POINT COMFORT", "state" : "TX", "county" : "CALHOUN" },
            "77979": { "city" : "PORT LAVACA", "state" : "TX", "county" : "CALHOUN" },
            "77982": { "city" : "PORT O CONNOR", "state" : "TX", "county" : "CALHOUN" },
            "77983": { "city" : "SEADRIFT", "state" : "TX", "county" : "CALHOUN" },
            "77984": { "city" : "SHINER", "state" : "TX", "county" : "LAVACA" },"77987": { "city" : "SWEET HOME", "state" : "TX", "county" : "LAVACA" },
            "77988": { "city" : "TELFERNER", "state" : "TX", "county" : "VICTORIA" },
            "77989": { "city" : "THOMASTON", "state" : "TX", "county" : "DE WITT" },
            "77990": { "city" : "TIVOLI", "state" : "TX", "county" : "REFUGIO" },
            "77991": { "city" : "VANDERBILT", "state" : "TX", "county" : "JACKSON" },
            "77993": { "city" : "WEESATCHE", "state" : "TX", "county" : "GOLIAD" },
            "77994": { "city" : "WESTHOFF", "state" : "TX", "county" : "DE WITT" },
            "77995": { "city" : "YOAKUM", "state" : "TX", "county" : "LAVACA" },"78001": { "city" : "ARTESIA WELLS", "state" : "TX", "county" : "LA SALLE" },
            "78002": { "city" : "ATASCOSA", "state" : "TX", "county" : "BEXAR" },
            "78003": { "city" : "BANDERA", "state" : "TX", "county" : "BANDERA" },
            "78004": { "city" : "BERGHEIM", "state" : "TX", "county" : "KENDALL" },
            "78005": { "city" : "BIGFOOT", "state" : "TX", "county" : "FRIO" },"78006": { "city" : "BOERNE", "state" : "TX", "county" : "KENDALL" },
            "78007": { "city" : "CALLIHAM", "state" : "TX", "county" : "MCMULLEN" },
            "78008": { "city" : "CAMPBELLTON", "state" : "TX", "county" : "ATASCOSA" },
            "78009": { "city" : "CASTROVILLE", "state" : "TX", "county" : "MEDINA" },
            "78010": { "city" : "CENTER POINT", "state" : "TX", "county" : "KERR" },
            "78011": { "city" : "CHARLOTTE", "state" : "TX", "county" : "ATASCOSA" },
            "78012": { "city" : "CHRISTINE", "state" : "TX", "county" : "ATASCOSA" },
            "78013": { "city" : "COMFORT", "state" : "TX", "county" : "KENDALL" },
            "78014": { "city" : "COTULLA", "state" : "TX", "county" : "LA SALLE" },
            "78015": { "city" : "BOERNE", "state" : "TX", "county" : "KENDALL" },
            "78016": { "city" : "DEVINE", "state" : "TX", "county" : "MEDINA" },"78017": { "city" : "DILLEY", "state" : "TX", "county" : "FRIO" },
            "78019": { "city" : "ENCINAL", "state" : "TX", "county" : "LA SALLE" },
            "78021": { "city" : "FOWLERTON", "state" : "TX", "county" : "LA SALLE" },
            "78022": { "city" : "GEORGE WEST", "state" : "TX", "county" : "LIVE OAK" },
            "78023": { "city" : "HELOTES", "state" : "TX", "county" : "BEXAR" },"78024": { "city" : "HUNT", "state" : "TX", "county" : "KERR" },
            "78025": { "city" : "INGRAM", "state" : "TX", "county" : "KERR" },"78026": { "city" : "JOURDANTON", "state" : "TX", "county" : "ATASCOSA" },
            "78027": { "city" : "KENDALIA", "state" : "TX", "county" : "KENDALL" },
            "78028": { "city" : "KERRVILLE", "state" : "TX", "county" : "KERR" },
            "78029": { "city" : "KERRVILLE", "state" : "TX", "county" : "KERR" },
            "78039": { "city" : "LA COSTE", "state" : "TX", "county" : "MEDINA" },
            "78040": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },"78041": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },
            "78042": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },"78043": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },
            "78044": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },"78045": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },
            "78046": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },"78049": { "city" : "LAREDO", "state" : "TX", "county" : "WEBB" },
            "78050": { "city" : "LEMING", "state" : "TX", "county" : "ATASCOSA" },
            "78052": { "city" : "LYTLE", "state" : "TX", "county" : "ATASCOSA" },
            "78054": { "city" : "MACDONA", "state" : "TX", "county" : "BEXAR" },"78055": { "city" : "MEDINA", "state" : "TX", "county" : "BANDERA" },
            "78056": { "city" : "MICO", "state" : "TX", "county" : "MEDINA" },"78057": { "city" : "MOORE", "state" : "TX", "county" : "FRIO" },
            "78058": { "city" : "MOUNTAIN HOME", "state" : "TX", "county" : "KERR" },
            "78059": { "city" : "NATALIA", "state" : "TX", "county" : "MEDINA" },
            "78060": { "city" : "OAKVILLE", "state" : "TX", "county" : "LIVE OAK" },
            "78061": { "city" : "PEARSALL", "state" : "TX", "county" : "FRIO" },"78062": { "city" : "PEGGY", "state" : "TX", "county" : "ATASCOSA" },
            "78063": { "city" : "PIPE CREEK", "state" : "TX", "county" : "BANDERA" },
            "78064": { "city" : "PLEASANTON", "state" : "TX", "county" : "ATASCOSA" },
            "78065": { "city" : "POTEET", "state" : "TX", "county" : "ATASCOSA" },
            "78066": { "city" : "RIO MEDINA", "state" : "TX", "county" : "MEDINA" },
            "78067": { "city" : "SAN YGNACIO", "state" : "TX", "county" : "ZAPATA" },
            "78069": { "city" : "SOMERSET", "state" : "TX", "county" : "BEXAR" },
            "78070": { "city" : "SPRING BRANCH", "state" : "TX", "county" : "COMAL" },
            "78071": { "city" : "THREE RIVERS", "state" : "TX", "county" : "LIVE OAK" },
            "78072": { "city" : "TILDEN", "state" : "TX", "county" : "MCMULLEN" },
            "78073": { "city" : "VON ORMY", "state" : "TX", "county" : "BEXAR" },
            "78074": { "city" : "WARING", "state" : "TX", "county" : "KENDALL" },
            "78075": { "city" : "WHITSETT", "state" : "TX", "county" : "LIVE OAK" },
            "78076": { "city" : "ZAPATA", "state" : "TX", "county" : "ZAPATA" },"78101": { "city" : "ADKINS", "state" : "TX", "county" : "BEXAR" },
            "78102": { "city" : "BEEVILLE", "state" : "TX", "county" : "BEE" },"78104": { "city" : "BEEVILLE", "state" : "TX", "county" : "BEE" },
            "78107": { "city" : "BERCLAIR", "state" : "TX", "county" : "GOLIAD" },
            "78108": { "city" : "CIBOLO", "state" : "TX", "county" : "GUADALUPE" },
            "78109": { "city" : "CONVERSE", "state" : "TX", "county" : "BEXAR" },
            "78111": { "city" : "ECLETO", "state" : "TX", "county" : "KARNES" },"78112": { "city" : "ELMENDORF", "state" : "TX", "county" : "BEXAR" },
            "78113": { "city" : "FALLS CITY", "state" : "TX", "county" : "KARNES" },
            "78114": { "city" : "FLORESVILLE", "state" : "TX", "county" : "WILSON" },
            "78115": { "city" : "GERONIMO", "state" : "TX", "county" : "GUADALUPE" },
            "78116": { "city" : "GILLETT", "state" : "TX", "county" : "KARNES" },
            "78117": { "city" : "HOBSON", "state" : "TX", "county" : "KARNES" },"78118": { "city" : "KARNES CITY", "state" : "TX", "county" : "KARNES" },
            "78119": { "city" : "KENEDY", "state" : "TX", "county" : "KARNES" },"78121": { "city" : "LA VERNIA", "state" : "TX", "county" : "WILSON" },
            "78122": { "city" : "LEESVILLE", "state" : "TX", "county" : "GONZALES" },
            "78123": { "city" : "MC QUEENEY", "state" : "TX", "county" : "GUADALUPE" },
            "78124": { "city" : "MARION", "state" : "TX", "county" : "GUADALUPE" },
            "78130": { "city" : "NEW BRAUNFELS", "state" : "TX", "county" : "COMAL" },
            "78131": { "city" : "NEW BRAUNFELS", "state" : "TX", "county" : "COMAL" },
            "78132": { "city" : "NEW BRAUNFELS", "state" : "TX", "county" : "COMAL" },
            "78133": { "city" : "CANYON LAKE", "state" : "TX", "county" : "COMAL" },
            "78135": { "city" : "NEW BRAUNFELS", "state" : "TX", "county" : "COMAL" },
            "78140": { "city" : "NIXON", "state" : "TX", "county" : "GONZALES" },
            "78141": { "city" : "NORDHEIM", "state" : "TX", "county" : "DE WITT" },
            "78142": { "city" : "NORMANNA", "state" : "TX", "county" : "BEE" },"78143": { "city" : "PANDORA", "state" : "TX", "county" : "WILSON" },
            "78144": { "city" : "PANNA MARIA", "state" : "TX", "county" : "KARNES" },
            "78145": { "city" : "PAWNEE", "state" : "TX", "county" : "BEE" },"78146": { "city" : "PETTUS", "state" : "TX", "county" : "BEE" },
            "78147": { "city" : "POTH", "state" : "TX", "county" : "WILSON" },"78148": { "city" : "UNIVERSAL CITY", "state" : "TX", "county" : "BEXAR" },
            "78150": { "city" : "UNIVERSAL CITY", "state" : "TX", "county" : "BEXAR" },
            "78151": { "city" : "RUNGE", "state" : "TX", "county" : "KARNES" },"78152": { "city" : "SAINT HEDWIG", "state" : "TX", "county" : "BEXAR" },
            "78154": { "city" : "SCHERTZ", "state" : "TX", "county" : "GUADALUPE" },
            "78155": { "city" : "SEGUIN", "state" : "TX", "county" : "GUADALUPE" },
            "78156": { "city" : "SEGUIN", "state" : "TX", "county" : "GUADALUPE" },
            "78159": { "city" : "SMILEY", "state" : "TX", "county" : "GONZALES" },
            "78160": { "city" : "STOCKDALE", "state" : "TX", "county" : "WILSON" },
            "78161": { "city" : "SUTHERLAND SPRINGS", "state" : "TX", "county" : "WILSON" },
            "78162": { "city" : "TULETA", "state" : "TX", "county" : "BEE" },"78163": { "city" : "BULVERDE", "state" : "TX", "county" : "COMAL" },
            "78164": { "city" : "YORKTOWN", "state" : "TX", "county" : "DE WITT" },
            "78201": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78202": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78203": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78204": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78205": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78206": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78207": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78208": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78209": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78210": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78211": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78212": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78213": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78214": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78215": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78216": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78217": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78218": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78219": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78220": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78221": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78222": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78223": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78224": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78225": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78226": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78227": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78228": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78229": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78230": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78231": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78232": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78233": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78234": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78235": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78236": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78237": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78238": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78239": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78240": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78241": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78242": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78243": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78244": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78245": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78246": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78247": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78248": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78249": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78250": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78251": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78252": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78253": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78254": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78255": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78256": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78257": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78258": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78259": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78260": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78261": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78262": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78263": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78264": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78265": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78266": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "COMAL" },
            "78268": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78269": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78270": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78275": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78278": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78279": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78280": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78283": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78284": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78287": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78288": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78291": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78292": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78293": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78295": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78296": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78297": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78299": { "city" : "SAN ANTONIO", "state" : "TX", "county" : "BEXAR" },
            "78330": { "city" : "AGUA DULCE", "state" : "TX", "county" : "NUECES" },
            "78332": { "city" : "ALICE", "state" : "TX", "county" : "JIM WELLS" },
            "78333": { "city" : "ALICE", "state" : "TX", "county" : "JIM WELLS" },
            "78335": { "city" : "ARANSAS PASS", "state" : "TX", "county" : "SAN PATRICIO" },
            "78336": { "city" : "ARANSAS PASS", "state" : "TX", "county" : "SAN PATRICIO" },
            "78338": { "city" : "ARMSTRONG", "state" : "TX", "county" : "KENEDY" },
            "78339": { "city" : "BANQUETE", "state" : "TX", "county" : "NUECES" },
            "78340": { "city" : "BAYSIDE", "state" : "TX", "county" : "REFUGIO" },
            "78341": { "city" : "BENAVIDES", "state" : "TX", "county" : "DUVAL" },
            "78342": { "city" : "BEN BOLT", "state" : "TX", "county" : "JIM WELLS" },
            "78343": { "city" : "BISHOP", "state" : "TX", "county" : "NUECES" },"78344": { "city" : "BRUNI", "state" : "TX", "county" : "WEBB" },
            "78347": { "city" : "CHAPMAN RANCH", "state" : "TX", "county" : "NUECES" },
            "78349": { "city" : "CONCEPCION", "state" : "TX", "county" : "DUVAL" },
            "78350": { "city" : "DINERO", "state" : "TX", "county" : "LIVE OAK" },
            "78351": { "city" : "DRISCOLL", "state" : "TX", "county" : "NUECES" },
            "78352": { "city" : "EDROY", "state" : "TX", "county" : "SAN PATRICIO" },
            "78353": { "city" : "ENCINO", "state" : "TX", "county" : "BROOKS" },"78355": { "city" : "FALFURRIAS", "state" : "TX", "county" : "BROOKS" },
            "78357": { "city" : "FREER", "state" : "TX", "county" : "DUVAL" },"78358": { "city" : "FULTON", "state" : "TX", "county" : "ARANSAS" },
            "78359": { "city" : "GREGORY", "state" : "TX", "county" : "SAN PATRICIO" },
            "78360": { "city" : "GUERRA", "state" : "TX", "county" : "JIM HOGG" },
            "78361": { "city" : "HEBBRONVILLE", "state" : "TX", "county" : "JIM HOGG" },
            "78362": { "city" : "INGLESIDE", "state" : "TX", "county" : "SAN PATRICIO" },
            "78363": { "city" : "KINGSVILLE", "state" : "TX", "county" : "KLEBERG" },
            "78364": { "city" : "KINGSVILLE", "state" : "TX", "county" : "KLEBERG" },
            "78368": { "city" : "MATHIS", "state" : "TX", "county" : "SAN PATRICIO" },
            "78369": { "city" : "MIRANDO CITY", "state" : "TX", "county" : "WEBB" },
            "78370": { "city" : "ODEM", "state" : "TX", "county" : "SAN PATRICIO" },
            "78371": { "city" : "OILTON", "state" : "TX", "county" : "WEBB" },"78372": { "city" : "ORANGE GROVE", "state" : "TX", "county" : "JIM WELLS" },
            "78373": { "city" : "PORT ARANSAS", "state" : "TX", "county" : "NUECES" },
            "78374": { "city" : "PORTLAND", "state" : "TX", "county" : "SAN PATRICIO" },
            "78375": { "city" : "PREMONT", "state" : "TX", "county" : "JIM WELLS" },
            "78376": { "city" : "REALITOS", "state" : "TX", "county" : "DUVAL" },
            "78377": { "city" : "REFUGIO", "state" : "TX", "county" : "REFUGIO" },
            "78379": { "city" : "RIVIERA", "state" : "TX", "county" : "KLEBERG" },
            "78380": { "city" : "ROBSTOWN", "state" : "TX", "county" : "NUECES" },
            "78381": { "city" : "ROCKPORT", "state" : "TX", "county" : "ARANSAS" },
            "78382": { "city" : "ROCKPORT", "state" : "TX", "county" : "ARANSAS" },
            "78383": { "city" : "SANDIA", "state" : "TX", "county" : "JIM WELLS" },
            "78384": { "city" : "SAN DIEGO", "state" : "TX", "county" : "DUVAL" },
            "78385": { "city" : "SARITA", "state" : "TX", "county" : "KENEDY" },"78387": { "city" : "SINTON", "state" : "TX", "county" : "SAN PATRICIO" },
            "78389": { "city" : "SKIDMORE", "state" : "TX", "county" : "BEE" },"78390": { "city" : "TAFT", "state" : "TX", "county" : "SAN PATRICIO" },
            "78391": { "city" : "TYNAN", "state" : "TX", "county" : "BEE" },"78393": { "city" : "WOODSBORO", "state" : "TX", "county" : "REFUGIO" },
            "78401": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78402": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78403": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78404": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78405": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78406": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78407": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78408": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78409": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78410": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78411": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78412": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78413": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78414": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78415": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78416": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78417": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78418": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78419": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78426": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78427": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78460": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78463": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78465": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78466": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78467": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78468": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78469": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78470": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78471": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78472": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78473": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78475": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78476": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78477": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78478": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78480": { "city" : "CORPUS CHRISTI", "state" : "TX", "county" : "NUECES" },
            "78501": { "city" : "MCALLEN", "state" : "TX", "county" : "HIDALGO" },
            "78502": { "city" : "MCALLEN", "state" : "TX", "county" : "HIDALGO" },
            "78503": { "city" : "MCALLEN", "state" : "TX", "county" : "HIDALGO" },
            "78504": { "city" : "MCALLEN", "state" : "TX", "county" : "HIDALGO" },
            "78505": { "city" : "MCALLEN", "state" : "TX", "county" : "HIDALGO" },
            "78516": { "city" : "ALAMO", "state" : "TX", "county" : "HIDALGO" },"78520": { "city" : "BROWNSVILLE", "state" : "TX", "county" : "CAMERON" },
            "78521": { "city" : "BROWNSVILLE", "state" : "TX", "county" : "CAMERON" },
            "78522": { "city" : "BROWNSVILLE", "state" : "TX", "county" : "CAMERON" },
            "78523": { "city" : "BROWNSVILLE", "state" : "TX", "county" : "CAMERON" },
            "78526": { "city" : "BROWNSVILLE", "state" : "TX", "county" : "CAMERON" },
            "78535": { "city" : "COMBES", "state" : "TX", "county" : "CAMERON" },
            "78536": { "city" : "DELMITA", "state" : "TX", "county" : "STARR" },"78537": { "city" : "DONNA", "state" : "TX", "county" : "HIDALGO" },
            "78538": { "city" : "EDCOUCH", "state" : "TX", "county" : "HIDALGO" },
            "78539": { "city" : "EDINBURG", "state" : "TX", "county" : "HIDALGO" },
            "78540": { "city" : "EDINBURG", "state" : "TX", "county" : "HIDALGO" },
            "78541": { "city" : "EDINBURG", "state" : "TX", "county" : "HIDALGO" },
            "78542": { "city" : "EDINBURG", "state" : "TX", "county" : "HIDALGO" },
            "78543": { "city" : "ELSA", "state" : "TX", "county" : "HIDALGO" },"78547": { "city" : "GARCIASVILLE", "state" : "TX", "county" : "STARR" },
            "78548": { "city" : "GRULLA", "state" : "TX", "county" : "STARR" },"78549": { "city" : "HARGILL", "state" : "TX", "county" : "HIDALGO" },
            "78550": { "city" : "HARLINGEN", "state" : "TX", "county" : "CAMERON" },
            "78551": { "city" : "HARLINGEN", "state" : "TX", "county" : "CAMERON" },
            "78552": { "city" : "HARLINGEN", "state" : "TX", "county" : "CAMERON" },
            "78553": { "city" : "HARLINGEN", "state" : "TX", "county" : "CAMERON" },
            "78557": { "city" : "HIDALGO", "state" : "TX", "county" : "HIDALGO" },
            "78558": { "city" : "LA BLANCA", "state" : "TX", "county" : "HIDALGO" },
            "78559": { "city" : "LA FERIA", "state" : "TX", "county" : "CAMERON" },
            "78560": { "city" : "LA JOYA", "state" : "TX", "county" : "HIDALGO" },
            "78561": { "city" : "LASARA", "state" : "TX", "county" : "WILLACY" },
            "78562": { "city" : "LA VILLA", "state" : "TX", "county" : "HIDALGO" },
            "78563": { "city" : "LINN", "state" : "TX", "county" : "HIDALGO" },"78565": { "city" : "LOS EBANOS", "state" : "TX", "county" : "HIDALGO" },
            "78566": { "city" : "LOS FRESNOS", "state" : "TX", "county" : "CAMERON" },
            "78567": { "city" : "LOS INDIOS", "state" : "TX", "county" : "CAMERON" },
            "78568": { "city" : "LOZANO", "state" : "TX", "county" : "CAMERON" },
            "78569": { "city" : "LYFORD", "state" : "TX", "county" : "WILLACY" },
            "78570": { "city" : "MERCEDES", "state" : "TX", "county" : "HIDALGO" },
            "78572": { "city" : "MISSION", "state" : "TX", "county" : "HIDALGO" },
            "78573": { "city" : "MISSION", "state" : "TX", "county" : "HIDALGO" },
            "78574": { "city" : "MISSION", "state" : "TX", "county" : "HIDALGO" },
            "78575": { "city" : "OLMITO", "state" : "TX", "county" : "CAMERON" },
            "78576": { "city" : "PENITAS", "state" : "TX", "county" : "HIDALGO" },
            "78577": { "city" : "PHARR", "state" : "TX", "county" : "HIDALGO" },"78578": { "city" : "PORT ISABEL", "state" : "TX", "county" : "CAMERON" },
            "78579": { "city" : "PROGRESO", "state" : "TX", "county" : "HIDALGO" },
            "78580": { "city" : "RAYMONDVILLE", "state" : "TX", "county" : "WILLACY" },
            "78582": { "city" : "RIO GRANDE CITY", "state" : "TX", "county" : "STARR" },
            "78583": { "city" : "RIO HONDO", "state" : "TX", "county" : "CAMERON" },
            "78584": { "city" : "ROMA", "state" : "TX", "county" : "STARR" },"78585": { "city" : "SALINENO", "state" : "TX", "county" : "STARR" },
            "78586": { "city" : "SAN BENITO", "state" : "TX", "county" : "CAMERON" },
            "78588": { "city" : "SAN ISIDRO", "state" : "TX", "county" : "STARR" },
            "78589": { "city" : "SAN JUAN", "state" : "TX", "county" : "HIDALGO" },
            "78590": { "city" : "SAN PERLITA", "state" : "TX", "county" : "WILLACY" },
            "78591": { "city" : "SANTA ELENA", "state" : "TX", "county" : "STARR" },
            "78592": { "city" : "SANTA MARIA", "state" : "TX", "county" : "CAMERON" },
            "78593": { "city" : "SANTA ROSA", "state" : "TX", "county" : "CAMERON" },
            "78594": { "city" : "SEBASTIAN", "state" : "TX", "county" : "WILLACY" },
            "78595": { "city" : "SULLIVAN CITY", "state" : "TX", "county" : "HIDALGO" },
            "78596": { "city" : "WESLACO", "state" : "TX", "county" : "HIDALGO" },
            "78597": { "city" : "SOUTH PADRE ISLAND", "state" : "TX", "county" : "CAMERON" },
            "78598": { "city" : "PORT MANSFIELD", "state" : "TX", "county" : "WILLACY" },
            "78599": { "city" : "WESLACO", "state" : "TX", "county" : "HIDALGO" },
            "78602": { "city" : "BASTROP", "state" : "TX", "county" : "BASTROP" },
            "78604": { "city" : "BELMONT", "state" : "TX", "county" : "GONZALES" },
            "78605": { "city" : "BERTRAM", "state" : "TX", "county" : "BURNET" },
            "78606": { "city" : "BLANCO", "state" : "TX", "county" : "BLANCO" },"78607": { "city" : "BLUFFTON", "state" : "TX", "county" : "LLANO" },
            "78608": { "city" : "BRIGGS", "state" : "TX", "county" : "BURNET" },"78609": { "city" : "BUCHANAN DAM", "state" : "TX", "county" : "LLANO" },
            "78610": { "city" : "BUDA", "state" : "TX", "county" : "HAYS" },"78611": { "city" : "BURNET", "state" : "TX", "county" : "BURNET" },
            "78612": { "city" : "CEDAR CREEK", "state" : "TX", "county" : "BASTROP" },
            "78613": { "city" : "CEDAR PARK", "state" : "TX", "county" : "WILLIAMSON" },
            "78614": { "city" : "COST", "state" : "TX", "county" : "GONZALES" },"78615": { "city" : "COUPLAND", "state" : "TX", "county" : "WILLIAMSON" },
            "78616": { "city" : "DALE", "state" : "TX", "county" : "CALDWELL" },"78617": { "city" : "DEL VALLE", "state" : "TX", "county" : "TRAVIS" },
            "78618": { "city" : "DOSS", "state" : "TX", "county" : "GILLESPIE" },
            "78619": { "city" : "DRIFTWOOD", "state" : "TX", "county" : "HAYS" },
            "78620": { "city" : "DRIPPING SPRINGS", "state" : "TX", "county" : "HAYS" },
            "78621": { "city" : "ELGIN", "state" : "TX", "county" : "BASTROP" },"78622": { "city" : "FENTRESS", "state" : "TX", "county" : "CALDWELL" },
            "78623": { "city" : "FISCHER", "state" : "TX", "county" : "COMAL" },"78624": { "city" : "FREDERICKSBURG", "state" : "TX", "county" : "GILLESPIE" },
            "78626": { "city" : "GEORGETOWN", "state" : "TX", "county" : "WILLIAMSON" },
            "78627": { "city" : "GEORGETOWN", "state" : "TX", "county" : "WILLIAMSON" },
            "78628": { "city" : "GEORGETOWN", "state" : "TX", "county" : "WILLIAMSON" },
            "78629": { "city" : "GONZALES", "state" : "TX", "county" : "GONZALES" },
            "78630": { "city" : "CEDAR PARK", "state" : "TX", "county" : "WILLIAMSON" },
            "78631": { "city" : "HARPER", "state" : "TX", "county" : "GILLESPIE" },
            "78632": { "city" : "HARWOOD", "state" : "TX", "county" : "GONZALES" },
            "78633": { "city" : "GEORGETOWN", "state" : "TX", "county" : "WILLIAMSON" },
            "78634": { "city" : "HUTTO", "state" : "TX", "county" : "WILLIAMSON" },
            "78635": { "city" : "HYE", "state" : "TX", "county" : "BLANCO" },"78636": { "city" : "JOHNSON CITY", "state" : "TX", "county" : "BLANCO" },
            "78638": { "city" : "KINGSBURY", "state" : "TX", "county" : "GUADALUPE" },
            "78639": { "city" : "KINGSLAND", "state" : "TX", "county" : "LLANO" },
            "78640": { "city" : "KYLE", "state" : "TX", "county" : "HAYS" },"78641": { "city" : "LEANDER", "state" : "TX", "county" : "WILLIAMSON" },
            "78642": { "city" : "LIBERTY HILL", "state" : "TX", "county" : "WILLIAMSON" },
            "78643": { "city" : "LLANO", "state" : "TX", "county" : "LLANO" },"78644": { "city" : "LOCKHART", "state" : "TX", "county" : "CALDWELL" },
            "78645": { "city" : "LEANDER", "state" : "TX", "county" : "TRAVIS" },
            "78646": { "city" : "LEANDER", "state" : "TX", "county" : "WILLIAMSON" },
            "78648": { "city" : "LULING", "state" : "TX", "county" : "CALDWELL" },
            "78650": { "city" : "MC DADE", "state" : "TX", "county" : "BASTROP" },
            "78652": { "city" : "MANCHACA", "state" : "TX", "county" : "TRAVIS" },
            "78653": { "city" : "MANOR", "state" : "TX", "county" : "TRAVIS" },"78654": { "city" : "MARBLE FALLS", "state" : "TX", "county" : "BURNET" },
            "78655": { "city" : "MARTINDALE", "state" : "TX", "county" : "CALDWELL" },
            "78656": { "city" : "MAXWELL", "state" : "TX", "county" : "CALDWELL" },
            "78657": { "city" : "HORSESHOE BAY", "state" : "TX", "county" : "LLANO" },
            "78659": { "city" : "PAIGE", "state" : "TX", "county" : "BASTROP" },"78660": { "city" : "PFLUGERVILLE", "state" : "TX", "county" : "TRAVIS" },
            "78661": { "city" : "PRAIRIE LEA", "state" : "TX", "county" : "CALDWELL" },
            "78662": { "city" : "RED ROCK", "state" : "TX", "county" : "BASTROP" },
            "78663": { "city" : "ROUND MOUNTAIN", "state" : "TX", "county" : "BLANCO" },
            "78664": { "city" : "ROUND ROCK", "state" : "TX", "county" : "WILLIAMSON" },
            "78665": { "city" : "ROUND ROCK", "state" : "TX", "county" : "WILLIAMSON" },
            "78666": { "city" : "SAN MARCOS", "state" : "TX", "county" : "HAYS" },
            "78667": { "city" : "SAN MARCOS", "state" : "TX", "county" : "HAYS" },
            "78669": { "city" : "SPICEWOOD", "state" : "TX", "county" : "TRAVIS" },
            "78670": { "city" : "STAPLES", "state" : "TX", "county" : "GUADALUPE" },
            "78671": { "city" : "STONEWALL", "state" : "TX", "county" : "GILLESPIE" },
            "78672": { "city" : "TOW", "state" : "TX", "county" : "LLANO" },"78673": { "city" : "WALBURG", "state" : "TX", "county" : "WILLIAMSON" },
            "78674": { "city" : "WEIR", "state" : "TX", "county" : "WILLIAMSON" },
            "78675": { "city" : "WILLOW CITY", "state" : "TX", "county" : "GILLESPIE" },
            "78676": { "city" : "WIMBERLEY", "state" : "TX", "county" : "HAYS" },
            "78680": { "city" : "ROUND ROCK", "state" : "TX", "county" : "WILLIAMSON" },
            "78681": { "city" : "ROUND ROCK", "state" : "TX", "county" : "WILLIAMSON" },
            "78682": { "city" : "ROUND ROCK", "state" : "TX", "county" : "WILLIAMSON" },
            "78683": { "city" : "ROUND ROCK", "state" : "TX", "county" : "WILLIAMSON" },
            "78691": { "city" : "PFLUGERVILLE", "state" : "TX", "county" : "TRAVIS" },
            "78701": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78702": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78703": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78704": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78705": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78708": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78709": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78710": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78711": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78712": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78713": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78714": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78715": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78716": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78717": { "city" : "AUSTIN", "state" : "TX", "county" : "WILLIAMSON" },
            "78718": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78719": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78720": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78721": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78722": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78723": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78724": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78725": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78726": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78727": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78728": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78729": { "city" : "AUSTIN", "state" : "TX", "county" : "WILLIAMSON" },
            "78730": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78731": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78732": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78733": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78734": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78735": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78736": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78737": { "city" : "AUSTIN", "state" : "TX", "county" : "HAYS" },
            "78738": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78739": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78741": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78742": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78744": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78745": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78746": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78747": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78748": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78749": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78750": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78751": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78752": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78753": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78754": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78755": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78756": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78757": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78758": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78759": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78760": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78761": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78762": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78763": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78764": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78765": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78766": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78767": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78768": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78772": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78774": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78778": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78785": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },"78789": { "city" : "AUSTIN", "state" : "TX", "county" : "TRAVIS" },
            "78801": { "city" : "UVALDE", "state" : "TX", "county" : "UVALDE" },"78802": { "city" : "UVALDE", "state" : "TX", "county" : "UVALDE" },
            "78827": { "city" : "ASHERTON", "state" : "TX", "county" : "DIMMIT" },
            "78828": { "city" : "BARKSDALE", "state" : "TX", "county" : "EDWARDS" },
            "78829": { "city" : "BATESVILLE", "state" : "TX", "county" : "ZAVALA" },
            "78830": { "city" : "BIG WELLS", "state" : "TX", "county" : "DIMMIT" },
            "78832": { "city" : "BRACKETTVILLE", "state" : "TX", "county" : "KINNEY" },
            "78833": { "city" : "CAMP WOOD", "state" : "TX", "county" : "REAL" },
            "78834": { "city" : "CARRIZO SPRINGS", "state" : "TX", "county" : "DIMMIT" },
            "78836": { "city" : "CATARINA", "state" : "TX", "county" : "DIMMIT" },
            "78838": { "city" : "CONCAN", "state" : "TX", "county" : "UVALDE" },"78839": { "city" : "CRYSTAL CITY", "state" : "TX", "county" : "ZAVALA" },
            "78840": { "city" : "DEL RIO", "state" : "TX", "county" : "VAL VERDE" },
            "78841": { "city" : "DEL RIO", "state" : "TX", "county" : "VAL VERDE" },
            "78842": { "city" : "DEL RIO", "state" : "TX", "county" : "VAL VERDE" },
            "78843": { "city" : "LAUGHLIN A F B", "state" : "TX", "county" : "VAL VERDE" },
            "78850": { "city" : "D HANIS", "state" : "TX", "county" : "MEDINA" },
            "78851": { "city" : "DRYDEN", "state" : "TX", "county" : "TERRELL" },
            "78852": { "city" : "EAGLE PASS", "state" : "TX", "county" : "MAVERICK" },
            "78853": { "city" : "EAGLE PASS", "state" : "TX", "county" : "MAVERICK" },
            "78861": { "city" : "HONDO", "state" : "TX", "county" : "MEDINA" },"78870": { "city" : "KNIPPA", "state" : "TX", "county" : "UVALDE" },
            "78872": { "city" : "LA PRYOR", "state" : "TX", "county" : "ZAVALA" },
            "78873": { "city" : "LEAKEY", "state" : "TX", "county" : "REAL" },"78877": { "city" : "QUEMADO", "state" : "TX", "county" : "MAVERICK" },
            "78879": { "city" : "RIO FRIO", "state" : "TX", "county" : "REAL" },"78880": { "city" : "ROCKSPRINGS", "state" : "TX", "county" : "EDWARDS" },
            "78881": { "city" : "SABINAL", "state" : "TX", "county" : "UVALDE" },
            "78883": { "city" : "TARPLEY", "state" : "TX", "county" : "BANDERA" },
            "78884": { "city" : "UTOPIA", "state" : "TX", "county" : "UVALDE" },"78885": { "city" : "VANDERPOOL", "state" : "TX", "county" : "BANDERA" },
            "78886": { "city" : "YANCEY", "state" : "TX", "county" : "MEDINA" },"78931": { "city" : "BLEIBLERVILLE", "state" : "TX", "county" : "AUSTIN" },
            "78932": { "city" : "CARMINE", "state" : "TX", "county" : "FAYETTE" },
            "78933": { "city" : "CAT SPRING", "state" : "TX", "county" : "AUSTIN" },
            "78934": { "city" : "COLUMBUS", "state" : "TX", "county" : "COLORADO" },
            "78935": { "city" : "ALLEYTON", "state" : "TX", "county" : "COLORADO" },
            "78938": { "city" : "ELLINGER", "state" : "TX", "county" : "FAYETTE" },
            "78940": { "city" : "FAYETTEVILLE", "state" : "TX", "county" : "FAYETTE" },
            "78941": { "city" : "FLATONIA", "state" : "TX", "county" : "FAYETTE" },
            "78942": { "city" : "GIDDINGS", "state" : "TX", "county" : "LEE" },"78943": { "city" : "GLIDDEN", "state" : "TX", "county" : "COLORADO" },
            "78944": { "city" : "INDUSTRY", "state" : "TX", "county" : "AUSTIN" },
            "78945": { "city" : "LA GRANGE", "state" : "TX", "county" : "FAYETTE" },
            "78946": { "city" : "LEDBETTER", "state" : "TX", "county" : "FAYETTE" },
            "78947": { "city" : "LEXINGTON", "state" : "TX", "county" : "LEE" },"78948": { "city" : "LINCOLN", "state" : "TX", "county" : "LEE" },
            "78949": { "city" : "MULDOON", "state" : "TX", "county" : "FAYETTE" },
            "78950": { "city" : "NEW ULM", "state" : "TX", "county" : "AUSTIN" },
            "78952": { "city" : "PLUM", "state" : "TX", "county" : "FAYETTE" },"78953": { "city" : "ROSANKY", "state" : "TX", "county" : "BASTROP" },
            "78954": { "city" : "ROUND TOP", "state" : "TX", "county" : "FAYETTE" },
            "78956": { "city" : "SCHULENBURG", "state" : "TX", "county" : "FAYETTE" },
            "78957": { "city" : "SMITHVILLE", "state" : "TX", "county" : "BASTROP" },
            "78959": { "city" : "WAELDER", "state" : "TX", "county" : "GONZALES" },
            "78960": { "city" : "WARDA", "state" : "TX", "county" : "FAYETTE" },"78962": { "city" : "WEIMAR", "state" : "TX", "county" : "COLORADO" },
            "78963": { "city" : "WEST POINT", "state" : "TX", "county" : "FAYETTE" },
            "79001": { "city" : "ADRIAN", "state" : "TX", "county" : "OLDHAM" },"79002": { "city" : "ALANREED", "state" : "TX", "county" : "GRAY" },
            "79003": { "city" : "ALLISON", "state" : "TX", "county" : "WHEELER" },
            "79005": { "city" : "BOOKER", "state" : "TX", "county" : "LIPSCOMB" },
            "79007": { "city" : "BORGER", "state" : "TX", "county" : "HUTCHINSON" },
            "79008": { "city" : "BORGER", "state" : "TX", "county" : "HUTCHINSON" },
            "79009": { "city" : "BOVINA", "state" : "TX", "county" : "PARMER" },"79010": { "city" : "BOYS RANCH", "state" : "TX", "county" : "OLDHAM" },
            "79011": { "city" : "BRISCOE", "state" : "TX", "county" : "WHEELER" },
            "79012": { "city" : "BUSHLAND", "state" : "TX", "county" : "POTTER" },
            "79013": { "city" : "CACTUS", "state" : "TX", "county" : "MOORE" },"79014": { "city" : "CANADIAN", "state" : "TX", "county" : "HEMPHILL" },
            "79015": { "city" : "CANYON", "state" : "TX", "county" : "RANDALL" },
            "79016": { "city" : "CANYON", "state" : "TX", "county" : "RANDALL" },
            "79018": { "city" : "CHANNING", "state" : "TX", "county" : "HARTLEY" },
            "79019": { "city" : "CLAUDE", "state" : "TX", "county" : "ARMSTRONG" },
            "79021": { "city" : "COTTON CENTER", "state" : "TX", "county" : "HALE" },
            "79022": { "city" : "DALHART", "state" : "TX", "county" : "DALLAM" },
            "79024": { "city" : "DARROUZETT", "state" : "TX", "county" : "LIPSCOMB" },
            "79025": { "city" : "DAWN", "state" : "TX", "county" : "DEAF SMITH" },
            "79027": { "city" : "DIMMITT", "state" : "TX", "county" : "CASTRO" },
            "79029": { "city" : "DUMAS", "state" : "TX", "county" : "MOORE" },"79031": { "city" : "EARTH", "state" : "TX", "county" : "LAMB" },
            "79032": { "city" : "EDMONSON", "state" : "TX", "county" : "HALE" },"79033": { "city" : "FARNSWORTH", "state" : "TX", "county" : "OCHILTREE" },
            "79034": { "city" : "FOLLETT", "state" : "TX", "county" : "LIPSCOMB" },
            "79035": { "city" : "FRIONA", "state" : "TX", "county" : "PARMER" },"79036": { "city" : "FRITCH", "state" : "TX", "county" : "HUTCHINSON" },
            "79039": { "city" : "GROOM", "state" : "TX", "county" : "CARSON" },"79040": { "city" : "GRUVER", "state" : "TX", "county" : "HANSFORD" },
            "79041": { "city" : "HALE CENTER", "state" : "TX", "county" : "HALE" },
            "79042": { "city" : "HAPPY", "state" : "TX", "county" : "SWISHER" },"79043": { "city" : "HART", "state" : "TX", "county" : "CASTRO" },
            "79044": { "city" : "HARTLEY", "state" : "TX", "county" : "HARTLEY" },
            "79045": { "city" : "HEREFORD", "state" : "TX", "county" : "DEAF SMITH" },
            "79046": { "city" : "HIGGINS", "state" : "TX", "county" : "LIPSCOMB" },
            "79051": { "city" : "KERRICK", "state" : "TX", "county" : "DALLAM" },
            "79052": { "city" : "KRESS", "state" : "TX", "county" : "SWISHER" },"79053": { "city" : "LAZBUDDIE", "state" : "TX", "county" : "PARMER" },
            "79054": { "city" : "LEFORS", "state" : "TX", "county" : "GRAY" },"79056": { "city" : "LIPSCOMB", "state" : "TX", "county" : "LIPSCOMB" },
            "79057": { "city" : "MCLEAN", "state" : "TX", "county" : "GRAY" },"79058": { "city" : "MASTERSON", "state" : "TX", "county" : "MOORE" },
            "79059": { "city" : "MIAMI", "state" : "TX", "county" : "ROBERTS" },"79061": { "city" : "MOBEETIE", "state" : "TX", "county" : "WHEELER" },
            "79062": { "city" : "MORSE", "state" : "TX", "county" : "HANSFORD" },
            "79063": { "city" : "NAZARETH", "state" : "TX", "county" : "CASTRO" },
            "79064": { "city" : "OLTON", "state" : "TX", "county" : "LAMB" },"79065": { "city" : "PAMPA", "state" : "TX", "county" : "GRAY" },
            "79066": { "city" : "PAMPA", "state" : "TX", "county" : "GRAY" },"79068": { "city" : "PANHANDLE", "state" : "TX", "county" : "CARSON" },
            "79070": { "city" : "PERRYTON", "state" : "TX", "county" : "OCHILTREE" },
            "79072": { "city" : "PLAINVIEW", "state" : "TX", "county" : "HALE" },
            "79073": { "city" : "PLAINVIEW", "state" : "TX", "county" : "HALE" },
            "79078": { "city" : "SANFORD", "state" : "TX", "county" : "HUTCHINSON" },
            "79079": { "city" : "SHAMROCK", "state" : "TX", "county" : "WHEELER" },
            "79080": { "city" : "SKELLYTOWN", "state" : "TX", "county" : "CARSON" },
            "79081": { "city" : "SPEARMAN", "state" : "TX", "county" : "HANSFORD" },
            "79082": { "city" : "SPRINGLAKE", "state" : "TX", "county" : "LAMB" },
            "79083": { "city" : "STINNETT", "state" : "TX", "county" : "HUTCHINSON" },
            "79084": { "city" : "STRATFORD", "state" : "TX", "county" : "SHERMAN" },
            "79085": { "city" : "SUMMERFIELD", "state" : "TX", "county" : "CASTRO" },
            "79086": { "city" : "SUNRAY", "state" : "TX", "county" : "MOORE" },"79087": { "city" : "TEXLINE", "state" : "TX", "county" : "DALLAM" },
            "79088": { "city" : "TULIA", "state" : "TX", "county" : "SWISHER" },"79091": { "city" : "UMBARGER", "state" : "TX", "county" : "RANDALL" },
            "79092": { "city" : "VEGA", "state" : "TX", "county" : "OLDHAM" },"79093": { "city" : "WAKA", "state" : "TX", "county" : "OCHILTREE" },
            "79094": { "city" : "WAYSIDE", "state" : "TX", "county" : "ARMSTRONG" },
            "79095": { "city" : "WELLINGTON", "state" : "TX", "county" : "COLLINGSWORTH" },
            "79096": { "city" : "WHEELER", "state" : "TX", "county" : "WHEELER" },
            "79097": { "city" : "WHITE DEER", "state" : "TX", "county" : "CARSON" },
            "79098": { "city" : "WILDORADO", "state" : "TX", "county" : "OLDHAM" },
            "79101": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79102": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79103": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79104": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79105": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79106": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79107": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79108": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79109": { "city" : "AMARILLO", "state" : "TX", "county" : "RANDALL" },
            "79110": { "city" : "AMARILLO", "state" : "TX", "county" : "RANDALL" },
            "79111": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79114": { "city" : "AMARILLO", "state" : "TX", "county" : "RANDALL" },
            "79116": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79117": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79118": { "city" : "AMARILLO", "state" : "TX", "county" : "RANDALL" },
            "79119": { "city" : "AMARILLO", "state" : "TX", "county" : "RANDALL" },
            "79120": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79121": { "city" : "AMARILLO", "state" : "TX", "county" : "RANDALL" },
            "79124": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79159": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79172": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79178": { "city" : "AMARILLO", "state" : "TX", "county" : "POTTER" },
            "79201": { "city" : "CHILDRESS", "state" : "TX", "county" : "CHILDRESS" },
            "79220": { "city" : "AFTON", "state" : "TX", "county" : "DICKENS" },"79221": { "city" : "AIKEN", "state" : "TX", "county" : "FLOYD" },
            "79225": { "city" : "CHILLICOTHE", "state" : "TX", "county" : "HARDEMAN" },
            "79226": { "city" : "CLARENDON", "state" : "TX", "county" : "DONLEY" },
            "79227": { "city" : "CROWELL", "state" : "TX", "county" : "FOARD" },"79229": { "city" : "DICKENS", "state" : "TX", "county" : "DICKENS" },
            "79230": { "city" : "DODSON", "state" : "TX", "county" : "COLLINGSWORTH" },
            "79231": { "city" : "DOUGHERTY", "state" : "TX", "county" : "FLOYD" },
            "79233": { "city" : "ESTELLINE", "state" : "TX", "county" : "HALL" },
            "79234": { "city" : "FLOMOT", "state" : "TX", "county" : "MOTLEY" },"79235": { "city" : "FLOYDADA", "state" : "TX", "county" : "FLOYD" },
            "79237": { "city" : "HEDLEY", "state" : "TX", "county" : "DONLEY" },"79239": { "city" : "LAKEVIEW", "state" : "TX", "county" : "HALL" },
            "79240": { "city" : "LELIA LAKE", "state" : "TX", "county" : "DONLEY" },
            "79241": { "city" : "LOCKNEY", "state" : "TX", "county" : "FLOYD" },"79243": { "city" : "MCADOO", "state" : "TX", "county" : "DICKENS" },
            "79244": { "city" : "MATADOR", "state" : "TX", "county" : "MOTLEY" },
            "79245": { "city" : "MEMPHIS", "state" : "TX", "county" : "HALL" },"79248": { "city" : "PADUCAH", "state" : "TX", "county" : "COTTLE" },
            "79250": { "city" : "PETERSBURG", "state" : "TX", "county" : "HALE" },
            "79251": { "city" : "QUAIL", "state" : "TX", "county" : "COLLINGSWORTH" },
            "79252": { "city" : "QUANAH", "state" : "TX", "county" : "HARDEMAN" },
            "79255": { "city" : "QUITAQUE", "state" : "TX", "county" : "BRISCOE" },
            "79256": { "city" : "ROARING SPRINGS", "state" : "TX", "county" : "MOTLEY" },
            "79257": { "city" : "SILVERTON", "state" : "TX", "county" : "BRISCOE" },
            "79258": { "city" : "SOUTH PLAINS", "state" : "TX", "county" : "FLOYD" },
            "79261": { "city" : "TURKEY", "state" : "TX", "county" : "HALL" },"79311": { "city" : "ABERNATHY", "state" : "TX", "county" : "HALE" },
            "79312": { "city" : "AMHERST", "state" : "TX", "county" : "LAMB" },"79313": { "city" : "ANTON", "state" : "TX", "county" : "HOCKLEY" },
            "79314": { "city" : "BLEDSOE", "state" : "TX", "county" : "COCHRAN" },
            "79316": { "city" : "BROWNFIELD", "state" : "TX", "county" : "TERRY" },
            "79322": { "city" : "CROSBYTON", "state" : "TX", "county" : "CROSBY" },
            "79323": { "city" : "DENVER CITY", "state" : "TX", "county" : "YOAKUM" },
            "79325": { "city" : "FARWELL", "state" : "TX", "county" : "PARMER" },
            "79326": { "city" : "FIELDTON", "state" : "TX", "county" : "LAMB" },"79329": { "city" : "IDALOU", "state" : "TX", "county" : "LUBBOCK" },
            "79330": { "city" : "JUSTICEBURG", "state" : "TX", "county" : "GARZA" },
            "79331": { "city" : "LAMESA", "state" : "TX", "county" : "DAWSON" },"79336": { "city" : "LEVELLAND", "state" : "TX", "county" : "HOCKLEY" },
            "79338": { "city" : "LEVELLAND", "state" : "TX", "county" : "HOCKLEY" },
            "79339": { "city" : "LITTLEFIELD", "state" : "TX", "county" : "LAMB" },
            "79342": { "city" : "LOOP", "state" : "TX", "county" : "GAINES" },"79343": { "city" : "LORENZO", "state" : "TX", "county" : "CROSBY" },
            "79345": { "city" : "MEADOW", "state" : "TX", "county" : "TERRY" },"79346": { "city" : "MORTON", "state" : "TX", "county" : "COCHRAN" },
            "79347": { "city" : "MULESHOE", "state" : "TX", "county" : "BAILEY" },
            "79350": { "city" : "NEW DEAL", "state" : "TX", "county" : "LUBBOCK" },
            "79351": { "city" : "ODONNELL", "state" : "TX", "county" : "LYNN" },"79355": { "city" : "PLAINS", "state" : "TX", "county" : "YOAKUM" },
            "79356": { "city" : "POST", "state" : "TX", "county" : "GARZA" },"79357": { "city" : "RALLS", "state" : "TX", "county" : "CROSBY" },
            "79358": { "city" : "ROPESVILLE", "state" : "TX", "county" : "HOCKLEY" },
            "79359": { "city" : "SEAGRAVES", "state" : "TX", "county" : "GAINES" },
            "79360": { "city" : "SEMINOLE", "state" : "TX", "county" : "GAINES" },
            "79363": { "city" : "SHALLOWATER", "state" : "TX", "county" : "LUBBOCK" },
            "79364": { "city" : "SLATON", "state" : "TX", "county" : "LUBBOCK" },
            "79366": { "city" : "RANSOM CANYON", "state" : "TX", "county" : "LUBBOCK" },
            "79367": { "city" : "SMYER", "state" : "TX", "county" : "HOCKLEY" },"79369": { "city" : "SPADE", "state" : "TX", "county" : "LAMB" },
            "79370": { "city" : "SPUR", "state" : "TX", "county" : "DICKENS" },"79371": { "city" : "SUDAN", "state" : "TX", "county" : "LAMB" },
            "79372": { "city" : "SUNDOWN", "state" : "TX", "county" : "HOCKLEY" },
            "79373": { "city" : "TAHOKA", "state" : "TX", "county" : "LYNN" },"79377": { "city" : "WELCH", "state" : "TX", "county" : "DAWSON" },
            "79378": { "city" : "WELLMAN", "state" : "TX", "county" : "TERRY" },"79379": { "city" : "WHITEFACE", "state" : "TX", "county" : "COCHRAN" },
            "79380": { "city" : "WHITHARRAL", "state" : "TX", "county" : "HOCKLEY" },
            "79381": { "city" : "WILSON", "state" : "TX", "county" : "LYNN" },"79382": { "city" : "WOLFFORTH", "state" : "TX", "county" : "LUBBOCK" },
            "79383": { "city" : "NEW HOME", "state" : "TX", "county" : "LYNN" },"79401": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79403": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79404": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79405": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79406": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79407": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79408": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79409": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79410": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79411": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79412": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79413": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79414": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79415": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79416": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79423": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79424": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79430": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79452": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79453": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79464": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79490": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79493": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79499": { "city" : "LUBBOCK", "state" : "TX", "county" : "LUBBOCK" },
            "79501": { "city" : "ANSON", "state" : "TX", "county" : "JONES" },"79502": { "city" : "ASPERMONT", "state" : "TX", "county" : "STONEWALL" },
            "79503": { "city" : "AVOCA", "state" : "TX", "county" : "JONES" },"79504": { "city" : "BAIRD", "state" : "TX", "county" : "CALLAHAN" },
            "79505": { "city" : "BENJAMIN", "state" : "TX", "county" : "KNOX" },"79506": { "city" : "BLACKWELL", "state" : "TX", "county" : "NOLAN" },
            "79508": { "city" : "BUFFALO GAP", "state" : "TX", "county" : "TAYLOR" },
            "79510": { "city" : "CLYDE", "state" : "TX", "county" : "CALLAHAN" },
            "79511": { "city" : "COAHOMA", "state" : "TX", "county" : "HOWARD" },
            "79512": { "city" : "COLORADO CITY", "state" : "TX", "county" : "MITCHELL" },
            "79517": { "city" : "FLUVANNA", "state" : "TX", "county" : "SCURRY" },
            "79519": { "city" : "GOLDSBORO", "state" : "TX", "county" : "COLEMAN" },
            "79520": { "city" : "HAMLIN", "state" : "TX", "county" : "JONES" },"79521": { "city" : "HASKELL", "state" : "TX", "county" : "HASKELL" },
            "79525": { "city" : "HAWLEY", "state" : "TX", "county" : "JONES" },"79526": { "city" : "HERMLEIGH", "state" : "TX", "county" : "SCURRY" },
            "79527": { "city" : "IRA", "state" : "TX", "county" : "SCURRY" },"79528": { "city" : "JAYTON", "state" : "TX", "county" : "KENT" },
            "79529": { "city" : "KNOX CITY", "state" : "TX", "county" : "KNOX" },
            "79530": { "city" : "LAWN", "state" : "TX", "county" : "TAYLOR" },"79532": { "city" : "LORAINE", "state" : "TX", "county" : "MITCHELL" },
            "79533": { "city" : "LUEDERS", "state" : "TX", "county" : "JONES" },"79534": { "city" : "MC CAULLEY", "state" : "TX", "county" : "FISHER" },
            "79535": { "city" : "MARYNEAL", "state" : "TX", "county" : "NOLAN" },
            "79536": { "city" : "MERKEL", "state" : "TX", "county" : "TAYLOR" },"79538": { "city" : "NOVICE", "state" : "TX", "county" : "COLEMAN" },
            "79539": { "city" : "O BRIEN", "state" : "TX", "county" : "HASKELL" },
            "79540": { "city" : "OLD GLORY", "state" : "TX", "county" : "STONEWALL" },
            "79541": { "city" : "OVALO", "state" : "TX", "county" : "TAYLOR" },"79543": { "city" : "ROBY", "state" : "TX", "county" : "FISHER" },
            "79544": { "city" : "ROCHESTER", "state" : "TX", "county" : "HASKELL" },
            "79545": { "city" : "ROSCOE", "state" : "TX", "county" : "NOLAN" },"79546": { "city" : "ROTAN", "state" : "TX", "county" : "FISHER" },
            "79547": { "city" : "RULE", "state" : "TX", "county" : "HASKELL" },"79548": { "city" : "RULE", "state" : "TX", "county" : "HASKELL" },
            "79549": { "city" : "SNYDER", "state" : "TX", "county" : "SCURRY" },"79550": { "city" : "SNYDER", "state" : "TX", "county" : "SCURRY" },
            "79553": { "city" : "STAMFORD", "state" : "TX", "county" : "JONES" },
            "79556": { "city" : "SWEETWATER", "state" : "TX", "county" : "NOLAN" },
            "79560": { "city" : "SYLVESTER", "state" : "TX", "county" : "FISHER" },
            "79561": { "city" : "TRENT", "state" : "TX", "county" : "TAYLOR" },"79562": { "city" : "TUSCOLA", "state" : "TX", "county" : "TAYLOR" },
            "79563": { "city" : "TYE", "state" : "TX", "county" : "TAYLOR" },"79565": { "city" : "WESTBROOK", "state" : "TX", "county" : "MITCHELL" },
            "79566": { "city" : "WINGATE", "state" : "TX", "county" : "RUNNELS" },
            "79567": { "city" : "WINTERS", "state" : "TX", "county" : "RUNNELS" },
            "79601": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79602": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79603": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79604": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79605": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79606": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79607": { "city" : "DYESS AFB", "state" : "TX", "county" : "TAYLOR" },
            "79608": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79697": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79698": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79699": { "city" : "ABILENE", "state" : "TX", "county" : "TAYLOR" },
            "79701": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79702": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79703": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79704": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79705": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79706": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79707": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79708": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79710": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79711": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79712": { "city" : "MIDLAND", "state" : "TX", "county" : "MIDLAND" },
            "79713": { "city" : "ACKERLY", "state" : "TX", "county" : "MARTIN" },
            "79714": { "city" : "ANDREWS", "state" : "TX", "county" : "ANDREWS" },
            "79718": { "city" : "BALMORHEA", "state" : "TX", "county" : "REEVES" },
            "79719": { "city" : "BARSTOW", "state" : "TX", "county" : "WARD" },"79720": { "city" : "BIG SPRING", "state" : "TX", "county" : "HOWARD" },
            "79721": { "city" : "BIG SPRING", "state" : "TX", "county" : "HOWARD" },
            "79730": { "city" : "COYANOSA", "state" : "TX", "county" : "PECOS" },
            "79731": { "city" : "CRANE", "state" : "TX", "county" : "CRANE" },"79733": { "city" : "FORSAN", "state" : "TX", "county" : "HOWARD" },
            "79734": { "city" : "FORT DAVIS", "state" : "TX", "county" : "JEFF DAVIS" },
            "79735": { "city" : "FORT STOCKTON", "state" : "TX", "county" : "PECOS" },
            "79738": { "city" : "GAIL", "state" : "TX", "county" : "BORDEN" },"79739": { "city" : "GARDEN CITY", "state" : "TX", "county" : "GLASSCOCK" },
            "79741": { "city" : "GOLDSMITH", "state" : "TX", "county" : "ECTOR" },
            "79742": { "city" : "GRANDFALLS", "state" : "TX", "county" : "WARD" },
            "79743": { "city" : "IMPERIAL", "state" : "TX", "county" : "PECOS" },
            "79744": { "city" : "IRAAN", "state" : "TX", "county" : "PECOS" },"79745": { "city" : "KERMIT", "state" : "TX", "county" : "WINKLER" },
            "79748": { "city" : "KNOTT", "state" : "TX", "county" : "HOWARD" },"79749": { "city" : "LENORAH", "state" : "TX", "county" : "MARTIN" },
            "79752": { "city" : "MC CAMEY", "state" : "TX", "county" : "UPTON" },
            "79754": { "city" : "MENTONE", "state" : "TX", "county" : "LOVING" },
            "79755": { "city" : "MIDKIFF", "state" : "TX", "county" : "UPTON" },"79756": { "city" : "MONAHANS", "state" : "TX", "county" : "WARD" },
            "79758": { "city" : "GARDENDALE", "state" : "TX", "county" : "ECTOR" },
            "79759": { "city" : "NOTREES", "state" : "TX", "county" : "ECTOR" },"79760": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },
            "79761": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },"79762": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },
            "79763": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },"79764": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },
            "79765": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },"79766": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },
            "79768": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },"79769": { "city" : "ODESSA", "state" : "TX", "county" : "ECTOR" },
            "79770": { "city" : "ORLA", "state" : "TX", "county" : "REEVES" },"79772": { "city" : "PECOS", "state" : "TX", "county" : "REEVES" },
            "79776": { "city" : "PENWELL", "state" : "TX", "county" : "ECTOR" },"79777": { "city" : "PYOTE", "state" : "TX", "county" : "WARD" },
            "79778": { "city" : "RANKIN", "state" : "TX", "county" : "UPTON" },"79780": { "city" : "SARAGOSA", "state" : "TX", "county" : "REEVES" },
            "79781": { "city" : "SHEFFIELD", "state" : "TX", "county" : "PECOS" },
            "79782": { "city" : "STANTON", "state" : "TX", "county" : "MARTIN" },
            "79783": { "city" : "TARZAN", "state" : "TX", "county" : "MARTIN" },"79785": { "city" : "TOYAH", "state" : "TX", "county" : "REEVES" },
            "79786": { "city" : "TOYAHVALE", "state" : "TX", "county" : "REEVES" },
            "79788": { "city" : "WICKETT", "state" : "TX", "county" : "WARD" },"79789": { "city" : "WINK", "state" : "TX", "county" : "WINKLER" },
            "79821": { "city" : "ANTHONY", "state" : "TX", "county" : "EL PASO" },
            "79830": { "city" : "ALPINE", "state" : "TX", "county" : "BREWSTER" },
            "79831": { "city" : "ALPINE", "state" : "TX", "county" : "BREWSTER" },
            "79832": { "city" : "ALPINE", "state" : "TX", "county" : "BREWSTER" },
            "79834": { "city" : "BIG BEND NATIONAL PARK", "state" : "TX", "county" : "BREWSTER" },
            "79835": { "city" : "CANUTILLO", "state" : "TX", "county" : "EL PASO" },
            "79836": { "city" : "CLINT", "state" : "TX", "county" : "EL PASO" },"79837": { "city" : "DELL CITY", "state" : "TX", "county" : "HUDSPETH" },
            "79838": { "city" : "FABENS", "state" : "TX", "county" : "EL PASO" },
            "79839": { "city" : "FORT HANCOCK", "state" : "TX", "county" : "HUDSPETH" },
            "79842": { "city" : "MARATHON", "state" : "TX", "county" : "BREWSTER" },
            "79843": { "city" : "MARFA", "state" : "TX", "county" : "PRESIDIO" },
            "79845": { "city" : "PRESIDIO", "state" : "TX", "county" : "PRESIDIO" },
            "79848": { "city" : "SANDERSON", "state" : "TX", "county" : "TERRELL" },
            "79849": { "city" : "SAN ELIZARIO", "state" : "TX", "county" : "EL PASO" },
            "79851": { "city" : "SIERRA BLANCA", "state" : "TX", "county" : "HUDSPETH" },
            "79852": { "city" : "TERLINGUA", "state" : "TX", "county" : "BREWSTER" },
            "79853": { "city" : "TORNILLO", "state" : "TX", "county" : "EL PASO" },
            "79854": { "city" : "VALENTINE", "state" : "TX", "county" : "PRESIDIO" },
            "79855": { "city" : "VAN HORN", "state" : "TX", "county" : "CULBERSON" },
            "79901": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79902": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79903": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79904": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79905": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79906": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79907": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79908": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79910": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79911": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79912": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79913": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79914": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79915": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79916": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79917": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79918": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79920": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79922": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79923": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79924": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79925": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79926": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79927": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79928": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79929": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79930": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79932": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79934": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79935": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79936": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79937": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79938": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79940": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79941": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79945": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79947": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79949": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79951": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79968": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79995": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79996": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79997": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "79998": { "city" : "EL PASO", "state" : "TX", "county" : "EL PASO" },
            "80001": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80002": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80003": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80004": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80005": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80006": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80007": { "city" : "ARVADA", "state" : "CO", "county" : "JEFFERSON" },
            "80010": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80011": { "city" : "AURORA", "state" : "CO", "county" : "ADAMS" },"80012": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80013": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80014": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80015": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80016": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80017": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80018": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80019": { "city" : "AURORA", "state" : "CO", "county" : "ADAMS" },"80020": { "city" : "BROOMFIELD", "state" : "CO", "county" : "BROOMFIELD" },
            "80021": { "city" : "BROOMFIELD", "state" : "CO", "county" : "JEFFERSON" },
            "80022": { "city" : "COMMERCE CITY", "state" : "CO", "county" : "ADAMS" },
            "80023": { "city" : "BROOMFIELD", "state" : "CO", "county" : "BROOMFIELD" },
            "80024": { "city" : "DUPONT", "state" : "CO", "county" : "ADAMS" },"80025": { "city" : "ELDORADO SPRINGS", "state" : "CO", "county" : "BOULDER" },
            "80026": { "city" : "LAFAYETTE", "state" : "CO", "county" : "BOULDER" },
            "80027": { "city" : "LOUISVILLE", "state" : "CO", "county" : "BOULDER" },
            "80028": { "city" : "LOUISVILLE", "state" : "CO", "county" : "BOULDER" },
            "80030": { "city" : "WESTMINSTER", "state" : "CO", "county" : "ADAMS" },
            "80031": { "city" : "WESTMINSTER", "state" : "CO", "county" : "ADAMS" },
            "80033": { "city" : "WHEAT RIDGE", "state" : "CO", "county" : "JEFFERSON" },
            "80034": { "city" : "WHEAT RIDGE", "state" : "CO", "county" : "JEFFERSON" },
            "80035": { "city" : "WESTMINSTER", "state" : "CO", "county" : "ADAMS" },
            "80036": { "city" : "WESTMINSTER", "state" : "CO", "county" : "ADAMS" },
            "80037": { "city" : "COMMERCE CITY", "state" : "CO", "county" : "ADAMS" },
            "80038": { "city" : "BROOMFIELD", "state" : "CO", "county" : "BROOMFIELD" },
            "80040": { "city" : "AURORA", "state" : "CO", "county" : "ADAMS" },"80041": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80042": { "city" : "AURORA", "state" : "CO", "county" : "ADAMS" },"80044": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80045": { "city" : "AURORA", "state" : "CO", "county" : "ADAMS" },"80046": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80047": { "city" : "AURORA", "state" : "CO", "county" : "ARAPAHOE" },
            "80101": { "city" : "AGATE", "state" : "CO", "county" : "ELBERT" },"80102": { "city" : "BENNETT", "state" : "CO", "county" : "ADAMS" },
            "80103": { "city" : "BYERS", "state" : "CO", "county" : "ARAPAHOE" },
            "80104": { "city" : "CASTLE ROCK", "state" : "CO", "county" : "DOUGLAS" },
            "80105": { "city" : "DEER TRAIL", "state" : "CO", "county" : "ARAPAHOE" },
            "80106": { "city" : "ELBERT", "state" : "CO", "county" : "EL PASO" },
            "80107": { "city" : "ELIZABETH", "state" : "CO", "county" : "ELBERT" },
            "80108": { "city" : "CASTLE ROCK", "state" : "CO", "county" : "DOUGLAS" },
            "80109": { "city" : "CASTLE ROCK", "state" : "CO", "county" : "DOUGLAS" },
            "80110": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80111": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80112": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80113": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80116": { "city" : "FRANKTOWN", "state" : "CO", "county" : "DOUGLAS" },
            "80117": { "city" : "KIOWA", "state" : "CO", "county" : "ELBERT" },"80118": { "city" : "LARKSPUR", "state" : "CO", "county" : "DOUGLAS" },
            "80120": { "city" : "LITTLETON", "state" : "CO", "county" : "ARAPAHOE" },
            "80121": { "city" : "LITTLETON", "state" : "CO", "county" : "ARAPAHOE" },
            "80122": { "city" : "LITTLETON", "state" : "CO", "county" : "ARAPAHOE" },
            "80123": { "city" : "LITTLETON", "state" : "CO", "county" : "JEFFERSON" },
            "80124": { "city" : "LONE TREE", "state" : "CO", "county" : "DOUGLAS" },
            "80125": { "city" : "LITTLETON", "state" : "CO", "county" : "DOUGLAS" },
            "80126": { "city" : "LITTLETON", "state" : "CO", "county" : "DOUGLAS" },
            "80127": { "city" : "LITTLETON", "state" : "CO", "county" : "JEFFERSON" },
            "80128": { "city" : "LITTLETON", "state" : "CO", "county" : "JEFFERSON" },
            "80129": { "city" : "LITTLETON", "state" : "CO", "county" : "DOUGLAS" },
            "80130": { "city" : "LITTLETON", "state" : "CO", "county" : "DOUGLAS" },
            "80131": { "city" : "LOUVIERS", "state" : "CO", "county" : "DOUGLAS" },
            "80132": { "city" : "MONUMENT", "state" : "CO", "county" : "EL PASO" },
            "80133": { "city" : "PALMER LAKE", "state" : "CO", "county" : "EL PASO" },
            "80134": { "city" : "PARKER", "state" : "CO", "county" : "DOUGLAS" },
            "80135": { "city" : "SEDALIA", "state" : "CO", "county" : "DOUGLAS" },
            "80136": { "city" : "STRASBURG", "state" : "CO", "county" : "ADAMS" },
            "80137": { "city" : "WATKINS", "state" : "CO", "county" : "ADAMS" },"80138": { "city" : "PARKER", "state" : "CO", "county" : "DOUGLAS" },
            "80150": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80151": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80155": { "city" : "ENGLEWOOD", "state" : "CO", "county" : "ARAPAHOE" },
            "80160": { "city" : "LITTLETON", "state" : "CO", "county" : "ARAPAHOE" },
            "80161": { "city" : "LITTLETON", "state" : "CO", "county" : "ARAPAHOE" },
            "80162": { "city" : "LITTLETON", "state" : "CO", "county" : "JEFFERSON" },
            "80163": { "city" : "LITTLETON", "state" : "CO", "county" : "DOUGLAS" },
            "80201": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80202": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80203": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80204": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80205": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80206": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80207": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80208": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80209": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80210": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80211": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80212": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80214": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80215": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80216": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80217": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80218": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80219": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80220": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80221": { "city" : "DENVER", "state" : "CO", "county" : "ADAMS" },
            "80222": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80223": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80224": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80225": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80226": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80227": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80228": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80229": { "city" : "DENVER", "state" : "CO", "county" : "ADAMS" },"80230": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80231": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80232": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80233": { "city" : "DENVER", "state" : "CO", "county" : "ADAMS" },"80234": { "city" : "DENVER", "state" : "CO", "county" : "ADAMS" },
            "80235": { "city" : "DENVER", "state" : "CO", "county" : "JEFFERSON" },
            "80236": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80237": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80238": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80239": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80241": { "city" : "DENVER", "state" : "CO", "county" : "ADAMS" },"80246": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80247": { "city" : "DENVER", "state" : "CO", "county" : "ARAPAHOE" },
            "80248": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80249": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80250": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80251": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80252": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80257": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80260": { "city" : "DENVER", "state" : "CO", "county" : "ADAMS" },"80261": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80262": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80263": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80264": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80265": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80266": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80273": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80274": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80279": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80280": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80290": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80291": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80293": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80294": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80295": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },
            "80299": { "city" : "DENVER", "state" : "CO", "county" : "DENVER" },"80301": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80302": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80303": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80304": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80305": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80306": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80307": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80308": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80309": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80310": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80314": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80321": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80322": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80323": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80328": { "city" : "BOULDER", "state" : "CO", "county" : "BOULDER" },
            "80401": { "city" : "GOLDEN", "state" : "CO", "county" : "JEFFERSON" },
            "80402": { "city" : "GOLDEN", "state" : "CO", "county" : "JEFFERSON" },
            "80403": { "city" : "GOLDEN", "state" : "CO", "county" : "JEFFERSON" },
            "80419": { "city" : "GOLDEN", "state" : "CO", "county" : "JEFFERSON" },
            "80420": { "city" : "ALMA", "state" : "CO", "county" : "PARK" },"80421": { "city" : "BAILEY", "state" : "CO", "county" : "PARK" },
            "80422": { "city" : "BLACK HAWK", "state" : "CO", "county" : "GILPIN" },
            "80423": { "city" : "BOND", "state" : "CO", "county" : "EAGLE" },"80424": { "city" : "BRECKENRIDGE", "state" : "CO", "county" : "SUMMIT" },
            "80425": { "city" : "BUFFALO CREEK", "state" : "CO", "county" : "JEFFERSON" },
            "80426": { "city" : "BURNS", "state" : "CO", "county" : "EAGLE" },"80427": { "city" : "CENTRAL CITY", "state" : "CO", "county" : "GILPIN" },
            "80428": { "city" : "CLARK", "state" : "CO", "county" : "ROUTT" },"80429": { "city" : "CLIMAX", "state" : "CO", "county" : "LAKE" },
            "80430": { "city" : "COALMONT", "state" : "CO", "county" : "JACKSON" },
            "80432": { "city" : "COMO", "state" : "CO", "county" : "PARK" },"80433": { "city" : "CONIFER", "state" : "CO", "county" : "JEFFERSON" },
            "80434": { "city" : "COWDREY", "state" : "CO", "county" : "JACKSON" },
            "80435": { "city" : "DILLON", "state" : "CO", "county" : "SUMMIT" },"80436": { "city" : "DUMONT", "state" : "CO", "county" : "CLEAR CREEK" },
            "80437": { "city" : "EVERGREEN", "state" : "CO", "county" : "JEFFERSON" },
            "80438": { "city" : "EMPIRE", "state" : "CO", "county" : "CLEAR CREEK" },
            "80439": { "city" : "EVERGREEN", "state" : "CO", "county" : "JEFFERSON" },
            "80440": { "city" : "FAIRPLAY", "state" : "CO", "county" : "PARK" },"80442": { "city" : "FRASER", "state" : "CO", "county" : "GRAND" },
            "80443": { "city" : "FRISCO", "state" : "CO", "county" : "SUMMIT" },"80444": { "city" : "GEORGETOWN", "state" : "CO", "county" : "CLEAR CREEK" },
            "80446": { "city" : "GRANBY", "state" : "CO", "county" : "GRAND" },"80447": { "city" : "GRAND LAKE", "state" : "CO", "county" : "GRAND" },
            "80448": { "city" : "GRANT", "state" : "CO", "county" : "PARK" },"80449": { "city" : "HARTSEL", "state" : "CO", "county" : "PARK" },
            "80451": { "city" : "HOT SULPHUR SPRINGS", "state" : "CO", "county" : "GRAND" },
            "80452": { "city" : "IDAHO SPRINGS", "state" : "CO", "county" : "CLEAR CREEK" },
            "80453": { "city" : "IDLEDALE", "state" : "CO", "county" : "JEFFERSON" },
            "80454": { "city" : "INDIAN HILLS", "state" : "CO", "county" : "JEFFERSON" },
            "80455": { "city" : "JAMESTOWN", "state" : "CO", "county" : "BOULDER" },
            "80456": { "city" : "JEFFERSON", "state" : "CO", "county" : "PARK" },
            "80457": { "city" : "KITTREDGE", "state" : "CO", "county" : "JEFFERSON" },
            "80459": { "city" : "KREMMLING", "state" : "CO", "county" : "GRAND" },
            "80461": { "city" : "LEADVILLE", "state" : "CO", "county" : "LAKE" },
            "80463": { "city" : "MC COY", "state" : "CO", "county" : "EAGLE" },"80465": { "city" : "MORRISON", "state" : "CO", "county" : "JEFFERSON" },
            "80466": { "city" : "NEDERLAND", "state" : "CO", "county" : "BOULDER" },
            "80467": { "city" : "OAK CREEK", "state" : "CO", "county" : "ROUTT" },
            "80468": { "city" : "PARSHALL", "state" : "CO", "county" : "GRAND" },
            "80469": { "city" : "PHIPPSBURG", "state" : "CO", "county" : "ROUTT" },
            "80470": { "city" : "PINE", "state" : "CO", "county" : "JEFFERSON" },
            "80471": { "city" : "PINECLIFFE", "state" : "CO", "county" : "BOULDER" },
            "80473": { "city" : "RAND", "state" : "CO", "county" : "JACKSON" },"80474": { "city" : "ROLLINSVILLE", "state" : "CO", "county" : "GILPIN" },
            "80475": { "city" : "SHAWNEE", "state" : "CO", "county" : "PARK" },"80476": { "city" : "SILVER PLUME", "state" : "CO", "county" : "CLEAR CREEK" },
            "80477": { "city" : "STEAMBOAT SPRINGS", "state" : "CO", "county" : "ROUTT" },
            "80478": { "city" : "TABERNASH", "state" : "CO", "county" : "GRAND" },
            "80479": { "city" : "TOPONAS", "state" : "CO", "county" : "ROUTT" },"80480": { "city" : "WALDEN", "state" : "CO", "county" : "JACKSON" },
            "80481": { "city" : "WARD", "state" : "CO", "county" : "BOULDER" },"80482": { "city" : "WINTER PARK", "state" : "CO", "county" : "GRAND" },
            "80483": { "city" : "YAMPA", "state" : "CO", "county" : "ROUTT" },"80487": { "city" : "STEAMBOAT SPRINGS", "state" : "CO", "county" : "ROUTT" },
            "80488": { "city" : "STEAMBOAT SPRINGS", "state" : "CO", "county" : "ROUTT" },
            "80497": { "city" : "SILVERTHORNE", "state" : "CO", "county" : "SUMMIT" },
            "80498": { "city" : "SILVERTHORNE", "state" : "CO", "county" : "SUMMIT" },
            "80501": { "city" : "LONGMONT", "state" : "CO", "county" : "BOULDER" },
            "80502": { "city" : "LONGMONT", "state" : "CO", "county" : "BOULDER" },
            "80503": { "city" : "LONGMONT", "state" : "CO", "county" : "BOULDER" },
            "80504": { "city" : "LONGMONT", "state" : "CO", "county" : "WELD" },"80510": { "city" : "ALLENSPARK", "state" : "CO", "county" : "BOULDER" },
            "80511": { "city" : "ESTES PARK", "state" : "CO", "county" : "LARIMER" },
            "80512": { "city" : "BELLVUE", "state" : "CO", "county" : "LARIMER" },
            "80513": { "city" : "BERTHOUD", "state" : "CO", "county" : "LARIMER" },
            "80514": { "city" : "DACONO", "state" : "CO", "county" : "WELD" },"80515": { "city" : "DRAKE", "state" : "CO", "county" : "LARIMER" },
            "80516": { "city" : "ERIE", "state" : "CO", "county" : "BOULDER" },"80517": { "city" : "ESTES PARK", "state" : "CO", "county" : "LARIMER" },
            "80520": { "city" : "FIRESTONE", "state" : "CO", "county" : "WELD" },
            "80521": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80522": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80523": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80524": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80525": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80526": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80527": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80528": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80530": { "city" : "FREDERICK", "state" : "CO", "county" : "WELD" },
            "80532": { "city" : "GLEN HAVEN", "state" : "CO", "county" : "LARIMER" },
            "80533": { "city" : "HYGIENE", "state" : "CO", "county" : "BOULDER" },
            "80534": { "city" : "JOHNSTOWN", "state" : "CO", "county" : "WELD" },
            "80535": { "city" : "LAPORTE", "state" : "CO", "county" : "LARIMER" },
            "80536": { "city" : "LIVERMORE", "state" : "CO", "county" : "LARIMER" },
            "80537": { "city" : "LOVELAND", "state" : "CO", "county" : "LARIMER" },
            "80538": { "city" : "LOVELAND", "state" : "CO", "county" : "LARIMER" },
            "80539": { "city" : "LOVELAND", "state" : "CO", "county" : "LARIMER" },
            "80540": { "city" : "LYONS", "state" : "CO", "county" : "BOULDER" },"80541": { "city" : "MASONVILLE", "state" : "CO", "county" : "LARIMER" },
            "80542": { "city" : "MEAD", "state" : "CO", "county" : "WELD" },"80543": { "city" : "MILLIKEN", "state" : "CO", "county" : "WELD" },
            "80544": { "city" : "NIWOT", "state" : "CO", "county" : "BOULDER" },"80545": { "city" : "RED FEATHER LAKES", "state" : "CO", "county" : "LARIMER" },
            "80546": { "city" : "SEVERANCE", "state" : "CO", "county" : "WELD" },
            "80547": { "city" : "TIMNATH", "state" : "CO", "county" : "LARIMER" },
            "80549": { "city" : "WELLINGTON", "state" : "CO", "county" : "LARIMER" },
            "80550": { "city" : "WINDSOR", "state" : "CO", "county" : "WELD" },"80551": { "city" : "WINDSOR", "state" : "CO", "county" : "WELD" },
            "80553": { "city" : "FORT COLLINS", "state" : "CO", "county" : "LARIMER" },
            "80601": { "city" : "BRIGHTON", "state" : "CO", "county" : "ADAMS" },
            "80602": { "city" : "BRIGHTON", "state" : "CO", "county" : "ADAMS" },
            "80603": { "city" : "BRIGHTON", "state" : "CO", "county" : "WELD" },"80610": { "city" : "AULT", "state" : "CO", "county" : "WELD" },
            "80611": { "city" : "BRIGGSDALE", "state" : "CO", "county" : "WELD" },
            "80612": { "city" : "CARR", "state" : "CO", "county" : "WELD" },"80614": { "city" : "EASTLAKE", "state" : "CO", "county" : "ADAMS" },
            "80615": { "city" : "EATON", "state" : "CO", "county" : "WELD" },"80620": { "city" : "EVANS", "state" : "CO", "county" : "WELD" },
            "80621": { "city" : "FORT LUPTON", "state" : "CO", "county" : "WELD" },
            "80622": { "city" : "GALETON", "state" : "CO", "county" : "WELD" },"80623": { "city" : "GILCREST", "state" : "CO", "county" : "WELD" },
            "80624": { "city" : "GILL", "state" : "CO", "county" : "WELD" },"80631": { "city" : "GREELEY", "state" : "CO", "county" : "WELD" },
            "80632": { "city" : "GREELEY", "state" : "CO", "county" : "WELD" },"80633": { "city" : "GREELEY", "state" : "CO", "county" : "WELD" },
            "80634": { "city" : "GREELEY", "state" : "CO", "county" : "WELD" },"80638": { "city" : "GREELEY", "state" : "CO", "county" : "WELD" },
            "80639": { "city" : "GREELEY", "state" : "CO", "county" : "WELD" },"80640": { "city" : "HENDERSON", "state" : "CO", "county" : "ADAMS" },
            "80642": { "city" : "HUDSON", "state" : "CO", "county" : "WELD" },"80643": { "city" : "KEENESBURG", "state" : "CO", "county" : "WELD" },
            "80644": { "city" : "KERSEY", "state" : "CO", "county" : "WELD" },"80645": { "city" : "LA SALLE", "state" : "CO", "county" : "WELD" },
            "80646": { "city" : "LUCERNE", "state" : "CO", "county" : "WELD" },"80648": { "city" : "NUNN", "state" : "CO", "county" : "WELD" },
            "80649": { "city" : "ORCHARD", "state" : "CO", "county" : "MORGAN" },
            "80650": { "city" : "PIERCE", "state" : "CO", "county" : "WELD" },"80651": { "city" : "PLATTEVILLE", "state" : "CO", "county" : "WELD" },
            "80652": { "city" : "ROGGEN", "state" : "CO", "county" : "WELD" },"80653": { "city" : "WELDONA", "state" : "CO", "county" : "MORGAN" },
            "80654": { "city" : "WIGGINS", "state" : "CO", "county" : "MORGAN" },
            "80701": { "city" : "FORT MORGAN", "state" : "CO", "county" : "MORGAN" },
            "80705": { "city" : "LOG LANE VILLAGE", "state" : "CO", "county" : "MORGAN" },
            "80720": { "city" : "AKRON", "state" : "CO", "county" : "WASHINGTON" },
            "80721": { "city" : "AMHERST", "state" : "CO", "county" : "PHILLIPS" },
            "80722": { "city" : "ATWOOD", "state" : "CO", "county" : "LOGAN" },"80723": { "city" : "BRUSH", "state" : "CO", "county" : "MORGAN" },
            "80726": { "city" : "CROOK", "state" : "CO", "county" : "LOGAN" },"80727": { "city" : "ECKLEY", "state" : "CO", "county" : "YUMA" },
            "80728": { "city" : "FLEMING", "state" : "CO", "county" : "LOGAN" },"80729": { "city" : "GROVER", "state" : "CO", "county" : "WELD" },
            "80731": { "city" : "HAXTUN", "state" : "CO", "county" : "PHILLIPS" },
            "80732": { "city" : "HEREFORD", "state" : "CO", "county" : "WELD" },"80733": { "city" : "HILLROSE", "state" : "CO", "county" : "MORGAN" },
            "80734": { "city" : "HOLYOKE", "state" : "CO", "county" : "PHILLIPS" },
            "80735": { "city" : "IDALIA", "state" : "CO", "county" : "YUMA" },"80736": { "city" : "ILIFF", "state" : "CO", "county" : "LOGAN" },
            "80737": { "city" : "JULESBURG", "state" : "CO", "county" : "SEDGWICK" },
            "80740": { "city" : "LINDON", "state" : "CO", "county" : "WASHINGTON" },
            "80741": { "city" : "MERINO", "state" : "CO", "county" : "LOGAN" },"80742": { "city" : "NEW RAYMER", "state" : "CO", "county" : "WELD" },
            "80743": { "city" : "OTIS", "state" : "CO", "county" : "WASHINGTON" },
            "80744": { "city" : "OVID", "state" : "CO", "county" : "SEDGWICK" },"80745": { "city" : "PADRONI", "state" : "CO", "county" : "LOGAN" },
            "80746": { "city" : "PAOLI", "state" : "CO", "county" : "PHILLIPS" },
            "80747": { "city" : "PEETZ", "state" : "CO", "county" : "LOGAN" },"80749": { "city" : "SEDGWICK", "state" : "CO", "county" : "SEDGWICK" },
            "80750": { "city" : "SNYDER", "state" : "CO", "county" : "MORGAN" },"80751": { "city" : "STERLING", "state" : "CO", "county" : "LOGAN" },
            "80754": { "city" : "STONEHAM", "state" : "CO", "county" : "WELD" },"80755": { "city" : "VERNON", "state" : "CO", "county" : "YUMA" },
            "80757": { "city" : "WOODROW", "state" : "CO", "county" : "WASHINGTON" },
            "80758": { "city" : "WRAY", "state" : "CO", "county" : "YUMA" },"80759": { "city" : "YUMA", "state" : "CO", "county" : "YUMA" },
            "80801": { "city" : "ANTON", "state" : "CO", "county" : "WASHINGTON" },
            "80802": { "city" : "ARAPAHOE", "state" : "CO", "county" : "CHEYENNE" },
            "80804": { "city" : "ARRIBA", "state" : "CO", "county" : "LINCOLN" },
            "80805": { "city" : "BETHUNE", "state" : "CO", "county" : "KIT CARSON" },
            "80807": { "city" : "BURLINGTON", "state" : "CO", "county" : "KIT CARSON" },
            "80808": { "city" : "CALHAN", "state" : "CO", "county" : "EL PASO" },
            "80809": { "city" : "CASCADE", "state" : "CO", "county" : "EL PASO" },
            "80810": { "city" : "CHEYENNE WELLS", "state" : "CO", "county" : "CHEYENNE" },
            "80812": { "city" : "COPE", "state" : "CO", "county" : "WASHINGTON" },
            "80813": { "city" : "CRIPPLE CREEK", "state" : "CO", "county" : "TELLER" },
            "80814": { "city" : "DIVIDE", "state" : "CO", "county" : "TELLER" },"80815": { "city" : "FLAGLER", "state" : "CO", "county" : "KIT CARSON" },
            "80816": { "city" : "FLORISSANT", "state" : "CO", "county" : "TELLER" },
            "80817": { "city" : "FOUNTAIN", "state" : "CO", "county" : "EL PASO" },
            "80818": { "city" : "GENOA", "state" : "CO", "county" : "LINCOLN" },"80819": { "city" : "GREEN MOUNTAIN FALLS", "state" : "CO", "county" : "EL PASO" },
            "80820": { "city" : "GUFFEY", "state" : "CO", "county" : "PARK" },"80821": { "city" : "HUGO", "state" : "CO", "county" : "LINCOLN" },
            "80822": { "city" : "JOES", "state" : "CO", "county" : "YUMA" },"80824": { "city" : "KIRK", "state" : "CO", "county" : "YUMA" },
            "80825": { "city" : "KIT CARSON", "state" : "CO", "county" : "CHEYENNE" },
            "80827": { "city" : "LAKE GEORGE", "state" : "CO", "county" : "PARK" },
            "80828": { "city" : "LIMON", "state" : "CO", "county" : "LINCOLN" },"80829": { "city" : "MANITOU SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80830": { "city" : "MATHESON", "state" : "CO", "county" : "ELBERT" },
            "80831": { "city" : "PEYTON", "state" : "CO", "county" : "EL PASO" },
            "80832": { "city" : "RAMAH", "state" : "CO", "county" : "EL PASO" },"80833": { "city" : "RUSH", "state" : "CO", "county" : "EL PASO" },
            "80834": { "city" : "SEIBERT", "state" : "CO", "county" : "KIT CARSON" },
            "80835": { "city" : "SIMLA", "state" : "CO", "county" : "ELBERT" },"80836": { "city" : "STRATTON", "state" : "CO", "county" : "KIT CARSON" },
            "80840": { "city" : "U S A F ACADEMY", "state" : "CO", "county" : "EL PASO" },
            "80841": { "city" : "U S A F ACADEMY", "state" : "CO", "county" : "EL PASO" },
            "80860": { "city" : "VICTOR", "state" : "CO", "county" : "TELLER" },"80861": { "city" : "VONA", "state" : "CO", "county" : "KIT CARSON" },
            "80863": { "city" : "WOODLAND PARK", "state" : "CO", "county" : "TELLER" },
            "80864": { "city" : "YODER", "state" : "CO", "county" : "EL PASO" },"80866": { "city" : "WOODLAND PARK", "state" : "CO", "county" : "TELLER" },
            "80901": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80902": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80903": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80904": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80905": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80906": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80907": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80908": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80909": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80910": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80911": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80912": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80913": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80914": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80915": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80916": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80917": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80918": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80919": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80920": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80921": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80922": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80923": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80924": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80925": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80926": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80927": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80928": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80929": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80930": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80931": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80932": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80933": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80934": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80935": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80936": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80937": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80939": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80940": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80946": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80947": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80949": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80951": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80960": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80962": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "80970": { "city" : "COLORADO SPRINGS", "state" : "CO", "county" : "EL PASO" },
            "81001": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },"81002": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },
            "81003": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },"81004": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },
            "81005": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },"81006": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },
            "81007": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },"81008": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },
            "81011": { "city" : "PUEBLO", "state" : "CO", "county" : "PUEBLO" },"81019": { "city" : "COLORADO CITY", "state" : "CO", "county" : "PUEBLO" },
            "81020": { "city" : "AGUILAR", "state" : "CO", "county" : "LAS ANIMAS" },
            "81022": { "city" : "AVONDALE", "state" : "CO", "county" : "PUEBLO" },
            "81023": { "city" : "BEULAH", "state" : "CO", "county" : "PUEBLO" },"81024": { "city" : "BONCARBO", "state" : "CO", "county" : "LAS ANIMAS" },
            "81025": { "city" : "BOONE", "state" : "CO", "county" : "PUEBLO" },"81027": { "city" : "BRANSON", "state" : "CO", "county" : "LAS ANIMAS" },
            "81029": { "city" : "CAMPO", "state" : "CO", "county" : "BACA" },"81030": { "city" : "CHERAW", "state" : "CO", "county" : "OTERO" },
            "81033": { "city" : "CROWLEY", "state" : "CO", "county" : "CROWLEY" },
            "81036": { "city" : "EADS", "state" : "CO", "county" : "KIOWA" },"81039": { "city" : "FOWLER", "state" : "CO", "county" : "OTERO" },
            "81040": { "city" : "GARDNER", "state" : "CO", "county" : "HUERFANO" },
            "81041": { "city" : "GRANADA", "state" : "CO", "county" : "PROWERS" },
            "81044": { "city" : "HASTY", "state" : "CO", "county" : "BENT" },"81045": { "city" : "HASWELL", "state" : "CO", "county" : "KIOWA" },
            "81046": { "city" : "HOEHNE", "state" : "CO", "county" : "LAS ANIMAS" },
            "81047": { "city" : "HOLLY", "state" : "CO", "county" : "PROWERS" },"81049": { "city" : "KIM", "state" : "CO", "county" : "LAS ANIMAS" },
            "81050": { "city" : "LA JUNTA", "state" : "CO", "county" : "OTERO" },
            "81052": { "city" : "LAMAR", "state" : "CO", "county" : "PROWERS" },"81054": { "city" : "LAS ANIMAS", "state" : "CO", "county" : "BENT" },
            "81055": { "city" : "LA VETA", "state" : "CO", "county" : "HUERFANO" },
            "81057": { "city" : "MC CLAVE", "state" : "CO", "county" : "BENT" },"81058": { "city" : "MANZANOLA", "state" : "CO", "county" : "OTERO" },
            "81059": { "city" : "MODEL", "state" : "CO", "county" : "LAS ANIMAS" },
            "81062": { "city" : "OLNEY SPRINGS", "state" : "CO", "county" : "CROWLEY" },
            "81063": { "city" : "ORDWAY", "state" : "CO", "county" : "CROWLEY" },
            "81064": { "city" : "PRITCHETT", "state" : "CO", "county" : "BACA" },
            "81067": { "city" : "ROCKY FORD", "state" : "CO", "county" : "OTERO" },
            "81069": { "city" : "RYE", "state" : "CO", "county" : "PUEBLO" },"81071": { "city" : "SHERIDAN LAKE", "state" : "CO", "county" : "KIOWA" },
            "81073": { "city" : "SPRINGFIELD", "state" : "CO", "county" : "BACA" },
            "81076": { "city" : "SUGAR CITY", "state" : "CO", "county" : "CROWLEY" },
            "81077": { "city" : "SWINK", "state" : "CO", "county" : "OTERO" },"81082": { "city" : "TRINIDAD", "state" : "CO", "county" : "LAS ANIMAS" },
            "81084": { "city" : "TWO BUTTES", "state" : "CO", "county" : "BACA" },
            "81087": { "city" : "VILAS", "state" : "CO", "county" : "BACA" },"81089": { "city" : "WALSENBURG", "state" : "CO", "county" : "HUERFANO" },
            "81090": { "city" : "WALSH", "state" : "CO", "county" : "BACA" },"81091": { "city" : "WESTON", "state" : "CO", "county" : "LAS ANIMAS" },
            "81092": { "city" : "WILEY", "state" : "CO", "county" : "PROWERS" },"81101": { "city" : "ALAMOSA", "state" : "CO", "county" : "ALAMOSA" },
            "81102": { "city" : "ALAMOSA", "state" : "CO", "county" : "ALAMOSA" },
            "81120": { "city" : "ANTONITO", "state" : "CO", "county" : "CONEJOS" },
            "81121": { "city" : "ARBOLES", "state" : "CO", "county" : "ARCHULETA" },
            "81122": { "city" : "BAYFIELD", "state" : "CO", "county" : "LA PLATA" },
            "81123": { "city" : "BLANCA", "state" : "CO", "county" : "COSTILLA" },
            "81124": { "city" : "CAPULIN", "state" : "CO", "county" : "CONEJOS" },
            "81125": { "city" : "CENTER", "state" : "CO", "county" : "RIO GRANDE" },
            "81127": { "city" : "CHIMNEY ROCK", "state" : "CO", "county" : "ARCHULETA" },
            "81128": { "city" : "CHROMO", "state" : "CO", "county" : "ARCHULETA" },
            "81129": { "city" : "CONEJOS", "state" : "CO", "county" : "CONEJOS" },
            "81130": { "city" : "CREEDE", "state" : "CO", "county" : "MINERAL" },
            "81131": { "city" : "CRESTONE", "state" : "CO", "county" : "SAGUACHE" },
            "81132": { "city" : "DEL NORTE", "state" : "CO", "county" : "RIO GRANDE" },
            "81133": { "city" : "FORT GARLAND", "state" : "CO", "county" : "COSTILLA" },
            "81136": { "city" : "HOOPER", "state" : "CO", "county" : "ALAMOSA" },
            "81137": { "city" : "IGNACIO", "state" : "CO", "county" : "LA PLATA" },
            "81138": { "city" : "JAROSO", "state" : "CO", "county" : "COSTILLA" },
            "81140": { "city" : "LA JARA", "state" : "CO", "county" : "CONEJOS" },
            "81141": { "city" : "MANASSA", "state" : "CO", "county" : "CONEJOS" },
            "81143": { "city" : "MOFFAT", "state" : "CO", "county" : "SAGUACHE" },
            "81144": { "city" : "MONTE VISTA", "state" : "CO", "county" : "RIO GRANDE" },
            "81146": { "city" : "MOSCA", "state" : "CO", "county" : "ALAMOSA" },"81147": { "city" : "PAGOSA SPRINGS", "state" : "CO", "county" : "ARCHULETA" },
            "81148": { "city" : "ROMEO", "state" : "CO", "county" : "CONEJOS" },"81149": { "city" : "SAGUACHE", "state" : "CO", "county" : "SAGUACHE" },
            "81151": { "city" : "SANFORD", "state" : "CO", "county" : "CONEJOS" },
            "81152": { "city" : "SAN LUIS", "state" : "CO", "county" : "COSTILLA" },
            "81154": { "city" : "SOUTH FORK", "state" : "CO", "county" : "RIO GRANDE" },
            "81155": { "city" : "VILLA GROVE", "state" : "CO", "county" : "SAGUACHE" },
            "81157": { "city" : "PAGOSA SPRINGS", "state" : "CO", "county" : "ARCHULETA" },
            "81201": { "city" : "SALIDA", "state" : "CO", "county" : "CHAFFEE" },
            "81210": { "city" : "ALMONT", "state" : "CO", "county" : "GUNNISON" },
            "81211": { "city" : "BUENA VISTA", "state" : "CO", "county" : "CHAFFEE" },
            "81212": { "city" : "CANON CITY", "state" : "CO", "county" : "FREMONT" },
            "81215": { "city" : "CANON CITY", "state" : "CO", "county" : "FREMONT" },
            "81220": { "city" : "CIMARRON", "state" : "CO", "county" : "MONTROSE" },
            "81221": { "city" : "COAL CREEK", "state" : "CO", "county" : "FREMONT" },
            "81222": { "city" : "COALDALE", "state" : "CO", "county" : "FREMONT" },
            "81223": { "city" : "COTOPAXI", "state" : "CO", "county" : "FREMONT" },
            "81224": { "city" : "CRESTED BUTTE", "state" : "CO", "county" : "GUNNISON" },
            "81225": { "city" : "CRESTED BUTTE", "state" : "CO", "county" : "GUNNISON" },
            "81226": { "city" : "FLORENCE", "state" : "CO", "county" : "FREMONT" },
            "81227": { "city" : "MONARCH", "state" : "CO", "county" : "CHAFFEE" },
            "81230": { "city" : "GUNNISON", "state" : "CO", "county" : "GUNNISON" },
            "81231": { "city" : "GUNNISON", "state" : "CO", "county" : "GUNNISON" },
            "81232": { "city" : "HILLSIDE", "state" : "CO", "county" : "FREMONT" },
            "81233": { "city" : "HOWARD", "state" : "CO", "county" : "FREMONT" },
            "81235": { "city" : "LAKE CITY", "state" : "CO", "county" : "HINSDALE" },
            "81236": { "city" : "NATHROP", "state" : "CO", "county" : "CHAFFEE" },
            "81237": { "city" : "OHIO CITY", "state" : "CO", "county" : "GUNNISON" },
            "81239": { "city" : "PARLIN", "state" : "CO", "county" : "GUNNISON" },
            "81240": { "city" : "PENROSE", "state" : "CO", "county" : "FREMONT" },
            "81241": { "city" : "PITKIN", "state" : "CO", "county" : "GUNNISON" },
            "81242": { "city" : "PONCHA SPRINGS", "state" : "CO", "county" : "CHAFFEE" },
            "81243": { "city" : "POWDERHORN", "state" : "CO", "county" : "GUNNISON" },
            "81244": { "city" : "ROCKVALE", "state" : "CO", "county" : "FREMONT" },
            "81248": { "city" : "SARGENTS", "state" : "CO", "county" : "SAGUACHE" },
            "81251": { "city" : "TWIN LAKES", "state" : "CO", "county" : "LAKE" },
            "81252": { "city" : "WESTCLIFFE", "state" : "CO", "county" : "CUSTER" },
            "81253": { "city" : "WETMORE", "state" : "CO", "county" : "CUSTER" },
            "81301": { "city" : "DURANGO", "state" : "CO", "county" : "LA PLATA" },
            "81302": { "city" : "DURANGO", "state" : "CO", "county" : "LA PLATA" },
            "81303": { "city" : "DURANGO", "state" : "CO", "county" : "LA PLATA" },
            "81320": { "city" : "CAHONE", "state" : "CO", "county" : "DOLORES" },
            "81321": { "city" : "CORTEZ", "state" : "CO", "county" : "MONTEZUMA" },
            "81323": { "city" : "DOLORES", "state" : "CO", "county" : "MONTEZUMA" },
            "81324": { "city" : "DOVE CREEK", "state" : "CO", "county" : "DOLORES" },
            "81325": { "city" : "EGNAR", "state" : "CO", "county" : "SAN MIGUEL" },
            "81326": { "city" : "HESPERUS", "state" : "CO", "county" : "LA PLATA" },
            "81327": { "city" : "LEWIS", "state" : "CO", "county" : "MONTEZUMA" },
            "81328": { "city" : "MANCOS", "state" : "CO", "county" : "MONTEZUMA" },
            "81329": { "city" : "MARVEL", "state" : "CO", "county" : "LA PLATA" },
            "81330": { "city" : "MESA VERDE NATIONAL PARK", "state" : "CO", "county" : "MONTEZUMA" },
            "81331": { "city" : "PLEASANT VIEW", "state" : "CO", "county" : "MONTEZUMA" },
            "81332": { "city" : "RICO", "state" : "CO", "county" : "DOLORES" },"81334": { "city" : "TOWAOC", "state" : "CO", "county" : "MONTEZUMA" },
            "81335": { "city" : "YELLOW JACKET", "state" : "CO", "county" : "MONTEZUMA" },
            "81401": { "city" : "MONTROSE", "state" : "CO", "county" : "MONTROSE" },
            "81402": { "city" : "MONTROSE", "state" : "CO", "county" : "MONTROSE" },
            "81403": { "city" : "MONTROSE", "state" : "CO", "county" : "MONTROSE" },
            "81410": { "city" : "AUSTIN", "state" : "CO", "county" : "DELTA" },"81411": { "city" : "BEDROCK", "state" : "CO", "county" : "MONTROSE" },
            "81413": { "city" : "CEDAREDGE", "state" : "CO", "county" : "DELTA" },
            "81414": { "city" : "CORY", "state" : "CO", "county" : "DELTA" },"81415": { "city" : "CRAWFORD", "state" : "CO", "county" : "DELTA" },
            "81416": { "city" : "DELTA", "state" : "CO", "county" : "DELTA" },"81418": { "city" : "ECKERT", "state" : "CO", "county" : "DELTA" },
            "81419": { "city" : "HOTCHKISS", "state" : "CO", "county" : "DELTA" },
            "81420": { "city" : "LAZEAR", "state" : "CO", "county" : "DELTA" },"81422": { "city" : "NATURITA", "state" : "CO", "county" : "MONTROSE" },
            "81423": { "city" : "NORWOOD", "state" : "CO", "county" : "SAN MIGUEL" },
            "81424": { "city" : "NUCLA", "state" : "CO", "county" : "MONTROSE" },
            "81425": { "city" : "OLATHE", "state" : "CO", "county" : "MONTROSE" },
            "81426": { "city" : "OPHIR", "state" : "CO", "county" : "SAN MIGUEL" },
            "81427": { "city" : "OURAY", "state" : "CO", "county" : "OURAY" },"81428": { "city" : "PAONIA", "state" : "CO", "county" : "DELTA" },
            "81429": { "city" : "PARADOX", "state" : "CO", "county" : "MONTROSE" },
            "81430": { "city" : "PLACERVILLE", "state" : "CO", "county" : "SAN MIGUEL" },
            "81431": { "city" : "REDVALE", "state" : "CO", "county" : "MONTROSE" },
            "81432": { "city" : "RIDGWAY", "state" : "CO", "county" : "OURAY" },"81433": { "city" : "SILVERTON", "state" : "CO", "county" : "SAN JUAN" },
            "81434": { "city" : "SOMERSET", "state" : "CO", "county" : "GUNNISON" },
            "81435": { "city" : "TELLURIDE", "state" : "CO", "county" : "SAN MIGUEL" },
            "81501": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81502": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81503": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81504": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81505": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81506": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81507": { "city" : "GRAND JUNCTION", "state" : "CO", "county" : "MESA" },
            "81520": { "city" : "CLIFTON", "state" : "CO", "county" : "MESA" },"81521": { "city" : "FRUITA", "state" : "CO", "county" : "MESA" },
            "81522": { "city" : "GATEWAY", "state" : "CO", "county" : "MESA" },"81523": { "city" : "GLADE PARK", "state" : "CO", "county" : "MESA" },
            "81524": { "city" : "LOMA", "state" : "CO", "county" : "MESA" },"81525": { "city" : "MACK", "state" : "CO", "county" : "MESA" },
            "81526": { "city" : "PALISADE", "state" : "CO", "county" : "MESA" },"81527": { "city" : "WHITEWATER", "state" : "CO", "county" : "MESA" },
            "81601": { "city" : "GLENWOOD SPRINGS", "state" : "CO", "county" : "GARFIELD" },
            "81602": { "city" : "GLENWOOD SPRINGS", "state" : "CO", "county" : "GARFIELD" },
            "81610": { "city" : "DINOSAUR", "state" : "CO", "county" : "MOFFAT" },
            "81611": { "city" : "ASPEN", "state" : "CO", "county" : "PITKIN" },"81612": { "city" : "ASPEN", "state" : "CO", "county" : "PITKIN" },
            "81615": { "city" : "SNOWMASS VILLAGE", "state" : "CO", "county" : "PITKIN" },
            "81620": { "city" : "AVON", "state" : "CO", "county" : "EAGLE" },"81621": { "city" : "BASALT", "state" : "CO", "county" : "EAGLE" },
            "81623": { "city" : "CARBONDALE", "state" : "CO", "county" : "GARFIELD" },
            "81624": { "city" : "COLLBRAN", "state" : "CO", "county" : "MESA" },"81625": { "city" : "CRAIG", "state" : "CO", "county" : "MOFFAT" },
            "81626": { "city" : "CRAIG", "state" : "CO", "county" : "MOFFAT" },"81630": { "city" : "DE BEQUE", "state" : "CO", "county" : "MESA" },
            "81631": { "city" : "EAGLE", "state" : "CO", "county" : "EAGLE" },"81632": { "city" : "EDWARDS", "state" : "CO", "county" : "EAGLE" },
            "81633": { "city" : "DINOSAUR", "state" : "CO", "county" : "MOFFAT" },
            "81635": { "city" : "PARACHUTE", "state" : "CO", "county" : "GARFIELD" },
            "81636": { "city" : "BATTLEMENT MESA", "state" : "CO", "county" : "GARFIELD" },
            "81637": { "city" : "GYPSUM", "state" : "CO", "county" : "EAGLE" },"81638": { "city" : "HAMILTON", "state" : "CO", "county" : "MOFFAT" },
            "81639": { "city" : "HAYDEN", "state" : "CO", "county" : "ROUTT" },"81640": { "city" : "MAYBELL", "state" : "CO", "county" : "MOFFAT" },
            "81641": { "city" : "MEEKER", "state" : "CO", "county" : "RIO BLANCO" },
            "81642": { "city" : "MEREDITH", "state" : "CO", "county" : "PITKIN" },
            "81643": { "city" : "MESA", "state" : "CO", "county" : "MESA" },"81645": { "city" : "MINTURN", "state" : "CO", "county" : "EAGLE" },
            "81646": { "city" : "MOLINA", "state" : "CO", "county" : "MESA" },"81647": { "city" : "NEW CASTLE", "state" : "CO", "county" : "GARFIELD" },
            "81648": { "city" : "RANGELY", "state" : "CO", "county" : "RIO BLANCO" },
            "81649": { "city" : "RED CLIFF", "state" : "CO", "county" : "EAGLE" },
            "81650": { "city" : "RIFLE", "state" : "CO", "county" : "GARFIELD" },
            "81652": { "city" : "SILT", "state" : "CO", "county" : "GARFIELD" },"81653": { "city" : "SLATER", "state" : "CO", "county" : "MOFFAT" },
            "81654": { "city" : "SNOWMASS", "state" : "CO", "county" : "PITKIN" },
            "81655": { "city" : "WOLCOTT", "state" : "CO", "county" : "EAGLE" },"81656": { "city" : "WOODY CREEK", "state" : "CO", "county" : "PITKIN" },
            "81657": { "city" : "VAIL", "state" : "CO", "county" : "EAGLE" },"81658": { "city" : "VAIL", "state" : "CO", "county" : "EAGLE" },
            "82001": { "city" : "CHEYENNE", "state" : "WY", "county" : "LARAMIE" },
            "82002": { "city" : "CHEYENNE", "state" : "WY", "county" : "LARAMIE" },
            "82003": { "city" : "CHEYENNE", "state" : "WY", "county" : "LARAMIE" },
            "82005": { "city" : "FT WARREN AFB", "state" : "WY", "county" : "LARAMIE" },
            "82007": { "city" : "CHEYENNE", "state" : "WY", "county" : "LARAMIE" },
            "82009": { "city" : "CHEYENNE", "state" : "WY", "county" : "LARAMIE" },
            "82050": { "city" : "ALBIN", "state" : "WY", "county" : "LARAMIE" },"82052": { "city" : "BUFORD", "state" : "WY", "county" : "ALBANY" },
            "82053": { "city" : "BURNS", "state" : "WY", "county" : "LARAMIE" },"82054": { "city" : "CARPENTER", "state" : "WY", "county" : "LARAMIE" },
            "82055": { "city" : "CENTENNIAL", "state" : "WY", "county" : "ALBANY" },
            "82059": { "city" : "GRANITE CANON", "state" : "WY", "county" : "LARAMIE" },
            "82060": { "city" : "HILLSDALE", "state" : "WY", "county" : "LARAMIE" },
            "82061": { "city" : "HORSE CREEK", "state" : "WY", "county" : "LARAMIE" },
            "82063": { "city" : "JELM", "state" : "WY", "county" : "ALBANY" },"82070": { "city" : "LARAMIE", "state" : "WY", "county" : "ALBANY" },
            "82071": { "city" : "LARAMIE", "state" : "WY", "county" : "ALBANY" },
            "82072": { "city" : "LARAMIE", "state" : "WY", "county" : "ALBANY" },
            "82073": { "city" : "LARAMIE", "state" : "WY", "county" : "ALBANY" },
            "82081": { "city" : "MERIDEN", "state" : "WY", "county" : "LARAMIE" },
            "82082": { "city" : "PINE BLUFFS", "state" : "WY", "county" : "LARAMIE" },
            "82083": { "city" : "ROCK RIVER", "state" : "WY", "county" : "ALBANY" },
            "82084": { "city" : "TIE SIDING", "state" : "WY", "county" : "ALBANY" },
            "82190": { "city" : "YELLOWSTONE NATIONAL PARK", "state" : "WY", "county" : "PARK" },
            "82201": { "city" : "WHEATLAND", "state" : "WY", "county" : "PLATTE" },
            "82210": { "city" : "CHUGWATER", "state" : "WY", "county" : "PLATTE" },
            "82212": { "city" : "FORT LARAMIE", "state" : "WY", "county" : "GOSHEN" },
            "82213": { "city" : "GLENDO", "state" : "WY", "county" : "PLATTE" },"82214": { "city" : "GUERNSEY", "state" : "WY", "county" : "PLATTE" },
            "82215": { "city" : "HARTVILLE", "state" : "WY", "county" : "PLATTE" },
            "82217": { "city" : "HAWK SPRINGS", "state" : "WY", "county" : "GOSHEN" },
            "82218": { "city" : "HUNTLEY", "state" : "WY", "county" : "GOSHEN" },
            "82221": { "city" : "LAGRANGE", "state" : "WY", "county" : "GOSHEN" },
            "82222": { "city" : "LANCE CREEK", "state" : "WY", "county" : "NIOBRARA" },
            "82223": { "city" : "LINGLE", "state" : "WY", "county" : "GOSHEN" },"82224": { "city" : "LOST SPRINGS", "state" : "WY", "county" : "CONVERSE" },
            "82225": { "city" : "LUSK", "state" : "WY", "county" : "NIOBRARA" },"82227": { "city" : "MANVILLE", "state" : "WY", "county" : "NIOBRARA" },
            "82240": { "city" : "TORRINGTON", "state" : "WY", "county" : "GOSHEN" },
            "82243": { "city" : "VETERAN", "state" : "WY", "county" : "GOSHEN" },
            "82244": { "city" : "YODER", "state" : "WY", "county" : "GOSHEN" },"82301": { "city" : "RAWLINS", "state" : "WY", "county" : "CARBON" },
            "82321": { "city" : "BAGGS", "state" : "WY", "county" : "CARBON" },"82322": { "city" : "BAIROIL", "state" : "WY", "county" : "SWEETWATER" },
            "82323": { "city" : "DIXON", "state" : "WY", "county" : "CARBON" },"82324": { "city" : "ELK MOUNTAIN", "state" : "WY", "county" : "CARBON" },
            "82325": { "city" : "ENCAMPMENT", "state" : "WY", "county" : "CARBON" },
            "82327": { "city" : "HANNA", "state" : "WY", "county" : "CARBON" },"82329": { "city" : "MEDICINE BOW", "state" : "WY", "county" : "CARBON" },
            "82331": { "city" : "SARATOGA", "state" : "WY", "county" : "CARBON" },
            "82332": { "city" : "SAVERY", "state" : "WY", "county" : "CARBON" },"82334": { "city" : "SINCLAIR", "state" : "WY", "county" : "CARBON" },
            "82335": { "city" : "WALCOTT", "state" : "WY", "county" : "CARBON" },
            "82336": { "city" : "WAMSUTTER", "state" : "WY", "county" : "SWEETWATER" },
            "82401": { "city" : "WORLAND", "state" : "WY", "county" : "WASHAKIE" },
            "82410": { "city" : "BASIN", "state" : "WY", "county" : "BIG HORN" },
            "82411": { "city" : "BURLINGTON", "state" : "WY", "county" : "BIG HORN" },
            "82412": { "city" : "BYRON", "state" : "WY", "county" : "BIG HORN" },
            "82414": { "city" : "CODY", "state" : "WY", "county" : "PARK" },"82420": { "city" : "COWLEY", "state" : "WY", "county" : "BIG HORN" },
            "82421": { "city" : "DEAVER", "state" : "WY", "county" : "BIG HORN" },
            "82423": { "city" : "FRANNIE", "state" : "WY", "county" : "PARK" },"82426": { "city" : "GREYBULL", "state" : "WY", "county" : "BIG HORN" },
            "82428": { "city" : "HYATTVILLE", "state" : "WY", "county" : "BIG HORN" },
            "82430": { "city" : "KIRBY", "state" : "WY", "county" : "HOT SPRINGS" },
            "82431": { "city" : "LOVELL", "state" : "WY", "county" : "BIG HORN" },
            "82432": { "city" : "MANDERSON", "state" : "WY", "county" : "BIG HORN" },
            "82433": { "city" : "MEETEETSE", "state" : "WY", "county" : "PARK" },
            "82434": { "city" : "OTTO", "state" : "WY", "county" : "BIG HORN" },"82435": { "city" : "POWELL", "state" : "WY", "county" : "PARK" },
            "82440": { "city" : "RALSTON", "state" : "WY", "county" : "PARK" },"82441": { "city" : "SHELL", "state" : "WY", "county" : "BIG HORN" },
            "82442": { "city" : "TEN SLEEP", "state" : "WY", "county" : "WASHAKIE" },
            "82443": { "city" : "THERMOPOLIS", "state" : "WY", "county" : "HOT SPRINGS" },
            "82450": { "city" : "WAPITI", "state" : "WY", "county" : "PARK" },"82501": { "city" : "RIVERTON", "state" : "WY", "county" : "FREMONT" },
            "82510": { "city" : "ARAPAHOE", "state" : "WY", "county" : "FREMONT" },
            "82512": { "city" : "CROWHEART", "state" : "WY", "county" : "FREMONT" },
            "82513": { "city" : "DUBOIS", "state" : "WY", "county" : "FREMONT" },
            "82514": { "city" : "FORT WASHAKIE", "state" : "WY", "county" : "FREMONT" },
            "82515": { "city" : "HUDSON", "state" : "WY", "county" : "FREMONT" },
            "82516": { "city" : "KINNEAR", "state" : "WY", "county" : "FREMONT" },
            "82520": { "city" : "LANDER", "state" : "WY", "county" : "FREMONT" },
            "82523": { "city" : "PAVILLION", "state" : "WY", "county" : "FREMONT" },
            "82524": { "city" : "SAINT STEPHENS", "state" : "WY", "county" : "FREMONT" },
            "82601": { "city" : "CASPER", "state" : "WY", "county" : "NATRONA" },
            "82602": { "city" : "CASPER", "state" : "WY", "county" : "NATRONA" },
            "82604": { "city" : "CASPER", "state" : "WY", "county" : "NATRONA" },
            "82605": { "city" : "CASPER", "state" : "WY", "county" : "NATRONA" },
            "82609": { "city" : "CASPER", "state" : "WY", "county" : "NATRONA" },
            "82615": { "city" : "SHIRLEY BASIN", "state" : "WY", "county" : "CARBON" },
            "82620": { "city" : "ALCOVA", "state" : "WY", "county" : "NATRONA" },
            "82633": { "city" : "DOUGLAS", "state" : "WY", "county" : "CONVERSE" },
            "82635": { "city" : "EDGERTON", "state" : "WY", "county" : "NATRONA" },
            "82636": { "city" : "EVANSVILLE", "state" : "WY", "county" : "NATRONA" },
            "82637": { "city" : "GLENROCK", "state" : "WY", "county" : "CONVERSE" },
            "82638": { "city" : "HILAND", "state" : "WY", "county" : "NATRONA" },
            "82639": { "city" : "KAYCEE", "state" : "WY", "county" : "JOHNSON" },
            "82640": { "city" : "LINCH", "state" : "WY", "county" : "JOHNSON" },"82642": { "city" : "LYSITE", "state" : "WY", "county" : "FREMONT" },
            "82643": { "city" : "MIDWEST", "state" : "WY", "county" : "NATRONA" },
            "82644": { "city" : "MILLS", "state" : "WY", "county" : "NATRONA" },"82648": { "city" : "POWDER RIVER", "state" : "WY", "county" : "NATRONA" },
            "82649": { "city" : "SHOSHONI", "state" : "WY", "county" : "FREMONT" },
            "82701": { "city" : "NEWCASTLE", "state" : "WY", "county" : "WESTON" },
            "82710": { "city" : "ALADDIN", "state" : "WY", "county" : "CROOK" },"82711": { "city" : "ALVA", "state" : "WY", "county" : "CROOK" },
            "82712": { "city" : "BEULAH", "state" : "WY", "county" : "CROOK" },"82714": { "city" : "DEVILS TOWER", "state" : "WY", "county" : "CROOK" },
            "82716": { "city" : "GILLETTE", "state" : "WY", "county" : "CAMPBELL" },
            "82717": { "city" : "GILLETTE", "state" : "WY", "county" : "CAMPBELL" },
            "82718": { "city" : "GILLETTE", "state" : "WY", "county" : "CAMPBELL" },
            "82720": { "city" : "HULETT", "state" : "WY", "county" : "CROOK" },"82721": { "city" : "MOORCROFT", "state" : "WY", "county" : "CROOK" },
            "82723": { "city" : "OSAGE", "state" : "WY", "county" : "WESTON" },"82725": { "city" : "RECLUSE", "state" : "WY", "county" : "CAMPBELL" },
            "82727": { "city" : "ROZET", "state" : "WY", "county" : "CAMPBELL" },
            "82729": { "city" : "SUNDANCE", "state" : "WY", "county" : "CROOK" },
            "82730": { "city" : "UPTON", "state" : "WY", "county" : "WESTON" },"82731": { "city" : "WESTON", "state" : "WY", "county" : "CAMPBELL" },
            "82732": { "city" : "WRIGHT", "state" : "WY", "county" : "CAMPBELL" },
            "82801": { "city" : "SHERIDAN", "state" : "WY", "county" : "SHERIDAN" },
            "82831": { "city" : "ARVADA", "state" : "WY", "county" : "SHERIDAN" },
            "82832": { "city" : "BANNER", "state" : "WY", "county" : "SHERIDAN" },
            "82833": { "city" : "BIG HORN", "state" : "WY", "county" : "SHERIDAN" },
            "82834": { "city" : "BUFFALO", "state" : "WY", "county" : "JOHNSON" },
            "82835": { "city" : "CLEARMONT", "state" : "WY", "county" : "SHERIDAN" },
            "82836": { "city" : "DAYTON", "state" : "WY", "county" : "SHERIDAN" },
            "82838": { "city" : "PARKMAN", "state" : "WY", "county" : "SHERIDAN" },
            "82839": { "city" : "RANCHESTER", "state" : "WY", "county" : "SHERIDAN" },
            "82840": { "city" : "SADDLESTRING", "state" : "WY", "county" : "JOHNSON" },
            "82842": { "city" : "STORY", "state" : "WY", "county" : "SHERIDAN" },
            "82844": { "city" : "WOLF", "state" : "WY", "county" : "SHERIDAN" },"82845": { "city" : "WYARNO", "state" : "WY", "county" : "SHERIDAN" },
            "82901": { "city" : "ROCK SPRINGS", "state" : "WY", "county" : "SWEETWATER" },
            "82902": { "city" : "ROCK SPRINGS", "state" : "WY", "county" : "SWEETWATER" },
            "82922": { "city" : "BONDURANT", "state" : "WY", "county" : "SUBLETTE" },
            "82923": { "city" : "BOULDER", "state" : "WY", "county" : "SUBLETTE" },
            "82925": { "city" : "CORA", "state" : "WY", "county" : "SUBLETTE" },"82929": { "city" : "LITTLE AMERICA", "state" : "WY", "county" : "SWEETWATER" },
            "82930": { "city" : "EVANSTON", "state" : "WY", "county" : "UINTA" },
            "82931": { "city" : "EVANSTON", "state" : "WY", "county" : "UINTA" },
            "82932": { "city" : "FARSON", "state" : "WY", "county" : "SWEETWATER" },
            "82933": { "city" : "FORT BRIDGER", "state" : "WY", "county" : "UINTA" },
            "82934": { "city" : "GRANGER", "state" : "WY", "county" : "SWEETWATER" },
            "82935": { "city" : "GREEN RIVER", "state" : "WY", "county" : "SWEETWATER" },
            "82936": { "city" : "LONETREE", "state" : "WY", "county" : "UINTA" },
            "82937": { "city" : "LYMAN", "state" : "WY", "county" : "UINTA" },"82938": { "city" : "MC KINNON", "state" : "WY", "county" : "SWEETWATER" },
            "82939": { "city" : "MOUNTAIN VIEW", "state" : "WY", "county" : "UINTA" },
            "82941": { "city" : "PINEDALE", "state" : "WY", "county" : "SUBLETTE" },
            "82942": { "city" : "POINT OF ROCKS", "state" : "WY", "county" : "SWEETWATER" },
            "82943": { "city" : "RELIANCE", "state" : "WY", "county" : "SWEETWATER" },
            "82944": { "city" : "ROBERTSON", "state" : "WY", "county" : "UINTA" },
            "82945": { "city" : "SUPERIOR", "state" : "WY", "county" : "SWEETWATER" },
            "83001": { "city" : "JACKSON", "state" : "WY", "county" : "TETON" },"83002": { "city" : "JACKSON", "state" : "WY", "county" : "TETON" },
            "83011": { "city" : "KELLY", "state" : "WY", "county" : "TETON" },"83012": { "city" : "MOOSE", "state" : "WY", "county" : "TETON" },
            "83013": { "city" : "MORAN", "state" : "WY", "county" : "TETON" },"83014": { "city" : "WILSON", "state" : "WY", "county" : "TETON" },
            "83025": { "city" : "TETON VILLAGE", "state" : "WY", "county" : "TETON" },
            "83101": { "city" : "KEMMERER", "state" : "WY", "county" : "LINCOLN" },
            "83110": { "city" : "AFTON", "state" : "WY", "county" : "LINCOLN" },"83111": { "city" : "AUBURN", "state" : "WY", "county" : "LINCOLN" },
            "83112": { "city" : "BEDFORD", "state" : "WY", "county" : "LINCOLN" },
            "83113": { "city" : "BIG PINEY", "state" : "WY", "county" : "SUBLETTE" },
            "83114": { "city" : "COKEVILLE", "state" : "WY", "county" : "LINCOLN" },
            "83115": { "city" : "DANIEL", "state" : "WY", "county" : "SUBLETTE" },
            "83116": { "city" : "DIAMONDVILLE", "state" : "WY", "county" : "LINCOLN" },
            "83118": { "city" : "ETNA", "state" : "WY", "county" : "LINCOLN" },"83119": { "city" : "FAIRVIEW", "state" : "WY", "county" : "LINCOLN" },
            "83120": { "city" : "FREEDOM", "state" : "WY", "county" : "LINCOLN" },
            "83121": { "city" : "FRONTIER", "state" : "WY", "county" : "LINCOLN" },
            "83122": { "city" : "GROVER", "state" : "WY", "county" : "LINCOLN" },
            "83123": { "city" : "LA BARGE", "state" : "WY", "county" : "LINCOLN" },
            "83124": { "city" : "OPAL", "state" : "WY", "county" : "LINCOLN" },"83126": { "city" : "SMOOT", "state" : "WY", "county" : "LINCOLN" },
            "83127": { "city" : "THAYNE", "state" : "WY", "county" : "LINCOLN" },
            "83128": { "city" : "ALPINE", "state" : "WY", "county" : "LINCOLN" },
            "83201": { "city" : "POCATELLO", "state" : "ID", "county" : "BANNOCK" },
            "83202": { "city" : "POCATELLO", "state" : "ID", "county" : "BANNOCK" },
            "83203": { "city" : "FORT HALL", "state" : "ID", "county" : "BINGHAM" },
            "83204": { "city" : "POCATELLO", "state" : "ID", "county" : "BANNOCK" },
            "83205": { "city" : "POCATELLO", "state" : "ID", "county" : "BANNOCK" },
            "83206": { "city" : "POCATELLO", "state" : "ID", "county" : "BANNOCK" },
            "83209": { "city" : "POCATELLO", "state" : "ID", "county" : "BANNOCK" },
            "83210": { "city" : "ABERDEEN", "state" : "ID", "county" : "BINGHAM" },
            "83211": { "city" : "AMERICAN FALLS", "state" : "ID", "county" : "POWER" },
            "83212": { "city" : "ARBON", "state" : "ID", "county" : "POWER" },"83213": { "city" : "ARCO", "state" : "ID", "county" : "BUTTE" },
            "83214": { "city" : "ARIMO", "state" : "ID", "county" : "BANNOCK" },"83217": { "city" : "BANCROFT", "state" : "ID", "county" : "CARIBOU" },
            "83220": { "city" : "BERN", "state" : "ID", "county" : "BEAR LAKE" },
            "83221": { "city" : "BLACKFOOT", "state" : "ID", "county" : "BINGHAM" },
            "83223": { "city" : "BLOOMINGTON", "state" : "ID", "county" : "BEAR LAKE" },
            "83226": { "city" : "CHALLIS", "state" : "ID", "county" : "CUSTER" },
            "83227": { "city" : "CLAYTON", "state" : "ID", "county" : "CUSTER" },
            "83228": { "city" : "CLIFTON", "state" : "ID", "county" : "FRANKLIN" },
            "83232": { "city" : "DAYTON", "state" : "ID", "county" : "FRANKLIN" },
            "83234": { "city" : "DOWNEY", "state" : "ID", "county" : "BANNOCK" },
            "83235": { "city" : "ELLIS", "state" : "ID", "county" : "CUSTER" },"83236": { "city" : "FIRTH", "state" : "ID", "county" : "BINGHAM" },
            "83237": { "city" : "FRANKLIN", "state" : "ID", "county" : "FRANKLIN" },
            "83238": { "city" : "GENEVA", "state" : "ID", "county" : "BEAR LAKE" },
            "83239": { "city" : "GEORGETOWN", "state" : "ID", "county" : "BEAR LAKE" },
            "83241": { "city" : "GRACE", "state" : "ID", "county" : "CARIBOU" },"83245": { "city" : "INKOM", "state" : "ID", "county" : "BANNOCK" },
            "83246": { "city" : "LAVA HOT SPRINGS", "state" : "ID", "county" : "BANNOCK" },
            "83250": { "city" : "MCCAMMON", "state" : "ID", "county" : "BANNOCK" },
            "83251": { "city" : "MACKAY", "state" : "ID", "county" : "CUSTER" },"83252": { "city" : "MALAD CITY", "state" : "ID", "county" : "ONEIDA" },
            "83253": { "city" : "MAY", "state" : "ID", "county" : "LEMHI" },"83254": { "city" : "MONTPELIER", "state" : "ID", "county" : "BEAR LAKE" },
            "83255": { "city" : "MOORE", "state" : "ID", "county" : "BUTTE" },"83256": { "city" : "MORELAND", "state" : "ID", "county" : "BINGHAM" },
            "83261": { "city" : "PARIS", "state" : "ID", "county" : "BEAR LAKE" },
            "83262": { "city" : "PINGREE", "state" : "ID", "county" : "BINGHAM" },
            "83263": { "city" : "PRESTON", "state" : "ID", "county" : "FRANKLIN" },
            "83271": { "city" : "ROCKLAND", "state" : "ID", "county" : "POWER" },
            "83272": { "city" : "SAINT CHARLES", "state" : "ID", "county" : "BEAR LAKE" },
            "83274": { "city" : "SHELLEY", "state" : "ID", "county" : "BINGHAM" },
            "83276": { "city" : "SODA SPRINGS", "state" : "ID", "county" : "CARIBOU" },
            "83277": { "city" : "SPRINGFIELD", "state" : "ID", "county" : "BINGHAM" },
            "83278": { "city" : "STANLEY", "state" : "ID", "county" : "CUSTER" },
            "83283": { "city" : "THATCHER", "state" : "ID", "county" : "FRANKLIN" },
            "83286": { "city" : "WESTON", "state" : "ID", "county" : "FRANKLIN" },
            "83287": { "city" : "FISH HAVEN", "state" : "ID", "county" : "BEAR LAKE" },
            "83301": { "city" : "TWIN FALLS", "state" : "ID", "county" : "TWIN FALLS" },
            "83302": { "city" : "ROGERSON", "state" : "ID", "county" : "TWIN FALLS" },
            "83303": { "city" : "TWIN FALLS", "state" : "ID", "county" : "TWIN FALLS" },
            "83311": { "city" : "ALBION", "state" : "ID", "county" : "CASSIA" },"83312": { "city" : "ALMO", "state" : "ID", "county" : "CASSIA" },
            "83313": { "city" : "BELLEVUE", "state" : "ID", "county" : "BLAINE" },
            "83314": { "city" : "BLISS", "state" : "ID", "county" : "GOODING" },"83316": { "city" : "BUHL", "state" : "ID", "county" : "TWIN FALLS" },
            "83318": { "city" : "BURLEY", "state" : "ID", "county" : "CASSIA" },"83320": { "city" : "CAREY", "state" : "ID", "county" : "BLAINE" },
            "83321": { "city" : "CASTLEFORD", "state" : "ID", "county" : "TWIN FALLS" },
            "83322": { "city" : "CORRAL", "state" : "ID", "county" : "CAMAS" },"83323": { "city" : "DECLO", "state" : "ID", "county" : "CASSIA" },
            "83324": { "city" : "DIETRICH", "state" : "ID", "county" : "LINCOLN" },
            "83325": { "city" : "EDEN", "state" : "ID", "county" : "JEROME" },"83327": { "city" : "FAIRFIELD", "state" : "ID", "county" : "CAMAS" },
            "83328": { "city" : "FILER", "state" : "ID", "county" : "TWIN FALLS" },
            "83330": { "city" : "GOODING", "state" : "ID", "county" : "GOODING" },
            "83332": { "city" : "HAGERMAN", "state" : "ID", "county" : "GOODING" },
            "83333": { "city" : "HAILEY", "state" : "ID", "county" : "BLAINE" },"83334": { "city" : "HANSEN", "state" : "ID", "county" : "TWIN FALLS" },
            "83335": { "city" : "HAZELTON", "state" : "ID", "county" : "JEROME" },
            "83336": { "city" : "HEYBURN", "state" : "ID", "county" : "MINIDOKA" },
            "83338": { "city" : "JEROME", "state" : "ID", "county" : "JEROME" },"83340": { "city" : "KETCHUM", "state" : "ID", "county" : "BLAINE" },
            "83341": { "city" : "KIMBERLY", "state" : "ID", "county" : "TWIN FALLS" },
            "83342": { "city" : "MALTA", "state" : "ID", "county" : "CASSIA" },"83343": { "city" : "MINIDOKA", "state" : "ID", "county" : "MINIDOKA" },
            "83344": { "city" : "MURTAUGH", "state" : "ID", "county" : "TWIN FALLS" },
            "83346": { "city" : "OAKLEY", "state" : "ID", "county" : "CASSIA" },"83347": { "city" : "PAUL", "state" : "ID", "county" : "MINIDOKA" },
            "83348": { "city" : "PICABO", "state" : "ID", "county" : "BLAINE" },"83349": { "city" : "RICHFIELD", "state" : "ID", "county" : "LINCOLN" },
            "83350": { "city" : "RUPERT", "state" : "ID", "county" : "MINIDOKA" },
            "83352": { "city" : "SHOSHONE", "state" : "ID", "county" : "LINCOLN" },
            "83353": { "city" : "SUN VALLEY", "state" : "ID", "county" : "BLAINE" },
            "83354": { "city" : "SUN VALLEY", "state" : "ID", "county" : "BLAINE" },
            "83355": { "city" : "WENDELL", "state" : "ID", "county" : "GOODING" },
            "83401": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83402": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83403": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83404": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83405": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83406": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83414": { "city" : "ALTA", "state" : "WY", "county" : "TETON" },"83415": { "city" : "IDAHO FALLS", "state" : "ID", "county" : "BONNEVILLE" },
            "83420": { "city" : "ASHTON", "state" : "ID", "county" : "FREMONT" },
            "83421": { "city" : "CHESTER", "state" : "ID", "county" : "FREMONT" },
            "83422": { "city" : "DRIGGS", "state" : "ID", "county" : "TETON" },"83423": { "city" : "DUBOIS", "state" : "ID", "county" : "CLARK" },
            "83424": { "city" : "FELT", "state" : "ID", "county" : "TETON" },"83425": { "city" : "HAMER", "state" : "ID", "county" : "JEFFERSON" },
            "83427": { "city" : "IONA", "state" : "ID", "county" : "BONNEVILLE" },
            "83428": { "city" : "IRWIN", "state" : "ID", "county" : "BONNEVILLE" },
            "83429": { "city" : "ISLAND PARK", "state" : "ID", "county" : "FREMONT" },
            "83431": { "city" : "LEWISVILLE", "state" : "ID", "county" : "JEFFERSON" },
            "83433": { "city" : "MACKS INN", "state" : "ID", "county" : "FREMONT" },
            "83434": { "city" : "MENAN", "state" : "ID", "county" : "JEFFERSON" },
            "83436": { "city" : "NEWDALE", "state" : "ID", "county" : "FREMONT" },
            "83438": { "city" : "PARKER", "state" : "ID", "county" : "FREMONT" },
            "83440": { "city" : "REXBURG", "state" : "ID", "county" : "MADISON" },
            "83441": { "city" : "REXBURG", "state" : "ID", "county" : "MADISON" },
            "83442": { "city" : "RIGBY", "state" : "ID", "county" : "JEFFERSON" },
            "83443": { "city" : "RIRIE", "state" : "ID", "county" : "JEFFERSON" },
            "83444": { "city" : "ROBERTS", "state" : "ID", "county" : "JEFFERSON" },
            "83445": { "city" : "SAINT ANTHONY", "state" : "ID", "county" : "FREMONT" },
            "83446": { "city" : "SPENCER", "state" : "ID", "county" : "CLARK" },"83448": { "city" : "SUGAR CITY", "state" : "ID", "county" : "MADISON" },
            "83449": { "city" : "SWAN VALLEY", "state" : "ID", "county" : "BONNEVILLE" },
            "83450": { "city" : "TERRETON", "state" : "ID", "county" : "JEFFERSON" },
            "83451": { "city" : "TETON", "state" : "ID", "county" : "FREMONT" },"83452": { "city" : "TETONIA", "state" : "ID", "county" : "TETON" },
            "83454": { "city" : "UCON", "state" : "ID", "county" : "BONNEVILLE" },
            "83455": { "city" : "VICTOR", "state" : "ID", "county" : "TETON" },"83460": { "city" : "REXBURG", "state" : "ID", "county" : "MADISON" },
            "83462": { "city" : "CARMEN", "state" : "ID", "county" : "LEMHI" },"83463": { "city" : "GIBBONSVILLE", "state" : "ID", "county" : "LEMHI" },
            "83464": { "city" : "LEADORE", "state" : "ID", "county" : "LEMHI" },"83465": { "city" : "LEMHI", "state" : "ID", "county" : "LEMHI" },
            "83466": { "city" : "NORTH FORK", "state" : "ID", "county" : "LEMHI" },
            "83467": { "city" : "SALMON", "state" : "ID", "county" : "LEMHI" },"83468": { "city" : "TENDOY", "state" : "ID", "county" : "LEMHI" },
            "83469": { "city" : "SHOUP", "state" : "ID", "county" : "LEMHI" },"83501": { "city" : "LEWISTON", "state" : "ID", "county" : "NEZ PERCE" },
            "83520": { "city" : "AHSAHKA", "state" : "ID", "county" : "CLEARWATER" },
            "83522": { "city" : "COTTONWOOD", "state" : "ID", "county" : "IDAHO" },
            "83523": { "city" : "CRAIGMONT", "state" : "ID", "county" : "LEWIS" },
            "83524": { "city" : "CULDESAC", "state" : "ID", "county" : "NEZ PERCE" },
            "83525": { "city" : "ELK CITY", "state" : "ID", "county" : "IDAHO" },
            "83526": { "city" : "FERDINAND", "state" : "ID", "county" : "IDAHO" },
            "83530": { "city" : "GRANGEVILLE", "state" : "ID", "county" : "IDAHO" },
            "83531": { "city" : "FENN", "state" : "ID", "county" : "IDAHO" },"83533": { "city" : "GREENCREEK", "state" : "ID", "county" : "IDAHO" },
            "83535": { "city" : "JULIAETTA", "state" : "ID", "county" : "LATAH" },
            "83536": { "city" : "KAMIAH", "state" : "ID", "county" : "LEWIS" },"83537": { "city" : "KENDRICK", "state" : "ID", "county" : "LATAH" },
            "83539": { "city" : "KOOSKIA", "state" : "ID", "county" : "IDAHO" },"83540": { "city" : "LAPWAI", "state" : "ID", "county" : "NEZ PERCE" },
            "83541": { "city" : "LENORE", "state" : "ID", "county" : "CLEARWATER" },
            "83542": { "city" : "LUCILE", "state" : "ID", "county" : "IDAHO" },"83543": { "city" : "NEZPERCE", "state" : "ID", "county" : "LEWIS" },
            "83544": { "city" : "OROFINO", "state" : "ID", "county" : "CLEARWATER" },
            "83545": { "city" : "PECK", "state" : "ID", "county" : "NEZ PERCE" },
            "83546": { "city" : "PIERCE", "state" : "ID", "county" : "CLEARWATER" },
            "83547": { "city" : "POLLOCK", "state" : "ID", "county" : "IDAHO" },"83548": { "city" : "REUBENS", "state" : "ID", "county" : "LEWIS" },
            "83549": { "city" : "RIGGINS", "state" : "ID", "county" : "IDAHO" },"83552": { "city" : "STITES", "state" : "ID", "county" : "IDAHO" },
            "83553": { "city" : "WEIPPE", "state" : "ID", "county" : "CLEARWATER" },
            "83554": { "city" : "WHITE BIRD", "state" : "ID", "county" : "IDAHO" },
            "83555": { "city" : "WINCHESTER", "state" : "ID", "county" : "LEWIS" },
            "83601": { "city" : "ATLANTA", "state" : "ID", "county" : "ELMORE" },
            "83602": { "city" : "BANKS", "state" : "ID", "county" : "BOISE" },"83604": { "city" : "BRUNEAU", "state" : "ID", "county" : "OWYHEE" },
            "83605": { "city" : "CALDWELL", "state" : "ID", "county" : "CANYON" },
            "83606": { "city" : "CALDWELL", "state" : "ID", "county" : "CANYON" },
            "83607": { "city" : "CALDWELL", "state" : "ID", "county" : "CANYON" },
            "83610": { "city" : "CAMBRIDGE", "state" : "ID", "county" : "WASHINGTON" },
            "83611": { "city" : "CASCADE", "state" : "ID", "county" : "VALLEY" },
            "83612": { "city" : "COUNCIL", "state" : "ID", "county" : "ADAMS" },"83615": { "city" : "DONNELLY", "state" : "ID", "county" : "VALLEY" },
            "83616": { "city" : "EAGLE", "state" : "ID", "county" : "ADA" },"83617": { "city" : "EMMETT", "state" : "ID", "county" : "GEM" },
            "83619": { "city" : "FRUITLAND", "state" : "ID", "county" : "PAYETTE" },
            "83622": { "city" : "GARDEN VALLEY", "state" : "ID", "county" : "BOISE" },
            "83623": { "city" : "GLENNS FERRY", "state" : "ID", "county" : "ELMORE" },
            "83624": { "city" : "GRAND VIEW", "state" : "ID", "county" : "OWYHEE" },
            "83626": { "city" : "GREENLEAF", "state" : "ID", "county" : "CANYON" },
            "83627": { "city" : "HAMMETT", "state" : "ID", "county" : "ELMORE" },
            "83628": { "city" : "HOMEDALE", "state" : "ID", "county" : "OWYHEE" },
            "83629": { "city" : "HORSESHOE BEND", "state" : "ID", "county" : "BOISE" },
            "83631": { "city" : "IDAHO CITY", "state" : "ID", "county" : "BOISE" },
            "83632": { "city" : "INDIAN VALLEY", "state" : "ID", "county" : "ADAMS" },
            "83633": { "city" : "KING HILL", "state" : "ID", "county" : "ELMORE" },
            "83634": { "city" : "KUNA", "state" : "ID", "county" : "ADA" },"83635": { "city" : "LAKE FORK", "state" : "ID", "county" : "VALLEY" },
            "83636": { "city" : "LETHA", "state" : "ID", "county" : "GEM" },"83637": { "city" : "LOWMAN", "state" : "ID", "county" : "BOISE" },
            "83638": { "city" : "MCCALL", "state" : "ID", "county" : "VALLEY" },"83639": { "city" : "MARSING", "state" : "ID", "county" : "OWYHEE" },
            "83641": { "city" : "MELBA", "state" : "ID", "county" : "CANYON" },"83642": { "city" : "MERIDIAN", "state" : "ID", "county" : "ADA" },
            "83643": { "city" : "MESA", "state" : "ID", "county" : "ADAMS" },"83644": { "city" : "MIDDLETON", "state" : "ID", "county" : "CANYON" },
            "83645": { "city" : "MIDVALE", "state" : "ID", "county" : "WASHINGTON" },
            "83646": { "city" : "MERIDIAN", "state" : "ID", "county" : "ADA" },"83647": { "city" : "MOUNTAIN HOME", "state" : "ID", "county" : "ELMORE" },
            "83648": { "city" : "MOUNTAIN HOME A F B", "state" : "ID", "county" : "ELMORE" },
            "83650": { "city" : "MURPHY", "state" : "ID", "county" : "OWYHEE" },"83651": { "city" : "NAMPA", "state" : "ID", "county" : "CANYON" },
            "83652": { "city" : "NAMPA", "state" : "ID", "county" : "CANYON" },"83653": { "city" : "NAMPA", "state" : "ID", "county" : "CANYON" },
            "83654": { "city" : "NEW MEADOWS", "state" : "ID", "county" : "ADAMS" },
            "83655": { "city" : "NEW PLYMOUTH", "state" : "ID", "county" : "PAYETTE" },
            "83656": { "city" : "NOTUS", "state" : "ID", "county" : "CANYON" },"83657": { "city" : "OLA", "state" : "ID", "county" : "GEM" },
            "83660": { "city" : "PARMA", "state" : "ID", "county" : "CANYON" },"83661": { "city" : "PAYETTE", "state" : "ID", "county" : "PAYETTE" },
            "83669": { "city" : "STAR", "state" : "ID", "county" : "ADA" },"83670": { "city" : "SWEET", "state" : "ID", "county" : "GEM" },
            "83672": { "city" : "WEISER", "state" : "ID", "county" : "WASHINGTON" },
            "83676": { "city" : "WILDER", "state" : "ID", "county" : "CANYON" },"83677": { "city" : "YELLOW PINE", "state" : "ID", "county" : "VALLEY" },
            "83680": { "city" : "MERIDIAN", "state" : "ID", "county" : "ADA" },"83686": { "city" : "NAMPA", "state" : "ID", "county" : "CANYON" },
            "83687": { "city" : "NAMPA", "state" : "ID", "county" : "CANYON" },"83701": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83702": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83703": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83704": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83705": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83706": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83707": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83708": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83709": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83711": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83712": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83713": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83714": { "city" : "GARDEN CITY", "state" : "ID", "county" : "ADA" },
            "83715": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83716": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83717": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83719": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83720": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83725": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83726": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83728": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83729": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },"83735": { "city" : "BOISE", "state" : "ID", "county" : "ADA" },
            "83801": { "city" : "ATHOL", "state" : "ID", "county" : "KOOTENAI" },
            "83802": { "city" : "AVERY", "state" : "ID", "county" : "SHOSHONE" },
            "83803": { "city" : "BAYVIEW", "state" : "ID", "county" : "KOOTENAI" },
            "83804": { "city" : "BLANCHARD", "state" : "ID", "county" : "BONNER" },
            "83805": { "city" : "BONNERS FERRY", "state" : "ID", "county" : "BOUNDARY" },
            "83806": { "city" : "BOVILL", "state" : "ID", "county" : "LATAH" },"83808": { "city" : "CALDER", "state" : "ID", "county" : "SHOSHONE" },
            "83809": { "city" : "CAREYWOOD", "state" : "ID", "county" : "BONNER" },
            "83810": { "city" : "CATALDO", "state" : "ID", "county" : "KOOTENAI" },
            "83811": { "city" : "CLARK FORK", "state" : "ID", "county" : "BONNER" },
            "83813": { "city" : "COCOLALLA", "state" : "ID", "county" : "BONNER" },
            "83814": { "city" : "COEUR D ALENE", "state" : "ID", "county" : "KOOTENAI" },
            "83815": { "city" : "COEUR D ALENE", "state" : "ID", "county" : "KOOTENAI" },
            "83816": { "city" : "COEUR D ALENE", "state" : "ID", "county" : "KOOTENAI" },
            "83821": { "city" : "COOLIN", "state" : "ID", "county" : "BONNER" },"83822": { "city" : "OLDTOWN", "state" : "ID", "county" : "BONNER" },
            "83823": { "city" : "DEARY", "state" : "ID", "county" : "LATAH" },"83824": { "city" : "DESMET", "state" : "ID", "county" : "BENEWAH" },
            "83825": { "city" : "DOVER", "state" : "ID", "county" : "BONNER" },"83826": { "city" : "EASTPORT", "state" : "ID", "county" : "BOUNDARY" },
            "83827": { "city" : "ELK RIVER", "state" : "ID", "county" : "CLEARWATER" },
            "83830": { "city" : "FERNWOOD", "state" : "ID", "county" : "BENEWAH" },
            "83832": { "city" : "GENESEE", "state" : "ID", "county" : "LATAH" },"83833": { "city" : "HARRISON", "state" : "ID", "county" : "KOOTENAI" },
            "83834": { "city" : "HARVARD", "state" : "ID", "county" : "LATAH" },"83835": { "city" : "HAYDEN", "state" : "ID", "county" : "KOOTENAI" },
            "83836": { "city" : "HOPE", "state" : "ID", "county" : "BONNER" },"83837": { "city" : "KELLOGG", "state" : "ID", "county" : "SHOSHONE" },
            "83839": { "city" : "KINGSTON", "state" : "ID", "county" : "SHOSHONE" },
            "83840": { "city" : "KOOTENAI", "state" : "ID", "county" : "BONNER" },
            "83841": { "city" : "LACLEDE", "state" : "ID", "county" : "BONNER" },
            "83842": { "city" : "MEDIMONT", "state" : "ID", "county" : "KOOTENAI" },
            "83843": { "city" : "MOSCOW", "state" : "ID", "county" : "LATAH" },"83844": { "city" : "MOSCOW", "state" : "ID", "county" : "LATAH" },
            "83845": { "city" : "MOYIE SPRINGS", "state" : "ID", "county" : "BOUNDARY" },
            "83846": { "city" : "MULLAN", "state" : "ID", "county" : "SHOSHONE" },
            "83847": { "city" : "NAPLES", "state" : "ID", "county" : "BOUNDARY" },
            "83848": { "city" : "NORDMAN", "state" : "ID", "county" : "BONNER" },
            "83849": { "city" : "OSBURN", "state" : "ID", "county" : "SHOSHONE" },
            "83850": { "city" : "PINEHURST", "state" : "ID", "county" : "SHOSHONE" },
            "83851": { "city" : "PLUMMER", "state" : "ID", "county" : "BENEWAH" },
            "83852": { "city" : "PONDERAY", "state" : "ID", "county" : "BONNER" },
            "83853": { "city" : "PORTHILL", "state" : "ID", "county" : "BOUNDARY" },
            "83854": { "city" : "POST FALLS", "state" : "ID", "county" : "KOOTENAI" },
            "83855": { "city" : "POTLATCH", "state" : "ID", "county" : "LATAH" },
            "83856": { "city" : "PRIEST RIVER", "state" : "ID", "county" : "BONNER" },
            "83857": { "city" : "PRINCETON", "state" : "ID", "county" : "LATAH" },
            "83858": { "city" : "RATHDRUM", "state" : "ID", "county" : "KOOTENAI" },
            "83860": { "city" : "SAGLE", "state" : "ID", "county" : "BONNER" },"83861": { "city" : "SAINT MARIES", "state" : "ID", "county" : "BENEWAH" },
            "83864": { "city" : "SANDPOINT", "state" : "ID", "county" : "BONNER" },
            "83865": { "city" : "COLBURN", "state" : "ID", "county" : "BONNER" },
            "83866": { "city" : "SANTA", "state" : "ID", "county" : "BENEWAH" },"83867": { "city" : "SILVERTON", "state" : "ID", "county" : "SHOSHONE" },
            "83868": { "city" : "SMELTERVILLE", "state" : "ID", "county" : "SHOSHONE" },
            "83869": { "city" : "SPIRIT LAKE", "state" : "ID", "county" : "KOOTENAI" },
            "83870": { "city" : "TENSED", "state" : "ID", "county" : "BENEWAH" },
            "83871": { "city" : "TROY", "state" : "ID", "county" : "LATAH" },"83872": { "city" : "VIOLA", "state" : "ID", "county" : "LATAH" },
            "83873": { "city" : "WALLACE", "state" : "ID", "county" : "SHOSHONE" },
            "83874": { "city" : "MURRAY", "state" : "ID", "county" : "SHOSHONE" },
            "83876": { "city" : "WORLEY", "state" : "ID", "county" : "KOOTENAI" },
            "83877": { "city" : "POST FALLS", "state" : "ID", "county" : "KOOTENAI" },
            "84001": { "city" : "ALTAMONT", "state" : "UT", "county" : "DUCHESNE" },
            "84002": { "city" : "ALTONAH", "state" : "UT", "county" : "DUCHESNE" },
            "84003": { "city" : "AMERICAN FORK", "state" : "UT", "county" : "UTAH" },
            "84004": { "city" : "ALPINE", "state" : "UT", "county" : "UTAH" },"84005": { "city" : "EAGLE MOUNTAIN", "state" : "UT", "county" : "UTAH" },
            "84006": { "city" : "BINGHAM CANYON", "state" : "UT", "county" : "SALT LAKE" },
            "84007": { "city" : "BLUEBELL", "state" : "UT", "county" : "DUCHESNE" },
            "84008": { "city" : "BONANZA", "state" : "UT", "county" : "UINTAH" },
            "84010": { "city" : "BOUNTIFUL", "state" : "UT", "county" : "DAVIS" },
            "84011": { "city" : "BOUNTIFUL", "state" : "UT", "county" : "DAVIS" },
            "84013": { "city" : "CEDAR VALLEY", "state" : "UT", "county" : "UTAH" },
            "84014": { "city" : "CENTERVILLE", "state" : "UT", "county" : "DAVIS" },
            "84015": { "city" : "CLEARFIELD", "state" : "UT", "county" : "DAVIS" },
            "84016": { "city" : "CLEARFIELD", "state" : "UT", "county" : "DAVIS" },
            "84017": { "city" : "COALVILLE", "state" : "UT", "county" : "SUMMIT" },
            "84018": { "city" : "CROYDON", "state" : "UT", "county" : "MORGAN" },
            "84020": { "city" : "DRAPER", "state" : "UT", "county" : "SALT LAKE" },
            "84021": { "city" : "DUCHESNE", "state" : "UT", "county" : "DUCHESNE" },
            "84022": { "city" : "DUGWAY", "state" : "UT", "county" : "TOOELE" },"84023": { "city" : "DUTCH JOHN", "state" : "UT", "county" : "DAGGETT" },
            "84024": { "city" : "ECHO", "state" : "UT", "county" : "SUMMIT" },"84025": { "city" : "FARMINGTON", "state" : "UT", "county" : "DAVIS" },
            "84026": { "city" : "FORT DUCHESNE", "state" : "UT", "county" : "UINTAH" },
            "84027": { "city" : "FRUITLAND", "state" : "UT", "county" : "DUCHESNE" },
            "84028": { "city" : "GARDEN CITY", "state" : "UT", "county" : "RICH" },
            "84029": { "city" : "GRANTSVILLE", "state" : "UT", "county" : "TOOELE" },
            "84031": { "city" : "HANNA", "state" : "UT", "county" : "DUCHESNE" },
            "84032": { "city" : "HEBER CITY", "state" : "UT", "county" : "WASATCH" },
            "84033": { "city" : "HENEFER", "state" : "UT", "county" : "SUMMIT" },
            "84034": { "city" : "IBAPAH", "state" : "UT", "county" : "TOOELE" },"84035": { "city" : "JENSEN", "state" : "UT", "county" : "UINTAH" },
            "84036": { "city" : "KAMAS", "state" : "UT", "county" : "SUMMIT" },"84037": { "city" : "KAYSVILLE", "state" : "UT", "county" : "DAVIS" },
            "84038": { "city" : "LAKETOWN", "state" : "UT", "county" : "RICH" },"84039": { "city" : "LAPOINT", "state" : "UT", "county" : "UINTAH" },
            "84040": { "city" : "LAYTON", "state" : "UT", "county" : "DAVIS" },"84041": { "city" : "LAYTON", "state" : "UT", "county" : "DAVIS" },
            "84042": { "city" : "LINDON", "state" : "UT", "county" : "UTAH" },"84043": { "city" : "LEHI", "state" : "UT", "county" : "UTAH" },
            "84044": { "city" : "MAGNA", "state" : "UT", "county" : "SALT LAKE" },
            "84045": { "city" : "SARATOGA SPRINGS", "state" : "UT", "county" : "UTAH" },
            "84046": { "city" : "MANILA", "state" : "UT", "county" : "DAGGETT" },
            "84047": { "city" : "MIDVALE", "state" : "UT", "county" : "SALT LAKE" },
            "84049": { "city" : "MIDWAY", "state" : "UT", "county" : "WASATCH" },
            "84050": { "city" : "MORGAN", "state" : "UT", "county" : "MORGAN" },"84051": { "city" : "MOUNTAIN HOME", "state" : "UT", "county" : "DUCHESNE" },
            "84052": { "city" : "MYTON", "state" : "UT", "county" : "DUCHESNE" },
            "84053": { "city" : "NEOLA", "state" : "UT", "county" : "DUCHESNE" },
            "84054": { "city" : "NORTH SALT LAKE", "state" : "UT", "county" : "DAVIS" },
            "84055": { "city" : "OAKLEY", "state" : "UT", "county" : "SUMMIT" },"84056": { "city" : "HILL AFB", "state" : "UT", "county" : "DAVIS" },
            "84057": { "city" : "OREM", "state" : "UT", "county" : "UTAH" },"84058": { "city" : "OREM", "state" : "UT", "county" : "UTAH" },
            "84059": { "city" : "OREM", "state" : "UT", "county" : "UTAH" },"84060": { "city" : "PARK CITY", "state" : "UT", "county" : "SUMMIT" },
            "84061": { "city" : "PEOA", "state" : "UT", "county" : "SUMMIT" },"84062": { "city" : "PLEASANT GROVE", "state" : "UT", "county" : "UTAH" },
            "84063": { "city" : "RANDLETT", "state" : "UT", "county" : "UINTAH" },
            "84064": { "city" : "RANDOLPH", "state" : "UT", "county" : "RICH" },"84065": { "city" : "RIVERTON", "state" : "UT", "county" : "SALT LAKE" },
            "84066": { "city" : "ROOSEVELT", "state" : "UT", "county" : "DUCHESNE" },
            "84067": { "city" : "ROY", "state" : "UT", "county" : "WEBER" },"84068": { "city" : "PARK CITY", "state" : "UT", "county" : "SUMMIT" },
            "84069": { "city" : "RUSH VALLEY", "state" : "UT", "county" : "TOOELE" },
            "84070": { "city" : "SANDY", "state" : "UT", "county" : "SALT LAKE" },
            "84071": { "city" : "STOCKTON", "state" : "UT", "county" : "TOOELE" },
            "84072": { "city" : "TABIONA", "state" : "UT", "county" : "DUCHESNE" },
            "84073": { "city" : "TALMAGE", "state" : "UT", "county" : "DUCHESNE" },
            "84074": { "city" : "TOOELE", "state" : "UT", "county" : "TOOELE" },"84075": { "city" : "SYRACUSE", "state" : "UT", "county" : "DAVIS" },
            "84076": { "city" : "TRIDELL", "state" : "UT", "county" : "UINTAH" },
            "84078": { "city" : "VERNAL", "state" : "UT", "county" : "UINTAH" },"84079": { "city" : "VERNAL", "state" : "UT", "county" : "UINTAH" },
            "84080": { "city" : "VERNON", "state" : "UT", "county" : "TOOELE" },"84081": { "city" : "WEST JORDAN", "state" : "UT", "county" : "SALT LAKE" },
            "84082": { "city" : "WALLSBURG", "state" : "UT", "county" : "WASATCH" },
            "84083": { "city" : "WENDOVER", "state" : "UT", "county" : "TOOELE" },
            "84084": { "city" : "WEST JORDAN", "state" : "UT", "county" : "SALT LAKE" },
            "84085": { "city" : "WHITEROCKS", "state" : "UT", "county" : "UINTAH" },
            "84086": { "city" : "WOODRUFF", "state" : "UT", "county" : "RICH" },"84087": { "city" : "WOODS CROSS", "state" : "UT", "county" : "DAVIS" },
            "84088": { "city" : "WEST JORDAN", "state" : "UT", "county" : "SALT LAKE" },
            "84089": { "city" : "CLEARFIELD", "state" : "UT", "county" : "DAVIS" },
            "84090": { "city" : "SANDY", "state" : "UT", "county" : "SALT LAKE" },
            "84091": { "city" : "SANDY", "state" : "UT", "county" : "SALT LAKE" },
            "84092": { "city" : "SANDY", "state" : "UT", "county" : "SALT LAKE" },
            "84093": { "city" : "SANDY", "state" : "UT", "county" : "SALT LAKE" },
            "84094": { "city" : "SANDY", "state" : "UT", "county" : "SALT LAKE" },
            "84095": { "city" : "SOUTH JORDAN", "state" : "UT", "county" : "SALT LAKE" },
            "84096": { "city" : "HERRIMAN", "state" : "UT", "county" : "SALT LAKE" },
            "84097": { "city" : "OREM", "state" : "UT", "county" : "UTAH" },"84098": { "city" : "PARK CITY", "state" : "UT", "county" : "SUMMIT" },
            "84101": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84102": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84103": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84104": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84105": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84106": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84107": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84108": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84109": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84110": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84111": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84112": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84113": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84114": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84115": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84116": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84117": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84118": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84119": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84120": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84121": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84122": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84123": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84124": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84125": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84126": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84127": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84128": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84129": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84130": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84132": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84133": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84134": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84138": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84139": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84143": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84144": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84145": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84147": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84148": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84150": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84152": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84157": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84158": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84165": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84170": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84171": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84180": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84184": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84190": { "city" : "SALT LAKE CITY", "state" : "UT", "county" : "SALT LAKE" },
            "84201": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },"84301": { "city" : "BEAR RIVER CITY", "state" : "UT", "county" : "BOX ELDER" },
            "84302": { "city" : "BRIGHAM CITY", "state" : "UT", "county" : "BOX ELDER" },
            "84304": { "city" : "CACHE JUNCTION", "state" : "UT", "county" : "CACHE" },
            "84305": { "city" : "CLARKSTON", "state" : "UT", "county" : "CACHE" },
            "84306": { "city" : "COLLINSTON", "state" : "UT", "county" : "BOX ELDER" },
            "84307": { "city" : "CORINNE", "state" : "UT", "county" : "BOX ELDER" },
            "84308": { "city" : "CORNISH", "state" : "UT", "county" : "CACHE" },"84309": { "city" : "DEWEYVILLE", "state" : "UT", "county" : "BOX ELDER" },
            "84310": { "city" : "EDEN", "state" : "UT", "county" : "WEBER" },"84311": { "city" : "FIELDING", "state" : "UT", "county" : "BOX ELDER" },
            "84312": { "city" : "GARLAND", "state" : "UT", "county" : "BOX ELDER" },
            "84313": { "city" : "GROUSE CREEK", "state" : "UT", "county" : "BOX ELDER" },
            "84314": { "city" : "HONEYVILLE", "state" : "UT", "county" : "BOX ELDER" },
            "84315": { "city" : "HOOPER", "state" : "UT", "county" : "WEBER" },"84316": { "city" : "HOWELL", "state" : "UT", "county" : "BOX ELDER" },
            "84317": { "city" : "HUNTSVILLE", "state" : "UT", "county" : "WEBER" },
            "84318": { "city" : "HYDE PARK", "state" : "UT", "county" : "CACHE" },
            "84319": { "city" : "HYRUM", "state" : "UT", "county" : "CACHE" },"84320": { "city" : "LEWISTON", "state" : "UT", "county" : "CACHE" },
            "84321": { "city" : "LOGAN", "state" : "UT", "county" : "CACHE" },"84322": { "city" : "LOGAN", "state" : "UT", "county" : "CACHE" },
            "84323": { "city" : "LOGAN", "state" : "UT", "county" : "CACHE" },"84324": { "city" : "MANTUA", "state" : "UT", "county" : "BOX ELDER" },
            "84325": { "city" : "MENDON", "state" : "UT", "county" : "CACHE" },"84326": { "city" : "MILLVILLE", "state" : "UT", "county" : "CACHE" },
            "84327": { "city" : "NEWTON", "state" : "UT", "county" : "CACHE" },"84328": { "city" : "PARADISE", "state" : "UT", "county" : "CACHE" },
            "84330": { "city" : "PLYMOUTH", "state" : "UT", "county" : "BOX ELDER" },
            "84331": { "city" : "PORTAGE", "state" : "UT", "county" : "BOX ELDER" },
            "84332": { "city" : "PROVIDENCE", "state" : "UT", "county" : "CACHE" },
            "84333": { "city" : "RICHMOND", "state" : "UT", "county" : "CACHE" },
            "84334": { "city" : "RIVERSIDE", "state" : "UT", "county" : "BOX ELDER" },
            "84335": { "city" : "SMITHFIELD", "state" : "UT", "county" : "CACHE" },
            "84336": { "city" : "SNOWVILLE", "state" : "UT", "county" : "BOX ELDER" },
            "84337": { "city" : "TREMONTON", "state" : "UT", "county" : "BOX ELDER" },
            "84338": { "city" : "TRENTON", "state" : "UT", "county" : "CACHE" },"84339": { "city" : "WELLSVILLE", "state" : "UT", "county" : "CACHE" },
            "84340": { "city" : "WILLARD", "state" : "UT", "county" : "BOX ELDER" },
            "84341": { "city" : "LOGAN", "state" : "UT", "county" : "CACHE" },"84401": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },
            "84402": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },"84403": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },
            "84404": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },"84405": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },
            "84407": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },"84408": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },
            "84409": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },"84412": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },
            "84414": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },"84415": { "city" : "OGDEN", "state" : "UT", "county" : "WEBER" },
            "84501": { "city" : "PRICE", "state" : "UT", "county" : "CARBON" },"84510": { "city" : "ANETH", "state" : "UT", "county" : "SAN JUAN" },
            "84511": { "city" : "BLANDING", "state" : "UT", "county" : "SAN JUAN" },
            "84512": { "city" : "BLUFF", "state" : "UT", "county" : "SAN JUAN" },
            "84513": { "city" : "CASTLE DALE", "state" : "UT", "county" : "EMERY" },
            "84515": { "city" : "CISCO", "state" : "UT", "county" : "GRAND" },"84518": { "city" : "CLEVELAND", "state" : "UT", "county" : "EMERY" },
            "84520": { "city" : "EAST CARBON", "state" : "UT", "county" : "CARBON" },
            "84521": { "city" : "ELMO", "state" : "UT", "county" : "EMERY" },"84522": { "city" : "EMERY", "state" : "UT", "county" : "EMERY" },
            "84523": { "city" : "FERRON", "state" : "UT", "county" : "EMERY" },"84525": { "city" : "GREEN RIVER", "state" : "UT", "county" : "EMERY" },
            "84526": { "city" : "HELPER", "state" : "UT", "county" : "CARBON" },"84528": { "city" : "HUNTINGTON", "state" : "UT", "county" : "EMERY" },
            "84530": { "city" : "LA SAL", "state" : "UT", "county" : "SAN JUAN" },
            "84531": { "city" : "MEXICAN HAT", "state" : "UT", "county" : "SAN JUAN" },
            "84532": { "city" : "MOAB", "state" : "UT", "county" : "GRAND" },"84533": { "city" : "LAKE POWELL", "state" : "UT", "county" : "SAN JUAN" },
            "84534": { "city" : "MONTEZUMA CREEK", "state" : "UT", "county" : "SAN JUAN" },
            "84535": { "city" : "MONTICELLO", "state" : "UT", "county" : "SAN JUAN" },
            "84536": { "city" : "MONUMENT VALLEY", "state" : "UT", "county" : "SAN JUAN" },
            "84537": { "city" : "ORANGEVILLE", "state" : "UT", "county" : "EMERY" },
            "84539": { "city" : "SUNNYSIDE", "state" : "UT", "county" : "CARBON" },
            "84540": { "city" : "THOMPSON", "state" : "UT", "county" : "GRAND" },
            "84542": { "city" : "WELLINGTON", "state" : "UT", "county" : "CARBON" },
            "84601": { "city" : "PROVO", "state" : "UT", "county" : "UTAH" },"84602": { "city" : "PROVO", "state" : "UT", "county" : "UTAH" },
            "84603": { "city" : "PROVO", "state" : "UT", "county" : "UTAH" },"84604": { "city" : "PROVO", "state" : "UT", "county" : "UTAH" },
            "84605": { "city" : "PROVO", "state" : "UT", "county" : "UTAH" },"84606": { "city" : "PROVO", "state" : "UT", "county" : "UTAH" },
            "84620": { "city" : "AURORA", "state" : "UT", "county" : "SEVIER" },"84621": { "city" : "AXTELL", "state" : "UT", "county" : "SANPETE" },
            "84622": { "city" : "CENTERFIELD", "state" : "UT", "county" : "SANPETE" },
            "84623": { "city" : "CHESTER", "state" : "UT", "county" : "SANPETE" },
            "84624": { "city" : "DELTA", "state" : "UT", "county" : "MILLARD" },"84626": { "city" : "ELBERTA", "state" : "UT", "county" : "UTAH" },
            "84627": { "city" : "EPHRAIM", "state" : "UT", "county" : "SANPETE" },
            "84628": { "city" : "EUREKA", "state" : "UT", "county" : "JUAB" },"84629": { "city" : "FAIRVIEW", "state" : "UT", "county" : "SANPETE" },
            "84630": { "city" : "FAYETTE", "state" : "UT", "county" : "SANPETE" },
            "84631": { "city" : "FILLMORE", "state" : "UT", "county" : "MILLARD" },
            "84632": { "city" : "FOUNTAIN GREEN", "state" : "UT", "county" : "SANPETE" },
            "84633": { "city" : "GOSHEN", "state" : "UT", "county" : "UTAH" },"84634": { "city" : "GUNNISON", "state" : "UT", "county" : "SANPETE" },
            "84635": { "city" : "HINCKLEY", "state" : "UT", "county" : "MILLARD" },
            "84636": { "city" : "HOLDEN", "state" : "UT", "county" : "MILLARD" },
            "84637": { "city" : "KANOSH", "state" : "UT", "county" : "MILLARD" },
            "84638": { "city" : "LEAMINGTON", "state" : "UT", "county" : "MILLARD" },
            "84639": { "city" : "LEVAN", "state" : "UT", "county" : "JUAB" },"84640": { "city" : "LYNNDYL", "state" : "UT", "county" : "MILLARD" },
            "84642": { "city" : "MANTI", "state" : "UT", "county" : "SANPETE" },"84643": { "city" : "MAYFIELD", "state" : "UT", "county" : "SANPETE" },
            "84644": { "city" : "MEADOW", "state" : "UT", "county" : "MILLARD" },
            "84645": { "city" : "MONA", "state" : "UT", "county" : "JUAB" },"84646": { "city" : "MORONI", "state" : "UT", "county" : "SANPETE" },
            "84647": { "city" : "MOUNT PLEASANT", "state" : "UT", "county" : "SANPETE" },
            "84648": { "city" : "NEPHI", "state" : "UT", "county" : "JUAB" },"84649": { "city" : "OAK CITY", "state" : "UT", "county" : "MILLARD" },
            "84651": { "city" : "PAYSON", "state" : "UT", "county" : "UTAH" },"84652": { "city" : "REDMOND", "state" : "UT", "county" : "SEVIER" },
            "84653": { "city" : "SALEM", "state" : "UT", "county" : "UTAH" },"84654": { "city" : "SALINA", "state" : "UT", "county" : "SEVIER" },
            "84655": { "city" : "SANTAQUIN", "state" : "UT", "county" : "UTAH" },
            "84656": { "city" : "SCIPIO", "state" : "UT", "county" : "MILLARD" },
            "84657": { "city" : "SIGURD", "state" : "UT", "county" : "SEVIER" },"84660": { "city" : "SPANISH FORK", "state" : "UT", "county" : "UTAH" },
            "84662": { "city" : "SPRING CITY", "state" : "UT", "county" : "SANPETE" },
            "84663": { "city" : "SPRINGVILLE", "state" : "UT", "county" : "UTAH" },
            "84664": { "city" : "MAPLETON", "state" : "UT", "county" : "UTAH" },"84665": { "city" : "STERLING", "state" : "UT", "county" : "SANPETE" },
            "84667": { "city" : "WALES", "state" : "UT", "county" : "SANPETE" },"84701": { "city" : "RICHFIELD", "state" : "UT", "county" : "SEVIER" },
            "84710": { "city" : "ALTON", "state" : "UT", "county" : "KANE" },"84711": { "city" : "ANNABELLA", "state" : "UT", "county" : "SEVIER" },
            "84712": { "city" : "ANTIMONY", "state" : "UT", "county" : "GARFIELD" },
            "84713": { "city" : "BEAVER", "state" : "UT", "county" : "BEAVER" },"84714": { "city" : "BERYL", "state" : "UT", "county" : "IRON" },
            "84715": { "city" : "BICKNELL", "state" : "UT", "county" : "WAYNE" },
            "84716": { "city" : "BOULDER", "state" : "UT", "county" : "GARFIELD" },
            "84718": { "city" : "CANNONVILLE", "state" : "UT", "county" : "GARFIELD" },
            "84719": { "city" : "BRIAN HEAD", "state" : "UT", "county" : "IRON" },
            "84720": { "city" : "CEDAR CITY", "state" : "UT", "county" : "IRON" },
            "84721": { "city" : "CEDAR CITY", "state" : "UT", "county" : "IRON" },
            "84722": { "city" : "CENTRAL", "state" : "UT", "county" : "WASHINGTON" },
            "84723": { "city" : "CIRCLEVILLE", "state" : "UT", "county" : "PIUTE" },
            "84724": { "city" : "ELSINORE", "state" : "UT", "county" : "SEVIER" },
            "84725": { "city" : "ENTERPRISE", "state" : "UT", "county" : "WASHINGTON" },
            "84726": { "city" : "ESCALANTE", "state" : "UT", "county" : "GARFIELD" },
            "84728": { "city" : "GARRISON", "state" : "UT", "county" : "MILLARD" },
            "84729": { "city" : "GLENDALE", "state" : "UT", "county" : "KANE" },"84730": { "city" : "GLENWOOD", "state" : "UT", "county" : "SEVIER" },
            "84731": { "city" : "GREENVILLE", "state" : "UT", "county" : "BEAVER" },
            "84733": { "city" : "GUNLOCK", "state" : "UT", "county" : "WASHINGTON" },
            "84734": { "city" : "HANKSVILLE", "state" : "UT", "county" : "WAYNE" },
            "84735": { "city" : "HATCH", "state" : "UT", "county" : "GARFIELD" },
            "84736": { "city" : "HENRIEVILLE", "state" : "UT", "county" : "GARFIELD" },
            "84737": { "city" : "HURRICANE", "state" : "UT", "county" : "WASHINGTON" },
            "84738": { "city" : "IVINS", "state" : "UT", "county" : "WASHINGTON" },
            "84739": { "city" : "JOSEPH", "state" : "UT", "county" : "SEVIER" },"84740": { "city" : "JUNCTION", "state" : "UT", "county" : "PIUTE" },
            "84741": { "city" : "KANAB", "state" : "UT", "county" : "KANE" },"84742": { "city" : "KANARRAVILLE", "state" : "UT", "county" : "IRON" },
            "84743": { "city" : "KINGSTON", "state" : "UT", "county" : "PIUTE" },
            "84744": { "city" : "KOOSHAREM", "state" : "UT", "county" : "SEVIER" },
            "84745": { "city" : "LA VERKIN", "state" : "UT", "county" : "WASHINGTON" },
            "84746": { "city" : "LEEDS", "state" : "UT", "county" : "WASHINGTON" },
            "84747": { "city" : "LOA", "state" : "UT", "county" : "WAYNE" },"84749": { "city" : "LYMAN", "state" : "UT", "county" : "WAYNE" },
            "84750": { "city" : "MARYSVALE", "state" : "UT", "county" : "PIUTE" },
            "84751": { "city" : "MILFORD", "state" : "UT", "county" : "BEAVER" },
            "84752": { "city" : "MINERSVILLE", "state" : "UT", "county" : "BEAVER" },
            "84753": { "city" : "MODENA", "state" : "UT", "county" : "IRON" },"84754": { "city" : "MONROE", "state" : "UT", "county" : "SEVIER" },
            "84755": { "city" : "MOUNT CARMEL", "state" : "UT", "county" : "KANE" },
            "84756": { "city" : "NEWCASTLE", "state" : "UT", "county" : "IRON" },
            "84757": { "city" : "NEW HARMONY", "state" : "UT", "county" : "WASHINGTON" },
            "84758": { "city" : "ORDERVILLE", "state" : "UT", "county" : "KANE" },
            "84759": { "city" : "PANGUITCH", "state" : "UT", "county" : "GARFIELD" },
            "84760": { "city" : "PARAGONAH", "state" : "UT", "county" : "IRON" },
            "84761": { "city" : "PAROWAN", "state" : "UT", "county" : "IRON" },"84762": { "city" : "DUCK CREEK VILLAGE", "state" : "UT", "county" : "KANE" },
            "84763": { "city" : "ROCKVILLE", "state" : "UT", "county" : "WASHINGTON" },
            "84764": { "city" : "BRYCE", "state" : "UT", "county" : "GARFIELD" },
            "84765": { "city" : "SANTA CLARA", "state" : "UT", "county" : "WASHINGTON" },
            "84766": { "city" : "SEVIER", "state" : "UT", "county" : "SEVIER" },"84767": { "city" : "SPRINGDALE", "state" : "UT", "county" : "WASHINGTON" },
            "84770": { "city" : "SAINT GEORGE", "state" : "UT", "county" : "WASHINGTON" },
            "84771": { "city" : "SAINT GEORGE", "state" : "UT", "county" : "WASHINGTON" },
            "84772": { "city" : "SUMMIT", "state" : "UT", "county" : "IRON" },"84773": { "city" : "TEASDALE", "state" : "UT", "county" : "WAYNE" },
            "84774": { "city" : "TOQUERVILLE", "state" : "UT", "county" : "WASHINGTON" },
            "84775": { "city" : "TORREY", "state" : "UT", "county" : "WAYNE" },"84776": { "city" : "TROPIC", "state" : "UT", "county" : "GARFIELD" },
            "84779": { "city" : "VIRGIN", "state" : "UT", "county" : "WASHINGTON" },
            "84780": { "city" : "WASHINGTON", "state" : "UT", "county" : "WASHINGTON" },
            "84781": { "city" : "PINE VALLEY", "state" : "UT", "county" : "WASHINGTON" },
            "84782": { "city" : "VEYO", "state" : "UT", "county" : "WASHINGTON" },
            "84783": { "city" : "DAMMERON VALLEY", "state" : "UT", "county" : "WASHINGTON" },
            "84784": { "city" : "HILDALE", "state" : "UT", "county" : "WASHINGTON" },
            "84790": { "city" : "SAINT GEORGE", "state" : "UT", "county" : "WASHINGTON" },
            "84791": { "city" : "SAINT GEORGE", "state" : "UT", "county" : "WASHINGTON" },
            "85001": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85002": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85003": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85004": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85005": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85006": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85007": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85008": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85009": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85010": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85011": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85012": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85013": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85014": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85015": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85016": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85017": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85018": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85019": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85020": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85021": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85022": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85023": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85024": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85025": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85026": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85027": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85028": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85029": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85030": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85031": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85032": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85033": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85034": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85035": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85036": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85037": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85038": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85039": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85040": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85041": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85042": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85043": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85044": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85045": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85046": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85048": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85050": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85051": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85053": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85054": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85055": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85060": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85061": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85062": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85063": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85064": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85066": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85067": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85068": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85069": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85070": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85071": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85072": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85073": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85074": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85075": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85076": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85078": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85079": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85080": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85082": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85083": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85085": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85086": { "city" : "PHOENIX", "state" : "AZ", "county" : "MARICOPA" },
            "85087": { "city" : "NEW RIVER", "state" : "AZ", "county" : "MARICOPA" },
            "85117": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85118": { "city" : "GOLD CANYON", "state" : "AZ", "county" : "PINAL" },
            "85119": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85120": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85122": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85123": { "city" : "ARIZONA CITY", "state" : "AZ", "county" : "PINAL" },
            "85127": { "city" : "CHANDLER HEIGHTS", "state" : "AZ", "county" : "MARICOPA" },
            "85128": { "city" : "COOLIDGE", "state" : "AZ", "county" : "PINAL" },
            "85130": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85131": { "city" : "ELOY", "state" : "AZ", "county" : "PINAL" },"85132": { "city" : "FLORENCE", "state" : "AZ", "county" : "PINAL" },
            "85137": { "city" : "KEARNY", "state" : "AZ", "county" : "PINAL" },"85138": { "city" : "MARICOPA", "state" : "AZ", "county" : "PINAL" },
            "85139": { "city" : "MARICOPA", "state" : "AZ", "county" : "PINAL" },
            "85140": { "city" : "SAN TAN VALLEY", "state" : "AZ", "county" : "PINAL" },
            "85141": { "city" : "PICACHO", "state" : "AZ", "county" : "PINAL" },"85142": { "city" : "QUEEN CREEK", "state" : "AZ", "county" : "MARICOPA" },
            "85143": { "city" : "SAN TAN VALLEY", "state" : "AZ", "county" : "PINAL" },
            "85145": { "city" : "RED ROCK", "state" : "AZ", "county" : "PINAL" },
            "85172": { "city" : "STANFIELD", "state" : "AZ", "county" : "PINAL" },
            "85173": { "city" : "SUPERIOR", "state" : "AZ", "county" : "PINAL" },
            "85178": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85191": { "city" : "VALLEY FARMS", "state" : "AZ", "county" : "PINAL" },
            "85193": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85194": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85201": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85202": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85203": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85204": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85205": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85206": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85207": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85208": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85209": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85210": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85211": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85212": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85213": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85214": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85215": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85216": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85217": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85218": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85219": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85220": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85221": { "city" : "BAPCHULE", "state" : "AZ", "county" : "PINAL" },
            "85222": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85223": { "city" : "ARIZONA CITY", "state" : "AZ", "county" : "PINAL" },
            "85224": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85225": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85226": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85227": { "city" : "CHANDLER HEIGHTS", "state" : "AZ", "county" : "MARICOPA" },
            "85228": { "city" : "COOLIDGE", "state" : "AZ", "county" : "PINAL" },
            "85230": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85231": { "city" : "ELOY", "state" : "AZ", "county" : "PINAL" },"85232": { "city" : "FLORENCE", "state" : "AZ", "county" : "PINAL" },
            "85233": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85234": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85235": { "city" : "HAYDEN", "state" : "AZ", "county" : "GILA" },"85236": { "city" : "HIGLEY", "state" : "AZ", "county" : "MARICOPA" },
            "85237": { "city" : "KEARNY", "state" : "AZ", "county" : "PINAL" },"85238": { "city" : "MARICOPA", "state" : "AZ", "county" : "PINAL" },
            "85239": { "city" : "MARICOPA", "state" : "AZ", "county" : "PINAL" },
            "85240": { "city" : "QUEEN CREEK", "state" : "AZ", "county" : "PINAL" },
            "85241": { "city" : "PICACHO", "state" : "AZ", "county" : "PINAL" },"85242": { "city" : "QUEEN CREEK", "state" : "AZ", "county" : "MARICOPA" },
            "85243": { "city" : "QUEEN CREEK", "state" : "AZ", "county" : "PINAL" },
            "85244": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85245": { "city" : "RED ROCK", "state" : "AZ", "county" : "PINAL" },
            "85246": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85247": { "city" : "SACATON", "state" : "AZ", "county" : "PINAL" },"85248": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85249": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85250": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85251": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85252": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85253": { "city" : "PARADISE VALLEY", "state" : "AZ", "county" : "MARICOPA" },
            "85254": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85255": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85256": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85257": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85258": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85259": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85260": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85261": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85262": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85263": { "city" : "RIO VERDE", "state" : "AZ", "county" : "MARICOPA" },
            "85264": { "city" : "FORT MCDOWELL", "state" : "AZ", "county" : "MARICOPA" },
            "85266": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85267": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85268": { "city" : "FOUNTAIN HILLS", "state" : "AZ", "county" : "MARICOPA" },
            "85269": { "city" : "FOUNTAIN HILLS", "state" : "AZ", "county" : "MARICOPA" },
            "85271": { "city" : "SCOTTSDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85272": { "city" : "STANFIELD", "state" : "AZ", "county" : "PINAL" },
            "85273": { "city" : "SUPERIOR", "state" : "AZ", "county" : "PINAL" },
            "85274": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85275": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },
            "85277": { "city" : "MESA", "state" : "AZ", "county" : "MARICOPA" },"85278": { "city" : "APACHE JUNCTION", "state" : "AZ", "county" : "PINAL" },
            "85280": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85281": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85282": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85283": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85284": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85285": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85286": { "city" : "CHANDLER", "state" : "AZ", "county" : "MARICOPA" },
            "85287": { "city" : "TEMPE", "state" : "AZ", "county" : "MARICOPA" },
            "85290": { "city" : "TORTILLA FLAT", "state" : "AZ", "county" : "MARICOPA" },
            "85291": { "city" : "VALLEY FARMS", "state" : "AZ", "county" : "PINAL" },
            "85292": { "city" : "WINKELMAN", "state" : "AZ", "county" : "GILA" },
            "85293": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85294": { "city" : "CASA GRANDE", "state" : "AZ", "county" : "PINAL" },
            "85295": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85296": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85297": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85298": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85299": { "city" : "GILBERT", "state" : "AZ", "county" : "MARICOPA" },
            "85301": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85302": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85303": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85304": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85305": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85306": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85307": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85308": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85309": { "city" : "GLENDALE LUKE AFB", "state" : "AZ", "county" : "MARICOPA" },
            "85310": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85311": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85312": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85318": { "city" : "GLENDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85320": { "city" : "AGUILA", "state" : "AZ", "county" : "MARICOPA" },
            "85321": { "city" : "AJO", "state" : "AZ", "county" : "PIMA" },"85322": { "city" : "ARLINGTON", "state" : "AZ", "county" : "MARICOPA" },
            "85323": { "city" : "AVONDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85324": { "city" : "BLACK CANYON CITY", "state" : "AZ", "county" : "YAVAPAI" },
            "85325": { "city" : "BOUSE", "state" : "AZ", "county" : "LA PAZ" },"85326": { "city" : "BUCKEYE", "state" : "AZ", "county" : "MARICOPA" },
            "85327": { "city" : "CAVE CREEK", "state" : "AZ", "county" : "MARICOPA" },
            "85328": { "city" : "CIBOLA", "state" : "AZ", "county" : "LA PAZ" },"85329": { "city" : "CASHION", "state" : "AZ", "county" : "MARICOPA" },
            "85331": { "city" : "CAVE CREEK", "state" : "AZ", "county" : "MARICOPA" },
            "85332": { "city" : "CONGRESS", "state" : "AZ", "county" : "YAVAPAI" },
            "85333": { "city" : "DATELAND", "state" : "AZ", "county" : "YUMA" },"85334": { "city" : "EHRENBERG", "state" : "AZ", "county" : "LA PAZ" },
            "85335": { "city" : "EL MIRAGE", "state" : "AZ", "county" : "MARICOPA" },
            "85336": { "city" : "GADSDEN", "state" : "AZ", "county" : "YUMA" },"85337": { "city" : "GILA BEND", "state" : "AZ", "county" : "MARICOPA" },
            "85338": { "city" : "GOODYEAR", "state" : "AZ", "county" : "MARICOPA" },
            "85339": { "city" : "LAVEEN", "state" : "AZ", "county" : "MARICOPA" },
            "85340": { "city" : "LITCHFIELD PARK", "state" : "AZ", "county" : "MARICOPA" },
            "85341": { "city" : "LUKEVILLE", "state" : "AZ", "county" : "PIMA" },
            "85342": { "city" : "MORRISTOWN", "state" : "AZ", "county" : "MARICOPA" },
            "85343": { "city" : "PALO VERDE", "state" : "AZ", "county" : "MARICOPA" },
            "85344": { "city" : "PARKER", "state" : "AZ", "county" : "LA PAZ" },"85345": { "city" : "PEORIA", "state" : "AZ", "county" : "MARICOPA" },
            "85346": { "city" : "QUARTZSITE", "state" : "AZ", "county" : "LA PAZ" },
            "85347": { "city" : "ROLL", "state" : "AZ", "county" : "YUMA" },"85348": { "city" : "SALOME", "state" : "AZ", "county" : "LA PAZ" },
            "85349": { "city" : "SAN LUIS", "state" : "AZ", "county" : "YUMA" },"85350": { "city" : "SOMERTON", "state" : "AZ", "county" : "YUMA" },
            "85351": { "city" : "SUN CITY", "state" : "AZ", "county" : "MARICOPA" },
            "85352": { "city" : "TACNA", "state" : "AZ", "county" : "YUMA" },"85353": { "city" : "TOLLESON", "state" : "AZ", "county" : "MARICOPA" },
            "85354": { "city" : "TONOPAH", "state" : "AZ", "county" : "MARICOPA" },
            "85355": { "city" : "WADDELL", "state" : "AZ", "county" : "MARICOPA" },
            "85356": { "city" : "WELLTON", "state" : "AZ", "county" : "YUMA" },"85357": { "city" : "WENDEN", "state" : "AZ", "county" : "LA PAZ" },
            "85358": { "city" : "WICKENBURG", "state" : "AZ", "county" : "MARICOPA" },
            "85359": { "city" : "QUARTZSITE", "state" : "AZ", "county" : "LA PAZ" },
            "85360": { "city" : "WIKIEUP", "state" : "AZ", "county" : "MOHAVE" },
            "85361": { "city" : "WITTMANN", "state" : "AZ", "county" : "MARICOPA" },
            "85362": { "city" : "YARNELL", "state" : "AZ", "county" : "YAVAPAI" },
            "85363": { "city" : "YOUNGTOWN", "state" : "AZ", "county" : "MARICOPA" },
            "85364": { "city" : "YUMA", "state" : "AZ", "county" : "YUMA" },"85365": { "city" : "YUMA", "state" : "AZ", "county" : "YUMA" },
            "85366": { "city" : "YUMA", "state" : "AZ", "county" : "YUMA" },"85367": { "city" : "YUMA", "state" : "AZ", "county" : "YUMA" },
            "85369": { "city" : "YUMA", "state" : "AZ", "county" : "YUMA" },"85371": { "city" : "POSTON", "state" : "AZ", "county" : "LA PAZ" },
            "85372": { "city" : "SUN CITY", "state" : "AZ", "county" : "MARICOPA" },
            "85373": { "city" : "SUN CITY", "state" : "AZ", "county" : "MARICOPA" },
            "85374": { "city" : "SURPRISE", "state" : "AZ", "county" : "MARICOPA" },
            "85375": { "city" : "SUN CITY WEST", "state" : "AZ", "county" : "MARICOPA" },
            "85376": { "city" : "SUN CITY WEST", "state" : "AZ", "county" : "MARICOPA" },
            "85377": { "city" : "CAREFREE", "state" : "AZ", "county" : "MARICOPA" },
            "85378": { "city" : "SURPRISE", "state" : "AZ", "county" : "MARICOPA" },
            "85379": { "city" : "SURPRISE", "state" : "AZ", "county" : "MARICOPA" },
            "85380": { "city" : "PEORIA", "state" : "AZ", "county" : "MARICOPA" },
            "85381": { "city" : "PEORIA", "state" : "AZ", "county" : "MARICOPA" },
            "85382": { "city" : "PEORIA", "state" : "AZ", "county" : "MARICOPA" },
            "85383": { "city" : "PEORIA", "state" : "AZ", "county" : "MARICOPA" },
            "85385": { "city" : "PEORIA", "state" : "AZ", "county" : "MARICOPA" },
            "85387": { "city" : "SURPRISE", "state" : "AZ", "county" : "MARICOPA" },
            "85388": { "city" : "SURPRISE", "state" : "AZ", "county" : "MARICOPA" },
            "85390": { "city" : "WICKENBURG", "state" : "AZ", "county" : "MARICOPA" },
            "85392": { "city" : "AVONDALE", "state" : "AZ", "county" : "MARICOPA" },
            "85395": { "city" : "GOODYEAR", "state" : "AZ", "county" : "MARICOPA" },
            "85396": { "city" : "BUCKEYE", "state" : "AZ", "county" : "MARICOPA" },
            "85501": { "city" : "GLOBE", "state" : "AZ", "county" : "GILA" },"85502": { "city" : "GLOBE", "state" : "AZ", "county" : "GILA" },
            "85530": { "city" : "BYLAS", "state" : "AZ", "county" : "GRAHAM" },"85531": { "city" : "CENTRAL", "state" : "AZ", "county" : "GRAHAM" },
            "85532": { "city" : "CLAYPOOL", "state" : "AZ", "county" : "GILA" },"85533": { "city" : "CLIFTON", "state" : "AZ", "county" : "GREENLEE" },
            "85534": { "city" : "DUNCAN", "state" : "AZ", "county" : "GREENLEE" },
            "85535": { "city" : "EDEN", "state" : "AZ", "county" : "GRAHAM" },"85536": { "city" : "FORT THOMAS", "state" : "AZ", "county" : "GRAHAM" },
            "85539": { "city" : "MIAMI", "state" : "AZ", "county" : "GILA" },"85540": { "city" : "MORENCI", "state" : "AZ", "county" : "GREENLEE" },
            "85541": { "city" : "PAYSON", "state" : "AZ", "county" : "GILA" },"85542": { "city" : "PERIDOT", "state" : "AZ", "county" : "GILA" },
            "85543": { "city" : "PIMA", "state" : "AZ", "county" : "GRAHAM" },"85544": { "city" : "PINE", "state" : "AZ", "county" : "GILA" },
            "85545": { "city" : "ROOSEVELT", "state" : "AZ", "county" : "GILA" },
            "85546": { "city" : "SAFFORD", "state" : "AZ", "county" : "GRAHAM" },
            "85547": { "city" : "PAYSON", "state" : "AZ", "county" : "GILA" },"85548": { "city" : "SAFFORD", "state" : "AZ", "county" : "GRAHAM" },
            "85550": { "city" : "SAN CARLOS", "state" : "AZ", "county" : "GILA" },
            "85551": { "city" : "SOLOMON", "state" : "AZ", "county" : "GRAHAM" },
            "85552": { "city" : "THATCHER", "state" : "AZ", "county" : "GRAHAM" },
            "85553": { "city" : "TONTO BASIN", "state" : "AZ", "county" : "GILA" },
            "85554": { "city" : "YOUNG", "state" : "AZ", "county" : "GILA" },"85601": { "city" : "ARIVACA", "state" : "AZ", "county" : "PIMA" },
            "85602": { "city" : "BENSON", "state" : "AZ", "county" : "COCHISE" },
            "85603": { "city" : "BISBEE", "state" : "AZ", "county" : "COCHISE" },
            "85605": { "city" : "BOWIE", "state" : "AZ", "county" : "COCHISE" },"85606": { "city" : "COCHISE", "state" : "AZ", "county" : "COCHISE" },
            "85607": { "city" : "DOUGLAS", "state" : "AZ", "county" : "COCHISE" },
            "85608": { "city" : "DOUGLAS", "state" : "AZ", "county" : "COCHISE" },
            "85609": { "city" : "DRAGOON", "state" : "AZ", "county" : "COCHISE" },
            "85610": { "city" : "ELFRIDA", "state" : "AZ", "county" : "COCHISE" },
            "85611": { "city" : "ELGIN", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85613": { "city" : "FORT HUACHUCA", "state" : "AZ", "county" : "COCHISE" },
            "85614": { "city" : "GREEN VALLEY", "state" : "AZ", "county" : "PIMA" },
            "85615": { "city" : "HEREFORD", "state" : "AZ", "county" : "COCHISE" },
            "85616": { "city" : "HUACHUCA CITY", "state" : "AZ", "county" : "COCHISE" },
            "85617": { "city" : "MC NEAL", "state" : "AZ", "county" : "COCHISE" },
            "85618": { "city" : "MAMMOTH", "state" : "AZ", "county" : "PINAL" },"85619": { "city" : "MOUNT LEMMON", "state" : "AZ", "county" : "PIMA" },
            "85620": { "city" : "NACO", "state" : "AZ", "county" : "COCHISE" },"85621": { "city" : "NOGALES", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85622": { "city" : "GREEN VALLEY", "state" : "AZ", "county" : "PIMA" },
            "85623": { "city" : "ORACLE", "state" : "AZ", "county" : "PINAL" },"85624": { "city" : "PATAGONIA", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85625": { "city" : "PEARCE", "state" : "AZ", "county" : "COCHISE" },
            "85626": { "city" : "PIRTLEVILLE", "state" : "AZ", "county" : "COCHISE" },
            "85627": { "city" : "POMERENE", "state" : "AZ", "county" : "COCHISE" },
            "85628": { "city" : "NOGALES", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85629": { "city" : "SAHUARITA", "state" : "AZ", "county" : "PIMA" },
            "85630": { "city" : "SAINT DAVID", "state" : "AZ", "county" : "COCHISE" },
            "85631": { "city" : "SAN MANUEL", "state" : "AZ", "county" : "PINAL" },
            "85632": { "city" : "SAN SIMON", "state" : "AZ", "county" : "COCHISE" },
            "85633": { "city" : "SASABE", "state" : "AZ", "county" : "PIMA" },"85634": { "city" : "SELLS", "state" : "AZ", "county" : "PIMA" },
            "85635": { "city" : "SIERRA VISTA", "state" : "AZ", "county" : "COCHISE" },
            "85636": { "city" : "SIERRA VISTA", "state" : "AZ", "county" : "COCHISE" },
            "85637": { "city" : "SONOITA", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85638": { "city" : "TOMBSTONE", "state" : "AZ", "county" : "COCHISE" },
            "85639": { "city" : "TOPAWA", "state" : "AZ", "county" : "PIMA" },"85640": { "city" : "TUMACACORI", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85641": { "city" : "VAIL", "state" : "AZ", "county" : "PIMA" },"85643": { "city" : "WILLCOX", "state" : "AZ", "county" : "COCHISE" },
            "85644": { "city" : "WILLCOX", "state" : "AZ", "county" : "COCHISE" },
            "85645": { "city" : "AMADO", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85646": { "city" : "TUBAC", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85648": { "city" : "RIO RICO", "state" : "AZ", "county" : "SANTA CRUZ" },
            "85650": { "city" : "SIERRA VISTA", "state" : "AZ", "county" : "COCHISE" },
            "85652": { "city" : "CORTARO", "state" : "AZ", "county" : "PIMA" },"85653": { "city" : "MARANA", "state" : "AZ", "county" : "PIMA" },
            "85654": { "city" : "RILLITO", "state" : "AZ", "county" : "PIMA" },"85658": { "city" : "MARANA", "state" : "AZ", "county" : "PIMA" },
            "85670": { "city" : "FORT HUACHUCA", "state" : "AZ", "county" : "COCHISE" },
            "85701": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85702": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85703": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85704": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85705": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85706": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85707": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85708": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85709": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85710": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85711": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85712": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85713": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85714": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85715": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85716": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85717": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85718": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85719": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85720": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85721": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85722": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85723": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85724": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85725": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85726": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85728": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85730": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85731": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85732": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85733": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85734": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85735": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85736": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85737": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85738": { "city" : "CATALINA", "state" : "AZ", "county" : "PIMA" },
            "85739": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85740": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85741": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85742": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85743": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85744": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85745": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85746": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85747": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85748": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85749": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85750": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85751": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85752": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85754": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85755": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85756": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85757": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },
            "85775": { "city" : "TUCSON", "state" : "AZ", "county" : "PIMA" },"85901": { "city" : "SHOW LOW", "state" : "AZ", "county" : "NAVAJO" },
            "85902": { "city" : "SHOW LOW", "state" : "AZ", "county" : "NAVAJO" },
            "85911": { "city" : "CIBECUE", "state" : "AZ", "county" : "NAVAJO" },
            "85912": { "city" : "WHITE MOUNTAIN LAKE", "state" : "AZ", "county" : "NAVAJO" },
            "85920": { "city" : "ALPINE", "state" : "AZ", "county" : "APACHE" },"85922": { "city" : "BLUE", "state" : "AZ", "county" : "GREENLEE" },
            "85923": { "city" : "CLAY SPRINGS", "state" : "AZ", "county" : "NAVAJO" },
            "85924": { "city" : "CONCHO", "state" : "AZ", "county" : "APACHE" },"85925": { "city" : "EAGAR", "state" : "AZ", "county" : "APACHE" },
            "85926": { "city" : "FORT APACHE", "state" : "AZ", "county" : "NAVAJO" },
            "85927": { "city" : "GREER", "state" : "AZ", "county" : "APACHE" },"85928": { "city" : "HEBER", "state" : "AZ", "county" : "NAVAJO" },
            "85929": { "city" : "LAKESIDE", "state" : "AZ", "county" : "NAVAJO" },
            "85931": { "city" : "FOREST LAKES", "state" : "AZ", "county" : "COCONINO" },
            "85932": { "city" : "NUTRIOSO", "state" : "AZ", "county" : "APACHE" },
            "85933": { "city" : "OVERGAARD", "state" : "AZ", "county" : "NAVAJO" },
            "85934": { "city" : "PINEDALE", "state" : "AZ", "county" : "NAVAJO" },
            "85935": { "city" : "PINETOP", "state" : "AZ", "county" : "NAVAJO" },
            "85936": { "city" : "SAINT JOHNS", "state" : "AZ", "county" : "APACHE" },
            "85937": { "city" : "SNOWFLAKE", "state" : "AZ", "county" : "NAVAJO" },
            "85938": { "city" : "SPRINGERVILLE", "state" : "AZ", "county" : "APACHE" },
            "85939": { "city" : "TAYLOR", "state" : "AZ", "county" : "NAVAJO" },"85940": { "city" : "VERNON", "state" : "AZ", "county" : "APACHE" },
            "85941": { "city" : "WHITERIVER", "state" : "AZ", "county" : "NAVAJO" },
            "86001": { "city" : "FLAGSTAFF", "state" : "AZ", "county" : "COCONINO" },
            "86002": { "city" : "FLAGSTAFF", "state" : "AZ", "county" : "COCONINO" },
            "86003": { "city" : "FLAGSTAFF", "state" : "AZ", "county" : "COCONINO" },
            "86004": { "city" : "FLAGSTAFF", "state" : "AZ", "county" : "COCONINO" },
            "86011": { "city" : "FLAGSTAFF", "state" : "AZ", "county" : "COCONINO" },
            "86015": { "city" : "BELLEMONT", "state" : "AZ", "county" : "COCONINO" },
            "86016": { "city" : "GRAY MOUNTAIN", "state" : "AZ", "county" : "COCONINO" },
            "86017": { "city" : "MUNDS PARK", "state" : "AZ", "county" : "COCONINO" },
            "86018": { "city" : "PARKS", "state" : "AZ", "county" : "COCONINO" },
            "86020": { "city" : "CAMERON", "state" : "AZ", "county" : "COCONINO" },
            "86021": { "city" : "COLORADO CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86022": { "city" : "FREDONIA", "state" : "AZ", "county" : "COCONINO" },
            "86023": { "city" : "GRAND CANYON", "state" : "AZ", "county" : "COCONINO" },
            "86024": { "city" : "HAPPY JACK", "state" : "AZ", "county" : "COCONINO" },
            "86025": { "city" : "HOLBROOK", "state" : "AZ", "county" : "NAVAJO" },
            "86028": { "city" : "PETRIFIED FOREST NATL PK", "state" : "AZ", "county" : "APACHE" },
            "86029": { "city" : "SUN VALLEY", "state" : "AZ", "county" : "NAVAJO" },
            "86030": { "city" : "HOTEVILLA", "state" : "AZ", "county" : "NAVAJO" },
            "86031": { "city" : "INDIAN WELLS", "state" : "AZ", "county" : "NAVAJO" },
            "86032": { "city" : "JOSEPH CITY", "state" : "AZ", "county" : "NAVAJO" },
            "86033": { "city" : "KAYENTA", "state" : "AZ", "county" : "NAVAJO" },
            "86034": { "city" : "KEAMS CANYON", "state" : "AZ", "county" : "NAVAJO" },
            "86035": { "city" : "LEUPP", "state" : "AZ", "county" : "COCONINO" },
            "86036": { "city" : "MARBLE CANYON", "state" : "AZ", "county" : "COCONINO" },
            "86038": { "city" : "MORMON LAKE", "state" : "AZ", "county" : "COCONINO" },
            "86039": { "city" : "KYKOTSMOVI VILLAGE", "state" : "AZ", "county" : "NAVAJO" },
            "86040": { "city" : "PAGE", "state" : "AZ", "county" : "COCONINO" },"86042": { "city" : "POLACCA", "state" : "AZ", "county" : "NAVAJO" },
            "86043": { "city" : "SECOND MESA", "state" : "AZ", "county" : "NAVAJO" },
            "86044": { "city" : "TONALEA", "state" : "AZ", "county" : "COCONINO" },
            "86045": { "city" : "TUBA CITY", "state" : "AZ", "county" : "COCONINO" },
            "86046": { "city" : "WILLIAMS", "state" : "AZ", "county" : "COCONINO" },
            "86047": { "city" : "WINSLOW", "state" : "AZ", "county" : "NAVAJO" },
            "86052": { "city" : "NORTH RIM", "state" : "AZ", "county" : "COCONINO" },
            "86053": { "city" : "KAIBETO", "state" : "AZ", "county" : "COCONINO" },
            "86054": { "city" : "SHONTO", "state" : "AZ", "county" : "NAVAJO" },"86301": { "city" : "PRESCOTT", "state" : "AZ", "county" : "YAVAPAI" },
            "86302": { "city" : "PRESCOTT", "state" : "AZ", "county" : "YAVAPAI" },
            "86303": { "city" : "PRESCOTT", "state" : "AZ", "county" : "YAVAPAI" },
            "86304": { "city" : "PRESCOTT", "state" : "AZ", "county" : "YAVAPAI" },
            "86305": { "city" : "PRESCOTT", "state" : "AZ", "county" : "YAVAPAI" },
            "86312": { "city" : "PRESCOTT VALLEY", "state" : "AZ", "county" : "YAVAPAI" },
            "86313": { "city" : "PRESCOTT", "state" : "AZ", "county" : "YAVAPAI" },
            "86314": { "city" : "PRESCOTT VALLEY", "state" : "AZ", "county" : "YAVAPAI" },
            "86315": { "city" : "PRESCOTT VALLEY", "state" : "AZ", "county" : "YAVAPAI" },
            "86320": { "city" : "ASH FORK", "state" : "AZ", "county" : "YAVAPAI" },
            "86321": { "city" : "BAGDAD", "state" : "AZ", "county" : "YAVAPAI" },
            "86322": { "city" : "CAMP VERDE", "state" : "AZ", "county" : "YAVAPAI" },
            "86323": { "city" : "CHINO VALLEY", "state" : "AZ", "county" : "YAVAPAI" },
            "86324": { "city" : "CLARKDALE", "state" : "AZ", "county" : "YAVAPAI" },
            "86325": { "city" : "CORNVILLE", "state" : "AZ", "county" : "YAVAPAI" },
            "86326": { "city" : "COTTONWOOD", "state" : "AZ", "county" : "YAVAPAI" },
            "86327": { "city" : "DEWEY", "state" : "AZ", "county" : "YAVAPAI" },"86329": { "city" : "HUMBOLDT", "state" : "AZ", "county" : "YAVAPAI" },
            "86331": { "city" : "JEROME", "state" : "AZ", "county" : "YAVAPAI" },
            "86332": { "city" : "KIRKLAND", "state" : "AZ", "county" : "YAVAPAI" },
            "86333": { "city" : "MAYER", "state" : "AZ", "county" : "YAVAPAI" },"86334": { "city" : "PAULDEN", "state" : "AZ", "county" : "YAVAPAI" },
            "86335": { "city" : "RIMROCK", "state" : "AZ", "county" : "YAVAPAI" },
            "86336": { "city" : "SEDONA", "state" : "AZ", "county" : "YAVAPAI" },
            "86337": { "city" : "SELIGMAN", "state" : "AZ", "county" : "YAVAPAI" },
            "86338": { "city" : "SKULL VALLEY", "state" : "AZ", "county" : "YAVAPAI" },
            "86339": { "city" : "SEDONA", "state" : "AZ", "county" : "COCONINO" },
            "86340": { "city" : "SEDONA", "state" : "AZ", "county" : "YAVAPAI" },
            "86341": { "city" : "SEDONA", "state" : "AZ", "county" : "YAVAPAI" },
            "86342": { "city" : "LAKE MONTEZUMA", "state" : "AZ", "county" : "YAVAPAI" },
            "86343": { "city" : "CROWN KING", "state" : "AZ", "county" : "YAVAPAI" },
            "86351": { "city" : "SEDONA", "state" : "AZ", "county" : "YAVAPAI" },
            "86401": { "city" : "KINGMAN", "state" : "AZ", "county" : "MOHAVE" },
            "86402": { "city" : "KINGMAN", "state" : "AZ", "county" : "MOHAVE" },
            "86403": { "city" : "LAKE HAVASU CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86404": { "city" : "LAKE HAVASU CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86405": { "city" : "LAKE HAVASU CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86406": { "city" : "LAKE HAVASU CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86409": { "city" : "KINGMAN", "state" : "AZ", "county" : "MOHAVE" },
            "86413": { "city" : "GOLDEN VALLEY", "state" : "AZ", "county" : "MOHAVE" },
            "86426": { "city" : "FORT MOHAVE", "state" : "AZ", "county" : "MOHAVE" },
            "86427": { "city" : "FORT MOHAVE", "state" : "AZ", "county" : "MOHAVE" },
            "86429": { "city" : "BULLHEAD CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86430": { "city" : "BULLHEAD CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86431": { "city" : "CHLORIDE", "state" : "AZ", "county" : "MOHAVE" },
            "86432": { "city" : "LITTLEFIELD", "state" : "AZ", "county" : "MOHAVE" },
            "86433": { "city" : "OATMAN", "state" : "AZ", "county" : "MOHAVE" },"86434": { "city" : "PEACH SPRINGS", "state" : "AZ", "county" : "MOHAVE" },
            "86436": { "city" : "TOPOCK", "state" : "AZ", "county" : "MOHAVE" },"86437": { "city" : "VALENTINE", "state" : "AZ", "county" : "MOHAVE" },
            "86438": { "city" : "YUCCA", "state" : "AZ", "county" : "MOHAVE" },"86439": { "city" : "BULLHEAD CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86440": { "city" : "MOHAVE VALLEY", "state" : "AZ", "county" : "MOHAVE" },
            "86441": { "city" : "DOLAN SPRINGS", "state" : "AZ", "county" : "MOHAVE" },
            "86442": { "city" : "BULLHEAD CITY", "state" : "AZ", "county" : "MOHAVE" },
            "86443": { "city" : "TEMPLE BAR MARINA", "state" : "AZ", "county" : "MOHAVE" },
            "86444": { "city" : "MEADVIEW", "state" : "AZ", "county" : "MOHAVE" },
            "86445": { "city" : "WILLOW BEACH", "state" : "AZ", "county" : "MOHAVE" },
            "86446": { "city" : "MOHAVE VALLEY", "state" : "AZ", "county" : "MOHAVE" },
            "86502": { "city" : "CHAMBERS", "state" : "AZ", "county" : "APACHE" },
            "86503": { "city" : "CHINLE", "state" : "AZ", "county" : "APACHE" },"86504": { "city" : "FORT DEFIANCE", "state" : "AZ", "county" : "APACHE" },
            "86505": { "city" : "GANADO", "state" : "AZ", "county" : "APACHE" },"86506": { "city" : "HOUCK", "state" : "AZ", "county" : "APACHE" },
            "86507": { "city" : "LUKACHUKAI", "state" : "AZ", "county" : "APACHE" },
            "86508": { "city" : "LUPTON", "state" : "AZ", "county" : "APACHE" },"86510": { "city" : "PINON", "state" : "AZ", "county" : "NAVAJO" },
            "86511": { "city" : "SAINT MICHAELS", "state" : "AZ", "county" : "APACHE" },
            "86512": { "city" : "SANDERS", "state" : "AZ", "county" : "APACHE" },
            "86514": { "city" : "TEEC NOS POS", "state" : "AZ", "county" : "APACHE" },
            "86515": { "city" : "WINDOW ROCK", "state" : "AZ", "county" : "APACHE" },
            "86520": { "city" : "BLUE GAP", "state" : "AZ", "county" : "NAVAJO" },
            "86538": { "city" : "MANY FARMS", "state" : "AZ", "county" : "APACHE" },
            "86544": { "city" : "RED VALLEY", "state" : "AZ", "county" : "APACHE" },
            "86545": { "city" : "ROCK POINT", "state" : "AZ", "county" : "APACHE" },
            "86547": { "city" : "ROUND ROCK", "state" : "AZ", "county" : "APACHE" },
            "86556": { "city" : "TSAILE", "state" : "AZ", "county" : "APACHE" },"87001": { "city" : "ALGODONES", "state" : "NM", "county" : "SANDOVAL" },
            "87002": { "city" : "BELEN", "state" : "NM", "county" : "VALENCIA" },
            "87004": { "city" : "BERNALILLO", "state" : "NM", "county" : "SANDOVAL" },
            "87005": { "city" : "BLUEWATER", "state" : "NM", "county" : "CIBOLA" },
            "87006": { "city" : "BOSQUE", "state" : "NM", "county" : "VALENCIA" },
            "87007": { "city" : "CASA BLANCA", "state" : "NM", "county" : "CIBOLA" },
            "87008": { "city" : "CEDAR CREST", "state" : "NM", "county" : "BERNALILLO" },
            "87010": { "city" : "CERRILLOS", "state" : "NM", "county" : "SANTA FE" },
            "87011": { "city" : "CLAUNCH", "state" : "NM", "county" : "SOCORRO" },
            "87012": { "city" : "COYOTE", "state" : "NM", "county" : "RIO ARRIBA" },
            "87013": { "city" : "CUBA", "state" : "NM", "county" : "SANDOVAL" },"87014": { "city" : "CUBERO", "state" : "NM", "county" : "CIBOLA" },
            "87015": { "city" : "EDGEWOOD", "state" : "NM", "county" : "SANTA FE" },
            "87016": { "city" : "ESTANCIA", "state" : "NM", "county" : "TORRANCE" },
            "87017": { "city" : "GALLINA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87020": { "city" : "GRANTS", "state" : "NM", "county" : "CIBOLA" },"87021": { "city" : "MILAN", "state" : "NM", "county" : "CIBOLA" },
            "87022": { "city" : "ISLETA", "state" : "NM", "county" : "BERNALILLO" },
            "87024": { "city" : "JEMEZ PUEBLO", "state" : "NM", "county" : "SANDOVAL" },
            "87025": { "city" : "JEMEZ SPRINGS", "state" : "NM", "county" : "SANDOVAL" },
            "87026": { "city" : "LAGUNA", "state" : "NM", "county" : "CIBOLA" },"87027": { "city" : "LA JARA", "state" : "NM", "county" : "SANDOVAL" },
            "87028": { "city" : "LA JOYA", "state" : "NM", "county" : "SOCORRO" },
            "87029": { "city" : "LINDRITH", "state" : "NM", "county" : "RIO ARRIBA" },
            "87031": { "city" : "LOS LUNAS", "state" : "NM", "county" : "VALENCIA" },
            "87032": { "city" : "MCINTOSH", "state" : "NM", "county" : "TORRANCE" },
            "87034": { "city" : "PUEBLO OF ACOMA", "state" : "NM", "county" : "VALENCIA" },
            "87035": { "city" : "MORIARTY", "state" : "NM", "county" : "TORRANCE" },
            "87036": { "city" : "MOUNTAINAIR", "state" : "NM", "county" : "TORRANCE" },
            "87037": { "city" : "NAGEEZI", "state" : "NM", "county" : "SAN JUAN" },
            "87038": { "city" : "NEW LAGUNA", "state" : "NM", "county" : "CIBOLA" },
            "87041": { "city" : "PENA BLANCA", "state" : "NM", "county" : "SANDOVAL" },
            "87042": { "city" : "PERALTA", "state" : "NM", "county" : "VALENCIA" },
            "87043": { "city" : "PLACITAS", "state" : "NM", "county" : "SANDOVAL" },
            "87044": { "city" : "PONDEROSA", "state" : "NM", "county" : "SANDOVAL" },
            "87045": { "city" : "PREWITT", "state" : "NM", "county" : "MCKINLEY" },
            "87046": { "city" : "REGINA", "state" : "NM", "county" : "SANDOVAL" },
            "87047": { "city" : "SANDIA PARK", "state" : "NM", "county" : "BERNALILLO" },
            "87048": { "city" : "CORRALES", "state" : "NM", "county" : "SANDOVAL" },
            "87049": { "city" : "SAN FIDEL", "state" : "NM", "county" : "CIBOLA" },
            "87051": { "city" : "SAN RAFAEL", "state" : "NM", "county" : "CIBOLA" },
            "87052": { "city" : "SANTO DOMINGO PUEBLO", "state" : "NM", "county" : "SANDOVAL" },
            "87053": { "city" : "SAN YSIDRO", "state" : "NM", "county" : "SANDOVAL" },
            "87056": { "city" : "STANLEY", "state" : "NM", "county" : "SANTA FE" },
            "87059": { "city" : "TIJERAS", "state" : "NM", "county" : "BERNALILLO" },
            "87060": { "city" : "TOME", "state" : "NM", "county" : "VALENCIA" },"87061": { "city" : "TORREON", "state" : "NM", "county" : "TORRANCE" },
            "87062": { "city" : "VEGUITA", "state" : "NM", "county" : "SOCORRO" },
            "87063": { "city" : "WILLARD", "state" : "NM", "county" : "TORRANCE" },
            "87064": { "city" : "YOUNGSVILLE", "state" : "NM", "county" : "RIO ARRIBA" },
            "87068": { "city" : "BOSQUE FARMS", "state" : "NM", "county" : "VALENCIA" },
            "87070": { "city" : "CLINES CORNERS", "state" : "NM", "county" : "TORRANCE" },
            "87072": { "city" : "COCHITI PUEBLO", "state" : "NM", "county" : "SANDOVAL" },
            "87083": { "city" : "COCHITI LAKE", "state" : "NM", "county" : "SANDOVAL" },
            "87101": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87102": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87103": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87104": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87105": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87106": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87107": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87108": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87109": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87110": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87111": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87112": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87113": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87114": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87115": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87116": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87117": { "city" : "KIRTLAND AFB", "state" : "NM", "county" : "BERNALILLO" },
            "87119": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87120": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87121": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87122": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87123": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87124": { "city" : "RIO RANCHO", "state" : "NM", "county" : "SANDOVAL" },
            "87125": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87131": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87144": { "city" : "RIO RANCHO", "state" : "NM", "county" : "SANDOVAL" },
            "87153": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87154": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87158": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87174": { "city" : "RIO RANCHO", "state" : "NM", "county" : "SANDOVAL" },
            "87176": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87181": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87184": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87185": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87187": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87190": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87191": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87192": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87193": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87194": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87195": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87196": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87197": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87198": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87199": { "city" : "ALBUQUERQUE", "state" : "NM", "county" : "BERNALILLO" },
            "87301": { "city" : "GALLUP", "state" : "NM", "county" : "MCKINLEY" },
            "87302": { "city" : "GALLUP", "state" : "NM", "county" : "MCKINLEY" },
            "87305": { "city" : "GALLUP", "state" : "NM", "county" : "MCKINLEY" },
            "87310": { "city" : "BRIMHALL", "state" : "NM", "county" : "MCKINLEY" },
            "87311": { "city" : "CHURCH ROCK", "state" : "NM", "county" : "MCKINLEY" },
            "87312": { "city" : "CONTINENTAL DIVIDE", "state" : "NM", "county" : "MCKINLEY" },
            "87313": { "city" : "CROWNPOINT", "state" : "NM", "county" : "MCKINLEY" },
            "87315": { "city" : "FENCE LAKE", "state" : "NM", "county" : "CIBOLA" },
            "87316": { "city" : "FORT WINGATE", "state" : "NM", "county" : "MCKINLEY" },
            "87317": { "city" : "GAMERCO", "state" : "NM", "county" : "MCKINLEY" },
            "87319": { "city" : "MENTMORE", "state" : "NM", "county" : "MCKINLEY" },
            "87321": { "city" : "RAMAH", "state" : "NM", "county" : "MCKINLEY" },
            "87322": { "city" : "REHOBOTH", "state" : "NM", "county" : "MCKINLEY" },
            "87323": { "city" : "THOREAU", "state" : "NM", "county" : "MCKINLEY" },
            "87325": { "city" : "TOHATCHI", "state" : "NM", "county" : "MCKINLEY" },
            "87326": { "city" : "VANDERWAGEN", "state" : "NM", "county" : "MCKINLEY" },
            "87327": { "city" : "ZUNI", "state" : "NM", "county" : "MCKINLEY" },"87328": { "city" : "NAVAJO", "state" : "NM", "county" : "MCKINLEY" },
            "87347": { "city" : "JAMESTOWN", "state" : "NM", "county" : "MCKINLEY" },
            "87357": { "city" : "PINEHILL", "state" : "NM", "county" : "CIBOLA" },
            "87364": { "city" : "SHEEP SPRINGS", "state" : "NM", "county" : "SAN JUAN" },
            "87365": { "city" : "SMITH LAKE", "state" : "NM", "county" : "MCKINLEY" },
            "87375": { "city" : "YATAHEY", "state" : "NM", "county" : "MCKINLEY" },
            "87401": { "city" : "FARMINGTON", "state" : "NM", "county" : "SAN JUAN" },
            "87402": { "city" : "FARMINGTON", "state" : "NM", "county" : "SAN JUAN" },
            "87410": { "city" : "AZTEC", "state" : "NM", "county" : "SAN JUAN" },
            "87412": { "city" : "BLANCO", "state" : "NM", "county" : "SAN JUAN" },
            "87413": { "city" : "BLOOMFIELD", "state" : "NM", "county" : "SAN JUAN" },
            "87415": { "city" : "FLORA VISTA", "state" : "NM", "county" : "SAN JUAN" },
            "87416": { "city" : "FRUITLAND", "state" : "NM", "county" : "SAN JUAN" },
            "87417": { "city" : "KIRTLAND", "state" : "NM", "county" : "SAN JUAN" },
            "87418": { "city" : "LA PLATA", "state" : "NM", "county" : "SAN JUAN" },
            "87419": { "city" : "NAVAJO DAM", "state" : "NM", "county" : "SAN JUAN" },
            "87420": { "city" : "SHIPROCK", "state" : "NM", "county" : "SAN JUAN" },
            "87421": { "city" : "WATERFLOW", "state" : "NM", "county" : "SAN JUAN" },
            "87455": { "city" : "NEWCOMB", "state" : "NM", "county" : "SAN JUAN" },
            "87461": { "city" : "SANOSTEE", "state" : "NM", "county" : "SAN JUAN" },
            "87499": { "city" : "FARMINGTON", "state" : "NM", "county" : "SAN JUAN" },
            "87501": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87502": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87503": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87504": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87505": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87506": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87507": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87508": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87510": { "city" : "ABIQUIU", "state" : "NM", "county" : "RIO ARRIBA" },
            "87511": { "city" : "ALCALDE", "state" : "NM", "county" : "RIO ARRIBA" },
            "87512": { "city" : "AMALIA", "state" : "NM", "county" : "TAOS" },"87513": { "city" : "ARROYO HONDO", "state" : "NM", "county" : "TAOS" },
            "87514": { "city" : "ARROYO SECO", "state" : "NM", "county" : "TAOS" },
            "87515": { "city" : "CANJILON", "state" : "NM", "county" : "RIO ARRIBA" },
            "87516": { "city" : "CANONES", "state" : "NM", "county" : "RIO ARRIBA" },
            "87517": { "city" : "CARSON", "state" : "NM", "county" : "TAOS" },"87518": { "city" : "CEBOLLA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87520": { "city" : "CHAMA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87521": { "city" : "CHAMISAL", "state" : "NM", "county" : "TAOS" },"87522": { "city" : "CHIMAYO", "state" : "NM", "county" : "RIO ARRIBA" },
            "87523": { "city" : "CORDOVA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87524": { "city" : "COSTILLA", "state" : "NM", "county" : "TAOS" },"87525": { "city" : "TAOS SKI VALLEY", "state" : "NM", "county" : "TAOS" },
            "87527": { "city" : "DIXON", "state" : "NM", "county" : "RIO ARRIBA" },
            "87528": { "city" : "DULCE", "state" : "NM", "county" : "RIO ARRIBA" },
            "87529": { "city" : "EL PRADO", "state" : "NM", "county" : "TAOS" },"87530": { "city" : "EL RITO", "state" : "NM", "county" : "RIO ARRIBA" },
            "87531": { "city" : "EMBUDO", "state" : "NM", "county" : "RIO ARRIBA" },
            "87532": { "city" : "ESPANOLA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87533": { "city" : "ESPANOLA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87535": { "city" : "GLORIETA", "state" : "NM", "county" : "SANTA FE" },
            "87537": { "city" : "HERNANDEZ", "state" : "NM", "county" : "RIO ARRIBA" },
            "87538": { "city" : "ILFELD", "state" : "NM", "county" : "SAN MIGUEL" },
            "87539": { "city" : "LA MADERA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87540": { "city" : "LAMY", "state" : "NM", "county" : "SANTA FE" },"87543": { "city" : "LLANO", "state" : "NM", "county" : "TAOS" },
            "87544": { "city" : "LOS ALAMOS", "state" : "NM", "county" : "LOS ALAMOS" },
            "87545": { "city" : "LOS ALAMOS", "state" : "NM", "county" : "LOS ALAMOS" },
            "87548": { "city" : "MEDANALES", "state" : "NM", "county" : "RIO ARRIBA" },
            "87549": { "city" : "OJO CALIENTE", "state" : "NM", "county" : "TAOS" },
            "87551": { "city" : "LOS OJOS", "state" : "NM", "county" : "RIO ARRIBA" },
            "87552": { "city" : "PECOS", "state" : "NM", "county" : "SAN MIGUEL" },
            "87553": { "city" : "PENASCO", "state" : "NM", "county" : "TAOS" },"87556": { "city" : "QUESTA", "state" : "NM", "county" : "TAOS" },
            "87557": { "city" : "RANCHOS DE TAOS", "state" : "NM", "county" : "TAOS" },
            "87558": { "city" : "RED RIVER", "state" : "NM", "county" : "TAOS" },
            "87560": { "city" : "RIBERA", "state" : "NM", "county" : "SAN MIGUEL" },
            "87562": { "city" : "ROWE", "state" : "NM", "county" : "SAN MIGUEL" },
            "87564": { "city" : "SAN CRISTOBAL", "state" : "NM", "county" : "TAOS" },
            "87565": { "city" : "SAN JOSE", "state" : "NM", "county" : "SAN MIGUEL" },
            "87566": { "city" : "OHKAY OWINGEH", "state" : "NM", "county" : "RIO ARRIBA" },
            "87567": { "city" : "SANTA CRUZ", "state" : "NM", "county" : "SANTA FE" },
            "87569": { "city" : "SERAFINA", "state" : "NM", "county" : "SAN MIGUEL" },
            "87571": { "city" : "TAOS", "state" : "NM", "county" : "TAOS" },"87573": { "city" : "TERERRO", "state" : "NM", "county" : "SAN MIGUEL" },
            "87574": { "city" : "TESUQUE", "state" : "NM", "county" : "SANTA FE" },
            "87575": { "city" : "TIERRA AMARILLA", "state" : "NM", "county" : "RIO ARRIBA" },
            "87577": { "city" : "TRES PIEDRAS", "state" : "NM", "county" : "TAOS" },
            "87578": { "city" : "TRUCHAS", "state" : "NM", "county" : "RIO ARRIBA" },
            "87579": { "city" : "VADITO", "state" : "NM", "county" : "TAOS" },"87580": { "city" : "VALDEZ", "state" : "NM", "county" : "TAOS" },
            "87581": { "city" : "VALLECITOS", "state" : "NM", "county" : "RIO ARRIBA" },
            "87582": { "city" : "VELARDE", "state" : "NM", "county" : "RIO ARRIBA" },
            "87592": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87594": { "city" : "SANTA FE", "state" : "NM", "county" : "SANTA FE" },
            "87701": { "city" : "LAS VEGAS", "state" : "NM", "county" : "SAN MIGUEL" },
            "87710": { "city" : "ANGEL FIRE", "state" : "NM", "county" : "COLFAX" },
            "87711": { "city" : "ANTON CHICO", "state" : "NM", "county" : "GUADALUPE" },
            "87712": { "city" : "BUENA VISTA", "state" : "NM", "county" : "MORA" },
            "87713": { "city" : "CHACON", "state" : "NM", "county" : "MORA" },"87714": { "city" : "CIMARRON", "state" : "NM", "county" : "COLFAX" },
            "87715": { "city" : "CLEVELAND", "state" : "NM", "county" : "MORA" },
            "87718": { "city" : "EAGLE NEST", "state" : "NM", "county" : "COLFAX" },
            "87722": { "city" : "GUADALUPITA", "state" : "NM", "county" : "MORA" },
            "87723": { "city" : "HOLMAN", "state" : "NM", "county" : "MORA" },"87728": { "city" : "MAXWELL", "state" : "NM", "county" : "COLFAX" },
            "87729": { "city" : "MIAMI", "state" : "NM", "county" : "COLFAX" },"87731": { "city" : "MONTEZUMA", "state" : "NM", "county" : "SAN MIGUEL" },
            "87732": { "city" : "MORA", "state" : "NM", "county" : "MORA" },"87733": { "city" : "MOSQUERO", "state" : "NM", "county" : "HARDING" },
            "87735": { "city" : "OJO FELIZ", "state" : "NM", "county" : "MORA" },
            "87740": { "city" : "RATON", "state" : "NM", "county" : "COLFAX" },"87742": { "city" : "ROCIADA", "state" : "NM", "county" : "SAN MIGUEL" },
            "87743": { "city" : "ROY", "state" : "NM", "county" : "HARDING" },"87745": { "city" : "SAPELLO", "state" : "NM", "county" : "SAN MIGUEL" },
            "87747": { "city" : "SPRINGER", "state" : "NM", "county" : "COLFAX" },
            "87749": { "city" : "UTE PARK", "state" : "NM", "county" : "COLFAX" },
            "87752": { "city" : "WAGON MOUND", "state" : "NM", "county" : "MORA" },
            "87753": { "city" : "WATROUS", "state" : "NM", "county" : "MORA" },"87801": { "city" : "SOCORRO", "state" : "NM", "county" : "SOCORRO" },
            "87820": { "city" : "ARAGON", "state" : "NM", "county" : "CATRON" },"87821": { "city" : "DATIL", "state" : "NM", "county" : "CATRON" },
            "87823": { "city" : "LEMITAR", "state" : "NM", "county" : "SOCORRO" },
            "87824": { "city" : "LUNA", "state" : "NM", "county" : "CATRON" },"87825": { "city" : "MAGDALENA", "state" : "NM", "county" : "SOCORRO" },
            "87827": { "city" : "PIE TOWN", "state" : "NM", "county" : "CATRON" },
            "87829": { "city" : "QUEMADO", "state" : "NM", "county" : "CATRON" },
            "87830": { "city" : "RESERVE", "state" : "NM", "county" : "CATRON" },
            "87831": { "city" : "SAN ACACIA", "state" : "NM", "county" : "SOCORRO" },
            "87832": { "city" : "SAN ANTONIO", "state" : "NM", "county" : "SOCORRO" },
            "87901": { "city" : "TRUTH OR CONSEQUENCES", "state" : "NM", "county" : "SIERRA" },
            "87930": { "city" : "ARREY", "state" : "NM", "county" : "SIERRA" },"87931": { "city" : "CABALLO", "state" : "NM", "county" : "SIERRA" },
            "87933": { "city" : "DERRY", "state" : "NM", "county" : "SIERRA" },"87935": { "city" : "ELEPHANT BUTTE", "state" : "NM", "county" : "SIERRA" },
            "87936": { "city" : "GARFIELD", "state" : "NM", "county" : "DONA ANA" },
            "87937": { "city" : "HATCH", "state" : "NM", "county" : "DONA ANA" },
            "87940": { "city" : "RINCON", "state" : "NM", "county" : "DONA ANA" },
            "87941": { "city" : "SALEM", "state" : "NM", "county" : "DONA ANA" },
            "87942": { "city" : "WILLIAMSBURG", "state" : "NM", "county" : "SIERRA" },
            "87943": { "city" : "WINSTON", "state" : "NM", "county" : "SIERRA" },
            "88001": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88002": { "city" : "WHITE SANDS MISSILE RANGE", "state" : "NM", "county" : "DONA ANA" },
            "88003": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88004": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88005": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88006": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88007": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88008": { "city" : "SANTA TERESA", "state" : "NM", "county" : "DONA ANA" },
            "88009": { "city" : "PLAYAS", "state" : "NM", "county" : "HIDALGO" },
            "88011": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88012": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88013": { "city" : "LAS CRUCES", "state" : "NM", "county" : "DONA ANA" },
            "88020": { "city" : "ANIMAS", "state" : "NM", "county" : "HIDALGO" },
            "88021": { "city" : "ANTHONY", "state" : "NM", "county" : "DONA ANA" },
            "88022": { "city" : "ARENAS VALLEY", "state" : "NM", "county" : "GRANT" },
            "88023": { "city" : "BAYARD", "state" : "NM", "county" : "GRANT" },"88024": { "city" : "BERINO", "state" : "NM", "county" : "DONA ANA" },
            "88026": { "city" : "SANTA CLARA", "state" : "NM", "county" : "GRANT" },
            "88027": { "city" : "CHAMBERINO", "state" : "NM", "county" : "DONA ANA" },
            "88028": { "city" : "CLIFF", "state" : "NM", "county" : "GRANT" },"88029": { "city" : "COLUMBUS", "state" : "NM", "county" : "LUNA" },
            "88030": { "city" : "DEMING", "state" : "NM", "county" : "LUNA" },"88031": { "city" : "DEMING", "state" : "NM", "county" : "LUNA" },
            "88032": { "city" : "DONA ANA", "state" : "NM", "county" : "DONA ANA" },
            "88033": { "city" : "FAIRACRES", "state" : "NM", "county" : "DONA ANA" },
            "88036": { "city" : "FORT BAYARD", "state" : "NM", "county" : "GRANT" },
            "88038": { "city" : "GILA", "state" : "NM", "county" : "GRANT" },"88039": { "city" : "GLENWOOD", "state" : "NM", "county" : "CATRON" },
            "88040": { "city" : "HACHITA", "state" : "NM", "county" : "GRANT" },"88041": { "city" : "HANOVER", "state" : "NM", "county" : "GRANT" },
            "88042": { "city" : "HILLSBORO", "state" : "NM", "county" : "SIERRA" },
            "88043": { "city" : "HURLEY", "state" : "NM", "county" : "GRANT" },"88044": { "city" : "LA MESA", "state" : "NM", "county" : "DONA ANA" },
            "88045": { "city" : "LORDSBURG", "state" : "NM", "county" : "HIDALGO" },
            "88046": { "city" : "MESILLA", "state" : "NM", "county" : "DONA ANA" },
            "88047": { "city" : "MESILLA PARK", "state" : "NM", "county" : "DONA ANA" },
            "88048": { "city" : "MESQUITE", "state" : "NM", "county" : "DONA ANA" },
            "88049": { "city" : "MIMBRES", "state" : "NM", "county" : "GRANT" },"88051": { "city" : "MULE CREEK", "state" : "NM", "county" : "GRANT" },
            "88052": { "city" : "ORGAN", "state" : "NM", "county" : "DONA ANA" },
            "88053": { "city" : "PINOS ALTOS", "state" : "NM", "county" : "GRANT" },
            "88054": { "city" : "RADIUM SPRINGS", "state" : "NM", "county" : "DONA ANA" },
            "88055": { "city" : "REDROCK", "state" : "NM", "county" : "GRANT" },"88056": { "city" : "RODEO", "state" : "NM", "county" : "HIDALGO" },
            "88058": { "city" : "SAN MIGUEL", "state" : "NM", "county" : "DONA ANA" },
            "88061": { "city" : "SILVER CITY", "state" : "NM", "county" : "GRANT" },
            "88062": { "city" : "SILVER CITY", "state" : "NM", "county" : "GRANT" },
            "88063": { "city" : "SUNLAND PARK", "state" : "NM", "county" : "DONA ANA" },
            "88065": { "city" : "TYRONE", "state" : "NM", "county" : "GRANT" },"88072": { "city" : "VADO", "state" : "NM", "county" : "DONA ANA" },
            "88081": { "city" : "CHAPARRAL", "state" : "NM", "county" : "DONA ANA" },
            "88101": { "city" : "CLOVIS", "state" : "NM", "county" : "CURRY" },"88102": { "city" : "CLOVIS", "state" : "NM", "county" : "CURRY" },
            "88103": { "city" : "CANNON AFB", "state" : "NM", "county" : "CURRY" },
            "88113": { "city" : "CAUSEY", "state" : "NM", "county" : "ROOSEVELT" },
            "88114": { "city" : "CROSSROADS", "state" : "NM", "county" : "LEA" },
            "88115": { "city" : "DORA", "state" : "NM", "county" : "ROOSEVELT" },
            "88116": { "city" : "ELIDA", "state" : "NM", "county" : "ROOSEVELT" },
            "88118": { "city" : "FLOYD", "state" : "NM", "county" : "ROOSEVELT" },
            "88119": { "city" : "FORT SUMNER", "state" : "NM", "county" : "DE BACA" },
            "88120": { "city" : "GRADY", "state" : "NM", "county" : "CURRY" },"88121": { "city" : "HOUSE", "state" : "NM", "county" : "QUAY" },
            "88124": { "city" : "MELROSE", "state" : "NM", "county" : "CURRY" },"88130": { "city" : "PORTALES", "state" : "NM", "county" : "ROOSEVELT" },
            "88134": { "city" : "TAIBAN", "state" : "NM", "county" : "DE BACA" },
            "88135": { "city" : "TEXICO", "state" : "NM", "county" : "CURRY" },"88136": { "city" : "YESO", "state" : "NM", "county" : "DE BACA" },
            "88201": { "city" : "ROSWELL", "state" : "NM", "county" : "CHAVES" },
            "88202": { "city" : "ROSWELL", "state" : "NM", "county" : "CHAVES" },
            "88203": { "city" : "ROSWELL", "state" : "NM", "county" : "CHAVES" },
            "88210": { "city" : "ARTESIA", "state" : "NM", "county" : "EDDY" },"88211": { "city" : "ARTESIA", "state" : "NM", "county" : "EDDY" },
            "88213": { "city" : "CAPROCK", "state" : "NM", "county" : "LEA" },"88220": { "city" : "CARLSBAD", "state" : "NM", "county" : "EDDY" },
            "88221": { "city" : "CARLSBAD", "state" : "NM", "county" : "EDDY" },"88230": { "city" : "DEXTER", "state" : "NM", "county" : "CHAVES" },
            "88231": { "city" : "EUNICE", "state" : "NM", "county" : "LEA" },"88232": { "city" : "HAGERMAN", "state" : "NM", "county" : "CHAVES" },
            "88240": { "city" : "HOBBS", "state" : "NM", "county" : "LEA" },"88241": { "city" : "HOBBS", "state" : "NM", "county" : "LEA" },
            "88242": { "city" : "HOBBS", "state" : "NM", "county" : "LEA" },"88244": { "city" : "HOBBS", "state" : "NM", "county" : "LEA" },
            "88250": { "city" : "HOPE", "state" : "NM", "county" : "EDDY" },"88252": { "city" : "JAL", "state" : "NM", "county" : "LEA" },
            "88253": { "city" : "LAKE ARTHUR", "state" : "NM", "county" : "CHAVES" },
            "88254": { "city" : "LAKEWOOD", "state" : "NM", "county" : "EDDY" },"88255": { "city" : "LOCO HILLS", "state" : "NM", "county" : "EDDY" },
            "88256": { "city" : "LOVING", "state" : "NM", "county" : "EDDY" },"88260": { "city" : "LOVINGTON", "state" : "NM", "county" : "LEA" },
            "88263": { "city" : "MALAGA", "state" : "NM", "county" : "EDDY" },"88264": { "city" : "MALJAMAR", "state" : "NM", "county" : "LEA" },
            "88265": { "city" : "MONUMENT", "state" : "NM", "county" : "LEA" },"88267": { "city" : "TATUM", "state" : "NM", "county" : "LEA" },
            "88301": { "city" : "CARRIZOZO", "state" : "NM", "county" : "LINCOLN" },
            "88310": { "city" : "ALAMOGORDO", "state" : "NM", "county" : "OTERO" },
            "88311": { "city" : "ALAMOGORDO", "state" : "NM", "county" : "OTERO" },
            "88312": { "city" : "ALTO", "state" : "NM", "county" : "LINCOLN" },"88314": { "city" : "BENT", "state" : "NM", "county" : "OTERO" },
            "88316": { "city" : "CAPITAN", "state" : "NM", "county" : "LINCOLN" },
            "88317": { "city" : "CLOUDCROFT", "state" : "NM", "county" : "OTERO" },
            "88318": { "city" : "CORONA", "state" : "NM", "county" : "LINCOLN" },
            "88321": { "city" : "ENCINO", "state" : "NM", "county" : "TORRANCE" },
            "88324": { "city" : "GLENCOE", "state" : "NM", "county" : "LINCOLN" },
            "88325": { "city" : "HIGH ROLLS MOUNTAIN PARK", "state" : "NM", "county" : "OTERO" },
            "88330": { "city" : "HOLLOMAN AIR FORCE BASE", "state" : "NM", "county" : "OTERO" },
            "88336": { "city" : "HONDO", "state" : "NM", "county" : "LINCOLN" },"88337": { "city" : "LA LUZ", "state" : "NM", "county" : "OTERO" },
            "88338": { "city" : "LINCOLN", "state" : "NM", "county" : "LINCOLN" },
            "88339": { "city" : "MAYHILL", "state" : "NM", "county" : "OTERO" },"88340": { "city" : "MESCALERO", "state" : "NM", "county" : "OTERO" },
            "88341": { "city" : "NOGAL", "state" : "NM", "county" : "LINCOLN" },"88342": { "city" : "OROGRANDE", "state" : "NM", "county" : "OTERO" },
            "88343": { "city" : "PICACHO", "state" : "NM", "county" : "LINCOLN" },
            "88344": { "city" : "PINON", "state" : "NM", "county" : "OTERO" },"88345": { "city" : "RUIDOSO", "state" : "NM", "county" : "LINCOLN" },
            "88346": { "city" : "RUIDOSO DOWNS", "state" : "NM", "county" : "LINCOLN" },
            "88347": { "city" : "SACRAMENTO", "state" : "NM", "county" : "OTERO" },
            "88348": { "city" : "SAN PATRICIO", "state" : "NM", "county" : "LINCOLN" },
            "88349": { "city" : "SUNSPOT", "state" : "NM", "county" : "OTERO" },"88350": { "city" : "TIMBERON", "state" : "NM", "county" : "OTERO" },
            "88351": { "city" : "TINNIE", "state" : "NM", "county" : "LINCOLN" },
            "88352": { "city" : "TULAROSA", "state" : "NM", "county" : "OTERO" },
            "88353": { "city" : "VAUGHN", "state" : "NM", "county" : "GUADALUPE" },
            "88355": { "city" : "RUIDOSO", "state" : "NM", "county" : "LINCOLN" },
            "88401": { "city" : "TUCUMCARI", "state" : "NM", "county" : "QUAY" },
            "88410": { "city" : "AMISTAD", "state" : "NM", "county" : "UNION" },"88414": { "city" : "CAPULIN", "state" : "NM", "county" : "UNION" },
            "88415": { "city" : "CLAYTON", "state" : "NM", "county" : "UNION" },"88416": { "city" : "CONCHAS DAM", "state" : "NM", "county" : "SAN MIGUEL" },
            "88418": { "city" : "DES MOINES", "state" : "NM", "county" : "UNION" },
            "88419": { "city" : "FOLSOM", "state" : "NM", "county" : "UNION" },"88426": { "city" : "LOGAN", "state" : "NM", "county" : "QUAY" },
            "88427": { "city" : "MCALISTER", "state" : "NM", "county" : "QUAY" },
            "88430": { "city" : "NARA VISA", "state" : "NM", "county" : "QUAY" },
            "88431": { "city" : "NEWKIRK", "state" : "NM", "county" : "GUADALUPE" },
            "88434": { "city" : "SAN JON", "state" : "NM", "county" : "QUAY" },"88435": { "city" : "SANTA ROSA", "state" : "NM", "county" : "GUADALUPE" },
            "88436": { "city" : "SEDAN", "state" : "NM", "county" : "UNION" },"88901": { "city" : "THE LAKES", "state" : "NV", "county" : "CLARK" },
            "89001": { "city" : "ALAMO", "state" : "NV", "county" : "LINCOLN" },"89002": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89003": { "city" : "BEATTY", "state" : "NV", "county" : "NYE" },"89004": { "city" : "BLUE DIAMOND", "state" : "NV", "county" : "CLARK" },
            "89005": { "city" : "BOULDER CITY", "state" : "NV", "county" : "CLARK" },
            "89006": { "city" : "BOULDER CITY", "state" : "NV", "county" : "CLARK" },
            "89007": { "city" : "BUNKERVILLE", "state" : "NV", "county" : "CLARK" },
            "89008": { "city" : "CALIENTE", "state" : "NV", "county" : "LINCOLN" },
            "89009": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89010": { "city" : "DYER", "state" : "NV", "county" : "ESMERALDA" },
            "89011": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89012": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89013": { "city" : "GOLDFIELD", "state" : "NV", "county" : "ESMERALDA" },
            "89014": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89015": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89016": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89017": { "city" : "HIKO", "state" : "NV", "county" : "LINCOLN" },"89018": { "city" : "INDIAN SPRINGS", "state" : "NV", "county" : "CLARK" },
            "89019": { "city" : "JEAN", "state" : "NV", "county" : "CLARK" },"89020": { "city" : "AMARGOSA VALLEY", "state" : "NV", "county" : "NYE" },
            "89021": { "city" : "LOGANDALE", "state" : "NV", "county" : "CLARK" },
            "89022": { "city" : "MANHATTAN", "state" : "NV", "county" : "NYE" },"89023": { "city" : "MERCURY", "state" : "NV", "county" : "NYE" },
            "89024": { "city" : "MESQUITE", "state" : "NV", "county" : "CLARK" },
            "89025": { "city" : "MOAPA", "state" : "NV", "county" : "CLARK" },"89027": { "city" : "MESQUITE", "state" : "NV", "county" : "CLARK" },
            "89028": { "city" : "LAUGHLIN", "state" : "NV", "county" : "CLARK" },
            "89029": { "city" : "LAUGHLIN", "state" : "NV", "county" : "CLARK" },
            "89030": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89031": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89032": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89033": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89034": { "city" : "MESQUITE", "state" : "NV", "county" : "CLARK" },
            "89036": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89037": { "city" : "COYOTE SPRINGS", "state" : "NV", "county" : "CLARK" },
            "89039": { "city" : "CAL NEV ARI", "state" : "NV", "county" : "CLARK" },
            "89040": { "city" : "OVERTON", "state" : "NV", "county" : "CLARK" },"89041": { "city" : "PAHRUMP", "state" : "NV", "county" : "NYE" },
            "89042": { "city" : "PANACA", "state" : "NV", "county" : "LINCOLN" },
            "89043": { "city" : "PIOCHE", "state" : "NV", "county" : "LINCOLN" },
            "89044": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89045": { "city" : "ROUND MOUNTAIN", "state" : "NV", "county" : "NYE" },
            "89046": { "city" : "SEARCHLIGHT", "state" : "NV", "county" : "CLARK" },
            "89047": { "city" : "SILVERPEAK", "state" : "NV", "county" : "ESMERALDA" },
            "89048": { "city" : "PAHRUMP", "state" : "NV", "county" : "NYE" },"89049": { "city" : "TONOPAH", "state" : "NV", "county" : "NYE" },
            "89052": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89053": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89054": { "city" : "SLOAN", "state" : "NV", "county" : "CLARK" },"89060": { "city" : "PAHRUMP", "state" : "NV", "county" : "NYE" },
            "89061": { "city" : "PAHRUMP", "state" : "NV", "county" : "NYE" },"89070": { "city" : "INDIAN SPRINGS", "state" : "NV", "county" : "CLARK" },
            "89074": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89077": { "city" : "HENDERSON", "state" : "NV", "county" : "CLARK" },
            "89081": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89084": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89085": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89086": { "city" : "NORTH LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89101": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89102": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89103": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89104": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89105": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89106": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89107": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89108": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89109": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89110": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89111": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89112": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89113": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89114": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89115": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89116": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89117": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89118": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89119": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89120": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89121": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89122": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89123": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89124": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89125": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89126": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89127": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89128": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89129": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89130": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89131": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89132": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89133": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89134": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89135": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89136": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89137": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89138": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89139": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89140": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89141": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89142": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89143": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89144": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89145": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89146": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89147": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89148": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89149": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89150": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89151": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89154": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89155": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89156": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89157": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89158": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89160": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89161": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89162": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89163": { "city" : "THE LAKES", "state" : "NV", "county" : "CLARK" },
            "89165": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89166": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89169": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89170": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89173": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89177": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89178": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89179": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89180": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89183": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89191": { "city" : "NELLIS AFB", "state" : "NV", "county" : "CLARK" },
            "89193": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89195": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89199": { "city" : "LAS VEGAS", "state" : "NV", "county" : "CLARK" },
            "89301": { "city" : "ELY", "state" : "NV", "county" : "WHITE PINE" },
            "89310": { "city" : "AUSTIN", "state" : "NV", "county" : "LANDER" },"89311": { "city" : "BAKER", "state" : "NV", "county" : "WHITE PINE" },
            "89314": { "city" : "DUCKWATER", "state" : "NV", "county" : "WHITE PINE" },
            "89315": { "city" : "ELY", "state" : "NV", "county" : "WHITE PINE" },
            "89316": { "city" : "EUREKA", "state" : "NV", "county" : "EUREKA" },"89317": { "city" : "LUND", "state" : "NV", "county" : "WHITE PINE" },
            "89318": { "city" : "MC GILL", "state" : "NV", "county" : "WHITE PINE" },
            "89319": { "city" : "RUTH", "state" : "NV", "county" : "WHITE PINE" },
            "89402": { "city" : "CRYSTAL BAY", "state" : "NV", "county" : "WASHOE" },
            "89403": { "city" : "DAYTON", "state" : "NV", "county" : "LYON" },"89404": { "city" : "DENIO", "state" : "NV", "county" : "HUMBOLDT" },
            "89405": { "city" : "EMPIRE", "state" : "NV", "county" : "WASHOE" },"89406": { "city" : "FALLON", "state" : "NV", "county" : "CHURCHILL" },
            "89407": { "city" : "FALLON", "state" : "NV", "county" : "CHURCHILL" },
            "89408": { "city" : "FERNLEY", "state" : "NV", "county" : "LYON" },"89409": { "city" : "GABBS", "state" : "NV", "county" : "NYE" },
            "89410": { "city" : "GARDNERVILLE", "state" : "NV", "county" : "DOUGLAS" },
            "89411": { "city" : "GENOA", "state" : "NV", "county" : "DOUGLAS" },"89412": { "city" : "GERLACH", "state" : "NV", "county" : "WASHOE" },
            "89413": { "city" : "GLENBROOK", "state" : "NV", "county" : "DOUGLAS" },
            "89414": { "city" : "GOLCONDA", "state" : "NV", "county" : "HUMBOLDT" },
            "89415": { "city" : "HAWTHORNE", "state" : "NV", "county" : "MINERAL" },
            "89418": { "city" : "IMLAY", "state" : "NV", "county" : "PERSHING" },
            "89419": { "city" : "LOVELOCK", "state" : "NV", "county" : "PERSHING" },
            "89421": { "city" : "MC DERMITT", "state" : "NV", "county" : "HUMBOLDT" },
            "89422": { "city" : "MINA", "state" : "NV", "county" : "MINERAL" },"89423": { "city" : "MINDEN", "state" : "NV", "county" : "DOUGLAS" },
            "89424": { "city" : "NIXON", "state" : "NV", "county" : "WASHOE" },"89425": { "city" : "OROVADA", "state" : "NV", "county" : "HUMBOLDT" },
            "89426": { "city" : "PARADISE VALLEY", "state" : "NV", "county" : "HUMBOLDT" },
            "89427": { "city" : "SCHURZ", "state" : "NV", "county" : "MINERAL" },
            "89428": { "city" : "SILVER CITY", "state" : "NV", "county" : "LYON" },
            "89429": { "city" : "SILVER SPRINGS", "state" : "NV", "county" : "LYON" },
            "89430": { "city" : "SMITH", "state" : "NV", "county" : "LYON" },"89431": { "city" : "SPARKS", "state" : "NV", "county" : "WASHOE" },
            "89432": { "city" : "SPARKS", "state" : "NV", "county" : "WASHOE" },"89433": { "city" : "SUN VALLEY", "state" : "NV", "county" : "WASHOE" },
            "89434": { "city" : "SPARKS", "state" : "NV", "county" : "WASHOE" },"89435": { "city" : "SPARKS", "state" : "NV", "county" : "WASHOE" },
            "89436": { "city" : "SPARKS", "state" : "NV", "county" : "WASHOE" },"89438": { "city" : "VALMY", "state" : "NV", "county" : "HUMBOLDT" },
            "89439": { "city" : "VERDI", "state" : "NV", "county" : "WASHOE" },"89440": { "city" : "VIRGINIA CITY", "state" : "NV", "county" : "STOREY" },
            "89441": { "city" : "SPARKS", "state" : "NV", "county" : "WASHOE" },"89442": { "city" : "WADSWORTH", "state" : "NV", "county" : "WASHOE" },
            "89444": { "city" : "WELLINGTON", "state" : "NV", "county" : "LYON" },
            "89445": { "city" : "WINNEMUCCA", "state" : "NV", "county" : "HUMBOLDT" },
            "89446": { "city" : "WINNEMUCCA", "state" : "NV", "county" : "HUMBOLDT" },
            "89447": { "city" : "YERINGTON", "state" : "NV", "county" : "LYON" },
            "89448": { "city" : "ZEPHYR COVE", "state" : "NV", "county" : "DOUGLAS" },
            "89449": { "city" : "STATELINE", "state" : "NV", "county" : "DOUGLAS" },
            "89450": { "city" : "INCLINE VILLAGE", "state" : "NV", "county" : "WASHOE" },
            "89451": { "city" : "INCLINE VILLAGE", "state" : "NV", "county" : "WASHOE" },
            "89452": { "city" : "INCLINE VILLAGE", "state" : "NV", "county" : "WASHOE" },
            "89460": { "city" : "GARDNERVILLE", "state" : "NV", "county" : "DOUGLAS" },
            "89496": { "city" : "FALLON", "state" : "NV", "county" : "CHURCHILL" },
            "89501": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89502": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89503": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89504": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89505": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89506": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89507": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89508": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89509": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89510": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89511": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89512": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89513": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89515": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89519": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89520": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89521": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89523": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89533": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89557": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89570": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },"89595": { "city" : "RENO", "state" : "NV", "county" : "WASHOE" },
            "89701": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89702": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89703": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89704": { "city" : "WASHOE VALLEY", "state" : "NV", "county" : "WASHOE" },
            "89705": { "city" : "CARSON CITY", "state" : "NV", "county" : "DOUGLAS" },
            "89706": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89712": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89713": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89721": { "city" : "CARSON CITY", "state" : "NV", "county" : "CARSON CITY" },
            "89801": { "city" : "ELKO", "state" : "NV", "county" : "ELKO" },"89802": { "city" : "ELKO", "state" : "NV", "county" : "ELKO" },
            "89803": { "city" : "ELKO", "state" : "NV", "county" : "ELKO" },"89815": { "city" : "SPRING CREEK", "state" : "NV", "county" : "ELKO" },
            "89820": { "city" : "BATTLE MOUNTAIN", "state" : "NV", "county" : "LANDER" },
            "89821": { "city" : "CRESCENT VALLEY", "state" : "NV", "county" : "EUREKA" },
            "89822": { "city" : "CARLIN", "state" : "NV", "county" : "ELKO" },"89823": { "city" : "DEETH", "state" : "NV", "county" : "ELKO" },
            "89825": { "city" : "JACKPOT", "state" : "NV", "county" : "ELKO" },"89826": { "city" : "JARBIDGE", "state" : "NV", "county" : "ELKO" },
            "89828": { "city" : "LAMOILLE", "state" : "NV", "county" : "ELKO" },"89831": { "city" : "MOUNTAIN CITY", "state" : "NV", "county" : "ELKO" },
            "89832": { "city" : "OWYHEE", "state" : "NV", "county" : "ELKO" },"89834": { "city" : "TUSCARORA", "state" : "NV", "county" : "ELKO" },
            "89835": { "city" : "WELLS", "state" : "NV", "county" : "ELKO" },"89883": { "city" : "WEST WENDOVER", "state" : "NV", "county" : "ELKO" },
            "90001": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90002": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90003": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90004": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90005": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90006": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90007": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90008": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90009": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90010": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90011": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90012": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90013": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90014": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90015": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90016": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90017": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90018": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90019": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90020": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90021": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90022": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90023": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90024": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90025": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90026": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90027": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90028": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90029": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90030": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90031": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90032": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90033": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90034": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90035": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90036": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90037": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90038": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90039": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90040": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90041": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90042": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90043": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90044": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90045": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90046": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90047": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90048": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90049": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90050": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90051": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90052": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90054": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90055": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90056": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90057": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90058": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90059": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90060": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90061": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90062": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90063": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90064": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90065": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90066": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90067": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90068": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90069": { "city" : "WEST HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90070": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90071": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90072": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90073": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90074": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90075": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90076": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90077": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90078": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90079": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90080": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90081": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90082": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90083": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90084": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90086": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90087": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90088": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90089": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90091": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90093": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90094": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90095": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90096": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90099": { "city" : "LOS ANGELES", "state" : "CA", "county" : "LOS ANGELES" },
            "90201": { "city" : "BELL", "state" : "CA", "county" : "LOS ANGELES" },
            "90202": { "city" : "BELL GARDENS", "state" : "CA", "county" : "LOS ANGELES" },
            "90209": { "city" : "BEVERLY HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "90210": { "city" : "BEVERLY HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "90211": { "city" : "BEVERLY HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "90212": { "city" : "BEVERLY HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "90213": { "city" : "BEVERLY HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "90220": { "city" : "COMPTON", "state" : "CA", "county" : "LOS ANGELES" },
            "90221": { "city" : "COMPTON", "state" : "CA", "county" : "LOS ANGELES" },
            "90222": { "city" : "COMPTON", "state" : "CA", "county" : "LOS ANGELES" },
            "90224": { "city" : "COMPTON", "state" : "CA", "county" : "LOS ANGELES" },
            "90230": { "city" : "CULVER CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "90231": { "city" : "CULVER CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "90232": { "city" : "CULVER CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "90233": { "city" : "CULVER CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "90239": { "city" : "DOWNEY", "state" : "CA", "county" : "LOS ANGELES" },
            "90240": { "city" : "DOWNEY", "state" : "CA", "county" : "LOS ANGELES" },
            "90241": { "city" : "DOWNEY", "state" : "CA", "county" : "LOS ANGELES" },
            "90242": { "city" : "DOWNEY", "state" : "CA", "county" : "LOS ANGELES" },
            "90245": { "city" : "EL SEGUNDO", "state" : "CA", "county" : "LOS ANGELES" },
            "90247": { "city" : "GARDENA", "state" : "CA", "county" : "LOS ANGELES" },
            "90248": { "city" : "GARDENA", "state" : "CA", "county" : "LOS ANGELES" },
            "90249": { "city" : "GARDENA", "state" : "CA", "county" : "LOS ANGELES" },
            "90250": { "city" : "HAWTHORNE", "state" : "CA", "county" : "LOS ANGELES" },
            "90251": { "city" : "HAWTHORNE", "state" : "CA", "county" : "LOS ANGELES" },
            "90254": { "city" : "HERMOSA BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90255": { "city" : "HUNTINGTON PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "90260": { "city" : "LAWNDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "90261": { "city" : "LAWNDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "90262": { "city" : "LYNWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90263": { "city" : "MALIBU", "state" : "CA", "county" : "LOS ANGELES" },
            "90264": { "city" : "MALIBU", "state" : "CA", "county" : "LOS ANGELES" },
            "90265": { "city" : "MALIBU", "state" : "CA", "county" : "LOS ANGELES" },
            "90266": { "city" : "MANHATTAN BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90267": { "city" : "MANHATTAN BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90270": { "city" : "MAYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90272": { "city" : "PACIFIC PALISADES", "state" : "CA", "county" : "LOS ANGELES" },
            "90274": { "city" : "PALOS VERDES PENINSULA", "state" : "CA", "county" : "LOS ANGELES" },
            "90275": { "city" : "RANCHO PALOS VERDES", "state" : "CA", "county" : "LOS ANGELES" },
            "90277": { "city" : "REDONDO BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90278": { "city" : "REDONDO BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90280": { "city" : "SOUTH GATE", "state" : "CA", "county" : "LOS ANGELES" },
            "90290": { "city" : "TOPANGA", "state" : "CA", "county" : "LOS ANGELES" },
            "90291": { "city" : "VENICE", "state" : "CA", "county" : "LOS ANGELES" },
            "90292": { "city" : "MARINA DEL REY", "state" : "CA", "county" : "LOS ANGELES" },
            "90293": { "city" : "PLAYA DEL REY", "state" : "CA", "county" : "LOS ANGELES" },
            "90294": { "city" : "VENICE", "state" : "CA", "county" : "LOS ANGELES" },
            "90295": { "city" : "MARINA DEL REY", "state" : "CA", "county" : "LOS ANGELES" },
            "90296": { "city" : "PLAYA DEL REY", "state" : "CA", "county" : "LOS ANGELES" },
            "90301": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90302": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90303": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90304": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90305": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90306": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90308": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90309": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90310": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90311": { "city" : "INGLEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90401": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90402": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90403": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90404": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90405": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90406": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90407": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90408": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90409": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90410": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90411": { "city" : "SANTA MONICA", "state" : "CA", "county" : "LOS ANGELES" },
            "90501": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90502": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90503": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90504": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90505": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90506": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90507": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90508": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90509": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90510": { "city" : "TORRANCE", "state" : "CA", "county" : "LOS ANGELES" },
            "90601": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90602": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90603": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90604": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90605": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90606": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90607": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90608": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90609": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90610": { "city" : "WHITTIER", "state" : "CA", "county" : "LOS ANGELES" },
            "90620": { "city" : "BUENA PARK", "state" : "CA", "county" : "ORANGE" },
            "90621": { "city" : "BUENA PARK", "state" : "CA", "county" : "ORANGE" },
            "90622": { "city" : "BUENA PARK", "state" : "CA", "county" : "ORANGE" },
            "90623": { "city" : "LA PALMA", "state" : "CA", "county" : "ORANGE" },
            "90624": { "city" : "BUENA PARK", "state" : "CA", "county" : "ORANGE" },
            "90630": { "city" : "CYPRESS", "state" : "CA", "county" : "ORANGE" },
            "90631": { "city" : "LA HABRA", "state" : "CA", "county" : "ORANGE" },
            "90632": { "city" : "LA HABRA", "state" : "CA", "county" : "ORANGE" },
            "90633": { "city" : "LA HABRA", "state" : "CA", "county" : "ORANGE" },
            "90637": { "city" : "LA MIRADA", "state" : "CA", "county" : "LOS ANGELES" },
            "90638": { "city" : "LA MIRADA", "state" : "CA", "county" : "LOS ANGELES" },
            "90639": { "city" : "LA MIRADA", "state" : "CA", "county" : "LOS ANGELES" },
            "90640": { "city" : "MONTEBELLO", "state" : "CA", "county" : "LOS ANGELES" },
            "90650": { "city" : "NORWALK", "state" : "CA", "county" : "LOS ANGELES" },
            "90651": { "city" : "NORWALK", "state" : "CA", "county" : "LOS ANGELES" },
            "90652": { "city" : "NORWALK", "state" : "CA", "county" : "LOS ANGELES" },
            "90660": { "city" : "PICO RIVERA", "state" : "CA", "county" : "LOS ANGELES" },
            "90661": { "city" : "PICO RIVERA", "state" : "CA", "county" : "LOS ANGELES" },
            "90670": { "city" : "SANTA FE SPRINGS", "state" : "CA", "county" : "LOS ANGELES" },
            "90671": { "city" : "SANTA FE SPRINGS", "state" : "CA", "county" : "LOS ANGELES" },
            "90680": { "city" : "STANTON", "state" : "CA", "county" : "ORANGE" },
            "90701": { "city" : "ARTESIA", "state" : "CA", "county" : "LOS ANGELES" },
            "90702": { "city" : "ARTESIA", "state" : "CA", "county" : "LOS ANGELES" },
            "90703": { "city" : "CERRITOS", "state" : "CA", "county" : "LOS ANGELES" },
            "90704": { "city" : "AVALON", "state" : "CA", "county" : "LOS ANGELES" },
            "90706": { "city" : "BELLFLOWER", "state" : "CA", "county" : "LOS ANGELES" },
            "90707": { "city" : "BELLFLOWER", "state" : "CA", "county" : "LOS ANGELES" },
            "90710": { "city" : "HARBOR CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "90711": { "city" : "LAKEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90712": { "city" : "LAKEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90713": { "city" : "LAKEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90714": { "city" : "LAKEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90715": { "city" : "LAKEWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "90716": { "city" : "HAWAIIAN GARDENS", "state" : "CA", "county" : "LOS ANGELES" },
            "90717": { "city" : "LOMITA", "state" : "CA", "county" : "LOS ANGELES" },
            "90720": { "city" : "LOS ALAMITOS", "state" : "CA", "county" : "ORANGE" },
            "90721": { "city" : "LOS ALAMITOS", "state" : "CA", "county" : "ORANGE" },
            "90723": { "city" : "PARAMOUNT", "state" : "CA", "county" : "LOS ANGELES" },
            "90731": { "city" : "SAN PEDRO", "state" : "CA", "county" : "LOS ANGELES" },
            "90732": { "city" : "SAN PEDRO", "state" : "CA", "county" : "LOS ANGELES" },
            "90733": { "city" : "SAN PEDRO", "state" : "CA", "county" : "LOS ANGELES" },
            "90734": { "city" : "SAN PEDRO", "state" : "CA", "county" : "LOS ANGELES" },
            "90740": { "city" : "SEAL BEACH", "state" : "CA", "county" : "ORANGE" },
            "90742": { "city" : "SUNSET BEACH", "state" : "CA", "county" : "ORANGE" },
            "90743": { "city" : "SURFSIDE", "state" : "CA", "county" : "ORANGE" },
            "90744": { "city" : "WILMINGTON", "state" : "CA", "county" : "LOS ANGELES" },
            "90745": { "city" : "CARSON", "state" : "CA", "county" : "LOS ANGELES" },
            "90746": { "city" : "CARSON", "state" : "CA", "county" : "LOS ANGELES" },
            "90747": { "city" : "CARSON", "state" : "CA", "county" : "LOS ANGELES" },
            "90748": { "city" : "WILMINGTON", "state" : "CA", "county" : "LOS ANGELES" },
            "90749": { "city" : "CARSON", "state" : "CA", "county" : "LOS ANGELES" },
            "90755": { "city" : "SIGNAL HILL", "state" : "CA", "county" : "LOS ANGELES" },
            "90801": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90802": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90803": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90804": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90805": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90806": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90807": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90808": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90809": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90810": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90813": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90814": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90815": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90822": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90831": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90832": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90840": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90844": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90846": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90848": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90853": { "city" : "LONG BEACH", "state" : "CA", "county" : "LOS ANGELES" },
            "90895": { "city" : "CARSON", "state" : "CA", "county" : "LOS ANGELES" },
            "91001": { "city" : "ALTADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91003": { "city" : "ALTADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91006": { "city" : "ARCADIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91007": { "city" : "ARCADIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91008": { "city" : "DUARTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91009": { "city" : "DUARTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91010": { "city" : "DUARTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91011": { "city" : "LA CANADA FLINTRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91012": { "city" : "LA CANADA FLINTRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91016": { "city" : "MONROVIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91017": { "city" : "MONROVIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91020": { "city" : "MONTROSE", "state" : "CA", "county" : "LOS ANGELES" },
            "91021": { "city" : "MONTROSE", "state" : "CA", "county" : "LOS ANGELES" },
            "91023": { "city" : "MOUNT WILSON", "state" : "CA", "county" : "LOS ANGELES" },
            "91024": { "city" : "SIERRA MADRE", "state" : "CA", "county" : "LOS ANGELES" },
            "91025": { "city" : "SIERRA MADRE", "state" : "CA", "county" : "LOS ANGELES" },
            "91030": { "city" : "SOUTH PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91031": { "city" : "SOUTH PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91040": { "city" : "SUNLAND", "state" : "CA", "county" : "LOS ANGELES" },
            "91041": { "city" : "SUNLAND", "state" : "CA", "county" : "LOS ANGELES" },
            "91042": { "city" : "TUJUNGA", "state" : "CA", "county" : "LOS ANGELES" },
            "91043": { "city" : "TUJUNGA", "state" : "CA", "county" : "LOS ANGELES" },
            "91046": { "city" : "VERDUGO CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91066": { "city" : "ARCADIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91077": { "city" : "ARCADIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91101": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91102": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91103": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91104": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91105": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91106": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91107": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91108": { "city" : "SAN MARINO", "state" : "CA", "county" : "LOS ANGELES" },
            "91109": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91110": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91114": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91115": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91116": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91117": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91118": { "city" : "SAN MARINO", "state" : "CA", "county" : "LOS ANGELES" },
            "91121": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91124": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91125": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91129": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91182": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91188": { "city" : "PASADENA", "state" : "CA", "county" : "LOS ANGELES" },
            "91201": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91202": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91203": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91204": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91205": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91206": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91207": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91208": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91209": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91210": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91214": { "city" : "LA CRESCENTA", "state" : "CA", "county" : "LOS ANGELES" },
            "91221": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91222": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91224": { "city" : "LA CRESCENTA", "state" : "CA", "county" : "LOS ANGELES" },
            "91225": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91226": { "city" : "GLENDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "91301": { "city" : "AGOURA HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91302": { "city" : "CALABASAS", "state" : "CA", "county" : "LOS ANGELES" },
            "91303": { "city" : "CANOGA PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91304": { "city" : "CANOGA PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91305": { "city" : "CANOGA PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91306": { "city" : "WINNETKA", "state" : "CA", "county" : "LOS ANGELES" },
            "91307": { "city" : "WEST HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91308": { "city" : "WEST HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91309": { "city" : "CANOGA PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91310": { "city" : "CASTAIC", "state" : "CA", "county" : "LOS ANGELES" },
            "91311": { "city" : "CHATSWORTH", "state" : "CA", "county" : "LOS ANGELES" },
            "91313": { "city" : "CHATSWORTH", "state" : "CA", "county" : "LOS ANGELES" },
            "91316": { "city" : "ENCINO", "state" : "CA", "county" : "LOS ANGELES" },
            "91319": { "city" : "NEWBURY PARK", "state" : "CA", "county" : "VENTURA" },
            "91320": { "city" : "NEWBURY PARK", "state" : "CA", "county" : "VENTURA" },
            "91321": { "city" : "NEWHALL", "state" : "CA", "county" : "LOS ANGELES" },
            "91322": { "city" : "NEWHALL", "state" : "CA", "county" : "LOS ANGELES" },
            "91324": { "city" : "NORTHRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91325": { "city" : "NORTHRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91326": { "city" : "PORTER RANCH", "state" : "CA", "county" : "LOS ANGELES" },
            "91327": { "city" : "NORTHRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91328": { "city" : "NORTHRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91329": { "city" : "NORTHRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91330": { "city" : "NORTHRIDGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91331": { "city" : "PACOIMA", "state" : "CA", "county" : "LOS ANGELES" },
            "91333": { "city" : "PACOIMA", "state" : "CA", "county" : "LOS ANGELES" },
            "91334": { "city" : "PACOIMA", "state" : "CA", "county" : "LOS ANGELES" },
            "91335": { "city" : "RESEDA", "state" : "CA", "county" : "LOS ANGELES" },
            "91337": { "city" : "RESEDA", "state" : "CA", "county" : "LOS ANGELES" },
            "91340": { "city" : "SAN FERNANDO", "state" : "CA", "county" : "LOS ANGELES" },
            "91341": { "city" : "SAN FERNANDO", "state" : "CA", "county" : "LOS ANGELES" },
            "91342": { "city" : "SYLMAR", "state" : "CA", "county" : "LOS ANGELES" },
            "91343": { "city" : "NORTH HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91344": { "city" : "GRANADA HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91345": { "city" : "MISSION HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91346": { "city" : "MISSION HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91350": { "city" : "SANTA CLARITA", "state" : "CA", "county" : "LOS ANGELES" },
            "91351": { "city" : "CANYON COUNTRY", "state" : "CA", "county" : "LOS ANGELES" },
            "91352": { "city" : "SUN VALLEY", "state" : "CA", "county" : "LOS ANGELES" },
            "91353": { "city" : "SUN VALLEY", "state" : "CA", "county" : "LOS ANGELES" },
            "91354": { "city" : "VALENCIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91355": { "city" : "VALENCIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91356": { "city" : "TARZANA", "state" : "CA", "county" : "LOS ANGELES" },
            "91357": { "city" : "TARZANA", "state" : "CA", "county" : "LOS ANGELES" },
            "91358": { "city" : "THOUSAND OAKS", "state" : "CA", "county" : "VENTURA" },
            "91359": { "city" : "WESTLAKE VILLAGE", "state" : "CA", "county" : "VENTURA" },
            "91360": { "city" : "THOUSAND OAKS", "state" : "CA", "county" : "VENTURA" },
            "91361": { "city" : "WESTLAKE VILLAGE", "state" : "CA", "county" : "VENTURA" },
            "91362": { "city" : "THOUSAND OAKS", "state" : "CA", "county" : "VENTURA" },
            "91364": { "city" : "WOODLAND HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91365": { "city" : "WOODLAND HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91367": { "city" : "WOODLAND HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91371": { "city" : "WOODLAND HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91372": { "city" : "CALABASAS", "state" : "CA", "county" : "LOS ANGELES" },
            "91376": { "city" : "AGOURA HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91377": { "city" : "OAK PARK", "state" : "CA", "county" : "VENTURA" },
            "91380": { "city" : "SANTA CLARITA", "state" : "CA", "county" : "LOS ANGELES" },
            "91381": { "city" : "STEVENSON RANCH", "state" : "CA", "county" : "LOS ANGELES" },
            "91382": { "city" : "SANTA CLARITA", "state" : "CA", "county" : "LOS ANGELES" },
            "91383": { "city" : "SANTA CLARITA", "state" : "CA", "county" : "LOS ANGELES" },
            "91384": { "city" : "CASTAIC", "state" : "CA", "county" : "LOS ANGELES" },
            "91385": { "city" : "VALENCIA", "state" : "CA", "county" : "LOS ANGELES" },
            "91386": { "city" : "CANYON COUNTRY", "state" : "CA", "county" : "LOS ANGELES" },
            "91387": { "city" : "CANYON COUNTRY", "state" : "CA", "county" : "LOS ANGELES" },
            "91390": { "city" : "SANTA CLARITA", "state" : "CA", "county" : "LOS ANGELES" },
            "91392": { "city" : "SYLMAR", "state" : "CA", "county" : "LOS ANGELES" },
            "91393": { "city" : "NORTH HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91394": { "city" : "GRANADA HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91395": { "city" : "MISSION HILLS", "state" : "CA", "county" : "LOS ANGELES" },
            "91396": { "city" : "WINNETKA", "state" : "CA", "county" : "LOS ANGELES" },
            "91401": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91402": { "city" : "PANORAMA CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91403": { "city" : "SHERMAN OAKS", "state" : "CA", "county" : "LOS ANGELES" },
            "91404": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91405": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91406": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91408": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91409": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91410": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91411": { "city" : "VAN NUYS", "state" : "CA", "county" : "LOS ANGELES" },
            "91412": { "city" : "PANORAMA CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91413": { "city" : "SHERMAN OAKS", "state" : "CA", "county" : "LOS ANGELES" },
            "91416": { "city" : "ENCINO", "state" : "CA", "county" : "LOS ANGELES" },
            "91423": { "city" : "SHERMAN OAKS", "state" : "CA", "county" : "LOS ANGELES" },
            "91426": { "city" : "ENCINO", "state" : "CA", "county" : "LOS ANGELES" },
            "91436": { "city" : "ENCINO", "state" : "CA", "county" : "LOS ANGELES" },
            "91501": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91502": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91503": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91504": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91505": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91506": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91507": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91508": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91510": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91521": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91522": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91523": { "city" : "BURBANK", "state" : "CA", "county" : "LOS ANGELES" },
            "91601": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91602": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91603": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91604": { "city" : "STUDIO CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91605": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91606": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91607": { "city" : "VALLEY VILLAGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91608": { "city" : "UNIVERSAL CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91609": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91610": { "city" : "TOLUCA LAKE", "state" : "CA", "county" : "LOS ANGELES" },
            "91612": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91614": { "city" : "STUDIO CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91615": { "city" : "NORTH HOLLYWOOD", "state" : "CA", "county" : "LOS ANGELES" },
            "91617": { "city" : "VALLEY VILLAGE", "state" : "CA", "county" : "LOS ANGELES" },
            "91701": { "city" : "RANCHO CUCAMONGA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91702": { "city" : "AZUSA", "state" : "CA", "county" : "LOS ANGELES" },
            "91706": { "city" : "BALDWIN PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91708": { "city" : "CHINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91709": { "city" : "CHINO HILLS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91710": { "city" : "CHINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91711": { "city" : "CLAREMONT", "state" : "CA", "county" : "LOS ANGELES" },
            "91714": { "city" : "CITY OF INDUSTRY", "state" : "CA", "county" : "LOS ANGELES" },
            "91715": { "city" : "CITY OF INDUSTRY", "state" : "CA", "county" : "LOS ANGELES" },
            "91716": { "city" : "CITY OF INDUSTRY", "state" : "CA", "county" : "LOS ANGELES" },
            "91722": { "city" : "COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91723": { "city" : "COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91724": { "city" : "COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91729": { "city" : "RANCHO CUCAMONGA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91730": { "city" : "RANCHO CUCAMONGA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91731": { "city" : "EL MONTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91732": { "city" : "EL MONTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91733": { "city" : "SOUTH EL MONTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91734": { "city" : "EL MONTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91735": { "city" : "EL MONTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91737": { "city" : "RANCHO CUCAMONGA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91739": { "city" : "RANCHO CUCAMONGA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91740": { "city" : "GLENDORA", "state" : "CA", "county" : "LOS ANGELES" },
            "91741": { "city" : "GLENDORA", "state" : "CA", "county" : "LOS ANGELES" },
            "91743": { "city" : "GUASTI", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91744": { "city" : "LA PUENTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91745": { "city" : "HACIENDA HEIGHTS", "state" : "CA", "county" : "LOS ANGELES" },
            "91746": { "city" : "LA PUENTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91747": { "city" : "LA PUENTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91748": { "city" : "ROWLAND HEIGHTS", "state" : "CA", "county" : "LOS ANGELES" },
            "91749": { "city" : "LA PUENTE", "state" : "CA", "county" : "LOS ANGELES" },
            "91750": { "city" : "LA VERNE", "state" : "CA", "county" : "LOS ANGELES" },
            "91752": { "city" : "MIRA LOMA", "state" : "CA", "county" : "RIVERSIDE" },
            "91754": { "city" : "MONTEREY PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91755": { "city" : "MONTEREY PARK", "state" : "CA", "county" : "LOS ANGELES" },
            "91758": { "city" : "ONTARIO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91759": { "city" : "MT BALDY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91761": { "city" : "ONTARIO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91762": { "city" : "ONTARIO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91763": { "city" : "MONTCLAIR", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91764": { "city" : "ONTARIO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91765": { "city" : "DIAMOND BAR", "state" : "CA", "county" : "LOS ANGELES" },
            "91766": { "city" : "POMONA", "state" : "CA", "county" : "LOS ANGELES" },
            "91767": { "city" : "POMONA", "state" : "CA", "county" : "LOS ANGELES" },
            "91768": { "city" : "POMONA", "state" : "CA", "county" : "LOS ANGELES" },
            "91769": { "city" : "POMONA", "state" : "CA", "county" : "LOS ANGELES" },
            "91770": { "city" : "ROSEMEAD", "state" : "CA", "county" : "LOS ANGELES" },
            "91772": { "city" : "ROSEMEAD", "state" : "CA", "county" : "LOS ANGELES" },
            "91773": { "city" : "SAN DIMAS", "state" : "CA", "county" : "LOS ANGELES" },
            "91775": { "city" : "SAN GABRIEL", "state" : "CA", "county" : "LOS ANGELES" },
            "91776": { "city" : "SAN GABRIEL", "state" : "CA", "county" : "LOS ANGELES" },
            "91778": { "city" : "SAN GABRIEL", "state" : "CA", "county" : "LOS ANGELES" },
            "91780": { "city" : "TEMPLE CITY", "state" : "CA", "county" : "LOS ANGELES" },
            "91784": { "city" : "UPLAND", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91785": { "city" : "UPLAND", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91786": { "city" : "UPLAND", "state" : "CA", "county" : "SAN BERNARDINO" },
            "91788": { "city" : "WALNUT", "state" : "CA", "county" : "LOS ANGELES" },
            "91789": { "city" : "WALNUT", "state" : "CA", "county" : "LOS ANGELES" },
            "91790": { "city" : "WEST COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91791": { "city" : "WEST COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91792": { "city" : "WEST COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91793": { "city" : "WEST COVINA", "state" : "CA", "county" : "LOS ANGELES" },
            "91795": { "city" : "WALNUT", "state" : "CA", "county" : "LOS ANGELES" },
            "91801": { "city" : "ALHAMBRA", "state" : "CA", "county" : "LOS ANGELES" },
            "91802": { "city" : "ALHAMBRA", "state" : "CA", "county" : "LOS ANGELES" },
            "91803": { "city" : "ALHAMBRA", "state" : "CA", "county" : "LOS ANGELES" },
            "91901": { "city" : "ALPINE", "state" : "CA", "county" : "SAN DIEGO" },
            "91902": { "city" : "BONITA", "state" : "CA", "county" : "SAN DIEGO" },
            "91903": { "city" : "ALPINE", "state" : "CA", "county" : "SAN DIEGO" },
            "91905": { "city" : "BOULEVARD", "state" : "CA", "county" : "SAN DIEGO" },
            "91906": { "city" : "CAMPO", "state" : "CA", "county" : "SAN DIEGO" },
            "91908": { "city" : "BONITA", "state" : "CA", "county" : "SAN DIEGO" },
            "91909": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91910": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91911": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91912": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91913": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91914": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91915": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91916": { "city" : "DESCANSO", "state" : "CA", "county" : "SAN DIEGO" },
            "91917": { "city" : "DULZURA", "state" : "CA", "county" : "SAN DIEGO" },
            "91921": { "city" : "CHULA VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "91931": { "city" : "GUATAY", "state" : "CA", "county" : "SAN DIEGO" },
            "91932": { "city" : "IMPERIAL BEACH", "state" : "CA", "county" : "SAN DIEGO" },
            "91933": { "city" : "IMPERIAL BEACH", "state" : "CA", "county" : "SAN DIEGO" },
            "91934": { "city" : "JACUMBA", "state" : "CA", "county" : "SAN DIEGO" },
            "91935": { "city" : "JAMUL", "state" : "CA", "county" : "SAN DIEGO" },
            "91941": { "city" : "LA MESA", "state" : "CA", "county" : "SAN DIEGO" },
            "91942": { "city" : "LA MESA", "state" : "CA", "county" : "SAN DIEGO" },
            "91943": { "city" : "LA MESA", "state" : "CA", "county" : "SAN DIEGO" },
            "91944": { "city" : "LA MESA", "state" : "CA", "county" : "SAN DIEGO" },
            "91945": { "city" : "LEMON GROVE", "state" : "CA", "county" : "SAN DIEGO" },
            "91946": { "city" : "LEMON GROVE", "state" : "CA", "county" : "SAN DIEGO" },
            "91947": { "city" : "LINCOLN ACRES", "state" : "CA", "county" : "SAN DIEGO" },
            "91948": { "city" : "MOUNT LAGUNA", "state" : "CA", "county" : "SAN DIEGO" },
            "91950": { "city" : "NATIONAL CITY", "state" : "CA", "county" : "SAN DIEGO" },
            "91951": { "city" : "NATIONAL CITY", "state" : "CA", "county" : "SAN DIEGO" },
            "91962": { "city" : "PINE VALLEY", "state" : "CA", "county" : "SAN DIEGO" },
            "91963": { "city" : "POTRERO", "state" : "CA", "county" : "SAN DIEGO" },
            "91976": { "city" : "SPRING VALLEY", "state" : "CA", "county" : "SAN DIEGO" },
            "91977": { "city" : "SPRING VALLEY", "state" : "CA", "county" : "SAN DIEGO" },
            "91978": { "city" : "SPRING VALLEY", "state" : "CA", "county" : "SAN DIEGO" },
            "91979": { "city" : "SPRING VALLEY", "state" : "CA", "county" : "SAN DIEGO" },
            "91980": { "city" : "TECATE", "state" : "CA", "county" : "SAN DIEGO" },
            "92003": { "city" : "BONSALL", "state" : "CA", "county" : "SAN DIEGO" },
            "92004": { "city" : "BORREGO SPRINGS", "state" : "CA", "county" : "SAN DIEGO" },
            "92007": { "city" : "CARDIFF BY THE SEA", "state" : "CA", "county" : "SAN DIEGO" },
            "92008": { "city" : "CARLSBAD", "state" : "CA", "county" : "SAN DIEGO" },
            "92009": { "city" : "CARLSBAD", "state" : "CA", "county" : "SAN DIEGO" },
            "92010": { "city" : "CARLSBAD", "state" : "CA", "county" : "SAN DIEGO" },
            "92011": { "city" : "CARLSBAD", "state" : "CA", "county" : "SAN DIEGO" },
            "92013": { "city" : "CARLSBAD", "state" : "CA", "county" : "SAN DIEGO" },
            "92014": { "city" : "DEL MAR", "state" : "CA", "county" : "SAN DIEGO" },
            "92018": { "city" : "CARLSBAD", "state" : "CA", "county" : "SAN DIEGO" },
            "92019": { "city" : "EL CAJON", "state" : "CA", "county" : "SAN DIEGO" },
            "92020": { "city" : "EL CAJON", "state" : "CA", "county" : "SAN DIEGO" },
            "92021": { "city" : "EL CAJON", "state" : "CA", "county" : "SAN DIEGO" },
            "92022": { "city" : "EL CAJON", "state" : "CA", "county" : "SAN DIEGO" },
            "92023": { "city" : "ENCINITAS", "state" : "CA", "county" : "SAN DIEGO" },
            "92024": { "city" : "ENCINITAS", "state" : "CA", "county" : "SAN DIEGO" },
            "92025": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92026": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92027": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92028": { "city" : "FALLBROOK", "state" : "CA", "county" : "SAN DIEGO" },
            "92029": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92030": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92033": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92036": { "city" : "JULIAN", "state" : "CA", "county" : "SAN DIEGO" },
            "92037": { "city" : "LA JOLLA", "state" : "CA", "county" : "SAN DIEGO" },
            "92038": { "city" : "LA JOLLA", "state" : "CA", "county" : "SAN DIEGO" },
            "92039": { "city" : "LA JOLLA", "state" : "CA", "county" : "SAN DIEGO" },
            "92040": { "city" : "LAKESIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92046": { "city" : "ESCONDIDO", "state" : "CA", "county" : "SAN DIEGO" },
            "92049": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92051": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92052": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92054": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92055": { "city" : "CAMP PENDLETON", "state" : "CA", "county" : "SAN DIEGO" },
            "92056": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92057": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92058": { "city" : "OCEANSIDE", "state" : "CA", "county" : "SAN DIEGO" },
            "92059": { "city" : "PALA", "state" : "CA", "county" : "SAN DIEGO" },
            "92060": { "city" : "PALOMAR MOUNTAIN", "state" : "CA", "county" : "SAN DIEGO" },
            "92061": { "city" : "PAUMA VALLEY", "state" : "CA", "county" : "SAN DIEGO" },
            "92064": { "city" : "POWAY", "state" : "CA", "county" : "SAN DIEGO" },
            "92065": { "city" : "RAMONA", "state" : "CA", "county" : "SAN DIEGO" },
            "92066": { "city" : "RANCHITA", "state" : "CA", "county" : "SAN DIEGO" },
            "92067": { "city" : "RANCHO SANTA FE", "state" : "CA", "county" : "SAN DIEGO" },
            "92068": { "city" : "SAN LUIS REY", "state" : "CA", "county" : "SAN DIEGO" },
            "92069": { "city" : "SAN MARCOS", "state" : "CA", "county" : "SAN DIEGO" },
            "92070": { "city" : "SANTA YSABEL", "state" : "CA", "county" : "SAN DIEGO" },
            "92071": { "city" : "SANTEE", "state" : "CA", "county" : "SAN DIEGO" },
            "92072": { "city" : "SANTEE", "state" : "CA", "county" : "SAN DIEGO" },
            "92074": { "city" : "POWAY", "state" : "CA", "county" : "SAN DIEGO" },
            "92075": { "city" : "SOLANA BEACH", "state" : "CA", "county" : "SAN DIEGO" },
            "92078": { "city" : "SAN MARCOS", "state" : "CA", "county" : "SAN DIEGO" },
            "92079": { "city" : "SAN MARCOS", "state" : "CA", "county" : "SAN DIEGO" },
            "92081": { "city" : "VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "92082": { "city" : "VALLEY CENTER", "state" : "CA", "county" : "SAN DIEGO" },
            "92083": { "city" : "VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "92084": { "city" : "VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "92085": { "city" : "VISTA", "state" : "CA", "county" : "SAN DIEGO" },
            "92086": { "city" : "WARNER SPRINGS", "state" : "CA", "county" : "SAN DIEGO" },
            "92088": { "city" : "FALLBROOK", "state" : "CA", "county" : "SAN DIEGO" },
            "92090": { "city" : "EL CAJON", "state" : "CA", "county" : "SAN DIEGO" },
            "92091": { "city" : "RANCHO SANTA FE", "state" : "CA", "county" : "SAN DIEGO" },
            "92092": { "city" : "LA JOLLA", "state" : "CA", "county" : "SAN DIEGO" },
            "92093": { "city" : "LA JOLLA", "state" : "CA", "county" : "SAN DIEGO" },
            "92096": { "city" : "SAN MARCOS", "state" : "CA", "county" : "SAN DIEGO" },
            "92101": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92102": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92103": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92104": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92105": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92106": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92107": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92108": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92109": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92110": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92111": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92112": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92113": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92114": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92115": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92116": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92117": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92118": { "city" : "CORONADO", "state" : "CA", "county" : "SAN DIEGO" },
            "92119": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92120": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92121": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92122": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92123": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92124": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92126": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92127": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92128": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92129": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92130": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92131": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92132": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92134": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92135": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92136": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92137": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92138": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92139": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92140": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92143": { "city" : "SAN YSIDRO", "state" : "CA", "county" : "SAN DIEGO" },
            "92145": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92147": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92149": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92150": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92152": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92153": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92154": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92155": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92158": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92159": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92160": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92161": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92163": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92165": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92166": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92167": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92168": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92169": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92170": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92171": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92172": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92173": { "city" : "SAN YSIDRO", "state" : "CA", "county" : "SAN DIEGO" },
            "92174": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92175": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92176": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92177": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92178": { "city" : "CORONADO", "state" : "CA", "county" : "SAN DIEGO" },
            "92179": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92182": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92186": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92190": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92191": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92192": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92193": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92195": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92196": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92198": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92199": { "city" : "SAN DIEGO", "state" : "CA", "county" : "SAN DIEGO" },
            "92201": { "city" : "INDIO", "state" : "CA", "county" : "RIVERSIDE" },
            "92202": { "city" : "INDIO", "state" : "CA", "county" : "RIVERSIDE" },
            "92203": { "city" : "INDIO", "state" : "CA", "county" : "RIVERSIDE" },
            "92210": { "city" : "INDIAN WELLS", "state" : "CA", "county" : "RIVERSIDE" },
            "92211": { "city" : "PALM DESERT", "state" : "CA", "county" : "RIVERSIDE" },
            "92220": { "city" : "BANNING", "state" : "CA", "county" : "RIVERSIDE" },
            "92222": { "city" : "BARD", "state" : "CA", "county" : "IMPERIAL" },"92223": { "city" : "BEAUMONT", "state" : "CA", "county" : "RIVERSIDE" },
            "92225": { "city" : "BLYTHE", "state" : "CA", "county" : "RIVERSIDE" },
            "92226": { "city" : "BLYTHE", "state" : "CA", "county" : "RIVERSIDE" },
            "92227": { "city" : "BRAWLEY", "state" : "CA", "county" : "IMPERIAL" },
            "92230": { "city" : "CABAZON", "state" : "CA", "county" : "RIVERSIDE" },
            "92231": { "city" : "CALEXICO", "state" : "CA", "county" : "IMPERIAL" },
            "92232": { "city" : "CALEXICO", "state" : "CA", "county" : "IMPERIAL" },
            "92233": { "city" : "CALIPATRIA", "state" : "CA", "county" : "IMPERIAL" },
            "92234": { "city" : "CATHEDRAL CITY", "state" : "CA", "county" : "RIVERSIDE" },
            "92235": { "city" : "CATHEDRAL CITY", "state" : "CA", "county" : "RIVERSIDE" },
            "92236": { "city" : "COACHELLA", "state" : "CA", "county" : "RIVERSIDE" },
            "92239": { "city" : "DESERT CENTER", "state" : "CA", "county" : "RIVERSIDE" },
            "92240": { "city" : "DESERT HOT SPRINGS", "state" : "CA", "county" : "RIVERSIDE" },
            "92241": { "city" : "DESERT HOT SPRINGS", "state" : "CA", "county" : "RIVERSIDE" },
            "92242": { "city" : "EARP", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92243": { "city" : "EL CENTRO", "state" : "CA", "county" : "IMPERIAL" },
            "92244": { "city" : "EL CENTRO", "state" : "CA", "county" : "IMPERIAL" },
            "92247": { "city" : "LA QUINTA", "state" : "CA", "county" : "RIVERSIDE" },
            "92248": { "city" : "LA QUINTA", "state" : "CA", "county" : "RIVERSIDE" },
            "92249": { "city" : "HEBER", "state" : "CA", "county" : "IMPERIAL" },
            "92250": { "city" : "HOLTVILLE", "state" : "CA", "county" : "IMPERIAL" },
            "92251": { "city" : "IMPERIAL", "state" : "CA", "county" : "IMPERIAL" },
            "92252": { "city" : "JOSHUA TREE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92253": { "city" : "LA QUINTA", "state" : "CA", "county" : "RIVERSIDE" },
            "92254": { "city" : "MECCA", "state" : "CA", "county" : "RIVERSIDE" },
            "92255": { "city" : "PALM DESERT", "state" : "CA", "county" : "RIVERSIDE" },
            "92256": { "city" : "MORONGO VALLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92257": { "city" : "NILAND", "state" : "CA", "county" : "IMPERIAL" },
            "92258": { "city" : "NORTH PALM SPRINGS", "state" : "CA", "county" : "RIVERSIDE" },
            "92259": { "city" : "OCOTILLO", "state" : "CA", "county" : "IMPERIAL" },
            "92260": { "city" : "PALM DESERT", "state" : "CA", "county" : "RIVERSIDE" },
            "92261": { "city" : "PALM DESERT", "state" : "CA", "county" : "RIVERSIDE" },
            "92262": { "city" : "PALM SPRINGS", "state" : "CA", "county" : "RIVERSIDE" },
            "92263": { "city" : "PALM SPRINGS", "state" : "CA", "county" : "RIVERSIDE" },
            "92264": { "city" : "PALM SPRINGS", "state" : "CA", "county" : "RIVERSIDE" },
            "92266": { "city" : "PALO VERDE", "state" : "CA", "county" : "IMPERIAL" },
            "92267": { "city" : "PARKER DAM", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92268": { "city" : "PIONEERTOWN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92270": { "city" : "RANCHO MIRAGE", "state" : "CA", "county" : "RIVERSIDE" },
            "92273": { "city" : "SEELEY", "state" : "CA", "county" : "IMPERIAL" },
            "92274": { "city" : "THERMAL", "state" : "CA", "county" : "RIVERSIDE" },
            "92275": { "city" : "SALTON CITY", "state" : "CA", "county" : "IMPERIAL" },
            "92276": { "city" : "THOUSAND PALMS", "state" : "CA", "county" : "RIVERSIDE" },
            "92277": { "city" : "TWENTYNINE PALMS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92278": { "city" : "TWENTYNINE PALMS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92280": { "city" : "VIDAL", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92281": { "city" : "WESTMORLAND", "state" : "CA", "county" : "IMPERIAL" },
            "92282": { "city" : "WHITEWATER", "state" : "CA", "county" : "RIVERSIDE" },
            "92283": { "city" : "WINTERHAVEN", "state" : "CA", "county" : "IMPERIAL" },
            "92284": { "city" : "YUCCA VALLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92285": { "city" : "LANDERS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92286": { "city" : "YUCCA VALLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92301": { "city" : "ADELANTO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92304": { "city" : "AMBOY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92305": { "city" : "ANGELUS OAKS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92307": { "city" : "APPLE VALLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92308": { "city" : "APPLE VALLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92309": { "city" : "BAKER", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92310": { "city" : "FORT IRWIN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92311": { "city" : "BARSTOW", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92312": { "city" : "BARSTOW", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92313": { "city" : "GRAND TERRACE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92314": { "city" : "BIG BEAR CITY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92315": { "city" : "BIG BEAR LAKE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92316": { "city" : "BLOOMINGTON", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92317": { "city" : "BLUE JAY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92318": { "city" : "BRYN MAWR", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92320": { "city" : "CALIMESA", "state" : "CA", "county" : "RIVERSIDE" },
            "92321": { "city" : "CEDAR GLEN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92322": { "city" : "CEDARPINES PARK", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92323": { "city" : "CIMA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92324": { "city" : "COLTON", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92325": { "city" : "CRESTLINE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92326": { "city" : "CREST PARK", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92327": { "city" : "DAGGETT", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92328": { "city" : "DEATH VALLEY", "state" : "CA", "county" : "INYO" },
            "92329": { "city" : "PHELAN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92331": { "city" : "FONTANA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92332": { "city" : "ESSEX", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92333": { "city" : "FAWNSKIN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92334": { "city" : "FONTANA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92335": { "city" : "FONTANA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92336": { "city" : "FONTANA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92337": { "city" : "FONTANA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92338": { "city" : "LUDLOW", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92339": { "city" : "FOREST FALLS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92340": { "city" : "HESPERIA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92341": { "city" : "GREEN VALLEY LAKE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92342": { "city" : "HELENDALE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92344": { "city" : "HESPERIA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92345": { "city" : "HESPERIA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92346": { "city" : "HIGHLAND", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92347": { "city" : "HINKLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92350": { "city" : "LOMA LINDA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92352": { "city" : "LAKE ARROWHEAD", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92354": { "city" : "LOMA LINDA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92356": { "city" : "LUCERNE VALLEY", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92357": { "city" : "LOMA LINDA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92358": { "city" : "LYTLE CREEK", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92359": { "city" : "MENTONE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92363": { "city" : "NEEDLES", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92364": { "city" : "NIPTON", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92365": { "city" : "NEWBERRY SPRINGS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92366": { "city" : "MOUNTAIN PASS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92368": { "city" : "ORO GRANDE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92369": { "city" : "PATTON", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92371": { "city" : "PHELAN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92372": { "city" : "PINON HILLS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92373": { "city" : "REDLANDS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92374": { "city" : "REDLANDS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92375": { "city" : "REDLANDS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92376": { "city" : "RIALTO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92377": { "city" : "RIALTO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92378": { "city" : "RIMFOREST", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92382": { "city" : "RUNNING SPRINGS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92384": { "city" : "SHOSHONE", "state" : "CA", "county" : "INYO" },"92385": { "city" : "SKYFOREST", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92386": { "city" : "SUGARLOAF", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92389": { "city" : "TECOPA", "state" : "CA", "county" : "INYO" },"92391": { "city" : "TWIN PEAKS", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92392": { "city" : "VICTORVILLE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92393": { "city" : "VICTORVILLE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92394": { "city" : "VICTORVILLE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92395": { "city" : "VICTORVILLE", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92397": { "city" : "WRIGHTWOOD", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92398": { "city" : "YERMO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92399": { "city" : "YUCAIPA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92401": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92402": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92403": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92404": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92405": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92406": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92407": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92408": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92410": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92411": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92412": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92413": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92414": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92415": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92418": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92423": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92427": { "city" : "SAN BERNARDINO", "state" : "CA", "county" : "SAN BERNARDINO" },
            "92501": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92502": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92503": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92504": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92505": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92506": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92507": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92508": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92509": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92513": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92514": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92515": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92516": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92517": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92518": { "city" : "MARCH AIR RESERVE BASE", "state" : "CA", "county" : "RIVERSIDE" },
            "92519": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92521": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92522": { "city" : "RIVERSIDE", "state" : "CA", "county" : "RIVERSIDE" },
            "92530": { "city" : "LAKE ELSINORE", "state" : "CA", "county" : "RIVERSIDE" },
            "92531": { "city" : "LAKE ELSINORE", "state" : "CA", "county" : "RIVERSIDE" },
            "92532": { "city" : "LAKE ELSINORE", "state" : "CA", "county" : "RIVERSIDE" },
            "92536": { "city" : "AGUANGA", "state" : "CA", "county" : "RIVERSIDE" },
            "92539": { "city" : "ANZA", "state" : "CA", "county" : "RIVERSIDE" },
            "92543": { "city" : "HEMET", "state" : "CA", "county" : "RIVERSIDE" },
            "92544": { "city" : "HEMET", "state" : "CA", "county" : "RIVERSIDE" },
            "92545": { "city" : "HEMET", "state" : "CA", "county" : "RIVERSIDE" },
            "92546": { "city" : "HEMET", "state" : "CA", "county" : "RIVERSIDE" },
            "92548": { "city" : "HOMELAND", "state" : "CA", "county" : "RIVERSIDE" },
            "92549": { "city" : "IDYLLWILD", "state" : "CA", "county" : "RIVERSIDE" },
            "92551": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92552": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92553": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92554": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92555": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92556": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92557": { "city" : "MORENO VALLEY", "state" : "CA", "county" : "RIVERSIDE" },
            "92561": { "city" : "MOUNTAIN CENTER", "state" : "CA", "county" : "RIVERSIDE" },
            "92562": { "city" : "MURRIETA", "state" : "CA", "county" : "RIVERSIDE" },
            "92563": { "city" : "MURRIETA", "state" : "CA", "county" : "RIVERSIDE" },
            "92564": { "city" : "MURRIETA", "state" : "CA", "county" : "RIVERSIDE" },
            "92567": { "city" : "NUEVO", "state" : "CA", "county" : "RIVERSIDE" },
            "92570": { "city" : "PERRIS", "state" : "CA", "county" : "RIVERSIDE" },
            "92571": { "city" : "PERRIS", "state" : "CA", "county" : "RIVERSIDE" },
            "92572": { "city" : "PERRIS", "state" : "CA", "county" : "RIVERSIDE" },
            "92581": { "city" : "SAN JACINTO", "state" : "CA", "county" : "RIVERSIDE" },
            "92582": { "city" : "SAN JACINTO", "state" : "CA", "county" : "RIVERSIDE" },
            "92583": { "city" : "SAN JACINTO", "state" : "CA", "county" : "RIVERSIDE" },
            "92584": { "city" : "MENIFEE", "state" : "CA", "county" : "RIVERSIDE" },
            "92585": { "city" : "SUN CITY", "state" : "CA", "county" : "RIVERSIDE" },
            "92586": { "city" : "SUN CITY", "state" : "CA", "county" : "RIVERSIDE" },
            "92587": { "city" : "SUN CITY", "state" : "CA", "county" : "RIVERSIDE" },
            "92589": { "city" : "TEMECULA", "state" : "CA", "county" : "RIVERSIDE" },
            "92590": { "city" : "TEMECULA", "state" : "CA", "county" : "RIVERSIDE" },
            "92591": { "city" : "TEMECULA", "state" : "CA", "county" : "RIVERSIDE" },
            "92592": { "city" : "TEMECULA", "state" : "CA", "county" : "RIVERSIDE" },
            "92593": { "city" : "TEMECULA", "state" : "CA", "county" : "RIVERSIDE" },
            "92595": { "city" : "WILDOMAR", "state" : "CA", "county" : "RIVERSIDE" },
            "92596": { "city" : "WINCHESTER", "state" : "CA", "county" : "RIVERSIDE" },
            "92599": { "city" : "PERRIS", "state" : "CA", "county" : "RIVERSIDE" },
            "92602": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92603": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },
            "92604": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92605": { "city" : "HUNTINGTON BEACH", "state" : "CA", "county" : "ORANGE" },
            "92606": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92607": { "city" : "LAGUNA NIGUEL", "state" : "CA", "county" : "ORANGE" },
            "92609": { "city" : "EL TORO", "state" : "CA", "county" : "ORANGE" },
            "92610": { "city" : "FOOTHILL RANCH", "state" : "CA", "county" : "ORANGE" },
            "92612": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92614": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },
            "92615": { "city" : "HUNTINGTON BEACH", "state" : "CA", "county" : "ORANGE" },
            "92616": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92617": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },
            "92618": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92619": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },
            "92620": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92623": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },
            "92624": { "city" : "CAPISTRANO BEACH", "state" : "CA", "county" : "ORANGE" },
            "92625": { "city" : "CORONA DEL MAR", "state" : "CA", "county" : "ORANGE" },
            "92626": { "city" : "COSTA MESA", "state" : "CA", "county" : "ORANGE" },
            "92627": { "city" : "COSTA MESA", "state" : "CA", "county" : "ORANGE" },
            "92628": { "city" : "COSTA MESA", "state" : "CA", "county" : "ORANGE" },
            "92629": { "city" : "DANA POINT", "state" : "CA", "county" : "ORANGE" },
            "92630": { "city" : "LAKE FOREST", "state" : "CA", "county" : "ORANGE" },
            "92637": { "city" : "LAGUNA WOODS", "state" : "CA", "county" : "ORANGE" },
            "92646": { "city" : "HUNTINGTON BEACH", "state" : "CA", "county" : "ORANGE" },
            "92647": { "city" : "HUNTINGTON BEACH", "state" : "CA", "county" : "ORANGE" },
            "92648": { "city" : "HUNTINGTON BEACH", "state" : "CA", "county" : "ORANGE" },
            "92649": { "city" : "HUNTINGTON BEACH", "state" : "CA", "county" : "ORANGE" },
            "92650": { "city" : "EAST IRVINE", "state" : "CA", "county" : "ORANGE" },
            "92651": { "city" : "LAGUNA BEACH", "state" : "CA", "county" : "ORANGE" },
            "92652": { "city" : "LAGUNA BEACH", "state" : "CA", "county" : "ORANGE" },
            "92653": { "city" : "LAGUNA HILLS", "state" : "CA", "county" : "ORANGE" },
            "92654": { "city" : "LAGUNA HILLS", "state" : "CA", "county" : "ORANGE" },
            "92655": { "city" : "MIDWAY CITY", "state" : "CA", "county" : "ORANGE" },
            "92656": { "city" : "ALISO VIEJO", "state" : "CA", "county" : "ORANGE" },
            "92657": { "city" : "NEWPORT COAST", "state" : "CA", "county" : "ORANGE" },
            "92658": { "city" : "NEWPORT BEACH", "state" : "CA", "county" : "ORANGE" },
            "92659": { "city" : "NEWPORT BEACH", "state" : "CA", "county" : "ORANGE" },
            "92660": { "city" : "NEWPORT BEACH", "state" : "CA", "county" : "ORANGE" },
            "92661": { "city" : "NEWPORT BEACH", "state" : "CA", "county" : "ORANGE" },
            "92662": { "city" : "NEWPORT BEACH", "state" : "CA", "county" : "ORANGE" },
            "92663": { "city" : "NEWPORT BEACH", "state" : "CA", "county" : "ORANGE" },
            "92672": { "city" : "SAN CLEMENTE", "state" : "CA", "county" : "ORANGE" },
            "92673": { "city" : "SAN CLEMENTE", "state" : "CA", "county" : "ORANGE" },
            "92674": { "city" : "SAN CLEMENTE", "state" : "CA", "county" : "ORANGE" },
            "92675": { "city" : "SAN JUAN CAPISTRANO", "state" : "CA", "county" : "ORANGE" },
            "92676": { "city" : "SILVERADO", "state" : "CA", "county" : "ORANGE" },
            "92677": { "city" : "LAGUNA NIGUEL", "state" : "CA", "county" : "ORANGE" },
            "92678": { "city" : "TRABUCO CANYON", "state" : "CA", "county" : "ORANGE" },
            "92679": { "city" : "TRABUCO CANYON", "state" : "CA", "county" : "ORANGE" },
            "92683": { "city" : "WESTMINSTER", "state" : "CA", "county" : "ORANGE" },
            "92684": { "city" : "WESTMINSTER", "state" : "CA", "county" : "ORANGE" },
            "92685": { "city" : "WESTMINSTER", "state" : "CA", "county" : "ORANGE" },
            "92688": { "city" : "RANCHO SANTA MARGARITA", "state" : "CA", "county" : "ORANGE" },
            "92690": { "city" : "MISSION VIEJO", "state" : "CA", "county" : "ORANGE" },
            "92691": { "city" : "MISSION VIEJO", "state" : "CA", "county" : "ORANGE" },
            "92692": { "city" : "MISSION VIEJO", "state" : "CA", "county" : "ORANGE" },
            "92693": { "city" : "SAN JUAN CAPISTRANO", "state" : "CA", "county" : "ORANGE" },
            "92694": { "city" : "LADERA RANCH", "state" : "CA", "county" : "ORANGE" },
            "92697": { "city" : "IRVINE", "state" : "CA", "county" : "ORANGE" },"92698": { "city" : "ALISO VIEJO", "state" : "CA", "county" : "ORANGE" },
            "92701": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92702": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92703": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92704": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92705": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92706": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92707": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92708": { "city" : "FOUNTAIN VALLEY", "state" : "CA", "county" : "ORANGE" },
            "92711": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92712": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92728": { "city" : "FOUNTAIN VALLEY", "state" : "CA", "county" : "ORANGE" },
            "92735": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92780": { "city" : "TUSTIN", "state" : "CA", "county" : "ORANGE" },"92781": { "city" : "TUSTIN", "state" : "CA", "county" : "ORANGE" },
            "92782": { "city" : "TUSTIN", "state" : "CA", "county" : "ORANGE" },"92799": { "city" : "SANTA ANA", "state" : "CA", "county" : "ORANGE" },
            "92801": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92802": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92803": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92804": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92805": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92806": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92807": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92808": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92809": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92811": { "city" : "ATWOOD", "state" : "CA", "county" : "ORANGE" },"92812": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92814": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92815": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92816": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92817": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92821": { "city" : "BREA", "state" : "CA", "county" : "ORANGE" },"92822": { "city" : "BREA", "state" : "CA", "county" : "ORANGE" },
            "92823": { "city" : "BREA", "state" : "CA", "county" : "ORANGE" },"92825": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92831": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92832": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92833": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92834": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92835": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92836": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92837": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92838": { "city" : "FULLERTON", "state" : "CA", "county" : "ORANGE" },
            "92840": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92841": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92842": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92843": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92844": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92845": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92846": { "city" : "GARDEN GROVE", "state" : "CA", "county" : "ORANGE" },
            "92850": { "city" : "ANAHEIM", "state" : "CA", "county" : "ORANGE" },
            "92856": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },"92857": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },
            "92859": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },"92860": { "city" : "NORCO", "state" : "CA", "county" : "RIVERSIDE" },
            "92861": { "city" : "VILLA PARK", "state" : "CA", "county" : "ORANGE" },
            "92862": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },"92863": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },
            "92864": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },"92865": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },
            "92866": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },"92867": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },
            "92868": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },"92869": { "city" : "ORANGE", "state" : "CA", "county" : "ORANGE" },
            "92870": { "city" : "PLACENTIA", "state" : "CA", "county" : "ORANGE" },
            "92871": { "city" : "PLACENTIA", "state" : "CA", "county" : "ORANGE" },
            "92877": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92878": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92879": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92880": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92881": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92882": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92883": { "city" : "CORONA", "state" : "CA", "county" : "RIVERSIDE" },
            "92885": { "city" : "YORBA LINDA", "state" : "CA", "county" : "ORANGE" },
            "92886": { "city" : "YORBA LINDA", "state" : "CA", "county" : "ORANGE" },
            "92887": { "city" : "YORBA LINDA", "state" : "CA", "county" : "ORANGE" },
            "93001": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93002": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93003": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93004": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93005": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93006": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93007": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93009": { "city" : "VENTURA", "state" : "CA", "county" : "VENTURA" },
            "93010": { "city" : "CAMARILLO", "state" : "CA", "county" : "VENTURA" },
            "93011": { "city" : "CAMARILLO", "state" : "CA", "county" : "VENTURA" },
            "93012": { "city" : "CAMARILLO", "state" : "CA", "county" : "VENTURA" },
            "93013": { "city" : "CARPINTERIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93014": { "city" : "CARPINTERIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93015": { "city" : "FILLMORE", "state" : "CA", "county" : "VENTURA" },
            "93016": { "city" : "FILLMORE", "state" : "CA", "county" : "VENTURA" },
            "93020": { "city" : "MOORPARK", "state" : "CA", "county" : "VENTURA" },
            "93021": { "city" : "MOORPARK", "state" : "CA", "county" : "VENTURA" },
            "93022": { "city" : "OAK VIEW", "state" : "CA", "county" : "VENTURA" },
            "93023": { "city" : "OJAI", "state" : "CA", "county" : "VENTURA" },"93024": { "city" : "OJAI", "state" : "CA", "county" : "VENTURA" },
            "93030": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93031": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93032": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93033": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93034": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93035": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93036": { "city" : "OXNARD", "state" : "CA", "county" : "VENTURA" },
            "93040": { "city" : "PIRU", "state" : "CA", "county" : "VENTURA" },"93041": { "city" : "PORT HUENEME", "state" : "CA", "county" : "VENTURA" },
            "93042": { "city" : "POINT MUGU NAWC", "state" : "CA", "county" : "VENTURA" },
            "93043": { "city" : "PORT HUENEME CBC BASE", "state" : "CA", "county" : "VENTURA" },
            "93044": { "city" : "PORT HUENEME", "state" : "CA", "county" : "VENTURA" },
            "93060": { "city" : "SANTA PAULA", "state" : "CA", "county" : "VENTURA" },
            "93061": { "city" : "SANTA PAULA", "state" : "CA", "county" : "VENTURA" },
            "93062": { "city" : "SIMI VALLEY", "state" : "CA", "county" : "VENTURA" },
            "93063": { "city" : "SIMI VALLEY", "state" : "CA", "county" : "VENTURA" },
            "93064": { "city" : "BRANDEIS", "state" : "CA", "county" : "VENTURA" },
            "93065": { "city" : "SIMI VALLEY", "state" : "CA", "county" : "VENTURA" },
            "93066": { "city" : "SOMIS", "state" : "CA", "county" : "VENTURA" },"93067": { "city" : "SUMMERLAND", "state" : "CA", "county" : "SANTA BARBARA" },
            "93094": { "city" : "SIMI VALLEY", "state" : "CA", "county" : "VENTURA" },
            "93099": { "city" : "SIMI VALLEY", "state" : "CA", "county" : "VENTURA" },
            "93101": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93102": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93103": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93105": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93106": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93107": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93108": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93109": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93110": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93111": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93116": { "city" : "GOLETA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93117": { "city" : "GOLETA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93118": { "city" : "GOLETA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93120": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93121": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93130": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93140": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93150": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93160": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93190": { "city" : "SANTA BARBARA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93199": { "city" : "GOLETA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93201": { "city" : "ALPAUGH", "state" : "CA", "county" : "TULARE" },
            "93202": { "city" : "ARMONA", "state" : "CA", "county" : "KINGS" },"93203": { "city" : "ARVIN", "state" : "CA", "county" : "KERN" },
            "93204": { "city" : "AVENAL", "state" : "CA", "county" : "KINGS" },"93205": { "city" : "BODFISH", "state" : "CA", "county" : "KERN" },
            "93206": { "city" : "BUTTONWILLOW", "state" : "CA", "county" : "KERN" },
            "93207": { "city" : "CALIFORNIA HOT SPRINGS", "state" : "CA", "county" : "TULARE" },
            "93208": { "city" : "CAMP NELSON", "state" : "CA", "county" : "TULARE" },
            "93210": { "city" : "COALINGA", "state" : "CA", "county" : "FRESNO" },
            "93212": { "city" : "CORCORAN", "state" : "CA", "county" : "KINGS" },
            "93215": { "city" : "DELANO", "state" : "CA", "county" : "KERN" },"93216": { "city" : "DELANO", "state" : "CA", "county" : "KERN" },
            "93218": { "city" : "DUCOR", "state" : "CA", "county" : "TULARE" },"93219": { "city" : "EARLIMART", "state" : "CA", "county" : "TULARE" },
            "93220": { "city" : "EDISON", "state" : "CA", "county" : "KERN" },"93221": { "city" : "EXETER", "state" : "CA", "county" : "TULARE" },
            "93222": { "city" : "FRAZIER PARK", "state" : "CA", "county" : "KERN" },
            "93223": { "city" : "FARMERSVILLE", "state" : "CA", "county" : "TULARE" },
            "93224": { "city" : "FELLOWS", "state" : "CA", "county" : "KERN" },"93225": { "city" : "FRAZIER PARK", "state" : "CA", "county" : "KERN" },
            "93226": { "city" : "GLENNVILLE", "state" : "CA", "county" : "KERN" },
            "93227": { "city" : "GOSHEN", "state" : "CA", "county" : "TULARE" },"93230": { "city" : "HANFORD", "state" : "CA", "county" : "KINGS" },
            "93232": { "city" : "HANFORD", "state" : "CA", "county" : "KINGS" },"93234": { "city" : "HURON", "state" : "CA", "county" : "FRESNO" },
            "93235": { "city" : "IVANHOE", "state" : "CA", "county" : "TULARE" },
            "93238": { "city" : "KERNVILLE", "state" : "CA", "county" : "KERN" },
            "93239": { "city" : "KETTLEMAN CITY", "state" : "CA", "county" : "KINGS" },
            "93240": { "city" : "LAKE ISABELLA", "state" : "CA", "county" : "KERN" },
            "93241": { "city" : "LAMONT", "state" : "CA", "county" : "KERN" },"93242": { "city" : "LATON", "state" : "CA", "county" : "FRESNO" },
            "93243": { "city" : "LEBEC", "state" : "CA", "county" : "KERN" },"93244": { "city" : "LEMON COVE", "state" : "CA", "county" : "TULARE" },
            "93245": { "city" : "LEMOORE", "state" : "CA", "county" : "KINGS" },"93246": { "city" : "LEMOORE", "state" : "CA", "county" : "KINGS" },
            "93247": { "city" : "LINDSAY", "state" : "CA", "county" : "TULARE" },
            "93249": { "city" : "LOST HILLS", "state" : "CA", "county" : "KERN" },
            "93250": { "city" : "MC FARLAND", "state" : "CA", "county" : "KERN" },
            "93251": { "city" : "MC KITTRICK", "state" : "CA", "county" : "KERN" },
            "93252": { "city" : "MARICOPA", "state" : "CA", "county" : "KERN" },"93254": { "city" : "NEW CUYAMA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93255": { "city" : "ONYX", "state" : "CA", "county" : "KERN" },"93256": { "city" : "PIXLEY", "state" : "CA", "county" : "TULARE" },
            "93257": { "city" : "PORTERVILLE", "state" : "CA", "county" : "TULARE" },
            "93258": { "city" : "PORTERVILLE", "state" : "CA", "county" : "TULARE" },
            "93260": { "city" : "POSEY", "state" : "CA", "county" : "TULARE" },"93261": { "city" : "RICHGROVE", "state" : "CA", "county" : "TULARE" },
            "93262": { "city" : "SEQUOIA NATIONAL PARK", "state" : "CA", "county" : "TULARE" },
            "93263": { "city" : "SHAFTER", "state" : "CA", "county" : "KERN" },"93265": { "city" : "SPRINGVILLE", "state" : "CA", "county" : "TULARE" },
            "93266": { "city" : "STRATFORD", "state" : "CA", "county" : "KINGS" },
            "93267": { "city" : "STRATHMORE", "state" : "CA", "county" : "TULARE" },
            "93268": { "city" : "TAFT", "state" : "CA", "county" : "KERN" },"93270": { "city" : "TERRA BELLA", "state" : "CA", "county" : "TULARE" },
            "93271": { "city" : "THREE RIVERS", "state" : "CA", "county" : "TULARE" },
            "93272": { "city" : "TIPTON", "state" : "CA", "county" : "TULARE" },"93274": { "city" : "TULARE", "state" : "CA", "county" : "TULARE" },
            "93275": { "city" : "TULARE", "state" : "CA", "county" : "TULARE" },"93276": { "city" : "TUPMAN", "state" : "CA", "county" : "KERN" },
            "93277": { "city" : "VISALIA", "state" : "CA", "county" : "TULARE" },
            "93278": { "city" : "VISALIA", "state" : "CA", "county" : "TULARE" },
            "93279": { "city" : "VISALIA", "state" : "CA", "county" : "TULARE" },
            "93280": { "city" : "WASCO", "state" : "CA", "county" : "KERN" },"93282": { "city" : "WAUKENA", "state" : "CA", "county" : "TULARE" },
            "93283": { "city" : "WELDON", "state" : "CA", "county" : "KERN" },"93285": { "city" : "WOFFORD HEIGHTS", "state" : "CA", "county" : "KERN" },
            "93286": { "city" : "WOODLAKE", "state" : "CA", "county" : "TULARE" },
            "93290": { "city" : "VISALIA", "state" : "CA", "county" : "TULARE" },
            "93291": { "city" : "VISALIA", "state" : "CA", "county" : "TULARE" },
            "93292": { "city" : "VISALIA", "state" : "CA", "county" : "TULARE" },
            "93301": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93302": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93303": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93304": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93305": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93306": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93307": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93308": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93309": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93311": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93312": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93313": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93314": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93380": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93383": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93384": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93385": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93386": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93387": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93388": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93389": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93390": { "city" : "BAKERSFIELD", "state" : "CA", "county" : "KERN" },
            "93401": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93402": { "city" : "LOS OSOS", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93403": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93405": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93406": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93407": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93408": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93409": { "city" : "SAN LUIS OBISPO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93412": { "city" : "LOS OSOS", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93420": { "city" : "ARROYO GRANDE", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93421": { "city" : "ARROYO GRANDE", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93422": { "city" : "ATASCADERO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93423": { "city" : "ATASCADERO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93424": { "city" : "AVILA BEACH", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93426": { "city" : "BRADLEY", "state" : "CA", "county" : "MONTEREY" },
            "93427": { "city" : "BUELLTON", "state" : "CA", "county" : "SANTA BARBARA" },
            "93428": { "city" : "CAMBRIA", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93429": { "city" : "CASMALIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93430": { "city" : "CAYUCOS", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93432": { "city" : "CRESTON", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93433": { "city" : "GROVER BEACH", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93434": { "city" : "GUADALUPE", "state" : "CA", "county" : "SANTA BARBARA" },
            "93435": { "city" : "HARMONY", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93436": { "city" : "LOMPOC", "state" : "CA", "county" : "SANTA BARBARA" },
            "93437": { "city" : "LOMPOC", "state" : "CA", "county" : "SANTA BARBARA" },
            "93438": { "city" : "LOMPOC", "state" : "CA", "county" : "SANTA BARBARA" },
            "93440": { "city" : "LOS ALAMOS", "state" : "CA", "county" : "SANTA BARBARA" },
            "93441": { "city" : "LOS OLIVOS", "state" : "CA", "county" : "SANTA BARBARA" },
            "93442": { "city" : "MORRO BAY", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93443": { "city" : "MORRO BAY", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93444": { "city" : "NIPOMO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93445": { "city" : "OCEANO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93446": { "city" : "PASO ROBLES", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93447": { "city" : "PASO ROBLES", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93448": { "city" : "PISMO BEACH", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93449": { "city" : "PISMO BEACH", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93450": { "city" : "SAN ARDO", "state" : "CA", "county" : "MONTEREY" },
            "93451": { "city" : "SAN MIGUEL", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93452": { "city" : "SAN SIMEON", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93453": { "city" : "SANTA MARGARITA", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93454": { "city" : "SANTA MARIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93455": { "city" : "SANTA MARIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93456": { "city" : "SANTA MARIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93457": { "city" : "SANTA MARIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93458": { "city" : "SANTA MARIA", "state" : "CA", "county" : "SANTA BARBARA" },
            "93460": { "city" : "SANTA YNEZ", "state" : "CA", "county" : "SANTA BARBARA" },
            "93461": { "city" : "SHANDON", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93463": { "city" : "SOLVANG", "state" : "CA", "county" : "SANTA BARBARA" },
            "93464": { "city" : "SOLVANG", "state" : "CA", "county" : "SANTA BARBARA" },
            "93465": { "city" : "TEMPLETON", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93475": { "city" : "OCEANO", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93483": { "city" : "GROVER BEACH", "state" : "CA", "county" : "SAN LUIS OBISPO" },
            "93501": { "city" : "MOJAVE", "state" : "CA", "county" : "KERN" },"93502": { "city" : "MOJAVE", "state" : "CA", "county" : "KERN" },
            "93504": { "city" : "CALIFORNIA CITY", "state" : "CA", "county" : "KERN" },
            "93505": { "city" : "CALIFORNIA CITY", "state" : "CA", "county" : "KERN" },
            "93510": { "city" : "ACTON", "state" : "CA", "county" : "LOS ANGELES" },
            "93512": { "city" : "BENTON", "state" : "CA", "county" : "MONO" },"93513": { "city" : "BIG PINE", "state" : "CA", "county" : "INYO" },
            "93514": { "city" : "BISHOP", "state" : "CA", "county" : "INYO" },"93515": { "city" : "BISHOP", "state" : "CA", "county" : "INYO" },
            "93516": { "city" : "BORON", "state" : "CA", "county" : "KERN" },"93517": { "city" : "BRIDGEPORT", "state" : "CA", "county" : "MONO" },
            "93518": { "city" : "CALIENTE", "state" : "CA", "county" : "KERN" },"93519": { "city" : "CANTIL", "state" : "CA", "county" : "KERN" },
            "93522": { "city" : "DARWIN", "state" : "CA", "county" : "INYO" },"93523": { "city" : "EDWARDS", "state" : "CA", "county" : "KERN" },
            "93524": { "city" : "EDWARDS", "state" : "CA", "county" : "KERN" },"93526": { "city" : "INDEPENDENCE", "state" : "CA", "county" : "INYO" },
            "93527": { "city" : "INYOKERN", "state" : "CA", "county" : "KERN" },"93529": { "city" : "JUNE LAKE", "state" : "CA", "county" : "MONO" },
            "93530": { "city" : "KEELER", "state" : "CA", "county" : "INYO" },"93531": { "city" : "KEENE", "state" : "CA", "county" : "KERN" },
            "93532": { "city" : "LAKE HUGHES", "state" : "CA", "county" : "LOS ANGELES" },
            "93534": { "city" : "LANCASTER", "state" : "CA", "county" : "LOS ANGELES" },
            "93535": { "city" : "LANCASTER", "state" : "CA", "county" : "LOS ANGELES" },
            "93536": { "city" : "LANCASTER", "state" : "CA", "county" : "LOS ANGELES" },
            "93539": { "city" : "LANCASTER", "state" : "CA", "county" : "LOS ANGELES" },
            "93541": { "city" : "LEE VINING", "state" : "CA", "county" : "MONO" },
            "93542": { "city" : "LITTLE LAKE", "state" : "CA", "county" : "INYO" },
            "93543": { "city" : "LITTLEROCK", "state" : "CA", "county" : "LOS ANGELES" },
            "93544": { "city" : "LLANO", "state" : "CA", "county" : "LOS ANGELES" },
            "93545": { "city" : "LONE PINE", "state" : "CA", "county" : "INYO" },
            "93546": { "city" : "MAMMOTH LAKES", "state" : "CA", "county" : "MONO" },
            "93549": { "city" : "OLANCHA", "state" : "CA", "county" : "INYO" },"93550": { "city" : "PALMDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "93551": { "city" : "PALMDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "93552": { "city" : "PALMDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "93553": { "city" : "PEARBLOSSOM", "state" : "CA", "county" : "LOS ANGELES" },
            "93554": { "city" : "RANDSBURG", "state" : "CA", "county" : "KERN" },
            "93555": { "city" : "RIDGECREST", "state" : "CA", "county" : "KERN" },
            "93556": { "city" : "RIDGECREST", "state" : "CA", "county" : "KERN" },
            "93558": { "city" : "RED MOUNTAIN", "state" : "CA", "county" : "SAN BERNARDINO" },
            "93560": { "city" : "ROSAMOND", "state" : "CA", "county" : "KERN" },"93561": { "city" : "TEHACHAPI", "state" : "CA", "county" : "KERN" },
            "93562": { "city" : "TRONA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "93563": { "city" : "VALYERMO", "state" : "CA", "county" : "LOS ANGELES" },
            "93581": { "city" : "TEHACHAPI", "state" : "CA", "county" : "KERN" },
            "93584": { "city" : "LANCASTER", "state" : "CA", "county" : "LOS ANGELES" },
            "93586": { "city" : "LANCASTER", "state" : "CA", "county" : "LOS ANGELES" },
            "93590": { "city" : "PALMDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "93591": { "city" : "PALMDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "93592": { "city" : "TRONA", "state" : "CA", "county" : "SAN BERNARDINO" },
            "93596": { "city" : "BORON", "state" : "CA", "county" : "KERN" },"93599": { "city" : "PALMDALE", "state" : "CA", "county" : "LOS ANGELES" },
            "93601": { "city" : "AHWAHNEE", "state" : "CA", "county" : "MADERA" },
            "93602": { "city" : "AUBERRY", "state" : "CA", "county" : "FRESNO" },
            "93603": { "city" : "BADGER", "state" : "CA", "county" : "TULARE" },"93604": { "city" : "BASS LAKE", "state" : "CA", "county" : "MADERA" },
            "93605": { "city" : "BIG CREEK", "state" : "CA", "county" : "FRESNO" },
            "93606": { "city" : "BIOLA", "state" : "CA", "county" : "FRESNO" },"93607": { "city" : "BURREL", "state" : "CA", "county" : "FRESNO" },
            "93608": { "city" : "CANTUA CREEK", "state" : "CA", "county" : "FRESNO" },
            "93609": { "city" : "CARUTHERS", "state" : "CA", "county" : "FRESNO" },
            "93610": { "city" : "CHOWCHILLA", "state" : "CA", "county" : "MADERA" },
            "93611": { "city" : "CLOVIS", "state" : "CA", "county" : "FRESNO" },"93612": { "city" : "CLOVIS", "state" : "CA", "county" : "FRESNO" },
            "93613": { "city" : "CLOVIS", "state" : "CA", "county" : "FRESNO" },"93614": { "city" : "COARSEGOLD", "state" : "CA", "county" : "MADERA" },
            "93615": { "city" : "CUTLER", "state" : "CA", "county" : "TULARE" },"93616": { "city" : "DEL REY", "state" : "CA", "county" : "FRESNO" },
            "93618": { "city" : "DINUBA", "state" : "CA", "county" : "TULARE" },"93619": { "city" : "CLOVIS", "state" : "CA", "county" : "FRESNO" },
            "93620": { "city" : "DOS PALOS", "state" : "CA", "county" : "MERCED" },
            "93621": { "city" : "DUNLAP", "state" : "CA", "county" : "FRESNO" },"93622": { "city" : "FIREBAUGH", "state" : "CA", "county" : "FRESNO" },
            "93623": { "city" : "FISH CAMP", "state" : "CA", "county" : "MARIPOSA" },
            "93624": { "city" : "FIVE POINTS", "state" : "CA", "county" : "FRESNO" },
            "93625": { "city" : "FOWLER", "state" : "CA", "county" : "FRESNO" },"93626": { "city" : "FRIANT", "state" : "CA", "county" : "FRESNO" },
            "93627": { "city" : "HELM", "state" : "CA", "county" : "FRESNO" },"93628": { "city" : "HUME", "state" : "CA", "county" : "FRESNO" },
            "93630": { "city" : "KERMAN", "state" : "CA", "county" : "FRESNO" },"93631": { "city" : "KINGSBURG", "state" : "CA", "county" : "FRESNO" },
            "93633": { "city" : "KINGS CANYON NATIONAL PK", "state" : "CA", "county" : "TULARE" },
            "93634": { "city" : "LAKESHORE", "state" : "CA", "county" : "FRESNO" },
            "93635": { "city" : "LOS BANOS", "state" : "CA", "county" : "MERCED" },
            "93636": { "city" : "MADERA", "state" : "CA", "county" : "MADERA" },"93637": { "city" : "MADERA", "state" : "CA", "county" : "MADERA" },
            "93638": { "city" : "MADERA", "state" : "CA", "county" : "MADERA" },"93639": { "city" : "MADERA", "state" : "CA", "county" : "MADERA" },
            "93640": { "city" : "MENDOTA", "state" : "CA", "county" : "FRESNO" },
            "93641": { "city" : "MIRAMONTE", "state" : "CA", "county" : "FRESNO" },
            "93642": { "city" : "MONO HOT SPRINGS", "state" : "CA", "county" : "FRESNO" },
            "93643": { "city" : "NORTH FORK", "state" : "CA", "county" : "MADERA" },
            "93644": { "city" : "OAKHURST", "state" : "CA", "county" : "MADERA" },
            "93645": { "city" : "O NEALS", "state" : "CA", "county" : "MADERA" },
            "93646": { "city" : "ORANGE COVE", "state" : "CA", "county" : "FRESNO" },
            "93647": { "city" : "OROSI", "state" : "CA", "county" : "TULARE" },"93648": { "city" : "PARLIER", "state" : "CA", "county" : "FRESNO" },
            "93649": { "city" : "PIEDRA", "state" : "CA", "county" : "FRESNO" },"93650": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93651": { "city" : "PRATHER", "state" : "CA", "county" : "FRESNO" },
            "93652": { "city" : "RAISIN CITY", "state" : "CA", "county" : "FRESNO" },
            "93653": { "city" : "RAYMOND", "state" : "CA", "county" : "MADERA" },
            "93654": { "city" : "REEDLEY", "state" : "CA", "county" : "FRESNO" },
            "93656": { "city" : "RIVERDALE", "state" : "CA", "county" : "FRESNO" },
            "93657": { "city" : "SANGER", "state" : "CA", "county" : "FRESNO" },"93660": { "city" : "SAN JOAQUIN", "state" : "CA", "county" : "FRESNO" },
            "93661": { "city" : "SANTA RITA PARK", "state" : "CA", "county" : "MERCED" },
            "93662": { "city" : "SELMA", "state" : "CA", "county" : "FRESNO" },"93664": { "city" : "SHAVER LAKE", "state" : "CA", "county" : "FRESNO" },
            "93665": { "city" : "SOUTH DOS PALOS", "state" : "CA", "county" : "MERCED" },
            "93666": { "city" : "SULTANA", "state" : "CA", "county" : "TULARE" },
            "93667": { "city" : "TOLLHOUSE", "state" : "CA", "county" : "FRESNO" },
            "93668": { "city" : "TRANQUILLITY", "state" : "CA", "county" : "FRESNO" },
            "93669": { "city" : "WISHON", "state" : "CA", "county" : "MADERA" },"93670": { "city" : "YETTEM", "state" : "CA", "county" : "TULARE" },
            "93673": { "city" : "TRAVER", "state" : "CA", "county" : "TULARE" },"93675": { "city" : "SQUAW VALLEY", "state" : "CA", "county" : "FRESNO" },
            "93701": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93702": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93703": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93704": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93705": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93706": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93707": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93708": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93709": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93710": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93711": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93712": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93714": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93715": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93716": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93717": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93718": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93720": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93721": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93722": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93723": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93724": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93725": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93726": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93727": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93728": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93729": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93730": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93737": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93740": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93741": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93744": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93745": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93747": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93750": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93755": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93771": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93772": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93774": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93775": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93776": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93777": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93778": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93779": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93786": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93790": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93791": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93792": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93793": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93794": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },
            "93888": { "city" : "FRESNO", "state" : "CA", "county" : "FRESNO" },"93901": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93902": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93905": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93906": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93907": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93908": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93912": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93915": { "city" : "SALINAS", "state" : "CA", "county" : "MONTEREY" },
            "93920": { "city" : "BIG SUR", "state" : "CA", "county" : "MONTEREY" },
            "93921": { "city" : "CARMEL BY THE SEA", "state" : "CA", "county" : "MONTEREY" },
            "93922": { "city" : "CARMEL", "state" : "CA", "county" : "MONTEREY" },
            "93923": { "city" : "CARMEL", "state" : "CA", "county" : "MONTEREY" },
            "93924": { "city" : "CARMEL VALLEY", "state" : "CA", "county" : "MONTEREY" },
            "93925": { "city" : "CHUALAR", "state" : "CA", "county" : "MONTEREY" },
            "93926": { "city" : "GONZALES", "state" : "CA", "county" : "MONTEREY" },
            "93927": { "city" : "GREENFIELD", "state" : "CA", "county" : "MONTEREY" },
            "93928": { "city" : "JOLON", "state" : "CA", "county" : "MONTEREY" },
            "93930": { "city" : "KING CITY", "state" : "CA", "county" : "MONTEREY" },
            "93932": { "city" : "LOCKWOOD", "state" : "CA", "county" : "MONTEREY" },
            "93933": { "city" : "MARINA", "state" : "CA", "county" : "MONTEREY" },
            "93940": { "city" : "MONTEREY", "state" : "CA", "county" : "MONTEREY" },
            "93942": { "city" : "MONTEREY", "state" : "CA", "county" : "MONTEREY" },
            "93943": { "city" : "MONTEREY", "state" : "CA", "county" : "MONTEREY" },
            "93944": { "city" : "MONTEREY", "state" : "CA", "county" : "MONTEREY" },
            "93950": { "city" : "PACIFIC GROVE", "state" : "CA", "county" : "MONTEREY" },
            "93953": { "city" : "PEBBLE BEACH", "state" : "CA", "county" : "MONTEREY" },
            "93954": { "city" : "SAN LUCAS", "state" : "CA", "county" : "MONTEREY" },
            "93955": { "city" : "SEASIDE", "state" : "CA", "county" : "MONTEREY" },
            "93960": { "city" : "SOLEDAD", "state" : "CA", "county" : "MONTEREY" },
            "93962": { "city" : "SPRECKELS", "state" : "CA", "county" : "MONTEREY" },
            "94002": { "city" : "BELMONT", "state" : "CA", "county" : "SAN MATEO" },
            "94005": { "city" : "BRISBANE", "state" : "CA", "county" : "SAN MATEO" },
            "94010": { "city" : "BURLINGAME", "state" : "CA", "county" : "SAN MATEO" },
            "94011": { "city" : "BURLINGAME", "state" : "CA", "county" : "SAN MATEO" },
            "94013": { "city" : "DALY CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94014": { "city" : "DALY CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94015": { "city" : "DALY CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94016": { "city" : "DALY CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94017": { "city" : "DALY CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94018": { "city" : "EL GRANADA", "state" : "CA", "county" : "SAN MATEO" },
            "94019": { "city" : "HALF MOON BAY", "state" : "CA", "county" : "SAN MATEO" },
            "94020": { "city" : "LA HONDA", "state" : "CA", "county" : "SAN MATEO" },
            "94021": { "city" : "LOMA MAR", "state" : "CA", "county" : "SAN MATEO" },
            "94022": { "city" : "LOS ALTOS", "state" : "CA", "county" : "SANTA CLARA" },
            "94023": { "city" : "LOS ALTOS", "state" : "CA", "county" : "SANTA CLARA" },
            "94024": { "city" : "LOS ALTOS", "state" : "CA", "county" : "SANTA CLARA" },
            "94025": { "city" : "MENLO PARK", "state" : "CA", "county" : "SAN MATEO" },
            "94026": { "city" : "MENLO PARK", "state" : "CA", "county" : "SAN MATEO" },
            "94027": { "city" : "ATHERTON", "state" : "CA", "county" : "SAN MATEO" },
            "94028": { "city" : "PORTOLA VALLEY", "state" : "CA", "county" : "SAN MATEO" },
            "94030": { "city" : "MILLBRAE", "state" : "CA", "county" : "SAN MATEO" },
            "94035": { "city" : "MOUNTAIN VIEW", "state" : "CA", "county" : "SANTA CLARA" },
            "94037": { "city" : "MONTARA", "state" : "CA", "county" : "SAN MATEO" },
            "94038": { "city" : "MOSS BEACH", "state" : "CA", "county" : "SAN MATEO" },
            "94039": { "city" : "MOUNTAIN VIEW", "state" : "CA", "county" : "SANTA CLARA" },
            "94040": { "city" : "MOUNTAIN VIEW", "state" : "CA", "county" : "SANTA CLARA" },
            "94041": { "city" : "MOUNTAIN VIEW", "state" : "CA", "county" : "SANTA CLARA" },
            "94042": { "city" : "MOUNTAIN VIEW", "state" : "CA", "county" : "SANTA CLARA" },
            "94043": { "city" : "MOUNTAIN VIEW", "state" : "CA", "county" : "SANTA CLARA" },
            "94044": { "city" : "PACIFICA", "state" : "CA", "county" : "SAN MATEO" },
            "94060": { "city" : "PESCADERO", "state" : "CA", "county" : "SAN MATEO" },
            "94061": { "city" : "REDWOOD CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94062": { "city" : "REDWOOD CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94063": { "city" : "REDWOOD CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94064": { "city" : "REDWOOD CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94065": { "city" : "REDWOOD CITY", "state" : "CA", "county" : "SAN MATEO" },
            "94066": { "city" : "SAN BRUNO", "state" : "CA", "county" : "SAN MATEO" },
            "94070": { "city" : "SAN CARLOS", "state" : "CA", "county" : "SAN MATEO" },
            "94074": { "city" : "SAN GREGORIO", "state" : "CA", "county" : "SAN MATEO" },
            "94080": { "city" : "SOUTH SAN FRANCISCO", "state" : "CA", "county" : "SAN MATEO" },
            "94083": { "city" : "SOUTH SAN FRANCISCO", "state" : "CA", "county" : "SAN MATEO" },
            "94085": { "city" : "SUNNYVALE", "state" : "CA", "county" : "SANTA CLARA" },
            "94086": { "city" : "SUNNYVALE", "state" : "CA", "county" : "SANTA CLARA" },
            "94087": { "city" : "SUNNYVALE", "state" : "CA", "county" : "SANTA CLARA" },
            "94088": { "city" : "SUNNYVALE", "state" : "CA", "county" : "SANTA CLARA" },
            "94089": { "city" : "SUNNYVALE", "state" : "CA", "county" : "SANTA CLARA" },
            "94101": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94102": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94103": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94104": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94105": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94107": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94108": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94109": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94110": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94111": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94112": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94114": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94115": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94116": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94117": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94118": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94119": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94120": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94121": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94122": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94123": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94124": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94125": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94126": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94127": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94128": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN MATEO" },
            "94129": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94130": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94131": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94132": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94133": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94134": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94137": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94139": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94140": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94141": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94142": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94143": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94144": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94145": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94146": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94147": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94153": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94158": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94159": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94164": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94188": { "city" : "SAN FRANCISCO", "state" : "CA", "county" : "SAN FRANCISCO" },
            "94203": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94204": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94205": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94208": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94211": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94230": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94240": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94256": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94280": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "94301": { "city" : "PALO ALTO", "state" : "CA", "county" : "SANTA CLARA" },
            "94302": { "city" : "PALO ALTO", "state" : "CA", "county" : "SANTA CLARA" },
            "94303": { "city" : "PALO ALTO", "state" : "CA", "county" : "SANTA CLARA" },
            "94304": { "city" : "PALO ALTO", "state" : "CA", "county" : "SANTA CLARA" },
            "94305": { "city" : "STANFORD", "state" : "CA", "county" : "SANTA CLARA" },
            "94306": { "city" : "PALO ALTO", "state" : "CA", "county" : "SANTA CLARA" },
            "94309": { "city" : "PALO ALTO", "state" : "CA", "county" : "SANTA CLARA" },
            "94401": { "city" : "SAN MATEO", "state" : "CA", "county" : "SAN MATEO" },
            "94402": { "city" : "SAN MATEO", "state" : "CA", "county" : "SAN MATEO" },
            "94403": { "city" : "SAN MATEO", "state" : "CA", "county" : "SAN MATEO" },
            "94404": { "city" : "SAN MATEO", "state" : "CA", "county" : "SAN MATEO" },
            "94497": { "city" : "SAN MATEO", "state" : "CA", "county" : "SAN MATEO" },
            "94501": { "city" : "ALAMEDA", "state" : "CA", "county" : "ALAMEDA" },
            "94502": { "city" : "ALAMEDA", "state" : "CA", "county" : "ALAMEDA" },
            "94503": { "city" : "AMERICAN CANYON", "state" : "CA", "county" : "NAPA" },
            "94505": { "city" : "DISCOVERY BAY", "state" : "CA", "county" : "CONTRA COSTA" },
            "94506": { "city" : "DANVILLE", "state" : "CA", "county" : "CONTRA COSTA" },
            "94507": { "city" : "ALAMO", "state" : "CA", "county" : "CONTRA COSTA" },
            "94508": { "city" : "ANGWIN", "state" : "CA", "county" : "NAPA" },"94509": { "city" : "ANTIOCH", "state" : "CA", "county" : "CONTRA COSTA" },
            "94510": { "city" : "BENICIA", "state" : "CA", "county" : "SOLANO" },
            "94511": { "city" : "BETHEL ISLAND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94512": { "city" : "BIRDS LANDING", "state" : "CA", "county" : "SOLANO" },
            "94513": { "city" : "BRENTWOOD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94514": { "city" : "BYRON", "state" : "CA", "county" : "CONTRA COSTA" },
            "94515": { "city" : "CALISTOGA", "state" : "CA", "county" : "NAPA" },
            "94516": { "city" : "CANYON", "state" : "CA", "county" : "CONTRA COSTA" },
            "94517": { "city" : "CLAYTON", "state" : "CA", "county" : "CONTRA COSTA" },
            "94518": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94519": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94520": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94521": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94522": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94523": { "city" : "PLEASANT HILL", "state" : "CA", "county" : "CONTRA COSTA" },
            "94524": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94525": { "city" : "CROCKETT", "state" : "CA", "county" : "CONTRA COSTA" },
            "94526": { "city" : "DANVILLE", "state" : "CA", "county" : "CONTRA COSTA" },
            "94527": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94528": { "city" : "DIABLO", "state" : "CA", "county" : "CONTRA COSTA" },
            "94529": { "city" : "CONCORD", "state" : "CA", "county" : "CONTRA COSTA" },
            "94530": { "city" : "EL CERRITO", "state" : "CA", "county" : "CONTRA COSTA" },
            "94531": { "city" : "ANTIOCH", "state" : "CA", "county" : "CONTRA COSTA" },
            "94533": { "city" : "FAIRFIELD", "state" : "CA", "county" : "SOLANO" },
            "94534": { "city" : "FAIRFIELD", "state" : "CA", "county" : "SOLANO" },
            "94535": { "city" : "TRAVIS AFB", "state" : "CA", "county" : "SOLANO" },
            "94536": { "city" : "FREMONT", "state" : "CA", "county" : "ALAMEDA" },
            "94537": { "city" : "FREMONT", "state" : "CA", "county" : "ALAMEDA" },
            "94538": { "city" : "FREMONT", "state" : "CA", "county" : "ALAMEDA" },
            "94539": { "city" : "FREMONT", "state" : "CA", "county" : "ALAMEDA" },
            "94540": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94541": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94542": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94543": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94544": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94545": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94546": { "city" : "CASTRO VALLEY", "state" : "CA", "county" : "ALAMEDA" },
            "94547": { "city" : "HERCULES", "state" : "CA", "county" : "CONTRA COSTA" },
            "94548": { "city" : "KNIGHTSEN", "state" : "CA", "county" : "CONTRA COSTA" },
            "94549": { "city" : "LAFAYETTE", "state" : "CA", "county" : "CONTRA COSTA" },
            "94550": { "city" : "LIVERMORE", "state" : "CA", "county" : "ALAMEDA" },
            "94551": { "city" : "LIVERMORE", "state" : "CA", "county" : "ALAMEDA" },
            "94552": { "city" : "CASTRO VALLEY", "state" : "CA", "county" : "ALAMEDA" },
            "94553": { "city" : "MARTINEZ", "state" : "CA", "county" : "CONTRA COSTA" },
            "94555": { "city" : "FREMONT", "state" : "CA", "county" : "ALAMEDA" },
            "94556": { "city" : "MORAGA", "state" : "CA", "county" : "CONTRA COSTA" },
            "94557": { "city" : "HAYWARD", "state" : "CA", "county" : "ALAMEDA" },
            "94558": { "city" : "NAPA", "state" : "CA", "county" : "NAPA" },"94559": { "city" : "NAPA", "state" : "CA", "county" : "NAPA" },
            "94560": { "city" : "NEWARK", "state" : "CA", "county" : "ALAMEDA" },
            "94561": { "city" : "OAKLEY", "state" : "CA", "county" : "CONTRA COSTA" },
            "94562": { "city" : "OAKVILLE", "state" : "CA", "county" : "NAPA" },"94563": { "city" : "ORINDA", "state" : "CA", "county" : "CONTRA COSTA" },
            "94564": { "city" : "PINOLE", "state" : "CA", "county" : "CONTRA COSTA" },
            "94565": { "city" : "PITTSBURG", "state" : "CA", "county" : "CONTRA COSTA" },
            "94566": { "city" : "PLEASANTON", "state" : "CA", "county" : "ALAMEDA" },
            "94567": { "city" : "POPE VALLEY", "state" : "CA", "county" : "NAPA" },
            "94568": { "city" : "DUBLIN", "state" : "CA", "county" : "ALAMEDA" },
            "94569": { "city" : "PORT COSTA", "state" : "CA", "county" : "CONTRA COSTA" },
            "94570": { "city" : "MORAGA", "state" : "CA", "county" : "CONTRA COSTA" },
            "94571": { "city" : "RIO VISTA", "state" : "CA", "county" : "SOLANO" },
            "94572": { "city" : "RODEO", "state" : "CA", "county" : "CONTRA COSTA" },
            "94573": { "city" : "RUTHERFORD", "state" : "CA", "county" : "NAPA" },
            "94574": { "city" : "SAINT HELENA", "state" : "CA", "county" : "NAPA" },
            "94575": { "city" : "MORAGA", "state" : "CA", "county" : "CONTRA COSTA" },
            "94576": { "city" : "DEER PARK", "state" : "CA", "county" : "NAPA" },
            "94577": { "city" : "SAN LEANDRO", "state" : "CA", "county" : "ALAMEDA" },
            "94578": { "city" : "SAN LEANDRO", "state" : "CA", "county" : "ALAMEDA" },
            "94579": { "city" : "SAN LEANDRO", "state" : "CA", "county" : "ALAMEDA" },
            "94580": { "city" : "SAN LORENZO", "state" : "CA", "county" : "ALAMEDA" },
            "94581": { "city" : "NAPA", "state" : "CA", "county" : "NAPA" },"94582": { "city" : "SAN RAMON", "state" : "CA", "county" : "CONTRA COSTA" },
            "94583": { "city" : "SAN RAMON", "state" : "CA", "county" : "CONTRA COSTA" },
            "94585": { "city" : "SUISUN CITY", "state" : "CA", "county" : "SOLANO" },
            "94586": { "city" : "SUNOL", "state" : "CA", "county" : "ALAMEDA" },"94587": { "city" : "UNION CITY", "state" : "CA", "county" : "ALAMEDA" },
            "94588": { "city" : "PLEASANTON", "state" : "CA", "county" : "ALAMEDA" },
            "94589": { "city" : "VALLEJO", "state" : "CA", "county" : "SOLANO" },
            "94590": { "city" : "VALLEJO", "state" : "CA", "county" : "SOLANO" },
            "94591": { "city" : "VALLEJO", "state" : "CA", "county" : "SOLANO" },
            "94592": { "city" : "VALLEJO", "state" : "CA", "county" : "SOLANO" },
            "94595": { "city" : "WALNUT CREEK", "state" : "CA", "county" : "CONTRA COSTA" },
            "94596": { "city" : "WALNUT CREEK", "state" : "CA", "county" : "CONTRA COSTA" },
            "94597": { "city" : "WALNUT CREEK", "state" : "CA", "county" : "CONTRA COSTA" },
            "94598": { "city" : "WALNUT CREEK", "state" : "CA", "county" : "CONTRA COSTA" },
            "94599": { "city" : "YOUNTVILLE", "state" : "CA", "county" : "NAPA" },
            "94601": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94602": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94603": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94604": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94605": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94606": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94607": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94608": { "city" : "EMERYVILLE", "state" : "CA", "county" : "ALAMEDA" },
            "94609": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94610": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94611": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94612": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94613": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94614": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94615": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94617": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94618": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94619": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94620": { "city" : "PIEDMONT", "state" : "CA", "county" : "ALAMEDA" },
            "94621": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94623": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94624": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94649": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94660": { "city" : "OAKLAND", "state" : "CA", "county" : "ALAMEDA" },
            "94662": { "city" : "EMERYVILLE", "state" : "CA", "county" : "ALAMEDA" },
            "94701": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94702": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94703": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94704": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94705": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94706": { "city" : "ALBANY", "state" : "CA", "county" : "ALAMEDA" },
            "94707": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94708": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94709": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94710": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94712": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94720": { "city" : "BERKELEY", "state" : "CA", "county" : "ALAMEDA" },
            "94801": { "city" : "RICHMOND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94802": { "city" : "RICHMOND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94803": { "city" : "EL SOBRANTE", "state" : "CA", "county" : "CONTRA COSTA" },
            "94804": { "city" : "RICHMOND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94805": { "city" : "RICHMOND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94806": { "city" : "SAN PABLO", "state" : "CA", "county" : "CONTRA COSTA" },
            "94807": { "city" : "RICHMOND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94808": { "city" : "RICHMOND", "state" : "CA", "county" : "CONTRA COSTA" },
            "94820": { "city" : "EL SOBRANTE", "state" : "CA", "county" : "CONTRA COSTA" },
            "94901": { "city" : "SAN RAFAEL", "state" : "CA", "county" : "MARIN" },
            "94903": { "city" : "SAN RAFAEL", "state" : "CA", "county" : "MARIN" },
            "94904": { "city" : "GREENBRAE", "state" : "CA", "county" : "MARIN" },
            "94912": { "city" : "SAN RAFAEL", "state" : "CA", "county" : "MARIN" },
            "94913": { "city" : "SAN RAFAEL", "state" : "CA", "county" : "MARIN" },
            "94914": { "city" : "KENTFIELD", "state" : "CA", "county" : "MARIN" },
            "94915": { "city" : "SAN RAFAEL", "state" : "CA", "county" : "MARIN" },
            "94920": { "city" : "BELVEDERE TIBURON", "state" : "CA", "county" : "MARIN" },
            "94922": { "city" : "BODEGA", "state" : "CA", "county" : "SONOMA" },"94923": { "city" : "BODEGA BAY", "state" : "CA", "county" : "SONOMA" },
            "94924": { "city" : "BOLINAS", "state" : "CA", "county" : "MARIN" },"94925": { "city" : "CORTE MADERA", "state" : "CA", "county" : "MARIN" },
            "94926": { "city" : "ROHNERT PARK", "state" : "CA", "county" : "SONOMA" },
            "94927": { "city" : "ROHNERT PARK", "state" : "CA", "county" : "SONOMA" },
            "94928": { "city" : "ROHNERT PARK", "state" : "CA", "county" : "SONOMA" },
            "94929": { "city" : "DILLON BEACH", "state" : "CA", "county" : "MARIN" },
            "94930": { "city" : "FAIRFAX", "state" : "CA", "county" : "MARIN" },"94931": { "city" : "COTATI", "state" : "CA", "county" : "SONOMA" },
            "94933": { "city" : "FOREST KNOLLS", "state" : "CA", "county" : "MARIN" },
            "94937": { "city" : "INVERNESS", "state" : "CA", "county" : "MARIN" },
            "94938": { "city" : "LAGUNITAS", "state" : "CA", "county" : "MARIN" },
            "94939": { "city" : "LARKSPUR", "state" : "CA", "county" : "MARIN" },
            "94940": { "city" : "MARSHALL", "state" : "CA", "county" : "MARIN" },
            "94941": { "city" : "MILL VALLEY", "state" : "CA", "county" : "MARIN" },
            "94942": { "city" : "MILL VALLEY", "state" : "CA", "county" : "MARIN" },
            "94945": { "city" : "NOVATO", "state" : "CA", "county" : "MARIN" },"94946": { "city" : "NICASIO", "state" : "CA", "county" : "MARIN" },
            "94947": { "city" : "NOVATO", "state" : "CA", "county" : "MARIN" },"94948": { "city" : "NOVATO", "state" : "CA", "county" : "MARIN" },
            "94949": { "city" : "NOVATO", "state" : "CA", "county" : "MARIN" },"94950": { "city" : "OLEMA", "state" : "CA", "county" : "MARIN" },
            "94951": { "city" : "PENNGROVE", "state" : "CA", "county" : "SONOMA" },
            "94952": { "city" : "PETALUMA", "state" : "CA", "county" : "SONOMA" },
            "94953": { "city" : "PETALUMA", "state" : "CA", "county" : "SONOMA" },
            "94954": { "city" : "PETALUMA", "state" : "CA", "county" : "SONOMA" },
            "94955": { "city" : "PETALUMA", "state" : "CA", "county" : "SONOMA" },
            "94956": { "city" : "POINT REYES STATION", "state" : "CA", "county" : "MARIN" },
            "94957": { "city" : "ROSS", "state" : "CA", "county" : "MARIN" },"94960": { "city" : "SAN ANSELMO", "state" : "CA", "county" : "MARIN" },
            "94963": { "city" : "SAN GERONIMO", "state" : "CA", "county" : "MARIN" },
            "94964": { "city" : "SAN QUENTIN", "state" : "CA", "county" : "MARIN" },
            "94965": { "city" : "SAUSALITO", "state" : "CA", "county" : "MARIN" },
            "94966": { "city" : "SAUSALITO", "state" : "CA", "county" : "MARIN" },
            "94970": { "city" : "STINSON BEACH", "state" : "CA", "county" : "MARIN" },
            "94971": { "city" : "TOMALES", "state" : "CA", "county" : "MARIN" },"94972": { "city" : "VALLEY FORD", "state" : "CA", "county" : "SONOMA" },
            "94973": { "city" : "WOODACRE", "state" : "CA", "county" : "MARIN" },
            "94975": { "city" : "PETALUMA", "state" : "CA", "county" : "SONOMA" },
            "94976": { "city" : "CORTE MADERA", "state" : "CA", "county" : "MARIN" },
            "94977": { "city" : "LARKSPUR", "state" : "CA", "county" : "MARIN" },
            "94978": { "city" : "FAIRFAX", "state" : "CA", "county" : "MARIN" },"94979": { "city" : "SAN ANSELMO", "state" : "CA", "county" : "MARIN" },
            "94998": { "city" : "NOVATO", "state" : "CA", "county" : "MARIN" },"95001": { "city" : "APTOS", "state" : "CA", "county" : "SANTA CRUZ" },
            "95002": { "city" : "ALVISO", "state" : "CA", "county" : "SANTA CLARA" },
            "95003": { "city" : "APTOS", "state" : "CA", "county" : "SANTA CRUZ" },
            "95004": { "city" : "AROMAS", "state" : "CA", "county" : "MONTEREY" },
            "95005": { "city" : "BEN LOMOND", "state" : "CA", "county" : "SANTA CRUZ" },
            "95006": { "city" : "BOULDER CREEK", "state" : "CA", "county" : "SANTA CRUZ" },
            "95007": { "city" : "BROOKDALE", "state" : "CA", "county" : "SANTA CRUZ" },
            "95008": { "city" : "CAMPBELL", "state" : "CA", "county" : "SANTA CLARA" },
            "95009": { "city" : "CAMPBELL", "state" : "CA", "county" : "SANTA CLARA" },
            "95010": { "city" : "CAPITOLA", "state" : "CA", "county" : "SANTA CRUZ" },
            "95011": { "city" : "CAMPBELL", "state" : "CA", "county" : "SANTA CLARA" },
            "95012": { "city" : "CASTROVILLE", "state" : "CA", "county" : "MONTEREY" },
            "95013": { "city" : "COYOTE", "state" : "CA", "county" : "SANTA CLARA" },
            "95014": { "city" : "CUPERTINO", "state" : "CA", "county" : "SANTA CLARA" },
            "95015": { "city" : "CUPERTINO", "state" : "CA", "county" : "SANTA CLARA" },
            "95017": { "city" : "DAVENPORT", "state" : "CA", "county" : "SANTA CRUZ" },
            "95018": { "city" : "FELTON", "state" : "CA", "county" : "SANTA CRUZ" },
            "95019": { "city" : "FREEDOM", "state" : "CA", "county" : "SANTA CRUZ" },
            "95020": { "city" : "GILROY", "state" : "CA", "county" : "SANTA CLARA" },
            "95021": { "city" : "GILROY", "state" : "CA", "county" : "SANTA CLARA" },
            "95023": { "city" : "HOLLISTER", "state" : "CA", "county" : "SAN BENITO" },
            "95024": { "city" : "HOLLISTER", "state" : "CA", "county" : "SAN BENITO" },
            "95026": { "city" : "HOLY CITY", "state" : "CA", "county" : "SANTA CLARA" },
            "95030": { "city" : "LOS GATOS", "state" : "CA", "county" : "SANTA CLARA" },
            "95031": { "city" : "LOS GATOS", "state" : "CA", "county" : "SANTA CLARA" },
            "95032": { "city" : "LOS GATOS", "state" : "CA", "county" : "SANTA CLARA" },
            "95033": { "city" : "LOS GATOS", "state" : "CA", "county" : "SANTA CRUZ" },
            "95035": { "city" : "MILPITAS", "state" : "CA", "county" : "SANTA CLARA" },
            "95036": { "city" : "MILPITAS", "state" : "CA", "county" : "SANTA CLARA" },
            "95037": { "city" : "MORGAN HILL", "state" : "CA", "county" : "SANTA CLARA" },
            "95038": { "city" : "MORGAN HILL", "state" : "CA", "county" : "SANTA CLARA" },
            "95039": { "city" : "MOSS LANDING", "state" : "CA", "county" : "MONTEREY" },
            "95041": { "city" : "MOUNT HERMON", "state" : "CA", "county" : "SANTA CRUZ" },
            "95042": { "city" : "NEW ALMADEN", "state" : "CA", "county" : "SANTA CLARA" },
            "95043": { "city" : "PAICINES", "state" : "CA", "county" : "SAN BENITO" },
            "95044": { "city" : "REDWOOD ESTATES", "state" : "CA", "county" : "SANTA CLARA" },
            "95045": { "city" : "SAN JUAN BAUTISTA", "state" : "CA", "county" : "SAN BENITO" },
            "95046": { "city" : "SAN MARTIN", "state" : "CA", "county" : "SANTA CLARA" },
            "95050": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95051": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95052": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95053": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95054": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95055": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95056": { "city" : "SANTA CLARA", "state" : "CA", "county" : "SANTA CLARA" },
            "95060": { "city" : "SANTA CRUZ", "state" : "CA", "county" : "SANTA CRUZ" },
            "95061": { "city" : "SANTA CRUZ", "state" : "CA", "county" : "SANTA CRUZ" },
            "95062": { "city" : "SANTA CRUZ", "state" : "CA", "county" : "SANTA CRUZ" },
            "95063": { "city" : "SANTA CRUZ", "state" : "CA", "county" : "SANTA CRUZ" },
            "95064": { "city" : "SANTA CRUZ", "state" : "CA", "county" : "SANTA CRUZ" },
            "95065": { "city" : "SANTA CRUZ", "state" : "CA", "county" : "SANTA CRUZ" },
            "95066": { "city" : "SCOTTS VALLEY", "state" : "CA", "county" : "SANTA CRUZ" },
            "95067": { "city" : "SCOTTS VALLEY", "state" : "CA", "county" : "SANTA CRUZ" },
            "95070": { "city" : "SARATOGA", "state" : "CA", "county" : "SANTA CLARA" },
            "95071": { "city" : "SARATOGA", "state" : "CA", "county" : "SANTA CLARA" },
            "95073": { "city" : "SOQUEL", "state" : "CA", "county" : "SANTA CRUZ" },
            "95075": { "city" : "TRES PINOS", "state" : "CA", "county" : "SAN BENITO" },
            "95076": { "city" : "WATSONVILLE", "state" : "CA", "county" : "SANTA CRUZ" },
            "95077": { "city" : "WATSONVILLE", "state" : "CA", "county" : "SANTA CRUZ" },
            "95101": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95103": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95106": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95108": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95109": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95110": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95111": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95112": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95113": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95115": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95116": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95117": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95118": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95119": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95120": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95121": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95122": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95123": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95124": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95125": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95126": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95127": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95128": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95129": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95130": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95131": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95132": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95133": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95134": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95135": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95136": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95138": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95139": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95140": { "city" : "MOUNT HAMILTON", "state" : "CA", "county" : "SANTA CLARA" },
            "95141": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95148": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95150": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95151": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95152": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95153": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95154": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95155": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95156": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95157": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95158": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95159": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95160": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95161": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95164": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95170": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95173": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95190": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95191": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95192": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95193": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95196": { "city" : "SAN JOSE", "state" : "CA", "county" : "SANTA CLARA" },
            "95201": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95202": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95203": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95204": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95205": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95206": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95207": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95208": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95209": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95210": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95211": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95212": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95213": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95215": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95219": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95220": { "city" : "ACAMPO", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95221": { "city" : "ALTAVILLE", "state" : "CA", "county" : "CALAVERAS" },
            "95222": { "city" : "ANGELS CAMP", "state" : "CA", "county" : "CALAVERAS" },
            "95223": { "city" : "ARNOLD", "state" : "CA", "county" : "CALAVERAS" },
            "95224": { "city" : "AVERY", "state" : "CA", "county" : "CALAVERAS" },
            "95225": { "city" : "BURSON", "state" : "CA", "county" : "CALAVERAS" },
            "95226": { "city" : "CAMPO SECO", "state" : "CA", "county" : "CALAVERAS" },
            "95227": { "city" : "CLEMENTS", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95228": { "city" : "COPPEROPOLIS", "state" : "CA", "county" : "CALAVERAS" },
            "95229": { "city" : "DOUGLAS FLAT", "state" : "CA", "county" : "CALAVERAS" },
            "95230": { "city" : "FARMINGTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95231": { "city" : "FRENCH CAMP", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95233": { "city" : "HATHAWAY PINES", "state" : "CA", "county" : "CALAVERAS" },
            "95234": { "city" : "HOLT", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95236": { "city" : "LINDEN", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95237": { "city" : "LOCKEFORD", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95240": { "city" : "LODI", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95241": { "city" : "LODI", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95242": { "city" : "LODI", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95245": { "city" : "MOKELUMNE HILL", "state" : "CA", "county" : "CALAVERAS" },
            "95246": { "city" : "MOUNTAIN RANCH", "state" : "CA", "county" : "CALAVERAS" },
            "95247": { "city" : "MURPHYS", "state" : "CA", "county" : "CALAVERAS" },
            "95248": { "city" : "RAIL ROAD FLAT", "state" : "CA", "county" : "CALAVERAS" },
            "95249": { "city" : "SAN ANDREAS", "state" : "CA", "county" : "CALAVERAS" },
            "95250": { "city" : "SHEEP RANCH", "state" : "CA", "county" : "CALAVERAS" },
            "95251": { "city" : "VALLECITO", "state" : "CA", "county" : "CALAVERAS" },
            "95252": { "city" : "VALLEY SPRINGS", "state" : "CA", "county" : "CALAVERAS" },
            "95253": { "city" : "VICTOR", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95254": { "city" : "WALLACE", "state" : "CA", "county" : "CALAVERAS" },
            "95255": { "city" : "WEST POINT", "state" : "CA", "county" : "CALAVERAS" },
            "95257": { "city" : "WILSEYVILLE", "state" : "CA", "county" : "CALAVERAS" },
            "95258": { "city" : "WOODBRIDGE", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95267": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95269": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95296": { "city" : "STOCKTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95301": { "city" : "ATWATER", "state" : "CA", "county" : "MERCED" },
            "95303": { "city" : "BALLICO", "state" : "CA", "county" : "MERCED" },
            "95304": { "city" : "TRACY", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95305": { "city" : "BIG OAK FLAT", "state" : "CA", "county" : "TUOLUMNE" },
            "95306": { "city" : "CATHEYS VALLEY", "state" : "CA", "county" : "MARIPOSA" },
            "95307": { "city" : "CERES", "state" : "CA", "county" : "STANISLAUS" },
            "95309": { "city" : "CHINESE CAMP", "state" : "CA", "county" : "TUOLUMNE" },
            "95310": { "city" : "COLUMBIA", "state" : "CA", "county" : "TUOLUMNE" },
            "95311": { "city" : "COULTERVILLE", "state" : "CA", "county" : "MARIPOSA" },
            "95312": { "city" : "CRESSEY", "state" : "CA", "county" : "MERCED" },
            "95313": { "city" : "CROWS LANDING", "state" : "CA", "county" : "STANISLAUS" },
            "95314": { "city" : "DARDANELLE", "state" : "CA", "county" : "TUOLUMNE" },
            "95315": { "city" : "DELHI", "state" : "CA", "county" : "MERCED" },"95316": { "city" : "DENAIR", "state" : "CA", "county" : "STANISLAUS" },
            "95317": { "city" : "EL NIDO", "state" : "CA", "county" : "MERCED" },
            "95318": { "city" : "EL PORTAL", "state" : "CA", "county" : "MARIPOSA" },
            "95319": { "city" : "EMPIRE", "state" : "CA", "county" : "STANISLAUS" },
            "95320": { "city" : "ESCALON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95321": { "city" : "GROVELAND", "state" : "CA", "county" : "TUOLUMNE" },
            "95322": { "city" : "GUSTINE", "state" : "CA", "county" : "MERCED" },
            "95323": { "city" : "HICKMAN", "state" : "CA", "county" : "STANISLAUS" },
            "95324": { "city" : "HILMAR", "state" : "CA", "county" : "MERCED" },"95325": { "city" : "HORNITOS", "state" : "CA", "county" : "MARIPOSA" },
            "95326": { "city" : "HUGHSON", "state" : "CA", "county" : "STANISLAUS" },
            "95327": { "city" : "JAMESTOWN", "state" : "CA", "county" : "TUOLUMNE" },
            "95328": { "city" : "KEYES", "state" : "CA", "county" : "STANISLAUS" },
            "95329": { "city" : "LA GRANGE", "state" : "CA", "county" : "STANISLAUS" },
            "95330": { "city" : "LATHROP", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95333": { "city" : "LE GRAND", "state" : "CA", "county" : "MERCED" },
            "95334": { "city" : "LIVINGSTON", "state" : "CA", "county" : "MERCED" },
            "95335": { "city" : "LONG BARN", "state" : "CA", "county" : "TUOLUMNE" },
            "95336": { "city" : "MANTECA", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95337": { "city" : "MANTECA", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95338": { "city" : "MARIPOSA", "state" : "CA", "county" : "MARIPOSA" },
            "95340": { "city" : "MERCED", "state" : "CA", "county" : "MERCED" },"95341": { "city" : "MERCED", "state" : "CA", "county" : "MERCED" },
            "95344": { "city" : "MERCED", "state" : "CA", "county" : "MERCED" },"95345": { "city" : "MIDPINES", "state" : "CA", "county" : "MARIPOSA" },
            "95346": { "city" : "MI WUK VILLAGE", "state" : "CA", "county" : "TUOLUMNE" },
            "95348": { "city" : "MERCED", "state" : "CA", "county" : "MERCED" },"95350": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95351": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95352": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95353": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95354": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95355": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95356": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95357": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95358": { "city" : "MODESTO", "state" : "CA", "county" : "STANISLAUS" },
            "95360": { "city" : "NEWMAN", "state" : "CA", "county" : "STANISLAUS" },
            "95361": { "city" : "OAKDALE", "state" : "CA", "county" : "STANISLAUS" },
            "95363": { "city" : "PATTERSON", "state" : "CA", "county" : "STANISLAUS" },
            "95364": { "city" : "PINECREST", "state" : "CA", "county" : "TUOLUMNE" },
            "95365": { "city" : "PLANADA", "state" : "CA", "county" : "MERCED" },
            "95366": { "city" : "RIPON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95367": { "city" : "RIVERBANK", "state" : "CA", "county" : "STANISLAUS" },
            "95368": { "city" : "SALIDA", "state" : "CA", "county" : "STANISLAUS" },
            "95369": { "city" : "SNELLING", "state" : "CA", "county" : "MERCED" },
            "95370": { "city" : "SONORA", "state" : "CA", "county" : "TUOLUMNE" },
            "95372": { "city" : "SOULSBYVILLE", "state" : "CA", "county" : "TUOLUMNE" },
            "95373": { "city" : "STANDARD", "state" : "CA", "county" : "TUOLUMNE" },
            "95374": { "city" : "STEVINSON", "state" : "CA", "county" : "MERCED" },
            "95375": { "city" : "STRAWBERRY", "state" : "CA", "county" : "TUOLUMNE" },
            "95376": { "city" : "TRACY", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95377": { "city" : "TRACY", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95378": { "city" : "TRACY", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95379": { "city" : "TUOLUMNE", "state" : "CA", "county" : "TUOLUMNE" },
            "95380": { "city" : "TURLOCK", "state" : "CA", "county" : "STANISLAUS" },
            "95381": { "city" : "TURLOCK", "state" : "CA", "county" : "STANISLAUS" },
            "95382": { "city" : "TURLOCK", "state" : "CA", "county" : "STANISLAUS" },
            "95383": { "city" : "TWAIN HARTE", "state" : "CA", "county" : "TUOLUMNE" },
            "95385": { "city" : "VERNALIS", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95386": { "city" : "WATERFORD", "state" : "CA", "county" : "STANISLAUS" },
            "95387": { "city" : "WESTLEY", "state" : "CA", "county" : "STANISLAUS" },
            "95388": { "city" : "WINTON", "state" : "CA", "county" : "MERCED" },"95389": { "city" : "YOSEMITE NATIONAL PARK", "state" : "CA", "county" : "MARIPOSA" },
            "95391": { "city" : "TRACY", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95401": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95402": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95403": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95404": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95405": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95406": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95407": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95409": { "city" : "SANTA ROSA", "state" : "CA", "county" : "SONOMA" },
            "95410": { "city" : "ALBION", "state" : "CA", "county" : "MENDOCINO" },
            "95412": { "city" : "ANNAPOLIS", "state" : "CA", "county" : "SONOMA" },
            "95415": { "city" : "BOONVILLE", "state" : "CA", "county" : "MENDOCINO" },
            "95416": { "city" : "BOYES HOT SPRINGS", "state" : "CA", "county" : "SONOMA" },
            "95417": { "city" : "BRANSCOMB", "state" : "CA", "county" : "MENDOCINO" },
            "95418": { "city" : "CALPELLA", "state" : "CA", "county" : "MENDOCINO" },
            "95419": { "city" : "CAMP MEEKER", "state" : "CA", "county" : "SONOMA" },
            "95420": { "city" : "CASPAR", "state" : "CA", "county" : "MENDOCINO" },
            "95421": { "city" : "CAZADERO", "state" : "CA", "county" : "SONOMA" },
            "95422": { "city" : "CLEARLAKE", "state" : "CA", "county" : "LAKE" },
            "95423": { "city" : "CLEARLAKE OAKS", "state" : "CA", "county" : "LAKE" },
            "95424": { "city" : "CLEARLAKE PARK", "state" : "CA", "county" : "LAKE" },
            "95425": { "city" : "CLOVERDALE", "state" : "CA", "county" : "SONOMA" },
            "95426": { "city" : "COBB", "state" : "CA", "county" : "LAKE" },"95427": { "city" : "COMPTCHE", "state" : "CA", "county" : "MENDOCINO" },
            "95428": { "city" : "COVELO", "state" : "CA", "county" : "MENDOCINO" },
            "95429": { "city" : "DOS RIOS", "state" : "CA", "county" : "MENDOCINO" },
            "95430": { "city" : "DUNCANS MILLS", "state" : "CA", "county" : "SONOMA" },
            "95431": { "city" : "ELDRIDGE", "state" : "CA", "county" : "SONOMA" },
            "95432": { "city" : "ELK", "state" : "CA", "county" : "MENDOCINO" },"95433": { "city" : "EL VERANO", "state" : "CA", "county" : "SONOMA" },
            "95435": { "city" : "FINLEY", "state" : "CA", "county" : "LAKE" },"95436": { "city" : "FORESTVILLE", "state" : "CA", "county" : "SONOMA" },
            "95437": { "city" : "FORT BRAGG", "state" : "CA", "county" : "MENDOCINO" },
            "95439": { "city" : "FULTON", "state" : "CA", "county" : "SONOMA" },"95441": { "city" : "GEYSERVILLE", "state" : "CA", "county" : "SONOMA" },
            "95442": { "city" : "GLEN ELLEN", "state" : "CA", "county" : "SONOMA" },
            "95443": { "city" : "GLENHAVEN", "state" : "CA", "county" : "LAKE" },
            "95444": { "city" : "GRATON", "state" : "CA", "county" : "SONOMA" },"95445": { "city" : "GUALALA", "state" : "CA", "county" : "MENDOCINO" },
            "95446": { "city" : "GUERNEVILLE", "state" : "CA", "county" : "SONOMA" },
            "95448": { "city" : "HEALDSBURG", "state" : "CA", "county" : "SONOMA" },
            "95449": { "city" : "HOPLAND", "state" : "CA", "county" : "MENDOCINO" },
            "95450": { "city" : "JENNER", "state" : "CA", "county" : "SONOMA" },"95451": { "city" : "KELSEYVILLE", "state" : "CA", "county" : "LAKE" },
            "95452": { "city" : "KENWOOD", "state" : "CA", "county" : "SONOMA" },
            "95453": { "city" : "LAKEPORT", "state" : "CA", "county" : "LAKE" },"95454": { "city" : "LAYTONVILLE", "state" : "CA", "county" : "MENDOCINO" },
            "95456": { "city" : "LITTLE RIVER", "state" : "CA", "county" : "MENDOCINO" },
            "95457": { "city" : "LOWER LAKE", "state" : "CA", "county" : "LAKE" },
            "95458": { "city" : "LUCERNE", "state" : "CA", "county" : "LAKE" },"95459": { "city" : "MANCHESTER", "state" : "CA", "county" : "MENDOCINO" },
            "95460": { "city" : "MENDOCINO", "state" : "CA", "county" : "MENDOCINO" },
            "95461": { "city" : "MIDDLETOWN", "state" : "CA", "county" : "LAKE" },
            "95462": { "city" : "MONTE RIO", "state" : "CA", "county" : "SONOMA" },
            "95463": { "city" : "NAVARRO", "state" : "CA", "county" : "MENDOCINO" },
            "95464": { "city" : "NICE", "state" : "CA", "county" : "LAKE" },"95465": { "city" : "OCCIDENTAL", "state" : "CA", "county" : "SONOMA" },
            "95466": { "city" : "PHILO", "state" : "CA", "county" : "MENDOCINO" },
            "95467": { "city" : "HIDDEN VALLEY LAKE", "state" : "CA", "county" : "LAKE" },
            "95468": { "city" : "POINT ARENA", "state" : "CA", "county" : "MENDOCINO" },
            "95469": { "city" : "POTTER VALLEY", "state" : "CA", "county" : "MENDOCINO" },
            "95470": { "city" : "REDWOOD VALLEY", "state" : "CA", "county" : "MENDOCINO" },
            "95471": { "city" : "RIO NIDO", "state" : "CA", "county" : "SONOMA" },
            "95472": { "city" : "SEBASTOPOL", "state" : "CA", "county" : "SONOMA" },
            "95473": { "city" : "SEBASTOPOL", "state" : "CA", "county" : "SONOMA" },
            "95476": { "city" : "SONOMA", "state" : "CA", "county" : "SONOMA" },"95480": { "city" : "STEWARTS POINT", "state" : "CA", "county" : "SONOMA" },
            "95481": { "city" : "TALMAGE", "state" : "CA", "county" : "MENDOCINO" },
            "95482": { "city" : "UKIAH", "state" : "CA", "county" : "MENDOCINO" },
            "95485": { "city" : "UPPER LAKE", "state" : "CA", "county" : "LAKE" },
            "95486": { "city" : "VILLA GRANDE", "state" : "CA", "county" : "SONOMA" },
            "95487": { "city" : "VINEBURG", "state" : "CA", "county" : "SONOMA" },
            "95488": { "city" : "WESTPORT", "state" : "CA", "county" : "MENDOCINO" },
            "95490": { "city" : "WILLITS", "state" : "CA", "county" : "MENDOCINO" },
            "95492": { "city" : "WINDSOR", "state" : "CA", "county" : "SONOMA" },
            "95493": { "city" : "WITTER SPRINGS", "state" : "CA", "county" : "LAKE" },
            "95494": { "city" : "YORKVILLE", "state" : "CA", "county" : "MENDOCINO" },
            "95497": { "city" : "THE SEA RANCH", "state" : "CA", "county" : "SONOMA" },
            "95501": { "city" : "EUREKA", "state" : "CA", "county" : "HUMBOLDT" },
            "95502": { "city" : "EUREKA", "state" : "CA", "county" : "HUMBOLDT" },
            "95503": { "city" : "EUREKA", "state" : "CA", "county" : "HUMBOLDT" },
            "95511": { "city" : "ALDERPOINT", "state" : "CA", "county" : "HUMBOLDT" },
            "95518": { "city" : "ARCATA", "state" : "CA", "county" : "HUMBOLDT" },
            "95519": { "city" : "MCKINLEYVILLE", "state" : "CA", "county" : "HUMBOLDT" },
            "95521": { "city" : "ARCATA", "state" : "CA", "county" : "HUMBOLDT" },
            "95524": { "city" : "BAYSIDE", "state" : "CA", "county" : "HUMBOLDT" },
            "95525": { "city" : "BLUE LAKE", "state" : "CA", "county" : "HUMBOLDT" },
            "95526": { "city" : "BRIDGEVILLE", "state" : "CA", "county" : "HUMBOLDT" },
            "95527": { "city" : "BURNT RANCH", "state" : "CA", "county" : "TRINITY" },
            "95528": { "city" : "CARLOTTA", "state" : "CA", "county" : "HUMBOLDT" },
            "95531": { "city" : "CRESCENT CITY", "state" : "CA", "county" : "DEL NORTE" },
            "95532": { "city" : "CRESCENT CITY", "state" : "CA", "county" : "DEL NORTE" },
            "95534": { "city" : "CUTTEN", "state" : "CA", "county" : "HUMBOLDT" },
            "95536": { "city" : "FERNDALE", "state" : "CA", "county" : "HUMBOLDT" },
            "95537": { "city" : "FIELDS LANDING", "state" : "CA", "county" : "HUMBOLDT" },
            "95538": { "city" : "FORT DICK", "state" : "CA", "county" : "DEL NORTE" },
            "95540": { "city" : "FORTUNA", "state" : "CA", "county" : "HUMBOLDT" },
            "95542": { "city" : "GARBERVILLE", "state" : "CA", "county" : "HUMBOLDT" },
            "95543": { "city" : "GASQUET", "state" : "CA", "county" : "DEL NORTE" },
            "95545": { "city" : "HONEYDEW", "state" : "CA", "county" : "HUMBOLDT" },
            "95546": { "city" : "HOOPA", "state" : "CA", "county" : "HUMBOLDT" },
            "95547": { "city" : "HYDESVILLE", "state" : "CA", "county" : "HUMBOLDT" },
            "95548": { "city" : "KLAMATH", "state" : "CA", "county" : "DEL NORTE" },
            "95549": { "city" : "KNEELAND", "state" : "CA", "county" : "HUMBOLDT" },
            "95550": { "city" : "KORBEL", "state" : "CA", "county" : "HUMBOLDT" },
            "95551": { "city" : "LOLETA", "state" : "CA", "county" : "HUMBOLDT" },
            "95552": { "city" : "MAD RIVER", "state" : "CA", "county" : "TRINITY" },
            "95553": { "city" : "MIRANDA", "state" : "CA", "county" : "HUMBOLDT" },
            "95554": { "city" : "MYERS FLAT", "state" : "CA", "county" : "HUMBOLDT" },
            "95555": { "city" : "ORICK", "state" : "CA", "county" : "HUMBOLDT" },
            "95556": { "city" : "ORLEANS", "state" : "CA", "county" : "HUMBOLDT" },
            "95558": { "city" : "PETROLIA", "state" : "CA", "county" : "HUMBOLDT" },
            "95559": { "city" : "PHILLIPSVILLE", "state" : "CA", "county" : "HUMBOLDT" },
            "95560": { "city" : "REDWAY", "state" : "CA", "county" : "HUMBOLDT" },
            "95562": { "city" : "RIO DELL", "state" : "CA", "county" : "HUMBOLDT" },
            "95563": { "city" : "SALYER", "state" : "CA", "county" : "TRINITY" },
            "95564": { "city" : "SAMOA", "state" : "CA", "county" : "HUMBOLDT" },
            "95565": { "city" : "SCOTIA", "state" : "CA", "county" : "HUMBOLDT" },
            "95567": { "city" : "SMITH RIVER", "state" : "CA", "county" : "DEL NORTE" },
            "95568": { "city" : "SOMES BAR", "state" : "CA", "county" : "SISKIYOU" },
            "95569": { "city" : "REDCREST", "state" : "CA", "county" : "HUMBOLDT" },
            "95570": { "city" : "TRINIDAD", "state" : "CA", "county" : "HUMBOLDT" },
            "95571": { "city" : "WEOTT", "state" : "CA", "county" : "HUMBOLDT" },
            "95573": { "city" : "WILLOW CREEK", "state" : "CA", "county" : "HUMBOLDT" },
            "95585": { "city" : "LEGGETT", "state" : "CA", "county" : "MENDOCINO" },
            "95587": { "city" : "PIERCY", "state" : "CA", "county" : "MENDOCINO" },
            "95589": { "city" : "WHITETHORN", "state" : "CA", "county" : "HUMBOLDT" },
            "95601": { "city" : "AMADOR CITY", "state" : "CA", "county" : "AMADOR" },
            "95602": { "city" : "AUBURN", "state" : "CA", "county" : "PLACER" },"95603": { "city" : "AUBURN", "state" : "CA", "county" : "PLACER" },
            "95604": { "city" : "AUBURN", "state" : "CA", "county" : "PLACER" },"95605": { "city" : "WEST SACRAMENTO", "state" : "CA", "county" : "YOLO" },
            "95606": { "city" : "BROOKS", "state" : "CA", "county" : "YOLO" },"95607": { "city" : "CAPAY", "state" : "CA", "county" : "YOLO" },
            "95608": { "city" : "CARMICHAEL", "state" : "CA", "county" : "SACRAMENTO" },
            "95609": { "city" : "CARMICHAEL", "state" : "CA", "county" : "SACRAMENTO" },
            "95610": { "city" : "CITRUS HEIGHTS", "state" : "CA", "county" : "SACRAMENTO" },
            "95611": { "city" : "CITRUS HEIGHTS", "state" : "CA", "county" : "SACRAMENTO" },
            "95612": { "city" : "CLARKSBURG", "state" : "CA", "county" : "YOLO" },
            "95613": { "city" : "COLOMA", "state" : "CA", "county" : "EL DORADO" },
            "95614": { "city" : "COOL", "state" : "CA", "county" : "EL DORADO" },
            "95615": { "city" : "COURTLAND", "state" : "CA", "county" : "SACRAMENTO" },
            "95616": { "city" : "DAVIS", "state" : "CA", "county" : "YOLO" },"95617": { "city" : "DAVIS", "state" : "CA", "county" : "YOLO" },
            "95618": { "city" : "DAVIS", "state" : "CA", "county" : "YOLO" },"95619": { "city" : "DIAMOND SPRINGS", "state" : "CA", "county" : "EL DORADO" },
            "95620": { "city" : "DIXON", "state" : "CA", "county" : "SOLANO" },"95621": { "city" : "CITRUS HEIGHTS", "state" : "CA", "county" : "SACRAMENTO" },
            "95623": { "city" : "EL DORADO", "state" : "CA", "county" : "EL DORADO" },
            "95624": { "city" : "ELK GROVE", "state" : "CA", "county" : "SACRAMENTO" },
            "95625": { "city" : "ELMIRA", "state" : "CA", "county" : "SOLANO" },"95626": { "city" : "ELVERTA", "state" : "CA", "county" : "SACRAMENTO" },
            "95627": { "city" : "ESPARTO", "state" : "CA", "county" : "YOLO" },"95628": { "city" : "FAIR OAKS", "state" : "CA", "county" : "SACRAMENTO" },
            "95629": { "city" : "FIDDLETOWN", "state" : "CA", "county" : "AMADOR" },
            "95630": { "city" : "FOLSOM", "state" : "CA", "county" : "SACRAMENTO" },
            "95631": { "city" : "FORESTHILL", "state" : "CA", "county" : "PLACER" },
            "95632": { "city" : "GALT", "state" : "CA", "county" : "SACRAMENTO" },
            "95633": { "city" : "GARDEN VALLEY", "state" : "CA", "county" : "EL DORADO" },
            "95634": { "city" : "GEORGETOWN", "state" : "CA", "county" : "EL DORADO" },
            "95635": { "city" : "GREENWOOD", "state" : "CA", "county" : "EL DORADO" },
            "95636": { "city" : "GRIZZLY FLATS", "state" : "CA", "county" : "EL DORADO" },
            "95637": { "city" : "GUINDA", "state" : "CA", "county" : "YOLO" },"95638": { "city" : "HERALD", "state" : "CA", "county" : "SACRAMENTO" },
            "95639": { "city" : "HOOD", "state" : "CA", "county" : "SACRAMENTO" },
            "95640": { "city" : "IONE", "state" : "CA", "county" : "AMADOR" },"95641": { "city" : "ISLETON", "state" : "CA", "county" : "SACRAMENTO" },
            "95642": { "city" : "JACKSON", "state" : "CA", "county" : "AMADOR" },
            "95644": { "city" : "KIT CARSON", "state" : "CA", "county" : "AMADOR" },
            "95645": { "city" : "KNIGHTS LANDING", "state" : "CA", "county" : "YOLO" },
            "95646": { "city" : "KIRKWOOD", "state" : "CA", "county" : "ALPINE" },
            "95648": { "city" : "LINCOLN", "state" : "CA", "county" : "PLACER" },
            "95650": { "city" : "LOOMIS", "state" : "CA", "county" : "PLACER" },"95651": { "city" : "LOTUS", "state" : "CA", "county" : "EL DORADO" },
            "95652": { "city" : "MCCLELLAN", "state" : "CA", "county" : "SACRAMENTO" },
            "95653": { "city" : "MADISON", "state" : "CA", "county" : "YOLO" },"95654": { "city" : "MARTELL", "state" : "CA", "county" : "AMADOR" },
            "95655": { "city" : "MATHER", "state" : "CA", "county" : "SACRAMENTO" },
            "95656": { "city" : "MOUNT AUKUM", "state" : "CA", "county" : "EL DORADO" },
            "95658": { "city" : "NEWCASTLE", "state" : "CA", "county" : "PLACER" },
            "95659": { "city" : "NICOLAUS", "state" : "CA", "county" : "SUTTER" },
            "95660": { "city" : "NORTH HIGHLANDS", "state" : "CA", "county" : "SACRAMENTO" },
            "95661": { "city" : "ROSEVILLE", "state" : "CA", "county" : "PLACER" },
            "95662": { "city" : "ORANGEVALE", "state" : "CA", "county" : "SACRAMENTO" },
            "95663": { "city" : "PENRYN", "state" : "CA", "county" : "PLACER" },"95664": { "city" : "PILOT HILL", "state" : "CA", "county" : "EL DORADO" },
            "95665": { "city" : "PINE GROVE", "state" : "CA", "county" : "AMADOR" },
            "95666": { "city" : "PIONEER", "state" : "CA", "county" : "AMADOR" },
            "95667": { "city" : "PLACERVILLE", "state" : "CA", "county" : "EL DORADO" },
            "95668": { "city" : "PLEASANT GROVE", "state" : "CA", "county" : "SUTTER" },
            "95669": { "city" : "PLYMOUTH", "state" : "CA", "county" : "AMADOR" },
            "95670": { "city" : "RANCHO CORDOVA", "state" : "CA", "county" : "SACRAMENTO" },
            "95671": { "city" : "REPRESA", "state" : "CA", "county" : "SACRAMENTO" },
            "95672": { "city" : "RESCUE", "state" : "CA", "county" : "EL DORADO" },
            "95673": { "city" : "RIO LINDA", "state" : "CA", "county" : "SACRAMENTO" },
            "95674": { "city" : "RIO OSO", "state" : "CA", "county" : "SUTTER" },
            "95675": { "city" : "RIVER PINES", "state" : "CA", "county" : "AMADOR" },
            "95676": { "city" : "ROBBINS", "state" : "CA", "county" : "SUTTER" },
            "95677": { "city" : "ROCKLIN", "state" : "CA", "county" : "PLACER" },
            "95678": { "city" : "ROSEVILLE", "state" : "CA", "county" : "PLACER" },
            "95679": { "city" : "RUMSEY", "state" : "CA", "county" : "YOLO" },"95680": { "city" : "RYDE", "state" : "CA", "county" : "SACRAMENTO" },
            "95681": { "city" : "SHERIDAN", "state" : "CA", "county" : "PLACER" },
            "95682": { "city" : "SHINGLE SPRINGS", "state" : "CA", "county" : "EL DORADO" },
            "95683": { "city" : "SLOUGHHOUSE", "state" : "CA", "county" : "SACRAMENTO" },
            "95684": { "city" : "SOMERSET", "state" : "CA", "county" : "EL DORADO" },
            "95685": { "city" : "SUTTER CREEK", "state" : "CA", "county" : "AMADOR" },
            "95686": { "city" : "THORNTON", "state" : "CA", "county" : "SAN JOAQUIN" },
            "95687": { "city" : "VACAVILLE", "state" : "CA", "county" : "SOLANO" },
            "95688": { "city" : "VACAVILLE", "state" : "CA", "county" : "SOLANO" },
            "95689": { "city" : "VOLCANO", "state" : "CA", "county" : "AMADOR" },
            "95690": { "city" : "WALNUT GROVE", "state" : "CA", "county" : "SACRAMENTO" },
            "95691": { "city" : "WEST SACRAMENTO", "state" : "CA", "county" : "YOLO" },
            "95692": { "city" : "WHEATLAND", "state" : "CA", "county" : "YUBA" },
            "95693": { "city" : "WILTON", "state" : "CA", "county" : "SACRAMENTO" },
            "95694": { "city" : "WINTERS", "state" : "CA", "county" : "YOLO" },"95695": { "city" : "WOODLAND", "state" : "CA", "county" : "YOLO" },
            "95696": { "city" : "VACAVILLE", "state" : "CA", "county" : "SOLANO" },
            "95697": { "city" : "YOLO", "state" : "CA", "county" : "YOLO" },"95698": { "city" : "ZAMORA", "state" : "CA", "county" : "YOLO" },
            "95699": { "city" : "DRYTOWN", "state" : "CA", "county" : "AMADOR" },
            "95701": { "city" : "ALTA", "state" : "CA", "county" : "PLACER" },"95703": { "city" : "APPLEGATE", "state" : "CA", "county" : "PLACER" },
            "95709": { "city" : "CAMINO", "state" : "CA", "county" : "EL DORADO" },
            "95712": { "city" : "CHICAGO PARK", "state" : "CA", "county" : "NEVADA" },
            "95713": { "city" : "COLFAX", "state" : "CA", "county" : "PLACER" },"95714": { "city" : "DUTCH FLAT", "state" : "CA", "county" : "PLACER" },
            "95715": { "city" : "EMIGRANT GAP", "state" : "CA", "county" : "PLACER" },
            "95717": { "city" : "GOLD RUN", "state" : "CA", "county" : "PLACER" },
            "95720": { "city" : "KYBURZ", "state" : "CA", "county" : "EL DORADO" },
            "95721": { "city" : "ECHO LAKE", "state" : "CA", "county" : "EL DORADO" },
            "95722": { "city" : "MEADOW VISTA", "state" : "CA", "county" : "PLACER" },
            "95724": { "city" : "NORDEN", "state" : "CA", "county" : "NEVADA" },"95726": { "city" : "POLLOCK PINES", "state" : "CA", "county" : "EL DORADO" },
            "95728": { "city" : "SODA SPRINGS", "state" : "CA", "county" : "NEVADA" },
            "95735": { "city" : "TWIN BRIDGES", "state" : "CA", "county" : "EL DORADO" },
            "95736": { "city" : "WEIMAR", "state" : "CA", "county" : "PLACER" },"95741": { "city" : "RANCHO CORDOVA", "state" : "CA", "county" : "SACRAMENTO" },
            "95742": { "city" : "RANCHO CORDOVA", "state" : "CA", "county" : "SACRAMENTO" },
            "95746": { "city" : "GRANITE BAY", "state" : "CA", "county" : "PLACER" },
            "95747": { "city" : "ROSEVILLE", "state" : "CA", "county" : "PLACER" },
            "95757": { "city" : "ELK GROVE", "state" : "CA", "county" : "SACRAMENTO" },
            "95758": { "city" : "ELK GROVE", "state" : "CA", "county" : "SACRAMENTO" },
            "95759": { "city" : "ELK GROVE", "state" : "CA", "county" : "SACRAMENTO" },
            "95762": { "city" : "EL DORADO HILLS", "state" : "CA", "county" : "EL DORADO" },
            "95763": { "city" : "FOLSOM", "state" : "CA", "county" : "SACRAMENTO" },
            "95765": { "city" : "ROCKLIN", "state" : "CA", "county" : "PLACER" },
            "95776": { "city" : "WOODLAND", "state" : "CA", "county" : "YOLO" },"95798": { "city" : "WEST SACRAMENTO", "state" : "CA", "county" : "YOLO" },
            "95799": { "city" : "WEST SACRAMENTO", "state" : "CA", "county" : "YOLO" },
            "95811": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95812": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95813": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95814": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95815": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95816": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95817": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95818": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95819": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95820": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95821": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95822": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95823": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95824": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95825": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95826": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95827": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95828": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95829": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95830": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95831": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95832": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95833": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95834": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95835": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95836": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95837": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95838": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95840": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95841": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95842": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95843": { "city" : "ANTELOPE", "state" : "CA", "county" : "SACRAMENTO" },
            "95851": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95852": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95853": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95860": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95864": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95865": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95866": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95867": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95899": { "city" : "SACRAMENTO", "state" : "CA", "county" : "SACRAMENTO" },
            "95901": { "city" : "MARYSVILLE", "state" : "CA", "county" : "YUBA" },
            "95903": { "city" : "BEALE AFB", "state" : "CA", "county" : "YUBA" },
            "95910": { "city" : "ALLEGHANY", "state" : "CA", "county" : "SIERRA" },
            "95912": { "city" : "ARBUCKLE", "state" : "CA", "county" : "COLUSA" },
            "95913": { "city" : "ARTOIS", "state" : "CA", "county" : "GLENN" },"95914": { "city" : "BANGOR", "state" : "CA", "county" : "BUTTE" },
            "95915": { "city" : "BELDEN", "state" : "CA", "county" : "PLUMAS" },"95916": { "city" : "BERRY CREEK", "state" : "CA", "county" : "BUTTE" },
            "95917": { "city" : "BIGGS", "state" : "CA", "county" : "BUTTE" },"95918": { "city" : "BROWNS VALLEY", "state" : "CA", "county" : "YUBA" },
            "95919": { "city" : "BROWNSVILLE", "state" : "CA", "county" : "YUBA" },
            "95920": { "city" : "BUTTE CITY", "state" : "CA", "county" : "GLENN" },
            "95922": { "city" : "CAMPTONVILLE", "state" : "CA", "county" : "YUBA" },
            "95923": { "city" : "CANYON DAM", "state" : "CA", "county" : "PLUMAS" },
            "95924": { "city" : "CEDAR RIDGE", "state" : "CA", "county" : "NEVADA" },
            "95925": { "city" : "CHALLENGE", "state" : "CA", "county" : "YUBA" },
            "95926": { "city" : "CHICO", "state" : "CA", "county" : "BUTTE" },"95927": { "city" : "CHICO", "state" : "CA", "county" : "BUTTE" },
            "95928": { "city" : "CHICO", "state" : "CA", "county" : "BUTTE" },"95929": { "city" : "CHICO", "state" : "CA", "county" : "BUTTE" },
            "95930": { "city" : "CLIPPER MILLS", "state" : "CA", "county" : "BUTTE" },
            "95932": { "city" : "COLUSA", "state" : "CA", "county" : "COLUSA" },"95934": { "city" : "CRESCENT MILLS", "state" : "CA", "county" : "PLUMAS" },
            "95935": { "city" : "DOBBINS", "state" : "CA", "county" : "YUBA" },"95936": { "city" : "DOWNIEVILLE", "state" : "CA", "county" : "SIERRA" },
            "95937": { "city" : "DUNNIGAN", "state" : "CA", "county" : "YOLO" },"95938": { "city" : "DURHAM", "state" : "CA", "county" : "BUTTE" },
            "95939": { "city" : "ELK CREEK", "state" : "CA", "county" : "GLENN" },
            "95940": { "city" : "FEATHER FALLS", "state" : "CA", "county" : "BUTTE" },
            "95941": { "city" : "FORBESTOWN", "state" : "CA", "county" : "BUTTE" },
            "95942": { "city" : "FOREST RANCH", "state" : "CA", "county" : "BUTTE" },
            "95943": { "city" : "GLENN", "state" : "CA", "county" : "GLENN" },"95944": { "city" : "GOODYEARS BAR", "state" : "CA", "county" : "SIERRA" },
            "95945": { "city" : "GRASS VALLEY", "state" : "CA", "county" : "NEVADA" },
            "95946": { "city" : "PENN VALLEY", "state" : "CA", "county" : "NEVADA" },
            "95947": { "city" : "GREENVILLE", "state" : "CA", "county" : "PLUMAS" },
            "95948": { "city" : "GRIDLEY", "state" : "CA", "county" : "BUTTE" },"95949": { "city" : "GRASS VALLEY", "state" : "CA", "county" : "NEVADA" },
            "95950": { "city" : "GRIMES", "state" : "CA", "county" : "COLUSA" },"95951": { "city" : "HAMILTON CITY", "state" : "CA", "county" : "GLENN" },
            "95953": { "city" : "LIVE OAK", "state" : "CA", "county" : "SUTTER" },
            "95954": { "city" : "MAGALIA", "state" : "CA", "county" : "BUTTE" },"95955": { "city" : "MAXWELL", "state" : "CA", "county" : "COLUSA" },
            "95956": { "city" : "MEADOW VALLEY", "state" : "CA", "county" : "PLUMAS" },
            "95957": { "city" : "MERIDIAN", "state" : "CA", "county" : "SUTTER" },
            "95958": { "city" : "NELSON", "state" : "CA", "county" : "BUTTE" },"95959": { "city" : "NEVADA CITY", "state" : "CA", "county" : "NEVADA" },
            "95960": { "city" : "NORTH SAN JUAN", "state" : "CA", "county" : "NEVADA" },
            "95961": { "city" : "OLIVEHURST", "state" : "CA", "county" : "YUBA" },
            "95962": { "city" : "OREGON HOUSE", "state" : "CA", "county" : "YUBA" },
            "95963": { "city" : "ORLAND", "state" : "CA", "county" : "GLENN" },"95965": { "city" : "OROVILLE", "state" : "CA", "county" : "BUTTE" },
            "95966": { "city" : "OROVILLE", "state" : "CA", "county" : "BUTTE" },
            "95967": { "city" : "PARADISE", "state" : "CA", "county" : "BUTTE" },
            "95968": { "city" : "PALERMO", "state" : "CA", "county" : "BUTTE" },"95969": { "city" : "PARADISE", "state" : "CA", "county" : "BUTTE" },
            "95970": { "city" : "PRINCETON", "state" : "CA", "county" : "COLUSA" },
            "95971": { "city" : "QUINCY", "state" : "CA", "county" : "PLUMAS" },"95972": { "city" : "RACKERBY", "state" : "CA", "county" : "YUBA" },
            "95973": { "city" : "CHICO", "state" : "CA", "county" : "BUTTE" },"95974": { "city" : "RICHVALE", "state" : "CA", "county" : "BUTTE" },
            "95975": { "city" : "ROUGH AND READY", "state" : "CA", "county" : "NEVADA" },
            "95977": { "city" : "SMARTSVILLE", "state" : "CA", "county" : "NEVADA" },
            "95978": { "city" : "STIRLING CITY", "state" : "CA", "county" : "BUTTE" },
            "95979": { "city" : "STONYFORD", "state" : "CA", "county" : "COLUSA" },
            "95981": { "city" : "STRAWBERRY VALLEY", "state" : "CA", "county" : "YUBA" },
            "95982": { "city" : "SUTTER", "state" : "CA", "county" : "SUTTER" },"95983": { "city" : "TAYLORSVILLE", "state" : "CA", "county" : "PLUMAS" },
            "95984": { "city" : "TWAIN", "state" : "CA", "county" : "PLUMAS" },"95986": { "city" : "WASHINGTON", "state" : "CA", "county" : "NEVADA" },
            "95987": { "city" : "WILLIAMS", "state" : "CA", "county" : "COLUSA" },
            "95988": { "city" : "WILLOWS", "state" : "CA", "county" : "GLENN" },"95991": { "city" : "YUBA CITY", "state" : "CA", "county" : "SUTTER" },
            "95992": { "city" : "YUBA CITY", "state" : "CA", "county" : "SUTTER" },
            "95993": { "city" : "YUBA CITY", "state" : "CA", "county" : "SUTTER" },
            "96001": { "city" : "REDDING", "state" : "CA", "county" : "SHASTA" },
            "96002": { "city" : "REDDING", "state" : "CA", "county" : "SHASTA" },
            "96003": { "city" : "REDDING", "state" : "CA", "county" : "SHASTA" },
            "96006": { "city" : "ADIN", "state" : "CA", "county" : "MODOC" },"96007": { "city" : "ANDERSON", "state" : "CA", "county" : "SHASTA" },
            "96008": { "city" : "BELLA VISTA", "state" : "CA", "county" : "SHASTA" },
            "96009": { "city" : "BIEBER", "state" : "CA", "county" : "LASSEN" },"96010": { "city" : "BIG BAR", "state" : "CA", "county" : "TRINITY" },
            "96011": { "city" : "BIG BEND", "state" : "CA", "county" : "SHASTA" },
            "96013": { "city" : "BURNEY", "state" : "CA", "county" : "SHASTA" },"96014": { "city" : "CALLAHAN", "state" : "CA", "county" : "SISKIYOU" },
            "96015": { "city" : "CANBY", "state" : "CA", "county" : "MODOC" },"96016": { "city" : "CASSEL", "state" : "CA", "county" : "SHASTA" },
            "96017": { "city" : "CASTELLA", "state" : "CA", "county" : "SHASTA" },
            "96019": { "city" : "SHASTA LAKE", "state" : "CA", "county" : "SHASTA" },
            "96020": { "city" : "CHESTER", "state" : "CA", "county" : "PLUMAS" },
            "96021": { "city" : "CORNING", "state" : "CA", "county" : "TEHAMA" },
            "96022": { "city" : "COTTONWOOD", "state" : "CA", "county" : "SHASTA" },
            "96023": { "city" : "DORRIS", "state" : "CA", "county" : "SISKIYOU" },
            "96024": { "city" : "DOUGLAS CITY", "state" : "CA", "county" : "TRINITY" },
            "96025": { "city" : "DUNSMUIR", "state" : "CA", "county" : "SISKIYOU" },
            "96027": { "city" : "ETNA", "state" : "CA", "county" : "SISKIYOU" },"96028": { "city" : "FALL RIVER MILLS", "state" : "CA", "county" : "SHASTA" },
            "96029": { "city" : "FLOURNOY", "state" : "CA", "county" : "TEHAMA" },
            "96031": { "city" : "FORKS OF SALMON", "state" : "CA", "county" : "SISKIYOU" },
            "96032": { "city" : "FORT JONES", "state" : "CA", "county" : "SISKIYOU" },
            "96033": { "city" : "FRENCH GULCH", "state" : "CA", "county" : "SHASTA" },
            "96034": { "city" : "GAZELLE", "state" : "CA", "county" : "SISKIYOU" },
            "96035": { "city" : "GERBER", "state" : "CA", "county" : "TEHAMA" },"96037": { "city" : "GREENVIEW", "state" : "CA", "county" : "SISKIYOU" },
            "96038": { "city" : "GRENADA", "state" : "CA", "county" : "SISKIYOU" },
            "96039": { "city" : "HAPPY CAMP", "state" : "CA", "county" : "SISKIYOU" },
            "96040": { "city" : "HAT CREEK", "state" : "CA", "county" : "SHASTA" },
            "96041": { "city" : "HAYFORK", "state" : "CA", "county" : "TRINITY" },
            "96044": { "city" : "HORNBROOK", "state" : "CA", "county" : "SISKIYOU" },
            "96046": { "city" : "HYAMPOM", "state" : "CA", "county" : "TRINITY" },
            "96047": { "city" : "IGO", "state" : "CA", "county" : "SHASTA" },"96048": { "city" : "JUNCTION CITY", "state" : "CA", "county" : "TRINITY" },
            "96049": { "city" : "REDDING", "state" : "CA", "county" : "SHASTA" },
            "96050": { "city" : "KLAMATH RIVER", "state" : "CA", "county" : "SISKIYOU" },
            "96051": { "city" : "LAKEHEAD", "state" : "CA", "county" : "SHASTA" },
            "96052": { "city" : "LEWISTON", "state" : "CA", "county" : "TRINITY" },
            "96054": { "city" : "LOOKOUT", "state" : "CA", "county" : "MODOC" },"96055": { "city" : "LOS MOLINOS", "state" : "CA", "county" : "TEHAMA" },
            "96056": { "city" : "MCARTHUR", "state" : "CA", "county" : "LASSEN" },
            "96057": { "city" : "MCCLOUD", "state" : "CA", "county" : "SISKIYOU" },
            "96058": { "city" : "MACDOEL", "state" : "CA", "county" : "SISKIYOU" },
            "96059": { "city" : "MANTON", "state" : "CA", "county" : "TEHAMA" },"96061": { "city" : "MILL CREEK", "state" : "CA", "county" : "TEHAMA" },
            "96062": { "city" : "MILLVILLE", "state" : "CA", "county" : "SHASTA" },
            "96063": { "city" : "MINERAL", "state" : "CA", "county" : "TEHAMA" },
            "96064": { "city" : "MONTAGUE", "state" : "CA", "county" : "SISKIYOU" },
            "96065": { "city" : "MONTGOMERY CREEK", "state" : "CA", "county" : "SHASTA" },
            "96067": { "city" : "MOUNT SHASTA", "state" : "CA", "county" : "SISKIYOU" },
            "96068": { "city" : "NUBIEBER", "state" : "CA", "county" : "LASSEN" },
            "96069": { "city" : "OAK RUN", "state" : "CA", "county" : "SHASTA" },
            "96070": { "city" : "OBRIEN", "state" : "CA", "county" : "SHASTA" },"96071": { "city" : "OLD STATION", "state" : "CA", "county" : "SHASTA" },
            "96073": { "city" : "PALO CEDRO", "state" : "CA", "county" : "SHASTA" },
            "96074": { "city" : "PASKENTA", "state" : "CA", "county" : "TEHAMA" },
            "96076": { "city" : "PLATINA", "state" : "CA", "county" : "SHASTA" },
            "96078": { "city" : "PROBERTA", "state" : "CA", "county" : "TEHAMA" },
            "96079": { "city" : "SHASTA LAKE", "state" : "CA", "county" : "SHASTA" },
            "96080": { "city" : "RED BLUFF", "state" : "CA", "county" : "TEHAMA" },
            "96084": { "city" : "ROUND MOUNTAIN", "state" : "CA", "county" : "SHASTA" },
            "96086": { "city" : "SEIAD VALLEY", "state" : "CA", "county" : "SISKIYOU" },
            "96087": { "city" : "SHASTA", "state" : "CA", "county" : "SHASTA" },"96088": { "city" : "SHINGLETOWN", "state" : "CA", "county" : "SHASTA" },
            "96089": { "city" : "SHASTA LAKE", "state" : "CA", "county" : "SHASTA" },
            "96090": { "city" : "TEHAMA", "state" : "CA", "county" : "TEHAMA" },"96091": { "city" : "TRINITY CENTER", "state" : "CA", "county" : "TRINITY" },
            "96092": { "city" : "VINA", "state" : "CA", "county" : "TEHAMA" },"96093": { "city" : "WEAVERVILLE", "state" : "CA", "county" : "TRINITY" },
            "96094": { "city" : "WEED", "state" : "CA", "county" : "SISKIYOU" },"96095": { "city" : "WHISKEYTOWN", "state" : "CA", "county" : "SHASTA" },
            "96096": { "city" : "WHITMORE", "state" : "CA", "county" : "SHASTA" },
            "96097": { "city" : "YREKA", "state" : "CA", "county" : "SISKIYOU" },
            "96099": { "city" : "REDDING", "state" : "CA", "county" : "SHASTA" },
            "96101": { "city" : "ALTURAS", "state" : "CA", "county" : "MODOC" },"96103": { "city" : "BLAIRSDEN-GRAEAGLE", "state" : "CA", "county" : "PLUMAS" },
            "96104": { "city" : "CEDARVILLE", "state" : "CA", "county" : "MODOC" },
            "96105": { "city" : "CHILCOOT", "state" : "CA", "county" : "PLUMAS" },
            "96106": { "city" : "CLIO", "state" : "CA", "county" : "PLUMAS" },"96107": { "city" : "COLEVILLE", "state" : "CA", "county" : "MONO" },
            "96108": { "city" : "DAVIS CREEK", "state" : "CA", "county" : "MODOC" },
            "96109": { "city" : "DOYLE", "state" : "CA", "county" : "LASSEN" },"96110": { "city" : "EAGLEVILLE", "state" : "CA", "county" : "MODOC" },
            "96111": { "city" : "FLORISTON", "state" : "CA", "county" : "NEVADA" },
            "96112": { "city" : "FORT BIDWELL", "state" : "CA", "county" : "MODOC" },
            "96113": { "city" : "HERLONG", "state" : "CA", "county" : "LASSEN" },
            "96114": { "city" : "JANESVILLE", "state" : "CA", "county" : "LASSEN" },
            "96115": { "city" : "LAKE CITY", "state" : "CA", "county" : "MODOC" },
            "96116": { "city" : "LIKELY", "state" : "CA", "county" : "MODOC" },"96117": { "city" : "LITCHFIELD", "state" : "CA", "county" : "LASSEN" },
            "96118": { "city" : "LOYALTON", "state" : "CA", "county" : "SIERRA" },
            "96119": { "city" : "MADELINE", "state" : "CA", "county" : "LASSEN" },
            "96120": { "city" : "MARKLEEVILLE", "state" : "CA", "county" : "ALPINE" },
            "96121": { "city" : "MILFORD", "state" : "CA", "county" : "LASSEN" },
            "96122": { "city" : "PORTOLA", "state" : "CA", "county" : "PLUMAS" },
            "96123": { "city" : "RAVENDALE", "state" : "CA", "county" : "LASSEN" },
            "96124": { "city" : "CALPINE", "state" : "CA", "county" : "SIERRA" },
            "96125": { "city" : "SIERRA CITY", "state" : "CA", "county" : "SIERRA" },
            "96126": { "city" : "SIERRAVILLE", "state" : "CA", "county" : "SIERRA" },
            "96127": { "city" : "SUSANVILLE", "state" : "CA", "county" : "LASSEN" },
            "96128": { "city" : "STANDISH", "state" : "CA", "county" : "LASSEN" },
            "96129": { "city" : "BECKWOURTH", "state" : "CA", "county" : "PLUMAS" },
            "96130": { "city" : "SUSANVILLE", "state" : "CA", "county" : "LASSEN" },
            "96132": { "city" : "TERMO", "state" : "CA", "county" : "LASSEN" },"96133": { "city" : "TOPAZ", "state" : "CA", "county" : "MONO" },
            "96134": { "city" : "TULELAKE", "state" : "CA", "county" : "SISKIYOU" },
            "96135": { "city" : "VINTON", "state" : "CA", "county" : "PLUMAS" },"96136": { "city" : "WENDEL", "state" : "CA", "county" : "LASSEN" },
            "96137": { "city" : "WESTWOOD", "state" : "CA", "county" : "LASSEN" },
            "96140": { "city" : "CARNELIAN BAY", "state" : "CA", "county" : "PLACER" },
            "96141": { "city" : "HOMEWOOD", "state" : "CA", "county" : "PLACER" },
            "96142": { "city" : "TAHOMA", "state" : "CA", "county" : "EL DORADO" },
            "96143": { "city" : "KINGS BEACH", "state" : "CA", "county" : "PLACER" },
            "96145": { "city" : "TAHOE CITY", "state" : "CA", "county" : "PLACER" },
            "96146": { "city" : "OLYMPIC VALLEY", "state" : "CA", "county" : "PLACER" },
            "96148": { "city" : "TAHOE VISTA", "state" : "CA", "county" : "PLACER" },
            "96150": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96151": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96152": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96154": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96155": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96156": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96157": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96158": { "city" : "SOUTH LAKE TAHOE", "state" : "CA", "county" : "EL DORADO" },
            "96160": { "city" : "TRUCKEE", "state" : "CA", "county" : "NEVADA" },
            "96161": { "city" : "TRUCKEE", "state" : "CA", "county" : "NEVADA" },
            "96162": { "city" : "TRUCKEE", "state" : "CA", "county" : "NEVADA" },
            "96701": { "city" : "AIEA", "state" : "HI", "county" : "HONOLULU" },"96703": { "city" : "ANAHOLA", "state" : "HI", "county" : "KAUAI" },
            "96704": { "city" : "CAPTAIN COOK", "state" : "HI", "county" : "HAWAII" },
            "96705": { "city" : "ELEELE", "state" : "HI", "county" : "KAUAI" },"96706": { "city" : "EWA BEACH", "state" : "HI", "county" : "HONOLULU" },
            "96707": { "city" : "KAPOLEI", "state" : "HI", "county" : "HONOLULU" },
            "96708": { "city" : "HAIKU", "state" : "HI", "county" : "MAUI" },"96709": { "city" : "KAPOLEI", "state" : "HI", "county" : "HONOLULU" },
            "96710": { "city" : "HAKALAU", "state" : "HI", "county" : "HAWAII" },
            "96712": { "city" : "HALEIWA", "state" : "HI", "county" : "HONOLULU" },
            "96713": { "city" : "HANA", "state" : "HI", "county" : "MAUI" },"96714": { "city" : "HANALEI", "state" : "HI", "county" : "KAUAI" },
            "96715": { "city" : "HANAMAULU", "state" : "HI", "county" : "KAUAI" },
            "96716": { "city" : "HANAPEPE", "state" : "HI", "county" : "KAUAI" },
            "96717": { "city" : "HAUULA", "state" : "HI", "county" : "HONOLULU" },
            "96718": { "city" : "HAWAII NATIONAL PARK", "state" : "HI", "county" : "HAWAII" },
            "96719": { "city" : "HAWI", "state" : "HI", "county" : "HAWAII" },"96720": { "city" : "HILO", "state" : "HI", "county" : "HAWAII" },
            "96721": { "city" : "HILO", "state" : "HI", "county" : "HAWAII" },"96722": { "city" : "PRINCEVILLE", "state" : "HI", "county" : "KAUAI" },
            "96725": { "city" : "HOLUALOA", "state" : "HI", "county" : "HAWAII" },
            "96726": { "city" : "HONAUNAU", "state" : "HI", "county" : "HAWAII" },
            "96727": { "city" : "HONOKAA", "state" : "HI", "county" : "HAWAII" },
            "96728": { "city" : "HONOMU", "state" : "HI", "county" : "HAWAII" },"96729": { "city" : "HOOLEHUA", "state" : "HI", "county" : "MAUI" },
            "96730": { "city" : "KAAAWA", "state" : "HI", "county" : "HONOLULU" },
            "96731": { "city" : "KAHUKU", "state" : "HI", "county" : "HONOLULU" },
            "96732": { "city" : "KAHULUI", "state" : "HI", "county" : "MAUI" },"96733": { "city" : "KAHULUI", "state" : "HI", "county" : "MAUI" },
            "96734": { "city" : "KAILUA", "state" : "HI", "county" : "HONOLULU" },
            "96737": { "city" : "OCEAN VIEW", "state" : "HI", "county" : "HAWAII" },
            "96738": { "city" : "WAIKOLOA", "state" : "HI", "county" : "HAWAII" },
            "96739": { "city" : "KEAUHOU", "state" : "HI", "county" : "HAWAII" },
            "96740": { "city" : "KAILUA KONA", "state" : "HI", "county" : "HAWAII" },
            "96741": { "city" : "KALAHEO", "state" : "HI", "county" : "KAUAI" },"96742": { "city" : "KALAUPAPA", "state" : "HI", "county" : "MAUI" },
            "96743": { "city" : "KAMUELA", "state" : "HI", "county" : "HAWAII" },
            "96744": { "city" : "KANEOHE", "state" : "HI", "county" : "HONOLULU" },
            "96745": { "city" : "KAILUA KONA", "state" : "HI", "county" : "HAWAII" },
            "96746": { "city" : "KAPAA", "state" : "HI", "county" : "KAUAI" },"96747": { "city" : "KAUMAKANI", "state" : "HI", "county" : "KAUAI" },
            "96748": { "city" : "KAUNAKAKAI", "state" : "HI", "county" : "MAUI" },
            "96749": { "city" : "KEAAU", "state" : "HI", "county" : "HAWAII" },"96750": { "city" : "KEALAKEKUA", "state" : "HI", "county" : "HAWAII" },
            "96751": { "city" : "KEALIA", "state" : "HI", "county" : "KAUAI" },"96752": { "city" : "KEKAHA", "state" : "HI", "county" : "KAUAI" },
            "96753": { "city" : "KIHEI", "state" : "HI", "county" : "MAUI" },"96754": { "city" : "KILAUEA", "state" : "HI", "county" : "KAUAI" },
            "96755": { "city" : "KAPAAU", "state" : "HI", "county" : "HAWAII" },"96756": { "city" : "KOLOA", "state" : "HI", "county" : "KAUAI" },
            "96757": { "city" : "KUALAPUU", "state" : "HI", "county" : "MAUI" },"96759": { "city" : "KUNIA", "state" : "HI", "county" : "HONOLULU" },
            "96760": { "city" : "KURTISTOWN", "state" : "HI", "county" : "HAWAII" },
            "96761": { "city" : "LAHAINA", "state" : "HI", "county" : "MAUI" },"96762": { "city" : "LAIE", "state" : "HI", "county" : "HONOLULU" },
            "96763": { "city" : "LANAI CITY", "state" : "HI", "county" : "MAUI" },
            "96764": { "city" : "LAUPAHOEHOE", "state" : "HI", "county" : "HAWAII" },
            "96765": { "city" : "LAWAI", "state" : "HI", "county" : "KAUAI" },"96766": { "city" : "LIHUE", "state" : "HI", "county" : "KAUAI" },
            "96767": { "city" : "LAHAINA", "state" : "HI", "county" : "MAUI" },"96768": { "city" : "MAKAWAO", "state" : "HI", "county" : "MAUI" },
            "96769": { "city" : "MAKAWELI", "state" : "HI", "county" : "KAUAI" },
            "96770": { "city" : "MAUNALOA", "state" : "HI", "county" : "MAUI" },"96771": { "city" : "MOUNTAIN VIEW", "state" : "HI", "county" : "HAWAII" },
            "96772": { "city" : "NAALEHU", "state" : "HI", "county" : "HAWAII" },
            "96773": { "city" : "NINOLE", "state" : "HI", "county" : "HAWAII" },"96774": { "city" : "OOKALA", "state" : "HI", "county" : "HAWAII" },
            "96776": { "city" : "PAAUILO", "state" : "HI", "county" : "HAWAII" },
            "96777": { "city" : "PAHALA", "state" : "HI", "county" : "HAWAII" },"96778": { "city" : "PAHOA", "state" : "HI", "county" : "HAWAII" },
            "96779": { "city" : "PAIA", "state" : "HI", "county" : "MAUI" },"96780": { "city" : "PAPAALOA", "state" : "HI", "county" : "HAWAII" },
            "96781": { "city" : "PAPAIKOU", "state" : "HI", "county" : "HAWAII" },
            "96782": { "city" : "PEARL CITY", "state" : "HI", "county" : "HONOLULU" },
            "96783": { "city" : "PEPEEKEO", "state" : "HI", "county" : "HAWAII" },
            "96784": { "city" : "PUUNENE", "state" : "HI", "county" : "MAUI" },"96785": { "city" : "VOLCANO", "state" : "HI", "county" : "HAWAII" },
            "96786": { "city" : "WAHIAWA", "state" : "HI", "county" : "HONOLULU" },
            "96788": { "city" : "PUKALANI", "state" : "HI", "county" : "MAUI" },"96789": { "city" : "MILILANI", "state" : "HI", "county" : "HONOLULU" },
            "96790": { "city" : "KULA", "state" : "HI", "county" : "MAUI" },"96791": { "city" : "WAIALUA", "state" : "HI", "county" : "HONOLULU" },
            "96792": { "city" : "WAIANAE", "state" : "HI", "county" : "HONOLULU" },
            "96793": { "city" : "WAILUKU", "state" : "HI", "county" : "MAUI" },"96795": { "city" : "WAIMANALO", "state" : "HI", "county" : "HONOLULU" },
            "96796": { "city" : "WAIMEA", "state" : "HI", "county" : "KAUAI" },"96797": { "city" : "WAIPAHU", "state" : "HI", "county" : "HONOLULU" },
            "96801": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96802": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96803": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96804": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96805": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96806": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96807": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96808": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96809": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96810": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96811": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96812": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96813": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96814": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96815": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96816": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96817": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96818": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96819": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96820": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96821": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96822": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96823": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96824": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96825": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96826": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96827": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96828": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96830": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96836": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96837": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96838": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96839": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96840": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96844": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96848": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96849": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96850": { "city" : "HONOLULU", "state" : "HI", "county" : "HONOLULU" },
            "96853": { "city" : "HICKAM AFB", "state" : "HI", "county" : "HONOLULU" },
            "96854": { "city" : "WHEELER ARMY AIRFIELD", "state" : "HI", "county" : "HONOLULU" },
            "96857": { "city" : "SCHOFIELD BARRACKS", "state" : "HI", "county" : "HONOLULU" },
            "96858": { "city" : "FORT SHAFTER", "state" : "HI", "county" : "HONOLULU" },
            "96859": { "city" : "TRIPLER ARMY MEDICAL CENTER", "state" : "HI", "county" : "HONOLULU" },
            "96860": { "city" : "PEARL HARBOR", "state" : "HI", "county" : "HONOLULU" },
            "96861": { "city" : "CAMP H M SMITH", "state" : "HI", "county" : "HONOLULU" },
            "96863": { "city" : "M C B H KANEOHE BAY", "state" : "HI", "county" : "HONOLULU" },
            "97001": { "city" : "ANTELOPE", "state" : "OR", "county" : "WASCO" },
            "97002": { "city" : "AURORA", "state" : "OR", "county" : "MARION" },"97004": { "city" : "BEAVERCREEK", "state" : "OR", "county" : "CLACKAMAS" },
            "97005": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97006": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97007": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97008": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97009": { "city" : "BORING", "state" : "OR", "county" : "CLACKAMAS" },
            "97010": { "city" : "BRIDAL VEIL", "state" : "OR", "county" : "MULTNOMAH" },
            "97011": { "city" : "BRIGHTWOOD", "state" : "OR", "county" : "CLACKAMAS" },
            "97013": { "city" : "CANBY", "state" : "OR", "county" : "CLACKAMAS" },
            "97014": { "city" : "CASCADE LOCKS", "state" : "OR", "county" : "HOOD RIVER" },
            "97015": { "city" : "CLACKAMAS", "state" : "OR", "county" : "CLACKAMAS" },
            "97016": { "city" : "CLATSKANIE", "state" : "OR", "county" : "COLUMBIA" },
            "97017": { "city" : "COLTON", "state" : "OR", "county" : "CLACKAMAS" },
            "97018": { "city" : "COLUMBIA CITY", "state" : "OR", "county" : "COLUMBIA" },
            "97019": { "city" : "CORBETT", "state" : "OR", "county" : "MULTNOMAH" },
            "97020": { "city" : "DONALD", "state" : "OR", "county" : "MARION" },"97021": { "city" : "DUFUR", "state" : "OR", "county" : "WASCO" },
            "97022": { "city" : "EAGLE CREEK", "state" : "OR", "county" : "CLACKAMAS" },
            "97023": { "city" : "ESTACADA", "state" : "OR", "county" : "CLACKAMAS" },
            "97024": { "city" : "FAIRVIEW", "state" : "OR", "county" : "MULTNOMAH" },
            "97026": { "city" : "GERVAIS", "state" : "OR", "county" : "MARION" },
            "97027": { "city" : "GLADSTONE", "state" : "OR", "county" : "CLACKAMAS" },
            "97028": { "city" : "GOVERNMENT CAMP", "state" : "OR", "county" : "CLACKAMAS" },
            "97029": { "city" : "GRASS VALLEY", "state" : "OR", "county" : "SHERMAN" },
            "97030": { "city" : "GRESHAM", "state" : "OR", "county" : "MULTNOMAH" },
            "97031": { "city" : "HOOD RIVER", "state" : "OR", "county" : "HOOD RIVER" },
            "97032": { "city" : "HUBBARD", "state" : "OR", "county" : "MARION" },
            "97033": { "city" : "KENT", "state" : "OR", "county" : "SHERMAN" },"97034": { "city" : "LAKE OSWEGO", "state" : "OR", "county" : "CLACKAMAS" },
            "97035": { "city" : "LAKE OSWEGO", "state" : "OR", "county" : "CLACKAMAS" },
            "97036": { "city" : "MARYLHURST", "state" : "OR", "county" : "CLACKAMAS" },
            "97037": { "city" : "MAUPIN", "state" : "OR", "county" : "WASCO" },"97038": { "city" : "MOLALLA", "state" : "OR", "county" : "CLACKAMAS" },
            "97039": { "city" : "MORO", "state" : "OR", "county" : "SHERMAN" },"97040": { "city" : "MOSIER", "state" : "OR", "county" : "WASCO" },
            "97041": { "city" : "MOUNT HOOD PARKDALE", "state" : "OR", "county" : "HOOD RIVER" },
            "97042": { "city" : "MULINO", "state" : "OR", "county" : "CLACKAMAS" },
            "97044": { "city" : "ODELL", "state" : "OR", "county" : "HOOD RIVER" },
            "97045": { "city" : "OREGON CITY", "state" : "OR", "county" : "CLACKAMAS" },
            "97048": { "city" : "RAINIER", "state" : "OR", "county" : "COLUMBIA" },
            "97049": { "city" : "RHODODENDRON", "state" : "OR", "county" : "CLACKAMAS" },
            "97050": { "city" : "RUFUS", "state" : "OR", "county" : "SHERMAN" },"97051": { "city" : "SAINT HELENS", "state" : "OR", "county" : "COLUMBIA" },
            "97053": { "city" : "WARREN", "state" : "OR", "county" : "COLUMBIA" },
            "97054": { "city" : "DEER ISLAND", "state" : "OR", "county" : "COLUMBIA" },
            "97055": { "city" : "SANDY", "state" : "OR", "county" : "CLACKAMAS" },
            "97056": { "city" : "SCAPPOOSE", "state" : "OR", "county" : "COLUMBIA" },
            "97057": { "city" : "SHANIKO", "state" : "OR", "county" : "WASCO" },"97058": { "city" : "THE DALLES", "state" : "OR", "county" : "WASCO" },
            "97060": { "city" : "TROUTDALE", "state" : "OR", "county" : "MULTNOMAH" },
            "97062": { "city" : "TUALATIN", "state" : "OR", "county" : "WASHINGTON" },
            "97063": { "city" : "TYGH VALLEY", "state" : "OR", "county" : "WASCO" },
            "97064": { "city" : "VERNONIA", "state" : "OR", "county" : "COLUMBIA" },
            "97065": { "city" : "WASCO", "state" : "OR", "county" : "SHERMAN" },"97067": { "city" : "WELCHES", "state" : "OR", "county" : "CLACKAMAS" },
            "97068": { "city" : "WEST LINN", "state" : "OR", "county" : "CLACKAMAS" },
            "97070": { "city" : "WILSONVILLE", "state" : "OR", "county" : "CLACKAMAS" },
            "97071": { "city" : "WOODBURN", "state" : "OR", "county" : "MARION" },
            "97075": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97076": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97077": { "city" : "BEAVERTON", "state" : "OR", "county" : "WASHINGTON" },
            "97080": { "city" : "GRESHAM", "state" : "OR", "county" : "MULTNOMAH" },
            "97086": { "city" : "HAPPY VALLEY", "state" : "OR", "county" : "CLACKAMAS" },
            "97089": { "city" : "DAMASCUS", "state" : "OR", "county" : "CLACKAMAS" },
            "97101": { "city" : "AMITY", "state" : "OR", "county" : "YAMHILL" },"97102": { "city" : "ARCH CAPE", "state" : "OR", "county" : "CLATSOP" },
            "97103": { "city" : "ASTORIA", "state" : "OR", "county" : "CLATSOP" },
            "97106": { "city" : "BANKS", "state" : "OR", "county" : "WASHINGTON" },
            "97107": { "city" : "BAY CITY", "state" : "OR", "county" : "TILLAMOOK" },
            "97108": { "city" : "BEAVER", "state" : "OR", "county" : "TILLAMOOK" },
            "97109": { "city" : "BUXTON", "state" : "OR", "county" : "WASHINGTON" },
            "97110": { "city" : "CANNON BEACH", "state" : "OR", "county" : "CLATSOP" },
            "97111": { "city" : "CARLTON", "state" : "OR", "county" : "YAMHILL" },
            "97112": { "city" : "CLOVERDALE", "state" : "OR", "county" : "TILLAMOOK" },
            "97113": { "city" : "CORNELIUS", "state" : "OR", "county" : "WASHINGTON" },
            "97114": { "city" : "DAYTON", "state" : "OR", "county" : "YAMHILL" },
            "97115": { "city" : "DUNDEE", "state" : "OR", "county" : "YAMHILL" },
            "97116": { "city" : "FOREST GROVE", "state" : "OR", "county" : "WASHINGTON" },
            "97117": { "city" : "GALES CREEK", "state" : "OR", "county" : "WASHINGTON" },
            "97118": { "city" : "GARIBALDI", "state" : "OR", "county" : "TILLAMOOK" },
            "97119": { "city" : "GASTON", "state" : "OR", "county" : "WASHINGTON" },
            "97121": { "city" : "HAMMOND", "state" : "OR", "county" : "CLATSOP" },
            "97122": { "city" : "HEBO", "state" : "OR", "county" : "TILLAMOOK" },
            "97123": { "city" : "HILLSBORO", "state" : "OR", "county" : "WASHINGTON" },
            "97124": { "city" : "HILLSBORO", "state" : "OR", "county" : "WASHINGTON" },
            "97125": { "city" : "MANNING", "state" : "OR", "county" : "WASHINGTON" },
            "97127": { "city" : "LAFAYETTE", "state" : "OR", "county" : "YAMHILL" },
            "97128": { "city" : "MCMINNVILLE", "state" : "OR", "county" : "YAMHILL" },
            "97130": { "city" : "MANZANITA", "state" : "OR", "county" : "TILLAMOOK" },
            "97131": { "city" : "NEHALEM", "state" : "OR", "county" : "TILLAMOOK" },
            "97132": { "city" : "NEWBERG", "state" : "OR", "county" : "YAMHILL" },
            "97133": { "city" : "NORTH PLAINS", "state" : "OR", "county" : "WASHINGTON" },
            "97134": { "city" : "OCEANSIDE", "state" : "OR", "county" : "TILLAMOOK" },
            "97135": { "city" : "PACIFIC CITY", "state" : "OR", "county" : "TILLAMOOK" },
            "97136": { "city" : "ROCKAWAY BEACH", "state" : "OR", "county" : "TILLAMOOK" },
            "97137": { "city" : "SAINT PAUL", "state" : "OR", "county" : "MARION" },
            "97138": { "city" : "SEASIDE", "state" : "OR", "county" : "CLATSOP" },
            "97140": { "city" : "SHERWOOD", "state" : "OR", "county" : "WASHINGTON" },
            "97141": { "city" : "TILLAMOOK", "state" : "OR", "county" : "TILLAMOOK" },
            "97143": { "city" : "NETARTS", "state" : "OR", "county" : "TILLAMOOK" },
            "97144": { "city" : "TIMBER", "state" : "OR", "county" : "WASHINGTON" },
            "97145": { "city" : "TOLOVANA PARK", "state" : "OR", "county" : "CLATSOP" },
            "97146": { "city" : "WARRENTON", "state" : "OR", "county" : "CLATSOP" },
            "97147": { "city" : "WHEELER", "state" : "OR", "county" : "TILLAMOOK" },
            "97148": { "city" : "YAMHILL", "state" : "OR", "county" : "YAMHILL" },
            "97149": { "city" : "NESKOWIN", "state" : "OR", "county" : "TILLAMOOK" },
            "97201": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97202": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97203": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97204": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97205": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97206": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97207": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97208": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97209": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97210": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97211": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97212": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97213": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97214": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97215": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97216": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97217": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97218": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97219": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97220": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97221": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97222": { "city" : "PORTLAND", "state" : "OR", "county" : "CLACKAMAS" },
            "97223": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97224": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97225": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97227": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97228": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97229": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97230": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97231": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97232": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97233": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97236": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97238": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97239": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97240": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97242": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97256": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97258": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97266": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97267": { "city" : "PORTLAND", "state" : "OR", "county" : "CLACKAMAS" },
            "97268": { "city" : "PORTLAND", "state" : "OR", "county" : "CLACKAMAS" },
            "97269": { "city" : "PORTLAND", "state" : "OR", "county" : "CLACKAMAS" },
            "97280": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97281": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97282": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97283": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97286": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97290": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97291": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97292": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97293": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97294": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97296": { "city" : "PORTLAND", "state" : "OR", "county" : "MULTNOMAH" },
            "97298": { "city" : "PORTLAND", "state" : "OR", "county" : "WASHINGTON" },
            "97301": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },"97302": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },
            "97303": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },"97304": { "city" : "SALEM", "state" : "OR", "county" : "POLK" },
            "97305": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },"97306": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },
            "97307": { "city" : "KEIZER", "state" : "OR", "county" : "MARION" },"97308": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },
            "97309": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },"97310": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },
            "97311": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },"97312": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },
            "97314": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },"97317": { "city" : "SALEM", "state" : "OR", "county" : "MARION" },
            "97321": { "city" : "ALBANY", "state" : "OR", "county" : "LINN" },"97322": { "city" : "ALBANY", "state" : "OR", "county" : "LINN" },
            "97324": { "city" : "ALSEA", "state" : "OR", "county" : "BENTON" },"97325": { "city" : "AUMSVILLE", "state" : "OR", "county" : "MARION" },
            "97326": { "city" : "BLODGETT", "state" : "OR", "county" : "BENTON" },
            "97327": { "city" : "BROWNSVILLE", "state" : "OR", "county" : "LINN" },
            "97329": { "city" : "CASCADIA", "state" : "OR", "county" : "LINN" },"97330": { "city" : "CORVALLIS", "state" : "OR", "county" : "BENTON" },
            "97331": { "city" : "CORVALLIS", "state" : "OR", "county" : "BENTON" },
            "97333": { "city" : "CORVALLIS", "state" : "OR", "county" : "BENTON" },
            "97335": { "city" : "CRABTREE", "state" : "OR", "county" : "LINN" },"97336": { "city" : "CRAWFORDSVILLE", "state" : "OR", "county" : "LINN" },
            "97338": { "city" : "DALLAS", "state" : "OR", "county" : "POLK" },"97339": { "city" : "CORVALLIS", "state" : "OR", "county" : "BENTON" },
            "97341": { "city" : "DEPOE BAY", "state" : "OR", "county" : "LINCOLN" },
            "97342": { "city" : "DETROIT", "state" : "OR", "county" : "MARION" },
            "97343": { "city" : "EDDYVILLE", "state" : "OR", "county" : "LINCOLN" },
            "97344": { "city" : "FALLS CITY", "state" : "OR", "county" : "POLK" },
            "97345": { "city" : "FOSTER", "state" : "OR", "county" : "LINN" },"97346": { "city" : "GATES", "state" : "OR", "county" : "MARION" },
            "97347": { "city" : "GRAND RONDE", "state" : "OR", "county" : "POLK" },
            "97348": { "city" : "HALSEY", "state" : "OR", "county" : "LINN" },"97350": { "city" : "IDANHA", "state" : "OR", "county" : "MARION" },
            "97351": { "city" : "INDEPENDENCE", "state" : "OR", "county" : "POLK" },
            "97352": { "city" : "JEFFERSON", "state" : "OR", "county" : "MARION" },
            "97355": { "city" : "LEBANON", "state" : "OR", "county" : "LINN" },"97357": { "city" : "LOGSDEN", "state" : "OR", "county" : "LINCOLN" },
            "97358": { "city" : "LYONS", "state" : "OR", "county" : "LINN" },"97360": { "city" : "MILL CITY", "state" : "OR", "county" : "LINN" },
            "97361": { "city" : "MONMOUTH", "state" : "OR", "county" : "POLK" },"97362": { "city" : "MOUNT ANGEL", "state" : "OR", "county" : "MARION" },
            "97364": { "city" : "NEOTSU", "state" : "OR", "county" : "LINCOLN" },
            "97365": { "city" : "NEWPORT", "state" : "OR", "county" : "LINCOLN" },
            "97366": { "city" : "SOUTH BEACH", "state" : "OR", "county" : "LINCOLN" },
            "97367": { "city" : "LINCOLN CITY", "state" : "OR", "county" : "LINCOLN" },
            "97368": { "city" : "OTIS", "state" : "OR", "county" : "LINCOLN" },"97369": { "city" : "OTTER ROCK", "state" : "OR", "county" : "LINCOLN" },
            "97370": { "city" : "PHILOMATH", "state" : "OR", "county" : "BENTON" },
            "97371": { "city" : "RICKREALL", "state" : "OR", "county" : "POLK" },
            "97373": { "city" : "SAINT BENEDICT", "state" : "OR", "county" : "MARION" },
            "97374": { "city" : "SCIO", "state" : "OR", "county" : "LINN" },"97375": { "city" : "SCOTTS MILLS", "state" : "OR", "county" : "MARION" },
            "97376": { "city" : "SEAL ROCK", "state" : "OR", "county" : "LINCOLN" },
            "97377": { "city" : "SHEDD", "state" : "OR", "county" : "LINN" },"97378": { "city" : "SHERIDAN", "state" : "OR", "county" : "YAMHILL" },
            "97380": { "city" : "SILETZ", "state" : "OR", "county" : "LINCOLN" },
            "97381": { "city" : "SILVERTON", "state" : "OR", "county" : "MARION" },
            "97383": { "city" : "STAYTON", "state" : "OR", "county" : "MARION" },
            "97384": { "city" : "MEHAMA", "state" : "OR", "county" : "MARION" },"97385": { "city" : "SUBLIMITY", "state" : "OR", "county" : "MARION" },
            "97386": { "city" : "SWEET HOME", "state" : "OR", "county" : "LINN" },
            "97388": { "city" : "GLENEDEN BEACH", "state" : "OR", "county" : "LINCOLN" },
            "97389": { "city" : "TANGENT", "state" : "OR", "county" : "LINN" },"97390": { "city" : "TIDEWATER", "state" : "OR", "county" : "LINCOLN" },
            "97391": { "city" : "TOLEDO", "state" : "OR", "county" : "LINCOLN" },
            "97392": { "city" : "TURNER", "state" : "OR", "county" : "MARION" },"97394": { "city" : "WALDPORT", "state" : "OR", "county" : "LINCOLN" },
            "97396": { "city" : "WILLAMINA", "state" : "OR", "county" : "YAMHILL" },
            "97401": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },"97402": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },
            "97403": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },"97404": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },
            "97405": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },"97406": { "city" : "AGNESS", "state" : "OR", "county" : "CURRY" },
            "97407": { "city" : "ALLEGANY", "state" : "OR", "county" : "COOS" },"97408": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },
            "97409": { "city" : "ALVADORE", "state" : "OR", "county" : "LANE" },"97410": { "city" : "AZALEA", "state" : "OR", "county" : "DOUGLAS" },
            "97411": { "city" : "BANDON", "state" : "OR", "county" : "COOS" },"97412": { "city" : "BLACHLY", "state" : "OR", "county" : "LANE" },
            "97413": { "city" : "BLUE RIVER", "state" : "OR", "county" : "LANE" },
            "97414": { "city" : "BROADBENT", "state" : "OR", "county" : "COOS" },
            "97415": { "city" : "BROOKINGS", "state" : "OR", "county" : "CURRY" },
            "97416": { "city" : "CAMAS VALLEY", "state" : "OR", "county" : "DOUGLAS" },
            "97417": { "city" : "CANYONVILLE", "state" : "OR", "county" : "DOUGLAS" },
            "97419": { "city" : "CHESHIRE", "state" : "OR", "county" : "LANE" },"97420": { "city" : "COOS BAY", "state" : "OR", "county" : "COOS" },
            "97423": { "city" : "COQUILLE", "state" : "OR", "county" : "COOS" },"97424": { "city" : "COTTAGE GROVE", "state" : "OR", "county" : "LANE" },
            "97426": { "city" : "CRESWELL", "state" : "OR", "county" : "LANE" },"97427": { "city" : "CULP CREEK", "state" : "OR", "county" : "LANE" },
            "97429": { "city" : "DAYS CREEK", "state" : "OR", "county" : "DOUGLAS" },
            "97430": { "city" : "DEADWOOD", "state" : "OR", "county" : "LANE" },"97431": { "city" : "DEXTER", "state" : "OR", "county" : "LANE" },
            "97432": { "city" : "DILLARD", "state" : "OR", "county" : "DOUGLAS" },
            "97434": { "city" : "DORENA", "state" : "OR", "county" : "LANE" },"97435": { "city" : "DRAIN", "state" : "OR", "county" : "DOUGLAS" },
            "97436": { "city" : "ELKTON", "state" : "OR", "county" : "DOUGLAS" },
            "97437": { "city" : "ELMIRA", "state" : "OR", "county" : "LANE" },"97438": { "city" : "FALL CREEK", "state" : "OR", "county" : "LANE" },
            "97439": { "city" : "FLORENCE", "state" : "OR", "county" : "LANE" },"97440": { "city" : "EUGENE", "state" : "OR", "county" : "LANE" },
            "97441": { "city" : "GARDINER", "state" : "OR", "county" : "DOUGLAS" },
            "97442": { "city" : "GLENDALE", "state" : "OR", "county" : "DOUGLAS" },
            "97443": { "city" : "GLIDE", "state" : "OR", "county" : "DOUGLAS" },"97444": { "city" : "GOLD BEACH", "state" : "OR", "county" : "CURRY" },
            "97446": { "city" : "HARRISBURG", "state" : "OR", "county" : "LINN" },
            "97447": { "city" : "IDLEYLD PARK", "state" : "OR", "county" : "DOUGLAS" },
            "97448": { "city" : "JUNCTION CITY", "state" : "OR", "county" : "LANE" },
            "97449": { "city" : "LAKESIDE", "state" : "OR", "county" : "COOS" },"97450": { "city" : "LANGLOIS", "state" : "OR", "county" : "CURRY" },
            "97451": { "city" : "LORANE", "state" : "OR", "county" : "LANE" },"97452": { "city" : "LOWELL", "state" : "OR", "county" : "LANE" },
            "97453": { "city" : "MAPLETON", "state" : "OR", "county" : "LANE" },"97454": { "city" : "MARCOLA", "state" : "OR", "county" : "LANE" },
            "97455": { "city" : "PLEASANT HILL", "state" : "OR", "county" : "LANE" },
            "97456": { "city" : "MONROE", "state" : "OR", "county" : "BENTON" },"97457": { "city" : "MYRTLE CREEK", "state" : "OR", "county" : "DOUGLAS" },
            "97458": { "city" : "MYRTLE POINT", "state" : "OR", "county" : "COOS" },
            "97459": { "city" : "NORTH BEND", "state" : "OR", "county" : "COOS" },
            "97461": { "city" : "NOTI", "state" : "OR", "county" : "LANE" },"97462": { "city" : "OAKLAND", "state" : "OR", "county" : "DOUGLAS" },
            "97463": { "city" : "OAKRIDGE", "state" : "OR", "county" : "LANE" },"97464": { "city" : "OPHIR", "state" : "OR", "county" : "CURRY" },
            "97465": { "city" : "PORT ORFORD", "state" : "OR", "county" : "CURRY" },
            "97466": { "city" : "POWERS", "state" : "OR", "county" : "COOS" },"97467": { "city" : "REEDSPORT", "state" : "OR", "county" : "DOUGLAS" },
            "97469": { "city" : "RIDDLE", "state" : "OR", "county" : "DOUGLAS" },
            "97470": { "city" : "ROSEBURG", "state" : "OR", "county" : "DOUGLAS" },
            "97471": { "city" : "ROSEBURG", "state" : "OR", "county" : "DOUGLAS" },
            "97473": { "city" : "SCOTTSBURG", "state" : "OR", "county" : "DOUGLAS" },
            "97475": { "city" : "SPRINGFIELD", "state" : "OR", "county" : "LANE" },
            "97476": { "city" : "SIXES", "state" : "OR", "county" : "CURRY" },"97477": { "city" : "SPRINGFIELD", "state" : "OR", "county" : "LANE" },
            "97478": { "city" : "SPRINGFIELD", "state" : "OR", "county" : "LANE" },
            "97479": { "city" : "SUTHERLIN", "state" : "OR", "county" : "DOUGLAS" },
            "97480": { "city" : "SWISSHOME", "state" : "OR", "county" : "LANE" },
            "97481": { "city" : "TENMILE", "state" : "OR", "county" : "DOUGLAS" },
            "97484": { "city" : "TILLER", "state" : "OR", "county" : "DOUGLAS" },
            "97486": { "city" : "UMPQUA", "state" : "OR", "county" : "DOUGLAS" },
            "97487": { "city" : "VENETA", "state" : "OR", "county" : "LANE" },"97488": { "city" : "VIDA", "state" : "OR", "county" : "LANE" },
            "97489": { "city" : "WALTERVILLE", "state" : "OR", "county" : "LANE" },
            "97490": { "city" : "WALTON", "state" : "OR", "county" : "LANE" },"97491": { "city" : "WEDDERBURN", "state" : "OR", "county" : "CURRY" },
            "97492": { "city" : "WESTFIR", "state" : "OR", "county" : "LANE" },"97493": { "city" : "WESTLAKE", "state" : "OR", "county" : "LANE" },
            "97494": { "city" : "WILBUR", "state" : "OR", "county" : "DOUGLAS" },
            "97495": { "city" : "WINCHESTER", "state" : "OR", "county" : "DOUGLAS" },
            "97496": { "city" : "WINSTON", "state" : "OR", "county" : "DOUGLAS" },
            "97497": { "city" : "WOLF CREEK", "state" : "OR", "county" : "JOSEPHINE" },
            "97498": { "city" : "YACHATS", "state" : "OR", "county" : "LINCOLN" },
            "97499": { "city" : "YONCALLA", "state" : "OR", "county" : "DOUGLAS" },
            "97501": { "city" : "MEDFORD", "state" : "OR", "county" : "JACKSON" },
            "97502": { "city" : "CENTRAL POINT", "state" : "OR", "county" : "JACKSON" },
            "97503": { "city" : "WHITE CITY", "state" : "OR", "county" : "JACKSON" },
            "97504": { "city" : "MEDFORD", "state" : "OR", "county" : "JACKSON" },
            "97520": { "city" : "ASHLAND", "state" : "OR", "county" : "JACKSON" },
            "97522": { "city" : "BUTTE FALLS", "state" : "OR", "county" : "JACKSON" },
            "97523": { "city" : "CAVE JUNCTION", "state" : "OR", "county" : "JOSEPHINE" },
            "97524": { "city" : "EAGLE POINT", "state" : "OR", "county" : "JACKSON" },
            "97525": { "city" : "GOLD HILL", "state" : "OR", "county" : "JACKSON" },
            "97526": { "city" : "GRANTS PASS", "state" : "OR", "county" : "JOSEPHINE" },
            "97527": { "city" : "GRANTS PASS", "state" : "OR", "county" : "JOSEPHINE" },
            "97528": { "city" : "GRANTS PASS", "state" : "OR", "county" : "JOSEPHINE" },
            "97530": { "city" : "JACKSONVILLE", "state" : "OR", "county" : "JACKSON" },
            "97531": { "city" : "KERBY", "state" : "OR", "county" : "JOSEPHINE" },
            "97532": { "city" : "MERLIN", "state" : "OR", "county" : "JOSEPHINE" },
            "97533": { "city" : "MURPHY", "state" : "OR", "county" : "JOSEPHINE" },
            "97534": { "city" : "O BRIEN", "state" : "OR", "county" : "JOSEPHINE" },
            "97535": { "city" : "PHOENIX", "state" : "OR", "county" : "JACKSON" },
            "97536": { "city" : "PROSPECT", "state" : "OR", "county" : "JACKSON" },
            "97537": { "city" : "ROGUE RIVER", "state" : "OR", "county" : "JACKSON" },
            "97538": { "city" : "SELMA", "state" : "OR", "county" : "JOSEPHINE" },
            "97539": { "city" : "SHADY COVE", "state" : "OR", "county" : "JACKSON" },
            "97540": { "city" : "TALENT", "state" : "OR", "county" : "JACKSON" },
            "97541": { "city" : "TRAIL", "state" : "OR", "county" : "JACKSON" },"97543": { "city" : "WILDERVILLE", "state" : "OR", "county" : "JOSEPHINE" },
            "97544": { "city" : "WILLIAMS", "state" : "OR", "county" : "JOSEPHINE" },
            "97601": { "city" : "KLAMATH FALLS", "state" : "OR", "county" : "KLAMATH" },
            "97602": { "city" : "KLAMATH FALLS", "state" : "OR", "county" : "KLAMATH" },
            "97603": { "city" : "KLAMATH FALLS", "state" : "OR", "county" : "KLAMATH" },
            "97604": { "city" : "CRATER LAKE", "state" : "OR", "county" : "KLAMATH" },
            "97621": { "city" : "BEATTY", "state" : "OR", "county" : "KLAMATH" },
            "97622": { "city" : "BLY", "state" : "OR", "county" : "KLAMATH" },"97623": { "city" : "BONANZA", "state" : "OR", "county" : "KLAMATH" },
            "97624": { "city" : "CHILOQUIN", "state" : "OR", "county" : "KLAMATH" },
            "97625": { "city" : "DAIRY", "state" : "OR", "county" : "KLAMATH" },"97626": { "city" : "FORT KLAMATH", "state" : "OR", "county" : "KLAMATH" },
            "97627": { "city" : "KENO", "state" : "OR", "county" : "KLAMATH" },"97630": { "city" : "LAKEVIEW", "state" : "OR", "county" : "LAKE" },
            "97632": { "city" : "MALIN", "state" : "OR", "county" : "KLAMATH" },"97633": { "city" : "MERRILL", "state" : "OR", "county" : "KLAMATH" },
            "97635": { "city" : "NEW PINE CREEK", "state" : "OR", "county" : "LAKE" },
            "97636": { "city" : "PAISLEY", "state" : "OR", "county" : "LAKE" },"97637": { "city" : "PLUSH", "state" : "OR", "county" : "LAKE" },
            "97638": { "city" : "SILVER LAKE", "state" : "OR", "county" : "LAKE" },
            "97639": { "city" : "SPRAGUE RIVER", "state" : "OR", "county" : "KLAMATH" },
            "97640": { "city" : "SUMMER LAKE", "state" : "OR", "county" : "LAKE" },
            "97641": { "city" : "CHRISTMAS VALLEY", "state" : "OR", "county" : "LAKE" },
            "97701": { "city" : "BEND", "state" : "OR", "county" : "DESCHUTES" },
            "97702": { "city" : "BEND", "state" : "OR", "county" : "DESCHUTES" },
            "97707": { "city" : "BEND", "state" : "OR", "county" : "DESCHUTES" },
            "97708": { "city" : "BEND", "state" : "OR", "county" : "DESCHUTES" },
            "97709": { "city" : "BEND", "state" : "OR", "county" : "DESCHUTES" },
            "97710": { "city" : "FIELDS", "state" : "OR", "county" : "HARNEY" },"97720": { "city" : "BURNS", "state" : "OR", "county" : "HARNEY" },
            "97721": { "city" : "PRINCETON", "state" : "OR", "county" : "HARNEY" },
            "97722": { "city" : "DIAMOND", "state" : "OR", "county" : "HARNEY" },
            "97730": { "city" : "CAMP SHERMAN", "state" : "OR", "county" : "JEFFERSON" },
            "97731": { "city" : "CHEMULT", "state" : "OR", "county" : "KLAMATH" },
            "97732": { "city" : "CRANE", "state" : "OR", "county" : "HARNEY" },"97733": { "city" : "CRESCENT", "state" : "OR", "county" : "KLAMATH" },
            "97734": { "city" : "CULVER", "state" : "OR", "county" : "JEFFERSON" },
            "97735": { "city" : "FORT ROCK", "state" : "OR", "county" : "LAKE" },
            "97736": { "city" : "FRENCHGLEN", "state" : "OR", "county" : "HARNEY" },
            "97737": { "city" : "GILCHRIST", "state" : "OR", "county" : "KLAMATH" },
            "97738": { "city" : "HINES", "state" : "OR", "county" : "HARNEY" },"97739": { "city" : "LA PINE", "state" : "OR", "county" : "DESCHUTES" },
            "97741": { "city" : "MADRAS", "state" : "OR", "county" : "JEFFERSON" },
            "97750": { "city" : "MITCHELL", "state" : "OR", "county" : "WHEELER" },
            "97752": { "city" : "POST", "state" : "OR", "county" : "CROOK" },"97753": { "city" : "POWELL BUTTE", "state" : "OR", "county" : "CROOK" },
            "97754": { "city" : "PRINEVILLE", "state" : "OR", "county" : "CROOK" },
            "97756": { "city" : "REDMOND", "state" : "OR", "county" : "DESCHUTES" },
            "97758": { "city" : "RILEY", "state" : "OR", "county" : "HARNEY" },"97759": { "city" : "SISTERS", "state" : "OR", "county" : "DESCHUTES" },
            "97760": { "city" : "TERREBONNE", "state" : "OR", "county" : "JEFFERSON" },
            "97761": { "city" : "WARM SPRINGS", "state" : "OR", "county" : "JEFFERSON" },
            "97801": { "city" : "PENDLETON", "state" : "OR", "county" : "UMATILLA" },
            "97810": { "city" : "ADAMS", "state" : "OR", "county" : "UMATILLA" },
            "97812": { "city" : "ARLINGTON", "state" : "OR", "county" : "GILLIAM" },
            "97813": { "city" : "ATHENA", "state" : "OR", "county" : "UMATILLA" },
            "97814": { "city" : "BAKER CITY", "state" : "OR", "county" : "BAKER" },
            "97817": { "city" : "BATES", "state" : "OR", "county" : "GRANT" },"97818": { "city" : "BOARDMAN", "state" : "OR", "county" : "MORROW" },
            "97820": { "city" : "CANYON CITY", "state" : "OR", "county" : "GRANT" },
            "97823": { "city" : "CONDON", "state" : "OR", "county" : "GILLIAM" },
            "97824": { "city" : "COVE", "state" : "OR", "county" : "UNION" },"97825": { "city" : "DAYVILLE", "state" : "OR", "county" : "GRANT" },
            "97826": { "city" : "ECHO", "state" : "OR", "county" : "UMATILLA" },"97827": { "city" : "ELGIN", "state" : "OR", "county" : "UNION" },
            "97828": { "city" : "ENTERPRISE", "state" : "OR", "county" : "WALLOWA" },
            "97830": { "city" : "FOSSIL", "state" : "OR", "county" : "WHEELER" },
            "97833": { "city" : "HAINES", "state" : "OR", "county" : "BAKER" },"97834": { "city" : "HALFWAY", "state" : "OR", "county" : "BAKER" },
            "97835": { "city" : "HELIX", "state" : "OR", "county" : "UMATILLA" },
            "97836": { "city" : "HEPPNER", "state" : "OR", "county" : "MORROW" },
            "97837": { "city" : "HEREFORD", "state" : "OR", "county" : "BAKER" },
            "97838": { "city" : "HERMISTON", "state" : "OR", "county" : "UMATILLA" },
            "97839": { "city" : "LEXINGTON", "state" : "OR", "county" : "MORROW" },
            "97840": { "city" : "OXBOW", "state" : "OR", "county" : "BAKER" },"97841": { "city" : "IMBLER", "state" : "OR", "county" : "UNION" },
            "97842": { "city" : "IMNAHA", "state" : "OR", "county" : "WALLOWA" },
            "97843": { "city" : "IONE", "state" : "OR", "county" : "MORROW" },"97844": { "city" : "IRRIGON", "state" : "OR", "county" : "MORROW" },
            "97845": { "city" : "JOHN DAY", "state" : "OR", "county" : "GRANT" },
            "97846": { "city" : "JOSEPH", "state" : "OR", "county" : "WALLOWA" },
            "97850": { "city" : "LA GRANDE", "state" : "OR", "county" : "UNION" },
            "97856": { "city" : "LONG CREEK", "state" : "OR", "county" : "GRANT" },
            "97857": { "city" : "LOSTINE", "state" : "OR", "county" : "WALLOWA" },
            "97861": { "city" : "MIKKALO", "state" : "OR", "county" : "GILLIAM" },
            "97862": { "city" : "MILTON FREEWATER", "state" : "OR", "county" : "UMATILLA" },
            "97864": { "city" : "MONUMENT", "state" : "OR", "county" : "GRANT" },
            "97865": { "city" : "MOUNT VERNON", "state" : "OR", "county" : "GRANT" },
            "97867": { "city" : "NORTH POWDER", "state" : "OR", "county" : "UNION" },
            "97868": { "city" : "PILOT ROCK", "state" : "OR", "county" : "UMATILLA" },
            "97869": { "city" : "PRAIRIE CITY", "state" : "OR", "county" : "GRANT" },
            "97870": { "city" : "RICHLAND", "state" : "OR", "county" : "BAKER" },
            "97873": { "city" : "SENECA", "state" : "OR", "county" : "GRANT" },"97874": { "city" : "SPRAY", "state" : "OR", "county" : "WHEELER" },
            "97875": { "city" : "STANFIELD", "state" : "OR", "county" : "UMATILLA" },
            "97876": { "city" : "SUMMERVILLE", "state" : "OR", "county" : "UNION" },
            "97877": { "city" : "SUMPTER", "state" : "OR", "county" : "BAKER" },"97880": { "city" : "UKIAH", "state" : "OR", "county" : "UMATILLA" },
            "97882": { "city" : "UMATILLA", "state" : "OR", "county" : "UMATILLA" },
            "97883": { "city" : "UNION", "state" : "OR", "county" : "UNION" },"97884": { "city" : "UNITY", "state" : "OR", "county" : "BAKER" },
            "97885": { "city" : "WALLOWA", "state" : "OR", "county" : "WALLOWA" },
            "97886": { "city" : "WESTON", "state" : "OR", "county" : "UMATILLA" },
            "97901": { "city" : "ADRIAN", "state" : "OR", "county" : "MALHEUR" },
            "97904": { "city" : "DREWSEY", "state" : "OR", "county" : "HARNEY" },
            "97905": { "city" : "DURKEE", "state" : "OR", "county" : "BAKER" },"97906": { "city" : "HARPER", "state" : "OR", "county" : "MALHEUR" },
            "97907": { "city" : "HUNTINGTON", "state" : "OR", "county" : "BAKER" },
            "97909": { "city" : "JAMIESON", "state" : "OR", "county" : "MALHEUR" },
            "97910": { "city" : "JORDAN VALLEY", "state" : "OR", "county" : "MALHEUR" },
            "97913": { "city" : "NYSSA", "state" : "OR", "county" : "MALHEUR" },"97914": { "city" : "ONTARIO", "state" : "OR", "county" : "MALHEUR" },
            "97918": { "city" : "VALE", "state" : "OR", "county" : "MALHEUR" },"97920": { "city" : "WESTFALL", "state" : "OR", "county" : "MALHEUR" },
            "98001": { "city" : "AUBURN", "state" : "WA", "county" : "KING" },"98002": { "city" : "AUBURN", "state" : "WA", "county" : "KING" },
            "98003": { "city" : "FEDERAL WAY", "state" : "WA", "county" : "KING" },
            "98004": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },"98005": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },
            "98006": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },"98007": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },
            "98008": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },"98009": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },
            "98010": { "city" : "BLACK DIAMOND", "state" : "WA", "county" : "KING" },
            "98011": { "city" : "BOTHELL", "state" : "WA", "county" : "KING" },"98012": { "city" : "BOTHELL", "state" : "WA", "county" : "SNOHOMISH" },
            "98013": { "city" : "BURTON", "state" : "WA", "county" : "KING" },"98014": { "city" : "CARNATION", "state" : "WA", "county" : "KING" },
            "98015": { "city" : "BELLEVUE", "state" : "WA", "county" : "KING" },"98019": { "city" : "DUVALL", "state" : "WA", "county" : "KING" },
            "98020": { "city" : "EDMONDS", "state" : "WA", "county" : "SNOHOMISH" },
            "98021": { "city" : "BOTHELL", "state" : "WA", "county" : "SNOHOMISH" },
            "98022": { "city" : "ENUMCLAW", "state" : "WA", "county" : "KING" },"98023": { "city" : "FEDERAL WAY", "state" : "WA", "county" : "KING" },
            "98024": { "city" : "FALL CITY", "state" : "WA", "county" : "KING" },
            "98025": { "city" : "HOBART", "state" : "WA", "county" : "KING" },"98026": { "city" : "EDMONDS", "state" : "WA", "county" : "SNOHOMISH" },
            "98027": { "city" : "ISSAQUAH", "state" : "WA", "county" : "KING" },"98028": { "city" : "KENMORE", "state" : "WA", "county" : "KING" },
            "98029": { "city" : "ISSAQUAH", "state" : "WA", "county" : "KING" },"98030": { "city" : "KENT", "state" : "WA", "county" : "KING" },
            "98031": { "city" : "KENT", "state" : "WA", "county" : "KING" },"98032": { "city" : "KENT", "state" : "WA", "county" : "KING" },
            "98033": { "city" : "KIRKLAND", "state" : "WA", "county" : "KING" },"98034": { "city" : "KIRKLAND", "state" : "WA", "county" : "KING" },
            "98035": { "city" : "KENT", "state" : "WA", "county" : "KING" },"98036": { "city" : "LYNNWOOD", "state" : "WA", "county" : "SNOHOMISH" },
            "98037": { "city" : "LYNNWOOD", "state" : "WA", "county" : "SNOHOMISH" },
            "98038": { "city" : "MAPLE VALLEY", "state" : "WA", "county" : "KING" },
            "98039": { "city" : "MEDINA", "state" : "WA", "county" : "KING" },"98040": { "city" : "MERCER ISLAND", "state" : "WA", "county" : "KING" },
            "98041": { "city" : "BOTHELL", "state" : "WA", "county" : "KING" },"98042": { "city" : "KENT", "state" : "WA", "county" : "KING" },
            "98043": { "city" : "MOUNTLAKE TERRACE", "state" : "WA", "county" : "SNOHOMISH" },
            "98045": { "city" : "NORTH BEND", "state" : "WA", "county" : "KING" },
            "98046": { "city" : "LYNNWOOD", "state" : "WA", "county" : "SNOHOMISH" },
            "98047": { "city" : "PACIFIC", "state" : "WA", "county" : "KING" },"98050": { "city" : "PRESTON", "state" : "WA", "county" : "KING" },
            "98051": { "city" : "RAVENSDALE", "state" : "WA", "county" : "KING" },
            "98052": { "city" : "REDMOND", "state" : "WA", "county" : "KING" },"98053": { "city" : "REDMOND", "state" : "WA", "county" : "KING" },
            "98054": { "city" : "REDONDO", "state" : "WA", "county" : "KING" },"98055": { "city" : "RENTON", "state" : "WA", "county" : "KING" },
            "98056": { "city" : "RENTON", "state" : "WA", "county" : "KING" },"98057": { "city" : "RENTON", "state" : "WA", "county" : "KING" },
            "98058": { "city" : "RENTON", "state" : "WA", "county" : "KING" },"98059": { "city" : "RENTON", "state" : "WA", "county" : "KING" },
            "98061": { "city" : "ROLLINGBAY", "state" : "WA", "county" : "KITSAP" },
            "98062": { "city" : "SEAHURST", "state" : "WA", "county" : "KING" },"98063": { "city" : "FEDERAL WAY", "state" : "WA", "county" : "KING" },
            "98064": { "city" : "KENT", "state" : "WA", "county" : "KING" },"98065": { "city" : "SNOQUALMIE", "state" : "WA", "county" : "KING" },
            "98068": { "city" : "SNOQUALMIE PASS", "state" : "WA", "county" : "KITTITAS" },
            "98070": { "city" : "VASHON", "state" : "WA", "county" : "KING" },"98071": { "city" : "AUBURN", "state" : "WA", "county" : "KING" },
            "98072": { "city" : "WOODINVILLE", "state" : "WA", "county" : "KING" },
            "98073": { "city" : "REDMOND", "state" : "WA", "county" : "KING" },"98074": { "city" : "SAMMAMISH", "state" : "WA", "county" : "KING" },
            "98075": { "city" : "SAMMAMISH", "state" : "WA", "county" : "KING" },
            "98077": { "city" : "WOODINVILLE", "state" : "WA", "county" : "KING" },
            "98082": { "city" : "MILL CREEK", "state" : "WA", "county" : "SNOHOMISH" },
            "98083": { "city" : "KIRKLAND", "state" : "WA", "county" : "KING" },"98087": { "city" : "LYNNWOOD", "state" : "WA", "county" : "SNOHOMISH" },
            "98089": { "city" : "KENT", "state" : "WA", "county" : "KING" },"98092": { "city" : "AUBURN", "state" : "WA", "county" : "KING" },
            "98093": { "city" : "FEDERAL WAY", "state" : "WA", "county" : "KING" },
            "98101": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98102": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98103": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98104": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98105": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98106": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98107": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98108": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98109": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98110": { "city" : "BAINBRIDGE ISLAND", "state" : "WA", "county" : "KITSAP" },
            "98111": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98112": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98113": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98114": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98115": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98116": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98117": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98118": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98119": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98121": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98122": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98124": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98125": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98126": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98127": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98129": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98133": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98134": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98136": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98138": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98139": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98141": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98144": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98145": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98146": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98148": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98154": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98155": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98158": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98160": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98161": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98164": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98165": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98166": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98168": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98174": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98175": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98177": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98178": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98181": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98185": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98188": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98191": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98194": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98195": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98198": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },
            "98199": { "city" : "SEATTLE", "state" : "WA", "county" : "KING" },"98201": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98203": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98204": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98205": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98206": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98207": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98208": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98213": { "city" : "EVERETT", "state" : "WA", "county" : "SNOHOMISH" },
            "98220": { "city" : "ACME", "state" : "WA", "county" : "WHATCOM" },"98221": { "city" : "ANACORTES", "state" : "WA", "county" : "SKAGIT" },
            "98222": { "city" : "BLAKELY ISLAND", "state" : "WA", "county" : "SAN JUAN" },
            "98223": { "city" : "ARLINGTON", "state" : "WA", "county" : "SNOHOMISH" },
            "98224": { "city" : "BARING", "state" : "WA", "county" : "KING" },"98225": { "city" : "BELLINGHAM", "state" : "WA", "county" : "WHATCOM" },
            "98226": { "city" : "BELLINGHAM", "state" : "WA", "county" : "WHATCOM" },
            "98227": { "city" : "BELLINGHAM", "state" : "WA", "county" : "WHATCOM" },
            "98228": { "city" : "BELLINGHAM", "state" : "WA", "county" : "WHATCOM" },
            "98229": { "city" : "BELLINGHAM", "state" : "WA", "county" : "WHATCOM" },
            "98230": { "city" : "BLAINE", "state" : "WA", "county" : "WHATCOM" },
            "98231": { "city" : "BLAINE", "state" : "WA", "county" : "WHATCOM" },
            "98232": { "city" : "BOW", "state" : "WA", "county" : "SKAGIT" },"98233": { "city" : "BURLINGTON", "state" : "WA", "county" : "SKAGIT" },
            "98235": { "city" : "CLEARLAKE", "state" : "WA", "county" : "SKAGIT" },
            "98236": { "city" : "CLINTON", "state" : "WA", "county" : "ISLAND" },
            "98237": { "city" : "CONCRETE", "state" : "WA", "county" : "SKAGIT" },
            "98238": { "city" : "CONWAY", "state" : "WA", "county" : "SKAGIT" },"98239": { "city" : "COUPEVILLE", "state" : "WA", "county" : "ISLAND" },
            "98240": { "city" : "CUSTER", "state" : "WA", "county" : "WHATCOM" },
            "98241": { "city" : "DARRINGTON", "state" : "WA", "county" : "SNOHOMISH" },
            "98243": { "city" : "DEER HARBOR", "state" : "WA", "county" : "SAN JUAN" },
            "98244": { "city" : "DEMING", "state" : "WA", "county" : "WHATCOM" },
            "98245": { "city" : "EASTSOUND", "state" : "WA", "county" : "SAN JUAN" },
            "98247": { "city" : "EVERSON", "state" : "WA", "county" : "WHATCOM" },
            "98248": { "city" : "FERNDALE", "state" : "WA", "county" : "WHATCOM" },
            "98249": { "city" : "FREELAND", "state" : "WA", "county" : "ISLAND" },
            "98250": { "city" : "FRIDAY HARBOR", "state" : "WA", "county" : "SAN JUAN" },
            "98251": { "city" : "GOLD BAR", "state" : "WA", "county" : "SNOHOMISH" },
            "98252": { "city" : "GRANITE FALLS", "state" : "WA", "county" : "SNOHOMISH" },
            "98253": { "city" : "GREENBANK", "state" : "WA", "county" : "ISLAND" },
            "98255": { "city" : "HAMILTON", "state" : "WA", "county" : "SKAGIT" },
            "98256": { "city" : "INDEX", "state" : "WA", "county" : "SNOHOMISH" },
            "98257": { "city" : "LA CONNER", "state" : "WA", "county" : "SKAGIT" },
            "98258": { "city" : "LAKE STEVENS", "state" : "WA", "county" : "SNOHOMISH" },
            "98259": { "city" : "NORTH LAKEWOOD", "state" : "WA", "county" : "SNOHOMISH" },
            "98260": { "city" : "LANGLEY", "state" : "WA", "county" : "ISLAND" },
            "98261": { "city" : "LOPEZ ISLAND", "state" : "WA", "county" : "SAN JUAN" },
            "98262": { "city" : "LUMMI ISLAND", "state" : "WA", "county" : "WHATCOM" },
            "98263": { "city" : "LYMAN", "state" : "WA", "county" : "SKAGIT" },"98264": { "city" : "LYNDEN", "state" : "WA", "county" : "WHATCOM" },
            "98266": { "city" : "MAPLE FALLS", "state" : "WA", "county" : "WHATCOM" },
            "98267": { "city" : "MARBLEMOUNT", "state" : "WA", "county" : "SKAGIT" },
            "98270": { "city" : "MARYSVILLE", "state" : "WA", "county" : "SNOHOMISH" },
            "98271": { "city" : "MARYSVILLE", "state" : "WA", "county" : "SNOHOMISH" },
            "98272": { "city" : "MONROE", "state" : "WA", "county" : "SNOHOMISH" },
            "98273": { "city" : "MOUNT VERNON", "state" : "WA", "county" : "SKAGIT" },
            "98274": { "city" : "MOUNT VERNON", "state" : "WA", "county" : "SKAGIT" },
            "98275": { "city" : "MUKILTEO", "state" : "WA", "county" : "SNOHOMISH" },
            "98276": { "city" : "NOOKSACK", "state" : "WA", "county" : "WHATCOM" },
            "98277": { "city" : "OAK HARBOR", "state" : "WA", "county" : "ISLAND" },
            "98278": { "city" : "OAK HARBOR", "state" : "WA", "county" : "ISLAND" },
            "98279": { "city" : "OLGA", "state" : "WA", "county" : "SAN JUAN" },"98280": { "city" : "ORCAS", "state" : "WA", "county" : "SAN JUAN" },
            "98281": { "city" : "POINT ROBERTS", "state" : "WA", "county" : "WHATCOM" },
            "98282": { "city" : "CAMANO ISLAND", "state" : "WA", "county" : "ISLAND" },
            "98283": { "city" : "ROCKPORT", "state" : "WA", "county" : "SKAGIT" },
            "98284": { "city" : "SEDRO WOOLLEY", "state" : "WA", "county" : "SKAGIT" },
            "98286": { "city" : "SHAW ISLAND", "state" : "WA", "county" : "SAN JUAN" },
            "98287": { "city" : "SILVANA", "state" : "WA", "county" : "SNOHOMISH" },
            "98288": { "city" : "SKYKOMISH", "state" : "WA", "county" : "KING" },
            "98290": { "city" : "SNOHOMISH", "state" : "WA", "county" : "SNOHOMISH" },
            "98291": { "city" : "SNOHOMISH", "state" : "WA", "county" : "SNOHOMISH" },
            "98292": { "city" : "STANWOOD", "state" : "WA", "county" : "SNOHOMISH" },
            "98293": { "city" : "STARTUP", "state" : "WA", "county" : "SNOHOMISH" },
            "98294": { "city" : "SULTAN", "state" : "WA", "county" : "SNOHOMISH" },
            "98295": { "city" : "SUMAS", "state" : "WA", "county" : "WHATCOM" },"98296": { "city" : "SNOHOMISH", "state" : "WA", "county" : "SNOHOMISH" },
            "98297": { "city" : "WALDRON", "state" : "WA", "county" : "SAN JUAN" },
            "98303": { "city" : "ANDERSON ISLAND", "state" : "WA", "county" : "PIERCE" },
            "98304": { "city" : "ASHFORD", "state" : "WA", "county" : "PIERCE" },
            "98305": { "city" : "BEAVER", "state" : "WA", "county" : "CLALLAM" },
            "98310": { "city" : "BREMERTON", "state" : "WA", "county" : "KITSAP" },
            "98311": { "city" : "BREMERTON", "state" : "WA", "county" : "KITSAP" },
            "98312": { "city" : "BREMERTON", "state" : "WA", "county" : "KITSAP" },
            "98314": { "city" : "BREMERTON", "state" : "WA", "county" : "KITSAP" },
            "98315": { "city" : "SILVERDALE", "state" : "WA", "county" : "KITSAP" },
            "98320": { "city" : "BRINNON", "state" : "WA", "county" : "JEFFERSON" },
            "98321": { "city" : "BUCKLEY", "state" : "WA", "county" : "PIERCE" },
            "98322": { "city" : "BURLEY", "state" : "WA", "county" : "KITSAP" },"98323": { "city" : "CARBONADO", "state" : "WA", "county" : "PIERCE" },
            "98324": { "city" : "CARLSBORG", "state" : "WA", "county" : "CLALLAM" },
            "98325": { "city" : "CHIMACUM", "state" : "WA", "county" : "JEFFERSON" },
            "98326": { "city" : "CLALLAM BAY", "state" : "WA", "county" : "CLALLAM" },
            "98327": { "city" : "DUPONT", "state" : "WA", "county" : "PIERCE" },"98328": { "city" : "EATONVILLE", "state" : "WA", "county" : "PIERCE" },
            "98329": { "city" : "GIG HARBOR", "state" : "WA", "county" : "PIERCE" },
            "98330": { "city" : "ELBE", "state" : "WA", "county" : "PIERCE" },"98331": { "city" : "FORKS", "state" : "WA", "county" : "CLALLAM" },
            "98332": { "city" : "GIG HARBOR", "state" : "WA", "county" : "PIERCE" },
            "98333": { "city" : "FOX ISLAND", "state" : "WA", "county" : "PIERCE" },
            "98335": { "city" : "GIG HARBOR", "state" : "WA", "county" : "PIERCE" },
            "98336": { "city" : "GLENOMA", "state" : "WA", "county" : "LEWIS" },"98337": { "city" : "BREMERTON", "state" : "WA", "county" : "KITSAP" },
            "98338": { "city" : "GRAHAM", "state" : "WA", "county" : "PIERCE" },"98339": { "city" : "PORT HADLOCK", "state" : "WA", "county" : "JEFFERSON" },
            "98340": { "city" : "HANSVILLE", "state" : "WA", "county" : "KITSAP" },
            "98342": { "city" : "INDIANOLA", "state" : "WA", "county" : "KITSAP" },
            "98343": { "city" : "JOYCE", "state" : "WA", "county" : "CLALLAM" },"98344": { "city" : "KAPOWSIN", "state" : "WA", "county" : "PIERCE" },
            "98345": { "city" : "KEYPORT", "state" : "WA", "county" : "KITSAP" },
            "98346": { "city" : "KINGSTON", "state" : "WA", "county" : "KITSAP" },
            "98348": { "city" : "LA GRANDE", "state" : "WA", "county" : "PIERCE" },
            "98349": { "city" : "LAKEBAY", "state" : "WA", "county" : "PIERCE" },
            "98351": { "city" : "LONGBRANCH", "state" : "WA", "county" : "PIERCE" },
            "98352": { "city" : "SUMNER", "state" : "WA", "county" : "PIERCE" },"98353": { "city" : "MANCHESTER", "state" : "WA", "county" : "KITSAP" },
            "98354": { "city" : "MILTON", "state" : "WA", "county" : "PIERCE" },"98355": { "city" : "MINERAL", "state" : "WA", "county" : "LEWIS" },
            "98356": { "city" : "MORTON", "state" : "WA", "county" : "LEWIS" },"98357": { "city" : "NEAH BAY", "state" : "WA", "county" : "CLALLAM" },
            "98358": { "city" : "NORDLAND", "state" : "WA", "county" : "JEFFERSON" },
            "98359": { "city" : "OLALLA", "state" : "WA", "county" : "KITSAP" },"98360": { "city" : "ORTING", "state" : "WA", "county" : "PIERCE" },
            "98361": { "city" : "PACKWOOD", "state" : "WA", "county" : "LEWIS" },
            "98362": { "city" : "PORT ANGELES", "state" : "WA", "county" : "CLALLAM" },
            "98363": { "city" : "PORT ANGELES", "state" : "WA", "county" : "CLALLAM" },
            "98364": { "city" : "PORT GAMBLE", "state" : "WA", "county" : "KITSAP" },
            "98365": { "city" : "PORT LUDLOW", "state" : "WA", "county" : "JEFFERSON" },
            "98366": { "city" : "PORT ORCHARD", "state" : "WA", "county" : "KITSAP" },
            "98367": { "city" : "PORT ORCHARD", "state" : "WA", "county" : "KITSAP" },
            "98368": { "city" : "PORT TOWNSEND", "state" : "WA", "county" : "JEFFERSON" },
            "98370": { "city" : "POULSBO", "state" : "WA", "county" : "KITSAP" },
            "98371": { "city" : "PUYALLUP", "state" : "WA", "county" : "PIERCE" },
            "98372": { "city" : "PUYALLUP", "state" : "WA", "county" : "PIERCE" },
            "98373": { "city" : "PUYALLUP", "state" : "WA", "county" : "PIERCE" },
            "98374": { "city" : "PUYALLUP", "state" : "WA", "county" : "PIERCE" },
            "98375": { "city" : "PUYALLUP", "state" : "WA", "county" : "PIERCE" },
            "98376": { "city" : "QUILCENE", "state" : "WA", "county" : "JEFFERSON" },
            "98377": { "city" : "RANDLE", "state" : "WA", "county" : "LEWIS" },"98378": { "city" : "RETSIL", "state" : "WA", "county" : "KITSAP" },
            "98380": { "city" : "SEABECK", "state" : "WA", "county" : "KITSAP" },
            "98381": { "city" : "SEKIU", "state" : "WA", "county" : "CLALLAM" },"98382": { "city" : "SEQUIM", "state" : "WA", "county" : "CLALLAM" },
            "98383": { "city" : "SILVERDALE", "state" : "WA", "county" : "KITSAP" },
            "98384": { "city" : "SOUTH COLBY", "state" : "WA", "county" : "KITSAP" },
            "98385": { "city" : "SOUTH PRAIRIE", "state" : "WA", "county" : "PIERCE" },
            "98386": { "city" : "SOUTHWORTH", "state" : "WA", "county" : "KITSAP" },
            "98387": { "city" : "SPANAWAY", "state" : "WA", "county" : "PIERCE" },
            "98388": { "city" : "STEILACOOM", "state" : "WA", "county" : "PIERCE" },
            "98390": { "city" : "SUMNER", "state" : "WA", "county" : "PIERCE" },"98391": { "city" : "BONNEY LAKE", "state" : "WA", "county" : "PIERCE" },
            "98392": { "city" : "SUQUAMISH", "state" : "WA", "county" : "KITSAP" },
            "98393": { "city" : "TRACYTON", "state" : "WA", "county" : "KITSAP" },
            "98394": { "city" : "VAUGHN", "state" : "WA", "county" : "PIERCE" },"98395": { "city" : "WAUNA", "state" : "WA", "county" : "PIERCE" },
            "98396": { "city" : "WILKESON", "state" : "WA", "county" : "PIERCE" },
            "98397": { "city" : "LONGMIRE", "state" : "WA", "county" : "PIERCE" },
            "98398": { "city" : "PARADISE INN", "state" : "WA", "county" : "PIERCE" },
            "98401": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98402": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98403": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98404": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98405": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98406": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98407": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98408": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98409": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98411": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98412": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98415": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98416": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98417": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98418": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98419": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98421": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98422": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98424": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98430": { "city" : "CAMP MURRAY", "state" : "WA", "county" : "PIERCE" },
            "98431": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98433": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98438": { "city" : "MCCHORD AFB", "state" : "WA", "county" : "PIERCE" },
            "98439": { "city" : "LAKEWOOD", "state" : "WA", "county" : "PIERCE" },
            "98442": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98443": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98444": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98445": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98446": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98447": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98448": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98464": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98465": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98466": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98467": { "city" : "UNIVERSITY PLACE", "state" : "WA", "county" : "PIERCE" },
            "98490": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },"98493": { "city" : "TACOMA", "state" : "WA", "county" : "PIERCE" },
            "98496": { "city" : "LAKEWOOD", "state" : "WA", "county" : "PIERCE" },
            "98497": { "city" : "LAKEWOOD", "state" : "WA", "county" : "PIERCE" },
            "98498": { "city" : "LAKEWOOD", "state" : "WA", "county" : "PIERCE" },
            "98499": { "city" : "LAKEWOOD", "state" : "WA", "county" : "PIERCE" },
            "98501": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98502": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98503": { "city" : "LACEY", "state" : "WA", "county" : "THURSTON" },
            "98504": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98505": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98506": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98507": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98508": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98509": { "city" : "LACEY", "state" : "WA", "county" : "THURSTON" },
            "98511": { "city" : "TUMWATER", "state" : "WA", "county" : "THURSTON" },
            "98512": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98513": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98516": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98520": { "city" : "ABERDEEN", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98522": { "city" : "ADNA", "state" : "WA", "county" : "LEWIS" },"98524": { "city" : "ALLYN", "state" : "WA", "county" : "MASON" },
            "98526": { "city" : "AMANDA PARK", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98527": { "city" : "BAY CENTER", "state" : "WA", "county" : "PACIFIC" },
            "98528": { "city" : "BELFAIR", "state" : "WA", "county" : "MASON" },"98530": { "city" : "BUCODA", "state" : "WA", "county" : "THURSTON" },
            "98531": { "city" : "CENTRALIA", "state" : "WA", "county" : "LEWIS" },
            "98532": { "city" : "CHEHALIS", "state" : "WA", "county" : "LEWIS" },
            "98533": { "city" : "CINEBAR", "state" : "WA", "county" : "LEWIS" },"98535": { "city" : "COPALIS BEACH", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98536": { "city" : "COPALIS CROSSING", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98537": { "city" : "COSMOPOLIS", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98538": { "city" : "CURTIS", "state" : "WA", "county" : "LEWIS" },"98539": { "city" : "DOTY", "state" : "WA", "county" : "LEWIS" },
            "98540": { "city" : "EAST OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98541": { "city" : "ELMA", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98542": { "city" : "ETHEL", "state" : "WA", "county" : "LEWIS" },"98546": { "city" : "GRAPEVIEW", "state" : "WA", "county" : "MASON" },
            "98547": { "city" : "GRAYLAND", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98548": { "city" : "HOODSPORT", "state" : "WA", "county" : "MASON" },
            "98550": { "city" : "HOQUIAM", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98552": { "city" : "HUMPTULIPS", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98554": { "city" : "LEBAM", "state" : "WA", "county" : "PACIFIC" },"98555": { "city" : "LILLIWAUP", "state" : "WA", "county" : "MASON" },
            "98556": { "city" : "LITTLEROCK", "state" : "WA", "county" : "THURSTON" },
            "98557": { "city" : "MCCLEARY", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98558": { "city" : "MCKENNA", "state" : "WA", "county" : "PIERCE" },
            "98559": { "city" : "MALONE", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98560": { "city" : "MATLOCK", "state" : "WA", "county" : "MASON" },"98561": { "city" : "MENLO", "state" : "WA", "county" : "PACIFIC" },
            "98562": { "city" : "MOCLIPS", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98563": { "city" : "MONTESANO", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98564": { "city" : "MOSSYROCK", "state" : "WA", "county" : "LEWIS" },
            "98565": { "city" : "NAPAVINE", "state" : "WA", "county" : "LEWIS" },
            "98566": { "city" : "NEILTON", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98568": { "city" : "OAKVILLE", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98569": { "city" : "OCEAN SHORES", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98570": { "city" : "ONALASKA", "state" : "WA", "county" : "LEWIS" },
            "98571": { "city" : "PACIFIC BEACH", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98572": { "city" : "PE ELL", "state" : "WA", "county" : "LEWIS" },"98575": { "city" : "QUINAULT", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98576": { "city" : "RAINIER", "state" : "WA", "county" : "THURSTON" },
            "98577": { "city" : "RAYMOND", "state" : "WA", "county" : "PACIFIC" },
            "98579": { "city" : "ROCHESTER", "state" : "WA", "county" : "THURSTON" },
            "98580": { "city" : "ROY", "state" : "WA", "county" : "PIERCE" },"98582": { "city" : "SALKUM", "state" : "WA", "county" : "LEWIS" },
            "98583": { "city" : "SATSOP", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98584": { "city" : "SHELTON", "state" : "WA", "county" : "MASON" },"98585": { "city" : "SILVER CREEK", "state" : "WA", "county" : "LEWIS" },
            "98586": { "city" : "SOUTH BEND", "state" : "WA", "county" : "PACIFIC" },
            "98587": { "city" : "TAHOLAH", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98588": { "city" : "TAHUYA", "state" : "WA", "county" : "MASON" },"98589": { "city" : "TENINO", "state" : "WA", "county" : "THURSTON" },
            "98590": { "city" : "TOKELAND", "state" : "WA", "county" : "PACIFIC" },
            "98591": { "city" : "TOLEDO", "state" : "WA", "county" : "LEWIS" },"98592": { "city" : "UNION", "state" : "WA", "county" : "MASON" },
            "98593": { "city" : "VADER", "state" : "WA", "county" : "LEWIS" },"98595": { "city" : "WESTPORT", "state" : "WA", "county" : "GRAYS HARBOR" },
            "98596": { "city" : "WINLOCK", "state" : "WA", "county" : "LEWIS" },"98597": { "city" : "YELM", "state" : "WA", "county" : "THURSTON" },
            "98599": { "city" : "OLYMPIA", "state" : "WA", "county" : "THURSTON" },
            "98601": { "city" : "AMBOY", "state" : "WA", "county" : "CLARK" },"98602": { "city" : "APPLETON", "state" : "WA", "county" : "KLICKITAT" },
            "98603": { "city" : "ARIEL", "state" : "WA", "county" : "COWLITZ" },"98604": { "city" : "BATTLE GROUND", "state" : "WA", "county" : "CLARK" },
            "98605": { "city" : "BINGEN", "state" : "WA", "county" : "KLICKITAT" },
            "98606": { "city" : "BRUSH PRAIRIE", "state" : "WA", "county" : "CLARK" },
            "98607": { "city" : "CAMAS", "state" : "WA", "county" : "CLARK" },"98610": { "city" : "CARSON", "state" : "WA", "county" : "SKAMANIA" },
            "98611": { "city" : "CASTLE ROCK", "state" : "WA", "county" : "COWLITZ" },
            "98612": { "city" : "CATHLAMET", "state" : "WA", "county" : "WAHKIAKUM" },
            "98613": { "city" : "CENTERVILLE", "state" : "WA", "county" : "KLICKITAT" },
            "98614": { "city" : "CHINOOK", "state" : "WA", "county" : "PACIFIC" },
            "98616": { "city" : "COUGAR", "state" : "WA", "county" : "COWLITZ" },
            "98617": { "city" : "DALLESPORT", "state" : "WA", "county" : "KLICKITAT" },
            "98619": { "city" : "GLENWOOD", "state" : "WA", "county" : "KLICKITAT" },
            "98620": { "city" : "GOLDENDALE", "state" : "WA", "county" : "KLICKITAT" },
            "98621": { "city" : "GRAYS RIVER", "state" : "WA", "county" : "WAHKIAKUM" },
            "98622": { "city" : "HEISSON", "state" : "WA", "county" : "CLARK" },"98623": { "city" : "HUSUM", "state" : "WA", "county" : "KLICKITAT" },
            "98624": { "city" : "ILWACO", "state" : "WA", "county" : "PACIFIC" },
            "98625": { "city" : "KALAMA", "state" : "WA", "county" : "COWLITZ" },
            "98626": { "city" : "KELSO", "state" : "WA", "county" : "COWLITZ" },"98628": { "city" : "KLICKITAT", "state" : "WA", "county" : "KLICKITAT" },
            "98629": { "city" : "LA CENTER", "state" : "WA", "county" : "CLARK" },
            "98631": { "city" : "LONG BEACH", "state" : "WA", "county" : "PACIFIC" },
            "98632": { "city" : "LONGVIEW", "state" : "WA", "county" : "COWLITZ" },
            "98635": { "city" : "LYLE", "state" : "WA", "county" : "KLICKITAT" },
            "98637": { "city" : "NAHCOTTA", "state" : "WA", "county" : "PACIFIC" },
            "98638": { "city" : "NASELLE", "state" : "WA", "county" : "PACIFIC" },
            "98639": { "city" : "NORTH BONNEVILLE", "state" : "WA", "county" : "SKAMANIA" },
            "98640": { "city" : "OCEAN PARK", "state" : "WA", "county" : "PACIFIC" },
            "98641": { "city" : "OYSTERVILLE", "state" : "WA", "county" : "PACIFIC" },
            "98642": { "city" : "RIDGEFIELD", "state" : "WA", "county" : "CLARK" },
            "98643": { "city" : "ROSBURG", "state" : "WA", "county" : "WAHKIAKUM" },
            "98644": { "city" : "SEAVIEW", "state" : "WA", "county" : "PACIFIC" },
            "98645": { "city" : "SILVERLAKE", "state" : "WA", "county" : "COWLITZ" },
            "98647": { "city" : "SKAMOKAWA", "state" : "WA", "county" : "WAHKIAKUM" },
            "98648": { "city" : "STEVENSON", "state" : "WA", "county" : "SKAMANIA" },
            "98649": { "city" : "TOUTLE", "state" : "WA", "county" : "COWLITZ" },
            "98650": { "city" : "TROUT LAKE", "state" : "WA", "county" : "KLICKITAT" },
            "98651": { "city" : "UNDERWOOD", "state" : "WA", "county" : "SKAMANIA" },
            "98660": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98661": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98662": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98663": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98664": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98665": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98666": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98668": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98670": { "city" : "WAHKIACUS", "state" : "WA", "county" : "KLICKITAT" },
            "98671": { "city" : "WASHOUGAL", "state" : "WA", "county" : "CLARK" },
            "98672": { "city" : "WHITE SALMON", "state" : "WA", "county" : "KLICKITAT" },
            "98673": { "city" : "WISHRAM", "state" : "WA", "county" : "KLICKITAT" },
            "98674": { "city" : "WOODLAND", "state" : "WA", "county" : "COWLITZ" },
            "98675": { "city" : "YACOLT", "state" : "WA", "county" : "CLARK" },"98682": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98683": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98684": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98685": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98686": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98687": { "city" : "VANCOUVER", "state" : "WA", "county" : "CLARK" },
            "98801": { "city" : "WENATCHEE", "state" : "WA", "county" : "CHELAN" },
            "98802": { "city" : "EAST WENATCHEE", "state" : "WA", "county" : "DOUGLAS" },
            "98807": { "city" : "WENATCHEE", "state" : "WA", "county" : "CHELAN" },
            "98811": { "city" : "ARDENVOIR", "state" : "WA", "county" : "CHELAN" },
            "98812": { "city" : "BREWSTER", "state" : "WA", "county" : "OKANOGAN" },
            "98813": { "city" : "BRIDGEPORT", "state" : "WA", "county" : "DOUGLAS" },
            "98814": { "city" : "CARLTON", "state" : "WA", "county" : "OKANOGAN" },
            "98815": { "city" : "CASHMERE", "state" : "WA", "county" : "CHELAN" },
            "98816": { "city" : "CHELAN", "state" : "WA", "county" : "CHELAN" },"98817": { "city" : "CHELAN FALLS", "state" : "WA", "county" : "CHELAN" },
            "98819": { "city" : "CONCONULLY", "state" : "WA", "county" : "OKANOGAN" },
            "98821": { "city" : "DRYDEN", "state" : "WA", "county" : "CHELAN" },"98822": { "city" : "ENTIAT", "state" : "WA", "county" : "CHELAN" },
            "98823": { "city" : "EPHRATA", "state" : "WA", "county" : "GRANT" },"98824": { "city" : "GEORGE", "state" : "WA", "county" : "GRANT" },
            "98826": { "city" : "LEAVENWORTH", "state" : "WA", "county" : "CHELAN" },
            "98827": { "city" : "LOOMIS", "state" : "WA", "county" : "OKANOGAN" },
            "98828": { "city" : "MALAGA", "state" : "WA", "county" : "CHELAN" },"98829": { "city" : "MALOTT", "state" : "WA", "county" : "OKANOGAN" },
            "98830": { "city" : "MANSFIELD", "state" : "WA", "county" : "DOUGLAS" },
            "98831": { "city" : "MANSON", "state" : "WA", "county" : "CHELAN" },"98832": { "city" : "MARLIN", "state" : "WA", "county" : "GRANT" },
            "98833": { "city" : "MAZAMA", "state" : "WA", "county" : "OKANOGAN" },
            "98834": { "city" : "METHOW", "state" : "WA", "county" : "OKANOGAN" },
            "98836": { "city" : "MONITOR", "state" : "WA", "county" : "CHELAN" },
            "98837": { "city" : "MOSES LAKE", "state" : "WA", "county" : "GRANT" },
            "98840": { "city" : "OKANOGAN", "state" : "WA", "county" : "OKANOGAN" },
            "98841": { "city" : "OMAK", "state" : "WA", "county" : "OKANOGAN" },"98843": { "city" : "ORONDO", "state" : "WA", "county" : "DOUGLAS" },
            "98844": { "city" : "OROVILLE", "state" : "WA", "county" : "OKANOGAN" },
            "98845": { "city" : "PALISADES", "state" : "WA", "county" : "DOUGLAS" },
            "98846": { "city" : "PATEROS", "state" : "WA", "county" : "OKANOGAN" },
            "98847": { "city" : "PESHASTIN", "state" : "WA", "county" : "CHELAN" },
            "98848": { "city" : "QUINCY", "state" : "WA", "county" : "GRANT" },"98849": { "city" : "RIVERSIDE", "state" : "WA", "county" : "OKANOGAN" },
            "98850": { "city" : "ROCK ISLAND", "state" : "WA", "county" : "DOUGLAS" },
            "98851": { "city" : "SOAP LAKE", "state" : "WA", "county" : "GRANT" },
            "98852": { "city" : "STEHEKIN", "state" : "WA", "county" : "CHELAN" },
            "98853": { "city" : "STRATFORD", "state" : "WA", "county" : "GRANT" },
            "98855": { "city" : "TONASKET", "state" : "WA", "county" : "OKANOGAN" },
            "98856": { "city" : "TWISP", "state" : "WA", "county" : "OKANOGAN" },
            "98857": { "city" : "WARDEN", "state" : "WA", "county" : "GRANT" },"98858": { "city" : "WATERVILLE", "state" : "WA", "county" : "DOUGLAS" },
            "98859": { "city" : "WAUCONDA", "state" : "WA", "county" : "OKANOGAN" },
            "98860": { "city" : "WILSON CREEK", "state" : "WA", "county" : "GRANT" },
            "98862": { "city" : "WINTHROP", "state" : "WA", "county" : "OKANOGAN" },
            "98901": { "city" : "YAKIMA", "state" : "WA", "county" : "YAKIMA" },"98902": { "city" : "YAKIMA", "state" : "WA", "county" : "YAKIMA" },
            "98903": { "city" : "YAKIMA", "state" : "WA", "county" : "YAKIMA" },"98907": { "city" : "YAKIMA", "state" : "WA", "county" : "YAKIMA" },
            "98908": { "city" : "YAKIMA", "state" : "WA", "county" : "YAKIMA" },"98909": { "city" : "YAKIMA", "state" : "WA", "county" : "YAKIMA" },
            "98921": { "city" : "BUENA", "state" : "WA", "county" : "YAKIMA" },"98922": { "city" : "CLE ELUM", "state" : "WA", "county" : "KITTITAS" },
            "98923": { "city" : "COWICHE", "state" : "WA", "county" : "YAKIMA" },
            "98925": { "city" : "EASTON", "state" : "WA", "county" : "KITTITAS" },
            "98926": { "city" : "ELLENSBURG", "state" : "WA", "county" : "KITTITAS" },
            "98929": { "city" : "GOOSE PRAIRIE", "state" : "WA", "county" : "YAKIMA" },
            "98930": { "city" : "GRANDVIEW", "state" : "WA", "county" : "YAKIMA" },
            "98932": { "city" : "GRANGER", "state" : "WA", "county" : "YAKIMA" },
            "98933": { "city" : "HARRAH", "state" : "WA", "county" : "YAKIMA" },"98934": { "city" : "KITTITAS", "state" : "WA", "county" : "KITTITAS" },
            "98935": { "city" : "MABTON", "state" : "WA", "county" : "YAKIMA" },"98936": { "city" : "MOXEE", "state" : "WA", "county" : "YAKIMA" },
            "98937": { "city" : "NACHES", "state" : "WA", "county" : "YAKIMA" },"98938": { "city" : "OUTLOOK", "state" : "WA", "county" : "YAKIMA" },
            "98939": { "city" : "PARKER", "state" : "WA", "county" : "YAKIMA" },"98940": { "city" : "RONALD", "state" : "WA", "county" : "KITTITAS" },
            "98941": { "city" : "ROSLYN", "state" : "WA", "county" : "KITTITAS" },
            "98942": { "city" : "SELAH", "state" : "WA", "county" : "YAKIMA" },"98943": { "city" : "SOUTH CLE ELUM", "state" : "WA", "county" : "KITTITAS" },
            "98944": { "city" : "SUNNYSIDE", "state" : "WA", "county" : "YAKIMA" },
            "98946": { "city" : "THORP", "state" : "WA", "county" : "KITTITAS" },
            "98947": { "city" : "TIETON", "state" : "WA", "county" : "YAKIMA" },"98948": { "city" : "TOPPENISH", "state" : "WA", "county" : "YAKIMA" },
            "98950": { "city" : "VANTAGE", "state" : "WA", "county" : "KITTITAS" },
            "98951": { "city" : "WAPATO", "state" : "WA", "county" : "YAKIMA" },"98952": { "city" : "WHITE SWAN", "state" : "WA", "county" : "YAKIMA" },
            "98953": { "city" : "ZILLAH", "state" : "WA", "county" : "YAKIMA" },"99001": { "city" : "AIRWAY HEIGHTS", "state" : "WA", "county" : "SPOKANE" },
            "99003": { "city" : "CHATTAROY", "state" : "WA", "county" : "SPOKANE" },
            "99004": { "city" : "CHENEY", "state" : "WA", "county" : "SPOKANE" },
            "99005": { "city" : "COLBERT", "state" : "WA", "county" : "SPOKANE" },
            "99006": { "city" : "DEER PARK", "state" : "WA", "county" : "SPOKANE" },
            "99008": { "city" : "EDWALL", "state" : "WA", "county" : "LINCOLN" },
            "99009": { "city" : "ELK", "state" : "WA", "county" : "SPOKANE" },"99011": { "city" : "FAIRCHILD AIR FORCE BASE", "state" : "WA", "county" : "SPOKANE" },
            "99012": { "city" : "FAIRFIELD", "state" : "WA", "county" : "SPOKANE" },
            "99013": { "city" : "FORD", "state" : "WA", "county" : "STEVENS" },"99014": { "city" : "FOUR LAKES", "state" : "WA", "county" : "SPOKANE" },
            "99016": { "city" : "GREENACRES", "state" : "WA", "county" : "SPOKANE" },
            "99017": { "city" : "LAMONT", "state" : "WA", "county" : "WHITMAN" },
            "99018": { "city" : "LATAH", "state" : "WA", "county" : "SPOKANE" },"99019": { "city" : "LIBERTY LAKE", "state" : "WA", "county" : "SPOKANE" },
            "99020": { "city" : "MARSHALL", "state" : "WA", "county" : "SPOKANE" },
            "99021": { "city" : "MEAD", "state" : "WA", "county" : "SPOKANE" },"99022": { "city" : "MEDICAL LAKE", "state" : "WA", "county" : "SPOKANE" },
            "99023": { "city" : "MICA", "state" : "WA", "county" : "SPOKANE" },"99025": { "city" : "NEWMAN LAKE", "state" : "WA", "county" : "SPOKANE" },
            "99026": { "city" : "NINE MILE FALLS", "state" : "WA", "county" : "SPOKANE" },
            "99027": { "city" : "OTIS ORCHARDS", "state" : "WA", "county" : "SPOKANE" },
            "99029": { "city" : "REARDAN", "state" : "WA", "county" : "LINCOLN" },
            "99030": { "city" : "ROCKFORD", "state" : "WA", "county" : "SPOKANE" },
            "99031": { "city" : "SPANGLE", "state" : "WA", "county" : "SPOKANE" },
            "99032": { "city" : "SPRAGUE", "state" : "WA", "county" : "LINCOLN" },
            "99033": { "city" : "TEKOA", "state" : "WA", "county" : "WHITMAN" },"99034": { "city" : "TUMTUM", "state" : "WA", "county" : "STEVENS" },
            "99036": { "city" : "VALLEYFORD", "state" : "WA", "county" : "SPOKANE" },
            "99037": { "city" : "VERADALE", "state" : "WA", "county" : "SPOKANE" },
            "99039": { "city" : "WAVERLY", "state" : "WA", "county" : "SPOKANE" },
            "99040": { "city" : "WELLPINIT", "state" : "WA", "county" : "STEVENS" },
            "99101": { "city" : "ADDY", "state" : "WA", "county" : "STEVENS" },"99102": { "city" : "ALBION", "state" : "WA", "county" : "WHITMAN" },
            "99103": { "city" : "ALMIRA", "state" : "WA", "county" : "LINCOLN" },
            "99109": { "city" : "CHEWELAH", "state" : "WA", "county" : "STEVENS" },
            "99110": { "city" : "CLAYTON", "state" : "WA", "county" : "STEVENS" },
            "99111": { "city" : "COLFAX", "state" : "WA", "county" : "WHITMAN" },
            "99113": { "city" : "COLTON", "state" : "WA", "county" : "WHITMAN" },
            "99114": { "city" : "COLVILLE", "state" : "WA", "county" : "STEVENS" },
            "99115": { "city" : "COULEE CITY", "state" : "WA", "county" : "GRANT" },
            "99116": { "city" : "COULEE DAM", "state" : "WA", "county" : "OKANOGAN" },
            "99117": { "city" : "CRESTON", "state" : "WA", "county" : "LINCOLN" },
            "99118": { "city" : "CURLEW", "state" : "WA", "county" : "FERRY" },"99119": { "city" : "CUSICK", "state" : "WA", "county" : "PEND OREILLE" },
            "99121": { "city" : "DANVILLE", "state" : "WA", "county" : "FERRY" },
            "99122": { "city" : "DAVENPORT", "state" : "WA", "county" : "LINCOLN" },
            "99123": { "city" : "ELECTRIC CITY", "state" : "WA", "county" : "GRANT" },
            "99124": { "city" : "ELMER CITY", "state" : "WA", "county" : "OKANOGAN" },
            "99125": { "city" : "ENDICOTT", "state" : "WA", "county" : "WHITMAN" },
            "99126": { "city" : "EVANS", "state" : "WA", "county" : "STEVENS" },"99128": { "city" : "FARMINGTON", "state" : "WA", "county" : "WHITMAN" },
            "99129": { "city" : "FRUITLAND", "state" : "WA", "county" : "STEVENS" },
            "99130": { "city" : "GARFIELD", "state" : "WA", "county" : "WHITMAN" },
            "99133": { "city" : "GRAND COULEE", "state" : "WA", "county" : "GRANT" },
            "99134": { "city" : "HARRINGTON", "state" : "WA", "county" : "LINCOLN" },
            "99135": { "city" : "HARTLINE", "state" : "WA", "county" : "GRANT" },
            "99137": { "city" : "HUNTERS", "state" : "WA", "county" : "STEVENS" },
            "99138": { "city" : "INCHELIUM", "state" : "WA", "county" : "FERRY" },
            "99139": { "city" : "IONE", "state" : "WA", "county" : "PEND OREILLE" },
            "99140": { "city" : "KELLER", "state" : "WA", "county" : "FERRY" },"99141": { "city" : "KETTLE FALLS", "state" : "WA", "county" : "STEVENS" },
            "99143": { "city" : "LACROSSE", "state" : "WA", "county" : "WHITMAN" },
            "99144": { "city" : "LAMONA", "state" : "WA", "county" : "LINCOLN" },
            "99147": { "city" : "LINCOLN", "state" : "WA", "county" : "LINCOLN" },
            "99148": { "city" : "LOON LAKE", "state" : "WA", "county" : "STEVENS" },
            "99149": { "city" : "MALDEN", "state" : "WA", "county" : "WHITMAN" },
            "99150": { "city" : "MALO", "state" : "WA", "county" : "FERRY" },"99151": { "city" : "MARCUS", "state" : "WA", "county" : "STEVENS" },
            "99152": { "city" : "METALINE", "state" : "WA", "county" : "PEND OREILLE" },
            "99153": { "city" : "METALINE FALLS", "state" : "WA", "county" : "PEND OREILLE" },
            "99154": { "city" : "MOHLER", "state" : "WA", "county" : "LINCOLN" },
            "99155": { "city" : "NESPELEM", "state" : "WA", "county" : "OKANOGAN" },
            "99156": { "city" : "NEWPORT", "state" : "WA", "county" : "PEND OREILLE" },
            "99157": { "city" : "NORTHPORT", "state" : "WA", "county" : "STEVENS" },
            "99158": { "city" : "OAKESDALE", "state" : "WA", "county" : "WHITMAN" },
            "99159": { "city" : "ODESSA", "state" : "WA", "county" : "LINCOLN" },
            "99160": { "city" : "ORIENT", "state" : "WA", "county" : "FERRY" },"99161": { "city" : "PALOUSE", "state" : "WA", "county" : "WHITMAN" },
            "99163": { "city" : "PULLMAN", "state" : "WA", "county" : "WHITMAN" },
            "99164": { "city" : "PULLMAN", "state" : "WA", "county" : "WHITMAN" },
            "99166": { "city" : "REPUBLIC", "state" : "WA", "county" : "FERRY" },
            "99167": { "city" : "RICE", "state" : "WA", "county" : "STEVENS" },"99169": { "city" : "RITZVILLE", "state" : "WA", "county" : "ADAMS" },
            "99170": { "city" : "ROSALIA", "state" : "WA", "county" : "WHITMAN" },
            "99171": { "city" : "SAINT JOHN", "state" : "WA", "county" : "WHITMAN" },
            "99173": { "city" : "SPRINGDALE", "state" : "WA", "county" : "STEVENS" },
            "99174": { "city" : "STEPTOE", "state" : "WA", "county" : "WHITMAN" },
            "99176": { "city" : "THORNTON", "state" : "WA", "county" : "WHITMAN" },
            "99179": { "city" : "UNIONTOWN", "state" : "WA", "county" : "WHITMAN" },
            "99180": { "city" : "USK", "state" : "WA", "county" : "PEND OREILLE" },
            "99181": { "city" : "VALLEY", "state" : "WA", "county" : "STEVENS" },
            "99185": { "city" : "WILBUR", "state" : "WA", "county" : "LINCOLN" },
            "99201": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99202": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99203": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99204": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99205": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99206": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99207": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99208": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99209": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99210": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99211": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99212": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99213": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99214": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99215": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99216": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99217": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99218": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99219": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99220": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99223": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99224": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99228": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99251": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99252": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99258": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99260": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99299": { "city" : "SPOKANE", "state" : "WA", "county" : "SPOKANE" },
            "99301": { "city" : "PASCO", "state" : "WA", "county" : "FRANKLIN" },
            "99302": { "city" : "PASCO", "state" : "WA", "county" : "FRANKLIN" },
            "99320": { "city" : "BENTON CITY", "state" : "WA", "county" : "BENTON" },
            "99321": { "city" : "BEVERLY", "state" : "WA", "county" : "GRANT" },"99322": { "city" : "BICKLETON", "state" : "WA", "county" : "KLICKITAT" },
            "99323": { "city" : "BURBANK", "state" : "WA", "county" : "WALLA WALLA" },
            "99324": { "city" : "COLLEGE PLACE", "state" : "WA", "county" : "WALLA WALLA" },
            "99326": { "city" : "CONNELL", "state" : "WA", "county" : "FRANKLIN" },
            "99328": { "city" : "DAYTON", "state" : "WA", "county" : "COLUMBIA" },
            "99329": { "city" : "DIXIE", "state" : "WA", "county" : "WALLA WALLA" },
            "99330": { "city" : "ELTOPIA", "state" : "WA", "county" : "FRANKLIN" },
            "99336": { "city" : "KENNEWICK", "state" : "WA", "county" : "BENTON" },
            "99337": { "city" : "KENNEWICK", "state" : "WA", "county" : "BENTON" },
            "99338": { "city" : "KENNEWICK", "state" : "WA", "county" : "BENTON" },
            "99341": { "city" : "LIND", "state" : "WA", "county" : "ADAMS" },"99343": { "city" : "MESA", "state" : "WA", "county" : "FRANKLIN" },
            "99344": { "city" : "OTHELLO", "state" : "WA", "county" : "ADAMS" },"99345": { "city" : "PATERSON", "state" : "WA", "county" : "BENTON" },
            "99346": { "city" : "PLYMOUTH", "state" : "WA", "county" : "BENTON" },
            "99347": { "city" : "POMEROY", "state" : "WA", "county" : "GARFIELD" },
            "99348": { "city" : "PRESCOTT", "state" : "WA", "county" : "WALLA WALLA" },
            "99349": { "city" : "MATTAWA", "state" : "WA", "county" : "GRANT" },"99350": { "city" : "PROSSER", "state" : "WA", "county" : "BENTON" },
            "99352": { "city" : "RICHLAND", "state" : "WA", "county" : "BENTON" },
            "99353": { "city" : "WEST RICHLAND", "state" : "WA", "county" : "BENTON" },
            "99354": { "city" : "RICHLAND", "state" : "WA", "county" : "BENTON" },
            "99356": { "city" : "ROOSEVELT", "state" : "WA", "county" : "KLICKITAT" },
            "99357": { "city" : "ROYAL CITY", "state" : "WA", "county" : "GRANT" },
            "99359": { "city" : "STARBUCK", "state" : "WA", "county" : "COLUMBIA" },
            "99360": { "city" : "TOUCHET", "state" : "WA", "county" : "WALLA WALLA" },
            "99361": { "city" : "WAITSBURG", "state" : "WA", "county" : "WALLA WALLA" },
            "99362": { "city" : "WALLA WALLA", "state" : "WA", "county" : "WALLA WALLA" },
            "99363": { "city" : "WALLULA", "state" : "WA", "county" : "WALLA WALLA" },
            "99371": { "city" : "WASHTUCNA", "state" : "WA", "county" : "ADAMS" },
            "99401": { "city" : "ANATONE", "state" : "WA", "county" : "ASOTIN" },
            "99402": { "city" : "ASOTIN", "state" : "WA", "county" : "ASOTIN" },"99403": { "city" : "CLARKSTON", "state" : "WA", "county" : "ASOTIN" },
            "99501": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99502": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99503": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99504": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99505": { "city" : "FORT RICHARDSON", "state" : "AK", "county" : "ANCHORAGE" },
            "99506": { "city" : "ELMENDORF AFB", "state" : "AK", "county" : "ANCHORAGE" },
            "99507": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99508": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99509": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99510": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99511": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99513": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99514": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99515": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99516": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99517": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99518": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99519": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99520": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99521": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99522": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99523": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99524": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99529": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99540": { "city" : "INDIAN", "state" : "AK", "county" : "ANCHORAGE" },
            "99545": { "city" : "KONGIGANAK", "state" : "AK", "county" : "BETHEL" },
            "99546": { "city" : "ADAK", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99547": { "city" : "ATKA", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99549": { "city" : "PORT HEIDEN", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99550": { "city" : "PORT LIONS", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99551": { "city" : "AKIACHAK", "state" : "AK", "county" : "BETHEL" },
            "99552": { "city" : "AKIAK", "state" : "AK", "county" : "BETHEL" },"99553": { "city" : "AKUTAN", "state" : "AK", "county" : "ALEUTIANS EAST" },
            "99554": { "city" : "ALAKANUK", "state" : "AK", "county" : "WADE HAMPTON" },
            "99555": { "city" : "ALEKNAGIK", "state" : "AK", "county" : "DILLINGHAM" },
            "99556": { "city" : "ANCHOR POINT", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99557": { "city" : "ANIAK", "state" : "AK", "county" : "BETHEL" },"99558": { "city" : "ANVIK", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99559": { "city" : "BETHEL", "state" : "AK", "county" : "BETHEL" },"99561": { "city" : "CHEFORNAK", "state" : "AK", "county" : "BETHEL" },
            "99563": { "city" : "CHEVAK", "state" : "AK", "county" : "WADE HAMPTON" },
            "99564": { "city" : "CHIGNIK", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99565": { "city" : "CHIGNIK LAGOON", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99566": { "city" : "CHITINA", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99567": { "city" : "CHUGIAK", "state" : "AK", "county" : "ANCHORAGE" },
            "99568": { "city" : "CLAM GULCH", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99569": { "city" : "CLARKS POINT", "state" : "AK", "county" : "DILLINGHAM" },
            "99571": { "city" : "COLD BAY", "state" : "AK", "county" : "ALEUTIANS EAST" },
            "99572": { "city" : "COOPER LANDING", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99573": { "city" : "COPPER CENTER", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99574": { "city" : "CORDOVA", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99575": { "city" : "CROOKED CREEK", "state" : "AK", "county" : "BETHEL" },
            "99576": { "city" : "DILLINGHAM", "state" : "AK", "county" : "DILLINGHAM" },
            "99577": { "city" : "EAGLE RIVER", "state" : "AK", "county" : "ANCHORAGE" },
            "99578": { "city" : "EEK", "state" : "AK", "county" : "BETHEL" },"99579": { "city" : "EGEGIK", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99580": { "city" : "EKWOK", "state" : "AK", "county" : "DILLINGHAM" },
            "99581": { "city" : "EMMONAK", "state" : "AK", "county" : "WADE HAMPTON" },
            "99583": { "city" : "FALSE PASS", "state" : "AK", "county" : "ALEUTIANS EAST" },
            "99585": { "city" : "MARSHALL", "state" : "AK", "county" : "WADE HAMPTON" },
            "99586": { "city" : "GAKONA", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99587": { "city" : "GIRDWOOD", "state" : "AK", "county" : "ANCHORAGE" },
            "99588": { "city" : "GLENNALLEN", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99589": { "city" : "GOODNEWS BAY", "state" : "AK", "county" : "BETHEL" },
            "99590": { "city" : "GRAYLING", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99591": { "city" : "SAINT GEORGE ISLAND", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99602": { "city" : "HOLY CROSS", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99603": { "city" : "HOMER", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99604": { "city" : "HOOPER BAY", "state" : "AK", "county" : "WADE HAMPTON" },
            "99605": { "city" : "HOPE", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99606": { "city" : "ILIAMNA", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99607": { "city" : "KALSKAG", "state" : "AK", "county" : "BETHEL" },
            "99608": { "city" : "KARLUK", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99609": { "city" : "KASIGLUK", "state" : "AK", "county" : "BETHEL" },
            "99610": { "city" : "KASILOF", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99611": { "city" : "KENAI", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99612": { "city" : "KING COVE", "state" : "AK", "county" : "ALEUTIANS EAST" },
            "99613": { "city" : "KING SALMON", "state" : "AK", "county" : "BRISTOL BAY" },
            "99614": { "city" : "KIPNUK", "state" : "AK", "county" : "BETHEL" },"99615": { "city" : "KODIAK", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99619": { "city" : "KODIAK", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99620": { "city" : "KOTLIK", "state" : "AK", "county" : "WADE HAMPTON" },
            "99621": { "city" : "KWETHLUK", "state" : "AK", "county" : "BETHEL" },
            "99622": { "city" : "KWIGILLINGOK", "state" : "AK", "county" : "BETHEL" },
            "99623": { "city" : "WASILLA", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99624": { "city" : "LARSEN BAY", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99625": { "city" : "LEVELOCK", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99627": { "city" : "MC GRATH", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99628": { "city" : "MANOKOTAK", "state" : "AK", "county" : "DILLINGHAM" },
            "99629": { "city" : "WASILLA", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99630": { "city" : "MEKORYUK", "state" : "AK", "county" : "BETHEL" },
            "99631": { "city" : "MOOSE PASS", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99632": { "city" : "MOUNTAIN VILLAGE", "state" : "AK", "county" : "WADE HAMPTON" },
            "99633": { "city" : "NAKNEK", "state" : "AK", "county" : "BRISTOL BAY" },
            "99634": { "city" : "NAPAKIAK", "state" : "AK", "county" : "BETHEL" },
            "99635": { "city" : "NIKISKI", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99636": { "city" : "NEW STUYAHOK", "state" : "AK", "county" : "DILLINGHAM" },
            "99637": { "city" : "TOKSOOK BAY", "state" : "AK", "county" : "BETHEL" },
            "99638": { "city" : "NIKOLSKI", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99639": { "city" : "NINILCHIK", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99640": { "city" : "NONDALTON", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99641": { "city" : "NUNAPITCHUK", "state" : "AK", "county" : "BETHEL" },
            "99643": { "city" : "OLD HARBOR", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99644": { "city" : "OUZINKIE", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99645": { "city" : "PALMER", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99647": { "city" : "PEDRO BAY", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99648": { "city" : "PERRYVILLE", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99649": { "city" : "PILOT POINT", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99650": { "city" : "PILOT STATION", "state" : "AK", "county" : "WADE HAMPTON" },
            "99651": { "city" : "PLATINUM", "state" : "AK", "county" : "BETHEL" },
            "99652": { "city" : "BIG LAKE", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99653": { "city" : "PORT ALSWORTH", "state" : "AK", "county" : "LAKE AND PENINSULA" },
            "99654": { "city" : "WASILLA", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99655": { "city" : "QUINHAGAK", "state" : "AK", "county" : "BETHEL" },
            "99656": { "city" : "RED DEVIL", "state" : "AK", "county" : "BETHEL" },
            "99657": { "city" : "RUSSIAN MISSION", "state" : "AK", "county" : "WADE HAMPTON" },
            "99658": { "city" : "SAINT MARYS", "state" : "AK", "county" : "WADE HAMPTON" },
            "99659": { "city" : "SAINT MICHAEL", "state" : "AK", "county" : "NOME" },
            "99660": { "city" : "SAINT PAUL ISLAND", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99661": { "city" : "SAND POINT", "state" : "AK", "county" : "ALEUTIANS EAST" },
            "99662": { "city" : "SCAMMON BAY", "state" : "AK", "county" : "WADE HAMPTON" },
            "99663": { "city" : "SELDOVIA", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99664": { "city" : "SEWARD", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99665": { "city" : "SHAGELUK", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99667": { "city" : "SKWENTNA", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99668": { "city" : "SLEETMUTE", "state" : "AK", "county" : "BETHEL" },
            "99669": { "city" : "SOLDOTNA", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99671": { "city" : "STEBBINS", "state" : "AK", "county" : "NOME" },"99672": { "city" : "STERLING", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99674": { "city" : "SUTTON", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99675": { "city" : "TAKOTNA", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99676": { "city" : "TALKEETNA", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99677": { "city" : "TATITLEK", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99678": { "city" : "TOGIAK", "state" : "AK", "county" : "DILLINGHAM" },
            "99679": { "city" : "TULUKSAK", "state" : "AK", "county" : "BETHEL" },
            "99680": { "city" : "TUNTUTULIAK", "state" : "AK", "county" : "BETHEL" },
            "99681": { "city" : "TUNUNAK", "state" : "AK", "county" : "BETHEL" },
            "99682": { "city" : "TYONEK", "state" : "AK", "county" : "KENAI PENINSULA" },
            "99683": { "city" : "TRAPPER CREEK", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99684": { "city" : "UNALAKLEET", "state" : "AK", "county" : "NOME" },
            "99685": { "city" : "UNALASKA", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99686": { "city" : "VALDEZ", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99687": { "city" : "WASILLA", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99688": { "city" : "WILLOW", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99689": { "city" : "YAKUTAT", "state" : "AK", "county" : "YAKUTAT" },
            "99690": { "city" : "NIGHTMUTE", "state" : "AK", "county" : "BETHEL" },
            "99691": { "city" : "NIKOLAI", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99692": { "city" : "DUTCH HARBOR", "state" : "AK", "county" : "ALEUTIANS WEST" },
            "99693": { "city" : "WHITTIER", "state" : "AK", "county" : "VALDEZ CORDOVA" },
            "99694": { "city" : "HOUSTON", "state" : "AK", "county" : "MATANUSKA SUSITNA" },
            "99695": { "city" : "ANCHORAGE", "state" : "AK", "county" : "ANCHORAGE" },
            "99697": { "city" : "KODIAK", "state" : "AK", "county" : "KODIAK ISLAND" },
            "99701": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99702": { "city" : "EIELSON AFB", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99703": { "city" : "FORT WAINWRIGHT", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99705": { "city" : "NORTH POLE", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99706": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99707": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99708": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99709": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99710": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99711": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99712": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99714": { "city" : "SALCHA", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99716": { "city" : "TWO RIVERS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99720": { "city" : "ALLAKAKET", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99721": { "city" : "ANAKTUVUK PASS", "state" : "AK", "county" : "NORTH SLOPE" },
            "99722": { "city" : "ARCTIC VILLAGE", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99723": { "city" : "BARROW", "state" : "AK", "county" : "NORTH SLOPE" },
            "99725": { "city" : "ESTER", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99726": { "city" : "BETTLES FIELD", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99727": { "city" : "BUCKLAND", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99729": { "city" : "CANTWELL", "state" : "AK", "county" : "DENALI" },
            "99730": { "city" : "CENTRAL", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99731": { "city" : "FORT GREELY", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99732": { "city" : "CHICKEN", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99734": { "city" : "PRUDHOE BAY", "state" : "AK", "county" : "NORTH SLOPE" },
            "99737": { "city" : "DELTA JUNCTION", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99738": { "city" : "EAGLE", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99739": { "city" : "ELIM", "state" : "AK", "county" : "NOME" },"99740": { "city" : "FORT YUKON", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99741": { "city" : "GALENA", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99742": { "city" : "GAMBELL", "state" : "AK", "county" : "NOME" },"99743": { "city" : "HEALY", "state" : "AK", "county" : "DENALI" },
            "99744": { "city" : "ANDERSON", "state" : "AK", "county" : "DENALI" },
            "99745": { "city" : "HUGHES", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99746": { "city" : "HUSLIA", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99747": { "city" : "KAKTOVIK", "state" : "AK", "county" : "NORTH SLOPE" },
            "99748": { "city" : "KALTAG", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99750": { "city" : "KIVALINA", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99751": { "city" : "KOBUK", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99752": { "city" : "KOTZEBUE", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99753": { "city" : "KOYUK", "state" : "AK", "county" : "NOME" },"99754": { "city" : "KOYUKUK", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99755": { "city" : "DENALI NATIONAL PARK", "state" : "AK", "county" : "DENALI" },
            "99756": { "city" : "MANLEY HOT SPRINGS", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99758": { "city" : "MINTO", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99759": { "city" : "POINT LAY", "state" : "AK", "county" : "NORTH SLOPE" },
            "99760": { "city" : "NENANA", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99761": { "city" : "NOATAK", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99762": { "city" : "NOME", "state" : "AK", "county" : "NOME" },"99763": { "city" : "NOORVIK", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99764": { "city" : "NORTHWAY", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99765": { "city" : "NULATO", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99766": { "city" : "POINT HOPE", "state" : "AK", "county" : "NORTH SLOPE" },
            "99768": { "city" : "RUBY", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99769": { "city" : "SAVOONGA", "state" : "AK", "county" : "NOME" },"99770": { "city" : "SELAWIK", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99771": { "city" : "SHAKTOOLIK", "state" : "AK", "county" : "NOME" },
            "99772": { "city" : "SHISHMAREF", "state" : "AK", "county" : "NOME" },
            "99773": { "city" : "SHUNGNAK", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99775": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99776": { "city" : "TANACROSS", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99777": { "city" : "TANANA", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99778": { "city" : "TELLER", "state" : "AK", "county" : "NOME" },"99780": { "city" : "TOK", "state" : "AK", "county" : "SOUTHEAST FAIRBANKS" },
            "99781": { "city" : "VENETIE", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99782": { "city" : "WAINWRIGHT", "state" : "AK", "county" : "NORTH SLOPE" },
            "99783": { "city" : "WALES", "state" : "AK", "county" : "NOME" },"99784": { "city" : "WHITE MOUNTAIN", "state" : "AK", "county" : "NOME" },
            "99785": { "city" : "BREVIG MISSION", "state" : "AK", "county" : "NOME" },
            "99786": { "city" : "AMBLER", "state" : "AK", "county" : "NORTHWEST ARCTIC" },
            "99788": { "city" : "CHALKYITSIK", "state" : "AK", "county" : "YUKON KOYUKUK" },
            "99789": { "city" : "NUIQSUT", "state" : "AK", "county" : "NORTH SLOPE" },
            "99790": { "city" : "FAIRBANKS", "state" : "AK", "county" : "FAIRBANKS NORTH STAR" },
            "99791": { "city" : "ATQASUK", "state" : "AK", "county" : "NORTH SLOPE" },
            "99801": { "city" : "JUNEAU", "state" : "AK", "county" : "JUNEAU" },"99802": { "city" : "JUNEAU", "state" : "AK", "county" : "JUNEAU" },
            "99803": { "city" : "JUNEAU", "state" : "AK", "county" : "JUNEAU" },"99820": { "city" : "ANGOON", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99821": { "city" : "AUKE BAY", "state" : "AK", "county" : "JUNEAU" },
            "99824": { "city" : "DOUGLAS", "state" : "AK", "county" : "JUNEAU" },
            "99825": { "city" : "ELFIN COVE", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99826": { "city" : "GUSTAVUS", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99827": { "city" : "HAINES", "state" : "AK", "county" : "HAINES" },"99829": { "city" : "HOONAH", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99830": { "city" : "KAKE", "state" : "AK", "county" : "WRANGELL PETERSBURG" },
            "99832": { "city" : "PELICAN", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99833": { "city" : "PETERSBURG", "state" : "AK", "county" : "WRANGELL PETERSBURG" },
            "99835": { "city" : "SITKA", "state" : "AK", "county" : "SITKA" },"99836": { "city" : "PORT ALEXANDER", "state" : "AK", "county" : "WRANGELL PETERSBURG" },
            "99840": { "city" : "SKAGWAY", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99841": { "city" : "TENAKEE SPRINGS", "state" : "AK", "county" : "SKAGWAY HOONAH ANGOON" },
            "99850": { "city" : "JUNEAU", "state" : "AK", "county" : "JUNEAU" },"99901": { "city" : "KETCHIKAN", "state" : "AK", "county" : "KETCHIKAN GATEWAY" },
            "99918": { "city" : "COFFMAN COVE", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99919": { "city" : "THORNE BAY", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99921": { "city" : "CRAIG", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99922": { "city" : "HYDABURG", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99923": { "city" : "HYDER", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99925": { "city" : "KLAWOCK", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99926": { "city" : "METLAKATLA", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99927": { "city" : "POINT BAKER", "state" : "AK", "county" : "PRINCE WALES KETCHIKAN" },
            "99928": { "city" : "WARD COVE", "state" : "AK", "county" : "KETCHIKAN GATEWAY" },
            "99929": { "city" : "WRANGELL", "state" : "AK", "county" : "WRANGELL PETERSBURG" },
            "99950": { "city" : "KETCHIKAN", "state" : "AK", "county" : "KETCHIKAN GATEWAY" } };


        if zip is not None or city is not None or county is not None or state is not None:
            if city is not None:
                for k in zips.keys():
                    if city.upper() == zips[k]['city'].upper():
                        if zip is None or zip == k:
                            self.ZipCode = k;
                            self.City    = zips[k]['city'].title();
                            self.County  = zips[k]['county'].title();
                            self.State   = zips[k]['state'].upper();
                            return;
            if county is not None:
                for k in zips.keys():
                    if county.upper() == zips[k]['county'].upper():
                        if zip is None or zip == k:
                            self.ZipCode = k;
                            self.City    = zips[k]['city'].title();
                            self.County  = zips[k]['county'].title();
                            self.State   = zips[k]['state'].upper();
                            return;
            if state is not None:
                for k in zips.keys():
                    if state.upper() == zips[k]['state'].upper():
                        if zip is None or zip == k:
                            self.ZipCode = k;
                            self.City    = zips[k]['city'].title();
                            self.County  = zips[k]['county'].title();
                            self.State   = zips[k]['state'].upper();
                            return;
            if zip is not None:
                if zip in zips:
                    self.ZipCode = zip;
                    self.City    = zips[zip]['city'].title();
                    self.County  = zips[zip]['county'].title();
                    self.State   = zips[zip]['state'].upper();
                    return;
        j = random.randint(0, len(zips) - 1);
        i = 0;
        for k in zips.keys():
            if i == j:
                self.ZipCode = k;
                self.City    = zips[k]['city'].title();
                self.County  = zips[k]['county'].title();
                self.State   = zips[k]['state'].upper();
                self.Country = 'US';
                return;
            i += 1;
        return;
